# Copyright 2023 Thales DIS France SAS
#
# Licensed under the Solderpad Hardware Licence, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# SPDX-License-Identifier: Apache-2.0 WITH SHL-2.0
# You may obtain a copy of the License at https://solderpad.org/licenses/
#

.globl main
main:
    #Start CSR tests: 3 iterations of random (max 5) Write/Read operations to all CSR addresses from 0 to 0xfff in a random order
    #Handle exceptions
    la x6, exception_handler
    csrw mtvec, x6  ## Load the address of the exception handler into MTVEC
    csrw 0x341, x0  ## Writing Zero to MEPC CSR
    csrw 0x342, x0  ## Writing Zero to MCAUSE CSR
    #End Handle exceptions

    #User ignored registers: MTVEC ,

    #Unmapped address 0x89a testing: random write/read operations
    #Address 0x89a Write value 0x3ba9dd81
    li x3, 0x3ba9dd81
    csrw 0x89a, x3

    #Address 0x89a read value
    csrr x14, 0x89a

    #Address 0x89a read value
    csrr x14, 0x89a

    #Address 0x89a Write value 0x3c0de7f0
    li x3, 0x3c0de7f0
    csrw 0x89a, x3

    #Unmapped address 0xf16 testing: random write/read operations
    #Address 0xf16 read value
    csrr x14, 0xf16

    #Address 0xf16 read value
    csrr x14, 0xf16

    #Address 0xf16 read value
    csrr x14, 0xf16

    #Unmapped address 0xf7 testing: random write/read operations
    #Address 0xf7 Write value 0x75ec7312
    li x3, 0x75ec7312
    csrw 0xf7, x3

    #Address 0xf7 Write value 0xd4e3bb3
    li x3, 0xd4e3bb3
    csrw 0xf7, x3

    #Address 0xf7 read value
    csrr x14, 0xf7

    #Address 0xf7 read value
    csrr x14, 0xf7

    #Address 0xf7 Write value 0xe83df765
    li x3, 0xe83df765
    csrw 0xf7, x3

    #Mapped address 0xb14 (mhpmcounter20) testing: random write/read operations
    #Address 0xb14 read value
    csrr x14, 0xb14

    #Address 0xb14 Write value 0xa5d645db
    li x3, 0xa5d645db
    csrw 0xb14, x3

    #Address 0xb14 Write value 0x7ac39eaf
    li x3, 0x7ac39eaf
    csrw 0xb14, x3

    #Address 0xb14 read value
    csrr x14, 0xb14

    #Unmapped address 0x275 testing: random write/read operations
    #Address 0x275 Write value 0xac422ed1
    li x3, 0xac422ed1
    csrw 0x275, x3

    #Unmapped address 0x27e testing: random write/read operations
    #Address 0x27e Write value 0x974ec335
    li x3, 0x974ec335
    csrw 0x27e, x3

    #Unmapped address 0x9a1 testing: random write/read operations
    #Address 0x9a1 read value
    csrr x14, 0x9a1

    #Address 0x9a1 Write value 0xf44b869c
    li x3, 0xf44b869c
    csrw 0x9a1, x3

    #Address 0x9a1 read value
    csrr x14, 0x9a1

    #Unmapped address 0x847 testing: random write/read operations
    #Address 0x847 Write value 0x948f550f
    li x3, 0x948f550f
    csrw 0x847, x3

    #Address 0x847 read value
    csrr x14, 0x847

    #Address 0x847 read value
    csrr x14, 0x847

    #Address 0x847 Write value 0x73ed1fc8
    li x3, 0x73ed1fc8
    csrw 0x847, x3

    #Unmapped address 0xc8d testing: random write/read operations
    #Address 0xc8d Write value 0xf36cc720
    li x3, 0xf36cc720
    csrw 0xc8d, x3

    #Address 0xc8d read value
    csrr x14, 0xc8d

    #Address 0xc8d read value
    csrr x14, 0xc8d

    #Address 0xc8d read value
    csrr x14, 0xc8d

    #Unmapped address 0x97a testing: random write/read operations
    #Address 0x97a read value
    csrr x14, 0x97a

    #Address 0x97a Write value 0x1b1a06c
    li x3, 0x1b1a06c
    csrw 0x97a, x3

    #Address 0x97a Write value 0xd845032f
    li x3, 0xd845032f
    csrw 0x97a, x3

    #Unmapped address 0x2e8 testing: random write/read operations
    #Address 0x2e8 Write value 0xfba782ce
    li x3, 0xfba782ce
    csrw 0x2e8, x3

    #Unmapped address 0xbef testing: random write/read operations
    #Address 0xbef read value
    csrr x14, 0xbef

    #Address 0xbef Write value 0x945582c6
    li x3, 0x945582c6
    csrw 0xbef, x3

    #Address 0xbef read value
    csrr x14, 0xbef

    #Unmapped address 0x8df testing: random write/read operations
    #Address 0x8df Write value 0xbadf3128
    li x3, 0xbadf3128
    csrw 0x8df, x3

    #Address 0x8df Write value 0x4a6ff11c
    li x3, 0x4a6ff11c
    csrw 0x8df, x3

    #Address 0x8df Write value 0x82ce14be
    li x3, 0x82ce14be
    csrw 0x8df, x3

    #Address 0x8df read value
    csrr x14, 0x8df

    #Address 0x8df Write value 0x669afe8a
    li x3, 0x669afe8a
    csrw 0x8df, x3

    #Unmapped address 0x2dc testing: random write/read operations
    #Address 0x2dc read value
    csrr x14, 0x2dc

    #Address 0x2dc read value
    csrr x14, 0x2dc

    #Address 0x2dc read value
    csrr x14, 0x2dc

    #Unmapped address 0x1f3 testing: random write/read operations
    #Address 0x1f3 Write value 0xa451e605
    li x3, 0xa451e605
    csrw 0x1f3, x3

    #Address 0x1f3 read value
    csrr x14, 0x1f3

    #Address 0x1f3 read value
    csrr x14, 0x1f3

    #Unmapped address 0xcff testing: random write/read operations
    #Address 0xcff Write value 0x5b6189ab
    li x3, 0x5b6189ab
    csrw 0xcff, x3

    #Address 0xcff Write value 0xbc9d1248
    li x3, 0xbc9d1248
    csrw 0xcff, x3

    #Address 0xcff Write value 0x14813bf1
    li x3, 0x14813bf1
    csrw 0xcff, x3

    #Address 0xcff read value
    csrr x14, 0xcff

    #Unmapped address 0x16e testing: random write/read operations
    #Address 0x16e Write value 0x5ba2ea24
    li x3, 0x5ba2ea24
    csrw 0x16e, x3

    #Address 0x16e read value
    csrr x14, 0x16e

    #Unmapped address 0xaa7 testing: random write/read operations
    #Address 0xaa7 read value
    csrr x14, 0xaa7

    #Address 0xaa7 Write value 0x7678fb57
    li x3, 0x7678fb57
    csrw 0xaa7, x3

    #Address 0xaa7 read value
    csrr x14, 0xaa7

    #Address 0xaa7 read value
    csrr x14, 0xaa7

    #Unmapped address 0x9b6 testing: random write/read operations
    #Address 0x9b6 read value
    csrr x14, 0x9b6

    #Address 0x9b6 read value
    csrr x14, 0x9b6

    #Unmapped address 0x1bc testing: random write/read operations
    #Address 0x1bc read value
    csrr x14, 0x1bc

    #Address 0x1bc Write value 0x66157d21
    li x3, 0x66157d21
    csrw 0x1bc, x3

    #Address 0x1bc read value
    csrr x14, 0x1bc

    #Address 0x1bc Write value 0x514e418b
    li x3, 0x514e418b
    csrw 0x1bc, x3

    #Unmapped address 0x225 testing: random write/read operations
    #Address 0x225 Write value 0xd46768ea
    li x3, 0xd46768ea
    csrw 0x225, x3

    #Address 0x225 read value
    csrr x14, 0x225

    #Unmapped address 0xa89 testing: random write/read operations
    #Address 0xa89 Write value 0x38f0abe1
    li x3, 0x38f0abe1
    csrw 0xa89, x3

    #Address 0xa89 Write value 0xdd2ae9f5
    li x3, 0xdd2ae9f5
    csrw 0xa89, x3

    #Unmapped address 0x10f testing: random write/read operations
    #Address 0x10f Write value 0x627e0e45
    li x3, 0x627e0e45
    csrw 0x10f, x3

    #Address 0x10f Write value 0xbeba0557
    li x3, 0xbeba0557
    csrw 0x10f, x3

    #Address 0x10f Write value 0xb08d24a6
    li x3, 0xb08d24a6
    csrw 0x10f, x3

    #Address 0x10f Write value 0x5537c481
    li x3, 0x5537c481
    csrw 0x10f, x3

    #Unmapped address 0x5cd testing: random write/read operations
    #Address 0x5cd Write value 0xb883e525
    li x3, 0xb883e525
    csrw 0x5cd, x3

    #Address 0x5cd read value
    csrr x14, 0x5cd

    #Address 0x5cd read value
    csrr x14, 0x5cd

    #Unmapped address 0xb26 testing: random write/read operations
    #Address 0xb26 Write value 0xc7c09e5b
    li x3, 0xc7c09e5b
    csrw 0xb26, x3

    #Unmapped address 0xc10 testing: random write/read operations
    #Address 0xc10 read value
    csrr x14, 0xc10

    #Address 0xc10 read value
    csrr x14, 0xc10

    #Address 0xc10 read value
    csrr x14, 0xc10

    #Address 0xc10 Write value 0x4335b702
    li x3, 0x4335b702
    csrw 0xc10, x3

    #Address 0xc10 read value
    csrr x14, 0xc10

    #Unmapped address 0xd7d testing: random write/read operations
    #Address 0xd7d Write value 0x31b4c2c7
    li x3, 0x31b4c2c7
    csrw 0xd7d, x3

    #Unmapped address 0xd2 testing: random write/read operations
    #Address 0xd2 read value
    csrr x14, 0xd2

    #Address 0xd2 read value
    csrr x14, 0xd2

    #Address 0xd2 read value
    csrr x14, 0xd2

    #Unmapped address 0xb34 testing: random write/read operations
    #Address 0xb34 Write value 0x7d5329f6
    li x3, 0x7d5329f6
    csrw 0xb34, x3

    #Address 0xb34 read value
    csrr x14, 0xb34

    #Address 0xb34 Write value 0x7b3aa2d9
    li x3, 0x7b3aa2d9
    csrw 0xb34, x3

    #Address 0xb34 read value
    csrr x14, 0xb34

    #Address 0xb34 Write value 0xc9d8042d
    li x3, 0xc9d8042d
    csrw 0xb34, x3

    #Unmapped address 0xa01 testing: random write/read operations
    #Address 0xa01 Write value 0xd349ae46
    li x3, 0xd349ae46
    csrw 0xa01, x3

    #Address 0xa01 Write value 0x844d48f7
    li x3, 0x844d48f7
    csrw 0xa01, x3

    #Unmapped address 0xc89 testing: random write/read operations
    #Address 0xc89 Write value 0x63ce807
    li x3, 0x63ce807
    csrw 0xc89, x3

    #Address 0xc89 Write value 0x175f91aa
    li x3, 0x175f91aa
    csrw 0xc89, x3

    #Address 0xc89 Write value 0x1f8eba45
    li x3, 0x1f8eba45
    csrw 0xc89, x3

    #Unmapped address 0x6a3 testing: random write/read operations
    #Address 0x6a3 read value
    csrr x14, 0x6a3

    #Address 0x6a3 read value
    csrr x14, 0x6a3

    #Unmapped address 0x9cd testing: random write/read operations
    #Address 0x9cd Write value 0xc7382266
    li x3, 0xc7382266
    csrw 0x9cd, x3

    #Address 0x9cd read value
    csrr x14, 0x9cd

    #Unmapped address 0x7ba testing: random write/read operations
    #Address 0x7ba read value
    csrr x14, 0x7ba

    #Unmapped address 0xdca testing: random write/read operations
    #Address 0xdca Write value 0x8d7bc220
    li x3, 0x8d7bc220
    csrw 0xdca, x3

    #Address 0xdca Write value 0x3a2ff23c
    li x3, 0x3a2ff23c
    csrw 0xdca, x3

    #Address 0xdca read value
    csrr x14, 0xdca

    #Unmapped address 0x99b testing: random write/read operations
    #Address 0x99b Write value 0x9003c3ec
    li x3, 0x9003c3ec
    csrw 0x99b, x3

    #Unmapped address 0x4ee testing: random write/read operations
    #Address 0x4ee read value
    csrr x14, 0x4ee

    #Unmapped address 0x503 testing: random write/read operations
    #Address 0x503 read value
    csrr x14, 0x503

    #Address 0x503 read value
    csrr x14, 0x503

    #Address 0x503 Write value 0x549d5777
    li x3, 0x549d5777
    csrw 0x503, x3

    #Address 0x503 read value
    csrr x14, 0x503

    #Address 0x503 Write value 0x6bc90888
    li x3, 0x6bc90888
    csrw 0x503, x3

    #Unmapped address 0x70b testing: random write/read operations
    #Address 0x70b Write value 0xbaa380d8
    li x3, 0xbaa380d8
    csrw 0x70b, x3

    #Address 0x70b Write value 0x4efd514
    li x3, 0x4efd514
    csrw 0x70b, x3

    #Address 0x70b read value
    csrr x14, 0x70b

    #Address 0x70b read value
    csrr x14, 0x70b

    #Mapped address 0x7c0 (icache) testing: random write/read operations
    #Address 0x7c0 Write value 0xdc662ae9
    li x3, 0xdc662ae9
    csrw 0x7c0, x3

    #Address 0x7c0 read value
    csrr x14, 0x7c0

    #Unmapped address 0x735 testing: random write/read operations
    #Address 0x735 read value
    csrr x14, 0x735

    #Address 0x735 Write value 0x603a9e67
    li x3, 0x603a9e67
    csrw 0x735, x3

    #Address 0x735 read value
    csrr x14, 0x735

    #Address 0x735 Write value 0x23970e2d
    li x3, 0x23970e2d
    csrw 0x735, x3

    #Unmapped address 0xa61 testing: random write/read operations
    #Address 0xa61 Write value 0xb707570e
    li x3, 0xb707570e
    csrw 0xa61, x3

    #Address 0xa61 Write value 0x98791af4
    li x3, 0x98791af4
    csrw 0xa61, x3

    #Address 0xa61 Write value 0xfb2f4a21
    li x3, 0xfb2f4a21
    csrw 0xa61, x3

    #Address 0xa61 read value
    csrr x14, 0xa61

    #Mapped address 0xb83 (mhpmcounterh3) testing: random write/read operations
    #Address 0xb83 read value
    csrr x14, 0xb83

    #Unmapped address 0xc88 testing: random write/read operations
    #Address 0xc88 read value
    csrr x14, 0xc88

    #Address 0xc88 Write value 0x42106b18
    li x3, 0x42106b18
    csrw 0xc88, x3

    #Address 0xc88 Write value 0x325c4bc9
    li x3, 0x325c4bc9
    csrw 0xc88, x3

    #Address 0xc88 Write value 0x2556b39e
    li x3, 0x2556b39e
    csrw 0xc88, x3

    #Unmapped address 0x9a8 testing: random write/read operations
    #Address 0x9a8 read value
    csrr x14, 0x9a8

    #Address 0x9a8 read value
    csrr x14, 0x9a8

    #Address 0x9a8 read value
    csrr x14, 0x9a8

    #Address 0x9a8 read value
    csrr x14, 0x9a8

    #Address 0x9a8 read value
    csrr x14, 0x9a8

    #Unmapped address 0x659 testing: random write/read operations
    #Address 0x659 read value
    csrr x14, 0x659

    #Address 0x659 Write value 0xd8f5f75a
    li x3, 0xd8f5f75a
    csrw 0x659, x3

    #Address 0x659 Write value 0x943f94c7
    li x3, 0x943f94c7
    csrw 0x659, x3

    #Address 0x659 Write value 0xffc71d9d
    li x3, 0xffc71d9d
    csrw 0x659, x3

    #Address 0x659 read value
    csrr x14, 0x659

    #Unmapped address 0x5a6 testing: random write/read operations
    #Address 0x5a6 read value
    csrr x14, 0x5a6

    #Address 0x5a6 read value
    csrr x14, 0x5a6

    #Address 0x5a6 read value
    csrr x14, 0x5a6

    #Address 0x5a6 Write value 0x39fe8875
    li x3, 0x39fe8875
    csrw 0x5a6, x3

    #Unmapped address 0x1b4 testing: random write/read operations
    #Address 0x1b4 Write value 0x23c5f281
    li x3, 0x23c5f281
    csrw 0x1b4, x3

    #Address 0x1b4 read value
    csrr x14, 0x1b4

    #Address 0x1b4 Write value 0x1f43232a
    li x3, 0x1f43232a
    csrw 0x1b4, x3

    #Unmapped address 0xf29 testing: random write/read operations
    #Address 0xf29 Write value 0xabb1153e
    li x3, 0xabb1153e
    csrw 0xf29, x3

    #Unmapped address 0x64b testing: random write/read operations
    #Address 0x64b read value
    csrr x14, 0x64b

    #Address 0x64b read value
    csrr x14, 0x64b

    #Unmapped address 0x193 testing: random write/read operations
    #Address 0x193 read value
    csrr x14, 0x193

    #Address 0x193 Write value 0x7088bb84
    li x3, 0x7088bb84
    csrw 0x193, x3

    #Address 0x193 Write value 0x98d7c13a
    li x3, 0x98d7c13a
    csrw 0x193, x3

    #Unmapped address 0xfb2 testing: random write/read operations
    #Address 0xfb2 read value
    csrr x14, 0xfb2

    #Address 0xfb2 Write value 0x95eeb4f2
    li x3, 0x95eeb4f2
    csrw 0xfb2, x3

    #Address 0xfb2 Write value 0x27c62f19
    li x3, 0x27c62f19
    csrw 0xfb2, x3

    #Address 0xfb2 Write value 0x2e09b0d2
    li x3, 0x2e09b0d2
    csrw 0xfb2, x3

    #Unmapped address 0x9ca testing: random write/read operations
    #Address 0x9ca Write value 0x355d0bbd
    li x3, 0x355d0bbd
    csrw 0x9ca, x3

    #Unmapped address 0xd9a testing: random write/read operations
    #Address 0xd9a Write value 0x580b9298
    li x3, 0x580b9298
    csrw 0xd9a, x3

    #Address 0xd9a read value
    csrr x14, 0xd9a

    #Unmapped address 0x283 testing: random write/read operations
    #Address 0x283 Write value 0x6dee57b6
    li x3, 0x6dee57b6
    csrw 0x283, x3

    #Unmapped address 0x379 testing: random write/read operations
    #Address 0x379 read value
    csrr x14, 0x379

    #Address 0x379 read value
    csrr x14, 0x379

    #Address 0x379 Write value 0xfd7a99b
    li x3, 0xfd7a99b
    csrw 0x379, x3

    #Address 0x379 read value
    csrr x14, 0x379

    #Address 0x379 Write value 0x8e1bf4a6
    li x3, 0x8e1bf4a6
    csrw 0x379, x3

    #Unmapped address 0xfa0 testing: random write/read operations
    #Address 0xfa0 read value
    csrr x14, 0xfa0

    #Address 0xfa0 read value
    csrr x14, 0xfa0

    #Unmapped address 0x99c testing: random write/read operations
    #Address 0x99c Write value 0x7051a308
    li x3, 0x7051a308
    csrw 0x99c, x3

    #Address 0x99c Write value 0x7407f732
    li x3, 0x7407f732
    csrw 0x99c, x3

    #Address 0x99c Write value 0x1a3f87e
    li x3, 0x1a3f87e
    csrw 0x99c, x3

    #Unmapped address 0xcf2 testing: random write/read operations
    #Address 0xcf2 Write value 0x6c417ca0
    li x3, 0x6c417ca0
    csrw 0xcf2, x3

    #Address 0xcf2 Write value 0x79a619cb
    li x3, 0x79a619cb
    csrw 0xcf2, x3

    #Unmapped address 0x8e6 testing: random write/read operations
    #Address 0x8e6 read value
    csrr x14, 0x8e6

    #Address 0x8e6 read value
    csrr x14, 0x8e6

    #Address 0x8e6 Write value 0x2ef35332
    li x3, 0x2ef35332
    csrw 0x8e6, x3

    #Unmapped address 0xb4 testing: random write/read operations
    #Address 0xb4 Write value 0x3f822990
    li x3, 0x3f822990
    csrw 0xb4, x3

    #Unmapped address 0x1f0 testing: random write/read operations
    #Address 0x1f0 Write value 0x8595bf2
    li x3, 0x8595bf2
    csrw 0x1f0, x3

    #Address 0x1f0 read value
    csrr x14, 0x1f0

    #Address 0x1f0 Write value 0x3fe2eb75
    li x3, 0x3fe2eb75
    csrw 0x1f0, x3

    #Address 0x1f0 Write value 0x627e004d
    li x3, 0x627e004d
    csrw 0x1f0, x3

    #Address 0x1f0 read value
    csrr x14, 0x1f0

    #Unmapped address 0xd64 testing: random write/read operations
    #Address 0xd64 read value
    csrr x14, 0xd64

    #Address 0xd64 read value
    csrr x14, 0xd64

    #Address 0xd64 read value
    csrr x14, 0xd64

    #Address 0xd64 read value
    csrr x14, 0xd64

    #Unmapped address 0x6c4 testing: random write/read operations
    #Address 0x6c4 read value
    csrr x14, 0x6c4

    #Address 0x6c4 Write value 0xfcc2970b
    li x3, 0xfcc2970b
    csrw 0x6c4, x3

    #Address 0x6c4 read value
    csrr x14, 0x6c4

    #Unmapped address 0xbaf testing: random write/read operations
    #Address 0xbaf Write value 0xb018492f
    li x3, 0xb018492f
    csrw 0xbaf, x3

    #Address 0xbaf read value
    csrr x14, 0xbaf

    #Address 0xbaf Write value 0x3d4085f0
    li x3, 0x3d4085f0
    csrw 0xbaf, x3

    #Address 0xbaf Write value 0x3ab59114
    li x3, 0x3ab59114
    csrw 0xbaf, x3

    #Unmapped address 0x9f7 testing: random write/read operations
    #Address 0x9f7 read value
    csrr x14, 0x9f7

    #Unmapped address 0xe testing: random write/read operations
    #Address 0xe read value
    csrr x14, 0xe

    #Address 0xe read value
    csrr x14, 0xe

    #Address 0xe Write value 0xc9539663
    li x3, 0xc9539663
    csrw 0xe, x3

    #Address 0xe read value
    csrr x14, 0xe

    #Address 0xe read value
    csrr x14, 0xe

    #Unmapped address 0x192 testing: random write/read operations
    #Address 0x192 read value
    csrr x14, 0x192

    #Unmapped address 0xdd testing: random write/read operations
    #Address 0xdd Write value 0x9007a796
    li x3, 0x9007a796
    csrw 0xdd, x3

    #Address 0xdd read value
    csrr x14, 0xdd

    #Address 0xdd read value
    csrr x14, 0xdd

    #Unmapped address 0xae8 testing: random write/read operations
    #Address 0xae8 read value
    csrr x14, 0xae8

    #Address 0xae8 Write value 0x28a1ebf5
    li x3, 0x28a1ebf5
    csrw 0xae8, x3

    #Unmapped address 0x795 testing: random write/read operations
    #Address 0x795 read value
    csrr x14, 0x795

    #Unmapped address 0x237 testing: random write/read operations
    #Address 0x237 Write value 0xf486282c
    li x3, 0xf486282c
    csrw 0x237, x3

    #Address 0x237 read value
    csrr x14, 0x237

    #Address 0x237 read value
    csrr x14, 0x237

    #Address 0x237 read value
    csrr x14, 0x237

    #Address 0x237 read value
    csrr x14, 0x237

    #Unmapped address 0x8a testing: random write/read operations
    #Address 0x8a Write value 0x30975529
    li x3, 0x30975529
    csrw 0x8a, x3

    #Address 0x8a read value
    csrr x14, 0x8a

    #Address 0x8a Write value 0x47634ab4
    li x3, 0x47634ab4
    csrw 0x8a, x3

    #Unmapped address 0x370 testing: random write/read operations
    #Address 0x370 read value
    csrr x14, 0x370

    #Address 0x370 Write value 0x33e5eef9
    li x3, 0x33e5eef9
    csrw 0x370, x3

    #Address 0x370 Write value 0x727592f5
    li x3, 0x727592f5
    csrw 0x370, x3

    #Address 0x370 Write value 0xe97d3ee7
    li x3, 0xe97d3ee7
    csrw 0x370, x3

    #Unmapped address 0x440 testing: random write/read operations
    #Address 0x440 Write value 0xbe6bf4cc
    li x3, 0xbe6bf4cc
    csrw 0x440, x3

    #Address 0x440 Write value 0x23489eeb
    li x3, 0x23489eeb
    csrw 0x440, x3

    #Address 0x440 read value
    csrr x14, 0x440

    #Unmapped address 0xc51 testing: random write/read operations
    #Address 0xc51 read value
    csrr x14, 0xc51

    #Address 0xc51 read value
    csrr x14, 0xc51

    #Address 0xc51 Write value 0x739067e8
    li x3, 0x739067e8
    csrw 0xc51, x3

    #Address 0xc51 Write value 0x1a97ff6a
    li x3, 0x1a97ff6a
    csrw 0xc51, x3

    #Address 0xc51 Write value 0xba766ef8
    li x3, 0xba766ef8
    csrw 0xc51, x3

    #Unmapped address 0x3db testing: random write/read operations
    #Address 0x3db read value
    csrr x14, 0x3db

    #Address 0x3db Write value 0xddaa50e1
    li x3, 0xddaa50e1
    csrw 0x3db, x3

    #Unmapped address 0x351 testing: random write/read operations
    #Address 0x351 read value
    csrr x14, 0x351

    #Address 0x351 read value
    csrr x14, 0x351

    #Address 0x351 read value
    csrr x14, 0x351

    #Address 0x351 Write value 0x46541547
    li x3, 0x46541547
    csrw 0x351, x3

    #Unmapped address 0xfc testing: random write/read operations
    #Address 0xfc Write value 0x7244c9d9
    li x3, 0x7244c9d9
    csrw 0xfc, x3

    #Mapped address 0x338 (mhpmevent24) testing: random write/read operations
    #Address 0x338 Write value 0xfc88b6be
    li x3, 0xfc88b6be
    csrw 0x338, x3

    #Unmapped address 0x6ac testing: random write/read operations
    #Address 0x6ac Write value 0xcfaa46d5
    li x3, 0xcfaa46d5
    csrw 0x6ac, x3

    #Address 0x6ac Write value 0xbbbca3e6
    li x3, 0xbbbca3e6
    csrw 0x6ac, x3

    #Address 0x6ac read value
    csrr x14, 0x6ac

    #Unmapped address 0xa5a testing: random write/read operations
    #Address 0xa5a read value
    csrr x14, 0xa5a

    #Unmapped address 0x937 testing: random write/read operations
    #Address 0x937 read value
    csrr x14, 0x937

    #Address 0x937 read value
    csrr x14, 0x937

    #Address 0x937 Write value 0x4165d79c
    li x3, 0x4165d79c
    csrw 0x937, x3

    #Unmapped address 0xb70 testing: random write/read operations
    #Address 0xb70 Write value 0x85f34506
    li x3, 0x85f34506
    csrw 0xb70, x3

    #Unmapped address 0xd6 testing: random write/read operations
    #Address 0xd6 Write value 0xc08044a5
    li x3, 0xc08044a5
    csrw 0xd6, x3

    #Address 0xd6 read value
    csrr x14, 0xd6

    #Address 0xd6 Write value 0xae56d26a
    li x3, 0xae56d26a
    csrw 0xd6, x3

    #Address 0xd6 read value
    csrr x14, 0xd6

    #Address 0xd6 read value
    csrr x14, 0xd6

    #Unmapped address 0xc68 testing: random write/read operations
    #Address 0xc68 Write value 0x7e3dd1d1
    li x3, 0x7e3dd1d1
    csrw 0xc68, x3

    #Unmapped address 0x521 testing: random write/read operations
    #Address 0x521 read value
    csrr x14, 0x521

    #Unmapped address 0x2a9 testing: random write/read operations
    #Address 0x2a9 Write value 0x46e78802
    li x3, 0x46e78802
    csrw 0x2a9, x3

    #Address 0x2a9 Write value 0x758b8da4
    li x3, 0x758b8da4
    csrw 0x2a9, x3

    #Address 0x2a9 read value
    csrr x14, 0x2a9

    #Address 0x2a9 Write value 0x9d7454b5
    li x3, 0x9d7454b5
    csrw 0x2a9, x3

    #Address 0x2a9 Write value 0xf0003719
    li x3, 0xf0003719
    csrw 0x2a9, x3

    #Unmapped address 0x39f testing: random write/read operations
    #Address 0x39f read value
    csrr x14, 0x39f

    #Unmapped address 0x390 testing: random write/read operations
    #Address 0x390 Write value 0x6934d70f
    li x3, 0x6934d70f
    csrw 0x390, x3

    #Unmapped address 0xb41 testing: random write/read operations
    #Address 0xb41 Write value 0x32cfa157
    li x3, 0x32cfa157
    csrw 0xb41, x3

    #Address 0xb41 Write value 0x8028002d
    li x3, 0x8028002d
    csrw 0xb41, x3

    #Address 0xb41 Write value 0x45f06247
    li x3, 0x45f06247
    csrw 0xb41, x3

    #Address 0xb41 read value
    csrr x14, 0xb41

    #Mapped address 0xf11 (mvendorid) testing: random write/read operations
    #Address 0xf11 Write value 0xb5ae44a9
    li x3, 0xb5ae44a9
    csrw 0xf11, x3

    #Unmapped address 0x7b7 testing: random write/read operations
    #Address 0x7b7 Write value 0xadd0bae6
    li x3, 0xadd0bae6
    csrw 0x7b7, x3

    #Address 0x7b7 Write value 0x4178ddae
    li x3, 0x4178ddae
    csrw 0x7b7, x3

    #Address 0x7b7 read value
    csrr x14, 0x7b7

    #Address 0x7b7 Write value 0x68348624
    li x3, 0x68348624
    csrw 0x7b7, x3

    #Unmapped address 0xb6e testing: random write/read operations
    #Address 0xb6e read value
    csrr x14, 0xb6e

    #Address 0xb6e Write value 0x4703f28
    li x3, 0x4703f28
    csrw 0xb6e, x3

    #Address 0xb6e Write value 0x389a67c1
    li x3, 0x389a67c1
    csrw 0xb6e, x3

    #Address 0xb6e read value
    csrr x14, 0xb6e

    #Unmapped address 0x57e testing: random write/read operations
    #Address 0x57e read value
    csrr x14, 0x57e

    #Address 0x57e Write value 0x34fe9904
    li x3, 0x34fe9904
    csrw 0x57e, x3

    #Unmapped address 0x2d8 testing: random write/read operations
    #Address 0x2d8 read value
    csrr x14, 0x2d8

    #Address 0x2d8 Write value 0x1ca02163
    li x3, 0x1ca02163
    csrw 0x2d8, x3

    #Address 0x2d8 read value
    csrr x14, 0x2d8

    #Address 0x2d8 read value
    csrr x14, 0x2d8

    #Unmapped address 0x56d testing: random write/read operations
    #Address 0x56d read value
    csrr x14, 0x56d

    #Address 0x56d read value
    csrr x14, 0x56d

    #Address 0x56d read value
    csrr x14, 0x56d

    #Address 0x56d Write value 0x44c26b59
    li x3, 0x44c26b59
    csrw 0x56d, x3

    #Address 0x56d read value
    csrr x14, 0x56d

    #Unmapped address 0xe1c testing: random write/read operations
    #Address 0xe1c read value
    csrr x14, 0xe1c

    #Address 0xe1c read value
    csrr x14, 0xe1c

    #Unmapped address 0xce9 testing: random write/read operations
    #Address 0xce9 Write value 0x450589d8
    li x3, 0x450589d8
    csrw 0xce9, x3

    #Address 0xce9 read value
    csrr x14, 0xce9

    #Address 0xce9 Write value 0x15ac7ba2
    li x3, 0x15ac7ba2
    csrw 0xce9, x3

    #Address 0xce9 Write value 0x56fe8b7c
    li x3, 0x56fe8b7c
    csrw 0xce9, x3

    #Address 0xce9 Write value 0xe2254534
    li x3, 0xe2254534
    csrw 0xce9, x3

    #Unmapped address 0x78b testing: random write/read operations
    #Address 0x78b Write value 0xaa0d1839
    li x3, 0xaa0d1839
    csrw 0x78b, x3

    #Address 0x78b Write value 0xbc398aef
    li x3, 0xbc398aef
    csrw 0x78b, x3

    #Address 0x78b Write value 0xfb2c6365
    li x3, 0xfb2c6365
    csrw 0x78b, x3

    #Address 0x78b Write value 0x7e338540
    li x3, 0x7e338540
    csrw 0x78b, x3

    #Address 0x78b Write value 0x7bfde786
    li x3, 0x7bfde786
    csrw 0x78b, x3

    #Unmapped address 0x8c2 testing: random write/read operations
    #Address 0x8c2 Write value 0xe46c6a9a
    li x3, 0xe46c6a9a
    csrw 0x8c2, x3

    #Address 0x8c2 read value
    csrr x14, 0x8c2

    #Address 0x8c2 Write value 0x8f0ade66
    li x3, 0x8f0ade66
    csrw 0x8c2, x3

    #Address 0x8c2 Write value 0xd05e5005
    li x3, 0xd05e5005
    csrw 0x8c2, x3

    #Address 0x8c2 Write value 0x33b078a4
    li x3, 0x33b078a4
    csrw 0x8c2, x3

    #Unmapped address 0x8d8 testing: random write/read operations
    #Address 0x8d8 read value
    csrr x14, 0x8d8

    #Address 0x8d8 read value
    csrr x14, 0x8d8

    #Address 0x8d8 Write value 0xd5b20e43
    li x3, 0xd5b20e43
    csrw 0x8d8, x3

    #Unmapped address 0xda9 testing: random write/read operations
    #Address 0xda9 Write value 0x9ed1b0c8
    li x3, 0x9ed1b0c8
    csrw 0xda9, x3

    #Address 0xda9 Write value 0x126d2161
    li x3, 0x126d2161
    csrw 0xda9, x3

    #Address 0xda9 Write value 0xa404efa3
    li x3, 0xa404efa3
    csrw 0xda9, x3

    #Address 0xda9 Write value 0x14ef0786
    li x3, 0x14ef0786
    csrw 0xda9, x3

    #Address 0xda9 read value
    csrr x14, 0xda9

    #Unmapped address 0x220 testing: random write/read operations
    #Address 0x220 read value
    csrr x14, 0x220

    #Address 0x220 read value
    csrr x14, 0x220

    #Address 0x220 Write value 0x469034b6
    li x3, 0x469034b6
    csrw 0x220, x3

    #Unmapped address 0xdff testing: random write/read operations
    #Address 0xdff Write value 0x9b50008a
    li x3, 0x9b50008a
    csrw 0xdff, x3

    #Address 0xdff Write value 0x14c5adb6
    li x3, 0x14c5adb6
    csrw 0xdff, x3

    #Address 0xdff read value
    csrr x14, 0xdff

    #Address 0xdff Write value 0xeeb98331
    li x3, 0xeeb98331
    csrw 0xdff, x3

    #Address 0xdff read value
    csrr x14, 0xdff

    #Unmapped address 0x2cb testing: random write/read operations
    #Address 0x2cb Write value 0x6b53791f
    li x3, 0x6b53791f
    csrw 0x2cb, x3

    #Address 0x2cb Write value 0x63e51710
    li x3, 0x63e51710
    csrw 0x2cb, x3

    #Address 0x2cb Write value 0x26b11aa1
    li x3, 0x26b11aa1
    csrw 0x2cb, x3

    #Unmapped address 0x970 testing: random write/read operations
    #Address 0x970 read value
    csrr x14, 0x970

    #Unmapped address 0x53d testing: random write/read operations
    #Address 0x53d read value
    csrr x14, 0x53d

    #Address 0x53d Write value 0x3d841dca
    li x3, 0x3d841dca
    csrw 0x53d, x3

    #Address 0x53d Write value 0xec5fdee
    li x3, 0xec5fdee
    csrw 0x53d, x3

    #Address 0x53d Write value 0x5c5fe245
    li x3, 0x5c5fe245
    csrw 0x53d, x3

    #Address 0x53d read value
    csrr x14, 0x53d

    #Unmapped address 0xf7d testing: random write/read operations
    #Address 0xf7d Write value 0x44a85cd
    li x3, 0x44a85cd
    csrw 0xf7d, x3

    #Address 0xf7d read value
    csrr x14, 0xf7d

    #Address 0xf7d Write value 0xfcaf6bb5
    li x3, 0xfcaf6bb5
    csrw 0xf7d, x3

    #Address 0xf7d Write value 0x6d6fd9
    li x3, 0x6d6fd9
    csrw 0xf7d, x3

    #Unmapped address 0xd87 testing: random write/read operations
    #Address 0xd87 read value
    csrr x14, 0xd87

    #Address 0xd87 read value
    csrr x14, 0xd87

    #Address 0xd87 Write value 0xad0c0eb
    li x3, 0xad0c0eb
    csrw 0xd87, x3

    #Address 0xd87 read value
    csrr x14, 0xd87

    #Address 0xd87 read value
    csrr x14, 0xd87

    #Unmapped address 0x683 testing: random write/read operations
    #Address 0x683 read value
    csrr x14, 0x683

    #Address 0x683 read value
    csrr x14, 0x683

    #Unmapped address 0xab8 testing: random write/read operations
    #Address 0xab8 Write value 0x9bc73caf
    li x3, 0x9bc73caf
    csrw 0xab8, x3

    #Address 0xab8 Write value 0x158abe55
    li x3, 0x158abe55
    csrw 0xab8, x3

    #Address 0xab8 read value
    csrr x14, 0xab8

    #Unmapped address 0xd19 testing: random write/read operations
    #Address 0xd19 Write value 0x369ff21b
    li x3, 0x369ff21b
    csrw 0xd19, x3

    #Address 0xd19 read value
    csrr x14, 0xd19

    #Address 0xd19 Write value 0x2a93b84e
    li x3, 0x2a93b84e
    csrw 0xd19, x3

    #Address 0xd19 read value
    csrr x14, 0xd19

    #Address 0xd19 Write value 0x39d8d1bf
    li x3, 0x39d8d1bf
    csrw 0xd19, x3

    #Unmapped address 0xe66 testing: random write/read operations
    #Address 0xe66 read value
    csrr x14, 0xe66

    #Address 0xe66 read value
    csrr x14, 0xe66

    #Unmapped address 0x7d testing: random write/read operations
    #Address 0x7d read value
    csrr x14, 0x7d

    #Address 0x7d Write value 0x3838e8a
    li x3, 0x3838e8a
    csrw 0x7d, x3

    #Address 0x7d Write value 0xdaff294c
    li x3, 0xdaff294c
    csrw 0x7d, x3

    #Unmapped address 0x365 testing: random write/read operations
    #Address 0x365 read value
    csrr x14, 0x365

    #Address 0x365 Write value 0x566ea14b
    li x3, 0x566ea14b
    csrw 0x365, x3

    #Address 0x365 read value
    csrr x14, 0x365

    #Address 0x365 Write value 0x59c04101
    li x3, 0x59c04101
    csrw 0x365, x3

    #Unmapped address 0x29e testing: random write/read operations
    #Address 0x29e read value
    csrr x14, 0x29e

    #Unmapped address 0xd73 testing: random write/read operations
    #Address 0xd73 read value
    csrr x14, 0xd73

    #Address 0xd73 Write value 0x3b0b8859
    li x3, 0x3b0b8859
    csrw 0xd73, x3

    #Address 0xd73 Write value 0xfdf33c13
    li x3, 0xfdf33c13
    csrw 0xd73, x3

    #Address 0xd73 Write value 0xac64809b
    li x3, 0xac64809b
    csrw 0xd73, x3

    #Address 0xd73 read value
    csrr x14, 0xd73

    #Unmapped address 0xb48 testing: random write/read operations
    #Address 0xb48 Write value 0x67437c9e
    li x3, 0x67437c9e
    csrw 0xb48, x3

    #Address 0xb48 Write value 0x5d4358a8
    li x3, 0x5d4358a8
    csrw 0xb48, x3

    #Address 0xb48 read value
    csrr x14, 0xb48

    #Address 0xb48 Write value 0xde5bdcb5
    li x3, 0xde5bdcb5
    csrw 0xb48, x3

    #Unmapped address 0x8b1 testing: random write/read operations
    #Address 0x8b1 read value
    csrr x14, 0x8b1

    #Address 0x8b1 Write value 0x6c5935bc
    li x3, 0x6c5935bc
    csrw 0x8b1, x3

    #Unmapped address 0xff7 testing: random write/read operations
    #Address 0xff7 read value
    csrr x14, 0xff7

    #Address 0xff7 Write value 0xec9492d
    li x3, 0xec9492d
    csrw 0xff7, x3

    #Address 0xff7 Write value 0x8878bb2b
    li x3, 0x8878bb2b
    csrw 0xff7, x3

    #Address 0xff7 Write value 0xceaba5ec
    li x3, 0xceaba5ec
    csrw 0xff7, x3

    #Unmapped address 0x18d testing: random write/read operations
    #Address 0x18d Write value 0x13d769b5
    li x3, 0x13d769b5
    csrw 0x18d, x3

    #Address 0x18d read value
    csrr x14, 0x18d

    #Address 0x18d Write value 0x60fa0fad
    li x3, 0x60fa0fad
    csrw 0x18d, x3

    #Unmapped address 0x4d1 testing: random write/read operations
    #Address 0x4d1 Write value 0x70b42c50
    li x3, 0x70b42c50
    csrw 0x4d1, x3

    #Mapped address 0xb9b (mhpmcounterh27) testing: random write/read operations
    #Address 0xb9b Write value 0xa9e6351d
    li x3, 0xa9e6351d
    csrw 0xb9b, x3

    #Address 0xb9b Write value 0xc8815403
    li x3, 0xc8815403
    csrw 0xb9b, x3

    #Address 0xb9b read value
    csrr x14, 0xb9b

    #Address 0xb9b Write value 0x306657bd
    li x3, 0x306657bd
    csrw 0xb9b, x3

    #Address 0xb9b Write value 0x2d23c9b7
    li x3, 0x2d23c9b7
    csrw 0xb9b, x3

    #Unmapped address 0x4a7 testing: random write/read operations
    #Address 0x4a7 read value
    csrr x14, 0x4a7

    #Address 0x4a7 read value
    csrr x14, 0x4a7

    #Address 0x4a7 Write value 0xb9240c91
    li x3, 0xb9240c91
    csrw 0x4a7, x3

    #Address 0x4a7 read value
    csrr x14, 0x4a7

    #Unmapped address 0xeb2 testing: random write/read operations
    #Address 0xeb2 Write value 0xddc78bde
    li x3, 0xddc78bde
    csrw 0xeb2, x3

    #Address 0xeb2 read value
    csrr x14, 0xeb2

    #Address 0xeb2 read value
    csrr x14, 0xeb2

    #Address 0xeb2 read value
    csrr x14, 0xeb2

    #Unmapped address 0x698 testing: random write/read operations
    #Address 0x698 Write value 0xffcc52c9
    li x3, 0xffcc52c9
    csrw 0x698, x3

    #Address 0x698 Write value 0x64efe1b6
    li x3, 0x64efe1b6
    csrw 0x698, x3

    #Address 0x698 Write value 0xb337d993
    li x3, 0xb337d993
    csrw 0x698, x3

    #Mapped address 0xb02 (minstret) testing: random write/read operations
    #Address 0xb02 read value
    csrr x14, 0xb02

    #Address 0xb02 Write value 0x18afa84c
    li x3, 0x18afa84c
    csrw 0xb02, x3

    #Address 0xb02 read value
    csrr x14, 0xb02

    #Unmapped address 0xd58 testing: random write/read operations
    #Address 0xd58 Write value 0x7cb7be72
    li x3, 0x7cb7be72
    csrw 0xd58, x3

    #Address 0xd58 read value
    csrr x14, 0xd58

    #Address 0xd58 Write value 0xae3dd4b8
    li x3, 0xae3dd4b8
    csrw 0xd58, x3

    #Address 0xd58 Write value 0xc1fe48e0
    li x3, 0xc1fe48e0
    csrw 0xd58, x3

    #Unmapped address 0x2c3 testing: random write/read operations
    #Address 0x2c3 Write value 0xdbc4d92b
    li x3, 0xdbc4d92b
    csrw 0x2c3, x3

    #Address 0x2c3 read value
    csrr x14, 0x2c3

    #Address 0x2c3 Write value 0xfc52db59
    li x3, 0xfc52db59
    csrw 0x2c3, x3

    #Address 0x2c3 Write value 0xf1c7543f
    li x3, 0xf1c7543f
    csrw 0x2c3, x3

    #Unmapped address 0x880 testing: random write/read operations
    #Address 0x880 read value
    csrr x14, 0x880

    #Address 0x880 Write value 0x80443463
    li x3, 0x80443463
    csrw 0x880, x3

    #Address 0x880 read value
    csrr x14, 0x880

    #Unmapped address 0x668 testing: random write/read operations
    #Address 0x668 read value
    csrr x14, 0x668

    #Address 0x668 Write value 0x46ae5b99
    li x3, 0x46ae5b99
    csrw 0x668, x3

    #Address 0x668 read value
    csrr x14, 0x668

    #Address 0x668 read value
    csrr x14, 0x668

    #Address 0x668 read value
    csrr x14, 0x668

    #Unmapped address 0xcdc testing: random write/read operations
    #Address 0xcdc Write value 0x187e824f
    li x3, 0x187e824f
    csrw 0xcdc, x3

    #Unmapped address 0x81e testing: random write/read operations
    #Address 0x81e read value
    csrr x14, 0x81e

    #Address 0x81e read value
    csrr x14, 0x81e

    #Address 0x81e Write value 0x3baf8de6
    li x3, 0x3baf8de6
    csrw 0x81e, x3

    #Unmapped address 0x953 testing: random write/read operations
    #Address 0x953 read value
    csrr x14, 0x953

    #Address 0x953 Write value 0x3744cdd9
    li x3, 0x3744cdd9
    csrw 0x953, x3

    #Unmapped address 0xe55 testing: random write/read operations
    #Address 0xe55 Write value 0x623b9521
    li x3, 0x623b9521
    csrw 0xe55, x3

    #Unmapped address 0x4b5 testing: random write/read operations
    #Address 0x4b5 read value
    csrr x14, 0x4b5

    #Address 0x4b5 read value
    csrr x14, 0x4b5

    #Address 0x4b5 Write value 0x2dea20bb
    li x3, 0x2dea20bb
    csrw 0x4b5, x3

    #Address 0x4b5 read value
    csrr x14, 0x4b5

    #Unmapped address 0x44 testing: random write/read operations
    #Address 0x44 read value
    csrr x14, 0x44

    #Address 0x44 read value
    csrr x14, 0x44

    #Address 0x44 read value
    csrr x14, 0x44

    #Address 0x44 Write value 0x9c323a47
    li x3, 0x9c323a47
    csrw 0x44, x3

    #Unmapped address 0xb6c testing: random write/read operations
    #Address 0xb6c read value
    csrr x14, 0xb6c

    #Unmapped address 0x29f testing: random write/read operations
    #Address 0x29f read value
    csrr x14, 0x29f

    #Address 0x29f read value
    csrr x14, 0x29f

    #Address 0x29f Write value 0x576121f6
    li x3, 0x576121f6
    csrw 0x29f, x3

    #Unmapped address 0xecb testing: random write/read operations
    #Address 0xecb Write value 0xfbc99a80
    li x3, 0xfbc99a80
    csrw 0xecb, x3

    #Address 0xecb Write value 0xd744ba8c
    li x3, 0xd744ba8c
    csrw 0xecb, x3

    #Address 0xecb read value
    csrr x14, 0xecb

    #Address 0xecb read value
    csrr x14, 0xecb

    #Address 0xecb read value
    csrr x14, 0xecb

    #Mapped address 0xb8c (mhpmcounterh12) testing: random write/read operations
    #Address 0xb8c Write value 0x10af6bb5
    li x3, 0x10af6bb5
    csrw 0xb8c, x3

    #Address 0xb8c Write value 0xe0ebc051
    li x3, 0xe0ebc051
    csrw 0xb8c, x3

    #Address 0xb8c Write value 0xb507131e
    li x3, 0xb507131e
    csrw 0xb8c, x3

    #Address 0xb8c Write value 0x896f1fb3
    li x3, 0x896f1fb3
    csrw 0xb8c, x3

    #Unmapped address 0x4da testing: random write/read operations
    #Address 0x4da Write value 0xdd13f487
    li x3, 0xdd13f487
    csrw 0x4da, x3

    #Address 0x4da read value
    csrr x14, 0x4da

    #Address 0x4da read value
    csrr x14, 0x4da

    #Unmapped address 0xb5c testing: random write/read operations
    #Address 0xb5c Write value 0x5a7d76cc
    li x3, 0x5a7d76cc
    csrw 0xb5c, x3

    #Address 0xb5c Write value 0x941add77
    li x3, 0x941add77
    csrw 0xb5c, x3

    #Unmapped address 0xf6a testing: random write/read operations
    #Address 0xf6a Write value 0x8facc331
    li x3, 0x8facc331
    csrw 0xf6a, x3

    #Address 0xf6a read value
    csrr x14, 0xf6a

    #Address 0xf6a Write value 0x6bc07c46
    li x3, 0x6bc07c46
    csrw 0xf6a, x3

    #Address 0xf6a read value
    csrr x14, 0xf6a

    #Address 0xf6a Write value 0xded639f5
    li x3, 0xded639f5
    csrw 0xf6a, x3

    #Unmapped address 0xd1 testing: random write/read operations
    #Address 0xd1 read value
    csrr x14, 0xd1

    #Address 0xd1 Write value 0xf206dfa3
    li x3, 0xf206dfa3
    csrw 0xd1, x3

    #Unmapped address 0x522 testing: random write/read operations
    #Address 0x522 read value
    csrr x14, 0x522

    #Address 0x522 read value
    csrr x14, 0x522

    #Address 0x522 read value
    csrr x14, 0x522

    #Unmapped address 0xb5a testing: random write/read operations
    #Address 0xb5a read value
    csrr x14, 0xb5a

    #Address 0xb5a read value
    csrr x14, 0xb5a

    #Unmapped address 0x43e testing: random write/read operations
    #Address 0x43e read value
    csrr x14, 0x43e

    #Address 0x43e read value
    csrr x14, 0x43e

    #Address 0x43e read value
    csrr x14, 0x43e

    #Unmapped address 0x8cb testing: random write/read operations
    #Address 0x8cb Write value 0x6d79d34c
    li x3, 0x6d79d34c
    csrw 0x8cb, x3

    #Address 0x8cb Write value 0x4a1a06bc
    li x3, 0x4a1a06bc
    csrw 0x8cb, x3

    #Address 0x8cb Write value 0x49718e2a
    li x3, 0x49718e2a
    csrw 0x8cb, x3

    #Address 0x8cb Write value 0xa6716690
    li x3, 0xa6716690
    csrw 0x8cb, x3

    #Unmapped address 0xcbb testing: random write/read operations
    #Address 0xcbb read value
    csrr x14, 0xcbb

    #Address 0xcbb read value
    csrr x14, 0xcbb

    #Unmapped address 0x28a testing: random write/read operations
    #Address 0x28a read value
    csrr x14, 0x28a

    #Address 0x28a Write value 0x3a48b3ab
    li x3, 0x3a48b3ab
    csrw 0x28a, x3

    #Address 0x28a read value
    csrr x14, 0x28a

    #Unmapped address 0x7b testing: random write/read operations
    #Address 0x7b Write value 0x381fdaa6
    li x3, 0x381fdaa6
    csrw 0x7b, x3

    #Unmapped address 0xdf3 testing: random write/read operations
    #Address 0xdf3 read value
    csrr x14, 0xdf3

    #Address 0xdf3 read value
    csrr x14, 0xdf3

    #Address 0xdf3 read value
    csrr x14, 0xdf3

    #Unmapped address 0x731 testing: random write/read operations
    #Address 0x731 read value
    csrr x14, 0x731

    #Address 0x731 Write value 0x5feeab6a
    li x3, 0x5feeab6a
    csrw 0x731, x3

    #Address 0x731 Write value 0xa0e8d2d
    li x3, 0xa0e8d2d
    csrw 0x731, x3

    #Address 0x731 read value
    csrr x14, 0x731

    #Address 0x731 Write value 0xf6b07706
    li x3, 0xf6b07706
    csrw 0x731, x3

    #Unmapped address 0xc8b testing: random write/read operations
    #Address 0xc8b Write value 0x716490c0
    li x3, 0x716490c0
    csrw 0xc8b, x3

    #Unmapped address 0x4c2 testing: random write/read operations
    #Address 0x4c2 read value
    csrr x14, 0x4c2

    #Unmapped address 0x389 testing: random write/read operations
    #Address 0x389 Write value 0x8beca511
    li x3, 0x8beca511
    csrw 0x389, x3

    #Address 0x389 Write value 0xfea1a50e
    li x3, 0xfea1a50e
    csrw 0x389, x3

    #Address 0x389 Write value 0x3ebafce0
    li x3, 0x3ebafce0
    csrw 0x389, x3

    #Unmapped address 0x66e testing: random write/read operations
    #Address 0x66e Write value 0x9eac6f18
    li x3, 0x9eac6f18
    csrw 0x66e, x3

    #Address 0x66e read value
    csrr x14, 0x66e

    #Unmapped address 0xdc5 testing: random write/read operations
    #Address 0xdc5 read value
    csrr x14, 0xdc5

    #Address 0xdc5 Write value 0xb9c54383
    li x3, 0xb9c54383
    csrw 0xdc5, x3

    #Address 0xdc5 Write value 0xc1d458c4
    li x3, 0xc1d458c4
    csrw 0xdc5, x3

    #Unmapped address 0xe34 testing: random write/read operations
    #Address 0xe34 read value
    csrr x14, 0xe34

    #Unmapped address 0x165 testing: random write/read operations
    #Address 0x165 read value
    csrr x14, 0x165

    #Address 0x165 read value
    csrr x14, 0x165

    #Address 0x165 Write value 0x50ee3005
    li x3, 0x50ee3005
    csrw 0x165, x3

    #Address 0x165 Write value 0xe720dadf
    li x3, 0xe720dadf
    csrw 0x165, x3

    #Unmapped address 0x977 testing: random write/read operations
    #Address 0x977 read value
    csrr x14, 0x977

    #Unmapped address 0x1f8 testing: random write/read operations
    #Address 0x1f8 Write value 0x1eb10c1d
    li x3, 0x1eb10c1d
    csrw 0x1f8, x3

    #Address 0x1f8 Write value 0xee13ccda
    li x3, 0xee13ccda
    csrw 0x1f8, x3

    #Address 0x1f8 read value
    csrr x14, 0x1f8

    #Unmapped address 0xfe5 testing: random write/read operations
    #Address 0xfe5 Write value 0x425bc2af
    li x3, 0x425bc2af
    csrw 0xfe5, x3

    #Address 0xfe5 Write value 0xb0d19013
    li x3, 0xb0d19013
    csrw 0xfe5, x3

    #Address 0xfe5 read value
    csrr x14, 0xfe5

    #Unmapped address 0xa5b testing: random write/read operations
    #Address 0xa5b Write value 0x6561731d
    li x3, 0x6561731d
    csrw 0xa5b, x3

    #Address 0xa5b read value
    csrr x14, 0xa5b

    #Address 0xa5b read value
    csrr x14, 0xa5b

    #Address 0xa5b Write value 0x30a0f286
    li x3, 0x30a0f286
    csrw 0xa5b, x3

    #Address 0xa5b Write value 0x2150d012
    li x3, 0x2150d012
    csrw 0xa5b, x3

    #Unmapped address 0xe43 testing: random write/read operations
    #Address 0xe43 read value
    csrr x14, 0xe43

    #Address 0xe43 Write value 0x7bc86140
    li x3, 0x7bc86140
    csrw 0xe43, x3

    #Address 0xe43 Write value 0xb38249c3
    li x3, 0xb38249c3
    csrw 0xe43, x3

    #Address 0xe43 read value
    csrr x14, 0xe43

    #Unmapped address 0x4b4 testing: random write/read operations
    #Address 0x4b4 read value
    csrr x14, 0x4b4

    #Address 0x4b4 Write value 0x7ffcf5c6
    li x3, 0x7ffcf5c6
    csrw 0x4b4, x3

    #Address 0x4b4 read value
    csrr x14, 0x4b4

    #Mapped address 0xb0f (mhpmcounter15) testing: random write/read operations
    #Address 0xb0f Write value 0xd674a39f
    li x3, 0xd674a39f
    csrw 0xb0f, x3

    #Address 0xb0f Write value 0xd351a88d
    li x3, 0xd351a88d
    csrw 0xb0f, x3

    #Unmapped address 0xcb2 testing: random write/read operations
    #Address 0xcb2 read value
    csrr x14, 0xcb2

    #Address 0xcb2 Write value 0x7ffa1bd8
    li x3, 0x7ffa1bd8
    csrw 0xcb2, x3

    #Address 0xcb2 read value
    csrr x14, 0xcb2

    #Unmapped address 0xf34 testing: random write/read operations
    #Address 0xf34 Write value 0xc1993fc4
    li x3, 0xc1993fc4
    csrw 0xf34, x3

    #Address 0xf34 Write value 0xd8abdc89
    li x3, 0xd8abdc89
    csrw 0xf34, x3

    #Address 0xf34 Write value 0x281bbb4f
    li x3, 0x281bbb4f
    csrw 0xf34, x3

    #Address 0xf34 Write value 0x35b6f367
    li x3, 0x35b6f367
    csrw 0xf34, x3

    #Unmapped address 0x12a testing: random write/read operations
    #Address 0x12a Write value 0x738cc0f3
    li x3, 0x738cc0f3
    csrw 0x12a, x3

    #Address 0x12a Write value 0xb960344b
    li x3, 0xb960344b
    csrw 0x12a, x3

    #Address 0x12a read value
    csrr x14, 0x12a

    #Address 0x12a Write value 0x88c66273
    li x3, 0x88c66273
    csrw 0x12a, x3

    #Address 0x12a Write value 0x4064972
    li x3, 0x4064972
    csrw 0x12a, x3

    #Unmapped address 0x27a testing: random write/read operations
    #Address 0x27a Write value 0xffba4c5c
    li x3, 0xffba4c5c
    csrw 0x27a, x3

    #Unmapped address 0xd6d testing: random write/read operations
    #Address 0xd6d read value
    csrr x14, 0xd6d

    #Address 0xd6d Write value 0xc15356a4
    li x3, 0xc15356a4
    csrw 0xd6d, x3

    #Address 0xd6d read value
    csrr x14, 0xd6d

    #Address 0xd6d read value
    csrr x14, 0xd6d

    #Address 0xd6d Write value 0xe7c6e66
    li x3, 0xe7c6e66
    csrw 0xd6d, x3

    #Unmapped address 0xfac testing: random write/read operations
    #Address 0xfac Write value 0xdd85e1f2
    li x3, 0xdd85e1f2
    csrw 0xfac, x3

    #Address 0xfac read value
    csrr x14, 0xfac

    #Address 0xfac read value
    csrr x14, 0xfac

    #Address 0xfac Write value 0xb1dc69a2
    li x3, 0xb1dc69a2
    csrw 0xfac, x3

    #Address 0xfac Write value 0x327e35b2
    li x3, 0x327e35b2
    csrw 0xfac, x3

    #Unmapped address 0xf9c testing: random write/read operations
    #Address 0xf9c Write value 0xbb7cac93
    li x3, 0xbb7cac93
    csrw 0xf9c, x3

    #Address 0xf9c read value
    csrr x14, 0xf9c

    #Address 0xf9c Write value 0x74664366
    li x3, 0x74664366
    csrw 0xf9c, x3

    #Address 0xf9c Write value 0x65c55b34
    li x3, 0x65c55b34
    csrw 0xf9c, x3

    #Unmapped address 0x57d testing: random write/read operations
    #Address 0x57d read value
    csrr x14, 0x57d

    #Address 0x57d read value
    csrr x14, 0x57d

    #Address 0x57d read value
    csrr x14, 0x57d

    #Address 0x57d Write value 0x4adeb6d9
    li x3, 0x4adeb6d9
    csrw 0x57d, x3

    #Address 0x57d read value
    csrr x14, 0x57d

    #Unmapped address 0x2a5 testing: random write/read operations
    #Address 0x2a5 read value
    csrr x14, 0x2a5

    #Address 0x2a5 read value
    csrr x14, 0x2a5

    #Unmapped address 0xca8 testing: random write/read operations
    #Address 0xca8 read value
    csrr x14, 0xca8

    #Address 0xca8 Write value 0xbce5cc6c
    li x3, 0xbce5cc6c
    csrw 0xca8, x3

    #Address 0xca8 Write value 0x6efcc6ee
    li x3, 0x6efcc6ee
    csrw 0xca8, x3

    #Address 0xca8 Write value 0x7a369720
    li x3, 0x7a369720
    csrw 0xca8, x3

    #Unmapped address 0xf22 testing: random write/read operations
    #Address 0xf22 read value
    csrr x14, 0xf22

    #Address 0xf22 Write value 0x191494e7
    li x3, 0x191494e7
    csrw 0xf22, x3

    #Address 0xf22 read value
    csrr x14, 0xf22

    #Unmapped address 0xa78 testing: random write/read operations
    #Address 0xa78 Write value 0x162eb48f
    li x3, 0x162eb48f
    csrw 0xa78, x3

    #Address 0xa78 read value
    csrr x14, 0xa78

    #Unmapped address 0x709 testing: random write/read operations
    #Address 0x709 Write value 0x5855f75b
    li x3, 0x5855f75b
    csrw 0x709, x3

    #Address 0x709 read value
    csrr x14, 0x709

    #Unmapped address 0xc2 testing: random write/read operations
    #Address 0xc2 Write value 0xbda0a67c
    li x3, 0xbda0a67c
    csrw 0xc2, x3

    #Address 0xc2 Write value 0x6194a82d
    li x3, 0x6194a82d
    csrw 0xc2, x3

    #Address 0xc2 read value
    csrr x14, 0xc2

    #Unmapped address 0xc4 testing: random write/read operations
    #Address 0xc4 read value
    csrr x14, 0xc4

    #Address 0xc4 read value
    csrr x14, 0xc4

    #Unmapped address 0x13f testing: random write/read operations
    #Address 0x13f read value
    csrr x14, 0x13f

    #Unmapped address 0x277 testing: random write/read operations
    #Address 0x277 read value
    csrr x14, 0x277

    #Address 0x277 Write value 0x43252f93
    li x3, 0x43252f93
    csrw 0x277, x3

    #Address 0x277 Write value 0x616403d9
    li x3, 0x616403d9
    csrw 0x277, x3

    #Address 0x277 read value
    csrr x14, 0x277

    #Address 0x277 read value
    csrr x14, 0x277

    #Mapped address 0xb12 (mhpmcounter18) testing: random write/read operations
    #Address 0xb12 Write value 0x29ea22e8
    li x3, 0x29ea22e8
    csrw 0xb12, x3

    #Unmapped address 0xff0 testing: random write/read operations
    #Address 0xff0 Write value 0x9d586c5c
    li x3, 0x9d586c5c
    csrw 0xff0, x3

    #Address 0xff0 read value
    csrr x14, 0xff0

    #Address 0xff0 read value
    csrr x14, 0xff0

    #Address 0xff0 read value
    csrr x14, 0xff0

    #Unmapped address 0x576 testing: random write/read operations
    #Address 0x576 Write value 0x29567ddb
    li x3, 0x29567ddb
    csrw 0x576, x3

    #Address 0x576 Write value 0x30ee3609
    li x3, 0x30ee3609
    csrw 0x576, x3

    #Address 0x576 read value
    csrr x14, 0x576

    #Address 0x576 Write value 0x8c397181
    li x3, 0x8c397181
    csrw 0x576, x3

    #Unmapped address 0x500 testing: random write/read operations
    #Address 0x500 Write value 0xa00fbcca
    li x3, 0xa00fbcca
    csrw 0x500, x3

    #Address 0x500 Write value 0x4c717eec
    li x3, 0x4c717eec
    csrw 0x500, x3

    #Address 0x500 read value
    csrr x14, 0x500

    #Address 0x500 Write value 0x4ab34890
    li x3, 0x4ab34890
    csrw 0x500, x3

    #Address 0x500 Write value 0xf001cf50
    li x3, 0xf001cf50
    csrw 0x500, x3

    #Unmapped address 0x94f testing: random write/read operations
    #Address 0x94f read value
    csrr x14, 0x94f

    #Address 0x94f read value
    csrr x14, 0x94f

    #Address 0x94f Write value 0xf46747f8
    li x3, 0xf46747f8
    csrw 0x94f, x3

    #Address 0x94f Write value 0x96d4aedb
    li x3, 0x96d4aedb
    csrw 0x94f, x3

    #Address 0x94f read value
    csrr x14, 0x94f

    #Unmapped address 0xc58 testing: random write/read operations
    #Address 0xc58 Write value 0x23a2e136
    li x3, 0x23a2e136
    csrw 0xc58, x3

    #Unmapped address 0xe2a testing: random write/read operations
    #Address 0xe2a Write value 0x892030c6
    li x3, 0x892030c6
    csrw 0xe2a, x3

    #Address 0xe2a read value
    csrr x14, 0xe2a

    #Unmapped address 0x6f9 testing: random write/read operations
    #Address 0x6f9 read value
    csrr x14, 0x6f9

    #Address 0x6f9 Write value 0x91b67697
    li x3, 0x91b67697
    csrw 0x6f9, x3

    #Address 0x6f9 read value
    csrr x14, 0x6f9

    #Unmapped address 0xd85 testing: random write/read operations
    #Address 0xd85 Write value 0x599654d5
    li x3, 0x599654d5
    csrw 0xd85, x3

    #Address 0xd85 read value
    csrr x14, 0xd85

    #Address 0xd85 Write value 0xfb8d6502
    li x3, 0xfb8d6502
    csrw 0xd85, x3

    #Address 0xd85 read value
    csrr x14, 0xd85

    #Address 0xd85 read value
    csrr x14, 0xd85

    #Unmapped address 0x321 testing: random write/read operations
    #Address 0x321 Write value 0xdaa672bf
    li x3, 0xdaa672bf
    csrw 0x321, x3

    #Address 0x321 read value
    csrr x14, 0x321

    #Address 0x321 Write value 0x7d9ae5b9
    li x3, 0x7d9ae5b9
    csrw 0x321, x3

    #Unmapped address 0x652 testing: random write/read operations
    #Address 0x652 Write value 0x62074354
    li x3, 0x62074354
    csrw 0x652, x3

    #Unmapped address 0x297 testing: random write/read operations
    #Address 0x297 Write value 0x981dc3b3
    li x3, 0x981dc3b3
    csrw 0x297, x3

    #Address 0x297 Write value 0xe5d7e09a
    li x3, 0xe5d7e09a
    csrw 0x297, x3

    #Unmapped address 0x426 testing: random write/read operations
    #Address 0x426 Write value 0x7d5a523f
    li x3, 0x7d5a523f
    csrw 0x426, x3

    #Unmapped address 0xe03 testing: random write/read operations
    #Address 0xe03 Write value 0x71269eae
    li x3, 0x71269eae
    csrw 0xe03, x3

    #Address 0xe03 read value
    csrr x14, 0xe03

    #Address 0xe03 read value
    csrr x14, 0xe03

    #Address 0xe03 read value
    csrr x14, 0xe03

    #Address 0xe03 Write value 0xefeec17b
    li x3, 0xefeec17b
    csrw 0xe03, x3

    #Unmapped address 0x1c9 testing: random write/read operations
    #Address 0x1c9 Write value 0x67e1a1d5
    li x3, 0x67e1a1d5
    csrw 0x1c9, x3

    #Address 0x1c9 read value
    csrr x14, 0x1c9

    #Address 0x1c9 read value
    csrr x14, 0x1c9

    #Address 0x1c9 Write value 0x375aff48
    li x3, 0x375aff48
    csrw 0x1c9, x3

    #Unmapped address 0xdcf testing: random write/read operations
    #Address 0xdcf read value
    csrr x14, 0xdcf

    #Address 0xdcf Write value 0x6a678e67
    li x3, 0x6a678e67
    csrw 0xdcf, x3

    #Unmapped address 0xe7a testing: random write/read operations
    #Address 0xe7a read value
    csrr x14, 0xe7a

    #Address 0xe7a read value
    csrr x14, 0xe7a

    #Address 0xe7a Write value 0xc30030ca
    li x3, 0xc30030ca
    csrw 0xe7a, x3

    #Address 0xe7a Write value 0xb2278cf2
    li x3, 0xb2278cf2
    csrw 0xe7a, x3

    #Unmapped address 0x2c6 testing: random write/read operations
    #Address 0x2c6 read value
    csrr x14, 0x2c6

    #Address 0x2c6 read value
    csrr x14, 0x2c6

    #Address 0x2c6 read value
    csrr x14, 0x2c6

    #Address 0x2c6 Write value 0xdef95f74
    li x3, 0xdef95f74
    csrw 0x2c6, x3

    #Address 0x2c6 read value
    csrr x14, 0x2c6

    #Unmapped address 0x534 testing: random write/read operations
    #Address 0x534 Write value 0xfaf69322
    li x3, 0xfaf69322
    csrw 0x534, x3

    #Address 0x534 Write value 0x5877081e
    li x3, 0x5877081e
    csrw 0x534, x3

    #Unmapped address 0x227 testing: random write/read operations
    #Address 0x227 read value
    csrr x14, 0x227

    #Unmapped address 0xf15 testing: random write/read operations
    #Address 0xf15 Write value 0xbc406f5f
    li x3, 0xbc406f5f
    csrw 0xf15, x3

    #Mapped address 0x330 (mhpmevent16) testing: random write/read operations
    #Address 0x330 read value
    csrr x14, 0x330

    #Mapped address 0x323 (mhpmevent3) testing: random write/read operations
    #Address 0x323 Write value 0xa6a6be66
    li x3, 0xa6a6be66
    csrw 0x323, x3

    #Address 0x323 read value
    csrr x14, 0x323

    #Unmapped address 0xb20 testing: random write/read operations
    #Address 0xb20 read value
    csrr x14, 0xb20

    #Unmapped address 0xbd9 testing: random write/read operations
    #Address 0xbd9 Write value 0xbbb8b1e1
    li x3, 0xbbb8b1e1
    csrw 0xbd9, x3

    #Address 0xbd9 Write value 0x2d863645
    li x3, 0x2d863645
    csrw 0xbd9, x3

    #Unmapped address 0x1b9 testing: random write/read operations
    #Address 0x1b9 read value
    csrr x14, 0x1b9

    #Address 0x1b9 read value
    csrr x14, 0x1b9

    #Address 0x1b9 read value
    csrr x14, 0x1b9

    #Address 0x1b9 read value
    csrr x14, 0x1b9

    #Address 0x1b9 read value
    csrr x14, 0x1b9

    #Unmapped address 0xdea testing: random write/read operations
    #Address 0xdea Write value 0xdf73148d
    li x3, 0xdf73148d
    csrw 0xdea, x3

    #Address 0xdea read value
    csrr x14, 0xdea

    #Unmapped address 0xe11 testing: random write/read operations
    #Address 0xe11 read value
    csrr x14, 0xe11

    #Unmapped address 0x1fb testing: random write/read operations
    #Address 0x1fb read value
    csrr x14, 0x1fb

    #Address 0x1fb read value
    csrr x14, 0x1fb

    #Address 0x1fb read value
    csrr x14, 0x1fb

    #Address 0x1fb Write value 0xed321eed
    li x3, 0xed321eed
    csrw 0x1fb, x3

    #Address 0x1fb Write value 0x6554abdd
    li x3, 0x6554abdd
    csrw 0x1fb, x3

    #Unmapped address 0xe24 testing: random write/read operations
    #Address 0xe24 Write value 0x5c09dddc
    li x3, 0x5c09dddc
    csrw 0xe24, x3

    #Address 0xe24 read value
    csrr x14, 0xe24

    #Address 0xe24 read value
    csrr x14, 0xe24

    #Unmapped address 0x8de testing: random write/read operations
    #Address 0x8de read value
    csrr x14, 0x8de

    #Unmapped address 0xbbe testing: random write/read operations
    #Address 0xbbe read value
    csrr x14, 0xbbe

    #Address 0xbbe Write value 0x48ec10ae
    li x3, 0x48ec10ae
    csrw 0xbbe, x3

    #Address 0xbbe read value
    csrr x14, 0xbbe

    #Address 0xbbe Write value 0x7eedd575
    li x3, 0x7eedd575
    csrw 0xbbe, x3

    #Unmapped address 0xe59 testing: random write/read operations
    #Address 0xe59 read value
    csrr x14, 0xe59

    #Address 0xe59 Write value 0x8aa9c7aa
    li x3, 0x8aa9c7aa
    csrw 0xe59, x3

    #Address 0xe59 read value
    csrr x14, 0xe59

    #Address 0xe59 Write value 0x270eca24
    li x3, 0x270eca24
    csrw 0xe59, x3

    #Address 0xe59 read value
    csrr x14, 0xe59

    #Unmapped address 0xbfc testing: random write/read operations
    #Address 0xbfc Write value 0x7670ec4d
    li x3, 0x7670ec4d
    csrw 0xbfc, x3

    #Address 0xbfc Write value 0xde193435
    li x3, 0xde193435
    csrw 0xbfc, x3

    #Address 0xbfc Write value 0xb0e1cd6
    li x3, 0xb0e1cd6
    csrw 0xbfc, x3

    #Unmapped address 0xd3b testing: random write/read operations
    #Address 0xd3b Write value 0x4a8bf217
    li x3, 0x4a8bf217
    csrw 0xd3b, x3

    #Address 0xd3b Write value 0x2aeba9f9
    li x3, 0x2aeba9f9
    csrw 0xd3b, x3

    #Address 0xd3b Write value 0x46a0d2f2
    li x3, 0x46a0d2f2
    csrw 0xd3b, x3

    #Address 0xd3b Write value 0xad87236f
    li x3, 0xad87236f
    csrw 0xd3b, x3

    #Address 0xd3b Write value 0xe72773d5
    li x3, 0xe72773d5
    csrw 0xd3b, x3

    #Unmapped address 0x643 testing: random write/read operations
    #Address 0x643 read value
    csrr x14, 0x643

    #Address 0x643 read value
    csrr x14, 0x643

    #Address 0x643 read value
    csrr x14, 0x643

    #Address 0x643 Write value 0xb19e1640
    li x3, 0xb19e1640
    csrw 0x643, x3

    #Address 0x643 read value
    csrr x14, 0x643

    #Unmapped address 0x730 testing: random write/read operations
    #Address 0x730 Write value 0x1e1d5646
    li x3, 0x1e1d5646
    csrw 0x730, x3

    #Unmapped address 0xeec testing: random write/read operations
    #Address 0xeec read value
    csrr x14, 0xeec

    #Address 0xeec read value
    csrr x14, 0xeec

    #Address 0xeec Write value 0x6f2c841d
    li x3, 0x6f2c841d
    csrw 0xeec, x3

    #Address 0xeec Write value 0x856a907c
    li x3, 0x856a907c
    csrw 0xeec, x3

    #Unmapped address 0x924 testing: random write/read operations
    #Address 0x924 Write value 0x3c9159a1
    li x3, 0x3c9159a1
    csrw 0x924, x3

    #Address 0x924 read value
    csrr x14, 0x924

    #Address 0x924 Write value 0xf2df7cee
    li x3, 0xf2df7cee
    csrw 0x924, x3

    #Address 0x924 read value
    csrr x14, 0x924

    #Address 0x924 Write value 0x20ad0be9
    li x3, 0x20ad0be9
    csrw 0x924, x3

    #Mapped address 0xb9c (mhpmcounterh28) testing: random write/read operations
    #Address 0xb9c read value
    csrr x14, 0xb9c

    #Address 0xb9c read value
    csrr x14, 0xb9c

    #Address 0xb9c Write value 0x3e6ae13b
    li x3, 0x3e6ae13b
    csrw 0xb9c, x3

    #Unmapped address 0xce2 testing: random write/read operations
    #Address 0xce2 Write value 0x97021cae
    li x3, 0x97021cae
    csrw 0xce2, x3

    #Address 0xce2 Write value 0x934a2e46
    li x3, 0x934a2e46
    csrw 0xce2, x3

    #Unmapped address 0x575 testing: random write/read operations
    #Address 0x575 read value
    csrr x14, 0x575

    #Unmapped address 0x802 testing: random write/read operations
    #Address 0x802 Write value 0xc1b6e14
    li x3, 0xc1b6e14
    csrw 0x802, x3

    #Address 0x802 Write value 0xca201042
    li x3, 0xca201042
    csrw 0x802, x3

    #Address 0x802 Write value 0xc24f525e
    li x3, 0xc24f525e
    csrw 0x802, x3

    #Address 0x802 read value
    csrr x14, 0x802

    #Unmapped address 0xbb4 testing: random write/read operations
    #Address 0xbb4 Write value 0x4def698e
    li x3, 0x4def698e
    csrw 0xbb4, x3

    #Address 0xbb4 Write value 0x9951b85c
    li x3, 0x9951b85c
    csrw 0xbb4, x3

    #Address 0xbb4 Write value 0x68c21dc1
    li x3, 0x68c21dc1
    csrw 0xbb4, x3

    #Address 0xbb4 Write value 0xff343900
    li x3, 0xff343900
    csrw 0xbb4, x3

    #Address 0xbb4 Write value 0x421d506d
    li x3, 0x421d506d
    csrw 0xbb4, x3

    #Unmapped address 0x124 testing: random write/read operations
    #Address 0x124 read value
    csrr x14, 0x124

    #Unmapped address 0xcaf testing: random write/read operations
    #Address 0xcaf read value
    csrr x14, 0xcaf

    #Address 0xcaf read value
    csrr x14, 0xcaf

    #Address 0xcaf read value
    csrr x14, 0xcaf

    #Address 0xcaf read value
    csrr x14, 0xcaf

    #Unmapped address 0x72c testing: random write/read operations
    #Address 0x72c Write value 0xe134c54e
    li x3, 0xe134c54e
    csrw 0x72c, x3

    #Address 0x72c Write value 0xe280a68d
    li x3, 0xe280a68d
    csrw 0x72c, x3

    #Address 0x72c read value
    csrr x14, 0x72c

    #Unmapped address 0x35f testing: random write/read operations
    #Address 0x35f read value
    csrr x14, 0x35f

    #Address 0x35f read value
    csrr x14, 0x35f

    #Address 0x35f Write value 0xe52cccf5
    li x3, 0xe52cccf5
    csrw 0x35f, x3

    #Address 0x35f Write value 0xcc215f53
    li x3, 0xcc215f53
    csrw 0x35f, x3

    #Address 0x35f read value
    csrr x14, 0x35f

    #Unmapped address 0xb31 testing: random write/read operations
    #Address 0xb31 Write value 0xddde43e8
    li x3, 0xddde43e8
    csrw 0xb31, x3

    #Address 0xb31 read value
    csrr x14, 0xb31

    #Address 0xb31 read value
    csrr x14, 0xb31

    #Unmapped address 0x733 testing: random write/read operations
    #Address 0x733 Write value 0x6afb90a8
    li x3, 0x6afb90a8
    csrw 0x733, x3

    #Address 0x733 Write value 0xbad6ea4f
    li x3, 0xbad6ea4f
    csrw 0x733, x3

    #Address 0x733 read value
    csrr x14, 0x733

    #Address 0x733 read value
    csrr x14, 0x733

    #Mapped address 0xc00 (cycle) testing: random write/read operations
    #Address 0xc00 read value
    csrr x14, 0xc00

    #Address 0xc00 Write value 0x30aef47f
    li x3, 0x30aef47f
    csrw 0xc00, x3

    #Address 0xc00 read value
    csrr x14, 0xc00

    #Address 0xc00 read value
    csrr x14, 0xc00

    #Address 0xc00 read value
    csrr x14, 0xc00

    #Unmapped address 0xb57 testing: random write/read operations
    #Address 0xb57 read value
    csrr x14, 0xb57

    #Address 0xb57 Write value 0x2c81d86
    li x3, 0x2c81d86
    csrw 0xb57, x3

    #Address 0xb57 read value
    csrr x14, 0xb57

    #Address 0xb57 read value
    csrr x14, 0xb57

    #Unmapped address 0x263 testing: random write/read operations
    #Address 0x263 read value
    csrr x14, 0x263

    #Unmapped address 0x5eb testing: random write/read operations
    #Address 0x5eb read value
    csrr x14, 0x5eb

    #Address 0x5eb Write value 0x95c99986
    li x3, 0x95c99986
    csrw 0x5eb, x3

    #Address 0x5eb Write value 0x57e4a64b
    li x3, 0x57e4a64b
    csrw 0x5eb, x3

    #Address 0x5eb read value
    csrr x14, 0x5eb

    #Address 0x5eb Write value 0xaf5562d9
    li x3, 0xaf5562d9
    csrw 0x5eb, x3

    #Unmapped address 0x9d0 testing: random write/read operations
    #Address 0x9d0 read value
    csrr x14, 0x9d0

    #Address 0x9d0 read value
    csrr x14, 0x9d0

    #Address 0x9d0 Write value 0x81291f58
    li x3, 0x81291f58
    csrw 0x9d0, x3

    #Address 0x9d0 Write value 0x4c983a0a
    li x3, 0x4c983a0a
    csrw 0x9d0, x3

    #Unmapped address 0xcf0 testing: random write/read operations
    #Address 0xcf0 read value
    csrr x14, 0xcf0

    #Address 0xcf0 Write value 0x4fb5118a
    li x3, 0x4fb5118a
    csrw 0xcf0, x3

    #Address 0xcf0 read value
    csrr x14, 0xcf0

    #Address 0xcf0 read value
    csrr x14, 0xcf0

    #Address 0xcf0 read value
    csrr x14, 0xcf0

    #Unmapped address 0x4af testing: random write/read operations
    #Address 0x4af Write value 0xd7ea3d7
    li x3, 0xd7ea3d7
    csrw 0x4af, x3

    #Address 0x4af read value
    csrr x14, 0x4af

    #Address 0x4af Write value 0xc0a3d6b8
    li x3, 0xc0a3d6b8
    csrw 0x4af, x3

    #Address 0x4af Write value 0x8ead065f
    li x3, 0x8ead065f
    csrw 0x4af, x3

    #Unmapped address 0x140 testing: random write/read operations
    #Address 0x140 Write value 0x5c1e1499
    li x3, 0x5c1e1499
    csrw 0x140, x3

    #Address 0x140 read value
    csrr x14, 0x140

    #Address 0x140 Write value 0x64f4fb3b
    li x3, 0x64f4fb3b
    csrw 0x140, x3

    #Unmapped address 0x624 testing: random write/read operations
    #Address 0x624 read value
    csrr x14, 0x624

    #Address 0x624 Write value 0xa5669413
    li x3, 0xa5669413
    csrw 0x624, x3

    #Address 0x624 read value
    csrr x14, 0x624

    #Address 0x624 Write value 0xed2088e1
    li x3, 0xed2088e1
    csrw 0x624, x3

    #Address 0x624 read value
    csrr x14, 0x624

    #Unmapped address 0x215 testing: random write/read operations
    #Address 0x215 read value
    csrr x14, 0x215

    #Address 0x215 Write value 0xdc84a95c
    li x3, 0xdc84a95c
    csrw 0x215, x3

    #Unmapped address 0x742 testing: random write/read operations
    #Address 0x742 read value
    csrr x14, 0x742

    #Address 0x742 Write value 0x2c9c36c6
    li x3, 0x2c9c36c6
    csrw 0x742, x3

    #Unmapped address 0x904 testing: random write/read operations
    #Address 0x904 Write value 0x6b0ca905
    li x3, 0x6b0ca905
    csrw 0x904, x3

    #Address 0x904 Write value 0x696c6a47
    li x3, 0x696c6a47
    csrw 0x904, x3

    #Unmapped address 0x61a testing: random write/read operations
    #Address 0x61a Write value 0x1b5021be
    li x3, 0x1b5021be
    csrw 0x61a, x3

    #Address 0x61a read value
    csrr x14, 0x61a

    #Unmapped address 0xb27 testing: random write/read operations
    #Address 0xb27 read value
    csrr x14, 0xb27

    #Unmapped address 0x5d7 testing: random write/read operations
    #Address 0x5d7 Write value 0x19934fff
    li x3, 0x19934fff
    csrw 0x5d7, x3

    #Address 0x5d7 read value
    csrr x14, 0x5d7

    #Address 0x5d7 read value
    csrr x14, 0x5d7

    #Address 0x5d7 Write value 0xdddac045
    li x3, 0xdddac045
    csrw 0x5d7, x3

    #Address 0x5d7 read value
    csrr x14, 0x5d7

    #Unmapped address 0x97c testing: random write/read operations
    #Address 0x97c read value
    csrr x14, 0x97c

    #Address 0x97c Write value 0x89e667ca
    li x3, 0x89e667ca
    csrw 0x97c, x3

    #Address 0x97c Write value 0xcf4962ce
    li x3, 0xcf4962ce
    csrw 0x97c, x3

    #Address 0x97c read value
    csrr x14, 0x97c

    #Address 0x97c read value
    csrr x14, 0x97c

    #Unmapped address 0xae4 testing: random write/read operations
    #Address 0xae4 Write value 0x6a1affd5
    li x3, 0x6a1affd5
    csrw 0xae4, x3

    #Address 0xae4 Write value 0xb387e6da
    li x3, 0xb387e6da
    csrw 0xae4, x3

    #Address 0xae4 read value
    csrr x14, 0xae4

    #Address 0xae4 read value
    csrr x14, 0xae4

    #Unmapped address 0xaa9 testing: random write/read operations
    #Address 0xaa9 Write value 0x43bdc134
    li x3, 0x43bdc134
    csrw 0xaa9, x3

    #Address 0xaa9 read value
    csrr x14, 0xaa9

    #Address 0xaa9 Write value 0xcec4aee8
    li x3, 0xcec4aee8
    csrw 0xaa9, x3

    #Unmapped address 0xdf5 testing: random write/read operations
    #Address 0xdf5 Write value 0x885c5045
    li x3, 0x885c5045
    csrw 0xdf5, x3

    #Address 0xdf5 Write value 0x3bedcc71
    li x3, 0x3bedcc71
    csrw 0xdf5, x3

    #Address 0xdf5 read value
    csrr x14, 0xdf5

    #Address 0xdf5 Write value 0xa24ae05f
    li x3, 0xa24ae05f
    csrw 0xdf5, x3

    #Address 0xdf5 read value
    csrr x14, 0xdf5

    #Unmapped address 0x181 testing: random write/read operations
    #Address 0x181 Write value 0xb64e8a55
    li x3, 0xb64e8a55
    csrw 0x181, x3

    #Address 0x181 read value
    csrr x14, 0x181

    #Address 0x181 Write value 0xf703c04e
    li x3, 0xf703c04e
    csrw 0x181, x3

    #Address 0x181 Write value 0xed38a68
    li x3, 0xed38a68
    csrw 0x181, x3

    #Unmapped address 0x88b testing: random write/read operations
    #Address 0x88b Write value 0xcf88a835
    li x3, 0xcf88a835
    csrw 0x88b, x3

    #Unmapped address 0x4e8 testing: random write/read operations
    #Address 0x4e8 read value
    csrr x14, 0x4e8

    #Unmapped address 0x6d2 testing: random write/read operations
    #Address 0x6d2 read value
    csrr x14, 0x6d2

    #Address 0x6d2 Write value 0x2810b3c2
    li x3, 0x2810b3c2
    csrw 0x6d2, x3

    #Address 0x6d2 read value
    csrr x14, 0x6d2

    #Address 0x6d2 read value
    csrr x14, 0x6d2

    #Address 0x6d2 read value
    csrr x14, 0x6d2

    #Unmapped address 0xf2 testing: random write/read operations
    #Address 0xf2 Write value 0xc46adbff
    li x3, 0xc46adbff
    csrw 0xf2, x3

    #Address 0xf2 read value
    csrr x14, 0xf2

    #Address 0xf2 read value
    csrr x14, 0xf2

    #Address 0xf2 Write value 0x403969ec
    li x3, 0x403969ec
    csrw 0xf2, x3

    #Address 0xf2 Write value 0xa5d2f948
    li x3, 0xa5d2f948
    csrw 0xf2, x3

    #Unmapped address 0xeae testing: random write/read operations
    #Address 0xeae read value
    csrr x14, 0xeae

    #Address 0xeae Write value 0x10db53de
    li x3, 0x10db53de
    csrw 0xeae, x3

    #Address 0xeae read value
    csrr x14, 0xeae

    #Unmapped address 0xde1 testing: random write/read operations
    #Address 0xde1 read value
    csrr x14, 0xde1

    #Address 0xde1 read value
    csrr x14, 0xde1

    #Address 0xde1 Write value 0x181d23e7
    li x3, 0x181d23e7
    csrw 0xde1, x3

    #Address 0xde1 read value
    csrr x14, 0xde1

    #Address 0xde1 read value
    csrr x14, 0xde1

    #Unmapped address 0xcc testing: random write/read operations
    #Address 0xcc Write value 0xb31ed7e9
    li x3, 0xb31ed7e9
    csrw 0xcc, x3

    #Mapped address 0xb1a (mhpmcounter26) testing: random write/read operations
    #Address 0xb1a read value
    csrr x14, 0xb1a

    #Address 0xb1a Write value 0xe8919052
    li x3, 0xe8919052
    csrw 0xb1a, x3

    #Address 0xb1a Write value 0x6f0d25f8
    li x3, 0x6f0d25f8
    csrw 0xb1a, x3

    #Address 0xb1a Write value 0x6a4b3031
    li x3, 0x6a4b3031
    csrw 0xb1a, x3

    #Address 0xb1a Write value 0x57c18d84
    li x3, 0x57c18d84
    csrw 0xb1a, x3

    #Unmapped address 0xe6f testing: random write/read operations
    #Address 0xe6f read value
    csrr x14, 0xe6f

    #Address 0xe6f read value
    csrr x14, 0xe6f

    #Address 0xe6f read value
    csrr x14, 0xe6f

    #Address 0xe6f read value
    csrr x14, 0xe6f

    #Unmapped address 0x362 testing: random write/read operations
    #Address 0x362 Write value 0x57cbe338
    li x3, 0x57cbe338
    csrw 0x362, x3

    #Address 0x362 Write value 0x4b64c7c6
    li x3, 0x4b64c7c6
    csrw 0x362, x3

    #Address 0x362 Write value 0x5b727fcc
    li x3, 0x5b727fcc
    csrw 0x362, x3

    #Address 0x362 Write value 0x7d7d6ed5
    li x3, 0x7d7d6ed5
    csrw 0x362, x3

    #Unmapped address 0xad2 testing: random write/read operations
    #Address 0xad2 read value
    csrr x14, 0xad2

    #Address 0xad2 read value
    csrr x14, 0xad2

    #Address 0xad2 Write value 0x95fad63c
    li x3, 0x95fad63c
    csrw 0xad2, x3

    #Address 0xad2 read value
    csrr x14, 0xad2

    #Address 0xad2 Write value 0x46bee1ac
    li x3, 0x46bee1ac
    csrw 0xad2, x3

    #Mapped address 0x310 (mstatush) testing: random write/read operations
    #Address 0x310 Write value 0x2e05de37
    li x3, 0x2e05de37
    csrw 0x310, x3

    #Address 0x310 Write value 0x18bcace2
    li x3, 0x18bcace2
    csrw 0x310, x3

    #Address 0x310 Write value 0xf837e0e2
    li x3, 0xf837e0e2
    csrw 0x310, x3

    #Address 0x310 Write value 0x6c54edfd
    li x3, 0x6c54edfd
    csrw 0x310, x3

    #Address 0x310 Write value 0x1f77b494
    li x3, 0x1f77b494
    csrw 0x310, x3

    #Unmapped address 0x1ef testing: random write/read operations
    #Address 0x1ef Write value 0xf739954f
    li x3, 0xf739954f
    csrw 0x1ef, x3

    #Address 0x1ef Write value 0xf31d2bb9
    li x3, 0xf31d2bb9
    csrw 0x1ef, x3

    #Address 0x1ef read value
    csrr x14, 0x1ef

    #Address 0x1ef Write value 0x5fab4c4a
    li x3, 0x5fab4c4a
    csrw 0x1ef, x3

    #Address 0x1ef Write value 0x611d5d63
    li x3, 0x611d5d63
    csrw 0x1ef, x3

    #Unmapped address 0x4a testing: random write/read operations
    #Address 0x4a Write value 0x9b8a8f6f
    li x3, 0x9b8a8f6f
    csrw 0x4a, x3

    #Address 0x4a read value
    csrr x14, 0x4a

    #Address 0x4a Write value 0xd99b9aea
    li x3, 0xd99b9aea
    csrw 0x4a, x3

    #Address 0x4a Write value 0xc3c52eac
    li x3, 0xc3c52eac
    csrw 0x4a, x3

    #Unmapped address 0x943 testing: random write/read operations
    #Address 0x943 read value
    csrr x14, 0x943

    #Address 0x943 Write value 0xad38a3d5
    li x3, 0xad38a3d5
    csrw 0x943, x3

    #Unmapped address 0x101 testing: random write/read operations
    #Address 0x101 read value
    csrr x14, 0x101

    #Address 0x101 Write value 0x4ec2d669
    li x3, 0x4ec2d669
    csrw 0x101, x3

    #Address 0x101 Write value 0x32639e6e
    li x3, 0x32639e6e
    csrw 0x101, x3

    #Address 0x101 Write value 0x6ea0999b
    li x3, 0x6ea0999b
    csrw 0x101, x3

    #Unmapped address 0x82 testing: random write/read operations
    #Address 0x82 read value
    csrr x14, 0x82

    #Address 0x82 Write value 0xae161975
    li x3, 0xae161975
    csrw 0x82, x3

    #Unmapped address 0x8ea testing: random write/read operations
    #Address 0x8ea read value
    csrr x14, 0x8ea

    #Address 0x8ea read value
    csrr x14, 0x8ea

    #Unmapped address 0x581 testing: random write/read operations
    #Address 0x581 read value
    csrr x14, 0x581

    #Address 0x581 read value
    csrr x14, 0x581

    #Address 0x581 Write value 0x2284f6d7
    li x3, 0x2284f6d7
    csrw 0x581, x3

    #Address 0x581 read value
    csrr x14, 0x581

    #Address 0x581 Write value 0xc96938b9
    li x3, 0xc96938b9
    csrw 0x581, x3

    #Unmapped address 0xaa8 testing: random write/read operations
    #Address 0xaa8 read value
    csrr x14, 0xaa8

    #Address 0xaa8 Write value 0x878d70bc
    li x3, 0x878d70bc
    csrw 0xaa8, x3

    #Unmapped address 0x82f testing: random write/read operations
    #Address 0x82f read value
    csrr x14, 0x82f

    #Address 0x82f Write value 0x59afef88
    li x3, 0x59afef88
    csrw 0x82f, x3

    #Address 0x82f read value
    csrr x14, 0x82f

    #Address 0x82f read value
    csrr x14, 0x82f

    #Unmapped address 0xffd testing: random write/read operations
    #Address 0xffd Write value 0x7738158e
    li x3, 0x7738158e
    csrw 0xffd, x3

    #Address 0xffd Write value 0xde9e8975
    li x3, 0xde9e8975
    csrw 0xffd, x3

    #Address 0xffd read value
    csrr x14, 0xffd

    #Unmapped address 0xfba testing: random write/read operations
    #Address 0xfba read value
    csrr x14, 0xfba

    #Address 0xfba read value
    csrr x14, 0xfba

    #Address 0xfba read value
    csrr x14, 0xfba

    #Address 0xfba Write value 0xb9031c56
    li x3, 0xb9031c56
    csrw 0xfba, x3

    #Address 0xfba Write value 0x8f501e3e
    li x3, 0x8f501e3e
    csrw 0xfba, x3

    #Unmapped address 0xbd5 testing: random write/read operations
    #Address 0xbd5 read value
    csrr x14, 0xbd5

    #Address 0xbd5 read value
    csrr x14, 0xbd5

    #Address 0xbd5 read value
    csrr x14, 0xbd5

    #Address 0xbd5 read value
    csrr x14, 0xbd5

    #Unmapped address 0x8af testing: random write/read operations
    #Address 0x8af read value
    csrr x14, 0x8af

    #Address 0x8af Write value 0x7602b9ef
    li x3, 0x7602b9ef
    csrw 0x8af, x3

    #Address 0x8af Write value 0x306ae9e8
    li x3, 0x306ae9e8
    csrw 0x8af, x3

    #Address 0x8af Write value 0xe0ec2123
    li x3, 0xe0ec2123
    csrw 0x8af, x3

    #Address 0x8af read value
    csrr x14, 0x8af

    #Unmapped address 0xa97 testing: random write/read operations
    #Address 0xa97 Write value 0x9912889d
    li x3, 0x9912889d
    csrw 0xa97, x3

    #Unmapped address 0x815 testing: random write/read operations
    #Address 0x815 Write value 0x39c5effc
    li x3, 0x39c5effc
    csrw 0x815, x3

    #Address 0x815 Write value 0x9b249519
    li x3, 0x9b249519
    csrw 0x815, x3

    #Unmapped address 0x77 testing: random write/read operations
    #Address 0x77 read value
    csrr x14, 0x77

    #Address 0x77 read value
    csrr x14, 0x77

    #Address 0x77 Write value 0xbff1dee2
    li x3, 0xbff1dee2
    csrw 0x77, x3

    #Address 0x77 read value
    csrr x14, 0x77

    #Address 0x77 read value
    csrr x14, 0x77

    #Unmapped address 0x104 testing: random write/read operations
    #Address 0x104 read value
    csrr x14, 0x104

    #Address 0x104 read value
    csrr x14, 0x104

    #Address 0x104 read value
    csrr x14, 0x104

    #Address 0x104 Write value 0x1e03d9c1
    li x3, 0x1e03d9c1
    csrw 0x104, x3

    #Unmapped address 0x6b9 testing: random write/read operations
    #Address 0x6b9 Write value 0x6f62c63b
    li x3, 0x6f62c63b
    csrw 0x6b9, x3

    #Unmapped address 0x4cc testing: random write/read operations
    #Address 0x4cc read value
    csrr x14, 0x4cc

    #Address 0x4cc read value
    csrr x14, 0x4cc

    #Unmapped address 0x34d testing: random write/read operations
    #Address 0x34d read value
    csrr x14, 0x34d

    #Address 0x34d Write value 0x6718f57b
    li x3, 0x6718f57b
    csrw 0x34d, x3

    #Address 0x34d read value
    csrr x14, 0x34d

    #Address 0x34d Write value 0x4d1e6b1a
    li x3, 0x4d1e6b1a
    csrw 0x34d, x3

    #Unmapped address 0x633 testing: random write/read operations
    #Address 0x633 read value
    csrr x14, 0x633

    #Address 0x633 Write value 0x3ce4d790
    li x3, 0x3ce4d790
    csrw 0x633, x3

    #Address 0x633 read value
    csrr x14, 0x633

    #Address 0x633 Write value 0x8b6f50b5
    li x3, 0x8b6f50b5
    csrw 0x633, x3

    #Unmapped address 0xb32 testing: random write/read operations
    #Address 0xb32 Write value 0xb2639868
    li x3, 0xb2639868
    csrw 0xb32, x3

    #Address 0xb32 Write value 0xc9b87b7e
    li x3, 0xc9b87b7e
    csrw 0xb32, x3

    #Address 0xb32 read value
    csrr x14, 0xb32

    #Address 0xb32 Write value 0x6e82c680
    li x3, 0x6e82c680
    csrw 0xb32, x3

    #Address 0xb32 read value
    csrr x14, 0xb32

    #Unmapped address 0x8dd testing: random write/read operations
    #Address 0x8dd read value
    csrr x14, 0x8dd

    #Address 0x8dd read value
    csrr x14, 0x8dd

    #Address 0x8dd Write value 0x7ff059e
    li x3, 0x7ff059e
    csrw 0x8dd, x3

    #Unmapped address 0x280 testing: random write/read operations
    #Address 0x280 Write value 0x479f3cd
    li x3, 0x479f3cd
    csrw 0x280, x3

    #Unmapped address 0x857 testing: random write/read operations
    #Address 0x857 read value
    csrr x14, 0x857

    #Address 0x857 Write value 0x4d56086a
    li x3, 0x4d56086a
    csrw 0x857, x3

    #Address 0x857 Write value 0xaf82699b
    li x3, 0xaf82699b
    csrw 0x857, x3

    #Address 0x857 Write value 0x9b44c28
    li x3, 0x9b44c28
    csrw 0x857, x3

    #Address 0x857 Write value 0xabcbd28e
    li x3, 0xabcbd28e
    csrw 0x857, x3

    #Unmapped address 0x357 testing: random write/read operations
    #Address 0x357 Write value 0x6eea78b5
    li x3, 0x6eea78b5
    csrw 0x357, x3

    #Address 0x357 Write value 0x81880284
    li x3, 0x81880284
    csrw 0x357, x3

    #Address 0x357 Write value 0x45ddd416
    li x3, 0x45ddd416
    csrw 0x357, x3

    #Address 0x357 read value
    csrr x14, 0x357

    #Address 0x357 read value
    csrr x14, 0x357

    #Unmapped address 0x356 testing: random write/read operations
    #Address 0x356 Write value 0xc562368e
    li x3, 0xc562368e
    csrw 0x356, x3

    #Address 0x356 read value
    csrr x14, 0x356

    #Address 0x356 read value
    csrr x14, 0x356

    #Address 0x356 read value
    csrr x14, 0x356

    #Address 0x356 read value
    csrr x14, 0x356

    #Unmapped address 0x145 testing: random write/read operations
    #Address 0x145 read value
    csrr x14, 0x145

    #Address 0x145 read value
    csrr x14, 0x145

    #Unmapped address 0x923 testing: random write/read operations
    #Address 0x923 Write value 0x68f19fc9
    li x3, 0x68f19fc9
    csrw 0x923, x3

    #Unmapped address 0xd8e testing: random write/read operations
    #Address 0xd8e read value
    csrr x14, 0xd8e

    #Address 0xd8e Write value 0xf6c4d4a4
    li x3, 0xf6c4d4a4
    csrw 0xd8e, x3

    #Address 0xd8e Write value 0xaf592847
    li x3, 0xaf592847
    csrw 0xd8e, x3

    #Mapped address 0xb1d (mhpmcounter29) testing: random write/read operations
    #Address 0xb1d read value
    csrr x14, 0xb1d

    #Unmapped address 0x5ab testing: random write/read operations
    #Address 0x5ab Write value 0x93875d7
    li x3, 0x93875d7
    csrw 0x5ab, x3

    #Address 0x5ab read value
    csrr x14, 0x5ab

    #Address 0x5ab read value
    csrr x14, 0x5ab

    #Unmapped address 0x5cf testing: random write/read operations
    #Address 0x5cf Write value 0x3c564f06
    li x3, 0x3c564f06
    csrw 0x5cf, x3

    #Address 0x5cf Write value 0x33ad0a8b
    li x3, 0x33ad0a8b
    csrw 0x5cf, x3

    #Unmapped address 0xc49 testing: random write/read operations
    #Address 0xc49 Write value 0x8ef80a44
    li x3, 0x8ef80a44
    csrw 0xc49, x3

    #Unmapped address 0x90 testing: random write/read operations
    #Address 0x90 read value
    csrr x14, 0x90

    #Address 0x90 Write value 0x70e5821
    li x3, 0x70e5821
    csrw 0x90, x3

    #Address 0x90 Write value 0x584a51d6
    li x3, 0x584a51d6
    csrw 0x90, x3

    #Address 0x90 read value
    csrr x14, 0x90

    #Address 0x90 read value
    csrr x14, 0x90

    #Unmapped address 0xe3c testing: random write/read operations
    #Address 0xe3c Write value 0x6c35f9a1
    li x3, 0x6c35f9a1
    csrw 0xe3c, x3

    #Address 0xe3c Write value 0xe3e53f05
    li x3, 0xe3e53f05
    csrw 0xe3c, x3

    #Address 0xe3c Write value 0x1826e8a4
    li x3, 0x1826e8a4
    csrw 0xe3c, x3

    #Unmapped address 0xda1 testing: random write/read operations
    #Address 0xda1 read value
    csrr x14, 0xda1

    #Address 0xda1 Write value 0xdb4225a9
    li x3, 0xdb4225a9
    csrw 0xda1, x3

    #Address 0xda1 Write value 0xd0ce21de
    li x3, 0xd0ce21de
    csrw 0xda1, x3

    #Address 0xda1 Write value 0xfe113439
    li x3, 0xfe113439
    csrw 0xda1, x3

    #Address 0xda1 Write value 0xe4a1d314
    li x3, 0xe4a1d314
    csrw 0xda1, x3

    #Unmapped address 0xf89 testing: random write/read operations
    #Address 0xf89 Write value 0x842843d7
    li x3, 0x842843d7
    csrw 0xf89, x3

    #Address 0xf89 read value
    csrr x14, 0xf89

    #Unmapped address 0x155 testing: random write/read operations
    #Address 0x155 read value
    csrr x14, 0x155

    #Address 0x155 read value
    csrr x14, 0x155

    #Address 0x155 read value
    csrr x14, 0x155

    #Unmapped address 0xf8b testing: random write/read operations
    #Address 0xf8b Write value 0x29465ca9
    li x3, 0x29465ca9
    csrw 0xf8b, x3

    #Address 0xf8b Write value 0x87df6e29
    li x3, 0x87df6e29
    csrw 0xf8b, x3

    #Unmapped address 0x7b2 testing: random write/read operations
    #Address 0x7b2 Write value 0x4bf92b3c
    li x3, 0x4bf92b3c
    csrw 0x7b2, x3

    #Address 0x7b2 Write value 0x7c042ee9
    li x3, 0x7c042ee9
    csrw 0x7b2, x3

    #Address 0x7b2 Write value 0x4842d290
    li x3, 0x4842d290
    csrw 0x7b2, x3

    #Unmapped address 0xc84 testing: random write/read operations
    #Address 0xc84 read value
    csrr x14, 0xc84

    #Address 0xc84 read value
    csrr x14, 0xc84

    #Address 0xc84 Write value 0xacdaa4d7
    li x3, 0xacdaa4d7
    csrw 0xc84, x3

    #Address 0xc84 read value
    csrr x14, 0xc84

    #Address 0xc84 read value
    csrr x14, 0xc84

    #Unmapped address 0x525 testing: random write/read operations
    #Address 0x525 read value
    csrr x14, 0x525

    #Address 0x525 read value
    csrr x14, 0x525

    #Address 0x525 read value
    csrr x14, 0x525

    #Address 0x525 read value
    csrr x14, 0x525

    #Address 0x525 read value
    csrr x14, 0x525

    #Unmapped address 0xe68 testing: random write/read operations
    #Address 0xe68 read value
    csrr x14, 0xe68

    #Address 0xe68 read value
    csrr x14, 0xe68

    #Address 0xe68 read value
    csrr x14, 0xe68

    #Address 0xe68 Write value 0xd8485a8f
    li x3, 0xd8485a8f
    csrw 0xe68, x3

    #Address 0xe68 read value
    csrr x14, 0xe68

    #Unmapped address 0xf64 testing: random write/read operations
    #Address 0xf64 Write value 0xd669c40d
    li x3, 0xd669c40d
    csrw 0xf64, x3

    #Address 0xf64 read value
    csrr x14, 0xf64

    #Unmapped address 0xad9 testing: random write/read operations
    #Address 0xad9 Write value 0x8f036c04
    li x3, 0x8f036c04
    csrw 0xad9, x3

    #Unmapped address 0xee6 testing: random write/read operations
    #Address 0xee6 Write value 0x9c34ed5a
    li x3, 0x9c34ed5a
    csrw 0xee6, x3

    #Address 0xee6 Write value 0x945851ba
    li x3, 0x945851ba
    csrw 0xee6, x3

    #Address 0xee6 read value
    csrr x14, 0xee6

    #Unmapped address 0xeb0 testing: random write/read operations
    #Address 0xeb0 Write value 0x13a99e16
    li x3, 0x13a99e16
    csrw 0xeb0, x3

    #Address 0xeb0 read value
    csrr x14, 0xeb0

    #Address 0xeb0 Write value 0xe40d23aa
    li x3, 0xe40d23aa
    csrw 0xeb0, x3

    #Address 0xeb0 Write value 0xd2488329
    li x3, 0xd2488329
    csrw 0xeb0, x3

    #Unmapped address 0x48e testing: random write/read operations
    #Address 0x48e Write value 0x3e668ef
    li x3, 0x3e668ef
    csrw 0x48e, x3

    #Address 0x48e Write value 0x4e55db03
    li x3, 0x4e55db03
    csrw 0x48e, x3

    #Unmapped address 0xf59 testing: random write/read operations
    #Address 0xf59 read value
    csrr x14, 0xf59

    #Address 0xf59 Write value 0xe41558e5
    li x3, 0xe41558e5
    csrw 0xf59, x3

    #Address 0xf59 read value
    csrr x14, 0xf59

    #Unmapped address 0xcca testing: random write/read operations
    #Address 0xcca read value
    csrr x14, 0xcca

    #Unmapped address 0xdfe testing: random write/read operations
    #Address 0xdfe read value
    csrr x14, 0xdfe

    #Address 0xdfe read value
    csrr x14, 0xdfe

    #Address 0xdfe read value
    csrr x14, 0xdfe

    #Unmapped address 0xb59 testing: random write/read operations
    #Address 0xb59 Write value 0x723cefbc
    li x3, 0x723cefbc
    csrw 0xb59, x3

    #Unmapped address 0x91 testing: random write/read operations
    #Address 0x91 Write value 0xd7a5d605
    li x3, 0xd7a5d605
    csrw 0x91, x3

    #Unmapped address 0x5d0 testing: random write/read operations
    #Address 0x5d0 Write value 0x9a8abe3b
    li x3, 0x9a8abe3b
    csrw 0x5d0, x3

    #Address 0x5d0 read value
    csrr x14, 0x5d0

    #Unmapped address 0x1fe testing: random write/read operations
    #Address 0x1fe read value
    csrr x14, 0x1fe

    #Address 0x1fe Write value 0xb08f03bb
    li x3, 0xb08f03bb
    csrw 0x1fe, x3

    #Address 0x1fe Write value 0x27d99076
    li x3, 0x27d99076
    csrw 0x1fe, x3

    #Address 0x1fe Write value 0x448051e7
    li x3, 0x448051e7
    csrw 0x1fe, x3

    #Unmapped address 0x2aa testing: random write/read operations
    #Address 0x2aa read value
    csrr x14, 0x2aa

    #Unmapped address 0x8e9 testing: random write/read operations
    #Address 0x8e9 read value
    csrr x14, 0x8e9

    #Address 0x8e9 Write value 0xa2a3996
    li x3, 0xa2a3996
    csrw 0x8e9, x3

    #Address 0x8e9 read value
    csrr x14, 0x8e9

    #Address 0x8e9 read value
    csrr x14, 0x8e9

    #Unmapped address 0xd71 testing: random write/read operations
    #Address 0xd71 read value
    csrr x14, 0xd71

    #Address 0xd71 read value
    csrr x14, 0xd71

    #Address 0xd71 Write value 0x2294dc0d
    li x3, 0x2294dc0d
    csrw 0xd71, x3

    #Unmapped address 0xbb8 testing: random write/read operations
    #Address 0xbb8 Write value 0xeba03a6d
    li x3, 0xeba03a6d
    csrw 0xbb8, x3

    #Address 0xbb8 Write value 0xd265c3bf
    li x3, 0xd265c3bf
    csrw 0xbb8, x3

    #Unmapped address 0xd2c testing: random write/read operations
    #Address 0xd2c Write value 0x86ac56d8
    li x3, 0x86ac56d8
    csrw 0xd2c, x3

    #Address 0xd2c read value
    csrr x14, 0xd2c

    #Address 0xd2c Write value 0x69bac3c8
    li x3, 0x69bac3c8
    csrw 0xd2c, x3

    #Address 0xd2c read value
    csrr x14, 0xd2c

    #Address 0xd2c read value
    csrr x14, 0xd2c

    #Unmapped address 0xcf8 testing: random write/read operations
    #Address 0xcf8 read value
    csrr x14, 0xcf8

    #Address 0xcf8 Write value 0x6c5c416
    li x3, 0x6c5c416
    csrw 0xcf8, x3

    #Address 0xcf8 Write value 0x30f6737
    li x3, 0x30f6737
    csrw 0xcf8, x3

    #Address 0xcf8 Write value 0xebab6400
    li x3, 0xebab6400
    csrw 0xcf8, x3

    #Address 0xcf8 Write value 0xc3b27c3f
    li x3, 0xc3b27c3f
    csrw 0xcf8, x3

    #Unmapped address 0x296 testing: random write/read operations
    #Address 0x296 read value
    csrr x14, 0x296

    #Address 0x296 Write value 0xf726fcd6
    li x3, 0xf726fcd6
    csrw 0x296, x3

    #Address 0x296 read value
    csrr x14, 0x296

    #Unmapped address 0x479 testing: random write/read operations
    #Address 0x479 Write value 0x245c2f2d
    li x3, 0x245c2f2d
    csrw 0x479, x3

    #Address 0x479 read value
    csrr x14, 0x479

    #Address 0x479 Write value 0xea8363a8
    li x3, 0xea8363a8
    csrw 0x479, x3

    #Unmapped address 0x8d2 testing: random write/read operations
    #Address 0x8d2 read value
    csrr x14, 0x8d2

    #Address 0x8d2 read value
    csrr x14, 0x8d2

    #Unmapped address 0xccb testing: random write/read operations
    #Address 0xccb read value
    csrr x14, 0xccb

    #Unmapped address 0x1c5 testing: random write/read operations
    #Address 0x1c5 read value
    csrr x14, 0x1c5

    #Address 0x1c5 Write value 0x49fb4d15
    li x3, 0x49fb4d15
    csrw 0x1c5, x3

    #Address 0x1c5 read value
    csrr x14, 0x1c5

    #Unmapped address 0x73f testing: random write/read operations
    #Address 0x73f read value
    csrr x14, 0x73f

    #Address 0x73f Write value 0x1c90f1c9
    li x3, 0x1c90f1c9
    csrw 0x73f, x3

    #Address 0x73f Write value 0x3ccb38f2
    li x3, 0x3ccb38f2
    csrw 0x73f, x3

    #Address 0x73f read value
    csrr x14, 0x73f

    #Unmapped address 0x18 testing: random write/read operations
    #Address 0x18 read value
    csrr x14, 0x18

    #Address 0x18 read value
    csrr x14, 0x18

    #Address 0x18 read value
    csrr x14, 0x18

    #Address 0x18 Write value 0x8a7a9771
    li x3, 0x8a7a9771
    csrw 0x18, x3

    #Address 0x18 read value
    csrr x14, 0x18

    #Unmapped address 0xb6d testing: random write/read operations
    #Address 0xb6d Write value 0x7c2a5e24
    li x3, 0x7c2a5e24
    csrw 0xb6d, x3

    #Address 0xb6d read value
    csrr x14, 0xb6d

    #Unmapped address 0xf98 testing: random write/read operations
    #Address 0xf98 read value
    csrr x14, 0xf98

    #Address 0xf98 read value
    csrr x14, 0xf98

    #Address 0xf98 Write value 0x617b6935
    li x3, 0x617b6935
    csrw 0xf98, x3

    #Address 0xf98 read value
    csrr x14, 0xf98

    #Address 0xf98 Write value 0x2020a089
    li x3, 0x2020a089
    csrw 0xf98, x3

    #Unmapped address 0xf42 testing: random write/read operations
    #Address 0xf42 Write value 0xae2d1552
    li x3, 0xae2d1552
    csrw 0xf42, x3

    #Address 0xf42 Write value 0xa3ab63f1
    li x3, 0xa3ab63f1
    csrw 0xf42, x3

    #Address 0xf42 read value
    csrr x14, 0xf42

    #Unmapped address 0x8e5 testing: random write/read operations
    #Address 0x8e5 Write value 0x586b7f8d
    li x3, 0x586b7f8d
    csrw 0x8e5, x3

    #Address 0x8e5 read value
    csrr x14, 0x8e5

    #Address 0x8e5 Write value 0xc2a0031d
    li x3, 0xc2a0031d
    csrw 0x8e5, x3

    #Address 0x8e5 read value
    csrr x14, 0x8e5

    #Address 0x8e5 Write value 0x91202ac
    li x3, 0x91202ac
    csrw 0x8e5, x3

    #Unmapped address 0xb78 testing: random write/read operations
    #Address 0xb78 read value
    csrr x14, 0xb78

    #Unmapped address 0xc34 testing: random write/read operations
    #Address 0xc34 read value
    csrr x14, 0xc34

    #Address 0xc34 read value
    csrr x14, 0xc34

    #Address 0xc34 read value
    csrr x14, 0xc34

    #Address 0xc34 Write value 0xfced8ff0
    li x3, 0xfced8ff0
    csrw 0xc34, x3

    #Address 0xc34 read value
    csrr x14, 0xc34

    #Unmapped address 0xa4c testing: random write/read operations
    #Address 0xa4c read value
    csrr x14, 0xa4c

    #Address 0xa4c Write value 0x3895db0
    li x3, 0x3895db0
    csrw 0xa4c, x3

    #Unmapped address 0x2b4 testing: random write/read operations
    #Address 0x2b4 Write value 0x917030a4
    li x3, 0x917030a4
    csrw 0x2b4, x3

    #Unmapped address 0x951 testing: random write/read operations
    #Address 0x951 Write value 0x73948901
    li x3, 0x73948901
    csrw 0x951, x3

    #Address 0x951 read value
    csrr x14, 0x951

    #Address 0x951 Write value 0xcfb914b8
    li x3, 0xcfb914b8
    csrw 0x951, x3

    #Unmapped address 0xeef testing: random write/read operations
    #Address 0xeef Write value 0xb9309d0e
    li x3, 0xb9309d0e
    csrw 0xeef, x3

    #Address 0xeef Write value 0x50ea8d27
    li x3, 0x50ea8d27
    csrw 0xeef, x3

    #Address 0xeef Write value 0xdc992480
    li x3, 0xdc992480
    csrw 0xeef, x3

    #Address 0xeef read value
    csrr x14, 0xeef

    #Unmapped address 0x17d testing: random write/read operations
    #Address 0x17d Write value 0xa4cc7222
    li x3, 0xa4cc7222
    csrw 0x17d, x3

    #Address 0x17d Write value 0x12ba63d5
    li x3, 0x12ba63d5
    csrw 0x17d, x3

    #Address 0x17d Write value 0xe9178a63
    li x3, 0xe9178a63
    csrw 0x17d, x3

    #Address 0x17d Write value 0xb2edeec
    li x3, 0xb2edeec
    csrw 0x17d, x3

    #Unmapped address 0x967 testing: random write/read operations
    #Address 0x967 Write value 0xbb7dcfb2
    li x3, 0xbb7dcfb2
    csrw 0x967, x3

    #Address 0x967 Write value 0x90238927
    li x3, 0x90238927
    csrw 0x967, x3

    #Address 0x967 Write value 0x8e8adc32
    li x3, 0x8e8adc32
    csrw 0x967, x3

    #Address 0x967 read value
    csrr x14, 0x967

    #Unmapped address 0x474 testing: random write/read operations
    #Address 0x474 Write value 0xd4bc0a4a
    li x3, 0xd4bc0a4a
    csrw 0x474, x3

    #Address 0x474 read value
    csrr x14, 0x474

    #Unmapped address 0x448 testing: random write/read operations
    #Address 0x448 read value
    csrr x14, 0x448

    #Address 0x448 read value
    csrr x14, 0x448

    #Address 0x448 read value
    csrr x14, 0x448

    #Address 0x448 read value
    csrr x14, 0x448

    #Mapped address 0xc80 (cycleh) testing: random write/read operations
    #Address 0xc80 Write value 0x96433c99
    li x3, 0x96433c99
    csrw 0xc80, x3

    #Address 0xc80 read value
    csrr x14, 0xc80

    #Address 0xc80 Write value 0x1f68727f
    li x3, 0x1f68727f
    csrw 0xc80, x3

    #Unmapped address 0x5d3 testing: random write/read operations
    #Address 0x5d3 read value
    csrr x14, 0x5d3

    #Address 0x5d3 Write value 0xcbc2e6bb
    li x3, 0xcbc2e6bb
    csrw 0x5d3, x3

    #Unmapped address 0x15e testing: random write/read operations
    #Address 0x15e read value
    csrr x14, 0x15e

    #Address 0x15e read value
    csrr x14, 0x15e

    #Address 0x15e Write value 0x600bdd3f
    li x3, 0x600bdd3f
    csrw 0x15e, x3

    #Address 0x15e Write value 0xbb852b3a
    li x3, 0xbb852b3a
    csrw 0x15e, x3

    #Unmapped address 0x529 testing: random write/read operations
    #Address 0x529 read value
    csrr x14, 0x529

    #Address 0x529 Write value 0xfab31a66
    li x3, 0xfab31a66
    csrw 0x529, x3

    #Unmapped address 0x7ca testing: random write/read operations
    #Address 0x7ca Write value 0xbb2f02ff
    li x3, 0xbb2f02ff
    csrw 0x7ca, x3

    #Address 0x7ca read value
    csrr x14, 0x7ca

    #Address 0x7ca Write value 0x57bd2ff1
    li x3, 0x57bd2ff1
    csrw 0x7ca, x3

    #Address 0x7ca Write value 0x60fa5f2c
    li x3, 0x60fa5f2c
    csrw 0x7ca, x3

    #Address 0x7ca Write value 0x429fd519
    li x3, 0x429fd519
    csrw 0x7ca, x3

    #Unmapped address 0xec0 testing: random write/read operations
    #Address 0xec0 Write value 0xbd0934ee
    li x3, 0xbd0934ee
    csrw 0xec0, x3

    #Address 0xec0 Write value 0x47d161a1
    li x3, 0x47d161a1
    csrw 0xec0, x3

    #Address 0xec0 read value
    csrr x14, 0xec0

    #Unmapped address 0x436 testing: random write/read operations
    #Address 0x436 read value
    csrr x14, 0x436

    #Address 0x436 read value
    csrr x14, 0x436

    #Unmapped address 0x3d5 testing: random write/read operations
    #Address 0x3d5 read value
    csrr x14, 0x3d5

    #Address 0x3d5 read value
    csrr x14, 0x3d5

    #Address 0x3d5 read value
    csrr x14, 0x3d5

    #Address 0x3d5 read value
    csrr x14, 0x3d5

    #Mapped address 0xb97 (mhpmcounterh23) testing: random write/read operations
    #Address 0xb97 read value
    csrr x14, 0xb97

    #Unmapped address 0x19d testing: random write/read operations
    #Address 0x19d Write value 0xf815879d
    li x3, 0xf815879d
    csrw 0x19d, x3

    #Address 0x19d Write value 0x1bfa1180
    li x3, 0x1bfa1180
    csrw 0x19d, x3

    #Address 0x19d Write value 0x68b0f845
    li x3, 0x68b0f845
    csrw 0x19d, x3

    #Unmapped address 0x9a9 testing: random write/read operations
    #Address 0x9a9 read value
    csrr x14, 0x9a9

    #Unmapped address 0x10b testing: random write/read operations
    #Address 0x10b Write value 0x9f49aa36
    li x3, 0x9f49aa36
    csrw 0x10b, x3

    #Unmapped address 0xd29 testing: random write/read operations
    #Address 0xd29 Write value 0x91a3864e
    li x3, 0x91a3864e
    csrw 0xd29, x3

    #Address 0xd29 read value
    csrr x14, 0xd29

    #Address 0xd29 read value
    csrr x14, 0xd29

    #Address 0xd29 read value
    csrr x14, 0xd29

    #Address 0xd29 read value
    csrr x14, 0xd29

    #Unmapped address 0xde9 testing: random write/read operations
    #Address 0xde9 Write value 0xa4307480
    li x3, 0xa4307480
    csrw 0xde9, x3

    #Address 0xde9 read value
    csrr x14, 0xde9

    #Address 0xde9 read value
    csrr x14, 0xde9

    #Address 0xde9 read value
    csrr x14, 0xde9

    #Unmapped address 0x944 testing: random write/read operations
    #Address 0x944 read value
    csrr x14, 0x944

    #Address 0x944 read value
    csrr x14, 0x944

    #Unmapped address 0x141 testing: random write/read operations
    #Address 0x141 read value
    csrr x14, 0x141

    #Address 0x141 Write value 0x169edc49
    li x3, 0x169edc49
    csrw 0x141, x3

    #Mapped address 0x300 (mstatus) testing: random write/read operations
    #Address 0x300 Write value 0x4d02a6b6
    li x3, 0x4d02a6b6
    csrw 0x300, x3

    #Address 0x300 Write value 0xc3ed6ee2
    li x3, 0xc3ed6ee2
    csrw 0x300, x3

    #Address 0x300 read value
    csrr x14, 0x300

    #Address 0x300 read value
    csrr x14, 0x300

    #Address 0x300 Write value 0xede28dd5
    li x3, 0xede28dd5
    csrw 0x300, x3

    #Unmapped address 0xfe3 testing: random write/read operations
    #Address 0xfe3 Write value 0x8af46957
    li x3, 0x8af46957
    csrw 0xfe3, x3

    #Address 0xfe3 Write value 0xf4450790
    li x3, 0xf4450790
    csrw 0xfe3, x3

    #Address 0xfe3 read value
    csrr x14, 0xfe3

    #Address 0xfe3 read value
    csrr x14, 0xfe3

    #Unmapped address 0xccc testing: random write/read operations
    #Address 0xccc Write value 0x55683b92
    li x3, 0x55683b92
    csrw 0xccc, x3

    #Address 0xccc read value
    csrr x14, 0xccc

    #Address 0xccc Write value 0xd1d18e2a
    li x3, 0xd1d18e2a
    csrw 0xccc, x3

    #Unmapped address 0x4a8 testing: random write/read operations
    #Address 0x4a8 Write value 0x164d271b
    li x3, 0x164d271b
    csrw 0x4a8, x3

    #Unmapped address 0xb74 testing: random write/read operations
    #Address 0xb74 read value
    csrr x14, 0xb74

    #Address 0xb74 read value
    csrr x14, 0xb74

    #Address 0xb74 read value
    csrr x14, 0xb74

    #Address 0xb74 read value
    csrr x14, 0xb74

    #Address 0xb74 Write value 0x22ef2cad
    li x3, 0x22ef2cad
    csrw 0xb74, x3

    #Unmapped address 0xaae testing: random write/read operations
    #Address 0xaae Write value 0x93a95ee9
    li x3, 0x93a95ee9
    csrw 0xaae, x3

    #Address 0xaae Write value 0x7919bea8
    li x3, 0x7919bea8
    csrw 0xaae, x3

    #Address 0xaae Write value 0x40bc7fc
    li x3, 0x40bc7fc
    csrw 0xaae, x3

    #Address 0xaae Write value 0xbca1f4d6
    li x3, 0xbca1f4d6
    csrw 0xaae, x3

    #Address 0xaae read value
    csrr x14, 0xaae

    #Unmapped address 0xf90 testing: random write/read operations
    #Address 0xf90 Write value 0x74356006
    li x3, 0x74356006
    csrw 0xf90, x3

    #Unmapped address 0xb6f testing: random write/read operations
    #Address 0xb6f Write value 0xc6e73555
    li x3, 0xc6e73555
    csrw 0xb6f, x3

    #Address 0xb6f read value
    csrr x14, 0xb6f

    #Address 0xb6f Write value 0xd45b0305
    li x3, 0xd45b0305
    csrw 0xb6f, x3

    #Unmapped address 0xc3e testing: random write/read operations
    #Address 0xc3e read value
    csrr x14, 0xc3e

    #Address 0xc3e read value
    csrr x14, 0xc3e

    #Address 0xc3e Write value 0xfc03091b
    li x3, 0xfc03091b
    csrw 0xc3e, x3

    #Address 0xc3e read value
    csrr x14, 0xc3e

    #Address 0xc3e Write value 0xad26f77c
    li x3, 0xad26f77c
    csrw 0xc3e, x3

    #Unmapped address 0x42a testing: random write/read operations
    #Address 0x42a Write value 0x5b37252f
    li x3, 0x5b37252f
    csrw 0x42a, x3

    #Address 0x42a read value
    csrr x14, 0x42a

    #Address 0x42a read value
    csrr x14, 0x42a

    #Address 0x42a Write value 0xa300f342
    li x3, 0xa300f342
    csrw 0x42a, x3

    #Unmapped address 0x934 testing: random write/read operations
    #Address 0x934 Write value 0xa07e2702
    li x3, 0xa07e2702
    csrw 0x934, x3

    #Address 0x934 read value
    csrr x14, 0x934

    #Address 0x934 read value
    csrr x14, 0x934

    #Address 0x934 Write value 0xe86e3222
    li x3, 0xe86e3222
    csrw 0x934, x3

    #Unmapped address 0xea4 testing: random write/read operations
    #Address 0xea4 Write value 0xf76077be
    li x3, 0xf76077be
    csrw 0xea4, x3

    #Address 0xea4 read value
    csrr x14, 0xea4

    #Address 0xea4 read value
    csrr x14, 0xea4

    #Unmapped address 0xbe testing: random write/read operations
    #Address 0xbe read value
    csrr x14, 0xbe

    #Address 0xbe read value
    csrr x14, 0xbe

    #Address 0xbe read value
    csrr x14, 0xbe

    #Unmapped address 0xe67 testing: random write/read operations
    #Address 0xe67 read value
    csrr x14, 0xe67

    #Address 0xe67 read value
    csrr x14, 0xe67

    #Unmapped address 0x62d testing: random write/read operations
    #Address 0x62d read value
    csrr x14, 0x62d

    #Address 0x62d Write value 0xa7d132ee
    li x3, 0xa7d132ee
    csrw 0x62d, x3

    #Address 0x62d read value
    csrr x14, 0x62d

    #Address 0x62d read value
    csrr x14, 0x62d

    #Address 0x62d Write value 0xbc97b23b
    li x3, 0xbc97b23b
    csrw 0x62d, x3

    #Unmapped address 0x507 testing: random write/read operations
    #Address 0x507 read value
    csrr x14, 0x507

    #Address 0x507 Write value 0x85e6287d
    li x3, 0x85e6287d
    csrw 0x507, x3

    #Unmapped address 0x805 testing: random write/read operations
    #Address 0x805 Write value 0xe0ed10ce
    li x3, 0xe0ed10ce
    csrw 0x805, x3

    #Mapped address 0xb1b (mhpmcounter27) testing: random write/read operations
    #Address 0xb1b Write value 0x5fe30c76
    li x3, 0x5fe30c76
    csrw 0xb1b, x3

    #Unmapped address 0xeb5 testing: random write/read operations
    #Address 0xeb5 read value
    csrr x14, 0xeb5

    #Address 0xeb5 Write value 0x180508d5
    li x3, 0x180508d5
    csrw 0xeb5, x3

    #Address 0xeb5 read value
    csrr x14, 0xeb5

    #Unmapped address 0xafd testing: random write/read operations
    #Address 0xafd Write value 0xb21450cc
    li x3, 0xb21450cc
    csrw 0xafd, x3

    #Address 0xafd Write value 0x97e2fd1f
    li x3, 0x97e2fd1f
    csrw 0xafd, x3

    #Address 0xafd read value
    csrr x14, 0xafd

    #Address 0xafd Write value 0x296a727a
    li x3, 0x296a727a
    csrw 0xafd, x3

    #Mapped address 0x332 (mhpmevent18) testing: random write/read operations
    #Address 0x332 Write value 0x52d9f1c3
    li x3, 0x52d9f1c3
    csrw 0x332, x3

    #Address 0x332 Write value 0x75c1b55e
    li x3, 0x75c1b55e
    csrw 0x332, x3

    #Address 0x332 Write value 0xe5f8db40
    li x3, 0xe5f8db40
    csrw 0x332, x3

    #Address 0x332 Write value 0x7b48a9a5
    li x3, 0x7b48a9a5
    csrw 0x332, x3

    #Address 0x332 read value
    csrr x14, 0x332

    #Unmapped address 0x157 testing: random write/read operations
    #Address 0x157 Write value 0xf21210b9
    li x3, 0xf21210b9
    csrw 0x157, x3

    #Address 0x157 Write value 0xe54f8d1a
    li x3, 0xe54f8d1a
    csrw 0x157, x3

    #Address 0x157 Write value 0xb4ab587a
    li x3, 0xb4ab587a
    csrw 0x157, x3

    #Address 0x157 read value
    csrr x14, 0x157

    #Address 0x157 Write value 0x2780f541
    li x3, 0x2780f541
    csrw 0x157, x3

    #Unmapped address 0xc29 testing: random write/read operations
    #Address 0xc29 read value
    csrr x14, 0xc29

    #Unmapped address 0x478 testing: random write/read operations
    #Address 0x478 read value
    csrr x14, 0x478

    #Address 0x478 Write value 0xab75e7c7
    li x3, 0xab75e7c7
    csrw 0x478, x3

    #Address 0x478 Write value 0xf0fd9728
    li x3, 0xf0fd9728
    csrw 0x478, x3

    #Address 0x478 Write value 0x1457fa1e
    li x3, 0x1457fa1e
    csrw 0x478, x3

    #Unmapped address 0x561 testing: random write/read operations
    #Address 0x561 Write value 0xb0360992
    li x3, 0xb0360992
    csrw 0x561, x3

    #Address 0x561 read value
    csrr x14, 0x561

    #Unmapped address 0xc8c testing: random write/read operations
    #Address 0xc8c read value
    csrr x14, 0xc8c

    #Unmapped address 0x646 testing: random write/read operations
    #Address 0x646 read value
    csrr x14, 0x646

    #Address 0x646 read value
    csrr x14, 0x646

    #Address 0x646 Write value 0xd7af08b4
    li x3, 0xd7af08b4
    csrw 0x646, x3

    #Address 0x646 read value
    csrr x14, 0x646

    #Address 0x646 Write value 0xef0194d6
    li x3, 0xef0194d6
    csrw 0x646, x3

    #Unmapped address 0xb2 testing: random write/read operations
    #Address 0xb2 Write value 0x62ba9b
    li x3, 0x62ba9b
    csrw 0xb2, x3

    #Unmapped address 0xaf2 testing: random write/read operations
    #Address 0xaf2 read value
    csrr x14, 0xaf2

    #Address 0xaf2 read value
    csrr x14, 0xaf2

    #Address 0xaf2 Write value 0x9972dc80
    li x3, 0x9972dc80
    csrw 0xaf2, x3

    #Address 0xaf2 Write value 0xb5922de2
    li x3, 0xb5922de2
    csrw 0xaf2, x3

    #Unmapped address 0x1a6 testing: random write/read operations
    #Address 0x1a6 read value
    csrr x14, 0x1a6

    #Address 0x1a6 read value
    csrr x14, 0x1a6

    #Unmapped address 0x7dc testing: random write/read operations
    #Address 0x7dc Write value 0x181d16d5
    li x3, 0x181d16d5
    csrw 0x7dc, x3

    #Unmapped address 0x5a7 testing: random write/read operations
    #Address 0x5a7 Write value 0xa7fd4c2b
    li x3, 0xa7fd4c2b
    csrw 0x5a7, x3

    #Unmapped address 0x533 testing: random write/read operations
    #Address 0x533 Write value 0x5de5b2a6
    li x3, 0x5de5b2a6
    csrw 0x533, x3

    #Address 0x533 Write value 0x501057db
    li x3, 0x501057db
    csrw 0x533, x3

    #Address 0x533 read value
    csrr x14, 0x533

    #Address 0x533 Write value 0x37ada60d
    li x3, 0x37ada60d
    csrw 0x533, x3

    #Address 0x533 read value
    csrr x14, 0x533

    #Unmapped address 0x30e testing: random write/read operations
    #Address 0x30e Write value 0x9e0b1e33
    li x3, 0x9e0b1e33
    csrw 0x30e, x3

    #Unmapped address 0x361 testing: random write/read operations
    #Address 0x361 read value
    csrr x14, 0x361

    #Address 0x361 read value
    csrr x14, 0x361

    #Address 0x361 read value
    csrr x14, 0x361

    #Unmapped address 0x6e2 testing: random write/read operations
    #Address 0x6e2 read value
    csrr x14, 0x6e2

    #Address 0x6e2 Write value 0x408adbbc
    li x3, 0x408adbbc
    csrw 0x6e2, x3

    #Address 0x6e2 Write value 0xcb3352e4
    li x3, 0xcb3352e4
    csrw 0x6e2, x3

    #Unmapped address 0x8fa testing: random write/read operations
    #Address 0x8fa Write value 0x354ef68
    li x3, 0x354ef68
    csrw 0x8fa, x3

    #Unmapped address 0x164 testing: random write/read operations
    #Address 0x164 read value
    csrr x14, 0x164

    #Unmapped address 0x7a0 testing: random write/read operations
    #Address 0x7a0 Write value 0xf9f45906
    li x3, 0xf9f45906
    csrw 0x7a0, x3

    #Address 0x7a0 Write value 0x599e5f65
    li x3, 0x599e5f65
    csrw 0x7a0, x3

    #Unmapped address 0x2ca testing: random write/read operations
    #Address 0x2ca Write value 0x9646c379
    li x3, 0x9646c379
    csrw 0x2ca, x3

    #Address 0x2ca Write value 0xba1f5e03
    li x3, 0xba1f5e03
    csrw 0x2ca, x3

    #Address 0x2ca read value
    csrr x14, 0x2ca

    #Address 0x2ca Write value 0x9987ad09
    li x3, 0x9987ad09
    csrw 0x2ca, x3

    #Unmapped address 0x4fa testing: random write/read operations
    #Address 0x4fa read value
    csrr x14, 0x4fa

    #Address 0x4fa Write value 0x439769e4
    li x3, 0x439769e4
    csrw 0x4fa, x3

    #Address 0x4fa Write value 0x6e1fb8c0
    li x3, 0x6e1fb8c0
    csrw 0x4fa, x3

    #Address 0x4fa read value
    csrr x14, 0x4fa

    #Address 0x4fa read value
    csrr x14, 0x4fa

    #Unmapped address 0x45c testing: random write/read operations
    #Address 0x45c Write value 0x45d855bf
    li x3, 0x45d855bf
    csrw 0x45c, x3

    #Address 0x45c read value
    csrr x14, 0x45c

    #Unmapped address 0xebb testing: random write/read operations
    #Address 0xebb Write value 0x28bbae85
    li x3, 0x28bbae85
    csrw 0xebb, x3

    #Address 0xebb read value
    csrr x14, 0xebb

    #Address 0xebb read value
    csrr x14, 0xebb

    #Unmapped address 0x7a3 testing: random write/read operations
    #Address 0x7a3 read value
    csrr x14, 0x7a3

    #Unmapped address 0x85f testing: random write/read operations
    #Address 0x85f read value
    csrr x14, 0x85f

    #Address 0x85f read value
    csrr x14, 0x85f

    #Address 0x85f read value
    csrr x14, 0x85f

    #Unmapped address 0x53c testing: random write/read operations
    #Address 0x53c Write value 0x202ba0a1
    li x3, 0x202ba0a1
    csrw 0x53c, x3

    #Address 0x53c Write value 0xdf728732
    li x3, 0xdf728732
    csrw 0x53c, x3

    #Unmapped address 0x62 testing: random write/read operations
    #Address 0x62 read value
    csrr x14, 0x62

    #Address 0x62 Write value 0xfcd2895b
    li x3, 0xfcd2895b
    csrw 0x62, x3

    #Address 0x62 read value
    csrr x14, 0x62

    #Unmapped address 0xe06 testing: random write/read operations
    #Address 0xe06 Write value 0x3a92f8dc
    li x3, 0x3a92f8dc
    csrw 0xe06, x3

    #Address 0xe06 read value
    csrr x14, 0xe06

    #Address 0xe06 Write value 0x955361b7
    li x3, 0x955361b7
    csrw 0xe06, x3

    #Unmapped address 0x21c testing: random write/read operations
    #Address 0x21c read value
    csrr x14, 0x21c

    #Address 0x21c read value
    csrr x14, 0x21c

    #Address 0x21c read value
    csrr x14, 0x21c

    #Unmapped address 0x4e9 testing: random write/read operations
    #Address 0x4e9 Write value 0x73ec1b96
    li x3, 0x73ec1b96
    csrw 0x4e9, x3

    #Address 0x4e9 Write value 0xac0287bb
    li x3, 0xac0287bb
    csrw 0x4e9, x3

    #Unmapped address 0xcf5 testing: random write/read operations
    #Address 0xcf5 Write value 0x274b2f60
    li x3, 0x274b2f60
    csrw 0xcf5, x3

    #Address 0xcf5 read value
    csrr x14, 0xcf5

    #Address 0xcf5 read value
    csrr x14, 0xcf5

    #Unmapped address 0xe69 testing: random write/read operations
    #Address 0xe69 Write value 0xf69aa7e0
    li x3, 0xf69aa7e0
    csrw 0xe69, x3

    #Address 0xe69 Write value 0xeb9853c8
    li x3, 0xeb9853c8
    csrw 0xe69, x3

    #Address 0xe69 read value
    csrr x14, 0xe69

    #Address 0xe69 read value
    csrr x14, 0xe69

    #Unmapped address 0x9e4 testing: random write/read operations
    #Address 0x9e4 read value
    csrr x14, 0x9e4

    #Unmapped address 0xdf4 testing: random write/read operations
    #Address 0xdf4 Write value 0xcbbfa1c9
    li x3, 0xcbbfa1c9
    csrw 0xdf4, x3

    #Address 0xdf4 Write value 0x5167849c
    li x3, 0x5167849c
    csrw 0xdf4, x3

    #Address 0xdf4 Write value 0xd29bfff8
    li x3, 0xd29bfff8
    csrw 0xdf4, x3

    #Unmapped address 0xdfb testing: random write/read operations
    #Address 0xdfb Write value 0xaac3cd55
    li x3, 0xaac3cd55
    csrw 0xdfb, x3

    #Address 0xdfb Write value 0x3f67c813
    li x3, 0x3f67c813
    csrw 0xdfb, x3

    #Address 0xdfb Write value 0xf159022d
    li x3, 0xf159022d
    csrw 0xdfb, x3

    #Address 0xdfb Write value 0x13928d81
    li x3, 0x13928d81
    csrw 0xdfb, x3

    #Unmapped address 0x956 testing: random write/read operations
    #Address 0x956 read value
    csrr x14, 0x956

    #Address 0x956 read value
    csrr x14, 0x956

    #Unmapped address 0x4a5 testing: random write/read operations
    #Address 0x4a5 Write value 0x5b0d255d
    li x3, 0x5b0d255d
    csrw 0x4a5, x3

    #Address 0x4a5 read value
    csrr x14, 0x4a5

    #Unmapped address 0xa41 testing: random write/read operations
    #Address 0xa41 read value
    csrr x14, 0xa41

    #Address 0xa41 read value
    csrr x14, 0xa41

    #Address 0xa41 read value
    csrr x14, 0xa41

    #Unmapped address 0x4ae testing: random write/read operations
    #Address 0x4ae read value
    csrr x14, 0x4ae

    #Address 0x4ae Write value 0x83084cf9
    li x3, 0x83084cf9
    csrw 0x4ae, x3

    #Unmapped address 0x873 testing: random write/read operations
    #Address 0x873 Write value 0xe347c2fe
    li x3, 0xe347c2fe
    csrw 0x873, x3

    #Address 0x873 read value
    csrr x14, 0x873

    #Address 0x873 Write value 0x8fd331e1
    li x3, 0x8fd331e1
    csrw 0x873, x3

    #Address 0x873 Write value 0x6a3e942d
    li x3, 0x6a3e942d
    csrw 0x873, x3

    #Unmapped address 0x792 testing: random write/read operations
    #Address 0x792 read value
    csrr x14, 0x792

    #Address 0x792 read value
    csrr x14, 0x792

    #Address 0x792 Write value 0x673f681d
    li x3, 0x673f681d
    csrw 0x792, x3

    #Address 0x792 Write value 0xf08873b8
    li x3, 0xf08873b8
    csrw 0x792, x3

    #Unmapped address 0x6ff testing: random write/read operations
    #Address 0x6ff Write value 0xc63d18fb
    li x3, 0xc63d18fb
    csrw 0x6ff, x3

    #Address 0x6ff read value
    csrr x14, 0x6ff

    #Address 0x6ff read value
    csrr x14, 0x6ff

    #Address 0x6ff read value
    csrr x14, 0x6ff

    #Unmapped address 0xf5f testing: random write/read operations
    #Address 0xf5f read value
    csrr x14, 0xf5f

    #Address 0xf5f Write value 0x16ba2d43
    li x3, 0x16ba2d43
    csrw 0xf5f, x3

    #Address 0xf5f Write value 0x691f392
    li x3, 0x691f392
    csrw 0xf5f, x3

    #Address 0xf5f read value
    csrr x14, 0xf5f

    #Address 0xf5f Write value 0x2d0e275e
    li x3, 0x2d0e275e
    csrw 0xf5f, x3

    #Unmapped address 0xff6 testing: random write/read operations
    #Address 0xff6 read value
    csrr x14, 0xff6

    #Address 0xff6 read value
    csrr x14, 0xff6

    #Unmapped address 0x17f testing: random write/read operations
    #Address 0x17f read value
    csrr x14, 0x17f

    #Address 0x17f read value
    csrr x14, 0x17f

    #Address 0x17f Write value 0xa7ee7b06
    li x3, 0xa7ee7b06
    csrw 0x17f, x3

    #Address 0x17f Write value 0x622d3bf5
    li x3, 0x622d3bf5
    csrw 0x17f, x3

    #Unmapped address 0xef5 testing: random write/read operations
    #Address 0xef5 Write value 0xea62874
    li x3, 0xea62874
    csrw 0xef5, x3

    #Address 0xef5 Write value 0x67eb00c4
    li x3, 0x67eb00c4
    csrw 0xef5, x3

    #Address 0xef5 read value
    csrr x14, 0xef5

    #Address 0xef5 Write value 0x18c96948
    li x3, 0x18c96948
    csrw 0xef5, x3

    #Address 0xef5 read value
    csrr x14, 0xef5

    #Mapped address 0x3b6 (pmpaddr6) testing: random write/read operations
    #Address 0x3b6 Write value 0x7d3936cd
    li x3, 0x7d3936cd
    csrw 0x3b6, x3

    #Address 0x3b6 Write value 0xe16b7432
    li x3, 0xe16b7432
    csrw 0x3b6, x3

    #Unmapped address 0xa8d testing: random write/read operations
    #Address 0xa8d read value
    csrr x14, 0xa8d

    #Unmapped address 0x74f testing: random write/read operations
    #Address 0x74f read value
    csrr x14, 0x74f

    #Address 0x74f Write value 0x9dc77b53
    li x3, 0x9dc77b53
    csrw 0x74f, x3

    #Address 0x74f Write value 0x29d84472
    li x3, 0x29d84472
    csrw 0x74f, x3

    #Unmapped address 0xeeb testing: random write/read operations
    #Address 0xeeb Write value 0x240c214a
    li x3, 0x240c214a
    csrw 0xeeb, x3

    #Address 0xeeb read value
    csrr x14, 0xeeb

    #Address 0xeeb Write value 0x4c1b62e8
    li x3, 0x4c1b62e8
    csrw 0xeeb, x3

    #Unmapped address 0xf63 testing: random write/read operations
    #Address 0xf63 Write value 0x5c106f4e
    li x3, 0x5c106f4e
    csrw 0xf63, x3

    #Unmapped address 0x16f testing: random write/read operations
    #Address 0x16f Write value 0x31a8ff9a
    li x3, 0x31a8ff9a
    csrw 0x16f, x3

    #Unmapped address 0x2e2 testing: random write/read operations
    #Address 0x2e2 read value
    csrr x14, 0x2e2

    #Address 0x2e2 read value
    csrr x14, 0x2e2

    #Unmapped address 0xb77 testing: random write/read operations
    #Address 0xb77 read value
    csrr x14, 0xb77

    #Address 0xb77 Write value 0x399952f9
    li x3, 0x399952f9
    csrw 0xb77, x3

    #Unmapped address 0x93d testing: random write/read operations
    #Address 0x93d Write value 0xe9231228
    li x3, 0xe9231228
    csrw 0x93d, x3

    #Address 0x93d Write value 0xa2ab3991
    li x3, 0xa2ab3991
    csrw 0x93d, x3

    #Address 0x93d read value
    csrr x14, 0x93d

    #Address 0x93d read value
    csrr x14, 0x93d

    #Address 0x93d Write value 0xe32d5cb1
    li x3, 0xe32d5cb1
    csrw 0x93d, x3

    #Unmapped address 0xe47 testing: random write/read operations
    #Address 0xe47 read value
    csrr x14, 0xe47

    #Address 0xe47 read value
    csrr x14, 0xe47

    #Unmapped address 0xe84 testing: random write/read operations
    #Address 0xe84 Write value 0x1b299f9
    li x3, 0x1b299f9
    csrw 0xe84, x3

    #Address 0xe84 read value
    csrr x14, 0xe84

    #Address 0xe84 Write value 0xec32be86
    li x3, 0xec32be86
    csrw 0xe84, x3

    #Address 0xe84 Write value 0x248d9fd5
    li x3, 0x248d9fd5
    csrw 0xe84, x3

    #Address 0xe84 read value
    csrr x14, 0xe84

    #Unmapped address 0x39c testing: random write/read operations
    #Address 0x39c Write value 0xde0d144a
    li x3, 0xde0d144a
    csrw 0x39c, x3

    #Address 0x39c read value
    csrr x14, 0x39c

    #Unmapped address 0x632 testing: random write/read operations
    #Address 0x632 Write value 0x3402cc85
    li x3, 0x3402cc85
    csrw 0x632, x3

    #Address 0x632 Write value 0x781e4c84
    li x3, 0x781e4c84
    csrw 0x632, x3

    #Address 0x632 read value
    csrr x14, 0x632

    #Unmapped address 0xe4d testing: random write/read operations
    #Address 0xe4d read value
    csrr x14, 0xe4d

    #Address 0xe4d read value
    csrr x14, 0xe4d

    #Address 0xe4d read value
    csrr x14, 0xe4d

    #Unmapped address 0x133 testing: random write/read operations
    #Address 0x133 Write value 0x7b67ec2d
    li x3, 0x7b67ec2d
    csrw 0x133, x3

    #Unmapped address 0xd75 testing: random write/read operations
    #Address 0xd75 read value
    csrr x14, 0xd75

    #Unmapped address 0x4cb testing: random write/read operations
    #Address 0x4cb read value
    csrr x14, 0x4cb

    #Address 0x4cb read value
    csrr x14, 0x4cb

    #Address 0x4cb Write value 0xe555eb57
    li x3, 0xe555eb57
    csrw 0x4cb, x3

    #Unmapped address 0x76d testing: random write/read operations
    #Address 0x76d read value
    csrr x14, 0x76d

    #Address 0x76d read value
    csrr x14, 0x76d

    #Address 0x76d Write value 0xb8268b9e
    li x3, 0xb8268b9e
    csrw 0x76d, x3

    #Address 0x76d Write value 0xf5b5b4e3
    li x3, 0xf5b5b4e3
    csrw 0x76d, x3

    #Address 0x76d read value
    csrr x14, 0x76d

    #Unmapped address 0x3e2 testing: random write/read operations
    #Address 0x3e2 Write value 0x386f6a06
    li x3, 0x386f6a06
    csrw 0x3e2, x3

    #Address 0x3e2 Write value 0x4940b70
    li x3, 0x4940b70
    csrw 0x3e2, x3

    #Unmapped address 0xbaa testing: random write/read operations
    #Address 0xbaa read value
    csrr x14, 0xbaa

    #Address 0xbaa Write value 0xa84cc5d2
    li x3, 0xa84cc5d2
    csrw 0xbaa, x3

    #Address 0xbaa Write value 0xf55f4fa6
    li x3, 0xf55f4fa6
    csrw 0xbaa, x3

    #Address 0xbaa Write value 0x23f8058f
    li x3, 0x23f8058f
    csrw 0xbaa, x3

    #Unmapped address 0x808 testing: random write/read operations
    #Address 0x808 read value
    csrr x14, 0x808

    #Address 0x808 read value
    csrr x14, 0x808

    #Unmapped address 0x999 testing: random write/read operations
    #Address 0x999 Write value 0x1204b840
    li x3, 0x1204b840
    csrw 0x999, x3

    #Address 0x999 read value
    csrr x14, 0x999

    #Address 0x999 Write value 0x34a46d01
    li x3, 0x34a46d01
    csrw 0x999, x3

    #Address 0x999 Write value 0x87a9cee1
    li x3, 0x87a9cee1
    csrw 0x999, x3

    #Unmapped address 0xf3d testing: random write/read operations
    #Address 0xf3d Write value 0x8ec0e39d
    li x3, 0x8ec0e39d
    csrw 0xf3d, x3

    #Address 0xf3d read value
    csrr x14, 0xf3d

    #Address 0xf3d Write value 0xc8f809ff
    li x3, 0xc8f809ff
    csrw 0xf3d, x3

    #Unmapped address 0xc0a testing: random write/read operations
    #Address 0xc0a Write value 0xa17095d3
    li x3, 0xa17095d3
    csrw 0xc0a, x3

    #Address 0xc0a read value
    csrr x14, 0xc0a

    #Address 0xc0a Write value 0xca5a9a1
    li x3, 0xca5a9a1
    csrw 0xc0a, x3

    #Address 0xc0a read value
    csrr x14, 0xc0a

    #Address 0xc0a Write value 0xb521b590
    li x3, 0xb521b590
    csrw 0xc0a, x3

    #Unmapped address 0xa8f testing: random write/read operations
    #Address 0xa8f read value
    csrr x14, 0xa8f

    #Address 0xa8f Write value 0xd0afe17d
    li x3, 0xd0afe17d
    csrw 0xa8f, x3

    #Mapped address 0x3a1 (pmpcfg1) testing: random write/read operations
    #Address 0x3a1 Write value 0x54266e39
    li x3, 0x54266e39
    csrw 0x3a1, x3

    #Address 0x3a1 Write value 0xf6b3822d
    li x3, 0xf6b3822d
    csrw 0x3a1, x3

    #Address 0x3a1 Write value 0x5840162f
    li x3, 0x5840162f
    csrw 0x3a1, x3

    #Unmapped address 0x168 testing: random write/read operations
    #Address 0x168 Write value 0xf02749dc
    li x3, 0xf02749dc
    csrw 0x168, x3

    #Address 0x168 Write value 0xd8976c9c
    li x3, 0xd8976c9c
    csrw 0x168, x3

    #Address 0x168 Write value 0xb7c2af32
    li x3, 0xb7c2af32
    csrw 0x168, x3

    #Unmapped address 0x4fd testing: random write/read operations
    #Address 0x4fd read value
    csrr x14, 0x4fd

    #Address 0x4fd read value
    csrr x14, 0x4fd

    #Unmapped address 0xfdc testing: random write/read operations
    #Address 0xfdc Write value 0xdb4256a6
    li x3, 0xdb4256a6
    csrw 0xfdc, x3

    #Unmapped address 0xf88 testing: random write/read operations
    #Address 0xf88 read value
    csrr x14, 0xf88

    #Address 0xf88 read value
    csrr x14, 0xf88

    #Address 0xf88 Write value 0x45fbe2
    li x3, 0x45fbe2
    csrw 0xf88, x3

    #Unmapped address 0xb24 testing: random write/read operations
    #Address 0xb24 read value
    csrr x14, 0xb24

    #Address 0xb24 read value
    csrr x14, 0xb24

    #Address 0xb24 read value
    csrr x14, 0xb24

    #Unmapped address 0x526 testing: random write/read operations
    #Address 0x526 Write value 0xfea8ef0
    li x3, 0xfea8ef0
    csrw 0x526, x3

    #Address 0x526 read value
    csrr x14, 0x526

    #Address 0x526 Write value 0xfb1861f5
    li x3, 0xfb1861f5
    csrw 0x526, x3

    #Address 0x526 Write value 0xdeb2190c
    li x3, 0xdeb2190c
    csrw 0x526, x3

    #Address 0x526 Write value 0x7dafa1bd
    li x3, 0x7dafa1bd
    csrw 0x526, x3

    #Unmapped address 0xa59 testing: random write/read operations
    #Address 0xa59 Write value 0xbbf836e8
    li x3, 0xbbf836e8
    csrw 0xa59, x3

    #Address 0xa59 read value
    csrr x14, 0xa59

    #Address 0xa59 read value
    csrr x14, 0xa59

    #Address 0xa59 read value
    csrr x14, 0xa59

    #Address 0xa59 Write value 0x5acf4332
    li x3, 0x5acf4332
    csrw 0xa59, x3

    #Unmapped address 0x4d9 testing: random write/read operations
    #Address 0x4d9 Write value 0x77915908
    li x3, 0x77915908
    csrw 0x4d9, x3

    #Address 0x4d9 read value
    csrr x14, 0x4d9

    #Address 0x4d9 read value
    csrr x14, 0x4d9

    #Address 0x4d9 read value
    csrr x14, 0x4d9

    #Address 0x4d9 read value
    csrr x14, 0x4d9

    #Unmapped address 0xc3 testing: random write/read operations
    #Address 0xc3 Write value 0x59333b94
    li x3, 0x59333b94
    csrw 0xc3, x3

    #Address 0xc3 read value
    csrr x14, 0xc3

    #Unmapped address 0x2d6 testing: random write/read operations
    #Address 0x2d6 Write value 0x59f27431
    li x3, 0x59f27431
    csrw 0x2d6, x3

    #Address 0x2d6 Write value 0xcf936328
    li x3, 0xcf936328
    csrw 0x2d6, x3

    #Address 0x2d6 read value
    csrr x14, 0x2d6

    #Unmapped address 0x41c testing: random write/read operations
    #Address 0x41c Write value 0xedf6e99e
    li x3, 0xedf6e99e
    csrw 0x41c, x3

    #Address 0x41c read value
    csrr x14, 0x41c

    #Mapped address 0xb80 (mcycleh) testing: random write/read operations
    #Address 0xb80 read value
    csrr x14, 0xb80

    #Address 0xb80 Write value 0x6a6f3a91
    li x3, 0x6a6f3a91
    csrw 0xb80, x3

    #Address 0xb80 read value
    csrr x14, 0xb80

    #Address 0xb80 Write value 0x524bd1d3
    li x3, 0x524bd1d3
    csrw 0xb80, x3

    #Address 0xb80 read value
    csrr x14, 0xb80

    #Unmapped address 0x78 testing: random write/read operations
    #Address 0x78 read value
    csrr x14, 0x78

    #Address 0x78 read value
    csrr x14, 0x78

    #Address 0x78 read value
    csrr x14, 0x78

    #Address 0x78 Write value 0x26eec950
    li x3, 0x26eec950
    csrw 0x78, x3

    #Address 0x78 read value
    csrr x14, 0x78

    #Unmapped address 0xb7f testing: random write/read operations
    #Address 0xb7f read value
    csrr x14, 0xb7f

    #Address 0xb7f Write value 0xd5f18f9e
    li x3, 0xd5f18f9e
    csrw 0xb7f, x3

    #Unmapped address 0x8eb testing: random write/read operations
    #Address 0x8eb Write value 0x438ac29f
    li x3, 0x438ac29f
    csrw 0x8eb, x3

    #Address 0x8eb read value
    csrr x14, 0x8eb

    #Unmapped address 0xeed testing: random write/read operations
    #Address 0xeed read value
    csrr x14, 0xeed

    #Address 0xeed Write value 0x35495f25
    li x3, 0x35495f25
    csrw 0xeed, x3

    #Address 0xeed Write value 0xcc338497
    li x3, 0xcc338497
    csrw 0xeed, x3

    #Address 0xeed read value
    csrr x14, 0xeed

    #Unmapped address 0x11 testing: random write/read operations
    #Address 0x11 Write value 0xadd17513
    li x3, 0xadd17513
    csrw 0x11, x3

    #Address 0x11 Write value 0xff1f50ce
    li x3, 0xff1f50ce
    csrw 0x11, x3

    #Unmapped address 0x35a testing: random write/read operations
    #Address 0x35a Write value 0xd4005108
    li x3, 0xd4005108
    csrw 0x35a, x3

    #Address 0x35a Write value 0x6dc2a569
    li x3, 0x6dc2a569
    csrw 0x35a, x3

    #Unmapped address 0xfa4 testing: random write/read operations
    #Address 0xfa4 Write value 0x2431d0c1
    li x3, 0x2431d0c1
    csrw 0xfa4, x3

    #Address 0xfa4 read value
    csrr x14, 0xfa4

    #Address 0xfa4 read value
    csrr x14, 0xfa4

    #Unmapped address 0x470 testing: random write/read operations
    #Address 0x470 read value
    csrr x14, 0x470

    #Address 0x470 read value
    csrr x14, 0x470

    #Address 0x470 Write value 0xe681b1b1
    li x3, 0xe681b1b1
    csrw 0x470, x3

    #Unmapped address 0xaa5 testing: random write/read operations
    #Address 0xaa5 read value
    csrr x14, 0xaa5

    #Unmapped address 0x942 testing: random write/read operations
    #Address 0x942 read value
    csrr x14, 0x942

    #Address 0x942 read value
    csrr x14, 0x942

    #Address 0x942 read value
    csrr x14, 0x942

    #Address 0x942 Write value 0x876b3c7f
    li x3, 0x876b3c7f
    csrw 0x942, x3

    #Unmapped address 0x4f4 testing: random write/read operations
    #Address 0x4f4 read value
    csrr x14, 0x4f4

    #Address 0x4f4 read value
    csrr x14, 0x4f4

    #Address 0x4f4 Write value 0xfbf07ad4
    li x3, 0xfbf07ad4
    csrw 0x4f4, x3

    #Address 0x4f4 read value
    csrr x14, 0x4f4

    #Unmapped address 0xc14 testing: random write/read operations
    #Address 0xc14 Write value 0x67813ea5
    li x3, 0x67813ea5
    csrw 0xc14, x3

    #Address 0xc14 Write value 0x17d15757
    li x3, 0x17d15757
    csrw 0xc14, x3

    #Unmapped address 0x625 testing: random write/read operations
    #Address 0x625 Write value 0xd415d6c1
    li x3, 0xd415d6c1
    csrw 0x625, x3

    #Address 0x625 Write value 0x38f67ecc
    li x3, 0x38f67ecc
    csrw 0x625, x3

    #Address 0x625 Write value 0x8e309db3
    li x3, 0x8e309db3
    csrw 0x625, x3

    #Address 0x625 read value
    csrr x14, 0x625

    #Unmapped address 0xc31 testing: random write/read operations
    #Address 0xc31 Write value 0xe2c53c28
    li x3, 0xe2c53c28
    csrw 0xc31, x3

    #Unmapped address 0xfbd testing: random write/read operations
    #Address 0xfbd Write value 0x1e08b45e
    li x3, 0x1e08b45e
    csrw 0xfbd, x3

    #Address 0xfbd Write value 0xf291183b
    li x3, 0xf291183b
    csrw 0xfbd, x3

    #Unmapped address 0xa09 testing: random write/read operations
    #Address 0xa09 Write value 0x8ad78840
    li x3, 0x8ad78840
    csrw 0xa09, x3

    #Address 0xa09 read value
    csrr x14, 0xa09

    #Address 0xa09 Write value 0x4221a425
    li x3, 0x4221a425
    csrw 0xa09, x3

    #Address 0xa09 read value
    csrr x14, 0xa09

    #Unmapped address 0xf2b testing: random write/read operations
    #Address 0xf2b Write value 0xc8fdcd6a
    li x3, 0xc8fdcd6a
    csrw 0xf2b, x3

    #Unmapped address 0xdcc testing: random write/read operations
    #Address 0xdcc Write value 0xe11d691f
    li x3, 0xe11d691f
    csrw 0xdcc, x3

    #Unmapped address 0xdac testing: random write/read operations
    #Address 0xdac read value
    csrr x14, 0xdac

    #Address 0xdac read value
    csrr x14, 0xdac

    #Unmapped address 0x504 testing: random write/read operations
    #Address 0x504 read value
    csrr x14, 0x504

    #Unmapped address 0xf7b testing: random write/read operations
    #Address 0xf7b read value
    csrr x14, 0xf7b

    #Address 0xf7b read value
    csrr x14, 0xf7b

    #Address 0xf7b Write value 0x56506448
    li x3, 0x56506448
    csrw 0xf7b, x3

    #Address 0xf7b Write value 0xa66c69cd
    li x3, 0xa66c69cd
    csrw 0xf7b, x3

    #Address 0xf7b Write value 0x9ed2facc
    li x3, 0x9ed2facc
    csrw 0xf7b, x3

    #Unmapped address 0xe86 testing: random write/read operations
    #Address 0xe86 read value
    csrr x14, 0xe86

    #Address 0xe86 read value
    csrr x14, 0xe86

    #Address 0xe86 Write value 0xab023f21
    li x3, 0xab023f21
    csrw 0xe86, x3

    #Address 0xe86 Write value 0x6a83fa8d
    li x3, 0x6a83fa8d
    csrw 0xe86, x3

    #Unmapped address 0xe7f testing: random write/read operations
    #Address 0xe7f read value
    csrr x14, 0xe7f

    #Address 0xe7f read value
    csrr x14, 0xe7f

    #Unmapped address 0xde6 testing: random write/read operations
    #Address 0xde6 Write value 0xf7879fba
    li x3, 0xf7879fba
    csrw 0xde6, x3

    #Address 0xde6 Write value 0x4dcefcb5
    li x3, 0x4dcefcb5
    csrw 0xde6, x3

    #Address 0xde6 read value
    csrr x14, 0xde6

    #Unmapped address 0x7ed testing: random write/read operations
    #Address 0x7ed Write value 0x7206cdca
    li x3, 0x7206cdca
    csrw 0x7ed, x3

    #Address 0x7ed Write value 0x31e360a3
    li x3, 0x31e360a3
    csrw 0x7ed, x3

    #Address 0x7ed Write value 0x60889720
    li x3, 0x60889720
    csrw 0x7ed, x3

    #Address 0x7ed Write value 0xcd6c9952
    li x3, 0xcd6c9952
    csrw 0x7ed, x3

    #Address 0x7ed Write value 0xaa179555
    li x3, 0xaa179555
    csrw 0x7ed, x3

    #Unmapped address 0xe21 testing: random write/read operations
    #Address 0xe21 Write value 0x4ea5964a
    li x3, 0x4ea5964a
    csrw 0xe21, x3

    #Address 0xe21 Write value 0x712aaed7
    li x3, 0x712aaed7
    csrw 0xe21, x3

    #Address 0xe21 read value
    csrr x14, 0xe21

    #Address 0xe21 read value
    csrr x14, 0xe21

    #Unmapped address 0xdbf testing: random write/read operations
    #Address 0xdbf Write value 0xc9a230e1
    li x3, 0xc9a230e1
    csrw 0xdbf, x3

    #Address 0xdbf read value
    csrr x14, 0xdbf

    #Address 0xdbf Write value 0x375d5732
    li x3, 0x375d5732
    csrw 0xdbf, x3

    #Unmapped address 0x6d7 testing: random write/read operations
    #Address 0x6d7 read value
    csrr x14, 0x6d7

    #Unmapped address 0x2c2 testing: random write/read operations
    #Address 0x2c2 Write value 0xa6d4df14
    li x3, 0xa6d4df14
    csrw 0x2c2, x3

    #Unmapped address 0x980 testing: random write/read operations
    #Address 0x980 read value
    csrr x14, 0x980

    #Address 0x980 read value
    csrr x14, 0x980

    #Address 0x980 Write value 0x9b5a38c2
    li x3, 0x9b5a38c2
    csrw 0x980, x3

    #Unmapped address 0xfd1 testing: random write/read operations
    #Address 0xfd1 Write value 0x3a2ed58e
    li x3, 0x3a2ed58e
    csrw 0xfd1, x3

    #Address 0xfd1 read value
    csrr x14, 0xfd1

    #Address 0xfd1 read value
    csrr x14, 0xfd1

    #Unmapped address 0xfe7 testing: random write/read operations
    #Address 0xfe7 read value
    csrr x14, 0xfe7

    #Address 0xfe7 read value
    csrr x14, 0xfe7

    #Unmapped address 0x468 testing: random write/read operations
    #Address 0x468 read value
    csrr x14, 0x468

    #Unmapped address 0xfbb testing: random write/read operations
    #Address 0xfbb Write value 0x493b87ec
    li x3, 0x493b87ec
    csrw 0xfbb, x3

    #Address 0xfbb Write value 0xe2092ed8
    li x3, 0xe2092ed8
    csrw 0xfbb, x3

    #Unmapped address 0x4e0 testing: random write/read operations
    #Address 0x4e0 Write value 0x2795fbb1
    li x3, 0x2795fbb1
    csrw 0x4e0, x3

    #Address 0x4e0 read value
    csrr x14, 0x4e0

    #Unmapped address 0xcd testing: random write/read operations
    #Address 0xcd read value
    csrr x14, 0xcd

    #Unmapped address 0xc54 testing: random write/read operations
    #Address 0xc54 read value
    csrr x14, 0xc54

    #Address 0xc54 read value
    csrr x14, 0xc54

    #Address 0xc54 Write value 0xc7265c8c
    li x3, 0xc7265c8c
    csrw 0xc54, x3

    #Unmapped address 0x7e testing: random write/read operations
    #Address 0x7e Write value 0x574c2615
    li x3, 0x574c2615
    csrw 0x7e, x3

    #Address 0x7e read value
    csrr x14, 0x7e

    #Address 0x7e Write value 0x24c2762b
    li x3, 0x24c2762b
    csrw 0x7e, x3

    #Address 0x7e read value
    csrr x14, 0x7e

    #Unmapped address 0x293 testing: random write/read operations
    #Address 0x293 Write value 0xc650d337
    li x3, 0xc650d337
    csrw 0x293, x3

    #Address 0x293 read value
    csrr x14, 0x293

    #Address 0x293 Write value 0x84a4f5e9
    li x3, 0x84a4f5e9
    csrw 0x293, x3

    #Address 0x293 Write value 0x8ec7ef73
    li x3, 0x8ec7ef73
    csrw 0x293, x3

    #Unmapped address 0xe23 testing: random write/read operations
    #Address 0xe23 read value
    csrr x14, 0xe23

    #Address 0xe23 Write value 0xba1ba054
    li x3, 0xba1ba054
    csrw 0xe23, x3

    #Address 0xe23 read value
    csrr x14, 0xe23

    #Address 0xe23 Write value 0x2ae29930
    li x3, 0x2ae29930
    csrw 0xe23, x3

    #Address 0xe23 Write value 0xa5e6eb95
    li x3, 0xa5e6eb95
    csrw 0xe23, x3

    #Unmapped address 0x24d testing: random write/read operations
    #Address 0x24d read value
    csrr x14, 0x24d

    #Unmapped address 0x3c testing: random write/read operations
    #Address 0x3c Write value 0x395bb619
    li x3, 0x395bb619
    csrw 0x3c, x3

    #Unmapped address 0x64c testing: random write/read operations
    #Address 0x64c read value
    csrr x14, 0x64c

    #Address 0x64c Write value 0x319f8fd1
    li x3, 0x319f8fd1
    csrw 0x64c, x3

    #Unmapped address 0xda5 testing: random write/read operations
    #Address 0xda5 read value
    csrr x14, 0xda5

    #Address 0xda5 read value
    csrr x14, 0xda5

    #Unmapped address 0x9b0 testing: random write/read operations
    #Address 0x9b0 read value
    csrr x14, 0x9b0

    #Address 0x9b0 Write value 0xce06c0fb
    li x3, 0xce06c0fb
    csrw 0x9b0, x3

    #Address 0x9b0 read value
    csrr x14, 0x9b0

    #Unmapped address 0x43b testing: random write/read operations
    #Address 0x43b read value
    csrr x14, 0x43b

    #Address 0x43b Write value 0x9a5e578c
    li x3, 0x9a5e578c
    csrw 0x43b, x3

    #Unmapped address 0x407 testing: random write/read operations
    #Address 0x407 read value
    csrr x14, 0x407

    #Address 0x407 read value
    csrr x14, 0x407

    #Address 0x407 Write value 0xe16d2309
    li x3, 0xe16d2309
    csrw 0x407, x3

    #Unmapped address 0x3d4 testing: random write/read operations
    #Address 0x3d4 Write value 0xa4618e47
    li x3, 0xa4618e47
    csrw 0x3d4, x3

    #Address 0x3d4 Write value 0xb03ce9d6
    li x3, 0xb03ce9d6
    csrw 0x3d4, x3

    #Address 0x3d4 read value
    csrr x14, 0x3d4

    #Unmapped address 0x996 testing: random write/read operations
    #Address 0x996 Write value 0xc6e28ad0
    li x3, 0xc6e28ad0
    csrw 0x996, x3

    #Address 0x996 read value
    csrr x14, 0x996

    #Address 0x996 read value
    csrr x14, 0x996

    #Address 0x996 Write value 0x1a8f0a47
    li x3, 0x1a8f0a47
    csrw 0x996, x3

    #Address 0x996 read value
    csrr x14, 0x996

    #Unmapped address 0x7c4 testing: random write/read operations
    #Address 0x7c4 read value
    csrr x14, 0x7c4

    #Address 0x7c4 Write value 0x65b7b0a
    li x3, 0x65b7b0a
    csrw 0x7c4, x3

    #Unmapped address 0x769 testing: random write/read operations
    #Address 0x769 read value
    csrr x14, 0x769

    #Address 0x769 Write value 0x32a20319
    li x3, 0x32a20319
    csrw 0x769, x3

    #Unmapped address 0x686 testing: random write/read operations
    #Address 0x686 Write value 0xaf629639
    li x3, 0xaf629639
    csrw 0x686, x3

    #Address 0x686 Write value 0xe1c10533
    li x3, 0xe1c10533
    csrw 0x686, x3

    #Address 0x686 read value
    csrr x14, 0x686

    #Address 0x686 Write value 0x45213c25
    li x3, 0x45213c25
    csrw 0x686, x3

    #Unmapped address 0xa05 testing: random write/read operations
    #Address 0xa05 Write value 0x39bb9642
    li x3, 0x39bb9642
    csrw 0xa05, x3

    #Unmapped address 0x21f testing: random write/read operations
    #Address 0x21f Write value 0x60b96fc4
    li x3, 0x60b96fc4
    csrw 0x21f, x3

    #Unmapped address 0x5e2 testing: random write/read operations
    #Address 0x5e2 read value
    csrr x14, 0x5e2

    #Unmapped address 0x1df testing: random write/read operations
    #Address 0x1df Write value 0x73eb9853
    li x3, 0x73eb9853
    csrw 0x1df, x3

    #Address 0x1df read value
    csrr x14, 0x1df

    #Address 0x1df Write value 0x15805837
    li x3, 0x15805837
    csrw 0x1df, x3

    #Address 0x1df read value
    csrr x14, 0x1df

    #Unmapped address 0x60a testing: random write/read operations
    #Address 0x60a read value
    csrr x14, 0x60a

    #Address 0x60a Write value 0x1694179d
    li x3, 0x1694179d
    csrw 0x60a, x3

    #Unmapped address 0xa86 testing: random write/read operations
    #Address 0xa86 Write value 0x86cf1909
    li x3, 0x86cf1909
    csrw 0xa86, x3

    #Address 0xa86 Write value 0x7bdf1ddb
    li x3, 0x7bdf1ddb
    csrw 0xa86, x3

    #Address 0xa86 read value
    csrr x14, 0xa86

    #Unmapped address 0xbfa testing: random write/read operations
    #Address 0xbfa Write value 0xfcb0be70
    li x3, 0xfcb0be70
    csrw 0xbfa, x3

    #Address 0xbfa read value
    csrr x14, 0xbfa

    #Address 0xbfa read value
    csrr x14, 0xbfa

    #Unmapped address 0x298 testing: random write/read operations
    #Address 0x298 read value
    csrr x14, 0x298

    #Address 0x298 read value
    csrr x14, 0x298

    #Unmapped address 0xae5 testing: random write/read operations
    #Address 0xae5 Write value 0x62f2425a
    li x3, 0x62f2425a
    csrw 0xae5, x3

    #Unmapped address 0x3ec testing: random write/read operations
    #Address 0x3ec Write value 0xa0697892
    li x3, 0xa0697892
    csrw 0x3ec, x3

    #Address 0x3ec read value
    csrr x14, 0x3ec

    #Address 0x3ec Write value 0x831cc71f
    li x3, 0x831cc71f
    csrw 0x3ec, x3

    #Unmapped address 0xc74 testing: random write/read operations
    #Address 0xc74 read value
    csrr x14, 0xc74

    #Address 0xc74 read value
    csrr x14, 0xc74

    #Address 0xc74 read value
    csrr x14, 0xc74

    #Address 0xc74 Write value 0x7351ae31
    li x3, 0x7351ae31
    csrw 0xc74, x3

    #Address 0xc74 Write value 0x269c9f53
    li x3, 0x269c9f53
    csrw 0xc74, x3

    #Unmapped address 0x987 testing: random write/read operations
    #Address 0x987 Write value 0x78ece85d
    li x3, 0x78ece85d
    csrw 0x987, x3

    #Address 0x987 Write value 0x2af6054d
    li x3, 0x2af6054d
    csrw 0x987, x3

    #Address 0x987 read value
    csrr x14, 0x987

    #Address 0x987 read value
    csrr x14, 0x987

    #Unmapped address 0xbb5 testing: random write/read operations
    #Address 0xbb5 read value
    csrr x14, 0xbb5

    #Unmapped address 0xf23 testing: random write/read operations
    #Address 0xf23 read value
    csrr x14, 0xf23

    #Address 0xf23 read value
    csrr x14, 0xf23

    #Address 0xf23 read value
    csrr x14, 0xf23

    #Unmapped address 0xed0 testing: random write/read operations
    #Address 0xed0 Write value 0x495310c1
    li x3, 0x495310c1
    csrw 0xed0, x3

    #Address 0xed0 Write value 0x512f3de3
    li x3, 0x512f3de3
    csrw 0xed0, x3

    #Address 0xed0 Write value 0x1cdb045e
    li x3, 0x1cdb045e
    csrw 0xed0, x3

    #Address 0xed0 read value
    csrr x14, 0xed0

    #Address 0xed0 Write value 0x83b8cc1c
    li x3, 0x83b8cc1c
    csrw 0xed0, x3

    #Unmapped address 0x4c6 testing: random write/read operations
    #Address 0x4c6 Write value 0x2e0518e9
    li x3, 0x2e0518e9
    csrw 0x4c6, x3

    #Address 0x4c6 read value
    csrr x14, 0x4c6

    #Address 0x4c6 Write value 0x99e3aefc
    li x3, 0x99e3aefc
    csrw 0x4c6, x3

    #Unmapped address 0x7a4 testing: random write/read operations
    #Address 0x7a4 Write value 0x9140a9ef
    li x3, 0x9140a9ef
    csrw 0x7a4, x3

    #Address 0x7a4 Write value 0x1030026c
    li x3, 0x1030026c
    csrw 0x7a4, x3

    #Unmapped address 0x657 testing: random write/read operations
    #Address 0x657 read value
    csrr x14, 0x657

    #Address 0x657 read value
    csrr x14, 0x657

    #Address 0x657 Write value 0xd544f0ee
    li x3, 0xd544f0ee
    csrw 0x657, x3

    #Unmapped address 0xde2 testing: random write/read operations
    #Address 0xde2 Write value 0x947c6193
    li x3, 0x947c6193
    csrw 0xde2, x3

    #Address 0xde2 Write value 0x6f2db6f4
    li x3, 0x6f2db6f4
    csrw 0xde2, x3

    #Address 0xde2 Write value 0x45bc3071
    li x3, 0x45bc3071
    csrw 0xde2, x3

    #Address 0xde2 read value
    csrr x14, 0xde2

    #Unmapped address 0x4ec testing: random write/read operations
    #Address 0x4ec read value
    csrr x14, 0x4ec

    #Address 0x4ec read value
    csrr x14, 0x4ec

    #Address 0x4ec Write value 0x767ce2ed
    li x3, 0x767ce2ed
    csrw 0x4ec, x3

    #Address 0x4ec Write value 0x3451e65
    li x3, 0x3451e65
    csrw 0x4ec, x3

    #Unmapped address 0x6fe testing: random write/read operations
    #Address 0x6fe read value
    csrr x14, 0x6fe

    #Address 0x6fe read value
    csrr x14, 0x6fe

    #Unmapped address 0xef1 testing: random write/read operations
    #Address 0xef1 Write value 0x3ca87032
    li x3, 0x3ca87032
    csrw 0xef1, x3

    #Unmapped address 0x73 testing: random write/read operations
    #Address 0x73 Write value 0x47b6ee33
    li x3, 0x47b6ee33
    csrw 0x73, x3

    #Address 0x73 read value
    csrr x14, 0x73

    #Address 0x73 read value
    csrr x14, 0x73

    #Unmapped address 0xa9b testing: random write/read operations
    #Address 0xa9b read value
    csrr x14, 0xa9b

    #Address 0xa9b read value
    csrr x14, 0xa9b

    #Unmapped address 0x9c2 testing: random write/read operations
    #Address 0x9c2 read value
    csrr x14, 0x9c2

    #Address 0x9c2 read value
    csrr x14, 0x9c2

    #Address 0x9c2 Write value 0xb461ecee
    li x3, 0xb461ecee
    csrw 0x9c2, x3

    #Unmapped address 0x711 testing: random write/read operations
    #Address 0x711 Write value 0xa1ca2b65
    li x3, 0xa1ca2b65
    csrw 0x711, x3

    #Address 0x711 read value
    csrr x14, 0x711

    #Address 0x711 Write value 0x712e7fc0
    li x3, 0x712e7fc0
    csrw 0x711, x3

    #Unmapped address 0xbc2 testing: random write/read operations
    #Address 0xbc2 Write value 0x413c45cd
    li x3, 0x413c45cd
    csrw 0xbc2, x3

    #Address 0xbc2 read value
    csrr x14, 0xbc2

    #Unmapped address 0xe5e testing: random write/read operations
    #Address 0xe5e Write value 0xdc90696d
    li x3, 0xdc90696d
    csrw 0xe5e, x3

    #Unmapped address 0x348 testing: random write/read operations
    #Address 0x348 read value
    csrr x14, 0x348

    #Address 0x348 Write value 0x372a046c
    li x3, 0x372a046c
    csrw 0x348, x3

    #Unmapped address 0x9c5 testing: random write/read operations
    #Address 0x9c5 read value
    csrr x14, 0x9c5

    #Address 0x9c5 Write value 0x27275672
    li x3, 0x27275672
    csrw 0x9c5, x3

    #Address 0x9c5 Write value 0x9d60e64c
    li x3, 0x9d60e64c
    csrw 0x9c5, x3

    #Address 0x9c5 Write value 0xd1202328
    li x3, 0xd1202328
    csrw 0x9c5, x3

    #Unmapped address 0xd51 testing: random write/read operations
    #Address 0xd51 read value
    csrr x14, 0xd51

    #Address 0xd51 Write value 0x9badee96
    li x3, 0x9badee96
    csrw 0xd51, x3

    #Address 0xd51 read value
    csrr x14, 0xd51

    #Address 0xd51 read value
    csrr x14, 0xd51

    #Address 0xd51 Write value 0x1291b51f
    li x3, 0x1291b51f
    csrw 0xd51, x3

    #Unmapped address 0x874 testing: random write/read operations
    #Address 0x874 Write value 0xea846924
    li x3, 0xea846924
    csrw 0x874, x3

    #Address 0x874 read value
    csrr x14, 0x874

    #Address 0x874 Write value 0xae87c33
    li x3, 0xae87c33
    csrw 0x874, x3

    #Unmapped address 0x83a testing: random write/read operations
    #Address 0x83a read value
    csrr x14, 0x83a

    #Address 0x83a Write value 0xdb6447f6
    li x3, 0xdb6447f6
    csrw 0x83a, x3

    #Unmapped address 0x57c testing: random write/read operations
    #Address 0x57c Write value 0x78828a94
    li x3, 0x78828a94
    csrw 0x57c, x3

    #Unmapped address 0xe2b testing: random write/read operations
    #Address 0xe2b read value
    csrr x14, 0xe2b

    #Address 0xe2b read value
    csrr x14, 0xe2b

    #Address 0xe2b read value
    csrr x14, 0xe2b

    #Unmapped address 0xda3 testing: random write/read operations
    #Address 0xda3 read value
    csrr x14, 0xda3

    #Address 0xda3 Write value 0xdbda23db
    li x3, 0xdbda23db
    csrw 0xda3, x3

    #Address 0xda3 read value
    csrr x14, 0xda3

    #Address 0xda3 read value
    csrr x14, 0xda3

    #Unmapped address 0x7c3 testing: random write/read operations
    #Address 0x7c3 Write value 0xe6b3023c
    li x3, 0xe6b3023c
    csrw 0x7c3, x3

    #Unmapped address 0xd7f testing: random write/read operations
    #Address 0xd7f read value
    csrr x14, 0xd7f

    #Address 0xd7f read value
    csrr x14, 0xd7f

    #Unmapped address 0x8e testing: random write/read operations
    #Address 0x8e read value
    csrr x14, 0x8e

    #Address 0x8e Write value 0x84a73d9f
    li x3, 0x84a73d9f
    csrw 0x8e, x3

    #Address 0x8e Write value 0x731a6b08
    li x3, 0x731a6b08
    csrw 0x8e, x3

    #Address 0x8e Write value 0x546a8188
    li x3, 0x546a8188
    csrw 0x8e, x3

    #Address 0x8e Write value 0x82fddb28
    li x3, 0x82fddb28
    csrw 0x8e, x3

    #Unmapped address 0xfee testing: random write/read operations
    #Address 0xfee read value
    csrr x14, 0xfee

    #Address 0xfee Write value 0x5b7120f4
    li x3, 0x5b7120f4
    csrw 0xfee, x3

    #Address 0xfee Write value 0x90310c9d
    li x3, 0x90310c9d
    csrw 0xfee, x3

    #Unmapped address 0x6d4 testing: random write/read operations
    #Address 0x6d4 read value
    csrr x14, 0x6d4

    #Address 0x6d4 read value
    csrr x14, 0x6d4

    #Unmapped address 0xa52 testing: random write/read operations
    #Address 0xa52 read value
    csrr x14, 0xa52

    #Address 0xa52 Write value 0x7435602
    li x3, 0x7435602
    csrw 0xa52, x3

    #Address 0xa52 Write value 0x51e0c9ed
    li x3, 0x51e0c9ed
    csrw 0xa52, x3

    #Address 0xa52 read value
    csrr x14, 0xa52

    #Address 0xa52 Write value 0x15d2e03
    li x3, 0x15d2e03
    csrw 0xa52, x3

    #Unmapped address 0x2e3 testing: random write/read operations
    #Address 0x2e3 Write value 0x9f70cf82
    li x3, 0x9f70cf82
    csrw 0x2e3, x3

    #Address 0x2e3 Write value 0x7ee4534f
    li x3, 0x7ee4534f
    csrw 0x2e3, x3

    #Unmapped address 0xace testing: random write/read operations
    #Address 0xace Write value 0x4d7e8ecd
    li x3, 0x4d7e8ecd
    csrw 0xace, x3

    #Unmapped address 0x74e testing: random write/read operations
    #Address 0x74e Write value 0xb19b1a90
    li x3, 0xb19b1a90
    csrw 0x74e, x3

    #Address 0x74e Write value 0xe163cf17
    li x3, 0xe163cf17
    csrw 0x74e, x3

    #Address 0x74e read value
    csrr x14, 0x74e

    #Unmapped address 0x544 testing: random write/read operations
    #Address 0x544 read value
    csrr x14, 0x544

    #Address 0x544 Write value 0x446d8ecf
    li x3, 0x446d8ecf
    csrw 0x544, x3

    #Unmapped address 0x961 testing: random write/read operations
    #Address 0x961 read value
    csrr x14, 0x961

    #Address 0x961 Write value 0xa51900be
    li x3, 0xa51900be
    csrw 0x961, x3

    #Unmapped address 0x617 testing: random write/read operations
    #Address 0x617 read value
    csrr x14, 0x617

    #Address 0x617 read value
    csrr x14, 0x617

    #Address 0x617 Write value 0x9a354766
    li x3, 0x9a354766
    csrw 0x617, x3

    #Address 0x617 read value
    csrr x14, 0x617

    #Unmapped address 0xe16 testing: random write/read operations
    #Address 0xe16 read value
    csrr x14, 0xe16

    #Unmapped address 0x3e1 testing: random write/read operations
    #Address 0x3e1 read value
    csrr x14, 0x3e1

    #Address 0x3e1 read value
    csrr x14, 0x3e1

    #Unmapped address 0xf07 testing: random write/read operations
    #Address 0xf07 Write value 0x453a0ff4
    li x3, 0x453a0ff4
    csrw 0xf07, x3

    #Unmapped address 0xca0 testing: random write/read operations
    #Address 0xca0 Write value 0x685fe182
    li x3, 0x685fe182
    csrw 0xca0, x3

    #Unmapped address 0xb58 testing: random write/read operations
    #Address 0xb58 Write value 0xf3fdb140
    li x3, 0xf3fdb140
    csrw 0xb58, x3

    #Address 0xb58 read value
    csrr x14, 0xb58

    #Address 0xb58 read value
    csrr x14, 0xb58

    #Address 0xb58 Write value 0x9bc6a26
    li x3, 0x9bc6a26
    csrw 0xb58, x3

    #Unmapped address 0xadf testing: random write/read operations
    #Address 0xadf Write value 0xca388559
    li x3, 0xca388559
    csrw 0xadf, x3

    #Address 0xadf read value
    csrr x14, 0xadf

    #Address 0xadf Write value 0x3cb3dd7d
    li x3, 0x3cb3dd7d
    csrw 0xadf, x3

    #Address 0xadf Write value 0xcf18e16d
    li x3, 0xcf18e16d
    csrw 0xadf, x3

    #Address 0xadf read value
    csrr x14, 0xadf

    #Unmapped address 0x8c7 testing: random write/read operations
    #Address 0x8c7 Write value 0x63a8a004
    li x3, 0x63a8a004
    csrw 0x8c7, x3

    #Address 0x8c7 read value
    csrr x14, 0x8c7

    #Address 0x8c7 Write value 0xe693c117
    li x3, 0xe693c117
    csrw 0x8c7, x3

    #Address 0x8c7 read value
    csrr x14, 0x8c7

    #Address 0x8c7 read value
    csrr x14, 0x8c7

    #Unmapped address 0xf45 testing: random write/read operations
    #Address 0xf45 read value
    csrr x14, 0xf45

    #Unmapped address 0x44b testing: random write/read operations
    #Address 0x44b Write value 0xa77cfdcc
    li x3, 0xa77cfdcc
    csrw 0x44b, x3

    #Address 0x44b read value
    csrr x14, 0x44b

    #Address 0x44b read value
    csrr x14, 0x44b

    #Unmapped address 0x7e2 testing: random write/read operations
    #Address 0x7e2 Write value 0x1eb2e30c
    li x3, 0x1eb2e30c
    csrw 0x7e2, x3

    #Address 0x7e2 read value
    csrr x14, 0x7e2

    #Address 0x7e2 Write value 0x668a75f1
    li x3, 0x668a75f1
    csrw 0x7e2, x3

    #Address 0x7e2 Write value 0xf0deeb1c
    li x3, 0xf0deeb1c
    csrw 0x7e2, x3

    #Address 0x7e2 Write value 0x2dfbb9bb
    li x3, 0x2dfbb9bb
    csrw 0x7e2, x3

    #Unmapped address 0xfa2 testing: random write/read operations
    #Address 0xfa2 Write value 0xd457ddf4
    li x3, 0xd457ddf4
    csrw 0xfa2, x3

    #Address 0xfa2 read value
    csrr x14, 0xfa2

    #Unmapped address 0x978 testing: random write/read operations
    #Address 0x978 read value
    csrr x14, 0x978

    #Address 0x978 read value
    csrr x14, 0x978

    #Address 0x978 Write value 0x98b2a329
    li x3, 0x98b2a329
    csrw 0x978, x3

    #Address 0x978 read value
    csrr x14, 0x978

    #Address 0x978 Write value 0x9e3a1d0f
    li x3, 0x9e3a1d0f
    csrw 0x978, x3

    #Unmapped address 0x954 testing: random write/read operations
    #Address 0x954 Write value 0x5be99ec
    li x3, 0x5be99ec
    csrw 0x954, x3

    #Address 0x954 read value
    csrr x14, 0x954

    #Address 0x954 Write value 0x879d957d
    li x3, 0x879d957d
    csrw 0x954, x3

    #Unmapped address 0x79f testing: random write/read operations
    #Address 0x79f read value
    csrr x14, 0x79f

    #Address 0x79f Write value 0x25f43e30
    li x3, 0x25f43e30
    csrw 0x79f, x3

    #Address 0x79f read value
    csrr x14, 0x79f

    #Address 0x79f Write value 0x86a79af2
    li x3, 0x86a79af2
    csrw 0x79f, x3

    #Unmapped address 0x7d4 testing: random write/read operations
    #Address 0x7d4 Write value 0xf17a8dfc
    li x3, 0xf17a8dfc
    csrw 0x7d4, x3

    #Address 0x7d4 Write value 0xe2c2324f
    li x3, 0xe2c2324f
    csrw 0x7d4, x3

    #Address 0x7d4 read value
    csrr x14, 0x7d4

    #Unmapped address 0xffa testing: random write/read operations
    #Address 0xffa Write value 0xc199eae5
    li x3, 0xc199eae5
    csrw 0xffa, x3

    #Address 0xffa Write value 0x3b2cbf27
    li x3, 0x3b2cbf27
    csrw 0xffa, x3

    #Address 0xffa read value
    csrr x14, 0xffa

    #Address 0xffa Write value 0xfbf1f309
    li x3, 0xfbf1f309
    csrw 0xffa, x3

    #Address 0xffa read value
    csrr x14, 0xffa

    #Unmapped address 0x4fe testing: random write/read operations
    #Address 0x4fe Write value 0xcfcb11c1
    li x3, 0xcfcb11c1
    csrw 0x4fe, x3

    #Unmapped address 0xe46 testing: random write/read operations
    #Address 0xe46 Write value 0xcec9d7e3
    li x3, 0xcec9d7e3
    csrw 0xe46, x3

    #Mapped address 0x334 (mhpmevent20) testing: random write/read operations
    #Address 0x334 read value
    csrr x14, 0x334

    #Address 0x334 Write value 0x92d62590
    li x3, 0x92d62590
    csrw 0x334, x3

    #Address 0x334 Write value 0xad4d331
    li x3, 0xad4d331
    csrw 0x334, x3

    #Address 0x334 read value
    csrr x14, 0x334

    #Unmapped address 0x863 testing: random write/read operations
    #Address 0x863 read value
    csrr x14, 0x863

    #Address 0x863 read value
    csrr x14, 0x863

    #Address 0x863 Write value 0xfdd320fb
    li x3, 0xfdd320fb
    csrw 0x863, x3

    #Address 0x863 Write value 0x5a5fe965
    li x3, 0x5a5fe965
    csrw 0x863, x3

    #Unmapped address 0xee2 testing: random write/read operations
    #Address 0xee2 Write value 0xf1ae226c
    li x3, 0xf1ae226c
    csrw 0xee2, x3

    #Address 0xee2 read value
    csrr x14, 0xee2

    #Address 0xee2 read value
    csrr x14, 0xee2

    #Unmapped address 0xfd0 testing: random write/read operations
    #Address 0xfd0 Write value 0x227191ef
    li x3, 0x227191ef
    csrw 0xfd0, x3

    #Address 0xfd0 Write value 0x76a17e37
    li x3, 0x76a17e37
    csrw 0xfd0, x3

    #Unmapped address 0x609 testing: random write/read operations
    #Address 0x609 Write value 0x364cd460
    li x3, 0x364cd460
    csrw 0x609, x3

    #Address 0x609 read value
    csrr x14, 0x609

    #Unmapped address 0x66 testing: random write/read operations
    #Address 0x66 Write value 0xeb75914b
    li x3, 0xeb75914b
    csrw 0x66, x3

    #Address 0x66 Write value 0xb98357f7
    li x3, 0xb98357f7
    csrw 0x66, x3

    #Unmapped address 0x7f3 testing: random write/read operations
    #Address 0x7f3 Write value 0x69fb52e4
    li x3, 0x69fb52e4
    csrw 0x7f3, x3

    #Address 0x7f3 read value
    csrr x14, 0x7f3

    #Address 0x7f3 Write value 0xa104f35a
    li x3, 0xa104f35a
    csrw 0x7f3, x3

    #Address 0x7f3 Write value 0xb1224c20
    li x3, 0xb1224c20
    csrw 0x7f3, x3

    #Unmapped address 0xa34 testing: random write/read operations
    #Address 0xa34 Write value 0x124cb4ae
    li x3, 0x124cb4ae
    csrw 0xa34, x3

    #Address 0xa34 read value
    csrr x14, 0xa34

    #Unmapped address 0x74a testing: random write/read operations
    #Address 0x74a Write value 0x8c671245
    li x3, 0x8c671245
    csrw 0x74a, x3

    #Address 0x74a read value
    csrr x14, 0x74a

    #Address 0x74a read value
    csrr x14, 0x74a

    #Unmapped address 0x3a6 testing: random write/read operations
    #Address 0x3a6 read value
    csrr x14, 0x3a6

    #Address 0x3a6 read value
    csrr x14, 0x3a6

    #Address 0x3a6 read value
    csrr x14, 0x3a6

    #Unmapped address 0x556 testing: random write/read operations
    #Address 0x556 read value
    csrr x14, 0x556

    #Address 0x556 read value
    csrr x14, 0x556

    #Address 0x556 Write value 0x849da672
    li x3, 0x849da672
    csrw 0x556, x3

    #Unmapped address 0x7c7 testing: random write/read operations
    #Address 0x7c7 read value
    csrr x14, 0x7c7

    #Address 0x7c7 read value
    csrr x14, 0x7c7

    #Address 0x7c7 read value
    csrr x14, 0x7c7

    #Address 0x7c7 Write value 0xfb7d10db
    li x3, 0xfb7d10db
    csrw 0x7c7, x3

    #Unmapped address 0x6c8 testing: random write/read operations
    #Address 0x6c8 read value
    csrr x14, 0x6c8

    #Address 0x6c8 Write value 0xfef965f
    li x3, 0xfef965f
    csrw 0x6c8, x3

    #Address 0x6c8 read value
    csrr x14, 0x6c8

    #Address 0x6c8 read value
    csrr x14, 0x6c8

    #Address 0x6c8 read value
    csrr x14, 0x6c8

    #Unmapped address 0xfa8 testing: random write/read operations
    #Address 0xfa8 read value
    csrr x14, 0xfa8

    #Address 0xfa8 read value
    csrr x14, 0xfa8

    #Address 0xfa8 read value
    csrr x14, 0xfa8

    #Unmapped address 0xbb1 testing: random write/read operations
    #Address 0xbb1 Write value 0xf73d82f5
    li x3, 0xf73d82f5
    csrw 0xbb1, x3

    #Address 0xbb1 read value
    csrr x14, 0xbb1

    #Unmapped address 0x1e2 testing: random write/read operations
    #Address 0x1e2 read value
    csrr x14, 0x1e2

    #Address 0x1e2 Write value 0xe424ee47
    li x3, 0xe424ee47
    csrw 0x1e2, x3

    #Address 0x1e2 Write value 0xda89eb34
    li x3, 0xda89eb34
    csrw 0x1e2, x3

    #Unmapped address 0xdc6 testing: random write/read operations
    #Address 0xdc6 read value
    csrr x14, 0xdc6

    #Unmapped address 0x58f testing: random write/read operations
    #Address 0x58f read value
    csrr x14, 0x58f

    #Address 0x58f Write value 0x307ed83
    li x3, 0x307ed83
    csrw 0x58f, x3

    #Address 0x58f Write value 0xf8f57572
    li x3, 0xf8f57572
    csrw 0x58f, x3

    #Address 0x58f Write value 0x99a00244
    li x3, 0x99a00244
    csrw 0x58f, x3

    #Unmapped address 0xa72 testing: random write/read operations
    #Address 0xa72 Write value 0x74ca8907
    li x3, 0x74ca8907
    csrw 0xa72, x3

    #Address 0xa72 read value
    csrr x14, 0xa72

    #Address 0xa72 Write value 0xb6483fe4
    li x3, 0xb6483fe4
    csrw 0xa72, x3

    #Address 0xa72 read value
    csrr x14, 0xa72

    #Address 0xa72 read value
    csrr x14, 0xa72

    #Unmapped address 0xc73 testing: random write/read operations
    #Address 0xc73 read value
    csrr x14, 0xc73

    #Address 0xc73 read value
    csrr x14, 0xc73

    #Address 0xc73 read value
    csrr x14, 0xc73

    #Address 0xc73 Write value 0x6956f110
    li x3, 0x6956f110
    csrw 0xc73, x3

    #Address 0xc73 Write value 0x254dc524
    li x3, 0x254dc524
    csrw 0xc73, x3

    #Unmapped address 0x92e testing: random write/read operations
    #Address 0x92e Write value 0xe295d622
    li x3, 0xe295d622
    csrw 0x92e, x3

    #Unmapped address 0x219 testing: random write/read operations
    #Address 0x219 read value
    csrr x14, 0x219

    #Address 0x219 read value
    csrr x14, 0x219

    #Address 0x219 read value
    csrr x14, 0x219

    #Address 0x219 read value
    csrr x14, 0x219

    #Address 0x219 read value
    csrr x14, 0x219

    #Unmapped address 0x5f0 testing: random write/read operations
    #Address 0x5f0 Write value 0xf435c8b4
    li x3, 0xf435c8b4
    csrw 0x5f0, x3

    #Address 0x5f0 read value
    csrr x14, 0x5f0

    #Unmapped address 0x1ea testing: random write/read operations
    #Address 0x1ea Write value 0x444af09f
    li x3, 0x444af09f
    csrw 0x1ea, x3

    #Address 0x1ea read value
    csrr x14, 0x1ea

    #Address 0x1ea Write value 0xee120336
    li x3, 0xee120336
    csrw 0x1ea, x3

    #Unmapped address 0x7bb testing: random write/read operations
    #Address 0x7bb read value
    csrr x14, 0x7bb

    #Address 0x7bb read value
    csrr x14, 0x7bb

    #Address 0x7bb Write value 0x644709f7
    li x3, 0x644709f7
    csrw 0x7bb, x3

    #Unmapped address 0xe5a testing: random write/read operations
    #Address 0xe5a Write value 0x1627b100
    li x3, 0x1627b100
    csrw 0xe5a, x3

    #Address 0xe5a Write value 0xf772cf53
    li x3, 0xf772cf53
    csrw 0xe5a, x3

    #Address 0xe5a read value
    csrr x14, 0xe5a

    #Address 0xe5a Write value 0xa0daa0e4
    li x3, 0xa0daa0e4
    csrw 0xe5a, x3

    #Address 0xe5a Write value 0x3cb0bb9b
    li x3, 0x3cb0bb9b
    csrw 0xe5a, x3

    #Unmapped address 0x2a4 testing: random write/read operations
    #Address 0x2a4 Write value 0x7b9475ed
    li x3, 0x7b9475ed
    csrw 0x2a4, x3

    #Address 0x2a4 Write value 0xc55d6561
    li x3, 0xc55d6561
    csrw 0x2a4, x3

    #Address 0x2a4 read value
    csrr x14, 0x2a4

    #Address 0x2a4 Write value 0x373005fd
    li x3, 0x373005fd
    csrw 0x2a4, x3

    #Address 0x2a4 Write value 0xfd66caec
    li x3, 0xfd66caec
    csrw 0x2a4, x3

    #Unmapped address 0x25c testing: random write/read operations
    #Address 0x25c read value
    csrr x14, 0x25c

    #Unmapped address 0x173 testing: random write/read operations
    #Address 0x173 Write value 0x6392e7f3
    li x3, 0x6392e7f3
    csrw 0x173, x3

    #Address 0x173 Write value 0x9248c666
    li x3, 0x9248c666
    csrw 0x173, x3

    #Address 0x173 read value
    csrr x14, 0x173

    #Unmapped address 0x47c testing: random write/read operations
    #Address 0x47c read value
    csrr x14, 0x47c

    #Address 0x47c read value
    csrr x14, 0x47c

    #Address 0x47c read value
    csrr x14, 0x47c

    #Address 0x47c Write value 0x19d6ee1c
    li x3, 0x19d6ee1c
    csrw 0x47c, x3

    #Unmapped address 0x3f2 testing: random write/read operations
    #Address 0x3f2 read value
    csrr x14, 0x3f2

    #Address 0x3f2 Write value 0x62ea94a
    li x3, 0x62ea94a
    csrw 0x3f2, x3

    #Address 0x3f2 Write value 0x41455ed
    li x3, 0x41455ed
    csrw 0x3f2, x3

    #Address 0x3f2 read value
    csrr x14, 0x3f2

    #Unmapped address 0x2cc testing: random write/read operations
    #Address 0x2cc Write value 0xa510457a
    li x3, 0xa510457a
    csrw 0x2cc, x3

    #Address 0x2cc read value
    csrr x14, 0x2cc

    #Address 0x2cc read value
    csrr x14, 0x2cc

    #Address 0x2cc Write value 0x98fac2a6
    li x3, 0x98fac2a6
    csrw 0x2cc, x3

    #Unmapped address 0x11a testing: random write/read operations
    #Address 0x11a Write value 0x59753e10
    li x3, 0x59753e10
    csrw 0x11a, x3

    #Unmapped address 0x515 testing: random write/read operations
    #Address 0x515 Write value 0xf5dbb15
    li x3, 0xf5dbb15
    csrw 0x515, x3

    #Address 0x515 Write value 0x5f57793a
    li x3, 0x5f57793a
    csrw 0x515, x3

    #Address 0x515 Write value 0x84e27879
    li x3, 0x84e27879
    csrw 0x515, x3

    #Address 0x515 read value
    csrr x14, 0x515

    #Address 0x515 read value
    csrr x14, 0x515

    #Unmapped address 0x708 testing: random write/read operations
    #Address 0x708 read value
    csrr x14, 0x708

    #Address 0x708 Write value 0x932e6104
    li x3, 0x932e6104
    csrw 0x708, x3

    #Address 0x708 Write value 0x81e5132f
    li x3, 0x81e5132f
    csrw 0x708, x3

    #Address 0x708 read value
    csrr x14, 0x708

    #Address 0x708 read value
    csrr x14, 0x708

    #Unmapped address 0xa12 testing: random write/read operations
    #Address 0xa12 read value
    csrr x14, 0xa12

    #Address 0xa12 Write value 0x4ab4382c
    li x3, 0x4ab4382c
    csrw 0xa12, x3

    #Address 0xa12 read value
    csrr x14, 0xa12

    #Address 0xa12 read value
    csrr x14, 0xa12

    #Unmapped address 0xa30 testing: random write/read operations
    #Address 0xa30 read value
    csrr x14, 0xa30

    #Address 0xa30 read value
    csrr x14, 0xa30

    #Unmapped address 0x1b8 testing: random write/read operations
    #Address 0x1b8 Write value 0x26908daf
    li x3, 0x26908daf
    csrw 0x1b8, x3

    #Address 0x1b8 read value
    csrr x14, 0x1b8

    #Address 0x1b8 Write value 0x4830fc27
    li x3, 0x4830fc27
    csrw 0x1b8, x3

    #Address 0x1b8 Write value 0x46320650
    li x3, 0x46320650
    csrw 0x1b8, x3

    #Address 0x1b8 Write value 0x5ed152d3
    li x3, 0x5ed152d3
    csrw 0x1b8, x3

    #Unmapped address 0xe45 testing: random write/read operations
    #Address 0xe45 Write value 0x5cdfca49
    li x3, 0x5cdfca49
    csrw 0xe45, x3

    #Address 0xe45 read value
    csrr x14, 0xe45

    #Address 0xe45 Write value 0x957cdf57
    li x3, 0x957cdf57
    csrw 0xe45, x3

    #Address 0xe45 Write value 0x636fd4f9
    li x3, 0x636fd4f9
    csrw 0xe45, x3

    #Unmapped address 0x969 testing: random write/read operations
    #Address 0x969 Write value 0x8dab7341
    li x3, 0x8dab7341
    csrw 0x969, x3

    #Unmapped address 0x639 testing: random write/read operations
    #Address 0x639 Write value 0xb0c8b6b9
    li x3, 0xb0c8b6b9
    csrw 0x639, x3

    #Address 0x639 Write value 0xe3a438d2
    li x3, 0xe3a438d2
    csrw 0x639, x3

    #Address 0x639 read value
    csrr x14, 0x639

    #Address 0x639 read value
    csrr x14, 0x639

    #Address 0x639 Write value 0x8862c1bb
    li x3, 0x8862c1bb
    csrw 0x639, x3

    #Unmapped address 0x5fa testing: random write/read operations
    #Address 0x5fa read value
    csrr x14, 0x5fa

    #Unmapped address 0xde4 testing: random write/read operations
    #Address 0xde4 read value
    csrr x14, 0xde4

    #Address 0xde4 read value
    csrr x14, 0xde4

    #Address 0xde4 Write value 0xaff68e2e
    li x3, 0xaff68e2e
    csrw 0xde4, x3

    #Unmapped address 0xe3d testing: random write/read operations
    #Address 0xe3d read value
    csrr x14, 0xe3d

    #Address 0xe3d Write value 0x1b39dfaf
    li x3, 0x1b39dfaf
    csrw 0xe3d, x3

    #Address 0xe3d Write value 0x97a8c82
    li x3, 0x97a8c82
    csrw 0xe3d, x3

    #Unmapped address 0xa29 testing: random write/read operations
    #Address 0xa29 Write value 0xd91a38c4
    li x3, 0xd91a38c4
    csrw 0xa29, x3

    #Address 0xa29 Write value 0xdf6d8ecb
    li x3, 0xdf6d8ecb
    csrw 0xa29, x3

    #Address 0xa29 Write value 0x4fd274c5
    li x3, 0x4fd274c5
    csrw 0xa29, x3

    #Address 0xa29 read value
    csrr x14, 0xa29

    #Address 0xa29 read value
    csrr x14, 0xa29

    #Unmapped address 0x849 testing: random write/read operations
    #Address 0x849 Write value 0xeb7224a1
    li x3, 0xeb7224a1
    csrw 0x849, x3

    #Address 0x849 Write value 0xde3472bc
    li x3, 0xde3472bc
    csrw 0x849, x3

    #Address 0x849 Write value 0x4dc144c8
    li x3, 0x4dc144c8
    csrw 0x849, x3

    #Address 0x849 read value
    csrr x14, 0x849

    #Address 0x849 Write value 0x78a6fe8c
    li x3, 0x78a6fe8c
    csrw 0x849, x3

    #Unmapped address 0x8f0 testing: random write/read operations
    #Address 0x8f0 Write value 0x69775342
    li x3, 0x69775342
    csrw 0x8f0, x3

    #Address 0x8f0 read value
    csrr x14, 0x8f0

    #Address 0x8f0 read value
    csrr x14, 0x8f0

    #Address 0x8f0 read value
    csrr x14, 0x8f0

    #Unmapped address 0xe62 testing: random write/read operations
    #Address 0xe62 Write value 0x89ac4d3a
    li x3, 0x89ac4d3a
    csrw 0xe62, x3

    #Unmapped address 0x1ff testing: random write/read operations
    #Address 0x1ff read value
    csrr x14, 0x1ff

    #Address 0x1ff read value
    csrr x14, 0x1ff

    #Address 0x1ff Write value 0x55b11d57
    li x3, 0x55b11d57
    csrw 0x1ff, x3

    #Address 0x1ff Write value 0x49e94921
    li x3, 0x49e94921
    csrw 0x1ff, x3

    #Address 0x1ff Write value 0xe07b8b2a
    li x3, 0xe07b8b2a
    csrw 0x1ff, x3

    #Unmapped address 0xac8 testing: random write/read operations
    #Address 0xac8 Write value 0xa1147c16
    li x3, 0xa1147c16
    csrw 0xac8, x3

    #Unmapped address 0xc1c testing: random write/read operations
    #Address 0xc1c Write value 0xf6ceab6f
    li x3, 0xf6ceab6f
    csrw 0xc1c, x3

    #Unmapped address 0xa13 testing: random write/read operations
    #Address 0xa13 read value
    csrr x14, 0xa13

    #Address 0xa13 read value
    csrr x14, 0xa13

    #Unmapped address 0xab0 testing: random write/read operations
    #Address 0xab0 Write value 0x5d0684da
    li x3, 0x5d0684da
    csrw 0xab0, x3

    #Unmapped address 0xf31 testing: random write/read operations
    #Address 0xf31 read value
    csrr x14, 0xf31

    #Address 0xf31 read value
    csrr x14, 0xf31

    #Address 0xf31 read value
    csrr x14, 0xf31

    #Address 0xf31 read value
    csrr x14, 0xf31

    #Address 0xf31 read value
    csrr x14, 0xf31

    #Unmapped address 0x6c7 testing: random write/read operations
    #Address 0x6c7 Write value 0x14033856
    li x3, 0x14033856
    csrw 0x6c7, x3

    #Address 0x6c7 Write value 0xd962849a
    li x3, 0xd962849a
    csrw 0x6c7, x3

    #Unmapped address 0x34f testing: random write/read operations
    #Address 0x34f read value
    csrr x14, 0x34f

    #Address 0x34f Write value 0xb842211
    li x3, 0xb842211
    csrw 0x34f, x3

    #Address 0x34f Write value 0x93b9dba5
    li x3, 0x93b9dba5
    csrw 0x34f, x3

    #Address 0x34f Write value 0x5a173345
    li x3, 0x5a173345
    csrw 0x34f, x3

    #Unmapped address 0xfce testing: random write/read operations
    #Address 0xfce read value
    csrr x14, 0xfce

    #Address 0xfce read value
    csrr x14, 0xfce

    #Address 0xfce Write value 0x8f1a1f4d
    li x3, 0x8f1a1f4d
    csrw 0xfce, x3

    #Unmapped address 0x663 testing: random write/read operations
    #Address 0x663 Write value 0x344eb0ac
    li x3, 0x344eb0ac
    csrw 0x663, x3

    #Address 0x663 Write value 0xf34985c7
    li x3, 0xf34985c7
    csrw 0x663, x3

    #Address 0x663 read value
    csrr x14, 0x663

    #Unmapped address 0xe12 testing: random write/read operations
    #Address 0xe12 read value
    csrr x14, 0xe12

    #Address 0xe12 read value
    csrr x14, 0xe12

    #Address 0xe12 Write value 0x1a86b02a
    li x3, 0x1a86b02a
    csrw 0xe12, x3

    #Address 0xe12 Write value 0xddc90415
    li x3, 0xddc90415
    csrw 0xe12, x3

    #Address 0xe12 read value
    csrr x14, 0xe12

    #Unmapped address 0x4c3 testing: random write/read operations
    #Address 0x4c3 Write value 0xe163b432
    li x3, 0xe163b432
    csrw 0x4c3, x3

    #Address 0x4c3 read value
    csrr x14, 0x4c3

    #Address 0x4c3 Write value 0x51488445
    li x3, 0x51488445
    csrw 0x4c3, x3

    #Address 0x4c3 read value
    csrr x14, 0x4c3

    #Unmapped address 0x308 testing: random write/read operations
    #Address 0x308 Write value 0x82f8b4f0
    li x3, 0x82f8b4f0
    csrw 0x308, x3

    #Address 0x308 Write value 0xcfe891d8
    li x3, 0xcfe891d8
    csrw 0x308, x3

    #Unmapped address 0xd84 testing: random write/read operations
    #Address 0xd84 Write value 0xf1946d9f
    li x3, 0xf1946d9f
    csrw 0xd84, x3

    #Address 0xd84 read value
    csrr x14, 0xd84

    #Address 0xd84 Write value 0xb090ba63
    li x3, 0xb090ba63
    csrw 0xd84, x3

    #Address 0xd84 read value
    csrr x14, 0xd84

    #Unmapped address 0x85c testing: random write/read operations
    #Address 0x85c read value
    csrr x14, 0x85c

    #Address 0x85c Write value 0x5edaaf11
    li x3, 0x5edaaf11
    csrw 0x85c, x3

    #Address 0x85c Write value 0xb09ddf27
    li x3, 0xb09ddf27
    csrw 0x85c, x3

    #Mapped address 0xb1c (mhpmcounter28) testing: random write/read operations
    #Address 0xb1c Write value 0x97e1ef14
    li x3, 0x97e1ef14
    csrw 0xb1c, x3

    #Address 0xb1c read value
    csrr x14, 0xb1c

    #Unmapped address 0x1cf testing: random write/read operations
    #Address 0x1cf Write value 0xef322aa1
    li x3, 0xef322aa1
    csrw 0x1cf, x3

    #Address 0x1cf read value
    csrr x14, 0x1cf

    #Address 0x1cf read value
    csrr x14, 0x1cf

    #Unmapped address 0x10e testing: random write/read operations
    #Address 0x10e Write value 0x452965a7
    li x3, 0x452965a7
    csrw 0x10e, x3

    #Address 0x10e read value
    csrr x14, 0x10e

    #Address 0x10e read value
    csrr x14, 0x10e

    #Unmapped address 0x31f testing: random write/read operations
    #Address 0x31f read value
    csrr x14, 0x31f

    #Unmapped address 0xd28 testing: random write/read operations
    #Address 0xd28 read value
    csrr x14, 0xd28

    #Mapped address 0x327 (mhpmevent7) testing: random write/read operations
    #Address 0x327 read value
    csrr x14, 0x327

    #Address 0x327 Write value 0xb0f0119a
    li x3, 0xb0f0119a
    csrw 0x327, x3

    #Unmapped address 0x552 testing: random write/read operations
    #Address 0x552 Write value 0xed6e0def
    li x3, 0xed6e0def
    csrw 0x552, x3

    #Address 0x552 Write value 0x9314e164
    li x3, 0x9314e164
    csrw 0x552, x3

    #Address 0x552 Write value 0x5492ca9e
    li x3, 0x5492ca9e
    csrw 0x552, x3

    #Address 0x552 Write value 0x1443c870
    li x3, 0x1443c870
    csrw 0x552, x3

    #Unmapped address 0xd7c testing: random write/read operations
    #Address 0xd7c read value
    csrr x14, 0xd7c

    #Address 0xd7c read value
    csrr x14, 0xd7c

    #Address 0xd7c read value
    csrr x14, 0xd7c

    #Address 0xd7c Write value 0x7af0119c
    li x3, 0x7af0119c
    csrw 0xd7c, x3

    #Address 0xd7c Write value 0x5a0dc924
    li x3, 0x5a0dc924
    csrw 0xd7c, x3

    #Unmapped address 0xb44 testing: random write/read operations
    #Address 0xb44 read value
    csrr x14, 0xb44

    #Address 0xb44 Write value 0x7c7b979b
    li x3, 0x7c7b979b
    csrw 0xb44, x3

    #Address 0xb44 Write value 0x8e850bbf
    li x3, 0x8e850bbf
    csrw 0xb44, x3

    #Unmapped address 0xe9f testing: random write/read operations
    #Address 0xe9f Write value 0x7ab51493
    li x3, 0x7ab51493
    csrw 0xe9f, x3

    #Address 0xe9f read value
    csrr x14, 0xe9f

    #Address 0xe9f Write value 0x10808302
    li x3, 0x10808302
    csrw 0xe9f, x3

    #Address 0xe9f Write value 0xf9a29a2b
    li x3, 0xf9a29a2b
    csrw 0xe9f, x3

    #Address 0xe9f read value
    csrr x14, 0xe9f

    #Unmapped address 0xa0b testing: random write/read operations
    #Address 0xa0b read value
    csrr x14, 0xa0b

    #Address 0xa0b read value
    csrr x14, 0xa0b

    #Address 0xa0b Write value 0x33548e89
    li x3, 0x33548e89
    csrw 0xa0b, x3

    #Unmapped address 0xcee testing: random write/read operations
    #Address 0xcee read value
    csrr x14, 0xcee

    #Address 0xcee read value
    csrr x14, 0xcee

    #Address 0xcee Write value 0xdc0f5bcf
    li x3, 0xdc0f5bcf
    csrw 0xcee, x3

    #Address 0xcee Write value 0x7495e534
    li x3, 0x7495e534
    csrw 0xcee, x3

    #Unmapped address 0x83e testing: random write/read operations
    #Address 0x83e Write value 0xe9eec2a5
    li x3, 0xe9eec2a5
    csrw 0x83e, x3

    #Unmapped address 0x429 testing: random write/read operations
    #Address 0x429 read value
    csrr x14, 0x429

    #Address 0x429 read value
    csrr x14, 0x429

    #Address 0x429 read value
    csrr x14, 0x429

    #Address 0x429 Write value 0xadd58c4c
    li x3, 0xadd58c4c
    csrw 0x429, x3

    #Address 0x429 read value
    csrr x14, 0x429

    #Unmapped address 0x118 testing: random write/read operations
    #Address 0x118 read value
    csrr x14, 0x118

    #Address 0x118 Write value 0x8f402235
    li x3, 0x8f402235
    csrw 0x118, x3

    #Address 0x118 read value
    csrr x14, 0x118

    #Address 0x118 read value
    csrr x14, 0x118

    #Address 0x118 Write value 0x20988add
    li x3, 0x20988add
    csrw 0x118, x3

    #Unmapped address 0xbe1 testing: random write/read operations
    #Address 0xbe1 read value
    csrr x14, 0xbe1

    #Address 0xbe1 read value
    csrr x14, 0xbe1

    #Address 0xbe1 Write value 0xba36f27f
    li x3, 0xba36f27f
    csrw 0xbe1, x3

    #Address 0xbe1 Write value 0x218ca82a
    li x3, 0x218ca82a
    csrw 0xbe1, x3

    #Address 0xbe1 Write value 0x49dbb8a2
    li x3, 0x49dbb8a2
    csrw 0xbe1, x3

    #Unmapped address 0x50e testing: random write/read operations
    #Address 0x50e Write value 0xb1edc8ab
    li x3, 0xb1edc8ab
    csrw 0x50e, x3

    #Address 0x50e read value
    csrr x14, 0x50e

    #Unmapped address 0x108 testing: random write/read operations
    #Address 0x108 read value
    csrr x14, 0x108

    #Address 0x108 read value
    csrr x14, 0x108

    #Address 0x108 read value
    csrr x14, 0x108

    #Address 0x108 read value
    csrr x14, 0x108

    #Unmapped address 0x95e testing: random write/read operations
    #Address 0x95e Write value 0x147b86a5
    li x3, 0x147b86a5
    csrw 0x95e, x3

    #Address 0x95e Write value 0x7e0821cc
    li x3, 0x7e0821cc
    csrw 0x95e, x3

    #Unmapped address 0x602 testing: random write/read operations
    #Address 0x602 Write value 0xc153897f
    li x3, 0xc153897f
    csrw 0x602, x3

    #Address 0x602 Write value 0x1da80882
    li x3, 0x1da80882
    csrw 0x602, x3

    #Address 0x602 Write value 0xa2dbcf0
    li x3, 0xa2dbcf0
    csrw 0x602, x3

    #Address 0x602 Write value 0x69c5401c
    li x3, 0x69c5401c
    csrw 0x602, x3

    #Address 0x602 read value
    csrr x14, 0x602

    #Unmapped address 0x539 testing: random write/read operations
    #Address 0x539 read value
    csrr x14, 0x539

    #Unmapped address 0xb33 testing: random write/read operations
    #Address 0xb33 read value
    csrr x14, 0xb33

    #Address 0xb33 read value
    csrr x14, 0xb33

    #Unmapped address 0x897 testing: random write/read operations
    #Address 0x897 read value
    csrr x14, 0x897

    #Address 0x897 read value
    csrr x14, 0x897

    #Address 0x897 read value
    csrr x14, 0x897

    #Unmapped address 0x8f9 testing: random write/read operations
    #Address 0x8f9 Write value 0x6de20080
    li x3, 0x6de20080
    csrw 0x8f9, x3

    #Address 0x8f9 read value
    csrr x14, 0x8f9

    #Unmapped address 0xfca testing: random write/read operations
    #Address 0xfca read value
    csrr x14, 0xfca

    #Address 0xfca Write value 0x3f55dfa9
    li x3, 0x3f55dfa9
    csrw 0xfca, x3

    #Unmapped address 0x75f testing: random write/read operations
    #Address 0x75f Write value 0x14349c07
    li x3, 0x14349c07
    csrw 0x75f, x3

    #Address 0x75f read value
    csrr x14, 0x75f

    #Unmapped address 0xfc7 testing: random write/read operations
    #Address 0xfc7 Write value 0x58ec9fac
    li x3, 0x58ec9fac
    csrw 0xfc7, x3

    #Address 0xfc7 Write value 0x246bfccb
    li x3, 0x246bfccb
    csrw 0xfc7, x3

    #Address 0xfc7 read value
    csrr x14, 0xfc7

    #Unmapped address 0xe9a testing: random write/read operations
    #Address 0xe9a Write value 0xceee2935
    li x3, 0xceee2935
    csrw 0xe9a, x3

    #Address 0xe9a read value
    csrr x14, 0xe9a

    #Address 0xe9a read value
    csrr x14, 0xe9a

    #Unmapped address 0xfdf testing: random write/read operations
    #Address 0xfdf Write value 0xc4bd35a7
    li x3, 0xc4bd35a7
    csrw 0xfdf, x3

    #Unmapped address 0x8ca testing: random write/read operations
    #Address 0x8ca read value
    csrr x14, 0x8ca

    #Address 0x8ca Write value 0xfa52f73
    li x3, 0xfa52f73
    csrw 0x8ca, x3

    #Address 0x8ca Write value 0x4f8a70fb
    li x3, 0x4f8a70fb
    csrw 0x8ca, x3

    #Unmapped address 0xc59 testing: random write/read operations
    #Address 0xc59 read value
    csrr x14, 0xc59

    #Address 0xc59 read value
    csrr x14, 0xc59

    #Address 0xc59 Write value 0x3b0c93a6
    li x3, 0x3b0c93a6
    csrw 0xc59, x3

    #Address 0xc59 Write value 0xf97dee25
    li x3, 0xf97dee25
    csrw 0xc59, x3

    #Address 0xc59 Write value 0xf072f302
    li x3, 0xf072f302
    csrw 0xc59, x3

    #Unmapped address 0xd61 testing: random write/read operations
    #Address 0xd61 read value
    csrr x14, 0xd61

    #Address 0xd61 read value
    csrr x14, 0xd61

    #Unmapped address 0x1e9 testing: random write/read operations
    #Address 0x1e9 read value
    csrr x14, 0x1e9

    #Address 0x1e9 read value
    csrr x14, 0x1e9

    #Mapped address 0xb04 (mhpmcounter4) testing: random write/read operations
    #Address 0xb04 read value
    csrr x14, 0xb04

    #Address 0xb04 read value
    csrr x14, 0xb04

    #Address 0xb04 Write value 0x62be9f69
    li x3, 0x62be9f69
    csrw 0xb04, x3

    #Unmapped address 0x817 testing: random write/read operations
    #Address 0x817 Write value 0x69ae6eb6
    li x3, 0x69ae6eb6
    csrw 0x817, x3

    #Address 0x817 read value
    csrr x14, 0x817

    #Address 0x817 Write value 0x7bf6d231
    li x3, 0x7bf6d231
    csrw 0x817, x3

    #Address 0x817 Write value 0x43cbf813
    li x3, 0x43cbf813
    csrw 0x817, x3

    #Address 0x817 read value
    csrr x14, 0x817

    #Unmapped address 0xe4e testing: random write/read operations
    #Address 0xe4e Write value 0xf8a8666b
    li x3, 0xf8a8666b
    csrw 0xe4e, x3

    #Unmapped address 0x260 testing: random write/read operations
    #Address 0x260 Write value 0xc71d1746
    li x3, 0xc71d1746
    csrw 0x260, x3

    #Address 0x260 read value
    csrr x14, 0x260

    #Unmapped address 0x139 testing: random write/read operations
    #Address 0x139 read value
    csrr x14, 0x139

    #Address 0x139 read value
    csrr x14, 0x139

    #Unmapped address 0x7d3 testing: random write/read operations
    #Address 0x7d3 Write value 0xe08a00ad
    li x3, 0xe08a00ad
    csrw 0x7d3, x3

    #Address 0x7d3 read value
    csrr x14, 0x7d3

    #Unmapped address 0xe90 testing: random write/read operations
    #Address 0xe90 read value
    csrr x14, 0xe90

    #Address 0xe90 read value
    csrr x14, 0xe90

    #Address 0xe90 Write value 0x770a72c9
    li x3, 0x770a72c9
    csrw 0xe90, x3

    #Unmapped address 0x13b testing: random write/read operations
    #Address 0x13b read value
    csrr x14, 0x13b

    #Address 0x13b Write value 0x56b6b908
    li x3, 0x56b6b908
    csrw 0x13b, x3

    #Unmapped address 0x940 testing: random write/read operations
    #Address 0x940 read value
    csrr x14, 0x940

    #Address 0x940 read value
    csrr x14, 0x940

    #Unmapped address 0xab3 testing: random write/read operations
    #Address 0xab3 Write value 0x14dbea7f
    li x3, 0x14dbea7f
    csrw 0xab3, x3

    #Address 0xab3 Write value 0x1e6eefc1
    li x3, 0x1e6eefc1
    csrw 0xab3, x3

    #Address 0xab3 read value
    csrr x14, 0xab3

    #Address 0xab3 read value
    csrr x14, 0xab3

    #Address 0xab3 read value
    csrr x14, 0xab3

    #Unmapped address 0xea1 testing: random write/read operations
    #Address 0xea1 Write value 0x30d98de5
    li x3, 0x30d98de5
    csrw 0xea1, x3

    #Address 0xea1 Write value 0x4411e044
    li x3, 0x4411e044
    csrw 0xea1, x3

    #Address 0xea1 Write value 0xdfdc2abb
    li x3, 0xdfdc2abb
    csrw 0xea1, x3

    #Address 0xea1 Write value 0x4709a0b0
    li x3, 0x4709a0b0
    csrw 0xea1, x3

    #Address 0xea1 Write value 0x88a4f6d1
    li x3, 0x88a4f6d1
    csrw 0xea1, x3

    #Unmapped address 0xd93 testing: random write/read operations
    #Address 0xd93 read value
    csrr x14, 0xd93

    #Address 0xd93 Write value 0x65c67848
    li x3, 0x65c67848
    csrw 0xd93, x3

    #Unmapped address 0x241 testing: random write/read operations
    #Address 0x241 Write value 0xe97336bb
    li x3, 0xe97336bb
    csrw 0x241, x3

    #Address 0x241 read value
    csrr x14, 0x241

    #Address 0x241 read value
    csrr x14, 0x241

    #Address 0x241 Write value 0xcb84469c
    li x3, 0xcb84469c
    csrw 0x241, x3

    #Unmapped address 0x548 testing: random write/read operations
    #Address 0x548 read value
    csrr x14, 0x548

    #Address 0x548 read value
    csrr x14, 0x548

    #Address 0x548 Write value 0x8a57bc37
    li x3, 0x8a57bc37
    csrw 0x548, x3

    #Unmapped address 0x6fa testing: random write/read operations
    #Address 0x6fa read value
    csrr x14, 0x6fa

    #Unmapped address 0x15d testing: random write/read operations
    #Address 0x15d Write value 0x4ea476ae
    li x3, 0x4ea476ae
    csrw 0x15d, x3

    #Address 0x15d read value
    csrr x14, 0x15d

    #Unmapped address 0xd3c testing: random write/read operations
    #Address 0xd3c Write value 0x5826f4e2
    li x3, 0x5826f4e2
    csrw 0xd3c, x3

    #Address 0xd3c Write value 0x474d4fa5
    li x3, 0x474d4fa5
    csrw 0xd3c, x3

    #Address 0xd3c Write value 0x88fef379
    li x3, 0x88fef379
    csrw 0xd3c, x3

    #Address 0xd3c Write value 0xe9d2ed8d
    li x3, 0xe9d2ed8d
    csrw 0xd3c, x3

    #Address 0xd3c Write value 0x6fd22052
    li x3, 0x6fd22052
    csrw 0xd3c, x3

    #Unmapped address 0x87f testing: random write/read operations
    #Address 0x87f Write value 0x3e57f7e2
    li x3, 0x3e57f7e2
    csrw 0x87f, x3

    #Address 0x87f Write value 0x49d25b06
    li x3, 0x49d25b06
    csrw 0x87f, x3

    #Address 0x87f read value
    csrr x14, 0x87f

    #Address 0x87f Write value 0x954d8666
    li x3, 0x954d8666
    csrw 0x87f, x3

    #Unmapped address 0x51c testing: random write/read operations
    #Address 0x51c read value
    csrr x14, 0x51c

    #Address 0x51c Write value 0x5709e953
    li x3, 0x5709e953
    csrw 0x51c, x3

    #Unmapped address 0x50f testing: random write/read operations
    #Address 0x50f Write value 0xd8fbb81d
    li x3, 0xd8fbb81d
    csrw 0x50f, x3

    #Address 0x50f read value
    csrr x14, 0x50f

    #Address 0x50f Write value 0xe4616e18
    li x3, 0xe4616e18
    csrw 0x50f, x3

    #Unmapped address 0xa71 testing: random write/read operations
    #Address 0xa71 Write value 0x29f92e20
    li x3, 0x29f92e20
    csrw 0xa71, x3

    #Unmapped address 0x21d testing: random write/read operations
    #Address 0x21d read value
    csrr x14, 0x21d

    #Unmapped address 0x1d2 testing: random write/read operations
    #Address 0x1d2 Write value 0xdcd79cb7
    li x3, 0xdcd79cb7
    csrw 0x1d2, x3

    #Address 0x1d2 Write value 0x1a62d6ee
    li x3, 0x1a62d6ee
    csrw 0x1d2, x3

    #Address 0x1d2 read value
    csrr x14, 0x1d2

    #Address 0x1d2 read value
    csrr x14, 0x1d2

    #Address 0x1d2 Write value 0x15381aab
    li x3, 0x15381aab
    csrw 0x1d2, x3

    #Unmapped address 0xdd8 testing: random write/read operations
    #Address 0xdd8 Write value 0x27679c5e
    li x3, 0x27679c5e
    csrw 0xdd8, x3

    #Address 0xdd8 Write value 0x75a8f98e
    li x3, 0x75a8f98e
    csrw 0xdd8, x3

    #Address 0xdd8 Write value 0x49b7a385
    li x3, 0x49b7a385
    csrw 0xdd8, x3

    #Address 0xdd8 Write value 0x784067a3
    li x3, 0x784067a3
    csrw 0xdd8, x3

    #Address 0xdd8 Write value 0xb5ffdf25
    li x3, 0xb5ffdf25
    csrw 0xdd8, x3

    #Mapped address 0xb0c (mhpmcounter12) testing: random write/read operations
    #Address 0xb0c read value
    csrr x14, 0xb0c

    #Address 0xb0c Write value 0xd2342c65
    li x3, 0xd2342c65
    csrw 0xb0c, x3

    #Address 0xb0c read value
    csrr x14, 0xb0c

    #Address 0xb0c Write value 0xc607a05e
    li x3, 0xc607a05e
    csrw 0xb0c, x3

    #Address 0xb0c Write value 0x6bba7535
    li x3, 0x6bba7535
    csrw 0xb0c, x3

    #Unmapped address 0x819 testing: random write/read operations
    #Address 0x819 Write value 0x11d52c0a
    li x3, 0x11d52c0a
    csrw 0x819, x3

    #Unmapped address 0xf04 testing: random write/read operations
    #Address 0xf04 read value
    csrr x14, 0xf04

    #Address 0xf04 read value
    csrr x14, 0xf04

    #Address 0xf04 Write value 0x22a7a4a5
    li x3, 0x22a7a4a5
    csrw 0xf04, x3

    #Unmapped address 0x217 testing: random write/read operations
    #Address 0x217 Write value 0x409d08a7
    li x3, 0x409d08a7
    csrw 0x217, x3

    #Address 0x217 Write value 0xc6592bc7
    li x3, 0xc6592bc7
    csrw 0x217, x3

    #Address 0x217 read value
    csrr x14, 0x217

    #Unmapped address 0xa94 testing: random write/read operations
    #Address 0xa94 Write value 0xa2b7311e
    li x3, 0xa2b7311e
    csrw 0xa94, x3

    #Address 0xa94 read value
    csrr x14, 0xa94

    #Address 0xa94 Write value 0xb708354e
    li x3, 0xb708354e
    csrw 0xa94, x3

    #Unmapped address 0xc16 testing: random write/read operations
    #Address 0xc16 read value
    csrr x14, 0xc16

    #Address 0xc16 Write value 0xfce79b07
    li x3, 0xfce79b07
    csrw 0xc16, x3

    #Mapped address 0xb90 (mhpmcounterh16) testing: random write/read operations
    #Address 0xb90 Write value 0x4d1b362
    li x3, 0x4d1b362
    csrw 0xb90, x3

    #Unmapped address 0x79e testing: random write/read operations
    #Address 0x79e read value
    csrr x14, 0x79e

    #Address 0x79e read value
    csrr x14, 0x79e

    #Address 0x79e read value
    csrr x14, 0x79e

    #Address 0x79e read value
    csrr x14, 0x79e

    #Unmapped address 0xbf7 testing: random write/read operations
    #Address 0xbf7 Write value 0x1fe9670e
    li x3, 0x1fe9670e
    csrw 0xbf7, x3

    #Address 0xbf7 read value
    csrr x14, 0xbf7

    #Address 0xbf7 read value
    csrr x14, 0xbf7

    #Address 0xbf7 read value
    csrr x14, 0xbf7

    #Address 0xbf7 Write value 0xc3988645
    li x3, 0xc3988645
    csrw 0xbf7, x3

    #Unmapped address 0xb4a testing: random write/read operations
    #Address 0xb4a read value
    csrr x14, 0xb4a

    #Address 0xb4a read value
    csrr x14, 0xb4a

    #Address 0xb4a read value
    csrr x14, 0xb4a

    #Address 0xb4a read value
    csrr x14, 0xb4a

    #Address 0xb4a Write value 0xf3a83387
    li x3, 0xf3a83387
    csrw 0xb4a, x3

    #Unmapped address 0xc38 testing: random write/read operations
    #Address 0xc38 read value
    csrr x14, 0xc38

    #Unmapped address 0x5a2 testing: random write/read operations
    #Address 0x5a2 read value
    csrr x14, 0x5a2

    #Address 0x5a2 Write value 0x2648bbe7
    li x3, 0x2648bbe7
    csrw 0x5a2, x3

    #Address 0x5a2 read value
    csrr x14, 0x5a2

    #Address 0x5a2 read value
    csrr x14, 0x5a2

    #Unmapped address 0xbf testing: random write/read operations
    #Address 0xbf read value
    csrr x14, 0xbf

    #Address 0xbf Write value 0xed220c51
    li x3, 0xed220c51
    csrw 0xbf, x3

    #Address 0xbf read value
    csrr x14, 0xbf

    #Address 0xbf Write value 0xbabc7ac8
    li x3, 0xbabc7ac8
    csrw 0xbf, x3

    #Unmapped address 0x2f testing: random write/read operations
    #Address 0x2f Write value 0x722a0f
    li x3, 0x722a0f
    csrw 0x2f, x3

    #Address 0x2f read value
    csrr x14, 0x2f

    #Address 0x2f read value
    csrr x14, 0x2f

    #Address 0x2f Write value 0xd6f024cc
    li x3, 0xd6f024cc
    csrw 0x2f, x3

    #Address 0x2f read value
    csrr x14, 0x2f

    #Unmapped address 0xcea testing: random write/read operations
    #Address 0xcea Write value 0xa71b8e
    li x3, 0xa71b8e
    csrw 0xcea, x3

    #Address 0xcea read value
    csrr x14, 0xcea

    #Address 0xcea read value
    csrr x14, 0xcea

    #Unmapped address 0xd2b testing: random write/read operations
    #Address 0xd2b read value
    csrr x14, 0xd2b

    #Unmapped address 0x12b testing: random write/read operations
    #Address 0x12b Write value 0x2696d3a4
    li x3, 0x2696d3a4
    csrw 0x12b, x3

    #Address 0x12b Write value 0x8e194323
    li x3, 0x8e194323
    csrw 0x12b, x3

    #Address 0x12b read value
    csrr x14, 0x12b

    #Unmapped address 0x31b testing: random write/read operations
    #Address 0x31b read value
    csrr x14, 0x31b

    #Address 0x31b read value
    csrr x14, 0x31b

    #Address 0x31b Write value 0xfc008db0
    li x3, 0xfc008db0
    csrw 0x31b, x3

    #Unmapped address 0x902 testing: random write/read operations
    #Address 0x902 Write value 0x970b3cd7
    li x3, 0x970b3cd7
    csrw 0x902, x3

    #Address 0x902 Write value 0x85dd55f1
    li x3, 0x85dd55f1
    csrw 0x902, x3

    #Address 0x902 read value
    csrr x14, 0x902

    #Address 0x902 read value
    csrr x14, 0x902

    #Unmapped address 0xd5f testing: random write/read operations
    #Address 0xd5f read value
    csrr x14, 0xd5f

    #Address 0xd5f Write value 0x6e49fa8b
    li x3, 0x6e49fa8b
    csrw 0xd5f, x3

    #Address 0xd5f read value
    csrr x14, 0xd5f

    #Address 0xd5f Write value 0x44e0be00
    li x3, 0x44e0be00
    csrw 0xd5f, x3

    #Unmapped address 0x5b9 testing: random write/read operations
    #Address 0x5b9 read value
    csrr x14, 0x5b9

    #Address 0x5b9 Write value 0xacc570d4
    li x3, 0xacc570d4
    csrw 0x5b9, x3

    #Address 0x5b9 read value
    csrr x14, 0x5b9

    #Unmapped address 0xdc7 testing: random write/read operations
    #Address 0xdc7 Write value 0x37c44dde
    li x3, 0x37c44dde
    csrw 0xdc7, x3

    #Unmapped address 0x4b6 testing: random write/read operations
    #Address 0x4b6 read value
    csrr x14, 0x4b6

    #Address 0x4b6 read value
    csrr x14, 0x4b6

    #Unmapped address 0x240 testing: random write/read operations
    #Address 0x240 read value
    csrr x14, 0x240

    #Unmapped address 0x9ef testing: random write/read operations
    #Address 0x9ef read value
    csrr x14, 0x9ef

    #Unmapped address 0x30c testing: random write/read operations
    #Address 0x30c Write value 0x47bd12b1
    li x3, 0x47bd12b1
    csrw 0x30c, x3

    #Address 0x30c read value
    csrr x14, 0x30c

    #Address 0x30c Write value 0x719f79b3
    li x3, 0x719f79b3
    csrw 0x30c, x3

    #Unmapped address 0x2d7 testing: random write/read operations
    #Address 0x2d7 read value
    csrr x14, 0x2d7

    #Address 0x2d7 read value
    csrr x14, 0x2d7

    #Address 0x2d7 read value
    csrr x14, 0x2d7

    #Address 0x2d7 Write value 0xc004347a
    li x3, 0xc004347a
    csrw 0x2d7, x3

    #Unmapped address 0x35c testing: random write/read operations
    #Address 0x35c read value
    csrr x14, 0x35c

    #Address 0x35c read value
    csrr x14, 0x35c

    #Address 0x35c read value
    csrr x14, 0x35c

    #Unmapped address 0xf6e testing: random write/read operations
    #Address 0xf6e Write value 0xa3a147f8
    li x3, 0xa3a147f8
    csrw 0xf6e, x3

    #Address 0xf6e Write value 0x87f24630
    li x3, 0x87f24630
    csrw 0xf6e, x3

    #Address 0xf6e read value
    csrr x14, 0xf6e

    #Address 0xf6e Write value 0xf3e792b4
    li x3, 0xf3e792b4
    csrw 0xf6e, x3

    #Address 0xf6e read value
    csrr x14, 0xf6e

    #Unmapped address 0xd30 testing: random write/read operations
    #Address 0xd30 read value
    csrr x14, 0xd30

    #Address 0xd30 Write value 0x9ba41fd7
    li x3, 0x9ba41fd7
    csrw 0xd30, x3

    #Unmapped address 0xe01 testing: random write/read operations
    #Address 0xe01 read value
    csrr x14, 0xe01

    #Address 0xe01 read value
    csrr x14, 0xe01

    #Address 0xe01 Write value 0xa93184aa
    li x3, 0xa93184aa
    csrw 0xe01, x3

    #Address 0xe01 read value
    csrr x14, 0xe01

    #Unmapped address 0x44c testing: random write/read operations
    #Address 0x44c Write value 0xd53721ad
    li x3, 0xd53721ad
    csrw 0x44c, x3

    #Address 0x44c Write value 0xc7d2f17
    li x3, 0xc7d2f17
    csrw 0x44c, x3

    #Address 0x44c read value
    csrr x14, 0x44c

    #Address 0x44c Write value 0xb10fef94
    li x3, 0xb10fef94
    csrw 0x44c, x3

    #Address 0x44c Write value 0x62f330b8
    li x3, 0x62f330b8
    csrw 0x44c, x3

    #Unmapped address 0x554 testing: random write/read operations
    #Address 0x554 Write value 0x263105ad
    li x3, 0x263105ad
    csrw 0x554, x3

    #Address 0x554 read value
    csrr x14, 0x554

    #Address 0x554 read value
    csrr x14, 0x554

    #Address 0x554 Write value 0x1fc36207
    li x3, 0x1fc36207
    csrw 0x554, x3

    #Unmapped address 0xc0b testing: random write/read operations
    #Address 0xc0b read value
    csrr x14, 0xc0b

    #Unmapped address 0x4ef testing: random write/read operations
    #Address 0x4ef Write value 0x8af524dd
    li x3, 0x8af524dd
    csrw 0x4ef, x3

    #Unmapped address 0x493 testing: random write/read operations
    #Address 0x493 Write value 0x2e2bf407
    li x3, 0x2e2bf407
    csrw 0x493, x3

    #Address 0x493 read value
    csrr x14, 0x493

    #Address 0x493 Write value 0x960e9d6
    li x3, 0x960e9d6
    csrw 0x493, x3

    #Unmapped address 0xbdd testing: random write/read operations
    #Address 0xbdd Write value 0x69dbee5c
    li x3, 0x69dbee5c
    csrw 0xbdd, x3

    #Address 0xbdd Write value 0xfe1b5800
    li x3, 0xfe1b5800
    csrw 0xbdd, x3

    #Address 0xbdd read value
    csrr x14, 0xbdd

    #Unmapped address 0x231 testing: random write/read operations
    #Address 0x231 read value
    csrr x14, 0x231

    #Address 0x231 read value
    csrr x14, 0x231

    #Unmapped address 0x1b6 testing: random write/read operations
    #Address 0x1b6 read value
    csrr x14, 0x1b6

    #Address 0x1b6 Write value 0x78b26352
    li x3, 0x78b26352
    csrw 0x1b6, x3

    #Address 0x1b6 read value
    csrr x14, 0x1b6

    #Address 0x1b6 read value
    csrr x14, 0x1b6

    #Address 0x1b6 read value
    csrr x14, 0x1b6

    #Unmapped address 0x727 testing: random write/read operations
    #Address 0x727 Write value 0x5d97ceae
    li x3, 0x5d97ceae
    csrw 0x727, x3

    #Unmapped address 0x65d testing: random write/read operations
    #Address 0x65d read value
    csrr x14, 0x65d

    #Address 0x65d Write value 0x89d8e8a7
    li x3, 0x89d8e8a7
    csrw 0x65d, x3

    #Address 0x65d read value
    csrr x14, 0x65d

    #Address 0x65d Write value 0x6146037
    li x3, 0x6146037
    csrw 0x65d, x3

    #Address 0x65d read value
    csrr x14, 0x65d

    #Unmapped address 0xdbc testing: random write/read operations
    #Address 0xdbc read value
    csrr x14, 0xdbc

    #Address 0xdbc read value
    csrr x14, 0xdbc

    #Address 0xdbc Write value 0x3f90220d
    li x3, 0x3f90220d
    csrw 0xdbc, x3

    #Address 0xdbc read value
    csrr x14, 0xdbc

    #Unmapped address 0x54b testing: random write/read operations
    #Address 0x54b read value
    csrr x14, 0x54b

    #Address 0x54b read value
    csrr x14, 0x54b

    #Unmapped address 0x9d4 testing: random write/read operations
    #Address 0x9d4 read value
    csrr x14, 0x9d4

    #Address 0x9d4 read value
    csrr x14, 0x9d4

    #Address 0x9d4 Write value 0x4025cd48
    li x3, 0x4025cd48
    csrw 0x9d4, x3

    #Unmapped address 0x2e1 testing: random write/read operations
    #Address 0x2e1 read value
    csrr x14, 0x2e1

    #Address 0x2e1 read value
    csrr x14, 0x2e1

    #Address 0x2e1 Write value 0x9f5fe4e0
    li x3, 0x9f5fe4e0
    csrw 0x2e1, x3

    #Address 0x2e1 Write value 0x76dc31c1
    li x3, 0x76dc31c1
    csrw 0x2e1, x3

    #Address 0x2e1 read value
    csrr x14, 0x2e1

    #Unmapped address 0x22d testing: random write/read operations
    #Address 0x22d Write value 0xc204538e
    li x3, 0xc204538e
    csrw 0x22d, x3

    #Address 0x22d read value
    csrr x14, 0x22d

    #Address 0x22d read value
    csrr x14, 0x22d

    #Address 0x22d Write value 0x1daa4851
    li x3, 0x1daa4851
    csrw 0x22d, x3

    #Address 0x22d read value
    csrr x14, 0x22d

    #Unmapped address 0x913 testing: random write/read operations
    #Address 0x913 Write value 0xd562b162
    li x3, 0xd562b162
    csrw 0x913, x3

    #Address 0x913 Write value 0x89e18cb0
    li x3, 0x89e18cb0
    csrw 0x913, x3

    #Unmapped address 0xb3f testing: random write/read operations
    #Address 0xb3f Write value 0x99e12df8
    li x3, 0x99e12df8
    csrw 0xb3f, x3

    #Address 0xb3f read value
    csrr x14, 0xb3f

    #Address 0xb3f Write value 0x3e164cf7
    li x3, 0x3e164cf7
    csrw 0xb3f, x3

    #Address 0xb3f Write value 0xc03af508
    li x3, 0xc03af508
    csrw 0xb3f, x3

    #Unmapped address 0x85d testing: random write/read operations
    #Address 0x85d Write value 0xaf6a0913
    li x3, 0xaf6a0913
    csrw 0x85d, x3

    #Address 0x85d Write value 0x5be8377c
    li x3, 0x5be8377c
    csrw 0x85d, x3

    #Address 0x85d Write value 0xefd900a1
    li x3, 0xefd900a1
    csrw 0x85d, x3

    #Address 0x85d read value
    csrr x14, 0x85d

    #Address 0x85d read value
    csrr x14, 0x85d

    #Unmapped address 0x635 testing: random write/read operations
    #Address 0x635 read value
    csrr x14, 0x635

    #Address 0x635 read value
    csrr x14, 0x635

    #Address 0x635 read value
    csrr x14, 0x635

    #Unmapped address 0xad1 testing: random write/read operations
    #Address 0xad1 Write value 0x6ec010b2
    li x3, 0x6ec010b2
    csrw 0xad1, x3

    #Address 0xad1 read value
    csrr x14, 0xad1

    #Address 0xad1 Write value 0x7e76d97e
    li x3, 0x7e76d97e
    csrw 0xad1, x3

    #Address 0xad1 Write value 0xe6371561
    li x3, 0xe6371561
    csrw 0xad1, x3

    #Unmapped address 0xf82 testing: random write/read operations
    #Address 0xf82 Write value 0x3567ca0b
    li x3, 0x3567ca0b
    csrw 0xf82, x3

    #Address 0xf82 read value
    csrr x14, 0xf82

    #Address 0xf82 read value
    csrr x14, 0xf82

    #Unmapped address 0xbc7 testing: random write/read operations
    #Address 0xbc7 read value
    csrr x14, 0xbc7

    #Address 0xbc7 read value
    csrr x14, 0xbc7

    #Unmapped address 0x1ab testing: random write/read operations
    #Address 0x1ab Write value 0xc805885a
    li x3, 0xc805885a
    csrw 0x1ab, x3

    #Unmapped address 0xba6 testing: random write/read operations
    #Address 0xba6 read value
    csrr x14, 0xba6

    #Address 0xba6 read value
    csrr x14, 0xba6

    #Address 0xba6 read value
    csrr x14, 0xba6

    #Unmapped address 0x782 testing: random write/read operations
    #Address 0x782 Write value 0x2575b68
    li x3, 0x2575b68
    csrw 0x782, x3

    #Address 0x782 Write value 0x63c989b9
    li x3, 0x63c989b9
    csrw 0x782, x3

    #Address 0x782 Write value 0x192409c1
    li x3, 0x192409c1
    csrw 0x782, x3

    #Unmapped address 0xbd7 testing: random write/read operations
    #Address 0xbd7 Write value 0x9b4ad17
    li x3, 0x9b4ad17
    csrw 0xbd7, x3

    #Address 0xbd7 Write value 0x732ab955
    li x3, 0x732ab955
    csrw 0xbd7, x3

    #Address 0xbd7 Write value 0xff8d4eb2
    li x3, 0xff8d4eb2
    csrw 0xbd7, x3

    #Unmapped address 0xc12 testing: random write/read operations
    #Address 0xc12 Write value 0xd5f7c2a9
    li x3, 0xd5f7c2a9
    csrw 0xc12, x3

    #Address 0xc12 Write value 0x75469516
    li x3, 0x75469516
    csrw 0xc12, x3

    #Address 0xc12 Write value 0xb28aadd
    li x3, 0xb28aadd
    csrw 0xc12, x3

    #Address 0xc12 read value
    csrr x14, 0xc12

    #Unmapped address 0xa56 testing: random write/read operations
    #Address 0xa56 read value
    csrr x14, 0xa56

    #Unmapped address 0x5d testing: random write/read operations
    #Address 0x5d Write value 0x1de151a6
    li x3, 0x1de151a6
    csrw 0x5d, x3

    #Address 0x5d read value
    csrr x14, 0x5d

    #Address 0x5d read value
    csrr x14, 0x5d

    #Address 0x5d read value
    csrr x14, 0x5d

    #Skipped Mapped address 0x305 (mtvec) because in user ignore list

    #Unmapped address 0x536 testing: random write/read operations
    #Address 0x536 Write value 0x89ba677c
    li x3, 0x89ba677c
    csrw 0x536, x3

    #Address 0x536 Write value 0xf5eb759e
    li x3, 0xf5eb759e
    csrw 0x536, x3

    #Address 0x536 Write value 0xe9a39826
    li x3, 0xe9a39826
    csrw 0x536, x3

    #Unmapped address 0x793 testing: random write/read operations
    #Address 0x793 Write value 0x75c3a2ee
    li x3, 0x75c3a2ee
    csrw 0x793, x3

    #Unmapped address 0xeaa testing: random write/read operations
    #Address 0xeaa read value
    csrr x14, 0xeaa

    #Address 0xeaa Write value 0x4437752e
    li x3, 0x4437752e
    csrw 0xeaa, x3

    #Unmapped address 0xab4 testing: random write/read operations
    #Address 0xab4 Write value 0xf308ef86
    li x3, 0xf308ef86
    csrw 0xab4, x3

    #Address 0xab4 read value
    csrr x14, 0xab4

    #Address 0xab4 Write value 0xecd1d365
    li x3, 0xecd1d365
    csrw 0xab4, x3

    #Unmapped address 0xafa testing: random write/read operations
    #Address 0xafa read value
    csrr x14, 0xafa

    #Unmapped address 0x75c testing: random write/read operations
    #Address 0x75c read value
    csrr x14, 0x75c

    #Address 0x75c Write value 0x9bdeaf3b
    li x3, 0x9bdeaf3b
    csrw 0x75c, x3

    #Address 0x75c Write value 0xc103ee93
    li x3, 0xc103ee93
    csrw 0x75c, x3

    #Address 0x75c read value
    csrr x14, 0x75c

    #Address 0x75c read value
    csrr x14, 0x75c

    #Unmapped address 0x1ed testing: random write/read operations
    #Address 0x1ed read value
    csrr x14, 0x1ed

    #Address 0x1ed Write value 0x404967f1
    li x3, 0x404967f1
    csrw 0x1ed, x3

    #Address 0x1ed Write value 0x8672f1eb
    li x3, 0x8672f1eb
    csrw 0x1ed, x3

    #Unmapped address 0x79a testing: random write/read operations
    #Address 0x79a Write value 0x1c6687c
    li x3, 0x1c6687c
    csrw 0x79a, x3

    #Address 0x79a read value
    csrr x14, 0x79a

    #Address 0x79a read value
    csrr x14, 0x79a

    #Address 0x79a read value
    csrr x14, 0x79a

    #Unmapped address 0xe5 testing: random write/read operations
    #Address 0xe5 read value
    csrr x14, 0xe5

    #Unmapped address 0xcf4 testing: random write/read operations
    #Address 0xcf4 read value
    csrr x14, 0xcf4

    #Address 0xcf4 Write value 0xefd57b69
    li x3, 0xefd57b69
    csrw 0xcf4, x3

    #Address 0xcf4 read value
    csrr x14, 0xcf4

    #Unmapped address 0xea5 testing: random write/read operations
    #Address 0xea5 Write value 0x90eb07f2
    li x3, 0x90eb07f2
    csrw 0xea5, x3

    #Address 0xea5 Write value 0x4be47d81
    li x3, 0x4be47d81
    csrw 0xea5, x3

    #Address 0xea5 Write value 0x5f0a3f79
    li x3, 0x5f0a3f79
    csrw 0xea5, x3

    #Unmapped address 0x853 testing: random write/read operations
    #Address 0x853 read value
    csrr x14, 0x853

    #Address 0x853 read value
    csrr x14, 0x853

    #Address 0x853 read value
    csrr x14, 0x853

    #Unmapped address 0x380 testing: random write/read operations
    #Address 0x380 read value
    csrr x14, 0x380

    #Address 0x380 read value
    csrr x14, 0x380

    #Address 0x380 Write value 0x35d40a33
    li x3, 0x35d40a33
    csrw 0x380, x3

    #Address 0x380 read value
    csrr x14, 0x380

    #Address 0x380 read value
    csrr x14, 0x380

    #Unmapped address 0x7b0 testing: random write/read operations
    #Address 0x7b0 read value
    csrr x14, 0x7b0

    #Unmapped address 0x5b6 testing: random write/read operations
    #Address 0x5b6 Write value 0xcb5cc1b2
    li x3, 0xcb5cc1b2
    csrw 0x5b6, x3

    #Address 0x5b6 read value
    csrr x14, 0x5b6

    #Address 0x5b6 read value
    csrr x14, 0x5b6

    #Unmapped address 0x204 testing: random write/read operations
    #Address 0x204 Write value 0xf0d803d2
    li x3, 0xf0d803d2
    csrw 0x204, x3

    #Address 0x204 Write value 0xa4eb3481
    li x3, 0xa4eb3481
    csrw 0x204, x3

    #Address 0x204 Write value 0x9ef33af
    li x3, 0x9ef33af
    csrw 0x204, x3

    #Unmapped address 0x8c4 testing: random write/read operations
    #Address 0x8c4 read value
    csrr x14, 0x8c4

    #Address 0x8c4 read value
    csrr x14, 0x8c4

    #Address 0x8c4 Write value 0x6c51564f
    li x3, 0x6c51564f
    csrw 0x8c4, x3

    #Address 0x8c4 read value
    csrr x14, 0x8c4

    #Address 0x8c4 read value
    csrr x14, 0x8c4

    #Unmapped address 0x29b testing: random write/read operations
    #Address 0x29b Write value 0xc10fee34
    li x3, 0xc10fee34
    csrw 0x29b, x3

    #Address 0x29b Write value 0x359db4bd
    li x3, 0x359db4bd
    csrw 0x29b, x3

    #Address 0x29b read value
    csrr x14, 0x29b

    #Unmapped address 0x960 testing: random write/read operations
    #Address 0x960 read value
    csrr x14, 0x960

    #Unmapped address 0x5fc testing: random write/read operations
    #Address 0x5fc read value
    csrr x14, 0x5fc

    #Address 0x5fc Write value 0x3e69f1dd
    li x3, 0x3e69f1dd
    csrw 0x5fc, x3

    #Address 0x5fc read value
    csrr x14, 0x5fc

    #Address 0x5fc Write value 0xdbf87cd0
    li x3, 0xdbf87cd0
    csrw 0x5fc, x3

    #Address 0x5fc read value
    csrr x14, 0x5fc

    #Unmapped address 0x2eb testing: random write/read operations
    #Address 0x2eb Write value 0xc3c95953
    li x3, 0xc3c95953
    csrw 0x2eb, x3

    #Unmapped address 0x61e testing: random write/read operations
    #Address 0x61e Write value 0x69818eea
    li x3, 0x69818eea
    csrw 0x61e, x3

    #Address 0x61e Write value 0x240dde87
    li x3, 0x240dde87
    csrw 0x61e, x3

    #Unmapped address 0x5dd testing: random write/read operations
    #Address 0x5dd read value
    csrr x14, 0x5dd

    #Address 0x5dd read value
    csrr x14, 0x5dd

    #Address 0x5dd read value
    csrr x14, 0x5dd

    #Address 0x5dd read value
    csrr x14, 0x5dd

    #Address 0x5dd read value
    csrr x14, 0x5dd

    #Unmapped address 0x5b2 testing: random write/read operations
    #Address 0x5b2 read value
    csrr x14, 0x5b2

    #Address 0x5b2 Write value 0x4bf6ce84
    li x3, 0x4bf6ce84
    csrw 0x5b2, x3

    #Address 0x5b2 Write value 0x117e4f9f
    li x3, 0x117e4f9f
    csrw 0x5b2, x3

    #Address 0x5b2 read value
    csrr x14, 0x5b2

    #Unmapped address 0x9c0 testing: random write/read operations
    #Address 0x9c0 read value
    csrr x14, 0x9c0

    #Address 0x9c0 Write value 0x99329add
    li x3, 0x99329add
    csrw 0x9c0, x3

    #Address 0x9c0 read value
    csrr x14, 0x9c0

    #Address 0x9c0 Write value 0x529cf02d
    li x3, 0x529cf02d
    csrw 0x9c0, x3

    #Address 0x9c0 Write value 0x4d118a3d
    li x3, 0x4d118a3d
    csrw 0x9c0, x3

    #Unmapped address 0x854 testing: random write/read operations
    #Address 0x854 read value
    csrr x14, 0x854

    #Address 0x854 Write value 0x218f0b5c
    li x3, 0x218f0b5c
    csrw 0x854, x3

    #Unmapped address 0x807 testing: random write/read operations
    #Address 0x807 Write value 0x82f613b7
    li x3, 0x82f613b7
    csrw 0x807, x3

    #Address 0x807 read value
    csrr x14, 0x807

    #Unmapped address 0xc22 testing: random write/read operations
    #Address 0xc22 Write value 0xd9083517
    li x3, 0xd9083517
    csrw 0xc22, x3

    #Address 0xc22 Write value 0xaa08997c
    li x3, 0xaa08997c
    csrw 0xc22, x3

    #Unmapped address 0x9b8 testing: random write/read operations
    #Address 0x9b8 read value
    csrr x14, 0x9b8

    #Address 0x9b8 read value
    csrr x14, 0x9b8

    #Address 0x9b8 read value
    csrr x14, 0x9b8

    #Unmapped address 0xab5 testing: random write/read operations
    #Address 0xab5 Write value 0x28b0d88f
    li x3, 0x28b0d88f
    csrw 0xab5, x3

    #Address 0xab5 read value
    csrr x14, 0xab5

    #Address 0xab5 Write value 0x3b2bbe3
    li x3, 0x3b2bbe3
    csrw 0xab5, x3

    #Address 0xab5 read value
    csrr x14, 0xab5

    #Unmapped address 0xf70 testing: random write/read operations
    #Address 0xf70 read value
    csrr x14, 0xf70

    #Unmapped address 0x882 testing: random write/read operations
    #Address 0x882 Write value 0x437d8c00
    li x3, 0x437d8c00
    csrw 0x882, x3

    #Address 0x882 read value
    csrr x14, 0x882

    #Address 0x882 Write value 0xdd1292fa
    li x3, 0xdd1292fa
    csrw 0x882, x3

    #Address 0x882 Write value 0xd33595f8
    li x3, 0xd33595f8
    csrw 0x882, x3

    #Unmapped address 0x6df testing: random write/read operations
    #Address 0x6df read value
    csrr x14, 0x6df

    #Unmapped address 0xbf8 testing: random write/read operations
    #Address 0xbf8 Write value 0xf92c8496
    li x3, 0xf92c8496
    csrw 0xbf8, x3

    #Address 0xbf8 read value
    csrr x14, 0xbf8

    #Address 0xbf8 Write value 0xdb1c9fd1
    li x3, 0xdb1c9fd1
    csrw 0xbf8, x3

    #Unmapped address 0x9d3 testing: random write/read operations
    #Address 0x9d3 Write value 0xdfe2a46
    li x3, 0xdfe2a46
    csrw 0x9d3, x3

    #Address 0x9d3 read value
    csrr x14, 0x9d3

    #Address 0x9d3 read value
    csrr x14, 0x9d3

    #Address 0x9d3 Write value 0x9b5b42fb
    li x3, 0x9b5b42fb
    csrw 0x9d3, x3

    #Unmapped address 0x7e1 testing: random write/read operations
    #Address 0x7e1 read value
    csrr x14, 0x7e1

    #Address 0x7e1 Write value 0xf1d98aec
    li x3, 0xf1d98aec
    csrw 0x7e1, x3

    #Address 0x7e1 read value
    csrr x14, 0x7e1

    #Address 0x7e1 read value
    csrr x14, 0x7e1

    #Unmapped address 0x11f testing: random write/read operations
    #Address 0x11f Write value 0x812bee86
    li x3, 0x812bee86
    csrw 0x11f, x3

    #Address 0x11f Write value 0x72c729ff
    li x3, 0x72c729ff
    csrw 0x11f, x3

    #Address 0x11f read value
    csrr x14, 0x11f

    #Address 0x11f Write value 0xa12a4483
    li x3, 0xa12a4483
    csrw 0x11f, x3

    #Unmapped address 0xee5 testing: random write/read operations
    #Address 0xee5 read value
    csrr x14, 0xee5

    #Address 0xee5 read value
    csrr x14, 0xee5

    #Address 0xee5 read value
    csrr x14, 0xee5

    #Unmapped address 0x8bf testing: random write/read operations
    #Address 0x8bf read value
    csrr x14, 0x8bf

    #Unmapped address 0x2d0 testing: random write/read operations
    #Address 0x2d0 Write value 0x9be3c8bb
    li x3, 0x9be3c8bb
    csrw 0x2d0, x3

    #Address 0x2d0 read value
    csrr x14, 0x2d0

    #Mapped address 0x3bd (pmpaddr13) testing: random write/read operations
    #Address 0x3bd read value
    csrr x14, 0x3bd

    #Address 0x3bd Write value 0x7e670e59
    li x3, 0x7e670e59
    csrw 0x3bd, x3

    #Unmapped address 0x9e0 testing: random write/read operations
    #Address 0x9e0 read value
    csrr x14, 0x9e0

    #Address 0x9e0 Write value 0x7a5d205b
    li x3, 0x7a5d205b
    csrw 0x9e0, x3

    #Address 0x9e0 Write value 0x3e4aaef0
    li x3, 0x3e4aaef0
    csrw 0x9e0, x3

    #Address 0x9e0 read value
    csrr x14, 0x9e0

    #Unmapped address 0xd91 testing: random write/read operations
    #Address 0xd91 read value
    csrr x14, 0xd91

    #Address 0xd91 read value
    csrr x14, 0xd91

    #Address 0xd91 read value
    csrr x14, 0xd91

    #Address 0xd91 read value
    csrr x14, 0xd91

    #Address 0xd91 Write value 0x73ba7fc4
    li x3, 0x73ba7fc4
    csrw 0xd91, x3

    #Unmapped address 0x92f testing: random write/read operations
    #Address 0x92f Write value 0xed8d0598
    li x3, 0xed8d0598
    csrw 0x92f, x3

    #Unmapped address 0x3a4 testing: random write/read operations
    #Address 0x3a4 Write value 0x590389ab
    li x3, 0x590389ab
    csrw 0x3a4, x3

    #Address 0x3a4 Write value 0x36b01f89
    li x3, 0x36b01f89
    csrw 0x3a4, x3

    #Unmapped address 0xdad testing: random write/read operations
    #Address 0xdad read value
    csrr x14, 0xdad

    #Address 0xdad read value
    csrr x14, 0xdad

    #Address 0xdad read value
    csrr x14, 0xdad

    #Address 0xdad read value
    csrr x14, 0xdad

    #Unmapped address 0xe5c testing: random write/read operations
    #Address 0xe5c read value
    csrr x14, 0xe5c

    #Address 0xe5c Write value 0x38f07726
    li x3, 0x38f07726
    csrw 0xe5c, x3

    #Address 0xe5c read value
    csrr x14, 0xe5c

    #Address 0xe5c read value
    csrr x14, 0xe5c

    #Unmapped address 0xbd testing: random write/read operations
    #Address 0xbd read value
    csrr x14, 0xbd

    #Address 0xbd read value
    csrr x14, 0xbd

    #Address 0xbd read value
    csrr x14, 0xbd

    #Address 0xbd Write value 0x57a23a2e
    li x3, 0x57a23a2e
    csrw 0xbd, x3

    #Unmapped address 0x640 testing: random write/read operations
    #Address 0x640 read value
    csrr x14, 0x640

    #Address 0x640 read value
    csrr x14, 0x640

    #Address 0x640 read value
    csrr x14, 0x640

    #Address 0x640 read value
    csrr x14, 0x640

    #Address 0x640 read value
    csrr x14, 0x640

    #Unmapped address 0x762 testing: random write/read operations
    #Address 0x762 Write value 0x401ed5ca
    li x3, 0x401ed5ca
    csrw 0x762, x3

    #Unmapped address 0xf08 testing: random write/read operations
    #Address 0xf08 Write value 0x15e20f91
    li x3, 0x15e20f91
    csrw 0xf08, x3

    #Address 0xf08 read value
    csrr x14, 0xf08

    #Unmapped address 0x8fd testing: random write/read operations
    #Address 0x8fd read value
    csrr x14, 0x8fd

    #Address 0x8fd read value
    csrr x14, 0x8fd

    #Unmapped address 0xa25 testing: random write/read operations
    #Address 0xa25 Write value 0x57bc5b0d
    li x3, 0x57bc5b0d
    csrw 0xa25, x3

    #Address 0xa25 read value
    csrr x14, 0xa25

    #Address 0xa25 Write value 0x1caafecb
    li x3, 0x1caafecb
    csrw 0xa25, x3

    #Address 0xa25 Write value 0xf5a7186e
    li x3, 0xf5a7186e
    csrw 0xa25, x3

    #Unmapped address 0xee7 testing: random write/read operations
    #Address 0xee7 Write value 0x70e36d6e
    li x3, 0x70e36d6e
    csrw 0xee7, x3

    #Address 0xee7 read value
    csrr x14, 0xee7

    #Address 0xee7 read value
    csrr x14, 0xee7

    #Address 0xee7 Write value 0x4dd65ca1
    li x3, 0x4dd65ca1
    csrw 0xee7, x3

    #Unmapped address 0x2ec testing: random write/read operations
    #Address 0x2ec Write value 0x97fb771
    li x3, 0x97fb771
    csrw 0x2ec, x3

    #Address 0x2ec read value
    csrr x14, 0x2ec

    #Address 0x2ec Write value 0x9276407b
    li x3, 0x9276407b
    csrw 0x2ec, x3

    #Address 0x2ec Write value 0x2a2690ae
    li x3, 0x2a2690ae
    csrw 0x2ec, x3

    #Address 0x2ec Write value 0x7b45364d
    li x3, 0x7b45364d
    csrw 0x2ec, x3

    #Unmapped address 0xfb8 testing: random write/read operations
    #Address 0xfb8 read value
    csrr x14, 0xfb8

    #Address 0xfb8 read value
    csrr x14, 0xfb8

    #Unmapped address 0x3f7 testing: random write/read operations
    #Address 0x3f7 read value
    csrr x14, 0x3f7

    #Address 0x3f7 Write value 0x9a0c2374
    li x3, 0x9a0c2374
    csrw 0x3f7, x3

    #Address 0x3f7 Write value 0x82532caf
    li x3, 0x82532caf
    csrw 0x3f7, x3

    #Address 0x3f7 read value
    csrr x14, 0x3f7

    #Address 0x3f7 Write value 0x24784b4f
    li x3, 0x24784b4f
    csrw 0x3f7, x3

    #Unmapped address 0x47a testing: random write/read operations
    #Address 0x47a Write value 0x61af8044
    li x3, 0x61af8044
    csrw 0x47a, x3

    #Address 0x47a Write value 0x7ae3c555
    li x3, 0x7ae3c555
    csrw 0x47a, x3

    #Unmapped address 0x41 testing: random write/read operations
    #Address 0x41 read value
    csrr x14, 0x41

    #Unmapped address 0xbde testing: random write/read operations
    #Address 0xbde Write value 0xeb82cf27
    li x3, 0xeb82cf27
    csrw 0xbde, x3

    #Address 0xbde read value
    csrr x14, 0xbde

    #Address 0xbde Write value 0x87c23c41
    li x3, 0x87c23c41
    csrw 0xbde, x3

    #Address 0xbde read value
    csrr x14, 0xbde

    #Address 0xbde read value
    csrr x14, 0xbde

    #Unmapped address 0x791 testing: random write/read operations
    #Address 0x791 Write value 0x39f7cabe
    li x3, 0x39f7cabe
    csrw 0x791, x3

    #Address 0x791 Write value 0x5e5a5626
    li x3, 0x5e5a5626
    csrw 0x791, x3

    #Address 0x791 Write value 0xc2c5fbf2
    li x3, 0xc2c5fbf2
    csrw 0x791, x3

    #Address 0x791 Write value 0x154359ee
    li x3, 0x154359ee
    csrw 0x791, x3

    #Address 0x791 Write value 0x94938a28
    li x3, 0x94938a28
    csrw 0x791, x3

    #Unmapped address 0x6b2 testing: random write/read operations
    #Address 0x6b2 read value
    csrr x14, 0x6b2

    #Address 0x6b2 Write value 0xfc06f81b
    li x3, 0xfc06f81b
    csrw 0x6b2, x3

    #Address 0x6b2 Write value 0x48bac164
    li x3, 0x48bac164
    csrw 0x6b2, x3

    #Unmapped address 0xf0c testing: random write/read operations
    #Address 0xf0c Write value 0x2faf1dee
    li x3, 0x2faf1dee
    csrw 0xf0c, x3

    #Address 0xf0c Write value 0xecb7930c
    li x3, 0xecb7930c
    csrw 0xf0c, x3

    #Unmapped address 0x45b testing: random write/read operations
    #Address 0x45b Write value 0x5afbceac
    li x3, 0x5afbceac
    csrw 0x45b, x3

    #Address 0x45b read value
    csrr x14, 0x45b

    #Address 0x45b Write value 0x166fffdf
    li x3, 0x166fffdf
    csrw 0x45b, x3

    #Unmapped address 0x684 testing: random write/read operations
    #Address 0x684 read value
    csrr x14, 0x684

    #Address 0x684 read value
    csrr x14, 0x684

    #Address 0x684 read value
    csrr x14, 0x684

    #Address 0x684 Write value 0xf79de9b4
    li x3, 0xf79de9b4
    csrw 0x684, x3

    #Unmapped address 0xbe0 testing: random write/read operations
    #Address 0xbe0 read value
    csrr x14, 0xbe0

    #Address 0xbe0 Write value 0x36f319c
    li x3, 0x36f319c
    csrw 0xbe0, x3

    #Address 0xbe0 Write value 0xa674acb0
    li x3, 0xa674acb0
    csrw 0xbe0, x3

    #Address 0xbe0 read value
    csrr x14, 0xbe0

    #Address 0xbe0 read value
    csrr x14, 0xbe0

    #Unmapped address 0x1a8 testing: random write/read operations
    #Address 0x1a8 Write value 0x52132c60
    li x3, 0x52132c60
    csrw 0x1a8, x3

    #Unmapped address 0x5fb testing: random write/read operations
    #Address 0x5fb Write value 0x7d01035a
    li x3, 0x7d01035a
    csrw 0x5fb, x3

    #Address 0x5fb Write value 0xc794df
    li x3, 0xc794df
    csrw 0x5fb, x3

    #Address 0x5fb read value
    csrr x14, 0x5fb

    #Address 0x5fb Write value 0xe9dd767
    li x3, 0xe9dd767
    csrw 0x5fb, x3

    #Unmapped address 0x2cd testing: random write/read operations
    #Address 0x2cd read value
    csrr x14, 0x2cd

    #Address 0x2cd read value
    csrr x14, 0x2cd

    #Address 0x2cd Write value 0xabdf503a
    li x3, 0xabdf503a
    csrw 0x2cd, x3

    #Address 0x2cd Write value 0xf95b7930
    li x3, 0xf95b7930
    csrw 0x2cd, x3

    #Unmapped address 0x5e5 testing: random write/read operations
    #Address 0x5e5 read value
    csrr x14, 0x5e5

    #Address 0x5e5 read value
    csrr x14, 0x5e5

    #Address 0x5e5 Write value 0x8feda09c
    li x3, 0x8feda09c
    csrw 0x5e5, x3

    #Address 0x5e5 Write value 0x8efc3797
    li x3, 0x8efc3797
    csrw 0x5e5, x3

    #Address 0x5e5 read value
    csrr x14, 0x5e5

    #Unmapped address 0x221 testing: random write/read operations
    #Address 0x221 read value
    csrr x14, 0x221

    #Address 0x221 read value
    csrr x14, 0x221

    #Address 0x221 Write value 0x92471d9f
    li x3, 0x92471d9f
    csrw 0x221, x3

    #Unmapped address 0xeb8 testing: random write/read operations
    #Address 0xeb8 read value
    csrr x14, 0xeb8

    #Address 0xeb8 read value
    csrr x14, 0xeb8

    #Address 0xeb8 read value
    csrr x14, 0xeb8

    #Unmapped address 0x9dd testing: random write/read operations
    #Address 0x9dd Write value 0xcebf2685
    li x3, 0xcebf2685
    csrw 0x9dd, x3

    #Address 0x9dd Write value 0x903fb060
    li x3, 0x903fb060
    csrw 0x9dd, x3

    #Unmapped address 0xe64 testing: random write/read operations
    #Address 0xe64 Write value 0xb99ad96c
    li x3, 0xb99ad96c
    csrw 0xe64, x3

    #Address 0xe64 read value
    csrr x14, 0xe64

    #Unmapped address 0xf93 testing: random write/read operations
    #Address 0xf93 read value
    csrr x14, 0xf93

    #Address 0xf93 read value
    csrr x14, 0xf93

    #Address 0xf93 Write value 0x73b8f3c1
    li x3, 0x73b8f3c1
    csrw 0xf93, x3

    #Unmapped address 0x404 testing: random write/read operations
    #Address 0x404 Write value 0x6679b453
    li x3, 0x6679b453
    csrw 0x404, x3

    #Address 0x404 Write value 0xb2b0f0bd
    li x3, 0xb2b0f0bd
    csrw 0x404, x3

    #Address 0x404 read value
    csrr x14, 0x404

    #Address 0x404 Write value 0x215b4204
    li x3, 0x215b4204
    csrw 0x404, x3

    #Address 0x404 Write value 0x35700e03
    li x3, 0x35700e03
    csrw 0x404, x3

    #Unmapped address 0x6cf testing: random write/read operations
    #Address 0x6cf read value
    csrr x14, 0x6cf

    #Address 0x6cf read value
    csrr x14, 0x6cf

    #Address 0x6cf read value
    csrr x14, 0x6cf

    #Unmapped address 0x20f testing: random write/read operations
    #Address 0x20f Write value 0x30ce3a3d
    li x3, 0x30ce3a3d
    csrw 0x20f, x3

    #Unmapped address 0x7be testing: random write/read operations
    #Address 0x7be read value
    csrr x14, 0x7be

    #Address 0x7be read value
    csrr x14, 0x7be

    #Address 0x7be Write value 0x70ff6729
    li x3, 0x70ff6729
    csrw 0x7be, x3

    #Address 0x7be Write value 0x9d73a4e3
    li x3, 0x9d73a4e3
    csrw 0x7be, x3

    #Address 0x7be read value
    csrr x14, 0x7be

    #Unmapped address 0x5e7 testing: random write/read operations
    #Address 0x5e7 read value
    csrr x14, 0x5e7

    #Address 0x5e7 read value
    csrr x14, 0x5e7

    #Address 0x5e7 read value
    csrr x14, 0x5e7

    #Unmapped address 0x1ca testing: random write/read operations
    #Address 0x1ca read value
    csrr x14, 0x1ca

    #Address 0x1ca read value
    csrr x14, 0x1ca

    #Address 0x1ca Write value 0x76ff7f3c
    li x3, 0x76ff7f3c
    csrw 0x1ca, x3

    #Address 0x1ca read value
    csrr x14, 0x1ca

    #Address 0x1ca Write value 0xafcb4127
    li x3, 0xafcb4127
    csrw 0x1ca, x3

    #Unmapped address 0xe0e testing: random write/read operations
    #Address 0xe0e Write value 0x9ec41951
    li x3, 0x9ec41951
    csrw 0xe0e, x3

    #Unmapped address 0xbf9 testing: random write/read operations
    #Address 0xbf9 read value
    csrr x14, 0xbf9

    #Address 0xbf9 Write value 0xcb696983
    li x3, 0xcb696983
    csrw 0xbf9, x3

    #Address 0xbf9 read value
    csrr x14, 0xbf9

    #Address 0xbf9 Write value 0x47e10864
    li x3, 0x47e10864
    csrw 0xbf9, x3

    #Unmapped address 0x417 testing: random write/read operations
    #Address 0x417 read value
    csrr x14, 0x417

    #Address 0x417 read value
    csrr x14, 0x417

    #Address 0x417 Write value 0x73ae8c0f
    li x3, 0x73ae8c0f
    csrw 0x417, x3

    #Address 0x417 read value
    csrr x14, 0x417

    #Address 0x417 read value
    csrr x14, 0x417

    #Unmapped address 0x9de testing: random write/read operations
    #Address 0x9de Write value 0xbebb7378
    li x3, 0xbebb7378
    csrw 0x9de, x3

    #Address 0x9de read value
    csrr x14, 0x9de

    #Address 0x9de Write value 0xb7623050
    li x3, 0xb7623050
    csrw 0x9de, x3

    #Address 0x9de Write value 0x68714d60
    li x3, 0x68714d60
    csrw 0x9de, x3

    #Unmapped address 0xd47 testing: random write/read operations
    #Address 0xd47 Write value 0x4540c164
    li x3, 0x4540c164
    csrw 0xd47, x3

    #Address 0xd47 read value
    csrr x14, 0xd47

    #Address 0xd47 Write value 0x5d53cebd
    li x3, 0x5d53cebd
    csrw 0xd47, x3

    #Address 0xd47 Write value 0xe2ce3683
    li x3, 0xe2ce3683
    csrw 0xd47, x3

    #Unmapped address 0x477 testing: random write/read operations
    #Address 0x477 read value
    csrr x14, 0x477

    #Address 0x477 read value
    csrr x14, 0x477

    #Address 0x477 read value
    csrr x14, 0x477

    #Address 0x477 Write value 0xb4afe22d
    li x3, 0xb4afe22d
    csrw 0x477, x3

    #Unmapped address 0x171 testing: random write/read operations
    #Address 0x171 read value
    csrr x14, 0x171

    #Address 0x171 Write value 0x201d5a77
    li x3, 0x201d5a77
    csrw 0x171, x3

    #Unmapped address 0xeaf testing: random write/read operations
    #Address 0xeaf read value
    csrr x14, 0xeaf

    #Address 0xeaf read value
    csrr x14, 0xeaf

    #Unmapped address 0xc06 testing: random write/read operations
    #Address 0xc06 Write value 0x7e03c5a6
    li x3, 0x7e03c5a6
    csrw 0xc06, x3

    #Address 0xc06 read value
    csrr x14, 0xc06

    #Address 0xc06 read value
    csrr x14, 0xc06

    #Address 0xc06 Write value 0x55cc9d20
    li x3, 0x55cc9d20
    csrw 0xc06, x3

    #Unmapped address 0xbf3 testing: random write/read operations
    #Address 0xbf3 Write value 0xf04f8f98
    li x3, 0xf04f8f98
    csrw 0xbf3, x3

    #Address 0xbf3 Write value 0x6f7e4e3f
    li x3, 0x6f7e4e3f
    csrw 0xbf3, x3

    #Address 0xbf3 read value
    csrr x14, 0xbf3

    #Address 0xbf3 read value
    csrr x14, 0xbf3

    #Address 0xbf3 read value
    csrr x14, 0xbf3

    #Unmapped address 0x438 testing: random write/read operations
    #Address 0x438 read value
    csrr x14, 0x438

    #Address 0x438 read value
    csrr x14, 0x438

    #Address 0x438 read value
    csrr x14, 0x438

    #Address 0x438 read value
    csrr x14, 0x438

    #Address 0x438 read value
    csrr x14, 0x438

    #Unmapped address 0xa02 testing: random write/read operations
    #Address 0xa02 Write value 0xb9549c99
    li x3, 0xb9549c99
    csrw 0xa02, x3

    #Address 0xa02 Write value 0x1fe4b748
    li x3, 0x1fe4b748
    csrw 0xa02, x3

    #Address 0xa02 Write value 0x78318dea
    li x3, 0x78318dea
    csrw 0xa02, x3

    #Address 0xa02 read value
    csrr x14, 0xa02

    #Unmapped address 0x354 testing: random write/read operations
    #Address 0x354 Write value 0x8d324ccc
    li x3, 0x8d324ccc
    csrw 0x354, x3

    #Address 0x354 Write value 0xbad309a
    li x3, 0xbad309a
    csrw 0x354, x3

    #Address 0x354 Write value 0xf7d696ca
    li x3, 0xf7d696ca
    csrw 0x354, x3

    #Unmapped address 0x692 testing: random write/read operations
    #Address 0x692 read value
    csrr x14, 0x692

    #Address 0x692 Write value 0x5d39048a
    li x3, 0x5d39048a
    csrw 0x692, x3

    #Address 0x692 read value
    csrr x14, 0x692

    #Address 0x692 Write value 0xca2bbac7
    li x3, 0xca2bbac7
    csrw 0x692, x3

    #Address 0x692 Write value 0xe31d42d7
    li x3, 0xe31d42d7
    csrw 0x692, x3

    #Unmapped address 0x3e6 testing: random write/read operations
    #Address 0x3e6 read value
    csrr x14, 0x3e6

    #Address 0x3e6 read value
    csrr x14, 0x3e6

    #Unmapped address 0xe2 testing: random write/read operations
    #Address 0xe2 Write value 0xcc2787f0
    li x3, 0xcc2787f0
    csrw 0xe2, x3

    #Address 0xe2 Write value 0x8b04ccba
    li x3, 0x8b04ccba
    csrw 0xe2, x3

    #Address 0xe2 Write value 0xf6817212
    li x3, 0xf6817212
    csrw 0xe2, x3

    #Address 0xe2 read value
    csrr x14, 0xe2

    #Mapped address 0x32e (mhpmevent14) testing: random write/read operations
    #Address 0x32e read value
    csrr x14, 0x32e

    #Address 0x32e read value
    csrr x14, 0x32e

    #Address 0x32e read value
    csrr x14, 0x32e

    #Address 0x32e read value
    csrr x14, 0x32e

    #Address 0x32e Write value 0xa9cdff5c
    li x3, 0xa9cdff5c
    csrw 0x32e, x3

    #Unmapped address 0xcec testing: random write/read operations
    #Address 0xcec Write value 0xbc762cc8
    li x3, 0xbc762cc8
    csrw 0xcec, x3

    #Address 0xcec read value
    csrr x14, 0xcec

    #Unmapped address 0xe52 testing: random write/read operations
    #Address 0xe52 Write value 0x161de828
    li x3, 0x161de828
    csrw 0xe52, x3

    #Unmapped address 0xf52 testing: random write/read operations
    #Address 0xf52 read value
    csrr x14, 0xf52

    #Address 0xf52 Write value 0xe5a6fc2c
    li x3, 0xe5a6fc2c
    csrw 0xf52, x3

    #Address 0xf52 Write value 0x8cca5897
    li x3, 0x8cca5897
    csrw 0xf52, x3

    #Address 0xf52 read value
    csrr x14, 0xf52

    #Address 0xf52 read value
    csrr x14, 0xf52

    #Unmapped address 0x22f testing: random write/read operations
    #Address 0x22f Write value 0x3eddf92a
    li x3, 0x3eddf92a
    csrw 0x22f, x3

    #Address 0x22f Write value 0xd56d3862
    li x3, 0xd56d3862
    csrw 0x22f, x3

    #Unmapped address 0x7f2 testing: random write/read operations
    #Address 0x7f2 Write value 0x1a7096f7
    li x3, 0x1a7096f7
    csrw 0x7f2, x3

    #Address 0x7f2 read value
    csrr x14, 0x7f2

    #Address 0x7f2 Write value 0xc67c89cc
    li x3, 0xc67c89cc
    csrw 0x7f2, x3

    #Unmapped address 0x4d8 testing: random write/read operations
    #Address 0x4d8 read value
    csrr x14, 0x4d8

    #Address 0x4d8 read value
    csrr x14, 0x4d8

    #Address 0x4d8 read value
    csrr x14, 0x4d8

    #Address 0x4d8 read value
    csrr x14, 0x4d8

    #Mapped address 0x336 (mhpmevent22) testing: random write/read operations
    #Address 0x336 read value
    csrr x14, 0x336

    #Address 0x336 Write value 0x97ed8c03
    li x3, 0x97ed8c03
    csrw 0x336, x3

    #Address 0x336 read value
    csrr x14, 0x336

    #Address 0x336 Write value 0x522efc15
    li x3, 0x522efc15
    csrw 0x336, x3

    #Address 0x336 read value
    csrr x14, 0x336

    #Unmapped address 0x69f testing: random write/read operations
    #Address 0x69f Write value 0xfbe464d8
    li x3, 0xfbe464d8
    csrw 0x69f, x3

    #Address 0x69f Write value 0xfeeab43f
    li x3, 0xfeeab43f
    csrw 0x69f, x3

    #Address 0x69f read value
    csrr x14, 0x69f

    #Address 0x69f Write value 0x7ee08112
    li x3, 0x7ee08112
    csrw 0x69f, x3

    #Unmapped address 0xb6b testing: random write/read operations
    #Address 0xb6b read value
    csrr x14, 0xb6b

    #Address 0xb6b read value
    csrr x14, 0xb6b

    #Unmapped address 0x77b testing: random write/read operations
    #Address 0x77b Write value 0x75b0e176
    li x3, 0x75b0e176
    csrw 0x77b, x3

    #Address 0x77b read value
    csrr x14, 0x77b

    #Address 0x77b Write value 0x915140da
    li x3, 0x915140da
    csrw 0x77b, x3

    #Address 0x77b Write value 0xc11c2ae2
    li x3, 0xc11c2ae2
    csrw 0x77b, x3

    #Address 0x77b read value
    csrr x14, 0x77b

    #Unmapped address 0xc81 testing: random write/read operations
    #Address 0xc81 read value
    csrr x14, 0xc81

    #Address 0xc81 Write value 0x8f55c812
    li x3, 0x8f55c812
    csrw 0xc81, x3

    #Unmapped address 0xd76 testing: random write/read operations
    #Address 0xd76 read value
    csrr x14, 0xd76

    #Address 0xd76 read value
    csrr x14, 0xd76

    #Address 0xd76 read value
    csrr x14, 0xd76

    #Address 0xd76 read value
    csrr x14, 0xd76

    #Unmapped address 0x3d7 testing: random write/read operations
    #Address 0x3d7 Write value 0x40f2f670
    li x3, 0x40f2f670
    csrw 0x3d7, x3

    #Address 0x3d7 read value
    csrr x14, 0x3d7

    #Address 0x3d7 Write value 0xf4f0bb66
    li x3, 0xf4f0bb66
    csrw 0x3d7, x3

    #Address 0x3d7 Write value 0x8a7f1ae6
    li x3, 0x8a7f1ae6
    csrw 0x3d7, x3

    #Unmapped address 0xe18 testing: random write/read operations
    #Address 0xe18 Write value 0x6a92cd61
    li x3, 0x6a92cd61
    csrw 0xe18, x3

    #Unmapped address 0x517 testing: random write/read operations
    #Address 0x517 read value
    csrr x14, 0x517

    #Address 0x517 Write value 0x26c67861
    li x3, 0x26c67861
    csrw 0x517, x3

    #Address 0x517 read value
    csrr x14, 0x517

    #Address 0x517 read value
    csrr x14, 0x517

    #Address 0x517 Write value 0xc2bfbd85
    li x3, 0xc2bfbd85
    csrw 0x517, x3

    #Unmapped address 0x77d testing: random write/read operations
    #Address 0x77d Write value 0xf9f7984d
    li x3, 0xf9f7984d
    csrw 0x77d, x3

    #Address 0x77d read value
    csrr x14, 0x77d

    #Address 0x77d Write value 0x51123154
    li x3, 0x51123154
    csrw 0x77d, x3

    #Unmapped address 0x976 testing: random write/read operations
    #Address 0x976 read value
    csrr x14, 0x976

    #Address 0x976 read value
    csrr x14, 0x976

    #Address 0x976 read value
    csrr x14, 0x976

    #Address 0x976 read value
    csrr x14, 0x976

    #Address 0x976 read value
    csrr x14, 0x976

    #Unmapped address 0x835 testing: random write/read operations
    #Address 0x835 read value
    csrr x14, 0x835

    #Address 0x835 Write value 0xf2bc7a88
    li x3, 0xf2bc7a88
    csrw 0x835, x3

    #Unmapped address 0x7 testing: random write/read operations
    #Address 0x7 Write value 0xb0a3a84a
    li x3, 0xb0a3a84a
    csrw 0x7, x3

    #Address 0x7 read value
    csrr x14, 0x7

    #Address 0x7 read value
    csrr x14, 0x7

    #Unmapped address 0xf32 testing: random write/read operations
    #Address 0xf32 Write value 0xdef8d1b4
    li x3, 0xdef8d1b4
    csrw 0xf32, x3

    #Address 0xf32 Write value 0xad0337c5
    li x3, 0xad0337c5
    csrw 0xf32, x3

    #Address 0xf32 Write value 0x4adaa239
    li x3, 0x4adaa239
    csrw 0xf32, x3

    #Unmapped address 0xfd3 testing: random write/read operations
    #Address 0xfd3 read value
    csrr x14, 0xfd3

    #Unmapped address 0xd36 testing: random write/read operations
    #Address 0xd36 Write value 0xa8134f55
    li x3, 0xa8134f55
    csrw 0xd36, x3

    #Unmapped address 0x6fd testing: random write/read operations
    #Address 0x6fd read value
    csrr x14, 0x6fd

    #Address 0x6fd read value
    csrr x14, 0x6fd

    #Address 0x6fd Write value 0xb2a18d57
    li x3, 0xb2a18d57
    csrw 0x6fd, x3

    #Address 0x6fd read value
    csrr x14, 0x6fd

    #Address 0x6fd read value
    csrr x14, 0x6fd

    #Unmapped address 0xf60 testing: random write/read operations
    #Address 0xf60 Write value 0xabbf9528
    li x3, 0xabbf9528
    csrw 0xf60, x3

    #Unmapped address 0x77c testing: random write/read operations
    #Address 0x77c read value
    csrr x14, 0x77c

    #Address 0x77c Write value 0x57e66ca4
    li x3, 0x57e66ca4
    csrw 0x77c, x3

    #Address 0x77c Write value 0x26a057bf
    li x3, 0x26a057bf
    csrw 0x77c, x3

    #Address 0x77c Write value 0x7823a175
    li x3, 0x7823a175
    csrw 0x77c, x3

    #Address 0x77c Write value 0xd9a1112a
    li x3, 0xd9a1112a
    csrw 0x77c, x3

    #Unmapped address 0xa68 testing: random write/read operations
    #Address 0xa68 read value
    csrr x14, 0xa68

    #Address 0xa68 read value
    csrr x14, 0xa68

    #Address 0xa68 Write value 0xd99a7003
    li x3, 0xd99a7003
    csrw 0xa68, x3

    #Unmapped address 0xed9 testing: random write/read operations
    #Address 0xed9 read value
    csrr x14, 0xed9

    #Unmapped address 0xf3b testing: random write/read operations
    #Address 0xf3b Write value 0x99f82c5b
    li x3, 0x99f82c5b
    csrw 0xf3b, x3

    #Unmapped address 0x7a1 testing: random write/read operations
    #Address 0x7a1 read value
    csrr x14, 0x7a1

    #Address 0x7a1 read value
    csrr x14, 0x7a1

    #Address 0x7a1 Write value 0xbc06f6c5
    li x3, 0xbc06f6c5
    csrw 0x7a1, x3

    #Address 0x7a1 Write value 0x1e1a05a7
    li x3, 0x1e1a05a7
    csrw 0x7a1, x3

    #Unmapped address 0xa3e testing: random write/read operations
    #Address 0xa3e Write value 0xeaa02813
    li x3, 0xeaa02813
    csrw 0xa3e, x3

    #Address 0xa3e Write value 0x8c2c5c81
    li x3, 0x8c2c5c81
    csrw 0xa3e, x3

    #Address 0xa3e read value
    csrr x14, 0xa3e

    #Address 0xa3e read value
    csrr x14, 0xa3e

    #Unmapped address 0xfea testing: random write/read operations
    #Address 0xfea read value
    csrr x14, 0xfea

    #Address 0xfea read value
    csrr x14, 0xfea

    #Address 0xfea read value
    csrr x14, 0xfea

    #Address 0xfea Write value 0x2ba059b0
    li x3, 0x2ba059b0
    csrw 0xfea, x3

    #Address 0xfea Write value 0xb52407db
    li x3, 0xb52407db
    csrw 0xfea, x3

    #Unmapped address 0x5ac testing: random write/read operations
    #Address 0x5ac Write value 0x2ed574b8
    li x3, 0x2ed574b8
    csrw 0x5ac, x3

    #Unmapped address 0xb4e testing: random write/read operations
    #Address 0xb4e read value
    csrr x14, 0xb4e

    #Address 0xb4e read value
    csrr x14, 0xb4e

    #Address 0xb4e Write value 0xc3a6f58
    li x3, 0xc3a6f58
    csrw 0xb4e, x3

    #Address 0xb4e Write value 0xeed8d4a3
    li x3, 0xeed8d4a3
    csrw 0xb4e, x3

    #Address 0xb4e read value
    csrr x14, 0xb4e

    #Unmapped address 0xe73 testing: random write/read operations
    #Address 0xe73 read value
    csrr x14, 0xe73

    #Address 0xe73 read value
    csrr x14, 0xe73

    #Address 0xe73 read value
    csrr x14, 0xe73

    #Address 0xe73 read value
    csrr x14, 0xe73

    #Unmapped address 0x838 testing: random write/read operations
    #Address 0x838 Write value 0x560dd1f9
    li x3, 0x560dd1f9
    csrw 0x838, x3

    #Address 0x838 read value
    csrr x14, 0x838

    #Address 0x838 Write value 0x407872ff
    li x3, 0x407872ff
    csrw 0x838, x3

    #Address 0x838 Write value 0x6b7a22af
    li x3, 0x6b7a22af
    csrw 0x838, x3

    #Address 0x838 read value
    csrr x14, 0x838

    #Unmapped address 0xcf6 testing: random write/read operations
    #Address 0xcf6 read value
    csrr x14, 0xcf6

    #Address 0xcf6 Write value 0x95f573e8
    li x3, 0x95f573e8
    csrw 0xcf6, x3

    #Address 0xcf6 Write value 0xed2924ca
    li x3, 0xed2924ca
    csrw 0xcf6, x3

    #Unmapped address 0x3cc testing: random write/read operations
    #Address 0x3cc Write value 0x72cfb8b9
    li x3, 0x72cfb8b9
    csrw 0x3cc, x3

    #Address 0x3cc Write value 0xf2685944
    li x3, 0xf2685944
    csrw 0x3cc, x3

    #Address 0x3cc Write value 0x2a591162
    li x3, 0x2a591162
    csrw 0x3cc, x3

    #Address 0x3cc read value
    csrr x14, 0x3cc

    #Unmapped address 0x9a3 testing: random write/read operations
    #Address 0x9a3 read value
    csrr x14, 0x9a3

    #Unmapped address 0xc85 testing: random write/read operations
    #Address 0xc85 read value
    csrr x14, 0xc85

    #Address 0xc85 read value
    csrr x14, 0xc85

    #Unmapped address 0xa95 testing: random write/read operations
    #Address 0xa95 Write value 0x4abfaead
    li x3, 0x4abfaead
    csrw 0xa95, x3

    #Address 0xa95 Write value 0x3657758b
    li x3, 0x3657758b
    csrw 0xa95, x3

    #Unmapped address 0x3b testing: random write/read operations
    #Address 0x3b Write value 0x30872385
    li x3, 0x30872385
    csrw 0x3b, x3

    #Address 0x3b read value
    csrr x14, 0x3b

    #Unmapped address 0xa3d testing: random write/read operations
    #Address 0xa3d read value
    csrr x14, 0xa3d

    #Address 0xa3d Write value 0x2b5637ce
    li x3, 0x2b5637ce
    csrw 0xa3d, x3

    #Unmapped address 0xc13 testing: random write/read operations
    #Address 0xc13 read value
    csrr x14, 0xc13

    #Unmapped address 0x244 testing: random write/read operations
    #Address 0x244 read value
    csrr x14, 0x244

    #Address 0x244 read value
    csrr x14, 0x244

    #Address 0x244 Write value 0x7db74341
    li x3, 0x7db74341
    csrw 0x244, x3

    #Unmapped address 0x95a testing: random write/read operations
    #Address 0x95a Write value 0xe7185b93
    li x3, 0xe7185b93
    csrw 0x95a, x3

    #Address 0x95a Write value 0xb0421206
    li x3, 0xb0421206
    csrw 0x95a, x3

    #Address 0x95a Write value 0xc5bf1871
    li x3, 0xc5bf1871
    csrw 0x95a, x3

    #Address 0x95a read value
    csrr x14, 0x95a

    #Unmapped address 0xb66 testing: random write/read operations
    #Address 0xb66 read value
    csrr x14, 0xb66

    #Unmapped address 0xcf7 testing: random write/read operations
    #Address 0xcf7 Write value 0x306711cf
    li x3, 0x306711cf
    csrw 0xcf7, x3

    #Address 0xcf7 read value
    csrr x14, 0xcf7

    #Address 0xcf7 Write value 0xc409778b
    li x3, 0xc409778b
    csrw 0xcf7, x3

    #Address 0xcf7 read value
    csrr x14, 0xcf7

    #Unmapped address 0xfd6 testing: random write/read operations
    #Address 0xfd6 Write value 0x92a9a8db
    li x3, 0x92a9a8db
    csrw 0xfd6, x3

    #Address 0xfd6 Write value 0x9988c1ae
    li x3, 0x9988c1ae
    csrw 0xfd6, x3

    #Address 0xfd6 Write value 0x15c4c987
    li x3, 0x15c4c987
    csrw 0xfd6, x3

    #Unmapped address 0x5af testing: random write/read operations
    #Address 0x5af read value
    csrr x14, 0x5af

    #Address 0x5af read value
    csrr x14, 0x5af

    #Address 0x5af Write value 0x97ebf99d
    li x3, 0x97ebf99d
    csrw 0x5af, x3

    #Address 0x5af Write value 0xec3d403b
    li x3, 0xec3d403b
    csrw 0x5af, x3

    #Unmapped address 0x7fe testing: random write/read operations
    #Address 0x7fe read value
    csrr x14, 0x7fe

    #Unmapped address 0xcb4 testing: random write/read operations
    #Address 0xcb4 read value
    csrr x14, 0xcb4

    #Unmapped address 0x6bf testing: random write/read operations
    #Address 0x6bf Write value 0x5e7acf0f
    li x3, 0x5e7acf0f
    csrw 0x6bf, x3

    #Address 0x6bf Write value 0x23a14975
    li x3, 0x23a14975
    csrw 0x6bf, x3

    #Address 0x6bf read value
    csrr x14, 0x6bf

    #Unmapped address 0x41b testing: random write/read operations
    #Address 0x41b read value
    csrr x14, 0x41b

    #Address 0x41b Write value 0x78ab2b8a
    li x3, 0x78ab2b8a
    csrw 0x41b, x3

    #Unmapped address 0x5e9 testing: random write/read operations
    #Address 0x5e9 Write value 0x5a1f2da4
    li x3, 0x5a1f2da4
    csrw 0x5e9, x3

    #Address 0x5e9 read value
    csrr x14, 0x5e9

    #Unmapped address 0x77e testing: random write/read operations
    #Address 0x77e read value
    csrr x14, 0x77e

    #Address 0x77e read value
    csrr x14, 0x77e

    #Address 0x77e read value
    csrr x14, 0x77e

    #Address 0x77e read value
    csrr x14, 0x77e

    #Address 0x77e read value
    csrr x14, 0x77e

    #Unmapped address 0xefc testing: random write/read operations
    #Address 0xefc Write value 0x8b2c9891
    li x3, 0x8b2c9891
    csrw 0xefc, x3

    #Address 0xefc Write value 0x6be9c3fd
    li x3, 0x6be9c3fd
    csrw 0xefc, x3

    #Unmapped address 0xf47 testing: random write/read operations
    #Address 0xf47 Write value 0xc66322ee
    li x3, 0xc66322ee
    csrw 0xf47, x3

    #Address 0xf47 read value
    csrr x14, 0xf47

    #Address 0xf47 read value
    csrr x14, 0xf47

    #Unmapped address 0x4e testing: random write/read operations
    #Address 0x4e Write value 0xd6683681
    li x3, 0xd6683681
    csrw 0x4e, x3

    #Address 0x4e Write value 0xb8fe2994
    li x3, 0xb8fe2994
    csrw 0x4e, x3

    #Unmapped address 0x20e testing: random write/read operations
    #Address 0x20e read value
    csrr x14, 0x20e

    #Address 0x20e read value
    csrr x14, 0x20e

    #Address 0x20e Write value 0xa288efd6
    li x3, 0xa288efd6
    csrw 0x20e, x3

    #Address 0x20e Write value 0x2f995802
    li x3, 0x2f995802
    csrw 0x20e, x3

    #Mapped address 0xf12 (marchid) testing: random write/read operations
    #Address 0xf12 Write value 0x662bb461
    li x3, 0x662bb461
    csrw 0xf12, x3

    #Unmapped address 0x627 testing: random write/read operations
    #Address 0x627 Write value 0x9a0c538c
    li x3, 0x9a0c538c
    csrw 0x627, x3

    #Address 0x627 Write value 0xbe7a5158
    li x3, 0xbe7a5158
    csrw 0x627, x3

    #Address 0x627 Write value 0x76097421
    li x3, 0x76097421
    csrw 0x627, x3

    #Unmapped address 0x841 testing: random write/read operations
    #Address 0x841 read value
    csrr x14, 0x841

    #Address 0x841 read value
    csrr x14, 0x841

    #Address 0x841 Write value 0x637d12ce
    li x3, 0x637d12ce
    csrw 0x841, x3

    #Unmapped address 0x5d5 testing: random write/read operations
    #Address 0x5d5 read value
    csrr x14, 0x5d5

    #Address 0x5d5 read value
    csrr x14, 0x5d5

    #Address 0x5d5 read value
    csrr x14, 0x5d5

    #Address 0x5d5 Write value 0x3686b03c
    li x3, 0x3686b03c
    csrw 0x5d5, x3

    #Unmapped address 0x239 testing: random write/read operations
    #Address 0x239 Write value 0xbc6b79fc
    li x3, 0xbc6b79fc
    csrw 0x239, x3

    #Unmapped address 0xaed testing: random write/read operations
    #Address 0xaed Write value 0x8e1d3ba4
    li x3, 0x8e1d3ba4
    csrw 0xaed, x3

    #Address 0xaed Write value 0x1042e548
    li x3, 0x1042e548
    csrw 0xaed, x3

    #Unmapped address 0xc7e testing: random write/read operations
    #Address 0xc7e Write value 0xcd9726e9
    li x3, 0xcd9726e9
    csrw 0xc7e, x3

    #Address 0xc7e read value
    csrr x14, 0xc7e

    #Unmapped address 0x57f testing: random write/read operations
    #Address 0x57f Write value 0xc56a87ec
    li x3, 0xc56a87ec
    csrw 0x57f, x3

    #Address 0x57f Write value 0x1c24f246
    li x3, 0x1c24f246
    csrw 0x57f, x3

    #Unmapped address 0xbdb testing: random write/read operations
    #Address 0xbdb read value
    csrr x14, 0xbdb

    #Address 0xbdb read value
    csrr x14, 0xbdb

    #Address 0xbdb read value
    csrr x14, 0xbdb

    #Address 0xbdb Write value 0x8e48578
    li x3, 0x8e48578
    csrw 0xbdb, x3

    #Unmapped address 0xd81 testing: random write/read operations
    #Address 0xd81 read value
    csrr x14, 0xd81

    #Address 0xd81 read value
    csrr x14, 0xd81

    #Address 0xd81 read value
    csrr x14, 0xd81

    #Address 0xd81 read value
    csrr x14, 0xd81

    #Address 0xd81 Write value 0x3a94466a
    li x3, 0x3a94466a
    csrw 0xd81, x3

    #Unmapped address 0x9fa testing: random write/read operations
    #Address 0x9fa Write value 0x5d93a4e7
    li x3, 0x5d93a4e7
    csrw 0x9fa, x3

    #Unmapped address 0x47e testing: random write/read operations
    #Address 0x47e Write value 0x4ef94a53
    li x3, 0x4ef94a53
    csrw 0x47e, x3

    #Address 0x47e read value
    csrr x14, 0x47e

    #Unmapped address 0xe05 testing: random write/read operations
    #Address 0xe05 Write value 0x8368a064
    li x3, 0x8368a064
    csrw 0xe05, x3

    #Address 0xe05 read value
    csrr x14, 0xe05

    #Address 0xe05 read value
    csrr x14, 0xe05

    #Address 0xe05 read value
    csrr x14, 0xe05

    #Unmapped address 0x9f8 testing: random write/read operations
    #Address 0x9f8 Write value 0x220a1341
    li x3, 0x220a1341
    csrw 0x9f8, x3

    #Unmapped address 0x194 testing: random write/read operations
    #Address 0x194 Write value 0x5614d6f7
    li x3, 0x5614d6f7
    csrw 0x194, x3

    #Address 0x194 Write value 0xf6e48785
    li x3, 0xf6e48785
    csrw 0x194, x3

    #Unmapped address 0xa32 testing: random write/read operations
    #Address 0xa32 read value
    csrr x14, 0xa32

    #Unmapped address 0x5b testing: random write/read operations
    #Address 0x5b read value
    csrr x14, 0x5b

    #Address 0x5b Write value 0xfa624ef7
    li x3, 0xfa624ef7
    csrw 0x5b, x3

    #Address 0x5b Write value 0x64e798b
    li x3, 0x64e798b
    csrw 0x5b, x3

    #Address 0x5b Write value 0xcf9b25ba
    li x3, 0xcf9b25ba
    csrw 0x5b, x3

    #Unmapped address 0x18e testing: random write/read operations
    #Address 0x18e Write value 0xcc8957ca
    li x3, 0xcc8957ca
    csrw 0x18e, x3

    #Address 0x18e read value
    csrr x14, 0x18e

    #Address 0x18e read value
    csrr x14, 0x18e

    #Unmapped address 0x3fd testing: random write/read operations
    #Address 0x3fd Write value 0x6d84eca3
    li x3, 0x6d84eca3
    csrw 0x3fd, x3

    #Address 0x3fd read value
    csrr x14, 0x3fd

    #Address 0x3fd read value
    csrr x14, 0x3fd

    #Unmapped address 0xac7 testing: random write/read operations
    #Address 0xac7 Write value 0x7c7e6f24
    li x3, 0x7c7e6f24
    csrw 0xac7, x3

    #Address 0xac7 read value
    csrr x14, 0xac7

    #Address 0xac7 read value
    csrr x14, 0xac7

    #Address 0xac7 read value
    csrr x14, 0xac7

    #Address 0xac7 read value
    csrr x14, 0xac7

    #Unmapped address 0x431 testing: random write/read operations
    #Address 0x431 Write value 0x573949d1
    li x3, 0x573949d1
    csrw 0x431, x3

    #Address 0x431 Write value 0xa3075dcd
    li x3, 0xa3075dcd
    csrw 0x431, x3

    #Address 0x431 Write value 0xe2f01123
    li x3, 0xe2f01123
    csrw 0x431, x3

    #Unmapped address 0x651 testing: random write/read operations
    #Address 0x651 read value
    csrr x14, 0x651

    #Address 0x651 Write value 0xc78cd63f
    li x3, 0xc78cd63f
    csrw 0x651, x3

    #Unmapped address 0x387 testing: random write/read operations
    #Address 0x387 Write value 0x48b40bcd
    li x3, 0x48b40bcd
    csrw 0x387, x3

    #Address 0x387 Write value 0x586f7d39
    li x3, 0x586f7d39
    csrw 0x387, x3

    #Address 0x387 read value
    csrr x14, 0x387

    #Address 0x387 Write value 0x64504658
    li x3, 0x64504658
    csrw 0x387, x3

    #Unmapped address 0x226 testing: random write/read operations
    #Address 0x226 read value
    csrr x14, 0x226

    #Unmapped address 0xb7e testing: random write/read operations
    #Address 0xb7e read value
    csrr x14, 0xb7e

    #Unmapped address 0xca testing: random write/read operations
    #Address 0xca read value
    csrr x14, 0xca

    #Address 0xca Write value 0x7e72b0e5
    li x3, 0x7e72b0e5
    csrw 0xca, x3

    #Address 0xca Write value 0xc4d04b79
    li x3, 0xc4d04b79
    csrw 0xca, x3

    #Unmapped address 0xbdc testing: random write/read operations
    #Address 0xbdc Write value 0xb6a50ba5
    li x3, 0xb6a50ba5
    csrw 0xbdc, x3

    #Address 0xbdc read value
    csrr x14, 0xbdc

    #Address 0xbdc read value
    csrr x14, 0xbdc

    #Address 0xbdc read value
    csrr x14, 0xbdc

    #Mapped address 0xb9d (mhpmcounterh29) testing: random write/read operations
    #Address 0xb9d read value
    csrr x14, 0xb9d

    #Unmapped address 0x989 testing: random write/read operations
    #Address 0x989 read value
    csrr x14, 0x989

    #Address 0x989 Write value 0xba29905c
    li x3, 0xba29905c
    csrw 0x989, x3

    #Address 0x989 Write value 0xc7ab2951
    li x3, 0xc7ab2951
    csrw 0x989, x3

    #Address 0x989 read value
    csrr x14, 0x989

    #Address 0x989 read value
    csrr x14, 0x989

    #Unmapped address 0xa5 testing: random write/read operations
    #Address 0xa5 Write value 0x28c9e867
    li x3, 0x28c9e867
    csrw 0xa5, x3

    #Unmapped address 0xd45 testing: random write/read operations
    #Address 0xd45 Write value 0x4f309797
    li x3, 0x4f309797
    csrw 0xd45, x3

    #Address 0xd45 read value
    csrr x14, 0xd45

    #Unmapped address 0xdc0 testing: random write/read operations
    #Address 0xdc0 Write value 0x99787b4f
    li x3, 0x99787b4f
    csrw 0xdc0, x3

    #Address 0xdc0 Write value 0xfbfb7712
    li x3, 0xfbfb7712
    csrw 0xdc0, x3

    #Address 0xdc0 read value
    csrr x14, 0xdc0

    #Unmapped address 0x258 testing: random write/read operations
    #Address 0x258 read value
    csrr x14, 0x258

    #Address 0x258 Write value 0xb2747ab5
    li x3, 0xb2747ab5
    csrw 0x258, x3

    #Address 0x258 read value
    csrr x14, 0x258

    #Address 0x258 Write value 0xef1376
    li x3, 0xef1376
    csrw 0x258, x3

    #Address 0x258 Write value 0x542bc08
    li x3, 0x542bc08
    csrw 0x258, x3

    #Unmapped address 0xf49 testing: random write/read operations
    #Address 0xf49 read value
    csrr x14, 0xf49

    #Address 0xf49 Write value 0x2c0bd224
    li x3, 0x2c0bd224
    csrw 0xf49, x3

    #Unmapped address 0xc92 testing: random write/read operations
    #Address 0xc92 read value
    csrr x14, 0xc92

    #Unmapped address 0xe65 testing: random write/read operations
    #Address 0xe65 Write value 0x7769e164
    li x3, 0x7769e164
    csrw 0xe65, x3

    #Address 0xe65 read value
    csrr x14, 0xe65

    #Address 0xe65 Write value 0xee775f75
    li x3, 0xee775f75
    csrw 0xe65, x3

    #Address 0xe65 read value
    csrr x14, 0xe65

    #Unmapped address 0x91e testing: random write/read operations
    #Address 0x91e read value
    csrr x14, 0x91e

    #Address 0x91e read value
    csrr x14, 0x91e

    #Address 0x91e read value
    csrr x14, 0x91e

    #Unmapped address 0x8b6 testing: random write/read operations
    #Address 0x8b6 Write value 0x2951fd03
    li x3, 0x2951fd03
    csrw 0x8b6, x3

    #Unmapped address 0x1c8 testing: random write/read operations
    #Address 0x1c8 read value
    csrr x14, 0x1c8

    #Address 0x1c8 Write value 0x5cd3e4e0
    li x3, 0x5cd3e4e0
    csrw 0x1c8, x3

    #Address 0x1c8 Write value 0xe96377b8
    li x3, 0xe96377b8
    csrw 0x1c8, x3

    #Unmapped address 0x600 testing: random write/read operations
    #Address 0x600 read value
    csrr x14, 0x600

    #Address 0x600 read value
    csrr x14, 0x600

    #Unmapped address 0xe50 testing: random write/read operations
    #Address 0xe50 read value
    csrr x14, 0xe50

    #Address 0xe50 Write value 0xf226ab88
    li x3, 0xf226ab88
    csrw 0xe50, x3

    #Address 0xe50 read value
    csrr x14, 0xe50

    #Address 0xe50 read value
    csrr x14, 0xe50

    #Unmapped address 0x6 testing: random write/read operations
    #Address 0x6 Write value 0x916f01e7
    li x3, 0x916f01e7
    csrw 0x6, x3

    #Address 0x6 read value
    csrr x14, 0x6

    #Unmapped address 0x154 testing: random write/read operations
    #Address 0x154 read value
    csrr x14, 0x154

    #Address 0x154 Write value 0x9be854af
    li x3, 0x9be854af
    csrw 0x154, x3

    #Address 0x154 read value
    csrr x14, 0x154

    #Address 0x154 read value
    csrr x14, 0x154

    #Unmapped address 0x14e testing: random write/read operations
    #Address 0x14e Write value 0xa0e56ac4
    li x3, 0xa0e56ac4
    csrw 0x14e, x3

    #Mapped address 0xb98 (mhpmcounterh24) testing: random write/read operations
    #Address 0xb98 Write value 0x30c5d5fb
    li x3, 0x30c5d5fb
    csrw 0xb98, x3

    #Address 0xb98 Write value 0x29c1cafd
    li x3, 0x29c1cafd
    csrw 0xb98, x3

    #Address 0xb98 Write value 0x813270c4
    li x3, 0x813270c4
    csrw 0xb98, x3

    #Unmapped address 0xc46 testing: random write/read operations
    #Address 0xc46 read value
    csrr x14, 0xc46

    #Address 0xc46 Write value 0xbf24f18d
    li x3, 0xbf24f18d
    csrw 0xc46, x3

    #Address 0xc46 read value
    csrr x14, 0xc46

    #Address 0xc46 Write value 0x2602ecf
    li x3, 0x2602ecf
    csrw 0xc46, x3

    #Unmapped address 0x72d testing: random write/read operations
    #Address 0x72d read value
    csrr x14, 0x72d

    #Address 0x72d read value
    csrr x14, 0x72d

    #Address 0x72d Write value 0x4a595f29
    li x3, 0x4a595f29
    csrw 0x72d, x3

    #Unmapped address 0x531 testing: random write/read operations
    #Address 0x531 read value
    csrr x14, 0x531

    #Address 0x531 Write value 0x93807d3d
    li x3, 0x93807d3d
    csrw 0x531, x3

    #Address 0x531 Write value 0xefc03bdb
    li x3, 0xefc03bdb
    csrw 0x531, x3

    #Address 0x531 read value
    csrr x14, 0x531

    #Unmapped address 0xd13 testing: random write/read operations
    #Address 0xd13 read value
    csrr x14, 0xd13

    #Address 0xd13 read value
    csrr x14, 0xd13

    #Address 0xd13 read value
    csrr x14, 0xd13

    #Unmapped address 0x9cc testing: random write/read operations
    #Address 0x9cc read value
    csrr x14, 0x9cc

    #Address 0x9cc Write value 0xcbf6055f
    li x3, 0xcbf6055f
    csrw 0x9cc, x3

    #Address 0x9cc read value
    csrr x14, 0x9cc

    #Address 0x9cc Write value 0x6e0a9f0e
    li x3, 0x6e0a9f0e
    csrw 0x9cc, x3

    #Unmapped address 0xe6b testing: random write/read operations
    #Address 0xe6b read value
    csrr x14, 0xe6b

    #Address 0xe6b read value
    csrr x14, 0xe6b

    #Address 0xe6b Write value 0x12077120
    li x3, 0x12077120
    csrw 0xe6b, x3

    #Unmapped address 0x985 testing: random write/read operations
    #Address 0x985 Write value 0xadfd6b63
    li x3, 0xadfd6b63
    csrw 0x985, x3

    #Address 0x985 read value
    csrr x14, 0x985

    #Address 0x985 Write value 0xf6d1df78
    li x3, 0xf6d1df78
    csrw 0x985, x3

    #Unmapped address 0x7f0 testing: random write/read operations
    #Address 0x7f0 Write value 0xe9d566fa
    li x3, 0xe9d566fa
    csrw 0x7f0, x3

    #Address 0x7f0 Write value 0x1ac5bf72
    li x3, 0x1ac5bf72
    csrw 0x7f0, x3

    #Address 0x7f0 read value
    csrr x14, 0x7f0

    #Address 0x7f0 Write value 0xf774fcc6
    li x3, 0xf774fcc6
    csrw 0x7f0, x3

    #Unmapped address 0x846 testing: random write/read operations
    #Address 0x846 read value
    csrr x14, 0x846

    #Address 0x846 Write value 0x59768e9c
    li x3, 0x59768e9c
    csrw 0x846, x3

    #Address 0x846 read value
    csrr x14, 0x846

    #Address 0x846 Write value 0x31a0eb63
    li x3, 0x31a0eb63
    csrw 0x846, x3

    #Address 0x846 read value
    csrr x14, 0x846

    #Unmapped address 0x73b testing: random write/read operations
    #Address 0x73b Write value 0x281b6b8b
    li x3, 0x281b6b8b
    csrw 0x73b, x3

    #Unmapped address 0xcae testing: random write/read operations
    #Address 0xcae Write value 0x7c083977
    li x3, 0x7c083977
    csrw 0xcae, x3

    #Unmapped address 0xdef testing: random write/read operations
    #Address 0xdef read value
    csrr x14, 0xdef

    #Address 0xdef Write value 0x51cff50b
    li x3, 0x51cff50b
    csrw 0xdef, x3

    #Address 0xdef Write value 0x3e834555
    li x3, 0x3e834555
    csrw 0xdef, x3

    #Address 0xdef read value
    csrr x14, 0xdef

    #Address 0xdef read value
    csrr x14, 0xdef

    #Unmapped address 0x446 testing: random write/read operations
    #Address 0x446 read value
    csrr x14, 0x446

    #Unmapped address 0x5f testing: random write/read operations
    #Address 0x5f Write value 0x405ee431
    li x3, 0x405ee431
    csrw 0x5f, x3

    #Unmapped address 0x2e9 testing: random write/read operations
    #Address 0x2e9 Write value 0xe42dd305
    li x3, 0xe42dd305
    csrw 0x2e9, x3

    #Address 0x2e9 read value
    csrr x14, 0x2e9

    #Address 0x2e9 Write value 0xc67c90a2
    li x3, 0xc67c90a2
    csrw 0x2e9, x3

    #Address 0x2e9 Write value 0x38f981e8
    li x3, 0x38f981e8
    csrw 0x2e9, x3

    #Unmapped address 0x90d testing: random write/read operations
    #Address 0x90d Write value 0x9d6f8670
    li x3, 0x9d6f8670
    csrw 0x90d, x3

    #Address 0x90d Write value 0x2fd4e4e4
    li x3, 0x2fd4e4e4
    csrw 0x90d, x3

    #Address 0x90d read value
    csrr x14, 0x90d

    #Address 0x90d read value
    csrr x14, 0x90d

    #Address 0x90d Write value 0x95e187f1
    li x3, 0x95e187f1
    csrw 0x90d, x3

    #Unmapped address 0xe41 testing: random write/read operations
    #Address 0xe41 read value
    csrr x14, 0xe41

    #Address 0xe41 Write value 0xdb54079d
    li x3, 0xdb54079d
    csrw 0xe41, x3

    #Address 0xe41 read value
    csrr x14, 0xe41

    #Unmapped address 0x6ec testing: random write/read operations
    #Address 0x6ec Write value 0xf4ae0533
    li x3, 0xf4ae0533
    csrw 0x6ec, x3

    #Address 0x6ec read value
    csrr x14, 0x6ec

    #Address 0x6ec read value
    csrr x14, 0x6ec

    #Address 0x6ec Write value 0xb48c7518
    li x3, 0xb48c7518
    csrw 0x6ec, x3

    #Mapped address 0xb8e (mhpmcounterh14) testing: random write/read operations
    #Address 0xb8e Write value 0xd9dd5df4
    li x3, 0xd9dd5df4
    csrw 0xb8e, x3

    #Address 0xb8e read value
    csrr x14, 0xb8e

    #Unmapped address 0xbfd testing: random write/read operations
    #Address 0xbfd read value
    csrr x14, 0xbfd

    #Address 0xbfd read value
    csrr x14, 0xbfd

    #Address 0xbfd read value
    csrr x14, 0xbfd

    #Address 0xbfd Write value 0x46f721e0
    li x3, 0x46f721e0
    csrw 0xbfd, x3

    #Address 0xbfd read value
    csrr x14, 0xbfd

    #Unmapped address 0x6fc testing: random write/read operations
    #Address 0x6fc read value
    csrr x14, 0x6fc

    #Address 0x6fc read value
    csrr x14, 0x6fc

    #Address 0x6fc read value
    csrr x14, 0x6fc

    #Address 0x6fc read value
    csrr x14, 0x6fc

    #Address 0x6fc Write value 0xbf2e41a8
    li x3, 0xbf2e41a8
    csrw 0x6fc, x3

    #Unmapped address 0xf27 testing: random write/read operations
    #Address 0xf27 read value
    csrr x14, 0xf27

    #Unmapped address 0x9a4 testing: random write/read operations
    #Address 0x9a4 read value
    csrr x14, 0x9a4

    #Address 0x9a4 Write value 0x3d885ddd
    li x3, 0x3d885ddd
    csrw 0x9a4, x3

    #Address 0x9a4 Write value 0xcbd26a88
    li x3, 0xcbd26a88
    csrw 0x9a4, x3

    #Address 0x9a4 Write value 0xfb083a0e
    li x3, 0xfb083a0e
    csrw 0x9a4, x3

    #Unmapped address 0x6d testing: random write/read operations
    #Address 0x6d read value
    csrr x14, 0x6d

    #Address 0x6d Write value 0x323fd89b
    li x3, 0x323fd89b
    csrw 0x6d, x3

    #Unmapped address 0x5a8 testing: random write/read operations
    #Address 0x5a8 read value
    csrr x14, 0x5a8

    #Address 0x5a8 Write value 0x9288579d
    li x3, 0x9288579d
    csrw 0x5a8, x3

    #Address 0x5a8 Write value 0x22809e06
    li x3, 0x22809e06
    csrw 0x5a8, x3

    #Unmapped address 0x28f testing: random write/read operations
    #Address 0x28f Write value 0xb8bab731
    li x3, 0xb8bab731
    csrw 0x28f, x3

    #Address 0x28f Write value 0x11bf8208
    li x3, 0x11bf8208
    csrw 0x28f, x3

    #Unmapped address 0x804 testing: random write/read operations
    #Address 0x804 read value
    csrr x14, 0x804

    #Address 0x804 read value
    csrr x14, 0x804

    #Address 0x804 read value
    csrr x14, 0x804

    #Address 0x804 Write value 0x770d3633
    li x3, 0x770d3633
    csrw 0x804, x3

    #Address 0x804 Write value 0x88003983
    li x3, 0x88003983
    csrw 0x804, x3

    #Unmapped address 0xd03 testing: random write/read operations
    #Address 0xd03 read value
    csrr x14, 0xd03

    #Address 0xd03 Write value 0x1d199fbe
    li x3, 0x1d199fbe
    csrw 0xd03, x3

    #Unmapped address 0x4dc testing: random write/read operations
    #Address 0x4dc Write value 0x992fd497
    li x3, 0x992fd497
    csrw 0x4dc, x3

    #Address 0x4dc Write value 0xc3e77878
    li x3, 0xc3e77878
    csrw 0x4dc, x3

    #Address 0x4dc read value
    csrr x14, 0x4dc

    #Address 0x4dc read value
    csrr x14, 0x4dc

    #Address 0x4dc read value
    csrr x14, 0x4dc

    #Unmapped address 0x3ca testing: random write/read operations
    #Address 0x3ca read value
    csrr x14, 0x3ca

    #Address 0x3ca Write value 0x9ec96786
    li x3, 0x9ec96786
    csrw 0x3ca, x3

    #Address 0x3ca read value
    csrr x14, 0x3ca

    #Address 0x3ca Write value 0xef8f4c59
    li x3, 0xef8f4c59
    csrw 0x3ca, x3

    #Address 0x3ca Write value 0xb7a93bf4
    li x3, 0xb7a93bf4
    csrw 0x3ca, x3

    #Unmapped address 0x619 testing: random write/read operations
    #Address 0x619 Write value 0xf07f29ee
    li x3, 0xf07f29ee
    csrw 0x619, x3

    #Address 0x619 Write value 0xf02b999c
    li x3, 0xf02b999c
    csrw 0x619, x3

    #Address 0x619 Write value 0xc1da7f6c
    li x3, 0xc1da7f6c
    csrw 0x619, x3

    #Unmapped address 0x76c testing: random write/read operations
    #Address 0x76c read value
    csrr x14, 0x76c

    #Address 0x76c read value
    csrr x14, 0x76c

    #Address 0x76c Write value 0x8f948f61
    li x3, 0x8f948f61
    csrw 0x76c, x3

    #Address 0x76c read value
    csrr x14, 0x76c

    #Unmapped address 0xe94 testing: random write/read operations
    #Address 0xe94 Write value 0x1b052a9e
    li x3, 0x1b052a9e
    csrw 0xe94, x3

    #Unmapped address 0x8b3 testing: random write/read operations
    #Address 0x8b3 read value
    csrr x14, 0x8b3

    #Unmapped address 0x734 testing: random write/read operations
    #Address 0x734 read value
    csrr x14, 0x734

    #Address 0x734 Write value 0x92d97fd8
    li x3, 0x92d97fd8
    csrw 0x734, x3

    #Address 0x734 read value
    csrr x14, 0x734

    #Address 0x734 read value
    csrr x14, 0x734

    #Address 0x734 Write value 0xeddb230d
    li x3, 0xeddb230d
    csrw 0x734, x3

    #Unmapped address 0x1 testing: random write/read operations
    #Address 0x1 Write value 0x1c45ea97
    li x3, 0x1c45ea97
    csrw 0x1, x3

    #Address 0x1 Write value 0x7a6049b1
    li x3, 0x7a6049b1
    csrw 0x1, x3

    #Unmapped address 0x1ba testing: random write/read operations
    #Address 0x1ba read value
    csrr x14, 0x1ba

    #Address 0x1ba Write value 0xa486c9dd
    li x3, 0xa486c9dd
    csrw 0x1ba, x3

    #Unmapped address 0x46a testing: random write/read operations
    #Address 0x46a read value
    csrr x14, 0x46a

    #Unmapped address 0x4cd testing: random write/read operations
    #Address 0x4cd Write value 0x671e634b
    li x3, 0x671e634b
    csrw 0x4cd, x3

    #Address 0x4cd Write value 0x97bd0b63
    li x3, 0x97bd0b63
    csrw 0x4cd, x3

    #Address 0x4cd read value
    csrr x14, 0x4cd

    #Address 0x4cd Write value 0x2f25157f
    li x3, 0x2f25157f
    csrw 0x4cd, x3

    #Unmapped address 0xa3b testing: random write/read operations
    #Address 0xa3b Write value 0x39873c04
    li x3, 0x39873c04
    csrw 0xa3b, x3

    #Address 0xa3b read value
    csrr x14, 0xa3b

    #Unmapped address 0x3cf testing: random write/read operations
    #Address 0x3cf Write value 0xc7e429a0
    li x3, 0xc7e429a0
    csrw 0x3cf, x3

    #Address 0x3cf Write value 0xc28c96dc
    li x3, 0xc28c96dc
    csrw 0x3cf, x3

    #Unmapped address 0xed1 testing: random write/read operations
    #Address 0xed1 read value
    csrr x14, 0xed1

    #Unmapped address 0xb28 testing: random write/read operations
    #Address 0xb28 read value
    csrr x14, 0xb28

    #Address 0xb28 Write value 0x482ed509
    li x3, 0x482ed509
    csrw 0xb28, x3

    #Address 0xb28 read value
    csrr x14, 0xb28

    #Address 0xb28 Write value 0x4dc35970
    li x3, 0x4dc35970
    csrw 0xb28, x3

    #Address 0xb28 Write value 0x661c24b9
    li x3, 0x661c24b9
    csrw 0xb28, x3

    #Unmapped address 0x1e8 testing: random write/read operations
    #Address 0x1e8 Write value 0x4813891d
    li x3, 0x4813891d
    csrw 0x1e8, x3

    #Address 0x1e8 read value
    csrr x14, 0x1e8

    #Address 0x1e8 Write value 0x960dc43b
    li x3, 0x960dc43b
    csrw 0x1e8, x3

    #Unmapped address 0x9da testing: random write/read operations
    #Address 0x9da read value
    csrr x14, 0x9da

    #Address 0x9da Write value 0x55977cc
    li x3, 0x55977cc
    csrw 0x9da, x3

    #Address 0x9da Write value 0x56fe3684
    li x3, 0x56fe3684
    csrw 0x9da, x3

    #Address 0x9da Write value 0x31340220
    li x3, 0x31340220
    csrw 0x9da, x3

    #Unmapped address 0xff2 testing: random write/read operations
    #Address 0xff2 Write value 0x4940ec12
    li x3, 0x4940ec12
    csrw 0xff2, x3

    #Address 0xff2 read value
    csrr x14, 0xff2

    #Unmapped address 0x282 testing: random write/read operations
    #Address 0x282 read value
    csrr x14, 0x282

    #Address 0x282 read value
    csrr x14, 0x282

    #Address 0x282 read value
    csrr x14, 0x282

    #Address 0x282 Write value 0x70751c16
    li x3, 0x70751c16
    csrw 0x282, x3

    #Unmapped address 0xa19 testing: random write/read operations
    #Address 0xa19 read value
    csrr x14, 0xa19

    #Unmapped address 0x423 testing: random write/read operations
    #Address 0x423 Write value 0x3a36aa37
    li x3, 0x3a36aa37
    csrw 0x423, x3

    #Address 0x423 Write value 0x4012fff0
    li x3, 0x4012fff0
    csrw 0x423, x3

    #Address 0x423 Write value 0x7b3c70d2
    li x3, 0x7b3c70d2
    csrw 0x423, x3

    #Unmapped address 0x21e testing: random write/read operations
    #Address 0x21e Write value 0x7127ab4f
    li x3, 0x7127ab4f
    csrw 0x21e, x3

    #Mapped address 0xb82 (minstreth) testing: random write/read operations
    #Address 0xb82 Write value 0x89776f9f
    li x3, 0x89776f9f
    csrw 0xb82, x3

    #Address 0xb82 read value
    csrr x14, 0xb82

    #Address 0xb82 read value
    csrr x14, 0xb82

    #Address 0xb82 read value
    csrr x14, 0xb82

    #Address 0xb82 Write value 0x216131e3
    li x3, 0x216131e3
    csrw 0xb82, x3

    #Unmapped address 0xc41 testing: random write/read operations
    #Address 0xc41 read value
    csrr x14, 0xc41

    #Address 0xc41 Write value 0xdc21d23
    li x3, 0xdc21d23
    csrw 0xc41, x3

    #Unmapped address 0xc42 testing: random write/read operations
    #Address 0xc42 read value
    csrr x14, 0xc42

    #Address 0xc42 Write value 0xcb0dac08
    li x3, 0xcb0dac08
    csrw 0xc42, x3

    #Address 0xc42 Write value 0x731fc885
    li x3, 0x731fc885
    csrw 0xc42, x3

    #Address 0xc42 read value
    csrr x14, 0xc42

    #Address 0xc42 read value
    csrr x14, 0xc42

    #Unmapped address 0xba7 testing: random write/read operations
    #Address 0xba7 Write value 0xcfcfbe82
    li x3, 0xcfcfbe82
    csrw 0xba7, x3

    #Address 0xba7 read value
    csrr x14, 0xba7

    #Unmapped address 0x439 testing: random write/read operations
    #Address 0x439 Write value 0x6fb9abe2
    li x3, 0x6fb9abe2
    csrw 0x439, x3

    #Address 0x439 read value
    csrr x14, 0x439

    #Address 0x439 read value
    csrr x14, 0x439

    #Address 0x439 Write value 0x8931d572
    li x3, 0x8931d572
    csrw 0x439, x3

    #Address 0x439 read value
    csrr x14, 0x439

    #Unmapped address 0x113 testing: random write/read operations
    #Address 0x113 read value
    csrr x14, 0x113

    #Unmapped address 0x89b testing: random write/read operations
    #Address 0x89b read value
    csrr x14, 0x89b

    #Address 0x89b read value
    csrr x14, 0x89b

    #Address 0x89b Write value 0x8cb20679
    li x3, 0x8cb20679
    csrw 0x89b, x3

    #Unmapped address 0xbed testing: random write/read operations
    #Address 0xbed Write value 0x4c2f016b
    li x3, 0x4c2f016b
    csrw 0xbed, x3

    #Unmapped address 0xc33 testing: random write/read operations
    #Address 0xc33 read value
    csrr x14, 0xc33

    #Address 0xc33 read value
    csrr x14, 0xc33

    #Address 0xc33 read value
    csrr x14, 0xc33

    #Address 0xc33 read value
    csrr x14, 0xc33

    #Address 0xc33 read value
    csrr x14, 0xc33

    #Unmapped address 0xe80 testing: random write/read operations
    #Address 0xe80 read value
    csrr x14, 0xe80

    #Unmapped address 0xded testing: random write/read operations
    #Address 0xded read value
    csrr x14, 0xded

    #Unmapped address 0x7d0 testing: random write/read operations
    #Address 0x7d0 read value
    csrr x14, 0x7d0

    #Unmapped address 0xafc testing: random write/read operations
    #Address 0xafc read value
    csrr x14, 0xafc

    #Address 0xafc read value
    csrr x14, 0xafc

    #Address 0xafc Write value 0x9fcdaa7f
    li x3, 0x9fcdaa7f
    csrw 0xafc, x3

    #Unmapped address 0xacc testing: random write/read operations
    #Address 0xacc Write value 0x5d4a6617
    li x3, 0x5d4a6617
    csrw 0xacc, x3

    #Address 0xacc Write value 0x9b2c5e06
    li x3, 0x9b2c5e06
    csrw 0xacc, x3

    #Mapped address 0x32a (mhpmevent10) testing: random write/read operations
    #Address 0x32a read value
    csrr x14, 0x32a

    #Address 0x32a Write value 0x7f11f4ab
    li x3, 0x7f11f4ab
    csrw 0x32a, x3

    #Address 0x32a Write value 0x7d16e23f
    li x3, 0x7d16e23f
    csrw 0x32a, x3

    #Unmapped address 0x49e testing: random write/read operations
    #Address 0x49e read value
    csrr x14, 0x49e

    #Address 0x49e Write value 0xefadd751
    li x3, 0xefadd751
    csrw 0x49e, x3

    #Address 0x49e read value
    csrr x14, 0x49e

    #Unmapped address 0xad3 testing: random write/read operations
    #Address 0xad3 read value
    csrr x14, 0xad3

    #Address 0xad3 Write value 0x71d2bc3b
    li x3, 0x71d2bc3b
    csrw 0xad3, x3

    #Address 0xad3 Write value 0x1ac4ce24
    li x3, 0x1ac4ce24
    csrw 0xad3, x3

    #Address 0xad3 read value
    csrr x14, 0xad3

    #Address 0xad3 read value
    csrr x14, 0xad3

    #Unmapped address 0x5bf testing: random write/read operations
    #Address 0x5bf read value
    csrr x14, 0x5bf

    #Unmapped address 0x5a0 testing: random write/read operations
    #Address 0x5a0 read value
    csrr x14, 0x5a0

    #Address 0x5a0 Write value 0xf4d2b2a4
    li x3, 0xf4d2b2a4
    csrw 0x5a0, x3

    #Address 0x5a0 read value
    csrr x14, 0x5a0

    #Address 0x5a0 Write value 0xaba608c7
    li x3, 0xaba608c7
    csrw 0x5a0, x3

    #Address 0x5a0 read value
    csrr x14, 0x5a0

    #Unmapped address 0x98d testing: random write/read operations
    #Address 0x98d Write value 0xadeb406
    li x3, 0xadeb406
    csrw 0x98d, x3

    #Unmapped address 0x952 testing: random write/read operations
    #Address 0x952 read value
    csrr x14, 0x952

    #Address 0x952 read value
    csrr x14, 0x952

    #Address 0x952 read value
    csrr x14, 0x952

    #Unmapped address 0x1b1 testing: random write/read operations
    #Address 0x1b1 read value
    csrr x14, 0x1b1

    #Unmapped address 0x3c8 testing: random write/read operations
    #Address 0x3c8 read value
    csrr x14, 0x3c8

    #Address 0x3c8 Write value 0xef36040b
    li x3, 0xef36040b
    csrw 0x3c8, x3

    #Unmapped address 0x82c testing: random write/read operations
    #Address 0x82c read value
    csrr x14, 0x82c

    #Address 0x82c read value
    csrr x14, 0x82c

    #Address 0x82c read value
    csrr x14, 0x82c

    #Unmapped address 0xd8 testing: random write/read operations
    #Address 0xd8 read value
    csrr x14, 0xd8

    #Address 0xd8 read value
    csrr x14, 0xd8

    #Address 0xd8 Write value 0x98d7d0a1
    li x3, 0x98d7d0a1
    csrw 0xd8, x3

    #Address 0xd8 read value
    csrr x14, 0xd8

    #Unmapped address 0xd69 testing: random write/read operations
    #Address 0xd69 Write value 0xc11221f2
    li x3, 0xc11221f2
    csrw 0xd69, x3

    #Address 0xd69 read value
    csrr x14, 0xd69

    #Unmapped address 0xc6d testing: random write/read operations
    #Address 0xc6d read value
    csrr x14, 0xc6d

    #Address 0xc6d Write value 0x30070683
    li x3, 0x30070683
    csrw 0xc6d, x3

    #Address 0xc6d read value
    csrr x14, 0xc6d

    #Address 0xc6d read value
    csrr x14, 0xc6d

    #Unmapped address 0x42f testing: random write/read operations
    #Address 0x42f read value
    csrr x14, 0x42f

    #Address 0x42f read value
    csrr x14, 0x42f

    #Address 0x42f read value
    csrr x14, 0x42f

    #Address 0x42f Write value 0xa4e180cb
    li x3, 0xa4e180cb
    csrw 0x42f, x3

    #Unmapped address 0x3d6 testing: random write/read operations
    #Address 0x3d6 read value
    csrr x14, 0x3d6

    #Address 0x3d6 read value
    csrr x14, 0x3d6

    #Address 0x3d6 Write value 0xde387480
    li x3, 0xde387480
    csrw 0x3d6, x3

    #Address 0x3d6 read value
    csrr x14, 0x3d6

    #Unmapped address 0xea7 testing: random write/read operations
    #Address 0xea7 read value
    csrr x14, 0xea7

    #Address 0xea7 read value
    csrr x14, 0xea7

    #Address 0xea7 Write value 0x1424d925
    li x3, 0x1424d925
    csrw 0xea7, x3

    #Address 0xea7 read value
    csrr x14, 0xea7

    #Unmapped address 0x25 testing: random write/read operations
    #Address 0x25 Write value 0x2e7cbe1f
    li x3, 0x2e7cbe1f
    csrw 0x25, x3

    #Address 0x25 read value
    csrr x14, 0x25

    #Unmapped address 0xf67 testing: random write/read operations
    #Address 0xf67 read value
    csrr x14, 0xf67

    #Unmapped address 0x44a testing: random write/read operations
    #Address 0x44a Write value 0xc5fc74ce
    li x3, 0xc5fc74ce
    csrw 0x44a, x3

    #Address 0x44a Write value 0x25832e85
    li x3, 0x25832e85
    csrw 0x44a, x3

    #Address 0x44a read value
    csrr x14, 0x44a

    #Unmapped address 0x687 testing: random write/read operations
    #Address 0x687 Write value 0x7d7f5b62
    li x3, 0x7d7f5b62
    csrw 0x687, x3

    #Address 0x687 Write value 0x2c0ef451
    li x3, 0x2c0ef451
    csrw 0x687, x3

    #Address 0x687 Write value 0x176b333a
    li x3, 0x176b333a
    csrw 0x687, x3

    #Address 0x687 read value
    csrr x14, 0x687

    #Address 0x687 read value
    csrr x14, 0x687

    #Unmapped address 0x96b testing: random write/read operations
    #Address 0x96b read value
    csrr x14, 0x96b

    #Address 0x96b Write value 0x24a84fe0
    li x3, 0x24a84fe0
    csrw 0x96b, x3

    #Address 0x96b read value
    csrr x14, 0x96b

    #Unmapped address 0xd7 testing: random write/read operations
    #Address 0xd7 Write value 0x7dbfc2d6
    li x3, 0x7dbfc2d6
    csrw 0xd7, x3

    #Address 0xd7 Write value 0xedee7182
    li x3, 0xedee7182
    csrw 0xd7, x3

    #Address 0xd7 read value
    csrr x14, 0xd7

    #Address 0xd7 read value
    csrr x14, 0xd7

    #Unmapped address 0xf66 testing: random write/read operations
    #Address 0xf66 read value
    csrr x14, 0xf66

    #Address 0xf66 Write value 0xcc95a093
    li x3, 0xcc95a093
    csrw 0xf66, x3

    #Address 0xf66 read value
    csrr x14, 0xf66

    #Address 0xf66 read value
    csrr x14, 0xf66

    #Unmapped address 0x6ea testing: random write/read operations
    #Address 0x6ea Write value 0x8fe381b
    li x3, 0x8fe381b
    csrw 0x6ea, x3

    #Address 0x6ea Write value 0x4d1b3326
    li x3, 0x4d1b3326
    csrw 0x6ea, x3

    #Address 0x6ea Write value 0x91b8474b
    li x3, 0x91b8474b
    csrw 0x6ea, x3

    #Address 0x6ea read value
    csrr x14, 0x6ea

    #Address 0x6ea read value
    csrr x14, 0x6ea

    #Unmapped address 0x611 testing: random write/read operations
    #Address 0x611 read value
    csrr x14, 0x611

    #Address 0x611 Write value 0x1fceb218
    li x3, 0x1fceb218
    csrw 0x611, x3

    #Unmapped address 0xbd8 testing: random write/read operations
    #Address 0xbd8 Write value 0x7b275a86
    li x3, 0x7b275a86
    csrw 0xbd8, x3

    #Address 0xbd8 read value
    csrr x14, 0xbd8

    #Address 0xbd8 read value
    csrr x14, 0xbd8

    #Address 0xbd8 read value
    csrr x14, 0xbd8

    #Address 0xbd8 read value
    csrr x14, 0xbd8

    #Unmapped address 0xf9e testing: random write/read operations
    #Address 0xf9e read value
    csrr x14, 0xf9e

    #Address 0xf9e read value
    csrr x14, 0xf9e

    #Address 0xf9e read value
    csrr x14, 0xf9e

    #Address 0xf9e Write value 0x6f3de415
    li x3, 0x6f3de415
    csrw 0xf9e, x3

    #Unmapped address 0x885 testing: random write/read operations
    #Address 0x885 Write value 0xe398612a
    li x3, 0xe398612a
    csrw 0x885, x3

    #Address 0x885 read value
    csrr x14, 0x885

    #Address 0x885 read value
    csrr x14, 0x885

    #Unmapped address 0x26b testing: random write/read operations
    #Address 0x26b Write value 0x1165cf5c
    li x3, 0x1165cf5c
    csrw 0x26b, x3

    #Address 0x26b Write value 0xdba9b65c
    li x3, 0xdba9b65c
    csrw 0x26b, x3

    #Unmapped address 0xd04 testing: random write/read operations
    #Address 0xd04 Write value 0xcf14bb5e
    li x3, 0xcf14bb5e
    csrw 0xd04, x3

    #Unmapped address 0x16c testing: random write/read operations
    #Address 0x16c read value
    csrr x14, 0x16c

    #Address 0x16c read value
    csrr x14, 0x16c

    #Address 0x16c Write value 0xec4d3a09
    li x3, 0xec4d3a09
    csrw 0x16c, x3

    #Address 0x16c Write value 0xdafd4c8d
    li x3, 0xdafd4c8d
    csrw 0x16c, x3

    #Address 0x16c Write value 0xd3431f47
    li x3, 0xd3431f47
    csrw 0x16c, x3

    #Unmapped address 0xcf3 testing: random write/read operations
    #Address 0xcf3 Write value 0xbb9acd6b
    li x3, 0xbb9acd6b
    csrw 0xcf3, x3

    #Address 0xcf3 Write value 0x1d242782
    li x3, 0x1d242782
    csrw 0xcf3, x3

    #Address 0xcf3 read value
    csrr x14, 0xcf3

    #Unmapped address 0xee4 testing: random write/read operations
    #Address 0xee4 read value
    csrr x14, 0xee4

    #Address 0xee4 Write value 0xc229755b
    li x3, 0xc229755b
    csrw 0xee4, x3

    #Unmapped address 0xaa0 testing: random write/read operations
    #Address 0xaa0 read value
    csrr x14, 0xaa0

    #Address 0xaa0 read value
    csrr x14, 0xaa0

    #Address 0xaa0 Write value 0xd3388586
    li x3, 0xd3388586
    csrw 0xaa0, x3

    #Address 0xaa0 read value
    csrr x14, 0xaa0

    #Address 0xaa0 read value
    csrr x14, 0xaa0

    #Unmapped address 0xc1 testing: random write/read operations
    #Address 0xc1 read value
    csrr x14, 0xc1

    #Address 0xc1 Write value 0xba6160f9
    li x3, 0xba6160f9
    csrw 0xc1, x3

    #Unmapped address 0x8d3 testing: random write/read operations
    #Address 0x8d3 Write value 0x14a05476
    li x3, 0x14a05476
    csrw 0x8d3, x3

    #Address 0x8d3 read value
    csrr x14, 0x8d3

    #Address 0x8d3 read value
    csrr x14, 0x8d3

    #Unmapped address 0x589 testing: random write/read operations
    #Address 0x589 read value
    csrr x14, 0x589

    #Address 0x589 read value
    csrr x14, 0x589

    #Unmapped address 0x3f5 testing: random write/read operations
    #Address 0x3f5 read value
    csrr x14, 0x3f5

    #Address 0x3f5 Write value 0xcafdc0a1
    li x3, 0xcafdc0a1
    csrw 0x3f5, x3

    #Unmapped address 0x91c testing: random write/read operations
    #Address 0x91c Write value 0x9c95dda7
    li x3, 0x9c95dda7
    csrw 0x91c, x3

    #Address 0x91c Write value 0xc348e618
    li x3, 0xc348e618
    csrw 0x91c, x3

    #Unmapped address 0xac1 testing: random write/read operations
    #Address 0xac1 read value
    csrr x14, 0xac1

    #Address 0xac1 read value
    csrr x14, 0xac1

    #Address 0xac1 read value
    csrr x14, 0xac1

    #Unmapped address 0xf4b testing: random write/read operations
    #Address 0xf4b read value
    csrr x14, 0xf4b

    #Address 0xf4b Write value 0x62edaad0
    li x3, 0x62edaad0
    csrw 0xf4b, x3

    #Address 0xf4b read value
    csrr x14, 0xf4b

    #Address 0xf4b read value
    csrr x14, 0xf4b

    #Unmapped address 0x8e8 testing: random write/read operations
    #Address 0x8e8 Write value 0x28a878ee
    li x3, 0x28a878ee
    csrw 0x8e8, x3

    #Unmapped address 0xb5d testing: random write/read operations
    #Address 0xb5d read value
    csrr x14, 0xb5d

    #Address 0xb5d read value
    csrr x14, 0xb5d

    #Address 0xb5d Write value 0x454e88c2
    li x3, 0x454e88c2
    csrw 0xb5d, x3

    #Unmapped address 0x2c8 testing: random write/read operations
    #Address 0x2c8 read value
    csrr x14, 0x2c8

    #Address 0x2c8 Write value 0xe67cd22b
    li x3, 0xe67cd22b
    csrw 0x2c8, x3

    #Unmapped address 0x7d2 testing: random write/read operations
    #Address 0x7d2 Write value 0xeffd6e9c
    li x3, 0xeffd6e9c
    csrw 0x7d2, x3

    #Address 0x7d2 Write value 0x8e85c140
    li x3, 0x8e85c140
    csrw 0x7d2, x3

    #Unmapped address 0xa7d testing: random write/read operations
    #Address 0xa7d read value
    csrr x14, 0xa7d

    #Address 0xa7d Write value 0xbe032593
    li x3, 0xbe032593
    csrw 0xa7d, x3

    #Address 0xa7d Write value 0xa40f016c
    li x3, 0xa40f016c
    csrw 0xa7d, x3

    #Unmapped address 0x75e testing: random write/read operations
    #Address 0x75e Write value 0x37c40b3c
    li x3, 0x37c40b3c
    csrw 0x75e, x3

    #Address 0x75e read value
    csrr x14, 0x75e

    #Address 0x75e Write value 0xecb7a407
    li x3, 0xecb7a407
    csrw 0x75e, x3

    #Address 0x75e Write value 0xd33cee62
    li x3, 0xd33cee62
    csrw 0x75e, x3

    #Unmapped address 0x42e testing: random write/read operations
    #Address 0x42e read value
    csrr x14, 0x42e

    #Address 0x42e Write value 0x9175775f
    li x3, 0x9175775f
    csrw 0x42e, x3

    #Address 0x42e Write value 0x6febff65
    li x3, 0x6febff65
    csrw 0x42e, x3

    #Address 0x42e read value
    csrr x14, 0x42e

    #Unmapped address 0x158 testing: random write/read operations
    #Address 0x158 read value
    csrr x14, 0x158

    #Address 0x158 Write value 0xcd18952d
    li x3, 0xcd18952d
    csrw 0x158, x3

    #Unmapped address 0x1a3 testing: random write/read operations
    #Address 0x1a3 read value
    csrr x14, 0x1a3

    #Address 0x1a3 Write value 0x890164da
    li x3, 0x890164da
    csrw 0x1a3, x3

    #Address 0x1a3 read value
    csrr x14, 0x1a3

    #Address 0x1a3 read value
    csrr x14, 0x1a3

    #Address 0x1a3 read value
    csrr x14, 0x1a3

    #Unmapped address 0x1da testing: random write/read operations
    #Address 0x1da Write value 0xaf9bf1fc
    li x3, 0xaf9bf1fc
    csrw 0x1da, x3

    #Unmapped address 0x6d9 testing: random write/read operations
    #Address 0x6d9 Write value 0x64c4c7fc
    li x3, 0x64c4c7fc
    csrw 0x6d9, x3

    #Address 0x6d9 read value
    csrr x14, 0x6d9

    #Address 0x6d9 read value
    csrr x14, 0x6d9

    #Address 0x6d9 Write value 0xd48dbb47
    li x3, 0xd48dbb47
    csrw 0x6d9, x3

    #Unmapped address 0xb50 testing: random write/read operations
    #Address 0xb50 Write value 0xfec09e01
    li x3, 0xfec09e01
    csrw 0xb50, x3

    #Address 0xb50 read value
    csrr x14, 0xb50

    #Address 0xb50 Write value 0x2b8eab1
    li x3, 0x2b8eab1
    csrw 0xb50, x3

    #Address 0xb50 Write value 0x5bd03bb1
    li x3, 0x5bd03bb1
    csrw 0xb50, x3

    #Address 0xb50 read value
    csrr x14, 0xb50

    #Unmapped address 0x889 testing: random write/read operations
    #Address 0x889 read value
    csrr x14, 0x889

    #Address 0x889 read value
    csrr x14, 0x889

    #Address 0x889 read value
    csrr x14, 0x889

    #Unmapped address 0xcdf testing: random write/read operations
    #Address 0xcdf read value
    csrr x14, 0xcdf

    #Unmapped address 0x7a5 testing: random write/read operations
    #Address 0x7a5 read value
    csrr x14, 0x7a5

    #Unmapped address 0x2cf testing: random write/read operations
    #Address 0x2cf Write value 0xca15fe7e
    li x3, 0xca15fe7e
    csrw 0x2cf, x3

    #Unmapped address 0x1ad testing: random write/read operations
    #Address 0x1ad Write value 0xc6d7eb31
    li x3, 0xc6d7eb31
    csrw 0x1ad, x3

    #Address 0x1ad Write value 0x5a759429
    li x3, 0x5a759429
    csrw 0x1ad, x3

    #Address 0x1ad read value
    csrr x14, 0x1ad

    #Unmapped address 0xa67 testing: random write/read operations
    #Address 0xa67 Write value 0xc225d298
    li x3, 0xc225d298
    csrw 0xa67, x3

    #Address 0xa67 read value
    csrr x14, 0xa67

    #Address 0xa67 Write value 0xf4d9651c
    li x3, 0xf4d9651c
    csrw 0xa67, x3

    #Address 0xa67 read value
    csrr x14, 0xa67

    #Address 0xa67 read value
    csrr x14, 0xa67

    #Unmapped address 0x715 testing: random write/read operations
    #Address 0x715 Write value 0x72f88d46
    li x3, 0x72f88d46
    csrw 0x715, x3

    #Unmapped address 0x583 testing: random write/read operations
    #Address 0x583 read value
    csrr x14, 0x583

    #Address 0x583 Write value 0xc71dcb3e
    li x3, 0xc71dcb3e
    csrw 0x583, x3

    #Mapped address 0x3b9 (pmpaddr9) testing: random write/read operations
    #Address 0x3b9 read value
    csrr x14, 0x3b9

    #Address 0x3b9 Write value 0x5f8e899
    li x3, 0x5f8e899
    csrw 0x3b9, x3

    #Address 0x3b9 Write value 0x3ca9c5e5
    li x3, 0x3ca9c5e5
    csrw 0x3b9, x3

    #Address 0x3b9 Write value 0x1a41f30e
    li x3, 0x1a41f30e
    csrw 0x3b9, x3

    #Unmapped address 0x658 testing: random write/read operations
    #Address 0x658 read value
    csrr x14, 0x658

    #Address 0x658 Write value 0xbba36a9
    li x3, 0xbba36a9
    csrw 0x658, x3

    #Address 0x658 Write value 0xf44924ac
    li x3, 0xf44924ac
    csrw 0x658, x3

    #Unmapped address 0xce3 testing: random write/read operations
    #Address 0xce3 Write value 0x62936074
    li x3, 0x62936074
    csrw 0xce3, x3

    #Unmapped address 0x1d9 testing: random write/read operations
    #Address 0x1d9 read value
    csrr x14, 0x1d9

    #Address 0x1d9 read value
    csrr x14, 0x1d9

    #Address 0x1d9 read value
    csrr x14, 0x1d9

    #Address 0x1d9 read value
    csrr x14, 0x1d9

    #Unmapped address 0xb5f testing: random write/read operations
    #Address 0xb5f read value
    csrr x14, 0xb5f

    #Address 0xb5f Write value 0xfa30d703
    li x3, 0xfa30d703
    csrw 0xb5f, x3

    #Address 0xb5f read value
    csrr x14, 0xb5f

    #Unmapped address 0x622 testing: random write/read operations
    #Address 0x622 Write value 0x536a899e
    li x3, 0x536a899e
    csrw 0x622, x3

    #Address 0x622 read value
    csrr x14, 0x622

    #Address 0x622 Write value 0x73354e1e
    li x3, 0x73354e1e
    csrw 0x622, x3

    #Address 0x622 Write value 0x7b4a5b72
    li x3, 0x7b4a5b72
    csrw 0x622, x3

    #Address 0x622 Write value 0xbd24bf75
    li x3, 0xbd24bf75
    csrw 0x622, x3

    #Unmapped address 0x50 testing: random write/read operations
    #Address 0x50 read value
    csrr x14, 0x50

    #Address 0x50 Write value 0x48a6c765
    li x3, 0x48a6c765
    csrw 0x50, x3

    #Address 0x50 read value
    csrr x14, 0x50

    #Unmapped address 0xe44 testing: random write/read operations
    #Address 0xe44 read value
    csrr x14, 0xe44

    #Address 0xe44 read value
    csrr x14, 0xe44

    #Address 0xe44 read value
    csrr x14, 0xe44

    #Address 0xe44 read value
    csrr x14, 0xe44

    #Address 0xe44 read value
    csrr x14, 0xe44

    #Unmapped address 0xc0f testing: random write/read operations
    #Address 0xc0f Write value 0x7dd71ff2
    li x3, 0x7dd71ff2
    csrw 0xc0f, x3

    #Address 0xc0f read value
    csrr x14, 0xc0f

    #Address 0xc0f read value
    csrr x14, 0xc0f

    #Address 0xc0f read value
    csrr x14, 0xc0f

    #Unmapped address 0x6aa testing: random write/read operations
    #Address 0x6aa read value
    csrr x14, 0x6aa

    #Address 0x6aa Write value 0xd6e1ec0e
    li x3, 0xd6e1ec0e
    csrw 0x6aa, x3

    #Address 0x6aa read value
    csrr x14, 0x6aa

    #Unmapped address 0x214 testing: random write/read operations
    #Address 0x214 read value
    csrr x14, 0x214

    #Address 0x214 Write value 0x95477d61
    li x3, 0x95477d61
    csrw 0x214, x3

    #Address 0x214 read value
    csrr x14, 0x214

    #Unmapped address 0xccf testing: random write/read operations
    #Address 0xccf Write value 0x4e179e1a
    li x3, 0x4e179e1a
    csrw 0xccf, x3

    #Address 0xccf Write value 0xe2fcaf6b
    li x3, 0xe2fcaf6b
    csrw 0xccf, x3

    #Address 0xccf Write value 0x18c0e632
    li x3, 0x18c0e632
    csrw 0xccf, x3

    #Address 0xccf read value
    csrr x14, 0xccf

    #Address 0xccf read value
    csrr x14, 0xccf

    #Unmapped address 0x2f2 testing: random write/read operations
    #Address 0x2f2 Write value 0x5e410223
    li x3, 0x5e410223
    csrw 0x2f2, x3

    #Address 0x2f2 read value
    csrr x14, 0x2f2

    #Address 0x2f2 Write value 0xcf62fca6
    li x3, 0xcf62fca6
    csrw 0x2f2, x3

    #Unmapped address 0x4d3 testing: random write/read operations
    #Address 0x4d3 read value
    csrr x14, 0x4d3

    #Address 0x4d3 Write value 0x96fd0034
    li x3, 0x96fd0034
    csrw 0x4d3, x3

    #Address 0x4d3 Write value 0x19c67c6d
    li x3, 0x19c67c6d
    csrw 0x4d3, x3

    #Unmapped address 0x2e6 testing: random write/read operations
    #Address 0x2e6 Write value 0x72a88e9b
    li x3, 0x72a88e9b
    csrw 0x2e6, x3

    #Unmapped address 0xd59 testing: random write/read operations
    #Address 0xd59 read value
    csrr x14, 0xd59

    #Address 0xd59 read value
    csrr x14, 0xd59

    #Address 0xd59 read value
    csrr x14, 0xd59

    #Unmapped address 0x5f6 testing: random write/read operations
    #Address 0x5f6 read value
    csrr x14, 0x5f6

    #Address 0x5f6 Write value 0xb6dab9c4
    li x3, 0xb6dab9c4
    csrw 0x5f6, x3

    #Address 0x5f6 read value
    csrr x14, 0x5f6

    #Unmapped address 0xa6d testing: random write/read operations
    #Address 0xa6d read value
    csrr x14, 0xa6d

    #Unmapped address 0xda6 testing: random write/read operations
    #Address 0xda6 read value
    csrr x14, 0xda6

    #Address 0xda6 Write value 0x65a9c06a
    li x3, 0x65a9c06a
    csrw 0xda6, x3

    #Unmapped address 0x96 testing: random write/read operations
    #Address 0x96 Write value 0xd510e0d5
    li x3, 0xd510e0d5
    csrw 0x96, x3

    #Address 0x96 read value
    csrr x14, 0x96

    #Address 0x96 read value
    csrr x14, 0x96

    #Address 0x96 read value
    csrr x14, 0x96

    #Address 0x96 Write value 0xd5755217
    li x3, 0xd5755217
    csrw 0x96, x3

    #Mapped address 0x3b1 (pmpaddr1) testing: random write/read operations
    #Address 0x3b1 read value
    csrr x14, 0x3b1

    #Address 0x3b1 read value
    csrr x14, 0x3b1

    #Address 0x3b1 read value
    csrr x14, 0x3b1

    #Unmapped address 0x9eb testing: random write/read operations
    #Address 0x9eb Write value 0x461490dd
    li x3, 0x461490dd
    csrw 0x9eb, x3

    #Address 0x9eb read value
    csrr x14, 0x9eb

    #Address 0x9eb read value
    csrr x14, 0x9eb

    #Address 0x9eb read value
    csrr x14, 0x9eb

    #Address 0x9eb read value
    csrr x14, 0x9eb

    #Unmapped address 0x7f7 testing: random write/read operations
    #Address 0x7f7 Write value 0x3c51e44
    li x3, 0x3c51e44
    csrw 0x7f7, x3

    #Address 0x7f7 Write value 0x864fba6b
    li x3, 0x864fba6b
    csrw 0x7f7, x3

    #Address 0x7f7 Write value 0x62df85a9
    li x3, 0x62df85a9
    csrw 0x7f7, x3

    #Address 0x7f7 Write value 0xd86eab7c
    li x3, 0xd86eab7c
    csrw 0x7f7, x3

    #Address 0x7f7 read value
    csrr x14, 0x7f7

    #Unmapped address 0x86 testing: random write/read operations
    #Address 0x86 read value
    csrr x14, 0x86

    #Address 0x86 read value
    csrr x14, 0x86

    #Address 0x86 read value
    csrr x14, 0x86

    #Address 0x86 Write value 0xd7e59cd5
    li x3, 0xd7e59cd5
    csrw 0x86, x3

    #Unmapped address 0x1c4 testing: random write/read operations
    #Address 0x1c4 read value
    csrr x14, 0x1c4

    #Address 0x1c4 read value
    csrr x14, 0x1c4

    #Address 0x1c4 read value
    csrr x14, 0x1c4

    #Address 0x1c4 Write value 0xea9bad06
    li x3, 0xea9bad06
    csrw 0x1c4, x3

    #Address 0x1c4 Write value 0x6039526e
    li x3, 0x6039526e
    csrw 0x1c4, x3

    #Unmapped address 0x2b3 testing: random write/read operations
    #Address 0x2b3 read value
    csrr x14, 0x2b3

    #Address 0x2b3 read value
    csrr x14, 0x2b3

    #Unmapped address 0xc94 testing: random write/read operations
    #Address 0xc94 Write value 0xcfa668e0
    li x3, 0xcfa668e0
    csrw 0xc94, x3

    #Address 0xc94 read value
    csrr x14, 0xc94

    #Unmapped address 0x696 testing: random write/read operations
    #Address 0x696 Write value 0xe68ba468
    li x3, 0xe68ba468
    csrw 0x696, x3

    #Address 0x696 Write value 0x9b55876e
    li x3, 0x9b55876e
    csrw 0x696, x3

    #Address 0x696 Write value 0x783ccd1d
    li x3, 0x783ccd1d
    csrw 0x696, x3

    #Address 0x696 read value
    csrr x14, 0x696

    #Address 0x696 read value
    csrr x14, 0x696

    #Unmapped address 0x31d testing: random write/read operations
    #Address 0x31d Write value 0xdb8c76e6
    li x3, 0xdb8c76e6
    csrw 0x31d, x3

    #Address 0x31d read value
    csrr x14, 0x31d

    #Address 0x31d read value
    csrr x14, 0x31d

    #Unmapped address 0x7e5 testing: random write/read operations
    #Address 0x7e5 read value
    csrr x14, 0x7e5

    #Unmapped address 0x74 testing: random write/read operations
    #Address 0x74 read value
    csrr x14, 0x74

    #Address 0x74 read value
    csrr x14, 0x74

    #Unmapped address 0x781 testing: random write/read operations
    #Address 0x781 read value
    csrr x14, 0x781

    #Address 0x781 read value
    csrr x14, 0x781

    #Address 0x781 Write value 0xb22cb0b5
    li x3, 0xb22cb0b5
    csrw 0x781, x3

    #Address 0x781 read value
    csrr x14, 0x781

    #Unmapped address 0x98c testing: random write/read operations
    #Address 0x98c Write value 0x7ce0b356
    li x3, 0x7ce0b356
    csrw 0x98c, x3

    #Address 0x98c read value
    csrr x14, 0x98c

    #Address 0x98c read value
    csrr x14, 0x98c

    #Address 0x98c read value
    csrr x14, 0x98c

    #Mapped address 0xb18 (mhpmcounter24) testing: random write/read operations
    #Address 0xb18 Write value 0x3acbbcf
    li x3, 0x3acbbcf
    csrw 0xb18, x3

    #Address 0xb18 read value
    csrr x14, 0xb18

    #Address 0xb18 read value
    csrr x14, 0xb18

    #Address 0xb18 read value
    csrr x14, 0xb18

    #Unmapped address 0xd0f testing: random write/read operations
    #Address 0xd0f Write value 0x58dbb83b
    li x3, 0x58dbb83b
    csrw 0xd0f, x3

    #Address 0xd0f Write value 0xe29719
    li x3, 0xe29719
    csrw 0xd0f, x3

    #Unmapped address 0x1e7 testing: random write/read operations
    #Address 0x1e7 read value
    csrr x14, 0x1e7

    #Unmapped address 0x768 testing: random write/read operations
    #Address 0x768 read value
    csrr x14, 0x768

    #Address 0x768 read value
    csrr x14, 0x768

    #Address 0x768 read value
    csrr x14, 0x768

    #Unmapped address 0x94a testing: random write/read operations
    #Address 0x94a read value
    csrr x14, 0x94a

    #Unmapped address 0xcb3 testing: random write/read operations
    #Address 0xcb3 Write value 0x295670a9
    li x3, 0x295670a9
    csrw 0xcb3, x3

    #Address 0xcb3 Write value 0xab91540d
    li x3, 0xab91540d
    csrw 0xcb3, x3

    #Unmapped address 0xd99 testing: random write/read operations
    #Address 0xd99 read value
    csrr x14, 0xd99

    #Address 0xd99 read value
    csrr x14, 0xd99

    #Unmapped address 0x273 testing: random write/read operations
    #Address 0x273 Write value 0xb0f5cff5
    li x3, 0xb0f5cff5
    csrw 0x273, x3

    #Address 0x273 read value
    csrr x14, 0x273

    #Address 0x273 read value
    csrr x14, 0x273

    #Address 0x273 Write value 0xb1343aa4
    li x3, 0xb1343aa4
    csrw 0x273, x3

    #Unmapped address 0x345 testing: random write/read operations
    #Address 0x345 read value
    csrr x14, 0x345

    #Address 0x345 Write value 0x9dfa02fa
    li x3, 0x9dfa02fa
    csrw 0x345, x3

    #Address 0x345 Write value 0x6dae9dcb
    li x3, 0x6dae9dcb
    csrw 0x345, x3

    #Unmapped address 0x8f8 testing: random write/read operations
    #Address 0x8f8 Write value 0x489f2625
    li x3, 0x489f2625
    csrw 0x8f8, x3

    #Address 0x8f8 Write value 0xdf09e4a4
    li x3, 0xdf09e4a4
    csrw 0x8f8, x3

    #Address 0x8f8 Write value 0x65c9ea5a
    li x3, 0x65c9ea5a
    csrw 0x8f8, x3

    #Address 0x8f8 Write value 0xa5ba8798
    li x3, 0xa5ba8798
    csrw 0x8f8, x3

    #Address 0x8f8 Write value 0x14bc3024
    li x3, 0x14bc3024
    csrw 0x8f8, x3

    #Unmapped address 0xc24 testing: random write/read operations
    #Address 0xc24 read value
    csrr x14, 0xc24

    #Address 0xc24 Write value 0xeb7afc56
    li x3, 0xeb7afc56
    csrw 0xc24, x3

    #Unmapped address 0x38c testing: random write/read operations
    #Address 0x38c Write value 0xb8160b5
    li x3, 0xb8160b5
    csrw 0x38c, x3

    #Address 0x38c Write value 0x59af975
    li x3, 0x59af975
    csrw 0x38c, x3

    #Unmapped address 0x518 testing: random write/read operations
    #Address 0x518 Write value 0x36a9b5be
    li x3, 0x36a9b5be
    csrw 0x518, x3

    #Address 0x518 Write value 0x98597797
    li x3, 0x98597797
    csrw 0x518, x3

    #Address 0x518 Write value 0xe1a65748
    li x3, 0xe1a65748
    csrw 0x518, x3

    #Unmapped address 0x1d8 testing: random write/read operations
    #Address 0x1d8 Write value 0x44496af1
    li x3, 0x44496af1
    csrw 0x1d8, x3

    #Address 0x1d8 read value
    csrr x14, 0x1d8

    #Address 0x1d8 read value
    csrr x14, 0x1d8

    #Address 0x1d8 Write value 0x914f2ace
    li x3, 0x914f2ace
    csrw 0x1d8, x3

    #Unmapped address 0xe1f testing: random write/read operations
    #Address 0xe1f Write value 0x188f306c
    li x3, 0x188f306c
    csrw 0xe1f, x3

    #Address 0xe1f Write value 0xea88d6f7
    li x3, 0xea88d6f7
    csrw 0xe1f, x3

    #Address 0xe1f read value
    csrr x14, 0xe1f

    #Unmapped address 0x3d2 testing: random write/read operations
    #Address 0x3d2 read value
    csrr x14, 0x3d2

    #Address 0x3d2 read value
    csrr x14, 0x3d2

    #Address 0x3d2 read value
    csrr x14, 0x3d2

    #Address 0x3d2 read value
    csrr x14, 0x3d2

    #Address 0x3d2 Write value 0x86891ff3
    li x3, 0x86891ff3
    csrw 0x3d2, x3

    #Unmapped address 0xc40 testing: random write/read operations
    #Address 0xc40 read value
    csrr x14, 0xc40

    #Address 0xc40 Write value 0xdccea961
    li x3, 0xdccea961
    csrw 0xc40, x3

    #Address 0xc40 Write value 0x1e9acae9
    li x3, 0x1e9acae9
    csrw 0xc40, x3

    #Address 0xc40 read value
    csrr x14, 0xc40

    #Unmapped address 0xa38 testing: random write/read operations
    #Address 0xa38 Write value 0xd8ef2264
    li x3, 0xd8ef2264
    csrw 0xa38, x3

    #Address 0xa38 Write value 0x2805ea81
    li x3, 0x2805ea81
    csrw 0xa38, x3

    #Address 0xa38 Write value 0xac3681d7
    li x3, 0xac3681d7
    csrw 0xa38, x3

    #Address 0xa38 read value
    csrr x14, 0xa38

    #Address 0xa38 Write value 0xaf2d6738
    li x3, 0xaf2d6738
    csrw 0xa38, x3

    #Unmapped address 0x434 testing: random write/read operations
    #Address 0x434 read value
    csrr x14, 0x434

    #Address 0x434 Write value 0x3fef2d0
    li x3, 0x3fef2d0
    csrw 0x434, x3

    #Address 0x434 Write value 0x735945a0
    li x3, 0x735945a0
    csrw 0x434, x3

    #Address 0x434 read value
    csrr x14, 0x434

    #Address 0x434 Write value 0xba73bc6c
    li x3, 0xba73bc6c
    csrw 0x434, x3

    #Unmapped address 0xf7a testing: random write/read operations
    #Address 0xf7a Write value 0xa744da7b
    li x3, 0xa744da7b
    csrw 0xf7a, x3

    #Address 0xf7a read value
    csrr x14, 0xf7a

    #Address 0xf7a read value
    csrr x14, 0xf7a

    #Address 0xf7a read value
    csrr x14, 0xf7a

    #Unmapped address 0x722 testing: random write/read operations
    #Address 0x722 Write value 0x33a03991
    li x3, 0x33a03991
    csrw 0x722, x3

    #Address 0x722 Write value 0x4ce31378
    li x3, 0x4ce31378
    csrw 0x722, x3

    #Address 0x722 read value
    csrr x14, 0x722

    #Address 0x722 read value
    csrr x14, 0x722

    #Address 0x722 read value
    csrr x14, 0x722

    #Unmapped address 0xb29 testing: random write/read operations
    #Address 0xb29 Write value 0x72e91c9e
    li x3, 0x72e91c9e
    csrw 0xb29, x3

    #Address 0xb29 Write value 0xb46bae5e
    li x3, 0xb46bae5e
    csrw 0xb29, x3

    #Unmapped address 0x3ee testing: random write/read operations
    #Address 0x3ee Write value 0x33428f1a
    li x3, 0x33428f1a
    csrw 0x3ee, x3

    #Address 0x3ee read value
    csrr x14, 0x3ee

    #Address 0x3ee Write value 0x546d5360
    li x3, 0x546d5360
    csrw 0x3ee, x3

    #Unmapped address 0x7b6 testing: random write/read operations
    #Address 0x7b6 Write value 0x95944227
    li x3, 0x95944227
    csrw 0x7b6, x3

    #Unmapped address 0x780 testing: random write/read operations
    #Address 0x780 Write value 0x96d32b8
    li x3, 0x96d32b8
    csrw 0x780, x3

    #Address 0x780 read value
    csrr x14, 0x780

    #Address 0x780 read value
    csrr x14, 0x780

    #Address 0x780 Write value 0x2ddd0945
    li x3, 0x2ddd0945
    csrw 0x780, x3

    #Address 0x780 Write value 0xca2a758c
    li x3, 0xca2a758c
    csrw 0x780, x3

    #Unmapped address 0x313 testing: random write/read operations
    #Address 0x313 Write value 0x226d48bd
    li x3, 0x226d48bd
    csrw 0x313, x3

    #Unmapped address 0x6d5 testing: random write/read operations
    #Address 0x6d5 Write value 0x9203ded
    li x3, 0x9203ded
    csrw 0x6d5, x3

    #Address 0x6d5 read value
    csrr x14, 0x6d5

    #Address 0x6d5 Write value 0xcaab792
    li x3, 0xcaab792
    csrw 0x6d5, x3

    #Address 0x6d5 Write value 0xba92cdcd
    li x3, 0xba92cdcd
    csrw 0x6d5, x3

    #Unmapped address 0x52f testing: random write/read operations
    #Address 0x52f Write value 0x766b8b15
    li x3, 0x766b8b15
    csrw 0x52f, x3

    #Address 0x52f read value
    csrr x14, 0x52f

    #Address 0x52f read value
    csrr x14, 0x52f

    #Unmapped address 0xf4c testing: random write/read operations
    #Address 0xf4c read value
    csrr x14, 0xf4c

    #Address 0xf4c Write value 0x61b73b18
    li x3, 0x61b73b18
    csrw 0xf4c, x3

    #Address 0xf4c read value
    csrr x14, 0xf4c

    #Unmapped address 0x7bc testing: random write/read operations
    #Address 0x7bc Write value 0x60b70187
    li x3, 0x60b70187
    csrw 0x7bc, x3

    #Address 0x7bc Write value 0x261d0843
    li x3, 0x261d0843
    csrw 0x7bc, x3

    #Address 0x7bc Write value 0x8b57671f
    li x3, 0x8b57671f
    csrw 0x7bc, x3

    #Address 0x7bc read value
    csrr x14, 0x7bc

    #Address 0x7bc read value
    csrr x14, 0x7bc

    #Unmapped address 0xd05 testing: random write/read operations
    #Address 0xd05 read value
    csrr x14, 0xd05

    #Address 0xd05 Write value 0xb6496e23
    li x3, 0xb6496e23
    csrw 0xd05, x3

    #Unmapped address 0x931 testing: random write/read operations
    #Address 0x931 read value
    csrr x14, 0x931

    #Unmapped address 0xbe3 testing: random write/read operations
    #Address 0xbe3 Write value 0x54165fca
    li x3, 0x54165fca
    csrw 0xbe3, x3

    #Address 0xbe3 Write value 0x57760e54
    li x3, 0x57760e54
    csrw 0xbe3, x3

    #Address 0xbe3 Write value 0xca4ffc3a
    li x3, 0xca4ffc3a
    csrw 0xbe3, x3

    #Unmapped address 0xd88 testing: random write/read operations
    #Address 0xd88 Write value 0x3715f883
    li x3, 0x3715f883
    csrw 0xd88, x3

    #Address 0xd88 Write value 0x5ec02285
    li x3, 0x5ec02285
    csrw 0xd88, x3

    #Address 0xd88 Write value 0xeddb873e
    li x3, 0xeddb873e
    csrw 0xd88, x3

    #Unmapped address 0x788 testing: random write/read operations
    #Address 0x788 read value
    csrr x14, 0x788

    #Address 0x788 Write value 0x75784bb0
    li x3, 0x75784bb0
    csrw 0x788, x3

    #Address 0x788 Write value 0x3af83bc7
    li x3, 0x3af83bc7
    csrw 0x788, x3

    #Unmapped address 0xcb0 testing: random write/read operations
    #Address 0xcb0 Write value 0x35357aad
    li x3, 0x35357aad
    csrw 0xcb0, x3

    #Address 0xcb0 read value
    csrr x14, 0xcb0

    #Unmapped address 0x268 testing: random write/read operations
    #Address 0x268 read value
    csrr x14, 0x268

    #Address 0x268 Write value 0x521b41b1
    li x3, 0x521b41b1
    csrw 0x268, x3

    #Address 0x268 Write value 0x8be9e063
    li x3, 0x8be9e063
    csrw 0x268, x3

    #Address 0x268 read value
    csrr x14, 0x268

    #Address 0x268 Write value 0x7963486c
    li x3, 0x7963486c
    csrw 0x268, x3

    #Unmapped address 0x72b testing: random write/read operations
    #Address 0x72b Write value 0x34bdb984
    li x3, 0x34bdb984
    csrw 0x72b, x3

    #Unmapped address 0xfdd testing: random write/read operations
    #Address 0xfdd read value
    csrr x14, 0xfdd

    #Address 0xfdd read value
    csrr x14, 0xfdd

    #Address 0xfdd read value
    csrr x14, 0xfdd

    #Address 0xfdd read value
    csrr x14, 0xfdd

    #Address 0xfdd read value
    csrr x14, 0xfdd

    #Unmapped address 0x428 testing: random write/read operations
    #Address 0x428 read value
    csrr x14, 0x428

    #Address 0x428 Write value 0x321d46ad
    li x3, 0x321d46ad
    csrw 0x428, x3

    #Address 0x428 read value
    csrr x14, 0x428

    #Address 0x428 Write value 0xc2023de9
    li x3, 0xc2023de9
    csrw 0x428, x3

    #Address 0x428 Write value 0x2c0f78e8
    li x3, 0x2c0f78e8
    csrw 0x428, x3

    #Unmapped address 0x3e7 testing: random write/read operations
    #Address 0x3e7 Write value 0xea208895
    li x3, 0xea208895
    csrw 0x3e7, x3

    #Address 0x3e7 read value
    csrr x14, 0x3e7

    #Address 0x3e7 Write value 0xbdf7dfb5
    li x3, 0xbdf7dfb5
    csrw 0x3e7, x3

    #Unmapped address 0x618 testing: random write/read operations
    #Address 0x618 read value
    csrr x14, 0x618

    #Address 0x618 read value
    csrr x14, 0x618

    #Address 0x618 Write value 0xf5519b0d
    li x3, 0xf5519b0d
    csrw 0x618, x3

    #Unmapped address 0xfcb testing: random write/read operations
    #Address 0xfcb read value
    csrr x14, 0xfcb

    #Address 0xfcb Write value 0x2365e46d
    li x3, 0x2365e46d
    csrw 0xfcb, x3

    #Unmapped address 0x4c8 testing: random write/read operations
    #Address 0x4c8 read value
    csrr x14, 0x4c8

    #Address 0x4c8 Write value 0x4d0140cf
    li x3, 0x4d0140cf
    csrw 0x4c8, x3

    #Address 0x4c8 read value
    csrr x14, 0x4c8

    #Address 0x4c8 Write value 0x88a4e825
    li x3, 0x88a4e825
    csrw 0x4c8, x3

    #Address 0x4c8 read value
    csrr x14, 0x4c8

    #Unmapped address 0x41d testing: random write/read operations
    #Address 0x41d read value
    csrr x14, 0x41d

    #Address 0x41d Write value 0x86fb20be
    li x3, 0x86fb20be
    csrw 0x41d, x3

    #Unmapped address 0x6b8 testing: random write/read operations
    #Address 0x6b8 Write value 0x62ad6408
    li x3, 0x62ad6408
    csrw 0x6b8, x3

    #Address 0x6b8 Write value 0xe19f1ff9
    li x3, 0xe19f1ff9
    csrw 0x6b8, x3

    #Address 0x6b8 Write value 0x1e963823
    li x3, 0x1e963823
    csrw 0x6b8, x3

    #Address 0x6b8 read value
    csrr x14, 0x6b8

    #Address 0x6b8 read value
    csrr x14, 0x6b8

    #Unmapped address 0xd5 testing: random write/read operations
    #Address 0xd5 Write value 0x403683f9
    li x3, 0x403683f9
    csrw 0xd5, x3

    #Unmapped address 0xfb5 testing: random write/read operations
    #Address 0xfb5 read value
    csrr x14, 0xfb5

    #Address 0xfb5 read value
    csrr x14, 0xfb5

    #Address 0xfb5 read value
    csrr x14, 0xfb5

    #Address 0xfb5 Write value 0x3af65796
    li x3, 0x3af65796
    csrw 0xfb5, x3

    #Unmapped address 0x2ce testing: random write/read operations
    #Address 0x2ce read value
    csrr x14, 0x2ce

    #Address 0x2ce Write value 0x93c1485e
    li x3, 0x93c1485e
    csrw 0x2ce, x3

    #Address 0x2ce Write value 0x6fbd82f
    li x3, 0x6fbd82f
    csrw 0x2ce, x3

    #Unmapped address 0xa82 testing: random write/read operations
    #Address 0xa82 Write value 0x917b431e
    li x3, 0x917b431e
    csrw 0xa82, x3

    #Address 0xa82 read value
    csrr x14, 0xa82

    #Unmapped address 0xd60 testing: random write/read operations
    #Address 0xd60 Write value 0x7fd7af64
    li x3, 0x7fd7af64
    csrw 0xd60, x3

    #Unmapped address 0xc93 testing: random write/read operations
    #Address 0xc93 Write value 0x83bc0cfa
    li x3, 0x83bc0cfa
    csrw 0xc93, x3

    #Address 0xc93 read value
    csrr x14, 0xc93

    #Unmapped address 0x3fb testing: random write/read operations
    #Address 0x3fb read value
    csrr x14, 0x3fb

    #Address 0x3fb Write value 0x53dee9dd
    li x3, 0x53dee9dd
    csrw 0x3fb, x3

    #Address 0x3fb Write value 0x3fd96bc0
    li x3, 0x3fd96bc0
    csrw 0x3fb, x3

    #Unmapped address 0x3d testing: random write/read operations
    #Address 0x3d read value
    csrr x14, 0x3d

    #Address 0x3d read value
    csrr x14, 0x3d

    #Address 0x3d Write value 0xab267ee5
    li x3, 0xab267ee5
    csrw 0x3d, x3

    #Address 0x3d Write value 0xb9a0e3ab
    li x3, 0xb9a0e3ab
    csrw 0x3d, x3

    #Unmapped address 0xb60 testing: random write/read operations
    #Address 0xb60 read value
    csrr x14, 0xb60

    #Unmapped address 0x153 testing: random write/read operations
    #Address 0x153 read value
    csrr x14, 0x153

    #Address 0x153 read value
    csrr x14, 0x153

    #Unmapped address 0xf26 testing: random write/read operations
    #Address 0xf26 Write value 0xef6d197c
    li x3, 0xef6d197c
    csrw 0xf26, x3

    #Address 0xf26 read value
    csrr x14, 0xf26

    #Unmapped address 0xa5f testing: random write/read operations
    #Address 0xa5f read value
    csrr x14, 0xa5f

    #Address 0xa5f read value
    csrr x14, 0xa5f

    #Address 0xa5f read value
    csrr x14, 0xa5f

    #Unmapped address 0x765 testing: random write/read operations
    #Address 0x765 read value
    csrr x14, 0x765

    #Address 0x765 read value
    csrr x14, 0x765

    #Address 0x765 Write value 0xdcde2518
    li x3, 0xdcde2518
    csrw 0x765, x3

    #Address 0x765 read value
    csrr x14, 0x765

    #Unmapped address 0xcfc testing: random write/read operations
    #Address 0xcfc Write value 0x822fec29
    li x3, 0x822fec29
    csrw 0xcfc, x3

    #Address 0xcfc read value
    csrr x14, 0xcfc

    #Unmapped address 0x149 testing: random write/read operations
    #Address 0x149 Write value 0xd1f3d9bb
    li x3, 0xd1f3d9bb
    csrw 0x149, x3

    #Address 0x149 Write value 0x3924ff23
    li x3, 0x3924ff23
    csrw 0x149, x3

    #Address 0x149 read value
    csrr x14, 0x149

    #Unmapped address 0x410 testing: random write/read operations
    #Address 0x410 Write value 0x52e57afe
    li x3, 0x52e57afe
    csrw 0x410, x3

    #Address 0x410 Write value 0x1b9b284f
    li x3, 0x1b9b284f
    csrw 0x410, x3

    #Address 0x410 read value
    csrr x14, 0x410

    #Address 0x410 read value
    csrr x14, 0x410

    #Unmapped address 0x51 testing: random write/read operations
    #Address 0x51 Write value 0x8c17be56
    li x3, 0x8c17be56
    csrw 0x51, x3

    #Address 0x51 Write value 0xf369924d
    li x3, 0xf369924d
    csrw 0x51, x3

    #Address 0x51 Write value 0xe036e5dd
    li x3, 0xe036e5dd
    csrw 0x51, x3

    #Unmapped address 0x30f testing: random write/read operations
    #Address 0x30f Write value 0xfd68cffa
    li x3, 0xfd68cffa
    csrw 0x30f, x3

    #Address 0x30f Write value 0xb33142d5
    li x3, 0xb33142d5
    csrw 0x30f, x3

    #Address 0x30f read value
    csrr x14, 0x30f

    #Unmapped address 0xff9 testing: random write/read operations
    #Address 0xff9 read value
    csrr x14, 0xff9

    #Address 0xff9 Write value 0xe0b33a70
    li x3, 0xe0b33a70
    csrw 0xff9, x3

    #Address 0xff9 Write value 0xc1e9c1f9
    li x3, 0xc1e9c1f9
    csrw 0xff9, x3

    #Address 0xff9 read value
    csrr x14, 0xff9

    #Unmapped address 0x5c1 testing: random write/read operations
    #Address 0x5c1 Write value 0x3d4651fb
    li x3, 0x3d4651fb
    csrw 0x5c1, x3

    #Unmapped address 0x132 testing: random write/read operations
    #Address 0x132 Write value 0xc1b8e514
    li x3, 0xc1b8e514
    csrw 0x132, x3

    #Unmapped address 0xe1e testing: random write/read operations
    #Address 0xe1e Write value 0x298047c9
    li x3, 0x298047c9
    csrw 0xe1e, x3

    #Unmapped address 0xd63 testing: random write/read operations
    #Address 0xd63 read value
    csrr x14, 0xd63

    #Unmapped address 0xfad testing: random write/read operations
    #Address 0xfad read value
    csrr x14, 0xfad

    #Address 0xfad read value
    csrr x14, 0xfad

    #Address 0xfad Write value 0x446afe1d
    li x3, 0x446afe1d
    csrw 0xfad, x3

    #Unmapped address 0x840 testing: random write/read operations
    #Address 0x840 read value
    csrr x14, 0x840

    #Address 0x840 Write value 0xa06c4a1
    li x3, 0xa06c4a1
    csrw 0x840, x3

    #Address 0x840 read value
    csrr x14, 0x840

    #Address 0x840 read value
    csrr x14, 0x840

    #Address 0x840 read value
    csrr x14, 0x840

    #Unmapped address 0xc23 testing: random write/read operations
    #Address 0xc23 read value
    csrr x14, 0xc23

    #Unmapped address 0x5b0 testing: random write/read operations
    #Address 0x5b0 read value
    csrr x14, 0x5b0

    #Address 0x5b0 Write value 0x7b952be6
    li x3, 0x7b952be6
    csrw 0x5b0, x3

    #Address 0x5b0 Write value 0x19f88fd9
    li x3, 0x19f88fd9
    csrw 0x5b0, x3

    #Address 0x5b0 read value
    csrr x14, 0x5b0

    #Address 0x5b0 Write value 0x3794c27e
    li x3, 0x3794c27e
    csrw 0x5b0, x3

    #Unmapped address 0xb testing: random write/read operations
    #Address 0xb Write value 0x8288b9f3
    li x3, 0x8288b9f3
    csrw 0xb, x3

    #Address 0xb read value
    csrr x14, 0xb

    #Address 0xb read value
    csrr x14, 0xb

    #Address 0xb read value
    csrr x14, 0xb

    #Unmapped address 0x4f0 testing: random write/read operations
    #Address 0x4f0 read value
    csrr x14, 0x4f0

    #Address 0x4f0 read value
    csrr x14, 0x4f0

    #Address 0x4f0 Write value 0xa611b3ad
    li x3, 0xa611b3ad
    csrw 0x4f0, x3

    #Unmapped address 0xb71 testing: random write/read operations
    #Address 0xb71 read value
    csrr x14, 0xb71

    #Address 0xb71 Write value 0x74b4a370
    li x3, 0x74b4a370
    csrw 0xb71, x3

    #Address 0xb71 Write value 0x5be383aa
    li x3, 0x5be383aa
    csrw 0xb71, x3

    #Unmapped address 0xa51 testing: random write/read operations
    #Address 0xa51 read value
    csrr x14, 0xa51

    #Mapped address 0xb89 (mhpmcounterh9) testing: random write/read operations
    #Address 0xb89 read value
    csrr x14, 0xb89

    #Address 0xb89 read value
    csrr x14, 0xb89

    #Address 0xb89 Write value 0x7883c175
    li x3, 0x7883c175
    csrw 0xb89, x3

    #Address 0xb89 read value
    csrr x14, 0xb89

    #Unmapped address 0x1bb testing: random write/read operations
    #Address 0x1bb Write value 0xea533525
    li x3, 0xea533525
    csrw 0x1bb, x3

    #Address 0x1bb read value
    csrr x14, 0x1bb

    #Address 0x1bb read value
    csrr x14, 0x1bb

    #Unmapped address 0x20a testing: random write/read operations
    #Address 0x20a read value
    csrr x14, 0x20a

    #Unmapped address 0xfd5 testing: random write/read operations
    #Address 0xfd5 read value
    csrr x14, 0xfd5

    #Address 0xfd5 read value
    csrr x14, 0xfd5

    #Address 0xfd5 Write value 0xf9b2630c
    li x3, 0xf9b2630c
    csrw 0xfd5, x3

    #Address 0xfd5 Write value 0xc96434a2
    li x3, 0xc96434a2
    csrw 0xfd5, x3

    #Unmapped address 0x65f testing: random write/read operations
    #Address 0x65f Write value 0x6e0a10e8
    li x3, 0x6e0a10e8
    csrw 0x65f, x3

    #Address 0x65f Write value 0x46b405ea
    li x3, 0x46b405ea
    csrw 0x65f, x3

    #Address 0x65f read value
    csrr x14, 0x65f

    #Unmapped address 0xf8c testing: random write/read operations
    #Address 0xf8c read value
    csrr x14, 0xf8c

    #Address 0xf8c read value
    csrr x14, 0xf8c

    #Address 0xf8c Write value 0xd0601e8f
    li x3, 0xd0601e8f
    csrw 0xf8c, x3

    #Address 0xf8c read value
    csrr x14, 0xf8c

    #Unmapped address 0xdf6 testing: random write/read operations
    #Address 0xdf6 Write value 0xeddee0d9
    li x3, 0xeddee0d9
    csrw 0xdf6, x3

    #Address 0xdf6 Write value 0x94eb4e8a
    li x3, 0x94eb4e8a
    csrw 0xdf6, x3

    #Address 0xdf6 read value
    csrr x14, 0xdf6

    #Unmapped address 0x363 testing: random write/read operations
    #Address 0x363 read value
    csrr x14, 0x363

    #Address 0x363 read value
    csrr x14, 0x363

    #Address 0x363 read value
    csrr x14, 0x363

    #Mapped address 0x32c (mhpmevent12) testing: random write/read operations
    #Address 0x32c read value
    csrr x14, 0x32c

    #Address 0x32c read value
    csrr x14, 0x32c

    #Address 0x32c read value
    csrr x14, 0x32c

    #Unmapped address 0xc7b testing: random write/read operations
    #Address 0xc7b read value
    csrr x14, 0xc7b

    #Address 0xc7b read value
    csrr x14, 0xc7b

    #Address 0xc7b read value
    csrr x14, 0xc7b

    #Address 0xc7b read value
    csrr x14, 0xc7b

    #Unmapped address 0x6ca testing: random write/read operations
    #Address 0x6ca read value
    csrr x14, 0x6ca

    #Address 0x6ca read value
    csrr x14, 0x6ca

    #Address 0x6ca read value
    csrr x14, 0x6ca

    #Unmapped address 0x549 testing: random write/read operations
    #Address 0x549 read value
    csrr x14, 0x549

    #Address 0x549 read value
    csrr x14, 0x549

    #Address 0x549 read value
    csrr x14, 0x549

    #Address 0x549 Write value 0xc89a52f4
    li x3, 0xc89a52f4
    csrw 0x549, x3

    #Address 0x549 read value
    csrr x14, 0x549

    #Unmapped address 0x418 testing: random write/read operations
    #Address 0x418 read value
    csrr x14, 0x418

    #Unmapped address 0x948 testing: random write/read operations
    #Address 0x948 Write value 0x17c8d2ba
    li x3, 0x17c8d2ba
    csrw 0x948, x3

    #Unmapped address 0x84c testing: random write/read operations
    #Address 0x84c Write value 0x764d428e
    li x3, 0x764d428e
    csrw 0x84c, x3

    #Unmapped address 0xe30 testing: random write/read operations
    #Address 0xe30 Write value 0x9a75b350
    li x3, 0x9a75b350
    csrw 0xe30, x3

    #Address 0xe30 read value
    csrr x14, 0xe30

    #Unmapped address 0xfe1 testing: random write/read operations
    #Address 0xfe1 Write value 0x2657a7ec
    li x3, 0x2657a7ec
    csrw 0xfe1, x3

    #Address 0xfe1 Write value 0x98007ff0
    li x3, 0x98007ff0
    csrw 0xfe1, x3

    #Unmapped address 0xd42 testing: random write/read operations
    #Address 0xd42 read value
    csrr x14, 0xd42

    #Unmapped address 0xf5c testing: random write/read operations
    #Address 0xf5c Write value 0xc0320eef
    li x3, 0xc0320eef
    csrw 0xf5c, x3

    #Address 0xf5c read value
    csrr x14, 0xf5c

    #Address 0xf5c read value
    csrr x14, 0xf5c

    #Address 0xf5c Write value 0x936dc368
    li x3, 0x936dc368
    csrw 0xf5c, x3

    #Unmapped address 0x19e testing: random write/read operations
    #Address 0x19e Write value 0x169ed274
    li x3, 0x169ed274
    csrw 0x19e, x3

    #Address 0x19e Write value 0x91132f96
    li x3, 0x91132f96
    csrw 0x19e, x3

    #Address 0x19e Write value 0xc4074e3b
    li x3, 0xc4074e3b
    csrw 0x19e, x3

    #Address 0x19e Write value 0x25aef1bb
    li x3, 0x25aef1bb
    csrw 0x19e, x3

    #Unmapped address 0x620 testing: random write/read operations
    #Address 0x620 Write value 0x317d9bfd
    li x3, 0x317d9bfd
    csrw 0x620, x3

    #Address 0x620 read value
    csrr x14, 0x620

    #Address 0x620 read value
    csrr x14, 0x620

    #Unmapped address 0x7f testing: random write/read operations
    #Address 0x7f Write value 0x45ab2d25
    li x3, 0x45ab2d25
    csrw 0x7f, x3

    #Address 0x7f read value
    csrr x14, 0x7f

    #Address 0x7f read value
    csrr x14, 0x7f

    #Address 0x7f Write value 0x4ecfc705
    li x3, 0x4ecfc705
    csrw 0x7f, x3

    #Address 0x7f read value
    csrr x14, 0x7f

    #Unmapped address 0xd97 testing: random write/read operations
    #Address 0xd97 read value
    csrr x14, 0xd97

    #Address 0xd97 Write value 0xc3a13528
    li x3, 0xc3a13528
    csrw 0xd97, x3

    #Address 0xd97 Write value 0xa563d4a9
    li x3, 0xa563d4a9
    csrw 0xd97, x3

    #Address 0xd97 Write value 0x5549a369
    li x3, 0x5549a369
    csrw 0xd97, x3

    #Address 0xd97 Write value 0x4f0eb229
    li x3, 0x4f0eb229
    csrw 0xd97, x3

    #Unmapped address 0x31 testing: random write/read operations
    #Address 0x31 read value
    csrr x14, 0x31

    #Address 0x31 Write value 0x24d9282d
    li x3, 0x24d9282d
    csrw 0x31, x3

    #Address 0x31 Write value 0xe4446ade
    li x3, 0xe4446ade
    csrw 0x31, x3

    #Address 0x31 read value
    csrr x14, 0x31

    #Unmapped address 0x5c5 testing: random write/read operations
    #Address 0x5c5 Write value 0x5da6aac0
    li x3, 0x5da6aac0
    csrw 0x5c5, x3

    #Address 0x5c5 Write value 0x75d3980e
    li x3, 0x75d3980e
    csrw 0x5c5, x3

    #Unmapped address 0xb2a testing: random write/read operations
    #Address 0xb2a Write value 0x96b12af0
    li x3, 0x96b12af0
    csrw 0xb2a, x3

    #Address 0xb2a read value
    csrr x14, 0xb2a

    #Address 0xb2a Write value 0x799e6786
    li x3, 0x799e6786
    csrw 0xb2a, x3

    #Unmapped address 0x47b testing: random write/read operations
    #Address 0x47b Write value 0x4379fec
    li x3, 0x4379fec
    csrw 0x47b, x3

    #Unmapped address 0xffe testing: random write/read operations
    #Address 0xffe Write value 0x8dfead
    li x3, 0x8dfead
    csrw 0xffe, x3

    #Address 0xffe read value
    csrr x14, 0xffe

    #Address 0xffe read value
    csrr x14, 0xffe

    #Address 0xffe read value
    csrr x14, 0xffe

    #Unmapped address 0x920 testing: random write/read operations
    #Address 0x920 Write value 0x838a5a26
    li x3, 0x838a5a26
    csrw 0x920, x3

    #Address 0x920 read value
    csrr x14, 0x920

    #Address 0x920 Write value 0x8285d110
    li x3, 0x8285d110
    csrw 0x920, x3

    #Address 0x920 read value
    csrr x14, 0x920

    #Address 0x920 read value
    csrr x14, 0x920

    #Unmapped address 0xdd0 testing: random write/read operations
    #Address 0xdd0 Write value 0x3d689205
    li x3, 0x3d689205
    csrw 0xdd0, x3

    #Address 0xdd0 read value
    csrr x14, 0xdd0

    #Address 0xdd0 Write value 0xbc8fa51
    li x3, 0xbc8fa51
    csrw 0xdd0, x3

    #Unmapped address 0xd90 testing: random write/read operations
    #Address 0xd90 Write value 0x101de6c9
    li x3, 0x101de6c9
    csrw 0xd90, x3

    #Address 0xd90 read value
    csrr x14, 0xd90

    #Address 0xd90 read value
    csrr x14, 0xd90

    #Unmapped address 0xbc5 testing: random write/read operations
    #Address 0xbc5 read value
    csrr x14, 0xbc5

    #Address 0xbc5 Write value 0x734edd76
    li x3, 0x734edd76
    csrw 0xbc5, x3

    #Address 0xbc5 read value
    csrr x14, 0xbc5

    #Address 0xbc5 read value
    csrr x14, 0xbc5

    #Unmapped address 0xaa2 testing: random write/read operations
    #Address 0xaa2 Write value 0xbcb40755
    li x3, 0xbcb40755
    csrw 0xaa2, x3

    #Unmapped address 0xa3f testing: random write/read operations
    #Address 0xa3f read value
    csrr x14, 0xa3f

    #Address 0xa3f Write value 0xc7b6f4c5
    li x3, 0xc7b6f4c5
    csrw 0xa3f, x3

    #Address 0xa3f read value
    csrr x14, 0xa3f

    #Address 0xa3f Write value 0xd0019263
    li x3, 0xd0019263
    csrw 0xa3f, x3

    #Unmapped address 0xbb2 testing: random write/read operations
    #Address 0xbb2 read value
    csrr x14, 0xbb2

    #Address 0xbb2 read value
    csrr x14, 0xbb2

    #Address 0xbb2 read value
    csrr x14, 0xbb2

    #Address 0xbb2 Write value 0x60294ba5
    li x3, 0x60294ba5
    csrw 0xbb2, x3

    #Address 0xbb2 Write value 0x3dda1988
    li x3, 0x3dda1988
    csrw 0xbb2, x3

    #Unmapped address 0x2b1 testing: random write/read operations
    #Address 0x2b1 Write value 0x1b86c90e
    li x3, 0x1b86c90e
    csrw 0x2b1, x3

    #Unmapped address 0x637 testing: random write/read operations
    #Address 0x637 Write value 0x3bb5f70
    li x3, 0x3bb5f70
    csrw 0x637, x3

    #Address 0x637 Write value 0x15254f55
    li x3, 0x15254f55
    csrw 0x637, x3

    #Address 0x637 read value
    csrr x14, 0x637

    #Unmapped address 0x9bb testing: random write/read operations
    #Address 0x9bb Write value 0xf752660d
    li x3, 0xf752660d
    csrw 0x9bb, x3

    #Address 0x9bb Write value 0xd66de373
    li x3, 0xd66de373
    csrw 0x9bb, x3

    #Address 0x9bb read value
    csrr x14, 0x9bb

    #Address 0x9bb read value
    csrr x14, 0x9bb

    #Address 0x9bb Write value 0xcf2a54d2
    li x3, 0xcf2a54d2
    csrw 0x9bb, x3

    #Unmapped address 0x264 testing: random write/read operations
    #Address 0x264 read value
    csrr x14, 0x264

    #Address 0x264 Write value 0xf9188e03
    li x3, 0xf9188e03
    csrw 0x264, x3

    #Address 0x264 Write value 0xc6137f4e
    li x3, 0xc6137f4e
    csrw 0x264, x3

    #Unmapped address 0x54d testing: random write/read operations
    #Address 0x54d read value
    csrr x14, 0x54d

    #Address 0x54d Write value 0x53a48907
    li x3, 0x53a48907
    csrw 0x54d, x3

    #Unmapped address 0xdaf testing: random write/read operations
    #Address 0xdaf read value
    csrr x14, 0xdaf

    #Address 0xdaf read value
    csrr x14, 0xdaf

    #Unmapped address 0x834 testing: random write/read operations
    #Address 0x834 read value
    csrr x14, 0x834

    #Address 0x834 Write value 0x158839cb
    li x3, 0x158839cb
    csrw 0x834, x3

    #Address 0x834 Write value 0xb45056cd
    li x3, 0xb45056cd
    csrw 0x834, x3

    #Address 0x834 read value
    csrr x14, 0x834

    #Address 0x834 read value
    csrr x14, 0x834

    #Unmapped address 0xcce testing: random write/read operations
    #Address 0xcce Write value 0xa6083da1
    li x3, 0xa6083da1
    csrw 0xcce, x3

    #Address 0xcce Write value 0xd95a81bf
    li x3, 0xd95a81bf
    csrw 0xcce, x3

    #Address 0xcce read value
    csrr x14, 0xcce

    #Address 0xcce read value
    csrr x14, 0xcce

    #Unmapped address 0xd3 testing: random write/read operations
    #Address 0xd3 read value
    csrr x14, 0xd3

    #Address 0xd3 Write value 0xa328e0c9
    li x3, 0xa328e0c9
    csrw 0xd3, x3

    #Address 0xd3 Write value 0x7d8febe9
    li x3, 0x7d8febe9
    csrw 0xd3, x3

    #Address 0xd3 read value
    csrr x14, 0xd3

    #Unmapped address 0x596 testing: random write/read operations
    #Address 0x596 read value
    csrr x14, 0x596

    #Address 0x596 read value
    csrr x14, 0x596

    #Address 0x596 read value
    csrr x14, 0x596

    #Address 0x596 Write value 0x3b32c39f
    li x3, 0x3b32c39f
    csrw 0x596, x3

    #Address 0x596 Write value 0xc8b3b701
    li x3, 0xc8b3b701
    csrw 0x596, x3

    #Unmapped address 0x9e8 testing: random write/read operations
    #Address 0x9e8 Write value 0x124061d
    li x3, 0x124061d
    csrw 0x9e8, x3

    #Address 0x9e8 Write value 0xe16378b7
    li x3, 0xe16378b7
    csrw 0x9e8, x3

    #Address 0x9e8 read value
    csrr x14, 0x9e8

    #Address 0x9e8 Write value 0x13adcc9
    li x3, 0x13adcc9
    csrw 0x9e8, x3

    #Address 0x9e8 Write value 0xb6c3c606
    li x3, 0xb6c3c606
    csrw 0x9e8, x3

    #Unmapped address 0x869 testing: random write/read operations
    #Address 0x869 read value
    csrr x14, 0x869

    #Unmapped address 0x281 testing: random write/read operations
    #Address 0x281 Write value 0xc9e5f792
    li x3, 0xc9e5f792
    csrw 0x281, x3

    #Address 0x281 Write value 0xde8143a1
    li x3, 0xde8143a1
    csrw 0x281, x3

    #Address 0x281 read value
    csrr x14, 0x281

    #Unmapped address 0x955 testing: random write/read operations
    #Address 0x955 Write value 0xc255c683
    li x3, 0xc255c683
    csrw 0x955, x3

    #Address 0x955 Write value 0x498b1d85
    li x3, 0x498b1d85
    csrw 0x955, x3

    #Address 0x955 Write value 0xc9be7d8d
    li x3, 0xc9be7d8d
    csrw 0x955, x3

    #Unmapped address 0x93b testing: random write/read operations
    #Address 0x93b Write value 0xed73b84c
    li x3, 0xed73b84c
    csrw 0x93b, x3

    #Unmapped address 0x4f5 testing: random write/read operations
    #Address 0x4f5 Write value 0xff3914dd
    li x3, 0xff3914dd
    csrw 0x4f5, x3

    #Address 0x4f5 Write value 0x80fc8efe
    li x3, 0x80fc8efe
    csrw 0x4f5, x3

    #Unmapped address 0x55f testing: random write/read operations
    #Address 0x55f read value
    csrr x14, 0x55f

    #Address 0x55f read value
    csrr x14, 0x55f

    #Address 0x55f read value
    csrr x14, 0x55f

    #Address 0x55f Write value 0x6479a90a
    li x3, 0x6479a90a
    csrw 0x55f, x3

    #Address 0x55f read value
    csrr x14, 0x55f

    #Unmapped address 0x43d testing: random write/read operations
    #Address 0x43d Write value 0xf1c43f0d
    li x3, 0xf1c43f0d
    csrw 0x43d, x3

    #Address 0x43d Write value 0xcdbd173f
    li x3, 0xcdbd173f
    csrw 0x43d, x3

    #Address 0x43d read value
    csrr x14, 0x43d

    #Address 0x43d read value
    csrr x14, 0x43d

    #Address 0x43d read value
    csrr x14, 0x43d

    #Unmapped address 0x1ae testing: random write/read operations
    #Address 0x1ae read value
    csrr x14, 0x1ae

    #Unmapped address 0xb37 testing: random write/read operations
    #Address 0xb37 Write value 0xa4028dcd
    li x3, 0xa4028dcd
    csrw 0xb37, x3

    #Address 0xb37 read value
    csrr x14, 0xb37

    #Address 0xb37 read value
    csrr x14, 0xb37

    #Address 0xb37 Write value 0x48248044
    li x3, 0x48248044
    csrw 0xb37, x3

    #Unmapped address 0xd26 testing: random write/read operations
    #Address 0xd26 Write value 0xa3fe986b
    li x3, 0xa3fe986b
    csrw 0xd26, x3

    #Unmapped address 0x79 testing: random write/read operations
    #Address 0x79 Write value 0xaf5102f7
    li x3, 0xaf5102f7
    csrw 0x79, x3

    #Address 0x79 Write value 0x952f489c
    li x3, 0x952f489c
    csrw 0x79, x3

    #Address 0x79 read value
    csrr x14, 0x79

    #Unmapped address 0x754 testing: random write/read operations
    #Address 0x754 read value
    csrr x14, 0x754

    #Unmapped address 0x56c testing: random write/read operations
    #Address 0x56c read value
    csrr x14, 0x56c

    #Address 0x56c Write value 0x572c17e
    li x3, 0x572c17e
    csrw 0x56c, x3

    #Address 0x56c read value
    csrr x14, 0x56c

    #Unmapped address 0x388 testing: random write/read operations
    #Address 0x388 Write value 0x406726a1
    li x3, 0x406726a1
    csrw 0x388, x3

    #Unmapped address 0xdd7 testing: random write/read operations
    #Address 0xdd7 Write value 0xe31ed67b
    li x3, 0xe31ed67b
    csrw 0xdd7, x3

    #Address 0xdd7 read value
    csrr x14, 0xdd7

    #Address 0xdd7 Write value 0xbd10e988
    li x3, 0xbd10e988
    csrw 0xdd7, x3

    #Unmapped address 0x0 testing: random write/read operations
    #Address 0x0 read value
    csrr x14, 0x0

    #Address 0x0 read value
    csrr x14, 0x0

    #Unmapped address 0x4bb testing: random write/read operations
    #Address 0x4bb Write value 0xbf498633
    li x3, 0xbf498633
    csrw 0x4bb, x3

    #Address 0x4bb read value
    csrr x14, 0x4bb

    #Unmapped address 0x6be testing: random write/read operations
    #Address 0x6be Write value 0x9f927c32
    li x3, 0x9f927c32
    csrw 0x6be, x3

    #Address 0x6be Write value 0x388ca9e3
    li x3, 0x388ca9e3
    csrw 0x6be, x3

    #Address 0x6be Write value 0x871b67a2
    li x3, 0x871b67a2
    csrw 0x6be, x3

    #Address 0x6be Write value 0x4fa5abe
    li x3, 0x4fa5abe
    csrw 0x6be, x3

    #Unmapped address 0x430 testing: random write/read operations
    #Address 0x430 read value
    csrr x14, 0x430

    #Address 0x430 read value
    csrr x14, 0x430

    #Address 0x430 Write value 0x98dea5b0
    li x3, 0x98dea5b0
    csrw 0x430, x3

    #Unmapped address 0x6ef testing: random write/read operations
    #Address 0x6ef read value
    csrr x14, 0x6ef

    #Address 0x6ef read value
    csrr x14, 0x6ef

    #Address 0x6ef read value
    csrr x14, 0x6ef

    #Address 0x6ef read value
    csrr x14, 0x6ef

    #Unmapped address 0x745 testing: random write/read operations
    #Address 0x745 Write value 0xef0fcf63
    li x3, 0xef0fcf63
    csrw 0x745, x3

    #Address 0x745 read value
    csrr x14, 0x745

    #Address 0x745 Write value 0x852bf7c0
    li x3, 0x852bf7c0
    csrw 0x745, x3

    #Unmapped address 0x710 testing: random write/read operations
    #Address 0x710 Write value 0xb57d1913
    li x3, 0xb57d1913
    csrw 0x710, x3

    #Address 0x710 Write value 0xb3044425
    li x3, 0xb3044425
    csrw 0x710, x3

    #Address 0x710 read value
    csrr x14, 0x710

    #Address 0x710 Write value 0x91be295f
    li x3, 0x91be295f
    csrw 0x710, x3

    #Address 0x710 Write value 0x1169eaa5
    li x3, 0x1169eaa5
    csrw 0x710, x3

    #Unmapped address 0x5bd testing: random write/read operations
    #Address 0x5bd read value
    csrr x14, 0x5bd

    #Unmapped address 0x786 testing: random write/read operations
    #Address 0x786 read value
    csrr x14, 0x786

    #Address 0x786 Write value 0xbb5293a2
    li x3, 0xbb5293a2
    csrw 0x786, x3

    #Unmapped address 0xbf4 testing: random write/read operations
    #Address 0xbf4 read value
    csrr x14, 0xbf4

    #Address 0xbf4 read value
    csrr x14, 0xbf4

    #Address 0xbf4 Write value 0x60a42bc4
    li x3, 0x60a42bc4
    csrw 0xbf4, x3

    #Address 0xbf4 Write value 0xb72405d6
    li x3, 0xb72405d6
    csrw 0xbf4, x3

    #Unmapped address 0x4c4 testing: random write/read operations
    #Address 0x4c4 Write value 0xfd46ff12
    li x3, 0xfd46ff12
    csrw 0x4c4, x3

    #Address 0x4c4 Write value 0x8c54f093
    li x3, 0x8c54f093
    csrw 0x4c4, x3

    #Address 0x4c4 read value
    csrr x14, 0x4c4

    #Address 0x4c4 Write value 0x7d99ed3b
    li x3, 0x7d99ed3b
    csrw 0x4c4, x3

    #Unmapped address 0xf21 testing: random write/read operations
    #Address 0xf21 Write value 0x3a728670
    li x3, 0x3a728670
    csrw 0xf21, x3

    #Address 0xf21 read value
    csrr x14, 0xf21

    #Address 0xf21 Write value 0x53ba11f9
    li x3, 0x53ba11f9
    csrw 0xf21, x3

    #Unmapped address 0x29c testing: random write/read operations
    #Address 0x29c Write value 0xb2b4134d
    li x3, 0xb2b4134d
    csrw 0x29c, x3

    #Unmapped address 0x551 testing: random write/read operations
    #Address 0x551 Write value 0xa0e159b5
    li x3, 0xa0e159b5
    csrw 0x551, x3

    #Address 0x551 read value
    csrr x14, 0x551

    #Address 0x551 Write value 0x9a16de8b
    li x3, 0x9a16de8b
    csrw 0x551, x3

    #Address 0x551 Write value 0x534137a6
    li x3, 0x534137a6
    csrw 0x551, x3

    #Unmapped address 0xe77 testing: random write/read operations
    #Address 0xe77 Write value 0x8f06c52
    li x3, 0x8f06c52
    csrw 0xe77, x3

    #Unmapped address 0x572 testing: random write/read operations
    #Address 0x572 Write value 0xb1298cf9
    li x3, 0xb1298cf9
    csrw 0x572, x3

    #Unmapped address 0x6d8 testing: random write/read operations
    #Address 0x6d8 Write value 0x11b13cff
    li x3, 0x11b13cff
    csrw 0x6d8, x3

    #Address 0x6d8 read value
    csrr x14, 0x6d8

    #Unmapped address 0x355 testing: random write/read operations
    #Address 0x355 read value
    csrr x14, 0x355

    #Address 0x355 read value
    csrr x14, 0x355

    #Address 0x355 read value
    csrr x14, 0x355

    #Address 0x355 read value
    csrr x14, 0x355

    #Unmapped address 0x8a5 testing: random write/read operations
    #Address 0x8a5 read value
    csrr x14, 0x8a5

    #Unmapped address 0x4b2 testing: random write/read operations
    #Address 0x4b2 read value
    csrr x14, 0x4b2

    #Address 0x4b2 read value
    csrr x14, 0x4b2

    #Mapped address 0x301 (misa) testing: random write/read operations
    #Address 0x301 Write value 0xddae1237
    li x3, 0xddae1237
    csrw 0x301, x3

    #Unmapped address 0x667 testing: random write/read operations
    #Address 0x667 read value
    csrr x14, 0x667

    #Address 0x667 Write value 0x4d9f2e06
    li x3, 0x4d9f2e06
    csrw 0x667, x3

    #Address 0x667 Write value 0x3f282266
    li x3, 0x3f282266
    csrw 0x667, x3

    #Address 0x667 Write value 0xeff30899
    li x3, 0xeff30899
    csrw 0x667, x3

    #Unmapped address 0x8d testing: random write/read operations
    #Address 0x8d read value
    csrr x14, 0x8d

    #Address 0x8d Write value 0x6891c27f
    li x3, 0x6891c27f
    csrw 0x8d, x3

    #Address 0x8d Write value 0x2a406f76
    li x3, 0x2a406f76
    csrw 0x8d, x3

    #Unmapped address 0x1b0 testing: random write/read operations
    #Address 0x1b0 Write value 0x337327c7
    li x3, 0x337327c7
    csrw 0x1b0, x3

    #Unmapped address 0x2ac testing: random write/read operations
    #Address 0x2ac Write value 0xc5ee810b
    li x3, 0xc5ee810b
    csrw 0x2ac, x3

    #Address 0x2ac Write value 0xeaedf875
    li x3, 0xeaedf875
    csrw 0x2ac, x3

    #Address 0x2ac Write value 0x748829f4
    li x3, 0x748829f4
    csrw 0x2ac, x3

    #Address 0x2ac read value
    csrr x14, 0x2ac

    #Unmapped address 0xec8 testing: random write/read operations
    #Address 0xec8 Write value 0x9b3a0ff2
    li x3, 0x9b3a0ff2
    csrw 0xec8, x3

    #Unmapped address 0xd65 testing: random write/read operations
    #Address 0xd65 Write value 0x41415273
    li x3, 0x41415273
    csrw 0xd65, x3

    #Address 0xd65 read value
    csrr x14, 0xd65

    #Address 0xd65 Write value 0x74e28e46
    li x3, 0x74e28e46
    csrw 0xd65, x3

    #Address 0xd65 Write value 0x90e5acec
    li x3, 0x90e5acec
    csrw 0xd65, x3

    #Address 0xd65 Write value 0x47ccfb56
    li x3, 0x47ccfb56
    csrw 0xd65, x3

    #Unmapped address 0xe83 testing: random write/read operations
    #Address 0xe83 Write value 0x60732e0e
    li x3, 0x60732e0e
    csrw 0xe83, x3

    #Address 0xe83 read value
    csrr x14, 0xe83

    #Address 0xe83 Write value 0xf655ac32
    li x3, 0xf655ac32
    csrw 0xe83, x3

    #Unmapped address 0x2f5 testing: random write/read operations
    #Address 0x2f5 Write value 0x31c3a78a
    li x3, 0x31c3a78a
    csrw 0x2f5, x3

    #Address 0x2f5 Write value 0x3de3b60f
    li x3, 0x3de3b60f
    csrw 0x2f5, x3

    #Address 0x2f5 read value
    csrr x14, 0x2f5

    #Address 0x2f5 Write value 0x1a59884f
    li x3, 0x1a59884f
    csrw 0x2f5, x3

    #Unmapped address 0x654 testing: random write/read operations
    #Address 0x654 Write value 0x1d5c44c0
    li x3, 0x1d5c44c0
    csrw 0x654, x3

    #Address 0x654 Write value 0x47c9ae49
    li x3, 0x47c9ae49
    csrw 0x654, x3

    #Address 0x654 read value
    csrr x14, 0x654

    #Address 0x654 Write value 0xdc5a99f1
    li x3, 0xdc5a99f1
    csrw 0x654, x3

    #Unmapped address 0xabd testing: random write/read operations
    #Address 0xabd Write value 0xb4fedd97
    li x3, 0xb4fedd97
    csrw 0xabd, x3

    #Address 0xabd read value
    csrr x14, 0xabd

    #Address 0xabd read value
    csrr x14, 0xabd

    #Address 0xabd Write value 0xbf10441b
    li x3, 0xbf10441b
    csrw 0xabd, x3

    #Address 0xabd read value
    csrr x14, 0xabd

    #Unmapped address 0x9bd testing: random write/read operations
    #Address 0x9bd Write value 0x2120e17e
    li x3, 0x2120e17e
    csrw 0x9bd, x3

    #Address 0x9bd read value
    csrr x14, 0x9bd

    #Address 0x9bd read value
    csrr x14, 0x9bd

    #Address 0x9bd read value
    csrr x14, 0x9bd

    #Address 0x9bd Write value 0x4938b996
    li x3, 0x4938b996
    csrw 0x9bd, x3

    #Unmapped address 0x37c testing: random write/read operations
    #Address 0x37c Write value 0xf50c8c6e
    li x3, 0xf50c8c6e
    csrw 0x37c, x3

    #Address 0x37c read value
    csrr x14, 0x37c

    #Address 0x37c Write value 0x63b15057
    li x3, 0x63b15057
    csrw 0x37c, x3

    #Address 0x37c Write value 0xa331e998
    li x3, 0xa331e998
    csrw 0x37c, x3

    #Address 0x37c Write value 0x9c418f2c
    li x3, 0x9c418f2c
    csrw 0x37c, x3

    #Unmapped address 0x41f testing: random write/read operations
    #Address 0x41f read value
    csrr x14, 0x41f

    #Unmapped address 0x38e testing: random write/read operations
    #Address 0x38e read value
    csrr x14, 0x38e

    #Address 0x38e read value
    csrr x14, 0x38e

    #Address 0x38e read value
    csrr x14, 0x38e

    #Address 0x38e read value
    csrr x14, 0x38e

    #Unmapped address 0x67c testing: random write/read operations
    #Address 0x67c read value
    csrr x14, 0x67c

    #Address 0x67c Write value 0xc1710023
    li x3, 0xc1710023
    csrw 0x67c, x3

    #Address 0x67c read value
    csrr x14, 0x67c

    #Unmapped address 0xa20 testing: random write/read operations
    #Address 0xa20 read value
    csrr x14, 0xa20

    #Address 0xa20 Write value 0x86a797f2
    li x3, 0x86a797f2
    csrw 0xa20, x3

    #Unmapped address 0xcd3 testing: random write/read operations
    #Address 0xcd3 Write value 0x889e948c
    li x3, 0x889e948c
    csrw 0xcd3, x3

    #Address 0xcd3 read value
    csrr x14, 0xcd3

    #Address 0xcd3 read value
    csrr x14, 0xcd3

    #Unmapped address 0xb2e testing: random write/read operations
    #Address 0xb2e Write value 0xa98a7a0a
    li x3, 0xa98a7a0a
    csrw 0xb2e, x3

    #Address 0xb2e read value
    csrr x14, 0xb2e

    #Address 0xb2e read value
    csrr x14, 0xb2e

    #Unmapped address 0xd09 testing: random write/read operations
    #Address 0xd09 read value
    csrr x14, 0xd09

    #Address 0xd09 read value
    csrr x14, 0xd09

    #Address 0xd09 read value
    csrr x14, 0xd09

    #Unmapped address 0xaf0 testing: random write/read operations
    #Address 0xaf0 read value
    csrr x14, 0xaf0

    #Address 0xaf0 Write value 0x91af5143
    li x3, 0x91af5143
    csrw 0xaf0, x3

    #Address 0xaf0 Write value 0x80854754
    li x3, 0x80854754
    csrw 0xaf0, x3

    #Address 0xaf0 read value
    csrr x14, 0xaf0

    #Address 0xaf0 Write value 0x96122a7
    li x3, 0x96122a7
    csrw 0xaf0, x3

    #Unmapped address 0x6e3 testing: random write/read operations
    #Address 0x6e3 read value
    csrr x14, 0x6e3

    #Unmapped address 0xfda testing: random write/read operations
    #Address 0xfda read value
    csrr x14, 0xfda

    #Unmapped address 0x912 testing: random write/read operations
    #Address 0x912 read value
    csrr x14, 0x912

    #Unmapped address 0xcac testing: random write/read operations
    #Address 0xcac Write value 0x96d65924
    li x3, 0x96d65924
    csrw 0xcac, x3

    #Address 0xcac read value
    csrr x14, 0xcac

    #Address 0xcac Write value 0x7fccb0b5
    li x3, 0x7fccb0b5
    csrw 0xcac, x3

    #Address 0xcac read value
    csrr x14, 0xcac

    #Unmapped address 0xf4 testing: random write/read operations
    #Address 0xf4 Write value 0x19b42c05
    li x3, 0x19b42c05
    csrw 0xf4, x3

    #Address 0xf4 read value
    csrr x14, 0xf4

    #Address 0xf4 read value
    csrr x14, 0xf4

    #Address 0xf4 read value
    csrr x14, 0xf4

    #Address 0xf4 Write value 0x1a7b9e88
    li x3, 0x1a7b9e88
    csrw 0xf4, x3

    #Unmapped address 0x592 testing: random write/read operations
    #Address 0x592 Write value 0x6c534489
    li x3, 0x6c534489
    csrw 0x592, x3

    #Address 0x592 Write value 0x6cb70f58
    li x3, 0x6cb70f58
    csrw 0x592, x3

    #Address 0x592 read value
    csrr x14, 0x592

    #Unmapped address 0xa35 testing: random write/read operations
    #Address 0xa35 read value
    csrr x14, 0xa35

    #Address 0xa35 read value
    csrr x14, 0xa35

    #Address 0xa35 read value
    csrr x14, 0xa35

    #Unmapped address 0x198 testing: random write/read operations
    #Address 0x198 Write value 0x83062c1e
    li x3, 0x83062c1e
    csrw 0x198, x3

    #Address 0x198 Write value 0x73342811
    li x3, 0x73342811
    csrw 0x198, x3

    #Address 0x198 Write value 0xa40a8f09
    li x3, 0xa40a8f09
    csrw 0x198, x3

    #Address 0x198 Write value 0x64a2e0c
    li x3, 0x64a2e0c
    csrw 0x198, x3

    #Unmapped address 0xf40 testing: random write/read operations
    #Address 0xf40 read value
    csrr x14, 0xf40

    #Address 0xf40 Write value 0x1534474a
    li x3, 0x1534474a
    csrw 0xf40, x3

    #Address 0xf40 Write value 0xd7c3c836
    li x3, 0xd7c3c836
    csrw 0xf40, x3

    #Address 0xf40 read value
    csrr x14, 0xf40

    #Address 0xf40 Write value 0x2870c17c
    li x3, 0x2870c17c
    csrw 0xf40, x3

    #Unmapped address 0x59e testing: random write/read operations
    #Address 0x59e read value
    csrr x14, 0x59e

    #Address 0x59e read value
    csrr x14, 0x59e

    #Address 0x59e Write value 0xe40ba63
    li x3, 0xe40ba63
    csrw 0x59e, x3

    #Address 0x59e read value
    csrr x14, 0x59e

    #Unmapped address 0xe29 testing: random write/read operations
    #Address 0xe29 read value
    csrr x14, 0xe29

    #Address 0xe29 read value
    csrr x14, 0xe29

    #Unmapped address 0x230 testing: random write/read operations
    #Address 0x230 read value
    csrr x14, 0x230

    #Address 0x230 Write value 0xd04984fa
    li x3, 0xd04984fa
    csrw 0x230, x3

    #Address 0x230 read value
    csrr x14, 0x230

    #Unmapped address 0x2da testing: random write/read operations
    #Address 0x2da Write value 0x79469baa
    li x3, 0x79469baa
    csrw 0x2da, x3

    #Address 0x2da Write value 0x4a0ba472
    li x3, 0x4a0ba472
    csrw 0x2da, x3

    #Address 0x2da Write value 0xccb0048a
    li x3, 0xccb0048a
    csrw 0x2da, x3

    #Unmapped address 0x143 testing: random write/read operations
    #Address 0x143 read value
    csrr x14, 0x143

    #Address 0x143 read value
    csrr x14, 0x143

    #Unmapped address 0x375 testing: random write/read operations
    #Address 0x375 Write value 0xd3b564e3
    li x3, 0xd3b564e3
    csrw 0x375, x3

    #Address 0x375 read value
    csrr x14, 0x375

    #Unmapped address 0xfd4 testing: random write/read operations
    #Address 0xfd4 read value
    csrr x14, 0xfd4

    #Address 0xfd4 Write value 0x83f8714
    li x3, 0x83f8714
    csrw 0xfd4, x3

    #Address 0xfd4 read value
    csrr x14, 0xfd4

    #Unmapped address 0x553 testing: random write/read operations
    #Address 0x553 Write value 0xeb8b72e4
    li x3, 0xeb8b72e4
    csrw 0x553, x3

    #Mapped address 0xb0d (mhpmcounter13) testing: random write/read operations
    #Address 0xb0d read value
    csrr x14, 0xb0d

    #Address 0xb0d read value
    csrr x14, 0xb0d

    #Address 0xb0d Write value 0xf8e5cd04
    li x3, 0xf8e5cd04
    csrw 0xb0d, x3

    #Address 0xb0d read value
    csrr x14, 0xb0d

    #Unmapped address 0xb22 testing: random write/read operations
    #Address 0xb22 Write value 0xbe3cf37f
    li x3, 0xbe3cf37f
    csrw 0xb22, x3

    #Address 0xb22 read value
    csrr x14, 0xb22

    #Address 0xb22 read value
    csrr x14, 0xb22

    #Address 0xb22 Write value 0xc278095e
    li x3, 0xc278095e
    csrw 0xb22, x3

    #Address 0xb22 read value
    csrr x14, 0xb22

    #Unmapped address 0x6ba testing: random write/read operations
    #Address 0x6ba Write value 0x925d35a9
    li x3, 0x925d35a9
    csrw 0x6ba, x3

    #Address 0x6ba Write value 0x8b51bf21
    li x3, 0x8b51bf21
    csrw 0x6ba, x3

    #Address 0x6ba Write value 0x1f7bcc8b
    li x3, 0x1f7bcc8b
    csrw 0x6ba, x3

    #Unmapped address 0x563 testing: random write/read operations
    #Address 0x563 Write value 0x626b2fde
    li x3, 0x626b2fde
    csrw 0x563, x3

    #Unmapped address 0x496 testing: random write/read operations
    #Address 0x496 read value
    csrr x14, 0x496

    #Address 0x496 read value
    csrr x14, 0x496

    #Address 0x496 Write value 0xaaec27ea
    li x3, 0xaaec27ea
    csrw 0x496, x3

    #Address 0x496 read value
    csrr x14, 0x496

    #Unmapped address 0x299 testing: random write/read operations
    #Address 0x299 read value
    csrr x14, 0x299

    #Address 0x299 Write value 0xb36dfd47
    li x3, 0xb36dfd47
    csrw 0x299, x3

    #Address 0x299 Write value 0xbb3ee79f
    li x3, 0xbb3ee79f
    csrw 0x299, x3

    #Unmapped address 0xd57 testing: random write/read operations
    #Address 0xd57 Write value 0x5516e024
    li x3, 0x5516e024
    csrw 0xd57, x3

    #Address 0xd57 Write value 0x3e07cc6b
    li x3, 0x3e07cc6b
    csrw 0xd57, x3

    #Address 0xd57 read value
    csrr x14, 0xd57

    #Address 0xd57 Write value 0x1fe5e942
    li x3, 0x1fe5e942
    csrw 0xd57, x3

    #Address 0xd57 read value
    csrr x14, 0xd57

    #Unmapped address 0xeb testing: random write/read operations
    #Address 0xeb Write value 0x8b67b263
    li x3, 0x8b67b263
    csrw 0xeb, x3

    #Address 0xeb Write value 0x17fa7cbb
    li x3, 0x17fa7cbb
    csrw 0xeb, x3

    #Address 0xeb Write value 0xa99ecb90
    li x3, 0xa99ecb90
    csrw 0xeb, x3

    #Unmapped address 0xfbf testing: random write/read operations
    #Address 0xfbf Write value 0x76a3e801
    li x3, 0x76a3e801
    csrw 0xfbf, x3

    #Address 0xfbf read value
    csrr x14, 0xfbf

    #Address 0xfbf Write value 0xe5b480ad
    li x3, 0xe5b480ad
    csrw 0xfbf, x3

    #Address 0xfbf read value
    csrr x14, 0xfbf

    #Address 0xfbf read value
    csrr x14, 0xfbf

    #Unmapped address 0x758 testing: random write/read operations
    #Address 0x758 Write value 0xc620b778
    li x3, 0xc620b778
    csrw 0x758, x3

    #Address 0x758 Write value 0xe1f0ba1e
    li x3, 0xe1f0ba1e
    csrw 0x758, x3

    #Address 0x758 read value
    csrr x14, 0x758

    #Unmapped address 0xc6f testing: random write/read operations
    #Address 0xc6f Write value 0x9d77324f
    li x3, 0x9d77324f
    csrw 0xc6f, x3

    #Address 0xc6f Write value 0x287cdb
    li x3, 0x287cdb
    csrw 0xc6f, x3

    #Address 0xc6f read value
    csrr x14, 0xc6f

    #Address 0xc6f read value
    csrr x14, 0xc6f

    #Unmapped address 0x3e8 testing: random write/read operations
    #Address 0x3e8 read value
    csrr x14, 0x3e8

    #Unmapped address 0xe3e testing: random write/read operations
    #Address 0xe3e read value
    csrr x14, 0xe3e

    #Address 0xe3e Write value 0x79266811
    li x3, 0x79266811
    csrw 0xe3e, x3

    #Unmapped address 0xec3 testing: random write/read operations
    #Address 0xec3 Write value 0x8b3b0466
    li x3, 0x8b3b0466
    csrw 0xec3, x3

    #Address 0xec3 read value
    csrr x14, 0xec3

    #Address 0xec3 read value
    csrr x14, 0xec3

    #Mapped address 0xb19 (mhpmcounter25) testing: random write/read operations
    #Address 0xb19 read value
    csrr x14, 0xb19

    #Address 0xb19 read value
    csrr x14, 0xb19

    #Unmapped address 0x1eb testing: random write/read operations
    #Address 0x1eb Write value 0x56c3b9cc
    li x3, 0x56c3b9cc
    csrw 0x1eb, x3

    #Address 0x1eb read value
    csrr x14, 0x1eb

    #Address 0x1eb read value
    csrr x14, 0x1eb

    #Address 0x1eb read value
    csrr x14, 0x1eb

    #Address 0x1eb read value
    csrr x14, 0x1eb

    #Unmapped address 0x4a2 testing: random write/read operations
    #Address 0x4a2 Write value 0x2d00fca0
    li x3, 0x2d00fca0
    csrw 0x4a2, x3

    #Address 0x4a2 read value
    csrr x14, 0x4a2

    #Address 0x4a2 read value
    csrr x14, 0x4a2

    #Address 0x4a2 Write value 0xca4ecef3
    li x3, 0xca4ecef3
    csrw 0x4a2, x3

    #Unmapped address 0x832 testing: random write/read operations
    #Address 0x832 Write value 0x5d78d16d
    li x3, 0x5d78d16d
    csrw 0x832, x3

    #Address 0x832 read value
    csrr x14, 0x832

    #Address 0x832 Write value 0x90a2edfd
    li x3, 0x90a2edfd
    csrw 0x832, x3

    #Address 0x832 Write value 0xf5f8b702
    li x3, 0xf5f8b702
    csrw 0x832, x3

    #Address 0x832 read value
    csrr x14, 0x832

    #Unmapped address 0x6f2 testing: random write/read operations
    #Address 0x6f2 Write value 0xf8fc1b08
    li x3, 0xf8fc1b08
    csrw 0x6f2, x3

    #Unmapped address 0x25d testing: random write/read operations
    #Address 0x25d Write value 0xaec38999
    li x3, 0xaec38999
    csrw 0x25d, x3

    #Address 0x25d read value
    csrr x14, 0x25d

    #Unmapped address 0x604 testing: random write/read operations
    #Address 0x604 read value
    csrr x14, 0x604

    #Address 0x604 Write value 0x9a6066fd
    li x3, 0x9a6066fd
    csrw 0x604, x3

    #Address 0x604 Write value 0x9b41d0d2
    li x3, 0x9b41d0d2
    csrw 0x604, x3

    #Unmapped address 0x9d9 testing: random write/read operations
    #Address 0x9d9 read value
    csrr x14, 0x9d9

    #Address 0x9d9 read value
    csrr x14, 0x9d9

    #Unmapped address 0xe25 testing: random write/read operations
    #Address 0xe25 Write value 0x221cffa
    li x3, 0x221cffa
    csrw 0xe25, x3

    #Address 0xe25 Write value 0xfed64616
    li x3, 0xfed64616
    csrw 0xe25, x3

    #Address 0xe25 Write value 0x2a0659a6
    li x3, 0x2a0659a6
    csrw 0xe25, x3

    #Address 0xe25 read value
    csrr x14, 0xe25

    #Address 0xe25 read value
    csrr x14, 0xe25

    #Unmapped address 0x480 testing: random write/read operations
    #Address 0x480 Write value 0xd231d7e7
    li x3, 0xd231d7e7
    csrw 0x480, x3

    #Address 0x480 read value
    csrr x14, 0x480

    #Unmapped address 0x19a testing: random write/read operations
    #Address 0x19a Write value 0x6c1a86f
    li x3, 0x6c1a86f
    csrw 0x19a, x3

    #Unmapped address 0x748 testing: random write/read operations
    #Address 0x748 Write value 0x65916324
    li x3, 0x65916324
    csrw 0x748, x3

    #Address 0x748 read value
    csrr x14, 0x748

    #Unmapped address 0x7b4 testing: random write/read operations
    #Address 0x7b4 Write value 0x905c976e
    li x3, 0x905c976e
    csrw 0x7b4, x3

    #Address 0x7b4 Write value 0xadd78891
    li x3, 0xadd78891
    csrw 0x7b4, x3

    #Unmapped address 0xbd1 testing: random write/read operations
    #Address 0xbd1 read value
    csrr x14, 0xbd1

    #Address 0xbd1 Write value 0xa7ae0679
    li x3, 0xa7ae0679
    csrw 0xbd1, x3

    #Unmapped address 0x9f1 testing: random write/read operations
    #Address 0x9f1 read value
    csrr x14, 0x9f1

    #Address 0x9f1 read value
    csrr x14, 0x9f1

    #Mapped address 0xb17 (mhpmcounter23) testing: random write/read operations
    #Address 0xb17 Write value 0x80c93515
    li x3, 0x80c93515
    csrw 0xb17, x3

    #Address 0xb17 read value
    csrr x14, 0xb17

    #Address 0xb17 Write value 0xccb4b814
    li x3, 0xccb4b814
    csrw 0xb17, x3

    #Address 0xb17 read value
    csrr x14, 0xb17

    #Unmapped address 0xdbe testing: random write/read operations
    #Address 0xdbe read value
    csrr x14, 0xdbe

    #Address 0xdbe Write value 0xca6c8889
    li x3, 0xca6c8889
    csrw 0xdbe, x3

    #Unmapped address 0xaba testing: random write/read operations
    #Address 0xaba Write value 0x732525d8
    li x3, 0x732525d8
    csrw 0xaba, x3

    #Address 0xaba Write value 0xac784f2
    li x3, 0xac784f2
    csrw 0xaba, x3

    #Address 0xaba Write value 0xf353f8bc
    li x3, 0xf353f8bc
    csrw 0xaba, x3

    #Unmapped address 0xe4 testing: random write/read operations
    #Address 0xe4 read value
    csrr x14, 0xe4

    #Address 0xe4 Write value 0x1b35b789
    li x3, 0x1b35b789
    csrw 0xe4, x3

    #Address 0xe4 read value
    csrr x14, 0xe4

    #Unmapped address 0x56 testing: random write/read operations
    #Address 0x56 Write value 0xd19ea9e5
    li x3, 0xd19ea9e5
    csrw 0x56, x3

    #Address 0x56 Write value 0x8a7335d
    li x3, 0x8a7335d
    csrw 0x56, x3

    #Unmapped address 0x15a testing: random write/read operations
    #Address 0x15a read value
    csrr x14, 0x15a

    #Address 0x15a read value
    csrr x14, 0x15a

    #Address 0x15a read value
    csrr x14, 0x15a

    #Address 0x15a read value
    csrr x14, 0x15a

    #Unmapped address 0x68b testing: random write/read operations
    #Address 0x68b Write value 0x7551e2fb
    li x3, 0x7551e2fb
    csrw 0x68b, x3

    #Address 0x68b read value
    csrr x14, 0x68b

    #Address 0x68b read value
    csrr x14, 0x68b

    #Address 0x68b read value
    csrr x14, 0x68b

    #Address 0x68b Write value 0x87cad089
    li x3, 0x87cad089
    csrw 0x68b, x3

    #Unmapped address 0x242 testing: random write/read operations
    #Address 0x242 Write value 0x32ce6e36
    li x3, 0x32ce6e36
    csrw 0x242, x3

    #Address 0x242 read value
    csrr x14, 0x242

    #Address 0x242 read value
    csrr x14, 0x242

    #Address 0x242 Write value 0x20dd209e
    li x3, 0x20dd209e
    csrw 0x242, x3

    #Unmapped address 0xb6a testing: random write/read operations
    #Address 0xb6a Write value 0x81c2cbab
    li x3, 0x81c2cbab
    csrw 0xb6a, x3

    #Address 0xb6a read value
    csrr x14, 0xb6a

    #Address 0xb6a Write value 0xd4eaf7d4
    li x3, 0xd4eaf7d4
    csrw 0xb6a, x3

    #Address 0xb6a Write value 0x9f9a511d
    li x3, 0x9f9a511d
    csrw 0xb6a, x3

    #Address 0xb6a Write value 0x7c6d9fbb
    li x3, 0x7c6d9fbb
    csrw 0xb6a, x3

    #Unmapped address 0x6af testing: random write/read operations
    #Address 0x6af read value
    csrr x14, 0x6af

    #Address 0x6af Write value 0xaf6ba84f
    li x3, 0xaf6ba84f
    csrw 0x6af, x3

    #Address 0x6af Write value 0x4974ba34
    li x3, 0x4974ba34
    csrw 0x6af, x3

    #Address 0x6af read value
    csrr x14, 0x6af

    #Unmapped address 0x80f testing: random write/read operations
    #Address 0x80f Write value 0x89c1517f
    li x3, 0x89c1517f
    csrw 0x80f, x3

    #Address 0x80f Write value 0xbd3591
    li x3, 0xbd3591
    csrw 0x80f, x3

    #Address 0x80f Write value 0x4a6d9617
    li x3, 0x4a6d9617
    csrw 0x80f, x3

    #Address 0x80f read value
    csrr x14, 0x80f

    #Address 0x80f Write value 0x6abf913
    li x3, 0x6abf913
    csrw 0x80f, x3

    #Unmapped address 0x660 testing: random write/read operations
    #Address 0x660 Write value 0x8a7bd9e1
    li x3, 0x8a7bd9e1
    csrw 0x660, x3

    #Address 0x660 Write value 0xe1ed27e1
    li x3, 0xe1ed27e1
    csrw 0x660, x3

    #Unmapped address 0xe78 testing: random write/read operations
    #Address 0xe78 Write value 0xe5354ff8
    li x3, 0xe5354ff8
    csrw 0xe78, x3

    #Address 0xe78 Write value 0xf61c8e4f
    li x3, 0xf61c8e4f
    csrw 0xe78, x3

    #Address 0xe78 Write value 0xc40f21e6
    li x3, 0xc40f21e6
    csrw 0xe78, x3

    #Unmapped address 0xec testing: random write/read operations
    #Address 0xec Write value 0x144073aa
    li x3, 0x144073aa
    csrw 0xec, x3

    #Address 0xec read value
    csrr x14, 0xec

    #Address 0xec read value
    csrr x14, 0xec

    #Address 0xec read value
    csrr x14, 0xec

    #Address 0xec read value
    csrr x14, 0xec

    #Unmapped address 0x569 testing: random write/read operations
    #Address 0x569 read value
    csrr x14, 0x569

    #Address 0x569 read value
    csrr x14, 0x569

    #Unmapped address 0x2bd testing: random write/read operations
    #Address 0x2bd Write value 0x749a3d7b
    li x3, 0x749a3d7b
    csrw 0x2bd, x3

    #Address 0x2bd Write value 0x1ce5c9c
    li x3, 0x1ce5c9c
    csrw 0x2bd, x3

    #Unmapped address 0x9e1 testing: random write/read operations
    #Address 0x9e1 read value
    csrr x14, 0x9e1

    #Address 0x9e1 Write value 0xe307501
    li x3, 0xe307501
    csrw 0x9e1, x3

    #Address 0x9e1 Write value 0xbec6c113
    li x3, 0xbec6c113
    csrw 0x9e1, x3

    #Address 0x9e1 Write value 0xc956ace6
    li x3, 0xc956ace6
    csrw 0x9e1, x3

    #Unmapped address 0xdb testing: random write/read operations
    #Address 0xdb read value
    csrr x14, 0xdb

    #Address 0xdb read value
    csrr x14, 0xdb

    #Address 0xdb read value
    csrr x14, 0xdb

    #Unmapped address 0xa15 testing: random write/read operations
    #Address 0xa15 read value
    csrr x14, 0xa15

    #Address 0xa15 read value
    csrr x14, 0xa15

    #Unmapped address 0x965 testing: random write/read operations
    #Address 0x965 Write value 0x89ea9848
    li x3, 0x89ea9848
    csrw 0x965, x3

    #Address 0x965 Write value 0x76fa0bf8
    li x3, 0x76fa0bf8
    csrw 0x965, x3

    #Address 0x965 read value
    csrr x14, 0x965

    #Address 0x965 Write value 0x7354d80c
    li x3, 0x7354d80c
    csrw 0x965, x3

    #Address 0x965 read value
    csrr x14, 0x965

    #Unmapped address 0x4a9 testing: random write/read operations
    #Address 0x4a9 Write value 0xcab0f625
    li x3, 0xcab0f625
    csrw 0x4a9, x3

    #Address 0x4a9 Write value 0x9f213bdd
    li x3, 0x9f213bdd
    csrw 0x4a9, x3

    #Address 0x4a9 read value
    csrr x14, 0x4a9

    #Unmapped address 0x892 testing: random write/read operations
    #Address 0x892 read value
    csrr x14, 0x892

    #Unmapped address 0x28b testing: random write/read operations
    #Address 0x28b read value
    csrr x14, 0x28b

    #Mapped address 0x33d (mhpmevent29) testing: random write/read operations
    #Address 0x33d read value
    csrr x14, 0x33d

    #Unmapped address 0xd39 testing: random write/read operations
    #Address 0xd39 Write value 0x410dd5c5
    li x3, 0x410dd5c5
    csrw 0xd39, x3

    #Address 0xd39 read value
    csrr x14, 0xd39

    #Address 0xd39 Write value 0x4e298e42
    li x3, 0x4e298e42
    csrw 0xd39, x3

    #Unmapped address 0xdd6 testing: random write/read operations
    #Address 0xdd6 Write value 0x3f9f8197
    li x3, 0x3f9f8197
    csrw 0xdd6, x3

    #Address 0xdd6 Write value 0x68bc4481
    li x3, 0x68bc4481
    csrw 0xdd6, x3

    #Address 0xdd6 read value
    csrr x14, 0xdd6

    #Unmapped address 0xc57 testing: random write/read operations
    #Address 0xc57 Write value 0x3c1dbb18
    li x3, 0x3c1dbb18
    csrw 0xc57, x3

    #Address 0xc57 read value
    csrr x14, 0xc57

    #Address 0xc57 Write value 0x8d862c1c
    li x3, 0x8d862c1c
    csrw 0xc57, x3

    #Address 0xc57 read value
    csrr x14, 0xc57

    #Address 0xc57 read value
    csrr x14, 0xc57

    #Unmapped address 0x898 testing: random write/read operations
    #Address 0x898 Write value 0x45c62ba0
    li x3, 0x45c62ba0
    csrw 0x898, x3

    #Unmapped address 0x5c4 testing: random write/read operations
    #Address 0x5c4 Write value 0x5ebdb477
    li x3, 0x5ebdb477
    csrw 0x5c4, x3

    #Address 0x5c4 Write value 0x6d514ec1
    li x3, 0x6d514ec1
    csrw 0x5c4, x3

    #Address 0x5c4 read value
    csrr x14, 0x5c4

    #Address 0x5c4 read value
    csrr x14, 0x5c4

    #Unmapped address 0xe88 testing: random write/read operations
    #Address 0xe88 read value
    csrr x14, 0xe88

    #Address 0xe88 read value
    csrr x14, 0xe88

    #Address 0xe88 Write value 0x3c8ef112
    li x3, 0x3c8ef112
    csrw 0xe88, x3

    #Address 0xe88 read value
    csrr x14, 0xe88

    #Unmapped address 0x384 testing: random write/read operations
    #Address 0x384 read value
    csrr x14, 0x384

    #Address 0x384 Write value 0xb9706069
    li x3, 0xb9706069
    csrw 0x384, x3

    #Address 0x384 read value
    csrr x14, 0x384

    #Unmapped address 0x52e testing: random write/read operations
    #Address 0x52e Write value 0xc516fd3f
    li x3, 0xc516fd3f
    csrw 0x52e, x3

    #Address 0x52e read value
    csrr x14, 0x52e

    #Address 0x52e read value
    csrr x14, 0x52e

    #Address 0x52e read value
    csrr x14, 0x52e

    #Unmapped address 0xd74 testing: random write/read operations
    #Address 0xd74 read value
    csrr x14, 0xd74

    #Address 0xd74 read value
    csrr x14, 0xd74

    #Address 0xd74 Write value 0xdfddc6d6
    li x3, 0xdfddc6d6
    csrw 0xd74, x3

    #Address 0xd74 read value
    csrr x14, 0xd74

    #Unmapped address 0xf68 testing: random write/read operations
    #Address 0xf68 read value
    csrr x14, 0xf68

    #Address 0xf68 read value
    csrr x14, 0xf68

    #Unmapped address 0xd70 testing: random write/read operations
    #Address 0xd70 read value
    csrr x14, 0xd70

    #Address 0xd70 Write value 0xad5b292b
    li x3, 0xad5b292b
    csrw 0xd70, x3

    #Address 0xd70 read value
    csrr x14, 0xd70

    #Address 0xd70 read value
    csrr x14, 0xd70

    #Unmapped address 0x3c7 testing: random write/read operations
    #Address 0x3c7 read value
    csrr x14, 0x3c7

    #Unmapped address 0x929 testing: random write/read operations
    #Address 0x929 read value
    csrr x14, 0x929

    #Address 0x929 read value
    csrr x14, 0x929

    #Address 0x929 Write value 0x478d5463
    li x3, 0x478d5463
    csrw 0x929, x3

    #Unmapped address 0x6a8 testing: random write/read operations
    #Address 0x6a8 Write value 0xe4015a7b
    li x3, 0xe4015a7b
    csrw 0x6a8, x3

    #Address 0x6a8 read value
    csrr x14, 0x6a8

    #Address 0x6a8 read value
    csrr x14, 0x6a8

    #Address 0x6a8 Write value 0x86b2a555
    li x3, 0x86b2a555
    csrw 0x6a8, x3

    #Unmapped address 0xc4a testing: random write/read operations
    #Address 0xc4a Write value 0xa22265e0
    li x3, 0xa22265e0
    csrw 0xc4a, x3

    #Unmapped address 0x2a2 testing: random write/read operations
    #Address 0x2a2 Write value 0xdad50552
    li x3, 0xdad50552
    csrw 0x2a2, x3

    #Address 0x2a2 Write value 0x475b928b
    li x3, 0x475b928b
    csrw 0x2a2, x3

    #Unmapped address 0x461 testing: random write/read operations
    #Address 0x461 read value
    csrr x14, 0x461

    #Address 0x461 read value
    csrr x14, 0x461

    #Unmapped address 0xddf testing: random write/read operations
    #Address 0xddf Write value 0x2f62c758
    li x3, 0x2f62c758
    csrw 0xddf, x3

    #Address 0xddf read value
    csrr x14, 0xddf

    #Address 0xddf Write value 0x9530e88f
    li x3, 0x9530e88f
    csrw 0xddf, x3

    #Unmapped address 0x1d3 testing: random write/read operations
    #Address 0x1d3 read value
    csrr x14, 0x1d3

    #Address 0x1d3 Write value 0x31ed573f
    li x3, 0x31ed573f
    csrw 0x1d3, x3

    #Unmapped address 0x7e4 testing: random write/read operations
    #Address 0x7e4 Write value 0x4270b109
    li x3, 0x4270b109
    csrw 0x7e4, x3

    #Address 0x7e4 read value
    csrr x14, 0x7e4

    #Unmapped address 0xd01 testing: random write/read operations
    #Address 0xd01 read value
    csrr x14, 0xd01

    #Address 0xd01 read value
    csrr x14, 0xd01

    #Address 0xd01 read value
    csrr x14, 0xd01

    #Address 0xd01 Write value 0x898f3b51
    li x3, 0x898f3b51
    csrw 0xd01, x3

    #Unmapped address 0x7a8 testing: random write/read operations
    #Address 0x7a8 Write value 0x5381da2d
    li x3, 0x5381da2d
    csrw 0x7a8, x3

    #Address 0x7a8 Write value 0xd7bea482
    li x3, 0xd7bea482
    csrw 0x7a8, x3

    #Unmapped address 0xb3 testing: random write/read operations
    #Address 0xb3 Write value 0xd21ed7ad
    li x3, 0xd21ed7ad
    csrw 0xb3, x3

    #Unmapped address 0x24b testing: random write/read operations
    #Address 0x24b Write value 0x7539d174
    li x3, 0x7539d174
    csrw 0x24b, x3

    #Address 0x24b Write value 0xb4e59d65
    li x3, 0xb4e59d65
    csrw 0x24b, x3

    #Address 0x24b read value
    csrr x14, 0x24b

    #Address 0x24b read value
    csrr x14, 0x24b

    #Address 0x24b read value
    csrr x14, 0x24b

    #Unmapped address 0x694 testing: random write/read operations
    #Address 0x694 read value
    csrr x14, 0x694

    #Address 0x694 Write value 0x1199fabf
    li x3, 0x1199fabf
    csrw 0x694, x3

    #Address 0x694 Write value 0x8aa9db6f
    li x3, 0x8aa9db6f
    csrw 0x694, x3

    #Address 0x694 Write value 0xcd0bcb7d
    li x3, 0xcd0bcb7d
    csrw 0x694, x3

    #Unmapped address 0x650 testing: random write/read operations
    #Address 0x650 Write value 0x7e86bb17
    li x3, 0x7e86bb17
    csrw 0x650, x3

    #Address 0x650 Write value 0xf3d426e1
    li x3, 0xf3d426e1
    csrw 0x650, x3

    #Address 0x650 read value
    csrr x14, 0x650

    #Address 0x650 read value
    csrr x14, 0x650

    #Unmapped address 0x2a6 testing: random write/read operations
    #Address 0x2a6 Write value 0xfbce380b
    li x3, 0xfbce380b
    csrw 0x2a6, x3

    #Address 0x2a6 Write value 0x4ae7fda2
    li x3, 0x4ae7fda2
    csrw 0x2a6, x3

    #Address 0x2a6 read value
    csrr x14, 0x2a6

    #Mapped address 0xb1f (mhpmcounter31) testing: random write/read operations
    #Address 0xb1f read value
    csrr x14, 0xb1f

    #Address 0xb1f Write value 0x769f5d00
    li x3, 0x769f5d00
    csrw 0xb1f, x3

    #Address 0xb1f Write value 0xb2eb6178
    li x3, 0xb2eb6178
    csrw 0xb1f, x3

    #Address 0xb1f read value
    csrr x14, 0xb1f

    #Unmapped address 0x771 testing: random write/read operations
    #Address 0x771 Write value 0x29c981c8
    li x3, 0x29c981c8
    csrw 0x771, x3

    #Address 0x771 Write value 0xc74d8316
    li x3, 0xc74d8316
    csrw 0x771, x3

    #Address 0x771 read value
    csrr x14, 0x771

    #Address 0x771 read value
    csrr x14, 0x771

    #Address 0x771 Write value 0x36070ec7
    li x3, 0x36070ec7
    csrw 0x771, x3

    #Unmapped address 0xe10 testing: random write/read operations
    #Address 0xe10 read value
    csrr x14, 0xe10

    #Unmapped address 0xd1d testing: random write/read operations
    #Address 0xd1d Write value 0x7dd6243f
    li x3, 0x7dd6243f
    csrw 0xd1d, x3

    #Address 0xd1d read value
    csrr x14, 0xd1d

    #Unmapped address 0xd0 testing: random write/read operations
    #Address 0xd0 Write value 0x14f1b3cf
    li x3, 0x14f1b3cf
    csrw 0xd0, x3

    #Unmapped address 0xd9 testing: random write/read operations
    #Address 0xd9 read value
    csrr x14, 0xd9

    #Address 0xd9 Write value 0xe75600e0
    li x3, 0xe75600e0
    csrw 0xd9, x3

    #Address 0xd9 Write value 0x6fd15d3f
    li x3, 0x6fd15d3f
    csrw 0xd9, x3

    #Unmapped address 0x136 testing: random write/read operations
    #Address 0x136 read value
    csrr x14, 0x136

    #Address 0x136 Write value 0xc8b7bd1
    li x3, 0xc8b7bd1
    csrw 0x136, x3

    #Address 0x136 read value
    csrr x14, 0x136

    #Address 0x136 Write value 0x7460d722
    li x3, 0x7460d722
    csrw 0x136, x3

    #Unmapped address 0xeb7 testing: random write/read operations
    #Address 0xeb7 Write value 0x507c2f6c
    li x3, 0x507c2f6c
    csrw 0xeb7, x3

    #Unmapped address 0x645 testing: random write/read operations
    #Address 0x645 read value
    csrr x14, 0x645

    #Unmapped address 0xc03 testing: random write/read operations
    #Address 0xc03 Write value 0x1ca53a90
    li x3, 0x1ca53a90
    csrw 0xc03, x3

    #Address 0xc03 read value
    csrr x14, 0xc03

    #Address 0xc03 read value
    csrr x14, 0xc03

    #Address 0xc03 read value
    csrr x14, 0xc03

    #Unmapped address 0xddd testing: random write/read operations
    #Address 0xddd Write value 0x6010ef89
    li x3, 0x6010ef89
    csrw 0xddd, x3

    #Address 0xddd Write value 0xef5186a6
    li x3, 0xef5186a6
    csrw 0xddd, x3

    #Address 0xddd read value
    csrr x14, 0xddd

    #Address 0xddd read value
    csrr x14, 0xddd

    #Address 0xddd read value
    csrr x14, 0xddd

    #Unmapped address 0xfc9 testing: random write/read operations
    #Address 0xfc9 read value
    csrr x14, 0xfc9

    #Address 0xfc9 Write value 0xa412b06c
    li x3, 0xa412b06c
    csrw 0xfc9, x3

    #Address 0xfc9 read value
    csrr x14, 0xfc9

    #Address 0xfc9 read value
    csrr x14, 0xfc9

    #Address 0xfc9 read value
    csrr x14, 0xfc9

    #Unmapped address 0x4aa testing: random write/read operations
    #Address 0x4aa read value
    csrr x14, 0x4aa

    #Address 0x4aa Write value 0xb7349f28
    li x3, 0xb7349f28
    csrw 0x4aa, x3

    #Address 0x4aa read value
    csrr x14, 0x4aa

    #Address 0x4aa read value
    csrr x14, 0x4aa

    #Address 0x4aa read value
    csrr x14, 0x4aa

    #Unmapped address 0xc9 testing: random write/read operations
    #Address 0xc9 Write value 0x41108502
    li x3, 0x41108502
    csrw 0xc9, x3

    #Address 0xc9 Write value 0x78d4cff8
    li x3, 0x78d4cff8
    csrw 0xc9, x3

    #Address 0xc9 Write value 0x978c046e
    li x3, 0x978c046e
    csrw 0xc9, x3

    #Address 0xc9 Write value 0xa26b439d
    li x3, 0xa26b439d
    csrw 0xc9, x3

    #Unmapped address 0x24c testing: random write/read operations
    #Address 0x24c read value
    csrr x14, 0x24c

    #Address 0x24c Write value 0x23037cea
    li x3, 0x23037cea
    csrw 0x24c, x3

    #Mapped address 0x344 (mip) testing: random write/read operations
    #Address 0x344 Write value 0x11056d3c
    li x3, 0x11056d3c
    csrw 0x344, x3

    #Address 0x344 Write value 0xb990bc2a
    li x3, 0xb990bc2a
    csrw 0x344, x3

    #Address 0x344 Write value 0x702c1797
    li x3, 0x702c1797
    csrw 0x344, x3

    #Unmapped address 0xfde testing: random write/read operations
    #Address 0xfde read value
    csrr x14, 0xfde

    #Address 0xfde read value
    csrr x14, 0xfde

    #Address 0xfde Write value 0x4fd72eef
    li x3, 0x4fd72eef
    csrw 0xfde, x3

    #Unmapped address 0xc27 testing: random write/read operations
    #Address 0xc27 read value
    csrr x14, 0xc27

    #Address 0xc27 read value
    csrr x14, 0xc27

    #Address 0xc27 read value
    csrr x14, 0xc27

    #Address 0xc27 Write value 0xbb9ab507
    li x3, 0xbb9ab507
    csrw 0xc27, x3

    #Unmapped address 0x6e5 testing: random write/read operations
    #Address 0x6e5 Write value 0x63ea1ce4
    li x3, 0x63ea1ce4
    csrw 0x6e5, x3

    #Address 0x6e5 Write value 0xd76f81b0
    li x3, 0xd76f81b0
    csrw 0x6e5, x3

    #Unmapped address 0x914 testing: random write/read operations
    #Address 0x914 read value
    csrr x14, 0x914

    #Address 0x914 Write value 0x675b4490
    li x3, 0x675b4490
    csrw 0x914, x3

    #Address 0x914 Write value 0xa65f3288
    li x3, 0xa65f3288
    csrw 0x914, x3

    #Address 0x914 read value
    csrr x14, 0x914

    #Unmapped address 0x44e testing: random write/read operations
    #Address 0x44e read value
    csrr x14, 0x44e

    #Address 0x44e Write value 0xc69c55b9
    li x3, 0xc69c55b9
    csrw 0x44e, x3

    #Address 0x44e Write value 0x3c733b50
    li x3, 0x3c733b50
    csrw 0x44e, x3

    #Unmapped address 0x56e testing: random write/read operations
    #Address 0x56e Write value 0x96ce3758
    li x3, 0x96ce3758
    csrw 0x56e, x3

    #Address 0x56e Write value 0x71235eee
    li x3, 0x71235eee
    csrw 0x56e, x3

    #Unmapped address 0xf55 testing: random write/read operations
    #Address 0xf55 read value
    csrr x14, 0xf55

    #Address 0xf55 read value
    csrr x14, 0xf55

    #Unmapped address 0x939 testing: random write/read operations
    #Address 0x939 Write value 0x728ef3f0
    li x3, 0x728ef3f0
    csrw 0x939, x3

    #Address 0x939 Write value 0xe23ec6
    li x3, 0xe23ec6
    csrw 0x939, x3

    #Address 0x939 read value
    csrr x14, 0x939

    #Address 0x939 read value
    csrr x14, 0x939

    #Unmapped address 0x25a testing: random write/read operations
    #Address 0x25a Write value 0x49505752
    li x3, 0x49505752
    csrw 0x25a, x3

    #Address 0x25a Write value 0xfb6142ed
    li x3, 0xfb6142ed
    csrw 0x25a, x3

    #Address 0x25a Write value 0xa0a3cb0d
    li x3, 0xa0a3cb0d
    csrw 0x25a, x3

    #Address 0x25a read value
    csrr x14, 0x25a

    #Unmapped address 0x2fa testing: random write/read operations
    #Address 0x2fa Write value 0xdde59f59
    li x3, 0xdde59f59
    csrw 0x2fa, x3

    #Address 0x2fa Write value 0x24838c80
    li x3, 0x24838c80
    csrw 0x2fa, x3

    #Unmapped address 0xfcc testing: random write/read operations
    #Address 0xfcc Write value 0x27cf54fd
    li x3, 0x27cf54fd
    csrw 0xfcc, x3

    #Address 0xfcc read value
    csrr x14, 0xfcc

    #Address 0xfcc read value
    csrr x14, 0xfcc

    #Unmapped address 0xaf4 testing: random write/read operations
    #Address 0xaf4 Write value 0x3363be3f
    li x3, 0x3363be3f
    csrw 0xaf4, x3

    #Address 0xaf4 Write value 0x3e00487e
    li x3, 0x3e00487e
    csrw 0xaf4, x3

    #Unmapped address 0x34a testing: random write/read operations
    #Address 0x34a read value
    csrr x14, 0x34a

    #Address 0x34a Write value 0x39f9e9d
    li x3, 0x39f9e9d
    csrw 0x34a, x3

    #Address 0x34a Write value 0x7b70b346
    li x3, 0x7b70b346
    csrw 0x34a, x3

    #Address 0x34a read value
    csrr x14, 0x34a

    #Address 0x34a read value
    csrr x14, 0x34a

    #Unmapped address 0x52b testing: random write/read operations
    #Address 0x52b Write value 0x105ab840
    li x3, 0x105ab840
    csrw 0x52b, x3

    #Address 0x52b Write value 0x7ac1d345
    li x3, 0x7ac1d345
    csrw 0x52b, x3

    #Address 0x52b read value
    csrr x14, 0x52b

    #Unmapped address 0x3cb testing: random write/read operations
    #Address 0x3cb Write value 0x8cdd1278
    li x3, 0x8cdd1278
    csrw 0x3cb, x3

    #Address 0x3cb read value
    csrr x14, 0x3cb

    #Address 0x3cb read value
    csrr x14, 0x3cb

    #Unmapped address 0x97 testing: random write/read operations
    #Address 0x97 Write value 0x222d8f5d
    li x3, 0x222d8f5d
    csrw 0x97, x3

    #Address 0x97 Write value 0xe676a67c
    li x3, 0xe676a67c
    csrw 0x97, x3

    #Address 0x97 Write value 0x10750f45
    li x3, 0x10750f45
    csrw 0x97, x3

    #Address 0x97 Write value 0x19797168
    li x3, 0x19797168
    csrw 0x97, x3

    #Unmapped address 0xd5b testing: random write/read operations
    #Address 0xd5b Write value 0x9960929
    li x3, 0x9960929
    csrw 0xd5b, x3

    #Unmapped address 0x86d testing: random write/read operations
    #Address 0x86d read value
    csrr x14, 0x86d

    #Address 0x86d Write value 0xdd9399f9
    li x3, 0xdd9399f9
    csrw 0x86d, x3

    #Address 0x86d read value
    csrr x14, 0x86d

    #Unmapped address 0x4a6 testing: random write/read operations
    #Address 0x4a6 Write value 0xa92e2e42
    li x3, 0xa92e2e42
    csrw 0x4a6, x3

    #Address 0x4a6 read value
    csrr x14, 0x4a6

    #Unmapped address 0x744 testing: random write/read operations
    #Address 0x744 read value
    csrr x14, 0x744

    #Unmapped address 0xc6b testing: random write/read operations
    #Address 0xc6b read value
    csrr x14, 0xc6b

    #Address 0xc6b read value
    csrr x14, 0xc6b

    #Unmapped address 0xa63 testing: random write/read operations
    #Address 0xa63 Write value 0x79b95d08
    li x3, 0x79b95d08
    csrw 0xa63, x3

    #Address 0xa63 read value
    csrr x14, 0xa63

    #Address 0xa63 read value
    csrr x14, 0xa63

    #Address 0xa63 read value
    csrr x14, 0xa63

    #Unmapped address 0xa4f testing: random write/read operations
    #Address 0xa4f read value
    csrr x14, 0xa4f

    #Address 0xa4f read value
    csrr x14, 0xa4f

    #Address 0xa4f read value
    csrr x14, 0xa4f

    #Unmapped address 0xc69 testing: random write/read operations
    #Address 0xc69 read value
    csrr x14, 0xc69

    #Address 0xc69 read value
    csrr x14, 0xc69

    #Address 0xc69 Write value 0x716c84d6
    li x3, 0x716c84d6
    csrw 0xc69, x3

    #Unmapped address 0x787 testing: random write/read operations
    #Address 0x787 Write value 0x841cb304
    li x3, 0x841cb304
    csrw 0x787, x3

    #Address 0x787 read value
    csrr x14, 0x787

    #Address 0x787 read value
    csrr x14, 0x787

    #Address 0x787 read value
    csrr x14, 0x787

    #Unmapped address 0x56a testing: random write/read operations
    #Address 0x56a read value
    csrr x14, 0x56a

    #Address 0x56a read value
    csrr x14, 0x56a

    #Unmapped address 0xcfe testing: random write/read operations
    #Address 0xcfe Write value 0xeb4593ce
    li x3, 0xeb4593ce
    csrw 0xcfe, x3

    #Address 0xcfe Write value 0x1fef285f
    li x3, 0x1fef285f
    csrw 0xcfe, x3

    #Address 0xcfe read value
    csrr x14, 0xcfe

    #Address 0xcfe Write value 0x785ab7c6
    li x3, 0x785ab7c6
    csrw 0xcfe, x3

    #Address 0xcfe Write value 0x4e9e6c46
    li x3, 0x4e9e6c46
    csrw 0xcfe, x3

    #Unmapped address 0xda0 testing: random write/read operations
    #Address 0xda0 Write value 0xff6c609
    li x3, 0xff6c609
    csrw 0xda0, x3

    #Address 0xda0 read value
    csrr x14, 0xda0

    #Address 0xda0 Write value 0xc8927a0c
    li x3, 0xc8927a0c
    csrw 0xda0, x3

    #Unmapped address 0xdc8 testing: random write/read operations
    #Address 0xdc8 read value
    csrr x14, 0xdc8

    #Unmapped address 0xea6 testing: random write/read operations
    #Address 0xea6 read value
    csrr x14, 0xea6

    #Address 0xea6 Write value 0x90d9a799
    li x3, 0x90d9a799
    csrw 0xea6, x3

    #Address 0xea6 Write value 0x3a7b40f3
    li x3, 0x3a7b40f3
    csrw 0xea6, x3

    #Unmapped address 0xc32 testing: random write/read operations
    #Address 0xc32 read value
    csrr x14, 0xc32

    #Unmapped address 0x68f testing: random write/read operations
    #Address 0x68f read value
    csrr x14, 0x68f

    #Address 0x68f read value
    csrr x14, 0x68f

    #Address 0x68f read value
    csrr x14, 0x68f

    #Address 0x68f Write value 0xae9806aa
    li x3, 0xae9806aa
    csrw 0x68f, x3

    #Address 0x68f read value
    csrr x14, 0x68f

    #Unmapped address 0x249 testing: random write/read operations
    #Address 0x249 read value
    csrr x14, 0x249

    #Address 0x249 Write value 0x4c91e942
    li x3, 0x4c91e942
    csrw 0x249, x3

    #Unmapped address 0x450 testing: random write/read operations
    #Address 0x450 Write value 0x43844be4
    li x3, 0x43844be4
    csrw 0x450, x3

    #Unmapped address 0x5de testing: random write/read operations
    #Address 0x5de read value
    csrr x14, 0x5de

    #Unmapped address 0x751 testing: random write/read operations
    #Address 0x751 read value
    csrr x14, 0x751

    #Address 0x751 read value
    csrr x14, 0x751

    #Address 0x751 read value
    csrr x14, 0x751

    #Address 0x751 Write value 0x4a38a4d6
    li x3, 0x4a38a4d6
    csrw 0x751, x3

    #Address 0x751 read value
    csrr x14, 0x751

    #Unmapped address 0xcb9 testing: random write/read operations
    #Address 0xcb9 Write value 0x493e8ef4
    li x3, 0x493e8ef4
    csrw 0xcb9, x3

    #Address 0xcb9 read value
    csrr x14, 0xcb9

    #Unmapped address 0xf28 testing: random write/read operations
    #Address 0xf28 read value
    csrr x14, 0xf28

    #Address 0xf28 read value
    csrr x14, 0xf28

    #Unmapped address 0x1c2 testing: random write/read operations
    #Address 0x1c2 read value
    csrr x14, 0x1c2

    #Address 0x1c2 read value
    csrr x14, 0x1c2

    #Address 0x1c2 read value
    csrr x14, 0x1c2

    #Address 0x1c2 Write value 0x4d75500f
    li x3, 0x4d75500f
    csrw 0x1c2, x3

    #Address 0x1c2 read value
    csrr x14, 0x1c2

    #Unmapped address 0x8cc testing: random write/read operations
    #Address 0x8cc read value
    csrr x14, 0x8cc

    #Unmapped address 0x95 testing: random write/read operations
    #Address 0x95 read value
    csrr x14, 0x95

    #Unmapped address 0xb38 testing: random write/read operations
    #Address 0xb38 Write value 0xf0519f37
    li x3, 0xf0519f37
    csrw 0xb38, x3

    #Address 0xb38 Write value 0x6bf024f0
    li x3, 0x6bf024f0
    csrw 0xb38, x3

    #Unmapped address 0xdf testing: random write/read operations
    #Address 0xdf Write value 0x764bf11f
    li x3, 0x764bf11f
    csrw 0xdf, x3

    #Unmapped address 0xaab testing: random write/read operations
    #Address 0xaab Write value 0xd67ac45d
    li x3, 0xd67ac45d
    csrw 0xaab, x3

    #Address 0xaab Write value 0x41db1a5d
    li x3, 0x41db1a5d
    csrw 0xaab, x3

    #Address 0xaab Write value 0xbabdc07b
    li x3, 0xbabdc07b
    csrw 0xaab, x3

    #Unmapped address 0x55e testing: random write/read operations
    #Address 0x55e Write value 0x3fbfaea5
    li x3, 0x3fbfaea5
    csrw 0x55e, x3

    #Address 0x55e Write value 0x5cbbcaaf
    li x3, 0x5cbbcaaf
    csrw 0x55e, x3

    #Unmapped address 0x445 testing: random write/read operations
    #Address 0x445 Write value 0x68089e6c
    li x3, 0x68089e6c
    csrw 0x445, x3

    #Address 0x445 read value
    csrr x14, 0x445

    #Address 0x445 read value
    csrr x14, 0x445

    #Address 0x445 Write value 0xd7de951c
    li x3, 0xd7de951c
    csrw 0x445, x3

    #Address 0x445 Write value 0x55e227a6
    li x3, 0x55e227a6
    csrw 0x445, x3

    #Unmapped address 0x5cc testing: random write/read operations
    #Address 0x5cc read value
    csrr x14, 0x5cc

    #Unmapped address 0xaf6 testing: random write/read operations
    #Address 0xaf6 Write value 0xaf83b13a
    li x3, 0xaf83b13a
    csrw 0xaf6, x3

    #Address 0xaf6 read value
    csrr x14, 0xaf6

    #Unmapped address 0x2e0 testing: random write/read operations
    #Address 0x2e0 read value
    csrr x14, 0x2e0

    #Address 0x2e0 read value
    csrr x14, 0x2e0

    #Address 0x2e0 Write value 0x2cf23792
    li x3, 0x2cf23792
    csrw 0x2e0, x3

    #Unmapped address 0x1db testing: random write/read operations
    #Address 0x1db Write value 0x6e15e9bf
    li x3, 0x6e15e9bf
    csrw 0x1db, x3

    #Unmapped address 0xed4 testing: random write/read operations
    #Address 0xed4 Write value 0x476d96e3
    li x3, 0x476d96e3
    csrw 0xed4, x3

    #Unmapped address 0xfcd testing: random write/read operations
    #Address 0xfcd read value
    csrr x14, 0xfcd

    #Unmapped address 0xe9b testing: random write/read operations
    #Address 0xe9b Write value 0x5eb4805c
    li x3, 0x5eb4805c
    csrw 0xe9b, x3

    #Address 0xe9b read value
    csrr x14, 0xe9b

    #Address 0xe9b read value
    csrr x14, 0xe9b

    #Address 0xe9b Write value 0xd7c78aa0
    li x3, 0xd7c78aa0
    csrw 0xe9b, x3

    #Mapped address 0x33b (mhpmevent27) testing: random write/read operations
    #Address 0x33b read value
    csrr x14, 0x33b

    #Address 0x33b Write value 0xc5c553e4
    li x3, 0xc5c553e4
    csrw 0x33b, x3

    #Unmapped address 0xbe6 testing: random write/read operations
    #Address 0xbe6 read value
    csrr x14, 0xbe6

    #Address 0xbe6 Write value 0x4677d5d2
    li x3, 0x4677d5d2
    csrw 0xbe6, x3

    #Address 0xbe6 read value
    csrr x14, 0xbe6

    #Unmapped address 0xa04 testing: random write/read operations
    #Address 0xa04 read value
    csrr x14, 0xa04

    #Unmapped address 0x106 testing: random write/read operations
    #Address 0x106 Write value 0x1d6f7ff1
    li x3, 0x1d6f7ff1
    csrw 0x106, x3

    #Unmapped address 0x5cb testing: random write/read operations
    #Address 0x5cb read value
    csrr x14, 0x5cb

    #Address 0x5cb read value
    csrr x14, 0x5cb

    #Unmapped address 0x669 testing: random write/read operations
    #Address 0x669 Write value 0xf0f22ad0
    li x3, 0xf0f22ad0
    csrw 0x669, x3

    #Address 0x669 read value
    csrr x14, 0x669

    #Address 0x669 read value
    csrr x14, 0x669

    #Unmapped address 0x922 testing: random write/read operations
    #Address 0x922 read value
    csrr x14, 0x922

    #Address 0x922 Write value 0x2421cb6f
    li x3, 0x2421cb6f
    csrw 0x922, x3

    #Unmapped address 0x827 testing: random write/read operations
    #Address 0x827 Write value 0xd389f80a
    li x3, 0xd389f80a
    csrw 0x827, x3

    #Address 0x827 Write value 0xe0097e56
    li x3, 0xe0097e56
    csrw 0x827, x3

    #Address 0x827 Write value 0x3cc5f342
    li x3, 0x3cc5f342
    csrw 0x827, x3

    #Unmapped address 0xf2c testing: random write/read operations
    #Address 0xf2c read value
    csrr x14, 0xf2c

    #Address 0xf2c Write value 0xd33792b2
    li x3, 0xd33792b2
    csrw 0xf2c, x3

    #Address 0xf2c Write value 0x6efff731
    li x3, 0x6efff731
    csrw 0xf2c, x3

    #Address 0xf2c read value
    csrr x14, 0xf2c

    #Unmapped address 0xc39 testing: random write/read operations
    #Address 0xc39 read value
    csrr x14, 0xc39

    #Unmapped address 0x864 testing: random write/read operations
    #Address 0x864 read value
    csrr x14, 0x864

    #Unmapped address 0xef0 testing: random write/read operations
    #Address 0xef0 read value
    csrr x14, 0xef0

    #Address 0xef0 Write value 0x91f728ff
    li x3, 0x91f728ff
    csrw 0xef0, x3

    #Unmapped address 0x13d testing: random write/read operations
    #Address 0x13d read value
    csrr x14, 0x13d

    #Address 0x13d read value
    csrr x14, 0x13d

    #Address 0x13d read value
    csrr x14, 0x13d

    #Unmapped address 0x1cc testing: random write/read operations
    #Address 0x1cc Write value 0x5d89c733
    li x3, 0x5d89c733
    csrw 0x1cc, x3

    #Address 0x1cc read value
    csrr x14, 0x1cc

    #Address 0x1cc read value
    csrr x14, 0x1cc

    #Unmapped address 0x36 testing: random write/read operations
    #Address 0x36 Write value 0xc4134d55
    li x3, 0xc4134d55
    csrw 0x36, x3

    #Address 0x36 read value
    csrr x14, 0x36

    #Address 0x36 read value
    csrr x14, 0x36

    #Unmapped address 0xd33 testing: random write/read operations
    #Address 0xd33 read value
    csrr x14, 0xd33

    #Address 0xd33 Write value 0x8916cd07
    li x3, 0x8916cd07
    csrw 0xd33, x3

    #Address 0xd33 read value
    csrr x14, 0xd33

    #Address 0xd33 read value
    csrr x14, 0xd33

    #Address 0xd33 read value
    csrr x14, 0xd33

    #Unmapped address 0xba1 testing: random write/read operations
    #Address 0xba1 read value
    csrr x14, 0xba1

    #Address 0xba1 read value
    csrr x14, 0xba1

    #Address 0xba1 read value
    csrr x14, 0xba1

    #Address 0xba1 Write value 0x4a3a4ec6
    li x3, 0x4a3a4ec6
    csrw 0xba1, x3

    #Address 0xba1 read value
    csrr x14, 0xba1

    #Mapped address 0x33a (mhpmevent26) testing: random write/read operations
    #Address 0x33a Write value 0xaf2180c9
    li x3, 0xaf2180c9
    csrw 0x33a, x3

    #Address 0x33a read value
    csrr x14, 0x33a

    #Address 0x33a read value
    csrr x14, 0x33a

    #Address 0x33a read value
    csrr x14, 0x33a

    #Unmapped address 0xb40 testing: random write/read operations
    #Address 0xb40 read value
    csrr x14, 0xb40

    #Address 0xb40 read value
    csrr x14, 0xb40

    #Address 0xb40 Write value 0xae074d8f
    li x3, 0xae074d8f
    csrw 0xb40, x3

    #Address 0xb40 read value
    csrr x14, 0xb40

    #Address 0xb40 Write value 0x215776b7
    li x3, 0x215776b7
    csrw 0xb40, x3

    #Unmapped address 0xe20 testing: random write/read operations
    #Address 0xe20 read value
    csrr x14, 0xe20

    #Address 0xe20 Write value 0x58455b9
    li x3, 0x58455b9
    csrw 0xe20, x3

    #Address 0xe20 Write value 0x77b51eb4
    li x3, 0x77b51eb4
    csrw 0xe20, x3

    #Unmapped address 0xdbd testing: random write/read operations
    #Address 0xdbd Write value 0x2b102cbd
    li x3, 0x2b102cbd
    csrw 0xdbd, x3

    #Address 0xdbd read value
    csrr x14, 0xdbd

    #Address 0xdbd Write value 0xfd8aba11
    li x3, 0xfd8aba11
    csrw 0xdbd, x3

    #Address 0xdbd read value
    csrr x14, 0xdbd

    #Address 0xdbd Write value 0x84cc63d3
    li x3, 0x84cc63d3
    csrw 0xdbd, x3

    #Unmapped address 0xcd8 testing: random write/read operations
    #Address 0xcd8 read value
    csrr x14, 0xcd8

    #Address 0xcd8 Write value 0xfdcadf1d
    li x3, 0xfdcadf1d
    csrw 0xcd8, x3

    #Address 0xcd8 Write value 0xcef5f31d
    li x3, 0xcef5f31d
    csrw 0xcd8, x3

    #Address 0xcd8 Write value 0xb16df981
    li x3, 0xb16df981
    csrw 0xcd8, x3

    #Unmapped address 0xe58 testing: random write/read operations
    #Address 0xe58 Write value 0xbb2d9954
    li x3, 0xbb2d9954
    csrw 0xe58, x3

    #Address 0xe58 Write value 0x95481be8
    li x3, 0x95481be8
    csrw 0xe58, x3

    #Address 0xe58 read value
    csrr x14, 0xe58

    #Unmapped address 0xe2e testing: random write/read operations
    #Address 0xe2e read value
    csrr x14, 0xe2e

    #Address 0xe2e Write value 0xd7d12dbc
    li x3, 0xd7d12dbc
    csrw 0xe2e, x3

    #Address 0xe2e Write value 0x6b7d1dcf
    li x3, 0x6b7d1dcf
    csrw 0xe2e, x3

    #Address 0xe2e Write value 0x9f1696f
    li x3, 0x9f1696f
    csrw 0xe2e, x3

    #Address 0xe2e read value
    csrr x14, 0xe2e

    #Unmapped address 0x9cf testing: random write/read operations
    #Address 0x9cf read value
    csrr x14, 0x9cf

    #Address 0x9cf read value
    csrr x14, 0x9cf

    #Unmapped address 0x152 testing: random write/read operations
    #Address 0x152 Write value 0x1a505974
    li x3, 0x1a505974
    csrw 0x152, x3

    #Address 0x152 Write value 0xbf3cc0b3
    li x3, 0xbf3cc0b3
    csrw 0x152, x3

    #Address 0x152 read value
    csrr x14, 0x152

    #Address 0x152 read value
    csrr x14, 0x152

    #Address 0x152 read value
    csrr x14, 0x152

    #Unmapped address 0xc76 testing: random write/read operations
    #Address 0xc76 Write value 0x97a176e3
    li x3, 0x97a176e3
    csrw 0xc76, x3

    #Address 0xc76 read value
    csrr x14, 0xc76

    #Address 0xc76 Write value 0x488842c3
    li x3, 0x488842c3
    csrw 0xc76, x3

    #Unmapped address 0x245 testing: random write/read operations
    #Address 0x245 read value
    csrr x14, 0x245

    #Address 0x245 Write value 0xe782feb9
    li x3, 0xe782feb9
    csrw 0x245, x3

    #Address 0x245 Write value 0x3c9f9230
    li x3, 0x3c9f9230
    csrw 0x245, x3

    #Unmapped address 0x460 testing: random write/read operations
    #Address 0x460 read value
    csrr x14, 0x460

    #Address 0x460 read value
    csrr x14, 0x460

    #Unmapped address 0x9af testing: random write/read operations
    #Address 0x9af Write value 0x7bc1a468
    li x3, 0x7bc1a468
    csrw 0x9af, x3

    #Unmapped address 0x590 testing: random write/read operations
    #Address 0x590 read value
    csrr x14, 0x590

    #Address 0x590 read value
    csrr x14, 0x590

    #Address 0x590 read value
    csrr x14, 0x590

    #Unmapped address 0x7de testing: random write/read operations
    #Address 0x7de read value
    csrr x14, 0x7de

    #Address 0x7de Write value 0x5057d3f4
    li x3, 0x5057d3f4
    csrw 0x7de, x3

    #Address 0x7de read value
    csrr x14, 0x7de

    #Address 0x7de Write value 0xa64758e6
    li x3, 0xa64758e6
    csrw 0x7de, x3

    #Unmapped address 0x8f2 testing: random write/read operations
    #Address 0x8f2 read value
    csrr x14, 0x8f2

    #Address 0x8f2 Write value 0xab7129cc
    li x3, 0xab7129cc
    csrw 0x8f2, x3

    #Address 0x8f2 Write value 0xd5650b4
    li x3, 0xd5650b4
    csrw 0x8f2, x3

    #Address 0x8f2 Write value 0xd1b6d75e
    li x3, 0xd1b6d75e
    csrw 0x8f2, x3

    #Address 0x8f2 read value
    csrr x14, 0x8f2

    #Unmapped address 0x2b testing: random write/read operations
    #Address 0x2b read value
    csrr x14, 0x2b

    #Unmapped address 0xea2 testing: random write/read operations
    #Address 0xea2 Write value 0xf23a1bad
    li x3, 0xf23a1bad
    csrw 0xea2, x3

    #Address 0xea2 Write value 0xd95e69ef
    li x3, 0xd95e69ef
    csrw 0xea2, x3

    #Address 0xea2 read value
    csrr x14, 0xea2

    #Address 0xea2 Write value 0x66dbc24b
    li x3, 0x66dbc24b
    csrw 0xea2, x3

    #Unmapped address 0x276 testing: random write/read operations
    #Address 0x276 Write value 0x58a9c39b
    li x3, 0x58a9c39b
    csrw 0x276, x3

    #Address 0x276 read value
    csrr x14, 0x276

    #Address 0x276 Write value 0xe8eb4040
    li x3, 0xe8eb4040
    csrw 0x276, x3

    #Address 0x276 read value
    csrr x14, 0x276

    #Unmapped address 0xafe testing: random write/read operations
    #Address 0xafe read value
    csrr x14, 0xafe

    #Unmapped address 0xab6 testing: random write/read operations
    #Address 0xab6 read value
    csrr x14, 0xab6

    #Address 0xab6 read value
    csrr x14, 0xab6

    #Address 0xab6 Write value 0x8536b1a1
    li x3, 0x8536b1a1
    csrw 0xab6, x3

    #Address 0xab6 read value
    csrr x14, 0xab6

    #Address 0xab6 Write value 0xa50f4ac
    li x3, 0xa50f4ac
    csrw 0xab6, x3

    #Unmapped address 0x360 testing: random write/read operations
    #Address 0x360 Write value 0x6b227b13
    li x3, 0x6b227b13
    csrw 0x360, x3

    #Unmapped address 0x8b4 testing: random write/read operations
    #Address 0x8b4 read value
    csrr x14, 0x8b4

    #Address 0x8b4 Write value 0xa9c73a49
    li x3, 0xa9c73a49
    csrw 0x8b4, x3

    #Unmapped address 0xd4d testing: random write/read operations
    #Address 0xd4d read value
    csrr x14, 0xd4d

    #Address 0xd4d Write value 0x26e312df
    li x3, 0x26e312df
    csrw 0xd4d, x3

    #Unmapped address 0x1aa testing: random write/read operations
    #Address 0x1aa read value
    csrr x14, 0x1aa

    #Unmapped address 0x56f testing: random write/read operations
    #Address 0x56f Write value 0x1d20e70d
    li x3, 0x1d20e70d
    csrw 0x56f, x3

    #Address 0x56f read value
    csrr x14, 0x56f

    #Address 0x56f Write value 0xd70c0902
    li x3, 0xd70c0902
    csrw 0x56f, x3

    #Address 0x56f Write value 0x40d8b17e
    li x3, 0x40d8b17e
    csrw 0x56f, x3

    #Address 0x56f Write value 0xbb19339d
    li x3, 0xbb19339d
    csrw 0x56f, x3

    #Unmapped address 0x6ad testing: random write/read operations
    #Address 0x6ad read value
    csrr x14, 0x6ad

    #Address 0x6ad read value
    csrr x14, 0x6ad

    #Address 0x6ad read value
    csrr x14, 0x6ad

    #Address 0x6ad read value
    csrr x14, 0x6ad

    #Address 0x6ad Write value 0x460073f6
    li x3, 0x460073f6
    csrw 0x6ad, x3

    #Unmapped address 0xdab testing: random write/read operations
    #Address 0xdab Write value 0x56b98fdf
    li x3, 0x56b98fdf
    csrw 0xdab, x3

    #Unmapped address 0xcbc testing: random write/read operations
    #Address 0xcbc Write value 0xc6515698
    li x3, 0xc6515698
    csrw 0xcbc, x3

    #Address 0xcbc Write value 0x75a54b83
    li x3, 0x75a54b83
    csrw 0xcbc, x3

    #Address 0xcbc read value
    csrr x14, 0xcbc

    #Address 0xcbc read value
    csrr x14, 0xcbc

    #Unmapped address 0x1dd testing: random write/read operations
    #Address 0x1dd read value
    csrr x14, 0x1dd

    #Address 0x1dd Write value 0x7f4644a5
    li x3, 0x7f4644a5
    csrw 0x1dd, x3

    #Address 0x1dd read value
    csrr x14, 0x1dd

    #Address 0x1dd Write value 0x3fd90f82
    li x3, 0x3fd90f82
    csrw 0x1dd, x3

    #Address 0x1dd read value
    csrr x14, 0x1dd

    #Unmapped address 0x66a testing: random write/read operations
    #Address 0x66a Write value 0x4a9d55a0
    li x3, 0x4a9d55a0
    csrw 0x66a, x3

    #Unmapped address 0xe89 testing: random write/read operations
    #Address 0xe89 read value
    csrr x14, 0xe89

    #Address 0xe89 read value
    csrr x14, 0xe89

    #Unmapped address 0xba2 testing: random write/read operations
    #Address 0xba2 read value
    csrr x14, 0xba2

    #Address 0xba2 Write value 0xa4a6e3e9
    li x3, 0xa4a6e3e9
    csrw 0xba2, x3

    #Address 0xba2 read value
    csrr x14, 0xba2

    #Unmapped address 0x12e testing: random write/read operations
    #Address 0x12e read value
    csrr x14, 0x12e

    #Address 0x12e read value
    csrr x14, 0x12e

    #Address 0x12e read value
    csrr x14, 0x12e

    #Address 0x12e Write value 0xedc54925
    li x3, 0xedc54925
    csrw 0x12e, x3

    #Unmapped address 0xc64 testing: random write/read operations
    #Address 0xc64 read value
    csrr x14, 0xc64

    #Address 0xc64 Write value 0x1bbac6b8
    li x3, 0x1bbac6b8
    csrw 0xc64, x3

    #Address 0xc64 read value
    csrr x14, 0xc64

    #Address 0xc64 read value
    csrr x14, 0xc64

    #Address 0xc64 Write value 0xf9b4bf6b
    li x3, 0xf9b4bf6b
    csrw 0xc64, x3

    #Unmapped address 0xfbc testing: random write/read operations
    #Address 0xfbc read value
    csrr x14, 0xfbc

    #Address 0xfbc Write value 0xbba73754
    li x3, 0xbba73754
    csrw 0xfbc, x3

    #Address 0xfbc Write value 0xdeb07871
    li x3, 0xdeb07871
    csrw 0xfbc, x3

    #Address 0xfbc Write value 0x2cc87640
    li x3, 0x2cc87640
    csrw 0xfbc, x3

    #Address 0xfbc read value
    csrr x14, 0xfbc

    #Unmapped address 0x67a testing: random write/read operations
    #Address 0x67a Write value 0x1fc7ff1d
    li x3, 0x1fc7ff1d
    csrw 0x67a, x3

    #Address 0x67a read value
    csrr x14, 0x67a

    #Address 0x67a read value
    csrr x14, 0x67a

    #Address 0x67a Write value 0x2d43e482
    li x3, 0x2d43e482
    csrw 0x67a, x3

    #Address 0x67a read value
    csrr x14, 0x67a

    #Unmapped address 0x42 testing: random write/read operations
    #Address 0x42 read value
    csrr x14, 0x42

    #Address 0x42 Write value 0x26dea0da
    li x3, 0x26dea0da
    csrw 0x42, x3

    #Address 0x42 read value
    csrr x14, 0x42

    #Address 0x42 Write value 0xa05348f8
    li x3, 0xa05348f8
    csrw 0x42, x3

    #Address 0x42 Write value 0x961c47f9
    li x3, 0x961c47f9
    csrw 0x42, x3

    #Unmapped address 0xaf9 testing: random write/read operations
    #Address 0xaf9 read value
    csrr x14, 0xaf9

    #Address 0xaf9 read value
    csrr x14, 0xaf9

    #Address 0xaf9 Write value 0xd7eef617
    li x3, 0xd7eef617
    csrw 0xaf9, x3

    #Address 0xaf9 read value
    csrr x14, 0xaf9

    #Unmapped address 0xd22 testing: random write/read operations
    #Address 0xd22 Write value 0x13a01db0
    li x3, 0x13a01db0
    csrw 0xd22, x3

    #Address 0xd22 Write value 0x127d3d86
    li x3, 0x127d3d86
    csrw 0xd22, x3

    #Address 0xd22 read value
    csrr x14, 0xd22

    #Address 0xd22 Write value 0xdd8141b0
    li x3, 0xdd8141b0
    csrw 0xd22, x3

    #Unmapped address 0xfa testing: random write/read operations
    #Address 0xfa Write value 0xf55cafca
    li x3, 0xf55cafca
    csrw 0xfa, x3

    #Address 0xfa read value
    csrr x14, 0xfa

    #Address 0xfa Write value 0x809e66dc
    li x3, 0x809e66dc
    csrw 0xfa, x3

    #Unmapped address 0x9b2 testing: random write/read operations
    #Address 0x9b2 Write value 0xbbc3f695
    li x3, 0xbbc3f695
    csrw 0x9b2, x3

    #Address 0x9b2 Write value 0xea6f8e54
    li x3, 0xea6f8e54
    csrw 0x9b2, x3

    #Unmapped address 0x178 testing: random write/read operations
    #Address 0x178 read value
    csrr x14, 0x178

    #Address 0x178 Write value 0x24b1771b
    li x3, 0x24b1771b
    csrw 0x178, x3

    #Address 0x178 read value
    csrr x14, 0x178

    #Unmapped address 0x457 testing: random write/read operations
    #Address 0x457 read value
    csrr x14, 0x457

    #Unmapped address 0xd53 testing: random write/read operations
    #Address 0xd53 read value
    csrr x14, 0xd53

    #Address 0xd53 read value
    csrr x14, 0xd53

    #Address 0xd53 read value
    csrr x14, 0xd53

    #Address 0xd53 read value
    csrr x14, 0xd53

    #Unmapped address 0x96e testing: random write/read operations
    #Address 0x96e Write value 0x2f988381
    li x3, 0x2f988381
    csrw 0x96e, x3

    #Address 0x96e read value
    csrr x14, 0x96e

    #Address 0x96e Write value 0x7f3d0c8a
    li x3, 0x7f3d0c8a
    csrw 0x96e, x3

    #Unmapped address 0xf5 testing: random write/read operations
    #Address 0xf5 read value
    csrr x14, 0xf5

    #Address 0xf5 Write value 0xe492e9ba
    li x3, 0xe492e9ba
    csrw 0xf5, x3

    #Address 0xf5 read value
    csrr x14, 0xf5

    #Address 0xf5 read value
    csrr x14, 0xf5

    #Unmapped address 0x509 testing: random write/read operations
    #Address 0x509 read value
    csrr x14, 0x509

    #Address 0x509 Write value 0xb86f541b
    li x3, 0xb86f541b
    csrw 0x509, x3

    #Address 0x509 read value
    csrr x14, 0x509

    #Address 0x509 read value
    csrr x14, 0x509

    #Unmapped address 0x560 testing: random write/read operations
    #Address 0x560 Write value 0xd69d03a6
    li x3, 0xd69d03a6
    csrw 0x560, x3

    #Address 0x560 read value
    csrr x14, 0x560

    #Address 0x560 read value
    csrr x14, 0x560

    #Address 0x560 read value
    csrr x14, 0x560

    #Address 0x560 Write value 0x189b04be
    li x3, 0x189b04be
    csrw 0x560, x3

    #Unmapped address 0x71 testing: random write/read operations
    #Address 0x71 Write value 0x9af9d2ac
    li x3, 0x9af9d2ac
    csrw 0x71, x3

    #Address 0x71 read value
    csrr x14, 0x71

    #Address 0x71 read value
    csrr x14, 0x71

    #Address 0x71 read value
    csrr x14, 0x71

    #Unmapped address 0xe76 testing: random write/read operations
    #Address 0xe76 Write value 0x90414366
    li x3, 0x90414366
    csrw 0xe76, x3

    #Address 0xe76 read value
    csrr x14, 0xe76

    #Address 0xe76 Write value 0xe6ad7b23
    li x3, 0xe6ad7b23
    csrw 0xe76, x3

    #Address 0xe76 read value
    csrr x14, 0xe76

    #Address 0xe76 read value
    csrr x14, 0xe76

    #Unmapped address 0x422 testing: random write/read operations
    #Address 0x422 Write value 0xc47cbee3
    li x3, 0xc47cbee3
    csrw 0x422, x3

    #Address 0x422 Write value 0x57456fa9
    li x3, 0x57456fa9
    csrw 0x422, x3

    #Address 0x422 Write value 0xe1aab3ef
    li x3, 0xe1aab3ef
    csrw 0x422, x3

    #Address 0x422 read value
    csrr x14, 0x422

    #Unmapped address 0xc09 testing: random write/read operations
    #Address 0xc09 read value
    csrr x14, 0xc09

    #Address 0xc09 Write value 0xa4a54b02
    li x3, 0xa4a54b02
    csrw 0xc09, x3

    #Address 0xc09 read value
    csrr x14, 0xc09

    #Mapped address 0xb94 (mhpmcounterh20) testing: random write/read operations
    #Address 0xb94 read value
    csrr x14, 0xb94

    #Address 0xb94 read value
    csrr x14, 0xb94

    #Unmapped address 0x77f testing: random write/read operations
    #Address 0x77f read value
    csrr x14, 0x77f

    #Address 0x77f Write value 0xa94038a
    li x3, 0xa94038a
    csrw 0x77f, x3

    #Address 0x77f Write value 0x77d599ee
    li x3, 0x77d599ee
    csrw 0x77f, x3

    #Address 0x77f Write value 0xf0c4256d
    li x3, 0xf0c4256d
    csrw 0x77f, x3

    #Unmapped address 0xfc0 testing: random write/read operations
    #Address 0xfc0 read value
    csrr x14, 0xfc0

    #Address 0xfc0 Write value 0x59296101
    li x3, 0x59296101
    csrw 0xfc0, x3

    #Address 0xfc0 Write value 0xff006036
    li x3, 0xff006036
    csrw 0xfc0, x3

    #Address 0xfc0 read value
    csrr x14, 0xfc0

    #Address 0xfc0 read value
    csrr x14, 0xfc0

    #Unmapped address 0x66b testing: random write/read operations
    #Address 0x66b Write value 0xa150ca78
    li x3, 0xa150ca78
    csrw 0x66b, x3

    #Unmapped address 0xd5e testing: random write/read operations
    #Address 0xd5e Write value 0x3b15448f
    li x3, 0x3b15448f
    csrw 0xd5e, x3

    #Address 0xd5e Write value 0x4da1e1e
    li x3, 0x4da1e1e
    csrw 0xd5e, x3

    #Address 0xd5e Write value 0xc83370fd
    li x3, 0xc83370fd
    csrw 0xd5e, x3

    #Unmapped address 0xcd0 testing: random write/read operations
    #Address 0xcd0 Write value 0xe2ea0181
    li x3, 0xe2ea0181
    csrw 0xcd0, x3

    #Address 0xcd0 read value
    csrr x14, 0xcd0

    #Unmapped address 0xc50 testing: random write/read operations
    #Address 0xc50 read value
    csrr x14, 0xc50

    #Address 0xc50 read value
    csrr x14, 0xc50

    #Unmapped address 0x51e testing: random write/read operations
    #Address 0x51e read value
    csrr x14, 0x51e

    #Address 0x51e read value
    csrr x14, 0x51e

    #Address 0x51e read value
    csrr x14, 0x51e

    #Address 0x51e Write value 0x1d334d4
    li x3, 0x1d334d4
    csrw 0x51e, x3

    #Unmapped address 0x4f8 testing: random write/read operations
    #Address 0x4f8 Write value 0xb17e2118
    li x3, 0xb17e2118
    csrw 0x4f8, x3

    #Address 0x4f8 Write value 0x6709879
    li x3, 0x6709879
    csrw 0x4f8, x3

    #Address 0x4f8 Write value 0x6b3ee2f2
    li x3, 0x6b3ee2f2
    csrw 0x4f8, x3

    #Address 0x4f8 Write value 0xdebb94f2
    li x3, 0xdebb94f2
    csrw 0x4f8, x3

    #Unmapped address 0x591 testing: random write/read operations
    #Address 0x591 read value
    csrr x14, 0x591

    #Address 0x591 Write value 0x64df15e7
    li x3, 0x64df15e7
    csrw 0x591, x3

    #Address 0x591 read value
    csrr x14, 0x591

    #Address 0x591 Write value 0xa28dfe33
    li x3, 0xa28dfe33
    csrw 0x591, x3

    #Address 0x591 read value
    csrr x14, 0x591

    #Mapped address 0x3b5 (pmpaddr5) testing: random write/read operations
    #Address 0x3b5 Write value 0x7c209da6
    li x3, 0x7c209da6
    csrw 0x3b5, x3

    #Unmapped address 0xff testing: random write/read operations
    #Address 0xff read value
    csrr x14, 0xff

    #Address 0xff read value
    csrr x14, 0xff

    #Address 0xff read value
    csrr x14, 0xff

    #Address 0xff read value
    csrr x14, 0xff

    #Address 0xff read value
    csrr x14, 0xff

    #Unmapped address 0x9d7 testing: random write/read operations
    #Address 0x9d7 read value
    csrr x14, 0x9d7

    #Address 0x9d7 read value
    csrr x14, 0x9d7

    #Unmapped address 0x31a testing: random write/read operations
    #Address 0x31a Write value 0x5bf93a4
    li x3, 0x5bf93a4
    csrw 0x31a, x3

    #Address 0x31a Write value 0x17dbb887
    li x3, 0x17dbb887
    csrw 0x31a, x3

    #Unmapped address 0xe57 testing: random write/read operations
    #Address 0xe57 Write value 0x7e6f64f
    li x3, 0x7e6f64f
    csrw 0xe57, x3

    #Unmapped address 0xf79 testing: random write/read operations
    #Address 0xf79 read value
    csrr x14, 0xf79

    #Address 0xf79 Write value 0x711461d7
    li x3, 0x711461d7
    csrw 0xf79, x3

    #Address 0xf79 read value
    csrr x14, 0xf79

    #Address 0xf79 read value
    csrr x14, 0xf79

    #Unmapped address 0x7ad testing: random write/read operations
    #Address 0x7ad read value
    csrr x14, 0x7ad

    #Address 0x7ad Write value 0x9bf719c2
    li x3, 0x9bf719c2
    csrw 0x7ad, x3

    #Address 0x7ad Write value 0x52b5e9ac
    li x3, 0x52b5e9ac
    csrw 0x7ad, x3

    #Unmapped address 0x121 testing: random write/read operations
    #Address 0x121 Write value 0xbece5a90
    li x3, 0xbece5a90
    csrw 0x121, x3

    #Address 0x121 Write value 0x40f67537
    li x3, 0x40f67537
    csrw 0x121, x3

    #Unmapped address 0x1b5 testing: random write/read operations
    #Address 0x1b5 Write value 0x4a00836b
    li x3, 0x4a00836b
    csrw 0x1b5, x3

    #Address 0x1b5 Write value 0x7cd97a61
    li x3, 0x7cd97a61
    csrw 0x1b5, x3

    #Address 0x1b5 Write value 0xe308a5a1
    li x3, 0xe308a5a1
    csrw 0x1b5, x3

    #Address 0x1b5 Write value 0x79aa27a6
    li x3, 0x79aa27a6
    csrw 0x1b5, x3

    #Address 0x1b5 Write value 0xc92060f3
    li x3, 0xc92060f3
    csrw 0x1b5, x3

    #Unmapped address 0x4f3 testing: random write/read operations
    #Address 0x4f3 Write value 0x85a17bae
    li x3, 0x85a17bae
    csrw 0x4f3, x3

    #Address 0x4f3 read value
    csrr x14, 0x4f3

    #Address 0x4f3 read value
    csrr x14, 0x4f3

    #Unmapped address 0xb76 testing: random write/read operations
    #Address 0xb76 read value
    csrr x14, 0xb76

    #Unmapped address 0x5bc testing: random write/read operations
    #Address 0x5bc read value
    csrr x14, 0x5bc

    #Unmapped address 0x93f testing: random write/read operations
    #Address 0x93f read value
    csrr x14, 0x93f

    #Address 0x93f read value
    csrr x14, 0x93f

    #Address 0x93f read value
    csrr x14, 0x93f

    #Address 0x93f Write value 0x9f49ae8f
    li x3, 0x9f49ae8f
    csrw 0x93f, x3

    #Unmapped address 0x723 testing: random write/read operations
    #Address 0x723 Write value 0x2acc2e94
    li x3, 0x2acc2e94
    csrw 0x723, x3

    #Address 0x723 Write value 0x440ba4c7
    li x3, 0x440ba4c7
    csrw 0x723, x3

    #Unmapped address 0xd4b testing: random write/read operations
    #Address 0xd4b read value
    csrr x14, 0xd4b

    #Address 0xd4b Write value 0x2c44760
    li x3, 0x2c44760
    csrw 0xd4b, x3

    #Unmapped address 0x11e testing: random write/read operations
    #Address 0x11e read value
    csrr x14, 0x11e

    #Address 0x11e Write value 0x1006f022
    li x3, 0x1006f022
    csrw 0x11e, x3

    #Address 0x11e read value
    csrr x14, 0x11e

    #Address 0x11e read value
    csrr x14, 0x11e

    #Unmapped address 0x489 testing: random write/read operations
    #Address 0x489 read value
    csrr x14, 0x489

    #Address 0x489 read value
    csrr x14, 0x489

    #Unmapped address 0xc3b testing: random write/read operations
    #Address 0xc3b read value
    csrr x14, 0xc3b

    #Address 0xc3b Write value 0x8e353a1b
    li x3, 0x8e353a1b
    csrw 0xc3b, x3

    #Address 0xc3b read value
    csrr x14, 0xc3b

    #Address 0xc3b Write value 0xe38fb0da
    li x3, 0xe38fb0da
    csrw 0xc3b, x3

    #Unmapped address 0xaf3 testing: random write/read operations
    #Address 0xaf3 Write value 0xbf667901
    li x3, 0xbf667901
    csrw 0xaf3, x3

    #Address 0xaf3 read value
    csrr x14, 0xaf3

    #Address 0xaf3 Write value 0x6ad6419b
    li x3, 0x6ad6419b
    csrw 0xaf3, x3

    #Address 0xaf3 read value
    csrr x14, 0xaf3

    #Unmapped address 0x93 testing: random write/read operations
    #Address 0x93 Write value 0x175d0374
    li x3, 0x175d0374
    csrw 0x93, x3

    #Address 0x93 Write value 0xb716e19c
    li x3, 0xb716e19c
    csrw 0x93, x3

    #Unmapped address 0x1c0 testing: random write/read operations
    #Address 0x1c0 Write value 0x42896499
    li x3, 0x42896499
    csrw 0x1c0, x3

    #Address 0x1c0 read value
    csrr x14, 0x1c0

    #Unmapped address 0x8e3 testing: random write/read operations
    #Address 0x8e3 read value
    csrr x14, 0x8e3

    #Address 0x8e3 Write value 0xe0eb29b1
    li x3, 0xe0eb29b1
    csrw 0x8e3, x3

    #Address 0x8e3 read value
    csrr x14, 0x8e3

    #Unmapped address 0x60c testing: random write/read operations
    #Address 0x60c read value
    csrr x14, 0x60c

    #Address 0x60c read value
    csrr x14, 0x60c

    #Address 0x60c Write value 0x1a1973ed
    li x3, 0x1a1973ed
    csrw 0x60c, x3

    #Unmapped address 0x453 testing: random write/read operations
    #Address 0x453 read value
    csrr x14, 0x453

    #Address 0x453 read value
    csrr x14, 0x453

    #Address 0x453 Write value 0xc24d9159
    li x3, 0xc24d9159
    csrw 0x453, x3

    #Address 0x453 read value
    csrr x14, 0x453

    #Unmapped address 0x2d1 testing: random write/read operations
    #Address 0x2d1 read value
    csrr x14, 0x2d1

    #Address 0x2d1 read value
    csrr x14, 0x2d1

    #Address 0x2d1 Write value 0x1f0ffe79
    li x3, 0x1f0ffe79
    csrw 0x2d1, x3

    #Address 0x2d1 Write value 0x9cb02d30
    li x3, 0x9cb02d30
    csrw 0x2d1, x3

    #Unmapped address 0xc9a testing: random write/read operations
    #Address 0xc9a read value
    csrr x14, 0xc9a

    #Address 0xc9a read value
    csrr x14, 0xc9a

    #Address 0xc9a read value
    csrr x14, 0xc9a

    #Unmapped address 0x798 testing: random write/read operations
    #Address 0x798 read value
    csrr x14, 0x798

    #Address 0x798 read value
    csrr x14, 0x798

    #Address 0x798 read value
    csrr x14, 0x798

    #Address 0x798 read value
    csrr x14, 0x798

    #Unmapped address 0x39a testing: random write/read operations
    #Address 0x39a read value
    csrr x14, 0x39a

    #Address 0x39a read value
    csrr x14, 0x39a

    #Address 0x39a Write value 0x3e40205f
    li x3, 0x3e40205f
    csrw 0x39a, x3

    #Unmapped address 0x3dd testing: random write/read operations
    #Address 0x3dd read value
    csrr x14, 0x3dd

    #Unmapped address 0xd52 testing: random write/read operations
    #Address 0xd52 read value
    csrr x14, 0xd52

    #Address 0xd52 Write value 0x226d6901
    li x3, 0x226d6901
    csrw 0xd52, x3

    #Address 0xd52 Write value 0xee25ce16
    li x3, 0xee25ce16
    csrw 0xd52, x3

    #Unmapped address 0xa9d testing: random write/read operations
    #Address 0xa9d read value
    csrr x14, 0xa9d

    #Address 0xa9d Write value 0xc449516d
    li x3, 0xc449516d
    csrw 0xa9d, x3

    #Address 0xa9d Write value 0x471c9b8
    li x3, 0x471c9b8
    csrw 0xa9d, x3

    #Address 0xa9d read value
    csrr x14, 0xa9d

    #Unmapped address 0x4b3 testing: random write/read operations
    #Address 0x4b3 read value
    csrr x14, 0x4b3

    #Address 0x4b3 Write value 0xc2243d79
    li x3, 0xc2243d79
    csrw 0x4b3, x3

    #Address 0x4b3 read value
    csrr x14, 0x4b3

    #Address 0x4b3 read value
    csrr x14, 0x4b3

    #Address 0x4b3 Write value 0xb8d16f4f
    li x3, 0xb8d16f4f
    csrw 0x4b3, x3

    #Unmapped address 0xe1b testing: random write/read operations
    #Address 0xe1b read value
    csrr x14, 0xe1b

    #Address 0xe1b Write value 0x45eb1190
    li x3, 0x45eb1190
    csrw 0xe1b, x3

    #Address 0xe1b read value
    csrr x14, 0xe1b

    #Address 0xe1b Write value 0x6410daf8
    li x3, 0x6410daf8
    csrw 0xe1b, x3

    #Unmapped address 0x737 testing: random write/read operations
    #Address 0x737 read value
    csrr x14, 0x737

    #Address 0x737 read value
    csrr x14, 0x737

    #Address 0x737 Write value 0x8222a126
    li x3, 0x8222a126
    csrw 0x737, x3

    #Address 0x737 Write value 0xe6b6bf94
    li x3, 0xe6b6bf94
    csrw 0x737, x3

    #Mapped address 0xb1e (mhpmcounter30) testing: random write/read operations
    #Address 0xb1e read value
    csrr x14, 0xb1e

    #Unmapped address 0x6c5 testing: random write/read operations
    #Address 0x6c5 Write value 0x9b46a9ad
    li x3, 0x9b46a9ad
    csrw 0x6c5, x3

    #Address 0x6c5 Write value 0xa0ec3c78
    li x3, 0xa0ec3c78
    csrw 0x6c5, x3

    #Address 0x6c5 read value
    csrr x14, 0x6c5

    #Address 0x6c5 read value
    csrr x14, 0x6c5

    #Address 0x6c5 Write value 0xf59acc33
    li x3, 0xf59acc33
    csrw 0x6c5, x3

    #Unmapped address 0xdf8 testing: random write/read operations
    #Address 0xdf8 Write value 0xec1d61d8
    li x3, 0xec1d61d8
    csrw 0xdf8, x3

    #Address 0xdf8 Write value 0x8f6ad3b9
    li x3, 0x8f6ad3b9
    csrw 0xdf8, x3

    #Address 0xdf8 read value
    csrr x14, 0xdf8

    #Unmapped address 0xc7a testing: random write/read operations
    #Address 0xc7a read value
    csrr x14, 0xc7a

    #Unmapped address 0x8d7 testing: random write/read operations
    #Address 0x8d7 read value
    csrr x14, 0x8d7

    #Address 0x8d7 read value
    csrr x14, 0x8d7

    #Unmapped address 0x84e testing: random write/read operations
    #Address 0x84e Write value 0xc70675f1
    li x3, 0xc70675f1
    csrw 0x84e, x3

    #Address 0x84e read value
    csrr x14, 0x84e

    #Unmapped address 0x5c2 testing: random write/read operations
    #Address 0x5c2 Write value 0x89dad55f
    li x3, 0x89dad55f
    csrw 0x5c2, x3

    #Address 0x5c2 Write value 0x7a4776a
    li x3, 0x7a4776a
    csrw 0x5c2, x3

    #Address 0x5c2 read value
    csrr x14, 0x5c2

    #Unmapped address 0x6e9 testing: random write/read operations
    #Address 0x6e9 Write value 0x475b6d84
    li x3, 0x475b6d84
    csrw 0x6e9, x3

    #Address 0x6e9 Write value 0xa9e2fe7b
    li x3, 0xa9e2fe7b
    csrw 0x6e9, x3

    #Unmapped address 0x256 testing: random write/read operations
    #Address 0x256 read value
    csrr x14, 0x256

    #Address 0x256 Write value 0x20b50628
    li x3, 0x20b50628
    csrw 0x256, x3

    #Address 0x256 read value
    csrr x14, 0x256

    #Address 0x256 read value
    csrr x14, 0x256

    #Address 0x256 Write value 0x232b6933
    li x3, 0x232b6933
    csrw 0x256, x3

    #Unmapped address 0xf2a testing: random write/read operations
    #Address 0xf2a Write value 0x91302826
    li x3, 0x91302826
    csrw 0xf2a, x3

    #Address 0xf2a read value
    csrr x14, 0xf2a

    #Address 0xf2a read value
    csrr x14, 0xf2a

    #Address 0xf2a read value
    csrr x14, 0xf2a

    #Address 0xf2a read value
    csrr x14, 0xf2a

    #Unmapped address 0x875 testing: random write/read operations
    #Address 0x875 read value
    csrr x14, 0x875

    #Address 0x875 read value
    csrr x14, 0x875

    #Address 0x875 Write value 0xffd13b43
    li x3, 0xffd13b43
    csrw 0x875, x3

    #Address 0x875 read value
    csrr x14, 0x875

    #Address 0x875 read value
    csrr x14, 0x875

    #Unmapped address 0x962 testing: random write/read operations
    #Address 0x962 Write value 0x8b0c167a
    li x3, 0x8b0c167a
    csrw 0x962, x3

    #Address 0x962 Write value 0x6d936452
    li x3, 0x6d936452
    csrw 0x962, x3

    #Address 0x962 Write value 0x98230a16
    li x3, 0x98230a16
    csrw 0x962, x3

    #Unmapped address 0xf81 testing: random write/read operations
    #Address 0xf81 Write value 0xb29ae8ab
    li x3, 0xb29ae8ab
    csrw 0xf81, x3

    #Address 0xf81 read value
    csrr x14, 0xf81

    #Unmapped address 0x38a testing: random write/read operations
    #Address 0x38a read value
    csrr x14, 0x38a

    #Unmapped address 0xd4e testing: random write/read operations
    #Address 0xd4e Write value 0x6c50cba0
    li x3, 0x6c50cba0
    csrw 0xd4e, x3

    #Unmapped address 0x7bd testing: random write/read operations
    #Address 0x7bd read value
    csrr x14, 0x7bd

    #Address 0x7bd Write value 0x738ed8a1
    li x3, 0x738ed8a1
    csrw 0x7bd, x3

    #Unmapped address 0x476 testing: random write/read operations
    #Address 0x476 read value
    csrr x14, 0x476

    #Unmapped address 0xc26 testing: random write/read operations
    #Address 0xc26 read value
    csrr x14, 0xc26

    #Address 0xc26 read value
    csrr x14, 0xc26

    #Address 0xc26 Write value 0x1ed18c69
    li x3, 0x1ed18c69
    csrw 0xc26, x3

    #Address 0xc26 read value
    csrr x14, 0xc26

    #Address 0xc26 read value
    csrr x14, 0xc26

    #Unmapped address 0xe7b testing: random write/read operations
    #Address 0xe7b read value
    csrr x14, 0xe7b

    #Address 0xe7b Write value 0x32c1ae25
    li x3, 0x32c1ae25
    csrw 0xe7b, x3

    #Unmapped address 0x5a testing: random write/read operations
    #Address 0x5a read value
    csrr x14, 0x5a

    #Unmapped address 0x691 testing: random write/read operations
    #Address 0x691 read value
    csrr x14, 0x691

    #Address 0x691 Write value 0x18a594f
    li x3, 0x18a594f
    csrw 0x691, x3

    #Address 0x691 read value
    csrr x14, 0x691

    #Address 0x691 Write value 0x5e41b761
    li x3, 0x5e41b761
    csrw 0x691, x3

    #Address 0x691 read value
    csrr x14, 0x691

    #Unmapped address 0xd1a testing: random write/read operations
    #Address 0xd1a Write value 0x226add04
    li x3, 0x226add04
    csrw 0xd1a, x3

    #Address 0xd1a Write value 0x8e320e94
    li x3, 0x8e320e94
    csrw 0xd1a, x3

    #Address 0xd1a Write value 0x578ce11c
    li x3, 0x578ce11c
    csrw 0xd1a, x3

    #Address 0xd1a Write value 0x2b46eec
    li x3, 0x2b46eec
    csrw 0xd1a, x3

    #Address 0xd1a Write value 0x1686dbe1
    li x3, 0x1686dbe1
    csrw 0xd1a, x3

    #Unmapped address 0x3f1 testing: random write/read operations
    #Address 0x3f1 read value
    csrr x14, 0x3f1

    #Address 0x3f1 read value
    csrr x14, 0x3f1

    #Address 0x3f1 read value
    csrr x14, 0x3f1

    #Unmapped address 0x397 testing: random write/read operations
    #Address 0x397 read value
    csrr x14, 0x397

    #Unmapped address 0x59a testing: random write/read operations
    #Address 0x59a Write value 0x14002938
    li x3, 0x14002938
    csrw 0x59a, x3

    #Address 0x59a Write value 0xa961a829
    li x3, 0xa961a829
    csrw 0x59a, x3

    #Address 0x59a Write value 0xee6c694e
    li x3, 0xee6c694e
    csrw 0x59a, x3

    #Address 0x59a read value
    csrr x14, 0x59a

    #Address 0x59a Write value 0xf5ae9bcf
    li x3, 0xf5ae9bcf
    csrw 0x59a, x3

    #Unmapped address 0x988 testing: random write/read operations
    #Address 0x988 Write value 0xf19cd913
    li x3, 0xf19cd913
    csrw 0x988, x3

    #Address 0x988 read value
    csrr x14, 0x988

    #Address 0x988 Write value 0xd092ed8f
    li x3, 0xd092ed8f
    csrw 0x988, x3

    #Address 0x988 read value
    csrr x14, 0x988

    #Unmapped address 0x69d testing: random write/read operations
    #Address 0x69d read value
    csrr x14, 0x69d

    #Address 0x69d read value
    csrr x14, 0x69d

    #Address 0x69d Write value 0x4ce3e0d0
    li x3, 0x4ce3e0d0
    csrw 0x69d, x3

    #Unmapped address 0x58a testing: random write/read operations
    #Address 0x58a Write value 0xce633f4f
    li x3, 0xce633f4f
    csrw 0x58a, x3

    #Address 0x58a read value
    csrr x14, 0x58a

    #Unmapped address 0xf57 testing: random write/read operations
    #Address 0xf57 Write value 0xa1e7422a
    li x3, 0xa1e7422a
    csrw 0xf57, x3

    #Unmapped address 0x1a testing: random write/read operations
    #Address 0x1a Write value 0x82b49b54
    li x3, 0x82b49b54
    csrw 0x1a, x3

    #Unmapped address 0x578 testing: random write/read operations
    #Address 0x578 Write value 0x2cdfb269
    li x3, 0x2cdfb269
    csrw 0x578, x3

    #Unmapped address 0x43f testing: random write/read operations
    #Address 0x43f Write value 0xb0fb14ac
    li x3, 0xb0fb14ac
    csrw 0x43f, x3

    #Address 0x43f Write value 0x428b71b8
    li x3, 0x428b71b8
    csrw 0x43f, x3

    #Address 0x43f Write value 0xa931cb18
    li x3, 0xa931cb18
    csrw 0x43f, x3

    #Unmapped address 0x385 testing: random write/read operations
    #Address 0x385 Write value 0x6af1dc95
    li x3, 0x6af1dc95
    csrw 0x385, x3

    #Unmapped address 0x374 testing: random write/read operations
    #Address 0x374 read value
    csrr x14, 0x374

    #Unmapped address 0x130 testing: random write/read operations
    #Address 0x130 read value
    csrr x14, 0x130

    #Address 0x130 read value
    csrr x14, 0x130

    #Address 0x130 read value
    csrr x14, 0x130

    #Address 0x130 read value
    csrr x14, 0x130

    #Unmapped address 0xab2 testing: random write/read operations
    #Address 0xab2 Write value 0x1011a99b
    li x3, 0x1011a99b
    csrw 0xab2, x3

    #Unmapped address 0x623 testing: random write/read operations
    #Address 0x623 read value
    csrr x14, 0x623

    #Address 0x623 Write value 0xff878c0e
    li x3, 0xff878c0e
    csrw 0x623, x3

    #Address 0x623 Write value 0xb16846ef
    li x3, 0xb16846ef
    csrw 0x623, x3

    #Address 0x623 read value
    csrr x14, 0x623

    #Unmapped address 0x993 testing: random write/read operations
    #Address 0x993 Write value 0xf703a6a2
    li x3, 0xf703a6a2
    csrw 0x993, x3

    #Address 0x993 read value
    csrr x14, 0x993

    #Address 0x993 Write value 0xd83acf1f
    li x3, 0xd83acf1f
    csrw 0x993, x3

    #Address 0x993 Write value 0xf2a671a6
    li x3, 0xf2a671a6
    csrw 0x993, x3

    #Unmapped address 0x8c testing: random write/read operations
    #Address 0x8c Write value 0x3bc100f7
    li x3, 0x3bc100f7
    csrw 0x8c, x3

    #Address 0x8c Write value 0xad8aebd2
    li x3, 0xad8aebd2
    csrw 0x8c, x3

    #Address 0x8c Write value 0xc5e006f1
    li x3, 0xc5e006f1
    csrw 0x8c, x3

    #Address 0x8c Write value 0xb0b99563
    li x3, 0xb0b99563
    csrw 0x8c, x3

    #Unmapped address 0x456 testing: random write/read operations
    #Address 0x456 Write value 0x1e4f6c0e
    li x3, 0x1e4f6c0e
    csrw 0x456, x3

    #Unmapped address 0xe09 testing: random write/read operations
    #Address 0xe09 Write value 0xb45dac65
    li x3, 0xb45dac65
    csrw 0xe09, x3

    #Address 0xe09 Write value 0xb45d2e1c
    li x3, 0xb45d2e1c
    csrw 0xe09, x3

    #Address 0xe09 Write value 0x56304bd3
    li x3, 0x56304bd3
    csrw 0xe09, x3

    #Address 0xe09 read value
    csrr x14, 0xe09

    #Address 0xe09 read value
    csrr x14, 0xe09

    #Unmapped address 0x41e testing: random write/read operations
    #Address 0x41e read value
    csrr x14, 0x41e

    #Unmapped address 0xea0 testing: random write/read operations
    #Address 0xea0 read value
    csrr x14, 0xea0

    #Address 0xea0 read value
    csrr x14, 0xea0

    #Unmapped address 0xf74 testing: random write/read operations
    #Address 0xf74 read value
    csrr x14, 0xf74

    #Unmapped address 0xe63 testing: random write/read operations
    #Address 0xe63 read value
    csrr x14, 0xe63

    #Unmapped address 0x78c testing: random write/read operations
    #Address 0x78c read value
    csrr x14, 0x78c

    #Address 0x78c read value
    csrr x14, 0x78c

    #Address 0x78c Write value 0xf298f4a7
    li x3, 0xf298f4a7
    csrw 0x78c, x3

    #Address 0x78c Write value 0x95153339
    li x3, 0x95153339
    csrw 0x78c, x3

    #Address 0x78c Write value 0x363b4d4d
    li x3, 0x363b4d4d
    csrw 0x78c, x3

    #Unmapped address 0x60d testing: random write/read operations
    #Address 0x60d read value
    csrr x14, 0x60d

    #Address 0x60d Write value 0x55801b9b
    li x3, 0x55801b9b
    csrw 0x60d, x3

    #Address 0x60d Write value 0xffde986e
    li x3, 0xffde986e
    csrw 0x60d, x3

    #Address 0x60d Write value 0x34510cce
    li x3, 0x34510cce
    csrw 0x60d, x3

    #Address 0x60d read value
    csrr x14, 0x60d

    #Unmapped address 0x704 testing: random write/read operations
    #Address 0x704 read value
    csrr x14, 0x704

    #Unmapped address 0xba3 testing: random write/read operations
    #Address 0xba3 Write value 0x8a4a11e4
    li x3, 0x8a4a11e4
    csrw 0xba3, x3

    #Address 0xba3 Write value 0xa7ca6999
    li x3, 0xa7ca6999
    csrw 0xba3, x3

    #Unmapped address 0x235 testing: random write/read operations
    #Address 0x235 read value
    csrr x14, 0x235

    #Address 0x235 read value
    csrr x14, 0x235

    #Address 0x235 Write value 0x7b801a5e
    li x3, 0x7b801a5e
    csrw 0x235, x3

    #Address 0x235 Write value 0x10abdf65
    li x3, 0x10abdf65
    csrw 0x235, x3

    #Unmapped address 0xcad testing: random write/read operations
    #Address 0xcad Write value 0x8a0a9e10
    li x3, 0x8a0a9e10
    csrw 0xcad, x3

    #Address 0xcad read value
    csrr x14, 0xcad

    #Address 0xcad Write value 0xbf47c071
    li x3, 0xbf47c071
    csrw 0xcad, x3

    #Address 0xcad Write value 0xc331f7c8
    li x3, 0xc331f7c8
    csrw 0xcad, x3

    #Address 0xcad read value
    csrr x14, 0xcad

    #Unmapped address 0x9fb testing: random write/read operations
    #Address 0x9fb Write value 0x2f7e60b6
    li x3, 0x2f7e60b6
    csrw 0x9fb, x3

    #Address 0x9fb Write value 0xb4706e1c
    li x3, 0xb4706e1c
    csrw 0x9fb, x3

    #Address 0x9fb Write value 0x2e729899
    li x3, 0x2e729899
    csrw 0x9fb, x3

    #Address 0x9fb Write value 0xc9acb7ab
    li x3, 0xc9acb7ab
    csrw 0x9fb, x3

    #Address 0x9fb read value
    csrr x14, 0x9fb

    #Unmapped address 0x825 testing: random write/read operations
    #Address 0x825 Write value 0xdd91d7bf
    li x3, 0xdd91d7bf
    csrw 0x825, x3

    #Address 0x825 read value
    csrr x14, 0x825

    #Unmapped address 0x408 testing: random write/read operations
    #Address 0x408 Write value 0xbb6b845
    li x3, 0xbb6b845
    csrw 0x408, x3

    #Address 0x408 Write value 0xcfe5fef7
    li x3, 0xcfe5fef7
    csrw 0x408, x3

    #Address 0x408 read value
    csrr x14, 0x408

    #Address 0x408 Write value 0xbccd9852
    li x3, 0xbccd9852
    csrw 0x408, x3

    #Unmapped address 0x8f4 testing: random write/read operations
    #Address 0x8f4 Write value 0x9afefca7
    li x3, 0x9afefca7
    csrw 0x8f4, x3

    #Address 0x8f4 Write value 0x5a55024c
    li x3, 0x5a55024c
    csrw 0x8f4, x3

    #Address 0x8f4 Write value 0x8afb6972
    li x3, 0x8afb6972
    csrw 0x8f4, x3

    #Address 0x8f4 Write value 0x54e011b4
    li x3, 0x54e011b4
    csrw 0x8f4, x3

    #Unmapped address 0x396 testing: random write/read operations
    #Address 0x396 read value
    csrr x14, 0x396

    #Address 0x396 Write value 0x4b6d4c24
    li x3, 0x4b6d4c24
    csrw 0x396, x3

    #Address 0x396 Write value 0x8b8a6839
    li x3, 0x8b8a6839
    csrw 0x396, x3

    #Address 0x396 read value
    csrr x14, 0x396

    #Address 0x396 read value
    csrr x14, 0x396

    #Unmapped address 0x315 testing: random write/read operations
    #Address 0x315 Write value 0x2580d9b4
    li x3, 0x2580d9b4
    csrw 0x315, x3

    #Address 0x315 Write value 0x9e820061
    li x3, 0x9e820061
    csrw 0x315, x3

    #Address 0x315 read value
    csrr x14, 0x315

    #Address 0x315 Write value 0x58c352d1
    li x3, 0x58c352d1
    csrw 0x315, x3

    #Address 0x315 read value
    csrr x14, 0x315

    #Unmapped address 0x40d testing: random write/read operations
    #Address 0x40d Write value 0x4dc18855
    li x3, 0x4dc18855
    csrw 0x40d, x3

    #Unmapped address 0x160 testing: random write/read operations
    #Address 0x160 read value
    csrr x14, 0x160

    #Address 0x160 Write value 0xb30187c
    li x3, 0xb30187c
    csrw 0x160, x3

    #Address 0x160 Write value 0x871aed8a
    li x3, 0x871aed8a
    csrw 0x160, x3

    #Address 0x160 Write value 0xd4e0a9c1
    li x3, 0xd4e0a9c1
    csrw 0x160, x3

    #Address 0x160 read value
    csrr x14, 0x160

    #Unmapped address 0xa90 testing: random write/read operations
    #Address 0xa90 Write value 0x799ae2a4
    li x3, 0x799ae2a4
    csrw 0xa90, x3

    #Address 0xa90 Write value 0x42d9704f
    li x3, 0x42d9704f
    csrw 0xa90, x3

    #Address 0xa90 read value
    csrr x14, 0xa90

    #Unmapped address 0xe9 testing: random write/read operations
    #Address 0xe9 read value
    csrr x14, 0xe9

    #Address 0xe9 Write value 0x494b6b8f
    li x3, 0x494b6b8f
    csrw 0xe9, x3

    #Address 0xe9 read value
    csrr x14, 0xe9

    #Address 0xe9 Write value 0x50434d84
    li x3, 0x50434d84
    csrw 0xe9, x3

    #Unmapped address 0xaff testing: random write/read operations
    #Address 0xaff Write value 0xe540dc46
    li x3, 0xe540dc46
    csrw 0xaff, x3

    #Address 0xaff read value
    csrr x14, 0xaff

    #Unmapped address 0x272 testing: random write/read operations
    #Address 0x272 Write value 0x99822d41
    li x3, 0x99822d41
    csrw 0x272, x3

    #Address 0x272 read value
    csrr x14, 0x272

    #Address 0x272 Write value 0x33f1a888
    li x3, 0x33f1a888
    csrw 0x272, x3

    #Unmapped address 0xd11 testing: random write/read operations
    #Address 0xd11 read value
    csrr x14, 0xd11

    #Unmapped address 0x605 testing: random write/read operations
    #Address 0x605 read value
    csrr x14, 0x605

    #Address 0x605 Write value 0x690ccb6
    li x3, 0x690ccb6
    csrw 0x605, x3

    #Address 0x605 read value
    csrr x14, 0x605

    #Unmapped address 0x8fb testing: random write/read operations
    #Address 0x8fb read value
    csrr x14, 0x8fb

    #Address 0x8fb read value
    csrr x14, 0x8fb

    #Address 0x8fb read value
    csrr x14, 0x8fb

    #Address 0x8fb read value
    csrr x14, 0x8fb

    #Unmapped address 0x2df testing: random write/read operations
    #Address 0x2df read value
    csrr x14, 0x2df

    #Address 0x2df read value
    csrr x14, 0x2df

    #Address 0x2df read value
    csrr x14, 0x2df

    #Address 0x2df Write value 0x27007d41
    li x3, 0x27007d41
    csrw 0x2df, x3

    #Unmapped address 0x188 testing: random write/read operations
    #Address 0x188 Write value 0x48116756
    li x3, 0x48116756
    csrw 0x188, x3

    #Address 0x188 read value
    csrr x14, 0x188

    #Address 0x188 Write value 0x3b3dbc92
    li x3, 0x3b3dbc92
    csrw 0x188, x3

    #Address 0x188 Write value 0xb590bcd7
    li x3, 0xb590bcd7
    csrw 0x188, x3

    #Unmapped address 0x15b testing: random write/read operations
    #Address 0x15b read value
    csrr x14, 0x15b

    #Address 0x15b read value
    csrr x14, 0x15b

    #Address 0x15b Write value 0x6e6c0a76
    li x3, 0x6e6c0a76
    csrw 0x15b, x3

    #Unmapped address 0x8c9 testing: random write/read operations
    #Address 0x8c9 read value
    csrr x14, 0x8c9

    #Address 0x8c9 read value
    csrr x14, 0x8c9

    #Unmapped address 0xafb testing: random write/read operations
    #Address 0xafb Write value 0xfb3699b6
    li x3, 0xfb3699b6
    csrw 0xafb, x3

    #Address 0xafb read value
    csrr x14, 0xafb

    #Address 0xafb read value
    csrr x14, 0xafb

    #Address 0xafb read value
    csrr x14, 0xafb

    #Unmapped address 0x1cd testing: random write/read operations
    #Address 0x1cd read value
    csrr x14, 0x1cd

    #Unmapped address 0xa9f testing: random write/read operations
    #Address 0xa9f Write value 0x6e019c68
    li x3, 0x6e019c68
    csrw 0xa9f, x3

    #Address 0xa9f Write value 0x59185342
    li x3, 0x59185342
    csrw 0xa9f, x3

    #Address 0xa9f read value
    csrr x14, 0xa9f

    #Address 0xa9f Write value 0xbccc8493
    li x3, 0xbccc8493
    csrw 0xa9f, x3

    #Unmapped address 0x681 testing: random write/read operations
    #Address 0x681 Write value 0xec8734de
    li x3, 0xec8734de
    csrw 0x681, x3

    #Address 0x681 read value
    csrr x14, 0x681

    #Address 0x681 read value
    csrr x14, 0x681

    #Unmapped address 0x45f testing: random write/read operations
    #Address 0x45f Write value 0x837b735
    li x3, 0x837b735
    csrw 0x45f, x3

    #Address 0x45f Write value 0x66cf20e5
    li x3, 0x66cf20e5
    csrw 0x45f, x3

    #Unmapped address 0x8a8 testing: random write/read operations
    #Address 0x8a8 Write value 0x7d9aa67
    li x3, 0x7d9aa67
    csrw 0x8a8, x3

    #Address 0x8a8 read value
    csrr x14, 0x8a8

    #Unmapped address 0x49 testing: random write/read operations
    #Address 0x49 read value
    csrr x14, 0x49

    #Address 0x49 Write value 0x5fb86f16
    li x3, 0x5fb86f16
    csrw 0x49, x3

    #Address 0x49 read value
    csrr x14, 0x49

    #Address 0x49 Write value 0xc2e309e4
    li x3, 0xc2e309e4
    csrw 0x49, x3

    #Address 0x49 Write value 0x4167a5c
    li x3, 0x4167a5c
    csrw 0x49, x3

    #Unmapped address 0x455 testing: random write/read operations
    #Address 0x455 Write value 0xf1d370f4
    li x3, 0xf1d370f4
    csrw 0x455, x3

    #Address 0x455 Write value 0x838c0dc2
    li x3, 0x838c0dc2
    csrw 0x455, x3

    #Address 0x455 Write value 0xbd9af893
    li x3, 0xbd9af893
    csrw 0x455, x3

    #Address 0x455 read value
    csrr x14, 0x455

    #Unmapped address 0xf92 testing: random write/read operations
    #Address 0xf92 read value
    csrr x14, 0xf92

    #Unmapped address 0xf62 testing: random write/read operations
    #Address 0xf62 Write value 0x2ea90c7c
    li x3, 0x2ea90c7c
    csrw 0xf62, x3

    #Unmapped address 0x9 testing: random write/read operations
    #Address 0x9 read value
    csrr x14, 0x9

    #Address 0x9 read value
    csrr x14, 0x9

    #Address 0x9 read value
    csrr x14, 0x9

    #Address 0x9 Write value 0xafc5f98f
    li x3, 0xafc5f98f
    csrw 0x9, x3

    #Unmapped address 0xda8 testing: random write/read operations
    #Address 0xda8 Write value 0x7301f544
    li x3, 0x7301f544
    csrw 0xda8, x3

    #Address 0xda8 Write value 0xacf2f9a0
    li x3, 0xacf2f9a0
    csrw 0xda8, x3

    #Unmapped address 0x48a testing: random write/read operations
    #Address 0x48a read value
    csrr x14, 0x48a

    #Unmapped address 0xe93 testing: random write/read operations
    #Address 0xe93 read value
    csrr x14, 0xe93

    #Address 0xe93 read value
    csrr x14, 0xe93

    #Address 0xe93 Write value 0x28707b
    li x3, 0x28707b
    csrw 0xe93, x3

    #Address 0xe93 read value
    csrr x14, 0xe93

    #Unmapped address 0x9b testing: random write/read operations
    #Address 0x9b Write value 0x2138b2c3
    li x3, 0x2138b2c3
    csrw 0x9b, x3

    #Address 0x9b read value
    csrr x14, 0x9b

    #Unmapped address 0xbc9 testing: random write/read operations
    #Address 0xbc9 Write value 0x34b9fde
    li x3, 0x34b9fde
    csrw 0xbc9, x3

    #Address 0xbc9 Write value 0x7ea61be2
    li x3, 0x7ea61be2
    csrw 0xbc9, x3

    #Address 0xbc9 read value
    csrr x14, 0xbc9

    #Address 0xbc9 read value
    csrr x14, 0xbc9

    #Unmapped address 0x65b testing: random write/read operations
    #Address 0x65b Write value 0xd6772035
    li x3, 0xd6772035
    csrw 0x65b, x3

    #Address 0x65b Write value 0x6c07ba67
    li x3, 0x6c07ba67
    csrw 0x65b, x3

    #Address 0x65b Write value 0x9e938aa4
    li x3, 0x9e938aa4
    csrw 0x65b, x3

    #Unmapped address 0xaa testing: random write/read operations
    #Address 0xaa Write value 0x452fa128
    li x3, 0x452fa128
    csrw 0xaa, x3

    #Address 0xaa read value
    csrr x14, 0xaa

    #Unmapped address 0xc21 testing: random write/read operations
    #Address 0xc21 Write value 0x84e57a6
    li x3, 0x84e57a6
    csrw 0xc21, x3

    #Unmapped address 0x58 testing: random write/read operations
    #Address 0x58 Write value 0xd2263d0c
    li x3, 0xd2263d0c
    csrw 0x58, x3

    #Address 0x58 read value
    csrr x14, 0x58

    #Address 0x58 Write value 0xc5a5ffa
    li x3, 0xc5a5ffa
    csrw 0x58, x3

    #Unmapped address 0xdf7 testing: random write/read operations
    #Address 0xdf7 Write value 0xfab89a2d
    li x3, 0xfab89a2d
    csrw 0xdf7, x3

    #Address 0xdf7 Write value 0xeca07188
    li x3, 0xeca07188
    csrw 0xdf7, x3

    #Address 0xdf7 Write value 0x21a96464
    li x3, 0x21a96464
    csrw 0xdf7, x3

    #Address 0xdf7 read value
    csrr x14, 0xdf7

    #Address 0xdf7 Write value 0x20c05a1f
    li x3, 0x20c05a1f
    csrw 0xdf7, x3

    #Unmapped address 0x382 testing: random write/read operations
    #Address 0x382 read value
    csrr x14, 0x382

    #Address 0x382 read value
    csrr x14, 0x382

    #Address 0x382 read value
    csrr x14, 0x382

    #Address 0x382 read value
    csrr x14, 0x382

    #Address 0x382 Write value 0xc1dfa1c5
    li x3, 0xc1dfa1c5
    csrw 0x382, x3

    #Unmapped address 0x224 testing: random write/read operations
    #Address 0x224 read value
    csrr x14, 0x224

    #Unmapped address 0x720 testing: random write/read operations
    #Address 0x720 read value
    csrr x14, 0x720

    #Unmapped address 0xcc1 testing: random write/read operations
    #Address 0xcc1 Write value 0xdee881eb
    li x3, 0xdee881eb
    csrw 0xcc1, x3

    #Address 0xcc1 read value
    csrr x14, 0xcc1

    #Address 0xcc1 Write value 0x50de27a5
    li x3, 0x50de27a5
    csrw 0xcc1, x3

    #Address 0xcc1 read value
    csrr x14, 0xcc1

    #Address 0xcc1 read value
    csrr x14, 0xcc1

    #Unmapped address 0x25e testing: random write/read operations
    #Address 0x25e read value
    csrr x14, 0x25e

    #Address 0x25e Write value 0x6073dbdf
    li x3, 0x6073dbdf
    csrw 0x25e, x3

    #Address 0x25e Write value 0x90a7df3f
    li x3, 0x90a7df3f
    csrw 0x25e, x3

    #Address 0x25e read value
    csrr x14, 0x25e

    #Unmapped address 0x9d5 testing: random write/read operations
    #Address 0x9d5 read value
    csrr x14, 0x9d5

    #Unmapped address 0x45d testing: random write/read operations
    #Address 0x45d read value
    csrr x14, 0x45d

    #Address 0x45d read value
    csrr x14, 0x45d

    #Address 0x45d Write value 0x9313b5ff
    li x3, 0x9313b5ff
    csrw 0x45d, x3

    #Address 0x45d read value
    csrr x14, 0x45d

    #Address 0x45d Write value 0xc6e8bdae
    li x3, 0xc6e8bdae
    csrw 0x45d, x3

    #Mapped address 0xf13 (mimpid) testing: random write/read operations
    #Address 0xf13 Write value 0x23ce145a
    li x3, 0x23ce145a
    csrw 0xf13, x3

    #Unmapped address 0xbe7 testing: random write/read operations
    #Address 0xbe7 Write value 0x4957b596
    li x3, 0x4957b596
    csrw 0xbe7, x3

    #Unmapped address 0x5c6 testing: random write/read operations
    #Address 0x5c6 Write value 0x745117fc
    li x3, 0x745117fc
    csrw 0x5c6, x3

    #Address 0x5c6 read value
    csrr x14, 0x5c6

    #Address 0x5c6 read value
    csrr x14, 0x5c6

    #Unmapped address 0xf36 testing: random write/read operations
    #Address 0xf36 Write value 0x32d12ca2
    li x3, 0x32d12ca2
    csrw 0xf36, x3

    #Address 0xf36 read value
    csrr x14, 0xf36

    #Unmapped address 0xd18 testing: random write/read operations
    #Address 0xd18 Write value 0xfea882bb
    li x3, 0xfea882bb
    csrw 0xd18, x3

    #Address 0xd18 Write value 0xcc9b0117
    li x3, 0xcc9b0117
    csrw 0xd18, x3

    #Address 0xd18 read value
    csrr x14, 0xd18

    #Unmapped address 0x845 testing: random write/read operations
    #Address 0x845 read value
    csrr x14, 0x845

    #Address 0x845 read value
    csrr x14, 0x845

    #Address 0x845 read value
    csrr x14, 0x845

    #Unmapped address 0xfa9 testing: random write/read operations
    #Address 0xfa9 read value
    csrr x14, 0xfa9

    #Address 0xfa9 Write value 0x4df646bd
    li x3, 0x4df646bd
    csrw 0xfa9, x3

    #Address 0xfa9 read value
    csrr x14, 0xfa9

    #Unmapped address 0xade testing: random write/read operations
    #Address 0xade read value
    csrr x14, 0xade

    #Address 0xade read value
    csrr x14, 0xade

    #Address 0xade read value
    csrr x14, 0xade

    #Address 0xade Write value 0xca7f0334
    li x3, 0xca7f0334
    csrw 0xade, x3

    #Address 0xade read value
    csrr x14, 0xade

    #Unmapped address 0x9a2 testing: random write/read operations
    #Address 0x9a2 read value
    csrr x14, 0x9a2

    #Address 0x9a2 Write value 0xdf7fd52e
    li x3, 0xdf7fd52e
    csrw 0x9a2, x3

    #Address 0x9a2 Write value 0xa244c438
    li x3, 0xa244c438
    csrw 0x9a2, x3

    #Address 0x9a2 read value
    csrr x14, 0x9a2

    #Unmapped address 0x71e testing: random write/read operations
    #Address 0x71e read value
    csrr x14, 0x71e

    #Address 0x71e read value
    csrr x14, 0x71e

    #Address 0x71e Write value 0xcb8dd0d1
    li x3, 0xcb8dd0d1
    csrw 0x71e, x3

    #Address 0x71e Write value 0x86105d6f
    li x3, 0x86105d6f
    csrw 0x71e, x3

    #Address 0x71e read value
    csrr x14, 0x71e

    #Unmapped address 0xb9 testing: random write/read operations
    #Address 0xb9 read value
    csrr x14, 0xb9

    #Address 0xb9 Write value 0x55b62085
    li x3, 0x55b62085
    csrw 0xb9, x3

    #Unmapped address 0xca3 testing: random write/read operations
    #Address 0xca3 Write value 0xe25a61f8
    li x3, 0xe25a61f8
    csrw 0xca3, x3

    #Unmapped address 0x8ba testing: random write/read operations
    #Address 0x8ba read value
    csrr x14, 0x8ba

    #Address 0x8ba Write value 0xb995d77a
    li x3, 0xb995d77a
    csrw 0x8ba, x3

    #Address 0x8ba read value
    csrr x14, 0x8ba

    #Address 0x8ba Write value 0xf508a62
    li x3, 0xf508a62
    csrw 0x8ba, x3

    #Address 0x8ba read value
    csrr x14, 0x8ba

    #Unmapped address 0xa22 testing: random write/read operations
    #Address 0xa22 read value
    csrr x14, 0xa22

    #Address 0xa22 read value
    csrr x14, 0xa22

    #Address 0xa22 Write value 0xe4467b3c
    li x3, 0xe4467b3c
    csrw 0xa22, x3

    #Address 0xa22 read value
    csrr x14, 0xa22

    #Address 0xa22 read value
    csrr x14, 0xa22

    #Unmapped address 0x3ac testing: random write/read operations
    #Address 0x3ac Write value 0x2ff1e714
    li x3, 0x2ff1e714
    csrw 0x3ac, x3

    #Address 0x3ac read value
    csrr x14, 0x3ac

    #Address 0x3ac Write value 0x4edca808
    li x3, 0x4edca808
    csrw 0x3ac, x3

    #Address 0x3ac Write value 0x77dc9daa
    li x3, 0x77dc9daa
    csrw 0x3ac, x3

    #Unmapped address 0x676 testing: random write/read operations
    #Address 0x676 read value
    csrr x14, 0x676

    #Address 0x676 read value
    csrr x14, 0x676

    #Address 0x676 read value
    csrr x14, 0x676

    #Address 0x676 read value
    csrr x14, 0x676

    #Unmapped address 0x915 testing: random write/read operations
    #Address 0x915 Write value 0x5b04beee
    li x3, 0x5b04beee
    csrw 0x915, x3

    #Address 0x915 read value
    csrr x14, 0x915

    #Address 0x915 read value
    csrr x14, 0x915

    #Address 0x915 read value
    csrr x14, 0x915

    #Mapped address 0x329 (mhpmevent9) testing: random write/read operations
    #Address 0x329 Write value 0xc7755b3a
    li x3, 0xc7755b3a
    csrw 0x329, x3

    #Address 0x329 read value
    csrr x14, 0x329

    #Address 0x329 Write value 0xb65c5c1c
    li x3, 0xb65c5c1c
    csrw 0x329, x3

    #Address 0x329 read value
    csrr x14, 0x329

    #Address 0x329 read value
    csrr x14, 0x329

    #Unmapped address 0x8ad testing: random write/read operations
    #Address 0x8ad read value
    csrr x14, 0x8ad

    #Address 0x8ad read value
    csrr x14, 0x8ad

    #Unmapped address 0xdd4 testing: random write/read operations
    #Address 0xdd4 Write value 0x810a434e
    li x3, 0x810a434e
    csrw 0xdd4, x3

    #Address 0xdd4 read value
    csrr x14, 0xdd4

    #Address 0xdd4 read value
    csrr x14, 0xdd4

    #Address 0xdd4 read value
    csrr x14, 0xdd4

    #Address 0xdd4 read value
    csrr x14, 0xdd4

    #Unmapped address 0x10a testing: random write/read operations
    #Address 0x10a read value
    csrr x14, 0x10a

    #Address 0x10a read value
    csrr x14, 0x10a

    #Unmapped address 0x498 testing: random write/read operations
    #Address 0x498 read value
    csrr x14, 0x498

    #Address 0x498 read value
    csrr x14, 0x498

    #Unmapped address 0x208 testing: random write/read operations
    #Address 0x208 Write value 0xd9bba82e
    li x3, 0xd9bba82e
    csrw 0x208, x3

    #Address 0x208 read value
    csrr x14, 0x208

    #Address 0x208 read value
    csrr x14, 0x208

    #Address 0x208 read value
    csrr x14, 0x208

    #Address 0x208 Write value 0x188ba564
    li x3, 0x188ba564
    csrw 0x208, x3

    #Unmapped address 0x4f2 testing: random write/read operations
    #Address 0x4f2 read value
    csrr x14, 0x4f2

    #Address 0x4f2 read value
    csrr x14, 0x4f2

    #Address 0x4f2 read value
    csrr x14, 0x4f2

    #Address 0x4f2 read value
    csrr x14, 0x4f2

    #Unmapped address 0xe74 testing: random write/read operations
    #Address 0xe74 read value
    csrr x14, 0xe74

    #Unmapped address 0xd7a testing: random write/read operations
    #Address 0xd7a read value
    csrr x14, 0xd7a

    #Unmapped address 0x6bb testing: random write/read operations
    #Address 0x6bb Write value 0xa7efd5f3
    li x3, 0xa7efd5f3
    csrw 0x6bb, x3

    #Address 0x6bb Write value 0x13735b9a
    li x3, 0x13735b9a
    csrw 0x6bb, x3

    #Address 0x6bb read value
    csrr x14, 0x6bb

    #Address 0x6bb read value
    csrr x14, 0x6bb

    #Unmapped address 0xcfd testing: random write/read operations
    #Address 0xcfd read value
    csrr x14, 0xcfd

    #Address 0xcfd read value
    csrr x14, 0xcfd

    #Unmapped address 0x8a6 testing: random write/read operations
    #Address 0x8a6 Write value 0x5a733279
    li x3, 0x5a733279
    csrw 0x8a6, x3

    #Address 0x8a6 Write value 0x95266843
    li x3, 0x95266843
    csrw 0x8a6, x3

    #Address 0x8a6 Write value 0xc6390025
    li x3, 0xc6390025
    csrw 0x8a6, x3

    #Unmapped address 0xed2 testing: random write/read operations
    #Address 0xed2 read value
    csrr x14, 0xed2

    #Address 0xed2 Write value 0xf826f15f
    li x3, 0xf826f15f
    csrw 0xed2, x3

    #Address 0xed2 Write value 0xd4e69cf7
    li x3, 0xd4e69cf7
    csrw 0xed2, x3

    #Address 0xed2 Write value 0x1570123a
    li x3, 0x1570123a
    csrw 0xed2, x3

    #Unmapped address 0xa58 testing: random write/read operations
    #Address 0xa58 read value
    csrr x14, 0xa58

    #Address 0xa58 read value
    csrr x14, 0xa58

    #Address 0xa58 Write value 0xc8ffa27
    li x3, 0xc8ffa27
    csrw 0xa58, x3

    #Address 0xa58 read value
    csrr x14, 0xa58

    #Unmapped address 0xc65 testing: random write/read operations
    #Address 0xc65 read value
    csrr x14, 0xc65

    #Unmapped address 0x6e6 testing: random write/read operations
    #Address 0x6e6 read value
    csrr x14, 0x6e6

    #Address 0x6e6 Write value 0xb5e4c8fe
    li x3, 0xb5e4c8fe
    csrw 0x6e6, x3

    #Address 0x6e6 Write value 0xe785ba1c
    li x3, 0xe785ba1c
    csrw 0x6e6, x3

    #Unmapped address 0xf8d testing: random write/read operations
    #Address 0xf8d Write value 0xb1e63d17
    li x3, 0xb1e63d17
    csrw 0xf8d, x3

    #Address 0xf8d Write value 0x68977032
    li x3, 0x68977032
    csrw 0xf8d, x3

    #Address 0xf8d Write value 0xfec1d67e
    li x3, 0xfec1d67e
    csrw 0xf8d, x3

    #Address 0xf8d read value
    csrr x14, 0xf8d

    #Unmapped address 0x14 testing: random write/read operations
    #Address 0x14 read value
    csrr x14, 0x14

    #Address 0x14 Write value 0x7ee817c
    li x3, 0x7ee817c
    csrw 0x14, x3

    #Address 0x14 Write value 0x5bf2941e
    li x3, 0x5bf2941e
    csrw 0x14, x3

    #Unmapped address 0x2ea testing: random write/read operations
    #Address 0x2ea read value
    csrr x14, 0x2ea

    #Address 0x2ea read value
    csrr x14, 0x2ea

    #Address 0x2ea Write value 0x96de7402
    li x3, 0x96de7402
    csrw 0x2ea, x3

    #Address 0x2ea Write value 0x5d53b2b
    li x3, 0x5d53b2b
    csrw 0x2ea, x3

    #Unmapped address 0x9f9 testing: random write/read operations
    #Address 0x9f9 read value
    csrr x14, 0x9f9

    #Address 0x9f9 read value
    csrr x14, 0x9f9

    #Address 0x9f9 Write value 0xa4d69ce9
    li x3, 0xa4d69ce9
    csrw 0x9f9, x3

    #Address 0x9f9 Write value 0x8e15d72f
    li x3, 0x8e15d72f
    csrw 0x9f9, x3

    #Address 0x9f9 Write value 0x6fb94543
    li x3, 0x6fb94543
    csrw 0x9f9, x3

    #Unmapped address 0x69a testing: random write/read operations
    #Address 0x69a read value
    csrr x14, 0x69a

    #Address 0x69a read value
    csrr x14, 0x69a

    #Unmapped address 0xff3 testing: random write/read operations
    #Address 0xff3 read value
    csrr x14, 0xff3

    #Address 0xff3 read value
    csrr x14, 0xff3

    #Address 0xff3 Write value 0xaa501d9
    li x3, 0xaa501d9
    csrw 0xff3, x3

    #Address 0xff3 Write value 0xad43d353
    li x3, 0xad43d353
    csrw 0xff3, x3

    #Unmapped address 0xfb1 testing: random write/read operations
    #Address 0xfb1 Write value 0x6cdf5455
    li x3, 0x6cdf5455
    csrw 0xfb1, x3

    #Address 0xfb1 Write value 0xdac1573f
    li x3, 0xdac1573f
    csrw 0xfb1, x3

    #Address 0xfb1 Write value 0xfcd11afa
    li x3, 0xfcd11afa
    csrw 0xfb1, x3

    #Address 0xfb1 read value
    csrr x14, 0xfb1

    #Unmapped address 0x6b testing: random write/read operations
    #Address 0x6b Write value 0x6e0ea2ab
    li x3, 0x6e0ea2ab
    csrw 0x6b, x3

    #Address 0x6b read value
    csrr x14, 0x6b

    #Unmapped address 0x4bf testing: random write/read operations
    #Address 0x4bf Write value 0xe42f50fa
    li x3, 0xe42f50fa
    csrw 0x4bf, x3

    #Address 0x4bf Write value 0x81162882
    li x3, 0x81162882
    csrw 0x4bf, x3

    #Address 0x4bf Write value 0x7d0d95eb
    li x3, 0x7d0d95eb
    csrw 0x4bf, x3

    #Unmapped address 0x615 testing: random write/read operations
    #Address 0x615 Write value 0x122362d6
    li x3, 0x122362d6
    csrw 0x615, x3

    #Unmapped address 0xefd testing: random write/read operations
    #Address 0xefd read value
    csrr x14, 0xefd

    #Address 0xefd read value
    csrr x14, 0xefd

    #Address 0xefd read value
    csrr x14, 0xefd

    #Unmapped address 0x20 testing: random write/read operations
    #Address 0x20 Write value 0x45810cef
    li x3, 0x45810cef
    csrw 0x20, x3

    #Address 0x20 read value
    csrr x14, 0x20

    #Address 0x20 read value
    csrr x14, 0x20

    #Unmapped address 0x4c1 testing: random write/read operations
    #Address 0x4c1 read value
    csrr x14, 0x4c1

    #Unmapped address 0xbab testing: random write/read operations
    #Address 0xbab Write value 0x311078b8
    li x3, 0x311078b8
    csrw 0xbab, x3

    #Address 0xbab read value
    csrr x14, 0xbab

    #Address 0xbab Write value 0x748bfe31
    li x3, 0x748bfe31
    csrw 0xbab, x3

    #Unmapped address 0x666 testing: random write/read operations
    #Address 0x666 Write value 0x36629ae6
    li x3, 0x36629ae6
    csrw 0x666, x3

    #Unmapped address 0x6d1 testing: random write/read operations
    #Address 0x6d1 Write value 0x300f0228
    li x3, 0x300f0228
    csrw 0x6d1, x3

    #Address 0x6d1 read value
    csrr x14, 0x6d1

    #Address 0x6d1 Write value 0xd8f6e3ae
    li x3, 0xd8f6e3ae
    csrw 0x6d1, x3

    #Address 0x6d1 read value
    csrr x14, 0x6d1

    #Address 0x6d1 read value
    csrr x14, 0x6d1

    #Unmapped address 0x9d6 testing: random write/read operations
    #Address 0x9d6 read value
    csrr x14, 0x9d6

    #Unmapped address 0x760 testing: random write/read operations
    #Address 0x760 read value
    csrr x14, 0x760

    #Address 0x760 read value
    csrr x14, 0x760

    #Address 0x760 Write value 0x95b3a51c
    li x3, 0x95b3a51c
    csrw 0x760, x3

    #Unmapped address 0x97d testing: random write/read operations
    #Address 0x97d Write value 0x7ce249a
    li x3, 0x7ce249a
    csrw 0x97d, x3

    #Address 0x97d read value
    csrr x14, 0x97d

    #Unmapped address 0xa9e testing: random write/read operations
    #Address 0xa9e read value
    csrr x14, 0xa9e

    #Address 0xa9e Write value 0xc66a946f
    li x3, 0xc66a946f
    csrw 0xa9e, x3

    #Address 0xa9e Write value 0xff3e4a99
    li x3, 0xff3e4a99
    csrw 0xa9e, x3

    #Unmapped address 0xc83 testing: random write/read operations
    #Address 0xc83 Write value 0xb2a6fb46
    li x3, 0xb2a6fb46
    csrw 0xc83, x3

    #Address 0xc83 read value
    csrr x14, 0xc83

    #Address 0xc83 Write value 0x596361ac
    li x3, 0x596361ac
    csrw 0xc83, x3

    #Unmapped address 0xfeb testing: random write/read operations
    #Address 0xfeb read value
    csrr x14, 0xfeb

    #Address 0xfeb read value
    csrr x14, 0xfeb

    #Address 0xfeb Write value 0xd6485773
    li x3, 0xd6485773
    csrw 0xfeb, x3

    #Address 0xfeb Write value 0x746d636a
    li x3, 0x746d636a
    csrw 0xfeb, x3

    #Unmapped address 0x7f5 testing: random write/read operations
    #Address 0x7f5 Write value 0xa00a6f8d
    li x3, 0xa00a6f8d
    csrw 0x7f5, x3

    #Address 0x7f5 Write value 0x529af47b
    li x3, 0x529af47b
    csrw 0x7f5, x3

    #Address 0x7f5 read value
    csrr x14, 0x7f5

    #Address 0x7f5 Write value 0x8281985c
    li x3, 0x8281985c
    csrw 0x7f5, x3

    #Address 0x7f5 read value
    csrr x14, 0x7f5

    #Unmapped address 0x88e testing: random write/read operations
    #Address 0x88e read value
    csrr x14, 0x88e

    #Unmapped address 0xddb testing: random write/read operations
    #Address 0xddb read value
    csrr x14, 0xddb

    #Address 0xddb read value
    csrr x14, 0xddb

    #Address 0xddb read value
    csrr x14, 0xddb

    #Unmapped address 0x763 testing: random write/read operations
    #Address 0x763 read value
    csrr x14, 0x763

    #Address 0x763 read value
    csrr x14, 0x763

    #Address 0x763 Write value 0x8b158aa
    li x3, 0x8b158aa
    csrw 0x763, x3

    #Address 0x763 read value
    csrr x14, 0x763

    #Address 0x763 read value
    csrr x14, 0x763

    #Unmapped address 0x405 testing: random write/read operations
    #Address 0x405 Write value 0x5ed1dd60
    li x3, 0x5ed1dd60
    csrw 0x405, x3

    #Address 0x405 read value
    csrr x14, 0x405

    #Address 0x405 read value
    csrr x14, 0x405

    #Address 0x405 read value
    csrr x14, 0x405

    #Unmapped address 0x1d5 testing: random write/read operations
    #Address 0x1d5 Write value 0xeeadb2ee
    li x3, 0xeeadb2ee
    csrw 0x1d5, x3

    #Address 0x1d5 Write value 0xf063df49
    li x3, 0xf063df49
    csrw 0x1d5, x3

    #Address 0x1d5 Write value 0x885e4b33
    li x3, 0x885e4b33
    csrw 0x1d5, x3

    #Unmapped address 0x6ae testing: random write/read operations
    #Address 0x6ae read value
    csrr x14, 0x6ae

    #Address 0x6ae Write value 0xa1e09642
    li x3, 0xa1e09642
    csrw 0x6ae, x3

    #Address 0x6ae Write value 0x5927713d
    li x3, 0x5927713d
    csrw 0x6ae, x3

    #Unmapped address 0x88 testing: random write/read operations
    #Address 0x88 Write value 0x7ed2043d
    li x3, 0x7ed2043d
    csrw 0x88, x3

    #Address 0x88 Write value 0x76e71d60
    li x3, 0x76e71d60
    csrw 0x88, x3

    #Address 0x88 read value
    csrr x14, 0x88

    #Unmapped address 0xd50 testing: random write/read operations
    #Address 0xd50 Write value 0xacd34b3e
    li x3, 0xacd34b3e
    csrw 0xd50, x3

    #Unmapped address 0x950 testing: random write/read operations
    #Address 0x950 Write value 0x1439730
    li x3, 0x1439730
    csrw 0x950, x3

    #Address 0x950 read value
    csrr x14, 0x950

    #Unmapped address 0x628 testing: random write/read operations
    #Address 0x628 read value
    csrr x14, 0x628

    #Address 0x628 Write value 0xfc623765
    li x3, 0xfc623765
    csrw 0x628, x3

    #Address 0x628 Write value 0xa283d3e0
    li x3, 0xa283d3e0
    csrw 0x628, x3

    #Unmapped address 0xf4d testing: random write/read operations
    #Address 0xf4d Write value 0x65ba42d7
    li x3, 0x65ba42d7
    csrw 0xf4d, x3

    #Address 0xf4d Write value 0x55150d90
    li x3, 0x55150d90
    csrw 0xf4d, x3

    #Address 0xf4d read value
    csrr x14, 0xf4d

    #Unmapped address 0xcd7 testing: random write/read operations
    #Address 0xcd7 Write value 0x5b7324d1
    li x3, 0x5b7324d1
    csrw 0xcd7, x3

    #Address 0xcd7 read value
    csrr x14, 0xcd7

    #Unmapped address 0xa1 testing: random write/read operations
    #Address 0xa1 Write value 0xcc90016
    li x3, 0xcc90016
    csrw 0xa1, x3

    #Address 0xa1 Write value 0xc21a453
    li x3, 0xc21a453
    csrw 0xa1, x3

    #Address 0xa1 Write value 0xe3fcb12b
    li x3, 0xe3fcb12b
    csrw 0xa1, x3

    #Unmapped address 0xc7c testing: random write/read operations
    #Address 0xc7c read value
    csrr x14, 0xc7c

    #Unmapped address 0x959 testing: random write/read operations
    #Address 0x959 Write value 0xc658ac29
    li x3, 0xc658ac29
    csrw 0x959, x3

    #Address 0x959 Write value 0x44fa898e
    li x3, 0x44fa898e
    csrw 0x959, x3

    #Address 0x959 read value
    csrr x14, 0x959

    #Unmapped address 0x15 testing: random write/read operations
    #Address 0x15 read value
    csrr x14, 0x15

    #Address 0x15 read value
    csrr x14, 0x15

    #Unmapped address 0x52 testing: random write/read operations
    #Address 0x52 read value
    csrr x14, 0x52

    #Address 0x52 read value
    csrr x14, 0x52

    #Address 0x52 Write value 0x89be1cf3
    li x3, 0x89be1cf3
    csrw 0x52, x3

    #Address 0x52 Write value 0x6ffed205
    li x3, 0x6ffed205
    csrw 0x52, x3

    #Address 0x52 read value
    csrr x14, 0x52

    #Unmapped address 0x4ff testing: random write/read operations
    #Address 0x4ff Write value 0xeed1ffdf
    li x3, 0xeed1ffdf
    csrw 0x4ff, x3

    #Address 0x4ff Write value 0x1c79bac
    li x3, 0x1c79bac
    csrw 0x4ff, x3

    #Address 0x4ff Write value 0x8e7cdec
    li x3, 0x8e7cdec
    csrw 0x4ff, x3

    #Address 0x4ff Write value 0xb80a03fe
    li x3, 0xb80a03fe
    csrw 0x4ff, x3

    #Address 0x4ff read value
    csrr x14, 0x4ff

    #Unmapped address 0x9a7 testing: random write/read operations
    #Address 0x9a7 read value
    csrr x14, 0x9a7

    #Address 0x9a7 Write value 0xc3ab0a95
    li x3, 0xc3ab0a95
    csrw 0x9a7, x3

    #Unmapped address 0x386 testing: random write/read operations
    #Address 0x386 read value
    csrr x14, 0x386

    #Unmapped address 0x9a5 testing: random write/read operations
    #Address 0x9a5 read value
    csrr x14, 0x9a5

    #Address 0x9a5 Write value 0x25c63ec5
    li x3, 0x25c63ec5
    csrw 0x9a5, x3

    #Address 0x9a5 read value
    csrr x14, 0x9a5

    #Unmapped address 0xb4d testing: random write/read operations
    #Address 0xb4d Write value 0x654ad40
    li x3, 0x654ad40
    csrw 0xb4d, x3

    #Address 0xb4d Write value 0x5466a86
    li x3, 0x5466a86
    csrw 0xb4d, x3

    #Address 0xb4d read value
    csrr x14, 0xb4d

    #Address 0xb4d read value
    csrr x14, 0xb4d

    #Address 0xb4d Write value 0xfdebcf56
    li x3, 0xfdebcf56
    csrw 0xb4d, x3

    #Unmapped address 0x402 testing: random write/read operations
    #Address 0x402 read value
    csrr x14, 0x402

    #Address 0x402 Write value 0xe74c8d0e
    li x3, 0xe74c8d0e
    csrw 0x402, x3

    #Unmapped address 0xae7 testing: random write/read operations
    #Address 0xae7 read value
    csrr x14, 0xae7

    #Address 0xae7 read value
    csrr x14, 0xae7

    #Address 0xae7 Write value 0x660a8fac
    li x3, 0x660a8fac
    csrw 0xae7, x3

    #Address 0xae7 Write value 0x349f448d
    li x3, 0x349f448d
    csrw 0xae7, x3

    #Address 0xae7 read value
    csrr x14, 0xae7

    #Unmapped address 0xe8a testing: random write/read operations
    #Address 0xe8a read value
    csrr x14, 0xe8a

    #Address 0xe8a read value
    csrr x14, 0xe8a

    #Unmapped address 0xbf0 testing: random write/read operations
    #Address 0xbf0 Write value 0xf60bf0c1
    li x3, 0xf60bf0c1
    csrw 0xbf0, x3

    #Address 0xbf0 read value
    csrr x14, 0xbf0

    #Unmapped address 0xabc testing: random write/read operations
    #Address 0xabc Write value 0x24216f9f
    li x3, 0x24216f9f
    csrw 0xabc, x3

    #Address 0xabc read value
    csrr x14, 0xabc

    #Address 0xabc read value
    csrr x14, 0xabc

    #Address 0xabc read value
    csrr x14, 0xabc

    #Unmapped address 0x67d testing: random write/read operations
    #Address 0x67d Write value 0xd262e9b
    li x3, 0xd262e9b
    csrw 0x67d, x3

    #Address 0x67d read value
    csrr x14, 0x67d

    #Address 0x67d Write value 0x710fd324
    li x3, 0x710fd324
    csrw 0x67d, x3

    #Address 0x67d Write value 0x4052fe7a
    li x3, 0x4052fe7a
    csrw 0x67d, x3

    #Address 0x67d Write value 0x83eb4f25
    li x3, 0x83eb4f25
    csrw 0x67d, x3

    #Unmapped address 0x8ce testing: random write/read operations
    #Address 0x8ce read value
    csrr x14, 0x8ce

    #Address 0x8ce read value
    csrr x14, 0x8ce

    #Address 0x8ce Write value 0x370a4ab0
    li x3, 0x370a4ab0
    csrw 0x8ce, x3

    #Unmapped address 0x4d5 testing: random write/read operations
    #Address 0x4d5 read value
    csrr x14, 0x4d5

    #Unmapped address 0xceb testing: random write/read operations
    #Address 0xceb Write value 0xf8b35241
    li x3, 0xf8b35241
    csrw 0xceb, x3

    #Address 0xceb Write value 0x36e376f3
    li x3, 0x36e376f3
    csrw 0xceb, x3

    #Address 0xceb read value
    csrr x14, 0xceb

    #Mapped address 0xb85 (mhpmcounterh5) testing: random write/read operations
    #Address 0xb85 Write value 0xe8b1f93a
    li x3, 0xe8b1f93a
    csrw 0xb85, x3

    #Address 0xb85 Write value 0x52963901
    li x3, 0x52963901
    csrw 0xb85, x3

    #Unmapped address 0x7c2 testing: random write/read operations
    #Address 0x7c2 read value
    csrr x14, 0x7c2

    #Address 0x7c2 Write value 0xa885a5f1
    li x3, 0xa885a5f1
    csrw 0x7c2, x3

    #Address 0x7c2 Write value 0x77253319
    li x3, 0x77253319
    csrw 0x7c2, x3

    #Address 0x7c2 read value
    csrr x14, 0x7c2

    #Address 0x7c2 read value
    csrr x14, 0x7c2

    #Unmapped address 0x17b testing: random write/read operations
    #Address 0x17b read value
    csrr x14, 0x17b

    #Address 0x17b Write value 0xff0be28a
    li x3, 0xff0be28a
    csrw 0x17b, x3

    #Unmapped address 0x732 testing: random write/read operations
    #Address 0x732 read value
    csrr x14, 0x732

    #Address 0x732 read value
    csrr x14, 0x732

    #Unmapped address 0xa92 testing: random write/read operations
    #Address 0xa92 Write value 0x5b15071d
    li x3, 0x5b15071d
    csrw 0xa92, x3

    #Address 0xa92 Write value 0xc1de8bca
    li x3, 0xc1de8bca
    csrw 0xa92, x3

    #Unmapped address 0xe8b testing: random write/read operations
    #Address 0xe8b read value
    csrr x14, 0xe8b

    #Address 0xe8b read value
    csrr x14, 0xe8b

    #Address 0xe8b Write value 0x689f1e72
    li x3, 0x689f1e72
    csrw 0xe8b, x3

    #Unmapped address 0x820 testing: random write/read operations
    #Address 0x820 read value
    csrr x14, 0x820

    #Address 0x820 read value
    csrr x14, 0x820

    #Address 0x820 read value
    csrr x14, 0x820

    #Address 0x820 read value
    csrr x14, 0x820

    #Unmapped address 0xa17 testing: random write/read operations
    #Address 0xa17 Write value 0xae3540d4
    li x3, 0xae3540d4
    csrw 0xa17, x3

    #Unmapped address 0x23e testing: random write/read operations
    #Address 0x23e read value
    csrr x14, 0x23e

    #Address 0x23e Write value 0xf1ad20d5
    li x3, 0xf1ad20d5
    csrw 0x23e, x3

    #Address 0x23e read value
    csrr x14, 0x23e

    #Unmapped address 0x435 testing: random write/read operations
    #Address 0x435 read value
    csrr x14, 0x435

    #Address 0x435 read value
    csrr x14, 0x435

    #Address 0x435 Write value 0xea65b205
    li x3, 0xea65b205
    csrw 0x435, x3

    #Address 0x435 Write value 0x51b40cba
    li x3, 0x51b40cba
    csrw 0x435, x3

    #Address 0x435 Write value 0x8a2beb7c
    li x3, 0x8a2beb7c
    csrw 0x435, x3

    #Unmapped address 0xc4e testing: random write/read operations
    #Address 0xc4e Write value 0xe8c36599
    li x3, 0xe8c36599
    csrw 0xc4e, x3

    #Address 0xc4e read value
    csrr x14, 0xc4e

    #Address 0xc4e read value
    csrr x14, 0xc4e

    #Address 0xc4e Write value 0x8095ac53
    li x3, 0x8095ac53
    csrw 0xc4e, x3

    #Address 0xc4e Write value 0x711fe9f8
    li x3, 0x711fe9f8
    csrw 0xc4e, x3

    #Unmapped address 0x9aa testing: random write/read operations
    #Address 0x9aa read value
    csrr x14, 0x9aa

    #Address 0x9aa Write value 0x17518cf6
    li x3, 0x17518cf6
    csrw 0x9aa, x3

    #Mapped address 0x3b0 (pmpaddr0) testing: random write/read operations
    #Address 0x3b0 Write value 0x802b6d5f
    li x3, 0x802b6d5f
    csrw 0x3b0, x3

    #Address 0x3b0 Write value 0x3a61699c
    li x3, 0x3a61699c
    csrw 0x3b0, x3

    #Unmapped address 0x680 testing: random write/read operations
    #Address 0x680 Write value 0x8174e41d
    li x3, 0x8174e41d
    csrw 0x680, x3

    #Address 0x680 read value
    csrr x14, 0x680

    #Address 0x680 read value
    csrr x14, 0x680

    #Address 0x680 Write value 0x84fecf5c
    li x3, 0x84fecf5c
    csrw 0x680, x3

    #Address 0x680 read value
    csrr x14, 0x680

    #Unmapped address 0x318 testing: random write/read operations
    #Address 0x318 read value
    csrr x14, 0x318

    #Address 0x318 Write value 0xbfac949a
    li x3, 0xbfac949a
    csrw 0x318, x3

    #Address 0x318 Write value 0x70ab8ef5
    li x3, 0x70ab8ef5
    csrw 0x318, x3

    #Address 0x318 Write value 0x60efb7cd
    li x3, 0x60efb7cd
    csrw 0x318, x3

    #Unmapped address 0x542 testing: random write/read operations
    #Address 0x542 read value
    csrr x14, 0x542

    #Address 0x542 read value
    csrr x14, 0x542

    #Address 0x542 Write value 0x96e9d7bc
    li x3, 0x96e9d7bc
    csrw 0x542, x3

    #Address 0x542 read value
    csrr x14, 0x542

    #Unmapped address 0x68e testing: random write/read operations
    #Address 0x68e read value
    csrr x14, 0x68e

    #Address 0x68e read value
    csrr x14, 0x68e

    #Unmapped address 0x997 testing: random write/read operations
    #Address 0x997 Write value 0x538e6e4f
    li x3, 0x538e6e4f
    csrw 0x997, x3

    #Address 0x997 read value
    csrr x14, 0x997

    #Address 0x997 Write value 0x9f1d4d8a
    li x3, 0x9f1d4d8a
    csrw 0x997, x3

    #Unmapped address 0x6a0 testing: random write/read operations
    #Address 0x6a0 Write value 0x26ba1dc5
    li x3, 0x26ba1dc5
    csrw 0x6a0, x3

    #Address 0x6a0 read value
    csrr x14, 0x6a0

    #Unmapped address 0x135 testing: random write/read operations
    #Address 0x135 read value
    csrr x14, 0x135

    #Address 0x135 read value
    csrr x14, 0x135

    #Unmapped address 0x9ab testing: random write/read operations
    #Address 0x9ab read value
    csrr x14, 0x9ab

    #Address 0x9ab Write value 0x4c1f339d
    li x3, 0x4c1f339d
    csrw 0x9ab, x3

    #Address 0x9ab Write value 0xe90c9a39
    li x3, 0xe90c9a39
    csrw 0x9ab, x3

    #Address 0x9ab Write value 0xc04e5a2f
    li x3, 0xc04e5a2f
    csrw 0x9ab, x3

    #Address 0x9ab Write value 0xcf67d63b
    li x3, 0xcf67d63b
    csrw 0x9ab, x3

    #Unmapped address 0x4d testing: random write/read operations
    #Address 0x4d Write value 0x8d139cb1
    li x3, 0x8d139cb1
    csrw 0x4d, x3

    #Address 0x4d read value
    csrr x14, 0x4d

    #Address 0x4d read value
    csrr x14, 0x4d

    #Address 0x4d read value
    csrr x14, 0x4d

    #Unmapped address 0x1f9 testing: random write/read operations
    #Address 0x1f9 read value
    csrr x14, 0x1f9

    #Address 0x1f9 read value
    csrr x14, 0x1f9

    #Address 0x1f9 Write value 0xaec1e463
    li x3, 0xaec1e463
    csrw 0x1f9, x3

    #Address 0x1f9 read value
    csrr x14, 0x1f9

    #Address 0x1f9 read value
    csrr x14, 0x1f9

    #Unmapped address 0xc5 testing: random write/read operations
    #Address 0xc5 read value
    csrr x14, 0xc5

    #Address 0xc5 Write value 0x729bc499
    li x3, 0x729bc499
    csrw 0xc5, x3

    #Address 0xc5 Write value 0xf4b0c5f9
    li x3, 0xf4b0c5f9
    csrw 0xc5, x3

    #Unmapped address 0xe28 testing: random write/read operations
    #Address 0xe28 Write value 0x3fb8f053
    li x3, 0x3fb8f053
    csrw 0xe28, x3

    #Address 0xe28 Write value 0x480a2e60
    li x3, 0x480a2e60
    csrw 0xe28, x3

    #Unmapped address 0xc0c testing: random write/read operations
    #Address 0xc0c read value
    csrr x14, 0xc0c

    #Address 0xc0c Write value 0x171d245c
    li x3, 0x171d245c
    csrw 0xc0c, x3

    #Address 0xc0c Write value 0x7c355656
    li x3, 0x7c355656
    csrw 0xc0c, x3

    #Address 0xc0c Write value 0x17fae362
    li x3, 0x17fae362
    csrw 0xc0c, x3

    #Unmapped address 0x2c0 testing: random write/read operations
    #Address 0x2c0 read value
    csrr x14, 0x2c0

    #Unmapped address 0xd0a testing: random write/read operations
    #Address 0xd0a read value
    csrr x14, 0xd0a

    #Unmapped address 0x92a testing: random write/read operations
    #Address 0x92a Write value 0x3da0d716
    li x3, 0x3da0d716
    csrw 0x92a, x3

    #Address 0x92a Write value 0x27bd1eea
    li x3, 0x27bd1eea
    csrw 0x92a, x3

    #Address 0x92a read value
    csrr x14, 0x92a

    #Address 0x92a read value
    csrr x14, 0x92a

    #Address 0x92a read value
    csrr x14, 0x92a

    #Unmapped address 0x5d6 testing: random write/read operations
    #Address 0x5d6 Write value 0x5104ba7b
    li x3, 0x5104ba7b
    csrw 0x5d6, x3

    #Address 0x5d6 read value
    csrr x14, 0x5d6

    #Unmapped address 0x936 testing: random write/read operations
    #Address 0x936 Write value 0x4c6f0ece
    li x3, 0x4c6f0ece
    csrw 0x936, x3

    #Address 0x936 Write value 0x9cd896db
    li x3, 0x9cd896db
    csrw 0x936, x3

    #Unmapped address 0xc66 testing: random write/read operations
    #Address 0xc66 Write value 0x38849d1a
    li x3, 0x38849d1a
    csrw 0xc66, x3

    #Address 0xc66 read value
    csrr x14, 0xc66

    #Mapped address 0xb9a (mhpmcounterh26) testing: random write/read operations
    #Address 0xb9a read value
    csrr x14, 0xb9a

    #Address 0xb9a read value
    csrr x14, 0xb9a

    #Unmapped address 0xa76 testing: random write/read operations
    #Address 0xa76 Write value 0xa40e63e7
    li x3, 0xa40e63e7
    csrw 0xa76, x3

    #Address 0xa76 Write value 0x22e1c5e4
    li x3, 0x22e1c5e4
    csrw 0xa76, x3

    #Address 0xa76 read value
    csrr x14, 0xa76

    #Unmapped address 0x958 testing: random write/read operations
    #Address 0x958 read value
    csrr x14, 0x958

    #Address 0x958 read value
    csrr x14, 0x958

    #Unmapped address 0xeac testing: random write/read operations
    #Address 0xeac read value
    csrr x14, 0xeac

    #Address 0xeac read value
    csrr x14, 0xeac

    #Address 0xeac read value
    csrr x14, 0xeac

    #Address 0xeac Write value 0x492562c
    li x3, 0x492562c
    csrw 0xeac, x3

    #Unmapped address 0xd37 testing: random write/read operations
    #Address 0xd37 read value
    csrr x14, 0xd37

    #Address 0xd37 read value
    csrr x14, 0xd37

    #Unmapped address 0xc4d testing: random write/read operations
    #Address 0xc4d Write value 0x513f884d
    li x3, 0x513f884d
    csrw 0xc4d, x3

    #Address 0xc4d Write value 0x9d886e67
    li x3, 0x9d886e67
    csrw 0xc4d, x3

    #Address 0xc4d read value
    csrr x14, 0xc4d

    #Address 0xc4d Write value 0xc0a71c6d
    li x3, 0xc0a71c6d
    csrw 0xc4d, x3

    #Address 0xc4d read value
    csrr x14, 0xc4d

    #Unmapped address 0xf38 testing: random write/read operations
    #Address 0xf38 Write value 0xa1ac911c
    li x3, 0xa1ac911c
    csrw 0xf38, x3

    #Address 0xf38 Write value 0xf2c8b063
    li x3, 0xf2c8b063
    csrw 0xf38, x3

    #Address 0xf38 Write value 0xcfc39d2e
    li x3, 0xcfc39d2e
    csrw 0xf38, x3

    #Address 0xf38 read value
    csrr x14, 0xf38

    #Address 0xf38 Write value 0x16fa09e5
    li x3, 0x16fa09e5
    csrw 0xf38, x3

    #Unmapped address 0x8cd testing: random write/read operations
    #Address 0x8cd Write value 0xc04e49c
    li x3, 0xc04e49c
    csrw 0x8cd, x3

    #Address 0x8cd read value
    csrr x14, 0x8cd

    #Address 0x8cd Write value 0x936c7da9
    li x3, 0x936c7da9
    csrw 0x8cd, x3

    #Address 0x8cd read value
    csrr x14, 0x8cd

    #Address 0x8cd Write value 0x5acbe814
    li x3, 0x5acbe814
    csrw 0x8cd, x3

    #Unmapped address 0x369 testing: random write/read operations
    #Address 0x369 read value
    csrr x14, 0x369

    #Address 0x369 Write value 0x5dfcc032
    li x3, 0x5dfcc032
    csrw 0x369, x3

    #Unmapped address 0x946 testing: random write/read operations
    #Address 0x946 Write value 0xdd72ff97
    li x3, 0xdd72ff97
    csrw 0x946, x3

    #Address 0x946 Write value 0x1b83a456
    li x3, 0x1b83a456
    csrw 0x946, x3

    #Unmapped address 0xefa testing: random write/read operations
    #Address 0xefa Write value 0xb7699f92
    li x3, 0xb7699f92
    csrw 0xefa, x3

    #Address 0xefa Write value 0x6d08453f
    li x3, 0x6d08453f
    csrw 0xefa, x3

    #Address 0xefa Write value 0x92ed466d
    li x3, 0x92ed466d
    csrw 0xefa, x3

    #Unmapped address 0x255 testing: random write/read operations
    #Address 0x255 Write value 0x8bbc8481
    li x3, 0x8bbc8481
    csrw 0x255, x3

    #Address 0x255 read value
    csrr x14, 0x255

    #Address 0x255 Write value 0x541e9f81
    li x3, 0x541e9f81
    csrw 0x255, x3

    #Address 0x255 read value
    csrr x14, 0x255

    #Unmapped address 0x1f4 testing: random write/read operations
    #Address 0x1f4 read value
    csrr x14, 0x1f4

    #Address 0x1f4 read value
    csrr x14, 0x1f4

    #Address 0x1f4 Write value 0x5f7c87dc
    li x3, 0x5f7c87dc
    csrw 0x1f4, x3

    #Address 0x1f4 read value
    csrr x14, 0x1f4

    #Address 0x1f4 Write value 0x966f1524
    li x3, 0x966f1524
    csrw 0x1f4, x3

    #Unmapped address 0x48b testing: random write/read operations
    #Address 0x48b read value
    csrr x14, 0x48b

    #Address 0x48b Write value 0xa43d26c6
    li x3, 0xa43d26c6
    csrw 0x48b, x3

    #Address 0x48b Write value 0x5c5c3807
    li x3, 0x5c5c3807
    csrw 0x48b, x3

    #Unmapped address 0x485 testing: random write/read operations
    #Address 0x485 Write value 0xa54859f8
    li x3, 0xa54859f8
    csrw 0x485, x3

    #Address 0x485 read value
    csrr x14, 0x485

    #Address 0x485 Write value 0xe99f0439
    li x3, 0xe99f0439
    csrw 0x485, x3

    #Address 0x485 Write value 0xef34688d
    li x3, 0xef34688d
    csrw 0x485, x3

    #Unmapped address 0x1ec testing: random write/read operations
    #Address 0x1ec Write value 0x1baebd08
    li x3, 0x1baebd08
    csrw 0x1ec, x3

    #Address 0x1ec Write value 0xedfe3e3b
    li x3, 0xedfe3e3b
    csrw 0x1ec, x3

    #Address 0x1ec read value
    csrr x14, 0x1ec

    #Address 0x1ec read value
    csrr x14, 0x1ec

    #Address 0x1ec Write value 0x86cd5f73
    li x3, 0x86cd5f73
    csrw 0x1ec, x3

    #Unmapped address 0xedd testing: random write/read operations
    #Address 0xedd Write value 0x495303c3
    li x3, 0x495303c3
    csrw 0xedd, x3

    #Address 0xedd Write value 0x6338bfcd
    li x3, 0x6338bfcd
    csrw 0xedd, x3

    #Address 0xedd read value
    csrr x14, 0xedd

    #Unmapped address 0x4d4 testing: random write/read operations
    #Address 0x4d4 read value
    csrr x14, 0x4d4

    #Unmapped address 0xc9d testing: random write/read operations
    #Address 0xc9d read value
    csrr x14, 0xc9d

    #Address 0xc9d read value
    csrr x14, 0xc9d

    #Address 0xc9d Write value 0xb15256d5
    li x3, 0xb15256d5
    csrw 0xc9d, x3

    #Unmapped address 0xa88 testing: random write/read operations
    #Address 0xa88 read value
    csrr x14, 0xa88

    #Unmapped address 0xfe testing: random write/read operations
    #Address 0xfe read value
    csrr x14, 0xfe

    #Address 0xfe Write value 0x7fbad15b
    li x3, 0x7fbad15b
    csrw 0xfe, x3

    #Unmapped address 0x38 testing: random write/read operations
    #Address 0x38 read value
    csrr x14, 0x38

    #Address 0x38 Write value 0x3e928589
    li x3, 0x3e928589
    csrw 0x38, x3

    #Address 0x38 Write value 0x595f8957
    li x3, 0x595f8957
    csrw 0x38, x3

    #Address 0x38 Write value 0xd430b2c7
    li x3, 0xd430b2c7
    csrw 0x38, x3

    #Address 0x38 Write value 0xb4c509ac
    li x3, 0xb4c509ac
    csrw 0x38, x3

    #Unmapped address 0xff4 testing: random write/read operations
    #Address 0xff4 Write value 0xb979dec
    li x3, 0xb979dec
    csrw 0xff4, x3

    #Address 0xff4 read value
    csrr x14, 0xff4

    #Address 0xff4 Write value 0x23d96822
    li x3, 0x23d96822
    csrw 0xff4, x3

    #Unmapped address 0x54e testing: random write/read operations
    #Address 0x54e read value
    csrr x14, 0x54e

    #Address 0x54e read value
    csrr x14, 0x54e

    #Address 0x54e read value
    csrr x14, 0x54e

    #Address 0x54e read value
    csrr x14, 0x54e

    #Address 0x54e read value
    csrr x14, 0x54e

    #Unmapped address 0xffc testing: random write/read operations
    #Address 0xffc Write value 0x1d4e492c
    li x3, 0x1d4e492c
    csrw 0xffc, x3

    #Address 0xffc Write value 0xc71b432e
    li x3, 0xc71b432e
    csrw 0xffc, x3

    #Address 0xffc read value
    csrr x14, 0xffc

    #Unmapped address 0xbbf testing: random write/read operations
    #Address 0xbbf read value
    csrr x14, 0xbbf

    #Address 0xbbf Write value 0x6c1986d2
    li x3, 0x6c1986d2
    csrw 0xbbf, x3

    #Address 0xbbf read value
    csrr x14, 0xbbf

    #Address 0xbbf read value
    csrr x14, 0xbbf

    #Unmapped address 0x5c testing: random write/read operations
    #Address 0x5c read value
    csrr x14, 0x5c

    #Address 0x5c Write value 0x4159256a
    li x3, 0x4159256a
    csrw 0x5c, x3

    #Address 0x5c read value
    csrr x14, 0x5c

    #Unmapped address 0xa60 testing: random write/read operations
    #Address 0xa60 Write value 0xa5d273c7
    li x3, 0xa5d273c7
    csrw 0xa60, x3

    #Unmapped address 0x9fe testing: random write/read operations
    #Address 0x9fe Write value 0x162d8cb4
    li x3, 0x162d8cb4
    csrw 0x9fe, x3

    #Address 0x9fe read value
    csrr x14, 0x9fe

    #Address 0x9fe read value
    csrr x14, 0x9fe

    #Address 0x9fe Write value 0x928eac77
    li x3, 0x928eac77
    csrw 0x9fe, x3

    #Address 0x9fe Write value 0x239c40ad
    li x3, 0x239c40ad
    csrw 0x9fe, x3

    #Unmapped address 0xa26 testing: random write/read operations
    #Address 0xa26 read value
    csrr x14, 0xa26

    #Address 0xa26 read value
    csrr x14, 0xa26

    #Address 0xa26 read value
    csrr x14, 0xa26

    #Address 0xa26 read value
    csrr x14, 0xa26

    #Address 0xa26 Write value 0x1c86065c
    li x3, 0x1c86065c
    csrw 0xa26, x3

    #Unmapped address 0x557 testing: random write/read operations
    #Address 0x557 Write value 0xcf3651bd
    li x3, 0xcf3651bd
    csrw 0x557, x3

    #Unmapped address 0x8bc testing: random write/read operations
    #Address 0x8bc Write value 0x22377da2
    li x3, 0x22377da2
    csrw 0x8bc, x3

    #Unmapped address 0x86e testing: random write/read operations
    #Address 0x86e Write value 0x90c157bb
    li x3, 0x90c157bb
    csrw 0x86e, x3

    #Unmapped address 0x88a testing: random write/read operations
    #Address 0x88a Write value 0xd3438bdc
    li x3, 0xd3438bdc
    csrw 0x88a, x3

    #Unmapped address 0xe1 testing: random write/read operations
    #Address 0xe1 read value
    csrr x14, 0xe1

    #Address 0xe1 read value
    csrr x14, 0xe1

    #Address 0xe1 read value
    csrr x14, 0xe1

    #Address 0xe1 read value
    csrr x14, 0xe1

    #Unmapped address 0x887 testing: random write/read operations
    #Address 0x887 read value
    csrr x14, 0x887

    #Address 0x887 read value
    csrr x14, 0x887

    #Address 0x887 read value
    csrr x14, 0x887

    #Address 0x887 read value
    csrr x14, 0x887

    #Unmapped address 0x71f testing: random write/read operations
    #Address 0x71f read value
    csrr x14, 0x71f

    #Address 0x71f Write value 0xda9267c
    li x3, 0xda9267c
    csrw 0x71f, x3

    #Address 0x71f read value
    csrr x14, 0x71f

    #Address 0x71f Write value 0x1cb24539
    li x3, 0x1cb24539
    csrw 0x71f, x3

    #Address 0x71f read value
    csrr x14, 0x71f

    #Unmapped address 0xa8b testing: random write/read operations
    #Address 0xa8b read value
    csrr x14, 0xa8b

    #Address 0xa8b read value
    csrr x14, 0xa8b

    #Address 0xa8b read value
    csrr x14, 0xa8b

    #Address 0xa8b read value
    csrr x14, 0xa8b

    #Unmapped address 0xc3f testing: random write/read operations
    #Address 0xc3f read value
    csrr x14, 0xc3f

    #Address 0xc3f read value
    csrr x14, 0xc3f

    #Address 0xc3f read value
    csrr x14, 0xc3f

    #Unmapped address 0xbe9 testing: random write/read operations
    #Address 0xbe9 Write value 0xa147bcc9
    li x3, 0xa147bcc9
    csrw 0xbe9, x3

    #Address 0xbe9 Write value 0xe4711634
    li x3, 0xe4711634
    csrw 0xbe9, x3

    #Address 0xbe9 Write value 0x84f496b8
    li x3, 0x84f496b8
    csrw 0xbe9, x3

    #Address 0xbe9 read value
    csrr x14, 0xbe9

    #Unmapped address 0xf44 testing: random write/read operations
    #Address 0xf44 Write value 0xa5eef7a2
    li x3, 0xa5eef7a2
    csrw 0xf44, x3

    #Address 0xf44 Write value 0xb5d607b8
    li x3, 0xb5d607b8
    csrw 0xf44, x3

    #Unmapped address 0x1a2 testing: random write/read operations
    #Address 0x1a2 Write value 0xc1cc525f
    li x3, 0xc1cc525f
    csrw 0x1a2, x3

    #Address 0x1a2 Write value 0x5b3befd2
    li x3, 0x5b3befd2
    csrw 0x1a2, x3

    #Address 0x1a2 read value
    csrr x14, 0x1a2

    #Unmapped address 0xd56 testing: random write/read operations
    #Address 0xd56 read value
    csrr x14, 0xd56

    #Address 0xd56 read value
    csrr x14, 0xd56

    #Address 0xd56 read value
    csrr x14, 0xd56

    #Address 0xd56 read value
    csrr x14, 0xd56

    #Address 0xd56 read value
    csrr x14, 0xd56

    #Unmapped address 0xae1 testing: random write/read operations
    #Address 0xae1 read value
    csrr x14, 0xae1

    #Unmapped address 0x629 testing: random write/read operations
    #Address 0x629 read value
    csrr x14, 0x629

    #Address 0x629 Write value 0xcd735914
    li x3, 0xcd735914
    csrw 0x629, x3

    #Address 0x629 read value
    csrr x14, 0x629

    #Address 0x629 read value
    csrr x14, 0x629

    #Address 0x629 Write value 0x3e8951a
    li x3, 0x3e8951a
    csrw 0x629, x3

    #Unmapped address 0xc11 testing: random write/read operations
    #Address 0xc11 Write value 0x2ae576ec
    li x3, 0x2ae576ec
    csrw 0xc11, x3

    #Address 0xc11 read value
    csrr x14, 0xc11

    #Address 0xc11 read value
    csrr x14, 0xc11

    #Address 0xc11 read value
    csrr x14, 0xc11

    #Address 0xc11 read value
    csrr x14, 0xc11

    #Unmapped address 0x6dd testing: random write/read operations
    #Address 0x6dd read value
    csrr x14, 0x6dd

    #Unmapped address 0xd15 testing: random write/read operations
    #Address 0xd15 read value
    csrr x14, 0xd15

    #Address 0xd15 Write value 0x99c720a
    li x3, 0x99c720a
    csrw 0xd15, x3

    #Address 0xd15 Write value 0x845124f7
    li x3, 0x845124f7
    csrw 0xd15, x3

    #Unmapped address 0x71a testing: random write/read operations
    #Address 0x71a read value
    csrr x14, 0x71a

    #Address 0x71a read value
    csrr x14, 0x71a

    #Address 0x71a read value
    csrr x14, 0x71a

    #Unmapped address 0xaad testing: random write/read operations
    #Address 0xaad Write value 0x2f5b2c
    li x3, 0x2f5b2c
    csrw 0xaad, x3

    #Unmapped address 0x1a9 testing: random write/read operations
    #Address 0x1a9 read value
    csrr x14, 0x1a9

    #Address 0x1a9 Write value 0x9e3d82bd
    li x3, 0x9e3d82bd
    csrw 0x1a9, x3

    #Address 0x1a9 Write value 0x6b7a99e3
    li x3, 0x6b7a99e3
    csrw 0x1a9, x3

    #Address 0x1a9 read value
    csrr x14, 0x1a9

    #Address 0x1a9 Write value 0x43961360
    li x3, 0x43961360
    csrw 0x1a9, x3

    #Unmapped address 0x6a1 testing: random write/read operations
    #Address 0x6a1 Write value 0x1a3964a4
    li x3, 0x1a3964a4
    csrw 0x6a1, x3

    #Address 0x6a1 read value
    csrr x14, 0x6a1

    #Unmapped address 0x1a5 testing: random write/read operations
    #Address 0x1a5 read value
    csrr x14, 0x1a5

    #Address 0x1a5 read value
    csrr x14, 0x1a5

    #Address 0x1a5 read value
    csrr x14, 0x1a5

    #Unmapped address 0xb7 testing: random write/read operations
    #Address 0xb7 Write value 0xd498f954
    li x3, 0xd498f954
    csrw 0xb7, x3

    #Unmapped address 0x7ea testing: random write/read operations
    #Address 0x7ea Write value 0x66ed61d1
    li x3, 0x66ed61d1
    csrw 0x7ea, x3

    #Address 0x7ea read value
    csrr x14, 0x7ea

    #Address 0x7ea read value
    csrr x14, 0x7ea

    #Address 0x7ea Write value 0x34b8d41e
    li x3, 0x34b8d41e
    csrw 0x7ea, x3

    #Unmapped address 0xb69 testing: random write/read operations
    #Address 0xb69 read value
    csrr x14, 0xb69

    #Address 0xb69 read value
    csrr x14, 0xb69

    #Address 0xb69 read value
    csrr x14, 0xb69

    #Unmapped address 0xa28 testing: random write/read operations
    #Address 0xa28 Write value 0x68c57449
    li x3, 0x68c57449
    csrw 0xa28, x3

    #Address 0xa28 read value
    csrr x14, 0xa28

    #Unmapped address 0x57a testing: random write/read operations
    #Address 0x57a Write value 0x83221818
    li x3, 0x83221818
    csrw 0x57a, x3

    #Address 0x57a read value
    csrr x14, 0x57a

    #Address 0x57a Write value 0x916bb447
    li x3, 0x916bb447
    csrw 0x57a, x3

    #Address 0x57a read value
    csrr x14, 0x57a

    #Unmapped address 0x750 testing: random write/read operations
    #Address 0x750 read value
    csrr x14, 0x750

    #Address 0x750 read value
    csrr x14, 0x750

    #Address 0x750 read value
    csrr x14, 0x750

    #Address 0x750 read value
    csrr x14, 0x750

    #Address 0x750 Write value 0x7044a8fc
    li x3, 0x7044a8fc
    csrw 0x750, x3

    #Unmapped address 0x894 testing: random write/read operations
    #Address 0x894 read value
    csrr x14, 0x894

    #Address 0x894 read value
    csrr x14, 0x894

    #Address 0x894 Write value 0x7a87e198
    li x3, 0x7a87e198
    csrw 0x894, x3

    #Address 0x894 read value
    csrr x14, 0x894

    #Address 0x894 Write value 0x1a575137
    li x3, 0x1a575137
    csrw 0x894, x3

    #Unmapped address 0x947 testing: random write/read operations
    #Address 0x947 read value
    csrr x14, 0x947

    #Unmapped address 0x1c3 testing: random write/read operations
    #Address 0x1c3 read value
    csrr x14, 0x1c3

    #Unmapped address 0xc4f testing: random write/read operations
    #Address 0xc4f Write value 0xd57e727d
    li x3, 0xd57e727d
    csrw 0xc4f, x3

    #Address 0xc4f Write value 0xb61e8bd1
    li x3, 0xb61e8bd1
    csrw 0xc4f, x3

    #Address 0xc4f Write value 0x5603aa3
    li x3, 0x5603aa3
    csrw 0xc4f, x3

    #Unmapped address 0xbfb testing: random write/read operations
    #Address 0xbfb read value
    csrr x14, 0xbfb

    #Address 0xbfb read value
    csrr x14, 0xbfb

    #Unmapped address 0x266 testing: random write/read operations
    #Address 0x266 Write value 0x47da1b43
    li x3, 0x47da1b43
    csrw 0x266, x3

    #Address 0x266 Write value 0x1815c62a
    li x3, 0x1815c62a
    csrw 0x266, x3

    #Unmapped address 0xb47 testing: random write/read operations
    #Address 0xb47 Write value 0x76b5ae27
    li x3, 0x76b5ae27
    csrw 0xb47, x3

    #Address 0xb47 Write value 0x98925e7a
    li x3, 0x98925e7a
    csrw 0xb47, x3

    #Address 0xb47 read value
    csrr x14, 0xb47

    #Unmapped address 0x111 testing: random write/read operations
    #Address 0x111 Write value 0xba6f6e7d
    li x3, 0xba6f6e7d
    csrw 0x111, x3

    #Address 0x111 Write value 0x9286762b
    li x3, 0x9286762b
    csrw 0x111, x3

    #Address 0x111 Write value 0xac9a6b1e
    li x3, 0xac9a6b1e
    csrw 0x111, x3

    #Address 0x111 Write value 0xe2bc60f2
    li x3, 0xe2bc60f2
    csrw 0x111, x3

    #Address 0x111 Write value 0xc8f9280c
    li x3, 0xc8f9280c
    csrw 0x111, x3

    #Unmapped address 0x41a testing: random write/read operations
    #Address 0x41a read value
    csrr x14, 0x41a

    #Address 0x41a Write value 0x270c8d30
    li x3, 0x270c8d30
    csrw 0x41a, x3

    #Address 0x41a Write value 0xcf680fe2
    li x3, 0xcf680fe2
    csrw 0x41a, x3

    #Unmapped address 0x712 testing: random write/read operations
    #Address 0x712 Write value 0x2e4944
    li x3, 0x2e4944
    csrw 0x712, x3

    #Address 0x712 read value
    csrr x14, 0x712

    #Unmapped address 0x866 testing: random write/read operations
    #Address 0x866 read value
    csrr x14, 0x866

    #Address 0x866 read value
    csrr x14, 0x866

    #Address 0x866 Write value 0x2340517e
    li x3, 0x2340517e
    csrw 0x866, x3

    #Address 0x866 Write value 0xc02d8a7a
    li x3, 0xc02d8a7a
    csrw 0x866, x3

    #Address 0x866 Write value 0x3d5b4150
    li x3, 0x3d5b4150
    csrw 0x866, x3

    #Unmapped address 0x151 testing: random write/read operations
    #Address 0x151 Write value 0x860ba535
    li x3, 0x860ba535
    csrw 0x151, x3

    #Address 0x151 Write value 0xd21b3b6f
    li x3, 0xd21b3b6f
    csrw 0x151, x3

    #Address 0x151 read value
    csrr x14, 0x151

    #Address 0x151 Write value 0x6f3d7dfe
    li x3, 0x6f3d7dfe
    csrw 0x151, x3

    #Address 0x151 Write value 0x76d584c0
    li x3, 0x76d584c0
    csrw 0x151, x3

    #Unmapped address 0x495 testing: random write/read operations
    #Address 0x495 read value
    csrr x14, 0x495

    #Address 0x495 Write value 0xaefc1e33
    li x3, 0xaefc1e33
    csrw 0x495, x3

    #Address 0x495 read value
    csrr x14, 0x495

    #Unmapped address 0xbdf testing: random write/read operations
    #Address 0xbdf Write value 0xe957bb3d
    li x3, 0xe957bb3d
    csrw 0xbdf, x3

    #Address 0xbdf read value
    csrr x14, 0xbdf

    #Unmapped address 0x908 testing: random write/read operations
    #Address 0x908 Write value 0xa5bffd3c
    li x3, 0xa5bffd3c
    csrw 0x908, x3

    #Address 0x908 Write value 0x5828f52f
    li x3, 0x5828f52f
    csrw 0x908, x3

    #Address 0x908 read value
    csrr x14, 0x908

    #Address 0x908 read value
    csrr x14, 0x908

    #Unmapped address 0xe91 testing: random write/read operations
    #Address 0xe91 Write value 0x358d9556
    li x3, 0x358d9556
    csrw 0xe91, x3

    #Address 0xe91 read value
    csrr x14, 0xe91

    #Address 0xe91 read value
    csrr x14, 0xe91

    #Unmapped address 0xe6c testing: random write/read operations
    #Address 0xe6c read value
    csrr x14, 0xe6c

    #Address 0xe6c read value
    csrr x14, 0xe6c

    #Address 0xe6c Write value 0x9276c40b
    li x3, 0x9276c40b
    csrw 0xe6c, x3

    #Unmapped address 0x1d testing: random write/read operations
    #Address 0x1d read value
    csrr x14, 0x1d

    #Address 0x1d Write value 0x9f1ed560
    li x3, 0x9f1ed560
    csrw 0x1d, x3

    #Address 0x1d read value
    csrr x14, 0x1d

    #Unmapped address 0x8aa testing: random write/read operations
    #Address 0x8aa Write value 0x9e2bdf7e
    li x3, 0x9e2bdf7e
    csrw 0x8aa, x3

    #Address 0x8aa Write value 0x2b15044e
    li x3, 0x2b15044e
    csrw 0x8aa, x3

    #Address 0x8aa read value
    csrr x14, 0x8aa

    #Unmapped address 0x9a0 testing: random write/read operations
    #Address 0x9a0 read value
    csrr x14, 0x9a0

    #Address 0x9a0 Write value 0x861d302c
    li x3, 0x861d302c
    csrw 0x9a0, x3

    #Unmapped address 0xa8 testing: random write/read operations
    #Address 0xa8 read value
    csrr x14, 0xa8

    #Address 0xa8 read value
    csrr x14, 0xa8

    #Address 0xa8 read value
    csrr x14, 0xa8

    #Unmapped address 0xa7b testing: random write/read operations
    #Address 0xa7b Write value 0x217ca670
    li x3, 0x217ca670
    csrw 0xa7b, x3

    #Address 0xa7b Write value 0xf95d5d4b
    li x3, 0xf95d5d4b
    csrw 0xa7b, x3

    #Address 0xa7b Write value 0x93aca1f
    li x3, 0x93aca1f
    csrw 0xa7b, x3

    #Unmapped address 0xcf1 testing: random write/read operations
    #Address 0xcf1 read value
    csrr x14, 0xcf1

    #Address 0xcf1 read value
    csrr x14, 0xcf1

    #Address 0xcf1 Write value 0xec26fb44
    li x3, 0xec26fb44
    csrw 0xcf1, x3

    #Address 0xcf1 Write value 0x29efdab
    li x3, 0x29efdab
    csrw 0xcf1, x3

    #Address 0xcf1 Write value 0x98e739d
    li x3, 0x98e739d
    csrw 0xcf1, x3

    #Unmapped address 0x78f testing: random write/read operations
    #Address 0x78f Write value 0xbd817b20
    li x3, 0xbd817b20
    csrw 0x78f, x3

    #Unmapped address 0x876 testing: random write/read operations
    #Address 0x876 Write value 0xa1bf4df0
    li x3, 0xa1bf4df0
    csrw 0x876, x3

    #Address 0x876 Write value 0x7a0990a8
    li x3, 0x7a0990a8
    csrw 0x876, x3

    #Address 0x876 Write value 0xa3bb61d6
    li x3, 0xa3bb61d6
    csrw 0x876, x3

    #Unmapped address 0x538 testing: random write/read operations
    #Address 0x538 read value
    csrr x14, 0x538

    #Address 0x538 Write value 0xcee7ff8e
    li x3, 0xcee7ff8e
    csrw 0x538, x3

    #Address 0x538 read value
    csrr x14, 0x538

    #Address 0x538 Write value 0x3f40fee
    li x3, 0x3f40fee
    csrw 0x538, x3

    #Address 0x538 Write value 0x5bc6d695
    li x3, 0x5bc6d695
    csrw 0x538, x3

    #Unmapped address 0xae0 testing: random write/read operations
    #Address 0xae0 read value
    csrr x14, 0xae0

    #Address 0xae0 Write value 0x56bd46ff
    li x3, 0x56bd46ff
    csrw 0xae0, x3

    #Unmapped address 0x3c0 testing: random write/read operations
    #Address 0x3c0 Write value 0x8dcba413
    li x3, 0x8dcba413
    csrw 0x3c0, x3

    #Unmapped address 0x50a testing: random write/read operations
    #Address 0x50a Write value 0x55db8b3a
    li x3, 0x55db8b3a
    csrw 0x50a, x3

    #Address 0x50a read value
    csrr x14, 0x50a

    #Address 0x50a read value
    csrr x14, 0x50a

    #Address 0x50a Write value 0xba907013
    li x3, 0xba907013
    csrw 0x50a, x3

    #Address 0x50a Write value 0x4ba3e032
    li x3, 0x4ba3e032
    csrw 0x50a, x3

    #Unmapped address 0xd94 testing: random write/read operations
    #Address 0xd94 Write value 0x91970c8d
    li x3, 0x91970c8d
    csrw 0xd94, x3

    #Address 0xd94 read value
    csrr x14, 0xd94

    #Address 0xd94 read value
    csrr x14, 0xd94

    #Unmapped address 0xd98 testing: random write/read operations
    #Address 0xd98 read value
    csrr x14, 0xd98

    #Address 0xd98 read value
    csrr x14, 0xd98

    #Mapped address 0x3b8 (pmpaddr8) testing: random write/read operations
    #Address 0x3b8 read value
    csrr x14, 0x3b8

    #Address 0x3b8 Write value 0x4efcef3d
    li x3, 0x4efcef3d
    csrw 0x3b8, x3

    #Address 0x3b8 Write value 0x83d059fa
    li x3, 0x83d059fa
    csrw 0x3b8, x3

    #Address 0x3b8 Write value 0xa562a271
    li x3, 0xa562a271
    csrw 0x3b8, x3

    #Address 0x3b8 read value
    csrr x14, 0x3b8

    #Unmapped address 0x98b testing: random write/read operations
    #Address 0x98b Write value 0xc342ebcd
    li x3, 0xc342ebcd
    csrw 0x98b, x3

    #Address 0x98b read value
    csrr x14, 0x98b

    #Address 0x98b read value
    csrr x14, 0x98b

    #Unmapped address 0x3c1 testing: random write/read operations
    #Address 0x3c1 Write value 0x4f0e989f
    li x3, 0x4f0e989f
    csrw 0x3c1, x3

    #Address 0x3c1 read value
    csrr x14, 0x3c1

    #Address 0x3c1 Write value 0x4908a75d
    li x3, 0x4908a75d
    csrw 0x3c1, x3

    #Address 0x3c1 read value
    csrr x14, 0x3c1

    #Address 0x3c1 read value
    csrr x14, 0x3c1

    #Unmapped address 0x584 testing: random write/read operations
    #Address 0x584 read value
    csrr x14, 0x584

    #Unmapped address 0xcf9 testing: random write/read operations
    #Address 0xcf9 read value
    csrr x14, 0xcf9

    #Address 0xcf9 read value
    csrr x14, 0xcf9

    #Address 0xcf9 read value
    csrr x14, 0xcf9

    #Address 0xcf9 read value
    csrr x14, 0xcf9

    #Unmapped address 0x8ed testing: random write/read operations
    #Address 0x8ed read value
    csrr x14, 0x8ed

    #Address 0x8ed read value
    csrr x14, 0x8ed

    #Address 0x8ed read value
    csrr x14, 0x8ed

    #Address 0x8ed read value
    csrr x14, 0x8ed

    #Address 0x8ed read value
    csrr x14, 0x8ed

    #Unmapped address 0xe7 testing: random write/read operations
    #Address 0xe7 Write value 0x97d2765d
    li x3, 0x97d2765d
    csrw 0xe7, x3

    #Address 0xe7 Write value 0xda53961
    li x3, 0xda53961
    csrw 0xe7, x3

    #Address 0xe7 Write value 0x856e8df4
    li x3, 0x856e8df4
    csrw 0xe7, x3

    #Address 0xe7 Write value 0x63a54fa2
    li x3, 0x63a54fa2
    csrw 0xe7, x3

    #Address 0xe7 Write value 0xbe00173
    li x3, 0xbe00173
    csrw 0xe7, x3

    #Unmapped address 0xb2d testing: random write/read operations
    #Address 0xb2d read value
    csrr x14, 0xb2d

    #Address 0xb2d Write value 0xe75222be
    li x3, 0xe75222be
    csrw 0xb2d, x3

    #Address 0xb2d read value
    csrr x14, 0xb2d

    #Address 0xb2d read value
    csrr x14, 0xb2d

    #Unmapped address 0xb5 testing: random write/read operations
    #Address 0xb5 Write value 0x131cba1f
    li x3, 0x131cba1f
    csrw 0xb5, x3

    #Address 0xb5 Write value 0xee49832a
    li x3, 0xee49832a
    csrw 0xb5, x3

    #Address 0xb5 Write value 0xfbfe0597
    li x3, 0xfbfe0597
    csrw 0xb5, x3

    #Address 0xb5 read value
    csrr x14, 0xb5

    #Unmapped address 0xa9c testing: random write/read operations
    #Address 0xa9c Write value 0x9bec8d87
    li x3, 0x9bec8d87
    csrw 0xa9c, x3

    #Address 0xa9c Write value 0xe82c8678
    li x3, 0xe82c8678
    csrw 0xa9c, x3

    #Address 0xa9c read value
    csrr x14, 0xa9c

    #Address 0xa9c Write value 0xcd5867e8
    li x3, 0xcd5867e8
    csrw 0xa9c, x3

    #Unmapped address 0x184 testing: random write/read operations
    #Address 0x184 Write value 0x731ae08f
    li x3, 0x731ae08f
    csrw 0x184, x3

    #Unmapped address 0x859 testing: random write/read operations
    #Address 0x859 Write value 0xb0ed1309
    li x3, 0xb0ed1309
    csrw 0x859, x3

    #Address 0x859 Write value 0x7ae08727
    li x3, 0x7ae08727
    csrw 0x859, x3

    #Address 0x859 read value
    csrr x14, 0x859

    #Unmapped address 0xb2f testing: random write/read operations
    #Address 0xb2f Write value 0x5f549312
    li x3, 0x5f549312
    csrw 0xb2f, x3

    #Address 0xb2f Write value 0x4d9a337c
    li x3, 0x4d9a337c
    csrw 0xb2f, x3

    #Address 0xb2f read value
    csrr x14, 0xb2f

    #Unmapped address 0xd78 testing: random write/read operations
    #Address 0xd78 read value
    csrr x14, 0xd78

    #Address 0xd78 read value
    csrr x14, 0xd78

    #Address 0xd78 read value
    csrr x14, 0xd78

    #Address 0xd78 read value
    csrr x14, 0xd78

    #Address 0xd78 read value
    csrr x14, 0xd78

    #Unmapped address 0x99e testing: random write/read operations
    #Address 0x99e Write value 0xc41d798d
    li x3, 0xc41d798d
    csrw 0x99e, x3

    #Address 0x99e read value
    csrr x14, 0x99e

    #Unmapped address 0xcc7 testing: random write/read operations
    #Address 0xcc7 Write value 0x28e62513
    li x3, 0x28e62513
    csrw 0xcc7, x3

    #Address 0xcc7 Write value 0xc1d56023
    li x3, 0xc1d56023
    csrw 0xcc7, x3

    #Unmapped address 0xd66 testing: random write/read operations
    #Address 0xd66 Write value 0xc0ea68fd
    li x3, 0xc0ea68fd
    csrw 0xd66, x3

    #Unmapped address 0x80 testing: random write/read operations
    #Address 0x80 Write value 0x4bf0d474
    li x3, 0x4bf0d474
    csrw 0x80, x3

    #Address 0x80 Write value 0xe63664b3
    li x3, 0xe63664b3
    csrw 0x80, x3

    #Address 0x80 Write value 0x3a3d857a
    li x3, 0x3a3d857a
    csrw 0x80, x3

    #Address 0x80 Write value 0xb45068a4
    li x3, 0xb45068a4
    csrw 0x80, x3

    #Address 0x80 read value
    csrr x14, 0x80

    #Unmapped address 0x7af testing: random write/read operations
    #Address 0x7af read value
    csrr x14, 0x7af

    #Unmapped address 0xbbc testing: random write/read operations
    #Address 0xbbc read value
    csrr x14, 0xbbc

    #Address 0xbbc Write value 0x21f0f643
    li x3, 0x21f0f643
    csrw 0xbbc, x3

    #Address 0xbbc read value
    csrr x14, 0xbbc

    #Address 0xbbc Write value 0x43fa3502
    li x3, 0x43fa3502
    csrw 0xbbc, x3

    #Unmapped address 0x320 testing: random write/read operations
    #Address 0x320 Write value 0x88f969b3
    li x3, 0x88f969b3
    csrw 0x320, x3

    #Address 0x320 read value
    csrr x14, 0x320

    #Address 0x320 Write value 0xcc0d5b3
    li x3, 0xcc0d5b3
    csrw 0x320, x3

    #Unmapped address 0xe98 testing: random write/read operations
    #Address 0xe98 Write value 0x27a87a85
    li x3, 0x27a87a85
    csrw 0xe98, x3

    #Address 0xe98 Write value 0x218447a2
    li x3, 0x218447a2
    csrw 0xe98, x3

    #Address 0xe98 read value
    csrr x14, 0xe98

    #Unmapped address 0x286 testing: random write/read operations
    #Address 0x286 read value
    csrr x14, 0x286

    #Address 0x286 Write value 0x77d566d0
    li x3, 0x77d566d0
    csrw 0x286, x3

    #Address 0x286 Write value 0x111ca479
    li x3, 0x111ca479
    csrw 0x286, x3

    #Address 0x286 Write value 0x76410a6
    li x3, 0x76410a6
    csrw 0x286, x3

    #Address 0x286 Write value 0xc6303e84
    li x3, 0xc6303e84
    csrw 0x286, x3

    #Unmapped address 0x4f7 testing: random write/read operations
    #Address 0x4f7 Write value 0x956c04d
    li x3, 0x956c04d
    csrw 0x4f7, x3

    #Address 0x4f7 Write value 0x414c9061
    li x3, 0x414c9061
    csrw 0x4f7, x3

    #Address 0x4f7 read value
    csrr x14, 0x4f7

    #Address 0x4f7 Write value 0xe38de9c0
    li x3, 0xe38de9c0
    csrw 0x4f7, x3

    #Address 0x4f7 Write value 0xf026f6aa
    li x3, 0xf026f6aa
    csrw 0x4f7, x3

    #Unmapped address 0x64d testing: random write/read operations
    #Address 0x64d read value
    csrr x14, 0x64d

    #Address 0x64d Write value 0x4c892760
    li x3, 0x4c892760
    csrw 0x64d, x3

    #Address 0x64d read value
    csrr x14, 0x64d

    #Unmapped address 0x801 testing: random write/read operations
    #Address 0x801 Write value 0xb4d7143
    li x3, 0xb4d7143
    csrw 0x801, x3

    #Unmapped address 0xa49 testing: random write/read operations
    #Address 0xa49 read value
    csrr x14, 0xa49

    #Address 0xa49 read value
    csrr x14, 0xa49

    #Unmapped address 0xa53 testing: random write/read operations
    #Address 0xa53 read value
    csrr x14, 0xa53

    #Address 0xa53 Write value 0xed9c45a9
    li x3, 0xed9c45a9
    csrw 0xa53, x3

    #Address 0xa53 Write value 0x1542117b
    li x3, 0x1542117b
    csrw 0xa53, x3

    #Unmapped address 0x137 testing: random write/read operations
    #Address 0x137 Write value 0x51d88f3
    li x3, 0x51d88f3
    csrw 0x137, x3

    #Address 0x137 read value
    csrr x14, 0x137

    #Unmapped address 0xf76 testing: random write/read operations
    #Address 0xf76 read value
    csrr x14, 0xf76

    #Address 0xf76 Write value 0xcb1eb7bc
    li x3, 0xcb1eb7bc
    csrw 0xf76, x3

    #Unmapped address 0x9cb testing: random write/read operations
    #Address 0x9cb Write value 0x81131920
    li x3, 0x81131920
    csrw 0x9cb, x3

    #Address 0x9cb Write value 0x4c88f45e
    li x3, 0x4c88f45e
    csrw 0x9cb, x3

    #Unmapped address 0xd3a testing: random write/read operations
    #Address 0xd3a Write value 0x88ebfabc
    li x3, 0x88ebfabc
    csrw 0xd3a, x3

    #Address 0xd3a Write value 0x7c87c5ab
    li x3, 0x7c87c5ab
    csrw 0xd3a, x3

    #Address 0xd3a Write value 0x10ad5a83
    li x3, 0x10ad5a83
    csrw 0xd3a, x3

    #Address 0xd3a read value
    csrr x14, 0xd3a

    #Unmapped address 0xf4e testing: random write/read operations
    #Address 0xf4e read value
    csrr x14, 0xf4e

    #Address 0xf4e Write value 0x40eb7d91
    li x3, 0x40eb7d91
    csrw 0xf4e, x3

    #Address 0xf4e Write value 0x321ef928
    li x3, 0x321ef928
    csrw 0xf4e, x3

    #Unmapped address 0xe49 testing: random write/read operations
    #Address 0xe49 Write value 0xd08dcc99
    li x3, 0xd08dcc99
    csrw 0xe49, x3

    #Address 0xe49 Write value 0xdce83c18
    li x3, 0xdce83c18
    csrw 0xe49, x3

    #Unmapped address 0x688 testing: random write/read operations
    #Address 0x688 read value
    csrr x14, 0x688

    #Address 0x688 read value
    csrr x14, 0x688

    #Unmapped address 0xe79 testing: random write/read operations
    #Address 0xe79 Write value 0xbc1d0c21
    li x3, 0xbc1d0c21
    csrw 0xe79, x3

    #Unmapped address 0xac0 testing: random write/read operations
    #Address 0xac0 Write value 0xad18afad
    li x3, 0xad18afad
    csrw 0xac0, x3

    #Address 0xac0 Write value 0xc3775d8b
    li x3, 0xc3775d8b
    csrw 0xac0, x3

    #Unmapped address 0x59 testing: random write/read operations
    #Address 0x59 read value
    csrr x14, 0x59

    #Address 0x59 read value
    csrr x14, 0x59

    #Address 0x59 Write value 0x6f389e33
    li x3, 0x6f389e33
    csrw 0x59, x3

    #Unmapped address 0xc testing: random write/read operations
    #Address 0xc Write value 0xfe7de895
    li x3, 0xfe7de895
    csrw 0xc, x3

    #Address 0xc read value
    csrr x14, 0xc

    #Address 0xc Write value 0xbfdacfd
    li x3, 0xbfdacfd
    csrw 0xc, x3

    #Address 0xc read value
    csrr x14, 0xc

    #Address 0xc Write value 0x8c4387e3
    li x3, 0x8c4387e3
    csrw 0xc, x3

    #Unmapped address 0xcdb testing: random write/read operations
    #Address 0xcdb read value
    csrr x14, 0xcdb

    #Address 0xcdb Write value 0xaffae329
    li x3, 0xaffae329
    csrw 0xcdb, x3

    #Address 0xcdb Write value 0x77a5b1bb
    li x3, 0x77a5b1bb
    csrw 0xcdb, x3

    #Address 0xcdb Write value 0xe38c92a
    li x3, 0xe38c92a
    csrw 0xcdb, x3

    #Address 0xcdb read value
    csrr x14, 0xcdb

    #Unmapped address 0x799 testing: random write/read operations
    #Address 0x799 read value
    csrr x14, 0x799

    #Address 0x799 Write value 0x2055718f
    li x3, 0x2055718f
    csrw 0x799, x3

    #Address 0x799 read value
    csrr x14, 0x799

    #Address 0x799 read value
    csrr x14, 0x799

    #Address 0x799 Write value 0x57e084dd
    li x3, 0x57e084dd
    csrw 0x799, x3

    #Unmapped address 0x169 testing: random write/read operations
    #Address 0x169 read value
    csrr x14, 0x169

    #Unmapped address 0x4eb testing: random write/read operations
    #Address 0x4eb read value
    csrr x14, 0x4eb

    #Address 0x4eb Write value 0x5c8e9be8
    li x3, 0x5c8e9be8
    csrw 0x4eb, x3

    #Unmapped address 0x22c testing: random write/read operations
    #Address 0x22c read value
    csrr x14, 0x22c

    #Unmapped address 0x653 testing: random write/read operations
    #Address 0x653 Write value 0x3a243575
    li x3, 0x3a243575
    csrw 0x653, x3

    #Address 0x653 read value
    csrr x14, 0x653

    #Address 0x653 read value
    csrr x14, 0x653

    #Address 0x653 read value
    csrr x14, 0x653

    #Unmapped address 0xe6 testing: random write/read operations
    #Address 0xe6 Write value 0xe651b46
    li x3, 0xe651b46
    csrw 0xe6, x3

    #Unmapped address 0xdc4 testing: random write/read operations
    #Address 0xdc4 Write value 0xc10440a0
    li x3, 0xc10440a0
    csrw 0xdc4, x3

    #Unmapped address 0x9e3 testing: random write/read operations
    #Address 0x9e3 read value
    csrr x14, 0x9e3

    #Unmapped address 0x790 testing: random write/read operations
    #Address 0x790 read value
    csrr x14, 0x790

    #Address 0x790 read value
    csrr x14, 0x790

    #Address 0x790 read value
    csrr x14, 0x790

    #Address 0x790 Write value 0x45514bf7
    li x3, 0x45514bf7
    csrw 0x790, x3

    #Address 0x790 read value
    csrr x14, 0x790

    #Unmapped address 0x98 testing: random write/read operations
    #Address 0x98 Write value 0x9389312
    li x3, 0x9389312
    csrw 0x98, x3

    #Address 0x98 read value
    csrr x14, 0x98

    #Address 0x98 read value
    csrr x14, 0x98

    #Address 0x98 read value
    csrr x14, 0x98

    #Address 0x98 read value
    csrr x14, 0x98

    #Unmapped address 0x865 testing: random write/read operations
    #Address 0x865 read value
    csrr x14, 0x865

    #Address 0x865 read value
    csrr x14, 0x865

    #Address 0x865 Write value 0x771a9078
    li x3, 0x771a9078
    csrw 0x865, x3

    #Address 0x865 read value
    csrr x14, 0x865

    #Unmapped address 0x610 testing: random write/read operations
    #Address 0x610 read value
    csrr x14, 0x610

    #Address 0x610 Write value 0x5859b977
    li x3, 0x5859b977
    csrw 0x610, x3

    #Address 0x610 Write value 0xc018ae8
    li x3, 0xc018ae8
    csrw 0x610, x3

    #Address 0x610 Write value 0x31c16d32
    li x3, 0x31c16d32
    csrw 0x610, x3

    #Address 0x610 read value
    csrr x14, 0x610

    #Unmapped address 0xfd9 testing: random write/read operations
    #Address 0xfd9 Write value 0x55d5cadd
    li x3, 0x55d5cadd
    csrw 0xfd9, x3

    #Unmapped address 0x7f9 testing: random write/read operations
    #Address 0x7f9 Write value 0xbcdb8187
    li x3, 0xbcdb8187
    csrw 0x7f9, x3

    #Address 0x7f9 read value
    csrr x14, 0x7f9

    #Address 0x7f9 read value
    csrr x14, 0x7f9

    #Address 0x7f9 read value
    csrr x14, 0x7f9

    #Mapped address 0xb8a (mhpmcounterh10) testing: random write/read operations
    #Address 0xb8a Write value 0x2ca8c975
    li x3, 0x2ca8c975
    csrw 0xb8a, x3

    #Unmapped address 0x69c testing: random write/read operations
    #Address 0x69c Write value 0x4f7f7f55
    li x3, 0x4f7f7f55
    csrw 0x69c, x3

    #Address 0x69c read value
    csrr x14, 0x69c

    #Address 0x69c Write value 0xb693c111
    li x3, 0xb693c111
    csrw 0x69c, x3

    #Address 0x69c read value
    csrr x14, 0x69c

    #Unmapped address 0x566 testing: random write/read operations
    #Address 0x566 read value
    csrr x14, 0x566

    #Address 0x566 Write value 0xbba7faae
    li x3, 0xbba7faae
    csrw 0x566, x3

    #Address 0x566 Write value 0x5a4fcf08
    li x3, 0x5a4fcf08
    csrw 0x566, x3

    #Address 0x566 Write value 0x5b725eaf
    li x3, 0x5b725eaf
    csrw 0x566, x3

    #Unmapped address 0x930 testing: random write/read operations
    #Address 0x930 read value
    csrr x14, 0x930

    #Unmapped address 0x9fc testing: random write/read operations
    #Address 0x9fc Write value 0xcde2d22e
    li x3, 0xcde2d22e
    csrw 0x9fc, x3

    #Address 0x9fc read value
    csrr x14, 0x9fc

    #Address 0x9fc Write value 0xa022df0d
    li x3, 0xa022df0d
    csrw 0x9fc, x3

    #Unmapped address 0x550 testing: random write/read operations
    #Address 0x550 read value
    csrr x14, 0x550

    #Address 0x550 Write value 0x2a91326
    li x3, 0x2a91326
    csrw 0x550, x3

    #Unmapped address 0x884 testing: random write/read operations
    #Address 0x884 Write value 0x37a50a53
    li x3, 0x37a50a53
    csrw 0x884, x3

    #Unmapped address 0x4 testing: random write/read operations
    #Address 0x4 Write value 0x3f75a62b
    li x3, 0x3f75a62b
    csrw 0x4, x3

    #Address 0x4 read value
    csrr x14, 0x4

    #Address 0x4 Write value 0xc8923fcf
    li x3, 0xc8923fcf
    csrw 0x4, x3

    #Address 0x4 read value
    csrr x14, 0x4

    #Address 0x4 Write value 0xc71a2108
    li x3, 0xc71a2108
    csrw 0x4, x3

    #Unmapped address 0xe08 testing: random write/read operations
    #Address 0xe08 Write value 0x6dc22077
    li x3, 0x6dc22077
    csrw 0xe08, x3

    #Unmapped address 0x8ff testing: random write/read operations
    #Address 0x8ff Write value 0x387b3d7
    li x3, 0x387b3d7
    csrw 0x8ff, x3

    #Address 0x8ff read value
    csrr x14, 0x8ff

    #Address 0x8ff Write value 0x61dcaacf
    li x3, 0x61dcaacf
    csrw 0x8ff, x3

    #Address 0x8ff read value
    csrr x14, 0x8ff

    #Unmapped address 0xbe8 testing: random write/read operations
    #Address 0xbe8 Write value 0xe1ab8f3b
    li x3, 0xe1ab8f3b
    csrw 0xbe8, x3

    #Address 0xbe8 Write value 0x2d4b353b
    li x3, 0x2d4b353b
    csrw 0xbe8, x3

    #Address 0xbe8 read value
    csrr x14, 0xbe8

    #Address 0xbe8 read value
    csrr x14, 0xbe8

    #Address 0xbe8 Write value 0xd94aa9fb
    li x3, 0xd94aa9fb
    csrw 0xbe8, x3

    #Unmapped address 0x7ce testing: random write/read operations
    #Address 0x7ce read value
    csrr x14, 0x7ce

    #Address 0x7ce Write value 0xf1a5caa2
    li x3, 0xf1a5caa2
    csrw 0x7ce, x3

    #Address 0x7ce Write value 0x715eaa2f
    li x3, 0x715eaa2f
    csrw 0x7ce, x3

    #Address 0x7ce Write value 0xb8fbc9a9
    li x3, 0xb8fbc9a9
    csrw 0x7ce, x3

    #Address 0x7ce read value
    csrr x14, 0x7ce

    #Unmapped address 0xdf9 testing: random write/read operations
    #Address 0xdf9 read value
    csrr x14, 0xdf9

    #Address 0xdf9 read value
    csrr x14, 0xdf9

    #Unmapped address 0x6a4 testing: random write/read operations
    #Address 0x6a4 Write value 0x1b8ca9cf
    li x3, 0x1b8ca9cf
    csrw 0x6a4, x3

    #Unmapped address 0x94 testing: random write/read operations
    #Address 0x94 read value
    csrr x14, 0x94

    #Address 0x94 read value
    csrr x14, 0x94

    #Address 0x94 read value
    csrr x14, 0x94

    #Address 0x94 read value
    csrr x14, 0x94

    #Unmapped address 0xb7b testing: random write/read operations
    #Address 0xb7b Write value 0x11c90663
    li x3, 0x11c90663
    csrw 0xb7b, x3

    #Address 0xb7b read value
    csrr x14, 0xb7b

    #Address 0xb7b Write value 0x5333506c
    li x3, 0x5333506c
    csrw 0xb7b, x3

    #Address 0xb7b Write value 0xa941dc7e
    li x3, 0xa941dc7e
    csrw 0xb7b, x3

    #Unmapped address 0xdec testing: random write/read operations
    #Address 0xdec Write value 0x280ba0e7
    li x3, 0x280ba0e7
    csrw 0xdec, x3

    #Address 0xdec Write value 0xf1c135d2
    li x3, 0xf1c135d2
    csrw 0xdec, x3

    #Unmapped address 0xc86 testing: random write/read operations
    #Address 0xc86 read value
    csrr x14, 0xc86

    #Address 0xc86 read value
    csrr x14, 0xc86

    #Address 0xc86 Write value 0xbd8a6f46
    li x3, 0xbd8a6f46
    csrw 0xc86, x3

    #Address 0xc86 Write value 0xa4e9bbc0
    li x3, 0xa4e9bbc0
    csrw 0xc86, x3

    #Unmapped address 0x14c testing: random write/read operations
    #Address 0x14c read value
    csrr x14, 0x14c

    #Address 0x14c read value
    csrr x14, 0x14c

    #Address 0x14c read value
    csrr x14, 0x14c

    #Unmapped address 0xada testing: random write/read operations
    #Address 0xada read value
    csrr x14, 0xada

    #Unmapped address 0x8fc testing: random write/read operations
    #Address 0x8fc Write value 0xf6a6204a
    li x3, 0xf6a6204a
    csrw 0x8fc, x3

    #Unmapped address 0xf7c testing: random write/read operations
    #Address 0xf7c Write value 0xcb93f784
    li x3, 0xcb93f784
    csrw 0xf7c, x3

    #Address 0xf7c Write value 0x8f68ff20
    li x3, 0x8f68ff20
    csrw 0xf7c, x3

    #Address 0xf7c Write value 0x9102df03
    li x3, 0x9102df03
    csrw 0xf7c, x3

    #Address 0xf7c Write value 0xf2d47094
    li x3, 0xf2d47094
    csrw 0xf7c, x3

    #Address 0xf7c read value
    csrr x14, 0xf7c

    #Unmapped address 0x102 testing: random write/read operations
    #Address 0x102 read value
    csrr x14, 0x102

    #Address 0x102 Write value 0x157cc103
    li x3, 0x157cc103
    csrw 0x102, x3

    #Address 0x102 Write value 0xeb98fb65
    li x3, 0xeb98fb65
    csrw 0x102, x3

    #Address 0x102 read value
    csrr x14, 0x102

    #Address 0x102 read value
    csrr x14, 0x102

    #Unmapped address 0x125 testing: random write/read operations
    #Address 0x125 Write value 0x9d70041c
    li x3, 0x9d70041c
    csrw 0x125, x3

    #Unmapped address 0xe5b testing: random write/read operations
    #Address 0xe5b read value
    csrr x14, 0xe5b

    #Unmapped address 0xa1e testing: random write/read operations
    #Address 0xa1e Write value 0x2851feee
    li x3, 0x2851feee
    csrw 0xa1e, x3

    #Address 0xa1e Write value 0xfdcd4c04
    li x3, 0xfdcd4c04
    csrw 0xa1e, x3

    #Address 0xa1e read value
    csrr x14, 0xa1e

    #Address 0xa1e read value
    csrr x14, 0xa1e

    #Address 0xa1e read value
    csrr x14, 0xa1e

    #Unmapped address 0x31c testing: random write/read operations
    #Address 0x31c read value
    csrr x14, 0x31c

    #Address 0x31c read value
    csrr x14, 0x31c

    #Address 0x31c read value
    csrr x14, 0x31c

    #Unmapped address 0x8b2 testing: random write/read operations
    #Address 0x8b2 Write value 0x8aa609d5
    li x3, 0x8aa609d5
    csrw 0x8b2, x3

    #Unmapped address 0xb68 testing: random write/read operations
    #Address 0xb68 read value
    csrr x14, 0xb68

    #Address 0xb68 Write value 0xace8b7ed
    li x3, 0xace8b7ed
    csrw 0xb68, x3

    #Unmapped address 0x7a7 testing: random write/read operations
    #Address 0x7a7 read value
    csrr x14, 0x7a7

    #Address 0x7a7 read value
    csrr x14, 0x7a7

    #Address 0x7a7 read value
    csrr x14, 0x7a7

    #Unmapped address 0x5b4 testing: random write/read operations
    #Address 0x5b4 Write value 0x3d5893de
    li x3, 0x3d5893de
    csrw 0x5b4, x3

    #Address 0x5b4 read value
    csrr x14, 0x5b4

    #Address 0x5b4 Write value 0xb6e2b276
    li x3, 0xb6e2b276
    csrw 0x5b4, x3

    #Unmapped address 0x48 testing: random write/read operations
    #Address 0x48 Write value 0x16b577d
    li x3, 0x16b577d
    csrw 0x48, x3

    #Address 0x48 Write value 0xbb562244
    li x3, 0xbb562244
    csrw 0x48, x3

    #Address 0x48 read value
    csrr x14, 0x48

    #Address 0x48 read value
    csrr x14, 0x48

    #Address 0x48 Write value 0xa96c772b
    li x3, 0xa96c772b
    csrw 0x48, x3

    #Unmapped address 0x547 testing: random write/read operations
    #Address 0x547 read value
    csrr x14, 0x547

    #Address 0x547 Write value 0x4660e971
    li x3, 0x4660e971
    csrw 0x547, x3

    #Address 0x547 read value
    csrr x14, 0x547

    #Address 0x547 read value
    csrr x14, 0x547

    #Address 0x547 Write value 0x773863e7
    li x3, 0x773863e7
    csrw 0x547, x3

    #Unmapped address 0x9ee testing: random write/read operations
    #Address 0x9ee read value
    csrr x14, 0x9ee

    #Address 0x9ee Write value 0x87abab54
    li x3, 0x87abab54
    csrw 0x9ee, x3

    #Address 0x9ee Write value 0x23c18ed1
    li x3, 0x23c18ed1
    csrw 0x9ee, x3

    #Unmapped address 0x58d testing: random write/read operations
    #Address 0x58d Write value 0x71f54d51
    li x3, 0x71f54d51
    csrw 0x58d, x3

    #Address 0x58d Write value 0x9ee75eb
    li x3, 0x9ee75eb
    csrw 0x58d, x3

    #Unmapped address 0x51b testing: random write/read operations
    #Address 0x51b read value
    csrr x14, 0x51b

    #Address 0x51b Write value 0x2efc7e93
    li x3, 0x2efc7e93
    csrw 0x51b, x3

    #Address 0x51b read value
    csrr x14, 0x51b

    #Unmapped address 0xa44 testing: random write/read operations
    #Address 0xa44 Write value 0xf4b12469
    li x3, 0xf4b12469
    csrw 0xa44, x3

    #Address 0xa44 Write value 0x1c6d249a
    li x3, 0x1c6d249a
    csrw 0xa44, x3

    #Address 0xa44 read value
    csrr x14, 0xa44

    #Address 0xa44 read value
    csrr x14, 0xa44

    #Unmapped address 0x9b7 testing: random write/read operations
    #Address 0x9b7 Write value 0xcfa5debe
    li x3, 0xcfa5debe
    csrw 0x9b7, x3

    #Address 0x9b7 Write value 0x8e81ace9
    li x3, 0x8e81ace9
    csrw 0x9b7, x3

    #Address 0x9b7 read value
    csrr x14, 0x9b7

    #Address 0x9b7 Write value 0x940550c3
    li x3, 0x940550c3
    csrw 0x9b7, x3

    #Unmapped address 0x677 testing: random write/read operations
    #Address 0x677 read value
    csrr x14, 0x677

    #Unmapped address 0xc7f testing: random write/read operations
    #Address 0xc7f read value
    csrr x14, 0xc7f

    #Address 0xc7f read value
    csrr x14, 0xc7f

    #Address 0xc7f read value
    csrr x14, 0xc7f

    #Address 0xc7f Write value 0x687acf7
    li x3, 0x687acf7
    csrw 0xc7f, x3

    #Unmapped address 0xb3b testing: random write/read operations
    #Address 0xb3b read value
    csrr x14, 0xb3b

    #Address 0xb3b read value
    csrr x14, 0xb3b

    #Unmapped address 0xdd5 testing: random write/read operations
    #Address 0xdd5 read value
    csrr x14, 0xdd5

    #Unmapped address 0xc87 testing: random write/read operations
    #Address 0xc87 read value
    csrr x14, 0xc87

    #Address 0xc87 read value
    csrr x14, 0xc87

    #Unmapped address 0xd2a testing: random write/read operations
    #Address 0xd2a read value
    csrr x14, 0xd2a

    #Mapped address 0x341 (mepc) testing: random write/read operations
    #Address 0x341 Write value 0x51e5f1ee
    li x3, 0x51e5f1ee
    csrw 0x341, x3

    #Unmapped address 0xf1a testing: random write/read operations
    #Address 0xf1a read value
    csrr x14, 0xf1a

    #Address 0xf1a read value
    csrr x14, 0xf1a

    #Unmapped address 0x138 testing: random write/read operations
    #Address 0x138 Write value 0xe8c509d4
    li x3, 0xe8c509d4
    csrw 0x138, x3

    #Address 0x138 Write value 0x83ccab09
    li x3, 0x83ccab09
    csrw 0x138, x3

    #Address 0x138 read value
    csrr x14, 0x138

    #Address 0x138 Write value 0x98c52d0
    li x3, 0x98c52d0
    csrw 0x138, x3

    #Unmapped address 0xd27 testing: random write/read operations
    #Address 0xd27 Write value 0x8a412d00
    li x3, 0x8a412d00
    csrw 0xd27, x3

    #Address 0xd27 read value
    csrr x14, 0xd27

    #Address 0xd27 read value
    csrr x14, 0xd27

    #Address 0xd27 Write value 0x8045c8e6
    li x3, 0x8045c8e6
    csrw 0xd27, x3

    #Unmapped address 0xf3e testing: random write/read operations
    #Address 0xf3e Write value 0x61febf44
    li x3, 0x61febf44
    csrw 0xf3e, x3

    #Address 0xf3e read value
    csrr x14, 0xf3e

    #Address 0xf3e read value
    csrr x14, 0xf3e

    #Address 0xf3e Write value 0x703954d6
    li x3, 0x703954d6
    csrw 0xf3e, x3

    #Address 0xf3e Write value 0x60c3d02f
    li x3, 0x60c3d02f
    csrw 0xf3e, x3

    #Unmapped address 0xd96 testing: random write/read operations
    #Address 0xd96 Write value 0xe33a12fd
    li x3, 0xe33a12fd
    csrw 0xd96, x3

    #Address 0xd96 read value
    csrr x14, 0xd96

    #Address 0xd96 read value
    csrr x14, 0xd96

    #Address 0xd96 Write value 0xf992c052
    li x3, 0xf992c052
    csrw 0xd96, x3

    #Address 0xd96 Write value 0xb4370a29
    li x3, 0xb4370a29
    csrw 0xd96, x3

    #Unmapped address 0x5b3 testing: random write/read operations
    #Address 0x5b3 read value
    csrr x14, 0x5b3

    #Unmapped address 0xa6b testing: random write/read operations
    #Address 0xa6b Write value 0xee47cbf8
    li x3, 0xee47cbf8
    csrw 0xa6b, x3

    #Address 0xa6b Write value 0xfab8f12d
    li x3, 0xfab8f12d
    csrw 0xa6b, x3

    #Unmapped address 0x9f testing: random write/read operations
    #Address 0x9f read value
    csrr x14, 0x9f

    #Address 0x9f Write value 0x844f19e4
    li x3, 0x844f19e4
    csrw 0x9f, x3

    #Address 0x9f Write value 0xbffc2478
    li x3, 0xbffc2478
    csrw 0x9f, x3

    #Address 0x9f Write value 0xa0a519a4
    li x3, 0xa0a519a4
    csrw 0x9f, x3

    #Address 0x9f Write value 0xeab72522
    li x3, 0xeab72522
    csrw 0x9f, x3

    #Unmapped address 0x35b testing: random write/read operations
    #Address 0x35b read value
    csrr x14, 0x35b

    #Address 0x35b Write value 0x74ee08ef
    li x3, 0x74ee08ef
    csrw 0x35b, x3

    #Address 0x35b Write value 0x430deadb
    li x3, 0x430deadb
    csrw 0x35b, x3

    #Address 0x35b Write value 0xc9e255ee
    li x3, 0xc9e255ee
    csrw 0x35b, x3

    #Unmapped address 0x8f6 testing: random write/read operations
    #Address 0x8f6 Write value 0x23898576
    li x3, 0x23898576
    csrw 0x8f6, x3

    #Address 0x8f6 Write value 0x4932a9b8
    li x3, 0x4932a9b8
    csrw 0x8f6, x3

    #Address 0x8f6 read value
    csrr x14, 0x8f6

    #Address 0x8f6 read value
    csrr x14, 0x8f6

    #Unmapped address 0x87a testing: random write/read operations
    #Address 0x87a read value
    csrr x14, 0x87a

    #Address 0x87a read value
    csrr x14, 0x87a

    #Address 0x87a read value
    csrr x14, 0x87a

    #Address 0x87a read value
    csrr x14, 0x87a

    #Address 0x87a Write value 0x522d9db8
    li x3, 0x522d9db8
    csrw 0x87a, x3

    #Unmapped address 0xd24 testing: random write/read operations
    #Address 0xd24 read value
    csrr x14, 0xd24

    #Address 0xd24 Write value 0xf4a94063
    li x3, 0xf4a94063
    csrw 0xd24, x3

    #Address 0xd24 Write value 0xcb020824
    li x3, 0xcb020824
    csrw 0xd24, x3

    #Address 0xd24 Write value 0xf7c6624
    li x3, 0xf7c6624
    csrw 0xd24, x3

    #Address 0xd24 read value
    csrr x14, 0xd24

    #Unmapped address 0x7ef testing: random write/read operations
    #Address 0x7ef read value
    csrr x14, 0x7ef

    #Address 0x7ef read value
    csrr x14, 0x7ef

    #Address 0x7ef read value
    csrr x14, 0x7ef

    #Address 0x7ef read value
    csrr x14, 0x7ef

    #Address 0x7ef read value
    csrr x14, 0x7ef

    #Unmapped address 0x5c3 testing: random write/read operations
    #Address 0x5c3 read value
    csrr x14, 0x5c3

    #Address 0x5c3 read value
    csrr x14, 0x5c3

    #Address 0x5c3 read value
    csrr x14, 0x5c3

    #Unmapped address 0x881 testing: random write/read operations
    #Address 0x881 read value
    csrr x14, 0x881

    #Address 0x881 Write value 0x4668763c
    li x3, 0x4668763c
    csrw 0x881, x3

    #Address 0x881 read value
    csrr x14, 0x881

    #Unmapped address 0x7db testing: random write/read operations
    #Address 0x7db Write value 0xe6d35c8b
    li x3, 0xe6d35c8b
    csrw 0x7db, x3

    #Address 0x7db Write value 0x12cb69df
    li x3, 0x12cb69df
    csrw 0x7db, x3

    #Unmapped address 0xeda testing: random write/read operations
    #Address 0xeda Write value 0xf842c584
    li x3, 0xf842c584
    csrw 0xeda, x3

    #Unmapped address 0x9b1 testing: random write/read operations
    #Address 0x9b1 read value
    csrr x14, 0x9b1

    #Address 0x9b1 Write value 0x18305ba4
    li x3, 0x18305ba4
    csrw 0x9b1, x3

    #Address 0x9b1 read value
    csrr x14, 0x9b1

    #Address 0x9b1 Write value 0xe413efbb
    li x3, 0xe413efbb
    csrw 0x9b1, x3

    #Unmapped address 0xb0 testing: random write/read operations
    #Address 0xb0 Write value 0xf8d703f7
    li x3, 0xf8d703f7
    csrw 0xb0, x3

    #Address 0xb0 Write value 0x98073205
    li x3, 0x98073205
    csrw 0xb0, x3

    #Address 0xb0 read value
    csrr x14, 0xb0

    #Address 0xb0 Write value 0xfa548647
    li x3, 0xfa548647
    csrw 0xb0, x3

    #Unmapped address 0x481 testing: random write/read operations
    #Address 0x481 read value
    csrr x14, 0x481

    #Address 0x481 read value
    csrr x14, 0x481

    #Address 0x481 read value
    csrr x14, 0x481

    #Unmapped address 0x4e1 testing: random write/read operations
    #Address 0x4e1 Write value 0x5e5d357b
    li x3, 0x5e5d357b
    csrw 0x4e1, x3

    #Address 0x4e1 read value
    csrr x14, 0x4e1

    #Address 0x4e1 read value
    csrr x14, 0x4e1

    #Address 0x4e1 read value
    csrr x14, 0x4e1

    #Address 0x4e1 read value
    csrr x14, 0x4e1

    #Unmapped address 0x94c testing: random write/read operations
    #Address 0x94c read value
    csrr x14, 0x94c

    #Unmapped address 0x246 testing: random write/read operations
    #Address 0x246 read value
    csrr x14, 0x246

    #Address 0x246 Write value 0xcf3e07b0
    li x3, 0xcf3e07b0
    csrw 0x246, x3

    #Address 0x246 read value
    csrr x14, 0x246

    #Address 0x246 Write value 0x3c77e780
    li x3, 0x3c77e780
    csrw 0x246, x3

    #Unmapped address 0x6b0 testing: random write/read operations
    #Address 0x6b0 read value
    csrr x14, 0x6b0

    #Address 0x6b0 Write value 0xd178eeea
    li x3, 0xd178eeea
    csrw 0x6b0, x3

    #Address 0x6b0 read value
    csrr x14, 0x6b0

    #Unmapped address 0x47f testing: random write/read operations
    #Address 0x47f Write value 0x573c73f5
    li x3, 0x573c73f5
    csrw 0x47f, x3

    #Address 0x47f Write value 0x5073f8ed
    li x3, 0x5073f8ed
    csrw 0x47f, x3

    #Address 0x47f Write value 0x6a2ecf2f
    li x3, 0x6a2ecf2f
    csrw 0x47f, x3

    #Address 0x47f read value
    csrr x14, 0x47f

    #Unmapped address 0x46d testing: random write/read operations
    #Address 0x46d Write value 0x32906ea1
    li x3, 0x32906ea1
    csrw 0x46d, x3

    #Unmapped address 0x6bc testing: random write/read operations
    #Address 0x6bc read value
    csrr x14, 0x6bc

    #Address 0x6bc Write value 0x46688a7d
    li x3, 0x46688a7d
    csrw 0x6bc, x3

    #Address 0x6bc read value
    csrr x14, 0x6bc

    #Address 0x6bc Write value 0x1d46e672
    li x3, 0x1d46e672
    csrw 0x6bc, x3

    #Address 0x6bc read value
    csrr x14, 0x6bc

    #Unmapped address 0xc96 testing: random write/read operations
    #Address 0xc96 Write value 0x9e23efdf
    li x3, 0x9e23efdf
    csrw 0xc96, x3

    #Address 0xc96 read value
    csrr x14, 0xc96

    #Address 0xc96 read value
    csrr x14, 0xc96

    #Unmapped address 0xff5 testing: random write/read operations
    #Address 0xff5 read value
    csrr x14, 0xff5

    #Unmapped address 0x7bf testing: random write/read operations
    #Address 0x7bf Write value 0x451b4dd2
    li x3, 0x451b4dd2
    csrw 0x7bf, x3

    #Address 0x7bf read value
    csrr x14, 0x7bf

    #Unmapped address 0xe7c testing: random write/read operations
    #Address 0xe7c read value
    csrr x14, 0xe7c

    #Address 0xe7c read value
    csrr x14, 0xe7c

    #Address 0xe7c read value
    csrr x14, 0xe7c

    #Address 0xe7c Write value 0xf3bdac89
    li x3, 0xf3bdac89
    csrw 0xe7c, x3

    #Unmapped address 0xa4b testing: random write/read operations
    #Address 0xa4b Write value 0xcd7b198b
    li x3, 0xcd7b198b
    csrw 0xa4b, x3

    #Address 0xa4b Write value 0xa1f79dfc
    li x3, 0xa1f79dfc
    csrw 0xa4b, x3

    #Unmapped address 0x60e testing: random write/read operations
    #Address 0x60e read value
    csrr x14, 0x60e

    #Address 0x60e Write value 0x5386723
    li x3, 0x5386723
    csrw 0x60e, x3

    #Address 0x60e Write value 0x9e62347b
    li x3, 0x9e62347b
    csrw 0x60e, x3

    #Address 0x60e read value
    csrr x14, 0x60e

    #Address 0x60e read value
    csrr x14, 0x60e

    #Unmapped address 0x26 testing: random write/read operations
    #Address 0x26 read value
    csrr x14, 0x26

    #Unmapped address 0x23d testing: random write/read operations
    #Address 0x23d read value
    csrr x14, 0x23d

    #Unmapped address 0xe72 testing: random write/read operations
    #Address 0xe72 Write value 0x1fb95feb
    li x3, 0x1fb95feb
    csrw 0xe72, x3

    #Unmapped address 0x183 testing: random write/read operations
    #Address 0x183 Write value 0x3feebb04
    li x3, 0x3feebb04
    csrw 0x183, x3

    #Unmapped address 0xed5 testing: random write/read operations
    #Address 0xed5 Write value 0x286e991
    li x3, 0x286e991
    csrw 0xed5, x3

    #Address 0xed5 read value
    csrr x14, 0xed5

    #Address 0xed5 read value
    csrr x14, 0xed5

    #Address 0xed5 Write value 0xff8f3ed3
    li x3, 0xff8f3ed3
    csrw 0xed5, x3

    #Unmapped address 0x84a testing: random write/read operations
    #Address 0x84a read value
    csrr x14, 0x84a

    #Address 0x84a Write value 0xb5fac2fc
    li x3, 0xb5fac2fc
    csrw 0x84a, x3

    #Address 0x84a read value
    csrr x14, 0x84a

    #Unmapped address 0x616 testing: random write/read operations
    #Address 0x616 Write value 0x6d59a455
    li x3, 0x6d59a455
    csrw 0x616, x3

    #Address 0x616 Write value 0x826149fd
    li x3, 0x826149fd
    csrw 0x616, x3

    #Unmapped address 0x7e6 testing: random write/read operations
    #Address 0x7e6 read value
    csrr x14, 0x7e6

    #Address 0x7e6 read value
    csrr x14, 0x7e6

    #Address 0x7e6 read value
    csrr x14, 0x7e6

    #Unmapped address 0x23a testing: random write/read operations
    #Address 0x23a read value
    csrr x14, 0x23a

    #Address 0x23a Write value 0x4e43c6f9
    li x3, 0x4e43c6f9
    csrw 0x23a, x3

    #Unmapped address 0x2a testing: random write/read operations
    #Address 0x2a read value
    csrr x14, 0x2a

    #Unmapped address 0xfe6 testing: random write/read operations
    #Address 0xfe6 Write value 0x71b6dc2e
    li x3, 0x71b6dc2e
    csrw 0xfe6, x3

    #Address 0xfe6 Write value 0x97d12eaa
    li x3, 0x97d12eaa
    csrw 0xfe6, x3

    #Unmapped address 0x20c testing: random write/read operations
    #Address 0x20c read value
    csrr x14, 0x20c

    #Address 0x20c Write value 0x90f161b9
    li x3, 0x90f161b9
    csrw 0x20c, x3

    #Address 0x20c read value
    csrr x14, 0x20c

    #Address 0x20c Write value 0x5ce18894
    li x3, 0x5ce18894
    csrw 0x20c, x3

    #Unmapped address 0x1e4 testing: random write/read operations
    #Address 0x1e4 Write value 0xbf556bec
    li x3, 0xbf556bec
    csrw 0x1e4, x3

    #Address 0x1e4 Write value 0xec9a17c4
    li x3, 0xec9a17c4
    csrw 0x1e4, x3

    #Unmapped address 0x9ac testing: random write/read operations
    #Address 0x9ac Write value 0x262e815b
    li x3, 0x262e815b
    csrw 0x9ac, x3

    #Address 0x9ac read value
    csrr x14, 0x9ac

    #Address 0x9ac read value
    csrr x14, 0x9ac

    #Unmapped address 0x49b testing: random write/read operations
    #Address 0x49b read value
    csrr x14, 0x49b

    #Address 0x49b read value
    csrr x14, 0x49b

    #Address 0x49b read value
    csrr x14, 0x49b

    #Address 0x49b Write value 0x2359cbec
    li x3, 0x2359cbec
    csrw 0x49b, x3

    #Address 0x49b Write value 0x5873c5a4
    li x3, 0x5873c5a4
    csrw 0x49b, x3

    #Unmapped address 0x306 testing: random write/read operations
    #Address 0x306 Write value 0x253caf9c
    li x3, 0x253caf9c
    csrw 0x306, x3

    #Address 0x306 Write value 0x63dafc6e
    li x3, 0x63dafc6e
    csrw 0x306, x3

    #Address 0x306 Write value 0xe4ad0237
    li x3, 0xe4ad0237
    csrw 0x306, x3

    #Unmapped address 0xdb5 testing: random write/read operations
    #Address 0xdb5 Write value 0x8cfd5fa0
    li x3, 0x8cfd5fa0
    csrw 0xdb5, x3

    #Address 0xdb5 read value
    csrr x14, 0xdb5

    #Address 0xdb5 read value
    csrr x14, 0xdb5

    #Unmapped address 0xa10 testing: random write/read operations
    #Address 0xa10 read value
    csrr x14, 0xa10

    #Unmapped address 0xdc2 testing: random write/read operations
    #Address 0xdc2 Write value 0x6c2e1ccb
    li x3, 0x6c2e1ccb
    csrw 0xdc2, x3

    #Address 0xdc2 read value
    csrr x14, 0xdc2

    #Unmapped address 0x513 testing: random write/read operations
    #Address 0x513 read value
    csrr x14, 0x513

    #Unmapped address 0xc5a testing: random write/read operations
    #Address 0xc5a read value
    csrr x14, 0xc5a

    #Address 0xc5a read value
    csrr x14, 0xc5a

    #Address 0xc5a Write value 0xdc1219b5
    li x3, 0xdc1219b5
    csrw 0xc5a, x3

    #Unmapped address 0xe31 testing: random write/read operations
    #Address 0xe31 Write value 0xe9aeb371
    li x3, 0xe9aeb371
    csrw 0xe31, x3

    #Unmapped address 0x3de testing: random write/read operations
    #Address 0x3de read value
    csrr x14, 0x3de

    #Address 0x3de Write value 0x41abae29
    li x3, 0x41abae29
    csrw 0x3de, x3

    #Address 0x3de read value
    csrr x14, 0x3de

    #Unmapped address 0x636 testing: random write/read operations
    #Address 0x636 read value
    csrr x14, 0x636

    #Unmapped address 0xc77 testing: random write/read operations
    #Address 0xc77 read value
    csrr x14, 0xc77

    #Address 0xc77 Write value 0x6d3c35ea
    li x3, 0x6d3c35ea
    csrw 0xc77, x3

    #Unmapped address 0x638 testing: random write/read operations
    #Address 0x638 Write value 0x14c389b3
    li x3, 0x14c389b3
    csrw 0x638, x3

    #Address 0x638 read value
    csrr x14, 0x638

    #Address 0x638 Write value 0xbf990034
    li x3, 0xbf990034
    csrw 0x638, x3

    #Address 0x638 Write value 0xefdab524
    li x3, 0xefdab524
    csrw 0x638, x3

    #Unmapped address 0xa7f testing: random write/read operations
    #Address 0xa7f read value
    csrr x14, 0xa7f

    #Address 0xa7f read value
    csrr x14, 0xa7f

    #Address 0xa7f Write value 0xeb892875
    li x3, 0xeb892875
    csrw 0xa7f, x3

    #Unmapped address 0xaaf testing: random write/read operations
    #Address 0xaaf Write value 0x844bf09b
    li x3, 0x844bf09b
    csrw 0xaaf, x3

    #Address 0xaaf read value
    csrr x14, 0xaaf

    #Address 0xaaf Write value 0xf67a074c
    li x3, 0xf67a074c
    csrw 0xaaf, x3

    #Unmapped address 0x26c testing: random write/read operations
    #Address 0x26c read value
    csrr x14, 0x26c

    #Address 0x26c read value
    csrr x14, 0x26c

    #Address 0x26c Write value 0xb2c4090d
    li x3, 0xb2c4090d
    csrw 0x26c, x3

    #Address 0x26c Write value 0xf9011ccb
    li x3, 0xf9011ccb
    csrw 0x26c, x3

    #Unmapped address 0x888 testing: random write/read operations
    #Address 0x888 read value
    csrr x14, 0x888

    #Unmapped address 0x2ed testing: random write/read operations
    #Address 0x2ed Write value 0x4dd1fd55
    li x3, 0x4dd1fd55
    csrw 0x2ed, x3

    #Address 0x2ed read value
    csrr x14, 0x2ed

    #Address 0x2ed Write value 0x587a7cb0
    li x3, 0x587a7cb0
    csrw 0x2ed, x3

    #Address 0x2ed Write value 0xdd811a11
    li x3, 0xdd811a11
    csrw 0x2ed, x3

    #Unmapped address 0x917 testing: random write/read operations
    #Address 0x917 read value
    csrr x14, 0x917

    #Unmapped address 0x2ff testing: random write/read operations
    #Address 0x2ff read value
    csrr x14, 0x2ff

    #Address 0x2ff read value
    csrr x14, 0x2ff

    #Address 0x2ff Write value 0xe1fa130f
    li x3, 0xe1fa130f
    csrw 0x2ff, x3

    #Address 0x2ff Write value 0xaa5bd158
    li x3, 0xaa5bd158
    csrw 0x2ff, x3

    #Unmapped address 0xf0 testing: random write/read operations
    #Address 0xf0 read value
    csrr x14, 0xf0

    #Address 0xf0 Write value 0x47f19145
    li x3, 0x47f19145
    csrw 0xf0, x3

    #Address 0xf0 read value
    csrr x14, 0xf0

    #Address 0xf0 Write value 0x7808d716
    li x3, 0x7808d716
    csrw 0xf0, x3

    #Address 0xf0 read value
    csrr x14, 0xf0

    #Unmapped address 0x201 testing: random write/read operations
    #Address 0x201 read value
    csrr x14, 0x201

    #Address 0x201 Write value 0x5bfd4ee1
    li x3, 0x5bfd4ee1
    csrw 0x201, x3

    #Address 0x201 read value
    csrr x14, 0x201

    #Address 0x201 Write value 0x229abd29
    li x3, 0x229abd29
    csrw 0x201, x3

    #Address 0x201 Write value 0x38caf9a5
    li x3, 0x38caf9a5
    csrw 0x201, x3

    #Unmapped address 0xa81 testing: random write/read operations
    #Address 0xa81 Write value 0x719e8e9e
    li x3, 0x719e8e9e
    csrw 0xa81, x3

    #Address 0xa81 read value
    csrr x14, 0xa81

    #Address 0xa81 Write value 0xa57b5e55
    li x3, 0xa57b5e55
    csrw 0xa81, x3

    #Address 0xa81 Write value 0x4876da6b
    li x3, 0x4876da6b
    csrw 0xa81, x3

    #Unmapped address 0xca2 testing: random write/read operations
    #Address 0xca2 read value
    csrr x14, 0xca2

    #Address 0xca2 Write value 0x7c0ab0f6
    li x3, 0x7c0ab0f6
    csrw 0xca2, x3

    #Address 0xca2 Write value 0x8b02050d
    li x3, 0x8b02050d
    csrw 0xca2, x3

    #Unmapped address 0x828 testing: random write/read operations
    #Address 0x828 Write value 0xfba0cc36
    li x3, 0xfba0cc36
    csrw 0x828, x3

    #Address 0x828 Write value 0x4c925305
    li x3, 0x4c925305
    csrw 0x828, x3

    #Address 0x828 Write value 0x5eaeb075
    li x3, 0x5eaeb075
    csrw 0x828, x3

    #Address 0x828 Write value 0x29e527d4
    li x3, 0x29e527d4
    csrw 0x828, x3

    #Address 0x828 read value
    csrr x14, 0x828

    #Unmapped address 0x43 testing: random write/read operations
    #Address 0x43 read value
    csrr x14, 0x43

    #Address 0x43 read value
    csrr x14, 0x43

    #Unmapped address 0xa5d testing: random write/read operations
    #Address 0xa5d read value
    csrr x14, 0xa5d

    #Address 0xa5d Write value 0xeeadd8ad
    li x3, 0xeeadd8ad
    csrw 0xa5d, x3

    #Unmapped address 0x303 testing: random write/read operations
    #Address 0x303 read value
    csrr x14, 0x303

    #Address 0x303 Write value 0xa7644e91
    li x3, 0xa7644e91
    csrw 0x303, x3

    #Address 0x303 Write value 0x67e0a011
    li x3, 0x67e0a011
    csrw 0x303, x3

    #Unmapped address 0xb73 testing: random write/read operations
    #Address 0xb73 Write value 0x8fb7a12f
    li x3, 0x8fb7a12f
    csrw 0xb73, x3

    #Address 0xb73 read value
    csrr x14, 0xb73

    #Unmapped address 0xd41 testing: random write/read operations
    #Address 0xd41 Write value 0x6ac0a5e2
    li x3, 0x6ac0a5e2
    csrw 0xd41, x3

    #Unmapped address 0xdb0 testing: random write/read operations
    #Address 0xdb0 read value
    csrr x14, 0xdb0

    #Address 0xdb0 Write value 0x62625123
    li x3, 0x62625123
    csrw 0xdb0, x3

    #Address 0xdb0 Write value 0x616ab6a0
    li x3, 0x616ab6a0
    csrw 0xdb0, x3

    #Unmapped address 0x16a testing: random write/read operations
    #Address 0x16a read value
    csrr x14, 0x16a

    #Address 0x16a Write value 0xaec05323
    li x3, 0xaec05323
    csrw 0x16a, x3

    #Address 0x16a read value
    csrr x14, 0x16a

    #Unmapped address 0x427 testing: random write/read operations
    #Address 0x427 read value
    csrr x14, 0x427

    #Unmapped address 0x19b testing: random write/read operations
    #Address 0x19b read value
    csrr x14, 0x19b

    #Address 0x19b read value
    csrr x14, 0x19b

    #Address 0x19b read value
    csrr x14, 0x19b

    #Address 0x19b read value
    csrr x14, 0x19b

    #Unmapped address 0x91b testing: random write/read operations
    #Address 0x91b Write value 0xb6c750d6
    li x3, 0xb6c750d6
    csrw 0x91b, x3

    #Address 0x91b read value
    csrr x14, 0x91b

    #Address 0x91b Write value 0xb22b3576
    li x3, 0xb22b3576
    csrw 0x91b, x3

    #Address 0x91b read value
    csrr x14, 0x91b

    #Unmapped address 0x70d testing: random write/read operations
    #Address 0x70d read value
    csrr x14, 0x70d

    #Address 0x70d Write value 0x1237bd7b
    li x3, 0x1237bd7b
    csrw 0x70d, x3

    #Address 0x70d Write value 0x357bf9b2
    li x3, 0x357bf9b2
    csrw 0x70d, x3

    #Address 0x70d Write value 0x45d9eaf3
    li x3, 0x45d9eaf3
    csrw 0x70d, x3

    #Address 0x70d read value
    csrr x14, 0x70d

    #Unmapped address 0x65a testing: random write/read operations
    #Address 0x65a read value
    csrr x14, 0x65a

    #Address 0x65a Write value 0x3b923c81
    li x3, 0x3b923c81
    csrw 0x65a, x3

    #Address 0x65a Write value 0x2a24504a
    li x3, 0x2a24504a
    csrw 0x65a, x3

    #Unmapped address 0xbb6 testing: random write/read operations
    #Address 0xbb6 Write value 0x84c4a669
    li x3, 0x84c4a669
    csrw 0xbb6, x3

    #Address 0xbb6 read value
    csrr x14, 0xbb6

    #Address 0xbb6 Write value 0x98645998
    li x3, 0x98645998
    csrw 0xbb6, x3

    #Address 0xbb6 read value
    csrr x14, 0xbb6

    #Unmapped address 0xbbd testing: random write/read operations
    #Address 0xbbd Write value 0x4baa3d2c
    li x3, 0x4baa3d2c
    csrw 0xbbd, x3

    #Address 0xbbd Write value 0x9c2c22d8
    li x3, 0x9c2c22d8
    csrw 0xbbd, x3

    #Address 0xbbd Write value 0xec4bb233
    li x3, 0xec4bb233
    csrw 0xbbd, x3

    #Unmapped address 0x540 testing: random write/read operations
    #Address 0x540 read value
    csrr x14, 0x540

    #Address 0x540 read value
    csrr x14, 0x540

    #Address 0x540 Write value 0x6da3c7f9
    li x3, 0x6da3c7f9
    csrw 0x540, x3

    #Unmapped address 0x372 testing: random write/read operations
    #Address 0x372 read value
    csrr x14, 0x372

    #Address 0x372 Write value 0x9abfabb1
    li x3, 0x9abfabb1
    csrw 0x372, x3

    #Address 0x372 Write value 0xac4a282d
    li x3, 0xac4a282d
    csrw 0x372, x3

    #Address 0x372 Write value 0xd57da7c7
    li x3, 0xd57da7c7
    csrw 0x372, x3

    #Unmapped address 0x535 testing: random write/read operations
    #Address 0x535 read value
    csrr x14, 0x535

    #Address 0x535 Write value 0xb5ccc8d4
    li x3, 0xb5ccc8d4
    csrw 0x535, x3

    #Address 0x535 read value
    csrr x14, 0x535

    #Address 0x535 read value
    csrr x14, 0x535

    #Unmapped address 0x599 testing: random write/read operations
    #Address 0x599 Write value 0x518653f5
    li x3, 0x518653f5
    csrw 0x599, x3

    #Address 0x599 read value
    csrr x14, 0x599

    #Address 0x599 read value
    csrr x14, 0x599

    #Unmapped address 0x8f1 testing: random write/read operations
    #Address 0x8f1 read value
    csrr x14, 0x8f1

    #Address 0x8f1 read value
    csrr x14, 0x8f1

    #Address 0x8f1 Write value 0xd4c15175
    li x3, 0xd4c15175
    csrw 0x8f1, x3

    #Address 0x8f1 read value
    csrr x14, 0x8f1

    #Unmapped address 0x46b testing: random write/read operations
    #Address 0x46b Write value 0x41368833
    li x3, 0x41368833
    csrw 0x46b, x3

    #Unmapped address 0xe22 testing: random write/read operations
    #Address 0xe22 read value
    csrr x14, 0xe22

    #Address 0xe22 Write value 0x33c1cadb
    li x3, 0x33c1cadb
    csrw 0xe22, x3

    #Unmapped address 0x6f4 testing: random write/read operations
    #Address 0x6f4 read value
    csrr x14, 0x6f4

    #Address 0x6f4 read value
    csrr x14, 0x6f4

    #Address 0x6f4 Write value 0x1aa56f41
    li x3, 0x1aa56f41
    csrw 0x6f4, x3

    #Address 0x6f4 Write value 0x7489c59d
    li x3, 0x7489c59d
    csrw 0x6f4, x3

    #Unmapped address 0x9df testing: random write/read operations
    #Address 0x9df Write value 0xeee24d60
    li x3, 0xeee24d60
    csrw 0x9df, x3

    #Address 0x9df Write value 0x8a9506b
    li x3, 0x8a9506b
    csrw 0x9df, x3

    #Address 0x9df read value
    csrr x14, 0x9df

    #Unmapped address 0xfd2 testing: random write/read operations
    #Address 0xfd2 Write value 0xe175f4c6
    li x3, 0xe175f4c6
    csrw 0xfd2, x3

    #Address 0xfd2 read value
    csrr x14, 0xfd2

    #Address 0xfd2 read value
    csrr x14, 0xfd2

    #Address 0xfd2 read value
    csrr x14, 0xfd2

    #Address 0xfd2 read value
    csrr x14, 0xfd2

    #Unmapped address 0xbd6 testing: random write/read operations
    #Address 0xbd6 Write value 0x1d74b85
    li x3, 0x1d74b85
    csrw 0xbd6, x3

    #Address 0xbd6 read value
    csrr x14, 0xbd6

    #Address 0xbd6 read value
    csrr x14, 0xbd6

    #Address 0xbd6 Write value 0x4a18d287
    li x3, 0x4a18d287
    csrw 0xbd6, x3

    #Unmapped address 0xe92 testing: random write/read operations
    #Address 0xe92 read value
    csrr x14, 0xe92

    #Address 0xe92 read value
    csrr x14, 0xe92

    #Unmapped address 0x5bb testing: random write/read operations
    #Address 0x5bb read value
    csrr x14, 0x5bb

    #Unmapped address 0xaf7 testing: random write/read operations
    #Address 0xaf7 Write value 0x3b98c2a6
    li x3, 0x3b98c2a6
    csrw 0xaf7, x3

    #Address 0xaf7 read value
    csrr x14, 0xaf7

    #Address 0xaf7 Write value 0xe347e137
    li x3, 0xe347e137
    csrw 0xaf7, x3

    #Address 0xaf7 Write value 0xdb263e7d
    li x3, 0xdb263e7d
    csrw 0xaf7, x3

    #Unmapped address 0x896 testing: random write/read operations
    #Address 0x896 Write value 0x5a50edac
    li x3, 0x5a50edac
    csrw 0x896, x3

    #Address 0x896 Write value 0xfbcd20a8
    li x3, 0xfbcd20a8
    csrw 0x896, x3

    #Address 0x896 read value
    csrr x14, 0x896

    #Address 0x896 Write value 0x79cd7db3
    li x3, 0x79cd7db3
    csrw 0x896, x3

    #Unmapped address 0x7f6 testing: random write/read operations
    #Address 0x7f6 Write value 0x8f60da76
    li x3, 0x8f60da76
    csrw 0x7f6, x3

    #Address 0x7f6 read value
    csrr x14, 0x7f6

    #Address 0x7f6 Write value 0x230d1b09
    li x3, 0x230d1b09
    csrw 0x7f6, x3

    #Address 0x7f6 read value
    csrr x14, 0x7f6

    #Unmapped address 0xe40 testing: random write/read operations
    #Address 0xe40 read value
    csrr x14, 0xe40

    #Address 0xe40 read value
    csrr x14, 0xe40

    #Address 0xe40 Write value 0x82f1023f
    li x3, 0x82f1023f
    csrw 0xe40, x3

    #Unmapped address 0x4e6 testing: random write/read operations
    #Address 0x4e6 read value
    csrr x14, 0x4e6

    #Address 0x4e6 read value
    csrr x14, 0x4e6

    #Address 0x4e6 Write value 0x4065ccb1
    li x3, 0x4065ccb1
    csrw 0x4e6, x3

    #Address 0x4e6 read value
    csrr x14, 0x4e6

    #Address 0x4e6 read value
    csrr x14, 0x4e6

    #Unmapped address 0x7c testing: random write/read operations
    #Address 0x7c Write value 0x2272e632
    li x3, 0x2272e632
    csrw 0x7c, x3

    #Address 0x7c read value
    csrr x14, 0x7c

    #Unmapped address 0x23c testing: random write/read operations
    #Address 0x23c Write value 0xb66ce610
    li x3, 0xb66ce610
    csrw 0x23c, x3

    #Unmapped address 0x2f9 testing: random write/read operations
    #Address 0x2f9 Write value 0xb1773d1f
    li x3, 0xb1773d1f
    csrw 0x2f9, x3

    #Address 0x2f9 Write value 0x4f73d983
    li x3, 0x4f73d983
    csrw 0x2f9, x3

    #Address 0x2f9 read value
    csrr x14, 0x2f9

    #Unmapped address 0x1a0 testing: random write/read operations
    #Address 0x1a0 read value
    csrr x14, 0x1a0

    #Address 0x1a0 Write value 0x487a9aa6
    li x3, 0x487a9aa6
    csrw 0x1a0, x3

    #Address 0x1a0 read value
    csrr x14, 0x1a0

    #Address 0x1a0 Write value 0xfe3de5f
    li x3, 0xfe3de5f
    csrw 0x1a0, x3

    #Address 0x1a0 Write value 0x90488011
    li x3, 0x90488011
    csrw 0x1a0, x3

    #Unmapped address 0xf80 testing: random write/read operations
    #Address 0xf80 Write value 0x3106c50b
    li x3, 0x3106c50b
    csrw 0xf80, x3

    #Address 0xf80 Write value 0x64da9991
    li x3, 0x64da9991
    csrw 0xf80, x3

    #Address 0xf80 Write value 0x508d77d1
    li x3, 0x508d77d1
    csrw 0xf80, x3

    #Address 0xf80 Write value 0x5ec9799d
    li x3, 0x5ec9799d
    csrw 0xf80, x3

    #Unmapped address 0xfab testing: random write/read operations
    #Address 0xfab Write value 0xfd18a14c
    li x3, 0xfd18a14c
    csrw 0xfab, x3

    #Address 0xfab Write value 0x4a7a52cd
    li x3, 0x4a7a52cd
    csrw 0xfab, x3

    #Unmapped address 0xab testing: random write/read operations
    #Address 0xab Write value 0xd311d6cc
    li x3, 0xd311d6cc
    csrw 0xab, x3

    #Address 0xab read value
    csrr x14, 0xab

    #Address 0xab read value
    csrr x14, 0xab

    #Unmapped address 0xc9b testing: random write/read operations
    #Address 0xc9b read value
    csrr x14, 0xc9b

    #Address 0xc9b Write value 0x709a74
    li x3, 0x709a74
    csrw 0xc9b, x3

    #Address 0xc9b read value
    csrr x14, 0xc9b

    #Unmapped address 0x3e4 testing: random write/read operations
    #Address 0x3e4 read value
    csrr x14, 0x3e4

    #Address 0x3e4 Write value 0x1d783251
    li x3, 0x1d783251
    csrw 0x3e4, x3

    #Address 0x3e4 Write value 0x84421e8
    li x3, 0x84421e8
    csrw 0x3e4, x3

    #Address 0x3e4 Write value 0x29f8130a
    li x3, 0x29f8130a
    csrw 0x3e4, x3

    #Address 0x3e4 Write value 0xd9a0cda
    li x3, 0xd9a0cda
    csrw 0x3e4, x3

    #Unmapped address 0x1b3 testing: random write/read operations
    #Address 0x1b3 read value
    csrr x14, 0x1b3

    #Address 0x1b3 read value
    csrr x14, 0x1b3

    #Address 0x1b3 read value
    csrr x14, 0x1b3

    #Unmapped address 0x4f6 testing: random write/read operations
    #Address 0x4f6 Write value 0x4ce28532
    li x3, 0x4ce28532
    csrw 0x4f6, x3

    #Unmapped address 0x7e7 testing: random write/read operations
    #Address 0x7e7 Write value 0x8349ce5b
    li x3, 0x8349ce5b
    csrw 0x7e7, x3

    #Address 0x7e7 Write value 0x3e643cc1
    li x3, 0x3e643cc1
    csrw 0x7e7, x3

    #Unmapped address 0x803 testing: random write/read operations
    #Address 0x803 Write value 0xcb9a76e
    li x3, 0xcb9a76e
    csrw 0x803, x3

    #Unmapped address 0x992 testing: random write/read operations
    #Address 0x992 read value
    csrr x14, 0x992

    #Address 0x992 Write value 0x704485eb
    li x3, 0x704485eb
    csrw 0x992, x3

    #Address 0x992 Write value 0x39bbbaa3
    li x3, 0x39bbbaa3
    csrw 0x992, x3

    #Address 0x992 read value
    csrr x14, 0x992

    #Unmapped address 0xf0d testing: random write/read operations
    #Address 0xf0d Write value 0x39f879fb
    li x3, 0x39f879fb
    csrw 0xf0d, x3

    #Address 0xf0d Write value 0xb29e4f6d
    li x3, 0xb29e4f6d
    csrw 0xf0d, x3

    #Unmapped address 0xcd4 testing: random write/read operations
    #Address 0xcd4 read value
    csrr x14, 0xcd4

    #Address 0xcd4 read value
    csrr x14, 0xcd4

    #Unmapped address 0x6b3 testing: random write/read operations
    #Address 0x6b3 read value
    csrr x14, 0x6b3

    #Address 0x6b3 Write value 0x2f4c93a
    li x3, 0x2f4c93a
    csrw 0x6b3, x3

    #Address 0x6b3 read value
    csrr x14, 0x6b3

    #Address 0x6b3 Write value 0xfcd1ea47
    li x3, 0xfcd1ea47
    csrw 0x6b3, x3

    #Unmapped address 0x251 testing: random write/read operations
    #Address 0x251 read value
    csrr x14, 0x251

    #Unmapped address 0x767 testing: random write/read operations
    #Address 0x767 read value
    csrr x14, 0x767

    #Unmapped address 0xe13 testing: random write/read operations
    #Address 0xe13 Write value 0x947c3a4d
    li x3, 0x947c3a4d
    csrw 0xe13, x3

    #Unmapped address 0x5e3 testing: random write/read operations
    #Address 0x5e3 read value
    csrr x14, 0x5e3

    #Address 0x5e3 Write value 0x4fe6cef5
    li x3, 0x4fe6cef5
    csrw 0x5e3, x3

    #Address 0x5e3 Write value 0x310ce79f
    li x3, 0x310ce79f
    csrw 0x5e3, x3

    #Unmapped address 0xd54 testing: random write/read operations
    #Address 0xd54 read value
    csrr x14, 0xd54

    #Address 0xd54 Write value 0xd0c86c1c
    li x3, 0xd0c86c1c
    csrw 0xd54, x3

    #Address 0xd54 read value
    csrr x14, 0xd54

    #Address 0xd54 read value
    csrr x14, 0xd54

    #Address 0xd54 Write value 0xe72ba1b0
    li x3, 0xe72ba1b0
    csrw 0xd54, x3

    #Unmapped address 0xdfd testing: random write/read operations
    #Address 0xdfd read value
    csrr x14, 0xdfd

    #Address 0xdfd read value
    csrr x14, 0xdfd

    #Address 0xdfd Write value 0x2a7147ef
    li x3, 0x2a7147ef
    csrw 0xdfd, x3

    #Address 0xdfd Write value 0x891c0fb4
    li x3, 0x891c0fb4
    csrw 0xdfd, x3

    #Unmapped address 0xfef testing: random write/read operations
    #Address 0xfef Write value 0x6ee1a982
    li x3, 0x6ee1a982
    csrw 0xfef, x3

    #Address 0xfef Write value 0x3190b68c
    li x3, 0x3190b68c
    csrw 0xfef, x3

    #Unmapped address 0x933 testing: random write/read operations
    #Address 0x933 Write value 0xbc4942e3
    li x3, 0xbc4942e3
    csrw 0x933, x3

    #Address 0x933 read value
    csrr x14, 0x933

    #Address 0x933 read value
    csrr x14, 0x933

    #Address 0x933 Write value 0x6f64220f
    li x3, 0x6f64220f
    csrw 0x933, x3

    #Unmapped address 0x5a1 testing: random write/read operations
    #Address 0x5a1 Write value 0xc7e8a882
    li x3, 0xc7e8a882
    csrw 0x5a1, x3

    #Address 0x5a1 Write value 0xb5de3ebc
    li x3, 0xb5de3ebc
    csrw 0x5a1, x3

    #Unmapped address 0x641 testing: random write/read operations
    #Address 0x641 read value
    csrr x14, 0x641

    #Address 0x641 Write value 0x11bc382c
    li x3, 0x11bc382c
    csrw 0x641, x3

    #Address 0x641 read value
    csrr x14, 0x641

    #Address 0x641 read value
    csrr x14, 0x641

    #Address 0x641 read value
    csrr x14, 0x641

    #Unmapped address 0x10c testing: random write/read operations
    #Address 0x10c Write value 0xd3fbf66f
    li x3, 0xd3fbf66f
    csrw 0x10c, x3

    #Unmapped address 0xb7a testing: random write/read operations
    #Address 0xb7a Write value 0xd54c363
    li x3, 0xd54c363
    csrw 0xb7a, x3

    #Address 0xb7a read value
    csrr x14, 0xb7a

    #Unmapped address 0x105 testing: random write/read operations
    #Address 0x105 read value
    csrr x14, 0x105

    #Address 0x105 Write value 0x6afb97c4
    li x3, 0x6afb97c4
    csrw 0x105, x3

    #Address 0x105 Write value 0x34658418
    li x3, 0x34658418
    csrw 0x105, x3

    #Address 0x105 Write value 0x62289996
    li x3, 0x62289996
    csrw 0x105, x3

    #Unmapped address 0xc97 testing: random write/read operations
    #Address 0xc97 read value
    csrr x14, 0xc97

    #Address 0xc97 read value
    csrr x14, 0xc97

    #Address 0xc97 Write value 0x9beead83
    li x3, 0x9beead83
    csrw 0xc97, x3

    #Address 0xc97 read value
    csrr x14, 0xc97

    #Unmapped address 0xa8a testing: random write/read operations
    #Address 0xa8a read value
    csrr x14, 0xa8a

    #Address 0xa8a read value
    csrr x14, 0xa8a

    #Unmapped address 0xf33 testing: random write/read operations
    #Address 0xf33 Write value 0x70c2de12
    li x3, 0x70c2de12
    csrw 0xf33, x3

    #Address 0xf33 Write value 0xb4cb3fc6
    li x3, 0xb4cb3fc6
    csrw 0xf33, x3

    #Address 0xf33 Write value 0xde4ac6aa
    li x3, 0xde4ac6aa
    csrw 0xf33, x3

    #Unmapped address 0x307 testing: random write/read operations
    #Address 0x307 read value
    csrr x14, 0x307

    #Address 0x307 read value
    csrr x14, 0x307

    #Address 0x307 Write value 0x2acf1eaf
    li x3, 0x2acf1eaf
    csrw 0x307, x3

    #Address 0x307 Write value 0xae7ddcff
    li x3, 0xae7ddcff
    csrw 0x307, x3

    #Address 0x307 read value
    csrr x14, 0x307

    #Unmapped address 0x278 testing: random write/read operations
    #Address 0x278 Write value 0xd2e2fde4
    li x3, 0xd2e2fde4
    csrw 0x278, x3

    #Address 0x278 Write value 0x368bd360
    li x3, 0x368bd360
    csrw 0x278, x3

    #Address 0x278 Write value 0xaad76fa2
    li x3, 0xaad76fa2
    csrw 0x278, x3

    #Address 0x278 read value
    csrr x14, 0x278

    #Address 0x278 Write value 0xb69b5f03
    li x3, 0xb69b5f03
    csrw 0x278, x3

    #Unmapped address 0x112 testing: random write/read operations
    #Address 0x112 Write value 0xd6555ffb
    li x3, 0xd6555ffb
    csrw 0x112, x3

    #Address 0x112 Write value 0x4129f782
    li x3, 0x4129f782
    csrw 0x112, x3

    #Unmapped address 0xba8 testing: random write/read operations
    #Address 0xba8 Write value 0xbed12e23
    li x3, 0xbed12e23
    csrw 0xba8, x3

    #Address 0xba8 read value
    csrr x14, 0xba8

    #Address 0xba8 Write value 0xda2c961c
    li x3, 0xda2c961c
    csrw 0xba8, x3

    #Address 0xba8 Write value 0x75bd03dd
    li x3, 0x75bd03dd
    csrw 0xba8, x3

    #Address 0xba8 read value
    csrr x14, 0xba8

    #Unmapped address 0x6f8 testing: random write/read operations
    #Address 0x6f8 Write value 0xef100d9f
    li x3, 0xef100d9f
    csrw 0x6f8, x3

    #Address 0x6f8 Write value 0x2c3bc9de
    li x3, 0x2c3bc9de
    csrw 0x6f8, x3

    #Address 0x6f8 Write value 0x34f52cc4
    li x3, 0x34f52cc4
    csrw 0x6f8, x3

    #Unmapped address 0xaac testing: random write/read operations
    #Address 0xaac read value
    csrr x14, 0xaac

    #Address 0xaac read value
    csrr x14, 0xaac

    #Address 0xaac read value
    csrr x14, 0xaac

    #Address 0xaac Write value 0xa73be4f3
    li x3, 0xa73be4f3
    csrw 0xaac, x3

    #Unmapped address 0x97b testing: random write/read operations
    #Address 0x97b Write value 0xb171b5b0
    li x3, 0xb171b5b0
    csrw 0x97b, x3

    #Address 0x97b Write value 0xac554f87
    li x3, 0xac554f87
    csrw 0x97b, x3

    #Address 0x97b Write value 0x2e9121be
    li x3, 0x2e9121be
    csrw 0x97b, x3

    #Unmapped address 0x11c testing: random write/read operations
    #Address 0x11c Write value 0x9fed6b8
    li x3, 0x9fed6b8
    csrw 0x11c, x3

    #Address 0x11c read value
    csrr x14, 0x11c

    #Address 0x11c Write value 0x2e7a2dec
    li x3, 0x2e7a2dec
    csrw 0x11c, x3

    #Address 0x11c Write value 0x6e17f440
    li x3, 0x6e17f440
    csrw 0x11c, x3

    #Unmapped address 0x6c6 testing: random write/read operations
    #Address 0x6c6 Write value 0xdc5a103d
    li x3, 0xdc5a103d
    csrw 0x6c6, x3

    #Address 0x6c6 Write value 0x692c8796
    li x3, 0x692c8796
    csrw 0x6c6, x3

    #Address 0x6c6 Write value 0xd9c14a7f
    li x3, 0xd9c14a7f
    csrw 0x6c6, x3

    #Address 0x6c6 read value
    csrr x14, 0x6c6

    #Unmapped address 0x649 testing: random write/read operations
    #Address 0x649 read value
    csrr x14, 0x649

    #Unmapped address 0x409 testing: random write/read operations
    #Address 0x409 read value
    csrr x14, 0x409

    #Address 0x409 read value
    csrr x14, 0x409

    #Address 0x409 read value
    csrr x14, 0x409

    #Address 0x409 Write value 0x2a4bcb88
    li x3, 0x2a4bcb88
    csrw 0x409, x3

    #Address 0x409 Write value 0x9c16a6fd
    li x3, 0x9c16a6fd
    csrw 0x409, x3

    #Unmapped address 0x5c0 testing: random write/read operations
    #Address 0x5c0 read value
    csrr x14, 0x5c0

    #Address 0x5c0 read value
    csrr x14, 0x5c0

    #Address 0x5c0 Write value 0xf0ce14e5
    li x3, 0xf0ce14e5
    csrw 0x5c0, x3

    #Unmapped address 0x6b6 testing: random write/read operations
    #Address 0x6b6 read value
    csrr x14, 0x6b6

    #Address 0x6b6 Write value 0xd4a89d63
    li x3, 0xd4a89d63
    csrw 0x6b6, x3

    #Mapped address 0xb8f (mhpmcounterh15) testing: random write/read operations
    #Address 0xb8f read value
    csrr x14, 0xb8f

    #Address 0xb8f read value
    csrr x14, 0xb8f

    #Unmapped address 0xebc testing: random write/read operations
    #Address 0xebc Write value 0x12963119
    li x3, 0x12963119
    csrw 0xebc, x3

    #Address 0xebc read value
    csrr x14, 0xebc

    #Address 0xebc read value
    csrr x14, 0xebc

    #Unmapped address 0x7c1 testing: random write/read operations
    #Address 0x7c1 Write value 0x665d699e
    li x3, 0x665d699e
    csrw 0x7c1, x3

    #Address 0x7c1 Write value 0x4b5ac9fe
    li x3, 0x4b5ac9fe
    csrw 0x7c1, x3

    #Address 0x7c1 Write value 0xe48c8c29
    li x3, 0xe48c8c29
    csrw 0x7c1, x3

    #Address 0x7c1 Write value 0xa2147b2
    li x3, 0xa2147b2
    csrw 0x7c1, x3

    #Address 0x7c1 Write value 0x788d3cf4
    li x3, 0x788d3cf4
    csrw 0x7c1, x3

    #Unmapped address 0x1be testing: random write/read operations
    #Address 0x1be Write value 0xdeb58274
    li x3, 0xdeb58274
    csrw 0x1be, x3

    #Address 0x1be read value
    csrr x14, 0x1be

    #Address 0x1be Write value 0x5e0fb0b5
    li x3, 0x5e0fb0b5
    csrw 0x1be, x3

    #Unmapped address 0xe75 testing: random write/read operations
    #Address 0xe75 Write value 0x18fce56e
    li x3, 0x18fce56e
    csrw 0xe75, x3

    #Address 0xe75 read value
    csrr x14, 0xe75

    #Address 0xe75 Write value 0xc3e8751f
    li x3, 0xc3e8751f
    csrw 0xe75, x3

    #Address 0xe75 read value
    csrr x14, 0xe75

    #Address 0xe75 Write value 0x1568c851
    li x3, 0x1568c851
    csrw 0xe75, x3

    #Unmapped address 0x903 testing: random write/read operations
    #Address 0x903 read value
    csrr x14, 0x903

    #Unmapped address 0xbcc testing: random write/read operations
    #Address 0xbcc Write value 0xffceccc4
    li x3, 0xffceccc4
    csrw 0xbcc, x3

    #Address 0xbcc Write value 0xb606db94
    li x3, 0xb606db94
    csrw 0xbcc, x3

    #Address 0xbcc read value
    csrr x14, 0xbcc

    #Address 0xbcc Write value 0x39081bb8
    li x3, 0x39081bb8
    csrw 0xbcc, x3

    #Address 0xbcc read value
    csrr x14, 0xbcc

    #Unmapped address 0x20d testing: random write/read operations
    #Address 0x20d Write value 0xdc5bfe5e
    li x3, 0xdc5bfe5e
    csrw 0x20d, x3

    #Address 0x20d read value
    csrr x14, 0x20d

    #Address 0x20d read value
    csrr x14, 0x20d

    #Unmapped address 0x1e1 testing: random write/read operations
    #Address 0x1e1 Write value 0xe167ee76
    li x3, 0xe167ee76
    csrw 0x1e1, x3

    #Address 0x1e1 read value
    csrr x14, 0x1e1

    #Address 0x1e1 read value
    csrr x14, 0x1e1

    #Address 0x1e1 Write value 0xb4ae6e8c
    li x3, 0xb4ae6e8c
    csrw 0x1e1, x3

    #Address 0x1e1 Write value 0xf2d29ef0
    li x3, 0xf2d29ef0
    csrw 0x1e1, x3

    #Unmapped address 0x693 testing: random write/read operations
    #Address 0x693 read value
    csrr x14, 0x693

    #Address 0x693 Write value 0xa227d714
    li x3, 0xa227d714
    csrw 0x693, x3

    #Address 0x693 read value
    csrr x14, 0x693

    #Address 0x693 Write value 0x502daf00
    li x3, 0x502daf00
    csrw 0x693, x3

    #Address 0x693 read value
    csrr x14, 0x693

    #Unmapped address 0x69e testing: random write/read operations
    #Address 0x69e Write value 0x76726ca3
    li x3, 0x76726ca3
    csrw 0x69e, x3

    #Address 0x69e Write value 0x19b37d67
    li x3, 0x19b37d67
    csrw 0x69e, x3

    #Address 0x69e Write value 0x9fa3528c
    li x3, 0x9fa3528c
    csrw 0x69e, x3

    #Address 0x69e Write value 0xd54a4d7d
    li x3, 0xd54a4d7d
    csrw 0x69e, x3

    #Address 0x69e Write value 0x33c0eac0
    li x3, 0x33c0eac0
    csrw 0x69e, x3

    #Unmapped address 0xce5 testing: random write/read operations
    #Address 0xce5 Write value 0x5c4612f
    li x3, 0x5c4612f
    csrw 0xce5, x3

    #Address 0xce5 read value
    csrr x14, 0xce5

    #Address 0xce5 read value
    csrr x14, 0xce5

    #Address 0xce5 read value
    csrr x14, 0xce5

    #Unmapped address 0x131 testing: random write/read operations
    #Address 0x131 Write value 0x24cbbbe
    li x3, 0x24cbbbe
    csrw 0x131, x3

    #Address 0x131 read value
    csrr x14, 0x131

    #Address 0x131 read value
    csrr x14, 0x131

    #Address 0x131 Write value 0xe97c293e
    li x3, 0xe97c293e
    csrw 0x131, x3

    #Unmapped address 0x236 testing: random write/read operations
    #Address 0x236 read value
    csrr x14, 0x236

    #Unmapped address 0xe6e testing: random write/read operations
    #Address 0xe6e Write value 0x5f7cfbf1
    li x3, 0x5f7cfbf1
    csrw 0xe6e, x3

    #Unmapped address 0xec1 testing: random write/read operations
    #Address 0xec1 read value
    csrr x14, 0xec1

    #Address 0xec1 read value
    csrr x14, 0xec1

    #Unmapped address 0xe32 testing: random write/read operations
    #Address 0xe32 read value
    csrr x14, 0xe32

    #Address 0xe32 read value
    csrr x14, 0xe32

    #Address 0xe32 Write value 0x4a2b9cbb
    li x3, 0x4a2b9cbb
    csrw 0xe32, x3

    #Unmapped address 0x406 testing: random write/read operations
    #Address 0x406 read value
    csrr x14, 0x406

    #Address 0x406 Write value 0x58d56c1
    li x3, 0x58d56c1
    csrw 0x406, x3

    #Address 0x406 Write value 0x9eb3766c
    li x3, 0x9eb3766c
    csrw 0x406, x3

    #Address 0x406 read value
    csrr x14, 0x406

    #Address 0x406 read value
    csrr x14, 0x406

    #Unmapped address 0x353 testing: random write/read operations
    #Address 0x353 Write value 0x4c3b568c
    li x3, 0x4c3b568c
    csrw 0x353, x3

    #Address 0x353 Write value 0xd1406502
    li x3, 0xd1406502
    csrw 0x353, x3

    #Address 0x353 read value
    csrr x14, 0x353

    #Unmapped address 0x23f testing: random write/read operations
    #Address 0x23f read value
    csrr x14, 0x23f

    #Unmapped address 0xc71 testing: random write/read operations
    #Address 0xc71 Write value 0x54d87edf
    li x3, 0x54d87edf
    csrw 0xc71, x3

    #Unmapped address 0x89 testing: random write/read operations
    #Address 0x89 read value
    csrr x14, 0x89

    #Address 0x89 Write value 0xda5217ae
    li x3, 0xda5217ae
    csrw 0x89, x3

    #Address 0x89 read value
    csrr x14, 0x89

    #Address 0x89 read value
    csrr x14, 0x89

    #Address 0x89 Write value 0xfa8bc18d
    li x3, 0xfa8bc18d
    csrw 0x89, x3

    #Unmapped address 0xd8b testing: random write/read operations
    #Address 0xd8b Write value 0x9245fb0a
    li x3, 0x9245fb0a
    csrw 0xd8b, x3

    #Address 0xd8b Write value 0xca78f55f
    li x3, 0xca78f55f
    csrw 0xd8b, x3

    #Unmapped address 0x9d testing: random write/read operations
    #Address 0x9d Write value 0x6351cdde
    li x3, 0x6351cdde
    csrw 0x9d, x3

    #Address 0x9d Write value 0x839aeb74
    li x3, 0x839aeb74
    csrw 0x9d, x3

    #Address 0x9d read value
    csrr x14, 0x9d

    #Unmapped address 0x6f1 testing: random write/read operations
    #Address 0x6f1 read value
    csrr x14, 0x6f1

    #Address 0x6f1 Write value 0x402102ab
    li x3, 0x402102ab
    csrw 0x6f1, x3

    #Address 0x6f1 Write value 0xf8bb7a66
    li x3, 0xf8bb7a66
    csrw 0x6f1, x3

    #Address 0x6f1 read value
    csrr x14, 0x6f1

    #Unmapped address 0x3c5 testing: random write/read operations
    #Address 0x3c5 Write value 0x9d42861f
    li x3, 0x9d42861f
    csrw 0x3c5, x3

    #Address 0x3c5 Write value 0x3d017ca4
    li x3, 0x3d017ca4
    csrw 0x3c5, x3

    #Unmapped address 0x2ba testing: random write/read operations
    #Address 0x2ba read value
    csrr x14, 0x2ba

    #Unmapped address 0x55b testing: random write/read operations
    #Address 0x55b Write value 0x6ec1032d
    li x3, 0x6ec1032d
    csrw 0x55b, x3

    #Address 0x55b read value
    csrr x14, 0x55b

    #Unmapped address 0x127 testing: random write/read operations
    #Address 0x127 Write value 0xde166d71
    li x3, 0xde166d71
    csrw 0x127, x3

    #Unmapped address 0x868 testing: random write/read operations
    #Address 0x868 read value
    csrr x14, 0x868

    #Address 0x868 Write value 0xdac8388b
    li x3, 0xdac8388b
    csrw 0x868, x3

    #Unmapped address 0x4b1 testing: random write/read operations
    #Address 0x4b1 Write value 0x3236f67a
    li x3, 0x3236f67a
    csrw 0x4b1, x3

    #Address 0x4b1 Write value 0xf7274f68
    li x3, 0xf7274f68
    csrw 0x4b1, x3

    #Unmapped address 0xdb1 testing: random write/read operations
    #Address 0xdb1 Write value 0xd77d7947
    li x3, 0xd77d7947
    csrw 0xdb1, x3

    #Address 0xdb1 Write value 0xa400cb34
    li x3, 0xa400cb34
    csrw 0xdb1, x3

    #Address 0xdb1 Write value 0xedf96b5d
    li x3, 0xedf96b5d
    csrw 0xdb1, x3

    #Unmapped address 0xd7e testing: random write/read operations
    #Address 0xd7e Write value 0xe33d3c08
    li x3, 0xe33d3c08
    csrw 0xd7e, x3

    #Address 0xd7e read value
    csrr x14, 0xd7e

    #Unmapped address 0x831 testing: random write/read operations
    #Address 0x831 Write value 0x99c5dc5c
    li x3, 0x99c5dc5c
    csrw 0x831, x3

    #Address 0x831 Write value 0x4b63ab8
    li x3, 0x4b63ab8
    csrw 0x831, x3

    #Address 0x831 Write value 0xaf5abce4
    li x3, 0xaf5abce4
    csrw 0x831, x3

    #Unmapped address 0x4e7 testing: random write/read operations
    #Address 0x4e7 Write value 0xc82a8e56
    li x3, 0xc82a8e56
    csrw 0x4e7, x3

    #Address 0x4e7 Write value 0x396a08ef
    li x3, 0x396a08ef
    csrw 0x4e7, x3

    #Address 0x4e7 Write value 0x3cff62d3
    li x3, 0x3cff62d3
    csrw 0x4e7, x3

    #Unmapped address 0x7d8 testing: random write/read operations
    #Address 0x7d8 read value
    csrr x14, 0x7d8

    #Unmapped address 0x44f testing: random write/read operations
    #Address 0x44f read value
    csrr x14, 0x44f

    #Address 0x44f read value
    csrr x14, 0x44f

    #Address 0x44f Write value 0x565fb1f2
    li x3, 0x565fb1f2
    csrw 0x44f, x3

    #Address 0x44f Write value 0xfb7df2d
    li x3, 0xfb7df2d
    csrw 0x44f, x3

    #Unmapped address 0x73e testing: random write/read operations
    #Address 0x73e read value
    csrr x14, 0x73e

    #Unmapped address 0xe4b testing: random write/read operations
    #Address 0xe4b read value
    csrr x14, 0xe4b

    #Unmapped address 0x368 testing: random write/read operations
    #Address 0x368 Write value 0xfa1adbf2
    li x3, 0xfa1adbf2
    csrw 0x368, x3

    #Address 0x368 Write value 0x93734689
    li x3, 0x93734689
    csrw 0x368, x3

    #Address 0x368 Write value 0x13586812
    li x3, 0x13586812
    csrw 0x368, x3

    #Unmapped address 0xb21 testing: random write/read operations
    #Address 0xb21 read value
    csrr x14, 0xb21

    #Address 0xb21 Write value 0x67ea7219
    li x3, 0x67ea7219
    csrw 0xb21, x3

    #Address 0xb21 Write value 0xd72a23bd
    li x3, 0xd72a23bd
    csrw 0xb21, x3

    #Unmapped address 0xa3a testing: random write/read operations
    #Address 0xa3a read value
    csrr x14, 0xa3a

    #Address 0xa3a Write value 0x58e90ebb
    li x3, 0x58e90ebb
    csrw 0xa3a, x3

    #Address 0xa3a Write value 0x79023873
    li x3, 0x79023873
    csrw 0xa3a, x3

    #Address 0xa3a read value
    csrr x14, 0xa3a

    #Unmapped address 0x49a testing: random write/read operations
    #Address 0x49a read value
    csrr x14, 0x49a

    #Unmapped address 0x979 testing: random write/read operations
    #Address 0x979 read value
    csrr x14, 0x979

    #Unmapped address 0x40f testing: random write/read operations
    #Address 0x40f Write value 0x1e18aaa2
    li x3, 0x1e18aaa2
    csrw 0x40f, x3

    #Address 0x40f read value
    csrr x14, 0x40f

    #Unmapped address 0xcc3 testing: random write/read operations
    #Address 0xcc3 read value
    csrr x14, 0xcc3

    #Unmapped address 0x975 testing: random write/read operations
    #Address 0x975 read value
    csrr x14, 0x975

    #Unmapped address 0x900 testing: random write/read operations
    #Address 0x900 read value
    csrr x14, 0x900

    #Address 0x900 Write value 0x99b69cef
    li x3, 0x99b69cef
    csrw 0x900, x3

    #Address 0x900 read value
    csrr x14, 0x900

    #Unmapped address 0xc43 testing: random write/read operations
    #Address 0xc43 Write value 0xe8064cfc
    li x3, 0xe8064cfc
    csrw 0xc43, x3

    #Address 0xc43 read value
    csrr x14, 0xc43

    #Address 0xc43 read value
    csrr x14, 0xc43

    #Address 0xc43 Write value 0x400f35c5
    li x3, 0x400f35c5
    csrw 0xc43, x3

    #Address 0xc43 read value
    csrr x14, 0xc43

    #Unmapped address 0x99 testing: random write/read operations
    #Address 0x99 read value
    csrr x14, 0x99

    #Address 0x99 read value
    csrr x14, 0x99

    #Address 0x99 Write value 0x3aaad1d
    li x3, 0x3aaad1d
    csrw 0x99, x3

    #Unmapped address 0xbb3 testing: random write/read operations
    #Address 0xbb3 Write value 0x23405ea1
    li x3, 0x23405ea1
    csrw 0xbb3, x3

    #Address 0xbb3 Write value 0xa309dd6a
    li x3, 0xa309dd6a
    csrw 0xbb3, x3

    #Unmapped address 0xa24 testing: random write/read operations
    #Address 0xa24 Write value 0xc7996623
    li x3, 0xc7996623
    csrw 0xa24, x3

    #Unmapped address 0xfa1 testing: random write/read operations
    #Address 0xfa1 Write value 0xbecaa4f2
    li x3, 0xbecaa4f2
    csrw 0xfa1, x3

    #Address 0xfa1 Write value 0xfc3e2870
    li x3, 0xfc3e2870
    csrw 0xfa1, x3

    #Unmapped address 0x19f testing: random write/read operations
    #Address 0x19f Write value 0xeef1f1ec
    li x3, 0xeef1f1ec
    csrw 0x19f, x3

    #Unmapped address 0x7ee testing: random write/read operations
    #Address 0x7ee read value
    csrr x14, 0x7ee

    #Address 0x7ee Write value 0x2ab5bd4
    li x3, 0x2ab5bd4
    csrw 0x7ee, x3

    #Address 0x7ee Write value 0x4c68e55
    li x3, 0x4c68e55
    csrw 0x7ee, x3

    #Address 0x7ee read value
    csrr x14, 0x7ee

    #Unmapped address 0xf9b testing: random write/read operations
    #Address 0xf9b Write value 0xe05d80a
    li x3, 0xe05d80a
    csrw 0xf9b, x3

    #Address 0xf9b read value
    csrr x14, 0xf9b

    #Unmapped address 0x753 testing: random write/read operations
    #Address 0x753 Write value 0x8ea7c87c
    li x3, 0x8ea7c87c
    csrw 0x753, x3

    #Address 0x753 read value
    csrr x14, 0x753

    #Address 0x753 read value
    csrr x14, 0x753

    #Address 0x753 Write value 0x155b39b1
    li x3, 0x155b39b1
    csrw 0x753, x3

    #Address 0x753 Write value 0x7a2db366
    li x3, 0x7a2db366
    csrw 0x753, x3

    #Unmapped address 0xee3 testing: random write/read operations
    #Address 0xee3 Write value 0xcf94e7ce
    li x3, 0xcf94e7ce
    csrw 0xee3, x3

    #Unmapped address 0xbff testing: random write/read operations
    #Address 0xbff Write value 0x1e23b2
    li x3, 0x1e23b2
    csrw 0xbff, x3

    #Address 0xbff read value
    csrr x14, 0xbff

    #Address 0xbff read value
    csrr x14, 0xbff

    #Unmapped address 0xaa6 testing: random write/read operations
    #Address 0xaa6 Write value 0xc9f4870c
    li x3, 0xc9f4870c
    csrw 0xaa6, x3

    #Address 0xaa6 read value
    csrr x14, 0xaa6

    #Address 0xaa6 read value
    csrr x14, 0xaa6

    #Address 0xaa6 Write value 0xc7b5b27d
    li x3, 0xc7b5b27d
    csrw 0xaa6, x3

    #Address 0xaa6 Write value 0x72c4824f
    li x3, 0x72c4824f
    csrw 0xaa6, x3

    #Unmapped address 0x8ac testing: random write/read operations
    #Address 0x8ac Write value 0x1d349512
    li x3, 0x1d349512
    csrw 0x8ac, x3

    #Address 0x8ac read value
    csrr x14, 0x8ac

    #Address 0x8ac read value
    csrr x14, 0x8ac

    #Address 0x8ac Write value 0xfb63f466
    li x3, 0xfb63f466
    csrw 0x8ac, x3

    #Address 0x8ac read value
    csrr x14, 0x8ac

    #Unmapped address 0x14d testing: random write/read operations
    #Address 0x14d Write value 0x4ef4ec0d
    li x3, 0x4ef4ec0d
    csrw 0x14d, x3

    #Address 0x14d Write value 0x61d8b65b
    li x3, 0x61d8b65b
    csrw 0x14d, x3

    #Address 0x14d Write value 0xf5ddd568
    li x3, 0xf5ddd568
    csrw 0x14d, x3

    #Address 0x14d read value
    csrr x14, 0x14d

    #Address 0x14d read value
    csrr x14, 0x14d

    #Unmapped address 0xa96 testing: random write/read operations
    #Address 0xa96 Write value 0x1c5e1449
    li x3, 0x1c5e1449
    csrw 0xa96, x3

    #Address 0xa96 Write value 0x21e5c8ce
    li x3, 0x21e5c8ce
    csrw 0xa96, x3

    #Address 0xa96 Write value 0x13a3e6cf
    li x3, 0x13a3e6cf
    csrw 0xa96, x3

    #Unmapped address 0x257 testing: random write/read operations
    #Address 0x257 read value
    csrr x14, 0x257

    #Address 0x257 Write value 0xf30fbeca
    li x3, 0xf30fbeca
    csrw 0x257, x3

    #Address 0x257 Write value 0x5f0677b9
    li x3, 0x5f0677b9
    csrw 0x257, x3

    #Address 0x257 Write value 0x3844462
    li x3, 0x3844462
    csrw 0x257, x3

    #Unmapped address 0xedb testing: random write/read operations
    #Address 0xedb read value
    csrr x14, 0xedb

    #Address 0xedb read value
    csrr x14, 0xedb

    #Address 0xedb Write value 0x1895a406
    li x3, 0x1895a406
    csrw 0xedb, x3

    #Address 0xedb Write value 0x5b4f840e
    li x3, 0x5b4f840e
    csrw 0xedb, x3

    #Unmapped address 0x76f testing: random write/read operations
    #Address 0x76f read value
    csrr x14, 0x76f

    #Address 0x76f Write value 0xd55ee9f1
    li x3, 0xd55ee9f1
    csrw 0x76f, x3

    #Address 0x76f read value
    csrr x14, 0x76f

    #Unmapped address 0xd0b testing: random write/read operations
    #Address 0xd0b Write value 0x382ea879
    li x3, 0x382ea879
    csrw 0xd0b, x3

    #Address 0xd0b read value
    csrr x14, 0xd0b

    #Address 0xd0b Write value 0x91d08193
    li x3, 0x91d08193
    csrw 0xd0b, x3

    #Address 0xd0b Write value 0xfd6319f9
    li x3, 0xfd6319f9
    csrw 0xd0b, x3

    #Unmapped address 0x73c testing: random write/read operations
    #Address 0x73c read value
    csrr x14, 0x73c

    #Address 0x73c Write value 0x42b96662
    li x3, 0x42b96662
    csrw 0x73c, x3

    #Address 0x73c read value
    csrr x14, 0x73c

    #Address 0x73c Write value 0x72526c18
    li x3, 0x72526c18
    csrw 0x73c, x3

    #Address 0x73c Write value 0x1ef2fa14
    li x3, 0x1ef2fa14
    csrw 0x73c, x3

    #Unmapped address 0x7b1 testing: random write/read operations
    #Address 0x7b1 read value
    csrr x14, 0x7b1

    #Unmapped address 0xe2d testing: random write/read operations
    #Address 0xe2d read value
    csrr x14, 0xe2d

    #Unmapped address 0x678 testing: random write/read operations
    #Address 0x678 Write value 0x32c4559b
    li x3, 0x32c4559b
    csrw 0x678, x3

    #Address 0x678 read value
    csrr x14, 0x678

    #Address 0x678 read value
    csrr x14, 0x678

    #Unmapped address 0x22b testing: random write/read operations
    #Address 0x22b Write value 0xc72669b0
    li x3, 0xc72669b0
    csrw 0x22b, x3

    #Address 0x22b Write value 0x973c96b4
    li x3, 0x973c96b4
    csrw 0x22b, x3

    #Unmapped address 0x64f testing: random write/read operations
    #Address 0x64f Write value 0xaa50391a
    li x3, 0xaa50391a
    csrw 0x64f, x3

    #Address 0x64f read value
    csrr x14, 0x64f

    #Unmapped address 0x63d testing: random write/read operations
    #Address 0x63d Write value 0x5259008c
    li x3, 0x5259008c
    csrw 0x63d, x3

    #Address 0x63d read value
    csrr x14, 0x63d

    #Address 0x63d read value
    csrr x14, 0x63d

    #Unmapped address 0x381 testing: random write/read operations
    #Address 0x381 Write value 0x1d38f1d1
    li x3, 0x1d38f1d1
    csrw 0x381, x3

    #Address 0x381 Write value 0x4fcfc2d9
    li x3, 0x4fcfc2d9
    csrw 0x381, x3

    #Address 0x381 Write value 0x8b0ac6e9
    li x3, 0x8b0ac6e9
    csrw 0x381, x3

    #Unmapped address 0x464 testing: random write/read operations
    #Address 0x464 read value
    csrr x14, 0x464

    #Mapped address 0x333 (mhpmevent19) testing: random write/read operations
    #Address 0x333 read value
    csrr x14, 0x333

    #Address 0x333 read value
    csrr x14, 0x333

    #Address 0x333 Write value 0x1d02d0a3
    li x3, 0x1d02d0a3
    csrw 0x333, x3

    #Address 0x333 read value
    csrr x14, 0x333

    #Mapped address 0xb8d (mhpmcounterh13) testing: random write/read operations
    #Address 0xb8d read value
    csrr x14, 0xb8d

    #Address 0xb8d Write value 0xd56aeeeb
    li x3, 0xd56aeeeb
    csrw 0xb8d, x3

    #Unmapped address 0xba4 testing: random write/read operations
    #Address 0xba4 Write value 0x1fe6685
    li x3, 0x1fe6685
    csrw 0xba4, x3

    #Address 0xba4 Write value 0xe01e9a17
    li x3, 0xe01e9a17
    csrw 0xba4, x3

    #Address 0xba4 read value
    csrr x14, 0xba4

    #Unmapped address 0x848 testing: random write/read operations
    #Address 0x848 Write value 0xcf211269
    li x3, 0xcf211269
    csrw 0x848, x3

    #Address 0x848 Write value 0x2ece2301
    li x3, 0x2ece2301
    csrw 0x848, x3

    #Address 0x848 read value
    csrr x14, 0x848

    #Address 0x848 read value
    csrr x14, 0x848

    #Address 0x848 Write value 0x5cf4a2cd
    li x3, 0x5cf4a2cd
    csrw 0x848, x3

    #Unmapped address 0xff8 testing: random write/read operations
    #Address 0xff8 Write value 0x3f22368c
    li x3, 0x3f22368c
    csrw 0xff8, x3

    #Address 0xff8 Write value 0x91da449
    li x3, 0x91da449
    csrw 0xff8, x3

    #Address 0xff8 Write value 0x9dcd00fb
    li x3, 0x9dcd00fb
    csrw 0xff8, x3

    #Address 0xff8 read value
    csrr x14, 0xff8

    #Address 0xff8 read value
    csrr x14, 0xff8

    #Unmapped address 0x74c testing: random write/read operations
    #Address 0x74c Write value 0x490c61ee
    li x3, 0x490c61ee
    csrw 0x74c, x3

    #Unmapped address 0x42b testing: random write/read operations
    #Address 0x42b Write value 0xa8727598
    li x3, 0xa8727598
    csrw 0x42b, x3

    #Address 0x42b read value
    csrr x14, 0x42b

    #Address 0x42b Write value 0xc78c9ca6
    li x3, 0xc78c9ca6
    csrw 0x42b, x3

    #Unmapped address 0x6f0 testing: random write/read operations
    #Address 0x6f0 read value
    csrr x14, 0x6f0

    #Address 0x6f0 Write value 0x19885a99
    li x3, 0x19885a99
    csrw 0x6f0, x3

    #Address 0x6f0 Write value 0x10322884
    li x3, 0x10322884
    csrw 0x6f0, x3

    #Unmapped address 0xf7f testing: random write/read operations
    #Address 0xf7f Write value 0xf7ce5731
    li x3, 0xf7ce5731
    csrw 0xf7f, x3

    #Address 0xf7f Write value 0xbc34d975
    li x3, 0xbc34d975
    csrw 0xf7f, x3

    #Address 0xf7f read value
    csrr x14, 0xf7f

    #Unmapped address 0x9d2 testing: random write/read operations
    #Address 0x9d2 Write value 0xf153fbcd
    li x3, 0xf153fbcd
    csrw 0x9d2, x3

    #Address 0x9d2 Write value 0x7f6d24da
    li x3, 0x7f6d24da
    csrw 0x9d2, x3

    #Mapped address 0x3a2 (pmpcfg2) testing: random write/read operations
    #Address 0x3a2 read value
    csrr x14, 0x3a2

    #Address 0x3a2 read value
    csrr x14, 0x3a2

    #Address 0x3a2 read value
    csrr x14, 0x3a2

    #Address 0x3a2 read value
    csrr x14, 0x3a2

    #Address 0x3a2 read value
    csrr x14, 0x3a2

    #Unmapped address 0xc72 testing: random write/read operations
    #Address 0xc72 read value
    csrr x14, 0xc72

    #Address 0xc72 Write value 0xd7c6c1b0
    li x3, 0xd7c6c1b0
    csrw 0xc72, x3

    #Unmapped address 0xd92 testing: random write/read operations
    #Address 0xd92 read value
    csrr x14, 0xd92

    #Address 0xd92 read value
    csrr x14, 0xd92

    #Address 0xd92 read value
    csrr x14, 0xd92

    #Address 0xd92 Write value 0x1e5ba549
    li x3, 0x1e5ba549
    csrw 0xd92, x3

    #Address 0xd92 read value
    csrr x14, 0xd92

    #Unmapped address 0x202 testing: random write/read operations
    #Address 0x202 Write value 0x38c956ef
    li x3, 0x38c956ef
    csrw 0x202, x3

    #Address 0x202 Write value 0x9b6e4a7d
    li x3, 0x9b6e4a7d
    csrw 0x202, x3

    #Address 0x202 Write value 0x9577313c
    li x3, 0x9577313c
    csrw 0x202, x3

    #Address 0x202 Write value 0xeb53a501
    li x3, 0xeb53a501
    csrw 0x202, x3

    #Unmapped address 0x416 testing: random write/read operations
    #Address 0x416 Write value 0x858fc1eb
    li x3, 0x858fc1eb
    csrw 0x416, x3

    #Unmapped address 0xc6e testing: random write/read operations
    #Address 0xc6e Write value 0x427c5c78
    li x3, 0x427c5c78
    csrw 0xc6e, x3

    #Address 0xc6e read value
    csrr x14, 0xc6e

    #Address 0xc6e read value
    csrr x14, 0xc6e

    #Address 0xc6e Write value 0xdb954a8e
    li x3, 0xdb954a8e
    csrw 0xc6e, x3

    #Address 0xc6e Write value 0x4d7f088f
    li x3, 0x4d7f088f
    csrw 0xc6e, x3

    #Unmapped address 0x674 testing: random write/read operations
    #Address 0x674 read value
    csrr x14, 0x674

    #Address 0x674 read value
    csrr x14, 0x674

    #Address 0x674 read value
    csrr x14, 0x674

    #Unmapped address 0xe87 testing: random write/read operations
    #Address 0xe87 Write value 0x41f1f094
    li x3, 0x41f1f094
    csrw 0xe87, x3

    #Address 0xe87 read value
    csrr x14, 0xe87

    #Address 0xe87 read value
    csrr x14, 0xe87

    #Unmapped address 0xbd0 testing: random write/read operations
    #Address 0xbd0 read value
    csrr x14, 0xbd0

    #Address 0xbd0 Write value 0xd9c79f26
    li x3, 0xd9c79f26
    csrw 0xbd0, x3

    #Address 0xbd0 Write value 0x7ee5a2e8
    li x3, 0x7ee5a2e8
    csrw 0xbd0, x3

    #Address 0xbd0 read value
    csrr x14, 0xbd0

    #Unmapped address 0x779 testing: random write/read operations
    #Address 0x779 read value
    csrr x14, 0x779

    #Address 0x779 read value
    csrr x14, 0x779

    #Address 0x779 Write value 0x89c335d6
    li x3, 0x89c335d6
    csrw 0x779, x3

    #Unmapped address 0x78d testing: random write/read operations
    #Address 0x78d read value
    csrr x14, 0x78d

    #Address 0x78d read value
    csrr x14, 0x78d

    #Address 0x78d read value
    csrr x14, 0x78d

    #Address 0x78d Write value 0x6080b89a
    li x3, 0x6080b89a
    csrw 0x78d, x3

    #Address 0x78d read value
    csrr x14, 0x78d

    #Unmapped address 0xe8 testing: random write/read operations
    #Address 0xe8 read value
    csrr x14, 0xe8

    #Address 0xe8 read value
    csrr x14, 0xe8

    #Address 0xe8 read value
    csrr x14, 0xe8

    #Unmapped address 0x6d0 testing: random write/read operations
    #Address 0x6d0 Write value 0x1c9e493e
    li x3, 0x1c9e493e
    csrw 0x6d0, x3

    #Address 0x6d0 Write value 0x3e868536
    li x3, 0x3e868536
    csrw 0x6d0, x3

    #Address 0x6d0 Write value 0xc6d59d9
    li x3, 0xc6d59d9
    csrw 0x6d0, x3

    #Address 0x6d0 Write value 0x7c725d4
    li x3, 0x7c725d4
    csrw 0x6d0, x3

    #Unmapped address 0x5dc testing: random write/read operations
    #Address 0x5dc Write value 0xfae85d2
    li x3, 0xfae85d2
    csrw 0x5dc, x3

    #Address 0x5dc Write value 0x63cfba4
    li x3, 0x63cfba4
    csrw 0x5dc, x3

    #Unmapped address 0x2e7 testing: random write/read operations
    #Address 0x2e7 read value
    csrr x14, 0x2e7

    #Unmapped address 0x37 testing: random write/read operations
    #Address 0x37 Write value 0x9553b841
    li x3, 0x9553b841
    csrw 0x37, x3

    #Address 0x37 read value
    csrr x14, 0x37

    #Unmapped address 0x59f testing: random write/read operations
    #Address 0x59f Write value 0x81837c75
    li x3, 0x81837c75
    csrw 0x59f, x3

    #Address 0x59f read value
    csrr x14, 0x59f

    #Address 0x59f Write value 0x5e61bf8a
    li x3, 0x5e61bf8a
    csrw 0x59f, x3

    #Address 0x59f Write value 0x66b0dec5
    li x3, 0x66b0dec5
    csrw 0x59f, x3

    #Unmapped address 0xead testing: random write/read operations
    #Address 0xead Write value 0x7467dc00
    li x3, 0x7467dc00
    csrw 0xead, x3

    #Address 0xead read value
    csrr x14, 0xead

    #Unmapped address 0x399 testing: random write/read operations
    #Address 0x399 read value
    csrr x14, 0x399

    #Address 0x399 read value
    csrr x14, 0x399

    #Address 0x399 Write value 0x45ac1284
    li x3, 0x45ac1284
    csrw 0x399, x3

    #Unmapped address 0x8d0 testing: random write/read operations
    #Address 0x8d0 Write value 0x23a6893a
    li x3, 0x23a6893a
    csrw 0x8d0, x3

    #Address 0x8d0 read value
    csrr x14, 0x8d0

    #Address 0x8d0 Write value 0x3ac2171a
    li x3, 0x3ac2171a
    csrw 0x8d0, x3

    #Address 0x8d0 read value
    csrr x14, 0x8d0

    #Address 0x8d0 Write value 0x6ee48cd7
    li x3, 0x6ee48cd7
    csrw 0x8d0, x3

    #Unmapped address 0x7f4 testing: random write/read operations
    #Address 0x7f4 Write value 0xad2de160
    li x3, 0xad2de160
    csrw 0x7f4, x3

    #Address 0x7f4 Write value 0x4c87d401
    li x3, 0x4c87d401
    csrw 0x7f4, x3

    #Address 0x7f4 read value
    csrr x14, 0x7f4

    #Address 0x7f4 read value
    csrr x14, 0x7f4

    #Address 0x7f4 Write value 0x657d9508
    li x3, 0x657d9508
    csrw 0x7f4, x3

    #Unmapped address 0xed3 testing: random write/read operations
    #Address 0xed3 Write value 0xf7aa0531
    li x3, 0xf7aa0531
    csrw 0xed3, x3

    #Address 0xed3 read value
    csrr x14, 0xed3

    #Address 0xed3 Write value 0x9a005c7f
    li x3, 0x9a005c7f
    csrw 0xed3, x3

    #Address 0xed3 Write value 0xe360437c
    li x3, 0xe360437c
    csrw 0xed3, x3

    #Address 0xed3 read value
    csrr x14, 0xed3

    #Unmapped address 0xde0 testing: random write/read operations
    #Address 0xde0 Write value 0xe31d3039
    li x3, 0xe31d3039
    csrw 0xde0, x3

    #Address 0xde0 read value
    csrr x14, 0xde0

    #Address 0xde0 read value
    csrr x14, 0xde0

    #Unmapped address 0x7c6 testing: random write/read operations
    #Address 0x7c6 Write value 0x1b217bbb
    li x3, 0x1b217bbb
    csrw 0x7c6, x3

    #Address 0x7c6 Write value 0x1af2b09b
    li x3, 0x1af2b09b
    csrw 0x7c6, x3

    #Address 0x7c6 Write value 0x862f271a
    li x3, 0x862f271a
    csrw 0x7c6, x3

    #Address 0x7c6 Write value 0x403a3c6d
    li x3, 0x403a3c6d
    csrw 0x7c6, x3

    #Unmapped address 0xaca testing: random write/read operations
    #Address 0xaca read value
    csrr x14, 0xaca

    #Address 0xaca Write value 0x74d0be33
    li x3, 0x74d0be33
    csrw 0xaca, x3

    #Address 0xaca Write value 0xacea25f9
    li x3, 0xacea25f9
    csrw 0xaca, x3

    #Address 0xaca read value
    csrr x14, 0xaca

    #Address 0xaca Write value 0xb6f4a170
    li x3, 0xb6f4a170
    csrw 0xaca, x3

    #Unmapped address 0xbc4 testing: random write/read operations
    #Address 0xbc4 Write value 0x6e35c08a
    li x3, 0x6e35c08a
    csrw 0xbc4, x3

    #Unmapped address 0x6c1 testing: random write/read operations
    #Address 0x6c1 Write value 0xa169a2d
    li x3, 0xa169a2d
    csrw 0x6c1, x3

    #Unmapped address 0xa5c testing: random write/read operations
    #Address 0xa5c Write value 0xefd9b8d5
    li x3, 0xefd9b8d5
    csrw 0xa5c, x3

    #Unmapped address 0xd06 testing: random write/read operations
    #Address 0xd06 Write value 0x99201f1c
    li x3, 0x99201f1c
    csrw 0xd06, x3

    #Unmapped address 0x38d testing: random write/read operations
    #Address 0x38d Write value 0x6152ec96
    li x3, 0x6152ec96
    csrw 0x38d, x3

    #Address 0x38d read value
    csrr x14, 0x38d

    #Unmapped address 0x14b testing: random write/read operations
    #Address 0x14b Write value 0x4ef0d043
    li x3, 0x4ef0d043
    csrw 0x14b, x3

    #Address 0x14b Write value 0x9b7b124d
    li x3, 0x9b7b124d
    csrw 0x14b, x3

    #Address 0x14b read value
    csrr x14, 0x14b

    #Address 0x14b read value
    csrr x14, 0x14b

    #Unmapped address 0x54 testing: random write/read operations
    #Address 0x54 read value
    csrr x14, 0x54

    #Unmapped address 0x8f5 testing: random write/read operations
    #Address 0x8f5 Write value 0xed4a6a16
    li x3, 0xed4a6a16
    csrw 0x8f5, x3

    #Address 0x8f5 Write value 0xe9ca3083
    li x3, 0xe9ca3083
    csrw 0x8f5, x3

    #Address 0x8f5 Write value 0x1fa9c1f4
    li x3, 0x1fa9c1f4
    csrw 0x8f5, x3

    #Address 0x8f5 read value
    csrr x14, 0x8f5

    #Address 0x8f5 read value
    csrr x14, 0x8f5

    #Unmapped address 0x565 testing: random write/read operations
    #Address 0x565 Write value 0xdb0b1b7d
    li x3, 0xdb0b1b7d
    csrw 0x565, x3

    #Address 0x565 read value
    csrr x14, 0x565

    #Address 0x565 Write value 0xde06babe
    li x3, 0xde06babe
    csrw 0x565, x3

    #Unmapped address 0x11d testing: random write/read operations
    #Address 0x11d read value
    csrr x14, 0x11d

    #Unmapped address 0xbf5 testing: random write/read operations
    #Address 0xbf5 Write value 0xd852ab2e
    li x3, 0xd852ab2e
    csrw 0xbf5, x3

    #Address 0xbf5 read value
    csrr x14, 0xbf5

    #Address 0xbf5 read value
    csrr x14, 0xbf5

    #Address 0xbf5 read value
    csrr x14, 0xbf5

    #Unmapped address 0x806 testing: random write/read operations
    #Address 0x806 read value
    csrr x14, 0x806

    #Address 0x806 Write value 0x56622211
    li x3, 0x56622211
    csrw 0x806, x3

    #Address 0x806 Write value 0xbebd8cc5
    li x3, 0xbebd8cc5
    csrw 0x806, x3

    #Unmapped address 0x119 testing: random write/read operations
    #Address 0x119 read value
    csrr x14, 0x119

    #Address 0x119 read value
    csrr x14, 0x119

    #Address 0x119 Write value 0x1e5c5b3d
    li x3, 0x1e5c5b3d
    csrw 0x119, x3

    #Address 0x119 Write value 0xc434fb32
    li x3, 0xc434fb32
    csrw 0x119, x3

    #Unmapped address 0xa50 testing: random write/read operations
    #Address 0xa50 Write value 0xec4baab2
    li x3, 0xec4baab2
    csrw 0xa50, x3

    #Unmapped address 0x608 testing: random write/read operations
    #Address 0x608 Write value 0xe45adc9b
    li x3, 0xe45adc9b
    csrw 0x608, x3

    #Address 0x608 Write value 0xe95601e4
    li x3, 0xe95601e4
    csrw 0x608, x3

    #Address 0x608 Write value 0x9746a39f
    li x3, 0x9746a39f
    csrw 0x608, x3

    #Address 0x608 read value
    csrr x14, 0x608

    #Address 0x608 Write value 0x9e06c429
    li x3, 0x9e06c429
    csrw 0x608, x3

    #Unmapped address 0x9c7 testing: random write/read operations
    #Address 0x9c7 Write value 0xb86e9fac
    li x3, 0xb86e9fac
    csrw 0x9c7, x3

    #Address 0x9c7 read value
    csrr x14, 0x9c7

    #Address 0x9c7 Write value 0x23c239eb
    li x3, 0x23c239eb
    csrw 0x9c7, x3

    #Address 0x9c7 Write value 0xad1ed32f
    li x3, 0xad1ed32f
    csrw 0x9c7, x3

    #Address 0x9c7 read value
    csrr x14, 0x9c7

    #Unmapped address 0x358 testing: random write/read operations
    #Address 0x358 read value
    csrr x14, 0x358

    #Address 0x358 read value
    csrr x14, 0x358

    #Address 0x358 read value
    csrr x14, 0x358

    #Unmapped address 0x2e testing: random write/read operations
    #Address 0x2e Write value 0x42f9f96f
    li x3, 0x42f9f96f
    csrw 0x2e, x3

    #Address 0x2e read value
    csrr x14, 0x2e

    #Address 0x2e Write value 0x58b93506
    li x3, 0x58b93506
    csrw 0x2e, x3

    #Address 0x2e Write value 0x40204ce3
    li x3, 0x40204ce3
    csrw 0x2e, x3

    #Address 0x2e read value
    csrr x14, 0x2e

    #Unmapped address 0x1d7 testing: random write/read operations
    #Address 0x1d7 Write value 0x83c4a8b1
    li x3, 0x83c4a8b1
    csrw 0x1d7, x3

    #Address 0x1d7 read value
    csrr x14, 0x1d7

    #Unmapped address 0x4b9 testing: random write/read operations
    #Address 0x4b9 read value
    csrr x14, 0x4b9

    #Address 0x4b9 Write value 0x9fab50f6
    li x3, 0x9fab50f6
    csrw 0x4b9, x3

    #Address 0x4b9 Write value 0xa400280
    li x3, 0xa400280
    csrw 0x4b9, x3

    #Unmapped address 0xe9d testing: random write/read operations
    #Address 0xe9d read value
    csrr x14, 0xe9d

    #Address 0xe9d read value
    csrr x14, 0xe9d

    #Unmapped address 0xf97 testing: random write/read operations
    #Address 0xf97 read value
    csrr x14, 0xf97

    #Address 0xf97 Write value 0x7d36201b
    li x3, 0x7d36201b
    csrw 0xf97, x3

    #Address 0xf97 read value
    csrr x14, 0xf97

    #Address 0xf97 Write value 0x1d53850f
    li x3, 0x1d53850f
    csrw 0xf97, x3

    #Unmapped address 0xcb6 testing: random write/read operations
    #Address 0xcb6 Write value 0x3c8d4c08
    li x3, 0x3c8d4c08
    csrw 0xcb6, x3

    #Address 0xcb6 Write value 0x82e00c27
    li x3, 0x82e00c27
    csrw 0xcb6, x3

    #Address 0xcb6 Write value 0x83fc4b78
    li x3, 0x83fc4b78
    csrw 0xcb6, x3

    #Address 0xcb6 Write value 0x110d88c1
    li x3, 0x110d88c1
    csrw 0xcb6, x3

    #Address 0xcb6 read value
    csrr x14, 0xcb6

    #Unmapped address 0xd32 testing: random write/read operations
    #Address 0xd32 read value
    csrr x14, 0xd32

    #Unmapped address 0x61b testing: random write/read operations
    #Address 0x61b Write value 0x47438e5f
    li x3, 0x47438e5f
    csrw 0x61b, x3

    #Address 0x61b read value
    csrr x14, 0x61b

    #Address 0x61b Write value 0x8cdcae60
    li x3, 0x8cdcae60
    csrw 0x61b, x3

    #Address 0x61b read value
    csrr x14, 0x61b

    #Unmapped address 0x59b testing: random write/read operations
    #Address 0x59b read value
    csrr x14, 0x59b

    #Address 0x59b read value
    csrr x14, 0x59b

    #Address 0x59b Write value 0xec5731c4
    li x3, 0xec5731c4
    csrw 0x59b, x3

    #Address 0x59b read value
    csrr x14, 0x59b

    #Unmapped address 0xa9a testing: random write/read operations
    #Address 0xa9a Write value 0x221674fe
    li x3, 0x221674fe
    csrw 0xa9a, x3

    #Address 0xa9a read value
    csrr x14, 0xa9a

    #Unmapped address 0xb30 testing: random write/read operations
    #Address 0xb30 Write value 0x17c976fe
    li x3, 0x17c976fe
    csrw 0xb30, x3

    #Unmapped address 0xa0d testing: random write/read operations
    #Address 0xa0d read value
    csrr x14, 0xa0d

    #Unmapped address 0x90e testing: random write/read operations
    #Address 0x90e Write value 0x81b05ea7
    li x3, 0x81b05ea7
    csrw 0x90e, x3

    #Address 0x90e Write value 0xc6ef057d
    li x3, 0xc6ef057d
    csrw 0x90e, x3

    #Address 0x90e read value
    csrr x14, 0x90e

    #Address 0x90e Write value 0x848ec495
    li x3, 0x848ec495
    csrw 0x90e, x3

    #Mapped address 0xb91 (mhpmcounterh17) testing: random write/read operations
    #Address 0xb91 Write value 0x40bdce8e
    li x3, 0x40bdce8e
    csrw 0xb91, x3

    #Address 0xb91 Write value 0x8d593b58
    li x3, 0x8d593b58
    csrw 0xb91, x3

    #Address 0xb91 read value
    csrr x14, 0xb91

    #Unmapped address 0x28c testing: random write/read operations
    #Address 0x28c Write value 0xb7be5052
    li x3, 0xb7be5052
    csrw 0x28c, x3

    #Address 0x28c read value
    csrr x14, 0x28c

    #Address 0x28c read value
    csrr x14, 0x28c

    #Address 0x28c Write value 0xdb175c2c
    li x3, 0xdb175c2c
    csrw 0x28c, x3

    #Unmapped address 0x8a2 testing: random write/read operations
    #Address 0x8a2 read value
    csrr x14, 0x8a2

    #Address 0x8a2 Write value 0x5c522d71
    li x3, 0x5c522d71
    csrw 0x8a2, x3

    #Unmapped address 0xa87 testing: random write/read operations
    #Address 0xa87 Write value 0x7aac360c
    li x3, 0x7aac360c
    csrw 0xa87, x3

    #Address 0xa87 Write value 0xade2a06a
    li x3, 0xade2a06a
    csrw 0xa87, x3

    #Address 0xa87 Write value 0x57d06685
    li x3, 0x57d06685
    csrw 0xa87, x3

    #Address 0xa87 read value
    csrr x14, 0xa87

    #Address 0xa87 read value
    csrr x14, 0xa87

    #Unmapped address 0xad7 testing: random write/read operations
    #Address 0xad7 Write value 0x681b7daa
    li x3, 0x681b7daa
    csrw 0xad7, x3

    #Address 0xad7 Write value 0x21d196db
    li x3, 0x21d196db
    csrw 0xad7, x3

    #Address 0xad7 Write value 0xeb0b2c11
    li x3, 0xeb0b2c11
    csrw 0xad7, x3

    #Address 0xad7 Write value 0xceab28c4
    li x3, 0xceab28c4
    csrw 0xad7, x3

    #Unmapped address 0x187 testing: random write/read operations
    #Address 0x187 Write value 0xea2315ac
    li x3, 0xea2315ac
    csrw 0x187, x3

    #Address 0x187 Write value 0x23b2abd7
    li x3, 0x23b2abd7
    csrw 0x187, x3

    #Address 0x187 Write value 0xb553b6ce
    li x3, 0xb553b6ce
    csrw 0x187, x3

    #Address 0x187 read value
    csrr x14, 0x187

    #Unmapped address 0xa2b testing: random write/read operations
    #Address 0xa2b Write value 0x5cf1631f
    li x3, 0x5cf1631f
    csrw 0xa2b, x3

    #Address 0xa2b read value
    csrr x14, 0xa2b

    #Address 0xa2b read value
    csrr x14, 0xa2b

    #Unmapped address 0xac3 testing: random write/read operations
    #Address 0xac3 Write value 0x2105498
    li x3, 0x2105498
    csrw 0xac3, x3

    #Address 0xac3 read value
    csrr x14, 0xac3

    #Address 0xac3 read value
    csrr x14, 0xac3

    #Address 0xac3 Write value 0xf9d14a91
    li x3, 0xf9d14a91
    csrw 0xac3, x3

    #Unmapped address 0x19c testing: random write/read operations
    #Address 0x19c Write value 0xac018c7c
    li x3, 0xac018c7c
    csrw 0x19c, x3

    #Address 0x19c read value
    csrr x14, 0x19c

    #Address 0x19c read value
    csrr x14, 0x19c

    #Address 0x19c read value
    csrr x14, 0x19c

    #Address 0x19c read value
    csrr x14, 0x19c

    #Unmapped address 0x6cd testing: random write/read operations
    #Address 0x6cd Write value 0xfabf809
    li x3, 0xfabf809
    csrw 0x6cd, x3

    #Address 0x6cd Write value 0xe6bba554
    li x3, 0xe6bba554
    csrw 0x6cd, x3

    #Unmapped address 0xf85 testing: random write/read operations
    #Address 0xf85 read value
    csrr x14, 0xf85

    #Address 0xf85 Write value 0x9ecf06dd
    li x3, 0x9ecf06dd
    csrw 0xf85, x3

    #Address 0xf85 read value
    csrr x14, 0xf85

    #Address 0xf85 Write value 0xb05ece71
    li x3, 0xb05ece71
    csrw 0xf85, x3

    #Address 0xf85 Write value 0x3786adfc
    li x3, 0x3786adfc
    csrw 0xf85, x3

    #Unmapped address 0xf53 testing: random write/read operations
    #Address 0xf53 Write value 0xe6c3b4d4
    li x3, 0xe6c3b4d4
    csrw 0xf53, x3

    #Unmapped address 0xc1a testing: random write/read operations
    #Address 0xc1a read value
    csrr x14, 0xc1a

    #Address 0xc1a Write value 0x1ce4c2c9
    li x3, 0x1ce4c2c9
    csrw 0xc1a, x3

    #Unmapped address 0x86a testing: random write/read operations
    #Address 0x86a read value
    csrr x14, 0x86a

    #Address 0x86a Write value 0x234650d3
    li x3, 0x234650d3
    csrw 0x86a, x3

    #Address 0x86a read value
    csrr x14, 0x86a

    #Address 0x86a Write value 0x6eafe4e
    li x3, 0x6eafe4e
    csrw 0x86a, x3

    #Unmapped address 0x162 testing: random write/read operations
    #Address 0x162 Write value 0x50fa705f
    li x3, 0x50fa705f
    csrw 0x162, x3

    #Unmapped address 0x100 testing: random write/read operations
    #Address 0x100 Write value 0x56271800
    li x3, 0x56271800
    csrw 0x100, x3

    #Address 0x100 Write value 0xbbd08958
    li x3, 0xbbd08958
    csrw 0x100, x3

    #Address 0x100 read value
    csrr x14, 0x100

    #Unmapped address 0xaaa testing: random write/read operations
    #Address 0xaaa read value
    csrr x14, 0xaaa

    #Address 0xaaa Write value 0xca2207c1
    li x3, 0xca2207c1
    csrw 0xaaa, x3

    #Address 0xaaa Write value 0xa4c14b39
    li x3, 0xa4c14b39
    csrw 0xaaa, x3

    #Address 0xaaa read value
    csrr x14, 0xaaa

    #Unmapped address 0xf24 testing: random write/read operations
    #Address 0xf24 read value
    csrr x14, 0xf24

    #Address 0xf24 Write value 0xe43dd75a
    li x3, 0xe43dd75a
    csrw 0xf24, x3

    #Unmapped address 0x76e testing: random write/read operations
    #Address 0x76e read value
    csrr x14, 0x76e

    #Address 0x76e read value
    csrr x14, 0x76e

    #Address 0x76e Write value 0x45394b3f
    li x3, 0x45394b3f
    csrw 0x76e, x3

    #Unmapped address 0xd2f testing: random write/read operations
    #Address 0xd2f Write value 0x9fcf5143
    li x3, 0x9fcf5143
    csrw 0xd2f, x3

    #Address 0xd2f read value
    csrr x14, 0xd2f

    #Address 0xd2f read value
    csrr x14, 0xd2f

    #Address 0xd2f read value
    csrr x14, 0xd2f

    #Address 0xd2f Write value 0x9dd7f6b7
    li x3, 0x9dd7f6b7
    csrw 0xd2f, x3

    #Unmapped address 0x421 testing: random write/read operations
    #Address 0x421 read value
    csrr x14, 0x421

    #Address 0x421 Write value 0x7f5c0371
    li x3, 0x7f5c0371
    csrw 0x421, x3

    #Address 0x421 read value
    csrr x14, 0x421

    #Unmapped address 0x877 testing: random write/read operations
    #Address 0x877 Write value 0x2fc3ad42
    li x3, 0x2fc3ad42
    csrw 0x877, x3

    #Address 0x877 read value
    csrr x14, 0x877

    #Address 0x877 read value
    csrr x14, 0x877

    #Address 0x877 Write value 0x6d03a3c9
    li x3, 0x6d03a3c9
    csrw 0x877, x3

    #Address 0x877 read value
    csrr x14, 0x877

    #Unmapped address 0x57b testing: random write/read operations
    #Address 0x57b read value
    csrr x14, 0x57b

    #Address 0x57b read value
    csrr x14, 0x57b

    #Address 0x57b Write value 0xd601b0a8
    li x3, 0xd601b0a8
    csrw 0x57b, x3

    #Address 0x57b read value
    csrr x14, 0x57b

    #Unmapped address 0x98e testing: random write/read operations
    #Address 0x98e read value
    csrr x14, 0x98e

    #Unmapped address 0x288 testing: random write/read operations
    #Address 0x288 Write value 0x440415fb
    li x3, 0x440415fb
    csrw 0x288, x3

    #Address 0x288 Write value 0x5c62336
    li x3, 0x5c62336
    csrw 0x288, x3

    #Address 0x288 read value
    csrr x14, 0x288

    #Address 0x288 read value
    csrr x14, 0x288

    #Address 0x288 Write value 0x5bb883d1
    li x3, 0x5bb883d1
    csrw 0x288, x3

    #Unmapped address 0x8a0 testing: random write/read operations
    #Address 0x8a0 read value
    csrr x14, 0x8a0

    #Address 0x8a0 read value
    csrr x14, 0x8a0

    #Unmapped address 0xebd testing: random write/read operations
    #Address 0xebd read value
    csrr x14, 0xebd

    #Address 0xebd read value
    csrr x14, 0xebd

    #Unmapped address 0x243 testing: random write/read operations
    #Address 0x243 read value
    csrr x14, 0x243

    #Unmapped address 0xd86 testing: random write/read operations
    #Address 0xd86 read value
    csrr x14, 0xd86

    #Unmapped address 0xb8 testing: random write/read operations
    #Address 0xb8 Write value 0x1bdf49b6
    li x3, 0x1bdf49b6
    csrw 0xb8, x3

    #Address 0xb8 Write value 0x8effc8e1
    li x3, 0x8effc8e1
    csrw 0xb8, x3

    #Address 0xb8 read value
    csrr x14, 0xb8

    #Address 0xb8 Write value 0xf0206924
    li x3, 0xf0206924
    csrw 0xb8, x3

    #Address 0xb8 Write value 0xa2da40d2
    li x3, 0xa2da40d2
    csrw 0xb8, x3

    #Unmapped address 0x7aa testing: random write/read operations
    #Address 0x7aa read value
    csrr x14, 0x7aa

    #Address 0x7aa read value
    csrr x14, 0x7aa

    #Address 0x7aa read value
    csrr x14, 0x7aa

    #Unmapped address 0x713 testing: random write/read operations
    #Address 0x713 read value
    csrr x14, 0x713

    #Address 0x713 Write value 0x9b1def12
    li x3, 0x9b1def12
    csrw 0x713, x3

    #Address 0x713 read value
    csrr x14, 0x713

    #Unmapped address 0x7eb testing: random write/read operations
    #Address 0x7eb Write value 0x96a323fb
    li x3, 0x96a323fb
    csrw 0x7eb, x3

    #Address 0x7eb read value
    csrr x14, 0x7eb

    #Address 0x7eb read value
    csrr x14, 0x7eb

    #Address 0x7eb Write value 0xd4dc73a2
    li x3, 0xd4dc73a2
    csrw 0x7eb, x3

    #Address 0x7eb Write value 0xf220b868
    li x3, 0xf220b868
    csrw 0x7eb, x3

    #Unmapped address 0x665 testing: random write/read operations
    #Address 0x665 read value
    csrr x14, 0x665

    #Unmapped address 0x811 testing: random write/read operations
    #Address 0x811 read value
    csrr x14, 0x811

    #Address 0x811 read value
    csrr x14, 0x811

    #Address 0x811 read value
    csrr x14, 0x811

    #Address 0x811 read value
    csrr x14, 0x811

    #Address 0x811 Write value 0xa3e983c6
    li x3, 0xa3e983c6
    csrw 0x811, x3

    #Unmapped address 0x2b2 testing: random write/read operations
    #Address 0x2b2 read value
    csrr x14, 0x2b2

    #Address 0x2b2 Write value 0xd3803280
    li x3, 0xd3803280
    csrw 0x2b2, x3

    #Unmapped address 0x8d4 testing: random write/read operations
    #Address 0x8d4 read value
    csrr x14, 0x8d4

    #Unmapped address 0x844 testing: random write/read operations
    #Address 0x844 Write value 0x7b59ac85
    li x3, 0x7b59ac85
    csrw 0x844, x3

    #Address 0x844 Write value 0xcd8caa5b
    li x3, 0xcd8caa5b
    csrw 0x844, x3

    #Address 0x844 read value
    csrr x14, 0x844

    #Address 0x844 Write value 0xe46d7bfb
    li x3, 0xe46d7bfb
    csrw 0x844, x3

    #Address 0x844 read value
    csrr x14, 0x844

    #Unmapped address 0x322 testing: random write/read operations
    #Address 0x322 Write value 0x9ea375e7
    li x3, 0x9ea375e7
    csrw 0x322, x3

    #Unmapped address 0x6e0 testing: random write/read operations
    #Address 0x6e0 Write value 0x7b16731d
    li x3, 0x7b16731d
    csrw 0x6e0, x3

    #Unmapped address 0x9b3 testing: random write/read operations
    #Address 0x9b3 read value
    csrr x14, 0x9b3

    #Address 0x9b3 Write value 0x6d92dc0c
    li x3, 0x6d92dc0c
    csrw 0x9b3, x3

    #Unmapped address 0x114 testing: random write/read operations
    #Address 0x114 Write value 0x4c77256e
    li x3, 0x4c77256e
    csrw 0x114, x3

    #Address 0x114 read value
    csrr x14, 0x114

    #Unmapped address 0xe35 testing: random write/read operations
    #Address 0xe35 read value
    csrr x14, 0xe35

    #Unmapped address 0xb3a testing: random write/read operations
    #Address 0xb3a read value
    csrr x14, 0xb3a

    #Address 0xb3a read value
    csrr x14, 0xb3a

    #Address 0xb3a Write value 0xa3c9a63e
    li x3, 0xa3c9a63e
    csrw 0xb3a, x3

    #Unmapped address 0x6da testing: random write/read operations
    #Address 0x6da read value
    csrr x14, 0x6da

    #Unmapped address 0xcc4 testing: random write/read operations
    #Address 0xcc4 Write value 0x66bfcb76
    li x3, 0x66bfcb76
    csrw 0xcc4, x3

    #Address 0xcc4 read value
    csrr x14, 0xcc4

    #Address 0xcc4 read value
    csrr x14, 0xcc4

    #Address 0xcc4 Write value 0xdf5bd67e
    li x3, 0xdf5bd67e
    csrw 0xcc4, x3

    #Address 0xcc4 read value
    csrr x14, 0xcc4

    #Unmapped address 0xd67 testing: random write/read operations
    #Address 0xd67 Write value 0xd32189d8
    li x3, 0xd32189d8
    csrw 0xd67, x3

    #Address 0xd67 read value
    csrr x14, 0xd67

    #Unmapped address 0xd79 testing: random write/read operations
    #Address 0xd79 read value
    csrr x14, 0xd79

    #Address 0xd79 read value
    csrr x14, 0xd79

    #Unmapped address 0x156 testing: random write/read operations
    #Address 0x156 Write value 0xeef0586f
    li x3, 0xeef0586f
    csrw 0x156, x3

    #Unmapped address 0x6a7 testing: random write/read operations
    #Address 0x6a7 Write value 0x607a8f58
    li x3, 0x607a8f58
    csrw 0x6a7, x3

    #Address 0x6a7 Write value 0x2604e91e
    li x3, 0x2604e91e
    csrw 0x6a7, x3

    #Address 0x6a7 Write value 0xcc4b2ec5
    li x3, 0xcc4b2ec5
    csrw 0x6a7, x3

    #Unmapped address 0xeea testing: random write/read operations
    #Address 0xeea Write value 0x338ab12e
    li x3, 0x338ab12e
    csrw 0xeea, x3

    #Address 0xeea read value
    csrr x14, 0xeea

    #Unmapped address 0xc19 testing: random write/read operations
    #Address 0xc19 Write value 0x7ed0554d
    li x3, 0x7ed0554d
    csrw 0xc19, x3

    #Address 0xc19 Write value 0xd6e55450
    li x3, 0xd6e55450
    csrw 0xc19, x3

    #Address 0xc19 Write value 0xdb72ac49
    li x3, 0xdb72ac49
    csrw 0xc19, x3

    #Address 0xc19 Write value 0x1f874327
    li x3, 0x1f874327
    csrw 0xc19, x3

    #Address 0xc19 read value
    csrr x14, 0xc19

    #Unmapped address 0xdf1 testing: random write/read operations
    #Address 0xdf1 Write value 0x40bdb41a
    li x3, 0x40bdb41a
    csrw 0xdf1, x3

    #Address 0xdf1 Write value 0xb0f6429
    li x3, 0xb0f6429
    csrw 0xdf1, x3

    #Address 0xdf1 Write value 0xae575423
    li x3, 0xae575423
    csrw 0xdf1, x3

    #Address 0xdf1 read value
    csrr x14, 0xdf1

    #Address 0xdf1 read value
    csrr x14, 0xdf1

    #Unmapped address 0xa39 testing: random write/read operations
    #Address 0xa39 read value
    csrr x14, 0xa39

    #Address 0xa39 read value
    csrr x14, 0xa39

    #Address 0xa39 read value
    csrr x14, 0xa39

    #Unmapped address 0x27c testing: random write/read operations
    #Address 0x27c read value
    csrr x14, 0x27c

    #Address 0x27c Write value 0xb366c37b
    li x3, 0xb366c37b
    csrw 0x27c, x3

    #Address 0x27c Write value 0x77059712
    li x3, 0x77059712
    csrw 0x27c, x3

    #Address 0x27c read value
    csrr x14, 0x27c

    #Address 0x27c read value
    csrr x14, 0x27c

    #Unmapped address 0x4f testing: random write/read operations
    #Address 0x4f Write value 0x9f0cbbaf
    li x3, 0x9f0cbbaf
    csrw 0x4f, x3

    #Address 0x4f Write value 0x4bb82283
    li x3, 0x4bb82283
    csrw 0x4f, x3

    #Address 0x4f read value
    csrr x14, 0x4f

    #Address 0x4f read value
    csrr x14, 0x4f

    #Address 0x4f Write value 0xe6e81d13
    li x3, 0xe6e81d13
    csrw 0x4f, x3

    #Unmapped address 0x8da testing: random write/read operations
    #Address 0x8da read value
    csrr x14, 0x8da

    #Address 0x8da Write value 0x3b974aed
    li x3, 0x3b974aed
    csrw 0x8da, x3

    #Address 0x8da Write value 0x2427e98b
    li x3, 0x2427e98b
    csrw 0x8da, x3

    #Address 0x8da Write value 0x3588a481
    li x3, 0x3588a481
    csrw 0x8da, x3

    #Address 0x8da Write value 0xb89d2a89
    li x3, 0xb89d2a89
    csrw 0x8da, x3

    #Unmapped address 0xca9 testing: random write/read operations
    #Address 0xca9 Write value 0xcf91351d
    li x3, 0xcf91351d
    csrw 0xca9, x3

    #Address 0xca9 read value
    csrr x14, 0xca9

    #Unmapped address 0x49d testing: random write/read operations
    #Address 0x49d read value
    csrr x14, 0x49d

    #Address 0x49d Write value 0x78d9cd00
    li x3, 0x78d9cd00
    csrw 0x49d, x3

    #Address 0x49d read value
    csrr x14, 0x49d

    #Address 0x49d Write value 0x52817c47
    li x3, 0x52817c47
    csrw 0x49d, x3

    #Address 0x49d read value
    csrr x14, 0x49d

    #Unmapped address 0x36c testing: random write/read operations
    #Address 0x36c Write value 0x1cdea3f3
    li x3, 0x1cdea3f3
    csrw 0x36c, x3

    #Address 0x36c Write value 0x9adf9353
    li x3, 0x9adf9353
    csrw 0x36c, x3

    #Address 0x36c Write value 0xc7b4efbe
    li x3, 0xc7b4efbe
    csrw 0x36c, x3

    #Address 0x36c read value
    csrr x14, 0x36c

    #Unmapped address 0xfb4 testing: random write/read operations
    #Address 0xfb4 Write value 0xbf09e9de
    li x3, 0xbf09e9de
    csrw 0xfb4, x3

    #Address 0xfb4 Write value 0x5a9c7788
    li x3, 0x5a9c7788
    csrw 0xfb4, x3

    #Address 0xfb4 Write value 0x70b89607
    li x3, 0x70b89607
    csrw 0xfb4, x3

    #Address 0xfb4 read value
    csrr x14, 0xfb4

    #Unmapped address 0xef7 testing: random write/read operations
    #Address 0xef7 read value
    csrr x14, 0xef7

    #Address 0xef7 read value
    csrr x14, 0xef7

    #Address 0xef7 read value
    csrr x14, 0xef7

    #Address 0xef7 read value
    csrr x14, 0xef7

    #Unmapped address 0xe85 testing: random write/read operations
    #Address 0xe85 read value
    csrr x14, 0xe85

    #Address 0xe85 read value
    csrr x14, 0xe85

    #Address 0xe85 Write value 0xae98962b
    li x3, 0xae98962b
    csrw 0xe85, x3

    #Address 0xe85 Write value 0x5106cd16
    li x3, 0x5106cd16
    csrw 0xe85, x3

    #Unmapped address 0x523 testing: random write/read operations
    #Address 0x523 read value
    csrr x14, 0x523

    #Unmapped address 0x134 testing: random write/read operations
    #Address 0x134 Write value 0xd549b860
    li x3, 0xd549b860
    csrw 0x134, x3

    #Unmapped address 0xc5d testing: random write/read operations
    #Address 0xc5d Write value 0x1481855e
    li x3, 0x1481855e
    csrw 0xc5d, x3

    #Address 0xc5d read value
    csrr x14, 0xc5d

    #Address 0xc5d read value
    csrr x14, 0xc5d

    #Address 0xc5d Write value 0x879b82ed
    li x3, 0x879b82ed
    csrw 0xc5d, x3

    #Address 0xc5d read value
    csrr x14, 0xc5d

    #Unmapped address 0xa69 testing: random write/read operations
    #Address 0xa69 read value
    csrr x14, 0xa69

    #Unmapped address 0x270 testing: random write/read operations
    #Address 0x270 read value
    csrr x14, 0x270

    #Address 0x270 read value
    csrr x14, 0x270

    #Address 0x270 read value
    csrr x14, 0x270

    #Address 0x270 read value
    csrr x14, 0x270

    #Unmapped address 0xcc9 testing: random write/read operations
    #Address 0xcc9 read value
    csrr x14, 0xcc9

    #Address 0xcc9 read value
    csrr x14, 0xcc9

    #Address 0xcc9 Write value 0x4c72f376
    li x3, 0x4c72f376
    csrw 0xcc9, x3

    #Address 0xcc9 Write value 0x8a48149f
    li x3, 0x8a48149f
    csrw 0xcc9, x3

    #Address 0xcc9 read value
    csrr x14, 0xcc9

    #Unmapped address 0x86b testing: random write/read operations
    #Address 0x86b read value
    csrr x14, 0x86b

    #Address 0x86b read value
    csrr x14, 0x86b

    #Address 0x86b read value
    csrr x14, 0x86b

    #Address 0x86b read value
    csrr x14, 0x86b

    #Unmapped address 0x5e testing: random write/read operations
    #Address 0x5e Write value 0xd8fc20a5
    li x3, 0xd8fc20a5
    csrw 0x5e, x3

    #Address 0x5e read value
    csrr x14, 0x5e

    #Unmapped address 0x5a3 testing: random write/read operations
    #Address 0x5a3 Write value 0x1fc23ccc
    li x3, 0x1fc23ccc
    csrw 0x5a3, x3

    #Address 0x5a3 Write value 0x635f6d58
    li x3, 0x635f6d58
    csrw 0x5a3, x3

    #Unmapped address 0x8e1 testing: random write/read operations
    #Address 0x8e1 Write value 0x31d48363
    li x3, 0x31d48363
    csrw 0x8e1, x3

    #Address 0x8e1 Write value 0x1d79a61e
    li x3, 0x1d79a61e
    csrw 0x8e1, x3

    #Unmapped address 0xa2d testing: random write/read operations
    #Address 0xa2d Write value 0xd1d0d8d
    li x3, 0xd1d0d8d
    csrw 0xa2d, x3

    #Address 0xa2d read value
    csrr x14, 0xa2d

    #Unmapped address 0xf9 testing: random write/read operations
    #Address 0xf9 Write value 0x1432d0c5
    li x3, 0x1432d0c5
    csrw 0xf9, x3

    #Unmapped address 0x995 testing: random write/read operations
    #Address 0x995 Write value 0xe1dcd8c2
    li x3, 0xe1dcd8c2
    csrw 0x995, x3

    #Address 0x995 Write value 0xb82fe1fc
    li x3, 0xb82fe1fc
    csrw 0x995, x3

    #Address 0x995 read value
    csrr x14, 0x995

    #Address 0x995 read value
    csrr x14, 0x995

    #Address 0x995 Write value 0xb201ac3
    li x3, 0xb201ac3
    csrw 0x995, x3

    #Unmapped address 0x9bf testing: random write/read operations
    #Address 0x9bf read value
    csrr x14, 0x9bf

    #Address 0x9bf Write value 0x452a2bb7
    li x3, 0x452a2bb7
    csrw 0x9bf, x3

    #Address 0x9bf read value
    csrr x14, 0x9bf

    #Address 0x9bf Write value 0xc27e2a52
    li x3, 0xc27e2a52
    csrw 0x9bf, x3

    #Unmapped address 0xad4 testing: random write/read operations
    #Address 0xad4 read value
    csrr x14, 0xad4

    #Address 0xad4 Write value 0xf5dd6454
    li x3, 0xf5dd6454
    csrw 0xad4, x3

    #Address 0xad4 Write value 0x447233f2
    li x3, 0x447233f2
    csrw 0xad4, x3

    #Unmapped address 0x3c6 testing: random write/read operations
    #Address 0x3c6 read value
    csrr x14, 0x3c6

    #Address 0x3c6 Write value 0x9ead055f
    li x3, 0x9ead055f
    csrw 0x3c6, x3

    #Unmapped address 0x110 testing: random write/read operations
    #Address 0x110 Write value 0x927db0aa
    li x3, 0x927db0aa
    csrw 0x110, x3

    #Address 0x110 read value
    csrr x14, 0x110

    #Address 0x110 Write value 0xb49e24e2
    li x3, 0xb49e24e2
    csrw 0x110, x3

    #Address 0x110 Write value 0x41d089f2
    li x3, 0x41d089f2
    csrw 0x110, x3

    #Address 0x110 read value
    csrr x14, 0x110

    #Unmapped address 0xca7 testing: random write/read operations
    #Address 0xca7 Write value 0xc26c71cd
    li x3, 0xc26c71cd
    csrw 0xca7, x3

    #Address 0xca7 Write value 0xd1e538ea
    li x3, 0xd1e538ea
    csrw 0xca7, x3

    #Address 0xca7 Write value 0xd6d4b33e
    li x3, 0xd6d4b33e
    csrw 0xca7, x3

    #Address 0xca7 read value
    csrr x14, 0xca7

    #Unmapped address 0xf17 testing: random write/read operations
    #Address 0xf17 read value
    csrr x14, 0xf17

    #Unmapped address 0x759 testing: random write/read operations
    #Address 0x759 Write value 0xe8c1774c
    li x3, 0xe8c1774c
    csrw 0x759, x3

    #Address 0x759 read value
    csrr x14, 0x759

    #Address 0x759 Write value 0xed6e7076
    li x3, 0xed6e7076
    csrw 0x759, x3

    #Address 0x759 Write value 0x15742032
    li x3, 0x15742032
    csrw 0x759, x3

    #Mapped address 0x3ba (pmpaddr10) testing: random write/read operations
    #Address 0x3ba Write value 0xaa593dda
    li x3, 0xaa593dda
    csrw 0x3ba, x3

    #Address 0x3ba read value
    csrr x14, 0x3ba

    #Address 0x3ba Write value 0xae015e8d
    li x3, 0xae015e8d
    csrw 0x3ba, x3

    #Address 0x3ba Write value 0x522bae36
    li x3, 0x522bae36
    csrw 0x3ba, x3

    #Address 0x3ba read value
    csrr x14, 0x3ba

    #Unmapped address 0x4bd testing: random write/read operations
    #Address 0x4bd Write value 0xb84a2b94
    li x3, 0xb84a2b94
    csrw 0x4bd, x3

    #Address 0x4bd Write value 0x801e39c5
    li x3, 0x801e39c5
    csrw 0x4bd, x3

    #Address 0x4bd read value
    csrr x14, 0x4bd

    #Unmapped address 0x78a testing: random write/read operations
    #Address 0x78a Write value 0xac127f8e
    li x3, 0xac127f8e
    csrw 0x78a, x3

    #Address 0x78a read value
    csrr x14, 0x78a

    #Address 0x78a Write value 0x33cb45cb
    li x3, 0x33cb45cb
    csrw 0x78a, x3

    #Unmapped address 0xbf6 testing: random write/read operations
    #Address 0xbf6 read value
    csrr x14, 0xbf6

    #Address 0xbf6 read value
    csrr x14, 0xbf6

    #Address 0xbf6 Write value 0x64f1a7e5
    li x3, 0x64f1a7e5
    csrw 0xbf6, x3

    #Unmapped address 0x6b4 testing: random write/read operations
    #Address 0x6b4 Write value 0x8a76d714
    li x3, 0x8a76d714
    csrw 0x6b4, x3

    #Address 0x6b4 Write value 0x6a3f01e6
    li x3, 0x6a3f01e6
    csrw 0x6b4, x3

    #Address 0x6b4 Write value 0xa2c41462
    li x3, 0xa2c41462
    csrw 0x6b4, x3

    #Address 0x6b4 Write value 0xc8c7878e
    li x3, 0xc8c7878e
    csrw 0x6b4, x3

    #Address 0x6b4 Write value 0xe3825c86
    li x3, 0xe3825c86
    csrw 0x6b4, x3

    #Unmapped address 0x66f testing: random write/read operations
    #Address 0x66f Write value 0x75889eac
    li x3, 0x75889eac
    csrw 0x66f, x3

    #Address 0x66f Write value 0x71a11259
    li x3, 0x71a11259
    csrw 0x66f, x3

    #Address 0x66f read value
    csrr x14, 0x66f

    #Address 0x66f Write value 0xca6345ae
    li x3, 0xca6345ae
    csrw 0x66f, x3

    #Unmapped address 0xbac testing: random write/read operations
    #Address 0xbac Write value 0xc5c071b8
    li x3, 0xc5c071b8
    csrw 0xbac, x3

    #Address 0xbac Write value 0xcf3f81ce
    li x3, 0xcf3f81ce
    csrw 0xbac, x3

    #Address 0xbac Write value 0x22a00598
    li x3, 0x22a00598
    csrw 0xbac, x3

    #Unmapped address 0xac testing: random write/read operations
    #Address 0xac read value
    csrr x14, 0xac

    #Unmapped address 0x50b testing: random write/read operations
    #Address 0x50b Write value 0xdc21c029
    li x3, 0xdc21c029
    csrw 0x50b, x3

    #Address 0x50b read value
    csrr x14, 0x50b

    #Address 0x50b read value
    csrr x14, 0x50b

    #Address 0x50b read value
    csrr x14, 0x50b

    #Unmapped address 0x8f testing: random write/read operations
    #Address 0x8f read value
    csrr x14, 0x8f

    #Address 0x8f read value
    csrr x14, 0x8f

    #Address 0x8f read value
    csrr x14, 0x8f

    #Address 0x8f Write value 0x9c5eb25c
    li x3, 0x9c5eb25c
    csrw 0x8f, x3

    #Unmapped address 0xeee testing: random write/read operations
    #Address 0xeee read value
    csrr x14, 0xeee

    #Address 0xeee Write value 0x63d8dd6c
    li x3, 0x63d8dd6c
    csrw 0xeee, x3

    #Address 0xeee read value
    csrr x14, 0xeee

    #Address 0xeee Write value 0xf0b5fdf1
    li x3, 0xf0b5fdf1
    csrw 0xeee, x3

    #Unmapped address 0xe70 testing: random write/read operations
    #Address 0xe70 Write value 0xc56ac92e
    li x3, 0xc56ac92e
    csrw 0xe70, x3

    #Address 0xe70 read value
    csrr x14, 0xe70

    #Unmapped address 0x21 testing: random write/read operations
    #Address 0x21 Write value 0x3385e501
    li x3, 0x3385e501
    csrw 0x21, x3

    #Mapped address 0x335 (mhpmevent21) testing: random write/read operations
    #Address 0x335 Write value 0xe7f8d4a9
    li x3, 0xe7f8d4a9
    csrw 0x335, x3

    #Address 0x335 Write value 0x46ce809c
    li x3, 0x46ce809c
    csrw 0x335, x3

    #Unmapped address 0x89c testing: random write/read operations
    #Address 0x89c read value
    csrr x14, 0x89c

    #Address 0x89c Write value 0x36d048f9
    li x3, 0x36d048f9
    csrw 0x89c, x3

    #Address 0x89c read value
    csrr x14, 0x89c

    #Address 0x89c read value
    csrr x14, 0x89c

    #Address 0x89c Write value 0x852894b4
    li x3, 0x852894b4
    csrw 0x89c, x3

    #Unmapped address 0x4bc testing: random write/read operations
    #Address 0x4bc read value
    csrr x14, 0x4bc

    #Address 0x4bc read value
    csrr x14, 0x4bc

    #Unmapped address 0xf1 testing: random write/read operations
    #Address 0xf1 read value
    csrr x14, 0xf1

    #Address 0xf1 Write value 0x3a9a7f3a
    li x3, 0x3a9a7f3a
    csrw 0xf1, x3

    #Address 0xf1 read value
    csrr x14, 0xf1

    #Address 0xf1 Write value 0x53a06efe
    li x3, 0x53a06efe
    csrw 0xf1, x3

    #Address 0xf1 read value
    csrr x14, 0xf1

    #Unmapped address 0x5f1 testing: random write/read operations
    #Address 0x5f1 Write value 0x8d507116
    li x3, 0x8d507116
    csrw 0x5f1, x3

    #Address 0x5f1 read value
    csrr x14, 0x5f1

    #Address 0x5f1 read value
    csrr x14, 0x5f1

    #Address 0x5f1 Write value 0xf2d50a7a
    li x3, 0xf2d50a7a
    csrw 0x5f1, x3

    #Address 0x5f1 read value
    csrr x14, 0x5f1

    #Unmapped address 0xa1a testing: random write/read operations
    #Address 0xa1a read value
    csrr x14, 0xa1a

    #Address 0xa1a read value
    csrr x14, 0xa1a

    #Address 0xa1a Write value 0xb60510ad
    li x3, 0xb60510ad
    csrw 0xa1a, x3

    #Unmapped address 0x910 testing: random write/read operations
    #Address 0x910 read value
    csrr x14, 0x910

    #Address 0x910 Write value 0x6d840a43
    li x3, 0x6d840a43
    csrw 0x910, x3

    #Address 0x910 Write value 0x568e18a0
    li x3, 0x568e18a0
    csrw 0x910, x3

    #Address 0x910 read value
    csrr x14, 0x910

    #Address 0x910 Write value 0x421da1ca
    li x3, 0x421da1ca
    csrw 0x910, x3

    #Unmapped address 0xe6d testing: random write/read operations
    #Address 0xe6d Write value 0xeb01f148
    li x3, 0xeb01f148
    csrw 0xe6d, x3

    #Address 0xe6d read value
    csrr x14, 0xe6d

    #Address 0xe6d Write value 0xba333dfc
    li x3, 0xba333dfc
    csrw 0xe6d, x3

    #Unmapped address 0x116 testing: random write/read operations
    #Address 0x116 read value
    csrr x14, 0x116

    #Address 0x116 Write value 0xd52f58fa
    li x3, 0xd52f58fa
    csrw 0x116, x3

    #Address 0x116 read value
    csrr x14, 0x116

    #Unmapped address 0x76 testing: random write/read operations
    #Address 0x76 read value
    csrr x14, 0x76

    #Address 0x76 read value
    csrr x14, 0x76

    #Unmapped address 0xb67 testing: random write/read operations
    #Address 0xb67 Write value 0xba316f9f
    li x3, 0xba316f9f
    csrw 0xb67, x3

    #Address 0xb67 read value
    csrr x14, 0xb67

    #Address 0xb67 Write value 0xab47e9d
    li x3, 0xab47e9d
    csrw 0xb67, x3

    #Unmapped address 0x724 testing: random write/read operations
    #Address 0x724 Write value 0x5142a704
    li x3, 0x5142a704
    csrw 0x724, x3

    #Address 0x724 Write value 0xedf12a7
    li x3, 0xedf12a7
    csrw 0x724, x3

    #Address 0x724 Write value 0x11897691
    li x3, 0x11897691
    csrw 0x724, x3

    #Address 0x724 Write value 0x54f5e82d
    li x3, 0x54f5e82d
    csrw 0x724, x3

    #Address 0x724 Write value 0xc51e6f1
    li x3, 0xc51e6f1
    csrw 0x724, x3

    #Unmapped address 0x2d4 testing: random write/read operations
    #Address 0x2d4 Write value 0x2daa1e0c
    li x3, 0x2daa1e0c
    csrw 0x2d4, x3

    #Unmapped address 0x70a testing: random write/read operations
    #Address 0x70a Write value 0xca4a57b6
    li x3, 0xca4a57b6
    csrw 0x70a, x3

    #Address 0x70a read value
    csrr x14, 0x70a

    #Unmapped address 0x505 testing: random write/read operations
    #Address 0x505 Write value 0xac3fc59e
    li x3, 0xac3fc59e
    csrw 0x505, x3

    #Address 0x505 Write value 0x57ef3432
    li x3, 0x57ef3432
    csrw 0x505, x3

    #Address 0x505 Write value 0xcf68e194
    li x3, 0xcf68e194
    csrw 0x505, x3

    #Unmapped address 0x851 testing: random write/read operations
    #Address 0x851 read value
    csrr x14, 0x851

    #Address 0x851 Write value 0x3155e333
    li x3, 0x3155e333
    csrw 0x851, x3

    #Address 0x851 Write value 0xfbd23e79
    li x3, 0xfbd23e79
    csrw 0x851, x3

    #Unmapped address 0x466 testing: random write/read operations
    #Address 0x466 read value
    csrr x14, 0x466

    #Address 0x466 read value
    csrr x14, 0x466

    #Address 0x466 Write value 0x651d146
    li x3, 0x651d146
    csrw 0x466, x3

    #Address 0x466 Write value 0xe476bd80
    li x3, 0xe476bd80
    csrw 0x466, x3

    #Unmapped address 0x3df testing: random write/read operations
    #Address 0x3df read value
    csrr x14, 0x3df

    #Address 0x3df Write value 0xe04b6814
    li x3, 0xe04b6814
    csrw 0x3df, x3

    #Address 0x3df Write value 0x84b967c6
    li x3, 0x84b967c6
    csrw 0x3df, x3

    #Address 0x3df Write value 0x4ea9d92d
    li x3, 0x4ea9d92d
    csrw 0x3df, x3

    #Unmapped address 0xf58 testing: random write/read operations
    #Address 0xf58 read value
    csrr x14, 0xf58

    #Address 0xf58 Write value 0x3949844c
    li x3, 0x3949844c
    csrw 0xf58, x3

    #Address 0xf58 Write value 0xc34e684
    li x3, 0xc34e684
    csrw 0xf58, x3

    #Address 0xf58 Write value 0xfad5d26c
    li x3, 0xfad5d26c
    csrw 0xf58, x3

    #Address 0xf58 read value
    csrr x14, 0xf58

    #Unmapped address 0xf1c testing: random write/read operations
    #Address 0xf1c Write value 0xc0f6a42b
    li x3, 0xc0f6a42b
    csrw 0xf1c, x3

    #Unmapped address 0xd8c testing: random write/read operations
    #Address 0xd8c read value
    csrr x14, 0xd8c

    #Address 0xd8c read value
    csrr x14, 0xd8c

    #Address 0xd8c read value
    csrr x14, 0xd8c

    #Unmapped address 0xd49 testing: random write/read operations
    #Address 0xd49 Write value 0xdc79b36d
    li x3, 0xdc79b36d
    csrw 0xd49, x3

    #Address 0xd49 read value
    csrr x14, 0xd49

    #Address 0xd49 Write value 0x7b604406
    li x3, 0x7b604406
    csrw 0xd49, x3

    #Address 0xd49 read value
    csrr x14, 0xd49

    #Address 0xd49 read value
    csrr x14, 0xd49

    #Unmapped address 0x99d testing: random write/read operations
    #Address 0x99d read value
    csrr x14, 0x99d

    #Address 0x99d read value
    csrr x14, 0x99d

    #Address 0x99d Write value 0xcb8d4250
    li x3, 0xcb8d4250
    csrw 0x99d, x3

    #Address 0x99d read value
    csrr x14, 0x99d

    #Unmapped address 0x5ff testing: random write/read operations
    #Address 0x5ff Write value 0x2ec33122
    li x3, 0x2ec33122
    csrw 0x5ff, x3

    #Address 0x5ff Write value 0x708ef5e9
    li x3, 0x708ef5e9
    csrw 0x5ff, x3

    #Address 0x5ff Write value 0x908d4570
    li x3, 0x908d4570
    csrw 0x5ff, x3

    #Unmapped address 0x630 testing: random write/read operations
    #Address 0x630 Write value 0xe09a12a0
    li x3, 0xe09a12a0
    csrw 0x630, x3

    #Address 0x630 read value
    csrr x14, 0x630

    #Unmapped address 0x359 testing: random write/read operations
    #Address 0x359 read value
    csrr x14, 0x359

    #Address 0x359 Write value 0x6f41aa26
    li x3, 0x6f41aa26
    csrw 0x359, x3

    #Unmapped address 0x3f3 testing: random write/read operations
    #Address 0x3f3 Write value 0xca00442f
    li x3, 0xca00442f
    csrw 0x3f3, x3

    #Unmapped address 0xb5b testing: random write/read operations
    #Address 0xb5b Write value 0xc0a1053f
    li x3, 0xc0a1053f
    csrw 0xb5b, x3

    #Unmapped address 0xcaa testing: random write/read operations
    #Address 0xcaa read value
    csrr x14, 0xcaa

    #Address 0xcaa read value
    csrr x14, 0xcaa

    #Address 0xcaa Write value 0xc8198d9e
    li x3, 0xc8198d9e
    csrw 0xcaa, x3

    #Address 0xcaa read value
    csrr x14, 0xcaa

    #Unmapped address 0xc52 testing: random write/read operations
    #Address 0xc52 Write value 0x507d92a6
    li x3, 0x507d92a6
    csrw 0xc52, x3

    #Address 0xc52 read value
    csrr x14, 0xc52

    #Address 0xc52 read value
    csrr x14, 0xc52

    #Address 0xc52 Write value 0xc7de6131
    li x3, 0xc7de6131
    csrw 0xc52, x3

    #Unmapped address 0x17e testing: random write/read operations
    #Address 0x17e read value
    csrr x14, 0x17e

    #Address 0x17e Write value 0x98bb1950
    li x3, 0x98bb1950
    csrw 0x17e, x3

    #Address 0x17e read value
    csrr x14, 0x17e

    #Address 0x17e Write value 0x5c02fbd4
    li x3, 0x5c02fbd4
    csrw 0x17e, x3

    #Address 0x17e read value
    csrr x14, 0x17e

    #Unmapped address 0xd40 testing: random write/read operations
    #Address 0xd40 read value
    csrr x14, 0xd40

    #Address 0xd40 read value
    csrr x14, 0xd40

    #Address 0xd40 read value
    csrr x14, 0xd40

    #Unmapped address 0xf3c testing: random write/read operations
    #Address 0xf3c Write value 0x32f747fa
    li x3, 0x32f747fa
    csrw 0xf3c, x3

    #Address 0xf3c read value
    csrr x14, 0xf3c

    #Unmapped address 0x400 testing: random write/read operations
    #Address 0x400 read value
    csrr x14, 0x400

    #Unmapped address 0x4ed testing: random write/read operations
    #Address 0x4ed read value
    csrr x14, 0x4ed

    #Address 0x4ed read value
    csrr x14, 0x4ed

    #Address 0x4ed read value
    csrr x14, 0x4ed

    #Address 0x4ed Write value 0xa5065e59
    li x3, 0xa5065e59
    csrw 0x4ed, x3

    #Unmapped address 0x1d1 testing: random write/read operations
    #Address 0x1d1 Write value 0x2ff5df8b
    li x3, 0x2ff5df8b
    csrw 0x1d1, x3

    #Address 0x1d1 Write value 0x37c7ca2a
    li x3, 0x37c7ca2a
    csrw 0x1d1, x3

    #Address 0x1d1 Write value 0xebdcfbef
    li x3, 0xebdcfbef
    csrw 0x1d1, x3

    #Address 0x1d1 read value
    csrr x14, 0x1d1

    #Unmapped address 0xed7 testing: random write/read operations
    #Address 0xed7 read value
    csrr x14, 0xed7

    #Address 0xed7 read value
    csrr x14, 0xed7

    #Address 0xed7 read value
    csrr x14, 0xed7

    #Unmapped address 0x352 testing: random write/read operations
    #Address 0x352 read value
    csrr x14, 0x352

    #Address 0x352 read value
    csrr x14, 0x352

    #Address 0x352 Write value 0x267eadec
    li x3, 0x267eadec
    csrw 0x352, x3

    #Address 0x352 read value
    csrr x14, 0x352

    #Address 0x352 read value
    csrr x14, 0x352

    #Unmapped address 0xa4a testing: random write/read operations
    #Address 0xa4a Write value 0x500a91c2
    li x3, 0x500a91c2
    csrw 0xa4a, x3

    #Address 0xa4a Write value 0x176fdb4e
    li x3, 0x176fdb4e
    csrw 0xa4a, x3

    #Address 0xa4a read value
    csrr x14, 0xa4a

    #Address 0xa4a read value
    csrr x14, 0xa4a

    #Unmapped address 0xd95 testing: random write/read operations
    #Address 0xd95 Write value 0x36d58358
    li x3, 0x36d58358
    csrw 0xd95, x3

    #Address 0xd95 read value
    csrr x14, 0xd95

    #Address 0xd95 Write value 0x683886e4
    li x3, 0x683886e4
    csrw 0xd95, x3

    #Address 0xd95 Write value 0x1e72a23e
    li x3, 0x1e72a23e
    csrw 0xd95, x3

    #Address 0xd95 Write value 0xc76f6d18
    li x3, 0xc76f6d18
    csrw 0xd95, x3

    #Unmapped address 0x7d1 testing: random write/read operations
    #Address 0x7d1 read value
    csrr x14, 0x7d1

    #Address 0x7d1 Write value 0x571f6447
    li x3, 0x571f6447
    csrw 0x7d1, x3

    #Address 0x7d1 read value
    csrr x14, 0x7d1

    #Address 0x7d1 read value
    csrr x14, 0x7d1

    #Address 0x7d1 Write value 0x6a9e740e
    li x3, 0x6a9e740e
    csrw 0x7d1, x3

    #Unmapped address 0xbb testing: random write/read operations
    #Address 0xbb Write value 0x1a55a453
    li x3, 0x1a55a453
    csrw 0xbb, x3

    #Unmapped address 0x5f2 testing: random write/read operations
    #Address 0x5f2 read value
    csrr x14, 0x5f2

    #Address 0x5f2 Write value 0x3a0c5465
    li x3, 0x3a0c5465
    csrw 0x5f2, x3

    #Address 0x5f2 read value
    csrr x14, 0x5f2

    #Unmapped address 0x3a8 testing: random write/read operations
    #Address 0x3a8 Write value 0x6f2e25d6
    li x3, 0x6f2e25d6
    csrw 0x3a8, x3

    #Address 0x3a8 Write value 0xdd4f65
    li x3, 0xdd4f65
    csrw 0x3a8, x3

    #Address 0x3a8 read value
    csrr x14, 0x3a8

    #Unmapped address 0x981 testing: random write/read operations
    #Address 0x981 Write value 0x3e51fd0b
    li x3, 0x3e51fd0b
    csrw 0x981, x3

    #Address 0x981 read value
    csrr x14, 0x981

    #Unmapped address 0xcbf testing: random write/read operations
    #Address 0xcbf read value
    csrr x14, 0xcbf

    #Address 0xcbf read value
    csrr x14, 0xcbf

    #Address 0xcbf Write value 0xc3aae5e7
    li x3, 0xc3aae5e7
    csrw 0xcbf, x3

    #Address 0xcbf read value
    csrr x14, 0xcbf

    #Address 0xcbf read value
    csrr x14, 0xcbf

    #Unmapped address 0x597 testing: random write/read operations
    #Address 0x597 Write value 0xb51619
    li x3, 0xb51619
    csrw 0x597, x3

    #Unmapped address 0xfd8 testing: random write/read operations
    #Address 0xfd8 read value
    csrr x14, 0xfd8

    #Address 0xfd8 Write value 0xc3980590
    li x3, 0xc3980590
    csrw 0xfd8, x3

    #Address 0xfd8 Write value 0x70213499
    li x3, 0x70213499
    csrw 0xfd8, x3

    #Address 0xfd8 read value
    csrr x14, 0xfd8

    #Unmapped address 0x516 testing: random write/read operations
    #Address 0x516 read value
    csrr x14, 0x516

    #Address 0x516 read value
    csrr x14, 0x516

    #Address 0x516 Write value 0x688da162
    li x3, 0x688da162
    csrw 0x516, x3

    #Address 0x516 Write value 0x891f15c2
    li x3, 0x891f15c2
    csrw 0x516, x3

    #Address 0x516 read value
    csrr x14, 0x516

    #Unmapped address 0x30a testing: random write/read operations
    #Address 0x30a read value
    csrr x14, 0x30a

    #Unmapped address 0x4a4 testing: random write/read operations
    #Address 0x4a4 read value
    csrr x14, 0x4a4

    #Address 0x4a4 Write value 0xade23232
    li x3, 0xade23232
    csrw 0x4a4, x3

    #Address 0x4a4 Write value 0xb1abb5cd
    li x3, 0xb1abb5cd
    csrw 0x4a4, x3

    #Address 0x4a4 read value
    csrr x14, 0x4a4

    #Address 0x4a4 read value
    csrr x14, 0x4a4

    #Unmapped address 0x58c testing: random write/read operations
    #Address 0x58c Write value 0xcb3fbd63
    li x3, 0xcb3fbd63
    csrw 0x58c, x3

    #Address 0x58c Write value 0x2e0bc459
    li x3, 0x2e0bc459
    csrw 0x58c, x3

    #Unmapped address 0x265 testing: random write/read operations
    #Address 0x265 read value
    csrr x14, 0x265

    #Unmapped address 0x48c testing: random write/read operations
    #Address 0x48c Write value 0x92542c8a
    li x3, 0x92542c8a
    csrw 0x48c, x3

    #Address 0x48c read value
    csrr x14, 0x48c

    #Mapped address 0x3be (pmpaddr14) testing: random write/read operations
    #Address 0x3be read value
    csrr x14, 0x3be

    #Unmapped address 0xd46 testing: random write/read operations
    #Address 0xd46 Write value 0x7761f58e
    li x3, 0x7761f58e
    csrw 0xd46, x3

    #Address 0xd46 read value
    csrr x14, 0xd46

    #Unmapped address 0x966 testing: random write/read operations
    #Address 0x966 Write value 0xe21d7050
    li x3, 0xe21d7050
    csrw 0x966, x3

    #Unmapped address 0x814 testing: random write/read operations
    #Address 0x814 Write value 0x2f3d6132
    li x3, 0x2f3d6132
    csrw 0x814, x3

    #Unmapped address 0xd9c testing: random write/read operations
    #Address 0xd9c Write value 0x4583fa0d
    li x3, 0x4583fa0d
    csrw 0xd9c, x3

    #Address 0xd9c read value
    csrr x14, 0xd9c

    #Address 0xd9c Write value 0x69a082f4
    li x3, 0x69a082f4
    csrw 0xd9c, x3

    #Address 0xd9c read value
    csrr x14, 0xd9c

    #Unmapped address 0x50c testing: random write/read operations
    #Address 0x50c read value
    csrr x14, 0x50c

    #Address 0x50c Write value 0x41664f78
    li x3, 0x41664f78
    csrw 0x50c, x3

    #Address 0x50c Write value 0x40878526
    li x3, 0x40878526
    csrw 0x50c, x3

    #Address 0x50c read value
    csrr x14, 0x50c

    #Address 0x50c read value
    csrr x14, 0x50c

    #Unmapped address 0x770 testing: random write/read operations
    #Address 0x770 read value
    csrr x14, 0x770

    #Address 0x770 read value
    csrr x14, 0x770

    #Address 0x770 Write value 0x44feb19c
    li x3, 0x44feb19c
    csrw 0x770, x3

    #Address 0x770 read value
    csrr x14, 0x770

    #Address 0x770 read value
    csrr x14, 0x770

    #Unmapped address 0x593 testing: random write/read operations
    #Address 0x593 Write value 0x63e8de44
    li x3, 0x63e8de44
    csrw 0x593, x3

    #Unmapped address 0x472 testing: random write/read operations
    #Address 0x472 Write value 0xf4dc7595
    li x3, 0xf4dc7595
    csrw 0x472, x3

    #Unmapped address 0xc5c testing: random write/read operations
    #Address 0xc5c read value
    csrr x14, 0xc5c

    #Address 0xc5c read value
    csrr x14, 0xc5c

    #Address 0xc5c read value
    csrr x14, 0xc5c

    #Unmapped address 0xccd testing: random write/read operations
    #Address 0xccd read value
    csrr x14, 0xccd

    #Mapped address 0x33f (mhpmevent31) testing: random write/read operations
    #Address 0x33f read value
    csrr x14, 0x33f

    #Address 0x33f Write value 0xd07b8bf2
    li x3, 0xd07b8bf2
    csrw 0x33f, x3

    #Address 0x33f Write value 0x64f6b8a9
    li x3, 0x64f6b8a9
    csrw 0x33f, x3

    #Unmapped address 0x2a3 testing: random write/read operations
    #Address 0x2a3 Write value 0x36b06971
    li x3, 0x36b06971
    csrw 0x2a3, x3

    #Unmapped address 0x2b0 testing: random write/read operations
    #Address 0x2b0 read value
    csrr x14, 0x2b0

    #Address 0x2b0 read value
    csrr x14, 0x2b0

    #Address 0x2b0 read value
    csrr x14, 0x2b0

    #Address 0x2b0 read value
    csrr x14, 0x2b0

    #Unmapped address 0x11b testing: random write/read operations
    #Address 0x11b Write value 0x947a8612
    li x3, 0x947a8612
    csrw 0x11b, x3

    #Unmapped address 0x5ae testing: random write/read operations
    #Address 0x5ae read value
    csrr x14, 0x5ae

    #Address 0x5ae read value
    csrr x14, 0x5ae

    #Address 0x5ae Write value 0x779a08db
    li x3, 0x779a08db
    csrw 0x5ae, x3

    #Unmapped address 0x927 testing: random write/read operations
    #Address 0x927 Write value 0x289726bf
    li x3, 0x289726bf
    csrw 0x927, x3

    #Address 0x927 read value
    csrr x14, 0x927

    #Address 0x927 Write value 0x6799e877
    li x3, 0x6799e877
    csrw 0x927, x3

    #Address 0x927 read value
    csrr x14, 0x927

    #Address 0x927 Write value 0x2faa7ec7
    li x3, 0x2faa7ec7
    csrw 0x927, x3

    #Unmapped address 0xe27 testing: random write/read operations
    #Address 0xe27 Write value 0xd5833eac
    li x3, 0xd5833eac
    csrw 0xe27, x3

    #Address 0xe27 read value
    csrr x14, 0xe27

    #Address 0xe27 read value
    csrr x14, 0xe27

    #Unmapped address 0xf6f testing: random write/read operations
    #Address 0xf6f Write value 0x99c9ce4f
    li x3, 0x99c9ce4f
    csrw 0xf6f, x3

    #Address 0xf6f read value
    csrr x14, 0xf6f

    #Address 0xf6f Write value 0x278e23bf
    li x3, 0x278e23bf
    csrw 0xf6f, x3

    #Unmapped address 0xdd2 testing: random write/read operations
    #Address 0xdd2 Write value 0xd08adfd2
    li x3, 0xd08adfd2
    csrw 0xdd2, x3

    #Address 0xdd2 Write value 0x1ce05abc
    li x3, 0x1ce05abc
    csrw 0xdd2, x3

    #Address 0xdd2 Write value 0xb17b962f
    li x3, 0xb17b962f
    csrw 0xdd2, x3

    #Unmapped address 0x907 testing: random write/read operations
    #Address 0x907 Write value 0xf321afe8
    li x3, 0xf321afe8
    csrw 0x907, x3

    #Address 0x907 Write value 0x44bf7d5
    li x3, 0x44bf7d5
    csrw 0x907, x3

    #Address 0x907 read value
    csrr x14, 0x907

    #Address 0x907 read value
    csrr x14, 0x907

    #Unmapped address 0x82d testing: random write/read operations
    #Address 0x82d read value
    csrr x14, 0x82d

    #Address 0x82d read value
    csrr x14, 0x82d

    #Address 0x82d read value
    csrr x14, 0x82d

    #Address 0x82d read value
    csrr x14, 0x82d

    #Address 0x82d read value
    csrr x14, 0x82d

    #Unmapped address 0x949 testing: random write/read operations
    #Address 0x949 read value
    csrr x14, 0x949

    #Unmapped address 0x717 testing: random write/read operations
    #Address 0x717 Write value 0x5783dfd4
    li x3, 0x5783dfd4
    csrw 0x717, x3

    #Address 0x717 Write value 0x13cf123d
    li x3, 0x13cf123d
    csrw 0x717, x3

    #Address 0x717 read value
    csrr x14, 0x717

    #Address 0x717 read value
    csrr x14, 0x717

    #Unmapped address 0x701 testing: random write/read operations
    #Address 0x701 Write value 0xb1a5f714
    li x3, 0xb1a5f714
    csrw 0x701, x3

    #Address 0x701 read value
    csrr x14, 0x701

    #Address 0x701 read value
    csrr x14, 0x701

    #Address 0x701 Write value 0xb141c011
    li x3, 0xb141c011
    csrw 0x701, x3

    #Unmapped address 0x689 testing: random write/read operations
    #Address 0x689 read value
    csrr x14, 0x689

    #Address 0x689 read value
    csrr x14, 0x689

    #Address 0x689 read value
    csrr x14, 0x689

    #Address 0x689 read value
    csrr x14, 0x689

    #Unmapped address 0x695 testing: random write/read operations
    #Address 0x695 Write value 0x310b8f25
    li x3, 0x310b8f25
    csrw 0x695, x3

    #Address 0x695 read value
    csrr x14, 0x695

    #Address 0x695 Write value 0x9e51be23
    li x3, 0x9e51be23
    csrw 0x695, x3

    #Address 0x695 Write value 0x2150c1c8
    li x3, 0x2150c1c8
    csrw 0x695, x3

    #Unmapped address 0x54c testing: random write/read operations
    #Address 0x54c read value
    csrr x14, 0x54c

    #Address 0x54c read value
    csrr x14, 0x54c

    #Address 0x54c read value
    csrr x14, 0x54c

    #Address 0x54c Write value 0x6729d700
    li x3, 0x6729d700
    csrw 0x54c, x3

    #Unmapped address 0xd08 testing: random write/read operations
    #Address 0xd08 read value
    csrr x14, 0xd08

    #Address 0xd08 Write value 0xb97fcb0b
    li x3, 0xb97fcb0b
    csrw 0xd08, x3

    #Unmapped address 0x690 testing: random write/read operations
    #Address 0x690 Write value 0x283dd691
    li x3, 0x283dd691
    csrw 0x690, x3

    #Address 0x690 read value
    csrr x14, 0x690

    #Unmapped address 0xdaa testing: random write/read operations
    #Address 0xdaa read value
    csrr x14, 0xdaa

    #Address 0xdaa Write value 0xf2a71354
    li x3, 0xf2a71354
    csrw 0xdaa, x3

    #Address 0xdaa read value
    csrr x14, 0xdaa

    #Address 0xdaa Write value 0x1e0a9f5c
    li x3, 0x1e0a9f5c
    csrw 0xdaa, x3

    #Unmapped address 0x9e testing: random write/read operations
    #Address 0x9e Write value 0x26f31e9b
    li x3, 0x26f31e9b
    csrw 0x9e, x3

    #Address 0x9e read value
    csrr x14, 0x9e

    #Address 0x9e read value
    csrr x14, 0x9e

    #Address 0x9e read value
    csrr x14, 0x9e

    #Unmapped address 0xadb testing: random write/read operations
    #Address 0xadb Write value 0xf5361bdd
    li x3, 0xf5361bdd
    csrw 0xadb, x3

    #Address 0xadb Write value 0x54cb9a35
    li x3, 0x54cb9a35
    csrw 0xadb, x3

    #Unmapped address 0x60 testing: random write/read operations
    #Address 0x60 read value
    csrr x14, 0x60

    #Mapped address 0x3a3 (pmpcfg3) testing: random write/read operations
    #Address 0x3a3 read value
    csrr x14, 0x3a3

    #Address 0x3a3 read value
    csrr x14, 0x3a3

    #Address 0x3a3 read value
    csrr x14, 0x3a3

    #Unmapped address 0x295 testing: random write/read operations
    #Address 0x295 read value
    csrr x14, 0x295

    #Unmapped address 0x682 testing: random write/read operations
    #Address 0x682 Write value 0x18d60742
    li x3, 0x18d60742
    csrw 0x682, x3

    #Unmapped address 0x7e3 testing: random write/read operations
    #Address 0x7e3 Write value 0x5a23236b
    li x3, 0x5a23236b
    csrw 0x7e3, x3

    #Address 0x7e3 Write value 0xf97c87cd
    li x3, 0xf97c87cd
    csrw 0x7e3, x3

    #Address 0x7e3 Write value 0x73e2fbe4
    li x3, 0x73e2fbe4
    csrw 0x7e3, x3

    #Unmapped address 0x502 testing: random write/read operations
    #Address 0x502 Write value 0xda373819
    li x3, 0xda373819
    csrw 0x502, x3

    #Unmapped address 0x209 testing: random write/read operations
    #Address 0x209 read value
    csrr x14, 0x209

    #Unmapped address 0xd82 testing: random write/read operations
    #Address 0xd82 read value
    csrr x14, 0xd82

    #Address 0xd82 read value
    csrr x14, 0xd82

    #Address 0xd82 Write value 0x4bb969d8
    li x3, 0x4bb969d8
    csrw 0xd82, x3

    #Unmapped address 0x1b7 testing: random write/read operations
    #Address 0x1b7 read value
    csrr x14, 0x1b7

    #Address 0x1b7 read value
    csrr x14, 0x1b7

    #Address 0x1b7 Write value 0xc9c4f0f1
    li x3, 0xc9c4f0f1
    csrw 0x1b7, x3

    #Address 0x1b7 Write value 0xcc6b7293
    li x3, 0xcc6b7293
    csrw 0x1b7, x3

    #Unmapped address 0x54a testing: random write/read operations
    #Address 0x54a read value
    csrr x14, 0x54a

    #Address 0x54a read value
    csrr x14, 0x54a

    #Unmapped address 0x3f8 testing: random write/read operations
    #Address 0x3f8 read value
    csrr x14, 0x3f8

    #Address 0x3f8 read value
    csrr x14, 0x3f8

    #Unmapped address 0x4d7 testing: random write/read operations
    #Address 0x4d7 read value
    csrr x14, 0x4d7

    #Address 0x4d7 read value
    csrr x14, 0x4d7

    #Unmapped address 0xd1f testing: random write/read operations
    #Address 0xd1f Write value 0x16c96341
    li x3, 0x16c96341
    csrw 0xd1f, x3

    #Unmapped address 0xc79 testing: random write/read operations
    #Address 0xc79 read value
    csrr x14, 0xc79

    #Address 0xc79 read value
    csrr x14, 0xc79

    #Address 0xc79 read value
    csrr x14, 0xc79

    #Unmapped address 0xc35 testing: random write/read operations
    #Address 0xc35 read value
    csrr x14, 0xc35

    #Unmapped address 0x6db testing: random write/read operations
    #Address 0x6db read value
    csrr x14, 0x6db

    #Address 0x6db read value
    csrr x14, 0x6db

    #Address 0x6db read value
    csrr x14, 0x6db

    #Address 0x6db read value
    csrr x14, 0x6db

    #Unmapped address 0x510 testing: random write/read operations
    #Address 0x510 Write value 0x1d271b96
    li x3, 0x1d271b96
    csrw 0x510, x3

    #Unmapped address 0xd25 testing: random write/read operations
    #Address 0xd25 read value
    csrr x14, 0xd25

    #Unmapped address 0xf3f testing: random write/read operations
    #Address 0xf3f Write value 0x8f68e151
    li x3, 0x8f68e151
    csrw 0xf3f, x3

    #Address 0xf3f read value
    csrr x14, 0xf3f

    #Address 0xf3f read value
    csrr x14, 0xf3f

    #Address 0xf3f read value
    csrr x14, 0xf3f

    #Address 0xf3f Write value 0xf036e4c4
    li x3, 0xf036e4c4
    csrw 0xf3f, x3

    #Unmapped address 0xb63 testing: random write/read operations
    #Address 0xb63 read value
    csrr x14, 0xb63

    #Address 0xb63 read value
    csrr x14, 0xb63

    #Address 0xb63 read value
    csrr x14, 0xb63

    #Address 0xb63 Write value 0x86f72f9e
    li x3, 0x86f72f9e
    csrw 0xb63, x3

    #Address 0xb63 read value
    csrr x14, 0xb63

    #Unmapped address 0xc8f testing: random write/read operations
    #Address 0xc8f read value
    csrr x14, 0xc8f

    #Address 0xc8f read value
    csrr x14, 0xc8f

    #Address 0xc8f Write value 0x2f2c4dbf
    li x3, 0x2f2c4dbf
    csrw 0xc8f, x3

    #Address 0xc8f read value
    csrr x14, 0xc8f

    #Unmapped address 0xab1 testing: random write/read operations
    #Address 0xab1 Write value 0xcf3066a5
    li x3, 0xcf3066a5
    csrw 0xab1, x3

    #Address 0xab1 read value
    csrr x14, 0xab1

    #Address 0xab1 read value
    csrr x14, 0xab1

    #Unmapped address 0xc36 testing: random write/read operations
    #Address 0xc36 read value
    csrr x14, 0xc36

    #Unmapped address 0x9c9 testing: random write/read operations
    #Address 0x9c9 Write value 0xd5b4ed18
    li x3, 0xd5b4ed18
    csrw 0x9c9, x3

    #Address 0x9c9 Write value 0x608d45d1
    li x3, 0x608d45d1
    csrw 0x9c9, x3

    #Unmapped address 0xa18 testing: random write/read operations
    #Address 0xa18 read value
    csrr x14, 0xa18

    #Address 0xa18 Write value 0x2e34a075
    li x3, 0x2e34a075
    csrw 0xa18, x3

    #Address 0xa18 Write value 0x94ba383c
    li x3, 0x94ba383c
    csrw 0xa18, x3

    #Address 0xa18 read value
    csrr x14, 0xa18

    #Unmapped address 0x411 testing: random write/read operations
    #Address 0x411 Write value 0x480969a4
    li x3, 0x480969a4
    csrw 0x411, x3

    #Address 0x411 read value
    csrr x14, 0x411

    #Address 0x411 Write value 0xf50d5c77
    li x3, 0xf50d5c77
    csrw 0x411, x3

    #Address 0x411 Write value 0x1ea699a4
    li x3, 0x1ea699a4
    csrw 0x411, x3

    #Unmapped address 0x94d testing: random write/read operations
    #Address 0x94d read value
    csrr x14, 0x94d

    #Address 0x94d read value
    csrr x14, 0x94d

    #Address 0x94d read value
    csrr x14, 0x94d

    #Unmapped address 0xad8 testing: random write/read operations
    #Address 0xad8 read value
    csrr x14, 0xad8

    #Address 0xad8 read value
    csrr x14, 0xad8

    #Address 0xad8 read value
    csrr x14, 0xad8

    #Address 0xad8 Write value 0x1d19d3ea
    li x3, 0x1d19d3ea
    csrw 0xad8, x3

    #Unmapped address 0xbe2 testing: random write/read operations
    #Address 0xbe2 Write value 0xc09cd9c9
    li x3, 0xc09cd9c9
    csrw 0xbe2, x3

    #Unmapped address 0x6e testing: random write/read operations
    #Address 0x6e Write value 0xa62debeb
    li x3, 0xa62debeb
    csrw 0x6e, x3

    #Address 0x6e Write value 0xf47147d1
    li x3, 0xf47147d1
    csrw 0x6e, x3

    #Address 0x6e read value
    csrr x14, 0x6e

    #Address 0x6e read value
    csrr x14, 0x6e

    #Unmapped address 0x1fa testing: random write/read operations
    #Address 0x1fa Write value 0x64ddee32
    li x3, 0x64ddee32
    csrw 0x1fa, x3

    #Address 0x1fa Write value 0x3aed17e5
    li x3, 0x3aed17e5
    csrw 0x1fa, x3

    #Address 0x1fa Write value 0x9f63f030
    li x3, 0x9f63f030
    csrw 0x1fa, x3

    #Unmapped address 0xf5b testing: random write/read operations
    #Address 0xf5b read value
    csrr x14, 0xf5b

    #Address 0xf5b read value
    csrr x14, 0xf5b

    #Unmapped address 0x1c1 testing: random write/read operations
    #Address 0x1c1 read value
    csrr x14, 0x1c1

    #Address 0x1c1 Write value 0x14966aa5
    li x3, 0x14966aa5
    csrw 0x1c1, x3

    #Address 0x1c1 read value
    csrr x14, 0x1c1

    #Unmapped address 0xce7 testing: random write/read operations
    #Address 0xce7 read value
    csrr x14, 0xce7

    #Unmapped address 0x459 testing: random write/read operations
    #Address 0x459 Write value 0x7ba706ea
    li x3, 0x7ba706ea
    csrw 0x459, x3

    #Address 0x459 Write value 0xd0d84481
    li x3, 0xd0d84481
    csrw 0x459, x3

    #Address 0x459 read value
    csrr x14, 0x459

    #Unmapped address 0x117 testing: random write/read operations
    #Address 0x117 read value
    csrr x14, 0x117

    #Address 0x117 Write value 0xc2233043
    li x3, 0xc2233043
    csrw 0x117, x3

    #Address 0x117 read value
    csrr x14, 0x117

    #Address 0x117 Write value 0x979b9e02
    li x3, 0x979b9e02
    csrw 0x117, x3

    #Address 0x117 read value
    csrr x14, 0x117

    #Unmapped address 0x48d testing: random write/read operations
    #Address 0x48d read value
    csrr x14, 0x48d

    #Address 0x48d read value
    csrr x14, 0x48d

    #Address 0x48d Write value 0x2e37f21c
    li x3, 0x2e37f21c
    csrw 0x48d, x3

    #Unmapped address 0xe2f testing: random write/read operations
    #Address 0xe2f Write value 0xda280b6a
    li x3, 0xda280b6a
    csrw 0xe2f, x3

    #Address 0xe2f read value
    csrr x14, 0xe2f

    #Address 0xe2f read value
    csrr x14, 0xe2f

    #Address 0xe2f Write value 0x827010bc
    li x3, 0x827010bc
    csrw 0xe2f, x3

    #Unmapped address 0xce8 testing: random write/read operations
    #Address 0xce8 Write value 0xd24a89fa
    li x3, 0xd24a89fa
    csrw 0xce8, x3

    #Unmapped address 0xa84 testing: random write/read operations
    #Address 0xa84 Write value 0xa3c74d80
    li x3, 0xa3c74d80
    csrw 0xa84, x3

    #Unmapped address 0x822 testing: random write/read operations
    #Address 0x822 Write value 0xbe574e98
    li x3, 0xbe574e98
    csrw 0x822, x3

    #Address 0x822 read value
    csrr x14, 0x822

    #Unmapped address 0xfc3 testing: random write/read operations
    #Address 0xfc3 read value
    csrr x14, 0xfc3

    #Address 0xfc3 read value
    csrr x14, 0xfc3

    #Unmapped address 0xcab testing: random write/read operations
    #Address 0xcab read value
    csrr x14, 0xcab

    #Unmapped address 0x150 testing: random write/read operations
    #Address 0x150 read value
    csrr x14, 0x150

    #Address 0x150 read value
    csrr x14, 0x150

    #Address 0x150 read value
    csrr x14, 0x150

    #Unmapped address 0x51f testing: random write/read operations
    #Address 0x51f Write value 0xa46dada1
    li x3, 0xa46dada1
    csrw 0x51f, x3

    #Address 0x51f Write value 0x806fc5d2
    li x3, 0x806fc5d2
    csrw 0x51f, x3

    #Address 0x51f Write value 0x3550d8b5
    li x3, 0x3550d8b5
    csrw 0x51f, x3

    #Address 0x51f read value
    csrr x14, 0x51f

    #Address 0x51f Write value 0x9d1783e3
    li x3, 0x9d1783e3
    csrw 0x51f, x3

    #Unmapped address 0x9f5 testing: random write/read operations
    #Address 0x9f5 Write value 0xbfce89c4
    li x3, 0xbfce89c4
    csrw 0x9f5, x3

    #Address 0x9f5 Write value 0x37d58405
    li x3, 0x37d58405
    csrw 0x9f5, x3

    #Address 0x9f5 read value
    csrr x14, 0x9f5

    #Address 0x9f5 read value
    csrr x14, 0x9f5

    #Address 0x9f5 read value
    csrr x14, 0x9f5

    #Unmapped address 0x45e testing: random write/read operations
    #Address 0x45e Write value 0x76710fc7
    li x3, 0x76710fc7
    csrw 0x45e, x3

    #Unmapped address 0x6a5 testing: random write/read operations
    #Address 0x6a5 read value
    csrr x14, 0x6a5

    #Address 0x6a5 read value
    csrr x14, 0x6a5

    #Address 0x6a5 Write value 0xa0476153
    li x3, 0xa0476153
    csrw 0x6a5, x3

    #Address 0x6a5 Write value 0xb2f96e44
    li x3, 0xb2f96e44
    csrw 0x6a5, x3

    #Unmapped address 0xa46 testing: random write/read operations
    #Address 0xa46 Write value 0x3bf06e95
    li x3, 0x3bf06e95
    csrw 0xa46, x3

    #Unmapped address 0x5fe testing: random write/read operations
    #Address 0x5fe read value
    csrr x14, 0x5fe

    #Address 0x5fe read value
    csrr x14, 0x5fe

    #Address 0x5fe Write value 0x14c40ee4
    li x3, 0x14c40ee4
    csrw 0x5fe, x3

    #Unmapped address 0x2fc testing: random write/read operations
    #Address 0x2fc read value
    csrr x14, 0x2fc

    #Unmapped address 0x347 testing: random write/read operations
    #Address 0x347 Write value 0x9938267e
    li x3, 0x9938267e
    csrw 0x347, x3

    #Address 0x347 Write value 0xdac564a2
    li x3, 0xdac564a2
    csrw 0x347, x3

    #Address 0x347 read value
    csrr x14, 0x347

    #Address 0x347 read value
    csrr x14, 0x347

    #Unmapped address 0x1fd testing: random write/read operations
    #Address 0x1fd Write value 0x98292117
    li x3, 0x98292117
    csrw 0x1fd, x3

    #Address 0x1fd read value
    csrr x14, 0x1fd

    #Address 0x1fd read value
    csrr x14, 0x1fd

    #Address 0x1fd Write value 0x28d8cd6d
    li x3, 0x28d8cd6d
    csrw 0x1fd, x3

    #Unmapped address 0xf48 testing: random write/read operations
    #Address 0xf48 read value
    csrr x14, 0xf48

    #Address 0xf48 Write value 0xbd43340b
    li x3, 0xbd43340b
    csrw 0xf48, x3

    #Address 0xf48 read value
    csrr x14, 0xf48

    #Unmapped address 0x559 testing: random write/read operations
    #Address 0x559 read value
    csrr x14, 0x559

    #Address 0x559 read value
    csrr x14, 0x559

    #Address 0x559 Write value 0x979340c5
    li x3, 0x979340c5
    csrw 0x559, x3

    #Address 0x559 read value
    csrr x14, 0x559

    #Address 0x559 read value
    csrr x14, 0x559

    #Unmapped address 0x62f testing: random write/read operations
    #Address 0x62f read value
    csrr x14, 0x62f

    #Address 0x62f Write value 0xbec9518c
    li x3, 0xbec9518c
    csrw 0x62f, x3

    #Address 0x62f read value
    csrr x14, 0x62f

    #Unmapped address 0x23 testing: random write/read operations
    #Address 0x23 Write value 0x80c4dcbb
    li x3, 0x80c4dcbb
    csrw 0x23, x3

    #Address 0x23 read value
    csrr x14, 0x23

    #Unmapped address 0x8db testing: random write/read operations
    #Address 0x8db read value
    csrr x14, 0x8db

    #Address 0x8db Write value 0xa1ec3c03
    li x3, 0xa1ec3c03
    csrw 0x8db, x3

    #Address 0x8db read value
    csrr x14, 0x8db

    #Address 0x8db read value
    csrr x14, 0x8db

    #Address 0x8db Write value 0x96a23cb8
    li x3, 0x96a23cb8
    csrw 0x8db, x3

    #Unmapped address 0xb65 testing: random write/read operations
    #Address 0xb65 Write value 0x5232e9b3
    li x3, 0x5232e9b3
    csrw 0xb65, x3

    #Address 0xb65 Write value 0x20bb5d28
    li x3, 0x20bb5d28
    csrw 0xb65, x3

    #Address 0xb65 Write value 0xc8a30392
    li x3, 0xc8a30392
    csrw 0xb65, x3

    #Unmapped address 0x7cf testing: random write/read operations
    #Address 0x7cf read value
    csrr x14, 0x7cf

    #Address 0x7cf Write value 0x13e63ac5
    li x3, 0x13e63ac5
    csrw 0x7cf, x3

    #Address 0x7cf Write value 0x42f87252
    li x3, 0x42f87252
    csrw 0x7cf, x3

    #Address 0x7cf Write value 0x5f8284bb
    li x3, 0x5f8284bb
    csrw 0x7cf, x3

    #Unmapped address 0x8c0 testing: random write/read operations
    #Address 0x8c0 read value
    csrr x14, 0x8c0

    #Address 0x8c0 Write value 0xde9d2e84
    li x3, 0xde9d2e84
    csrw 0x8c0, x3

    #Unmapped address 0x497 testing: random write/read operations
    #Address 0x497 read value
    csrr x14, 0x497

    #Address 0x497 Write value 0x384f4fab
    li x3, 0x384f4fab
    csrw 0x497, x3

    #Address 0x497 read value
    csrr x14, 0x497

    #Unmapped address 0x420 testing: random write/read operations
    #Address 0x420 read value
    csrr x14, 0x420

    #Address 0x420 Write value 0x5ff78d6c
    li x3, 0x5ff78d6c
    csrw 0x420, x3

    #Unmapped address 0x4c9 testing: random write/read operations
    #Address 0x4c9 Write value 0x33bc510c
    li x3, 0x33bc510c
    csrw 0x4c9, x3

    #Address 0x4c9 Write value 0x51418157
    li x3, 0x51418157
    csrw 0x4c9, x3

    #Address 0x4c9 Write value 0x1486a8cc
    li x3, 0x1486a8cc
    csrw 0x4c9, x3

    #Address 0x4c9 Write value 0x1b427efb
    li x3, 0x1b427efb
    csrw 0x4c9, x3

    #Address 0x4c9 Write value 0x4682608a
    li x3, 0x4682608a
    csrw 0x4c9, x3

    #Unmapped address 0x4d0 testing: random write/read operations
    #Address 0x4d0 Write value 0xc3ced585
    li x3, 0xc3ced585
    csrw 0x4d0, x3

    #Address 0x4d0 read value
    csrr x14, 0x4d0

    #Unmapped address 0x784 testing: random write/read operations
    #Address 0x784 read value
    csrr x14, 0x784

    #Address 0x784 read value
    csrr x14, 0x784

    #Address 0x784 read value
    csrr x14, 0x784

    #Address 0x784 read value
    csrr x14, 0x784

    #Address 0x784 read value
    csrr x14, 0x784

    #Unmapped address 0xd4a testing: random write/read operations
    #Address 0xd4a Write value 0xba30a348
    li x3, 0xba30a348
    csrw 0xd4a, x3

    #Address 0xd4a Write value 0x267d6003
    li x3, 0x267d6003
    csrw 0xd4a, x3

    #Address 0xd4a Write value 0x3bdfa04
    li x3, 0x3bdfa04
    csrw 0xd4a, x3

    #Address 0xd4a Write value 0xee1eaae5
    li x3, 0xee1eaae5
    csrw 0xd4a, x3

    #Address 0xd4a read value
    csrr x14, 0xd4a

    #Unmapped address 0x1f5 testing: random write/read operations
    #Address 0x1f5 Write value 0x71347f99
    li x3, 0x71347f99
    csrw 0x1f5, x3

    #Address 0x1f5 Write value 0x6b028e0d
    li x3, 0x6b028e0d
    csrw 0x1f5, x3

    #Unmapped address 0x437 testing: random write/read operations
    #Address 0x437 read value
    csrr x14, 0x437

    #Unmapped address 0xa70 testing: random write/read operations
    #Address 0xa70 Write value 0x22c3bea3
    li x3, 0x22c3bea3
    csrw 0xa70, x3

    #Address 0xa70 Write value 0x22f54565
    li x3, 0x22f54565
    csrw 0xa70, x3

    #Unmapped address 0x6a6 testing: random write/read operations
    #Address 0x6a6 read value
    csrr x14, 0x6a6

    #Address 0x6a6 Write value 0x3f1682d5
    li x3, 0x3f1682d5
    csrw 0x6a6, x3

    #Address 0x6a6 read value
    csrr x14, 0x6a6

    #Address 0x6a6 read value
    csrr x14, 0x6a6

    #Address 0x6a6 Write value 0x207a45d2
    li x3, 0x207a45d2
    csrw 0x6a6, x3

    #Unmapped address 0xc3c testing: random write/read operations
    #Address 0xc3c Write value 0x21084fe7
    li x3, 0x21084fe7
    csrw 0xc3c, x3

    #Address 0xc3c Write value 0x9ba78e7b
    li x3, 0x9ba78e7b
    csrw 0xc3c, x3

    #Unmapped address 0x83 testing: random write/read operations
    #Address 0x83 read value
    csrr x14, 0x83

    #Address 0x83 Write value 0xc525e8b9
    li x3, 0xc525e8b9
    csrw 0x83, x3

    #Address 0x83 Write value 0xb800fbc5
    li x3, 0xb800fbc5
    csrw 0x83, x3

    #Address 0x83 Write value 0xd4c3e9da
    li x3, 0xd4c3e9da
    csrw 0x83, x3

    #Unmapped address 0xa36 testing: random write/read operations
    #Address 0xa36 Write value 0x4f814c89
    li x3, 0x4f814c89
    csrw 0xa36, x3

    #Address 0xa36 read value
    csrr x14, 0xa36

    #Address 0xa36 Write value 0xa039052a
    li x3, 0xa039052a
    csrw 0xa36, x3

    #Address 0xa36 Write value 0xc461abb2
    li x3, 0xc461abb2
    csrw 0xa36, x3

    #Unmapped address 0x29a testing: random write/read operations
    #Address 0x29a Write value 0x71e1dd1b
    li x3, 0x71e1dd1b
    csrw 0x29a, x3

    #Address 0x29a Write value 0x7f3014a
    li x3, 0x7f3014a
    csrw 0x29a, x3

    #Unmapped address 0x36e testing: random write/read operations
    #Address 0x36e read value
    csrr x14, 0x36e

    #Unmapped address 0x6cb testing: random write/read operations
    #Address 0x6cb Write value 0x987620d1
    li x3, 0x987620d1
    csrw 0x6cb, x3

    #Address 0x6cb Write value 0x6588c8d2
    li x3, 0x6588c8d2
    csrw 0x6cb, x3

    #Unmapped address 0xe1a testing: random write/read operations
    #Address 0xe1a read value
    csrr x14, 0xe1a

    #Address 0xe1a Write value 0x234c2969
    li x3, 0x234c2969
    csrw 0xe1a, x3

    #Address 0xe1a Write value 0x8fbdc94a
    li x3, 0x8fbdc94a
    csrw 0xe1a, x3

    #Address 0xe1a Write value 0x56953db8
    li x3, 0x56953db8
    csrw 0xe1a, x3

    #Unmapped address 0xd23 testing: random write/read operations
    #Address 0xd23 Write value 0x8d51b1cb
    li x3, 0x8d51b1cb
    csrw 0xd23, x3

    #Unmapped address 0x29 testing: random write/read operations
    #Address 0x29 read value
    csrr x14, 0x29

    #Address 0x29 read value
    csrr x14, 0x29

    #Address 0x29 Write value 0xde5da189
    li x3, 0xde5da189
    csrw 0x29, x3

    #Unmapped address 0x3ea testing: random write/read operations
    #Address 0x3ea read value
    csrr x14, 0x3ea

    #Address 0x3ea read value
    csrr x14, 0x3ea

    #Address 0x3ea Write value 0x4d3ca275
    li x3, 0x4d3ca275
    csrw 0x3ea, x3

    #Address 0x3ea Write value 0x7d0e13cf
    li x3, 0x7d0e13cf
    csrw 0x3ea, x3

    #Address 0x3ea read value
    csrr x14, 0x3ea

    #Unmapped address 0x490 testing: random write/read operations
    #Address 0x490 read value
    csrr x14, 0x490

    #Address 0x490 read value
    csrr x14, 0x490

    #Address 0x490 read value
    csrr x14, 0x490

    #Address 0x490 Write value 0xe8eaa871
    li x3, 0xe8eaa871
    csrw 0x490, x3

    #Unmapped address 0x96f testing: random write/read operations
    #Address 0x96f Write value 0xc8e8731b
    li x3, 0xc8e8731b
    csrw 0x96f, x3

    #Address 0x96f read value
    csrr x14, 0x96f

    #Address 0x96f Write value 0x73dce7aa
    li x3, 0x73dce7aa
    csrw 0x96f, x3

    #Address 0x96f Write value 0x61204473
    li x3, 0x61204473
    csrw 0x96f, x3

    #Address 0x96f read value
    csrr x14, 0x96f

    #Unmapped address 0xbb7 testing: random write/read operations
    #Address 0xbb7 read value
    csrr x14, 0xbb7

    #Unmapped address 0x9ae testing: random write/read operations
    #Address 0x9ae Write value 0x9fe19bfa
    li x3, 0x9fe19bfa
    csrw 0x9ae, x3

    #Address 0x9ae read value
    csrr x14, 0x9ae

    #Address 0x9ae read value
    csrr x14, 0x9ae

    #Address 0x9ae Write value 0x9fe6a03
    li x3, 0x9fe6a03
    csrw 0x9ae, x3

    #Unmapped address 0xd34 testing: random write/read operations
    #Address 0xd34 Write value 0x4aaf42ed
    li x3, 0x4aaf42ed
    csrw 0xd34, x3

    #Unmapped address 0xe0a testing: random write/read operations
    #Address 0xe0a read value
    csrr x14, 0xe0a

    #Address 0xe0a read value
    csrr x14, 0xe0a

    #Unmapped address 0x670 testing: random write/read operations
    #Address 0x670 read value
    csrr x14, 0x670

    #Unmapped address 0x2b7 testing: random write/read operations
    #Address 0x2b7 Write value 0x311fdbe6
    li x3, 0x311fdbe6
    csrw 0x2b7, x3

    #Address 0x2b7 Write value 0x757a2eb6
    li x3, 0x757a2eb6
    csrw 0x2b7, x3

    #Unmapped address 0x366 testing: random write/read operations
    #Address 0x366 read value
    csrr x14, 0x366

    #Address 0x366 Write value 0xe7280df9
    li x3, 0xe7280df9
    csrw 0x366, x3

    #Address 0x366 read value
    csrr x14, 0x366

    #Address 0x366 read value
    csrr x14, 0x366

    #Address 0x366 read value
    csrr x14, 0x366

    #Unmapped address 0xa6e testing: random write/read operations
    #Address 0xa6e read value
    csrr x14, 0xa6e

    #Address 0xa6e Write value 0x1ecaa94a
    li x3, 0x1ecaa94a
    csrw 0xa6e, x3

    #Address 0xa6e read value
    csrr x14, 0xa6e

    #Unmapped address 0x541 testing: random write/read operations
    #Address 0x541 Write value 0xfc665c11
    li x3, 0xfc665c11
    csrw 0x541, x3

    #Address 0x541 read value
    csrr x14, 0x541

    #Address 0x541 read value
    csrr x14, 0x541

    #Unmapped address 0xc48 testing: random write/read operations
    #Address 0xc48 read value
    csrr x14, 0xc48

    #Address 0xc48 read value
    csrr x14, 0xc48

    #Address 0xc48 read value
    csrr x14, 0xc48

    #Mapped address 0xb93 (mhpmcounterh19) testing: random write/read operations
    #Address 0xb93 read value
    csrr x14, 0xb93

    #Unmapped address 0xbd4 testing: random write/read operations
    #Address 0xbd4 read value
    csrr x14, 0xbd4

    #Address 0xbd4 Write value 0xbf207d1b
    li x3, 0xbf207d1b
    csrw 0xbd4, x3

    #Unmapped address 0xaf5 testing: random write/read operations
    #Address 0xaf5 read value
    csrr x14, 0xaf5

    #Address 0xaf5 read value
    csrr x14, 0xaf5

    #Address 0xaf5 read value
    csrr x14, 0xaf5

    #Address 0xaf5 read value
    csrr x14, 0xaf5

    #Unmapped address 0xe96 testing: random write/read operations
    #Address 0xe96 Write value 0x314c4ba8
    li x3, 0x314c4ba8
    csrw 0xe96, x3

    #Mapped address 0x3b2 (pmpaddr2) testing: random write/read operations
    #Address 0x3b2 read value
    csrr x14, 0x3b2

    #Address 0x3b2 Write value 0xa11d6ba
    li x3, 0xa11d6ba
    csrw 0x3b2, x3

    #Address 0x3b2 Write value 0x8f019fe0
    li x3, 0x8f019fe0
    csrw 0x3b2, x3

    #Unmapped address 0x148 testing: random write/read operations
    #Address 0x148 Write value 0xfd27818c
    li x3, 0xfd27818c
    csrw 0x148, x3

    #Address 0x148 read value
    csrr x14, 0x148

    #Address 0x148 Write value 0xace1e208
    li x3, 0xace1e208
    csrw 0x148, x3

    #Address 0x148 read value
    csrr x14, 0x148

    #Unmapped address 0xb49 testing: random write/read operations
    #Address 0xb49 Write value 0xe34e2ee9
    li x3, 0xe34e2ee9
    csrw 0xb49, x3

    #Unmapped address 0xe19 testing: random write/read operations
    #Address 0xe19 Write value 0xee5fe969
    li x3, 0xee5fe969
    csrw 0xe19, x3

    #Unmapped address 0xe4f testing: random write/read operations
    #Address 0xe4f read value
    csrr x14, 0xe4f

    #Address 0xe4f Write value 0x457355bd
    li x3, 0x457355bd
    csrw 0xe4f, x3

    #Address 0xe4f Write value 0xc483cf12
    li x3, 0xc483cf12
    csrw 0xe4f, x3

    #Address 0xe4f Write value 0xe3428ab9
    li x3, 0xe3428ab9
    csrw 0xe4f, x3

    #Address 0xe4f read value
    csrr x14, 0xe4f

    #Unmapped address 0x766 testing: random write/read operations
    #Address 0x766 Write value 0x457ce56
    li x3, 0x457ce56
    csrw 0x766, x3

    #Address 0x766 read value
    csrr x14, 0x766

    #Address 0x766 Write value 0x712a1f80
    li x3, 0x712a1f80
    csrw 0x766, x3

    #Address 0x766 Write value 0xe4ca87f4
    li x3, 0xe4ca87f4
    csrw 0x766, x3

    #Address 0x766 read value
    csrr x14, 0x766

    #Unmapped address 0x5ec testing: random write/read operations
    #Address 0x5ec read value
    csrr x14, 0x5ec

    #Address 0x5ec Write value 0x725b6fff
    li x3, 0x725b6fff
    csrw 0x5ec, x3

    #Address 0x5ec read value
    csrr x14, 0x5ec

    #Address 0x5ec read value
    csrr x14, 0x5ec

    #Address 0x5ec Write value 0x5e631fb2
    li x3, 0x5e631fb2
    csrw 0x5ec, x3

    #Unmapped address 0xbda testing: random write/read operations
    #Address 0xbda read value
    csrr x14, 0xbda

    #Address 0xbda read value
    csrr x14, 0xbda

    #Address 0xbda read value
    csrr x14, 0xbda

    #Address 0xbda read value
    csrr x14, 0xbda

    #Unmapped address 0x5ad testing: random write/read operations
    #Address 0x5ad read value
    csrr x14, 0x5ad

    #Unmapped address 0xc2d testing: random write/read operations
    #Address 0xc2d Write value 0xbb15aa5e
    li x3, 0xbb15aa5e
    csrw 0xc2d, x3

    #Address 0xc2d read value
    csrr x14, 0xc2d

    #Address 0xc2d read value
    csrr x14, 0xc2d

    #Address 0xc2d read value
    csrr x14, 0xc2d

    #Unmapped address 0xd35 testing: random write/read operations
    #Address 0xd35 read value
    csrr x14, 0xd35

    #Address 0xd35 Write value 0x8396b3cf
    li x3, 0x8396b3cf
    csrw 0xd35, x3

    #Address 0xd35 Write value 0x5996e59b
    li x3, 0x5996e59b
    csrw 0xd35, x3

    #Address 0xd35 Write value 0x7be40daf
    li x3, 0x7be40daf
    csrw 0xd35, x3

    #Unmapped address 0xf1d testing: random write/read operations
    #Address 0xf1d read value
    csrr x14, 0xf1d

    #Unmapped address 0xcc6 testing: random write/read operations
    #Address 0xcc6 read value
    csrr x14, 0xcc6

    #Address 0xcc6 Write value 0x4ea7d02
    li x3, 0x4ea7d02
    csrw 0xcc6, x3

    #Address 0xcc6 Write value 0x4cf76978
    li x3, 0x4cf76978
    csrw 0xcc6, x3

    #Address 0xcc6 read value
    csrr x14, 0xcc6

    #Unmapped address 0x2a0 testing: random write/read operations
    #Address 0x2a0 Write value 0x5951e133
    li x3, 0x5951e133
    csrw 0x2a0, x3

    #Address 0x2a0 Write value 0xb2e3922
    li x3, 0xb2e3922
    csrw 0x2a0, x3

    #Address 0x2a0 read value
    csrr x14, 0x2a0

    #Address 0x2a0 Write value 0x9f47ee8c
    li x3, 0x9f47ee8c
    csrw 0x2a0, x3

    #Address 0x2a0 read value
    csrr x14, 0x2a0

    #Unmapped address 0xdc3 testing: random write/read operations
    #Address 0xdc3 Write value 0x465a374b
    li x3, 0x465a374b
    csrw 0xdc3, x3

    #Address 0xdc3 read value
    csrr x14, 0xdc3

    #Unmapped address 0xb51 testing: random write/read operations
    #Address 0xb51 Write value 0x83036454
    li x3, 0x83036454
    csrw 0xb51, x3

    #Address 0xb51 read value
    csrr x14, 0xb51

    #Address 0xb51 Write value 0xa8258da2
    li x3, 0xa8258da2
    csrw 0xb51, x3

    #Address 0xb51 read value
    csrr x14, 0xb51

    #Address 0xb51 Write value 0x6c7a5bf8
    li x3, 0x6c7a5bf8
    csrw 0xb51, x3

    #Unmapped address 0xbc0 testing: random write/read operations
    #Address 0xbc0 read value
    csrr x14, 0xbc0

    #Address 0xbc0 read value
    csrr x14, 0xbc0

    #Address 0xbc0 read value
    csrr x14, 0xbc0

    #Address 0xbc0 read value
    csrr x14, 0xbc0

    #Address 0xbc0 Write value 0x59e7abc2
    li x3, 0x59e7abc2
    csrw 0xbc0, x3

    #Unmapped address 0x68a testing: random write/read operations
    #Address 0x68a Write value 0xd92e0e7b
    li x3, 0xd92e0e7b
    csrw 0x68a, x3

    #Address 0x68a read value
    csrr x14, 0x68a

    #Address 0x68a Write value 0x112b0c71
    li x3, 0x112b0c71
    csrw 0x68a, x3

    #Address 0x68a Write value 0x86ab58dd
    li x3, 0x86ab58dd
    csrw 0x68a, x3

    #Address 0x68a Write value 0x6f3a90c2
    li x3, 0x6f3a90c2
    csrw 0x68a, x3

    #Unmapped address 0x12f testing: random write/read operations
    #Address 0x12f read value
    csrr x14, 0x12f

    #Address 0x12f Write value 0x163226c7
    li x3, 0x163226c7
    csrw 0x12f, x3

    #Address 0x12f Write value 0x9ee08537
    li x3, 0x9ee08537
    csrw 0x12f, x3

    #Address 0x12f Write value 0xf8e3f548
    li x3, 0xf8e3f548
    csrw 0x12f, x3

    #Address 0x12f Write value 0xac0a915a
    li x3, 0xac0a915a
    csrw 0x12f, x3

    #Unmapped address 0x860 testing: random write/read operations
    #Address 0x860 Write value 0xc83d2619
    li x3, 0xc83d2619
    csrw 0x860, x3

    #Unmapped address 0x16 testing: random write/read operations
    #Address 0x16 Write value 0xd7fc1a2
    li x3, 0xd7fc1a2
    csrw 0x16, x3

    #Address 0x16 Write value 0x821e6453
    li x3, 0x821e6453
    csrw 0x16, x3

    #Address 0x16 Write value 0xbb89bfcb
    li x3, 0xbb89bfcb
    csrw 0x16, x3

    #Unmapped address 0x5be testing: random write/read operations
    #Address 0x5be Write value 0x99e24f68
    li x3, 0x99e24f68
    csrw 0x5be, x3

    #Address 0x5be read value
    csrr x14, 0x5be

    #Address 0x5be read value
    csrr x14, 0x5be

    #Address 0x5be read value
    csrr x14, 0x5be

    #Unmapped address 0x7e0 testing: random write/read operations
    #Address 0x7e0 read value
    csrr x14, 0x7e0

    #Address 0x7e0 Write value 0x8f857afd
    li x3, 0x8f857afd
    csrw 0x7e0, x3

    #Address 0x7e0 read value
    csrr x14, 0x7e0

    #Address 0x7e0 read value
    csrr x14, 0x7e0

    #Address 0x7e0 Write value 0xc4cd9f4c
    li x3, 0xc4cd9f4c
    csrw 0x7e0, x3

    #Unmapped address 0x92 testing: random write/read operations
    #Address 0x92 Write value 0x4f6381ed
    li x3, 0x4f6381ed
    csrw 0x92, x3

    #Address 0x92 Write value 0xb195159e
    li x3, 0xb195159e
    csrw 0x92, x3

    #Address 0x92 Write value 0x6f292564
    li x3, 0x6f292564
    csrw 0x92, x3

    #Address 0x92 Write value 0x919ecce
    li x3, 0x919ecce
    csrw 0x92, x3

    #Address 0x92 read value
    csrr x14, 0x92

    #Unmapped address 0x1fc testing: random write/read operations
    #Address 0x1fc read value
    csrr x14, 0x1fc

    #Address 0x1fc read value
    csrr x14, 0x1fc

    #Address 0x1fc Write value 0x8684001b
    li x3, 0x8684001b
    csrw 0x1fc, x3

    #Unmapped address 0x974 testing: random write/read operations
    #Address 0x974 read value
    csrr x14, 0x974

    #Address 0x974 read value
    csrr x14, 0x974

    #Address 0x974 read value
    csrr x14, 0x974

    #Address 0x974 read value
    csrr x14, 0x974

    #Unmapped address 0x8b8 testing: random write/read operations
    #Address 0x8b8 Write value 0x4c72bddd
    li x3, 0x4c72bddd
    csrw 0x8b8, x3

    #Address 0x8b8 read value
    csrr x14, 0x8b8

    #Address 0x8b8 Write value 0xe2dc4f6d
    li x3, 0xe2dc4f6d
    csrw 0x8b8, x3

    #Address 0x8b8 Write value 0xb41971f9
    li x3, 0xb41971f9
    csrw 0x8b8, x3

    #Unmapped address 0xea testing: random write/read operations
    #Address 0xea Write value 0x89d65fbc
    li x3, 0x89d65fbc
    csrw 0xea, x3

    #Unmapped address 0x6f5 testing: random write/read operations
    #Address 0x6f5 Write value 0x24841940
    li x3, 0x24841940
    csrw 0x6f5, x3

    #Address 0x6f5 Write value 0x32f25a5b
    li x3, 0x32f25a5b
    csrw 0x6f5, x3

    #Address 0x6f5 read value
    csrr x14, 0x6f5

    #Unmapped address 0x9c testing: random write/read operations
    #Address 0x9c read value
    csrr x14, 0x9c

    #Address 0x9c Write value 0x975732c2
    li x3, 0x975732c2
    csrw 0x9c, x3

    #Address 0x9c read value
    csrr x14, 0x9c

    #Address 0x9c Write value 0x3e46638e
    li x3, 0x3e46638e
    csrw 0x9c, x3

    #Unmapped address 0x238 testing: random write/read operations
    #Address 0x238 Write value 0x19531e38
    li x3, 0x19531e38
    csrw 0x238, x3

    #Address 0x238 Write value 0x438cbb0e
    li x3, 0x438cbb0e
    csrw 0x238, x3

    #Unmapped address 0x452 testing: random write/read operations
    #Address 0x452 read value
    csrr x14, 0x452

    #Address 0x452 read value
    csrr x14, 0x452

    #Unmapped address 0xf6b testing: random write/read operations
    #Address 0xf6b Write value 0x8f9f9ed7
    li x3, 0x8f9f9ed7
    csrw 0xf6b, x3

    #Address 0xf6b read value
    csrr x14, 0xf6b

    #Address 0xf6b Write value 0x78af967c
    li x3, 0x78af967c
    csrw 0xf6b, x3

    #Address 0xf6b Write value 0x7b305b03
    li x3, 0x7b305b03
    csrw 0xf6b, x3

    #Address 0xf6b Write value 0x5788f42f
    li x3, 0x5788f42f
    csrw 0xf6b, x3

    #Unmapped address 0xc70 testing: random write/read operations
    #Address 0xc70 read value
    csrr x14, 0xc70

    #Unmapped address 0xe3a testing: random write/read operations
    #Address 0xe3a read value
    csrr x14, 0xe3a

    #Address 0xe3a Write value 0x113e366f
    li x3, 0x113e366f
    csrw 0xe3a, x3

    #Unmapped address 0x1e testing: random write/read operations
    #Address 0x1e read value
    csrr x14, 0x1e

    #Address 0x1e read value
    csrr x14, 0x1e

    #Address 0x1e Write value 0xdfabcf81
    li x3, 0xdfabcf81
    csrw 0x1e, x3

    #Address 0x1e Write value 0x80223b4
    li x3, 0x80223b4
    csrw 0x1e, x3

    #Address 0x1e Write value 0x61d15713
    li x3, 0x61d15713
    csrw 0x1e, x3

    #Unmapped address 0x10 testing: random write/read operations
    #Address 0x10 read value
    csrr x14, 0x10

    #Address 0x10 Write value 0x5c6a93f6
    li x3, 0x5c6a93f6
    csrw 0x10, x3

    #Address 0x10 Write value 0x84b796aa
    li x3, 0x84b796aa
    csrw 0x10, x3

    #Address 0x10 Write value 0x8bdc9bb7
    li x3, 0x8bdc9bb7
    csrw 0x10, x3

    #Address 0x10 Write value 0x3b0a10db
    li x3, 0x3b0a10db
    csrw 0x10, x3

    #Unmapped address 0x378 testing: random write/read operations
    #Address 0x378 read value
    csrr x14, 0x378

    #Unmapped address 0x234 testing: random write/read operations
    #Address 0x234 Write value 0x6f9995e
    li x3, 0x6f9995e
    csrw 0x234, x3

    #Unmapped address 0x843 testing: random write/read operations
    #Address 0x843 read value
    csrr x14, 0x843

    #Address 0x843 Write value 0xdd7e9fae
    li x3, 0xdd7e9fae
    csrw 0x843, x3

    #Address 0x843 Write value 0xa3ad1380
    li x3, 0xa3ad1380
    csrw 0x843, x3

    #Address 0x843 Write value 0x4628243
    li x3, 0x4628243
    csrw 0x843, x3

    #Unmapped address 0x938 testing: random write/read operations
    #Address 0x938 read value
    csrr x14, 0x938

    #Address 0x938 Write value 0x6443e441
    li x3, 0x6443e441
    csrw 0x938, x3

    #Address 0x938 read value
    csrr x14, 0x938

    #Address 0x938 read value
    csrr x14, 0x938

    #Unmapped address 0x905 testing: random write/read operations
    #Address 0x905 read value
    csrr x14, 0x905

    #Address 0x905 Write value 0xc7338725
    li x3, 0xc7338725
    csrw 0x905, x3

    #Address 0x905 Write value 0xab64fde7
    li x3, 0xab64fde7
    csrw 0x905, x3

    #Address 0x905 Write value 0x57292992
    li x3, 0x57292992
    csrw 0x905, x3

    #Unmapped address 0x163 testing: random write/read operations
    #Address 0x163 read value
    csrr x14, 0x163

    #Address 0x163 Write value 0x7080d76b
    li x3, 0x7080d76b
    csrw 0x163, x3

    #Address 0x163 Write value 0xa3d32e88
    li x3, 0xa3d32e88
    csrw 0x163, x3

    #Address 0x163 Write value 0xc867c9a7
    li x3, 0xc867c9a7
    csrw 0x163, x3

    #Unmapped address 0xcc5 testing: random write/read operations
    #Address 0xcc5 Write value 0x6144a818
    li x3, 0x6144a818
    csrw 0xcc5, x3

    #Address 0xcc5 read value
    csrr x14, 0xcc5

    #Address 0xcc5 Write value 0x50dd85e2
    li x3, 0x50dd85e2
    csrw 0xcc5, x3

    #Address 0xcc5 Write value 0x33923fe5
    li x3, 0x33923fe5
    csrw 0xcc5, x3

    #Address 0xcc5 Write value 0x78b90fe5
    li x3, 0x78b90fe5
    csrw 0xcc5, x3

    #Unmapped address 0x9f3 testing: random write/read operations
    #Address 0x9f3 Write value 0x79a925d3
    li x3, 0x79a925d3
    csrw 0x9f3, x3

    #Address 0x9f3 Write value 0x75ed1049
    li x3, 0x75ed1049
    csrw 0x9f3, x3

    #Address 0x9f3 Write value 0xe4a8bbef
    li x3, 0xe4a8bbef
    csrw 0x9f3, x3

    #Address 0x9f3 Write value 0x8dea5796
    li x3, 0x8dea5796
    csrw 0x9f3, x3

    #Address 0x9f3 Write value 0x5b197051
    li x3, 0x5b197051
    csrw 0x9f3, x3

    #Unmapped address 0x309 testing: random write/read operations
    #Address 0x309 read value
    csrr x14, 0x309

    #Address 0x309 read value
    csrr x14, 0x309

    #Address 0x309 read value
    csrr x14, 0x309

    #Unmapped address 0x203 testing: random write/read operations
    #Address 0x203 read value
    csrr x14, 0x203

    #Address 0x203 Write value 0x57c087d0
    li x3, 0x57c087d0
    csrw 0x203, x3

    #Address 0x203 read value
    csrr x14, 0x203

    #Address 0x203 read value
    csrr x14, 0x203

    #Unmapped address 0x545 testing: random write/read operations
    #Address 0x545 read value
    csrr x14, 0x545

    #Address 0x545 read value
    csrr x14, 0x545

    #Unmapped address 0x4ba testing: random write/read operations
    #Address 0x4ba read value
    csrr x14, 0x4ba

    #Address 0x4ba Write value 0x776a139
    li x3, 0x776a139
    csrw 0x4ba, x3

    #Unmapped address 0x63a testing: random write/read operations
    #Address 0x63a Write value 0x9026e64e
    li x3, 0x9026e64e
    csrw 0x63a, x3

    #Address 0x63a Write value 0xecf82294
    li x3, 0xecf82294
    csrw 0x63a, x3

    #Address 0x63a read value
    csrr x14, 0x63a

    #Address 0x63a read value
    csrr x14, 0x63a

    #Unmapped address 0x672 testing: random write/read operations
    #Address 0x672 read value
    csrr x14, 0x672

    #Address 0x672 read value
    csrr x14, 0x672

    #Address 0x672 Write value 0x1c37d28b
    li x3, 0x1c37d28b
    csrw 0x672, x3

    #Unmapped address 0x1e5 testing: random write/read operations
    #Address 0x1e5 Write value 0x509d5b0f
    li x3, 0x509d5b0f
    csrw 0x1e5, x3

    #Address 0x1e5 read value
    csrr x14, 0x1e5

    #Address 0x1e5 read value
    csrr x14, 0x1e5

    #Address 0x1e5 read value
    csrr x14, 0x1e5

    #Address 0x1e5 Write value 0xeabd85b8
    li x3, 0xeabd85b8
    csrw 0x1e5, x3

    #Unmapped address 0x5 testing: random write/read operations
    #Address 0x5 read value
    csrr x14, 0x5

    #Address 0x5 read value
    csrr x14, 0x5

    #Address 0x5 Write value 0x30e72e1d
    li x3, 0x30e72e1d
    csrw 0x5, x3

    #Unmapped address 0x85b testing: random write/read operations
    #Address 0x85b Write value 0xcd4f1641
    li x3, 0xcd4f1641
    csrw 0x85b, x3

    #Address 0x85b read value
    csrr x14, 0x85b

    #Address 0x85b read value
    csrr x14, 0x85b

    #Unmapped address 0x1ac testing: random write/read operations
    #Address 0x1ac read value
    csrr x14, 0x1ac

    #Address 0x1ac Write value 0x20b37d74
    li x3, 0x20b37d74
    csrw 0x1ac, x3

    #Address 0x1ac Write value 0xbf317953
    li x3, 0xbf317953
    csrw 0x1ac, x3

    #Address 0x1ac Write value 0x9921e83e
    li x3, 0x9921e83e
    csrw 0x1ac, x3

    #Address 0x1ac read value
    csrr x14, 0x1ac

    #Unmapped address 0xb42 testing: random write/read operations
    #Address 0xb42 Write value 0x472b6ffb
    li x3, 0x472b6ffb
    csrw 0xb42, x3

    #Address 0xb42 Write value 0x26c085c4
    li x3, 0x26c085c4
    csrw 0xb42, x3

    #Address 0xb42 Write value 0xaf5050c7
    li x3, 0xaf5050c7
    csrw 0xb42, x3

    #Address 0xb42 Write value 0x9f5fd5a5
    li x3, 0x9f5fd5a5
    csrw 0xb42, x3

    #Unmapped address 0x8b0 testing: random write/read operations
    #Address 0x8b0 Write value 0xa1f6181
    li x3, 0xa1f6181
    csrw 0x8b0, x3

    #Address 0x8b0 Write value 0xf6ccf63e
    li x3, 0xf6ccf63e
    csrw 0x8b0, x3

    #Address 0x8b0 read value
    csrr x14, 0x8b0

    #Address 0x8b0 read value
    csrr x14, 0x8b0

    #Address 0x8b0 Write value 0xce340b19
    li x3, 0xce340b19
    csrw 0x8b0, x3

    #Unmapped address 0x50d testing: random write/read operations
    #Address 0x50d read value
    csrr x14, 0x50d

    #Address 0x50d read value
    csrr x14, 0x50d

    #Address 0x50d Write value 0x9e3fc904
    li x3, 0x9e3fc904
    csrw 0x50d, x3

    #Unmapped address 0xa08 testing: random write/read operations
    #Address 0xa08 Write value 0x24caaad9
    li x3, 0x24caaad9
    csrw 0xa08, x3

    #Address 0xa08 read value
    csrr x14, 0xa08

    #Address 0xa08 read value
    csrr x14, 0xa08

    #Address 0xa08 read value
    csrr x14, 0xa08

    #Address 0xa08 read value
    csrr x14, 0xa08

    #Unmapped address 0x527 testing: random write/read operations
    #Address 0x527 read value
    csrr x14, 0x527

    #Unmapped address 0x1b testing: random write/read operations
    #Address 0x1b read value
    csrr x14, 0x1b

    #Address 0x1b read value
    csrr x14, 0x1b

    #Address 0x1b read value
    csrr x14, 0x1b

    #Unmapped address 0xd55 testing: random write/read operations
    #Address 0xd55 Write value 0xd728a5a1
    li x3, 0xd728a5a1
    csrw 0xd55, x3

    #Address 0xd55 Write value 0x50f33f65
    li x3, 0x50f33f65
    csrw 0xd55, x3

    #Address 0xd55 read value
    csrr x14, 0xd55

    #Address 0xd55 Write value 0x81d395af
    li x3, 0x81d395af
    csrw 0xd55, x3

    #Address 0xd55 read value
    csrr x14, 0xd55

    #Unmapped address 0x52c testing: random write/read operations
    #Address 0x52c read value
    csrr x14, 0x52c

    #Unmapped address 0x84b testing: random write/read operations
    #Address 0x84b Write value 0xbc54c093
    li x3, 0xbc54c093
    csrw 0x84b, x3

    #Address 0x84b read value
    csrr x14, 0x84b

    #Address 0x84b Write value 0xa5f10c24
    li x3, 0xa5f10c24
    csrw 0x84b, x3

    #Address 0x84b Write value 0xe11530d8
    li x3, 0xe11530d8
    csrw 0x84b, x3

    #Address 0x84b read value
    csrr x14, 0x84b

    #Unmapped address 0x675 testing: random write/read operations
    #Address 0x675 Write value 0x47fb1236
    li x3, 0x47fb1236
    csrw 0x675, x3

    #Address 0x675 Write value 0x2adbe062
    li x3, 0x2adbe062
    csrw 0x675, x3

    #Address 0x675 Write value 0x8bf069f4
    li x3, 0x8bf069f4
    csrw 0x675, x3

    #Address 0x675 Write value 0xed5a9818
    li x3, 0xed5a9818
    csrw 0x675, x3

    #Address 0x675 read value
    csrr x14, 0x675

    #Unmapped address 0x747 testing: random write/read operations
    #Address 0x747 Write value 0x5a504871
    li x3, 0x5a504871
    csrw 0x747, x3

    #Address 0x747 Write value 0x723fd1c8
    li x3, 0x723fd1c8
    csrw 0x747, x3

    #Unmapped address 0x746 testing: random write/read operations
    #Address 0x746 Write value 0x38460f73
    li x3, 0x38460f73
    csrw 0x746, x3

    #Address 0x746 read value
    csrr x14, 0x746

    #Address 0x746 Write value 0x308fdc25
    li x3, 0x308fdc25
    csrw 0x746, x3

    #Unmapped address 0xbcf testing: random write/read operations
    #Address 0xbcf Write value 0x47fafa74
    li x3, 0x47fafa74
    csrw 0xbcf, x3

    #Address 0xbcf Write value 0xe4dbed28
    li x3, 0xe4dbed28
    csrw 0xbcf, x3

    #Address 0xbcf Write value 0x59cbf124
    li x3, 0x59cbf124
    csrw 0xbcf, x3

    #Address 0xbcf read value
    csrr x14, 0xbcf

    #Address 0xbcf Write value 0x7dd66989
    li x3, 0x7dd66989
    csrw 0xbcf, x3

    #Unmapped address 0xac2 testing: random write/read operations
    #Address 0xac2 Write value 0x98904730
    li x3, 0x98904730
    csrw 0xac2, x3

    #Address 0xac2 read value
    csrr x14, 0xac2

    #Address 0xac2 read value
    csrr x14, 0xac2

    #Unmapped address 0x35 testing: random write/read operations
    #Address 0x35 read value
    csrr x14, 0x35

    #Address 0x35 Write value 0x86a37ef8
    li x3, 0x86a37ef8
    csrw 0x35, x3

    #Address 0x35 Write value 0xd3482004
    li x3, 0xd3482004
    csrw 0x35, x3

    #Address 0x35 read value
    csrr x14, 0x35

    #Address 0x35 read value
    csrr x14, 0x35

    #Unmapped address 0x5e1 testing: random write/read operations
    #Address 0x5e1 Write value 0xd2da307d
    li x3, 0xd2da307d
    csrw 0x5e1, x3

    #Mapped address 0xb9e (mhpmcounterh30) testing: random write/read operations
    #Address 0xb9e read value
    csrr x14, 0xb9e

    #Address 0xb9e Write value 0x228fcc40
    li x3, 0x228fcc40
    csrw 0xb9e, x3

    #Address 0xb9e Write value 0x645d94d6
    li x3, 0x645d94d6
    csrw 0xb9e, x3

    #Unmapped address 0x216 testing: random write/read operations
    #Address 0x216 read value
    csrr x14, 0x216

    #Address 0x216 Write value 0xff9ce641
    li x3, 0xff9ce641
    csrw 0x216, x3

    #Address 0x216 Write value 0x106cb982
    li x3, 0x106cb982
    csrw 0x216, x3

    #Address 0x216 Write value 0x93aae02c
    li x3, 0x93aae02c
    csrw 0x216, x3

    #Address 0x216 Write value 0x5e6d28c4
    li x3, 0x5e6d28c4
    csrw 0x216, x3

    #Unmapped address 0x757 testing: random write/read operations
    #Address 0x757 read value
    csrr x14, 0x757

    #Unmapped address 0xbca testing: random write/read operations
    #Address 0xbca Write value 0xe8616696
    li x3, 0xe8616696
    csrw 0xbca, x3

    #Unmapped address 0xc17 testing: random write/read operations
    #Address 0xc17 Write value 0xb4173cf6
    li x3, 0xb4173cf6
    csrw 0xc17, x3

    #Address 0xc17 read value
    csrr x14, 0xc17

    #Address 0xc17 Write value 0x2237ca32
    li x3, 0x2237ca32
    csrw 0xc17, x3

    #Address 0xc17 read value
    csrr x14, 0xc17

    #Address 0xc17 Write value 0x2734090d
    li x3, 0x2734090d
    csrw 0xc17, x3

    #Unmapped address 0xbee testing: random write/read operations
    #Address 0xbee Write value 0xa85b9f98
    li x3, 0xa85b9f98
    csrw 0xbee, x3

    #Address 0xbee read value
    csrr x14, 0xbee

    #Address 0xbee Write value 0x3cc0fbdc
    li x3, 0x3cc0fbdc
    csrw 0xbee, x3

    #Unmapped address 0xc47 testing: random write/read operations
    #Address 0xc47 read value
    csrr x14, 0xc47

    #Address 0xc47 Write value 0xf5dac2e0
    li x3, 0xf5dac2e0
    csrw 0xc47, x3

    #Address 0xc47 Write value 0x1c04ee86
    li x3, 0x1c04ee86
    csrw 0xc47, x3

    #Unmapped address 0x2c4 testing: random write/read operations
    #Address 0x2c4 read value
    csrr x14, 0x2c4

    #Address 0x2c4 read value
    csrr x14, 0x2c4

    #Address 0x2c4 read value
    csrr x14, 0x2c4

    #Address 0x2c4 read value
    csrr x14, 0x2c4

    #Unmapped address 0x8c8 testing: random write/read operations
    #Address 0x8c8 Write value 0x5380b410
    li x3, 0x5380b410
    csrw 0x8c8, x3

    #Address 0x8c8 read value
    csrr x14, 0x8c8

    #Address 0x8c8 read value
    csrr x14, 0x8c8

    #Address 0x8c8 Write value 0xe50f60a1
    li x3, 0xe50f60a1
    csrw 0x8c8, x3

    #Unmapped address 0xd6b testing: random write/read operations
    #Address 0xd6b Write value 0xda8c7f25
    li x3, 0xda8c7f25
    csrw 0xd6b, x3

    #Unmapped address 0xf86 testing: random write/read operations
    #Address 0xf86 Write value 0x335b4c82
    li x3, 0x335b4c82
    csrw 0xf86, x3

    #Unmapped address 0x5f9 testing: random write/read operations
    #Address 0x5f9 Write value 0x54937fc7
    li x3, 0x54937fc7
    csrw 0x5f9, x3

    #Address 0x5f9 read value
    csrr x14, 0x5f9

    #Address 0x5f9 read value
    csrr x14, 0x5f9

    #Unmapped address 0xb54 testing: random write/read operations
    #Address 0xb54 Write value 0xc3036e55
    li x3, 0xc3036e55
    csrw 0xb54, x3

    #Unmapped address 0xce1 testing: random write/read operations
    #Address 0xce1 Write value 0x3d4876c5
    li x3, 0x3d4876c5
    csrw 0xce1, x3

    #Unmapped address 0xca6 testing: random write/read operations
    #Address 0xca6 Write value 0x4056d041
    li x3, 0x4056d041
    csrw 0xca6, x3

    #Address 0xca6 Write value 0xc6d469e6
    li x3, 0xc6d469e6
    csrw 0xca6, x3

    #Unmapped address 0x88c testing: random write/read operations
    #Address 0x88c Write value 0x200de036
    li x3, 0x200de036
    csrw 0x88c, x3

    #Address 0x88c Write value 0xb7445d9f
    li x3, 0xb7445d9f
    csrw 0x88c, x3

    #Address 0x88c read value
    csrr x14, 0x88c

    #Unmapped address 0xa11 testing: random write/read operations
    #Address 0xa11 Write value 0x3928f6c4
    li x3, 0x3928f6c4
    csrw 0xa11, x3

    #Address 0xa11 Write value 0x4609e763
    li x3, 0x4609e763
    csrw 0xa11, x3

    #Address 0xa11 read value
    csrr x14, 0xa11

    #Address 0xa11 Write value 0xc8a2e859
    li x3, 0xc8a2e859
    csrw 0xa11, x3

    #Unmapped address 0xe53 testing: random write/read operations
    #Address 0xe53 Write value 0x764d2d14
    li x3, 0x764d2d14
    csrw 0xe53, x3

    #Address 0xe53 read value
    csrr x14, 0xe53

    #Address 0xe53 Write value 0x35b6cdad
    li x3, 0x35b6cdad
    csrw 0xe53, x3

    #Address 0xe53 Write value 0xd2a9c646
    li x3, 0xd2a9c646
    csrw 0xe53, x3

    #Address 0xe53 Write value 0x17979487
    li x3, 0x17979487
    csrw 0xe53, x3

    #Unmapped address 0xde5 testing: random write/read operations
    #Address 0xde5 Write value 0x9f2da959
    li x3, 0x9f2da959
    csrw 0xde5, x3

    #Address 0xde5 Write value 0x887eed43
    li x3, 0x887eed43
    csrw 0xde5, x3

    #Unmapped address 0xf91 testing: random write/read operations
    #Address 0xf91 read value
    csrr x14, 0xf91

    #Unmapped address 0x317 testing: random write/read operations
    #Address 0x317 read value
    csrr x14, 0x317

    #Unmapped address 0x916 testing: random write/read operations
    #Address 0x916 Write value 0xaffd37bc
    li x3, 0xaffd37bc
    csrw 0x916, x3

    #Address 0x916 Write value 0xa23ba24a
    li x3, 0xa23ba24a
    csrw 0x916, x3

    #Unmapped address 0xe48 testing: random write/read operations
    #Address 0xe48 read value
    csrr x14, 0xe48

    #Address 0xe48 Write value 0xcaf307af
    li x3, 0xcaf307af
    csrw 0xe48, x3

    #Address 0xe48 Write value 0x76cde9e9
    li x3, 0x76cde9e9
    csrw 0xe48, x3

    #Address 0xe48 read value
    csrr x14, 0xe48

    #Unmapped address 0x77a testing: random write/read operations
    #Address 0x77a Write value 0x5b02c5be
    li x3, 0x5b02c5be
    csrw 0x77a, x3

    #Address 0x77a read value
    csrr x14, 0x77a

    #Address 0x77a read value
    csrr x14, 0x77a

    #Address 0x77a read value
    csrr x14, 0x77a

    #Address 0x77a Write value 0x292b438c
    li x3, 0x292b438c
    csrw 0x77a, x3

    #Unmapped address 0xfaa testing: random write/read operations
    #Address 0xfaa read value
    csrr x14, 0xfaa

    #Address 0xfaa read value
    csrr x14, 0xfaa

    #Unmapped address 0x6a9 testing: random write/read operations
    #Address 0x6a9 read value
    csrr x14, 0x6a9

    #Address 0x6a9 read value
    csrr x14, 0x6a9

    #Address 0x6a9 Write value 0x3930a9a3
    li x3, 0x3930a9a3
    csrw 0x6a9, x3

    #Address 0x6a9 read value
    csrr x14, 0x6a9

    #Address 0x6a9 Write value 0x91653861
    li x3, 0x91653861
    csrw 0x6a9, x3

    #Unmapped address 0xb01 testing: random write/read operations
    #Address 0xb01 Write value 0xb5782292
    li x3, 0xb5782292
    csrw 0xb01, x3

    #Address 0xb01 Write value 0x65cbbe25
    li x3, 0x65cbbe25
    csrw 0xb01, x3

    #Address 0xb01 Write value 0xccdbd814
    li x3, 0xccdbd814
    csrw 0xb01, x3

    #Unmapped address 0xd68 testing: random write/read operations
    #Address 0xd68 read value
    csrr x14, 0xd68

    #Address 0xd68 read value
    csrr x14, 0xd68

    #Address 0xd68 read value
    csrr x14, 0xd68

    #Address 0xd68 Write value 0x7ec74e00
    li x3, 0x7ec74e00
    csrw 0xd68, x3

    #Address 0xd68 Write value 0x259d2570
    li x3, 0x259d2570
    csrw 0xd68, x3

    #Unmapped address 0xf10 testing: random write/read operations
    #Address 0xf10 Write value 0x440283e8
    li x3, 0x440283e8
    csrw 0xf10, x3

    #Address 0xf10 read value
    csrr x14, 0xf10

    #Address 0xf10 read value
    csrr x14, 0xf10

    #Unmapped address 0x9a6 testing: random write/read operations
    #Address 0x9a6 Write value 0x8327c601
    li x3, 0x8327c601
    csrw 0x9a6, x3

    #Unmapped address 0x5ba testing: random write/read operations
    #Address 0x5ba Write value 0xee00f1ed
    li x3, 0xee00f1ed
    csrw 0x5ba, x3

    #Address 0x5ba Write value 0xe92445e1
    li x3, 0xe92445e1
    csrw 0x5ba, x3

    #Address 0x5ba Write value 0xc000ec10
    li x3, 0xc000ec10
    csrw 0x5ba, x3

    #Unmapped address 0x371 testing: random write/read operations
    #Address 0x371 read value
    csrr x14, 0x371

    #Address 0x371 read value
    csrr x14, 0x371

    #Address 0x371 read value
    csrr x14, 0x371

    #Address 0x371 Write value 0x977215fe
    li x3, 0x977215fe
    csrw 0x371, x3

    #Address 0x371 read value
    csrr x14, 0x371

    #Unmapped address 0xdb6 testing: random write/read operations
    #Address 0xdb6 read value
    csrr x14, 0xdb6

    #Address 0xdb6 read value
    csrr x14, 0xdb6

    #Unmapped address 0x971 testing: random write/read operations
    #Address 0x971 Write value 0x9ac3f18e
    li x3, 0x9ac3f18e
    csrw 0x971, x3

    #Unmapped address 0x7e9 testing: random write/read operations
    #Address 0x7e9 read value
    csrr x14, 0x7e9

    #Address 0x7e9 read value
    csrr x14, 0x7e9

    #Address 0x7e9 Write value 0xb6b97c27
    li x3, 0xb6b97c27
    csrw 0x7e9, x3

    #Address 0x7e9 Write value 0xd8aef8fa
    li x3, 0xd8aef8fa
    csrw 0x7e9, x3

    #Address 0x7e9 read value
    csrr x14, 0x7e9

    #Unmapped address 0xf5d testing: random write/read operations
    #Address 0xf5d Write value 0xa7e06234
    li x3, 0xa7e06234
    csrw 0xf5d, x3

    #Address 0xf5d read value
    csrr x14, 0xf5d

    #Address 0xf5d read value
    csrr x14, 0xf5d

    #Address 0xf5d read value
    csrr x14, 0xf5d

    #Address 0xf5d Write value 0xfe29aa1a
    li x3, 0xfe29aa1a
    csrw 0xf5d, x3

    #Unmapped address 0xf83 testing: random write/read operations
    #Address 0xf83 read value
    csrr x14, 0xf83

    #Address 0xf83 read value
    csrr x14, 0xf83

    #Address 0xf83 Write value 0x89656ed8
    li x3, 0x89656ed8
    csrw 0xf83, x3

    #Address 0xf83 Write value 0x1d708d26
    li x3, 0x1d708d26
    csrw 0xf83, x3

    #Address 0xf83 Write value 0xe33a2f9b
    li x3, 0xe33a2f9b
    csrw 0xf83, x3

    #Unmapped address 0xf9d testing: random write/read operations
    #Address 0xf9d read value
    csrr x14, 0xf9d

    #Address 0xf9d read value
    csrr x14, 0xf9d

    #Address 0xf9d Write value 0x3f4dd038
    li x3, 0x3f4dd038
    csrw 0xf9d, x3

    #Address 0xf9d Write value 0x5727325d
    li x3, 0x5727325d
    csrw 0xf9d, x3

    #Address 0xf9d Write value 0x691be552
    li x3, 0x691be552
    csrw 0xf9d, x3

    #Unmapped address 0xb7d testing: random write/read operations
    #Address 0xb7d read value
    csrr x14, 0xb7d

    #Address 0xb7d Write value 0xdc005edd
    li x3, 0xdc005edd
    csrw 0xb7d, x3

    #Address 0xb7d Write value 0xe8fba63e
    li x3, 0xe8fba63e
    csrw 0xb7d, x3

    #Address 0xb7d Write value 0x2b05981d
    li x3, 0x2b05981d
    csrw 0xb7d, x3

    #Unmapped address 0x349 testing: random write/read operations
    #Address 0x349 read value
    csrr x14, 0x349

    #Address 0x349 Write value 0xc4681f0c
    li x3, 0xc4681f0c
    csrw 0x349, x3

    #Address 0x349 read value
    csrr x14, 0x349

    #Address 0x349 Write value 0x2bae3946
    li x3, 0x2bae3946
    csrw 0x349, x3

    #Unmapped address 0x58e testing: random write/read operations
    #Address 0x58e Write value 0x50f8267a
    li x3, 0x50f8267a
    csrw 0x58e, x3

    #Address 0x58e read value
    csrr x14, 0x58e

    #Address 0x58e Write value 0x326c1857
    li x3, 0x326c1857
    csrw 0x58e, x3

    #Unmapped address 0x7cb testing: random write/read operations
    #Address 0x7cb read value
    csrr x14, 0x7cb

    #Address 0x7cb Write value 0xb62c8fcf
    li x3, 0xb62c8fcf
    csrw 0x7cb, x3

    #Unmapped address 0x2f3 testing: random write/read operations
    #Address 0x2f3 read value
    csrr x14, 0x2f3

    #Address 0x2f3 Write value 0xa94bcc96
    li x3, 0xa94bcc96
    csrw 0x2f3, x3

    #Unmapped address 0x574 testing: random write/read operations
    #Address 0x574 Write value 0x2d7c403f
    li x3, 0x2d7c403f
    csrw 0x574, x3

    #Address 0x574 read value
    csrr x14, 0x574

    #Address 0x574 read value
    csrr x14, 0x574

    #Unmapped address 0x82b testing: random write/read operations
    #Address 0x82b read value
    csrr x14, 0x82b

    #Address 0x82b read value
    csrr x14, 0x82b

    #Address 0x82b Write value 0x6b32099
    li x3, 0x6b32099
    csrw 0x82b, x3

    #Unmapped address 0xf7e testing: random write/read operations
    #Address 0xf7e read value
    csrr x14, 0xf7e

    #Address 0xf7e Write value 0x5a553446
    li x3, 0x5a553446
    csrw 0xf7e, x3

    #Address 0xf7e Write value 0x72d3659d
    li x3, 0x72d3659d
    csrw 0xf7e, x3

    #Unmapped address 0x32 testing: random write/read operations
    #Address 0x32 read value
    csrr x14, 0x32

    #Address 0x32 read value
    csrr x14, 0x32

    #Address 0x32 read value
    csrr x14, 0x32

    #Address 0x32 Write value 0x7befb352
    li x3, 0x7befb352
    csrw 0x32, x3

    #Unmapped address 0x22e testing: random write/read operations
    #Address 0x22e Write value 0xa871964d
    li x3, 0xa871964d
    csrw 0x22e, x3

    #Address 0x22e read value
    csrr x14, 0x22e

    #Address 0x22e Write value 0xaa7a22e8
    li x3, 0xaa7a22e8
    csrw 0x22e, x3

    #Unmapped address 0xde7 testing: random write/read operations
    #Address 0xde7 Write value 0x28171ac7
    li x3, 0x28171ac7
    csrw 0xde7, x3

    #Unmapped address 0x909 testing: random write/read operations
    #Address 0x909 Write value 0x4e9a3e81
    li x3, 0x4e9a3e81
    csrw 0x909, x3

    #Address 0x909 read value
    csrr x14, 0x909

    #Unmapped address 0x271 testing: random write/read operations
    #Address 0x271 read value
    csrr x14, 0x271

    #Address 0x271 Write value 0xeb2e995d
    li x3, 0xeb2e995d
    csrw 0x271, x3

    #Unmapped address 0x401 testing: random write/read operations
    #Address 0x401 Write value 0x951633f7
    li x3, 0x951633f7
    csrw 0x401, x3

    #Address 0x401 read value
    csrr x14, 0x401

    #Unmapped address 0x994 testing: random write/read operations
    #Address 0x994 Write value 0x78255913
    li x3, 0x78255913
    csrw 0x994, x3

    #Address 0x994 read value
    csrr x14, 0x994

    #Address 0x994 read value
    csrr x14, 0x994

    #Unmapped address 0x9ea testing: random write/read operations
    #Address 0x9ea read value
    csrr x14, 0x9ea

    #Address 0x9ea read value
    csrr x14, 0x9ea

    #Address 0x9ea read value
    csrr x14, 0x9ea

    #Unmapped address 0x4b7 testing: random write/read operations
    #Address 0x4b7 read value
    csrr x14, 0x4b7

    #Address 0x4b7 read value
    csrr x14, 0x4b7

    #Address 0x4b7 read value
    csrr x14, 0x4b7

    #Unmapped address 0xa66 testing: random write/read operations
    #Address 0xa66 Write value 0x3da6a8a2
    li x3, 0x3da6a8a2
    csrw 0xa66, x3

    #Address 0xa66 read value
    csrr x14, 0xa66

    #Address 0xa66 read value
    csrr x14, 0xa66

    #Address 0xa66 read value
    csrr x14, 0xa66

    #Unmapped address 0xf6 testing: random write/read operations
    #Address 0xf6 Write value 0xabe5a57c
    li x3, 0xabe5a57c
    csrw 0xf6, x3

    #Address 0xf6 read value
    csrr x14, 0xf6

    #Address 0xf6 read value
    csrr x14, 0xf6

    #Unmapped address 0xeb4 testing: random write/read operations
    #Address 0xeb4 read value
    csrr x14, 0xeb4

    #Unmapped address 0x707 testing: random write/read operations
    #Address 0x707 Write value 0x81ec5ac
    li x3, 0x81ec5ac
    csrw 0x707, x3

    #Address 0x707 Write value 0xee8e3df1
    li x3, 0xee8e3df1
    csrw 0x707, x3

    #Address 0x707 Write value 0x3138c965
    li x3, 0x3138c965
    csrw 0x707, x3

    #Unmapped address 0x671 testing: random write/read operations
    #Address 0x671 read value
    csrr x14, 0x671

    #Address 0x671 Write value 0x5354e85a
    li x3, 0x5354e85a
    csrw 0x671, x3

    #Address 0x671 Write value 0x70393bb1
    li x3, 0x70393bb1
    csrw 0x671, x3

    #Address 0x671 read value
    csrr x14, 0x671

    #Unmapped address 0xc1b testing: random write/read operations
    #Address 0xc1b Write value 0x20534513
    li x3, 0x20534513
    csrw 0xc1b, x3

    #Address 0xc1b Write value 0x1d4fd495
    li x3, 0x1d4fd495
    csrw 0xc1b, x3

    #Address 0xc1b read value
    csrr x14, 0xc1b

    #Address 0xc1b read value
    csrr x14, 0xc1b

    #Address 0xc1b read value
    csrr x14, 0xc1b

    #Unmapped address 0xe36 testing: random write/read operations
    #Address 0xe36 read value
    csrr x14, 0xe36

    #Address 0xe36 read value
    csrr x14, 0xe36

    #Address 0xe36 Write value 0x7ae98e69
    li x3, 0x7ae98e69
    csrw 0xe36, x3

    #Address 0xe36 read value
    csrr x14, 0xe36

    #Address 0xe36 read value
    csrr x14, 0xe36

    #Mapped address 0x328 (mhpmevent8) testing: random write/read operations
    #Address 0x328 Write value 0x368d09d3
    li x3, 0x368d09d3
    csrw 0x328, x3

    #Unmapped address 0x170 testing: random write/read operations
    #Address 0x170 Write value 0x7ef5f8bf
    li x3, 0x7ef5f8bf
    csrw 0x170, x3

    #Address 0x170 Write value 0x42b53cf9
    li x3, 0x42b53cf9
    csrw 0x170, x3

    #Address 0x170 read value
    csrr x14, 0x170

    #Address 0x170 Write value 0x4ee27061
    li x3, 0x4ee27061
    csrw 0x170, x3

    #Address 0x170 read value
    csrr x14, 0x170

    #Unmapped address 0x4be testing: random write/read operations
    #Address 0x4be read value
    csrr x14, 0x4be

    #Address 0x4be Write value 0x23ba02f5
    li x3, 0x23ba02f5
    csrw 0x4be, x3

    #Address 0x4be read value
    csrr x14, 0x4be

    #Unmapped address 0x673 testing: random write/read operations
    #Address 0x673 Write value 0x9326679
    li x3, 0x9326679
    csrw 0x673, x3

    #Address 0x673 Write value 0x2d422836
    li x3, 0x2d422836
    csrw 0x673, x3

    #Address 0x673 read value
    csrr x14, 0x673

    #Address 0x673 Write value 0x25248cb1
    li x3, 0x25248cb1
    csrw 0x673, x3

    #Address 0x673 read value
    csrr x14, 0x673

    #Unmapped address 0xd21 testing: random write/read operations
    #Address 0xd21 read value
    csrr x14, 0xd21

    #Address 0xd21 read value
    csrr x14, 0xd21

    #Address 0xd21 read value
    csrr x14, 0xd21

    #Address 0xd21 Write value 0x843f4385
    li x3, 0x843f4385
    csrw 0xd21, x3

    #Unmapped address 0xc53 testing: random write/read operations
    #Address 0xc53 Write value 0xbcee7a35
    li x3, 0xbcee7a35
    csrw 0xc53, x3

    #Address 0xc53 Write value 0x881b97df
    li x3, 0x881b97df
    csrw 0xc53, x3

    #Unmapped address 0xcef testing: random write/read operations
    #Address 0xcef Write value 0xdf9609f5
    li x3, 0xdf9609f5
    csrw 0xcef, x3

    #Address 0xcef read value
    csrr x14, 0xcef

    #Address 0xcef Write value 0x5ad7998d
    li x3, 0x5ad7998d
    csrw 0xcef, x3

    #Address 0xcef Write value 0xbc47301a
    li x3, 0xbc47301a
    csrw 0xcef, x3

    #Unmapped address 0xd6f testing: random write/read operations
    #Address 0xd6f read value
    csrr x14, 0xd6f

    #Unmapped address 0xd1e testing: random write/read operations
    #Address 0xd1e Write value 0x28f9e47b
    li x3, 0x28f9e47b
    csrw 0xd1e, x3

    #Unmapped address 0x68d testing: random write/read operations
    #Address 0x68d read value
    csrr x14, 0x68d

    #Unmapped address 0xba5 testing: random write/read operations
    #Address 0xba5 Write value 0x9f91e45b
    li x3, 0x9f91e45b
    csrw 0xba5, x3

    #Address 0xba5 read value
    csrr x14, 0xba5

    #Address 0xba5 Write value 0x2eb4b73a
    li x3, 0x2eb4b73a
    csrw 0xba5, x3

    #Unmapped address 0x247 testing: random write/read operations
    #Address 0x247 read value
    csrr x14, 0x247

    #Address 0x247 Write value 0x67940d11
    li x3, 0x67940d11
    csrw 0x247, x3

    #Address 0x247 read value
    csrr x14, 0x247

    #Address 0x247 Write value 0xcb897d40
    li x3, 0xcb897d40
    csrw 0x247, x3

    #Address 0x247 read value
    csrr x14, 0x247

    #Unmapped address 0x528 testing: random write/read operations
    #Address 0x528 Write value 0xfd7383f1
    li x3, 0xfd7383f1
    csrw 0x528, x3

    #Unmapped address 0xc04 testing: random write/read operations
    #Address 0xc04 read value
    csrr x14, 0xc04

    #Address 0xc04 Write value 0x5e15cd41
    li x3, 0x5e15cd41
    csrw 0xc04, x3

    #Address 0xc04 Write value 0x107ba66f
    li x3, 0x107ba66f
    csrw 0xc04, x3

    #Address 0xc04 read value
    csrr x14, 0xc04

    #Unmapped address 0xf05 testing: random write/read operations
    #Address 0xf05 Write value 0x547168bb
    li x3, 0x547168bb
    csrw 0xf05, x3

    #Unmapped address 0x890 testing: random write/read operations
    #Address 0x890 Write value 0x1b5f4b03
    li x3, 0x1b5f4b03
    csrw 0x890, x3

    #Address 0x890 Write value 0xbbce9538
    li x3, 0xbbce9538
    csrw 0x890, x3

    #Address 0x890 read value
    csrr x14, 0x890

    #Address 0x890 read value
    csrr x14, 0x890

    #Address 0x890 Write value 0xc0f88e60
    li x3, 0xc0f88e60
    csrw 0x890, x3

    #Unmapped address 0xb61 testing: random write/read operations
    #Address 0xb61 Write value 0x281e1b63
    li x3, 0x281e1b63
    csrw 0xb61, x3

    #Address 0xb61 read value
    csrr x14, 0xb61

    #Address 0xb61 read value
    csrr x14, 0xb61

    #Address 0xb61 Write value 0xbf385384
    li x3, 0xbf385384
    csrw 0xb61, x3

    #Address 0xb61 Write value 0xdb1d2087
    li x3, 0xdb1d2087
    csrw 0xb61, x3

    #Unmapped address 0xad5 testing: random write/read operations
    #Address 0xad5 read value
    csrr x14, 0xad5

    #Address 0xad5 read value
    csrr x14, 0xad5

    #Unmapped address 0x96d testing: random write/read operations
    #Address 0x96d read value
    csrr x14, 0x96d

    #Address 0x96d read value
    csrr x14, 0x96d

    #Unmapped address 0x5d4 testing: random write/read operations
    #Address 0x5d4 Write value 0x23b97182
    li x3, 0x23b97182
    csrw 0x5d4, x3

    #Address 0x5d4 read value
    csrr x14, 0x5d4

    #Unmapped address 0xd10 testing: random write/read operations
    #Address 0xd10 Write value 0x2523412a
    li x3, 0x2523412a
    csrw 0xd10, x3

    #Address 0xd10 Write value 0xc53e6eab
    li x3, 0xc53e6eab
    csrw 0xd10, x3

    #Address 0xd10 read value
    csrr x14, 0xd10

    #Unmapped address 0x582 testing: random write/read operations
    #Address 0x582 read value
    csrr x14, 0x582

    #Address 0x582 Write value 0x24c051
    li x3, 0x24c051
    csrw 0x582, x3

    #Address 0x582 Write value 0xe8549ff1
    li x3, 0xe8549ff1
    csrw 0x582, x3

    #Unmapped address 0xd6a testing: random write/read operations
    #Address 0xd6a Write value 0x4085e1a7
    li x3, 0x4085e1a7
    csrw 0xd6a, x3

    #Unmapped address 0xc6c testing: random write/read operations
    #Address 0xc6c Write value 0xfc1e0c
    li x3, 0xfc1e0c
    csrw 0xc6c, x3

    #Address 0xc6c read value
    csrr x14, 0xc6c

    #Address 0xc6c Write value 0xabfe2014
    li x3, 0xabfe2014
    csrw 0xc6c, x3

    #Address 0xc6c Write value 0x13907b4
    li x3, 0x13907b4
    csrw 0xc6c, x3

    #Address 0xc6c Write value 0x9c07db32
    li x3, 0x9c07db32
    csrw 0xc6c, x3

    #Unmapped address 0xc25 testing: random write/read operations
    #Address 0xc25 Write value 0x3ea99759
    li x3, 0x3ea99759
    csrw 0xc25, x3

    #Address 0xc25 read value
    csrr x14, 0xc25

    #Address 0xc25 read value
    csrr x14, 0xc25

    #Address 0xc25 read value
    csrr x14, 0xc25

    #Address 0xc25 Write value 0x3c1c636f
    li x3, 0x3c1c636f
    csrw 0xc25, x3

    #Unmapped address 0xe02 testing: random write/read operations
    #Address 0xe02 read value
    csrr x14, 0xe02

    #Address 0xe02 read value
    csrr x14, 0xe02

    #Address 0xe02 Write value 0xa05e6445
    li x3, 0xa05e6445
    csrw 0xe02, x3

    #Address 0xe02 Write value 0xafecc91
    li x3, 0xafecc91
    csrw 0xe02, x3

    #Address 0xe02 Write value 0x45a6395c
    li x3, 0x45a6395c
    csrw 0xe02, x3

    #Unmapped address 0xfec testing: random write/read operations
    #Address 0xfec Write value 0xaac384ed
    li x3, 0xaac384ed
    csrw 0xfec, x3

    #Address 0xfec Write value 0xbdf7707b
    li x3, 0xbdf7707b
    csrw 0xfec, x3

    #Address 0xfec read value
    csrr x14, 0xfec

    #Address 0xfec read value
    csrr x14, 0xfec

    #Address 0xfec Write value 0x1f1c6a74
    li x3, 0x1f1c6a74
    csrw 0xfec, x3

    #Unmapped address 0xa14 testing: random write/read operations
    #Address 0xa14 read value
    csrr x14, 0xa14

    #Address 0xa14 Write value 0x7eda96d
    li x3, 0x7eda96d
    csrw 0xa14, x3

    #Address 0xa14 Write value 0x3f2d23fd
    li x3, 0x3f2d23fd
    csrw 0xa14, x3

    #Unmapped address 0xca5 testing: random write/read operations
    #Address 0xca5 read value
    csrr x14, 0xca5

    #Address 0xca5 Write value 0x95c2457c
    li x3, 0x95c2457c
    csrw 0xca5, x3

    #Address 0xca5 Write value 0x4dcbfdf0
    li x3, 0x4dcbfdf0
    csrw 0xca5, x3

    #Address 0xca5 Write value 0xf223ab8b
    li x3, 0xf223ab8b
    csrw 0xca5, x3

    #Unmapped address 0x7d6 testing: random write/read operations
    #Address 0x7d6 read value
    csrr x14, 0x7d6

    #Unmapped address 0x195 testing: random write/read operations
    #Address 0x195 read value
    csrr x14, 0x195

    #Address 0x195 read value
    csrr x14, 0x195

    #Address 0x195 Write value 0x7f6ada23
    li x3, 0x7f6ada23
    csrw 0x195, x3

    #Address 0x195 Write value 0xf2d384b6
    li x3, 0xf2d384b6
    csrw 0x195, x3

    #Address 0x195 read value
    csrr x14, 0x195

    #Unmapped address 0x65e testing: random write/read operations
    #Address 0x65e Write value 0x1edd4775
    li x3, 0x1edd4775
    csrw 0x65e, x3

    #Address 0x65e read value
    csrr x14, 0x65e

    #Address 0x65e read value
    csrr x14, 0x65e

    #Unmapped address 0xac6 testing: random write/read operations
    #Address 0xac6 read value
    csrr x14, 0xac6

    #Address 0xac6 Write value 0xe8b69396
    li x3, 0xe8b69396
    csrw 0xac6, x3

    #Address 0xac6 read value
    csrr x14, 0xac6

    #Unmapped address 0xdfa testing: random write/read operations
    #Address 0xdfa read value
    csrr x14, 0xdfa

    #Address 0xdfa read value
    csrr x14, 0xdfa

    #Address 0xdfa read value
    csrr x14, 0xdfa

    #Address 0xdfa Write value 0x9c1493e4
    li x3, 0x9c1493e4
    csrw 0xdfa, x3

    #Unmapped address 0xc95 testing: random write/read operations
    #Address 0xc95 read value
    csrr x14, 0xc95

    #Address 0xc95 read value
    csrr x14, 0xc95

    #Address 0xc95 Write value 0x731eb432
    li x3, 0x731eb432
    csrw 0xc95, x3

    #Address 0xc95 read value
    csrr x14, 0xc95

    #Unmapped address 0x103 testing: random write/read operations
    #Address 0x103 read value
    csrr x14, 0x103

    #Address 0x103 Write value 0xb2613215
    li x3, 0xb2613215
    csrw 0x103, x3

    #Address 0x103 read value
    csrr x14, 0x103

    #Address 0x103 read value
    csrr x14, 0x103

    #Address 0x103 read value
    csrr x14, 0x103

    #Unmapped address 0x8ae testing: random write/read operations
    #Address 0x8ae Write value 0x474d3c91
    li x3, 0x474d3c91
    csrw 0x8ae, x3

    #Unmapped address 0x982 testing: random write/read operations
    #Address 0x982 Write value 0xb3c90dbd
    li x3, 0xb3c90dbd
    csrw 0x982, x3

    #Address 0x982 read value
    csrr x14, 0x982

    #Address 0x982 Write value 0x45ef63aa
    li x3, 0x45ef63aa
    csrw 0x982, x3

    #Address 0x982 read value
    csrr x14, 0x982

    #Address 0x982 Write value 0x4ef80a8
    li x3, 0x4ef80a8
    csrw 0x982, x3

    #Unmapped address 0xfa3 testing: random write/read operations
    #Address 0xfa3 Write value 0xa6631db7
    li x3, 0xa6631db7
    csrw 0xfa3, x3

    #Address 0xfa3 read value
    csrr x14, 0xfa3

    #Address 0xfa3 Write value 0xe4389862
    li x3, 0xe4389862
    csrw 0xfa3, x3

    #Address 0xfa3 read value
    csrr x14, 0xfa3

    #Unmapped address 0x9f2 testing: random write/read operations
    #Address 0x9f2 Write value 0xfedac474
    li x3, 0xfedac474
    csrw 0x9f2, x3

    #Address 0x9f2 Write value 0x2707cf37
    li x3, 0x2707cf37
    csrw 0x9f2, x3

    #Unmapped address 0xf00 testing: random write/read operations
    #Address 0xf00 read value
    csrr x14, 0xf00

    #Address 0xf00 Write value 0x555f0505
    li x3, 0x555f0505
    csrw 0xf00, x3

    #Address 0xf00 Write value 0x24e3bacd
    li x3, 0x24e3bacd
    csrw 0xf00, x3

    #Address 0xf00 read value
    csrr x14, 0xf00

    #Unmapped address 0x501 testing: random write/read operations
    #Address 0x501 Write value 0xc798215d
    li x3, 0xc798215d
    csrw 0x501, x3

    #Address 0x501 Write value 0xc32390fe
    li x3, 0xc32390fe
    csrw 0x501, x3

    #Address 0x501 read value
    csrr x14, 0x501

    #Address 0x501 Write value 0xbce8f52b
    li x3, 0xbce8f52b
    csrw 0x501, x3

    #Unmapped address 0xbcd testing: random write/read operations
    #Address 0xbcd Write value 0x1c976d9c
    li x3, 0x1c976d9c
    csrw 0xbcd, x3

    #Address 0xbcd read value
    csrr x14, 0xbcd

    #Unmapped address 0xe0 testing: random write/read operations
    #Address 0xe0 read value
    csrr x14, 0xe0

    #Unmapped address 0x419 testing: random write/read operations
    #Address 0x419 Write value 0xdeff1307
    li x3, 0xdeff1307
    csrw 0x419, x3

    #Address 0x419 read value
    csrr x14, 0x419

    #Address 0x419 read value
    csrr x14, 0x419

    #Unmapped address 0xa03 testing: random write/read operations
    #Address 0xa03 read value
    csrr x14, 0xa03

    #Address 0xa03 read value
    csrr x14, 0xa03

    #Address 0xa03 read value
    csrr x14, 0xa03

    #Unmapped address 0x7d5 testing: random write/read operations
    #Address 0x7d5 read value
    csrr x14, 0x7d5

    #Address 0x7d5 read value
    csrr x14, 0x7d5

    #Address 0x7d5 read value
    csrr x14, 0x7d5

    #Unmapped address 0x142 testing: random write/read operations
    #Address 0x142 Write value 0x306e05cd
    li x3, 0x306e05cd
    csrw 0x142, x3

    #Address 0x142 read value
    csrr x14, 0x142

    #Address 0x142 read value
    csrr x14, 0x142

    #Mapped address 0xb07 (mhpmcounter7) testing: random write/read operations
    #Address 0xb07 Write value 0xf169c261
    li x3, 0xf169c261
    csrw 0xb07, x3

    #Unmapped address 0xbad testing: random write/read operations
    #Address 0xbad read value
    csrr x14, 0xbad

    #Address 0xbad Write value 0xaffde9ef
    li x3, 0xaffde9ef
    csrw 0xbad, x3

    #Address 0xbad read value
    csrr x14, 0xbad

    #Unmapped address 0x879 testing: random write/read operations
    #Address 0x879 Write value 0x30ae8b12
    li x3, 0x30ae8b12
    csrw 0x879, x3

    #Address 0x879 Write value 0x4d16aea4
    li x3, 0x4d16aea4
    csrw 0x879, x3

    #Address 0x879 read value
    csrr x14, 0x879

    #Unmapped address 0x7a6 testing: random write/read operations
    #Address 0x7a6 read value
    csrr x14, 0x7a6

    #Address 0x7a6 Write value 0x5221f57f
    li x3, 0x5221f57f
    csrw 0x7a6, x3

    #Unmapped address 0xc2e testing: random write/read operations
    #Address 0xc2e Write value 0x930774f2
    li x3, 0x930774f2
    csrw 0xc2e, x3

    #Address 0xc2e read value
    csrr x14, 0xc2e

    #Address 0xc2e read value
    csrr x14, 0xc2e

    #Unmapped address 0xf54 testing: random write/read operations
    #Address 0xf54 read value
    csrr x14, 0xf54

    #Address 0xf54 read value
    csrr x14, 0xf54

    #Unmapped address 0x90f testing: random write/read operations
    #Address 0x90f Write value 0xa43afe6c
    li x3, 0xa43afe6c
    csrw 0x90f, x3

    #Address 0x90f read value
    csrr x14, 0x90f

    #Unmapped address 0x6c0 testing: random write/read operations
    #Address 0x6c0 read value
    csrr x14, 0x6c0

    #Address 0x6c0 read value
    csrr x14, 0x6c0

    #Address 0x6c0 read value
    csrr x14, 0x6c0

    #Address 0x6c0 Write value 0xd51b7022
    li x3, 0xd51b7022
    csrw 0x6c0, x3

    #Address 0x6c0 Write value 0x2e901ca4
    li x3, 0x2e901ca4
    csrw 0x6c0, x3

    #Unmapped address 0xc30 testing: random write/read operations
    #Address 0xc30 read value
    csrr x14, 0xc30

    #Address 0xc30 read value
    csrr x14, 0xc30

    #Address 0xc30 Write value 0x6a892cb5
    li x3, 0x6a892cb5
    csrw 0xc30, x3

    #Address 0xc30 Write value 0xd9184813
    li x3, 0xd9184813
    csrw 0xc30, x3

    #Address 0xc30 Write value 0xfef58794
    li x3, 0xfef58794
    csrw 0xc30, x3

    #Unmapped address 0x49c testing: random write/read operations
    #Address 0x49c read value
    csrr x14, 0x49c

    #Address 0x49c read value
    csrr x14, 0x49c

    #Unmapped address 0x2b6 testing: random write/read operations
    #Address 0x2b6 read value
    csrr x14, 0x2b6

    #Address 0x2b6 Write value 0xaf91417c
    li x3, 0xaf91417c
    csrw 0x2b6, x3

    #Address 0x2b6 Write value 0xe74de576
    li x3, 0xe74de576
    csrw 0x2b6, x3

    #Address 0x2b6 read value
    csrr x14, 0x2b6

    #Unmapped address 0xf94 testing: random write/read operations
    #Address 0xf94 read value
    csrr x14, 0xf94

    #Address 0xf94 read value
    csrr x14, 0xf94

    #Unmapped address 0xef9 testing: random write/read operations
    #Address 0xef9 Write value 0xe3367191
    li x3, 0xe3367191
    csrw 0xef9, x3

    #Address 0xef9 Write value 0xa64c64b3
    li x3, 0xa64c64b3
    csrw 0xef9, x3

    #Address 0xef9 read value
    csrr x14, 0xef9

    #Address 0xef9 Write value 0xc5655288
    li x3, 0xc5655288
    csrw 0xef9, x3

    #Address 0xef9 read value
    csrr x14, 0xef9

    #Unmapped address 0x2bc testing: random write/read operations
    #Address 0x2bc read value
    csrr x14, 0x2bc

    #Address 0x2bc read value
    csrr x14, 0x2bc

    #Address 0x2bc Write value 0xa644a64e
    li x3, 0xa644a64e
    csrw 0x2bc, x3

    #Address 0x2bc read value
    csrr x14, 0x2bc

    #Mapped address 0x32b (mhpmevent11) testing: random write/read operations
    #Address 0x32b Write value 0xa771cfbd
    li x3, 0xa771cfbd
    csrw 0x32b, x3

    #Address 0x32b read value
    csrr x14, 0x32b

    #Unmapped address 0xd62 testing: random write/read operations
    #Address 0xd62 Write value 0xbab52a08
    li x3, 0xbab52a08
    csrw 0xd62, x3

    #Address 0xd62 Write value 0x4d4b15c7
    li x3, 0x4d4b15c7
    csrw 0xd62, x3

    #Unmapped address 0x8d9 testing: random write/read operations
    #Address 0x8d9 read value
    csrr x14, 0x8d9

    #Address 0x8d9 read value
    csrr x14, 0x8d9

    #Unmapped address 0x891 testing: random write/read operations
    #Address 0x891 Write value 0x82cb0a62
    li x3, 0x82cb0a62
    csrw 0x891, x3

    #Address 0x891 read value
    csrr x14, 0x891

    #Address 0x891 read value
    csrr x14, 0x891

    #Address 0x891 read value
    csrr x14, 0x891

    #Address 0x891 read value
    csrr x14, 0x891

    #Unmapped address 0xdc testing: random write/read operations
    #Address 0xdc read value
    csrr x14, 0xdc

    #Address 0xdc read value
    csrr x14, 0xdc

    #Address 0xdc Write value 0xd2e0ab38
    li x3, 0xd2e0ab38
    csrw 0xdc, x3

    #Mapped address 0xb00 (mcycle) testing: random write/read operations
    #Address 0xb00 Write value 0x967cc5e
    li x3, 0x967cc5e
    csrw 0xb00, x3

    #Address 0xb00 Write value 0x81e0fb81
    li x3, 0x81e0fb81
    csrw 0xb00, x3

    #Address 0xb00 Write value 0x6ca1e375
    li x3, 0x6ca1e375
    csrw 0xb00, x3

    #Address 0xb00 read value
    csrr x14, 0xb00

    #Address 0xb00 read value
    csrr x14, 0xb00

    #Unmapped address 0xed testing: random write/read operations
    #Address 0xed read value
    csrr x14, 0xed

    #Address 0xed Write value 0x6ae0fcec
    li x3, 0x6ae0fcec
    csrw 0xed, x3

    #Address 0xed read value
    csrr x14, 0xed

    #Unmapped address 0x655 testing: random write/read operations
    #Address 0x655 read value
    csrr x14, 0x655

    #Address 0x655 Write value 0x93a66dc7
    li x3, 0x93a66dc7
    csrw 0x655, x3

    #Unmapped address 0x4e2 testing: random write/read operations
    #Address 0x4e2 Write value 0xd9379f14
    li x3, 0xd9379f14
    csrw 0x4e2, x3

    #Address 0x4e2 Write value 0xdeba8009
    li x3, 0xdeba8009
    csrw 0x4e2, x3

    #Address 0x4e2 read value
    csrr x14, 0x4e2

    #Address 0x4e2 read value
    csrr x14, 0x4e2

    #Unmapped address 0xab7 testing: random write/read operations
    #Address 0xab7 read value
    csrr x14, 0xab7

    #Unmapped address 0x5ed testing: random write/read operations
    #Address 0x5ed Write value 0x3f699a7c
    li x3, 0x3f699a7c
    csrw 0x5ed, x3

    #Address 0x5ed Write value 0x58aea2d3
    li x3, 0x58aea2d3
    csrw 0x5ed, x3

    #Address 0x5ed read value
    csrr x14, 0x5ed

    #Unmapped address 0xd31 testing: random write/read operations
    #Address 0xd31 read value
    csrr x14, 0xd31

    #Address 0xd31 Write value 0x167d8d04
    li x3, 0x167d8d04
    csrw 0xd31, x3

    #Unmapped address 0xf50 testing: random write/read operations
    #Address 0xf50 read value
    csrr x14, 0xf50

    #Address 0xf50 Write value 0x9df6957e
    li x3, 0x9df6957e
    csrw 0xf50, x3

    #Address 0xf50 Write value 0x7ad6c0c8
    li x3, 0x7ad6c0c8
    csrw 0xf50, x3

    #Address 0xf50 Write value 0x99cab7b6
    li x3, 0x99cab7b6
    csrw 0xf50, x3

    #Unmapped address 0x81d testing: random write/read operations
    #Address 0x81d Write value 0x35bc836b
    li x3, 0x35bc836b
    csrw 0x81d, x3

    #Address 0x81d read value
    csrr x14, 0x81d

    #Address 0x81d read value
    csrr x14, 0x81d

    #Unmapped address 0x40c testing: random write/read operations
    #Address 0x40c read value
    csrr x14, 0x40c

    #Mapped address 0xb99 (mhpmcounterh25) testing: random write/read operations
    #Address 0xb99 read value
    csrr x14, 0xb99

    #Address 0xb99 Write value 0xea8ee128
    li x3, 0xea8ee128
    csrw 0xb99, x3

    #Mapped address 0x325 (mhpmevent5) testing: random write/read operations
    #Address 0x325 Write value 0x2c712c85
    li x3, 0x2c712c85
    csrw 0x325, x3

    #Address 0x325 Write value 0xa1b241a2
    li x3, 0xa1b241a2
    csrw 0x325, x3

    #Address 0x325 Write value 0x912b3bbc
    li x3, 0x912b3bbc
    csrw 0x325, x3

    #Address 0x325 Write value 0x86685eb8
    li x3, 0x86685eb8
    csrw 0x325, x3

    #Address 0x325 Write value 0x81d59392
    li x3, 0x81d59392
    csrw 0x325, x3

    #Unmapped address 0xa5e testing: random write/read operations
    #Address 0xa5e read value
    csrr x14, 0xa5e

    #Address 0xa5e read value
    csrr x14, 0xa5e

    #Address 0xa5e read value
    csrr x14, 0xa5e

    #Address 0xa5e Write value 0xba371948
    li x3, 0xba371948
    csrw 0xa5e, x3

    #Unmapped address 0x2de testing: random write/read operations
    #Address 0x2de Write value 0xab33052f
    li x3, 0xab33052f
    csrw 0x2de, x3

    #Address 0x2de Write value 0x42d394c2
    li x3, 0x42d394c2
    csrw 0x2de, x3

    #Address 0x2de Write value 0xb22a5715
    li x3, 0xb22a5715
    csrw 0x2de, x3

    #Unmapped address 0x72f testing: random write/read operations
    #Address 0x72f read value
    csrr x14, 0x72f

    #Address 0x72f Write value 0x5c7cbc32
    li x3, 0x5c7cbc32
    csrw 0x72f, x3

    #Unmapped address 0x5aa testing: random write/read operations
    #Address 0x5aa Write value 0x2346f3fc
    li x3, 0x2346f3fc
    csrw 0x5aa, x3

    #Address 0x5aa Write value 0x106b16
    li x3, 0x106b16
    csrw 0x5aa, x3

    #Address 0x5aa Write value 0x7588c58e
    li x3, 0x7588c58e
    csrw 0x5aa, x3

    #Unmapped address 0x579 testing: random write/read operations
    #Address 0x579 read value
    csrr x14, 0x579

    #Address 0x579 read value
    csrr x14, 0x579

    #Address 0x579 Write value 0xc5942058
    li x3, 0xc5942058
    csrw 0x579, x3

    #Address 0x579 read value
    csrr x14, 0x579

    #Unmapped address 0x800 testing: random write/read operations
    #Address 0x800 read value
    csrr x14, 0x800

    #Unmapped address 0xfb testing: random write/read operations
    #Address 0xfb Write value 0x5a01ce9d
    li x3, 0x5a01ce9d
    csrw 0xfb, x3

    #Unmapped address 0x6e8 testing: random write/read operations
    #Address 0x6e8 read value
    csrr x14, 0x6e8

    #Unmapped address 0x64a testing: random write/read operations
    #Address 0x64a read value
    csrr x14, 0x64a

    #Address 0x64a read value
    csrr x14, 0x64a

    #Address 0x64a read value
    csrr x14, 0x64a

    #Address 0x64a read value
    csrr x14, 0x64a

    #Address 0x64a Write value 0x61ace8d6
    li x3, 0x61ace8d6
    csrw 0x64a, x3

    #Unmapped address 0xf69 testing: random write/read operations
    #Address 0xf69 Write value 0x2ae1c6e0
    li x3, 0x2ae1c6e0
    csrw 0xf69, x3

    #Unmapped address 0x34 testing: random write/read operations
    #Address 0x34 Write value 0x3155e109
    li x3, 0x3155e109
    csrw 0x34, x3

    #Address 0x34 Write value 0x4ab365b8
    li x3, 0x4ab365b8
    csrw 0x34, x3

    #Address 0x34 Write value 0xb8923c3e
    li x3, 0xb8923c3e
    csrw 0x34, x3

    #Address 0x34 read value
    csrr x14, 0x34

    #Address 0x34 read value
    csrr x14, 0x34

    #Unmapped address 0x6dc testing: random write/read operations
    #Address 0x6dc read value
    csrr x14, 0x6dc

    #Address 0x6dc read value
    csrr x14, 0x6dc

    #Address 0x6dc Write value 0xa59d9582
    li x3, 0xa59d9582
    csrw 0x6dc, x3

    #Address 0x6dc Write value 0xcad764b3
    li x3, 0xcad764b3
    csrw 0x6dc, x3

    #Address 0x6dc Write value 0x261e24a2
    li x3, 0x261e24a2
    csrw 0x6dc, x3

    #Unmapped address 0x7c8 testing: random write/read operations
    #Address 0x7c8 Write value 0xc0f365f4
    li x3, 0xc0f365f4
    csrw 0x7c8, x3

    #Address 0x7c8 Write value 0xd2b43afd
    li x3, 0xd2b43afd
    csrw 0x7c8, x3

    #Address 0x7c8 Write value 0x7936ab09
    li x3, 0x7936ab09
    csrw 0x7c8, x3

    #Address 0x7c8 Write value 0x35c7bdda
    li x3, 0x35c7bdda
    csrw 0x7c8, x3

    #Unmapped address 0xc15 testing: random write/read operations
    #Address 0xc15 Write value 0x35e48e10
    li x3, 0x35e48e10
    csrw 0xc15, x3

    #Address 0xc15 Write value 0xc53639f
    li x3, 0xc53639f
    csrw 0xc15, x3

    #Unmapped address 0x196 testing: random write/read operations
    #Address 0x196 Write value 0x3e1a2ab8
    li x3, 0x3e1a2ab8
    csrw 0x196, x3

    #Address 0x196 Write value 0xbc9fd7ea
    li x3, 0xbc9fd7ea
    csrw 0x196, x3

    #Address 0x196 read value
    csrr x14, 0x196

    #Unmapped address 0x314 testing: random write/read operations
    #Address 0x314 Write value 0xb042af07
    li x3, 0xb042af07
    csrw 0x314, x3

    #Address 0x314 Write value 0xc563dcf4
    li x3, 0xc563dcf4
    csrw 0x314, x3

    #Address 0x314 read value
    csrr x14, 0x314

    #Address 0x314 read value
    csrr x14, 0x314

    #Address 0x314 Write value 0xd549087d
    li x3, 0xd549087d
    csrw 0x314, x3

    #Unmapped address 0x6f7 testing: random write/read operations
    #Address 0x6f7 read value
    csrr x14, 0x6f7

    #Unmapped address 0xfb6 testing: random write/read operations
    #Address 0xfb6 Write value 0x746afbf7
    li x3, 0x746afbf7
    csrw 0xfb6, x3

    #Address 0xfb6 Write value 0x3fd89adc
    li x3, 0x3fd89adc
    csrw 0xfb6, x3

    #Address 0xfb6 read value
    csrr x14, 0xfb6

    #Address 0xfb6 read value
    csrr x14, 0xfb6

    #Unmapped address 0xcdd testing: random write/read operations
    #Address 0xcdd Write value 0xb5607e72
    li x3, 0xb5607e72
    csrw 0xcdd, x3

    #Address 0xcdd read value
    csrr x14, 0xcdd

    #Address 0xcdd read value
    csrr x14, 0xcdd

    #Unmapped address 0x287 testing: random write/read operations
    #Address 0x287 Write value 0x2126a143
    li x3, 0x2126a143
    csrw 0x287, x3

    #Unmapped address 0x76a testing: random write/read operations
    #Address 0x76a Write value 0x8f457df6
    li x3, 0x8f457df6
    csrw 0x76a, x3

    #Unmapped address 0x2 testing: random write/read operations
    #Address 0x2 read value
    csrr x14, 0x2

    #Address 0x2 read value
    csrr x14, 0x2

    #Address 0x2 read value
    csrr x14, 0x2

    #Unmapped address 0x7f1 testing: random write/read operations
    #Address 0x7f1 Write value 0x8a682df
    li x3, 0x8a682df
    csrw 0x7f1, x3

    #Address 0x7f1 Write value 0x9ecb29f5
    li x3, 0x9ecb29f5
    csrw 0x7f1, x3

    #Address 0x7f1 Write value 0xb055d8fa
    li x3, 0xb055d8fa
    csrw 0x7f1, x3

    #Unmapped address 0xc7 testing: random write/read operations
    #Address 0xc7 Write value 0x6c6222ef
    li x3, 0x6c6222ef
    csrw 0xc7, x3

    #Unmapped address 0xb1 testing: random write/read operations
    #Address 0xb1 Write value 0x17a16dd4
    li x3, 0x17a16dd4
    csrw 0xb1, x3

    #Address 0xb1 read value
    csrr x14, 0xb1

    #Address 0xb1 read value
    csrr x14, 0xb1

    #Unmapped address 0x80e testing: random write/read operations
    #Address 0x80e read value
    csrr x14, 0x80e

    #Address 0x80e Write value 0xbc9640f0
    li x3, 0xbc9640f0
    csrw 0x80e, x3

    #Unmapped address 0xc2f testing: random write/read operations
    #Address 0xc2f Write value 0x2d9a1786
    li x3, 0x2d9a1786
    csrw 0xc2f, x3

    #Address 0xc2f Write value 0x4531f53a
    li x3, 0x4531f53a
    csrw 0xc2f, x3

    #Unmapped address 0xce4 testing: random write/read operations
    #Address 0xce4 Write value 0x1d88a745
    li x3, 0x1d88a745
    csrw 0xce4, x3

    #Unmapped address 0xdb3 testing: random write/read operations
    #Address 0xdb3 read value
    csrr x14, 0xdb3

    #Address 0xdb3 Write value 0xb6719d61
    li x3, 0xb6719d61
    csrw 0xdb3, x3

    #Address 0xdb3 Write value 0x995a66d7
    li x3, 0x995a66d7
    csrw 0xdb3, x3

    #Address 0xdb3 Write value 0xc9a79221
    li x3, 0xc9a79221
    csrw 0xdb3, x3

    #Unmapped address 0xce testing: random write/read operations
    #Address 0xce read value
    csrr x14, 0xce

    #Address 0xce Write value 0x1ba45a04
    li x3, 0x1ba45a04
    csrw 0xce, x3

    #Address 0xce read value
    csrr x14, 0xce

    #Address 0xce read value
    csrr x14, 0xce

    #Unmapped address 0xa57 testing: random write/read operations
    #Address 0xa57 Write value 0x5cc396e6
    li x3, 0x5cc396e6
    csrw 0xa57, x3

    #Address 0xa57 Write value 0xaf287b03
    li x3, 0xaf287b03
    csrw 0xa57, x3

    #Address 0xa57 read value
    csrr x14, 0xa57

    #Unmapped address 0x49f testing: random write/read operations
    #Address 0x49f read value
    csrr x14, 0x49f

    #Address 0x49f Write value 0xfb40c964
    li x3, 0xfb40c964
    csrw 0x49f, x3

    #Address 0x49f Write value 0x1d80724b
    li x3, 0x1d80724b
    csrw 0x49f, x3

    #Unmapped address 0xaef testing: random write/read operations
    #Address 0xaef Write value 0x35948758
    li x3, 0x35948758
    csrw 0xaef, x3

    #Address 0xaef Write value 0x8e8bd76
    li x3, 0x8e8bd76
    csrw 0xaef, x3

    #Address 0xaef read value
    csrr x14, 0xaef

    #Unmapped address 0xd14 testing: random write/read operations
    #Address 0xd14 read value
    csrr x14, 0xd14

    #Address 0xd14 Write value 0xe923538c
    li x3, 0xe923538c
    csrw 0xd14, x3

    #Address 0xd14 read value
    csrr x14, 0xd14

    #Unmapped address 0x3e9 testing: random write/read operations
    #Address 0x3e9 Write value 0xc74021f4
    li x3, 0xc74021f4
    csrw 0x3e9, x3

    #Address 0x3e9 read value
    csrr x14, 0x3e9

    #Unmapped address 0x45a testing: random write/read operations
    #Address 0x45a read value
    csrr x14, 0x45a

    #Address 0x45a read value
    csrr x14, 0x45a

    #Address 0x45a read value
    csrr x14, 0x45a

    #Address 0x45a Write value 0x46a1800b
    li x3, 0x46a1800b
    csrw 0x45a, x3

    #Address 0x45a read value
    csrr x14, 0x45a

    #Unmapped address 0x87d testing: random write/read operations
    #Address 0x87d Write value 0x34a8255
    li x3, 0x34a8255
    csrw 0x87d, x3

    #Unmapped address 0x821 testing: random write/read operations
    #Address 0x821 read value
    csrr x14, 0x821

    #Address 0x821 Write value 0x82f8fdb7
    li x3, 0x82f8fdb7
    csrw 0x821, x3

    #Address 0x821 Write value 0xf3b77e5b
    li x3, 0xf3b77e5b
    csrw 0x821, x3

    #Unmapped address 0xe42 testing: random write/read operations
    #Address 0xe42 read value
    csrr x14, 0xe42

    #Address 0xe42 Write value 0x405449f4
    li x3, 0x405449f4
    csrw 0xe42, x3

    #Address 0xe42 read value
    csrr x14, 0xe42

    #Unmapped address 0x1a1 testing: random write/read operations
    #Address 0x1a1 read value
    csrr x14, 0x1a1

    #Unmapped address 0x191 testing: random write/read operations
    #Address 0x191 Write value 0x8a7bed57
    li x3, 0x8a7bed57
    csrw 0x191, x3

    #Address 0x191 Write value 0x1dcc7248
    li x3, 0x1dcc7248
    csrw 0x191, x3

    #Unmapped address 0xe82 testing: random write/read operations
    #Address 0xe82 Write value 0x6eb1e40f
    li x3, 0x6eb1e40f
    csrw 0xe82, x3

    #Address 0xe82 Write value 0x861452d9
    li x3, 0x861452d9
    csrw 0xe82, x3

    #Address 0xe82 read value
    csrr x14, 0xe82

    #Address 0xe82 read value
    csrr x14, 0xe82

    #Unmapped address 0xc98 testing: random write/read operations
    #Address 0xc98 read value
    csrr x14, 0xc98

    #Address 0xc98 Write value 0x4e84b336
    li x3, 0x4e84b336
    csrw 0xc98, x3

    #Unmapped address 0x177 testing: random write/read operations
    #Address 0x177 Write value 0x2d78ed2f
    li x3, 0x2d78ed2f
    csrw 0x177, x3

    #Address 0x177 Write value 0x2e01e181
    li x3, 0x2e01e181
    csrw 0x177, x3

    #Address 0x177 read value
    csrr x14, 0x177

    #Address 0x177 Write value 0x2e273ba8
    li x3, 0x2e273ba8
    csrw 0x177, x3

    #Address 0x177 Write value 0xab9c9ed5
    li x3, 0xab9c9ed5
    csrw 0x177, x3

    #Unmapped address 0xc37 testing: random write/read operations
    #Address 0xc37 Write value 0x88788580
    li x3, 0x88788580
    csrw 0xc37, x3

    #Address 0xc37 read value
    csrr x14, 0xc37

    #Address 0xc37 Write value 0x746fbc73
    li x3, 0x746fbc73
    csrw 0xc37, x3

    #Unmapped address 0xdda testing: random write/read operations
    #Address 0xdda read value
    csrr x14, 0xdda

    #Address 0xdda Write value 0x63dc78a8
    li x3, 0x63dc78a8
    csrw 0xdda, x3

    #Address 0xdda read value
    csrr x14, 0xdda

    #Address 0xdda Write value 0xaec8bfb0
    li x3, 0xaec8bfb0
    csrw 0xdda, x3

    #Unmapped address 0x8cf testing: random write/read operations
    #Address 0x8cf Write value 0x7d7f42ca
    li x3, 0x7d7f42ca
    csrw 0x8cf, x3

    #Address 0x8cf read value
    csrr x14, 0x8cf

    #Unmapped address 0x886 testing: random write/read operations
    #Address 0x886 read value
    csrr x14, 0x886

    #Address 0x886 Write value 0x3bde0960
    li x3, 0x3bde0960
    csrw 0x886, x3

    #Address 0x886 read value
    csrr x14, 0x886

    #Address 0x886 Write value 0x71b6d966
    li x3, 0x71b6d966
    csrw 0x886, x3

    #Unmapped address 0xb3c testing: random write/read operations
    #Address 0xb3c read value
    csrr x14, 0xb3c

    #Address 0xb3c Write value 0xd6929419
    li x3, 0xd6929419
    csrw 0xb3c, x3

    #Address 0xb3c Write value 0xcee05a7
    li x3, 0xcee05a7
    csrw 0xb3c, x3

    #Address 0xb3c Write value 0xfebb7513
    li x3, 0xfebb7513
    csrw 0xb3c, x3

    #Mapped address 0xb86 (mhpmcounterh6) testing: random write/read operations
    #Address 0xb86 Write value 0xbc208714
    li x3, 0xbc208714
    csrw 0xb86, x3

    #Address 0xb86 Write value 0x51813f77
    li x3, 0x51813f77
    csrw 0xb86, x3

    #Unmapped address 0x180 testing: random write/read operations
    #Address 0x180 read value
    csrr x14, 0x180

    #Address 0x180 Write value 0x87f94b5d
    li x3, 0x87f94b5d
    csrw 0x180, x3

    #Unmapped address 0xc0d testing: random write/read operations
    #Address 0xc0d read value
    csrr x14, 0xc0d

    #Address 0xc0d read value
    csrr x14, 0xc0d

    #Address 0xc0d read value
    csrr x14, 0xc0d

    #Address 0xc0d read value
    csrr x14, 0xc0d

    #Address 0xc0d read value
    csrr x14, 0xc0d

    #Unmapped address 0xdb2 testing: random write/read operations
    #Address 0xdb2 read value
    csrr x14, 0xdb2

    #Address 0xdb2 Write value 0xc4905a5
    li x3, 0xc4905a5
    csrw 0xdb2, x3

    #Address 0xdb2 read value
    csrr x14, 0xdb2

    #Unmapped address 0x123 testing: random write/read operations
    #Address 0x123 Write value 0xcae58942
    li x3, 0xcae58942
    csrw 0x123, x3

    #Address 0x123 Write value 0xabd826bd
    li x3, 0xabd826bd
    csrw 0x123, x3

    #Address 0x123 read value
    csrr x14, 0x123

    #Unmapped address 0x95d testing: random write/read operations
    #Address 0x95d read value
    csrr x14, 0x95d

    #Address 0x95d Write value 0xb2a1787c
    li x3, 0xb2a1787c
    csrw 0x95d, x3

    #Address 0x95d Write value 0xb32b8426
    li x3, 0xb32b8426
    csrw 0x95d, x3

    #Address 0x95d read value
    csrr x14, 0x95d

    #Unmapped address 0xaa1 testing: random write/read operations
    #Address 0xaa1 Write value 0x7b1b89
    li x3, 0x7b1b89
    csrw 0xaa1, x3

    #Address 0xaa1 read value
    csrr x14, 0xaa1

    #Unmapped address 0x200 testing: random write/read operations
    #Address 0x200 read value
    csrr x14, 0x200

    #Unmapped address 0x506 testing: random write/read operations
    #Address 0x506 read value
    csrr x14, 0x506

    #Address 0x506 Write value 0x41f16e85
    li x3, 0x41f16e85
    csrw 0x506, x3

    #Address 0x506 Write value 0x9f08b1f8
    li x3, 0x9f08b1f8
    csrw 0x506, x3

    #Address 0x506 read value
    csrr x14, 0x506

    #Address 0x506 Write value 0x54d05bbb
    li x3, 0x54d05bbb
    csrw 0x506, x3

    #Unmapped address 0x88f testing: random write/read operations
    #Address 0x88f Write value 0xf71c7001
    li x3, 0xf71c7001
    csrw 0x88f, x3

    #Unmapped address 0xa65 testing: random write/read operations
    #Address 0xa65 read value
    csrr x14, 0xa65

    #Address 0xa65 Write value 0x887ff682
    li x3, 0x887ff682
    csrw 0xa65, x3

    #Address 0xa65 Write value 0x23823c5
    li x3, 0x23823c5
    csrw 0xa65, x3

    #Address 0xa65 read value
    csrr x14, 0xa65

    #Address 0xa65 read value
    csrr x14, 0xa65

    #Unmapped address 0x1e6 testing: random write/read operations
    #Address 0x1e6 Write value 0x9ff60437
    li x3, 0x9ff60437
    csrw 0x1e6, x3

    #Address 0x1e6 Write value 0xd1774ee0
    li x3, 0xd1774ee0
    csrw 0x1e6, x3

    #Address 0x1e6 Write value 0x3d5a3716
    li x3, 0x3d5a3716
    csrw 0x1e6, x3

    #Address 0x1e6 read value
    csrr x14, 0x1e6

    #Address 0x1e6 read value
    csrr x14, 0x1e6

    #Unmapped address 0x3f9 testing: random write/read operations
    #Address 0x3f9 read value
    csrr x14, 0x3f9

    #Address 0x3f9 Write value 0x5726d3eb
    li x3, 0x5726d3eb
    csrw 0x3f9, x3

    #Address 0x3f9 read value
    csrr x14, 0x3f9

    #Unmapped address 0x7a9 testing: random write/read operations
    #Address 0x7a9 read value
    csrr x14, 0x7a9

    #Address 0x7a9 Write value 0xaf00a179
    li x3, 0xaf00a179
    csrw 0x7a9, x3

    #Address 0x7a9 read value
    csrr x14, 0x7a9

    #Unmapped address 0x7a2 testing: random write/read operations
    #Address 0x7a2 Write value 0x65264ea1
    li x3, 0x65264ea1
    csrw 0x7a2, x3

    #Address 0x7a2 read value
    csrr x14, 0x7a2

    #Mapped address 0xb11 (mhpmcounter17) testing: random write/read operations
    #Address 0xb11 read value
    csrr x14, 0xb11

    #Address 0xb11 Write value 0xe2a5f3ff
    li x3, 0xe2a5f3ff
    csrw 0xb11, x3

    #Unmapped address 0x7ae testing: random write/read operations
    #Address 0x7ae read value
    csrr x14, 0x7ae

    #Address 0x7ae Write value 0xc80dbf2e
    li x3, 0xc80dbf2e
    csrw 0x7ae, x3

    #Unmapped address 0x2c5 testing: random write/read operations
    #Address 0x2c5 Write value 0xc98ccdb
    li x3, 0xc98ccdb
    csrw 0x2c5, x3

    #Address 0x2c5 read value
    csrr x14, 0x2c5

    #Address 0x2c5 read value
    csrr x14, 0x2c5

    #Unmapped address 0x75a testing: random write/read operations
    #Address 0x75a read value
    csrr x14, 0x75a

    #Address 0x75a read value
    csrr x14, 0x75a

    #Address 0x75a read value
    csrr x14, 0x75a

    #Address 0x75a read value
    csrr x14, 0x75a

    #Address 0x75a Write value 0x43eaecda
    li x3, 0x43eaecda
    csrw 0x75a, x3

    #Unmapped address 0x911 testing: random write/read operations
    #Address 0x911 read value
    csrr x14, 0x911

    #Unmapped address 0xc91 testing: random write/read operations
    #Address 0xc91 Write value 0xc23e16b4
    li x3, 0xc23e16b4
    csrw 0xc91, x3

    #Address 0xc91 read value
    csrr x14, 0xc91

    #Address 0xc91 read value
    csrr x14, 0xc91

    #Address 0xc91 Write value 0x66937cf7
    li x3, 0x66937cf7
    csrw 0xc91, x3

    #Unmapped address 0xf6d testing: random write/read operations
    #Address 0xf6d Write value 0x69bd6864
    li x3, 0x69bd6864
    csrw 0xf6d, x3

    #Address 0xf6d Write value 0xd41bccc
    li x3, 0xd41bccc
    csrw 0xf6d, x3

    #Address 0xf6d read value
    csrr x14, 0xf6d

    #Address 0xf6d Write value 0x5384095c
    li x3, 0x5384095c
    csrw 0xf6d, x3

    #Address 0xf6d read value
    csrr x14, 0xf6d

    #Mapped address 0x3b7 (pmpaddr7) testing: random write/read operations
    #Address 0x3b7 read value
    csrr x14, 0x3b7

    #Address 0x3b7 Write value 0xb7567857
    li x3, 0xb7567857
    csrw 0x3b7, x3

    #Address 0x3b7 Write value 0x3ba15c58
    li x3, 0x3ba15c58
    csrw 0x3b7, x3

    #Unmapped address 0x5ee testing: random write/read operations
    #Address 0x5ee read value
    csrr x14, 0x5ee

    #Address 0x5ee read value
    csrr x14, 0x5ee

    #Address 0x5ee read value
    csrr x14, 0x5ee

    #Address 0x5ee read value
    csrr x14, 0x5ee

    #Unmapped address 0x233 testing: random write/read operations
    #Address 0x233 read value
    csrr x14, 0x233

    #Unmapped address 0x80b testing: random write/read operations
    #Address 0x80b Write value 0x2d6ac38c
    li x3, 0x2d6ac38c
    csrw 0x80b, x3

    #Address 0x80b read value
    csrr x14, 0x80b

    #Address 0x80b read value
    csrr x14, 0x80b

    #Address 0x80b Write value 0x87765938
    li x3, 0x87765938
    csrw 0x80b, x3

    #Unmapped address 0x9a testing: random write/read operations
    #Address 0x9a Write value 0xb927ab0
    li x3, 0xb927ab0
    csrw 0x9a, x3

    #Address 0x9a Write value 0xa7e83bd8
    li x3, 0xa7e83bd8
    csrw 0x9a, x3

    #Address 0x9a Write value 0x1e75b8bb
    li x3, 0x1e75b8bb
    csrw 0x9a, x3

    #Address 0x9a read value
    csrr x14, 0x9a

    #Unmapped address 0x3ed testing: random write/read operations
    #Address 0x3ed Write value 0x8dede1b0
    li x3, 0x8dede1b0
    csrw 0x3ed, x3

    #Address 0x3ed Write value 0xeef7fac4
    li x3, 0xeef7fac4
    csrw 0x3ed, x3

    #Unmapped address 0xdba testing: random write/read operations
    #Address 0xdba Write value 0xb6a455a9
    li x3, 0xb6a455a9
    csrw 0xdba, x3

    #Address 0xdba read value
    csrr x14, 0xdba

    #Address 0xdba read value
    csrr x14, 0xdba

    #Unmapped address 0x83b testing: random write/read operations
    #Address 0x83b read value
    csrr x14, 0x83b

    #Address 0x83b read value
    csrr x14, 0x83b

    #Address 0x83b read value
    csrr x14, 0x83b

    #Address 0x83b Write value 0x1f3135d9
    li x3, 0x1f3135d9
    csrw 0x83b, x3

    #Unmapped address 0x451 testing: random write/read operations
    #Address 0x451 read value
    csrr x14, 0x451

    #Address 0x451 Write value 0x4735389
    li x3, 0x4735389
    csrw 0x451, x3

    #Address 0x451 Write value 0x8851666
    li x3, 0x8851666
    csrw 0x451, x3

    #Address 0x451 read value
    csrr x14, 0x451

    #Address 0x451 read value
    csrr x14, 0x451

    #Unmapped address 0x55d testing: random write/read operations
    #Address 0x55d read value
    csrr x14, 0x55d

    #Address 0x55d read value
    csrr x14, 0x55d

    #Address 0x55d Write value 0xa9ea7acc
    li x3, 0xa9ea7acc
    csrw 0x55d, x3

    #Address 0x55d read value
    csrr x14, 0x55d

    #Address 0x55d Write value 0xbd6480b2
    li x3, 0xbd6480b2
    csrw 0x55d, x3

    #Unmapped address 0x73a testing: random write/read operations
    #Address 0x73a Write value 0xf413cc1a
    li x3, 0xf413cc1a
    csrw 0x73a, x3

    #Unmapped address 0xc0 testing: random write/read operations
    #Address 0xc0 Write value 0xb8f75f73
    li x3, 0xb8f75f73
    csrw 0xc0, x3

    #Address 0xc0 read value
    csrr x14, 0xc0

    #Address 0xc0 Write value 0x8e6b7f0
    li x3, 0x8e6b7f0
    csrw 0xc0, x3

    #Address 0xc0 Write value 0xb755994f
    li x3, 0xb755994f
    csrw 0xc0, x3

    #Unmapped address 0x89d testing: random write/read operations
    #Address 0x89d Write value 0x1eb1253f
    li x3, 0x1eb1253f
    csrw 0x89d, x3

    #Address 0x89d read value
    csrr x14, 0x89d

    #Address 0x89d read value
    csrr x14, 0x89d

    #Address 0x89d Write value 0xae2f6971
    li x3, 0xae2f6971
    csrw 0x89d, x3

    #Address 0x89d Write value 0x941bcb93
    li x3, 0x941bcb93
    csrw 0x89d, x3

    #Unmapped address 0x1e3 testing: random write/read operations
    #Address 0x1e3 Write value 0x4e33243a
    li x3, 0x4e33243a
    csrw 0x1e3, x3

    #Unmapped address 0x312 testing: random write/read operations
    #Address 0x312 Write value 0xb6a22485
    li x3, 0xb6a22485
    csrw 0x312, x3

    #Address 0x312 read value
    csrr x14, 0x312

    #Address 0x312 read value
    csrr x14, 0x312

    #Unmapped address 0xa40 testing: random write/read operations
    #Address 0xa40 Write value 0x1f39778c
    li x3, 0x1f39778c
    csrw 0xa40, x3

    #Unmapped address 0x253 testing: random write/read operations
    #Address 0x253 read value
    csrr x14, 0x253

    #Address 0x253 Write value 0x47a2fbd3
    li x3, 0x47a2fbd3
    csrw 0x253, x3

    #Address 0x253 Write value 0x76b7f4d4
    li x3, 0x76b7f4d4
    csrw 0x253, x3

    #Address 0x253 read value
    csrr x14, 0x253

    #Unmapped address 0x24f testing: random write/read operations
    #Address 0x24f read value
    csrr x14, 0x24f

    #Address 0x24f Write value 0xe86eda79
    li x3, 0xe86eda79
    csrw 0x24f, x3

    #Address 0x24f Write value 0x132b3672
    li x3, 0x132b3672
    csrw 0x24f, x3

    #Address 0x24f Write value 0xa0722b9a
    li x3, 0xa0722b9a
    csrw 0x24f, x3

    #Address 0x24f Write value 0xe5ca0da4
    li x3, 0xe5ca0da4
    csrw 0x24f, x3

    #Unmapped address 0x4d2 testing: random write/read operations
    #Address 0x4d2 Write value 0xac6e0f76
    li x3, 0xac6e0f76
    csrw 0x4d2, x3

    #Address 0x4d2 Write value 0x46b40dce
    li x3, 0x46b40dce
    csrw 0x4d2, x3

    #Address 0x4d2 Write value 0xa0fd2669
    li x3, 0xa0fd2669
    csrw 0x4d2, x3

    #Address 0x4d2 read value
    csrr x14, 0x4d2

    #Address 0x4d2 Write value 0x4350f4eb
    li x3, 0x4350f4eb
    csrw 0x4d2, x3

    #Unmapped address 0xdeb testing: random write/read operations
    #Address 0xdeb read value
    csrr x14, 0xdeb

    #Address 0xdeb read value
    csrr x14, 0xdeb

    #Address 0xdeb read value
    csrr x14, 0xdeb

    #Address 0xdeb read value
    csrr x14, 0xdeb

    #Address 0xdeb Write value 0x4b01f7eb
    li x3, 0x4b01f7eb
    csrw 0xdeb, x3

    #Unmapped address 0xc6a testing: random write/read operations
    #Address 0xc6a read value
    csrr x14, 0xc6a

    #Address 0xc6a read value
    csrr x14, 0xc6a

    #Unmapped address 0xbc1 testing: random write/read operations
    #Address 0xbc1 Write value 0xa85072b1
    li x3, 0xa85072b1
    csrw 0xbc1, x3

    #Address 0xbc1 Write value 0xa3427ff7
    li x3, 0xa3427ff7
    csrw 0xbc1, x3

    #Address 0xbc1 read value
    csrr x14, 0xbc1

    #Unmapped address 0x58b testing: random write/read operations
    #Address 0x58b Write value 0x9d381ebb
    li x3, 0x9d381ebb
    csrw 0x58b, x3

    #Address 0x58b Write value 0x9dbcb6db
    li x3, 0x9dbcb6db
    csrw 0x58b, x3

    #Address 0x58b Write value 0xac7ac1c0
    li x3, 0xac7ac1c0
    csrw 0x58b, x3

    #Unmapped address 0x2bf testing: random write/read operations
    #Address 0x2bf Write value 0x1f64a43d
    li x3, 0x1f64a43d
    csrw 0x2bf, x3

    #Address 0x2bf read value
    csrr x14, 0x2bf

    #Address 0x2bf Write value 0x28521c39
    li x3, 0x28521c39
    csrw 0x2bf, x3

    #Address 0x2bf read value
    csrr x14, 0x2bf

    #Mapped address 0x343 (mtval) testing: random write/read operations
    #Address 0x343 read value
    csrr x14, 0x343

    #Address 0x343 Write value 0xaa120b0c
    li x3, 0xaa120b0c
    csrw 0x343, x3

    #Address 0x343 Write value 0x26132030
    li x3, 0x26132030
    csrw 0x343, x3

    #Unmapped address 0xc07 testing: random write/read operations
    #Address 0xc07 Write value 0xfe8ebce7
    li x3, 0xfe8ebce7
    csrw 0xc07, x3

    #Unmapped address 0x725 testing: random write/read operations
    #Address 0x725 read value
    csrr x14, 0x725

    #Unmapped address 0xec2 testing: random write/read operations
    #Address 0xec2 Write value 0x74a82576
    li x3, 0x74a82576
    csrw 0xec2, x3

    #Address 0xec2 Write value 0xe32a4f8a
    li x3, 0xe32a4f8a
    csrw 0xec2, x3

    #Unmapped address 0xeb3 testing: random write/read operations
    #Address 0xeb3 Write value 0x695e44cb
    li x3, 0x695e44cb
    csrw 0xeb3, x3

    #Address 0xeb3 read value
    csrr x14, 0xeb3

    #Address 0xeb3 Write value 0x27dd5985
    li x3, 0x27dd5985
    csrw 0xeb3, x3

    #Address 0xeb3 Write value 0xd865e205
    li x3, 0xd865e205
    csrw 0xeb3, x3

    #Address 0xeb3 Write value 0x43ce4cc4
    li x3, 0x43ce4cc4
    csrw 0xeb3, x3

    #Unmapped address 0x6e1 testing: random write/read operations
    #Address 0x6e1 read value
    csrr x14, 0x6e1

    #Address 0x6e1 read value
    csrr x14, 0x6e1

    #Address 0x6e1 read value
    csrr x14, 0x6e1

    #Unmapped address 0x55a testing: random write/read operations
    #Address 0x55a read value
    csrr x14, 0x55a

    #Address 0x55a Write value 0x98992926
    li x3, 0x98992926
    csrw 0x55a, x3

    #Address 0x55a Write value 0x242f989c
    li x3, 0x242f989c
    csrw 0x55a, x3

    #Address 0x55a Write value 0xa1cbcc4
    li x3, 0xa1cbcc4
    csrw 0x55a, x3

    #Address 0x55a read value
    csrr x14, 0x55a

    #Unmapped address 0xf75 testing: random write/read operations
    #Address 0xf75 read value
    csrr x14, 0xf75

    #Address 0xf75 read value
    csrr x14, 0xf75

    #Unmapped address 0x5a5 testing: random write/read operations
    #Address 0x5a5 read value
    csrr x14, 0x5a5

    #Address 0x5a5 read value
    csrr x14, 0x5a5

    #Mapped address 0x3a0 (pmpcfg0) testing: random write/read operations
    #Address 0x3a0 read value
    csrr x14, 0x3a0

    #Address 0x3a0 Write value 0x926b6112
    li x3, 0x926b6112
    csrw 0x3a0, x3

    #Address 0x3a0 Write value 0x9e90522d
    li x3, 0x9e90522d
    csrw 0x3a0, x3

    #Address 0x3a0 read value
    csrr x14, 0x3a0

    #Unmapped address 0x393 testing: random write/read operations
    #Address 0x393 read value
    csrr x14, 0x393

    #Address 0x393 read value
    csrr x14, 0x393

    #Address 0x393 read value
    csrr x14, 0x393

    #Unmapped address 0xf3a testing: random write/read operations
    #Address 0xf3a read value
    csrr x14, 0xf3a

    #Address 0xf3a Write value 0xfdd038ce
    li x3, 0xfdd038ce
    csrw 0xf3a, x3

    #Unmapped address 0x5d2 testing: random write/read operations
    #Address 0x5d2 read value
    csrr x14, 0x5d2

    #Unmapped address 0xf1f testing: random write/read operations
    #Address 0xf1f read value
    csrr x14, 0xf1f

    #Address 0xf1f Write value 0x590fa3e3
    li x3, 0x590fa3e3
    csrw 0xf1f, x3

    #Address 0xf1f read value
    csrr x14, 0xf1f

    #Address 0xf1f read value
    csrr x14, 0xf1f

    #Unmapped address 0x9ec testing: random write/read operations
    #Address 0x9ec Write value 0x1d934f14
    li x3, 0x1d934f14
    csrw 0x9ec, x3

    #Unmapped address 0x491 testing: random write/read operations
    #Address 0x491 read value
    csrr x14, 0x491

    #Unmapped address 0x8f7 testing: random write/read operations
    #Address 0x8f7 Write value 0x91e41323
    li x3, 0x91e41323
    csrw 0x8f7, x3

    #Address 0x8f7 read value
    csrr x14, 0x8f7

    #Address 0x8f7 Write value 0xb6210a35
    li x3, 0xb6210a35
    csrw 0x8f7, x3

    #Address 0x8f7 Write value 0xe87244a1
    li x3, 0xe87244a1
    csrw 0x8f7, x3

    #Address 0x8f7 read value
    csrr x14, 0x8f7

    #Unmapped address 0xf03 testing: random write/read operations
    #Address 0xf03 Write value 0xf5ec0653
    li x3, 0xf5ec0653
    csrw 0xf03, x3

    #Mapped address 0xb9f (mhpmcounterh31) testing: random write/read operations
    #Address 0xb9f Write value 0xcde3d729
    li x3, 0xcde3d729
    csrw 0xb9f, x3

    #Address 0xb9f Write value 0x46d59854
    li x3, 0x46d59854
    csrw 0xb9f, x3

    #Unmapped address 0xee8 testing: random write/read operations
    #Address 0xee8 read value
    csrr x14, 0xee8

    #Address 0xee8 Write value 0x527f88af
    li x3, 0x527f88af
    csrw 0xee8, x3

    #Address 0xee8 Write value 0xa694c886
    li x3, 0xa694c886
    csrw 0xee8, x3

    #Address 0xee8 read value
    csrr x14, 0xee8

    #Address 0xee8 read value
    csrr x14, 0xee8

    #Unmapped address 0xaeb testing: random write/read operations
    #Address 0xaeb read value
    csrr x14, 0xaeb

    #Unmapped address 0x394 testing: random write/read operations
    #Address 0x394 Write value 0xc3c12fe
    li x3, 0xc3c12fe
    csrw 0x394, x3

    #Address 0x394 read value
    csrr x14, 0x394

    #Unmapped address 0xbb0 testing: random write/read operations
    #Address 0xbb0 Write value 0xbc267a73
    li x3, 0xbc267a73
    csrw 0xbb0, x3

    #Address 0xbb0 read value
    csrr x14, 0xbb0

    #Unmapped address 0x39b testing: random write/read operations
    #Address 0x39b read value
    csrr x14, 0x39b

    #Address 0x39b read value
    csrr x14, 0x39b

    #Address 0x39b Write value 0x53d77e25
    li x3, 0x53d77e25
    csrw 0x39b, x3

    #Address 0x39b read value
    csrr x14, 0x39b

    #Unmapped address 0x68 testing: random write/read operations
    #Address 0x68 read value
    csrr x14, 0x68

    #Address 0x68 read value
    csrr x14, 0x68

    #Unmapped address 0x72e testing: random write/read operations
    #Address 0x72e read value
    csrr x14, 0x72e

    #Mapped address 0xb96 (mhpmcounterh22) testing: random write/read operations
    #Address 0xb96 Write value 0xcf96a3e4
    li x3, 0xcf96a3e4
    csrw 0xb96, x3

    #Unmapped address 0xaea testing: random write/read operations
    #Address 0xaea Write value 0x3a736cb6
    li x3, 0x3a736cb6
    csrw 0xaea, x3

    #Address 0xaea read value
    csrr x14, 0xaea

    #Unmapped address 0x18f testing: random write/read operations
    #Address 0x18f Write value 0xd696eadc
    li x3, 0xd696eadc
    csrw 0x18f, x3

    #Address 0x18f Write value 0xc50c692f
    li x3, 0xc50c692f
    csrw 0x18f, x3

    #Address 0x18f read value
    csrr x14, 0x18f

    #Unmapped address 0x81b testing: random write/read operations
    #Address 0x81b Write value 0x44f460e4
    li x3, 0x44f460e4
    csrw 0x81b, x3

    #Unmapped address 0x199 testing: random write/read operations
    #Address 0x199 read value
    csrr x14, 0x199

    #Address 0x199 Write value 0xeb894cd1
    li x3, 0xeb894cd1
    csrw 0x199, x3

    #Address 0x199 read value
    csrr x14, 0x199

    #Address 0x199 Write value 0x90b3d825
    li x3, 0x90b3d825
    csrw 0x199, x3

    #Address 0x199 read value
    csrr x14, 0x199

    #Unmapped address 0xa testing: random write/read operations
    #Address 0xa Write value 0x31f58c86
    li x3, 0x31f58c86
    csrw 0xa, x3

    #Address 0xa read value
    csrr x14, 0xa

    #Address 0xa read value
    csrr x14, 0xa

    #Address 0xa Write value 0xeb8168bb
    li x3, 0xeb8168bb
    csrw 0xa, x3

    #Address 0xa read value
    csrr x14, 0xa

    #Unmapped address 0xe61 testing: random write/read operations
    #Address 0xe61 read value
    csrr x14, 0xe61

    #Address 0xe61 read value
    csrr x14, 0xe61

    #Address 0xe61 Write value 0x61d95903
    li x3, 0x61d95903
    csrw 0xe61, x3

    #Address 0xe61 read value
    csrr x14, 0xe61

    #Address 0xe61 Write value 0x71ab9179
    li x3, 0x71ab9179
    csrw 0xe61, x3

    #Unmapped address 0x991 testing: random write/read operations
    #Address 0x991 Write value 0xdff1f2af
    li x3, 0xdff1f2af
    csrw 0x991, x3

    #Unmapped address 0x2f6 testing: random write/read operations
    #Address 0x2f6 read value
    csrr x14, 0x2f6

    #Address 0x2f6 read value
    csrr x14, 0x2f6

    #Address 0x2f6 read value
    csrr x14, 0x2f6

    #Address 0x2f6 Write value 0xcf94625
    li x3, 0xcf94625
    csrw 0x2f6, x3

    #Unmapped address 0x2d3 testing: random write/read operations
    #Address 0x2d3 read value
    csrr x14, 0x2d3

    #Address 0x2d3 Write value 0x770a084b
    li x3, 0x770a084b
    csrw 0x2d3, x3

    #Address 0x2d3 Write value 0xbfff97f4
    li x3, 0xbfff97f4
    csrw 0x2d3, x3

    #Address 0x2d3 Write value 0x4f9aecf6
    li x3, 0x4f9aecf6
    csrw 0x2d3, x3

    #Address 0x2d3 read value
    csrr x14, 0x2d3

    #Unmapped address 0x2f1 testing: random write/read operations
    #Address 0x2f1 Write value 0x4d35c3db
    li x3, 0x4d35c3db
    csrw 0x2f1, x3

    #Address 0x2f1 read value
    csrr x14, 0x2f1

    #Address 0x2f1 Write value 0x90d1a5a5
    li x3, 0x90d1a5a5
    csrw 0x2f1, x3

    #Unmapped address 0x115 testing: random write/read operations
    #Address 0x115 read value
    csrr x14, 0x115

    #Address 0x115 read value
    csrr x14, 0x115

    #Address 0x115 read value
    csrr x14, 0x115

    #Address 0x115 read value
    csrr x14, 0x115

    #Address 0x115 read value
    csrr x14, 0x115

    #Unmapped address 0xa75 testing: random write/read operations
    #Address 0xa75 read value
    csrr x14, 0xa75

    #Address 0xa75 read value
    csrr x14, 0xa75

    #Unmapped address 0x6d6 testing: random write/read operations
    #Address 0x6d6 read value
    csrr x14, 0x6d6

    #Address 0x6d6 Write value 0xbfe40a3
    li x3, 0xbfe40a3
    csrw 0x6d6, x3

    #Address 0x6d6 Write value 0xc90e4df7
    li x3, 0xc90e4df7
    csrw 0x6d6, x3

    #Address 0x6d6 read value
    csrr x14, 0x6d6

    #Unmapped address 0x824 testing: random write/read operations
    #Address 0x824 Write value 0x7bf58fb8
    li x3, 0x7bf58fb8
    csrw 0x824, x3

    #Address 0x824 read value
    csrr x14, 0x824

    #Address 0x824 read value
    csrr x14, 0x824

    #Unmapped address 0x714 testing: random write/read operations
    #Address 0x714 read value
    csrr x14, 0x714

    #Address 0x714 read value
    csrr x14, 0x714

    #Address 0x714 Write value 0x5c84e009
    li x3, 0x5c84e009
    csrw 0x714, x3

    #Unmapped address 0x519 testing: random write/read operations
    #Address 0x519 Write value 0x7fcfd67b
    li x3, 0x7fcfd67b
    csrw 0x519, x3

    #Address 0x519 Write value 0x845eaa69
    li x3, 0x845eaa69
    csrw 0x519, x3

    #Address 0x519 Write value 0x2825ff1e
    li x3, 0x2825ff1e
    csrw 0x519, x3

    #Unmapped address 0xda7 testing: random write/read operations
    #Address 0xda7 Write value 0x3d4b6b8
    li x3, 0x3d4b6b8
    csrw 0xda7, x3

    #Address 0xda7 Write value 0x50a186eb
    li x3, 0x50a186eb
    csrw 0xda7, x3

    #Address 0xda7 Write value 0xbea8a40c
    li x3, 0xbea8a40c
    csrw 0xda7, x3

    #Address 0xda7 Write value 0x968e61f6
    li x3, 0x968e61f6
    csrw 0xda7, x3

    #Address 0xda7 Write value 0x6e86d315
    li x3, 0x6e86d315
    csrw 0xda7, x3

    #Unmapped address 0xc1d testing: random write/read operations
    #Address 0xc1d read value
    csrr x14, 0xc1d

    #Unmapped address 0xa1d testing: random write/read operations
    #Address 0xa1d read value
    csrr x14, 0xa1d

    #Address 0xa1d read value
    csrr x14, 0xa1d

    #Unmapped address 0x4cf testing: random write/read operations
    #Address 0x4cf Write value 0xc4cb8fb3
    li x3, 0xc4cb8fb3
    csrw 0x4cf, x3

    #Address 0x4cf Write value 0x1f2a221d
    li x3, 0x1f2a221d
    csrw 0x4cf, x3

    #Address 0x4cf read value
    csrr x14, 0x4cf

    #Address 0x4cf read value
    csrr x14, 0x4cf

    #Address 0x4cf Write value 0xeb588ce7
    li x3, 0xeb588ce7
    csrw 0x4cf, x3

    #Unmapped address 0x6ab testing: random write/read operations
    #Address 0x6ab read value
    csrr x14, 0x6ab

    #Address 0x6ab read value
    csrr x14, 0x6ab

    #Address 0x6ab Write value 0xf6ea68d7
    li x3, 0xf6ea68d7
    csrw 0x6ab, x3

    #Address 0x6ab read value
    csrr x14, 0x6ab

    #Address 0x6ab Write value 0x1ea35d31
    li x3, 0x1ea35d31
    csrw 0x6ab, x3

    #Unmapped address 0x398 testing: random write/read operations
    #Address 0x398 Write value 0xaaf5e7e9
    li x3, 0xaaf5e7e9
    csrw 0x398, x3

    #Address 0x398 Write value 0x441ed35b
    li x3, 0x441ed35b
    csrw 0x398, x3

    #Address 0x398 read value
    csrr x14, 0x398

    #Address 0x398 read value
    csrr x14, 0x398

    #Unmapped address 0xda2 testing: random write/read operations
    #Address 0xda2 Write value 0x8a850330
    li x3, 0x8a850330
    csrw 0xda2, x3

    #Address 0xda2 read value
    csrr x14, 0xda2

    #Unmapped address 0x30 testing: random write/read operations
    #Address 0x30 Write value 0x48b1dd5a
    li x3, 0x48b1dd5a
    csrw 0x30, x3

    #Address 0x30 read value
    csrr x14, 0x30

    #Unmapped address 0x3cd testing: random write/read operations
    #Address 0x3cd Write value 0xf6ceb585
    li x3, 0xf6ceb585
    csrw 0x3cd, x3

    #Address 0x3cd Write value 0x85f32d28
    li x3, 0x85f32d28
    csrw 0x3cd, x3

    #Unmapped address 0x175 testing: random write/read operations
    #Address 0x175 read value
    csrr x14, 0x175

    #Address 0x175 read value
    csrr x14, 0x175

    #Address 0x175 read value
    csrr x14, 0x175

    #Address 0x175 read value
    csrr x14, 0x175

    #Unmapped address 0x3f0 testing: random write/read operations
    #Address 0x3f0 read value
    csrr x14, 0x3f0

    #Address 0x3f0 read value
    csrr x14, 0x3f0

    #Address 0x3f0 read value
    csrr x14, 0x3f0

    #Address 0x3f0 Write value 0xeed38102
    li x3, 0xeed38102
    csrw 0x3f0, x3

    #Address 0x3f0 read value
    csrr x14, 0x3f0

    #Unmapped address 0x75b testing: random write/read operations
    #Address 0x75b read value
    csrr x14, 0x75b

    #Address 0x75b read value
    csrr x14, 0x75b

    #Unmapped address 0xf2f testing: random write/read operations
    #Address 0xf2f Write value 0xffd3aae7
    li x3, 0xffd3aae7
    csrw 0xf2f, x3

    #Unmapped address 0x39d testing: random write/read operations
    #Address 0x39d Write value 0xe15a1568
    li x3, 0xe15a1568
    csrw 0x39d, x3

    #Address 0x39d Write value 0xce15e041
    li x3, 0xce15e041
    csrw 0x39d, x3

    #Address 0x39d Write value 0xc82d376
    li x3, 0xc82d376
    csrw 0x39d, x3

    #Address 0x39d Write value 0x4b407f2e
    li x3, 0x4b407f2e
    csrw 0x39d, x3

    #Address 0x39d read value
    csrr x14, 0x39d

    #Unmapped address 0x87e testing: random write/read operations
    #Address 0x87e Write value 0xacf5762e
    li x3, 0xacf5762e
    csrw 0x87e, x3

    #Address 0x87e read value
    csrr x14, 0x87e

    #Address 0x87e read value
    csrr x14, 0x87e

    #Address 0x87e read value
    csrr x14, 0x87e

    #Unmapped address 0x5c8 testing: random write/read operations
    #Address 0x5c8 Write value 0xf94797ca
    li x3, 0xf94797ca
    csrw 0x5c8, x3

    #Unmapped address 0x858 testing: random write/read operations
    #Address 0x858 read value
    csrr x14, 0x858

    #Address 0x858 Write value 0x5b963f76
    li x3, 0x5b963f76
    csrw 0x858, x3

    #Address 0x858 read value
    csrr x14, 0x858

    #Unmapped address 0x601 testing: random write/read operations
    #Address 0x601 read value
    csrr x14, 0x601

    #Address 0x601 Write value 0x99872f46
    li x3, 0x99872f46
    csrw 0x601, x3

    #Address 0x601 Write value 0xdcbb917c
    li x3, 0xdcbb917c
    csrw 0x601, x3

    #Address 0x601 Write value 0xcafd38e3
    li x3, 0xcafd38e3
    csrw 0x601, x3

    #Unmapped address 0xa93 testing: random write/read operations
    #Address 0xa93 Write value 0x8ae3522a
    li x3, 0x8ae3522a
    csrw 0xa93, x3

    #Address 0xa93 Write value 0x64974023
    li x3, 0x64974023
    csrw 0xa93, x3

    #Address 0xa93 Write value 0x79a8808c
    li x3, 0x79a8808c
    csrw 0xa93, x3

    #Mapped address 0xf14 (mhartid) testing: random write/read operations
    #Address 0xf14 Write value 0x6c10199d
    li x3, 0x6c10199d
    csrw 0xf14, x3

    #Address 0xf14 Write value 0x7c7866f9
    li x3, 0x7c7866f9
    csrw 0xf14, x3

    #Address 0xf14 read value
    csrr x14, 0xf14

    #Unmapped address 0x6b5 testing: random write/read operations
    #Address 0x6b5 Write value 0xe6761d73
    li x3, 0xe6761d73
    csrw 0x6b5, x3

    #Address 0x6b5 read value
    csrr x14, 0x6b5

    #Address 0x6b5 Write value 0xa4c85d3f
    li x3, 0xa4c85d3f
    csrw 0x6b5, x3

    #Address 0x6b5 read value
    csrr x14, 0x6b5

    #Mapped address 0x3bb (pmpaddr11) testing: random write/read operations
    #Address 0x3bb read value
    csrr x14, 0x3bb

    #Unmapped address 0x96a testing: random write/read operations
    #Address 0x96a Write value 0x30603df3
    li x3, 0x30603df3
    csrw 0x96a, x3

    #Address 0x96a Write value 0x6f634553
    li x3, 0x6f634553
    csrw 0x96a, x3

    #Address 0x96a read value
    csrr x14, 0x96a

    #Unmapped address 0x120 testing: random write/read operations
    #Address 0x120 read value
    csrr x14, 0x120

    #Address 0x120 Write value 0x40acdd6
    li x3, 0x40acdd6
    csrw 0x120, x3

    #Address 0x120 Write value 0x4f4cdf80
    li x3, 0x4f4cdf80
    csrw 0x120, x3

    #Address 0x120 Write value 0x18d31562
    li x3, 0x18d31562
    csrw 0x120, x3

    #Unmapped address 0x4c0 testing: random write/read operations
    #Address 0x4c0 Write value 0x651cbf2d
    li x3, 0x651cbf2d
    csrw 0x4c0, x3

    #Address 0x4c0 read value
    csrr x14, 0x4c0

    #Address 0x4c0 Write value 0xd282f8ab
    li x3, 0xd282f8ab
    csrw 0x4c0, x3

    #Unmapped address 0x4ad testing: random write/read operations
    #Address 0x4ad Write value 0x378f6d5f
    li x3, 0x378f6d5f
    csrw 0x4ad, x3

    #Address 0x4ad read value
    csrr x14, 0x4ad

    #Address 0x4ad Write value 0x692aa6e8
    li x3, 0x692aa6e8
    csrw 0x4ad, x3

    #Unmapped address 0x87c testing: random write/read operations
    #Address 0x87c Write value 0xae71f635
    li x3, 0xae71f635
    csrw 0x87c, x3

    #Address 0x87c Write value 0xe782c5c1
    li x3, 0xe782c5c1
    csrw 0x87c, x3

    #Address 0x87c read value
    csrr x14, 0x87c

    #Unmapped address 0xcde testing: random write/read operations
    #Address 0xcde read value
    csrr x14, 0xcde

    #Mapped address 0xb0e (mhpmcounter14) testing: random write/read operations
    #Address 0xb0e Write value 0xc31702ed
    li x3, 0xc31702ed
    csrw 0xb0e, x3

    #Address 0xb0e Write value 0x8794bea
    li x3, 0x8794bea
    csrw 0xb0e, x3

    #Unmapped address 0x511 testing: random write/read operations
    #Address 0x511 read value
    csrr x14, 0x511

    #Address 0x511 Write value 0xca838b0c
    li x3, 0xca838b0c
    csrw 0x511, x3

    #Unmapped address 0xc61 testing: random write/read operations
    #Address 0xc61 read value
    csrr x14, 0xc61

    #Address 0xc61 Write value 0x6c0d4404
    li x3, 0x6c0d4404
    csrw 0xc61, x3

    #Address 0xc61 read value
    csrr x14, 0xc61

    #Unmapped address 0xc62 testing: random write/read operations
    #Address 0xc62 Write value 0xdca605f9
    li x3, 0xdca605f9
    csrw 0xc62, x3

    #Address 0xc62 read value
    csrr x14, 0xc62

    #Address 0xc62 read value
    csrr x14, 0xc62

    #Unmapped address 0x789 testing: random write/read operations
    #Address 0x789 read value
    csrr x14, 0x789

    #Address 0x789 read value
    csrr x14, 0x789

    #Address 0x789 read value
    csrr x14, 0x789

    #Address 0x789 Write value 0x6d4f8b27
    li x3, 0x6d4f8b27
    csrw 0x789, x3

    #Unmapped address 0xa1f testing: random write/read operations
    #Address 0xa1f Write value 0xa2ac3385
    li x3, 0xa2ac3385
    csrw 0xa1f, x3

    #Unmapped address 0x35d testing: random write/read operations
    #Address 0x35d read value
    csrr x14, 0x35d

    #Address 0x35d read value
    csrr x14, 0x35d

    #Unmapped address 0xcbd testing: random write/read operations
    #Address 0xcbd read value
    csrr x14, 0xcbd

    #Address 0xcbd Write value 0xbd7675e0
    li x3, 0xbd7675e0
    csrw 0xcbd, x3

    #Unmapped address 0xcb1 testing: random write/read operations
    #Address 0xcb1 read value
    csrr x14, 0xcb1

    #Address 0xcb1 read value
    csrr x14, 0xcb1

    #Unmapped address 0x755 testing: random write/read operations
    #Address 0x755 Write value 0xaf913b25
    li x3, 0xaf913b25
    csrw 0x755, x3

    #Address 0x755 read value
    csrr x14, 0x755

    #Address 0x755 Write value 0xfc33f740
    li x3, 0xfc33f740
    csrw 0x755, x3

    #Address 0x755 Write value 0xde1d4156
    li x3, 0xde1d4156
    csrw 0x755, x3

    #Unmapped address 0x1e0 testing: random write/read operations
    #Address 0x1e0 Write value 0x7900f7f0
    li x3, 0x7900f7f0
    csrw 0x1e0, x3

    #Address 0x1e0 read value
    csrr x14, 0x1e0

    #Unmapped address 0x27f testing: random write/read operations
    #Address 0x27f read value
    csrr x14, 0x27f

    #Address 0x27f Write value 0xa1f5b5be
    li x3, 0xa1f5b5be
    csrw 0x27f, x3

    #Address 0x27f Write value 0xdcc8be28
    li x3, 0xdcc8be28
    csrw 0x27f, x3

    #Unmapped address 0xa2e testing: random write/read operations
    #Address 0xa2e Write value 0x75058f53
    li x3, 0x75058f53
    csrw 0xa2e, x3

    #Address 0xa2e read value
    csrr x14, 0xa2e

    #Address 0xa2e read value
    csrr x14, 0xa2e

    #Address 0xa2e Write value 0x9754f6b3
    li x3, 0x9754f6b3
    csrw 0xa2e, x3

    #Address 0xa2e Write value 0x7a3de1f5
    li x3, 0x7a3de1f5
    csrw 0xa2e, x3

    #Unmapped address 0xfdb testing: random write/read operations
    #Address 0xfdb Write value 0xd66309f6
    li x3, 0xd66309f6
    csrw 0xfdb, x3

    #Address 0xfdb Write value 0xf9618b9
    li x3, 0xf9618b9
    csrw 0xfdb, x3

    #Unmapped address 0xca1 testing: random write/read operations
    #Address 0xca1 read value
    csrr x14, 0xca1

    #Address 0xca1 Write value 0x75b0d7a4
    li x3, 0x75b0d7a4
    csrw 0xca1, x3

    #Address 0xca1 Write value 0x6192e761
    li x3, 0x6192e761
    csrw 0xca1, x3

    #Address 0xca1 Write value 0x440c0690
    li x3, 0x440c0690
    csrw 0xca1, x3

    #Unmapped address 0x700 testing: random write/read operations
    #Address 0x700 Write value 0x171cd779
    li x3, 0x171cd779
    csrw 0x700, x3

    #Address 0x700 Write value 0x1bb00f03
    li x3, 0x1bb00f03
    csrw 0x700, x3

    #Unmapped address 0xdce testing: random write/read operations
    #Address 0xdce Write value 0xb1a01cad
    li x3, 0xb1a01cad
    csrw 0xdce, x3

    #Address 0xdce Write value 0x5262bbe
    li x3, 0x5262bbe
    csrw 0xdce, x3

    #Address 0xdce Write value 0xb2abd260
    li x3, 0xb2abd260
    csrw 0xdce, x3

    #Unmapped address 0xf6c testing: random write/read operations
    #Address 0xf6c Write value 0xde3b87a6
    li x3, 0xde3b87a6
    csrw 0xf6c, x3

    #Address 0xf6c Write value 0xd4c59031
    li x3, 0xd4c59031
    csrw 0xf6c, x3

    #Unmapped address 0xf71 testing: random write/read operations
    #Address 0xf71 read value
    csrr x14, 0xf71

    #Address 0xf71 Write value 0x18807437
    li x3, 0x18807437
    csrw 0xf71, x3

    #Unmapped address 0x27b testing: random write/read operations
    #Address 0x27b read value
    csrr x14, 0x27b

    #Address 0x27b Write value 0xab7383c9
    li x3, 0xab7383c9
    csrw 0x27b, x3

    #Address 0x27b read value
    csrr x14, 0x27b

    #Address 0x27b read value
    csrr x14, 0x27b

    #Address 0x27b read value
    csrr x14, 0x27b

    #Unmapped address 0x1f6 testing: random write/read operations
    #Address 0x1f6 read value
    csrr x14, 0x1f6

    #Unmapped address 0xa31 testing: random write/read operations
    #Address 0xa31 read value
    csrr x14, 0xa31

    #Address 0xa31 Write value 0xf4f7ab02
    li x3, 0xf4f7ab02
    csrw 0xa31, x3

    #Address 0xa31 Write value 0x2624f116
    li x3, 0x2624f116
    csrw 0xa31, x3

    #Address 0xa31 Write value 0xeef42756
    li x3, 0xeef42756
    csrw 0xa31, x3

    #Unmapped address 0xad6 testing: random write/read operations
    #Address 0xad6 read value
    csrr x14, 0xad6

    #Address 0xad6 read value
    csrr x14, 0xad6

    #Unmapped address 0x90a testing: random write/read operations
    #Address 0x90a read value
    csrr x14, 0x90a

    #Address 0x90a Write value 0x8df34959
    li x3, 0x8df34959
    csrw 0x90a, x3

    #Address 0x90a read value
    csrr x14, 0x90a

    #Address 0x90a Write value 0x7fb5b964
    li x3, 0x7fb5b964
    csrw 0x90a, x3

    #Unmapped address 0x3fe testing: random write/read operations
    #Address 0x3fe Write value 0xd0e74db4
    li x3, 0xd0e74db4
    csrw 0x3fe, x3

    #Unmapped address 0x469 testing: random write/read operations
    #Address 0x469 read value
    csrr x14, 0x469

    #Address 0x469 read value
    csrr x14, 0x469

    #Address 0x469 read value
    csrr x14, 0x469

    #Unmapped address 0x83d testing: random write/read operations
    #Address 0x83d read value
    csrr x14, 0x83d

    #Unmapped address 0xc28 testing: random write/read operations
    #Address 0xc28 Write value 0xe19f7ce8
    li x3, 0xe19f7ce8
    csrw 0xc28, x3

    #Address 0xc28 Write value 0xaf65dd9b
    li x3, 0xaf65dd9b
    csrw 0xc28, x3

    #Address 0xc28 read value
    csrr x14, 0xc28

    #Address 0xc28 read value
    csrr x14, 0xc28

    #Unmapped address 0xfc8 testing: random write/read operations
    #Address 0xfc8 read value
    csrr x14, 0xfc8

    #Address 0xfc8 read value
    csrr x14, 0xfc8

    #Address 0xfc8 read value
    csrr x14, 0xfc8

    #Unmapped address 0x8a7 testing: random write/read operations
    #Address 0x8a7 Write value 0xcd090e36
    li x3, 0xcd090e36
    csrw 0x8a7, x3

    #Address 0x8a7 Write value 0x86c92d4c
    li x3, 0x86c92d4c
    csrw 0x8a7, x3

    #Address 0x8a7 read value
    csrr x14, 0x8a7

    #Unmapped address 0x454 testing: random write/read operations
    #Address 0x454 Write value 0x50f2ab10
    li x3, 0x50f2ab10
    csrw 0x454, x3

    #Address 0x454 read value
    csrr x14, 0x454

    #Address 0x454 Write value 0xc35856f0
    li x3, 0xc35856f0
    csrw 0x454, x3

    #Address 0x454 read value
    csrr x14, 0x454

    #Unmapped address 0xbae testing: random write/read operations
    #Address 0xbae Write value 0xe23c7af9
    li x3, 0xe23c7af9
    csrw 0xbae, x3

    #Address 0xbae read value
    csrr x14, 0xbae

    #Unmapped address 0x33 testing: random write/read operations
    #Address 0x33 Write value 0xb55bf19c
    li x3, 0xb55bf19c
    csrw 0x33, x3

    #Address 0x33 read value
    csrr x14, 0x33

    #Address 0x33 Write value 0x1c372bab
    li x3, 0x1c372bab
    csrw 0x33, x3

    #Unmapped address 0x3a9 testing: random write/read operations
    #Address 0x3a9 read value
    csrr x14, 0x3a9

    #Unmapped address 0x530 testing: random write/read operations
    #Address 0x530 read value
    csrr x14, 0x530

    #Unmapped address 0xa8e testing: random write/read operations
    #Address 0xa8e read value
    csrr x14, 0xa8e

    #Unmapped address 0xef4 testing: random write/read operations
    #Address 0xef4 Write value 0xa0a829cf
    li x3, 0xa0a829cf
    csrw 0xef4, x3

    #Address 0xef4 Write value 0xb4618e3
    li x3, 0xb4618e3
    csrw 0xef4, x3

    #Address 0xef4 Write value 0x9361111e
    li x3, 0x9361111e
    csrw 0xef4, x3

    #Unmapped address 0x764 testing: random write/read operations
    #Address 0x764 Write value 0xc7b4e25e
    li x3, 0xc7b4e25e
    csrw 0x764, x3

    #Address 0x764 Write value 0x3c4537c3
    li x3, 0x3c4537c3
    csrw 0x764, x3

    #Address 0x764 Write value 0xad63dcab
    li x3, 0xad63dcab
    csrw 0x764, x3

    #Address 0x764 read value
    csrr x14, 0x764

    #Unmapped address 0x444 testing: random write/read operations
    #Address 0x444 Write value 0x724ef073
    li x3, 0x724ef073
    csrw 0x444, x3

    #Address 0x444 read value
    csrr x14, 0x444

    #Address 0x444 Write value 0x64f827f0
    li x3, 0x64f827f0
    csrw 0x444, x3

    #Address 0x444 Write value 0xafdb034d
    li x3, 0xafdb034d
    csrw 0x444, x3

    #Address 0x444 Write value 0x845fbe1d
    li x3, 0x845fbe1d
    csrw 0x444, x3

    #Unmapped address 0x2ab testing: random write/read operations
    #Address 0x2ab Write value 0xad48467e
    li x3, 0xad48467e
    csrw 0x2ab, x3

    #Address 0x2ab read value
    csrr x14, 0x2ab

    #Address 0x2ab read value
    csrr x14, 0x2ab

    #Unmapped address 0x2ef testing: random write/read operations
    #Address 0x2ef Write value 0x84a17f0e
    li x3, 0x84a17f0e
    csrw 0x2ef, x3

    #Unmapped address 0x424 testing: random write/read operations
    #Address 0x424 read value
    csrr x14, 0x424

    #Unmapped address 0xb7c testing: random write/read operations
    #Address 0xb7c read value
    csrr x14, 0xb7c

    #Address 0xb7c Write value 0x2d9b2423
    li x3, 0x2d9b2423
    csrw 0xb7c, x3

    #Address 0xb7c Write value 0x8ff3eab
    li x3, 0x8ff3eab
    csrw 0xb7c, x3

    #Unmapped address 0x901 testing: random write/read operations
    #Address 0x901 Write value 0x521d66b2
    li x3, 0x521d66b2
    csrw 0x901, x3

    #Unmapped address 0x74d testing: random write/read operations
    #Address 0x74d Write value 0xe02a2d81
    li x3, 0xe02a2d81
    csrw 0x74d, x3

    #Address 0x74d read value
    csrr x14, 0x74d

    #Address 0x74d read value
    csrr x14, 0x74d

    #Address 0x74d read value
    csrr x14, 0x74d

    #Unmapped address 0x55 testing: random write/read operations
    #Address 0x55 read value
    csrr x14, 0x55

    #Address 0x55 Write value 0xe9c59265
    li x3, 0xe9c59265
    csrw 0x55, x3

    #Address 0x55 Write value 0xac40c78
    li x3, 0xac40c78
    csrw 0x55, x3

    #Address 0x55 Write value 0x6a61d2da
    li x3, 0x6a61d2da
    csrw 0x55, x3

    #Address 0x55 Write value 0xa30322a3
    li x3, 0xa30322a3
    csrw 0x55, x3

    #Unmapped address 0x7a testing: random write/read operations
    #Address 0x7a Write value 0x2b9ca625
    li x3, 0x2b9ca625
    csrw 0x7a, x3

    #Unmapped address 0x1b2 testing: random write/read operations
    #Address 0x1b2 Write value 0xb69da957
    li x3, 0xb69da957
    csrw 0x1b2, x3

    #Address 0x1b2 Write value 0x86423fd7
    li x3, 0x86423fd7
    csrw 0x1b2, x3

    #Address 0x1b2 read value
    csrr x14, 0x1b2

    #Address 0x1b2 Write value 0xe83d3561
    li x3, 0xe83d3561
    csrw 0x1b2, x3

    #Address 0x1b2 Write value 0xe706569a
    li x3, 0xe706569a
    csrw 0x1b2, x3

    #Unmapped address 0x64 testing: random write/read operations
    #Address 0x64 Write value 0x9e2858b1
    li x3, 0x9e2858b1
    csrw 0x64, x3

    #Address 0x64 Write value 0x4d05006a
    li x3, 0x4d05006a
    csrw 0x64, x3

    #Address 0x64 read value
    csrr x14, 0x64

    #Address 0x64 Write value 0xa566cb90
    li x3, 0xa566cb90
    csrw 0x64, x3

    #Address 0x64 read value
    csrr x14, 0x64

    #Unmapped address 0x9ed testing: random write/read operations
    #Address 0x9ed read value
    csrr x14, 0x9ed

    #Unmapped address 0x483 testing: random write/read operations
    #Address 0x483 read value
    csrr x14, 0x483

    #Address 0x483 read value
    csrr x14, 0x483

    #Address 0x483 Write value 0x4418b8a3
    li x3, 0x4418b8a3
    csrw 0x483, x3

    #Unmapped address 0xf65 testing: random write/read operations
    #Address 0xf65 read value
    csrr x14, 0xf65

    #Address 0xf65 Write value 0x133c806d
    li x3, 0x133c806d
    csrw 0xf65, x3

    #Unmapped address 0x6c9 testing: random write/read operations
    #Address 0x6c9 Write value 0x9ddeb45a
    li x3, 0x9ddeb45a
    csrw 0x6c9, x3

    #Address 0x6c9 read value
    csrr x14, 0x6c9

    #Address 0x6c9 Write value 0x9eb30b84
    li x3, 0x9eb30b84
    csrw 0x6c9, x3

    #Address 0x6c9 read value
    csrr x14, 0x6c9

    #Unmapped address 0xa00 testing: random write/read operations
    #Address 0xa00 read value
    csrr x14, 0xa00

    #Address 0xa00 read value
    csrr x14, 0xa00

    #Address 0xa00 Write value 0x649579e6
    li x3, 0x649579e6
    csrw 0xa00, x3

    #Address 0xa00 read value
    csrr x14, 0xa00

    #Unmapped address 0x48f testing: random write/read operations
    #Address 0x48f read value
    csrr x14, 0x48f

    #Address 0x48f read value
    csrr x14, 0x48f

    #Address 0x48f Write value 0xf290ae79
    li x3, 0xf290ae79
    csrw 0x48f, x3

    #Address 0x48f Write value 0xc4ce4628
    li x3, 0xc4ce4628
    csrw 0x48f, x3

    #Unmapped address 0xb53 testing: random write/read operations
    #Address 0xb53 Write value 0x869d5ad
    li x3, 0x869d5ad
    csrw 0xb53, x3

    #Address 0xb53 read value
    csrr x14, 0xb53

    #Address 0xb53 Write value 0x623f5450
    li x3, 0x623f5450
    csrw 0xb53, x3

    #Mapped address 0x331 (mhpmevent17) testing: random write/read operations
    #Address 0x331 Write value 0xa6460c35
    li x3, 0xa6460c35
    csrw 0x331, x3

    #Address 0x331 read value
    csrr x14, 0x331

    #Unmapped address 0x612 testing: random write/read operations
    #Address 0x612 read value
    csrr x14, 0x612

    #Unmapped address 0xbba testing: random write/read operations
    #Address 0xbba Write value 0xff56a0fb
    li x3, 0xff56a0fb
    csrw 0xbba, x3

    #Address 0xbba Write value 0x4bebce8c
    li x3, 0x4bebce8c
    csrw 0xbba, x3

    #Address 0xbba read value
    csrr x14, 0xbba

    #Address 0xbba read value
    csrr x14, 0xbba

    #Unmapped address 0xf73 testing: random write/read operations
    #Address 0xf73 Write value 0x6880a8c4
    li x3, 0x6880a8c4
    csrw 0xf73, x3

    #Address 0xf73 read value
    csrr x14, 0xf73

    #Address 0xf73 Write value 0x1932d93f
    li x3, 0x1932d93f
    csrw 0xf73, x3

    #Address 0xf73 read value
    csrr x14, 0xf73

    #Unmapped address 0xd3e testing: random write/read operations
    #Address 0xd3e Write value 0x21860488
    li x3, 0x21860488
    csrw 0xd3e, x3

    #Address 0xd3e read value
    csrr x14, 0xd3e

    #Address 0xd3e Write value 0x2f84e1cb
    li x3, 0x2f84e1cb
    csrw 0xd3e, x3

    #Unmapped address 0x232 testing: random write/read operations
    #Address 0x232 read value
    csrr x14, 0x232

    #Address 0x232 read value
    csrr x14, 0x232

    #Unmapped address 0xdb8 testing: random write/read operations
    #Address 0xdb8 read value
    csrr x14, 0xdb8

    #Unmapped address 0x487 testing: random write/read operations
    #Address 0x487 read value
    csrr x14, 0x487

    #Address 0x487 Write value 0xc20e011f
    li x3, 0xc20e011f
    csrw 0x487, x3

    #Unmapped address 0x1cb testing: random write/read operations
    #Address 0x1cb read value
    csrr x14, 0x1cb

    #Address 0x1cb Write value 0x51fdb67c
    li x3, 0x51fdb67c
    csrw 0x1cb, x3

    #Unmapped address 0xf01 testing: random write/read operations
    #Address 0xf01 Write value 0xd20658f9
    li x3, 0xd20658f9
    csrw 0xf01, x3

    #Address 0xf01 Write value 0x1dd328b2
    li x3, 0x1dd328b2
    csrw 0xf01, x3

    #Address 0xf01 Write value 0xec7f66a
    li x3, 0xec7f66a
    csrw 0xf01, x3

    #Unmapped address 0x24a testing: random write/read operations
    #Address 0x24a Write value 0x271da413
    li x3, 0x271da413
    csrw 0x24a, x3

    #Address 0x24a Write value 0xce3b01d
    li x3, 0xce3b01d
    csrw 0x24a, x3

    #Address 0x24a Write value 0xe6375d2
    li x3, 0xe6375d2
    csrw 0x24a, x3

    #Address 0x24a read value
    csrr x14, 0x24a

    #Unmapped address 0x84d testing: random write/read operations
    #Address 0x84d Write value 0xa6efc021
    li x3, 0xa6efc021
    csrw 0x84d, x3

    #Address 0x84d read value
    csrr x14, 0x84d

    #Unmapped address 0x91f testing: random write/read operations
    #Address 0x91f Write value 0xea24505b
    li x3, 0xea24505b
    csrw 0x91f, x3

    #Address 0x91f Write value 0x54ce98a4
    li x3, 0x54ce98a4
    csrw 0x91f, x3

    #Address 0x91f read value
    csrr x14, 0x91f

    #Unmapped address 0x5db testing: random write/read operations
    #Address 0x5db Write value 0x3f66e21a
    li x3, 0x3f66e21a
    csrw 0x5db, x3

    #Address 0x5db Write value 0x889dd4f7
    li x3, 0x889dd4f7
    csrw 0x5db, x3

    #Unmapped address 0x16d testing: random write/read operations
    #Address 0x16d read value
    csrr x14, 0x16d

    #Address 0x16d Write value 0x774d6e3f
    li x3, 0x774d6e3f
    csrw 0x16d, x3

    #Address 0x16d read value
    csrr x14, 0x16d

    #Address 0x16d Write value 0xecc1647b
    li x3, 0xecc1647b
    csrw 0x16d, x3

    #Address 0x16d Write value 0x68440b75
    li x3, 0x68440b75
    csrw 0x16d, x3

    #Unmapped address 0x8e4 testing: random write/read operations
    #Address 0x8e4 Write value 0xdf5ce151
    li x3, 0xdf5ce151
    csrw 0x8e4, x3

    #Address 0x8e4 read value
    csrr x14, 0x8e4

    #Unmapped address 0x842 testing: random write/read operations
    #Address 0x842 Write value 0x89694a12
    li x3, 0x89694a12
    csrw 0x842, x3

    #Address 0x842 Write value 0xff3d00d9
    li x3, 0xff3d00d9
    csrw 0x842, x3

    #Address 0x842 read value
    csrr x14, 0x842

    #Address 0x842 read value
    csrr x14, 0x842

    #Address 0x842 read value
    csrr x14, 0x842

    #Unmapped address 0x52d testing: random write/read operations
    #Address 0x52d read value
    csrr x14, 0x52d

    #Address 0x52d Write value 0xb35c8cc3
    li x3, 0xb35c8cc3
    csrw 0x52d, x3

    #Address 0x52d Write value 0x77ef08fb
    li x3, 0x77ef08fb
    csrw 0x52d, x3

    #Address 0x52d Write value 0x5da0bfd6
    li x3, 0x5da0bfd6
    csrw 0x52d, x3

    #Unmapped address 0x4ac testing: random write/read operations
    #Address 0x4ac Write value 0xac845568
    li x3, 0xac845568
    csrw 0x4ac, x3

    #Address 0x4ac Write value 0x72be9867
    li x3, 0x72be9867
    csrw 0x4ac, x3

    #Unmapped address 0x82a testing: random write/read operations
    #Address 0x82a read value
    csrr x14, 0x82a

    #Address 0x82a read value
    csrr x14, 0x82a

    #Address 0x82a Write value 0x197f9972
    li x3, 0x197f9972
    csrw 0x82a, x3

    #Unmapped address 0x147 testing: random write/read operations
    #Address 0x147 Write value 0x73719ed1
    li x3, 0x73719ed1
    csrw 0x147, x3

    #Unmapped address 0x728 testing: random write/read operations
    #Address 0x728 read value
    csrr x14, 0x728

    #Unmapped address 0x67e testing: random write/read operations
    #Address 0x67e Write value 0x68ece6b8
    li x3, 0x68ece6b8
    csrw 0x67e, x3

    #Address 0x67e read value
    csrr x14, 0x67e

    #Address 0x67e Write value 0xc073b410
    li x3, 0xc073b410
    csrw 0x67e, x3

    #Address 0x67e Write value 0xef55dd7
    li x3, 0xef55dd7
    csrw 0x67e, x3

    #Address 0x67e read value
    csrr x14, 0x67e

    #Unmapped address 0x2f4 testing: random write/read operations
    #Address 0x2f4 Write value 0x4c8b1b2d
    li x3, 0x4c8b1b2d
    csrw 0x2f4, x3

    #Address 0x2f4 read value
    csrr x14, 0x2f4

    #Address 0x2f4 Write value 0xf32afe92
    li x3, 0xf32afe92
    csrw 0x2f4, x3

    #Address 0x2f4 read value
    csrr x14, 0x2f4

    #Unmapped address 0xeb1 testing: random write/read operations
    #Address 0xeb1 Write value 0xc352b0eb
    li x3, 0xc352b0eb
    csrw 0xeb1, x3

    #Address 0xeb1 Write value 0x7ff29f7b
    li x3, 0x7ff29f7b
    csrw 0xeb1, x3

    #Mapped address 0x342 (mcause) testing: random write/read operations
    #Address 0x342 Write value 0x990bd1e2
    li x3, 0x990bd1e2
    csrw 0x342, x3

    #Address 0x342 read value
    csrr x14, 0x342

    #Address 0x342 Write value 0xa989b399
    li x3, 0xa989b399
    csrw 0x342, x3

    #Unmapped address 0xfd testing: random write/read operations
    #Address 0xfd Write value 0x941dad84
    li x3, 0x941dad84
    csrw 0xfd, x3

    #Address 0xfd read value
    csrr x14, 0xfd

    #Address 0xfd read value
    csrr x14, 0xfd

    #Address 0xfd read value
    csrr x14, 0xfd

    #Unmapped address 0x3c2 testing: random write/read operations
    #Address 0x3c2 Write value 0xd3edd4f2
    li x3, 0xd3edd4f2
    csrw 0x3c2, x3

    #Address 0x3c2 read value
    csrr x14, 0x3c2

    #Address 0x3c2 Write value 0xf9883762
    li x3, 0xf9883762
    csrw 0x3c2, x3

    #Address 0x3c2 Write value 0xea8100b4
    li x3, 0xea8100b4
    csrw 0x3c2, x3

    #Address 0x3c2 read value
    csrr x14, 0x3c2

    #Unmapped address 0x30b testing: random write/read operations
    #Address 0x30b Write value 0x1cfec548
    li x3, 0x1cfec548
    csrw 0x30b, x3

    #Address 0x30b read value
    csrr x14, 0x30b

    #Address 0x30b read value
    csrr x14, 0x30b

    #Address 0x30b read value
    csrr x14, 0x30b

    #Unmapped address 0xa0f testing: random write/read operations
    #Address 0xa0f Write value 0x6f2bd50d
    li x3, 0x6f2bd50d
    csrw 0xa0f, x3

    #Unmapped address 0x109 testing: random write/read operations
    #Address 0x109 read value
    csrr x14, 0x109

    #Address 0x109 read value
    csrr x14, 0x109

    #Address 0x109 Write value 0x35bbdaae
    li x3, 0x35bbdaae
    csrw 0x109, x3

    #Address 0x109 Write value 0x46b3bffd
    li x3, 0x46b3bffd
    csrw 0x109, x3

    #Address 0x109 Write value 0xdc289c64
    li x3, 0xdc289c64
    csrw 0x109, x3

    #Unmapped address 0xfe4 testing: random write/read operations
    #Address 0xfe4 Write value 0x118de7c3
    li x3, 0x118de7c3
    csrw 0xfe4, x3

    #Address 0xfe4 Write value 0x9d6147dd
    li x3, 0x9d6147dd
    csrw 0xfe4, x3

    #Address 0xfe4 Write value 0x18794589
    li x3, 0x18794589
    csrw 0xfe4, x3

    #Address 0xfe4 read value
    csrr x14, 0xfe4

    #Address 0xfe4 read value
    csrr x14, 0xfe4

    #Unmapped address 0xf99 testing: random write/read operations
    #Address 0xf99 Write value 0xc5abdb4
    li x3, 0xc5abdb4
    csrw 0xf99, x3

    #Address 0xf99 Write value 0xddcbba02
    li x3, 0xddcbba02
    csrw 0xf99, x3

    #Address 0xf99 Write value 0xdc4fd24
    li x3, 0xdc4fd24
    csrw 0xf99, x3

    #Address 0xf99 Write value 0xdb1a9575
    li x3, 0xdb1a9575
    csrw 0xf99, x3

    #Unmapped address 0xef8 testing: random write/read operations
    #Address 0xef8 read value
    csrr x14, 0xef8

    #Address 0xef8 Write value 0xcbe8c4a4
    li x3, 0xcbe8c4a4
    csrw 0xef8, x3

    #Address 0xef8 read value
    csrr x14, 0xef8

    #Address 0xef8 Write value 0x26ae866
    li x3, 0x26ae866
    csrw 0xef8, x3

    #Mapped address 0xb84 (mhpmcounterh4) testing: random write/read operations
    #Address 0xb84 Write value 0xbb43077f
    li x3, 0xbb43077f
    csrw 0xb84, x3

    #Unmapped address 0xa3 testing: random write/read operations
    #Address 0xa3 read value
    csrr x14, 0xa3

    #Address 0xa3 read value
    csrr x14, 0xa3

    #Unmapped address 0xb45 testing: random write/read operations
    #Address 0xb45 Write value 0xfb089368
    li x3, 0xfb089368
    csrw 0xb45, x3

    #Address 0xb45 read value
    csrr x14, 0xb45

    #Address 0xb45 Write value 0x5f944
    li x3, 0x5f944
    csrw 0xb45, x3

    #Address 0xb45 read value
    csrr x14, 0xb45

    #Address 0xb45 read value
    csrr x14, 0xb45

    #Unmapped address 0x774 testing: random write/read operations
    #Address 0x774 read value
    csrr x14, 0x774

    #Address 0x774 Write value 0x2bc92a87
    li x3, 0x2bc92a87
    csrw 0x774, x3

    #Address 0x774 read value
    csrr x14, 0x774

    #Unmapped address 0xc05 testing: random write/read operations
    #Address 0xc05 read value
    csrr x14, 0xc05

    #Address 0xc05 Write value 0x6beec7c4
    li x3, 0x6beec7c4
    csrw 0xc05, x3

    #Unmapped address 0xa07 testing: random write/read operations
    #Address 0xa07 read value
    csrr x14, 0xa07

    #Address 0xa07 Write value 0xb8cb9f2d
    li x3, 0xb8cb9f2d
    csrw 0xa07, x3

    #Address 0xa07 read value
    csrr x14, 0xa07

    #Unmapped address 0x53 testing: random write/read operations
    #Address 0x53 read value
    csrr x14, 0x53

    #Address 0x53 Write value 0x779f9470
    li x3, 0x779f9470
    csrw 0x53, x3

    #Address 0x53 read value
    csrr x14, 0x53

    #Address 0x53 Write value 0x72163507
    li x3, 0x72163507
    csrw 0x53, x3

    #Unmapped address 0xef3 testing: random write/read operations
    #Address 0xef3 Write value 0x63d3f974
    li x3, 0x63d3f974
    csrw 0xef3, x3

    #Unmapped address 0x809 testing: random write/read operations
    #Address 0x809 read value
    csrr x14, 0x809

    #Address 0x809 read value
    csrr x14, 0x809

    #Unmapped address 0x564 testing: random write/read operations
    #Address 0x564 Write value 0xcaeb7d9c
    li x3, 0xcaeb7d9c
    csrw 0x564, x3

    #Address 0x564 Write value 0x388f970b
    li x3, 0x388f970b
    csrw 0x564, x3

    #Address 0x564 read value
    csrr x14, 0x564

    #Mapped address 0xb08 (mhpmcounter8) testing: random write/read operations
    #Address 0xb08 read value
    csrr x14, 0xb08

    #Address 0xb08 read value
    csrr x14, 0xb08

    #Unmapped address 0x6a2 testing: random write/read operations
    #Address 0x6a2 Write value 0xd47365e5
    li x3, 0xd47365e5
    csrw 0x6a2, x3

    #Address 0x6a2 Write value 0x4400c040
    li x3, 0x4400c040
    csrw 0x6a2, x3

    #Unmapped address 0xbf1 testing: random write/read operations
    #Address 0xbf1 Write value 0xe32d3e93
    li x3, 0xe32d3e93
    csrw 0xbf1, x3

    #Address 0xbf1 Write value 0x92200a07
    li x3, 0x92200a07
    csrw 0xbf1, x3

    #Address 0xbf1 Write value 0x46bfa569
    li x3, 0x46bfa569
    csrw 0xbf1, x3

    #Address 0xbf1 read value
    csrr x14, 0xbf1

    #Address 0xbf1 read value
    csrr x14, 0xbf1

    #Unmapped address 0xa8c testing: random write/read operations
    #Address 0xa8c read value
    csrr x14, 0xa8c

    #Address 0xa8c Write value 0x1adb146a
    li x3, 0x1adb146a
    csrw 0xa8c, x3

    #Address 0xa8c read value
    csrr x14, 0xa8c

    #Address 0xa8c read value
    csrr x14, 0xa8c

    #Unmapped address 0x34e testing: random write/read operations
    #Address 0x34e Write value 0x8a846b32
    li x3, 0x8a846b32
    csrw 0x34e, x3

    #Address 0x34e Write value 0xf0e031ac
    li x3, 0xf0e031ac
    csrw 0x34e, x3

    #Address 0x34e Write value 0xac8b57eb
    li x3, 0xac8b57eb
    csrw 0x34e, x3

    #Address 0x34e Write value 0x499383a3
    li x3, 0x499383a3
    csrw 0x34e, x3

    #Unmapped address 0x1ee testing: random write/read operations
    #Address 0x1ee read value
    csrr x14, 0x1ee

    #Address 0x1ee Write value 0x68833d52
    li x3, 0x68833d52
    csrw 0x1ee, x3

    #Address 0x1ee read value
    csrr x14, 0x1ee

    #Address 0x1ee read value
    csrr x14, 0x1ee

    #Unmapped address 0x555 testing: random write/read operations
    #Address 0x555 read value
    csrr x14, 0x555

    #Address 0x555 Write value 0xfa8e4bb8
    li x3, 0xfa8e4bb8
    csrw 0x555, x3

    #Unmapped address 0xd9f testing: random write/read operations
    #Address 0xd9f read value
    csrr x14, 0xd9f

    #Address 0xd9f read value
    csrr x14, 0xd9f

    #Address 0xd9f Write value 0xaf91d335
    li x3, 0xaf91d335
    csrw 0xd9f, x3

    #Unmapped address 0x285 testing: random write/read operations
    #Address 0x285 read value
    csrr x14, 0x285

    #Address 0x285 Write value 0xedf14853
    li x3, 0xedf14853
    csrw 0x285, x3

    #Mapped address 0xc02 (instret) testing: random write/read operations
    #Address 0xc02 Write value 0x65e667a7
    li x3, 0x65e667a7
    csrw 0xc02, x3

    #Address 0xc02 read value
    csrr x14, 0xc02

    #Unmapped address 0xec7 testing: random write/read operations
    #Address 0xec7 read value
    csrr x14, 0xec7

    #Address 0xec7 Write value 0xbed6565
    li x3, 0xbed6565
    csrw 0xec7, x3

    #Address 0xec7 Write value 0x1050dbed
    li x3, 0x1050dbed
    csrw 0xec7, x3

    #Unmapped address 0x81f testing: random write/read operations
    #Address 0x81f Write value 0xd6f8fb9c
    li x3, 0xd6f8fb9c
    csrw 0x81f, x3

    #Address 0x81f Write value 0x583ec69b
    li x3, 0x583ec69b
    csrw 0x81f, x3

    #Address 0x81f Write value 0x1d2a0971
    li x3, 0x1d2a0971
    csrw 0x81f, x3

    #Mapped address 0x3bf (pmpaddr15) testing: random write/read operations
    #Address 0x3bf Write value 0x935ea424
    li x3, 0x935ea424
    csrw 0x3bf, x3

    #Address 0x3bf Write value 0x9eabcaac
    li x3, 0x9eabcaac
    csrw 0x3bf, x3

    #Address 0x3bf read value
    csrr x14, 0x3bf

    #Address 0x3bf Write value 0xbf3b14d6
    li x3, 0xbf3b14d6
    csrw 0x3bf, x3

    #Address 0x3bf read value
    csrr x14, 0x3bf

    #Unmapped address 0xa85 testing: random write/read operations
    #Address 0xa85 read value
    csrr x14, 0xa85

    #Address 0xa85 Write value 0x70f18780
    li x3, 0x70f18780
    csrw 0xa85, x3

    #Address 0xa85 Write value 0xa6ebf84c
    li x3, 0xa6ebf84c
    csrw 0xa85, x3

    #Unmapped address 0x46f testing: random write/read operations
    #Address 0x46f read value
    csrr x14, 0x46f

    #Address 0x46f read value
    csrr x14, 0x46f

    #Unmapped address 0xf25 testing: random write/read operations
    #Address 0xf25 read value
    csrr x14, 0xf25

    #Address 0xf25 Write value 0x148dc444
    li x3, 0x148dc444
    csrw 0xf25, x3

    #Address 0xf25 read value
    csrr x14, 0xf25

    #Address 0xf25 read value
    csrr x14, 0xf25

    #Address 0xf25 Write value 0x19e568bb
    li x3, 0x19e568bb
    csrw 0xf25, x3

    #Unmapped address 0x4a0 testing: random write/read operations
    #Address 0x4a0 read value
    csrr x14, 0x4a0

    #Address 0x4a0 Write value 0xf87944bf
    li x3, 0xf87944bf
    csrw 0x4a0, x3

    #Address 0x4a0 Write value 0x4025dcd0
    li x3, 0x4025dcd0
    csrw 0x4a0, x3

    #Address 0x4a0 Write value 0x6c1b2b91
    li x3, 0x6c1b2b91
    csrw 0x4a0, x3

    #Address 0x4a0 read value
    csrr x14, 0x4a0

    #Unmapped address 0x906 testing: random write/read operations
    #Address 0x906 read value
    csrr x14, 0x906

    #Address 0x906 read value
    csrr x14, 0x906

    #Address 0x906 Write value 0xc60fa8cf
    li x3, 0xc60fa8cf
    csrw 0x906, x3

    #Address 0x906 Write value 0x34f31998
    li x3, 0x34f31998
    csrw 0x906, x3

    #Unmapped address 0xb3d testing: random write/read operations
    #Address 0xb3d Write value 0xbaac6561
    li x3, 0xbaac6561
    csrw 0xb3d, x3

    #Address 0xb3d read value
    csrr x14, 0xb3d

    #Unmapped address 0x3f6 testing: random write/read operations
    #Address 0x3f6 Write value 0x6cf4765a
    li x3, 0x6cf4765a
    csrw 0x3f6, x3

    #Address 0x3f6 Write value 0xb2dd76ea
    li x3, 0xb2dd76ea
    csrw 0x3f6, x3

    #Address 0x3f6 Write value 0xe15b49f6
    li x3, 0xe15b49f6
    csrw 0x3f6, x3

    #Unmapped address 0xc99 testing: random write/read operations
    #Address 0xc99 read value
    csrr x14, 0xc99

    #Address 0xc99 Write value 0x6a06ff63
    li x3, 0x6a06ff63
    csrw 0xc99, x3

    #Unmapped address 0x1a7 testing: random write/read operations
    #Address 0x1a7 Write value 0xe3ec3b9a
    li x3, 0xe3ec3b9a
    csrw 0x1a7, x3

    #Address 0x1a7 Write value 0x8f6bca0e
    li x3, 0x8f6bca0e
    csrw 0x1a7, x3

    #Address 0x1a7 read value
    csrr x14, 0x1a7

    #Address 0x1a7 Write value 0x4826ea10
    li x3, 0x4826ea10
    csrw 0x1a7, x3

    #Unmapped address 0x9bc testing: random write/read operations
    #Address 0x9bc read value
    csrr x14, 0x9bc

    #Address 0x9bc Write value 0x1650edbd
    li x3, 0x1650edbd
    csrw 0x9bc, x3

    #Address 0x9bc Write value 0x468477a8
    li x3, 0x468477a8
    csrw 0x9bc, x3

    #Unmapped address 0xb36 testing: random write/read operations
    #Address 0xb36 read value
    csrr x14, 0xb36

    #Address 0xb36 read value
    csrr x14, 0xb36

    #Address 0xb36 read value
    csrr x14, 0xb36

    #Unmapped address 0xb4c testing: random write/read operations
    #Address 0xb4c read value
    csrr x14, 0xb4c

    #Address 0xb4c Write value 0x403458b2
    li x3, 0x403458b2
    csrw 0xb4c, x3

    #Unmapped address 0xbcb testing: random write/read operations
    #Address 0xbcb read value
    csrr x14, 0xbcb

    #Address 0xbcb read value
    csrr x14, 0xbcb

    #Unmapped address 0xeb9 testing: random write/read operations
    #Address 0xeb9 read value
    csrr x14, 0xeb9

    #Address 0xeb9 read value
    csrr x14, 0xeb9

    #Unmapped address 0xd07 testing: random write/read operations
    #Address 0xd07 read value
    csrr x14, 0xd07

    #Address 0xd07 read value
    csrr x14, 0xd07

    #Address 0xd07 Write value 0x205bd45d
    li x3, 0x205bd45d
    csrw 0xd07, x3

    #Unmapped address 0x17 testing: random write/read operations
    #Address 0x17 Write value 0x74168164
    li x3, 0x74168164
    csrw 0x17, x3

    #Address 0x17 Write value 0x7ad68cb8
    li x3, 0x7ad68cb8
    csrw 0x17, x3

    #Unmapped address 0x5da testing: random write/read operations
    #Address 0x5da read value
    csrr x14, 0x5da

    #Address 0x5da Write value 0x299011eb
    li x3, 0x299011eb
    csrw 0x5da, x3

    #Address 0x5da Write value 0xa2500276
    li x3, 0xa2500276
    csrw 0x5da, x3

    #Address 0x5da read value
    csrr x14, 0x5da

    #Unmapped address 0xbc6 testing: random write/read operations
    #Address 0xbc6 read value
    csrr x14, 0xbc6

    #Address 0xbc6 Write value 0x8aea7d6f
    li x3, 0x8aea7d6f
    csrw 0xbc6, x3

    #Address 0xbc6 read value
    csrr x14, 0xbc6

    #Unmapped address 0x8 testing: random write/read operations
    #Address 0x8 read value
    csrr x14, 0x8

    #Unmapped address 0x492 testing: random write/read operations
    #Address 0x492 Write value 0x12b3dc3d
    li x3, 0x12b3dc3d
    csrw 0x492, x3

    #Address 0x492 read value
    csrr x14, 0x492

    #Address 0x492 Write value 0xd86f762d
    li x3, 0xd86f762d
    csrw 0x492, x3

    #Address 0x492 Write value 0x4668c89a
    li x3, 0x4668c89a
    csrw 0x492, x3

    #Address 0x492 Write value 0xb2f75428
    li x3, 0xb2f75428
    csrw 0x492, x3

    #Unmapped address 0xa33 testing: random write/read operations
    #Address 0xa33 Write value 0x3fca1db1
    li x3, 0x3fca1db1
    csrw 0xa33, x3

    #Address 0xa33 Write value 0x4f87c669
    li x3, 0x4f87c669
    csrw 0xa33, x3

    #Address 0xa33 Write value 0x30fe9a93
    li x3, 0x30fe9a93
    csrw 0xa33, x3

    #Address 0xa33 Write value 0x602a5bd0
    li x3, 0x602a5bd0
    csrw 0xa33, x3

    #Unmapped address 0x7fc testing: random write/read operations
    #Address 0x7fc read value
    csrr x14, 0x7fc

    #Address 0x7fc Write value 0xa28d5e14
    li x3, 0xa28d5e14
    csrw 0x7fc, x3

    #Address 0x7fc Write value 0xf9a5bce7
    li x3, 0xf9a5bce7
    csrw 0x7fc, x3

    #Address 0x7fc Write value 0xac96a297
    li x3, 0xac96a297
    csrw 0x7fc, x3

    #Address 0x7fc Write value 0x21721bb9
    li x3, 0x21721bb9
    csrw 0x7fc, x3

    #Unmapped address 0x40b testing: random write/read operations
    #Address 0x40b read value
    csrr x14, 0x40b

    #Address 0x40b read value
    csrr x14, 0x40b

    #Address 0x40b Write value 0x17acd197
    li x3, 0x17acd197
    csrw 0x40b, x3

    #Address 0x40b read value
    csrr x14, 0x40b

    #Unmapped address 0x6a testing: random write/read operations
    #Address 0x6a Write value 0x520d5eaa
    li x3, 0x520d5eaa
    csrw 0x6a, x3

    #Address 0x6a read value
    csrr x14, 0x6a

    #Address 0x6a read value
    csrr x14, 0x6a

    #Address 0x6a read value
    csrr x14, 0x6a

    #Unmapped address 0xe07 testing: random write/read operations
    #Address 0xe07 read value
    csrr x14, 0xe07

    #Address 0xe07 read value
    csrr x14, 0xe07

    #Address 0xe07 read value
    csrr x14, 0xe07

    #Unmapped address 0xe60 testing: random write/read operations
    #Address 0xe60 read value
    csrr x14, 0xe60

    #Address 0xe60 Write value 0x3b9a66ff
    li x3, 0x3b9a66ff
    csrw 0xe60, x3

    #Unmapped address 0xfa7 testing: random write/read operations
    #Address 0xfa7 Write value 0xd379bb93
    li x3, 0xd379bb93
    csrw 0xfa7, x3

    #Address 0xfa7 Write value 0x9e16a7d6
    li x3, 0x9e16a7d6
    csrw 0xfa7, x3

    #Unmapped address 0xced testing: random write/read operations
    #Address 0xced Write value 0x90fb1e5a
    li x3, 0x90fb1e5a
    csrw 0xced, x3

    #Address 0xced Write value 0x4c6a7261
    li x3, 0x4c6a7261
    csrw 0xced, x3

    #Address 0xced Write value 0x7c9dc4cf
    li x3, 0x7c9dc4cf
    csrw 0xced, x3

    #Address 0xced Write value 0x7e5547e8
    li x3, 0x7e5547e8
    csrw 0xced, x3

    #Unmapped address 0xa64 testing: random write/read operations
    #Address 0xa64 read value
    csrr x14, 0xa64

    #Address 0xa64 Write value 0x9e9a7e86
    li x3, 0x9e9a7e86
    csrw 0xa64, x3

    #Unmapped address 0x6f6 testing: random write/read operations
    #Address 0x6f6 Write value 0x2f7763cf
    li x3, 0x2f7763cf
    csrw 0x6f6, x3

    #Address 0x6f6 read value
    csrr x14, 0x6f6

    #Unmapped address 0x6ee testing: random write/read operations
    #Address 0x6ee read value
    csrr x14, 0x6ee

    #Address 0x6ee read value
    csrr x14, 0x6ee

    #Address 0x6ee Write value 0xbe80eeaa
    li x3, 0xbe80eeaa
    csrw 0x6ee, x3

    #Unmapped address 0xe0b testing: random write/read operations
    #Address 0xe0b Write value 0x2fed4052
    li x3, 0x2fed4052
    csrw 0xe0b, x3

    #Address 0xe0b read value
    csrr x14, 0xe0b

    #Address 0xe0b read value
    csrr x14, 0xe0b

    #Unmapped address 0x471 testing: random write/read operations
    #Address 0x471 Write value 0x6f7e5480
    li x3, 0x6f7e5480
    csrw 0x471, x3

    #Unmapped address 0x473 testing: random write/read operations
    #Address 0x473 Write value 0x4172ed40
    li x3, 0x4172ed40
    csrw 0x473, x3

    #Address 0x473 Write value 0x3b293686
    li x3, 0x3b293686
    csrw 0x473, x3

    #Address 0x473 read value
    csrr x14, 0x473

    #Unmapped address 0xe71 testing: random write/read operations
    #Address 0xe71 Write value 0x98989e3f
    li x3, 0x98989e3f
    csrw 0xe71, x3

    #Address 0xe71 read value
    csrr x14, 0xe71

    #Address 0xe71 read value
    csrr x14, 0xe71

    #Unmapped address 0x514 testing: random write/read operations
    #Address 0x514 read value
    csrr x14, 0x514

    #Address 0x514 Write value 0x1e05d37a
    li x3, 0x1e05d37a
    csrw 0x514, x3

    #Unmapped address 0xcfb testing: random write/read operations
    #Address 0xcfb read value
    csrr x14, 0xcfb

    #Address 0xcfb Write value 0x6056b3e8
    li x3, 0x6056b3e8
    csrw 0xcfb, x3

    #Address 0xcfb read value
    csrr x14, 0xcfb

    #Address 0xcfb read value
    csrr x14, 0xcfb

    #Address 0xcfb Write value 0x270f4ce9
    li x3, 0x270f4ce9
    csrw 0xcfb, x3

    #Unmapped address 0x53a testing: random write/read operations
    #Address 0x53a read value
    csrr x14, 0x53a

    #Address 0x53a Write value 0x6ecec11e
    li x3, 0x6ecec11e
    csrw 0x53a, x3

    #Address 0x53a Write value 0x39cbb98d
    li x3, 0x39cbb98d
    csrw 0x53a, x3

    #Unmapped address 0xa48 testing: random write/read operations
    #Address 0xa48 read value
    csrr x14, 0xa48

    #Address 0xa48 Write value 0xee8f8e33
    li x3, 0xee8f8e33
    csrw 0xa48, x3

    #Address 0xa48 Write value 0x9d2ff719
    li x3, 0x9d2ff719
    csrw 0xa48, x3

    #Address 0xa48 read value
    csrr x14, 0xa48

    #Unmapped address 0xdd9 testing: random write/read operations
    #Address 0xdd9 Write value 0x76969a57
    li x3, 0x76969a57
    csrw 0xdd9, x3

    #Address 0xdd9 Write value 0x5ed9d169
    li x3, 0x5ed9d169
    csrw 0xdd9, x3

    #Unmapped address 0xd44 testing: random write/read operations
    #Address 0xd44 read value
    csrr x14, 0xd44

    #Address 0xd44 Write value 0x98187c5d
    li x3, 0x98187c5d
    csrw 0xd44, x3

    #Address 0xd44 read value
    csrr x14, 0xd44

    #Address 0xd44 read value
    csrr x14, 0xd44

    #Unmapped address 0x932 testing: random write/read operations
    #Address 0x932 read value
    csrr x14, 0x932

    #Unmapped address 0x70 testing: random write/read operations
    #Address 0x70 read value
    csrr x14, 0x70

    #Address 0x70 Write value 0xe63b2cfb
    li x3, 0xe63b2cfb
    csrw 0x70, x3

    #Address 0x70 Write value 0x290f2617
    li x3, 0x290f2617
    csrw 0x70, x3

    #Address 0x70 read value
    csrr x14, 0x70

    #Address 0x70 Write value 0x3e5be9b6
    li x3, 0x3e5be9b6
    csrw 0x70, x3

    #Unmapped address 0x96c testing: random write/read operations
    #Address 0x96c read value
    csrr x14, 0x96c

    #Address 0x96c read value
    csrr x14, 0x96c

    #Address 0x96c read value
    csrr x14, 0x96c

    #Address 0x96c Write value 0xae82431b
    li x3, 0xae82431b
    csrw 0x96c, x3

    #Unmapped address 0x5df testing: random write/read operations
    #Address 0x5df Write value 0x5b06b832
    li x3, 0x5b06b832
    csrw 0x5df, x3

    #Unmapped address 0x8e7 testing: random write/read operations
    #Address 0x8e7 read value
    csrr x14, 0x8e7

    #Address 0x8e7 Write value 0x1606c2e
    li x3, 0x1606c2e
    csrw 0x8e7, x3

    #Unmapped address 0x182 testing: random write/read operations
    #Address 0x182 Write value 0x123bdd0a
    li x3, 0x123bdd0a
    csrw 0x182, x3

    #Address 0x182 read value
    csrr x14, 0x182

    #Address 0x182 Write value 0xbc63b5bd
    li x3, 0xbc63b5bd
    csrw 0x182, x3

    #Unmapped address 0x212 testing: random write/read operations
    #Address 0x212 Write value 0x8cb64be4
    li x3, 0x8cb64be4
    csrw 0x212, x3

    #Unmapped address 0x37d testing: random write/read operations
    #Address 0x37d read value
    csrr x14, 0x37d

    #Address 0x37d Write value 0x1bb5b6d5
    li x3, 0x1bb5b6d5
    csrw 0x37d, x3

    #Unmapped address 0x64e testing: random write/read operations
    #Address 0x64e Write value 0xaa4d905c
    li x3, 0xaa4d905c
    csrw 0x64e, x3

    #Unmapped address 0x5ef testing: random write/read operations
    #Address 0x5ef Write value 0xf0ec517c
    li x3, 0xf0ec517c
    csrw 0x5ef, x3

    #Address 0x5ef read value
    csrr x14, 0x5ef

    #Unmapped address 0xf61 testing: random write/read operations
    #Address 0xf61 read value
    csrr x14, 0xf61

    #Address 0xf61 read value
    csrr x14, 0xf61

    #Unmapped address 0x813 testing: random write/read operations
    #Address 0x813 Write value 0x21771173
    li x3, 0x21771173
    csrw 0x813, x3

    #Unmapped address 0xa7a testing: random write/read operations
    #Address 0xa7a Write value 0xe511b040
    li x3, 0xe511b040
    csrw 0xa7a, x3

    #Address 0xa7a Write value 0x87129f50
    li x3, 0x87129f50
    csrw 0xa7a, x3

    #Unmapped address 0x34b testing: random write/read operations
    #Address 0x34b read value
    csrr x14, 0x34b

    #Address 0x34b read value
    csrr x14, 0x34b

    #Address 0x34b Write value 0xbf94e246
    li x3, 0xbf94e246
    csrw 0x34b, x3

    #Unmapped address 0xa43 testing: random write/read operations
    #Address 0xa43 Write value 0xdd5d5bad
    li x3, 0xdd5d5bad
    csrw 0xa43, x3

    #Address 0xa43 read value
    csrr x14, 0xa43

    #Address 0xa43 read value
    csrr x14, 0xa43

    #Address 0xa43 read value
    csrr x14, 0xa43

    #Address 0xa43 Write value 0xb0ee26a9
    li x3, 0xb0ee26a9
    csrw 0xa43, x3

    #Unmapped address 0x70e testing: random write/read operations
    #Address 0x70e read value
    csrr x14, 0x70e

    #Address 0x70e Write value 0x5822c948
    li x3, 0x5822c948
    csrw 0x70e, x3

    #Unmapped address 0x72a testing: random write/read operations
    #Address 0x72a read value
    csrr x14, 0x72a

    #Address 0x72a Write value 0xf61f297d
    li x3, 0xf61f297d
    csrw 0x72a, x3

    #Unmapped address 0xe04 testing: random write/read operations
    #Address 0xe04 read value
    csrr x14, 0xe04

    #Address 0xe04 read value
    csrr x14, 0xe04

    #Address 0xe04 Write value 0xc857571f
    li x3, 0xc857571f
    csrw 0xe04, x3

    #Address 0xe04 read value
    csrr x14, 0xe04

    #Address 0xe04 Write value 0x73e7e2a8
    li x3, 0x73e7e2a8
    csrw 0xe04, x3

    #Unmapped address 0x26d testing: random write/read operations
    #Address 0x26d Write value 0xf2df5cef
    li x3, 0xf2df5cef
    csrw 0x26d, x3

    #Unmapped address 0xa99 testing: random write/read operations
    #Address 0xa99 read value
    csrr x14, 0xa99

    #Address 0xa99 Write value 0x50204e92
    li x3, 0x50204e92
    csrw 0xa99, x3

    #Address 0xa99 Write value 0x62b57319
    li x3, 0x62b57319
    csrw 0xa99, x3

    #Mapped address 0xb88 (mhpmcounterh8) testing: random write/read operations
    #Address 0xb88 read value
    csrr x14, 0xb88

    #Unmapped address 0xecf testing: random write/read operations
    #Address 0xecf read value
    csrr x14, 0xecf

    #Address 0xecf Write value 0xff9aab0f
    li x3, 0xff9aab0f
    csrw 0xecf, x3

    #Unmapped address 0xef6 testing: random write/read operations
    #Address 0xef6 read value
    csrr x14, 0xef6

    #Unmapped address 0xec5 testing: random write/read operations
    #Address 0xec5 read value
    csrr x14, 0xec5

    #Address 0xec5 Write value 0xfbdba744
    li x3, 0xfbdba744
    csrw 0xec5, x3

    #Address 0xec5 read value
    csrr x14, 0xec5

    #Address 0xec5 read value
    csrr x14, 0xec5

    #Unmapped address 0x543 testing: random write/read operations
    #Address 0x543 Write value 0xeffa01b3
    li x3, 0xeffa01b3
    csrw 0x543, x3

    #Address 0x543 read value
    csrr x14, 0x543

    #Unmapped address 0x9e2 testing: random write/read operations
    #Address 0x9e2 read value
    csrr x14, 0x9e2

    #Unmapped address 0x27 testing: random write/read operations
    #Address 0x27 Write value 0x5b2758f1
    li x3, 0x5b2758f1
    csrw 0x27, x3

    #Unmapped address 0x22 testing: random write/read operations
    #Address 0x22 Write value 0xcc7a3b7b
    li x3, 0xcc7a3b7b
    csrw 0x22, x3

    #Address 0x22 read value
    csrr x14, 0x22

    #Address 0x22 read value
    csrr x14, 0x22

    #Address 0x22 read value
    csrr x14, 0x22

    #Address 0x22 read value
    csrr x14, 0x22

    #Unmapped address 0x92d testing: random write/read operations
    #Address 0x92d read value
    csrr x14, 0x92d

    #Unmapped address 0xa6c testing: random write/read operations
    #Address 0xa6c read value
    csrr x14, 0xa6c

    #Address 0xa6c Write value 0xaa525653
    li x3, 0xaa525653
    csrw 0xa6c, x3

    #Address 0xa6c read value
    csrr x14, 0xa6c

    #Unmapped address 0x7fb testing: random write/read operations
    #Address 0x7fb read value
    csrr x14, 0x7fb

    #Address 0x7fb Write value 0x782b8bb2
    li x3, 0x782b8bb2
    csrw 0x7fb, x3

    #Unmapped address 0x69 testing: random write/read operations
    #Address 0x69 read value
    csrr x14, 0x69

    #Address 0x69 Write value 0x1f4c1555
    li x3, 0x1f4c1555
    csrw 0x69, x3

    #Unmapped address 0x656 testing: random write/read operations
    #Address 0x656 Write value 0xedb45af0
    li x3, 0xedb45af0
    csrw 0x656, x3

    #Unmapped address 0x54f testing: random write/read operations
    #Address 0x54f read value
    csrr x14, 0x54f

    #Unmapped address 0xcd2 testing: random write/read operations
    #Address 0xcd2 read value
    csrr x14, 0xcd2

    #Address 0xcd2 Write value 0x9141efc6
    li x3, 0x9141efc6
    csrw 0xcd2, x3

    #Address 0xcd2 read value
    csrr x14, 0xcd2

    #Unmapped address 0xa6 testing: random write/read operations
    #Address 0xa6 Write value 0x5da20328
    li x3, 0x5da20328
    csrw 0xa6, x3

    #Address 0xa6 read value
    csrr x14, 0xa6

    #Unmapped address 0x9c4 testing: random write/read operations
    #Address 0x9c4 Write value 0xb361b51d
    li x3, 0xb361b51d
    csrw 0x9c4, x3

    #Address 0x9c4 Write value 0x3d8a0eb1
    li x3, 0x3d8a0eb1
    csrw 0x9c4, x3

    #Unmapped address 0xfbe testing: random write/read operations
    #Address 0xfbe Write value 0x848eb5d6
    li x3, 0x848eb5d6
    csrw 0xfbe, x3

    #Address 0xfbe Write value 0x8cab3807
    li x3, 0x8cab3807
    csrw 0xfbe, x3

    #Address 0xfbe read value
    csrr x14, 0xfbe

    #Address 0xfbe read value
    csrr x14, 0xfbe

    #Unmapped address 0xf0e testing: random write/read operations
    #Address 0xf0e Write value 0x90f8e884
    li x3, 0x90f8e884
    csrw 0xf0e, x3

    #Address 0xf0e read value
    csrr x14, 0xf0e

    #Unmapped address 0xbce testing: random write/read operations
    #Address 0xbce read value
    csrr x14, 0xbce

    #Unmapped address 0x626 testing: random write/read operations
    #Address 0x626 Write value 0x7350c940
    li x3, 0x7350c940
    csrw 0x626, x3

    #Address 0x626 Write value 0xc4fe083f
    li x3, 0xc4fe083f
    csrw 0x626, x3

    #Address 0x626 read value
    csrr x14, 0x626

    #Address 0x626 read value
    csrr x14, 0x626

    #Address 0x626 Write value 0x8b5c69
    li x3, 0x8b5c69
    csrw 0x626, x3

    #Unmapped address 0xe7d testing: random write/read operations
    #Address 0xe7d Write value 0x884b43f2
    li x3, 0x884b43f2
    csrw 0xe7d, x3

    #Address 0xe7d read value
    csrr x14, 0xe7d

    #Unmapped address 0xee0 testing: random write/read operations
    #Address 0xee0 read value
    csrr x14, 0xee0

    #Unmapped address 0x30d testing: random write/read operations
    #Address 0x30d Write value 0x3f540d32
    li x3, 0x3f540d32
    csrw 0x30d, x3

    #Address 0x30d read value
    csrr x14, 0x30d

    #Unmapped address 0xf95 testing: random write/read operations
    #Address 0xf95 read value
    csrr x14, 0xf95

    #Address 0xf95 Write value 0x46d439ee
    li x3, 0x46d439ee
    csrw 0xf95, x3

    #Address 0xf95 read value
    csrr x14, 0xf95

    #Address 0xf95 Write value 0x349fb2af
    li x3, 0x349fb2af
    csrw 0xf95, x3

    #Unmapped address 0x16b testing: random write/read operations
    #Address 0x16b read value
    csrr x14, 0x16b

    #Address 0x16b Write value 0x736bcdb5
    li x3, 0x736bcdb5
    csrw 0x16b, x3

    #Address 0x16b read value
    csrr x14, 0x16b

    #Address 0x16b Write value 0x4523dbe3
    li x3, 0x4523dbe3
    csrw 0x16b, x3

    #Unmapped address 0x28d testing: random write/read operations
    #Address 0x28d read value
    csrr x14, 0x28d

    #Address 0x28d read value
    csrr x14, 0x28d

    #Address 0x28d Write value 0xbd3239fc
    li x3, 0xbd3239fc
    csrw 0x28d, x3

    #Unmapped address 0x7cd testing: random write/read operations
    #Address 0x7cd Write value 0xab20560
    li x3, 0xab20560
    csrw 0x7cd, x3

    #Address 0x7cd read value
    csrr x14, 0x7cd

    #Address 0x7cd read value
    csrr x14, 0x7cd

    #Address 0x7cd Write value 0x2a5fab95
    li x3, 0x2a5fab95
    csrw 0x7cd, x3

    #Address 0x7cd Write value 0x25de02f
    li x3, 0x25de02f
    csrw 0x7cd, x3

    #Unmapped address 0x13a testing: random write/read operations
    #Address 0x13a Write value 0x8496323e
    li x3, 0x8496323e
    csrw 0x13a, x3

    #Address 0x13a read value
    csrr x14, 0x13a

    #Address 0x13a Write value 0xeb8d13c4
    li x3, 0xeb8d13c4
    csrw 0x13a, x3

    #Address 0x13a Write value 0x5e5b8b53
    li x3, 0x5e5b8b53
    csrw 0x13a, x3

    #Unmapped address 0x8d6 testing: random write/read operations
    #Address 0x8d6 read value
    csrr x14, 0x8d6

    #Unmapped address 0x685 testing: random write/read operations
    #Address 0x685 read value
    csrr x14, 0x685

    #Address 0x685 read value
    csrr x14, 0x685

    #Address 0x685 Write value 0xd75bba24
    li x3, 0xd75bba24
    csrw 0x685, x3

    #Unmapped address 0x62b testing: random write/read operations
    #Address 0x62b read value
    csrr x14, 0x62b

    #Address 0x62b Write value 0xd806d585
    li x3, 0xd806d585
    csrw 0x62b, x3

    #Address 0x62b read value
    csrr x14, 0x62b

    #Unmapped address 0x18a testing: random write/read operations
    #Address 0x18a read value
    csrr x14, 0x18a

    #Unmapped address 0x893 testing: random write/read operations
    #Address 0x893 Write value 0xb7c7c5a2
    li x3, 0xb7c7c5a2
    csrw 0x893, x3

    #Address 0x893 read value
    csrr x14, 0x893

    #Address 0x893 Write value 0xb7dfa989
    li x3, 0xb7dfa989
    csrw 0x893, x3

    #Address 0x893 read value
    csrr x14, 0x893

    #Address 0x893 Write value 0x1f14d118
    li x3, 0x1f14d118
    csrw 0x893, x3

    #Unmapped address 0x3 testing: random write/read operations
    #Address 0x3 read value
    csrr x14, 0x3

    #Address 0x3 Write value 0x5e909e90
    li x3, 0x5e909e90
    csrw 0x3, x3

    #Address 0x3 Write value 0x8f26bfdf
    li x3, 0x8f26bfdf
    csrw 0x3, x3

    #Address 0x3 read value
    csrr x14, 0x3

    #Unmapped address 0x2fe testing: random write/read operations
    #Address 0x2fe read value
    csrr x14, 0x2fe

    #Address 0x2fe Write value 0x570cec18
    li x3, 0x570cec18
    csrw 0x2fe, x3

    #Address 0x2fe Write value 0xa4d450de
    li x3, 0xa4d450de
    csrw 0x2fe, x3

    #Unmapped address 0x1d0 testing: random write/read operations
    #Address 0x1d0 Write value 0xa939cb3
    li x3, 0xa939cb3
    csrw 0x1d0, x3

    #Address 0x1d0 read value
    csrr x14, 0x1d0

    #Address 0x1d0 read value
    csrr x14, 0x1d0

    #Address 0x1d0 read value
    csrr x14, 0x1d0

    #Address 0x1d0 Write value 0x5da6cea
    li x3, 0x5da6cea
    csrw 0x1d0, x3

    #Unmapped address 0x6f3 testing: random write/read operations
    #Address 0x6f3 read value
    csrr x14, 0x6f3

    #Address 0x6f3 read value
    csrr x14, 0x6f3

    #Address 0x6f3 Write value 0x102d6e7
    li x3, 0x102d6e7
    csrw 0x6f3, x3

    #Address 0x6f3 Write value 0xc2efbaec
    li x3, 0xc2efbaec
    csrw 0x6f3, x3

    #Unmapped address 0x719 testing: random write/read operations
    #Address 0x719 read value
    csrr x14, 0x719

    #Unmapped address 0x284 testing: random write/read operations
    #Address 0x284 Write value 0xfe309118
    li x3, 0xfe309118
    csrw 0x284, x3

    #Address 0x284 Write value 0x73cbb1c0
    li x3, 0x73cbb1c0
    csrw 0x284, x3

    #Address 0x284 read value
    csrr x14, 0x284

    #Address 0x284 Write value 0x6bda9f84
    li x3, 0x6bda9f84
    csrw 0x284, x3

    #Unmapped address 0x210 testing: random write/read operations
    #Address 0x210 Write value 0xdb7cc8cc
    li x3, 0xdb7cc8cc
    csrw 0x210, x3

    #Unmapped address 0x6f testing: random write/read operations
    #Address 0x6f read value
    csrr x14, 0x6f

    #Address 0x6f Write value 0xfbd1b461
    li x3, 0xfbd1b461
    csrw 0x6f, x3

    #Unmapped address 0x99f testing: random write/read operations
    #Address 0x99f Write value 0x8c50c2ba
    li x3, 0x8c50c2ba
    csrw 0x99f, x3

    #Address 0x99f Write value 0xa31d800f
    li x3, 0xa31d800f
    csrw 0x99f, x3

    #Address 0x99f read value
    csrr x14, 0x99f

    #Unmapped address 0xf43 testing: random write/read operations
    #Address 0xf43 Write value 0xcfe8aaea
    li x3, 0xcfe8aaea
    csrw 0xf43, x3

    #Address 0xf43 Write value 0x9d14c69b
    li x3, 0x9d14c69b
    csrw 0xf43, x3

    #Address 0xf43 read value
    csrr x14, 0xf43

    #Address 0xf43 read value
    csrr x14, 0xf43

    #Unmapped address 0x392 testing: random write/read operations
    #Address 0x392 read value
    csrr x14, 0x392

    #Unmapped address 0x494 testing: random write/read operations
    #Address 0x494 read value
    csrr x14, 0x494

    #Unmapped address 0x829 testing: random write/read operations
    #Address 0x829 read value
    csrr x14, 0x829

    #Address 0x829 Write value 0xe9374696
    li x3, 0xe9374696
    csrw 0x829, x3

    #Address 0x829 Write value 0x3a53d17d
    li x3, 0x3a53d17d
    csrw 0x829, x3

    #Address 0x829 read value
    csrr x14, 0x829

    #Address 0x829 Write value 0xc1a4fe34
    li x3, 0xc1a4fe34
    csrw 0x829, x3

    #Unmapped address 0x74b testing: random write/read operations
    #Address 0x74b Write value 0x654d77fe
    li x3, 0x654d77fe
    csrw 0x74b, x3

    #Address 0x74b read value
    csrr x14, 0x74b

    #Address 0x74b Write value 0xd7202dbf
    li x3, 0xd7202dbf
    csrw 0x74b, x3

    #Unmapped address 0x122 testing: random write/read operations
    #Address 0x122 Write value 0xb9a1b8e9
    li x3, 0xb9a1b8e9
    csrw 0x122, x3

    #Address 0x122 read value
    csrr x14, 0x122

    #Unmapped address 0xbe5 testing: random write/read operations
    #Address 0xbe5 read value
    csrr x14, 0xbe5

    #Address 0xbe5 read value
    csrr x14, 0xbe5

    #Address 0xbe5 read value
    csrr x14, 0xbe5

    #Unmapped address 0x716 testing: random write/read operations
    #Address 0x716 Write value 0x777d9669
    li x3, 0x777d9669
    csrw 0x716, x3

    #Address 0x716 Write value 0xaea0d02c
    li x3, 0xaea0d02c
    csrw 0x716, x3

    #Address 0x716 read value
    csrr x14, 0x716

    #Address 0x716 Write value 0x69618f87
    li x3, 0x69618f87
    csrw 0x716, x3

    #Unmapped address 0xfe2 testing: random write/read operations
    #Address 0xfe2 read value
    csrr x14, 0xfe2

    #Unmapped address 0x9dc testing: random write/read operations
    #Address 0x9dc read value
    csrr x14, 0x9dc

    #Address 0x9dc read value
    csrr x14, 0x9dc

    #Address 0x9dc Write value 0xa4dc47d0
    li x3, 0xa4dc47d0
    csrw 0x9dc, x3

    #Unmapped address 0xf9f testing: random write/read operations
    #Address 0xf9f read value
    csrr x14, 0xf9f

    #Address 0xf9f Write value 0xeefd6ccd
    li x3, 0xeefd6ccd
    csrw 0xf9f, x3

    #Unmapped address 0xa45 testing: random write/read operations
    #Address 0xa45 Write value 0x5786e8ac
    li x3, 0x5786e8ac
    csrw 0xa45, x3

    #Address 0xa45 read value
    csrr x14, 0xa45

    #Address 0xa45 Write value 0x506fb934
    li x3, 0x506fb934
    csrw 0xa45, x3

    #Address 0xa45 read value
    csrr x14, 0xa45

    #Unmapped address 0x9ff testing: random write/read operations
    #Address 0x9ff read value
    csrr x14, 0x9ff

    #Unmapped address 0xa23 testing: random write/read operations
    #Address 0xa23 read value
    csrr x14, 0xa23

    #Address 0xa23 Write value 0xa4b2573f
    li x3, 0xa4b2573f
    csrw 0xa23, x3

    #Address 0xa23 Write value 0xaa9f37d6
    li x3, 0xaa9f37d6
    csrw 0xa23, x3

    #Address 0xa23 Write value 0x568f7081
    li x3, 0x568f7081
    csrw 0xa23, x3

    #Unmapped address 0xc55 testing: random write/read operations
    #Address 0xc55 Write value 0x29f5cdaf
    li x3, 0x29f5cdaf
    csrw 0xc55, x3

    #Address 0xc55 read value
    csrr x14, 0xc55

    #Address 0xc55 read value
    csrr x14, 0xc55

    #Address 0xc55 Write value 0x3ad7dbee
    li x3, 0x3ad7dbee
    csrw 0xc55, x3

    #Address 0xc55 Write value 0x34c7d985
    li x3, 0x34c7d985
    csrw 0xc55, x3

    #Unmapped address 0x36d testing: random write/read operations
    #Address 0x36d Write value 0xe8a355b7
    li x3, 0xe8a355b7
    csrw 0x36d, x3

    #Address 0x36d read value
    csrr x14, 0x36d

    #Address 0x36d Write value 0x4025f486
    li x3, 0x4025f486
    csrw 0x36d, x3

    #Unmapped address 0x4e4 testing: random write/read operations
    #Address 0x4e4 read value
    csrr x14, 0x4e4

    #Address 0x4e4 Write value 0x40061456
    li x3, 0x40061456
    csrw 0x4e4, x3

    #Address 0x4e4 Write value 0x7e85d106
    li x3, 0x7e85d106
    csrw 0x4e4, x3

    #Unmapped address 0x571 testing: random write/read operations
    #Address 0x571 read value
    csrr x14, 0x571

    #Address 0x571 read value
    csrr x14, 0x571

    #Unmapped address 0x85a testing: random write/read operations
    #Address 0x85a read value
    csrr x14, 0x85a

    #Address 0x85a read value
    csrr x14, 0x85a

    #Address 0x85a Write value 0xbe12b454
    li x3, 0xbe12b454
    csrw 0x85a, x3

    #Unmapped address 0x9e6 testing: random write/read operations
    #Address 0x9e6 Write value 0x3b9cf9af
    li x3, 0x3b9cf9af
    csrw 0x9e6, x3

    #Address 0x9e6 read value
    csrr x14, 0x9e6

    #Address 0x9e6 Write value 0x7593120e
    li x3, 0x7593120e
    csrw 0x9e6, x3

    #Address 0x9e6 Write value 0x2b68f037
    li x3, 0x2b68f037
    csrw 0x9e6, x3

    #Address 0x9e6 Write value 0x28a2a941
    li x3, 0x28a2a941
    csrw 0x9e6, x3

    #Mapped address 0xb05 (mhpmcounter5) testing: random write/read operations
    #Address 0xb05 read value
    csrr x14, 0xb05

    #Unmapped address 0x862 testing: random write/read operations
    #Address 0x862 read value
    csrr x14, 0x862

    #Address 0x862 read value
    csrr x14, 0x862

    #Address 0x862 read value
    csrr x14, 0x862

    #Address 0x862 Write value 0x13357bd1
    li x3, 0x13357bd1
    csrw 0x862, x3

    #Address 0x862 Write value 0x556f528a
    li x3, 0x556f528a
    csrw 0x862, x3

    #Unmapped address 0x2c1 testing: random write/read operations
    #Address 0x2c1 read value
    csrr x14, 0x2c1

    #Address 0x2c1 read value
    csrr x14, 0x2c1

    #Address 0x2c1 read value
    csrr x14, 0x2c1

    #Unmapped address 0xf18 testing: random write/read operations
    #Address 0xf18 read value
    csrr x14, 0xf18

    #Unmapped address 0x9e5 testing: random write/read operations
    #Address 0x9e5 read value
    csrr x14, 0x9e5

    #Address 0x9e5 Write value 0xf7d77d0e
    li x3, 0xf7d77d0e
    csrw 0x9e5, x3

    #Address 0x9e5 read value
    csrr x14, 0x9e5

    #Address 0x9e5 read value
    csrr x14, 0x9e5

    #Address 0x9e5 read value
    csrr x14, 0x9e5

    #Unmapped address 0x39e testing: random write/read operations
    #Address 0x39e read value
    csrr x14, 0x39e

    #Address 0x39e read value
    csrr x14, 0x39e

    #Unmapped address 0x972 testing: random write/read operations
    #Address 0x972 read value
    csrr x14, 0x972

    #Address 0x972 Write value 0x81f52
    li x3, 0x81f52
    csrw 0x972, x3

    #Address 0x972 Write value 0x965ccffe
    li x3, 0x965ccffe
    csrw 0x972, x3

    #Address 0x972 read value
    csrr x14, 0x972

    #Unmapped address 0x2e5 testing: random write/read operations
    #Address 0x2e5 Write value 0x42f62977
    li x3, 0x42f62977
    csrw 0x2e5, x3

    #Address 0x2e5 read value
    csrr x14, 0x2e5

    #Address 0x2e5 read value
    csrr x14, 0x2e5

    #Unmapped address 0x12 testing: random write/read operations
    #Address 0x12 Write value 0xc0bf7852
    li x3, 0xc0bf7852
    csrw 0x12, x3

    #Address 0x12 Write value 0xf9b49d8e
    li x3, 0xf9b49d8e
    csrw 0x12, x3

    #Address 0x12 read value
    csrr x14, 0x12

    #Address 0x12 Write value 0x562e0bf8
    li x3, 0x562e0bf8
    csrw 0x12, x3

    #Address 0x12 Write value 0xa36cc3b5
    li x3, 0xa36cc3b5
    csrw 0x12, x3

    #Unmapped address 0x7df testing: random write/read operations
    #Address 0x7df read value
    csrr x14, 0x7df

    #Unmapped address 0x486 testing: random write/read operations
    #Address 0x486 read value
    csrr x14, 0x486

    #Address 0x486 Write value 0x2dce9b2c
    li x3, 0x2dce9b2c
    csrw 0x486, x3

    #Unmapped address 0xc5f testing: random write/read operations
    #Address 0xc5f read value
    csrr x14, 0xc5f

    #Address 0xc5f Write value 0x25e891c3
    li x3, 0x25e891c3
    csrw 0xc5f, x3

    #Address 0xc5f read value
    csrr x14, 0xc5f

    #Mapped address 0xb87 (mhpmcounterh7) testing: random write/read operations
    #Address 0xb87 Write value 0xc8303f6f
    li x3, 0xc8303f6f
    csrw 0xb87, x3

    #Address 0xb87 read value
    csrr x14, 0xb87

    #Address 0xb87 Write value 0x69152629
    li x3, 0x69152629
    csrw 0xb87, x3

    #Address 0xb87 Write value 0x22bad283
    li x3, 0x22bad283
    csrw 0xb87, x3

    #Address 0xb87 read value
    csrr x14, 0xb87

    #Unmapped address 0xdb7 testing: random write/read operations
    #Address 0xdb7 read value
    csrr x14, 0xdb7

    #Address 0xdb7 read value
    csrr x14, 0xdb7

    #Unmapped address 0xeb6 testing: random write/read operations
    #Address 0xeb6 Write value 0xb9715e2c
    li x3, 0xb9715e2c
    csrw 0xeb6, x3

    #Address 0xeb6 read value
    csrr x14, 0xeb6

    #Address 0xeb6 Write value 0xe010e7b4
    li x3, 0xe010e7b4
    csrw 0xeb6, x3

    #Address 0xeb6 read value
    csrr x14, 0xeb6

    #Unmapped address 0x785 testing: random write/read operations
    #Address 0x785 read value
    csrr x14, 0x785

    #Address 0x785 Write value 0x566850dc
    li x3, 0x566850dc
    csrw 0x785, x3

    #Unmapped address 0xf56 testing: random write/read operations
    #Address 0xf56 Write value 0x8825a43f
    li x3, 0x8825a43f
    csrw 0xf56, x3

    #Address 0xf56 Write value 0x4a5e1492
    li x3, 0x4a5e1492
    csrw 0xf56, x3

    #Unmapped address 0xd0e testing: random write/read operations
    #Address 0xd0e read value
    csrr x14, 0xd0e

    #Address 0xd0e read value
    csrr x14, 0xd0e

    #Address 0xd0e read value
    csrr x14, 0xd0e

    #Address 0xd0e read value
    csrr x14, 0xd0e

    #Address 0xd0e Write value 0x1dbeb871
    li x3, 0x1dbeb871
    csrw 0xd0e, x3

    #Unmapped address 0xe97 testing: random write/read operations
    #Address 0xe97 Write value 0x8a89d099
    li x3, 0x8a89d099
    csrw 0xe97, x3

    #Address 0xe97 read value
    csrr x14, 0xe97

    #Address 0xe97 read value
    csrr x14, 0xe97

    #Address 0xe97 read value
    csrr x14, 0xe97

    #Unmapped address 0x302 testing: random write/read operations
    #Address 0x302 Write value 0xb0ef912
    li x3, 0xb0ef912
    csrw 0x302, x3

    #Address 0x302 Write value 0xf0600672
    li x3, 0xf0600672
    csrw 0x302, x3

    #Unmapped address 0xac4 testing: random write/read operations
    #Address 0xac4 Write value 0xf38c61f7
    li x3, 0xf38c61f7
    csrw 0xac4, x3

    #Address 0xac4 Write value 0x902e426c
    li x3, 0x902e426c
    csrw 0xac4, x3

    #Unmapped address 0xff1 testing: random write/read operations
    #Address 0xff1 read value
    csrr x14, 0xff1

    #Address 0xff1 read value
    csrr x14, 0xff1

    #Address 0xff1 read value
    csrr x14, 0xff1

    #Address 0xff1 Write value 0x3f9c0f30
    li x3, 0x3f9c0f30
    csrw 0xff1, x3

    #Address 0xff1 read value
    csrr x14, 0xff1

    #Unmapped address 0xd4f testing: random write/read operations
    #Address 0xd4f read value
    csrr x14, 0xd4f

    #Address 0xd4f Write value 0x1ea03b4
    li x3, 0x1ea03b4
    csrw 0xd4f, x3

    #Address 0xd4f Write value 0x99778171
    li x3, 0x99778171
    csrw 0xd4f, x3

    #Address 0xd4f read value
    csrr x14, 0xd4f

    #Address 0xd4f read value
    csrr x14, 0xd4f

    #Unmapped address 0x373 testing: random write/read operations
    #Address 0x373 read value
    csrr x14, 0x373

    #Address 0x373 Write value 0xecb64dc4
    li x3, 0xecb64dc4
    csrw 0x373, x3

    #Address 0x373 read value
    csrr x14, 0x373

    #Address 0x373 read value
    csrr x14, 0x373

    #Address 0x373 read value
    csrr x14, 0x373

    #Unmapped address 0xc7d testing: random write/read operations
    #Address 0xc7d Write value 0xfdfdd970
    li x3, 0xfdfdd970
    csrw 0xc7d, x3

    #Address 0xc7d Write value 0x18ae4a3e
    li x3, 0x18ae4a3e
    csrw 0xc7d, x3

    #Address 0xc7d read value
    csrr x14, 0xc7d

    #Address 0xc7d Write value 0xc3ea85d1
    li x3, 0xc3ea85d1
    csrw 0xc7d, x3

    #Unmapped address 0xcb7 testing: random write/read operations
    #Address 0xcb7 read value
    csrr x14, 0xcb7

    #Unmapped address 0x159 testing: random write/read operations
    #Address 0x159 Write value 0x9c270ebe
    li x3, 0x9c270ebe
    csrw 0x159, x3

    #Unmapped address 0xd48 testing: random write/read operations
    #Address 0xd48 read value
    csrr x14, 0xd48

    #Unmapped address 0x9f6 testing: random write/read operations
    #Address 0x9f6 read value
    csrr x14, 0x9f6

    #Address 0x9f6 read value
    csrr x14, 0x9f6

    #Address 0x9f6 Write value 0xfb607538
    li x3, 0xfb607538
    csrw 0x9f6, x3

    #Address 0x9f6 read value
    csrr x14, 0x9f6

    #Address 0x9f6 Write value 0x32912ed8
    li x3, 0x32912ed8
    csrw 0x9f6, x3

    #Unmapped address 0x3fc testing: random write/read operations
    #Address 0x3fc read value
    csrr x14, 0x3fc

    #Unmapped address 0x594 testing: random write/read operations
    #Address 0x594 Write value 0x9eae15c8
    li x3, 0x9eae15c8
    csrw 0x594, x3

    #Address 0x594 read value
    csrr x14, 0x594

    #Unmapped address 0x197 testing: random write/read operations
    #Address 0x197 Write value 0x4a820bb1
    li x3, 0x4a820bb1
    csrw 0x197, x3

    #Address 0x197 read value
    csrr x14, 0x197

    #Address 0x197 Write value 0x30a8be4f
    li x3, 0x30a8be4f
    csrw 0x197, x3

    #Address 0x197 Write value 0x8cc8cc08
    li x3, 0x8cc8cc08
    csrw 0x197, x3

    #Unmapped address 0x5ea testing: random write/read operations
    #Address 0x5ea Write value 0x38ee4611
    li x3, 0x38ee4611
    csrw 0x5ea, x3

    #Address 0x5ea Write value 0x31b9726c
    li x3, 0x31b9726c
    csrw 0x5ea, x3

    #Address 0x5ea read value
    csrr x14, 0x5ea

    #Address 0x5ea Write value 0xa244850f
    li x3, 0xa244850f
    csrw 0x5ea, x3

    #Unmapped address 0x4e3 testing: random write/read operations
    #Address 0x4e3 Write value 0x311bdcb3
    li x3, 0x311bdcb3
    csrw 0x4e3, x3

    #Address 0x4e3 Write value 0xa079a181
    li x3, 0xa079a181
    csrw 0x4e3, x3

    #Address 0x4e3 Write value 0xda8bc4b8
    li x3, 0xda8bc4b8
    csrw 0x4e3, x3

    #Address 0x4e3 Write value 0x7779abbc
    li x3, 0x7779abbc
    csrw 0x4e3, x3

    #Unmapped address 0x9d1 testing: random write/read operations
    #Address 0x9d1 read value
    csrr x14, 0x9d1

    #Address 0x9d1 read value
    csrr x14, 0x9d1

    #Address 0x9d1 read value
    csrr x14, 0x9d1

    #Address 0x9d1 Write value 0xed02bda1
    li x3, 0xed02bda1
    csrw 0x9d1, x3

    #Unmapped address 0x8a4 testing: random write/read operations
    #Address 0x8a4 Write value 0x77e8ed38
    li x3, 0x77e8ed38
    csrw 0x8a4, x3

    #Address 0x8a4 Write value 0xd8d0252b
    li x3, 0xd8d0252b
    csrw 0x8a4, x3

    #Address 0x8a4 read value
    csrr x14, 0x8a4

    #Unmapped address 0x3a7 testing: random write/read operations
    #Address 0x3a7 Write value 0x6ea746f3
    li x3, 0x6ea746f3
    csrw 0x3a7, x3

    #Address 0x3a7 Write value 0xd2ef19ce
    li x3, 0xd2ef19ce
    csrw 0x3a7, x3

    #Address 0x3a7 read value
    csrr x14, 0x3a7

    #Address 0x3a7 read value
    csrr x14, 0x3a7

    #Address 0x3a7 Write value 0xa8ec053e
    li x3, 0xa8ec053e
    csrw 0x3a7, x3

    #Unmapped address 0x3ae testing: random write/read operations
    #Address 0x3ae read value
    csrr x14, 0x3ae

    #Address 0x3ae read value
    csrr x14, 0x3ae

    #Address 0x3ae Write value 0x3c8f2884
    li x3, 0x3c8f2884
    csrw 0x3ae, x3

    #Unmapped address 0x99a testing: random write/read operations
    #Address 0x99a read value
    csrr x14, 0x99a

    #Address 0x99a read value
    csrr x14, 0x99a

    #Address 0x99a Write value 0x571035d
    li x3, 0x571035d
    csrw 0x99a, x3

    #Unmapped address 0xe0d testing: random write/read operations
    #Address 0xe0d Write value 0x796d0779
    li x3, 0x796d0779
    csrw 0xe0d, x3

    #Address 0xe0d read value
    csrr x14, 0xe0d

    #Address 0xe0d Write value 0x58211194
    li x3, 0x58211194
    csrw 0xe0d, x3

    #Address 0xe0d Write value 0x4b0f54eb
    li x3, 0x4b0f54eb
    csrw 0xe0d, x3

    #Address 0xe0d read value
    csrr x14, 0xe0d

    #Unmapped address 0xd43 testing: random write/read operations
    #Address 0xd43 read value
    csrr x14, 0xd43

    #Address 0xd43 Write value 0xe640cf23
    li x3, 0xe640cf23
    csrw 0xd43, x3

    #Address 0xd43 read value
    csrr x14, 0xd43

    #Unmapped address 0xb46 testing: random write/read operations
    #Address 0xb46 read value
    csrr x14, 0xb46

    #Address 0xb46 Write value 0x98fe619a
    li x3, 0x98fe619a
    csrw 0xb46, x3

    #Address 0xb46 Write value 0xc0cd5c94
    li x3, 0xc0cd5c94
    csrw 0xb46, x3

    #Unmapped address 0x878 testing: random write/read operations
    #Address 0x878 Write value 0xeb386f05
    li x3, 0xeb386f05
    csrw 0x878, x3

    #Address 0x878 read value
    csrr x14, 0x878

    #Address 0x878 read value
    csrr x14, 0x878

    #Address 0x878 Write value 0xc7b4637c
    li x3, 0xc7b4637c
    csrw 0x878, x3

    #Address 0x878 read value
    csrr x14, 0x878

    #Unmapped address 0x35e testing: random write/read operations
    #Address 0x35e Write value 0x9b13b5e0
    li x3, 0x9b13b5e0
    csrw 0x35e, x3

    #Address 0x35e read value
    csrr x14, 0x35e

    #Address 0x35e read value
    csrr x14, 0x35e

    #Address 0x35e read value
    csrr x14, 0x35e

    #Unmapped address 0xcd1 testing: random write/read operations
    #Address 0xcd1 read value
    csrr x14, 0xcd1

    #Address 0xcd1 Write value 0xdeae16a2
    li x3, 0xdeae16a2
    csrw 0xcd1, x3

    #Address 0xcd1 read value
    csrr x14, 0xcd1

    #Address 0xcd1 read value
    csrr x14, 0xcd1

    #Unmapped address 0x87 testing: random write/read operations
    #Address 0x87 read value
    csrr x14, 0x87

    #Address 0x87 read value
    csrr x14, 0x87

    #Unmapped address 0x679 testing: random write/read operations
    #Address 0x679 read value
    csrr x14, 0x679

    #Address 0x679 read value
    csrr x14, 0x679

    #Unmapped address 0xa6a testing: random write/read operations
    #Address 0xa6a Write value 0x7ac5a2c2
    li x3, 0x7ac5a2c2
    csrw 0xa6a, x3

    #Address 0xa6a Write value 0x539e304c
    li x3, 0x539e304c
    csrw 0xa6a, x3

    #Unmapped address 0xb75 testing: random write/read operations
    #Address 0xb75 Write value 0xaa8cc100
    li x3, 0xaa8cc100
    csrw 0xb75, x3

    #Address 0xb75 read value
    csrr x14, 0xb75

    #Address 0xb75 Write value 0x556b02ef
    li x3, 0x556b02ef
    csrw 0xb75, x3

    #Unmapped address 0x65c testing: random write/read operations
    #Address 0x65c read value
    csrr x14, 0x65c

    #Address 0x65c Write value 0x44b04947
    li x3, 0x44b04947
    csrw 0x65c, x3

    #Unmapped address 0xaec testing: random write/read operations
    #Address 0xaec Write value 0xb134e0e
    li x3, 0xb134e0e
    csrw 0xaec, x3

    #Unmapped address 0xea8 testing: random write/read operations
    #Address 0xea8 read value
    csrr x14, 0xea8

    #Address 0xea8 Write value 0x55229987
    li x3, 0x55229987
    csrw 0xea8, x3

    #Address 0xea8 Write value 0x71e671ee
    li x3, 0x71e671ee
    csrw 0xea8, x3

    #Address 0xea8 Write value 0x6bf0694f
    li x3, 0x6bf0694f
    csrw 0xea8, x3

    #Unmapped address 0x6eb testing: random write/read operations
    #Address 0x6eb Write value 0x87def069
    li x3, 0x87def069
    csrw 0x6eb, x3

    #Address 0x6eb read value
    csrr x14, 0x6eb

    #Address 0x6eb read value
    csrr x14, 0x6eb

    #Unmapped address 0x5d1 testing: random write/read operations
    #Address 0x5d1 Write value 0x49d0f06
    li x3, 0x49d0f06
    csrw 0x5d1, x3

    #Address 0x5d1 read value
    csrr x14, 0x5d1

    #Address 0x5d1 Write value 0xc67f8048
    li x3, 0xc67f8048
    csrw 0x5d1, x3

    #Address 0x5d1 Write value 0xc9d1baee
    li x3, 0xc9d1baee
    csrw 0x5d1, x3

    #Unmapped address 0x963 testing: random write/read operations
    #Address 0x963 Write value 0x4bf99855
    li x3, 0x4bf99855
    csrw 0x963, x3

    #Address 0x963 read value
    csrr x14, 0x963

    #Address 0x963 read value
    csrr x14, 0x963

    #Address 0x963 Write value 0x3c4fc813
    li x3, 0x3c4fc813
    csrw 0x963, x3

    #Address 0x963 read value
    csrr x14, 0x963

    #Unmapped address 0xd38 testing: random write/read operations
    #Address 0xd38 read value
    csrr x14, 0xd38

    #Address 0xd38 read value
    csrr x14, 0xd38

    #Address 0xd38 Write value 0xbe24b3e4
    li x3, 0xbe24b3e4
    csrw 0xd38, x3

    #Address 0xd38 read value
    csrr x14, 0xd38

    #Unmapped address 0xe6a testing: random write/read operations
    #Address 0xe6a Write value 0xc7c7c118
    li x3, 0xc7c7c118
    csrw 0xe6a, x3

    #Unmapped address 0x567 testing: random write/read operations
    #Address 0x567 Write value 0xffb421a1
    li x3, 0xffb421a1
    csrw 0x567, x3

    #Address 0x567 read value
    csrr x14, 0x567

    #Address 0x567 Write value 0x4b220114
    li x3, 0x4b220114
    csrw 0x567, x3

    #Address 0x567 Write value 0xb2294657
    li x3, 0xb2294657
    csrw 0x567, x3

    #Address 0x567 read value
    csrr x14, 0x567

    #Unmapped address 0xa74 testing: random write/read operations
    #Address 0xa74 Write value 0xd11c65eb
    li x3, 0xd11c65eb
    csrw 0xa74, x3

    #Address 0xa74 read value
    csrr x14, 0xa74

    #Unmapped address 0x383 testing: random write/read operations
    #Address 0x383 Write value 0xe660ce85
    li x3, 0xe660ce85
    csrw 0x383, x3

    #Unmapped address 0xadc testing: random write/read operations
    #Address 0xadc read value
    csrr x14, 0xadc

    #Address 0xadc read value
    csrr x14, 0xadc

    #Address 0xadc Write value 0x9811e2fe
    li x3, 0x9811e2fe
    csrw 0xadc, x3

    #Address 0xadc read value
    csrr x14, 0xadc

    #Unmapped address 0xf37 testing: random write/read operations
    #Address 0xf37 read value
    csrr x14, 0xf37

    #Unmapped address 0x5e6 testing: random write/read operations
    #Address 0x5e6 read value
    csrr x14, 0x5e6

    #Unmapped address 0x4c testing: random write/read operations
    #Address 0x4c read value
    csrr x14, 0x4c

    #Address 0x4c Write value 0x914541cd
    li x3, 0x914541cd
    csrw 0x4c, x3

    #Address 0x4c Write value 0x31414f40
    li x3, 0x31414f40
    csrw 0x4c, x3

    #Unmapped address 0x86f testing: random write/read operations
    #Address 0x86f read value
    csrr x14, 0x86f

    #Address 0x86f read value
    csrr x14, 0x86f

    #Address 0x86f Write value 0xbeac87a9
    li x3, 0xbeac87a9
    csrw 0x86f, x3

    #Address 0x86f Write value 0xb27a6fb3
    li x3, 0xb27a6fb3
    csrw 0x86f, x3

    #Unmapped address 0x3ce testing: random write/read operations
    #Address 0x3ce Write value 0x8212dde1
    li x3, 0x8212dde1
    csrw 0x3ce, x3

    #Address 0x3ce read value
    csrr x14, 0x3ce

    #Address 0x3ce Write value 0x93ff70d9
    li x3, 0x93ff70d9
    csrw 0x3ce, x3

    #Address 0x3ce read value
    csrr x14, 0x3ce

    #Address 0x3ce Write value 0x26b7938a
    li x3, 0x26b7938a
    csrw 0x3ce, x3

    #Unmapped address 0x2a8 testing: random write/read operations
    #Address 0x2a8 read value
    csrr x14, 0x2a8

    #Address 0x2a8 read value
    csrr x14, 0x2a8

    #Unmapped address 0xf testing: random write/read operations
    #Address 0xf read value
    csrr x14, 0xf

    #Address 0xf read value
    csrr x14, 0xf

    #Address 0xf read value
    csrr x14, 0xf

    #Unmapped address 0x2fd testing: random write/read operations
    #Address 0x2fd Write value 0xdb4b6f3d
    li x3, 0xdb4b6f3d
    csrw 0x2fd, x3

    #Address 0x2fd read value
    csrr x14, 0x2fd

    #Address 0x2fd read value
    csrr x14, 0x2fd

    #Unmapped address 0xc2c testing: random write/read operations
    #Address 0xc2c Write value 0xd6d54c69
    li x3, 0xd6d54c69
    csrw 0xc2c, x3

    #Address 0xc2c Write value 0x74d2389a
    li x3, 0x74d2389a
    csrw 0xc2c, x3

    #Address 0xc2c Write value 0x2199fe72
    li x3, 0x2199fe72
    csrw 0xc2c, x3

    #Address 0xc2c Write value 0x27996457
    li x3, 0x27996457
    csrw 0xc2c, x3

    #Unmapped address 0x92c testing: random write/read operations
    #Address 0x92c Write value 0xbed1b0b9
    li x3, 0xbed1b0b9
    csrw 0x92c, x3

    #Address 0x92c read value
    csrr x14, 0x92c

    #Address 0x92c Write value 0xdf18771
    li x3, 0xdf18771
    csrw 0x92c, x3

    #Unmapped address 0xad testing: random write/read operations
    #Address 0xad read value
    csrr x14, 0xad

    #Unmapped address 0xf0f testing: random write/read operations
    #Address 0xf0f Write value 0x4553acdf
    li x3, 0x4553acdf
    csrw 0xf0f, x3

    #Address 0xf0f Write value 0x38cf6c6d
    li x3, 0x38cf6c6d
    csrw 0xf0f, x3

    #Unmapped address 0xf8a testing: random write/read operations
    #Address 0xf8a Write value 0x25f2d6e4
    li x3, 0x25f2d6e4
    csrw 0xf8a, x3

    #Address 0xf8a Write value 0xfd48f0d5
    li x3, 0xfd48f0d5
    csrw 0xf8a, x3

    #Unmapped address 0xb2b testing: random write/read operations
    #Address 0xb2b Write value 0xd043feaf
    li x3, 0xd043feaf
    csrw 0xb2b, x3

    #Unmapped address 0x161 testing: random write/read operations
    #Address 0x161 Write value 0xd50bbdb6
    li x3, 0xd50bbdb6
    csrw 0x161, x3

    #Address 0x161 read value
    csrr x14, 0x161

    #Address 0x161 Write value 0xd524d7d5
    li x3, 0xd524d7d5
    csrw 0x161, x3

    #Address 0x161 Write value 0x77014062
    li x3, 0x77014062
    csrw 0x161, x3

    #Address 0x161 Write value 0x2503a5c7
    li x3, 0x2503a5c7
    csrw 0x161, x3

    #Unmapped address 0xf4a testing: random write/read operations
    #Address 0xf4a Write value 0x99cbc7ea
    li x3, 0x99cbc7ea
    csrw 0xf4a, x3

    #Address 0xf4a Write value 0xf73b7993
    li x3, 0xf73b7993
    csrw 0xf4a, x3

    #Address 0xf4a read value
    csrr x14, 0xf4a

    #Address 0xf4a Write value 0xb3429f22
    li x3, 0xb3429f22
    csrw 0xf4a, x3

    #Unmapped address 0x6fb testing: random write/read operations
    #Address 0x6fb read value
    csrr x14, 0x6fb

    #Address 0x6fb read value
    csrr x14, 0x6fb

    #Address 0x6fb Write value 0xa58d716a
    li x3, 0xa58d716a
    csrw 0x6fb, x3

    #Address 0x6fb read value
    csrr x14, 0x6fb

    #Unmapped address 0xce6 testing: random write/read operations
    #Address 0xce6 read value
    csrr x14, 0xce6

    #Address 0xce6 Write value 0xfa20de00
    li x3, 0xfa20de00
    csrw 0xce6, x3

    #Address 0xce6 Write value 0xfcd442b2
    li x3, 0xfcd442b2
    csrw 0xce6, x3

    #Address 0xce6 read value
    csrr x14, 0xce6

    #Unmapped address 0xbe4 testing: random write/read operations
    #Address 0xbe4 read value
    csrr x14, 0xbe4

    #Address 0xbe4 Write value 0x1fae4c0a
    li x3, 0x1fae4c0a
    csrw 0xbe4, x3

    #Unmapped address 0xacb testing: random write/read operations
    #Address 0xacb Write value 0x5a3f74d8
    li x3, 0x5a3f74d8
    csrw 0xacb, x3

    #Address 0xacb read value
    csrr x14, 0xacb

    #Unmapped address 0xed8 testing: random write/read operations
    #Address 0xed8 read value
    csrr x14, 0xed8

    #Unmapped address 0x391 testing: random write/read operations
    #Address 0x391 read value
    csrr x14, 0x391

    #Address 0x391 read value
    csrr x14, 0x391

    #Address 0x391 Write value 0xa31eb700
    li x3, 0xa31eb700
    csrw 0x391, x3

    #Unmapped address 0x8d5 testing: random write/read operations
    #Address 0x8d5 Write value 0xd2c06f48
    li x3, 0xd2c06f48
    csrw 0x8d5, x3

    #Address 0x8d5 Write value 0x89fb4ba4
    li x3, 0x89fb4ba4
    csrw 0x8d5, x3

    #Address 0x8d5 read value
    csrr x14, 0x8d5

    #Address 0x8d5 Write value 0xd4a213c
    li x3, 0xd4a213c
    csrw 0x8d5, x3

    #Unmapped address 0x90c testing: random write/read operations
    #Address 0x90c read value
    csrr x14, 0x90c

    #Address 0x90c read value
    csrr x14, 0x90c

    #Address 0x90c Write value 0x1e53832f
    li x3, 0x1e53832f
    csrw 0x90c, x3

    #Unmapped address 0xe81 testing: random write/read operations
    #Address 0xe81 Write value 0x69736772
    li x3, 0x69736772
    csrw 0xe81, x3

    #Address 0xe81 Write value 0x3ebeb16a
    li x3, 0x3ebeb16a
    csrw 0xe81, x3

    #Mapped address 0x32d (mhpmevent13) testing: random write/read operations
    #Address 0x32d Write value 0x2c04c2e6
    li x3, 0x2c04c2e6
    csrw 0x32d, x3

    #Address 0x32d Write value 0x88cdfb7f
    li x3, 0x88cdfb7f
    csrw 0x32d, x3

    #Address 0x32d Write value 0xbb38a2cc
    li x3, 0xbb38a2cc
    csrw 0x32d, x3

    #Unmapped address 0xe15 testing: random write/read operations
    #Address 0xe15 Write value 0x310f0fe2
    li x3, 0x310f0fe2
    csrw 0xe15, x3

    #Address 0xe15 read value
    csrr x14, 0xe15

    #Address 0xe15 read value
    csrr x14, 0xe15

    #Address 0xe15 Write value 0xea8183b2
    li x3, 0xea8183b2
    csrw 0xe15, x3

    #Unmapped address 0x839 testing: random write/read operations
    #Address 0x839 read value
    csrr x14, 0x839

    #Address 0x839 Write value 0x941947b
    li x3, 0x941947b
    csrw 0x839, x3

    #Address 0x839 read value
    csrr x14, 0x839

    #Unmapped address 0x570 testing: random write/read operations
    #Address 0x570 Write value 0x9d3e1947
    li x3, 0x9d3e1947
    csrw 0x570, x3

    #Address 0x570 read value
    csrr x14, 0x570

    #Unmapped address 0x777 testing: random write/read operations
    #Address 0x777 read value
    csrr x14, 0x777

    #Address 0x777 read value
    csrr x14, 0x777

    #Address 0x777 Write value 0x3fdec4f3
    li x3, 0x3fdec4f3
    csrw 0x777, x3

    #Address 0x777 read value
    csrr x14, 0x777

    #Unmapped address 0x129 testing: random write/read operations
    #Address 0x129 read value
    csrr x14, 0x129

    #Address 0x129 read value
    csrr x14, 0x129

    #Address 0x129 read value
    csrr x14, 0x129

    #Address 0x129 Write value 0x3dff6286
    li x3, 0x3dff6286
    csrw 0x129, x3

    #Address 0x129 read value
    csrr x14, 0x129

    #Unmapped address 0x7c5 testing: random write/read operations
    #Address 0x7c5 read value
    csrr x14, 0x7c5

    #Address 0x7c5 read value
    csrr x14, 0x7c5

    #Address 0x7c5 Write value 0x7a419b1f
    li x3, 0x7a419b1f
    csrw 0x7c5, x3

    #Address 0x7c5 Write value 0xfe08101b
    li x3, 0xfe08101b
    csrw 0x7c5, x3

    #Address 0x7c5 read value
    csrr x14, 0x7c5

    #Unmapped address 0x664 testing: random write/read operations
    #Address 0x664 Write value 0x2cfc139c
    li x3, 0x2cfc139c
    csrw 0x664, x3

    #Address 0x664 read value
    csrr x14, 0x664

    #Unmapped address 0xf1e testing: random write/read operations
    #Address 0xf1e read value
    csrr x14, 0xf1e

    #Address 0xf1e Write value 0x2f05d2aa
    li x3, 0x2f05d2aa
    csrw 0xf1e, x3

    #Address 0xf1e read value
    csrr x14, 0xf1e

    #Address 0xf1e Write value 0xe35979b7
    li x3, 0xe35979b7
    csrw 0xf1e, x3

    #Unmapped address 0x7b9 testing: random write/read operations
    #Address 0x7b9 read value
    csrr x14, 0x7b9

    #Address 0x7b9 Write value 0x1e7b2dc7
    li x3, 0x1e7b2dc7
    csrw 0x7b9, x3

    #Address 0x7b9 Write value 0x120258cd
    li x3, 0x120258cd
    csrw 0x7b9, x3

    #Unmapped address 0xeca testing: random write/read operations
    #Address 0xeca read value
    csrr x14, 0xeca

    #Unmapped address 0x702 testing: random write/read operations
    #Address 0x702 read value
    csrr x14, 0x702

    #Address 0x702 Write value 0x2b61a091
    li x3, 0x2b61a091
    csrw 0x702, x3

    #Address 0x702 read value
    csrr x14, 0x702

    #Address 0x702 Write value 0xd1ef33dc
    li x3, 0xd1ef33dc
    csrw 0x702, x3

    #Address 0x702 read value
    csrr x14, 0x702

    #Unmapped address 0x62e testing: random write/read operations
    #Address 0x62e Write value 0x193f1f4
    li x3, 0x193f1f4
    csrw 0x62e, x3

    #Address 0x62e Write value 0x482e3b2b
    li x3, 0x482e3b2b
    csrw 0x62e, x3

    #Address 0x62e Write value 0x75e50341
    li x3, 0x75e50341
    csrw 0x62e, x3

    #Address 0x62e read value
    csrr x14, 0x62e

    #Unmapped address 0xabb testing: random write/read operations
    #Address 0xabb Write value 0xe8899e01
    li x3, 0xe8899e01
    csrw 0xabb, x3

    #Unmapped address 0x25b testing: random write/read operations
    #Address 0x25b Write value 0x1994fcff
    li x3, 0x1994fcff
    csrw 0x25b, x3

    #Address 0x25b read value
    csrr x14, 0x25b

    #Address 0x25b Write value 0xf972fde1
    li x3, 0xf972fde1
    csrw 0x25b, x3

    #Unmapped address 0x1d6 testing: random write/read operations
    #Address 0x1d6 read value
    csrr x14, 0x1d6

    #Address 0x1d6 read value
    csrr x14, 0x1d6

    #Address 0x1d6 Write value 0x1f6aef4e
    li x3, 0x1f6aef4e
    csrw 0x1d6, x3

    #Unmapped address 0x63 testing: random write/read operations
    #Address 0x63 read value
    csrr x14, 0x63

    #Address 0x63 read value
    csrr x14, 0x63

    #Address 0x63 Write value 0x976cf9ee
    li x3, 0x976cf9ee
    csrw 0x63, x3

    #Address 0x63 read value
    csrr x14, 0x63

    #Unmapped address 0xe56 testing: random write/read operations
    #Address 0xe56 read value
    csrr x14, 0xe56

    #Address 0xe56 Write value 0x76f15843
    li x3, 0x76f15843
    csrw 0xe56, x3

    #Address 0xe56 read value
    csrr x14, 0xe56

    #Unmapped address 0x837 testing: random write/read operations
    #Address 0x837 read value
    csrr x14, 0x837

    #Address 0x837 read value
    csrr x14, 0x837

    #Address 0x837 Write value 0x7070a09a
    li x3, 0x7070a09a
    csrw 0x837, x3

    #Address 0x837 Write value 0xc28b1e34
    li x3, 0xc28b1e34
    csrw 0x837, x3

    #Unmapped address 0x261 testing: random write/read operations
    #Address 0x261 read value
    csrr x14, 0x261

    #Address 0x261 Write value 0x61010a39
    li x3, 0x61010a39
    csrw 0x261, x3

    #Address 0x261 Write value 0x48533105
    li x3, 0x48533105
    csrw 0x261, x3

    #Address 0x261 read value
    csrr x14, 0x261

    #Unmapped address 0x756 testing: random write/read operations
    #Address 0x756 Write value 0x3965309e
    li x3, 0x3965309e
    csrw 0x756, x3

    #Address 0x756 read value
    csrr x14, 0x756

    #Unmapped address 0xe8f testing: random write/read operations
    #Address 0xe8f Write value 0x704b1eb0
    li x3, 0x704b1eb0
    csrw 0xe8f, x3

    #Address 0xe8f read value
    csrr x14, 0xe8f

    #Unmapped address 0xf1b testing: random write/read operations
    #Address 0xf1b Write value 0x2c486f57
    li x3, 0x2c486f57
    csrw 0xf1b, x3

    #Address 0xf1b Write value 0x5c7d12bb
    li x3, 0x5c7d12bb
    csrw 0xf1b, x3

    #Address 0xf1b read value
    csrr x14, 0xf1b

    #Address 0xf1b Write value 0xd8ab58f4
    li x3, 0xd8ab58f4
    csrw 0xf1b, x3

    #Unmapped address 0xbf2 testing: random write/read operations
    #Address 0xbf2 read value
    csrr x14, 0xbf2

    #Address 0xbf2 read value
    csrr x14, 0xbf2

    #Address 0xbf2 Write value 0xf612d5fb
    li x3, 0xf612d5fb
    csrw 0xbf2, x3

    #Unmapped address 0xc60 testing: random write/read operations
    #Address 0xc60 Write value 0x1ab35e95
    li x3, 0x1ab35e95
    csrw 0xc60, x3

    #Address 0xc60 Write value 0x2747ef7b
    li x3, 0x2747ef7b
    csrw 0xc60, x3

    #Address 0xc60 Write value 0x15864fe1
    li x3, 0x15864fe1
    csrw 0xc60, x3

    #Unmapped address 0xda testing: random write/read operations
    #Address 0xda read value
    csrr x14, 0xda

    #Unmapped address 0x5f4 testing: random write/read operations
    #Address 0x5f4 Write value 0xc7d89074
    li x3, 0xc7d89074
    csrw 0x5f4, x3

    #Address 0x5f4 Write value 0x3b78d969
    li x3, 0x3b78d969
    csrw 0x5f4, x3

    #Address 0x5f4 read value
    csrr x14, 0x5f4

    #Unmapped address 0x8b7 testing: random write/read operations
    #Address 0x8b7 Write value 0xeee7552c
    li x3, 0xeee7552c
    csrw 0x8b7, x3

    #Address 0x8b7 Write value 0xeb3fa26d
    li x3, 0xeb3fa26d
    csrw 0x8b7, x3

    #Address 0x8b7 Write value 0xd379de93
    li x3, 0xd379de93
    csrw 0x8b7, x3

    #Address 0x8b7 read value
    csrr x14, 0x8b7

    #Address 0x8b7 Write value 0xd64f5512
    li x3, 0xd64f5512
    csrw 0x8b7, x3

    #Unmapped address 0x5d9 testing: random write/read operations
    #Address 0x5d9 Write value 0xa0c257e2
    li x3, 0xa0c257e2
    csrw 0x5d9, x3

    #Address 0x5d9 read value
    csrr x14, 0x5d9

    #Address 0x5d9 Write value 0x509c754
    li x3, 0x509c754
    csrw 0x5d9, x3

    #Address 0x5d9 read value
    csrr x14, 0x5d9

    #Unmapped address 0x56b testing: random write/read operations
    #Address 0x56b Write value 0x1f6b047e
    li x3, 0x1f6b047e
    csrw 0x56b, x3

    #Unmapped address 0x91a testing: random write/read operations
    #Address 0x91a read value
    csrr x14, 0x91a

    #Address 0x91a Write value 0x1a28d707
    li x3, 0x1a28d707
    csrw 0x91a, x3

    #Address 0x91a Write value 0xeeb739d7
    li x3, 0xeeb739d7
    csrw 0x91a, x3

    #Unmapped address 0x442 testing: random write/read operations
    #Address 0x442 read value
    csrr x14, 0x442

    #Address 0x442 read value
    csrr x14, 0x442

    #Unmapped address 0x34c testing: random write/read operations
    #Address 0x34c read value
    csrr x14, 0x34c

    #Unmapped address 0xe2c testing: random write/read operations
    #Address 0xe2c read value
    csrr x14, 0xe2c

    #Address 0xe2c read value
    csrr x14, 0xe2c

    #Address 0xe2c read value
    csrr x14, 0xe2c

    #Unmapped address 0xd1c testing: random write/read operations
    #Address 0xd1c read value
    csrr x14, 0xd1c

    #Address 0xd1c Write value 0x24fd36a1
    li x3, 0x24fd36a1
    csrw 0xd1c, x3

    #Address 0xd1c Write value 0x34b5b6c6
    li x3, 0x34b5b6c6
    csrw 0xd1c, x3

    #Unmapped address 0xd6c testing: random write/read operations
    #Address 0xd6c read value
    csrr x14, 0xd6c

    #Address 0xd6c read value
    csrr x14, 0xd6c

    #Unmapped address 0xa2f testing: random write/read operations
    #Address 0xa2f Write value 0xea0140be
    li x3, 0xea0140be
    csrw 0xa2f, x3

    #Address 0xa2f read value
    csrr x14, 0xa2f

    #Address 0xa2f Write value 0xe83faa96
    li x3, 0xe83faa96
    csrw 0xa2f, x3

    #Address 0xa2f read value
    csrr x14, 0xa2f

    #Mapped address 0x340 (mscratch) testing: random write/read operations
    #Address 0x340 Write value 0xb4946c93
    li x3, 0xb4946c93
    csrw 0x340, x3

    #Mapped address 0xb10 (mhpmcounter16) testing: random write/read operations
    #Address 0xb10 read value
    csrr x14, 0xb10

    #Address 0xb10 Write value 0xb6d114a5
    li x3, 0xb6d114a5
    csrw 0xb10, x3

    #Address 0xb10 read value
    csrr x14, 0xb10

    #Address 0xb10 Write value 0x5abf4e5a
    li x3, 0x5abf4e5a
    csrw 0xb10, x3

    #Address 0xb10 read value
    csrr x14, 0xb10

    #Unmapped address 0xfed testing: random write/read operations
    #Address 0xfed Write value 0x337ff0c5
    li x3, 0x337ff0c5
    csrw 0xfed, x3

    #Address 0xfed read value
    csrr x14, 0xfed

    #Address 0xfed Write value 0x16fe6a13
    li x3, 0x16fe6a13
    csrw 0xfed, x3

    #Unmapped address 0x5ca testing: random write/read operations
    #Address 0x5ca Write value 0x15452bf0
    li x3, 0x15452bf0
    csrw 0x5ca, x3

    #Address 0x5ca read value
    csrr x14, 0x5ca

    #Unmapped address 0xf35 testing: random write/read operations
    #Address 0xf35 Write value 0x9acfec5
    li x3, 0x9acfec5
    csrw 0xf35, x3

    #Address 0xf35 read value
    csrr x14, 0xf35

    #Unmapped address 0xe8e testing: random write/read operations
    #Address 0xe8e Write value 0x4a03cd13
    li x3, 0x4a03cd13
    csrw 0xe8e, x3

    #Unmapped address 0xcd5 testing: random write/read operations
    #Address 0xcd5 Write value 0xc4c32159
    li x3, 0xc4c32159
    csrw 0xcd5, x3

    #Address 0xcd5 read value
    csrr x14, 0xcd5

    #Unmapped address 0xeba testing: random write/read operations
    #Address 0xeba read value
    csrr x14, 0xeba

    #Address 0xeba Write value 0xc4e08eae
    li x3, 0xc4e08eae
    csrw 0xeba, x3

    #Address 0xeba Write value 0x48bee403
    li x3, 0x48bee403
    csrw 0xeba, x3

    #Address 0xeba read value
    csrr x14, 0xeba

    #Unmapped address 0x46c testing: random write/read operations
    #Address 0x46c Write value 0xe409b9be
    li x3, 0xe409b9be
    csrw 0x46c, x3

    #Address 0x46c Write value 0xbd4418a4
    li x3, 0xbd4418a4
    csrw 0x46c, x3

    #Address 0x46c read value
    csrr x14, 0x46c

    #Address 0x46c Write value 0xc15224f9
    li x3, 0xc15224f9
    csrw 0x46c, x3

    #Unmapped address 0x229 testing: random write/read operations
    #Address 0x229 Write value 0xb9a459bb
    li x3, 0xb9a459bb
    csrw 0x229, x3

    #Address 0x229 Write value 0x47218213
    li x3, 0x47218213
    csrw 0x229, x3

    #Address 0x229 read value
    csrr x14, 0x229

    #Address 0x229 Write value 0x8fa7dca1
    li x3, 0x8fa7dca1
    csrw 0x229, x3

    #Address 0x229 Write value 0x52735add
    li x3, 0x52735add
    csrw 0x229, x3

    #Unmapped address 0x176 testing: random write/read operations
    #Address 0x176 Write value 0x4f5e3480
    li x3, 0x4f5e3480
    csrw 0x176, x3

    #Address 0x176 Write value 0x40298299
    li x3, 0x40298299
    csrw 0x176, x3

    #Unmapped address 0x425 testing: random write/read operations
    #Address 0x425 Write value 0xed12a045
    li x3, 0xed12a045
    csrw 0x425, x3

    #Address 0x425 read value
    csrr x14, 0x425

    #Address 0x425 Write value 0xc4d6d185
    li x3, 0xc4d6d185
    csrw 0x425, x3

    #Address 0x425 read value
    csrr x14, 0x425

    #Address 0x425 read value
    csrr x14, 0x425

    #Unmapped address 0x61f testing: random write/read operations
    #Address 0x61f Write value 0x304b95c4
    li x3, 0x304b95c4
    csrw 0x61f, x3

    #Address 0x61f read value
    csrr x14, 0x61f

    #Unmapped address 0x189 testing: random write/read operations
    #Address 0x189 read value
    csrr x14, 0x189

    #Address 0x189 read value
    csrr x14, 0x189

    #Unmapped address 0x8a3 testing: random write/read operations
    #Address 0x8a3 read value
    csrr x14, 0x8a3

    #Address 0x8a3 read value
    csrr x14, 0x8a3

    #Address 0x8a3 Write value 0x67050b4c
    li x3, 0x67050b4c
    csrw 0x8a3, x3

    #Address 0x8a3 read value
    csrr x14, 0x8a3

    #Unmapped address 0x772 testing: random write/read operations
    #Address 0x772 read value
    csrr x14, 0x772

    #Address 0x772 Write value 0xf62048ea
    li x3, 0xf62048ea
    csrw 0x772, x3

    #Address 0x772 Write value 0x37c08b5d
    li x3, 0x37c08b5d
    csrw 0x772, x3

    #Address 0x772 Write value 0x58c55292
    li x3, 0x58c55292
    csrw 0x772, x3

    #Address 0x772 read value
    csrr x14, 0x772

    #Unmapped address 0xf5a testing: random write/read operations
    #Address 0xf5a read value
    csrr x14, 0xf5a

    #Address 0xf5a read value
    csrr x14, 0xf5a

    #Address 0xf5a Write value 0xb359ebde
    li x3, 0xb359ebde
    csrw 0xf5a, x3

    #Address 0xf5a read value
    csrr x14, 0xf5a

    #Address 0xf5a Write value 0x47679344
    li x3, 0x47679344
    csrw 0xf5a, x3

    #Unmapped address 0x5b5 testing: random write/read operations
    #Address 0x5b5 read value
    csrr x14, 0x5b5

    #Unmapped address 0xbec testing: random write/read operations
    #Address 0xbec Write value 0xe6240b10
    li x3, 0xe6240b10
    csrw 0xbec, x3

    #Address 0xbec Write value 0x335cbab9
    li x3, 0x335cbab9
    csrw 0xbec, x3

    #Unmapped address 0x833 testing: random write/read operations
    #Address 0x833 read value
    csrr x14, 0x833

    #Address 0x833 Write value 0x295545bb
    li x3, 0x295545bb
    csrw 0x833, x3

    #Address 0x833 read value
    csrr x14, 0x833

    #Address 0x833 Write value 0x339e62e2
    li x3, 0x339e62e2
    csrw 0x833, x3

    #Unmapped address 0x69b testing: random write/read operations
    #Address 0x69b read value
    csrr x14, 0x69b

    #Address 0x69b read value
    csrr x14, 0x69b

    #Address 0x69b read value
    csrr x14, 0x69b

    #Address 0x69b read value
    csrr x14, 0x69b

    #Address 0x69b read value
    csrr x14, 0x69b

    #Unmapped address 0x741 testing: random write/read operations
    #Address 0x741 read value
    csrr x14, 0x741

    #Address 0x741 Write value 0x1edb6a02
    li x3, 0x1edb6a02
    csrw 0x741, x3

    #Address 0x741 read value
    csrr x14, 0x741

    #Unmapped address 0x29d testing: random write/read operations
    #Address 0x29d Write value 0x660aafb8
    li x3, 0x660aafb8
    csrw 0x29d, x3

    #Address 0x29d Write value 0xb0ae28c4
    li x3, 0xb0ae28c4
    csrw 0x29d, x3

    #Address 0x29d Write value 0xf140acf4
    li x3, 0xf140acf4
    csrw 0x29d, x3

    #Address 0x29d read value
    csrr x14, 0x29d

    #Unmapped address 0x945 testing: random write/read operations
    #Address 0x945 Write value 0xd0f38ee4
    li x3, 0xd0f38ee4
    csrw 0x945, x3

    #Address 0x945 read value
    csrr x14, 0x945

    #Address 0x945 Write value 0x579ae8b5
    li x3, 0x579ae8b5
    csrw 0x945, x3

    #Address 0x945 read value
    csrr x14, 0x945

    #Unmapped address 0xcd6 testing: random write/read operations
    #Address 0xcd6 read value
    csrr x14, 0xcd6

    #Address 0xcd6 Write value 0xea3d5055
    li x3, 0xea3d5055
    csrw 0xcd6, x3

    #Address 0xcd6 Write value 0xbb46b90d
    li x3, 0xbb46b90d
    csrw 0xcd6, x3

    #Unmapped address 0x267 testing: random write/read operations
    #Address 0x267 Write value 0x41eb122
    li x3, 0x41eb122
    csrw 0x267, x3

    #Address 0x267 read value
    csrr x14, 0x267

    #Unmapped address 0x749 testing: random write/read operations
    #Address 0x749 read value
    csrr x14, 0x749

    #Address 0x749 read value
    csrr x14, 0x749

    #Address 0x749 read value
    csrr x14, 0x749

    #Unmapped address 0x3af testing: random write/read operations
    #Address 0x3af read value
    csrr x14, 0x3af

    #Address 0x3af read value
    csrr x14, 0x3af

    #Address 0x3af Write value 0x1434ddef
    li x3, 0x1434ddef
    csrw 0x3af, x3

    #Address 0x3af read value
    csrr x14, 0x3af

    #Unmapped address 0xd00 testing: random write/read operations
    #Address 0xd00 Write value 0x53cf07f4
    li x3, 0x53cf07f4
    csrw 0xd00, x3

    #Address 0xd00 Write value 0x908d31d1
    li x3, 0x908d31d1
    csrw 0xd00, x3

    #Unmapped address 0xb56 testing: random write/read operations
    #Address 0xb56 Write value 0x74d9256
    li x3, 0x74d9256
    csrw 0xb56, x3

    #Address 0xb56 read value
    csrr x14, 0xb56

    #Address 0xb56 read value
    csrr x14, 0xb56

    #Unmapped address 0xb72 testing: random write/read operations
    #Address 0xb72 read value
    csrr x14, 0xb72

    #Unmapped address 0x867 testing: random write/read operations
    #Address 0x867 Write value 0x253acf9f
    li x3, 0x253acf9f
    csrw 0x867, x3

    #Address 0x867 Write value 0x5067fe71
    li x3, 0x5067fe71
    csrw 0x867, x3

    #Address 0x867 Write value 0x66e35e25
    li x3, 0x66e35e25
    csrw 0x867, x3

    #Unmapped address 0x512 testing: random write/read operations
    #Address 0x512 read value
    csrr x14, 0x512

    #Address 0x512 read value
    csrr x14, 0x512

    #Address 0x512 read value
    csrr x14, 0x512

    #Address 0x512 Write value 0x1bf344f2
    li x3, 0x1bf344f2
    csrw 0x512, x3

    #Address 0x512 Write value 0x92e40ea
    li x3, 0x92e40ea
    csrw 0x512, x3

    #Unmapped address 0xd0d testing: random write/read operations
    #Address 0xd0d read value
    csrr x14, 0xd0d

    #Address 0xd0d Write value 0x8dbbfc5b
    li x3, 0x8dbbfc5b
    csrw 0xd0d, x3

    #Address 0xd0d Write value 0xb26b069e
    li x3, 0xb26b069e
    csrw 0xd0d, x3

    #Address 0xd0d Write value 0xae4fbd16
    li x3, 0xae4fbd16
    csrw 0xd0d, x3

    #Unmapped address 0x8ee testing: random write/read operations
    #Address 0x8ee Write value 0x2b932b8a
    li x3, 0x2b932b8a
    csrw 0x8ee, x3

    #Address 0x8ee Write value 0x45de44a
    li x3, 0x45de44a
    csrw 0x8ee, x3

    #Address 0x8ee read value
    csrr x14, 0x8ee

    #Address 0x8ee read value
    csrr x14, 0x8ee

    #Address 0x8ee Write value 0xeaa2ae2e
    li x3, 0xeaa2ae2e
    csrw 0x8ee, x3

    #Unmapped address 0xdcb testing: random write/read operations
    #Address 0xdcb read value
    csrr x14, 0xdcb

    #Address 0xdcb Write value 0x8f61d8bf
    li x3, 0x8f61d8bf
    csrw 0xdcb, x3

    #Address 0xdcb Write value 0x13a1f405
    li x3, 0x13a1f405
    csrw 0xdcb, x3

    #Unmapped address 0x647 testing: random write/read operations
    #Address 0x647 Write value 0xa54dbd99
    li x3, 0xa54dbd99
    csrw 0x647, x3

    #Address 0x647 Write value 0xfb0b1a01
    li x3, 0xfb0b1a01
    csrw 0x647, x3

    #Address 0x647 Write value 0x22e5c3c9
    li x3, 0x22e5c3c9
    csrw 0x647, x3

    #Unmapped address 0x588 testing: random write/read operations
    #Address 0x588 read value
    csrr x14, 0x588

    #Address 0x588 Write value 0x52739f51
    li x3, 0x52739f51
    csrw 0x588, x3

    #Address 0x588 Write value 0xde67243c
    li x3, 0xde67243c
    csrw 0x588, x3

    #Address 0x588 Write value 0xc816cbe9
    li x3, 0xc816cbe9
    csrw 0x588, x3

    #Unmapped address 0xbd2 testing: random write/read operations
    #Address 0xbd2 Write value 0xc277f39a
    li x3, 0xc277f39a
    csrw 0xbd2, x3

    #Address 0xbd2 Write value 0x30022836
    li x3, 0x30022836
    csrw 0xbd2, x3

    #Address 0xbd2 read value
    csrr x14, 0xbd2

    #Address 0xbd2 Write value 0x6dca898c
    li x3, 0x6dca898c
    csrw 0xbd2, x3

    #Address 0xbd2 Write value 0xe67d11b7
    li x3, 0xe67d11b7
    csrw 0xbd2, x3

    #Unmapped address 0x70c testing: random write/read operations
    #Address 0x70c Write value 0xcf2d67de
    li x3, 0xcf2d67de
    csrw 0x70c, x3

    #Address 0x70c read value
    csrr x14, 0x70c

    #Address 0x70c Write value 0x52e409d2
    li x3, 0x52e409d2
    csrw 0x70c, x3

    #Address 0x70c Write value 0x494d6a05
    li x3, 0x494d6a05
    csrw 0x70c, x3

    #Unmapped address 0x6e4 testing: random write/read operations
    #Address 0x6e4 Write value 0xff77af51
    li x3, 0xff77af51
    csrw 0x6e4, x3

    #Address 0x6e4 read value
    csrr x14, 0x6e4

    #Unmapped address 0xf8 testing: random write/read operations
    #Address 0xf8 Write value 0x9c7f7e7f
    li x3, 0x9c7f7e7f
    csrw 0xf8, x3

    #Address 0xf8 read value
    csrr x14, 0xf8

    #Unmapped address 0x778 testing: random write/read operations
    #Address 0x778 Write value 0xa8a75db7
    li x3, 0xa8a75db7
    csrw 0x778, x3

    #Address 0x778 Write value 0xaefa7b4e
    li x3, 0xaefa7b4e
    csrw 0x778, x3

    #Address 0x778 read value
    csrr x14, 0x778

    #Address 0x778 Write value 0xf47fd18d
    li x3, 0xf47fd18d
    csrw 0x778, x3

    #Address 0x778 read value
    csrr x14, 0x778

    #Unmapped address 0x603 testing: random write/read operations
    #Address 0x603 read value
    csrr x14, 0x603

    #Address 0x603 Write value 0xd132c554
    li x3, 0xd132c554
    csrw 0x603, x3

    #Address 0x603 read value
    csrr x14, 0x603

    #Address 0x603 Write value 0x6863700a
    li x3, 0x6863700a
    csrw 0x603, x3

    #Unmapped address 0x20b testing: random write/read operations
    #Address 0x20b read value
    csrr x14, 0x20b

    #Address 0x20b read value
    csrr x14, 0x20b

    #Address 0x20b read value
    csrr x14, 0x20b

    #Unmapped address 0x699 testing: random write/read operations
    #Address 0x699 read value
    csrr x14, 0x699

    #Address 0x699 read value
    csrr x14, 0x699

    #Address 0x699 read value
    csrr x14, 0x699

    #Unmapped address 0xa16 testing: random write/read operations
    #Address 0xa16 read value
    csrr x14, 0xa16

    #Address 0xa16 read value
    csrr x14, 0xa16

    #Address 0xa16 Write value 0xa4eda8f0
    li x3, 0xa4eda8f0
    csrw 0xa16, x3

    #Address 0xa16 read value
    csrr x14, 0xa16

    #Address 0xa16 read value
    csrr x14, 0xa16

    #Unmapped address 0x3eb testing: random write/read operations
    #Address 0x3eb read value
    csrr x14, 0x3eb

    #Address 0x3eb Write value 0x93331f30
    li x3, 0x93331f30
    csrw 0x3eb, x3

    #Unmapped address 0x9b9 testing: random write/read operations
    #Address 0x9b9 Write value 0x64ee96dd
    li x3, 0x64ee96dd
    csrw 0x9b9, x3

    #Address 0x9b9 read value
    csrr x14, 0x9b9

    #Address 0x9b9 read value
    csrr x14, 0x9b9

    #Unmapped address 0x3f4 testing: random write/read operations
    #Address 0x3f4 Write value 0x398749c6
    li x3, 0x398749c6
    csrw 0x3f4, x3

    #Address 0x3f4 Write value 0xac252a7c
    li x3, 0xac252a7c
    csrw 0x3f4, x3

    #Address 0x3f4 Write value 0xa987508e
    li x3, 0xa987508e
    csrw 0x3f4, x3

    #Address 0x3f4 Write value 0x6c821610
    li x3, 0x6c821610
    csrw 0x3f4, x3

    #Address 0x3f4 Write value 0x88ca97fe
    li x3, 0x88ca97fe
    csrw 0x3f4, x3

    #Unmapped address 0x4ce testing: random write/read operations
    #Address 0x4ce Write value 0xd78e621
    li x3, 0xd78e621
    csrw 0x4ce, x3

    #Unmapped address 0x573 testing: random write/read operations
    #Address 0x573 Write value 0x38039bbb
    li x3, 0x38039bbb
    csrw 0x573, x3

    #Address 0x573 read value
    csrr x14, 0x573

    #Address 0x573 read value
    csrr x14, 0x573

    #Unmapped address 0xda4 testing: random write/read operations
    #Address 0xda4 read value
    csrr x14, 0xda4

    #Unmapped address 0x1f testing: random write/read operations
    #Address 0x1f read value
    csrr x14, 0x1f

    #Unmapped address 0x166 testing: random write/read operations
    #Address 0x166 read value
    csrr x14, 0x166

    #Address 0x166 Write value 0x9e5e1840
    li x3, 0x9e5e1840
    csrw 0x166, x3

    #Address 0x166 read value
    csrr x14, 0x166

    #Address 0x166 Write value 0x97509be8
    li x3, 0x97509be8
    csrw 0x166, x3

    #Address 0x166 read value
    csrr x14, 0x166

    #Unmapped address 0xc67 testing: random write/read operations
    #Address 0xc67 read value
    csrr x14, 0xc67

    #Unmapped address 0x269 testing: random write/read operations
    #Address 0x269 read value
    csrr x14, 0x269

    #Address 0x269 Write value 0x7feca3aa
    li x3, 0x7feca3aa
    csrw 0x269, x3

    #Unmapped address 0xdcd testing: random write/read operations
    #Address 0xdcd Write value 0xcd634e66
    li x3, 0xcd634e66
    csrw 0xdcd, x3

    #Unmapped address 0x97e testing: random write/read operations
    #Address 0x97e Write value 0xcbf1fe4d
    li x3, 0xcbf1fe4d
    csrw 0x97e, x3

    #Unmapped address 0x85 testing: random write/read operations
    #Address 0x85 Write value 0x2d94dd76
    li x3, 0x2d94dd76
    csrw 0x85, x3

    #Unmapped address 0xe5d testing: random write/read operations
    #Address 0xe5d Write value 0xc97b1b26
    li x3, 0xc97b1b26
    csrw 0xe5d, x3

    #Address 0xe5d Write value 0x1ddc302a
    li x3, 0x1ddc302a
    csrw 0xe5d, x3

    #Address 0xe5d read value
    csrr x14, 0xe5d

    #Unmapped address 0xfc5 testing: random write/read operations
    #Address 0xfc5 read value
    csrr x14, 0xfc5

    #Address 0xfc5 Write value 0xb073dcb
    li x3, 0xb073dcb
    csrw 0xfc5, x3

    #Address 0xfc5 Write value 0x45a76fb4
    li x3, 0x45a76fb4
    csrw 0xfc5, x3

    #Unmapped address 0xb2c testing: random write/read operations
    #Address 0xb2c Write value 0xd00c3efa
    li x3, 0xd00c3efa
    csrw 0xb2c, x3

    #Unmapped address 0x262 testing: random write/read operations
    #Address 0x262 Write value 0xfd45d10e
    li x3, 0xfd45d10e
    csrw 0x262, x3

    #Address 0x262 read value
    csrr x14, 0x262

    #Address 0x262 Write value 0x6bc6e6c4
    li x3, 0x6bc6e6c4
    csrw 0x262, x3

    #Address 0x262 Write value 0xec590710
    li x3, 0xec590710
    csrw 0x262, x3

    #Unmapped address 0x254 testing: random write/read operations
    #Address 0x254 Write value 0x9d1c84f7
    li x3, 0x9d1c84f7
    csrw 0x254, x3

    #Address 0x254 Write value 0x1d7a34a6
    li x3, 0x1d7a34a6
    csrw 0x254, x3

    #Unmapped address 0x3aa testing: random write/read operations
    #Address 0x3aa Write value 0x53bac6fb
    li x3, 0x53bac6fb
    csrw 0x3aa, x3

    #Address 0x3aa Write value 0x23df38cb
    li x3, 0x23df38cb
    csrw 0x3aa, x3

    #Address 0x3aa read value
    csrr x14, 0x3aa

    #Address 0x3aa Write value 0x38de36b2
    li x3, 0x38de36b2
    csrw 0x3aa, x3

    #Address 0x3aa read value
    csrr x14, 0x3aa

    #Unmapped address 0x81 testing: random write/read operations
    #Address 0x81 Write value 0xb9f5073f
    li x3, 0xb9f5073f
    csrw 0x81, x3

    #Address 0x81 Write value 0x1635baa
    li x3, 0x1635baa
    csrw 0x81, x3

    #Unmapped address 0xf30 testing: random write/read operations
    #Address 0xf30 Write value 0xe39c671e
    li x3, 0xe39c671e
    csrw 0xf30, x3

    #Address 0xf30 read value
    csrr x14, 0xf30

    #Address 0xf30 Write value 0xe0963292
    li x3, 0xe0963292
    csrw 0xf30, x3

    #Address 0xf30 Write value 0x479ed67d
    li x3, 0x479ed67d
    csrw 0xf30, x3

    #Unmapped address 0x172 testing: random write/read operations
    #Address 0x172 read value
    csrr x14, 0x172

    #Address 0x172 Write value 0xf45de12a
    li x3, 0xf45de12a
    csrw 0x172, x3

    #Address 0x172 read value
    csrr x14, 0x172

    #Address 0x172 read value
    csrr x14, 0x172

    #Address 0x172 Write value 0xea119e76
    li x3, 0xea119e76
    csrw 0x172, x3

    #Unmapped address 0x794 testing: random write/read operations
    #Address 0x794 Write value 0xe2af5fda
    li x3, 0xe2af5fda
    csrw 0x794, x3

    #Address 0x794 Write value 0x4944866e
    li x3, 0x4944866e
    csrw 0x794, x3

    #Address 0x794 read value
    csrr x14, 0x794

    #Address 0x794 read value
    csrr x14, 0x794

    #Address 0x794 read value
    csrr x14, 0x794

    #Unmapped address 0xa54 testing: random write/read operations
    #Address 0xa54 Write value 0x83e97979
    li x3, 0x83e97979
    csrw 0xa54, x3

    #Address 0xa54 Write value 0xd25f39f4
    li x3, 0xd25f39f4
    csrw 0xa54, x3

    #Address 0xa54 read value
    csrr x14, 0xa54

    #Unmapped address 0xc63 testing: random write/read operations
    #Address 0xc63 Write value 0xa9a9e50a
    li x3, 0xa9a9e50a
    csrw 0xc63, x3

    #Address 0xc63 read value
    csrr x14, 0xc63

    #Unmapped address 0x4fb testing: random write/read operations
    #Address 0x4fb read value
    csrr x14, 0x4fb

    #Address 0x4fb Write value 0x321d4e7f
    li x3, 0x321d4e7f
    csrw 0x4fb, x3

    #Address 0x4fb read value
    csrr x14, 0x4fb

    #Address 0x4fb Write value 0x6b3a87a3
    li x3, 0x6b3a87a3
    csrw 0x4fb, x3

    #Address 0x4fb read value
    csrr x14, 0x4fb

    #Unmapped address 0x223 testing: random write/read operations
    #Address 0x223 read value
    csrr x14, 0x223

    #Unmapped address 0x14f testing: random write/read operations
    #Address 0x14f Write value 0x94e15da4
    li x3, 0x94e15da4
    csrw 0x14f, x3

    #Unmapped address 0xa27 testing: random write/read operations
    #Address 0xa27 read value
    csrr x14, 0xa27

    #Address 0xa27 read value
    csrr x14, 0xa27

    #Address 0xa27 Write value 0x7b0d13be
    li x3, 0x7b0d13be
    csrw 0xa27, x3

    #Address 0xa27 Write value 0x74958a5b
    li x3, 0x74958a5b
    csrw 0xa27, x3

    #Address 0xa27 Write value 0x4c39e455
    li x3, 0x4c39e455
    csrw 0xa27, x3

    #Unmapped address 0xd3d testing: random write/read operations
    #Address 0xd3d read value
    csrr x14, 0xd3d

    #Address 0xd3d Write value 0x4b763283
    li x3, 0x4b763283
    csrw 0xd3d, x3

    #Address 0xd3d read value
    csrr x14, 0xd3d

    #Address 0xd3d Write value 0x573d053f
    li x3, 0x573d053f
    csrw 0xd3d, x3

    #Unmapped address 0xa1b testing: random write/read operations
    #Address 0xa1b Write value 0x9dc0330e
    li x3, 0x9dc0330e
    csrw 0xa1b, x3

    #Address 0xa1b read value
    csrr x14, 0xa1b

    #Unmapped address 0xa0a testing: random write/read operations
    #Address 0xa0a read value
    csrr x14, 0xa0a

    #Address 0xa0a read value
    csrr x14, 0xa0a

    #Address 0xa0a Write value 0x91b1c510
    li x3, 0x91b1c510
    csrw 0xa0a, x3

    #Address 0xa0a Write value 0x5a796237
    li x3, 0x5a796237
    csrw 0xa0a, x3

    #Address 0xa0a Write value 0xae2cff63
    li x3, 0xae2cff63
    csrw 0xa0a, x3

    #Unmapped address 0x983 testing: random write/read operations
    #Address 0x983 read value
    csrr x14, 0x983

    #Address 0x983 Write value 0x9e07a70a
    li x3, 0x9e07a70a
    csrw 0x983, x3

    #Address 0x983 Write value 0x3f855a38
    li x3, 0x3f855a38
    csrw 0x983, x3

    #Unmapped address 0xfc4 testing: random write/read operations
    #Address 0xfc4 read value
    csrr x14, 0xfc4

    #Address 0xfc4 read value
    csrr x14, 0xfc4

    #Address 0xfc4 read value
    csrr x14, 0xfc4

    #Address 0xfc4 read value
    csrr x14, 0xfc4

    #Address 0xfc4 read value
    csrr x14, 0xfc4

    #Unmapped address 0xae9 testing: random write/read operations
    #Address 0xae9 Write value 0xb44a2ccb
    li x3, 0xb44a2ccb
    csrw 0xae9, x3

    #Address 0xae9 Write value 0x2fb15b48
    li x3, 0x2fb15b48
    csrw 0xae9, x3

    #Address 0xae9 read value
    csrr x14, 0xae9

    #Unmapped address 0x968 testing: random write/read operations
    #Address 0x968 read value
    csrr x14, 0x968

    #Address 0x968 read value
    csrr x14, 0x968

    #Address 0x968 read value
    csrr x14, 0x968

    #Address 0x968 Write value 0xb951ff6
    li x3, 0xb951ff6
    csrw 0x968, x3

    #Unmapped address 0xb25 testing: random write/read operations
    #Address 0xb25 read value
    csrr x14, 0xb25

    #Unmapped address 0xac9 testing: random write/read operations
    #Address 0xac9 Write value 0x4299dfad
    li x3, 0x4299dfad
    csrw 0xac9, x3

    #Address 0xac9 Write value 0xcff93afa
    li x3, 0xcff93afa
    csrw 0xac9, x3

    #Address 0xac9 read value
    csrr x14, 0xac9

    #Address 0xac9 Write value 0xfa7c857c
    li x3, 0xfa7c857c
    csrw 0xac9, x3

    #Address 0xac9 read value
    csrr x14, 0xac9

    #Unmapped address 0x39 testing: random write/read operations
    #Address 0x39 read value
    csrr x14, 0x39

    #Unmapped address 0xb5e testing: random write/read operations
    #Address 0xb5e Write value 0x70f7fd03
    li x3, 0x70f7fd03
    csrw 0xb5e, x3

    #Unmapped address 0xcbe testing: random write/read operations
    #Address 0xcbe read value
    csrr x14, 0xcbe

    #Address 0xcbe Write value 0xf1375a83
    li x3, 0xf1375a83
    csrw 0xcbe, x3

    #Address 0xcbe Write value 0x1f8391ce
    li x3, 0x1f8391ce
    csrw 0xcbe, x3

    #Unmapped address 0xf2e testing: random write/read operations
    #Address 0xf2e read value
    csrr x14, 0xf2e

    #Unmapped address 0x580 testing: random write/read operations
    #Address 0x580 read value
    csrr x14, 0x580

    #Address 0x580 Write value 0x94b97417
    li x3, 0x94b97417
    csrw 0x580, x3

    #Unmapped address 0xde8 testing: random write/read operations
    #Address 0xde8 Write value 0x99d7edca
    li x3, 0x99d7edca
    csrw 0xde8, x3

    #Address 0xde8 Write value 0x33706eea
    li x3, 0x33706eea
    csrw 0xde8, x3

    #Address 0xde8 read value
    csrr x14, 0xde8

    #Unmapped address 0xfb9 testing: random write/read operations
    #Address 0xfb9 read value
    csrr x14, 0xfb9

    #Address 0xfb9 read value
    csrr x14, 0xfb9

    #Unmapped address 0x25f testing: random write/read operations
    #Address 0x25f Write value 0x5c8929e1
    li x3, 0x5c8929e1
    csrw 0x25f, x3

    #Address 0x25f Write value 0xb74ac012
    li x3, 0xb74ac012
    csrw 0x25f, x3

    #Address 0x25f read value
    csrr x14, 0x25f

    #Address 0x25f read value
    csrr x14, 0x25f

    #Address 0x25f Write value 0xe9e47144
    li x3, 0xe9e47144
    csrw 0x25f, x3

    #Unmapped address 0x207 testing: random write/read operations
    #Address 0x207 Write value 0xf95e5bdc
    li x3, 0xf95e5bdc
    csrw 0x207, x3

    #Address 0x207 Write value 0xa86387b4
    li x3, 0xa86387b4
    csrw 0x207, x3

    #Address 0x207 read value
    csrr x14, 0x207

    #Address 0x207 read value
    csrr x14, 0x207

    #Unmapped address 0x18c testing: random write/read operations
    #Address 0x18c Write value 0x9c68d929
    li x3, 0x9c68d929
    csrw 0x18c, x3

    #Address 0x18c Write value 0x40cc1083
    li x3, 0x40cc1083
    csrw 0x18c, x3

    #Address 0x18c read value
    csrr x14, 0x18c

    #Address 0x18c read value
    csrr x14, 0x18c

    #Unmapped address 0x89e testing: random write/read operations
    #Address 0x89e Write value 0x56be247
    li x3, 0x56be247
    csrw 0x89e, x3

    #Address 0x89e Write value 0x27a44d45
    li x3, 0x27a44d45
    csrw 0x89e, x3

    #Address 0x89e Write value 0xa3f8bd25
    li x3, 0xa3f8bd25
    csrw 0x89e, x3

    #Address 0x89e Write value 0xc7f6a6ce
    li x3, 0xc7f6a6ce
    csrw 0x89e, x3

    #Address 0x89e Write value 0x4d580076
    li x3, 0x4d580076
    csrw 0x89e, x3

    #Unmapped address 0x8c1 testing: random write/read operations
    #Address 0x8c1 read value
    csrr x14, 0x8c1

    #Address 0x8c1 Write value 0x92680b39
    li x3, 0x92680b39
    csrw 0x8c1, x3

    #Address 0x8c1 read value
    csrr x14, 0x8c1

    #Address 0x8c1 read value
    csrr x14, 0x8c1

    #Unmapped address 0xcc0 testing: random write/read operations
    #Address 0xcc0 read value
    csrr x14, 0xcc0

    #Address 0xcc0 read value
    csrr x14, 0xcc0

    #Address 0xcc0 read value
    csrr x14, 0xcc0

    #Unmapped address 0x40a testing: random write/read operations
    #Address 0x40a Write value 0x22edf424
    li x3, 0x22edf424
    csrw 0x40a, x3

    #Address 0x40a Write value 0xb81d5796
    li x3, 0xb81d5796
    csrw 0x40a, x3

    #Unmapped address 0x836 testing: random write/read operations
    #Address 0x836 read value
    csrr x14, 0x836

    #Address 0x836 Write value 0xd57339c8
    li x3, 0xd57339c8
    csrw 0x836, x3

    #Unmapped address 0x4ca testing: random write/read operations
    #Address 0x4ca Write value 0xd77d369f
    li x3, 0xd77d369f
    csrw 0x4ca, x3

    #Address 0x4ca read value
    csrr x14, 0x4ca

    #Address 0x4ca read value
    csrr x14, 0x4ca

    #Unmapped address 0xdde testing: random write/read operations
    #Address 0xdde Write value 0xf55fc378
    li x3, 0xf55fc378
    csrw 0xdde, x3

    #Unmapped address 0x577 testing: random write/read operations
    #Address 0x577 Write value 0x27e3c440
    li x3, 0x27e3c440
    csrw 0x577, x3

    #Address 0x577 Write value 0xa8c9dc97
    li x3, 0xa8c9dc97
    csrw 0x577, x3

    #Address 0x577 Write value 0x2b9a9b69
    li x3, 0x2b9a9b69
    csrw 0x577, x3

    #Unmapped address 0xdd1 testing: random write/read operations
    #Address 0xdd1 read value
    csrr x14, 0xdd1

    #Address 0xdd1 Write value 0xa597c79b
    li x3, 0xa597c79b
    csrw 0xdd1, x3

    #Address 0xdd1 read value
    csrr x14, 0xdd1

    #Address 0xdd1 read value
    csrr x14, 0xdd1

    #Address 0xdd1 read value
    csrr x14, 0xdd1

    #Unmapped address 0x146 testing: random write/read operations
    #Address 0x146 Write value 0x32500994
    li x3, 0x32500994
    csrw 0x146, x3

    #Unmapped address 0x558 testing: random write/read operations
    #Address 0x558 read value
    csrr x14, 0x558

    #Unmapped address 0xdc9 testing: random write/read operations
    #Address 0xdc9 Write value 0x9f563b2
    li x3, 0x9f563b2
    csrw 0xdc9, x3

    #Address 0xdc9 Write value 0xc6156a9
    li x3, 0xc6156a9
    csrw 0xdc9, x3

    #Address 0xdc9 Write value 0x3e67a3f4
    li x3, 0x3e67a3f4
    csrw 0xdc9, x3

    #Address 0xdc9 read value
    csrr x14, 0xdc9

    #Unmapped address 0x65 testing: random write/read operations
    #Address 0x65 read value
    csrr x14, 0x65

    #Address 0x65 Write value 0x5f0170cd
    li x3, 0x5f0170cd
    csrw 0x65, x3

    #Address 0x65 Write value 0xaab421a5
    li x3, 0xaab421a5
    csrw 0x65, x3

    #Address 0x65 Write value 0xcac23da2
    li x3, 0xcac23da2
    csrw 0x65, x3

    #Unmapped address 0xe4c testing: random write/read operations
    #Address 0xe4c read value
    csrr x14, 0xe4c

    #Unmapped address 0x2ee testing: random write/read operations
    #Address 0x2ee Write value 0x99cc44b3
    li x3, 0x99cc44b3
    csrw 0x2ee, x3

    #Address 0x2ee Write value 0xf8f19022
    li x3, 0xf8f19022
    csrw 0x2ee, x3

    #Address 0x2ee Write value 0xb4c63314
    li x3, 0xb4c63314
    csrw 0x2ee, x3

    #Address 0x2ee Write value 0x75deeb2e
    li x3, 0x75deeb2e
    csrw 0x2ee, x3

    #Unmapped address 0x213 testing: random write/read operations
    #Address 0x213 read value
    csrr x14, 0x213

    #Address 0x213 Write value 0x2e874f6b
    li x3, 0x2e874f6b
    csrw 0x213, x3

    #Unmapped address 0xc4c testing: random write/read operations
    #Address 0xc4c read value
    csrr x14, 0xc4c

    #Unmapped address 0xbea testing: random write/read operations
    #Address 0xbea read value
    csrr x14, 0xbea

    #Address 0xbea read value
    csrr x14, 0xbea

    #Unmapped address 0xb79 testing: random write/read operations
    #Address 0xb79 read value
    csrr x14, 0xb79

    #Address 0xb79 read value
    csrr x14, 0xb79

    #Address 0xb79 read value
    csrr x14, 0xb79

    #Unmapped address 0x7da testing: random write/read operations
    #Address 0x7da Write value 0xe81f2ce4
    li x3, 0xe81f2ce4
    csrw 0x7da, x3

    #Address 0x7da Write value 0x8e59469e
    li x3, 0x8e59469e
    csrw 0x7da, x3

    #Unmapped address 0xdb4 testing: random write/read operations
    #Address 0xdb4 Write value 0xaea093f0
    li x3, 0xaea093f0
    csrw 0xdb4, x3

    #Address 0xdb4 Write value 0xbd9e68b1
    li x3, 0xbd9e68b1
    csrw 0xdb4, x3

    #Address 0xdb4 Write value 0x4b86fde2
    li x3, 0x4b86fde2
    csrw 0xdb4, x3

    #Unmapped address 0xc08 testing: random write/read operations
    #Address 0xc08 read value
    csrr x14, 0xc08

    #Unmapped address 0x1af testing: random write/read operations
    #Address 0x1af read value
    csrr x14, 0x1af

    #Address 0x1af read value
    csrr x14, 0x1af

    #Address 0x1af read value
    csrr x14, 0x1af

    #Address 0x1af Write value 0xcb537679
    li x3, 0xcb537679
    csrw 0x1af, x3

    #Address 0x1af Write value 0x845d2914
    li x3, 0x845d2914
    csrw 0x1af, x3

    #Unmapped address 0xb23 testing: random write/read operations
    #Address 0xb23 read value
    csrr x14, 0xb23

    #Address 0xb23 read value
    csrr x14, 0xb23

    #Unmapped address 0xa2a testing: random write/read operations
    #Address 0xa2a Write value 0x2ded0bc3
    li x3, 0x2ded0bc3
    csrw 0xa2a, x3

    #Address 0xa2a Write value 0x10bb97c0
    li x3, 0x10bb97c0
    csrw 0xa2a, x3

    #Address 0xa2a read value
    csrr x14, 0xa2a

    #Address 0xa2a Write value 0x9b4ec44a
    li x3, 0x9b4ec44a
    csrw 0xa2a, x3

    #Unmapped address 0xf72 testing: random write/read operations
    #Address 0xf72 read value
    csrr x14, 0xf72

    #Unmapped address 0x107 testing: random write/read operations
    #Address 0x107 read value
    csrr x14, 0x107

    #Address 0x107 Write value 0x77887b55
    li x3, 0x77887b55
    csrw 0x107, x3

    #Address 0x107 read value
    csrr x14, 0x107

    #Mapped address 0xb16 (mhpmcounter22) testing: random write/read operations
    #Address 0xb16 Write value 0x9747c74b
    li x3, 0x9747c74b
    csrw 0xb16, x3

    #Address 0xb16 read value
    csrr x14, 0xb16

    #Address 0xb16 Write value 0x28b6d62
    li x3, 0x28b6d62
    csrw 0xb16, x3

    #Address 0xb16 Write value 0x16bda90
    li x3, 0x16bda90
    csrw 0xb16, x3

    #Address 0xb16 Write value 0x37a472b1
    li x3, 0x37a472b1
    csrw 0xb16, x3

    #Unmapped address 0x8dc testing: random write/read operations
    #Address 0x8dc read value
    csrr x14, 0x8dc

    #Address 0x8dc Write value 0x58cab5f2
    li x3, 0x58cab5f2
    csrw 0x8dc, x3

    #Address 0x8dc Write value 0x3324029c
    li x3, 0x3324029c
    csrw 0x8dc, x3

    #Address 0x8dc Write value 0x79fda662
    li x3, 0x79fda662
    csrw 0x8dc, x3

    #Unmapped address 0x458 testing: random write/read operations
    #Address 0x458 Write value 0x50d20618
    li x3, 0x50d20618
    csrw 0x458, x3

    #Address 0x458 Write value 0x4998a9b5
    li x3, 0x4998a9b5
    csrw 0x458, x3

    #Unmapped address 0x24 testing: random write/read operations
    #Address 0x24 Write value 0x2e10b1e9
    li x3, 0x2e10b1e9
    csrw 0x24, x3

    #Address 0x24 Write value 0x204a9017
    li x3, 0x204a9017
    csrw 0x24, x3

    #Address 0x24 read value
    csrr x14, 0x24

    #Address 0x24 Write value 0x1fede3ff
    li x3, 0x1fede3ff
    csrw 0x24, x3

    #Address 0x24 Write value 0xdd378488
    li x3, 0xdd378488
    csrw 0x24, x3

    #Mapped address 0x326 (mhpmevent6) testing: random write/read operations
    #Address 0x326 Write value 0xf3851772
    li x3, 0xf3851772
    csrw 0x326, x3

    #Address 0x326 Write value 0x77be49af
    li x3, 0x77be49af
    csrw 0x326, x3

    #Address 0x326 read value
    csrr x14, 0x326

    #Unmapped address 0x8ab testing: random write/read operations
    #Address 0x8ab read value
    csrr x14, 0x8ab

    #Address 0x8ab read value
    csrr x14, 0x8ab

    #Address 0x8ab read value
    csrr x14, 0x8ab

    #Address 0x8ab read value
    csrr x14, 0x8ab

    #Address 0x8ab Write value 0x1668c083
    li x3, 0x1668c083
    csrw 0x8ab, x3

    #Unmapped address 0x85e testing: random write/read operations
    #Address 0x85e read value
    csrr x14, 0x85e

    #Address 0x85e Write value 0x9c4da5ae
    li x3, 0x9c4da5ae
    csrw 0x85e, x3

    #Address 0x85e Write value 0x78dffb58
    li x3, 0x78dffb58
    csrw 0x85e, x3

    #Address 0x85e Write value 0xc89c19c0
    li x3, 0xc89c19c0
    csrw 0x85e, x3

    #Unmapped address 0x8b testing: random write/read operations
    #Address 0x8b Write value 0xe5a786f
    li x3, 0xe5a786f
    csrw 0x8b, x3

    #Unmapped address 0x7b3 testing: random write/read operations
    #Address 0x7b3 read value
    csrr x14, 0x7b3

    #Address 0x7b3 Write value 0x79d2de88
    li x3, 0x79d2de88
    csrw 0x7b3, x3

    #Address 0x7b3 read value
    csrr x14, 0x7b3

    #Address 0x7b3 Write value 0x8c258353
    li x3, 0x8c258353
    csrw 0x7b3, x3

    #Unmapped address 0x10d testing: random write/read operations
    #Address 0x10d Write value 0x500239ee
    li x3, 0x500239ee
    csrw 0x10d, x3

    #Address 0x10d Write value 0xbdae8ccb
    li x3, 0xbdae8ccb
    csrw 0x10d, x3

    #Address 0x10d read value
    csrr x14, 0x10d

    #Unmapped address 0x918 testing: random write/read operations
    #Address 0x918 Write value 0xf2b0fa62
    li x3, 0xf2b0fa62
    csrw 0x918, x3

    #Address 0x918 Write value 0x5cd52c85
    li x3, 0x5cd52c85
    csrw 0x918, x3

    #Unmapped address 0x67 testing: random write/read operations
    #Address 0x67 Write value 0x51aab310
    li x3, 0x51aab310
    csrw 0x67, x3

    #Address 0x67 read value
    csrr x14, 0x67

    #Address 0x67 Write value 0x7daba657
    li x3, 0x7daba657
    csrw 0x67, x3

    #Address 0x67 Write value 0xc1c8ef21
    li x3, 0xc1c8ef21
    csrw 0x67, x3

    #Unmapped address 0x22a testing: random write/read operations
    #Address 0x22a Write value 0xda891320
    li x3, 0xda891320
    csrw 0x22a, x3

    #Address 0x22a read value
    csrr x14, 0x22a

    #Address 0x22a read value
    csrr x14, 0x22a

    #Unmapped address 0xfe9 testing: random write/read operations
    #Address 0xfe9 read value
    csrr x14, 0xfe9

    #Address 0xfe9 read value
    csrr x14, 0xfe9

    #Address 0xfe9 read value
    csrr x14, 0xfe9

    #Unmapped address 0xa37 testing: random write/read operations
    #Address 0xa37 read value
    csrr x14, 0xa37

    #Address 0xa37 read value
    csrr x14, 0xa37

    #Address 0xa37 read value
    csrr x14, 0xa37

    #Unmapped address 0x433 testing: random write/read operations
    #Address 0x433 Write value 0x9ad47413
    li x3, 0x9ad47413
    csrw 0x433, x3

    #Address 0x433 Write value 0x869ffa2a
    li x3, 0x869ffa2a
    csrw 0x433, x3

    #Unmapped address 0xe39 testing: random write/read operations
    #Address 0xe39 Write value 0x497ba404
    li x3, 0x497ba404
    csrw 0xe39, x3

    #Address 0xe39 Write value 0x318fef1e
    li x3, 0x318fef1e
    csrw 0xe39, x3

    #Address 0xe39 Write value 0x5b3533c7
    li x3, 0x5b3533c7
    csrw 0xe39, x3

    #Address 0xe39 Write value 0x3a7e3449
    li x3, 0x3a7e3449
    csrw 0xe39, x3

    #Unmapped address 0xf09 testing: random write/read operations
    #Address 0xf09 Write value 0x9d30aa75
    li x3, 0x9d30aa75
    csrw 0xf09, x3

    #Address 0xf09 read value
    csrr x14, 0xf09

    #Address 0xf09 Write value 0x8508f9ce
    li x3, 0x8508f9ce
    csrw 0xf09, x3

    #Address 0xf09 Write value 0x5e33a4e8
    li x3, 0x5e33a4e8
    csrw 0xf09, x3

    #Address 0xf09 read value
    csrr x14, 0xf09

    #Unmapped address 0xc5b testing: random write/read operations
    #Address 0xc5b Write value 0xb069b0be
    li x3, 0xb069b0be
    csrw 0xc5b, x3

    #Address 0xc5b read value
    csrr x14, 0xc5b

    #Unmapped address 0xdf2 testing: random write/read operations
    #Address 0xdf2 Write value 0xa111893b
    li x3, 0xa111893b
    csrw 0xdf2, x3

    #Address 0xdf2 read value
    csrr x14, 0xdf2

    #Address 0xdf2 Write value 0x52bd9377
    li x3, 0x52bd9377
    csrw 0xdf2, x3

    #Unmapped address 0xf4f testing: random write/read operations
    #Address 0xf4f Write value 0x42524fe0
    li x3, 0x42524fe0
    csrw 0xf4f, x3

    #Unmapped address 0xfc6 testing: random write/read operations
    #Address 0xfc6 Write value 0x584fb27f
    li x3, 0x584fb27f
    csrw 0xfc6, x3

    #Address 0xfc6 Write value 0xc6e959fc
    li x3, 0xc6e959fc
    csrw 0xfc6, x3

    #Address 0xfc6 read value
    csrr x14, 0xfc6

    #Address 0xfc6 read value
    csrr x14, 0xfc6

    #Unmapped address 0x291 testing: random write/read operations
    #Address 0x291 Write value 0xc9d5742
    li x3, 0xc9d5742
    csrw 0x291, x3

    #Address 0x291 Write value 0x8d6ef36d
    li x3, 0x8d6ef36d
    csrw 0x291, x3

    #Address 0x291 read value
    csrr x14, 0x291

    #Address 0x291 Write value 0xbc31d79f
    li x3, 0xbc31d79f
    csrw 0x291, x3

    #Address 0x291 Write value 0x18e15ae4
    li x3, 0x18e15ae4
    csrw 0x291, x3

    #Unmapped address 0x316 testing: random write/read operations
    #Address 0x316 read value
    csrr x14, 0x316

    #Unmapped address 0x606 testing: random write/read operations
    #Address 0x606 read value
    csrr x14, 0x606

    #Address 0x606 read value
    csrr x14, 0x606

    #Address 0x606 Write value 0xb367c0fc
    li x3, 0xb367c0fc
    csrw 0x606, x3

    #Unmapped address 0xc56 testing: random write/read operations
    #Address 0xc56 read value
    csrr x14, 0xc56

    #Address 0xc56 read value
    csrr x14, 0xc56

    #Unmapped address 0xb52 testing: random write/read operations
    #Address 0xb52 read value
    csrr x14, 0xb52

    #Address 0xb52 Write value 0x497e9d89
    li x3, 0x497e9d89
    csrw 0xb52, x3

    #Unmapped address 0x488 testing: random write/read operations
    #Address 0x488 read value
    csrr x14, 0x488

    #Unmapped address 0x1bf testing: random write/read operations
    #Address 0x1bf read value
    csrr x14, 0x1bf

    #Address 0x1bf Write value 0x209c9db2
    li x3, 0x209c9db2
    csrw 0x1bf, x3

    #Address 0x1bf Write value 0x594c55c9
    li x3, 0x594c55c9
    csrw 0x1bf, x3

    #Unmapped address 0xa2 testing: random write/read operations
    #Address 0xa2 Write value 0x2d26abec
    li x3, 0x2d26abec
    csrw 0xa2, x3

    #Address 0xa2 read value
    csrr x14, 0xa2

    #Address 0xa2 Write value 0x2e1b8d95
    li x3, 0x2e1b8d95
    csrw 0xa2, x3

    #Unmapped address 0x144 testing: random write/read operations
    #Address 0x144 Write value 0xf2af0d02
    li x3, 0xf2af0d02
    csrw 0x144, x3

    #Unmapped address 0xcfa testing: random write/read operations
    #Address 0xcfa Write value 0x49d87b3
    li x3, 0x49d87b3
    csrw 0xcfa, x3

    #Address 0xcfa read value
    csrr x14, 0xcfa

    #Address 0xcfa read value
    csrr x14, 0xcfa

    #Address 0xcfa Write value 0xd6da7ae9
    li x3, 0xd6da7ae9
    csrw 0xcfa, x3

    #Unmapped address 0xaee testing: random write/read operations
    #Address 0xaee read value
    csrr x14, 0xaee

    #Address 0xaee Write value 0x4bc45f69
    li x3, 0x4bc45f69
    csrw 0xaee, x3

    #Address 0xaee Write value 0x30b8ae00
    li x3, 0x30b8ae00
    csrw 0xaee, x3

    #Address 0xaee read value
    csrr x14, 0xaee

    #Unmapped address 0x205 testing: random write/read operations
    #Address 0x205 Write value 0xed3ffe59
    li x3, 0xed3ffe59
    csrw 0x205, x3

    #Unmapped address 0x24e testing: random write/read operations
    #Address 0x24e Write value 0xd59d637f
    li x3, 0xd59d637f
    csrw 0x24e, x3

    #Address 0x24e read value
    csrr x14, 0x24e

    #Address 0x24e read value
    csrr x14, 0x24e

    #Unmapped address 0x46e testing: random write/read operations
    #Address 0x46e Write value 0x182e8ae1
    li x3, 0x182e8ae1
    csrw 0x46e, x3

    #Address 0x46e Write value 0xf810cf5a
    li x3, 0xf810cf5a
    csrw 0x46e, x3

    #Address 0x46e Write value 0xd9723766
    li x3, 0xd9723766
    csrw 0x46e, x3

    #Address 0x46e read value
    csrr x14, 0x46e

    #Address 0x46e read value
    csrr x14, 0x46e

    #Unmapped address 0x80d testing: random write/read operations
    #Address 0x80d read value
    csrr x14, 0x80d

    #Address 0x80d read value
    csrr x14, 0x80d

    #Unmapped address 0xe0f testing: random write/read operations
    #Address 0xe0f read value
    csrr x14, 0xe0f

    #Address 0xe0f Write value 0xb2903c75
    li x3, 0xb2903c75
    csrw 0xe0f, x3

    #Address 0xe0f Write value 0xcc5f9dbb
    li x3, 0xcc5f9dbb
    csrw 0xe0f, x3

    #Address 0xe0f Write value 0x5db4bbf0
    li x3, 0x5db4bbf0
    csrw 0xe0f, x3

    #Unmapped address 0x126 testing: random write/read operations
    #Address 0x126 Write value 0x6cacd846
    li x3, 0x6cacd846
    csrw 0x126, x3

    #Address 0x126 Write value 0x7ea25825
    li x3, 0x7ea25825
    csrw 0x126, x3

    #Address 0x126 read value
    csrr x14, 0x126

    #Address 0x126 Write value 0x80ab9f1c
    li x3, 0x80ab9f1c
    csrw 0x126, x3

    #Address 0x126 read value
    csrr x14, 0x126

    #Unmapped address 0x167 testing: random write/read operations
    #Address 0x167 Write value 0x7db3c88a
    li x3, 0x7db3c88a
    csrw 0x167, x3

    #Mapped address 0xb92 (mhpmcounterh18) testing: random write/read operations
    #Address 0xb92 read value
    csrr x14, 0xb92

    #Address 0xb92 Write value 0x45d0060e
    li x3, 0x45d0060e
    csrw 0xb92, x3

    #Address 0xb92 read value
    csrr x14, 0xb92

    #Address 0xb92 Write value 0x3dc61525
    li x3, 0x3dc61525
    csrw 0xb92, x3

    #Unmapped address 0x63c testing: random write/read operations
    #Address 0x63c Write value 0xc024acf3
    li x3, 0xc024acf3
    csrw 0x63c, x3

    #Unmapped address 0x279 testing: random write/read operations
    #Address 0x279 read value
    csrr x14, 0x279

    #Address 0x279 Write value 0xda68f74e
    li x3, 0xda68f74e
    csrw 0x279, x3

    #Address 0x279 Write value 0x6be16f81
    li x3, 0x6be16f81
    csrw 0x279, x3

    #Address 0x279 read value
    csrr x14, 0x279

    #Unmapped address 0xf5e testing: random write/read operations
    #Address 0xf5e read value
    csrr x14, 0xf5e

    #Address 0xf5e Write value 0x12f779aa
    li x3, 0x12f779aa
    csrw 0xf5e, x3

    #Unmapped address 0xdb9 testing: random write/read operations
    #Address 0xdb9 read value
    csrr x14, 0xdb9

    #Address 0xdb9 Write value 0x9fce783f
    li x3, 0x9fce783f
    csrw 0xdb9, x3

    #Unmapped address 0x93a testing: random write/read operations
    #Address 0x93a Write value 0xa8708486
    li x3, 0xa8708486
    csrw 0x93a, x3

    #Unmapped address 0xcd9 testing: random write/read operations
    #Address 0xcd9 Write value 0xec0054f1
    li x3, 0xec0054f1
    csrw 0xcd9, x3

    #Address 0xcd9 read value
    csrr x14, 0xcd9

    #Address 0xcd9 Write value 0x2c6f11fa
    li x3, 0x2c6f11fa
    csrw 0xcd9, x3

    #Address 0xcd9 read value
    csrr x14, 0xcd9

    #Unmapped address 0x274 testing: random write/read operations
    #Address 0x274 read value
    csrr x14, 0x274

    #Address 0x274 read value
    csrr x14, 0x274

    #Address 0x274 Write value 0xdd6121f7
    li x3, 0xdd6121f7
    csrw 0x274, x3

    #Address 0x274 Write value 0x6569152f
    li x3, 0x6569152f
    csrw 0x274, x3

    #Address 0x274 read value
    csrr x14, 0x274

    #Unmapped address 0x5b8 testing: random write/read operations
    #Address 0x5b8 read value
    csrr x14, 0x5b8

    #Address 0x5b8 read value
    csrr x14, 0x5b8

    #Address 0x5b8 read value
    csrr x14, 0x5b8

    #Address 0x5b8 Write value 0x1c74768e
    li x3, 0x1c74768e
    csrw 0x5b8, x3

    #Unmapped address 0x8f3 testing: random write/read operations
    #Address 0x8f3 Write value 0x85c8643c
    li x3, 0x85c8643c
    csrw 0x8f3, x3

    #Address 0x8f3 read value
    csrr x14, 0x8f3

    #Address 0x8f3 Write value 0x55665dcc
    li x3, 0x55665dcc
    csrw 0x8f3, x3

    #Unmapped address 0x350 testing: random write/read operations
    #Address 0x350 read value
    csrr x14, 0x350

    #Address 0x350 Write value 0x4bf6c89e
    li x3, 0x4bf6c89e
    csrw 0x350, x3

    #Address 0x350 read value
    csrr x14, 0x350

    #Address 0x350 read value
    csrr x14, 0x350

    #Unmapped address 0xaf1 testing: random write/read operations
    #Address 0xaf1 read value
    csrr x14, 0xaf1

    #Address 0xaf1 read value
    csrr x14, 0xaf1

    #Address 0xaf1 Write value 0xcd507a61
    li x3, 0xcd507a61
    csrw 0xaf1, x3

    #Address 0xaf1 Write value 0xecdb6fa2
    li x3, 0xecdb6fa2
    csrw 0xaf1, x3

    #Unmapped address 0xcc2 testing: random write/read operations
    #Address 0xcc2 read value
    csrr x14, 0xcc2

    #Address 0xcc2 Write value 0x7c013c76
    li x3, 0x7c013c76
    csrw 0xcc2, x3

    #Address 0xcc2 read value
    csrr x14, 0xcc2

    #Address 0xcc2 Write value 0xc1420
    li x3, 0xc1420
    csrw 0xcc2, x3

    #Address 0xcc2 read value
    csrr x14, 0xcc2

    #Unmapped address 0xb64 testing: random write/read operations
    #Address 0xb64 read value
    csrr x14, 0xb64

    #Address 0xb64 read value
    csrr x14, 0xb64

    #Address 0xb64 read value
    csrr x14, 0xb64

    #Address 0xb64 read value
    csrr x14, 0xb64

    #Unmapped address 0xedc testing: random write/read operations
    #Address 0xedc read value
    csrr x14, 0xedc

    #Address 0xedc Write value 0x629cc6d3
    li x3, 0x629cc6d3
    csrw 0xedc, x3

    #Address 0xedc Write value 0x1e4c0386
    li x3, 0x1e4c0386
    csrw 0xedc, x3

    #Address 0xedc Write value 0xe9a29416
    li x3, 0xe9a29416
    csrw 0xedc, x3

    #Unmapped address 0x2ad testing: random write/read operations
    #Address 0x2ad Write value 0x230fb1f5
    li x3, 0x230fb1f5
    csrw 0x2ad, x3

    #Address 0x2ad Write value 0x142fb912
    li x3, 0x142fb912
    csrw 0x2ad, x3

    #Address 0x2ad Write value 0xc7973415
    li x3, 0xc7973415
    csrw 0x2ad, x3

    #Address 0x2ad read value
    csrr x14, 0x2ad

    #Address 0x2ad Write value 0x643ff55a
    li x3, 0x643ff55a
    csrw 0x2ad, x3

    #Unmapped address 0x7ec testing: random write/read operations
    #Address 0x7ec read value
    csrr x14, 0x7ec

    #Address 0x7ec Write value 0x89428afa
    li x3, 0x89428afa
    csrw 0x7ec, x3

    #Address 0x7ec Write value 0x25075c7f
    li x3, 0x25075c7f
    csrw 0x7ec, x3

    #Unmapped address 0x19 testing: random write/read operations
    #Address 0x19 Write value 0x3819efe8
    li x3, 0x3819efe8
    csrw 0x19, x3

    #Address 0x19 Write value 0x12ac05f5
    li x3, 0x12ac05f5
    csrw 0x19, x3

    #Address 0x19 Write value 0x2d5a47e0
    li x3, 0x2d5a47e0
    csrw 0x19, x3

    #Address 0x19 read value
    csrr x14, 0x19

    #Address 0x19 Write value 0xa34fbadc
    li x3, 0xa34fbadc
    csrw 0x19, x3

    #Unmapped address 0x856 testing: random write/read operations
    #Address 0x856 read value
    csrr x14, 0x856

    #Unmapped address 0x6cc testing: random write/read operations
    #Address 0x6cc read value
    csrr x14, 0x6cc

    #Address 0x6cc Write value 0x58867d89
    li x3, 0x58867d89
    csrw 0x6cc, x3

    #Address 0x6cc read value
    csrr x14, 0x6cc

    #Address 0x6cc read value
    csrr x14, 0x6cc

    #Unmapped address 0x773 testing: random write/read operations
    #Address 0x773 read value
    csrr x14, 0x773

    #Address 0x773 Write value 0x5ee4f6fe
    li x3, 0x5ee4f6fe
    csrw 0x773, x3

    #Unmapped address 0x395 testing: random write/read operations
    #Address 0x395 Write value 0xd6b6cd4f
    li x3, 0xd6b6cd4f
    csrw 0x395, x3

    #Address 0x395 Write value 0xa1398762
    li x3, 0xa1398762
    csrw 0x395, x3

    #Unmapped address 0xcc8 testing: random write/read operations
    #Address 0xcc8 Write value 0xaa41a6d5
    li x3, 0xaa41a6d5
    csrw 0xcc8, x3

    #Address 0xcc8 read value
    csrr x14, 0xcc8

    #Address 0xcc8 read value
    csrr x14, 0xcc8

    #Address 0xcc8 Write value 0x122b208
    li x3, 0x122b208
    csrw 0xcc8, x3

    #Unmapped address 0x68c testing: random write/read operations
    #Address 0x68c Write value 0x51b3ea40
    li x3, 0x51b3ea40
    csrw 0x68c, x3

    #Address 0x68c Write value 0x13364ac0
    li x3, 0x13364ac0
    csrw 0x68c, x3

    #Address 0x68c Write value 0x14b4c523
    li x3, 0x14b4c523
    csrw 0x68c, x3

    #Address 0x68c read value
    csrr x14, 0x68c

    #Address 0x68c read value
    csrr x14, 0x68c

    #Unmapped address 0xc8e testing: random write/read operations
    #Address 0xc8e Write value 0xbeb9c520
    li x3, 0xbeb9c520
    csrw 0xc8e, x3

    #Address 0xc8e Write value 0x4070886e
    li x3, 0x4070886e
    csrw 0xc8e, x3

    #Address 0xc8e read value
    csrr x14, 0xc8e

    #Address 0xc8e Write value 0x9f26ef75
    li x3, 0x9f26ef75
    csrw 0xc8e, x3

    #Mapped address 0xb06 (mhpmcounter6) testing: random write/read operations
    #Address 0xb06 read value
    csrr x14, 0xb06

    #Address 0xb06 Write value 0x9d843bee
    li x3, 0x9d843bee
    csrw 0xb06, x3

    #Address 0xb06 read value
    csrr x14, 0xb06

    #Address 0xb06 Write value 0x567ce20e
    li x3, 0x567ce20e
    csrw 0xb06, x3

    #Address 0xb06 Write value 0x859eb8b8
    li x3, 0x859eb8b8
    csrw 0xb06, x3

    #Unmapped address 0x2be testing: random write/read operations
    #Address 0x2be read value
    csrr x14, 0x2be

    #Address 0x2be Write value 0xb4304604
    li x3, 0xb4304604
    csrw 0x2be, x3

    #Address 0x2be read value
    csrr x14, 0x2be

    #Unmapped address 0x475 testing: random write/read operations
    #Address 0x475 Write value 0x579e70f1
    li x3, 0x579e70f1
    csrw 0x475, x3

    #Address 0x475 read value
    csrr x14, 0x475

    #Address 0x475 Write value 0xa980067e
    li x3, 0xa980067e
    csrw 0x475, x3

    #Address 0x475 read value
    csrr x14, 0x475

    #Unmapped address 0x2ae testing: random write/read operations
    #Address 0x2ae Write value 0x4044f8c2
    li x3, 0x4044f8c2
    csrw 0x2ae, x3

    #Address 0x2ae Write value 0x7a8b7994
    li x3, 0x7a8b7994
    csrw 0x2ae, x3

    #Address 0x2ae read value
    csrr x14, 0x2ae

    #Address 0x2ae read value
    csrr x14, 0x2ae

    #Address 0x2ae Write value 0xe4f6a6ae
    li x3, 0xe4f6a6ae
    csrw 0x2ae, x3

    #Unmapped address 0x2b5 testing: random write/read operations
    #Address 0x2b5 Write value 0x63b46f4c
    li x3, 0x63b46f4c
    csrw 0x2b5, x3

    #Address 0x2b5 Write value 0x83509d94
    li x3, 0x83509d94
    csrw 0x2b5, x3

    #Address 0x2b5 Write value 0x38a6020c
    li x3, 0x38a6020c
    csrw 0x2b5, x3

    #Address 0x2b5 Write value 0x3d6bd822
    li x3, 0x3d6bd822
    csrw 0x2b5, x3

    #Unmapped address 0x79c testing: random write/read operations
    #Address 0x79c Write value 0xce522872
    li x3, 0xce522872
    csrw 0x79c, x3

    #Address 0x79c read value
    csrr x14, 0x79c

    #Unmapped address 0x631 testing: random write/read operations
    #Address 0x631 read value
    csrr x14, 0x631

    #Address 0x631 read value
    csrr x14, 0x631

    #Address 0x631 read value
    csrr x14, 0x631

    #Address 0x631 read value
    csrr x14, 0x631

    #Unmapped address 0x95f testing: random write/read operations
    #Address 0x95f Write value 0xd7ec7212
    li x3, 0xd7ec7212
    csrw 0x95f, x3

    #Address 0x95f Write value 0x9acce49d
    li x3, 0x9acce49d
    csrw 0x95f, x3

    #Unmapped address 0x62a testing: random write/read operations
    #Address 0x62a read value
    csrr x14, 0x62a

    #Address 0x62a read value
    csrr x14, 0x62a

    #Address 0x62a read value
    csrr x14, 0x62a

    #Address 0x62a Write value 0xfeef9730
    li x3, 0xfeef9730
    csrw 0x62a, x3

    #Address 0x62a read value
    csrr x14, 0x62a

    #Unmapped address 0x3a testing: random write/read operations
    #Address 0x3a read value
    csrr x14, 0x3a

    #Address 0x3a read value
    csrr x14, 0x3a

    #Address 0x3a read value
    csrr x14, 0x3a

    #Address 0x3a Write value 0x247255e2
    li x3, 0x247255e2
    csrw 0x3a, x3

    #Unmapped address 0x861 testing: random write/read operations
    #Address 0x861 read value
    csrr x14, 0x861

    #Address 0x861 Write value 0x68c5d5b7
    li x3, 0x68c5d5b7
    csrw 0x861, x3

    #Address 0x861 read value
    csrr x14, 0x861

    #Unmapped address 0x883 testing: random write/read operations
    #Address 0x883 Write value 0xed4e5866
    li x3, 0xed4e5866
    csrw 0x883, x3

    #Unmapped address 0x4a1 testing: random write/read operations
    #Address 0x4a1 Write value 0xf37a790a
    li x3, 0xf37a790a
    csrw 0x4a1, x3

    #Address 0x4a1 Write value 0x37f78fa1
    li x3, 0x37f78fa1
    csrw 0x4a1, x3

    #Address 0x4a1 Write value 0x81e7f234
    li x3, 0x81e7f234
    csrw 0x4a1, x3

    #Unmapped address 0x413 testing: random write/read operations
    #Address 0x413 read value
    csrr x14, 0x413

    #Address 0x413 read value
    csrr x14, 0x413

    #Address 0x413 Write value 0x32b7e2f9
    li x3, 0x32b7e2f9
    csrw 0x413, x3

    #Address 0x413 Write value 0x903cd90d
    li x3, 0x903cd90d
    csrw 0x413, x3

    #Address 0x413 read value
    csrr x14, 0x413

    #Unmapped address 0x537 testing: random write/read operations
    #Address 0x537 read value
    csrr x14, 0x537

    #Address 0x537 Write value 0x31c0fa11
    li x3, 0x31c0fa11
    csrw 0x537, x3

    #Unmapped address 0xec9 testing: random write/read operations
    #Address 0xec9 read value
    csrr x14, 0xec9

    #Address 0xec9 Write value 0xa8e43367
    li x3, 0xa8e43367
    csrw 0xec9, x3

    #Unmapped address 0x562 testing: random write/read operations
    #Address 0x562 Write value 0x964f7f1f
    li x3, 0x964f7f1f
    csrw 0x562, x3

    #Address 0x562 Write value 0x42c6aa0d
    li x3, 0x42c6aa0d
    csrw 0x562, x3

    #Address 0x562 Write value 0x389a1cdd
    li x3, 0x389a1cdd
    csrw 0x562, x3

    #Address 0x562 read value
    csrr x14, 0x562

    #Unmapped address 0xc20 testing: random write/read operations
    #Address 0xc20 read value
    csrr x14, 0xc20

    #Address 0xc20 Write value 0x558092ad
    li x3, 0x558092ad
    csrw 0xc20, x3

    #Address 0xc20 read value
    csrr x14, 0xc20

    #Address 0xc20 read value
    csrr x14, 0xc20

    #Unmapped address 0xc9f testing: random write/read operations
    #Address 0xc9f read value
    csrr x14, 0xc9f

    #Address 0xc9f Write value 0x1d0b25da
    li x3, 0x1d0b25da
    csrw 0xc9f, x3

    #Unmapped address 0xcb5 testing: random write/read operations
    #Address 0xcb5 read value
    csrr x14, 0xcb5

    #Address 0xcb5 read value
    csrr x14, 0xcb5

    #Unmapped address 0xb35 testing: random write/read operations
    #Address 0xb35 read value
    csrr x14, 0xb35

    #Address 0xb35 Write value 0x8308e901
    li x3, 0x8308e901
    csrw 0xb35, x3

    #Address 0xb35 Write value 0xbf63a0a8
    li x3, 0xbf63a0a8
    csrw 0xb35, x3

    #Address 0xb35 Write value 0xdc94fdde
    li x3, 0xdc94fdde
    csrw 0xb35, x3

    #Address 0xb35 read value
    csrr x14, 0xb35

    #Unmapped address 0x3ab testing: random write/read operations
    #Address 0x3ab read value
    csrr x14, 0x3ab

    #Address 0x3ab Write value 0x6c7f2fe7
    li x3, 0x6c7f2fe7
    csrw 0x3ab, x3

    #Unmapped address 0x2d2 testing: random write/read operations
    #Address 0x2d2 Write value 0xf7079fb4
    li x3, 0xf7079fb4
    csrw 0x2d2, x3

    #Address 0x2d2 Write value 0xe44a7506
    li x3, 0xe44a7506
    csrw 0x2d2, x3

    #Address 0x2d2 read value
    csrr x14, 0x2d2

    #Address 0x2d2 read value
    csrr x14, 0x2d2

    #Unmapped address 0xa77 testing: random write/read operations
    #Address 0xa77 Write value 0xc510ffa6
    li x3, 0xc510ffa6
    csrw 0xa77, x3

    #Address 0xa77 read value
    csrr x14, 0xa77

    #Unmapped address 0xa55 testing: random write/read operations
    #Address 0xa55 read value
    csrr x14, 0xa55

    #Address 0xa55 read value
    csrr x14, 0xa55

    #Address 0xa55 read value
    csrr x14, 0xa55

    #Address 0xa55 read value
    csrr x14, 0xa55

    #Unmapped address 0xdee testing: random write/read operations
    #Address 0xdee Write value 0x48893d44
    li x3, 0x48893d44
    csrw 0xdee, x3

    #Unmapped address 0x8e2 testing: random write/read operations
    #Address 0x8e2 Write value 0x63f65fef
    li x3, 0x63f65fef
    csrw 0x8e2, x3

    #Unmapped address 0xb39 testing: random write/read operations
    #Address 0xb39 read value
    csrr x14, 0xb39

    #Address 0xb39 Write value 0xf3b51d5
    li x3, 0xf3b51d5
    csrw 0xb39, x3

    #Address 0xb39 Write value 0xae05d1c4
    li x3, 0xae05d1c4
    csrw 0xb39, x3

    #Address 0xb39 read value
    csrr x14, 0xb39

    #Address 0xb39 read value
    csrr x14, 0xb39

    #Unmapped address 0xa80 testing: random write/read operations
    #Address 0xa80 read value
    csrr x14, 0xa80

    #Address 0xa80 read value
    csrr x14, 0xa80

    #Address 0xa80 read value
    csrr x14, 0xa80

    #Address 0xa80 read value
    csrr x14, 0xa80

    #Address 0xa80 read value
    csrr x14, 0xa80

    #Unmapped address 0xd5a testing: random write/read operations
    #Address 0xd5a Write value 0xa4976ffd
    li x3, 0xa4976ffd
    csrw 0xd5a, x3

    #Address 0xd5a read value
    csrr x14, 0xd5a

    #Address 0xd5a read value
    csrr x14, 0xd5a

    #Address 0xd5a read value
    csrr x14, 0xd5a

    #Unmapped address 0xacd testing: random write/read operations
    #Address 0xacd read value
    csrr x14, 0xacd

    #Address 0xacd Write value 0x9d1e484b
    li x3, 0x9d1e484b
    csrw 0xacd, x3

    #Unmapped address 0x7ff testing: random write/read operations
    #Address 0x7ff read value
    csrr x14, 0x7ff

    #Address 0x7ff Write value 0xc2aae5d7
    li x3, 0xc2aae5d7
    csrw 0x7ff, x3

    #Address 0x7ff read value
    csrr x14, 0x7ff

    #Mapped address 0xb13 (mhpmcounter19) testing: random write/read operations
    #Address 0xb13 read value
    csrr x14, 0xb13

    #Address 0xb13 Write value 0x94e2f36
    li x3, 0x94e2f36
    csrw 0xb13, x3

    #Unmapped address 0x5e0 testing: random write/read operations
    #Address 0x5e0 read value
    csrr x14, 0x5e0

    #Address 0x5e0 Write value 0x9a37a592
    li x3, 0x9a37a592
    csrw 0x5e0, x3

    #Address 0x5e0 Write value 0x9479916d
    li x3, 0x9479916d
    csrw 0x5e0, x3

    #Address 0x5e0 read value
    csrr x14, 0x5e0

    #Unmapped address 0x186 testing: random write/read operations
    #Address 0x186 Write value 0x485a6a7c
    li x3, 0x485a6a7c
    csrw 0x186, x3

    #Address 0x186 read value
    csrr x14, 0x186

    #Address 0x186 read value
    csrr x14, 0x186

    #Unmapped address 0x467 testing: random write/read operations
    #Address 0x467 Write value 0xc1ffe38c
    li x3, 0xc1ffe38c
    csrw 0x467, x3

    #Address 0x467 read value
    csrr x14, 0x467

    #Address 0x467 Write value 0x4720f6b
    li x3, 0x4720f6b
    csrw 0x467, x3

    #Address 0x467 read value
    csrr x14, 0x467

    #Unmapped address 0x252 testing: random write/read operations
    #Address 0x252 read value
    csrr x14, 0x252

    #Address 0x252 Write value 0x9911d39a
    li x3, 0x9911d39a
    csrw 0x252, x3

    #Address 0x252 read value
    csrr x14, 0x252

    #Unmapped address 0x776 testing: random write/read operations
    #Address 0x776 read value
    csrr x14, 0x776

    #Address 0x776 Write value 0xaa4a91ad
    li x3, 0xaa4a91ad
    csrw 0x776, x3

    #Address 0x776 Write value 0xb6b8646b
    li x3, 0xb6b8646b
    csrw 0x776, x3

    #Unmapped address 0xdbb testing: random write/read operations
    #Address 0xdbb Write value 0xe390eaa6
    li x3, 0xe390eaa6
    csrw 0xdbb, x3

    #Address 0xdbb Write value 0xf5f387ce
    li x3, 0xf5f387ce
    csrw 0xdbb, x3

    #Unmapped address 0xdfc testing: random write/read operations
    #Address 0xdfc read value
    csrr x14, 0xdfc

    #Address 0xdfc Write value 0x6043a192
    li x3, 0x6043a192
    csrw 0xdfc, x3

    #Address 0xdfc read value
    csrr x14, 0xdfc

    #Address 0xdfc Write value 0xe0db117
    li x3, 0xe0db117
    csrw 0xdfc, x3

    #Unmapped address 0x818 testing: random write/read operations
    #Address 0x818 Write value 0x282c5ab1
    li x3, 0x282c5ab1
    csrw 0x818, x3

    #Address 0x818 Write value 0x221e3fb
    li x3, 0x221e3fb
    csrw 0x818, x3

    #Address 0x818 read value
    csrr x14, 0x818

    #Address 0x818 read value
    csrr x14, 0x818

    #Unmapped address 0xe95 testing: random write/read operations
    #Address 0xe95 Write value 0xb2068d12
    li x3, 0xb2068d12
    csrw 0xe95, x3

    #Address 0xe95 read value
    csrr x14, 0xe95

    #Address 0xe95 Write value 0x41e7eb51
    li x3, 0x41e7eb51
    csrw 0xe95, x3

    #Address 0xe95 read value
    csrr x14, 0xe95

    #Address 0xe95 read value
    csrr x14, 0xe95

    #Unmapped address 0x9ba testing: random write/read operations
    #Address 0x9ba read value
    csrr x14, 0x9ba

    #Address 0x9ba Write value 0xce060a8e
    li x3, 0xce060a8e
    csrw 0x9ba, x3

    #Address 0x9ba Write value 0x11afd62f
    li x3, 0x11afd62f
    csrw 0x9ba, x3

    #Unmapped address 0xf96 testing: random write/read operations
    #Address 0xf96 read value
    csrr x14, 0xf96

    #Address 0xf96 Write value 0xd053086d
    li x3, 0xd053086d
    csrw 0xf96, x3

    #Unmapped address 0x51a testing: random write/read operations
    #Address 0x51a Write value 0x305b9acb
    li x3, 0x305b9acb
    csrw 0x51a, x3

    #Address 0x51a Write value 0x46969fa0
    li x3, 0x46969fa0
    csrw 0x51a, x3

    #Address 0x51a read value
    csrr x14, 0x51a

    #Address 0x51a read value
    csrr x14, 0x51a

    #Address 0x51a read value
    csrr x14, 0x51a

    #Unmapped address 0xf78 testing: random write/read operations
    #Address 0xf78 read value
    csrr x14, 0xf78

    #Address 0xf78 read value
    csrr x14, 0xf78

    #Address 0xf78 read value
    csrr x14, 0xf78

    #Address 0xf78 read value
    csrr x14, 0xf78

    #Address 0xf78 Write value 0xdf9dc211
    li x3, 0xdf9dc211
    csrw 0xf78, x3

    #Unmapped address 0x634 testing: random write/read operations
    #Address 0x634 Write value 0xce9423a8
    li x3, 0xce9423a8
    csrw 0x634, x3

    #Address 0x634 Write value 0x86f0b99f
    li x3, 0x86f0b99f
    csrw 0x634, x3

    #Address 0x634 Write value 0xf8694936
    li x3, 0xf8694936
    csrw 0x634, x3

    #Unmapped address 0xf87 testing: random write/read operations
    #Address 0xf87 Write value 0x164c4718
    li x3, 0x164c4718
    csrw 0xf87, x3

    #Address 0xf87 Write value 0xf10f036c
    li x3, 0xf10f036c
    csrw 0xf87, x3

    #Unmapped address 0x872 testing: random write/read operations
    #Address 0x872 read value
    csrr x14, 0x872

    #Address 0x872 read value
    csrr x14, 0x872

    #Address 0x872 read value
    csrr x14, 0x872

    #Address 0x872 read value
    csrr x14, 0x872

    #Unmapped address 0x919 testing: random write/read operations
    #Address 0x919 read value
    csrr x14, 0x919

    #Unmapped address 0x15c testing: random write/read operations
    #Address 0x15c read value
    csrr x14, 0x15c

    #Unmapped address 0x1c testing: random write/read operations
    #Address 0x1c read value
    csrr x14, 0x1c

    #Address 0x1c Write value 0x1623b1d7
    li x3, 0x1623b1d7
    csrw 0x1c, x3

    #Unmapped address 0x9e7 testing: random write/read operations
    #Address 0x9e7 read value
    csrr x14, 0x9e7

    #Unmapped address 0xc75 testing: random write/read operations
    #Address 0xc75 read value
    csrr x14, 0xc75

    #Address 0xc75 read value
    csrr x14, 0xc75

    #Address 0xc75 read value
    csrr x14, 0xc75

    #Unmapped address 0xf8e testing: random write/read operations
    #Address 0xf8e read value
    csrr x14, 0xf8e

    #Address 0xf8e Write value 0x80fbbbfc
    li x3, 0x80fbbbfc
    csrw 0xf8e, x3

    #Address 0xf8e read value
    csrr x14, 0xf8e

    #Unmapped address 0x26a testing: random write/read operations
    #Address 0x26a read value
    csrr x14, 0x26a

    #Address 0x26a Write value 0x62671d78
    li x3, 0x62671d78
    csrw 0x26a, x3

    #Unmapped address 0x4ea testing: random write/read operations
    #Address 0x4ea read value
    csrr x14, 0x4ea

    #Address 0x4ea read value
    csrr x14, 0x4ea

    #Address 0x4ea Write value 0x86b889e9
    li x3, 0x86b889e9
    csrw 0x4ea, x3

    #Address 0x4ea read value
    csrr x14, 0x4ea

    #Address 0x4ea Write value 0xdda14b7d
    li x3, 0xdda14b7d
    csrw 0x4ea, x3

    #Unmapped address 0x8bd testing: random write/read operations
    #Address 0x8bd Write value 0x9cd535
    li x3, 0x9cd535
    csrw 0x8bd, x3

    #Address 0x8bd read value
    csrr x14, 0x8bd

    #Address 0x8bd read value
    csrr x14, 0x8bd

    #Address 0x8bd Write value 0x8a1c64e0
    li x3, 0x8a1c64e0
    csrw 0x8bd, x3

    #Address 0x8bd read value
    csrr x14, 0x8bd

    #Unmapped address 0x72 testing: random write/read operations
    #Address 0x72 read value
    csrr x14, 0x72

    #Address 0x72 Write value 0x16cf4546
    li x3, 0x16cf4546
    csrw 0x72, x3

    #Address 0x72 read value
    csrr x14, 0x72

    #Unmapped address 0x415 testing: random write/read operations
    #Address 0x415 Write value 0x5dca50b1
    li x3, 0x5dca50b1
    csrw 0x415, x3

    #Address 0x415 read value
    csrr x14, 0x415

    #Address 0x415 read value
    csrr x14, 0x415

    #Address 0x415 read value
    csrr x14, 0x415

    #Address 0x415 read value
    csrr x14, 0x415

    #Unmapped address 0x9f4 testing: random write/read operations
    #Address 0x9f4 read value
    csrr x14, 0x9f4

    #Unmapped address 0x17a testing: random write/read operations
    #Address 0x17a read value
    csrr x14, 0x17a

    #Address 0x17a Write value 0xe6f61fa6
    li x3, 0xe6f61fa6
    csrw 0x17a, x3

    #Address 0x17a Write value 0xce6bf50f
    li x3, 0xce6bf50f
    csrw 0x17a, x3

    #Address 0x17a Write value 0x3e63f960
    li x3, 0x3e63f960
    csrw 0x17a, x3

    #Address 0x17a Write value 0xdd874a74
    li x3, 0xdd874a74
    csrw 0x17a, x3

    #Unmapped address 0x59c testing: random write/read operations
    #Address 0x59c Write value 0x3bd83d1a
    li x3, 0x3bd83d1a
    csrw 0x59c, x3

    #Unmapped address 0xa73 testing: random write/read operations
    #Address 0xa73 read value
    csrr x14, 0xa73

    #Address 0xa73 Write value 0x6296b6b
    li x3, 0x6296b6b
    csrw 0xa73, x3

    #Address 0xa73 Write value 0x6f11bf94
    li x3, 0x6f11bf94
    csrw 0xa73, x3

    #Address 0xa73 read value
    csrr x14, 0xa73

    #Unmapped address 0x26e testing: random write/read operations
    #Address 0x26e Write value 0xd4a131f0
    li x3, 0xd4a131f0
    csrw 0x26e, x3

    #Address 0x26e read value
    csrr x14, 0x26e

    #Address 0x26e Write value 0x8882284b
    li x3, 0x8882284b
    csrw 0x26e, x3

    #Address 0x26e Write value 0xa10f84eb
    li x3, 0xa10f84eb
    csrw 0x26e, x3

    #Address 0x26e read value
    csrr x14, 0x26e

    #Unmapped address 0xd2e testing: random write/read operations
    #Address 0xd2e read value
    csrr x14, 0xd2e

    #Address 0xd2e read value
    csrr x14, 0xd2e

    #Address 0xd2e read value
    csrr x14, 0xd2e

    #Address 0xd2e Write value 0x48ceb786
    li x3, 0x48ceb786
    csrw 0xd2e, x3

    #Address 0xd2e read value
    csrr x14, 0xd2e

    #Unmapped address 0xec6 testing: random write/read operations
    #Address 0xec6 read value
    csrr x14, 0xec6

    #Address 0xec6 Write value 0xd6bec7fc
    li x3, 0xd6bec7fc
    csrw 0xec6, x3

    #Address 0xec6 read value
    csrr x14, 0xec6

    #Unmapped address 0x13e testing: random write/read operations
    #Address 0x13e read value
    csrr x14, 0x13e

    #Unmapped address 0x7dd testing: random write/read operations
    #Address 0x7dd read value
    csrr x14, 0x7dd

    #Unmapped address 0x7e8 testing: random write/read operations
    #Address 0x7e8 read value
    csrr x14, 0x7e8

    #Address 0x7e8 Write value 0x9343de65
    li x3, 0x9343de65
    csrw 0x7e8, x3

    #Address 0x7e8 read value
    csrr x14, 0x7e8

    #Address 0x7e8 Write value 0x8b4198f4
    li x3, 0x8b4198f4
    csrw 0x7e8, x3

    #Unmapped address 0x1de testing: random write/read operations
    #Address 0x1de Write value 0x6443918d
    li x3, 0x6443918d
    csrw 0x1de, x3

    #Address 0x1de read value
    csrr x14, 0x1de

    #Address 0x1de Write value 0x55e0c0f5
    li x3, 0x55e0c0f5
    csrw 0x1de, x3

    #Address 0x1de Write value 0xdf45c493
    li x3, 0xdf45c493
    csrw 0x1de, x3

    #Unmapped address 0x738 testing: random write/read operations
    #Address 0x738 Write value 0x421738cf
    li x3, 0x421738cf
    csrw 0x738, x3

    #Address 0x738 read value
    csrr x14, 0x738

    #Address 0x738 read value
    csrr x14, 0x738

    #Address 0x738 read value
    csrr x14, 0x738

    #Address 0x738 Write value 0x221cf7e3
    li x3, 0x221cf7e3
    csrw 0x738, x3

    #Unmapped address 0x206 testing: random write/read operations
    #Address 0x206 Write value 0x33d174d2
    li x3, 0x33d174d2
    csrw 0x206, x3

    #Address 0x206 Write value 0x25ccbe08
    li x3, 0x25ccbe08
    csrw 0x206, x3

    #Address 0x206 Write value 0x92e96fbb
    li x3, 0x92e96fbb
    csrw 0x206, x3

    #Address 0x206 read value
    csrr x14, 0x206

    #Address 0x206 Write value 0x8392c18e
    li x3, 0x8392c18e
    csrw 0x206, x3

    #Unmapped address 0x9d8 testing: random write/read operations
    #Address 0x9d8 Write value 0x114ab86e
    li x3, 0x114ab86e
    csrw 0x9d8, x3

    #Address 0x9d8 Write value 0x29819a5c
    li x3, 0x29819a5c
    csrw 0x9d8, x3

    #Unmapped address 0x42c testing: random write/read operations
    #Address 0x42c Write value 0xe7fe2513
    li x3, 0xe7fe2513
    csrw 0x42c, x3

    #Address 0x42c read value
    csrr x14, 0x42c

    #Address 0x42c Write value 0xfebecc6b
    li x3, 0xfebecc6b
    csrw 0x42c, x3

    #Unmapped address 0x95c testing: random write/read operations
    #Address 0x95c read value
    csrr x14, 0x95c

    #Address 0x95c read value
    csrr x14, 0x95c

    #Unmapped address 0x7ab testing: random write/read operations
    #Address 0x7ab Write value 0x898244c9
    li x3, 0x898244c9
    csrw 0x7ab, x3

    #Address 0x7ab Write value 0xc1322f43
    li x3, 0xc1322f43
    csrw 0x7ab, x3

    #Address 0x7ab Write value 0xeff8cc64
    li x3, 0xeff8cc64
    csrw 0x7ab, x3

    #Address 0x7ab Write value 0x1163ea47
    li x3, 0x1163ea47
    csrw 0x7ab, x3

    #Unmapped address 0x7c9 testing: random write/read operations
    #Address 0x7c9 read value
    csrr x14, 0x7c9

    #Address 0x7c9 Write value 0xfa8a5f50
    li x3, 0xfa8a5f50
    csrw 0x7c9, x3

    #Address 0x7c9 read value
    csrr x14, 0x7c9

    #Address 0x7c9 read value
    csrr x14, 0x7c9

    #Unmapped address 0x376 testing: random write/read operations
    #Address 0x376 read value
    csrr x14, 0x376

    #Address 0x376 read value
    csrr x14, 0x376

    #Address 0x376 read value
    csrr x14, 0x376

    #Address 0x376 read value
    csrr x14, 0x376

    #Address 0x376 read value
    csrr x14, 0x376

    #Unmapped address 0xe14 testing: random write/read operations
    #Address 0xe14 Write value 0xc9ea3c5e
    li x3, 0xc9ea3c5e
    csrw 0xe14, x3

    #Address 0xe14 read value
    csrr x14, 0xe14

    #Address 0xe14 Write value 0x33bb5bdb
    li x3, 0x33bb5bdb
    csrw 0xe14, x3

    #Address 0xe14 read value
    csrr x14, 0xe14

    #Address 0xe14 read value
    csrr x14, 0xe14

    #Unmapped address 0xa06 testing: random write/read operations
    #Address 0xa06 read value
    csrr x14, 0xa06

    #Address 0xa06 read value
    csrr x14, 0xa06

    #Address 0xa06 read value
    csrr x14, 0xa06

    #Unmapped address 0x6b7 testing: random write/read operations
    #Address 0x6b7 read value
    csrr x14, 0x6b7

    #Unmapped address 0x83f testing: random write/read operations
    #Address 0x83f read value
    csrr x14, 0x83f

    #Address 0x83f read value
    csrr x14, 0x83f

    #Address 0x83f Write value 0x7304b524
    li x3, 0x7304b524
    csrw 0x83f, x3

    #Address 0x83f Write value 0xc72bac2c
    li x3, 0xc72bac2c
    csrw 0x83f, x3

    #Unmapped address 0xe33 testing: random write/read operations
    #Address 0xe33 Write value 0x3b6f5317
    li x3, 0x3b6f5317
    csrw 0xe33, x3

    #Address 0xe33 Write value 0xa882f2ec
    li x3, 0xa882f2ec
    csrw 0xe33, x3

    #Unmapped address 0xbd3 testing: random write/read operations
    #Address 0xbd3 Write value 0xeefed52e
    li x3, 0xeefed52e
    csrw 0xbd3, x3

    #Address 0xbd3 Write value 0x4d7f42a4
    li x3, 0x4d7f42a4
    csrw 0xbd3, x3

    #Unmapped address 0x5ce testing: random write/read operations
    #Address 0x5ce read value
    csrr x14, 0x5ce

    #Address 0x5ce read value
    csrr x14, 0x5ce

    #Address 0x5ce read value
    csrr x14, 0x5ce

    #Address 0x5ce read value
    csrr x14, 0x5ce

    #Address 0x5ce read value
    csrr x14, 0x5ce

    #Unmapped address 0xbc3 testing: random write/read operations
    #Address 0xbc3 Write value 0x6bb77b8
    li x3, 0x6bb77b8
    csrw 0xbc3, x3

    #Address 0xbc3 read value
    csrr x14, 0xbc3

    #Address 0xbc3 Write value 0xac0dd7d5
    li x3, 0xac0dd7d5
    csrw 0xbc3, x3

    #Address 0xbc3 Write value 0x86e9e9b2
    li x3, 0x86e9e9b2
    csrw 0xbc3, x3

    #Unmapped address 0x7fd testing: random write/read operations
    #Address 0x7fd read value
    csrr x14, 0x7fd

    #Unmapped address 0xede testing: random write/read operations
    #Address 0xede Write value 0xa4d0acc3
    li x3, 0xa4d0acc3
    csrw 0xede, x3

    #Address 0xede Write value 0xafbc8cf4
    li x3, 0xafbc8cf4
    csrw 0xede, x3

    #Unmapped address 0x67f testing: random write/read operations
    #Address 0x67f read value
    csrr x14, 0x67f

    #Address 0x67f read value
    csrr x14, 0x67f

    #Address 0x67f read value
    csrr x14, 0x67f

    #Unmapped address 0xf77 testing: random write/read operations
    #Address 0xf77 read value
    csrr x14, 0xf77

    #Address 0xf77 Write value 0x86758e9
    li x3, 0x86758e9
    csrw 0xf77, x3

    #Unmapped address 0x2bb testing: random write/read operations
    #Address 0x2bb read value
    csrr x14, 0x2bb

    #Address 0x2bb read value
    csrr x14, 0x2bb

    #Address 0x2bb Write value 0x22d5e94a
    li x3, 0x22d5e94a
    csrw 0x2bb, x3

    #Unmapped address 0xe37 testing: random write/read operations
    #Address 0xe37 Write value 0x6251649e
    li x3, 0x6251649e
    csrw 0xe37, x3

    #Address 0xe37 Write value 0x2624708b
    li x3, 0x2624708b
    csrw 0xe37, x3

    #Unmapped address 0x1c6 testing: random write/read operations
    #Address 0x1c6 read value
    csrr x14, 0x1c6

    #Address 0x1c6 Write value 0x6458a140
    li x3, 0x6458a140
    csrw 0x1c6, x3

    #Address 0x1c6 Write value 0xc82317a3
    li x3, 0xc82317a3
    csrw 0x1c6, x3

    #Unmapped address 0x7ac testing: random write/read operations
    #Address 0x7ac Write value 0x995924a5
    li x3, 0x995924a5
    csrw 0x7ac, x3

    #Address 0x7ac Write value 0x9ba6f364
    li x3, 0x9ba6f364
    csrw 0x7ac, x3

    #Address 0x7ac read value
    csrr x14, 0x7ac

    #Address 0x7ac Write value 0x57688c42
    li x3, 0x57688c42
    csrw 0x7ac, x3

    #Unmapped address 0xd3f testing: random write/read operations
    #Address 0xd3f Write value 0x88e79963
    li x3, 0x88e79963
    csrw 0xd3f, x3

    #Address 0xd3f Write value 0xb5527859
    li x3, 0xb5527859
    csrw 0xd3f, x3

    #Unmapped address 0xa4e testing: random write/read operations
    #Address 0xa4e Write value 0x58feb1a2
    li x3, 0x58feb1a2
    csrw 0xa4e, x3

    #Address 0xa4e read value
    csrr x14, 0xa4e

    #Address 0xa4e read value
    csrr x14, 0xa4e

    #Address 0xa4e read value
    csrr x14, 0xa4e

    #Unmapped address 0x642 testing: random write/read operations
    #Address 0x642 Write value 0xb7abc6c4
    li x3, 0xb7abc6c4
    csrw 0x642, x3

    #Address 0x642 read value
    csrr x14, 0x642

    #Address 0x642 Write value 0xcaf89ddb
    li x3, 0xcaf89ddb
    csrw 0x642, x3

    #Address 0x642 Write value 0xc3be384f
    li x3, 0xc3be384f
    csrw 0x642, x3

    #Unmapped address 0x174 testing: random write/read operations
    #Address 0x174 read value
    csrr x14, 0x174

    #Unmapped address 0x61 testing: random write/read operations
    #Address 0x61 Write value 0xeb909477
    li x3, 0xeb909477
    csrw 0x61, x3

    #Address 0x61 read value
    csrr x14, 0x61

    #Address 0x61 read value
    csrr x14, 0x61

    #Address 0x61 Write value 0xe919a5d1
    li x3, 0xe919a5d1
    csrw 0x61, x3

    #Unmapped address 0x2e4 testing: random write/read operations
    #Address 0x2e4 Write value 0x8c710238
    li x3, 0x8c710238
    csrw 0x2e4, x3

    #Address 0x2e4 Write value 0xe3eb7ada
    li x3, 0xe3eb7ada
    csrw 0x2e4, x3

    #Address 0x2e4 read value
    csrr x14, 0x2e4

    #Address 0x2e4 read value
    csrr x14, 0x2e4

    #Unmapped address 0x607 testing: random write/read operations
    #Address 0x607 read value
    csrr x14, 0x607

    #Address 0x607 Write value 0xf8397975
    li x3, 0xf8397975
    csrw 0x607, x3

    #Address 0x607 Write value 0x7ad25965
    li x3, 0x7ad25965
    csrw 0x607, x3

    #Address 0x607 read value
    csrr x14, 0x607

    #Unmapped address 0xfc2 testing: random write/read operations
    #Address 0xfc2 Write value 0x9df7b0a3
    li x3, 0x9df7b0a3
    csrw 0xfc2, x3

    #Address 0xfc2 read value
    csrr x14, 0xfc2

    #Address 0xfc2 read value
    csrr x14, 0xfc2

    #Address 0xfc2 read value
    csrr x14, 0xfc2

    #Unmapped address 0xa79 testing: random write/read operations
    #Address 0xa79 Write value 0xa52a10f7
    li x3, 0xa52a10f7
    csrw 0xa79, x3

    #Address 0xa79 Write value 0xeb045eea
    li x3, 0xeb045eea
    csrw 0xa79, x3

    #Address 0xa79 read value
    csrr x14, 0xa79

    #Address 0xa79 Write value 0xaf6f0bcc
    li x3, 0xaf6f0bcc
    csrw 0xa79, x3

    #Unmapped address 0x973 testing: random write/read operations
    #Address 0x973 Write value 0xf235e2ef
    li x3, 0xf235e2ef
    csrw 0x973, x3

    #Address 0x973 Write value 0xb9c1a936
    li x3, 0xb9c1a936
    csrw 0x973, x3

    #Address 0x973 read value
    csrr x14, 0x973

    #Address 0x973 read value
    csrr x14, 0x973

    #Address 0x973 Write value 0xeeb3e9ab
    li x3, 0xeeb3e9ab
    csrw 0x973, x3

    #Unmapped address 0x21b testing: random write/read operations
    #Address 0x21b Write value 0xa700796d
    li x3, 0xa700796d
    csrw 0x21b, x3

    #Address 0x21b read value
    csrr x14, 0x21b

    #Address 0x21b Write value 0x54cd3967
    li x3, 0x54cd3967
    csrw 0x21b, x3

    #Address 0x21b Write value 0x25e157cd
    li x3, 0x25e157cd
    csrw 0x21b, x3

    #Unmapped address 0x53b testing: random write/read operations
    #Address 0x53b Write value 0x43796c3d
    li x3, 0x43796c3d
    csrw 0x53b, x3

    #Address 0x53b read value
    csrr x14, 0x53b

    #Address 0x53b Write value 0x5400843e
    li x3, 0x5400843e
    csrw 0x53b, x3

    #Unmapped address 0xe3f testing: random write/read operations
    #Address 0xe3f read value
    csrr x14, 0xe3f

    #Unmapped address 0x367 testing: random write/read operations
    #Address 0x367 read value
    csrr x14, 0x367

    #Address 0x367 read value
    csrr x14, 0x367

    #Unmapped address 0x2a1 testing: random write/read operations
    #Address 0x2a1 Write value 0xe67098d0
    li x3, 0xe67098d0
    csrw 0x2a1, x3

    #Address 0x2a1 Write value 0x2f9cfcba
    li x3, 0x2f9cfcba
    csrw 0x2a1, x3

    #Address 0x2a1 read value
    csrr x14, 0x2a1

    #Unmapped address 0xa91 testing: random write/read operations
    #Address 0xa91 read value
    csrr x14, 0xa91

    #Address 0xa91 Write value 0x5300acd1
    li x3, 0x5300acd1
    csrw 0xa91, x3

    #Address 0xa91 read value
    csrr x14, 0xa91

    #Unmapped address 0x935 testing: random write/read operations
    #Address 0x935 Write value 0xfbbec827
    li x3, 0xfbbec827
    csrw 0x935, x3

    #Unmapped address 0x986 testing: random write/read operations
    #Address 0x986 Write value 0x46d81479
    li x3, 0x46d81479
    csrw 0x986, x3

    #Address 0x986 read value
    csrr x14, 0x986

    #Unmapped address 0x42d testing: random write/read operations
    #Address 0x42d Write value 0xea5a7057
    li x3, 0xea5a7057
    csrw 0x42d, x3

    #Address 0x42d read value
    csrr x14, 0x42d

    #Address 0x42d read value
    csrr x14, 0x42d

    #Unmapped address 0xa4d testing: random write/read operations
    #Address 0xa4d read value
    csrr x14, 0xa4d

    #Unmapped address 0xac5 testing: random write/read operations
    #Address 0xac5 Write value 0x2c986a4f
    li x3, 0x2c986a4f
    csrw 0xac5, x3

    #Unmapped address 0x520 testing: random write/read operations
    #Address 0x520 read value
    csrr x14, 0x520

    #Address 0x520 read value
    csrr x14, 0x520

    #Address 0x520 Write value 0xbda235cd
    li x3, 0xbda235cd
    csrw 0x520, x3

    #Address 0x520 read value
    csrr x14, 0x520

    #Unmapped address 0x8ef testing: random write/read operations
    #Address 0x8ef read value
    csrr x14, 0x8ef

    #Address 0x8ef Write value 0xa52d22c7
    li x3, 0xa52d22c7
    csrw 0x8ef, x3

    #Address 0x8ef read value
    csrr x14, 0x8ef

    #Address 0x8ef read value
    csrr x14, 0x8ef

    #Unmapped address 0xddc testing: random write/read operations
    #Address 0xddc Write value 0x5651a2fd
    li x3, 0x5651a2fd
    csrw 0xddc, x3

    #Address 0xddc Write value 0xc0f8016d
    li x3, 0xc0f8016d
    csrw 0xddc, x3

    #Address 0xddc read value
    csrr x14, 0xddc

    #Address 0xddc Write value 0x557ea28e
    li x3, 0x557ea28e
    csrw 0xddc, x3

    #Unmapped address 0xd20 testing: random write/read operations
    #Address 0xd20 Write value 0x9aa587e3
    li x3, 0x9aa587e3
    csrw 0xd20, x3

    #Address 0xd20 Write value 0xe8e23e19
    li x3, 0xe8e23e19
    csrw 0xd20, x3

    #Address 0xd20 Write value 0xc6a1bcf6
    li x3, 0xc6a1bcf6
    csrw 0xd20, x3

    #Unmapped address 0xe9c testing: random write/read operations
    #Address 0xe9c Write value 0x48ad6f59
    li x3, 0x48ad6f59
    csrw 0xe9c, x3

    #Address 0xe9c Write value 0x316bd333
    li x3, 0x316bd333
    csrw 0xe9c, x3

    #Address 0xe9c read value
    csrr x14, 0xe9c

    #Address 0xe9c Write value 0x559988c2
    li x3, 0x559988c2
    csrw 0xe9c, x3

    #Unmapped address 0xebe testing: random write/read operations
    #Address 0xebe Write value 0xca43f58c
    li x3, 0xca43f58c
    csrw 0xebe, x3

    #Address 0xebe Write value 0x10478112
    li x3, 0x10478112
    csrw 0xebe, x3

    #Unmapped address 0xf19 testing: random write/read operations
    #Address 0xf19 read value
    csrr x14, 0xf19

    #Address 0xf19 read value
    csrr x14, 0xf19

    #Unmapped address 0x5e4 testing: random write/read operations
    #Address 0x5e4 read value
    csrr x14, 0x5e4

    #Address 0x5e4 read value
    csrr x14, 0x5e4

    #Address 0x5e4 Write value 0xd5935a6c
    li x3, 0xd5935a6c
    csrw 0x5e4, x3

    #Address 0x5e4 Write value 0x2995a6c8
    li x3, 0x2995a6c8
    csrw 0x5e4, x3

    #Address 0x5e4 read value
    csrr x14, 0x5e4

    #Unmapped address 0x1d4 testing: random write/read operations
    #Address 0x1d4 read value
    csrr x14, 0x1d4

    #Address 0x1d4 read value
    csrr x14, 0x1d4

    #Address 0x1d4 Write value 0x1515f8c3
    li x3, 0x1515f8c3
    csrw 0x1d4, x3

    #Address 0x1d4 read value
    csrr x14, 0x1d4

    #Unmapped address 0x5b1 testing: random write/read operations
    #Address 0x5b1 Write value 0x7ba2c538
    li x3, 0x7ba2c538
    csrw 0x5b1, x3

    #Address 0x5b1 read value
    csrr x14, 0x5b1

    #Address 0x5b1 read value
    csrr x14, 0x5b1

    #Address 0x5b1 read value
    csrr x14, 0x5b1

    #Unmapped address 0xadd testing: random write/read operations
    #Address 0xadd read value
    csrr x14, 0xadd

    #Unmapped address 0x8ec testing: random write/read operations
    #Address 0x8ec read value
    csrr x14, 0x8ec

    #Address 0x8ec read value
    csrr x14, 0x8ec

    #Unmapped address 0x5e8 testing: random write/read operations
    #Address 0x5e8 Write value 0xa8938834
    li x3, 0xa8938834
    csrw 0x5e8, x3

    #Unmapped address 0x6bd testing: random write/read operations
    #Address 0x6bd Write value 0x5c4e2a44
    li x3, 0x5c4e2a44
    csrw 0x6bd, x3

    #Address 0x6bd Write value 0xff0ab53f
    li x3, 0xff0ab53f
    csrw 0x6bd, x3

    #Address 0x6bd Write value 0xeafc0980
    li x3, 0xeafc0980
    csrw 0x6bd, x3

    #Unmapped address 0x37a testing: random write/read operations
    #Address 0x37a read value
    csrr x14, 0x37a

    #Address 0x37a Write value 0x16ada364
    li x3, 0x16ada364
    csrw 0x37a, x3

    #Address 0x37a Write value 0xf06a2019
    li x3, 0xf06a2019
    csrw 0x37a, x3

    #Mapped address 0xb0a (mhpmcounter10) testing: random write/read operations
    #Address 0xb0a Write value 0x1854034c
    li x3, 0x1854034c
    csrw 0xb0a, x3

    #Address 0xb0a read value
    csrr x14, 0xb0a

    #Address 0xb0a Write value 0x7e091dd5
    li x3, 0x7e091dd5
    csrw 0xb0a, x3

    #Address 0xb0a read value
    csrr x14, 0xb0a

    #Address 0xb0a read value
    csrr x14, 0xb0a

    #Unmapped address 0xd12 testing: random write/read operations
    #Address 0xd12 read value
    csrr x14, 0xd12

    #Unmapped address 0x3da testing: random write/read operations
    #Address 0x3da Write value 0x531628fd
    li x3, 0x531628fd
    csrw 0x3da, x3

    #Address 0x3da read value
    csrr x14, 0x3da

    #Address 0x3da Write value 0x7d14f19c
    li x3, 0x7d14f19c
    csrw 0x3da, x3

    #Address 0x3da read value
    csrr x14, 0x3da

    #Unmapped address 0x18b testing: random write/read operations
    #Address 0x18b read value
    csrr x14, 0x18b

    #Address 0x18b read value
    csrr x14, 0x18b

    #Address 0x18b Write value 0x8c9089f
    li x3, 0x8c9089f
    csrw 0x18b, x3

    #Address 0x18b read value
    csrr x14, 0x18b

    #Unmapped address 0x86c testing: random write/read operations
    #Address 0x86c Write value 0xb0756c99
    li x3, 0xb0756c99
    csrw 0x86c, x3

    #Address 0x86c read value
    csrr x14, 0x86c

    #Address 0x86c Write value 0xd94349e2
    li x3, 0xd94349e2
    csrw 0x86c, x3

    #Address 0x86c read value
    csrr x14, 0x86c

    #Address 0x86c Write value 0xd8f79b65
    li x3, 0xd8f79b65
    csrw 0x86c, x3

    #Unmapped address 0x211 testing: random write/read operations
    #Address 0x211 read value
    csrr x14, 0x211

    #Address 0x211 read value
    csrr x14, 0x211

    #Address 0x211 read value
    csrr x14, 0x211

    #Address 0x211 read value
    csrr x14, 0x211

    #Address 0x211 Write value 0xe1bfb30b
    li x3, 0xe1bfb30b
    csrw 0x211, x3

    #Unmapped address 0x3d1 testing: random write/read operations
    #Address 0x3d1 Write value 0xa77c0e9a
    li x3, 0xa77c0e9a
    csrw 0x3d1, x3

    #Unmapped address 0x4c7 testing: random write/read operations
    #Address 0x4c7 read value
    csrr x14, 0x4c7

    #Address 0x4c7 Write value 0xb05bb450
    li x3, 0xb05bb450
    csrw 0x4c7, x3

    #Address 0x4c7 read value
    csrr x14, 0x4c7

    #Unmapped address 0xfb0 testing: random write/read operations
    #Address 0xfb0 read value
    csrr x14, 0xfb0

    #Address 0xfb0 read value
    csrr x14, 0xfb0

    #Unmapped address 0xd8a testing: random write/read operations
    #Address 0xd8a read value
    csrr x14, 0xd8a

    #Address 0xd8a read value
    csrr x14, 0xd8a

    #Unmapped address 0x3f testing: random write/read operations
    #Address 0x3f Write value 0x38b89f18
    li x3, 0x38b89f18
    csrw 0x3f, x3

    #Address 0x3f Write value 0x8975f441
    li x3, 0x8975f441
    csrw 0x3f, x3

    #Address 0x3f read value
    csrr x14, 0x3f

    #Address 0x3f Write value 0x4abf6cfd
    li x3, 0x4abf6cfd
    csrw 0x3f, x3

    #Unmapped address 0x46 testing: random write/read operations
    #Address 0x46 read value
    csrr x14, 0x46

    #Address 0x46 read value
    csrr x14, 0x46

    #Unmapped address 0x4ab testing: random write/read operations
    #Address 0x4ab read value
    csrr x14, 0x4ab

    #Address 0x4ab Write value 0xeac5c239
    li x3, 0xeac5c239
    csrw 0x4ab, x3

    #Unmapped address 0x941 testing: random write/read operations
    #Address 0x941 read value
    csrr x14, 0x941

    #Unmapped address 0x60b testing: random write/read operations
    #Address 0x60b read value
    csrr x14, 0x60b

    #Address 0x60b read value
    csrr x14, 0x60b

    #Address 0x60b read value
    csrr x14, 0x60b

    #Address 0x60b Write value 0x23e06a52
    li x3, 0x23e06a52
    csrw 0x60b, x3

    #Unmapped address 0xdf0 testing: random write/read operations
    #Address 0xdf0 read value
    csrr x14, 0xdf0

    #Unmapped address 0xad0 testing: random write/read operations
    #Address 0xad0 read value
    csrr x14, 0xad0

    #Address 0xad0 read value
    csrr x14, 0xad0

    #Address 0xad0 Write value 0x28700e37
    li x3, 0x28700e37
    csrw 0xad0, x3

    #Address 0xad0 Write value 0xe232b544
    li x3, 0xe232b544
    csrw 0xad0, x3

    #Address 0xad0 read value
    csrr x14, 0xad0

    #Unmapped address 0x3ef testing: random write/read operations
    #Address 0x3ef read value
    csrr x14, 0x3ef

    #Address 0x3ef Write value 0x5ca70def
    li x3, 0x5ca70def
    csrw 0x3ef, x3

    #Unmapped address 0x9ce testing: random write/read operations
    #Address 0x9ce Write value 0x807413f2
    li x3, 0x807413f2
    csrw 0x9ce, x3

    #Address 0x9ce Write value 0x46d516e2
    li x3, 0x46d516e2
    csrw 0x9ce, x3

    #Address 0x9ce read value
    csrr x14, 0x9ce

    #Unmapped address 0xd72 testing: random write/read operations
    #Address 0xd72 Write value 0x4207902e
    li x3, 0x4207902e
    csrw 0xd72, x3

    #Address 0xd72 read value
    csrr x14, 0xd72

    #Unmapped address 0xc2b testing: random write/read operations
    #Address 0xc2b Write value 0xe28071b3
    li x3, 0xe28071b3
    csrw 0xc2b, x3

    #Address 0xc2b read value
    csrr x14, 0xc2b

    #Address 0xc2b read value
    csrr x14, 0xc2b

    #Unmapped address 0x432 testing: random write/read operations
    #Address 0x432 Write value 0xf84784fc
    li x3, 0xf84784fc
    csrw 0x432, x3

    #Address 0x432 read value
    csrr x14, 0x432

    #Address 0x432 Write value 0x656c3289
    li x3, 0x656c3289
    csrw 0x432, x3

    #Address 0x432 Write value 0x6b4e6994
    li x3, 0x6b4e6994
    csrw 0x432, x3

    #Address 0x432 read value
    csrr x14, 0x432

    #Unmapped address 0x2f8 testing: random write/read operations
    #Address 0x2f8 Write value 0x41e1775f
    li x3, 0x41e1775f
    csrw 0x2f8, x3

    #Unmapped address 0x250 testing: random write/read operations
    #Address 0x250 read value
    csrr x14, 0x250

    #Unmapped address 0x52a testing: random write/read operations
    #Address 0x52a Write value 0xb0a4e270
    li x3, 0xb0a4e270
    csrw 0x52a, x3

    #Address 0x52a read value
    csrr x14, 0x52a

    #Address 0x52a read value
    csrr x14, 0x52a

    #Address 0x52a Write value 0x508613a2
    li x3, 0x508613a2
    csrw 0x52a, x3

    #Unmapped address 0x2d5 testing: random write/read operations
    #Address 0x2d5 Write value 0x9fdef9fb
    li x3, 0x9fdef9fb
    csrw 0x2d5, x3

    #Address 0x2d5 read value
    csrr x14, 0x2d5

    #Address 0x2d5 Write value 0x1fc7fc8a
    li x3, 0x1fc7fc8a
    csrw 0x2d5, x3

    #Unmapped address 0x3dc testing: random write/read operations
    #Address 0x3dc Write value 0x72cb8ab7
    li x3, 0x72cb8ab7
    csrw 0x3dc, x3

    #Address 0x3dc Write value 0xc60fad1f
    li x3, 0xc60fad1f
    csrw 0x3dc, x3

    #Unmapped address 0x63b testing: random write/read operations
    #Address 0x63b read value
    csrr x14, 0x63b

    #Address 0x63b read value
    csrr x14, 0x63b

    #Unmapped address 0x61d testing: random write/read operations
    #Address 0x61d read value
    csrr x14, 0x61d

    #Unmapped address 0x4df testing: random write/read operations
    #Address 0x4df read value
    csrr x14, 0x4df

    #Address 0x4df Write value 0x545158eb
    li x3, 0x545158eb
    csrw 0x4df, x3

    #Address 0x4df Write value 0xc09ecc0e
    li x3, 0xc09ecc0e
    csrw 0x4df, x3

    #Address 0x4df Write value 0xd8a568af
    li x3, 0xd8a568af
    csrw 0x4df, x3

    #Unmapped address 0x63f testing: random write/read operations
    #Address 0x63f Write value 0x498b17da
    li x3, 0x498b17da
    csrw 0x63f, x3

    #Address 0x63f Write value 0xcf3fcf22
    li x3, 0xcf3fcf22
    csrw 0x63f, x3

    #Address 0x63f Write value 0x7e39442e
    li x3, 0x7e39442e
    csrw 0x63f, x3

    #Address 0x63f Write value 0xba08cb2e
    li x3, 0xba08cb2e
    csrw 0x63f, x3

    #Address 0x63f read value
    csrr x14, 0x63f

    #Unmapped address 0x3ff testing: random write/read operations
    #Address 0x3ff read value
    csrr x14, 0x3ff

    #Address 0x3ff read value
    csrr x14, 0x3ff

    #Address 0x3ff read value
    csrr x14, 0x3ff

    #Unmapped address 0xc6 testing: random write/read operations
    #Address 0xc6 read value
    csrr x14, 0xc6

    #Address 0xc6 Write value 0x1a27e749
    li x3, 0x1a27e749
    csrw 0xc6, x3

    #Address 0xc6 read value
    csrr x14, 0xc6

    #Address 0xc6 read value
    csrr x14, 0xc6

    #Unmapped address 0x47 testing: random write/read operations
    #Address 0x47 read value
    csrr x14, 0x47

    #Address 0x47 read value
    csrr x14, 0x47

    #Address 0x47 read value
    csrr x14, 0x47

    #Address 0x47 read value
    csrr x14, 0x47

    #Unmapped address 0xb6 testing: random write/read operations
    #Address 0xb6 read value
    csrr x14, 0xb6

    #Unmapped address 0x81c testing: random write/read operations
    #Address 0x81c read value
    csrr x14, 0x81c

    #Unmapped address 0x2f0 testing: random write/read operations
    #Address 0x2f0 read value
    csrr x14, 0x2f0

    #Address 0x2f0 read value
    csrr x14, 0x2f0

    #Unmapped address 0xe3b testing: random write/read operations
    #Address 0xe3b read value
    csrr x14, 0xe3b

    #Address 0xe3b Write value 0xae0d136f
    li x3, 0xae0d136f
    csrw 0xe3b, x3

    #Address 0xe3b Write value 0x6880a5f
    li x3, 0x6880a5f
    csrw 0xe3b, x3

    #Address 0xe3b read value
    csrr x14, 0xe3b

    #Address 0xe3b Write value 0xa5bae9c5
    li x3, 0xa5bae9c5
    csrw 0xe3b, x3

    #Unmapped address 0xd9d testing: random write/read operations
    #Address 0xd9d Write value 0xc372bfee
    li x3, 0xc372bfee
    csrw 0xd9d, x3

    #Address 0xd9d Write value 0x5ffe045e
    li x3, 0x5ffe045e
    csrw 0xd9d, x3

    #Address 0xd9d Write value 0xebcd56ef
    li x3, 0xebcd56ef
    csrw 0xd9d, x3

    #Address 0xd9d read value
    csrr x14, 0xd9d

    #Unmapped address 0x964 testing: random write/read operations
    #Address 0x964 read value
    csrr x14, 0x964

    #Address 0x964 read value
    csrr x14, 0x964

    #Address 0x964 Write value 0x713beba9
    li x3, 0x713beba9
    csrw 0x964, x3

    #Unmapped address 0xee1 testing: random write/read operations
    #Address 0xee1 Write value 0x528e9668
    li x3, 0x528e9668
    csrw 0xee1, x3

    #Address 0xee1 Write value 0xe7abba22
    li x3, 0xe7abba22
    csrw 0xee1, x3

    #Unmapped address 0x190 testing: random write/read operations
    #Address 0x190 Write value 0xdbee3228
    li x3, 0xdbee3228
    csrw 0x190, x3

    #Address 0x190 read value
    csrr x14, 0x190

    #Address 0x190 Write value 0xc27c1b52
    li x3, 0xc27c1b52
    csrw 0x190, x3

    #Address 0x190 Write value 0xc1bc066e
    li x3, 0xc1bc066e
    csrw 0x190, x3

    #Unmapped address 0x8a1 testing: random write/read operations
    #Address 0x8a1 Write value 0xeb4dc969
    li x3, 0xeb4dc969
    csrw 0x8a1, x3

    #Address 0x8a1 Write value 0x884d9793
    li x3, 0x884d9793
    csrw 0x8a1, x3

    #Unmapped address 0xf46 testing: random write/read operations
    #Address 0xf46 Write value 0x8e7daf4d
    li x3, 0x8e7daf4d
    csrw 0xf46, x3

    #Address 0xf46 Write value 0x4a76cc83
    li x3, 0x4a76cc83
    csrw 0xf46, x3

    #Address 0xf46 Write value 0x756099b9
    li x3, 0x756099b9
    csrw 0xf46, x3

    #Address 0xf46 read value
    csrr x14, 0xf46

    #Address 0xf46 read value
    csrr x14, 0xf46

    #Unmapped address 0x3fa testing: random write/read operations
    #Address 0x3fa Write value 0xf8b88d62
    li x3, 0xf8b88d62
    csrw 0x3fa, x3

    #Address 0x3fa read value
    csrr x14, 0x3fa

    #Address 0x3fa Write value 0x64a90cf1
    li x3, 0x64a90cf1
    csrw 0x3fa, x3

    #Address 0x3fa Write value 0x96033f8e
    li x3, 0x96033f8e
    csrw 0x3fa, x3

    #Unmapped address 0x67b testing: random write/read operations
    #Address 0x67b read value
    csrr x14, 0x67b

    #Unmapped address 0xfae testing: random write/read operations
    #Address 0xfae Write value 0xef73844a
    li x3, 0xef73844a
    csrw 0xfae, x3

    #Address 0xfae read value
    csrr x14, 0xfae

    #Address 0xfae read value
    csrr x14, 0xfae

    #Address 0xfae Write value 0xb22a5692
    li x3, 0xb22a5692
    csrw 0xfae, x3

    #Mapped address 0x304 (mie) testing: random write/read operations
    #Address 0x304 Write value 0xe9999b44
    li x3, 0xe9999b44
    csrw 0x304, x3

    #Address 0x304 read value
    csrr x14, 0x304

    #Address 0x304 Write value 0x75b744ab
    li x3, 0x75b744ab
    csrw 0x304, x3

    #Address 0x304 read value
    csrr x14, 0x304

    #Unmapped address 0xc9c testing: random write/read operations
    #Address 0xc9c read value
    csrr x14, 0xc9c

    #Address 0xc9c Write value 0xeca9bcf8
    li x3, 0xeca9bcf8
    csrw 0xc9c, x3

    #Address 0xc9c Write value 0xf3f20b4a
    li x3, 0xf3f20b4a
    csrw 0xc9c, x3

    #Address 0xc9c read value
    csrr x14, 0xc9c

    #Address 0xc9c Write value 0x1ba1a9e1
    li x3, 0x1ba1a9e1
    csrw 0xc9c, x3

    #Unmapped address 0x1bd testing: random write/read operations
    #Address 0x1bd Write value 0x6423d2f
    li x3, 0x6423d2f
    csrw 0x1bd, x3

    #Address 0x1bd Write value 0xd81b8838
    li x3, 0xd81b8838
    csrw 0x1bd, x3

    #Address 0x1bd read value
    csrr x14, 0x1bd

    #Unmapped address 0x482 testing: random write/read operations
    #Address 0x482 Write value 0x226d8bcf
    li x3, 0x226d8bcf
    csrw 0x482, x3

    #Address 0x482 read value
    csrr x14, 0x482

    #Address 0x482 Write value 0x3e09e003
    li x3, 0x3e09e003
    csrw 0x482, x3

    #Address 0x482 Write value 0xda180b21
    li x3, 0xda180b21
    csrw 0x482, x3

    #Address 0x482 Write value 0x843e13b3
    li x3, 0x843e13b3
    csrw 0x482, x3

    #Unmapped address 0x9be testing: random write/read operations
    #Address 0x9be Write value 0xd486bae0
    li x3, 0xd486bae0
    csrw 0x9be, x3

    #Address 0x9be Write value 0xeea2c2a
    li x3, 0xeea2c2a
    csrw 0x9be, x3

    #Address 0x9be Write value 0xfbe0b922
    li x3, 0xfbe0b922
    csrw 0x9be, x3

    #Unmapped address 0x830 testing: random write/read operations
    #Address 0x830 read value
    csrr x14, 0x830

    #Address 0x830 Write value 0xa06c889e
    li x3, 0xa06c889e
    csrw 0x830, x3

    #Address 0x830 read value
    csrr x14, 0x830

    #Unmapped address 0xdae testing: random write/read operations
    #Address 0xdae Write value 0xb607e397
    li x3, 0xb607e397
    csrw 0xdae, x3

    #Address 0xdae Write value 0x87e712fa
    li x3, 0x87e712fa
    csrw 0xdae, x3

    #Address 0xdae read value
    csrr x14, 0xdae

    #Address 0xdae Write value 0x9dd5b112
    li x3, 0x9dd5b112
    csrw 0xdae, x3

    #Mapped address 0x324 (mhpmevent4) testing: random write/read operations
    #Address 0x324 Write value 0x5edc5c3e
    li x3, 0x5edc5c3e
    csrw 0x324, x3

    #Address 0x324 read value
    csrr x14, 0x324

    #Address 0x324 read value
    csrr x14, 0x324

    #Unmapped address 0xba9 testing: random write/read operations
    #Address 0xba9 read value
    csrr x14, 0xba9

    #Address 0xba9 Write value 0x4d7f1d54
    li x3, 0x4d7f1d54
    csrw 0xba9, x3

    #Address 0xba9 Write value 0x5246d714
    li x3, 0x5246d714
    csrw 0xba9, x3

    #Address 0xba9 read value
    csrr x14, 0xba9

    #Unmapped address 0xf8f testing: random write/read operations
    #Address 0xf8f Write value 0xe3070a0b
    li x3, 0xe3070a0b
    csrw 0xf8f, x3

    #Address 0xf8f Write value 0x9f5fefad
    li x3, 0x9f5fefad
    csrw 0xf8f, x3

    #Address 0xf8f Write value 0xdf4ae6d8
    li x3, 0xdf4ae6d8
    csrw 0xf8f, x3

    #Unmapped address 0xb81 testing: random write/read operations
    #Address 0xb81 Write value 0x3a33bdb2
    li x3, 0x3a33bdb2
    csrw 0xb81, x3

    #Address 0xb81 Write value 0x8065361f
    li x3, 0x8065361f
    csrw 0xb81, x3

    #Address 0xb81 read value
    csrr x14, 0xb81

    #Unmapped address 0xe00 testing: random write/read operations
    #Address 0xe00 read value
    csrr x14, 0xe00

    #Address 0xe00 read value
    csrr x14, 0xe00

    #Address 0xe00 Write value 0x93ba0e25
    li x3, 0x93ba0e25
    csrw 0xe00, x3

    #Address 0xe00 Write value 0x96861cd1
    li x3, 0x96861cd1
    csrw 0xe00, x3

    #Unmapped address 0x8e0 testing: random write/read operations
    #Address 0x8e0 read value
    csrr x14, 0x8e0

    #Unmapped address 0x2c9 testing: random write/read operations
    #Address 0x2c9 Write value 0x27b29b1e
    li x3, 0x27b29b1e
    csrw 0x2c9, x3

    #Address 0x2c9 read value
    csrr x14, 0x2c9

    #Unmapped address 0x6de testing: random write/read operations
    #Address 0x6de read value
    csrr x14, 0x6de

    #Address 0x6de Write value 0x7946d14a
    li x3, 0x7946d14a
    csrw 0x6de, x3

    #Unmapped address 0x7f8 testing: random write/read operations
    #Address 0x7f8 read value
    csrr x14, 0x7f8

    #Address 0x7f8 Write value 0x28e9240d
    li x3, 0x28e9240d
    csrw 0x7f8, x3

    #Address 0x7f8 Write value 0x9306dc1e
    li x3, 0x9306dc1e
    csrw 0x7f8, x3

    #Unmapped address 0x443 testing: random write/read operations
    #Address 0x443 Write value 0xa8ceed86
    li x3, 0xa8ceed86
    csrw 0x443, x3

    #Address 0x443 Write value 0xec809693
    li x3, 0xec809693
    csrw 0x443, x3

    #Address 0x443 read value
    csrr x14, 0x443

    #Address 0x443 Write value 0xd280acb8
    li x3, 0xd280acb8
    csrw 0x443, x3

    #Unmapped address 0x7d9 testing: random write/read operations
    #Address 0x7d9 Write value 0x2d6fdaf3
    li x3, 0x2d6fdaf3
    csrw 0x7d9, x3

    #Address 0x7d9 read value
    csrr x14, 0x7d9

    #Address 0x7d9 read value
    csrr x14, 0x7d9

    #Unmapped address 0xa7 testing: random write/read operations
    #Address 0xa7 read value
    csrr x14, 0xa7

    #Address 0xa7 Write value 0x807c5203
    li x3, 0x807c5203
    csrw 0xa7, x3

    #Address 0xa7 Write value 0xa64b5a6a
    li x3, 0xa64b5a6a
    csrw 0xa7, x3

    #Address 0xa7 Write value 0x772ab7cd
    li x3, 0x772ab7cd
    csrw 0xa7, x3

    #Unmapped address 0xc9e testing: random write/read operations
    #Address 0xc9e read value
    csrr x14, 0xc9e

    #Address 0xc9e read value
    csrr x14, 0xc9e

    #Address 0xc9e read value
    csrr x14, 0xc9e

    #Address 0xc9e Write value 0xb2d8af1f
    li x3, 0xb2d8af1f
    csrw 0xc9e, x3

    #Address 0xc9e Write value 0x66528251
    li x3, 0x66528251
    csrw 0xc9e, x3

    #Unmapped address 0x613 testing: random write/read operations
    #Address 0x613 read value
    csrr x14, 0x613

    #Address 0x613 read value
    csrr x14, 0x613

    #Address 0x613 read value
    csrr x14, 0x613

    #Address 0x613 read value
    csrr x14, 0x613

    #Address 0x613 read value
    csrr x14, 0x613

    #Unmapped address 0xa62 testing: random write/read operations
    #Address 0xa62 Write value 0xe8d2f12d
    li x3, 0xe8d2f12d
    csrw 0xa62, x3

    #Address 0xa62 Write value 0x76a7ff88
    li x3, 0x76a7ff88
    csrw 0xa62, x3

    #Unmapped address 0xea3 testing: random write/read operations
    #Address 0xea3 read value
    csrr x14, 0xea3

    #Address 0xea3 Write value 0x24a5ec7c
    li x3, 0x24a5ec7c
    csrw 0xea3, x3

    #Unmapped address 0xcba testing: random write/read operations
    #Address 0xcba read value
    csrr x14, 0xcba

    #Address 0xcba Write value 0x414168c8
    li x3, 0x414168c8
    csrw 0xcba, x3

    #Address 0xcba Write value 0xe07d3172
    li x3, 0xe07d3172
    csrw 0xcba, x3

    #Address 0xcba Write value 0xa9a4d62d
    li x3, 0xa9a4d62d
    csrw 0xcba, x3

    #Unmapped address 0x3e0 testing: random write/read operations
    #Address 0x3e0 Write value 0xcc176e85
    li x3, 0xcc176e85
    csrw 0x3e0, x3

    #Address 0x3e0 read value
    csrr x14, 0x3e0

    #Unmapped address 0xec4 testing: random write/read operations
    #Address 0xec4 read value
    csrr x14, 0xec4

    #Address 0xec4 read value
    csrr x14, 0xec4

    #Unmapped address 0x92b testing: random write/read operations
    #Address 0x92b read value
    csrr x14, 0x92b

    #Address 0x92b read value
    csrr x14, 0x92b

    #Unmapped address 0xe4a testing: random write/read operations
    #Address 0xe4a read value
    csrr x14, 0xe4a

    #Address 0xe4a read value
    csrr x14, 0xe4a

    #Address 0xe4a read value
    csrr x14, 0xe4a

    #Unmapped address 0x4db testing: random write/read operations
    #Address 0x4db read value
    csrr x14, 0x4db

    #Address 0x4db read value
    csrr x14, 0x4db

    #Address 0x4db Write value 0x8da89c76
    li x3, 0x8da89c76
    csrw 0x4db, x3

    #Unmapped address 0xfd7 testing: random write/read operations
    #Address 0xfd7 Write value 0xd3b9c4b9
    li x3, 0xd3b9c4b9
    csrw 0xfd7, x3

    #Address 0xfd7 read value
    csrr x14, 0xfd7

    #Unmapped address 0x31e testing: random write/read operations
    #Address 0x31e read value
    csrr x14, 0x31e

    #Address 0x31e Write value 0xb4d1a798
    li x3, 0xb4d1a798
    csrw 0x31e, x3

    #Address 0x31e read value
    csrr x14, 0x31e

    #Address 0x31e read value
    csrr x14, 0x31e

    #Unmapped address 0x595 testing: random write/read operations
    #Address 0x595 read value
    csrr x14, 0x595

    #Address 0x595 read value
    csrr x14, 0x595

    #Address 0x595 read value
    csrr x14, 0x595

    #Address 0x595 read value
    csrr x14, 0x595

    #Address 0x595 Write value 0x2cd867fd
    li x3, 0x2cd867fd
    csrw 0x595, x3

    #Unmapped address 0x465 testing: random write/read operations
    #Address 0x465 read value
    csrr x14, 0x465

    #Unmapped address 0xd17 testing: random write/read operations
    #Address 0xd17 Write value 0x97c72c20
    li x3, 0x97c72c20
    csrw 0xd17, x3

    #Unmapped address 0xf0b testing: random write/read operations
    #Address 0xf0b Write value 0xe7a32fe9
    li x3, 0xe7a32fe9
    csrw 0xf0b, x3

    #Unmapped address 0xc18 testing: random write/read operations
    #Address 0xc18 read value
    csrr x14, 0xc18

    #Address 0xc18 Write value 0x3a1a9f76
    li x3, 0x3a1a9f76
    csrw 0xc18, x3

    #Address 0xc18 read value
    csrr x14, 0xc18

    #Address 0xc18 read value
    csrr x14, 0xc18

    #Unmapped address 0xae6 testing: random write/read operations
    #Address 0xae6 read value
    csrr x14, 0xae6

    #Address 0xae6 Write value 0x93104e62
    li x3, 0x93104e62
    csrw 0xae6, x3

    #Address 0xae6 Write value 0x95c91f13
    li x3, 0x95c91f13
    csrw 0xae6, x3

    #Unmapped address 0x97f testing: random write/read operations
    #Address 0x97f read value
    csrr x14, 0x97f

    #Address 0x97f Write value 0x48993cf3
    li x3, 0x48993cf3
    csrw 0x97f, x3

    #Address 0x97f read value
    csrr x14, 0x97f

    #Address 0x97f Write value 0xd943ecd5
    li x3, 0xd943ecd5
    csrw 0x97f, x3

    #Address 0x97f Write value 0x6fc9a6c7
    li x3, 0x6fc9a6c7
    csrw 0x97f, x3

    #Unmapped address 0xe3 testing: random write/read operations
    #Address 0xe3 read value
    csrr x14, 0xe3

    #Address 0xe3 Write value 0x8feb0f1d
    li x3, 0x8feb0f1d
    csrw 0xe3, x3

    #Address 0xe3 read value
    csrr x14, 0xe3

    #Address 0xe3 read value
    csrr x14, 0xe3

    #Mapped address 0xb8b (mhpmcounterh11) testing: random write/read operations
    #Address 0xb8b read value
    csrr x14, 0xb8b

    #Address 0xb8b Write value 0x575ad785
    li x3, 0x575ad785
    csrw 0xb8b, x3

    #Address 0xb8b read value
    csrr x14, 0xb8b

    #Mapped address 0xb0b (mhpmcounter11) testing: random write/read operations
    #Address 0xb0b Write value 0x4847da24
    li x3, 0x4847da24
    csrw 0xb0b, x3

    #Address 0xb0b read value
    csrr x14, 0xb0b

    #Unmapped address 0x364 testing: random write/read operations
    #Address 0x364 read value
    csrr x14, 0x364

    #Address 0x364 Write value 0x36169b24
    li x3, 0x36169b24
    csrw 0x364, x3

    #Unmapped address 0x823 testing: random write/read operations
    #Address 0x823 read value
    csrr x14, 0x823

    #Address 0x823 Write value 0x94476d9a
    li x3, 0x94476d9a
    csrw 0x823, x3

    #Unmapped address 0xe0c testing: random write/read operations
    #Address 0xe0c Write value 0xdbd34b0f
    li x3, 0xdbd34b0f
    csrw 0xe0c, x3

    #Address 0xe0c Write value 0xf4dbaf31
    li x3, 0xf4dbaf31
    csrw 0xe0c, x3

    #Address 0xe0c read value
    csrr x14, 0xe0c

    #Mapped address 0xc82 (instreth) testing: random write/read operations
    #Address 0xc82 read value
    csrr x14, 0xc82

    #Address 0xc82 read value
    csrr x14, 0xc82

    #Address 0xc82 read value
    csrr x14, 0xc82

    #Address 0xc82 read value
    csrr x14, 0xc82

    #Address 0xc82 read value
    csrr x14, 0xc82

    #Unmapped address 0xe5f testing: random write/read operations
    #Address 0xe5f read value
    csrr x14, 0xe5f

    #Address 0xe5f read value
    csrr x14, 0xe5f

    #Address 0xe5f Write value 0x45596e44
    li x3, 0x45596e44
    csrw 0xe5f, x3

    #Unmapped address 0xae testing: random write/read operations
    #Address 0xae Write value 0xe95c271e
    li x3, 0xe95c271e
    csrw 0xae, x3

    #Unmapped address 0xd7b testing: random write/read operations
    #Address 0xd7b read value
    csrr x14, 0xd7b

    #Address 0xd7b Write value 0x4f7d925e
    li x3, 0x4f7d925e
    csrw 0xd7b, x3

    #Unmapped address 0xa21 testing: random write/read operations
    #Address 0xa21 Write value 0x2d2cd2f6
    li x3, 0x2d2cd2f6
    csrw 0xa21, x3

    #Address 0xa21 Write value 0x1f7413b
    li x3, 0x1f7413b
    csrw 0xa21, x3

    #Address 0xa21 Write value 0x1d8b289d
    li x3, 0x1d8b289d
    csrw 0xa21, x3

    #Unmapped address 0xa0c testing: random write/read operations
    #Address 0xa0c read value
    csrr x14, 0xa0c

    #Address 0xa0c Write value 0x5608dbac
    li x3, 0x5608dbac
    csrw 0xa0c, x3

    #Unmapped address 0xaa3 testing: random write/read operations
    #Address 0xaa3 Write value 0x8b517603
    li x3, 0x8b517603
    csrw 0xaa3, x3

    #Address 0xaa3 Write value 0x75765902
    li x3, 0x75765902
    csrw 0xaa3, x3

    #Address 0xaa3 Write value 0x5612dfdc
    li x3, 0x5612dfdc
    csrw 0xaa3, x3

    #Address 0xaa3 Write value 0x3f8b96cd
    li x3, 0x3f8b96cd
    csrw 0xaa3, x3

    #Unmapped address 0x984 testing: random write/read operations
    #Address 0x984 Write value 0x7ebcd1f9
    li x3, 0x7ebcd1f9
    csrw 0x984, x3

    #Address 0x984 read value
    csrr x14, 0x984

    #Unmapped address 0xebf testing: random write/read operations
    #Address 0xebf read value
    csrr x14, 0xebf

    #Address 0xebf Write value 0xf72ab38d
    li x3, 0xf72ab38d
    csrw 0xebf, x3

    #Address 0xebf Write value 0xc23cd258
    li x3, 0xc23cd258
    csrw 0xebf, x3

    #Address 0xebf Write value 0x84b2f48
    li x3, 0x84b2f48
    csrw 0xebf, x3

    #Address 0xebf read value
    csrr x14, 0xebf

    #Unmapped address 0x346 testing: random write/read operations
    #Address 0x346 read value
    csrr x14, 0x346

    #Address 0x346 Write value 0x661405dd
    li x3, 0x661405dd
    csrw 0x346, x3

    #Address 0x346 Write value 0x4902f947
    li x3, 0x4902f947
    csrw 0x346, x3

    #Address 0x346 Write value 0xc5afa16a
    li x3, 0xc5afa16a
    csrw 0x346, x3

    #Unmapped address 0x739 testing: random write/read operations
    #Address 0x739 read value
    csrr x14, 0x739

    #Address 0x739 read value
    csrr x14, 0x739

    #Address 0x739 Write value 0xd2e1cc3
    li x3, 0xd2e1cc3
    csrw 0x739, x3

    #Address 0x739 Write value 0xfbfc57e1
    li x3, 0xfbfc57e1
    csrw 0x739, x3

    #Unmapped address 0x8be testing: random write/read operations
    #Address 0x8be Write value 0x841b0c3e
    li x3, 0x841b0c3e
    csrw 0x8be, x3

    #Address 0x8be read value
    csrr x14, 0x8be

    #Address 0x8be read value
    csrr x14, 0x8be

    #Address 0x8be Write value 0x2b455db3
    li x3, 0x2b455db3
    csrw 0x8be, x3

    #Unmapped address 0x28e testing: random write/read operations
    #Address 0x28e read value
    csrr x14, 0x28e

    #Address 0x28e read value
    csrr x14, 0x28e

    #Unmapped address 0x928 testing: random write/read operations
    #Address 0x928 Write value 0x52314562
    li x3, 0x52314562
    csrw 0x928, x3

    #Address 0x928 read value
    csrr x14, 0x928

    #Unmapped address 0xecc testing: random write/read operations
    #Address 0xecc Write value 0x71ce1370
    li x3, 0x71ce1370
    csrw 0xecc, x3

    #Address 0xecc read value
    csrr x14, 0xecc

    #Address 0xecc read value
    csrr x14, 0xecc

    #Unmapped address 0xefb testing: random write/read operations
    #Address 0xefb Write value 0x8f7e6833
    li x3, 0x8f7e6833
    csrw 0xefb, x3

    #Unmapped address 0xd0c testing: random write/read operations
    #Address 0xd0c read value
    csrr x14, 0xd0c

    #Address 0xd0c Write value 0xc63003a7
    li x3, 0xc63003a7
    csrw 0xd0c, x3

    #Address 0xd0c Write value 0x6d07e3aa
    li x3, 0x6d07e3aa
    csrw 0xd0c, x3

    #Mapped address 0x32f (mhpmevent15) testing: random write/read operations
    #Address 0x32f read value
    csrr x14, 0x32f

    #Address 0x32f Write value 0xa0c4c0eb
    li x3, 0xa0c4c0eb
    csrw 0x32f, x3

    #Address 0x32f read value
    csrr x14, 0x32f

    #Address 0x32f Write value 0xd5061c76
    li x3, 0xd5061c76
    csrw 0x32f, x3

    #Address 0x32f read value
    csrr x14, 0x32f

    #Unmapped address 0x27d testing: random write/read operations
    #Address 0x27d Write value 0x260731fd
    li x3, 0x260731fd
    csrw 0x27d, x3

    #Address 0x27d Write value 0x583b9e00
    li x3, 0x583b9e00
    csrw 0x27d, x3

    #Address 0x27d Write value 0xf082daea
    li x3, 0xf082daea
    csrw 0x27d, x3

    #Unmapped address 0x3d0 testing: random write/read operations
    #Address 0x3d0 Write value 0xfd0c2a4
    li x3, 0xfd0c2a4
    csrw 0x3d0, x3

    #Address 0x3d0 read value
    csrr x14, 0x3d0

    #Unmapped address 0xf3 testing: random write/read operations
    #Address 0xf3 read value
    csrr x14, 0xf3

    #Address 0xf3 read value
    csrr x14, 0xf3

    #Address 0xf3 Write value 0x7fed99e3
    li x3, 0x7fed99e3
    csrw 0xf3, x3

    #Address 0xf3 read value
    csrr x14, 0xf3

    #Address 0xf3 Write value 0x6fc3b2c9
    li x3, 0x6fc3b2c9
    csrw 0xf3, x3

    #Unmapped address 0xfe8 testing: random write/read operations
    #Address 0xfe8 read value
    csrr x14, 0xfe8

    #Address 0xfe8 read value
    csrr x14, 0xfe8

    #Address 0xfe8 read value
    csrr x14, 0xfe8

    #Address 0xfe8 Write value 0xd4335fe2
    li x3, 0xd4335fe2
    csrw 0xfe8, x3

    #Address 0xfe8 Write value 0x6af1c9d6
    li x3, 0x6af1c9d6
    csrw 0xfe8, x3

    #Unmapped address 0xa2c testing: random write/read operations
    #Address 0xa2c Write value 0x9a71fb96
    li x3, 0x9a71fb96
    csrw 0xa2c, x3

    #Address 0xa2c read value
    csrr x14, 0xa2c

    #Address 0xa2c read value
    csrr x14, 0xa2c

    #Address 0xa2c Write value 0x15df756
    li x3, 0x15df756
    csrw 0xa2c, x3

    #Address 0xa2c read value
    csrr x14, 0xa2c

    #Unmapped address 0x5f7 testing: random write/read operations
    #Address 0x5f7 read value
    csrr x14, 0x5f7

    #Unmapped address 0x45 testing: random write/read operations
    #Address 0x45 Write value 0xa479369
    li x3, 0xa479369
    csrw 0x45, x3

    #Unmapped address 0xef testing: random write/read operations
    #Address 0xef read value
    csrr x14, 0xef

    #Address 0xef read value
    csrr x14, 0xef

    #Address 0xef Write value 0xfe9d5ef5
    li x3, 0xfe9d5ef5
    csrw 0xef, x3

    #Address 0xef Write value 0xc9f5a521
    li x3, 0xc9f5a521
    csrw 0xef, x3

    #Unmapped address 0xf9a testing: random write/read operations
    #Address 0xf9a read value
    csrr x14, 0xf9a

    #Address 0xf9a Write value 0x1577371b
    li x3, 0x1577371b
    csrw 0xf9a, x3

    #Address 0xf9a Write value 0x7acd26b7
    li x3, 0x7acd26b7
    csrw 0xf9a, x3

    #Address 0xf9a Write value 0x37b18a2e
    li x3, 0x37b18a2e
    csrw 0xf9a, x3

    #Address 0xf9a Write value 0x8656369a
    li x3, 0x8656369a
    csrw 0xf9a, x3

    #Unmapped address 0x414 testing: random write/read operations
    #Address 0x414 read value
    csrr x14, 0x414

    #Address 0x414 Write value 0x700d3d59
    li x3, 0x700d3d59
    csrw 0x414, x3

    #Unmapped address 0x797 testing: random write/read operations
    #Address 0x797 read value
    csrr x14, 0x797

    #Unmapped address 0x7fa testing: random write/read operations
    #Address 0x7fa read value
    csrr x14, 0x7fa

    #Address 0x7fa Write value 0x3f416a3f
    li x3, 0x3f416a3f
    csrw 0x7fa, x3

    #Address 0x7fa read value
    csrr x14, 0x7fa

    #Address 0x7fa Write value 0x9f910a9c
    li x3, 0x9f910a9c
    csrw 0x7fa, x3

    #Address 0x7fa Write value 0x1aaeaccc
    li x3, 0x1aaeaccc
    csrw 0x7fa, x3

    #Unmapped address 0xa7c testing: random write/read operations
    #Address 0xa7c read value
    csrr x14, 0xa7c

    #Address 0xa7c Write value 0x970d3a47
    li x3, 0x970d3a47
    csrw 0xa7c, x3

    #Address 0xa7c read value
    csrr x14, 0xa7c

    #Address 0xa7c Write value 0x65ea1e5c
    li x3, 0x65ea1e5c
    csrw 0xa7c, x3

    #Unmapped address 0xd9e testing: random write/read operations
    #Address 0xd9e Write value 0x6120c856
    li x3, 0x6120c856
    csrw 0xd9e, x3

    #Address 0xd9e Write value 0x8a73f5cb
    li x3, 0x8a73f5cb
    csrw 0xd9e, x3

    #Address 0xd9e read value
    csrr x14, 0xd9e

    #Address 0xd9e Write value 0x90000b30
    li x3, 0x90000b30
    csrw 0xd9e, x3

    #Unmapped address 0xa47 testing: random write/read operations
    #Address 0xa47 Write value 0x33a34db7
    li x3, 0x33a34db7
    csrw 0xa47, x3

    #Address 0xa47 Write value 0xf9bc2e6c
    li x3, 0xf9bc2e6c
    csrw 0xa47, x3

    #Address 0xa47 read value
    csrr x14, 0xa47

    #Unmapped address 0xb62 testing: random write/read operations
    #Address 0xb62 Write value 0x6f90dc0d
    li x3, 0x6f90dc0d
    csrw 0xb62, x3

    #Address 0xb62 read value
    csrr x14, 0xb62

    #Address 0xb62 read value
    csrr x14, 0xb62

    #Address 0xb62 read value
    csrr x14, 0xb62

    #Address 0xb62 read value
    csrr x14, 0xb62

    #Unmapped address 0xd5c testing: random write/read operations
    #Address 0xd5c read value
    csrr x14, 0xd5c

    #Address 0xd5c Write value 0x43826b8a
    li x3, 0x43826b8a
    csrw 0xd5c, x3

    #Unmapped address 0x78e testing: random write/read operations
    #Address 0x78e read value
    csrr x14, 0x78e

    #Address 0x78e Write value 0xb3991d54
    li x3, 0xb3991d54
    csrw 0x78e, x3

    #Address 0x78e read value
    csrr x14, 0x78e

    #Unmapped address 0x9ad testing: random write/read operations
    #Address 0x9ad Write value 0xff86f1fc
    li x3, 0xff86f1fc
    csrw 0x9ad, x3

    #Address 0x9ad read value
    csrr x14, 0x9ad

    #Unmapped address 0x587 testing: random write/read operations
    #Address 0x587 Write value 0x76e737d2
    li x3, 0x76e737d2
    csrw 0x587, x3

    #Address 0x587 Write value 0xf56d7ebb
    li x3, 0xf56d7ebb
    csrw 0x587, x3

    #Address 0x587 Write value 0xc7748090
    li x3, 0xc7748090
    csrw 0x587, x3

    #Unmapped address 0xcb testing: random write/read operations
    #Address 0xcb read value
    csrr x14, 0xcb

    #Unmapped address 0x128 testing: random write/read operations
    #Address 0x128 read value
    csrr x14, 0x128

    #Address 0x128 Write value 0x7a05f0c2
    li x3, 0x7a05f0c2
    csrw 0x128, x3

    #Address 0x128 Write value 0x6e68efce
    li x3, 0x6e68efce
    csrw 0x128, x3

    #Address 0x128 read value
    csrr x14, 0x128

    #Address 0x128 read value
    csrr x14, 0x128

    #Unmapped address 0xae3 testing: random write/read operations
    #Address 0xae3 read value
    csrr x14, 0xae3

    #Unmapped address 0xece testing: random write/read operations
    #Address 0xece read value
    csrr x14, 0xece

    #Address 0xece Write value 0xdcc07677
    li x3, 0xdcc07677
    csrw 0xece, x3

    #Address 0xece read value
    csrr x14, 0xece

    #Unmapped address 0x3d3 testing: random write/read operations
    #Address 0x3d3 Write value 0x377c0ed
    li x3, 0x377c0ed
    csrw 0x3d3, x3

    #Address 0x3d3 Write value 0x53c80c1f
    li x3, 0x53c80c1f
    csrw 0x3d3, x3

    #Address 0x3d3 read value
    csrr x14, 0x3d3

    #Address 0x3d3 Write value 0x1920c3a
    li x3, 0x1920c3a
    csrw 0x3d3, x3

    #Address 0x3d3 read value
    csrr x14, 0x3d3

    #Mapped address 0xb09 (mhpmcounter9) testing: random write/read operations
    #Address 0xb09 Write value 0xcdf61bc2
    li x3, 0xcdf61bc2
    csrw 0xb09, x3

    #Unmapped address 0x12d testing: random write/read operations
    #Address 0x12d read value
    csrr x14, 0x12d

    #Address 0x12d Write value 0xf5703fbd
    li x3, 0xf5703fbd
    csrw 0x12d, x3

    #Unmapped address 0xc0e testing: random write/read operations
    #Address 0xc0e read value
    csrr x14, 0xc0e

    #Address 0xc0e read value
    csrr x14, 0xc0e

    #Address 0xc0e read value
    csrr x14, 0xc0e

    #Unmapped address 0x449 testing: random write/read operations
    #Address 0x449 read value
    csrr x14, 0x449

    #Unmapped address 0xf84 testing: random write/read operations
    #Address 0xf84 Write value 0xe64789ae
    li x3, 0xe64789ae
    csrw 0xf84, x3

    #Address 0xf84 Write value 0x74896158
    li x3, 0x74896158
    csrw 0xf84, x3

    #Address 0xf84 Write value 0x388b8149
    li x3, 0x388b8149
    csrw 0xf84, x3

    #Address 0xf84 read value
    csrr x14, 0xf84

    #Address 0xf84 Write value 0xdb732433
    li x3, 0xdb732433
    csrw 0xf84, x3

    #Unmapped address 0xfa6 testing: random write/read operations
    #Address 0xfa6 read value
    csrr x14, 0xfa6

    #Address 0xfa6 read value
    csrr x14, 0xfa6

    #Address 0xfa6 read value
    csrr x14, 0xfa6

    #Unmapped address 0x9c8 testing: random write/read operations
    #Address 0x9c8 Write value 0x6c1518aa
    li x3, 0x6c1518aa
    csrw 0x9c8, x3

    #Address 0x9c8 Write value 0x34f78271
    li x3, 0x34f78271
    csrw 0x9c8, x3

    #Address 0x9c8 read value
    csrr x14, 0x9c8

    #Unmapped address 0x7cc testing: random write/read operations
    #Address 0x7cc Write value 0xa16d8e9b
    li x3, 0xa16d8e9b
    csrw 0x7cc, x3

    #Address 0x7cc Write value 0x4280c152
    li x3, 0x4280c152
    csrw 0x7cc, x3

    #Unmapped address 0xd9b testing: random write/read operations
    #Address 0xd9b read value
    csrr x14, 0xd9b

    #Address 0xd9b read value
    csrr x14, 0xd9b

    #Unmapped address 0x93c testing: random write/read operations
    #Address 0x93c read value
    csrr x14, 0x93c

    #Address 0x93c Write value 0xd26582a2
    li x3, 0xd26582a2
    csrw 0x93c, x3

    #Address 0x93c Write value 0x43b07e7d
    li x3, 0x43b07e7d
    csrw 0x93c, x3

    #Unmapped address 0x1dc testing: random write/read operations
    #Address 0x1dc read value
    csrr x14, 0x1dc

    #Address 0x1dc read value
    csrr x14, 0x1dc

    #Address 0x1dc read value
    csrr x14, 0x1dc

    #Address 0x1dc Write value 0xa7c88f54
    li x3, 0xa7c88f54
    csrw 0x1dc, x3

    #Address 0x1dc Write value 0x3881616f
    li x3, 0x3881616f
    csrw 0x1dc, x3

    #Unmapped address 0xd2d testing: random write/read operations
    #Address 0xd2d Write value 0x224ef8c7
    li x3, 0x224ef8c7
    csrw 0xd2d, x3

    #Unmapped address 0x5c9 testing: random write/read operations
    #Address 0x5c9 Write value 0x4a0ef22d
    li x3, 0x4a0ef22d
    csrw 0x5c9, x3

    #Address 0x5c9 Write value 0x35985fa0
    li x3, 0x35985fa0
    csrw 0x5c9, x3

    #Address 0x5c9 Write value 0xc52018a7
    li x3, 0xc52018a7
    csrw 0x5c9, x3

    #Address 0x5c9 read value
    csrr x14, 0x5c9

    #Address 0x5c9 Write value 0xe70fdcce
    li x3, 0xe70fdcce
    csrw 0x5c9, x3

    #Unmapped address 0xacf testing: random write/read operations
    #Address 0xacf read value
    csrr x14, 0xacf

    #Address 0xacf Write value 0xadf8159c
    li x3, 0xadf8159c
    csrw 0xacf, x3

    #Address 0xacf read value
    csrr x14, 0xacf

    #Unmapped address 0xd8f testing: random write/read operations
    #Address 0xd8f read value
    csrr x14, 0xd8f

    #Address 0xd8f Write value 0xa0717555
    li x3, 0xa0717555
    csrw 0xd8f, x3

    #Address 0xd8f read value
    csrr x14, 0xd8f

    #Address 0xd8f Write value 0x5f9d1fe6
    li x3, 0x5f9d1fe6
    csrw 0xd8f, x3

    #Address 0xd8f Write value 0xdac08185
    li x3, 0xdac08185
    csrw 0xd8f, x3

    #Unmapped address 0x51d testing: random write/read operations
    #Address 0x51d Write value 0x30a83e2f
    li x3, 0x30a83e2f
    csrw 0x51d, x3

    #Address 0x51d read value
    csrr x14, 0x51d

    #Mapped address 0x339 (mhpmevent25) testing: random write/read operations
    #Address 0x339 read value
    csrr x14, 0x339

    #Address 0x339 Write value 0xe3906842
    li x3, 0xe3906842
    csrw 0x339, x3

    #Address 0x339 Write value 0x130abe87
    li x3, 0x130abe87
    csrw 0x339, x3

    #Address 0x339 read value
    csrr x14, 0x339

    #Address 0x339 Write value 0x42dcf086
    li x3, 0x42dcf086
    csrw 0x339, x3

    #Unmapped address 0x585 testing: random write/read operations
    #Address 0x585 Write value 0xca65854c
    li x3, 0xca65854c
    csrw 0x585, x3

    #Address 0x585 read value
    csrr x14, 0x585

    #Address 0x585 Write value 0xc79a962a
    li x3, 0xc79a962a
    csrw 0x585, x3

    #Address 0x585 Write value 0x2ca7efea
    li x3, 0x2ca7efea
    csrw 0x585, x3

    #Address 0x585 read value
    csrr x14, 0x585

    #Unmapped address 0x775 testing: random write/read operations
    #Address 0x775 read value
    csrr x14, 0x775

    #Address 0x775 Write value 0x6759f2ad
    li x3, 0x6759f2ad
    csrw 0x775, x3

    #Address 0x775 Write value 0x923e5397
    li x3, 0x923e5397
    csrw 0x775, x3

    #Unmapped address 0x87b testing: random write/read operations
    #Address 0x87b read value
    csrr x14, 0x87b

    #Address 0x87b Write value 0x2b4e6a33
    li x3, 0x2b4e6a33
    csrw 0x87b, x3

    #Address 0x87b read value
    csrr x14, 0x87b

    #Address 0x87b Write value 0x74465f8c
    li x3, 0x74465f8c
    csrw 0x87b, x3

    #Address 0x87b read value
    csrr x14, 0x87b

    #Unmapped address 0x752 testing: random write/read operations
    #Address 0x752 read value
    csrr x14, 0x752

    #Address 0x752 Write value 0x36f37563
    li x3, 0x36f37563
    csrw 0x752, x3

    #Unmapped address 0x5c7 testing: random write/read operations
    #Address 0x5c7 Write value 0x8794eb18
    li x3, 0x8794eb18
    csrw 0x5c7, x3

    #Address 0x5c7 read value
    csrr x14, 0x5c7

    #Address 0x5c7 Write value 0x495236b1
    li x3, 0x495236b1
    csrw 0x5c7, x3

    #Address 0x5c7 Write value 0x5a09db2
    li x3, 0x5a09db2
    csrw 0x5c7, x3

    #Address 0x5c7 read value
    csrr x14, 0x5c7

    #Unmapped address 0xc8a testing: random write/read operations
    #Address 0xc8a read value
    csrr x14, 0xc8a

    #Address 0xc8a read value
    csrr x14, 0xc8a

    #Address 0xc8a read value
    csrr x14, 0xc8a

    #Address 0xc8a read value
    csrr x14, 0xc8a

    #Address 0xc8a Write value 0x13dcd23c
    li x3, 0x13dcd23c
    csrw 0xc8a, x3

    #Unmapped address 0xc5e testing: random write/read operations
    #Address 0xc5e read value
    csrr x14, 0xc5e

    #Address 0xc5e read value
    csrr x14, 0xc5e

    #Unmapped address 0x403 testing: random write/read operations
    #Address 0x403 read value
    csrr x14, 0x403

    #Address 0x403 read value
    csrr x14, 0x403

    #Unmapped address 0x94b testing: random write/read operations
    #Address 0x94b read value
    csrr x14, 0x94b

    #Address 0x94b read value
    csrr x14, 0x94b

    #Address 0x94b Write value 0xec435ec2
    li x3, 0xec435ec2
    csrw 0x94b, x3

    #Unmapped address 0x4a3 testing: random write/read operations
    #Address 0x4a3 Write value 0xc828f693
    li x3, 0xc828f693
    csrw 0x4a3, x3

    #Address 0x4a3 Write value 0xddb1c51d
    li x3, 0xddb1c51d
    csrw 0x4a3, x3

    #Address 0x4a3 read value
    csrr x14, 0x4a3

    #Address 0x4a3 Write value 0x3f2c76d8
    li x3, 0x3f2c76d8
    csrw 0x4a3, x3

    #Unmapped address 0xc45 testing: random write/read operations
    #Address 0xc45 read value
    csrr x14, 0xc45

    #Unmapped address 0xa98 testing: random write/read operations
    #Address 0xa98 read value
    csrr x14, 0xa98

    #Address 0xa98 Write value 0xb84d1ba0
    li x3, 0xb84d1ba0
    csrw 0xa98, x3

    #Address 0xa98 Write value 0x3084ff50
    li x3, 0x3084ff50
    csrw 0xa98, x3

    #Unmapped address 0x7b8 testing: random write/read operations
    #Address 0x7b8 read value
    csrr x14, 0x7b8

    #Address 0x7b8 read value
    csrr x14, 0x7b8

    #Unmapped address 0x3c9 testing: random write/read operations
    #Address 0x3c9 Write value 0x9d30997a
    li x3, 0x9d30997a
    csrw 0x3c9, x3

    #Address 0x3c9 Write value 0xeec864f8
    li x3, 0xeec864f8
    csrw 0x3c9, x3

    #Address 0x3c9 Write value 0x65250000
    li x3, 0x65250000
    csrw 0x3c9, x3

    #Address 0x3c9 Write value 0xf92dbbb4
    li x3, 0xf92dbbb4
    csrw 0x3c9, x3

    #Unmapped address 0x729 testing: random write/read operations
    #Address 0x729 Write value 0x14755d71
    li x3, 0x14755d71
    csrw 0x729, x3

    #Address 0x729 Write value 0x9c0d351f
    li x3, 0x9c0d351f
    csrw 0x729, x3

    #Address 0x729 read value
    csrr x14, 0x729

    #Unmapped address 0x36a testing: random write/read operations
    #Address 0x36a read value
    csrr x14, 0x36a

    #Address 0x36a Write value 0xfd3de2f5
    li x3, 0xfd3de2f5
    csrw 0x36a, x3

    #Unmapped address 0xffb testing: random write/read operations
    #Address 0xffb Write value 0xce74c8dd
    li x3, 0xce74c8dd
    csrw 0xffb, x3

    #Address 0xffb Write value 0x294e5df1
    li x3, 0x294e5df1
    csrw 0xffb, x3

    #Unmapped address 0x3c4 testing: random write/read operations
    #Address 0x3c4 read value
    csrr x14, 0x3c4

    #Unmapped address 0xca4 testing: random write/read operations
    #Address 0xca4 Write value 0x94cf8d8f
    li x3, 0x94cf8d8f
    csrw 0xca4, x3

    #Address 0xca4 Write value 0xb1692a83
    li x3, 0xb1692a83
    csrw 0xca4, x3

    #Address 0xca4 read value
    csrr x14, 0xca4

    #Unmapped address 0x9db testing: random write/read operations
    #Address 0x9db Write value 0xa6ff3827
    li x3, 0xa6ff3827
    csrw 0x9db, x3

    #Address 0x9db Write value 0xaa4d8b1f
    li x3, 0xaa4d8b1f
    csrw 0x9db, x3

    #Address 0x9db read value
    csrr x14, 0x9db

    #Mapped address 0x33c (mhpmevent28) testing: random write/read operations
    #Address 0x33c Write value 0xe5b597e9
    li x3, 0xe5b597e9
    csrw 0x33c, x3

    #Address 0x33c Write value 0x10ac9f49
    li x3, 0x10ac9f49
    csrw 0x33c, x3

    #Address 0x33c Write value 0x6b9ef4d1
    li x3, 0x6b9ef4d1
    csrw 0x33c, x3

    #Address 0x33c read value
    csrr x14, 0x33c

    #Unmapped address 0x2b9 testing: random write/read operations
    #Address 0x2b9 read value
    csrr x14, 0x2b9

    #Address 0x2b9 read value
    csrr x14, 0x2b9

    #Unmapped address 0xb4b testing: random write/read operations
    #Address 0xb4b Write value 0xaef817c
    li x3, 0xaef817c
    csrw 0xb4b, x3

    #Address 0xb4b Write value 0x43752975
    li x3, 0x43752975
    csrw 0xb4b, x3

    #Address 0xb4b Write value 0x3e6912ee
    li x3, 0x3e6912ee
    csrw 0xb4b, x3

    #Unmapped address 0xde3 testing: random write/read operations
    #Address 0xde3 read value
    csrr x14, 0xde3

    #Address 0xde3 read value
    csrr x14, 0xde3

    #Address 0xde3 Write value 0x3bb56cfb
    li x3, 0x3bb56cfb
    csrw 0xde3, x3

    #Unmapped address 0x5b7 testing: random write/read operations
    #Address 0x5b7 Write value 0xa94214aa
    li x3, 0xa94214aa
    csrw 0x5b7, x3

    #Unmapped address 0x6ed testing: random write/read operations
    #Address 0x6ed Write value 0x4841471d
    li x3, 0x4841471d
    csrw 0x6ed, x3

    #Address 0x6ed Write value 0xd791876b
    li x3, 0xd791876b
    csrw 0x6ed, x3

    #Address 0x6ed Write value 0x9647941a
    li x3, 0x9647941a
    csrw 0x6ed, x3

    #Address 0x6ed read value
    csrr x14, 0x6ed

    #Unmapped address 0xa0e testing: random write/read operations
    #Address 0xa0e read value
    csrr x14, 0xa0e

    #Address 0xa0e Write value 0xf015d71
    li x3, 0xf015d71
    csrw 0xa0e, x3

    #Address 0xa0e read value
    csrr x14, 0xa0e

    #Address 0xa0e read value
    csrr x14, 0xa0e

    #Unmapped address 0xce0 testing: random write/read operations
    #Address 0xce0 Write value 0x7a108a24
    li x3, 0x7a108a24
    csrw 0xce0, x3

    #Address 0xce0 read value
    csrr x14, 0xce0

    #Address 0xce0 read value
    csrr x14, 0xce0

    #Address 0xce0 read value
    csrr x14, 0xce0

    #Address 0xce0 Write value 0xbd495a06
    li x3, 0xbd495a06
    csrw 0xce0, x3

    #Unmapped address 0xbfe testing: random write/read operations
    #Address 0xbfe read value
    csrr x14, 0xbfe

    #Address 0xbfe read value
    csrr x14, 0xbfe

    #Address 0xbfe read value
    csrr x14, 0xbfe

    #Address 0xbfe read value
    csrr x14, 0xbfe

    #Address 0xbfe Write value 0xa93266d4
    li x3, 0xa93266d4
    csrw 0xbfe, x3

    #Unmapped address 0xe17 testing: random write/read operations
    #Address 0xe17 read value
    csrr x14, 0xe17

    #Address 0xe17 Write value 0xe385bc73
    li x3, 0xe385bc73
    csrw 0xe17, x3

    #Address 0xe17 read value
    csrr x14, 0xe17

    #Address 0xe17 Write value 0x610ef370
    li x3, 0x610ef370
    csrw 0xe17, x3

    #Address 0xe17 read value
    csrr x14, 0xe17

    #Unmapped address 0x23b testing: random write/read operations
    #Address 0x23b read value
    csrr x14, 0x23b

    #Address 0x23b Write value 0x387f1fd4
    li x3, 0x387f1fd4
    csrw 0x23b, x3

    #Address 0x23b read value
    csrr x14, 0x23b

    #Address 0x23b Write value 0x47e1bc14
    li x3, 0x47e1bc14
    csrw 0x23b, x3

    #Address 0x23b read value
    csrr x14, 0x23b

    #Unmapped address 0x855 testing: random write/read operations
    #Address 0x855 read value
    csrr x14, 0x855

    #Address 0x855 read value
    csrr x14, 0x855

    #Address 0x855 Write value 0x2bfa16f6
    li x3, 0x2bfa16f6
    csrw 0x855, x3

    #Mapped address 0x3bc (pmpaddr12) testing: random write/read operations
    #Address 0x3bc Write value 0x7cbf7407
    li x3, 0x7cbf7407
    csrw 0x3bc, x3

    #Address 0x3bc read value
    csrr x14, 0x3bc

    #Address 0x3bc Write value 0x57f28593
    li x3, 0x57f28593
    csrw 0x3bc, x3

    #Address 0x3bc read value
    csrr x14, 0x3bc

    #Address 0x3bc read value
    csrr x14, 0x3bc

    #Unmapped address 0x4b testing: random write/read operations
    #Address 0x4b Write value 0x667a8d3a
    li x3, 0x667a8d3a
    csrw 0x4b, x3

    #Address 0x4b read value
    csrr x14, 0x4b

    #Address 0x4b Write value 0x3436ffe3
    li x3, 0x3436ffe3
    csrw 0x4b, x3

    #Address 0x4b read value
    csrr x14, 0x4b

    #Address 0x4b Write value 0xb5729946
    li x3, 0xb5729946
    csrw 0x4b, x3

    #Unmapped address 0x12c testing: random write/read operations
    #Address 0x12c Write value 0xb7e89528
    li x3, 0xb7e89528
    csrw 0x12c, x3

    #Address 0x12c Write value 0x82143a90
    li x3, 0x82143a90
    csrw 0x12c, x3

    #Unmapped address 0xa3c testing: random write/read operations
    #Address 0xa3c Write value 0xd75a8cc0
    li x3, 0xd75a8cc0
    csrw 0xa3c, x3

    #Mapped address 0x3b4 (pmpaddr4) testing: random write/read operations
    #Address 0x3b4 Write value 0xe84e6e61
    li x3, 0xe84e6e61
    csrw 0x3b4, x3

    #Address 0x3b4 read value
    csrr x14, 0x3b4

    #Address 0x3b4 Write value 0x5bb9fd0c
    li x3, 0x5bb9fd0c
    csrw 0x3b4, x3

    #Address 0x3b4 read value
    csrr x14, 0x3b4

    #Mapped address 0xb95 (mhpmcounterh21) testing: random write/read operations
    #Address 0xb95 Write value 0x61e1a097
    li x3, 0x61e1a097
    csrw 0xb95, x3

    #Address 0xb95 Write value 0xa39b08c2
    li x3, 0xa39b08c2
    csrw 0xb95, x3

    #Address 0xb95 read value
    csrr x14, 0xb95

    #Address 0xb95 read value
    csrr x14, 0xb95

    #Address 0xb95 read value
    csrr x14, 0xb95

    #Unmapped address 0x463 testing: random write/read operations
    #Address 0x463 read value
    csrr x14, 0x463

    #Address 0x463 read value
    csrr x14, 0x463

    #Unmapped address 0x9b5 testing: random write/read operations
    #Address 0x9b5 Write value 0x7be95126
    li x3, 0x7be95126
    csrw 0x9b5, x3

    #Unmapped address 0x259 testing: random write/read operations
    #Address 0x259 Write value 0xb48eda6f
    li x3, 0xb48eda6f
    csrw 0x259, x3

    #Unmapped address 0x5f5 testing: random write/read operations
    #Address 0x5f5 Write value 0x7ee81fe
    li x3, 0x7ee81fe
    csrw 0x5f5, x3

    #Address 0x5f5 read value
    csrr x14, 0x5f5

    #Address 0x5f5 Write value 0x23d9d4b1
    li x3, 0x23d9d4b1
    csrw 0x5f5, x3

    #Unmapped address 0x926 testing: random write/read operations
    #Address 0x926 Write value 0xab6a6e3d
    li x3, 0xab6a6e3d
    csrw 0x926, x3

    #Unmapped address 0x8d1 testing: random write/read operations
    #Address 0x8d1 Write value 0xf6ec7129
    li x3, 0xf6ec7129
    csrw 0x8d1, x3

    #Address 0x8d1 Write value 0x2db3adcd
    li x3, 0x2db3adcd
    csrw 0x8d1, x3

    #Address 0x8d1 read value
    csrr x14, 0x8d1

    #Unmapped address 0xba testing: random write/read operations
    #Address 0xba Write value 0x4f14823
    li x3, 0x4f14823
    csrw 0xba, x3

    #Unmapped address 0xee9 testing: random write/read operations
    #Address 0xee9 read value
    csrr x14, 0xee9

    #Address 0xee9 Write value 0x8b182cda
    li x3, 0x8b182cda
    csrw 0xee9, x3

    #Unmapped address 0x290 testing: random write/read operations
    #Address 0x290 read value
    csrr x14, 0x290

    #Address 0x290 Write value 0xa3906539
    li x3, 0xa3906539
    csrw 0x290, x3

    #Unmapped address 0x91d testing: random write/read operations
    #Address 0x91d Write value 0x2fff0f58
    li x3, 0x2fff0f58
    csrw 0x91d, x3

    #Address 0x91d read value
    csrr x14, 0x91d

    #Address 0x91d read value
    csrr x14, 0x91d

    #Address 0x91d read value
    csrr x14, 0x91d

    #Address 0x91d Write value 0x419f3b4c
    li x3, 0x419f3b4c
    csrw 0x91d, x3

    #Unmapped address 0x377 testing: random write/read operations
    #Address 0x377 read value
    csrr x14, 0x377

    #Address 0x377 read value
    csrr x14, 0x377

    #Address 0x377 Write value 0xaf411c16
    li x3, 0xaf411c16
    csrw 0x377, x3

    #Address 0x377 read value
    csrr x14, 0x377

    #Address 0x377 Write value 0x7f9ec0c6
    li x3, 0x7f9ec0c6
    csrw 0x377, x3

    #Unmapped address 0x921 testing: random write/read operations
    #Address 0x921 read value
    csrr x14, 0x921

    #Unmapped address 0xa1c testing: random write/read operations
    #Address 0xa1c read value
    csrr x14, 0xa1c

    #Unmapped address 0xe54 testing: random write/read operations
    #Address 0xe54 read value
    csrr x14, 0xe54

    #Address 0xe54 read value
    csrr x14, 0xe54

    #Address 0xe54 Write value 0xbfc9efce
    li x3, 0xbfc9efce
    csrw 0xe54, x3

    #Unmapped address 0x2d9 testing: random write/read operations
    #Address 0x2d9 read value
    csrr x14, 0x2d9

    #Address 0x2d9 Write value 0x95b0cb28
    li x3, 0x95b0cb28
    csrw 0x2d9, x3

    #Address 0x2d9 Write value 0x3c1bc8b3
    li x3, 0x3c1bc8b3
    csrw 0x2d9, x3

    #Unmapped address 0xd80 testing: random write/read operations
    #Address 0xd80 Write value 0x686af54a
    li x3, 0x686af54a
    csrw 0xd80, x3

    #Unmapped address 0x7b5 testing: random write/read operations
    #Address 0x7b5 read value
    csrr x14, 0x7b5

    #Unmapped address 0x812 testing: random write/read operations
    #Address 0x812 Write value 0x436fc2de
    li x3, 0x436fc2de
    csrw 0x812, x3

    #Address 0x812 read value
    csrr x14, 0x812

    #Address 0x812 Write value 0xab80f9b4
    li x3, 0xab80f9b4
    csrw 0x812, x3

    #Unmapped address 0x81a testing: random write/read operations
    #Address 0x81a read value
    csrr x14, 0x81a

    #Address 0x81a Write value 0xcf4bb3c0
    li x3, 0xcf4bb3c0
    csrw 0x81a, x3

    #Address 0x81a Write value 0x52083db2
    li x3, 0x52083db2
    csrw 0x81a, x3

    #Address 0x81a Write value 0x8debc953
    li x3, 0x8debc953
    csrw 0x81a, x3

    #Address 0x81a read value
    csrr x14, 0x81a

    #Unmapped address 0x59d testing: random write/read operations
    #Address 0x59d read value
    csrr x14, 0x59d

    #Address 0x59d read value
    csrr x14, 0x59d

    #Address 0x59d Write value 0x39ccaf41
    li x3, 0x39ccaf41
    csrw 0x59d, x3

    #Unmapped address 0xa9 testing: random write/read operations
    #Address 0xa9 read value
    csrr x14, 0xa9

    #Address 0xa9 read value
    csrr x14, 0xa9

    #Address 0xa9 read value
    csrr x14, 0xa9

    #Unmapped address 0xde testing: random write/read operations
    #Address 0xde Write value 0x2aa5e1a4
    li x3, 0x2aa5e1a4
    csrw 0xde, x3

    #Address 0xde Write value 0xeb84b4d0
    li x3, 0xeb84b4d0
    csrw 0xde, x3

    #Unmapped address 0x89f testing: random write/read operations
    #Address 0x89f Write value 0x39df4d37
    li x3, 0x39df4d37
    csrw 0x89f, x3

    #Address 0x89f read value
    csrr x14, 0x89f

    #Address 0x89f read value
    csrr x14, 0x89f

    #Address 0x89f Write value 0xe5d50aa8
    li x3, 0xe5d50aa8
    csrw 0x89f, x3

    #Unmapped address 0x6b1 testing: random write/read operations
    #Address 0x6b1 read value
    csrr x14, 0x6b1

    #Unmapped address 0x40e testing: random write/read operations
    #Address 0x40e Write value 0x2d0b5f20
    li x3, 0x2d0b5f20
    csrw 0x40e, x3

    #Address 0x40e Write value 0x17d3c582
    li x3, 0x17d3c582
    csrw 0x40e, x3

    #Address 0x40e Write value 0xfbeb8bb5
    li x3, 0xfbeb8bb5
    csrw 0x40e, x3

    #Unmapped address 0x2c testing: random write/read operations
    #Address 0x2c Write value 0x56d1d653
    li x3, 0x56d1d653
    csrw 0x2c, x3

    #Address 0x2c read value
    csrr x14, 0x2c

    #Unmapped address 0x70f testing: random write/read operations
    #Address 0x70f read value
    csrr x14, 0x70f

    #Address 0x70f read value
    csrr x14, 0x70f

    #Unmapped address 0x998 testing: random write/read operations
    #Address 0x998 Write value 0x91bdb18
    li x3, 0x91bdb18
    csrw 0x998, x3

    #Address 0x998 read value
    csrr x14, 0x998

    #Address 0x998 read value
    csrr x14, 0x998

    #Address 0x998 Write value 0x30094ae1
    li x3, 0x30094ae1
    csrw 0x998, x3

    #Unmapped address 0x71c testing: random write/read operations
    #Address 0x71c read value
    csrr x14, 0x71c

    #Address 0x71c read value
    csrr x14, 0x71c

    #Address 0x71c read value
    csrr x14, 0x71c

    #Address 0x71c read value
    csrr x14, 0x71c

    #Address 0x71c Write value 0x3198f9cb
    li x3, 0x3198f9cb
    csrw 0x71c, x3

    #Unmapped address 0x1f2 testing: random write/read operations
    #Address 0x1f2 Write value 0x16ac8458
    li x3, 0x16ac8458
    csrw 0x1f2, x3

    #Address 0x1f2 Write value 0xad5d2d0d
    li x3, 0xad5d2d0d
    csrw 0x1f2, x3

    #Address 0x1f2 Write value 0xe719d43a
    li x3, 0xe719d43a
    csrw 0x1f2, x3

    #Address 0x1f2 read value
    csrr x14, 0x1f2

    #Unmapped address 0x40 testing: random write/read operations
    #Address 0x40 Write value 0x2d8005c3
    li x3, 0x2d8005c3
    csrw 0x40, x3

    #Address 0x40 Write value 0xf28571cb
    li x3, 0xf28571cb
    csrw 0x40, x3

    #Unmapped address 0xf06 testing: random write/read operations
    #Address 0xf06 read value
    csrr x14, 0xf06

    #Address 0xf06 read value
    csrr x14, 0xf06

    #Unmapped address 0xea9 testing: random write/read operations
    #Address 0xea9 read value
    csrr x14, 0xea9

    #Address 0xea9 Write value 0x7414effe
    li x3, 0x7414effe
    csrw 0xea9, x3

    #Unmapped address 0x990 testing: random write/read operations
    #Address 0x990 Write value 0x527e3827
    li x3, 0x527e3827
    csrw 0x990, x3

    #Address 0x990 read value
    csrr x14, 0x990

    #Unmapped address 0x2d testing: random write/read operations
    #Address 0x2d read value
    csrr x14, 0x2d

    #Address 0x2d Write value 0x94adadbd
    li x3, 0x94adadbd
    csrw 0x2d, x3

    #Address 0x2d read value
    csrr x14, 0x2d

    #Unmapped address 0x5a9 testing: random write/read operations
    #Address 0x5a9 Write value 0x8629413
    li x3, 0x8629413
    csrw 0x5a9, x3

    #Address 0x5a9 read value
    csrr x14, 0x5a9

    #Address 0x5a9 read value
    csrr x14, 0x5a9

    #Address 0x5a9 Write value 0x93af287b
    li x3, 0x93af287b
    csrw 0x5a9, x3

    #Unmapped address 0x8bb testing: random write/read operations
    #Address 0x8bb Write value 0xc7d388c7
    li x3, 0xc7d388c7
    csrw 0x8bb, x3

    #Address 0x8bb read value
    csrr x14, 0x8bb

    #Address 0x8bb Write value 0xbc4303df
    li x3, 0xbc4303df
    csrw 0x8bb, x3

    #Address 0x8bb Write value 0x8e3e9a2e
    li x3, 0x8e3e9a2e
    csrw 0x8bb, x3

    #Address 0x8bb read value
    csrr x14, 0x8bb

    #Unmapped address 0xba0 testing: random write/read operations
    #Address 0xba0 Write value 0x86158858
    li x3, 0x86158858
    csrw 0xba0, x3

    #Unmapped address 0x79d testing: random write/read operations
    #Address 0x79d read value
    csrr x14, 0x79d

    #Unmapped address 0xf2d testing: random write/read operations
    #Address 0xf2d Write value 0x49c4fc41
    li x3, 0x49c4fc41
    csrw 0xf2d, x3

    #Unmapped address 0x228 testing: random write/read operations
    #Address 0x228 Write value 0xb9c5a204
    li x3, 0xb9c5a204
    csrw 0x228, x3

    #Address 0x228 Write value 0xf99d1551
    li x3, 0xf99d1551
    csrw 0x228, x3

    #Unmapped address 0xc01 testing: random write/read operations
    #Address 0xc01 read value
    csrr x14, 0xc01

    #Address 0xc01 Write value 0xd9a9e617
    li x3, 0xd9a9e617
    csrw 0xc01, x3

    #Address 0xc01 Write value 0xe9f90b69
    li x3, 0xe9f90b69
    csrw 0xc01, x3

    #Address 0xc01 read value
    csrr x14, 0xc01

    #Address 0xc01 read value
    csrr x14, 0xc01

    #Unmapped address 0xdc1 testing: random write/read operations
    #Address 0xdc1 read value
    csrr x14, 0xdc1

    #Unmapped address 0x508 testing: random write/read operations
    #Address 0x508 read value
    csrr x14, 0x508

    #Unmapped address 0x499 testing: random write/read operations
    #Address 0x499 Write value 0x5d3700af
    li x3, 0x5d3700af
    csrw 0x499, x3

    #Address 0x499 read value
    csrr x14, 0x499

    #Address 0x499 Write value 0x8f096aac
    li x3, 0x8f096aac
    csrw 0x499, x3

    #Address 0x499 read value
    csrr x14, 0x499

    #Unmapped address 0x852 testing: random write/read operations
    #Address 0x852 read value
    csrr x14, 0x852

    #Unmapped address 0x8c5 testing: random write/read operations
    #Address 0x8c5 read value
    csrr x14, 0x8c5

    #Address 0x8c5 read value
    csrr x14, 0x8c5

    #Unmapped address 0x826 testing: random write/read operations
    #Address 0x826 Write value 0x560e6331
    li x3, 0x560e6331
    csrw 0x826, x3

    #Address 0x826 read value
    csrr x14, 0x826

    #Unmapped address 0x71b testing: random write/read operations
    #Address 0x71b Write value 0xee3b37f6
    li x3, 0xee3b37f6
    csrw 0x71b, x3

    #Address 0x71b Write value 0xd2b3f7c7
    li x3, 0xd2b3f7c7
    csrw 0x71b, x3

    #Address 0x71b read value
    csrr x14, 0x71b

    #Unmapped address 0x36f testing: random write/read operations
    #Address 0x36f Write value 0x7e28e1a1
    li x3, 0x7e28e1a1
    csrw 0x36f, x3

    #Address 0x36f Write value 0x4dd454
    li x3, 0x4dd454
    csrw 0x36f, x3

    #Address 0x36f read value
    csrr x14, 0x36f

    #Unmapped address 0x2f7 testing: random write/read operations
    #Address 0x2f7 Write value 0x9936bc14
    li x3, 0x9936bc14
    csrw 0x2f7, x3

    #Unmapped address 0x9fd testing: random write/read operations
    #Address 0x9fd read value
    csrr x14, 0x9fd

    #Address 0x9fd Write value 0x5d2eeb4a
    li x3, 0x5d2eeb4a
    csrw 0x9fd, x3

    #Address 0x9fd read value
    csrr x14, 0x9fd

    #Address 0x9fd Write value 0x4f207dca
    li x3, 0x4f207dca
    csrw 0x9fd, x3

    #Address 0x9fd read value
    csrr x14, 0x9fd

    #Unmapped address 0xf20 testing: random write/read operations
    #Address 0xf20 read value
    csrr x14, 0xf20

    #Address 0xf20 Write value 0xe107fd51
    li x3, 0xe107fd51
    csrw 0xf20, x3

    #Unmapped address 0x4c5 testing: random write/read operations
    #Address 0x4c5 Write value 0xef8fc173
    li x3, 0xef8fc173
    csrw 0x4c5, x3

    #Address 0x4c5 Write value 0x57680301
    li x3, 0x57680301
    csrw 0x4c5, x3

    #Unmapped address 0x61c testing: random write/read operations
    #Address 0x61c Write value 0xeee14a89
    li x3, 0xeee14a89
    csrw 0x61c, x3

    #Address 0x61c Write value 0x6054a7fb
    li x3, 0x6054a7fb
    csrw 0x61c, x3

    #Address 0x61c Write value 0x189a3c37
    li x3, 0x189a3c37
    csrw 0x61c, x3

    #Address 0x61c Write value 0x8e1a0b5a
    li x3, 0x8e1a0b5a
    csrw 0x61c, x3

    #Unmapped address 0x319 testing: random write/read operations
    #Address 0x319 read value
    csrr x14, 0x319

    #Address 0x319 Write value 0x93bf5b5e
    li x3, 0x93bf5b5e
    csrw 0x319, x3

    #Address 0x319 read value
    csrr x14, 0x319

    #Address 0x319 read value
    csrr x14, 0x319

    #Unmapped address 0xe51 testing: random write/read operations
    #Address 0xe51 read value
    csrr x14, 0xe51

    #Address 0xe51 read value
    csrr x14, 0xe51

    #Address 0xe51 read value
    csrr x14, 0xe51

    #Address 0xe51 read value
    csrr x14, 0xe51

    #Address 0xe51 Write value 0xf7e28a26
    li x3, 0xf7e28a26
    csrw 0xe51, x3

    #Unmapped address 0xd89 testing: random write/read operations
    #Address 0xd89 read value
    csrr x14, 0xd89

    #Address 0xd89 read value
    csrr x14, 0xd89

    #Unmapped address 0xd6e testing: random write/read operations
    #Address 0xd6e read value
    csrr x14, 0xd6e

    #Address 0xd6e Write value 0x3275150f
    li x3, 0x3275150f
    csrw 0xd6e, x3

    #Address 0xd6e read value
    csrr x14, 0xd6e

    #Address 0xd6e Write value 0xcbaa16ce
    li x3, 0xcbaa16ce
    csrw 0xd6e, x3

    #Unmapped address 0xfe0 testing: random write/read operations
    #Address 0xfe0 Write value 0x933a0876
    li x3, 0x933a0876
    csrw 0xfe0, x3

    #Address 0xfe0 read value
    csrr x14, 0xfe0

    #Address 0xfe0 read value
    csrr x14, 0xfe0

    #Address 0xfe0 read value
    csrr x14, 0xfe0

    #Unmapped address 0xe8d testing: random write/read operations
    #Address 0xe8d Write value 0xca91f7c2
    li x3, 0xca91f7c2
    csrw 0xe8d, x3

    #Address 0xe8d read value
    csrr x14, 0xe8d

    #Address 0xe8d read value
    csrr x14, 0xe8d

    #Address 0xe8d Write value 0x702d20dd
    li x3, 0x702d20dd
    csrw 0xe8d, x3

    #Address 0xe8d read value
    csrr x14, 0xe8d

    #Unmapped address 0xa6f testing: random write/read operations
    #Address 0xa6f read value
    csrr x14, 0xa6f

    #Address 0xa6f Write value 0xcfa32356
    li x3, 0xcfa32356
    csrw 0xa6f, x3

    #Address 0xa6f read value
    csrr x14, 0xa6f

    #Unmapped address 0xed6 testing: random write/read operations
    #Address 0xed6 Write value 0x80bce286
    li x3, 0x80bce286
    csrw 0xed6, x3

    #Unmapped address 0x703 testing: random write/read operations
    #Address 0x703 read value
    csrr x14, 0x703

    #Address 0x703 read value
    csrr x14, 0x703

    #Unmapped address 0xc1f testing: random write/read operations
    #Address 0xc1f read value
    csrr x14, 0xc1f

    #Address 0xc1f read value
    csrr x14, 0xc1f

    #Address 0xc1f read value
    csrr x14, 0xc1f

    #Unmapped address 0x80c testing: random write/read operations
    #Address 0x80c read value
    csrr x14, 0x80c

    #Address 0x80c Write value 0x16a41476
    li x3, 0x16a41476
    csrw 0x80c, x3

    #Address 0x80c read value
    csrr x14, 0x80c

    #Address 0x80c Write value 0x4be2e6e8
    li x3, 0x4be2e6e8
    csrw 0x80c, x3

    #Unmapped address 0x5fd testing: random write/read operations
    #Address 0x5fd Write value 0x89bf4e91
    li x3, 0x89bf4e91
    csrw 0x5fd, x3

    #Address 0x5fd Write value 0x2c2aa97b
    li x3, 0x2c2aa97b
    csrw 0x5fd, x3

    #Unmapped address 0xaf testing: random write/read operations
    #Address 0xaf read value
    csrr x14, 0xaf

    #Unmapped address 0x850 testing: random write/read operations
    #Address 0x850 read value
    csrr x14, 0x850

    #Unmapped address 0xfc1 testing: random write/read operations
    #Address 0xfc1 read value
    csrr x14, 0xfc1

    #Unmapped address 0x3e5 testing: random write/read operations
    #Address 0x3e5 read value
    csrr x14, 0x3e5

    #Unmapped address 0x2fb testing: random write/read operations
    #Address 0x2fb Write value 0x551efd2d
    li x3, 0x551efd2d
    csrw 0x2fb, x3

    #Address 0x2fb read value
    csrr x14, 0x2fb

    #Address 0x2fb Write value 0x2fd3f2a7
    li x3, 0x2fd3f2a7
    csrw 0x2fb, x3

    #Unmapped address 0x75 testing: random write/read operations
    #Address 0x75 read value
    csrr x14, 0x75

    #Mapped address 0x3b3 (pmpaddr3) testing: random write/read operations
    #Address 0x3b3 read value
    csrr x14, 0x3b3

    #Address 0x3b3 Write value 0xd986a48d
    li x3, 0xd986a48d
    csrw 0x3b3, x3

    #Address 0x3b3 Write value 0x7eee1778
    li x3, 0x7eee1778
    csrw 0x3b3, x3

    #Address 0x3b3 Write value 0x7b168971
    li x3, 0x7b168971
    csrw 0x3b3, x3

    #Address 0x3b3 read value
    csrr x14, 0x3b3

    #Unmapped address 0x621 testing: random write/read operations
    #Address 0x621 read value
    csrr x14, 0x621

    #Unmapped address 0x648 testing: random write/read operations
    #Address 0x648 read value
    csrr x14, 0x648

    #Unmapped address 0x1c7 testing: random write/read operations
    #Address 0x1c7 Write value 0x97813851
    li x3, 0x97813851
    csrw 0x1c7, x3

    #Unmapped address 0x5a4 testing: random write/read operations
    #Address 0x5a4 read value
    csrr x14, 0x5a4

    #Address 0x5a4 Write value 0x4c8e9a82
    li x3, 0x4c8e9a82
    csrw 0x5a4, x3

    #Address 0x5a4 read value
    csrr x14, 0x5a4

    #Address 0x5a4 read value
    csrr x14, 0x5a4

    #Unmapped address 0x248 testing: random write/read operations
    #Address 0x248 Write value 0x7fea6df6
    li x3, 0x7fea6df6
    csrw 0x248, x3

    #Address 0x248 Write value 0x1901d8e5
    li x3, 0x1901d8e5
    csrw 0x248, x3

    #Address 0x248 read value
    csrr x14, 0x248

    #Address 0x248 read value
    csrr x14, 0x248

    #Mapped address 0x337 (mhpmevent23) testing: random write/read operations
    #Address 0x337 read value
    csrr x14, 0x337

    #Address 0x337 Write value 0xd2db4a47
    li x3, 0xd2db4a47
    csrw 0x337, x3

    #Address 0x337 read value
    csrr x14, 0x337

    #Address 0x337 Write value 0x1aef72aa
    li x3, 0x1aef72aa
    csrw 0x337, x3

    #Address 0x337 Write value 0xec0fdc74
    li x3, 0xec0fdc74
    csrw 0x337, x3

    #Unmapped address 0x5f8 testing: random write/read operations
    #Address 0x5f8 read value
    csrr x14, 0x5f8

    #Address 0x5f8 read value
    csrr x14, 0x5f8

    #Address 0x5f8 read value
    csrr x14, 0x5f8

    #Address 0x5f8 Write value 0xfcd31ade
    li x3, 0xfcd31ade
    csrw 0x5f8, x3

    #Address 0x5f8 read value
    csrr x14, 0x5f8

    #Unmapped address 0x484 testing: random write/read operations
    #Address 0x484 Write value 0x345799f3
    li x3, 0x345799f3
    csrw 0x484, x3

    #Address 0x484 read value
    csrr x14, 0x484

    #Address 0x484 Write value 0x8785fad9
    li x3, 0x8785fad9
    csrw 0x484, x3

    #Unmapped address 0xbbb testing: random write/read operations
    #Address 0xbbb Write value 0x3b51edaa
    li x3, 0x3b51edaa
    csrw 0xbbb, x3

    #Address 0xbbb Write value 0x69129e03
    li x3, 0x69129e03
    csrw 0xbbb, x3

    #Address 0xbbb read value
    csrr x14, 0xbbb

    #Unmapped address 0x60f testing: random write/read operations
    #Address 0x60f read value
    csrr x14, 0x60f

    #Address 0x60f read value
    csrr x14, 0x60f

    #Address 0x60f Write value 0x6b0eff70
    li x3, 0x6b0eff70
    csrw 0x60f, x3

    #Address 0x60f Write value 0x1f84c320
    li x3, 0x1f84c320
    csrw 0x60f, x3

    #Unmapped address 0x17c testing: random write/read operations
    #Address 0x17c read value
    csrr x14, 0x17c

    #Address 0x17c read value
    csrr x14, 0x17c

    #Unmapped address 0x84 testing: random write/read operations
    #Address 0x84 Write value 0x75e8fbd3
    li x3, 0x75e8fbd3
    csrw 0x84, x3

    #Address 0x84 Write value 0xfcaaef9
    li x3, 0xfcaaef9
    csrw 0x84, x3

    #Address 0x84 read value
    csrr x14, 0x84

    #Address 0x84 Write value 0x600d8fcc
    li x3, 0x600d8fcc
    csrw 0x84, x3

    #Address 0x84 Write value 0xd51d3be7
    li x3, 0xd51d3be7
    csrw 0x84, x3

    #Unmapped address 0x462 testing: random write/read operations
    #Address 0x462 read value
    csrr x14, 0x462

    #Address 0x462 read value
    csrr x14, 0x462

    #Address 0x462 read value
    csrr x14, 0x462

    #Address 0x462 read value
    csrr x14, 0x462

    #Unmapped address 0xecd testing: random write/read operations
    #Address 0xecd Write value 0x6dc9e10c
    li x3, 0x6dc9e10c
    csrw 0xecd, x3

    #Unmapped address 0x740 testing: random write/read operations
    #Address 0x740 Write value 0x3eee7484
    li x3, 0x3eee7484
    csrw 0x740, x3

    #Address 0x740 Write value 0x7e02b888
    li x3, 0x7e02b888
    csrw 0x740, x3

    #Address 0x740 Write value 0xe745a67
    li x3, 0xe745a67
    csrw 0x740, x3

    #Address 0x740 read value
    csrr x14, 0x740

    #Address 0x740 read value
    csrr x14, 0x740

    #Unmapped address 0x6c2 testing: random write/read operations
    #Address 0x6c2 read value
    csrr x14, 0x6c2

    #Address 0x6c2 read value
    csrr x14, 0x6c2

    #Address 0x6c2 read value
    csrr x14, 0x6c2

    #Address 0x6c2 Write value 0xb875c170
    li x3, 0xb875c170
    csrw 0x6c2, x3

    #Address 0x6c2 Write value 0x2066dc5
    li x3, 0x2066dc5
    csrw 0x6c2, x3

    #Unmapped address 0xbc testing: random write/read operations
    #Address 0xbc read value
    csrr x14, 0xbc

    #Address 0xbc Write value 0x385db520
    li x3, 0x385db520
    csrw 0xbc, x3

    #Address 0xbc Write value 0xe62abf1c
    li x3, 0xe62abf1c
    csrw 0xbc, x3

    #Address 0xbc Write value 0x5ab13ba2
    li x3, 0x5ab13ba2
    csrw 0xbc, x3

    #Unmapped address 0x706 testing: random write/read operations
    #Address 0x706 read value
    csrr x14, 0x706

    #Unmapped address 0x9b4 testing: random write/read operations
    #Address 0x9b4 Write value 0x745f9328
    li x3, 0x745f9328
    csrw 0x9b4, x3

    #Unmapped address 0x8c6 testing: random write/read operations
    #Address 0x8c6 Write value 0x247ffe47
    li x3, 0x247ffe47
    csrw 0x8c6, x3

    #Address 0x8c6 Write value 0x9a5116e9
    li x3, 0x9a5116e9
    csrw 0x8c6, x3

    #Address 0x8c6 Write value 0xe7db7bc1
    li x3, 0xe7db7bc1
    csrw 0x8c6, x3

    #Unmapped address 0x55c testing: random write/read operations
    #Address 0x55c read value
    csrr x14, 0x55c

    #Address 0x55c read value
    csrr x14, 0x55c

    #Address 0x55c Write value 0x5257cf70
    li x3, 0x5257cf70
    csrw 0x55c, x3

    #Address 0x55c read value
    csrr x14, 0x55c

    #Unmapped address 0xd83 testing: random write/read operations
    #Address 0xd83 read value
    csrr x14, 0xd83

    #Address 0xd83 Write value 0xee62fb4b
    li x3, 0xee62fb4b
    csrw 0xd83, x3

    #Address 0xd83 read value
    csrr x14, 0xd83

    #Unmapped address 0xfb3 testing: random write/read operations
    #Address 0xfb3 read value
    csrr x14, 0xfb3

    #Address 0xfb3 read value
    csrr x14, 0xfb3

    #Address 0xfb3 Write value 0xc2b8ca20
    li x3, 0xc2b8ca20
    csrw 0xfb3, x3

    #Address 0xfb3 read value
    csrr x14, 0xfb3

    #Unmapped address 0x532 testing: random write/read operations
    #Address 0x532 Write value 0x79f5cea1
    li x3, 0x79f5cea1
    csrw 0x532, x3

    #Address 0x532 read value
    csrr x14, 0x532

    #Address 0x532 read value
    csrr x14, 0x532

    #Address 0x532 read value
    csrr x14, 0x532

    #Unmapped address 0x598 testing: random write/read operations
    #Address 0x598 Write value 0x8c1eb0bb
    li x3, 0x8c1eb0bb
    csrw 0x598, x3

    #Unmapped address 0x94e testing: random write/read operations
    #Address 0x94e read value
    csrr x14, 0x94e

    #Unmapped address 0x6c3 testing: random write/read operations
    #Address 0x6c3 read value
    csrr x14, 0x6c3

    #Unmapped address 0xd testing: random write/read operations
    #Address 0xd Write value 0xf0c945eb
    li x3, 0xf0c945eb
    csrw 0xd, x3

    #Address 0xd read value
    csrr x14, 0xd

    #Address 0xd Write value 0x1d3f0c3f
    li x3, 0x1d3f0c3f
    csrw 0xd, x3

    #Address 0xd read value
    csrr x14, 0xd

    #Unmapped address 0x2c7 testing: random write/read operations
    #Address 0x2c7 read value
    csrr x14, 0x2c7

    #Address 0x2c7 Write value 0x95129ce2
    li x3, 0x95129ce2
    csrw 0x2c7, x3

    #Address 0x2c7 Write value 0x1c88990b
    li x3, 0x1c88990b
    csrw 0x2c7, x3

    #Unmapped address 0xd4 testing: random write/read operations
    #Address 0xd4 read value
    csrr x14, 0xd4

    #Address 0xd4 Write value 0x8e277473
    li x3, 0x8e277473
    csrw 0xd4, x3

    #Address 0xd4 read value
    csrr x14, 0xd4

    #Address 0xd4 read value
    csrr x14, 0xd4

    #Address 0xd4 read value
    csrr x14, 0xd4

    #Unmapped address 0x6e7 testing: random write/read operations
    #Address 0x6e7 Write value 0x65114f50
    li x3, 0x65114f50
    csrw 0x6e7, x3

    #Unmapped address 0x66c testing: random write/read operations
    #Address 0x66c Write value 0x59fd9a2b
    li x3, 0x59fd9a2b
    csrw 0x66c, x3

    #Address 0x66c read value
    csrr x14, 0x66c

    #Address 0x66c read value
    csrr x14, 0x66c

    #Unmapped address 0x2af testing: random write/read operations
    #Address 0x2af Write value 0x8f825d97
    li x3, 0x8f825d97
    csrw 0x2af, x3

    #Address 0x2af Write value 0x51c27f66
    li x3, 0x51c27f66
    csrw 0x2af, x3

    #Address 0x2af read value
    csrr x14, 0x2af

    #Address 0x2af Write value 0x2ce2cf78
    li x3, 0x2ce2cf78
    csrw 0x2af, x3

    #Unmapped address 0xc78 testing: random write/read operations
    #Address 0xc78 Write value 0x51158ee2
    li x3, 0x51158ee2
    csrw 0xc78, x3

    #Address 0xc78 Write value 0x84217564
    li x3, 0x84217564
    csrw 0xc78, x3

    #Address 0xc78 Write value 0xf5662d0c
    li x3, 0xf5662d0c
    csrw 0xc78, x3

    #Address 0xc78 Write value 0x45dfc0a8
    li x3, 0x45dfc0a8
    csrw 0xc78, x3

    #Unmapped address 0xb55 testing: random write/read operations
    #Address 0xb55 Write value 0xfd7537d9
    li x3, 0xfd7537d9
    csrw 0xb55, x3

    #Address 0xb55 read value
    csrr x14, 0xb55

    #Address 0xb55 read value
    csrr x14, 0xb55

    #Address 0xb55 read value
    csrr x14, 0xb55

    #Address 0xb55 read value
    csrr x14, 0xb55

    #Unmapped address 0x761 testing: random write/read operations
    #Address 0x761 Write value 0x9505be6c
    li x3, 0x9505be6c
    csrw 0x761, x3

    #Address 0x761 Write value 0x87ba5016
    li x3, 0x87ba5016
    csrw 0x761, x3

    #Address 0x761 read value
    csrr x14, 0x761

    #Address 0x761 Write value 0xb5947640
    li x3, 0xb5947640
    csrw 0x761, x3

    #Unmapped address 0xe7e testing: random write/read operations
    #Address 0xe7e read value
    csrr x14, 0xe7e

    #Address 0xe7e Write value 0x9b6173ec
    li x3, 0x9b6173ec
    csrw 0xe7e, x3

    #Address 0xe7e read value
    csrr x14, 0xe7e

    #Unmapped address 0x82e testing: random write/read operations
    #Address 0x82e read value
    csrr x14, 0x82e

    #Address 0x82e Write value 0xf74e9c05
    li x3, 0xf74e9c05
    csrw 0x82e, x3

    #Address 0x82e Write value 0x3478a798
    li x3, 0x3478a798
    csrw 0x82e, x3

    #Address 0x82e read value
    csrr x14, 0x82e

    #Address 0x82e Write value 0x4e10dc3
    li x3, 0x4e10dc3
    csrw 0x82e, x3

    #Unmapped address 0xe26 testing: random write/read operations
    #Address 0xe26 read value
    csrr x14, 0xe26

    #Unmapped address 0xf0a testing: random write/read operations
    #Address 0xf0a Write value 0xe52819ea
    li x3, 0xe52819ea
    csrw 0xf0a, x3

    #Address 0xf0a Write value 0xf68b8eeb
    li x3, 0xf68b8eeb
    csrw 0xf0a, x3

    #Unmapped address 0x93e testing: random write/read operations
    #Address 0x93e Write value 0x34b50880
    li x3, 0x34b50880
    csrw 0x93e, x3

    #Address 0x93e Write value 0xfdbf281c
    li x3, 0xfdbf281c
    csrw 0x93e, x3

    #Address 0x93e read value
    csrr x14, 0x93e

    #Address 0x93e read value
    csrr x14, 0x93e

    #Address 0x93e Write value 0xf936bcbf
    li x3, 0xf936bcbf
    csrw 0x93e, x3

    #Unmapped address 0xb4f testing: random write/read operations
    #Address 0xb4f Write value 0x115020a1
    li x3, 0x115020a1
    csrw 0xb4f, x3

    #Unmapped address 0x721 testing: random write/read operations
    #Address 0x721 Write value 0x73031807
    li x3, 0x73031807
    csrw 0x721, x3

    #Address 0x721 read value
    csrr x14, 0x721

    #Address 0x721 Write value 0x6c7b7d13
    li x3, 0x6c7b7d13
    csrw 0x721, x3

    #Unmapped address 0x38b testing: random write/read operations
    #Address 0x38b Write value 0x2b188cbc
    li x3, 0x2b188cbc
    csrw 0x38b, x3

    #Address 0x38b Write value 0x62a43113
    li x3, 0x62a43113
    csrw 0x38b, x3

    #Address 0x38b read value
    csrr x14, 0x38b

    #Address 0x38b read value
    csrr x14, 0x38b

    #Address 0x38b Write value 0x79cce232
    li x3, 0x79cce232
    csrw 0x38b, x3

    #Unmapped address 0x899 testing: random write/read operations
    #Address 0x899 Write value 0x27a4cba5
    li x3, 0x27a4cba5
    csrw 0x899, x3

    #Address 0x899 read value
    csrr x14, 0x899

    #Address 0x899 read value
    csrr x14, 0x899

    #Unmapped address 0xa4 testing: random write/read operations
    #Address 0xa4 Write value 0x74ab89b5
    li x3, 0x74ab89b5
    csrw 0xa4, x3

    #Address 0xa4 Write value 0x99f517d7
    li x3, 0x99f517d7
    csrw 0xa4, x3

    #Address 0xa4 Write value 0xab7bd343
    li x3, 0xab7bd343
    csrw 0xa4, x3

    #Unmapped address 0xb43 testing: random write/read operations
    #Address 0xb43 read value
    csrr x14, 0xb43

    #Address 0xb43 read value
    csrr x14, 0xb43

    #Address 0xb43 read value
    csrr x14, 0xb43

    #Address 0xb43 Write value 0xf3534cec
    li x3, 0xf3534cec
    csrw 0xb43, x3

    #Address 0xb43 Write value 0xc98adb86
    li x3, 0xc98adb86
    csrw 0xb43, x3

    #Unmapped address 0x289 testing: random write/read operations
    #Address 0x289 Write value 0xb1576231
    li x3, 0xb1576231
    csrw 0x289, x3

    #Address 0x289 Write value 0x547df918
    li x3, 0x547df918
    csrw 0x289, x3

    #Unmapped address 0xd1b testing: random write/read operations
    #Address 0xd1b Write value 0x127bdb5c
    li x3, 0x127bdb5c
    csrw 0xd1b, x3

    #Address 0xd1b Write value 0xeeb4ef7f
    li x3, 0xeeb4ef7f
    csrw 0xd1b, x3

    #Unmapped address 0xd8d testing: random write/read operations
    #Address 0xd8d read value
    csrr x14, 0xd8d

    #Address 0xd8d Write value 0x7eac8829
    li x3, 0x7eac8829
    csrw 0xd8d, x3

    #Address 0xd8d Write value 0x3c665432
    li x3, 0x3c665432
    csrw 0xd8d, x3

    #Address 0xd8d read value
    csrr x14, 0xd8d

    #Unmapped address 0x8b9 testing: random write/read operations
    #Address 0x8b9 Write value 0x368656a8
    li x3, 0x368656a8
    csrw 0x8b9, x3

    #Unmapped address 0x895 testing: random write/read operations
    #Address 0x895 Write value 0x9fe8ec8e
    li x3, 0x9fe8ec8e
    csrw 0x895, x3

    #Address 0x895 Write value 0xacc38172
    li x3, 0xacc38172
    csrw 0x895, x3

    #Address 0x895 read value
    csrr x14, 0x895

    #Address 0x895 Write value 0x3cf67c8a
    li x3, 0x3cf67c8a
    csrw 0x895, x3

    #Address 0x895 read value
    csrr x14, 0x895

    #Unmapped address 0x63e testing: random write/read operations
    #Address 0x63e read value
    csrr x14, 0x63e

    #Address 0x63e Write value 0x1f63afc9
    li x3, 0x1f63afc9
    csrw 0x63e, x3

    #Address 0x63e read value
    csrr x14, 0x63e

    #Address 0x63e read value
    csrr x14, 0x63e

    #Address 0x63e read value
    csrr x14, 0x63e

    #Unmapped address 0x292 testing: random write/read operations
    #Address 0x292 read value
    csrr x14, 0x292

    #Address 0x292 read value
    csrr x14, 0x292

    #Address 0x292 read value
    csrr x14, 0x292

    #Address 0x292 Write value 0x5a7ef481
    li x3, 0x5a7ef481
    csrw 0x292, x3

    #Address 0x292 read value
    csrr x14, 0x292

    #Unmapped address 0x6d3 testing: random write/read operations
    #Address 0x6d3 Write value 0xd854405d
    li x3, 0xd854405d
    csrw 0x6d3, x3

    #Unmapped address 0x3e3 testing: random write/read operations
    #Address 0x3e3 Write value 0xe73456f9
    li x3, 0xe73456f9
    csrw 0x3e3, x3

    #Address 0x3e3 read value
    csrr x14, 0x3e3

    #Unmapped address 0xeff testing: random write/read operations
    #Address 0xeff read value
    csrr x14, 0xeff

    #Unmapped address 0xedf testing: random write/read operations
    #Address 0xedf Write value 0xa860388d
    li x3, 0xa860388d
    csrw 0xedf, x3

    #Address 0xedf read value
    csrr x14, 0xedf

    #Address 0xedf Write value 0xc9ae560c
    li x3, 0xc9ae560c
    csrw 0xedf, x3

    #Address 0xedf Write value 0xa4d767a9
    li x3, 0xa4d767a9
    csrw 0xedf, x3

    #Address 0xedf Write value 0xbaaa6a19
    li x3, 0xbaaa6a19
    csrw 0xedf, x3

    #Unmapped address 0x9c3 testing: random write/read operations
    #Address 0x9c3 read value
    csrr x14, 0x9c3

    #Address 0x9c3 read value
    csrr x14, 0x9c3

    #Address 0x9c3 Write value 0x7fe7c564
    li x3, 0x7fe7c564
    csrw 0x9c3, x3

    #Address 0x9c3 Write value 0xf29cef0a
    li x3, 0xf29cef0a
    csrw 0x9c3, x3

    #Unmapped address 0x9f0 testing: random write/read operations
    #Address 0x9f0 Write value 0x314a75ea
    li x3, 0x314a75ea
    csrw 0x9f0, x3

    #Address 0x9f0 Write value 0xa04f05ab
    li x3, 0xa04f05ab
    csrw 0x9f0, x3

    #Address 0x9f0 Write value 0xfab55e16
    li x3, 0xfab55e16
    csrw 0x9f0, x3

    #Address 0x9f0 Write value 0xc16f3709
    li x3, 0xc16f3709
    csrw 0x9f0, x3

    #Address 0x9f0 Write value 0xa823d531
    li x3, 0xa823d531
    csrw 0x9f0, x3

    #Unmapped address 0xe8c testing: random write/read operations
    #Address 0xe8c read value
    csrr x14, 0xe8c

    #Address 0xe8c Write value 0x2291779b
    li x3, 0x2291779b
    csrw 0xe8c, x3

    #Address 0xe8c Write value 0x1dc56cb4
    li x3, 0x1dc56cb4
    csrw 0xe8c, x3

    #Unmapped address 0x644 testing: random write/read operations
    #Address 0x644 read value
    csrr x14, 0x644

    #Address 0x644 Write value 0x9450643e
    li x3, 0x9450643e
    csrw 0x644, x3

    #Address 0x644 read value
    csrr x14, 0x644

    #Address 0x644 read value
    csrr x14, 0x644

    #Address 0x644 Write value 0xd7599e71
    li x3, 0xd7599e71
    csrw 0x644, x3

    #Unmapped address 0x925 testing: random write/read operations
    #Address 0x925 read value
    csrr x14, 0x925

    #Address 0x925 Write value 0xed884e82
    li x3, 0xed884e82
    csrw 0x925, x3

    #Address 0x925 Write value 0x8feb0a06
    li x3, 0x8feb0a06
    csrw 0x925, x3

    #Address 0x925 Write value 0xc241e5e8
    li x3, 0xc241e5e8
    csrw 0x925, x3

    #Address 0x925 read value
    csrr x14, 0x925

    #Unmapped address 0x705 testing: random write/read operations
    #Address 0x705 read value
    csrr x14, 0x705

    #Address 0x705 read value
    csrr x14, 0x705

    #Address 0x705 read value
    csrr x14, 0x705

    #Unmapped address 0xc1e testing: random write/read operations
    #Address 0xc1e Write value 0x64b499e8
    li x3, 0x64b499e8
    csrw 0xc1e, x3

    #Address 0xc1e Write value 0xee64e5e6
    li x3, 0xee64e5e6
    csrw 0xc1e, x3

    #Address 0xc1e read value
    csrr x14, 0xc1e

    #Address 0xc1e Write value 0xeae050f2
    li x3, 0xeae050f2
    csrw 0xc1e, x3

    #Address 0xc1e read value
    csrr x14, 0xc1e

    #Unmapped address 0xcda testing: random write/read operations
    #Address 0xcda read value
    csrr x14, 0xcda

    #Address 0xcda read value
    csrr x14, 0xcda

    #Address 0xcda Write value 0xc3f10bb4
    li x3, 0xc3f10bb4
    csrw 0xcda, x3

    #Unmapped address 0x80a testing: random write/read operations
    #Address 0x80a read value
    csrr x14, 0x80a

    #Address 0x80a read value
    csrr x14, 0x80a

    #Address 0x80a Write value 0xf0cb4703
    li x3, 0xf0cb4703
    csrw 0x80a, x3

    #Unmapped address 0x13 testing: random write/read operations
    #Address 0x13 Write value 0x60395973
    li x3, 0x60395973
    csrw 0x13, x3

    #Address 0x13 read value
    csrr x14, 0x13

    #Address 0x13 read value
    csrr x14, 0x13

    #Address 0x13 Write value 0x64716afc
    li x3, 0x64716afc
    csrw 0x13, x3

    #Unmapped address 0xfaf testing: random write/read operations
    #Address 0xfaf Write value 0xa94e1c3c
    li x3, 0xa94e1c3c
    csrw 0xfaf, x3

    #Address 0xfaf read value
    csrr x14, 0xfaf

    #Address 0xfaf Write value 0xca98156a
    li x3, 0xca98156a
    csrw 0xfaf, x3

    #Address 0xfaf Write value 0x21ec3c5a
    li x3, 0x21ec3c5a
    csrw 0xfaf, x3

    #Address 0xfaf read value
    csrr x14, 0xfaf

    #Unmapped address 0xc4b testing: random write/read operations
    #Address 0xc4b Write value 0xe96fc5c
    li x3, 0xe96fc5c
    csrw 0xc4b, x3

    #Address 0xc4b read value
    csrr x14, 0xc4b

    #Address 0xc4b read value
    csrr x14, 0xc4b

    #Unmapped address 0x9e9 testing: random write/read operations
    #Address 0x9e9 read value
    csrr x14, 0x9e9

    #Unmapped address 0x3a5 testing: random write/read operations
    #Address 0x3a5 read value
    csrr x14, 0x3a5

    #Address 0x3a5 read value
    csrr x14, 0x3a5

    #Address 0x3a5 read value
    csrr x14, 0x3a5

    #Address 0x3a5 read value
    csrr x14, 0x3a5

    #Unmapped address 0xa83 testing: random write/read operations
    #Address 0xa83 read value
    csrr x14, 0xa83

    #Unmapped address 0x957 testing: random write/read operations
    #Address 0x957 Write value 0x80a46e97
    li x3, 0x80a46e97
    csrw 0x957, x3

    #Address 0x957 read value
    csrr x14, 0x957

    #Address 0x957 Write value 0xcc696b04
    li x3, 0xcc696b04
    csrw 0x957, x3

    #Address 0x957 Write value 0x2ae18eb9
    li x3, 0x2ae18eb9
    csrw 0x957, x3

    #Unmapped address 0x8fe testing: random write/read operations
    #Address 0x8fe Write value 0x390d5d33
    li x3, 0x390d5d33
    csrw 0x8fe, x3

    #Address 0x8fe Write value 0xd1f9fa09
    li x3, 0xd1f9fa09
    csrw 0x8fe, x3

    #Unmapped address 0x26f testing: random write/read operations
    #Address 0x26f Write value 0xb29efa4d
    li x3, 0xb29efa4d
    csrw 0x26f, x3

    #Address 0x26f Write value 0xc13c3c07
    li x3, 0xc13c3c07
    csrw 0x26f, x3

    #Unmapped address 0xcf testing: random write/read operations
    #Address 0xcf Write value 0x8fc518cb
    li x3, 0x8fc518cb
    csrw 0xcf, x3

    #Address 0xcf Write value 0x7e04cb08
    li x3, 0x7e04cb08
    csrw 0xcf, x3

    #Address 0xcf read value
    csrr x14, 0xcf

    #Address 0xcf read value
    csrr x14, 0xcf

    #Unmapped address 0x76b testing: random write/read operations
    #Address 0x76b Write value 0x3e84238f
    li x3, 0x3e84238f
    csrw 0x76b, x3

    #Address 0x76b read value
    csrr x14, 0x76b

    #Unmapped address 0x412 testing: random write/read operations
    #Address 0x412 Write value 0x153a72cc
    li x3, 0x153a72cc
    csrw 0x412, x3

    #Address 0x412 Write value 0x9b297181
    li x3, 0x9b297181
    csrw 0x412, x3

    #Unmapped address 0x4fc testing: random write/read operations
    #Address 0x4fc Write value 0x341e4afb
    li x3, 0x341e4afb
    csrw 0x4fc, x3

    #Address 0x4fc read value
    csrr x14, 0x4fc

    #Address 0x4fc read value
    csrr x14, 0x4fc

    #Address 0x4fc read value
    csrr x14, 0x4fc

    #Address 0x4fc read value
    csrr x14, 0x4fc

    #Unmapped address 0x44d testing: random write/read operations
    #Address 0x44d Write value 0x6bdb68e3
    li x3, 0x6bdb68e3
    csrw 0x44d, x3

    #Address 0x44d Write value 0x860a996e
    li x3, 0x860a996e
    csrw 0x44d, x3

    #Address 0x44d read value
    csrr x14, 0x44d

    #Unmapped address 0xa0 testing: random write/read operations
    #Address 0xa0 Write value 0xf73952ec
    li x3, 0xf73952ec
    csrw 0xa0, x3

    #Address 0xa0 Write value 0x37638ef7
    li x3, 0x37638ef7
    csrw 0xa0, x3

    #Address 0xa0 read value
    csrr x14, 0xa0

    #Address 0xa0 Write value 0x3633e1e3
    li x3, 0x3633e1e3
    csrw 0xa0, x3

    #Address 0xa0 read value
    csrr x14, 0xa0

    #Unmapped address 0x84f testing: random write/read operations
    #Address 0x84f read value
    csrr x14, 0x84f

    #Address 0x84f read value
    csrr x14, 0x84f

    #Address 0x84f read value
    csrr x14, 0x84f

    #Address 0x84f read value
    csrr x14, 0x84f

    #Unmapped address 0xabe testing: random write/read operations
    #Address 0xabe read value
    csrr x14, 0xabe

    #Address 0xabe Write value 0x583c674a
    li x3, 0x583c674a
    csrw 0xabe, x3

    #Unmapped address 0xbeb testing: random write/read operations
    #Address 0xbeb read value
    csrr x14, 0xbeb

    #Address 0xbeb Write value 0xfaafb415
    li x3, 0xfaafb415
    csrw 0xbeb, x3

    #Address 0xbeb Write value 0x6a36e5e0
    li x3, 0x6a36e5e0
    csrw 0xbeb, x3

    #Address 0xbeb read value
    csrr x14, 0xbeb

    #Address 0xbeb Write value 0x7fd2f0aa
    li x3, 0x7fd2f0aa
    csrw 0xbeb, x3

    #Unmapped address 0x1a4 testing: random write/read operations
    #Address 0x1a4 Write value 0x2e7ab64e
    li x3, 0x2e7ab64e
    csrw 0x1a4, x3

    #Unmapped address 0x6ce testing: random write/read operations
    #Address 0x6ce read value
    csrr x14, 0x6ce

    #Address 0x6ce read value
    csrr x14, 0x6ce

    #Address 0x6ce read value
    csrr x14, 0x6ce

    #Unmapped address 0xf41 testing: random write/read operations
    #Address 0xf41 read value
    csrr x14, 0xf41

    #Address 0xf41 read value
    csrr x14, 0xf41

    #Address 0xf41 read value
    csrr x14, 0xf41

    #Address 0xf41 read value
    csrr x14, 0xf41

    #Unmapped address 0x5f3 testing: random write/read operations
    #Address 0x5f3 read value
    csrr x14, 0x5f3

    #Unmapped address 0xaf8 testing: random write/read operations
    #Address 0xaf8 read value
    csrr x14, 0xaf8

    #Address 0xaf8 read value
    csrr x14, 0xaf8

    #Address 0xaf8 read value
    csrr x14, 0xaf8

    #Address 0xaf8 read value
    csrr x14, 0xaf8

    #Unmapped address 0x73d testing: random write/read operations
    #Address 0x73d Write value 0x4552a55f
    li x3, 0x4552a55f
    csrw 0x73d, x3

    #Address 0x73d read value
    csrr x14, 0x73d

    #Address 0x73d read value
    csrr x14, 0x73d

    #Address 0x73d Write value 0xe9528489
    li x3, 0xe9528489
    csrw 0x73d, x3

    #Unmapped address 0xc3a testing: random write/read operations
    #Address 0xc3a Write value 0x28e4ac3
    li x3, 0x28e4ac3
    csrw 0xc3a, x3

    #Address 0xc3a Write value 0x975bfd98
    li x3, 0x975bfd98
    csrw 0xc3a, x3

    #Address 0xc3a read value
    csrr x14, 0xc3a

    #Address 0xc3a Write value 0x939498f8
    li x3, 0x939498f8
    csrw 0xc3a, x3

    #Unmapped address 0x62c testing: random write/read operations
    #Address 0x62c read value
    csrr x14, 0x62c

    #Address 0x62c read value
    csrr x14, 0x62c

    #Address 0x62c read value
    csrr x14, 0x62c

    #Address 0x62c read value
    csrr x14, 0x62c

    #Address 0x62c read value
    csrr x14, 0x62c

    #Unmapped address 0x5d8 testing: random write/read operations
    #Address 0x5d8 read value
    csrr x14, 0x5d8

    #Address 0x5d8 Write value 0xc783a574
    li x3, 0xc783a574
    csrw 0x5d8, x3

    #Address 0x5d8 Write value 0xf170c151
    li x3, 0xf170c151
    csrw 0x5d8, x3

    #Address 0x5d8 Write value 0x351ec508
    li x3, 0x351ec508
    csrw 0x5d8, x3

    #Unmapped address 0x90b testing: random write/read operations
    #Address 0x90b Write value 0xa5ad965b
    li x3, 0xa5ad965b
    csrw 0x90b, x3

    #Address 0x90b Write value 0x607a5882
    li x3, 0x607a5882
    csrw 0x90b, x3

    #Address 0x90b read value
    csrr x14, 0x90b

    #Address 0x90b read value
    csrr x14, 0x90b

    #Address 0x90b read value
    csrr x14, 0x90b

    #Unmapped address 0xb3e testing: random write/read operations
    #Address 0xb3e Write value 0xc0835b23
    li x3, 0xc0835b23
    csrw 0xb3e, x3

    #Address 0xb3e Write value 0x90b1ea45
    li x3, 0x90b1ea45
    csrw 0xb3e, x3

    #Address 0xb3e read value
    csrr x14, 0xb3e

    #Unmapped address 0x568 testing: random write/read operations
    #Address 0x568 read value
    csrr x14, 0x568

    #Address 0x568 Write value 0x5d2dbe6c
    li x3, 0x5d2dbe6c
    csrw 0x568, x3

    #Address 0x568 read value
    csrr x14, 0x568

    #Address 0x568 Write value 0x3e00b9ea
    li x3, 0x3e00b9ea
    csrw 0x568, x3

    #Mapped address 0x33e (mhpmevent30) testing: random write/read operations
    #Address 0x33e read value
    csrr x14, 0x33e

    #Address 0x33e Write value 0x8d01db99
    li x3, 0x8d01db99
    csrw 0x33e, x3

    #Address 0x33e read value
    csrr x14, 0x33e

    #Unmapped address 0xfa5 testing: random write/read operations
    #Address 0xfa5 Write value 0x98ffee3
    li x3, 0x98ffee3
    csrw 0xfa5, x3

    #Address 0xfa5 read value
    csrr x14, 0xfa5

    #Unmapped address 0x2a7 testing: random write/read operations
    #Address 0x2a7 Write value 0x48e18aac
    li x3, 0x48e18aac
    csrw 0x2a7, x3

    #Address 0x2a7 read value
    csrr x14, 0x2a7

    #Address 0x2a7 Write value 0x18880e33
    li x3, 0x18880e33
    csrw 0x2a7, x3

    #Address 0x2a7 Write value 0x71810a79
    li x3, 0x71810a79
    csrw 0x2a7, x3

    #Address 0x2a7 read value
    csrr x14, 0x2a7

    #Unmapped address 0x37f testing: random write/read operations
    #Address 0x37f read value
    csrr x14, 0x37f

    #Address 0x37f read value
    csrr x14, 0x37f

    #Address 0x37f Write value 0x42249c1d
    li x3, 0x42249c1d
    csrw 0x37f, x3

    #Address 0x37f Write value 0x2fef294e
    li x3, 0x2fef294e
    csrw 0x37f, x3

    #Unmapped address 0x43c testing: random write/read operations
    #Address 0x43c Write value 0x2c527f82
    li x3, 0x2c527f82
    csrw 0x43c, x3

    #Address 0x43c read value
    csrr x14, 0x43c

    #Address 0x43c Write value 0x7eb009df
    li x3, 0x7eb009df
    csrw 0x43c, x3

    #Address 0x43c Write value 0xba221578
    li x3, 0xba221578
    csrw 0x43c, x3

    #Unmapped address 0xee testing: random write/read operations
    #Address 0xee Write value 0x330c4213
    li x3, 0x330c4213
    csrw 0xee, x3

    #Address 0xee Write value 0xf4ed95d9
    li x3, 0xf4ed95d9
    csrw 0xee, x3

    #Address 0xee read value
    csrr x14, 0xee

    #Unmapped address 0xc2a testing: random write/read operations
    #Address 0xc2a Write value 0xd2de6029
    li x3, 0xd2de6029
    csrw 0xc2a, x3

    #Address 0xc2a Write value 0xb5dae8ae
    li x3, 0xb5dae8ae
    csrw 0xc2a, x3

    #Unmapped address 0xcb8 testing: random write/read operations
    #Address 0xcb8 Write value 0xc47a6765
    li x3, 0xc47a6765
    csrw 0xcb8, x3

    #Unmapped address 0x179 testing: random write/read operations
    #Address 0x179 Write value 0xca45fa9e
    li x3, 0xca45fa9e
    csrw 0x179, x3

    #Address 0x179 read value
    csrr x14, 0x179

    #Address 0x179 read value
    csrr x14, 0x179

    #Unmapped address 0x4dd testing: random write/read operations
    #Address 0x4dd read value
    csrr x14, 0x4dd

    #Address 0x4dd Write value 0x2d7597f7
    li x3, 0x2d7597f7
    csrw 0x4dd, x3

    #Address 0x4dd Write value 0xa49a7515
    li x3, 0xa49a7515
    csrw 0x4dd, x3

    #Address 0x4dd read value
    csrr x14, 0x4dd

    #Address 0x4dd read value
    csrr x14, 0x4dd

    #Unmapped address 0x37b testing: random write/read operations
    #Address 0x37b read value
    csrr x14, 0x37b

    #Address 0x37b Write value 0xec3efccc
    li x3, 0xec3efccc
    csrw 0x37b, x3

    #Address 0x37b read value
    csrr x14, 0x37b

    #Address 0x37b read value
    csrr x14, 0x37b

    #Address 0x37b read value
    csrr x14, 0x37b

    #Unmapped address 0x14a testing: random write/read operations
    #Address 0x14a Write value 0x4c1f3e0b
    li x3, 0x4c1f3e0b
    csrw 0x14a, x3

    #Address 0x14a Write value 0xda8b57e7
    li x3, 0xda8b57e7
    csrw 0x14a, x3

    #Unmapped address 0xf51 testing: random write/read operations
    #Address 0xf51 Write value 0x3cd4729
    li x3, 0x3cd4729
    csrw 0xf51, x3

    #Unmapped address 0x88d testing: random write/read operations
    #Address 0x88d Write value 0x89b9aff2
    li x3, 0x89b9aff2
    csrw 0x88d, x3

    #Address 0x88d Write value 0x39542802
    li x3, 0x39542802
    csrw 0x88d, x3

    #Address 0x88d read value
    csrr x14, 0x88d

    #Unmapped address 0x1ce testing: random write/read operations
    #Address 0x1ce Write value 0xf3aba645
    li x3, 0xf3aba645
    csrw 0x1ce, x3

    #Address 0x1ce read value
    csrr x14, 0x1ce

    #Address 0x1ce read value
    csrr x14, 0x1ce

    #Address 0x1ce Write value 0x4a9acaff
    li x3, 0x4a9acaff
    csrw 0x1ce, x3

    #Address 0x1ce read value
    csrr x14, 0x1ce

    #Unmapped address 0x3e testing: random write/read operations
    #Address 0x3e read value
    csrr x14, 0x3e

    #Unmapped address 0xbc8 testing: random write/read operations
    #Address 0xbc8 Write value 0x2ecc4d3
    li x3, 0x2ecc4d3
    csrw 0xbc8, x3

    #Address 0xbc8 Write value 0x138aa46a
    li x3, 0x138aa46a
    csrw 0xbc8, x3

    #Address 0xbc8 Write value 0xe8971d14
    li x3, 0xe8971d14
    csrw 0xbc8, x3

    #Address 0xbc8 read value
    csrr x14, 0xbc8

    #Address 0xbc8 read value
    csrr x14, 0xbc8

    #Unmapped address 0x2dd testing: random write/read operations
    #Address 0x2dd read value
    csrr x14, 0x2dd

    #Address 0x2dd Write value 0x2433550a
    li x3, 0x2433550a
    csrw 0x2dd, x3

    #Address 0x2dd Write value 0xd1094816
    li x3, 0xd1094816
    csrw 0x2dd, x3

    #Unmapped address 0x83c testing: random write/read operations
    #Address 0x83c Write value 0x5796c3e5
    li x3, 0x5796c3e5
    csrw 0x83c, x3

    #Address 0x83c Write value 0xd107ad48
    li x3, 0xd107ad48
    csrw 0x83c, x3

    #Address 0x83c read value
    csrr x14, 0x83c

    #Address 0x83c Write value 0x1113b41
    li x3, 0x1113b41
    csrw 0x83c, x3

    #Address 0x83c read value
    csrr x14, 0x83c

    #Unmapped address 0xf02 testing: random write/read operations
    #Address 0xf02 read value
    csrr x14, 0xf02

    #Unmapped address 0x36b testing: random write/read operations
    #Address 0x36b Write value 0x6d8625d6
    li x3, 0x6d8625d6
    csrw 0x36b, x3

    #Address 0x36b read value
    csrr x14, 0x36b

    #Address 0x36b read value
    csrr x14, 0x36b

    #Address 0x36b read value
    csrr x14, 0x36b

    #Address 0x36b read value
    csrr x14, 0x36b

    #Unmapped address 0xab9 testing: random write/read operations
    #Address 0xab9 read value
    csrr x14, 0xab9

    #Unmapped address 0x3d8 testing: random write/read operations
    #Address 0x3d8 Write value 0xcac965ae
    li x3, 0xcac965ae
    csrw 0x3d8, x3

    #Address 0x3d8 read value
    csrr x14, 0x3d8

    #Address 0x3d8 Write value 0x1d678916
    li x3, 0x1d678916
    csrw 0x3d8, x3

    #Address 0x3d8 Write value 0x1ad838ed
    li x3, 0x1ad838ed
    csrw 0x3d8, x3

    #Address 0x3d8 Write value 0x444c5437
    li x3, 0x444c5437
    csrw 0x3d8, x3

    #Unmapped address 0xe9e testing: random write/read operations
    #Address 0xe9e Write value 0x2befe194
    li x3, 0x2befe194
    csrw 0xe9e, x3

    #Address 0xe9e read value
    csrr x14, 0xe9e

    #Address 0xe9e Write value 0xa5a9d7d
    li x3, 0xa5a9d7d
    csrw 0xe9e, x3

    #Address 0xe9e read value
    csrr x14, 0xe9e

    #Unmapped address 0xd02 testing: random write/read operations
    #Address 0xd02 Write value 0xdf7ad855
    li x3, 0xdf7ad855
    csrw 0xd02, x3

    #Address 0xd02 read value
    csrr x14, 0xd02

    #Address 0xd02 Write value 0xeed91a33
    li x3, 0xeed91a33
    csrw 0xd02, x3

    #Unmapped address 0xc90 testing: random write/read operations
    #Address 0xc90 Write value 0x6060d0d
    li x3, 0x6060d0d
    csrw 0xc90, x3

    #Address 0xc90 Write value 0x345a8509
    li x3, 0x345a8509
    csrw 0xc90, x3

    #Address 0xc90 Write value 0xc2e877ad
    li x3, 0xc2e877ad
    csrw 0xc90, x3

    #Unmapped address 0xd77 testing: random write/read operations
    #Address 0xd77 read value
    csrr x14, 0xd77

    #Address 0xd77 Write value 0x136e73df
    li x3, 0x136e73df
    csrw 0xd77, x3

    #Unmapped address 0x726 testing: random write/read operations
    #Address 0x726 read value
    csrr x14, 0x726

    #Address 0x726 Write value 0x51ee72bd
    li x3, 0x51ee72bd
    csrw 0x726, x3

    #Address 0x726 Write value 0xee016469
    li x3, 0xee016469
    csrw 0x726, x3

    #Unmapped address 0x2b8 testing: random write/read operations
    #Address 0x2b8 Write value 0xb2d696e5
    li x3, 0xb2d696e5
    csrw 0x2b8, x3

    #Address 0x2b8 read value
    csrr x14, 0x2b8

    #Address 0x2b8 Write value 0x4d09fd96
    li x3, 0x4d09fd96
    csrw 0x2b8, x3

    #Address 0x2b8 Write value 0x11db08e0
    li x3, 0x11db08e0
    csrw 0x2b8, x3

    #Unmapped address 0x783 testing: random write/read operations
    #Address 0x783 read value
    csrr x14, 0x783

    #Address 0x783 Write value 0xaa067273
    li x3, 0xaa067273
    csrw 0x783, x3

    #Unmapped address 0x546 testing: random write/read operations
    #Address 0x546 Write value 0x96c76fce
    li x3, 0x96c76fce
    csrw 0x546, x3

    #Address 0x546 read value
    csrr x14, 0x546

    #Address 0x546 Write value 0xd0642793
    li x3, 0xd0642793
    csrw 0x546, x3

    #Unmapped address 0x218 testing: random write/read operations
    #Address 0x218 read value
    csrr x14, 0x218

    #Address 0x218 Write value 0x6f9a380e
    li x3, 0x6f9a380e
    csrw 0x218, x3

    #Address 0x218 Write value 0x9c512a5
    li x3, 0x9c512a5
    csrw 0x218, x3

    #Address 0x218 read value
    csrr x14, 0x218

    #Unmapped address 0x47d testing: random write/read operations
    #Address 0x47d Write value 0x23245452
    li x3, 0x23245452
    csrw 0x47d, x3

    #Mapped address 0xb03 (mhpmcounter3) testing: random write/read operations
    #Address 0xb03 Write value 0xcb160e98
    li x3, 0xcb160e98
    csrw 0xb03, x3

    #Address 0xb03 read value
    csrr x14, 0xb03

    #Address 0xb03 Write value 0x39dc338e
    li x3, 0x39dc338e
    csrw 0xb03, x3

    #Mapped address 0xb15 (mhpmcounter21) testing: random write/read operations
    #Address 0xb15 Write value 0x23692e7a
    li x3, 0x23692e7a
    csrw 0xb15, x3

    #Address 0xb15 Write value 0xde98705
    li x3, 0xde98705
    csrw 0xb15, x3

    #Address 0xb15 read value
    csrr x14, 0xb15

    #Address 0xb15 read value
    csrr x14, 0xb15

    #Unmapped address 0x75d testing: random write/read operations
    #Address 0x75d Write value 0x3953a8d6
    li x3, 0x3953a8d6
    csrw 0x75d, x3

    #Unmapped address 0xae2 testing: random write/read operations
    #Address 0xae2 read value
    csrr x14, 0xae2

    #Unmapped address 0x2db testing: random write/read operations
    #Address 0x2db Write value 0x69e4d81d
    li x3, 0x69e4d81d
    csrw 0x2db, x3

    #Address 0x2db Write value 0x88b3f812
    li x3, 0x88b3f812
    csrw 0x2db, x3

    #Address 0x2db Write value 0xf111faa7
    li x3, 0xf111faa7
    csrw 0x2db, x3

    #Address 0x2db read value
    csrr x14, 0x2db

    #Unmapped address 0x95b testing: random write/read operations
    #Address 0x95b Write value 0x3574f177
    li x3, 0x3574f177
    csrw 0x95b, x3

    #Address 0x95b read value
    csrr x14, 0x95b

    #Address 0x95b Write value 0x74318929
    li x3, 0x74318929
    csrw 0x95b, x3

    #Unmapped address 0x586 testing: random write/read operations
    #Address 0x586 Write value 0x99db51d3
    li x3, 0x99db51d3
    csrw 0x586, x3

    #Address 0x586 read value
    csrr x14, 0x586

    #Unmapped address 0x13c testing: random write/read operations
    #Address 0x13c Write value 0x54687f42
    li x3, 0x54687f42
    csrw 0x13c, x3

    #Unmapped address 0x6c testing: random write/read operations
    #Address 0x6c read value
    csrr x14, 0x6c

    #Unmapped address 0x441 testing: random write/read operations
    #Address 0x441 Write value 0xe8b9b361
    li x3, 0xe8b9b361
    csrw 0x441, x3

    #Address 0x441 read value
    csrr x14, 0x441

    #Address 0x441 read value
    csrr x14, 0x441

    #Unmapped address 0xabf testing: random write/read operations
    #Address 0xabf Write value 0x7a734d1a
    li x3, 0x7a734d1a
    csrw 0xabf, x3

    #Address 0xabf Write value 0xa3629620
    li x3, 0xa3629620
    csrw 0xabf, x3

    #Address 0xabf Write value 0x4fdb4e47
    li x3, 0x4fdb4e47
    csrw 0xabf, x3

    #Address 0xabf read value
    csrr x14, 0xabf

    #Address 0xabf Write value 0xcc965634
    li x3, 0xcc965634
    csrw 0xabf, x3

    #Unmapped address 0xf39 testing: random write/read operations
    #Address 0xf39 read value
    csrr x14, 0xf39

    #Address 0xf39 read value
    csrr x14, 0xf39

    #Address 0xf39 Write value 0xfd853ab6
    li x3, 0xfd853ab6
    csrw 0xf39, x3

    #Address 0xf39 read value
    csrr x14, 0xf39

    #Unmapped address 0xa42 testing: random write/read operations
    #Address 0xa42 Write value 0x92c00d24
    li x3, 0x92c00d24
    csrw 0xa42, x3

    #Address 0xa42 read value
    csrr x14, 0xa42

    #Address 0xa42 read value
    csrr x14, 0xa42

    #Unmapped address 0x4b0 testing: random write/read operations
    #Address 0x4b0 Write value 0xa3a75d27
    li x3, 0xa3a75d27
    csrw 0x4b0, x3

    #Address 0x4b0 read value
    csrr x14, 0x4b0

    #Unmapped address 0x718 testing: random write/read operations
    #Address 0x718 Write value 0x4127150c
    li x3, 0x4127150c
    csrw 0x718, x3

    #Unmapped address 0xeab testing: random write/read operations
    #Address 0xeab read value
    csrr x14, 0xeab

    #Address 0xeab Write value 0xca90692
    li x3, 0xca90692
    csrw 0xeab, x3

    #Address 0xeab Write value 0xe0f460b0
    li x3, 0xe0f460b0
    csrw 0xeab, x3

    #Address 0xeab read value
    csrr x14, 0xeab

    #Address 0xeab Write value 0x539cb0fd
    li x3, 0x539cb0fd
    csrw 0xeab, x3

    #Unmapped address 0xd4c testing: random write/read operations
    #Address 0xd4c read value
    csrr x14, 0xd4c

    #Unmapped address 0x614 testing: random write/read operations
    #Address 0x614 Write value 0xeb8c84f7
    li x3, 0xeb8c84f7
    csrw 0x614, x3

    #Address 0x614 Write value 0xfae23174
    li x3, 0xfae23174
    csrw 0x614, x3

    #Address 0x614 Write value 0xcfed0540
    li x3, 0xcfed0540
    csrw 0x614, x3

    #Unmapped address 0xe99 testing: random write/read operations
    #Address 0xe99 read value
    csrr x14, 0xe99

    #Unmapped address 0x185 testing: random write/read operations
    #Address 0x185 Write value 0x4c53afb2
    li x3, 0x4c53afb2
    csrw 0x185, x3

    #Address 0x185 Write value 0x95164306
    li x3, 0x95164306
    csrw 0x185, x3

    #Address 0x185 read value
    csrr x14, 0x185

    #Address 0x185 Write value 0x557c817e
    li x3, 0x557c817e
    csrw 0x185, x3

    #Address 0x185 Write value 0x34d59fc2
    li x3, 0x34d59fc2
    csrw 0x185, x3

    #Unmapped address 0x796 testing: random write/read operations
    #Address 0x796 Write value 0x5582cf15
    li x3, 0x5582cf15
    csrw 0x796, x3

    #Unmapped address 0xaa4 testing: random write/read operations
    #Address 0xaa4 read value
    csrr x14, 0xaa4

    #Address 0xaa4 read value
    csrr x14, 0xaa4

    #Address 0xaa4 Write value 0xf838034f
    li x3, 0xf838034f
    csrw 0xaa4, x3

    #Address 0xaa4 read value
    csrr x14, 0xaa4

    #Unmapped address 0xc8 testing: random write/read operations
    #Address 0xc8 Write value 0x9d3eed37
    li x3, 0x9d3eed37
    csrw 0xc8, x3

    #Unmapped address 0x697 testing: random write/read operations
    #Address 0x697 Write value 0x86f84d90
    li x3, 0x86f84d90
    csrw 0x697, x3

    #Address 0x697 read value
    csrr x14, 0x697

    #Address 0x697 Write value 0x20cc6c52
    li x3, 0x20cc6c52
    csrw 0x697, x3

    #Unmapped address 0x66d testing: random write/read operations
    #Address 0x66d read value
    csrr x14, 0x66d

    #Address 0x66d read value
    csrr x14, 0x66d

    #Address 0x66d Write value 0xc8de7c72
    li x3, 0xc8de7c72
    csrw 0x66d, x3

    #Address 0x66d Write value 0x6925c585
    li x3, 0x6925c585
    csrw 0x66d, x3

    #Unmapped address 0x810 testing: random write/read operations
    #Address 0x810 Write value 0xd1d61a1d
    li x3, 0xd1d61a1d
    csrw 0x810, x3

    #Address 0x810 read value
    csrr x14, 0x810

    #Address 0x810 Write value 0x53d1ff2f
    li x3, 0x53d1ff2f
    csrw 0x810, x3

    #Address 0x810 read value
    csrr x14, 0x810

    #Address 0x810 read value
    csrr x14, 0x810

    #Unmapped address 0x3ad testing: random write/read operations
    #Address 0x3ad Write value 0x51040151
    li x3, 0x51040151
    csrw 0x3ad, x3

    #Address 0x3ad Write value 0x9d6da0e1
    li x3, 0x9d6da0e1
    csrw 0x3ad, x3

    #Address 0x3ad Write value 0x6153c62b
    li x3, 0x6153c62b
    csrw 0x3ad, x3

    #Address 0x3ad read value
    csrr x14, 0x3ad

    #Address 0x3ad read value
    csrr x14, 0x3ad

    #Unmapped address 0x871 testing: random write/read operations
    #Address 0x871 Write value 0xa6016daf
    li x3, 0xa6016daf
    csrw 0x871, x3

    #Unmapped address 0xfcf testing: random write/read operations
    #Address 0xfcf Write value 0xe6a2118a
    li x3, 0xe6a2118a
    csrw 0xfcf, x3

    #Unmapped address 0xc3d testing: random write/read operations
    #Address 0xc3d read value
    csrr x14, 0xc3d

    #Address 0xc3d Write value 0x71c21961
    li x3, 0x71c21961
    csrw 0xc3d, x3

    #Unmapped address 0x21a testing: random write/read operations
    #Address 0x21a Write value 0x1480014f
    li x3, 0x1480014f
    csrw 0x21a, x3

    #Address 0x21a Write value 0xb2c75202
    li x3, 0xb2c75202
    csrw 0x21a, x3

    #Unmapped address 0x294 testing: random write/read operations
    #Address 0x294 Write value 0xf4809dee
    li x3, 0xf4809dee
    csrw 0x294, x3

    #Address 0x294 Write value 0x97d695bd
    li x3, 0x97d695bd
    csrw 0x294, x3

    #Unmapped address 0xa7e testing: random write/read operations
    #Address 0xa7e Write value 0x9416cac9
    li x3, 0x9416cac9
    csrw 0xa7e, x3

    #Address 0xa7e read value
    csrr x14, 0xa7e

    #Address 0xa7e Write value 0x612bc550
    li x3, 0x612bc550
    csrw 0xa7e, x3

    #Address 0xa7e Write value 0x1c9a1077
    li x3, 0x1c9a1077
    csrw 0xa7e, x3

    #Unmapped address 0x4e5 testing: random write/read operations
    #Address 0x4e5 read value
    csrr x14, 0x4e5

    #Address 0x4e5 Write value 0x949dc11c
    li x3, 0x949dc11c
    csrw 0x4e5, x3

    #Unmapped address 0x4f1 testing: random write/read operations
    #Address 0x4f1 read value
    csrr x14, 0x4f1

    #Unmapped address 0x43a testing: random write/read operations
    #Address 0x43a read value
    csrr x14, 0x43a

    #Address 0x43a read value
    csrr x14, 0x43a

    #Address 0x43a read value
    csrr x14, 0x43a

    #Address 0x43a read value
    csrr x14, 0x43a

    #Unmapped address 0x57 testing: random write/read operations
    #Address 0x57 read value
    csrr x14, 0x57

    #Address 0x57 Write value 0x96ab19fa
    li x3, 0x96ab19fa
    csrw 0x57, x3

    #Address 0x57 read value
    csrr x14, 0x57

    #Address 0x57 read value
    csrr x14, 0x57

    #Unmapped address 0x4de testing: random write/read operations
    #Address 0x4de Write value 0x11671edc
    li x3, 0x11671edc
    csrw 0x4de, x3

    #Address 0x4de read value
    csrr x14, 0x4de

    #Address 0x4de Write value 0x2c709b95
    li x3, 0x2c709b95
    csrw 0x4de, x3

    #Address 0x4de Write value 0xc27eee37
    li x3, 0xc27eee37
    csrw 0x4de, x3

    #Unmapped address 0x53e testing: random write/read operations
    #Address 0x53e Write value 0x932c7c34
    li x3, 0x932c7c34
    csrw 0x53e, x3

    #Address 0x53e read value
    csrr x14, 0x53e

    #Address 0x53e read value
    csrr x14, 0x53e

    #Unmapped address 0x4d6 testing: random write/read operations
    #Address 0x4d6 Write value 0xa30f0ed9
    li x3, 0xa30f0ed9
    csrw 0x4d6, x3

    #Address 0x4d6 Write value 0x7abd38c0
    li x3, 0x7abd38c0
    csrw 0x4d6, x3

    #Address 0x4d6 read value
    csrr x14, 0x4d6

    #Unmapped address 0xd5d testing: random write/read operations
    #Address 0xd5d read value
    csrr x14, 0xd5d

    #Address 0xd5d Write value 0xbe6e30ce
    li x3, 0xbe6e30ce
    csrw 0xd5d, x3

    #Address 0xd5d Write value 0x4beb358a
    li x3, 0x4beb358a
    csrw 0xd5d, x3

    #Unmapped address 0x4b8 testing: random write/read operations
    #Address 0x4b8 Write value 0x54b7e280
    li x3, 0x54b7e280
    csrw 0x4b8, x3

    #Unmapped address 0xbb9 testing: random write/read operations
    #Address 0xbb9 Write value 0x8f15df17
    li x3, 0x8f15df17
    csrw 0xbb9, x3

    #Address 0xbb9 read value
    csrr x14, 0xbb9

    #Address 0xbb9 Write value 0x6d57126
    li x3, 0x6d57126
    csrw 0xbb9, x3

    #Unmapped address 0x38f testing: random write/read operations
    #Address 0x38f read value
    csrr x14, 0x38f

    #Address 0x38f Write value 0x20b538a1
    li x3, 0x20b538a1
    csrw 0x38f, x3

    #Unmapped address 0x447 testing: random write/read operations
    #Address 0x447 Write value 0x30b16c7
    li x3, 0x30b16c7
    csrw 0x447, x3

    #Address 0x447 read value
    csrr x14, 0x447

    #Unmapped address 0x9c1 testing: random write/read operations
    #Address 0x9c1 read value
    csrr x14, 0x9c1

    #Address 0x9c1 Write value 0x58b9cf38
    li x3, 0x58b9cf38
    csrw 0x9c1, x3

    #Address 0x9c1 read value
    csrr x14, 0x9c1

    #Address 0x9c1 read value
    csrr x14, 0x9c1

    #Address 0x9c1 Write value 0xb645ccd9
    li x3, 0xb645ccd9
    csrw 0x9c1, x3

    #Unmapped address 0xdd3 testing: random write/read operations
    #Address 0xdd3 Write value 0xb25c86cf
    li x3, 0xb25c86cf
    csrw 0xdd3, x3

    #Address 0xdd3 read value
    csrr x14, 0xdd3

    #Address 0xdd3 Write value 0xf71d1749
    li x3, 0xf71d1749
    csrw 0xdd3, x3

    #Address 0xdd3 read value
    csrr x14, 0xdd3

    #Address 0xdd3 Write value 0xc48dd3af
    li x3, 0xc48dd3af
    csrw 0xdd3, x3

    #Unmapped address 0x662 testing: random write/read operations
    #Address 0x662 Write value 0x99e8b59a
    li x3, 0x99e8b59a
    csrw 0x662, x3

    #Address 0x662 read value
    csrr x14, 0x662

    #Address 0x662 read value
    csrr x14, 0x662

    #Address 0x662 read value
    csrr x14, 0x662

    #Address 0x662 read value
    csrr x14, 0x662

    #Unmapped address 0x8c3 testing: random write/read operations
    #Address 0x8c3 Write value 0x7c405dc1
    li x3, 0x7c405dc1
    csrw 0x8c3, x3

    #Unmapped address 0xc44 testing: random write/read operations
    #Address 0xc44 read value
    csrr x14, 0xc44

    #Unmapped address 0x311 testing: random write/read operations
    #Address 0x311 read value
    csrr x14, 0x311

    #Address 0x311 read value
    csrr x14, 0x311

    #Address 0x311 read value
    csrr x14, 0x311

    #Unmapped address 0x53f testing: random write/read operations
    #Address 0x53f read value
    csrr x14, 0x53f

    #Unmapped address 0x661 testing: random write/read operations
    #Address 0x661 Write value 0xc99e61d5
    li x3, 0xc99e61d5
    csrw 0x661, x3

    #Address 0x661 read value
    csrr x14, 0x661

    #Address 0x661 Write value 0x43aa654c
    li x3, 0x43aa654c
    csrw 0x661, x3

    #Unmapped address 0x37e testing: random write/read operations
    #Address 0x37e Write value 0x766d78e9
    li x3, 0x766d78e9
    csrw 0x37e, x3

    #Unmapped address 0x4f9 testing: random write/read operations
    #Address 0x4f9 read value
    csrr x14, 0x4f9

    #Unmapped address 0x15f testing: random write/read operations
    #Address 0x15f Write value 0x971a4710
    li x3, 0x971a4710
    csrw 0x15f, x3

    #Unmapped address 0xef2 testing: random write/read operations
    #Address 0xef2 Write value 0x89be01b4
    li x3, 0x89be01b4
    csrw 0xef2, x3

    #Address 0xef2 Write value 0xcd1b9291
    li x3, 0xcd1b9291
    csrw 0xef2, x3

    #Unmapped address 0xefe testing: random write/read operations
    #Address 0xefe Write value 0x4edc5d7b
    li x3, 0x4edc5d7b
    csrw 0xefe, x3

    #Unmapped address 0x8a9 testing: random write/read operations
    #Address 0x8a9 Write value 0xeac188bf
    li x3, 0xeac188bf
    csrw 0x8a9, x3

    #Address 0x8a9 read value
    csrr x14, 0x8a9

    #Address 0x8a9 Write value 0xf885a431
    li x3, 0xf885a431
    csrw 0x8a9, x3

    #Address 0x8a9 Write value 0xda00a799
    li x3, 0xda00a799
    csrw 0x8a9, x3

    #Unmapped address 0x870 testing: random write/read operations
    #Address 0x870 Write value 0x2848d352
    li x3, 0x2848d352
    csrw 0x870, x3

    #Address 0x870 Write value 0xbf87acdc
    li x3, 0xbf87acdc
    csrw 0x870, x3

    #Unmapped address 0x1f1 testing: random write/read operations
    #Address 0x1f1 read value
    csrr x14, 0x1f1

    #Address 0x1f1 read value
    csrr x14, 0x1f1

    #Address 0x1f1 read value
    csrr x14, 0x1f1

    #Unmapped address 0x743 testing: random write/read operations
    #Address 0x743 Write value 0xc819ed5f
    li x3, 0xc819ed5f
    csrw 0x743, x3

    #Address 0x743 Write value 0x662e0566
    li x3, 0x662e0566
    csrw 0x743, x3

    #Address 0x743 Write value 0x7c2654e8
    li x3, 0x7c2654e8
    csrw 0x743, x3

    #Unmapped address 0x7d7 testing: random write/read operations
    #Address 0x7d7 Write value 0x4670ec64
    li x3, 0x4670ec64
    csrw 0x7d7, x3

    #Unmapped address 0xfb7 testing: random write/read operations
    #Address 0xfb7 Write value 0x1dbb9fc9
    li x3, 0x1dbb9fc9
    csrw 0xfb7, x3

    #Address 0xfb7 Write value 0xe7e1bc3b
    li x3, 0xe7e1bc3b
    csrw 0xfb7, x3

    #Address 0xfb7 Write value 0x92cc17f9
    li x3, 0x92cc17f9
    csrw 0xfb7, x3

    #Unmapped address 0x9c6 testing: random write/read operations
    #Address 0x9c6 read value
    csrr x14, 0x9c6

    #Address 0x9c6 Write value 0x4297ec
    li x3, 0x4297ec
    csrw 0x9c6, x3

    #Address 0x9c6 read value
    csrr x14, 0x9c6

    #Address 0x9c6 Write value 0x26a6a9e9
    li x3, 0x26a6a9e9
    csrw 0x9c6, x3

    #Unmapped address 0x71d testing: random write/read operations
    #Address 0x71d read value
    csrr x14, 0x71d

    #Unmapped address 0x1f7 testing: random write/read operations
    #Address 0x1f7 Write value 0x345dad8d
    li x3, 0x345dad8d
    csrw 0x1f7, x3

    #Unmapped address 0x222 testing: random write/read operations
    #Address 0x222 Write value 0x8fe63328
    li x3, 0x8fe63328
    csrw 0x222, x3

    #Address 0x222 Write value 0x43b4bfab
    li x3, 0x43b4bfab
    csrw 0x222, x3

    #Address 0x222 Write value 0x2a797773
    li x3, 0x2a797773
    csrw 0x222, x3

    #Unmapped address 0x8b5 testing: random write/read operations
    #Address 0x8b5 Write value 0x86cfbd4c
    li x3, 0x86cfbd4c
    csrw 0x8b5, x3

    #Address 0x8b5 read value
    csrr x14, 0x8b5

    #Address 0x8b5 read value
    csrr x14, 0x8b5

    #Address 0x8b5 Write value 0xc2ae1a93
    li x3, 0xc2ae1a93
    csrw 0x8b5, x3

    #Address 0x8b5 Write value 0xce7bee60
    li x3, 0xce7bee60
    csrw 0x8b5, x3

    #Unmapped address 0x98a testing: random write/read operations
    #Address 0x98a Write value 0xe6dbc556
    li x3, 0xe6dbc556
    csrw 0x98a, x3

    #Address 0x98a Write value 0x4469fd7f
    li x3, 0x4469fd7f
    csrw 0x98a, x3

    #Address 0x98a Write value 0xbf983bee
    li x3, 0xbf983bee
    csrw 0x98a, x3

    #Unmapped address 0x816 testing: random write/read operations
    #Address 0x816 read value
    csrr x14, 0x816

    #Address 0x816 Write value 0x400edb8f
    li x3, 0x400edb8f
    csrw 0x816, x3

    #Unmapped address 0x524 testing: random write/read operations
    #Address 0x524 Write value 0x4ff31268
    li x3, 0x4ff31268
    csrw 0x524, x3

    #Unmapped address 0x3c3 testing: random write/read operations
    #Address 0x3c3 Write value 0x6b9ca729
    li x3, 0x6b9ca729
    csrw 0x3c3, x3

    #Address 0x3c3 read value
    csrr x14, 0x3c3

    #Address 0x3c3 read value
    csrr x14, 0x3c3

    #Address 0x3c3 Write value 0x577802fe
    li x3, 0x577802fe
    csrw 0x3c3, x3

    #Unmapped address 0x736 testing: random write/read operations
    #Address 0x736 Write value 0xeb8fe10c
    li x3, 0xeb8fe10c
    csrw 0x736, x3

    #Address 0x736 read value
    csrr x14, 0x736

    #Address 0x736 read value
    csrr x14, 0x736

    #Unmapped address 0x28 testing: random write/read operations
    #Address 0x28 Write value 0x5ca5ebf6
    li x3, 0x5ca5ebf6
    csrw 0x28, x3

    #Unmapped address 0x98f testing: random write/read operations
    #Address 0x98f Write value 0x575fdd8
    li x3, 0x575fdd8
    csrw 0x98f, x3

    #Unmapped address 0xe1d testing: random write/read operations
    #Address 0xe1d read value
    csrr x14, 0xe1d

    #Unmapped address 0x3d9 testing: random write/read operations
    #Address 0x3d9 Write value 0x9ee8a29d
    li x3, 0x9ee8a29d
    csrw 0x3d9, x3

    #Address 0x3d9 Write value 0xbb9229a
    li x3, 0xbb9229a
    csrw 0x3d9, x3

    #Unmapped address 0x79b testing: random write/read operations
    #Address 0x79b Write value 0x5859a2db
    li x3, 0x5859a2db
    csrw 0x79b, x3

    #Address 0x79b Write value 0xa5b40484
    li x3, 0xa5b40484
    csrw 0x79b, x3

    #Unmapped address 0xe38 testing: random write/read operations
    #Address 0xe38 read value
    csrr x14, 0xe38

    #Address 0xe38 Write value 0xe2efb97
    li x3, 0xe2efb97
    csrw 0xe38, x3

    #Address 0xe38 read value
    csrr x14, 0xe38

    #Address 0xe38 read value
    csrr x14, 0xe38

    #Address 0xe38 Write value 0xa3dc5caf
    li x3, 0xa3dc5caf
    csrw 0xe38, x3

    #Unmapped address 0xd16 testing: random write/read operations
    #Address 0xd16 read value
    csrr x14, 0xd16

    #Address 0xd16 read value
    csrr x14, 0xd16

    #Address 0xd16 Write value 0x85e7de46
    li x3, 0x85e7de46
    csrw 0xd16, x3

    #Address 0xd16 Write value 0xb69ea055
    li x3, 0xb69ea055
    csrw 0xd16, x3

    #Address 0xd16 Write value 0x3e815889
    li x3, 0x3e815889
    csrw 0xd16, x3

    #Unmapped address 0x9a1 testing: random write/read operations
    #Address 0x9a1 read value
    csrr x14, 0x9a1

    #Address 0x9a1 read value
    csrr x14, 0x9a1

    #Address 0x9a1 Write value 0xf789bd22
    li x3, 0xf789bd22
    csrw 0x9a1, x3

    #Address 0x9a1 Write value 0xc041c21c
    li x3, 0xc041c21c
    csrw 0x9a1, x3

    #Address 0x9a1 read value
    csrr x14, 0x9a1

    #Unmapped address 0xab4 testing: random write/read operations
    #Address 0xab4 Write value 0x3bc9fa48
    li x3, 0x3bc9fa48
    csrw 0xab4, x3

    #Unmapped address 0x3b testing: random write/read operations
    #Address 0x3b read value
    csrr x14, 0x3b

    #Unmapped address 0x73a testing: random write/read operations
    #Address 0x73a read value
    csrr x14, 0x73a

    #Address 0x73a read value
    csrr x14, 0x73a

    #Address 0x73a Write value 0x7323869f
    li x3, 0x7323869f
    csrw 0x73a, x3

    #Address 0x73a read value
    csrr x14, 0x73a

    #Unmapped address 0x637 testing: random write/read operations
    #Address 0x637 read value
    csrr x14, 0x637

    #Address 0x637 Write value 0xb034ec10
    li x3, 0xb034ec10
    csrw 0x637, x3

    #Unmapped address 0x438 testing: random write/read operations
    #Address 0x438 Write value 0xc7cadc33
    li x3, 0xc7cadc33
    csrw 0x438, x3

    #Address 0x438 Write value 0x6f65a87
    li x3, 0x6f65a87
    csrw 0x438, x3

    #Address 0x438 read value
    csrr x14, 0x438

    #Unmapped address 0x354 testing: random write/read operations
    #Address 0x354 read value
    csrr x14, 0x354

    #Address 0x354 read value
    csrr x14, 0x354

    #Address 0x354 read value
    csrr x14, 0x354

    #Address 0x354 read value
    csrr x14, 0x354

    #Unmapped address 0xa8b testing: random write/read operations
    #Address 0xa8b Write value 0x994d91c4
    li x3, 0x994d91c4
    csrw 0xa8b, x3

    #Address 0xa8b read value
    csrr x14, 0xa8b

    #Address 0xa8b read value
    csrr x14, 0xa8b

    #Address 0xa8b read value
    csrr x14, 0xa8b

    #Address 0xa8b read value
    csrr x14, 0xa8b

    #Unmapped address 0x397 testing: random write/read operations
    #Address 0x397 read value
    csrr x14, 0x397

    #Address 0x397 read value
    csrr x14, 0x397

    #Unmapped address 0x51e testing: random write/read operations
    #Address 0x51e Write value 0x9aceaea8
    li x3, 0x9aceaea8
    csrw 0x51e, x3

    #Address 0x51e Write value 0xe9b17fa8
    li x3, 0xe9b17fa8
    csrw 0x51e, x3

    #Address 0x51e read value
    csrr x14, 0x51e

    #Unmapped address 0xddb testing: random write/read operations
    #Address 0xddb read value
    csrr x14, 0xddb

    #Address 0xddb read value
    csrr x14, 0xddb

    #Address 0xddb Write value 0xbbb3137
    li x3, 0xbbb3137
    csrw 0xddb, x3

    #Unmapped address 0xf64 testing: random write/read operations
    #Address 0xf64 Write value 0x703b420f
    li x3, 0x703b420f
    csrw 0xf64, x3

    #Address 0xf64 read value
    csrr x14, 0xf64

    #Address 0xf64 read value
    csrr x14, 0xf64

    #Address 0xf64 read value
    csrr x14, 0xf64

    #Address 0xf64 Write value 0x9a61b811
    li x3, 0x9a61b811
    csrw 0xf64, x3

    #Unmapped address 0x881 testing: random write/read operations
    #Address 0x881 Write value 0x558d2e0f
    li x3, 0x558d2e0f
    csrw 0x881, x3

    #Address 0x881 read value
    csrr x14, 0x881

    #Address 0x881 read value
    csrr x14, 0x881

    #Address 0x881 read value
    csrr x14, 0x881

    #Unmapped address 0x6a testing: random write/read operations
    #Address 0x6a Write value 0x11d82755
    li x3, 0x11d82755
    csrw 0x6a, x3

    #Unmapped address 0x7d testing: random write/read operations
    #Address 0x7d Write value 0x5bf5eab9
    li x3, 0x5bf5eab9
    csrw 0x7d, x3

    #Unmapped address 0x3d7 testing: random write/read operations
    #Address 0x3d7 read value
    csrr x14, 0x3d7

    #Address 0x3d7 read value
    csrr x14, 0x3d7

    #Address 0x3d7 read value
    csrr x14, 0x3d7

    #Unmapped address 0x9a0 testing: random write/read operations
    #Address 0x9a0 read value
    csrr x14, 0x9a0

    #Address 0x9a0 read value
    csrr x14, 0x9a0

    #Address 0x9a0 Write value 0xc1c929b8
    li x3, 0xc1c929b8
    csrw 0x9a0, x3

    #Address 0x9a0 read value
    csrr x14, 0x9a0

    #Address 0x9a0 read value
    csrr x14, 0x9a0

    #Unmapped address 0x857 testing: random write/read operations
    #Address 0x857 read value
    csrr x14, 0x857

    #Address 0x857 Write value 0x70fcc7df
    li x3, 0x70fcc7df
    csrw 0x857, x3

    #Address 0x857 Write value 0x35c85d86
    li x3, 0x35c85d86
    csrw 0x857, x3

    #Address 0x857 Write value 0x6003bf81
    li x3, 0x6003bf81
    csrw 0x857, x3

    #Address 0x857 Write value 0xd174bdfb
    li x3, 0xd174bdfb
    csrw 0x857, x3

    #Unmapped address 0x9df testing: random write/read operations
    #Address 0x9df Write value 0xfbb3ff24
    li x3, 0xfbb3ff24
    csrw 0x9df, x3

    #Unmapped address 0xe55 testing: random write/read operations
    #Address 0xe55 read value
    csrr x14, 0xe55

    #Address 0xe55 Write value 0xea0758c0
    li x3, 0xea0758c0
    csrw 0xe55, x3

    #Address 0xe55 Write value 0x13f74b43
    li x3, 0x13f74b43
    csrw 0xe55, x3

    #Unmapped address 0x9ca testing: random write/read operations
    #Address 0x9ca Write value 0xbfa19538
    li x3, 0xbfa19538
    csrw 0x9ca, x3

    #Address 0x9ca Write value 0x1d415f97
    li x3, 0x1d415f97
    csrw 0x9ca, x3

    #Address 0x9ca read value
    csrr x14, 0x9ca

    #Address 0x9ca read value
    csrr x14, 0x9ca

    #Address 0x9ca read value
    csrr x14, 0x9ca

    #Unmapped address 0x3ce testing: random write/read operations
    #Address 0x3ce Write value 0xc3ea8cbc
    li x3, 0xc3ea8cbc
    csrw 0x3ce, x3

    #Unmapped address 0x5ab testing: random write/read operations
    #Address 0x5ab read value
    csrr x14, 0x5ab

    #Address 0x5ab Write value 0x7fdb681d
    li x3, 0x7fdb681d
    csrw 0x5ab, x3

    #Address 0x5ab read value
    csrr x14, 0x5ab

    #Address 0x5ab read value
    csrr x14, 0x5ab

    #Unmapped address 0x2e testing: random write/read operations
    #Address 0x2e Write value 0xa1cbb91e
    li x3, 0xa1cbb91e
    csrw 0x2e, x3

    #Address 0x2e Write value 0x105d8e39
    li x3, 0x105d8e39
    csrw 0x2e, x3

    #Address 0x2e read value
    csrr x14, 0x2e

    #Address 0x2e Write value 0x3f2b7623
    li x3, 0x3f2b7623
    csrw 0x2e, x3

    #Address 0x2e Write value 0xc8bb6697
    li x3, 0xc8bb6697
    csrw 0x2e, x3

    #Mapped address 0xb16 (mhpmcounter22) testing: random write/read operations
    #Address 0xb16 Write value 0x2e299371
    li x3, 0x2e299371
    csrw 0xb16, x3

    #Unmapped address 0x996 testing: random write/read operations
    #Address 0x996 read value
    csrr x14, 0x996

    #Address 0x996 read value
    csrr x14, 0x996

    #Address 0x996 Write value 0xb63576a2
    li x3, 0xb63576a2
    csrw 0x996, x3

    #Address 0x996 read value
    csrr x14, 0x996

    #Unmapped address 0xcab testing: random write/read operations
    #Address 0xcab read value
    csrr x14, 0xcab

    #Address 0xcab read value
    csrr x14, 0xcab

    #Address 0xcab Write value 0x94ad8353
    li x3, 0x94ad8353
    csrw 0xcab, x3

    #Address 0xcab read value
    csrr x14, 0xcab

    #Address 0xcab Write value 0xc0502ccb
    li x3, 0xc0502ccb
    csrw 0xcab, x3

    #Unmapped address 0x196 testing: random write/read operations
    #Address 0x196 read value
    csrr x14, 0x196

    #Unmapped address 0xc04 testing: random write/read operations
    #Address 0xc04 read value
    csrr x14, 0xc04

    #Address 0xc04 Write value 0xb57fbd4f
    li x3, 0xb57fbd4f
    csrw 0xc04, x3

    #Address 0xc04 read value
    csrr x14, 0xc04

    #Address 0xc04 read value
    csrr x14, 0xc04

    #Unmapped address 0xc1d testing: random write/read operations
    #Address 0xc1d Write value 0x97edafe4
    li x3, 0x97edafe4
    csrw 0xc1d, x3

    #Address 0xc1d read value
    csrr x14, 0xc1d

    #Address 0xc1d read value
    csrr x14, 0xc1d

    #Address 0xc1d Write value 0x1db4d5b3
    li x3, 0x1db4d5b3
    csrw 0xc1d, x3

    #Address 0xc1d Write value 0xd894bb93
    li x3, 0xd894bb93
    csrw 0xc1d, x3

    #Unmapped address 0xc57 testing: random write/read operations
    #Address 0xc57 Write value 0xe8b4cd68
    li x3, 0xe8b4cd68
    csrw 0xc57, x3

    #Address 0xc57 read value
    csrr x14, 0xc57

    #Address 0xc57 Write value 0x8d8faf24
    li x3, 0x8d8faf24
    csrw 0xc57, x3

    #Unmapped address 0x7e testing: random write/read operations
    #Address 0x7e read value
    csrr x14, 0x7e

    #Address 0x7e read value
    csrr x14, 0x7e

    #Address 0x7e Write value 0xa671bb8c
    li x3, 0xa671bb8c
    csrw 0x7e, x3

    #Address 0x7e Write value 0xa054f485
    li x3, 0xa054f485
    csrw 0x7e, x3

    #Address 0x7e read value
    csrr x14, 0x7e

    #Mapped address 0xb82 (minstreth) testing: random write/read operations
    #Address 0xb82 Write value 0xffbd832
    li x3, 0xffbd832
    csrw 0xb82, x3

    #Address 0xb82 read value
    csrr x14, 0xb82

    #Address 0xb82 Write value 0xd3a0fcda
    li x3, 0xd3a0fcda
    csrw 0xb82, x3

    #Address 0xb82 read value
    csrr x14, 0xb82

    #Address 0xb82 read value
    csrr x14, 0xb82

    #Unmapped address 0x778 testing: random write/read operations
    #Address 0x778 read value
    csrr x14, 0x778

    #Address 0x778 Write value 0x5c2ad671
    li x3, 0x5c2ad671
    csrw 0x778, x3

    #Address 0x778 Write value 0x67d3ce3e
    li x3, 0x67d3ce3e
    csrw 0x778, x3

    #Address 0x778 Write value 0xb313d2f7
    li x3, 0xb313d2f7
    csrw 0x778, x3

    #Unmapped address 0x528 testing: random write/read operations
    #Address 0x528 Write value 0x5ddaedeb
    li x3, 0x5ddaedeb
    csrw 0x528, x3

    #Unmapped address 0x563 testing: random write/read operations
    #Address 0x563 Write value 0x1e50fccc
    li x3, 0x1e50fccc
    csrw 0x563, x3

    #Address 0x563 Write value 0x4cc8373e
    li x3, 0x4cc8373e
    csrw 0x563, x3

    #Address 0x563 Write value 0x32af0e6c
    li x3, 0x32af0e6c
    csrw 0x563, x3

    #Address 0x563 Write value 0xb272ef74
    li x3, 0xb272ef74
    csrw 0x563, x3

    #Unmapped address 0x5ed testing: random write/read operations
    #Address 0x5ed read value
    csrr x14, 0x5ed

    #Address 0x5ed read value
    csrr x14, 0x5ed

    #Address 0x5ed Write value 0x779347e1
    li x3, 0x779347e1
    csrw 0x5ed, x3

    #Unmapped address 0xbf8 testing: random write/read operations
    #Address 0xbf8 Write value 0x42c478cf
    li x3, 0x42c478cf
    csrw 0xbf8, x3

    #Address 0xbf8 read value
    csrr x14, 0xbf8

    #Unmapped address 0xbb7 testing: random write/read operations
    #Address 0xbb7 read value
    csrr x14, 0xbb7

    #Address 0xbb7 read value
    csrr x14, 0xbb7

    #Address 0xbb7 Write value 0x47e88a38
    li x3, 0x47e88a38
    csrw 0xbb7, x3

    #Unmapped address 0x3fe testing: random write/read operations
    #Address 0x3fe read value
    csrr x14, 0x3fe

    #Address 0x3fe Write value 0xc8d0bb3b
    li x3, 0xc8d0bb3b
    csrw 0x3fe, x3

    #Unmapped address 0xdaa testing: random write/read operations
    #Address 0xdaa read value
    csrr x14, 0xdaa

    #Address 0xdaa read value
    csrr x14, 0xdaa

    #Unmapped address 0x2d8 testing: random write/read operations
    #Address 0x2d8 read value
    csrr x14, 0x2d8

    #Address 0x2d8 read value
    csrr x14, 0x2d8

    #Address 0x2d8 Write value 0xb173949d
    li x3, 0xb173949d
    csrw 0x2d8, x3

    #Unmapped address 0x4bd testing: random write/read operations
    #Address 0x4bd read value
    csrr x14, 0x4bd

    #Unmapped address 0x121 testing: random write/read operations
    #Address 0x121 read value
    csrr x14, 0x121

    #Address 0x121 read value
    csrr x14, 0x121

    #Address 0x121 read value
    csrr x14, 0x121

    #Address 0x121 read value
    csrr x14, 0x121

    #Address 0x121 read value
    csrr x14, 0x121

    #Unmapped address 0x63d testing: random write/read operations
    #Address 0x63d read value
    csrr x14, 0x63d

    #Address 0x63d read value
    csrr x14, 0x63d

    #Address 0x63d Write value 0xfd26764b
    li x3, 0xfd26764b
    csrw 0x63d, x3

    #Unmapped address 0x427 testing: random write/read operations
    #Address 0x427 read value
    csrr x14, 0x427

    #Address 0x427 Write value 0xf831733e
    li x3, 0xf831733e
    csrw 0x427, x3

    #Unmapped address 0x9f testing: random write/read operations
    #Address 0x9f Write value 0x9bfc6343
    li x3, 0x9bfc6343
    csrw 0x9f, x3

    #Address 0x9f read value
    csrr x14, 0x9f

    #Address 0x9f read value
    csrr x14, 0x9f

    #Address 0x9f Write value 0x8bd656f1
    li x3, 0x8bd656f1
    csrw 0x9f, x3

    #Unmapped address 0x385 testing: random write/read operations
    #Address 0x385 Write value 0xccc15fa5
    li x3, 0xccc15fa5
    csrw 0x385, x3

    #Address 0x385 read value
    csrr x14, 0x385

    #Address 0x385 read value
    csrr x14, 0x385

    #Address 0x385 read value
    csrr x14, 0x385

    #Address 0x385 read value
    csrr x14, 0x385

    #Unmapped address 0xa67 testing: random write/read operations
    #Address 0xa67 read value
    csrr x14, 0xa67

    #Address 0xa67 Write value 0xc312e1e6
    li x3, 0xc312e1e6
    csrw 0xa67, x3

    #Address 0xa67 read value
    csrr x14, 0xa67

    #Address 0xa67 read value
    csrr x14, 0xa67

    #Address 0xa67 read value
    csrr x14, 0xa67

    #Unmapped address 0x562 testing: random write/read operations
    #Address 0x562 read value
    csrr x14, 0x562

    #Address 0x562 Write value 0x583d4760
    li x3, 0x583d4760
    csrw 0x562, x3

    #Unmapped address 0xa46 testing: random write/read operations
    #Address 0xa46 Write value 0x4312feef
    li x3, 0x4312feef
    csrw 0xa46, x3

    #Address 0xa46 read value
    csrr x14, 0xa46

    #Address 0xa46 read value
    csrr x14, 0xa46

    #Unmapped address 0x17 testing: random write/read operations
    #Address 0x17 read value
    csrr x14, 0x17

    #Unmapped address 0x5f7 testing: random write/read operations
    #Address 0x5f7 read value
    csrr x14, 0x5f7

    #Address 0x5f7 Write value 0xddc59ebf
    li x3, 0xddc59ebf
    csrw 0x5f7, x3

    #Address 0x5f7 read value
    csrr x14, 0x5f7

    #Address 0x5f7 Write value 0x53934539
    li x3, 0x53934539
    csrw 0x5f7, x3

    #Unmapped address 0x77c testing: random write/read operations
    #Address 0x77c Write value 0x73202d59
    li x3, 0x73202d59
    csrw 0x77c, x3

    #Unmapped address 0xb7c testing: random write/read operations
    #Address 0xb7c Write value 0xc7ae349
    li x3, 0xc7ae349
    csrw 0xb7c, x3

    #Unmapped address 0x6ea testing: random write/read operations
    #Address 0x6ea read value
    csrr x14, 0x6ea

    #Address 0x6ea Write value 0x41ba1081
    li x3, 0x41ba1081
    csrw 0x6ea, x3

    #Address 0x6ea read value
    csrr x14, 0x6ea

    #Address 0x6ea read value
    csrr x14, 0x6ea

    #Address 0x6ea read value
    csrr x14, 0x6ea

    #Unmapped address 0x160 testing: random write/read operations
    #Address 0x160 read value
    csrr x14, 0x160

    #Address 0x160 Write value 0x984360
    li x3, 0x984360
    csrw 0x160, x3

    #Address 0x160 read value
    csrr x14, 0x160

    #Address 0x160 Write value 0x7f65ac3d
    li x3, 0x7f65ac3d
    csrw 0x160, x3

    #Unmapped address 0x6d2 testing: random write/read operations
    #Address 0x6d2 Write value 0x957a4ec5
    li x3, 0x957a4ec5
    csrw 0x6d2, x3

    #Address 0x6d2 Write value 0xd2a4c75d
    li x3, 0xd2a4c75d
    csrw 0x6d2, x3

    #Unmapped address 0xda testing: random write/read operations
    #Address 0xda read value
    csrr x14, 0xda

    #Address 0xda Write value 0x98843cd1
    li x3, 0x98843cd1
    csrw 0xda, x3

    #Unmapped address 0xcef testing: random write/read operations
    #Address 0xcef Write value 0xe2256286
    li x3, 0xe2256286
    csrw 0xcef, x3

    #Address 0xcef Write value 0xd7979808
    li x3, 0xd7979808
    csrw 0xcef, x3

    #Address 0xcef read value
    csrr x14, 0xcef

    #Address 0xcef Write value 0xcbb0edb5
    li x3, 0xcbb0edb5
    csrw 0xcef, x3

    #Address 0xcef Write value 0x392e4f3
    li x3, 0x392e4f3
    csrw 0xcef, x3

    #Unmapped address 0xe59 testing: random write/read operations
    #Address 0xe59 Write value 0x4dae7df0
    li x3, 0x4dae7df0
    csrw 0xe59, x3

    #Address 0xe59 read value
    csrr x14, 0xe59

    #Unmapped address 0x8a6 testing: random write/read operations
    #Address 0x8a6 read value
    csrr x14, 0x8a6

    #Address 0x8a6 read value
    csrr x14, 0x8a6

    #Address 0x8a6 read value
    csrr x14, 0x8a6

    #Address 0x8a6 read value
    csrr x14, 0x8a6

    #Address 0x8a6 read value
    csrr x14, 0x8a6

    #Unmapped address 0xd06 testing: random write/read operations
    #Address 0xd06 read value
    csrr x14, 0xd06

    #Address 0xd06 Write value 0x58bb09eb
    li x3, 0x58bb09eb
    csrw 0xd06, x3

    #Address 0xd06 read value
    csrr x14, 0xd06

    #Address 0xd06 read value
    csrr x14, 0xd06

    #Address 0xd06 Write value 0xf7ca800f
    li x3, 0xf7ca800f
    csrw 0xd06, x3

    #Unmapped address 0x456 testing: random write/read operations
    #Address 0x456 Write value 0x2ada4d04
    li x3, 0x2ada4d04
    csrw 0x456, x3

    #Unmapped address 0xe85 testing: random write/read operations
    #Address 0xe85 Write value 0xa0639da
    li x3, 0xa0639da
    csrw 0xe85, x3

    #Address 0xe85 Write value 0xb156671
    li x3, 0xb156671
    csrw 0xe85, x3

    #Address 0xe85 read value
    csrr x14, 0xe85

    #Address 0xe85 Write value 0x535bdfe7
    li x3, 0x535bdfe7
    csrw 0xe85, x3

    #Address 0xe85 read value
    csrr x14, 0xe85

    #Unmapped address 0x4f3 testing: random write/read operations
    #Address 0x4f3 Write value 0x4474cf5e
    li x3, 0x4474cf5e
    csrw 0x4f3, x3

    #Address 0x4f3 Write value 0x57b21319
    li x3, 0x57b21319
    csrw 0x4f3, x3

    #Address 0x4f3 read value
    csrr x14, 0x4f3

    #Address 0x4f3 read value
    csrr x14, 0x4f3

    #Unmapped address 0x737 testing: random write/read operations
    #Address 0x737 Write value 0xd3e9722d
    li x3, 0xd3e9722d
    csrw 0x737, x3

    #Unmapped address 0x5d9 testing: random write/read operations
    #Address 0x5d9 Write value 0xd64cf5b6
    li x3, 0xd64cf5b6
    csrw 0x5d9, x3

    #Address 0x5d9 Write value 0xe19c19dc
    li x3, 0xe19c19dc
    csrw 0x5d9, x3

    #Address 0x5d9 read value
    csrr x14, 0x5d9

    #Address 0x5d9 Write value 0xf3bb64fc
    li x3, 0xf3bb64fc
    csrw 0x5d9, x3

    #Unmapped address 0xcd1 testing: random write/read operations
    #Address 0xcd1 Write value 0xa7daecbb
    li x3, 0xa7daecbb
    csrw 0xcd1, x3

    #Address 0xcd1 Write value 0x723926c8
    li x3, 0x723926c8
    csrw 0xcd1, x3

    #Unmapped address 0x9ff testing: random write/read operations
    #Address 0x9ff read value
    csrr x14, 0x9ff

    #Address 0x9ff read value
    csrr x14, 0x9ff

    #Unmapped address 0xecd testing: random write/read operations
    #Address 0xecd Write value 0xc7cbe4f4
    li x3, 0xc7cbe4f4
    csrw 0xecd, x3

    #Address 0xecd Write value 0x6489b39a
    li x3, 0x6489b39a
    csrw 0xecd, x3

    #Unmapped address 0xf58 testing: random write/read operations
    #Address 0xf58 Write value 0x8727207f
    li x3, 0x8727207f
    csrw 0xf58, x3

    #Address 0xf58 read value
    csrr x14, 0xf58

    #Unmapped address 0x50f testing: random write/read operations
    #Address 0x50f read value
    csrr x14, 0x50f

    #Address 0x50f Write value 0x5fa4929b
    li x3, 0x5fa4929b
    csrw 0x50f, x3

    #Unmapped address 0xb5b testing: random write/read operations
    #Address 0xb5b Write value 0xe8ec9934
    li x3, 0xe8ec9934
    csrw 0xb5b, x3

    #Address 0xb5b read value
    csrr x14, 0xb5b

    #Address 0xb5b Write value 0x48f9d508
    li x3, 0x48f9d508
    csrw 0xb5b, x3

    #Unmapped address 0x21a testing: random write/read operations
    #Address 0x21a Write value 0xe790ec63
    li x3, 0xe790ec63
    csrw 0x21a, x3

    #Address 0x21a read value
    csrr x14, 0x21a

    #Address 0x21a read value
    csrr x14, 0x21a

    #Address 0x21a read value
    csrr x14, 0x21a

    #Unmapped address 0x6e0 testing: random write/read operations
    #Address 0x6e0 Write value 0xf1419b54
    li x3, 0xf1419b54
    csrw 0x6e0, x3

    #Address 0x6e0 Write value 0x4f75d280
    li x3, 0x4f75d280
    csrw 0x6e0, x3

    #Address 0x6e0 Write value 0xa806c073
    li x3, 0xa806c073
    csrw 0x6e0, x3

    #Address 0x6e0 Write value 0x120564c7
    li x3, 0x120564c7
    csrw 0x6e0, x3

    #Unmapped address 0x1d4 testing: random write/read operations
    #Address 0x1d4 read value
    csrr x14, 0x1d4

    #Address 0x1d4 read value
    csrr x14, 0x1d4

    #Address 0x1d4 read value
    csrr x14, 0x1d4

    #Address 0x1d4 read value
    csrr x14, 0x1d4

    #Address 0x1d4 read value
    csrr x14, 0x1d4

    #Unmapped address 0x3c6 testing: random write/read operations
    #Address 0x3c6 read value
    csrr x14, 0x3c6

    #Unmapped address 0xbef testing: random write/read operations
    #Address 0xbef Write value 0x8c7159c0
    li x3, 0x8c7159c0
    csrw 0xbef, x3

    #Address 0xbef read value
    csrr x14, 0xbef

    #Address 0xbef read value
    csrr x14, 0xbef

    #Address 0xbef read value
    csrr x14, 0xbef

    #Unmapped address 0xa7c testing: random write/read operations
    #Address 0xa7c Write value 0xfb170d7f
    li x3, 0xfb170d7f
    csrw 0xa7c, x3

    #Address 0xa7c Write value 0x8290a7a5
    li x3, 0x8290a7a5
    csrw 0xa7c, x3

    #Unmapped address 0x406 testing: random write/read operations
    #Address 0x406 read value
    csrr x14, 0x406

    #Address 0x406 read value
    csrr x14, 0x406

    #Address 0x406 Write value 0x8891c96b
    li x3, 0x8891c96b
    csrw 0x406, x3

    #Unmapped address 0xe9b testing: random write/read operations
    #Address 0xe9b Write value 0x73f81779
    li x3, 0x73f81779
    csrw 0xe9b, x3

    #Unmapped address 0xf08 testing: random write/read operations
    #Address 0xf08 read value
    csrr x14, 0xf08

    #Address 0xf08 Write value 0x742f157d
    li x3, 0x742f157d
    csrw 0xf08, x3

    #Unmapped address 0xda3 testing: random write/read operations
    #Address 0xda3 read value
    csrr x14, 0xda3

    #Address 0xda3 Write value 0x3a948e40
    li x3, 0x3a948e40
    csrw 0xda3, x3

    #Address 0xda3 read value
    csrr x14, 0xda3

    #Address 0xda3 read value
    csrr x14, 0xda3

    #Unmapped address 0xbf0 testing: random write/read operations
    #Address 0xbf0 read value
    csrr x14, 0xbf0

    #Address 0xbf0 read value
    csrr x14, 0xbf0

    #Address 0xbf0 Write value 0x66067b1
    li x3, 0x66067b1
    csrw 0xbf0, x3

    #Address 0xbf0 Write value 0x88f74ab
    li x3, 0x88f74ab
    csrw 0xbf0, x3

    #Unmapped address 0xbf testing: random write/read operations
    #Address 0xbf Write value 0xa4c3e931
    li x3, 0xa4c3e931
    csrw 0xbf, x3

    #Address 0xbf Write value 0xb02a6b02
    li x3, 0xb02a6b02
    csrw 0xbf, x3

    #Unmapped address 0x6ac testing: random write/read operations
    #Address 0x6ac read value
    csrr x14, 0x6ac

    #Unmapped address 0xfb2 testing: random write/read operations
    #Address 0xfb2 read value
    csrr x14, 0xfb2

    #Unmapped address 0x248 testing: random write/read operations
    #Address 0x248 Write value 0xf6a01369
    li x3, 0xf6a01369
    csrw 0x248, x3

    #Unmapped address 0xcf3 testing: random write/read operations
    #Address 0xcf3 read value
    csrr x14, 0xcf3

    #Address 0xcf3 read value
    csrr x14, 0xcf3

    #Unmapped address 0x2d6 testing: random write/read operations
    #Address 0x2d6 read value
    csrr x14, 0x2d6

    #Address 0x2d6 Write value 0x3d42e8b2
    li x3, 0x3d42e8b2
    csrw 0x2d6, x3

    #Address 0x2d6 read value
    csrr x14, 0x2d6

    #Address 0x2d6 read value
    csrr x14, 0x2d6

    #Unmapped address 0xfdf testing: random write/read operations
    #Address 0xfdf read value
    csrr x14, 0xfdf

    #Address 0xfdf read value
    csrr x14, 0xfdf

    #Address 0xfdf Write value 0x2f4a4e2d
    li x3, 0x2f4a4e2d
    csrw 0xfdf, x3

    #Address 0xfdf read value
    csrr x14, 0xfdf

    #Unmapped address 0x1ff testing: random write/read operations
    #Address 0x1ff read value
    csrr x14, 0x1ff

    #Address 0x1ff read value
    csrr x14, 0x1ff

    #Address 0x1ff read value
    csrr x14, 0x1ff

    #Address 0x1ff read value
    csrr x14, 0x1ff

    #Unmapped address 0xe5d testing: random write/read operations
    #Address 0xe5d read value
    csrr x14, 0xe5d

    #Address 0xe5d read value
    csrr x14, 0xe5d

    #Address 0xe5d Write value 0x51b4939b
    li x3, 0x51b4939b
    csrw 0xe5d, x3

    #Address 0xe5d read value
    csrr x14, 0xe5d

    #Address 0xe5d Write value 0x147a1ee
    li x3, 0x147a1ee
    csrw 0xe5d, x3

    #Unmapped address 0x986 testing: random write/read operations
    #Address 0x986 Write value 0x8bf2e853
    li x3, 0x8bf2e853
    csrw 0x986, x3

    #Address 0x986 read value
    csrr x14, 0x986

    #Unmapped address 0x1e2 testing: random write/read operations
    #Address 0x1e2 read value
    csrr x14, 0x1e2

    #Address 0x1e2 Write value 0xee38156f
    li x3, 0xee38156f
    csrw 0x1e2, x3

    #Address 0x1e2 read value
    csrr x14, 0x1e2

    #Address 0x1e2 read value
    csrr x14, 0x1e2

    #Unmapped address 0x981 testing: random write/read operations
    #Address 0x981 read value
    csrr x14, 0x981

    #Address 0x981 read value
    csrr x14, 0x981

    #Unmapped address 0xcb5 testing: random write/read operations
    #Address 0xcb5 read value
    csrr x14, 0xcb5

    #Address 0xcb5 Write value 0x677b450c
    li x3, 0x677b450c
    csrw 0xcb5, x3

    #Address 0xcb5 Write value 0x9e2c29e0
    li x3, 0x9e2c29e0
    csrw 0xcb5, x3

    #Address 0xcb5 read value
    csrr x14, 0xcb5

    #Unmapped address 0x565 testing: random write/read operations
    #Address 0x565 Write value 0x700767e0
    li x3, 0x700767e0
    csrw 0x565, x3

    #Address 0x565 read value
    csrr x14, 0x565

    #Address 0x565 Write value 0x4a6f1cf6
    li x3, 0x4a6f1cf6
    csrw 0x565, x3

    #Address 0x565 Write value 0x62e7d97c
    li x3, 0x62e7d97c
    csrw 0x565, x3

    #Address 0x565 read value
    csrr x14, 0x565

    #Unmapped address 0x4b0 testing: random write/read operations
    #Address 0x4b0 Write value 0xb3898f59
    li x3, 0xb3898f59
    csrw 0x4b0, x3

    #Unmapped address 0x655 testing: random write/read operations
    #Address 0x655 Write value 0x6240a1e6
    li x3, 0x6240a1e6
    csrw 0x655, x3

    #Address 0x655 read value
    csrr x14, 0x655

    #Address 0x655 read value
    csrr x14, 0x655

    #Address 0x655 read value
    csrr x14, 0x655

    #Unmapped address 0xefb testing: random write/read operations
    #Address 0xefb read value
    csrr x14, 0xefb

    #Address 0xefb Write value 0x2e332904
    li x3, 0x2e332904
    csrw 0xefb, x3

    #Address 0xefb Write value 0xd73e1779
    li x3, 0xd73e1779
    csrw 0xefb, x3

    #Address 0xefb read value
    csrr x14, 0xefb

    #Address 0xefb read value
    csrr x14, 0xefb

    #Mapped address 0x323 (mhpmevent3) testing: random write/read operations
    #Address 0x323 Write value 0x6cb0183d
    li x3, 0x6cb0183d
    csrw 0x323, x3

    #Address 0x323 Write value 0x46ffbbf
    li x3, 0x46ffbbf
    csrw 0x323, x3

    #Address 0x323 Write value 0x5fbc8fa8
    li x3, 0x5fbc8fa8
    csrw 0x323, x3

    #Address 0x323 Write value 0xae0c138d
    li x3, 0xae0c138d
    csrw 0x323, x3

    #Address 0x323 read value
    csrr x14, 0x323

    #Unmapped address 0x214 testing: random write/read operations
    #Address 0x214 Write value 0xa3f7bc41
    li x3, 0xa3f7bc41
    csrw 0x214, x3

    #Address 0x214 read value
    csrr x14, 0x214

    #Address 0x214 Write value 0xc90415a3
    li x3, 0xc90415a3
    csrw 0x214, x3

    #Address 0x214 Write value 0x449cb529
    li x3, 0x449cb529
    csrw 0x214, x3

    #Unmapped address 0x745 testing: random write/read operations
    #Address 0x745 Write value 0xf1732426
    li x3, 0xf1732426
    csrw 0x745, x3

    #Address 0x745 read value
    csrr x14, 0x745

    #Address 0x745 Write value 0xd1e6147e
    li x3, 0xd1e6147e
    csrw 0x745, x3

    #Address 0x745 Write value 0x398f9a46
    li x3, 0x398f9a46
    csrw 0x745, x3

    #Unmapped address 0x643 testing: random write/read operations
    #Address 0x643 read value
    csrr x14, 0x643

    #Address 0x643 read value
    csrr x14, 0x643

    #Address 0x643 Write value 0xeb64bc7a
    li x3, 0xeb64bc7a
    csrw 0x643, x3

    #Address 0x643 Write value 0x46c41a68
    li x3, 0x46c41a68
    csrw 0x643, x3

    #Unmapped address 0xff2 testing: random write/read operations
    #Address 0xff2 Write value 0x3974bbd7
    li x3, 0x3974bbd7
    csrw 0xff2, x3

    #Address 0xff2 Write value 0x517af146
    li x3, 0x517af146
    csrw 0xff2, x3

    #Address 0xff2 read value
    csrr x14, 0xff2

    #Address 0xff2 Write value 0xd0c2b7fc
    li x3, 0xd0c2b7fc
    csrw 0xff2, x3

    #Address 0xff2 Write value 0xe756ce97
    li x3, 0xe756ce97
    csrw 0xff2, x3

    #Unmapped address 0x142 testing: random write/read operations
    #Address 0x142 read value
    csrr x14, 0x142

    #Address 0x142 read value
    csrr x14, 0x142

    #Address 0x142 read value
    csrr x14, 0x142

    #Unmapped address 0xee5 testing: random write/read operations
    #Address 0xee5 Write value 0x546210bd
    li x3, 0x546210bd
    csrw 0xee5, x3

    #Unmapped address 0x987 testing: random write/read operations
    #Address 0x987 read value
    csrr x14, 0x987

    #Address 0x987 read value
    csrr x14, 0x987

    #Address 0x987 read value
    csrr x14, 0x987

    #Address 0x987 read value
    csrr x14, 0x987

    #Address 0x987 read value
    csrr x14, 0x987

    #Unmapped address 0x940 testing: random write/read operations
    #Address 0x940 read value
    csrr x14, 0x940

    #Address 0x940 read value
    csrr x14, 0x940

    #Unmapped address 0x8b testing: random write/read operations
    #Address 0x8b Write value 0x8dec9578
    li x3, 0x8dec9578
    csrw 0x8b, x3

    #Address 0x8b Write value 0xc3123435
    li x3, 0xc3123435
    csrw 0x8b, x3

    #Address 0x8b Write value 0xe0e3c828
    li x3, 0xe0e3c828
    csrw 0x8b, x3

    #Address 0x8b read value
    csrr x14, 0x8b

    #Address 0x8b read value
    csrr x14, 0x8b

    #Unmapped address 0x173 testing: random write/read operations
    #Address 0x173 Write value 0x3a7ff65
    li x3, 0x3a7ff65
    csrw 0x173, x3

    #Address 0x173 read value
    csrr x14, 0x173

    #Address 0x173 Write value 0x297702fe
    li x3, 0x297702fe
    csrw 0x173, x3

    #Unmapped address 0xa39 testing: random write/read operations
    #Address 0xa39 read value
    csrr x14, 0xa39

    #Unmapped address 0x3f8 testing: random write/read operations
    #Address 0x3f8 read value
    csrr x14, 0x3f8

    #Address 0x3f8 read value
    csrr x14, 0x3f8

    #Address 0x3f8 Write value 0x57b12170
    li x3, 0x57b12170
    csrw 0x3f8, x3

    #Address 0x3f8 Write value 0xec8aa97a
    li x3, 0xec8aa97a
    csrw 0x3f8, x3

    #Address 0x3f8 read value
    csrr x14, 0x3f8

    #Unmapped address 0x16f testing: random write/read operations
    #Address 0x16f read value
    csrr x14, 0x16f

    #Address 0x16f Write value 0xd40f193c
    li x3, 0xd40f193c
    csrw 0x16f, x3

    #Mapped address 0x3b6 (pmpaddr6) testing: random write/read operations
    #Address 0x3b6 Write value 0x1273a986
    li x3, 0x1273a986
    csrw 0x3b6, x3

    #Address 0x3b6 Write value 0x320684a4
    li x3, 0x320684a4
    csrw 0x3b6, x3

    #Address 0x3b6 read value
    csrr x14, 0x3b6

    #Unmapped address 0x44d testing: random write/read operations
    #Address 0x44d Write value 0x1b8db808
    li x3, 0x1b8db808
    csrw 0x44d, x3

    #Address 0x44d Write value 0xe9565114
    li x3, 0xe9565114
    csrw 0x44d, x3

    #Address 0x44d read value
    csrr x14, 0x44d

    #Address 0x44d Write value 0x38550058
    li x3, 0x38550058
    csrw 0x44d, x3

    #Unmapped address 0xb2b testing: random write/read operations
    #Address 0xb2b read value
    csrr x14, 0xb2b

    #Unmapped address 0x6d testing: random write/read operations
    #Address 0x6d Write value 0xc85f2db7
    li x3, 0xc85f2db7
    csrw 0x6d, x3

    #Unmapped address 0x9e4 testing: random write/read operations
    #Address 0x9e4 Write value 0xa642f887
    li x3, 0xa642f887
    csrw 0x9e4, x3

    #Address 0x9e4 Write value 0x76c1164
    li x3, 0x76c1164
    csrw 0x9e4, x3

    #Unmapped address 0x20a testing: random write/read operations
    #Address 0x20a Write value 0xf985dff2
    li x3, 0xf985dff2
    csrw 0x20a, x3

    #Address 0x20a Write value 0xdefba30f
    li x3, 0xdefba30f
    csrw 0x20a, x3

    #Address 0x20a Write value 0x62bf07f4
    li x3, 0x62bf07f4
    csrw 0x20a, x3

    #Unmapped address 0x895 testing: random write/read operations
    #Address 0x895 Write value 0x48880e
    li x3, 0x48880e
    csrw 0x895, x3

    #Address 0x895 Write value 0x95f9856
    li x3, 0x95f9856
    csrw 0x895, x3

    #Address 0x895 Write value 0x14c6c8fa
    li x3, 0x14c6c8fa
    csrw 0x895, x3

    #Address 0x895 read value
    csrr x14, 0x895

    #Address 0x895 read value
    csrr x14, 0x895

    #Unmapped address 0x781 testing: random write/read operations
    #Address 0x781 read value
    csrr x14, 0x781

    #Address 0x781 Write value 0x5ee07f2a
    li x3, 0x5ee07f2a
    csrw 0x781, x3

    #Address 0x781 read value
    csrr x14, 0x781

    #Address 0x781 read value
    csrr x14, 0x781

    #Address 0x781 Write value 0xc6f26c3c
    li x3, 0xc6f26c3c
    csrw 0x781, x3

    #Unmapped address 0x428 testing: random write/read operations
    #Address 0x428 read value
    csrr x14, 0x428

    #Address 0x428 Write value 0xbe8fcd85
    li x3, 0xbe8fcd85
    csrw 0x428, x3

    #Unmapped address 0x838 testing: random write/read operations
    #Address 0x838 read value
    csrr x14, 0x838

    #Address 0x838 Write value 0xf270cebf
    li x3, 0xf270cebf
    csrw 0x838, x3

    #Address 0x838 Write value 0xd7c24075
    li x3, 0xd7c24075
    csrw 0x838, x3

    #Address 0x838 read value
    csrr x14, 0x838

    #Address 0x838 Write value 0xcc58ed4c
    li x3, 0xcc58ed4c
    csrw 0x838, x3

    #Unmapped address 0x52a testing: random write/read operations
    #Address 0x52a Write value 0xdf7b31c1
    li x3, 0xdf7b31c1
    csrw 0x52a, x3

    #Address 0x52a read value
    csrr x14, 0x52a

    #Address 0x52a Write value 0x9a9c4b8b
    li x3, 0x9a9c4b8b
    csrw 0x52a, x3

    #Address 0x52a read value
    csrr x14, 0x52a

    #Unmapped address 0x31b testing: random write/read operations
    #Address 0x31b Write value 0xaa208053
    li x3, 0xaa208053
    csrw 0x31b, x3

    #Address 0x31b read value
    csrr x14, 0x31b

    #Address 0x31b Write value 0x567b620b
    li x3, 0x567b620b
    csrw 0x31b, x3

    #Address 0x31b read value
    csrr x14, 0x31b

    #Address 0x31b Write value 0xdda5cc22
    li x3, 0xdda5cc22
    csrw 0x31b, x3

    #Unmapped address 0x268 testing: random write/read operations
    #Address 0x268 read value
    csrr x14, 0x268

    #Address 0x268 Write value 0xf8feaf97
    li x3, 0xf8feaf97
    csrw 0x268, x3

    #Address 0x268 read value
    csrr x14, 0x268

    #Address 0x268 Write value 0x74ae77cb
    li x3, 0x74ae77cb
    csrw 0x268, x3

    #Unmapped address 0x1d7 testing: random write/read operations
    #Address 0x1d7 read value
    csrr x14, 0x1d7

    #Unmapped address 0xd58 testing: random write/read operations
    #Address 0xd58 read value
    csrr x14, 0xd58

    #Address 0xd58 Write value 0xe9b68782
    li x3, 0xe9b68782
    csrw 0xd58, x3

    #Address 0xd58 read value
    csrr x14, 0xd58

    #Address 0xd58 read value
    csrr x14, 0xd58

    #Unmapped address 0x970 testing: random write/read operations
    #Address 0x970 Write value 0xe276f8e3
    li x3, 0xe276f8e3
    csrw 0x970, x3

    #Address 0x970 Write value 0xfe8b6ea3
    li x3, 0xfe8b6ea3
    csrw 0x970, x3

    #Address 0x970 Write value 0xc3ed8731
    li x3, 0xc3ed8731
    csrw 0x970, x3

    #Unmapped address 0xac8 testing: random write/read operations
    #Address 0xac8 Write value 0x386edcb0
    li x3, 0x386edcb0
    csrw 0xac8, x3

    #Address 0xac8 read value
    csrr x14, 0xac8

    #Unmapped address 0xa25 testing: random write/read operations
    #Address 0xa25 Write value 0x5fbe2941
    li x3, 0x5fbe2941
    csrw 0xa25, x3

    #Address 0xa25 read value
    csrr x14, 0xa25

    #Address 0xa25 Write value 0xd9966260
    li x3, 0xd9966260
    csrw 0xa25, x3

    #Unmapped address 0xf84 testing: random write/read operations
    #Address 0xf84 read value
    csrr x14, 0xf84

    #Unmapped address 0xce5 testing: random write/read operations
    #Address 0xce5 read value
    csrr x14, 0xce5

    #Address 0xce5 read value
    csrr x14, 0xce5

    #Address 0xce5 Write value 0xcf4cdd65
    li x3, 0xcf4cdd65
    csrw 0xce5, x3

    #Address 0xce5 read value
    csrr x14, 0xce5

    #Address 0xce5 Write value 0x12785e07
    li x3, 0x12785e07
    csrw 0xce5, x3

    #Unmapped address 0x8f testing: random write/read operations
    #Address 0x8f Write value 0x792c8b27
    li x3, 0x792c8b27
    csrw 0x8f, x3

    #Unmapped address 0x404 testing: random write/read operations
    #Address 0x404 read value
    csrr x14, 0x404

    #Address 0x404 read value
    csrr x14, 0x404

    #Address 0x404 Write value 0xbccd4a53
    li x3, 0xbccd4a53
    csrw 0x404, x3

    #Address 0x404 Write value 0xb2d53d91
    li x3, 0xb2d53d91
    csrw 0x404, x3

    #Unmapped address 0xea8 testing: random write/read operations
    #Address 0xea8 read value
    csrr x14, 0xea8

    #Address 0xea8 Write value 0x78fad717
    li x3, 0x78fad717
    csrw 0xea8, x3

    #Address 0xea8 read value
    csrr x14, 0xea8

    #Address 0xea8 Write value 0x69143c8d
    li x3, 0x69143c8d
    csrw 0xea8, x3

    #Address 0xea8 read value
    csrr x14, 0xea8

    #Unmapped address 0x3f1 testing: random write/read operations
    #Address 0x3f1 Write value 0x59f85af2
    li x3, 0x59f85af2
    csrw 0x3f1, x3

    #Address 0x3f1 Write value 0x8da5e017
    li x3, 0x8da5e017
    csrw 0x3f1, x3

    #Address 0x3f1 read value
    csrr x14, 0x3f1

    #Address 0x3f1 read value
    csrr x14, 0x3f1

    #Address 0x3f1 Write value 0xbc2ac078
    li x3, 0xbc2ac078
    csrw 0x3f1, x3

    #Unmapped address 0x923 testing: random write/read operations
    #Address 0x923 Write value 0x79349dab
    li x3, 0x79349dab
    csrw 0x923, x3

    #Address 0x923 read value
    csrr x14, 0x923

    #Address 0x923 Write value 0x1af7af05
    li x3, 0x1af7af05
    csrw 0x923, x3

    #Unmapped address 0xc49 testing: random write/read operations
    #Address 0xc49 Write value 0x2af64517
    li x3, 0x2af64517
    csrw 0xc49, x3

    #Address 0xc49 Write value 0xb78070f4
    li x3, 0xb78070f4
    csrw 0xc49, x3

    #Address 0xc49 read value
    csrr x14, 0xc49

    #Unmapped address 0xf94 testing: random write/read operations
    #Address 0xf94 Write value 0x72240772
    li x3, 0x72240772
    csrw 0xf94, x3

    #Address 0xf94 read value
    csrr x14, 0xf94

    #Address 0xf94 Write value 0x51d08fae
    li x3, 0x51d08fae
    csrw 0xf94, x3

    #Address 0xf94 read value
    csrr x14, 0xf94

    #Address 0xf94 read value
    csrr x14, 0xf94

    #Unmapped address 0x789 testing: random write/read operations
    #Address 0x789 Write value 0xa26117dd
    li x3, 0xa26117dd
    csrw 0x789, x3

    #Address 0x789 read value
    csrr x14, 0x789

    #Address 0x789 Write value 0xca7ace9c
    li x3, 0xca7ace9c
    csrw 0x789, x3

    #Address 0x789 Write value 0x8bffef3c
    li x3, 0x8bffef3c
    csrw 0x789, x3

    #Address 0x789 Write value 0xd11daf84
    li x3, 0xd11daf84
    csrw 0x789, x3

    #Unmapped address 0xd11 testing: random write/read operations
    #Address 0xd11 read value
    csrr x14, 0xd11

    #Address 0xd11 read value
    csrr x14, 0xd11

    #Unmapped address 0xdc4 testing: random write/read operations
    #Address 0xdc4 read value
    csrr x14, 0xdc4

    #Address 0xdc4 Write value 0x2882595
    li x3, 0x2882595
    csrw 0xdc4, x3

    #Address 0xdc4 Write value 0xc58c2a
    li x3, 0xc58c2a
    csrw 0xdc4, x3

    #Unmapped address 0x819 testing: random write/read operations
    #Address 0x819 Write value 0x3adb9a96
    li x3, 0x3adb9a96
    csrw 0x819, x3

    #Address 0x819 read value
    csrr x14, 0x819

    #Address 0x819 read value
    csrr x14, 0x819

    #Address 0x819 read value
    csrr x14, 0x819

    #Unmapped address 0x831 testing: random write/read operations
    #Address 0x831 read value
    csrr x14, 0x831

    #Address 0x831 read value
    csrr x14, 0x831

    #Address 0x831 Write value 0x585f5f99
    li x3, 0x585f5f99
    csrw 0x831, x3

    #Address 0x831 Write value 0xd72ab20a
    li x3, 0xd72ab20a
    csrw 0x831, x3

    #Address 0x831 read value
    csrr x14, 0x831

    #Unmapped address 0x793 testing: random write/read operations
    #Address 0x793 Write value 0x52d51ef2
    li x3, 0x52d51ef2
    csrw 0x793, x3

    #Address 0x793 Write value 0x935a4d28
    li x3, 0x935a4d28
    csrw 0x793, x3

    #Address 0x793 Write value 0xe399894
    li x3, 0xe399894
    csrw 0x793, x3

    #Address 0x793 Write value 0x74584c47
    li x3, 0x74584c47
    csrw 0x793, x3

    #Unmapped address 0x2d5 testing: random write/read operations
    #Address 0x2d5 read value
    csrr x14, 0x2d5

    #Address 0x2d5 read value
    csrr x14, 0x2d5

    #Address 0x2d5 Write value 0x7ca838ac
    li x3, 0x7ca838ac
    csrw 0x2d5, x3

    #Address 0x2d5 Write value 0x81b46c5c
    li x3, 0x81b46c5c
    csrw 0x2d5, x3

    #Address 0x2d5 read value
    csrr x14, 0x2d5

    #Unmapped address 0x4d1 testing: random write/read operations
    #Address 0x4d1 read value
    csrr x14, 0x4d1

    #Address 0x4d1 Write value 0xf4f77b9b
    li x3, 0xf4f77b9b
    csrw 0x4d1, x3

    #Address 0x4d1 Write value 0x98e1b06a
    li x3, 0x98e1b06a
    csrw 0x4d1, x3

    #Address 0x4d1 read value
    csrr x14, 0x4d1

    #Mapped address 0xb02 (minstret) testing: random write/read operations
    #Address 0xb02 read value
    csrr x14, 0xb02

    #Address 0xb02 Write value 0x6b620457
    li x3, 0x6b620457
    csrw 0xb02, x3

    #Address 0xb02 read value
    csrr x14, 0xb02

    #Unmapped address 0xd74 testing: random write/read operations
    #Address 0xd74 Write value 0xd16926d1
    li x3, 0xd16926d1
    csrw 0xd74, x3

    #Address 0xd74 read value
    csrr x14, 0xd74

    #Address 0xd74 Write value 0x5890c55f
    li x3, 0x5890c55f
    csrw 0xd74, x3

    #Address 0xd74 Write value 0x9ea9c5d5
    li x3, 0x9ea9c5d5
    csrw 0xd74, x3

    #Address 0xd74 read value
    csrr x14, 0xd74

    #Unmapped address 0x86a testing: random write/read operations
    #Address 0x86a Write value 0x686decc3
    li x3, 0x686decc3
    csrw 0x86a, x3

    #Address 0x86a read value
    csrr x14, 0x86a

    #Address 0x86a Write value 0xefca3af
    li x3, 0xefca3af
    csrw 0x86a, x3

    #Unmapped address 0x817 testing: random write/read operations
    #Address 0x817 Write value 0x6aa701cd
    li x3, 0x6aa701cd
    csrw 0x817, x3

    #Unmapped address 0x38b testing: random write/read operations
    #Address 0x38b Write value 0x41f56abe
    li x3, 0x41f56abe
    csrw 0x38b, x3

    #Address 0x38b Write value 0x9d89ef38
    li x3, 0x9d89ef38
    csrw 0x38b, x3

    #Address 0x38b Write value 0xe5222f7f
    li x3, 0xe5222f7f
    csrw 0x38b, x3

    #Address 0x38b read value
    csrr x14, 0x38b

    #Address 0x38b read value
    csrr x14, 0x38b

    #Unmapped address 0xa22 testing: random write/read operations
    #Address 0xa22 read value
    csrr x14, 0xa22

    #Address 0xa22 read value
    csrr x14, 0xa22

    #Address 0xa22 Write value 0xb92885dc
    li x3, 0xb92885dc
    csrw 0xa22, x3

    #Address 0xa22 read value
    csrr x14, 0xa22

    #Address 0xa22 read value
    csrr x14, 0xa22

    #Unmapped address 0x319 testing: random write/read operations
    #Address 0x319 Write value 0xe430e491
    li x3, 0xe430e491
    csrw 0x319, x3

    #Address 0x319 read value
    csrr x14, 0x319

    #Address 0x319 read value
    csrr x14, 0x319

    #Address 0x319 read value
    csrr x14, 0x319

    #Unmapped address 0x17d testing: random write/read operations
    #Address 0x17d read value
    csrr x14, 0x17d

    #Address 0x17d Write value 0x7e39bdde
    li x3, 0x7e39bdde
    csrw 0x17d, x3

    #Address 0x17d read value
    csrr x14, 0x17d

    #Address 0x17d Write value 0xb1ecc031
    li x3, 0xb1ecc031
    csrw 0x17d, x3

    #Unmapped address 0xe00 testing: random write/read operations
    #Address 0xe00 Write value 0x8cbdffe4
    li x3, 0x8cbdffe4
    csrw 0xe00, x3

    #Address 0xe00 read value
    csrr x14, 0xe00

    #Unmapped address 0xc23 testing: random write/read operations
    #Address 0xc23 read value
    csrr x14, 0xc23

    #Address 0xc23 read value
    csrr x14, 0xc23

    #Unmapped address 0x9c7 testing: random write/read operations
    #Address 0x9c7 Write value 0x2af1b986
    li x3, 0x2af1b986
    csrw 0x9c7, x3

    #Address 0x9c7 read value
    csrr x14, 0x9c7

    #Address 0x9c7 read value
    csrr x14, 0x9c7

    #Address 0x9c7 read value
    csrr x14, 0x9c7

    #Unmapped address 0x1a0 testing: random write/read operations
    #Address 0x1a0 read value
    csrr x14, 0x1a0

    #Unmapped address 0xc16 testing: random write/read operations
    #Address 0xc16 Write value 0x6bf48f06
    li x3, 0x6bf48f06
    csrw 0xc16, x3

    #Address 0xc16 Write value 0xb2a38492
    li x3, 0xb2a38492
    csrw 0xc16, x3

    #Unmapped address 0xf7d testing: random write/read operations
    #Address 0xf7d Write value 0x8705d7b1
    li x3, 0x8705d7b1
    csrw 0xf7d, x3

    #Address 0xf7d read value
    csrr x14, 0xf7d

    #Address 0xf7d Write value 0x58996a88
    li x3, 0x58996a88
    csrw 0xf7d, x3

    #Unmapped address 0x10a testing: random write/read operations
    #Address 0x10a Write value 0xc3455c04
    li x3, 0xc3455c04
    csrw 0x10a, x3

    #Address 0x10a read value
    csrr x14, 0x10a

    #Address 0x10a Write value 0x657c9507
    li x3, 0x657c9507
    csrw 0x10a, x3

    #Address 0x10a Write value 0x227b4965
    li x3, 0x227b4965
    csrw 0x10a, x3

    #Address 0x10a Write value 0x4648f678
    li x3, 0x4648f678
    csrw 0x10a, x3

    #Unmapped address 0x87b testing: random write/read operations
    #Address 0x87b Write value 0x5dbf96f3
    li x3, 0x5dbf96f3
    csrw 0x87b, x3

    #Address 0x87b Write value 0x85b19b06
    li x3, 0x85b19b06
    csrw 0x87b, x3

    #Address 0x87b Write value 0x29089a21
    li x3, 0x29089a21
    csrw 0x87b, x3

    #Unmapped address 0xc59 testing: random write/read operations
    #Address 0xc59 read value
    csrr x14, 0xc59

    #Unmapped address 0x132 testing: random write/read operations
    #Address 0x132 read value
    csrr x14, 0x132

    #Address 0x132 Write value 0x62057eeb
    li x3, 0x62057eeb
    csrw 0x132, x3

    #Address 0x132 read value
    csrr x14, 0x132

    #Unmapped address 0x5db testing: random write/read operations
    #Address 0x5db read value
    csrr x14, 0x5db

    #Address 0x5db read value
    csrr x14, 0x5db

    #Address 0x5db read value
    csrr x14, 0x5db

    #Address 0x5db read value
    csrr x14, 0x5db

    #Unmapped address 0xfc8 testing: random write/read operations
    #Address 0xfc8 read value
    csrr x14, 0xfc8

    #Unmapped address 0x4e testing: random write/read operations
    #Address 0x4e read value
    csrr x14, 0x4e

    #Address 0x4e read value
    csrr x14, 0x4e

    #Address 0x4e Write value 0xb2660d6a
    li x3, 0xb2660d6a
    csrw 0x4e, x3

    #Unmapped address 0x4f8 testing: random write/read operations
    #Address 0x4f8 read value
    csrr x14, 0x4f8

    #Address 0x4f8 read value
    csrr x14, 0x4f8

    #Address 0x4f8 Write value 0x75b36a2
    li x3, 0x75b36a2
    csrw 0x4f8, x3

    #Address 0x4f8 read value
    csrr x14, 0x4f8

    #Address 0x4f8 read value
    csrr x14, 0x4f8

    #Unmapped address 0xac4 testing: random write/read operations
    #Address 0xac4 Write value 0x79853fdf
    li x3, 0x79853fdf
    csrw 0xac4, x3

    #Address 0xac4 read value
    csrr x14, 0xac4

    #Address 0xac4 read value
    csrr x14, 0xac4

    #Address 0xac4 Write value 0x46f35f2b
    li x3, 0x46f35f2b
    csrw 0xac4, x3

    #Unmapped address 0xd8e testing: random write/read operations
    #Address 0xd8e read value
    csrr x14, 0xd8e

    #Address 0xd8e Write value 0xae619c8f
    li x3, 0xae619c8f
    csrw 0xd8e, x3

    #Address 0xd8e Write value 0x5fade882
    li x3, 0x5fade882
    csrw 0xd8e, x3

    #Unmapped address 0x825 testing: random write/read operations
    #Address 0x825 Write value 0x2a56a43b
    li x3, 0x2a56a43b
    csrw 0x825, x3

    #Address 0x825 Write value 0xb2c0454d
    li x3, 0xb2c0454d
    csrw 0x825, x3

    #Address 0x825 Write value 0x7f94e058
    li x3, 0x7f94e058
    csrw 0x825, x3

    #Address 0x825 Write value 0xc383586d
    li x3, 0xc383586d
    csrw 0x825, x3

    #Unmapped address 0x1ce testing: random write/read operations
    #Address 0x1ce Write value 0x71a8b336
    li x3, 0x71a8b336
    csrw 0x1ce, x3

    #Unmapped address 0xd6d testing: random write/read operations
    #Address 0xd6d read value
    csrr x14, 0xd6d

    #Address 0xd6d Write value 0xeb5cc080
    li x3, 0xeb5cc080
    csrw 0xd6d, x3

    #Address 0xd6d Write value 0xf0f2b502
    li x3, 0xf0f2b502
    csrw 0xd6d, x3

    #Unmapped address 0xaf0 testing: random write/read operations
    #Address 0xaf0 read value
    csrr x14, 0xaf0

    #Address 0xaf0 Write value 0x8a34c4b3
    li x3, 0x8a34c4b3
    csrw 0xaf0, x3

    #Unmapped address 0xc87 testing: random write/read operations
    #Address 0xc87 read value
    csrr x14, 0xc87

    #Address 0xc87 read value
    csrr x14, 0xc87

    #Address 0xc87 read value
    csrr x14, 0xc87

    #Unmapped address 0x49e testing: random write/read operations
    #Address 0x49e read value
    csrr x14, 0x49e

    #Address 0x49e read value
    csrr x14, 0x49e

    #Address 0x49e Write value 0xd6f28da2
    li x3, 0xd6f28da2
    csrw 0x49e, x3

    #Address 0x49e read value
    csrr x14, 0x49e

    #Unmapped address 0x982 testing: random write/read operations
    #Address 0x982 Write value 0x5df8b435
    li x3, 0x5df8b435
    csrw 0x982, x3

    #Address 0x982 Write value 0xe84ac571
    li x3, 0xe84ac571
    csrw 0x982, x3

    #Address 0x982 read value
    csrr x14, 0x982

    #Unmapped address 0x7c6 testing: random write/read operations
    #Address 0x7c6 Write value 0xdec1ecec
    li x3, 0xdec1ecec
    csrw 0x7c6, x3

    #Unmapped address 0xb66 testing: random write/read operations
    #Address 0xb66 read value
    csrr x14, 0xb66

    #Address 0xb66 Write value 0xf34b77de
    li x3, 0xf34b77de
    csrw 0xb66, x3

    #Unmapped address 0xa77 testing: random write/read operations
    #Address 0xa77 Write value 0x345c0d4
    li x3, 0x345c0d4
    csrw 0xa77, x3

    #Address 0xa77 Write value 0xafc3d79c
    li x3, 0xafc3d79c
    csrw 0xa77, x3

    #Address 0xa77 Write value 0x57ed596
    li x3, 0x57ed596
    csrw 0xa77, x3

    #Unmapped address 0x9c1 testing: random write/read operations
    #Address 0x9c1 read value
    csrr x14, 0x9c1

    #Address 0x9c1 read value
    csrr x14, 0x9c1

    #Address 0x9c1 read value
    csrr x14, 0x9c1

    #Address 0x9c1 read value
    csrr x14, 0x9c1

    #Address 0x9c1 read value
    csrr x14, 0x9c1

    #Unmapped address 0xba0 testing: random write/read operations
    #Address 0xba0 read value
    csrr x14, 0xba0

    #Address 0xba0 read value
    csrr x14, 0xba0

    #Address 0xba0 read value
    csrr x14, 0xba0

    #Unmapped address 0xed9 testing: random write/read operations
    #Address 0xed9 read value
    csrr x14, 0xed9

    #Address 0xed9 read value
    csrr x14, 0xed9

    #Unmapped address 0x5c4 testing: random write/read operations
    #Address 0x5c4 Write value 0x6543cd1f
    li x3, 0x6543cd1f
    csrw 0x5c4, x3

    #Address 0x5c4 read value
    csrr x14, 0x5c4

    #Unmapped address 0xf4c testing: random write/read operations
    #Address 0xf4c read value
    csrr x14, 0xf4c

    #Address 0xf4c read value
    csrr x14, 0xf4c

    #Address 0xf4c read value
    csrr x14, 0xf4c

    #Address 0xf4c read value
    csrr x14, 0xf4c

    #Address 0xf4c Write value 0xd00724a3
    li x3, 0xd00724a3
    csrw 0xf4c, x3

    #Unmapped address 0x92d testing: random write/read operations
    #Address 0x92d Write value 0xac993fa5
    li x3, 0xac993fa5
    csrw 0x92d, x3

    #Address 0x92d read value
    csrr x14, 0x92d

    #Address 0x92d read value
    csrr x14, 0x92d

    #Unmapped address 0xd6 testing: random write/read operations
    #Address 0xd6 read value
    csrr x14, 0xd6

    #Address 0xd6 read value
    csrr x14, 0xd6

    #Unmapped address 0xc60 testing: random write/read operations
    #Address 0xc60 read value
    csrr x14, 0xc60

    #Address 0xc60 read value
    csrr x14, 0xc60

    #Address 0xc60 Write value 0x15223c2b
    li x3, 0x15223c2b
    csrw 0xc60, x3

    #Unmapped address 0xbd1 testing: random write/read operations
    #Address 0xbd1 Write value 0x87b553db
    li x3, 0x87b553db
    csrw 0xbd1, x3

    #Address 0xbd1 read value
    csrr x14, 0xbd1

    #Address 0xbd1 Write value 0x16ae0468
    li x3, 0x16ae0468
    csrw 0xbd1, x3

    #Address 0xbd1 read value
    csrr x14, 0xbd1

    #Unmapped address 0x353 testing: random write/read operations
    #Address 0x353 read value
    csrr x14, 0x353

    #Address 0x353 Write value 0x28276434
    li x3, 0x28276434
    csrw 0x353, x3

    #Unmapped address 0x237 testing: random write/read operations
    #Address 0x237 read value
    csrr x14, 0x237

    #Address 0x237 Write value 0xeceb4a74
    li x3, 0xeceb4a74
    csrw 0x237, x3

    #Mapped address 0xb11 (mhpmcounter17) testing: random write/read operations
    #Address 0xb11 Write value 0x8bda5cf2
    li x3, 0x8bda5cf2
    csrw 0xb11, x3

    #Address 0xb11 read value
    csrr x14, 0xb11

    #Unmapped address 0xda4 testing: random write/read operations
    #Address 0xda4 Write value 0xac2cc3e8
    li x3, 0xac2cc3e8
    csrw 0xda4, x3

    #Address 0xda4 Write value 0xce0bc686
    li x3, 0xce0bc686
    csrw 0xda4, x3

    #Address 0xda4 read value
    csrr x14, 0xda4

    #Unmapped address 0xbd9 testing: random write/read operations
    #Address 0xbd9 read value
    csrr x14, 0xbd9

    #Address 0xbd9 read value
    csrr x14, 0xbd9

    #Address 0xbd9 Write value 0xe85f2ee6
    li x3, 0xe85f2ee6
    csrw 0xbd9, x3

    #Address 0xbd9 read value
    csrr x14, 0xbd9

    #Unmapped address 0xff testing: random write/read operations
    #Address 0xff read value
    csrr x14, 0xff

    #Address 0xff read value
    csrr x14, 0xff

    #Address 0xff read value
    csrr x14, 0xff

    #Unmapped address 0xa6a testing: random write/read operations
    #Address 0xa6a Write value 0x545b5191
    li x3, 0x545b5191
    csrw 0xa6a, x3

    #Address 0xa6a read value
    csrr x14, 0xa6a

    #Address 0xa6a read value
    csrr x14, 0xa6a

    #Address 0xa6a read value
    csrr x14, 0xa6a

    #Unmapped address 0x416 testing: random write/read operations
    #Address 0x416 read value
    csrr x14, 0x416

    #Address 0x416 Write value 0xba2f88bb
    li x3, 0xba2f88bb
    csrw 0x416, x3

    #Address 0x416 read value
    csrr x14, 0x416

    #Unmapped address 0xadf testing: random write/read operations
    #Address 0xadf read value
    csrr x14, 0xadf

    #Address 0xadf Write value 0x8d04b2f4
    li x3, 0x8d04b2f4
    csrw 0xadf, x3

    #Address 0xadf read value
    csrr x14, 0xadf

    #Unmapped address 0x439 testing: random write/read operations
    #Address 0x439 Write value 0x342613c5
    li x3, 0x342613c5
    csrw 0x439, x3

    #Address 0x439 Write value 0xb03230d3
    li x3, 0xb03230d3
    csrw 0x439, x3

    #Address 0x439 Write value 0xeef48cae
    li x3, 0xeef48cae
    csrw 0x439, x3

    #Unmapped address 0x5 testing: random write/read operations
    #Address 0x5 read value
    csrr x14, 0x5

    #Unmapped address 0xdea testing: random write/read operations
    #Address 0xdea Write value 0x7f1c4380
    li x3, 0x7f1c4380
    csrw 0xdea, x3

    #Address 0xdea Write value 0x37fc5888
    li x3, 0x37fc5888
    csrw 0xdea, x3

    #Address 0xdea Write value 0x25cc5423
    li x3, 0x25cc5423
    csrw 0xdea, x3

    #Unmapped address 0x813 testing: random write/read operations
    #Address 0x813 read value
    csrr x14, 0x813

    #Address 0x813 Write value 0x8c389d6b
    li x3, 0x8c389d6b
    csrw 0x813, x3

    #Unmapped address 0xc75 testing: random write/read operations
    #Address 0xc75 read value
    csrr x14, 0xc75

    #Unmapped address 0xbdd testing: random write/read operations
    #Address 0xbdd read value
    csrr x14, 0xbdd

    #Address 0xbdd read value
    csrr x14, 0xbdd

    #Address 0xbdd Write value 0x330b5f45
    li x3, 0x330b5f45
    csrw 0xbdd, x3

    #Address 0xbdd read value
    csrr x14, 0xbdd

    #Unmapped address 0x2c0 testing: random write/read operations
    #Address 0x2c0 read value
    csrr x14, 0x2c0

    #Unmapped address 0xdb4 testing: random write/read operations
    #Address 0xdb4 read value
    csrr x14, 0xdb4

    #Address 0xdb4 read value
    csrr x14, 0xdb4

    #Address 0xdb4 read value
    csrr x14, 0xdb4

    #Address 0xdb4 Write value 0x8d134785
    li x3, 0x8d134785
    csrw 0xdb4, x3

    #Unmapped address 0x373 testing: random write/read operations
    #Address 0x373 read value
    csrr x14, 0x373

    #Unmapped address 0x81a testing: random write/read operations
    #Address 0x81a read value
    csrr x14, 0x81a

    #Address 0x81a read value
    csrr x14, 0x81a

    #Address 0x81a Write value 0xca07335d
    li x3, 0xca07335d
    csrw 0x81a, x3

    #Address 0x81a read value
    csrr x14, 0x81a

    #Unmapped address 0x993 testing: random write/read operations
    #Address 0x993 Write value 0x4ef9d517
    li x3, 0x4ef9d517
    csrw 0x993, x3

    #Address 0x993 read value
    csrr x14, 0x993

    #Address 0x993 read value
    csrr x14, 0x993

    #Address 0x993 read value
    csrr x14, 0x993

    #Unmapped address 0x8c3 testing: random write/read operations
    #Address 0x8c3 Write value 0xedeb06a6
    li x3, 0xedeb06a6
    csrw 0x8c3, x3

    #Address 0x8c3 Write value 0xfed4eb52
    li x3, 0xfed4eb52
    csrw 0x8c3, x3

    #Address 0x8c3 Write value 0xaa78653c
    li x3, 0xaa78653c
    csrw 0x8c3, x3

    #Address 0x8c3 Write value 0x91304423
    li x3, 0x91304423
    csrw 0x8c3, x3

    #Unmapped address 0x4f6 testing: random write/read operations
    #Address 0x4f6 Write value 0x1982d253
    li x3, 0x1982d253
    csrw 0x4f6, x3

    #Address 0x4f6 Write value 0x977f44a3
    li x3, 0x977f44a3
    csrw 0x4f6, x3

    #Address 0x4f6 read value
    csrr x14, 0x4f6

    #Unmapped address 0x2bc testing: random write/read operations
    #Address 0x2bc read value
    csrr x14, 0x2bc

    #Address 0x2bc read value
    csrr x14, 0x2bc

    #Mapped address 0x341 (mepc) testing: random write/read operations
    #Address 0x341 read value
    csrr x14, 0x341

    #Unmapped address 0xcd9 testing: random write/read operations
    #Address 0xcd9 Write value 0x4e56e83e
    li x3, 0x4e56e83e
    csrw 0xcd9, x3

    #Address 0xcd9 read value
    csrr x14, 0xcd9

    #Unmapped address 0x165 testing: random write/read operations
    #Address 0x165 read value
    csrr x14, 0x165

    #Address 0x165 read value
    csrr x14, 0x165

    #Address 0x165 Write value 0x59864cbc
    li x3, 0x59864cbc
    csrw 0x165, x3

    #Unmapped address 0xf6 testing: random write/read operations
    #Address 0xf6 read value
    csrr x14, 0xf6

    #Address 0xf6 Write value 0xd5cfec11
    li x3, 0xd5cfec11
    csrw 0xf6, x3

    #Address 0xf6 Write value 0x8612bf18
    li x3, 0x8612bf18
    csrw 0xf6, x3

    #Address 0xf6 read value
    csrr x14, 0xf6

    #Unmapped address 0x41e testing: random write/read operations
    #Address 0x41e Write value 0x848a3de2
    li x3, 0x848a3de2
    csrw 0x41e, x3

    #Address 0x41e Write value 0x4ac3f1cf
    li x3, 0x4ac3f1cf
    csrw 0x41e, x3

    #Address 0x41e read value
    csrr x14, 0x41e

    #Unmapped address 0x11d testing: random write/read operations
    #Address 0x11d Write value 0x27389258
    li x3, 0x27389258
    csrw 0x11d, x3

    #Address 0x11d Write value 0x791b556f
    li x3, 0x791b556f
    csrw 0x11d, x3

    #Address 0x11d Write value 0x9acfb40f
    li x3, 0x9acfb40f
    csrw 0x11d, x3

    #Address 0x11d Write value 0x159be74e
    li x3, 0x159be74e
    csrw 0x11d, x3

    #Address 0x11d Write value 0x6307536d
    li x3, 0x6307536d
    csrw 0x11d, x3

    #Unmapped address 0x60a testing: random write/read operations
    #Address 0x60a Write value 0x54383209
    li x3, 0x54383209
    csrw 0x60a, x3

    #Address 0x60a read value
    csrr x14, 0x60a

    #Address 0x60a Write value 0x23371fd
    li x3, 0x23371fd
    csrw 0x60a, x3

    #Address 0x60a Write value 0x2dc7e866
    li x3, 0x2dc7e866
    csrw 0x60a, x3

    #Address 0x60a read value
    csrr x14, 0x60a

    #Unmapped address 0x4cc testing: random write/read operations
    #Address 0x4cc read value
    csrr x14, 0x4cc

    #Address 0x4cc Write value 0xb6944d6d
    li x3, 0xb6944d6d
    csrw 0x4cc, x3

    #Address 0x4cc Write value 0xd921a64a
    li x3, 0xd921a64a
    csrw 0x4cc, x3

    #Unmapped address 0x3ae testing: random write/read operations
    #Address 0x3ae read value
    csrr x14, 0x3ae

    #Address 0x3ae Write value 0xf03627f2
    li x3, 0xf03627f2
    csrw 0x3ae, x3

    #Address 0x3ae read value
    csrr x14, 0x3ae

    #Address 0x3ae Write value 0x2e5974
    li x3, 0x2e5974
    csrw 0x3ae, x3

    #Address 0x3ae read value
    csrr x14, 0x3ae

    #Unmapped address 0x797 testing: random write/read operations
    #Address 0x797 read value
    csrr x14, 0x797

    #Address 0x797 Write value 0x787d9940
    li x3, 0x787d9940
    csrw 0x797, x3

    #Address 0x797 Write value 0xa19d7cdf
    li x3, 0xa19d7cdf
    csrw 0x797, x3

    #Unmapped address 0x244 testing: random write/read operations
    #Address 0x244 Write value 0xb3251fc0
    li x3, 0xb3251fc0
    csrw 0x244, x3

    #Address 0x244 Write value 0x4fa4d9b9
    li x3, 0x4fa4d9b9
    csrw 0x244, x3

    #Address 0x244 Write value 0xc7aeb59e
    li x3, 0xc7aeb59e
    csrw 0x244, x3

    #Address 0x244 read value
    csrr x14, 0x244

    #Address 0x244 Write value 0x9fe773b1
    li x3, 0x9fe773b1
    csrw 0x244, x3

    #Unmapped address 0x99b testing: random write/read operations
    #Address 0x99b Write value 0xbe057bd9
    li x3, 0xbe057bd9
    csrw 0x99b, x3

    #Address 0x99b read value
    csrr x14, 0x99b

    #Address 0x99b read value
    csrr x14, 0x99b

    #Address 0x99b Write value 0xa57a30a3
    li x3, 0xa57a30a3
    csrw 0x99b, x3

    #Unmapped address 0xdb5 testing: random write/read operations
    #Address 0xdb5 Write value 0x5d6f1eb4
    li x3, 0x5d6f1eb4
    csrw 0xdb5, x3

    #Address 0xdb5 Write value 0x1d4ea677
    li x3, 0x1d4ea677
    csrw 0xdb5, x3

    #Address 0xdb5 Write value 0x5d2d0230
    li x3, 0x5d2d0230
    csrw 0xdb5, x3

    #Address 0xdb5 Write value 0x19bc7e49
    li x3, 0x19bc7e49
    csrw 0xdb5, x3

    #Unmapped address 0x9b6 testing: random write/read operations
    #Address 0x9b6 Write value 0xfba7cd0f
    li x3, 0xfba7cd0f
    csrw 0x9b6, x3

    #Address 0x9b6 Write value 0xfe5374fe
    li x3, 0xfe5374fe
    csrw 0x9b6, x3

    #Address 0x9b6 read value
    csrr x14, 0x9b6

    #Address 0x9b6 Write value 0x48a8cf9b
    li x3, 0x48a8cf9b
    csrw 0x9b6, x3

    #Address 0x9b6 read value
    csrr x14, 0x9b6

    #Unmapped address 0x457 testing: random write/read operations
    #Address 0x457 read value
    csrr x14, 0x457

    #Address 0x457 Write value 0xa5f2b5d1
    li x3, 0xa5f2b5d1
    csrw 0x457, x3

    #Address 0x457 read value
    csrr x14, 0x457

    #Address 0x457 Write value 0x84428d2c
    li x3, 0x84428d2c
    csrw 0x457, x3

    #Unmapped address 0x702 testing: random write/read operations
    #Address 0x702 read value
    csrr x14, 0x702

    #Address 0x702 Write value 0x155e88f2
    li x3, 0x155e88f2
    csrw 0x702, x3

    #Address 0x702 read value
    csrr x14, 0x702

    #Address 0x702 read value
    csrr x14, 0x702

    #Address 0x702 read value
    csrr x14, 0x702

    #Unmapped address 0x45f testing: random write/read operations
    #Address 0x45f read value
    csrr x14, 0x45f

    #Address 0x45f Write value 0x164f87dd
    li x3, 0x164f87dd
    csrw 0x45f, x3

    #Address 0x45f Write value 0xa8784379
    li x3, 0xa8784379
    csrw 0x45f, x3

    #Address 0x45f read value
    csrr x14, 0x45f

    #Address 0x45f Write value 0xecdf8c8a
    li x3, 0xecdf8c8a
    csrw 0x45f, x3

    #Unmapped address 0xd4 testing: random write/read operations
    #Address 0xd4 read value
    csrr x14, 0xd4

    #Address 0xd4 read value
    csrr x14, 0xd4

    #Address 0xd4 read value
    csrr x14, 0xd4

    #Address 0xd4 Write value 0x63ede7dc
    li x3, 0x63ede7dc
    csrw 0xd4, x3

    #Address 0xd4 Write value 0xf626828c
    li x3, 0xf626828c
    csrw 0xd4, x3

    #Mapped address 0xb91 (mhpmcounterh17) testing: random write/read operations
    #Address 0xb91 read value
    csrr x14, 0xb91

    #Address 0xb91 Write value 0xe278314e
    li x3, 0xe278314e
    csrw 0xb91, x3

    #Address 0xb91 Write value 0xacbfb591
    li x3, 0xacbfb591
    csrw 0xb91, x3

    #Unmapped address 0x757 testing: random write/read operations
    #Address 0x757 read value
    csrr x14, 0x757

    #Address 0x757 read value
    csrr x14, 0x757

    #Address 0x757 Write value 0xf649948c
    li x3, 0xf649948c
    csrw 0x757, x3

    #Unmapped address 0xf3b testing: random write/read operations
    #Address 0xf3b read value
    csrr x14, 0xf3b

    #Address 0xf3b read value
    csrr x14, 0xf3b

    #Unmapped address 0xc8d testing: random write/read operations
    #Address 0xc8d Write value 0xbf354ca6
    li x3, 0xbf354ca6
    csrw 0xc8d, x3

    #Address 0xc8d Write value 0xf4ba08a9
    li x3, 0xf4ba08a9
    csrw 0xc8d, x3

    #Address 0xc8d Write value 0xdbabc3e8
    li x3, 0xdbabc3e8
    csrw 0xc8d, x3

    #Address 0xc8d read value
    csrr x14, 0xc8d

    #Unmapped address 0xa35 testing: random write/read operations
    #Address 0xa35 read value
    csrr x14, 0xa35

    #Address 0xa35 read value
    csrr x14, 0xa35

    #Unmapped address 0x441 testing: random write/read operations
    #Address 0x441 read value
    csrr x14, 0x441

    #Address 0x441 Write value 0xfe986b22
    li x3, 0xfe986b22
    csrw 0x441, x3

    #Unmapped address 0xc0 testing: random write/read operations
    #Address 0xc0 read value
    csrr x14, 0xc0

    #Address 0xc0 read value
    csrr x14, 0xc0

    #Address 0xc0 Write value 0x27f8d86c
    li x3, 0x27f8d86c
    csrw 0xc0, x3

    #Unmapped address 0x772 testing: random write/read operations
    #Address 0x772 read value
    csrr x14, 0x772

    #Unmapped address 0x994 testing: random write/read operations
    #Address 0x994 read value
    csrr x14, 0x994

    #Unmapped address 0x16a testing: random write/read operations
    #Address 0x16a Write value 0x8570751
    li x3, 0x8570751
    csrw 0x16a, x3

    #Unmapped address 0x40f testing: random write/read operations
    #Address 0x40f read value
    csrr x14, 0x40f

    #Address 0x40f Write value 0x7735d196
    li x3, 0x7735d196
    csrw 0x40f, x3

    #Address 0x40f Write value 0x79bcda69
    li x3, 0x79bcda69
    csrw 0x40f, x3

    #Unmapped address 0xed2 testing: random write/read operations
    #Address 0xed2 Write value 0x1db51820
    li x3, 0x1db51820
    csrw 0xed2, x3

    #Address 0xed2 Write value 0x90a20ae7
    li x3, 0x90a20ae7
    csrw 0xed2, x3

    #Address 0xed2 read value
    csrr x14, 0xed2

    #Unmapped address 0x571 testing: random write/read operations
    #Address 0x571 Write value 0x63e31d2b
    li x3, 0x63e31d2b
    csrw 0x571, x3

    #Address 0x571 read value
    csrr x14, 0x571

    #Address 0x571 read value
    csrr x14, 0x571

    #Address 0x571 Write value 0xa0660578
    li x3, 0xa0660578
    csrw 0x571, x3

    #Address 0x571 read value
    csrr x14, 0x571

    #Unmapped address 0xe26 testing: random write/read operations
    #Address 0xe26 Write value 0x1b935499
    li x3, 0x1b935499
    csrw 0xe26, x3

    #Unmapped address 0xd43 testing: random write/read operations
    #Address 0xd43 read value
    csrr x14, 0xd43

    #Unmapped address 0xacc testing: random write/read operations
    #Address 0xacc Write value 0x75de7f27
    li x3, 0x75de7f27
    csrw 0xacc, x3

    #Address 0xacc Write value 0x33d3de47
    li x3, 0x33d3de47
    csrw 0xacc, x3

    #Address 0xacc Write value 0xfaa17202
    li x3, 0xfaa17202
    csrw 0xacc, x3

    #Unmapped address 0x885 testing: random write/read operations
    #Address 0x885 Write value 0x38c5199
    li x3, 0x38c5199
    csrw 0x885, x3

    #Address 0x885 read value
    csrr x14, 0x885

    #Address 0x885 read value
    csrr x14, 0x885

    #Address 0x885 read value
    csrr x14, 0x885

    #Address 0x885 Write value 0x38944481
    li x3, 0x38944481
    csrw 0x885, x3

    #Unmapped address 0x7c4 testing: random write/read operations
    #Address 0x7c4 Write value 0xa109339d
    li x3, 0xa109339d
    csrw 0x7c4, x3

    #Address 0x7c4 read value
    csrr x14, 0x7c4

    #Address 0x7c4 read value
    csrr x14, 0x7c4

    #Address 0x7c4 read value
    csrr x14, 0x7c4

    #Address 0x7c4 read value
    csrr x14, 0x7c4

    #Unmapped address 0x8b2 testing: random write/read operations
    #Address 0x8b2 read value
    csrr x14, 0x8b2

    #Address 0x8b2 Write value 0x69915e3c
    li x3, 0x69915e3c
    csrw 0x8b2, x3

    #Address 0x8b2 read value
    csrr x14, 0x8b2

    #Unmapped address 0xd79 testing: random write/read operations
    #Address 0xd79 Write value 0x1ce0c6f5
    li x3, 0x1ce0c6f5
    csrw 0xd79, x3

    #Unmapped address 0x229 testing: random write/read operations
    #Address 0x229 read value
    csrr x14, 0x229

    #Unmapped address 0xd53 testing: random write/read operations
    #Address 0xd53 read value
    csrr x14, 0xd53

    #Unmapped address 0xf61 testing: random write/read operations
    #Address 0xf61 Write value 0xf219648a
    li x3, 0xf219648a
    csrw 0xf61, x3

    #Address 0xf61 read value
    csrr x14, 0xf61

    #Address 0xf61 read value
    csrr x14, 0xf61

    #Address 0xf61 read value
    csrr x14, 0xf61

    #Address 0xf61 read value
    csrr x14, 0xf61

    #Unmapped address 0x48b testing: random write/read operations
    #Address 0x48b read value
    csrr x14, 0x48b

    #Address 0x48b read value
    csrr x14, 0x48b

    #Address 0x48b Write value 0xbe133f26
    li x3, 0xbe133f26
    csrw 0x48b, x3

    #Address 0x48b read value
    csrr x14, 0x48b

    #Address 0x48b read value
    csrr x14, 0x48b

    #Unmapped address 0x6b3 testing: random write/read operations
    #Address 0x6b3 Write value 0x5678387
    li x3, 0x5678387
    csrw 0x6b3, x3

    #Address 0x6b3 read value
    csrr x14, 0x6b3

    #Address 0x6b3 read value
    csrr x14, 0x6b3

    #Unmapped address 0x8df testing: random write/read operations
    #Address 0x8df read value
    csrr x14, 0x8df

    #Address 0x8df Write value 0xea6a352f
    li x3, 0xea6a352f
    csrw 0x8df, x3

    #Address 0x8df Write value 0x1248ba46
    li x3, 0x1248ba46
    csrw 0x8df, x3

    #Unmapped address 0x94f testing: random write/read operations
    #Address 0x94f read value
    csrr x14, 0x94f

    #Unmapped address 0xeab testing: random write/read operations
    #Address 0xeab read value
    csrr x14, 0xeab

    #Address 0xeab Write value 0xe43b1bf0
    li x3, 0xe43b1bf0
    csrw 0xeab, x3

    #Mapped address 0xb10 (mhpmcounter16) testing: random write/read operations
    #Address 0xb10 Write value 0x995bd01e
    li x3, 0x995bd01e
    csrw 0xb10, x3

    #Address 0xb10 read value
    csrr x14, 0xb10

    #Unmapped address 0xe68 testing: random write/read operations
    #Address 0xe68 Write value 0xadccdda8
    li x3, 0xadccdda8
    csrw 0xe68, x3

    #Address 0xe68 Write value 0xddfbf1e3
    li x3, 0xddfbf1e3
    csrw 0xe68, x3

    #Unmapped address 0xbc0 testing: random write/read operations
    #Address 0xbc0 Write value 0xef67c50
    li x3, 0xef67c50
    csrw 0xbc0, x3

    #Address 0xbc0 Write value 0x19183440
    li x3, 0x19183440
    csrw 0xbc0, x3

    #Address 0xbc0 Write value 0x3a9dee82
    li x3, 0x3a9dee82
    csrw 0xbc0, x3

    #Address 0xbc0 read value
    csrr x14, 0xbc0

    #Unmapped address 0xfd3 testing: random write/read operations
    #Address 0xfd3 Write value 0x5e36d508
    li x3, 0x5e36d508
    csrw 0xfd3, x3

    #Address 0xfd3 read value
    csrr x14, 0xfd3

    #Address 0xfd3 Write value 0x68231e98
    li x3, 0x68231e98
    csrw 0xfd3, x3

    #Address 0xfd3 read value
    csrr x14, 0xfd3

    #Unmapped address 0x8e6 testing: random write/read operations
    #Address 0x8e6 Write value 0x6928be95
    li x3, 0x6928be95
    csrw 0x8e6, x3

    #Address 0x8e6 Write value 0x2a3ab509
    li x3, 0x2a3ab509
    csrw 0x8e6, x3

    #Unmapped address 0x807 testing: random write/read operations
    #Address 0x807 Write value 0xc4cec7ac
    li x3, 0xc4cec7ac
    csrw 0x807, x3

    #Address 0x807 Write value 0x6ed5873e
    li x3, 0x6ed5873e
    csrw 0x807, x3

    #Address 0x807 Write value 0x411d4756
    li x3, 0x411d4756
    csrw 0x807, x3

    #Address 0x807 read value
    csrr x14, 0x807

    #Address 0x807 Write value 0xecc1919d
    li x3, 0xecc1919d
    csrw 0x807, x3

    #Unmapped address 0x112 testing: random write/read operations
    #Address 0x112 Write value 0x941ecdc5
    li x3, 0x941ecdc5
    csrw 0x112, x3

    #Address 0x112 read value
    csrr x14, 0x112

    #Address 0x112 Write value 0x7e7fe7d
    li x3, 0x7e7fe7d
    csrw 0x112, x3

    #Address 0x112 read value
    csrr x14, 0x112

    #Address 0x112 read value
    csrr x14, 0x112

    #Unmapped address 0x88c testing: random write/read operations
    #Address 0x88c Write value 0xfcb6f77f
    li x3, 0xfcb6f77f
    csrw 0x88c, x3

    #Address 0x88c read value
    csrr x14, 0x88c

    #Unmapped address 0xd34 testing: random write/read operations
    #Address 0xd34 Write value 0x5ad9ccca
    li x3, 0x5ad9ccca
    csrw 0xd34, x3

    #Address 0xd34 Write value 0xb3dd4449
    li x3, 0xb3dd4449
    csrw 0xd34, x3

    #Address 0xd34 read value
    csrr x14, 0xd34

    #Address 0xd34 read value
    csrr x14, 0xd34

    #Address 0xd34 Write value 0x6a14deb
    li x3, 0x6a14deb
    csrw 0xd34, x3

    #Unmapped address 0xd5f testing: random write/read operations
    #Address 0xd5f Write value 0x73a3fddf
    li x3, 0x73a3fddf
    csrw 0xd5f, x3

    #Address 0xd5f Write value 0x9152f4ce
    li x3, 0x9152f4ce
    csrw 0xd5f, x3

    #Address 0xd5f read value
    csrr x14, 0xd5f

    #Address 0xd5f read value
    csrr x14, 0xd5f

    #Address 0xd5f Write value 0x98eb87d4
    li x3, 0x98eb87d4
    csrw 0xd5f, x3

    #Unmapped address 0xcfb testing: random write/read operations
    #Address 0xcfb read value
    csrr x14, 0xcfb

    #Address 0xcfb Write value 0xf4dbfc6e
    li x3, 0xf4dbfc6e
    csrw 0xcfb, x3

    #Unmapped address 0x44b testing: random write/read operations
    #Address 0x44b Write value 0xa26fc3fe
    li x3, 0xa26fc3fe
    csrw 0x44b, x3

    #Address 0x44b Write value 0xa173f5f1
    li x3, 0xa173f5f1
    csrw 0x44b, x3

    #Address 0x44b Write value 0x5ae5e148
    li x3, 0x5ae5e148
    csrw 0x44b, x3

    #Unmapped address 0x380 testing: random write/read operations
    #Address 0x380 Write value 0xde3e5fd5
    li x3, 0xde3e5fd5
    csrw 0x380, x3

    #Address 0x380 Write value 0x2ed834e7
    li x3, 0x2ed834e7
    csrw 0x380, x3

    #Mapped address 0xb98 (mhpmcounterh24) testing: random write/read operations
    #Address 0xb98 read value
    csrr x14, 0xb98

    #Address 0xb98 Write value 0x271510ad
    li x3, 0x271510ad
    csrw 0xb98, x3

    #Address 0xb98 Write value 0xcff7b6dc
    li x3, 0xcff7b6dc
    csrw 0xb98, x3

    #Unmapped address 0x514 testing: random write/read operations
    #Address 0x514 Write value 0x60dc3d5c
    li x3, 0x60dc3d5c
    csrw 0x514, x3

    #Unmapped address 0xa90 testing: random write/read operations
    #Address 0xa90 read value
    csrr x14, 0xa90

    #Address 0xa90 read value
    csrr x14, 0xa90

    #Address 0xa90 read value
    csrr x14, 0xa90

    #Unmapped address 0xbbe testing: random write/read operations
    #Address 0xbbe read value
    csrr x14, 0xbbe

    #Address 0xbbe Write value 0x228c265d
    li x3, 0x228c265d
    csrw 0xbbe, x3

    #Unmapped address 0x9e9 testing: random write/read operations
    #Address 0x9e9 Write value 0x666f67fb
    li x3, 0x666f67fb
    csrw 0x9e9, x3

    #Address 0x9e9 read value
    csrr x14, 0x9e9

    #Unmapped address 0x88a testing: random write/read operations
    #Address 0x88a read value
    csrr x14, 0x88a

    #Address 0x88a Write value 0x964749ac
    li x3, 0x964749ac
    csrw 0x88a, x3

    #Unmapped address 0x155 testing: random write/read operations
    #Address 0x155 Write value 0x4d293271
    li x3, 0x4d293271
    csrw 0x155, x3

    #Address 0x155 read value
    csrr x14, 0x155

    #Address 0x155 Write value 0x564f5c68
    li x3, 0x564f5c68
    csrw 0x155, x3

    #Unmapped address 0x537 testing: random write/read operations
    #Address 0x537 Write value 0xbc98ab40
    li x3, 0xbc98ab40
    csrw 0x537, x3

    #Address 0x537 Write value 0xa40ea6e7
    li x3, 0xa40ea6e7
    csrw 0x537, x3

    #Address 0x537 Write value 0xcd432a83
    li x3, 0xcd432a83
    csrw 0x537, x3

    #Unmapped address 0x97f testing: random write/read operations
    #Address 0x97f Write value 0x11ee2a56
    li x3, 0x11ee2a56
    csrw 0x97f, x3

    #Address 0x97f read value
    csrr x14, 0x97f

    #Address 0x97f read value
    csrr x14, 0x97f

    #Unmapped address 0x2c9 testing: random write/read operations
    #Address 0x2c9 Write value 0xccf0c674
    li x3, 0xccf0c674
    csrw 0x2c9, x3

    #Address 0x2c9 read value
    csrr x14, 0x2c9

    #Address 0x2c9 Write value 0x41417c66
    li x3, 0x41417c66
    csrw 0x2c9, x3

    #Address 0x2c9 Write value 0x536f3057
    li x3, 0x536f3057
    csrw 0x2c9, x3

    #Address 0x2c9 Write value 0x9a7b2a2a
    li x3, 0x9a7b2a2a
    csrw 0x2c9, x3

    #Unmapped address 0xf65 testing: random write/read operations
    #Address 0xf65 read value
    csrr x14, 0xf65

    #Address 0xf65 Write value 0xfe6fe164
    li x3, 0xfe6fe164
    csrw 0xf65, x3

    #Mapped address 0xc80 (cycleh) testing: random write/read operations
    #Address 0xc80 Write value 0x61711fd6
    li x3, 0x61711fd6
    csrw 0xc80, x3

    #Address 0xc80 Write value 0x3272c7b5
    li x3, 0x3272c7b5
    csrw 0xc80, x3

    #Address 0xc80 read value
    csrr x14, 0xc80

    #Address 0xc80 Write value 0xf6c79997
    li x3, 0xf6c79997
    csrw 0xc80, x3

    #Unmapped address 0xf48 testing: random write/read operations
    #Address 0xf48 read value
    csrr x14, 0xf48

    #Address 0xf48 Write value 0xa489fe7c
    li x3, 0xa489fe7c
    csrw 0xf48, x3

    #Address 0xf48 Write value 0x368b62ea
    li x3, 0x368b62ea
    csrw 0xf48, x3

    #Address 0xf48 Write value 0x9cc3c47d
    li x3, 0x9cc3c47d
    csrw 0xf48, x3

    #Address 0xf48 Write value 0x35144036
    li x3, 0x35144036
    csrw 0xf48, x3

    #Unmapped address 0x9f1 testing: random write/read operations
    #Address 0x9f1 read value
    csrr x14, 0x9f1

    #Address 0x9f1 Write value 0xc66cac5c
    li x3, 0xc66cac5c
    csrw 0x9f1, x3

    #Address 0x9f1 Write value 0xa6dc840f
    li x3, 0xa6dc840f
    csrw 0x9f1, x3

    #Unmapped address 0xf53 testing: random write/read operations
    #Address 0xf53 Write value 0xce4d7053
    li x3, 0xce4d7053
    csrw 0xf53, x3

    #Unmapped address 0x575 testing: random write/read operations
    #Address 0x575 read value
    csrr x14, 0x575

    #Address 0x575 read value
    csrr x14, 0x575

    #Address 0x575 Write value 0x5d9e12ea
    li x3, 0x5d9e12ea
    csrw 0x575, x3

    #Address 0x575 read value
    csrr x14, 0x575

    #Unmapped address 0xeb7 testing: random write/read operations
    #Address 0xeb7 Write value 0xb7fa14b6
    li x3, 0xb7fa14b6
    csrw 0xeb7, x3

    #Address 0xeb7 Write value 0xd102c006
    li x3, 0xd102c006
    csrw 0xeb7, x3

    #Address 0xeb7 Write value 0x8b2bc947
    li x3, 0x8b2bc947
    csrw 0xeb7, x3

    #Mapped address 0xb8a (mhpmcounterh10) testing: random write/read operations
    #Address 0xb8a read value
    csrr x14, 0xb8a

    #Address 0xb8a read value
    csrr x14, 0xb8a

    #Address 0xb8a Write value 0x36e54d55
    li x3, 0x36e54d55
    csrw 0xb8a, x3

    #Address 0xb8a read value
    csrr x14, 0xb8a

    #Address 0xb8a read value
    csrr x14, 0xb8a

    #Unmapped address 0x246 testing: random write/read operations
    #Address 0x246 Write value 0xddfe7244
    li x3, 0xddfe7244
    csrw 0x246, x3

    #Address 0x246 read value
    csrr x14, 0x246

    #Address 0x246 Write value 0x5381a676
    li x3, 0x5381a676
    csrw 0x246, x3

    #Address 0x246 Write value 0xa326b878
    li x3, 0xa326b878
    csrw 0x246, x3

    #Unmapped address 0x269 testing: random write/read operations
    #Address 0x269 read value
    csrr x14, 0x269

    #Address 0x269 read value
    csrr x14, 0x269

    #Unmapped address 0x7bb testing: random write/read operations
    #Address 0x7bb read value
    csrr x14, 0x7bb

    #Address 0x7bb read value
    csrr x14, 0x7bb

    #Address 0x7bb read value
    csrr x14, 0x7bb

    #Address 0x7bb read value
    csrr x14, 0x7bb

    #Address 0x7bb read value
    csrr x14, 0x7bb

    #Unmapped address 0xba7 testing: random write/read operations
    #Address 0xba7 Write value 0x3b26e587
    li x3, 0x3b26e587
    csrw 0xba7, x3

    #Address 0xba7 Write value 0x8fda009e
    li x3, 0x8fda009e
    csrw 0xba7, x3

    #Address 0xba7 read value
    csrr x14, 0xba7

    #Address 0xba7 Write value 0x98080d8
    li x3, 0x98080d8
    csrw 0xba7, x3

    #Address 0xba7 Write value 0xa89fdd5e
    li x3, 0xa89fdd5e
    csrw 0xba7, x3

    #Unmapped address 0xca9 testing: random write/read operations
    #Address 0xca9 read value
    csrr x14, 0xca9

    #Address 0xca9 Write value 0xa802d22b
    li x3, 0xa802d22b
    csrw 0xca9, x3

    #Unmapped address 0x36e testing: random write/read operations
    #Address 0x36e Write value 0xafd94ef4
    li x3, 0xafd94ef4
    csrw 0x36e, x3

    #Address 0x36e read value
    csrr x14, 0x36e

    #Address 0x36e Write value 0x9e76d7c6
    li x3, 0x9e76d7c6
    csrw 0x36e, x3

    #Address 0x36e read value
    csrr x14, 0x36e

    #Address 0x36e read value
    csrr x14, 0x36e

    #Unmapped address 0xcb0 testing: random write/read operations
    #Address 0xcb0 read value
    csrr x14, 0xcb0

    #Address 0xcb0 Write value 0x64c03828
    li x3, 0x64c03828
    csrw 0xcb0, x3

    #Address 0xcb0 read value
    csrr x14, 0xcb0

    #Address 0xcb0 read value
    csrr x14, 0xcb0

    #Address 0xcb0 read value
    csrr x14, 0xcb0

    #Unmapped address 0xe65 testing: random write/read operations
    #Address 0xe65 read value
    csrr x14, 0xe65

    #Unmapped address 0x5cf testing: random write/read operations
    #Address 0x5cf Write value 0x3a77f448
    li x3, 0x3a77f448
    csrw 0x5cf, x3

    #Address 0x5cf Write value 0x3e0e9ee9
    li x3, 0x3e0e9ee9
    csrw 0x5cf, x3

    #Mapped address 0x332 (mhpmevent18) testing: random write/read operations
    #Address 0x332 read value
    csrr x14, 0x332

    #Address 0x332 read value
    csrr x14, 0x332

    #Address 0x332 read value
    csrr x14, 0x332

    #Unmapped address 0xdd5 testing: random write/read operations
    #Address 0xdd5 Write value 0x86ecc4ed
    li x3, 0x86ecc4ed
    csrw 0xdd5, x3

    #Address 0xdd5 read value
    csrr x14, 0xdd5

    #Address 0xdd5 read value
    csrr x14, 0xdd5

    #Address 0xdd5 Write value 0x14401d7d
    li x3, 0x14401d7d
    csrw 0xdd5, x3

    #Address 0xdd5 Write value 0xef18a9a4
    li x3, 0xef18a9a4
    csrw 0xdd5, x3

    #Unmapped address 0xeec testing: random write/read operations
    #Address 0xeec read value
    csrr x14, 0xeec

    #Address 0xeec read value
    csrr x14, 0xeec

    #Unmapped address 0x3e7 testing: random write/read operations
    #Address 0x3e7 Write value 0x9340d854
    li x3, 0x9340d854
    csrw 0x3e7, x3

    #Address 0x3e7 Write value 0xb0a44ffd
    li x3, 0xb0a44ffd
    csrw 0x3e7, x3

    #Unmapped address 0x4b9 testing: random write/read operations
    #Address 0x4b9 Write value 0x10f8c757
    li x3, 0x10f8c757
    csrw 0x4b9, x3

    #Address 0x4b9 Write value 0xb682182b
    li x3, 0xb682182b
    csrw 0x4b9, x3

    #Address 0x4b9 Write value 0x46fa2512
    li x3, 0x46fa2512
    csrw 0x4b9, x3

    #Address 0x4b9 Write value 0x16a5f5bf
    li x3, 0x16a5f5bf
    csrw 0x4b9, x3

    #Unmapped address 0xc6c testing: random write/read operations
    #Address 0xc6c Write value 0x92046578
    li x3, 0x92046578
    csrw 0xc6c, x3

    #Address 0xc6c Write value 0x9a4634db
    li x3, 0x9a4634db
    csrw 0xc6c, x3

    #Address 0xc6c read value
    csrr x14, 0xc6c

    #Unmapped address 0xac3 testing: random write/read operations
    #Address 0xac3 Write value 0x95c867f
    li x3, 0x95c867f
    csrw 0xac3, x3

    #Unmapped address 0xe1b testing: random write/read operations
    #Address 0xe1b read value
    csrr x14, 0xe1b

    #Address 0xe1b read value
    csrr x14, 0xe1b

    #Address 0xe1b read value
    csrr x14, 0xe1b

    #Address 0xe1b Write value 0x92d1478e
    li x3, 0x92d1478e
    csrw 0xe1b, x3

    #Unmapped address 0x7b2 testing: random write/read operations
    #Address 0x7b2 read value
    csrr x14, 0x7b2

    #Address 0x7b2 Write value 0xb0e912e1
    li x3, 0xb0e912e1
    csrw 0x7b2, x3

    #Address 0x7b2 read value
    csrr x14, 0x7b2

    #Address 0x7b2 read value
    csrr x14, 0x7b2

    #Address 0x7b2 Write value 0x87f2e42e
    li x3, 0x87f2e42e
    csrw 0x7b2, x3

    #Unmapped address 0x69 testing: random write/read operations
    #Address 0x69 read value
    csrr x14, 0x69

    #Address 0x69 Write value 0x2256c75
    li x3, 0x2256c75
    csrw 0x69, x3

    #Address 0x69 read value
    csrr x14, 0x69

    #Address 0x69 read value
    csrr x14, 0x69

    #Unmapped address 0x497 testing: random write/read operations
    #Address 0x497 read value
    csrr x14, 0x497

    #Address 0x497 Write value 0x1db95c0a
    li x3, 0x1db95c0a
    csrw 0x497, x3

    #Unmapped address 0xb2 testing: random write/read operations
    #Address 0xb2 Write value 0x71ec524f
    li x3, 0x71ec524f
    csrw 0xb2, x3

    #Address 0xb2 Write value 0x9be98c9c
    li x3, 0x9be98c9c
    csrw 0xb2, x3

    #Unmapped address 0xee9 testing: random write/read operations
    #Address 0xee9 Write value 0x28002299
    li x3, 0x28002299
    csrw 0xee9, x3

    #Address 0xee9 read value
    csrr x14, 0xee9

    #Address 0xee9 read value
    csrr x14, 0xee9

    #Address 0xee9 Write value 0xfc225a8d
    li x3, 0xfc225a8d
    csrw 0xee9, x3

    #Unmapped address 0x500 testing: random write/read operations
    #Address 0x500 Write value 0xa077b529
    li x3, 0xa077b529
    csrw 0x500, x3

    #Address 0x500 read value
    csrr x14, 0x500

    #Address 0x500 read value
    csrr x14, 0x500

    #Address 0x500 read value
    csrr x14, 0x500

    #Unmapped address 0xda7 testing: random write/read operations
    #Address 0xda7 Write value 0xab6cd238
    li x3, 0xab6cd238
    csrw 0xda7, x3

    #Unmapped address 0xfcd testing: random write/read operations
    #Address 0xfcd read value
    csrr x14, 0xfcd

    #Address 0xfcd Write value 0xe4f759dd
    li x3, 0xe4f759dd
    csrw 0xfcd, x3

    #Mapped address 0x327 (mhpmevent7) testing: random write/read operations
    #Address 0x327 Write value 0xab3ba65
    li x3, 0xab3ba65
    csrw 0x327, x3

    #Address 0x327 Write value 0x3876a418
    li x3, 0x3876a418
    csrw 0x327, x3

    #Address 0x327 Write value 0x3403a7e8
    li x3, 0x3403a7e8
    csrw 0x327, x3

    #Unmapped address 0xa09 testing: random write/read operations
    #Address 0xa09 Write value 0xd1a62fb1
    li x3, 0xd1a62fb1
    csrw 0xa09, x3

    #Unmapped address 0x93b testing: random write/read operations
    #Address 0x93b Write value 0x6f71c471
    li x3, 0x6f71c471
    csrw 0x93b, x3

    #Unmapped address 0xd1a testing: random write/read operations
    #Address 0xd1a Write value 0xd4d067be
    li x3, 0xd4d067be
    csrw 0xd1a, x3

    #Address 0xd1a read value
    csrr x14, 0xd1a

    #Address 0xd1a read value
    csrr x14, 0xd1a

    #Address 0xd1a Write value 0x45f5111a
    li x3, 0x45f5111a
    csrw 0xd1a, x3

    #Unmapped address 0xa40 testing: random write/read operations
    #Address 0xa40 Write value 0x258d2770
    li x3, 0x258d2770
    csrw 0xa40, x3

    #Address 0xa40 read value
    csrr x14, 0xa40

    #Address 0xa40 read value
    csrr x14, 0xa40

    #Address 0xa40 read value
    csrr x14, 0xa40

    #Mapped address 0x324 (mhpmevent4) testing: random write/read operations
    #Address 0x324 Write value 0x73f52e2a
    li x3, 0x73f52e2a
    csrw 0x324, x3

    #Address 0x324 read value
    csrr x14, 0x324

    #Address 0x324 Write value 0x8ae6378e
    li x3, 0x8ae6378e
    csrw 0x324, x3

    #Address 0x324 Write value 0xb0ee3c69
    li x3, 0xb0ee3c69
    csrw 0x324, x3

    #Address 0x324 Write value 0x3a86e92
    li x3, 0x3a86e92
    csrw 0x324, x3

    #Unmapped address 0xd4b testing: random write/read operations
    #Address 0xd4b read value
    csrr x14, 0xd4b

    #Address 0xd4b Write value 0x35fda672
    li x3, 0x35fda672
    csrw 0xd4b, x3

    #Address 0xd4b Write value 0x55f255fa
    li x3, 0x55f255fa
    csrw 0xd4b, x3

    #Address 0xd4b read value
    csrr x14, 0xd4b

    #Unmapped address 0x58e testing: random write/read operations
    #Address 0x58e read value
    csrr x14, 0x58e

    #Address 0x58e Write value 0xc66e87ba
    li x3, 0xc66e87ba
    csrw 0x58e, x3

    #Unmapped address 0xe78 testing: random write/read operations
    #Address 0xe78 Write value 0xdb255e1c
    li x3, 0xdb255e1c
    csrw 0xe78, x3

    #Address 0xe78 read value
    csrr x14, 0xe78

    #Address 0xe78 Write value 0x69937872
    li x3, 0x69937872
    csrw 0xe78, x3

    #Unmapped address 0x29b testing: random write/read operations
    #Address 0x29b Write value 0x7d043071
    li x3, 0x7d043071
    csrw 0x29b, x3

    #Address 0x29b Write value 0x8b1a7b67
    li x3, 0x8b1a7b67
    csrw 0x29b, x3

    #Address 0x29b read value
    csrr x14, 0x29b

    #Address 0x29b Write value 0x48344dc3
    li x3, 0x48344dc3
    csrw 0x29b, x3

    #Unmapped address 0xee7 testing: random write/read operations
    #Address 0xee7 Write value 0xd5635c91
    li x3, 0xd5635c91
    csrw 0xee7, x3

    #Unmapped address 0x6d0 testing: random write/read operations
    #Address 0x6d0 Write value 0xe34f646f
    li x3, 0xe34f646f
    csrw 0x6d0, x3

    #Address 0x6d0 Write value 0xd21b1e5
    li x3, 0xd21b1e5
    csrw 0x6d0, x3

    #Address 0x6d0 Write value 0x46b56546
    li x3, 0x46b56546
    csrw 0x6d0, x3

    #Unmapped address 0x6ae testing: random write/read operations
    #Address 0x6ae read value
    csrr x14, 0x6ae

    #Unmapped address 0x692 testing: random write/read operations
    #Address 0x692 Write value 0x589f0aa6
    li x3, 0x589f0aa6
    csrw 0x692, x3

    #Address 0x692 Write value 0x56b7767b
    li x3, 0x56b7767b
    csrw 0x692, x3

    #Address 0x692 read value
    csrr x14, 0x692

    #Address 0x692 Write value 0x851e7b1d
    li x3, 0x851e7b1d
    csrw 0x692, x3

    #Unmapped address 0x15f testing: random write/read operations
    #Address 0x15f read value
    csrr x14, 0x15f

    #Address 0x15f Write value 0x5e077d63
    li x3, 0x5e077d63
    csrw 0x15f, x3

    #Address 0x15f read value
    csrr x14, 0x15f

    #Address 0x15f read value
    csrr x14, 0x15f

    #Unmapped address 0xbca testing: random write/read operations
    #Address 0xbca Write value 0x2c9fb276
    li x3, 0x2c9fb276
    csrw 0xbca, x3

    #Unmapped address 0x11a testing: random write/read operations
    #Address 0x11a Write value 0x71194fe6
    li x3, 0x71194fe6
    csrw 0x11a, x3

    #Address 0x11a Write value 0x2dcd7ec2
    li x3, 0x2dcd7ec2
    csrw 0x11a, x3

    #Address 0x11a Write value 0x76275a3
    li x3, 0x76275a3
    csrw 0x11a, x3

    #Address 0x11a Write value 0x9b56cb8c
    li x3, 0x9b56cb8c
    csrw 0x11a, x3

    #Address 0x11a Write value 0x7c6e68e9
    li x3, 0x7c6e68e9
    csrw 0x11a, x3

    #Unmapped address 0x39d testing: random write/read operations
    #Address 0x39d read value
    csrr x14, 0x39d

    #Address 0x39d Write value 0x4addfd5c
    li x3, 0x4addfd5c
    csrw 0x39d, x3

    #Address 0x39d Write value 0x8bb7dfcc
    li x3, 0x8bb7dfcc
    csrw 0x39d, x3

    #Address 0x39d Write value 0x77b4f552
    li x3, 0x77b4f552
    csrw 0x39d, x3

    #Address 0x39d Write value 0x44907260
    li x3, 0x44907260
    csrw 0x39d, x3

    #Unmapped address 0x850 testing: random write/read operations
    #Address 0x850 read value
    csrr x14, 0x850

    #Address 0x850 read value
    csrr x14, 0x850

    #Unmapped address 0x35 testing: random write/read operations
    #Address 0x35 Write value 0x4611ed5d
    li x3, 0x4611ed5d
    csrw 0x35, x3

    #Unmapped address 0xf51 testing: random write/read operations
    #Address 0xf51 Write value 0xcd61fd91
    li x3, 0xcd61fd91
    csrw 0xf51, x3

    #Address 0xf51 Write value 0xf3f969c6
    li x3, 0xf3f969c6
    csrw 0xf51, x3

    #Address 0xf51 Write value 0xcf4a5f5d
    li x3, 0xcf4a5f5d
    csrw 0xf51, x3

    #Address 0xf51 Write value 0xa18bae62
    li x3, 0xa18bae62
    csrw 0xf51, x3

    #Unmapped address 0xf20 testing: random write/read operations
    #Address 0xf20 read value
    csrr x14, 0xf20

    #Address 0xf20 read value
    csrr x14, 0xf20

    #Address 0xf20 Write value 0x5252ff04
    li x3, 0x5252ff04
    csrw 0xf20, x3

    #Address 0xf20 read value
    csrr x14, 0xf20

    #Unmapped address 0x733 testing: random write/read operations
    #Address 0x733 read value
    csrr x14, 0x733

    #Unmapped address 0xc39 testing: random write/read operations
    #Address 0xc39 Write value 0x3ec46bd2
    li x3, 0x3ec46bd2
    csrw 0xc39, x3

    #Address 0xc39 Write value 0xc073b169
    li x3, 0xc073b169
    csrw 0xc39, x3

    #Address 0xc39 Write value 0x8997cdd5
    li x3, 0x8997cdd5
    csrw 0xc39, x3

    #Address 0xc39 read value
    csrr x14, 0xc39

    #Unmapped address 0x9ac testing: random write/read operations
    #Address 0x9ac Write value 0xb225a474
    li x3, 0xb225a474
    csrw 0x9ac, x3

    #Address 0x9ac read value
    csrr x14, 0x9ac

    #Address 0x9ac Write value 0xdfa5c115
    li x3, 0xdfa5c115
    csrw 0x9ac, x3

    #Address 0x9ac read value
    csrr x14, 0x9ac

    #Address 0x9ac Write value 0x299a1d64
    li x3, 0x299a1d64
    csrw 0x9ac, x3

    #Unmapped address 0xd51 testing: random write/read operations
    #Address 0xd51 Write value 0xf4515eee
    li x3, 0xf4515eee
    csrw 0xd51, x3

    #Address 0xd51 Write value 0x6681a49
    li x3, 0x6681a49
    csrw 0xd51, x3

    #Unmapped address 0x211 testing: random write/read operations
    #Address 0x211 Write value 0x9266cadb
    li x3, 0x9266cadb
    csrw 0x211, x3

    #Unmapped address 0x3f testing: random write/read operations
    #Address 0x3f read value
    csrr x14, 0x3f

    #Address 0x3f read value
    csrr x14, 0x3f

    #Address 0x3f Write value 0xb27bd9e3
    li x3, 0xb27bd9e3
    csrw 0x3f, x3

    #Unmapped address 0xb49 testing: random write/read operations
    #Address 0xb49 Write value 0xbefaa63c
    li x3, 0xbefaa63c
    csrw 0xb49, x3

    #Address 0xb49 Write value 0x328c72a1
    li x3, 0x328c72a1
    csrw 0xb49, x3

    #Address 0xb49 read value
    csrr x14, 0xb49

    #Unmapped address 0x6ba testing: random write/read operations
    #Address 0x6ba Write value 0xafef34e0
    li x3, 0xafef34e0
    csrw 0x6ba, x3

    #Address 0x6ba read value
    csrr x14, 0x6ba

    #Address 0x6ba Write value 0xd47086a8
    li x3, 0xd47086a8
    csrw 0x6ba, x3

    #Unmapped address 0x70 testing: random write/read operations
    #Address 0x70 Write value 0x12029962
    li x3, 0x12029962
    csrw 0x70, x3

    #Unmapped address 0xb0 testing: random write/read operations
    #Address 0xb0 read value
    csrr x14, 0xb0

    #Unmapped address 0xe3a testing: random write/read operations
    #Address 0xe3a read value
    csrr x14, 0xe3a

    #Address 0xe3a read value
    csrr x14, 0xe3a

    #Address 0xe3a read value
    csrr x14, 0xe3a

    #Unmapped address 0xfe3 testing: random write/read operations
    #Address 0xfe3 Write value 0x102ec020
    li x3, 0x102ec020
    csrw 0xfe3, x3

    #Address 0xfe3 Write value 0xcc1a4c5c
    li x3, 0xcc1a4c5c
    csrw 0xfe3, x3

    #Address 0xfe3 read value
    csrr x14, 0xfe3

    #Unmapped address 0x101 testing: random write/read operations
    #Address 0x101 read value
    csrr x14, 0x101

    #Address 0x101 Write value 0x12584443
    li x3, 0x12584443
    csrw 0x101, x3

    #Address 0x101 read value
    csrr x14, 0x101

    #Unmapped address 0x770 testing: random write/read operations
    #Address 0x770 read value
    csrr x14, 0x770

    #Address 0x770 read value
    csrr x14, 0x770

    #Address 0x770 Write value 0xaaed4f8e
    li x3, 0xaaed4f8e
    csrw 0x770, x3

    #Address 0x770 Write value 0x370ee9a9
    li x3, 0x370ee9a9
    csrw 0x770, x3

    #Address 0x770 Write value 0xde9f54ea
    li x3, 0xde9f54ea
    csrw 0x770, x3

    #Unmapped address 0xf77 testing: random write/read operations
    #Address 0xf77 read value
    csrr x14, 0xf77

    #Address 0xf77 Write value 0xc6dfc436
    li x3, 0xc6dfc436
    csrw 0xf77, x3

    #Unmapped address 0xeb2 testing: random write/read operations
    #Address 0xeb2 Write value 0x1620c2fb
    li x3, 0x1620c2fb
    csrw 0xeb2, x3

    #Address 0xeb2 Write value 0xe796bd60
    li x3, 0xe796bd60
    csrw 0xeb2, x3

    #Unmapped address 0xdf4 testing: random write/read operations
    #Address 0xdf4 read value
    csrr x14, 0xdf4

    #Address 0xdf4 read value
    csrr x14, 0xdf4

    #Unmapped address 0x9ad testing: random write/read operations
    #Address 0x9ad read value
    csrr x14, 0x9ad

    #Unmapped address 0xe19 testing: random write/read operations
    #Address 0xe19 Write value 0x942194fa
    li x3, 0x942194fa
    csrw 0xe19, x3

    #Unmapped address 0x89c testing: random write/read operations
    #Address 0x89c read value
    csrr x14, 0x89c

    #Address 0x89c read value
    csrr x14, 0x89c

    #Unmapped address 0x29d testing: random write/read operations
    #Address 0x29d Write value 0x841f4658
    li x3, 0x841f4658
    csrw 0x29d, x3

    #Address 0x29d Write value 0x8c18bf97
    li x3, 0x8c18bf97
    csrw 0x29d, x3

    #Address 0x29d Write value 0x3c6caa2
    li x3, 0x3c6caa2
    csrw 0x29d, x3

    #Unmapped address 0xc58 testing: random write/read operations
    #Address 0xc58 read value
    csrr x14, 0xc58

    #Address 0xc58 read value
    csrr x14, 0xc58

    #Address 0xc58 read value
    csrr x14, 0xc58

    #Address 0xc58 read value
    csrr x14, 0xc58

    #Address 0xc58 Write value 0x4771a88a
    li x3, 0x4771a88a
    csrw 0xc58, x3

    #Unmapped address 0x79d testing: random write/read operations
    #Address 0x79d read value
    csrr x14, 0x79d

    #Address 0x79d read value
    csrr x14, 0x79d

    #Address 0x79d read value
    csrr x14, 0x79d

    #Mapped address 0x340 (mscratch) testing: random write/read operations
    #Address 0x340 Write value 0xbf9e0ffb
    li x3, 0xbf9e0ffb
    csrw 0x340, x3

    #Address 0x340 read value
    csrr x14, 0x340

    #Address 0x340 read value
    csrr x14, 0x340

    #Address 0x340 read value
    csrr x14, 0x340

    #Unmapped address 0x482 testing: random write/read operations
    #Address 0x482 read value
    csrr x14, 0x482

    #Address 0x482 Write value 0x1de5c552
    li x3, 0x1de5c552
    csrw 0x482, x3

    #Address 0x482 Write value 0xacef7c9c
    li x3, 0xacef7c9c
    csrw 0x482, x3

    #Unmapped address 0x763 testing: random write/read operations
    #Address 0x763 read value
    csrr x14, 0x763

    #Address 0x763 Write value 0x81f86b98
    li x3, 0x81f86b98
    csrw 0x763, x3

    #Address 0x763 Write value 0x42235e06
    li x3, 0x42235e06
    csrw 0x763, x3

    #Address 0x763 Write value 0xe384eaf3
    li x3, 0xe384eaf3
    csrw 0x763, x3

    #Unmapped address 0xcfa testing: random write/read operations
    #Address 0xcfa read value
    csrr x14, 0xcfa

    #Address 0xcfa Write value 0x4b3a5441
    li x3, 0x4b3a5441
    csrw 0xcfa, x3

    #Address 0xcfa read value
    csrr x14, 0xcfa

    #Address 0xcfa read value
    csrr x14, 0xcfa

    #Unmapped address 0xd64 testing: random write/read operations
    #Address 0xd64 Write value 0xf78d3da9
    li x3, 0xf78d3da9
    csrw 0xd64, x3

    #Mapped address 0x330 (mhpmevent16) testing: random write/read operations
    #Address 0x330 Write value 0x4bbf2ba1
    li x3, 0x4bbf2ba1
    csrw 0x330, x3

    #Address 0x330 Write value 0x4251440f
    li x3, 0x4251440f
    csrw 0x330, x3

    #Mapped address 0x3b9 (pmpaddr9) testing: random write/read operations
    #Address 0x3b9 read value
    csrr x14, 0x3b9

    #Address 0x3b9 Write value 0x2218d931
    li x3, 0x2218d931
    csrw 0x3b9, x3

    #Address 0x3b9 read value
    csrr x14, 0x3b9

    #Unmapped address 0xca6 testing: random write/read operations
    #Address 0xca6 Write value 0xd2445bef
    li x3, 0xd2445bef
    csrw 0xca6, x3

    #Unmapped address 0xb25 testing: random write/read operations
    #Address 0xb25 read value
    csrr x14, 0xb25

    #Address 0xb25 Write value 0xa38def3a
    li x3, 0xa38def3a
    csrw 0xb25, x3

    #Address 0xb25 read value
    csrr x14, 0xb25

    #Unmapped address 0xc4c testing: random write/read operations
    #Address 0xc4c Write value 0x4dd91cae
    li x3, 0x4dd91cae
    csrw 0xc4c, x3

    #Address 0xc4c read value
    csrr x14, 0xc4c

    #Address 0xc4c read value
    csrr x14, 0xc4c

    #Address 0xc4c read value
    csrr x14, 0xc4c

    #Address 0xc4c Write value 0xd9ffebef
    li x3, 0xd9ffebef
    csrw 0xc4c, x3

    #Unmapped address 0xcd5 testing: random write/read operations
    #Address 0xcd5 read value
    csrr x14, 0xcd5

    #Address 0xcd5 read value
    csrr x14, 0xcd5

    #Unmapped address 0x2a testing: random write/read operations
    #Address 0x2a Write value 0x50261ec5
    li x3, 0x50261ec5
    csrw 0x2a, x3

    #Unmapped address 0xfc0 testing: random write/read operations
    #Address 0xfc0 read value
    csrr x14, 0xfc0

    #Address 0xfc0 read value
    csrr x14, 0xfc0

    #Address 0xfc0 read value
    csrr x14, 0xfc0

    #Address 0xfc0 read value
    csrr x14, 0xfc0

    #Unmapped address 0xfa5 testing: random write/read operations
    #Address 0xfa5 Write value 0xbb648d6a
    li x3, 0xbb648d6a
    csrw 0xfa5, x3

    #Address 0xfa5 Write value 0xe78d2ca3
    li x3, 0xe78d2ca3
    csrw 0xfa5, x3

    #Address 0xfa5 Write value 0x5fef40ae
    li x3, 0x5fef40ae
    csrw 0xfa5, x3

    #Unmapped address 0xe9c testing: random write/read operations
    #Address 0xe9c read value
    csrr x14, 0xe9c

    #Address 0xe9c Write value 0x564077a0
    li x3, 0x564077a0
    csrw 0xe9c, x3

    #Address 0xe9c Write value 0xc6282773
    li x3, 0xc6282773
    csrw 0xe9c, x3

    #Address 0xe9c read value
    csrr x14, 0xe9c

    #Address 0xe9c read value
    csrr x14, 0xe9c

    #Unmapped address 0x768 testing: random write/read operations
    #Address 0x768 read value
    csrr x14, 0x768

    #Address 0x768 read value
    csrr x14, 0x768

    #Unmapped address 0xecf testing: random write/read operations
    #Address 0xecf Write value 0x7c64908d
    li x3, 0x7c64908d
    csrw 0xecf, x3

    #Address 0xecf Write value 0xcbe516a2
    li x3, 0xcbe516a2
    csrw 0xecf, x3

    #Address 0xecf read value
    csrr x14, 0xecf

    #Address 0xecf Write value 0x8cb95e84
    li x3, 0x8cb95e84
    csrw 0xecf, x3

    #Address 0xecf read value
    csrr x14, 0xecf

    #Unmapped address 0x7b4 testing: random write/read operations
    #Address 0x7b4 read value
    csrr x14, 0x7b4

    #Address 0x7b4 Write value 0xd7fd966a
    li x3, 0xd7fd966a
    csrw 0x7b4, x3

    #Unmapped address 0x403 testing: random write/read operations
    #Address 0x403 read value
    csrr x14, 0x403

    #Address 0x403 Write value 0x886d6353
    li x3, 0x886d6353
    csrw 0x403, x3

    #Address 0x403 read value
    csrr x14, 0x403

    #Address 0x403 Write value 0x1b205052
    li x3, 0x1b205052
    csrw 0x403, x3

    #Unmapped address 0xede testing: random write/read operations
    #Address 0xede read value
    csrr x14, 0xede

    #Address 0xede Write value 0xa7df20ea
    li x3, 0xa7df20ea
    csrw 0xede, x3

    #Address 0xede Write value 0xf9f375a0
    li x3, 0xf9f375a0
    csrw 0xede, x3

    #Address 0xede Write value 0xda45be09
    li x3, 0xda45be09
    csrw 0xede, x3

    #Unmapped address 0x7c8 testing: random write/read operations
    #Address 0x7c8 read value
    csrr x14, 0x7c8

    #Address 0x7c8 read value
    csrr x14, 0x7c8

    #Address 0x7c8 read value
    csrr x14, 0x7c8

    #Unmapped address 0xd93 testing: random write/read operations
    #Address 0xd93 Write value 0xd5966f7f
    li x3, 0xd5966f7f
    csrw 0xd93, x3

    #Address 0xd93 read value
    csrr x14, 0xd93

    #Address 0xd93 read value
    csrr x14, 0xd93

    #Address 0xd93 read value
    csrr x14, 0xd93

    #Address 0xd93 read value
    csrr x14, 0xd93

    #Unmapped address 0x4e3 testing: random write/read operations
    #Address 0x4e3 Write value 0x20387c52
    li x3, 0x20387c52
    csrw 0x4e3, x3

    #Address 0x4e3 Write value 0xc517f391
    li x3, 0xc517f391
    csrw 0x4e3, x3

    #Address 0x4e3 read value
    csrr x14, 0x4e3

    #Unmapped address 0x62d testing: random write/read operations
    #Address 0x62d read value
    csrr x14, 0x62d

    #Address 0x62d Write value 0x5111fe76
    li x3, 0x5111fe76
    csrw 0x62d, x3

    #Address 0x62d Write value 0x184c9136
    li x3, 0x184c9136
    csrw 0x62d, x3

    #Unmapped address 0x1 testing: random write/read operations
    #Address 0x1 Write value 0x65f42f54
    li x3, 0x65f42f54
    csrw 0x1, x3

    #Address 0x1 Write value 0x1123fbf3
    li x3, 0x1123fbf3
    csrw 0x1, x3

    #Address 0x1 Write value 0x3312a960
    li x3, 0x3312a960
    csrw 0x1, x3

    #Unmapped address 0x9cc testing: random write/read operations
    #Address 0x9cc read value
    csrr x14, 0x9cc

    #Unmapped address 0xf8f testing: random write/read operations
    #Address 0xf8f read value
    csrr x14, 0xf8f

    #Unmapped address 0xb23 testing: random write/read operations
    #Address 0xb23 Write value 0xc290f612
    li x3, 0xc290f612
    csrw 0xb23, x3

    #Address 0xb23 Write value 0x3902e70
    li x3, 0x3902e70
    csrw 0xb23, x3

    #Address 0xb23 read value
    csrr x14, 0xb23

    #Address 0xb23 Write value 0x5f8ca49b
    li x3, 0x5f8ca49b
    csrw 0xb23, x3

    #Unmapped address 0xddf testing: random write/read operations
    #Address 0xddf Write value 0x23d245b5
    li x3, 0x23d245b5
    csrw 0xddf, x3

    #Address 0xddf read value
    csrr x14, 0xddf

    #Address 0xddf Write value 0x78b03023
    li x3, 0x78b03023
    csrw 0xddf, x3

    #Unmapped address 0x7c1 testing: random write/read operations
    #Address 0x7c1 read value
    csrr x14, 0x7c1

    #Address 0x7c1 Write value 0xe42b8af8
    li x3, 0xe42b8af8
    csrw 0x7c1, x3

    #Address 0x7c1 read value
    csrr x14, 0x7c1

    #Address 0x7c1 Write value 0xbca50a76
    li x3, 0xbca50a76
    csrw 0x7c1, x3

    #Address 0x7c1 Write value 0x84212f76
    li x3, 0x84212f76
    csrw 0x7c1, x3

    #Unmapped address 0x521 testing: random write/read operations
    #Address 0x521 read value
    csrr x14, 0x521

    #Address 0x521 read value
    csrr x14, 0x521

    #Unmapped address 0xa74 testing: random write/read operations
    #Address 0xa74 read value
    csrr x14, 0xa74

    #Unmapped address 0xd65 testing: random write/read operations
    #Address 0xd65 Write value 0xf9ba1f5b
    li x3, 0xf9ba1f5b
    csrw 0xd65, x3

    #Address 0xd65 Write value 0x7bf78631
    li x3, 0x7bf78631
    csrw 0xd65, x3

    #Mapped address 0xb9c (mhpmcounterh28) testing: random write/read operations
    #Address 0xb9c Write value 0x1a13d070
    li x3, 0x1a13d070
    csrw 0xb9c, x3

    #Address 0xb9c Write value 0x629c6a59
    li x3, 0x629c6a59
    csrw 0xb9c, x3

    #Unmapped address 0x6e testing: random write/read operations
    #Address 0x6e Write value 0xcd1ab198
    li x3, 0xcd1ab198
    csrw 0x6e, x3

    #Address 0x6e read value
    csrr x14, 0x6e

    #Unmapped address 0x86b testing: random write/read operations
    #Address 0x86b Write value 0xd6f8de0c
    li x3, 0xd6f8de0c
    csrw 0x86b, x3

    #Address 0x86b Write value 0x2fc73371
    li x3, 0x2fc73371
    csrw 0x86b, x3

    #Address 0x86b read value
    csrr x14, 0x86b

    #Address 0x86b read value
    csrr x14, 0x86b

    #Unmapped address 0x574 testing: random write/read operations
    #Address 0x574 read value
    csrr x14, 0x574

    #Address 0x574 Write value 0x5a9b4772
    li x3, 0x5a9b4772
    csrw 0x574, x3

    #Address 0x574 Write value 0x82588f04
    li x3, 0x82588f04
    csrw 0x574, x3

    #Address 0x574 Write value 0xe5b20100
    li x3, 0xe5b20100
    csrw 0x574, x3

    #Unmapped address 0x6e6 testing: random write/read operations
    #Address 0x6e6 read value
    csrr x14, 0x6e6

    #Address 0x6e6 Write value 0xa7bbd327
    li x3, 0xa7bbd327
    csrw 0x6e6, x3

    #Address 0x6e6 Write value 0x17740ac6
    li x3, 0x17740ac6
    csrw 0x6e6, x3

    #Unmapped address 0x145 testing: random write/read operations
    #Address 0x145 Write value 0x871cb427
    li x3, 0x871cb427
    csrw 0x145, x3

    #Address 0x145 Write value 0x2cff4aff
    li x3, 0x2cff4aff
    csrw 0x145, x3

    #Address 0x145 read value
    csrr x14, 0x145

    #Address 0x145 Write value 0xb519e1b9
    li x3, 0xb519e1b9
    csrw 0x145, x3

    #Unmapped address 0x1fd testing: random write/read operations
    #Address 0x1fd Write value 0xa224ab60
    li x3, 0xa224ab60
    csrw 0x1fd, x3

    #Address 0x1fd read value
    csrr x14, 0x1fd

    #Address 0x1fd read value
    csrr x14, 0x1fd

    #Address 0x1fd read value
    csrr x14, 0x1fd

    #Address 0x1fd Write value 0x9b7a77e8
    li x3, 0x9b7a77e8
    csrw 0x1fd, x3

    #Unmapped address 0xa2 testing: random write/read operations
    #Address 0xa2 Write value 0x9a4f82e0
    li x3, 0x9a4f82e0
    csrw 0xa2, x3

    #Address 0xa2 read value
    csrr x14, 0xa2

    #Address 0xa2 read value
    csrr x14, 0xa2

    #Address 0xa2 read value
    csrr x14, 0xa2

    #Address 0xa2 Write value 0x42f01f24
    li x3, 0x42f01f24
    csrw 0xa2, x3

    #Mapped address 0x338 (mhpmevent24) testing: random write/read operations
    #Address 0x338 Write value 0x3e7fb9b9
    li x3, 0x3e7fb9b9
    csrw 0x338, x3

    #Address 0x338 Write value 0x802cd409
    li x3, 0x802cd409
    csrw 0x338, x3

    #Address 0x338 read value
    csrr x14, 0x338

    #Unmapped address 0x6bb testing: random write/read operations
    #Address 0x6bb Write value 0xdea18109
    li x3, 0xdea18109
    csrw 0x6bb, x3

    #Address 0x6bb read value
    csrr x14, 0x6bb

    #Unmapped address 0xe9d testing: random write/read operations
    #Address 0xe9d Write value 0x7c05b499
    li x3, 0x7c05b499
    csrw 0xe9d, x3

    #Address 0xe9d read value
    csrr x14, 0xe9d

    #Unmapped address 0x2a6 testing: random write/read operations
    #Address 0x2a6 read value
    csrr x14, 0x2a6

    #Address 0x2a6 read value
    csrr x14, 0x2a6

    #Unmapped address 0x499 testing: random write/read operations
    #Address 0x499 read value
    csrr x14, 0x499

    #Address 0x499 read value
    csrr x14, 0x499

    #Address 0x499 read value
    csrr x14, 0x499

    #Unmapped address 0x454 testing: random write/read operations
    #Address 0x454 read value
    csrr x14, 0x454

    #Unmapped address 0xed7 testing: random write/read operations
    #Address 0xed7 read value
    csrr x14, 0xed7

    #Address 0xed7 read value
    csrr x14, 0xed7

    #Address 0xed7 read value
    csrr x14, 0xed7

    #Address 0xed7 read value
    csrr x14, 0xed7

    #Address 0xed7 Write value 0x99fb39fb
    li x3, 0x99fb39fb
    csrw 0xed7, x3

    #Unmapped address 0x588 testing: random write/read operations
    #Address 0x588 read value
    csrr x14, 0x588

    #Unmapped address 0x183 testing: random write/read operations
    #Address 0x183 read value
    csrr x14, 0x183

    #Address 0x183 Write value 0xe47fd180
    li x3, 0xe47fd180
    csrw 0x183, x3

    #Address 0x183 Write value 0xace99efb
    li x3, 0xace99efb
    csrw 0x183, x3

    #Unmapped address 0xfe8 testing: random write/read operations
    #Address 0xfe8 read value
    csrr x14, 0xfe8

    #Address 0xfe8 read value
    csrr x14, 0xfe8

    #Address 0xfe8 Write value 0xa714a60
    li x3, 0xa714a60
    csrw 0xfe8, x3

    #Address 0xfe8 read value
    csrr x14, 0xfe8

    #Unmapped address 0x419 testing: random write/read operations
    #Address 0x419 Write value 0x40babe68
    li x3, 0x40babe68
    csrw 0x419, x3

    #Address 0x419 read value
    csrr x14, 0x419

    #Address 0x419 Write value 0xa7a0a401
    li x3, 0xa7a0a401
    csrw 0x419, x3

    #Address 0x419 Write value 0x8e6b6f96
    li x3, 0x8e6b6f96
    csrw 0x419, x3

    #Unmapped address 0x25 testing: random write/read operations
    #Address 0x25 Write value 0x8387c706
    li x3, 0x8387c706
    csrw 0x25, x3

    #Address 0x25 read value
    csrr x14, 0x25

    #Address 0x25 read value
    csrr x14, 0x25

    #Mapped address 0x3bd (pmpaddr13) testing: random write/read operations
    #Address 0x3bd read value
    csrr x14, 0x3bd

    #Address 0x3bd read value
    csrr x14, 0x3bd

    #Address 0x3bd Write value 0x1740391e
    li x3, 0x1740391e
    csrw 0x3bd, x3

    #Address 0x3bd Write value 0x2ae985e2
    li x3, 0x2ae985e2
    csrw 0x3bd, x3

    #Unmapped address 0xd21 testing: random write/read operations
    #Address 0xd21 read value
    csrr x14, 0xd21

    #Address 0xd21 read value
    csrr x14, 0xd21

    #Address 0xd21 Write value 0xdaf32686
    li x3, 0xdaf32686
    csrw 0xd21, x3

    #Address 0xd21 Write value 0xb81a082b
    li x3, 0xb81a082b
    csrw 0xd21, x3

    #Unmapped address 0xeb1 testing: random write/read operations
    #Address 0xeb1 Write value 0x42c8fd3e
    li x3, 0x42c8fd3e
    csrw 0xeb1, x3

    #Address 0xeb1 read value
    csrr x14, 0xeb1

    #Address 0xeb1 read value
    csrr x14, 0xeb1

    #Mapped address 0x325 (mhpmevent5) testing: random write/read operations
    #Address 0x325 Write value 0x5f7c8bb1
    li x3, 0x5f7c8bb1
    csrw 0x325, x3

    #Unmapped address 0x7e5 testing: random write/read operations
    #Address 0x7e5 Write value 0x610d771e
    li x3, 0x610d771e
    csrw 0x7e5, x3

    #Address 0x7e5 Write value 0xa8636e0d
    li x3, 0xa8636e0d
    csrw 0x7e5, x3

    #Address 0x7e5 read value
    csrr x14, 0x7e5

    #Address 0x7e5 read value
    csrr x14, 0x7e5

    #Address 0x7e5 Write value 0xa9a8ad83
    li x3, 0xa9a8ad83
    csrw 0x7e5, x3

    #Unmapped address 0x746 testing: random write/read operations
    #Address 0x746 Write value 0x1ab2a21
    li x3, 0x1ab2a21
    csrw 0x746, x3

    #Unmapped address 0x2ce testing: random write/read operations
    #Address 0x2ce read value
    csrr x14, 0x2ce

    #Address 0x2ce Write value 0x3dbc623b
    li x3, 0x3dbc623b
    csrw 0x2ce, x3

    #Unmapped address 0x22b testing: random write/read operations
    #Address 0x22b read value
    csrr x14, 0x22b

    #Address 0x22b read value
    csrr x14, 0x22b

    #Unmapped address 0xb01 testing: random write/read operations
    #Address 0xb01 Write value 0x80bcff23
    li x3, 0x80bcff23
    csrw 0xb01, x3

    #Address 0xb01 read value
    csrr x14, 0xb01

    #Address 0xb01 read value
    csrr x14, 0xb01

    #Address 0xb01 read value
    csrr x14, 0xb01

    #Address 0xb01 Write value 0x9a2b7ee7
    li x3, 0x9a2b7ee7
    csrw 0xb01, x3

    #Unmapped address 0x5d3 testing: random write/read operations
    #Address 0x5d3 Write value 0x7146ebdc
    li x3, 0x7146ebdc
    csrw 0x5d3, x3

    #Address 0x5d3 Write value 0x141ce2be
    li x3, 0x141ce2be
    csrw 0x5d3, x3

    #Address 0x5d3 read value
    csrr x14, 0x5d3

    #Address 0x5d3 read value
    csrr x14, 0x5d3

    #Unmapped address 0x972 testing: random write/read operations
    #Address 0x972 read value
    csrr x14, 0x972

    #Unmapped address 0xd5 testing: random write/read operations
    #Address 0xd5 read value
    csrr x14, 0xd5

    #Address 0xd5 read value
    csrr x14, 0xd5

    #Address 0xd5 Write value 0x7fe4e1cb
    li x3, 0x7fe4e1cb
    csrw 0xd5, x3

    #Unmapped address 0x713 testing: random write/read operations
    #Address 0x713 read value
    csrr x14, 0x713

    #Address 0x713 Write value 0xb5687c11
    li x3, 0xb5687c11
    csrw 0x713, x3

    #Address 0x713 Write value 0x564723a4
    li x3, 0x564723a4
    csrw 0x713, x3

    #Unmapped address 0x3f4 testing: random write/read operations
    #Address 0x3f4 Write value 0xb5c9522f
    li x3, 0xb5c9522f
    csrw 0x3f4, x3

    #Unmapped address 0x8fb testing: random write/read operations
    #Address 0x8fb read value
    csrr x14, 0x8fb

    #Address 0x8fb Write value 0xefd65ec7
    li x3, 0xefd65ec7
    csrw 0x8fb, x3

    #Address 0x8fb read value
    csrr x14, 0x8fb

    #Unmapped address 0x5af testing: random write/read operations
    #Address 0x5af read value
    csrr x14, 0x5af

    #Address 0x5af Write value 0x265c7293
    li x3, 0x265c7293
    csrw 0x5af, x3

    #Address 0x5af Write value 0x4279f569
    li x3, 0x4279f569
    csrw 0x5af, x3

    #Unmapped address 0xc63 testing: random write/read operations
    #Address 0xc63 Write value 0x960fb849
    li x3, 0x960fb849
    csrw 0xc63, x3

    #Address 0xc63 Write value 0x1a52d093
    li x3, 0x1a52d093
    csrw 0xc63, x3

    #Unmapped address 0x959 testing: random write/read operations
    #Address 0x959 read value
    csrr x14, 0x959

    #Address 0x959 Write value 0xa4f2ee23
    li x3, 0xa4f2ee23
    csrw 0x959, x3

    #Address 0x959 Write value 0xa6bd0a9d
    li x3, 0xa6bd0a9d
    csrw 0x959, x3

    #Unmapped address 0x2ef testing: random write/read operations
    #Address 0x2ef read value
    csrr x14, 0x2ef

    #Address 0x2ef read value
    csrr x14, 0x2ef

    #Address 0x2ef Write value 0x7265c73e
    li x3, 0x7265c73e
    csrw 0x2ef, x3

    #Address 0x2ef Write value 0x223ff99e
    li x3, 0x223ff99e
    csrw 0x2ef, x3

    #Address 0x2ef Write value 0xe0bb915
    li x3, 0xe0bb915
    csrw 0x2ef, x3

    #Unmapped address 0xa15 testing: random write/read operations
    #Address 0xa15 Write value 0x5e5286c6
    li x3, 0x5e5286c6
    csrw 0xa15, x3

    #Address 0xa15 Write value 0x59ccbf9b
    li x3, 0x59ccbf9b
    csrw 0xa15, x3

    #Address 0xa15 Write value 0x7e31e18d
    li x3, 0x7e31e18d
    csrw 0xa15, x3

    #Unmapped address 0x4ef testing: random write/read operations
    #Address 0x4ef Write value 0xede6876d
    li x3, 0xede6876d
    csrw 0x4ef, x3

    #Address 0x4ef read value
    csrr x14, 0x4ef

    #Address 0x4ef read value
    csrr x14, 0x4ef

    #Address 0x4ef Write value 0x7339cff2
    li x3, 0x7339cff2
    csrw 0x4ef, x3

    #Unmapped address 0x413 testing: random write/read operations
    #Address 0x413 read value
    csrr x14, 0x413

    #Address 0x413 read value
    csrr x14, 0x413

    #Address 0x413 Write value 0x2c215123
    li x3, 0x2c215123
    csrw 0x413, x3

    #Unmapped address 0x635 testing: random write/read operations
    #Address 0x635 Write value 0x212dcbb7
    li x3, 0x212dcbb7
    csrw 0x635, x3

    #Address 0x635 Write value 0xe2686a46
    li x3, 0xe2686a46
    csrw 0x635, x3

    #Address 0x635 Write value 0x1b39b731
    li x3, 0x1b39b731
    csrw 0x635, x3

    #Address 0x635 read value
    csrr x14, 0x635

    #Unmapped address 0xee6 testing: random write/read operations
    #Address 0xee6 Write value 0xfa524704
    li x3, 0xfa524704
    csrw 0xee6, x3

    #Address 0xee6 Write value 0x3df39ea6
    li x3, 0x3df39ea6
    csrw 0xee6, x3

    #Address 0xee6 read value
    csrr x14, 0xee6

    #Unmapped address 0x932 testing: random write/read operations
    #Address 0x932 Write value 0x9648c489
    li x3, 0x9648c489
    csrw 0x932, x3

    #Unmapped address 0x498 testing: random write/read operations
    #Address 0x498 read value
    csrr x14, 0x498

    #Address 0x498 read value
    csrr x14, 0x498

    #Address 0x498 Write value 0x4f92a25e
    li x3, 0x4f92a25e
    csrw 0x498, x3

    #Address 0x498 read value
    csrr x14, 0x498

    #Address 0x498 Write value 0xeb09911b
    li x3, 0xeb09911b
    csrw 0x498, x3

    #Unmapped address 0x422 testing: random write/read operations
    #Address 0x422 read value
    csrr x14, 0x422

    #Address 0x422 read value
    csrr x14, 0x422

    #Address 0x422 Write value 0x5b7e57bf
    li x3, 0x5b7e57bf
    csrw 0x422, x3

    #Address 0x422 Write value 0xb0244520
    li x3, 0xb0244520
    csrw 0x422, x3

    #Unmapped address 0x9a2 testing: random write/read operations
    #Address 0x9a2 read value
    csrr x14, 0x9a2

    #Address 0x9a2 read value
    csrr x14, 0x9a2

    #Address 0x9a2 Write value 0x98d43237
    li x3, 0x98d43237
    csrw 0x9a2, x3

    #Address 0x9a2 read value
    csrr x14, 0x9a2

    #Unmapped address 0x26c testing: random write/read operations
    #Address 0x26c read value
    csrr x14, 0x26c

    #Unmapped address 0x76 testing: random write/read operations
    #Address 0x76 read value
    csrr x14, 0x76

    #Address 0x76 Write value 0x6fc2eee5
    li x3, 0x6fc2eee5
    csrw 0x76, x3

    #Address 0x76 Write value 0x332408a1
    li x3, 0x332408a1
    csrw 0x76, x3

    #Address 0x76 Write value 0x224164d2
    li x3, 0x224164d2
    csrw 0x76, x3

    #Address 0x76 read value
    csrr x14, 0x76

    #Unmapped address 0x85d testing: random write/read operations
    #Address 0x85d Write value 0x8db4ec50
    li x3, 0x8db4ec50
    csrw 0x85d, x3

    #Address 0x85d Write value 0x3abfd53f
    li x3, 0x3abfd53f
    csrw 0x85d, x3

    #Address 0x85d read value
    csrr x14, 0x85d

    #Address 0x85d read value
    csrr x14, 0x85d

    #Address 0x85d Write value 0x9d7d465b
    li x3, 0x9d7d465b
    csrw 0x85d, x3

    #Unmapped address 0x975 testing: random write/read operations
    #Address 0x975 Write value 0x6796a61f
    li x3, 0x6796a61f
    csrw 0x975, x3

    #Unmapped address 0x94c testing: random write/read operations
    #Address 0x94c Write value 0xf309aa1a
    li x3, 0xf309aa1a
    csrw 0x94c, x3

    #Address 0x94c Write value 0x6180c49e
    li x3, 0x6180c49e
    csrw 0x94c, x3

    #Unmapped address 0x3d6 testing: random write/read operations
    #Address 0x3d6 Write value 0x9e867fed
    li x3, 0x9e867fed
    csrw 0x3d6, x3

    #Address 0x3d6 read value
    csrr x14, 0x3d6

    #Address 0x3d6 read value
    csrr x14, 0x3d6

    #Address 0x3d6 Write value 0xeba7f094
    li x3, 0xeba7f094
    csrw 0x3d6, x3

    #Unmapped address 0x5a8 testing: random write/read operations
    #Address 0x5a8 read value
    csrr x14, 0x5a8

    #Address 0x5a8 Write value 0x7e15c18c
    li x3, 0x7e15c18c
    csrw 0x5a8, x3

    #Unmapped address 0xe7c testing: random write/read operations
    #Address 0xe7c read value
    csrr x14, 0xe7c

    #Address 0xe7c read value
    csrr x14, 0xe7c

    #Address 0xe7c Write value 0x3376f080
    li x3, 0x3376f080
    csrw 0xe7c, x3

    #Address 0xe7c read value
    csrr x14, 0xe7c

    #Address 0xe7c Write value 0x1acef5f0
    li x3, 0x1acef5f0
    csrw 0xe7c, x3

    #Unmapped address 0x25e testing: random write/read operations
    #Address 0x25e Write value 0xb8e3f3ae
    li x3, 0xb8e3f3ae
    csrw 0x25e, x3

    #Address 0x25e read value
    csrr x14, 0x25e

    #Unmapped address 0xf10 testing: random write/read operations
    #Address 0xf10 Write value 0xaa3c5946
    li x3, 0xaa3c5946
    csrw 0xf10, x3

    #Address 0xf10 Write value 0x79fce63
    li x3, 0x79fce63
    csrw 0xf10, x3

    #Unmapped address 0xf43 testing: random write/read operations
    #Address 0xf43 Write value 0xf674cdf3
    li x3, 0xf674cdf3
    csrw 0xf43, x3

    #Address 0xf43 Write value 0x23a4abff
    li x3, 0x23a4abff
    csrw 0xf43, x3

    #Address 0xf43 read value
    csrr x14, 0xf43

    #Address 0xf43 Write value 0xa01ef433
    li x3, 0xa01ef433
    csrw 0xf43, x3

    #Unmapped address 0xad7 testing: random write/read operations
    #Address 0xad7 Write value 0xf3d461c4
    li x3, 0xf3d461c4
    csrw 0xad7, x3

    #Address 0xad7 Write value 0x244c8906
    li x3, 0x244c8906
    csrw 0xad7, x3

    #Address 0xad7 read value
    csrr x14, 0xad7

    #Address 0xad7 read value
    csrr x14, 0xad7

    #Address 0xad7 read value
    csrr x14, 0xad7

    #Unmapped address 0xe40 testing: random write/read operations
    #Address 0xe40 Write value 0xb2f16e5a
    li x3, 0xb2f16e5a
    csrw 0xe40, x3

    #Address 0xe40 Write value 0xb25dfa53
    li x3, 0xb25dfa53
    csrw 0xe40, x3

    #Unmapped address 0xe9e testing: random write/read operations
    #Address 0xe9e Write value 0xf8096ab9
    li x3, 0xf8096ab9
    csrw 0xe9e, x3

    #Address 0xe9e Write value 0xacbe9d6f
    li x3, 0xacbe9d6f
    csrw 0xe9e, x3

    #Address 0xe9e Write value 0x608618b3
    li x3, 0x608618b3
    csrw 0xe9e, x3

    #Unmapped address 0x901 testing: random write/read operations
    #Address 0x901 Write value 0x138db8ef
    li x3, 0x138db8ef
    csrw 0x901, x3

    #Address 0x901 read value
    csrr x14, 0x901

    #Address 0x901 Write value 0x6c924e65
    li x3, 0x6c924e65
    csrw 0x901, x3

    #Address 0x901 read value
    csrr x14, 0x901

    #Unmapped address 0x6ce testing: random write/read operations
    #Address 0x6ce read value
    csrr x14, 0x6ce

    #Address 0x6ce read value
    csrr x14, 0x6ce

    #Address 0x6ce read value
    csrr x14, 0x6ce

    #Unmapped address 0xd25 testing: random write/read operations
    #Address 0xd25 read value
    csrr x14, 0xd25

    #Address 0xd25 Write value 0xe3767453
    li x3, 0xe3767453
    csrw 0xd25, x3

    #Address 0xd25 read value
    csrr x14, 0xd25

    #Address 0xd25 read value
    csrr x14, 0xd25

    #Address 0xd25 read value
    csrr x14, 0xd25

    #Unmapped address 0xc3c testing: random write/read operations
    #Address 0xc3c Write value 0xbe42172e
    li x3, 0xbe42172e
    csrw 0xc3c, x3

    #Address 0xc3c Write value 0xc9fabc28
    li x3, 0xc9fabc28
    csrw 0xc3c, x3

    #Address 0xc3c read value
    csrr x14, 0xc3c

    #Address 0xc3c Write value 0x83871b24
    li x3, 0x83871b24
    csrw 0xc3c, x3

    #Unmapped address 0x42e testing: random write/read operations
    #Address 0x42e read value
    csrr x14, 0x42e

    #Unmapped address 0xb51 testing: random write/read operations
    #Address 0xb51 Write value 0x74ad742c
    li x3, 0x74ad742c
    csrw 0xb51, x3

    #Address 0xb51 read value
    csrr x14, 0xb51

    #Unmapped address 0x56a testing: random write/read operations
    #Address 0x56a read value
    csrr x14, 0x56a

    #Address 0x56a read value
    csrr x14, 0x56a

    #Unmapped address 0x42f testing: random write/read operations
    #Address 0x42f read value
    csrr x14, 0x42f

    #Address 0x42f Write value 0x4e04f3aa
    li x3, 0x4e04f3aa
    csrw 0x42f, x3

    #Unmapped address 0x52b testing: random write/read operations
    #Address 0x52b read value
    csrr x14, 0x52b

    #Address 0x52b Write value 0x71f1405b
    li x3, 0x71f1405b
    csrw 0x52b, x3

    #Unmapped address 0xc03 testing: random write/read operations
    #Address 0xc03 read value
    csrr x14, 0xc03

    #Unmapped address 0xd6a testing: random write/read operations
    #Address 0xd6a Write value 0xf7c7203b
    li x3, 0xf7c7203b
    csrw 0xd6a, x3

    #Address 0xd6a Write value 0x537dbbf2
    li x3, 0x537dbbf2
    csrw 0xd6a, x3

    #Unmapped address 0xfba testing: random write/read operations
    #Address 0xfba Write value 0x68f8dcd1
    li x3, 0x68f8dcd1
    csrw 0xfba, x3

    #Address 0xfba Write value 0xf49853d0
    li x3, 0xf49853d0
    csrw 0xfba, x3

    #Address 0xfba Write value 0xe0e02f86
    li x3, 0xe0e02f86
    csrw 0xfba, x3

    #Address 0xfba Write value 0x1b7e0aa7
    li x3, 0x1b7e0aa7
    csrw 0xfba, x3

    #Address 0xfba Write value 0x9031900b
    li x3, 0x9031900b
    csrw 0xfba, x3

    #Unmapped address 0x544 testing: random write/read operations
    #Address 0x544 read value
    csrr x14, 0x544

    #Address 0x544 read value
    csrr x14, 0x544

    #Address 0x544 Write value 0xef4e129d
    li x3, 0xef4e129d
    csrw 0x544, x3

    #Address 0x544 read value
    csrr x14, 0x544

    #Unmapped address 0x74 testing: random write/read operations
    #Address 0x74 read value
    csrr x14, 0x74

    #Address 0x74 Write value 0xaac3a591
    li x3, 0xaac3a591
    csrw 0x74, x3

    #Unmapped address 0xc6d testing: random write/read operations
    #Address 0xc6d Write value 0x1c5f34f8
    li x3, 0x1c5f34f8
    csrw 0xc6d, x3

    #Address 0xc6d Write value 0x8b5d26f2
    li x3, 0x8b5d26f2
    csrw 0xc6d, x3

    #Unmapped address 0x6f3 testing: random write/read operations
    #Address 0x6f3 Write value 0xbeecb349
    li x3, 0xbeecb349
    csrw 0x6f3, x3

    #Address 0x6f3 Write value 0x8c8e9b32
    li x3, 0x8c8e9b32
    csrw 0x6f3, x3

    #Address 0x6f3 Write value 0x3ef8a160
    li x3, 0x3ef8a160
    csrw 0x6f3, x3

    #Address 0x6f3 Write value 0x3070a369
    li x3, 0x3070a369
    csrw 0x6f3, x3

    #Unmapped address 0xd24 testing: random write/read operations
    #Address 0xd24 read value
    csrr x14, 0xd24

    #Address 0xd24 read value
    csrr x14, 0xd24

    #Address 0xd24 Write value 0xdfccf40c
    li x3, 0xdfccf40c
    csrw 0xd24, x3

    #Unmapped address 0x1ee testing: random write/read operations
    #Address 0x1ee Write value 0x49bc9d1a
    li x3, 0x49bc9d1a
    csrw 0x1ee, x3

    #Unmapped address 0x288 testing: random write/read operations
    #Address 0x288 Write value 0x563f2491
    li x3, 0x563f2491
    csrw 0x288, x3

    #Address 0x288 Write value 0x9a5e8561
    li x3, 0x9a5e8561
    csrw 0x288, x3

    #Unmapped address 0x9e6 testing: random write/read operations
    #Address 0x9e6 read value
    csrr x14, 0x9e6

    #Unmapped address 0xd19 testing: random write/read operations
    #Address 0xd19 read value
    csrr x14, 0xd19

    #Address 0xd19 read value
    csrr x14, 0xd19

    #Unmapped address 0x36f testing: random write/read operations
    #Address 0x36f Write value 0x3596f138
    li x3, 0x3596f138
    csrw 0x36f, x3

    #Unmapped address 0xc4b testing: random write/read operations
    #Address 0xc4b Write value 0x45aca48a
    li x3, 0x45aca48a
    csrw 0xc4b, x3

    #Address 0xc4b Write value 0x4a2c86d2
    li x3, 0x4a2c86d2
    csrw 0xc4b, x3

    #Address 0xc4b Write value 0x9e4ddbb4
    li x3, 0x9e4ddbb4
    csrw 0xc4b, x3

    #Unmapped address 0xc28 testing: random write/read operations
    #Address 0xc28 read value
    csrr x14, 0xc28

    #Address 0xc28 read value
    csrr x14, 0xc28

    #Address 0xc28 Write value 0x6c7b0308
    li x3, 0x6c7b0308
    csrw 0xc28, x3

    #Unmapped address 0xaf3 testing: random write/read operations
    #Address 0xaf3 read value
    csrr x14, 0xaf3

    #Unmapped address 0x4c3 testing: random write/read operations
    #Address 0x4c3 Write value 0xbbce3ebe
    li x3, 0xbbce3ebe
    csrw 0x4c3, x3

    #Unmapped address 0xf50 testing: random write/read operations
    #Address 0xf50 read value
    csrr x14, 0xf50

    #Address 0xf50 Write value 0xf46645c8
    li x3, 0xf46645c8
    csrw 0xf50, x3

    #Unmapped address 0x3fa testing: random write/read operations
    #Address 0x3fa read value
    csrr x14, 0x3fa

    #Address 0x3fa read value
    csrr x14, 0x3fa

    #Address 0x3fa read value
    csrr x14, 0x3fa

    #Address 0x3fa read value
    csrr x14, 0x3fa

    #Address 0x3fa read value
    csrr x14, 0x3fa

    #Unmapped address 0xfc9 testing: random write/read operations
    #Address 0xfc9 Write value 0x99ed8f04
    li x3, 0x99ed8f04
    csrw 0xfc9, x3

    #Address 0xfc9 Write value 0x2a543e1
    li x3, 0x2a543e1
    csrw 0xfc9, x3

    #Address 0xfc9 read value
    csrr x14, 0xfc9

    #Address 0xfc9 Write value 0x3bfd9983
    li x3, 0x3bfd9983
    csrw 0xfc9, x3

    #Address 0xfc9 read value
    csrr x14, 0xfc9

    #Unmapped address 0x1e6 testing: random write/read operations
    #Address 0x1e6 read value
    csrr x14, 0x1e6

    #Address 0x1e6 read value
    csrr x14, 0x1e6

    #Address 0x1e6 read value
    csrr x14, 0x1e6

    #Unmapped address 0x2ad testing: random write/read operations
    #Address 0x2ad read value
    csrr x14, 0x2ad

    #Address 0x2ad read value
    csrr x14, 0x2ad

    #Unmapped address 0x31e testing: random write/read operations
    #Address 0x31e Write value 0x2b03fcb8
    li x3, 0x2b03fcb8
    csrw 0x31e, x3

    #Address 0x31e Write value 0x708041af
    li x3, 0x708041af
    csrw 0x31e, x3

    #Unmapped address 0xe7 testing: random write/read operations
    #Address 0xe7 Write value 0x6a243933
    li x3, 0x6a243933
    csrw 0xe7, x3

    #Address 0xe7 read value
    csrr x14, 0xe7

    #Unmapped address 0x383 testing: random write/read operations
    #Address 0x383 read value
    csrr x14, 0x383

    #Unmapped address 0x7a9 testing: random write/read operations
    #Address 0x7a9 Write value 0x24a2ac0a
    li x3, 0x24a2ac0a
    csrw 0x7a9, x3

    #Unmapped address 0x176 testing: random write/read operations
    #Address 0x176 Write value 0x8975dc98
    li x3, 0x8975dc98
    csrw 0x176, x3

    #Address 0x176 Write value 0x32339f37
    li x3, 0x32339f37
    csrw 0x176, x3

    #Address 0x176 read value
    csrr x14, 0x176

    #Unmapped address 0x156 testing: random write/read operations
    #Address 0x156 Write value 0xe827c370
    li x3, 0xe827c370
    csrw 0x156, x3

    #Address 0x156 Write value 0x2f7f852d
    li x3, 0x2f7f852d
    csrw 0x156, x3

    #Address 0x156 read value
    csrr x14, 0x156

    #Address 0x156 read value
    csrr x14, 0x156

    #Unmapped address 0x620 testing: random write/read operations
    #Address 0x620 read value
    csrr x14, 0x620

    #Address 0x620 Write value 0x8d1974b2
    li x3, 0x8d1974b2
    csrw 0x620, x3

    #Unmapped address 0xe3f testing: random write/read operations
    #Address 0xe3f Write value 0x9afdcb2a
    li x3, 0x9afdcb2a
    csrw 0xe3f, x3

    #Address 0xe3f read value
    csrr x14, 0xe3f

    #Address 0xe3f Write value 0xe632594
    li x3, 0xe632594
    csrw 0xe3f, x3

    #Address 0xe3f read value
    csrr x14, 0xe3f

    #Unmapped address 0x7dd testing: random write/read operations
    #Address 0x7dd read value
    csrr x14, 0x7dd

    #Address 0x7dd Write value 0xba12a3c6
    li x3, 0xba12a3c6
    csrw 0x7dd, x3

    #Address 0x7dd Write value 0xac1a582b
    li x3, 0xac1a582b
    csrw 0x7dd, x3

    #Unmapped address 0x88b testing: random write/read operations
    #Address 0x88b read value
    csrr x14, 0x88b

    #Unmapped address 0xdc1 testing: random write/read operations
    #Address 0xdc1 read value
    csrr x14, 0xdc1

    #Address 0xdc1 Write value 0x4b75672f
    li x3, 0x4b75672f
    csrw 0xdc1, x3

    #Address 0xdc1 read value
    csrr x14, 0xdc1

    #Address 0xdc1 Write value 0x4ddded9d
    li x3, 0x4ddded9d
    csrw 0xdc1, x3

    #Unmapped address 0xb33 testing: random write/read operations
    #Address 0xb33 Write value 0x875c556a
    li x3, 0x875c556a
    csrw 0xb33, x3

    #Mapped address 0xb90 (mhpmcounterh16) testing: random write/read operations
    #Address 0xb90 read value
    csrr x14, 0xb90

    #Unmapped address 0x417 testing: random write/read operations
    #Address 0x417 Write value 0x98ac9744
    li x3, 0x98ac9744
    csrw 0x417, x3

    #Address 0x417 read value
    csrr x14, 0x417

    #Address 0x417 read value
    csrr x14, 0x417

    #Address 0x417 Write value 0x3f5596e0
    li x3, 0x3f5596e0
    csrw 0x417, x3

    #Unmapped address 0x27d testing: random write/read operations
    #Address 0x27d read value
    csrr x14, 0x27d

    #Address 0x27d Write value 0x5e7a1293
    li x3, 0x5e7a1293
    csrw 0x27d, x3

    #Address 0x27d Write value 0xa8207ed0
    li x3, 0xa8207ed0
    csrw 0x27d, x3

    #Address 0x27d read value
    csrr x14, 0x27d

    #Address 0x27d Write value 0xd46bfa49
    li x3, 0xd46bfa49
    csrw 0x27d, x3

    #Unmapped address 0x44a testing: random write/read operations
    #Address 0x44a Write value 0x926ddb79
    li x3, 0x926ddb79
    csrw 0x44a, x3

    #Address 0x44a Write value 0xf7831cc7
    li x3, 0xf7831cc7
    csrw 0x44a, x3

    #Address 0x44a read value
    csrr x14, 0x44a

    #Address 0x44a Write value 0x2395e24a
    li x3, 0x2395e24a
    csrw 0x44a, x3

    #Unmapped address 0x1b1 testing: random write/read operations
    #Address 0x1b1 read value
    csrr x14, 0x1b1

    #Address 0x1b1 read value
    csrr x14, 0x1b1

    #Address 0x1b1 Write value 0xecf09227
    li x3, 0xecf09227
    csrw 0x1b1, x3

    #Address 0x1b1 read value
    csrr x14, 0x1b1

    #Address 0x1b1 read value
    csrr x14, 0x1b1

    #Unmapped address 0x1e3 testing: random write/read operations
    #Address 0x1e3 read value
    csrr x14, 0x1e3

    #Address 0x1e3 Write value 0xc1888649
    li x3, 0xc1888649
    csrw 0x1e3, x3

    #Address 0x1e3 Write value 0xfac65ff2
    li x3, 0xfac65ff2
    csrw 0x1e3, x3

    #Address 0x1e3 read value
    csrr x14, 0x1e3

    #Unmapped address 0xa1c testing: random write/read operations
    #Address 0xa1c read value
    csrr x14, 0xa1c

    #Address 0xa1c read value
    csrr x14, 0xa1c

    #Address 0xa1c read value
    csrr x14, 0xa1c

    #Address 0xa1c read value
    csrr x14, 0xa1c

    #Unmapped address 0x804 testing: random write/read operations
    #Address 0x804 Write value 0x42162003
    li x3, 0x42162003
    csrw 0x804, x3

    #Address 0x804 read value
    csrr x14, 0x804

    #Mapped address 0xb09 (mhpmcounter9) testing: random write/read operations
    #Address 0xb09 read value
    csrr x14, 0xb09

    #Unmapped address 0xf78 testing: random write/read operations
    #Address 0xf78 read value
    csrr x14, 0xf78

    #Unmapped address 0x1dd testing: random write/read operations
    #Address 0x1dd read value
    csrr x14, 0x1dd

    #Address 0x1dd read value
    csrr x14, 0x1dd

    #Address 0x1dd read value
    csrr x14, 0x1dd

    #Address 0x1dd Write value 0x4b00ca04
    li x3, 0x4b00ca04
    csrw 0x1dd, x3

    #Mapped address 0xb15 (mhpmcounter21) testing: random write/read operations
    #Address 0xb15 read value
    csrr x14, 0xb15

    #Address 0xb15 read value
    csrr x14, 0xb15

    #Address 0xb15 Write value 0xc2d26451
    li x3, 0xc2d26451
    csrw 0xb15, x3

    #Unmapped address 0x1a5 testing: random write/read operations
    #Address 0x1a5 Write value 0x50fc51f0
    li x3, 0x50fc51f0
    csrw 0x1a5, x3

    #Address 0x1a5 Write value 0xc98c3097
    li x3, 0xc98c3097
    csrw 0x1a5, x3

    #Address 0x1a5 read value
    csrr x14, 0x1a5

    #Unmapped address 0x2b7 testing: random write/read operations
    #Address 0x2b7 read value
    csrr x14, 0x2b7

    #Unmapped address 0xf60 testing: random write/read operations
    #Address 0xf60 Write value 0x9692183c
    li x3, 0x9692183c
    csrw 0xf60, x3

    #Address 0xf60 read value
    csrr x14, 0xf60

    #Address 0xf60 Write value 0x465baba8
    li x3, 0x465baba8
    csrw 0xf60, x3

    #Address 0xf60 read value
    csrr x14, 0xf60

    #Unmapped address 0x1e4 testing: random write/read operations
    #Address 0x1e4 read value
    csrr x14, 0x1e4

    #Address 0x1e4 Write value 0x56e69335
    li x3, 0x56e69335
    csrw 0x1e4, x3

    #Address 0x1e4 read value
    csrr x14, 0x1e4

    #Mapped address 0x304 (mie) testing: random write/read operations
    #Address 0x304 read value
    csrr x14, 0x304

    #Address 0x304 read value
    csrr x14, 0x304

    #Address 0x304 read value
    csrr x14, 0x304

    #Address 0x304 read value
    csrr x14, 0x304

    #Address 0x304 Write value 0x6e1ca2fe
    li x3, 0x6e1ca2fe
    csrw 0x304, x3

    #Unmapped address 0x826 testing: random write/read operations
    #Address 0x826 read value
    csrr x14, 0x826

    #Address 0x826 read value
    csrr x14, 0x826

    #Address 0x826 read value
    csrr x14, 0x826

    #Address 0x826 read value
    csrr x14, 0x826

    #Unmapped address 0xd44 testing: random write/read operations
    #Address 0xd44 Write value 0x2af0f46b
    li x3, 0x2af0f46b
    csrw 0xd44, x3

    #Unmapped address 0x6f1 testing: random write/read operations
    #Address 0x6f1 Write value 0x4b897a6a
    li x3, 0x4b897a6a
    csrw 0x6f1, x3

    #Address 0x6f1 Write value 0xf329b965
    li x3, 0xf329b965
    csrw 0x6f1, x3

    #Address 0x6f1 Write value 0xc703c015
    li x3, 0xc703c015
    csrw 0x6f1, x3

    #Address 0x6f1 read value
    csrr x14, 0x6f1

    #Unmapped address 0xca7 testing: random write/read operations
    #Address 0xca7 read value
    csrr x14, 0xca7

    #Address 0xca7 read value
    csrr x14, 0xca7

    #Unmapped address 0x913 testing: random write/read operations
    #Address 0x913 read value
    csrr x14, 0x913

    #Unmapped address 0x964 testing: random write/read operations
    #Address 0x964 Write value 0xfc559880
    li x3, 0xfc559880
    csrw 0x964, x3

    #Address 0x964 Write value 0x3a872065
    li x3, 0x3a872065
    csrw 0x964, x3

    #Address 0x964 read value
    csrr x14, 0x964

    #Unmapped address 0xeee testing: random write/read operations
    #Address 0xeee Write value 0x9565a74f
    li x3, 0x9565a74f
    csrw 0xeee, x3

    #Address 0xeee read value
    csrr x14, 0xeee

    #Address 0xeee read value
    csrr x14, 0xeee

    #Address 0xeee read value
    csrr x14, 0xeee

    #Unmapped address 0x77b testing: random write/read operations
    #Address 0x77b Write value 0xe7798ab5
    li x3, 0xe7798ab5
    csrw 0x77b, x3

    #Address 0x77b read value
    csrr x14, 0x77b

    #Address 0x77b Write value 0xce302997
    li x3, 0xce302997
    csrw 0x77b, x3

    #Address 0x77b read value
    csrr x14, 0x77b

    #Unmapped address 0x8cb testing: random write/read operations
    #Address 0x8cb read value
    csrr x14, 0x8cb

    #Address 0x8cb Write value 0xe89742cf
    li x3, 0xe89742cf
    csrw 0x8cb, x3

    #Address 0x8cb Write value 0xd1027650
    li x3, 0xd1027650
    csrw 0x8cb, x3

    #Address 0x8cb read value
    csrr x14, 0x8cb

    #Address 0x8cb Write value 0xbb86d5e8
    li x3, 0xbb86d5e8
    csrw 0x8cb, x3

    #Unmapped address 0x31c testing: random write/read operations
    #Address 0x31c Write value 0x1cc9afa8
    li x3, 0x1cc9afa8
    csrw 0x31c, x3

    #Address 0x31c read value
    csrr x14, 0x31c

    #Address 0x31c read value
    csrr x14, 0x31c

    #Address 0x31c Write value 0x221678c9
    li x3, 0x221678c9
    csrw 0x31c, x3

    #Address 0x31c Write value 0x5453837b
    li x3, 0x5453837b
    csrw 0x31c, x3

    #Unmapped address 0x3d2 testing: random write/read operations
    #Address 0x3d2 Write value 0x7d5528b2
    li x3, 0x7d5528b2
    csrw 0x3d2, x3

    #Unmapped address 0x5e8 testing: random write/read operations
    #Address 0x5e8 read value
    csrr x14, 0x5e8

    #Unmapped address 0x287 testing: random write/read operations
    #Address 0x287 Write value 0x60f0b25
    li x3, 0x60f0b25
    csrw 0x287, x3

    #Address 0x287 read value
    csrr x14, 0x287

    #Address 0x287 Write value 0x3781fabd
    li x3, 0x3781fabd
    csrw 0x287, x3

    #Address 0x287 read value
    csrr x14, 0x287

    #Address 0x287 read value
    csrr x14, 0x287

    #Unmapped address 0xd8c testing: random write/read operations
    #Address 0xd8c Write value 0x5e94dbdc
    li x3, 0x5e94dbdc
    csrw 0xd8c, x3

    #Address 0xd8c read value
    csrr x14, 0xd8c

    #Address 0xd8c Write value 0xc41aa346
    li x3, 0xc41aa346
    csrw 0xd8c, x3

    #Address 0xd8c Write value 0xe61bcde
    li x3, 0xe61bcde
    csrw 0xd8c, x3

    #Unmapped address 0x4c6 testing: random write/read operations
    #Address 0x4c6 Write value 0x13b29643
    li x3, 0x13b29643
    csrw 0x4c6, x3

    #Address 0x4c6 read value
    csrr x14, 0x4c6

    #Address 0x4c6 read value
    csrr x14, 0x4c6

    #Unmapped address 0x208 testing: random write/read operations
    #Address 0x208 read value
    csrr x14, 0x208

    #Address 0x208 Write value 0xe7e2600c
    li x3, 0xe7e2600c
    csrw 0x208, x3

    #Unmapped address 0xbb1 testing: random write/read operations
    #Address 0xbb1 Write value 0xcbdef630
    li x3, 0xcbdef630
    csrw 0xbb1, x3

    #Unmapped address 0x57 testing: random write/read operations
    #Address 0x57 read value
    csrr x14, 0x57

    #Address 0x57 read value
    csrr x14, 0x57

    #Unmapped address 0x7f2 testing: random write/read operations
    #Address 0x7f2 read value
    csrr x14, 0x7f2

    #Address 0x7f2 Write value 0x6c557734
    li x3, 0x6c557734
    csrw 0x7f2, x3

    #Address 0x7f2 Write value 0xf0183317
    li x3, 0xf0183317
    csrw 0x7f2, x3

    #Address 0x7f2 Write value 0x65647c79
    li x3, 0x65647c79
    csrw 0x7f2, x3

    #Unmapped address 0xa6 testing: random write/read operations
    #Address 0xa6 read value
    csrr x14, 0xa6

    #Address 0xa6 Write value 0x6c7c910d
    li x3, 0x6c7c910d
    csrw 0xa6, x3

    #Address 0xa6 read value
    csrr x14, 0xa6

    #Unmapped address 0x242 testing: random write/read operations
    #Address 0x242 Write value 0x9105e379
    li x3, 0x9105e379
    csrw 0x242, x3

    #Unmapped address 0x79 testing: random write/read operations
    #Address 0x79 Write value 0xcbbe9acd
    li x3, 0xcbbe9acd
    csrw 0x79, x3

    #Unmapped address 0x3c2 testing: random write/read operations
    #Address 0x3c2 read value
    csrr x14, 0x3c2

    #Address 0x3c2 Write value 0xe8bff8e5
    li x3, 0xe8bff8e5
    csrw 0x3c2, x3

    #Address 0x3c2 Write value 0x3d09bf4d
    li x3, 0x3d09bf4d
    csrw 0x3c2, x3

    #Unmapped address 0x961 testing: random write/read operations
    #Address 0x961 read value
    csrr x14, 0x961

    #Address 0x961 read value
    csrr x14, 0x961

    #Address 0x961 Write value 0xdef718fd
    li x3, 0xdef718fd
    csrw 0x961, x3

    #Address 0x961 read value
    csrr x14, 0x961

    #Unmapped address 0x958 testing: random write/read operations
    #Address 0x958 read value
    csrr x14, 0x958

    #Address 0x958 Write value 0xfcaaf85d
    li x3, 0xfcaaf85d
    csrw 0x958, x3

    #Address 0x958 Write value 0xc8e24aa3
    li x3, 0xc8e24aa3
    csrw 0x958, x3

    #Address 0x958 read value
    csrr x14, 0x958

    #Address 0x958 read value
    csrr x14, 0x958

    #Unmapped address 0x41d testing: random write/read operations
    #Address 0x41d Write value 0xde2035a9
    li x3, 0xde2035a9
    csrw 0x41d, x3

    #Address 0x41d read value
    csrr x14, 0x41d

    #Address 0x41d read value
    csrr x14, 0x41d

    #Unmapped address 0x4e1 testing: random write/read operations
    #Address 0x4e1 read value
    csrr x14, 0x4e1

    #Address 0x4e1 read value
    csrr x14, 0x4e1

    #Address 0x4e1 Write value 0x180920ff
    li x3, 0x180920ff
    csrw 0x4e1, x3

    #Unmapped address 0x7af testing: random write/read operations
    #Address 0x7af read value
    csrr x14, 0x7af

    #Address 0x7af Write value 0x91a577c2
    li x3, 0x91a577c2
    csrw 0x7af, x3

    #Address 0x7af Write value 0xd9299ef2
    li x3, 0xd9299ef2
    csrw 0x7af, x3

    #Address 0x7af read value
    csrr x14, 0x7af

    #Unmapped address 0xcf testing: random write/read operations
    #Address 0xcf read value
    csrr x14, 0xcf

    #Address 0xcf read value
    csrr x14, 0xcf

    #Unmapped address 0xa78 testing: random write/read operations
    #Address 0xa78 read value
    csrr x14, 0xa78

    #Address 0xa78 read value
    csrr x14, 0xa78

    #Address 0xa78 read value
    csrr x14, 0xa78

    #Unmapped address 0x1e7 testing: random write/read operations
    #Address 0x1e7 Write value 0x644a95df
    li x3, 0x644a95df
    csrw 0x1e7, x3

    #Address 0x1e7 read value
    csrr x14, 0x1e7

    #Address 0x1e7 Write value 0x4edaacce
    li x3, 0x4edaacce
    csrw 0x1e7, x3

    #Address 0x1e7 read value
    csrr x14, 0x1e7

    #Address 0x1e7 Write value 0x84b9204
    li x3, 0x84b9204
    csrw 0x1e7, x3

    #Unmapped address 0xf52 testing: random write/read operations
    #Address 0xf52 read value
    csrr x14, 0xf52

    #Address 0xf52 read value
    csrr x14, 0xf52

    #Unmapped address 0x675 testing: random write/read operations
    #Address 0x675 read value
    csrr x14, 0x675

    #Unmapped address 0x18e testing: random write/read operations
    #Address 0x18e read value
    csrr x14, 0x18e

    #Address 0x18e Write value 0x9dac51a8
    li x3, 0x9dac51a8
    csrw 0x18e, x3

    #Address 0x18e read value
    csrr x14, 0x18e

    #Unmapped address 0xf69 testing: random write/read operations
    #Address 0xf69 read value
    csrr x14, 0xf69

    #Address 0xf69 read value
    csrr x14, 0xf69

    #Unmapped address 0x48c testing: random write/read operations
    #Address 0x48c Write value 0x6a293bc4
    li x3, 0x6a293bc4
    csrw 0x48c, x3

    #Address 0x48c read value
    csrr x14, 0x48c

    #Mapped address 0x32d (mhpmevent13) testing: random write/read operations
    #Address 0x32d Write value 0x5737fce8
    li x3, 0x5737fce8
    csrw 0x32d, x3

    #Unmapped address 0x31d testing: random write/read operations
    #Address 0x31d Write value 0xf1458401
    li x3, 0xf1458401
    csrw 0x31d, x3

    #Address 0x31d read value
    csrr x14, 0x31d

    #Address 0x31d Write value 0x907284e
    li x3, 0x907284e
    csrw 0x31d, x3

    #Unmapped address 0xcc2 testing: random write/read operations
    #Address 0xcc2 read value
    csrr x14, 0xcc2

    #Unmapped address 0x41 testing: random write/read operations
    #Address 0x41 read value
    csrr x14, 0x41

    #Address 0x41 Write value 0x1936e590
    li x3, 0x1936e590
    csrw 0x41, x3

    #Address 0x41 Write value 0x7ee147a2
    li x3, 0x7ee147a2
    csrw 0x41, x3

    #Unmapped address 0x946 testing: random write/read operations
    #Address 0x946 read value
    csrr x14, 0x946

    #Address 0x946 Write value 0x18a6f386
    li x3, 0x18a6f386
    csrw 0x946, x3

    #Mapped address 0x32e (mhpmevent14) testing: random write/read operations
    #Address 0x32e Write value 0xe8e1cd2d
    li x3, 0xe8e1cd2d
    csrw 0x32e, x3

    #Address 0x32e read value
    csrr x14, 0x32e

    #Address 0x32e Write value 0xc11332a1
    li x3, 0xc11332a1
    csrw 0x32e, x3

    #Unmapped address 0x971 testing: random write/read operations
    #Address 0x971 read value
    csrr x14, 0x971

    #Address 0x971 read value
    csrr x14, 0x971

    #Address 0x971 read value
    csrr x14, 0x971

    #Address 0x971 read value
    csrr x14, 0x971

    #Address 0x971 Write value 0xbfcab61d
    li x3, 0xbfcab61d
    csrw 0x971, x3

    #Unmapped address 0x6af testing: random write/read operations
    #Address 0x6af Write value 0xdec0b0db
    li x3, 0xdec0b0db
    csrw 0x6af, x3

    #Address 0x6af read value
    csrr x14, 0x6af

    #Address 0x6af read value
    csrr x14, 0x6af

    #Address 0x6af Write value 0xa77d0b68
    li x3, 0xa77d0b68
    csrw 0x6af, x3

    #Address 0x6af read value
    csrr x14, 0x6af

    #Unmapped address 0xfbd testing: random write/read operations
    #Address 0xfbd Write value 0xe915ff78
    li x3, 0xe915ff78
    csrw 0xfbd, x3

    #Address 0xfbd Write value 0x9307b7d6
    li x3, 0x9307b7d6
    csrw 0xfbd, x3

    #Address 0xfbd read value
    csrr x14, 0xfbd

    #Address 0xfbd Write value 0x8a0a9fe2
    li x3, 0x8a0a9fe2
    csrw 0xfbd, x3

    #Unmapped address 0xe4b testing: random write/read operations
    #Address 0xe4b read value
    csrr x14, 0xe4b

    #Address 0xe4b Write value 0x5abd11b5
    li x3, 0x5abd11b5
    csrw 0xe4b, x3

    #Address 0xe4b read value
    csrr x14, 0xe4b

    #Address 0xe4b Write value 0xc4f05a98
    li x3, 0xc4f05a98
    csrw 0xe4b, x3

    #Address 0xe4b read value
    csrr x14, 0xe4b

    #Unmapped address 0x312 testing: random write/read operations
    #Address 0x312 read value
    csrr x14, 0x312

    #Address 0x312 Write value 0x7ca97cad
    li x3, 0x7ca97cad
    csrw 0x312, x3

    #Address 0x312 read value
    csrr x14, 0x312

    #Address 0x312 read value
    csrr x14, 0x312

    #Unmapped address 0xf72 testing: random write/read operations
    #Address 0xf72 Write value 0xac40558b
    li x3, 0xac40558b
    csrw 0xf72, x3

    #Address 0xf72 Write value 0xfb596074
    li x3, 0xfb596074
    csrw 0xf72, x3

    #Address 0xf72 read value
    csrr x14, 0xf72

    #Unmapped address 0xf5c testing: random write/read operations
    #Address 0xf5c read value
    csrr x14, 0xf5c

    #Unmapped address 0x616 testing: random write/read operations
    #Address 0x616 Write value 0x4356c000
    li x3, 0x4356c000
    csrw 0x616, x3

    #Address 0x616 read value
    csrr x14, 0x616

    #Address 0x616 Write value 0x45a9ed7c
    li x3, 0x45a9ed7c
    csrw 0x616, x3

    #Address 0x616 Write value 0xc121e8ac
    li x3, 0xc121e8ac
    csrw 0x616, x3

    #Unmapped address 0x883 testing: random write/read operations
    #Address 0x883 read value
    csrr x14, 0x883

    #Unmapped address 0x773 testing: random write/read operations
    #Address 0x773 read value
    csrr x14, 0x773

    #Address 0x773 read value
    csrr x14, 0x773

    #Address 0x773 read value
    csrr x14, 0x773

    #Address 0x773 Write value 0xfd31b7a6
    li x3, 0xfd31b7a6
    csrw 0x773, x3

    #Address 0x773 read value
    csrr x14, 0x773

    #Unmapped address 0x1f0 testing: random write/read operations
    #Address 0x1f0 Write value 0xdfbbbe0
    li x3, 0xdfbbbe0
    csrw 0x1f0, x3

    #Unmapped address 0xe71 testing: random write/read operations
    #Address 0xe71 Write value 0xc6ca0777
    li x3, 0xc6ca0777
    csrw 0xe71, x3

    #Address 0xe71 read value
    csrr x14, 0xe71

    #Address 0xe71 Write value 0x59b96476
    li x3, 0x59b96476
    csrw 0xe71, x3

    #Address 0xe71 read value
    csrr x14, 0xe71

    #Unmapped address 0xde3 testing: random write/read operations
    #Address 0xde3 Write value 0xab96ca52
    li x3, 0xab96ca52
    csrw 0xde3, x3

    #Unmapped address 0xcbb testing: random write/read operations
    #Address 0xcbb Write value 0xc06b9e32
    li x3, 0xc06b9e32
    csrw 0xcbb, x3

    #Address 0xcbb read value
    csrr x14, 0xcbb

    #Unmapped address 0x2f9 testing: random write/read operations
    #Address 0x2f9 Write value 0x6cdfd7af
    li x3, 0x6cdfd7af
    csrw 0x2f9, x3

    #Address 0x2f9 Write value 0xca8d126e
    li x3, 0xca8d126e
    csrw 0x2f9, x3

    #Address 0x2f9 Write value 0x3c87fd3e
    li x3, 0x3c87fd3e
    csrw 0x2f9, x3

    #Address 0x2f9 Write value 0x4f7fed84
    li x3, 0x4f7fed84
    csrw 0x2f9, x3

    #Address 0x2f9 read value
    csrr x14, 0x2f9

    #Unmapped address 0x68c testing: random write/read operations
    #Address 0x68c Write value 0x6748e58c
    li x3, 0x6748e58c
    csrw 0x68c, x3

    #Address 0x68c read value
    csrr x14, 0x68c

    #Address 0x68c Write value 0x6af1c5bf
    li x3, 0x6af1c5bf
    csrw 0x68c, x3

    #Unmapped address 0xf1a testing: random write/read operations
    #Address 0xf1a Write value 0x54f88073
    li x3, 0x54f88073
    csrw 0xf1a, x3

    #Address 0xf1a Write value 0x706639b
    li x3, 0x706639b
    csrw 0xf1a, x3

    #Unmapped address 0xc4a testing: random write/read operations
    #Address 0xc4a Write value 0x318dc8a8
    li x3, 0x318dc8a8
    csrw 0xc4a, x3

    #Address 0xc4a Write value 0x963be526
    li x3, 0x963be526
    csrw 0xc4a, x3

    #Address 0xc4a read value
    csrr x14, 0xc4a

    #Unmapped address 0x8a5 testing: random write/read operations
    #Address 0x8a5 read value
    csrr x14, 0x8a5

    #Address 0x8a5 read value
    csrr x14, 0x8a5

    #Address 0x8a5 Write value 0xc7231f34
    li x3, 0xc7231f34
    csrw 0x8a5, x3

    #Unmapped address 0x898 testing: random write/read operations
    #Address 0x898 Write value 0x680f19e9
    li x3, 0x680f19e9
    csrw 0x898, x3

    #Address 0x898 Write value 0x454f18ca
    li x3, 0x454f18ca
    csrw 0x898, x3

    #Address 0x898 Write value 0x93f75c60
    li x3, 0x93f75c60
    csrw 0x898, x3

    #Unmapped address 0x663 testing: random write/read operations
    #Address 0x663 read value
    csrr x14, 0x663

    #Address 0x663 read value
    csrr x14, 0x663

    #Address 0x663 Write value 0xdb78f7b4
    li x3, 0xdb78f7b4
    csrw 0x663, x3

    #Address 0x663 Write value 0x1e7f9ebe
    li x3, 0x1e7f9ebe
    csrw 0x663, x3

    #Address 0x663 read value
    csrr x14, 0x663

    #Unmapped address 0xfa3 testing: random write/read operations
    #Address 0xfa3 Write value 0x49ea60b5
    li x3, 0x49ea60b5
    csrw 0xfa3, x3

    #Address 0xfa3 Write value 0x6cc7a2a6
    li x3, 0x6cc7a2a6
    csrw 0xfa3, x3

    #Address 0xfa3 read value
    csrr x14, 0xfa3

    #Unmapped address 0x1b testing: random write/read operations
    #Address 0x1b Write value 0xb3aadf2a
    li x3, 0xb3aadf2a
    csrw 0x1b, x3

    #Address 0x1b read value
    csrr x14, 0x1b

    #Address 0x1b Write value 0x434db4ff
    li x3, 0x434db4ff
    csrw 0x1b, x3

    #Address 0x1b Write value 0xb4ae3568
    li x3, 0xb4ae3568
    csrw 0x1b, x3

    #Unmapped address 0x581 testing: random write/read operations
    #Address 0x581 Write value 0xf807d418
    li x3, 0xf807d418
    csrw 0x581, x3

    #Address 0x581 Write value 0x3f90e139
    li x3, 0x3f90e139
    csrw 0x581, x3

    #Address 0x581 Write value 0x714509fe
    li x3, 0x714509fe
    csrw 0x581, x3

    #Address 0x581 read value
    csrr x14, 0x581

    #Address 0x581 read value
    csrr x14, 0x581

    #Unmapped address 0xe83 testing: random write/read operations
    #Address 0xe83 Write value 0x518b2e24
    li x3, 0x518b2e24
    csrw 0xe83, x3

    #Address 0xe83 read value
    csrr x14, 0xe83

    #Address 0xe83 Write value 0xc9b3d1d9
    li x3, 0xc9b3d1d9
    csrw 0xe83, x3

    #Address 0xe83 read value
    csrr x14, 0xe83

    #Address 0xe83 Write value 0x2e912dcd
    li x3, 0x2e912dcd
    csrw 0xe83, x3

    #Unmapped address 0x740 testing: random write/read operations
    #Address 0x740 read value
    csrr x14, 0x740

    #Address 0x740 Write value 0x1da99a2b
    li x3, 0x1da99a2b
    csrw 0x740, x3

    #Address 0x740 read value
    csrr x14, 0x740

    #Unmapped address 0x23d testing: random write/read operations
    #Address 0x23d Write value 0xb0af8014
    li x3, 0xb0af8014
    csrw 0x23d, x3

    #Unmapped address 0xd10 testing: random write/read operations
    #Address 0xd10 Write value 0x96c9dffd
    li x3, 0x96c9dffd
    csrw 0xd10, x3

    #Address 0xd10 read value
    csrr x14, 0xd10

    #Unmapped address 0x478 testing: random write/read operations
    #Address 0x478 Write value 0x63a3fbc7
    li x3, 0x63a3fbc7
    csrw 0x478, x3

    #Address 0x478 Write value 0x836643fa
    li x3, 0x836643fa
    csrw 0x478, x3

    #Address 0x478 Write value 0x137ed6c2
    li x3, 0x137ed6c2
    csrw 0x478, x3

    #Address 0x478 Write value 0xc01c181c
    li x3, 0xc01c181c
    csrw 0x478, x3

    #Unmapped address 0x72d testing: random write/read operations
    #Address 0x72d Write value 0x18d77cc
    li x3, 0x18d77cc
    csrw 0x72d, x3

    #Address 0x72d Write value 0x4de0b1ea
    li x3, 0x4de0b1ea
    csrw 0x72d, x3

    #Address 0x72d Write value 0x88512ab6
    li x3, 0x88512ab6
    csrw 0x72d, x3

    #Address 0x72d read value
    csrr x14, 0x72d

    #Address 0x72d Write value 0xb72afb39
    li x3, 0xb72afb39
    csrw 0x72d, x3

    #Unmapped address 0x515 testing: random write/read operations
    #Address 0x515 read value
    csrr x14, 0x515

    #Address 0x515 Write value 0xaf2db566
    li x3, 0xaf2db566
    csrw 0x515, x3

    #Address 0x515 Write value 0x34aa66df
    li x3, 0x34aa66df
    csrw 0x515, x3

    #Unmapped address 0xb6f testing: random write/read operations
    #Address 0xb6f read value
    csrr x14, 0xb6f

    #Unmapped address 0xbb4 testing: random write/read operations
    #Address 0xbb4 read value
    csrr x14, 0xbb4

    #Address 0xbb4 read value
    csrr x14, 0xbb4

    #Unmapped address 0xd8a testing: random write/read operations
    #Address 0xd8a read value
    csrr x14, 0xd8a

    #Address 0xd8a read value
    csrr x14, 0xd8a

    #Address 0xd8a read value
    csrr x14, 0xd8a

    #Unmapped address 0x759 testing: random write/read operations
    #Address 0x759 read value
    csrr x14, 0x759

    #Address 0x759 Write value 0x90da899
    li x3, 0x90da899
    csrw 0x759, x3

    #Address 0x759 read value
    csrr x14, 0x759

    #Address 0x759 Write value 0xefc6a85b
    li x3, 0xefc6a85b
    csrw 0x759, x3

    #Address 0x759 read value
    csrr x14, 0x759

    #Unmapped address 0x42a testing: random write/read operations
    #Address 0x42a read value
    csrr x14, 0x42a

    #Address 0x42a Write value 0x166a6c28
    li x3, 0x166a6c28
    csrw 0x42a, x3

    #Unmapped address 0x5f9 testing: random write/read operations
    #Address 0x5f9 Write value 0xbddc6c0c
    li x3, 0xbddc6c0c
    csrw 0x5f9, x3

    #Address 0x5f9 Write value 0x470c6ebd
    li x3, 0x470c6ebd
    csrw 0x5f9, x3

    #Address 0x5f9 Write value 0x14c13cc0
    li x3, 0x14c13cc0
    csrw 0x5f9, x3

    #Address 0x5f9 read value
    csrr x14, 0x5f9

    #Unmapped address 0x841 testing: random write/read operations
    #Address 0x841 read value
    csrr x14, 0x841

    #Unmapped address 0x46 testing: random write/read operations
    #Address 0x46 read value
    csrr x14, 0x46

    #Address 0x46 read value
    csrr x14, 0x46

    #Unmapped address 0x7b7 testing: random write/read operations
    #Address 0x7b7 Write value 0xe872a240
    li x3, 0xe872a240
    csrw 0x7b7, x3

    #Address 0x7b7 Write value 0x62936e98
    li x3, 0x62936e98
    csrw 0x7b7, x3

    #Address 0x7b7 Write value 0xe86a4524
    li x3, 0xe86a4524
    csrw 0x7b7, x3

    #Address 0x7b7 read value
    csrr x14, 0x7b7

    #Unmapped address 0x7d0 testing: random write/read operations
    #Address 0x7d0 Write value 0xb4768b31
    li x3, 0xb4768b31
    csrw 0x7d0, x3

    #Address 0x7d0 Write value 0x70ff0405
    li x3, 0x70ff0405
    csrw 0x7d0, x3

    #Unmapped address 0xb21 testing: random write/read operations
    #Address 0xb21 Write value 0xe4c50760
    li x3, 0xe4c50760
    csrw 0xb21, x3

    #Address 0xb21 read value
    csrr x14, 0xb21

    #Unmapped address 0xa62 testing: random write/read operations
    #Address 0xa62 Write value 0xf168a71b
    li x3, 0xf168a71b
    csrw 0xa62, x3

    #Address 0xa62 read value
    csrr x14, 0xa62

    #Address 0xa62 read value
    csrr x14, 0xa62

    #Address 0xa62 Write value 0x85b7c4ec
    li x3, 0x85b7c4ec
    csrw 0xa62, x3

    #Address 0xa62 Write value 0xe145d689
    li x3, 0xe145d689
    csrw 0xa62, x3

    #Unmapped address 0x4b testing: random write/read operations
    #Address 0x4b Write value 0xe81a98a
    li x3, 0xe81a98a
    csrw 0x4b, x3

    #Address 0x4b read value
    csrr x14, 0x4b

    #Address 0x4b Write value 0xda69e58c
    li x3, 0xda69e58c
    csrw 0x4b, x3

    #Address 0x4b Write value 0xcabfb7fb
    li x3, 0xcabfb7fb
    csrw 0x4b, x3

    #Address 0x4b Write value 0xeb887e5c
    li x3, 0xeb887e5c
    csrw 0x4b, x3

    #Unmapped address 0x399 testing: random write/read operations
    #Address 0x399 Write value 0x8c10e66c
    li x3, 0x8c10e66c
    csrw 0x399, x3

    #Address 0x399 read value
    csrr x14, 0x399

    #Address 0x399 Write value 0x5fc2d353
    li x3, 0x5fc2d353
    csrw 0x399, x3

    #Address 0x399 Write value 0x63d135a4
    li x3, 0x63d135a4
    csrw 0x399, x3

    #Address 0x399 Write value 0xdb10fe32
    li x3, 0xdb10fe32
    csrw 0x399, x3

    #Unmapped address 0x180 testing: random write/read operations
    #Address 0x180 Write value 0x88aef0c5
    li x3, 0x88aef0c5
    csrw 0x180, x3

    #Unmapped address 0xd5b testing: random write/read operations
    #Address 0xd5b read value
    csrr x14, 0xd5b

    #Address 0xd5b read value
    csrr x14, 0xd5b

    #Unmapped address 0x896 testing: random write/read operations
    #Address 0x896 read value
    csrr x14, 0x896

    #Address 0x896 Write value 0xa707f5f3
    li x3, 0xa707f5f3
    csrw 0x896, x3

    #Address 0x896 read value
    csrr x14, 0x896

    #Address 0x896 Write value 0x6fa73e9
    li x3, 0x6fa73e9
    csrw 0x896, x3

    #Unmapped address 0xd20 testing: random write/read operations
    #Address 0xd20 Write value 0x6046252b
    li x3, 0x6046252b
    csrw 0xd20, x3

    #Address 0xd20 read value
    csrr x14, 0xd20

    #Address 0xd20 Write value 0x83e04108
    li x3, 0x83e04108
    csrw 0xd20, x3

    #Address 0xd20 read value
    csrr x14, 0xd20

    #Unmapped address 0xd29 testing: random write/read operations
    #Address 0xd29 read value
    csrr x14, 0xd29

    #Address 0xd29 read value
    csrr x14, 0xd29

    #Address 0xd29 read value
    csrr x14, 0xd29

    #Unmapped address 0xe0e testing: random write/read operations
    #Address 0xe0e Write value 0x91733d9
    li x3, 0x91733d9
    csrw 0xe0e, x3

    #Address 0xe0e read value
    csrr x14, 0xe0e

    #Address 0xe0e Write value 0x6d47cce6
    li x3, 0x6d47cce6
    csrw 0xe0e, x3

    #Address 0xe0e read value
    csrr x14, 0xe0e

    #Unmapped address 0xba1 testing: random write/read operations
    #Address 0xba1 read value
    csrr x14, 0xba1

    #Address 0xba1 read value
    csrr x14, 0xba1

    #Unmapped address 0xa4b testing: random write/read operations
    #Address 0xa4b read value
    csrr x14, 0xa4b

    #Address 0xa4b read value
    csrr x14, 0xa4b

    #Address 0xa4b read value
    csrr x14, 0xa4b

    #Address 0xa4b read value
    csrr x14, 0xa4b

    #Address 0xa4b Write value 0xeb577ace
    li x3, 0xeb577ace
    csrw 0xa4b, x3

    #Unmapped address 0x1bf testing: random write/read operations
    #Address 0x1bf read value
    csrr x14, 0x1bf

    #Address 0x1bf read value
    csrr x14, 0x1bf

    #Address 0x1bf Write value 0x399e6192
    li x3, 0x399e6192
    csrw 0x1bf, x3

    #Unmapped address 0xd3b testing: random write/read operations
    #Address 0xd3b read value
    csrr x14, 0xd3b

    #Unmapped address 0xaf7 testing: random write/read operations
    #Address 0xaf7 Write value 0xb2e52a93
    li x3, 0xb2e52a93
    csrw 0xaf7, x3

    #Address 0xaf7 read value
    csrr x14, 0xaf7

    #Address 0xaf7 Write value 0x710e1e5f
    li x3, 0x710e1e5f
    csrw 0xaf7, x3

    #Unmapped address 0x115 testing: random write/read operations
    #Address 0x115 Write value 0x957a768b
    li x3, 0x957a768b
    csrw 0x115, x3

    #Address 0x115 read value
    csrr x14, 0x115

    #Unmapped address 0xeb8 testing: random write/read operations
    #Address 0xeb8 Write value 0xd62326b9
    li x3, 0xd62326b9
    csrw 0xeb8, x3

    #Address 0xeb8 read value
    csrr x14, 0xeb8

    #Address 0xeb8 read value
    csrr x14, 0xeb8

    #Address 0xeb8 Write value 0x94ce613b
    li x3, 0x94ce613b
    csrw 0xeb8, x3

    #Unmapped address 0x198 testing: random write/read operations
    #Address 0x198 read value
    csrr x14, 0x198

    #Address 0x198 read value
    csrr x14, 0x198

    #Unmapped address 0xbb8 testing: random write/read operations
    #Address 0xbb8 Write value 0xe5d424f6
    li x3, 0xe5d424f6
    csrw 0xbb8, x3

    #Address 0xbb8 Write value 0x748d178
    li x3, 0x748d178
    csrw 0xbb8, x3

    #Address 0xbb8 read value
    csrr x14, 0xbb8

    #Address 0xbb8 Write value 0x7919e28e
    li x3, 0x7919e28e
    csrw 0xbb8, x3

    #Unmapped address 0xc42 testing: random write/read operations
    #Address 0xc42 read value
    csrr x14, 0xc42

    #Address 0xc42 Write value 0xccb6d746
    li x3, 0xccb6d746
    csrw 0xc42, x3

    #Unmapped address 0x1d1 testing: random write/read operations
    #Address 0x1d1 Write value 0x673bca6e
    li x3, 0x673bca6e
    csrw 0x1d1, x3

    #Address 0x1d1 Write value 0xf8cc556
    li x3, 0xf8cc556
    csrw 0x1d1, x3

    #Unmapped address 0x71f testing: random write/read operations
    #Address 0x71f Write value 0x7c27fe98
    li x3, 0x7c27fe98
    csrw 0x71f, x3

    #Address 0x71f read value
    csrr x14, 0x71f

    #Address 0x71f read value
    csrr x14, 0x71f

    #Address 0x71f Write value 0xcdfe9863
    li x3, 0xcdfe9863
    csrw 0x71f, x3

    #Unmapped address 0x77d testing: random write/read operations
    #Address 0x77d Write value 0xf7a3acd8
    li x3, 0xf7a3acd8
    csrw 0x77d, x3

    #Address 0x77d Write value 0x65fb2658
    li x3, 0x65fb2658
    csrw 0x77d, x3

    #Address 0x77d Write value 0xbea057b
    li x3, 0xbea057b
    csrw 0x77d, x3

    #Unmapped address 0x992 testing: random write/read operations
    #Address 0x992 read value
    csrr x14, 0x992

    #Address 0x992 read value
    csrr x14, 0x992

    #Address 0x992 Write value 0x42a6e76e
    li x3, 0x42a6e76e
    csrw 0x992, x3

    #Address 0x992 read value
    csrr x14, 0x992

    #Unmapped address 0x7fe testing: random write/read operations
    #Address 0x7fe read value
    csrr x14, 0x7fe

    #Unmapped address 0x5c3 testing: random write/read operations
    #Address 0x5c3 Write value 0x8286b484
    li x3, 0x8286b484
    csrw 0x5c3, x3

    #Unmapped address 0x752 testing: random write/read operations
    #Address 0x752 read value
    csrr x14, 0x752

    #Unmapped address 0x708 testing: random write/read operations
    #Address 0x708 read value
    csrr x14, 0x708

    #Address 0x708 Write value 0x97cd9f97
    li x3, 0x97cd9f97
    csrw 0x708, x3

    #Unmapped address 0xa31 testing: random write/read operations
    #Address 0xa31 Write value 0xe34214f8
    li x3, 0xe34214f8
    csrw 0xa31, x3

    #Address 0xa31 Write value 0x512d33fe
    li x3, 0x512d33fe
    csrw 0xa31, x3

    #Address 0xa31 Write value 0xe3bb05ec
    li x3, 0xe3bb05ec
    csrw 0xa31, x3

    #Address 0xa31 Write value 0xb916d0e1
    li x3, 0xb916d0e1
    csrw 0xa31, x3

    #Unmapped address 0xe9f testing: random write/read operations
    #Address 0xe9f Write value 0xb03e955c
    li x3, 0xb03e955c
    csrw 0xe9f, x3

    #Address 0xe9f Write value 0xb7974d3f
    li x3, 0xb7974d3f
    csrw 0xe9f, x3

    #Unmapped address 0x30e testing: random write/read operations
    #Address 0x30e Write value 0xea9ab39a
    li x3, 0xea9ab39a
    csrw 0x30e, x3

    #Address 0x30e Write value 0x7a4c6dbf
    li x3, 0x7a4c6dbf
    csrw 0x30e, x3

    #Address 0x30e read value
    csrr x14, 0x30e

    #Address 0x30e Write value 0xe53d4cf7
    li x3, 0xe53d4cf7
    csrw 0x30e, x3

    #Unmapped address 0x78b testing: random write/read operations
    #Address 0x78b Write value 0x5b6e1ddb
    li x3, 0x5b6e1ddb
    csrw 0x78b, x3

    #Unmapped address 0x7a4 testing: random write/read operations
    #Address 0x7a4 read value
    csrr x14, 0x7a4

    #Unmapped address 0xe5a testing: random write/read operations
    #Address 0xe5a read value
    csrr x14, 0xe5a

    #Unmapped address 0x3ad testing: random write/read operations
    #Address 0x3ad Write value 0x3e42ce0c
    li x3, 0x3e42ce0c
    csrw 0x3ad, x3

    #Address 0x3ad read value
    csrr x14, 0x3ad

    #Address 0x3ad Write value 0xab19b4f1
    li x3, 0xab19b4f1
    csrw 0x3ad, x3

    #Address 0x3ad Write value 0x5385dde6
    li x3, 0x5385dde6
    csrw 0x3ad, x3

    #Address 0x3ad Write value 0xc77cf151
    li x3, 0xc77cf151
    csrw 0x3ad, x3

    #Unmapped address 0xd61 testing: random write/read operations
    #Address 0xd61 read value
    csrr x14, 0xd61

    #Address 0xd61 read value
    csrr x14, 0xd61

    #Address 0xd61 read value
    csrr x14, 0xd61

    #Unmapped address 0x6bd testing: random write/read operations
    #Address 0x6bd Write value 0xe7f5367e
    li x3, 0xe7f5367e
    csrw 0x6bd, x3

    #Address 0x6bd read value
    csrr x14, 0x6bd

    #Address 0x6bd Write value 0x46e96a51
    li x3, 0x46e96a51
    csrw 0x6bd, x3

    #Unmapped address 0x674 testing: random write/read operations
    #Address 0x674 read value
    csrr x14, 0x674

    #Unmapped address 0xdc2 testing: random write/read operations
    #Address 0xdc2 Write value 0xf8a9d088
    li x3, 0xf8a9d088
    csrw 0xdc2, x3

    #Address 0xdc2 Write value 0x87c3deab
    li x3, 0x87c3deab
    csrw 0xdc2, x3

    #Address 0xdc2 read value
    csrr x14, 0xdc2

    #Address 0xdc2 Write value 0x24ea30d9
    li x3, 0x24ea30d9
    csrw 0xdc2, x3

    #Unmapped address 0x29c testing: random write/read operations
    #Address 0x29c read value
    csrr x14, 0x29c

    #Address 0x29c Write value 0x3bd2847d
    li x3, 0x3bd2847d
    csrw 0x29c, x3

    #Address 0x29c read value
    csrr x14, 0x29c

    #Address 0x29c read value
    csrr x14, 0x29c

    #Unmapped address 0x31a testing: random write/read operations
    #Address 0x31a read value
    csrr x14, 0x31a

    #Address 0x31a read value
    csrr x14, 0x31a

    #Address 0x31a Write value 0x8a359bf7
    li x3, 0x8a359bf7
    csrw 0x31a, x3

    #Address 0x31a Write value 0x766590f0
    li x3, 0x766590f0
    csrw 0x31a, x3

    #Address 0x31a read value
    csrr x14, 0x31a

    #Unmapped address 0x703 testing: random write/read operations
    #Address 0x703 read value
    csrr x14, 0x703

    #Address 0x703 read value
    csrr x14, 0x703

    #Address 0x703 Write value 0xf4cd814d
    li x3, 0xf4cd814d
    csrw 0x703, x3

    #Address 0x703 read value
    csrr x14, 0x703

    #Address 0x703 Write value 0x60ba6410
    li x3, 0x60ba6410
    csrw 0x703, x3

    #Unmapped address 0x5c7 testing: random write/read operations
    #Address 0x5c7 read value
    csrr x14, 0x5c7

    #Unmapped address 0x75e testing: random write/read operations
    #Address 0x75e Write value 0x3a8912d7
    li x3, 0x3a8912d7
    csrw 0x75e, x3

    #Address 0x75e read value
    csrr x14, 0x75e

    #Address 0x75e Write value 0xbe8ea57c
    li x3, 0xbe8ea57c
    csrw 0x75e, x3

    #Address 0x75e Write value 0xd9b00c4b
    li x3, 0xd9b00c4b
    csrw 0x75e, x3

    #Unmapped address 0xaa1 testing: random write/read operations
    #Address 0xaa1 read value
    csrr x14, 0xaa1

    #Address 0xaa1 read value
    csrr x14, 0xaa1

    #Address 0xaa1 read value
    csrr x14, 0xaa1

    #Address 0xaa1 Write value 0x9f038a80
    li x3, 0x9f038a80
    csrw 0xaa1, x3

    #Unmapped address 0x592 testing: random write/read operations
    #Address 0x592 Write value 0x14c9d450
    li x3, 0x14c9d450
    csrw 0x592, x3

    #Unmapped address 0x167 testing: random write/read operations
    #Address 0x167 read value
    csrr x14, 0x167

    #Unmapped address 0x490 testing: random write/read operations
    #Address 0x490 Write value 0xa4b0c2dc
    li x3, 0xa4b0c2dc
    csrw 0x490, x3

    #Unmapped address 0xaab testing: random write/read operations
    #Address 0xaab read value
    csrr x14, 0xaab

    #Mapped address 0x32b (mhpmevent11) testing: random write/read operations
    #Address 0x32b Write value 0xf364d0f6
    li x3, 0xf364d0f6
    csrw 0x32b, x3

    #Address 0x32b Write value 0x2209e9f2
    li x3, 0x2209e9f2
    csrw 0x32b, x3

    #Address 0x32b read value
    csrr x14, 0x32b

    #Address 0x32b read value
    csrr x14, 0x32b

    #Address 0x32b read value
    csrr x14, 0x32b

    #Unmapped address 0x199 testing: random write/read operations
    #Address 0x199 read value
    csrr x14, 0x199

    #Unmapped address 0xbe0 testing: random write/read operations
    #Address 0xbe0 read value
    csrr x14, 0xbe0

    #Address 0xbe0 read value
    csrr x14, 0xbe0

    #Unmapped address 0xc66 testing: random write/read operations
    #Address 0xc66 read value
    csrr x14, 0xc66

    #Address 0xc66 read value
    csrr x14, 0xc66

    #Address 0xc66 read value
    csrr x14, 0xc66

    #Address 0xc66 Write value 0x7c392600
    li x3, 0x7c392600
    csrw 0xc66, x3

    #Unmapped address 0x412 testing: random write/read operations
    #Address 0x412 read value
    csrr x14, 0x412

    #Address 0x412 Write value 0x48d36017
    li x3, 0x48d36017
    csrw 0x412, x3

    #Address 0x412 Write value 0x45fbff67
    li x3, 0x45fbff67
    csrw 0x412, x3

    #Address 0x412 Write value 0xb0c21fe5
    li x3, 0xb0c21fe5
    csrw 0x412, x3

    #Unmapped address 0xf3c testing: random write/read operations
    #Address 0xf3c Write value 0x2bb88dc4
    li x3, 0x2bb88dc4
    csrw 0xf3c, x3

    #Address 0xf3c read value
    csrr x14, 0xf3c

    #Unmapped address 0x921 testing: random write/read operations
    #Address 0x921 read value
    csrr x14, 0x921

    #Address 0x921 Write value 0xd609b3a4
    li x3, 0xd609b3a4
    csrw 0x921, x3

    #Address 0x921 read value
    csrr x14, 0x921

    #Unmapped address 0xba3 testing: random write/read operations
    #Address 0xba3 read value
    csrr x14, 0xba3

    #Address 0xba3 read value
    csrr x14, 0xba3

    #Address 0xba3 Write value 0xf659a78c
    li x3, 0xf659a78c
    csrw 0xba3, x3

    #Address 0xba3 read value
    csrr x14, 0xba3

    #Unmapped address 0x36b testing: random write/read operations
    #Address 0x36b Write value 0x7637d7
    li x3, 0x7637d7
    csrw 0x36b, x3

    #Address 0x36b read value
    csrr x14, 0x36b

    #Address 0x36b read value
    csrr x14, 0x36b

    #Address 0x36b read value
    csrr x14, 0x36b

    #Address 0x36b Write value 0x902f522f
    li x3, 0x902f522f
    csrw 0x36b, x3

    #Unmapped address 0xa5d testing: random write/read operations
    #Address 0xa5d Write value 0xa297d12f
    li x3, 0xa297d12f
    csrw 0xa5d, x3

    #Address 0xa5d Write value 0xbe140489
    li x3, 0xbe140489
    csrw 0xa5d, x3

    #Unmapped address 0x9c3 testing: random write/read operations
    #Address 0x9c3 Write value 0x7b8f696f
    li x3, 0x7b8f696f
    csrw 0x9c3, x3

    #Address 0x9c3 read value
    csrr x14, 0x9c3

    #Address 0x9c3 Write value 0xa14f4575
    li x3, 0xa14f4575
    csrw 0x9c3, x3

    #Unmapped address 0x837 testing: random write/read operations
    #Address 0x837 read value
    csrr x14, 0x837

    #Address 0x837 read value
    csrr x14, 0x837

    #Address 0x837 read value
    csrr x14, 0x837

    #Address 0x837 read value
    csrr x14, 0x837

    #Unmapped address 0x54d testing: random write/read operations
    #Address 0x54d Write value 0x89db538
    li x3, 0x89db538
    csrw 0x54d, x3

    #Address 0x54d read value
    csrr x14, 0x54d

    #Address 0x54d Write value 0x473a20a
    li x3, 0x473a20a
    csrw 0x54d, x3

    #Unmapped address 0xf8c testing: random write/read operations
    #Address 0xf8c read value
    csrr x14, 0xf8c

    #Address 0xf8c read value
    csrr x14, 0xf8c

    #Address 0xf8c Write value 0xb5706bbc
    li x3, 0xb5706bbc
    csrw 0xf8c, x3

    #Address 0xf8c Write value 0xa6d6db36
    li x3, 0xa6d6db36
    csrw 0xf8c, x3

    #Unmapped address 0xed6 testing: random write/read operations
    #Address 0xed6 read value
    csrr x14, 0xed6

    #Address 0xed6 Write value 0x5ffc0859
    li x3, 0x5ffc0859
    csrw 0xed6, x3

    #Address 0xed6 read value
    csrr x14, 0xed6

    #Address 0xed6 read value
    csrr x14, 0xed6

    #Address 0xed6 Write value 0x5f20c355
    li x3, 0x5f20c355
    csrw 0xed6, x3

    #Unmapped address 0xf24 testing: random write/read operations
    #Address 0xf24 read value
    csrr x14, 0xf24

    #Address 0xf24 Write value 0x58e17c07
    li x3, 0x58e17c07
    csrw 0xf24, x3

    #Address 0xf24 Write value 0xf410096b
    li x3, 0xf410096b
    csrw 0xf24, x3

    #Unmapped address 0x61a testing: random write/read operations
    #Address 0x61a Write value 0xced80bb6
    li x3, 0xced80bb6
    csrw 0x61a, x3

    #Address 0x61a read value
    csrr x14, 0x61a

    #Unmapped address 0x3ed testing: random write/read operations
    #Address 0x3ed Write value 0x9d135582
    li x3, 0x9d135582
    csrw 0x3ed, x3

    #Address 0x3ed read value
    csrr x14, 0x3ed

    #Unmapped address 0x186 testing: random write/read operations
    #Address 0x186 read value
    csrr x14, 0x186

    #Address 0x186 read value
    csrr x14, 0x186

    #Address 0x186 read value
    csrr x14, 0x186

    #Address 0x186 Write value 0x3464a296
    li x3, 0x3464a296
    csrw 0x186, x3

    #Unmapped address 0x1e5 testing: random write/read operations
    #Address 0x1e5 Write value 0xc347ca98
    li x3, 0xc347ca98
    csrw 0x1e5, x3

    #Address 0x1e5 Write value 0x734072fd
    li x3, 0x734072fd
    csrw 0x1e5, x3

    #Unmapped address 0xedf testing: random write/read operations
    #Address 0xedf read value
    csrr x14, 0xedf

    #Unmapped address 0x446 testing: random write/read operations
    #Address 0x446 Write value 0xe2b3bda
    li x3, 0xe2b3bda
    csrw 0x446, x3

    #Unmapped address 0x86f testing: random write/read operations
    #Address 0x86f read value
    csrr x14, 0x86f

    #Address 0x86f read value
    csrr x14, 0x86f

    #Unmapped address 0x524 testing: random write/read operations
    #Address 0x524 read value
    csrr x14, 0x524

    #Address 0x524 read value
    csrr x14, 0x524

    #Unmapped address 0x7db testing: random write/read operations
    #Address 0x7db Write value 0xf8ec5184
    li x3, 0xf8ec5184
    csrw 0x7db, x3

    #Unmapped address 0xe79 testing: random write/read operations
    #Address 0xe79 read value
    csrr x14, 0xe79

    #Address 0xe79 read value
    csrr x14, 0xe79

    #Address 0xe79 read value
    csrr x14, 0xe79

    #Address 0xe79 Write value 0x859cfba9
    li x3, 0x859cfba9
    csrw 0xe79, x3

    #Unmapped address 0xc71 testing: random write/read operations
    #Address 0xc71 Write value 0x3f7352a
    li x3, 0x3f7352a
    csrw 0xc71, x3

    #Address 0xc71 read value
    csrr x14, 0xc71

    #Address 0xc71 read value
    csrr x14, 0xc71

    #Unmapped address 0x503 testing: random write/read operations
    #Address 0x503 Write value 0x73443df3
    li x3, 0x73443df3
    csrw 0x503, x3

    #Address 0x503 Write value 0xbe57ed7e
    li x3, 0xbe57ed7e
    csrw 0x503, x3

    #Address 0x503 Write value 0xcf63ce81
    li x3, 0xcf63ce81
    csrw 0x503, x3

    #Unmapped address 0x65 testing: random write/read operations
    #Address 0x65 read value
    csrr x14, 0x65

    #Address 0x65 Write value 0x8165b9c3
    li x3, 0x8165b9c3
    csrw 0x65, x3

    #Mapped address 0xb07 (mhpmcounter7) testing: random write/read operations
    #Address 0xb07 Write value 0x627c14fe
    li x3, 0x627c14fe
    csrw 0xb07, x3

    #Address 0xb07 read value
    csrr x14, 0xb07

    #Unmapped address 0x45d testing: random write/read operations
    #Address 0x45d Write value 0xdb1c8df6
    li x3, 0xdb1c8df6
    csrw 0x45d, x3

    #Address 0x45d Write value 0xaa2ab73a
    li x3, 0xaa2ab73a
    csrw 0x45d, x3

    #Address 0x45d read value
    csrr x14, 0x45d

    #Address 0x45d Write value 0xd68e592f
    li x3, 0xd68e592f
    csrw 0x45d, x3

    #Unmapped address 0xef1 testing: random write/read operations
    #Address 0xef1 read value
    csrr x14, 0xef1

    #Unmapped address 0xf19 testing: random write/read operations
    #Address 0xf19 Write value 0x5bf9e31d
    li x3, 0x5bf9e31d
    csrw 0xf19, x3

    #Unmapped address 0x682 testing: random write/read operations
    #Address 0x682 Write value 0x4be064e9
    li x3, 0x4be064e9
    csrw 0x682, x3

    #Address 0x682 read value
    csrr x14, 0x682

    #Unmapped address 0x2c5 testing: random write/read operations
    #Address 0x2c5 read value
    csrr x14, 0x2c5

    #Address 0x2c5 read value
    csrr x14, 0x2c5

    #Address 0x2c5 read value
    csrr x14, 0x2c5

    #Address 0x2c5 Write value 0xbfbb6ca0
    li x3, 0xbfbb6ca0
    csrw 0x2c5, x3

    #Address 0x2c5 read value
    csrr x14, 0x2c5

    #Unmapped address 0x654 testing: random write/read operations
    #Address 0x654 read value
    csrr x14, 0x654

    #Unmapped address 0x6fc testing: random write/read operations
    #Address 0x6fc Write value 0x2e5b5daa
    li x3, 0x2e5b5daa
    csrw 0x6fc, x3

    #Unmapped address 0x504 testing: random write/read operations
    #Address 0x504 Write value 0x2866c081
    li x3, 0x2866c081
    csrw 0x504, x3

    #Address 0x504 Write value 0x6652c5a3
    li x3, 0x6652c5a3
    csrw 0x504, x3

    #Address 0x504 Write value 0xc3588854
    li x3, 0xc3588854
    csrw 0x504, x3

    #Address 0x504 Write value 0x5e12ebf
    li x3, 0x5e12ebf
    csrw 0x504, x3

    #Unmapped address 0x508 testing: random write/read operations
    #Address 0x508 Write value 0x14ba990e
    li x3, 0x14ba990e
    csrw 0x508, x3

    #Address 0x508 Write value 0xd81c2d87
    li x3, 0xd81c2d87
    csrw 0x508, x3

    #Address 0x508 Write value 0x42b9d868
    li x3, 0x42b9d868
    csrw 0x508, x3

    #Address 0x508 Write value 0x953b8ffc
    li x3, 0x953b8ffc
    csrw 0x508, x3

    #Unmapped address 0xc36 testing: random write/read operations
    #Address 0xc36 read value
    csrr x14, 0xc36

    #Unmapped address 0xa0c testing: random write/read operations
    #Address 0xa0c read value
    csrr x14, 0xa0c

    #Address 0xa0c read value
    csrr x14, 0xa0c

    #Address 0xa0c Write value 0x757dbbe5
    li x3, 0x757dbbe5
    csrw 0xa0c, x3

    #Unmapped address 0x168 testing: random write/read operations
    #Address 0x168 read value
    csrr x14, 0x168

    #Address 0x168 read value
    csrr x14, 0x168

    #Unmapped address 0x81d testing: random write/read operations
    #Address 0x81d Write value 0x4a4eef71
    li x3, 0x4a4eef71
    csrw 0x81d, x3

    #Address 0x81d Write value 0x20f8c9b1
    li x3, 0x20f8c9b1
    csrw 0x81d, x3

    #Address 0x81d Write value 0xfc47d016
    li x3, 0xfc47d016
    csrw 0x81d, x3

    #Address 0x81d Write value 0xa3949ab5
    li x3, 0xa3949ab5
    csrw 0x81d, x3

    #Address 0x81d Write value 0xdeb38941
    li x3, 0xdeb38941
    csrw 0x81d, x3

    #Mapped address 0xb96 (mhpmcounterh22) testing: random write/read operations
    #Address 0xb96 Write value 0x114fe566
    li x3, 0x114fe566
    csrw 0xb96, x3

    #Unmapped address 0xa57 testing: random write/read operations
    #Address 0xa57 read value
    csrr x14, 0xa57

    #Address 0xa57 Write value 0xfc354585
    li x3, 0xfc354585
    csrw 0xa57, x3

    #Unmapped address 0xc8c testing: random write/read operations
    #Address 0xc8c read value
    csrr x14, 0xc8c

    #Address 0xc8c Write value 0x70eba141
    li x3, 0x70eba141
    csrw 0xc8c, x3

    #Address 0xc8c Write value 0x97911305
    li x3, 0x97911305
    csrw 0xc8c, x3

    #Address 0xc8c Write value 0x4e7d1b2f
    li x3, 0x4e7d1b2f
    csrw 0xc8c, x3

    #Unmapped address 0x54f testing: random write/read operations
    #Address 0x54f read value
    csrr x14, 0x54f

    #Address 0x54f Write value 0x8096d77b
    li x3, 0x8096d77b
    csrw 0x54f, x3

    #Address 0x54f Write value 0x36109337
    li x3, 0x36109337
    csrw 0x54f, x3

    #Unmapped address 0x82a testing: random write/read operations
    #Address 0x82a Write value 0xb02efb64
    li x3, 0xb02efb64
    csrw 0x82a, x3

    #Unmapped address 0x750 testing: random write/read operations
    #Address 0x750 Write value 0x5ceba5a7
    li x3, 0x5ceba5a7
    csrw 0x750, x3

    #Address 0x750 Write value 0xe0eb7724
    li x3, 0xe0eb7724
    csrw 0x750, x3

    #Unmapped address 0x6d8 testing: random write/read operations
    #Address 0x6d8 read value
    csrr x14, 0x6d8

    #Address 0x6d8 read value
    csrr x14, 0x6d8

    #Address 0x6d8 Write value 0xeef7ac5e
    li x3, 0xeef7ac5e
    csrw 0x6d8, x3

    #Address 0x6d8 Write value 0xb1c8b2
    li x3, 0xb1c8b2
    csrw 0x6d8, x3

    #Address 0x6d8 Write value 0x88f1512f
    li x3, 0x88f1512f
    csrw 0x6d8, x3

    #Unmapped address 0x30f testing: random write/read operations
    #Address 0x30f read value
    csrr x14, 0x30f

    #Address 0x30f Write value 0x243d6ce7
    li x3, 0x243d6ce7
    csrw 0x30f, x3

    #Address 0x30f read value
    csrr x14, 0x30f

    #Address 0x30f Write value 0x29886528
    li x3, 0x29886528
    csrw 0x30f, x3

    #Address 0x30f read value
    csrr x14, 0x30f

    #Unmapped address 0x859 testing: random write/read operations
    #Address 0x859 read value
    csrr x14, 0x859

    #Unmapped address 0x34c testing: random write/read operations
    #Address 0x34c read value
    csrr x14, 0x34c

    #Address 0x34c Write value 0x5a0b3f04
    li x3, 0x5a0b3f04
    csrw 0x34c, x3

    #Mapped address 0xb1e (mhpmcounter30) testing: random write/read operations
    #Address 0xb1e read value
    csrr x14, 0xb1e

    #Mapped address 0x334 (mhpmevent20) testing: random write/read operations
    #Address 0x334 Write value 0x2b76b80c
    li x3, 0x2b76b80c
    csrw 0x334, x3

    #Unmapped address 0x91a testing: random write/read operations
    #Address 0x91a read value
    csrr x14, 0x91a

    #Address 0x91a read value
    csrr x14, 0x91a

    #Unmapped address 0xf32 testing: random write/read operations
    #Address 0xf32 Write value 0x545c49fc
    li x3, 0x545c49fc
    csrw 0xf32, x3

    #Unmapped address 0x78f testing: random write/read operations
    #Address 0x78f read value
    csrr x14, 0x78f

    #Unmapped address 0xec testing: random write/read operations
    #Address 0xec Write value 0x5ceddfdb
    li x3, 0x5ceddfdb
    csrw 0xec, x3

    #Address 0xec Write value 0x1e2c8339
    li x3, 0x1e2c8339
    csrw 0xec, x3

    #Address 0xec read value
    csrr x14, 0xec

    #Unmapped address 0x4e7 testing: random write/read operations
    #Address 0x4e7 read value
    csrr x14, 0x4e7

    #Unmapped address 0x6a7 testing: random write/read operations
    #Address 0x6a7 Write value 0x7e99f28f
    li x3, 0x7e99f28f
    csrw 0x6a7, x3

    #Address 0x6a7 read value
    csrr x14, 0x6a7

    #Address 0x6a7 Write value 0x6be26230
    li x3, 0x6be26230
    csrw 0x6a7, x3

    #Unmapped address 0x630 testing: random write/read operations
    #Address 0x630 read value
    csrr x14, 0x630

    #Address 0x630 Write value 0x6a8abd31
    li x3, 0x6a8abd31
    csrw 0x630, x3

    #Unmapped address 0xfda testing: random write/read operations
    #Address 0xfda read value
    csrr x14, 0xfda

    #Address 0xfda Write value 0x626d94b1
    li x3, 0x626d94b1
    csrw 0xfda, x3

    #Address 0xfda read value
    csrr x14, 0xfda

    #Address 0xfda Write value 0x579036ee
    li x3, 0x579036ee
    csrw 0xfda, x3

    #Address 0xfda Write value 0x3a7a8c3a
    li x3, 0x3a7a8c3a
    csrw 0xfda, x3

    #Unmapped address 0x665 testing: random write/read operations
    #Address 0x665 Write value 0x2f638ae8
    li x3, 0x2f638ae8
    csrw 0x665, x3

    #Address 0x665 Write value 0xf5dd3e2c
    li x3, 0xf5dd3e2c
    csrw 0x665, x3

    #Address 0x665 Write value 0xcd9e6f9e
    li x3, 0xcd9e6f9e
    csrw 0x665, x3

    #Unmapped address 0xd55 testing: random write/read operations
    #Address 0xd55 Write value 0x6f27328
    li x3, 0x6f27328
    csrw 0xd55, x3

    #Address 0xd55 Write value 0xf69e2632
    li x3, 0xf69e2632
    csrw 0xd55, x3

    #Address 0xd55 read value
    csrr x14, 0xd55

    #Address 0xd55 read value
    csrr x14, 0xd55

    #Unmapped address 0x379 testing: random write/read operations
    #Address 0x379 read value
    csrr x14, 0x379

    #Address 0x379 Write value 0xff5b7
    li x3, 0xff5b7
    csrw 0x379, x3

    #Address 0x379 Write value 0x94b23a46
    li x3, 0x94b23a46
    csrw 0x379, x3

    #Address 0x379 Write value 0x5c6cdc18
    li x3, 0x5c6cdc18
    csrw 0x379, x3

    #Address 0x379 Write value 0x66ba5123
    li x3, 0x66ba5123
    csrw 0x379, x3

    #Unmapped address 0x4a testing: random write/read operations
    #Address 0x4a read value
    csrr x14, 0x4a

    #Unmapped address 0xb2d testing: random write/read operations
    #Address 0xb2d read value
    csrr x14, 0xb2d

    #Unmapped address 0x944 testing: random write/read operations
    #Address 0x944 Write value 0x8d48f57c
    li x3, 0x8d48f57c
    csrw 0x944, x3

    #Address 0x944 read value
    csrr x14, 0x944

    #Address 0x944 read value
    csrr x14, 0x944

    #Address 0x944 Write value 0x214e59f1
    li x3, 0x214e59f1
    csrw 0x944, x3

    #Unmapped address 0x80e testing: random write/read operations
    #Address 0x80e Write value 0xbb431f70
    li x3, 0xbb431f70
    csrw 0x80e, x3

    #Unmapped address 0x92a testing: random write/read operations
    #Address 0x92a Write value 0x29e44d11
    li x3, 0x29e44d11
    csrw 0x92a, x3

    #Address 0x92a Write value 0x478da085
    li x3, 0x478da085
    csrw 0x92a, x3

    #Address 0x92a Write value 0x632ed9cd
    li x3, 0x632ed9cd
    csrw 0x92a, x3

    #Address 0x92a Write value 0x8e85d458
    li x3, 0x8e85d458
    csrw 0x92a, x3

    #Unmapped address 0x862 testing: random write/read operations
    #Address 0x862 read value
    csrr x14, 0x862

    #Address 0x862 read value
    csrr x14, 0x862

    #Address 0x862 Write value 0x1ce95b19
    li x3, 0x1ce95b19
    csrw 0x862, x3

    #Address 0x862 Write value 0x9e21c501
    li x3, 0x9e21c501
    csrw 0x862, x3

    #Unmapped address 0xfa9 testing: random write/read operations
    #Address 0xfa9 read value
    csrr x14, 0xfa9

    #Address 0xfa9 Write value 0xe3650787
    li x3, 0xe3650787
    csrw 0xfa9, x3

    #Address 0xfa9 Write value 0x8fd977f4
    li x3, 0x8fd977f4
    csrw 0xfa9, x3

    #Address 0xfa9 read value
    csrr x14, 0xfa9

    #Address 0xfa9 read value
    csrr x14, 0xfa9

    #Unmapped address 0x2cd testing: random write/read operations
    #Address 0x2cd Write value 0xb3ea67a4
    li x3, 0xb3ea67a4
    csrw 0x2cd, x3

    #Address 0x2cd read value
    csrr x14, 0x2cd

    #Address 0x2cd Write value 0xc792ecdb
    li x3, 0xc792ecdb
    csrw 0x2cd, x3

    #Address 0x2cd Write value 0x160f0ecb
    li x3, 0x160f0ecb
    csrw 0x2cd, x3

    #Unmapped address 0xe34 testing: random write/read operations
    #Address 0xe34 read value
    csrr x14, 0xe34

    #Address 0xe34 read value
    csrr x14, 0xe34

    #Unmapped address 0x669 testing: random write/read operations
    #Address 0x669 Write value 0x680897b3
    li x3, 0x680897b3
    csrw 0x669, x3

    #Address 0x669 read value
    csrr x14, 0x669

    #Address 0x669 Write value 0xb4bc717a
    li x3, 0xb4bc717a
    csrw 0x669, x3

    #Unmapped address 0x910 testing: random write/read operations
    #Address 0x910 read value
    csrr x14, 0x910

    #Address 0x910 read value
    csrr x14, 0x910

    #Unmapped address 0xaf5 testing: random write/read operations
    #Address 0xaf5 read value
    csrr x14, 0xaf5

    #Address 0xaf5 Write value 0x12da921c
    li x3, 0x12da921c
    csrw 0xaf5, x3

    #Address 0xaf5 Write value 0x3c7a34ce
    li x3, 0x3c7a34ce
    csrw 0xaf5, x3

    #Address 0xaf5 read value
    csrr x14, 0xaf5

    #Address 0xaf5 Write value 0x42f90def
    li x3, 0x42f90def
    csrw 0xaf5, x3

    #Unmapped address 0x8ca testing: random write/read operations
    #Address 0x8ca read value
    csrr x14, 0x8ca

    #Address 0x8ca Write value 0xc316de62
    li x3, 0xc316de62
    csrw 0x8ca, x3

    #Unmapped address 0xb59 testing: random write/read operations
    #Address 0xb59 Write value 0x63d505cc
    li x3, 0x63d505cc
    csrw 0xb59, x3

    #Address 0xb59 Write value 0x77344f78
    li x3, 0x77344f78
    csrw 0xb59, x3

    #Unmapped address 0x83a testing: random write/read operations
    #Address 0x83a read value
    csrr x14, 0x83a

    #Address 0x83a read value
    csrr x14, 0x83a

    #Address 0x83a read value
    csrr x14, 0x83a

    #Address 0x83a read value
    csrr x14, 0x83a

    #Address 0x83a Write value 0x55d6a478
    li x3, 0x55d6a478
    csrw 0x83a, x3

    #Unmapped address 0x3f6 testing: random write/read operations
    #Address 0x3f6 read value
    csrr x14, 0x3f6

    #Address 0x3f6 read value
    csrr x14, 0x3f6

    #Address 0x3f6 Write value 0xae90ce5a
    li x3, 0xae90ce5a
    csrw 0x3f6, x3

    #Address 0x3f6 Write value 0x1f62103e
    li x3, 0x1f62103e
    csrw 0x3f6, x3

    #Address 0x3f6 Write value 0x1781259d
    li x3, 0x1781259d
    csrw 0x3f6, x3

    #Unmapped address 0xe6a testing: random write/read operations
    #Address 0xe6a read value
    csrr x14, 0xe6a

    #Address 0xe6a read value
    csrr x14, 0xe6a

    #Address 0xe6a read value
    csrr x14, 0xe6a

    #Unmapped address 0x37c testing: random write/read operations
    #Address 0x37c read value
    csrr x14, 0x37c

    #Address 0x37c Write value 0xf12fe504
    li x3, 0xf12fe504
    csrw 0x37c, x3

    #Address 0x37c read value
    csrr x14, 0x37c

    #Unmapped address 0x91b testing: random write/read operations
    #Address 0x91b read value
    csrr x14, 0x91b

    #Address 0x91b Write value 0x8f69a245
    li x3, 0x8f69a245
    csrw 0x91b, x3

    #Address 0x91b read value
    csrr x14, 0x91b

    #Address 0x91b Write value 0x4eb98dd7
    li x3, 0x4eb98dd7
    csrw 0x91b, x3

    #Unmapped address 0xae7 testing: random write/read operations
    #Address 0xae7 read value
    csrr x14, 0xae7

    #Address 0xae7 Write value 0xd609df31
    li x3, 0xd609df31
    csrw 0xae7, x3

    #Unmapped address 0xe87 testing: random write/read operations
    #Address 0xe87 Write value 0xa141fb2e
    li x3, 0xa141fb2e
    csrw 0xe87, x3

    #Address 0xe87 Write value 0xcf56c35c
    li x3, 0xcf56c35c
    csrw 0xe87, x3

    #Address 0xe87 Write value 0xa319b275
    li x3, 0xa319b275
    csrw 0xe87, x3

    #Address 0xe87 read value
    csrr x14, 0xe87

    #Unmapped address 0x510 testing: random write/read operations
    #Address 0x510 read value
    csrr x14, 0x510

    #Address 0x510 Write value 0x3c71296c
    li x3, 0x3c71296c
    csrw 0x510, x3

    #Address 0x510 read value
    csrr x14, 0x510

    #Address 0x510 read value
    csrr x14, 0x510

    #Address 0x510 Write value 0xca06a949
    li x3, 0xca06a949
    csrw 0x510, x3

    #Unmapped address 0xfcb testing: random write/read operations
    #Address 0xfcb Write value 0xac6cf982
    li x3, 0xac6cf982
    csrw 0xfcb, x3

    #Address 0xfcb Write value 0x70fc0bd4
    li x3, 0x70fc0bd4
    csrw 0xfcb, x3

    #Address 0xfcb Write value 0x8884a90f
    li x3, 0x8884a90f
    csrw 0xfcb, x3

    #Unmapped address 0x28b testing: random write/read operations
    #Address 0x28b Write value 0x80b227c
    li x3, 0x80b227c
    csrw 0x28b, x3

    #Unmapped address 0xf76 testing: random write/read operations
    #Address 0xf76 read value
    csrr x14, 0xf76

    #Address 0xf76 read value
    csrr x14, 0xf76

    #Address 0xf76 read value
    csrr x14, 0xf76

    #Address 0xf76 Write value 0x2c61089d
    li x3, 0x2c61089d
    csrw 0xf76, x3

    #Unmapped address 0xa32 testing: random write/read operations
    #Address 0xa32 Write value 0xd5f5dcdb
    li x3, 0xd5f5dcdb
    csrw 0xa32, x3

    #Address 0xa32 Write value 0x54d91d0b
    li x3, 0x54d91d0b
    csrw 0xa32, x3

    #Address 0xa32 Write value 0x8b4df4
    li x3, 0x8b4df4
    csrw 0xa32, x3

    #Address 0xa32 Write value 0x1fb6f70e
    li x3, 0x1fb6f70e
    csrw 0xa32, x3

    #Unmapped address 0x431 testing: random write/read operations
    #Address 0x431 read value
    csrr x14, 0x431

    #Address 0x431 Write value 0x3bf19b65
    li x3, 0x3bf19b65
    csrw 0x431, x3

    #Address 0x431 Write value 0xa2a74c4
    li x3, 0xa2a74c4
    csrw 0x431, x3

    #Unmapped address 0x4b3 testing: random write/read operations
    #Address 0x4b3 read value
    csrr x14, 0x4b3

    #Address 0x4b3 read value
    csrr x14, 0x4b3

    #Address 0x4b3 read value
    csrr x14, 0x4b3

    #Unmapped address 0x62f testing: random write/read operations
    #Address 0x62f read value
    csrr x14, 0x62f

    #Address 0x62f Write value 0x90abd882
    li x3, 0x90abd882
    csrw 0x62f, x3

    #Address 0x62f Write value 0x20d24588
    li x3, 0x20d24588
    csrw 0x62f, x3

    #Address 0x62f Write value 0x21508286
    li x3, 0x21508286
    csrw 0x62f, x3

    #Unmapped address 0xad5 testing: random write/read operations
    #Address 0xad5 read value
    csrr x14, 0xad5

    #Address 0xad5 read value
    csrr x14, 0xad5

    #Address 0xad5 read value
    csrr x14, 0xad5

    #Address 0xad5 read value
    csrr x14, 0xad5

    #Unmapped address 0x107 testing: random write/read operations
    #Address 0x107 read value
    csrr x14, 0x107

    #Address 0x107 read value
    csrr x14, 0x107

    #Address 0x107 Write value 0x7d13dbb8
    li x3, 0x7d13dbb8
    csrw 0x107, x3

    #Address 0x107 Write value 0xf3ec4f9a
    li x3, 0xf3ec4f9a
    csrw 0x107, x3

    #Unmapped address 0x1e8 testing: random write/read operations
    #Address 0x1e8 read value
    csrr x14, 0x1e8

    #Address 0x1e8 read value
    csrr x14, 0x1e8

    #Unmapped address 0xb2a testing: random write/read operations
    #Address 0xb2a Write value 0x2f45b67e
    li x3, 0x2f45b67e
    csrw 0xb2a, x3

    #Address 0xb2a read value
    csrr x14, 0xb2a

    #Address 0xb2a read value
    csrr x14, 0xb2a

    #Unmapped address 0x24b testing: random write/read operations
    #Address 0x24b read value
    csrr x14, 0x24b

    #Address 0x24b read value
    csrr x14, 0x24b

    #Address 0x24b read value
    csrr x14, 0x24b

    #Unmapped address 0xb79 testing: random write/read operations
    #Address 0xb79 read value
    csrr x14, 0xb79

    #Address 0xb79 Write value 0x4022d3ca
    li x3, 0x4022d3ca
    csrw 0xb79, x3

    #Address 0xb79 read value
    csrr x14, 0xb79

    #Unmapped address 0x14b testing: random write/read operations
    #Address 0x14b read value
    csrr x14, 0x14b

    #Address 0x14b Write value 0xd865b43e
    li x3, 0xd865b43e
    csrw 0x14b, x3

    #Address 0x14b Write value 0xbb92da21
    li x3, 0xbb92da21
    csrw 0x14b, x3

    #Unmapped address 0x43e testing: random write/read operations
    #Address 0x43e read value
    csrr x14, 0x43e

    #Address 0x43e read value
    csrr x14, 0x43e

    #Unmapped address 0x794 testing: random write/read operations
    #Address 0x794 Write value 0x448f0dbd
    li x3, 0x448f0dbd
    csrw 0x794, x3

    #Address 0x794 read value
    csrr x14, 0x794

    #Address 0x794 Write value 0xa280543c
    li x3, 0xa280543c
    csrw 0x794, x3

    #Unmapped address 0x62c testing: random write/read operations
    #Address 0x62c read value
    csrr x14, 0x62c

    #Address 0x62c read value
    csrr x14, 0x62c

    #Address 0x62c Write value 0xa9b9ff5c
    li x3, 0xa9b9ff5c
    csrw 0x62c, x3

    #Unmapped address 0xfd8 testing: random write/read operations
    #Address 0xfd8 read value
    csrr x14, 0xfd8

    #Address 0xfd8 read value
    csrr x14, 0xfd8

    #Address 0xfd8 read value
    csrr x14, 0xfd8

    #Address 0xfd8 read value
    csrr x14, 0xfd8

    #Address 0xfd8 read value
    csrr x14, 0xfd8

    #Unmapped address 0x8db testing: random write/read operations
    #Address 0x8db read value
    csrr x14, 0x8db

    #Mapped address 0xb9a (mhpmcounterh26) testing: random write/read operations
    #Address 0xb9a Write value 0x1e535cd7
    li x3, 0x1e535cd7
    csrw 0xb9a, x3

    #Address 0xb9a Write value 0x18ea1224
    li x3, 0x18ea1224
    csrw 0xb9a, x3

    #Address 0xb9a Write value 0xd52f43ef
    li x3, 0xd52f43ef
    csrw 0xb9a, x3

    #Address 0xb9a read value
    csrr x14, 0xb9a

    #Unmapped address 0x8b9 testing: random write/read operations
    #Address 0x8b9 Write value 0x6bdd496
    li x3, 0x6bdd496
    csrw 0x8b9, x3

    #Address 0x8b9 read value
    csrr x14, 0x8b9

    #Address 0x8b9 read value
    csrr x14, 0x8b9

    #Address 0x8b9 Write value 0x15406b94
    li x3, 0x15406b94
    csrw 0x8b9, x3

    #Address 0x8b9 read value
    csrr x14, 0x8b9

    #Unmapped address 0x927 testing: random write/read operations
    #Address 0x927 read value
    csrr x14, 0x927

    #Address 0x927 read value
    csrr x14, 0x927

    #Address 0x927 read value
    csrr x14, 0x927

    #Unmapped address 0x7fb testing: random write/read operations
    #Address 0x7fb read value
    csrr x14, 0x7fb

    #Unmapped address 0x71e testing: random write/read operations
    #Address 0x71e Write value 0x20849f80
    li x3, 0x20849f80
    csrw 0x71e, x3

    #Address 0x71e Write value 0x5502fabe
    li x3, 0x5502fabe
    csrw 0x71e, x3

    #Unmapped address 0xdbd testing: random write/read operations
    #Address 0xdbd read value
    csrr x14, 0xdbd

    #Address 0xdbd Write value 0xc54b9909
    li x3, 0xc54b9909
    csrw 0xdbd, x3

    #Address 0xdbd Write value 0x875170b1
    li x3, 0x875170b1
    csrw 0xdbd, x3

    #Address 0xdbd Write value 0x53d71980
    li x3, 0x53d71980
    csrw 0xdbd, x3

    #Unmapped address 0xf7f testing: random write/read operations
    #Address 0xf7f Write value 0x8afd4c10
    li x3, 0x8afd4c10
    csrw 0xf7f, x3

    #Address 0xf7f read value
    csrr x14, 0xf7f

    #Address 0xf7f read value
    csrr x14, 0xf7f

    #Address 0xf7f read value
    csrr x14, 0xf7f

    #Unmapped address 0x93d testing: random write/read operations
    #Address 0x93d Write value 0x33b57830
    li x3, 0x33b57830
    csrw 0x93d, x3

    #Unmapped address 0x69a testing: random write/read operations
    #Address 0x69a Write value 0xea8f04b1
    li x3, 0xea8f04b1
    csrw 0x69a, x3

    #Address 0x69a Write value 0x99575c96
    li x3, 0x99575c96
    csrw 0x69a, x3

    #Address 0x69a Write value 0xa464d7cd
    li x3, 0xa464d7cd
    csrw 0x69a, x3

    #Unmapped address 0x802 testing: random write/read operations
    #Address 0x802 read value
    csrr x14, 0x802

    #Address 0x802 Write value 0x99510f82
    li x3, 0x99510f82
    csrw 0x802, x3

    #Unmapped address 0xe84 testing: random write/read operations
    #Address 0xe84 read value
    csrr x14, 0xe84

    #Address 0xe84 Write value 0x369f6f05
    li x3, 0x369f6f05
    csrw 0xe84, x3

    #Address 0xe84 Write value 0xa5ce9a0d
    li x3, 0xa5ce9a0d
    csrw 0xe84, x3

    #Unmapped address 0x6ef testing: random write/read operations
    #Address 0x6ef Write value 0x35ac7a69
    li x3, 0x35ac7a69
    csrw 0x6ef, x3

    #Address 0x6ef read value
    csrr x14, 0x6ef

    #Unmapped address 0x47d testing: random write/read operations
    #Address 0x47d read value
    csrr x14, 0x47d

    #Address 0x47d Write value 0x6677c8ec
    li x3, 0x6677c8ec
    csrw 0x47d, x3

    #Unmapped address 0xa5c testing: random write/read operations
    #Address 0xa5c Write value 0xae18e611
    li x3, 0xae18e611
    csrw 0xa5c, x3

    #Address 0xa5c Write value 0x5fb4f370
    li x3, 0x5fb4f370
    csrw 0xa5c, x3

    #Unmapped address 0xdef testing: random write/read operations
    #Address 0xdef Write value 0xce3d126d
    li x3, 0xce3d126d
    csrw 0xdef, x3

    #Address 0xdef read value
    csrr x14, 0xdef

    #Address 0xdef read value
    csrr x14, 0xdef

    #Mapped address 0x3b8 (pmpaddr8) testing: random write/read operations
    #Address 0x3b8 Write value 0xdded2bda
    li x3, 0xdded2bda
    csrw 0x3b8, x3

    #Address 0x3b8 read value
    csrr x14, 0x3b8

    #Address 0x3b8 read value
    csrr x14, 0x3b8

    #Unmapped address 0xad3 testing: random write/read operations
    #Address 0xad3 read value
    csrr x14, 0xad3

    #Address 0xad3 read value
    csrr x14, 0xad3

    #Address 0xad3 read value
    csrr x14, 0xad3

    #Unmapped address 0xd37 testing: random write/read operations
    #Address 0xd37 read value
    csrr x14, 0xd37

    #Address 0xd37 Write value 0xd4a5bf0f
    li x3, 0xd4a5bf0f
    csrw 0xd37, x3

    #Address 0xd37 Write value 0x48057ff9
    li x3, 0x48057ff9
    csrw 0xd37, x3

    #Unmapped address 0x950 testing: random write/read operations
    #Address 0x950 Write value 0x32c0b82a
    li x3, 0x32c0b82a
    csrw 0x950, x3

    #Address 0x950 Write value 0x8d1d0e6e
    li x3, 0x8d1d0e6e
    csrw 0x950, x3

    #Address 0x950 Write value 0x5bd9705
    li x3, 0x5bd9705
    csrw 0x950, x3

    #Address 0x950 read value
    csrr x14, 0x950

    #Address 0x950 read value
    csrr x14, 0x950

    #Unmapped address 0xe3b testing: random write/read operations
    #Address 0xe3b Write value 0x5b0d8ec4
    li x3, 0x5b0d8ec4
    csrw 0xe3b, x3

    #Address 0xe3b Write value 0x2421b811
    li x3, 0x2421b811
    csrw 0xe3b, x3

    #Address 0xe3b Write value 0x4c0387e2
    li x3, 0x4c0387e2
    csrw 0xe3b, x3

    #Unmapped address 0x281 testing: random write/read operations
    #Address 0x281 read value
    csrr x14, 0x281

    #Address 0x281 read value
    csrr x14, 0x281

    #Address 0x281 read value
    csrr x14, 0x281

    #Address 0x281 read value
    csrr x14, 0x281

    #Address 0x281 read value
    csrr x14, 0x281

    #Unmapped address 0x18f testing: random write/read operations
    #Address 0x18f read value
    csrr x14, 0x18f

    #Unmapped address 0x258 testing: random write/read operations
    #Address 0x258 Write value 0x5d1ad104
    li x3, 0x5d1ad104
    csrw 0x258, x3

    #Unmapped address 0xf59 testing: random write/read operations
    #Address 0xf59 Write value 0xc86a17ba
    li x3, 0xc86a17ba
    csrw 0xf59, x3

    #Address 0xf59 Write value 0x6373712d
    li x3, 0x6373712d
    csrw 0xf59, x3

    #Unmapped address 0xd40 testing: random write/read operations
    #Address 0xd40 Write value 0xacfb4fdb
    li x3, 0xacfb4fdb
    csrw 0xd40, x3

    #Address 0xd40 Write value 0xda448f32
    li x3, 0xda448f32
    csrw 0xd40, x3

    #Address 0xd40 read value
    csrr x14, 0xd40

    #Address 0xd40 Write value 0x2b8f4473
    li x3, 0x2b8f4473
    csrw 0xd40, x3

    #Unmapped address 0xa47 testing: random write/read operations
    #Address 0xa47 read value
    csrr x14, 0xa47

    #Address 0xa47 read value
    csrr x14, 0xa47

    #Address 0xa47 read value
    csrr x14, 0xa47

    #Mapped address 0xf12 (marchid) testing: random write/read operations
    #Address 0xf12 read value
    csrr x14, 0xf12

    #Address 0xf12 Write value 0xff0f3b25
    li x3, 0xff0f3b25
    csrw 0xf12, x3

    #Address 0xf12 read value
    csrr x14, 0xf12

    #Address 0xf12 read value
    csrr x14, 0xf12

    #Unmapped address 0x546 testing: random write/read operations
    #Address 0x546 read value
    csrr x14, 0x546

    #Address 0x546 Write value 0xbb2741a4
    li x3, 0xbb2741a4
    csrw 0x546, x3

    #Address 0x546 read value
    csrr x14, 0x546

    #Unmapped address 0xc25 testing: random write/read operations
    #Address 0xc25 read value
    csrr x14, 0xc25

    #Unmapped address 0x483 testing: random write/read operations
    #Address 0x483 read value
    csrr x14, 0x483

    #Address 0x483 Write value 0xf433f0e5
    li x3, 0xf433f0e5
    csrw 0x483, x3

    #Address 0x483 Write value 0xc7c1613d
    li x3, 0xc7c1613d
    csrw 0x483, x3

    #Address 0x483 Write value 0x1bb04db4
    li x3, 0x1bb04db4
    csrw 0x483, x3

    #Address 0x483 read value
    csrr x14, 0x483

    #Unmapped address 0xeaa testing: random write/read operations
    #Address 0xeaa read value
    csrr x14, 0xeaa

    #Address 0xeaa read value
    csrr x14, 0xeaa

    #Address 0xeaa read value
    csrr x14, 0xeaa

    #Address 0xeaa read value
    csrr x14, 0xeaa

    #Address 0xeaa Write value 0x886cc834
    li x3, 0x886cc834
    csrw 0xeaa, x3

    #Unmapped address 0xc61 testing: random write/read operations
    #Address 0xc61 read value
    csrr x14, 0xc61

    #Address 0xc61 Write value 0x5dfcc019
    li x3, 0x5dfcc019
    csrw 0xc61, x3

    #Address 0xc61 read value
    csrr x14, 0xc61

    #Unmapped address 0x990 testing: random write/read operations
    #Address 0x990 read value
    csrr x14, 0x990

    #Address 0x990 Write value 0x147b3c66
    li x3, 0x147b3c66
    csrw 0x990, x3

    #Address 0x990 Write value 0x62bebe3a
    li x3, 0x62bebe3a
    csrw 0x990, x3

    #Address 0x990 read value
    csrr x14, 0x990

    #Unmapped address 0x7b0 testing: random write/read operations
    #Address 0x7b0 read value
    csrr x14, 0x7b0

    #Address 0x7b0 read value
    csrr x14, 0x7b0

    #Address 0x7b0 Write value 0x6145644
    li x3, 0x6145644
    csrw 0x7b0, x3

    #Address 0x7b0 read value
    csrr x14, 0x7b0

    #Address 0x7b0 read value
    csrr x14, 0x7b0

    #Unmapped address 0x983 testing: random write/read operations
    #Address 0x983 Write value 0x62128346
    li x3, 0x62128346
    csrw 0x983, x3

    #Address 0x983 read value
    csrr x14, 0x983

    #Address 0x983 Write value 0x3d7ef7a2
    li x3, 0x3d7ef7a2
    csrw 0x983, x3

    #Unmapped address 0x348 testing: random write/read operations
    #Address 0x348 Write value 0x8dac4d9e
    li x3, 0x8dac4d9e
    csrw 0x348, x3

    #Address 0x348 read value
    csrr x14, 0x348

    #Address 0x348 Write value 0x9894f431
    li x3, 0x9894f431
    csrw 0x348, x3

    #Unmapped address 0x5fd testing: random write/read operations
    #Address 0x5fd read value
    csrr x14, 0x5fd

    #Address 0x5fd read value
    csrr x14, 0x5fd

    #Address 0x5fd read value
    csrr x14, 0x5fd

    #Unmapped address 0xa0f testing: random write/read operations
    #Address 0xa0f Write value 0x67bb5bc3
    li x3, 0x67bb5bc3
    csrw 0xa0f, x3

    #Address 0xa0f read value
    csrr x14, 0xa0f

    #Address 0xa0f read value
    csrr x14, 0xa0f

    #Unmapped address 0x9bb testing: random write/read operations
    #Address 0x9bb read value
    csrr x14, 0x9bb

    #Address 0x9bb read value
    csrr x14, 0x9bb

    #Address 0x9bb Write value 0xcd21ea1c
    li x3, 0xcd21ea1c
    csrw 0x9bb, x3

    #Address 0x9bb read value
    csrr x14, 0x9bb

    #Address 0x9bb Write value 0x83d11d8d
    li x3, 0x83d11d8d
    csrw 0x9bb, x3

    #Unmapped address 0x91 testing: random write/read operations
    #Address 0x91 read value
    csrr x14, 0x91

    #Address 0x91 Write value 0xd6637570
    li x3, 0xd6637570
    csrw 0x91, x3

    #Address 0x91 read value
    csrr x14, 0x91

    #Address 0x91 Write value 0x55479c13
    li x3, 0x55479c13
    csrw 0x91, x3

    #Mapped address 0x335 (mhpmevent21) testing: random write/read operations
    #Address 0x335 Write value 0xe7831ea
    li x3, 0xe7831ea
    csrw 0x335, x3

    #Address 0x335 read value
    csrr x14, 0x335

    #Address 0x335 Write value 0x2b793290
    li x3, 0x2b793290
    csrw 0x335, x3

    #Address 0x335 read value
    csrr x14, 0x335

    #Unmapped address 0x991 testing: random write/read operations
    #Address 0x991 Write value 0xa6ff49c1
    li x3, 0xa6ff49c1
    csrw 0x991, x3

    #Unmapped address 0x2da testing: random write/read operations
    #Address 0x2da read value
    csrr x14, 0x2da

    #Address 0x2da read value
    csrr x14, 0x2da

    #Address 0x2da read value
    csrr x14, 0x2da

    #Address 0x2da Write value 0x83c14591
    li x3, 0x83c14591
    csrw 0x2da, x3

    #Unmapped address 0xc20 testing: random write/read operations
    #Address 0xc20 read value
    csrr x14, 0xc20

    #Address 0xc20 read value
    csrr x14, 0xc20

    #Unmapped address 0x144 testing: random write/read operations
    #Address 0x144 Write value 0xe203206e
    li x3, 0xe203206e
    csrw 0x144, x3

    #Address 0x144 Write value 0x53204253
    li x3, 0x53204253
    csrw 0x144, x3

    #Address 0x144 Write value 0x44b65409
    li x3, 0x44b65409
    csrw 0x144, x3

    #Unmapped address 0x547 testing: random write/read operations
    #Address 0x547 read value
    csrr x14, 0x547

    #Address 0x547 Write value 0x1d764136
    li x3, 0x1d764136
    csrw 0x547, x3

    #Address 0x547 read value
    csrr x14, 0x547

    #Unmapped address 0x452 testing: random write/read operations
    #Address 0x452 Write value 0x8c49bcb2
    li x3, 0x8c49bcb2
    csrw 0x452, x3

    #Unmapped address 0x9f3 testing: random write/read operations
    #Address 0x9f3 Write value 0x54cbc8a0
    li x3, 0x54cbc8a0
    csrw 0x9f3, x3

    #Address 0x9f3 read value
    csrr x14, 0x9f3

    #Address 0x9f3 Write value 0x38c2c1cf
    li x3, 0x38c2c1cf
    csrw 0x9f3, x3

    #Address 0x9f3 Write value 0xa0d240cf
    li x3, 0xa0d240cf
    csrw 0x9f3, x3

    #Address 0x9f3 Write value 0x6833464a
    li x3, 0x6833464a
    csrw 0x9f3, x3

    #Unmapped address 0x8fa testing: random write/read operations
    #Address 0x8fa Write value 0xcb3bf7a1
    li x3, 0xcb3bf7a1
    csrw 0x8fa, x3

    #Address 0x8fa read value
    csrr x14, 0x8fa

    #Unmapped address 0xe3c testing: random write/read operations
    #Address 0xe3c Write value 0xa6849d90
    li x3, 0xa6849d90
    csrw 0xe3c, x3

    #Address 0xe3c Write value 0x781f48b6
    li x3, 0x781f48b6
    csrw 0xe3c, x3

    #Address 0xe3c Write value 0x2dc9a8bd
    li x3, 0x2dc9a8bd
    csrw 0xe3c, x3

    #Address 0xe3c read value
    csrr x14, 0xe3c

    #Unmapped address 0xc7d testing: random write/read operations
    #Address 0xc7d Write value 0xde7c53c8
    li x3, 0xde7c53c8
    csrw 0xc7d, x3

    #Address 0xc7d read value
    csrr x14, 0xc7d

    #Unmapped address 0xffa testing: random write/read operations
    #Address 0xffa Write value 0xe9558ec0
    li x3, 0xe9558ec0
    csrw 0xffa, x3

    #Address 0xffa read value
    csrr x14, 0xffa

    #Unmapped address 0xc29 testing: random write/read operations
    #Address 0xc29 read value
    csrr x14, 0xc29

    #Address 0xc29 Write value 0x8e7435c4
    li x3, 0x8e7435c4
    csrw 0xc29, x3

    #Address 0xc29 Write value 0x11f0aafa
    li x3, 0x11f0aafa
    csrw 0xc29, x3

    #Address 0xc29 Write value 0x5b64c9e7
    li x3, 0x5b64c9e7
    csrw 0xc29, x3

    #Unmapped address 0x89e testing: random write/read operations
    #Address 0x89e read value
    csrr x14, 0x89e

    #Address 0x89e Write value 0xe1319cdb
    li x3, 0xe1319cdb
    csrw 0x89e, x3

    #Address 0x89e read value
    csrr x14, 0x89e

    #Address 0x89e read value
    csrr x14, 0x89e

    #Unmapped address 0xca1 testing: random write/read operations
    #Address 0xca1 Write value 0xee061a99
    li x3, 0xee061a99
    csrw 0xca1, x3

    #Address 0xca1 Write value 0x3592051a
    li x3, 0x3592051a
    csrw 0xca1, x3

    #Unmapped address 0x40 testing: random write/read operations
    #Address 0x40 Write value 0xa0b113f6
    li x3, 0xa0b113f6
    csrw 0x40, x3

    #Address 0x40 Write value 0x6c289277
    li x3, 0x6c289277
    csrw 0x40, x3

    #Address 0x40 read value
    csrr x14, 0x40

    #Unmapped address 0xa10 testing: random write/read operations
    #Address 0xa10 read value
    csrr x14, 0xa10

    #Address 0xa10 read value
    csrr x14, 0xa10

    #Address 0xa10 read value
    csrr x14, 0xa10

    #Address 0xa10 read value
    csrr x14, 0xa10

    #Unmapped address 0x6fa testing: random write/read operations
    #Address 0x6fa Write value 0x2af3aa44
    li x3, 0x2af3aa44
    csrw 0x6fa, x3

    #Address 0x6fa Write value 0x6647c953
    li x3, 0x6647c953
    csrw 0x6fa, x3

    #Address 0x6fa Write value 0x733a9c13
    li x3, 0x733a9c13
    csrw 0x6fa, x3

    #Unmapped address 0x1a1 testing: random write/read operations
    #Address 0x1a1 Write value 0xebf5b0f2
    li x3, 0xebf5b0f2
    csrw 0x1a1, x3

    #Address 0x1a1 read value
    csrr x14, 0x1a1

    #Address 0x1a1 Write value 0x6fa8b26
    li x3, 0x6fa8b26
    csrw 0x1a1, x3

    #Unmapped address 0x90b testing: random write/read operations
    #Address 0x90b read value
    csrr x14, 0x90b

    #Address 0x90b read value
    csrr x14, 0x90b

    #Address 0x90b read value
    csrr x14, 0x90b

    #Address 0x90b Write value 0x8045f57f
    li x3, 0x8045f57f
    csrw 0x90b, x3

    #Address 0x90b Write value 0xd9826fbe
    li x3, 0xd9826fbe
    csrw 0x90b, x3

    #Unmapped address 0x303 testing: random write/read operations
    #Address 0x303 Write value 0x75180bd1
    li x3, 0x75180bd1
    csrw 0x303, x3

    #Unmapped address 0x2f1 testing: random write/read operations
    #Address 0x2f1 Write value 0x9d63f3c3
    li x3, 0x9d63f3c3
    csrw 0x2f1, x3

    #Address 0x2f1 read value
    csrr x14, 0x2f1

    #Address 0x2f1 read value
    csrr x14, 0x2f1

    #Unmapped address 0x5f3 testing: random write/read operations
    #Address 0x5f3 read value
    csrr x14, 0x5f3

    #Address 0x5f3 Write value 0x92f57477
    li x3, 0x92f57477
    csrw 0x5f3, x3

    #Address 0x5f3 read value
    csrr x14, 0x5f3

    #Address 0x5f3 Write value 0x51f68aa1
    li x3, 0x51f68aa1
    csrw 0x5f3, x3

    #Address 0x5f3 Write value 0x477a6dec
    li x3, 0x477a6dec
    csrw 0x5f3, x3

    #Unmapped address 0x182 testing: random write/read operations
    #Address 0x182 read value
    csrr x14, 0x182

    #Address 0x182 read value
    csrr x14, 0x182

    #Address 0x182 read value
    csrr x14, 0x182

    #Address 0x182 Write value 0xddf46058
    li x3, 0xddf46058
    csrw 0x182, x3

    #Address 0x182 read value
    csrr x14, 0x182

    #Unmapped address 0xc7e testing: random write/read operations
    #Address 0xc7e Write value 0x7554db6d
    li x3, 0x7554db6d
    csrw 0xc7e, x3

    #Address 0xc7e Write value 0x4665f763
    li x3, 0x4665f763
    csrw 0xc7e, x3

    #Address 0xc7e read value
    csrr x14, 0xc7e

    #Address 0xc7e read value
    csrr x14, 0xc7e

    #Unmapped address 0x69c testing: random write/read operations
    #Address 0x69c read value
    csrr x14, 0x69c

    #Address 0x69c read value
    csrr x14, 0x69c

    #Address 0x69c read value
    csrr x14, 0x69c

    #Unmapped address 0x76e testing: random write/read operations
    #Address 0x76e Write value 0x50063c3c
    li x3, 0x50063c3c
    csrw 0x76e, x3

    #Unmapped address 0xe32 testing: random write/read operations
    #Address 0xe32 Write value 0x9e1029f9
    li x3, 0x9e1029f9
    csrw 0xe32, x3

    #Unmapped address 0xc1f testing: random write/read operations
    #Address 0xc1f read value
    csrr x14, 0xc1f

    #Address 0xc1f read value
    csrr x14, 0xc1f

    #Unmapped address 0x666 testing: random write/read operations
    #Address 0x666 Write value 0x95da170f
    li x3, 0x95da170f
    csrw 0x666, x3

    #Unmapped address 0x86e testing: random write/read operations
    #Address 0x86e read value
    csrr x14, 0x86e

    #Address 0x86e read value
    csrr x14, 0x86e

    #Address 0x86e read value
    csrr x14, 0x86e

    #Unmapped address 0xd0a testing: random write/read operations
    #Address 0xd0a Write value 0x7d3c3148
    li x3, 0x7d3c3148
    csrw 0xd0a, x3

    #Address 0xd0a read value
    csrr x14, 0xd0a

    #Unmapped address 0xd88 testing: random write/read operations
    #Address 0xd88 Write value 0xede8b847
    li x3, 0xede8b847
    csrw 0xd88, x3

    #Address 0xd88 Write value 0x617a0726
    li x3, 0x617a0726
    csrw 0xd88, x3

    #Address 0xd88 read value
    csrr x14, 0xd88

    #Address 0xd88 read value
    csrr x14, 0xd88

    #Address 0xd88 Write value 0xf21f7ab3
    li x3, 0xf21f7ab3
    csrw 0xd88, x3

    #Unmapped address 0x1c3 testing: random write/read operations
    #Address 0x1c3 Write value 0xec5c17fa
    li x3, 0xec5c17fa
    csrw 0x1c3, x3

    #Address 0x1c3 Write value 0xbaaae537
    li x3, 0xbaaae537
    csrw 0x1c3, x3

    #Address 0x1c3 read value
    csrr x14, 0x1c3

    #Address 0x1c3 Write value 0x82bbf8af
    li x3, 0x82bbf8af
    csrw 0x1c3, x3

    #Address 0x1c3 read value
    csrr x14, 0x1c3

    #Unmapped address 0x135 testing: random write/read operations
    #Address 0x135 read value
    csrr x14, 0x135

    #Address 0x135 Write value 0x2a3a0ae6
    li x3, 0x2a3a0ae6
    csrw 0x135, x3

    #Unmapped address 0x3e5 testing: random write/read operations
    #Address 0x3e5 Write value 0xa437b3f1
    li x3, 0xa437b3f1
    csrw 0x3e5, x3

    #Address 0x3e5 Write value 0x726276a2
    li x3, 0x726276a2
    csrw 0x3e5, x3

    #Address 0x3e5 Write value 0xfbac402d
    li x3, 0xfbac402d
    csrw 0x3e5, x3

    #Unmapped address 0xf8b testing: random write/read operations
    #Address 0xf8b read value
    csrr x14, 0xf8b

    #Address 0xf8b read value
    csrr x14, 0xf8b

    #Address 0xf8b read value
    csrr x14, 0xf8b

    #Address 0xf8b Write value 0xc89f5e0e
    li x3, 0xc89f5e0e
    csrw 0xf8b, x3

    #Address 0xf8b read value
    csrr x14, 0xf8b

    #Unmapped address 0x56d testing: random write/read operations
    #Address 0x56d Write value 0x78933f5f
    li x3, 0x78933f5f
    csrw 0x56d, x3

    #Address 0x56d read value
    csrr x14, 0x56d

    #Address 0x56d read value
    csrr x14, 0x56d

    #Unmapped address 0xc56 testing: random write/read operations
    #Address 0xc56 Write value 0x5b32b78b
    li x3, 0x5b32b78b
    csrw 0xc56, x3

    #Address 0xc56 Write value 0x55e9b6e1
    li x3, 0x55e9b6e1
    csrw 0xc56, x3

    #Address 0xc56 read value
    csrr x14, 0xc56

    #Address 0xc56 Write value 0xa4f2a92d
    li x3, 0xa4f2a92d
    csrw 0xc56, x3

    #Unmapped address 0x453 testing: random write/read operations
    #Address 0x453 Write value 0xb4134f50
    li x3, 0xb4134f50
    csrw 0x453, x3

    #Unmapped address 0x3d8 testing: random write/read operations
    #Address 0x3d8 Write value 0xbeb7a5a2
    li x3, 0xbeb7a5a2
    csrw 0x3d8, x3

    #Address 0x3d8 read value
    csrr x14, 0x3d8

    #Address 0x3d8 read value
    csrr x14, 0x3d8

    #Address 0x3d8 read value
    csrr x14, 0x3d8

    #Unmapped address 0x5dc testing: random write/read operations
    #Address 0x5dc Write value 0x7906c0a6
    li x3, 0x7906c0a6
    csrw 0x5dc, x3

    #Address 0x5dc read value
    csrr x14, 0x5dc

    #Address 0x5dc read value
    csrr x14, 0x5dc

    #Address 0x5dc read value
    csrr x14, 0x5dc

    #Address 0x5dc read value
    csrr x14, 0x5dc

    #Unmapped address 0x372 testing: random write/read operations
    #Address 0x372 Write value 0x59922e58
    li x3, 0x59922e58
    csrw 0x372, x3

    #Address 0x372 read value
    csrr x14, 0x372

    #Address 0x372 Write value 0x6a378929
    li x3, 0x6a378929
    csrw 0x372, x3

    #Address 0x372 Write value 0x98b2c9e1
    li x3, 0x98b2c9e1
    csrw 0x372, x3

    #Unmapped address 0x8b0 testing: random write/read operations
    #Address 0x8b0 read value
    csrr x14, 0x8b0

    #Unmapped address 0x74c testing: random write/read operations
    #Address 0x74c Write value 0x891a336a
    li x3, 0x891a336a
    csrw 0x74c, x3

    #Address 0x74c Write value 0xe489295c
    li x3, 0xe489295c
    csrw 0x74c, x3

    #Address 0x74c Write value 0xb33ccc53
    li x3, 0xb33ccc53
    csrw 0x74c, x3

    #Address 0x74c Write value 0xa7ea81f4
    li x3, 0xa7ea81f4
    csrw 0x74c, x3

    #Address 0x74c read value
    csrr x14, 0x74c

    #Unmapped address 0xf45 testing: random write/read operations
    #Address 0xf45 Write value 0xec361dbe
    li x3, 0xec361dbe
    csrw 0xf45, x3

    #Address 0xf45 read value
    csrr x14, 0xf45

    #Address 0xf45 Write value 0x78b2634c
    li x3, 0x78b2634c
    csrw 0xf45, x3

    #Address 0xf45 read value
    csrr x14, 0xf45

    #Address 0xf45 read value
    csrr x14, 0xf45

    #Unmapped address 0x8f5 testing: random write/read operations
    #Address 0x8f5 Write value 0xe150d25c
    li x3, 0xe150d25c
    csrw 0x8f5, x3

    #Address 0x8f5 read value
    csrr x14, 0x8f5

    #Address 0x8f5 read value
    csrr x14, 0x8f5

    #Address 0x8f5 Write value 0xfab1a8c2
    li x3, 0xfab1a8c2
    csrw 0x8f5, x3

    #Unmapped address 0x79c testing: random write/read operations
    #Address 0x79c Write value 0xed01e726
    li x3, 0xed01e726
    csrw 0x79c, x3

    #Address 0x79c read value
    csrr x14, 0x79c

    #Address 0x79c Write value 0x4f831475
    li x3, 0x4f831475
    csrw 0x79c, x3

    #Address 0x79c read value
    csrr x14, 0x79c

    #Address 0x79c read value
    csrr x14, 0x79c

    #Unmapped address 0x25d testing: random write/read operations
    #Address 0x25d Write value 0xf40e5031
    li x3, 0xf40e5031
    csrw 0x25d, x3

    #Address 0x25d read value
    csrr x14, 0x25d

    #Address 0x25d Write value 0x5366f2ec
    li x3, 0x5366f2ec
    csrw 0x25d, x3

    #Address 0x25d read value
    csrr x14, 0x25d

    #Address 0x25d read value
    csrr x14, 0x25d

    #Unmapped address 0x1f4 testing: random write/read operations
    #Address 0x1f4 read value
    csrr x14, 0x1f4

    #Address 0x1f4 read value
    csrr x14, 0x1f4

    #Address 0x1f4 read value
    csrr x14, 0x1f4

    #Address 0x1f4 read value
    csrr x14, 0x1f4

    #Unmapped address 0x647 testing: random write/read operations
    #Address 0x647 Write value 0xf06a44d6
    li x3, 0xf06a44d6
    csrw 0x647, x3

    #Address 0x647 read value
    csrr x14, 0x647

    #Address 0x647 Write value 0xeafbaf24
    li x3, 0xeafbaf24
    csrw 0x647, x3

    #Address 0x647 Write value 0x5e1699f9
    li x3, 0x5e1699f9
    csrw 0x647, x3

    #Unmapped address 0x7d8 testing: random write/read operations
    #Address 0x7d8 Write value 0x41b28dac
    li x3, 0x41b28dac
    csrw 0x7d8, x3

    #Address 0x7d8 read value
    csrr x14, 0x7d8

    #Address 0x7d8 Write value 0xd14102a5
    li x3, 0xd14102a5
    csrw 0x7d8, x3

    #Address 0x7d8 read value
    csrr x14, 0x7d8

    #Unmapped address 0x92b testing: random write/read operations
    #Address 0x92b read value
    csrr x14, 0x92b

    #Unmapped address 0x22 testing: random write/read operations
    #Address 0x22 Write value 0x1f38685b
    li x3, 0x1f38685b
    csrw 0x22, x3

    #Address 0x22 read value
    csrr x14, 0x22

    #Address 0x22 read value
    csrr x14, 0x22

    #Unmapped address 0x493 testing: random write/read operations
    #Address 0x493 read value
    csrr x14, 0x493

    #Address 0x493 read value
    csrr x14, 0x493

    #Address 0x493 read value
    csrr x14, 0x493

    #Address 0x493 read value
    csrr x14, 0x493

    #Address 0x493 Write value 0xb518abca
    li x3, 0xb518abca
    csrw 0x493, x3

    #Unmapped address 0x929 testing: random write/read operations
    #Address 0x929 read value
    csrr x14, 0x929

    #Unmapped address 0xc0a testing: random write/read operations
    #Address 0xc0a read value
    csrr x14, 0xc0a

    #Unmapped address 0x82 testing: random write/read operations
    #Address 0x82 Write value 0x3f12c7b4
    li x3, 0x3f12c7b4
    csrw 0x82, x3

    #Address 0x82 Write value 0x590ac3c9
    li x3, 0x590ac3c9
    csrw 0x82, x3

    #Address 0x82 read value
    csrr x14, 0x82

    #Address 0x82 Write value 0x33c4fca3
    li x3, 0x33c4fca3
    csrw 0x82, x3

    #Address 0x82 Write value 0xb1976c3d
    li x3, 0xb1976c3d
    csrw 0x82, x3

    #Unmapped address 0x645 testing: random write/read operations
    #Address 0x645 Write value 0xd3b3b44c
    li x3, 0xd3b3b44c
    csrw 0x645, x3

    #Unmapped address 0x50c testing: random write/read operations
    #Address 0x50c Write value 0x98eee50
    li x3, 0x98eee50
    csrw 0x50c, x3

    #Address 0x50c read value
    csrr x14, 0x50c

    #Address 0x50c read value
    csrr x14, 0x50c

    #Unmapped address 0x9ee testing: random write/read operations
    #Address 0x9ee read value
    csrr x14, 0x9ee

    #Address 0x9ee read value
    csrr x14, 0x9ee

    #Unmapped address 0x98a testing: random write/read operations
    #Address 0x98a Write value 0x78e15af2
    li x3, 0x78e15af2
    csrw 0x98a, x3

    #Address 0x98a read value
    csrr x14, 0x98a

    #Unmapped address 0x6a8 testing: random write/read operations
    #Address 0x6a8 read value
    csrr x14, 0x6a8

    #Address 0x6a8 read value
    csrr x14, 0x6a8

    #Unmapped address 0x362 testing: random write/read operations
    #Address 0x362 read value
    csrr x14, 0x362

    #Address 0x362 read value
    csrr x14, 0x362

    #Address 0x362 Write value 0x8a20c02a
    li x3, 0x8a20c02a
    csrw 0x362, x3

    #Address 0x362 Write value 0x7add3967
    li x3, 0x7add3967
    csrw 0x362, x3

    #Address 0x362 read value
    csrr x14, 0x362

    #Unmapped address 0x948 testing: random write/read operations
    #Address 0x948 read value
    csrr x14, 0x948

    #Address 0x948 read value
    csrr x14, 0x948

    #Address 0x948 read value
    csrr x14, 0x948

    #Address 0x948 Write value 0x32818fdd
    li x3, 0x32818fdd
    csrw 0x948, x3

    #Unmapped address 0x2e7 testing: random write/read operations
    #Address 0x2e7 Write value 0x155ae1e8
    li x3, 0x155ae1e8
    csrw 0x2e7, x3

    #Address 0x2e7 read value
    csrr x14, 0x2e7

    #Address 0x2e7 read value
    csrr x14, 0x2e7

    #Unmapped address 0x889 testing: random write/read operations
    #Address 0x889 read value
    csrr x14, 0x889

    #Address 0x889 Write value 0x94e443fe
    li x3, 0x94e443fe
    csrw 0x889, x3

    #Unmapped address 0xda5 testing: random write/read operations
    #Address 0xda5 Write value 0x7242acb8
    li x3, 0x7242acb8
    csrw 0xda5, x3

    #Address 0xda5 Write value 0x7383095f
    li x3, 0x7383095f
    csrw 0xda5, x3

    #Address 0xda5 Write value 0x57a1f57
    li x3, 0x57a1f57
    csrw 0xda5, x3

    #Address 0xda5 read value
    csrr x14, 0xda5

    #Address 0xda5 Write value 0xf6e80a86
    li x3, 0xf6e80a86
    csrw 0xda5, x3

    #Unmapped address 0x8d3 testing: random write/read operations
    #Address 0x8d3 Write value 0xd923c36a
    li x3, 0xd923c36a
    csrw 0x8d3, x3

    #Address 0x8d3 Write value 0x1e095c5e
    li x3, 0x1e095c5e
    csrw 0x8d3, x3

    #Address 0x8d3 read value
    csrr x14, 0x8d3

    #Address 0x8d3 Write value 0x8e7b3d9c
    li x3, 0x8e7b3d9c
    csrw 0x8d3, x3

    #Unmapped address 0xe77 testing: random write/read operations
    #Address 0xe77 read value
    csrr x14, 0xe77

    #Address 0xe77 Write value 0x28e6d31a
    li x3, 0x28e6d31a
    csrw 0xe77, x3

    #Address 0xe77 Write value 0xa995660a
    li x3, 0xa995660a
    csrw 0xe77, x3

    #Unmapped address 0x5e4 testing: random write/read operations
    #Address 0x5e4 Write value 0xc9426e35
    li x3, 0xc9426e35
    csrw 0x5e4, x3

    #Address 0x5e4 read value
    csrr x14, 0x5e4

    #Address 0x5e4 read value
    csrr x14, 0x5e4

    #Unmapped address 0xa50 testing: random write/read operations
    #Address 0xa50 read value
    csrr x14, 0xa50

    #Mapped address 0x328 (mhpmevent8) testing: random write/read operations
    #Address 0x328 Write value 0x6c2a3833
    li x3, 0x6c2a3833
    csrw 0x328, x3

    #Address 0x328 Write value 0x1483bfb8
    li x3, 0x1483bfb8
    csrw 0x328, x3

    #Address 0x328 read value
    csrr x14, 0x328

    #Address 0x328 read value
    csrr x14, 0x328

    #Unmapped address 0xc09 testing: random write/read operations
    #Address 0xc09 Write value 0x421dedbb
    li x3, 0x421dedbb
    csrw 0xc09, x3

    #Address 0xc09 read value
    csrr x14, 0xc09

    #Address 0xc09 Write value 0xfc40506f
    li x3, 0xfc40506f
    csrw 0xc09, x3

    #Address 0xc09 read value
    csrr x14, 0xc09

    #Unmapped address 0x68f testing: random write/read operations
    #Address 0x68f read value
    csrr x14, 0x68f

    #Address 0x68f Write value 0x511b0811
    li x3, 0x511b0811
    csrw 0x68f, x3

    #Address 0x68f Write value 0x2193748f
    li x3, 0x2193748f
    csrw 0x68f, x3

    #Address 0x68f read value
    csrr x14, 0x68f

    #Unmapped address 0x7ac testing: random write/read operations
    #Address 0x7ac Write value 0x4d683fd7
    li x3, 0x4d683fd7
    csrw 0x7ac, x3

    #Address 0x7ac read value
    csrr x14, 0x7ac

    #Address 0x7ac read value
    csrr x14, 0x7ac

    #Unmapped address 0x29a testing: random write/read operations
    #Address 0x29a read value
    csrr x14, 0x29a

    #Address 0x29a Write value 0xc22cb5fa
    li x3, 0xc22cb5fa
    csrw 0x29a, x3

    #Address 0x29a Write value 0xe5c1d419
    li x3, 0xe5c1d419
    csrw 0x29a, x3

    #Unmapped address 0x629 testing: random write/read operations
    #Address 0x629 read value
    csrr x14, 0x629

    #Address 0x629 Write value 0x32ba6ae0
    li x3, 0x32ba6ae0
    csrw 0x629, x3

    #Address 0x629 read value
    csrr x14, 0x629

    #Address 0x629 Write value 0xdda6abdc
    li x3, 0xdda6abdc
    csrw 0x629, x3

    #Unmapped address 0x400 testing: random write/read operations
    #Address 0x400 read value
    csrr x14, 0x400

    #Address 0x400 Write value 0x96a99832
    li x3, 0x96a99832
    csrw 0x400, x3

    #Address 0x400 read value
    csrr x14, 0x400

    #Address 0x400 read value
    csrr x14, 0x400

    #Unmapped address 0x5e7 testing: random write/read operations
    #Address 0x5e7 Write value 0x31c5116
    li x3, 0x31c5116
    csrw 0x5e7, x3

    #Address 0x5e7 Write value 0x6704cee0
    li x3, 0x6704cee0
    csrw 0x5e7, x3

    #Address 0x5e7 read value
    csrr x14, 0x5e7

    #Address 0x5e7 read value
    csrr x14, 0x5e7

    #Unmapped address 0x315 testing: random write/read operations
    #Address 0x315 Write value 0xaf8597c8
    li x3, 0xaf8597c8
    csrw 0x315, x3

    #Unmapped address 0xec0 testing: random write/read operations
    #Address 0xec0 Write value 0x271fb992
    li x3, 0x271fb992
    csrw 0xec0, x3

    #Address 0xec0 read value
    csrr x14, 0xec0

    #Address 0xec0 read value
    csrr x14, 0xec0

    #Address 0xec0 read value
    csrr x14, 0xec0

    #Address 0xec0 read value
    csrr x14, 0xec0

    #Unmapped address 0x28e testing: random write/read operations
    #Address 0x28e read value
    csrr x14, 0x28e

    #Address 0x28e read value
    csrr x14, 0x28e

    #Address 0x28e Write value 0x7fe14365
    li x3, 0x7fe14365
    csrw 0x28e, x3

    #Unmapped address 0xbe4 testing: random write/read operations
    #Address 0xbe4 Write value 0xff9092a9
    li x3, 0xff9092a9
    csrw 0xbe4, x3

    #Address 0xbe4 Write value 0x6be84d14
    li x3, 0x6be84d14
    csrw 0xbe4, x3

    #Address 0xbe4 Write value 0x4c6d72b1
    li x3, 0x4c6d72b1
    csrw 0xbe4, x3

    #Unmapped address 0x51d testing: random write/read operations
    #Address 0x51d Write value 0x373783ae
    li x3, 0x373783ae
    csrw 0x51d, x3

    #Address 0x51d Write value 0xb7a9efe6
    li x3, 0xb7a9efe6
    csrw 0x51d, x3

    #Address 0x51d read value
    csrr x14, 0x51d

    #Address 0x51d read value
    csrr x14, 0x51d

    #Unmapped address 0xa4c testing: random write/read operations
    #Address 0xa4c read value
    csrr x14, 0xa4c

    #Address 0xa4c read value
    csrr x14, 0xa4c

    #Address 0xa4c Write value 0x52fabc53
    li x3, 0x52fabc53
    csrw 0xa4c, x3

    #Address 0xa4c read value
    csrr x14, 0xa4c

    #Address 0xa4c Write value 0x57a1d38f
    li x3, 0x57a1d38f
    csrw 0xa4c, x3

    #Unmapped address 0xd67 testing: random write/read operations
    #Address 0xd67 Write value 0xd7e5271a
    li x3, 0xd7e5271a
    csrw 0xd67, x3

    #Address 0xd67 Write value 0xd63ffc6e
    li x3, 0xd63ffc6e
    csrw 0xd67, x3

    #Address 0xd67 read value
    csrr x14, 0xd67

    #Unmapped address 0xf27 testing: random write/read operations
    #Address 0xf27 Write value 0x47156138
    li x3, 0x47156138
    csrw 0xf27, x3

    #Address 0xf27 read value
    csrr x14, 0xf27

    #Address 0xf27 Write value 0xf17b62ad
    li x3, 0xf17b62ad
    csrw 0xf27, x3

    #Unmapped address 0x867 testing: random write/read operations
    #Address 0x867 read value
    csrr x14, 0x867

    #Address 0x867 Write value 0xedccbcc4
    li x3, 0xedccbcc4
    csrw 0x867, x3

    #Address 0x867 read value
    csrr x14, 0x867

    #Unmapped address 0x7d1 testing: random write/read operations
    #Address 0x7d1 read value
    csrr x14, 0x7d1

    #Address 0x7d1 Write value 0xaed8f4aa
    li x3, 0xaed8f4aa
    csrw 0x7d1, x3

    #Address 0x7d1 Write value 0xe35e8322
    li x3, 0xe35e8322
    csrw 0x7d1, x3

    #Address 0x7d1 read value
    csrr x14, 0x7d1

    #Unmapped address 0x43 testing: random write/read operations
    #Address 0x43 read value
    csrr x14, 0x43

    #Address 0x43 Write value 0xcdd23f99
    li x3, 0xcdd23f99
    csrw 0x43, x3

    #Address 0x43 Write value 0xf9845c6a
    li x3, 0xf9845c6a
    csrw 0x43, x3

    #Address 0x43 read value
    csrr x14, 0x43

    #Address 0x43 Write value 0xa029c356
    li x3, 0xa029c356
    csrw 0x43, x3

    #Unmapped address 0xec8 testing: random write/read operations
    #Address 0xec8 read value
    csrr x14, 0xec8

    #Address 0xec8 read value
    csrr x14, 0xec8

    #Address 0xec8 read value
    csrr x14, 0xec8

    #Address 0xec8 Write value 0x8dda7a2f
    li x3, 0x8dda7a2f
    csrw 0xec8, x3

    #Unmapped address 0x1f7 testing: random write/read operations
    #Address 0x1f7 Write value 0x1ad98ad9
    li x3, 0x1ad98ad9
    csrw 0x1f7, x3

    #Address 0x1f7 Write value 0x11e80246
    li x3, 0x11e80246
    csrw 0x1f7, x3

    #Address 0x1f7 Write value 0x3eb574ad
    li x3, 0x3eb574ad
    csrw 0x1f7, x3

    #Address 0x1f7 read value
    csrr x14, 0x1f7

    #Unmapped address 0xd9d testing: random write/read operations
    #Address 0xd9d read value
    csrr x14, 0xd9d

    #Address 0xd9d read value
    csrr x14, 0xd9d

    #Address 0xd9d read value
    csrr x14, 0xd9d

    #Mapped address 0x344 (mip) testing: random write/read operations
    #Address 0x344 read value
    csrr x14, 0x344

    #Address 0x344 Write value 0x9bb1643
    li x3, 0x9bb1643
    csrw 0x344, x3

    #Address 0x344 read value
    csrr x14, 0x344

    #Address 0x344 read value
    csrr x14, 0x344

    #Address 0x344 read value
    csrr x14, 0x344

    #Unmapped address 0x812 testing: random write/read operations
    #Address 0x812 read value
    csrr x14, 0x812

    #Unmapped address 0xf1 testing: random write/read operations
    #Address 0xf1 Write value 0x3df59603
    li x3, 0x3df59603
    csrw 0xf1, x3

    #Address 0xf1 Write value 0x6f87e641
    li x3, 0x6f87e641
    csrw 0xf1, x3

    #Unmapped address 0x12 testing: random write/read operations
    #Address 0x12 read value
    csrr x14, 0x12

    #Address 0x12 read value
    csrr x14, 0x12

    #Address 0x12 Write value 0xa18cd5ba
    li x3, 0xa18cd5ba
    csrw 0x12, x3

    #Address 0x12 read value
    csrr x14, 0x12

    #Unmapped address 0x904 testing: random write/read operations
    #Address 0x904 read value
    csrr x14, 0x904

    #Address 0x904 read value
    csrr x14, 0x904

    #Address 0x904 read value
    csrr x14, 0x904

    #Address 0x904 read value
    csrr x14, 0x904

    #Address 0x904 read value
    csrr x14, 0x904

    #Unmapped address 0x43a testing: random write/read operations
    #Address 0x43a read value
    csrr x14, 0x43a

    #Address 0x43a read value
    csrr x14, 0x43a

    #Address 0x43a read value
    csrr x14, 0x43a

    #Unmapped address 0xae8 testing: random write/read operations
    #Address 0xae8 Write value 0x24029bfc
    li x3, 0x24029bfc
    csrw 0xae8, x3

    #Address 0xae8 Write value 0xbad838d0
    li x3, 0xbad838d0
    csrw 0xae8, x3

    #Address 0xae8 Write value 0x6460453d
    li x3, 0x6460453d
    csrw 0xae8, x3

    #Address 0xae8 read value
    csrr x14, 0xae8

    #Address 0xae8 Write value 0x6536a31d
    li x3, 0x6536a31d
    csrw 0xae8, x3

    #Unmapped address 0x245 testing: random write/read operations
    #Address 0x245 read value
    csrr x14, 0x245

    #Address 0x245 Write value 0x66f51f21
    li x3, 0x66f51f21
    csrw 0x245, x3

    #Address 0x245 Write value 0x2eef7514
    li x3, 0x2eef7514
    csrw 0x245, x3

    #Unmapped address 0xaa8 testing: random write/read operations
    #Address 0xaa8 Write value 0xedf5d78
    li x3, 0xedf5d78
    csrw 0xaa8, x3

    #Unmapped address 0x85f testing: random write/read operations
    #Address 0x85f Write value 0xd1440ec5
    li x3, 0xd1440ec5
    csrw 0x85f, x3

    #Address 0x85f read value
    csrr x14, 0x85f

    #Address 0x85f read value
    csrr x14, 0x85f

    #Address 0x85f Write value 0x8a5b3123
    li x3, 0x8a5b3123
    csrw 0x85f, x3

    #Unmapped address 0xb20 testing: random write/read operations
    #Address 0xb20 Write value 0x58c497cb
    li x3, 0x58c497cb
    csrw 0xb20, x3

    #Address 0xb20 read value
    csrr x14, 0xb20

    #Unmapped address 0x840 testing: random write/read operations
    #Address 0x840 Write value 0x44546c84
    li x3, 0x44546c84
    csrw 0x840, x3

    #Unmapped address 0xb3e testing: random write/read operations
    #Address 0xb3e Write value 0xbccd803b
    li x3, 0xbccd803b
    csrw 0xb3e, x3

    #Mapped address 0x3a3 (pmpcfg3) testing: random write/read operations
    #Address 0x3a3 Write value 0xc9e1b241
    li x3, 0xc9e1b241
    csrw 0x3a3, x3

    #Address 0x3a3 read value
    csrr x14, 0x3a3

    #Address 0x3a3 Write value 0xe18d4d71
    li x3, 0xe18d4d71
    csrw 0x3a3, x3

    #Address 0x3a3 Write value 0x27a90d3a
    li x3, 0x27a90d3a
    csrw 0x3a3, x3

    #Address 0x3a3 read value
    csrr x14, 0x3a3

    #Unmapped address 0x679 testing: random write/read operations
    #Address 0x679 Write value 0xd40e5892
    li x3, 0xd40e5892
    csrw 0x679, x3

    #Address 0x679 Write value 0xdfceba2f
    li x3, 0xdfceba2f
    csrw 0x679, x3

    #Address 0x679 read value
    csrr x14, 0x679

    #Address 0x679 read value
    csrr x14, 0x679

    #Unmapped address 0x251 testing: random write/read operations
    #Address 0x251 read value
    csrr x14, 0x251

    #Address 0x251 read value
    csrr x14, 0x251

    #Unmapped address 0x595 testing: random write/read operations
    #Address 0x595 Write value 0x2b62ca1b
    li x3, 0x2b62ca1b
    csrw 0x595, x3

    #Address 0x595 read value
    csrr x14, 0x595

    #Address 0x595 Write value 0x12c18ddb
    li x3, 0x12c18ddb
    csrw 0x595, x3

    #Address 0x595 Write value 0x3dd244ee
    li x3, 0x3dd244ee
    csrw 0x595, x3

    #Address 0x595 read value
    csrr x14, 0x595

    #Unmapped address 0xe4c testing: random write/read operations
    #Address 0xe4c Write value 0x94846ec1
    li x3, 0x94846ec1
    csrw 0xe4c, x3

    #Address 0xe4c read value
    csrr x14, 0xe4c

    #Address 0xe4c Write value 0x97cca43f
    li x3, 0x97cca43f
    csrw 0xe4c, x3

    #Address 0xe4c Write value 0xbfc72b95
    li x3, 0xbfc72b95
    csrw 0xe4c, x3

    #Address 0xe4c Write value 0x4eb1e39c
    li x3, 0x4eb1e39c
    csrw 0xe4c, x3

    #Unmapped address 0x52d testing: random write/read operations
    #Address 0x52d Write value 0x4a40070b
    li x3, 0x4a40070b
    csrw 0x52d, x3

    #Address 0x52d Write value 0x7bfb7961
    li x3, 0x7bfb7961
    csrw 0x52d, x3

    #Address 0x52d read value
    csrr x14, 0x52d

    #Address 0x52d Write value 0x74fb64e5
    li x3, 0x74fb64e5
    csrw 0x52d, x3

    #Unmapped address 0x8e5 testing: random write/read operations
    #Address 0x8e5 read value
    csrr x14, 0x8e5

    #Address 0x8e5 read value
    csrr x14, 0x8e5

    #Address 0x8e5 Write value 0xb460261a
    li x3, 0xb460261a
    csrw 0x8e5, x3

    #Address 0x8e5 Write value 0x3babb886
    li x3, 0x3babb886
    csrw 0x8e5, x3

    #Unmapped address 0x712 testing: random write/read operations
    #Address 0x712 read value
    csrr x14, 0x712

    #Address 0x712 read value
    csrr x14, 0x712

    #Address 0x712 Write value 0xd0e0916f
    li x3, 0xd0e0916f
    csrw 0x712, x3

    #Address 0x712 Write value 0x8bf847e2
    li x3, 0x8bf847e2
    csrw 0x712, x3

    #Unmapped address 0xc0c testing: random write/read operations
    #Address 0xc0c read value
    csrr x14, 0xc0c

    #Address 0xc0c read value
    csrr x14, 0xc0c

    #Unmapped address 0xe57 testing: random write/read operations
    #Address 0xe57 Write value 0x2e012380
    li x3, 0x2e012380
    csrw 0xe57, x3

    #Address 0xe57 Write value 0xf94ba4f9
    li x3, 0xf94ba4f9
    csrw 0xe57, x3

    #Address 0xe57 read value
    csrr x14, 0xe57

    #Address 0xe57 Write value 0x17943b88
    li x3, 0x17943b88
    csrw 0xe57, x3

    #Unmapped address 0xd57 testing: random write/read operations
    #Address 0xd57 read value
    csrr x14, 0xd57

    #Address 0xd57 read value
    csrr x14, 0xd57

    #Address 0xd57 read value
    csrr x14, 0xd57

    #Address 0xd57 read value
    csrr x14, 0xd57

    #Unmapped address 0xb50 testing: random write/read operations
    #Address 0xb50 Write value 0x60754748
    li x3, 0x60754748
    csrw 0xb50, x3

    #Address 0xb50 Write value 0x114f4f6a
    li x3, 0x114f4f6a
    csrw 0xb50, x3

    #Unmapped address 0x2e4 testing: random write/read operations
    #Address 0x2e4 read value
    csrr x14, 0x2e4

    #Unmapped address 0x9be testing: random write/read operations
    #Address 0x9be read value
    csrr x14, 0x9be

    #Address 0x9be Write value 0x66477f9c
    li x3, 0x66477f9c
    csrw 0x9be, x3

    #Address 0x9be read value
    csrr x14, 0x9be

    #Unmapped address 0xd92 testing: random write/read operations
    #Address 0xd92 Write value 0x399858e8
    li x3, 0x399858e8
    csrw 0xd92, x3

    #Unmapped address 0xefe testing: random write/read operations
    #Address 0xefe read value
    csrr x14, 0xefe

    #Address 0xefe read value
    csrr x14, 0xefe

    #Address 0xefe Write value 0x45c5c5bf
    li x3, 0x45c5c5bf
    csrw 0xefe, x3

    #Address 0xefe Write value 0x58a37f27
    li x3, 0x58a37f27
    csrw 0xefe, x3

    #Unmapped address 0xb6a testing: random write/read operations
    #Address 0xb6a read value
    csrr x14, 0xb6a

    #Address 0xb6a read value
    csrr x14, 0xb6a

    #Address 0xb6a read value
    csrr x14, 0xb6a

    #Address 0xb6a Write value 0x23370613
    li x3, 0x23370613
    csrw 0xb6a, x3

    #Address 0xb6a read value
    csrr x14, 0xb6a

    #Unmapped address 0x96a testing: random write/read operations
    #Address 0x96a read value
    csrr x14, 0x96a

    #Address 0x96a read value
    csrr x14, 0x96a

    #Address 0x96a Write value 0xbe0c2939
    li x3, 0xbe0c2939
    csrw 0x96a, x3

    #Unmapped address 0x9ed testing: random write/read operations
    #Address 0x9ed Write value 0x856c109f
    li x3, 0x856c109f
    csrw 0x9ed, x3

    #Address 0x9ed read value
    csrr x14, 0x9ed

    #Address 0x9ed Write value 0x1202bee0
    li x3, 0x1202bee0
    csrw 0x9ed, x3

    #Address 0x9ed read value
    csrr x14, 0x9ed

    #Address 0x9ed Write value 0x7dc4b490
    li x3, 0x7dc4b490
    csrw 0x9ed, x3

    #Unmapped address 0xc8a testing: random write/read operations
    #Address 0xc8a read value
    csrr x14, 0xc8a

    #Address 0xc8a read value
    csrr x14, 0xc8a

    #Address 0xc8a Write value 0x96520b32
    li x3, 0x96520b32
    csrw 0xc8a, x3

    #Address 0xc8a read value
    csrr x14, 0xc8a

    #Unmapped address 0x8f4 testing: random write/read operations
    #Address 0x8f4 Write value 0xf26f0934
    li x3, 0xf26f0934
    csrw 0x8f4, x3

    #Address 0x8f4 read value
    csrr x14, 0x8f4

    #Address 0x8f4 Write value 0xddaf2824
    li x3, 0xddaf2824
    csrw 0x8f4, x3

    #Address 0x8f4 read value
    csrr x14, 0x8f4

    #Mapped address 0xb83 (mhpmcounterh3) testing: random write/read operations
    #Address 0xb83 Write value 0x84b77821
    li x3, 0x84b77821
    csrw 0xb83, x3

    #Address 0xb83 read value
    csrr x14, 0xb83

    #Address 0xb83 Write value 0x70c58858
    li x3, 0x70c58858
    csrw 0xb83, x3

    #Address 0xb83 read value
    csrr x14, 0xb83

    #Address 0xb83 read value
    csrr x14, 0xb83

    #Unmapped address 0x2ae testing: random write/read operations
    #Address 0x2ae read value
    csrr x14, 0x2ae

    #Address 0x2ae read value
    csrr x14, 0x2ae

    #Address 0x2ae read value
    csrr x14, 0x2ae

    #Unmapped address 0x465 testing: random write/read operations
    #Address 0x465 read value
    csrr x14, 0x465

    #Address 0x465 Write value 0xba43339b
    li x3, 0xba43339b
    csrw 0x465, x3

    #Address 0x465 read value
    csrr x14, 0x465

    #Unmapped address 0xba testing: random write/read operations
    #Address 0xba read value
    csrr x14, 0xba

    #Unmapped address 0x4b5 testing: random write/read operations
    #Address 0x4b5 Write value 0x2394f2a2
    li x3, 0x2394f2a2
    csrw 0x4b5, x3

    #Unmapped address 0xf0b testing: random write/read operations
    #Address 0xf0b Write value 0xaa2ed20a
    li x3, 0xaa2ed20a
    csrw 0xf0b, x3

    #Address 0xf0b read value
    csrr x14, 0xf0b

    #Address 0xf0b read value
    csrr x14, 0xf0b

    #Address 0xf0b Write value 0xfecd551b
    li x3, 0xfecd551b
    csrw 0xf0b, x3

    #Unmapped address 0xbac testing: random write/read operations
    #Address 0xbac read value
    csrr x14, 0xbac

    #Unmapped address 0xe88 testing: random write/read operations
    #Address 0xe88 read value
    csrr x14, 0xe88

    #Address 0xe88 read value
    csrr x14, 0xe88

    #Address 0xe88 read value
    csrr x14, 0xe88

    #Address 0xe88 Write value 0x4c6674de
    li x3, 0x4c6674de
    csrw 0xe88, x3

    #Unmapped address 0xd23 testing: random write/read operations
    #Address 0xd23 Write value 0x7dac411f
    li x3, 0x7dac411f
    csrw 0xd23, x3

    #Address 0xd23 read value
    csrr x14, 0xd23

    #Address 0xd23 Write value 0x1a4fc59
    li x3, 0x1a4fc59
    csrw 0xd23, x3

    #Unmapped address 0xe8d testing: random write/read operations
    #Address 0xe8d Write value 0xc3be58ab
    li x3, 0xc3be58ab
    csrw 0xe8d, x3

    #Address 0xe8d read value
    csrr x14, 0xe8d

    #Address 0xe8d Write value 0x951f99e2
    li x3, 0x951f99e2
    csrw 0xe8d, x3

    #Address 0xe8d Write value 0x978c164e
    li x3, 0x978c164e
    csrw 0xe8d, x3

    #Address 0xe8d Write value 0x6a95df47
    li x3, 0x6a95df47
    csrw 0xe8d, x3

    #Unmapped address 0xa55 testing: random write/read operations
    #Address 0xa55 Write value 0xec61e3c8
    li x3, 0xec61e3c8
    csrw 0xa55, x3

    #Address 0xa55 read value
    csrr x14, 0xa55

    #Address 0xa55 read value
    csrr x14, 0xa55

    #Address 0xa55 Write value 0x54dea9c9
    li x3, 0x54dea9c9
    csrw 0xa55, x3

    #Unmapped address 0xb74 testing: random write/read operations
    #Address 0xb74 Write value 0xd506df0
    li x3, 0xd506df0
    csrw 0xb74, x3

    #Address 0xb74 Write value 0x5891eb41
    li x3, 0x5891eb41
    csrw 0xb74, x3

    #Unmapped address 0x5d6 testing: random write/read operations
    #Address 0x5d6 read value
    csrr x14, 0x5d6

    #Address 0x5d6 read value
    csrr x14, 0x5d6

    #Address 0x5d6 Write value 0xefda11d2
    li x3, 0xefda11d2
    csrw 0x5d6, x3

    #Address 0x5d6 read value
    csrr x14, 0x5d6

    #Address 0x5d6 Write value 0x2b38dc0c
    li x3, 0x2b38dc0c
    csrw 0x5d6, x3

    #Unmapped address 0xcd4 testing: random write/read operations
    #Address 0xcd4 read value
    csrr x14, 0xcd4

    #Unmapped address 0xbd0 testing: random write/read operations
    #Address 0xbd0 Write value 0x3a73aca6
    li x3, 0x3a73aca6
    csrw 0xbd0, x3

    #Address 0xbd0 Write value 0x30dcfae5
    li x3, 0x30dcfae5
    csrw 0xbd0, x3

    #Address 0xbd0 read value
    csrr x14, 0xbd0

    #Address 0xbd0 Write value 0x8111cf78
    li x3, 0x8111cf78
    csrw 0xbd0, x3

    #Address 0xbd0 read value
    csrr x14, 0xbd0

    #Unmapped address 0x603 testing: random write/read operations
    #Address 0x603 Write value 0xfc145169
    li x3, 0xfc145169
    csrw 0x603, x3

    #Address 0x603 read value
    csrr x14, 0x603

    #Address 0x603 Write value 0xf7eed8cf
    li x3, 0xf7eed8cf
    csrw 0x603, x3

    #Address 0x603 Write value 0xf6e282a4
    li x3, 0xf6e282a4
    csrw 0x603, x3

    #Address 0x603 Write value 0x2dbc2bd9
    li x3, 0x2dbc2bd9
    csrw 0x603, x3

    #Unmapped address 0x648 testing: random write/read operations
    #Address 0x648 read value
    csrr x14, 0x648

    #Unmapped address 0xd7c testing: random write/read operations
    #Address 0xd7c read value
    csrr x14, 0xd7c

    #Address 0xd7c Write value 0xbe810e4c
    li x3, 0xbe810e4c
    csrw 0xd7c, x3

    #Address 0xd7c read value
    csrr x14, 0xd7c

    #Address 0xd7c Write value 0x9a994735
    li x3, 0x9a994735
    csrw 0xd7c, x3

    #Unmapped address 0x47c testing: random write/read operations
    #Address 0x47c Write value 0x1d0ca254
    li x3, 0x1d0ca254
    csrw 0x47c, x3

    #Address 0x47c Write value 0x4b52ab8c
    li x3, 0x4b52ab8c
    csrw 0x47c, x3

    #Address 0x47c Write value 0xaf68923
    li x3, 0xaf68923
    csrw 0x47c, x3

    #Address 0x47c read value
    csrr x14, 0x47c

    #Address 0x47c Write value 0x3aed2941
    li x3, 0x3aed2941
    csrw 0x47c, x3

    #Unmapped address 0xdc8 testing: random write/read operations
    #Address 0xdc8 Write value 0x5293c003
    li x3, 0x5293c003
    csrw 0xdc8, x3

    #Address 0xdc8 read value
    csrr x14, 0xdc8

    #Address 0xdc8 read value
    csrr x14, 0xdc8

    #Address 0xdc8 read value
    csrr x14, 0xdc8

    #Unmapped address 0x187 testing: random write/read operations
    #Address 0x187 Write value 0xa2eed4f4
    li x3, 0xa2eed4f4
    csrw 0x187, x3

    #Address 0x187 Write value 0x232a921a
    li x3, 0x232a921a
    csrw 0x187, x3

    #Unmapped address 0xd99 testing: random write/read operations
    #Address 0xd99 Write value 0xb3e50536
    li x3, 0xb3e50536
    csrw 0xd99, x3

    #Address 0xd99 read value
    csrr x14, 0xd99

    #Address 0xd99 Write value 0xd83646a7
    li x3, 0xd83646a7
    csrw 0xd99, x3

    #Address 0xd99 Write value 0xea920269
    li x3, 0xea920269
    csrw 0xd99, x3

    #Unmapped address 0xc0d testing: random write/read operations
    #Address 0xc0d Write value 0xaee40ee1
    li x3, 0xaee40ee1
    csrw 0xc0d, x3

    #Address 0xc0d Write value 0xd8cd432a
    li x3, 0xd8cd432a
    csrw 0xc0d, x3

    #Address 0xc0d Write value 0x3c6ac7e4
    li x3, 0x3c6ac7e4
    csrw 0xc0d, x3

    #Unmapped address 0xc55 testing: random write/read operations
    #Address 0xc55 read value
    csrr x14, 0xc55

    #Address 0xc55 Write value 0xbe79bb6d
    li x3, 0xbe79bb6d
    csrw 0xc55, x3

    #Address 0xc55 read value
    csrr x14, 0xc55

    #Address 0xc55 Write value 0x3612b44a
    li x3, 0x3612b44a
    csrw 0xc55, x3

    #Address 0xc55 Write value 0x4db41fb2
    li x3, 0x4db41fb2
    csrw 0xc55, x3

    #Unmapped address 0x136 testing: random write/read operations
    #Address 0x136 read value
    csrr x14, 0x136

    #Unmapped address 0xfad testing: random write/read operations
    #Address 0xfad Write value 0xdf7b9ab5
    li x3, 0xdf7b9ab5
    csrw 0xfad, x3

    #Address 0xfad Write value 0x88557cc2
    li x3, 0x88557cc2
    csrw 0xfad, x3

    #Address 0xfad Write value 0x5984b4cc
    li x3, 0x5984b4cc
    csrw 0xfad, x3

    #Address 0xfad Write value 0x34d11f5d
    li x3, 0x34d11f5d
    csrw 0xfad, x3

    #Address 0xfad read value
    csrr x14, 0xfad

    #Unmapped address 0x8d5 testing: random write/read operations
    #Address 0x8d5 Write value 0xfee715c6
    li x3, 0xfee715c6
    csrw 0x8d5, x3

    #Unmapped address 0x45 testing: random write/read operations
    #Address 0x45 read value
    csrr x14, 0x45

    #Address 0x45 read value
    csrr x14, 0x45

    #Address 0x45 read value
    csrr x14, 0x45

    #Address 0x45 read value
    csrr x14, 0x45

    #Unmapped address 0x99 testing: random write/read operations
    #Address 0x99 Write value 0xc86d870b
    li x3, 0xc86d870b
    csrw 0x99, x3

    #Address 0x99 Write value 0xd3d9ec7a
    li x3, 0xd3d9ec7a
    csrw 0x99, x3

    #Address 0x99 Write value 0xc8baa006
    li x3, 0xc8baa006
    csrw 0x99, x3

    #Address 0x99 read value
    csrr x14, 0x99

    #Unmapped address 0x6aa testing: random write/read operations
    #Address 0x6aa Write value 0x8fce697f
    li x3, 0x8fce697f
    csrw 0x6aa, x3

    #Address 0x6aa Write value 0x3a9d4bd5
    li x3, 0x3a9d4bd5
    csrw 0x6aa, x3

    #Address 0x6aa Write value 0xc79bcca5
    li x3, 0xc79bcca5
    csrw 0x6aa, x3

    #Address 0x6aa read value
    csrr x14, 0x6aa

    #Address 0x6aa Write value 0x23187cb4
    li x3, 0x23187cb4
    csrw 0x6aa, x3

    #Unmapped address 0xef8 testing: random write/read operations
    #Address 0xef8 Write value 0x2e17e668
    li x3, 0x2e17e668
    csrw 0xef8, x3

    #Address 0xef8 Write value 0x90b24c0f
    li x3, 0x90b24c0f
    csrw 0xef8, x3

    #Address 0xef8 read value
    csrr x14, 0xef8

    #Unmapped address 0x844 testing: random write/read operations
    #Address 0x844 read value
    csrr x14, 0x844

    #Address 0x844 Write value 0x38be857
    li x3, 0x38be857
    csrw 0x844, x3

    #Address 0x844 read value
    csrr x14, 0x844

    #Address 0x844 Write value 0x1d7adb58
    li x3, 0x1d7adb58
    csrw 0x844, x3

    #Address 0x844 Write value 0x45d87b99
    li x3, 0x45d87b99
    csrw 0x844, x3

    #Unmapped address 0x4e0 testing: random write/read operations
    #Address 0x4e0 Write value 0xf8ffcbc1
    li x3, 0xf8ffcbc1
    csrw 0x4e0, x3

    #Address 0x4e0 Write value 0x817290a4
    li x3, 0x817290a4
    csrw 0x4e0, x3

    #Unmapped address 0xa34 testing: random write/read operations
    #Address 0xa34 read value
    csrr x14, 0xa34

    #Address 0xa34 read value
    csrr x14, 0xa34

    #Address 0xa34 read value
    csrr x14, 0xa34

    #Address 0xa34 read value
    csrr x14, 0xa34

    #Unmapped address 0x16e testing: random write/read operations
    #Address 0x16e read value
    csrr x14, 0x16e

    #Address 0x16e Write value 0x7ed12e92
    li x3, 0x7ed12e92
    csrw 0x16e, x3

    #Unmapped address 0xd0c testing: random write/read operations
    #Address 0xd0c Write value 0xddac1e49
    li x3, 0xddac1e49
    csrw 0xd0c, x3

    #Address 0xd0c read value
    csrr x14, 0xd0c

    #Address 0xd0c Write value 0xfe66171b
    li x3, 0xfe66171b
    csrw 0xd0c, x3

    #Unmapped address 0x2fd testing: random write/read operations
    #Address 0x2fd read value
    csrr x14, 0x2fd

    #Address 0x2fd Write value 0x47606084
    li x3, 0x47606084
    csrw 0x2fd, x3

    #Mapped address 0xb0d (mhpmcounter13) testing: random write/read operations
    #Address 0xb0d Write value 0xb9205fdb
    li x3, 0xb9205fdb
    csrw 0xb0d, x3

    #Mapped address 0x3b7 (pmpaddr7) testing: random write/read operations
    #Address 0x3b7 read value
    csrr x14, 0x3b7

    #Address 0x3b7 Write value 0x3cce57e4
    li x3, 0x3cce57e4
    csrw 0x3b7, x3

    #Unmapped address 0x387 testing: random write/read operations
    #Address 0x387 read value
    csrr x14, 0x387

    #Address 0x387 read value
    csrr x14, 0x387

    #Address 0x387 Write value 0x61ec876a
    li x3, 0x61ec876a
    csrw 0x387, x3

    #Unmapped address 0x68 testing: random write/read operations
    #Address 0x68 read value
    csrr x14, 0x68

    #Address 0x68 read value
    csrr x14, 0x68

    #Address 0x68 read value
    csrr x14, 0x68

    #Address 0x68 Write value 0x46841342
    li x3, 0x46841342
    csrw 0x68, x3

    #Address 0x68 Write value 0x9b037059
    li x3, 0x9b037059
    csrw 0x68, x3

    #Unmapped address 0xaff testing: random write/read operations
    #Address 0xaff read value
    csrr x14, 0xaff

    #Address 0xaff read value
    csrr x14, 0xaff

    #Mapped address 0xb8b (mhpmcounterh11) testing: random write/read operations
    #Address 0xb8b Write value 0xc669f030
    li x3, 0xc669f030
    csrw 0xb8b, x3

    #Address 0xb8b read value
    csrr x14, 0xb8b

    #Address 0xb8b Write value 0xc41fd4f2
    li x3, 0xc41fd4f2
    csrw 0xb8b, x3

    #Unmapped address 0xd1e testing: random write/read operations
    #Address 0xd1e read value
    csrr x14, 0xd1e

    #Address 0xd1e Write value 0x4d83d453
    li x3, 0x4d83d453
    csrw 0xd1e, x3

    #Address 0xd1e read value
    csrr x14, 0xd1e

    #Unmapped address 0xe01 testing: random write/read operations
    #Address 0xe01 read value
    csrr x14, 0xe01

    #Unmapped address 0xdc9 testing: random write/read operations
    #Address 0xdc9 Write value 0x9451c1a4
    li x3, 0x9451c1a4
    csrw 0xdc9, x3

    #Address 0xdc9 read value
    csrr x14, 0xdc9

    #Address 0xdc9 read value
    csrr x14, 0xdc9

    #Address 0xdc9 Write value 0x661a4aff
    li x3, 0x661a4aff
    csrw 0xdc9, x3

    #Unmapped address 0x181 testing: random write/read operations
    #Address 0x181 Write value 0x4ce855a9
    li x3, 0x4ce855a9
    csrw 0x181, x3

    #Address 0x181 Write value 0xe3c532ee
    li x3, 0xe3c532ee
    csrw 0x181, x3

    #Address 0x181 Write value 0xaddbfb61
    li x3, 0xaddbfb61
    csrw 0x181, x3

    #Address 0x181 Write value 0x6ce36880
    li x3, 0x6ce36880
    csrw 0x181, x3

    #Unmapped address 0xb4c testing: random write/read operations
    #Address 0xb4c read value
    csrr x14, 0xb4c

    #Address 0xb4c Write value 0xa90b6994
    li x3, 0xa90b6994
    csrw 0xb4c, x3

    #Address 0xb4c read value
    csrr x14, 0xb4c

    #Unmapped address 0x5c testing: random write/read operations
    #Address 0x5c read value
    csrr x14, 0x5c

    #Address 0x5c read value
    csrr x14, 0x5c

    #Address 0x5c Write value 0xeece8a9d
    li x3, 0xeece8a9d
    csrw 0x5c, x3

    #Address 0x5c read value
    csrr x14, 0x5c

    #Address 0x5c Write value 0x57b09e48
    li x3, 0x57b09e48
    csrw 0x5c, x3

    #Unmapped address 0x8d6 testing: random write/read operations
    #Address 0x8d6 read value
    csrr x14, 0x8d6

    #Address 0x8d6 read value
    csrr x14, 0x8d6

    #Unmapped address 0x4a5 testing: random write/read operations
    #Address 0x4a5 Write value 0x166c40fc
    li x3, 0x166c40fc
    csrw 0x4a5, x3

    #Address 0x4a5 Write value 0x5980a179
    li x3, 0x5980a179
    csrw 0x4a5, x3

    #Address 0x4a5 read value
    csrr x14, 0x4a5

    #Address 0x4a5 read value
    csrr x14, 0x4a5

    #Address 0x4a5 read value
    csrr x14, 0x4a5

    #Unmapped address 0xbf3 testing: random write/read operations
    #Address 0xbf3 Write value 0x3f8ed3f6
    li x3, 0x3f8ed3f6
    csrw 0xbf3, x3

    #Address 0xbf3 read value
    csrr x14, 0xbf3

    #Address 0xbf3 Write value 0x554c274a
    li x3, 0x554c274a
    csrw 0xbf3, x3

    #Address 0xbf3 read value
    csrr x14, 0xbf3

    #Address 0xbf3 Write value 0x95071637
    li x3, 0x95071637
    csrw 0xbf3, x3

    #Unmapped address 0x449 testing: random write/read operations
    #Address 0x449 Write value 0xfbef166a
    li x3, 0xfbef166a
    csrw 0x449, x3

    #Address 0x449 read value
    csrr x14, 0x449

    #Unmapped address 0x74b testing: random write/read operations
    #Address 0x74b Write value 0x2112c58b
    li x3, 0x2112c58b
    csrw 0x74b, x3

    #Address 0x74b Write value 0xcea2464e
    li x3, 0xcea2464e
    csrw 0x74b, x3

    #Address 0x74b read value
    csrr x14, 0x74b

    #Address 0x74b Write value 0x34902809
    li x3, 0x34902809
    csrw 0x74b, x3

    #Unmapped address 0x26a testing: random write/read operations
    #Address 0x26a Write value 0xf4efe662
    li x3, 0xf4efe662
    csrw 0x26a, x3

    #Address 0x26a Write value 0x4a59132d
    li x3, 0x4a59132d
    csrw 0x26a, x3

    #Address 0x26a read value
    csrr x14, 0x26a

    #Address 0x26a read value
    csrr x14, 0x26a

    #Unmapped address 0xd70 testing: random write/read operations
    #Address 0xd70 Write value 0xb5a68ff9
    li x3, 0xb5a68ff9
    csrw 0xd70, x3

    #Unmapped address 0xd02 testing: random write/read operations
    #Address 0xd02 Write value 0xf93d1022
    li x3, 0xf93d1022
    csrw 0xd02, x3

    #Address 0xd02 Write value 0x7db8073b
    li x3, 0x7db8073b
    csrw 0xd02, x3

    #Unmapped address 0x88d testing: random write/read operations
    #Address 0x88d read value
    csrr x14, 0x88d

    #Address 0x88d read value
    csrr x14, 0x88d

    #Unmapped address 0x749 testing: random write/read operations
    #Address 0x749 read value
    csrr x14, 0x749

    #Address 0x749 read value
    csrr x14, 0x749

    #Address 0x749 Write value 0xbd7d57bf
    li x3, 0xbd7d57bf
    csrw 0x749, x3

    #Address 0x749 read value
    csrr x14, 0x749

    #Unmapped address 0x2a9 testing: random write/read operations
    #Address 0x2a9 Write value 0x65210169
    li x3, 0x65210169
    csrw 0x2a9, x3

    #Unmapped address 0x4d3 testing: random write/read operations
    #Address 0x4d3 Write value 0x5aed28b0
    li x3, 0x5aed28b0
    csrw 0x4d3, x3

    #Address 0x4d3 Write value 0x46730c35
    li x3, 0x46730c35
    csrw 0x4d3, x3

    #Address 0x4d3 Write value 0xd80d059c
    li x3, 0xd80d059c
    csrw 0x4d3, x3

    #Unmapped address 0x7e1 testing: random write/read operations
    #Address 0x7e1 Write value 0x57118e79
    li x3, 0x57118e79
    csrw 0x7e1, x3

    #Address 0x7e1 Write value 0x8d9cdb46
    li x3, 0x8d9cdb46
    csrw 0x7e1, x3

    #Unmapped address 0x4bf testing: random write/read operations
    #Address 0x4bf read value
    csrr x14, 0x4bf

    #Address 0x4bf Write value 0xae836ead
    li x3, 0xae836ead
    csrw 0x4bf, x3

    #Address 0x4bf read value
    csrr x14, 0x4bf

    #Address 0x4bf Write value 0x46cf7f38
    li x3, 0x46cf7f38
    csrw 0x4bf, x3

    #Unmapped address 0xea7 testing: random write/read operations
    #Address 0xea7 read value
    csrr x14, 0xea7

    #Unmapped address 0x1c9 testing: random write/read operations
    #Address 0x1c9 Write value 0x92da785
    li x3, 0x92da785
    csrw 0x1c9, x3

    #Address 0x1c9 read value
    csrr x14, 0x1c9

    #Address 0x1c9 read value
    csrr x14, 0x1c9

    #Address 0x1c9 Write value 0x492b6498
    li x3, 0x492b6498
    csrw 0x1c9, x3

    #Address 0x1c9 read value
    csrr x14, 0x1c9

    #Unmapped address 0x299 testing: random write/read operations
    #Address 0x299 Write value 0xd4650ac4
    li x3, 0xd4650ac4
    csrw 0x299, x3

    #Address 0x299 read value
    csrr x14, 0x299

    #Address 0x299 Write value 0x6273e384
    li x3, 0x6273e384
    csrw 0x299, x3

    #Unmapped address 0x1b8 testing: random write/read operations
    #Address 0x1b8 Write value 0x995347
    li x3, 0x995347
    csrw 0x1b8, x3

    #Address 0x1b8 read value
    csrr x14, 0x1b8

    #Unmapped address 0x1ae testing: random write/read operations
    #Address 0x1ae read value
    csrr x14, 0x1ae

    #Unmapped address 0x432 testing: random write/read operations
    #Address 0x432 Write value 0x5d5dc526
    li x3, 0x5d5dc526
    csrw 0x432, x3

    #Address 0x432 read value
    csrr x14, 0x432

    #Address 0x432 Write value 0xf8309b27
    li x3, 0xf8309b27
    csrw 0x432, x3

    #Address 0x432 read value
    csrr x14, 0x432

    #Unmapped address 0xf1c testing: random write/read operations
    #Address 0xf1c read value
    csrr x14, 0xf1c

    #Address 0xf1c read value
    csrr x14, 0xf1c

    #Address 0xf1c read value
    csrr x14, 0xf1c

    #Address 0xf1c Write value 0xc4898f4a
    li x3, 0xc4898f4a
    csrw 0xf1c, x3

    #Unmapped address 0xc77 testing: random write/read operations
    #Address 0xc77 Write value 0x92e425db
    li x3, 0x92e425db
    csrw 0xc77, x3

    #Address 0xc77 read value
    csrr x14, 0xc77

    #Unmapped address 0xefc testing: random write/read operations
    #Address 0xefc read value
    csrr x14, 0xefc

    #Address 0xefc Write value 0xebf3fc80
    li x3, 0xebf3fc80
    csrw 0xefc, x3

    #Unmapped address 0xaa3 testing: random write/read operations
    #Address 0xaa3 read value
    csrr x14, 0xaa3

    #Address 0xaa3 Write value 0x184f9140
    li x3, 0x184f9140
    csrw 0xaa3, x3

    #Address 0xaa3 read value
    csrr x14, 0xaa3

    #Address 0xaa3 Write value 0xc913df50
    li x3, 0xc913df50
    csrw 0xaa3, x3

    #Unmapped address 0x2e8 testing: random write/read operations
    #Address 0x2e8 read value
    csrr x14, 0x2e8

    #Address 0x2e8 read value
    csrr x14, 0x2e8

    #Address 0x2e8 read value
    csrr x14, 0x2e8

    #Unmapped address 0x1d0 testing: random write/read operations
    #Address 0x1d0 read value
    csrr x14, 0x1d0

    #Address 0x1d0 Write value 0xb88c60e4
    li x3, 0xb88c60e4
    csrw 0x1d0, x3

    #Address 0x1d0 read value
    csrr x14, 0x1d0

    #Address 0x1d0 read value
    csrr x14, 0x1d0

    #Address 0x1d0 Write value 0xe35c0271
    li x3, 0xe35c0271
    csrw 0x1d0, x3

    #Unmapped address 0xa45 testing: random write/read operations
    #Address 0xa45 read value
    csrr x14, 0xa45

    #Address 0xa45 read value
    csrr x14, 0xa45

    #Address 0xa45 Write value 0x3d4a4778
    li x3, 0x3d4a4778
    csrw 0xa45, x3

    #Unmapped address 0x4bc testing: random write/read operations
    #Address 0x4bc read value
    csrr x14, 0x4bc

    #Address 0x4bc read value
    csrr x14, 0x4bc

    #Unmapped address 0x8d4 testing: random write/read operations
    #Address 0x8d4 read value
    csrr x14, 0x8d4

    #Unmapped address 0x922 testing: random write/read operations
    #Address 0x922 Write value 0x4ab2e805
    li x3, 0x4ab2e805
    csrw 0x922, x3

    #Address 0x922 Write value 0xd95040cb
    li x3, 0xd95040cb
    csrw 0x922, x3

    #Address 0x922 Write value 0x53aeda50
    li x3, 0x53aeda50
    csrw 0x922, x3

    #Address 0x922 read value
    csrr x14, 0x922

    #Unmapped address 0xea4 testing: random write/read operations
    #Address 0xea4 Write value 0xdd1f1f48
    li x3, 0xdd1f1f48
    csrw 0xea4, x3

    #Address 0xea4 read value
    csrr x14, 0xea4

    #Unmapped address 0x9b2 testing: random write/read operations
    #Address 0x9b2 read value
    csrr x14, 0x9b2

    #Unmapped address 0xe2e testing: random write/read operations
    #Address 0xe2e read value
    csrr x14, 0xe2e

    #Address 0xe2e Write value 0xb5ab2120
    li x3, 0xb5ab2120
    csrw 0xe2e, x3

    #Address 0xe2e read value
    csrr x14, 0xe2e

    #Unmapped address 0x7b3 testing: random write/read operations
    #Address 0x7b3 read value
    csrr x14, 0x7b3

    #Address 0x7b3 read value
    csrr x14, 0x7b3

    #Address 0x7b3 Write value 0x9dc90ea9
    li x3, 0x9dc90ea9
    csrw 0x7b3, x3

    #Unmapped address 0xae1 testing: random write/read operations
    #Address 0xae1 read value
    csrr x14, 0xae1

    #Address 0xae1 read value
    csrr x14, 0xae1

    #Address 0xae1 read value
    csrr x14, 0xae1

    #Unmapped address 0x222 testing: random write/read operations
    #Address 0x222 Write value 0x57b9bd3
    li x3, 0x57b9bd3
    csrw 0x222, x3

    #Address 0x222 read value
    csrr x14, 0x222

    #Unmapped address 0xb5c testing: random write/read operations
    #Address 0xb5c read value
    csrr x14, 0xb5c

    #Address 0xb5c Write value 0xece94aa9
    li x3, 0xece94aa9
    csrw 0xb5c, x3

    #Address 0xb5c Write value 0xee5338d9
    li x3, 0xee5338d9
    csrw 0xb5c, x3

    #Address 0xb5c read value
    csrr x14, 0xb5c

    #Unmapped address 0x480 testing: random write/read operations
    #Address 0x480 Write value 0x6a13512d
    li x3, 0x6a13512d
    csrw 0x480, x3

    #Mapped address 0xb92 (mhpmcounterh18) testing: random write/read operations
    #Address 0xb92 read value
    csrr x14, 0xb92

    #Address 0xb92 read value
    csrr x14, 0xb92

    #Address 0xb92 Write value 0x9cd33fea
    li x3, 0x9cd33fea
    csrw 0xb92, x3

    #Unmapped address 0xd2e testing: random write/read operations
    #Address 0xd2e Write value 0xcd74133c
    li x3, 0xcd74133c
    csrw 0xd2e, x3

    #Address 0xd2e Write value 0xbd1fb58
    li x3, 0xbd1fb58
    csrw 0xd2e, x3

    #Address 0xd2e Write value 0xe5884f02
    li x3, 0xe5884f02
    csrw 0xd2e, x3

    #Address 0xd2e read value
    csrr x14, 0xd2e

    #Unmapped address 0x8d2 testing: random write/read operations
    #Address 0x8d2 read value
    csrr x14, 0x8d2

    #Address 0x8d2 read value
    csrr x14, 0x8d2

    #Unmapped address 0xb54 testing: random write/read operations
    #Address 0xb54 read value
    csrr x14, 0xb54

    #Address 0xb54 Write value 0xe8fb8f7c
    li x3, 0xe8fb8f7c
    csrw 0xb54, x3

    #Address 0xb54 Write value 0x38225391
    li x3, 0x38225391
    csrw 0xb54, x3

    #Unmapped address 0x2b testing: random write/read operations
    #Address 0x2b Write value 0x3dfee666
    li x3, 0x3dfee666
    csrw 0x2b, x3

    #Address 0x2b Write value 0x16f02c0b
    li x3, 0x16f02c0b
    csrw 0x2b, x3

    #Address 0x2b read value
    csrr x14, 0x2b

    #Address 0x2b Write value 0x11f577e6
    li x3, 0x11f577e6
    csrw 0x2b, x3

    #Address 0x2b read value
    csrr x14, 0x2b

    #Unmapped address 0xa86 testing: random write/read operations
    #Address 0xa86 Write value 0x417822b4
    li x3, 0x417822b4
    csrw 0xa86, x3

    #Address 0xa86 read value
    csrr x14, 0xa86

    #Address 0xa86 Write value 0xffe6a584
    li x3, 0xffe6a584
    csrw 0xa86, x3

    #Address 0xa86 Write value 0x578f603f
    li x3, 0x578f603f
    csrw 0xa86, x3

    #Address 0xa86 Write value 0xf78c6dc5
    li x3, 0xf78c6dc5
    csrw 0xa86, x3

    #Unmapped address 0x130 testing: random write/read operations
    #Address 0x130 read value
    csrr x14, 0x130

    #Address 0x130 read value
    csrr x14, 0x130

    #Address 0x130 read value
    csrr x14, 0x130

    #Unmapped address 0x14a testing: random write/read operations
    #Address 0x14a read value
    csrr x14, 0x14a

    #Unmapped address 0xccc testing: random write/read operations
    #Address 0xccc Write value 0x7848b983
    li x3, 0x7848b983
    csrw 0xccc, x3

    #Address 0xccc read value
    csrr x14, 0xccc

    #Address 0xccc read value
    csrr x14, 0xccc

    #Unmapped address 0x5bb testing: random write/read operations
    #Address 0x5bb Write value 0xc2c2c8f
    li x3, 0xc2c2c8f
    csrw 0x5bb, x3

    #Unmapped address 0xedc testing: random write/read operations
    #Address 0xedc Write value 0x9fcf2ba8
    li x3, 0x9fcf2ba8
    csrw 0xedc, x3

    #Address 0xedc Write value 0x81f0c245
    li x3, 0x81f0c245
    csrw 0xedc, x3

    #Address 0xedc Write value 0xaa7d168a
    li x3, 0xaa7d168a
    csrw 0xedc, x3

    #Address 0xedc Write value 0xb7a6ab
    li x3, 0xb7a6ab
    csrw 0xedc, x3

    #Unmapped address 0x3e8 testing: random write/read operations
    #Address 0x3e8 read value
    csrr x14, 0x3e8

    #Address 0x3e8 read value
    csrr x14, 0x3e8

    #Address 0x3e8 Write value 0x3335d394
    li x3, 0x3335d394
    csrw 0x3e8, x3

    #Address 0x3e8 Write value 0x7acbf1de
    li x3, 0x7acbf1de
    csrw 0x3e8, x3

    #Unmapped address 0xb7 testing: random write/read operations
    #Address 0xb7 read value
    csrr x14, 0xb7

    #Address 0xb7 Write value 0x594f7588
    li x3, 0x594f7588
    csrw 0xb7, x3

    #Address 0xb7 read value
    csrr x14, 0xb7

    #Address 0xb7 read value
    csrr x14, 0xb7

    #Address 0xb7 read value
    csrr x14, 0xb7

    #Unmapped address 0x611 testing: random write/read operations
    #Address 0x611 read value
    csrr x14, 0x611

    #Address 0x611 read value
    csrr x14, 0x611

    #Address 0x611 Write value 0x62e889de
    li x3, 0x62e889de
    csrw 0x611, x3

    #Unmapped address 0xf29 testing: random write/read operations
    #Address 0xf29 read value
    csrr x14, 0xf29

    #Address 0xf29 read value
    csrr x14, 0xf29

    #Address 0xf29 Write value 0x3d04d809
    li x3, 0x3d04d809
    csrw 0xf29, x3

    #Address 0xf29 read value
    csrr x14, 0xf29

    #Unmapped address 0xf42 testing: random write/read operations
    #Address 0xf42 read value
    csrr x14, 0xf42

    #Address 0xf42 Write value 0xce6a6e4c
    li x3, 0xce6a6e4c
    csrw 0xf42, x3

    #Address 0xf42 Write value 0xd3348eb2
    li x3, 0xd3348eb2
    csrw 0xf42, x3

    #Address 0xf42 read value
    csrr x14, 0xf42

    #Unmapped address 0x585 testing: random write/read operations
    #Address 0x585 read value
    csrr x14, 0x585

    #Address 0x585 read value
    csrr x14, 0x585

    #Address 0x585 Write value 0xc7ce31ec
    li x3, 0xc7ce31ec
    csrw 0x585, x3

    #Address 0x585 read value
    csrr x14, 0x585

    #Address 0x585 read value
    csrr x14, 0x585

    #Unmapped address 0x158 testing: random write/read operations
    #Address 0x158 read value
    csrr x14, 0x158

    #Address 0x158 read value
    csrr x14, 0x158

    #Address 0x158 Write value 0x5c5fe9b9
    li x3, 0x5c5fe9b9
    csrw 0x158, x3

    #Unmapped address 0xa4f testing: random write/read operations
    #Address 0xa4f Write value 0x5a1c550d
    li x3, 0x5a1c550d
    csrw 0xa4f, x3

    #Address 0xa4f read value
    csrr x14, 0xa4f

    #Address 0xa4f read value
    csrr x14, 0xa4f

    #Address 0xa4f read value
    csrr x14, 0xa4f

    #Unmapped address 0x522 testing: random write/read operations
    #Address 0x522 read value
    csrr x14, 0x522

    #Address 0x522 read value
    csrr x14, 0x522

    #Unmapped address 0x5fc testing: random write/read operations
    #Address 0x5fc Write value 0x29d48c4e
    li x3, 0x29d48c4e
    csrw 0x5fc, x3

    #Address 0x5fc read value
    csrr x14, 0x5fc

    #Unmapped address 0x962 testing: random write/read operations
    #Address 0x962 Write value 0x1490675b
    li x3, 0x1490675b
    csrw 0x962, x3

    #Address 0x962 Write value 0xb0b7221c
    li x3, 0xb0b7221c
    csrw 0x962, x3

    #Address 0x962 Write value 0x75f878aa
    li x3, 0x75f878aa
    csrw 0x962, x3

    #Address 0x962 Write value 0x1f38fd8f
    li x3, 0x1f38fd8f
    csrw 0x962, x3

    #Unmapped address 0xaf testing: random write/read operations
    #Address 0xaf Write value 0x411567e4
    li x3, 0x411567e4
    csrw 0xaf, x3

    #Address 0xaf read value
    csrr x14, 0xaf

    #Address 0xaf Write value 0x152d724
    li x3, 0x152d724
    csrw 0xaf, x3

    #Address 0xaf read value
    csrr x14, 0xaf

    #Unmapped address 0xf67 testing: random write/read operations
    #Address 0xf67 read value
    csrr x14, 0xf67

    #Address 0xf67 read value
    csrr x14, 0xf67

    #Address 0xf67 Write value 0x675e3b82
    li x3, 0x675e3b82
    csrw 0xf67, x3

    #Address 0xf67 read value
    csrr x14, 0xf67

    #Unmapped address 0x651 testing: random write/read operations
    #Address 0x651 read value
    csrr x14, 0x651

    #Unmapped address 0xcc6 testing: random write/read operations
    #Address 0xcc6 Write value 0xaa3b3679
    li x3, 0xaa3b3679
    csrw 0xcc6, x3

    #Address 0xcc6 read value
    csrr x14, 0xcc6

    #Unmapped address 0xc10 testing: random write/read operations
    #Address 0xc10 Write value 0x9a23eca9
    li x3, 0x9a23eca9
    csrw 0xc10, x3

    #Address 0xc10 Write value 0xa920c511
    li x3, 0xa920c511
    csrw 0xc10, x3

    #Address 0xc10 read value
    csrr x14, 0xc10

    #Unmapped address 0x6b6 testing: random write/read operations
    #Address 0x6b6 read value
    csrr x14, 0x6b6

    #Address 0x6b6 Write value 0x86edb52a
    li x3, 0x86edb52a
    csrw 0x6b6, x3

    #Address 0x6b6 read value
    csrr x14, 0x6b6

    #Address 0x6b6 read value
    csrr x14, 0x6b6

    #Unmapped address 0xfc2 testing: random write/read operations
    #Address 0xfc2 Write value 0xcffb9f2
    li x3, 0xcffb9f2
    csrw 0xfc2, x3

    #Address 0xfc2 read value
    csrr x14, 0xfc2

    #Address 0xfc2 Write value 0x76aaac58
    li x3, 0x76aaac58
    csrw 0xfc2, x3

    #Address 0xfc2 Write value 0x3a21248a
    li x3, 0x3a21248a
    csrw 0xfc2, x3

    #Unmapped address 0x3f3 testing: random write/read operations
    #Address 0x3f3 Write value 0xf472d44
    li x3, 0xf472d44
    csrw 0x3f3, x3

    #Address 0x3f3 Write value 0xb05a0b36
    li x3, 0xb05a0b36
    csrw 0x3f3, x3

    #Address 0x3f3 Write value 0xc4bd28b3
    li x3, 0xc4bd28b3
    csrw 0x3f3, x3

    #Address 0x3f3 Write value 0x437b54dd
    li x3, 0x437b54dd
    csrw 0x3f3, x3

    #Unmapped address 0xd85 testing: random write/read operations
    #Address 0xd85 read value
    csrr x14, 0xd85

    #Address 0xd85 read value
    csrr x14, 0xd85

    #Address 0xd85 read value
    csrr x14, 0xd85

    #Address 0xd85 read value
    csrr x14, 0xd85

    #Unmapped address 0x852 testing: random write/read operations
    #Address 0x852 Write value 0xd93c0832
    li x3, 0xd93c0832
    csrw 0x852, x3

    #Address 0x852 Write value 0x945ed6ef
    li x3, 0x945ed6ef
    csrw 0x852, x3

    #Address 0x852 Write value 0xf13ac6ac
    li x3, 0xf13ac6ac
    csrw 0x852, x3

    #Address 0x852 read value
    csrr x14, 0x852

    #Address 0x852 read value
    csrr x14, 0x852

    #Unmapped address 0x6a6 testing: random write/read operations
    #Address 0x6a6 Write value 0xdfc2559e
    li x3, 0xdfc2559e
    csrw 0x6a6, x3

    #Address 0x6a6 read value
    csrr x14, 0x6a6

    #Address 0x6a6 Write value 0xcdf542c8
    li x3, 0xcdf542c8
    csrw 0x6a6, x3

    #Address 0x6a6 Write value 0x5ce8384
    li x3, 0x5ce8384
    csrw 0x6a6, x3

    #Unmapped address 0xd63 testing: random write/read operations
    #Address 0xd63 read value
    csrr x14, 0xd63

    #Address 0xd63 Write value 0x9a75b767
    li x3, 0x9a75b767
    csrw 0xd63, x3

    #Address 0xd63 read value
    csrr x14, 0xd63

    #Unmapped address 0x8e2 testing: random write/read operations
    #Address 0x8e2 read value
    csrr x14, 0x8e2

    #Address 0x8e2 Write value 0x88dc0ade
    li x3, 0x88dc0ade
    csrw 0x8e2, x3

    #Address 0x8e2 read value
    csrr x14, 0x8e2

    #Unmapped address 0x50b testing: random write/read operations
    #Address 0x50b read value
    csrr x14, 0x50b

    #Address 0x50b read value
    csrr x14, 0x50b

    #Address 0x50b read value
    csrr x14, 0x50b

    #Address 0x50b read value
    csrr x14, 0x50b

    #Address 0x50b read value
    csrr x14, 0x50b

    #Unmapped address 0xab testing: random write/read operations
    #Address 0xab Write value 0x2276641d
    li x3, 0x2276641d
    csrw 0xab, x3

    #Address 0xab read value
    csrr x14, 0xab

    #Address 0xab Write value 0x32a08c2
    li x3, 0x32a08c2
    csrw 0xab, x3

    #Address 0xab Write value 0x62de4057
    li x3, 0x62de4057
    csrw 0xab, x3

    #Unmapped address 0x12f testing: random write/read operations
    #Address 0x12f Write value 0x4633ea74
    li x3, 0x4633ea74
    csrw 0x12f, x3

    #Address 0x12f read value
    csrr x14, 0x12f

    #Address 0x12f Write value 0x272d1cc6
    li x3, 0x272d1cc6
    csrw 0x12f, x3

    #Unmapped address 0xf46 testing: random write/read operations
    #Address 0xf46 Write value 0x15440387
    li x3, 0x15440387
    csrw 0xf46, x3

    #Address 0xf46 read value
    csrr x14, 0xf46

    #Address 0xf46 Write value 0x5315f3c5
    li x3, 0x5315f3c5
    csrw 0xf46, x3

    #Unmapped address 0xd36 testing: random write/read operations
    #Address 0xd36 read value
    csrr x14, 0xd36

    #Address 0xd36 Write value 0x3b8022c2
    li x3, 0x3b8022c2
    csrw 0xd36, x3

    #Unmapped address 0x879 testing: random write/read operations
    #Address 0x879 Write value 0x929d065d
    li x3, 0x929d065d
    csrw 0x879, x3

    #Address 0x879 read value
    csrr x14, 0x879

    #Unmapped address 0x2af testing: random write/read operations
    #Address 0x2af Write value 0x5c250a8c
    li x3, 0x5c250a8c
    csrw 0x2af, x3

    #Address 0x2af Write value 0x51344296
    li x3, 0x51344296
    csrw 0x2af, x3

    #Address 0x2af read value
    csrr x14, 0x2af

    #Unmapped address 0x3c0 testing: random write/read operations
    #Address 0x3c0 Write value 0xc289c385
    li x3, 0xc289c385
    csrw 0x3c0, x3

    #Address 0x3c0 Write value 0xec700c62
    li x3, 0xec700c62
    csrw 0x3c0, x3

    #Address 0x3c0 read value
    csrr x14, 0x3c0

    #Unmapped address 0x639 testing: random write/read operations
    #Address 0x639 Write value 0x85e58f30
    li x3, 0x85e58f30
    csrw 0x639, x3

    #Address 0x639 Write value 0x7daeafab
    li x3, 0x7daeafab
    csrw 0x639, x3

    #Unmapped address 0xe69 testing: random write/read operations
    #Address 0xe69 Write value 0x85504fc6
    li x3, 0x85504fc6
    csrw 0xe69, x3

    #Address 0xe69 Write value 0xc031a4bf
    li x3, 0xc031a4bf
    csrw 0xe69, x3

    #Address 0xe69 Write value 0x5a34169c
    li x3, 0x5a34169c
    csrw 0xe69, x3

    #Address 0xe69 read value
    csrr x14, 0xe69

    #Address 0xe69 read value
    csrr x14, 0xe69

    #Unmapped address 0x2f4 testing: random write/read operations
    #Address 0x2f4 Write value 0xd737f824
    li x3, 0xd737f824
    csrw 0x2f4, x3

    #Unmapped address 0xe12 testing: random write/read operations
    #Address 0xe12 Write value 0x6074e1ac
    li x3, 0x6074e1ac
    csrw 0xe12, x3

    #Address 0xe12 read value
    csrr x14, 0xe12

    #Address 0xe12 read value
    csrr x14, 0xe12

    #Address 0xe12 read value
    csrr x14, 0xe12

    #Address 0xe12 Write value 0x5f800db2
    li x3, 0x5f800db2
    csrw 0xe12, x3

    #Unmapped address 0x90 testing: random write/read operations
    #Address 0x90 Write value 0xe4aefeeb
    li x3, 0xe4aefeeb
    csrw 0x90, x3

    #Unmapped address 0x230 testing: random write/read operations
    #Address 0x230 Write value 0x9d85a9ec
    li x3, 0x9d85a9ec
    csrw 0x230, x3

    #Unmapped address 0xce9 testing: random write/read operations
    #Address 0xce9 read value
    csrr x14, 0xce9

    #Address 0xce9 Write value 0xb819a426
    li x3, 0xb819a426
    csrw 0xce9, x3

    #Address 0xce9 Write value 0x1df7e791
    li x3, 0x1df7e791
    csrw 0xce9, x3

    #Address 0xce9 Write value 0x7a0edb36
    li x3, 0x7a0edb36
    csrw 0xce9, x3

    #Unmapped address 0x3cb testing: random write/read operations
    #Address 0x3cb Write value 0x111a0152
    li x3, 0x111a0152
    csrw 0x3cb, x3

    #Address 0x3cb Write value 0xf1b5afb5
    li x3, 0xf1b5afb5
    csrw 0x3cb, x3

    #Address 0x3cb Write value 0x8a877bec
    li x3, 0x8a877bec
    csrw 0x3cb, x3

    #Unmapped address 0x6b1 testing: random write/read operations
    #Address 0x6b1 Write value 0xa986de08
    li x3, 0xa986de08
    csrw 0x6b1, x3

    #Address 0x6b1 Write value 0xa76ae6f4
    li x3, 0xa76ae6f4
    csrw 0x6b1, x3

    #Address 0x6b1 Write value 0x404a7ee9
    li x3, 0x404a7ee9
    csrw 0x6b1, x3

    #Address 0x6b1 read value
    csrr x14, 0x6b1

    #Unmapped address 0xddc testing: random write/read operations
    #Address 0xddc read value
    csrr x14, 0xddc

    #Address 0xddc Write value 0xab5f9d87
    li x3, 0xab5f9d87
    csrw 0xddc, x3

    #Address 0xddc Write value 0xb0692046
    li x3, 0xb0692046
    csrw 0xddc, x3

    #Address 0xddc Write value 0x83b7c3cc
    li x3, 0x83b7c3cc
    csrw 0xddc, x3

    #Address 0xddc read value
    csrr x14, 0xddc

    #Unmapped address 0xccb testing: random write/read operations
    #Address 0xccb Write value 0xe0eee8d1
    li x3, 0xe0eee8d1
    csrw 0xccb, x3

    #Address 0xccb read value
    csrr x14, 0xccb

    #Unmapped address 0x71d testing: random write/read operations
    #Address 0x71d Write value 0xa350c50e
    li x3, 0xa350c50e
    csrw 0x71d, x3

    #Unmapped address 0x46b testing: random write/read operations
    #Address 0x46b read value
    csrr x14, 0x46b

    #Address 0x46b read value
    csrr x14, 0x46b

    #Address 0x46b read value
    csrr x14, 0x46b

    #Address 0x46b Write value 0x1d0c7aa5
    li x3, 0x1d0c7aa5
    csrw 0x46b, x3

    #Address 0x46b Write value 0x4d448c10
    li x3, 0x4d448c10
    csrw 0x46b, x3

    #Unmapped address 0xd2f testing: random write/read operations
    #Address 0xd2f Write value 0x7076ce9a
    li x3, 0x7076ce9a
    csrw 0xd2f, x3

    #Address 0xd2f Write value 0x9af6698f
    li x3, 0x9af6698f
    csrw 0xd2f, x3

    #Address 0xd2f Write value 0xb3cd77cb
    li x3, 0xb3cd77cb
    csrw 0xd2f, x3

    #Address 0xd2f read value
    csrr x14, 0xd2f

    #Address 0xd2f Write value 0xf627b6f8
    li x3, 0xf627b6f8
    csrw 0xd2f, x3

    #Unmapped address 0x55f testing: random write/read operations
    #Address 0x55f read value
    csrr x14, 0x55f

    #Address 0x55f Write value 0xd3abae15
    li x3, 0xd3abae15
    csrw 0x55f, x3

    #Address 0x55f Write value 0x2a12bbe2
    li x3, 0x2a12bbe2
    csrw 0x55f, x3

    #Unmapped address 0x15 testing: random write/read operations
    #Address 0x15 Write value 0xb779793e
    li x3, 0xb779793e
    csrw 0x15, x3

    #Address 0x15 read value
    csrr x14, 0x15

    #Address 0x15 read value
    csrr x14, 0x15

    #Address 0x15 Write value 0x963ab6d6
    li x3, 0x963ab6d6
    csrw 0x15, x3

    #Address 0x15 Write value 0xdb713edd
    li x3, 0xdb713edd
    csrw 0x15, x3

    #Unmapped address 0x2de testing: random write/read operations
    #Address 0x2de read value
    csrr x14, 0x2de

    #Address 0x2de read value
    csrr x14, 0x2de

    #Address 0x2de Write value 0xe399c586
    li x3, 0xe399c586
    csrw 0x2de, x3

    #Address 0x2de read value
    csrr x14, 0x2de

    #Unmapped address 0x38d testing: random write/read operations
    #Address 0x38d read value
    csrr x14, 0x38d

    #Address 0x38d read value
    csrr x14, 0x38d

    #Address 0x38d Write value 0x827193e3
    li x3, 0x827193e3
    csrw 0x38d, x3

    #Unmapped address 0x6f4 testing: random write/read operations
    #Address 0x6f4 Write value 0x2eeff0d6
    li x3, 0x2eeff0d6
    csrw 0x6f4, x3

    #Address 0x6f4 Write value 0xb146ca29
    li x3, 0xb146ca29
    csrw 0x6f4, x3

    #Address 0x6f4 read value
    csrr x14, 0x6f4

    #Address 0x6f4 read value
    csrr x14, 0x6f4

    #Unmapped address 0x81f testing: random write/read operations
    #Address 0x81f Write value 0x30544d0b
    li x3, 0x30544d0b
    csrw 0x81f, x3

    #Address 0x81f Write value 0x887cdc15
    li x3, 0x887cdc15
    csrw 0x81f, x3

    #Unmapped address 0xfdc testing: random write/read operations
    #Address 0xfdc read value
    csrr x14, 0xfdc

    #Address 0xfdc read value
    csrr x14, 0xfdc

    #Unmapped address 0x501 testing: random write/read operations
    #Address 0x501 read value
    csrr x14, 0x501

    #Address 0x501 read value
    csrr x14, 0x501

    #Address 0x501 read value
    csrr x14, 0x501

    #Address 0x501 Write value 0x69550d1b
    li x3, 0x69550d1b
    csrw 0x501, x3

    #Unmapped address 0xcc testing: random write/read operations
    #Address 0xcc read value
    csrr x14, 0xcc

    #Address 0xcc read value
    csrr x14, 0xcc

    #Address 0xcc Write value 0x5534d97a
    li x3, 0x5534d97a
    csrw 0xcc, x3

    #Address 0xcc read value
    csrr x14, 0xcc

    #Address 0xcc read value
    csrr x14, 0xcc

    #Unmapped address 0xf4d testing: random write/read operations
    #Address 0xf4d Write value 0xcf844423
    li x3, 0xcf844423
    csrw 0xf4d, x3

    #Address 0xf4d Write value 0xa27a018d
    li x3, 0xa27a018d
    csrw 0xf4d, x3

    #Unmapped address 0x401 testing: random write/read operations
    #Address 0x401 read value
    csrr x14, 0x401

    #Unmapped address 0xf75 testing: random write/read operations
    #Address 0xf75 read value
    csrr x14, 0xf75

    #Address 0xf75 read value
    csrr x14, 0xf75

    #Address 0xf75 Write value 0x69f65d5b
    li x3, 0x69f65d5b
    csrw 0xf75, x3

    #Unmapped address 0xfd4 testing: random write/read operations
    #Address 0xfd4 Write value 0xc4a1dfdd
    li x3, 0xc4a1dfdd
    csrw 0xfd4, x3

    #Unmapped address 0xc9b testing: random write/read operations
    #Address 0xc9b Write value 0xccd301c
    li x3, 0xccd301c
    csrw 0xc9b, x3

    #Address 0xc9b Write value 0xb08a2f7b
    li x3, 0xb08a2f7b
    csrw 0xc9b, x3

    #Address 0xc9b read value
    csrr x14, 0xc9b

    #Unmapped address 0xf0f testing: random write/read operations
    #Address 0xf0f read value
    csrr x14, 0xf0f

    #Address 0xf0f read value
    csrr x14, 0xf0f

    #Address 0xf0f read value
    csrr x14, 0xf0f

    #Address 0xf0f read value
    csrr x14, 0xf0f

    #Mapped address 0xf14 (mhartid) testing: random write/read operations
    #Address 0xf14 read value
    csrr x14, 0xf14

    #Address 0xf14 read value
    csrr x14, 0xf14

    #Unmapped address 0x718 testing: random write/read operations
    #Address 0x718 read value
    csrr x14, 0x718

    #Address 0x718 read value
    csrr x14, 0x718

    #Address 0x718 read value
    csrr x14, 0x718

    #Address 0x718 read value
    csrr x14, 0x718

    #Unmapped address 0x49b testing: random write/read operations
    #Address 0x49b read value
    csrr x14, 0x49b

    #Address 0x49b Write value 0xb60be686
    li x3, 0xb60be686
    csrw 0x49b, x3

    #Unmapped address 0x462 testing: random write/read operations
    #Address 0x462 read value
    csrr x14, 0x462

    #Unmapped address 0x9aa testing: random write/read operations
    #Address 0x9aa read value
    csrr x14, 0x9aa

    #Address 0x9aa Write value 0x72a50e43
    li x3, 0x72a50e43
    csrw 0x9aa, x3

    #Address 0x9aa Write value 0x9335bc92
    li x3, 0x9335bc92
    csrw 0x9aa, x3

    #Address 0x9aa Write value 0x9d1063e5
    li x3, 0x9d1063e5
    csrw 0x9aa, x3

    #Unmapped address 0xec9 testing: random write/read operations
    #Address 0xec9 read value
    csrr x14, 0xec9

    #Unmapped address 0xe97 testing: random write/read operations
    #Address 0xe97 Write value 0xc3fdda89
    li x3, 0xc3fdda89
    csrw 0xe97, x3

    #Unmapped address 0x6e4 testing: random write/read operations
    #Address 0x6e4 Write value 0x238a5e6a
    li x3, 0x238a5e6a
    csrw 0x6e4, x3

    #Address 0x6e4 read value
    csrr x14, 0x6e4

    #Address 0x6e4 read value
    csrr x14, 0x6e4

    #Unmapped address 0xeb0 testing: random write/read operations
    #Address 0xeb0 read value
    csrr x14, 0xeb0

    #Address 0xeb0 read value
    csrr x14, 0xeb0

    #Address 0xeb0 read value
    csrr x14, 0xeb0

    #Address 0xeb0 read value
    csrr x14, 0xeb0

    #Unmapped address 0x8ec testing: random write/read operations
    #Address 0x8ec Write value 0xe3fdfa5c
    li x3, 0xe3fdfa5c
    csrw 0x8ec, x3

    #Unmapped address 0x7d7 testing: random write/read operations
    #Address 0x7d7 Write value 0xae4a9fdc
    li x3, 0xae4a9fdc
    csrw 0x7d7, x3

    #Unmapped address 0x81 testing: random write/read operations
    #Address 0x81 read value
    csrr x14, 0x81

    #Address 0x81 read value
    csrr x14, 0x81

    #Unmapped address 0xae testing: random write/read operations
    #Address 0xae read value
    csrr x14, 0xae

    #Unmapped address 0x553 testing: random write/read operations
    #Address 0x553 Write value 0xcc59b224
    li x3, 0xcc59b224
    csrw 0x553, x3

    #Address 0x553 Write value 0x51e71914
    li x3, 0x51e71914
    csrw 0x553, x3

    #Unmapped address 0xa20 testing: random write/read operations
    #Address 0xa20 read value
    csrr x14, 0xa20

    #Address 0xa20 Write value 0x9b097134
    li x3, 0x9b097134
    csrw 0xa20, x3

    #Address 0xa20 read value
    csrr x14, 0xa20

    #Unmapped address 0xdeb testing: random write/read operations
    #Address 0xdeb read value
    csrr x14, 0xdeb

    #Address 0xdeb read value
    csrr x14, 0xdeb

    #Address 0xdeb read value
    csrr x14, 0xdeb

    #Address 0xdeb read value
    csrr x14, 0xdeb

    #Unmapped address 0x1f5 testing: random write/read operations
    #Address 0x1f5 Write value 0xbfd90258
    li x3, 0xbfd90258
    csrw 0x1f5, x3

    #Address 0x1f5 read value
    csrr x14, 0x1f5

    #Address 0x1f5 read value
    csrr x14, 0x1f5

    #Address 0x1f5 read value
    csrr x14, 0x1f5

    #Address 0x1f5 read value
    csrr x14, 0x1f5

    #Unmapped address 0xe82 testing: random write/read operations
    #Address 0xe82 Write value 0xd0cfd79c
    li x3, 0xd0cfd79c
    csrw 0xe82, x3

    #Address 0xe82 read value
    csrr x14, 0xe82

    #Address 0xe82 Write value 0xa87df498
    li x3, 0xa87df498
    csrw 0xe82, x3

    #Unmapped address 0x4c8 testing: random write/read operations
    #Address 0x4c8 Write value 0x9cf01968
    li x3, 0x9cf01968
    csrw 0x4c8, x3

    #Address 0x4c8 read value
    csrr x14, 0x4c8

    #Address 0x4c8 read value
    csrr x14, 0x4c8

    #Unmapped address 0x6cc testing: random write/read operations
    #Address 0x6cc read value
    csrr x14, 0x6cc

    #Unmapped address 0x917 testing: random write/read operations
    #Address 0x917 Write value 0xd410a461
    li x3, 0xd410a461
    csrw 0x917, x3

    #Address 0x917 Write value 0x8fc0fb2d
    li x3, 0x8fc0fb2d
    csrw 0x917, x3

    #Address 0x917 read value
    csrr x14, 0x917

    #Address 0x917 read value
    csrr x14, 0x917

    #Unmapped address 0x55 testing: random write/read operations
    #Address 0x55 read value
    csrr x14, 0x55

    #Address 0x55 Write value 0xbd917817
    li x3, 0xbd917817
    csrw 0x55, x3

    #Address 0x55 Write value 0x29f42aca
    li x3, 0x29f42aca
    csrw 0x55, x3

    #Unmapped address 0xc2e testing: random write/read operations
    #Address 0xc2e Write value 0x76b1f9a8
    li x3, 0x76b1f9a8
    csrw 0xc2e, x3

    #Unmapped address 0xceb testing: random write/read operations
    #Address 0xceb Write value 0xf9ee32a1
    li x3, 0xf9ee32a1
    csrw 0xceb, x3

    #Unmapped address 0xd4f testing: random write/read operations
    #Address 0xd4f Write value 0x8e6d8b3f
    li x3, 0x8e6d8b3f
    csrw 0xd4f, x3

    #Unmapped address 0x529 testing: random write/read operations
    #Address 0x529 read value
    csrr x14, 0x529

    #Address 0x529 Write value 0xe4636cb7
    li x3, 0xe4636cb7
    csrw 0x529, x3

    #Address 0x529 Write value 0x80c381b9
    li x3, 0x80c381b9
    csrw 0x529, x3

    #Address 0x529 read value
    csrr x14, 0x529

    #Mapped address 0xb86 (mhpmcounterh6) testing: random write/read operations
    #Address 0xb86 read value
    csrr x14, 0xb86

    #Address 0xb86 read value
    csrr x14, 0xb86

    #Address 0xb86 Write value 0x79ef8207
    li x3, 0x79ef8207
    csrw 0xb86, x3

    #Unmapped address 0xa04 testing: random write/read operations
    #Address 0xa04 Write value 0x65fb7688
    li x3, 0x65fb7688
    csrw 0xa04, x3

    #Address 0xa04 read value
    csrr x14, 0xa04

    #Address 0xa04 Write value 0xa6d7da93
    li x3, 0xa6d7da93
    csrw 0xa04, x3

    #Address 0xa04 Write value 0x36c83238
    li x3, 0x36c83238
    csrw 0xa04, x3

    #Unmapped address 0x865 testing: random write/read operations
    #Address 0x865 Write value 0x9821dc7
    li x3, 0x9821dc7
    csrw 0x865, x3

    #Unmapped address 0x463 testing: random write/read operations
    #Address 0x463 read value
    csrr x14, 0x463

    #Address 0x463 read value
    csrr x14, 0x463

    #Address 0x463 read value
    csrr x14, 0x463

    #Address 0x463 read value
    csrr x14, 0x463

    #Address 0x463 Write value 0xc30ceeda
    li x3, 0xc30ceeda
    csrw 0x463, x3

    #Unmapped address 0x4e2 testing: random write/read operations
    #Address 0x4e2 read value
    csrr x14, 0x4e2

    #Address 0x4e2 read value
    csrr x14, 0x4e2

    #Unmapped address 0xffb testing: random write/read operations
    #Address 0xffb Write value 0x1e3057f2
    li x3, 0x1e3057f2
    csrw 0xffb, x3

    #Address 0xffb Write value 0xcbadd638
    li x3, 0xcbadd638
    csrw 0xffb, x3

    #Unmapped address 0xbf2 testing: random write/read operations
    #Address 0xbf2 Write value 0x16dde545
    li x3, 0x16dde545
    csrw 0xbf2, x3

    #Address 0xbf2 read value
    csrr x14, 0xbf2

    #Address 0xbf2 read value
    csrr x14, 0xbf2

    #Address 0xbf2 Write value 0xd3d49902
    li x3, 0xd3d49902
    csrw 0xbf2, x3

    #Address 0xbf2 read value
    csrr x14, 0xbf2

    #Unmapped address 0xfe9 testing: random write/read operations
    #Address 0xfe9 Write value 0xafa23007
    li x3, 0xafa23007
    csrw 0xfe9, x3

    #Unmapped address 0xf44 testing: random write/read operations
    #Address 0xf44 read value
    csrr x14, 0xf44

    #Address 0xf44 Write value 0x86e6365b
    li x3, 0x86e6365b
    csrw 0xf44, x3

    #Address 0xf44 Write value 0x4a72b67f
    li x3, 0x4a72b67f
    csrw 0xf44, x3

    #Address 0xf44 Write value 0xf7973a22
    li x3, 0xf7973a22
    csrw 0xf44, x3

    #Unmapped address 0xf8d testing: random write/read operations
    #Address 0xf8d read value
    csrr x14, 0xf8d

    #Address 0xf8d Write value 0x4cccec7c
    li x3, 0x4cccec7c
    csrw 0xf8d, x3

    #Address 0xf8d read value
    csrr x14, 0xf8d

    #Address 0xf8d read value
    csrr x14, 0xf8d

    #Address 0xf8d read value
    csrr x14, 0xf8d

    #Unmapped address 0x8ac testing: random write/read operations
    #Address 0x8ac Write value 0x85d3822d
    li x3, 0x85d3822d
    csrw 0x8ac, x3

    #Address 0x8ac Write value 0xc8d31c52
    li x3, 0xc8d31c52
    csrw 0x8ac, x3

    #Address 0x8ac read value
    csrr x14, 0x8ac

    #Address 0x8ac read value
    csrr x14, 0x8ac

    #Unmapped address 0xe5 testing: random write/read operations
    #Address 0xe5 read value
    csrr x14, 0xe5

    #Unmapped address 0xb43 testing: random write/read operations
    #Address 0xb43 read value
    csrr x14, 0xb43

    #Address 0xb43 Write value 0x6d4b7779
    li x3, 0x6d4b7779
    csrw 0xb43, x3

    #Address 0xb43 Write value 0x2672b35e
    li x3, 0x2672b35e
    csrw 0xb43, x3

    #Address 0xb43 Write value 0xfaf281ad
    li x3, 0xfaf281ad
    csrw 0xb43, x3

    #Unmapped address 0x541 testing: random write/read operations
    #Address 0x541 Write value 0xd20689a0
    li x3, 0xd20689a0
    csrw 0x541, x3

    #Address 0x541 read value
    csrr x14, 0x541

    #Unmapped address 0xed1 testing: random write/read operations
    #Address 0xed1 read value
    csrr x14, 0xed1

    #Unmapped address 0x618 testing: random write/read operations
    #Address 0x618 Write value 0xefff9811
    li x3, 0xefff9811
    csrw 0x618, x3

    #Address 0x618 Write value 0xd3c3716c
    li x3, 0xd3c3716c
    csrw 0x618, x3

    #Unmapped address 0xe6c testing: random write/read operations
    #Address 0xe6c read value
    csrr x14, 0xe6c

    #Address 0xe6c read value
    csrr x14, 0xe6c

    #Address 0xe6c Write value 0x4f59cbb5
    li x3, 0x4f59cbb5
    csrw 0xe6c, x3

    #Address 0xe6c read value
    csrr x14, 0xe6c

    #Address 0xe6c Write value 0x6a08d1
    li x3, 0x6a08d1
    csrw 0xe6c, x3

    #Unmapped address 0x4a6 testing: random write/read operations
    #Address 0x4a6 read value
    csrr x14, 0x4a6

    #Address 0x4a6 Write value 0xb9cb836d
    li x3, 0xb9cb836d
    csrw 0x4a6, x3

    #Address 0x4a6 Write value 0x11ba084b
    li x3, 0x11ba084b
    csrw 0x4a6, x3

    #Unmapped address 0xe17 testing: random write/read operations
    #Address 0xe17 Write value 0x46b2a611
    li x3, 0x46b2a611
    csrw 0xe17, x3

    #Address 0xe17 Write value 0x8461cb21
    li x3, 0x8461cb21
    csrw 0xe17, x3

    #Address 0xe17 read value
    csrr x14, 0xe17

    #Address 0xe17 read value
    csrr x14, 0xe17

    #Address 0xe17 Write value 0xc0423bf
    li x3, 0xc0423bf
    csrw 0xe17, x3

    #Unmapped address 0xdb2 testing: random write/read operations
    #Address 0xdb2 Write value 0xcd215203
    li x3, 0xcd215203
    csrw 0xdb2, x3

    #Unmapped address 0x41f testing: random write/read operations
    #Address 0x41f Write value 0x9e5ce492
    li x3, 0x9e5ce492
    csrw 0x41f, x3

    #Address 0x41f read value
    csrr x14, 0x41f

    #Address 0x41f read value
    csrr x14, 0x41f

    #Address 0x41f read value
    csrr x14, 0x41f

    #Unmapped address 0x5f6 testing: random write/read operations
    #Address 0x5f6 Write value 0xb2ecf717
    li x3, 0xb2ecf717
    csrw 0x5f6, x3

    #Unmapped address 0xdc6 testing: random write/read operations
    #Address 0xdc6 Write value 0xb74dcea2
    li x3, 0xb74dcea2
    csrw 0xdc6, x3

    #Unmapped address 0xfa1 testing: random write/read operations
    #Address 0xfa1 Write value 0x4770b6fb
    li x3, 0x4770b6fb
    csrw 0xfa1, x3

    #Address 0xfa1 Write value 0xbb39e664
    li x3, 0xbb39e664
    csrw 0xfa1, x3

    #Address 0xfa1 Write value 0x93481669
    li x3, 0x93481669
    csrw 0xfa1, x3

    #Unmapped address 0x442 testing: random write/read operations
    #Address 0x442 Write value 0x166b3d27
    li x3, 0x166b3d27
    csrw 0x442, x3

    #Address 0x442 read value
    csrr x14, 0x442

    #Address 0x442 Write value 0x355a94f3
    li x3, 0x355a94f3
    csrw 0x442, x3

    #Address 0x442 Write value 0x6cc67289
    li x3, 0x6cc67289
    csrw 0x442, x3

    #Address 0x442 Write value 0xec4b7a10
    li x3, 0xec4b7a10
    csrw 0x442, x3

    #Unmapped address 0x30c testing: random write/read operations
    #Address 0x30c Write value 0x70212c63
    li x3, 0x70212c63
    csrw 0x30c, x3

    #Address 0x30c read value
    csrr x14, 0x30c

    #Address 0x30c read value
    csrr x14, 0x30c

    #Unmapped address 0x6c4 testing: random write/read operations
    #Address 0x6c4 read value
    csrr x14, 0x6c4

    #Address 0x6c4 Write value 0x65a13577
    li x3, 0x65a13577
    csrw 0x6c4, x3

    #Address 0x6c4 Write value 0x50b123d9
    li x3, 0x50b123d9
    csrw 0x6c4, x3

    #Address 0x6c4 read value
    csrr x14, 0x6c4

    #Unmapped address 0x443 testing: random write/read operations
    #Address 0x443 Write value 0x60cb1e13
    li x3, 0x60cb1e13
    csrw 0x443, x3

    #Address 0x443 Write value 0x8688fa42
    li x3, 0x8688fa42
    csrw 0x443, x3

    #Unmapped address 0xf9 testing: random write/read operations
    #Address 0xf9 Write value 0x554e2346
    li x3, 0x554e2346
    csrw 0xf9, x3

    #Address 0xf9 read value
    csrr x14, 0xf9

    #Address 0xf9 Write value 0xc72fc65c
    li x3, 0xc72fc65c
    csrw 0xf9, x3

    #Address 0xf9 read value
    csrr x14, 0xf9

    #Unmapped address 0x634 testing: random write/read operations
    #Address 0x634 read value
    csrr x14, 0x634

    #Address 0x634 read value
    csrr x14, 0x634

    #Address 0x634 read value
    csrr x14, 0x634

    #Address 0x634 Write value 0x58cf8835
    li x3, 0x58cf8835
    csrw 0x634, x3

    #Address 0x634 Write value 0x9e2cbae8
    li x3, 0x9e2cbae8
    csrw 0x634, x3

    #Unmapped address 0xde8 testing: random write/read operations
    #Address 0xde8 Write value 0x738aaf3a
    li x3, 0x738aaf3a
    csrw 0xde8, x3

    #Address 0xde8 Write value 0xce3db3ec
    li x3, 0xce3db3ec
    csrw 0xde8, x3

    #Address 0xde8 read value
    csrr x14, 0xde8

    #Address 0xde8 Write value 0xf8f78671
    li x3, 0xf8f78671
    csrw 0xde8, x3

    #Unmapped address 0x7f5 testing: random write/read operations
    #Address 0x7f5 read value
    csrr x14, 0x7f5

    #Address 0x7f5 read value
    csrr x14, 0x7f5

    #Unmapped address 0x43b testing: random write/read operations
    #Address 0x43b read value
    csrr x14, 0x43b

    #Address 0x43b Write value 0x30d42527
    li x3, 0x30d42527
    csrw 0x43b, x3

    #Unmapped address 0x2a2 testing: random write/read operations
    #Address 0x2a2 Write value 0xf8c08703
    li x3, 0xf8c08703
    csrw 0x2a2, x3

    #Address 0x2a2 Write value 0xf452b4ad
    li x3, 0xf452b4ad
    csrw 0x2a2, x3

    #Address 0x2a2 Write value 0x37dbea83
    li x3, 0x37dbea83
    csrw 0x2a2, x3

    #Unmapped address 0xf40 testing: random write/read operations
    #Address 0xf40 Write value 0xd749f786
    li x3, 0xd749f786
    csrw 0xf40, x3

    #Address 0xf40 Write value 0x6fe55e04
    li x3, 0x6fe55e04
    csrw 0xf40, x3

    #Address 0xf40 Write value 0xa62c8199
    li x3, 0xa62c8199
    csrw 0xf40, x3

    #Unmapped address 0x3e4 testing: random write/read operations
    #Address 0x3e4 Write value 0xcb4f20cc
    li x3, 0xcb4f20cc
    csrw 0x3e4, x3

    #Address 0x3e4 Write value 0x71a95d9f
    li x3, 0x71a95d9f
    csrw 0x3e4, x3

    #Address 0x3e4 read value
    csrr x14, 0x3e4

    #Address 0x3e4 Write value 0xa0a60389
    li x3, 0xa0a60389
    csrw 0x3e4, x3

    #Address 0x3e4 read value
    csrr x14, 0x3e4

    #Unmapped address 0x864 testing: random write/read operations
    #Address 0x864 Write value 0xa2c02082
    li x3, 0xa2c02082
    csrw 0x864, x3

    #Address 0x864 read value
    csrr x14, 0x864

    #Address 0x864 Write value 0x9a672a25
    li x3, 0x9a672a25
    csrw 0x864, x3

    #Address 0x864 Write value 0x69c9a4a2
    li x3, 0x69c9a4a2
    csrw 0x864, x3

    #Address 0x864 read value
    csrr x14, 0x864

    #Unmapped address 0x450 testing: random write/read operations
    #Address 0x450 read value
    csrr x14, 0x450

    #Address 0x450 read value
    csrr x14, 0x450

    #Address 0x450 Write value 0x91adf497
    li x3, 0x91adf497
    csrw 0x450, x3

    #Address 0x450 Write value 0x12cb9c35
    li x3, 0x12cb9c35
    csrw 0x450, x3

    #Unmapped address 0x698 testing: random write/read operations
    #Address 0x698 read value
    csrr x14, 0x698

    #Unmapped address 0xe76 testing: random write/read operations
    #Address 0xe76 read value
    csrr x14, 0xe76

    #Address 0xe76 Write value 0xff6e5a34
    li x3, 0xff6e5a34
    csrw 0xe76, x3

    #Address 0xe76 read value
    csrr x14, 0xe76

    #Unmapped address 0xfbc testing: random write/read operations
    #Address 0xfbc read value
    csrr x14, 0xfbc

    #Address 0xfbc read value
    csrr x14, 0xfbc

    #Address 0xfbc read value
    csrr x14, 0xfbc

    #Address 0xfbc Write value 0xfb71b771
    li x3, 0xfb71b771
    csrw 0xfbc, x3

    #Address 0xfbc read value
    csrr x14, 0xfbc

    #Unmapped address 0xad4 testing: random write/read operations
    #Address 0xad4 read value
    csrr x14, 0xad4

    #Address 0xad4 read value
    csrr x14, 0xad4

    #Unmapped address 0xa95 testing: random write/read operations
    #Address 0xa95 read value
    csrr x14, 0xa95

    #Address 0xa95 Write value 0xfb438e84
    li x3, 0xfb438e84
    csrw 0xa95, x3

    #Unmapped address 0x8e7 testing: random write/read operations
    #Address 0x8e7 Write value 0xf18bde73
    li x3, 0xf18bde73
    csrw 0x8e7, x3

    #Unmapped address 0x8cc testing: random write/read operations
    #Address 0x8cc Write value 0x28f0642b
    li x3, 0x28f0642b
    csrw 0x8cc, x3

    #Address 0x8cc Write value 0x70aa5062
    li x3, 0x70aa5062
    csrw 0x8cc, x3

    #Address 0x8cc Write value 0x6444bf68
    li x3, 0x6444bf68
    csrw 0x8cc, x3

    #Address 0x8cc read value
    csrr x14, 0x8cc

    #Address 0x8cc Write value 0x9949256c
    li x3, 0x9949256c
    csrw 0x8cc, x3

    #Unmapped address 0x79b testing: random write/read operations
    #Address 0x79b Write value 0x4cf9f631
    li x3, 0x4cf9f631
    csrw 0x79b, x3

    #Address 0x79b read value
    csrr x14, 0x79b

    #Address 0x79b read value
    csrr x14, 0x79b

    #Address 0x79b read value
    csrr x14, 0x79b

    #Address 0x79b Write value 0x97281265
    li x3, 0x97281265
    csrw 0x79b, x3

    #Unmapped address 0x5b7 testing: random write/read operations
    #Address 0x5b7 read value
    csrr x14, 0x5b7

    #Unmapped address 0xfdd testing: random write/read operations
    #Address 0xfdd read value
    csrr x14, 0xfdd

    #Address 0xfdd Write value 0x6a0bdff0
    li x3, 0x6a0bdff0
    csrw 0xfdd, x3

    #Unmapped address 0x2a8 testing: random write/read operations
    #Address 0x2a8 read value
    csrr x14, 0x2a8

    #Address 0x2a8 read value
    csrr x14, 0x2a8

    #Address 0x2a8 read value
    csrr x14, 0x2a8

    #Address 0x2a8 read value
    csrr x14, 0x2a8

    #Unmapped address 0x1b2 testing: random write/read operations
    #Address 0x1b2 read value
    csrr x14, 0x1b2

    #Address 0x1b2 read value
    csrr x14, 0x1b2

    #Unmapped address 0x4a8 testing: random write/read operations
    #Address 0x4a8 read value
    csrr x14, 0x4a8

    #Unmapped address 0x296 testing: random write/read operations
    #Address 0x296 read value
    csrr x14, 0x296

    #Address 0x296 read value
    csrr x14, 0x296

    #Mapped address 0xc82 (instreth) testing: random write/read operations
    #Address 0xc82 Write value 0xa196c43
    li x3, 0xa196c43
    csrw 0xc82, x3

    #Address 0xc82 Write value 0xcd7418f7
    li x3, 0xcd7418f7
    csrw 0xc82, x3

    #Unmapped address 0xb5a testing: random write/read operations
    #Address 0xb5a Write value 0x557e3fa
    li x3, 0x557e3fa
    csrw 0xb5a, x3

    #Address 0xb5a read value
    csrr x14, 0xb5a

    #Address 0xb5a read value
    csrr x14, 0xb5a

    #Unmapped address 0x691 testing: random write/read operations
    #Address 0x691 Write value 0x2d91bd98
    li x3, 0x2d91bd98
    csrw 0x691, x3

    #Address 0x691 Write value 0x9e4da79b
    li x3, 0x9e4da79b
    csrw 0x691, x3

    #Unmapped address 0x9d4 testing: random write/read operations
    #Address 0x9d4 read value
    csrr x14, 0x9d4

    #Address 0x9d4 Write value 0xe45d3485
    li x3, 0xe45d3485
    csrw 0x9d4, x3

    #Address 0x9d4 read value
    csrr x14, 0x9d4

    #Address 0x9d4 Write value 0xc458ba26
    li x3, 0xc458ba26
    csrw 0x9d4, x3

    #Address 0x9d4 Write value 0x35e4053
    li x3, 0x35e4053
    csrw 0x9d4, x3

    #Unmapped address 0x3dd testing: random write/read operations
    #Address 0x3dd read value
    csrr x14, 0x3dd

    #Mapped address 0x301 (misa) testing: random write/read operations
    #Address 0x301 Write value 0xd1f69002
    li x3, 0xd1f69002
    csrw 0x301, x3

    #Address 0x301 Write value 0xf830ca84
    li x3, 0xf830ca84
    csrw 0x301, x3

    #Address 0x301 Write value 0xda3abe0f
    li x3, 0xda3abe0f
    csrw 0x301, x3

    #Address 0x301 read value
    csrr x14, 0x301

    #Address 0x301 Write value 0x83ff42c1
    li x3, 0x83ff42c1
    csrw 0x301, x3

    #Unmapped address 0x98e testing: random write/read operations
    #Address 0x98e Write value 0xf6dcf83c
    li x3, 0xf6dcf83c
    csrw 0x98e, x3

    #Unmapped address 0x7d2 testing: random write/read operations
    #Address 0x7d2 read value
    csrr x14, 0x7d2

    #Address 0x7d2 read value
    csrr x14, 0x7d2

    #Address 0x7d2 Write value 0xdf0547e7
    li x3, 0xdf0547e7
    csrw 0x7d2, x3

    #Unmapped address 0xadb testing: random write/read operations
    #Address 0xadb read value
    csrr x14, 0xadb

    #Address 0xadb read value
    csrr x14, 0xadb

    #Address 0xadb read value
    csrr x14, 0xadb

    #Address 0xadb read value
    csrr x14, 0xadb

    #Address 0xadb Write value 0x334067ce
    li x3, 0x334067ce
    csrw 0xadb, x3

    #Unmapped address 0xf37 testing: random write/read operations
    #Address 0xf37 read value
    csrr x14, 0xf37

    #Address 0xf37 Write value 0x42a19f95
    li x3, 0x42a19f95
    csrw 0xf37, x3

    #Address 0xf37 Write value 0x463fce7d
    li x3, 0x463fce7d
    csrw 0xf37, x3

    #Address 0xf37 Write value 0xb851d23c
    li x3, 0xb851d23c
    csrw 0xf37, x3

    #Unmapped address 0xb5d testing: random write/read operations
    #Address 0xb5d read value
    csrr x14, 0xb5d

    #Address 0xb5d read value
    csrr x14, 0xb5d

    #Address 0xb5d Write value 0x64f1f7a1
    li x3, 0x64f1f7a1
    csrw 0xb5d, x3

    #Address 0xb5d Write value 0xea995597
    li x3, 0xea995597
    csrw 0xb5d, x3

    #Unmapped address 0xa3f testing: random write/read operations
    #Address 0xa3f read value
    csrr x14, 0xa3f

    #Address 0xa3f Write value 0x662ed719
    li x3, 0x662ed719
    csrw 0xa3f, x3

    #Address 0xa3f Write value 0x9869307
    li x3, 0x9869307
    csrw 0xa3f, x3

    #Address 0xa3f Write value 0xadeaf800
    li x3, 0xadeaf800
    csrw 0xa3f, x3

    #Unmapped address 0x17e testing: random write/read operations
    #Address 0x17e read value
    csrr x14, 0x17e

    #Address 0x17e read value
    csrr x14, 0x17e

    #Address 0x17e read value
    csrr x14, 0x17e

    #Address 0x17e Write value 0xfbea99ce
    li x3, 0xfbea99ce
    csrw 0x17e, x3

    #Address 0x17e Write value 0x3ab762dd
    li x3, 0x3ab762dd
    csrw 0x17e, x3

    #Unmapped address 0xd77 testing: random write/read operations
    #Address 0xd77 Write value 0xbbbdc198
    li x3, 0xbbbdc198
    csrw 0xd77, x3

    #Unmapped address 0x762 testing: random write/read operations
    #Address 0x762 Write value 0xb1b5f09e
    li x3, 0xb1b5f09e
    csrw 0x762, x3

    #Address 0x762 read value
    csrr x14, 0x762

    #Unmapped address 0x61c testing: random write/read operations
    #Address 0x61c Write value 0x1903d3c0
    li x3, 0x1903d3c0
    csrw 0x61c, x3

    #Address 0x61c Write value 0x664c81ce
    li x3, 0x664c81ce
    csrw 0x61c, x3

    #Address 0x61c read value
    csrr x14, 0x61c

    #Address 0x61c read value
    csrr x14, 0x61c

    #Address 0x61c read value
    csrr x14, 0x61c

    #Unmapped address 0xa1e testing: random write/read operations
    #Address 0xa1e read value
    csrr x14, 0xa1e

    #Address 0xa1e Write value 0xc7647be2
    li x3, 0xc7647be2
    csrw 0xa1e, x3

    #Unmapped address 0xb4f testing: random write/read operations
    #Address 0xb4f Write value 0xc21fdd3b
    li x3, 0xc21fdd3b
    csrw 0xb4f, x3

    #Address 0xb4f Write value 0xad6a7786
    li x3, 0xad6a7786
    csrw 0xb4f, x3

    #Address 0xb4f Write value 0x212b032b
    li x3, 0x212b032b
    csrw 0xb4f, x3

    #Address 0xb4f Write value 0xcd9d68cc
    li x3, 0xcd9d68cc
    csrw 0xb4f, x3

    #Address 0xb4f Write value 0x22ca5cd
    li x3, 0x22ca5cd
    csrw 0xb4f, x3

    #Unmapped address 0x653 testing: random write/read operations
    #Address 0x653 read value
    csrr x14, 0x653

    #Address 0x653 Write value 0x3e5135a6
    li x3, 0x3e5135a6
    csrw 0x653, x3

    #Address 0x653 read value
    csrr x14, 0x653

    #Unmapped address 0xba8 testing: random write/read operations
    #Address 0xba8 Write value 0x52da05bf
    li x3, 0x52da05bf
    csrw 0xba8, x3

    #Address 0xba8 Write value 0x91b573dc
    li x3, 0x91b573dc
    csrw 0xba8, x3

    #Unmapped address 0x47b testing: random write/read operations
    #Address 0x47b Write value 0xd46c4fb7
    li x3, 0xd46c4fb7
    csrw 0x47b, x3

    #Address 0x47b read value
    csrr x14, 0x47b

    #Address 0x47b Write value 0xb89fb6b4
    li x3, 0xb89fb6b4
    csrw 0x47b, x3

    #Address 0x47b Write value 0x2cc2b471
    li x3, 0x2cc2b471
    csrw 0x47b, x3

    #Address 0x47b read value
    csrr x14, 0x47b

    #Unmapped address 0x2b3 testing: random write/read operations
    #Address 0x2b3 Write value 0x6e194409
    li x3, 0x6e194409
    csrw 0x2b3, x3

    #Address 0x2b3 Write value 0x2c697f5a
    li x3, 0x2c697f5a
    csrw 0x2b3, x3

    #Address 0x2b3 read value
    csrr x14, 0x2b3

    #Unmapped address 0xa43 testing: random write/read operations
    #Address 0xa43 Write value 0xe77a551e
    li x3, 0xe77a551e
    csrw 0xa43, x3

    #Unmapped address 0xc24 testing: random write/read operations
    #Address 0xc24 read value
    csrr x14, 0xc24

    #Unmapped address 0xe11 testing: random write/read operations
    #Address 0xe11 Write value 0x92db8aaa
    li x3, 0x92db8aaa
    csrw 0xe11, x3

    #Address 0xe11 read value
    csrr x14, 0xe11

    #Address 0xe11 Write value 0xde784b76
    li x3, 0xde784b76
    csrw 0xe11, x3

    #Address 0xe11 Write value 0x45ea3712
    li x3, 0x45ea3712
    csrw 0xe11, x3

    #Address 0xe11 Write value 0xcdef640f
    li x3, 0xcdef640f
    csrw 0xe11, x3

    #Unmapped address 0x7f6 testing: random write/read operations
    #Address 0x7f6 read value
    csrr x14, 0x7f6

    #Address 0x7f6 read value
    csrr x14, 0x7f6

    #Address 0x7f6 Write value 0xce68f464
    li x3, 0xce68f464
    csrw 0x7f6, x3

    #Unmapped address 0x667 testing: random write/read operations
    #Address 0x667 read value
    csrr x14, 0x667

    #Address 0x667 read value
    csrr x14, 0x667

    #Address 0x667 Write value 0x6d7859e1
    li x3, 0x6d7859e1
    csrw 0x667, x3

    #Address 0x667 read value
    csrr x14, 0x667

    #Unmapped address 0x2b8 testing: random write/read operations
    #Address 0x2b8 Write value 0x69f13ce
    li x3, 0x69f13ce
    csrw 0x2b8, x3

    #Unmapped address 0x9d9 testing: random write/read operations
    #Address 0x9d9 read value
    csrr x14, 0x9d9

    #Address 0x9d9 read value
    csrr x14, 0x9d9

    #Address 0x9d9 Write value 0x4a9086ea
    li x3, 0x4a9086ea
    csrw 0x9d9, x3

    #Unmapped address 0x350 testing: random write/read operations
    #Address 0x350 Write value 0x4a1dbe5f
    li x3, 0x4a1dbe5f
    csrw 0x350, x3

    #Unmapped address 0x65f testing: random write/read operations
    #Address 0x65f Write value 0x5f0ca0a4
    li x3, 0x5f0ca0a4
    csrw 0x65f, x3

    #Address 0x65f read value
    csrr x14, 0x65f

    #Address 0x65f Write value 0xf9c16ded
    li x3, 0xf9c16ded
    csrw 0x65f, x3

    #Address 0x65f read value
    csrr x14, 0x65f

    #Address 0x65f read value
    csrr x14, 0x65f

    #Unmapped address 0x6dd testing: random write/read operations
    #Address 0x6dd Write value 0x908a8c91
    li x3, 0x908a8c91
    csrw 0x6dd, x3

    #Unmapped address 0xb5f testing: random write/read operations
    #Address 0xb5f read value
    csrr x14, 0xb5f

    #Unmapped address 0x720 testing: random write/read operations
    #Address 0x720 read value
    csrr x14, 0x720

    #Address 0x720 Write value 0x8f9dd9b4
    li x3, 0x8f9dd9b4
    csrw 0x720, x3

    #Unmapped address 0x53d testing: random write/read operations
    #Address 0x53d Write value 0x8ac63b9
    li x3, 0x8ac63b9
    csrw 0x53d, x3

    #Unmapped address 0xde4 testing: random write/read operations
    #Address 0xde4 read value
    csrr x14, 0xde4

    #Unmapped address 0xbf9 testing: random write/read operations
    #Address 0xbf9 Write value 0x81f090e9
    li x3, 0x81f090e9
    csrw 0xbf9, x3

    #Address 0xbf9 Write value 0x20333b38
    li x3, 0x20333b38
    csrw 0xbf9, x3

    #Address 0xbf9 Write value 0x7927d056
    li x3, 0x7927d056
    csrw 0xbf9, x3

    #Unmapped address 0x5c1 testing: random write/read operations
    #Address 0x5c1 read value
    csrr x14, 0x5c1

    #Address 0x5c1 Write value 0x20a53026
    li x3, 0x20a53026
    csrw 0x5c1, x3

    #Address 0x5c1 read value
    csrr x14, 0x5c1

    #Unmapped address 0x11e testing: random write/read operations
    #Address 0x11e Write value 0xde34c13f
    li x3, 0xde34c13f
    csrw 0x11e, x3

    #Unmapped address 0xa83 testing: random write/read operations
    #Address 0xa83 read value
    csrr x14, 0xa83

    #Address 0xa83 read value
    csrr x14, 0xa83

    #Address 0xa83 Write value 0x79e0ddb0
    li x3, 0x79e0ddb0
    csrw 0xa83, x3

    #Address 0xa83 Write value 0x94f40d1a
    li x3, 0x94f40d1a
    csrw 0xa83, x3

    #Address 0xa83 read value
    csrr x14, 0xa83

    #Unmapped address 0x398 testing: random write/read operations
    #Address 0x398 read value
    csrr x14, 0x398

    #Address 0x398 read value
    csrr x14, 0x398

    #Unmapped address 0x83b testing: random write/read operations
    #Address 0x83b read value
    csrr x14, 0x83b

    #Address 0x83b read value
    csrr x14, 0x83b

    #Address 0x83b read value
    csrr x14, 0x83b

    #Address 0x83b Write value 0x41ea0b88
    li x3, 0x41ea0b88
    csrw 0x83b, x3

    #Address 0x83b Write value 0x62328c1d
    li x3, 0x62328c1d
    csrw 0x83b, x3

    #Unmapped address 0xb41 testing: random write/read operations
    #Address 0xb41 Write value 0x71a2331f
    li x3, 0x71a2331f
    csrw 0xb41, x3

    #Address 0xb41 Write value 0x5315f749
    li x3, 0x5315f749
    csrw 0xb41, x3

    #Address 0xb41 read value
    csrr x14, 0xb41

    #Unmapped address 0xcfd testing: random write/read operations
    #Address 0xcfd Write value 0xc21b5614
    li x3, 0xc21b5614
    csrw 0xcfd, x3

    #Address 0xcfd Write value 0x67a49c7f
    li x3, 0x67a49c7f
    csrw 0xcfd, x3

    #Unmapped address 0x6c7 testing: random write/read operations
    #Address 0x6c7 Write value 0x4cd75c90
    li x3, 0x4cd75c90
    csrw 0x6c7, x3

    #Address 0x6c7 Write value 0x303e5e81
    li x3, 0x303e5e81
    csrw 0x6c7, x3

    #Address 0x6c7 Write value 0xcda1555c
    li x3, 0xcda1555c
    csrw 0x6c7, x3

    #Address 0x6c7 read value
    csrr x14, 0x6c7

    #Unmapped address 0x39 testing: random write/read operations
    #Address 0x39 Write value 0xc3ddb15d
    li x3, 0xc3ddb15d
    csrw 0x39, x3

    #Address 0x39 Write value 0x4d0ea775
    li x3, 0x4d0ea775
    csrw 0x39, x3

    #Address 0x39 Write value 0xf3d204c3
    li x3, 0xf3d204c3
    csrw 0x39, x3

    #Address 0x39 Write value 0xe757328b
    li x3, 0xe757328b
    csrw 0x39, x3

    #Unmapped address 0x4e6 testing: random write/read operations
    #Address 0x4e6 Write value 0x2589505a
    li x3, 0x2589505a
    csrw 0x4e6, x3

    #Address 0x4e6 read value
    csrr x14, 0x4e6

    #Address 0x4e6 read value
    csrr x14, 0x4e6

    #Address 0x4e6 Write value 0xcb73e3f3
    li x3, 0xcb73e3f3
    csrw 0x4e6, x3

    #Unmapped address 0x8c7 testing: random write/read operations
    #Address 0x8c7 Write value 0x515c4ff4
    li x3, 0x515c4ff4
    csrw 0x8c7, x3

    #Address 0x8c7 Write value 0x2e3b622c
    li x3, 0x2e3b622c
    csrw 0x8c7, x3

    #Address 0x8c7 Write value 0x1a145c66
    li x3, 0x1a145c66
    csrw 0x8c7, x3

    #Address 0x8c7 Write value 0x9e2d71ae
    li x3, 0x9e2d71ae
    csrw 0x8c7, x3

    #Address 0x8c7 Write value 0xa4706618
    li x3, 0xa4706618
    csrw 0x8c7, x3

    #Unmapped address 0xa7 testing: random write/read operations
    #Address 0xa7 Write value 0x6cd808e0
    li x3, 0x6cd808e0
    csrw 0xa7, x3

    #Address 0xa7 Write value 0x4485a0a9
    li x3, 0x4485a0a9
    csrw 0xa7, x3

    #Unmapped address 0xd9b testing: random write/read operations
    #Address 0xd9b read value
    csrr x14, 0xd9b

    #Address 0xd9b read value
    csrr x14, 0xd9b

    #Address 0xd9b read value
    csrr x14, 0xd9b

    #Address 0xd9b Write value 0xd5271747
    li x3, 0xd5271747
    csrw 0xd9b, x3

    #Address 0xd9b read value
    csrr x14, 0xd9b

    #Unmapped address 0xe63 testing: random write/read operations
    #Address 0xe63 Write value 0x9b0d0a71
    li x3, 0x9b0d0a71
    csrw 0xe63, x3

    #Address 0xe63 read value
    csrr x14, 0xe63

    #Address 0xe63 Write value 0x11886f5
    li x3, 0x11886f5
    csrw 0xe63, x3

    #Address 0xe63 read value
    csrr x14, 0xe63

    #Unmapped address 0x178 testing: random write/read operations
    #Address 0x178 read value
    csrr x14, 0x178

    #Address 0x178 read value
    csrr x14, 0x178

    #Address 0x178 Write value 0x92d57b9a
    li x3, 0x92d57b9a
    csrw 0x178, x3

    #Address 0x178 Write value 0x3175d28
    li x3, 0x3175d28
    csrw 0x178, x3

    #Address 0x178 read value
    csrr x14, 0x178

    #Unmapped address 0xf1d testing: random write/read operations
    #Address 0xf1d Write value 0x896c858a
    li x3, 0x896c858a
    csrw 0xf1d, x3

    #Address 0xf1d read value
    csrr x14, 0xf1d

    #Address 0xf1d read value
    csrr x14, 0xf1d

    #Address 0xf1d read value
    csrr x14, 0xf1d

    #Unmapped address 0xe18 testing: random write/read operations
    #Address 0xe18 read value
    csrr x14, 0xe18

    #Address 0xe18 read value
    csrr x14, 0xe18

    #Address 0xe18 Write value 0x6649b626
    li x3, 0x6649b626
    csrw 0xe18, x3

    #Unmapped address 0xdca testing: random write/read operations
    #Address 0xdca read value
    csrr x14, 0xdca

    #Address 0xdca Write value 0x336dd59f
    li x3, 0x336dd59f
    csrw 0xdca, x3

    #Address 0xdca read value
    csrr x14, 0xdca

    #Unmapped address 0xc1a testing: random write/read operations
    #Address 0xc1a read value
    csrr x14, 0xc1a

    #Unmapped address 0xee2 testing: random write/read operations
    #Address 0xee2 read value
    csrr x14, 0xee2

    #Address 0xee2 Write value 0xbca25cfe
    li x3, 0xbca25cfe
    csrw 0xee2, x3

    #Unmapped address 0x295 testing: random write/read operations
    #Address 0x295 read value
    csrr x14, 0x295

    #Address 0x295 read value
    csrr x14, 0x295

    #Address 0x295 Write value 0x6df6f9b1
    li x3, 0x6df6f9b1
    csrw 0x295, x3

    #Address 0x295 read value
    csrr x14, 0x295

    #Address 0x295 read value
    csrr x14, 0x295

    #Unmapped address 0xef0 testing: random write/read operations
    #Address 0xef0 read value
    csrr x14, 0xef0

    #Unmapped address 0x6a1 testing: random write/read operations
    #Address 0x6a1 Write value 0xa4b0d3a9
    li x3, 0xa4b0d3a9
    csrw 0x6a1, x3

    #Address 0x6a1 read value
    csrr x14, 0x6a1

    #Address 0x6a1 read value
    csrr x14, 0x6a1

    #Address 0x6a1 Write value 0xc6b01484
    li x3, 0xc6b01484
    csrw 0x6a1, x3

    #Address 0x6a1 Write value 0x53255876
    li x3, 0x53255876
    csrw 0x6a1, x3

    #Unmapped address 0xe38 testing: random write/read operations
    #Address 0xe38 Write value 0x7ae0452a
    li x3, 0x7ae0452a
    csrw 0xe38, x3

    #Address 0xe38 read value
    csrr x14, 0xe38

    #Address 0xe38 read value
    csrr x14, 0xe38

    #Unmapped address 0xe33 testing: random write/read operations
    #Address 0xe33 read value
    csrr x14, 0xe33

    #Address 0xe33 read value
    csrr x14, 0xe33

    #Address 0xe33 read value
    csrr x14, 0xe33

    #Unmapped address 0x4 testing: random write/read operations
    #Address 0x4 Write value 0x23791dfc
    li x3, 0x23791dfc
    csrw 0x4, x3

    #Address 0x4 read value
    csrr x14, 0x4

    #Address 0x4 Write value 0x1664af67
    li x3, 0x1664af67
    csrw 0x4, x3

    #Address 0x4 read value
    csrr x14, 0x4

    #Address 0x4 read value
    csrr x14, 0x4

    #Unmapped address 0xbea testing: random write/read operations
    #Address 0xbea read value
    csrr x14, 0xbea

    #Address 0xbea read value
    csrr x14, 0xbea

    #Address 0xbea read value
    csrr x14, 0xbea

    #Address 0xbea Write value 0xb581d3f0
    li x3, 0xb581d3f0
    csrw 0xbea, x3

    #Unmapped address 0x696 testing: random write/read operations
    #Address 0x696 Write value 0x2f043687
    li x3, 0x2f043687
    csrw 0x696, x3

    #Address 0x696 read value
    csrr x14, 0x696

    #Address 0x696 read value
    csrr x14, 0x696

    #Address 0x696 Write value 0x49ec3e51
    li x3, 0x49ec3e51
    csrw 0x696, x3

    #Address 0x696 Write value 0x2d7fabb3
    li x3, 0x2d7fabb3
    csrw 0x696, x3

    #Unmapped address 0xa92 testing: random write/read operations
    #Address 0xa92 read value
    csrr x14, 0xa92

    #Address 0xa92 read value
    csrr x14, 0xa92

    #Address 0xa92 Write value 0x4220341e
    li x3, 0x4220341e
    csrw 0xa92, x3

    #Address 0xa92 Write value 0xb759e380
    li x3, 0xb759e380
    csrw 0xa92, x3

    #Address 0xa92 read value
    csrr x14, 0xa92

    #Unmapped address 0x129 testing: random write/read operations
    #Address 0x129 read value
    csrr x14, 0x129

    #Unmapped address 0x22e testing: random write/read operations
    #Address 0x22e Write value 0xfcbcc87b
    li x3, 0xfcbcc87b
    csrw 0x22e, x3

    #Unmapped address 0x5c9 testing: random write/read operations
    #Address 0x5c9 read value
    csrr x14, 0x5c9

    #Address 0x5c9 Write value 0xb984f821
    li x3, 0xb984f821
    csrw 0x5c9, x3

    #Unmapped address 0x491 testing: random write/read operations
    #Address 0x491 read value
    csrr x14, 0x491

    #Address 0x491 Write value 0x67c0e92d
    li x3, 0x67c0e92d
    csrw 0x491, x3

    #Address 0x491 Write value 0x25d0ddf
    li x3, 0x25d0ddf
    csrw 0x491, x3

    #Address 0x491 Write value 0x3279d41f
    li x3, 0x3279d41f
    csrw 0x491, x3

    #Unmapped address 0xb64 testing: random write/read operations
    #Address 0xb64 read value
    csrr x14, 0xb64

    #Address 0xb64 read value
    csrr x14, 0xb64

    #Unmapped address 0xf5 testing: random write/read operations
    #Address 0xf5 read value
    csrr x14, 0xf5

    #Address 0xf5 Write value 0x30eb5cb2
    li x3, 0x30eb5cb2
    csrw 0xf5, x3

    #Address 0xf5 read value
    csrr x14, 0xf5

    #Address 0xf5 Write value 0x924b67fd
    li x3, 0x924b67fd
    csrw 0xf5, x3

    #Unmapped address 0xb30 testing: random write/read operations
    #Address 0xb30 Write value 0x9c433353
    li x3, 0x9c433353
    csrw 0xb30, x3

    #Unmapped address 0xbe5 testing: random write/read operations
    #Address 0xbe5 Write value 0xde0812f0
    li x3, 0xde0812f0
    csrw 0xbe5, x3

    #Address 0xbe5 read value
    csrr x14, 0xbe5

    #Address 0xbe5 read value
    csrr x14, 0xbe5

    #Unmapped address 0x37a testing: random write/read operations
    #Address 0x37a read value
    csrr x14, 0x37a

    #Address 0x37a Write value 0x84cc95c2
    li x3, 0x84cc95c2
    csrw 0x37a, x3

    #Address 0x37a read value
    csrr x14, 0x37a

    #Address 0x37a Write value 0x4b19d89c
    li x3, 0x4b19d89c
    csrw 0x37a, x3

    #Address 0x37a Write value 0xe0632494
    li x3, 0xe0632494
    csrw 0x37a, x3

    #Unmapped address 0x437 testing: random write/read operations
    #Address 0x437 Write value 0xd86271e2
    li x3, 0xd86271e2
    csrw 0x437, x3

    #Address 0x437 Write value 0xd9aae5af
    li x3, 0xd9aae5af
    csrw 0x437, x3

    #Unmapped address 0xe41 testing: random write/read operations
    #Address 0xe41 read value
    csrr x14, 0xe41

    #Address 0xe41 Write value 0xd1e10d58
    li x3, 0xd1e10d58
    csrw 0xe41, x3

    #Address 0xe41 read value
    csrr x14, 0xe41

    #Address 0xe41 read value
    csrr x14, 0xe41

    #Address 0xe41 read value
    csrr x14, 0xe41

    #Unmapped address 0x4f4 testing: random write/read operations
    #Address 0x4f4 read value
    csrr x14, 0x4f4

    #Unmapped address 0x57c testing: random write/read operations
    #Address 0x57c read value
    csrr x14, 0x57c

    #Unmapped address 0x4c2 testing: random write/read operations
    #Address 0x4c2 read value
    csrr x14, 0x4c2

    #Address 0x4c2 read value
    csrr x14, 0x4c2

    #Address 0x4c2 Write value 0x87c8da7f
    li x3, 0x87c8da7f
    csrw 0x4c2, x3

    #Address 0x4c2 read value
    csrr x14, 0x4c2

    #Unmapped address 0xfa6 testing: random write/read operations
    #Address 0xfa6 Write value 0x6c2fb583
    li x3, 0x6c2fb583
    csrw 0xfa6, x3

    #Address 0xfa6 Write value 0x92a5201a
    li x3, 0x92a5201a
    csrw 0xfa6, x3

    #Address 0xfa6 read value
    csrr x14, 0xfa6

    #Unmapped address 0x84c testing: random write/read operations
    #Address 0x84c Write value 0xa2fdd986
    li x3, 0xa2fdd986
    csrw 0x84c, x3

    #Address 0x84c Write value 0xb49d32f3
    li x3, 0xb49d32f3
    csrw 0x84c, x3

    #Address 0x84c read value
    csrr x14, 0x84c

    #Address 0x84c read value
    csrr x14, 0x84c

    #Unmapped address 0x2fe testing: random write/read operations
    #Address 0x2fe Write value 0x9fcc0f63
    li x3, 0x9fcc0f63
    csrw 0x2fe, x3

    #Address 0x2fe read value
    csrr x14, 0x2fe

    #Address 0x2fe read value
    csrr x14, 0x2fe

    #Unmapped address 0x9e0 testing: random write/read operations
    #Address 0x9e0 Write value 0x909c64a
    li x3, 0x909c64a
    csrw 0x9e0, x3

    #Unmapped address 0x1e9 testing: random write/read operations
    #Address 0x1e9 read value
    csrr x14, 0x1e9

    #Address 0x1e9 read value
    csrr x14, 0x1e9

    #Address 0x1e9 Write value 0x240823e
    li x3, 0x240823e
    csrw 0x1e9, x3

    #Unmapped address 0x75d testing: random write/read operations
    #Address 0x75d Write value 0x378de8fc
    li x3, 0x378de8fc
    csrw 0x75d, x3

    #Address 0x75d read value
    csrr x14, 0x75d

    #Address 0x75d read value
    csrr x14, 0x75d

    #Address 0x75d read value
    csrr x14, 0x75d

    #Address 0x75d Write value 0xdca01d76
    li x3, 0xdca01d76
    csrw 0x75d, x3

    #Unmapped address 0xce1 testing: random write/read operations
    #Address 0xce1 Write value 0x4ba5b163
    li x3, 0x4ba5b163
    csrw 0xce1, x3

    #Address 0xce1 read value
    csrr x14, 0xce1

    #Address 0xce1 read value
    csrr x14, 0xce1

    #Address 0xce1 read value
    csrr x14, 0xce1

    #Unmapped address 0x897 testing: random write/read operations
    #Address 0x897 Write value 0x7048ef18
    li x3, 0x7048ef18
    csrw 0x897, x3

    #Unmapped address 0xe80 testing: random write/read operations
    #Address 0xe80 Write value 0xcce2c798
    li x3, 0xcce2c798
    csrw 0xe80, x3

    #Address 0xe80 Write value 0x50f351b
    li x3, 0x50f351b
    csrw 0xe80, x3

    #Unmapped address 0x8a3 testing: random write/read operations
    #Address 0x8a3 Write value 0xc4571a75
    li x3, 0xc4571a75
    csrw 0x8a3, x3

    #Address 0x8a3 Write value 0xcefc0666
    li x3, 0xcefc0666
    csrw 0x8a3, x3

    #Address 0x8a3 read value
    csrr x14, 0x8a3

    #Unmapped address 0xd97 testing: random write/read operations
    #Address 0xd97 Write value 0x7d4db852
    li x3, 0x7d4db852
    csrw 0xd97, x3

    #Address 0xd97 Write value 0xd03510c8
    li x3, 0xd03510c8
    csrw 0xd97, x3

    #Address 0xd97 Write value 0x95646de1
    li x3, 0x95646de1
    csrw 0xd97, x3

    #Address 0xd97 read value
    csrr x14, 0xd97

    #Unmapped address 0x7aa testing: random write/read operations
    #Address 0x7aa Write value 0x4d67afc1
    li x3, 0x4d67afc1
    csrw 0x7aa, x3

    #Unmapped address 0x739 testing: random write/read operations
    #Address 0x739 read value
    csrr x14, 0x739

    #Unmapped address 0xff4 testing: random write/read operations
    #Address 0xff4 read value
    csrr x14, 0xff4

    #Address 0xff4 read value
    csrr x14, 0xff4

    #Address 0xff4 read value
    csrr x14, 0xff4

    #Address 0xff4 read value
    csrr x14, 0xff4

    #Address 0xff4 read value
    csrr x14, 0xff4

    #Unmapped address 0x2c8 testing: random write/read operations
    #Address 0x2c8 read value
    csrr x14, 0x2c8

    #Address 0x2c8 Write value 0x103872e9
    li x3, 0x103872e9
    csrw 0x2c8, x3

    #Address 0x2c8 read value
    csrr x14, 0x2c8

    #Unmapped address 0xe44 testing: random write/read operations
    #Address 0xe44 Write value 0x95b42fa0
    li x3, 0x95b42fa0
    csrw 0xe44, x3

    #Unmapped address 0xb6 testing: random write/read operations
    #Address 0xb6 Write value 0xc91b6b9f
    li x3, 0xc91b6b9f
    csrw 0xb6, x3

    #Address 0xb6 Write value 0xe9683f4d
    li x3, 0xe9683f4d
    csrw 0xb6, x3

    #Unmapped address 0x311 testing: random write/read operations
    #Address 0x311 Write value 0x7e0faa1b
    li x3, 0x7e0faa1b
    csrw 0x311, x3

    #Address 0x311 Write value 0x50af5b6c
    li x3, 0x50af5b6c
    csrw 0x311, x3

    #Unmapped address 0xafa testing: random write/read operations
    #Address 0xafa Write value 0x521dc4e6
    li x3, 0x521dc4e6
    csrw 0xafa, x3

    #Address 0xafa read value
    csrr x14, 0xafa

    #Address 0xafa Write value 0xe78b5a65
    li x3, 0xe78b5a65
    csrw 0xafa, x3

    #Address 0xafa read value
    csrr x14, 0xafa

    #Unmapped address 0xff5 testing: random write/read operations
    #Address 0xff5 Write value 0x50472ea9
    li x3, 0x50472ea9
    csrw 0xff5, x3

    #Address 0xff5 read value
    csrr x14, 0xff5

    #Address 0xff5 read value
    csrr x14, 0xff5

    #Address 0xff5 read value
    csrr x14, 0xff5

    #Unmapped address 0x215 testing: random write/read operations
    #Address 0x215 Write value 0x9b0ce03f
    li x3, 0x9b0ce03f
    csrw 0x215, x3

    #Address 0x215 read value
    csrr x14, 0x215

    #Address 0x215 read value
    csrr x14, 0x215

    #Address 0x215 Write value 0x459ed298
    li x3, 0x459ed298
    csrw 0x215, x3

    #Address 0x215 Write value 0x97033973
    li x3, 0x97033973
    csrw 0x215, x3

    #Unmapped address 0xcf4 testing: random write/read operations
    #Address 0xcf4 Write value 0xd66bd3c7
    li x3, 0xd66bd3c7
    csrw 0xcf4, x3

    #Unmapped address 0x715 testing: random write/read operations
    #Address 0x715 Write value 0x32459a55
    li x3, 0x32459a55
    csrw 0x715, x3

    #Address 0x715 Write value 0x9e4fd6d1
    li x3, 0x9e4fd6d1
    csrw 0x715, x3

    #Address 0x715 read value
    csrr x14, 0x715

    #Address 0x715 read value
    csrr x14, 0x715

    #Unmapped address 0x9d1 testing: random write/read operations
    #Address 0x9d1 read value
    csrr x14, 0x9d1

    #Address 0x9d1 Write value 0xb0e7727
    li x3, 0xb0e7727
    csrw 0x9d1, x3

    #Address 0x9d1 Write value 0x4a5dc325
    li x3, 0x4a5dc325
    csrw 0x9d1, x3

    #Address 0x9d1 Write value 0xae06d2a2
    li x3, 0xae06d2a2
    csrw 0x9d1, x3

    #Address 0x9d1 Write value 0x9a7c117d
    li x3, 0x9a7c117d
    csrw 0x9d1, x3

    #Unmapped address 0x13e testing: random write/read operations
    #Address 0x13e Write value 0xd6233354
    li x3, 0xd6233354
    csrw 0x13e, x3

    #Address 0x13e Write value 0x7c23582a
    li x3, 0x7c23582a
    csrw 0x13e, x3

    #Address 0x13e Write value 0x620c1836
    li x3, 0x620c1836
    csrw 0x13e, x3

    #Address 0x13e Write value 0xc9f2a83c
    li x3, 0xc9f2a83c
    csrw 0x13e, x3

    #Unmapped address 0xbaf testing: random write/read operations
    #Address 0xbaf Write value 0x641c2180
    li x3, 0x641c2180
    csrw 0xbaf, x3

    #Unmapped address 0x7bd testing: random write/read operations
    #Address 0x7bd Write value 0xb9607786
    li x3, 0xb9607786
    csrw 0x7bd, x3

    #Address 0x7bd Write value 0x3c568ac2
    li x3, 0x3c568ac2
    csrw 0x7bd, x3

    #Unmapped address 0xc12 testing: random write/read operations
    #Address 0xc12 read value
    csrr x14, 0xc12

    #Address 0xc12 read value
    csrr x14, 0xc12

    #Unmapped address 0xeda testing: random write/read operations
    #Address 0xeda read value
    csrr x14, 0xeda

    #Address 0xeda read value
    csrr x14, 0xeda

    #Address 0xeda read value
    csrr x14, 0xeda

    #Address 0xeda Write value 0x5b864910
    li x3, 0x5b864910
    csrw 0xeda, x3

    #Unmapped address 0x824 testing: random write/read operations
    #Address 0x824 read value
    csrr x14, 0x824

    #Address 0x824 Write value 0x324be255
    li x3, 0x324be255
    csrw 0x824, x3

    #Address 0x824 Write value 0x636baeab
    li x3, 0x636baeab
    csrw 0x824, x3

    #Address 0x824 Write value 0x206b48be
    li x3, 0x206b48be
    csrw 0x824, x3

    #Address 0x824 read value
    csrr x14, 0x824

    #Unmapped address 0x823 testing: random write/read operations
    #Address 0x823 Write value 0x90069207
    li x3, 0x90069207
    csrw 0x823, x3

    #Unmapped address 0xce3 testing: random write/read operations
    #Address 0xce3 read value
    csrr x14, 0xce3

    #Address 0xce3 read value
    csrr x14, 0xce3

    #Address 0xce3 Write value 0x8432a75a
    li x3, 0x8432a75a
    csrw 0xce3, x3

    #Unmapped address 0x6f7 testing: random write/read operations
    #Address 0x6f7 Write value 0xe391b9e7
    li x3, 0xe391b9e7
    csrw 0x6f7, x3

    #Address 0x6f7 Write value 0xfe51438
    li x3, 0xfe51438
    csrw 0x6f7, x3

    #Address 0x6f7 read value
    csrr x14, 0x6f7

    #Address 0x6f7 Write value 0x494dce73
    li x3, 0x494dce73
    csrw 0x6f7, x3

    #Unmapped address 0x363 testing: random write/read operations
    #Address 0x363 Write value 0x90e8326
    li x3, 0x90e8326
    csrw 0x363, x3

    #Address 0x363 read value
    csrr x14, 0x363

    #Unmapped address 0x83 testing: random write/read operations
    #Address 0x83 read value
    csrr x14, 0x83

    #Address 0x83 Write value 0xf1db0772
    li x3, 0xf1db0772
    csrw 0x83, x3

    #Address 0x83 read value
    csrr x14, 0x83

    #Address 0x83 Write value 0x2edfcd09
    li x3, 0x2edfcd09
    csrw 0x83, x3

    #Address 0x83 read value
    csrr x14, 0x83

    #Unmapped address 0xacf testing: random write/read operations
    #Address 0xacf read value
    csrr x14, 0xacf

    #Address 0xacf Write value 0x87040b5d
    li x3, 0x87040b5d
    csrw 0xacf, x3

    #Unmapped address 0xf95 testing: random write/read operations
    #Address 0xf95 Write value 0x48c2b0f6
    li x3, 0x48c2b0f6
    csrw 0xf95, x3

    #Address 0xf95 read value
    csrr x14, 0xf95

    #Address 0xf95 Write value 0x63a18c32
    li x3, 0x63a18c32
    csrw 0xf95, x3

    #Address 0xf95 Write value 0xc13c18a
    li x3, 0xc13c18a
    csrw 0xf95, x3

    #Address 0xf95 Write value 0x8b82e3ab
    li x3, 0x8b82e3ab
    csrw 0xf95, x3

    #Unmapped address 0xb60 testing: random write/read operations
    #Address 0xb60 read value
    csrr x14, 0xb60

    #Address 0xb60 Write value 0x5f5911b7
    li x3, 0x5f5911b7
    csrw 0xb60, x3

    #Address 0xb60 read value
    csrr x14, 0xb60

    #Address 0xb60 read value
    csrr x14, 0xb60

    #Address 0xb60 read value
    csrr x14, 0xb60

    #Unmapped address 0xa2a testing: random write/read operations
    #Address 0xa2a read value
    csrr x14, 0xa2a

    #Address 0xa2a Write value 0x9e700e65
    li x3, 0x9e700e65
    csrw 0xa2a, x3

    #Unmapped address 0x264 testing: random write/read operations
    #Address 0x264 read value
    csrr x14, 0x264

    #Address 0x264 Write value 0x3e9fb128
    li x3, 0x3e9fb128
    csrw 0x264, x3

    #Address 0x264 Write value 0x82c7d192
    li x3, 0x82c7d192
    csrw 0x264, x3

    #Address 0x264 Write value 0x74f45838
    li x3, 0x74f45838
    csrw 0x264, x3

    #Address 0x264 read value
    csrr x14, 0x264

    #Unmapped address 0x150 testing: random write/read operations
    #Address 0x150 read value
    csrr x14, 0x150

    #Address 0x150 read value
    csrr x14, 0x150

    #Address 0x150 Write value 0x9e354bf7
    li x3, 0x9e354bf7
    csrw 0x150, x3

    #Address 0x150 Write value 0xd0cabd85
    li x3, 0xd0cabd85
    csrw 0x150, x3

    #Unmapped address 0x63 testing: random write/read operations
    #Address 0x63 Write value 0xf34e3e22
    li x3, 0xf34e3e22
    csrw 0x63, x3

    #Address 0x63 Write value 0x3310710a
    li x3, 0x3310710a
    csrw 0x63, x3

    #Address 0x63 read value
    csrr x14, 0x63

    #Address 0x63 read value
    csrr x14, 0x63

    #Mapped address 0x342 (mcause) testing: random write/read operations
    #Address 0x342 Write value 0xe85b71ef
    li x3, 0xe85b71ef
    csrw 0x342, x3

    #Unmapped address 0x1ec testing: random write/read operations
    #Address 0x1ec read value
    csrr x14, 0x1ec

    #Unmapped address 0x34d testing: random write/read operations
    #Address 0x34d read value
    csrr x14, 0x34d

    #Address 0x34d Write value 0xae246991
    li x3, 0xae246991
    csrw 0x34d, x3

    #Address 0x34d Write value 0xc4303246
    li x3, 0xc4303246
    csrw 0x34d, x3

    #Address 0x34d Write value 0x15430f6d
    li x3, 0x15430f6d
    csrw 0x34d, x3

    #Unmapped address 0x6d1 testing: random write/read operations
    #Address 0x6d1 Write value 0x75e65607
    li x3, 0x75e65607
    csrw 0x6d1, x3

    #Address 0x6d1 read value
    csrr x14, 0x6d1

    #Unmapped address 0x409 testing: random write/read operations
    #Address 0x409 Write value 0x91e85d3c
    li x3, 0x91e85d3c
    csrw 0x409, x3

    #Address 0x409 read value
    csrr x14, 0x409

    #Address 0x409 Write value 0x560603a2
    li x3, 0x560603a2
    csrw 0x409, x3

    #Unmapped address 0x361 testing: random write/read operations
    #Address 0x361 read value
    csrr x14, 0x361

    #Unmapped address 0x19a testing: random write/read operations
    #Address 0x19a Write value 0xac646854
    li x3, 0xac646854
    csrw 0x19a, x3

    #Address 0x19a read value
    csrr x14, 0x19a

    #Address 0x19a read value
    csrr x14, 0x19a

    #Address 0x19a Write value 0x8abb2eb9
    li x3, 0x8abb2eb9
    csrw 0x19a, x3

    #Unmapped address 0xe0b testing: random write/read operations
    #Address 0xe0b read value
    csrr x14, 0xe0b

    #Address 0xe0b read value
    csrr x14, 0xe0b

    #Unmapped address 0xc98 testing: random write/read operations
    #Address 0xc98 read value
    csrr x14, 0xc98

    #Address 0xc98 read value
    csrr x14, 0xc98

    #Unmapped address 0x2d9 testing: random write/read operations
    #Address 0x2d9 Write value 0x44cbfc97
    li x3, 0x44cbfc97
    csrw 0x2d9, x3

    #Address 0x2d9 read value
    csrr x14, 0x2d9

    #Address 0x2d9 Write value 0xa3c8c9fa
    li x3, 0xa3c8c9fa
    csrw 0x2d9, x3

    #Unmapped address 0x978 testing: random write/read operations
    #Address 0x978 read value
    csrr x14, 0x978

    #Address 0x978 read value
    csrr x14, 0x978

    #Address 0x978 Write value 0x6b9e87c7
    li x3, 0x6b9e87c7
    csrw 0x978, x3

    #Unmapped address 0x6bc testing: random write/read operations
    #Address 0x6bc Write value 0x2695b7cd
    li x3, 0x2695b7cd
    csrw 0x6bc, x3

    #Address 0x6bc read value
    csrr x14, 0x6bc

    #Address 0x6bc Write value 0x66e18960
    li x3, 0x66e18960
    csrw 0x6bc, x3

    #Unmapped address 0x184 testing: random write/read operations
    #Address 0x184 read value
    csrr x14, 0x184

    #Unmapped address 0xad testing: random write/read operations
    #Address 0xad Write value 0xb1041123
    li x3, 0xb1041123
    csrw 0xad, x3

    #Address 0xad Write value 0x1f07ff59
    li x3, 0x1f07ff59
    csrw 0xad, x3

    #Unmapped address 0xd testing: random write/read operations
    #Address 0xd Write value 0xf9565fd5
    li x3, 0xf9565fd5
    csrw 0xd, x3

    #Address 0xd read value
    csrr x14, 0xd

    #Address 0xd read value
    csrr x14, 0xd

    #Address 0xd read value
    csrr x14, 0xd

    #Address 0xd read value
    csrr x14, 0xd

    #Unmapped address 0x846 testing: random write/read operations
    #Address 0x846 read value
    csrr x14, 0x846

    #Unmapped address 0x7d4 testing: random write/read operations
    #Address 0x7d4 Write value 0x24029d33
    li x3, 0x24029d33
    csrw 0x7d4, x3

    #Address 0x7d4 read value
    csrr x14, 0x7d4

    #Address 0x7d4 Write value 0x8d4272c
    li x3, 0x8d4272c
    csrw 0x7d4, x3

    #Address 0x7d4 Write value 0x8a87229e
    li x3, 0x8a87229e
    csrw 0x7d4, x3

    #Unmapped address 0x19e testing: random write/read operations
    #Address 0x19e Write value 0x35588644
    li x3, 0x35588644
    csrw 0x19e, x3

    #Unmapped address 0xd7b testing: random write/read operations
    #Address 0xd7b Write value 0x9ee790df
    li x3, 0x9ee790df
    csrw 0xd7b, x3

    #Address 0xd7b Write value 0x6f5c6837
    li x3, 0x6f5c6837
    csrw 0xd7b, x3

    #Address 0xd7b Write value 0x3072a431
    li x3, 0x3072a431
    csrw 0xd7b, x3

    #Address 0xd7b Write value 0x228a0e78
    li x3, 0x228a0e78
    csrw 0xd7b, x3

    #Unmapped address 0x9f4 testing: random write/read operations
    #Address 0x9f4 read value
    csrr x14, 0x9f4

    #Address 0x9f4 read value
    csrr x14, 0x9f4

    #Unmapped address 0x7e0 testing: random write/read operations
    #Address 0x7e0 read value
    csrr x14, 0x7e0

    #Address 0x7e0 read value
    csrr x14, 0x7e0

    #Address 0x7e0 Write value 0x2cae38d6
    li x3, 0x2cae38d6
    csrw 0x7e0, x3

    #Address 0x7e0 Write value 0x9545d96d
    li x3, 0x9545d96d
    csrw 0x7e0, x3

    #Unmapped address 0x6ca testing: random write/read operations
    #Address 0x6ca read value
    csrr x14, 0x6ca

    #Address 0x6ca read value
    csrr x14, 0x6ca

    #Address 0x6ca Write value 0x3b13a9bd
    li x3, 0x3b13a9bd
    csrw 0x6ca, x3

    #Address 0x6ca Write value 0x663c0bd3
    li x3, 0x663c0bd3
    csrw 0x6ca, x3

    #Address 0x6ca Write value 0xd7e6f676
    li x3, 0xd7e6f676
    csrw 0x6ca, x3

    #Unmapped address 0xae0 testing: random write/read operations
    #Address 0xae0 read value
    csrr x14, 0xae0

    #Unmapped address 0x278 testing: random write/read operations
    #Address 0x278 read value
    csrr x14, 0x278

    #Address 0x278 Write value 0x16d39ae3
    li x3, 0x16d39ae3
    csrw 0x278, x3

    #Unmapped address 0x166 testing: random write/read operations
    #Address 0x166 Write value 0x10a3ac5b
    li x3, 0x10a3ac5b
    csrw 0x166, x3

    #Address 0x166 Write value 0xa24a2d5c
    li x3, 0xa24a2d5c
    csrw 0x166, x3

    #Unmapped address 0x96e testing: random write/read operations
    #Address 0x96e read value
    csrr x14, 0x96e

    #Address 0x96e read value
    csrr x14, 0x96e

    #Address 0x96e read value
    csrr x14, 0x96e

    #Unmapped address 0x63b testing: random write/read operations
    #Address 0x63b Write value 0xbd5e647b
    li x3, 0xbd5e647b
    csrw 0x63b, x3

    #Address 0x63b read value
    csrr x14, 0x63b

    #Unmapped address 0x474 testing: random write/read operations
    #Address 0x474 Write value 0x7187ef89
    li x3, 0x7187ef89
    csrw 0x474, x3

    #Address 0x474 Write value 0xaa8f85cf
    li x3, 0xaa8f85cf
    csrw 0x474, x3

    #Address 0x474 read value
    csrr x14, 0x474

    #Address 0x474 read value
    csrr x14, 0x474

    #Unmapped address 0xbe2 testing: random write/read operations
    #Address 0xbe2 Write value 0x3af565cc
    li x3, 0x3af565cc
    csrw 0xbe2, x3

    #Address 0xbe2 Write value 0x477f15d7
    li x3, 0x477f15d7
    csrw 0xbe2, x3

    #Address 0xbe2 Write value 0xc7cdfa83
    li x3, 0xc7cdfa83
    csrw 0xbe2, x3

    #Address 0xbe2 Write value 0xd8db99f5
    li x3, 0xd8db99f5
    csrw 0xbe2, x3

    #Address 0xbe2 Write value 0x34eafea7
    li x3, 0x34eafea7
    csrw 0xbe2, x3

    #Unmapped address 0xa06 testing: random write/read operations
    #Address 0xa06 Write value 0x248e8d29
    li x3, 0x248e8d29
    csrw 0xa06, x3

    #Address 0xa06 Write value 0xc13a970a
    li x3, 0xc13a970a
    csrw 0xa06, x3

    #Address 0xa06 Write value 0x741f9a5d
    li x3, 0x741f9a5d
    csrw 0xa06, x3

    #Address 0xa06 read value
    csrr x14, 0xa06

    #Address 0xa06 Write value 0x508c92f9
    li x3, 0x508c92f9
    csrw 0xa06, x3

    #Unmapped address 0x9e7 testing: random write/read operations
    #Address 0x9e7 read value
    csrr x14, 0x9e7

    #Unmapped address 0x6f5 testing: random write/read operations
    #Address 0x6f5 Write value 0x795dda07
    li x3, 0x795dda07
    csrw 0x6f5, x3

    #Unmapped address 0xfb3 testing: random write/read operations
    #Address 0xfb3 read value
    csrr x14, 0xfb3

    #Address 0xfb3 Write value 0x40166a44
    li x3, 0x40166a44
    csrw 0xfb3, x3

    #Address 0xfb3 read value
    csrr x14, 0xfb3

    #Unmapped address 0x473 testing: random write/read operations
    #Address 0x473 read value
    csrr x14, 0x473

    #Address 0x473 Write value 0x85f10138
    li x3, 0x85f10138
    csrw 0x473, x3

    #Address 0x473 read value
    csrr x14, 0x473

    #Address 0x473 Write value 0xa8365145
    li x3, 0xa8365145
    csrw 0x473, x3

    #Address 0x473 read value
    csrr x14, 0x473

    #Unmapped address 0xf68 testing: random write/read operations
    #Address 0xf68 read value
    csrr x14, 0xf68

    #Address 0xf68 Write value 0x23788bba
    li x3, 0x23788bba
    csrw 0xf68, x3

    #Address 0xf68 read value
    csrr x14, 0xf68

    #Address 0xf68 Write value 0x7dba3e96
    li x3, 0x7dba3e96
    csrw 0xf68, x3

    #Unmapped address 0xc21 testing: random write/read operations
    #Address 0xc21 Write value 0x438052a9
    li x3, 0x438052a9
    csrw 0xc21, x3

    #Address 0xc21 read value
    csrr x14, 0xc21

    #Address 0xc21 read value
    csrr x14, 0xc21

    #Address 0xc21 read value
    csrr x14, 0xc21

    #Address 0xc21 Write value 0xe5c5d4fb
    li x3, 0xe5c5d4fb
    csrw 0xc21, x3

    #Unmapped address 0x10f testing: random write/read operations
    #Address 0x10f Write value 0xfe9a3c1c
    li x3, 0xfe9a3c1c
    csrw 0x10f, x3

    #Address 0x10f read value
    csrr x14, 0x10f

    #Unmapped address 0x55e testing: random write/read operations
    #Address 0x55e Write value 0x3ebfc4a5
    li x3, 0x3ebfc4a5
    csrw 0x55e, x3

    #Address 0x55e read value
    csrr x14, 0x55e

    #Unmapped address 0x20e testing: random write/read operations
    #Address 0x20e read value
    csrr x14, 0x20e

    #Address 0x20e read value
    csrr x14, 0x20e

    #Address 0x20e Write value 0x52ea9402
    li x3, 0x52ea9402
    csrw 0x20e, x3

    #Unmapped address 0xeac testing: random write/read operations
    #Address 0xeac read value
    csrr x14, 0xeac

    #Address 0xeac Write value 0x3c2ed33
    li x3, 0x3c2ed33
    csrw 0xeac, x3

    #Address 0xeac Write value 0x10a96e02
    li x3, 0x10a96e02
    csrw 0xeac, x3

    #Address 0xeac Write value 0xf65fc96f
    li x3, 0xf65fc96f
    csrw 0xeac, x3

    #Address 0xeac Write value 0x3fe21e74
    li x3, 0x3fe21e74
    csrw 0xeac, x3

    #Unmapped address 0x149 testing: random write/read operations
    #Address 0x149 Write value 0xb6551547
    li x3, 0xb6551547
    csrw 0x149, x3

    #Address 0x149 Write value 0xf56af598
    li x3, 0xf56af598
    csrw 0x149, x3

    #Address 0x149 read value
    csrr x14, 0x149

    #Address 0x149 Write value 0x3c47dc47
    li x3, 0x3c47dc47
    csrw 0x149, x3

    #Unmapped address 0xffc testing: random write/read operations
    #Address 0xffc Write value 0x18e8a60c
    li x3, 0x18e8a60c
    csrw 0xffc, x3

    #Address 0xffc Write value 0x1e5fd7d2
    li x3, 0x1e5fd7d2
    csrw 0xffc, x3

    #Unmapped address 0xf18 testing: random write/read operations
    #Address 0xf18 read value
    csrr x14, 0xf18

    #Unmapped address 0x57d testing: random write/read operations
    #Address 0x57d read value
    csrr x14, 0x57d

    #Address 0x57d Write value 0x78236eb3
    li x3, 0x78236eb3
    csrw 0x57d, x3

    #Unmapped address 0xd76 testing: random write/read operations
    #Address 0xd76 read value
    csrr x14, 0xd76

    #Address 0xd76 Write value 0x803754ae
    li x3, 0x803754ae
    csrw 0xd76, x3

    #Address 0xd76 read value
    csrr x14, 0xd76

    #Unmapped address 0xdda testing: random write/read operations
    #Address 0xdda read value
    csrr x14, 0xdda

    #Unmapped address 0x402 testing: random write/read operations
    #Address 0x402 Write value 0x2276ac88
    li x3, 0x2276ac88
    csrw 0x402, x3

    #Address 0x402 read value
    csrr x14, 0x402

    #Address 0x402 Write value 0xce453b01
    li x3, 0xce453b01
    csrw 0x402, x3

    #Address 0x402 Write value 0x553db612
    li x3, 0x553db612
    csrw 0x402, x3

    #Unmapped address 0x9ec testing: random write/read operations
    #Address 0x9ec read value
    csrr x14, 0x9ec

    #Unmapped address 0x7bc testing: random write/read operations
    #Address 0x7bc Write value 0xf7cbd297
    li x3, 0xf7cbd297
    csrw 0x7bc, x3

    #Address 0x7bc Write value 0x18344cfb
    li x3, 0x18344cfb
    csrw 0x7bc, x3

    #Address 0x7bc read value
    csrr x14, 0x7bc

    #Address 0x7bc Write value 0x31a1b4ee
    li x3, 0x31a1b4ee
    csrw 0x7bc, x3

    #Unmapped address 0xbc6 testing: random write/read operations
    #Address 0xbc6 read value
    csrr x14, 0xbc6

    #Address 0xbc6 read value
    csrr x14, 0xbc6

    #Address 0xbc6 read value
    csrr x14, 0xbc6

    #Unmapped address 0xf89 testing: random write/read operations
    #Address 0xf89 read value
    csrr x14, 0xf89

    #Address 0xf89 read value
    csrr x14, 0xf89

    #Address 0xf89 Write value 0x24b205a1
    li x3, 0x24b205a1
    csrw 0xf89, x3

    #Address 0xf89 Write value 0xc3a9a4ed
    li x3, 0xc3a9a4ed
    csrw 0xf89, x3

    #Unmapped address 0x8f8 testing: random write/read operations
    #Address 0x8f8 Write value 0x1bf91df3
    li x3, 0x1bf91df3
    csrw 0x8f8, x3

    #Unmapped address 0x1fa testing: random write/read operations
    #Address 0x1fa Write value 0x877c2c56
    li x3, 0x877c2c56
    csrw 0x1fa, x3

    #Address 0x1fa read value
    csrr x14, 0x1fa

    #Unmapped address 0xa96 testing: random write/read operations
    #Address 0xa96 read value
    csrr x14, 0xa96

    #Address 0xa96 read value
    csrr x14, 0xa96

    #Unmapped address 0x274 testing: random write/read operations
    #Address 0x274 Write value 0x31c07fb0
    li x3, 0x31c07fb0
    csrw 0x274, x3

    #Unmapped address 0x84d testing: random write/read operations
    #Address 0x84d read value
    csrr x14, 0x84d

    #Unmapped address 0xf7 testing: random write/read operations
    #Address 0xf7 read value
    csrr x14, 0xf7

    #Unmapped address 0x87d testing: random write/read operations
    #Address 0x87d read value
    csrr x14, 0x87d

    #Address 0x87d Write value 0x39ad0e45
    li x3, 0x39ad0e45
    csrw 0x87d, x3

    #Address 0x87d read value
    csrr x14, 0x87d

    #Address 0x87d read value
    csrr x14, 0x87d

    #Unmapped address 0x1fb testing: random write/read operations
    #Address 0x1fb Write value 0x9a69e0f4
    li x3, 0x9a69e0f4
    csrw 0x1fb, x3

    #Address 0x1fb Write value 0xff20cf8
    li x3, 0xff20cf8
    csrw 0x1fb, x3

    #Unmapped address 0x22a testing: random write/read operations
    #Address 0x22a read value
    csrr x14, 0x22a

    #Unmapped address 0x475 testing: random write/read operations
    #Address 0x475 Write value 0x2de832e4
    li x3, 0x2de832e4
    csrw 0x475, x3

    #Address 0x475 read value
    csrr x14, 0x475

    #Unmapped address 0x526 testing: random write/read operations
    #Address 0x526 read value
    csrr x14, 0x526

    #Address 0x526 read value
    csrr x14, 0x526

    #Address 0x526 read value
    csrr x14, 0x526

    #Address 0x526 Write value 0xbeeb7b1c
    li x3, 0xbeeb7b1c
    csrw 0x526, x3

    #Unmapped address 0x9b testing: random write/read operations
    #Address 0x9b read value
    csrr x14, 0x9b

    #Address 0x9b read value
    csrr x14, 0x9b

    #Unmapped address 0x5e3 testing: random write/read operations
    #Address 0x5e3 read value
    csrr x14, 0x5e3

    #Address 0x5e3 Write value 0xc495e42e
    li x3, 0xc495e42e
    csrw 0x5e3, x3

    #Unmapped address 0x685 testing: random write/read operations
    #Address 0x685 Write value 0xfb08b990
    li x3, 0xfb08b990
    csrw 0x685, x3

    #Address 0x685 read value
    csrr x14, 0x685

    #Address 0x685 Write value 0xb3efc9b4
    li x3, 0xb3efc9b4
    csrw 0x685, x3

    #Address 0x685 Write value 0xc60c4035
    li x3, 0xc60c4035
    csrw 0x685, x3

    #Address 0x685 Write value 0x188dd1f0
    li x3, 0x188dd1f0
    csrw 0x685, x3

    #Unmapped address 0xbc8 testing: random write/read operations
    #Address 0xbc8 Write value 0xc99e8721
    li x3, 0xc99e8721
    csrw 0xbc8, x3

    #Address 0xbc8 Write value 0xd541cd9b
    li x3, 0xd541cd9b
    csrw 0xbc8, x3

    #Address 0xbc8 read value
    csrr x14, 0xbc8

    #Address 0xbc8 Write value 0x5b440acb
    li x3, 0x5b440acb
    csrw 0xbc8, x3

    #Address 0xbc8 Write value 0xe621e409
    li x3, 0xe621e409
    csrw 0xbc8, x3

    #Unmapped address 0x6ab testing: random write/read operations
    #Address 0x6ab read value
    csrr x14, 0x6ab

    #Address 0x6ab read value
    csrr x14, 0x6ab

    #Address 0x6ab Write value 0x63fb123b
    li x3, 0x63fb123b
    csrw 0x6ab, x3

    #Address 0x6ab read value
    csrr x14, 0x6ab

    #Address 0x6ab read value
    csrr x14, 0x6ab

    #Unmapped address 0x963 testing: random write/read operations
    #Address 0x963 Write value 0x3e661fa8
    li x3, 0x3e661fa8
    csrw 0x963, x3

    #Unmapped address 0x882 testing: random write/read operations
    #Address 0x882 read value
    csrr x14, 0x882

    #Address 0x882 read value
    csrr x14, 0x882

    #Unmapped address 0xaac testing: random write/read operations
    #Address 0xaac Write value 0x1df39bcf
    li x3, 0x1df39bcf
    csrw 0xaac, x3

    #Address 0xaac read value
    csrr x14, 0xaac

    #Address 0xaac Write value 0xdfa64d09
    li x3, 0xdfa64d09
    csrw 0xaac, x3

    #Address 0xaac read value
    csrr x14, 0xaac

    #Address 0xaac Write value 0xa57ab1d3
    li x3, 0xa57ab1d3
    csrw 0xaac, x3

    #Unmapped address 0xb46 testing: random write/read operations
    #Address 0xb46 Write value 0x9c0498d9
    li x3, 0x9c0498d9
    csrw 0xb46, x3

    #Address 0xb46 Write value 0xddc5cc89
    li x3, 0xddc5cc89
    csrw 0xb46, x3

    #Unmapped address 0x51 testing: random write/read operations
    #Address 0x51 Write value 0x22f1bb58
    li x3, 0x22f1bb58
    csrw 0x51, x3

    #Address 0x51 Write value 0xb472ff10
    li x3, 0xb472ff10
    csrw 0x51, x3

    #Address 0x51 read value
    csrr x14, 0x51

    #Address 0x51 Write value 0x2398cb64
    li x3, 0x2398cb64
    csrw 0x51, x3

    #Address 0x51 Write value 0x93c0d6d7
    li x3, 0x93c0d6d7
    csrw 0x51, x3

    #Unmapped address 0xbbf testing: random write/read operations
    #Address 0xbbf Write value 0x9a5eed3f
    li x3, 0x9a5eed3f
    csrw 0xbbf, x3

    #Unmapped address 0xa5b testing: random write/read operations
    #Address 0xa5b read value
    csrr x14, 0xa5b

    #Address 0xa5b read value
    csrr x14, 0xa5b

    #Address 0xa5b read value
    csrr x14, 0xa5b

    #Unmapped address 0xf57 testing: random write/read operations
    #Address 0xf57 Write value 0x7889f1ae
    li x3, 0x7889f1ae
    csrw 0xf57, x3

    #Address 0xf57 read value
    csrr x14, 0xf57

    #Address 0xf57 read value
    csrr x14, 0xf57

    #Address 0xf57 Write value 0x7dc11a70
    li x3, 0x7dc11a70
    csrw 0xf57, x3

    #Address 0xf57 Write value 0xceb81a61
    li x3, 0xceb81a61
    csrw 0xf57, x3

    #Unmapped address 0x777 testing: random write/read operations
    #Address 0x777 Write value 0xa133fb8c
    li x3, 0xa133fb8c
    csrw 0x777, x3

    #Address 0x777 Write value 0x682ef965
    li x3, 0x682ef965
    csrw 0x777, x3

    #Address 0x777 read value
    csrr x14, 0x777

    #Unmapped address 0x6f9 testing: random write/read operations
    #Address 0x6f9 read value
    csrr x14, 0x6f9

    #Address 0x6f9 read value
    csrr x14, 0x6f9

    #Unmapped address 0x8d1 testing: random write/read operations
    #Address 0x8d1 read value
    csrr x14, 0x8d1

    #Unmapped address 0x45a testing: random write/read operations
    #Address 0x45a read value
    csrr x14, 0x45a

    #Address 0x45a read value
    csrr x14, 0x45a

    #Address 0x45a read value
    csrr x14, 0x45a

    #Address 0x45a read value
    csrr x14, 0x45a

    #Unmapped address 0x321 testing: random write/read operations
    #Address 0x321 Write value 0xa0ab9388
    li x3, 0xa0ab9388
    csrw 0x321, x3

    #Address 0x321 Write value 0xa46ce841
    li x3, 0xa46ce841
    csrw 0x321, x3

    #Unmapped address 0x250 testing: random write/read operations
    #Address 0x250 read value
    csrr x14, 0x250

    #Address 0x250 read value
    csrr x14, 0x250

    #Unmapped address 0x20 testing: random write/read operations
    #Address 0x20 read value
    csrr x14, 0x20

    #Address 0x20 Write value 0x73de79cc
    li x3, 0x73de79cc
    csrw 0x20, x3

    #Unmapped address 0xa63 testing: random write/read operations
    #Address 0xa63 read value
    csrr x14, 0xa63

    #Unmapped address 0x3c3 testing: random write/read operations
    #Address 0x3c3 read value
    csrr x14, 0x3c3

    #Unmapped address 0x425 testing: random write/read operations
    #Address 0x425 read value
    csrr x14, 0x425

    #Address 0x425 Write value 0x78137658
    li x3, 0x78137658
    csrw 0x425, x3

    #Address 0x425 Write value 0xa2162ec0
    li x3, 0xa2162ec0
    csrw 0x425, x3

    #Address 0x425 Write value 0x59967794
    li x3, 0x59967794
    csrw 0x425, x3

    #Unmapped address 0x9ae testing: random write/read operations
    #Address 0x9ae read value
    csrr x14, 0x9ae

    #Address 0x9ae read value
    csrr x14, 0x9ae

    #Address 0x9ae Write value 0x9d359cd5
    li x3, 0x9d359cd5
    csrw 0x9ae, x3

    #Address 0x9ae read value
    csrr x14, 0x9ae

    #Address 0x9ae Write value 0x27fd4feb
    li x3, 0x27fd4feb
    csrw 0x9ae, x3

    #Unmapped address 0x835 testing: random write/read operations
    #Address 0x835 read value
    csrr x14, 0x835

    #Unmapped address 0x766 testing: random write/read operations
    #Address 0x766 Write value 0xe6403595
    li x3, 0xe6403595
    csrw 0x766, x3

    #Address 0x766 Write value 0xf4ead90
    li x3, 0xf4ead90
    csrw 0x766, x3

    #Address 0x766 Write value 0x92985757
    li x3, 0x92985757
    csrw 0x766, x3

    #Unmapped address 0x916 testing: random write/read operations
    #Address 0x916 read value
    csrr x14, 0x916

    #Address 0x916 read value
    csrr x14, 0x916

    #Address 0x916 read value
    csrr x14, 0x916

    #Unmapped address 0x35e testing: random write/read operations
    #Address 0x35e Write value 0xc4116c2e
    li x3, 0xc4116c2e
    csrw 0x35e, x3

    #Address 0x35e Write value 0xb0adf94f
    li x3, 0xb0adf94f
    csrw 0x35e, x3

    #Unmapped address 0x276 testing: random write/read operations
    #Address 0x276 Write value 0xc524784c
    li x3, 0xc524784c
    csrw 0x276, x3

    #Address 0x276 Write value 0x60c4a409
    li x3, 0x60c4a409
    csrw 0x276, x3

    #Address 0x276 Write value 0xa53a577c
    li x3, 0xa53a577c
    csrw 0x276, x3

    #Address 0x276 read value
    csrr x14, 0x276

    #Unmapped address 0x164 testing: random write/read operations
    #Address 0x164 read value
    csrr x14, 0x164

    #Address 0x164 Write value 0xeda8da5f
    li x3, 0xeda8da5f
    csrw 0x164, x3

    #Address 0x164 Write value 0x7e79bda9
    li x3, 0x7e79bda9
    csrw 0x164, x3

    #Unmapped address 0x26f testing: random write/read operations
    #Address 0x26f read value
    csrr x14, 0x26f

    #Address 0x26f Write value 0xf3e0b6aa
    li x3, 0xf3e0b6aa
    csrw 0x26f, x3

    #Address 0x26f Write value 0x58690f57
    li x3, 0x58690f57
    csrw 0x26f, x3

    #Unmapped address 0x6eb testing: random write/read operations
    #Address 0x6eb read value
    csrr x14, 0x6eb

    #Address 0x6eb Write value 0xca84bfb
    li x3, 0xca84bfb
    csrw 0x6eb, x3

    #Unmapped address 0xa94 testing: random write/read operations
    #Address 0xa94 Write value 0xfe742018
    li x3, 0xfe742018
    csrw 0xa94, x3

    #Mapped address 0xb9f (mhpmcounterh31) testing: random write/read operations
    #Address 0xb9f Write value 0xb8d099a8
    li x3, 0xb8d099a8
    csrw 0xb9f, x3

    #Address 0xb9f read value
    csrr x14, 0xb9f

    #Address 0xb9f Write value 0x5923f812
    li x3, 0x5923f812
    csrw 0xb9f, x3

    #Address 0xb9f Write value 0xe8ba261a
    li x3, 0xe8ba261a
    csrw 0xb9f, x3

    #Address 0xb9f Write value 0xcd9a0b52
    li x3, 0xcd9a0b52
    csrw 0xb9f, x3

    #Unmapped address 0xf5f testing: random write/read operations
    #Address 0xf5f Write value 0x915c25fc
    li x3, 0x915c25fc
    csrw 0xf5f, x3

    #Address 0xf5f Write value 0xd73e15c3
    li x3, 0xd73e15c3
    csrw 0xf5f, x3

    #Address 0xf5f read value
    csrr x14, 0xf5f

    #Address 0xf5f Write value 0x39187306
    li x3, 0x39187306
    csrw 0xf5f, x3

    #Address 0xf5f Write value 0x6e68bd86
    li x3, 0x6e68bd86
    csrw 0xf5f, x3

    #Unmapped address 0x671 testing: random write/read operations
    #Address 0x671 Write value 0x1f338aea
    li x3, 0x1f338aea
    csrw 0x671, x3

    #Address 0x671 read value
    csrr x14, 0x671

    #Unmapped address 0xf05 testing: random write/read operations
    #Address 0xf05 Write value 0xe45ad238
    li x3, 0xe45ad238
    csrw 0xf05, x3

    #Address 0xf05 read value
    csrr x14, 0xf05

    #Address 0xf05 Write value 0x2fea9c02
    li x3, 0x2fea9c02
    csrw 0xf05, x3

    #Unmapped address 0xf9c testing: random write/read operations
    #Address 0xf9c Write value 0x77a2f4dc
    li x3, 0x77a2f4dc
    csrw 0xf9c, x3

    #Address 0xf9c read value
    csrr x14, 0xf9c

    #Address 0xf9c read value
    csrr x14, 0xf9c

    #Address 0xf9c read value
    csrr x14, 0xf9c

    #Address 0xf9c Write value 0xd10bd7ec
    li x3, 0xd10bd7ec
    csrw 0xf9c, x3

    #Unmapped address 0xd46 testing: random write/read operations
    #Address 0xd46 Write value 0x8c64ca35
    li x3, 0x8c64ca35
    csrw 0xd46, x3

    #Address 0xd46 Write value 0x2be5d3b
    li x3, 0x2be5d3b
    csrw 0xd46, x3

    #Unmapped address 0x58b testing: random write/read operations
    #Address 0x58b read value
    csrr x14, 0x58b

    #Unmapped address 0xd54 testing: random write/read operations
    #Address 0xd54 Write value 0x41aa1cd3
    li x3, 0x41aa1cd3
    csrw 0xd54, x3

    #Address 0xd54 read value
    csrr x14, 0xd54

    #Address 0xd54 Write value 0x64be16b3
    li x3, 0x64be16b3
    csrw 0xd54, x3

    #Address 0xd54 Write value 0x4c3b31c6
    li x3, 0x4c3b31c6
    csrw 0xd54, x3

    #Address 0xd54 Write value 0x8bc6c0d
    li x3, 0x8bc6c0d
    csrw 0xd54, x3

    #Unmapped address 0xf23 testing: random write/read operations
    #Address 0xf23 Write value 0x96c7ed20
    li x3, 0x96c7ed20
    csrw 0xf23, x3

    #Address 0xf23 Write value 0x5c7339d
    li x3, 0x5c7339d
    csrw 0xf23, x3

    #Unmapped address 0xe8 testing: random write/read operations
    #Address 0xe8 Write value 0xab216be9
    li x3, 0xab216be9
    csrw 0xe8, x3

    #Address 0xe8 read value
    csrr x14, 0xe8

    #Address 0xe8 Write value 0x7fecc801
    li x3, 0x7fecc801
    csrw 0xe8, x3

    #Address 0xe8 read value
    csrr x14, 0xe8

    #Unmapped address 0x8b1 testing: random write/read operations
    #Address 0x8b1 Write value 0x6b19e8d
    li x3, 0x6b19e8d
    csrw 0x8b1, x3

    #Address 0x8b1 read value
    csrr x14, 0x8b1

    #Unmapped address 0x161 testing: random write/read operations
    #Address 0x161 read value
    csrr x14, 0x161

    #Address 0x161 Write value 0xdbe4b1e6
    li x3, 0xdbe4b1e6
    csrw 0x161, x3

    #Address 0x161 read value
    csrr x14, 0x161

    #Unmapped address 0x120 testing: random write/read operations
    #Address 0x120 Write value 0x7d13955f
    li x3, 0x7d13955f
    csrw 0x120, x3

    #Address 0x120 read value
    csrr x14, 0x120

    #Address 0x120 read value
    csrr x14, 0x120

    #Unmapped address 0x54b testing: random write/read operations
    #Address 0x54b read value
    csrr x14, 0x54b

    #Address 0x54b read value
    csrr x14, 0x54b

    #Unmapped address 0x517 testing: random write/read operations
    #Address 0x517 Write value 0x552205ca
    li x3, 0x552205ca
    csrw 0x517, x3

    #Address 0x517 Write value 0x21c87154
    li x3, 0x21c87154
    csrw 0x517, x3

    #Address 0x517 read value
    csrr x14, 0x517

    #Address 0x517 read value
    csrr x14, 0x517

    #Address 0x517 Write value 0x454100cb
    li x3, 0x454100cb
    csrw 0x517, x3

    #Unmapped address 0xef4 testing: random write/read operations
    #Address 0xef4 Write value 0x971cc175
    li x3, 0x971cc175
    csrw 0xef4, x3

    #Address 0xef4 read value
    csrr x14, 0xef4

    #Unmapped address 0x784 testing: random write/read operations
    #Address 0x784 read value
    csrr x14, 0x784

    #Address 0x784 read value
    csrr x14, 0x784

    #Address 0x784 read value
    csrr x14, 0x784

    #Unmapped address 0xf91 testing: random write/read operations
    #Address 0xf91 Write value 0x4025e197
    li x3, 0x4025e197
    csrw 0xf91, x3

    #Address 0xf91 read value
    csrr x14, 0xf91

    #Address 0xf91 Write value 0x20314cd1
    li x3, 0x20314cd1
    csrw 0xf91, x3

    #Unmapped address 0xa79 testing: random write/read operations
    #Address 0xa79 Write value 0xdd7e3291
    li x3, 0xdd7e3291
    csrw 0xa79, x3

    #Address 0xa79 read value
    csrr x14, 0xa79

    #Address 0xa79 read value
    csrr x14, 0xa79

    #Address 0xa79 Write value 0xbebba4e6
    li x3, 0xbebba4e6
    csrw 0xa79, x3

    #Address 0xa79 read value
    csrr x14, 0xa79

    #Unmapped address 0x4f2 testing: random write/read operations
    #Address 0x4f2 read value
    csrr x14, 0x4f2

    #Address 0x4f2 read value
    csrr x14, 0x4f2

    #Unmapped address 0x386 testing: random write/read operations
    #Address 0x386 Write value 0x46081919
    li x3, 0x46081919
    csrw 0x386, x3

    #Address 0x386 read value
    csrr x14, 0x386

    #Address 0x386 read value
    csrr x14, 0x386

    #Address 0x386 Write value 0x362aeb57
    li x3, 0x362aeb57
    csrw 0x386, x3

    #Address 0x386 read value
    csrr x14, 0x386

    #Mapped address 0xb84 (mhpmcounterh4) testing: random write/read operations
    #Address 0xb84 Write value 0x7b1f0991
    li x3, 0x7b1f0991
    csrw 0xb84, x3

    #Address 0xb84 Write value 0x80ecb414
    li x3, 0x80ecb414
    csrw 0xb84, x3

    #Unmapped address 0xe61 testing: random write/read operations
    #Address 0xe61 Write value 0x8f1a996f
    li x3, 0x8f1a996f
    csrw 0xe61, x3

    #Address 0xe61 read value
    csrr x14, 0xe61

    #Address 0xe61 Write value 0xd107ca28
    li x3, 0xd107ca28
    csrw 0xe61, x3

    #Address 0xe61 read value
    csrr x14, 0xe61

    #Unmapped address 0x7b1 testing: random write/read operations
    #Address 0x7b1 read value
    csrr x14, 0x7b1

    #Address 0x7b1 read value
    csrr x14, 0x7b1

    #Address 0x7b1 Write value 0x2cf680c3
    li x3, 0x2cf680c3
    csrw 0x7b1, x3

    #Address 0x7b1 read value
    csrr x14, 0x7b1

    #Address 0x7b1 read value
    csrr x14, 0x7b1

    #Unmapped address 0x56c testing: random write/read operations
    #Address 0x56c Write value 0x3f2e147f
    li x3, 0x3f2e147f
    csrw 0x56c, x3

    #Address 0x56c Write value 0x211d6370
    li x3, 0x211d6370
    csrw 0x56c, x3

    #Unmapped address 0xdf8 testing: random write/read operations
    #Address 0xdf8 Write value 0x177041f7
    li x3, 0x177041f7
    csrw 0xdf8, x3

    #Address 0xdf8 Write value 0xc36827cb
    li x3, 0xc36827cb
    csrw 0xdf8, x3

    #Address 0xdf8 Write value 0xd157065c
    li x3, 0xd157065c
    csrw 0xdf8, x3

    #Address 0xdf8 read value
    csrr x14, 0xdf8

    #Unmapped address 0xe2d testing: random write/read operations
    #Address 0xe2d read value
    csrr x14, 0xe2d

    #Unmapped address 0xfd7 testing: random write/read operations
    #Address 0xfd7 Write value 0x9290ac65
    li x3, 0x9290ac65
    csrw 0xfd7, x3

    #Address 0xfd7 read value
    csrr x14, 0xfd7

    #Address 0xfd7 Write value 0xc8e54ab0
    li x3, 0xc8e54ab0
    csrw 0xfd7, x3

    #Address 0xfd7 read value
    csrr x14, 0xfd7

    #Unmapped address 0xff9 testing: random write/read operations
    #Address 0xff9 read value
    csrr x14, 0xff9

    #Address 0xff9 Write value 0x227af8db
    li x3, 0x227af8db
    csrw 0xff9, x3

    #Unmapped address 0x5c8 testing: random write/read operations
    #Address 0x5c8 Write value 0xbd51faa
    li x3, 0xbd51faa
    csrw 0x5c8, x3

    #Address 0x5c8 Write value 0xcca78edf
    li x3, 0xcca78edf
    csrw 0x5c8, x3

    #Unmapped address 0x53e testing: random write/read operations
    #Address 0x53e Write value 0x2ac27669
    li x3, 0x2ac27669
    csrw 0x53e, x3

    #Address 0x53e read value
    csrr x14, 0x53e

    #Address 0x53e read value
    csrr x14, 0x53e

    #Address 0x53e read value
    csrr x14, 0x53e

    #Address 0x53e read value
    csrr x14, 0x53e

    #Unmapped address 0xf38 testing: random write/read operations
    #Address 0xf38 Write value 0xcfbfe237
    li x3, 0xcfbfe237
    csrw 0xf38, x3

    #Unmapped address 0xa65 testing: random write/read operations
    #Address 0xa65 Write value 0xfa253078
    li x3, 0xfa253078
    csrw 0xa65, x3

    #Address 0xa65 read value
    csrr x14, 0xa65

    #Address 0xa65 Write value 0x9ec9d53c
    li x3, 0x9ec9d53c
    csrw 0xa65, x3

    #Unmapped address 0x3c8 testing: random write/read operations
    #Address 0x3c8 read value
    csrr x14, 0x3c8

    #Unmapped address 0x834 testing: random write/read operations
    #Address 0x834 read value
    csrr x14, 0x834

    #Unmapped address 0xf07 testing: random write/read operations
    #Address 0xf07 read value
    csrr x14, 0xf07

    #Address 0xf07 Write value 0x4b316456
    li x3, 0x4b316456
    csrw 0xf07, x3

    #Address 0xf07 Write value 0x758bdb63
    li x3, 0x758bdb63
    csrw 0xf07, x3

    #Unmapped address 0x487 testing: random write/read operations
    #Address 0x487 Write value 0x484e826f
    li x3, 0x484e826f
    csrw 0x487, x3

    #Address 0x487 Write value 0x1c000f47
    li x3, 0x1c000f47
    csrw 0x487, x3

    #Address 0x487 read value
    csrr x14, 0x487

    #Address 0x487 read value
    csrr x14, 0x487

    #Address 0x487 Write value 0xff6db69b
    li x3, 0xff6db69b
    csrw 0x487, x3

    #Unmapped address 0x3d1 testing: random write/read operations
    #Address 0x3d1 read value
    csrr x14, 0x3d1

    #Address 0x3d1 Write value 0xac7a115f
    li x3, 0xac7a115f
    csrw 0x3d1, x3

    #Unmapped address 0xbda testing: random write/read operations
    #Address 0xbda Write value 0x44b0db4f
    li x3, 0x44b0db4f
    csrw 0xbda, x3

    #Address 0xbda read value
    csrr x14, 0xbda

    #Address 0xbda Write value 0x7edcf70c
    li x3, 0x7edcf70c
    csrw 0xbda, x3

    #Address 0xbda Write value 0xac343d4
    li x3, 0xac343d4
    csrw 0xbda, x3

    #Unmapped address 0x49c testing: random write/read operations
    #Address 0x49c Write value 0xba2ae78a
    li x3, 0xba2ae78a
    csrw 0x49c, x3

    #Address 0x49c read value
    csrr x14, 0x49c

    #Unmapped address 0xabd testing: random write/read operations
    #Address 0xabd Write value 0x7ecc22c4
    li x3, 0x7ecc22c4
    csrw 0xabd, x3

    #Unmapped address 0x93c testing: random write/read operations
    #Address 0x93c Write value 0xcd6ab544
    li x3, 0xcd6ab544
    csrw 0x93c, x3

    #Address 0x93c Write value 0x366f78e2
    li x3, 0x366f78e2
    csrw 0x93c, x3

    #Address 0x93c read value
    csrr x14, 0x93c

    #Address 0x93c read value
    csrr x14, 0x93c

    #Unmapped address 0xf3 testing: random write/read operations
    #Address 0xf3 Write value 0xe360c26
    li x3, 0xe360c26
    csrw 0xf3, x3

    #Address 0xf3 read value
    csrr x14, 0xf3

    #Address 0xf3 Write value 0x98942146
    li x3, 0x98942146
    csrw 0xf3, x3

    #Unmapped address 0x256 testing: random write/read operations
    #Address 0x256 read value
    csrr x14, 0x256

    #Address 0x256 read value
    csrr x14, 0x256

    #Address 0x256 Write value 0xbdb7ac44
    li x3, 0xbdb7ac44
    csrw 0x256, x3

    #Address 0x256 read value
    csrr x14, 0x256

    #Address 0x256 Write value 0x31ccc2ec
    li x3, 0x31ccc2ec
    csrw 0x256, x3

    #Unmapped address 0x656 testing: random write/read operations
    #Address 0x656 read value
    csrr x14, 0x656

    #Unmapped address 0x2db testing: random write/read operations
    #Address 0x2db Write value 0xf0ac8b69
    li x3, 0xf0ac8b69
    csrw 0x2db, x3

    #Address 0x2db read value
    csrr x14, 0x2db

    #Address 0x2db Write value 0xeb092032
    li x3, 0xeb092032
    csrw 0x2db, x3

    #Unmapped address 0xda0 testing: random write/read operations
    #Address 0xda0 read value
    csrr x14, 0xda0

    #Address 0xda0 read value
    csrr x14, 0xda0

    #Address 0xda0 read value
    csrr x14, 0xda0

    #Unmapped address 0x775 testing: random write/read operations
    #Address 0x775 Write value 0x3ae60511
    li x3, 0x3ae60511
    csrw 0x775, x3

    #Address 0x775 read value
    csrr x14, 0x775

    #Address 0x775 read value
    csrr x14, 0x775

    #Address 0x775 read value
    csrr x14, 0x775

    #Unmapped address 0x905 testing: random write/read operations
    #Address 0x905 Write value 0x140da87b
    li x3, 0x140da87b
    csrw 0x905, x3

    #Unmapped address 0xcbd testing: random write/read operations
    #Address 0xcbd read value
    csrr x14, 0xcbd

    #Address 0xcbd Write value 0x7000d423
    li x3, 0x7000d423
    csrw 0xcbd, x3

    #Address 0xcbd Write value 0x25d45b82
    li x3, 0x25d45b82
    csrw 0xcbd, x3

    #Unmapped address 0x81b testing: random write/read operations
    #Address 0x81b read value
    csrr x14, 0x81b

    #Address 0x81b Write value 0xc2ca2ffe
    li x3, 0xc2ca2ffe
    csrw 0x81b, x3

    #Address 0x81b read value
    csrr x14, 0x81b

    #Address 0x81b read value
    csrr x14, 0x81b

    #Address 0x81b read value
    csrr x14, 0x81b

    #Unmapped address 0x1be testing: random write/read operations
    #Address 0x1be Write value 0xbf57707c
    li x3, 0xbf57707c
    csrw 0x1be, x3

    #Address 0x1be Write value 0x289529dd
    li x3, 0x289529dd
    csrw 0x1be, x3

    #Address 0x1be Write value 0x5aa78c7e
    li x3, 0x5aa78c7e
    csrw 0x1be, x3

    #Address 0x1be read value
    csrr x14, 0x1be

    #Unmapped address 0xf02 testing: random write/read operations
    #Address 0xf02 read value
    csrr x14, 0xf02

    #Address 0xf02 read value
    csrr x14, 0xf02

    #Address 0xf02 read value
    csrr x14, 0xf02

    #Address 0xf02 Write value 0x601021b0
    li x3, 0x601021b0
    csrw 0xf02, x3

    #Unmapped address 0xdc3 testing: random write/read operations
    #Address 0xdc3 Write value 0x8f0cb64
    li x3, 0x8f0cb64
    csrw 0xdc3, x3

    #Address 0xdc3 Write value 0xec01d51
    li x3, 0xec01d51
    csrw 0xdc3, x3

    #Unmapped address 0x3ee testing: random write/read operations
    #Address 0x3ee Write value 0x3cd4e575
    li x3, 0x3cd4e575
    csrw 0x3ee, x3

    #Address 0x3ee Write value 0xb6a51777
    li x3, 0xb6a51777
    csrw 0x3ee, x3

    #Unmapped address 0x277 testing: random write/read operations
    #Address 0x277 Write value 0x498eb4dd
    li x3, 0x498eb4dd
    csrw 0x277, x3

    #Unmapped address 0x998 testing: random write/read operations
    #Address 0x998 Write value 0x82ced12
    li x3, 0x82ced12
    csrw 0x998, x3

    #Address 0x998 read value
    csrr x14, 0x998

    #Address 0x998 read value
    csrr x14, 0x998

    #Unmapped address 0xc11 testing: random write/read operations
    #Address 0xc11 Write value 0x26a86b89
    li x3, 0x26a86b89
    csrw 0xc11, x3

    #Address 0xc11 read value
    csrr x14, 0xc11

    #Address 0xc11 read value
    csrr x14, 0xc11

    #Address 0xc11 read value
    csrr x14, 0xc11

    #Address 0xc11 Write value 0x639d1825
    li x3, 0x639d1825
    csrw 0xc11, x3

    #Unmapped address 0x9d3 testing: random write/read operations
    #Address 0x9d3 read value
    csrr x14, 0x9d3

    #Address 0x9d3 read value
    csrr x14, 0x9d3

    #Address 0x9d3 Write value 0xc3c577f5
    li x3, 0xc3c577f5
    csrw 0x9d3, x3

    #Address 0x9d3 Write value 0xeab59405
    li x3, 0xeab59405
    csrw 0x9d3, x3

    #Address 0x9d3 read value
    csrr x14, 0x9d3

    #Unmapped address 0x496 testing: random write/read operations
    #Address 0x496 Write value 0x6e2f95c8
    li x3, 0x6e2f95c8
    csrw 0x496, x3

    #Address 0x496 read value
    csrr x14, 0x496

    #Address 0x496 Write value 0xa60d3c4
    li x3, 0xa60d3c4
    csrw 0x496, x3

    #Address 0x496 read value
    csrr x14, 0x496

    #Unmapped address 0x939 testing: random write/read operations
    #Address 0x939 read value
    csrr x14, 0x939

    #Address 0x939 read value
    csrr x14, 0x939

    #Address 0x939 Write value 0x5595a353
    li x3, 0x5595a353
    csrw 0x939, x3

    #Unmapped address 0x966 testing: random write/read operations
    #Address 0x966 read value
    csrr x14, 0x966

    #Address 0x966 Write value 0x9c566e2f
    li x3, 0x9c566e2f
    csrw 0x966, x3

    #Unmapped address 0x755 testing: random write/read operations
    #Address 0x755 read value
    csrr x14, 0x755

    #Unmapped address 0xfa8 testing: random write/read operations
    #Address 0xfa8 read value
    csrr x14, 0xfa8

    #Unmapped address 0x5e5 testing: random write/read operations
    #Address 0x5e5 read value
    csrr x14, 0x5e5

    #Address 0x5e5 read value
    csrr x14, 0x5e5

    #Address 0x5e5 Write value 0xad6b2470
    li x3, 0xad6b2470
    csrw 0x5e5, x3

    #Address 0x5e5 read value
    csrr x14, 0x5e5

    #Unmapped address 0x2cf testing: random write/read operations
    #Address 0x2cf Write value 0xdc58c9d7
    li x3, 0xdc58c9d7
    csrw 0x2cf, x3

    #Address 0x2cf Write value 0xb407a4af
    li x3, 0xb407a4af
    csrw 0x2cf, x3

    #Unmapped address 0xf81 testing: random write/read operations
    #Address 0xf81 read value
    csrr x14, 0xf81

    #Address 0xf81 Write value 0xb43daad5
    li x3, 0xb43daad5
    csrw 0xf81, x3

    #Unmapped address 0x908 testing: random write/read operations
    #Address 0x908 read value
    csrr x14, 0x908

    #Unmapped address 0xf47 testing: random write/read operations
    #Address 0xf47 read value
    csrr x14, 0xf47

    #Address 0xf47 Write value 0x40455452
    li x3, 0x40455452
    csrw 0xf47, x3

    #Address 0xf47 Write value 0x9ef38f3f
    li x3, 0x9ef38f3f
    csrw 0xf47, x3

    #Unmapped address 0x65b testing: random write/read operations
    #Address 0x65b Write value 0xffcd2170
    li x3, 0xffcd2170
    csrw 0x65b, x3

    #Address 0x65b read value
    csrr x14, 0x65b

    #Address 0x65b read value
    csrr x14, 0x65b

    #Unmapped address 0xf6d testing: random write/read operations
    #Address 0xf6d read value
    csrr x14, 0xf6d

    #Address 0xf6d read value
    csrr x14, 0xf6d

    #Address 0xf6d read value
    csrr x14, 0xf6d

    #Address 0xf6d Write value 0xfdf41bb4
    li x3, 0xfdf41bb4
    csrw 0xf6d, x3

    #Unmapped address 0x5a6 testing: random write/read operations
    #Address 0x5a6 read value
    csrr x14, 0x5a6

    #Address 0x5a6 read value
    csrr x14, 0x5a6

    #Address 0x5a6 read value
    csrr x14, 0x5a6

    #Address 0x5a6 read value
    csrr x14, 0x5a6

    #Address 0x5a6 Write value 0xca33c19a
    li x3, 0xca33c19a
    csrw 0x5a6, x3

    #Unmapped address 0x1a2 testing: random write/read operations
    #Address 0x1a2 Write value 0xa664f628
    li x3, 0xa664f628
    csrw 0x1a2, x3

    #Address 0x1a2 Write value 0x9cef5951
    li x3, 0x9cef5951
    csrw 0x1a2, x3

    #Address 0x1a2 Write value 0x77cad817
    li x3, 0x77cad817
    csrw 0x1a2, x3

    #Address 0x1a2 Write value 0x712e24e
    li x3, 0x712e24e
    csrw 0x1a2, x3

    #Unmapped address 0xac testing: random write/read operations
    #Address 0xac Write value 0x36e08a0
    li x3, 0x36e08a0
    csrw 0xac, x3

    #Unmapped address 0x1d5 testing: random write/read operations
    #Address 0x1d5 Write value 0xf4b4bce
    li x3, 0xf4b4bce
    csrw 0x1d5, x3

    #Address 0x1d5 Write value 0xd44d4967
    li x3, 0xd44d4967
    csrw 0x1d5, x3

    #Address 0x1d5 Write value 0x35a61001
    li x3, 0x35a61001
    csrw 0x1d5, x3

    #Address 0x1d5 Write value 0x440275f4
    li x3, 0x440275f4
    csrw 0x1d5, x3

    #Unmapped address 0xd6c testing: random write/read operations
    #Address 0xd6c Write value 0x28cb13db
    li x3, 0x28cb13db
    csrw 0xd6c, x3

    #Address 0xd6c Write value 0xfde0ea61
    li x3, 0xfde0ea61
    csrw 0xd6c, x3

    #Address 0xd6c Write value 0x46f7f46e
    li x3, 0x46f7f46e
    csrw 0xd6c, x3

    #Address 0xd6c read value
    csrr x14, 0xd6c

    #Address 0xd6c Write value 0x739d9719
    li x3, 0x739d9719
    csrw 0xd6c, x3

    #Unmapped address 0x919 testing: random write/read operations
    #Address 0x919 Write value 0x8ae02fa3
    li x3, 0x8ae02fa3
    csrw 0x919, x3

    #Address 0x919 Write value 0xc4c1c476
    li x3, 0xc4c1c476
    csrw 0x919, x3

    #Address 0x919 read value
    csrr x14, 0x919

    #Unmapped address 0x97b testing: random write/read operations
    #Address 0x97b read value
    csrr x14, 0x97b

    #Address 0x97b Write value 0x9be8ba8b
    li x3, 0x9be8ba8b
    csrw 0x97b, x3

    #Address 0x97b Write value 0x144eb3c0
    li x3, 0x144eb3c0
    csrw 0x97b, x3

    #Address 0x97b read value
    csrr x14, 0x97b

    #Unmapped address 0xa0d testing: random write/read operations
    #Address 0xa0d Write value 0xda29acf3
    li x3, 0xda29acf3
    csrw 0xa0d, x3

    #Unmapped address 0x7e3 testing: random write/read operations
    #Address 0x7e3 read value
    csrr x14, 0x7e3

    #Address 0x7e3 read value
    csrr x14, 0x7e3

    #Address 0x7e3 read value
    csrr x14, 0x7e3

    #Address 0x7e3 Write value 0x2fd51670
    li x3, 0x2fd51670
    csrw 0x7e3, x3

    #Unmapped address 0xea testing: random write/read operations
    #Address 0xea read value
    csrr x14, 0xea

    #Address 0xea Write value 0x7c74b3b2
    li x3, 0x7c74b3b2
    csrw 0xea, x3

    #Address 0xea Write value 0x13467bbf
    li x3, 0x13467bbf
    csrw 0xea, x3

    #Unmapped address 0xf15 testing: random write/read operations
    #Address 0xf15 read value
    csrr x14, 0xf15

    #Address 0xf15 Write value 0xaea3f85d
    li x3, 0xaea3f85d
    csrw 0xf15, x3

    #Address 0xf15 read value
    csrr x14, 0xf15

    #Address 0xf15 read value
    csrr x14, 0xf15

    #Unmapped address 0x9e1 testing: random write/read operations
    #Address 0x9e1 read value
    csrr x14, 0x9e1

    #Address 0x9e1 Write value 0xbdbe4359
    li x3, 0xbdbe4359
    csrw 0x9e1, x3

    #Address 0x9e1 Write value 0x5e8b89b8
    li x3, 0x5e8b89b8
    csrw 0x9e1, x3

    #Unmapped address 0x5b4 testing: random write/read operations
    #Address 0x5b4 read value
    csrr x14, 0x5b4

    #Address 0x5b4 Write value 0x145c0d70
    li x3, 0x145c0d70
    csrw 0x5b4, x3

    #Address 0x5b4 Write value 0x3700fedf
    li x3, 0x3700fedf
    csrw 0x5b4, x3

    #Address 0x5b4 read value
    csrr x14, 0x5b4

    #Unmapped address 0x8ea testing: random write/read operations
    #Address 0x8ea Write value 0x3778e2f9
    li x3, 0x3778e2f9
    csrw 0x8ea, x3

    #Address 0x8ea Write value 0xdbb1b786
    li x3, 0xdbb1b786
    csrw 0x8ea, x3

    #Address 0x8ea read value
    csrr x14, 0x8ea

    #Address 0x8ea read value
    csrr x14, 0x8ea

    #Address 0x8ea Write value 0xb061fff7
    li x3, 0xb061fff7
    csrw 0x8ea, x3

    #Unmapped address 0xe64 testing: random write/read operations
    #Address 0xe64 Write value 0x273fc720
    li x3, 0x273fc720
    csrw 0xe64, x3

    #Address 0xe64 Write value 0xa5663d0b
    li x3, 0xa5663d0b
    csrw 0xe64, x3

    #Address 0xe64 read value
    csrr x14, 0xe64

    #Address 0xe64 Write value 0xfb3330e8
    li x3, 0xfb3330e8
    csrw 0xe64, x3

    #Address 0xe64 read value
    csrr x14, 0xe64

    #Unmapped address 0xa70 testing: random write/read operations
    #Address 0xa70 read value
    csrr x14, 0xa70

    #Unmapped address 0x11b testing: random write/read operations
    #Address 0x11b read value
    csrr x14, 0x11b

    #Address 0x11b Write value 0x9f5b54fd
    li x3, 0x9f5b54fd
    csrw 0x11b, x3

    #Address 0x11b Write value 0xb9b57819
    li x3, 0xb9b57819
    csrw 0x11b, x3

    #Unmapped address 0xd95 testing: random write/read operations
    #Address 0xd95 Write value 0xb403ea5d
    li x3, 0xb403ea5d
    csrw 0xd95, x3

    #Address 0xd95 read value
    csrr x14, 0xd95

    #Address 0xd95 read value
    csrr x14, 0xd95

    #Unmapped address 0x7ed testing: random write/read operations
    #Address 0x7ed Write value 0x418b9f9f
    li x3, 0x418b9f9f
    csrw 0x7ed, x3

    #Address 0x7ed Write value 0xb95c9af
    li x3, 0xb95c9af
    csrw 0x7ed, x3

    #Unmapped address 0xd66 testing: random write/read operations
    #Address 0xd66 Write value 0xf79b2672
    li x3, 0xf79b2672
    csrw 0xd66, x3

    #Address 0xd66 Write value 0x2a6113e8
    li x3, 0x2a6113e8
    csrw 0xd66, x3

    #Address 0xd66 read value
    csrr x14, 0xd66

    #Address 0xd66 read value
    csrr x14, 0xd66

    #Address 0xd66 read value
    csrr x14, 0xd66

    #Unmapped address 0x68d testing: random write/read operations
    #Address 0x68d read value
    csrr x14, 0x68d

    #Address 0x68d Write value 0x9cd6db9c
    li x3, 0x9cd6db9c
    csrw 0x68d, x3

    #Unmapped address 0x58f testing: random write/read operations
    #Address 0x58f Write value 0xff70b693
    li x3, 0xff70b693
    csrw 0x58f, x3

    #Address 0x58f Write value 0xb2620d9
    li x3, 0xb2620d9
    csrw 0x58f, x3

    #Address 0x58f read value
    csrr x14, 0x58f

    #Address 0x58f Write value 0x6190886c
    li x3, 0x6190886c
    csrw 0x58f, x3

    #Unmapped address 0x71 testing: random write/read operations
    #Address 0x71 Write value 0xccb162b1
    li x3, 0xccb162b1
    csrw 0x71, x3

    #Address 0x71 Write value 0x8d9c6df0
    li x3, 0x8d9c6df0
    csrw 0x71, x3

    #Unmapped address 0x2ee testing: random write/read operations
    #Address 0x2ee read value
    csrr x14, 0x2ee

    #Address 0x2ee Write value 0x1f15572c
    li x3, 0x1f15572c
    csrw 0x2ee, x3

    #Address 0x2ee Write value 0xd28caac1
    li x3, 0xd28caac1
    csrw 0x2ee, x3

    #Address 0x2ee Write value 0x7750af1b
    li x3, 0x7750af1b
    csrw 0x2ee, x3

    #Address 0x2ee read value
    csrr x14, 0x2ee

    #Unmapped address 0x7a8 testing: random write/read operations
    #Address 0x7a8 Write value 0x4fa5b2de
    li x3, 0x4fa5b2de
    csrw 0x7a8, x3

    #Address 0x7a8 read value
    csrr x14, 0x7a8

    #Address 0x7a8 read value
    csrr x14, 0x7a8

    #Unmapped address 0xdab testing: random write/read operations
    #Address 0xdab read value
    csrr x14, 0xdab

    #Address 0xdab Write value 0x3847cbe2
    li x3, 0x3847cbe2
    csrw 0xdab, x3

    #Address 0xdab Write value 0xf0c6408b
    li x3, 0xf0c6408b
    csrw 0xdab, x3

    #Address 0xdab Write value 0x8d58c89f
    li x3, 0x8d58c89f
    csrw 0xdab, x3

    #Address 0xdab Write value 0xb007c9a6
    li x3, 0xb007c9a6
    csrw 0xdab, x3

    #Unmapped address 0xc5c testing: random write/read operations
    #Address 0xc5c read value
    csrr x14, 0xc5c

    #Address 0xc5c Write value 0xaf12ba8b
    li x3, 0xaf12ba8b
    csrw 0xc5c, x3

    #Address 0xc5c read value
    csrr x14, 0xc5c

    #Unmapped address 0x1a9 testing: random write/read operations
    #Address 0x1a9 read value
    csrr x14, 0x1a9

    #Address 0x1a9 Write value 0x75df16be
    li x3, 0x75df16be
    csrw 0x1a9, x3

    #Unmapped address 0x6cf testing: random write/read operations
    #Address 0x6cf read value
    csrr x14, 0x6cf

    #Address 0x6cf read value
    csrr x14, 0x6cf

    #Address 0x6cf Write value 0xf5cca795
    li x3, 0xf5cca795
    csrw 0x6cf, x3

    #Unmapped address 0x842 testing: random write/read operations
    #Address 0x842 Write value 0x7787c780
    li x3, 0x7787c780
    csrw 0x842, x3

    #Address 0x842 read value
    csrr x14, 0x842

    #Address 0x842 Write value 0xc069768b
    li x3, 0xc069768b
    csrw 0x842, x3

    #Address 0x842 Write value 0x85603157
    li x3, 0x85603157
    csrw 0x842, x3

    #Unmapped address 0x3 testing: random write/read operations
    #Address 0x3 Write value 0xc40ce3a
    li x3, 0xc40ce3a
    csrw 0x3, x3

    #Address 0x3 read value
    csrr x14, 0x3

    #Address 0x3 read value
    csrr x14, 0x3

    #Unmapped address 0xbc testing: random write/read operations
    #Address 0xbc Write value 0xe2ae6426
    li x3, 0xe2ae6426
    csrw 0xbc, x3

    #Unmapped address 0xcb7 testing: random write/read operations
    #Address 0xcb7 read value
    csrr x14, 0xcb7

    #Address 0xcb7 read value
    csrr x14, 0xcb7

    #Address 0xcb7 read value
    csrr x14, 0xcb7

    #Address 0xcb7 Write value 0xe5b0960c
    li x3, 0xe5b0960c
    csrw 0xcb7, x3

    #Unmapped address 0xe2f testing: random write/read operations
    #Address 0xe2f Write value 0x9638e210
    li x3, 0x9638e210
    csrw 0xe2f, x3

    #Address 0xe2f Write value 0x6e4d11f7
    li x3, 0x6e4d11f7
    csrw 0xe2f, x3

    #Unmapped address 0xb63 testing: random write/read operations
    #Address 0xb63 read value
    csrr x14, 0xb63

    #Address 0xb63 Write value 0xcb0a100e
    li x3, 0xcb0a100e
    csrw 0xb63, x3

    #Address 0xb63 read value
    csrr x14, 0xb63

    #Address 0xb63 read value
    csrr x14, 0xb63

    #Unmapped address 0xf96 testing: random write/read operations
    #Address 0xf96 Write value 0xbfc36072
    li x3, 0xbfc36072
    csrw 0xf96, x3

    #Address 0xf96 Write value 0x4d33a1ab
    li x3, 0x4d33a1ab
    csrw 0xf96, x3

    #Address 0xf96 read value
    csrr x14, 0xf96

    #Unmapped address 0x884 testing: random write/read operations
    #Address 0x884 Write value 0x29c3772
    li x3, 0x29c3772
    csrw 0x884, x3

    #Address 0x884 read value
    csrr x14, 0x884

    #Unmapped address 0xbf6 testing: random write/read operations
    #Address 0xbf6 read value
    csrr x14, 0xbf6

    #Address 0xbf6 read value
    csrr x14, 0xbf6

    #Address 0xbf6 read value
    csrr x14, 0xbf6

    #Address 0xbf6 Write value 0x1d81845f
    li x3, 0x1d81845f
    csrw 0xbf6, x3

    #Unmapped address 0xb3f testing: random write/read operations
    #Address 0xb3f Write value 0xdcd0cb79
    li x3, 0xdcd0cb79
    csrw 0xb3f, x3

    #Address 0xb3f read value
    csrr x14, 0xb3f

    #Address 0xb3f Write value 0x60574340
    li x3, 0x60574340
    csrw 0xb3f, x3

    #Address 0xb3f Write value 0x14c99409
    li x3, 0x14c99409
    csrw 0xb3f, x3

    #Address 0xb3f read value
    csrr x14, 0xb3f

    #Unmapped address 0xd07 testing: random write/read operations
    #Address 0xd07 Write value 0xc73d2d73
    li x3, 0xc73d2d73
    csrw 0xd07, x3

    #Unmapped address 0x492 testing: random write/read operations
    #Address 0x492 read value
    csrr x14, 0x492

    #Address 0x492 Write value 0xa101f05c
    li x3, 0xa101f05c
    csrw 0x492, x3

    #Address 0x492 read value
    csrr x14, 0x492

    #Address 0x492 Write value 0x7f612442
    li x3, 0x7f612442
    csrw 0x492, x3

    #Address 0x492 read value
    csrr x14, 0x492

    #Unmapped address 0xa11 testing: random write/read operations
    #Address 0xa11 Write value 0xdb3bfe9d
    li x3, 0xdb3bfe9d
    csrw 0xa11, x3

    #Unmapped address 0x6a5 testing: random write/read operations
    #Address 0x6a5 Write value 0xe982d55
    li x3, 0xe982d55
    csrw 0x6a5, x3

    #Address 0x6a5 Write value 0x5ba83c3
    li x3, 0x5ba83c3
    csrw 0x6a5, x3

    #Address 0x6a5 Write value 0xc31bf090
    li x3, 0xc31bf090
    csrw 0x6a5, x3

    #Address 0x6a5 read value
    csrr x14, 0x6a5

    #Address 0x6a5 Write value 0x1dd4aab1
    li x3, 0x1dd4aab1
    csrw 0x6a5, x3

    #Unmapped address 0xaad testing: random write/read operations
    #Address 0xaad Write value 0x723de832
    li x3, 0x723de832
    csrw 0xaad, x3

    #Unmapped address 0x828 testing: random write/read operations
    #Address 0x828 read value
    csrr x14, 0x828

    #Unmapped address 0xb45 testing: random write/read operations
    #Address 0xb45 Write value 0x3a54ecc2
    li x3, 0x3a54ecc2
    csrw 0xb45, x3

    #Address 0xb45 read value
    csrr x14, 0xb45

    #Unmapped address 0x7d3 testing: random write/read operations
    #Address 0x7d3 read value
    csrr x14, 0x7d3

    #Address 0x7d3 Write value 0x646b557f
    li x3, 0x646b557f
    csrw 0x7d3, x3

    #Address 0x7d3 Write value 0xd8cd431a
    li x3, 0xd8cd431a
    csrw 0x7d3, x3

    #Address 0x7d3 Write value 0x66b16441
    li x3, 0x66b16441
    csrw 0x7d3, x3

    #Unmapped address 0x313 testing: random write/read operations
    #Address 0x313 Write value 0xe24f82a6
    li x3, 0xe24f82a6
    csrw 0x313, x3

    #Address 0x313 Write value 0xa4961948
    li x3, 0xa4961948
    csrw 0x313, x3

    #Unmapped address 0x216 testing: random write/read operations
    #Address 0x216 Write value 0x45e5d429
    li x3, 0x45e5d429
    csrw 0x216, x3

    #Unmapped address 0xc65 testing: random write/read operations
    #Address 0xc65 read value
    csrr x14, 0xc65

    #Address 0xc65 read value
    csrr x14, 0xc65

    #Address 0xc65 read value
    csrr x14, 0xc65

    #Address 0xc65 Write value 0x46ea61a
    li x3, 0x46ea61a
    csrw 0xc65, x3

    #Address 0xc65 Write value 0xab4f086a
    li x3, 0xab4f086a
    csrw 0xc65, x3

    #Unmapped address 0x576 testing: random write/read operations
    #Address 0x576 read value
    csrr x14, 0x576

    #Address 0x576 Write value 0xad67354a
    li x3, 0xad67354a
    csrw 0x576, x3

    #Address 0x576 Write value 0xc9964065
    li x3, 0xc9964065
    csrw 0x576, x3

    #Unmapped address 0x16 testing: random write/read operations
    #Address 0x16 Write value 0xacabb3cf
    li x3, 0xacabb3cf
    csrw 0x16, x3

    #Address 0x16 Write value 0x8d6a07df
    li x3, 0x8d6a07df
    csrw 0x16, x3

    #Address 0x16 read value
    csrr x14, 0x16

    #Address 0x16 Write value 0xbfd90a23
    li x3, 0xbfd90a23
    csrw 0x16, x3

    #Unmapped address 0x860 testing: random write/read operations
    #Address 0x860 Write value 0x93b0ba01
    li x3, 0x93b0ba01
    csrw 0x860, x3

    #Address 0x860 Write value 0xaab57334
    li x3, 0xaab57334
    csrw 0x860, x3

    #Unmapped address 0xec7 testing: random write/read operations
    #Address 0xec7 read value
    csrr x14, 0xec7

    #Address 0xec7 Write value 0xcf011141
    li x3, 0xcf011141
    csrw 0xec7, x3

    #Unmapped address 0x7f9 testing: random write/read operations
    #Address 0x7f9 read value
    csrr x14, 0x7f9

    #Address 0x7f9 read value
    csrr x14, 0x7f9

    #Address 0x7f9 Write value 0xa116dd6b
    li x3, 0xa116dd6b
    csrw 0x7f9, x3

    #Address 0x7f9 Write value 0xb2e259e9
    li x3, 0xb2e259e9
    csrw 0x7f9, x3

    #Address 0x7f9 Write value 0xad7e7bb0
    li x3, 0xad7e7bb0
    csrw 0x7f9, x3

    #Unmapped address 0xc15 testing: random write/read operations
    #Address 0xc15 read value
    csrr x14, 0xc15

    #Address 0xc15 Write value 0x37e33e46
    li x3, 0x37e33e46
    csrw 0xc15, x3

    #Address 0xc15 read value
    csrr x14, 0xc15

    #Address 0xc15 read value
    csrr x14, 0xc15

    #Unmapped address 0xe73 testing: random write/read operations
    #Address 0xe73 read value
    csrr x14, 0xe73

    #Unmapped address 0x4a3 testing: random write/read operations
    #Address 0x4a3 read value
    csrr x14, 0x4a3

    #Address 0x4a3 read value
    csrr x14, 0x4a3

    #Unmapped address 0xb78 testing: random write/read operations
    #Address 0xb78 Write value 0x637cf1
    li x3, 0x637cf1
    csrw 0xb78, x3

    #Address 0xb78 read value
    csrr x14, 0xb78

    #Address 0xb78 read value
    csrr x14, 0xb78

    #Unmapped address 0x697 testing: random write/read operations
    #Address 0x697 read value
    csrr x14, 0x697

    #Address 0x697 read value
    csrr x14, 0x697

    #Address 0x697 Write value 0xf10bfc5f
    li x3, 0xf10bfc5f
    csrw 0x697, x3

    #Address 0x697 read value
    csrr x14, 0x697

    #Unmapped address 0xfeb testing: random write/read operations
    #Address 0xfeb Write value 0x127cd4e3
    li x3, 0x127cd4e3
    csrw 0xfeb, x3

    #Address 0xfeb read value
    csrr x14, 0xfeb

    #Address 0xfeb Write value 0xa46f7418
    li x3, 0xa46f7418
    csrw 0xfeb, x3

    #Unmapped address 0x24a testing: random write/read operations
    #Address 0x24a Write value 0x2b096b62
    li x3, 0x2b096b62
    csrw 0x24a, x3

    #Address 0x24a read value
    csrr x14, 0x24a

    #Address 0x24a Write value 0x99cde370
    li x3, 0x99cde370
    csrw 0x24a, x3

    #Address 0x24a Write value 0x53fa41ec
    li x3, 0x53fa41ec
    csrw 0x24a, x3

    #Address 0x24a Write value 0xcb61aea8
    li x3, 0xcb61aea8
    csrw 0x24a, x3

    #Unmapped address 0x9f8 testing: random write/read operations
    #Address 0x9f8 read value
    csrr x14, 0x9f8

    #Address 0x9f8 read value
    csrr x14, 0x9f8

    #Address 0x9f8 Write value 0x6c52ee2d
    li x3, 0x6c52ee2d
    csrw 0x9f8, x3

    #Unmapped address 0x212 testing: random write/read operations
    #Address 0x212 Write value 0x913e84d1
    li x3, 0x913e84d1
    csrw 0x212, x3

    #Address 0x212 read value
    csrr x14, 0x212

    #Address 0x212 read value
    csrr x14, 0x212

    #Mapped address 0x33e (mhpmevent30) testing: random write/read operations
    #Address 0x33e Write value 0xcf2265a3
    li x3, 0xcf2265a3
    csrw 0x33e, x3

    #Address 0x33e read value
    csrr x14, 0x33e

    #Unmapped address 0x7a2 testing: random write/read operations
    #Address 0x7a2 Write value 0xcd65ce61
    li x3, 0xcd65ce61
    csrw 0x7a2, x3

    #Address 0x7a2 read value
    csrr x14, 0x7a2

    #Address 0x7a2 Write value 0x3d4a0a6
    li x3, 0x3d4a0a6
    csrw 0x7a2, x3

    #Address 0x7a2 read value
    csrr x14, 0x7a2

    #Unmapped address 0x8bf testing: random write/read operations
    #Address 0x8bf Write value 0x697736af
    li x3, 0x697736af
    csrw 0x8bf, x3

    #Address 0x8bf Write value 0x8747347f
    li x3, 0x8747347f
    csrw 0x8bf, x3

    #Address 0x8bf Write value 0xa512f055
    li x3, 0xa512f055
    csrw 0x8bf, x3

    #Address 0x8bf read value
    csrr x14, 0x8bf

    #Unmapped address 0x7e4 testing: random write/read operations
    #Address 0x7e4 read value
    csrr x14, 0x7e4

    #Unmapped address 0x435 testing: random write/read operations
    #Address 0x435 Write value 0x677411ef
    li x3, 0x677411ef
    csrw 0x435, x3

    #Address 0x435 read value
    csrr x14, 0x435

    #Address 0x435 read value
    csrr x14, 0x435

    #Unmapped address 0x56f testing: random write/read operations
    #Address 0x56f read value
    csrr x14, 0x56f

    #Unmapped address 0xef5 testing: random write/read operations
    #Address 0xef5 read value
    csrr x14, 0xef5

    #Unmapped address 0x6df testing: random write/read operations
    #Address 0x6df Write value 0x87eaa82a
    li x3, 0x87eaa82a
    csrw 0x6df, x3

    #Address 0x6df read value
    csrr x14, 0x6df

    #Address 0x6df Write value 0x9ca1061
    li x3, 0x9ca1061
    csrw 0x6df, x3

    #Address 0x6df Write value 0x4548e3d9
    li x3, 0x4548e3d9
    csrw 0x6df, x3

    #Address 0x6df Write value 0xe20d307e
    li x3, 0xe20d307e
    csrw 0x6df, x3

    #Unmapped address 0x506 testing: random write/read operations
    #Address 0x506 Write value 0x417c92a2
    li x3, 0x417c92a2
    csrw 0x506, x3

    #Address 0x506 read value
    csrr x14, 0x506

    #Address 0x506 Write value 0x9331f825
    li x3, 0x9331f825
    csrw 0x506, x3

    #Address 0x506 read value
    csrr x14, 0x506

    #Unmapped address 0xf63 testing: random write/read operations
    #Address 0xf63 read value
    csrr x14, 0xf63

    #Address 0xf63 Write value 0xfc941b37
    li x3, 0xfc941b37
    csrw 0xf63, x3

    #Address 0xf63 read value
    csrr x14, 0xf63

    #Address 0xf63 read value
    csrr x14, 0xf63

    #Address 0xf63 Write value 0x3e7331ec
    li x3, 0x3e7331ec
    csrw 0xf63, x3

    #Unmapped address 0xc4f testing: random write/read operations
    #Address 0xc4f Write value 0x887d26eb
    li x3, 0x887d26eb
    csrw 0xc4f, x3

    #Address 0xc4f read value
    csrr x14, 0xc4f

    #Address 0xc4f read value
    csrr x14, 0xc4f

    #Address 0xc4f read value
    csrr x14, 0xc4f

    #Unmapped address 0xc93 testing: random write/read operations
    #Address 0xc93 Write value 0x68ed2b97
    li x3, 0x68ed2b97
    csrw 0xc93, x3

    #Address 0xc93 Write value 0xcab113eb
    li x3, 0xcab113eb
    csrw 0xc93, x3

    #Unmapped address 0x5b8 testing: random write/read operations
    #Address 0x5b8 read value
    csrr x14, 0x5b8

    #Address 0x5b8 read value
    csrr x14, 0x5b8

    #Address 0x5b8 read value
    csrr x14, 0x5b8

    #Address 0x5b8 Write value 0x3069332a
    li x3, 0x3069332a
    csrw 0x5b8, x3

    #Unmapped address 0x8f9 testing: random write/read operations
    #Address 0x8f9 Write value 0x96cb62b2
    li x3, 0x96cb62b2
    csrw 0x8f9, x3

    #Address 0x8f9 Write value 0x9491c935
    li x3, 0x9491c935
    csrw 0x8f9, x3

    #Address 0x8f9 Write value 0x6103edf2
    li x3, 0x6103edf2
    csrw 0x8f9, x3

    #Unmapped address 0x2e3 testing: random write/read operations
    #Address 0x2e3 Write value 0x6aebaaf9
    li x3, 0x6aebaaf9
    csrw 0x2e3, x3

    #Address 0x2e3 Write value 0x8b6d0012
    li x3, 0x8b6d0012
    csrw 0x2e3, x3

    #Unmapped address 0x140 testing: random write/read operations
    #Address 0x140 Write value 0x4d23fc97
    li x3, 0x4d23fc97
    csrw 0x140, x3

    #Address 0x140 read value
    csrr x14, 0x140

    #Unmapped address 0xf34 testing: random write/read operations
    #Address 0xf34 read value
    csrr x14, 0xf34

    #Address 0xf34 Write value 0x2a85ee9
    li x3, 0x2a85ee9
    csrw 0xf34, x3

    #Address 0xf34 Write value 0xca1d2982
    li x3, 0xca1d2982
    csrw 0xf34, x3

    #Address 0xf34 read value
    csrr x14, 0xf34

    #Address 0xf34 read value
    csrr x14, 0xf34

    #Unmapped address 0x17f testing: random write/read operations
    #Address 0x17f read value
    csrr x14, 0x17f

    #Address 0x17f read value
    csrr x14, 0x17f

    #Unmapped address 0x1e testing: random write/read operations
    #Address 0x1e Write value 0x3026a458
    li x3, 0x3026a458
    csrw 0x1e, x3

    #Address 0x1e Write value 0x78254f68
    li x3, 0x78254f68
    csrw 0x1e, x3

    #Address 0x1e read value
    csrr x14, 0x1e

    #Address 0x1e Write value 0x3f9d02dd
    li x3, 0x3f9d02dd
    csrw 0x1e, x3

    #Address 0x1e Write value 0x6cddbef5
    li x3, 0x6cddbef5
    csrw 0x1e, x3

    #Unmapped address 0x511 testing: random write/read operations
    #Address 0x511 read value
    csrr x14, 0x511

    #Address 0x511 Write value 0xbc7fc16c
    li x3, 0xbc7fc16c
    csrw 0x511, x3

    #Unmapped address 0x84 testing: random write/read operations
    #Address 0x84 read value
    csrr x14, 0x84

    #Address 0x84 read value
    csrr x14, 0x84

    #Unmapped address 0x429 testing: random write/read operations
    #Address 0x429 Write value 0x49347ae4
    li x3, 0x49347ae4
    csrw 0x429, x3

    #Address 0x429 Write value 0xd0210b47
    li x3, 0xd0210b47
    csrw 0x429, x3

    #Address 0x429 Write value 0xb306347b
    li x3, 0xb306347b
    csrw 0x429, x3

    #Address 0x429 Write value 0xffe81ca7
    li x3, 0xffe81ca7
    csrw 0x429, x3

    #Address 0x429 read value
    csrr x14, 0x429

    #Unmapped address 0xf22 testing: random write/read operations
    #Address 0xf22 Write value 0x4607ed5a
    li x3, 0x4607ed5a
    csrw 0xf22, x3

    #Address 0xf22 read value
    csrr x14, 0xf22

    #Mapped address 0xb12 (mhpmcounter18) testing: random write/read operations
    #Address 0xb12 read value
    csrr x14, 0xb12

    #Unmapped address 0xea6 testing: random write/read operations
    #Address 0xea6 Write value 0xff967f83
    li x3, 0xff967f83
    csrw 0xea6, x3

    #Address 0xea6 read value
    csrr x14, 0xea6

    #Unmapped address 0x1ef testing: random write/read operations
    #Address 0x1ef Write value 0x4ff20c2
    li x3, 0x4ff20c2
    csrw 0x1ef, x3

    #Address 0x1ef Write value 0xf5013a9b
    li x3, 0xf5013a9b
    csrw 0x1ef, x3

    #Address 0x1ef Write value 0xab0b4eea
    li x3, 0xab0b4eea
    csrw 0x1ef, x3

    #Address 0x1ef Write value 0xad801cf7
    li x3, 0xad801cf7
    csrw 0x1ef, x3

    #Address 0x1ef Write value 0x70d548b8
    li x3, 0x70d548b8
    csrw 0x1ef, x3

    #Unmapped address 0xf6b testing: random write/read operations
    #Address 0xf6b read value
    csrr x14, 0xf6b

    #Unmapped address 0x32 testing: random write/read operations
    #Address 0x32 read value
    csrr x14, 0x32

    #Address 0x32 read value
    csrr x14, 0x32

    #Address 0x32 read value
    csrr x14, 0x32

    #Unmapped address 0xed4 testing: random write/read operations
    #Address 0xed4 read value
    csrr x14, 0xed4

    #Address 0xed4 Write value 0xc559aaf5
    li x3, 0xc559aaf5
    csrw 0xed4, x3

    #Unmapped address 0xd87 testing: random write/read operations
    #Address 0xd87 Write value 0x4b67c604
    li x3, 0x4b67c604
    csrw 0xd87, x3

    #Address 0xd87 Write value 0x89865fd2
    li x3, 0x89865fd2
    csrw 0xd87, x3

    #Address 0xd87 read value
    csrr x14, 0xd87

    #Address 0xd87 Write value 0x788d74b4
    li x3, 0x788d74b4
    csrw 0xd87, x3

    #Address 0xd87 read value
    csrr x14, 0xd87

    #Unmapped address 0x73d testing: random write/read operations
    #Address 0x73d Write value 0x364135e5
    li x3, 0x364135e5
    csrw 0x73d, x3

    #Unmapped address 0xc8e testing: random write/read operations
    #Address 0xc8e read value
    csrr x14, 0xc8e

    #Address 0xc8e Write value 0xc2dddc58
    li x3, 0xc2dddc58
    csrw 0xc8e, x3

    #Address 0xc8e Write value 0xab74efb8
    li x3, 0xab74efb8
    csrw 0xc8e, x3

    #Unmapped address 0x476 testing: random write/read operations
    #Address 0x476 Write value 0x3b6d1e7e
    li x3, 0x3b6d1e7e
    csrw 0x476, x3

    #Address 0x476 Write value 0x378a4ceb
    li x3, 0x378a4ceb
    csrw 0x476, x3

    #Address 0x476 Write value 0xceb1ae9f
    li x3, 0xceb1ae9f
    csrw 0x476, x3

    #Address 0x476 Write value 0x9490cd96
    li x3, 0x9490cd96
    csrw 0x476, x3

    #Unmapped address 0x9dd testing: random write/read operations
    #Address 0x9dd Write value 0x8ab2d174
    li x3, 0x8ab2d174
    csrw 0x9dd, x3

    #Unmapped address 0x206 testing: random write/read operations
    #Address 0x206 Write value 0x938b0642
    li x3, 0x938b0642
    csrw 0x206, x3

    #Unmapped address 0x74f testing: random write/read operations
    #Address 0x74f Write value 0x8c215347
    li x3, 0x8c215347
    csrw 0x74f, x3

    #Address 0x74f Write value 0x8fd7d163
    li x3, 0x8fd7d163
    csrw 0x74f, x3

    #Unmapped address 0x767 testing: random write/read operations
    #Address 0x767 Write value 0x95f91568
    li x3, 0x95f91568
    csrw 0x767, x3

    #Address 0x767 read value
    csrr x14, 0x767

    #Address 0x767 Write value 0x2dab9af9
    li x3, 0x2dab9af9
    csrw 0x767, x3

    #Unmapped address 0x13d testing: random write/read operations
    #Address 0x13d Write value 0xe59bc2f7
    li x3, 0xe59bc2f7
    csrw 0x13d, x3

    #Address 0x13d read value
    csrr x14, 0x13d

    #Address 0x13d Write value 0xa6535edd
    li x3, 0xa6535edd
    csrw 0x13d, x3

    #Address 0x13d Write value 0x5a41df88
    li x3, 0x5a41df88
    csrw 0x13d, x3

    #Unmapped address 0x751 testing: random write/read operations
    #Address 0x751 Write value 0xb08faea
    li x3, 0xb08faea
    csrw 0x751, x3

    #Mapped address 0xc02 (instret) testing: random write/read operations
    #Address 0xc02 Write value 0x2e32cbfa
    li x3, 0x2e32cbfa
    csrw 0xc02, x3

    #Address 0xc02 Write value 0x7a56c020
    li x3, 0x7a56c020
    csrw 0xc02, x3

    #Address 0xc02 Write value 0x44624b7e
    li x3, 0x44624b7e
    csrw 0xc02, x3

    #Unmapped address 0x318 testing: random write/read operations
    #Address 0x318 read value
    csrr x14, 0x318

    #Unmapped address 0xd16 testing: random write/read operations
    #Address 0xd16 read value
    csrr x14, 0xd16

    #Address 0xd16 read value
    csrr x14, 0xd16

    #Unmapped address 0xcaa testing: random write/read operations
    #Address 0xcaa Write value 0xa4a01c4c
    li x3, 0xa4a01c4c
    csrw 0xcaa, x3

    #Unmapped address 0x247 testing: random write/read operations
    #Address 0x247 read value
    csrr x14, 0x247

    #Address 0x247 read value
    csrr x14, 0x247

    #Address 0x247 read value
    csrr x14, 0x247

    #Unmapped address 0x26e testing: random write/read operations
    #Address 0x26e Write value 0x55d80f4f
    li x3, 0x55d80f4f
    csrw 0x26e, x3

    #Address 0x26e Write value 0x108d19b2
    li x3, 0x108d19b2
    csrw 0x26e, x3

    #Address 0x26e read value
    csrr x14, 0x26e

    #Address 0x26e read value
    csrr x14, 0x26e

    #Unmapped address 0xe5c testing: random write/read operations
    #Address 0xe5c read value
    csrr x14, 0xe5c

    #Address 0xe5c Write value 0x46b12e14
    li x3, 0x46b12e14
    csrw 0xe5c, x3

    #Address 0xe5c read value
    csrr x14, 0xe5c

    #Unmapped address 0x548 testing: random write/read operations
    #Address 0x548 Write value 0xeba63ba8
    li x3, 0xeba63ba8
    csrw 0x548, x3

    #Address 0x548 read value
    csrr x14, 0x548

    #Address 0x548 Write value 0xa8f8d8ab
    li x3, 0xa8f8d8ab
    csrw 0x548, x3

    #Unmapped address 0x9ea testing: random write/read operations
    #Address 0x9ea read value
    csrr x14, 0x9ea

    #Address 0x9ea Write value 0x272f080
    li x3, 0x272f080
    csrw 0x9ea, x3

    #Unmapped address 0xf0c testing: random write/read operations
    #Address 0xf0c Write value 0xa9ea0ea6
    li x3, 0xa9ea0ea6
    csrw 0xf0c, x3

    #Address 0xf0c Write value 0x192fac3e
    li x3, 0x192fac3e
    csrw 0xf0c, x3

    #Address 0xf0c read value
    csrr x14, 0xf0c

    #Address 0xf0c Write value 0xecb3cb79
    li x3, 0xecb3cb79
    csrw 0xf0c, x3

    #Unmapped address 0xc86 testing: random write/read operations
    #Address 0xc86 read value
    csrr x14, 0xc86

    #Address 0xc86 read value
    csrr x14, 0xc86

    #Unmapped address 0x170 testing: random write/read operations
    #Address 0x170 Write value 0x8801803
    li x3, 0x8801803
    csrw 0x170, x3

    #Address 0x170 read value
    csrr x14, 0x170

    #Address 0x170 read value
    csrr x14, 0x170

    #Address 0x170 read value
    csrr x14, 0x170

    #Unmapped address 0xe95 testing: random write/read operations
    #Address 0xe95 read value
    csrr x14, 0xe95

    #Unmapped address 0xf2e testing: random write/read operations
    #Address 0xf2e Write value 0xf7e6f9f1
    li x3, 0xf7e6f9f1
    csrw 0xf2e, x3

    #Address 0xf2e read value
    csrr x14, 0xf2e

    #Address 0xf2e Write value 0x96ca3974
    li x3, 0x96ca3974
    csrw 0xf2e, x3

    #Address 0xf2e read value
    csrr x14, 0xf2e

    #Unmapped address 0x10e testing: random write/read operations
    #Address 0x10e Write value 0x438a355b
    li x3, 0x438a355b
    csrw 0x10e, x3

    #Address 0x10e read value
    csrr x14, 0x10e

    #Unmapped address 0xd7a testing: random write/read operations
    #Address 0xd7a Write value 0x293dad7c
    li x3, 0x293dad7c
    csrw 0xd7a, x3

    #Address 0xd7a Write value 0x5195316c
    li x3, 0x5195316c
    csrw 0xd7a, x3

    #Unmapped address 0x9c8 testing: random write/read operations
    #Address 0x9c8 read value
    csrr x14, 0x9c8

    #Unmapped address 0x40b testing: random write/read operations
    #Address 0x40b read value
    csrr x14, 0x40b

    #Unmapped address 0xe4 testing: random write/read operations
    #Address 0xe4 Write value 0x8ce664d1
    li x3, 0x8ce664d1
    csrw 0xe4, x3

    #Address 0xe4 Write value 0xfecb456d
    li x3, 0xfecb456d
    csrw 0xe4, x3

    #Address 0xe4 read value
    csrr x14, 0xe4

    #Address 0xe4 Write value 0x5892350b
    li x3, 0x5892350b
    csrw 0xe4, x3

    #Unmapped address 0xab2 testing: random write/read operations
    #Address 0xab2 read value
    csrr x14, 0xab2

    #Address 0xab2 Write value 0x188c3b4
    li x3, 0x188c3b4
    csrw 0xab2, x3

    #Unmapped address 0x13b testing: random write/read operations
    #Address 0x13b read value
    csrr x14, 0x13b

    #Address 0x13b Write value 0xe81b7b4d
    li x3, 0xe81b7b4d
    csrw 0x13b, x3

    #Unmapped address 0x3a8 testing: random write/read operations
    #Address 0x3a8 read value
    csrr x14, 0x3a8

    #Unmapped address 0xa1a testing: random write/read operations
    #Address 0xa1a read value
    csrr x14, 0xa1a

    #Unmapped address 0x29e testing: random write/read operations
    #Address 0x29e Write value 0x7bb01464
    li x3, 0x7bb01464
    csrw 0x29e, x3

    #Address 0x29e read value
    csrr x14, 0x29e

    #Address 0x29e Write value 0xd7e50306
    li x3, 0xd7e50306
    csrw 0x29e, x3

    #Address 0x29e read value
    csrr x14, 0x29e

    #Unmapped address 0xef testing: random write/read operations
    #Address 0xef read value
    csrr x14, 0xef

    #Unmapped address 0x114 testing: random write/read operations
    #Address 0x114 Write value 0x4c2f10cf
    li x3, 0x4c2f10cf
    csrw 0x114, x3

    #Address 0x114 Write value 0x75cff09e
    li x3, 0x75cff09e
    csrw 0x114, x3

    #Unmapped address 0x8e0 testing: random write/read operations
    #Address 0x8e0 read value
    csrr x14, 0x8e0

    #Unmapped address 0x5ec testing: random write/read operations
    #Address 0x5ec read value
    csrr x14, 0x5ec

    #Address 0x5ec Write value 0x5760b6bb
    li x3, 0x5760b6bb
    csrw 0x5ec, x3

    #Unmapped address 0x46c testing: random write/read operations
    #Address 0x46c read value
    csrr x14, 0x46c

    #Unmapped address 0x676 testing: random write/read operations
    #Address 0x676 Write value 0xfb22b4f6
    li x3, 0xfb22b4f6
    csrw 0x676, x3

    #Address 0x676 read value
    csrr x14, 0x676

    #Unmapped address 0x31f testing: random write/read operations
    #Address 0x31f read value
    csrr x14, 0x31f

    #Address 0x31f read value
    csrr x14, 0x31f

    #Address 0x31f Write value 0xa16d0137
    li x3, 0xa16d0137
    csrw 0x31f, x3

    #Unmapped address 0x3de testing: random write/read operations
    #Address 0x3de Write value 0xa8218a3a
    li x3, 0xa8218a3a
    csrw 0x3de, x3

    #Unmapped address 0x217 testing: random write/read operations
    #Address 0x217 Write value 0xc04f7ab9
    li x3, 0xc04f7ab9
    csrw 0x217, x3

    #Address 0x217 Write value 0x1a2eef76
    li x3, 0x1a2eef76
    csrw 0x217, x3

    #Address 0x217 read value
    csrr x14, 0x217

    #Address 0x217 read value
    csrr x14, 0x217

    #Address 0x217 read value
    csrr x14, 0x217

    #Unmapped address 0x7eb testing: random write/read operations
    #Address 0x7eb Write value 0xc357de45
    li x3, 0xc357de45
    csrw 0x7eb, x3

    #Address 0x7eb Write value 0x522da36c
    li x3, 0x522da36c
    csrw 0x7eb, x3

    #Address 0x7eb Write value 0x214ec823
    li x3, 0x214ec823
    csrw 0x7eb, x3

    #Address 0x7eb Write value 0xfda120b5
    li x3, 0xfda120b5
    csrw 0x7eb, x3

    #Unmapped address 0xdd4 testing: random write/read operations
    #Address 0xdd4 read value
    csrr x14, 0xdd4

    #Address 0xdd4 read value
    csrr x14, 0xdd4

    #Address 0xdd4 read value
    csrr x14, 0xdd4

    #Address 0xdd4 read value
    csrr x14, 0xdd4

    #Address 0xdd4 read value
    csrr x14, 0xdd4

    #Unmapped address 0x285 testing: random write/read operations
    #Address 0x285 read value
    csrr x14, 0x285

    #Address 0x285 Write value 0xef6bc51
    li x3, 0xef6bc51
    csrw 0x285, x3

    #Unmapped address 0x98c testing: random write/read operations
    #Address 0x98c read value
    csrr x14, 0x98c

    #Address 0x98c Write value 0xe4db1e24
    li x3, 0xe4db1e24
    csrw 0x98c, x3

    #Address 0x98c Write value 0x76be3612
    li x3, 0x76be3612
    csrw 0x98c, x3

    #Address 0x98c Write value 0x96a1d8c5
    li x3, 0x96a1d8c5
    csrw 0x98c, x3

    #Unmapped address 0x57f testing: random write/read operations
    #Address 0x57f Write value 0xd10760ef
    li x3, 0xd10760ef
    csrw 0x57f, x3

    #Address 0x57f Write value 0xaae9dfbc
    li x3, 0xaae9dfbc
    csrw 0x57f, x3

    #Address 0x57f Write value 0x3a4717b4
    li x3, 0x3a4717b4
    csrw 0x57f, x3

    #Address 0x57f read value
    csrr x14, 0x57f

    #Unmapped address 0xfa2 testing: random write/read operations
    #Address 0xfa2 read value
    csrr x14, 0xfa2

    #Address 0xfa2 Write value 0x3462c922
    li x3, 0x3462c922
    csrw 0xfa2, x3

    #Address 0xfa2 Write value 0xee857f6b
    li x3, 0xee857f6b
    csrw 0xfa2, x3

    #Address 0xfa2 read value
    csrr x14, 0xfa2

    #Address 0xfa2 read value
    csrr x14, 0xfa2

    #Unmapped address 0xcb2 testing: random write/read operations
    #Address 0xcb2 read value
    csrr x14, 0xcb2

    #Address 0xcb2 read value
    csrr x14, 0xcb2

    #Address 0xcb2 read value
    csrr x14, 0xcb2

    #Address 0xcb2 Write value 0x3f41586b
    li x3, 0x3f41586b
    csrw 0xcb2, x3

    #Unmapped address 0x1db testing: random write/read operations
    #Address 0x1db Write value 0xb3146d4a
    li x3, 0xb3146d4a
    csrw 0x1db, x3

    #Unmapped address 0x999 testing: random write/read operations
    #Address 0x999 read value
    csrr x14, 0x999

    #Address 0x999 Write value 0xe8383cf1
    li x3, 0xe8383cf1
    csrw 0x999, x3

    #Unmapped address 0xa16 testing: random write/read operations
    #Address 0xa16 read value
    csrr x14, 0xa16

    #Address 0xa16 read value
    csrr x14, 0xa16

    #Address 0xa16 read value
    csrr x14, 0xa16

    #Unmapped address 0x8a9 testing: random write/read operations
    #Address 0x8a9 read value
    csrr x14, 0x8a9

    #Address 0x8a9 read value
    csrr x14, 0x8a9

    #Address 0x8a9 Write value 0xecc8bdf4
    li x3, 0xecc8bdf4
    csrw 0x8a9, x3

    #Mapped address 0xb0e (mhpmcounter14) testing: random write/read operations
    #Address 0xb0e Write value 0xd0b9b5b2
    li x3, 0xd0b9b5b2
    csrw 0xb0e, x3

    #Unmapped address 0x9c5 testing: random write/read operations
    #Address 0x9c5 Write value 0xb70e615f
    li x3, 0xb70e615f
    csrw 0x9c5, x3

    #Address 0x9c5 read value
    csrr x14, 0x9c5

    #Address 0x9c5 read value
    csrr x14, 0x9c5

    #Address 0x9c5 read value
    csrr x14, 0x9c5

    #Address 0x9c5 read value
    csrr x14, 0x9c5

    #Unmapped address 0x1c4 testing: random write/read operations
    #Address 0x1c4 read value
    csrr x14, 0x1c4

    #Address 0x1c4 read value
    csrr x14, 0x1c4

    #Unmapped address 0x126 testing: random write/read operations
    #Address 0x126 read value
    csrr x14, 0x126

    #Address 0x126 Write value 0x57e56da9
    li x3, 0x57e56da9
    csrw 0x126, x3

    #Address 0x126 Write value 0xe8508419
    li x3, 0xe8508419
    csrw 0x126, x3

    #Address 0x126 read value
    csrr x14, 0x126

    #Address 0x126 read value
    csrr x14, 0x126

    #Mapped address 0xb85 (mhpmcounterh5) testing: random write/read operations
    #Address 0xb85 read value
    csrr x14, 0xb85

    #Address 0xb85 read value
    csrr x14, 0xb85

    #Address 0xb85 Write value 0x7bc177e9
    li x3, 0x7bc177e9
    csrw 0xb85, x3

    #Address 0xb85 Write value 0x26721f11
    li x3, 0x26721f11
    csrw 0xb85, x3

    #Unmapped address 0xd39 testing: random write/read operations
    #Address 0xd39 read value
    csrr x14, 0xd39

    #Address 0xd39 read value
    csrr x14, 0xd39

    #Address 0xd39 read value
    csrr x14, 0xd39

    #Unmapped address 0x7a6 testing: random write/read operations
    #Address 0x7a6 Write value 0x21c6a529
    li x3, 0x21c6a529
    csrw 0x7a6, x3

    #Unmapped address 0xc testing: random write/read operations
    #Address 0xc read value
    csrr x14, 0xc

    #Address 0xc Write value 0xf5850767
    li x3, 0xf5850767
    csrw 0xc, x3

    #Address 0xc read value
    csrr x14, 0xc

    #Unmapped address 0x814 testing: random write/read operations
    #Address 0x814 Write value 0x36cf98a8
    li x3, 0x36cf98a8
    csrw 0x814, x3

    #Address 0x814 Write value 0x65b8231a
    li x3, 0x65b8231a
    csrw 0x814, x3

    #Unmapped address 0xe4e testing: random write/read operations
    #Address 0xe4e Write value 0x1fe280b
    li x3, 0x1fe280b
    csrw 0xe4e, x3

    #Address 0xe4e Write value 0x111aa051
    li x3, 0x111aa051
    csrw 0xe4e, x3

    #Address 0xe4e read value
    csrr x14, 0xe4e

    #Address 0xe4e Write value 0x36fe6c98
    li x3, 0x36fe6c98
    csrw 0xe4e, x3

    #Address 0xe4e read value
    csrr x14, 0xe4e

    #Unmapped address 0x3ff testing: random write/read operations
    #Address 0x3ff read value
    csrr x14, 0x3ff

    #Address 0x3ff read value
    csrr x14, 0x3ff

    #Unmapped address 0x5b9 testing: random write/read operations
    #Address 0x5b9 Write value 0x8c6a2c5f
    li x3, 0x8c6a2c5f
    csrw 0x5b9, x3

    #Address 0x5b9 Write value 0x213ae361
    li x3, 0x213ae361
    csrw 0x5b9, x3

    #Address 0x5b9 Write value 0xe99adc8c
    li x3, 0xe99adc8c
    csrw 0x5b9, x3

    #Unmapped address 0x3c testing: random write/read operations
    #Address 0x3c read value
    csrr x14, 0x3c

    #Address 0x3c read value
    csrr x14, 0x3c

    #Address 0x3c Write value 0x34701743
    li x3, 0x34701743
    csrw 0x3c, x3

    #Unmapped address 0x36d testing: random write/read operations
    #Address 0x36d read value
    csrr x14, 0x36d

    #Address 0x36d read value
    csrr x14, 0x36d

    #Address 0x36d Write value 0xee90df8b
    li x3, 0xee90df8b
    csrw 0x36d, x3

    #Address 0x36d Write value 0xa83a0d23
    li x3, 0xa83a0d23
    csrw 0x36d, x3

    #Address 0x36d read value
    csrr x14, 0x36d

    #Unmapped address 0xd17 testing: random write/read operations
    #Address 0xd17 Write value 0xcf7ce7bf
    li x3, 0xcf7ce7bf
    csrw 0xd17, x3

    #Address 0xd17 read value
    csrr x14, 0xd17

    #Address 0xd17 read value
    csrr x14, 0xd17

    #Address 0xd17 Write value 0x55476f2e
    li x3, 0x55476f2e
    csrw 0xd17, x3

    #Address 0xd17 Write value 0x461ae90
    li x3, 0x461ae90
    csrw 0xd17, x3

    #Unmapped address 0x89a testing: random write/read operations
    #Address 0x89a Write value 0x64fea515
    li x3, 0x64fea515
    csrw 0x89a, x3

    #Address 0x89a read value
    csrr x14, 0x89a

    #Address 0x89a Write value 0x24b98a7e
    li x3, 0x24b98a7e
    csrw 0x89a, x3

    #Address 0x89a read value
    csrr x14, 0x89a

    #Address 0x89a read value
    csrr x14, 0x89a

    #Unmapped address 0x159 testing: random write/read operations
    #Address 0x159 Write value 0xe003af8f
    li x3, 0xe003af8f
    csrw 0x159, x3

    #Address 0x159 Write value 0x2f9531f8
    li x3, 0x2f9531f8
    csrw 0x159, x3

    #Unmapped address 0xc3b testing: random write/read operations
    #Address 0xc3b read value
    csrr x14, 0xc3b

    #Address 0xc3b Write value 0x50068319
    li x3, 0x50068319
    csrw 0xc3b, x3

    #Address 0xc3b read value
    csrr x14, 0xc3b

    #Address 0xc3b read value
    csrr x14, 0xc3b

    #Address 0xc3b Write value 0x1e9f3d12
    li x3, 0x1e9f3d12
    csrw 0xc3b, x3

    #Unmapped address 0xd4e testing: random write/read operations
    #Address 0xd4e read value
    csrr x14, 0xd4e

    #Address 0xd4e read value
    csrr x14, 0xd4e

    #Address 0xd4e read value
    csrr x14, 0xd4e

    #Unmapped address 0x172 testing: random write/read operations
    #Address 0x172 Write value 0x60e71f57
    li x3, 0x60e71f57
    csrw 0x172, x3

    #Address 0x172 read value
    csrr x14, 0x172

    #Unmapped address 0xdd2 testing: random write/read operations
    #Address 0xdd2 read value
    csrr x14, 0xdd2

    #Address 0xdd2 Write value 0x180d59fe
    li x3, 0x180d59fe
    csrw 0xdd2, x3

    #Address 0xdd2 read value
    csrr x14, 0xdd2

    #Address 0xdd2 Write value 0xc6c3579a
    li x3, 0xc6c3579a
    csrw 0xdd2, x3

    #Unmapped address 0x3d4 testing: random write/read operations
    #Address 0x3d4 read value
    csrr x14, 0x3d4

    #Address 0x3d4 read value
    csrr x14, 0x3d4

    #Unmapped address 0x596 testing: random write/read operations
    #Address 0x596 read value
    csrr x14, 0x596

    #Address 0x596 read value
    csrr x14, 0x596

    #Address 0x596 Write value 0x9cb8271a
    li x3, 0x9cb8271a
    csrw 0x596, x3

    #Unmapped address 0x2f0 testing: random write/read operations
    #Address 0x2f0 read value
    csrr x14, 0x2f0

    #Address 0x2f0 read value
    csrr x14, 0x2f0

    #Address 0x2f0 Write value 0xf3673035
    li x3, 0xf3673035
    csrw 0x2f0, x3

    #Address 0x2f0 read value
    csrr x14, 0x2f0

    #Unmapped address 0x98d testing: random write/read operations
    #Address 0x98d read value
    csrr x14, 0x98d

    #Address 0x98d read value
    csrr x14, 0x98d

    #Unmapped address 0x75 testing: random write/read operations
    #Address 0x75 read value
    csrr x14, 0x75

    #Address 0x75 Write value 0x990b0941
    li x3, 0x990b0941
    csrw 0x75, x3

    #Unmapped address 0x6b7 testing: random write/read operations
    #Address 0x6b7 read value
    csrr x14, 0x6b7

    #Address 0x6b7 read value
    csrr x14, 0x6b7

    #Address 0x6b7 read value
    csrr x14, 0x6b7

    #Address 0x6b7 Write value 0x6cdb0dff
    li x3, 0x6cdb0dff
    csrw 0x6b7, x3

    #Address 0x6b7 read value
    csrr x14, 0x6b7

    #Unmapped address 0xae5 testing: random write/read operations
    #Address 0xae5 read value
    csrr x14, 0xae5

    #Address 0xae5 Write value 0x7c75990a
    li x3, 0x7c75990a
    csrw 0xae5, x3

    #Address 0xae5 read value
    csrr x14, 0xae5

    #Unmapped address 0x415 testing: random write/read operations
    #Address 0x415 Write value 0x627bfa36
    li x3, 0x627bfa36
    csrw 0x415, x3

    #Unmapped address 0xcc3 testing: random write/read operations
    #Address 0xcc3 Write value 0x67964b45
    li x3, 0x67964b45
    csrw 0xcc3, x3

    #Address 0xcc3 Write value 0x96d0eac1
    li x3, 0x96d0eac1
    csrw 0xcc3, x3

    #Address 0xcc3 read value
    csrr x14, 0xcc3

    #Address 0xcc3 Write value 0xc655d8e9
    li x3, 0xc655d8e9
    csrw 0xcc3, x3

    #Address 0xcc3 Write value 0x9c5d8814
    li x3, 0x9c5d8814
    csrw 0xcc3, x3

    #Unmapped address 0xd71 testing: random write/read operations
    #Address 0xd71 read value
    csrr x14, 0xd71

    #Address 0xd71 Write value 0x63cfd75
    li x3, 0x63cfd75
    csrw 0xd71, x3

    #Unmapped address 0x849 testing: random write/read operations
    #Address 0x849 Write value 0x77ef73cb
    li x3, 0x77ef73cb
    csrw 0x849, x3

    #Address 0x849 Write value 0xf00b4729
    li x3, 0xf00b4729
    csrw 0x849, x3

    #Address 0x849 read value
    csrr x14, 0x849

    #Unmapped address 0x536 testing: random write/read operations
    #Address 0x536 read value
    csrr x14, 0x536

    #Address 0x536 Write value 0x2ebe6dd5
    li x3, 0x2ebe6dd5
    csrw 0x536, x3

    #Address 0x536 read value
    csrr x14, 0x536

    #Address 0x536 Write value 0xfa3dd393
    li x3, 0xfa3dd393
    csrw 0x536, x3

    #Unmapped address 0x2eb testing: random write/read operations
    #Address 0x2eb Write value 0xa87b1278
    li x3, 0xa87b1278
    csrw 0x2eb, x3

    #Address 0x2eb Write value 0x7a8a8d21
    li x3, 0x7a8a8d21
    csrw 0x2eb, x3

    #Address 0x2eb read value
    csrr x14, 0x2eb

    #Unmapped address 0x151 testing: random write/read operations
    #Address 0x151 read value
    csrr x14, 0x151

    #Address 0x151 Write value 0xcf06ef06
    li x3, 0xcf06ef06
    csrw 0x151, x3

    #Address 0x151 Write value 0x457d4b43
    li x3, 0x457d4b43
    csrw 0x151, x3

    #Unmapped address 0x9bd testing: random write/read operations
    #Address 0x9bd read value
    csrr x14, 0x9bd

    #Unmapped address 0xd52 testing: random write/read operations
    #Address 0xd52 Write value 0x784930eb
    li x3, 0x784930eb
    csrw 0xd52, x3

    #Address 0xd52 Write value 0x8d0ae3aa
    li x3, 0x8d0ae3aa
    csrw 0xd52, x3

    #Address 0xd52 read value
    csrr x14, 0xd52

    #Unmapped address 0xf9e testing: random write/read operations
    #Address 0xf9e Write value 0x6b17a81c
    li x3, 0x6b17a81c
    csrw 0xf9e, x3

    #Address 0xf9e read value
    csrr x14, 0xf9e

    #Address 0xf9e Write value 0x4652ff79
    li x3, 0x4652ff79
    csrw 0xf9e, x3

    #Address 0xf9e read value
    csrr x14, 0xf9e

    #Address 0xf9e read value
    csrr x14, 0xf9e

    #Unmapped address 0xa56 testing: random write/read operations
    #Address 0xa56 Write value 0x54421a90
    li x3, 0x54421a90
    csrw 0xa56, x3

    #Address 0xa56 Write value 0xf1470901
    li x3, 0xf1470901
    csrw 0xa56, x3

    #Address 0xa56 Write value 0x9442d090
    li x3, 0x9442d090
    csrw 0xa56, x3

    #Address 0xa56 read value
    csrr x14, 0xa56

    #Unmapped address 0xa71 testing: random write/read operations
    #Address 0xa71 read value
    csrr x14, 0xa71

    #Address 0xa71 read value
    csrr x14, 0xa71

    #Address 0xa71 Write value 0x431be5ec
    li x3, 0x431be5ec
    csrw 0xa71, x3

    #Unmapped address 0xf01 testing: random write/read operations
    #Address 0xf01 read value
    csrr x14, 0xf01

    #Address 0xf01 Write value 0xb7bf0f4
    li x3, 0xb7bf0f4
    csrw 0xf01, x3

    #Address 0xf01 read value
    csrr x14, 0xf01

    #Address 0xf01 Write value 0x2d816d67
    li x3, 0x2d816d67
    csrw 0xf01, x3

    #Address 0xf01 Write value 0x3578d230
    li x3, 0x3578d230
    csrw 0xf01, x3

    #Unmapped address 0xd22 testing: random write/read operations
    #Address 0xd22 read value
    csrr x14, 0xd22

    #Address 0xd22 Write value 0x7c9f2084
    li x3, 0x7c9f2084
    csrw 0xd22, x3

    #Unmapped address 0x53 testing: random write/read operations
    #Address 0x53 Write value 0x64884e88
    li x3, 0x64884e88
    csrw 0x53, x3

    #Address 0x53 read value
    csrr x14, 0x53

    #Unmapped address 0x531 testing: random write/read operations
    #Address 0x531 Write value 0xdbe3fc23
    li x3, 0xdbe3fc23
    csrw 0x531, x3

    #Address 0x531 read value
    csrr x14, 0x531

    #Unmapped address 0x381 testing: random write/read operations
    #Address 0x381 read value
    csrr x14, 0x381

    #Address 0x381 Write value 0x1163928d
    li x3, 0x1163928d
    csrw 0x381, x3

    #Address 0x381 Write value 0x393cab4d
    li x3, 0x393cab4d
    csrw 0x381, x3

    #Address 0x381 Write value 0xaffc5943
    li x3, 0xaffc5943
    csrw 0x381, x3

    #Unmapped address 0x61d testing: random write/read operations
    #Address 0x61d Write value 0xa3990152
    li x3, 0xa3990152
    csrw 0x61d, x3

    #Address 0x61d read value
    csrr x14, 0x61d

    #Address 0x61d Write value 0xf123fcae
    li x3, 0xf123fcae
    csrw 0x61d, x3

    #Address 0x61d read value
    csrr x14, 0x61d

    #Address 0x61d read value
    csrr x14, 0x61d

    #Unmapped address 0x25f testing: random write/read operations
    #Address 0x25f read value
    csrr x14, 0x25f

    #Address 0x25f read value
    csrr x14, 0x25f

    #Unmapped address 0xbcb testing: random write/read operations
    #Address 0xbcb read value
    csrr x14, 0xbcb

    #Address 0xbcb read value
    csrr x14, 0xbcb

    #Address 0xbcb Write value 0xfc88c7e9
    li x3, 0xfc88c7e9
    csrw 0xbcb, x3

    #Address 0xbcb read value
    csrr x14, 0xbcb

    #Unmapped address 0x66f testing: random write/read operations
    #Address 0x66f Write value 0x14d222fb
    li x3, 0x14d222fb
    csrw 0x66f, x3

    #Address 0x66f read value
    csrr x14, 0x66f

    #Address 0x66f read value
    csrr x14, 0x66f

    #Address 0x66f Write value 0x25883099
    li x3, 0x25883099
    csrw 0x66f, x3

    #Address 0x66f read value
    csrr x14, 0x66f

    #Unmapped address 0xa61 testing: random write/read operations
    #Address 0xa61 read value
    csrr x14, 0xa61

    #Address 0xa61 Write value 0xd44186cf
    li x3, 0xd44186cf
    csrw 0xa61, x3

    #Address 0xa61 Write value 0x7783c9ea
    li x3, 0x7783c9ea
    csrw 0xa61, x3

    #Address 0xa61 read value
    csrr x14, 0xa61

    #Unmapped address 0x92c testing: random write/read operations
    #Address 0x92c Write value 0xa839bad6
    li x3, 0xa839bad6
    csrw 0x92c, x3

    #Address 0x92c read value
    csrr x14, 0x92c

    #Unmapped address 0x8a8 testing: random write/read operations
    #Address 0x8a8 read value
    csrr x14, 0x8a8

    #Address 0x8a8 read value
    csrr x14, 0x8a8

    #Address 0x8a8 Write value 0xa1034122
    li x3, 0xa1034122
    csrw 0x8a8, x3

    #Address 0x8a8 read value
    csrr x14, 0x8a8

    #Address 0x8a8 read value
    csrr x14, 0x8a8

    #Unmapped address 0x56 testing: random write/read operations
    #Address 0x56 read value
    csrr x14, 0x56

    #Address 0x56 read value
    csrr x14, 0x56

    #Address 0x56 Write value 0xbfd331f0
    li x3, 0xbfd331f0
    csrw 0x56, x3

    #Address 0x56 Write value 0x2917e940
    li x3, 0x2917e940
    csrw 0x56, x3

    #Unmapped address 0xdc testing: random write/read operations
    #Address 0xdc Write value 0xe9b69911
    li x3, 0xe9b69911
    csrw 0xdc, x3

    #Address 0xdc Write value 0xb682e2ae
    li x3, 0xb682e2ae
    csrw 0xdc, x3

    #Address 0xdc read value
    csrr x14, 0xdc

    #Address 0xdc read value
    csrr x14, 0xdc

    #Address 0xdc read value
    csrr x14, 0xdc

    #Unmapped address 0x719 testing: random write/read operations
    #Address 0x719 read value
    csrr x14, 0x719

    #Unmapped address 0xeb4 testing: random write/read operations
    #Address 0xeb4 Write value 0x2cf552bf
    li x3, 0x2cf552bf
    csrw 0xeb4, x3

    #Address 0xeb4 Write value 0xd7e08e4b
    li x3, 0xd7e08e4b
    csrw 0xeb4, x3

    #Address 0xeb4 read value
    csrr x14, 0xeb4

    #Address 0xeb4 read value
    csrr x14, 0xeb4

    #Address 0xeb4 Write value 0x7a22c98c
    li x3, 0x7a22c98c
    csrw 0xeb4, x3

    #Unmapped address 0xf99 testing: random write/read operations
    #Address 0xf99 Write value 0xf309d2d3
    li x3, 0xf309d2d3
    csrw 0xf99, x3

    #Address 0xf99 read value
    csrr x14, 0xf99

    #Address 0xf99 read value
    csrr x14, 0xf99

    #Unmapped address 0x49a testing: random write/read operations
    #Address 0x49a read value
    csrr x14, 0x49a

    #Address 0x49a Write value 0xab68c077
    li x3, 0xab68c077
    csrw 0x49a, x3

    #Address 0x49a Write value 0xa8dc73f0
    li x3, 0xa8dc73f0
    csrw 0x49a, x3

    #Address 0x49a read value
    csrr x14, 0x49a

    #Address 0x49a Write value 0x8f41bc77
    li x3, 0x8f41bc77
    csrw 0x49a, x3

    #Unmapped address 0x688 testing: random write/read operations
    #Address 0x688 Write value 0xca6b941a
    li x3, 0xca6b941a
    csrw 0x688, x3

    #Address 0x688 read value
    csrr x14, 0x688

    #Address 0x688 read value
    csrr x14, 0x688

    #Address 0x688 Write value 0xd3ec8854
    li x3, 0xd3ec8854
    csrw 0x688, x3

    #Unmapped address 0x623 testing: random write/read operations
    #Address 0x623 Write value 0x85f9f7e2
    li x3, 0x85f9f7e2
    csrw 0x623, x3

    #Address 0x623 Write value 0xa64bd488
    li x3, 0xa64bd488
    csrw 0x623, x3

    #Address 0x623 read value
    csrr x14, 0x623

    #Address 0x623 read value
    csrr x14, 0x623

    #Unmapped address 0x771 testing: random write/read operations
    #Address 0x771 read value
    csrr x14, 0x771

    #Address 0x771 read value
    csrr x14, 0x771

    #Unmapped address 0x5f8 testing: random write/read operations
    #Address 0x5f8 read value
    csrr x14, 0x5f8

    #Address 0x5f8 read value
    csrr x14, 0x5f8

    #Address 0x5f8 Write value 0x6769118a
    li x3, 0x6769118a
    csrw 0x5f8, x3

    #Address 0x5f8 read value
    csrr x14, 0x5f8

    #Address 0x5f8 Write value 0xb31168d7
    li x3, 0xb31168d7
    csrw 0x5f8, x3

    #Unmapped address 0x34e testing: random write/read operations
    #Address 0x34e read value
    csrr x14, 0x34e

    #Address 0x34e Write value 0x84d06893
    li x3, 0x84d06893
    csrw 0x34e, x3

    #Address 0x34e read value
    csrr x14, 0x34e

    #Address 0x34e Write value 0x5e11623c
    li x3, 0x5e11623c
    csrw 0x34e, x3

    #Address 0x34e read value
    csrr x14, 0x34e

    #Unmapped address 0x5ad testing: random write/read operations
    #Address 0x5ad read value
    csrr x14, 0x5ad

    #Address 0x5ad Write value 0x37f21b1d
    li x3, 0x37f21b1d
    csrw 0x5ad, x3

    #Address 0x5ad Write value 0x7fa76803
    li x3, 0x7fa76803
    csrw 0x5ad, x3

    #Address 0x5ad read value
    csrr x14, 0x5ad

    #Address 0x5ad Write value 0xc1cbfbe0
    li x3, 0xc1cbfbe0
    csrw 0x5ad, x3

    #Unmapped address 0xa53 testing: random write/read operations
    #Address 0xa53 read value
    csrr x14, 0xa53

    #Address 0xa53 Write value 0xed5a68ee
    li x3, 0xed5a68ee
    csrw 0xa53, x3

    #Address 0xa53 read value
    csrr x14, 0xa53

    #Unmapped address 0x5cd testing: random write/read operations
    #Address 0x5cd read value
    csrr x14, 0x5cd

    #Address 0x5cd read value
    csrr x14, 0x5cd

    #Address 0x5cd read value
    csrr x14, 0x5cd

    #Mapped address 0xb87 (mhpmcounterh7) testing: random write/read operations
    #Address 0xb87 read value
    csrr x14, 0xb87

    #Address 0xb87 read value
    csrr x14, 0xb87

    #Address 0xb87 read value
    csrr x14, 0xb87

    #Unmapped address 0xb22 testing: random write/read operations
    #Address 0xb22 read value
    csrr x14, 0xb22

    #Unmapped address 0xe4d testing: random write/read operations
    #Address 0xe4d read value
    csrr x14, 0xe4d

    #Address 0xe4d read value
    csrr x14, 0xe4d

    #Unmapped address 0x892 testing: random write/read operations
    #Address 0x892 read value
    csrr x14, 0x892

    #Address 0x892 read value
    csrr x14, 0x892

    #Address 0x892 read value
    csrr x14, 0x892

    #Unmapped address 0x5d testing: random write/read operations
    #Address 0x5d read value
    csrr x14, 0x5d

    #Address 0x5d Write value 0x9f713892
    li x3, 0x9f713892
    csrw 0x5d, x3

    #Address 0x5d read value
    csrr x14, 0x5d

    #Address 0x5d Write value 0x3d9a1410
    li x3, 0x3d9a1410
    csrw 0x5d, x3

    #Address 0x5d read value
    csrr x14, 0x5d

    #Unmapped address 0xfb8 testing: random write/read operations
    #Address 0xfb8 read value
    csrr x14, 0xfb8

    #Address 0xfb8 Write value 0xd5d4c5c0
    li x3, 0xd5d4c5c0
    csrw 0xfb8, x3

    #Address 0xfb8 Write value 0xa90d0a9
    li x3, 0xa90d0a9
    csrw 0xfb8, x3

    #Address 0xfb8 Write value 0xbab8446c
    li x3, 0xbab8446c
    csrw 0xfb8, x3

    #Address 0xfb8 Write value 0x6c88aac7
    li x3, 0x6c88aac7
    csrw 0xfb8, x3

    #Unmapped address 0xca testing: random write/read operations
    #Address 0xca Write value 0x8a3e538d
    li x3, 0x8a3e538d
    csrw 0xca, x3

    #Address 0xca read value
    csrr x14, 0xca

    #Address 0xca Write value 0x4a7a209b
    li x3, 0x4a7a209b
    csrw 0xca, x3

    #Address 0xca read value
    csrr x14, 0xca

    #Unmapped address 0x4d5 testing: random write/read operations
    #Address 0x4d5 read value
    csrr x14, 0x4d5

    #Address 0x4d5 Write value 0x478b2d7
    li x3, 0x478b2d7
    csrw 0x4d5, x3

    #Address 0x4d5 Write value 0x1d7bce0b
    li x3, 0x1d7bce0b
    csrw 0x4d5, x3

    #Address 0x4d5 read value
    csrr x14, 0x4d5

    #Address 0x4d5 read value
    csrr x14, 0x4d5

    #Unmapped address 0x141 testing: random write/read operations
    #Address 0x141 Write value 0x1e72b114
    li x3, 0x1e72b114
    csrw 0x141, x3

    #Address 0x141 read value
    csrr x14, 0x141

    #Address 0x141 read value
    csrr x14, 0x141

    #Address 0x141 read value
    csrr x14, 0x141

    #Address 0x141 Write value 0x9a41fabd
    li x3, 0x9a41fabd
    csrw 0x141, x3

    #Unmapped address 0x8c4 testing: random write/read operations
    #Address 0x8c4 read value
    csrr x14, 0x8c4

    #Address 0x8c4 read value
    csrr x14, 0x8c4

    #Unmapped address 0xbd5 testing: random write/read operations
    #Address 0xbd5 read value
    csrr x14, 0xbd5

    #Unmapped address 0x64f testing: random write/read operations
    #Address 0x64f read value
    csrr x14, 0x64f

    #Address 0x64f read value
    csrr x14, 0x64f

    #Address 0x64f Write value 0x71e4c585
    li x3, 0x71e4c585
    csrw 0x64f, x3

    #Address 0x64f Write value 0xdf10d6ca
    li x3, 0xdf10d6ca
    csrw 0x64f, x3

    #Address 0x64f read value
    csrr x14, 0x64f

    #Unmapped address 0xd6e testing: random write/read operations
    #Address 0xd6e Write value 0x7ef9d482
    li x3, 0x7ef9d482
    csrw 0xd6e, x3

    #Unmapped address 0x3ea testing: random write/read operations
    #Address 0x3ea read value
    csrr x14, 0x3ea

    #Address 0x3ea read value
    csrr x14, 0x3ea

    #Address 0x3ea read value
    csrr x14, 0x3ea

    #Address 0x3ea Write value 0x4380027b
    li x3, 0x4380027b
    csrw 0x3ea, x3

    #Unmapped address 0x4d4 testing: random write/read operations
    #Address 0x4d4 read value
    csrr x14, 0x4d4

    #Unmapped address 0xfc1 testing: random write/read operations
    #Address 0xfc1 read value
    csrr x14, 0xfc1

    #Address 0xfc1 read value
    csrr x14, 0xfc1

    #Unmapped address 0x8fd testing: random write/read operations
    #Address 0x8fd Write value 0xc7c9f6b3
    li x3, 0xc7c9f6b3
    csrw 0x8fd, x3

    #Address 0x8fd Write value 0x7cd49f31
    li x3, 0x7cd49f31
    csrw 0x8fd, x3

    #Unmapped address 0x368 testing: random write/read operations
    #Address 0x368 read value
    csrr x14, 0x368

    #Address 0x368 read value
    csrr x14, 0x368

    #Address 0x368 Write value 0xb4a36365
    li x3, 0xb4a36365
    csrw 0x368, x3

    #Address 0x368 Write value 0x299f875e
    li x3, 0x299f875e
    csrw 0x368, x3

    #Address 0x368 read value
    csrr x14, 0x368

    #Unmapped address 0xfe7 testing: random write/read operations
    #Address 0xfe7 Write value 0x8357c58a
    li x3, 0x8357c58a
    csrw 0xfe7, x3

    #Unmapped address 0x3c1 testing: random write/read operations
    #Address 0x3c1 read value
    csrr x14, 0x3c1

    #Address 0x3c1 read value
    csrr x14, 0x3c1

    #Address 0x3c1 Write value 0x4036131
    li x3, 0x4036131
    csrw 0x3c1, x3

    #Address 0x3c1 read value
    csrr x14, 0x3c1

    #Unmapped address 0x6ff testing: random write/read operations
    #Address 0x6ff read value
    csrr x14, 0x6ff

    #Address 0x6ff read value
    csrr x14, 0x6ff

    #Address 0x6ff Write value 0x566bd702
    li x3, 0x566bd702
    csrw 0x6ff, x3

    #Address 0x6ff Write value 0x3a802b6f
    li x3, 0x3a802b6f
    csrw 0x6ff, x3

    #Unmapped address 0x91e testing: random write/read operations
    #Address 0x91e read value
    csrr x14, 0x91e

    #Address 0x91e Write value 0xb9c7389b
    li x3, 0xb9c7389b
    csrw 0x91e, x3

    #Address 0x91e read value
    csrr x14, 0x91e

    #Unmapped address 0x5ae testing: random write/read operations
    #Address 0x5ae read value
    csrr x14, 0x5ae

    #Address 0x5ae read value
    csrr x14, 0x5ae

    #Address 0x5ae read value
    csrr x14, 0x5ae

    #Unmapped address 0x9b8 testing: random write/read operations
    #Address 0x9b8 read value
    csrr x14, 0x9b8

    #Address 0x9b8 read value
    csrr x14, 0x9b8

    #Address 0x9b8 Write value 0x9b86d8c2
    li x3, 0x9b86d8c2
    csrw 0x9b8, x3

    #Unmapped address 0x550 testing: random write/read operations
    #Address 0x550 Write value 0x2d79203a
    li x3, 0x2d79203a
    csrw 0x550, x3

    #Address 0x550 Write value 0x255ceece
    li x3, 0x255ceece
    csrw 0x550, x3

    #Address 0x550 read value
    csrr x14, 0x550

    #Address 0x550 read value
    csrr x14, 0x550

    #Address 0x550 Write value 0x56bb3fc8
    li x3, 0x56bb3fc8
    csrw 0x550, x3

    #Unmapped address 0x110 testing: random write/read operations
    #Address 0x110 read value
    csrr x14, 0x110

    #Address 0x110 read value
    csrr x14, 0x110

    #Address 0x110 Write value 0xcfde7f50
    li x3, 0xcfde7f50
    csrw 0x110, x3

    #Address 0x110 Write value 0xcd147ca
    li x3, 0xcd147ca
    csrw 0x110, x3

    #Unmapped address 0x20c testing: random write/read operations
    #Address 0x20c read value
    csrr x14, 0x20c

    #Unmapped address 0x494 testing: random write/read operations
    #Address 0x494 Write value 0xbd1490d1
    li x3, 0xbd1490d1
    csrw 0x494, x3

    #Address 0x494 Write value 0x5f31e910
    li x3, 0x5f31e910
    csrw 0x494, x3

    #Address 0x494 read value
    csrr x14, 0x494

    #Address 0x494 read value
    csrr x14, 0x494

    #Address 0x494 Write value 0x5cdf10b6
    li x3, 0x5cdf10b6
    csrw 0x494, x3

    #Unmapped address 0xf2f testing: random write/read operations
    #Address 0xf2f Write value 0x3632a6b7
    li x3, 0x3632a6b7
    csrw 0xf2f, x3

    #Address 0xf2f read value
    csrr x14, 0xf2f

    #Unmapped address 0xa17 testing: random write/read operations
    #Address 0xa17 Write value 0x6d114ff1
    li x3, 0x6d114ff1
    csrw 0xa17, x3

    #Address 0xa17 read value
    csrr x14, 0xa17

    #Address 0xa17 read value
    csrr x14, 0xa17

    #Unmapped address 0x9ba testing: random write/read operations
    #Address 0x9ba read value
    csrr x14, 0x9ba

    #Unmapped address 0x1ab testing: random write/read operations
    #Address 0x1ab read value
    csrr x14, 0x1ab

    #Address 0x1ab read value
    csrr x14, 0x1ab

    #Address 0x1ab Write value 0x131ba962
    li x3, 0x131ba962
    csrw 0x1ab, x3

    #Address 0x1ab Write value 0x892e2969
    li x3, 0x892e2969
    csrw 0x1ab, x3

    #Unmapped address 0xdd9 testing: random write/read operations
    #Address 0xdd9 Write value 0x4a285e60
    li x3, 0x4a285e60
    csrw 0xdd9, x3

    #Address 0xdd9 read value
    csrr x14, 0xdd9

    #Address 0xdd9 read value
    csrr x14, 0xdd9

    #Unmapped address 0xa0 testing: random write/read operations
    #Address 0xa0 read value
    csrr x14, 0xa0

    #Unmapped address 0xded testing: random write/read operations
    #Address 0xded Write value 0xa8f90c
    li x3, 0xa8f90c
    csrw 0xded, x3

    #Address 0xded Write value 0x731fa967
    li x3, 0x731fa967
    csrw 0xded, x3

    #Address 0xded Write value 0x95f22e3
    li x3, 0x95f22e3
    csrw 0xded, x3

    #Unmapped address 0x86c testing: random write/read operations
    #Address 0x86c read value
    csrr x14, 0x86c

    #Address 0x86c read value
    csrr x14, 0x86c

    #Unmapped address 0x1df testing: random write/read operations
    #Address 0x1df Write value 0xfe914069
    li x3, 0xfe914069
    csrw 0x1df, x3

    #Address 0x1df Write value 0xa5159fc5
    li x3, 0xa5159fc5
    csrw 0x1df, x3

    #Address 0x1df Write value 0xfbb1279b
    li x3, 0xfbb1279b
    csrw 0x1df, x3

    #Address 0x1df Write value 0xe02fb463
    li x3, 0xe02fb463
    csrw 0x1df, x3

    #Address 0x1df read value
    csrr x14, 0x1df

    #Unmapped address 0x949 testing: random write/read operations
    #Address 0x949 read value
    csrr x14, 0x949

    #Address 0x949 Write value 0x35fde96f
    li x3, 0x35fde96f
    csrw 0x949, x3

    #Address 0x949 Write value 0x12408036
    li x3, 0x12408036
    csrw 0x949, x3

    #Address 0x949 read value
    csrr x14, 0x949

    #Unmapped address 0x8f1 testing: random write/read operations
    #Address 0x8f1 Write value 0x75123b04
    li x3, 0x75123b04
    csrw 0x8f1, x3

    #Address 0x8f1 read value
    csrr x14, 0x8f1

    #Address 0x8f1 read value
    csrr x14, 0x8f1

    #Address 0x8f1 read value
    csrr x14, 0x8f1

    #Unmapped address 0x90d testing: random write/read operations
    #Address 0x90d read value
    csrr x14, 0x90d

    #Address 0x90d read value
    csrr x14, 0x90d

    #Unmapped address 0x3f0 testing: random write/read operations
    #Address 0x3f0 read value
    csrr x14, 0x3f0

    #Address 0x3f0 read value
    csrr x14, 0x3f0

    #Address 0x3f0 Write value 0x2a1f538c
    li x3, 0x2a1f538c
    csrw 0x3f0, x3

    #Unmapped address 0x34f testing: random write/read operations
    #Address 0x34f read value
    csrr x14, 0x34f

    #Address 0x34f Write value 0x9e35b7df
    li x3, 0x9e35b7df
    csrw 0x34f, x3

    #Unmapped address 0xa9 testing: random write/read operations
    #Address 0xa9 read value
    csrr x14, 0xa9

    #Address 0xa9 Write value 0x50487d1e
    li x3, 0x50487d1e
    csrw 0xa9, x3

    #Address 0xa9 Write value 0x90f2fc02
    li x3, 0x90f2fc02
    csrw 0xa9, x3

    #Address 0xa9 Write value 0xb408c3bf
    li x3, 0xb408c3bf
    csrw 0xa9, x3

    #Address 0xa9 read value
    csrr x14, 0xa9

    #Unmapped address 0x90f testing: random write/read operations
    #Address 0x90f read value
    csrr x14, 0x90f

    #Address 0x90f read value
    csrr x14, 0x90f

    #Address 0x90f Write value 0xa0f89abf
    li x3, 0xa0f89abf
    csrw 0x90f, x3

    #Address 0x90f read value
    csrr x14, 0x90f

    #Unmapped address 0x70c testing: random write/read operations
    #Address 0x70c Write value 0x858fc08e
    li x3, 0x858fc08e
    csrw 0x70c, x3

    #Address 0x70c Write value 0x5fbcef07
    li x3, 0x5fbcef07
    csrw 0x70c, x3

    #Address 0x70c read value
    csrr x14, 0x70c

    #Unmapped address 0xc32 testing: random write/read operations
    #Address 0xc32 Write value 0xa1cc710b
    li x3, 0xa1cc710b
    csrw 0xc32, x3

    #Address 0xc32 read value
    csrr x14, 0xc32

    #Address 0xc32 read value
    csrr x14, 0xc32

    #Unmapped address 0xf0e testing: random write/read operations
    #Address 0xf0e read value
    csrr x14, 0xf0e

    #Address 0xf0e read value
    csrr x14, 0xf0e

    #Unmapped address 0x118 testing: random write/read operations
    #Address 0x118 Write value 0xaa691f4b
    li x3, 0xaa691f4b
    csrw 0x118, x3

    #Unmapped address 0xc6a testing: random write/read operations
    #Address 0xc6a Write value 0xc9aacb17
    li x3, 0xc9aacb17
    csrw 0xc6a, x3

    #Address 0xc6a read value
    csrr x14, 0xc6a

    #Address 0xc6a Write value 0xaad2bae4
    li x3, 0xaad2bae4
    csrw 0xc6a, x3

    #Unmapped address 0x5da testing: random write/read operations
    #Address 0x5da read value
    csrr x14, 0x5da

    #Address 0x5da read value
    csrr x14, 0x5da

    #Address 0x5da read value
    csrr x14, 0x5da

    #Address 0x5da Write value 0x4da0f8ab
    li x3, 0x4da0f8ab
    csrw 0x5da, x3

    #Unmapped address 0x7f3 testing: random write/read operations
    #Address 0x7f3 Write value 0xef4cd46a
    li x3, 0xef4cd46a
    csrw 0x7f3, x3

    #Address 0x7f3 read value
    csrr x14, 0x7f3

    #Unmapped address 0xca5 testing: random write/read operations
    #Address 0xca5 Write value 0xc06b7819
    li x3, 0xc06b7819
    csrw 0xca5, x3

    #Address 0xca5 Write value 0xf14077c4
    li x3, 0xf14077c4
    csrw 0xca5, x3

    #Unmapped address 0xc83 testing: random write/read operations
    #Address 0xc83 Write value 0xcf851837
    li x3, 0xcf851837
    csrw 0xc83, x3

    #Address 0xc83 Write value 0x8f06da4e
    li x3, 0x8f06da4e
    csrw 0xc83, x3

    #Address 0xc83 read value
    csrr x14, 0xc83

    #Address 0xc83 Write value 0x1feebfcd
    li x3, 0x1feebfcd
    csrw 0xc83, x3

    #Address 0xc83 Write value 0x9c5e39b7
    li x3, 0x9c5e39b7
    csrw 0xc83, x3

    #Unmapped address 0x9b9 testing: random write/read operations
    #Address 0x9b9 read value
    csrr x14, 0x9b9

    #Address 0x9b9 Write value 0xe7fec5d8
    li x3, 0xe7fec5d8
    csrw 0x9b9, x3

    #Address 0x9b9 Write value 0x85d7ca8
    li x3, 0x85d7ca8
    csrw 0x9b9, x3

    #Unmapped address 0x899 testing: random write/read operations
    #Address 0x899 Write value 0x46e118fc
    li x3, 0x46e118fc
    csrw 0x899, x3

    #Address 0x899 read value
    csrr x14, 0x899

    #Unmapped address 0x552 testing: random write/read operations
    #Address 0x552 read value
    csrr x14, 0x552

    #Address 0x552 Write value 0xade381e1
    li x3, 0xade381e1
    csrw 0x552, x3

    #Address 0x552 Write value 0xc7bd7e55
    li x3, 0xc7bd7e55
    csrw 0x552, x3

    #Unmapped address 0xc2b testing: random write/read operations
    #Address 0xc2b read value
    csrr x14, 0xc2b

    #Unmapped address 0x1de testing: random write/read operations
    #Address 0x1de read value
    csrr x14, 0x1de

    #Unmapped address 0xdd8 testing: random write/read operations
    #Address 0xdd8 Write value 0xa4f6f4e6
    li x3, 0xa4f6f4e6
    csrw 0xdd8, x3

    #Address 0xdd8 Write value 0x86c05f0
    li x3, 0x86c05f0
    csrw 0xdd8, x3

    #Address 0xdd8 read value
    csrr x14, 0xdd8

    #Address 0xdd8 Write value 0x42282981
    li x3, 0x42282981
    csrw 0xdd8, x3

    #Address 0xdd8 Write value 0xd0bf0602
    li x3, 0xd0bf0602
    csrw 0xdd8, x3

    #Unmapped address 0x471 testing: random write/read operations
    #Address 0x471 read value
    csrr x14, 0x471

    #Address 0x471 Write value 0xaeb3d03
    li x3, 0xaeb3d03
    csrw 0x471, x3

    #Unmapped address 0x3ec testing: random write/read operations
    #Address 0x3ec read value
    csrr x14, 0x3ec

    #Address 0x3ec read value
    csrr x14, 0x3ec

    #Address 0x3ec Write value 0xdc508a20
    li x3, 0xdc508a20
    csrw 0x3ec, x3

    #Address 0x3ec read value
    csrr x14, 0x3ec

    #Unmapped address 0x566 testing: random write/read operations
    #Address 0x566 Write value 0xedc2b644
    li x3, 0xedc2b644
    csrw 0x566, x3

    #Address 0x566 read value
    csrr x14, 0x566

    #Address 0x566 read value
    csrr x14, 0x566

    #Address 0x566 Write value 0x2f1fc3ef
    li x3, 0x2f1fc3ef
    csrw 0x566, x3

    #Unmapped address 0xd5d testing: random write/read operations
    #Address 0xd5d Write value 0xfe21833c
    li x3, 0xfe21833c
    csrw 0xd5d, x3

    #Address 0xd5d read value
    csrr x14, 0xd5d

    #Address 0xd5d read value
    csrr x14, 0xd5d

    #Address 0xd5d read value
    csrr x14, 0xd5d

    #Unmapped address 0x960 testing: random write/read operations
    #Address 0x960 read value
    csrr x14, 0x960

    #Address 0x960 read value
    csrr x14, 0x960

    #Unmapped address 0xea1 testing: random write/read operations
    #Address 0xea1 read value
    csrr x14, 0xea1

    #Address 0xea1 Write value 0x88893c5b
    li x3, 0x88893c5b
    csrw 0xea1, x3

    #Address 0xea1 read value
    csrr x14, 0xea1

    #Unmapped address 0xbc5 testing: random write/read operations
    #Address 0xbc5 Write value 0x9d5041d1
    li x3, 0x9d5041d1
    csrw 0xbc5, x3

    #Address 0xbc5 Write value 0x8a868976
    li x3, 0x8a868976
    csrw 0xbc5, x3

    #Address 0xbc5 Write value 0xf0eb6eed
    li x3, 0xf0eb6eed
    csrw 0xbc5, x3

    #Address 0xbc5 read value
    csrr x14, 0xbc5

    #Unmapped address 0x833 testing: random write/read operations
    #Address 0x833 Write value 0x8aacbd88
    li x3, 0x8aacbd88
    csrw 0x833, x3

    #Address 0x833 read value
    csrr x14, 0x833

    #Address 0x833 read value
    csrr x14, 0x833

    #Address 0x833 read value
    csrr x14, 0x833

    #Address 0x833 Write value 0x5f2bb98f
    li x3, 0x5f2bb98f
    csrw 0x833, x3

    #Unmapped address 0x2e9 testing: random write/read operations
    #Address 0x2e9 Write value 0xe76e4887
    li x3, 0xe76e4887
    csrw 0x2e9, x3

    #Address 0x2e9 Write value 0xce39cece
    li x3, 0xce39cece
    csrw 0x2e9, x3

    #Address 0x2e9 Write value 0x8fe2cd0a
    li x3, 0x8fe2cd0a
    csrw 0x2e9, x3

    #Address 0x2e9 Write value 0x4a3f053f
    li x3, 0x4a3f053f
    csrw 0x2e9, x3

    #Unmapped address 0x969 testing: random write/read operations
    #Address 0x969 Write value 0xa42cfe08
    li x3, 0xa42cfe08
    csrw 0x969, x3

    #Address 0x969 read value
    csrr x14, 0x969

    #Address 0x969 Write value 0xf86d8215
    li x3, 0xf86d8215
    csrw 0x969, x3

    #Address 0x969 Write value 0xbead846d
    li x3, 0xbead846d
    csrw 0x969, x3

    #Unmapped address 0x34 testing: random write/read operations
    #Address 0x34 read value
    csrr x14, 0x34

    #Address 0x34 Write value 0x9d397aee
    li x3, 0x9d397aee
    csrw 0x34, x3

    #Address 0x34 Write value 0xb5c88098
    li x3, 0xb5c88098
    csrw 0x34, x3

    #Address 0x34 Write value 0x129caea4
    li x3, 0x129caea4
    csrw 0x34, x3

    #Address 0x34 read value
    csrr x14, 0x34

    #Unmapped address 0x272 testing: random write/read operations
    #Address 0x272 read value
    csrr x14, 0x272

    #Address 0x272 read value
    csrr x14, 0x272

    #Address 0x272 read value
    csrr x14, 0x272

    #Address 0x272 read value
    csrr x14, 0x272

    #Unmapped address 0x830 testing: random write/read operations
    #Address 0x830 read value
    csrr x14, 0x830

    #Address 0x830 Write value 0x401cb2c1
    li x3, 0x401cb2c1
    csrw 0x830, x3

    #Address 0x830 read value
    csrr x14, 0x830

    #Address 0x830 Write value 0x396b6bfc
    li x3, 0x396b6bfc
    csrw 0x830, x3

    #Address 0x830 Write value 0xddeaf39d
    li x3, 0xddeaf39d
    csrw 0x830, x3

    #Unmapped address 0x728 testing: random write/read operations
    #Address 0x728 read value
    csrr x14, 0x728

    #Address 0x728 read value
    csrr x14, 0x728

    #Unmapped address 0x65d testing: random write/read operations
    #Address 0x65d read value
    csrr x14, 0x65d

    #Address 0x65d Write value 0xd628f962
    li x3, 0xd628f962
    csrw 0x65d, x3

    #Unmapped address 0x3e0 testing: random write/read operations
    #Address 0x3e0 read value
    csrr x14, 0x3e0

    #Unmapped address 0xcb testing: random write/read operations
    #Address 0xcb read value
    csrr x14, 0xcb

    #Address 0xcb read value
    csrr x14, 0xcb

    #Address 0xcb read value
    csrr x14, 0xcb

    #Unmapped address 0xbe1 testing: random write/read operations
    #Address 0xbe1 read value
    csrr x14, 0xbe1

    #Address 0xbe1 read value
    csrr x14, 0xbe1

    #Address 0xbe1 Write value 0x8e1c85f7
    li x3, 0x8e1c85f7
    csrw 0xbe1, x3

    #Address 0xbe1 read value
    csrr x14, 0xbe1

    #Address 0xbe1 read value
    csrr x14, 0xbe1

    #Unmapped address 0xc79 testing: random write/read operations
    #Address 0xc79 read value
    csrr x14, 0xc79

    #Address 0xc79 Write value 0x176c7ee0
    li x3, 0x176c7ee0
    csrw 0xc79, x3

    #Address 0xc79 read value
    csrr x14, 0xc79

    #Address 0xc79 Write value 0x844aaf87
    li x3, 0x844aaf87
    csrw 0xc79, x3

    #Address 0xc79 read value
    csrr x14, 0xc79

    #Unmapped address 0xe28 testing: random write/read operations
    #Address 0xe28 read value
    csrr x14, 0xe28

    #Address 0xe28 read value
    csrr x14, 0xe28

    #Address 0xe28 Write value 0xacbc2bd0
    li x3, 0xacbc2bd0
    csrw 0xe28, x3

    #Unmapped address 0xdee testing: random write/read operations
    #Address 0xdee read value
    csrr x14, 0xdee

    #Unmapped address 0x50a testing: random write/read operations
    #Address 0x50a read value
    csrr x14, 0x50a

    #Address 0x50a Write value 0x7385cbe4
    li x3, 0x7385cbe4
    csrw 0x50a, x3

    #Address 0x50a Write value 0x6274739f
    li x3, 0x6274739f
    csrw 0x50a, x3

    #Address 0x50a read value
    csrr x14, 0x50a

    #Unmapped address 0x8d8 testing: random write/read operations
    #Address 0x8d8 Write value 0xcb49d9bd
    li x3, 0xcb49d9bd
    csrw 0x8d8, x3

    #Unmapped address 0xdbc testing: random write/read operations
    #Address 0xdbc read value
    csrr x14, 0xdbc

    #Address 0xdbc read value
    csrr x14, 0xdbc

    #Unmapped address 0xa7f testing: random write/read operations
    #Address 0xa7f Write value 0xbc0e5f21
    li x3, 0xbc0e5f21
    csrw 0xa7f, x3

    #Address 0xa7f read value
    csrr x14, 0xa7f

    #Unmapped address 0xc4 testing: random write/read operations
    #Address 0xc4 Write value 0x1e65b7c2
    li x3, 0x1e65b7c2
    csrw 0xc4, x3

    #Address 0xc4 Write value 0x7adde678
    li x3, 0x7adde678
    csrw 0xc4, x3

    #Address 0xc4 Write value 0xa6e9b982
    li x3, 0xa6e9b982
    csrw 0xc4, x3

    #Address 0xc4 Write value 0xaccc6451
    li x3, 0xaccc6451
    csrw 0xc4, x3

    #Unmapped address 0xb1 testing: random write/read operations
    #Address 0xb1 read value
    csrr x14, 0xb1

    #Address 0xb1 Write value 0x7093d42f
    li x3, 0x7093d42f
    csrw 0xb1, x3

    #Address 0xb1 read value
    csrr x14, 0xb1

    #Address 0xb1 read value
    csrr x14, 0xb1

    #Address 0xb1 Write value 0x6b879cd2
    li x3, 0x6b879cd2
    csrw 0xb1, x3

    #Unmapped address 0xb39 testing: random write/read operations
    #Address 0xb39 read value
    csrr x14, 0xb39

    #Address 0xb39 Write value 0xb88d6877
    li x3, 0xb88d6877
    csrw 0xb39, x3

    #Address 0xb39 read value
    csrr x14, 0xb39

    #Address 0xb39 read value
    csrr x14, 0xb39

    #Unmapped address 0x489 testing: random write/read operations
    #Address 0x489 Write value 0xda64657b
    li x3, 0xda64657b
    csrw 0x489, x3

    #Address 0x489 Write value 0xdfd8ce5b
    li x3, 0xdfd8ce5b
    csrw 0x489, x3

    #Address 0x489 read value
    csrr x14, 0x489

    #Unmapped address 0xff6 testing: random write/read operations
    #Address 0xff6 Write value 0x3e2bcdb0
    li x3, 0x3e2bcdb0
    csrw 0xff6, x3

    #Address 0xff6 read value
    csrr x14, 0xff6

    #Address 0xff6 Write value 0x97c198a6
    li x3, 0x97c198a6
    csrw 0xff6, x3

    #Address 0xff6 Write value 0x2846155d
    li x3, 0x2846155d
    csrw 0xff6, x3

    #Unmapped address 0x4ad testing: random write/read operations
    #Address 0x4ad Write value 0xa36228eb
    li x3, 0xa36228eb
    csrw 0x4ad, x3

    #Address 0x4ad read value
    csrr x14, 0x4ad

    #Address 0x4ad Write value 0xd747f15b
    li x3, 0xd747f15b
    csrw 0x4ad, x3

    #Address 0x4ad Write value 0xa95c4731
    li x3, 0xa95c4731
    csrw 0x4ad, x3

    #Address 0x4ad Write value 0xd188b804
    li x3, 0xd188b804
    csrw 0x4ad, x3

    #Unmapped address 0x67a testing: random write/read operations
    #Address 0x67a Write value 0x97fcc5b9
    li x3, 0x97fcc5b9
    csrw 0x67a, x3

    #Unmapped address 0x701 testing: random write/read operations
    #Address 0x701 read value
    csrr x14, 0x701

    #Address 0x701 Write value 0xc97e1e6c
    li x3, 0xc97e1e6c
    csrw 0x701, x3

    #Address 0x701 read value
    csrr x14, 0x701

    #Unmapped address 0x943 testing: random write/read operations
    #Address 0x943 Write value 0xe5aab69d
    li x3, 0xe5aab69d
    csrw 0x943, x3

    #Unmapped address 0x4c0 testing: random write/read operations
    #Address 0x4c0 Write value 0xf47e2353
    li x3, 0xf47e2353
    csrw 0x4c0, x3

    #Unmapped address 0x127 testing: random write/read operations
    #Address 0x127 read value
    csrr x14, 0x127

    #Address 0x127 read value
    csrr x14, 0x127

    #Unmapped address 0xf97 testing: random write/read operations
    #Address 0xf97 Write value 0x18179012
    li x3, 0x18179012
    csrw 0xf97, x3

    #Unmapped address 0xdb1 testing: random write/read operations
    #Address 0xdb1 Write value 0xfe274ead
    li x3, 0xfe274ead
    csrw 0xdb1, x3

    #Address 0xdb1 read value
    csrr x14, 0xdb1

    #Address 0xdb1 Write value 0xa8d28c40
    li x3, 0xa8d28c40
    csrw 0xdb1, x3

    #Address 0xdb1 read value
    csrr x14, 0xdb1

    #Unmapped address 0x219 testing: random write/read operations
    #Address 0x219 read value
    csrr x14, 0x219

    #Unmapped address 0xaca testing: random write/read operations
    #Address 0xaca read value
    csrr x14, 0xaca

    #Address 0xaca read value
    csrr x14, 0xaca

    #Address 0xaca read value
    csrr x14, 0xaca

    #Address 0xaca Write value 0xae206d2b
    li x3, 0xae206d2b
    csrw 0xaca, x3

    #Address 0xaca Write value 0xdeafafc8
    li x3, 0xdeafafc8
    csrw 0xaca, x3

    #Unmapped address 0x6ed testing: random write/read operations
    #Address 0x6ed Write value 0xf4e8d5ce
    li x3, 0xf4e8d5ce
    csrw 0x6ed, x3

    #Unmapped address 0x957 testing: random write/read operations
    #Address 0x957 read value
    csrr x14, 0x957

    #Unmapped address 0xc8b testing: random write/read operations
    #Address 0xc8b read value
    csrr x14, 0xc8b

    #Address 0xc8b Write value 0x9500a0da
    li x3, 0x9500a0da
    csrw 0xc8b, x3

    #Address 0xc8b Write value 0x66eaa861
    li x3, 0x66eaa861
    csrw 0xc8b, x3

    #Address 0xc8b Write value 0x2a9706c3
    li x3, 0x2a9706c3
    csrw 0xc8b, x3

    #Unmapped address 0xdce testing: random write/read operations
    #Address 0xdce Write value 0xc2fd751c
    li x3, 0xc2fd751c
    csrw 0xdce, x3

    #Address 0xdce Write value 0xaf0b0d0e
    li x3, 0xaf0b0d0e
    csrw 0xdce, x3

    #Unmapped address 0x131 testing: random write/read operations
    #Address 0x131 Write value 0x9a5a9df9
    li x3, 0x9a5a9df9
    csrw 0x131, x3

    #Address 0x131 Write value 0x1cd41049
    li x3, 0x1cd41049
    csrw 0x131, x3

    #Address 0x131 read value
    csrr x14, 0x131

    #Address 0x131 read value
    csrr x14, 0x131

    #Unmapped address 0xf56 testing: random write/read operations
    #Address 0xf56 Write value 0xa21a97e6
    li x3, 0xa21a97e6
    csrw 0xf56, x3

    #Address 0xf56 Write value 0x9628ba42
    li x3, 0x9628ba42
    csrw 0xf56, x3

    #Address 0xf56 Write value 0x3b46f3d4
    li x3, 0x3b46f3d4
    csrw 0xf56, x3

    #Unmapped address 0xa8f testing: random write/read operations
    #Address 0xa8f Write value 0xe541b752
    li x3, 0xe541b752
    csrw 0xa8f, x3

    #Address 0xa8f read value
    csrr x14, 0xa8f

    #Unmapped address 0xb35 testing: random write/read operations
    #Address 0xb35 Write value 0x52e24c1d
    li x3, 0x52e24c1d
    csrw 0xb35, x3

    #Address 0xb35 read value
    csrr x14, 0xb35

    #Address 0xb35 Write value 0x8a86905
    li x3, 0x8a86905
    csrw 0xb35, x3

    #Address 0xb35 read value
    csrr x14, 0xb35

    #Unmapped address 0x7d9 testing: random write/read operations
    #Address 0x7d9 read value
    csrr x14, 0x7d9

    #Address 0x7d9 Write value 0x6397e6f1
    li x3, 0x6397e6f1
    csrw 0x7d9, x3

    #Address 0x7d9 read value
    csrr x14, 0x7d9

    #Unmapped address 0x395 testing: random write/read operations
    #Address 0x395 Write value 0x7984cd3e
    li x3, 0x7984cd3e
    csrw 0x395, x3

    #Address 0x395 Write value 0x969fe889
    li x3, 0x969fe889
    csrw 0x395, x3

    #Address 0x395 Write value 0x60051dc1
    li x3, 0x60051dc1
    csrw 0x395, x3

    #Address 0x395 Write value 0x65c24fd2
    li x3, 0x65c24fd2
    csrw 0x395, x3

    #Unmapped address 0x468 testing: random write/read operations
    #Address 0x468 Write value 0x6d6c6909
    li x3, 0x6d6c6909
    csrw 0x468, x3

    #Unmapped address 0x289 testing: random write/read operations
    #Address 0x289 Write value 0x7f3c90cd
    li x3, 0x7f3c90cd
    csrw 0x289, x3

    #Address 0x289 read value
    csrr x14, 0x289

    #Mapped address 0x3a0 (pmpcfg0) testing: random write/read operations
    #Address 0x3a0 read value
    csrr x14, 0x3a0

    #Address 0x3a0 read value
    csrr x14, 0x3a0

    #Address 0x3a0 read value
    csrr x14, 0x3a0

    #Unmapped address 0x5d0 testing: random write/read operations
    #Address 0x5d0 Write value 0x3d0d3ce9
    li x3, 0x3d0d3ce9
    csrw 0x5d0, x3

    #Address 0x5d0 read value
    csrr x14, 0x5d0

    #Address 0x5d0 read value
    csrr x14, 0x5d0

    #Address 0x5d0 Write value 0x547b5a7c
    li x3, 0x547b5a7c
    csrw 0x5d0, x3

    #Address 0x5d0 read value
    csrr x14, 0x5d0

    #Unmapped address 0x163 testing: random write/read operations
    #Address 0x163 Write value 0x9843e9a9
    li x3, 0x9843e9a9
    csrw 0x163, x3

    #Address 0x163 Write value 0xfc7bfd05
    li x3, 0xfc7bfd05
    csrw 0x163, x3

    #Address 0x163 Write value 0xde8d2c0
    li x3, 0xde8d2c0
    csrw 0x163, x3

    #Address 0x163 read value
    csrr x14, 0x163

    #Address 0x163 Write value 0x6552ec6
    li x3, 0x6552ec6
    csrw 0x163, x3

    #Unmapped address 0x9c testing: random write/read operations
    #Address 0x9c read value
    csrr x14, 0x9c

    #Address 0x9c Write value 0x71db29cd
    li x3, 0x71db29cd
    csrw 0x9c, x3

    #Address 0x9c Write value 0x99c2966b
    li x3, 0x99c2966b
    csrw 0x9c, x3

    #Address 0x9c Write value 0xe962dd45
    li x3, 0xe962dd45
    csrw 0x9c, x3

    #Address 0x9c read value
    csrr x14, 0x9c

    #Unmapped address 0xcc4 testing: random write/read operations
    #Address 0xcc4 read value
    csrr x14, 0xcc4

    #Address 0xcc4 Write value 0xca097171
    li x3, 0xca097171
    csrw 0xcc4, x3

    #Address 0xcc4 read value
    csrr x14, 0xcc4

    #Address 0xcc4 read value
    csrr x14, 0xcc4

    #Address 0xcc4 read value
    csrr x14, 0xcc4

    #Unmapped address 0x1aa testing: random write/read operations
    #Address 0x1aa Write value 0x85109dda
    li x3, 0x85109dda
    csrw 0x1aa, x3

    #Address 0x1aa read value
    csrr x14, 0x1aa

    #Address 0x1aa read value
    csrr x14, 0x1aa

    #Address 0x1aa Write value 0xab193254
    li x3, 0xab193254
    csrw 0x1aa, x3

    #Unmapped address 0xaaf testing: random write/read operations
    #Address 0xaaf read value
    csrr x14, 0xaaf

    #Address 0xaaf read value
    csrr x14, 0xaaf

    #Unmapped address 0xae6 testing: random write/read operations
    #Address 0xae6 read value
    csrr x14, 0xae6

    #Address 0xae6 Write value 0xa2515c8a
    li x3, 0xa2515c8a
    csrw 0xae6, x3

    #Address 0xae6 Write value 0x51f12bfe
    li x3, 0x51f12bfe
    csrw 0xae6, x3

    #Address 0xae6 Write value 0x242e4338
    li x3, 0x242e4338
    csrw 0xae6, x3

    #Address 0xae6 Write value 0xaef398cb
    li x3, 0xaef398cb
    csrw 0xae6, x3

    #Unmapped address 0x68a testing: random write/read operations
    #Address 0x68a read value
    csrr x14, 0x68a

    #Address 0x68a Write value 0x22df3aca
    li x3, 0x22df3aca
    csrw 0x68a, x3

    #Address 0x68a read value
    csrr x14, 0x68a

    #Address 0x68a Write value 0x8ec027a8
    li x3, 0x8ec027a8
    csrw 0x68a, x3

    #Unmapped address 0x495 testing: random write/read operations
    #Address 0x495 read value
    csrr x14, 0x495

    #Address 0x495 read value
    csrr x14, 0x495

    #Address 0x495 read value
    csrr x14, 0x495

    #Unmapped address 0xeb testing: random write/read operations
    #Address 0xeb read value
    csrr x14, 0xeb

    #Address 0xeb Write value 0x8b6ffec5
    li x3, 0x8b6ffec5
    csrw 0xeb, x3

    #Address 0xeb read value
    csrr x14, 0xeb

    #Address 0xeb Write value 0x102ceb66
    li x3, 0x102ceb66
    csrw 0xeb, x3

    #Unmapped address 0x192 testing: random write/read operations
    #Address 0x192 read value
    csrr x14, 0x192

    #Address 0x192 Write value 0xac94eb0f
    li x3, 0xac94eb0f
    csrw 0x192, x3

    #Unmapped address 0xd96 testing: random write/read operations
    #Address 0xd96 Write value 0xe2282b93
    li x3, 0xe2282b93
    csrw 0xd96, x3

    #Address 0xd96 read value
    csrr x14, 0xd96

    #Address 0xd96 Write value 0x486569bc
    li x3, 0x486569bc
    csrw 0xd96, x3

    #Address 0xd96 read value
    csrr x14, 0xd96

    #Address 0xd96 read value
    csrr x14, 0xd96

    #Unmapped address 0x928 testing: random write/read operations
    #Address 0x928 read value
    csrr x14, 0x928

    #Address 0x928 read value
    csrr x14, 0x928

    #Address 0x928 read value
    csrr x14, 0x928

    #Unmapped address 0x51a testing: random write/read operations
    #Address 0x51a read value
    csrr x14, 0x51a

    #Unmapped address 0x34b testing: random write/read operations
    #Address 0x34b Write value 0xfc8d27ba
    li x3, 0xfc8d27ba
    csrw 0x34b, x3

    #Unmapped address 0x806 testing: random write/read operations
    #Address 0x806 Write value 0x291ee67f
    li x3, 0x291ee67f
    csrw 0x806, x3

    #Address 0x806 read value
    csrr x14, 0x806

    #Address 0x806 Write value 0x37a6208
    li x3, 0x37a6208
    csrw 0x806, x3

    #Address 0x806 Write value 0xd036451a
    li x3, 0xd036451a
    csrw 0x806, x3

    #Unmapped address 0xcdc testing: random write/read operations
    #Address 0xcdc read value
    csrr x14, 0xcdc

    #Address 0xcdc read value
    csrr x14, 0xcdc

    #Address 0xcdc Write value 0x4d21a42e
    li x3, 0x4d21a42e
    csrw 0xcdc, x3

    #Address 0xcdc read value
    csrr x14, 0xcdc

    #Address 0xcdc Write value 0x52c2771f
    li x3, 0x52c2771f
    csrw 0xcdc, x3

    #Unmapped address 0x5a4 testing: random write/read operations
    #Address 0x5a4 Write value 0x8b596641
    li x3, 0x8b596641
    csrw 0x5a4, x3

    #Address 0x5a4 read value
    csrr x14, 0x5a4

    #Address 0x5a4 read value
    csrr x14, 0x5a4

    #Address 0x5a4 Write value 0x22805ac2
    li x3, 0x22805ac2
    csrw 0x5a4, x3

    #Address 0x5a4 Write value 0x9adffbef
    li x3, 0x9adffbef
    csrw 0x5a4, x3

    #Unmapped address 0xe29 testing: random write/read operations
    #Address 0xe29 Write value 0xd51d8684
    li x3, 0xd51d8684
    csrw 0xe29, x3

    #Address 0xe29 Write value 0xf3264ca2
    li x3, 0xf3264ca2
    csrw 0xe29, x3

    #Address 0xe29 Write value 0x59ac59df
    li x3, 0x59ac59df
    csrw 0xe29, x3

    #Address 0xe29 read value
    csrr x14, 0xe29

    #Address 0xe29 read value
    csrr x14, 0xe29

    #Unmapped address 0x44 testing: random write/read operations
    #Address 0x44 read value
    csrr x14, 0x44

    #Unmapped address 0xe72 testing: random write/read operations
    #Address 0xe72 read value
    csrr x14, 0xe72

    #Address 0xe72 Write value 0x9da3f5fc
    li x3, 0x9da3f5fc
    csrw 0xe72, x3

    #Address 0xe72 Write value 0x295f9e6c
    li x3, 0x295f9e6c
    csrw 0xe72, x3

    #Address 0xe72 Write value 0xcb6e2747
    li x3, 0xcb6e2747
    csrw 0xe72, x3

    #Address 0xe72 Write value 0xd1f4be3
    li x3, 0xd1f4be3
    csrw 0xe72, x3

    #Unmapped address 0x78 testing: random write/read operations
    #Address 0x78 read value
    csrr x14, 0x78

    #Address 0x78 Write value 0xacc62af8
    li x3, 0xacc62af8
    csrw 0x78, x3

    #Address 0x78 read value
    csrr x14, 0x78

    #Unmapped address 0xfd testing: random write/read operations
    #Address 0xfd Write value 0x325769a6
    li x3, 0x325769a6
    csrw 0xfd, x3

    #Address 0xfd Write value 0xb2c0e593
    li x3, 0xb2c0e593
    csrw 0xfd, x3

    #Address 0xfd read value
    csrr x14, 0xfd

    #Unmapped address 0x249 testing: random write/read operations
    #Address 0x249 read value
    csrr x14, 0x249

    #Address 0x249 read value
    csrr x14, 0x249

    #Address 0x249 Write value 0x3e5932ba
    li x3, 0x3e5932ba
    csrw 0x249, x3

    #Unmapped address 0xad2 testing: random write/read operations
    #Address 0xad2 read value
    csrr x14, 0xad2

    #Address 0xad2 read value
    csrr x14, 0xad2

    #Address 0xad2 Write value 0xe64da6ca
    li x3, 0xe64da6ca
    csrw 0xad2, x3

    #Address 0xad2 read value
    csrr x14, 0xad2

    #Unmapped address 0x677 testing: random write/read operations
    #Address 0x677 Write value 0x4b77b83c
    li x3, 0x4b77b83c
    csrw 0x677, x3

    #Address 0x677 read value
    csrr x14, 0x677

    #Unmapped address 0xad8 testing: random write/read operations
    #Address 0xad8 read value
    csrr x14, 0xad8

    #Address 0xad8 Write value 0x7c70092c
    li x3, 0x7c70092c
    csrw 0xad8, x3

    #Unmapped address 0xfcc testing: random write/read operations
    #Address 0xfcc Write value 0xab02ec72
    li x3, 0xab02ec72
    csrw 0xfcc, x3

    #Address 0xfcc read value
    csrr x14, 0xfcc

    #Address 0xfcc read value
    csrr x14, 0xfcc

    #Address 0xfcc Write value 0xe54077a8
    li x3, 0xe54077a8
    csrw 0xfcc, x3

    #Address 0xfcc Write value 0x510535b4
    li x3, 0x510535b4
    csrw 0xfcc, x3

    #Unmapped address 0xc84 testing: random write/read operations
    #Address 0xc84 Write value 0xa58fd351
    li x3, 0xa58fd351
    csrw 0xc84, x3

    #Address 0xc84 Write value 0xf6719d8a
    li x3, 0xf6719d8a
    csrw 0xc84, x3

    #Unmapped address 0x98f testing: random write/read operations
    #Address 0x98f read value
    csrr x14, 0x98f

    #Address 0x98f Write value 0x1ab766d
    li x3, 0x1ab766d
    csrw 0x98f, x3

    #Unmapped address 0xa7a testing: random write/read operations
    #Address 0xa7a Write value 0xb9c3eacd
    li x3, 0xb9c3eacd
    csrw 0xa7a, x3

    #Address 0xa7a read value
    csrr x14, 0xa7a

    #Address 0xa7a Write value 0x8fc7ad1a
    li x3, 0x8fc7ad1a
    csrw 0xa7a, x3

    #Address 0xa7a read value
    csrr x14, 0xa7a

    #Unmapped address 0x820 testing: random write/read operations
    #Address 0x820 Write value 0x7da95f7d
    li x3, 0x7da95f7d
    csrw 0x820, x3

    #Address 0x820 Write value 0x6af71816
    li x3, 0x6af71816
    csrw 0x820, x3

    #Address 0x820 read value
    csrr x14, 0x820

    #Address 0x820 Write value 0x3ed02c89
    li x3, 0x3ed02c89
    csrw 0x820, x3

    #Address 0x820 Write value 0xd0f8f432
    li x3, 0xd0f8f432
    csrw 0x820, x3

    #Unmapped address 0x827 testing: random write/read operations
    #Address 0x827 Write value 0x23748510
    li x3, 0x23748510
    csrw 0x827, x3

    #Unmapped address 0x2fb testing: random write/read operations
    #Address 0x2fb Write value 0x72df96b6
    li x3, 0x72df96b6
    csrw 0x2fb, x3

    #Address 0x2fb read value
    csrr x14, 0x2fb

    #Unmapped address 0x38a testing: random write/read operations
    #Address 0x38a read value
    csrr x14, 0x38a

    #Unmapped address 0x580 testing: random write/read operations
    #Address 0x580 read value
    csrr x14, 0x580

    #Address 0x580 Write value 0xc1b3a8f0
    li x3, 0xc1b3a8f0
    csrw 0x580, x3

    #Address 0x580 Write value 0xcd47daa4
    li x3, 0xcd47daa4
    csrw 0x580, x3

    #Address 0x580 read value
    csrr x14, 0x580

    #Address 0x580 Write value 0x14fb2e39
    li x3, 0x14fb2e39
    csrw 0x580, x3

    #Unmapped address 0x7ff testing: random write/read operations
    #Address 0x7ff read value
    csrr x14, 0x7ff

    #Unmapped address 0xd98 testing: random write/read operations
    #Address 0xd98 Write value 0xce3a065f
    li x3, 0xce3a065f
    csrw 0xd98, x3

    #Address 0xd98 Write value 0x14fe179
    li x3, 0x14fe179
    csrw 0xd98, x3

    #Address 0xd98 read value
    csrr x14, 0xd98

    #Address 0xd98 read value
    csrr x14, 0xd98

    #Unmapped address 0xdf2 testing: random write/read operations
    #Address 0xdf2 Write value 0xe7010662
    li x3, 0xe7010662
    csrw 0xdf2, x3

    #Address 0xdf2 read value
    csrr x14, 0xdf2

    #Address 0xdf2 read value
    csrr x14, 0xdf2

    #Address 0xdf2 read value
    csrr x14, 0xdf2

    #Unmapped address 0xaa6 testing: random write/read operations
    #Address 0xaa6 Write value 0x660cb6c5
    li x3, 0x660cb6c5
    csrw 0xaa6, x3

    #Address 0xaa6 read value
    csrr x14, 0xaa6

    #Address 0xaa6 read value
    csrr x14, 0xaa6

    #Address 0xaa6 read value
    csrr x14, 0xaa6

    #Address 0xaa6 read value
    csrr x14, 0xaa6

    #Unmapped address 0xaef testing: random write/read operations
    #Address 0xaef Write value 0x2d62fbd6
    li x3, 0x2d62fbd6
    csrw 0xaef, x3

    #Address 0xaef Write value 0x925ca566
    li x3, 0x925ca566
    csrw 0xaef, x3

    #Address 0xaef Write value 0x6b3d1c94
    li x3, 0x6b3d1c94
    csrw 0xaef, x3

    #Address 0xaef Write value 0x51af9579
    li x3, 0x51af9579
    csrw 0xaef, x3

    #Address 0xaef read value
    csrr x14, 0xaef

    #Unmapped address 0xb70 testing: random write/read operations
    #Address 0xb70 Write value 0xa23e0293
    li x3, 0xa23e0293
    csrw 0xb70, x3

    #Address 0xb70 Write value 0x6ab3c8e7
    li x3, 0x6ab3c8e7
    csrw 0xb70, x3

    #Address 0xb70 Write value 0x3b2dd997
    li x3, 0x3b2dd997
    csrw 0xb70, x3

    #Unmapped address 0x1a testing: random write/read operations
    #Address 0x1a Write value 0xe1f37d53
    li x3, 0xe1f37d53
    csrw 0x1a, x3

    #Address 0x1a Write value 0xd4999764
    li x3, 0xd4999764
    csrw 0x1a, x3

    #Address 0x1a read value
    csrr x14, 0x1a

    #Unmapped address 0x408 testing: random write/read operations
    #Address 0x408 read value
    csrr x14, 0x408

    #Unmapped address 0x6f6 testing: random write/read operations
    #Address 0x6f6 Write value 0xd74b5436
    li x3, 0xd74b5436
    csrw 0x6f6, x3

    #Address 0x6f6 Write value 0x1d4abff0
    li x3, 0x1d4abff0
    csrw 0x6f6, x3

    #Address 0x6f6 read value
    csrr x14, 0x6f6

    #Address 0x6f6 Write value 0xda1f83d1
    li x3, 0xda1f83d1
    csrw 0x6f6, x3

    #Unmapped address 0x147 testing: random write/read operations
    #Address 0x147 read value
    csrr x14, 0x147

    #Address 0x147 Write value 0x8062aef7
    li x3, 0x8062aef7
    csrw 0x147, x3

    #Address 0x147 Write value 0xa843cad
    li x3, 0xa843cad
    csrw 0x147, x3

    #Unmapped address 0x82d testing: random write/read operations
    #Address 0x82d Write value 0x74070d2
    li x3, 0x74070d2
    csrw 0x82d, x3

    #Address 0x82d read value
    csrr x14, 0x82d

    #Address 0x82d Write value 0x2cd15770
    li x3, 0x2cd15770
    csrw 0x82d, x3

    #Unmapped address 0x64d testing: random write/read operations
    #Address 0x64d read value
    csrr x14, 0x64d

    #Address 0x64d read value
    csrr x14, 0x64d

    #Address 0x64d read value
    csrr x14, 0x64d

    #Address 0x64d Write value 0xed94f468
    li x3, 0xed94f468
    csrw 0x64d, x3

    #Unmapped address 0x7b8 testing: random write/read operations
    #Address 0x7b8 read value
    csrr x14, 0x7b8

    #Address 0x7b8 read value
    csrr x14, 0x7b8

    #Unmapped address 0x2c testing: random write/read operations
    #Address 0x2c read value
    csrr x14, 0x2c

    #Address 0x2c Write value 0x8a4bf5fd
    li x3, 0x8a4bf5fd
    csrw 0x2c, x3

    #Address 0x2c read value
    csrr x14, 0x2c

    #Address 0x2c read value
    csrr x14, 0x2c

    #Address 0x2c Write value 0xe22514f0
    li x3, 0xe22514f0
    csrw 0x2c, x3

    #Unmapped address 0x190 testing: random write/read operations
    #Address 0x190 read value
    csrr x14, 0x190

    #Address 0x190 read value
    csrr x14, 0x190

    #Unmapped address 0xa30 testing: random write/read operations
    #Address 0xa30 Write value 0x498a854
    li x3, 0x498a854
    csrw 0xa30, x3

    #Unmapped address 0x104 testing: random write/read operations
    #Address 0x104 Write value 0x62592518
    li x3, 0x62592518
    csrw 0x104, x3

    #Unmapped address 0x2b6 testing: random write/read operations
    #Address 0x2b6 read value
    csrr x14, 0x2b6

    #Unmapped address 0x4fd testing: random write/read operations
    #Address 0x4fd read value
    csrr x14, 0x4fd

    #Unmapped address 0xaa9 testing: random write/read operations
    #Address 0xaa9 Write value 0x8c6e6f04
    li x3, 0x8c6e6f04
    csrw 0xaa9, x3

    #Address 0xaa9 Write value 0x9f58d04a
    li x3, 0x9f58d04a
    csrw 0xaa9, x3

    #Unmapped address 0xc2a testing: random write/read operations
    #Address 0xc2a Write value 0x828ff6cf
    li x3, 0x828ff6cf
    csrw 0xc2a, x3

    #Address 0xc2a Write value 0xf34e62ea
    li x3, 0xf34e62ea
    csrw 0xc2a, x3

    #Unmapped address 0x534 testing: random write/read operations
    #Address 0x534 Write value 0x48c022fc
    li x3, 0x48c022fc
    csrw 0x534, x3

    #Address 0x534 read value
    csrr x14, 0x534

    #Address 0x534 read value
    csrr x14, 0x534

    #Address 0x534 read value
    csrr x14, 0x534

    #Unmapped address 0xcce testing: random write/read operations
    #Address 0xcce read value
    csrr x14, 0xcce

    #Address 0xcce read value
    csrr x14, 0xcce

    #Address 0xcce read value
    csrr x14, 0xcce

    #Address 0xcce read value
    csrr x14, 0xcce

    #Unmapped address 0xee0 testing: random write/read operations
    #Address 0xee0 Write value 0x98006ae9
    li x3, 0x98006ae9
    csrw 0xee0, x3

    #Address 0xee0 read value
    csrr x14, 0xee0

    #Address 0xee0 read value
    csrr x14, 0xee0

    #Address 0xee0 Write value 0xcb859b2d
    li x3, 0xcb859b2d
    csrw 0xee0, x3

    #Address 0xee0 Write value 0x7c3f6a41
    li x3, 0x7c3f6a41
    csrw 0xee0, x3

    #Unmapped address 0x7fa testing: random write/read operations
    #Address 0x7fa Write value 0x25e28685
    li x3, 0x25e28685
    csrw 0x7fa, x3

    #Address 0x7fa read value
    csrr x14, 0x7fa

    #Address 0x7fa Write value 0x4adc7b64
    li x3, 0x4adc7b64
    csrw 0x7fa, x3

    #Address 0x7fa read value
    csrr x14, 0x7fa

    #Address 0x7fa Write value 0x30d06571
    li x3, 0x30d06571
    csrw 0x7fa, x3

    #Unmapped address 0x4d8 testing: random write/read operations
    #Address 0x4d8 read value
    csrr x14, 0x4d8

    #Address 0x4d8 read value
    csrr x14, 0x4d8

    #Unmapped address 0x5ff testing: random write/read operations
    #Address 0x5ff read value
    csrr x14, 0x5ff

    #Unmapped address 0x8e8 testing: random write/read operations
    #Address 0x8e8 Write value 0xfbf1525
    li x3, 0xfbf1525
    csrw 0x8e8, x3

    #Address 0x8e8 read value
    csrr x14, 0x8e8

    #Unmapped address 0x355 testing: random write/read operations
    #Address 0x355 read value
    csrr x14, 0x355

    #Address 0x355 Write value 0x1da50b7
    li x3, 0x1da50b7
    csrw 0x355, x3

    #Address 0x355 Write value 0xf8dae429
    li x3, 0xf8dae429
    csrw 0x355, x3

    #Address 0x355 read value
    csrr x14, 0x355

    #Unmapped address 0x591 testing: random write/read operations
    #Address 0x591 Write value 0xf60138aa
    li x3, 0xf60138aa
    csrw 0x591, x3

    #Address 0x591 Write value 0xe4e881fe
    li x3, 0xe4e881fe
    csrw 0x591, x3

    #Address 0x591 read value
    csrr x14, 0x591

    #Address 0x591 Write value 0xe69777fe
    li x3, 0xe69777fe
    csrw 0x591, x3

    #Unmapped address 0x97e testing: random write/read operations
    #Address 0x97e Write value 0x2bfadaf5
    li x3, 0x2bfadaf5
    csrw 0x97e, x3

    #Unmapped address 0x275 testing: random write/read operations
    #Address 0x275 read value
    csrr x14, 0x275

    #Address 0x275 read value
    csrr x14, 0x275

    #Address 0x275 read value
    csrr x14, 0x275

    #Unmapped address 0x734 testing: random write/read operations
    #Address 0x734 read value
    csrr x14, 0x734

    #Address 0x734 Write value 0x4ece293d
    li x3, 0x4ece293d
    csrw 0x734, x3

    #Address 0x734 read value
    csrr x14, 0x734

    #Address 0x734 Write value 0x5cb32ff8
    li x3, 0x5cb32ff8
    csrw 0x734, x3

    #Unmapped address 0x2d7 testing: random write/read operations
    #Address 0x2d7 Write value 0x65224672
    li x3, 0x65224672
    csrw 0x2d7, x3

    #Address 0x2d7 Write value 0x7e0b4a37
    li x3, 0x7e0b4a37
    csrw 0x2d7, x3

    #Address 0x2d7 read value
    csrr x14, 0x2d7

    #Unmapped address 0xeba testing: random write/read operations
    #Address 0xeba read value
    csrr x14, 0xeba

    #Address 0xeba Write value 0x76e2f4dc
    li x3, 0x76e2f4dc
    csrw 0xeba, x3

    #Address 0xeba read value
    csrr x14, 0xeba

    #Address 0xeba read value
    csrr x14, 0xeba

    #Address 0xeba Write value 0x21f65f90
    li x3, 0x21f65f90
    csrw 0xeba, x3

    #Unmapped address 0x723 testing: random write/read operations
    #Address 0x723 Write value 0x58ef4d76
    li x3, 0x58ef4d76
    csrw 0x723, x3

    #Mapped address 0xb8f (mhpmcounterh15) testing: random write/read operations
    #Address 0xb8f Write value 0x28647076
    li x3, 0x28647076
    csrw 0xb8f, x3

    #Address 0xb8f read value
    csrr x14, 0xb8f

    #Address 0xb8f Write value 0x5c075304
    li x3, 0x5c075304
    csrw 0xb8f, x3

    #Address 0xb8f read value
    csrr x14, 0xb8f

    #Unmapped address 0x2 testing: random write/read operations
    #Address 0x2 Write value 0x6619ac31
    li x3, 0x6619ac31
    csrw 0x2, x3

    #Address 0x2 Write value 0x501a40a7
    li x3, 0x501a40a7
    csrw 0x2, x3

    #Address 0x2 read value
    csrr x14, 0x2

    #Unmapped address 0xa69 testing: random write/read operations
    #Address 0xa69 read value
    csrr x14, 0xa69

    #Address 0xa69 Write value 0xc679983f
    li x3, 0xc679983f
    csrw 0xa69, x3

    #Unmapped address 0xebe testing: random write/read operations
    #Address 0xebe read value
    csrr x14, 0xebe

    #Address 0xebe Write value 0x776daf60
    li x3, 0x776daf60
    csrw 0xebe, x3

    #Address 0xebe Write value 0x9ab2cf88
    li x3, 0x9ab2cf88
    csrw 0xebe, x3

    #Address 0xebe Write value 0x6a7d9300
    li x3, 0x6a7d9300
    csrw 0xebe, x3

    #Address 0xebe read value
    csrr x14, 0xebe

    #Unmapped address 0xae2 testing: random write/read operations
    #Address 0xae2 read value
    csrr x14, 0xae2

    #Address 0xae2 read value
    csrr x14, 0xae2

    #Address 0xae2 Write value 0xba3d25d2
    li x3, 0xba3d25d2
    csrw 0xae2, x3

    #Address 0xae2 Write value 0xd5e52a55
    li x3, 0xd5e52a55
    csrw 0xae2, x3

    #Unmapped address 0x6cb testing: random write/read operations
    #Address 0x6cb Write value 0xd41b122
    li x3, 0xd41b122
    csrw 0x6cb, x3

    #Address 0x6cb Write value 0x557f63f1
    li x3, 0x557f63f1
    csrw 0x6cb, x3

    #Address 0x6cb read value
    csrr x14, 0x6cb

    #Address 0x6cb read value
    csrr x14, 0x6cb

    #Unmapped address 0xdfe testing: random write/read operations
    #Address 0xdfe read value
    csrr x14, 0xdfe

    #Unmapped address 0xc5a testing: random write/read operations
    #Address 0xc5a Write value 0x37199d12
    li x3, 0x37199d12
    csrw 0xc5a, x3

    #Unmapped address 0x945 testing: random write/read operations
    #Address 0x945 read value
    csrr x14, 0x945

    #Address 0x945 Write value 0xb62d5c47
    li x3, 0xb62d5c47
    csrw 0x945, x3

    #Address 0x945 read value
    csrr x14, 0x945

    #Unmapped address 0x709 testing: random write/read operations
    #Address 0x709 Write value 0x703d302
    li x3, 0x703d302
    csrw 0x709, x3

    #Unmapped address 0x743 testing: random write/read operations
    #Address 0x743 read value
    csrr x14, 0x743

    #Address 0x743 read value
    csrr x14, 0x743

    #Unmapped address 0x253 testing: random write/read operations
    #Address 0x253 read value
    csrr x14, 0x253

    #Address 0x253 Write value 0xb3fea8be
    li x3, 0xb3fea8be
    csrw 0x253, x3

    #Unmapped address 0x59f testing: random write/read operations
    #Address 0x59f read value
    csrr x14, 0x59f

    #Address 0x59f Write value 0xc67107eb
    li x3, 0xc67107eb
    csrw 0x59f, x3

    #Address 0x59f read value
    csrr x14, 0x59f

    #Address 0x59f read value
    csrr x14, 0x59f

    #Address 0x59f Write value 0x5f47fca6
    li x3, 0x5f47fca6
    csrw 0x59f, x3

    #Unmapped address 0xf09 testing: random write/read operations
    #Address 0xf09 read value
    csrr x14, 0xf09

    #Address 0xf09 read value
    csrr x14, 0xf09

    #Address 0xf09 Write value 0xd7db0ab4
    li x3, 0xd7db0ab4
    csrw 0xf09, x3

    #Address 0xf09 read value
    csrr x14, 0xf09

    #Unmapped address 0x2bb testing: random write/read operations
    #Address 0x2bb read value
    csrr x14, 0x2bb

    #Address 0x2bb read value
    csrr x14, 0x2bb

    #Mapped address 0x3b0 (pmpaddr0) testing: random write/read operations
    #Address 0x3b0 Write value 0x17a8925d
    li x3, 0x17a8925d
    csrw 0x3b0, x3

    #Unmapped address 0x1dc testing: random write/read operations
    #Address 0x1dc Write value 0x14842291
    li x3, 0x14842291
    csrw 0x1dc, x3

    #Address 0x1dc Write value 0xc1e2ee09
    li x3, 0xc1e2ee09
    csrw 0x1dc, x3

    #Unmapped address 0xb2f testing: random write/read operations
    #Address 0xb2f read value
    csrr x14, 0xb2f

    #Address 0xb2f read value
    csrr x14, 0xb2f

    #Unmapped address 0x209 testing: random write/read operations
    #Address 0x209 Write value 0x5cf70527
    li x3, 0x5cf70527
    csrw 0x209, x3

    #Address 0x209 read value
    csrr x14, 0x209

    #Address 0x209 read value
    csrr x14, 0x209

    #Address 0x209 Write value 0xa7b7bef9
    li x3, 0xa7b7bef9
    csrw 0x209, x3

    #Address 0x209 read value
    csrr x14, 0x209

    #Unmapped address 0x5fe testing: random write/read operations
    #Address 0x5fe Write value 0x4b4aa9db
    li x3, 0x4b4aa9db
    csrw 0x5fe, x3

    #Unmapped address 0x1a7 testing: random write/read operations
    #Address 0x1a7 read value
    csrr x14, 0x1a7

    #Address 0x1a7 read value
    csrr x14, 0x1a7

    #Address 0x1a7 Write value 0x6ceb8b1b
    li x3, 0x6ceb8b1b
    csrw 0x1a7, x3

    #Address 0x1a7 Write value 0xea71df84
    li x3, 0xea71df84
    csrw 0x1a7, x3

    #Unmapped address 0x8c testing: random write/read operations
    #Address 0x8c read value
    csrr x14, 0x8c

    #Address 0x8c read value
    csrr x14, 0x8c

    #Address 0x8c Write value 0xdc455d75
    li x3, 0xdc455d75
    csrw 0x8c, x3

    #Address 0x8c Write value 0x552ff804
    li x3, 0x552ff804
    csrw 0x8c, x3

    #Unmapped address 0x6e7 testing: random write/read operations
    #Address 0x6e7 read value
    csrr x14, 0x6e7

    #Address 0x6e7 Write value 0x7120a6ca
    li x3, 0x7120a6ca
    csrw 0x6e7, x3

    #Address 0x6e7 read value
    csrr x14, 0x6e7

    #Address 0x6e7 read value
    csrr x14, 0x6e7

    #Address 0x6e7 Write value 0x12aada4e
    li x3, 0x12aada4e
    csrw 0x6e7, x3

    #Unmapped address 0xbb3 testing: random write/read operations
    #Address 0xbb3 Write value 0x94aaa191
    li x3, 0x94aaa191
    csrw 0xbb3, x3

    #Unmapped address 0xd3f testing: random write/read operations
    #Address 0xd3f Write value 0xfa98361a
    li x3, 0xfa98361a
    csrw 0xd3f, x3

    #Address 0xd3f Write value 0x2efe4276
    li x3, 0x2efe4276
    csrw 0xd3f, x3

    #Address 0xd3f read value
    csrr x14, 0xd3f

    #Unmapped address 0x540 testing: random write/read operations
    #Address 0x540 read value
    csrr x14, 0x540

    #Unmapped address 0xf testing: random write/read operations
    #Address 0xf Write value 0xff96d0ce
    li x3, 0xff96d0ce
    csrw 0xf, x3

    #Address 0xf read value
    csrr x14, 0xf

    #Address 0xf read value
    csrr x14, 0xf

    #Address 0xf Write value 0x884ad3d3
    li x3, 0x884ad3d3
    csrw 0xf, x3

    #Address 0xf read value
    csrr x14, 0xf

    #Unmapped address 0xd12 testing: random write/read operations
    #Address 0xd12 read value
    csrr x14, 0xd12

    #Address 0xd12 read value
    csrr x14, 0xd12

    #Address 0xd12 Write value 0xf0ab5899
    li x3, 0xf0ab5899
    csrw 0xd12, x3

    #Address 0xd12 read value
    csrr x14, 0xd12

    #Unmapped address 0xccf testing: random write/read operations
    #Address 0xccf read value
    csrr x14, 0xccf

    #Address 0xccf read value
    csrr x14, 0xccf

    #Address 0xccf Write value 0x5a165aac
    li x3, 0x5a165aac
    csrw 0xccf, x3

    #Address 0xccf Write value 0x2c4465d2
    li x3, 0x2c4465d2
    csrw 0xccf, x3

    #Address 0xccf Write value 0xab67f770
    li x3, 0xab67f770
    csrw 0xccf, x3

    #Mapped address 0xb97 (mhpmcounterh23) testing: random write/read operations
    #Address 0xb97 Write value 0xa8c43712
    li x3, 0xa8c43712
    csrw 0xb97, x3

    #Address 0xb97 Write value 0x83a0a8e6
    li x3, 0x83a0a8e6
    csrw 0xb97, x3

    #Unmapped address 0x40c testing: random write/read operations
    #Address 0x40c read value
    csrr x14, 0x40c

    #Address 0x40c read value
    csrr x14, 0x40c

    #Address 0x40c Write value 0x175ee766
    li x3, 0x175ee766
    csrw 0x40c, x3

    #Address 0x40c Write value 0x6847f9d0
    li x3, 0x6847f9d0
    csrw 0x40c, x3

    #Address 0x40c read value
    csrr x14, 0x40c

    #Unmapped address 0xb4d testing: random write/read operations
    #Address 0xb4d read value
    csrr x14, 0xb4d

    #Unmapped address 0x512 testing: random write/read operations
    #Address 0x512 read value
    csrr x14, 0x512

    #Unmapped address 0x934 testing: random write/read operations
    #Address 0x934 read value
    csrr x14, 0x934

    #Address 0x934 read value
    csrr x14, 0x934

    #Address 0x934 read value
    csrr x14, 0x934

    #Address 0x934 Write value 0xa9ec81
    li x3, 0xa9ec81
    csrw 0x934, x3

    #Unmapped address 0x2ba testing: random write/read operations
    #Address 0x2ba Write value 0x1150d6b5
    li x3, 0x1150d6b5
    csrw 0x2ba, x3

    #Address 0x2ba Write value 0xfcdb15fb
    li x3, 0xfcdb15fb
    csrw 0x2ba, x3

    #Address 0x2ba Write value 0x33f29be8
    li x3, 0x33f29be8
    csrw 0x2ba, x3

    #Address 0x2ba read value
    csrr x14, 0x2ba

    #Address 0x2ba Write value 0x41c0004c
    li x3, 0x41c0004c
    csrw 0x2ba, x3

    #Unmapped address 0x607 testing: random write/read operations
    #Address 0x607 read value
    csrr x14, 0x607

    #Address 0x607 read value
    csrr x14, 0x607

    #Address 0x607 read value
    csrr x14, 0x607

    #Unmapped address 0xfaf testing: random write/read operations
    #Address 0xfaf read value
    csrr x14, 0xfaf

    #Address 0xfaf Write value 0x5d42be14
    li x3, 0x5d42be14
    csrw 0xfaf, x3

    #Address 0xfaf read value
    csrr x14, 0xfaf

    #Address 0xfaf Write value 0xb827e7e9
    li x3, 0xb827e7e9
    csrw 0xfaf, x3

    #Address 0xfaf read value
    csrr x14, 0xfaf

    #Unmapped address 0xe5f testing: random write/read operations
    #Address 0xe5f Write value 0x52157141
    li x3, 0x52157141
    csrw 0xe5f, x3

    #Unmapped address 0x6fe testing: random write/read operations
    #Address 0x6fe Write value 0xc53462b4
    li x3, 0xc53462b4
    csrw 0x6fe, x3

    #Unmapped address 0xbed testing: random write/read operations
    #Address 0xbed read value
    csrr x14, 0xbed

    #Address 0xbed Write value 0x8c500f87
    li x3, 0x8c500f87
    csrw 0xbed, x3

    #Address 0xbed read value
    csrr x14, 0xbed

    #Address 0xbed Write value 0xa2ddbec
    li x3, 0xa2ddbec
    csrw 0xbed, x3

    #Unmapped address 0x780 testing: random write/read operations
    #Address 0x780 Write value 0xf120a30a
    li x3, 0xf120a30a
    csrw 0x780, x3

    #Address 0x780 read value
    csrr x14, 0x780

    #Unmapped address 0xa0b testing: random write/read operations
    #Address 0xa0b read value
    csrr x14, 0xa0b

    #Unmapped address 0x912 testing: random write/read operations
    #Address 0x912 read value
    csrr x14, 0x912

    #Address 0x912 Write value 0x1fbca162
    li x3, 0x1fbca162
    csrw 0x912, x3

    #Address 0x912 read value
    csrr x14, 0x912

    #Address 0x912 Write value 0xeeaf0ec
    li x3, 0xeeaf0ec
    csrw 0x912, x3

    #Address 0x912 Write value 0x5a8cab3e
    li x3, 0x5a8cab3e
    csrw 0x912, x3

    #Unmapped address 0xdf7 testing: random write/read operations
    #Address 0xdf7 read value
    csrr x14, 0xdf7

    #Address 0xdf7 Write value 0x978b1cb1
    li x3, 0x978b1cb1
    csrw 0xdf7, x3

    #Address 0xdf7 Write value 0x961e6036
    li x3, 0x961e6036
    csrw 0xdf7, x3

    #Unmapped address 0x61e testing: random write/read operations
    #Address 0x61e Write value 0xfcf587b3
    li x3, 0xfcf587b3
    csrw 0x61e, x3

    #Address 0x61e read value
    csrr x14, 0x61e

    #Address 0x61e read value
    csrr x14, 0x61e

    #Address 0x61e Write value 0x69194d80
    li x3, 0x69194d80
    csrw 0x61e, x3

    #Address 0x61e read value
    csrr x14, 0x61e

    #Unmapped address 0xc30 testing: random write/read operations
    #Address 0xc30 read value
    csrr x14, 0xc30

    #Address 0xc30 Write value 0x8ee1a45a
    li x3, 0x8ee1a45a
    csrw 0xc30, x3

    #Unmapped address 0xa2b testing: random write/read operations
    #Address 0xa2b Write value 0x5f97f863
    li x3, 0x5f97f863
    csrw 0xa2b, x3

    #Address 0xa2b Write value 0x2f5ebd51
    li x3, 0x2f5ebd51
    csrw 0xa2b, x3

    #Unmapped address 0x741 testing: random write/read operations
    #Address 0x741 Write value 0x760e498c
    li x3, 0x760e498c
    csrw 0x741, x3

    #Address 0x741 read value
    csrr x14, 0x741

    #Address 0x741 Write value 0x79221862
    li x3, 0x79221862
    csrw 0x741, x3

    #Address 0x741 Write value 0x2dea4203
    li x3, 0x2dea4203
    csrw 0x741, x3

    #Unmapped address 0x622 testing: random write/read operations
    #Address 0x622 read value
    csrr x14, 0x622

    #Address 0x622 read value
    csrr x14, 0x622

    #Address 0x622 read value
    csrr x14, 0x622

    #Address 0x622 read value
    csrr x14, 0x622

    #Address 0x622 Write value 0xecde68c2
    li x3, 0xecde68c2
    csrw 0x622, x3

    #Unmapped address 0xf6f testing: random write/read operations
    #Address 0xf6f Write value 0xd6a2151f
    li x3, 0xd6a2151f
    csrw 0xf6f, x3

    #Address 0xf6f read value
    csrr x14, 0xf6f

    #Unmapped address 0x89b testing: random write/read operations
    #Address 0x89b read value
    csrr x14, 0x89b

    #Address 0x89b Write value 0x6ab3602b
    li x3, 0x6ab3602b
    csrw 0x89b, x3

    #Address 0x89b Write value 0x2ae05a6b
    li x3, 0x2ae05a6b
    csrw 0x89b, x3

    #Address 0x89b Write value 0xdb0b1ec4
    li x3, 0xdb0b1ec4
    csrw 0x89b, x3

    #Unmapped address 0x7cc testing: random write/read operations
    #Address 0x7cc read value
    csrr x14, 0x7cc

    #Address 0x7cc Write value 0xca6cfe64
    li x3, 0xca6cfe64
    csrw 0x7cc, x3

    #Address 0x7cc read value
    csrr x14, 0x7cc

    #Address 0x7cc Write value 0xf1da8b8d
    li x3, 0xf1da8b8d
    csrw 0x7cc, x3

    #Address 0x7cc read value
    csrr x14, 0x7cc

    #Unmapped address 0x8bb testing: random write/read operations
    #Address 0x8bb read value
    csrr x14, 0x8bb

    #Address 0x8bb read value
    csrr x14, 0x8bb

    #Address 0x8bb read value
    csrr x14, 0x8bb

    #Address 0x8bb read value
    csrr x14, 0x8bb

    #Address 0x8bb read value
    csrr x14, 0x8bb

    #Unmapped address 0x555 testing: random write/read operations
    #Address 0x555 Write value 0xf4a7d7a7
    li x3, 0xf4a7d7a7
    csrw 0x555, x3

    #Address 0x555 Write value 0xbd4d3675
    li x3, 0xbd4d3675
    csrw 0x555, x3

    #Address 0x555 read value
    csrr x14, 0x555

    #Unmapped address 0xcd0 testing: random write/read operations
    #Address 0xcd0 read value
    csrr x14, 0xcd0

    #Address 0xcd0 Write value 0x4fc1898d
    li x3, 0x4fc1898d
    csrw 0xcd0, x3

    #Address 0xcd0 Write value 0xe2173a33
    li x3, 0xe2173a33
    csrw 0xcd0, x3

    #Unmapped address 0xbb0 testing: random write/read operations
    #Address 0xbb0 read value
    csrr x14, 0xbb0

    #Address 0xbb0 read value
    csrr x14, 0xbb0

    #Address 0xbb0 read value
    csrr x14, 0xbb0

    #Address 0xbb0 Write value 0xa2d15864
    li x3, 0xa2d15864
    csrw 0xbb0, x3

    #Unmapped address 0x8c2 testing: random write/read operations
    #Address 0x8c2 Write value 0xbf99b0b0
    li x3, 0xbf99b0b0
    csrw 0x8c2, x3

    #Address 0x8c2 Write value 0x8a44719e
    li x3, 0x8a44719e
    csrw 0x8c2, x3

    #Address 0x8c2 Write value 0x8c9ac491
    li x3, 0x8c9ac491
    csrw 0x8c2, x3

    #Unmapped address 0x4af testing: random write/read operations
    #Address 0x4af read value
    csrr x14, 0x4af

    #Address 0x4af read value
    csrr x14, 0x4af

    #Address 0x4af Write value 0x40df68b1
    li x3, 0x40df68b1
    csrw 0x4af, x3

    #Address 0x4af read value
    csrr x14, 0x4af

    #Unmapped address 0x3e1 testing: random write/read operations
    #Address 0x3e1 read value
    csrr x14, 0x3e1

    #Address 0x3e1 Write value 0xb343975c
    li x3, 0xb343975c
    csrw 0x3e1, x3

    #Address 0x3e1 Write value 0x9db5de15
    li x3, 0x9db5de15
    csrw 0x3e1, x3

    #Unmapped address 0xe9a testing: random write/read operations
    #Address 0xe9a read value
    csrr x14, 0xe9a

    #Address 0xe9a read value
    csrr x14, 0xe9a

    #Address 0xe9a Write value 0x551d0296
    li x3, 0x551d0296
    csrw 0xe9a, x3

    #Address 0xe9a read value
    csrr x14, 0xe9a

    #Unmapped address 0xa19 testing: random write/read operations
    #Address 0xa19 read value
    csrr x14, 0xa19

    #Address 0xa19 read value
    csrr x14, 0xa19

    #Address 0xa19 read value
    csrr x14, 0xa19

    #Unmapped address 0x7cd testing: random write/read operations
    #Address 0x7cd read value
    csrr x14, 0x7cd

    #Unmapped address 0x545 testing: random write/read operations
    #Address 0x545 Write value 0xc9d2d928
    li x3, 0xc9d2d928
    csrw 0x545, x3

    #Address 0x545 Write value 0xec567eab
    li x3, 0xec567eab
    csrw 0x545, x3

    #Address 0x545 read value
    csrr x14, 0x545

    #Unmapped address 0xa08 testing: random write/read operations
    #Address 0xa08 Write value 0x526636ac
    li x3, 0x526636ac
    csrw 0xa08, x3

    #Address 0xa08 read value
    csrr x14, 0xa08

    #Address 0xa08 read value
    csrr x14, 0xa08

    #Unmapped address 0x1f2 testing: random write/read operations
    #Address 0x1f2 read value
    csrr x14, 0x1f2

    #Address 0x1f2 read value
    csrr x14, 0x1f2

    #Address 0x1f2 Write value 0x6c76af4e
    li x3, 0x6c76af4e
    csrw 0x1f2, x3

    #Unmapped address 0xbc4 testing: random write/read operations
    #Address 0xbc4 read value
    csrr x14, 0xbc4

    #Unmapped address 0x4f7 testing: random write/read operations
    #Address 0x4f7 Write value 0x723709eb
    li x3, 0x723709eb
    csrw 0x4f7, x3

    #Address 0x4f7 Write value 0x55890819
    li x3, 0x55890819
    csrw 0x4f7, x3

    #Address 0x4f7 read value
    csrr x14, 0x4f7

    #Address 0x4f7 read value
    csrr x14, 0x4f7

    #Unmapped address 0x907 testing: random write/read operations
    #Address 0x907 Write value 0xf839ddae
    li x3, 0xf839ddae
    csrw 0x907, x3

    #Address 0x907 Write value 0x24a2ea71
    li x3, 0x24a2ea71
    csrw 0x907, x3

    #Address 0x907 Write value 0x9f2a8022
    li x3, 0x9f2a8022
    csrw 0x907, x3

    #Address 0x907 Write value 0x506f61e8
    li x3, 0x506f61e8
    csrw 0x907, x3

    #Address 0x907 Write value 0x8345a5d9
    li x3, 0x8345a5d9
    csrw 0x907, x3

    #Unmapped address 0xe96 testing: random write/read operations
    #Address 0xe96 Write value 0x4c724c2c
    li x3, 0x4c724c2c
    csrw 0xe96, x3

    #Address 0xe96 read value
    csrr x14, 0xe96

    #Address 0xe96 read value
    csrr x14, 0xe96

    #Address 0xe96 Write value 0xddc04bf8
    li x3, 0xddc04bf8
    csrw 0xe96, x3

    #Address 0xe96 Write value 0x7bf42ff5
    li x3, 0x7bf42ff5
    csrw 0xe96, x3

    #Unmapped address 0x96b testing: random write/read operations
    #Address 0x96b Write value 0xabdf09c7
    li x3, 0xabdf09c7
    csrw 0x96b, x3

    #Address 0x96b read value
    csrr x14, 0x96b

    #Address 0x96b Write value 0xdcf3fb7c
    li x3, 0xdcf3fb7c
    csrw 0x96b, x3

    #Unmapped address 0xb4 testing: random write/read operations
    #Address 0xb4 Write value 0xb1608905
    li x3, 0xb1608905
    csrw 0xb4, x3

    #Address 0xb4 Write value 0x52e7cb1f
    li x3, 0x52e7cb1f
    csrw 0xb4, x3

    #Address 0xb4 Write value 0xa2562bfb
    li x3, 0xa2562bfb
    csrw 0xb4, x3

    #Address 0xb4 read value
    csrr x14, 0xb4

    #Unmapped address 0x133 testing: random write/read operations
    #Address 0x133 read value
    csrr x14, 0x133

    #Address 0x133 Write value 0xc0b234b4
    li x3, 0xc0b234b4
    csrw 0x133, x3

    #Address 0x133 Write value 0x8154f694
    li x3, 0x8154f694
    csrw 0x133, x3

    #Unmapped address 0xe23 testing: random write/read operations
    #Address 0xe23 read value
    csrr x14, 0xe23

    #Address 0xe23 Write value 0xffbcf051
    li x3, 0xffbcf051
    csrw 0xe23, x3

    #Address 0xe23 Write value 0x94f20f8b
    li x3, 0x94f20f8b
    csrw 0xe23, x3

    #Unmapped address 0xda9 testing: random write/read operations
    #Address 0xda9 read value
    csrr x14, 0xda9

    #Address 0xda9 Write value 0xf305f48
    li x3, 0xf305f48
    csrw 0xda9, x3

    #Address 0xda9 Write value 0xb42f4f8a
    li x3, 0xb42f4f8a
    csrw 0xda9, x3

    #Unmapped address 0x67 testing: random write/read operations
    #Address 0x67 Write value 0xe4da0484
    li x3, 0xe4da0484
    csrw 0x67, x3

    #Address 0x67 Write value 0x88c3b61a
    li x3, 0x88c3b61a
    csrw 0x67, x3

    #Address 0x67 Write value 0xb9651a5
    li x3, 0xb9651a5
    csrw 0x67, x3

    #Address 0x67 Write value 0x9f23ab7c
    li x3, 0x9f23ab7c
    csrw 0x67, x3

    #Address 0x67 read value
    csrr x14, 0x67

    #Unmapped address 0x5d2 testing: random write/read operations
    #Address 0x5d2 Write value 0x29cab429
    li x3, 0x29cab429
    csrw 0x5d2, x3

    #Unmapped address 0xc0e testing: random write/read operations
    #Address 0xc0e Write value 0x949342a7
    li x3, 0x949342a7
    csrw 0xc0e, x3

    #Unmapped address 0x4ed testing: random write/read operations
    #Address 0x4ed read value
    csrr x14, 0x4ed

    #Unmapped address 0x583 testing: random write/read operations
    #Address 0x583 Write value 0x97f99eaa
    li x3, 0x97f99eaa
    csrw 0x583, x3

    #Address 0x583 Write value 0x81b35e3e
    li x3, 0x81b35e3e
    csrw 0x583, x3

    #Address 0x583 read value
    csrr x14, 0x583

    #Unmapped address 0x4bb testing: random write/read operations
    #Address 0x4bb read value
    csrr x14, 0x4bb

    #Address 0x4bb read value
    csrr x14, 0x4bb

    #Address 0x4bb Write value 0xbcddd1d6
    li x3, 0xbcddd1d6
    csrw 0x4bb, x3

    #Address 0x4bb Write value 0x95256d68
    li x3, 0x95256d68
    csrw 0x4bb, x3

    #Unmapped address 0xc3a testing: random write/read operations
    #Address 0xc3a Write value 0x487ba6ec
    li x3, 0x487ba6ec
    csrw 0xc3a, x3

    #Address 0xc3a Write value 0xb763be7b
    li x3, 0xb763be7b
    csrw 0xc3a, x3

    #Address 0xc3a read value
    csrr x14, 0xc3a

    #Address 0xc3a read value
    csrr x14, 0xc3a

    #Unmapped address 0xaf6 testing: random write/read operations
    #Address 0xaf6 read value
    csrr x14, 0xaf6

    #Address 0xaf6 Write value 0x5993855b
    li x3, 0x5993855b
    csrw 0xaf6, x3

    #Unmapped address 0x14f testing: random write/read operations
    #Address 0x14f read value
    csrr x14, 0x14f

    #Address 0x14f Write value 0x356678fb
    li x3, 0x356678fb
    csrw 0x14f, x3

    #Address 0x14f read value
    csrr x14, 0x14f

    #Address 0x14f Write value 0xa0ecc6d5
    li x3, 0xa0ecc6d5
    csrw 0x14f, x3

    #Mapped address 0xb14 (mhpmcounter20) testing: random write/read operations
    #Address 0xb14 read value
    csrr x14, 0xb14

    #Address 0xb14 read value
    csrr x14, 0xb14

    #Address 0xb14 Write value 0xa334eb51
    li x3, 0xa334eb51
    csrw 0xb14, x3

    #Address 0xb14 Write value 0x4eecb4ad
    li x3, 0x4eecb4ad
    csrw 0xb14, x3

    #Address 0xb14 Write value 0xce9fffce
    li x3, 0xce9fffce
    csrw 0xb14, x3

    #Unmapped address 0xe67 testing: random write/read operations
    #Address 0xe67 read value
    csrr x14, 0xe67

    #Unmapped address 0xabb testing: random write/read operations
    #Address 0xabb read value
    csrr x14, 0xabb

    #Address 0xabb Write value 0xb39284ea
    li x3, 0xb39284ea
    csrw 0xabb, x3

    #Address 0xabb read value
    csrr x14, 0xabb

    #Unmapped address 0x423 testing: random write/read operations
    #Address 0x423 read value
    csrr x14, 0x423

    #Address 0x423 read value
    csrr x14, 0x423

    #Address 0x423 Write value 0x958eb739
    li x3, 0x958eb739
    csrw 0x423, x3

    #Mapped address 0x33f (mhpmevent31) testing: random write/read operations
    #Address 0x33f read value
    csrr x14, 0x33f

    #Address 0x33f Write value 0x6ecf7dd5
    li x3, 0x6ecf7dd5
    csrw 0x33f, x3

    #Unmapped address 0x36c testing: random write/read operations
    #Address 0x36c Write value 0x1d775c46
    li x3, 0x1d775c46
    csrw 0x36c, x3

    #Address 0x36c Write value 0xbf46d407
    li x3, 0xbf46d407
    csrw 0x36c, x3

    #Address 0x36c Write value 0xa95e3ffe
    li x3, 0xa95e3ffe
    csrw 0x36c, x3

    #Address 0x36c read value
    csrr x14, 0x36c

    #Unmapped address 0xf55 testing: random write/read operations
    #Address 0xf55 Write value 0xa85095ba
    li x3, 0xa85095ba
    csrw 0xf55, x3

    #Address 0xf55 Write value 0x66a6c5f5
    li x3, 0x66a6c5f5
    csrw 0xf55, x3

    #Unmapped address 0xe42 testing: random write/read operations
    #Address 0xe42 read value
    csrr x14, 0xe42

    #Address 0xe42 read value
    csrr x14, 0xe42

    #Address 0xe42 Write value 0xc6e6a2ac
    li x3, 0xc6e6a2ac
    csrw 0xe42, x3

    #Unmapped address 0x46a testing: random write/read operations
    #Address 0x46a Write value 0xdfa1edbd
    li x3, 0xdfa1edbd
    csrw 0x46a, x3

    #Address 0x46a read value
    csrr x14, 0x46a

    #Address 0x46a read value
    csrr x14, 0x46a

    #Address 0x46a Write value 0xf754dc3c
    li x3, 0xf754dc3c
    csrw 0x46a, x3

    #Unmapped address 0xbb9 testing: random write/read operations
    #Address 0xbb9 Write value 0xc74eff7a
    li x3, 0xc74eff7a
    csrw 0xbb9, x3

    #Unmapped address 0x7f4 testing: random write/read operations
    #Address 0x7f4 Write value 0xf0f2701c
    li x3, 0xf0f2701c
    csrw 0x7f4, x3

    #Address 0x7f4 Write value 0x30ae72f0
    li x3, 0x30ae72f0
    csrw 0x7f4, x3

    #Address 0x7f4 Write value 0xcd597eb9
    li x3, 0xcd597eb9
    csrw 0x7f4, x3

    #Address 0x7f4 Write value 0xb55b5b03
    li x3, 0xb55b5b03
    csrw 0x7f4, x3

    #Unmapped address 0x273 testing: random write/read operations
    #Address 0x273 read value
    csrr x14, 0x273

    #Address 0x273 read value
    csrr x14, 0x273

    #Address 0x273 Write value 0xb0f0822a
    li x3, 0xb0f0822a
    csrw 0x273, x3

    #Unmapped address 0xd2 testing: random write/read operations
    #Address 0xd2 read value
    csrr x14, 0xd2

    #Address 0xd2 read value
    csrr x14, 0xd2

    #Address 0xd2 Write value 0xe43b7dab
    li x3, 0xe43b7dab
    csrw 0xd2, x3

    #Address 0xd2 Write value 0xc487fb70
    li x3, 0xc487fb70
    csrw 0xd2, x3

    #Unmapped address 0xff7 testing: random write/read operations
    #Address 0xff7 Write value 0x53f7228c
    li x3, 0x53f7228c
    csrw 0xff7, x3

    #Address 0xff7 read value
    csrr x14, 0xff7

    #Address 0xff7 read value
    csrr x14, 0xff7

    #Address 0xff7 read value
    csrr x14, 0xff7

    #Address 0xff7 Write value 0xd7d0346
    li x3, 0xd7d0346
    csrw 0xff7, x3

    #Unmapped address 0xd41 testing: random write/read operations
    #Address 0xd41 Write value 0x6b2897d9
    li x3, 0x6b2897d9
    csrw 0xd41, x3

    #Unmapped address 0x6d4 testing: random write/read operations
    #Address 0x6d4 Write value 0xfd16bfca
    li x3, 0xfd16bfca
    csrw 0x6d4, x3

    #Address 0x6d4 Write value 0x8f59bd54
    li x3, 0x8f59bd54
    csrw 0x6d4, x3

    #Address 0x6d4 read value
    csrr x14, 0x6d4

    #Address 0x6d4 Write value 0xbe010dd1
    li x3, 0xbe010dd1
    csrw 0x6d4, x3

    #Unmapped address 0x626 testing: random write/read operations
    #Address 0x626 read value
    csrr x14, 0x626

    #Address 0x626 Write value 0xe28d2e74
    li x3, 0xe28d2e74
    csrw 0x626, x3

    #Unmapped address 0xead testing: random write/read operations
    #Address 0xead Write value 0x9a446190
    li x3, 0x9a446190
    csrw 0xead, x3

    #Unmapped address 0xdbb testing: random write/read operations
    #Address 0xdbb Write value 0x7baef7b6
    li x3, 0x7baef7b6
    csrw 0xdbb, x3

    #Address 0xdbb read value
    csrr x14, 0xdbb

    #Address 0xdbb read value
    csrr x14, 0xdbb

    #Unmapped address 0x5d7 testing: random write/read operations
    #Address 0x5d7 Write value 0xdad5555f
    li x3, 0xdad5555f
    csrw 0x5d7, x3

    #Address 0x5d7 read value
    csrr x14, 0x5d7

    #Address 0x5d7 read value
    csrr x14, 0x5d7

    #Address 0x5d7 Write value 0x1feecb80
    li x3, 0x1feecb80
    csrw 0x5d7, x3

    #Address 0x5d7 read value
    csrr x14, 0x5d7

    #Unmapped address 0xa2d testing: random write/read operations
    #Address 0xa2d read value
    csrr x14, 0xa2d

    #Address 0xa2d Write value 0x785ae5e5
    li x3, 0x785ae5e5
    csrw 0xa2d, x3

    #Address 0xa2d Write value 0xeee3f7f7
    li x3, 0xeee3f7f7
    csrw 0xa2d, x3

    #Unmapped address 0x39e testing: random write/read operations
    #Address 0x39e Write value 0x9aab90d6
    li x3, 0x9aab90d6
    csrw 0x39e, x3

    #Address 0x39e Write value 0x460a7d1a
    li x3, 0x460a7d1a
    csrw 0x39e, x3

    #Address 0x39e Write value 0x5ec62876
    li x3, 0x5ec62876
    csrw 0x39e, x3

    #Unmapped address 0x39a testing: random write/read operations
    #Address 0x39a Write value 0xf039c17b
    li x3, 0xf039c17b
    csrw 0x39a, x3

    #Address 0x39a read value
    csrr x14, 0x39a

    #Address 0x39a Write value 0x983c0994
    li x3, 0x983c0994
    csrw 0x39a, x3

    #Address 0x39a read value
    csrr x14, 0x39a

    #Address 0x39a read value
    csrr x14, 0x39a

    #Unmapped address 0x85a testing: random write/read operations
    #Address 0x85a read value
    csrr x14, 0x85a

    #Unmapped address 0xdb0 testing: random write/read operations
    #Address 0xdb0 Write value 0xb9068321
    li x3, 0xb9068321
    csrw 0xdb0, x3

    #Unmapped address 0xcf9 testing: random write/read operations
    #Address 0xcf9 Write value 0x3624da4b
    li x3, 0x3624da4b
    csrw 0xcf9, x3

    #Unmapped address 0x77 testing: random write/read operations
    #Address 0x77 read value
    csrr x14, 0x77

    #Address 0x77 read value
    csrr x14, 0x77

    #Address 0x77 Write value 0x2d4bd5ed
    li x3, 0x2d4bd5ed
    csrw 0x77, x3

    #Address 0x77 Write value 0x7376410b
    li x3, 0x7376410b
    csrw 0x77, x3

    #Unmapped address 0xcac testing: random write/read operations
    #Address 0xcac Write value 0xf85163
    li x3, 0xf85163
    csrw 0xcac, x3

    #Address 0xcac Write value 0xa4f27e23
    li x3, 0xa4f27e23
    csrw 0xcac, x3

    #Address 0xcac Write value 0x102fd43a
    li x3, 0x102fd43a
    csrw 0xcac, x3

    #Address 0xcac read value
    csrr x14, 0xcac

    #Unmapped address 0x887 testing: random write/read operations
    #Address 0x887 read value
    csrr x14, 0x887

    #Address 0x887 read value
    csrr x14, 0x887

    #Address 0x887 read value
    csrr x14, 0x887

    #Address 0x887 read value
    csrr x14, 0x887

    #Unmapped address 0x9d2 testing: random write/read operations
    #Address 0x9d2 read value
    csrr x14, 0x9d2

    #Address 0x9d2 Write value 0x5f11ded3
    li x3, 0x5f11ded3
    csrw 0x9d2, x3

    #Address 0x9d2 read value
    csrr x14, 0x9d2

    #Unmapped address 0xe02 testing: random write/read operations
    #Address 0xe02 read value
    csrr x14, 0xe02

    #Address 0xe02 read value
    csrr x14, 0xe02

    #Address 0xe02 read value
    csrr x14, 0xe02

    #Address 0xe02 Write value 0x8066522f
    li x3, 0x8066522f
    csrw 0xe02, x3

    #Unmapped address 0xc14 testing: random write/read operations
    #Address 0xc14 read value
    csrr x14, 0xc14

    #Address 0xc14 Write value 0xfcedd1d2
    li x3, 0xfcedd1d2
    csrw 0xc14, x3

    #Unmapped address 0xcb4 testing: random write/read operations
    #Address 0xcb4 read value
    csrr x14, 0xcb4

    #Address 0xcb4 Write value 0xa3fb4e6f
    li x3, 0xa3fb4e6f
    csrw 0xcb4, x3

    #Unmapped address 0x72a testing: random write/read operations
    #Address 0x72a Write value 0x5f6ac9d6
    li x3, 0x5f6ac9d6
    csrw 0x72a, x3

    #Address 0x72a Write value 0x86e732d4
    li x3, 0x86e732d4
    csrw 0x72a, x3

    #Address 0x72a Write value 0xbe09dbe2
    li x3, 0xbe09dbe2
    csrw 0x72a, x3

    #Address 0x72a Write value 0x27f26d48
    li x3, 0x27f26d48
    csrw 0x72a, x3

    #Address 0x72a Write value 0xca799fb5
    li x3, 0xca799fb5
    csrw 0x72a, x3

    #Unmapped address 0xb8 testing: random write/read operations
    #Address 0xb8 read value
    csrr x14, 0xb8

    #Unmapped address 0xbd3 testing: random write/read operations
    #Address 0xbd3 Write value 0x59b61e91
    li x3, 0x59b61e91
    csrw 0xbd3, x3

    #Address 0xbd3 Write value 0xe300dd4c
    li x3, 0xe300dd4c
    csrw 0xbd3, x3

    #Address 0xbd3 Write value 0xea103c16
    li x3, 0xea103c16
    csrw 0xbd3, x3

    #Address 0xbd3 read value
    csrr x14, 0xbd3

    #Address 0xbd3 Write value 0x1fef2af8
    li x3, 0x1fef2af8
    csrw 0xbd3, x3

    #Unmapped address 0x693 testing: random write/read operations
    #Address 0x693 Write value 0xb93508e2
    li x3, 0xb93508e2
    csrw 0x693, x3

    #Address 0x693 read value
    csrr x14, 0x693

    #Address 0x693 read value
    csrr x14, 0x693

    #Address 0x693 read value
    csrr x14, 0x693

    #Unmapped address 0x94b testing: random write/read operations
    #Address 0x94b read value
    csrr x14, 0x94b

    #Address 0x94b read value
    csrr x14, 0x94b

    #Address 0x94b read value
    csrr x14, 0x94b

    #Unmapped address 0x9c4 testing: random write/read operations
    #Address 0x9c4 read value
    csrr x14, 0x9c4

    #Unmapped address 0xc53 testing: random write/read operations
    #Address 0xc53 read value
    csrr x14, 0xc53

    #Address 0xc53 Write value 0x4e576c84
    li x3, 0x4e576c84
    csrw 0xc53, x3

    #Address 0xc53 Write value 0xdad27d92
    li x3, 0xdad27d92
    csrw 0xc53, x3

    #Address 0xc53 read value
    csrr x14, 0xc53

    #Unmapped address 0xf74 testing: random write/read operations
    #Address 0xf74 Write value 0xf59ef84b
    li x3, 0xf59ef84b
    csrw 0xf74, x3

    #Address 0xf74 read value
    csrr x14, 0xf74

    #Address 0xf74 Write value 0xd7334775
    li x3, 0xd7334775
    csrw 0xf74, x3

    #Address 0xf74 Write value 0x70978f20
    li x3, 0x70978f20
    csrw 0xf74, x3

    #Unmapped address 0xa29 testing: random write/read operations
    #Address 0xa29 Write value 0x1b609e3c
    li x3, 0x1b609e3c
    csrw 0xa29, x3

    #Address 0xa29 Write value 0x27d98000
    li x3, 0x27d98000
    csrw 0xa29, x3

    #Address 0xa29 read value
    csrr x14, 0xa29

    #Address 0xa29 Write value 0xc15e0fc8
    li x3, 0xc15e0fc8
    csrw 0xa29, x3

    #Unmapped address 0x13c testing: random write/read operations
    #Address 0x13c read value
    csrr x14, 0x13c

    #Address 0x13c Write value 0x5827e464
    li x3, 0x5827e464
    csrw 0x13c, x3

    #Unmapped address 0x6b2 testing: random write/read operations
    #Address 0x6b2 Write value 0xc0449c52
    li x3, 0xc0449c52
    csrw 0x6b2, x3

    #Address 0x6b2 read value
    csrr x14, 0x6b2

    #Unmapped address 0xb62 testing: random write/read operations
    #Address 0xb62 read value
    csrr x14, 0xb62

    #Address 0xb62 read value
    csrr x14, 0xb62

    #Address 0xb62 Write value 0x2b31e7ef
    li x3, 0x2b31e7ef
    csrw 0xb62, x3

    #Address 0xb62 read value
    csrr x14, 0xb62

    #Address 0xb62 read value
    csrr x14, 0xb62

    #Unmapped address 0x80a testing: random write/read operations
    #Address 0x80a read value
    csrr x14, 0x80a

    #Address 0x80a Write value 0x140fe674
    li x3, 0x140fe674
    csrw 0x80a, x3

    #Unmapped address 0xefa testing: random write/read operations
    #Address 0xefa Write value 0x186627f3
    li x3, 0x186627f3
    csrw 0xefa, x3

    #Address 0xefa Write value 0x40690d07
    li x3, 0x40690d07
    csrw 0xefa, x3

    #Address 0xefa Write value 0xc6fda765
    li x3, 0xc6fda765
    csrw 0xefa, x3

    #Unmapped address 0x5b testing: random write/read operations
    #Address 0x5b Write value 0x4a34b6e4
    li x3, 0x4a34b6e4
    csrw 0x5b, x3

    #Address 0x5b Write value 0xbfd603e4
    li x3, 0xbfd603e4
    csrw 0x5b, x3

    #Address 0x5b Write value 0x41d18a4
    li x3, 0x41d18a4
    csrw 0x5b, x3

    #Address 0x5b Write value 0x4f0285d
    li x3, 0x4f0285d
    csrw 0x5b, x3

    #Address 0x5b read value
    csrr x14, 0x5b

    #Unmapped address 0xf7a testing: random write/read operations
    #Address 0xf7a read value
    csrr x14, 0xf7a

    #Address 0xf7a read value
    csrr x14, 0xf7a

    #Address 0xf7a read value
    csrr x14, 0xf7a

    #Address 0xf7a Write value 0x36d527e6
    li x3, 0x36d527e6
    csrw 0xf7a, x3

    #Address 0xf7a read value
    csrr x14, 0xf7a

    #Unmapped address 0xaee testing: random write/read operations
    #Address 0xaee read value
    csrr x14, 0xaee

    #Address 0xaee Write value 0xf75ea0e8
    li x3, 0xf75ea0e8
    csrw 0xaee, x3

    #Unmapped address 0xfb testing: random write/read operations
    #Address 0xfb read value
    csrr x14, 0xfb

    #Address 0xfb read value
    csrr x14, 0xfb

    #Address 0xfb Write value 0x14cf8df4
    li x3, 0x14cf8df4
    csrw 0xfb, x3

    #Address 0xfb read value
    csrr x14, 0xfb

    #Address 0xfb read value
    csrr x14, 0xfb

    #Unmapped address 0x7f0 testing: random write/read operations
    #Address 0x7f0 Write value 0x2c3d8c56
    li x3, 0x2c3d8c56
    csrw 0x7f0, x3

    #Address 0x7f0 read value
    csrr x14, 0x7f0

    #Address 0x7f0 read value
    csrr x14, 0x7f0

    #Address 0x7f0 Write value 0x31a97f09
    li x3, 0x31a97f09
    csrw 0x7f0, x3

    #Unmapped address 0x5a5 testing: random write/read operations
    #Address 0x5a5 read value
    csrr x14, 0x5a5

    #Address 0x5a5 Write value 0x4c99384f
    li x3, 0x4c99384f
    csrw 0x5a5, x3

    #Address 0x5a5 Write value 0x98ad4ae5
    li x3, 0x98ad4ae5
    csrw 0x5a5, x3

    #Address 0x5a5 Write value 0xc7a34aa0
    li x3, 0xc7a34aa0
    csrw 0x5a5, x3

    #Unmapped address 0x952 testing: random write/read operations
    #Address 0x952 Write value 0xe746ada
    li x3, 0xe746ada
    csrw 0x952, x3

    #Address 0x952 Write value 0x841784a8
    li x3, 0x841784a8
    csrw 0x952, x3

    #Address 0x952 Write value 0xacf5574a
    li x3, 0xacf5574a
    csrw 0x952, x3

    #Address 0x952 read value
    csrr x14, 0x952

    #Address 0x952 read value
    csrr x14, 0x952

    #Unmapped address 0x458 testing: random write/read operations
    #Address 0x458 read value
    csrr x14, 0x458

    #Address 0x458 read value
    csrr x14, 0x458

    #Address 0x458 Write value 0x76004ad9
    li x3, 0x76004ad9
    csrw 0x458, x3

    #Address 0x458 Write value 0x7cda8a84
    li x3, 0x7cda8a84
    csrw 0x458, x3

    #Unmapped address 0xdb7 testing: random write/read operations
    #Address 0xdb7 read value
    csrr x14, 0xdb7

    #Unmapped address 0xce0 testing: random write/read operations
    #Address 0xce0 Write value 0xab339184
    li x3, 0xab339184
    csrw 0xce0, x3

    #Address 0xce0 read value
    csrr x14, 0xce0

    #Address 0xce0 Write value 0x3f556ff0
    li x3, 0x3f556ff0
    csrw 0xce0, x3

    #Address 0xce0 read value
    csrr x14, 0xce0

    #Address 0xce0 read value
    csrr x14, 0xce0

    #Unmapped address 0x265 testing: random write/read operations
    #Address 0x265 Write value 0x51ec56b8
    li x3, 0x51ec56b8
    csrw 0x265, x3

    #Address 0x265 read value
    csrr x14, 0x265

    #Address 0x265 Write value 0x923f2556
    li x3, 0x923f2556
    csrw 0x265, x3

    #Address 0x265 read value
    csrr x14, 0x265

    #Address 0x265 Write value 0x55fd11d1
    li x3, 0x55fd11d1
    csrw 0x265, x3

    #Unmapped address 0x486 testing: random write/read operations
    #Address 0x486 Write value 0x81231948
    li x3, 0x81231948
    csrw 0x486, x3

    #Address 0x486 read value
    csrr x14, 0x486

    #Unmapped address 0x345 testing: random write/read operations
    #Address 0x345 read value
    csrr x14, 0x345

    #Address 0x345 Write value 0x3fac2cfc
    li x3, 0x3fac2cfc
    csrw 0x345, x3

    #Unmapped address 0x513 testing: random write/read operations
    #Address 0x513 read value
    csrr x14, 0x513

    #Address 0x513 read value
    csrr x14, 0x513

    #Unmapped address 0x967 testing: random write/read operations
    #Address 0x967 Write value 0x69d6ceee
    li x3, 0x69d6ceee
    csrw 0x967, x3

    #Address 0x967 Write value 0x72879580
    li x3, 0x72879580
    csrw 0x967, x3

    #Unmapped address 0x9bf testing: random write/read operations
    #Address 0x9bf read value
    csrr x14, 0x9bf

    #Address 0x9bf read value
    csrr x14, 0x9bf

    #Address 0x9bf Write value 0x93e88bd4
    li x3, 0x93e88bd4
    csrw 0x9bf, x3

    #Address 0x9bf read value
    csrr x14, 0x9bf

    #Unmapped address 0x570 testing: random write/read operations
    #Address 0x570 read value
    csrr x14, 0x570

    #Address 0x570 Write value 0xc55ec40f
    li x3, 0xc55ec40f
    csrw 0x570, x3

    #Address 0x570 Write value 0xc5b3721e
    li x3, 0xc5b3721e
    csrw 0x570, x3

    #Address 0x570 Write value 0xab34b09b
    li x3, 0xab34b09b
    csrw 0x570, x3

    #Unmapped address 0xb75 testing: random write/read operations
    #Address 0xb75 read value
    csrr x14, 0xb75

    #Address 0xb75 read value
    csrr x14, 0xb75

    #Address 0xb75 Write value 0x78dbb8e
    li x3, 0x78dbb8e
    csrw 0xb75, x3

    #Address 0xb75 read value
    csrr x14, 0xb75

    #Address 0xb75 read value
    csrr x14, 0xb75

    #Unmapped address 0xa33 testing: random write/read operations
    #Address 0xa33 read value
    csrr x14, 0xa33

    #Address 0xa33 read value
    csrr x14, 0xa33

    #Address 0xa33 read value
    csrr x14, 0xa33

    #Address 0xa33 read value
    csrr x14, 0xa33

    #Address 0xa33 read value
    csrr x14, 0xa33

    #Unmapped address 0xdbf testing: random write/read operations
    #Address 0xdbf read value
    csrr x14, 0xdbf

    #Address 0xdbf read value
    csrr x14, 0xdbf

    #Address 0xdbf Write value 0x60136351
    li x3, 0x60136351
    csrw 0xdbf, x3

    #Address 0xdbf read value
    csrr x14, 0xdbf

    #Unmapped address 0x374 testing: random write/read operations
    #Address 0x374 read value
    csrr x14, 0x374

    #Address 0x374 Write value 0x15dd14d5
    li x3, 0x15dd14d5
    csrw 0x374, x3

    #Address 0x374 Write value 0x3e543f2d
    li x3, 0x3e543f2d
    csrw 0x374, x3

    #Address 0x374 Write value 0x41cea485
    li x3, 0x41cea485
    csrw 0x374, x3

    #Address 0x374 read value
    csrr x14, 0x374

    #Unmapped address 0x2b0 testing: random write/read operations
    #Address 0x2b0 Write value 0x55a4cb23
    li x3, 0x55a4cb23
    csrw 0x2b0, x3

    #Address 0x2b0 read value
    csrr x14, 0x2b0

    #Address 0x2b0 read value
    csrr x14, 0x2b0

    #Address 0x2b0 read value
    csrr x14, 0x2b0

    #Unmapped address 0x779 testing: random write/read operations
    #Address 0x779 read value
    csrr x14, 0x779

    #Unmapped address 0x593 testing: random write/read operations
    #Address 0x593 read value
    csrr x14, 0x593

    #Address 0x593 Write value 0x7e92d6eb
    li x3, 0x7e92d6eb
    csrw 0x593, x3

    #Address 0x593 read value
    csrr x14, 0x593

    #Address 0x593 Write value 0xd8a4378f
    li x3, 0xd8a4378f
    csrw 0x593, x3

    #Address 0x593 Write value 0xaa003466
    li x3, 0xaa003466
    csrw 0x593, x3

    #Unmapped address 0xbde testing: random write/read operations
    #Address 0xbde read value
    csrr x14, 0xbde

    #Unmapped address 0x63e testing: random write/read operations
    #Address 0x63e Write value 0xae1553d
    li x3, 0xae1553d
    csrw 0x63e, x3

    #Unmapped address 0xa03 testing: random write/read operations
    #Address 0xa03 Write value 0xd83cb3b
    li x3, 0xd83cb3b
    csrw 0xa03, x3

    #Address 0xa03 Write value 0x5fe9459b
    li x3, 0x5fe9459b
    csrw 0xa03, x3

    #Address 0xa03 read value
    csrr x14, 0xa03

    #Address 0xa03 Write value 0x92c27f2d
    li x3, 0x92c27f2d
    csrw 0xa03, x3

    #Address 0xa03 Write value 0x8e3b5d7c
    li x3, 0x8e3b5d7c
    csrw 0xa03, x3

    #Mapped address 0xb95 (mhpmcounterh21) testing: random write/read operations
    #Address 0xb95 read value
    csrr x14, 0xb95

    #Address 0xb95 read value
    csrr x14, 0xb95

    #Unmapped address 0xde2 testing: random write/read operations
    #Address 0xde2 Write value 0xc343a3c8
    li x3, 0xc343a3c8
    csrw 0xde2, x3

    #Address 0xde2 Write value 0x8468115
    li x3, 0x8468115
    csrw 0xde2, x3

    #Unmapped address 0x9e5 testing: random write/read operations
    #Address 0x9e5 read value
    csrr x14, 0x9e5

    #Address 0x9e5 read value
    csrr x14, 0x9e5

    #Unmapped address 0x1cf testing: random write/read operations
    #Address 0x1cf Write value 0x3e1fd641
    li x3, 0x3e1fd641
    csrw 0x1cf, x3

    #Address 0x1cf Write value 0xf3618d23
    li x3, 0xf3618d23
    csrw 0x1cf, x3

    #Unmapped address 0xf2c testing: random write/read operations
    #Address 0xf2c read value
    csrr x14, 0xf2c

    #Address 0xf2c read value
    csrr x14, 0xf2c

    #Address 0xf2c Write value 0xc247723f
    li x3, 0xc247723f
    csrw 0xf2c, x3

    #Address 0xf2c Write value 0xf1abcc9a
    li x3, 0xf1abcc9a
    csrw 0xf2c, x3

    #Address 0xf2c Write value 0x88aa9e86
    li x3, 0x88aa9e86
    csrw 0xf2c, x3

    #Unmapped address 0x220 testing: random write/read operations
    #Address 0x220 read value
    csrr x14, 0x220

    #Address 0x220 read value
    csrr x14, 0x220

    #Address 0x220 Write value 0x48ce51ff
    li x3, 0x48ce51ff
    csrw 0x220, x3

    #Address 0x220 Write value 0x5ec43306
    li x3, 0x5ec43306
    csrw 0x220, x3

    #Address 0x220 read value
    csrr x14, 0x220

    #Unmapped address 0x235 testing: random write/read operations
    #Address 0x235 read value
    csrr x14, 0x235

    #Address 0x235 Write value 0xb744171a
    li x3, 0xb744171a
    csrw 0x235, x3

    #Unmapped address 0xe21 testing: random write/read operations
    #Address 0xe21 Write value 0x9e8df4f5
    li x3, 0x9e8df4f5
    csrw 0xe21, x3

    #Address 0xe21 Write value 0xe2eb803c
    li x3, 0xe2eb803c
    csrw 0xe21, x3

    #Address 0xe21 read value
    csrr x14, 0xe21

    #Address 0xe21 Write value 0x7c83ff8a
    li x3, 0x7c83ff8a
    csrw 0xe21, x3

    #Address 0xe21 read value
    csrr x14, 0xe21

    #Mapped address 0xb0c (mhpmcounter12) testing: random write/read operations
    #Address 0xb0c read value
    csrr x14, 0xb0c

    #Address 0xb0c read value
    csrr x14, 0xb0c

    #Unmapped address 0xf5d testing: random write/read operations
    #Address 0xf5d read value
    csrr x14, 0xf5d

    #Address 0xf5d Write value 0xc01dcbe9
    li x3, 0xc01dcbe9
    csrw 0xf5d, x3

    #Address 0xf5d Write value 0xb3b617c0
    li x3, 0xb3b617c0
    csrw 0xf5d, x3

    #Unmapped address 0x890 testing: random write/read operations
    #Address 0x890 read value
    csrr x14, 0x890

    #Address 0x890 Write value 0x1d17999d
    li x3, 0x1d17999d
    csrw 0x890, x3

    #Address 0x890 read value
    csrr x14, 0x890

    #Address 0x890 Write value 0xea576ca3
    li x3, 0xea576ca3
    csrw 0x890, x3

    #Address 0x890 read value
    csrr x14, 0x890

    #Unmapped address 0x8e9 testing: random write/read operations
    #Address 0x8e9 read value
    csrr x14, 0x8e9

    #Address 0x8e9 Write value 0x6d4095b6
    li x3, 0x6d4095b6
    csrw 0x8e9, x3

    #Address 0x8e9 Write value 0x784beb8a
    li x3, 0x784beb8a
    csrw 0x8e9, x3

    #Address 0x8e9 Write value 0x610197a4
    li x3, 0x610197a4
    csrw 0x8e9, x3

    #Address 0x8e9 read value
    csrr x14, 0x8e9

    #Unmapped address 0x505 testing: random write/read operations
    #Address 0x505 Write value 0x96306294
    li x3, 0x96306294
    csrw 0x505, x3

    #Unmapped address 0x22c testing: random write/read operations
    #Address 0x22c read value
    csrr x14, 0x22c

    #Address 0x22c Write value 0xf19fc69b
    li x3, 0xf19fc69b
    csrw 0x22c, x3

    #Address 0x22c Write value 0xa98b0c53
    li x3, 0xa98b0c53
    csrw 0x22c, x3

    #Address 0x22c Write value 0xea085b05
    li x3, 0xea085b05
    csrw 0x22c, x3

    #Unmapped address 0xf36 testing: random write/read operations
    #Address 0xf36 read value
    csrr x14, 0xf36

    #Unmapped address 0x45c testing: random write/read operations
    #Address 0x45c read value
    csrr x14, 0x45c

    #Unmapped address 0xa24 testing: random write/read operations
    #Address 0xa24 read value
    csrr x14, 0xa24

    #Unmapped address 0xfb1 testing: random write/read operations
    #Address 0xfb1 Write value 0x5049274
    li x3, 0x5049274
    csrw 0xfb1, x3

    #Address 0xfb1 Write value 0x3feb7571
    li x3, 0x3feb7571
    csrw 0xfb1, x3

    #Unmapped address 0x4ab testing: random write/read operations
    #Address 0x4ab read value
    csrr x14, 0x4ab

    #Address 0x4ab read value
    csrr x14, 0x4ab

    #Address 0x4ab Write value 0x49292492
    li x3, 0x49292492
    csrw 0x4ab, x3

    #Address 0x4ab read value
    csrr x14, 0x4ab

    #Unmapped address 0x26d testing: random write/read operations
    #Address 0x26d Write value 0xb0e2184b
    li x3, 0xb0e2184b
    csrw 0x26d, x3

    #Address 0x26d read value
    csrr x14, 0x26d

    #Address 0x26d read value
    csrr x14, 0x26d

    #Unmapped address 0xeeb testing: random write/read operations
    #Address 0xeeb read value
    csrr x14, 0xeeb

    #Address 0xeeb Write value 0xd419f8ca
    li x3, 0xd419f8ca
    csrw 0xeeb, x3

    #Unmapped address 0xfbf testing: random write/read operations
    #Address 0xfbf read value
    csrr x14, 0xfbf

    #Address 0xfbf Write value 0x2a1b2d06
    li x3, 0x2a1b2d06
    csrw 0xfbf, x3

    #Unmapped address 0x87a testing: random write/read operations
    #Address 0x87a read value
    csrr x14, 0x87a

    #Address 0x87a Write value 0x6f292b29
    li x3, 0x6f292b29
    csrw 0x87a, x3

    #Unmapped address 0xbcd testing: random write/read operations
    #Address 0xbcd read value
    csrr x14, 0xbcd

    #Unmapped address 0x14e testing: random write/read operations
    #Address 0x14e Write value 0xd792d3af
    li x3, 0xd792d3af
    csrw 0x14e, x3

    #Address 0x14e read value
    csrr x14, 0x14e

    #Address 0x14e read value
    csrr x14, 0x14e

    #Address 0x14e read value
    csrr x14, 0x14e

    #Unmapped address 0x148 testing: random write/read operations
    #Address 0x148 read value
    csrr x14, 0x148

    #Address 0x148 Write value 0xcf440684
    li x3, 0xcf440684
    csrw 0x148, x3

    #Address 0x148 read value
    csrr x14, 0x148

    #Address 0x148 read value
    csrr x14, 0x148

    #Unmapped address 0x407 testing: random write/read operations
    #Address 0x407 read value
    csrr x14, 0x407

    #Address 0x407 Write value 0xbc17b0e0
    li x3, 0xbc17b0e0
    csrw 0x407, x3

    #Address 0x407 Write value 0x416e0f55
    li x3, 0x416e0f55
    csrw 0x407, x3

    #Unmapped address 0x7c9 testing: random write/read operations
    #Address 0x7c9 read value
    csrr x14, 0x7c9

    #Unmapped address 0x4df testing: random write/read operations
    #Address 0x4df read value
    csrr x14, 0x4df

    #Address 0x4df Write value 0xe27efd64
    li x3, 0xe27efd64
    csrw 0x4df, x3

    #Address 0x4df Write value 0x12d88ae3
    li x3, 0x12d88ae3
    csrw 0x4df, x3

    #Mapped address 0x33a (mhpmevent26) testing: random write/read operations
    #Address 0x33a Write value 0x40e71196
    li x3, 0x40e71196
    csrw 0x33a, x3

    #Address 0x33a Write value 0x7124ec65
    li x3, 0x7124ec65
    csrw 0x33a, x3

    #Address 0x33a read value
    csrr x14, 0x33a

    #Unmapped address 0x54a testing: random write/read operations
    #Address 0x54a read value
    csrr x14, 0x54a

    #Address 0x54a read value
    csrr x14, 0x54a

    #Address 0x54a read value
    csrr x14, 0x54a

    #Unmapped address 0xf9d testing: random write/read operations
    #Address 0xf9d Write value 0x9306c0f5
    li x3, 0x9306c0f5
    csrw 0xf9d, x3

    #Address 0xf9d read value
    csrr x14, 0xf9d

    #Address 0xf9d Write value 0x27da1672
    li x3, 0x27da1672
    csrw 0xf9d, x3

    #Unmapped address 0x556 testing: random write/read operations
    #Address 0x556 Write value 0x988c540
    li x3, 0x988c540
    csrw 0x556, x3

    #Unmapped address 0xa6f testing: random write/read operations
    #Address 0xa6f Write value 0x7c16f006
    li x3, 0x7c16f006
    csrw 0xa6f, x3

    #Address 0xa6f Write value 0xe731f40
    li x3, 0xe731f40
    csrw 0xa6f, x3

    #Unmapped address 0x16b testing: random write/read operations
    #Address 0x16b read value
    csrr x14, 0x16b

    #Address 0x16b Write value 0x879282d0
    li x3, 0x879282d0
    csrw 0x16b, x3

    #Address 0x16b read value
    csrr x14, 0x16b

    #Address 0x16b read value
    csrr x14, 0x16b

    #Address 0x16b Write value 0x4e6d4cdb
    li x3, 0x4e6d4cdb
    csrw 0x16b, x3

    #Unmapped address 0x95c testing: random write/read operations
    #Address 0x95c read value
    csrr x14, 0x95c

    #Unmapped address 0x75a testing: random write/read operations
    #Address 0x75a Write value 0xad23060a
    li x3, 0xad23060a
    csrw 0x75a, x3

    #Unmapped address 0x94e testing: random write/read operations
    #Address 0x94e read value
    csrr x14, 0x94e

    #Address 0x94e Write value 0x56c8dc27
    li x3, 0x56c8dc27
    csrw 0x94e, x3

    #Address 0x94e read value
    csrr x14, 0x94e

    #Address 0x94e Write value 0xb8297ee5
    li x3, 0xb8297ee5
    csrw 0x94e, x3

    #Address 0x94e read value
    csrr x14, 0x94e

    #Unmapped address 0x8b5 testing: random write/read operations
    #Address 0x8b5 Write value 0x3463df4e
    li x3, 0x3463df4e
    csrw 0x8b5, x3

    #Address 0x8b5 Write value 0xc4ef7353
    li x3, 0xc4ef7353
    csrw 0x8b5, x3

    #Address 0x8b5 Write value 0x2f28d1ab
    li x3, 0x2f28d1ab
    csrw 0x8b5, x3

    #Address 0x8b5 Write value 0x8626596c
    li x3, 0x8626596c
    csrw 0x8b5, x3

    #Address 0x8b5 Write value 0xe0c81ffb
    li x3, 0xe0c81ffb
    csrw 0x8b5, x3

    #Unmapped address 0xe22 testing: random write/read operations
    #Address 0xe22 Write value 0x66a8c641
    li x3, 0x66a8c641
    csrw 0xe22, x3

    #Address 0xe22 Write value 0xe12df454
    li x3, 0xe12df454
    csrw 0xe22, x3

    #Address 0xe22 read value
    csrr x14, 0xe22

    #Address 0xe22 Write value 0xf17f3d1f
    li x3, 0xf17f3d1f
    csrw 0xe22, x3

    #Unmapped address 0x662 testing: random write/read operations
    #Address 0x662 Write value 0x5b9e14a2
    li x3, 0x5b9e14a2
    csrw 0x662, x3

    #Address 0x662 Write value 0x93c08887
    li x3, 0x93c08887
    csrw 0x662, x3

    #Address 0x662 Write value 0xf702d451
    li x3, 0xf702d451
    csrw 0x662, x3

    #Address 0x662 read value
    csrr x14, 0x662

    #Unmapped address 0xac2 testing: random write/read operations
    #Address 0xac2 Write value 0x166c1ed8
    li x3, 0x166c1ed8
    csrw 0xac2, x3

    #Address 0xac2 Write value 0x123471b4
    li x3, 0x123471b4
    csrw 0xac2, x3

    #Address 0xac2 Write value 0x905fcbc
    li x3, 0x905fcbc
    csrw 0xac2, x3

    #Unmapped address 0x760 testing: random write/read operations
    #Address 0x760 Write value 0xdb912b77
    li x3, 0xdb912b77
    csrw 0x760, x3

    #Address 0x760 Write value 0x30b66351
    li x3, 0x30b66351
    csrw 0x760, x3

    #Address 0x760 Write value 0x204fa83d
    li x3, 0x204fa83d
    csrw 0x760, x3

    #Address 0x760 Write value 0x88d20f6c
    li x3, 0x88d20f6c
    csrw 0x760, x3

    #Unmapped address 0xc34 testing: random write/read operations
    #Address 0xc34 Write value 0x4ac77189
    li x3, 0x4ac77189
    csrw 0xc34, x3

    #Unmapped address 0x582 testing: random write/read operations
    #Address 0x582 Write value 0xfd7122d6
    li x3, 0xfd7122d6
    csrw 0x582, x3

    #Address 0x582 read value
    csrr x14, 0x582

    #Unmapped address 0x7ca testing: random write/read operations
    #Address 0x7ca Write value 0xe00c93df
    li x3, 0xe00c93df
    csrw 0x7ca, x3

    #Address 0x7ca Write value 0xe6991e97
    li x3, 0xe6991e97
    csrw 0x7ca, x3

    #Unmapped address 0x39c testing: random write/read operations
    #Address 0x39c read value
    csrr x14, 0x39c

    #Unmapped address 0x727 testing: random write/read operations
    #Address 0x727 Write value 0xce996b10
    li x3, 0xce996b10
    csrw 0x727, x3

    #Address 0x727 Write value 0xda719725
    li x3, 0xda719725
    csrw 0x727, x3

    #Mapped address 0xb0b (mhpmcounter11) testing: random write/read operations
    #Address 0xb0b read value
    csrr x14, 0xb0b

    #Address 0xb0b read value
    csrr x14, 0xb0b

    #Unmapped address 0xfd6 testing: random write/read operations
    #Address 0xfd6 read value
    csrr x14, 0xfd6

    #Unmapped address 0x75c testing: random write/read operations
    #Address 0x75c read value
    csrr x14, 0x75c

    #Address 0x75c Write value 0xaa980cde
    li x3, 0xaa980cde
    csrw 0x75c, x3

    #Address 0x75c Write value 0x72355ddd
    li x3, 0x72355ddd
    csrw 0x75c, x3

    #Address 0x75c Write value 0x3b4c3451
    li x3, 0x3b4c3451
    csrw 0x75c, x3

    #Address 0x75c read value
    csrr x14, 0x75c

    #Unmapped address 0xe7a testing: random write/read operations
    #Address 0xe7a read value
    csrr x14, 0xe7a

    #Address 0xe7a Write value 0xbf1e0667
    li x3, 0xbf1e0667
    csrw 0xe7a, x3

    #Address 0xe7a read value
    csrr x14, 0xe7a

    #Address 0xe7a Write value 0xc872d06
    li x3, 0xc872d06
    csrw 0xe7a, x3

    #Address 0xe7a read value
    csrr x14, 0xe7a

    #Unmapped address 0x3eb testing: random write/read operations
    #Address 0x3eb Write value 0x7dee7938
    li x3, 0x7dee7938
    csrw 0x3eb, x3

    #Address 0x3eb read value
    csrr x14, 0x3eb

    #Unmapped address 0xe6b testing: random write/read operations
    #Address 0xe6b Write value 0xcf4dcdd3
    li x3, 0xcf4dcdd3
    csrw 0xe6b, x3

    #Address 0xe6b read value
    csrr x14, 0xe6b

    #Address 0xe6b Write value 0xfef04620
    li x3, 0xfef04620
    csrw 0xe6b, x3

    #Address 0xe6b read value
    csrr x14, 0xe6b

    #Unmapped address 0xf79 testing: random write/read operations
    #Address 0xf79 read value
    csrr x14, 0xf79

    #Address 0xf79 read value
    csrr x14, 0xf79

    #Unmapped address 0x263 testing: random write/read operations
    #Address 0x263 read value
    csrr x14, 0x263

    #Address 0x263 Write value 0x2aea0bc7
    li x3, 0x2aea0bc7
    csrw 0x263, x3

    #Address 0x263 read value
    csrr x14, 0x263

    #Unmapped address 0x799 testing: random write/read operations
    #Address 0x799 read value
    csrr x14, 0x799

    #Address 0x799 read value
    csrr x14, 0x799

    #Address 0x799 Write value 0xda0f5980
    li x3, 0xda0f5980
    csrw 0x799, x3

    #Address 0x799 read value
    csrr x14, 0x799

    #Address 0x799 read value
    csrr x14, 0x799

    #Mapped address 0xb1d (mhpmcounter29) testing: random write/read operations
    #Address 0xb1d Write value 0xbc2caf07
    li x3, 0xbc2caf07
    csrw 0xb1d, x3

    #Address 0xb1d read value
    csrr x14, 0xb1d

    #Address 0xb1d Write value 0xd79ee602
    li x3, 0xd79ee602
    csrw 0xb1d, x3

    #Address 0xb1d Write value 0x4c602628
    li x3, 0x4c602628
    csrw 0xb1d, x3

    #Unmapped address 0x726 testing: random write/read operations
    #Address 0x726 Write value 0x8772f9e8
    li x3, 0x8772f9e8
    csrw 0x726, x3

    #Address 0x726 Write value 0x69947703
    li x3, 0x69947703
    csrw 0x726, x3

    #Address 0x726 Write value 0x7521b1
    li x3, 0x7521b1
    csrw 0x726, x3

    #Address 0x726 Write value 0xa4025f7f
    li x3, 0xa4025f7f
    csrw 0x726, x3

    #Address 0x726 Write value 0x4b13de3a
    li x3, 0x4b13de3a
    csrw 0x726, x3

    #Unmapped address 0xfc6 testing: random write/read operations
    #Address 0xfc6 Write value 0x8352fe30
    li x3, 0x8352fe30
    csrw 0xfc6, x3

    #Unmapped address 0x894 testing: random write/read operations
    #Address 0x894 Write value 0x58758946
    li x3, 0x58758946
    csrw 0x894, x3

    #Unmapped address 0x96f testing: random write/read operations
    #Address 0x96f Write value 0x22a17819
    li x3, 0x22a17819
    csrw 0x96f, x3

    #Address 0x96f Write value 0xa1c48539
    li x3, 0xa1c48539
    csrw 0x96f, x3

    #Unmapped address 0xa27 testing: random write/read operations
    #Address 0xa27 Write value 0xff60b065
    li x3, 0xff60b065
    csrw 0xa27, x3

    #Address 0xa27 Write value 0xca49f649
    li x3, 0xca49f649
    csrw 0xa27, x3

    #Address 0xa27 Write value 0x454ff657
    li x3, 0x454ff657
    csrw 0xa27, x3

    #Address 0xa27 read value
    csrr x14, 0xa27

    #Unmapped address 0x4ee testing: random write/read operations
    #Address 0x4ee read value
    csrr x14, 0x4ee

    #Address 0x4ee read value
    csrr x14, 0x4ee

    #Address 0x4ee read value
    csrr x14, 0x4ee

    #Unmapped address 0x7e6 testing: random write/read operations
    #Address 0x7e6 read value
    csrr x14, 0x7e6

    #Address 0x7e6 read value
    csrr x14, 0x7e6

    #Address 0x7e6 Write value 0xd0328d3a
    li x3, 0xd0328d3a
    csrw 0x7e6, x3

    #Address 0x7e6 read value
    csrr x14, 0x7e6

    #Unmapped address 0xf35 testing: random write/read operations
    #Address 0xf35 Write value 0xf34b5b75
    li x3, 0xf34b5b75
    csrw 0xf35, x3

    #Address 0xf35 read value
    csrr x14, 0xf35

    #Address 0xf35 Write value 0xcd4d1ba6
    li x3, 0xcd4d1ba6
    csrw 0xf35, x3

    #Address 0xf35 read value
    csrr x14, 0xf35

    #Unmapped address 0xfe1 testing: random write/read operations
    #Address 0xfe1 read value
    csrr x14, 0xfe1

    #Address 0xfe1 read value
    csrr x14, 0xfe1

    #Unmapped address 0xc3 testing: random write/read operations
    #Address 0xc3 Write value 0xe74bb02b
    li x3, 0xe74bb02b
    csrw 0xc3, x3

    #Address 0xc3 read value
    csrr x14, 0xc3

    #Address 0xc3 Write value 0x5af45480
    li x3, 0x5af45480
    csrw 0xc3, x3

    #Unmapped address 0x942 testing: random write/read operations
    #Address 0x942 Write value 0x316b69cd
    li x3, 0x316b69cd
    csrw 0x942, x3

    #Address 0x942 read value
    csrr x14, 0x942

    #Unmapped address 0xb5e testing: random write/read operations
    #Address 0xb5e Write value 0xbe6d3e4b
    li x3, 0xbe6d3e4b
    csrw 0xb5e, x3

    #Unmapped address 0x5a testing: random write/read operations
    #Address 0x5a Write value 0x6ba6a2e
    li x3, 0x6ba6a2e
    csrw 0x5a, x3

    #Address 0x5a read value
    csrr x14, 0x5a

    #Address 0x5a Write value 0xc5ea89da
    li x3, 0xc5ea89da
    csrw 0x5a, x3

    #Unmapped address 0xbff testing: random write/read operations
    #Address 0xbff Write value 0x39da889f
    li x3, 0x39da889f
    csrw 0xbff, x3

    #Address 0xbff read value
    csrr x14, 0xbff

    #Address 0xbff read value
    csrr x14, 0xbff

    #Address 0xbff Write value 0x447985ac
    li x3, 0x447985ac
    csrw 0xbff, x3

    #Address 0xbff Write value 0x544db02f
    li x3, 0x544db02f
    csrw 0xbff, x3

    #Unmapped address 0x800 testing: random write/read operations
    #Address 0x800 read value
    csrr x14, 0x800

    #Address 0x800 Write value 0x6de77b
    li x3, 0x6de77b
    csrw 0x800, x3

    #Address 0x800 read value
    csrr x14, 0x800

    #Unmapped address 0xda2 testing: random write/read operations
    #Address 0xda2 Write value 0x79e22156
    li x3, 0x79e22156
    csrw 0xda2, x3

    #Unmapped address 0xd2b testing: random write/read operations
    #Address 0xd2b Write value 0x3edaed18
    li x3, 0x3edaed18
    csrw 0xd2b, x3

    #Address 0xd2b Write value 0xde0063cb
    li x3, 0xde0063cb
    csrw 0xd2b, x3

    #Address 0xd2b Write value 0x98e28591
    li x3, 0x98e28591
    csrw 0xd2b, x3

    #Address 0xd2b Write value 0xd4dd6d93
    li x3, 0xd4dd6d93
    csrw 0xd2b, x3

    #Unmapped address 0xfce testing: random write/read operations
    #Address 0xfce Write value 0x5a817009
    li x3, 0x5a817009
    csrw 0xfce, x3

    #Address 0xfce read value
    csrr x14, 0xfce

    #Unmapped address 0x646 testing: random write/read operations
    #Address 0x646 Write value 0x9f060f42
    li x3, 0x9f060f42
    csrw 0x646, x3

    #Address 0x646 Write value 0x2a07f915
    li x3, 0x2a07f915
    csrw 0x646, x3

    #Address 0x646 Write value 0x4ddfed73
    li x3, 0x4ddfed73
    csrw 0x646, x3

    #Address 0x646 Write value 0x8ac1b977
    li x3, 0x8ac1b977
    csrw 0x646, x3

    #Unmapped address 0x392 testing: random write/read operations
    #Address 0x392 read value
    csrr x14, 0x392

    #Address 0x392 read value
    csrr x14, 0x392

    #Address 0x392 Write value 0x9aa6504
    li x3, 0x9aa6504
    csrw 0x392, x3

    #Address 0x392 Write value 0x7a72341e
    li x3, 0x7a72341e
    csrw 0x392, x3

    #Unmapped address 0x14d testing: random write/read operations
    #Address 0x14d Write value 0xa76748c4
    li x3, 0xa76748c4
    csrw 0x14d, x3

    #Address 0x14d Write value 0x2d3178cf
    li x3, 0x2d3178cf
    csrw 0x14d, x3

    #Address 0x14d Write value 0xcb960fe7
    li x3, 0xcb960fe7
    csrw 0x14d, x3

    #Address 0x14d Write value 0xe97e3114
    li x3, 0xe97e3114
    csrw 0x14d, x3

    #Address 0x14d Write value 0x69e7d56d
    li x3, 0x69e7d56d
    csrw 0x14d, x3

    #Unmapped address 0xcf0 testing: random write/read operations
    #Address 0xcf0 read value
    csrr x14, 0xcf0

    #Address 0xcf0 read value
    csrr x14, 0xcf0

    #Address 0xcf0 Write value 0xe597f4db
    li x3, 0xe597f4db
    csrw 0xcf0, x3

    #Unmapped address 0xa12 testing: random write/read operations
    #Address 0xa12 read value
    csrr x14, 0xa12

    #Unmapped address 0x52c testing: random write/read operations
    #Address 0x52c read value
    csrr x14, 0x52c

    #Unmapped address 0xe1a testing: random write/read operations
    #Address 0xe1a Write value 0x87fb41f0
    li x3, 0x87fb41f0
    csrw 0xe1a, x3

    #Unmapped address 0xd69 testing: random write/read operations
    #Address 0xd69 Write value 0x9f529bf4
    li x3, 0x9f529bf4
    csrw 0xd69, x3

    #Address 0xd69 Write value 0x8be7d2c0
    li x3, 0x8be7d2c0
    csrw 0xd69, x3

    #Address 0xd69 Write value 0xd19bafa4
    li x3, 0xd19bafa4
    csrw 0xd69, x3

    #Address 0xd69 Write value 0x757df763
    li x3, 0x757df763
    csrw 0xd69, x3

    #Address 0xd69 read value
    csrr x14, 0xd69

    #Unmapped address 0x7da testing: random write/read operations
    #Address 0x7da Write value 0xa0e147df
    li x3, 0xa0e147df
    csrw 0x7da, x3

    #Address 0x7da Write value 0x1fd140a
    li x3, 0x1fd140a
    csrw 0x7da, x3

    #Unmapped address 0x2ac testing: random write/read operations
    #Address 0x2ac read value
    csrr x14, 0x2ac

    #Address 0x2ac Write value 0xd5a2c33b
    li x3, 0xd5a2c33b
    csrw 0x2ac, x3

    #Unmapped address 0x357 testing: random write/read operations
    #Address 0x357 Write value 0x4bbae4ff
    li x3, 0x4bbae4ff
    csrw 0x357, x3

    #Address 0x357 Write value 0x2ff86b2d
    li x3, 0x2ff86b2d
    csrw 0x357, x3

    #Address 0x357 read value
    csrr x14, 0x357

    #Address 0x357 read value
    csrr x14, 0x357

    #Address 0x357 read value
    csrr x14, 0x357

    #Unmapped address 0x10d testing: random write/read operations
    #Address 0x10d Write value 0xbca93fc9
    li x3, 0xbca93fc9
    csrw 0x10d, x3

    #Unmapped address 0x234 testing: random write/read operations
    #Address 0x234 read value
    csrr x14, 0x234

    #Address 0x234 read value
    csrr x14, 0x234

    #Address 0x234 Write value 0xf62abb7a
    li x3, 0xf62abb7a
    csrw 0x234, x3

    #Address 0x234 read value
    csrr x14, 0x234

    #Unmapped address 0x447 testing: random write/read operations
    #Address 0x447 read value
    csrr x14, 0x447

    #Unmapped address 0x577 testing: random write/read operations
    #Address 0x577 Write value 0xb9395f6
    li x3, 0xb9395f6
    csrw 0x577, x3

    #Address 0x577 read value
    csrr x14, 0x577

    #Address 0x577 read value
    csrr x14, 0x577

    #Unmapped address 0xffd testing: random write/read operations
    #Address 0xffd read value
    csrr x14, 0xffd

    #Unmapped address 0xe89 testing: random write/read operations
    #Address 0xe89 Write value 0x9e971df9
    li x3, 0x9e971df9
    csrw 0xe89, x3

    #Address 0xe89 read value
    csrr x14, 0xe89

    #Address 0xe89 read value
    csrr x14, 0xe89

    #Unmapped address 0x213 testing: random write/read operations
    #Address 0x213 Write value 0x9f6f0119
    li x3, 0x9f6f0119
    csrw 0x213, x3

    #Address 0x213 read value
    csrr x14, 0x213

    #Unmapped address 0x1bb testing: random write/read operations
    #Address 0x1bb Write value 0xba5d8e6
    li x3, 0xba5d8e6
    csrw 0x1bb, x3

    #Address 0x1bb read value
    csrr x14, 0x1bb

    #Unmapped address 0x71b testing: random write/read operations
    #Address 0x71b Write value 0x8584d97f
    li x3, 0x8584d97f
    csrw 0x71b, x3

    #Address 0x71b Write value 0xe2a9f88f
    li x3, 0xe2a9f88f
    csrw 0x71b, x3

    #Mapped address 0xb9e (mhpmcounterh30) testing: random write/read operations
    #Address 0xb9e Write value 0x3a021c94
    li x3, 0x3a021c94
    csrw 0xb9e, x3

    #Address 0xb9e Write value 0x422c2c05
    li x3, 0x422c2c05
    csrw 0xb9e, x3

    #Mapped address 0xb9b (mhpmcounterh27) testing: random write/read operations
    #Address 0xb9b Write value 0xf94f80a1
    li x3, 0xf94f80a1
    csrw 0xb9b, x3

    #Address 0xb9b Write value 0xc1be613e
    li x3, 0xc1be613e
    csrw 0xb9b, x3

    #Address 0xb9b read value
    csrr x14, 0xb9b

    #Address 0xb9b Write value 0x13e12046
    li x3, 0x13e12046
    csrw 0xb9b, x3

    #Unmapped address 0x729 testing: random write/read operations
    #Address 0x729 Write value 0x332f1799
    li x3, 0x332f1799
    csrw 0x729, x3

    #Address 0x729 read value
    csrr x14, 0x729

    #Address 0x729 Write value 0xbfc3268b
    li x3, 0xbfc3268b
    csrw 0x729, x3

    #Address 0x729 read value
    csrr x14, 0x729

    #Address 0x729 Write value 0xbd24d0d5
    li x3, 0xbd24d0d5
    csrw 0x729, x3

    #Unmapped address 0xdd1 testing: random write/read operations
    #Address 0xdd1 read value
    csrr x14, 0xdd1

    #Address 0xdd1 read value
    csrr x14, 0xdd1

    #Address 0xdd1 read value
    csrr x14, 0xdd1

    #Address 0xdd1 read value
    csrr x14, 0xdd1

    #Address 0xdd1 Write value 0x46576e3
    li x3, 0x46576e3
    csrw 0xdd1, x3

    #Unmapped address 0x179 testing: random write/read operations
    #Address 0x179 Write value 0xe053a05f
    li x3, 0xe053a05f
    csrw 0x179, x3

    #Unmapped address 0xbab testing: random write/read operations
    #Address 0xbab read value
    csrr x14, 0xbab

    #Address 0xbab read value
    csrr x14, 0xbab

    #Address 0xbab read value
    csrr x14, 0xbab

    #Unmapped address 0x18 testing: random write/read operations
    #Address 0x18 Write value 0xc0df24fc
    li x3, 0xc0df24fc
    csrw 0x18, x3

    #Address 0x18 Write value 0x1a273aef
    li x3, 0x1a273aef
    csrw 0x18, x3

    #Address 0x18 read value
    csrr x14, 0x18

    #Address 0x18 read value
    csrr x14, 0x18

    #Address 0x18 Write value 0x5596519c
    li x3, 0x5596519c
    csrw 0x18, x3

    #Unmapped address 0xc88 testing: random write/read operations
    #Address 0xc88 read value
    csrr x14, 0xc88

    #Address 0xc88 Write value 0xe52b1c9d
    li x3, 0xe52b1c9d
    csrw 0xc88, x3

    #Unmapped address 0x174 testing: random write/read operations
    #Address 0x174 read value
    csrr x14, 0x174

    #Address 0x174 read value
    csrr x14, 0x174

    #Unmapped address 0xffe testing: random write/read operations
    #Address 0xffe Write value 0xa42f182c
    li x3, 0xa42f182c
    csrw 0xffe, x3

    #Address 0xffe read value
    csrr x14, 0xffe

    #Address 0xffe read value
    csrr x14, 0xffe

    #Address 0xffe Write value 0xdc691031
    li x3, 0xdc691031
    csrw 0xffe, x3

    #Address 0xffe read value
    csrr x14, 0xffe

    #Unmapped address 0xcb9 testing: random write/read operations
    #Address 0xcb9 Write value 0xa9740e56
    li x3, 0xa9740e56
    csrw 0xcb9, x3

    #Unmapped address 0x1a8 testing: random write/read operations
    #Address 0x1a8 Write value 0x6b969589
    li x3, 0x6b969589
    csrw 0x1a8, x3

    #Unmapped address 0xe7f testing: random write/read operations
    #Address 0xe7f read value
    csrr x14, 0xe7f

    #Unmapped address 0xf6c testing: random write/read operations
    #Address 0xf6c read value
    csrr x14, 0xf6c

    #Address 0xf6c Write value 0x9a2d24fd
    li x3, 0x9a2d24fd
    csrw 0xf6c, x3

    #Address 0xf6c Write value 0x55a9239c
    li x3, 0x55a9239c
    csrw 0xf6c, x3

    #Address 0xf6c Write value 0x4fffda3
    li x3, 0x4fffda3
    csrw 0xf6c, x3

    #Address 0xf6c Write value 0x4cedc3ef
    li x3, 0x4cedc3ef
    csrw 0xf6c, x3

    #Unmapped address 0x549 testing: random write/read operations
    #Address 0x549 read value
    csrr x14, 0x549

    #Address 0x549 Write value 0xa31d7c08
    li x3, 0xa31d7c08
    csrw 0x549, x3

    #Address 0x549 read value
    csrr x14, 0x549

    #Address 0x549 Write value 0x1629071c
    li x3, 0x1629071c
    csrw 0x549, x3

    #Address 0x549 Write value 0x80e80b88
    li x3, 0x80e80b88
    csrw 0x549, x3

    #Unmapped address 0xd80 testing: random write/read operations
    #Address 0xd80 Write value 0x5e6f298b
    li x3, 0x5e6f298b
    csrw 0xd80, x3

    #Address 0xd80 Write value 0x74dd544c
    li x3, 0x74dd544c
    csrw 0xd80, x3

    #Address 0xd80 read value
    csrr x14, 0xd80

    #Address 0xd80 Write value 0x6fa1d534
    li x3, 0x6fa1d534
    csrw 0xd80, x3

    #Unmapped address 0x808 testing: random write/read operations
    #Address 0x808 Write value 0x1223af1d
    li x3, 0x1223af1d
    csrw 0x808, x3

    #Address 0x808 Write value 0x1dbbd869
    li x3, 0x1dbbd869
    csrw 0x808, x3

    #Address 0x808 Write value 0xf9625cdf
    li x3, 0xf9625cdf
    csrw 0x808, x3

    #Address 0x808 read value
    csrr x14, 0x808

    #Address 0x808 Write value 0x9eb6e31b
    li x3, 0x9eb6e31b
    csrw 0x808, x3

    #Unmapped address 0x64e testing: random write/read operations
    #Address 0x64e Write value 0x3554873a
    li x3, 0x3554873a
    csrw 0x64e, x3

    #Address 0x64e read value
    csrr x14, 0x64e

    #Unmapped address 0xf00 testing: random write/read operations
    #Address 0xf00 read value
    csrr x14, 0xf00

    #Address 0xf00 Write value 0xe94b93f4
    li x3, 0xe94b93f4
    csrw 0xf00, x3

    #Address 0xf00 read value
    csrr x14, 0xf00

    #Address 0xf00 read value
    csrr x14, 0xf00

    #Unmapped address 0xa9d testing: random write/read operations
    #Address 0xa9d read value
    csrr x14, 0xa9d

    #Address 0xa9d read value
    csrr x14, 0xa9d

    #Address 0xa9d Write value 0x717c317
    li x3, 0x717c317
    csrw 0xa9d, x3

    #Address 0xa9d Write value 0x5063d5e0
    li x3, 0x5063d5e0
    csrw 0xa9d, x3

    #Unmapped address 0x105 testing: random write/read operations
    #Address 0x105 Write value 0x4826b5db
    li x3, 0x4826b5db
    csrw 0x105, x3

    #Unmapped address 0x6db testing: random write/read operations
    #Address 0x6db Write value 0xf996ef3b
    li x3, 0xf996ef3b
    csrw 0x6db, x3

    #Address 0x6db Write value 0x120994c7
    li x3, 0x120994c7
    csrw 0x6db, x3

    #Address 0x6db Write value 0x197015ac
    li x3, 0x197015ac
    csrw 0x6db, x3

    #Unmapped address 0x1cc testing: random write/read operations
    #Address 0x1cc Write value 0xbcfee4fe
    li x3, 0xbcfee4fe
    csrw 0x1cc, x3

    #Address 0x1cc Write value 0x98c8688a
    li x3, 0x98c8688a
    csrw 0x1cc, x3

    #Address 0x1cc read value
    csrr x14, 0x1cc

    #Address 0x1cc Write value 0xd43ac263
    li x3, 0xd43ac263
    csrw 0x1cc, x3

    #Unmapped address 0xb9 testing: random write/read operations
    #Address 0xb9 Write value 0x3de9d9b7
    li x3, 0x3de9d9b7
    csrw 0xb9, x3

    #Address 0xb9 Write value 0x78900e80
    li x3, 0x78900e80
    csrw 0xb9, x3

    #Address 0xb9 Write value 0xe43d04f7
    li x3, 0xe43d04f7
    csrw 0xb9, x3

    #Unmapped address 0xe9 testing: random write/read operations
    #Address 0xe9 read value
    csrr x14, 0xe9

    #Address 0xe9 read value
    csrr x14, 0xe9

    #Address 0xe9 Write value 0xfc65b9d4
    li x3, 0xfc65b9d4
    csrw 0xe9, x3

    #Address 0xe9 read value
    csrr x14, 0xe9

    #Unmapped address 0x599 testing: random write/read operations
    #Address 0x599 read value
    csrr x14, 0x599

    #Address 0x599 Write value 0x9401f8a
    li x3, 0x9401f8a
    csrw 0x599, x3

    #Unmapped address 0x668 testing: random write/read operations
    #Address 0x668 Write value 0x869064c9
    li x3, 0x869064c9
    csrw 0x668, x3

    #Address 0x668 Write value 0x83ae367a
    li x3, 0x83ae367a
    csrw 0x668, x3

    #Address 0x668 Write value 0x7cb3bebd
    li x3, 0x7cb3bebd
    csrw 0x668, x3

    #Address 0x668 read value
    csrr x14, 0x668

    #Unmapped address 0x1a6 testing: random write/read operations
    #Address 0x1a6 read value
    csrr x14, 0x1a6

    #Address 0x1a6 Write value 0xfd4de7a3
    li x3, 0xfd4de7a3
    csrw 0x1a6, x3

    #Address 0x1a6 read value
    csrr x14, 0x1a6

    #Address 0x1a6 Write value 0x5c5e5237
    li x3, 0x5c5e5237
    csrw 0x1a6, x3

    #Address 0x1a6 read value
    csrr x14, 0x1a6

    #Unmapped address 0x567 testing: random write/read operations
    #Address 0x567 Write value 0x323e16a4
    li x3, 0x323e16a4
    csrw 0x567, x3

    #Address 0x567 Write value 0x97c82b47
    li x3, 0x97c82b47
    csrw 0x567, x3

    #Unmapped address 0x876 testing: random write/read operations
    #Address 0x876 read value
    csrr x14, 0x876

    #Address 0x876 Write value 0x78c9f7e1
    li x3, 0x78c9f7e1
    csrw 0x876, x3

    #Unmapped address 0x86d testing: random write/read operations
    #Address 0x86d read value
    csrr x14, 0x86d

    #Unmapped address 0x6ad testing: random write/read operations
    #Address 0x6ad Write value 0xf9e3c496
    li x3, 0xf9e3c496
    csrw 0x6ad, x3

    #Address 0x6ad read value
    csrr x14, 0x6ad

    #Address 0x6ad Write value 0xf9667544
    li x3, 0xf9667544
    csrw 0x6ad, x3

    #Unmapped address 0x1f testing: random write/read operations
    #Address 0x1f Write value 0xf4f63ac2
    li x3, 0xf4f63ac2
    csrw 0x1f, x3

    #Address 0x1f read value
    csrr x14, 0x1f

    #Address 0x1f Write value 0xc90c1c6b
    li x3, 0xc90c1c6b
    csrw 0x1f, x3

    #Address 0x1f read value
    csrr x14, 0x1f

    #Unmapped address 0x920 testing: random write/read operations
    #Address 0x920 read value
    csrr x14, 0x920

    #Address 0x920 Write value 0xf8564798
    li x3, 0xf8564798
    csrw 0x920, x3

    #Address 0x920 read value
    csrr x14, 0x920

    #Unmapped address 0xf8e testing: random write/read operations
    #Address 0xf8e Write value 0x8e927133
    li x3, 0x8e927133
    csrw 0xf8e, x3

    #Address 0xf8e Write value 0x6a5dab49
    li x3, 0x6a5dab49
    csrw 0xf8e, x3

    #Unmapped address 0x821 testing: random write/read operations
    #Address 0x821 read value
    csrr x14, 0x821

    #Address 0x821 Write value 0x96d65147
    li x3, 0x96d65147
    csrw 0x821, x3

    #Address 0x821 read value
    csrr x14, 0x821

    #Unmapped address 0x225 testing: random write/read operations
    #Address 0x225 read value
    csrr x14, 0x225

    #Unmapped address 0xab7 testing: random write/read operations
    #Address 0xab7 Write value 0x5da61ce8
    li x3, 0x5da61ce8
    csrw 0xab7, x3

    #Address 0xab7 Write value 0x65a64b3d
    li x3, 0x65a64b3d
    csrw 0xab7, x3

    #Unmapped address 0x45e testing: random write/read operations
    #Address 0x45e Write value 0xda5f995c
    li x3, 0xda5f995c
    csrw 0x45e, x3

    #Unmapped address 0x8aa testing: random write/read operations
    #Address 0x8aa read value
    csrr x14, 0x8aa

    #Address 0x8aa read value
    csrr x14, 0x8aa

    #Address 0x8aa Write value 0xcaf8bc9a
    li x3, 0xcaf8bc9a
    csrw 0x8aa, x3

    #Address 0x8aa Write value 0x4fb3535d
    li x3, 0x4fb3535d
    csrw 0x8aa, x3

    #Address 0x8aa Write value 0x6ac2fb69
    li x3, 0x6ac2fb69
    csrw 0x8aa, x3

    #Unmapped address 0xdd0 testing: random write/read operations
    #Address 0xdd0 Write value 0x5357b338
    li x3, 0x5357b338
    csrw 0xdd0, x3

    #Unmapped address 0x370 testing: random write/read operations
    #Address 0x370 Write value 0x33b8bf2c
    li x3, 0x33b8bf2c
    csrw 0x370, x3

    #Address 0x370 Write value 0x21646b8b
    li x3, 0x21646b8b
    csrw 0x370, x3

    #Unmapped address 0xf06 testing: random write/read operations
    #Address 0xf06 read value
    csrr x14, 0xf06

    #Address 0xf06 Write value 0x86f0d4a3
    li x3, 0x86f0d4a3
    csrw 0xf06, x3

    #Address 0xf06 read value
    csrr x14, 0xf06

    #Address 0xf06 read value
    csrr x14, 0xf06

    #Address 0xf06 read value
    csrr x14, 0xf06

    #Unmapped address 0x0 testing: random write/read operations
    #Address 0x0 read value
    csrr x14, 0x0

    #Address 0x0 read value
    csrr x14, 0x0

    #Address 0x0 read value
    csrr x14, 0x0

    #Address 0x0 Write value 0x4338b16e
    li x3, 0x4338b16e
    csrw 0x0, x3

    #Address 0x0 read value
    csrr x14, 0x0

    #Unmapped address 0xa82 testing: random write/read operations
    #Address 0xa82 Write value 0x9f255f8d
    li x3, 0x9f255f8d
    csrw 0xa82, x3

    #Address 0xa82 read value
    csrr x14, 0xa82

    #Unmapped address 0xe49 testing: random write/read operations
    #Address 0xe49 read value
    csrr x14, 0xe49

    #Address 0xe49 Write value 0x4cc497b1
    li x3, 0x4cc497b1
    csrw 0xe49, x3

    #Address 0xe49 read value
    csrr x14, 0xe49

    #Unmapped address 0xaa4 testing: random write/read operations
    #Address 0xaa4 Write value 0x59cba390
    li x3, 0x59cba390
    csrw 0xaa4, x3

    #Address 0xaa4 Write value 0x6852a133
    li x3, 0x6852a133
    csrw 0xaa4, x3

    #Unmapped address 0x9d5 testing: random write/read operations
    #Address 0x9d5 Write value 0x4e280712
    li x3, 0x4e280712
    csrw 0x9d5, x3

    #Address 0x9d5 read value
    csrr x14, 0x9d5

    #Address 0x9d5 read value
    csrr x14, 0x9d5

    #Address 0x9d5 Write value 0x66405d48
    li x3, 0x66405d48
    csrw 0x9d5, x3

    #Unmapped address 0x8ae testing: random write/read operations
    #Address 0x8ae Write value 0x3e229dae
    li x3, 0x3e229dae
    csrw 0x8ae, x3

    #Unmapped address 0x188 testing: random write/read operations
    #Address 0x188 Write value 0x5dad65d9
    li x3, 0x5dad65d9
    csrw 0x188, x3

    #Address 0x188 Write value 0xdc8a0858
    li x3, 0xdc8a0858
    csrw 0x188, x3

    #Address 0x188 Write value 0x9eb44872
    li x3, 0x9eb44872
    csrw 0x188, x3

    #Address 0x188 Write value 0x32a9a029
    li x3, 0x32a9a029
    csrw 0x188, x3

    #Address 0x188 read value
    csrr x14, 0x188

    #Unmapped address 0x4a1 testing: random write/read operations
    #Address 0x4a1 read value
    csrr x14, 0x4a1

    #Address 0x4a1 read value
    csrr x14, 0x4a1

    #Address 0x4a1 read value
    csrr x14, 0x4a1

    #Address 0x4a1 read value
    csrr x14, 0x4a1

    #Unmapped address 0x85 testing: random write/read operations
    #Address 0x85 Write value 0xe9f36588
    li x3, 0xe9f36588
    csrw 0x85, x3

    #Address 0x85 Write value 0xe1618ae4
    li x3, 0xe1618ae4
    csrw 0x85, x3

    #Mapped address 0x3be (pmpaddr14) testing: random write/read operations
    #Address 0x3be Write value 0x5221c713
    li x3, 0x5221c713
    csrw 0x3be, x3

    #Address 0x3be read value
    csrr x14, 0x3be

    #Address 0x3be Write value 0x69005a0b
    li x3, 0x69005a0b
    csrw 0x3be, x3

    #Address 0x3be read value
    csrr x14, 0x3be

    #Unmapped address 0x5d8 testing: random write/read operations
    #Address 0x5d8 read value
    csrr x14, 0x5d8

    #Unmapped address 0x744 testing: random write/read operations
    #Address 0x744 Write value 0x5156859
    li x3, 0x5156859
    csrw 0x744, x3

    #Unmapped address 0x231 testing: random write/read operations
    #Address 0x231 read value
    csrr x14, 0x231

    #Address 0x231 Write value 0x8047f567
    li x3, 0x8047f567
    csrw 0x231, x3

    #Unmapped address 0x461 testing: random write/read operations
    #Address 0x461 read value
    csrr x14, 0x461

    #Unmapped address 0xc97 testing: random write/read operations
    #Address 0xc97 read value
    csrr x14, 0xc97

    #Address 0xc97 read value
    csrr x14, 0xc97

    #Address 0xc97 Write value 0x5742955c
    li x3, 0x5742955c
    csrw 0xc97, x3

    #Address 0xc97 read value
    csrr x14, 0xc97

    #Address 0xc97 Write value 0xbdb719f7
    li x3, 0xbdb719f7
    csrw 0xc97, x3

    #Unmapped address 0xb65 testing: random write/read operations
    #Address 0xb65 Write value 0xd6327b78
    li x3, 0xd6327b78
    csrw 0xb65, x3

    #Address 0xb65 Write value 0xdd28a039
    li x3, 0xdd28a039
    csrw 0xb65, x3

    #Address 0xb65 read value
    csrr x14, 0xb65

    #Unmapped address 0x8 testing: random write/read operations
    #Address 0x8 read value
    csrr x14, 0x8

    #Address 0x8 Write value 0xe1a3a800
    li x3, 0xe1a3a800
    csrw 0x8, x3

    #Address 0x8 Write value 0xe842792f
    li x3, 0xe842792f
    csrw 0x8, x3

    #Address 0x8 read value
    csrr x14, 0x8

    #Address 0x8 Write value 0x1961021e
    li x3, 0x1961021e
    csrw 0x8, x3

    #Unmapped address 0xd4d testing: random write/read operations
    #Address 0xd4d Write value 0x1182ad2a
    li x3, 0x1182ad2a
    csrw 0xd4d, x3

    #Address 0xd4d read value
    csrr x14, 0xd4d

    #Address 0xd4d read value
    csrr x14, 0xd4d

    #Address 0xd4d Write value 0xe5a00ba6
    li x3, 0xe5a00ba6
    csrw 0xd4d, x3

    #Unmapped address 0x5eb testing: random write/read operations
    #Address 0x5eb Write value 0x37e9c147
    li x3, 0x37e9c147
    csrw 0x5eb, x3

    #Address 0x5eb read value
    csrr x14, 0x5eb

    #Address 0x5eb Write value 0x23da723e
    li x3, 0x23da723e
    csrw 0x5eb, x3

    #Unmapped address 0x60e testing: random write/read operations
    #Address 0x60e read value
    csrr x14, 0x60e

    #Address 0x60e Write value 0x3ac354cd
    li x3, 0x3ac354cd
    csrw 0x60e, x3

    #Address 0x60e read value
    csrr x14, 0x60e

    #Unmapped address 0xd14 testing: random write/read operations
    #Address 0xd14 read value
    csrr x14, 0xd14

    #Unmapped address 0x590 testing: random write/read operations
    #Address 0x590 read value
    csrr x14, 0x590

    #Unmapped address 0xfde testing: random write/read operations
    #Address 0xfde read value
    csrr x14, 0xfde

    #Address 0xfde Write value 0x891f2112
    li x3, 0x891f2112
    csrw 0xfde, x3

    #Unmapped address 0x710 testing: random write/read operations
    #Address 0x710 read value
    csrr x14, 0x710

    #Address 0x710 Write value 0x260dbf99
    li x3, 0x260dbf99
    csrw 0x710, x3

    #Address 0x710 read value
    csrr x14, 0x710

    #Address 0x710 read value
    csrr x14, 0x710

    #Address 0x710 read value
    csrr x14, 0x710

    #Unmapped address 0x4c testing: random write/read operations
    #Address 0x4c Write value 0xdddd8e61
    li x3, 0xdddd8e61
    csrw 0x4c, x3

    #Address 0x4c Write value 0xe405ec67
    li x3, 0xe405ec67
    csrw 0x4c, x3

    #Address 0x4c read value
    csrr x14, 0x4c

    #Unmapped address 0x980 testing: random write/read operations
    #Address 0x980 read value
    csrr x14, 0x980

    #Address 0x980 Write value 0x7ef84226
    li x3, 0x7ef84226
    csrw 0x980, x3

    #Address 0x980 Write value 0xd56854a5
    li x3, 0xd56854a5
    csrw 0x980, x3

    #Address 0x980 Write value 0xd5c0435e
    li x3, 0xd5c0435e
    csrw 0x980, x3

    #Unmapped address 0x298 testing: random write/read operations
    #Address 0x298 Write value 0x2454971e
    li x3, 0x2454971e
    csrw 0x298, x3

    #Address 0x298 read value
    csrr x14, 0x298

    #Unmapped address 0xa8c testing: random write/read operations
    #Address 0xa8c Write value 0x648f3c9b
    li x3, 0x648f3c9b
    csrw 0xa8c, x3

    #Address 0xa8c read value
    csrr x14, 0xa8c

    #Unmapped address 0xa7b testing: random write/read operations
    #Address 0xa7b Write value 0xc2282e34
    li x3, 0xc2282e34
    csrw 0xa7b, x3

    #Address 0xa7b Write value 0x52128777
    li x3, 0x52128777
    csrw 0xa7b, x3

    #Unmapped address 0x924 testing: random write/read operations
    #Address 0x924 read value
    csrr x14, 0x924

    #Address 0x924 Write value 0x6ae684a0
    li x3, 0x6ae684a0
    csrw 0x924, x3

    #Address 0x924 read value
    csrr x14, 0x924

    #Address 0x924 Write value 0x238c52a3
    li x3, 0x238c52a3
    csrw 0x924, x3

    #Unmapped address 0x48f testing: random write/read operations
    #Address 0x48f Write value 0xba02ab12
    li x3, 0xba02ab12
    csrw 0x48f, x3

    #Address 0x48f Write value 0xc27da587
    li x3, 0xc27da587
    csrw 0x48f, x3

    #Address 0x48f Write value 0x9cb89010
    li x3, 0x9cb89010
    csrw 0x48f, x3

    #Address 0x48f read value
    csrr x14, 0x48f

    #Address 0x48f Write value 0x2601f724
    li x3, 0x2601f724
    csrw 0x48f, x3

    #Unmapped address 0x7cf testing: random write/read operations
    #Address 0x7cf read value
    csrr x14, 0x7cf

    #Address 0x7cf read value
    csrr x14, 0x7cf

    #Address 0x7cf Write value 0x64a22e7e
    li x3, 0x64a22e7e
    csrw 0x7cf, x3

    #Unmapped address 0xc69 testing: random write/read operations
    #Address 0xc69 Write value 0xb83657f3
    li x3, 0xb83657f3
    csrw 0xc69, x3

    #Address 0xc69 read value
    csrr x14, 0xc69

    #Unmapped address 0xcd testing: random write/read operations
    #Address 0xcd read value
    csrr x14, 0xcd

    #Address 0xcd read value
    csrr x14, 0xcd

    #Address 0xcd read value
    csrr x14, 0xcd

    #Unmapped address 0xea3 testing: random write/read operations
    #Address 0xea3 Write value 0x3c56f5bf
    li x3, 0x3c56f5bf
    csrw 0xea3, x3

    #Address 0xea3 Write value 0xef81a18
    li x3, 0xef81a18
    csrw 0xea3, x3

    #Address 0xea3 read value
    csrr x14, 0xea3

    #Address 0xea3 read value
    csrr x14, 0xea3

    #Address 0xea3 read value
    csrr x14, 0xea3

    #Unmapped address 0xab6 testing: random write/read operations
    #Address 0xab6 read value
    csrr x14, 0xab6

    #Address 0xab6 read value
    csrr x14, 0xab6

    #Address 0xab6 read value
    csrr x14, 0xab6

    #Address 0xab6 read value
    csrr x14, 0xab6

    #Address 0xab6 Write value 0x72a0ec79
    li x3, 0x72a0ec79
    csrw 0xab6, x3

    #Unmapped address 0xac6 testing: random write/read operations
    #Address 0xac6 Write value 0x7cca884c
    li x3, 0x7cca884c
    csrw 0xac6, x3

    #Address 0xac6 read value
    csrr x14, 0xac6

    #Address 0xac6 read value
    csrr x14, 0xac6

    #Address 0xac6 read value
    csrr x14, 0xac6

    #Address 0xac6 read value
    csrr x14, 0xac6

    #Unmapped address 0x60f testing: random write/read operations
    #Address 0x60f read value
    csrr x14, 0x60f

    #Unmapped address 0x7c testing: random write/read operations
    #Address 0x7c Write value 0xb002c2aa
    li x3, 0xb002c2aa
    csrw 0x7c, x3

    #Address 0x7c read value
    csrr x14, 0x7c

    #Address 0x7c read value
    csrr x14, 0x7c

    #Unmapped address 0xd8b testing: random write/read operations
    #Address 0xd8b Write value 0x9468c1d
    li x3, 0x9468c1d
    csrw 0xd8b, x3

    #Address 0xd8b read value
    csrr x14, 0xd8b

    #Address 0xd8b read value
    csrr x14, 0xd8b

    #Unmapped address 0xdae testing: random write/read operations
    #Address 0xdae Write value 0x32f48d5b
    li x3, 0x32f48d5b
    csrw 0xdae, x3

    #Address 0xdae Write value 0xfc686684
    li x3, 0xfc686684
    csrw 0xdae, x3

    #Address 0xdae read value
    csrr x14, 0xdae

    #Unmapped address 0x9ab testing: random write/read operations
    #Address 0x9ab read value
    csrr x14, 0x9ab

    #Address 0x9ab read value
    csrr x14, 0x9ab

    #Address 0x9ab Write value 0x226e4d2d
    li x3, 0x226e4d2d
    csrw 0x9ab, x3

    #Address 0x9ab read value
    csrr x14, 0x9ab

    #Unmapped address 0x24f testing: random write/read operations
    #Address 0x24f Write value 0x92059ec7
    li x3, 0x92059ec7
    csrw 0x24f, x3

    #Address 0x24f read value
    csrr x14, 0x24f

    #Address 0x24f read value
    csrr x14, 0x24f

    #Address 0x24f Write value 0x339f1b46
    li x3, 0x339f1b46
    csrw 0x24f, x3

    #Unmapped address 0xb69 testing: random write/read operations
    #Address 0xb69 Write value 0x9dbfaa72
    li x3, 0x9dbfaa72
    csrw 0xb69, x3

    #Unmapped address 0x204 testing: random write/read operations
    #Address 0x204 read value
    csrr x14, 0x204

    #Address 0x204 Write value 0x81be632a
    li x3, 0x81be632a
    csrw 0x204, x3

    #Address 0x204 read value
    csrr x14, 0x204

    #Address 0x204 Write value 0x5a3e9512
    li x3, 0x5a3e9512
    csrw 0x204, x3

    #Unmapped address 0xc31 testing: random write/read operations
    #Address 0xc31 Write value 0x4940bf4a
    li x3, 0x4940bf4a
    csrw 0xc31, x3

    #Address 0xc31 Write value 0x4f013a4d
    li x3, 0x4f013a4d
    csrw 0xc31, x3

    #Address 0xc31 read value
    csrr x14, 0xc31

    #Unmapped address 0x1d6 testing: random write/read operations
    #Address 0x1d6 Write value 0xcc992a17
    li x3, 0xcc992a17
    csrw 0x1d6, x3

    #Address 0x1d6 Write value 0xc3bd51de
    li x3, 0xc3bd51de
    csrw 0x1d6, x3

    #Address 0x1d6 read value
    csrr x14, 0x1d6

    #Unmapped address 0x189 testing: random write/read operations
    #Address 0x189 Write value 0x58d9a5a0
    li x3, 0x58d9a5a0
    csrw 0x189, x3

    #Address 0x189 Write value 0xedfb14a
    li x3, 0xedfb14a
    csrw 0x189, x3

    #Address 0x189 read value
    csrr x14, 0x189

    #Unmapped address 0x7c7 testing: random write/read operations
    #Address 0x7c7 read value
    csrr x14, 0x7c7

    #Address 0x7c7 Write value 0x91903e52
    li x3, 0x91903e52
    csrw 0x7c7, x3

    #Address 0x7c7 Write value 0xce6e4397
    li x3, 0xce6e4397
    csrw 0x7c7, x3

    #Address 0x7c7 read value
    csrr x14, 0x7c7

    #Address 0x7c7 Write value 0x3f8a6c14
    li x3, 0x3f8a6c14
    csrw 0x7c7, x3

    #Unmapped address 0xb67 testing: random write/read operations
    #Address 0xb67 read value
    csrr x14, 0xb67

    #Address 0xb67 read value
    csrr x14, 0xb67

    #Unmapped address 0x93 testing: random write/read operations
    #Address 0x93 Write value 0xd50edfaa
    li x3, 0xd50edfaa
    csrw 0x93, x3

    #Address 0x93 read value
    csrr x14, 0x93

    #Address 0x93 Write value 0xc353231e
    li x3, 0xc353231e
    csrw 0x93, x3

    #Address 0x93 Write value 0xd3bf5e90
    li x3, 0xd3bf5e90
    csrw 0x93, x3

    #Address 0x93 Write value 0xcbe44dd8
    li x3, 0xcbe44dd8
    csrw 0x93, x3

    #Unmapped address 0xf71 testing: random write/read operations
    #Address 0xf71 Write value 0xfa5514fe
    li x3, 0xfa5514fe
    csrw 0xf71, x3

    #Address 0xf71 read value
    csrr x14, 0xf71

    #Address 0xf71 read value
    csrr x14, 0xf71

    #Address 0xf71 read value
    csrr x14, 0xf71

    #Address 0xf71 Write value 0xd4c261ee
    li x3, 0xd4c261ee
    csrw 0xf71, x3

    #Unmapped address 0xf86 testing: random write/read operations
    #Address 0xf86 read value
    csrr x14, 0xf86

    #Address 0xf86 Write value 0xa54096a9
    li x3, 0xa54096a9
    csrw 0xf86, x3

    #Address 0xf86 read value
    csrr x14, 0xf86

    #Unmapped address 0x18d testing: random write/read operations
    #Address 0x18d read value
    csrr x14, 0x18d

    #Address 0x18d Write value 0xda0ac5de
    li x3, 0xda0ac5de
    csrw 0x18d, x3

    #Address 0x18d read value
    csrr x14, 0x18d

    #Address 0x18d read value
    csrr x14, 0x18d

    #Unmapped address 0xd31 testing: random write/read operations
    #Address 0xd31 Write value 0x83754fe
    li x3, 0x83754fe
    csrw 0xd31, x3

    #Address 0xd31 Write value 0x83cc2613
    li x3, 0x83cc2613
    csrw 0xd31, x3

    #Unmapped address 0xf8a testing: random write/read operations
    #Address 0xf8a Write value 0x56057b52
    li x3, 0x56057b52
    csrw 0xf8a, x3

    #Address 0xf8a Write value 0x27589c0f
    li x3, 0x27589c0f
    csrw 0xf8a, x3

    #Address 0xf8a Write value 0x585cf702
    li x3, 0x585cf702
    csrw 0xf8a, x3

    #Unmapped address 0x2f6 testing: random write/read operations
    #Address 0x2f6 read value
    csrr x14, 0x2f6

    #Address 0x2f6 Write value 0x49232c37
    li x3, 0x49232c37
    csrw 0x2f6, x3

    #Address 0x2f6 read value
    csrr x14, 0x2f6

    #Address 0x2f6 Write value 0x7de616cb
    li x3, 0x7de616cb
    csrw 0x2f6, x3

    #Address 0x2f6 Write value 0x7973052e
    li x3, 0x7973052e
    csrw 0x2f6, x3

    #Unmapped address 0x257 testing: random write/read operations
    #Address 0x257 read value
    csrr x14, 0x257

    #Address 0x257 Write value 0x718a0f52
    li x3, 0x718a0f52
    csrw 0x257, x3

    #Address 0x257 read value
    csrr x14, 0x257

    #Address 0x257 read value
    csrr x14, 0x257

    #Unmapped address 0x293 testing: random write/read operations
    #Address 0x293 read value
    csrr x14, 0x293

    #Address 0x293 read value
    csrr x14, 0x293

    #Unmapped address 0x8a testing: random write/read operations
    #Address 0x8a Write value 0x33769da9
    li x3, 0x33769da9
    csrw 0x8a, x3

    #Address 0x8a Write value 0x23016a43
    li x3, 0x23016a43
    csrw 0x8a, x3

    #Address 0x8a read value
    csrr x14, 0x8a

    #Address 0x8a read value
    csrr x14, 0x8a

    #Unmapped address 0xa13 testing: random write/read operations
    #Address 0xa13 read value
    csrr x14, 0xa13

    #Unmapped address 0x109 testing: random write/read operations
    #Address 0x109 read value
    csrr x14, 0x109

    #Address 0x109 Write value 0x49b0bf20
    li x3, 0x49b0bf20
    csrw 0x109, x3

    #Address 0x109 read value
    csrr x14, 0x109

    #Address 0x109 read value
    csrr x14, 0x109

    #Address 0x109 Write value 0x2cfc0a
    li x3, 0x2cfc0a
    csrw 0x109, x3

    #Unmapped address 0xa3b testing: random write/read operations
    #Address 0xa3b Write value 0x34913adf
    li x3, 0x34913adf
    csrw 0xa3b, x3

    #Address 0xa3b read value
    csrr x14, 0xa3b

    #Mapped address 0x343 (mtval) testing: random write/read operations
    #Address 0x343 Write value 0x3b0aba1d
    li x3, 0x3b0aba1d
    csrw 0x343, x3

    #Address 0x343 read value
    csrr x14, 0x343

    #Address 0x343 read value
    csrr x14, 0x343

    #Address 0x343 read value
    csrr x14, 0x343

    #Address 0x343 read value
    csrr x14, 0x343

    #Unmapped address 0x4ba testing: random write/read operations
    #Address 0x4ba read value
    csrr x14, 0x4ba

    #Address 0x4ba read value
    csrr x14, 0x4ba

    #Address 0x4ba read value
    csrr x14, 0x4ba

    #Unmapped address 0x617 testing: random write/read operations
    #Address 0x617 Write value 0x77c35593
    li x3, 0x77c35593
    csrw 0x617, x3

    #Address 0x617 Write value 0x24d7cdfb
    li x3, 0x24d7cdfb
    csrw 0x617, x3

    #Address 0x617 read value
    csrr x14, 0x617

    #Address 0x617 read value
    csrr x14, 0x617

    #Unmapped address 0xa05 testing: random write/read operations
    #Address 0xa05 Write value 0x2aa8bfe6
    li x3, 0x2aa8bfe6
    csrw 0xa05, x3

    #Address 0xa05 Write value 0xd764d085
    li x3, 0xd764d085
    csrw 0xa05, x3

    #Address 0xa05 Write value 0xb53ea20f
    li x3, 0xb53ea20f
    csrw 0xa05, x3

    #Address 0xa05 read value
    csrr x14, 0xa05

    #Unmapped address 0x5ee testing: random write/read operations
    #Address 0x5ee read value
    csrr x14, 0x5ee

    #Address 0x5ee Write value 0x766fcace
    li x3, 0x766fcace
    csrw 0x5ee, x3

    #Address 0x5ee Write value 0x79362acd
    li x3, 0x79362acd
    csrw 0x5ee, x3

    #Address 0x5ee Write value 0x39440f86
    li x3, 0x39440f86
    csrw 0x5ee, x3

    #Address 0x5ee read value
    csrr x14, 0x5ee

    #Unmapped address 0x78d testing: random write/read operations
    #Address 0x78d Write value 0xc03a107a
    li x3, 0xc03a107a
    csrw 0x78d, x3

    #Address 0x78d read value
    csrr x14, 0x78d

    #Unmapped address 0x873 testing: random write/read operations
    #Address 0x873 Write value 0x15c50aab
    li x3, 0x15c50aab
    csrw 0x873, x3

    #Unmapped address 0x7d5 testing: random write/read operations
    #Address 0x7d5 Write value 0x19ba620c
    li x3, 0x19ba620c
    csrw 0x7d5, x3

    #Address 0x7d5 Write value 0xdfc5f9b8
    li x3, 0xdfc5f9b8
    csrw 0x7d5, x3

    #Unmapped address 0xd81 testing: random write/read operations
    #Address 0xd81 read value
    csrr x14, 0xd81

    #Address 0xd81 read value
    csrr x14, 0xd81

    #Address 0xd81 Write value 0xa7c443c9
    li x3, 0xa7c443c9
    csrw 0xd81, x3

    #Address 0xd81 read value
    csrr x14, 0xd81

    #Address 0xd81 Write value 0x5864c3dc
    li x3, 0x5864c3dc
    csrw 0xd81, x3

    #Unmapped address 0x80 testing: random write/read operations
    #Address 0x80 read value
    csrr x14, 0x80

    #Address 0x80 Write value 0x3c4d6490
    li x3, 0x3c4d6490
    csrw 0x80, x3

    #Unmapped address 0x878 testing: random write/read operations
    #Address 0x878 read value
    csrr x14, 0x878

    #Address 0x878 Write value 0x7d781e2d
    li x3, 0x7d781e2d
    csrw 0x878, x3

    #Address 0x878 read value
    csrr x14, 0x878

    #Address 0x878 read value
    csrr x14, 0x878

    #Address 0x878 Write value 0x489864a9
    li x3, 0x489864a9
    csrw 0x878, x3

    #Unmapped address 0x4ae testing: random write/read operations
    #Address 0x4ae read value
    csrr x14, 0x4ae

    #Address 0x4ae Write value 0x8d3615f3
    li x3, 0x8d3615f3
    csrw 0x4ae, x3

    #Address 0x4ae Write value 0x83a5cc6f
    li x3, 0x83a5cc6f
    csrw 0x4ae, x3

    #Unmapped address 0x7fc testing: random write/read operations
    #Address 0x7fc Write value 0xb07c3e9a
    li x3, 0xb07c3e9a
    csrw 0x7fc, x3

    #Address 0x7fc read value
    csrr x14, 0x7fc

    #Address 0x7fc Write value 0x34794c78
    li x3, 0x34794c78
    csrw 0x7fc, x3

    #Address 0x7fc read value
    csrr x14, 0x7fc

    #Address 0x7fc read value
    csrr x14, 0x7fc

    #Unmapped address 0xdad testing: random write/read operations
    #Address 0xdad read value
    csrr x14, 0xdad

    #Address 0xdad Write value 0x1e769bf8
    li x3, 0x1e769bf8
    csrw 0xdad, x3

    #Unmapped address 0x393 testing: random write/read operations
    #Address 0x393 Write value 0x310a4924
    li x3, 0x310a4924
    csrw 0x393, x3

    #Address 0x393 Write value 0xdd9d0eb9
    li x3, 0xdd9d0eb9
    csrw 0x393, x3

    #Address 0x393 Write value 0xf2eb66c0
    li x3, 0xf2eb66c0
    csrw 0x393, x3

    #Address 0x393 Write value 0xf753e936
    li x3, 0xf753e936
    csrw 0x393, x3

    #Unmapped address 0x8e4 testing: random write/read operations
    #Address 0x8e4 read value
    csrr x14, 0x8e4

    #Address 0x8e4 read value
    csrr x14, 0x8e4

    #Unmapped address 0xa00 testing: random write/read operations
    #Address 0xa00 Write value 0x13498cf0
    li x3, 0x13498cf0
    csrw 0xa00, x3

    #Address 0xa00 read value
    csrr x14, 0xa00

    #Address 0xa00 read value
    csrr x14, 0xa00

    #Address 0xa00 read value
    csrr x14, 0xa00

    #Unmapped address 0xd26 testing: random write/read operations
    #Address 0xd26 read value
    csrr x14, 0xd26

    #Unmapped address 0x891 testing: random write/read operations
    #Address 0x891 read value
    csrr x14, 0x891

    #Address 0x891 Write value 0x16776ead
    li x3, 0x16776ead
    csrw 0x891, x3

    #Address 0x891 read value
    csrr x14, 0x891

    #Address 0x891 read value
    csrr x14, 0x891

    #Unmapped address 0x1b4 testing: random write/read operations
    #Address 0x1b4 read value
    csrr x14, 0x1b4

    #Unmapped address 0x2b2 testing: random write/read operations
    #Address 0x2b2 Write value 0xf1f87fe5
    li x3, 0xf1f87fe5
    csrw 0x2b2, x3

    #Address 0x2b2 read value
    csrr x14, 0x2b2

    #Address 0x2b2 read value
    csrr x14, 0x2b2

    #Unmapped address 0xcd6 testing: random write/read operations
    #Address 0xcd6 read value
    csrr x14, 0xcd6

    #Unmapped address 0x6d7 testing: random write/read operations
    #Address 0x6d7 read value
    csrr x14, 0x6d7

    #Address 0x6d7 read value
    csrr x14, 0x6d7

    #Address 0x6d7 read value
    csrr x14, 0x6d7

    #Unmapped address 0x22f testing: random write/read operations
    #Address 0x22f read value
    csrr x14, 0x22f

    #Address 0x22f Write value 0xbc7ba093
    li x3, 0xbc7ba093
    csrw 0x22f, x3

    #Address 0x22f read value
    csrr x14, 0x22f

    #Unmapped address 0x761 testing: random write/read operations
    #Address 0x761 read value
    csrr x14, 0x761

    #Address 0x761 read value
    csrr x14, 0x761

    #Address 0x761 Write value 0x22111404
    li x3, 0x22111404
    csrw 0x761, x3

    #Unmapped address 0xfa7 testing: random write/read operations
    #Address 0xfa7 read value
    csrr x14, 0xfa7

    #Address 0xfa7 Write value 0x9704cf00
    li x3, 0x9704cf00
    csrw 0xfa7, x3

    #Unmapped address 0xab1 testing: random write/read operations
    #Address 0xab1 read value
    csrr x14, 0xab1

    #Unmapped address 0x59e testing: random write/read operations
    #Address 0x59e Write value 0x600f4a97
    li x3, 0x600f4a97
    csrw 0x59e, x3

    #Address 0x59e read value
    csrr x14, 0x59e

    #Unmapped address 0xee testing: random write/read operations
    #Address 0xee read value
    csrr x14, 0xee

    #Unmapped address 0xd68 testing: random write/read operations
    #Address 0xd68 read value
    csrr x14, 0xd68

    #Address 0xd68 read value
    csrr x14, 0xd68

    #Address 0xd68 read value
    csrr x14, 0xd68

    #Unmapped address 0xf33 testing: random write/read operations
    #Address 0xf33 read value
    csrr x14, 0xf33

    #Unmapped address 0x210 testing: random write/read operations
    #Address 0x210 read value
    csrr x14, 0x210

    #Unmapped address 0xd91 testing: random write/read operations
    #Address 0xd91 Write value 0x6d722fc8
    li x3, 0x6d722fc8
    csrw 0xd91, x3

    #Address 0xd91 Write value 0xf7a2ef1a
    li x3, 0xf7a2ef1a
    csrw 0xd91, x3

    #Address 0xd91 Write value 0x1a19c225
    li x3, 0x1a19c225
    csrw 0xd91, x3

    #Unmapped address 0x5e testing: random write/read operations
    #Address 0x5e Write value 0x29daad22
    li x3, 0x29daad22
    csrw 0x5e, x3

    #Address 0x5e Write value 0x26691adf
    li x3, 0x26691adf
    csrw 0x5e, x3

    #Address 0x5e Write value 0x331ebcd4
    li x3, 0x331ebcd4
    csrw 0x5e, x3

    #Address 0x5e read value
    csrr x14, 0x5e

    #Address 0x5e Write value 0xe9a9f77c
    li x3, 0xe9a9f77c
    csrw 0x5e, x3

    #Unmapped address 0xbb6 testing: random write/read operations
    #Address 0xbb6 read value
    csrr x14, 0xbb6

    #Unmapped address 0xe1d testing: random write/read operations
    #Address 0xe1d Write value 0xa52479b
    li x3, 0xa52479b
    csrw 0xe1d, x3

    #Unmapped address 0x205 testing: random write/read operations
    #Address 0x205 Write value 0x74f78114
    li x3, 0x74f78114
    csrw 0x205, x3

    #Address 0x205 Write value 0x8d748b76
    li x3, 0x8d748b76
    csrw 0x205, x3

    #Unmapped address 0x7ef testing: random write/read operations
    #Address 0x7ef read value
    csrr x14, 0x7ef

    #Address 0x7ef Write value 0x990473e2
    li x3, 0x990473e2
    csrw 0x7ef, x3

    #Unmapped address 0x8b8 testing: random write/read operations
    #Address 0x8b8 read value
    csrr x14, 0x8b8

    #Mapped address 0xb8e (mhpmcounterh14) testing: random write/read operations
    #Address 0xb8e Write value 0xa8415f87
    li x3, 0xa8415f87
    csrw 0xb8e, x3

    #Unmapped address 0x7b9 testing: random write/read operations
    #Address 0x7b9 read value
    csrr x14, 0x7b9

    #Unmapped address 0x7b5 testing: random write/read operations
    #Address 0x7b5 read value
    csrr x14, 0x7b5

    #Unmapped address 0x19f testing: random write/read operations
    #Address 0x19f read value
    csrr x14, 0x19f

    #Address 0x19f read value
    csrr x14, 0x19f

    #Address 0x19f Write value 0x289b2289
    li x3, 0x289b2289
    csrw 0x19f, x3

    #Address 0x19f read value
    csrr x14, 0x19f

    #Address 0x19f read value
    csrr x14, 0x19f

    #Unmapped address 0x28 testing: random write/read operations
    #Address 0x28 Write value 0x48b98ec2
    li x3, 0x48b98ec2
    csrw 0x28, x3

    #Address 0x28 read value
    csrr x14, 0x28

    #Address 0x28 Write value 0xd79bd1dc
    li x3, 0xd79bd1dc
    csrw 0x28, x3

    #Address 0x28 Write value 0x86d05fd1
    li x3, 0x86d05fd1
    csrw 0x28, x3

    #Address 0x28 Write value 0x111f4392
    li x3, 0x111f4392
    csrw 0x28, x3

    #Unmapped address 0xa8a testing: random write/read operations
    #Address 0xa8a read value
    csrr x14, 0xa8a

    #Address 0xa8a Write value 0x822ca9cd
    li x3, 0x822ca9cd
    csrw 0xa8a, x3

    #Mapped address 0x3b2 (pmpaddr2) testing: random write/read operations
    #Address 0x3b2 read value
    csrr x14, 0x3b2

    #Mapped address 0x3a2 (pmpcfg2) testing: random write/read operations
    #Address 0x3a2 read value
    csrr x14, 0x3a2

    #Address 0x3a2 read value
    csrr x14, 0x3a2

    #Unmapped address 0x21b testing: random write/read operations
    #Address 0x21b Write value 0xc8c6620e
    li x3, 0xc8c6620e
    csrw 0x21b, x3

    #Address 0x21b Write value 0x73bd62e4
    li x3, 0x73bd62e4
    csrw 0x21b, x3

    #Address 0x21b read value
    csrr x14, 0x21b

    #Address 0x21b read value
    csrr x14, 0x21b

    #Address 0x21b read value
    csrr x14, 0x21b

    #Unmapped address 0xda8 testing: random write/read operations
    #Address 0xda8 read value
    csrr x14, 0xda8

    #Address 0xda8 read value
    csrr x14, 0xda8

    #Address 0xda8 read value
    csrr x14, 0xda8

    #Address 0xda8 Write value 0x630bbda6
    li x3, 0x630bbda6
    csrw 0xda8, x3

    #Unmapped address 0x4e9 testing: random write/read operations
    #Address 0x4e9 read value
    csrr x14, 0x4e9

    #Address 0x4e9 Write value 0x9d46b88a
    li x3, 0x9d46b88a
    csrw 0x4e9, x3

    #Address 0x4e9 read value
    csrr x14, 0x4e9

    #Address 0x4e9 read value
    csrr x14, 0x4e9

    #Address 0x4e9 read value
    csrr x14, 0x4e9

    #Unmapped address 0x96d testing: random write/read operations
    #Address 0x96d Write value 0xebd35c2f
    li x3, 0xebd35c2f
    csrw 0x96d, x3

    #Address 0x96d Write value 0x8b52f1b4
    li x3, 0x8b52f1b4
    csrw 0x96d, x3

    #Unmapped address 0x564 testing: random write/read operations
    #Address 0x564 Write value 0xe6f3ea92
    li x3, 0xe6f3ea92
    csrw 0x564, x3

    #Address 0x564 Write value 0x3452fc9f
    li x3, 0x3452fc9f
    csrw 0x564, x3

    #Address 0x564 Write value 0xdd0bb45c
    li x3, 0xdd0bb45c
    csrw 0x564, x3

    #Unmapped address 0x2d3 testing: random write/read operations
    #Address 0x2d3 read value
    csrr x14, 0x2d3

    #Mapped address 0xb8c (mhpmcounterh12) testing: random write/read operations
    #Address 0xb8c Write value 0x2852d012
    li x3, 0x2852d012
    csrw 0xb8c, x3

    #Address 0xb8c Write value 0x79c442bb
    li x3, 0x79c442bb
    csrw 0xb8c, x3

    #Address 0xb8c Write value 0x3415b78c
    li x3, 0x3415b78c
    csrw 0xb8c, x3

    #Address 0xb8c read value
    csrr x14, 0xb8c

    #Address 0xb8c read value
    csrr x14, 0xb8c

    #Unmapped address 0x914 testing: random write/read operations
    #Address 0x914 Write value 0xce5f39b1
    li x3, 0xce5f39b1
    csrw 0x914, x3

    #Address 0x914 read value
    csrr x14, 0x914

    #Address 0x914 Write value 0x8e988ef3
    li x3, 0x8e988ef3
    csrw 0x914, x3

    #Address 0x914 read value
    csrr x14, 0x914

    #Unmapped address 0x568 testing: random write/read operations
    #Address 0x568 Write value 0xbeafcfa6
    li x3, 0xbeafcfa6
    csrw 0x568, x3

    #Address 0x568 Write value 0xba3c8c29
    li x3, 0xba3c8c29
    csrw 0x568, x3

    #Address 0x568 read value
    csrr x14, 0x568

    #Unmapped address 0x3a4 testing: random write/read operations
    #Address 0x3a4 Write value 0x74084d54
    li x3, 0x74084d54
    csrw 0x3a4, x3

    #Address 0x3a4 Write value 0xa3f045e5
    li x3, 0xa3f045e5
    csrw 0x3a4, x3

    #Address 0x3a4 read value
    csrr x14, 0x3a4

    #Address 0x3a4 Write value 0x3039185a
    li x3, 0x3039185a
    csrw 0x3a4, x3

    #Unmapped address 0x445 testing: random write/read operations
    #Address 0x445 read value
    csrr x14, 0x445

    #Address 0x445 read value
    csrr x14, 0x445

    #Address 0x445 read value
    csrr x14, 0x445

    #Address 0x445 read value
    csrr x14, 0x445

    #Unmapped address 0xabc testing: random write/read operations
    #Address 0xabc read value
    csrr x14, 0xabc

    #Unmapped address 0x4de testing: random write/read operations
    #Address 0x4de read value
    csrr x14, 0x4de

    #Address 0x4de Write value 0xe041263e
    li x3, 0xe041263e
    csrw 0x4de, x3

    #Address 0x4de read value
    csrr x14, 0x4de

    #Address 0x4de Write value 0xb2e8b8b0
    li x3, 0xb2e8b8b0
    csrw 0x4de, x3

    #Address 0x4de Write value 0xe74ccbaf
    li x3, 0xe74ccbaf
    csrw 0x4de, x3

    #Unmapped address 0x239 testing: random write/read operations
    #Address 0x239 read value
    csrr x14, 0x239

    #Address 0x239 read value
    csrr x14, 0x239

    #Address 0x239 Write value 0xa25ab22
    li x3, 0xa25ab22
    csrw 0x239, x3

    #Unmapped address 0xcd2 testing: random write/read operations
    #Address 0xcd2 read value
    csrr x14, 0xcd2

    #Address 0xcd2 Write value 0xac1ad5f4
    li x3, 0xac1ad5f4
    csrw 0xcd2, x3

    #Address 0xcd2 read value
    csrr x14, 0xcd2

    #Address 0xcd2 read value
    csrr x14, 0xcd2

    #Address 0xcd2 Write value 0xba3aed7a
    li x3, 0xba3aed7a
    csrw 0xcd2, x3

    #Unmapped address 0x774 testing: random write/read operations
    #Address 0x774 Write value 0x18b4fa39
    li x3, 0x18b4fa39
    csrw 0x774, x3

    #Address 0x774 Write value 0x79725ae7
    li x3, 0x79725ae7
    csrw 0x774, x3

    #Address 0x774 Write value 0x5aa7415e
    li x3, 0x5aa7415e
    csrw 0x774, x3

    #Address 0x774 read value
    csrr x14, 0x774

    #Address 0x774 read value
    csrr x14, 0x774

    #Unmapped address 0x8c0 testing: random write/read operations
    #Address 0x8c0 read value
    csrr x14, 0x8c0

    #Address 0x8c0 Write value 0x6d5b4ece
    li x3, 0x6d5b4ece
    csrw 0x8c0, x3

    #Address 0x8c0 read value
    csrr x14, 0x8c0

    #Unmapped address 0xac7 testing: random write/read operations
    #Address 0xac7 Write value 0x789374ef
    li x3, 0x789374ef
    csrw 0xac7, x3

    #Unmapped address 0x270 testing: random write/read operations
    #Address 0x270 Write value 0x69dba203
    li x3, 0x69dba203
    csrw 0x270, x3

    #Address 0x270 Write value 0x49e8575a
    li x3, 0x49e8575a
    csrw 0x270, x3

    #Unmapped address 0xb24 testing: random write/read operations
    #Address 0xb24 read value
    csrr x14, 0xb24

    #Address 0xb24 read value
    csrr x14, 0xb24

    #Address 0xb24 read value
    csrr x14, 0xb24

    #Address 0xb24 read value
    csrr x14, 0xb24

    #Unmapped address 0x4f9 testing: random write/read operations
    #Address 0x4f9 read value
    csrr x14, 0x4f9

    #Address 0x4f9 Write value 0xbdc034f1
    li x3, 0xbdc034f1
    csrw 0x4f9, x3

    #Address 0x4f9 read value
    csrr x14, 0x4f9

    #Address 0x4f9 Write value 0x9997b27b
    li x3, 0x9997b27b
    csrw 0x4f9, x3

    #Unmapped address 0x926 testing: random write/read operations
    #Address 0x926 read value
    csrr x14, 0x926

    #Address 0x926 Write value 0x1c4409ba
    li x3, 0x1c4409ba
    csrw 0x926, x3

    #Address 0x926 read value
    csrr x14, 0x926

    #Address 0x926 Write value 0x855808f9
    li x3, 0x855808f9
    csrw 0x926, x3

    #Address 0x926 Write value 0x33a908b4
    li x3, 0x33a908b4
    csrw 0x926, x3

    #Unmapped address 0xc4e testing: random write/read operations
    #Address 0xc4e read value
    csrr x14, 0xc4e

    #Address 0xc4e read value
    csrr x14, 0xc4e

    #Unmapped address 0x9a4 testing: random write/read operations
    #Address 0x9a4 Write value 0xd41961de
    li x3, 0xd41961de
    csrw 0x9a4, x3

    #Address 0x9a4 Write value 0xae3a9bcc
    li x3, 0xae3a9bcc
    csrw 0x9a4, x3

    #Address 0x9a4 Write value 0xf8ba36d9
    li x3, 0xf8ba36d9
    csrw 0x9a4, x3

    #Unmapped address 0x6b8 testing: random write/read operations
    #Address 0x6b8 Write value 0x67654199
    li x3, 0x67654199
    csrw 0x6b8, x3

    #Address 0x6b8 Write value 0xca51366c
    li x3, 0xca51366c
    csrw 0x6b8, x3

    #Unmapped address 0x88f testing: random write/read operations
    #Address 0x88f read value
    csrr x14, 0x88f

    #Address 0x88f read value
    csrr x14, 0x88f

    #Address 0x88f Write value 0xbfcb6e6
    li x3, 0xbfcb6e6
    csrw 0x88f, x3

    #Address 0x88f read value
    csrr x14, 0x88f

    #Unmapped address 0x9d6 testing: random write/read operations
    #Address 0x9d6 read value
    csrr x14, 0x9d6

    #Address 0x9d6 Write value 0xc84eee5d
    li x3, 0xc84eee5d
    csrw 0x9d6, x3

    #Address 0x9d6 Write value 0xf7f2fb82
    li x3, 0xf7f2fb82
    csrw 0x9d6, x3

    #Address 0x9d6 read value
    csrr x14, 0x9d6

    #Address 0x9d6 Write value 0xad23d337
    li x3, 0xad23d337
    csrw 0x9d6, x3

    #Unmapped address 0xcf5 testing: random write/read operations
    #Address 0xcf5 Write value 0x9fc138c6
    li x3, 0x9fc138c6
    csrw 0xcf5, x3

    #Address 0xcf5 Write value 0xac23fd0
    li x3, 0xac23fd0
    csrw 0xcf5, x3

    #Address 0xcf5 read value
    csrr x14, 0xcf5

    #Address 0xcf5 Write value 0xdf8f1f69
    li x3, 0xdf8f1f69
    csrw 0xcf5, x3

    #Address 0xcf5 read value
    csrr x14, 0xcf5

    #Unmapped address 0x615 testing: random write/read operations
    #Address 0x615 read value
    csrr x14, 0x615

    #Address 0x615 read value
    csrr x14, 0x615

    #Unmapped address 0x915 testing: random write/read operations
    #Address 0x915 read value
    csrr x14, 0x915

    #Address 0x915 read value
    csrr x14, 0x915

    #Unmapped address 0x20b testing: random write/read operations
    #Address 0x20b read value
    csrr x14, 0x20b

    #Address 0x20b read value
    csrr x14, 0x20b

    #Address 0x20b Write value 0x23537d9c
    li x3, 0x23537d9c
    csrw 0x20b, x3

    #Address 0x20b read value
    csrr x14, 0x20b

    #Address 0x20b Write value 0xe65d7539
    li x3, 0xe65d7539
    csrw 0x20b, x3

    #Unmapped address 0x930 testing: random write/read operations
    #Address 0x930 read value
    csrr x14, 0x930

    #Address 0x930 read value
    csrr x14, 0x930

    #Address 0x930 Write value 0xff39199b
    li x3, 0xff39199b
    csrw 0x930, x3

    #Address 0x930 read value
    csrr x14, 0x930

    #Unmapped address 0xb testing: random write/read operations
    #Address 0xb Write value 0xc08e2c1e
    li x3, 0xc08e2c1e
    csrw 0xb, x3

    #Address 0xb Write value 0x941cc372
    li x3, 0x941cc372
    csrw 0xb, x3

    #Address 0xb Write value 0x33cf596d
    li x3, 0x33cf596d
    csrw 0xb, x3

    #Address 0xb read value
    csrr x14, 0xb

    #Address 0xb Write value 0xdbb75b2d
    li x3, 0xdbb75b2d
    csrw 0xb, x3

    #Unmapped address 0xa75 testing: random write/read operations
    #Address 0xa75 Write value 0x9ab58bb4
    li x3, 0x9ab58bb4
    csrw 0xa75, x3

    #Address 0xa75 Write value 0x2f03eeab
    li x3, 0x2f03eeab
    csrw 0xa75, x3

    #Address 0xa75 read value
    csrr x14, 0xa75

    #Address 0xa75 Write value 0x5d959acb
    li x3, 0x5d959acb
    csrw 0xa75, x3

    #Unmapped address 0xf1b testing: random write/read operations
    #Address 0xf1b Write value 0xd71d38d8
    li x3, 0xd71d38d8
    csrw 0xf1b, x3

    #Address 0xf1b Write value 0x82d06118
    li x3, 0x82d06118
    csrw 0xf1b, x3

    #Address 0xf1b Write value 0x2653eced
    li x3, 0x2653eced
    csrw 0xf1b, x3

    #Unmapped address 0x391 testing: random write/read operations
    #Address 0x391 Write value 0xf0e54e7b
    li x3, 0xf0e54e7b
    csrw 0x391, x3

    #Address 0x391 read value
    csrr x14, 0x391

    #Address 0x391 read value
    csrr x14, 0x391

    #Unmapped address 0xa0a testing: random write/read operations
    #Address 0xa0a Write value 0x15f48d05
    li x3, 0x15f48d05
    csrw 0xa0a, x3

    #Address 0xa0a Write value 0x6141afb
    li x3, 0x6141afb
    csrw 0xa0a, x3

    #Address 0xa0a read value
    csrr x14, 0xa0a

    #Address 0xa0a Write value 0x92faeee
    li x3, 0x92faeee
    csrw 0xa0a, x3

    #Address 0xa0a read value
    csrr x14, 0xa0a

    #Unmapped address 0x472 testing: random write/read operations
    #Address 0x472 read value
    csrr x14, 0x472

    #Address 0x472 Write value 0xf12acc12
    li x3, 0xf12acc12
    csrw 0x472, x3

    #Unmapped address 0x228 testing: random write/read operations
    #Address 0x228 read value
    csrr x14, 0x228

    #Address 0x228 Write value 0x16502ad0
    li x3, 0x16502ad0
    csrw 0x228, x3

    #Address 0x228 read value
    csrr x14, 0x228

    #Address 0x228 read value
    csrr x14, 0x228

    #Address 0x228 read value
    csrr x14, 0x228

    #Mapped address 0x331 (mhpmevent17) testing: random write/read operations
    #Address 0x331 Write value 0x40f6575d
    li x3, 0x40f6575d
    csrw 0x331, x3

    #Unmapped address 0x1fe testing: random write/read operations
    #Address 0x1fe Write value 0x386d1b87
    li x3, 0x386d1b87
    csrw 0x1fe, x3

    #Address 0x1fe Write value 0x4317f0
    li x3, 0x4317f0
    csrw 0x1fe, x3

    #Address 0x1fe Write value 0x115a121e
    li x3, 0x115a121e
    csrw 0x1fe, x3

    #Unmapped address 0xfca testing: random write/read operations
    #Address 0xfca Write value 0x4f2c7f86
    li x3, 0x4f2c7f86
    csrw 0xfca, x3

    #Address 0xfca read value
    csrr x14, 0xfca

    #Address 0xfca read value
    csrr x14, 0xfca

    #Address 0xfca Write value 0xa4c678fe
    li x3, 0xa4c678fe
    csrw 0xfca, x3

    #Unmapped address 0xae4 testing: random write/read operations
    #Address 0xae4 Write value 0xdd93ecda
    li x3, 0xdd93ecda
    csrw 0xae4, x3

    #Address 0xae4 read value
    csrr x14, 0xae4

    #Unmapped address 0x7ee testing: random write/read operations
    #Address 0x7ee read value
    csrr x14, 0x7ee

    #Address 0x7ee Write value 0x2d9a855a
    li x3, 0x2d9a855a
    csrw 0x7ee, x3

    #Address 0x7ee read value
    csrr x14, 0x7ee

    #Unmapped address 0x62e testing: random write/read operations
    #Address 0x62e Write value 0xa48828b8
    li x3, 0xa48828b8
    csrw 0x62e, x3

    #Unmapped address 0xd59 testing: random write/read operations
    #Address 0xd59 read value
    csrr x14, 0xd59

    #Address 0xd59 read value
    csrr x14, 0xd59

    #Unmapped address 0xcfc testing: random write/read operations
    #Address 0xcfc read value
    csrr x14, 0xcfc

    #Address 0xcfc read value
    csrr x14, 0xcfc

    #Unmapped address 0x5a0 testing: random write/read operations
    #Address 0x5a0 Write value 0x1cc82f42
    li x3, 0x1cc82f42
    csrw 0x5a0, x3

    #Address 0x5a0 read value
    csrr x14, 0x5a0

    #Unmapped address 0x985 testing: random write/read operations
    #Address 0x985 Write value 0xea335b2a
    li x3, 0xea335b2a
    csrw 0x985, x3

    #Address 0x985 read value
    csrr x14, 0x985

    #Address 0x985 read value
    csrr x14, 0x985

    #Address 0x985 Write value 0x955ece26
    li x3, 0x955ece26
    csrw 0x985, x3

    #Address 0x985 read value
    csrr x14, 0x985

    #Unmapped address 0xab8 testing: random write/read operations
    #Address 0xab8 read value
    csrr x14, 0xab8

    #Address 0xab8 read value
    csrr x14, 0xab8

    #Address 0xab8 Write value 0x878470bd
    li x3, 0x878470bd
    csrw 0xab8, x3

    #Address 0xab8 read value
    csrr x14, 0xab8

    #Unmapped address 0x8c1 testing: random write/read operations
    #Address 0x8c1 read value
    csrr x14, 0x8c1

    #Unmapped address 0x8a4 testing: random write/read operations
    #Address 0x8a4 Write value 0x610f9913
    li x3, 0x610f9913
    csrw 0x8a4, x3

    #Address 0x8a4 read value
    csrr x14, 0x8a4

    #Address 0x8a4 Write value 0xe78233c9
    li x3, 0xe78233c9
    csrw 0x8a4, x3

    #Unmapped address 0x21f testing: random write/read operations
    #Address 0x21f Write value 0x31f06714
    li x3, 0x31f06714
    csrw 0x21f, x3

    #Address 0x21f read value
    csrr x14, 0x21f

    #Unmapped address 0x5df testing: random write/read operations
    #Address 0x5df Write value 0xfeed35f6
    li x3, 0xfeed35f6
    csrw 0x5df, x3

    #Address 0x5df Write value 0xc7e9487a
    li x3, 0xc7e9487a
    csrw 0x5df, x3

    #Address 0x5df read value
    csrr x14, 0x5df

    #Address 0x5df read value
    csrr x14, 0x5df

    #Unmapped address 0x861 testing: random write/read operations
    #Address 0x861 read value
    csrr x14, 0x861

    #Unmapped address 0x6fd testing: random write/read operations
    #Address 0x6fd read value
    csrr x14, 0x6fd

    #Address 0x6fd read value
    csrr x14, 0x6fd

    #Address 0x6fd read value
    csrr x14, 0x6fd

    #Address 0x6fd Write value 0x485f656e
    li x3, 0x485f656e
    csrw 0x6fd, x3

    #Address 0x6fd Write value 0xce61a740
    li x3, 0xce61a740
    csrw 0x6fd, x3

    #Unmapped address 0xacb testing: random write/read operations
    #Address 0xacb Write value 0xd03a016
    li x3, 0xd03a016
    csrw 0xacb, x3

    #Address 0xacb read value
    csrr x14, 0xacb

    #Address 0xacb read value
    csrr x14, 0xacb

    #Address 0xacb read value
    csrr x14, 0xacb

    #Unmapped address 0x5ca testing: random write/read operations
    #Address 0x5ca read value
    csrr x14, 0x5ca

    #Address 0x5ca read value
    csrr x14, 0x5ca

    #Unmapped address 0xac1 testing: random write/read operations
    #Address 0xac1 read value
    csrr x14, 0xac1

    #Address 0xac1 Write value 0x7166a17
    li x3, 0x7166a17
    csrw 0xac1, x3

    #Address 0xac1 Write value 0xc3042f8f
    li x3, 0xc3042f8f
    csrw 0xac1, x3

    #Address 0xac1 Write value 0x321171f3
    li x3, 0x321171f3
    csrw 0xac1, x3

    #Unmapped address 0xa93 testing: random write/read operations
    #Address 0xa93 Write value 0xee4bec12
    li x3, 0xee4bec12
    csrw 0xa93, x3

    #Address 0xa93 read value
    csrr x14, 0xa93

    #Address 0xa93 read value
    csrr x14, 0xa93

    #Address 0xa93 read value
    csrr x14, 0xa93

    #Unmapped address 0xd42 testing: random write/read operations
    #Address 0xd42 Write value 0x4e0f666d
    li x3, 0x4e0f666d
    csrw 0xd42, x3

    #Address 0xd42 Write value 0x298fd605
    li x3, 0x298fd605
    csrw 0xd42, x3

    #Unmapped address 0x661 testing: random write/read operations
    #Address 0x661 read value
    csrr x14, 0x661

    #Address 0x661 read value
    csrr x14, 0x661

    #Address 0x661 Write value 0x705bb720
    li x3, 0x705bb720
    csrw 0x661, x3

    #Unmapped address 0xdcb testing: random write/read operations
    #Address 0xdcb Write value 0xb4a0117a
    li x3, 0xb4a0117a
    csrw 0xdcb, x3

    #Unmapped address 0xcba testing: random write/read operations
    #Address 0xcba read value
    csrr x14, 0xcba

    #Address 0xcba Write value 0xf40732ae
    li x3, 0xf40732ae
    csrw 0xcba, x3

    #Unmapped address 0xe6f testing: random write/read operations
    #Address 0xe6f read value
    csrr x14, 0xe6f

    #Address 0xe6f Write value 0x18470f84
    li x3, 0x18470f84
    csrw 0xe6f, x3

    #Unmapped address 0x359 testing: random write/read operations
    #Address 0x359 Write value 0x397a7136
    li x3, 0x397a7136
    csrw 0x359, x3

    #Unmapped address 0xedb testing: random write/read operations
    #Address 0xedb Write value 0xae99170d
    li x3, 0xae99170d
    csrw 0xedb, x3

    #Address 0xedb read value
    csrr x14, 0xedb

    #Address 0xedb read value
    csrr x14, 0xedb

    #Unmapped address 0x600 testing: random write/read operations
    #Address 0x600 read value
    csrr x14, 0x600

    #Address 0x600 Write value 0xce1cbb3
    li x3, 0xce1cbb3
    csrw 0x600, x3

    #Unmapped address 0xe04 testing: random write/read operations
    #Address 0xe04 Write value 0x9ef26d0a
    li x3, 0x9ef26d0a
    csrw 0xe04, x3

    #Address 0xe04 Write value 0xd17ce2e8
    li x3, 0xd17ce2e8
    csrw 0xe04, x3

    #Address 0xe04 read value
    csrr x14, 0xe04

    #Address 0xe04 read value
    csrr x14, 0xe04

    #Unmapped address 0xc1 testing: random write/read operations
    #Address 0xc1 read value
    csrr x14, 0xc1

    #Address 0xc1 Write value 0x2199698f
    li x3, 0x2199698f
    csrw 0xc1, x3

    #Address 0xc1 read value
    csrr x14, 0xc1

    #Address 0xc1 Write value 0x2ff7a92
    li x3, 0x2ff7a92
    csrw 0xc1, x3

    #Address 0xc1 Write value 0x7e6ef3ea
    li x3, 0x7e6ef3ea
    csrw 0xc1, x3

    #Unmapped address 0xfb7 testing: random write/read operations
    #Address 0xfb7 read value
    csrr x14, 0xfb7

    #Address 0xfb7 Write value 0x8da2eac
    li x3, 0x8da2eac
    csrw 0xfb7, x3

    #Address 0xfb7 read value
    csrr x14, 0xfb7

    #Address 0xfb7 read value
    csrr x14, 0xfb7

    #Unmapped address 0x320 testing: random write/read operations
    #Address 0x320 read value
    csrr x14, 0x320

    #Unmapped address 0x1e0 testing: random write/read operations
    #Address 0x1e0 Write value 0x9976d968
    li x3, 0x9976d968
    csrw 0x1e0, x3

    #Unmapped address 0x9e2 testing: random write/read operations
    #Address 0x9e2 Write value 0xbd6cdaec
    li x3, 0xbd6cdaec
    csrw 0x9e2, x3

    #Address 0x9e2 Write value 0x781456e5
    li x3, 0x781456e5
    csrw 0x9e2, x3

    #Unmapped address 0xbce testing: random write/read operations
    #Address 0xbce Write value 0x57fbcb38
    li x3, 0x57fbcb38
    csrw 0xbce, x3

    #Address 0xbce Write value 0xaf304f57
    li x3, 0xaf304f57
    csrw 0xbce, x3

    #Address 0xbce read value
    csrr x14, 0xbce

    #Address 0xbce read value
    csrr x14, 0xbce

    #Unmapped address 0xce4 testing: random write/read operations
    #Address 0xce4 Write value 0xd119572f
    li x3, 0xd119572f
    csrw 0xce4, x3

    #Address 0xce4 Write value 0x946d05e7
    li x3, 0x946d05e7
    csrw 0xce4, x3

    #Address 0xce4 read value
    csrr x14, 0xce4

    #Unmapped address 0x51b testing: random write/read operations
    #Address 0x51b Write value 0x4171aa9e
    li x3, 0x4171aa9e
    csrw 0x51b, x3

    #Unmapped address 0x71a testing: random write/read operations
    #Address 0x71a read value
    csrr x14, 0x71a

    #Address 0x71a Write value 0xe5e99b83
    li x3, 0xe5e99b83
    csrw 0x71a, x3

    #Address 0x71a read value
    csrr x14, 0x71a

    #Address 0x71a Write value 0xac37e579
    li x3, 0xac37e579
    csrw 0x71a, x3

    #Address 0x71a Write value 0x868d83f5
    li x3, 0x868d83f5
    csrw 0x71a, x3

    #Unmapped address 0x955 testing: random write/read operations
    #Address 0x955 Write value 0x2a7f36d2
    li x3, 0x2a7f36d2
    csrw 0x955, x3

    #Address 0x955 Write value 0x429cc2ac
    li x3, 0x429cc2ac
    csrw 0x955, x3

    #Address 0x955 Write value 0xaa06cb00
    li x3, 0xaa06cb00
    csrw 0x955, x3

    #Address 0x955 Write value 0x8d6b8796
    li x3, 0x8d6b8796
    csrw 0x955, x3

    #Unmapped address 0xa52 testing: random write/read operations
    #Address 0xa52 Write value 0xe4d6ee24
    li x3, 0xe4d6ee24
    csrw 0xa52, x3

    #Address 0xa52 Write value 0xd67e2c82
    li x3, 0xd67e2c82
    csrw 0xa52, x3

    #Address 0xa52 read value
    csrr x14, 0xa52

    #Unmapped address 0x5fb testing: random write/read operations
    #Address 0x5fb Write value 0xf422b134
    li x3, 0xf422b134
    csrw 0x5fb, x3

    #Address 0x5fb Write value 0xc52a743f
    li x3, 0xc52a743f
    csrw 0x5fb, x3

    #Address 0x5fb read value
    csrr x14, 0x5fb

    #Address 0x5fb read value
    csrr x14, 0x5fb

    #Address 0x5fb Write value 0x3493b78f
    li x3, 0x3493b78f
    csrw 0x5fb, x3

    #Unmapped address 0xed5 testing: random write/read operations
    #Address 0xed5 Write value 0x8647960c
    li x3, 0x8647960c
    csrw 0xed5, x3

    #Address 0xed5 read value
    csrr x14, 0xed5

    #Unmapped address 0xe14 testing: random write/read operations
    #Address 0xe14 read value
    csrr x14, 0xe14

    #Address 0xe14 read value
    csrr x14, 0xe14

    #Address 0xe14 read value
    csrr x14, 0xe14

    #Unmapped address 0x602 testing: random write/read operations
    #Address 0x602 Write value 0x6995d556
    li x3, 0x6995d556
    csrw 0x602, x3

    #Address 0x602 read value
    csrr x14, 0x602

    #Address 0x602 read value
    csrr x14, 0x602

    #Address 0x602 read value
    csrr x14, 0x602

    #Unmapped address 0xb6e testing: random write/read operations
    #Address 0xb6e Write value 0xb2aff0a5
    li x3, 0xb2aff0a5
    csrw 0xb6e, x3

    #Address 0xb6e Write value 0x7f2bbea0
    li x3, 0x7f2bbea0
    csrw 0xb6e, x3

    #Address 0xb6e Write value 0x2a7db170
    li x3, 0x2a7db170
    csrw 0xb6e, x3

    #Address 0xb6e read value
    csrr x14, 0xb6e

    #Address 0xb6e read value
    csrr x14, 0xb6e

    #Unmapped address 0x95e testing: random write/read operations
    #Address 0x95e Write value 0x52912379
    li x3, 0x52912379
    csrw 0x95e, x3

    #Unmapped address 0xde testing: random write/read operations
    #Address 0xde read value
    csrr x14, 0xde

    #Address 0xde read value
    csrr x14, 0xde

    #Address 0xde read value
    csrr x14, 0xde

    #Unmapped address 0x5ef testing: random write/read operations
    #Address 0x5ef Write value 0x5a2535b9
    li x3, 0x5a2535b9
    csrw 0x5ef, x3

    #Address 0x5ef read value
    csrr x14, 0x5ef

    #Address 0x5ef Write value 0x7af7362f
    li x3, 0x7af7362f
    csrw 0x5ef, x3

    #Unmapped address 0xc9f testing: random write/read operations
    #Address 0xc9f read value
    csrr x14, 0xc9f

    #Address 0xc9f read value
    csrr x14, 0xc9f

    #Address 0xc9f read value
    csrr x14, 0xc9f

    #Unmapped address 0x55b testing: random write/read operations
    #Address 0x55b Write value 0x22321dc6
    li x3, 0x22321dc6
    csrw 0x55b, x3

    #Address 0x55b Write value 0x4d366f24
    li x3, 0x4d366f24
    csrw 0x55b, x3

    #Address 0x55b Write value 0xc30ac98c
    li x3, 0xc30ac98c
    csrw 0x55b, x3

    #Unmapped address 0xbec testing: random write/read operations
    #Address 0xbec read value
    csrr x14, 0xbec

    #Address 0xbec read value
    csrr x14, 0xbec

    #Address 0xbec read value
    csrr x14, 0xbec

    #Address 0xbec read value
    csrr x14, 0xbec

    #Unmapped address 0xa18 testing: random write/read operations
    #Address 0xa18 Write value 0xfcfc0ced
    li x3, 0xfcfc0ced
    csrw 0xa18, x3

    #Address 0xa18 Write value 0x8e91d8d0
    li x3, 0x8e91d8d0
    csrw 0xa18, x3

    #Address 0xa18 read value
    csrr x14, 0xa18

    #Address 0xa18 read value
    csrr x14, 0xa18

    #Unmapped address 0x700 testing: random write/read operations
    #Address 0x700 Write value 0x15e04403
    li x3, 0x15e04403
    csrw 0x700, x3

    #Address 0x700 read value
    csrr x14, 0x700

    #Address 0x700 Write value 0xf7272853
    li x3, 0xf7272853
    csrw 0x700, x3

    #Unmapped address 0x816 testing: random write/read operations
    #Address 0x816 Write value 0x406d2fdf
    li x3, 0x406d2fdf
    csrw 0x816, x3

    #Address 0x816 Write value 0x7dc998b9
    li x3, 0x7dc998b9
    csrw 0x816, x3

    #Address 0x816 Write value 0x315d2cad
    li x3, 0x315d2cad
    csrw 0x816, x3

    #Address 0x816 read value
    csrr x14, 0x816

    #Unmapped address 0x56b testing: random write/read operations
    #Address 0x56b Write value 0xb86fe11a
    li x3, 0xb86fe11a
    csrw 0x56b, x3

    #Unmapped address 0x6c9 testing: random write/read operations
    #Address 0x6c9 Write value 0xc5b33055
    li x3, 0xc5b33055
    csrw 0x6c9, x3

    #Address 0x6c9 Write value 0x71e66910
    li x3, 0x71e66910
    csrw 0x6c9, x3

    #Unmapped address 0x538 testing: random write/read operations
    #Address 0x538 read value
    csrr x14, 0x538

    #Address 0x538 Write value 0xf70479e3
    li x3, 0xf70479e3
    csrw 0x538, x3

    #Unmapped address 0x756 testing: random write/read operations
    #Address 0x756 read value
    csrr x14, 0x756

    #Address 0x756 read value
    csrr x14, 0x756

    #Address 0x756 Write value 0x384bcc10
    li x3, 0x384bcc10
    csrw 0x756, x3

    #Unmapped address 0x6ee testing: random write/read operations
    #Address 0x6ee Write value 0x41cfaa1a
    li x3, 0x41cfaa1a
    csrw 0x6ee, x3

    #Address 0x6ee read value
    csrr x14, 0x6ee

    #Address 0x6ee read value
    csrr x14, 0x6ee

    #Address 0x6ee Write value 0x90532245
    li x3, 0x90532245
    csrw 0x6ee, x3

    #Unmapped address 0x695 testing: random write/read operations
    #Address 0x695 Write value 0xfb7b857a
    li x3, 0xfb7b857a
    csrw 0x695, x3

    #Address 0x695 Write value 0xd096e8f0
    li x3, 0xd096e8f0
    csrw 0x695, x3

    #Address 0x695 Write value 0x948c2d1
    li x3, 0x948c2d1
    csrw 0x695, x3

    #Unmapped address 0xada testing: random write/read operations
    #Address 0xada read value
    csrr x14, 0xada

    #Unmapped address 0x5b2 testing: random write/read operations
    #Address 0x5b2 Write value 0xcffe614
    li x3, 0xcffe614
    csrw 0x5b2, x3

    #Address 0x5b2 Write value 0x869eb4de
    li x3, 0x869eb4de
    csrw 0x5b2, x3

    #Address 0x5b2 read value
    csrr x14, 0x5b2

    #Unmapped address 0x973 testing: random write/read operations
    #Address 0x973 read value
    csrr x14, 0x973

    #Unmapped address 0xb77 testing: random write/read operations
    #Address 0xb77 Write value 0xec8a9398
    li x3, 0xec8a9398
    csrw 0xb77, x3

    #Unmapped address 0x284 testing: random write/read operations
    #Address 0x284 read value
    csrr x14, 0x284

    #Address 0x284 Write value 0xdcb31908
    li x3, 0xdcb31908
    csrw 0x284, x3

    #Address 0x284 Write value 0xe30e28f
    li x3, 0xe30e28f
    csrw 0x284, x3

    #Unmapped address 0xc9d testing: random write/read operations
    #Address 0xc9d read value
    csrr x14, 0xc9d

    #Address 0xc9d read value
    csrr x14, 0xc9d

    #Address 0xc9d Write value 0x9836b89a
    li x3, 0x9836b89a
    csrw 0xc9d, x3

    #Address 0xc9d read value
    csrr x14, 0xc9d

    #Address 0xc9d Write value 0x34feea70
    li x3, 0x34feea70
    csrw 0xc9d, x3

    #Unmapped address 0xa5a testing: random write/read operations
    #Address 0xa5a read value
    csrr x14, 0xa5a

    #Address 0xa5a read value
    csrr x14, 0xa5a

    #Unmapped address 0x53b testing: random write/read operations
    #Address 0x53b Write value 0x3b5638a6
    li x3, 0x3b5638a6
    csrw 0x53b, x3

    #Address 0x53b read value
    csrr x14, 0x53b

    #Address 0x53b read value
    csrr x14, 0x53b

    #Address 0x53b read value
    csrr x14, 0x53b

    #Address 0x53b Write value 0xc9589191
    li x3, 0xc9589191
    csrw 0x53b, x3

    #Unmapped address 0xfee testing: random write/read operations
    #Address 0xfee Write value 0x367de591
    li x3, 0x367de591
    csrw 0xfee, x3

    #Address 0xfee read value
    csrr x14, 0xfee

    #Unmapped address 0x143 testing: random write/read operations
    #Address 0x143 read value
    csrr x14, 0x143

    #Address 0x143 Write value 0x583cbbe
    li x3, 0x583cbbe
    csrw 0x143, x3

    #Unmapped address 0x21c testing: random write/read operations
    #Address 0x21c read value
    csrr x14, 0x21c

    #Unmapped address 0x8ef testing: random write/read operations
    #Address 0x8ef Write value 0xf6dfe6d4
    li x3, 0xf6dfe6d4
    csrw 0x8ef, x3

    #Address 0x8ef Write value 0xa269bd8d
    li x3, 0xa269bd8d
    csrw 0x8ef, x3

    #Address 0x8ef read value
    csrr x14, 0x8ef

    #Address 0x8ef read value
    csrr x14, 0x8ef

    #Unmapped address 0xd0d testing: random write/read operations
    #Address 0xd0d read value
    csrr x14, 0xd0d

    #Address 0xd0d read value
    csrr x14, 0xd0d

    #Unmapped address 0x6f testing: random write/read operations
    #Address 0x6f read value
    csrr x14, 0x6f

    #Address 0x6f read value
    csrr x14, 0x6f

    #Address 0x6f read value
    csrr x14, 0x6f

    #Address 0x6f Write value 0xd8f239cf
    li x3, 0xd8f239cf
    csrw 0x6f, x3

    #Address 0x6f Write value 0x1705ae35
    li x3, 0x1705ae35
    csrw 0x6f, x3

    #Unmapped address 0x358 testing: random write/read operations
    #Address 0x358 Write value 0x9cd2cdae
    li x3, 0x9cd2cdae
    csrw 0x358, x3

    #Address 0x358 Write value 0x59ce0c8c
    li x3, 0x59ce0c8c
    csrw 0x358, x3

    #Unmapped address 0x822 testing: random write/read operations
    #Address 0x822 Write value 0x4e65beec
    li x3, 0x4e65beec
    csrw 0x822, x3

    #Unmapped address 0xec2 testing: random write/read operations
    #Address 0xec2 read value
    csrr x14, 0xec2

    #Address 0xec2 Write value 0x76c605ea
    li x3, 0x76c605ea
    csrw 0xec2, x3

    #Unmapped address 0x1cd testing: random write/read operations
    #Address 0x1cd Write value 0x67776123
    li x3, 0x67776123
    csrw 0x1cd, x3

    #Unmapped address 0x65c testing: random write/read operations
    #Address 0x65c Write value 0xa9ebf732
    li x3, 0xa9ebf732
    csrw 0x65c, x3

    #Address 0x65c read value
    csrr x14, 0x65c

    #Unmapped address 0xe3 testing: random write/read operations
    #Address 0xe3 Write value 0x4faaa8e7
    li x3, 0x4faaa8e7
    csrw 0xe3, x3

    #Address 0xe3 Write value 0x9c99d0ea
    li x3, 0x9c99d0ea
    csrw 0xe3, x3

    #Address 0xe3 Write value 0x7e9c59e5
    li x3, 0x7e9c59e5
    csrw 0xe3, x3

    #Unmapped address 0xe27 testing: random write/read operations
    #Address 0xe27 Write value 0x5c1495c9
    li x3, 0x5c1495c9
    csrw 0xe27, x3

    #Address 0xe27 Write value 0x6d319d33
    li x3, 0x6d319d33
    csrw 0xe27, x3

    #Address 0xe27 read value
    csrr x14, 0xe27

    #Address 0xe27 Write value 0xc44d952a
    li x3, 0xc44d952a
    csrw 0xe27, x3

    #Mapped address 0x3b4 (pmpaddr4) testing: random write/read operations
    #Address 0x3b4 Write value 0x28091240
    li x3, 0x28091240
    csrw 0x3b4, x3

    #Unmapped address 0x91f testing: random write/read operations
    #Address 0x91f read value
    csrr x14, 0x91f

    #Address 0x91f Write value 0x4b027f2
    li x3, 0x4b027f2
    csrw 0x91f, x3

    #Address 0x91f read value
    csrr x14, 0x91f

    #Address 0x91f read value
    csrr x14, 0x91f

    #Unmapped address 0xad1 testing: random write/read operations
    #Address 0xad1 Write value 0x35299226
    li x3, 0x35299226
    csrw 0xad1, x3

    #Address 0xad1 Write value 0x9600a99c
    li x3, 0x9600a99c
    csrw 0xad1, x3

    #Address 0xad1 read value
    csrr x14, 0xad1

    #Unmapped address 0xbe testing: random write/read operations
    #Address 0xbe Write value 0xd80b4b31
    li x3, 0xd80b4b31
    csrw 0xbe, x3

    #Address 0xbe read value
    csrr x14, 0xbe

    #Address 0xbe Write value 0xb3adc225
    li x3, 0xb3adc225
    csrw 0xbe, x3

    #Address 0xbe Write value 0xfa17ec76
    li x3, 0xfa17ec76
    csrw 0xbe, x3

    #Address 0xbe Write value 0x4b171af7
    li x3, 0x4b171af7
    csrw 0xbe, x3

    #Unmapped address 0x1c1 testing: random write/read operations
    #Address 0x1c1 read value
    csrr x14, 0x1c1

    #Address 0x1c1 read value
    csrr x14, 0x1c1

    #Address 0x1c1 read value
    csrr x14, 0x1c1

    #Address 0x1c1 read value
    csrr x14, 0x1c1

    #Address 0x1c1 read value
    csrr x14, 0x1c1

    #Unmapped address 0x3a5 testing: random write/read operations
    #Address 0x3a5 read value
    csrr x14, 0x3a5

    #Address 0x3a5 read value
    csrr x14, 0x3a5

    #Unmapped address 0x382 testing: random write/read operations
    #Address 0x382 Write value 0xd5e71686
    li x3, 0xd5e71686
    csrw 0x382, x3

    #Address 0x382 Write value 0xc46e8cd6
    li x3, 0xc46e8cd6
    csrw 0x382, x3

    #Address 0x382 Write value 0x9af0c5fb
    li x3, 0x9af0c5fb
    csrw 0x382, x3

    #Unmapped address 0x12e testing: random write/read operations
    #Address 0x12e read value
    csrr x14, 0x12e

    #Unmapped address 0xf30 testing: random write/read operations
    #Address 0xf30 Write value 0xae0e3a8c
    li x3, 0xae0e3a8c
    csrw 0xf30, x3

    #Address 0xf30 read value
    csrr x14, 0xf30

    #Address 0xf30 Write value 0x9970ae5e
    li x3, 0x9970ae5e
    csrw 0xf30, x3

    #Address 0xf30 Write value 0xd1c4ced7
    li x3, 0xd1c4ced7
    csrw 0xf30, x3

    #Unmapped address 0x3da testing: random write/read operations
    #Address 0x3da read value
    csrr x14, 0x3da

    #Address 0x3da read value
    csrr x14, 0x3da

    #Address 0x3da Write value 0xbc4455ba
    li x3, 0xbc4455ba
    csrw 0x3da, x3

    #Address 0x3da read value
    csrr x14, 0x3da

    #Unmapped address 0x9dc testing: random write/read operations
    #Address 0x9dc Write value 0x67c0bc7a
    li x3, 0x67c0bc7a
    csrw 0x9dc, x3

    #Address 0x9dc Write value 0xfdf05719
    li x3, 0xfdf05719
    csrw 0x9dc, x3

    #Address 0x9dc read value
    csrr x14, 0x9dc

    #Address 0x9dc read value
    csrr x14, 0x9dc

    #Unmapped address 0x2f2 testing: random write/read operations
    #Address 0x2f2 Write value 0x6f1be797
    li x3, 0x6f1be797
    csrw 0x2f2, x3

    #Address 0x2f2 Write value 0x12b3053
    li x3, 0x12b3053
    csrw 0x2f2, x3

    #Address 0x2f2 read value
    csrr x14, 0x2f2

    #Address 0x2f2 Write value 0x643d57b4
    li x3, 0x643d57b4
    csrw 0x2f2, x3

    #Unmapped address 0xd5c testing: random write/read operations
    #Address 0xd5c Write value 0xc1a74b51
    li x3, 0xc1a74b51
    csrw 0xd5c, x3

    #Unmapped address 0x479 testing: random write/read operations
    #Address 0x479 read value
    csrr x14, 0x479

    #Address 0x479 Write value 0x554c8da1
    li x3, 0x554c8da1
    csrw 0x479, x3

    #Address 0x479 read value
    csrr x14, 0x479

    #Address 0x479 read value
    csrr x14, 0x479

    #Address 0x479 Write value 0x59758044
    li x3, 0x59758044
    csrw 0x479, x3

    #Unmapped address 0x67e testing: random write/read operations
    #Address 0x67e read value
    csrr x14, 0x67e

    #Address 0x67e Write value 0x4f290f41
    li x3, 0x4f290f41
    csrw 0x67e, x3

    #Address 0x67e Write value 0xc49a2252
    li x3, 0xc49a2252
    csrw 0x67e, x3

    #Address 0x67e Write value 0x47c7d3a1
    li x3, 0x47c7d3a1
    csrw 0x67e, x3

    #Unmapped address 0x352 testing: random write/read operations
    #Address 0x352 read value
    csrr x14, 0x352

    #Address 0x352 Write value 0x91d699e8
    li x3, 0x91d699e8
    csrw 0x352, x3

    #Address 0x352 read value
    csrr x14, 0x352

    #Address 0x352 read value
    csrr x14, 0x352

    #Unmapped address 0xcb3 testing: random write/read operations
    #Address 0xcb3 read value
    csrr x14, 0xcb3

    #Address 0xcb3 read value
    csrr x14, 0xcb3

    #Address 0xcb3 read value
    csrr x14, 0xcb3

    #Address 0xcb3 read value
    csrr x14, 0xcb3

    #Unmapped address 0xa84 testing: random write/read operations
    #Address 0xa84 read value
    csrr x14, 0xa84

    #Unmapped address 0x35f testing: random write/read operations
    #Address 0x35f read value
    csrr x14, 0x35f

    #Address 0x35f Write value 0xe73e54ba
    li x3, 0xe73e54ba
    csrw 0x35f, x3

    #Unmapped address 0x69f testing: random write/read operations
    #Address 0x69f read value
    csrr x14, 0x69f

    #Address 0x69f read value
    csrr x14, 0x69f

    #Address 0x69f read value
    csrr x14, 0x69f

    #Address 0x69f Write value 0x4f49629e
    li x3, 0x4f49629e
    csrw 0x69f, x3

    #Unmapped address 0x747 testing: random write/read operations
    #Address 0x747 read value
    csrr x14, 0x747

    #Address 0x747 read value
    csrr x14, 0x747

    #Address 0x747 Write value 0xae9a3d84
    li x3, 0xae9a3d84
    csrw 0x747, x3

    #Address 0x747 read value
    csrr x14, 0x747

    #Address 0x747 Write value 0xb1a58ad0
    li x3, 0xb1a58ad0
    csrw 0x747, x3

    #Unmapped address 0x77a testing: random write/read operations
    #Address 0x77a read value
    csrr x14, 0x77a

    #Address 0x77a read value
    csrr x14, 0x77a

    #Unmapped address 0x53f testing: random write/read operations
    #Address 0x53f read value
    csrr x14, 0x53f

    #Address 0x53f read value
    csrr x14, 0x53f

    #Address 0x53f read value
    csrr x14, 0x53f

    #Unmapped address 0x48d testing: random write/read operations
    #Address 0x48d read value
    csrr x14, 0x48d

    #Address 0x48d Write value 0x880bfbe0
    li x3, 0x880bfbe0
    csrw 0x48d, x3

    #Address 0x48d read value
    csrr x14, 0x48d

    #Unmapped address 0x12b testing: random write/read operations
    #Address 0x12b Write value 0xb000c52f
    li x3, 0xb000c52f
    csrw 0x12b, x3

    #Address 0x12b Write value 0xe136e434
    li x3, 0xe136e434
    csrw 0x12b, x3

    #Address 0x12b read value
    csrr x14, 0x12b

    #Address 0x12b Write value 0x440b8b22
    li x3, 0x440b8b22
    csrw 0x12b, x3

    #Unmapped address 0xbc1 testing: random write/read operations
    #Address 0xbc1 Write value 0xb32816dd
    li x3, 0xb32816dd
    csrw 0xbc1, x3

    #Address 0xbc1 read value
    csrr x14, 0xbc1

    #Unmapped address 0x5ba testing: random write/read operations
    #Address 0x5ba Write value 0x22cd8b6a
    li x3, 0x22cd8b6a
    csrw 0x5ba, x3

    #Address 0x5ba Write value 0xe0c178bf
    li x3, 0xe0c178bf
    csrw 0x5ba, x3

    #Address 0x5ba Write value 0xf797b020
    li x3, 0xf797b020
    csrw 0x5ba, x3

    #Address 0x5ba Write value 0x6862d899
    li x3, 0x6862d899
    csrw 0x5ba, x3

    #Address 0x5ba read value
    csrr x14, 0x5ba

    #Unmapped address 0x70b testing: random write/read operations
    #Address 0x70b Write value 0x477d5c7c
    li x3, 0x477d5c7c
    csrw 0x70b, x3

    #Address 0x70b Write value 0x15e5be41
    li x3, 0x15e5be41
    csrw 0x70b, x3

    #Address 0x70b read value
    csrr x14, 0x70b

    #Address 0x70b read value
    csrr x14, 0x70b

    #Unmapped address 0x421 testing: random write/read operations
    #Address 0x421 Write value 0x543d7ae2
    li x3, 0x543d7ae2
    csrw 0x421, x3

    #Address 0x421 Write value 0xa98d79ff
    li x3, 0xa98d79ff
    csrw 0x421, x3

    #Unmapped address 0x803 testing: random write/read operations
    #Address 0x803 Write value 0xc3129af0
    li x3, 0xc3129af0
    csrw 0x803, x3

    #Address 0x803 Write value 0xec956391
    li x3, 0xec956391
    csrw 0x803, x3

    #Unmapped address 0x8ed testing: random write/read operations
    #Address 0x8ed read value
    csrr x14, 0x8ed

    #Address 0x8ed read value
    csrr x14, 0x8ed

    #Address 0x8ed Write value 0x59b352f4
    li x3, 0x59b352f4
    csrw 0x8ed, x3

    #Address 0x8ed read value
    csrr x14, 0x8ed

    #Address 0x8ed read value
    csrr x14, 0x8ed

    #Unmapped address 0x2a5 testing: random write/read operations
    #Address 0x2a5 read value
    csrr x14, 0x2a5

    #Address 0x2a5 read value
    csrr x14, 0x2a5

    #Address 0x2a5 Write value 0x775f2721
    li x3, 0x775f2721
    csrw 0x2a5, x3

    #Address 0x2a5 Write value 0x7b4eec22
    li x3, 0x7b4eec22
    csrw 0x2a5, x3

    #Unmapped address 0x798 testing: random write/read operations
    #Address 0x798 Write value 0x4584739c
    li x3, 0x4584739c
    csrw 0x798, x3

    #Address 0x798 read value
    csrr x14, 0x798

    #Address 0x798 Write value 0xc87884d9
    li x3, 0xc87884d9
    csrw 0x798, x3

    #Unmapped address 0x4e8 testing: random write/read operations
    #Address 0x4e8 Write value 0x2951b056
    li x3, 0x2951b056
    csrw 0x4e8, x3

    #Address 0x4e8 Write value 0x8fbcd08e
    li x3, 0x8fbcd08e
    csrw 0x4e8, x3

    #Address 0x4e8 Write value 0x73f0ba41
    li x3, 0x73f0ba41
    csrw 0x4e8, x3

    #Unmapped address 0xa7e testing: random write/read operations
    #Address 0xa7e Write value 0x11f785a4
    li x3, 0x11f785a4
    csrw 0xa7e, x3

    #Address 0xa7e read value
    csrr x14, 0xa7e

    #Address 0xa7e read value
    csrr x14, 0xa7e

    #Unmapped address 0x7a3 testing: random write/read operations
    #Address 0x7a3 read value
    csrr x14, 0x7a3

    #Address 0x7a3 read value
    csrr x14, 0x7a3

    #Address 0x7a3 read value
    csrr x14, 0x7a3

    #Address 0x7a3 read value
    csrr x14, 0x7a3

    #Unmapped address 0x5f testing: random write/read operations
    #Address 0x5f Write value 0x4d57d155
    li x3, 0x4d57d155
    csrw 0x5f, x3

    #Address 0x5f Write value 0x1f734232
    li x3, 0x1f734232
    csrw 0x5f, x3

    #Address 0x5f read value
    csrr x14, 0x5f

    #Address 0x5f Write value 0x8669932c
    li x3, 0x8669932c
    csrw 0x5f, x3

    #Unmapped address 0x108 testing: random write/read operations
    #Address 0x108 read value
    csrr x14, 0x108

    #Unmapped address 0x13a testing: random write/read operations
    #Address 0x13a read value
    csrr x14, 0x13a

    #Unmapped address 0xe36 testing: random write/read operations
    #Address 0xe36 Write value 0x44e7f120
    li x3, 0x44e7f120
    csrw 0xe36, x3

    #Unmapped address 0xa99 testing: random write/read operations
    #Address 0xa99 Write value 0x4c8c0637
    li x3, 0x4c8c0637
    csrw 0xa99, x3

    #Address 0xa99 Write value 0x90d901d7
    li x3, 0x90d901d7
    csrw 0xa99, x3

    #Address 0xa99 read value
    csrr x14, 0xa99

    #Address 0xa99 Write value 0x3b576535
    li x3, 0x3b576535
    csrw 0xa99, x3

    #Address 0xa99 Write value 0x577e5b55
    li x3, 0x577e5b55
    csrw 0xa99, x3

    #Unmapped address 0xdd3 testing: random write/read operations
    #Address 0xdd3 Write value 0xd19061ca
    li x3, 0xd19061ca
    csrw 0xdd3, x3

    #Address 0xdd3 read value
    csrr x14, 0xdd3

    #Address 0xdd3 read value
    csrr x14, 0xdd3

    #Unmapped address 0x584 testing: random write/read operations
    #Address 0x584 Write value 0x2eeaa6eb
    li x3, 0x2eeaa6eb
    csrw 0x584, x3

    #Unmapped address 0xd3e testing: random write/read operations
    #Address 0xd3e read value
    csrr x14, 0xd3e

    #Address 0xd3e read value
    csrr x14, 0xd3e

    #Address 0xd3e Write value 0xc08a582d
    li x3, 0xc08a582d
    csrw 0xd3e, x3

    #Unmapped address 0x76a testing: random write/read operations
    #Address 0x76a read value
    csrr x14, 0x76a

    #Address 0x76a Write value 0x83b73dd7
    li x3, 0x83b73dd7
    csrw 0x76a, x3

    #Address 0x76a read value
    csrr x14, 0x76a

    #Address 0x76a Write value 0xef2a557c
    li x3, 0xef2a557c
    csrw 0x76a, x3

    #Unmapped address 0x6c3 testing: random write/read operations
    #Address 0x6c3 read value
    csrr x14, 0x6c3

    #Address 0x6c3 read value
    csrr x14, 0x6c3

    #Unmapped address 0x371 testing: random write/read operations
    #Address 0x371 read value
    csrr x14, 0x371

    #Address 0x371 read value
    csrr x14, 0x371

    #Unmapped address 0xc5e testing: random write/read operations
    #Address 0xc5e read value
    csrr x14, 0xc5e

    #Address 0xc5e Write value 0xffa205b1
    li x3, 0xffa205b1
    csrw 0xc5e, x3

    #Address 0xc5e read value
    csrr x14, 0xc5e

    #Address 0xc5e Write value 0x5b05d833
    li x3, 0x5b05d833
    csrw 0xc5e, x3

    #Unmapped address 0xe6d testing: random write/read operations
    #Address 0xe6d Write value 0x589ffc96
    li x3, 0x589ffc96
    csrw 0xe6d, x3

    #Address 0xe6d read value
    csrr x14, 0xe6d

    #Address 0xe6d read value
    csrr x14, 0xe6d

    #Address 0xe6d Write value 0xcab1226c
    li x3, 0xcab1226c
    csrw 0xe6d, x3

    #Unmapped address 0xc4d testing: random write/read operations
    #Address 0xc4d read value
    csrr x14, 0xc4d

    #Unmapped address 0xaa5 testing: random write/read operations
    #Address 0xaa5 Write value 0xb17446f6
    li x3, 0xb17446f6
    csrw 0xaa5, x3

    #Address 0xaa5 Write value 0x196cfae5
    li x3, 0x196cfae5
    csrw 0xaa5, x3

    #Address 0xaa5 read value
    csrr x14, 0xaa5

    #Unmapped address 0x5d1 testing: random write/read operations
    #Address 0x5d1 Write value 0xb6c239de
    li x3, 0xb6c239de
    csrw 0x5d1, x3

    #Address 0x5d1 Write value 0xf7469551
    li x3, 0xf7469551
    csrw 0x5d1, x3

    #Address 0x5d1 read value
    csrr x14, 0x5d1

    #Address 0x5d1 read value
    csrr x14, 0x5d1

    #Address 0x5d1 read value
    csrr x14, 0x5d1

    #Unmapped address 0x162 testing: random write/read operations
    #Address 0x162 Write value 0x5ee58562
    li x3, 0x5ee58562
    csrw 0x162, x3

    #Address 0x162 read value
    csrr x14, 0x162

    #Address 0x162 read value
    csrr x14, 0x162

    #Address 0x162 read value
    csrr x14, 0x162

    #Address 0x162 read value
    csrr x14, 0x162

    #Unmapped address 0x2c7 testing: random write/read operations
    #Address 0x2c7 read value
    csrr x14, 0x2c7

    #Address 0x2c7 read value
    csrr x14, 0x2c7

    #Address 0x2c7 read value
    csrr x14, 0x2c7

    #Unmapped address 0x254 testing: random write/read operations
    #Address 0x254 Write value 0x586eb87c
    li x3, 0x586eb87c
    csrw 0x254, x3

    #Unmapped address 0x137 testing: random write/read operations
    #Address 0x137 read value
    csrr x14, 0x137

    #Address 0x137 Write value 0x43fa2fbf
    li x3, 0x43fa2fbf
    csrw 0x137, x3

    #Unmapped address 0x9e testing: random write/read operations
    #Address 0x9e read value
    csrr x14, 0x9e

    #Unmapped address 0x631 testing: random write/read operations
    #Address 0x631 read value
    csrr x14, 0x631

    #Address 0x631 read value
    csrr x14, 0x631

    #Unmapped address 0x12d testing: random write/read operations
    #Address 0x12d Write value 0x963e1ca2
    li x3, 0x963e1ca2
    csrw 0x12d, x3

    #Unmapped address 0x3f5 testing: random write/read operations
    #Address 0x3f5 Write value 0xa9fe4d71
    li x3, 0xa9fe4d71
    csrw 0x3f5, x3

    #Address 0x3f5 Write value 0x556f230e
    li x3, 0x556f230e
    csrw 0x3f5, x3

    #Unmapped address 0x9e8 testing: random write/read operations
    #Address 0x9e8 read value
    csrr x14, 0x9e8

    #Address 0x9e8 read value
    csrr x14, 0x9e8

    #Address 0x9e8 Write value 0x81f8fa8e
    li x3, 0x81f8fa8e
    csrw 0x9e8, x3

    #Address 0x9e8 Write value 0x3346cff3
    li x3, 0x3346cff3
    csrw 0x9e8, x3

    #Unmapped address 0xb73 testing: random write/read operations
    #Address 0xb73 read value
    csrr x14, 0xb73

    #Address 0xb73 read value
    csrr x14, 0xb73

    #Address 0xb73 Write value 0x94869ad
    li x3, 0x94869ad
    csrw 0xb73, x3

    #Address 0xb73 Write value 0x3061ca72
    li x3, 0x3061ca72
    csrw 0xb73, x3

    #Address 0xb73 Write value 0xb361522b
    li x3, 0xb361522b
    csrw 0xb73, x3

    #Unmapped address 0x8e testing: random write/read operations
    #Address 0x8e read value
    csrr x14, 0x8e

    #Address 0x8e read value
    csrr x14, 0x8e

    #Unmapped address 0x8f6 testing: random write/read operations
    #Address 0x8f6 Write value 0xc0f07fd0
    li x3, 0xc0f07fd0
    csrw 0x8f6, x3

    #Address 0x8f6 Write value 0x3ce0fd4d
    li x3, 0x3ce0fd4d
    csrw 0x8f6, x3

    #Address 0x8f6 read value
    csrr x14, 0x8f6

    #Unmapped address 0xc43 testing: random write/read operations
    #Address 0xc43 Write value 0xbc027169
    li x3, 0xbc027169
    csrw 0xc43, x3

    #Address 0xc43 Write value 0xa27c1f36
    li x3, 0xa27c1f36
    csrw 0xc43, x3

    #Address 0xc43 read value
    csrr x14, 0xc43

    #Address 0xc43 Write value 0xcf7a6065
    li x3, 0xcf7a6065
    csrw 0xc43, x3

    #Unmapped address 0x6c8 testing: random write/read operations
    #Address 0x6c8 Write value 0x9c57bba9
    li x3, 0x9c57bba9
    csrw 0x6c8, x3

    #Address 0x6c8 read value
    csrr x14, 0x6c8

    #Unmapped address 0x8c5 testing: random write/read operations
    #Address 0x8c5 read value
    csrr x14, 0x8c5

    #Address 0x8c5 Write value 0x1bcc3849
    li x3, 0x1bcc3849
    csrw 0x8c5, x3

    #Address 0x8c5 Write value 0xdc0b6353
    li x3, 0xdc0b6353
    csrw 0x8c5, x3

    #Address 0x8c5 Write value 0x93b7fd1d
    li x3, 0x93b7fd1d
    csrw 0x8c5, x3

    #Address 0x8c5 Write value 0x46c01fc9
    li x3, 0x46c01fc9
    csrw 0x8c5, x3

    #Unmapped address 0x3db testing: random write/read operations
    #Address 0x3db read value
    csrr x14, 0x3db

    #Address 0x3db read value
    csrr x14, 0x3db

    #Unmapped address 0xfbe testing: random write/read operations
    #Address 0xfbe read value
    csrr x14, 0xfbe

    #Address 0xfbe Write value 0x1af3d447
    li x3, 0x1af3d447
    csrw 0xfbe, x3

    #Address 0xfbe Write value 0x88eac810
    li x3, 0x88eac810
    csrw 0xfbe, x3

    #Address 0xfbe read value
    csrr x14, 0xfbe

    #Address 0xfbe Write value 0xa196c94a
    li x3, 0xa196c94a
    csrw 0xfbe, x3

    #Unmapped address 0xc7b testing: random write/read operations
    #Address 0xc7b Write value 0xb0b8e817
    li x3, 0xb0b8e817
    csrw 0xc7b, x3

    #Unmapped address 0xaa2 testing: random write/read operations
    #Address 0xaa2 read value
    csrr x14, 0xaa2

    #Address 0xaa2 Write value 0x9900dc70
    li x3, 0x9900dc70
    csrw 0xaa2, x3

    #Address 0xaa2 read value
    csrr x14, 0xaa2

    #Address 0xaa2 read value
    csrr x14, 0xaa2

    #Unmapped address 0x42d testing: random write/read operations
    #Address 0x42d Write value 0xb29a8eaf
    li x3, 0xb29a8eaf
    csrw 0x42d, x3

    #Address 0x42d read value
    csrr x14, 0x42d

    #Address 0x42d Write value 0x3846afb5
    li x3, 0x3846afb5
    csrw 0x42d, x3

    #Unmapped address 0x5dd testing: random write/read operations
    #Address 0x5dd read value
    csrr x14, 0x5dd

    #Address 0x5dd read value
    csrr x14, 0x5dd

    #Address 0x5dd read value
    csrr x14, 0x5dd

    #Address 0x5dd Write value 0x926999d1
    li x3, 0x926999d1
    csrw 0x5dd, x3

    #Address 0x5dd Write value 0xecb211e8
    li x3, 0xecb211e8
    csrw 0x5dd, x3

    #Unmapped address 0x82c testing: random write/read operations
    #Address 0x82c read value
    csrr x14, 0x82c

    #Unmapped address 0x8ee testing: random write/read operations
    #Address 0x8ee Write value 0xf724d75c
    li x3, 0xf724d75c
    csrw 0x8ee, x3

    #Unmapped address 0xdd6 testing: random write/read operations
    #Address 0xdd6 read value
    csrr x14, 0xdd6

    #Address 0xdd6 Write value 0x8a77b577
    li x3, 0x8a77b577
    csrw 0xdd6, x3

    #Address 0xdd6 read value
    csrr x14, 0xdd6

    #Address 0xdd6 Write value 0x90a5fcf9
    li x3, 0x90a5fcf9
    csrw 0xdd6, x3

    #Address 0xdd6 read value
    csrr x14, 0xdd6

    #Unmapped address 0x5d4 testing: random write/read operations
    #Address 0x5d4 read value
    csrr x14, 0x5d4

    #Address 0x5d4 read value
    csrr x14, 0x5d4

    #Address 0x5d4 Write value 0xf1095fd2
    li x3, 0xf1095fd2
    csrw 0x5d4, x3

    #Address 0x5d4 Write value 0x95983b84
    li x3, 0x95983b84
    csrw 0x5d4, x3

    #Address 0x5d4 read value
    csrr x14, 0x5d4

    #Unmapped address 0x1f6 testing: random write/read operations
    #Address 0x1f6 read value
    csrr x14, 0x1f6

    #Address 0x1f6 read value
    csrr x14, 0x1f6

    #Unmapped address 0xc35 testing: random write/read operations
    #Address 0xc35 read value
    csrr x14, 0xc35

    #Address 0xc35 read value
    csrr x14, 0xc35

    #Unmapped address 0x469 testing: random write/read operations
    #Address 0x469 read value
    csrr x14, 0x469

    #Address 0x469 read value
    csrr x14, 0x469

    #Address 0x469 Write value 0xae64edcf
    li x3, 0xae64edcf
    csrw 0x469, x3

    #Mapped address 0xb93 (mhpmcounterh19) testing: random write/read operations
    #Address 0xb93 Write value 0x4d87e1f2
    li x3, 0x4d87e1f2
    csrw 0xb93, x3

    #Address 0xb93 Write value 0x9e07929d
    li x3, 0x9e07929d
    csrw 0xb93, x3

    #Unmapped address 0x68e testing: random write/read operations
    #Address 0x68e Write value 0xe4a24743
    li x3, 0xe4a24743
    csrw 0x68e, x3

    #Unmapped address 0x3c7 testing: random write/read operations
    #Address 0x3c7 Write value 0x5098e41d
    li x3, 0x5098e41d
    csrw 0x3c7, x3

    #Address 0x3c7 read value
    csrr x14, 0x3c7

    #Unmapped address 0x9ce testing: random write/read operations
    #Address 0x9ce read value
    csrr x14, 0x9ce

    #Address 0x9ce Write value 0x6768b829
    li x3, 0x6768b829
    csrw 0x9ce, x3

    #Address 0x9ce Write value 0x9ff03277
    li x3, 0x9ff03277
    csrw 0x9ce, x3

    #Unmapped address 0x1f1 testing: random write/read operations
    #Address 0x1f1 read value
    csrr x14, 0x1f1

    #Address 0x1f1 Write value 0x8b5a36f6
    li x3, 0x8b5a36f6
    csrw 0x1f1, x3

    #Address 0x1f1 read value
    csrr x14, 0x1f1

    #Unmapped address 0xccd testing: random write/read operations
    #Address 0xccd Write value 0xccc6b7fa
    li x3, 0xccc6b7fa
    csrw 0xccd, x3

    #Address 0xccd read value
    csrr x14, 0xccd

    #Unmapped address 0x81e testing: random write/read operations
    #Address 0x81e Write value 0x7c277ea8
    li x3, 0x7c277ea8
    csrw 0x81e, x3

    #Unmapped address 0xe90 testing: random write/read operations
    #Address 0xe90 read value
    csrr x14, 0xe90

    #Address 0xe90 read value
    csrr x14, 0xe90

    #Address 0xe90 Write value 0x17964020
    li x3, 0x17964020
    csrw 0xe90, x3

    #Address 0xe90 read value
    csrr x14, 0xe90

    #Unmapped address 0x7a1 testing: random write/read operations
    #Address 0x7a1 Write value 0x35f32914
    li x3, 0x35f32914
    csrw 0x7a1, x3

    #Address 0x7a1 Write value 0x156afc71
    li x3, 0x156afc71
    csrw 0x7a1, x3

    #Address 0x7a1 Write value 0x740b1e24
    li x3, 0x740b1e24
    csrw 0x7a1, x3

    #Address 0x7a1 Write value 0xf118f699
    li x3, 0xf118f699
    csrw 0x7a1, x3

    #Unmapped address 0x23f testing: random write/read operations
    #Address 0x23f read value
    csrr x14, 0x23f

    #Unmapped address 0x9de testing: random write/read operations
    #Address 0x9de Write value 0x6a97bda
    li x3, 0x6a97bda
    csrw 0x9de, x3

    #Unmapped address 0x801 testing: random write/read operations
    #Address 0x801 read value
    csrr x14, 0x801

    #Address 0x801 read value
    csrr x14, 0x801

    #Address 0x801 read value
    csrr x14, 0x801

    #Address 0x801 Write value 0xf92bc61
    li x3, 0xf92bc61
    csrw 0x801, x3

    #Unmapped address 0x24c testing: random write/read operations
    #Address 0x24c Write value 0xa22d338c
    li x3, 0xa22d338c
    csrw 0x24c, x3

    #Address 0x24c read value
    csrr x14, 0x24c

    #Address 0x24c Write value 0xb506a116
    li x3, 0xb506a116
    csrw 0x24c, x3

    #Address 0x24c Write value 0xacdf9197
    li x3, 0xacdf9197
    csrw 0x24c, x3

    #Address 0x24c Write value 0x9a3ccd0e
    li x3, 0x9a3ccd0e
    csrw 0x24c, x3

    #Unmapped address 0xa88 testing: random write/read operations
    #Address 0xa88 read value
    csrr x14, 0xa88

    #Address 0xa88 read value
    csrr x14, 0xa88

    #Address 0xa88 read value
    csrr x14, 0xa88

    #Unmapped address 0xd73 testing: random write/read operations
    #Address 0xd73 Write value 0x64d98c2c
    li x3, 0x64d98c2c
    csrw 0xd73, x3

    #Address 0xd73 Write value 0xe1f518c2
    li x3, 0xe1f518c2
    csrw 0xd73, x3

    #Address 0xd73 Write value 0x84c4142b
    li x3, 0x84c4142b
    csrw 0xd73, x3

    #Address 0xd73 read value
    csrr x14, 0xd73

    #Address 0xd73 read value
    csrr x14, 0xd73

    #Unmapped address 0xb6c testing: random write/read operations
    #Address 0xb6c read value
    csrr x14, 0xb6c

    #Address 0xb6c read value
    csrr x14, 0xb6c

    #Address 0xb6c read value
    csrr x14, 0xb6c

    #Unmapped address 0x918 testing: random write/read operations
    #Address 0x918 read value
    csrr x14, 0x918

    #Unmapped address 0x937 testing: random write/read operations
    #Address 0x937 Write value 0x15da3ab9
    li x3, 0x15da3ab9
    csrw 0x937, x3

    #Address 0x937 Write value 0x451ea63f
    li x3, 0x451ea63f
    csrw 0x937, x3

    #Address 0x937 read value
    csrr x14, 0x937

    #Unmapped address 0x579 testing: random write/read operations
    #Address 0x579 Write value 0xd3689244
    li x3, 0xd3689244
    csrw 0x579, x3

    #Unmapped address 0x649 testing: random write/read operations
    #Address 0x649 Write value 0x9a64612e
    li x3, 0x9a64612e
    csrw 0x649, x3

    #Address 0x649 Write value 0x744432b4
    li x3, 0x744432b4
    csrw 0x649, x3

    #Address 0x649 read value
    csrr x14, 0x649

    #Address 0x649 Write value 0x14a4c461
    li x3, 0x14a4c461
    csrw 0x649, x3

    #Address 0x649 Write value 0x12d2633f
    li x3, 0x12d2633f
    csrw 0x649, x3

    #Unmapped address 0x886 testing: random write/read operations
    #Address 0x886 Write value 0xa45d9d8b
    li x3, 0xa45d9d8b
    csrw 0x886, x3

    #Address 0x886 Write value 0x2dafd533
    li x3, 0x2dafd533
    csrw 0x886, x3

    #Unmapped address 0x657 testing: random write/read operations
    #Address 0x657 read value
    csrr x14, 0x657

    #Address 0x657 read value
    csrr x14, 0x657

    #Address 0x657 read value
    csrr x14, 0x657

    #Address 0x657 Write value 0x310e7369
    li x3, 0x310e7369
    csrw 0x657, x3

    #Unmapped address 0xf90 testing: random write/read operations
    #Address 0xf90 Write value 0x9e9e9213
    li x3, 0x9e9e9213
    csrw 0xf90, x3

    #Address 0xf90 Write value 0xa2ddee43
    li x3, 0xa2ddee43
    csrw 0xf90, x3

    #Address 0xf90 read value
    csrr x14, 0xf90

    #Unmapped address 0xba4 testing: random write/read operations
    #Address 0xba4 read value
    csrr x14, 0xba4

    #Address 0xba4 read value
    csrr x14, 0xba4

    #Unmapped address 0xdf testing: random write/read operations
    #Address 0xdf Write value 0xca31bbc9
    li x3, 0xca31bbc9
    csrw 0xdf, x3

    #Address 0xdf Write value 0x31796def
    li x3, 0x31796def
    csrw 0xdf, x3

    #Address 0xdf read value
    csrr x14, 0xdf

    #Unmapped address 0x21 testing: random write/read operations
    #Address 0x21 read value
    csrr x14, 0x21

    #Address 0x21 read value
    csrr x14, 0x21

    #Unmapped address 0xbd4 testing: random write/read operations
    #Address 0xbd4 Write value 0x7a33e907
    li x3, 0x7a33e907
    csrw 0xbd4, x3

    #Address 0xbd4 Write value 0xafc96088
    li x3, 0xafc96088
    csrw 0xbd4, x3

    #Address 0xbd4 Write value 0xb5595681
    li x3, 0xb5595681
    csrw 0xbd4, x3

    #Address 0xbd4 Write value 0xe321b0db
    li x3, 0xe321b0db
    csrw 0xbd4, x3

    #Address 0xbd4 read value
    csrr x14, 0xbd4

    #Unmapped address 0xd72 testing: random write/read operations
    #Address 0xd72 read value
    csrr x14, 0xd72

    #Address 0xd72 Write value 0x1d34f94
    li x3, 0x1d34f94
    csrw 0xd72, x3

    #Address 0xd72 Write value 0x36b6fbec
    li x3, 0x36b6fbec
    csrw 0xd72, x3

    #Unmapped address 0x3e3 testing: random write/read operations
    #Address 0x3e3 read value
    csrr x14, 0x3e3

    #Unmapped address 0x100 testing: random write/read operations
    #Address 0x100 Write value 0x68d5c06
    li x3, 0x68d5c06
    csrw 0x100, x3

    #Address 0x100 read value
    csrr x14, 0x100

    #Address 0x100 Write value 0x8d3afec5
    li x3, 0x8d3afec5
    csrw 0x100, x3

    #Unmapped address 0x68b testing: random write/read operations
    #Address 0x68b Write value 0xaf62473d
    li x3, 0xaf62473d
    csrw 0x68b, x3

    #Unmapped address 0x2a7 testing: random write/read operations
    #Address 0x2a7 Write value 0x88b52e41
    li x3, 0x88b52e41
    csrw 0x2a7, x3

    #Address 0x2a7 read value
    csrr x14, 0x2a7

    #Address 0x2a7 read value
    csrr x14, 0x2a7

    #Address 0x2a7 Write value 0xd62b866d
    li x3, 0xd62b866d
    csrw 0x2a7, x3

    #Address 0x2a7 Write value 0x556e188e
    li x3, 0x556e188e
    csrw 0x2a7, x3

    #Unmapped address 0x37f testing: random write/read operations
    #Address 0x37f read value
    csrr x14, 0x37f

    #Address 0x37f read value
    csrr x14, 0x37f

    #Address 0x37f Write value 0x5195e72f
    li x3, 0x5195e72f
    csrw 0x37f, x3

    #Address 0x37f Write value 0xef1a1239
    li x3, 0xef1a1239
    csrw 0x37f, x3

    #Address 0x37f Write value 0xdfc4e6aa
    li x3, 0xdfc4e6aa
    csrw 0x37f, x3

    #Unmapped address 0xacd testing: random write/read operations
    #Address 0xacd Write value 0x519ea81c
    li x3, 0x519ea81c
    csrw 0xacd, x3

    #Unmapped address 0xe39 testing: random write/read operations
    #Address 0xe39 read value
    csrr x14, 0xe39

    #Address 0xe39 Write value 0xc8508cfe
    li x3, 0xc8508cfe
    csrw 0xe39, x3

    #Unmapped address 0x364 testing: random write/read operations
    #Address 0x364 Write value 0x2b1baa50
    li x3, 0x2b1baa50
    csrw 0x364, x3

    #Address 0x364 Write value 0x6776d974
    li x3, 0x6776d974
    csrw 0x364, x3

    #Address 0x364 Write value 0xabd81fd1
    li x3, 0xabd81fd1
    csrw 0x364, x3

    #Address 0x364 Write value 0x6a3c2edd
    li x3, 0x6a3c2edd
    csrw 0x364, x3

    #Unmapped address 0x376 testing: random write/read operations
    #Address 0x376 read value
    csrr x14, 0x376

    #Address 0x376 read value
    csrr x14, 0x376

    #Address 0x376 read value
    csrr x14, 0x376

    #Address 0x376 read value
    csrr x14, 0x376

    #Unmapped address 0x4b4 testing: random write/read operations
    #Address 0x4b4 Write value 0xf7436266
    li x3, 0xf7436266
    csrw 0x4b4, x3

    #Address 0x4b4 read value
    csrr x14, 0x4b4

    #Address 0x4b4 read value
    csrr x14, 0x4b4

    #Address 0x4b4 Write value 0xd3b47bb5
    li x3, 0xd3b47bb5
    csrw 0x4b4, x3

    #Address 0x4b4 Write value 0xf111818b
    li x3, 0xf111818b
    csrw 0x4b4, x3

    #Unmapped address 0xe48 testing: random write/read operations
    #Address 0xe48 read value
    csrr x14, 0xe48

    #Address 0xe48 Write value 0x92b206da
    li x3, 0x92b206da
    csrw 0xe48, x3

    #Unmapped address 0xee8 testing: random write/read operations
    #Address 0xee8 Write value 0x65d916a7
    li x3, 0x65d916a7
    csrw 0xee8, x3

    #Address 0xee8 read value
    csrr x14, 0xee8

    #Address 0xee8 Write value 0x4e54e7c9
    li x3, 0x4e54e7c9
    csrw 0xee8, x3

    #Address 0xee8 Write value 0xf236ffdc
    li x3, 0xf236ffdc
    csrw 0xee8, x3

    #Unmapped address 0x2f8 testing: random write/read operations
    #Address 0x2f8 read value
    csrr x14, 0x2f8

    #Unmapped address 0x240 testing: random write/read operations
    #Address 0x240 read value
    csrr x14, 0x240

    #Unmapped address 0x3d5 testing: random write/read operations
    #Address 0x3d5 Write value 0xeb7ba463
    li x3, 0xeb7ba463
    csrw 0x3d5, x3

    #Address 0x3d5 Write value 0x1eceeece
    li x3, 0x1eceeece
    csrw 0x3d5, x3

    #Address 0x3d5 Write value 0x25758d3e
    li x3, 0x25758d3e
    csrw 0x3d5, x3

    #Address 0x3d5 Write value 0x51cf66b2
    li x3, 0x51cf66b2
    csrw 0x3d5, x3

    #Unmapped address 0xf4e testing: random write/read operations
    #Address 0xf4e read value
    csrr x14, 0xf4e

    #Address 0xf4e read value
    csrr x14, 0xf4e

    #Address 0xf4e Write value 0xe27900f5
    li x3, 0xe27900f5
    csrw 0xf4e, x3

    #Address 0xf4e read value
    csrr x14, 0xf4e

    #Unmapped address 0x1b6 testing: random write/read operations
    #Address 0x1b6 read value
    csrr x14, 0x1b6

    #Unmapped address 0xc5f testing: random write/read operations
    #Address 0xc5f Write value 0x4d89010b
    li x3, 0x4d89010b
    csrw 0xc5f, x3

    #Unmapped address 0x52 testing: random write/read operations
    #Address 0x52 read value
    csrr x14, 0x52

    #Address 0x52 read value
    csrr x14, 0x52

    #Address 0x52 read value
    csrr x14, 0x52

    #Address 0x52 Write value 0xa536dc7a
    li x3, 0xa536dc7a
    csrw 0x52, x3

    #Address 0x52 Write value 0x5e6e1a9e
    li x3, 0x5e6e1a9e
    csrw 0x52, x3

    #Unmapped address 0x902 testing: random write/read operations
    #Address 0x902 Write value 0x4f0cbed4
    li x3, 0x4f0cbed4
    csrw 0x902, x3

    #Address 0x902 read value
    csrr x14, 0x902

    #Address 0x902 Write value 0x62c14b37
    li x3, 0x62c14b37
    csrw 0x902, x3

    #Unmapped address 0x4b7 testing: random write/read operations
    #Address 0x4b7 Write value 0x6a000f01
    li x3, 0x6a000f01
    csrw 0x4b7, x3

    #Address 0x4b7 Write value 0x4683b3cd
    li x3, 0x4683b3cd
    csrw 0x4b7, x3

    #Address 0x4b7 read value
    csrr x14, 0x4b7

    #Address 0x4b7 Write value 0xe89b9b1f
    li x3, 0xe89b9b1f
    csrw 0x4b7, x3

    #Address 0x4b7 read value
    csrr x14, 0x4b7

    #Unmapped address 0xe51 testing: random write/read operations
    #Address 0xe51 Write value 0x86d67541
    li x3, 0x86d67541
    csrw 0xe51, x3

    #Unmapped address 0xb27 testing: random write/read operations
    #Address 0xb27 read value
    csrr x14, 0xb27

    #Address 0xb27 read value
    csrr x14, 0xb27

    #Address 0xb27 read value
    csrr x14, 0xb27

    #Address 0xb27 Write value 0xa41fae92
    li x3, 0xa41fae92
    csrw 0xb27, x3

    #Unmapped address 0x4fb testing: random write/read operations
    #Address 0x4fb read value
    csrr x14, 0x4fb

    #Address 0x4fb read value
    csrr x14, 0x4fb

    #Address 0x4fb Write value 0x6c77c5d8
    li x3, 0x6c77c5d8
    csrw 0x4fb, x3

    #Unmapped address 0x25a testing: random write/read operations
    #Address 0x25a Write value 0xaa2e9d01
    li x3, 0xaa2e9d01
    csrw 0x25a, x3

    #Address 0x25a Write value 0x7cd34be4
    li x3, 0x7cd34be4
    csrw 0x25a, x3

    #Address 0x25a read value
    csrr x14, 0x25a

    #Address 0x25a Write value 0x9bae9ed0
    li x3, 0x9bae9ed0
    csrw 0x25a, x3

    #Address 0x25a Write value 0x9a00fbc1
    li x3, 0x9a00fbc1
    csrw 0x25a, x3

    #Unmapped address 0xe52 testing: random write/read operations
    #Address 0xe52 Write value 0x887c4936
    li x3, 0x887c4936
    csrw 0xe52, x3

    #Address 0xe52 read value
    csrr x14, 0xe52

    #Unmapped address 0xa36 testing: random write/read operations
    #Address 0xa36 Write value 0x1f3923d1
    li x3, 0x1f3923d1
    csrw 0xa36, x3

    #Address 0xa36 read value
    csrr x14, 0xa36

    #Address 0xa36 read value
    csrr x14, 0xa36

    #Address 0xa36 read value
    csrr x14, 0xa36

    #Address 0xa36 Write value 0x57c370a1
    li x3, 0x57c370a1
    csrw 0xa36, x3

    #Unmapped address 0xd2d testing: random write/read operations
    #Address 0xd2d read value
    csrr x14, 0xd2d

    #Unmapped address 0x99f testing: random write/read operations
    #Address 0x99f Write value 0x8998a96e
    li x3, 0x8998a96e
    csrw 0x99f, x3

    #Address 0x99f Write value 0xf5cff007
    li x3, 0xf5cff007
    csrw 0x99f, x3

    #Address 0x99f read value
    csrr x14, 0x99f

    #Address 0x99f read value
    csrr x14, 0x99f

    #Address 0x99f read value
    csrr x14, 0x99f

    #Mapped address 0x32c (mhpmevent12) testing: random write/read operations
    #Address 0x32c read value
    csrr x14, 0x32c

    #Unmapped address 0xd7f testing: random write/read operations
    #Address 0xd7f Write value 0xfcf05558
    li x3, 0xfcf05558
    csrw 0xd7f, x3

    #Address 0xd7f Write value 0xe3069898
    li x3, 0xe3069898
    csrw 0xd7f, x3

    #Address 0xd7f Write value 0x8b263004
    li x3, 0x8b263004
    csrw 0xd7f, x3

    #Address 0xd7f Write value 0xd0bc0f0f
    li x3, 0xd0bc0f0f
    csrw 0xd7f, x3

    #Unmapped address 0xa66 testing: random write/read operations
    #Address 0xa66 read value
    csrr x14, 0xa66

    #Address 0xa66 Write value 0x7eafde7e
    li x3, 0x7eafde7e
    csrw 0xa66, x3

    #Address 0xa66 read value
    csrr x14, 0xa66

    #Address 0xa66 Write value 0xf4867b07
    li x3, 0xf4867b07
    csrw 0xa66, x3

    #Address 0xa66 read value
    csrr x14, 0xa66

    #Unmapped address 0xc9 testing: random write/read operations
    #Address 0xc9 Write value 0x5f81fdd8
    li x3, 0x5f81fdd8
    csrw 0xc9, x3

    #Address 0xc9 Write value 0xf4b6a5c
    li x3, 0xf4b6a5c
    csrw 0xc9, x3

    #Address 0xc9 Write value 0xb1dc2d7a
    li x3, 0xb1dc2d7a
    csrw 0xc9, x3

    #Mapped address 0xb9d (mhpmcounterh29) testing: random write/read operations
    #Address 0xb9d read value
    csrr x14, 0xb9d

    #Address 0xb9d Write value 0x98f7c050
    li x3, 0x98f7c050
    csrw 0xb9d, x3

    #Address 0xb9d read value
    csrr x14, 0xb9d

    #Unmapped address 0xdb8 testing: random write/read operations
    #Address 0xdb8 Write value 0x5a733c69
    li x3, 0x5a733c69
    csrw 0xdb8, x3

    #Address 0xdb8 Write value 0x239cc840
    li x3, 0x239cc840
    csrw 0xdb8, x3

    #Address 0xdb8 Write value 0xfad7fb35
    li x3, 0xfad7fb35
    csrw 0xdb8, x3

    #Address 0xdb8 Write value 0x4a60729d
    li x3, 0x4a60729d
    csrw 0xdb8, x3

    #Address 0xdb8 read value
    csrr x14, 0xdb8

    #Unmapped address 0x466 testing: random write/read operations
    #Address 0x466 Write value 0xf2443510
    li x3, 0xf2443510
    csrw 0x466, x3

    #Unmapped address 0xf4a testing: random write/read operations
    #Address 0xf4a Write value 0xca6682ca
    li x3, 0xca6682ca
    csrw 0xf4a, x3

    #Address 0xf4a read value
    csrr x14, 0xf4a

    #Address 0xf4a Write value 0x9e65ee1
    li x3, 0x9e65ee1
    csrw 0xf4a, x3

    #Address 0xf4a Write value 0xe2d52d16
    li x3, 0xe2d52d16
    csrw 0xf4a, x3

    #Address 0xf4a read value
    csrr x14, 0xf4a

    #Unmapped address 0x72e testing: random write/read operations
    #Address 0x72e read value
    csrr x14, 0x72e

    #Address 0x72e Write value 0xb6212174
    li x3, 0xb6212174
    csrw 0x72e, x3

    #Address 0x72e read value
    csrr x14, 0x72e

    #Address 0x72e read value
    csrr x14, 0x72e

    #Unmapped address 0xd6b testing: random write/read operations
    #Address 0xd6b read value
    csrr x14, 0xd6b

    #Address 0xd6b read value
    csrr x14, 0xd6b

    #Address 0xd6b read value
    csrr x14, 0xd6b

    #Unmapped address 0x4a0 testing: random write/read operations
    #Address 0x4a0 read value
    csrr x14, 0x4a0

    #Address 0x4a0 read value
    csrr x14, 0x4a0

    #Address 0x4a0 Write value 0x8d23ff6d
    li x3, 0x8d23ff6d
    csrw 0x4a0, x3

    #Unmapped address 0x4d testing: random write/read operations
    #Address 0x4d read value
    csrr x14, 0x4d

    #Address 0x4d read value
    csrr x14, 0x4d

    #Unmapped address 0x29 testing: random write/read operations
    #Address 0x29 read value
    csrr x14, 0x29

    #Address 0x29 read value
    csrr x14, 0x29

    #Address 0x29 Write value 0x50f9d7d7
    li x3, 0x50f9d7d7
    csrw 0x29, x3

    #Unmapped address 0x233 testing: random write/read operations
    #Address 0x233 Write value 0x92e4a716
    li x3, 0x92e4a716
    csrw 0x233, x3

    #Address 0x233 Write value 0xc53b1cea
    li x3, 0xc53b1cea
    csrw 0x233, x3

    #Address 0x233 read value
    csrr x14, 0x233

    #Unmapped address 0x765 testing: random write/read operations
    #Address 0x765 Write value 0xdcb54f6a
    li x3, 0xdcb54f6a
    csrw 0x765, x3

    #Address 0x765 read value
    csrr x14, 0x765

    #Address 0x765 Write value 0xd1a6b307
    li x3, 0xd1a6b307
    csrw 0x765, x3

    #Address 0x765 read value
    csrr x14, 0x765

    #Unmapped address 0x664 testing: random write/read operations
    #Address 0x664 read value
    csrr x14, 0x664

    #Address 0x664 read value
    csrr x14, 0x664

    #Address 0x664 read value
    csrr x14, 0x664

    #Unmapped address 0xaf9 testing: random write/read operations
    #Address 0xaf9 Write value 0x4ce8ea05
    li x3, 0x4ce8ea05
    csrw 0xaf9, x3

    #Address 0xaf9 Write value 0x12dd0677
    li x3, 0x12dd0677
    csrw 0xaf9, x3

    #Address 0xaf9 read value
    csrr x14, 0xaf9

    #Unmapped address 0x70a testing: random write/read operations
    #Address 0x70a read value
    csrr x14, 0x70a

    #Address 0x70a Write value 0x3affa6af
    li x3, 0x3affa6af
    csrw 0x70a, x3

    #Address 0x70a Write value 0x27561708
    li x3, 0x27561708
    csrw 0x70a, x3

    #Unmapped address 0x13 testing: random write/read operations
    #Address 0x13 Write value 0x2c2dee90
    li x3, 0x2c2dee90
    csrw 0x13, x3

    #Address 0x13 read value
    csrr x14, 0x13

    #Address 0x13 read value
    csrr x14, 0x13

    #Address 0x13 read value
    csrr x14, 0x13

    #Unmapped address 0xd48 testing: random write/read operations
    #Address 0xd48 Write value 0xf0957534
    li x3, 0xf0957534
    csrw 0xd48, x3

    #Address 0xd48 read value
    csrr x14, 0xd48

    #Address 0xd48 Write value 0xf79313cd
    li x3, 0xf79313cd
    csrw 0xd48, x3

    #Address 0xd48 read value
    csrr x14, 0xd48

    #Address 0xd48 read value
    csrr x14, 0xd48

    #Unmapped address 0x875 testing: random write/read operations
    #Address 0x875 Write value 0x67a87818
    li x3, 0x67a87818
    csrw 0x875, x3

    #Address 0x875 read value
    csrr x14, 0x875

    #Address 0x875 read value
    csrr x14, 0x875

    #Unmapped address 0x6c0 testing: random write/read operations
    #Address 0x6c0 Write value 0xb966b10f
    li x3, 0xb966b10f
    csrw 0x6c0, x3

    #Unmapped address 0x97c testing: random write/read operations
    #Address 0x97c read value
    csrr x14, 0x97c

    #Address 0x97c Write value 0xc6f07681
    li x3, 0xc6f07681
    csrw 0x97c, x3

    #Address 0x97c Write value 0xb2fc0a24
    li x3, 0xb2fc0a24
    csrw 0x97c, x3

    #Address 0x97c Write value 0x6f81a3c9
    li x3, 0x6f81a3c9
    csrw 0x97c, x3

    #Unmapped address 0xe20 testing: random write/read operations
    #Address 0xe20 Write value 0xe76580c1
    li x3, 0xe76580c1
    csrw 0xe20, x3

    #Address 0xe20 Write value 0xbcbd1573
    li x3, 0xbcbd1573
    csrw 0xe20, x3

    #Unmapped address 0x37b testing: random write/read operations
    #Address 0x37b Write value 0x1f6c051a
    li x3, 0x1f6c051a
    csrw 0x37b, x3

    #Address 0x37b read value
    csrr x14, 0x37b

    #Unmapped address 0xad0 testing: random write/read operations
    #Address 0xad0 Write value 0x175cdcf9
    li x3, 0x175cdcf9
    csrw 0xad0, x3

    #Address 0xad0 read value
    csrr x14, 0xad0

    #Address 0xad0 read value
    csrr x14, 0xad0

    #Unmapped address 0xd9c testing: random write/read operations
    #Address 0xd9c Write value 0xace1422e
    li x3, 0xace1422e
    csrw 0xd9c, x3

    #Address 0xd9c Write value 0xf59f9a0c
    li x3, 0xf59f9a0c
    csrw 0xd9c, x3

    #Address 0xd9c Write value 0x11e95c62
    li x3, 0x11e95c62
    csrw 0xd9c, x3

    #Unmapped address 0xd1d testing: random write/read operations
    #Address 0xd1d Write value 0x6b2d17c7
    li x3, 0x6b2d17c7
    csrw 0xd1d, x3

    #Unmapped address 0x75b testing: random write/read operations
    #Address 0x75b read value
    csrr x14, 0x75b

    #Address 0x75b Write value 0x16e422fa
    li x3, 0x16e422fa
    csrw 0x75b, x3

    #Address 0x75b Write value 0xdbdda736
    li x3, 0xdbdda736
    csrw 0x75b, x3

    #Unmapped address 0xdb testing: random write/read operations
    #Address 0xdb Write value 0x644ea272
    li x3, 0x644ea272
    csrw 0xdb, x3

    #Address 0xdb read value
    csrr x14, 0xdb

    #Address 0xdb read value
    csrr x14, 0xdb

    #Address 0xdb read value
    csrr x14, 0xdb

    #Unmapped address 0xa1f testing: random write/read operations
    #Address 0xa1f Write value 0xf0e7a74f
    li x3, 0xf0e7a74f
    csrw 0xa1f, x3

    #Address 0xa1f read value
    csrr x14, 0xa1f

    #Address 0xa1f read value
    csrr x14, 0xa1f

    #Address 0xa1f Write value 0x28d1ba6e
    li x3, 0x28d1ba6e
    csrw 0xa1f, x3

    #Address 0xa1f read value
    csrr x14, 0xa1f

    #Unmapped address 0xb2e testing: random write/read operations
    #Address 0xb2e read value
    csrr x14, 0xb2e

    #Address 0xb2e read value
    csrr x14, 0xb2e

    #Address 0xb2e Write value 0xdb633848
    li x3, 0xdb633848
    csrw 0xb2e, x3

    #Unmapped address 0x4cd testing: random write/read operations
    #Address 0x4cd Write value 0x149fcd00
    li x3, 0x149fcd00
    csrw 0x4cd, x3

    #Address 0x4cd read value
    csrr x14, 0x4cd

    #Address 0x4cd read value
    csrr x14, 0x4cd

    #Address 0x4cd Write value 0x1e1f2d80
    li x3, 0x1e1f2d80
    csrw 0x4cd, x3

    #Address 0x4cd read value
    csrr x14, 0x4cd

    #Unmapped address 0xfdb testing: random write/read operations
    #Address 0xfdb read value
    csrr x14, 0xfdb

    #Address 0xfdb Write value 0xeeb084f
    li x3, 0xeeb084f
    csrw 0xfdb, x3

    #Address 0xfdb read value
    csrr x14, 0xfdb

    #Address 0xfdb read value
    csrr x14, 0xfdb

    #Address 0xfdb Write value 0xd1dc2c7d
    li x3, 0xd1dc2c7d
    csrw 0xfdb, x3

    #Unmapped address 0x1d9 testing: random write/read operations
    #Address 0x1d9 Write value 0x3fb8ff48
    li x3, 0x3fb8ff48
    csrw 0x1d9, x3

    #Address 0x1d9 Write value 0xae3e45fc
    li x3, 0xae3e45fc
    csrw 0x1d9, x3

    #Address 0x1d9 Write value 0x4299b6c
    li x3, 0x4299b6c
    csrw 0x1d9, x3

    #Address 0x1d9 Write value 0xb74f2639
    li x3, 0xb74f2639
    csrw 0x1d9, x3

    #Address 0x1d9 read value
    csrr x14, 0x1d9

    #Unmapped address 0x6be testing: random write/read operations
    #Address 0x6be read value
    csrr x14, 0x6be

    #Address 0x6be Write value 0x68fd6816
    li x3, 0x68fd6816
    csrw 0x6be, x3

    #Unmapped address 0x2cc testing: random write/read operations
    #Address 0x2cc read value
    csrr x14, 0x2cc

    #Address 0x2cc read value
    csrr x14, 0x2cc

    #Address 0x2cc read value
    csrr x14, 0x2cc

    #Address 0x2cc Write value 0xa8dad530
    li x3, 0xa8dad530
    csrw 0x2cc, x3

    #Address 0x2cc read value
    csrr x14, 0x2cc

    #Unmapped address 0xcdd testing: random write/read operations
    #Address 0xcdd read value
    csrr x14, 0xcdd

    #Address 0xcdd read value
    csrr x14, 0xcdd

    #Unmapped address 0x2e2 testing: random write/read operations
    #Address 0x2e2 Write value 0x4d704225
    li x3, 0x4d704225
    csrw 0x2e2, x3

    #Address 0x2e2 Write value 0x27d82547
    li x3, 0x27d82547
    csrw 0x2e2, x3

    #Address 0x2e2 Write value 0x8068e95b
    li x3, 0x8068e95b
    csrw 0x2e2, x3

    #Address 0x2e2 Write value 0x3cb28db6
    li x3, 0x3cb28db6
    csrw 0x2e2, x3

    #Address 0x2e2 Write value 0xc357c906
    li x3, 0xc357c906
    csrw 0x2e2, x3

    #Unmapped address 0xd82 testing: random write/read operations
    #Address 0xd82 Write value 0x7e8cc364
    li x3, 0x7e8cc364
    csrw 0xd82, x3

    #Address 0xd82 read value
    csrr x14, 0xd82

    #Unmapped address 0xe07 testing: random write/read operations
    #Address 0xe07 Write value 0x4ef1a3cc
    li x3, 0x4ef1a3cc
    csrw 0xe07, x3

    #Address 0xe07 read value
    csrr x14, 0xe07

    #Address 0xe07 Write value 0x91f7fa8f
    li x3, 0x91f7fa8f
    csrw 0xe07, x3

    #Address 0xe07 read value
    csrr x14, 0xe07

    #Address 0xe07 Write value 0xb3e1cd4a
    li x3, 0xb3e1cd4a
    csrw 0xe07, x3

    #Unmapped address 0x90a testing: random write/read operations
    #Address 0x90a Write value 0x3ffc811c
    li x3, 0x3ffc811c
    csrw 0x90a, x3

    #Address 0x90a read value
    csrr x14, 0x90a

    #Unmapped address 0x280 testing: random write/read operations
    #Address 0x280 read value
    csrr x14, 0x280

    #Address 0x280 read value
    csrr x14, 0x280

    #Address 0x280 read value
    csrr x14, 0x280

    #Address 0x280 Write value 0x882e2429
    li x3, 0x882e2429
    csrw 0x280, x3

    #Address 0x280 Write value 0xc06df63
    li x3, 0xc06df63
    csrw 0x280, x3

    #Unmapped address 0xa8 testing: random write/read operations
    #Address 0xa8 Write value 0x89d76909
    li x3, 0x89d76909
    csrw 0xa8, x3

    #Unmapped address 0x6b testing: random write/read operations
    #Address 0x6b Write value 0xaf37a839
    li x3, 0xaf37a839
    csrw 0x6b, x3

    #Address 0x6b read value
    csrr x14, 0x6b

    #Address 0x6b read value
    csrr x14, 0x6b

    #Address 0x6b Write value 0x3ffbd663
    li x3, 0x3ffbd663
    csrw 0x6b, x3

    #Unmapped address 0xdf3 testing: random write/read operations
    #Address 0xdf3 read value
    csrr x14, 0xdf3

    #Address 0xdf3 Write value 0x1a3a56ab
    li x3, 0x1a3a56ab
    csrw 0xdf3, x3

    #Address 0xdf3 Write value 0x192a2a42
    li x3, 0x192a2a42
    csrw 0xdf3, x3

    #Address 0xdf3 read value
    csrr x14, 0xdf3

    #Address 0xdf3 Write value 0xbfd5abb1
    li x3, 0xbfd5abb1
    csrw 0xdf3, x3

    #Unmapped address 0xc95 testing: random write/read operations
    #Address 0xc95 Write value 0xe30d331f
    li x3, 0xe30d331f
    csrw 0xc95, x3

    #Address 0xc95 read value
    csrr x14, 0xc95

    #Address 0xc95 read value
    csrr x14, 0xc95

    #Unmapped address 0x2a1 testing: random write/read operations
    #Address 0x2a1 read value
    csrr x14, 0x2a1

    #Address 0x2a1 Write value 0xb102c5a8
    li x3, 0xb102c5a8
    csrw 0x2a1, x3

    #Address 0x2a1 Write value 0x1f2b72b4
    li x3, 0x1f2b72b4
    csrw 0x2a1, x3

    #Address 0x2a1 read value
    csrr x14, 0x2a1

    #Address 0x2a1 Write value 0xc02a8c56
    li x3, 0xc02a8c56
    csrw 0x2a1, x3

    #Unmapped address 0xbcc testing: random write/read operations
    #Address 0xbcc Write value 0xc365d885
    li x3, 0xc365d885
    csrw 0xbcc, x3

    #Address 0xbcc Write value 0xa7cddcb9
    li x3, 0xa7cddcb9
    csrw 0xbcc, x3

    #Address 0xbcc Write value 0xfe76d409
    li x3, 0xfe76d409
    csrw 0xbcc, x3

    #Address 0xbcc read value
    csrr x14, 0xbcc

    #Address 0xbcc Write value 0xc8bc1b87
    li x3, 0xc8bc1b87
    csrw 0xbcc, x3

    #Unmapped address 0x7bf testing: random write/read operations
    #Address 0x7bf read value
    csrr x14, 0x7bf

    #Address 0x7bf Write value 0x1b13ed42
    li x3, 0x1b13ed42
    csrw 0x7bf, x3

    #Unmapped address 0xbbb testing: random write/read operations
    #Address 0xbbb read value
    csrr x14, 0xbbb

    #Address 0xbbb Write value 0xa40a86f7
    li x3, 0xa40a86f7
    csrw 0xbbb, x3

    #Address 0xbbb read value
    csrr x14, 0xbbb

    #Unmapped address 0x8b7 testing: random write/read operations
    #Address 0x8b7 read value
    csrr x14, 0x8b7

    #Address 0x8b7 Write value 0x3fde5c6c
    li x3, 0x3fde5c6c
    csrw 0x8b7, x3

    #Address 0x8b7 Write value 0xa7666e3e
    li x3, 0xa7666e3e
    csrw 0x8b7, x3

    #Address 0x8b7 Write value 0x18a3b3a9
    li x3, 0x18a3b3a9
    csrw 0x8b7, x3

    #Address 0x8b7 Write value 0xa7639bea
    li x3, 0xa7639bea
    csrw 0x8b7, x3

    #Unmapped address 0x367 testing: random write/read operations
    #Address 0x367 Write value 0x5a7be222
    li x3, 0x5a7be222
    csrw 0x367, x3

    #Address 0x367 Write value 0xb857b91b
    li x3, 0xb857b91b
    csrw 0x367, x3

    #Address 0x367 read value
    csrr x14, 0x367

    #Address 0x367 Write value 0x52a84e65
    li x3, 0x52a84e65
    csrw 0x367, x3

    #Address 0x367 read value
    csrr x14, 0x367

    #Unmapped address 0x67d testing: random write/read operations
    #Address 0x67d read value
    csrr x14, 0x67d

    #Unmapped address 0xebd testing: random write/read operations
    #Address 0xebd read value
    csrr x14, 0xebd

    #Unmapped address 0x88 testing: random write/read operations
    #Address 0x88 Write value 0xc8ec8db5
    li x3, 0xc8ec8db5
    csrw 0x88, x3

    #Unmapped address 0x598 testing: random write/read operations
    #Address 0x598 read value
    csrr x14, 0x598

    #Address 0x598 read value
    csrr x14, 0x598

    #Address 0x598 read value
    csrr x14, 0x598

    #Unmapped address 0xa89 testing: random write/read operations
    #Address 0xa89 read value
    csrr x14, 0xa89

    #Address 0xa89 Write value 0x9b9e7b02
    li x3, 0x9b9e7b02
    csrw 0xa89, x3

    #Unmapped address 0x49 testing: random write/read operations
    #Address 0x49 Write value 0xbd69f43e
    li x3, 0xbd69f43e
    csrw 0x49, x3

    #Address 0x49 Write value 0xc8de0d
    li x3, 0xc8de0d
    csrw 0x49, x3

    #Address 0x49 Write value 0x849e9190
    li x3, 0x849e9190
    csrw 0x49, x3

    #Address 0x49 Write value 0x834008eb
    li x3, 0x834008eb
    csrw 0x49, x3

    #Address 0x49 read value
    csrr x14, 0x49

    #Unmapped address 0x2d1 testing: random write/read operations
    #Address 0x2d1 Write value 0x158487e4
    li x3, 0x158487e4
    csrw 0x2d1, x3

    #Address 0x2d1 read value
    csrr x14, 0x2d1

    #Address 0x2d1 read value
    csrr x14, 0x2d1

    #Address 0x2d1 Write value 0xd3ddcc04
    li x3, 0xd3ddcc04
    csrw 0x2d1, x3

    #Address 0x2d1 read value
    csrr x14, 0x2d1

    #Unmapped address 0x681 testing: random write/read operations
    #Address 0x681 read value
    csrr x14, 0x681

    #Address 0x681 Write value 0xb02e3afd
    li x3, 0xb02e3afd
    csrw 0x681, x3

    #Address 0x681 Write value 0xd375519a
    li x3, 0xd375519a
    csrw 0x681, x3

    #Unmapped address 0xd28 testing: random write/read operations
    #Address 0xd28 Write value 0x62386a75
    li x3, 0x62386a75
    csrw 0xd28, x3

    #Unmapped address 0xdf1 testing: random write/read operations
    #Address 0xdf1 Write value 0x9ea1185a
    li x3, 0x9ea1185a
    csrw 0xdf1, x3

    #Unmapped address 0x42 testing: random write/read operations
    #Address 0x42 read value
    csrr x14, 0x42

    #Unmapped address 0xfd9 testing: random write/read operations
    #Address 0xfd9 Write value 0x7c4145d2
    li x3, 0x7c4145d2
    csrw 0xfd9, x3

    #Address 0xfd9 read value
    csrr x14, 0xfd9

    #Address 0xfd9 Write value 0x8d4994ec
    li x3, 0x8d4994ec
    csrw 0xfd9, x3

    #Address 0xfd9 Write value 0x9ca94009
    li x3, 0x9ca94009
    csrw 0xfd9, x3

    #Address 0xfd9 Write value 0x632a8b91
    li x3, 0x632a8b91
    csrw 0xfd9, x3

    #Unmapped address 0xb58 testing: random write/read operations
    #Address 0xb58 read value
    csrr x14, 0xb58

    #Address 0xb58 Write value 0x71ef6202
    li x3, 0x71ef6202
    csrw 0xb58, x3

    #Address 0xb58 Write value 0xa1096058
    li x3, 0xa1096058
    csrw 0xb58, x3

    #Address 0xb58 read value
    csrr x14, 0xb58

    #Unmapped address 0xe15 testing: random write/read operations
    #Address 0xe15 Write value 0x66356e5c
    li x3, 0x66356e5c
    csrw 0xe15, x3

    #Address 0xe15 read value
    csrr x14, 0xe15

    #Address 0xe15 read value
    csrr x14, 0xe15

    #Address 0xe15 read value
    csrr x14, 0xe15

    #Unmapped address 0x5c6 testing: random write/read operations
    #Address 0x5c6 read value
    csrr x14, 0x5c6

    #Address 0x5c6 read value
    csrr x14, 0x5c6

    #Address 0x5c6 read value
    csrr x14, 0x5c6

    #Unmapped address 0x724 testing: random write/read operations
    #Address 0x724 Write value 0xc25fb169
    li x3, 0xc25fb169
    csrw 0x724, x3

    #Address 0x724 Write value 0x4222dfd8
    li x3, 0x4222dfd8
    csrw 0x724, x3

    #Unmapped address 0xa51 testing: random write/read operations
    #Address 0xa51 Write value 0x26e7a654
    li x3, 0x26e7a654
    csrw 0xa51, x3

    #Unmapped address 0x9fe testing: random write/read operations
    #Address 0x9fe read value
    csrr x14, 0x9fe

    #Address 0x9fe Write value 0x966e35
    li x3, 0x966e35
    csrw 0x9fe, x3

    #Address 0x9fe Write value 0x9961858c
    li x3, 0x9961858c
    csrw 0x9fe, x3

    #Unmapped address 0xe10 testing: random write/read operations
    #Address 0xe10 Write value 0x3990a235
    li x3, 0x3990a235
    csrw 0xe10, x3

    #Address 0xe10 Write value 0xb305d415
    li x3, 0xb305d415
    csrw 0xe10, x3

    #Unmapped address 0xaed testing: random write/read operations
    #Address 0xaed Write value 0x7524499e
    li x3, 0x7524499e
    csrw 0xaed, x3

    #Address 0xaed Write value 0xb865938f
    li x3, 0xb865938f
    csrw 0xaed, x3

    #Address 0xaed Write value 0xf25713f2
    li x3, 0xf25713f2
    csrw 0xaed, x3

    #Address 0xaed Write value 0xbed762b
    li x3, 0xbed762b
    csrw 0xaed, x3

    #Unmapped address 0xff3 testing: random write/read operations
    #Address 0xff3 read value
    csrr x14, 0xff3

    #Address 0xff3 read value
    csrr x14, 0xff3

    #Address 0xff3 Write value 0xa81ef700
    li x3, 0xa81ef700
    csrw 0xff3, x3

    #Address 0xff3 read value
    csrr x14, 0xff3

    #Address 0xff3 read value
    csrr x14, 0xff3

    #Unmapped address 0x2f7 testing: random write/read operations
    #Address 0x2f7 Write value 0x8d4d24a2
    li x3, 0x8d4d24a2
    csrw 0x2f7, x3

    #Address 0x2f7 Write value 0xf2ff0bfe
    li x3, 0xf2ff0bfe
    csrw 0x2f7, x3

    #Address 0x2f7 read value
    csrr x14, 0x2f7

    #Unmapped address 0x5a9 testing: random write/read operations
    #Address 0x5a9 read value
    csrr x14, 0x5a9

    #Address 0x5a9 read value
    csrr x14, 0x5a9

    #Address 0x5a9 read value
    csrr x14, 0x5a9

    #Address 0x5a9 Write value 0xfdbba3e8
    li x3, 0xfdbba3e8
    csrw 0x5a9, x3

    #Address 0x5a9 Write value 0x3ec5b064
    li x3, 0x3ec5b064
    csrw 0x5a9, x3

    #Unmapped address 0xaec testing: random write/read operations
    #Address 0xaec read value
    csrr x14, 0xaec

    #Address 0xaec Write value 0xbf20a7b3
    li x3, 0xbf20a7b3
    csrw 0xaec, x3

    #Address 0xaec Write value 0x4782c5ef
    li x3, 0x4782c5ef
    csrw 0xaec, x3

    #Address 0xaec Write value 0x6d406d32
    li x3, 0x6d406d32
    csrw 0xaec, x3

    #Unmapped address 0xe62 testing: random write/read operations
    #Address 0xe62 Write value 0xe8c73e55
    li x3, 0xe8c73e55
    csrw 0xe62, x3

    #Unmapped address 0xb68 testing: random write/read operations
    #Address 0xb68 read value
    csrr x14, 0xb68

    #Address 0xb68 Write value 0x45031643
    li x3, 0x45031643
    csrw 0xb68, x3

    #Address 0xb68 Write value 0x4ea29fc6
    li x3, 0x4ea29fc6
    csrw 0xb68, x3

    #Address 0xb68 read value
    csrr x14, 0xb68

    #Address 0xb68 read value
    csrr x14, 0xb68

    #Unmapped address 0x39b testing: random write/read operations
    #Address 0x39b read value
    csrr x14, 0x39b

    #Address 0x39b read value
    csrr x14, 0x39b

    #Address 0x39b read value
    csrr x14, 0x39b

    #Address 0x39b read value
    csrr x14, 0x39b

    #Address 0x39b Write value 0xf95a69b6
    li x3, 0xf95a69b6
    csrw 0x39b, x3

    #Unmapped address 0x4d6 testing: random write/read operations
    #Address 0x4d6 read value
    csrr x14, 0x4d6

    #Address 0x4d6 read value
    csrr x14, 0x4d6

    #Address 0x4d6 Write value 0x62a70aa4
    li x3, 0x62a70aa4
    csrw 0x4d6, x3

    #Unmapped address 0xe31 testing: random write/read operations
    #Address 0xe31 Write value 0xa2117489
    li x3, 0xa2117489
    csrw 0xe31, x3

    #Address 0xe31 read value
    csrr x14, 0xe31

    #Address 0xe31 read value
    csrr x14, 0xe31

    #Unmapped address 0xc7a testing: random write/read operations
    #Address 0xc7a Write value 0x2e155e5b
    li x3, 0x2e155e5b
    csrw 0xc7a, x3

    #Address 0xc7a read value
    csrr x14, 0xc7a

    #Unmapped address 0x1f3 testing: random write/read operations
    #Address 0x1f3 read value
    csrr x14, 0x1f3

    #Address 0x1f3 read value
    csrr x14, 0x1f3

    #Address 0x1f3 read value
    csrr x14, 0x1f3

    #Address 0x1f3 Write value 0x98e994cd
    li x3, 0x98e994cd
    csrw 0x1f3, x3

    #Address 0x1f3 read value
    csrr x14, 0x1f3

    #Unmapped address 0x171 testing: random write/read operations
    #Address 0x171 read value
    csrr x14, 0x171

    #Unmapped address 0x25b testing: random write/read operations
    #Address 0x25b Write value 0x9be2de73
    li x3, 0x9be2de73
    csrw 0x25b, x3

    #Address 0x25b read value
    csrr x14, 0x25b

    #Address 0x25b Write value 0xc0e2446d
    li x3, 0xc0e2446d
    csrw 0x25b, x3

    #Address 0x25b read value
    csrr x14, 0x25b

    #Address 0x25b read value
    csrr x14, 0x25b

    #Unmapped address 0x294 testing: random write/read operations
    #Address 0x294 read value
    csrr x14, 0x294

    #Address 0x294 Write value 0x2cde0c63
    li x3, 0x2cde0c63
    csrw 0x294, x3

    #Unmapped address 0x73c testing: random write/read operations
    #Address 0x73c read value
    csrr x14, 0x73c

    #Unmapped address 0x89 testing: random write/read operations
    #Address 0x89 read value
    csrr x14, 0x89

    #Address 0x89 Write value 0x1daa32dc
    li x3, 0x1daa32dc
    csrw 0x89, x3

    #Unmapped address 0x455 testing: random write/read operations
    #Address 0x455 Write value 0xc4732a9b
    li x3, 0xc4732a9b
    csrw 0x455, x3

    #Address 0x455 read value
    csrr x14, 0x455

    #Unmapped address 0xe8e testing: random write/read operations
    #Address 0xe8e read value
    csrr x14, 0xe8e

    #Address 0xe8e read value
    csrr x14, 0xe8e

    #Address 0xe8e read value
    csrr x14, 0xe8e

    #Address 0xe8e read value
    csrr x14, 0xe8e

    #Unmapped address 0xca0 testing: random write/read operations
    #Address 0xca0 Write value 0x6a4a0512
    li x3, 0x6a4a0512
    csrw 0xca0, x3

    #Address 0xca0 Write value 0xac9422d0
    li x3, 0xac9422d0
    csrw 0xca0, x3

    #Address 0xca0 read value
    csrr x14, 0xca0

    #Address 0xca0 Write value 0x8a4bb14f
    li x3, 0x8a4bb14f
    csrw 0xca0, x3

    #Address 0xca0 read value
    csrr x14, 0xca0

    #Unmapped address 0x9a testing: random write/read operations
    #Address 0x9a Write value 0x99015400
    li x3, 0x99015400
    csrw 0x9a, x3

    #Address 0x9a Write value 0xe97f043a
    li x3, 0xe97f043a
    csrw 0x9a, x3

    #Unmapped address 0x94d testing: random write/read operations
    #Address 0x94d Write value 0x2c7d763d
    li x3, 0x2c7d763d
    csrw 0x94d, x3

    #Address 0x94d read value
    csrr x14, 0x94d

    #Address 0x94d read value
    csrr x14, 0x94d

    #Address 0x94d Write value 0x47bfbab1
    li x3, 0x47bfbab1
    csrw 0x94d, x3

    #Unmapped address 0xca2 testing: random write/read operations
    #Address 0xca2 read value
    csrr x14, 0xca2

    #Address 0xca2 Write value 0x92dad0b5
    li x3, 0x92dad0b5
    csrw 0xca2, x3

    #Address 0xca2 Write value 0x3981d5ce
    li x3, 0x3981d5ce
    csrw 0xca2, x3

    #Address 0xca2 Write value 0xf7de71c2
    li x3, 0xf7de71c2
    csrw 0xca2, x3

    #Unmapped address 0x37d testing: random write/read operations
    #Address 0x37d Write value 0x34f91832
    li x3, 0x34f91832
    csrw 0x37d, x3

    #Address 0x37d Write value 0x2e1b68a8
    li x3, 0x2e1b68a8
    csrw 0x37d, x3

    #Address 0x37d read value
    csrr x14, 0x37d

    #Address 0x37d read value
    csrr x14, 0x37d

    #Address 0x37d Write value 0x17df7013
    li x3, 0x17df7013
    csrw 0x37d, x3

    #Unmapped address 0xc89 testing: random write/read operations
    #Address 0xc89 read value
    csrr x14, 0xc89

    #Address 0xc89 Write value 0xb061f16e
    li x3, 0xb061f16e
    csrw 0xc89, x3

    #Unmapped address 0xa42 testing: random write/read operations
    #Address 0xa42 read value
    csrr x14, 0xa42

    #Unmapped address 0xd32 testing: random write/read operations
    #Address 0xd32 read value
    csrr x14, 0xd32

    #Unmapped address 0x843 testing: random write/read operations
    #Address 0x843 Write value 0xfef68148
    li x3, 0xfef68148
    csrw 0x843, x3

    #Unmapped address 0x169 testing: random write/read operations
    #Address 0x169 read value
    csrr x14, 0x169

    #Address 0x169 Write value 0x39a6f5e5
    li x3, 0x39a6f5e5
    csrw 0x169, x3

    #Address 0x169 read value
    csrr x14, 0x169

    #Unmapped address 0x4d7 testing: random write/read operations
    #Address 0x4d7 read value
    csrr x14, 0x4d7

    #Unmapped address 0x572 testing: random write/read operations
    #Address 0x572 Write value 0x296e4c7e
    li x3, 0x296e4c7e
    csrw 0x572, x3

    #Unmapped address 0x2b1 testing: random write/read operations
    #Address 0x2b1 Write value 0x741299bf
    li x3, 0x741299bf
    csrw 0x2b1, x3

    #Unmapped address 0xc90 testing: random write/read operations
    #Address 0xc90 read value
    csrr x14, 0xc90

    #Address 0xc90 Write value 0xd081e29b
    li x3, 0xd081e29b
    csrw 0xc90, x3

    #Address 0xc90 Write value 0x8b270e07
    li x3, 0x8b270e07
    csrw 0xc90, x3

    #Address 0xc90 read value
    csrr x14, 0xc90

    #Unmapped address 0x467 testing: random write/read operations
    #Address 0x467 Write value 0xe1972fbe
    li x3, 0xe1972fbe
    csrw 0x467, x3

    #Address 0x467 read value
    csrr x14, 0x467

    #Address 0x467 read value
    csrr x14, 0x467

    #Unmapped address 0x9b4 testing: random write/read operations
    #Address 0x9b4 Write value 0xec6b0e9b
    li x3, 0xec6b0e9b
    csrw 0x9b4, x3

    #Address 0x9b4 read value
    csrr x14, 0x9b4

    #Address 0x9b4 Write value 0x12df0361
    li x3, 0x12df0361
    csrw 0x9b4, x3

    #Address 0x9b4 read value
    csrr x14, 0x9b4

    #Address 0x9b4 Write value 0x81b6fa9
    li x3, 0x81b6fa9
    csrw 0x9b4, x3

    #Unmapped address 0x785 testing: random write/read operations
    #Address 0x785 Write value 0xedacda9b
    li x3, 0xedacda9b
    csrw 0x785, x3

    #Address 0x785 Write value 0x5183868a
    li x3, 0x5183868a
    csrw 0x785, x3

    #Unmapped address 0xd05 testing: random write/read operations
    #Address 0xd05 read value
    csrr x14, 0xd05

    #Unmapped address 0xaa testing: random write/read operations
    #Address 0xaa read value
    csrr x14, 0xaa

    #Address 0xaa read value
    csrr x14, 0xaa

    #Address 0xaa read value
    csrr x14, 0xaa

    #Address 0xaa read value
    csrr x14, 0xaa

    #Unmapped address 0xd5e testing: random write/read operations
    #Address 0xd5e read value
    csrr x14, 0xd5e

    #Address 0xd5e Write value 0xdcb6a196
    li x3, 0xdcb6a196
    csrw 0xd5e, x3

    #Address 0xd5e read value
    csrr x14, 0xd5e

    #Address 0xd5e Write value 0xc183595e
    li x3, 0xc183595e
    csrw 0xd5e, x3

    #Unmapped address 0x805 testing: random write/read operations
    #Address 0x805 Write value 0xd1d8cdac
    li x3, 0xd1d8cdac
    csrw 0x805, x3

    #Address 0x805 Write value 0x9d504d50
    li x3, 0x9d504d50
    csrw 0x805, x3

    #Address 0x805 read value
    csrr x14, 0x805

    #Address 0x805 read value
    csrr x14, 0x805

    #Unmapped address 0x3cf testing: random write/read operations
    #Address 0x3cf Write value 0x144a3e3e
    li x3, 0x144a3e3e
    csrw 0x3cf, x3

    #Address 0x3cf read value
    csrr x14, 0x3cf

    #Address 0x3cf read value
    csrr x14, 0x3cf

    #Address 0x3cf Write value 0x13bb006c
    li x3, 0x13bb006c
    csrw 0x3cf, x3

    #Unmapped address 0xa59 testing: random write/read operations
    #Address 0xa59 Write value 0xd325bc0a
    li x3, 0xd325bc0a
    csrw 0xa59, x3

    #Address 0xa59 read value
    csrr x14, 0xa59

    #Unmapped address 0xcf6 testing: random write/read operations
    #Address 0xcf6 read value
    csrr x14, 0xcf6

    #Unmapped address 0x8e1 testing: random write/read operations
    #Address 0x8e1 Write value 0x8e290e88
    li x3, 0x8e290e88
    csrw 0x8e1, x3

    #Unmapped address 0xf62 testing: random write/read operations
    #Address 0xf62 read value
    csrr x14, 0xf62

    #Unmapped address 0xf49 testing: random write/read operations
    #Address 0xf49 Write value 0xe92abf78
    li x3, 0xe92abf78
    csrw 0xf49, x3

    #Address 0xf49 Write value 0x3ef397a5
    li x3, 0x3ef397a5
    csrw 0xf49, x3

    #Address 0xf49 Write value 0x10c7fee1
    li x3, 0x10c7fee1
    csrw 0xf49, x3

    #Unmapped address 0xd5a testing: random write/read operations
    #Address 0xd5a read value
    csrr x14, 0xd5a

    #Unmapped address 0xc45 testing: random write/read operations
    #Address 0xc45 Write value 0xe0b40dc8
    li x3, 0xe0b40dc8
    csrw 0xc45, x3

    #Address 0xc45 Write value 0x305a2361
    li x3, 0x305a2361
    csrw 0xc45, x3

    #Address 0xc45 Write value 0xd60d357d
    li x3, 0xd60d357d
    csrw 0xc45, x3

    #Address 0xc45 read value
    csrr x14, 0xc45

    #Unmapped address 0x377 testing: random write/read operations
    #Address 0x377 read value
    csrr x14, 0x377

    #Address 0x377 Write value 0xba7ae445
    li x3, 0xba7ae445
    csrw 0x377, x3

    #Address 0x377 read value
    csrr x14, 0x377

    #Unmapped address 0x7a testing: random write/read operations
    #Address 0x7a read value
    csrr x14, 0x7a

    #Address 0x7a read value
    csrr x14, 0x7a

    #Address 0x7a read value
    csrr x14, 0x7a

    #Address 0x7a read value
    csrr x14, 0x7a

    #Unmapped address 0x203 testing: random write/read operations
    #Address 0x203 read value
    csrr x14, 0x203

    #Address 0x203 Write value 0xc7110fc7
    li x3, 0xc7110fc7
    csrw 0x203, x3

    #Address 0x203 Write value 0x88149790
    li x3, 0x88149790
    csrw 0x203, x3

    #Unmapped address 0xab9 testing: random write/read operations
    #Address 0xab9 Write value 0x14706023
    li x3, 0x14706023
    csrw 0xab9, x3

    #Address 0xab9 read value
    csrr x14, 0xab9

    #Unmapped address 0xb2c testing: random write/read operations
    #Address 0xb2c Write value 0xba0961d2
    li x3, 0xba0961d2
    csrw 0xb2c, x3

    #Address 0xb2c read value
    csrr x14, 0xb2c

    #Address 0xb2c read value
    csrr x14, 0xb2c

    #Address 0xb2c read value
    csrr x14, 0xb2c

    #Unmapped address 0xc18 testing: random write/read operations
    #Address 0xc18 Write value 0x9794c67e
    li x3, 0x9794c67e
    csrw 0xc18, x3

    #Address 0xc18 read value
    csrr x14, 0xc18

    #Address 0xc18 read value
    csrr x14, 0xc18

    #Unmapped address 0x202 testing: random write/read operations
    #Address 0x202 Write value 0x3d01bd31
    li x3, 0x3d01bd31
    csrw 0x202, x3

    #Unmapped address 0xbfe testing: random write/read operations
    #Address 0xbfe read value
    csrr x14, 0xbfe

    #Address 0xbfe Write value 0x4f31264f
    li x3, 0x4f31264f
    csrw 0xbfe, x3

    #Address 0xbfe read value
    csrr x14, 0xbfe

    #Address 0xbfe Write value 0xb2e2d86b
    li x3, 0xb2e2d86b
    csrw 0xbfe, x3

    #Unmapped address 0xdcf testing: random write/read operations
    #Address 0xdcf Write value 0x8af8f9c5
    li x3, 0x8af8f9c5
    csrw 0xdcf, x3

    #Unmapped address 0xcca testing: random write/read operations
    #Address 0xcca read value
    csrr x14, 0xcca

    #Address 0xcca Write value 0x2439da74
    li x3, 0x2439da74
    csrw 0xcca, x3

    #Unmapped address 0x460 testing: random write/read operations
    #Address 0x460 read value
    csrr x14, 0x460

    #Address 0x460 Write value 0x536115e
    li x3, 0x536115e
    csrw 0x460, x3

    #Unmapped address 0x5cb testing: random write/read operations
    #Address 0x5cb read value
    csrr x14, 0x5cb

    #Address 0x5cb read value
    csrr x14, 0x5cb

    #Address 0x5cb read value
    csrr x14, 0x5cb

    #Unmapped address 0x7b6 testing: random write/read operations
    #Address 0x7b6 read value
    csrr x14, 0x7b6

    #Unmapped address 0xf5a testing: random write/read operations
    #Address 0xf5a Write value 0x339985dd
    li x3, 0x339985dd
    csrw 0xf5a, x3

    #Address 0xf5a Write value 0x5871172e
    li x3, 0x5871172e
    csrw 0xf5a, x3

    #Address 0xf5a read value
    csrr x14, 0xf5a

    #Address 0xf5a Write value 0x5aabe4ba
    li x3, 0x5aabe4ba
    csrw 0xf5a, x3

    #Unmapped address 0xff1 testing: random write/read operations
    #Address 0xff1 Write value 0x5e17b1ea
    li x3, 0x5e17b1ea
    csrw 0xff1, x3

    #Address 0xff1 read value
    csrr x14, 0xff1

    #Address 0xff1 read value
    csrr x14, 0xff1

    #Address 0xff1 read value
    csrr x14, 0xff1

    #Unmapped address 0xd3 testing: random write/read operations
    #Address 0xd3 read value
    csrr x14, 0xd3

    #Address 0xd3 read value
    csrr x14, 0xd3

    #Address 0xd3 read value
    csrr x14, 0xd3

    #Address 0xd3 read value
    csrr x14, 0xd3

    #Address 0xd3 Write value 0x2aa37e42
    li x3, 0x2aa37e42
    csrw 0xd3, x3

    #Unmapped address 0x116 testing: random write/read operations
    #Address 0x116 Write value 0xde2e3928
    li x3, 0xde2e3928
    csrw 0x116, x3

    #Address 0x116 read value
    csrr x14, 0x116

    #Address 0x116 read value
    csrr x14, 0x116

    #Unmapped address 0xe56 testing: random write/read operations
    #Address 0xe56 Write value 0x16ae6b76
    li x3, 0x16ae6b76
    csrw 0xe56, x3

    #Address 0xe56 read value
    csrr x14, 0xe56

    #Unmapped address 0xa4d testing: random write/read operations
    #Address 0xa4d Write value 0xd8aa89b5
    li x3, 0xd8aa89b5
    csrw 0xa4d, x3

    #Address 0xa4d read value
    csrr x14, 0xa4d

    #Unmapped address 0x6c1 testing: random write/read operations
    #Address 0x6c1 read value
    csrr x14, 0x6c1

    #Unmapped address 0xd7e testing: random write/read operations
    #Address 0xd7e Write value 0x69f327bf
    li x3, 0x69f327bf
    csrw 0xd7e, x3

    #Address 0xd7e read value
    csrr x14, 0xd7e

    #Address 0xd7e read value
    csrr x14, 0xd7e

    #Address 0xd7e Write value 0x325c7b81
    li x3, 0x325c7b81
    csrw 0xd7e, x3

    #Unmapped address 0xa07 testing: random write/read operations
    #Address 0xa07 Write value 0xf40a2ff9
    li x3, 0xf40a2ff9
    csrw 0xa07, x3

    #Unmapped address 0x41c testing: random write/read operations
    #Address 0x41c Write value 0x612eab80
    li x3, 0x612eab80
    csrw 0x41c, x3

    #Unmapped address 0x4dd testing: random write/read operations
    #Address 0x4dd read value
    csrr x14, 0x4dd

    #Address 0x4dd read value
    csrr x14, 0x4dd

    #Address 0x4dd read value
    csrr x14, 0x4dd

    #Unmapped address 0x9cf testing: random write/read operations
    #Address 0x9cf read value
    csrr x14, 0x9cf

    #Address 0x9cf read value
    csrr x14, 0x9cf

    #Mapped address 0xb17 (mhpmcounter23) testing: random write/read operations
    #Address 0xb17 read value
    csrr x14, 0xb17

    #Address 0xb17 read value
    csrr x14, 0xb17

    #Address 0xb17 read value
    csrr x14, 0xb17

    #Address 0xb17 read value
    csrr x14, 0xb17

    #Unmapped address 0x989 testing: random write/read operations
    #Address 0x989 Write value 0x12af9e83
    li x3, 0x12af9e83
    csrw 0x989, x3

    #Unmapped address 0xae3 testing: random write/read operations
    #Address 0xae3 read value
    csrr x14, 0xae3

    #Address 0xae3 Write value 0x18becae1
    li x3, 0x18becae1
    csrw 0xae3, x3

    #Address 0xae3 Write value 0x394653c6
    li x3, 0x394653c6
    csrw 0xae3, x3

    #Address 0xae3 read value
    csrr x14, 0xae3

    #Address 0xae3 read value
    csrr x14, 0xae3

    #Unmapped address 0x3a7 testing: random write/read operations
    #Address 0x3a7 read value
    csrr x14, 0x3a7

    #Address 0x3a7 read value
    csrr x14, 0x3a7

    #Unmapped address 0x5be testing: random write/read operations
    #Address 0x5be read value
    csrr x14, 0x5be

    #Address 0x5be read value
    csrr x14, 0x5be

    #Address 0x5be Write value 0x23e90417
    li x3, 0x23e90417
    csrw 0x5be, x3

    #Address 0x5be read value
    csrr x14, 0x5be

    #Address 0x5be read value
    csrr x14, 0x5be

    #Unmapped address 0xc8 testing: random write/read operations
    #Address 0xc8 Write value 0xfa12dabe
    li x3, 0xfa12dabe
    csrw 0xc8, x3

    #Unmapped address 0x686 testing: random write/read operations
    #Address 0x686 read value
    csrr x14, 0x686

    #Address 0x686 Write value 0xd632ef71
    li x3, 0xd632ef71
    csrw 0x686, x3

    #Address 0x686 read value
    csrr x14, 0x686

    #Unmapped address 0x29f testing: random write/read operations
    #Address 0x29f read value
    csrr x14, 0x29f

    #Address 0x29f Write value 0x1752e280
    li x3, 0x1752e280
    csrw 0x29f, x3

    #Address 0x29f Write value 0xfe41e1b6
    li x3, 0xfe41e1b6
    csrw 0x29f, x3

    #Unmapped address 0x64a testing: random write/read operations
    #Address 0x64a Write value 0x8233f242
    li x3, 0x8233f242
    csrw 0x64a, x3

    #Address 0x64a Write value 0xa9677c2a
    li x3, 0xa9677c2a
    csrw 0x64a, x3

    #Address 0x64a read value
    csrr x14, 0x64a

    #Address 0x64a read value
    csrr x14, 0x64a

    #Unmapped address 0x4b2 testing: random write/read operations
    #Address 0x4b2 read value
    csrr x14, 0x4b2

    #Address 0x4b2 Write value 0x2294da28
    li x3, 0x2294da28
    csrw 0x4b2, x3

    #Unmapped address 0x1af testing: random write/read operations
    #Address 0x1af read value
    csrr x14, 0x1af

    #Unmapped address 0xf4b testing: random write/read operations
    #Address 0xf4b Write value 0x632f6125
    li x3, 0x632f6125
    csrw 0xf4b, x3

    #Address 0xf4b read value
    csrr x14, 0xf4b

    #Address 0xf4b read value
    csrr x14, 0xf4b

    #Unmapped address 0x66e testing: random write/read operations
    #Address 0x66e read value
    csrr x14, 0x66e

    #Unmapped address 0xbd2 testing: random write/read operations
    #Address 0xbd2 Write value 0x3f57d261
    li x3, 0x3f57d261
    csrw 0xbd2, x3

    #Address 0xbd2 read value
    csrr x14, 0xbd2

    #Unmapped address 0x16d testing: random write/read operations
    #Address 0x16d read value
    csrr x14, 0x16d

    #Address 0x16d read value
    csrr x14, 0x16d

    #Address 0x16d Write value 0xf1f719bf
    li x3, 0xf1f719bf
    csrw 0x16d, x3

    #Unmapped address 0x6e1 testing: random write/read operations
    #Address 0x6e1 Write value 0x9a1b5ff0
    li x3, 0x9a1b5ff0
    csrw 0x6e1, x3

    #Address 0x6e1 read value
    csrr x14, 0x6e1

    #Address 0x6e1 Write value 0xae29dbf9
    li x3, 0xae29dbf9
    csrw 0x6e1, x3

    #Address 0x6e1 read value
    csrr x14, 0x6e1

    #Unmapped address 0xf17 testing: random write/read operations
    #Address 0xf17 Write value 0x7bc79522
    li x3, 0x7bc79522
    csrw 0xf17, x3

    #Unmapped address 0x527 testing: random write/read operations
    #Address 0x527 read value
    csrr x14, 0x527

    #Address 0x527 read value
    csrr x14, 0x527

    #Address 0x527 Write value 0x2ce6b8a9
    li x3, 0x2ce6b8a9
    csrw 0x527, x3

    #Address 0x527 read value
    csrr x14, 0x527

    #Address 0x527 Write value 0xbf6e2473
    li x3, 0xbf6e2473
    csrw 0x527, x3

    #Unmapped address 0xf7b testing: random write/read operations
    #Address 0xf7b read value
    csrr x14, 0xf7b

    #Address 0xf7b Write value 0xbde46162
    li x3, 0xbde46162
    csrw 0xf7b, x3

    #Unmapped address 0x94 testing: random write/read operations
    #Address 0x94 read value
    csrr x14, 0x94

    #Address 0x94 Write value 0x9e53d8c4
    li x3, 0x9e53d8c4
    csrw 0x94, x3

    #Address 0x94 read value
    csrr x14, 0x94

    #Address 0x94 read value
    csrr x14, 0x94

    #Unmapped address 0xb3a testing: random write/read operations
    #Address 0xb3a Write value 0x7253520f
    li x3, 0x7253520f
    csrw 0xb3a, x3

    #Address 0xb3a read value
    csrr x14, 0xb3a

    #Unmapped address 0x3d3 testing: random write/read operations
    #Address 0x3d3 Write value 0x8df75b2a
    li x3, 0x8df75b2a
    csrw 0x3d3, x3

    #Address 0x3d3 read value
    csrr x14, 0x3d3

    #Address 0x3d3 read value
    csrr x14, 0x3d3

    #Unmapped address 0x11f testing: random write/read operations
    #Address 0x11f Write value 0x2140acf7
    li x3, 0x2140acf7
    csrw 0x11f, x3

    #Address 0x11f read value
    csrr x14, 0x11f

    #Unmapped address 0x430 testing: random write/read operations
    #Address 0x430 Write value 0x16397620
    li x3, 0x16397620
    csrw 0x430, x3

    #Address 0x430 Write value 0x72122d17
    li x3, 0x72122d17
    csrw 0x430, x3

    #Address 0x430 read value
    csrr x14, 0x430

    #Address 0x430 Write value 0xff3029d7
    li x3, 0xff3029d7
    csrw 0x430, x3

    #Unmapped address 0xcae testing: random write/read operations
    #Address 0xcae Write value 0xc5122da6
    li x3, 0xc5122da6
    csrw 0xcae, x3

    #Unmapped address 0x9af testing: random write/read operations
    #Address 0x9af Write value 0xfa64ea6c
    li x3, 0xfa64ea6c
    csrw 0x9af, x3

    #Address 0x9af Write value 0xd6105268
    li x3, 0xd6105268
    csrw 0x9af, x3

    #Address 0x9af Write value 0x17aab7eb
    li x3, 0x17aab7eb
    csrw 0x9af, x3

    #Address 0x9af Write value 0x411fce39
    li x3, 0x411fce39
    csrw 0x9af, x3

    #Unmapped address 0xdb6 testing: random write/read operations
    #Address 0xdb6 read value
    csrr x14, 0xdb6

    #Address 0xdb6 Write value 0x85d09397
    li x3, 0x85d09397
    csrw 0xdb6, x3

    #Address 0xdb6 read value
    csrr x14, 0xdb6

    #Unmapped address 0x70f testing: random write/read operations
    #Address 0x70f read value
    csrr x14, 0x70f

    #Address 0x70f read value
    csrr x14, 0x70f

    #Address 0x70f read value
    csrr x14, 0x70f

    #Address 0x70f Write value 0xfd87cf1e
    li x3, 0xfd87cf1e
    csrw 0x70f, x3

    #Address 0x70f Write value 0x9c44e5fb
    li x3, 0x9c44e5fb
    csrw 0x70f, x3

    #Unmapped address 0x6a0 testing: random write/read operations
    #Address 0x6a0 read value
    csrr x14, 0x6a0

    #Address 0x6a0 read value
    csrr x14, 0x6a0

    #Address 0x6a0 read value
    csrr x14, 0x6a0

    #Address 0x6a0 read value
    csrr x14, 0x6a0

    #Address 0x6a0 Write value 0x6d2db442
    li x3, 0x6d2db442
    csrw 0x6a0, x3

    #Unmapped address 0xc62 testing: random write/read operations
    #Address 0xc62 Write value 0x9fbeaa5d
    li x3, 0x9fbeaa5d
    csrw 0xc62, x3

    #Address 0xc62 Write value 0x60dd0ffb
    li x3, 0x60dd0ffb
    csrw 0xc62, x3

    #Address 0xc62 Write value 0x80e748ed
    li x3, 0x80e748ed
    csrw 0xc62, x3

    #Mapped address 0xb99 (mhpmcounterh25) testing: random write/read operations
    #Address 0xb99 read value
    csrr x14, 0xb99

    #Address 0xb99 read value
    csrr x14, 0xb99

    #Address 0xb99 read value
    csrr x14, 0xb99

    #Address 0xb99 read value
    csrr x14, 0xb99

    #Address 0xb99 Write value 0x8c90b463
    li x3, 0x8c90b463
    csrw 0xb99, x3

    #Unmapped address 0x58c testing: random write/read operations
    #Address 0x58c read value
    csrr x14, 0x58c

    #Address 0x58c Write value 0x933dbe8b
    li x3, 0x933dbe8b
    csrw 0x58c, x3

    #Unmapped address 0xd9a testing: random write/read operations
    #Address 0xd9a Write value 0xc77c5bc1
    li x3, 0xc77c5bc1
    csrw 0xd9a, x3

    #Address 0xd9a Write value 0xdb7ba0ad
    li x3, 0xdb7ba0ad
    csrw 0xd9a, x3

    #Address 0xd9a read value
    csrr x14, 0xd9a

    #Unmapped address 0x3c4 testing: random write/read operations
    #Address 0x3c4 Write value 0x8ff095f
    li x3, 0x8ff095f
    csrw 0x3c4, x3

    #Address 0x3c4 read value
    csrr x14, 0x3c4

    #Address 0x3c4 Write value 0x5d2dba89
    li x3, 0x5d2dba89
    csrw 0x3c4, x3

    #Unmapped address 0xe7d testing: random write/read operations
    #Address 0xe7d Write value 0x8307f8b1
    li x3, 0x8307f8b1
    csrw 0xe7d, x3

    #Address 0xe7d Write value 0x7d815dfa
    li x3, 0x7d815dfa
    csrw 0xe7d, x3

    #Address 0xe7d Write value 0xb16ed419
    li x3, 0xb16ed419
    csrw 0xe7d, x3

    #Address 0xe7d Write value 0xb68804cc
    li x3, 0xb68804cc
    csrw 0xe7d, x3

    #Unmapped address 0x5e6 testing: random write/read operations
    #Address 0x5e6 read value
    csrr x14, 0x5e6

    #Address 0x5e6 Write value 0xd99b3f92
    li x3, 0xd99b3f92
    csrw 0x5e6, x3

    #Address 0x5e6 read value
    csrr x14, 0x5e6

    #Unmapped address 0xb6b testing: random write/read operations
    #Address 0xb6b Write value 0x362d3164
    li x3, 0x362d3164
    csrw 0xb6b, x3

    #Address 0xb6b read value
    csrr x14, 0xb6b

    #Address 0xb6b Write value 0x3cf88215
    li x3, 0x3cf88215
    csrw 0xb6b, x3

    #Unmapped address 0xa48 testing: random write/read operations
    #Address 0xa48 Write value 0xc030b91b
    li x3, 0xc030b91b
    csrw 0xa48, x3

    #Address 0xa48 read value
    csrr x14, 0xa48

    #Unmapped address 0x58a testing: random write/read operations
    #Address 0x58a Write value 0xbe524a81
    li x3, 0xbe524a81
    csrw 0x58a, x3

    #Unmapped address 0x2f3 testing: random write/read operations
    #Address 0x2f3 read value
    csrr x14, 0x2f3

    #Address 0x2f3 read value
    csrr x14, 0x2f3

    #Address 0x2f3 Write value 0x7a7644c2
    li x3, 0x7a7644c2
    csrw 0x2f3, x3

    #Unmapped address 0x6a4 testing: random write/read operations
    #Address 0x6a4 Write value 0x9f610700
    li x3, 0x9f610700
    csrw 0x6a4, x3

    #Address 0x6a4 read value
    csrr x14, 0x6a4

    #Unmapped address 0x37e testing: random write/read operations
    #Address 0x37e read value
    csrr x14, 0x37e

    #Mapped address 0xb08 (mhpmcounter8) testing: random write/read operations
    #Address 0xb08 Write value 0xef10af36
    li x3, 0xef10af36
    csrw 0xb08, x3

    #Unmapped address 0xcd8 testing: random write/read operations
    #Address 0xcd8 read value
    csrr x14, 0xcd8

    #Unmapped address 0x123 testing: random write/read operations
    #Address 0x123 read value
    csrr x14, 0x123

    #Address 0x123 Write value 0xa0998379
    li x3, 0xa0998379
    csrw 0x123, x3

    #Address 0x123 read value
    csrr x14, 0x123

    #Address 0x123 read value
    csrr x14, 0x123

    #Unmapped address 0xbfb testing: random write/read operations
    #Address 0xbfb Write value 0xacccc471
    li x3, 0xacccc471
    csrw 0xbfb, x3

    #Address 0xbfb read value
    csrr x14, 0xbfb

    #Unmapped address 0xcde testing: random write/read operations
    #Address 0xcde Write value 0x58225f17
    li x3, 0x58225f17
    csrw 0xcde, x3

    #Address 0xcde read value
    csrr x14, 0xcde

    #Address 0xcde Write value 0xae3e75f1
    li x3, 0xae3e75f1
    csrw 0xcde, x3

    #Address 0xcde read value
    csrr x14, 0xcde

    #Address 0xcde Write value 0x5466e68a
    li x3, 0x5466e68a
    csrw 0xcde, x3

    #Unmapped address 0xafe testing: random write/read operations
    #Address 0xafe read value
    csrr x14, 0xafe

    #Address 0xafe Write value 0x10f7f48
    li x3, 0x10f7f48
    csrw 0xafe, x3

    #Unmapped address 0xaea testing: random write/read operations
    #Address 0xaea Write value 0x853d6067
    li x3, 0x853d6067
    csrw 0xaea, x3

    #Unmapped address 0x61f testing: random write/read operations
    #Address 0x61f read value
    csrr x14, 0x61f

    #Address 0x61f read value
    csrr x14, 0x61f

    #Address 0x61f Write value 0x723b2eca
    li x3, 0x723b2eca
    csrw 0x61f, x3

    #Address 0x61f read value
    csrr x14, 0x61f

    #Unmapped address 0xeed testing: random write/read operations
    #Address 0xeed Write value 0x722a4176
    li x3, 0x722a4176
    csrw 0xeed, x3

    #Address 0xeed read value
    csrr x14, 0xeed

    #Address 0xeed Write value 0x2d53c45
    li x3, 0x2d53c45
    csrw 0xeed, x3

    #Address 0xeed Write value 0xf1f2d71a
    li x3, 0xf1f2d71a
    csrw 0xeed, x3

    #Unmapped address 0xfb5 testing: random write/read operations
    #Address 0xfb5 read value
    csrr x14, 0xfb5

    #Address 0xfb5 read value
    csrr x14, 0xfb5

    #Address 0xfb5 Write value 0xed4feec6
    li x3, 0xed4feec6
    csrw 0xfb5, x3

    #Address 0xfb5 Write value 0x6d7b132a
    li x3, 0x6d7b132a
    csrw 0xfb5, x3

    #Address 0xfb5 read value
    csrr x14, 0xfb5

    #Unmapped address 0xeaf testing: random write/read operations
    #Address 0xeaf Write value 0x9642d596
    li x3, 0x9642d596
    csrw 0xeaf, x3

    #Unmapped address 0xd38 testing: random write/read operations
    #Address 0xd38 Write value 0xea14f24b
    li x3, 0xea14f24b
    csrw 0xd38, x3

    #Address 0xd38 Write value 0x1027dea8
    li x3, 0x1027dea8
    csrw 0xd38, x3

    #Address 0xd38 read value
    csrr x14, 0xd38

    #Address 0xd38 Write value 0x7b91ee9
    li x3, 0x7b91ee9
    csrw 0xd38, x3

    #Unmapped address 0x687 testing: random write/read operations
    #Address 0x687 read value
    csrr x14, 0x687

    #Address 0x687 Write value 0x20216827
    li x3, 0x20216827
    csrw 0x687, x3

    #Unmapped address 0xe91 testing: random write/read operations
    #Address 0xe91 read value
    csrr x14, 0xe91

    #Address 0xe91 read value
    csrr x14, 0xe91

    #Address 0xe91 read value
    csrr x14, 0xe91

    #Address 0xe91 read value
    csrr x14, 0xe91

    #Unmapped address 0xd04 testing: random write/read operations
    #Address 0xd04 read value
    csrr x14, 0xd04

    #Address 0xd04 read value
    csrr x14, 0xd04

    #Address 0xd04 read value
    csrr x14, 0xd04

    #Address 0xd04 read value
    csrr x14, 0xd04

    #Unmapped address 0x94a testing: random write/read operations
    #Address 0x94a read value
    csrr x14, 0x94a

    #Address 0x94a read value
    csrr x14, 0x94a

    #Address 0x94a read value
    csrr x14, 0x94a

    #Unmapped address 0x19 testing: random write/read operations
    #Address 0x19 read value
    csrr x14, 0x19

    #Address 0x19 read value
    csrr x14, 0x19

    #Address 0x19 Write value 0xbc8fa45f
    li x3, 0xbc8fa45f
    csrw 0x19, x3

    #Address 0x19 read value
    csrr x14, 0x19

    #Address 0x19 read value
    csrr x14, 0x19

    #Unmapped address 0xb48 testing: random write/read operations
    #Address 0xb48 read value
    csrr x14, 0xb48

    #Unmapped address 0x139 testing: random write/read operations
    #Address 0x139 read value
    csrr x14, 0x139

    #Address 0x139 Write value 0x59bd032d
    li x3, 0x59bd032d
    csrw 0x139, x3

    #Address 0x139 read value
    csrr x14, 0x139

    #Address 0x139 read value
    csrr x14, 0x139

    #Address 0x139 read value
    csrr x14, 0x139

    #Unmapped address 0x95a testing: random write/read operations
    #Address 0x95a Write value 0xdd6d96eb
    li x3, 0xdd6d96eb
    csrw 0x95a, x3

    #Address 0x95a Write value 0xe1d68bf3
    li x3, 0xe1d68bf3
    csrw 0x95a, x3

    #Address 0x95a Write value 0x7382e5a5
    li x3, 0x7382e5a5
    csrw 0x95a, x3

    #Unmapped address 0x872 testing: random write/read operations
    #Address 0x872 Write value 0xf7b55b37
    li x3, 0xf7b55b37
    csrw 0x872, x3

    #Unmapped address 0x502 testing: random write/read operations
    #Address 0x502 Write value 0x92946350
    li x3, 0x92946350
    csrw 0x502, x3

    #Address 0x502 Write value 0x3b262c91
    li x3, 0x3b262c91
    csrw 0x502, x3

    #Address 0x502 read value
    csrr x14, 0x502

    #Address 0x502 Write value 0x8b21fcfa
    li x3, 0x8b21fcfa
    csrw 0x502, x3

    #Unmapped address 0x6e9 testing: random write/read operations
    #Address 0x6e9 Write value 0x58d1f659
    li x3, 0x58d1f659
    csrw 0x6e9, x3

    #Mapped address 0x32f (mhpmevent15) testing: random write/read operations
    #Address 0x32f read value
    csrr x14, 0x32f

    #Address 0x32f Write value 0x46b29630
    li x3, 0x46b29630
    csrw 0x32f, x3

    #Address 0x32f read value
    csrr x14, 0x32f

    #Unmapped address 0xc9e testing: random write/read operations
    #Address 0xc9e read value
    csrr x14, 0xc9e

    #Address 0xc9e read value
    csrr x14, 0xc9e

    #Unmapped address 0x858 testing: random write/read operations
    #Address 0x858 Write value 0x9ec72ebb
    li x3, 0x9ec72ebb
    csrw 0x858, x3

    #Address 0x858 Write value 0x30b7a078
    li x3, 0x30b7a078
    csrw 0x858, x3

    #Address 0x858 Write value 0xdca7110
    li x3, 0xdca7110
    csrw 0x858, x3

    #Address 0x858 Write value 0xe6e94b74
    li x3, 0xe6e94b74
    csrw 0x858, x3

    #Unmapped address 0x27a testing: random write/read operations
    #Address 0x27a read value
    csrr x14, 0x27a

    #Address 0x27a Write value 0x1f3a769a
    li x3, 0x1f3a769a
    csrw 0x27a, x3

    #Unmapped address 0x16c testing: random write/read operations
    #Address 0x16c Write value 0x53e40122
    li x3, 0x53e40122
    csrw 0x16c, x3

    #Address 0x16c read value
    csrr x14, 0x16c

    #Address 0x16c Write value 0x5690cb2b
    li x3, 0x5690cb2b
    csrw 0x16c, x3

    #Unmapped address 0xcec testing: random write/read operations
    #Address 0xcec Write value 0x9695b17
    li x3, 0x9695b17
    csrw 0xcec, x3

    #Address 0xcec Write value 0x97850b
    li x3, 0x97850b
    csrw 0xcec, x3

    #Address 0xcec Write value 0xb7de622a
    li x3, 0xb7de622a
    csrw 0xcec, x3

    #Address 0xcec Write value 0xe74e4997
    li x3, 0xe74e4997
    csrw 0xcec, x3

    #Address 0xcec read value
    csrr x14, 0xcec

    #Unmapped address 0x6b5 testing: random write/read operations
    #Address 0x6b5 read value
    csrr x14, 0x6b5

    #Address 0x6b5 Write value 0xb25de01a
    li x3, 0xb25de01a
    csrw 0x6b5, x3

    #Unmapped address 0x74e testing: random write/read operations
    #Address 0x74e Write value 0x993aeafb
    li x3, 0x993aeafb
    csrw 0x74e, x3

    #Address 0x74e Write value 0xd469e391
    li x3, 0xd469e391
    csrw 0x74e, x3

    #Address 0x74e read value
    csrr x14, 0x74e

    #Unmapped address 0x9e3 testing: random write/read operations
    #Address 0x9e3 read value
    csrr x14, 0x9e3

    #Address 0x9e3 read value
    csrr x14, 0x9e3

    #Address 0x9e3 read value
    csrr x14, 0x9e3

    #Address 0x9e3 Write value 0x352c8909
    li x3, 0x352c8909
    csrw 0x9e3, x3

    #Address 0x9e3 read value
    csrr x14, 0x9e3

    #Unmapped address 0xa02 testing: random write/read operations
    #Address 0xa02 read value
    csrr x14, 0xa02

    #Address 0xa02 read value
    csrr x14, 0xa02

    #Unmapped address 0x6c2 testing: random write/read operations
    #Address 0x6c2 Write value 0x882f81fe
    li x3, 0x882f81fe
    csrw 0x6c2, x3

    #Unmapped address 0xf83 testing: random write/read operations
    #Address 0xf83 Write value 0x2b4ddd1b
    li x3, 0x2b4ddd1b
    csrw 0xf83, x3

    #Address 0xf83 Write value 0x232b0102
    li x3, 0x232b0102
    csrw 0xf83, x3

    #Address 0xf83 read value
    csrr x14, 0xf83

    #Address 0xf83 read value
    csrr x14, 0xf83

    #Unmapped address 0x1b5 testing: random write/read operations
    #Address 0x1b5 read value
    csrr x14, 0x1b5

    #Mapped address 0x329 (mhpmevent9) testing: random write/read operations
    #Address 0x329 read value
    csrr x14, 0x329

    #Address 0x329 read value
    csrr x14, 0x329

    #Address 0x329 Write value 0xf3db5998
    li x3, 0xf3db5998
    csrw 0x329, x3

    #Unmapped address 0xed3 testing: random write/read operations
    #Address 0xed3 read value
    csrr x14, 0xed3

    #Address 0xed3 Write value 0x487faa39
    li x3, 0x487faa39
    csrw 0xed3, x3

    #Unmapped address 0xf85 testing: random write/read operations
    #Address 0xf85 Write value 0x35c7fa25
    li x3, 0x35c7fa25
    csrw 0xf85, x3

    #Unmapped address 0x366 testing: random write/read operations
    #Address 0x366 Write value 0x2ac8f3bf
    li x3, 0x2ac8f3bf
    csrw 0x366, x3

    #Address 0x366 read value
    csrr x14, 0x366

    #Address 0x366 Write value 0x90c36b51
    li x3, 0x90c36b51
    csrw 0x366, x3

    #Address 0x366 read value
    csrr x14, 0x366

    #Unmapped address 0xb31 testing: random write/read operations
    #Address 0xb31 Write value 0x145fdd7
    li x3, 0x145fdd7
    csrw 0xb31, x3

    #Address 0xb31 Write value 0x8546b088
    li x3, 0x8546b088
    csrw 0xb31, x3

    #Unmapped address 0xa3c testing: random write/read operations
    #Address 0xa3c read value
    csrr x14, 0xa3c

    #Address 0xa3c read value
    csrr x14, 0xa3c

    #Address 0xa3c read value
    csrr x14, 0xa3c

    #Address 0xa3c Write value 0xa680df0
    li x3, 0xa680df0
    csrw 0xa3c, x3

    #Unmapped address 0xb55 testing: random write/read operations
    #Address 0xb55 Write value 0x7a818d5c
    li x3, 0x7a818d5c
    csrw 0xb55, x3

    #Address 0xb55 Write value 0x581a18f1
    li x3, 0x581a18f1
    csrw 0xb55, x3

    #Address 0xb55 read value
    csrr x14, 0xb55

    #Address 0xb55 read value
    csrr x14, 0xb55

    #Address 0xb55 read value
    csrr x14, 0xb55

    #Unmapped address 0x177 testing: random write/read operations
    #Address 0x177 Write value 0xa68ec702
    li x3, 0xa68ec702
    csrw 0x177, x3

    #Address 0x177 Write value 0x9587bfc4
    li x3, 0x9587bfc4
    csrw 0x177, x3

    #Address 0x177 read value
    csrr x14, 0x177

    #Address 0x177 read value
    csrr x14, 0x177

    #Unmapped address 0x65e testing: random write/read operations
    #Address 0x65e Write value 0x18e80910
    li x3, 0x18e80910
    csrw 0x65e, x3

    #Address 0x65e read value
    csrr x14, 0x65e

    #Address 0x65e read value
    csrr x14, 0x65e

    #Address 0x65e read value
    csrr x14, 0x65e

    #Address 0x65e read value
    csrr x14, 0x65e

    #Unmapped address 0x871 testing: random write/read operations
    #Address 0x871 Write value 0xaf07d2e7
    li x3, 0xaf07d2e7
    csrw 0x871, x3

    #Address 0x871 read value
    csrr x14, 0x871

    #Unmapped address 0x2ea testing: random write/read operations
    #Address 0x2ea read value
    csrr x14, 0x2ea

    #Address 0x2ea read value
    csrr x14, 0x2ea

    #Unmapped address 0x9b7 testing: random write/read operations
    #Address 0x9b7 Write value 0x6aceca4a
    li x3, 0x6aceca4a
    csrw 0x9b7, x3

    #Address 0x9b7 Write value 0x1a811dda
    li x3, 0x1a811dda
    csrw 0x9b7, x3

    #Address 0x9b7 Write value 0xa01001b2
    li x3, 0xa01001b2
    csrw 0x9b7, x3

    #Unmapped address 0xc01 testing: random write/read operations
    #Address 0xc01 read value
    csrr x14, 0xc01

    #Address 0xc01 Write value 0x5e3bc2ec
    li x3, 0x5e3bc2ec
    csrw 0xc01, x3

    #Address 0xc01 Write value 0x77babe4
    li x3, 0x77babe4
    csrw 0xc01, x3

    #Unmapped address 0x542 testing: random write/read operations
    #Address 0x542 read value
    csrr x14, 0x542

    #Address 0x542 Write value 0xe2fbb467
    li x3, 0xe2fbb467
    csrw 0x542, x3

    #Address 0x542 Write value 0x1bd8cabe
    li x3, 0x1bd8cabe
    csrw 0x542, x3

    #Address 0x542 Write value 0x4cb8ff30
    li x3, 0x4cb8ff30
    csrw 0x542, x3

    #Unmapped address 0xcc8 testing: random write/read operations
    #Address 0xcc8 read value
    csrr x14, 0xcc8

    #Address 0xcc8 Write value 0x255c91db
    li x3, 0x255c91db
    csrw 0xcc8, x3

    #Address 0xcc8 read value
    csrr x14, 0xcc8

    #Address 0xcc8 Write value 0x81d84e6d
    li x3, 0x81d84e6d
    csrw 0xcc8, x3

    #Address 0xcc8 Write value 0xd517c35
    li x3, 0xd517c35
    csrw 0xcc8, x3

    #Unmapped address 0x2ab testing: random write/read operations
    #Address 0x2ab Write value 0x1c1327bc
    li x3, 0x1c1327bc
    csrw 0x2ab, x3

    #Address 0x2ab read value
    csrr x14, 0x2ab

    #Address 0x2ab Write value 0xd90162e0
    li x3, 0xd90162e0
    csrw 0x2ab, x3

    #Unmapped address 0x694 testing: random write/read operations
    #Address 0x694 read value
    csrr x14, 0x694

    #Unmapped address 0xa64 testing: random write/read operations
    #Address 0xa64 Write value 0xa231d159
    li x3, 0xa231d159
    csrw 0xa64, x3

    #Address 0xa64 read value
    csrr x14, 0xa64

    #Address 0xa64 Write value 0x66f1f1fb
    li x3, 0x66f1f1fb
    csrw 0xa64, x3

    #Address 0xa64 read value
    csrr x14, 0xa64

    #Unmapped address 0x587 testing: random write/read operations
    #Address 0x587 Write value 0x42185400
    li x3, 0x42185400
    csrw 0x587, x3

    #Address 0x587 read value
    csrr x14, 0x587

    #Address 0x587 read value
    csrr x14, 0x587

    #Address 0x587 read value
    csrr x14, 0x587

    #Unmapped address 0x99c testing: random write/read operations
    #Address 0x99c read value
    csrr x14, 0x99c

    #Address 0x99c read value
    csrr x14, 0x99c

    #Address 0x99c Write value 0xd3491fd0
    li x3, 0xd3491fd0
    csrw 0x99c, x3

    #Unmapped address 0x5a1 testing: random write/read operations
    #Address 0x5a1 Write value 0x21e10547
    li x3, 0x21e10547
    csrw 0x5a1, x3

    #Address 0x5a1 Write value 0x2323d583
    li x3, 0x2323d583
    csrw 0x5a1, x3

    #Address 0x5a1 Write value 0x73668506
    li x3, 0x73668506
    csrw 0x5a1, x3

    #Address 0x5a1 read value
    csrr x14, 0x5a1

    #Unmapped address 0xc1e testing: random write/read operations
    #Address 0xc1e read value
    csrr x14, 0xc1e

    #Address 0xc1e Write value 0x8cb55443
    li x3, 0x8cb55443
    csrw 0xc1e, x3

    #Unmapped address 0x96c testing: random write/read operations
    #Address 0x96c read value
    csrr x14, 0x96c

    #Address 0x96c Write value 0xaf7b7b76
    li x3, 0xaf7b7b76
    csrw 0x96c, x3

    #Address 0x96c Write value 0xde9b7f90
    li x3, 0xde9b7f90
    csrw 0x96c, x3

    #Mapped address 0xb06 (mhpmcounter6) testing: random write/read operations
    #Address 0xb06 read value
    csrr x14, 0xb06

    #Address 0xb06 read value
    csrr x14, 0xb06

    #Address 0xb06 read value
    csrr x14, 0xb06

    #Address 0xb06 Write value 0x492a8a9b
    li x3, 0x492a8a9b
    csrw 0xb06, x3

    #Address 0xb06 read value
    csrr x14, 0xb06

    #Unmapped address 0x782 testing: random write/read operations
    #Address 0x782 read value
    csrr x14, 0x782

    #Address 0x782 Write value 0xa40282ce
    li x3, 0xa40282ce
    csrw 0x782, x3

    #Unmapped address 0xb44 testing: random write/read operations
    #Address 0xb44 read value
    csrr x14, 0xb44

    #Address 0xb44 Write value 0x89affe9c
    li x3, 0x89affe9c
    csrw 0xb44, x3

    #Address 0xb44 Write value 0xe4a7bfc7
    li x3, 0xe4a7bfc7
    csrw 0xb44, x3

    #Address 0xb44 Write value 0x3fe5eaab
    li x3, 0x3fe5eaab
    csrw 0xb44, x3

    #Unmapped address 0x5b3 testing: random write/read operations
    #Address 0x5b3 Write value 0xcfd19798
    li x3, 0xcfd19798
    csrw 0x5b3, x3

    #Address 0x5b3 Write value 0x8720c260
    li x3, 0x8720c260
    csrw 0x5b3, x3

    #Address 0x5b3 read value
    csrr x14, 0x5b3

    #Address 0x5b3 read value
    csrr x14, 0x5b3

    #Address 0x5b3 read value
    csrr x14, 0x5b3

    #Unmapped address 0xa4 testing: random write/read operations
    #Address 0xa4 Write value 0x6dd8324f
    li x3, 0x6dd8324f
    csrw 0xa4, x3

    #Address 0xa4 read value
    csrr x14, 0xa4

    #Address 0xa4 read value
    csrr x14, 0xa4

    #Address 0xa4 read value
    csrr x14, 0xa4

    #Mapped address 0x3b1 (pmpaddr1) testing: random write/read operations
    #Address 0x3b1 read value
    csrr x14, 0x3b1

    #Address 0x3b1 Write value 0xabb6ab6f
    li x3, 0xabb6ab6f
    csrw 0x3b1, x3

    #Address 0x3b1 read value
    csrr x14, 0x3b1

    #Address 0x3b1 Write value 0xf09b00ab
    li x3, 0xf09b00ab
    csrw 0x3b1, x3

    #Unmapped address 0xc74 testing: random write/read operations
    #Address 0xc74 Write value 0x8479fef5
    li x3, 0x8479fef5
    csrw 0xc74, x3

    #Address 0xc74 read value
    csrr x14, 0xc74

    #Address 0xc74 read value
    csrr x14, 0xc74

    #Address 0xc74 Write value 0x7a1ac365
    li x3, 0x7a1ac365
    csrw 0xc74, x3

    #Address 0xc74 Write value 0x3f8a627d
    li x3, 0x3f8a627d
    csrw 0xc74, x3

    #Unmapped address 0x236 testing: random write/read operations
    #Address 0x236 read value
    csrr x14, 0x236

    #Address 0x236 read value
    csrr x14, 0x236

    #Address 0x236 read value
    csrr x14, 0x236

    #Address 0x236 read value
    csrr x14, 0x236

    #Unmapped address 0x95f testing: random write/read operations
    #Address 0x95f read value
    csrr x14, 0x95f

    #Address 0x95f read value
    csrr x14, 0x95f

    #Address 0x95f Write value 0xf3d43a88
    li x3, 0xf3d43a88
    csrw 0x95f, x3

    #Address 0x95f read value
    csrr x14, 0x95f

    #Address 0x95f read value
    csrr x14, 0x95f

    #Unmapped address 0x7ae testing: random write/read operations
    #Address 0x7ae Write value 0x7e29737b
    li x3, 0x7e29737b
    csrw 0x7ae, x3

    #Address 0x7ae Write value 0x9469fbdd
    li x3, 0x9469fbdd
    csrw 0x7ae, x3

    #Unmapped address 0x2f testing: random write/read operations
    #Address 0x2f Write value 0xaf07a1e4
    li x3, 0xaf07a1e4
    csrw 0x2f, x3

    #Unmapped address 0xe58 testing: random write/read operations
    #Address 0xe58 read value
    csrr x14, 0xe58

    #Address 0xe58 Write value 0xf3474bbc
    li x3, 0xf3474bbc
    csrw 0xe58, x3

    #Address 0xe58 read value
    csrr x14, 0xe58

    #Unmapped address 0x705 testing: random write/read operations
    #Address 0x705 Write value 0x20ab04c5
    li x3, 0x20ab04c5
    csrw 0x705, x3

    #Address 0x705 read value
    csrr x14, 0x705

    #Address 0x705 Write value 0x61cd0967
    li x3, 0x61cd0967
    csrw 0x705, x3

    #Address 0x705 Write value 0xb989361d
    li x3, 0xb989361d
    csrw 0x705, x3

    #Address 0x705 Write value 0xbe936d8d
    li x3, 0xbe936d8d
    csrw 0x705, x3

    #Unmapped address 0xd1c testing: random write/read operations
    #Address 0xd1c read value
    csrr x14, 0xd1c

    #Unmapped address 0xbbd testing: random write/read operations
    #Address 0xbbd Write value 0x164a25a2
    li x3, 0x164a25a2
    csrw 0xbbd, x3

    #Address 0xbbd read value
    csrr x14, 0xbbd

    #Address 0xbbd Write value 0x86940495
    li x3, 0x86940495
    csrw 0xbbd, x3

    #Address 0xbbd Write value 0xd93384d7
    li x3, 0xd93384d7
    csrw 0xbbd, x3

    #Unmapped address 0xc08 testing: random write/read operations
    #Address 0xc08 read value
    csrr x14, 0xc08

    #Address 0xc08 read value
    csrr x14, 0xc08

    #Address 0xc08 read value
    csrr x14, 0xc08

    #Address 0xc08 Write value 0x174357ef
    li x3, 0x174357ef
    csrw 0xc08, x3

    #Address 0xc08 read value
    csrr x14, 0xc08

    #Unmapped address 0xf8 testing: random write/read operations
    #Address 0xf8 read value
    csrr x14, 0xf8

    #Address 0xf8 read value
    csrr x14, 0xf8

    #Unmapped address 0x7a5 testing: random write/read operations
    #Address 0x7a5 read value
    csrr x14, 0x7a5

    #Address 0x7a5 read value
    csrr x14, 0x7a5

    #Unmapped address 0x266 testing: random write/read operations
    #Address 0x266 Write value 0xb1e745a5
    li x3, 0xb1e745a5
    csrw 0x266, x3

    #Address 0x266 read value
    csrr x14, 0x266

    #Address 0x266 Write value 0x2c5d3203
    li x3, 0x2c5d3203
    csrw 0x266, x3

    #Address 0x266 Write value 0x3ed2b78
    li x3, 0x3ed2b78
    csrw 0x266, x3

    #Address 0x266 Write value 0xf629dcc0
    li x3, 0xf629dcc0
    csrw 0x266, x3

    #Unmapped address 0x24e testing: random write/read operations
    #Address 0x24e read value
    csrr x14, 0x24e

    #Address 0x24e read value
    csrr x14, 0x24e

    #Address 0x24e Write value 0x47936607
    li x3, 0x47936607
    csrw 0x24e, x3

    #Address 0x24e Write value 0x78262f8
    li x3, 0x78262f8
    csrw 0x24e, x3

    #Address 0x24e Write value 0x7b4448cb
    li x3, 0x7b4448cb
    csrw 0x24e, x3

    #Unmapped address 0x9b5 testing: random write/read operations
    #Address 0x9b5 read value
    csrr x14, 0x9b5

    #Address 0x9b5 Write value 0x723953bf
    li x3, 0x723953bf
    csrw 0x9b5, x3

    #Address 0x9b5 Write value 0x5e9c430c
    li x3, 0x5e9c430c
    csrw 0x9b5, x3

    #Address 0x9b5 Write value 0xa1480cb1
    li x3, 0xa1480cb1
    csrw 0x9b5, x3

    #Address 0x9b5 Write value 0xf757d183
    li x3, 0xf757d183
    csrw 0x9b5, x3

    #Unmapped address 0xb7b testing: random write/read operations
    #Address 0xb7b Write value 0x863f8779
    li x3, 0x863f8779
    csrw 0xb7b, x3

    #Address 0xb7b read value
    csrr x14, 0xb7b

    #Address 0xb7b Write value 0x6f6b5d27
    li x3, 0x6f6b5d27
    csrw 0xb7b, x3

    #Address 0xb7b read value
    csrr x14, 0xb7b

    #Unmapped address 0xa91 testing: random write/read operations
    #Address 0xa91 Write value 0x99fde55b
    li x3, 0x99fde55b
    csrw 0xa91, x3

    #Address 0xa91 read value
    csrr x14, 0xa91

    #Address 0xa91 read value
    csrr x14, 0xa91

    #Address 0xa91 Write value 0x1f988ba6
    li x3, 0x1f988ba6
    csrw 0xa91, x3

    #Address 0xa91 Write value 0x5bc43b09
    li x3, 0x5bc43b09
    csrw 0xa91, x3

    #Unmapped address 0xbfd testing: random write/read operations
    #Address 0xbfd Write value 0x76ebf72
    li x3, 0x76ebf72
    csrw 0xbfd, x3

    #Address 0xbfd Write value 0xa89b2e12
    li x3, 0xa89b2e12
    csrw 0xbfd, x3

    #Address 0xbfd read value
    csrr x14, 0xbfd

    #Unmapped address 0xbe8 testing: random write/read operations
    #Address 0xbe8 read value
    csrr x14, 0xbe8

    #Address 0xbe8 read value
    csrr x14, 0xbe8

    #Unmapped address 0x154 testing: random write/read operations
    #Address 0x154 read value
    csrr x14, 0x154

    #Unmapped address 0xe50 testing: random write/read operations
    #Address 0xe50 read value
    csrr x14, 0xe50

    #Unmapped address 0xc40 testing: random write/read operations
    #Address 0xc40 Write value 0x420d14c5
    li x3, 0x420d14c5
    csrw 0xc40, x3

    #Address 0xc40 Write value 0xdd948638
    li x3, 0xdd948638
    csrw 0xc40, x3

    #Address 0xc40 Write value 0x7e4828f
    li x3, 0x7e4828f
    csrw 0xc40, x3

    #Unmapped address 0xac0 testing: random write/read operations
    #Address 0xac0 read value
    csrr x14, 0xac0

    #Address 0xac0 read value
    csrr x14, 0xac0

    #Address 0xac0 Write value 0xddd52175
    li x3, 0xddd52175
    csrw 0xac0, x3

    #Unmapped address 0xb56 testing: random write/read operations
    #Address 0xb56 read value
    csrr x14, 0xb56

    #Address 0xb56 read value
    csrr x14, 0xb56

    #Address 0xb56 read value
    csrr x14, 0xb56

    #Address 0xb56 Write value 0x9aa7ab2e
    li x3, 0x9aa7ab2e
    csrw 0xb56, x3

    #Address 0xb56 Write value 0x7c9e2758
    li x3, 0x7c9e2758
    csrw 0xb56, x3

    #Unmapped address 0x99e testing: random write/read operations
    #Address 0x99e read value
    csrr x14, 0x99e

    #Address 0x99e read value
    csrr x14, 0x99e

    #Unmapped address 0x1b9 testing: random write/read operations
    #Address 0x1b9 read value
    csrr x14, 0x1b9

    #Address 0x1b9 Write value 0x878cbcc2
    li x3, 0x878cbcc2
    csrw 0x1b9, x3

    #Address 0x1b9 Write value 0xb8fb82a4
    li x3, 0xb8fb82a4
    csrw 0x1b9, x3

    #Address 0x1b9 Write value 0xd375e2e9
    li x3, 0xd375e2e9
    csrw 0x1b9, x3

    #Address 0x1b9 Write value 0x74662f24
    li x3, 0x74662f24
    csrw 0x1b9, x3

    #Unmapped address 0xaf8 testing: random write/read operations
    #Address 0xaf8 read value
    csrr x14, 0xaf8

    #Unmapped address 0x1c2 testing: random write/read operations
    #Address 0x1c2 read value
    csrr x14, 0x1c2

    #Unmapped address 0x614 testing: random write/read operations
    #Address 0x614 Write value 0x2f3b9996
    li x3, 0x2f3b9996
    csrw 0x614, x3

    #Address 0x614 Write value 0x20d5f89d
    li x3, 0x20d5f89d
    csrw 0x614, x3

    #Address 0x614 read value
    csrr x14, 0x614

    #Unmapped address 0x8bd testing: random write/read operations
    #Address 0x8bd read value
    csrr x14, 0x8bd

    #Address 0x8bd read value
    csrr x14, 0x8bd

    #Unmapped address 0x48e testing: random write/read operations
    #Address 0x48e read value
    csrr x14, 0x48e

    #Address 0x48e read value
    csrr x14, 0x48e

    #Address 0x48e Write value 0x6f3f62f4
    li x3, 0x6f3f62f4
    csrw 0x48e, x3

    #Address 0x48e read value
    csrr x14, 0x48e

    #Address 0x48e read value
    csrr x14, 0x48e

    #Unmapped address 0x66b testing: random write/read operations
    #Address 0x66b Write value 0x9824ca7d
    li x3, 0x9824ca7d
    csrw 0x66b, x3

    #Unmapped address 0xc27 testing: random write/read operations
    #Address 0xc27 read value
    csrr x14, 0xc27

    #Address 0xc27 Write value 0x2175a8ed
    li x3, 0x2175a8ed
    csrw 0xc27, x3

    #Unmapped address 0xf41 testing: random write/read operations
    #Address 0xf41 Write value 0x8e9ef1f8
    li x3, 0x8e9ef1f8
    csrw 0xf41, x3

    #Address 0xf41 Write value 0xe4bc1d8c
    li x3, 0xe4bc1d8c
    csrw 0xf41, x3

    #Address 0xf41 read value
    csrr x14, 0xf41

    #Address 0xf41 read value
    csrr x14, 0xf41

    #Address 0xf41 read value
    csrr x14, 0xf41

    #Unmapped address 0xf9b testing: random write/read operations
    #Address 0xf9b read value
    csrr x14, 0xf9b

    #Address 0xf9b Write value 0x136b732a
    li x3, 0x136b732a
    csrw 0xf9b, x3

    #Address 0xf9b read value
    csrr x14, 0xf9b

    #Address 0xf9b read value
    csrr x14, 0xf9b

    #Address 0xf9b Write value 0xf1760817
    li x3, 0xf1760817
    csrw 0xf9b, x3

    #Unmapped address 0xf92 testing: random write/read operations
    #Address 0xf92 read value
    csrr x14, 0xf92

    #Unmapped address 0xcee testing: random write/read operations
    #Address 0xcee Write value 0x6c4164af
    li x3, 0x6c4164af
    csrw 0xcee, x3

    #Unmapped address 0xe66 testing: random write/read operations
    #Address 0xe66 Write value 0x76f20312
    li x3, 0x76f20312
    csrw 0xe66, x3

    #Address 0xe66 read value
    csrr x14, 0xe66

    #Unmapped address 0xdec testing: random write/read operations
    #Address 0xdec Write value 0xa94470a7
    li x3, 0xa94470a7
    csrw 0xdec, x3

    #Address 0xdec read value
    csrr x14, 0xdec

    #Address 0xdec read value
    csrr x14, 0xdec

    #Address 0xdec Write value 0x7ae50165
    li x3, 0x7ae50165
    csrw 0xdec, x3

    #Unmapped address 0x7ea testing: random write/read operations
    #Address 0x7ea read value
    csrr x14, 0x7ea

    #Address 0x7ea read value
    csrr x14, 0x7ea

    #Unmapped address 0x8af testing: random write/read operations
    #Address 0x8af read value
    csrr x14, 0x8af

    #Address 0x8af Write value 0xe56dbbbf
    li x3, 0xe56dbbbf
    csrw 0x8af, x3

    #Unmapped address 0x85c testing: random write/read operations
    #Address 0x85c read value
    csrr x14, 0x85c

    #Address 0x85c read value
    csrr x14, 0x85c

    #Address 0x85c Write value 0xd3ca82ab
    li x3, 0xd3ca82ab
    csrw 0x85c, x3

    #Address 0x85c Write value 0x2eb47431
    li x3, 0x2eb47431
    csrw 0x85c, x3

    #Address 0x85c Write value 0xbbcac05c
    li x3, 0xbbcac05c
    csrw 0x85c, x3

    #Unmapped address 0xd2c testing: random write/read operations
    #Address 0xd2c read value
    csrr x14, 0xd2c

    #Address 0xd2c read value
    csrr x14, 0xd2c

    #Unmapped address 0xafd testing: random write/read operations
    #Address 0xafd Write value 0xf5b85a8b
    li x3, 0xf5b85a8b
    csrw 0xafd, x3

    #Unmapped address 0x7f testing: random write/read operations
    #Address 0x7f read value
    csrr x14, 0x7f

    #Address 0x7f Write value 0xcf4619a2
    li x3, 0xcf4619a2
    csrw 0x7f, x3

    #Address 0x7f Write value 0x8a0f9f3a
    li x3, 0x8a0f9f3a
    csrw 0x7f, x3

    #Address 0x7f read value
    csrr x14, 0x7f

    #Unmapped address 0x102 testing: random write/read operations
    #Address 0x102 read value
    csrr x14, 0x102

    #Address 0x102 Write value 0x3d3313f8
    li x3, 0x3d3313f8
    csrw 0x102, x3

    #Address 0x102 read value
    csrr x14, 0x102

    #Address 0x102 read value
    csrr x14, 0x102

    #Address 0x102 Write value 0x96e74275
    li x3, 0x96e74275
    csrw 0x102, x3

    #Unmapped address 0x405 testing: random write/read operations
    #Address 0x405 read value
    csrr x14, 0x405

    #Unmapped address 0x113 testing: random write/read operations
    #Address 0x113 Write value 0x35d79469
    li x3, 0x35d79469
    csrw 0x113, x3

    #Address 0x113 read value
    csrr x14, 0x113

    #Address 0x113 Write value 0x5587b047
    li x3, 0x5587b047
    csrw 0x113, x3

    #Address 0x113 read value
    csrr x14, 0x113

    #Address 0x113 read value
    csrr x14, 0x113

    #Unmapped address 0x877 testing: random write/read operations
    #Address 0x877 read value
    csrr x14, 0x877

    #Unmapped address 0xe93 testing: random write/read operations
    #Address 0xe93 Write value 0x6c312ab6
    li x3, 0x6c312ab6
    csrw 0xe93, x3

    #Unmapped address 0x9f9 testing: random write/read operations
    #Address 0x9f9 read value
    csrr x14, 0x9f9

    #Address 0x9f9 Write value 0xeb8ab91e
    li x3, 0xeb8ab91e
    csrw 0x9f9, x3

    #Address 0x9f9 read value
    csrr x14, 0x9f9

    #Address 0x9f9 read value
    csrr x14, 0x9f9

    #Unmapped address 0x5de testing: random write/read operations
    #Address 0x5de Write value 0xd19aacae
    li x3, 0xd19aacae
    csrw 0x5de, x3

    #Address 0x5de read value
    csrr x14, 0x5de

    #Address 0x5de read value
    csrr x14, 0x5de

    #Address 0x5de Write value 0x90b3a982
    li x3, 0x90b3a982
    csrw 0x5de, x3

    #Address 0x5de read value
    csrr x14, 0x5de

    #Unmapped address 0x50d testing: random write/read operations
    #Address 0x50d Write value 0xd6dd0676
    li x3, 0xd6dd0676
    csrw 0x50d, x3

    #Address 0x50d Write value 0x7dc31784
    li x3, 0x7dc31784
    csrw 0x50d, x3

    #Address 0x50d Write value 0xcf98ee70
    li x3, 0xcf98ee70
    csrw 0x50d, x3

    #Address 0x50d read value
    csrr x14, 0x50d

    #Unmapped address 0xfb6 testing: random write/read operations
    #Address 0xfb6 Write value 0x8aab991f
    li x3, 0x8aab991f
    csrw 0xfb6, x3

    #Address 0xfb6 Write value 0x8c2c4436
    li x3, 0x8c2c4436
    csrw 0xfb6, x3

    #Address 0xfb6 read value
    csrr x14, 0xfb6

    #Address 0xfb6 Write value 0x96fe130c
    li x3, 0x96fe130c
    csrw 0xfb6, x3

    #Unmapped address 0xbeb testing: random write/read operations
    #Address 0xbeb Write value 0xadd31118
    li x3, 0xadd31118
    csrw 0xbeb, x3

    #Address 0xbeb read value
    csrr x14, 0xbeb

    #Address 0xbeb read value
    csrr x14, 0xbeb

    #Unmapped address 0x9a8 testing: random write/read operations
    #Address 0x9a8 read value
    csrr x14, 0x9a8

    #Address 0x9a8 Write value 0x55d0b361
    li x3, 0x55d0b361
    csrw 0x9a8, x3

    #Unmapped address 0xac5 testing: random write/read operations
    #Address 0xac5 Write value 0x7315dfaa
    li x3, 0x7315dfaa
    csrw 0xac5, x3

    #Address 0xac5 read value
    csrr x14, 0xac5

    #Address 0xac5 Write value 0x1dd22a72
    li x3, 0x1dd22a72
    csrw 0xac5, x3

    #Address 0xac5 Write value 0x7cdd545b
    li x3, 0x7cdd545b
    csrw 0xac5, x3

    #Address 0xac5 read value
    csrr x14, 0xac5

    #Unmapped address 0x6c6 testing: random write/read operations
    #Address 0x6c6 read value
    csrr x14, 0x6c6

    #Address 0x6c6 Write value 0x99d023f3
    li x3, 0x99d023f3
    csrw 0x6c6, x3

    #Address 0x6c6 read value
    csrr x14, 0x6c6

    #Unmapped address 0x8c6 testing: random write/read operations
    #Address 0x8c6 read value
    csrr x14, 0x8c6

    #Address 0x8c6 read value
    csrr x14, 0x8c6

    #Unmapped address 0xcf1 testing: random write/read operations
    #Address 0xcf1 read value
    csrr x14, 0xcf1

    #Unmapped address 0x6f2 testing: random write/read operations
    #Address 0x6f2 Write value 0xc3c30d44
    li x3, 0xc3c30d44
    csrw 0x6f2, x3

    #Address 0x6f2 read value
    csrr x14, 0x6f2

    #Address 0x6f2 Write value 0x520e761b
    li x3, 0x520e761b
    csrw 0x6f2, x3

    #Address 0x6f2 read value
    csrr x14, 0x6f2

    #Unmapped address 0x786 testing: random write/read operations
    #Address 0x786 read value
    csrr x14, 0x786

    #Address 0x786 Write value 0x423235f2
    li x3, 0x423235f2
    csrw 0x786, x3

    #Address 0x786 Write value 0x14c447b0
    li x3, 0x14c447b0
    csrw 0x786, x3

    #Address 0x786 read value
    csrr x14, 0x786

    #Address 0x786 read value
    csrr x14, 0x786

    #Unmapped address 0xc19 testing: random write/read operations
    #Address 0xc19 read value
    csrr x14, 0xc19

    #Unmapped address 0x59a testing: random write/read operations
    #Address 0x59a Write value 0xb676ab53
    li x3, 0xb676ab53
    csrw 0x59a, x3

    #Address 0x59a Write value 0x7c380af7
    li x3, 0x7c380af7
    csrw 0x59a, x3

    #Address 0x59a Write value 0x31079077
    li x3, 0x31079077
    csrw 0x59a, x3

    #Address 0x59a read value
    csrr x14, 0x59a

    #Address 0x59a Write value 0xa9d2c3a1
    li x3, 0xa9d2c3a1
    csrw 0x59a, x3

    #Unmapped address 0xef2 testing: random write/read operations
    #Address 0xef2 Write value 0x5268705c
    li x3, 0x5268705c
    csrw 0xef2, x3

    #Address 0xef2 read value
    csrr x14, 0xef2

    #Address 0xef2 read value
    csrr x14, 0xef2

    #Address 0xef2 Write value 0xfc63086c
    li x3, 0xfc63086c
    csrw 0xef2, x3

    #Address 0xef2 Write value 0x9c74319c
    li x3, 0x9c74319c
    csrw 0xef2, x3

    #Unmapped address 0x375 testing: random write/read operations
    #Address 0x375 Write value 0x4b87c6c1
    li x3, 0x4b87c6c1
    csrw 0x375, x3

    #Address 0x375 read value
    csrr x14, 0x375

    #Address 0x375 Write value 0xd8211fa0
    li x3, 0xd8211fa0
    csrw 0x375, x3

    #Address 0x375 Write value 0x4c214c77
    li x3, 0x4c214c77
    csrw 0x375, x3

    #Unmapped address 0x128 testing: random write/read operations
    #Address 0x128 read value
    csrr x14, 0x128

    #Address 0x128 Write value 0xd15310e7
    li x3, 0xd15310e7
    csrw 0x128, x3

    #Address 0x128 read value
    csrr x14, 0x128

    #Address 0x128 read value
    csrr x14, 0x128

    #Unmapped address 0x308 testing: random write/read operations
    #Address 0x308 read value
    csrr x14, 0x308

    #Address 0x308 Write value 0x88201f0
    li x3, 0x88201f0
    csrw 0x308, x3

    #Address 0x308 Write value 0x34ecf82e
    li x3, 0x34ecf82e
    csrw 0x308, x3

    #Address 0x308 read value
    csrr x14, 0x308

    #Unmapped address 0x509 testing: random write/read operations
    #Address 0x509 read value
    csrr x14, 0x509

    #Address 0x509 read value
    csrr x14, 0x509

    #Address 0x509 Write value 0xa60bd7aa
    li x3, 0xa60bd7aa
    csrw 0x509, x3

    #Address 0x509 Write value 0x7c88145a
    li x3, 0x7c88145a
    csrw 0x509, x3

    #Unmapped address 0xd8d testing: random write/read operations
    #Address 0xd8d read value
    csrr x14, 0xd8d

    #Address 0xd8d read value
    csrr x14, 0xd8d

    #Address 0xd8d read value
    csrr x14, 0xd8d

    #Address 0xd8d Write value 0x392d1fd6
    li x3, 0x392d1fd6
    csrw 0xd8d, x3

    #Unmapped address 0x650 testing: random write/read operations
    #Address 0x650 Write value 0xb586b5ac
    li x3, 0xb586b5ac
    csrw 0x650, x3

    #Address 0x650 Write value 0xe0fdeb7a
    li x3, 0xe0fdeb7a
    csrw 0x650, x3

    #Address 0x650 read value
    csrr x14, 0x650

    #Address 0x650 read value
    csrr x14, 0x650

    #Address 0x650 Write value 0x55b3ae
    li x3, 0x55b3ae
    csrw 0x650, x3

    #Unmapped address 0xee4 testing: random write/read operations
    #Address 0xee4 Write value 0xe71b0126
    li x3, 0xe71b0126
    csrw 0xee4, x3

    #Address 0xee4 read value
    csrr x14, 0xee4

    #Address 0xee4 Write value 0x82b7c214
    li x3, 0x82b7c214
    csrw 0xee4, x3

    #Address 0xee4 read value
    csrr x14, 0xee4

    #Unmapped address 0xfc7 testing: random write/read operations
    #Address 0xfc7 Write value 0xc0dff71d
    li x3, 0xc0dff71d
    csrw 0xfc7, x3

    #Unmapped address 0xa97 testing: random write/read operations
    #Address 0xa97 read value
    csrr x14, 0xa97

    #Address 0xa97 Write value 0x97a9afbe
    li x3, 0x97a9afbe
    csrw 0xa97, x3

    #Address 0xa97 read value
    csrr x14, 0xa97

    #Unmapped address 0x8de testing: random write/read operations
    #Address 0x8de read value
    csrr x14, 0x8de

    #Unmapped address 0x742 testing: random write/read operations
    #Address 0x742 read value
    csrr x14, 0x742

    #Address 0x742 Write value 0xf3b7a8a8
    li x3, 0xf3b7a8a8
    csrw 0x742, x3

    #Address 0x742 Write value 0xffb3c29b
    li x3, 0xffb3c29b
    csrw 0x742, x3

    #Address 0x742 Write value 0x98916bad
    li x3, 0x98916bad
    csrw 0x742, x3

    #Unmapped address 0x13f testing: random write/read operations
    #Address 0x13f read value
    csrr x14, 0x13f

    #Address 0x13f Write value 0x21504d7d
    li x3, 0x21504d7d
    csrw 0x13f, x3

    #Address 0x13f read value
    csrr x14, 0x13f

    #Address 0x13f read value
    csrr x14, 0x13f

    #Unmapped address 0xf70 testing: random write/read operations
    #Address 0xf70 Write value 0x609e7416
    li x3, 0x609e7416
    csrw 0xf70, x3

    #Unmapped address 0xb5 testing: random write/read operations
    #Address 0xb5 read value
    csrr x14, 0xb5

    #Address 0xb5 read value
    csrr x14, 0xb5

    #Address 0xb5 Write value 0x99bf4250
    li x3, 0x99bf4250
    csrw 0xb5, x3

    #Address 0xb5 Write value 0x396a6672
    li x3, 0x396a6672
    csrw 0xb5, x3

    #Unmapped address 0xb4b testing: random write/read operations
    #Address 0xb4b read value
    csrr x14, 0xb4b

    #Address 0xb4b read value
    csrr x14, 0xb4b

    #Unmapped address 0xbcf testing: random write/read operations
    #Address 0xbcf Write value 0xb94017c4
    li x3, 0xb94017c4
    csrw 0xbcf, x3

    #Address 0xbcf Write value 0xe11cb98c
    li x3, 0xe11cb98c
    csrw 0xbcf, x3

    #Address 0xbcf read value
    csrr x14, 0xbcf

    #Unmapped address 0xfb0 testing: random write/read operations
    #Address 0xfb0 Write value 0xd94750d6
    li x3, 0xd94750d6
    csrw 0xfb0, x3

    #Address 0xfb0 read value
    csrr x14, 0xfb0

    #Address 0xfb0 read value
    csrr x14, 0xfb0

    #Address 0xfb0 read value
    csrr x14, 0xfb0

    #Address 0xfb0 read value
    csrr x14, 0xfb0

    #Unmapped address 0xea5 testing: random write/read operations
    #Address 0xea5 read value
    csrr x14, 0xea5

    #Address 0xea5 read value
    csrr x14, 0xea5

    #Address 0xea5 read value
    csrr x14, 0xea5

    #Address 0xea5 read value
    csrr x14, 0xea5

    #Address 0xea5 Write value 0x63de1b85
    li x3, 0x63de1b85
    csrw 0xea5, x3

    #Unmapped address 0x59c testing: random write/read operations
    #Address 0x59c read value
    csrr x14, 0x59c

    #Address 0x59c Write value 0x9b2c91f3
    li x3, 0x9b2c91f3
    csrw 0x59c, x3

    #Address 0x59c read value
    csrr x14, 0x59c

    #Unmapped address 0xc3e testing: random write/read operations
    #Address 0xc3e Write value 0x6bd4f56d
    li x3, 0x6bd4f56d
    csrw 0xc3e, x3

    #Address 0xc3e Write value 0x4f262914
    li x3, 0x4f262914
    csrw 0xc3e, x3

    #Unmapped address 0x232 testing: random write/read operations
    #Address 0x232 Write value 0x8b1accc8
    li x3, 0x8b1accc8
    csrw 0x232, x3

    #Address 0x232 read value
    csrr x14, 0x232

    #Address 0x232 Write value 0xcbdd6913
    li x3, 0xcbdd6913
    csrw 0x232, x3

    #Unmapped address 0x317 testing: random write/read operations
    #Address 0x317 read value
    csrr x14, 0x317

    #Address 0x317 Write value 0xbb00bb4e
    li x3, 0xbb00bb4e
    csrw 0x317, x3

    #Unmapped address 0x2d0 testing: random write/read operations
    #Address 0x2d0 read value
    csrr x14, 0x2d0

    #Address 0x2d0 Write value 0x78d971de
    li x3, 0x78d971de
    csrw 0x2d0, x3

    #Address 0x2d0 read value
    csrr x14, 0x2d0

    #Unmapped address 0x9f0 testing: random write/read operations
    #Address 0x9f0 read value
    csrr x14, 0x9f0

    #Address 0x9f0 Write value 0xfb47cad2
    li x3, 0xfb47cad2
    csrw 0x9f0, x3

    #Address 0x9f0 read value
    csrr x14, 0x9f0

    #Address 0x9f0 read value
    csrr x14, 0x9f0

    #Address 0x9f0 read value
    csrr x14, 0x9f0

    #Unmapped address 0x28a testing: random write/read operations
    #Address 0x28a Write value 0x55b54d32
    li x3, 0x55b54d32
    csrw 0x28a, x3

    #Address 0x28a Write value 0x6b260db5
    li x3, 0x6b260db5
    csrw 0x28a, x3

    #Unmapped address 0x606 testing: random write/read operations
    #Address 0x606 read value
    csrr x14, 0x606

    #Address 0x606 Write value 0x6de2e67d
    li x3, 0x6de2e67d
    csrw 0x606, x3

    #Unmapped address 0x525 testing: random write/read operations
    #Address 0x525 Write value 0x810d4afc
    li x3, 0x810d4afc
    csrw 0x525, x3

    #Address 0x525 read value
    csrr x14, 0x525

    #Address 0x525 read value
    csrr x14, 0x525

    #Unmapped address 0xec3 testing: random write/read operations
    #Address 0xec3 read value
    csrr x14, 0xec3

    #Address 0xec3 read value
    csrr x14, 0xec3

    #Address 0xec3 read value
    csrr x14, 0xec3

    #Address 0xec3 Write value 0x87db52d3
    li x3, 0x87db52d3
    csrw 0xec3, x3

    #Address 0xec3 Write value 0x53f00091
    li x3, 0x53f00091
    csrw 0xec3, x3

    #Unmapped address 0x1f8 testing: random write/read operations
    #Address 0x1f8 Write value 0xe5a180b1
    li x3, 0xe5a180b1
    csrw 0x1f8, x3

    #Address 0x1f8 Write value 0x3feb193
    li x3, 0x3feb193
    csrw 0x1f8, x3

    #Address 0x1f8 read value
    csrr x14, 0x1f8

    #Unmapped address 0x97d testing: random write/read operations
    #Address 0x97d Write value 0x6b0c40ca
    li x3, 0x6b0c40ca
    csrw 0x97d, x3

    #Address 0x97d Write value 0x78b68eb9
    li x3, 0x78b68eb9
    csrw 0x97d, x3

    #Unmapped address 0x309 testing: random write/read operations
    #Address 0x309 read value
    csrr x14, 0x309

    #Address 0x309 Write value 0xf2b7ef1d
    li x3, 0xf2b7ef1d
    csrw 0x309, x3

    #Address 0x309 Write value 0xb54298b
    li x3, 0xb54298b
    csrw 0x309, x3

    #Address 0x309 Write value 0xa4b918a3
    li x3, 0xa4b918a3
    csrw 0x309, x3

    #Address 0x309 Write value 0xe07f7eb7
    li x3, 0xe07f7eb7
    csrw 0x309, x3

    #Unmapped address 0x74a testing: random write/read operations
    #Address 0x74a Write value 0xfd4abb73
    li x3, 0xfd4abb73
    csrw 0x74a, x3

    #Unmapped address 0xe37 testing: random write/read operations
    #Address 0xe37 read value
    csrr x14, 0xe37

    #Unmapped address 0xeef testing: random write/read operations
    #Address 0xeef Write value 0x8531dfd3
    li x3, 0x8531dfd3
    csrw 0xeef, x3

    #Address 0xeef Write value 0x619ff7cd
    li x3, 0x619ff7cd
    csrw 0xeef, x3

    #Address 0xeef Write value 0x5788fdc
    li x3, 0x5788fdc
    csrw 0xeef, x3

    #Address 0xeef read value
    csrr x14, 0xeef

    #Unmapped address 0xe70 testing: random write/read operations
    #Address 0xe70 read value
    csrr x14, 0xe70

    #Address 0xe70 Write value 0x16c85c18
    li x3, 0x16c85c18
    csrw 0xe70, x3

    #Address 0xe70 read value
    csrr x14, 0xe70

    #Address 0xe70 read value
    csrr x14, 0xe70

    #Unmapped address 0x59d testing: random write/read operations
    #Address 0x59d Write value 0x32032fb4
    li x3, 0x32032fb4
    csrw 0x59d, x3

    #Address 0x59d Write value 0x39b3a679
    li x3, 0x39b3a679
    csrw 0x59d, x3

    #Address 0x59d Write value 0x56e9d8b7
    li x3, 0x56e9d8b7
    csrw 0x59d, x3

    #Unmapped address 0x7d6 testing: random write/read operations
    #Address 0x7d6 read value
    csrr x14, 0x7d6

    #Address 0x7d6 Write value 0xcdc1bf91
    li x3, 0xcdc1bf91
    csrw 0x7d6, x3

    #Unmapped address 0xf9a testing: random write/read operations
    #Address 0xf9a Write value 0x5ec651fd
    li x3, 0x5ec651fd
    csrw 0xf9a, x3

    #Address 0xf9a Write value 0xa783c588
    li x3, 0xa783c588
    csrw 0xf9a, x3

    #Address 0xf9a Write value 0x8694bff
    li x3, 0x8694bff
    csrw 0xf9a, x3

    #Unmapped address 0xd1b testing: random write/read operations
    #Address 0xd1b read value
    csrr x14, 0xd1b

    #Address 0xd1b read value
    csrr x14, 0xd1b

    #Unmapped address 0xc06 testing: random write/read operations
    #Address 0xc06 Write value 0xba2d1ada
    li x3, 0xba2d1ada
    csrw 0xc06, x3

    #Unmapped address 0xcdf testing: random write/read operations
    #Address 0xcdf Write value 0xd871c986
    li x3, 0xd871c986
    csrw 0xcdf, x3

    #Address 0xcdf Write value 0xf8cd11f5
    li x3, 0xf8cd11f5
    csrw 0xcdf, x3

    #Address 0xcdf read value
    csrr x14, 0xcdf

    #Address 0xcdf Write value 0xcf60f6cc
    li x3, 0xcf60f6cc
    csrw 0xcdf, x3

    #Unmapped address 0x85b testing: random write/read operations
    #Address 0x85b Write value 0xf9bdd2f6
    li x3, 0xf9bdd2f6
    csrw 0x85b, x3

    #Unmapped address 0x6e2 testing: random write/read operations
    #Address 0x6e2 Write value 0x46732b89
    li x3, 0x46732b89
    csrw 0x6e2, x3

    #Address 0x6e2 read value
    csrr x14, 0x6e2

    #Unmapped address 0xc22 testing: random write/read operations
    #Address 0xc22 read value
    csrr x14, 0xc22

    #Address 0xc22 read value
    csrr x14, 0xc22

    #Address 0xc22 read value
    csrr x14, 0xc22

    #Unmapped address 0xa49 testing: random write/read operations
    #Address 0xa49 read value
    csrr x14, 0xa49

    #Address 0xa49 Write value 0x1cb95633
    li x3, 0x1cb95633
    csrw 0xa49, x3

    #Address 0xa49 read value
    csrr x14, 0xa49

    #Unmapped address 0xdcd testing: random write/read operations
    #Address 0xdcd read value
    csrr x14, 0xdcd

    #Unmapped address 0xc64 testing: random write/read operations
    #Address 0xc64 Write value 0xd300803b
    li x3, 0xd300803b
    csrw 0xc64, x3

    #Address 0xc64 Write value 0x29891c47
    li x3, 0x29891c47
    csrw 0xc64, x3

    #Address 0xc64 Write value 0x10003de9
    li x3, 0x10003de9
    csrw 0xc64, x3

    #Unmapped address 0x8b3 testing: random write/read operations
    #Address 0x8b3 read value
    csrr x14, 0x8b3

    #Address 0x8b3 read value
    csrr x14, 0x8b3

    #Unmapped address 0xd9e testing: random write/read operations
    #Address 0xd9e Write value 0xaf29fb49
    li x3, 0xaf29fb49
    csrw 0xd9e, x3

    #Address 0xd9e Write value 0x74b07e85
    li x3, 0x74b07e85
    csrw 0xd9e, x3

    #Address 0xd9e Write value 0x3bf74c9d
    li x3, 0x3bf74c9d
    csrw 0xd9e, x3

    #Unmapped address 0x979 testing: random write/read operations
    #Address 0x979 Write value 0x2ff76c26
    li x3, 0x2ff76c26
    csrw 0x979, x3

    #Unmapped address 0x2ca testing: random write/read operations
    #Address 0x2ca read value
    csrr x14, 0x2ca

    #Unmapped address 0xc91 testing: random write/read operations
    #Address 0xc91 read value
    csrr x14, 0xc91

    #Address 0xc91 Write value 0xf06e4a4a
    li x3, 0xf06e4a4a
    csrw 0xc91, x3

    #Unmapped address 0x5b0 testing: random write/read operations
    #Address 0x5b0 Write value 0x2612d040
    li x3, 0x2612d040
    csrw 0x5b0, x3

    #Unmapped address 0xbdb testing: random write/read operations
    #Address 0xbdb Write value 0x91ae4d8
    li x3, 0x91ae4d8
    csrw 0xbdb, x3

    #Address 0xbdb read value
    csrr x14, 0xbdb

    #Unmapped address 0xcd7 testing: random write/read operations
    #Address 0xcd7 Write value 0x366eeef9
    li x3, 0x366eeef9
    csrw 0xcd7, x3

    #Address 0xcd7 read value
    csrr x14, 0xcd7

    #Address 0xcd7 read value
    csrr x14, 0xcd7

    #Address 0xcd7 Write value 0x8b39680a
    li x3, 0x8b39680a
    csrw 0xcd7, x3

    #Address 0xcd7 Write value 0x58be4e57
    li x3, 0x58be4e57
    csrw 0xcd7, x3

    #Unmapped address 0xe8c testing: random write/read operations
    #Address 0xe8c Write value 0x8232d7f0
    li x3, 0x8232d7f0
    csrw 0xe8c, x3

    #Unmapped address 0x15b testing: random write/read operations
    #Address 0x15b Write value 0xf6fb5ac9
    li x3, 0xf6fb5ac9
    csrw 0x15b, x3

    #Address 0x15b Write value 0xd4c74333
    li x3, 0xd4c74333
    csrw 0x15b, x3

    #Address 0x15b read value
    csrr x14, 0x15b

    #Address 0x15b Write value 0xdb71a7d4
    li x3, 0xdb71a7d4
    csrw 0x15b, x3

    #Unmapped address 0x716 testing: random write/read operations
    #Address 0x716 Write value 0xbeab7bd3
    li x3, 0xbeab7bd3
    csrw 0x716, x3

    #Address 0x716 Write value 0x80127971
    li x3, 0x80127971
    csrw 0x716, x3

    #Address 0x716 read value
    csrr x14, 0x716

    #Address 0x716 read value
    csrr x14, 0x716

    #Address 0x716 Write value 0xc7c36602
    li x3, 0xc7c36602
    csrw 0x716, x3

    #Unmapped address 0x863 testing: random write/read operations
    #Address 0x863 Write value 0x8894d018
    li x3, 0x8894d018
    csrw 0x863, x3

    #Unmapped address 0xc3d testing: random write/read operations
    #Address 0xc3d Write value 0xe06bce60
    li x3, 0xe06bce60
    csrw 0xc3d, x3

    #Address 0xc3d Write value 0x1afffb53
    li x3, 0x1afffb53
    csrw 0xc3d, x3

    #Address 0xc3d Write value 0xa799d61e
    li x3, 0xa799d61e
    csrw 0xc3d, x3

    #Address 0xc3d Write value 0xd8018898
    li x3, 0xd8018898
    csrw 0xc3d, x3

    #Address 0xc3d Write value 0x53596d80
    li x3, 0x53596d80
    csrw 0xc3d, x3

    #Mapped address 0xb00 (mcycle) testing: random write/read operations
    #Address 0xb00 read value
    csrr x14, 0xb00

    #Address 0xb00 read value
    csrr x14, 0xb00

    #Address 0xb00 read value
    csrr x14, 0xb00

    #Unmapped address 0xa73 testing: random write/read operations
    #Address 0xa73 read value
    csrr x14, 0xa73

    #Unmapped address 0x997 testing: random write/read operations
    #Address 0x997 Write value 0x36828fdc
    li x3, 0x36828fdc
    csrw 0x997, x3

    #Address 0x997 Write value 0x16610636
    li x3, 0x16610636
    csrw 0x997, x3

    #Address 0x997 Write value 0x220f9a2b
    li x3, 0x220f9a2b
    csrw 0x997, x3

    #Address 0x997 read value
    csrr x14, 0x997

    #Address 0x997 read value
    csrr x14, 0x997

    #Unmapped address 0x7f1 testing: random write/read operations
    #Address 0x7f1 Write value 0xd604a213
    li x3, 0xd604a213
    csrw 0x7f1, x3

    #Address 0x7f1 read value
    csrr x14, 0x7f1

    #Unmapped address 0x790 testing: random write/read operations
    #Address 0x790 read value
    csrr x14, 0x790

    #Address 0x790 read value
    csrr x14, 0x790

    #Address 0x790 Write value 0x4e606ac
    li x3, 0x4e606ac
    csrw 0x790, x3

    #Address 0x790 Write value 0xf5060aa6
    li x3, 0xf5060aa6
    csrw 0x790, x3

    #Address 0x790 Write value 0xa31e0d1a
    li x3, 0xa31e0d1a
    csrw 0x790, x3

    #Unmapped address 0x440 testing: random write/read operations
    #Address 0x440 read value
    csrr x14, 0x440

    #Address 0x440 Write value 0xf4a30de0
    li x3, 0xf4a30de0
    csrw 0x440, x3

    #Address 0x440 Write value 0x2eec4ac
    li x3, 0x2eec4ac
    csrw 0x440, x3

    #Address 0x440 read value
    csrr x14, 0x440

    #Unmapped address 0xdd7 testing: random write/read operations
    #Address 0xdd7 read value
    csrr x14, 0xdd7

    #Address 0xdd7 read value
    csrr x14, 0xdd7

    #Address 0xdd7 read value
    csrr x14, 0xdd7

    #Unmapped address 0xe45 testing: random write/read operations
    #Address 0xe45 Write value 0x737174b6
    li x3, 0x737174b6
    csrw 0xe45, x3

    #Address 0xe45 read value
    csrr x14, 0xe45

    #Address 0xe45 Write value 0xb23ce4aa
    li x3, 0xb23ce4aa
    csrw 0xe45, x3

    #Unmapped address 0x414 testing: random write/read operations
    #Address 0x414 read value
    csrr x14, 0x414

    #Address 0x414 read value
    csrr x14, 0x414

    #Address 0x414 read value
    csrr x14, 0x414

    #Unmapped address 0x1f9 testing: random write/read operations
    #Address 0x1f9 read value
    csrr x14, 0x1f9

    #Address 0x1f9 Write value 0xc8ef7afe
    li x3, 0xc8ef7afe
    csrw 0x1f9, x3

    #Address 0x1f9 read value
    csrr x14, 0x1f9

    #Address 0x1f9 Write value 0xac4e3a5f
    li x3, 0xac4e3a5f
    csrw 0x1f9, x3

    #Address 0x1f9 read value
    csrr x14, 0x1f9

    #Unmapped address 0xfb9 testing: random write/read operations
    #Address 0xfb9 Write value 0xf56946f3
    li x3, 0xf56946f3
    csrw 0xfb9, x3

    #Address 0xfb9 read value
    csrr x14, 0xfb9

    #Address 0xfb9 Write value 0xd159bb0a
    li x3, 0xd159bb0a
    csrw 0xfb9, x3

    #Address 0xfb9 read value
    csrr x14, 0xfb9

    #Address 0xfb9 Write value 0xf06e459c
    li x3, 0xf06e459c
    csrw 0xfb9, x3

    #Unmapped address 0xfb4 testing: random write/read operations
    #Address 0xfb4 read value
    csrr x14, 0xfb4

    #Address 0xfb4 Write value 0x97ec1948
    li x3, 0x97ec1948
    csrw 0xfb4, x3

    #Address 0xfb4 read value
    csrr x14, 0xfb4

    #Address 0xfb4 Write value 0x18432354
    li x3, 0x18432354
    csrw 0xfb4, x3

    #Address 0xfb4 read value
    csrr x14, 0xfb4

    #Unmapped address 0x2a0 testing: random write/read operations
    #Address 0x2a0 Write value 0xc0b114b9
    li x3, 0xc0b114b9
    csrw 0x2a0, x3

    #Address 0x2a0 Write value 0x6f8ab85e
    li x3, 0x6f8ab85e
    csrw 0x2a0, x3

    #Address 0x2a0 read value
    csrr x14, 0x2a0

    #Address 0x2a0 Write value 0x38493b2a
    li x3, 0x38493b2a
    csrw 0x2a0, x3

    #Unmapped address 0xd7 testing: random write/read operations
    #Address 0xd7 read value
    csrr x14, 0xd7

    #Address 0xd7 Write value 0x933c6052
    li x3, 0x933c6052
    csrw 0xd7, x3

    #Address 0xd7 Write value 0xc4bf7c3a
    li x3, 0xc4bf7c3a
    csrw 0xd7, x3

    #Address 0xd7 read value
    csrr x14, 0xd7

    #Unmapped address 0x2ed testing: random write/read operations
    #Address 0x2ed Write value 0x9d141332
    li x3, 0x9d141332
    csrw 0x2ed, x3

    #Address 0x2ed Write value 0x7d5092e5
    li x3, 0x7d5092e5
    csrw 0x2ed, x3

    #Unmapped address 0x4ff testing: random write/read operations
    #Address 0x4ff Write value 0xfdb8dde8
    li x3, 0xfdb8dde8
    csrw 0x4ff, x3

    #Address 0x4ff Write value 0x36d9dc28
    li x3, 0x36d9dc28
    csrw 0x4ff, x3

    #Address 0x4ff read value
    csrr x14, 0x4ff

    #Unmapped address 0xd94 testing: random write/read operations
    #Address 0xd94 read value
    csrr x14, 0xd94

    #Address 0xd94 read value
    csrr x14, 0xd94

    #Address 0xd94 Write value 0xb2f12acd
    li x3, 0xb2f12acd
    csrw 0xd94, x3

    #Address 0xd94 read value
    csrr x14, 0xd94

    #Unmapped address 0xfd1 testing: random write/read operations
    #Address 0xfd1 Write value 0x45afec50
    li x3, 0x45afec50
    csrw 0xfd1, x3

    #Address 0xfd1 read value
    csrr x14, 0xfd1

    #Address 0xfd1 Write value 0xb7939857
    li x3, 0xb7939857
    csrw 0xfd1, x3

    #Unmapped address 0xad9 testing: random write/read operations
    #Address 0xad9 Write value 0x36782712
    li x3, 0x36782712
    csrw 0xad9, x3

    #Address 0xad9 read value
    csrr x14, 0xad9

    #Address 0xad9 Write value 0x3303b9d4
    li x3, 0x3303b9d4
    csrw 0xad9, x3

    #Address 0xad9 read value
    csrr x14, 0xad9

    #Unmapped address 0x51f testing: random write/read operations
    #Address 0x51f Write value 0xca616d07
    li x3, 0xca616d07
    csrw 0x51f, x3

    #Address 0x51f Write value 0x33df48b4
    li x3, 0x33df48b4
    csrw 0x51f, x3

    #Unmapped address 0x4cb testing: random write/read operations
    #Address 0x4cb read value
    csrr x14, 0x4cb

    #Unmapped address 0xe1f testing: random write/read operations
    #Address 0xe1f Write value 0xe85d9bc3
    li x3, 0xe85d9bc3
    csrw 0xe1f, x3

    #Address 0xe1f Write value 0xb85d3a2d
    li x3, 0xb85d3a2d
    csrw 0xe1f, x3

    #Address 0xe1f Write value 0x6fbf1f5f
    li x3, 0x6fbf1f5f
    csrw 0xe1f, x3

    #Unmapped address 0xc81 testing: random write/read operations
    #Address 0xc81 Write value 0x7a651c23
    li x3, 0x7a651c23
    csrw 0xc81, x3

    #Address 0xc81 Write value 0xa56a6120
    li x3, 0xa56a6120
    csrw 0xc81, x3

    #Unmapped address 0x52e testing: random write/read operations
    #Address 0x52e Write value 0x8f282c86
    li x3, 0x8f282c86
    csrw 0x52e, x3

    #Address 0x52e read value
    csrr x14, 0x52e

    #Unmapped address 0x93e testing: random write/read operations
    #Address 0x93e read value
    csrr x14, 0x93e

    #Address 0x93e read value
    csrr x14, 0x93e

    #Address 0x93e read value
    csrr x14, 0x93e

    #Address 0x93e Write value 0x36fa4ede
    li x3, 0x36fa4ede
    csrw 0x93e, x3

    #Unmapped address 0x638 testing: random write/read operations
    #Address 0x638 Write value 0xf46c470d
    li x3, 0xf46c470d
    csrw 0x638, x3

    #Address 0x638 read value
    csrr x14, 0x638

    #Address 0x638 Write value 0xd16d3bc6
    li x3, 0xd16d3bc6
    csrw 0x638, x3

    #Address 0x638 read value
    csrr x14, 0x638

    #Unmapped address 0x262 testing: random write/read operations
    #Address 0x262 read value
    csrr x14, 0x262

    #Address 0x262 Write value 0xf03500dd
    li x3, 0xf03500dd
    csrw 0x262, x3

    #Address 0x262 Write value 0x874bdb75
    li x3, 0x874bdb75
    csrw 0x262, x3

    #Unmapped address 0x290 testing: random write/read operations
    #Address 0x290 read value
    csrr x14, 0x290

    #Unmapped address 0x23c testing: random write/read operations
    #Address 0x23c Write value 0xcd97f734
    li x3, 0xcd97f734
    csrw 0x23c, x3

    #Address 0x23c Write value 0x5f88f858
    li x3, 0x5f88f858
    csrw 0x23c, x3

    #Unmapped address 0xe3e testing: random write/read operations
    #Address 0xe3e read value
    csrr x14, 0xe3e

    #Unmapped address 0x2b4 testing: random write/read operations
    #Address 0x2b4 read value
    csrr x14, 0x2b4

    #Address 0x2b4 read value
    csrr x14, 0x2b4

    #Address 0x2b4 Write value 0xf286b2a
    li x3, 0xf286b2a
    csrw 0x2b4, x3

    #Address 0x2b4 read value
    csrr x14, 0x2b4

    #Unmapped address 0x5aa testing: random write/read operations
    #Address 0x5aa read value
    csrr x14, 0x5aa

    #Address 0x5aa Write value 0xa3855841
    li x3, 0xa3855841
    csrw 0x5aa, x3

    #Address 0x5aa read value
    csrr x14, 0x5aa

    #Address 0x5aa read value
    csrr x14, 0x5aa

    #Unmapped address 0xe25 testing: random write/read operations
    #Address 0xe25 Write value 0xb4a3b911
    li x3, 0xb4a3b911
    csrw 0xe25, x3

    #Address 0xe25 Write value 0x2e3e7cc3
    li x3, 0x2e3e7cc3
    csrw 0xe25, x3

    #Address 0xe25 read value
    csrr x14, 0xe25

    #Unmapped address 0x658 testing: random write/read operations
    #Address 0x658 read value
    csrr x14, 0x658

    #Address 0x658 Write value 0x15053fda
    li x3, 0x15053fda
    csrw 0x658, x3

    #Address 0x658 read value
    csrr x14, 0x658

    #Address 0x658 read value
    csrr x14, 0x658

    #Unmapped address 0x55d testing: random write/read operations
    #Address 0x55d read value
    csrr x14, 0x55d

    #Address 0x55d read value
    csrr x14, 0x55d

    #Address 0x55d Write value 0x1d4d63d2
    li x3, 0x1d4d63d2
    csrw 0x55d, x3

    #Address 0x55d read value
    csrr x14, 0x55d

    #Address 0x55d Write value 0xe2583970
    li x3, 0xe2583970
    csrw 0x55d, x3

    #Unmapped address 0xa2f testing: random write/read operations
    #Address 0xa2f read value
    csrr x14, 0xa2f

    #Address 0xa2f Write value 0xa1232cf2
    li x3, 0xa1232cf2
    csrw 0xa2f, x3

    #Address 0xa2f read value
    csrr x14, 0xa2f

    #Address 0xa2f read value
    csrr x14, 0xa2f

    #Address 0xa2f Write value 0xb8326d1d
    li x3, 0xb8326d1d
    csrw 0xa2f, x3

    #Unmapped address 0x316 testing: random write/read operations
    #Address 0x316 read value
    csrr x14, 0x316

    #Address 0x316 read value
    csrr x14, 0x316

    #Address 0x316 read value
    csrr x14, 0x316

    #Unmapped address 0xe2b testing: random write/read operations
    #Address 0xe2b read value
    csrr x14, 0xe2b

    #Address 0xe2b read value
    csrr x14, 0xe2b

    #Address 0xe2b read value
    csrr x14, 0xe2b

    #Address 0xe2b read value
    csrr x14, 0xe2b

    #Unmapped address 0x138 testing: random write/read operations
    #Address 0x138 Write value 0x5c9deded
    li x3, 0x5c9deded
    csrw 0x138, x3

    #Address 0x138 Write value 0xe1949b97
    li x3, 0xe1949b97
    csrw 0x138, x3

    #Address 0x138 read value
    csrr x14, 0x138

    #Address 0x138 Write value 0x525ab03e
    li x3, 0x525ab03e
    csrw 0x138, x3

    #Unmapped address 0x218 testing: random write/read operations
    #Address 0x218 read value
    csrr x14, 0x218

    #Address 0x218 Write value 0x4c1d757b
    li x3, 0x4c1d757b
    csrw 0x218, x3

    #Address 0x218 read value
    csrr x14, 0x218

    #Unmapped address 0x8fc testing: random write/read operations
    #Address 0x8fc Write value 0x2bcd4043
    li x3, 0x2bcd4043
    csrw 0x8fc, x3

    #Address 0x8fc read value
    csrr x14, 0x8fc

    #Address 0x8fc Write value 0x3d7bc00b
    li x3, 0x3d7bc00b
    csrw 0x8fc, x3

    #Address 0x8fc Write value 0xcc8a7a5e
    li x3, 0xcc8a7a5e
    csrw 0x8fc, x3

    #Unmapped address 0x25c testing: random write/read operations
    #Address 0x25c Write value 0x9e0590cd
    li x3, 0x9e0590cd
    csrw 0x25c, x3

    #Address 0x25c Write value 0x7049cc93
    li x3, 0x7049cc93
    csrw 0x25c, x3

    #Unmapped address 0xbd6 testing: random write/read operations
    #Address 0xbd6 Write value 0xb0ced5cb
    li x3, 0xb0ced5cb
    csrw 0xbd6, x3

    #Address 0xbd6 Write value 0x40b27c4e
    li x3, 0x40b27c4e
    csrw 0xbd6, x3

    #Address 0xbd6 read value
    csrr x14, 0xbd6

    #Unmapped address 0x3e6 testing: random write/read operations
    #Address 0x3e6 Write value 0x57692960
    li x3, 0x57692960
    csrw 0x3e6, x3

    #Address 0x3e6 Write value 0xf851750f
    li x3, 0xf851750f
    csrw 0x3e6, x3

    #Unmapped address 0x47f testing: random write/read operations
    #Address 0x47f read value
    csrr x14, 0x47f

    #Address 0x47f Write value 0xaf61815e
    li x3, 0xaf61815e
    csrw 0x47f, x3

    #Address 0x47f Write value 0xb7871455
    li x3, 0xb7871455
    csrw 0x47f, x3

    #Unmapped address 0xf3f testing: random write/read operations
    #Address 0xf3f Write value 0xd09048ac
    li x3, 0xd09048ac
    csrw 0xf3f, x3

    #Unmapped address 0xc07 testing: random write/read operations
    #Address 0xc07 read value
    csrr x14, 0xc07

    #Address 0xc07 read value
    csrr x14, 0xc07

    #Unmapped address 0x47 testing: random write/read operations
    #Address 0x47 Write value 0x58a77e4e
    li x3, 0x58a77e4e
    csrw 0x47, x3

    #Address 0x47 Write value 0xb35e7144
    li x3, 0xb35e7144
    csrw 0x47, x3

    #Unmapped address 0xdc0 testing: random write/read operations
    #Address 0xdc0 read value
    csrr x14, 0xdc0

    #Unmapped address 0xab5 testing: random write/read operations
    #Address 0xab5 read value
    csrr x14, 0xab5

    #Address 0xab5 read value
    csrr x14, 0xab5

    #Address 0xab5 read value
    csrr x14, 0xab5

    #Unmapped address 0x434 testing: random write/read operations
    #Address 0x434 read value
    csrr x14, 0x434

    #Unmapped address 0x63f testing: random write/read operations
    #Address 0x63f Write value 0x891b8cad
    li x3, 0x891b8cad
    csrw 0x63f, x3

    #Address 0x63f Write value 0x3aa5a394
    li x3, 0x3aa5a394
    csrw 0x63f, x3

    #Unmapped address 0x4d0 testing: random write/read operations
    #Address 0x4d0 Write value 0xbc1c5544
    li x3, 0xbc1c5544
    csrw 0x4d0, x3

    #Address 0x4d0 Write value 0xc4c79545
    li x3, 0xc4c79545
    csrw 0x4d0, x3

    #Address 0x4d0 Write value 0x2ea0da8b
    li x3, 0x2ea0da8b
    csrw 0x4d0, x3

    #Address 0x4d0 Write value 0xcd8cd36b
    li x3, 0xcd8cd36b
    csrw 0x4d0, x3

    #Address 0x4d0 read value
    csrr x14, 0x4d0

    #Unmapped address 0xed0 testing: random write/read operations
    #Address 0xed0 Write value 0x3c9ac4f7
    li x3, 0x3c9ac4f7
    csrw 0xed0, x3

    #Unmapped address 0xa5e testing: random write/read operations
    #Address 0xa5e Write value 0xe4c77be5
    li x3, 0xe4c77be5
    csrw 0xa5e, x3

    #Address 0xa5e read value
    csrr x14, 0xa5e

    #Address 0xa5e read value
    csrr x14, 0xa5e

    #Address 0xa5e read value
    csrr x14, 0xa5e

    #Unmapped address 0x63c testing: random write/read operations
    #Address 0x63c read value
    csrr x14, 0x63c

    #Mapped address 0x3b5 (pmpaddr5) testing: random write/read operations
    #Address 0x3b5 Write value 0xadc96287
    li x3, 0xadc96287
    csrw 0x3b5, x3

    #Address 0x3b5 read value
    csrr x14, 0x3b5

    #Address 0x3b5 Write value 0x2451e144
    li x3, 0x2451e144
    csrw 0x3b5, x3

    #Address 0x3b5 read value
    csrr x14, 0x3b5

    #Unmapped address 0x2c4 testing: random write/read operations
    #Address 0x2c4 Write value 0x438326ad
    li x3, 0x438326ad
    csrw 0x2c4, x3

    #Address 0x2c4 read value
    csrr x14, 0x2c4

    #Address 0x2c4 read value
    csrr x14, 0x2c4

    #Unmapped address 0x63a testing: random write/read operations
    #Address 0x63a Write value 0x5ee04874
    li x3, 0x5ee04874
    csrw 0x63a, x3

    #Address 0x63a Write value 0x3a6f4849
    li x3, 0x3a6f4849
    csrw 0x63a, x3

    #Unmapped address 0xb7f testing: random write/read operations
    #Address 0xb7f Write value 0x12812700
    li x3, 0x12812700
    csrw 0xb7f, x3

    #Address 0xb7f Write value 0x24823bc1
    li x3, 0x24823bc1
    csrw 0xb7f, x3

    #Address 0xb7f Write value 0x7a62b159
    li x3, 0x7a62b159
    csrw 0xb7f, x3

    #Address 0xb7f read value
    csrr x14, 0xb7f

    #Address 0xb7f Write value 0xd2d1f7cd
    li x3, 0xd2d1f7cd
    csrw 0xb7f, x3

    #Unmapped address 0xfae testing: random write/read operations
    #Address 0xfae read value
    csrr x14, 0xfae

    #Address 0xfae Write value 0x7c1c641c
    li x3, 0x7c1c641c
    csrw 0xfae, x3

    #Unmapped address 0xc2f testing: random write/read operations
    #Address 0xc2f Write value 0x3c8dd54
    li x3, 0x3c8dd54
    csrw 0xc2f, x3

    #Unmapped address 0xf93 testing: random write/read operations
    #Address 0xf93 read value
    csrr x14, 0xf93

    #Address 0xf93 Write value 0xe1c582d4
    li x3, 0xe1c582d4
    csrw 0xf93, x3

    #Address 0xf93 Write value 0x3006910f
    li x3, 0x3006910f
    csrw 0xf93, x3

    #Address 0xf93 read value
    csrr x14, 0xf93

    #Unmapped address 0x89d testing: random write/read operations
    #Address 0x89d Write value 0x90f39da3
    li x3, 0x90f39da3
    csrw 0x89d, x3

    #Address 0x89d read value
    csrr x14, 0x89d

    #Address 0x89d read value
    csrr x14, 0x89d

    #Address 0x89d read value
    csrr x14, 0x89d

    #Address 0x89d read value
    csrr x14, 0x89d

    #Unmapped address 0xf25 testing: random write/read operations
    #Address 0xf25 read value
    csrr x14, 0xf25

    #Address 0xf25 Write value 0x799e6ea3
    li x3, 0x799e6ea3
    csrw 0xf25, x3

    #Address 0xf25 Write value 0xe91ab332
    li x3, 0xe91ab332
    csrw 0xf25, x3

    #Unmapped address 0x711 testing: random write/read operations
    #Address 0x711 Write value 0x20dcf814
    li x3, 0x20dcf814
    csrw 0x711, x3

    #Address 0x711 Write value 0x88a414e1
    li x3, 0x88a414e1
    csrw 0x711, x3

    #Address 0x711 read value
    csrr x14, 0x711

    #Address 0x711 read value
    csrr x14, 0x711

    #Address 0x711 Write value 0xb1154dba
    li x3, 0xb1154dba
    csrw 0x711, x3

    #Unmapped address 0x4c1 testing: random write/read operations
    #Address 0x4c1 read value
    csrr x14, 0x4c1

    #Address 0x4c1 Write value 0x7ce8f42f
    li x3, 0x7ce8f42f
    csrw 0x4c1, x3

    #Address 0x4c1 read value
    csrr x14, 0x4c1

    #Address 0x4c1 Write value 0x66b844e
    li x3, 0x66b844e
    csrw 0x4c1, x3

    #Unmapped address 0x1d8 testing: random write/read operations
    #Address 0x1d8 read value
    csrr x14, 0x1d8

    #Address 0x1d8 read value
    csrr x14, 0x1d8

    #Address 0x1d8 Write value 0xbd0a9926
    li x3, 0xbd0a9926
    csrw 0x1d8, x3

    #Address 0x1d8 Write value 0xa3ece95
    li x3, 0xa3ece95
    csrw 0x1d8, x3

    #Unmapped address 0xf6e testing: random write/read operations
    #Address 0xf6e Write value 0x4c7bf4cc
    li x3, 0x4c7bf4cc
    csrw 0xf6e, x3

    #Address 0xf6e read value
    csrr x14, 0xf6e

    #Address 0xf6e read value
    csrr x14, 0xf6e

    #Address 0xf6e read value
    csrr x14, 0xf6e

    #Address 0xf6e Write value 0x63163b6f
    li x3, 0x63163b6f
    csrw 0xf6e, x3

    #Unmapped address 0x97a testing: random write/read operations
    #Address 0x97a Write value 0x82872323
    li x3, 0x82872323
    csrw 0x97a, x3

    #Address 0x97a read value
    csrr x14, 0x97a

    #Address 0x97a Write value 0x272950b6
    li x3, 0x272950b6
    csrw 0x97a, x3

    #Address 0x97a read value
    csrr x14, 0x97a

    #Unmapped address 0xc48 testing: random write/read operations
    #Address 0xc48 read value
    csrr x14, 0xc48

    #Address 0xc48 Write value 0xad95f71d
    li x3, 0xad95f71d
    csrw 0xc48, x3

    #Address 0xc48 Write value 0x4f1e257a
    li x3, 0x4f1e257a
    csrw 0xc48, x3

    #Unmapped address 0xe2a testing: random write/read operations
    #Address 0xe2a Write value 0x629c667c
    li x3, 0x629c667c
    csrw 0xe2a, x3

    #Unmapped address 0xfe4 testing: random write/read operations
    #Address 0xfe4 read value
    csrr x14, 0xfe4

    #Address 0xfe4 Write value 0xda081dd3
    li x3, 0xda081dd3
    csrw 0xfe4, x3

    #Address 0xfe4 read value
    csrr x14, 0xfe4

    #Address 0xfe4 read value
    csrr x14, 0xfe4

    #Address 0xfe4 Write value 0xd7269472
    li x3, 0xd7269472
    csrw 0xfe4, x3

    #Unmapped address 0x533 testing: random write/read operations
    #Address 0x533 Write value 0x4d513a0d
    li x3, 0x4d513a0d
    csrw 0x533, x3

    #Address 0x533 read value
    csrr x14, 0x533

    #Unmapped address 0x153 testing: random write/read operations
    #Address 0x153 Write value 0x5e87c668
    li x3, 0x5e87c668
    csrw 0x153, x3

    #Address 0x153 read value
    csrr x14, 0x153

    #Address 0x153 read value
    csrr x14, 0x153

    #Address 0x153 Write value 0x112d234e
    li x3, 0x112d234e
    csrw 0x153, x3

    #Unmapped address 0x6fb testing: random write/read operations
    #Address 0x6fb Write value 0x6e6ce637
    li x3, 0x6e6ce637
    csrw 0x6fb, x3

    #Address 0x6fb read value
    csrr x14, 0x6fb

    #Address 0x6fb Write value 0xf1b845b9
    li x3, 0xf1b845b9
    csrw 0x6fb, x3

    #Address 0x6fb read value
    csrr x14, 0x6fb

    #Unmapped address 0x77e testing: random write/read operations
    #Address 0x77e read value
    csrr x14, 0x77e

    #Address 0x77e read value
    csrr x14, 0x77e

    #Address 0x77e Write value 0xe8bc16c5
    li x3, 0xe8bc16c5
    csrw 0x77e, x3

    #Address 0x77e read value
    csrr x14, 0x77e

    #Address 0x77e read value
    csrr x14, 0x77e

    #Unmapped address 0x4a4 testing: random write/read operations
    #Address 0x4a4 Write value 0x9aa3f4bb
    li x3, 0x9aa3f4bb
    csrw 0x4a4, x3

    #Address 0x4a4 Write value 0x7ea2d614
    li x3, 0x7ea2d614
    csrw 0x4a4, x3

    #Address 0x4a4 read value
    csrr x14, 0x4a4

    #Unmapped address 0x4ec testing: random write/read operations
    #Address 0x4ec Write value 0xe84c67f8
    li x3, 0xe84c67f8
    csrw 0x4ec, x3

    #Address 0x4ec Write value 0x760bb440
    li x3, 0x760bb440
    csrw 0x4ec, x3

    #Unmapped address 0x58 testing: random write/read operations
    #Address 0x58 Write value 0x5a465300
    li x3, 0x5a465300
    csrw 0x58, x3

    #Address 0x58 Write value 0x7cb5faca
    li x3, 0x7cb5faca
    csrw 0x58, x3

    #Unmapped address 0x5a3 testing: random write/read operations
    #Address 0x5a3 Write value 0x5a503f89
    li x3, 0x5a503f89
    csrw 0x5a3, x3

    #Address 0x5a3 read value
    csrr x14, 0x5a3

    #Address 0x5a3 Write value 0xd6b36f35
    li x3, 0xd6b36f35
    csrw 0x5a3, x3

    #Address 0x5a3 read value
    csrr x14, 0x5a3

    #Unmapped address 0x9b3 testing: random write/read operations
    #Address 0x9b3 read value
    csrr x14, 0x9b3

    #Address 0x9b3 Write value 0xfd01299b
    li x3, 0xfd01299b
    csrw 0x9b3, x3

    #Address 0x9b3 read value
    csrr x14, 0x9b3

    #Unmapped address 0x64c testing: random write/read operations
    #Address 0x64c read value
    csrr x14, 0x64c

    #Address 0x64c Write value 0x1d4907ed
    li x3, 0x1d4907ed
    csrw 0x64c, x3

    #Address 0x64c Write value 0x91d29c7c
    li x3, 0x91d29c7c
    csrw 0x64c, x3

    #Address 0x64c Write value 0x4d16ac97
    li x3, 0x4d16ac97
    csrw 0x64c, x3

    #Unmapped address 0xb42 testing: random write/read operations
    #Address 0xb42 Write value 0xe11d5724
    li x3, 0xe11d5724
    csrw 0xb42, x3

    #Address 0xb42 read value
    csrr x14, 0xb42

    #Address 0xb42 read value
    csrr x14, 0xb42

    #Address 0xb42 Write value 0x4270ce
    li x3, 0x4270ce
    csrw 0xb42, x3

    #Address 0xb42 Write value 0x3b37db89
    li x3, 0x3b37db89
    csrw 0xb42, x3

    #Unmapped address 0x1b7 testing: random write/read operations
    #Address 0x1b7 read value
    csrr x14, 0x1b7

    #Address 0x1b7 read value
    csrr x14, 0x1b7

    #Unmapped address 0xb61 testing: random write/read operations
    #Address 0xb61 read value
    csrr x14, 0xb61

    #Unmapped address 0xde1 testing: random write/read operations
    #Address 0xde1 Write value 0x88f34740
    li x3, 0x88f34740
    csrw 0xde1, x3

    #Address 0xde1 Write value 0xbe7ec7a4
    li x3, 0xbe7ec7a4
    csrw 0xde1, x3

    #Unmapped address 0x559 testing: random write/read operations
    #Address 0x559 Write value 0xf252aeb1
    li x3, 0xf252aeb1
    csrw 0x559, x3

    #Address 0x559 read value
    csrr x14, 0x559

    #Address 0x559 read value
    csrr x14, 0x559

    #Unmapped address 0x8b6 testing: random write/read operations
    #Address 0x8b6 Write value 0x736396e1
    li x3, 0x736396e1
    csrw 0x8b6, x3

    #Address 0x8b6 Write value 0x7d40572c
    li x3, 0x7d40572c
    csrw 0x8b6, x3

    #Address 0x8b6 Write value 0x63fe5fe2
    li x3, 0x63fe5fe2
    csrw 0x8b6, x3

    #Address 0x8b6 Write value 0x74841a33
    li x3, 0x74841a33
    csrw 0x8b6, x3

    #Unmapped address 0x936 testing: random write/read operations
    #Address 0x936 read value
    csrr x14, 0x936

    #Address 0x936 Write value 0xd6c3ccad
    li x3, 0xd6c3ccad
    csrw 0x936, x3

    #Address 0x936 read value
    csrr x14, 0x936

    #Address 0x936 Write value 0xdd0330ec
    li x3, 0xdd0330ec
    csrw 0x936, x3

    #Unmapped address 0x976 testing: random write/read operations
    #Address 0x976 read value
    csrr x14, 0x976

    #Unmapped address 0xf16 testing: random write/read operations
    #Address 0xf16 Write value 0xce79f424
    li x3, 0xce79f424
    csrw 0xf16, x3

    #Address 0xf16 read value
    csrr x14, 0xf16

    #Address 0xf16 read value
    csrr x14, 0xf16

    #Unmapped address 0xba5 testing: random write/read operations
    #Address 0xba5 Write value 0xfaa6b95e
    li x3, 0xfaa6b95e
    csrw 0xba5, x3

    #Unmapped address 0xb7a testing: random write/read operations
    #Address 0xb7a Write value 0xa33cb72e
    li x3, 0xa33cb72e
    csrw 0xb7a, x3

    #Address 0xb7a Write value 0x1117f4f1
    li x3, 0x1117f4f1
    csrw 0xb7a, x3

    #Address 0xb7a Write value 0x8bfbf64f
    li x3, 0x8bfbf64f
    csrw 0xb7a, x3

    #Address 0xb7a read value
    csrr x14, 0xb7a

    #Address 0xb7a read value
    csrr x14, 0xb7a

    #Unmapped address 0x349 testing: random write/read operations
    #Address 0x349 Write value 0xb1f8d770
    li x3, 0xb1f8d770
    csrw 0x349, x3

    #Address 0x349 Write value 0xfdb3e06f
    li x3, 0xfdb3e06f
    csrw 0x349, x3

    #Address 0x349 Write value 0xb3cc6d6f
    li x3, 0xb3cc6d6f
    csrw 0x349, x3

    #Unmapped address 0x5cc testing: random write/read operations
    #Address 0x5cc read value
    csrr x14, 0x5cc

    #Address 0x5cc read value
    csrr x14, 0x5cc

    #Address 0x5cc Write value 0xd0fe044e
    li x3, 0xd0fe044e
    csrw 0x5cc, x3

    #Unmapped address 0xc76 testing: random write/read operations
    #Address 0xc76 Write value 0x9dd4884c
    li x3, 0x9dd4884c
    csrw 0xc76, x3

    #Address 0xc76 Write value 0x4b56661e
    li x3, 0x4b56661e
    csrw 0xc76, x3

    #Address 0xc76 read value
    csrr x14, 0xc76

    #Unmapped address 0xc6e testing: random write/read operations
    #Address 0xc6e Write value 0x6b972fe9
    li x3, 0x6b972fe9
    csrw 0xc6e, x3

    #Address 0xc6e read value
    csrr x14, 0xc6e

    #Unmapped address 0xaaa testing: random write/read operations
    #Address 0xaaa Write value 0xca84b12a
    li x3, 0xca84b12a
    csrw 0xaaa, x3

    #Address 0xaaa Write value 0x1b1f1451
    li x3, 0x1b1f1451
    csrw 0xaaa, x3

    #Address 0xaaa Write value 0x70ab270e
    li x3, 0x70ab270e
    csrw 0xaaa, x3

    #Unmapped address 0xc70 testing: random write/read operations
    #Address 0xc70 read value
    csrr x14, 0xc70

    #Address 0xc70 Write value 0x2a425f37
    li x3, 0x2a425f37
    csrw 0xc70, x3

    #Address 0xc70 Write value 0xf7e8f7dd
    li x3, 0xf7e8f7dd
    csrw 0xc70, x3

    #Address 0xc70 Write value 0xb30593ed
    li x3, 0xb30593ed
    csrw 0xc70, x3

    #Unmapped address 0x92 testing: random write/read operations
    #Address 0x92 read value
    csrr x14, 0x92

    #Unmapped address 0x4a7 testing: random write/read operations
    #Address 0x4a7 read value
    csrr x14, 0x4a7

    #Address 0x4a7 read value
    csrr x14, 0x4a7

    #Unmapped address 0x628 testing: random write/read operations
    #Address 0x628 Write value 0x1fc09b06
    li x3, 0x1fc09b06
    csrw 0x628, x3

    #Address 0x628 Write value 0x68265ac9
    li x3, 0x68265ac9
    csrw 0x628, x3

    #Address 0x628 read value
    csrr x14, 0x628

    #Address 0x628 read value
    csrr x14, 0x628

    #Address 0x628 Write value 0x7927bdee
    li x3, 0x7927bdee
    csrw 0x628, x3

    #Unmapped address 0x6bf testing: random write/read operations
    #Address 0x6bf read value
    csrr x14, 0x6bf

    #Unmapped address 0x644 testing: random write/read operations
    #Address 0x644 Write value 0xd1a6cc94
    li x3, 0xd1a6cc94
    csrw 0x644, x3

    #Address 0x644 read value
    csrr x14, 0x644

    #Unmapped address 0x45b testing: random write/read operations
    #Address 0x45b Write value 0xca5ca572
    li x3, 0xca5ca572
    csrw 0x45b, x3

    #Unmapped address 0x8c9 testing: random write/read operations
    #Address 0x8c9 Write value 0x1c8ea131
    li x3, 0x1c8ea131
    csrw 0x8c9, x3

    #Unmapped address 0x477 testing: random write/read operations
    #Address 0x477 read value
    csrr x14, 0x477

    #Address 0x477 Write value 0x6c416ceb
    li x3, 0x6c416ceb
    csrw 0x477, x3

    #Unmapped address 0x956 testing: random write/read operations
    #Address 0x956 read value
    csrr x14, 0x956

    #Address 0x956 read value
    csrr x14, 0x956

    #Unmapped address 0x4c5 testing: random write/read operations
    #Address 0x4c5 Write value 0x867b098b
    li x3, 0x867b098b
    csrw 0x4c5, x3

    #Address 0x4c5 read value
    csrr x14, 0x4c5

    #Address 0x4c5 Write value 0x8f52cba3
    li x3, 0x8f52cba3
    csrw 0x4c5, x3

    #Address 0x4c5 read value
    csrr x14, 0x4c5

    #Address 0x4c5 Write value 0xc1757af4
    li x3, 0xc1757af4
    csrw 0x4c5, x3

    #Unmapped address 0x9f5 testing: random write/read operations
    #Address 0x9f5 Write value 0x5db4d49b
    li x3, 0x5db4d49b
    csrw 0x9f5, x3

    #Unmapped address 0x60c testing: random write/read operations
    #Address 0x60c read value
    csrr x14, 0x60c

    #Address 0x60c Write value 0xc4281b84
    li x3, 0xc4281b84
    csrw 0x60c, x3

    #Address 0x60c read value
    csrr x14, 0x60c

    #Unmapped address 0x652 testing: random write/read operations
    #Address 0x652 read value
    csrr x14, 0x652

    #Address 0x652 Write value 0x85fe9e5e
    li x3, 0x85fe9e5e
    csrw 0x652, x3

    #Address 0x652 read value
    csrr x14, 0x652

    #Address 0x652 read value
    csrr x14, 0x652

    #Address 0x652 read value
    csrr x14, 0x652

    #Unmapped address 0xc92 testing: random write/read operations
    #Address 0xc92 Write value 0xcc41178f
    li x3, 0xcc41178f
    csrw 0xc92, x3

    #Unmapped address 0x4f5 testing: random write/read operations
    #Address 0x4f5 Write value 0x8d052db1
    li x3, 0x8d052db1
    csrw 0x4f5, x3

    #Address 0x4f5 read value
    csrr x14, 0x4f5

    #Address 0x4f5 read value
    csrr x14, 0x4f5

    #Address 0x4f5 Write value 0x79b2b7b8
    li x3, 0x79b2b7b8
    csrw 0x4f5, x3

    #Address 0x4f5 read value
    csrr x14, 0x4f5

    #Unmapped address 0xbd7 testing: random write/read operations
    #Address 0xbd7 Write value 0x3fb2d78f
    li x3, 0x3fb2d78f
    csrw 0xbd7, x3

    #Address 0xbd7 read value
    csrr x14, 0xbd7

    #Unmapped address 0xce6 testing: random write/read operations
    #Address 0xce6 read value
    csrr x14, 0xce6

    #Address 0xce6 Write value 0xfdd46e0c
    li x3, 0xfdd46e0c
    csrw 0xce6, x3

    #Address 0xce6 read value
    csrr x14, 0xce6

    #Address 0xce6 Write value 0xc8c9a63d
    li x3, 0xc8c9a63d
    csrw 0xce6, x3

    #Unmapped address 0xafb testing: random write/read operations
    #Address 0xafb Write value 0x452068e9
    li x3, 0x452068e9
    csrw 0xafb, x3

    #Unmapped address 0x61 testing: random write/read operations
    #Address 0x61 Write value 0x871e1ac6
    li x3, 0x871e1ac6
    csrw 0x61, x3

    #Address 0x61 read value
    csrr x14, 0x61

    #Address 0x61 Write value 0xf7c9e4ef
    li x3, 0xf7c9e4ef
    csrw 0x61, x3

    #Address 0x61 read value
    csrr x14, 0x61

    #Unmapped address 0x17a testing: random write/read operations
    #Address 0x17a Write value 0x8b98377f
    li x3, 0x8b98377f
    csrw 0x17a, x3

    #Address 0x17a Write value 0x4eca17f2
    li x3, 0x4eca17f2
    csrw 0x17a, x3

    #Address 0x17a read value
    csrr x14, 0x17a

    #Address 0x17a Write value 0xc3971b49
    li x3, 0xc3971b49
    csrw 0x17a, x3

    #Unmapped address 0xc9c testing: random write/read operations
    #Address 0xc9c read value
    csrr x14, 0xc9c

    #Address 0xc9c Write value 0xd2e0ab6f
    li x3, 0xd2e0ab6f
    csrw 0xc9c, x3

    #Address 0xc9c read value
    csrr x14, 0xc9c

    #Address 0xc9c Write value 0x7468f02
    li x3, 0x7468f02
    csrw 0xc9c, x3

    #Address 0xc9c Write value 0x9d70ac74
    li x3, 0x9d70ac74
    csrw 0xc9c, x3

    #Unmapped address 0x5fa testing: random write/read operations
    #Address 0x5fa read value
    csrr x14, 0x5fa

    #Address 0x5fa Write value 0xa33b96b3
    li x3, 0xa33b96b3
    csrw 0x5fa, x3

    #Unmapped address 0xfab testing: random write/read operations
    #Address 0xfab Write value 0x52821fd6
    li x3, 0x52821fd6
    csrw 0xfab, x3

    #Unmapped address 0x78a testing: random write/read operations
    #Address 0x78a read value
    csrr x14, 0x78a

    #Address 0x78a read value
    csrr x14, 0x78a

    #Address 0x78a Write value 0xc3da6c05
    li x3, 0xc3da6c05
    csrw 0x78a, x3

    #Unmapped address 0x836 testing: random write/read operations
    #Address 0x836 Write value 0x978b8599
    li x3, 0x978b8599
    csrw 0x836, x3

    #Address 0x836 Write value 0x1015e705
    li x3, 0x1015e705
    csrw 0x836, x3

    #Unmapped address 0xb29 testing: random write/read operations
    #Address 0xb29 read value
    csrr x14, 0xb29

    #Unmapped address 0x1b3 testing: random write/read operations
    #Address 0x1b3 read value
    csrr x14, 0x1b3

    #Address 0x1b3 Write value 0xa6e62cf1
    li x3, 0xa6e62cf1
    csrw 0x1b3, x3

    #Address 0x1b3 Write value 0x86c5472
    li x3, 0x86c5472
    csrw 0x1b3, x3

    #Unmapped address 0xe35 testing: random write/read operations
    #Address 0xe35 read value
    csrr x14, 0xe35

    #Address 0xe35 read value
    csrr x14, 0xe35

    #Address 0xe35 Write value 0x7f995629
    li x3, 0x7f995629
    csrw 0xe35, x3

    #Address 0xe35 Write value 0x135f2ca1
    li x3, 0x135f2ca1
    csrw 0xe35, x3

    #Unmapped address 0x77f testing: random write/read operations
    #Address 0x77f read value
    csrr x14, 0x77f

    #Address 0x77f Write value 0x84f00a9a
    li x3, 0x84f00a9a
    csrw 0x77f, x3

    #Address 0x77f Write value 0x6350f50b
    li x3, 0x6350f50b
    csrw 0x77f, x3

    #Mapped address 0xb03 (mhpmcounter3) testing: random write/read operations
    #Address 0xb03 Write value 0x1beb8dd
    li x3, 0x1beb8dd
    csrw 0xb03, x3

    #Address 0xb03 Write value 0x6289b74a
    li x3, 0x6289b74a
    csrw 0xb03, x3

    #Address 0xb03 Write value 0xc2b47d7b
    li x3, 0xc2b47d7b
    csrw 0xb03, x3

    #Address 0xb03 read value
    csrr x14, 0xb03

    #Unmapped address 0x76f testing: random write/read operations
    #Address 0x76f Write value 0xe3bbcc73
    li x3, 0xe3bbcc73
    csrw 0x76f, x3

    #Address 0x76f Write value 0x1506f337
    li x3, 0x1506f337
    csrw 0x76f, x3

    #Address 0x76f Write value 0xafe51a57
    li x3, 0xafe51a57
    csrw 0x76f, x3

    #Unmapped address 0xb4e testing: random write/read operations
    #Address 0xb4e Write value 0xc551fbd
    li x3, 0xc551fbd
    csrw 0xb4e, x3

    #Address 0xb4e read value
    csrr x14, 0xb4e

    #Address 0xb4e read value
    csrr x14, 0xb4e

    #Address 0xb4e read value
    csrr x14, 0xb4e

    #Unmapped address 0x8f3 testing: random write/read operations
    #Address 0x8f3 Write value 0x97b9567
    li x3, 0x97b9567
    csrw 0x8f3, x3

    #Unmapped address 0x5f4 testing: random write/read operations
    #Address 0x5f4 read value
    csrr x14, 0x5f4

    #Address 0x5f4 Write value 0xdb0c06ac
    li x3, 0xdb0c06ac
    csrw 0x5f4, x3

    #Address 0x5f4 read value
    csrr x14, 0x5f4

    #Unmapped address 0xce8 testing: random write/read operations
    #Address 0xce8 Write value 0x95e09171
    li x3, 0x95e09171
    csrw 0xce8, x3

    #Address 0xce8 Write value 0xacad01c2
    li x3, 0xacad01c2
    csrw 0xce8, x3

    #Address 0xce8 Write value 0x98299151
    li x3, 0x98299151
    csrw 0xce8, x3

    #Address 0xce8 Write value 0x1cd70691
    li x3, 0x1cd70691
    csrw 0xce8, x3

    #Address 0xce8 Write value 0x751beb21
    li x3, 0x751beb21
    csrw 0xce8, x3

    #Unmapped address 0xd78 testing: random write/read operations
    #Address 0xd78 Write value 0xc72f487e
    li x3, 0xc72f487e
    csrw 0xd78, x3

    #Address 0xd78 read value
    csrr x14, 0xd78

    #Address 0xd78 Write value 0x8f999fc3
    li x3, 0x8f999fc3
    csrw 0xd78, x3

    #Address 0xd78 Write value 0x862372a8
    li x3, 0x862372a8
    csrw 0xd78, x3

    #Unmapped address 0xf4 testing: random write/read operations
    #Address 0xf4 read value
    csrr x14, 0xf4

    #Address 0xf4 read value
    csrr x14, 0xf4

    #Address 0xf4 Write value 0x554fee03
    li x3, 0x554fee03
    csrw 0xf4, x3

    #Address 0xf4 read value
    csrr x14, 0xf4

    #Unmapped address 0x640 testing: random write/read operations
    #Address 0x640 Write value 0x6183529c
    li x3, 0x6183529c
    csrw 0x640, x3

    #Unmapped address 0xeb5 testing: random write/read operations
    #Address 0xeb5 Write value 0x55977b63
    li x3, 0x55977b63
    csrw 0xeb5, x3

    #Address 0xeb5 read value
    csrr x14, 0xeb5

    #Address 0xeb5 read value
    csrr x14, 0xeb5

    #Unmapped address 0x589 testing: random write/read operations
    #Address 0x589 read value
    csrr x14, 0x589

    #Address 0x589 read value
    csrr x14, 0x589

    #Unmapped address 0xde7 testing: random write/read operations
    #Address 0xde7 read value
    csrr x14, 0xde7

    #Address 0xde7 Write value 0x3167842f
    li x3, 0x3167842f
    csrw 0xde7, x3

    #Unmapped address 0x758 testing: random write/read operations
    #Address 0x758 Write value 0x1413f839
    li x3, 0x1413f839
    csrw 0x758, x3

    #Unmapped address 0x62 testing: random write/read operations
    #Address 0x62 Write value 0xc4e40b26
    li x3, 0xc4e40b26
    csrw 0x62, x3

    #Address 0x62 read value
    csrr x14, 0x62

    #Address 0x62 read value
    csrr x14, 0x62

    #Unmapped address 0xcb8 testing: random write/read operations
    #Address 0xcb8 read value
    csrr x14, 0xcb8

    #Address 0xcb8 read value
    csrr x14, 0xcb8

    #Address 0xcb8 read value
    csrr x14, 0xcb8

    #Mapped address 0xf13 (mimpid) testing: random write/read operations
    #Address 0xf13 read value
    csrr x14, 0xf13

    #Unmapped address 0x809 testing: random write/read operations
    #Address 0x809 read value
    csrr x14, 0x809

    #Address 0x809 Write value 0xdbc3796e
    li x3, 0xdbc3796e
    csrw 0x809, x3

    #Address 0x809 Write value 0x591ae2be
    li x3, 0x591ae2be
    csrw 0x809, x3

    #Mapped address 0xb0f (mhpmcounter15) testing: random write/read operations
    #Address 0xb0f read value
    csrr x14, 0xb0f

    #Unmapped address 0x125 testing: random write/read operations
    #Address 0x125 read value
    csrr x14, 0x125

    #Address 0x125 Write value 0x61664b1
    li x3, 0x61664b1
    csrw 0x125, x3

    #Unmapped address 0xd60 testing: random write/read operations
    #Address 0xd60 read value
    csrr x14, 0xd60

    #Address 0xd60 Write value 0xc408bd7f
    li x3, 0xc408bd7f
    csrw 0xd60, x3

    #Unmapped address 0xed8 testing: random write/read operations
    #Address 0xed8 Write value 0xea8cdb40
    li x3, 0xea8cdb40
    csrw 0xed8, x3

    #Unmapped address 0x5f1 testing: random write/read operations
    #Address 0x5f1 Write value 0x970e87ac
    li x3, 0x970e87ac
    csrw 0x5f1, x3

    #Address 0x5f1 read value
    csrr x14, 0x5f1

    #Address 0x5f1 read value
    csrr x14, 0x5f1

    #Address 0x5f1 read value
    csrr x14, 0x5f1

    #Unmapped address 0x2ff testing: random write/read operations
    #Address 0x2ff read value
    csrr x14, 0x2ff

    #Address 0x2ff read value
    csrr x14, 0x2ff

    #Address 0x2ff Write value 0x475589cc
    li x3, 0x475589cc
    csrw 0x2ff, x3

    #Unmapped address 0x72f testing: random write/read operations
    #Address 0x72f read value
    csrr x14, 0x72f

    #Address 0x72f Write value 0x148ee890
    li x3, 0x148ee890
    csrw 0x72f, x3

    #Address 0x72f Write value 0x7b7489de
    li x3, 0x7b7489de
    csrw 0x72f, x3

    #Address 0x72f read value
    csrr x14, 0x72f

    #Unmapped address 0xcc7 testing: random write/read operations
    #Address 0xcc7 read value
    csrr x14, 0xcc7

    #Unmapped address 0x87f testing: random write/read operations
    #Address 0x87f read value
    csrr x14, 0x87f

    #Address 0x87f Write value 0x7ec33b5b
    li x3, 0x7ec33b5b
    csrw 0x87f, x3

    #Address 0x87f Write value 0x8c1681aa
    li x3, 0x8c1681aa
    csrw 0x87f, x3

    #Unmapped address 0xbe6 testing: random write/read operations
    #Address 0xbe6 Write value 0xcc262843
    li x3, 0xcc262843
    csrw 0xbe6, x3

    #Address 0xbe6 read value
    csrr x14, 0xbe6

    #Address 0xbe6 read value
    csrr x14, 0xbe6

    #Unmapped address 0xde5 testing: random write/read operations
    #Address 0xde5 read value
    csrr x14, 0xde5

    #Unmapped address 0x7ba testing: random write/read operations
    #Address 0x7ba Write value 0x3cb0ee8
    li x3, 0x3cb0ee8
    csrw 0x7ba, x3

    #Address 0x7ba Write value 0xad191f8d
    li x3, 0xad191f8d
    csrw 0x7ba, x3

    #Unmapped address 0xd9f testing: random write/read operations
    #Address 0xd9f read value
    csrr x14, 0xd9f

    #Address 0xd9f read value
    csrr x14, 0xd9f

    #Address 0xd9f Write value 0xaee910c3
    li x3, 0xaee910c3
    csrw 0xd9f, x3

    #Unmapped address 0xa0e testing: random write/read operations
    #Address 0xa0e Write value 0x3e91ddea
    li x3, 0x3e91ddea
    csrw 0xa0e, x3

    #Address 0xa0e read value
    csrr x14, 0xa0e

    #Mapped address 0xb1a (mhpmcounter26) testing: random write/read operations
    #Address 0xb1a read value
    csrr x14, 0xb1a

    #Address 0xb1a read value
    csrr x14, 0xb1a

    #Address 0xb1a Write value 0x30f9389f
    li x3, 0x30f9389f
    csrw 0xb1a, x3

    #Unmapped address 0x880 testing: random write/read operations
    #Address 0x880 read value
    csrr x14, 0x880

    #Address 0x880 read value
    csrr x14, 0x880

    #Address 0x880 read value
    csrr x14, 0x880

    #Address 0x880 Write value 0xbd1edb9e
    li x3, 0xbd1edb9e
    csrw 0x880, x3

    #Mapped address 0xb04 (mhpmcounter4) testing: random write/read operations
    #Address 0xb04 Write value 0xffb6b455
    li x3, 0xffb6b455
    csrw 0xb04, x3

    #Address 0xb04 Write value 0x1cc2dabe
    li x3, 0x1cc2dabe
    csrw 0xb04, x3

    #Address 0xb04 Write value 0xb53c0acb
    li x3, 0xb53c0acb
    csrw 0xb04, x3

    #Address 0xb04 read value
    csrr x14, 0xb04

    #Address 0xb04 Write value 0x69c36ab5
    li x3, 0x69c36ab5
    csrw 0xb04, x3

    #Unmapped address 0xe16 testing: random write/read operations
    #Address 0xe16 read value
    csrr x14, 0xe16

    #Address 0xe16 read value
    csrr x14, 0xe16

    #Address 0xe16 read value
    csrr x14, 0xe16

    #Unmapped address 0xb37 testing: random write/read operations
    #Address 0xb37 Write value 0xf62012c1
    li x3, 0xf62012c1
    csrw 0xb37, x3

    #Address 0xb37 read value
    csrr x14, 0xb37

    #Address 0xb37 read value
    csrr x14, 0xb37

    #Address 0xb37 Write value 0x4643f221
    li x3, 0x4643f221
    csrw 0xb37, x3

    #Address 0xb37 Write value 0xf3ec1198
    li x3, 0xf3ec1198
    csrw 0xb37, x3

    #Unmapped address 0xadc testing: random write/read operations
    #Address 0xadc read value
    csrr x14, 0xadc

    #Address 0xadc read value
    csrr x14, 0xadc

    #Address 0xadc read value
    csrr x14, 0xadc

    #Address 0xadc Write value 0x44b7fe0a
    li x3, 0x44b7fe0a
    csrw 0xadc, x3

    #Address 0xadc read value
    csrr x14, 0xadc

    #Unmapped address 0x194 testing: random write/read operations
    #Address 0x194 Write value 0x4ce7cef1
    li x3, 0x4ce7cef1
    csrw 0x194, x3

    #Address 0x194 read value
    csrr x14, 0x194

    #Address 0x194 Write value 0xa972e978
    li x3, 0xa972e978
    csrw 0x194, x3

    #Address 0x194 read value
    csrr x14, 0x194

    #Address 0x194 read value
    csrr x14, 0x194

    #Unmapped address 0x9fa testing: random write/read operations
    #Address 0x9fa Write value 0x80c4877a
    li x3, 0x80c4877a
    csrw 0x9fa, x3

    #Address 0x9fa Write value 0xcc00a53
    li x3, 0xcc00a53
    csrw 0x9fa, x3

    #Address 0x9fa Write value 0x4dd4affe
    li x3, 0x4dd4affe
    csrw 0x9fa, x3

    #Address 0x9fa Write value 0x625ae931
    li x3, 0x625ae931
    csrw 0x9fa, x3

    #Unmapped address 0xc67 testing: random write/read operations
    #Address 0xc67 read value
    csrr x14, 0xc67

    #Unmapped address 0x954 testing: random write/read operations
    #Address 0x954 read value
    csrr x14, 0x954

    #Unmapped address 0xd86 testing: random write/read operations
    #Address 0xd86 Write value 0xa132df4
    li x3, 0xa132df4
    csrw 0xd86, x3

    #Address 0xd86 read value
    csrr x14, 0xd86

    #Address 0xd86 read value
    csrr x14, 0xd86

    #Address 0xd86 Write value 0xbfc78e92
    li x3, 0xbfc78e92
    csrw 0xd86, x3

    #Unmapped address 0x683 testing: random write/read operations
    #Address 0x683 read value
    csrr x14, 0x683

    #Unmapped address 0x791 testing: random write/read operations
    #Address 0x791 Write value 0x62ffd85c
    li x3, 0x62ffd85c
    csrw 0x791, x3

    #Address 0x791 Write value 0x2b7f2fef
    li x3, 0x2b7f2fef
    csrw 0x791, x3

    #Address 0x791 read value
    csrr x14, 0x791

    #Address 0x791 Write value 0x80cbe0a7
    li x3, 0x80cbe0a7
    csrw 0x791, x3

    #Unmapped address 0x783 testing: random write/read operations
    #Address 0x783 Write value 0x78453ce9
    li x3, 0x78453ce9
    csrw 0x783, x3

    #Address 0x783 read value
    csrr x14, 0x783

    #Address 0x783 Write value 0x3dc42d81
    li x3, 0x3dc42d81
    csrw 0x783, x3

    #Address 0x783 read value
    csrr x14, 0x783

    #Address 0x783 Write value 0xe2395022
    li x3, 0xe2395022
    csrw 0x783, x3

    #Unmapped address 0x3fc testing: random write/read operations
    #Address 0x3fc Write value 0x27108e61
    li x3, 0x27108e61
    csrw 0x3fc, x3

    #Address 0x3fc Write value 0x1d1d2d3e
    li x3, 0x1d1d2d3e
    csrw 0x3fc, x3

    #Address 0x3fc Write value 0x35eaca1b
    li x3, 0x35eaca1b
    csrw 0x3fc, x3

    #Address 0x3fc Write value 0xaf5002b4
    li x3, 0xaf5002b4
    csrw 0x3fc, x3

    #Address 0x3fc Write value 0x3ce91782
    li x3, 0x3ce91782
    csrw 0x3fc, x3

    #Unmapped address 0x2e0 testing: random write/read operations
    #Address 0x2e0 Write value 0xcf5d54e1
    li x3, 0xcf5d54e1
    csrw 0x2e0, x3

    #Unmapped address 0xc7 testing: random write/read operations
    #Address 0xc7 read value
    csrr x14, 0xc7

    #Address 0xc7 Write value 0xc1bad5ae
    li x3, 0xc1bad5ae
    csrw 0xc7, x3

    #Unmapped address 0x4be testing: random write/read operations
    #Address 0x4be read value
    csrr x14, 0x4be

    #Address 0x4be Write value 0x3f4d2159
    li x3, 0x3f4d2159
    csrw 0x4be, x3

    #Address 0x4be Write value 0x95d83fa
    li x3, 0x95d83fa
    csrw 0x4be, x3

    #Unmapped address 0xf7c testing: random write/read operations
    #Address 0xf7c read value
    csrr x14, 0xf7c

    #Unmapped address 0x73f testing: random write/read operations
    #Address 0x73f read value
    csrr x14, 0x73f

    #Unmapped address 0x2e1 testing: random write/read operations
    #Address 0x2e1 Write value 0xc8a40355
    li x3, 0xc8a40355
    csrw 0x2e1, x3

    #Address 0x2e1 read value
    csrr x14, 0x2e1

    #Address 0x2e1 read value
    csrr x14, 0x2e1

    #Address 0x2e1 Write value 0x896abb89
    li x3, 0x896abb89
    csrw 0x2e1, x3

    #Unmapped address 0x6d3 testing: random write/read operations
    #Address 0x6d3 read value
    csrr x14, 0x6d3

    #Unmapped address 0x30d testing: random write/read operations
    #Address 0x30d Write value 0xacd3b016
    li x3, 0xacd3b016
    csrw 0x30d, x3

    #Address 0x30d read value
    csrr x14, 0x30d

    #Mapped address 0x333 (mhpmevent19) testing: random write/read operations
    #Address 0x333 read value
    csrr x14, 0x333

    #Address 0x333 Write value 0xfff4194d
    li x3, 0xfff4194d
    csrw 0x333, x3

    #Address 0x333 read value
    csrr x14, 0x333

    #Address 0x333 Write value 0xb5d36639
    li x3, 0xb5d36639
    csrw 0x333, x3

    #Unmapped address 0xc47 testing: random write/read operations
    #Address 0xc47 Write value 0xafa07838
    li x3, 0xafa07838
    csrw 0xc47, x3

    #Address 0xc47 read value
    csrr x14, 0xc47

    #Unmapped address 0xb3b testing: random write/read operations
    #Address 0xb3b read value
    csrr x14, 0xb3b

    #Unmapped address 0xc99 testing: random write/read operations
    #Address 0xc99 read value
    csrr x14, 0xc99

    #Address 0xc99 Write value 0x32b0bcc2
    li x3, 0x32b0bcc2
    csrw 0xc99, x3

    #Address 0xc99 read value
    csrr x14, 0xc99

    #Unmapped address 0x83f testing: random write/read operations
    #Address 0x83f Write value 0x71450a4f
    li x3, 0x71450a4f
    csrw 0x83f, x3

    #Address 0x83f read value
    csrr x14, 0x83f

    #Address 0x83f Write value 0xe8aff005
    li x3, 0xe8aff005
    csrw 0x83f, x3

    #Address 0x83f Write value 0x85c2e08e
    li x3, 0x85c2e08e
    csrw 0x83f, x3

    #Address 0x83f Write value 0x3213316c
    li x3, 0x3213316c
    csrw 0x83f, x3

    #Unmapped address 0xcfe testing: random write/read operations
    #Address 0xcfe Write value 0xb3a9f429
    li x3, 0xb3a9f429
    csrw 0xcfe, x3

    #Address 0xcfe Write value 0xc919d5dd
    li x3, 0xc919d5dd
    csrw 0xcfe, x3

    #Address 0xcfe Write value 0x3fe383dd
    li x3, 0x3fe383dd
    csrw 0xcfe, x3

    #Address 0xcfe Write value 0x634e2eb6
    li x3, 0x634e2eb6
    csrw 0xcfe, x3

    #Unmapped address 0x7e2 testing: random write/read operations
    #Address 0x7e2 Write value 0xd96a504b
    li x3, 0xd96a504b
    csrw 0x7e2, x3

    #Address 0x7e2 Write value 0xe0a05256
    li x3, 0xe0a05256
    csrw 0x7e2, x3

    #Unmapped address 0x9ef testing: random write/read operations
    #Address 0x9ef Write value 0x84adb29f
    li x3, 0x84adb29f
    csrw 0x9ef, x3

    #Unmapped address 0xe4f testing: random write/read operations
    #Address 0xe4f Write value 0x65bbe7f5
    li x3, 0x65bbe7f5
    csrw 0xe4f, x3

    #Address 0xe4f Write value 0xbb88d3e4
    li x3, 0xbb88d3e4
    csrw 0xe4f, x3

    #Address 0xe4f read value
    csrr x14, 0xe4f

    #Unmapped address 0xc9a testing: random write/read operations
    #Address 0xc9a Write value 0x13a222df
    li x3, 0x13a222df
    csrw 0xc9a, x3

    #Address 0xc9a read value
    csrr x14, 0xc9a

    #Address 0xc9a Write value 0x40ac67a3
    li x3, 0x40ac67a3
    csrw 0xc9a, x3

    #Address 0xc9a read value
    csrr x14, 0xc9a

    #Unmapped address 0x839 testing: random write/read operations
    #Address 0x839 read value
    csrr x14, 0x839

    #Address 0x839 read value
    csrr x14, 0x839

    #Address 0x839 read value
    csrr x14, 0x839

    #Address 0x839 read value
    csrr x14, 0x839

    #Address 0x839 Write value 0x5a5e98b3
    li x3, 0x5a5e98b3
    csrw 0x839, x3

    #Unmapped address 0xea2 testing: random write/read operations
    #Address 0xea2 Write value 0x612c4095
    li x3, 0x612c4095
    csrw 0xea2, x3

    #Address 0xea2 Write value 0xdc457415
    li x3, 0xdc457415
    csrw 0xea2, x3

    #Address 0xea2 read value
    csrr x14, 0xea2

    #Address 0xea2 read value
    csrr x14, 0xea2

    #Address 0xea2 Write value 0xff556a36
    li x3, 0xff556a36
    csrw 0xea2, x3

    #Unmapped address 0xcf8 testing: random write/read operations
    #Address 0xcf8 read value
    csrr x14, 0xcf8

    #Unmapped address 0x2dd testing: random write/read operations
    #Address 0x2dd Write value 0x198dd7cd
    li x3, 0x198dd7cd
    csrw 0x2dd, x3

    #Unmapped address 0xd18 testing: random write/read operations
    #Address 0xd18 read value
    csrr x14, 0xd18

    #Address 0xd18 Write value 0xa74a2315
    li x3, 0xa74a2315
    csrw 0xd18, x3

    #Mapped address 0xb1b (mhpmcounter27) testing: random write/read operations
    #Address 0xb1b read value
    csrr x14, 0xb1b

    #Unmapped address 0x8ce testing: random write/read operations
    #Address 0x8ce read value
    csrr x14, 0x8ce

    #Address 0x8ce read value
    csrr x14, 0x8ce

    #Address 0x8ce Write value 0x170a743
    li x3, 0x170a743
    csrw 0x8ce, x3

    #Address 0x8ce read value
    csrr x14, 0x8ce

    #Address 0x8ce read value
    csrr x14, 0x8ce

    #Unmapped address 0x122 testing: random write/read operations
    #Address 0x122 read value
    csrr x14, 0x122

    #Address 0x122 Write value 0xcbc08492
    li x3, 0xcbc08492
    csrw 0x122, x3

    #Address 0x122 Write value 0xf511efc3
    li x3, 0xf511efc3
    csrw 0x122, x3

    #Unmapped address 0xa37 testing: random write/read operations
    #Address 0xa37 read value
    csrr x14, 0xa37

    #Address 0xa37 Write value 0xbf8adfc4
    li x3, 0xbf8adfc4
    csrw 0xa37, x3

    #Address 0xa37 read value
    csrr x14, 0xa37

    #Address 0xa37 read value
    csrr x14, 0xa37

    #Unmapped address 0xf3d testing: random write/read operations
    #Address 0xf3d Write value 0x54aa1082
    li x3, 0x54aa1082
    csrw 0xf3d, x3

    #Address 0xf3d Write value 0x1fbb88bf
    li x3, 0x1fbb88bf
    csrw 0xf3d, x3

    #Unmapped address 0x9fc testing: random write/read operations
    #Address 0x9fc read value
    csrr x14, 0x9fc

    #Unmapped address 0x941 testing: random write/read operations
    #Address 0x941 Write value 0x952a138e
    li x3, 0x952a138e
    csrw 0x941, x3

    #Address 0x941 Write value 0x803602cc
    li x3, 0x803602cc
    csrw 0x941, x3

    #Address 0x941 Write value 0x7ff5317b
    li x3, 0x7ff5317b
    csrw 0x941, x3

    #Address 0x941 Write value 0x4d1f5f46
    li x3, 0x4d1f5f46
    csrw 0x941, x3

    #Address 0x941 read value
    csrr x14, 0x941

    #Unmapped address 0xd2a testing: random write/read operations
    #Address 0xd2a read value
    csrr x14, 0xd2a

    #Address 0xd2a Write value 0x8e12573d
    li x3, 0x8e12573d
    csrw 0xd2a, x3

    #Unmapped address 0x53c testing: random write/read operations
    #Address 0x53c Write value 0xf6004b45
    li x3, 0xf6004b45
    csrw 0x53c, x3

    #Address 0x53c read value
    csrr x14, 0x53c

    #Unmapped address 0x911 testing: random write/read operations
    #Address 0x911 read value
    csrr x14, 0x911

    #Address 0x911 read value
    csrr x14, 0x911

    #Address 0x911 Write value 0xe2271500
    li x3, 0xe2271500
    csrw 0x911, x3

    #Address 0x911 read value
    csrr x14, 0x911

    #Address 0x911 read value
    csrr x14, 0x911

    #Unmapped address 0x43c testing: random write/read operations
    #Address 0x43c read value
    csrr x14, 0x43c

    #Unmapped address 0xb38 testing: random write/read operations
    #Address 0xb38 Write value 0x4ce897fb
    li x3, 0x4ce897fb
    csrw 0xb38, x3

    #Address 0xb38 read value
    csrr x14, 0xb38

    #Unmapped address 0x3dc testing: random write/read operations
    #Address 0x3dc Write value 0xa78884ee
    li x3, 0xa78884ee
    csrw 0x3dc, x3

    #Unmapped address 0xd6f testing: random write/read operations
    #Address 0xd6f read value
    csrr x14, 0xd6f

    #Address 0xd6f Write value 0xe2714afe
    li x3, 0xe2714afe
    csrw 0xd6f, x3

    #Address 0xd6f Write value 0xad00d0fd
    li x3, 0xad00d0fd
    csrw 0xd6f, x3

    #Address 0xd6f read value
    csrr x14, 0xd6f

    #Address 0xd6f read value
    csrr x14, 0xd6f

    #Unmapped address 0x554 testing: random write/read operations
    #Address 0x554 Write value 0x4b3bfba7
    li x3, 0x4b3bfba7
    csrw 0x554, x3

    #Unmapped address 0x44e testing: random write/read operations
    #Address 0x44e Write value 0x80d9cab1
    li x3, 0x80d9cab1
    csrw 0x44e, x3

    #Address 0x44e read value
    csrr x14, 0x44e

    #Address 0x44e Write value 0x4a8f005d
    li x3, 0x4a8f005d
    csrw 0x44e, x3

    #Unmapped address 0x252 testing: random write/read operations
    #Address 0x252 Write value 0x304c3b44
    li x3, 0x304c3b44
    csrw 0x252, x3

    #Address 0x252 read value
    csrr x14, 0x252

    #Address 0x252 Write value 0x96448cb5
    li x3, 0x96448cb5
    csrw 0x252, x3

    #Address 0x252 read value
    csrr x14, 0x252

    #Address 0x252 read value
    csrr x14, 0x252

    #Unmapped address 0x146 testing: random write/read operations
    #Address 0x146 Write value 0x879f12ea
    li x3, 0x879f12ea
    csrw 0x146, x3

    #Address 0x146 read value
    csrr x14, 0x146

    #Address 0x146 read value
    csrr x14, 0x146

    #Address 0x146 read value
    csrr x14, 0x146

    #Address 0x146 Write value 0x6c5b3b7f
    li x3, 0x6c5b3b7f
    csrw 0x146, x3

    #Unmapped address 0x95d testing: random write/read operations
    #Address 0x95d read value
    csrr x14, 0x95d

    #Address 0x95d read value
    csrr x14, 0x95d

    #Unmapped address 0xecc testing: random write/read operations
    #Address 0xecc Write value 0xe9a05a80
    li x3, 0xe9a05a80
    csrw 0xecc, x3

    #Address 0xecc read value
    csrr x14, 0xecc

    #Address 0xecc Write value 0x5bbb943c
    li x3, 0x5bbb943c
    csrw 0xecc, x3

    #Unmapped address 0x67c testing: random write/read operations
    #Address 0x67c Write value 0x1a8564b1
    li x3, 0x1a8564b1
    csrw 0x67c, x3

    #Address 0x67c read value
    csrr x14, 0x67c

    #Unmapped address 0xbee testing: random write/read operations
    #Address 0xbee Write value 0xfc6ae24e
    li x3, 0xfc6ae24e
    csrw 0xbee, x3

    #Address 0xbee Write value 0xb69cc8a5
    li x3, 0xb69cc8a5
    csrw 0xbee, x3

    #Unmapped address 0xec1 testing: random write/read operations
    #Address 0xec1 Write value 0xa666ba9d
    li x3, 0xa666ba9d
    csrw 0xec1, x3

    #Address 0xec1 read value
    csrr x14, 0xec1

    #Address 0xec1 read value
    csrr x14, 0xec1

    #Address 0xec1 read value
    csrr x14, 0xec1

    #Address 0xec1 read value
    csrr x14, 0xec1

    #Unmapped address 0xe53 testing: random write/read operations
    #Address 0xe53 Write value 0x8aa98805
    li x3, 0x8aa98805
    csrw 0xe53, x3

    #Address 0xe53 Write value 0xd5d975df
    li x3, 0xd5d975df
    csrw 0xe53, x3

    #Address 0xe53 Write value 0xedbd360e
    li x3, 0xedbd360e
    csrw 0xe53, x3

    #Address 0xe53 read value
    csrr x14, 0xe53

    #Unmapped address 0x2f5 testing: random write/read operations
    #Address 0x2f5 read value
    csrr x14, 0x2f5

    #Address 0x2f5 read value
    csrr x14, 0x2f5

    #Unmapped address 0xbf1 testing: random write/read operations
    #Address 0xbf1 Write value 0x2e70395a
    li x3, 0x2e70395a
    csrw 0xbf1, x3

    #Address 0xbf1 Write value 0x66db1448
    li x3, 0x66db1448
    csrw 0xbf1, x3

    #Address 0xbf1 read value
    csrr x14, 0xbf1

    #Unmapped address 0xa3d testing: random write/read operations
    #Address 0xa3d Write value 0x8393f61a
    li x3, 0x8393f61a
    csrw 0xa3d, x3

    #Unmapped address 0x3a testing: random write/read operations
    #Address 0x3a Write value 0xfd3c93e1
    li x3, 0xfd3c93e1
    csrw 0x3a, x3

    #Address 0x3a read value
    csrr x14, 0x3a

    #Address 0x3a read value
    csrr x14, 0x3a

    #Address 0x3a read value
    csrr x14, 0x3a

    #Address 0x3a Write value 0xc875fe4b
    li x3, 0xc875fe4b
    csrw 0x3a, x3

    #Unmapped address 0x92f testing: random write/read operations
    #Address 0x92f Write value 0xc8c9b66b
    li x3, 0xc8c9b66b
    csrw 0x92f, x3

    #Address 0x92f Write value 0xfe208f00
    li x3, 0xfe208f00
    csrw 0x92f, x3

    #Address 0x92f Write value 0x3a3f1b73
    li x3, 0x3a3f1b73
    csrw 0x92f, x3

    #Unmapped address 0x3cc testing: random write/read operations
    #Address 0x3cc read value
    csrr x14, 0x3cc

    #Address 0x3cc read value
    csrr x14, 0x3cc

    #Address 0x3cc Write value 0x62507b6
    li x3, 0x62507b6
    csrw 0x3cc, x3

    #Address 0x3cc read value
    csrr x14, 0x3cc

    #Unmapped address 0x21e testing: random write/read operations
    #Address 0x21e read value
    csrr x14, 0x21e

    #Unmapped address 0x4f1 testing: random write/read operations
    #Address 0x4f1 Write value 0x8cad8b61
    li x3, 0x8cad8b61
    csrw 0x4f1, x3

    #Unmapped address 0xe1e testing: random write/read operations
    #Address 0xe1e read value
    csrr x14, 0xe1e

    #Address 0xe1e Write value 0x4e2c8430
    li x3, 0x4e2c8430
    csrw 0xe1e, x3

    #Address 0xe1e read value
    csrr x14, 0xe1e

    #Address 0xe1e Write value 0x298df865
    li x3, 0x298df865
    csrw 0xe1e, x3

    #Address 0xe1e Write value 0xe7c3c13c
    li x3, 0xe7c3c13c
    csrw 0xe1e, x3

    #Unmapped address 0x3d0 testing: random write/read operations
    #Address 0x3d0 read value
    csrr x14, 0x3d0

    #Address 0x3d0 read value
    csrr x14, 0x3d0

    #Unmapped address 0xeae testing: random write/read operations
    #Address 0xeae read value
    csrr x14, 0xeae

    #Address 0xeae read value
    csrr x14, 0xeae

    #Address 0xeae Write value 0x1c6cd2c9
    li x3, 0x1c6cd2c9
    csrw 0xeae, x3

    #Address 0xeae read value
    csrr x14, 0xeae

    #Unmapped address 0xf0 testing: random write/read operations
    #Address 0xf0 Write value 0x160e8acc
    li x3, 0x160e8acc
    csrw 0xf0, x3

    #Address 0xf0 Write value 0xf2640a1c
    li x3, 0xf2640a1c
    csrw 0xf0, x3

    #Unmapped address 0xe8a testing: random write/read operations
    #Address 0xe8a Write value 0x9ec613f0
    li x3, 0x9ec613f0
    csrw 0xe8a, x3

    #Address 0xe8a Write value 0xdf4351ba
    li x3, 0xdf4351ba
    csrw 0xe8a, x3

    #Address 0xe8a Write value 0x1c061cc6
    li x3, 0x1c061cc6
    csrw 0xe8a, x3

    #Address 0xe8a Write value 0x30f0db0d
    li x3, 0x30f0db0d
    csrw 0xe8a, x3

    #Mapped address 0x3ba (pmpaddr10) testing: random write/read operations
    #Address 0x3ba read value
    csrr x14, 0x3ba

    #Address 0x3ba Write value 0x11c1a2fe
    li x3, 0x11c1a2fe
    csrw 0x3ba, x3

    #Address 0x3ba Write value 0x5cf22171
    li x3, 0x5cf22171
    csrw 0x3ba, x3

    #Unmapped address 0xa6c testing: random write/read operations
    #Address 0xa6c Write value 0x82557a69
    li x3, 0x82557a69
    csrw 0xa6c, x3

    #Unmapped address 0x26 testing: random write/read operations
    #Address 0x26 read value
    csrr x14, 0x26

    #Unmapped address 0x938 testing: random write/read operations
    #Address 0x938 Write value 0x43b2d799
    li x3, 0x43b2d799
    csrw 0x938, x3

    #Address 0x938 read value
    csrr x14, 0x938

    #Address 0x938 read value
    csrr x14, 0x938

    #Address 0x938 read value
    csrr x14, 0x938

    #Address 0x938 Write value 0x224fac4d
    li x3, 0x224fac4d
    csrw 0x938, x3

    #Unmapped address 0x642 testing: random write/read operations
    #Address 0x642 Write value 0x749dd01f
    li x3, 0x749dd01f
    csrw 0x642, x3

    #Address 0x642 read value
    csrr x14, 0x642

    #Address 0x642 read value
    csrr x14, 0x642

    #Address 0x642 Write value 0x5632e92a
    li x3, 0x5632e92a
    csrw 0x642, x3

    #Unmapped address 0x518 testing: random write/read operations
    #Address 0x518 Write value 0x855cea46
    li x3, 0x855cea46
    csrw 0x518, x3

    #Address 0x518 read value
    csrr x14, 0x518

    #Address 0x518 Write value 0x8237b14c
    li x3, 0x8237b14c
    csrw 0x518, x3

    #Unmapped address 0x730 testing: random write/read operations
    #Address 0x730 read value
    csrr x14, 0x730

    #Unmapped address 0x74d testing: random write/read operations
    #Address 0x74d Write value 0xcb6b8807
    li x3, 0xcb6b8807
    csrw 0x74d, x3

    #Address 0x74d read value
    csrr x14, 0x74d

    #Address 0x74d read value
    csrr x14, 0x74d

    #Address 0x74d read value
    csrr x14, 0x74d

    #Address 0x74d read value
    csrr x14, 0x74d

    #Unmapped address 0xe5e testing: random write/read operations
    #Address 0xe5e read value
    csrr x14, 0xe5e

    #Unmapped address 0xf0d testing: random write/read operations
    #Address 0xf0d Write value 0x19998de3
    li x3, 0x19998de3
    csrw 0xf0d, x3

    #Address 0xf0d Write value 0xd889e15c
    li x3, 0xd889e15c
    csrw 0xf0d, x3

    #Address 0xf0d read value
    csrr x14, 0xf0d

    #Address 0xf0d read value
    csrr x14, 0xf0d

    #Unmapped address 0xc5b testing: random write/read operations
    #Address 0xc5b Write value 0x1a9f1171
    li x3, 0x1a9f1171
    csrw 0xc5b, x3

    #Address 0xc5b read value
    csrr x14, 0xc5b

    #Address 0xc5b Write value 0xb4baaa09
    li x3, 0xb4baaa09
    csrw 0xc5b, x3

    #Address 0xc5b Write value 0x553e49a5
    li x3, 0x553e49a5
    csrw 0xc5b, x3

    #Address 0xc5b read value
    csrr x14, 0xc5b

    #Unmapped address 0xbe7 testing: random write/read operations
    #Address 0xbe7 read value
    csrr x14, 0xbe7

    #Address 0xbe7 Write value 0xfc7c11c1
    li x3, 0xfc7c11c1
    csrw 0xbe7, x3

    #Address 0xbe7 read value
    csrr x14, 0xbe7

    #Address 0xbe7 read value
    csrr x14, 0xbe7

    #Address 0xbe7 Write value 0x32c08123
    li x3, 0x32c08123
    csrw 0xbe7, x3

    #Unmapped address 0x5f2 testing: random write/read operations
    #Address 0x5f2 read value
    csrr x14, 0x5f2

    #Address 0x5f2 read value
    csrr x14, 0x5f2

    #Address 0x5f2 Write value 0x4d13d940
    li x3, 0x4d13d940
    csrw 0x5f2, x3

    #Address 0x5f2 Write value 0x31b129de
    li x3, 0x31b129de
    csrw 0x5f2, x3

    #Address 0x5f2 Write value 0x9db3e74e
    li x3, 0x9db3e74e
    csrw 0x5f2, x3

    #Unmapped address 0xe8b testing: random write/read operations
    #Address 0xe8b Write value 0x3118e80e
    li x3, 0x3118e80e
    csrw 0xe8b, x3

    #Address 0xe8b Write value 0xff664f7d
    li x3, 0xff664f7d
    csrw 0xe8b, x3

    #Address 0xe8b Write value 0xfad390fb
    li x3, 0xfad390fb
    csrw 0xe8b, x3

    #Address 0xe8b read value
    csrr x14, 0xe8b

    #Address 0xe8b Write value 0x78ea3c0b
    li x3, 0x78ea3c0b
    csrw 0xe8b, x3

    #Unmapped address 0x10b testing: random write/read operations
    #Address 0x10b Write value 0x6168864e
    li x3, 0x6168864e
    csrw 0x10b, x3

    #Address 0x10b read value
    csrr x14, 0x10b

    #Address 0x10b read value
    csrr x14, 0x10b

    #Address 0x10b Write value 0xa543f2cf
    li x3, 0xa543f2cf
    csrw 0x10b, x3

    #Unmapped address 0x4f0 testing: random write/read operations
    #Address 0x4f0 read value
    csrr x14, 0x4f0

    #Address 0x4f0 Write value 0x1e8622e9
    li x3, 0x1e8622e9
    csrw 0x4f0, x3

    #Address 0x4f0 read value
    csrr x14, 0x4f0

    #Unmapped address 0x2fa testing: random write/read operations
    #Address 0x2fa read value
    csrr x14, 0x2fa

    #Address 0x2fa read value
    csrr x14, 0x2fa

    #Unmapped address 0x1a4 testing: random write/read operations
    #Address 0x1a4 read value
    csrr x14, 0x1a4

    #Address 0x1a4 read value
    csrr x14, 0x1a4

    #Address 0x1a4 read value
    csrr x14, 0x1a4

    #Unmapped address 0x59b testing: random write/read operations
    #Address 0x59b Write value 0xdfb96bdd
    li x3, 0xdfb96bdd
    csrw 0x59b, x3

    #Address 0x59b read value
    csrr x14, 0x59b

    #Address 0x59b read value
    csrr x14, 0x59b

    #Unmapped address 0x935 testing: random write/read operations
    #Address 0x935 read value
    csrr x14, 0x935

    #Address 0x935 Write value 0x272d9d34
    li x3, 0x272d9d34
    csrw 0x935, x3

    #Address 0x935 read value
    csrr x14, 0x935

    #Address 0x935 Write value 0x81035b66
    li x3, 0x81035b66
    csrw 0x935, x3

    #Address 0x935 Write value 0x2f9b860f
    li x3, 0x2f9b860f
    csrw 0x935, x3

    #Unmapped address 0x7e9 testing: random write/read operations
    #Address 0x7e9 Write value 0xdd1a3b0a
    li x3, 0xdd1a3b0a
    csrw 0x7e9, x3

    #Address 0x7e9 read value
    csrr x14, 0x7e9

    #Address 0x7e9 read value
    csrr x14, 0x7e9

    #Address 0x7e9 read value
    csrr x14, 0x7e9

    #Address 0x7e9 Write value 0xa645b37
    li x3, 0xa645b37
    csrw 0x7e9, x3

    #Unmapped address 0xa85 testing: random write/read operations
    #Address 0xa85 read value
    csrr x14, 0xa85

    #Unmapped address 0x360 testing: random write/read operations
    #Address 0x360 Write value 0x962a2279
    li x3, 0x962a2279
    csrw 0x360, x3

    #Unmapped address 0x1c0 testing: random write/read operations
    #Address 0x1c0 Write value 0x4edcfdf8
    li x3, 0x4edcfdf8
    csrw 0x1c0, x3

    #Address 0x1c0 Write value 0x412046b5
    li x3, 0x412046b5
    csrw 0x1c0, x3

    #Unmapped address 0xce2 testing: random write/read operations
    #Address 0xce2 read value
    csrr x14, 0xce2

    #Address 0xce2 read value
    csrr x14, 0xce2

    #Unmapped address 0x79e testing: random write/read operations
    #Address 0x79e Write value 0x192adde5
    li x3, 0x192adde5
    csrw 0x79e, x3

    #Address 0x79e Write value 0x93f1586
    li x3, 0x93f1586
    csrw 0x79e, x3

    #Unmapped address 0xac9 testing: random write/read operations
    #Address 0xac9 Write value 0xa1ac833a
    li x3, 0xa1ac833a
    csrw 0xac9, x3

    #Address 0xac9 Write value 0xfeff2d20
    li x3, 0xfeff2d20
    csrw 0xac9, x3

    #Address 0xac9 read value
    csrr x14, 0xac9

    #Address 0xac9 read value
    csrr x14, 0xac9

    #Unmapped address 0x3e9 testing: random write/read operations
    #Address 0x3e9 Write value 0x3be0fed3
    li x3, 0x3be0fed3
    csrw 0x3e9, x3

    #Address 0x3e9 read value
    csrr x14, 0x3e9

    #Unmapped address 0x573 testing: random write/read operations
    #Address 0x573 Write value 0x7812e353
    li x3, 0x7812e353
    csrw 0x573, x3

    #Address 0x573 read value
    csrr x14, 0x573

    #Unmapped address 0x70d testing: random write/read operations
    #Address 0x70d Write value 0xb86eac10
    li x3, 0xb86eac10
    csrw 0x70d, x3

    #Address 0x70d Write value 0x86aa2fd7
    li x3, 0x86aa2fd7
    csrw 0x70d, x3

    #Address 0x70d read value
    csrr x14, 0x70d

    #Unmapped address 0x207 testing: random write/read operations
    #Address 0x207 read value
    csrr x14, 0x207

    #Address 0x207 read value
    csrr x14, 0x207

    #Address 0x207 read value
    csrr x14, 0x207

    #Unmapped address 0x84a testing: random write/read operations
    #Address 0x84a Write value 0xdff11d50
    li x3, 0xdff11d50
    csrw 0x84a, x3

    #Address 0x84a Write value 0xde5f93af
    li x3, 0xde5f93af
    csrw 0x84a, x3

    #Unmapped address 0xf1f testing: random write/read operations
    #Address 0xf1f Write value 0x98bde428
    li x3, 0x98bde428
    csrw 0xf1f, x3

    #Unmapped address 0xbba testing: random write/read operations
    #Address 0xbba read value
    csrr x14, 0xbba

    #Unmapped address 0xa87 testing: random write/read operations
    #Address 0xa87 read value
    csrr x14, 0xa87

    #Address 0xa87 read value
    csrr x14, 0xa87

    #Address 0xa87 Write value 0xe66583d6
    li x3, 0xe66583d6
    csrw 0xa87, x3

    #Address 0xa87 Write value 0xf2c61a77
    li x3, 0xf2c61a77
    csrw 0xa87, x3

    #Unmapped address 0x103 testing: random write/read operations
    #Address 0x103 Write value 0x820eb25d
    li x3, 0x820eb25d
    csrw 0x103, x3

    #Address 0x103 Write value 0x346dacdd
    li x3, 0x346dacdd
    csrw 0x103, x3

    #Address 0x103 read value
    csrr x14, 0x103

    #Address 0x103 Write value 0x8f65e1f8
    li x3, 0x8f65e1f8
    csrw 0x103, x3

    #Address 0x103 Write value 0xc0ee7733
    li x3, 0xc0ee7733
    csrw 0x103, x3

    #Unmapped address 0x4a9 testing: random write/read operations
    #Address 0x4a9 read value
    csrr x14, 0x4a9

    #Address 0x4a9 read value
    csrr x14, 0x4a9

    #Address 0x4a9 read value
    csrr x14, 0x4a9

    #Unmapped address 0x27 testing: random write/read operations
    #Address 0x27 Write value 0x2e987c81
    li x3, 0x2e987c81
    csrw 0x27, x3

    #Address 0x27 read value
    csrr x14, 0x27

    #Address 0x27 read value
    csrr x14, 0x27

    #Address 0x27 read value
    csrr x14, 0x27

    #Address 0x27 Write value 0xa65b3c4f
    li x3, 0xa65b3c4f
    csrw 0x27, x3

    #Unmapped address 0xd49 testing: random write/read operations
    #Address 0xd49 Write value 0xe7cf1ac8
    li x3, 0xe7cf1ac8
    csrw 0xd49, x3

    #Address 0xd49 read value
    csrr x14, 0xd49

    #Address 0xd49 Write value 0x8e53060a
    li x3, 0x8e53060a
    csrw 0xd49, x3

    #Address 0xd49 Write value 0xcf4f92e4
    li x3, 0xcf4f92e4
    csrw 0xd49, x3

    #Address 0xd49 read value
    csrr x14, 0xd49

    #Unmapped address 0xaae testing: random write/read operations
    #Address 0xaae Write value 0x2c19de11
    li x3, 0x2c19de11
    csrw 0xaae, x3

    #Unmapped address 0x70e testing: random write/read operations
    #Address 0x70e Write value 0xddfe03de
    li x3, 0xddfe03de
    csrw 0x70e, x3

    #Address 0x70e read value
    csrr x14, 0x70e

    #Unmapped address 0xbaa testing: random write/read operations
    #Address 0xbaa Write value 0x9b4e9c90
    li x3, 0x9b4e9c90
    csrw 0xbaa, x3

    #Address 0xbaa Write value 0x6b496956
    li x3, 0x6b496956
    csrw 0xbaa, x3

    #Address 0xbaa read value
    csrr x14, 0xbaa

    #Unmapped address 0x76c testing: random write/read operations
    #Address 0x76c read value
    csrr x14, 0x76c

    #Address 0x76c read value
    csrr x14, 0x76c

    #Address 0x76c read value
    csrr x14, 0x76c

    #Unmapped address 0x1c6 testing: random write/read operations
    #Address 0x1c6 Write value 0xe5c471a7
    li x3, 0xe5c471a7
    csrw 0x1c6, x3

    #Unmapped address 0xee1 testing: random write/read operations
    #Address 0xee1 Write value 0x7beda0e
    li x3, 0x7beda0e
    csrw 0xee1, x3

    #Address 0xee1 read value
    csrr x14, 0xee1

    #Address 0xee1 Write value 0x1610a8b0
    li x3, 0x1610a8b0
    csrw 0xee1, x3

    #Address 0xee1 Write value 0x68cf0c65
    li x3, 0x68cf0c65
    csrw 0xee1, x3

    #Address 0xee1 read value
    csrr x14, 0xee1

    #Unmapped address 0xf98 testing: random write/read operations
    #Address 0xf98 Write value 0xe1fce862
    li x3, 0xe1fce862
    csrw 0xf98, x3

    #Address 0xf98 read value
    csrr x14, 0xf98

    #Address 0xf98 read value
    csrr x14, 0xf98

    #Address 0xf98 read value
    csrr x14, 0xf98

    #Address 0xf98 read value
    csrr x14, 0xf98

    #Unmapped address 0x951 testing: random write/read operations
    #Address 0x951 read value
    csrr x14, 0x951

    #Unmapped address 0x279 testing: random write/read operations
    #Address 0x279 read value
    csrr x14, 0x279

    #Address 0x279 Write value 0x9a8a5552
    li x3, 0x9a8a5552
    csrw 0x279, x3

    #Address 0x279 read value
    csrr x14, 0x279

    #Address 0x279 Write value 0x3c3eada0
    li x3, 0x3c3eada0
    csrw 0x279, x3

    #Address 0x279 read value
    csrr x14, 0x279

    #Unmapped address 0xea0 testing: random write/read operations
    #Address 0xea0 read value
    csrr x14, 0xea0

    #Address 0xea0 Write value 0xeedfb96b
    li x3, 0xeedfb96b
    csrw 0xea0, x3

    #Address 0xea0 Write value 0xd1dddc00
    li x3, 0xd1dddc00
    csrw 0xea0, x3

    #Address 0xea0 Write value 0x66af3041
    li x3, 0x66af3041
    csrw 0xea0, x3

    #Address 0xea0 Write value 0x61e376d
    li x3, 0x61e376d
    csrw 0xea0, x3

    #Unmapped address 0xcc5 testing: random write/read operations
    #Address 0xcc5 Write value 0x7760f7d3
    li x3, 0x7760f7d3
    csrw 0xcc5, x3

    #Address 0xcc5 Write value 0x9cce87c0
    li x3, 0x9cce87c0
    csrw 0xcc5, x3

    #Address 0xcc5 read value
    csrr x14, 0xcc5

    #Address 0xcc5 read value
    csrr x14, 0xcc5

    #Address 0xcc5 read value
    csrr x14, 0xcc5

    #Unmapped address 0x5d5 testing: random write/read operations
    #Address 0x5d5 Write value 0x1b06cbb0
    li x3, 0x1b06cbb0
    csrw 0x5d5, x3

    #Address 0x5d5 read value
    csrr x14, 0x5d5

    #Unmapped address 0x8a1 testing: random write/read operations
    #Address 0x8a1 read value
    csrr x14, 0x8a1

    #Address 0x8a1 Write value 0x2159a909
    li x3, 0x2159a909
    csrw 0x8a1, x3

    #Address 0x8a1 read value
    csrr x14, 0x8a1

    #Unmapped address 0xa26 testing: random write/read operations
    #Address 0xa26 Write value 0x1d961d94
    li x3, 0x1d961d94
    csrw 0xa26, x3

    #Address 0xa26 read value
    csrr x14, 0xa26

    #Unmapped address 0x7ec testing: random write/read operations
    #Address 0x7ec Write value 0x5950c4cd
    li x3, 0x5950c4cd
    csrw 0x7ec, x3

    #Address 0x7ec read value
    csrr x14, 0x7ec

    #Address 0x7ec read value
    csrr x14, 0x7ec

    #Unmapped address 0x23e testing: random write/read operations
    #Address 0x23e Write value 0xfe83104
    li x3, 0xfe83104
    csrw 0x23e, x3

    #Unmapped address 0x558 testing: random write/read operations
    #Address 0x558 Write value 0x5e2c2762
    li x3, 0x5e2c2762
    csrw 0x558, x3

    #Unmapped address 0x224 testing: random write/read operations
    #Address 0x224 Write value 0xb69679fe
    li x3, 0xb69679fe
    csrw 0x224, x3

    #Unmapped address 0x3df testing: random write/read operations
    #Address 0x3df read value
    csrr x14, 0x3df

    #Address 0x3df read value
    csrr x14, 0x3df

    #Address 0x3df Write value 0x3a13de7b
    li x3, 0x3a13de7b
    csrw 0x3df, x3

    #Address 0x3df Write value 0x1ad04b08
    li x3, 0x1ad04b08
    csrw 0x3df, x3

    #Unmapped address 0x62a testing: random write/read operations
    #Address 0x62a Write value 0xd8508345
    li x3, 0xd8508345
    csrw 0x62a, x3

    #Address 0x62a read value
    csrr x14, 0x62a

    #Unmapped address 0x848 testing: random write/read operations
    #Address 0x848 read value
    csrr x14, 0x848

    #Address 0x848 Write value 0x5e5e80cf
    li x3, 0x5e5e80cf
    csrw 0x848, x3

    #Unmapped address 0x6e8 testing: random write/read operations
    #Address 0x6e8 read value
    csrr x14, 0x6e8

    #Address 0x6e8 read value
    csrr x14, 0x6e8

    #Address 0x6e8 read value
    csrr x14, 0x6e8

    #Unmapped address 0x1eb testing: random write/read operations
    #Address 0x1eb read value
    csrr x14, 0x1eb

    #Address 0x1eb read value
    csrr x14, 0x1eb

    #Address 0x1eb Write value 0x58716458
    li x3, 0x58716458
    csrw 0x1eb, x3

    #Address 0x1eb read value
    csrr x14, 0x1eb

    #Unmapped address 0x9d0 testing: random write/read operations
    #Address 0x9d0 read value
    csrr x14, 0x9d0

    #Address 0x9d0 Write value 0x4622f1b6
    li x3, 0x4622f1b6
    csrw 0x9d0, x3

    #Address 0x9d0 read value
    csrr x14, 0x9d0

    #Unmapped address 0xfc3 testing: random write/read operations
    #Address 0xfc3 Write value 0x3d217724
    li x3, 0x3d217724
    csrw 0xfc3, x3

    #Address 0xfc3 Write value 0xdbb64ad5
    li x3, 0xdbb64ad5
    csrw 0xfc3, x3

    #Address 0xfc3 Write value 0x3d0c03c1
    li x3, 0x3d0c03c1
    csrw 0xfc3, x3

    #Address 0xfc3 read value
    csrr x14, 0xfc3

    #Address 0xfc3 read value
    csrr x14, 0xfc3

    #Unmapped address 0x845 testing: random write/read operations
    #Address 0x845 read value
    csrr x14, 0x845

    #Address 0x845 Write value 0x97b25e07
    li x3, 0x97b25e07
    csrw 0x845, x3

    #Address 0x845 read value
    csrr x14, 0x845

    #Address 0x845 read value
    csrr x14, 0x845

    #Address 0x845 Write value 0x9927240e
    li x3, 0x9927240e
    csrw 0x845, x3

    #Unmapped address 0xcbe testing: random write/read operations
    #Address 0xcbe read value
    csrr x14, 0xcbe

    #Address 0xcbe read value
    csrr x14, 0xcbe

    #Address 0xcbe Write value 0xcd692e11
    li x3, 0xcd692e11
    csrw 0xcbe, x3

    #Address 0xcbe Write value 0x6f0b46e1
    li x3, 0x6f0b46e1
    csrw 0xcbe, x3

    #Address 0xcbe Write value 0xd5e26019
    li x3, 0xd5e26019
    csrw 0xcbe, x3

    #Unmapped address 0x725 testing: random write/read operations
    #Address 0x725 read value
    csrr x14, 0x725

    #Unmapped address 0x4ea testing: random write/read operations
    #Address 0x4ea Write value 0x67587ba5
    li x3, 0x67587ba5
    csrw 0x4ea, x3

    #Address 0x4ea Write value 0xb9f9a84
    li x3, 0xb9f9a84
    csrw 0x4ea, x3

    #Address 0x4ea Write value 0xc915514f
    li x3, 0xc915514f
    csrw 0x4ea, x3

    #Address 0x4ea read value
    csrr x14, 0x4ea

    #Address 0x4ea read value
    csrr x14, 0x4ea

    #Unmapped address 0xaf1 testing: random write/read operations
    #Address 0xaf1 read value
    csrr x14, 0xaf1

    #Address 0xaf1 read value
    csrr x14, 0xaf1

    #Address 0xaf1 read value
    csrr x14, 0xaf1

    #Unmapped address 0x3f2 testing: random write/read operations
    #Address 0x3f2 read value
    csrr x14, 0x3f2

    #Unmapped address 0x2c6 testing: random write/read operations
    #Address 0x2c6 read value
    csrr x14, 0x2c6

    #Address 0x2c6 read value
    csrr x14, 0x2c6

    #Address 0x2c6 read value
    csrr x14, 0x2c6

    #Address 0x2c6 Write value 0xb15fb75a
    li x3, 0xb15fb75a
    csrw 0x2c6, x3

    #Address 0x2c6 Write value 0x3120c609
    li x3, 0x3120c609
    csrw 0x2c6, x3

    #Unmapped address 0xc1b testing: random write/read operations
    #Address 0xc1b Write value 0x2aa4b3c7
    li x3, 0x2aa4b3c7
    csrw 0xc1b, x3

    #Address 0xc1b Write value 0xeffccfae
    li x3, 0xeffccfae
    csrw 0xc1b, x3

    #Address 0xc1b read value
    csrr x14, 0xc1b

    #Address 0xc1b read value
    csrr x14, 0xc1b

    #Address 0xc1b Write value 0x294fad7e
    li x3, 0x294fad7e
    csrw 0xc1b, x3

    #Unmapped address 0x4c7 testing: random write/read operations
    #Address 0x4c7 read value
    csrr x14, 0x4c7

    #Unmapped address 0xd45 testing: random write/read operations
    #Address 0xd45 Write value 0x59194ce5
    li x3, 0x59194ce5
    csrw 0xd45, x3

    #Unmapped address 0x636 testing: random write/read operations
    #Address 0x636 read value
    csrr x14, 0x636

    #Address 0x636 Write value 0x25fd32c8
    li x3, 0x25fd32c8
    csrw 0x636, x3

    #Unmapped address 0x6a2 testing: random write/read operations
    #Address 0x6a2 read value
    csrr x14, 0x6a2

    #Address 0x6a2 read value
    csrr x14, 0x6a2

    #Address 0x6a2 read value
    csrr x14, 0x6a2

    #Address 0x6a2 Write value 0xf1d7a836
    li x3, 0xf1d7a836
    csrw 0x6a2, x3

    #Address 0x6a2 Write value 0x725604c4
    li x3, 0x725604c4
    csrw 0x6a2, x3

    #Unmapped address 0x714 testing: random write/read operations
    #Address 0x714 Write value 0x35125213
    li x3, 0x35125213
    csrw 0x714, x3

    #Address 0x714 Write value 0x9e0a5829
    li x3, 0x9e0a5829
    csrw 0x714, x3

    #Address 0x714 read value
    csrr x14, 0x714

    #Address 0x714 read value
    csrr x14, 0x714

    #Address 0x714 Write value 0x365eb314
    li x3, 0x365eb314
    csrw 0x714, x3

    #Unmapped address 0xf2 testing: random write/read operations
    #Address 0xf2 Write value 0x7bda3548
    li x3, 0x7bda3548
    csrw 0xf2, x3

    #Unmapped address 0x3a6 testing: random write/read operations
    #Address 0x3a6 Write value 0x7fe5c1a
    li x3, 0x7fe5c1a
    csrw 0x3a6, x3

    #Address 0x3a6 read value
    csrr x14, 0x3a6

    #Unmapped address 0xf21 testing: random write/read operations
    #Address 0xf21 Write value 0x6f5d0012
    li x3, 0x6f5d0012
    csrw 0xf21, x3

    #Unmapped address 0x347 testing: random write/read operations
    #Address 0x347 Write value 0x7dba9531
    li x3, 0x7dba9531
    csrw 0x347, x3

    #Address 0x347 Write value 0xccdfe02c
    li x3, 0xccdfe02c
    csrw 0x347, x3

    #Address 0x347 read value
    csrr x14, 0x347

    #Address 0x347 Write value 0xec04749e
    li x3, 0xec04749e
    csrw 0x347, x3

    #Address 0x347 read value
    csrr x14, 0x347

    #Unmapped address 0xf66 testing: random write/read operations
    #Address 0xf66 Write value 0x17f1b3db
    li x3, 0x17f1b3db
    csrw 0xf66, x3

    #Unmapped address 0x2c2 testing: random write/read operations
    #Address 0x2c2 read value
    csrr x14, 0x2c2

    #Address 0x2c2 read value
    csrr x14, 0x2c2

    #Address 0x2c2 read value
    csrr x14, 0x2c2

    #Address 0x2c2 read value
    csrr x14, 0x2c2

    #Unmapped address 0x736 testing: random write/read operations
    #Address 0x736 Write value 0xc6fee636
    li x3, 0xc6fee636
    csrw 0x736, x3

    #Address 0x736 Write value 0x1ecc37b2
    li x3, 0x1ecc37b2
    csrw 0x736, x3

    #Address 0x736 read value
    csrr x14, 0x736

    #Address 0x736 Write value 0xf796380
    li x3, 0xf796380
    csrw 0x736, x3

    #Address 0x736 Write value 0x66b6d567
    li x3, 0x66b6d567
    csrw 0x736, x3

    #Unmapped address 0x83c testing: random write/read operations
    #Address 0x83c Write value 0xc6576cad
    li x3, 0xc6576cad
    csrw 0x83c, x3

    #Address 0x83c Write value 0xa918023b
    li x3, 0xa918023b
    csrw 0x83c, x3

    #Unmapped address 0xbfa testing: random write/read operations
    #Address 0xbfa read value
    csrr x14, 0xbfa

    #Unmapped address 0x15e testing: random write/read operations
    #Address 0x15e Write value 0xe31d444d
    li x3, 0xe31d444d
    csrw 0x15e, x3

    #Address 0x15e read value
    csrr x14, 0x15e

    #Address 0x15e Write value 0x6051571
    li x3, 0x6051571
    csrw 0x15e, x3

    #Unmapped address 0xfa testing: random write/read operations
    #Address 0xfa read value
    csrr x14, 0xfa

    #Address 0xfa Write value 0x98401126
    li x3, 0x98401126
    csrw 0xfa, x3

    #Unmapped address 0xf5b testing: random write/read operations
    #Address 0xf5b Write value 0xc79ec617
    li x3, 0xc79ec617
    csrw 0xf5b, x3

    #Address 0xf5b Write value 0x869b9cf0
    li x3, 0x869b9cf0
    csrw 0xf5b, x3

    #Address 0xf5b Write value 0xd4d85cd7
    li x3, 0xd4d85cd7
    csrw 0xf5b, x3

    #Address 0xf5b read value
    csrr x14, 0xf5b

    #Address 0xf5b read value
    csrr x14, 0xf5b

    #Unmapped address 0xf39 testing: random write/read operations
    #Address 0xf39 read value
    csrr x14, 0xf39

    #Address 0xf39 read value
    csrr x14, 0xf39

    #Address 0xf39 Write value 0x2b1d7e1a
    li x3, 0x2b1d7e1a
    csrw 0xf39, x3

    #Address 0xf39 read value
    csrr x14, 0xf39

    #Address 0xf39 read value
    csrr x14, 0xf39

    #Unmapped address 0xa72 testing: random write/read operations
    #Address 0xa72 read value
    csrr x14, 0xa72

    #Address 0xa72 read value
    csrr x14, 0xa72

    #Unmapped address 0xe6e testing: random write/read operations
    #Address 0xe6e read value
    csrr x14, 0xe6e

    #Unmapped address 0x282 testing: random write/read operations
    #Address 0x282 read value
    csrr x14, 0x282

    #Address 0x282 Write value 0x2bd7cd1b
    li x3, 0x2bd7cd1b
    csrw 0x282, x3

    #Unmapped address 0x851 testing: random write/read operations
    #Address 0x851 read value
    csrr x14, 0x851

    #Address 0x851 Write value 0x31c3d818
    li x3, 0x31c3d818
    csrw 0x851, x3

    #Address 0x851 read value
    csrr x14, 0x851

    #Unmapped address 0xaf4 testing: random write/read operations
    #Address 0xaf4 read value
    csrr x14, 0xaf4

    #Address 0xaf4 read value
    csrr x14, 0xaf4

    #Unmapped address 0x8ff testing: random write/read operations
    #Address 0x8ff Write value 0x1c04507
    li x3, 0x1c04507
    csrw 0x8ff, x3

    #Address 0x8ff Write value 0x1260da7f
    li x3, 0x1260da7f
    csrw 0x8ff, x3

    #Unmapped address 0x787 testing: random write/read operations
    #Address 0x787 read value
    csrr x14, 0x787

    #Address 0x787 Write value 0x3f7fe3b2
    li x3, 0x3f7fe3b2
    csrw 0x787, x3

    #Address 0x787 Write value 0x2487a04f
    li x3, 0x2487a04f
    csrw 0x787, x3

    #Address 0x787 Write value 0x12d4d06a
    li x3, 0x12d4d06a
    csrw 0x787, x3

    #Unmapped address 0xde6 testing: random write/read operations
    #Address 0xde6 read value
    csrr x14, 0xde6

    #Address 0xde6 Write value 0xd3a0dc94
    li x3, 0xd3a0dc94
    csrw 0xde6, x3

    #Address 0xde6 read value
    csrr x14, 0xde6

    #Unmapped address 0x900 testing: random write/read operations
    #Address 0x900 read value
    csrr x14, 0x900

    #Unmapped address 0xfe2 testing: random write/read operations
    #Address 0xfe2 Write value 0x2493739c
    li x3, 0x2493739c
    csrw 0xfe2, x3

    #Unmapped address 0xec5 testing: random write/read operations
    #Address 0xec5 read value
    csrr x14, 0xec5

    #Unmapped address 0x9a5 testing: random write/read operations
    #Address 0x9a5 read value
    csrr x14, 0x9a5

    #Address 0x9a5 Write value 0x9939a650
    li x3, 0x9939a650
    csrw 0x9a5, x3

    #Unmapped address 0xfe6 testing: random write/read operations
    #Address 0xfe6 read value
    csrr x14, 0xfe6

    #Unmapped address 0xe3d testing: random write/read operations
    #Address 0xe3d read value
    csrr x14, 0xe3d

    #Address 0xe3d read value
    csrr x14, 0xe3d

    #Address 0xe3d Write value 0x128e9cdf
    li x3, 0x128e9cdf
    csrw 0xe3d, x3

    #Address 0xe3d read value
    csrr x14, 0xe3d

    #Unmapped address 0x436 testing: random write/read operations
    #Address 0x436 Write value 0x2fa86d8b
    li x3, 0x2fa86d8b
    csrw 0x436, x3

    #Address 0x436 Write value 0x60a8f133
    li x3, 0x60a8f133
    csrw 0x436, x3

    #Address 0x436 Write value 0x10e762ce
    li x3, 0x10e762ce
    csrw 0x436, x3

    #Address 0x436 Write value 0xb348444d
    li x3, 0xb348444d
    csrw 0x436, x3

    #Address 0x436 Write value 0x8240b931
    li x3, 0x8240b931
    csrw 0x436, x3

    #Unmapped address 0x322 testing: random write/read operations
    #Address 0x322 Write value 0x323892f8
    li x3, 0x323892f8
    csrw 0x322, x3

    #Address 0x322 read value
    csrr x14, 0x322

    #Address 0x322 read value
    csrr x14, 0x322

    #Address 0x322 Write value 0xac3bf6a
    li x3, 0xac3bf6a
    csrw 0x322, x3

    #Address 0x322 read value
    csrr x14, 0x322

    #Unmapped address 0xdfc testing: random write/read operations
    #Address 0xdfc Write value 0x264a41f1
    li x3, 0x264a41f1
    csrw 0xdfc, x3

    #Address 0xdfc Write value 0x1a67e565
    li x3, 0x1a67e565
    csrw 0xdfc, x3

    #Unmapped address 0xe54 testing: random write/read operations
    #Address 0xe54 Write value 0x58403547
    li x3, 0x58403547
    csrw 0xe54, x3

    #Address 0xe54 read value
    csrr x14, 0xe54

    #Address 0xe54 Write value 0xfda1dc83
    li x3, 0xfda1dc83
    csrw 0xe54, x3

    #Unmapped address 0x259 testing: random write/read operations
    #Address 0x259 read value
    csrr x14, 0x259

    #Address 0x259 read value
    csrr x14, 0x259

    #Unmapped address 0x384 testing: random write/read operations
    #Address 0x384 read value
    csrr x14, 0x384

    #Address 0x384 read value
    csrr x14, 0x384

    #Address 0x384 read value
    csrr x14, 0x384

    #Address 0x384 read value
    csrr x14, 0x384

    #Address 0x384 Write value 0x40c9dfbd
    li x3, 0x40c9dfbd
    csrw 0x384, x3

    #Unmapped address 0xa9b testing: random write/read operations
    #Address 0xa9b Write value 0xe18025ff
    li x3, 0xe18025ff
    csrw 0xa9b, x3

    #Address 0xa9b Write value 0xb33c9f90
    li x3, 0xb33c9f90
    csrw 0xa9b, x3

    #Address 0xa9b read value
    csrr x14, 0xa9b

    #Address 0xa9b Write value 0x7e7c8fbb
    li x3, 0x7e7c8fbb
    csrw 0xa9b, x3

    #Address 0xa9b Write value 0x2f14189a
    li x3, 0x2f14189a
    csrw 0xa9b, x3

    #Unmapped address 0x3fb testing: random write/read operations
    #Address 0x3fb read value
    csrr x14, 0x3fb

    #Address 0x3fb Write value 0x5e8a1ebf
    li x3, 0x5e8a1ebf
    csrw 0x3fb, x3

    #Address 0x3fb Write value 0xb0bf1323
    li x3, 0xb0bf1323
    csrw 0x3fb, x3

    #Address 0x3fb Write value 0xacdd1519
    li x3, 0xacdd1519
    csrw 0x3fb, x3

    #Unmapped address 0xa8e testing: random write/read operations
    #Address 0xa8e read value
    csrr x14, 0xa8e

    #Address 0xa8e Write value 0x41ecb00
    li x3, 0x41ecb00
    csrw 0xa8e, x3

    #Address 0xa8e read value
    csrr x14, 0xa8e

    #Address 0xa8e Write value 0x9cc86e83
    li x3, 0x9cc86e83
    csrw 0xa8e, x3

    #Address 0xa8e Write value 0x7a60f617
    li x3, 0x7a60f617
    csrw 0xa8e, x3

    #Unmapped address 0xedd testing: random write/read operations
    #Address 0xedd Write value 0x3205faba
    li x3, 0x3205faba
    csrw 0xedd, x3

    #Address 0xedd Write value 0xd456bc36
    li x3, 0xd456bc36
    csrw 0xedd, x3

    #Unmapped address 0xd13 testing: random write/read operations
    #Address 0xd13 Write value 0x7c5c9211
    li x3, 0x7c5c9211
    csrw 0xd13, x3

    #Unmapped address 0x37 testing: random write/read operations
    #Address 0x37 Write value 0x92803eba
    li x3, 0x92803eba
    csrw 0x37, x3

    #Address 0x37 Write value 0xaa8fd61d
    li x3, 0xaa8fd61d
    csrw 0x37, x3

    #Address 0x37 read value
    csrr x14, 0x37

    #Unmapped address 0xf04 testing: random write/read operations
    #Address 0xf04 Write value 0xc71c03ec
    li x3, 0xc71c03ec
    csrw 0xf04, x3

    #Address 0xf04 Write value 0x26d8e65d
    li x3, 0x26d8e65d
    csrw 0xf04, x3

    #Address 0xf04 read value
    csrr x14, 0xf04

    #Address 0xf04 Write value 0xe57f52bb
    li x3, 0xe57f52bb
    csrw 0xf04, x3

    #Address 0xf04 Write value 0xcd703df3
    li x3, 0xcd703df3
    csrw 0xf04, x3

    #Unmapped address 0x8b4 testing: random write/read operations
    #Address 0x8b4 read value
    csrr x14, 0x8b4

    #Address 0x8b4 read value
    csrr x14, 0x8b4

    #Unmapped address 0xa1 testing: random write/read operations
    #Address 0xa1 Write value 0xff034fb1
    li x3, 0xff034fb1
    csrw 0xa1, x3

    #Unmapped address 0xcc9 testing: random write/read operations
    #Address 0xcc9 read value
    csrr x14, 0xcc9

    #Address 0xcc9 read value
    csrr x14, 0xcc9

    #Unmapped address 0x30a testing: random write/read operations
    #Address 0x30a Write value 0xab39c809
    li x3, 0xab39c809
    csrw 0x30a, x3

    #Address 0x30a read value
    csrr x14, 0x30a

    #Unmapped address 0xb81 testing: random write/read operations
    #Address 0xb81 read value
    csrr x14, 0xb81

    #Address 0xb81 read value
    csrr x14, 0xb81

    #Unmapped address 0x520 testing: random write/read operations
    #Address 0x520 read value
    csrr x14, 0x520

    #Address 0x520 read value
    csrr x14, 0x520

    #Address 0x520 read value
    csrr x14, 0x520

    #Address 0x520 read value
    csrr x14, 0x520

    #Unmapped address 0xcf7 testing: random write/read operations
    #Address 0xcf7 Write value 0xe708241c
    li x3, 0xe708241c
    csrw 0xcf7, x3

    #Address 0xcf7 Write value 0xde45ae6b
    li x3, 0xde45ae6b
    csrw 0xcf7, x3

    #Address 0xcf7 Write value 0xb7f51957
    li x3, 0xb7f51957
    csrw 0xcf7, x3

    #Address 0xcf7 Write value 0x828471b7
    li x3, 0x828471b7
    csrw 0xcf7, x3

    #Address 0xcf7 read value
    csrr x14, 0xcf7

    #Unmapped address 0xa68 testing: random write/read operations
    #Address 0xa68 read value
    csrr x14, 0xa68

    #Mapped address 0x32a (mhpmevent10) testing: random write/read operations
    #Address 0x32a Write value 0x9fb95874
    li x3, 0x9fb95874
    csrw 0x32a, x3

    #Address 0x32a read value
    csrr x14, 0x32a

    #Unmapped address 0xb4a testing: random write/read operations
    #Address 0xb4a read value
    csrr x14, 0xb4a

    #Unmapped address 0xe92 testing: random write/read operations
    #Address 0xe92 read value
    csrr x14, 0xe92

    #Address 0xe92 Write value 0xd78d22ea
    li x3, 0xd78d22ea
    csrw 0xe92, x3

    #Address 0xe92 read value
    csrr x14, 0xe92

    #Address 0xe92 Write value 0xca79e9fe
    li x3, 0xca79e9fe
    csrw 0xe92, x3

    #Address 0xe92 read value
    csrr x14, 0xe92

    #Unmapped address 0x988 testing: random write/read operations
    #Address 0x988 Write value 0x931dc407
    li x3, 0x931dc407
    csrw 0x988, x3

    #Address 0x988 read value
    csrr x14, 0x988

    #Address 0x988 Write value 0x1a3375e1
    li x3, 0x1a3375e1
    csrw 0x988, x3

    #Address 0x988 read value
    csrr x14, 0x988

    #Address 0x988 Write value 0x1e6da957
    li x3, 0x1e6da957
    csrw 0x988, x3

    #Unmapped address 0x35d testing: random write/read operations
    #Address 0x35d read value
    csrr x14, 0x35d

    #Address 0x35d read value
    csrr x14, 0x35d

    #Address 0x35d Write value 0x6184694a
    li x3, 0x6184694a
    csrw 0x35d, x3

    #Address 0x35d read value
    csrr x14, 0x35d

    #Address 0x35d Write value 0xac721387
    li x3, 0xac721387
    csrw 0x35d, x3

    #Unmapped address 0xc46 testing: random write/read operations
    #Address 0xc46 Write value 0xedfd30a9
    li x3, 0xedfd30a9
    csrw 0xc46, x3

    #Unmapped address 0xd0b testing: random write/read operations
    #Address 0xd0b read value
    csrr x14, 0xd0b

    #Address 0xd0b read value
    csrr x14, 0xd0b

    #Address 0xd0b Write value 0xea3e074f
    li x3, 0xea3e074f
    csrw 0xd0b, x3

    #Address 0xd0b Write value 0xe9b956d3
    li x3, 0xe9b956d3
    csrw 0xd0b, x3

    #Address 0xd0b Write value 0x4df8411f
    li x3, 0x4df8411f
    csrw 0xd0b, x3

    #Unmapped address 0x3fd testing: random write/read operations
    #Address 0x3fd read value
    csrr x14, 0x3fd

    #Address 0x3fd Write value 0x9364beb
    li x3, 0x9364beb
    csrw 0x3fd, x3

    #Unmapped address 0x5a2 testing: random write/read operations
    #Address 0x5a2 Write value 0x6531803
    li x3, 0x6531803
    csrw 0x5a2, x3

    #Unmapped address 0x906 testing: random write/read operations
    #Address 0x906 Write value 0x7a5f76d9
    li x3, 0x7a5f76d9
    csrw 0x906, x3

    #Address 0x906 read value
    csrr x14, 0x906

    #Address 0x906 Write value 0x951593c4
    li x3, 0x951593c4
    csrw 0x906, x3

    #Address 0x906 read value
    csrr x14, 0x906

    #Unmapped address 0xab0 testing: random write/read operations
    #Address 0xab0 Write value 0x2542d352
    li x3, 0x2542d352
    csrw 0xab0, x3

    #Unmapped address 0xe09 testing: random write/read operations
    #Address 0xe09 Write value 0xc623358e
    li x3, 0xc623358e
    csrw 0xe09, x3

    #Unmapped address 0x660 testing: random write/read operations
    #Address 0x660 Write value 0xcc5528e3
    li x3, 0xcc5528e3
    csrw 0x660, x3

    #Address 0x660 read value
    csrr x14, 0x660

    #Mapped address 0xb80 (mcycleh) testing: random write/read operations
    #Address 0xb80 read value
    csrr x14, 0xb80

    #Address 0xb80 read value
    csrr x14, 0xb80

    #Unmapped address 0xc7f testing: random write/read operations
    #Address 0xc7f Write value 0xe4f6cdbf
    li x3, 0xe4f6cdbf
    csrw 0xc7f, x3

    #Unmapped address 0x9d8 testing: random write/read operations
    #Address 0x9d8 Write value 0x1bc12976
    li x3, 0x1bc12976
    csrw 0x9d8, x3

    #Address 0x9d8 Write value 0x782ec0fd
    li x3, 0x782ec0fd
    csrw 0x9d8, x3

    #Address 0x9d8 Write value 0xd576b0
    li x3, 0xd576b0
    csrw 0x9d8, x3

    #Unmapped address 0x776 testing: random write/read operations
    #Address 0x776 read value
    csrr x14, 0x776

    #Unmapped address 0x80f testing: random write/read operations
    #Address 0x80f read value
    csrr x14, 0x80f

    #Address 0x80f read value
    csrr x14, 0x80f

    #Address 0x80f Write value 0x3269972f
    li x3, 0x3269972f
    csrw 0x80f, x3

    #Address 0x80f Write value 0xc4ab721b
    li x3, 0xc4ab721b
    csrw 0x80f, x3

    #Unmapped address 0xa2e testing: random write/read operations
    #Address 0xa2e Write value 0xc4fd84b3
    li x3, 0xc4fd84b3
    csrw 0xa2e, x3

    #Unmapped address 0x292 testing: random write/read operations
    #Address 0x292 Write value 0xda4b7e7b
    li x3, 0xda4b7e7b
    csrw 0x292, x3

    #Address 0x292 Write value 0xfa613e5e
    li x3, 0xfa613e5e
    csrw 0x292, x3

    #Address 0x292 read value
    csrr x14, 0x292

    #Address 0x292 read value
    csrr x14, 0x292

    #Unmapped address 0x557 testing: random write/read operations
    #Address 0x557 Write value 0x4da541bb
    li x3, 0x4da541bb
    csrw 0x557, x3

    #Address 0x557 Write value 0xc0e86eb8
    li x3, 0xc0e86eb8
    csrw 0x557, x3

    #Unmapped address 0xa testing: random write/read operations
    #Address 0xa Write value 0x8d3cb71e
    li x3, 0x8d3cb71e
    csrw 0xa, x3

    #Address 0xa Write value 0xead0b49f
    li x3, 0xead0b49f
    csrw 0xa, x3

    #Unmapped address 0x753 testing: random write/read operations
    #Address 0x753 Write value 0xa678af9b
    li x3, 0xa678af9b
    csrw 0x753, x3

    #Address 0x753 Write value 0x6dbfa92e
    li x3, 0x6dbfa92e
    csrw 0x753, x3

    #Address 0x753 read value
    csrr x14, 0x753

    #Address 0x753 Write value 0x18f77011
    li x3, 0x18f77011
    csrw 0x753, x3

    #Unmapped address 0xbb2 testing: random write/read operations
    #Address 0xbb2 read value
    csrr x14, 0xbb2

    #Unmapped address 0x2e6 testing: random write/read operations
    #Address 0x2e6 read value
    csrr x14, 0x2e6

    #Address 0x2e6 read value
    csrr x14, 0x2e6

    #Address 0x2e6 read value
    csrr x14, 0x2e6

    #Address 0x2e6 read value
    csrr x14, 0x2e6

    #Address 0x2e6 Write value 0x2f1342b
    li x3, 0x2f1342b
    csrw 0x2e6, x3

    #Unmapped address 0xe60 testing: random write/read operations
    #Address 0xe60 read value
    csrr x14, 0xe60

    #Address 0xe60 Write value 0x85a74231
    li x3, 0x85a74231
    csrw 0xe60, x3

    #Address 0xe60 Write value 0x8fa59fbd
    li x3, 0x8fa59fbd
    csrw 0xe60, x3

    #Address 0xe60 read value
    csrr x14, 0xe60

    #Unmapped address 0x157 testing: random write/read operations
    #Address 0x157 Write value 0xe287776f
    li x3, 0xe287776f
    csrw 0x157, x3

    #Unmapped address 0x1fc testing: random write/read operations
    #Address 0x1fc read value
    csrr x14, 0x1fc

    #Address 0x1fc read value
    csrr x14, 0x1fc

    #Address 0x1fc Write value 0x6cac07e7
    li x3, 0x6cac07e7
    csrw 0x1fc, x3

    #Address 0x1fc read value
    csrr x14, 0x1fc

    #Address 0x1fc Write value 0x73534e66
    li x3, 0x73534e66
    csrw 0x1fc, x3

    #Unmapped address 0x931 testing: random write/read operations
    #Address 0x931 read value
    csrr x14, 0x931

    #Address 0x931 Write value 0x551ec845
    li x3, 0x551ec845
    csrw 0x931, x3

    #Address 0x931 read value
    csrr x14, 0x931

    #Address 0x931 read value
    csrr x14, 0x931

    #Unmapped address 0x8f7 testing: random write/read operations
    #Address 0x8f7 read value
    csrr x14, 0x8f7

    #Address 0x8f7 read value
    csrr x14, 0x8f7

    #Address 0x8f7 Write value 0x561d6d95
    li x3, 0x561d6d95
    csrw 0x8f7, x3

    #Unmapped address 0x5e1 testing: random write/read operations
    #Address 0x5e1 Write value 0xd8e86959
    li x3, 0xd8e86959
    csrw 0x5e1, x3

    #Address 0x5e1 read value
    csrr x14, 0x5e1

    #Unmapped address 0xc0b testing: random write/read operations
    #Address 0xc0b read value
    csrr x14, 0xc0b

    #Address 0xc0b Write value 0x87d87b1f
    li x3, 0x87d87b1f
    csrw 0xc0b, x3

    #Address 0xc0b Write value 0xf01c0391
    li x3, 0xf01c0391
    csrw 0xc0b, x3

    #Address 0xc0b read value
    csrr x14, 0xc0b

    #Unmapped address 0x15c testing: random write/read operations
    #Address 0x15c Write value 0x2f26b076
    li x3, 0x2f26b076
    csrw 0x15c, x3

    #Address 0x15c read value
    csrr x14, 0x15c

    #Address 0x15c read value
    csrr x14, 0x15c

    #Address 0x15c read value
    csrr x14, 0x15c

    #Address 0x15c Write value 0xdf435a73
    li x3, 0xdf435a73
    csrw 0x15c, x3

    #Unmapped address 0x6b0 testing: random write/read operations
    #Address 0x6b0 read value
    csrr x14, 0x6b0

    #Address 0x6b0 read value
    csrr x14, 0x6b0

    #Address 0x6b0 Write value 0x84a5d79
    li x3, 0x84a5d79
    csrw 0x6b0, x3

    #Unmapped address 0x6e5 testing: random write/read operations
    #Address 0x6e5 read value
    csrr x14, 0x6e5

    #Address 0x6e5 Write value 0xe1611f07
    li x3, 0xe1611f07
    csrw 0x6e5, x3

    #Address 0x6e5 read value
    csrr x14, 0x6e5

    #Address 0x6e5 Write value 0xf3f25d1a
    li x3, 0xf3f25d1a
    csrw 0x6e5, x3

    #Address 0x6e5 read value
    csrr x14, 0x6e5

    #Unmapped address 0x4e4 testing: random write/read operations
    #Address 0x4e4 Write value 0x2f3b844c
    li x3, 0x2f3b844c
    csrw 0x4e4, x3

    #Address 0x4e4 read value
    csrr x14, 0x4e4

    #Unmapped address 0x968 testing: random write/read operations
    #Address 0x968 Write value 0x2c2b161b
    li x3, 0x2c2b161b
    csrw 0x968, x3

    #Address 0x968 Write value 0x2b7a160c
    li x3, 0x2b7a160c
    csrw 0x968, x3

    #Address 0x968 Write value 0xae025a40
    li x3, 0xae025a40
    csrw 0x968, x3

    #Address 0x968 Write value 0x50fea5b7
    li x3, 0x50fea5b7
    csrw 0x968, x3

    #Unmapped address 0x261 testing: random write/read operations
    #Address 0x261 Write value 0xa05db78
    li x3, 0xa05db78
    csrw 0x261, x3

    #Unmapped address 0x1ca testing: random write/read operations
    #Address 0x1ca Write value 0x54b66b95
    li x3, 0x54b66b95
    csrw 0x1ca, x3

    #Address 0x1ca read value
    csrr x14, 0x1ca

    #Address 0x1ca read value
    csrr x14, 0x1ca

    #Address 0x1ca Write value 0x9e0560da
    li x3, 0x9e0560da
    csrw 0x1ca, x3

    #Address 0x1ca read value
    csrr x14, 0x1ca

    #Unmapped address 0x6cd testing: random write/read operations
    #Address 0x6cd read value
    csrr x14, 0x6cd

    #Address 0x6cd Write value 0x3b9fadad
    li x3, 0x3b9fadad
    csrw 0x6cd, x3

    #Unmapped address 0x815 testing: random write/read operations
    #Address 0x815 Write value 0x90f44910
    li x3, 0x90f44910
    csrw 0x815, x3

    #Unmapped address 0xda6 testing: random write/read operations
    #Address 0xda6 Write value 0x5eff2c7b
    li x3, 0x5eff2c7b
    csrw 0xda6, x3

    #Address 0xda6 read value
    csrr x14, 0xda6

    #Address 0xda6 Write value 0x461232d5
    li x3, 0x461232d5
    csrw 0xda6, x3

    #Address 0xda6 read value
    csrr x14, 0xda6

    #Address 0xda6 read value
    csrr x14, 0xda6

    #Unmapped address 0x829 testing: random write/read operations
    #Address 0x829 Write value 0xbf73aee0
    li x3, 0xbf73aee0
    csrw 0x829, x3

    #Unmapped address 0x2e5 testing: random write/read operations
    #Address 0x2e5 Write value 0x95d02d57
    li x3, 0x95d02d57
    csrw 0x2e5, x3

    #Address 0x2e5 Write value 0xf44c7e0a
    li x3, 0xf44c7e0a
    csrw 0x2e5, x3

    #Address 0x2e5 read value
    csrr x14, 0x2e5

    #Address 0x2e5 read value
    csrr x14, 0x2e5

    #Unmapped address 0x76d testing: random write/read operations
    #Address 0x76d read value
    csrr x14, 0x76d

    #Address 0x76d read value
    csrr x14, 0x76d

    #Address 0x76d read value
    csrr x14, 0x76d

    #Address 0x76d Write value 0xf8e2cf12
    li x3, 0xf8e2cf12
    csrw 0x76d, x3

    #Address 0x76d read value
    csrr x14, 0x76d

    #Unmapped address 0x5e2 testing: random write/read operations
    #Address 0x5e2 Write value 0x5b0c3bbb
    li x3, 0x5b0c3bbb
    csrw 0x5e2, x3

    #Address 0x5e2 Write value 0x8e58954
    li x3, 0x8e58954
    csrw 0x5e2, x3

    #Address 0x5e2 read value
    csrr x14, 0x5e2

    #Unmapped address 0xdde testing: random write/read operations
    #Address 0xdde read value
    csrr x14, 0xdde

    #Unmapped address 0x36a testing: random write/read operations
    #Address 0x36a read value
    csrr x14, 0x36a

    #Address 0x36a Write value 0x51bc1f15
    li x3, 0x51bc1f15
    csrw 0x36a, x3

    #Address 0x36a Write value 0x176d9984
    li x3, 0x176d9984
    csrw 0x36a, x3

    #Unmapped address 0x191 testing: random write/read operations
    #Address 0x191 Write value 0x4f5b36d9
    li x3, 0x4f5b36d9
    csrw 0x191, x3

    #Unmapped address 0x411 testing: random write/read operations
    #Address 0x411 Write value 0xdfbe8f9e
    li x3, 0xdfbe8f9e
    csrw 0x411, x3

    #Address 0x411 read value
    csrr x14, 0x411

    #Address 0x411 read value
    csrr x14, 0x411

    #Address 0x411 Write value 0x348cd50a
    li x3, 0x348cd50a
    csrw 0x411, x3

    #Unmapped address 0x818 testing: random write/read operations
    #Address 0x818 read value
    csrr x14, 0x818

    #Address 0x818 read value
    csrr x14, 0x818

    #Address 0x818 read value
    csrr x14, 0x818

    #Unmapped address 0xa58 testing: random write/read operations
    #Address 0xa58 Write value 0x374b8b6f
    li x3, 0x374b8b6f
    csrw 0xa58, x3

    #Unmapped address 0x6 testing: random write/read operations
    #Address 0x6 read value
    csrr x14, 0x6

    #Address 0x6 read value
    csrr x14, 0x6

    #Address 0x6 read value
    csrr x14, 0x6

    #Address 0x6 Write value 0x652b9a89
    li x3, 0x652b9a89
    csrw 0x6, x3

    #Address 0x6 read value
    csrr x14, 0x6

    #Unmapped address 0x855 testing: random write/read operations
    #Address 0x855 read value
    csrr x14, 0x855

    #Address 0x855 Write value 0x39449f90
    li x3, 0x39449f90
    csrw 0x855, x3

    #Address 0x855 read value
    csrr x14, 0x855

    #Unmapped address 0xd00 testing: random write/read operations
    #Address 0xd00 read value
    csrr x14, 0xd00

    #Address 0xd00 Write value 0x39eb0dc7
    li x3, 0x39eb0dc7
    csrw 0xd00, x3

    #Address 0xd00 Write value 0x55cebd50
    li x3, 0x55cebd50
    csrw 0xd00, x3

    #Unmapped address 0x597 testing: random write/read operations
    #Address 0x597 Write value 0x3e170ccd
    li x3, 0x3e170ccd
    csrw 0x597, x3

    #Address 0x597 read value
    csrr x14, 0x597

    #Address 0x597 Write value 0xcfa6e594
    li x3, 0xcfa6e594
    csrw 0x597, x3

    #Unmapped address 0xc78 testing: random write/read operations
    #Address 0xc78 Write value 0x4d72da1a
    li x3, 0x4d72da1a
    csrw 0xc78, x3

    #Address 0xc78 read value
    csrr x14, 0xc78

    #Address 0xc78 Write value 0xea6b7a8e
    li x3, 0xea6b7a8e
    csrw 0xc78, x3

    #Address 0xc78 Write value 0xda8dd353
    li x3, 0xda8dd353
    csrw 0xc78, x3

    #Address 0xc78 read value
    csrr x14, 0xc78

    #Unmapped address 0xf3a testing: random write/read operations
    #Address 0xf3a read value
    csrr x14, 0xf3a

    #Address 0xf3a read value
    csrr x14, 0xf3a

    #Address 0xf3a read value
    csrr x14, 0xf3a

    #Address 0xf3a read value
    csrr x14, 0xf3a

    #Unmapped address 0xf54 testing: random write/read operations
    #Address 0xf54 Write value 0xbb2549bc
    li x3, 0xbb2549bc
    csrw 0xf54, x3

    #Address 0xf54 Write value 0x466bb58
    li x3, 0x466bb58
    csrw 0xf54, x3

    #Address 0xf54 Write value 0x732b90b0
    li x3, 0x732b90b0
    csrw 0xf54, x3

    #Address 0xf54 read value
    csrr x14, 0xf54

    #Unmapped address 0xaf2 testing: random write/read operations
    #Address 0xaf2 Write value 0x64812b00
    li x3, 0x64812b00
    csrw 0xaf2, x3

    #Address 0xaf2 read value
    csrr x14, 0xaf2

    #Unmapped address 0x38c testing: random write/read operations
    #Address 0x38c Write value 0x4f96d280
    li x3, 0x4f96d280
    csrw 0x38c, x3

    #Unmapped address 0x2bd testing: random write/read operations
    #Address 0x2bd read value
    csrr x14, 0x2bd

    #Address 0x2bd read value
    csrr x14, 0x2bd

    #Unmapped address 0x410 testing: random write/read operations
    #Address 0x410 read value
    csrr x14, 0x410

    #Address 0x410 Write value 0xeec0ad3e
    li x3, 0xeec0ad3e
    csrw 0x410, x3

    #Unmapped address 0xd8f testing: random write/read operations
    #Address 0xd8f Write value 0xc2abd3f5
    li x3, 0xc2abd3f5
    csrw 0xd8f, x3

    #Address 0xd8f read value
    csrr x14, 0xd8f

    #Address 0xd8f Write value 0x18414212
    li x3, 0x18414212
    csrw 0xd8f, x3

    #Address 0xd8f read value
    csrr x14, 0xd8f

    #Address 0xd8f Write value 0x110a4a52
    li x3, 0x110a4a52
    csrw 0xd8f, x3

    #Unmapped address 0x119 testing: random write/read operations
    #Address 0x119 Write value 0xbaa5467e
    li x3, 0xbaa5467e
    csrw 0x119, x3

    #Address 0x119 Write value 0xe10edd5
    li x3, 0xe10edd5
    csrw 0x119, x3

    #Address 0x119 read value
    csrr x14, 0x119

    #Unmapped address 0xc05 testing: random write/read operations
    #Address 0xc05 read value
    csrr x14, 0xc05

    #Address 0xc05 Write value 0x3e74fbe0
    li x3, 0x3e74fbe0
    csrw 0xc05, x3

    #Unmapped address 0xd4a testing: random write/read operations
    #Address 0xd4a Write value 0x504bff59
    li x3, 0x504bff59
    csrw 0xd4a, x3

    #Address 0xd4a Write value 0x32c10d25
    li x3, 0x32c10d25
    csrw 0xd4a, x3

    #Address 0xd4a Write value 0xd4e33ea0
    li x3, 0xd4e33ea0
    csrw 0xd4a, x3

    #Address 0xd4a read value
    csrr x14, 0xd4a

    #Unmapped address 0x134 testing: random write/read operations
    #Address 0x134 read value
    csrr x14, 0x134

    #Address 0x134 read value
    csrr x14, 0x134

    #Address 0x134 Write value 0x42019fc2
    li x3, 0x42019fc2
    csrw 0x134, x3

    #Address 0x134 read value
    csrr x14, 0x134

    #Address 0x134 read value
    csrr x14, 0x134

    #Unmapped address 0x30b testing: random write/read operations
    #Address 0x30b read value
    csrr x14, 0x30b

    #Address 0x30b Write value 0xe800102a
    li x3, 0xe800102a
    csrw 0x30b, x3

    #Unmapped address 0xfd2 testing: random write/read operations
    #Address 0xfd2 Write value 0x25375d00
    li x3, 0x25375d00
    csrw 0xfd2, x3

    #Address 0xfd2 Write value 0x6ec4e5e
    li x3, 0x6ec4e5e
    csrw 0xfd2, x3

    #Address 0xfd2 read value
    csrr x14, 0xfd2

    #Address 0xfd2 read value
    csrr x14, 0xfd2

    #Address 0xfd2 read value
    csrr x14, 0xfd2

    #Unmapped address 0x627 testing: random write/read operations
    #Address 0x627 Write value 0x7952142b
    li x3, 0x7952142b
    csrw 0x627, x3

    #Address 0x627 Write value 0x3bc461ec
    li x3, 0x3bc461ec
    csrw 0x627, x3

    #Address 0x627 Write value 0xdc3667ac
    li x3, 0xdc3667ac
    csrw 0x627, x3

    #Address 0x627 Write value 0xdb014814
    li x3, 0xdb014814
    csrw 0x627, x3

    #Unmapped address 0x1ed testing: random write/read operations
    #Address 0x1ed Write value 0x1ef83b2c
    li x3, 0x1ef83b2c
    csrw 0x1ed, x3

    #Address 0x1ed Write value 0xb974e68c
    li x3, 0xb974e68c
    csrw 0x1ed, x3

    #Address 0x1ed read value
    csrr x14, 0x1ed

    #Unmapped address 0x448 testing: random write/read operations
    #Address 0x448 read value
    csrr x14, 0x448

    #Address 0x448 Write value 0x2e12c12f
    li x3, 0x2e12c12f
    csrw 0x448, x3

    #Unmapped address 0x66c testing: random write/read operations
    #Address 0x66c Write value 0xf778dc85
    li x3, 0xf778dc85
    csrw 0x66c, x3

    #Address 0x66c Write value 0xb314cf3a
    li x3, 0xb314cf3a
    csrw 0x66c, x3

    #Address 0x66c Write value 0x772ce4ea
    li x3, 0x772ce4ea
    csrw 0x66c, x3

    #Address 0x66c read value
    csrr x14, 0x66c

    #Unmapped address 0xe06 testing: random write/read operations
    #Address 0xe06 read value
    csrr x14, 0xe06

    #Address 0xe06 read value
    csrr x14, 0xe06

    #Unmapped address 0x481 testing: random write/read operations
    #Address 0x481 Write value 0x66a3126e
    li x3, 0x66a3126e
    csrw 0x481, x3

    #Address 0x481 read value
    csrr x14, 0x481

    #Address 0x481 read value
    csrr x14, 0x481

    #Address 0x481 read value
    csrr x14, 0x481

    #Unmapped address 0x34a testing: random write/read operations
    #Address 0x34a read value
    csrr x14, 0x34a

    #Address 0x34a Write value 0x8e01d91e
    li x3, 0x8e01d91e
    csrw 0x34a, x3

    #Address 0x34a Write value 0xcaac6108
    li x3, 0xcaac6108
    csrw 0x34a, x3

    #Address 0x34a Write value 0x58ada306
    li x3, 0x58ada306
    csrw 0x34a, x3

    #Unmapped address 0xb7d testing: random write/read operations
    #Address 0xb7d read value
    csrr x14, 0xb7d

    #Address 0xb7d Write value 0xda444c19
    li x3, 0xda444c19
    csrw 0xb7d, x3

    #Unmapped address 0x632 testing: random write/read operations
    #Address 0x632 read value
    csrr x14, 0x632

    #Unmapped address 0x7df testing: random write/read operations
    #Address 0x7df read value
    csrr x14, 0x7df

    #Unmapped address 0x42c testing: random write/read operations
    #Address 0x42c read value
    csrr x14, 0x42c

    #Address 0x42c read value
    csrr x14, 0x42c

    #Address 0x42c Write value 0x788ddb98
    li x3, 0x788ddb98
    csrw 0x42c, x3

    #Address 0x42c Write value 0xdf763dbd
    li x3, 0xdf763dbd
    csrw 0x42c, x3

    #Address 0x42c read value
    csrr x14, 0x42c

    #Unmapped address 0x984 testing: random write/read operations
    #Address 0x984 read value
    csrr x14, 0x984

    #Address 0x984 read value
    csrr x14, 0x984

    #Address 0x984 Write value 0xc1efebdb
    li x3, 0xc1efebdb
    csrw 0x984, x3

    #Address 0x984 Write value 0xa71249b2
    li x3, 0xa71249b2
    csrw 0x984, x3

    #Unmapped address 0xbb testing: random write/read operations
    #Address 0xbb read value
    csrr x14, 0xbb

    #Address 0xbb read value
    csrr x14, 0xbb

    #Address 0xbb Write value 0xe76548d0
    li x3, 0xe76548d0
    csrw 0xbb, x3

    #Unmapped address 0x699 testing: random write/read operations
    #Address 0x699 Write value 0xf14d946b
    li x3, 0xf14d946b
    csrw 0x699, x3

    #Address 0x699 Write value 0x6cf521dd
    li x3, 0x6cf521dd
    csrw 0x699, x3

    #Address 0x699 read value
    csrr x14, 0x699

    #Unmapped address 0xdf9 testing: random write/read operations
    #Address 0xdf9 read value
    csrr x14, 0xdf9

    #Unmapped address 0x85e testing: random write/read operations
    #Address 0x85e Write value 0x87ae0dcc
    li x3, 0x87ae0dcc
    csrw 0x85e, x3

    #Address 0x85e read value
    csrr x14, 0x85e

    #Address 0x85e read value
    csrr x14, 0x85e

    #Address 0x85e Write value 0x48ea743b
    li x3, 0x48ea743b
    csrw 0x85e, x3

    #Unmapped address 0x57b testing: random write/read operations
    #Address 0x57b Write value 0xed180b3d
    li x3, 0xed180b3d
    csrw 0x57b, x3

    #Address 0x57b Write value 0x9a2d9ca4
    li x3, 0x9a2d9ca4
    csrw 0x57b, x3

    #Unmapped address 0x5b1 testing: random write/read operations
    #Address 0x5b1 Write value 0x53e2f743
    li x3, 0x53e2f743
    csrw 0x5b1, x3

    #Address 0x5b1 read value
    csrr x14, 0x5b1

    #Address 0x5b1 read value
    csrr x14, 0x5b1

    #Address 0x5b1 read value
    csrr x14, 0x5b1

    #Unmapped address 0xc68 testing: random write/read operations
    #Address 0xc68 Write value 0x23122685
    li x3, 0x23122685
    csrw 0xc68, x3

    #Address 0xc68 read value
    csrr x14, 0xc68

    #Address 0xc68 read value
    csrr x14, 0xc68

    #Unmapped address 0x86 testing: random write/read operations
    #Address 0x86 Write value 0xc7a2b52
    li x3, 0xc7a2b52
    csrw 0x86, x3

    #Address 0x86 read value
    csrr x14, 0x86

    #Unmapped address 0xdfb testing: random write/read operations
    #Address 0xdfb Write value 0x16045df1
    li x3, 0x16045df1
    csrw 0xdfb, x3

    #Address 0xdfb read value
    csrr x14, 0xdfb

    #Unmapped address 0x8f2 testing: random write/read operations
    #Address 0x8f2 Write value 0xce88df86
    li x3, 0xce88df86
    csrw 0x8f2, x3

    #Address 0x8f2 read value
    csrr x14, 0x8f2

    #Unmapped address 0x420 testing: random write/read operations
    #Address 0x420 read value
    csrr x14, 0x420

    #Address 0x420 Write value 0x4269f7f7
    li x3, 0x4269f7f7
    csrw 0x420, x3

    #Address 0x420 read value
    csrr x14, 0x420

    #Unmapped address 0x47e testing: random write/read operations
    #Address 0x47e Write value 0x47482dbc
    li x3, 0x47482dbc
    csrw 0x47e, x3

    #Address 0x47e Write value 0xbe8da616
    li x3, 0xbe8da616
    csrw 0x47e, x3

    #Address 0x47e Write value 0x28c7fb74
    li x3, 0x28c7fb74
    csrw 0x47e, x3

    #Unmapped address 0x9c9 testing: random write/read operations
    #Address 0x9c9 read value
    csrr x14, 0x9c9

    #Address 0x9c9 read value
    csrr x14, 0x9c9

    #Address 0x9c9 read value
    csrr x14, 0x9c9

    #Unmapped address 0x578 testing: random write/read operations
    #Address 0x578 read value
    csrr x14, 0x578

    #Address 0x578 read value
    csrr x14, 0x578

    #Unmapped address 0x2d2 testing: random write/read operations
    #Address 0x2d2 read value
    csrr x14, 0x2d2

    #Address 0x2d2 Write value 0x2675dbca
    li x3, 0x2675dbca
    csrw 0x2d2, x3

    #Address 0x2d2 read value
    csrr x14, 0x2d2

    #Unmapped address 0xfac testing: random write/read operations
    #Address 0xfac Write value 0xaaeb67d4
    li x3, 0xaaeb67d4
    csrw 0xfac, x3

    #Address 0xfac read value
    csrr x14, 0xfac

    #Address 0xfac read value
    csrr x14, 0xfac

    #Address 0xfac read value
    csrr x14, 0xfac

    #Unmapped address 0x4f testing: random write/read operations
    #Address 0x4f Write value 0x7419c4b4
    li x3, 0x7419c4b4
    csrw 0x4f, x3

    #Address 0x4f Write value 0x93257885
    li x3, 0x93257885
    csrw 0x4f, x3

    #Unmapped address 0x868 testing: random write/read operations
    #Address 0x868 Write value 0xaadc9bef
    li x3, 0xaadc9bef
    csrw 0x868, x3

    #Address 0x868 Write value 0x5d647788
    li x3, 0x5d647788
    csrw 0x868, x3

    #Unmapped address 0x27b testing: random write/read operations
    #Address 0x27b Write value 0x7bc4b66c
    li x3, 0x7bc4b66c
    csrw 0x27b, x3

    #Address 0x27b Write value 0xce1fd3ed
    li x3, 0xce1fd3ed
    csrw 0x27b, x3

    #Address 0x27b read value
    csrr x14, 0x27b

    #Address 0x27b Write value 0x42225ab3
    li x3, 0x42225ab3
    csrw 0x27b, x3

    #Address 0x27b read value
    csrr x14, 0x27b

    #Unmapped address 0xb26 testing: random write/read operations
    #Address 0xb26 Write value 0xd50d12f8
    li x3, 0xd50d12f8
    csrw 0xb26, x3

    #Address 0xb26 Write value 0x734e7c28
    li x3, 0x734e7c28
    csrw 0xb26, x3

    #Address 0xb26 read value
    csrr x14, 0xb26

    #Address 0xb26 Write value 0xd218a282
    li x3, 0xd218a282
    csrw 0xb26, x3

    #Unmapped address 0x36 testing: random write/read operations
    #Address 0x36 read value
    csrr x14, 0x36

    #Address 0x36 read value
    csrr x14, 0x36

    #Address 0x36 Write value 0x9b03b1ec
    li x3, 0x9b03b1ec
    csrw 0x36, x3

    #Unmapped address 0xa3e testing: random write/read operations
    #Address 0xa3e Write value 0xee28356b
    li x3, 0xee28356b
    csrw 0xa3e, x3

    #Address 0xa3e Write value 0x705cd2f3
    li x3, 0x705cd2f3
    csrw 0xa3e, x3

    #Address 0xa3e Write value 0x8eadbfc0
    li x3, 0x8eadbfc0
    csrw 0xa3e, x3

    #Address 0xa3e read value
    csrr x14, 0xa3e

    #Unmapped address 0x847 testing: random write/read operations
    #Address 0x847 read value
    csrr x14, 0x847

    #Address 0x847 Write value 0x467e0776
    li x3, 0x467e0776
    csrw 0x847, x3

    #Address 0x847 Write value 0xdf0f8a85
    li x3, 0xdf0f8a85
    csrw 0x847, x3

    #Address 0x847 read value
    csrr x14, 0x847

    #Unmapped address 0x8ad testing: random write/read operations
    #Address 0x8ad Write value 0x393cd856
    li x3, 0x393cd856
    csrw 0x8ad, x3

    #Address 0x8ad read value
    csrr x14, 0x8ad

    #Address 0x8ad Write value 0x595dd8f5
    li x3, 0x595dd8f5
    csrw 0x8ad, x3

    #Unmapped address 0x185 testing: random write/read operations
    #Address 0x185 read value
    csrr x14, 0x185

    #Address 0x185 Write value 0xeab310ae
    li x3, 0xeab310ae
    csrw 0x185, x3

    #Unmapped address 0x6a3 testing: random write/read operations
    #Address 0x6a3 read value
    csrr x14, 0x6a3

    #Unmapped address 0xdf6 testing: random write/read operations
    #Address 0xdf6 Write value 0xdbf4779d
    li x3, 0xdbf4779d
    csrw 0xdf6, x3

    #Address 0xdf6 Write value 0xb2c5bc71
    li x3, 0xb2c5bc71
    csrw 0xdf6, x3

    #Address 0xdf6 read value
    csrr x14, 0xdf6

    #Unmapped address 0x28d testing: random write/read operations
    #Address 0x28d read value
    csrr x14, 0x28d

    #Address 0x28d Write value 0x6e30aa75
    li x3, 0x6e30aa75
    csrw 0x28d, x3

    #Address 0x28d Write value 0xdfcc3664
    li x3, 0xdfcc3664
    csrw 0x28d, x3

    #Address 0x28d Write value 0x2f4d8b6
    li x3, 0x2f4d8b6
    csrw 0x28d, x3

    #Address 0x28d Write value 0xb7fe55a2
    li x3, 0xb7fe55a2
    csrw 0x28d, x3

    #Unmapped address 0x39f testing: random write/read operations
    #Address 0x39f read value
    csrr x14, 0x39f

    #Address 0x39f Write value 0x94619540
    li x3, 0x94619540
    csrw 0x39f, x3

    #Address 0x39f Write value 0x8588c488
    li x3, 0x8588c488
    csrw 0x39f, x3

    #Unmapped address 0xd56 testing: random write/read operations
    #Address 0xd56 Write value 0xb67e1d07
    li x3, 0xb67e1d07
    csrw 0xd56, x3

    #Address 0xd56 Write value 0x76969898
    li x3, 0x76969898
    csrw 0xd56, x3

    #Address 0xd56 read value
    csrr x14, 0xd56

    #Unmapped address 0x738 testing: random write/read operations
    #Address 0x738 Write value 0xabfbc857
    li x3, 0xabfbc857
    csrw 0x738, x3

    #Address 0x738 read value
    csrr x14, 0x738

    #Address 0x738 Write value 0x6bc652b4
    li x3, 0x6bc652b4
    csrw 0x738, x3

    #Unmapped address 0x260 testing: random write/read operations
    #Address 0x260 read value
    csrr x14, 0x260

    #Address 0x260 Write value 0xd40bc514
    li x3, 0xd40bc514
    csrw 0x260, x3

    #Address 0x260 Write value 0x27db3dd5
    li x3, 0x27db3dd5
    csrw 0x260, x3

    #Address 0x260 Write value 0x45bf3def
    li x3, 0x45bf3def
    csrw 0x260, x3

    #Unmapped address 0x624 testing: random write/read operations
    #Address 0x624 Write value 0xa3d212a1
    li x3, 0xa3d212a1
    csrw 0x624, x3

    #Address 0x624 Write value 0x8057fa
    li x3, 0x8057fa
    csrw 0x624, x3

    #Unmapped address 0x4ca testing: random write/read operations
    #Address 0x4ca Write value 0xd3280176
    li x3, 0xd3280176
    csrw 0x4ca, x3

    #Mapped address 0xb1f (mhpmcounter31) testing: random write/read operations
    #Address 0xb1f Write value 0xfde97988
    li x3, 0xfde97988
    csrw 0xb1f, x3

    #Address 0xb1f read value
    csrr x14, 0xb1f

    #Address 0xb1f Write value 0x6ef57877
    li x3, 0x6ef57877
    csrw 0xb1f, x3

    #Unmapped address 0x88e testing: random write/read operations
    #Address 0x88e read value
    csrr x14, 0x88e

    #Address 0x88e read value
    csrr x14, 0x88e

    #Unmapped address 0x152 testing: random write/read operations
    #Address 0x152 read value
    csrr x14, 0x152

    #Address 0x152 Write value 0x101ccbd4
    li x3, 0x101ccbd4
    csrw 0x152, x3

    #Address 0x152 Write value 0x71539747
    li x3, 0x71539747
    csrw 0x152, x3

    #Address 0x152 read value
    csrr x14, 0x152

    #Unmapped address 0x551 testing: random write/read operations
    #Address 0x551 Write value 0x4ad20b2c
    li x3, 0x4ad20b2c
    csrw 0x551, x3

    #Address 0x551 Write value 0x8b3055d
    li x3, 0x8b3055d
    csrw 0x551, x3

    #Address 0x551 Write value 0xb67ed8c
    li x3, 0xb67ed8c
    csrw 0x551, x3

    #Unmapped address 0x58d testing: random write/read operations
    #Address 0x58d Write value 0xb7b725b7
    li x3, 0xb7b725b7
    csrw 0x58d, x3

    #Unmapped address 0x1d2 testing: random write/read operations
    #Address 0x1d2 Write value 0x1f3507f1
    li x3, 0x1f3507f1
    csrw 0x1d2, x3

    #Address 0x1d2 read value
    csrr x14, 0x1d2

    #Address 0x1d2 read value
    csrr x14, 0x1d2

    #Address 0x1d2 Write value 0x8b89548b
    li x3, 0x8b89548b
    csrw 0x1d2, x3

    #Address 0x1d2 Write value 0x51371e7a
    li x3, 0x51371e7a
    csrw 0x1d2, x3

    #Unmapped address 0x3ab testing: random write/read operations
    #Address 0x3ab read value
    csrr x14, 0x3ab

    #Address 0x3ab read value
    csrr x14, 0x3ab

    #Address 0x3ab Write value 0x99a94bb8
    li x3, 0x99a94bb8
    csrw 0x3ab, x3

    #Unmapped address 0x670 testing: random write/read operations
    #Address 0x670 read value
    csrr x14, 0x670

    #Address 0x670 Write value 0x65dd329
    li x3, 0x65dd329
    csrw 0x670, x3

    #Address 0x670 read value
    csrr x14, 0x670

    #Address 0x670 Write value 0x61d0632d
    li x3, 0x61d0632d
    csrw 0x670, x3

    #Unmapped address 0x8d0 testing: random write/read operations
    #Address 0x8d0 Write value 0x3a02d123
    li x3, 0x3a02d123
    csrw 0x8d0, x3

    #Address 0x8d0 Write value 0x9ca7e665
    li x3, 0x9ca7e665
    csrw 0x8d0, x3

    #Address 0x8d0 Write value 0xc00ce89e
    li x3, 0xc00ce89e
    csrw 0x8d0, x3

    #Unmapped address 0x267 testing: random write/read operations
    #Address 0x267 Write value 0x46658770
    li x3, 0x46658770
    csrw 0x267, x3

    #Address 0x267 Write value 0x4f90a60f
    li x3, 0x4f90a60f
    csrw 0x267, x3

    #Address 0x267 Write value 0x2e616139
    li x3, 0x2e616139
    csrw 0x267, x3

    #Address 0x267 Write value 0x17f6f03f
    li x3, 0x17f6f03f
    csrw 0x267, x3

    #Address 0x267 Write value 0xd429c8e7
    li x3, 0xd429c8e7
    csrw 0x267, x3

    #Unmapped address 0x43d testing: random write/read operations
    #Address 0x43d read value
    csrr x14, 0x43d

    #Address 0x43d Write value 0x2a851b68
    li x3, 0x2a851b68
    csrw 0x43d, x3

    #Address 0x43d Write value 0x4b8c44d6
    li x3, 0x4b8c44d6
    csrw 0x43d, x3

    #Address 0x43d read value
    csrr x14, 0x43d

    #Address 0x43d Write value 0x164a052c
    li x3, 0x164a052c
    csrw 0x43d, x3

    #Unmapped address 0x19b testing: random write/read operations
    #Address 0x19b read value
    csrr x14, 0x19b

    #Address 0x19b read value
    csrr x14, 0x19b

    #Address 0x19b Write value 0xbb7b5948
    li x3, 0xbb7b5948
    csrw 0x19b, x3

    #Unmapped address 0xf73 testing: random write/read operations
    #Address 0xf73 Write value 0xfebac49b
    li x3, 0xfebac49b
    csrw 0xf73, x3

    #Address 0xf73 Write value 0xe70a1908
    li x3, 0xe70a1908
    csrw 0xf73, x3

    #Address 0xf73 read value
    csrr x14, 0xf73

    #Unmapped address 0x1bd testing: random write/read operations
    #Address 0x1bd Write value 0x17bd2527
    li x3, 0x17bd2527
    csrw 0x1bd, x3

    #Address 0x1bd Write value 0xaa543b25
    li x3, 0xaa543b25
    csrw 0x1bd, x3

    #Address 0x1bd Write value 0x5690b10b
    li x3, 0x5690b10b
    csrw 0x1bd, x3

    #Unmapped address 0xba2 testing: random write/read operations
    #Address 0xba2 read value
    csrr x14, 0xba2

    #Address 0xba2 read value
    csrr x14, 0xba2

    #Address 0xba2 Write value 0xce6b147
    li x3, 0xce6b147
    csrw 0xba2, x3

    #Address 0xba2 Write value 0x297a3e06
    li x3, 0x297a3e06
    csrw 0xba2, x3

    #Address 0xba2 read value
    csrr x14, 0xba2

    #Unmapped address 0x9d7 testing: random write/read operations
    #Address 0x9d7 Write value 0x30183b45
    li x3, 0x30183b45
    csrw 0x9d7, x3

    #Unmapped address 0xe4a testing: random write/read operations
    #Address 0xe4a Write value 0x1ae7736f
    li x3, 0x1ae7736f
    csrw 0xe4a, x3

    #Address 0xe4a Write value 0x73372c7d
    li x3, 0x73372c7d
    csrw 0xe4a, x3

    #Address 0xe4a Write value 0x53a4288e
    li x3, 0x53a4288e
    csrw 0xe4a, x3

    #Unmapped address 0x99d testing: random write/read operations
    #Address 0x99d read value
    csrr x14, 0x99d

    #Unmapped address 0x19d testing: random write/read operations
    #Address 0x19d read value
    csrr x14, 0x19d

    #Address 0x19d Write value 0x2edce0f4
    li x3, 0x2edce0f4
    csrw 0x19d, x3

    #Address 0x19d read value
    csrr x14, 0x19d

    #Unmapped address 0x8cf testing: random write/read operations
    #Address 0x8cf read value
    csrr x14, 0x8cf

    #Mapped address 0xb18 (mhpmcounter24) testing: random write/read operations
    #Address 0xb18 Write value 0x99cde2e9
    li x3, 0x99cde2e9
    csrw 0xb18, x3

    #Address 0xb18 Write value 0x1f2851be
    li x3, 0x1f2851be
    csrw 0xb18, x3

    #Address 0xb18 read value
    csrr x14, 0xb18

    #Unmapped address 0x378 testing: random write/read operations
    #Address 0x378 read value
    csrr x14, 0x378

    #Address 0x378 read value
    csrr x14, 0x378

    #Address 0x378 read value
    csrr x14, 0x378

    #Address 0x378 read value
    csrr x14, 0x378

    #Address 0x378 Write value 0x2d7a155f
    li x3, 0x2d7a155f
    csrw 0x378, x3

    #Unmapped address 0x5ea testing: random write/read operations
    #Address 0x5ea read value
    csrr x14, 0x5ea

    #Address 0x5ea read value
    csrr x14, 0x5ea

    #Mapped address 0x3bf (pmpaddr15) testing: random write/read operations
    #Address 0x3bf Write value 0xc58a614c
    li x3, 0xc58a614c
    csrw 0x3bf, x3

    #Address 0x3bf Write value 0x787771ef
    li x3, 0x787771ef
    csrw 0x3bf, x3

    #Address 0x3bf read value
    csrr x14, 0x3bf

    #Unmapped address 0x3d9 testing: random write/read operations
    #Address 0x3d9 Write value 0xa9a19feb
    li x3, 0xa9a19feb
    csrw 0x3d9, x3

    #Address 0x3d9 read value
    csrr x14, 0x3d9

    #Unmapped address 0x65a testing: random write/read operations
    #Address 0x65a Write value 0x7bad92c2
    li x3, 0x7bad92c2
    csrw 0x65a, x3

    #Address 0x65a read value
    csrr x14, 0x65a

    #Unmapped address 0x12c testing: random write/read operations
    #Address 0x12c read value
    csrr x14, 0x12c

    #Address 0x12c Write value 0xc66cbf7b
    li x3, 0xc66cbf7b
    csrw 0x12c, x3

    #Address 0x12c Write value 0x71983cd0
    li x3, 0x71983cd0
    csrw 0x12c, x3

    #Address 0x12c Write value 0xe1a97c98
    li x3, 0xe1a97c98
    csrw 0x12c, x3

    #Address 0x12c Write value 0x2967f483
    li x3, 0x2967f483
    csrw 0x12c, x3

    #Unmapped address 0x426 testing: random write/read operations
    #Address 0x426 Write value 0x26aae988
    li x3, 0x26aae988
    csrw 0x426, x3

    #Address 0x426 read value
    csrr x14, 0x426

    #Address 0x426 Write value 0x93ce8e59
    li x3, 0x93ce8e59
    csrw 0x426, x3

    #Address 0x426 Write value 0x3b61871a
    li x3, 0x3b61871a
    csrw 0x426, x3

    #Address 0x426 Write value 0x42327b38
    li x3, 0x42327b38
    csrw 0x426, x3

    #Unmapped address 0x28f testing: random write/read operations
    #Address 0x28f Write value 0xc3598e13
    li x3, 0xc3598e13
    csrw 0x28f, x3

    #Unmapped address 0xfe0 testing: random write/read operations
    #Address 0xfe0 read value
    csrr x14, 0xfe0

    #Address 0xfe0 Write value 0x981e7fb7
    li x3, 0x981e7fb7
    csrw 0xfe0, x3

    #Unmapped address 0x72 testing: random write/read operations
    #Address 0x72 Write value 0x607216
    li x3, 0x607216
    csrw 0x72, x3

    #Address 0x72 Write value 0x38450758
    li x3, 0x38450758
    csrw 0x72, x3

    #Address 0x72 Write value 0x99884e24
    li x3, 0x99884e24
    csrw 0x72, x3

    #Unmapped address 0x8f0 testing: random write/read operations
    #Address 0x8f0 Write value 0xf6a95b44
    li x3, 0xf6a95b44
    csrw 0x8f0, x3

    #Address 0x8f0 read value
    csrr x14, 0x8f0

    #Unmapped address 0x4c4 testing: random write/read operations
    #Address 0x4c4 read value
    csrr x14, 0x4c4

    #Address 0x4c4 Write value 0x1ac7028c
    li x3, 0x1ac7028c
    csrw 0x4c4, x3

    #Address 0x4c4 read value
    csrr x14, 0x4c4

    #Address 0x4c4 read value
    csrr x14, 0x4c4

    #Mapped address 0x33d (mhpmevent29) testing: random write/read operations
    #Address 0x33d Write value 0xbef64cc1
    li x3, 0xbef64cc1
    csrw 0x33d, x3

    #Address 0x33d Write value 0xfa8bf481
    li x3, 0xfa8bf481
    csrw 0x33d, x3

    #Address 0x33d Write value 0xf09c5e0f
    li x3, 0xf09c5e0f
    csrw 0x33d, x3

    #Address 0x33d read value
    csrr x14, 0x33d

    #Unmapped address 0x93f testing: random write/read operations
    #Address 0x93f Write value 0x4a2f2680
    li x3, 0x4a2f2680
    csrw 0x93f, x3

    #Address 0x93f read value
    csrr x14, 0x93f

    #Address 0x93f Write value 0xd4ba895a
    li x3, 0xd4ba895a
    csrw 0x93f, x3

    #Mapped address 0x3bc (pmpaddr12) testing: random write/read operations
    #Address 0x3bc read value
    csrr x14, 0x3bc

    #Unmapped address 0x27e testing: random write/read operations
    #Address 0x27e read value
    csrr x14, 0x27e

    #Unmapped address 0xf1e testing: random write/read operations
    #Address 0xf1e Write value 0xb34a6d5e
    li x3, 0xb34a6d5e
    csrw 0xf1e, x3

    #Address 0xf1e read value
    csrr x14, 0xf1e

    #Address 0xf1e read value
    csrr x14, 0xf1e

    #Address 0xf1e read value
    csrr x14, 0xf1e

    #Unmapped address 0x8a2 testing: random write/read operations
    #Address 0x8a2 Write value 0xab5b45c4
    li x3, 0xab5b45c4
    csrw 0x8a2, x3

    #Address 0x8a2 Write value 0x7855d17d
    li x3, 0x7855d17d
    csrw 0x8a2, x3

    #Address 0x8a2 read value
    csrr x14, 0x8a2

    #Unmapped address 0xbbc testing: random write/read operations
    #Address 0xbbc Write value 0xc96bcc33
    li x3, 0xc96bcc33
    csrw 0xbbc, x3

    #Address 0xbbc Write value 0xa6335530
    li x3, 0xa6335530
    csrw 0xbbc, x3

    #Address 0xbbc Write value 0x6014418c
    li x3, 0x6014418c
    csrw 0xbbc, x3

    #Address 0xbbc read value
    csrr x14, 0xbbc

    #Address 0xbbc read value
    csrr x14, 0xbbc

    #Unmapped address 0xcb6 testing: random write/read operations
    #Address 0xcb6 read value
    csrr x14, 0xcb6

    #Address 0xcb6 Write value 0xe775c876
    li x3, 0xe775c876
    csrw 0xcb6, x3

    #Address 0xcb6 Write value 0x3ee5f025
    li x3, 0x3ee5f025
    csrw 0xcb6, x3

    #Address 0xcb6 Write value 0x8c43c42e
    li x3, 0x8c43c42e
    csrw 0xcb6, x3

    #Address 0xcb6 Write value 0x989448a8
    li x3, 0x989448a8
    csrw 0xcb6, x3

    #Unmapped address 0x50e testing: random write/read operations
    #Address 0x50e read value
    csrr x14, 0x50e

    #Address 0x50e read value
    csrr x14, 0x50e

    #Address 0x50e read value
    csrr x14, 0x50e

    #Address 0x50e Write value 0xdc60712c
    li x3, 0xdc60712c
    csrw 0x50e, x3

    #Address 0x50e read value
    csrr x14, 0x50e

    #Unmapped address 0x24 testing: random write/read operations
    #Address 0x24 read value
    csrr x14, 0x24

    #Unmapped address 0xd09 testing: random write/read operations
    #Address 0xd09 Write value 0x8f5212e4
    li x3, 0x8f5212e4
    csrw 0xd09, x3

    #Unmapped address 0xe0 testing: random write/read operations
    #Address 0xe0 read value
    csrr x14, 0xe0

    #Unmapped address 0xb3 testing: random write/read operations
    #Address 0xb3 Write value 0xe6e413de
    li x3, 0xe6e413de
    csrw 0xb3, x3

    #Address 0xb3 Write value 0x1af33e5c
    li x3, 0x1af33e5c
    csrw 0xb3, x3

    #Unmapped address 0xb32 testing: random write/read operations
    #Address 0xb32 Write value 0x7dee5eaa
    li x3, 0x7dee5eaa
    csrw 0xb32, x3

    #Address 0xb32 Write value 0x4ba51a0c
    li x3, 0x4ba51a0c
    csrw 0xb32, x3

    #Address 0xb32 read value
    csrr x14, 0xb32

    #Address 0xb32 read value
    csrr x14, 0xb32

    #Address 0xb32 Write value 0x2b34813b
    li x3, 0x2b34813b
    csrw 0xb32, x3

    #Unmapped address 0x9eb testing: random write/read operations
    #Address 0x9eb read value
    csrr x14, 0x9eb

    #Address 0x9eb read value
    csrr x14, 0x9eb

    #Address 0x9eb Write value 0x78ea3f22
    li x3, 0x78ea3f22
    csrw 0x9eb, x3

    #Address 0x9eb read value
    csrr x14, 0x9eb

    #Unmapped address 0x605 testing: random write/read operations
    #Address 0x605 read value
    csrr x14, 0x605

    #Unmapped address 0xfe5 testing: random write/read operations
    #Address 0xfe5 Write value 0xb4fe0aa9
    li x3, 0xb4fe0aa9
    csrw 0xfe5, x3

    #Address 0xfe5 read value
    csrr x14, 0xfe5

    #Address 0xfe5 read value
    csrr x14, 0xfe5

    #Unmapped address 0x87 testing: random write/read operations
    #Address 0x87 read value
    csrr x14, 0x87

    #Address 0x87 read value
    csrr x14, 0x87

    #Address 0x87 read value
    csrr x14, 0x87

    #Address 0x87 read value
    csrr x14, 0x87

    #Address 0x87 Write value 0xf358c60b
    li x3, 0xf358c60b
    csrw 0x87, x3

    #Unmapped address 0x10c testing: random write/read operations
    #Address 0x10c read value
    csrr x14, 0x10c

    #Address 0x10c read value
    csrr x14, 0x10c

    #Address 0x10c Write value 0xa91d0c0c
    li x3, 0xa91d0c0c
    csrw 0x10c, x3

    #Address 0x10c Write value 0xcda867f8
    li x3, 0xcda867f8
    csrw 0x10c, x3

    #Unmapped address 0x388 testing: random write/read operations
    #Address 0x388 Write value 0xdb65b4b9
    li x3, 0xdb65b4b9
    csrw 0x388, x3

    #Address 0x388 Write value 0xfb453c1a
    li x3, 0xfb453c1a
    csrw 0x388, x3

    #Address 0x388 read value
    csrr x14, 0x388

    #Address 0x388 Write value 0xa03821c5
    li x3, 0xa03821c5
    csrw 0x388, x3

    #Address 0x388 Write value 0x196b763
    li x3, 0x196b763
    csrw 0x388, x3

    #Unmapped address 0xa60 testing: random write/read operations
    #Address 0xa60 read value
    csrr x14, 0xa60

    #Unmapped address 0x6de testing: random write/read operations
    #Address 0x6de read value
    csrr x14, 0x6de

    #Mapped address 0x3bb (pmpaddr11) testing: random write/read operations
    #Address 0x3bb Write value 0x52ab2c01
    li x3, 0x52ab2c01
    csrw 0x3bb, x3

    #Unmapped address 0xf31 testing: random write/read operations
    #Address 0xf31 read value
    csrr x14, 0xf31

    #Address 0xf31 Write value 0xae1cdd28
    li x3, 0xae1cdd28
    csrw 0xf31, x3

    #Address 0xf31 Write value 0xf55c4a21
    li x3, 0xf55c4a21
    csrw 0xf31, x3

    #Address 0xf31 read value
    csrr x14, 0xf31

    #Unmapped address 0x853 testing: random write/read operations
    #Address 0x853 Write value 0x26c98bc7
    li x3, 0x26c98bc7
    csrw 0x853, x3

    #Address 0x853 read value
    csrr x14, 0x853

    #Address 0x853 read value
    csrr x14, 0x853

    #Address 0x853 read value
    csrr x14, 0x853

    #Address 0x853 read value
    csrr x14, 0x853

    #Unmapped address 0x7a7 testing: random write/read operations
    #Address 0x7a7 Write value 0x356f4766
    li x3, 0x356f4766
    csrw 0x7a7, x3

    #Address 0x7a7 Write value 0x26ee3167
    li x3, 0x26ee3167
    csrw 0x7a7, x3

    #Address 0x7a7 Write value 0xfc870168
    li x3, 0xfc870168
    csrw 0x7a7, x3

    #Unmapped address 0xbfc testing: random write/read operations
    #Address 0xbfc Write value 0x2115fb02
    li x3, 0x2115fb02
    csrw 0xbfc, x3

    #Address 0xbfc Write value 0x5d18ed2e
    li x3, 0x5d18ed2e
    csrw 0xbfc, x3

    #Address 0xbfc read value
    csrr x14, 0xbfc

    #Address 0xbfc read value
    csrr x14, 0xbfc

    #Unmapped address 0x27f testing: random write/read operations
    #Address 0x27f read value
    csrr x14, 0x27f

    #Address 0x27f Write value 0x7f8a4f30
    li x3, 0x7f8a4f30
    csrw 0x27f, x3

    #Address 0x27f read value
    csrr x14, 0x27f

    #Address 0x27f read value
    csrr x14, 0x27f

    #Unmapped address 0xa01 testing: random write/read operations
    #Address 0xa01 Write value 0x816ddb10
    li x3, 0x816ddb10
    csrw 0xa01, x3

    #Address 0xa01 Write value 0x91cc8b1b
    li x3, 0x91cc8b1b
    csrw 0xa01, x3

    #Address 0xa01 Write value 0xa3a5ba77
    li x3, 0xa3a5ba77
    csrw 0xa01, x3

    #Address 0xa01 read value
    csrr x14, 0xa01

    #Unmapped address 0x612 testing: random write/read operations
    #Address 0x612 Write value 0xa369359f
    li x3, 0xa369359f
    csrw 0x612, x3

    #Address 0x612 Write value 0x554cc94e
    li x3, 0x554cc94e
    csrw 0x612, x3

    #Address 0x612 read value
    csrr x14, 0x612

    #Address 0x612 Write value 0x7215ce54
    li x3, 0x7215ce54
    csrw 0x612, x3

    #Address 0x612 read value
    csrr x14, 0x612

    #Unmapped address 0x673 testing: random write/read operations
    #Address 0x673 read value
    csrr x14, 0x673

    #Address 0x673 Write value 0x77bff48b
    li x3, 0x77bff48b
    csrw 0x673, x3

    #Address 0x673 read value
    csrr x14, 0x673

    #Unmapped address 0x7ab testing: random write/read operations
    #Address 0x7ab Write value 0x807c9e07
    li x3, 0x807c9e07
    csrw 0x7ab, x3

    #Unmapped address 0xafc testing: random write/read operations
    #Address 0xafc read value
    csrr x14, 0xafc

    #Address 0xafc Write value 0x10757023
    li x3, 0x10757023
    csrw 0xafc, x3

    #Address 0xafc Write value 0x4b7c2203
    li x3, 0x4b7c2203
    csrw 0xafc, x3

    #Address 0xafc read value
    csrr x14, 0xafc

    #Address 0xafc Write value 0x7bbd3f90
    li x3, 0x7bbd3f90
    csrw 0xafc, x3

    #Mapped address 0xb88 (mhpmcounterh8) testing: random write/read operations
    #Address 0xb88 Write value 0x1f290359
    li x3, 0x1f290359
    csrw 0xb88, x3

    #Address 0xb88 read value
    csrr x14, 0xb88

    #Unmapped address 0xaeb testing: random write/read operations
    #Address 0xaeb Write value 0xb63bdf68
    li x3, 0xb63bdf68
    csrw 0xaeb, x3

    #Address 0xaeb Write value 0xcc1bd3a5
    li x3, 0xcc1bd3a5
    csrw 0xaeb, x3

    #Unmapped address 0x561 testing: random write/read operations
    #Address 0x561 read value
    csrr x14, 0x561

    #Unmapped address 0x64b testing: random write/read operations
    #Address 0x64b read value
    csrr x14, 0x64b

    #Address 0x64b Write value 0xd5f34204
    li x3, 0xd5f34204
    csrw 0x64b, x3

    #Address 0x64b read value
    csrr x14, 0x64b

    #Address 0x64b read value
    csrr x14, 0x64b

    #Address 0x64b Write value 0x20801ba9
    li x3, 0x20801ba9
    csrw 0x64b, x3

    #Unmapped address 0x365 testing: random write/read operations
    #Address 0x365 read value
    csrr x14, 0x365

    #Unmapped address 0xc96 testing: random write/read operations
    #Address 0xc96 Write value 0xe89ac3d4
    li x3, 0xe89ac3d4
    csrw 0xc96, x3

    #Unmapped address 0x953 testing: random write/read operations
    #Address 0x953 read value
    csrr x14, 0x953

    #Unmapped address 0xf4f testing: random write/read operations
    #Address 0xf4f Write value 0x39f3c877
    li x3, 0x39f3c877
    csrw 0xf4f, x3

    #Unmapped address 0xdba testing: random write/read operations
    #Address 0xdba Write value 0x246e0cd6
    li x3, 0x246e0cd6
    csrw 0xdba, x3

    #Unmapped address 0x9cb testing: random write/read operations
    #Address 0x9cb Write value 0x8f7ff192
    li x3, 0x8f7ff192
    csrw 0x9cb, x3

    #Address 0x9cb read value
    csrr x14, 0x9cb

    #Address 0x9cb read value
    csrr x14, 0x9cb

    #Address 0x9cb read value
    csrr x14, 0x9cb

    #Address 0x9cb Write value 0xf11a4dba
    li x3, 0xf11a4dba
    csrw 0x9cb, x3

    #Unmapped address 0x8a0 testing: random write/read operations
    #Address 0x8a0 Write value 0x306dbcc0
    li x3, 0x306dbcc0
    csrw 0x8a0, x3

    #Address 0x8a0 Write value 0xd033117d
    li x3, 0xd033117d
    csrw 0x8a0, x3

    #Unmapped address 0xfe testing: random write/read operations
    #Address 0xfe read value
    csrr x14, 0xfe

    #Address 0xfe Write value 0xd8d36539
    li x3, 0xd8d36539
    csrw 0xfe, x3

    #Address 0xfe Write value 0xa63acf7
    li x3, 0xa63acf7
    csrw 0xfe, x3

    #Address 0xfe read value
    csrr x14, 0xfe

    #Unmapped address 0x3ca testing: random write/read operations
    #Address 0x3ca read value
    csrr x14, 0x3ca

    #Address 0x3ca read value
    csrr x14, 0x3ca

    #Unmapped address 0x6dc testing: random write/read operations
    #Address 0x6dc read value
    csrr x14, 0x6dc

    #Unmapped address 0xa1b testing: random write/read operations
    #Address 0xa1b Write value 0xcc74f07e
    li x3, 0xcc74f07e
    csrw 0xa1b, x3

    #Address 0xa1b read value
    csrr x14, 0xa1b

    #Address 0xa1b read value
    csrr x14, 0xa1b

    #Address 0xa1b read value
    csrr x14, 0xa1b

    #Unmapped address 0xc50 testing: random write/read operations
    #Address 0xc50 read value
    csrr x14, 0xc50

    #Address 0xc50 Write value 0x5574f851
    li x3, 0x5574f851
    csrw 0xc50, x3

    #Address 0xc50 read value
    csrr x14, 0xc50

    #Address 0xc50 Write value 0x3a4dbc18
    li x3, 0x3a4dbc18
    csrw 0xc50, x3

    #Address 0xc50 read value
    csrr x14, 0xc50

    #Unmapped address 0x586 testing: random write/read operations
    #Address 0x586 read value
    csrr x14, 0x586

    #Address 0x586 Write value 0x29678e0c
    li x3, 0x29678e0c
    csrw 0x586, x3

    #Address 0x586 Write value 0x8a58238e
    li x3, 0x8a58238e
    csrw 0x586, x3

    #Unmapped address 0x48a testing: random write/read operations
    #Address 0x48a read value
    csrr x14, 0x48a

    #Address 0x48a Write value 0x3dc5f9cd
    li x3, 0x3dc5f9cd
    csrw 0x48a, x3

    #Address 0x48a Write value 0x1dd87ff7
    li x3, 0x1dd87ff7
    csrw 0x48a, x3

    #Address 0x48a read value
    csrr x14, 0x48a

    #Address 0x48a Write value 0xe6a20933
    li x3, 0xe6a20933
    csrw 0x48a, x3

    #Unmapped address 0x4a2 testing: random write/read operations
    #Address 0x4a2 Write value 0x9c42219a
    li x3, 0x9c42219a
    csrw 0x4a2, x3

    #Mapped address 0xb0a (mhpmcounter10) testing: random write/read operations
    #Address 0xb0a Write value 0xf4ed92a
    li x3, 0xf4ed92a
    csrw 0xb0a, x3

    #Address 0xb0a Write value 0x2208e6ad
    li x3, 0x2208e6ad
    csrw 0xb0a, x3

    #Unmapped address 0x394 testing: random write/read operations
    #Address 0x394 read value
    csrr x14, 0x394

    #Address 0x394 Write value 0x9958d67
    li x3, 0x9958d67
    csrw 0x394, x3

    #Address 0x394 Write value 0xfc02e2b0
    li x3, 0xfc02e2b0
    csrw 0x394, x3

    #Address 0x394 Write value 0xb7b3001e
    li x3, 0xb7b3001e
    csrw 0x394, x3

    #Address 0x394 read value
    csrr x14, 0x394

    #Unmapped address 0xc8f testing: random write/read operations
    #Address 0xc8f Write value 0x30fd58a6
    li x3, 0x30fd58a6
    csrw 0xc8f, x3

    #Address 0xc8f read value
    csrr x14, 0xc8f

    #Unmapped address 0x33 testing: random write/read operations
    #Address 0x33 read value
    csrr x14, 0x33

    #Address 0x33 Write value 0xfc6813e9
    li x3, 0xfc6813e9
    csrw 0x33, x3

    #Unmapped address 0xbe9 testing: random write/read operations
    #Address 0xbe9 read value
    csrr x14, 0xbe9

    #Address 0xbe9 read value
    csrr x14, 0xbe9

    #Unmapped address 0x2ec testing: random write/read operations
    #Address 0x2ec Write value 0x5da7e75c
    li x3, 0x5da7e75c
    csrw 0x2ec, x3

    #Address 0x2ec read value
    csrr x14, 0x2ec

    #Unmapped address 0x46d testing: random write/read operations
    #Address 0x46d read value
    csrr x14, 0x46d

    #Address 0x46d read value
    csrr x14, 0x46d

    #Address 0x46d read value
    csrr x14, 0x46d

    #Address 0x46d read value
    csrr x14, 0x46d

    #Unmapped address 0x8c8 testing: random write/read operations
    #Address 0x8c8 read value
    csrr x14, 0x8c8

    #Address 0x8c8 read value
    csrr x14, 0x8c8

    #Address 0x8c8 read value
    csrr x14, 0x8c8

    #Address 0x8c8 read value
    csrr x14, 0x8c8

    #Unmapped address 0x5b6 testing: random write/read operations
    #Address 0x5b6 Write value 0x459cbe55
    li x3, 0x459cbe55
    csrw 0x5b6, x3

    #Address 0x5b6 Write value 0x5767d73a
    li x3, 0x5767d73a
    csrw 0x5b6, x3

    #Address 0x5b6 Write value 0xfc847166
    li x3, 0xfc847166
    csrw 0x5b6, x3

    #Address 0x5b6 Write value 0xde16f7e6
    li x3, 0xde16f7e6
    csrw 0x5b6, x3

    #Address 0x5b6 read value
    csrr x14, 0x5b6

    #Unmapped address 0x59 testing: random write/read operations
    #Address 0x59 Write value 0xeba633ed
    li x3, 0xeba633ed
    csrw 0x59, x3

    #Address 0x59 Write value 0x1e9f9a9c
    li x3, 0x1e9f9a9c
    csrw 0x59, x3

    #Unmapped address 0x7c3 testing: random write/read operations
    #Address 0x7c3 Write value 0x14225b1f
    li x3, 0x14225b1f
    csrw 0x7c3, x3

    #Address 0x7c3 read value
    csrr x14, 0x7c3

    #Unmapped address 0xd1 testing: random write/read operations
    #Address 0xd1 read value
    csrr x14, 0xd1

    #Address 0xd1 read value
    csrr x14, 0xd1

    #Address 0xd1 read value
    csrr x14, 0xd1

    #Address 0xd1 Write value 0x2927dfc0
    li x3, 0x2927dfc0
    csrw 0xd1, x3

    #Address 0xd1 read value
    csrr x14, 0xd1

    #Unmapped address 0xd30 testing: random write/read operations
    #Address 0xd30 Write value 0x221ec99d
    li x3, 0x221ec99d
    csrw 0xd30, x3

    #Unmapped address 0x297 testing: random write/read operations
    #Address 0x297 Write value 0x6813444e
    li x3, 0x6813444e
    csrw 0x297, x3

    #Unmapped address 0x55a testing: random write/read operations
    #Address 0x55a Write value 0x6b3036c5
    li x3, 0x6b3036c5
    csrw 0x55a, x3

    #Address 0x55a Write value 0x9d7f7a27
    li x3, 0x9d7f7a27
    csrw 0x55a, x3

    #Unmapped address 0xa9c testing: random write/read operations
    #Address 0xa9c read value
    csrr x14, 0xa9c

    #Unmapped address 0x485 testing: random write/read operations
    #Address 0x485 Write value 0x6a4891c1
    li x3, 0x6a4891c1
    csrw 0x485, x3

    #Address 0x485 Write value 0xf14f8b04
    li x3, 0xf14f8b04
    csrw 0x485, x3

    #Address 0x485 read value
    csrr x14, 0x485

    #Address 0x485 read value
    csrr x14, 0x485

    #Unmapped address 0x9bc testing: random write/read operations
    #Address 0x9bc Write value 0x790698c0
    li x3, 0x790698c0
    csrw 0x9bc, x3

    #Unmapped address 0xace testing: random write/read operations
    #Address 0xace read value
    csrr x14, 0xace

    #Address 0xace Write value 0x422fa1a3
    li x3, 0x422fa1a3
    csrw 0xace, x3

    #Unmapped address 0x9b0 testing: random write/read operations
    #Address 0x9b0 read value
    csrr x14, 0x9b0

    #Address 0x9b0 Write value 0x511adfa8
    li x3, 0x511adfa8
    csrw 0x9b0, x3

    #Address 0x9b0 Write value 0x7383a47e
    li x3, 0x7383a47e
    csrw 0x9b0, x3

    #Address 0x9b0 read value
    csrr x14, 0x9b0

    #Address 0x9b0 Write value 0x7107d172
    li x3, 0x7107d172
    csrw 0x9b0, x3

    #Unmapped address 0xebf testing: random write/read operations
    #Address 0xebf read value
    csrr x14, 0xebf

    #Address 0xebf read value
    csrr x14, 0xebf

    #Unmapped address 0x2bf testing: random write/read operations
    #Address 0x2bf Write value 0x53ca4996
    li x3, 0x53ca4996
    csrw 0x2bf, x3

    #Address 0x2bf Write value 0x38d4757e
    li x3, 0x38d4757e
    csrw 0x2bf, x3

    #Address 0x2bf Write value 0xb68d8688
    li x3, 0xb68d8688
    csrw 0x2bf, x3

    #Address 0x2bf read value
    csrr x14, 0x2bf

    #Address 0x2bf Write value 0xc902110f
    li x3, 0xc902110f
    csrw 0x2bf, x3

    #Unmapped address 0xa4a testing: random write/read operations
    #Address 0xa4a read value
    csrr x14, 0xa4a

    #Address 0xa4a Write value 0x4360f3c0
    li x3, 0x4360f3c0
    csrw 0xa4a, x3

    #Address 0xa4a Write value 0x98b735ab
    li x3, 0x98b735ab
    csrw 0xa4a, x3

    #Address 0xa4a read value
    csrr x14, 0xa4a

    #Address 0xa4a read value
    csrr x14, 0xa4a

    #Unmapped address 0x6ec testing: random write/read operations
    #Address 0x6ec Write value 0x85c48a58
    li x3, 0x85c48a58
    csrw 0x6ec, x3

    #Unmapped address 0xf2a testing: random write/read operations
    #Address 0xf2a Write value 0x24483c03
    li x3, 0x24483c03
    csrw 0xf2a, x3

    #Address 0xf2a read value
    csrr x14, 0xf2a

    #Address 0xf2a read value
    csrr x14, 0xf2a

    #Address 0xf2a read value
    csrr x14, 0xf2a

    #Unmapped address 0x35c testing: random write/read operations
    #Address 0x35c Write value 0xf3193416
    li x3, 0xf3193416
    csrw 0x35c, x3

    #Address 0x35c read value
    csrr x14, 0x35c

    #Address 0x35c Write value 0x89070dce
    li x3, 0x89070dce
    csrw 0x35c, x3

    #Unmapped address 0xe testing: random write/read operations
    #Address 0xe Write value 0x56e89b57
    li x3, 0x56e89b57
    csrw 0xe, x3

    #Unmapped address 0x11 testing: random write/read operations
    #Address 0x11 read value
    csrr x14, 0x11

    #Unmapped address 0x84e testing: random write/read operations
    #Address 0x84e read value
    csrr x14, 0x84e

    #Address 0x84e read value
    csrr x14, 0x84e

    #Address 0x84e read value
    csrr x14, 0x84e

    #Unmapped address 0x1c8 testing: random write/read operations
    #Address 0x1c8 read value
    csrr x14, 0x1c8

    #Address 0x1c8 Write value 0x2615f150
    li x3, 0x2615f150
    csrw 0x1c8, x3

    #Address 0x1c8 Write value 0x34473899
    li x3, 0x34473899
    csrw 0x1c8, x3

    #Address 0x1c8 read value
    csrr x14, 0x1c8

    #Unmapped address 0x197 testing: random write/read operations
    #Address 0x197 Write value 0x67d520af
    li x3, 0x67d520af
    csrw 0x197, x3

    #Address 0x197 Write value 0x7fe62eea
    li x3, 0x7fe62eea
    csrw 0x197, x3

    #Unmapped address 0xf5e testing: random write/read operations
    #Address 0xf5e Write value 0x2fae6c19
    li x3, 0x2fae6c19
    csrw 0xf5e, x3

    #Address 0xf5e Write value 0xbcbe5cbc
    li x3, 0xbcbe5cbc
    csrw 0xf5e, x3

    #Unmapped address 0x175 testing: random write/read operations
    #Address 0x175 Write value 0x92910549
    li x3, 0x92910549
    csrw 0x175, x3

    #Address 0x175 Write value 0x9aacc196
    li x3, 0x9aacc196
    csrw 0x175, x3

    #Address 0x175 Write value 0x42c2e071
    li x3, 0x42c2e071
    csrw 0x175, x3

    #Address 0x175 Write value 0xd81ca069
    li x3, 0xd81ca069
    csrw 0x175, x3

    #Unmapped address 0x99a testing: random write/read operations
    #Address 0x99a Write value 0xad24309b
    li x3, 0xad24309b
    csrw 0x99a, x3

    #Address 0x99a read value
    csrr x14, 0x99a

    #Address 0x99a read value
    csrr x14, 0x99a

    #Address 0x99a Write value 0x4ca9cb91
    li x3, 0x4ca9cb91
    csrw 0x99a, x3

    #Address 0x99a read value
    csrr x14, 0x99a

    #Unmapped address 0xd1f testing: random write/read operations
    #Address 0xd1f Write value 0x928921f2
    li x3, 0x928921f2
    csrw 0xd1f, x3

    #Address 0xd1f read value
    csrr x14, 0xd1f

    #Unmapped address 0x609 testing: random write/read operations
    #Address 0x609 Write value 0x66fdff93
    li x3, 0x66fdff93
    csrw 0x609, x3

    #Address 0x609 read value
    csrr x14, 0x609

    #Address 0x609 read value
    csrr x14, 0x609

    #Unmapped address 0x38f testing: random write/read operations
    #Address 0x38f Write value 0xd217247a
    li x3, 0xd217247a
    csrw 0x38f, x3

    #Address 0x38f read value
    csrr x14, 0x38f

    #Address 0x38f read value
    csrr x14, 0x38f

    #Unmapped address 0x54e testing: random write/read operations
    #Address 0x54e Write value 0x65156cbc
    li x3, 0x65156cbc
    csrw 0x54e, x3

    #Address 0x54e read value
    csrr x14, 0x54e

    #Address 0x54e read value
    csrr x14, 0x54e

    #Address 0x54e read value
    csrr x14, 0x54e

    #Address 0x54e Write value 0xe3029e64
    li x3, 0xe3029e64
    csrw 0x54e, x3

    #Unmapped address 0x543 testing: random write/read operations
    #Address 0x543 read value
    csrr x14, 0x543

    #Address 0x543 read value
    csrr x14, 0x543

    #Address 0x543 read value
    csrr x14, 0x543

    #Address 0x543 Write value 0x9064eca9
    li x3, 0x9064eca9
    csrw 0x543, x3

    #Address 0x543 Write value 0x3b3d83cd
    li x3, 0x3b3d83cd
    csrw 0x543, x3

    #Unmapped address 0x97 testing: random write/read operations
    #Address 0x97 read value
    csrr x14, 0x97

    #Address 0x97 read value
    csrr x14, 0x97

    #Address 0x97 read value
    csrr x14, 0x97

    #Address 0x97 read value
    csrr x14, 0x97

    #Unmapped address 0x4ce testing: random write/read operations
    #Address 0x4ce read value
    csrr x14, 0x4ce

    #Address 0x4ce Write value 0xad93bf79
    li x3, 0xad93bf79
    csrw 0x4ce, x3

    #Address 0x4ce Write value 0xfef85afc
    li x3, 0xfef85afc
    csrw 0x4ce, x3

    #Address 0x4ce read value
    csrr x14, 0x4ce

    #Unmapped address 0xa41 testing: random write/read operations
    #Address 0xa41 read value
    csrr x14, 0xa41

    #Unmapped address 0x8bc testing: random write/read operations
    #Address 0x8bc read value
    csrr x14, 0x8bc

    #Address 0x8bc read value
    csrr x14, 0x8bc

    #Address 0x8bc Write value 0xa4dcc662
    li x3, 0xa4dcc662
    csrw 0x8bc, x3

    #Address 0x8bc read value
    csrr x14, 0x8bc

    #Unmapped address 0x271 testing: random write/read operations
    #Address 0x271 read value
    csrr x14, 0x271

    #Address 0x271 Write value 0xd2f0344f
    li x3, 0xd2f0344f
    csrw 0x271, x3

    #Address 0x271 read value
    csrr x14, 0x271

    #Unmapped address 0xaa0 testing: random write/read operations
    #Address 0xaa0 read value
    csrr x14, 0xaa0

    #Address 0xaa0 Write value 0x96a3bb23
    li x3, 0x96a3bb23
    csrw 0xaa0, x3

    #Address 0xaa0 Write value 0xe5077480
    li x3, 0xe5077480
    csrw 0xaa0, x3

    #Address 0xaa0 read value
    csrr x14, 0xaa0

    #Unmapped address 0xed testing: random write/read operations
    #Address 0xed read value
    csrr x14, 0xed

    #Address 0xed Write value 0xc653ab26
    li x3, 0xc653ab26
    csrw 0xed, x3

    #Address 0xed Write value 0xfdd9cd2d
    li x3, 0xfdd9cd2d
    csrw 0xed, x3

    #Address 0xed Write value 0x40d2d0a
    li x3, 0x40d2d0a
    csrw 0xed, x3

    #Address 0xed read value
    csrr x14, 0xed

    #Unmapped address 0x7f7 testing: random write/read operations
    #Address 0x7f7 read value
    csrr x14, 0x7f7

    #Address 0x7f7 Write value 0x68baae9e
    li x3, 0x68baae9e
    csrw 0x7f7, x3

    #Address 0x7f7 Write value 0xc45fb81b
    li x3, 0xc45fb81b
    csrw 0x7f7, x3

    #Mapped address 0xc00 (cycle) testing: random write/read operations
    #Address 0xc00 Write value 0x7f198e5f
    li x3, 0x7f198e5f
    csrw 0xc00, x3

    #Address 0xc00 Write value 0xf92333fd
    li x3, 0xf92333fd
    csrw 0xc00, x3

    #Address 0xc00 Write value 0x23555d02
    li x3, 0x23555d02
    csrw 0xc00, x3

    #Unmapped address 0x76b testing: random write/read operations
    #Address 0x76b Write value 0x15782bd5
    li x3, 0x15782bd5
    csrw 0x76b, x3

    #Address 0x76b read value
    csrr x14, 0x76b

    #Address 0x76b read value
    csrr x14, 0x76b

    #Unmapped address 0x12a testing: random write/read operations
    #Address 0x12a read value
    csrr x14, 0x12a

    #Unmapped address 0x69e testing: random write/read operations
    #Address 0x69e read value
    csrr x14, 0x69e

    #Address 0x69e read value
    csrr x14, 0x69e

    #Unmapped address 0xef7 testing: random write/read operations
    #Address 0xef7 read value
    csrr x14, 0xef7

    #Address 0xef7 Write value 0xdd475b4a
    li x3, 0xdd475b4a
    csrw 0xef7, x3

    #Address 0xef7 Write value 0x1bb9eea6
    li x3, 0x1bb9eea6
    csrw 0xef7, x3

    #Unmapped address 0xc2d testing: random write/read operations
    #Address 0xc2d Write value 0x81ee4fed
    li x3, 0x81ee4fed
    csrw 0xc2d, x3

    #Address 0xc2d Write value 0xc75294a5
    li x3, 0xc75294a5
    csrw 0xc2d, x3

    #Skipped Mapped address 0x305 (mtvec) because in user ignore list

    #Unmapped address 0xf80 testing: random write/read operations
    #Address 0xf80 read value
    csrr x14, 0xf80

    #Address 0xf80 Write value 0x284012db
    li x3, 0x284012db
    csrw 0xf80, x3

    #Address 0xf80 Write value 0x27ccfc20
    li x3, 0x27ccfc20
    csrw 0xf80, x3

    #Unmapped address 0x302 testing: random write/read operations
    #Address 0x302 read value
    csrr x14, 0x302

    #Unmapped address 0x21d testing: random write/read operations
    #Address 0x21d Write value 0xb5acd0bb
    li x3, 0xb5acd0bb
    csrw 0x21d, x3

    #Address 0x21d read value
    csrr x14, 0x21d

    #Address 0x21d Write value 0x8a1685f8
    li x3, 0x8a1685f8
    csrw 0x21d, x3

    #Address 0x21d Write value 0x537ae4bb
    li x3, 0x537ae4bb
    csrw 0x21d, x3

    #Address 0x21d read value
    csrr x14, 0x21d

    #Unmapped address 0x1cb testing: random write/read operations
    #Address 0x1cb Write value 0x9c43f464
    li x3, 0x9c43f464
    csrw 0x1cb, x3

    #Unmapped address 0xdf5 testing: random write/read operations
    #Address 0xdf5 read value
    csrr x14, 0xdf5

    #Address 0xdf5 Write value 0xef7beaff
    li x3, 0xef7beaff
    csrw 0xdf5, x3

    #Address 0xdf5 Write value 0x776cc745
    li x3, 0x776cc745
    csrw 0xdf5, x3

    #Address 0xdf5 Write value 0x567a71cf
    li x3, 0x567a71cf
    csrw 0xdf5, x3

    #Address 0xdf5 read value
    csrr x14, 0xdf5

    #Unmapped address 0x8da testing: random write/read operations
    #Address 0x8da Write value 0xa9edfc0
    li x3, 0xa9edfc0
    csrw 0x8da, x3

    #Address 0x8da read value
    csrr x14, 0x8da

    #Address 0x8da read value
    csrr x14, 0x8da

    #Address 0x8da Write value 0xf36c4e65
    li x3, 0xf36c4e65
    csrw 0x8da, x3

    #Address 0x8da Write value 0xe9f33735
    li x3, 0xe9f33735
    csrw 0x8da, x3

    #Unmapped address 0x87c testing: random write/read operations
    #Address 0x87c read value
    csrr x14, 0x87c

    #Address 0x87c Write value 0x1011c68b
    li x3, 0x1011c68b
    csrw 0x87c, x3

    #Address 0x87c read value
    csrr x14, 0x87c

    #Address 0x87c read value
    csrr x14, 0x87c

    #Address 0x87c Write value 0xe85b44df
    li x3, 0xe85b44df
    csrw 0x87c, x3

    #Unmapped address 0x731 testing: random write/read operations
    #Address 0x731 Write value 0x79f32e97
    li x3, 0x79f32e97
    csrw 0x731, x3

    #Address 0x731 read value
    csrr x14, 0x731

    #Address 0x731 read value
    csrr x14, 0x731

    #Address 0x731 Write value 0x517f2000
    li x3, 0x517f2000
    csrw 0x731, x3

    #Unmapped address 0x193 testing: random write/read operations
    #Address 0x193 Write value 0x42fbbe6d
    li x3, 0x42fbbe6d
    csrw 0x193, x3

    #Unmapped address 0x424 testing: random write/read operations
    #Address 0x424 read value
    csrr x14, 0x424

    #Address 0x424 Write value 0xaa4e0101
    li x3, 0xaa4e0101
    csrw 0x424, x3

    #Address 0x424 Write value 0x3df00d0a
    li x3, 0x3df00d0a
    csrw 0x424, x3

    #Address 0x424 read value
    csrr x14, 0x424

    #Address 0x424 Write value 0xe125e7b8
    li x3, 0xe125e7b8
    csrw 0x424, x3

    #Unmapped address 0xbad testing: random write/read operations
    #Address 0xbad Write value 0x6f165223
    li x3, 0x6f165223
    csrw 0xbad, x3

    #Address 0xbad Write value 0x6f1a9b74
    li x3, 0x6f1a9b74
    csrw 0xbad, x3

    #Address 0xbad read value
    csrr x14, 0xbad

    #Unmapped address 0x82b testing: random write/read operations
    #Address 0x82b read value
    csrr x14, 0x82b

    #Address 0x82b read value
    csrr x14, 0x82b

    #Address 0x82b Write value 0x23004b1e
    li x3, 0x23004b1e
    csrw 0x82b, x3

    #Address 0x82b Write value 0x5938d54f
    li x3, 0x5938d54f
    csrw 0x82b, x3

    #Unmapped address 0x243 testing: random write/read operations
    #Address 0x243 read value
    csrr x14, 0x243

    #Address 0x243 read value
    csrr x14, 0x243

    #Address 0x243 read value
    csrr x14, 0x243

    #Unmapped address 0x53a testing: random write/read operations
    #Address 0x53a Write value 0x8e120b
    li x3, 0x8e120b
    csrw 0x53a, x3

    #Address 0x53a read value
    csrr x14, 0x53a

    #Unmapped address 0x30 testing: random write/read operations
    #Address 0x30 Write value 0x3db5b929
    li x3, 0x3db5b929
    csrw 0x30, x3

    #Address 0x30 read value
    csrr x14, 0x30

    #Address 0x30 read value
    csrr x14, 0x30

    #Address 0x30 Write value 0xb8c8fac1
    li x3, 0xb8c8fac1
    csrw 0x30, x3

    #Unmapped address 0x1a3 testing: random write/read operations
    #Address 0x1a3 Write value 0x661d862
    li x3, 0x661d862
    csrw 0x1a3, x3

    #Address 0x1a3 read value
    csrr x14, 0x1a3

    #Address 0x1a3 Write value 0x9af04d76
    li x3, 0x9af04d76
    csrw 0x1a3, x3

    #Unmapped address 0xc6f testing: random write/read operations
    #Address 0xc6f Write value 0x59300703
    li x3, 0x59300703
    csrw 0xc6f, x3

    #Address 0xc6f read value
    csrr x14, 0xc6f

    #Address 0xc6f read value
    csrr x14, 0xc6f

    #Address 0xc6f read value
    csrr x14, 0xc6f

    #Address 0xc6f read value
    csrr x14, 0xc6f

    #Unmapped address 0xd3c testing: random write/read operations
    #Address 0xd3c read value
    csrr x14, 0xd3c

    #Address 0xd3c read value
    csrr x14, 0xd3c

    #Address 0xd3c read value
    csrr x14, 0xd3c

    #Address 0xd3c Write value 0x76872e57
    li x3, 0x76872e57
    csrw 0xd3c, x3

    #Address 0xd3c read value
    csrr x14, 0xd3c

    #Unmapped address 0x14 testing: random write/read operations
    #Address 0x14 read value
    csrr x14, 0x14

    #Address 0x14 read value
    csrr x14, 0x14

    #Address 0x14 Write value 0x9767e8a5
    li x3, 0x9767e8a5
    csrw 0x14, x3

    #Address 0x14 read value
    csrr x14, 0x14

    #Unmapped address 0xef9 testing: random write/read operations
    #Address 0xef9 Write value 0xaa606ff0
    li x3, 0xaa606ff0
    csrw 0xef9, x3

    #Unmapped address 0x7e7 testing: random write/read operations
    #Address 0x7e7 Write value 0x5d1c0fe6
    li x3, 0x5d1c0fe6
    csrw 0x7e7, x3

    #Address 0x7e7 Write value 0x7a7cc39d
    li x3, 0x7a7cc39d
    csrw 0x7e7, x3

    #Address 0x7e7 read value
    csrr x14, 0x7e7

    #Address 0x7e7 Write value 0x4cbbb964
    li x3, 0x4cbbb964
    csrw 0x7e7, x3

    #Unmapped address 0xdc5 testing: random write/read operations
    #Address 0xdc5 Write value 0x7ae977cc
    li x3, 0x7ae977cc
    csrw 0xdc5, x3

    #Address 0xdc5 Write value 0xb6861432
    li x3, 0xb6861432
    csrw 0xdc5, x3

    #Address 0xdc5 Write value 0xea7ef554
    li x3, 0xea7ef554
    csrw 0xdc5, x3

    #Address 0xdc5 read value
    csrr x14, 0xdc5

    #Unmapped address 0x810 testing: random write/read operations
    #Address 0x810 Write value 0xe5c02a61
    li x3, 0xe5c02a61
    csrw 0x810, x3

    #Address 0x810 Write value 0x77527b04
    li x3, 0x77527b04
    csrw 0x810, x3

    #Address 0x810 Write value 0x9de369fe
    li x3, 0x9de369fe
    csrw 0x810, x3

    #Unmapped address 0xff0 testing: random write/read operations
    #Address 0xff0 read value
    csrr x14, 0xff0

    #Address 0xff0 Write value 0xc3fa5452
    li x3, 0xc3fa5452
    csrw 0xff0, x3

    #Unmapped address 0xc33 testing: random write/read operations
    #Address 0xc33 Write value 0x9cc57796
    li x3, 0x9cc57796
    csrw 0xc33, x3

    #Address 0xc33 Write value 0xaac19aca
    li x3, 0xaac19aca
    csrw 0xc33, x3

    #Address 0xc33 Write value 0x76d56678
    li x3, 0x76d56678
    csrw 0xc33, x3

    #Unmapped address 0xbdc testing: random write/read operations
    #Address 0xbdc Write value 0x3e07c003
    li x3, 0x3e07c003
    csrw 0xbdc, x3

    #Address 0xbdc read value
    csrr x14, 0xbdc

    #Address 0xbdc Write value 0xbfbad78b
    li x3, 0xbfbad78b
    csrw 0xbdc, x3

    #Address 0xbdc Write value 0x5656a2a4
    li x3, 0x5656a2a4
    csrw 0xbdc, x3

    #Unmapped address 0x50 testing: random write/read operations
    #Address 0x50 Write value 0x86c1a462
    li x3, 0x86c1a462
    csrw 0x50, x3

    #Address 0x50 read value
    csrr x14, 0x50

    #Address 0x50 Write value 0x598f360
    li x3, 0x598f360
    csrw 0x50, x3

    #Address 0x50 read value
    csrr x14, 0x50

    #Unmapped address 0xfa4 testing: random write/read operations
    #Address 0xfa4 read value
    csrr x14, 0xfa4

    #Address 0xfa4 Write value 0xf727201b
    li x3, 0xf727201b
    csrw 0xfa4, x3

    #Address 0xfa4 Write value 0xabf4a9f2
    li x3, 0xabf4a9f2
    csrw 0xfa4, x3

    #Address 0xfa4 read value
    csrr x14, 0xfa4

    #Unmapped address 0x6d5 testing: random write/read operations
    #Address 0x6d5 read value
    csrr x14, 0x6d5

    #Unmapped address 0x684 testing: random write/read operations
    #Address 0x684 read value
    csrr x14, 0x684

    #Address 0x684 Write value 0x7bc79326
    li x3, 0x7bc79326
    csrw 0x684, x3

    #Address 0x684 Write value 0x7d5edb86
    li x3, 0x7d5edb86
    csrw 0x684, x3

    #Address 0x684 Write value 0x35f4d7c7
    li x3, 0x35f4d7c7
    csrw 0x684, x3

    #Unmapped address 0x80c testing: random write/read operations
    #Address 0x80c Write value 0x36de3bea
    li x3, 0x36de3bea
    csrw 0x80c, x3

    #Address 0x80c Write value 0x9d481bdd
    li x3, 0x9d481bdd
    csrw 0x80c, x3

    #Address 0x80c read value
    csrr x14, 0x80c

    #Unmapped address 0xd62 testing: random write/read operations
    #Address 0xd62 Write value 0xe049eb73
    li x3, 0xe049eb73
    csrw 0xd62, x3

    #Address 0xd62 Write value 0xff5593d9
    li x3, 0xff5593d9
    csrw 0xd62, x3

    #Address 0xd62 Write value 0xea362b9d
    li x3, 0xea362b9d
    csrw 0xd62, x3

    #Address 0xd62 read value
    csrr x14, 0xd62

    #Unmapped address 0x8d7 testing: random write/read operations
    #Address 0x8d7 read value
    csrr x14, 0x8d7

    #Address 0x8d7 Write value 0x1a2e615f
    li x3, 0x1a2e615f
    csrw 0x8d7, x3

    #Address 0x8d7 Write value 0x37e390e0
    li x3, 0x37e390e0
    csrw 0x8d7, x3

    #Unmapped address 0x1b0 testing: random write/read operations
    #Address 0x1b0 Write value 0xe99a498f
    li x3, 0xe99a498f
    csrw 0x1b0, x3

    #Address 0x1b0 read value
    csrr x14, 0x1b0

    #Address 0x1b0 Write value 0x273d7443
    li x3, 0x273d7443
    csrw 0x1b0, x3

    #Address 0x1b0 Write value 0x36d2c061
    li x3, 0x36d2c061
    csrw 0x1b0, x3

    #Unmapped address 0xbc3 testing: random write/read operations
    #Address 0xbc3 read value
    csrr x14, 0xbc3

    #Address 0xbc3 Write value 0xad00a487
    li x3, 0xad00a487
    csrw 0xbc3, x3

    #Address 0xbc3 Write value 0x6a4f10f0
    li x3, 0x6a4f10f0
    csrw 0xbc3, x3

    #Address 0xbc3 Write value 0xede10b2e
    li x3, 0xede10b2e
    csrw 0xbc3, x3

    #Address 0xbc3 Write value 0x93c1c34f
    li x3, 0x93c1c34f
    csrw 0xbc3, x3

    #Unmapped address 0x67b testing: random write/read operations
    #Address 0x67b read value
    csrr x14, 0x67b

    #Unmapped address 0x4cf testing: random write/read operations
    #Address 0x4cf read value
    csrr x14, 0x4cf

    #Address 0x4cf Write value 0x4d3841e3
    li x3, 0x4d3841e3
    csrw 0x4cf, x3

    #Address 0x4cf read value
    csrr x14, 0x4cf

    #Unmapped address 0x106 testing: random write/read operations
    #Address 0x106 Write value 0xe2a67a49
    li x3, 0xe2a67a49
    csrw 0x106, x3

    #Address 0x106 Write value 0x24bb6775
    li x3, 0x24bb6775
    csrw 0x106, x3

    #Address 0x106 read value
    csrr x14, 0x106

    #Address 0x106 read value
    csrr x14, 0x106

    #Address 0x106 Write value 0xbb39955f
    li x3, 0xbb39955f
    csrw 0x106, x3

    #Unmapped address 0x81c testing: random write/read operations
    #Address 0x81c Write value 0xe047982d
    li x3, 0xe047982d
    csrw 0x81c, x3

    #Address 0x81c Write value 0x695046a6
    li x3, 0x695046a6
    csrw 0x81c, x3

    #Address 0x81c read value
    csrr x14, 0x81c

    #Address 0x81c Write value 0xb067d2f
    li x3, 0xb067d2f
    csrw 0x81c, x3

    #Unmapped address 0x15d testing: random write/read operations
    #Address 0x15d Write value 0xbafdc40b
    li x3, 0xbafdc40b
    csrw 0x15d, x3

    #Address 0x15d Write value 0xa3681141
    li x3, 0xa3681141
    csrw 0x15d, x3

    #Address 0x15d Write value 0x8f01d92f
    li x3, 0x8f01d92f
    csrw 0x15d, x3

    #Unmapped address 0x5bc testing: random write/read operations
    #Address 0x5bc read value
    csrr x14, 0x5bc

    #Address 0x5bc Write value 0x2eaa5755
    li x3, 0x2eaa5755
    csrw 0x5bc, x3

    #Unmapped address 0x3f9 testing: random write/read operations
    #Address 0x3f9 Write value 0xca4ecfd3
    li x3, 0xca4ecfd3
    csrw 0x3f9, x3

    #Unmapped address 0x7c5 testing: random write/read operations
    #Address 0x7c5 Write value 0x37d5d027
    li x3, 0x37d5d027
    csrw 0x7c5, x3

    #Address 0x7c5 read value
    csrr x14, 0x7c5

    #Address 0x7c5 Write value 0xfd5825cc
    li x3, 0xfd5825cc
    csrw 0x7c5, x3

    #Address 0x7c5 Write value 0xd17ad682
    li x3, 0xd17ad682
    csrw 0x7c5, x3

    #Unmapped address 0x7ad testing: random write/read operations
    #Address 0x7ad read value
    csrr x14, 0x7ad

    #Address 0x7ad Write value 0xa6944462
    li x3, 0xa6944462
    csrw 0x7ad, x3

    #Address 0x7ad Write value 0x67f20526
    li x3, 0x67f20526
    csrw 0x7ad, x3

    #Address 0x7ad read value
    csrr x14, 0x7ad

    #Unmapped address 0x43f testing: random write/read operations
    #Address 0x43f read value
    csrr x14, 0x43f

    #Address 0x43f read value
    csrr x14, 0x43f

    #Address 0x43f Write value 0x13878367
    li x3, 0x13878367
    csrw 0x43f, x3

    #Address 0x43f read value
    csrr x14, 0x43f

    #Address 0x43f read value
    csrr x14, 0x43f

    #Unmapped address 0xdfa testing: random write/read operations
    #Address 0xdfa read value
    csrr x14, 0xdfa

    #Mapped address 0xb89 (mhpmcounterh9) testing: random write/read operations
    #Address 0xb89 read value
    csrr x14, 0xb89

    #Address 0xb89 Write value 0x8d45f043
    li x3, 0x8d45f043
    csrw 0xb89, x3

    #Address 0xb89 read value
    csrr x14, 0xb89

    #Address 0xb89 Write value 0x83ee5f3b
    li x3, 0x83ee5f3b
    csrw 0xb89, x3

    #Unmapped address 0x707 testing: random write/read operations
    #Address 0x707 read value
    csrr x14, 0x707

    #Address 0x707 Write value 0xa367ec80
    li x3, 0xa367ec80
    csrw 0x707, x3

    #Address 0x707 read value
    csrr x14, 0x707

    #Unmapped address 0x7a0 testing: random write/read operations
    #Address 0x7a0 Write value 0xa578f79e
    li x3, 0xa578f79e
    csrw 0x7a0, x3

    #Unmapped address 0x539 testing: random write/read operations
    #Address 0x539 Write value 0xeb30a7c4
    li x3, 0xeb30a7c4
    csrw 0x539, x3

    #Unmapped address 0x1d3 testing: random write/read operations
    #Address 0x1d3 Write value 0xa66a8e9f
    li x3, 0xa66a8e9f
    csrw 0x1d3, x3

    #Address 0x1d3 read value
    csrr x14, 0x1d3

    #Address 0x1d3 read value
    csrr x14, 0x1d3

    #Address 0x1d3 read value
    csrr x14, 0x1d3

    #Address 0x1d3 Write value 0xe7313670
    li x3, 0xe7313670
    csrw 0x1d3, x3

    #Unmapped address 0xaba testing: random write/read operations
    #Address 0xaba Write value 0xbee5f423
    li x3, 0xbee5f423
    csrw 0xaba, x3

    #Address 0xaba read value
    csrr x14, 0xaba

    #Unmapped address 0x2be testing: random write/read operations
    #Address 0x2be read value
    csrr x14, 0x2be

    #Unmapped address 0xe2c testing: random write/read operations
    #Address 0xe2c Write value 0x8d76d19
    li x3, 0x8d76d19
    csrw 0xe2c, x3

    #Address 0xe2c read value
    csrr x14, 0xe2c

    #Address 0xe2c Write value 0x9ddb30bf
    li x3, 0x9ddb30bf
    csrw 0xe2c, x3

    #Unmapped address 0x84f testing: random write/read operations
    #Address 0x84f Write value 0xa82bc640
    li x3, 0xa82bc640
    csrw 0x84f, x3

    #Address 0x84f read value
    csrr x14, 0x84f

    #Unmapped address 0xc41 testing: random write/read operations
    #Address 0xc41 Write value 0x1794f3ad
    li x3, 0x1794f3ad
    csrw 0xc41, x3

    #Address 0xc41 Write value 0xdf74cefe
    li x3, 0xdf74cefe
    csrw 0xc41, x3

    #Address 0xc41 Write value 0x9375f25f
    li x3, 0x9375f25f
    csrw 0xc41, x3

    #Address 0xc41 Write value 0x783675d0
    li x3, 0x783675d0
    csrw 0xc41, x3

    #Address 0xc41 read value
    csrr x14, 0xc41

    #Unmapped address 0xeca testing: random write/read operations
    #Address 0xeca Write value 0xab36f21
    li x3, 0xab36f21
    csrw 0xeca, x3

    #Address 0xeca Write value 0xd5a39050
    li x3, 0xd5a39050
    csrw 0xeca, x3

    #Address 0xeca Write value 0x5fa4fc93
    li x3, 0x5fa4fc93
    csrw 0xeca, x3

    #Address 0xeca Write value 0x2feec400
    li x3, 0x2feec400
    csrw 0xeca, x3

    #Unmapped address 0x7cb testing: random write/read operations
    #Address 0x7cb Write value 0x15b81379
    li x3, 0x15b81379
    csrw 0x7cb, x3

    #Address 0x7cb read value
    csrr x14, 0x7cb

    #Unmapped address 0xe30 testing: random write/read operations
    #Address 0xe30 Write value 0xb49b6b4f
    li x3, 0xb49b6b4f
    csrw 0xe30, x3

    #Address 0xe30 read value
    csrr x14, 0xe30

    #Unmapped address 0x51c testing: random write/read operations
    #Address 0x51c Write value 0x193e0143
    li x3, 0x193e0143
    csrw 0x51c, x3

    #Address 0x51c Write value 0xd95c975f
    li x3, 0xd95c975f
    csrw 0x51c, x3

    #Address 0x51c Write value 0x89a7a506
    li x3, 0x89a7a506
    csrw 0x51c, x3

    #Address 0x51c read value
    csrr x14, 0x51c

    #Unmapped address 0x98 testing: random write/read operations
    #Address 0x98 read value
    csrr x14, 0x98

    #Address 0x98 Write value 0xc13a7ce9
    li x3, 0xc13a7ce9
    csrw 0x98, x3

    #Address 0x98 read value
    csrr x14, 0x98

    #Address 0x98 Write value 0x3869d4e0
    li x3, 0x3869d4e0
    csrw 0x98, x3

    #Mapped address 0x7c0 (icache) testing: random write/read operations
    #Address 0x7c0 read value
    csrr x14, 0x7c0

    #Address 0x7c0 read value
    csrr x14, 0x7c0

    #Address 0x7c0 read value
    csrr x14, 0x7c0

    #Unmapped address 0xa9a testing: random write/read operations
    #Address 0xa9a read value
    csrr x14, 0xa9a

    #Address 0xa9a read value
    csrr x14, 0xa9a

    #Address 0xa9a read value
    csrr x14, 0xa9a

    #Address 0xa9a Write value 0x4e04cfc8
    li x3, 0x4e04cfc8
    csrw 0xa9a, x3

    #Address 0xa9a Write value 0x3bb515ff
    li x3, 0x3bb515ff
    csrw 0xa9a, x3

    #Unmapped address 0x69b testing: random write/read operations
    #Address 0x69b Write value 0x32a7ab91
    li x3, 0x32a7ab91
    csrw 0x69b, x3

    #Address 0x69b read value
    csrr x14, 0x69b

    #Address 0x69b read value
    csrr x14, 0x69b

    #Address 0x69b read value
    csrr x14, 0x69b

    #Unmapped address 0xb34 testing: random write/read operations
    #Address 0xb34 Write value 0x81666fb4
    li x3, 0x81666fb4
    csrw 0xb34, x3

    #Address 0xb34 Write value 0x54b0e13
    li x3, 0x54b0e13
    csrw 0xb34, x3

    #Address 0xb34 Write value 0x2e05f26e
    li x3, 0x2e05f26e
    csrw 0xb34, x3

    #Address 0xb34 read value
    csrr x14, 0xb34

    #Unmapped address 0x530 testing: random write/read operations
    #Address 0x530 Write value 0x83061365
    li x3, 0x83061365
    csrw 0x530, x3

    #Unmapped address 0x788 testing: random write/read operations
    #Address 0x788 Write value 0xa50836d3
    li x3, 0xa50836d3
    csrw 0x788, x3

    #Address 0x788 Write value 0x10ef2cd7
    li x3, 0x10ef2cd7
    csrw 0x788, x3

    #Address 0x788 read value
    csrr x14, 0x788

    #Unmapped address 0xfbb testing: random write/read operations
    #Address 0xfbb read value
    csrr x14, 0xfbb

    #Address 0xfbb Write value 0x719d99e0
    li x3, 0x719d99e0
    csrw 0xfbb, x3

    #Address 0xfbb Write value 0xdfadd38b
    li x3, 0xdfadd38b
    csrw 0xfbb, x3

    #Address 0xfbb Write value 0x7f4f718f
    li x3, 0x7f4f718f
    csrw 0xfbb, x3

    #Unmapped address 0x96 testing: random write/read operations
    #Address 0x96 read value
    csrr x14, 0x96

    #Address 0x96 read value
    csrr x14, 0x96

    #Address 0x96 read value
    csrr x14, 0x96

    #Address 0x96 read value
    csrr x14, 0x96

    #Unmapped address 0xca4 testing: random write/read operations
    #Address 0xca4 read value
    csrr x14, 0xca4

    #Address 0xca4 Write value 0x98277872
    li x3, 0x98277872
    csrw 0xca4, x3

    #Unmapped address 0x369 testing: random write/read operations
    #Address 0x369 read value
    csrr x14, 0x369

    #Address 0x369 Write value 0x5dfd375a
    li x3, 0x5dfd375a
    csrw 0x369, x3

    #Unmapped address 0x735 testing: random write/read operations
    #Address 0x735 read value
    csrr x14, 0x735

    #Address 0x735 read value
    csrr x14, 0x735

    #Unmapped address 0x3e testing: random write/read operations
    #Address 0x3e Write value 0xbee092ab
    li x3, 0xbee092ab
    csrw 0x3e, x3

    #Address 0x3e read value
    csrr x14, 0x3e

    #Address 0x3e read value
    csrr x14, 0x3e

    #Address 0x3e read value
    csrr x14, 0x3e

    #Address 0x3e Write value 0x53692e11
    li x3, 0x53692e11
    csrw 0x3e, x3

    #Unmapped address 0xb57 testing: random write/read operations
    #Address 0xb57 Write value 0x242ab978
    li x3, 0x242ab978
    csrw 0xb57, x3

    #Address 0xb57 Write value 0x53c5534e
    li x3, 0x53c5534e
    csrw 0xb57, x3

    #Address 0xb57 Write value 0xcbb1256a
    li x3, 0xcbb1256a
    csrw 0xb57, x3

    #Address 0xb57 read value
    csrr x14, 0xb57

    #Unmapped address 0xadd testing: random write/read operations
    #Address 0xadd Write value 0xa9f1e729
    li x3, 0xa9f1e729
    csrw 0xadd, x3

    #Address 0xadd Write value 0x9fbe3406
    li x3, 0x9fbe3406
    csrw 0xadd, x3

    #Address 0xadd Write value 0x302379a6
    li x3, 0x302379a6
    csrw 0xadd, x3

    #Unmapped address 0xe99 testing: random write/read operations
    #Address 0xe99 read value
    csrr x14, 0xe99

    #Address 0xe99 read value
    csrr x14, 0xe99

    #Unmapped address 0x1ba testing: random write/read operations
    #Address 0x1ba Write value 0x7bf34799
    li x3, 0x7bf34799
    csrw 0x1ba, x3

    #Address 0x1ba read value
    csrr x14, 0x1ba

    #Address 0x1ba read value
    csrr x14, 0x1ba

    #Address 0x1ba read value
    csrr x14, 0x1ba

    #Address 0x1ba Write value 0x416b2316
    li x3, 0x416b2316
    csrw 0x1ba, x3

    #Unmapped address 0xd7d testing: random write/read operations
    #Address 0xd7d read value
    csrr x14, 0xd7d

    #Address 0xd7d read value
    csrr x14, 0xd7d

    #Address 0xd7d read value
    csrr x14, 0xd7d

    #Unmapped address 0x54 testing: random write/read operations
    #Address 0x54 read value
    csrr x14, 0x54

    #Address 0x54 Write value 0x39e47537
    li x3, 0x39e47537
    csrw 0x54, x3

    #Address 0x54 read value
    csrr x14, 0x54

    #Unmapped address 0xb47 testing: random write/read operations
    #Address 0xb47 read value
    csrr x14, 0xb47

    #Unmapped address 0x9a7 testing: random write/read operations
    #Address 0x9a7 read value
    csrr x14, 0x9a7

    #Unmapped address 0x535 testing: random write/read operations
    #Address 0x535 read value
    csrr x14, 0x535

    #Address 0x535 read value
    csrr x14, 0x535

    #Unmapped address 0x1ac testing: random write/read operations
    #Address 0x1ac read value
    csrr x14, 0x1ac

    #Unmapped address 0xba6 testing: random write/read operations
    #Address 0xba6 read value
    csrr x14, 0xba6

    #Address 0xba6 read value
    csrr x14, 0xba6

    #Address 0xba6 read value
    csrr x14, 0xba6

    #Address 0xba6 read value
    csrr x14, 0xba6

    #Address 0xba6 Write value 0xf5217f4f
    li x3, 0xf5217f4f
    csrw 0xba6, x3

    #Unmapped address 0x314 testing: random write/read operations
    #Address 0x314 read value
    csrr x14, 0x314

    #Address 0x314 read value
    csrr x14, 0x314

    #Address 0x314 read value
    csrr x14, 0x314

    #Address 0x314 read value
    csrr x14, 0x314

    #Unmapped address 0x124 testing: random write/read operations
    #Address 0x124 Write value 0x7c3ec82e
    li x3, 0x7c3ec82e
    csrw 0x124, x3

    #Address 0x124 Write value 0x25c5d572
    li x3, 0x25c5d572
    csrw 0x124, x3

    #Address 0x124 Write value 0x62c1112c
    li x3, 0x62c1112c
    csrw 0x124, x3

    #Address 0x124 Write value 0x6f1582d0
    li x3, 0x6f1582d0
    csrw 0x124, x3

    #Address 0x124 read value
    csrr x14, 0x124

    #Unmapped address 0x8eb testing: random write/read operations
    #Address 0x8eb Write value 0x81cafbeb
    li x3, 0x81cafbeb
    csrw 0x8eb, x3

    #Address 0x8eb read value
    csrr x14, 0x8eb

    #Unmapped address 0xe0f testing: random write/read operations
    #Address 0xe0f Write value 0x56f0f7e1
    li x3, 0x56f0f7e1
    csrw 0xe0f, x3

    #Address 0xe0f read value
    csrr x14, 0xe0f

    #Address 0xe0f Write value 0xed28f7d1
    li x3, 0xed28f7d1
    csrw 0xe0f, x3

    #Address 0xe0f Write value 0xe6dfca3c
    li x3, 0xe6dfca3c
    csrw 0xe0f, x3

    #Address 0xe0f read value
    csrr x14, 0xe0f

    #Unmapped address 0xbd8 testing: random write/read operations
    #Address 0xbd8 Write value 0xe8c3c47c
    li x3, 0xe8c3c47c
    csrw 0xbd8, x3

    #Address 0xbd8 read value
    csrr x14, 0xbd8

    #Unmapped address 0x356 testing: random write/read operations
    #Address 0x356 read value
    csrr x14, 0x356

    #Address 0x356 Write value 0xef60a530
    li x3, 0xef60a530
    csrw 0x356, x3

    #Address 0x356 Write value 0x9506cefb
    li x3, 0x9506cefb
    csrw 0x356, x3

    #Address 0x356 read value
    csrr x14, 0x356

    #Unmapped address 0x7dc testing: random write/read operations
    #Address 0x7dc read value
    csrr x14, 0x7dc

    #Unmapped address 0xe0a testing: random write/read operations
    #Address 0xe0a read value
    csrr x14, 0xe0a

    #Address 0xe0a Write value 0x6c228232
    li x3, 0x6c228232
    csrw 0xe0a, x3

    #Address 0xe0a read value
    csrr x14, 0xe0a

    #Address 0xe0a read value
    csrr x14, 0xe0a

    #Unmapped address 0xfc5 testing: random write/read operations
    #Address 0xfc5 read value
    csrr x14, 0xfc5

    #Address 0xfc5 Write value 0xedaa3630
    li x3, 0xedaa3630
    csrw 0xfc5, x3

    #Address 0xfc5 Write value 0x2124b117
    li x3, 0x2124b117
    csrw 0xfc5, x3

    #Address 0xfc5 read value
    csrr x14, 0xfc5

    #Address 0xfc5 Write value 0x54400c30
    li x3, 0x54400c30
    csrw 0xfc5, x3

    #Unmapped address 0xd0e testing: random write/read operations
    #Address 0xd0e read value
    csrr x14, 0xd0e

    #Unmapped address 0x3aa testing: random write/read operations
    #Address 0x3aa read value
    csrr x14, 0x3aa

    #Address 0x3aa Write value 0xb5094378
    li x3, 0xb5094378
    csrw 0x3aa, x3

    #Address 0x3aa read value
    csrr x14, 0x3aa

    #Address 0x3aa Write value 0x4590d3b7
    li x3, 0x4590d3b7
    csrw 0x3aa, x3

    #Address 0x3aa Write value 0x55fea7bc
    li x3, 0x55fea7bc
    csrw 0x3aa, x3

    #Unmapped address 0x9f7 testing: random write/read operations
    #Address 0x9f7 Write value 0x28334ce3
    li x3, 0x28334ce3
    csrw 0x9f7, x3

    #Address 0x9f7 Write value 0x82857587
    li x3, 0x82857587
    csrw 0x9f7, x3

    #Address 0x9f7 Write value 0xa2b50095
    li x3, 0xa2b50095
    csrw 0x9f7, x3

    #Address 0x9f7 Write value 0xf9943eed
    li x3, 0xf9943eed
    csrw 0x9f7, x3

    #Address 0x9f7 Write value 0x4caea4c0
    li x3, 0x4caea4c0
    csrw 0x9f7, x3

    #Unmapped address 0xd27 testing: random write/read operations
    #Address 0xd27 Write value 0x7c29bdb
    li x3, 0x7c29bdb
    csrw 0xd27, x3

    #Address 0xd27 Write value 0x6f8b32c
    li x3, 0x6f8b32c
    csrw 0xd27, x3

    #Address 0xd27 read value
    csrr x14, 0xd27

    #Unmapped address 0xa4e testing: random write/read operations
    #Address 0xa4e read value
    csrr x14, 0xa4e

    #Address 0xa4e read value
    csrr x14, 0xa4e

    #Address 0xa4e read value
    csrr x14, 0xa4e

    #Address 0xa4e read value
    csrr x14, 0xa4e

    #Address 0xa4e read value
    csrr x14, 0xa4e

    #Unmapped address 0x754 testing: random write/read operations
    #Address 0x754 read value
    csrr x14, 0x754

    #Unmapped address 0xab3 testing: random write/read operations
    #Address 0xab3 read value
    csrr x14, 0xab3

    #Address 0xab3 Write value 0xcec039ab
    li x3, 0xcec039ab
    csrw 0xab3, x3

    #Unmapped address 0x7ce testing: random write/read operations
    #Address 0x7ce read value
    csrr x14, 0x7ce

    #Unmapped address 0xcaf testing: random write/read operations
    #Address 0xcaf read value
    csrr x14, 0xcaf

    #Address 0xcaf read value
    csrr x14, 0xcaf

    #Address 0xcaf read value
    csrr x14, 0xcaf

    #Address 0xcaf Write value 0x2b95ced9
    li x3, 0x2b95ced9
    csrw 0xcaf, x3

    #Unmapped address 0xea9 testing: random write/read operations
    #Address 0xea9 read value
    csrr x14, 0xea9

    #Address 0xea9 read value
    csrr x14, 0xea9

    #Address 0xea9 Write value 0x6dea88c3
    li x3, 0x6dea88c3
    csrw 0xea9, x3

    #Unmapped address 0x470 testing: random write/read operations
    #Address 0x470 read value
    csrr x14, 0x470

    #Unmapped address 0xc85 testing: random write/read operations
    #Address 0xc85 Write value 0x16bcc948
    li x3, 0x16bcc948
    csrw 0xc85, x3

    #Address 0xc85 read value
    csrr x14, 0xc85

    #Unmapped address 0x8ab testing: random write/read operations
    #Address 0x8ab read value
    csrr x14, 0x8ab

    #Address 0x8ab Write value 0xddcf0153
    li x3, 0xddcf0153
    csrw 0x8ab, x3

    #Address 0x8ab read value
    csrr x14, 0x8ab

    #Unmapped address 0xd15 testing: random write/read operations
    #Address 0xd15 Write value 0x81dfcf46
    li x3, 0x81dfcf46
    csrw 0xd15, x3

    #Address 0xd15 Write value 0xa16fb16b
    li x3, 0xa16fb16b
    csrw 0xd15, x3

    #Address 0xd15 read value
    csrr x14, 0xd15

    #Address 0xd15 read value
    csrr x14, 0xd15

    #Unmapped address 0xf2d testing: random write/read operations
    #Address 0xf2d Write value 0x2ec69d2a
    li x3, 0x2ec69d2a
    csrw 0xf2d, x3

    #Address 0xf2d read value
    csrr x14, 0xf2d

    #Unmapped address 0x451 testing: random write/read operations
    #Address 0x451 Write value 0x756c71b1
    li x3, 0x756c71b1
    csrw 0x451, x3

    #Unmapped address 0xa81 testing: random write/read operations
    #Address 0xa81 read value
    csrr x14, 0xa81

    #Address 0xa81 Write value 0xb7bd1a0f
    li x3, 0xb7bd1a0f
    csrw 0xa81, x3

    #Unmapped address 0x569 testing: random write/read operations
    #Address 0x569 Write value 0xe146a44b
    li x3, 0xe146a44b
    csrw 0x569, x3

    #Address 0x569 Write value 0x70d506c6
    li x3, 0x70d506c6
    csrw 0x569, x3

    #Unmapped address 0xcb1 testing: random write/read operations
    #Address 0xcb1 Write value 0xd758d75
    li x3, 0xd758d75
    csrw 0xcb1, x3

    #Address 0xcb1 Write value 0x2ae0e69d
    li x3, 0x2ae0e69d
    csrw 0xcb1, x3

    #Unmapped address 0x4fc testing: random write/read operations
    #Address 0x4fc read value
    csrr x14, 0x4fc

    #Address 0x4fc Write value 0x8d0e6923
    li x3, 0x8d0e6923
    csrw 0x4fc, x3

    #Address 0x4fc Write value 0x915a015f
    li x3, 0x915a015f
    csrw 0x4fc, x3

    #Address 0x4fc Write value 0x573a5344
    li x3, 0x573a5344
    csrw 0x4fc, x3

    #Address 0x4fc read value
    csrr x14, 0x4fc

    #Unmapped address 0x8fe testing: random write/read operations
    #Address 0x8fe read value
    csrr x14, 0x8fe

    #Address 0x8fe Write value 0x75e73b54
    li x3, 0x75e73b54
    csrw 0x8fe, x3

    #Address 0x8fe read value
    csrr x14, 0x8fe

    #Address 0x8fe read value
    csrr x14, 0x8fe

    #Address 0x8fe read value
    csrr x14, 0x8fe

    #Unmapped address 0x7e8 testing: random write/read operations
    #Address 0x7e8 Write value 0xbd9013a
    li x3, 0xbd9013a
    csrw 0x7e8, x3

    #Address 0x7e8 read value
    csrr x14, 0x7e8

    #Address 0x7e8 read value
    csrr x14, 0x7e8

    #Address 0x7e8 Write value 0x80d656e1
    li x3, 0x80d656e1
    csrw 0x7e8, x3

    #Unmapped address 0x80b testing: random write/read operations
    #Address 0x80b read value
    csrr x14, 0x80b

    #Address 0x80b Write value 0x8ea9d61
    li x3, 0x8ea9d61
    csrw 0x80b, x3

    #Address 0x80b read value
    csrr x14, 0x80b

    #Unmapped address 0x672 testing: random write/read operations
    #Address 0x672 read value
    csrr x14, 0x672

    #Address 0x672 Write value 0x32617af2
    li x3, 0x32617af2
    csrw 0x672, x3

    #Address 0x672 read value
    csrr x14, 0x672

    #Address 0x672 Write value 0x2b143ad4
    li x3, 0x2b143ad4
    csrw 0x672, x3

    #Address 0x672 read value
    csrr x14, 0x672

    #Unmapped address 0x35a testing: random write/read operations
    #Address 0x35a read value
    csrr x14, 0x35a

    #Unmapped address 0xdff testing: random write/read operations
    #Address 0xdff Write value 0xe5508b58
    li x3, 0xe5508b58
    csrw 0xdff, x3

    #Unmapped address 0xb52 testing: random write/read operations
    #Address 0xb52 Write value 0x3aad31b1
    li x3, 0x3aad31b1
    csrw 0xb52, x3

    #Address 0xb52 Write value 0x64b9a822
    li x3, 0x64b9a822
    csrw 0xb52, x3

    #Address 0xb52 read value
    csrr x14, 0xb52

    #Unmapped address 0x854 testing: random write/read operations
    #Address 0x854 read value
    csrr x14, 0x854

    #Address 0x854 read value
    csrr x14, 0x854

    #Address 0x854 Write value 0x3e29c1cc
    li x3, 0x3e29c1cc
    csrw 0x854, x3

    #Address 0x854 read value
    csrr x14, 0x854

    #Unmapped address 0xd35 testing: random write/read operations
    #Address 0xd35 Write value 0x54efa9a8
    li x3, 0x54efa9a8
    csrw 0xd35, x3

    #Unmapped address 0x223 testing: random write/read operations
    #Address 0x223 Write value 0x600fce6b
    li x3, 0x600fce6b
    csrw 0x223, x3

    #Address 0x223 Write value 0xcaca4ab3
    li x3, 0xcaca4ab3
    csrw 0x223, x3

    #Address 0x223 read value
    csrr x14, 0x223

    #Address 0x223 Write value 0x84c64fd3
    li x3, 0x84c64fd3
    csrw 0x223, x3

    #Unmapped address 0xf6a testing: random write/read operations
    #Address 0xf6a Write value 0x77586233
    li x3, 0x77586233
    csrw 0xf6a, x3

    #Address 0xf6a read value
    csrr x14, 0xf6a

    #Address 0xf6a read value
    csrr x14, 0xf6a

    #Address 0xf6a Write value 0xb1a24943
    li x3, 0xb1a24943
    csrw 0xf6a, x3

    #Unmapped address 0x625 testing: random write/read operations
    #Address 0x625 Write value 0x2ec9537e
    li x3, 0x2ec9537e
    csrw 0x625, x3

    #Address 0x625 read value
    csrr x14, 0x625

    #Address 0x625 Write value 0x596e2ac0
    li x3, 0x596e2ac0
    csrw 0x625, x3

    #Address 0x625 read value
    csrr x14, 0x625

    #Address 0x625 Write value 0x408b75bf
    li x3, 0x408b75bf
    csrw 0x625, x3

    #Unmapped address 0x4db testing: random write/read operations
    #Address 0x4db read value
    csrr x14, 0x4db

    #Address 0x4db Write value 0xf9421da6
    li x3, 0xf9421da6
    csrw 0x4db, x3

    #Address 0x4db Write value 0x81dddd3e
    li x3, 0x81dddd3e
    csrw 0x4db, x3

    #Address 0x4db read value
    csrr x14, 0x4db

    #Address 0x4db read value
    csrr x14, 0x4db

    #Unmapped address 0x5c5 testing: random write/read operations
    #Address 0x5c5 read value
    csrr x14, 0x5c5

    #Address 0x5c5 read value
    csrr x14, 0x5c5

    #Address 0x5c5 Write value 0x7f5121dc
    li x3, 0x7f5121dc
    csrw 0x5c5, x3

    #Unmapped address 0xfef testing: random write/read operations
    #Address 0xfef Write value 0x6e85c897
    li x3, 0x6e85c897
    csrw 0xfef, x3

    #Address 0xfef Write value 0xc06b563b
    li x3, 0xc06b563b
    csrw 0xfef, x3

    #Address 0xfef Write value 0x2e233820
    li x3, 0x2e233820
    csrw 0xfef, x3

    #Address 0xfef Write value 0x674f32b0
    li x3, 0x674f32b0
    csrw 0xfef, x3

    #Address 0xfef Write value 0x5978dbd7
    li x3, 0x5978dbd7
    csrw 0xfef, x3

    #Unmapped address 0xc72 testing: random write/read operations
    #Address 0xc72 Write value 0x4bb7a687
    li x3, 0x4bb7a687
    csrw 0xc72, x3

    #Unmapped address 0xa2c testing: random write/read operations
    #Address 0xa2c Write value 0xedfb82b
    li x3, 0xedfb82b
    csrw 0xa2c, x3

    #Address 0xa2c Write value 0x7df854a0
    li x3, 0x7df854a0
    csrw 0xa2c, x3

    #Address 0xa2c Write value 0xbb90c2c3
    li x3, 0xbb90c2c3
    csrw 0xa2c, x3

    #Address 0xa2c Write value 0x2ac3dc2c
    li x3, 0x2ac3dc2c
    csrw 0xa2c, x3

    #Unmapped address 0x91d testing: random write/read operations
    #Address 0x91d read value
    csrr x14, 0x91d

    #Unmapped address 0x893 testing: random write/read operations
    #Address 0x893 Write value 0x9996e847
    li x3, 0x9996e847
    csrw 0x893, x3

    #Unmapped address 0x8cd testing: random write/read operations
    #Address 0x8cd Write value 0x23552be5
    li x3, 0x23552be5
    csrw 0x8cd, x3

    #Address 0x8cd read value
    csrr x14, 0x8cd

    #Address 0x8cd read value
    csrr x14, 0x8cd

    #Address 0x8cd Write value 0x1d97a194
    li x3, 0x1d97a194
    csrw 0x8cd, x3

    #Address 0x8cd Write value 0x7ef0cf6
    li x3, 0x7ef0cf6
    csrw 0x8cd, x3

    #Unmapped address 0xc6b testing: random write/read operations
    #Address 0xc6b read value
    csrr x14, 0xc6b

    #Address 0xc6b read value
    csrr x14, 0xc6b

    #Address 0xc6b Write value 0xcc5be5a8
    li x3, 0xcc5be5a8
    csrw 0xc6b, x3

    #Address 0xc6b Write value 0xa8c356ef
    li x3, 0xa8c356ef
    csrw 0xc6b, x3

    #Unmapped address 0x464 testing: random write/read operations
    #Address 0x464 read value
    csrr x14, 0x464

    #Address 0x464 Write value 0x94e71f34
    li x3, 0x94e71f34
    csrw 0x464, x3

    #Address 0x464 read value
    csrr x14, 0x464

    #Address 0x464 Write value 0xb5889d9
    li x3, 0xb5889d9
    csrw 0x464, x3

    #Unmapped address 0xa54 testing: random write/read operations
    #Address 0xa54 read value
    csrr x14, 0xa54

    #Address 0xa54 Write value 0x78465bf7
    li x3, 0x78465bf7
    csrw 0xa54, x3

    #Address 0xa54 read value
    csrr x14, 0xa54

    #Unmapped address 0xa76 testing: random write/read operations
    #Address 0xa76 read value
    csrr x14, 0xa76

    #Address 0xa76 read value
    csrr x14, 0xa76

    #Unmapped address 0xc17 testing: random write/read operations
    #Address 0xc17 read value
    csrr x14, 0xc17

    #Address 0xc17 Write value 0x9b133eb
    li x3, 0x9b133eb
    csrw 0xc17, x3

    #Unmapped address 0x73 testing: random write/read operations
    #Address 0x73 Write value 0x3bf5283f
    li x3, 0x3bf5283f
    csrw 0x73, x3

    #Unmapped address 0x418 testing: random write/read operations
    #Address 0x418 read value
    csrr x14, 0x418

    #Address 0x418 Write value 0xc661441a
    li x3, 0xc661441a
    csrw 0x418, x3

    #Unmapped address 0xfd0 testing: random write/read operations
    #Address 0xfd0 read value
    csrr x14, 0xfd0

    #Address 0xfd0 Write value 0x6fd35af6
    li x3, 0x6fd35af6
    csrw 0xfd0, x3

    #Address 0xfd0 read value
    csrr x14, 0xfd0

    #Mapped address 0xb19 (mhpmcounter25) testing: random write/read operations
    #Address 0xb19 Write value 0xfd8d513b
    li x3, 0xfd8d513b
    csrw 0xb19, x3

    #Address 0xb19 Write value 0x8e61a58f
    li x3, 0x8e61a58f
    csrw 0xb19, x3

    #Address 0xb19 read value
    csrr x14, 0xb19

    #Address 0xb19 Write value 0xf11ff1e0
    li x3, 0xf11ff1e0
    csrw 0xb19, x3

    #Address 0xb19 Write value 0x96b859af
    li x3, 0x96b859af
    csrw 0xb19, x3

    #Unmapped address 0xb7e testing: random write/read operations
    #Address 0xb7e Write value 0xee8cc96c
    li x3, 0xee8cc96c
    csrw 0xb7e, x3

    #Address 0xb7e Write value 0xb78f112a
    li x3, 0xb78f112a
    csrw 0xb7e, x3

    #Address 0xb7e Write value 0x6e594310
    li x3, 0x6e594310
    csrw 0xb7e, x3

    #Address 0xb7e Write value 0x1f05344
    li x3, 0x1f05344
    csrw 0xb7e, x3

    #Address 0xb7e read value
    csrr x14, 0xb7e

    #Unmapped address 0x9f2 testing: random write/read operations
    #Address 0x9f2 Write value 0x9f628a2d
    li x3, 0x9f628a2d
    csrw 0x9f2, x3

    #Address 0x9f2 read value
    csrr x14, 0x9f2

    #Address 0x9f2 read value
    csrr x14, 0x9f2

    #Unmapped address 0x227 testing: random write/read operations
    #Address 0x227 read value
    csrr x14, 0x227

    #Address 0x227 Write value 0xac14d088
    li x3, 0xac14d088
    csrw 0x227, x3

    #Address 0x227 read value
    csrr x14, 0x227

    #Unmapped address 0xcbf testing: random write/read operations
    #Address 0xcbf read value
    csrr x14, 0xcbf

    #Unmapped address 0xb6d testing: random write/read operations
    #Address 0xb6d Write value 0x5d4aa8a5
    li x3, 0x5d4aa8a5
    csrw 0xb6d, x3

    #Address 0xb6d read value
    csrr x14, 0xb6d

    #Address 0xb6d read value
    csrr x14, 0xb6d

    #Unmapped address 0x221 testing: random write/read operations
    #Address 0x221 Write value 0x8674eda
    li x3, 0x8674eda
    csrw 0x221, x3

    #Address 0x221 Write value 0xbed3bcdc
    li x3, 0xbed3bcdc
    csrw 0x221, x3

    #Address 0x221 read value
    csrr x14, 0x221

    #Unmapped address 0xbb5 testing: random write/read operations
    #Address 0xbb5 read value
    csrr x14, 0xbb5

    #Address 0xbb5 read value
    csrr x14, 0xbb5

    #Unmapped address 0x5ce testing: random write/read operations
    #Address 0x5ce Write value 0x5fce66ab
    li x3, 0x5fce66ab
    csrw 0x5ce, x3

    #Unmapped address 0xb53 testing: random write/read operations
    #Address 0xb53 read value
    csrr x14, 0xb53

    #Address 0xb53 read value
    csrr x14, 0xb53

    #Address 0xb53 read value
    csrr x14, 0xb53

    #Address 0xb53 read value
    csrr x14, 0xb53

    #Unmapped address 0xae9 testing: random write/read operations
    #Address 0xae9 read value
    csrr x14, 0xae9

    #Address 0xae9 Write value 0x63e76367
    li x3, 0x63e76367
    csrw 0xae9, x3

    #Address 0xae9 read value
    csrr x14, 0xae9

    #Unmapped address 0x5c0 testing: random write/read operations
    #Address 0x5c0 Write value 0x4048f669
    li x3, 0x4048f669
    csrw 0x5c0, x3

    #Address 0x5c0 Write value 0x494b2769
    li x3, 0x494b2769
    csrw 0x5c0, x3

    #Address 0x5c0 Write value 0x695f4aa6
    li x3, 0x695f4aa6
    csrw 0x5c0, x3

    #Address 0x5c0 read value
    csrr x14, 0x5c0

    #Mapped address 0x3b3 (pmpaddr3) testing: random write/read operations
    #Address 0x3b3 read value
    csrr x14, 0x3b3

    #Address 0x3b3 read value
    csrr x14, 0x3b3

    #Address 0x3b3 read value
    csrr x14, 0x3b3

    #Unmapped address 0x3c9 testing: random write/read operations
    #Address 0x3c9 Write value 0xd07b8fb5
    li x3, 0xd07b8fb5
    csrw 0x3c9, x3

    #Address 0x3c9 read value
    csrr x14, 0x3c9

    #Address 0x3c9 Write value 0x37d7b984
    li x3, 0x37d7b984
    csrw 0x3c9, x3

    #Address 0x3c9 read value
    csrr x14, 0x3c9

    #Address 0x3c9 Write value 0xd51b8cde
    li x3, 0xd51b8cde
    csrw 0x3c9, x3

    #Unmapped address 0x49d testing: random write/read operations
    #Address 0x49d Write value 0xa25018ab
    li x3, 0xa25018ab
    csrw 0x49d, x3

    #Address 0x49d read value
    csrr x14, 0x49d

    #Unmapped address 0x2aa testing: random write/read operations
    #Address 0x2aa read value
    csrr x14, 0x2aa

    #Address 0x2aa Write value 0xd2dcbaf7
    li x3, 0xd2dcbaf7
    csrw 0x2aa, x3

    #Unmapped address 0xce testing: random write/read operations
    #Address 0xce Write value 0x510057fe
    li x3, 0x510057fe
    csrw 0xce, x3

    #Address 0xce Write value 0x767aa0c8
    li x3, 0x767aa0c8
    csrw 0xce, x3

    #Address 0xce Write value 0x11a10bf1
    li x3, 0x11a10bf1
    csrw 0xce, x3

    #Address 0xce read value
    csrr x14, 0xce

    #Unmapped address 0xfed testing: random write/read operations
    #Address 0xfed read value
    csrr x14, 0xfed

    #Address 0xfed read value
    csrr x14, 0xfed

    #Unmapped address 0x49f testing: random write/read operations
    #Address 0x49f read value
    csrr x14, 0x49f

    #Unmapped address 0x47a testing: random write/read operations
    #Address 0x47a Write value 0xa9b6d740
    li x3, 0xa9b6d740
    csrw 0x47a, x3

    #Address 0x47a read value
    csrr x14, 0x47a

    #Address 0x47a Write value 0x39f5c3f3
    li x3, 0x39f5c3f3
    csrw 0x47a, x3

    #Address 0x47a Write value 0x1855722c
    li x3, 0x1855722c
    csrw 0x47a, x3

    #Unmapped address 0x5c2 testing: random write/read operations
    #Address 0x5c2 read value
    csrr x14, 0x5c2

    #Address 0x5c2 read value
    csrr x14, 0x5c2

    #Address 0x5c2 read value
    csrr x14, 0x5c2

    #Unmapped address 0x3af testing: random write/read operations
    #Address 0x3af Write value 0xa298827
    li x3, 0xa298827
    csrw 0x3af, x3

    #Address 0x3af Write value 0x502ec6a2
    li x3, 0x502ec6a2
    csrw 0x3af, x3

    #Address 0x3af read value
    csrr x14, 0x3af

    #Unmapped address 0xfec testing: random write/read operations
    #Address 0xfec read value
    csrr x14, 0xfec

    #Unmapped address 0xa14 testing: random write/read operations
    #Address 0xa14 read value
    csrr x14, 0xa14

    #Address 0xa14 Write value 0x62ed90f2
    li x3, 0x62ed90f2
    csrw 0xa14, x3

    #Address 0xa14 Write value 0xc0a4a2ad
    li x3, 0xc0a4a2ad
    csrw 0xa14, x3

    #Address 0xa14 read value
    csrr x14, 0xa14

    #Unmapped address 0x23a testing: random write/read operations
    #Address 0x23a read value
    csrr x14, 0x23a

    #Address 0x23a read value
    csrr x14, 0x23a

    #Address 0x23a read value
    csrr x14, 0x23a

    #Address 0x23a read value
    csrr x14, 0x23a

    #Unmapped address 0xbe3 testing: random write/read operations
    #Address 0xbe3 Write value 0x9b2feeb1
    li x3, 0x9b2feeb1
    csrw 0xbe3, x3

    #Address 0xbe3 Write value 0x54d19b26
    li x3, 0x54d19b26
    csrw 0xbe3, x3

    #Address 0xbe3 Write value 0xe4d5b208
    li x3, 0xe4d5b208
    csrw 0xbe3, x3

    #Address 0xbe3 read value
    csrr x14, 0xbe3

    #Address 0xbe3 Write value 0xb0ac3532
    li x3, 0xb0ac3532
    csrw 0xbe3, x3

    #Unmapped address 0x73e testing: random write/read operations
    #Address 0x73e Write value 0xb80ca9c3
    li x3, 0xb80ca9c3
    csrw 0x73e, x3

    #Address 0x73e Write value 0x9e9043b8
    li x3, 0x9e9043b8
    csrw 0x73e, x3

    #Address 0x73e read value
    csrr x14, 0x73e

    #Address 0x73e Write value 0x6fe5e11
    li x3, 0x6fe5e11
    csrw 0x73e, x3

    #Address 0x73e Write value 0x1ff8d0d2
    li x3, 0x1ff8d0d2
    csrw 0x73e, x3

    #Unmapped address 0xa7d testing: random write/read operations
    #Address 0xa7d Write value 0x6f076bac
    li x3, 0x6f076bac
    csrw 0xa7d, x3

    #Address 0xa7d Write value 0x2054348b
    li x3, 0x2054348b
    csrw 0xa7d, x3

    #Address 0xa7d read value
    csrr x14, 0xa7d

    #Unmapped address 0xdb3 testing: random write/read operations
    #Address 0xdb3 Write value 0x75a156ff
    li x3, 0x75a156ff
    csrw 0xdb3, x3

    #Address 0xdb3 Write value 0xea250733
    li x3, 0xea250733
    csrw 0xdb3, x3

    #Address 0xdb3 Write value 0x211d175c
    li x3, 0x211d175c
    csrw 0xdb3, x3

    #Unmapped address 0xebc testing: random write/read operations
    #Address 0xebc read value
    csrr x14, 0xebc

    #Unmapped address 0x444 testing: random write/read operations
    #Address 0x444 read value
    csrr x14, 0x444

    #Address 0x444 read value
    csrr x14, 0x444

    #Unmapped address 0x1c7 testing: random write/read operations
    #Address 0x1c7 Write value 0xc8443052
    li x3, 0xc8443052
    csrw 0x1c7, x3

    #Address 0x1c7 read value
    csrr x14, 0x1c7

    #Address 0x1c7 Write value 0x955f6ab5
    li x3, 0x955f6ab5
    csrw 0x1c7, x3

    #Unmapped address 0xa6b testing: random write/read operations
    #Address 0xa6b Write value 0xbbbd80c3
    li x3, 0xbbbd80c3
    csrw 0xa6b, x3

    #Address 0xa6b Write value 0xc234b397
    li x3, 0xc234b397
    csrw 0xa6b, x3

    #Address 0xa6b Write value 0x92c89c55
    li x3, 0x92c89c55
    csrw 0xa6b, x3

    #Address 0xa6b Write value 0xbf9f526c
    li x3, 0xbf9f526c
    csrw 0xa6b, x3

    #Unmapped address 0x390 testing: random write/read operations
    #Address 0x390 Write value 0x88360a5c
    li x3, 0x88360a5c
    csrw 0x390, x3

    #Unmapped address 0x38e testing: random write/read operations
    #Address 0x38e read value
    csrr x14, 0x38e

    #Address 0x38e read value
    csrr x14, 0x38e

    #Address 0x38e read value
    csrr x14, 0x38e

    #Unmapped address 0x6e3 testing: random write/read operations
    #Address 0x6e3 Write value 0x50b218eb
    li x3, 0x50b218eb
    csrw 0x6e3, x3

    #Address 0x6e3 read value
    csrr x14, 0x6e3

    #Address 0x6e3 Write value 0x9b09b6d3
    li x3, 0x9b09b6d3
    csrw 0x6e3, x3

    #Address 0x6e3 Write value 0xd55727fd
    li x3, 0xd55727fd
    csrw 0x6e3, x3

    #Unmapped address 0xbf7 testing: random write/read operations
    #Address 0xbf7 Write value 0xe7e44b14
    li x3, 0xe7e44b14
    csrw 0xbf7, x3

    #Unmapped address 0x93a testing: random write/read operations
    #Address 0x93a read value
    csrr x14, 0x93a

    #Unmapped address 0xd3a testing: random write/read operations
    #Address 0xd3a Write value 0x5624f8c5
    li x3, 0x5624f8c5
    csrw 0xd3a, x3

    #Address 0xd3a read value
    csrr x14, 0xd3a

    #Unmapped address 0xf9f testing: random write/read operations
    #Address 0xf9f read value
    csrr x14, 0xf9f

    #Unmapped address 0xa6e testing: random write/read operations
    #Address 0xa6e read value
    csrr x14, 0xa6e

    #Address 0xa6e Write value 0xf12ff5fa
    li x3, 0xf12ff5fa
    csrw 0xa6e, x3

    #Address 0xa6e Write value 0xae81eb59
    li x3, 0xae81eb59
    csrw 0xa6e, x3

    #Address 0xa6e read value
    csrr x14, 0xa6e

    #Unmapped address 0x2c3 testing: random write/read operations
    #Address 0x2c3 read value
    csrr x14, 0x2c3

    #Unmapped address 0xc44 testing: random write/read operations
    #Address 0xc44 Write value 0xd6632dcf
    li x3, 0xd6632dcf
    csrw 0xc44, x3

    #Unmapped address 0xb76 testing: random write/read operations
    #Address 0xb76 Write value 0x73bae063
    li x3, 0x73bae063
    csrw 0xb76, x3

    #Address 0xb76 read value
    csrr x14, 0xb76

    #Address 0xb76 Write value 0x2a41cd41
    li x3, 0x2a41cd41
    csrw 0xb76, x3

    #Address 0xb76 read value
    csrr x14, 0xb76

    #Unmapped address 0x8d testing: random write/read operations
    #Address 0x8d read value
    csrr x14, 0x8d

    #Address 0x8d Write value 0x7b6f3599
    li x3, 0x7b6f3599
    csrw 0x8d, x3

    #Address 0x8d Write value 0x1984756a
    li x3, 0x1984756a
    csrw 0x8d, x3

    #Address 0x8d read value
    csrr x14, 0x8d

    #Address 0x8d Write value 0x8bdfa953
    li x3, 0x8bdfa953
    csrw 0x8d, x3

    #Unmapped address 0x764 testing: random write/read operations
    #Address 0x764 read value
    csrr x14, 0x764

    #Unmapped address 0xb71 testing: random write/read operations
    #Address 0xb71 read value
    csrr x14, 0xb71

    #Mapped address 0x3a1 (pmpcfg1) testing: random write/read operations
    #Address 0x3a1 read value
    csrr x14, 0x3a1

    #Address 0x3a1 read value
    csrr x14, 0x3a1

    #Address 0x3a1 Write value 0xcd44a406
    li x3, 0xcd44a406
    csrw 0x3a1, x3

    #Address 0x3a1 Write value 0xd7e16219
    li x3, 0xd7e16219
    csrw 0x3a1, x3

    #Unmapped address 0xc1c testing: random write/read operations
    #Address 0xc1c read value
    csrr x14, 0xc1c

    #Unmapped address 0xe81 testing: random write/read operations
    #Address 0xe81 read value
    csrr x14, 0xe81

    #Address 0xe81 read value
    csrr x14, 0xe81

    #Unmapped address 0x64 testing: random write/read operations
    #Address 0x64 read value
    csrr x14, 0x64

    #Address 0x64 Write value 0x97c784b5
    li x3, 0x97c784b5
    csrw 0x64, x3

    #Address 0x64 read value
    csrr x14, 0x64

    #Address 0x64 Write value 0x4a4ee5e5
    li x3, 0x4a4ee5e5
    csrw 0x64, x3

    #Address 0x64 read value
    csrr x14, 0x64

    #Unmapped address 0x610 testing: random write/read operations
    #Address 0x610 Write value 0x46356ed2
    li x3, 0x46356ed2
    csrw 0x610, x3

    #Address 0x610 Write value 0xb13ac9fb
    li x3, 0xb13ac9fb
    csrw 0x610, x3

    #Unmapped address 0x83e testing: random write/read operations
    #Address 0x83e read value
    csrr x14, 0x83e

    #Address 0x83e read value
    csrr x14, 0x83e

    #Unmapped address 0x90e testing: random write/read operations
    #Address 0x90e Write value 0x93b8dcea
    li x3, 0x93b8dcea
    csrw 0x90e, x3

    #Address 0x90e read value
    csrr x14, 0x90e

    #Address 0x90e Write value 0x5c490f11
    li x3, 0x5c490f11
    csrw 0x90e, x3

    #Address 0x90e read value
    csrr x14, 0x90e

    #Address 0x90e Write value 0x67812944
    li x3, 0x67812944
    csrw 0x90e, x3

    #Unmapped address 0x965 testing: random write/read operations
    #Address 0x965 read value
    csrr x14, 0x965

    #Address 0x965 read value
    csrr x14, 0x965

    #Address 0x965 Write value 0xf02b1267
    li x3, 0xf02b1267
    csrw 0x965, x3

    #Address 0x965 read value
    csrr x14, 0x965

    #Address 0x965 Write value 0xe91342bb
    li x3, 0xe91342bb
    csrw 0x965, x3

    #Unmapped address 0x678 testing: random write/read operations
    #Address 0x678 read value
    csrr x14, 0x678

    #Unmapped address 0x4d2 testing: random write/read operations
    #Address 0x4d2 read value
    csrr x14, 0x4d2

    #Address 0x4d2 Write value 0x878fd980
    li x3, 0x878fd980
    csrw 0x4d2, x3

    #Address 0x4d2 Write value 0x5a42262d
    li x3, 0x5a42262d
    csrw 0x4d2, x3

    #Address 0x4d2 Write value 0x5e84c677
    li x3, 0x5e84c677
    csrw 0x4d2, x3

    #Address 0x4d2 Write value 0xc2abf5dc
    li x3, 0xc2abf5dc
    csrw 0x4d2, x3

    #Unmapped address 0xe13 testing: random write/read operations
    #Address 0xe13 read value
    csrr x14, 0xe13

    #Address 0xe13 Write value 0xd74ac823
    li x3, 0xd74ac823
    csrw 0xe13, x3

    #Unmapped address 0xfcf testing: random write/read operations
    #Address 0xfcf read value
    csrr x14, 0xfcf

    #Address 0xfcf Write value 0xea6fc94
    li x3, 0xea6fc94
    csrw 0xfcf, x3

    #Address 0xfcf read value
    csrr x14, 0xfcf

    #Address 0xfcf read value
    csrr x14, 0xfcf

    #Address 0xfcf read value
    csrr x14, 0xfcf

    #Unmapped address 0x44f testing: random write/read operations
    #Address 0x44f read value
    csrr x14, 0x44f

    #Address 0x44f Write value 0x7ba5387f
    li x3, 0x7ba5387f
    csrw 0x44f, x3

    #Unmapped address 0x6d9 testing: random write/read operations
    #Address 0x6d9 Write value 0x16679b37
    li x3, 0x16679b37
    csrw 0x6d9, x3

    #Address 0x6d9 Write value 0x8ccdbdfb
    li x3, 0x8ccdbdfb
    csrw 0x6d9, x3

    #Unmapped address 0x9d testing: random write/read operations
    #Address 0x9d read value
    csrr x14, 0x9d

    #Address 0x9d read value
    csrr x14, 0x9d

    #Unmapped address 0xd8 testing: random write/read operations
    #Address 0xd8 read value
    csrr x14, 0xd8

    #Address 0xd8 read value
    csrr x14, 0xd8

    #Address 0xd8 Write value 0x15032a7b
    li x3, 0x15032a7b
    csrw 0xd8, x3

    #Address 0xd8 read value
    csrr x14, 0xd8

    #Address 0xd8 read value
    csrr x14, 0xd8

    #Unmapped address 0x9c6 testing: random write/read operations
    #Address 0x9c6 read value
    csrr x14, 0x9c6

    #Address 0x9c6 Write value 0xff1800fc
    li x3, 0xff1800fc
    csrw 0x9c6, x3

    #Address 0x9c6 Write value 0x3401a973
    li x3, 0x3401a973
    csrw 0x9c6, x3

    #Unmapped address 0x307 testing: random write/read operations
    #Address 0x307 Write value 0xb6306fa3
    li x3, 0xb6306fa3
    csrw 0x307, x3

    #Address 0x307 read value
    csrr x14, 0x307

    #Address 0x307 Write value 0x770f4de2
    li x3, 0x770f4de2
    csrw 0x307, x3

    #Unmapped address 0x4dc testing: random write/read operations
    #Address 0x4dc read value
    csrr x14, 0x4dc

    #Address 0x4dc Write value 0xf112fb0e
    li x3, 0xf112fb0e
    csrw 0x4dc, x3

    #Address 0x4dc read value
    csrr x14, 0x4dc

    #Address 0x4dc Write value 0x907b00d5
    li x3, 0x907b00d5
    csrw 0x4dc, x3

    #Address 0x4dc Write value 0x107f190f
    li x3, 0x107f190f
    csrw 0x4dc, x3

    #Unmapped address 0x48 testing: random write/read operations
    #Address 0x48 read value
    csrr x14, 0x48

    #Mapped address 0x33b (mhpmevent27) testing: random write/read operations
    #Address 0x33b Write value 0x7765e563
    li x3, 0x7765e563
    csrw 0x33b, x3

    #Address 0x33b read value
    csrr x14, 0x33b

    #Address 0x33b read value
    csrr x14, 0x33b

    #Unmapped address 0xdcc testing: random write/read operations
    #Address 0xdcc read value
    csrr x14, 0xdcc

    #Address 0xdcc Write value 0x82a6d771
    li x3, 0x82a6d771
    csrw 0xdcc, x3

    #Address 0xdcc read value
    csrr x14, 0xdcc

    #Address 0xdcc Write value 0x8b38b963
    li x3, 0x8b38b963
    csrw 0xdcc, x3

    #Unmapped address 0xec4 testing: random write/read operations
    #Address 0xec4 read value
    csrr x14, 0xec4

    #Address 0xec4 Write value 0x2d09e055
    li x3, 0x2d09e055
    csrw 0xec4, x3

    #Unmapped address 0x84b testing: random write/read operations
    #Address 0x84b Write value 0xf4c5c331
    li x3, 0xf4c5c331
    csrw 0x84b, x3

    #Address 0x84b Write value 0x6f7ea547
    li x3, 0x6f7ea547
    csrw 0x84b, x3

    #Unmapped address 0x346 testing: random write/read operations
    #Address 0x346 Write value 0x8752a540
    li x3, 0x8752a540
    csrw 0x346, x3

    #Address 0x346 read value
    csrr x14, 0x346

    #Address 0x346 Write value 0xc7dcf94e
    li x3, 0xc7dcf94e
    csrw 0x346, x3

    #Unmapped address 0xc2c testing: random write/read operations
    #Address 0xc2c Write value 0xabb299c
    li x3, 0xabb299c
    csrw 0xc2c, x3

    #Unmapped address 0xf7e testing: random write/read operations
    #Address 0xf7e Write value 0xda61b743
    li x3, 0xda61b743
    csrw 0xf7e, x3

    #Address 0xf7e Write value 0xa5b01a73
    li x3, 0xa5b01a73
    csrw 0xf7e, x3

    #Address 0xf7e Write value 0x3daccb57
    li x3, 0x3daccb57
    csrw 0xf7e, x3

    #Unmapped address 0x3c5 testing: random write/read operations
    #Address 0x3c5 read value
    csrr x14, 0x3c5

    #Address 0x3c5 Write value 0xa2e087ad
    li x3, 0xa2e087ad
    csrw 0x3c5, x3

    #Unmapped address 0x57a testing: random write/read operations
    #Address 0x57a Write value 0x6d2311ee
    li x3, 0x6d2311ee
    csrw 0x57a, x3

    #Unmapped address 0xa3a testing: random write/read operations
    #Address 0xa3a read value
    csrr x14, 0xa3a

    #Address 0xa3a read value
    csrr x14, 0xa3a

    #Unmapped address 0x98b testing: random write/read operations
    #Address 0x98b Write value 0x16c76d14
    li x3, 0x16c76d14
    csrw 0x98b, x3

    #Address 0x98b Write value 0x19930981
    li x3, 0x19930981
    csrw 0x98b, x3

    #Address 0x98b Write value 0x9e447e61
    li x3, 0x9e447e61
    csrw 0x98b, x3

    #Unmapped address 0x11c testing: random write/read operations
    #Address 0x11c read value
    csrr x14, 0x11c

    #Address 0x11c read value
    csrr x14, 0x11c

    #Address 0x11c read value
    csrr x14, 0x11c

    #Unmapped address 0x14c testing: random write/read operations
    #Address 0x14c read value
    csrr x14, 0x14c

    #Unmapped address 0x1c5 testing: random write/read operations
    #Address 0x1c5 Write value 0x93a5422d
    li x3, 0x93a5422d
    csrw 0x1c5, x3

    #Address 0x1c5 Write value 0x2d474c
    li x3, 0x2d474c
    csrw 0x1c5, x3

    #Address 0x1c5 read value
    csrr x14, 0x1c5

    #Unmapped address 0x18a testing: random write/read operations
    #Address 0x18a Write value 0xb107477a
    li x3, 0xb107477a
    csrw 0x18a, x3

    #Address 0x18a Write value 0xa23c05b5
    li x3, 0xa23c05b5
    csrw 0x18a, x3

    #Address 0x18a read value
    csrr x14, 0x18a

    #Address 0x18a read value
    csrr x14, 0x18a

    #Address 0x18a Write value 0x2881097f
    li x3, 0x2881097f
    csrw 0x18a, x3

    #Unmapped address 0xb3d testing: random write/read operations
    #Address 0xb3d Write value 0x7114675d
    li x3, 0x7114675d
    csrw 0xb3d, x3

    #Unmapped address 0x6b9 testing: random write/read operations
    #Address 0x6b9 Write value 0xfac85651
    li x3, 0xfac85651
    csrw 0x6b9, x3

    #Address 0x6b9 Write value 0xb7d6a87
    li x3, 0xb7d6a87
    csrw 0x6b9, x3

    #Address 0x6b9 read value
    csrr x14, 0x6b9

    #Unmapped address 0xc5 testing: random write/read operations
    #Address 0xc5 read value
    csrr x14, 0xc5

    #Address 0xc5 Write value 0xd361d483
    li x3, 0xd361d483
    csrw 0xc5, x3

    #Mapped address 0xb8d (mhpmcounterh13) testing: random write/read operations
    #Address 0xb8d Write value 0xd763afbb
    li x3, 0xd763afbb
    csrw 0xb8d, x3

    #Unmapped address 0x7fd testing: random write/read operations
    #Address 0x7fd read value
    csrr x14, 0x7fd

    #Address 0x7fd Write value 0x430744bb
    li x3, 0x430744bb
    csrw 0x7fd, x3

    #Address 0x7fd read value
    csrr x14, 0x7fd

    #Address 0x7fd read value
    csrr x14, 0x7fd

    #Address 0x7fd read value
    csrr x14, 0x7fd

    #Unmapped address 0xb28 testing: random write/read operations
    #Address 0xb28 Write value 0x88ef648
    li x3, 0x88ef648
    csrw 0xb28, x3

    #Address 0xb28 Write value 0xf5d0fdb5
    li x3, 0xf5d0fdb5
    csrw 0xb28, x3

    #Address 0xb28 Write value 0xf6c31f30
    li x3, 0xf6c31f30
    csrw 0xb28, x3

    #Address 0xb28 Write value 0xa6d7ac49
    li x3, 0xa6d7ac49
    csrw 0xb28, x3

    #Address 0xb28 Write value 0x68699fdf
    li x3, 0x68699fdf
    csrw 0xb28, x3

    #Unmapped address 0xd84 testing: random write/read operations
    #Address 0xd84 Write value 0x5f0a1bfe
    li x3, 0x5f0a1bfe
    csrw 0xd84, x3

    #Address 0xd84 Write value 0x2abc3c32
    li x3, 0x2abc3c32
    csrw 0xd84, x3

    #Unmapped address 0x532 testing: random write/read operations
    #Address 0x532 Write value 0x11b7e0ce
    li x3, 0x11b7e0ce
    csrw 0x532, x3

    #Address 0x532 Write value 0xbf15ce0f
    li x3, 0xbf15ce0f
    csrw 0x532, x3

    #Address 0x532 read value
    csrr x14, 0x532

    #Unmapped address 0x792 testing: random write/read operations
    #Address 0x792 read value
    csrr x14, 0x792

    #Address 0x792 read value
    csrr x14, 0x792

    #Address 0x792 read value
    csrr x14, 0x792

    #Address 0x792 Write value 0x517952ec
    li x3, 0x517952ec
    csrw 0x792, x3

    #Address 0x792 Write value 0x4615067d
    li x3, 0x4615067d
    csrw 0x792, x3

    #Unmapped address 0x2dc testing: random write/read operations
    #Address 0x2dc read value
    csrr x14, 0x2dc

    #Unmapped address 0x2a3 testing: random write/read operations
    #Address 0x2a3 Write value 0x4d5dddd2
    li x3, 0x4d5dddd2
    csrw 0x2a3, x3

    #Address 0x2a3 read value
    csrr x14, 0x2a3

    #Address 0x2a3 Write value 0x385213ec
    li x3, 0x385213ec
    csrw 0x2a3, x3

    #Unmapped address 0x9da testing: random write/read operations
    #Address 0x9da Write value 0x2de12cab
    li x3, 0x2de12cab
    csrw 0x9da, x3

    #Unmapped address 0x8ba testing: random write/read operations
    #Address 0x8ba read value
    csrr x14, 0x8ba

    #Address 0x8ba read value
    csrr x14, 0x8ba

    #Address 0x8ba Write value 0xb1f9965e
    li x3, 0xb1f9965e
    csrw 0x8ba, x3

    #Address 0x8ba Write value 0x858e56ab
    li x3, 0x858e56ab
    csrw 0x8ba, x3

    #Address 0x8ba read value
    csrr x14, 0x8ba

    #Unmapped address 0x560 testing: random write/read operations
    #Address 0x560 read value
    csrr x14, 0x560

    #Address 0x560 read value
    csrr x14, 0x560

    #Unmapped address 0x20f testing: random write/read operations
    #Address 0x20f read value
    csrr x14, 0x20f

    #Unmapped address 0x2fc testing: random write/read operations
    #Address 0x2fc read value
    csrr x14, 0x2fc

    #Unmapped address 0x680 testing: random write/read operations
    #Address 0x680 Write value 0x2fdf70e5
    li x3, 0x2fdf70e5
    csrw 0x680, x3

    #Address 0x680 Write value 0xad1a6e06
    li x3, 0xad1a6e06
    csrw 0x680, x3

    #Address 0x680 Write value 0x58d24497
    li x3, 0x58d24497
    csrw 0x680, x3

    #Address 0x680 Write value 0x67aad091
    li x3, 0x67aad091
    csrw 0x680, x3

    #Unmapped address 0x9b1 testing: random write/read operations
    #Address 0x9b1 Write value 0x8e629440
    li x3, 0x8e629440
    csrw 0x9b1, x3

    #Mapped address 0xb94 (mhpmcounterh20) testing: random write/read operations
    #Address 0xb94 Write value 0xd30b00f9
    li x3, 0xd30b00f9
    csrw 0xb94, x3

    #Address 0xb94 read value
    csrr x14, 0xb94

    #Address 0xb94 Write value 0xedc8281e
    li x3, 0xedc8281e
    csrw 0xb94, x3

    #Address 0xb94 Write value 0x17ca2229
    li x3, 0x17ca2229
    csrw 0xb94, x3

    #Address 0xb94 Write value 0x976ef764
    li x3, 0x976ef764
    csrw 0xb94, x3

    #Unmapped address 0x66d testing: random write/read operations
    #Address 0x66d Write value 0xd3782810
    li x3, 0xd3782810
    csrw 0x66d, x3

    #Unmapped address 0x8be testing: random write/read operations
    #Address 0x8be read value
    csrr x14, 0x8be

    #Address 0x8be read value
    csrr x14, 0x8be

    #Address 0x8be read value
    csrr x14, 0x8be

    #Address 0x8be read value
    csrr x14, 0x8be

    #Address 0x8be read value
    csrr x14, 0x8be

    #Unmapped address 0x396 testing: random write/read operations
    #Address 0x396 read value
    csrr x14, 0x396

    #Address 0x396 Write value 0x202be9c9
    li x3, 0x202be9c9
    csrw 0x396, x3

    #Unmapped address 0x933 testing: random write/read operations
    #Address 0x933 Write value 0xe558ed08
    li x3, 0xe558ed08
    csrw 0x933, x3

    #Address 0x933 read value
    csrr x14, 0x933

    #Address 0x933 Write value 0x5f810f74
    li x3, 0x5f810f74
    csrw 0x933, x3

    #Address 0x933 Write value 0x67a134ed
    li x3, 0x67a134ed
    csrw 0x933, x3

    #Address 0x933 read value
    csrr x14, 0x933

    #Unmapped address 0x95 testing: random write/read operations
    #Address 0x95 read value
    csrr x14, 0x95

    #Unmapped address 0xd03 testing: random write/read operations
    #Address 0xd03 Write value 0xa9698cab
    li x3, 0xa9698cab
    csrw 0xd03, x3

    #Address 0xd03 read value
    csrr x14, 0xd03

    #Address 0xd03 read value
    csrr x14, 0xd03

    #Address 0xd03 read value
    csrr x14, 0xd03

    #Address 0xd03 Write value 0x28399a30
    li x3, 0x28399a30
    csrw 0xd03, x3

    #Unmapped address 0x41a testing: random write/read operations
    #Address 0x41a Write value 0x8c23383e
    li x3, 0x8c23383e
    csrw 0x41a, x3

    #Unmapped address 0x31 testing: random write/read operations
    #Address 0x31 read value
    csrr x14, 0x31

    #Address 0x31 Write value 0xf9302fae
    li x3, 0xf9302fae
    csrw 0x31, x3

    #Unmapped address 0x18c testing: random write/read operations
    #Address 0x18c read value
    csrr x14, 0x18c

    #Address 0x18c read value
    csrr x14, 0x18c

    #Address 0x18c Write value 0xb27261d5
    li x3, 0xb27261d5
    csrw 0x18c, x3

    #Address 0x18c read value
    csrr x14, 0x18c

    #Unmapped address 0xd83 testing: random write/read operations
    #Address 0xd83 Write value 0x9a0bf235
    li x3, 0x9a0bf235
    csrw 0xd83, x3

    #Address 0xd83 read value
    csrr x14, 0xd83

    #Address 0xd83 Write value 0x3f6cf34c
    li x3, 0x3f6cf34c
    csrw 0xd83, x3

    #Unmapped address 0x974 testing: random write/read operations
    #Address 0x974 Write value 0x5575d770
    li x3, 0x5575d770
    csrw 0x974, x3

    #Address 0x974 read value
    csrr x14, 0x974

    #Address 0x974 Write value 0x8370c7df
    li x3, 0x8370c7df
    csrw 0x974, x3

    #Unmapped address 0x621 testing: random write/read operations
    #Address 0x621 read value
    csrr x14, 0x621

    #Address 0x621 Write value 0x93430b93
    li x3, 0x93430b93
    csrw 0x621, x3

    #Address 0x621 read value
    csrr x14, 0x621

    #Address 0x621 read value
    csrr x14, 0x621

    #Unmapped address 0xd75 testing: random write/read operations
    #Address 0xd75 Write value 0x848a6d95
    li x3, 0x848a6d95
    csrw 0xd75, x3

    #Address 0xd75 Write value 0x74ca1b1f
    li x3, 0x74ca1b1f
    csrw 0xd75, x3

    #Address 0xd75 read value
    csrr x14, 0xd75

    #Address 0xd75 read value
    csrr x14, 0xd75

    #Address 0xd75 Write value 0xebf84158
    li x3, 0xebf84158
    csrw 0xd75, x3

    #Unmapped address 0xe05 testing: random write/read operations
    #Address 0xe05 read value
    csrr x14, 0xe05

    #Address 0xe05 Write value 0x546389ca
    li x3, 0x546389ca
    csrw 0xe05, x3

    #Address 0xe05 read value
    csrr x14, 0xe05

    #Address 0xe05 Write value 0x456d6386
    li x3, 0x456d6386
    csrw 0xe05, x3

    #Address 0xe05 read value
    csrr x14, 0xe05

    #Unmapped address 0xe47 testing: random write/read operations
    #Address 0xe47 read value
    csrr x14, 0xe47

    #Address 0xe47 Write value 0x72a35836
    li x3, 0x72a35836
    csrw 0xe47, x3

    #Unmapped address 0x5bf testing: random write/read operations
    #Address 0x5bf Write value 0x3862984
    li x3, 0x3862984
    csrw 0x5bf, x3

    #Address 0x5bf read value
    csrr x14, 0x5bf

    #Unmapped address 0xfd5 testing: random write/read operations
    #Address 0xfd5 Write value 0x50878aef
    li x3, 0x50878aef
    csrw 0xfd5, x3

    #Unmapped address 0x6a9 testing: random write/read operations
    #Address 0x6a9 Write value 0x1c4f8965
    li x3, 0x1c4f8965
    csrw 0x6a9, x3

    #Address 0x6a9 read value
    csrr x14, 0x6a9

    #Address 0x6a9 read value
    csrr x14, 0x6a9

    #Address 0x6a9 Write value 0xab688614
    li x3, 0xab688614
    csrw 0x6a9, x3

    #Address 0x6a9 read value
    csrr x14, 0x6a9

    #Unmapped address 0xda1 testing: random write/read operations
    #Address 0xda1 read value
    csrr x14, 0xda1

    #Address 0xda1 Write value 0x98f76495
    li x3, 0x98f76495
    csrw 0xda1, x3

    #Address 0xda1 Write value 0x8cae25a8
    li x3, 0x8cae25a8
    csrw 0xda1, x3

    #Unmapped address 0x613 testing: random write/read operations
    #Address 0x613 read value
    csrr x14, 0x613

    #Address 0x613 read value
    csrr x14, 0x613

    #Address 0x613 Write value 0xf7b38082
    li x3, 0xf7b38082
    csrw 0x613, x3

    #Unmapped address 0xe24 testing: random write/read operations
    #Address 0xe24 read value
    csrr x14, 0xe24

    #Address 0xe24 read value
    csrr x14, 0xe24

    #Address 0xe24 Write value 0xdec27159
    li x3, 0xdec27159
    csrw 0xe24, x3

    #Unmapped address 0xe0c testing: random write/read operations
    #Address 0xe0c read value
    csrr x14, 0xe0c

    #Address 0xe0c Write value 0x2de10a0d
    li x3, 0x2de10a0d
    csrw 0xe0c, x3

    #Address 0xe0c Write value 0xbaa79146
    li x3, 0xbaa79146
    csrw 0xe0c, x3

    #Address 0xe0c Write value 0x62ccf3f2
    li x3, 0x62ccf3f2
    csrw 0xe0c, x3

    #Address 0xe0c read value
    csrr x14, 0xe0c

    #Unmapped address 0x78c testing: random write/read operations
    #Address 0x78c read value
    csrr x14, 0x78c

    #Address 0x78c read value
    csrr x14, 0x78c

    #Address 0x78c read value
    csrr x14, 0x78c

    #Unmapped address 0x23 testing: random write/read operations
    #Address 0x23 Write value 0xec666011
    li x3, 0xec666011
    csrw 0x23, x3

    #Address 0x23 read value
    csrr x14, 0x23

    #Address 0x23 read value
    csrr x14, 0x23

    #Address 0x23 read value
    csrr x14, 0x23

    #Address 0x23 Write value 0x34b9a88b
    li x3, 0x34b9a88b
    csrw 0x23, x3

    #Unmapped address 0xf03 testing: random write/read operations
    #Address 0xf03 read value
    csrr x14, 0xf03

    #Address 0xf03 Write value 0xc9a05d5f
    li x3, 0xc9a05d5f
    csrw 0xf03, x3

    #Address 0xf03 Write value 0x5affe784
    li x3, 0x5affe784
    csrw 0xf03, x3

    #Address 0xf03 read value
    csrr x14, 0xf03

    #Address 0xf03 read value
    csrr x14, 0xf03

    #Unmapped address 0xabf testing: random write/read operations
    #Address 0xabf read value
    csrr x14, 0xabf

    #Address 0xabf read value
    csrr x14, 0xabf

    #Unmapped address 0x1da testing: random write/read operations
    #Address 0x1da read value
    csrr x14, 0x1da

    #Unmapped address 0x92e testing: random write/read operations
    #Address 0x92e Write value 0x6a4039ff
    li x3, 0x6a4039ff
    csrw 0x92e, x3

    #Address 0x92e read value
    csrr x14, 0x92e

    #Address 0x92e read value
    csrr x14, 0x92e

    #Unmapped address 0x23b testing: random write/read operations
    #Address 0x23b read value
    csrr x14, 0x23b

    #Address 0x23b Write value 0xf3ae82b2
    li x3, 0xf3ae82b2
    csrw 0x23b, x3

    #Unmapped address 0xf26 testing: random write/read operations
    #Address 0xf26 read value
    csrr x14, 0xf26

    #Address 0xf26 read value
    csrr x14, 0xf26

    #Address 0xf26 Write value 0xc4123406
    li x3, 0xc4123406
    csrw 0xf26, x3

    #Address 0xf26 read value
    csrr x14, 0xf26

    #Unmapped address 0xf2b testing: random write/read operations
    #Address 0xf2b Write value 0x977c8e91
    li x3, 0x977c8e91
    csrw 0xf2b, x3

    #Unmapped address 0xbf5 testing: random write/read operations
    #Address 0xbf5 read value
    csrr x14, 0xbf5

    #Address 0xbf5 read value
    csrr x14, 0xbf5

    #Unmapped address 0x2cb testing: random write/read operations
    #Address 0x2cb read value
    csrr x14, 0x2cb

    #Address 0x2cb read value
    csrr x14, 0x2cb

    #Address 0x2cb Write value 0x1c960de2
    li x3, 0x1c960de2
    csrw 0x2cb, x3

    #Unmapped address 0xd90 testing: random write/read operations
    #Address 0xd90 Write value 0x9649a8ee
    li x3, 0x9649a8ee
    csrw 0xd90, x3

    #Address 0xd90 read value
    csrr x14, 0xd90

    #Address 0xd90 read value
    csrr x14, 0xd90

    #Address 0xd90 read value
    csrr x14, 0xd90

    #Address 0xd90 read value
    csrr x14, 0xd90

    #Unmapped address 0xd08 testing: random write/read operations
    #Address 0xd08 read value
    csrr x14, 0xd08

    #Address 0xd08 Write value 0x1021b814
    li x3, 0x1021b814
    csrw 0xd08, x3

    #Address 0xd08 read value
    csrr x14, 0xd08

    #Address 0xd08 Write value 0x9c5e54b1
    li x3, 0x9c5e54b1
    csrw 0xd08, x3

    #Unmapped address 0x17c testing: random write/read operations
    #Address 0x17c Write value 0xa6dba961
    li x3, 0xa6dba961
    csrw 0x17c, x3

    #Address 0x17c read value
    csrr x14, 0x17c

    #Address 0x17c read value
    csrr x14, 0x17c

    #Unmapped address 0x5f5 testing: random write/read operations
    #Address 0x5f5 Write value 0x9b5a9246
    li x3, 0x9b5a9246
    csrw 0x5f5, x3

    #Address 0x5f5 Write value 0x5d03d0df
    li x3, 0x5d03d0df
    csrw 0x5f5, x3

    #Address 0x5f5 Write value 0x1c068c2
    li x3, 0x1c068c2
    csrw 0x5f5, x3

    #Address 0x5f5 read value
    csrr x14, 0x5f5

    #Unmapped address 0x291 testing: random write/read operations
    #Address 0x291 read value
    csrr x14, 0x291

    #Address 0x291 read value
    csrr x14, 0x291

    #Address 0x291 read value
    csrr x14, 0x291

    #Address 0x291 read value
    csrr x14, 0x291

    #Unmapped address 0xe6 testing: random write/read operations
    #Address 0xe6 Write value 0xbf30a6bd
    li x3, 0xbf30a6bd
    csrw 0xe6, x3

    #Address 0xe6 read value
    csrr x14, 0xe6

    #Address 0xe6 read value
    csrr x14, 0xe6

    #Address 0xe6 Write value 0x98a2804c
    li x3, 0x98a2804c
    csrw 0xe6, x3

    #Address 0xe6 Write value 0x35459d9f
    li x3, 0x35459d9f
    csrw 0xe6, x3

    #Unmapped address 0xaa7 testing: random write/read operations
    #Address 0xaa7 Write value 0x41da27ff
    li x3, 0x41da27ff
    csrw 0xaa7, x3

    #Address 0xaa7 read value
    csrr x14, 0xaa7

    #Address 0xaa7 Write value 0x4853a683
    li x3, 0x4853a683
    csrw 0xaa7, x3

    #Address 0xaa7 read value
    csrr x14, 0xaa7

    #Address 0xaa7 read value
    csrr x14, 0xaa7

    #Unmapped address 0x62b testing: random write/read operations
    #Address 0x62b Write value 0x312b8620
    li x3, 0x312b8620
    csrw 0x62b, x3

    #Address 0x62b read value
    csrr x14, 0x62b

    #Unmapped address 0x15a testing: random write/read operations
    #Address 0x15a Write value 0xf9847f7f
    li x3, 0xf9847f7f
    csrw 0x15a, x3

    #Address 0x15a read value
    csrr x14, 0x15a

    #Address 0x15a read value
    csrr x14, 0x15a

    #Address 0x15a Write value 0x4578b628
    li x3, 0x4578b628
    csrw 0x15a, x3

    #Address 0x15a Write value 0xfb9ac5b7
    li x3, 0xfb9ac5b7
    csrw 0x15a, x3

    #Unmapped address 0x40a testing: random write/read operations
    #Address 0x40a read value
    csrr x14, 0x40a

    #Address 0x40a read value
    csrr x14, 0x40a

    #Address 0x40a Write value 0x6c743ef2
    li x3, 0x6c743ef2
    csrw 0x40a, x3

    #Address 0x40a read value
    csrr x14, 0x40a

    #Address 0x40a Write value 0xcba6143a
    li x3, 0xcba6143a
    csrw 0x40a, x3

    #Mapped address 0xb13 (mhpmcounter19) testing: random write/read operations
    #Address 0xb13 Write value 0x1262c917
    li x3, 0x1262c917
    csrw 0xb13, x3

    #Address 0xb13 read value
    csrr x14, 0xb13

    #Address 0xb13 read value
    csrr x14, 0xb13

    #Unmapped address 0xce7 testing: random write/read operations
    #Address 0xce7 read value
    csrr x14, 0xce7

    #Address 0xce7 read value
    csrr x14, 0xce7

    #Unmapped address 0xdc7 testing: random write/read operations
    #Address 0xdc7 Write value 0x408286cc
    li x3, 0x408286cc
    csrw 0xdc7, x3

    #Address 0xdc7 Write value 0x6a03fce5
    li x3, 0x6a03fce5
    csrw 0xdc7, x3

    #Unmapped address 0x41b testing: random write/read operations
    #Address 0x41b read value
    csrr x14, 0x41b

    #Address 0x41b read value
    csrr x14, 0x41b

    #Address 0x41b read value
    csrr x14, 0x41b

    #Address 0x41b Write value 0x9628032d
    li x3, 0x9628032d
    csrw 0x41b, x3

    #Unmapped address 0xe08 testing: random write/read operations
    #Address 0xe08 read value
    csrr x14, 0xe08

    #Address 0xe08 read value
    csrr x14, 0xe08

    #Unmapped address 0xe0d testing: random write/read operations
    #Address 0xe0d read value
    csrr x14, 0xe0d

    #Address 0xe0d read value
    csrr x14, 0xe0d

    #Address 0xe0d read value
    csrr x14, 0xe0d

    #Address 0xe0d read value
    csrr x14, 0xe0d

    #Address 0xe0d Write value 0xbbfa65cb
    li x3, 0xbbfa65cb
    csrw 0xe0d, x3

    #Unmapped address 0x8dc testing: random write/read operations
    #Address 0x8dc read value
    csrr x14, 0x8dc

    #Address 0x8dc Write value 0x7c27093
    li x3, 0x7c27093
    csrw 0x8dc, x3

    #Address 0x8dc read value
    csrr x14, 0x8dc

    #Address 0x8dc Write value 0x2bcd4fec
    li x3, 0x2bcd4fec
    csrw 0x8dc, x3

    #Address 0x8dc Write value 0x56f1636
    li x3, 0x56f1636
    csrw 0x8dc, x3

    #Unmapped address 0x6d6 testing: random write/read operations
    #Address 0x6d6 read value
    csrr x14, 0x6d6

    #Unmapped address 0x44c testing: random write/read operations
    #Address 0x44c read value
    csrr x14, 0x44c

    #Address 0x44c Write value 0x26620883
    li x3, 0x26620883
    csrw 0x44c, x3

    #Address 0x44c Write value 0xb2418114
    li x3, 0xb2418114
    csrw 0x44c, x3

    #Address 0x44c read value
    csrr x14, 0x44c

    #Unmapped address 0xefd testing: random write/read operations
    #Address 0xefd read value
    csrr x14, 0xefd

    #Address 0xefd Write value 0xa4b89040
    li x3, 0xa4b89040
    csrw 0xefd, x3

    #Unmapped address 0xc54 testing: random write/read operations
    #Address 0xc54 Write value 0xb1ade695
    li x3, 0xb1ade695
    csrw 0xc54, x3

    #Address 0xc54 read value
    csrr x14, 0xc54

    #Address 0xc54 read value
    csrr x14, 0xc54

    #Address 0xc54 read value
    csrr x14, 0xc54

    #Unmapped address 0x7de testing: random write/read operations
    #Address 0x7de read value
    csrr x14, 0x7de

    #Address 0x7de read value
    csrr x14, 0x7de

    #Address 0x7de read value
    csrr x14, 0x7de

    #Unmapped address 0x9f6 testing: random write/read operations
    #Address 0x9f6 read value
    csrr x14, 0x9f6

    #Unmapped address 0x3ac testing: random write/read operations
    #Address 0x3ac Write value 0xedd674f1
    li x3, 0xedd674f1
    csrw 0x3ac, x3

    #Unmapped address 0x4eb testing: random write/read operations
    #Address 0x4eb Write value 0x712969d0
    li x3, 0x712969d0
    csrw 0x4eb, x3

    #Address 0x4eb read value
    csrr x14, 0x4eb

    #Address 0x4eb read value
    csrr x14, 0x4eb

    #Address 0x4eb Write value 0x5243c283
    li x3, 0x5243c283
    csrw 0x4eb, x3

    #Unmapped address 0xcda testing: random write/read operations
    #Address 0xcda Write value 0x36c49779
    li x3, 0x36c49779
    csrw 0xcda, x3

    #Address 0xcda Write value 0x88180dee
    li x3, 0x88180dee
    csrw 0xcda, x3

    #Unmapped address 0x73b testing: random write/read operations
    #Address 0x73b read value
    csrr x14, 0x73b

    #Address 0x73b read value
    csrr x14, 0x73b

    #Address 0x73b Write value 0x60e5a38
    li x3, 0x60e5a38
    csrw 0x73b, x3

    #Address 0x73b read value
    csrr x14, 0x73b

    #Unmapped address 0x5bd testing: random write/read operations
    #Address 0x5bd read value
    csrr x14, 0x5bd

    #Unmapped address 0x201 testing: random write/read operations
    #Address 0x201 Write value 0x3f0a88f
    li x3, 0x3f0a88f
    csrw 0x201, x3

    #Address 0x201 Write value 0xa677702d
    li x3, 0xa677702d
    csrw 0x201, x3

    #Address 0x201 Write value 0x36cee708
    li x3, 0x36cee708
    csrw 0x201, x3

    #Address 0x201 Write value 0x97a82350
    li x3, 0x97a82350
    csrw 0x201, x3

    #Unmapped address 0x200 testing: random write/read operations
    #Address 0x200 read value
    csrr x14, 0x200

    #Address 0x200 Write value 0x7f2747da
    li x3, 0x7f2747da
    csrw 0x200, x3

    #Unmapped address 0x60d testing: random write/read operations
    #Address 0x60d read value
    csrr x14, 0x60d

    #Address 0x60d read value
    csrr x14, 0x60d

    #Address 0x60d read value
    csrr x14, 0x60d

    #Address 0x60d read value
    csrr x14, 0x60d

    #Address 0x60d Write value 0xc53c9ff4
    li x3, 0xc53c9ff4
    csrw 0x60d, x3

    #Unmapped address 0xa6d testing: random write/read operations
    #Address 0xa6d Write value 0x6a368071
    li x3, 0x6a368071
    csrw 0xa6d, x3

    #Unmapped address 0x389 testing: random write/read operations
    #Address 0x389 read value
    csrr x14, 0x389

    #Address 0x389 Write value 0x7690a53
    li x3, 0x7690a53
    csrw 0x389, x3

    #Address 0x389 read value
    csrr x14, 0x389

    #Address 0x389 Write value 0x404b5bfa
    li x3, 0x404b5bfa
    csrw 0x389, x3

    #Unmapped address 0xf0a testing: random write/read operations
    #Address 0xf0a read value
    csrr x14, 0xf0a

    #Address 0xf0a Write value 0xf4999111
    li x3, 0xf4999111
    csrw 0xf0a, x3

    #Unmapped address 0xd47 testing: random write/read operations
    #Address 0xd47 read value
    csrr x14, 0xd47

    #Address 0xd47 read value
    csrr x14, 0xd47

    #Unmapped address 0x523 testing: random write/read operations
    #Address 0x523 read value
    csrr x14, 0x523

    #Address 0x523 Write value 0x4555f6f0
    li x3, 0x4555f6f0
    csrw 0x523, x3

    #Address 0x523 Write value 0x3341bf36
    li x3, 0x3341bf36
    csrw 0x523, x3

    #Unmapped address 0x46f testing: random write/read operations
    #Address 0x46f Write value 0xa89f3fd2
    li x3, 0xa89f3fd2
    csrw 0x46f, x3

    #Address 0x46f read value
    csrr x14, 0x46f

    #Address 0x46f read value
    csrr x14, 0x46f

    #Unmapped address 0xff8 testing: random write/read operations
    #Address 0xff8 Write value 0x620ea2d0
    li x3, 0x620ea2d0
    csrw 0xff8, x3

    #Address 0xff8 Write value 0xab70342d
    li x3, 0xab70342d
    csrw 0xff8, x3

    #Address 0xff8 Write value 0xe0fd2848
    li x3, 0xe0fd2848
    csrw 0xff8, x3

    #Unmapped address 0x28c testing: random write/read operations
    #Address 0x28c read value
    csrr x14, 0x28c

    #Address 0x28c Write value 0xe881f05b
    li x3, 0xe881f05b
    csrw 0x28c, x3

    #Unmapped address 0xd0f testing: random write/read operations
    #Address 0xd0f read value
    csrr x14, 0xd0f

    #Address 0xd0f read value
    csrr x14, 0xd0f

    #Address 0xd0f read value
    csrr x14, 0xd0f

    #Address 0xd0f read value
    csrr x14, 0xd0f

    #Address 0xd0f read value
    csrr x14, 0xd0f

    #Unmapped address 0x46e testing: random write/read operations
    #Address 0x46e read value
    csrr x14, 0x46e

    #Address 0x46e Write value 0x75dea48
    li x3, 0x75dea48
    csrw 0x46e, x3

    #Unmapped address 0x619 testing: random write/read operations
    #Address 0x619 read value
    csrr x14, 0x619

    #Address 0x619 Write value 0x9e0e6358
    li x3, 0x9e0e6358
    csrw 0x619, x3

    #Address 0x619 read value
    csrr x14, 0x619

    #Unmapped address 0x82e testing: random write/read operations
    #Address 0x82e Write value 0xdde55a61
    li x3, 0xdde55a61
    csrw 0x82e, x3

    #Address 0x82e Write value 0x7c8355c3
    li x3, 0x7c8355c3
    csrw 0x82e, x3

    #Address 0x82e Write value 0xb498191a
    li x3, 0xb498191a
    csrw 0x82e, x3

    #Address 0x82e Write value 0x51408914
    li x3, 0x51408914
    csrw 0x82e, x3

    #Address 0x82e read value
    csrr x14, 0x82e

    #Unmapped address 0x7c2 testing: random write/read operations
    #Address 0x7c2 Write value 0xffaf19df
    li x3, 0xffaf19df
    csrw 0x7c2, x3

    #Address 0x7c2 read value
    csrr x14, 0x7c2

    #Address 0x7c2 read value
    csrr x14, 0x7c2

    #Address 0x7c2 Write value 0x912536d0
    li x3, 0x912536d0
    csrw 0x7c2, x3

    #Unmapped address 0x1ad testing: random write/read operations
    #Address 0x1ad Write value 0x16abc558
    li x3, 0x16abc558
    csrw 0x1ad, x3

    #Address 0x1ad read value
    csrr x14, 0x1ad

    #Address 0x1ad Write value 0x736a6f39
    li x3, 0x736a6f39
    csrw 0x1ad, x3

    #Unmapped address 0x69d testing: random write/read operations
    #Address 0x69d read value
    csrr x14, 0x69d

    #Address 0x69d Write value 0x2499aa1e
    li x3, 0x2499aa1e
    csrw 0x69d, x3

    #Address 0x69d read value
    csrr x14, 0x69d

    #Address 0x69d read value
    csrr x14, 0x69d

    #Unmapped address 0xc6 testing: random write/read operations
    #Address 0xc6 Write value 0xf4a13b15
    li x3, 0xf4a13b15
    csrw 0xc6, x3

    #Address 0xc6 read value
    csrr x14, 0xc6

    #Address 0xc6 Write value 0xf20c57f5
    li x3, 0xf20c57f5
    csrw 0xc6, x3

    #Address 0xc6 read value
    csrr x14, 0xc6

    #Unmapped address 0xdfd testing: random write/read operations
    #Address 0xdfd read value
    csrr x14, 0xdfd

    #Address 0xdfd read value
    csrr x14, 0xdfd

    #Unmapped address 0x832 testing: random write/read operations
    #Address 0x832 Write value 0xa1538e1f
    li x3, 0xa1538e1f
    csrw 0x832, x3

    #Address 0x832 Write value 0x19e5d2b8
    li x3, 0x19e5d2b8
    csrw 0x832, x3

    #Unmapped address 0x78e testing: random write/read operations
    #Address 0x78e read value
    csrr x14, 0x78e

    #Unmapped address 0x4c9 testing: random write/read operations
    #Address 0x4c9 Write value 0xe7b7ac4e
    li x3, 0xe7b7ac4e
    csrw 0x4c9, x3

    #Address 0x4c9 read value
    csrr x14, 0x4c9

    #Unmapped address 0x2d testing: random write/read operations
    #Address 0x2d Write value 0xd6933a2c
    li x3, 0xd6933a2c
    csrw 0x2d, x3

    #Address 0x2d read value
    csrr x14, 0x2d

    #Address 0x2d read value
    csrr x14, 0x2d

    #Address 0x2d Write value 0xe2cf1149
    li x3, 0xe2cf1149
    csrw 0x2d, x3

    #Address 0x2d Write value 0x250be1b9
    li x3, 0x250be1b9
    csrw 0x2d, x3

    #Unmapped address 0x484 testing: random write/read operations
    #Address 0x484 read value
    csrr x14, 0x484

    #Address 0x484 Write value 0x1dcacd74
    li x3, 0x1dcacd74
    csrw 0x484, x3

    #Address 0x484 read value
    csrr x14, 0x484

    #Unmapped address 0x4d9 testing: random write/read operations
    #Address 0x4d9 read value
    csrr x14, 0x4d9

    #Mapped address 0x300 (mstatus) testing: random write/read operations
    #Address 0x300 Write value 0x1ca86b1
    li x3, 0x1ca86b1
    csrw 0x300, x3

    #Address 0x300 Write value 0x4105a201
    li x3, 0x4105a201
    csrw 0x300, x3

    #Address 0x300 Write value 0x2164c7ad
    li x3, 0x2164c7ad
    csrw 0x300, x3

    #Address 0x300 read value
    csrr x14, 0x300

    #Unmapped address 0xbf4 testing: random write/read operations
    #Address 0xbf4 read value
    csrr x14, 0xbf4

    #Address 0xbf4 read value
    csrr x14, 0xbf4

    #Unmapped address 0xc2 testing: random write/read operations
    #Address 0xc2 read value
    csrr x14, 0xc2

    #Unmapped address 0xeff testing: random write/read operations
    #Address 0xeff read value
    csrr x14, 0xeff

    #Address 0xeff read value
    csrr x14, 0xeff

    #Address 0xeff Write value 0x69c80d44
    li x3, 0x69c80d44
    csrw 0xeff, x3

    #Unmapped address 0x66 testing: random write/read operations
    #Address 0x66 Write value 0x6c1e62bc
    li x3, 0x6c1e62bc
    csrw 0x66, x3

    #Address 0x66 read value
    csrr x14, 0x66

    #Address 0x66 Write value 0xd89e6771
    li x3, 0xd89e6771
    csrw 0x66, x3

    #Unmapped address 0x79a testing: random write/read operations
    #Address 0x79a read value
    csrr x14, 0x79a

    #Unmapped address 0x238 testing: random write/read operations
    #Address 0x238 read value
    csrr x14, 0x238

    #Address 0x238 read value
    csrr x14, 0x238

    #Unmapped address 0x9a9 testing: random write/read operations
    #Address 0x9a9 read value
    csrr x14, 0x9a9

    #Address 0x9a9 Write value 0x82bdb066
    li x3, 0x82bdb066
    csrw 0x9a9, x3

    #Mapped address 0x326 (mhpmevent6) testing: random write/read operations
    #Address 0x326 Write value 0xdbb5501b
    li x3, 0xdbb5501b
    csrw 0x326, x3

    #Unmapped address 0x608 testing: random write/read operations
    #Address 0x608 Write value 0x30310f7
    li x3, 0x30310f7
    csrw 0x608, x3

    #Address 0x608 read value
    csrr x14, 0x608

    #Address 0x608 read value
    csrr x14, 0x608

    #Unmapped address 0x67f testing: random write/read operations
    #Address 0x67f Write value 0x93624b9f
    li x3, 0x93624b9f
    csrw 0x67f, x3

    #Address 0x67f Write value 0x348b7452
    li x3, 0x348b7452
    csrw 0x67f, x3

    #Address 0x67f read value
    csrr x14, 0x67f

    #Address 0x67f Write value 0x8a97ae5b
    li x3, 0x8a97ae5b
    csrw 0x67f, x3

    #Address 0x67f Write value 0xa0f43d20
    li x3, 0xa0f43d20
    csrw 0x67f, x3

    #Unmapped address 0x6b4 testing: random write/read operations
    #Address 0x6b4 read value
    csrr x14, 0x6b4

    #Address 0x6b4 read value
    csrr x14, 0x6b4

    #Address 0x6b4 Write value 0x6cc9d740
    li x3, 0x6cc9d740
    csrw 0x6b4, x3

    #Address 0x6b4 Write value 0x2e3e743d
    li x3, 0x2e3e743d
    csrw 0x6b4, x3

    #Address 0x6b4 Write value 0x3f603069
    li x3, 0x3f603069
    csrw 0x6b4, x3

    #Unmapped address 0xcea testing: random write/read operations
    #Address 0xcea read value
    csrr x14, 0xcea

    #Address 0xcea Write value 0xfac33953
    li x3, 0xfac33953
    csrw 0xcea, x3

    #Address 0xcea Write value 0x392557cc
    li x3, 0x392557cc
    csrw 0xcea, x3

    #Address 0xcea Write value 0xe7e58717
    li x3, 0xe7e58717
    csrw 0xcea, x3

    #Address 0xcea Write value 0x19ccb37f
    li x3, 0x19ccb37f
    csrw 0xcea, x3

    #Unmapped address 0xfaa testing: random write/read operations
    #Address 0xfaa read value
    csrr x14, 0xfaa

    #Address 0xfaa read value
    csrr x14, 0xfaa

    #Address 0xfaa read value
    csrr x14, 0xfaa

    #Mapped address 0x339 (mhpmevent25) testing: random write/read operations
    #Address 0x339 read value
    csrr x14, 0x339

    #Address 0x339 Write value 0x81fa94ac
    li x3, 0x81fa94ac
    csrw 0x339, x3

    #Address 0x339 Write value 0x26e9461a
    li x3, 0x26e9461a
    csrw 0x339, x3

    #Address 0x339 Write value 0xd7f610b9
    li x3, 0xd7f610b9
    csrw 0x339, x3

    #Address 0x339 read value
    csrr x14, 0x339

    #Unmapped address 0x286 testing: random write/read operations
    #Address 0x286 read value
    csrr x14, 0x286

    #Address 0x286 read value
    csrr x14, 0x286

    #Address 0x286 read value
    csrr x14, 0x286

    #Address 0x286 read value
    csrr x14, 0x286

    #Unmapped address 0x52f testing: random write/read operations
    #Address 0x52f read value
    csrr x14, 0x52f

    #Address 0x52f read value
    csrr x14, 0x52f

    #Address 0x52f read value
    csrr x14, 0x52f

    #Address 0x52f Write value 0xb363d9bd
    li x3, 0xb363d9bd
    csrw 0x52f, x3

    #Address 0x52f read value
    csrr x14, 0x52f

    #Unmapped address 0x6f8 testing: random write/read operations
    #Address 0x6f8 read value
    csrr x14, 0x6f8

    #Unmapped address 0x9fd testing: random write/read operations
    #Address 0x9fd Write value 0x866e8862
    li x3, 0x866e8862
    csrw 0x9fd, x3

    #Address 0x9fd read value
    csrr x14, 0x9fd

    #Address 0x9fd read value
    csrr x14, 0x9fd

    #Unmapped address 0xc73 testing: random write/read operations
    #Address 0xc73 read value
    csrr x14, 0xc73

    #Address 0xc73 Write value 0x2cbe2041
    li x3, 0x2cbe2041
    csrw 0xc73, x3

    #Address 0xc73 Write value 0x5c690048
    li x3, 0x5c690048
    csrw 0xc73, x3

    #Unmapped address 0x6f0 testing: random write/read operations
    #Address 0x6f0 read value
    csrr x14, 0x6f0

    #Address 0x6f0 read value
    csrr x14, 0x6f0

    #Address 0x6f0 Write value 0x682fb86a
    li x3, 0x682fb86a
    csrw 0x6f0, x3

    #Address 0x6f0 Write value 0x2a2c2bc5
    li x3, 0x2a2c2bc5
    csrw 0x6f0, x3

    #Unmapped address 0x7f8 testing: random write/read operations
    #Address 0x7f8 read value
    csrr x14, 0x7f8

    #Unmapped address 0xcc0 testing: random write/read operations
    #Address 0xcc0 read value
    csrr x14, 0xcc0

    #Address 0xcc0 Write value 0xc5177c00
    li x3, 0xc5177c00
    csrw 0xcc0, x3

    #Address 0xcc0 Write value 0xc4188f02
    li x3, 0xc4188f02
    csrw 0xcc0, x3

    #Address 0xcc0 Write value 0xd12744dd
    li x3, 0xd12744dd
    csrw 0xcc0, x3

    #Address 0xcc0 read value
    csrr x14, 0xcc0

    #Unmapped address 0xd33 testing: random write/read operations
    #Address 0xd33 read value
    csrr x14, 0xd33

    #Address 0xd33 read value
    csrr x14, 0xd33

    #Unmapped address 0x89f testing: random write/read operations
    #Address 0x89f read value
    csrr x14, 0x89f

    #Address 0x89f Write value 0x321572af
    li x3, 0x321572af
    csrw 0x89f, x3

    #Address 0x89f Write value 0x1cc89aee
    li x3, 0x1cc89aee
    csrw 0x89f, x3

    #Unmapped address 0xa21 testing: random write/read operations
    #Address 0xa21 read value
    csrr x14, 0xa21

    #Address 0xa21 read value
    csrr x14, 0xa21

    #Unmapped address 0xd89 testing: random write/read operations
    #Address 0xd89 read value
    csrr x14, 0xd89

    #Address 0xd89 Write value 0xf51a0934
    li x3, 0xf51a0934
    csrw 0xd89, x3

    #Address 0xd89 read value
    csrr x14, 0xd89

    #Unmapped address 0xdbe testing: random write/read operations
    #Address 0xdbe read value
    csrr x14, 0xdbe

    #Address 0xdbe Write value 0x92af07f9
    li x3, 0x92af07f9
    csrw 0xdbe, x3

    #Address 0xdbe read value
    csrr x14, 0xdbe

    #Unmapped address 0xe1 testing: random write/read operations
    #Address 0xe1 read value
    csrr x14, 0xe1

    #Address 0xe1 read value
    csrr x14, 0xe1

    #Address 0xe1 Write value 0xe3e5c7cb
    li x3, 0xe3e5c7cb
    csrw 0xe1, x3

    #Address 0xe1 read value
    csrr x14, 0xe1

    #Address 0xe1 read value
    csrr x14, 0xe1

    #Unmapped address 0xfea testing: random write/read operations
    #Address 0xfea Write value 0xf299b9ba
    li x3, 0xf299b9ba
    csrw 0xfea, x3

    #Address 0xfea read value
    csrr x14, 0xfea

    #Unmapped address 0x17b testing: random write/read operations
    #Address 0x17b Write value 0xeaee0454
    li x3, 0xeaee0454
    csrw 0x17b, x3

    #Unmapped address 0x87e testing: random write/read operations
    #Address 0x87e read value
    csrr x14, 0x87e

    #Address 0x87e read value
    csrr x14, 0x87e

    #Unmapped address 0xc0f testing: random write/read operations
    #Address 0xc0f Write value 0x8b42cc4
    li x3, 0x8b42cc4
    csrw 0xc0f, x3

    #Address 0xc0f read value
    csrr x14, 0xc0f

    #Address 0xc0f Write value 0xdd8489c7
    li x3, 0xdd8489c7
    csrw 0xc0f, x3

    #Unmapped address 0x732 testing: random write/read operations
    #Address 0x732 Write value 0x58fb2b85
    li x3, 0x58fb2b85
    csrw 0x732, x3

    #Unmapped address 0xc94 testing: random write/read operations
    #Address 0xc94 Write value 0x43de9886
    li x3, 0x43de9886
    csrw 0xc94, x3

    #Address 0xc94 Write value 0x5996bb40
    li x3, 0x5996bb40
    csrw 0xc94, x3

    #Address 0xc94 read value
    csrr x14, 0xc94

    #Unmapped address 0xabe testing: random write/read operations
    #Address 0xabe Write value 0x4f9f5d8e
    li x3, 0x4f9f5d8e
    csrw 0xabe, x3

    #Address 0xabe Write value 0x55c9b805
    li x3, 0x55c9b805
    csrw 0xabe, x3

    #Unmapped address 0xcc1 testing: random write/read operations
    #Address 0xcc1 Write value 0xa55b5bb8
    li x3, 0xa55b5bb8
    csrw 0xcc1, x3

    #Address 0xcc1 read value
    csrr x14, 0xcc1

    #Address 0xcc1 read value
    csrr x14, 0xcc1

    #Address 0xcc1 read value
    csrr x14, 0xcc1

    #Address 0xcc1 read value
    csrr x14, 0xcc1

    #Unmapped address 0xc37 testing: random write/read operations
    #Address 0xc37 Write value 0x7c35b976
    li x3, 0x7c35b976
    csrw 0xc37, x3

    #Unmapped address 0x2c1 testing: random write/read operations
    #Address 0x2c1 read value
    csrr x14, 0x2c1

    #Address 0x2c1 read value
    csrr x14, 0x2c1

    #Address 0x2c1 read value
    csrr x14, 0x2c1

    #Unmapped address 0x433 testing: random write/read operations
    #Address 0x433 Write value 0x3401e3d8
    li x3, 0x3401e3d8
    csrw 0x433, x3

    #Address 0x433 read value
    csrr x14, 0x433

    #Address 0x433 read value
    csrr x14, 0x433

    #Unmapped address 0x4b1 testing: random write/read operations
    #Address 0x4b1 Write value 0x1e7a66ac
    li x3, 0x1e7a66ac
    csrw 0x4b1, x3

    #Unmapped address 0xd4c testing: random write/read operations
    #Address 0xd4c read value
    csrr x14, 0xd4c

    #Address 0xd4c read value
    csrr x14, 0xd4c

    #Address 0xd4c read value
    csrr x14, 0xd4c

    #Address 0xd4c read value
    csrr x14, 0xd4c

    #Address 0xd4c Write value 0x57a353e3
    li x3, 0x57a353e3
    csrw 0xd4c, x3

    #Unmapped address 0x5e9 testing: random write/read operations
    #Address 0x5e9 Write value 0x4b9489c2
    li x3, 0x4b9489c2
    csrw 0x5e9, x3

    #Address 0x5e9 Write value 0x13db89a
    li x3, 0x13db89a
    csrw 0x5e9, x3

    #Address 0x5e9 Write value 0x9032134f
    li x3, 0x9032134f
    csrw 0x5e9, x3

    #Address 0x5e9 read value
    csrr x14, 0x5e9

    #Address 0x5e9 read value
    csrr x14, 0x5e9

    #Unmapped address 0x856 testing: random write/read operations
    #Address 0x856 read value
    csrr x14, 0x856

    #Address 0x856 Write value 0x8a32842a
    li x3, 0x8a32842a
    csrw 0x856, x3

    #Address 0x856 Write value 0x997cccb2
    li x3, 0x997cccb2
    csrw 0x856, x3

    #Unmapped address 0xec6 testing: random write/read operations
    #Address 0xec6 Write value 0xfa9d490d
    li x3, 0xfa9d490d
    csrw 0xec6, x3

    #Unmapped address 0xe86 testing: random write/read operations
    #Address 0xe86 Write value 0xba620cef
    li x3, 0xba620cef
    csrw 0xe86, x3

    #Unmapped address 0x3cd testing: random write/read operations
    #Address 0x3cd Write value 0x5bfa2682
    li x3, 0x5bfa2682
    csrw 0x3cd, x3

    #Address 0x3cd Write value 0xf5d21147
    li x3, 0xf5d21147
    csrw 0x3cd, x3

    #Address 0x3cd read value
    csrr x14, 0x3cd

    #Address 0x3cd Write value 0x676a25f9
    li x3, 0x676a25f9
    csrw 0x3cd, x3

    #Address 0x3cd read value
    csrr x14, 0x3cd

    #Unmapped address 0x633 testing: random write/read operations
    #Address 0x633 Write value 0xcd9ce67d
    li x3, 0xcd9ce67d
    csrw 0x633, x3

    #Unmapped address 0xcbc testing: random write/read operations
    #Address 0xcbc read value
    csrr x14, 0xcbc

    #Address 0xcbc Write value 0xec3bfb43
    li x3, 0xec3bfb43
    csrw 0xcbc, x3

    #Address 0xcbc Write value 0x279cf8e6
    li x3, 0x279cf8e6
    csrw 0xcbc, x3

    #Address 0xcbc read value
    csrr x14, 0xcbc

    #Address 0xcbc Write value 0xd5e35181
    li x3, 0xd5e35181
    csrw 0xcbc, x3

    #Unmapped address 0xad6 testing: random write/read operations
    #Address 0xad6 read value
    csrr x14, 0xad6

    #Address 0xad6 Write value 0x4efb131b
    li x3, 0x4efb131b
    csrw 0xad6, x3

    #Unmapped address 0x60 testing: random write/read operations
    #Address 0x60 read value
    csrr x14, 0x60

    #Address 0x60 read value
    csrr x14, 0x60

    #Address 0x60 Write value 0x1bb9a8a3
    li x3, 0x1bb9a8a3
    csrw 0x60, x3

    #Address 0x60 read value
    csrr x14, 0x60

    #Address 0x60 Write value 0x7bb115ad
    li x3, 0x7bb115ad
    csrw 0x60, x3

    #Unmapped address 0xb3c testing: random write/read operations
    #Address 0xb3c read value
    csrr x14, 0xb3c

    #Unmapped address 0x2a4 testing: random write/read operations
    #Address 0x2a4 read value
    csrr x14, 0x2a4

    #Address 0x2a4 read value
    csrr x14, 0x2a4

    #Address 0x2a4 Write value 0xcf66aeb7
    li x3, 0xcf66aeb7
    csrw 0x2a4, x3

    #Address 0x2a4 Write value 0x2d9828a1
    li x3, 0x2d9828a1
    csrw 0x2a4, x3

    #Address 0x2a4 Write value 0x5a97dca7
    li x3, 0x5a97dca7
    csrw 0x2a4, x3

    #Unmapped address 0x5ac testing: random write/read operations
    #Address 0x5ac read value
    csrr x14, 0x5ac

    #Address 0x5ac read value
    csrr x14, 0x5ac

    #Address 0x5ac Write value 0xd236f858
    li x3, 0xd236f858
    csrw 0x5ac, x3

    #Unmapped address 0x874 testing: random write/read operations
    #Address 0x874 read value
    csrr x14, 0x874

    #Address 0x874 Write value 0x3029a80e
    li x3, 0x3029a80e
    csrw 0x874, x3

    #Address 0x874 read value
    csrr x14, 0x874

    #Unmapped address 0xcdb testing: random write/read operations
    #Address 0xcdb read value
    csrr x14, 0xcdb

    #Address 0xcdb Write value 0x900cbd11
    li x3, 0x900cbd11
    csrw 0xcdb, x3

    #Unmapped address 0xef3 testing: random write/read operations
    #Address 0xef3 read value
    csrr x14, 0xef3

    #Address 0xef3 read value
    csrr x14, 0xef3

    #Unmapped address 0x689 testing: random write/read operations
    #Address 0x689 Write value 0xd664622e
    li x3, 0xd664622e
    csrw 0x689, x3

    #Address 0x689 read value
    csrr x14, 0x689

    #Address 0x689 read value
    csrr x14, 0x689

    #Address 0x689 Write value 0x33093ae0
    li x3, 0x33093ae0
    csrw 0x689, x3

    #Unmapped address 0xdd testing: random write/read operations
    #Address 0xdd Write value 0x650fc5e7
    li x3, 0x650fc5e7
    csrw 0xdd, x3

    #Address 0xdd Write value 0x76901027
    li x3, 0x76901027
    csrw 0xdd, x3

    #Unmapped address 0xfc testing: random write/read operations
    #Address 0xfc read value
    csrr x14, 0xfc

    #Address 0xfc Write value 0xea963ce5
    li x3, 0xea963ce5
    csrw 0xfc, x3

    #Address 0xfc read value
    csrr x14, 0xfc

    #Address 0xfc Write value 0x59a0e5f6
    li x3, 0x59a0e5f6
    csrw 0xfc, x3

    #Address 0xfc read value
    csrr x14, 0xfc

    #Unmapped address 0xa5f testing: random write/read operations
    #Address 0xa5f read value
    csrr x14, 0xa5f

    #Address 0xa5f read value
    csrr x14, 0xa5f

    #Address 0xa5f read value
    csrr x14, 0xa5f

    #Address 0xa5f Write value 0xf2561fbd
    li x3, 0xf2561fbd
    csrw 0xa5f, x3

    #Address 0xa5f Write value 0xc5e8bc8e
    li x3, 0xc5e8bc8e
    csrw 0xa5f, x3

    #Unmapped address 0xb40 testing: random write/read operations
    #Address 0xb40 Write value 0x74cda8d7
    li x3, 0x74cda8d7
    csrw 0xb40, x3

    #Unmapped address 0x866 testing: random write/read operations
    #Address 0x866 read value
    csrr x14, 0x866

    #Address 0x866 Write value 0xe92a40dc
    li x3, 0xe92a40dc
    csrw 0x866, x3

    #Address 0x866 Write value 0x359603df
    li x3, 0x359603df
    csrw 0x866, x3

    #Unmapped address 0x241 testing: random write/read operations
    #Address 0x241 Write value 0x9f723957
    li x3, 0x9f723957
    csrw 0x241, x3

    #Address 0x241 read value
    csrr x14, 0x241

    #Address 0x241 read value
    csrr x14, 0x241

    #Address 0x241 Write value 0x40c03413
    li x3, 0x40c03413
    csrw 0x241, x3

    #Address 0x241 Write value 0xaaf02a1f
    li x3, 0xaaf02a1f
    csrw 0x241, x3

    #Unmapped address 0x4fe testing: random write/read operations
    #Address 0x4fe Write value 0x54c3520a
    li x3, 0x54c3520a
    csrw 0x4fe, x3

    #Unmapped address 0x5e0 testing: random write/read operations
    #Address 0x5e0 Write value 0xcd2e9f45
    li x3, 0xcd2e9f45
    csrw 0x5e0, x3

    #Address 0x5e0 Write value 0x558999e6
    li x3, 0x558999e6
    csrw 0x5e0, x3

    #Address 0x5e0 Write value 0xecc3ee3a
    li x3, 0xecc3ee3a
    csrw 0x5e0, x3

    #Address 0x5e0 Write value 0x9b1fa9c8
    li x3, 0x9b1fa9c8
    csrw 0x5e0, x3

    #Unmapped address 0xced testing: random write/read operations
    #Address 0xced read value
    csrr x14, 0xced

    #Address 0xced Write value 0xaa6d1ead
    li x3, 0xaa6d1ead
    csrw 0xced, x3

    #Address 0xced read value
    csrr x14, 0xced

    #Unmapped address 0xa28 testing: random write/read operations
    #Address 0xa28 read value
    csrr x14, 0xa28

    #Address 0xa28 read value
    csrr x14, 0xa28

    #Address 0xa28 read value
    csrr x14, 0xa28

    #Address 0xa28 Write value 0x8b60ce96
    li x3, 0x8b60ce96
    csrw 0xa28, x3

    #Unmapped address 0xde9 testing: random write/read operations
    #Address 0xde9 read value
    csrr x14, 0xde9

    #Unmapped address 0x811 testing: random write/read operations
    #Address 0x811 Write value 0x1eb26eaa
    li x3, 0x1eb26eaa
    csrw 0x811, x3

    #Address 0x811 Write value 0x4804cd0
    li x3, 0x4804cd0
    csrw 0x811, x3

    #Unmapped address 0x4b6 testing: random write/read operations
    #Address 0x4b6 Write value 0xbb907d70
    li x3, 0xbb907d70
    csrw 0x4b6, x3

    #Unmapped address 0xd9 testing: random write/read operations
    #Address 0xd9 Write value 0x629d197b
    li x3, 0x629d197b
    csrw 0xd9, x3

    #Address 0xd9 read value
    csrr x14, 0xd9

    #Unmapped address 0x604 testing: random write/read operations
    #Address 0x604 read value
    csrr x14, 0x604

    #Unmapped address 0x706 testing: random write/read operations
    #Address 0x706 Write value 0xcc5391a7
    li x3, 0xcc5391a7
    csrw 0x706, x3

    #Unmapped address 0x869 testing: random write/read operations
    #Address 0x869 read value
    csrr x14, 0x869

    #Unmapped address 0xa80 testing: random write/read operations
    #Address 0xa80 Write value 0x96fce26f
    li x3, 0x96fce26f
    csrw 0xa80, x3

    #Address 0xa80 Write value 0x61a9a3cc
    li x3, 0x61a9a3cc
    csrw 0xa80, x3

    #Mapped address 0xf11 (mvendorid) testing: random write/read operations
    #Address 0xf11 Write value 0x6f2f6770
    li x3, 0x6f2f6770
    csrw 0xf11, x3

    #Address 0xf11 Write value 0xa0f0c059
    li x3, 0xa0f0c059
    csrw 0xf11, x3

    #Address 0xf11 read value
    csrr x14, 0xf11

    #Unmapped address 0x38 testing: random write/read operations
    #Address 0x38 read value
    csrr x14, 0x38

    #Address 0x38 Write value 0xc0487a2
    li x3, 0xc0487a2
    csrw 0x38, x3

    #Unmapped address 0xd0 testing: random write/read operations
    #Address 0xd0 Write value 0x514f845e
    li x3, 0x514f845e
    csrw 0xd0, x3

    #Address 0xd0 Write value 0xc0815f9b
    li x3, 0xc0815f9b
    csrw 0xd0, x3

    #Address 0xd0 Write value 0x5cbd97fa
    li x3, 0x5cbd97fa
    csrw 0xd0, x3

    #Unmapped address 0xc26 testing: random write/read operations
    #Address 0xc26 Write value 0x9d776bdd
    li x3, 0x9d776bdd
    csrw 0xc26, x3

    #Address 0xc26 Write value 0xf69905f2
    li x3, 0xf69905f2
    csrw 0xc26, x3

    #Address 0xc26 read value
    csrr x14, 0xc26

    #Address 0xc26 Write value 0x8066a2d2
    li x3, 0x8066a2d2
    csrw 0xc26, x3

    #Unmapped address 0xba9 testing: random write/read operations
    #Address 0xba9 Write value 0x65851bca
    li x3, 0x65851bca
    csrw 0xba9, x3

    #Address 0xba9 Write value 0xd1635346
    li x3, 0xd1635346
    csrw 0xba9, x3

    #Address 0xba9 Write value 0xd27a8597
    li x3, 0xd27a8597
    csrw 0xba9, x3

    #Address 0xba9 read value
    csrr x14, 0xba9

    #Address 0xba9 read value
    csrr x14, 0xba9

    #Unmapped address 0x9fb testing: random write/read operations
    #Address 0x9fb read value
    csrr x14, 0x9fb

    #Address 0x9fb read value
    csrr x14, 0x9fb

    #Address 0x9fb read value
    csrr x14, 0x9fb

    #Address 0x9fb read value
    csrr x14, 0x9fb

    #Unmapped address 0x83d testing: random write/read operations
    #Address 0x83d read value
    csrr x14, 0x83d

    #Address 0x83d Write value 0xb760b59e
    li x3, 0xb760b59e
    csrw 0x83d, x3

    #Unmapped address 0x351 testing: random write/read operations
    #Address 0x351 Write value 0x57781ee1
    li x3, 0x57781ee1
    csrw 0x351, x3

    #Address 0x351 read value
    csrr x14, 0x351

    #Address 0x351 Write value 0xd262579
    li x3, 0xd262579
    csrw 0x351, x3

    #Unmapped address 0xcd3 testing: random write/read operations
    #Address 0xcd3 read value
    csrr x14, 0xcd3

    #Address 0xcd3 read value
    csrr x14, 0xcd3

    #Address 0xcd3 Write value 0xc1b7a761
    li x3, 0xc1b7a761
    csrw 0xcd3, x3

    #Unmapped address 0x117 testing: random write/read operations
    #Address 0x117 read value
    csrr x14, 0x117

    #Address 0x117 Write value 0x5203df3f
    li x3, 0x5203df3f
    csrw 0x117, x3

    #Address 0x117 Write value 0x670140c7
    li x3, 0x670140c7
    csrw 0x117, x3

    #Unmapped address 0x947 testing: random write/read operations
    #Address 0x947 Write value 0xde5a0626
    li x3, 0xde5a0626
    csrw 0x947, x3

    #Address 0x947 read value
    csrr x14, 0x947

    #Address 0x947 Write value 0x98acdd47
    li x3, 0x98acdd47
    csrw 0x947, x3

    #Unmapped address 0x2b5 testing: random write/read operations
    #Address 0x2b5 read value
    csrr x14, 0x2b5

    #Address 0x2b5 read value
    csrr x14, 0x2b5

    #Address 0x2b5 read value
    csrr x14, 0x2b5

    #Unmapped address 0xf3e testing: random write/read operations
    #Address 0xf3e read value
    csrr x14, 0xf3e

    #Address 0xf3e read value
    csrr x14, 0xf3e

    #Address 0xf3e Write value 0x103d0967
    li x3, 0x103d0967
    csrw 0xf3e, x3

    #Unmapped address 0xeb9 testing: random write/read operations
    #Address 0xeb9 read value
    csrr x14, 0xeb9

    #Unmapped address 0x977 testing: random write/read operations
    #Address 0x977 Write value 0xab7d077
    li x3, 0xab7d077
    csrw 0x977, x3

    #Address 0x977 read value
    csrr x14, 0x977

    #Unmapped address 0x24d testing: random write/read operations
    #Address 0x24d Write value 0x2318e144
    li x3, 0x2318e144
    csrw 0x24d, x3

    #Unmapped address 0xe5b testing: random write/read operations
    #Address 0xe5b read value
    csrr x14, 0xe5b

    #Address 0xe5b Write value 0x1eeb3180
    li x3, 0x1eeb3180
    csrw 0xe5b, x3

    #Address 0xe5b read value
    csrr x14, 0xe5b

    #Address 0xe5b Write value 0xac4a1244
    li x3, 0xac4a1244
    csrw 0xe5b, x3

    #Address 0xe5b read value
    csrr x14, 0xe5b

    #Unmapped address 0xe7e testing: random write/read operations
    #Address 0xe7e read value
    csrr x14, 0xe7e

    #Unmapped address 0xbc9 testing: random write/read operations
    #Address 0xbc9 read value
    csrr x14, 0xbc9

    #Address 0xbc9 Write value 0x8b3a6b8d
    li x3, 0x8b3a6b8d
    csrw 0xbc9, x3

    #Address 0xbc9 Write value 0xf7d5ea55
    li x3, 0xf7d5ea55
    csrw 0xbc9, x3

    #Address 0xbc9 read value
    csrr x14, 0xbc9

    #Address 0xbc9 Write value 0x523d3cf4
    li x3, 0x523d3cf4
    csrw 0xbc9, x3

    #Unmapped address 0x507 testing: random write/read operations
    #Address 0x507 Write value 0xb06d6ab9
    li x3, 0xb06d6ab9
    csrw 0x507, x3

    #Address 0x507 read value
    csrr x14, 0x507

    #Address 0x507 Write value 0x36a1753c
    li x3, 0x36a1753c
    csrw 0x507, x3

    #Address 0x507 Write value 0x3042248b
    li x3, 0x3042248b
    csrw 0x507, x3

    #Address 0x507 Write value 0xe0b4c0b
    li x3, 0xe0b4c0b
    csrw 0x507, x3

    #Unmapped address 0x704 testing: random write/read operations
    #Address 0x704 Write value 0xf9827cf7
    li x3, 0xf9827cf7
    csrw 0x704, x3

    #Address 0x704 Write value 0x467c93fc
    li x3, 0x467c93fc
    csrw 0x704, x3

    #Address 0x704 read value
    csrr x14, 0x704

    #Address 0x704 Write value 0xade27879
    li x3, 0xade27879
    csrw 0x704, x3

    #Address 0x704 read value
    csrr x14, 0x704

    #Unmapped address 0x80d testing: random write/read operations
    #Address 0x80d read value
    csrr x14, 0x80d

    #Address 0x80d Write value 0x487dabb9
    li x3, 0x487dabb9
    csrw 0x80d, x3

    #Address 0x80d read value
    csrr x14, 0x80d

    #Address 0x80d read value
    csrr x14, 0x80d

    #Unmapped address 0xa9e testing: random write/read operations
    #Address 0xa9e Write value 0x982ca5f
    li x3, 0x982ca5f
    csrw 0xa9e, x3

    #Address 0xa9e read value
    csrr x14, 0xa9e

    #Unmapped address 0x5b5 testing: random write/read operations
    #Address 0x5b5 read value
    csrr x14, 0x5b5

    #Address 0x5b5 Write value 0xc609c91c
    li x3, 0xc609c91c
    csrw 0x5b5, x3

    #Address 0x5b5 read value
    csrr x14, 0x5b5

    #Address 0x5b5 read value
    csrr x14, 0x5b5

    #Unmapped address 0x72c testing: random write/read operations
    #Address 0x72c read value
    csrr x14, 0x72c

    #Address 0x72c Write value 0xf3a92a96
    li x3, 0xf3a92a96
    csrw 0x72c, x3

    #Address 0x72c Write value 0x3b50ec9f
    li x3, 0x3b50ec9f
    csrw 0x72c, x3

    #Address 0x72c Write value 0x8e29c677
    li x3, 0x8e29c677
    csrw 0x72c, x3

    #Address 0x72c Write value 0x64beb65d
    li x3, 0x64beb65d
    csrw 0x72c, x3

    #Unmapped address 0x601 testing: random write/read operations
    #Address 0x601 read value
    csrr x14, 0x601

    #Address 0x601 Write value 0xce49a9b6
    li x3, 0xce49a9b6
    csrw 0x601, x3

    #Address 0x601 Write value 0x32449425
    li x3, 0x32449425
    csrw 0x601, x3

    #Address 0x601 Write value 0x896f05a8
    li x3, 0x896f05a8
    csrw 0x601, x3

    #Unmapped address 0xa44 testing: random write/read operations
    #Address 0xa44 read value
    csrr x14, 0xa44

    #Address 0xa44 read value
    csrr x14, 0xa44

    #Address 0xa44 read value
    csrr x14, 0xa44

    #Address 0xa44 Write value 0xf519d321
    li x3, 0xf519d321
    csrw 0xa44, x3

    #Address 0xa44 Write value 0x595ab4dd
    li x3, 0x595ab4dd
    csrw 0xa44, x3

    #Unmapped address 0x4b8 testing: random write/read operations
    #Address 0x4b8 Write value 0x7ac48bc
    li x3, 0x7ac48bc
    csrw 0x4b8, x3

    #Unmapped address 0xe98 testing: random write/read operations
    #Address 0xe98 Write value 0x7fdafb84
    li x3, 0x7fdafb84
    csrw 0xe98, x3

    #Address 0xe98 read value
    csrr x14, 0xe98

    #Unmapped address 0x66a testing: random write/read operations
    #Address 0x66a Write value 0x594e4d5e
    li x3, 0x594e4d5e
    csrw 0x66a, x3

    #Address 0x66a Write value 0xb7680829
    li x3, 0xb7680829
    csrw 0x66a, x3

    #Address 0x66a read value
    csrr x14, 0x66a

    #Unmapped address 0x594 testing: random write/read operations
    #Address 0x594 read value
    csrr x14, 0x594

    #Unmapped address 0xca8 testing: random write/read operations
    #Address 0xca8 read value
    csrr x14, 0xca8

    #Address 0xca8 read value
    csrr x14, 0xca8

    #Address 0xca8 Write value 0x229fdf5f
    li x3, 0x229fdf5f
    csrw 0xca8, x3

    #Address 0xca8 Write value 0xb970fc57
    li x3, 0xb970fc57
    csrw 0xca8, x3

    #Address 0xca8 read value
    csrr x14, 0xca8

    #Unmapped address 0x9a6 testing: random write/read operations
    #Address 0x9a6 read value
    csrr x14, 0x9a6

    #Address 0x9a6 read value
    csrr x14, 0x9a6

    #Address 0x9a6 read value
    csrr x14, 0x9a6

    #Address 0x9a6 read value
    csrr x14, 0x9a6

    #Address 0x9a6 read value
    csrr x14, 0x9a6

    #Unmapped address 0x35b testing: random write/read operations
    #Address 0x35b Write value 0x43e0b2af
    li x3, 0x43e0b2af
    csrw 0x35b, x3

    #Address 0x35b read value
    csrr x14, 0x35b

    #Unmapped address 0x54c testing: random write/read operations
    #Address 0x54c read value
    csrr x14, 0x54c

    #Address 0x54c read value
    csrr x14, 0x54c

    #Address 0x54c Write value 0x3738249b
    li x3, 0x3738249b
    csrw 0x54c, x3

    #Unmapped address 0x226 testing: random write/read operations
    #Address 0x226 read value
    csrr x14, 0x226

    #Address 0x226 Write value 0xb6715d71
    li x3, 0xb6715d71
    csrw 0x226, x3

    #Address 0x226 Write value 0xe609e673
    li x3, 0xe609e673
    csrw 0x226, x3

    #Address 0x226 read value
    csrr x14, 0x226

    #Address 0x226 Write value 0xfac3edbc
    li x3, 0xfac3edbc
    csrw 0x226, x3

    #Unmapped address 0x4da testing: random write/read operations
    #Address 0x4da read value
    csrr x14, 0x4da

    #Address 0x4da read value
    csrr x14, 0x4da

    #Unmapped address 0x8d9 testing: random write/read operations
    #Address 0x8d9 Write value 0xe3922b80
    li x3, 0xe3922b80
    csrw 0x8d9, x3

    #Unmapped address 0x18b testing: random write/read operations
    #Address 0x18b read value
    csrr x14, 0x18b

    #Address 0x18b read value
    csrr x14, 0x18b

    #Address 0x18b Write value 0xc51631db
    li x3, 0xc51631db
    csrw 0x18b, x3

    #Unmapped address 0xc51 testing: random write/read operations
    #Address 0xc51 read value
    csrr x14, 0xc51

    #Address 0xc51 read value
    csrr x14, 0xc51

    #Unmapped address 0x82f testing: random write/read operations
    #Address 0x82f read value
    csrr x14, 0x82f

    #Address 0x82f read value
    csrr x14, 0x82f

    #Address 0x82f Write value 0x49ed218a
    li x3, 0x49ed218a
    csrw 0x82f, x3

    #Address 0x82f read value
    csrr x14, 0x82f

    #Address 0x82f read value
    csrr x14, 0x82f

    #Unmapped address 0xc52 testing: random write/read operations
    #Address 0xc52 Write value 0x6b005322
    li x3, 0x6b005322
    csrw 0xc52, x3

    #Address 0xc52 read value
    csrr x14, 0xc52

    #Address 0xc52 read value
    csrr x14, 0xc52

    #Address 0xc52 Write value 0xb04860c8
    li x3, 0xb04860c8
    csrw 0xc52, x3

    #Unmapped address 0x9db testing: random write/read operations
    #Address 0x9db Write value 0xfaba9abd
    li x3, 0xfaba9abd
    csrw 0x9db, x3

    #Address 0x9db Write value 0xcd49d3f0
    li x3, 0xcd49d3f0
    csrw 0x9db, x3

    #Unmapped address 0x255 testing: random write/read operations
    #Address 0x255 read value
    csrr x14, 0x255

    #Address 0x255 read value
    csrr x14, 0x255

    #Address 0x255 Write value 0x85f6619c
    li x3, 0x85f6619c
    csrw 0x255, x3

    #Unmapped address 0x7b testing: random write/read operations
    #Address 0x7b Write value 0xb71ec0f7
    li x3, 0xb71ec0f7
    csrw 0x7b, x3

    #Address 0x7b read value
    csrr x14, 0x7b

    #Address 0x7b read value
    csrr x14, 0x7b

    #Address 0x7b Write value 0x2605a592
    li x3, 0x2605a592
    csrw 0x7b, x3

    #Unmapped address 0xf87 testing: random write/read operations
    #Address 0xf87 Write value 0x39b0716d
    li x3, 0x39b0716d
    csrw 0xf87, x3

    #Address 0xf87 read value
    csrr x14, 0xf87

    #Mapped address 0x337 (mhpmevent23) testing: random write/read operations
    #Address 0x337 read value
    csrr x14, 0x337

    #Address 0x337 Write value 0xd69d0777
    li x3, 0xd69d0777
    csrw 0x337, x3

    #Address 0x337 read value
    csrr x14, 0x337

    #Unmapped address 0x9 testing: random write/read operations
    #Address 0x9 read value
    csrr x14, 0x9

    #Unmapped address 0xe7b testing: random write/read operations
    #Address 0xe7b Write value 0x874e3c1b
    li x3, 0x874e3c1b
    csrw 0xe7b, x3

    #Address 0xe7b read value
    csrr x14, 0xe7b

    #Address 0xe7b read value
    csrr x14, 0xe7b

    #Unmapped address 0x26b testing: random write/read operations
    #Address 0x26b read value
    csrr x14, 0x26b

    #Address 0x26b Write value 0xdaf33ac6
    li x3, 0xdaf33ac6
    csrw 0x26b, x3

    #Address 0x26b read value
    csrr x14, 0x26b

    #Unmapped address 0xe1c testing: random write/read operations
    #Address 0xe1c Write value 0x28a9ab73
    li x3, 0x28a9ab73
    csrw 0xe1c, x3

    #Address 0xe1c read value
    csrr x14, 0xe1c

    #Address 0xe1c read value
    csrr x14, 0xe1c

    #Address 0xe1c Write value 0x286fa60d
    li x3, 0x286fa60d
    csrw 0xe1c, x3

    #Address 0xe1c Write value 0xbd2b3739
    li x3, 0xbd2b3739
    csrw 0xe1c, x3

    #Unmapped address 0x8a7 testing: random write/read operations
    #Address 0x8a7 Write value 0xa7775cb7
    li x3, 0xa7775cb7
    csrw 0x8a7, x3

    #Address 0x8a7 Write value 0x31979cf
    li x3, 0x31979cf
    csrw 0x8a7, x3

    #Address 0x8a7 read value
    csrr x14, 0x8a7

    #Address 0x8a7 read value
    csrr x14, 0x8a7

    #Address 0x8a7 Write value 0x8ce962eb
    li x3, 0x8ce962eb
    csrw 0x8a7, x3

    #Unmapped address 0xddd testing: random write/read operations
    #Address 0xddd read value
    csrr x14, 0xddd

    #Unmapped address 0xcff testing: random write/read operations
    #Address 0xcff Write value 0xd866ce63
    li x3, 0xd866ce63
    csrw 0xcff, x3

    #Address 0xcff Write value 0x40a3eeb2
    li x3, 0x40a3eeb2
    csrw 0xcff, x3

    #Address 0xcff Write value 0x25b0cf72
    li x3, 0x25b0cf72
    csrw 0xcff, x3

    #Address 0xcff Write value 0x4fc271ac
    li x3, 0x4fc271ac
    csrw 0xcff, x3

    #Address 0xcff Write value 0x2ad16b92
    li x3, 0x2ad16b92
    csrw 0xcff, x3

    #Unmapped address 0x95b testing: random write/read operations
    #Address 0x95b Write value 0x84679e19
    li x3, 0x84679e19
    csrw 0x95b, x3

    #Unmapped address 0x57e testing: random write/read operations
    #Address 0x57e read value
    csrr x14, 0x57e

    #Address 0x57e read value
    csrr x14, 0x57e

    #Address 0x57e read value
    csrr x14, 0x57e

    #Unmapped address 0xa3 testing: random write/read operations
    #Address 0xa3 read value
    csrr x14, 0xa3

    #Address 0xa3 read value
    csrr x14, 0xa3

    #Address 0xa3 read value
    csrr x14, 0xa3

    #Address 0xa3 read value
    csrr x14, 0xa3

    #Address 0xa3 read value
    csrr x14, 0xa3

    #Unmapped address 0x722 testing: random write/read operations
    #Address 0x722 read value
    csrr x14, 0x722

    #Address 0x722 Write value 0xfee8ebc7
    li x3, 0xfee8ebc7
    csrw 0x722, x3

    #Address 0x722 read value
    csrr x14, 0x722

    #Address 0x722 Write value 0x79f654e1
    li x3, 0x79f654e1
    csrw 0x722, x3

    #Unmapped address 0x75f testing: random write/read operations
    #Address 0x75f Write value 0xd2ab3277
    li x3, 0xd2ab3277
    csrw 0x75f, x3

    #Address 0x75f Write value 0xba799a49
    li x3, 0xba799a49
    csrw 0x75f, x3

    #Unmapped address 0xeea testing: random write/read operations
    #Address 0xeea read value
    csrr x14, 0xeea

    #Unmapped address 0xebb testing: random write/read operations
    #Address 0xebb Write value 0xcd91441b
    li x3, 0xcd91441b
    csrw 0xebb, x3

    #Address 0xebb read value
    csrr x14, 0xebb

    #Unmapped address 0xcad testing: random write/read operations
    #Address 0xcad Write value 0xc4e5d547
    li x3, 0xc4e5d547
    csrw 0xcad, x3

    #Address 0xcad read value
    csrr x14, 0xcad

    #Address 0xcad Write value 0xe0d9848e
    li x3, 0xe0d9848e
    csrw 0xcad, x3

    #Unmapped address 0xfa0 testing: random write/read operations
    #Address 0xfa0 read value
    csrr x14, 0xfa0

    #Unmapped address 0x19c testing: random write/read operations
    #Address 0x19c read value
    csrr x14, 0x19c

    #Address 0x19c Write value 0x78fceacb
    li x3, 0x78fceacb
    csrw 0x19c, x3

    #Address 0x19c Write value 0x8a3733dc
    li x3, 0x8a3733dc
    csrw 0x19c, x3

    #Unmapped address 0x1c testing: random write/read operations
    #Address 0x1c Write value 0x9b6c874b
    li x3, 0x9b6c874b
    csrw 0x1c, x3

    #Address 0x1c Write value 0x306342ee
    li x3, 0x306342ee
    csrw 0x1c, x3

    #Unmapped address 0xfc4 testing: random write/read operations
    #Address 0xfc4 read value
    csrr x14, 0xfc4

    #Address 0xfc4 read value
    csrr x14, 0xfc4

    #Address 0xfc4 Write value 0x72e21dd4
    li x3, 0x72e21dd4
    csrw 0xfc4, x3

    #Unmapped address 0xe43 testing: random write/read operations
    #Address 0xe43 Write value 0xe54326bb
    li x3, 0xe54326bb
    csrw 0xe43, x3

    #Address 0xe43 Write value 0x47472b3c
    li x3, 0x47472b3c
    csrw 0xe43, x3

    #Address 0xe43 Write value 0x9463cb40
    li x3, 0x9463cb40
    csrw 0xe43, x3

    #Unmapped address 0x1d testing: random write/read operations
    #Address 0x1d read value
    csrr x14, 0x1d

    #Address 0x1d read value
    csrr x14, 0x1d

    #Unmapped address 0x3ef testing: random write/read operations
    #Address 0x3ef read value
    csrr x14, 0x3ef

    #Address 0x3ef read value
    csrr x14, 0x3ef

    #Unmapped address 0xa98 testing: random write/read operations
    #Address 0xa98 Write value 0x806dfdf5
    li x3, 0x806dfdf5
    csrw 0xa98, x3

    #Address 0xa98 Write value 0xb908127a
    li x3, 0xb908127a
    csrw 0xa98, x3

    #Unmapped address 0x111 testing: random write/read operations
    #Address 0x111 read value
    csrr x14, 0x111

    #Address 0x111 read value
    csrr x14, 0x111

    #Address 0x111 read value
    csrr x14, 0x111

    #Address 0x111 Write value 0xb9582c8e
    li x3, 0xb9582c8e
    csrw 0x111, x3

    #Unmapped address 0xa38 testing: random write/read operations
    #Address 0xa38 Write value 0x3756906b
    li x3, 0x3756906b
    csrw 0xa38, x3

    #Unmapped address 0x7be testing: random write/read operations
    #Address 0x7be Write value 0xac09137c
    li x3, 0xac09137c
    csrw 0x7be, x3

    #Address 0x7be Write value 0xad14634d
    li x3, 0xad14634d
    csrw 0x7be, x3

    #Address 0x7be read value
    csrr x14, 0x7be

    #Unmapped address 0x60b testing: random write/read operations
    #Address 0x60b Write value 0xa91f1d7c
    li x3, 0xa91f1d7c
    csrw 0x60b, x3

    #Address 0x60b read value
    csrr x14, 0x60b

    #Address 0x60b Write value 0x98a31d9a
    li x3, 0x98a31d9a
    csrw 0x60b, x3

    #Unmapped address 0xe8f testing: random write/read operations
    #Address 0xe8f Write value 0x171680f8
    li x3, 0x171680f8
    csrw 0xe8f, x3

    #Address 0xe8f Write value 0x6edfb684
    li x3, 0x6edfb684
    csrw 0xe8f, x3

    #Unmapped address 0xd01 testing: random write/read operations
    #Address 0xd01 read value
    csrr x14, 0xd01

    #Address 0xd01 Write value 0x1a9d53f9
    li x3, 0x1a9d53f9
    csrw 0xd01, x3

    #Address 0xd01 Write value 0x638b9e06
    li x3, 0x638b9e06
    csrw 0xd01, x3

    #Address 0xd01 read value
    csrr x14, 0xd01

    #Address 0xd01 read value
    csrr x14, 0xd01

    #Unmapped address 0x516 testing: random write/read operations
    #Address 0x516 read value
    csrr x14, 0x516

    #Address 0x516 Write value 0x3f395725
    li x3, 0x3f395725
    csrw 0x516, x3

    #Address 0x516 Write value 0x9f800d28
    li x3, 0x9f800d28
    csrw 0x516, x3

    #Address 0x516 Write value 0xbf0edbf2
    li x3, 0xbf0edbf2
    csrw 0x516, x3

    #Address 0x516 Write value 0x6189f7ea
    li x3, 0x6189f7ea
    csrw 0x516, x3

    #Unmapped address 0x90c testing: random write/read operations
    #Address 0x90c read value
    csrr x14, 0x90c

    #Address 0x90c Write value 0x864cd4fb
    li x3, 0x864cd4fb
    csrw 0x90c, x3

    #Address 0x90c Write value 0xbf80ce4
    li x3, 0xbf80ce4
    csrw 0x90c, x3

    #Address 0x90c read value
    csrr x14, 0x90c

    #Unmapped address 0x8e3 testing: random write/read operations
    #Address 0x8e3 Write value 0x27310d0
    li x3, 0x27310d0
    csrw 0x8e3, x3

    #Address 0x8e3 Write value 0x3c7716b
    li x3, 0x3c7716b
    csrw 0x8e3, x3

    #Mapped address 0x310 (mstatush) testing: random write/read operations
    #Address 0x310 read value
    csrr x14, 0x310

    #Address 0x310 read value
    csrr x14, 0x310

    #Address 0x310 Write value 0x5f3a43e
    li x3, 0x5f3a43e
    csrw 0x310, x3

    #Unmapped address 0xef6 testing: random write/read operations
    #Address 0xef6 Write value 0x250c5345
    li x3, 0x250c5345
    csrw 0xef6, x3

    #Address 0xef6 Write value 0x5ad6805b
    li x3, 0x5ad6805b
    csrw 0xef6, x3

    #Address 0xef6 Write value 0x8a281986
    li x3, 0x8a281986
    csrw 0xef6, x3

    #Address 0xef6 Write value 0x41c95ad1
    li x3, 0x41c95ad1
    csrw 0xef6, x3

    #Address 0xef6 read value
    csrr x14, 0xef6

    #Mapped address 0x33c (mhpmevent28) testing: random write/read operations
    #Address 0x33c Write value 0x3a9f29e1
    li x3, 0x3a9f29e1
    csrw 0x33c, x3

    #Unmapped address 0xece testing: random write/read operations
    #Address 0xece Write value 0x2bdd32bf
    li x3, 0x2bdd32bf
    csrw 0xece, x3

    #Unmapped address 0x3a9 testing: random write/read operations
    #Address 0x3a9 Write value 0x5cb81aa8
    li x3, 0x5cb81aa8
    csrw 0x3a9, x3

    #Unmapped address 0xe94 testing: random write/read operations
    #Address 0xe94 Write value 0xb5ae156f
    li x3, 0xb5ae156f
    csrw 0xe94, x3

    #Address 0xe94 read value
    csrr x14, 0xe94

    #Unmapped address 0x42b testing: random write/read operations
    #Address 0x42b read value
    csrr x14, 0x42b

    #Address 0x42b Write value 0x4398ec89
    li x3, 0x4398ec89
    csrw 0x42b, x3

    #Address 0x42b read value
    csrr x14, 0x42b

    #Address 0x42b read value
    csrr x14, 0x42b

    #Unmapped address 0xc13 testing: random write/read operations
    #Address 0xc13 read value
    csrr x14, 0xc13

    #Address 0xc13 Write value 0xd540d26f
    li x3, 0xd540d26f
    csrw 0xc13, x3

    #Address 0xc13 read value
    csrr x14, 0xc13

    #Address 0xc13 read value
    csrr x14, 0xc13

    #Unmapped address 0x2b9 testing: random write/read operations
    #Address 0x2b9 read value
    csrr x14, 0x2b9

    #Unmapped address 0x796 testing: random write/read operations
    #Address 0x796 Write value 0xd8c930f2
    li x3, 0xd8c930f2
    csrw 0x796, x3

    #Address 0x796 Write value 0x80e68128
    li x3, 0x80e68128
    csrw 0x796, x3

    #Address 0x796 Write value 0x11edf04
    li x3, 0x11edf04
    csrw 0x796, x3

    #Address 0x796 read value
    csrr x14, 0x796

    #Address 0x796 read value
    csrr x14, 0x796

    #Mapped address 0x336 (mhpmevent22) testing: random write/read operations
    #Address 0x336 Write value 0x55fd2627
    li x3, 0x55fd2627
    csrw 0x336, x3

    #Unmapped address 0x8dd testing: random write/read operations
    #Address 0x8dd read value
    csrr x14, 0x8dd

    #Address 0x8dd read value
    csrr x14, 0x8dd

    #Address 0x8dd read value
    csrr x14, 0x8dd

    #Address 0x8dd read value
    csrr x14, 0x8dd

    #Address 0x8dd Write value 0x3d74764f
    li x3, 0x3d74764f
    csrw 0x8dd, x3

    #Unmapped address 0x870 testing: random write/read operations
    #Address 0x870 Write value 0x66aceaec
    li x3, 0x66aceaec
    csrw 0x870, x3

    #Address 0x870 Write value 0xd3ced2ae
    li x3, 0xd3ced2ae
    csrw 0x870, x3

    #Address 0x870 read value
    csrr x14, 0x870

    #Address 0x870 Write value 0x4b6a8c2c
    li x3, 0x4b6a8c2c
    csrw 0x870, x3

    #Address 0x870 Write value 0xf968d23a
    li x3, 0xf968d23a
    csrw 0x870, x3

    #Unmapped address 0xdf0 testing: random write/read operations
    #Address 0xdf0 Write value 0xe4cf67ac
    li x3, 0xe4cf67ac
    csrw 0xdf0, x3

    #Unmapped address 0x9a3 testing: random write/read operations
    #Address 0x9a3 Write value 0xa5c6077b
    li x3, 0xa5c6077b
    csrw 0x9a3, x3

    #Address 0x9a3 Write value 0x42199ae4
    li x3, 0x42199ae4
    csrw 0x9a3, x3

    #Address 0x9a3 read value
    csrr x14, 0x9a3

    #Unmapped address 0xd3d testing: random write/read operations
    #Address 0xd3d read value
    csrr x14, 0xd3d

    #Unmapped address 0x5a7 testing: random write/read operations
    #Address 0x5a7 read value
    csrr x14, 0x5a7

    #Address 0x5a7 read value
    csrr x14, 0x5a7

    #Address 0x5a7 read value
    csrr x14, 0x5a7

    #Address 0x5a7 Write value 0x2592c590
    li x3, 0x2592c590
    csrw 0x5a7, x3

    #Mapped address 0xb1c (mhpmcounter28) testing: random write/read operations
    #Address 0xb1c Write value 0x8d14787e
    li x3, 0x8d14787e
    csrw 0xb1c, x3

    #Unmapped address 0xf28 testing: random write/read operations
    #Address 0xf28 read value
    csrr x14, 0xf28

    #Unmapped address 0xee3 testing: random write/read operations
    #Address 0xee3 read value
    csrr x14, 0xee3

    #Unmapped address 0x5f0 testing: random write/read operations
    #Address 0x5f0 read value
    csrr x14, 0x5f0

    #Address 0x5f0 Write value 0xa073e1ba
    li x3, 0xa073e1ba
    csrw 0x5f0, x3

    #Address 0x5f0 Write value 0x5dbfa9ef
    li x3, 0x5dbfa9ef
    csrw 0x5f0, x3

    #Address 0x5f0 read value
    csrr x14, 0x5f0

    #Unmapped address 0x909 testing: random write/read operations
    #Address 0x909 Write value 0x38b38d31
    li x3, 0x38b38d31
    csrw 0x909, x3

    #Address 0x909 Write value 0xa3954c7d
    li x3, 0xa3954c7d
    csrw 0x909, x3

    #Address 0x909 read value
    csrr x14, 0x909

    #Address 0x909 read value
    csrr x14, 0x909

    #Address 0x909 read value
    csrr x14, 0x909

    #Unmapped address 0xbdf testing: random write/read operations
    #Address 0xbdf read value
    csrr x14, 0xbdf

    #Address 0xbdf Write value 0x7e380013
    li x3, 0x7e380013
    csrw 0xbdf, x3

    #Unmapped address 0x3f7 testing: random write/read operations
    #Address 0x3f7 Write value 0x381a1866
    li x3, 0x381a1866
    csrw 0x3f7, x3

    #Unmapped address 0x9c2 testing: random write/read operations
    #Address 0x9c2 Write value 0x169dfdc6
    li x3, 0x169dfdc6
    csrw 0x9c2, x3

    #Unmapped address 0x6da testing: random write/read operations
    #Address 0x6da read value
    csrr x14, 0x6da

    #Address 0x6da read value
    csrr x14, 0x6da

    #Address 0x6da Write value 0xaa314dc
    li x3, 0xaa314dc
    csrw 0x6da, x3

    #Address 0x6da Write value 0xbe92f693
    li x3, 0xbe92f693
    csrw 0x6da, x3

    #Address 0x6da read value
    csrr x14, 0x6da

    #Unmapped address 0xa1d testing: random write/read operations
    #Address 0xa1d Write value 0x377a0855
    li x3, 0x377a0855
    csrw 0xa1d, x3

    #Address 0xa1d Write value 0x92c8edd4
    li x3, 0x92c8edd4
    csrw 0xa1d, x3

    #Unmapped address 0xcf2 testing: random write/read operations
    #Address 0xcf2 Write value 0x8269d582
    li x3, 0x8269d582
    csrw 0xcf2, x3

    #Address 0xcf2 Write value 0x617ca36f
    li x3, 0x617ca36f
    csrw 0xcf2, x3

    #Address 0xcf2 read value
    csrr x14, 0xcf2

    #Address 0xcf2 read value
    csrr x14, 0xcf2

    #Address 0xcf2 Write value 0x79941783
    li x3, 0x79941783
    csrw 0xcf2, x3

    #Unmapped address 0x659 testing: random write/read operations
    #Address 0x659 read value
    csrr x14, 0x659

    #Address 0x659 Write value 0xe9f00fe4
    li x3, 0xe9f00fe4
    csrw 0x659, x3

    #Address 0x659 read value
    csrr x14, 0x659

    #Unmapped address 0xbc7 testing: random write/read operations
    #Address 0xbc7 Write value 0x596a1c4d
    li x3, 0x596a1c4d
    csrw 0xbc7, x3

    #Address 0xbc7 read value
    csrr x14, 0xbc7

    #Unmapped address 0x795 testing: random write/read operations
    #Address 0x795 read value
    csrr x14, 0x795

    #Address 0x795 read value
    csrr x14, 0x795

    #Address 0x795 Write value 0x180013a9
    li x3, 0x180013a9
    csrw 0x795, x3

    #Address 0x795 Write value 0x1d9a7291
    li x3, 0x1d9a7291
    csrw 0x795, x3

    #Unmapped address 0xade testing: random write/read operations
    #Address 0xade read value
    csrr x14, 0xade

    #Address 0xade Write value 0x248183e3
    li x3, 0x248183e3
    csrw 0xade, x3

    #Unmapped address 0x7 testing: random write/read operations
    #Address 0x7 read value
    csrr x14, 0x7

    #Address 0x7 read value
    csrr x14, 0x7

    #Address 0x7 read value
    csrr x14, 0x7

    #Address 0x7 Write value 0x9040843
    li x3, 0x9040843
    csrw 0x7, x3

    #Address 0x7 Write value 0x9cd36e05
    li x3, 0x9cd36e05
    csrw 0x7, x3

    #Unmapped address 0x748 testing: random write/read operations
    #Address 0x748 Write value 0xec8c5fce
    li x3, 0xec8c5fce
    csrw 0x748, x3

    #Address 0x748 Write value 0x7d6f28bd
    li x3, 0x7d6f28bd
    csrw 0x748, x3

    #Unmapped address 0x91c testing: random write/read operations
    #Address 0x91c Write value 0x1a9f0ecf
    li x3, 0x1a9f0ecf
    csrw 0x91c, x3

    #Address 0x91c read value
    csrr x14, 0x91c

    #Address 0x91c Write value 0xbb655092
    li x3, 0xbb655092
    csrw 0x91c, x3

    #Address 0x91c read value
    csrr x14, 0x91c

    #Unmapped address 0x1e1 testing: random write/read operations
    #Address 0x1e1 read value
    csrr x14, 0x1e1

    #Address 0x1e1 Write value 0x144ac380
    li x3, 0x144ac380
    csrw 0x1e1, x3

    #Unmapped address 0xc7c testing: random write/read operations
    #Address 0xc7c read value
    csrr x14, 0xc7c

    #Address 0xc7c Write value 0x5e6a23b1
    li x3, 0x5e6a23b1
    csrw 0xc7c, x3

    #Address 0xc7c read value
    csrr x14, 0xc7c

    #Unmapped address 0x306 testing: random write/read operations
    #Address 0x306 Write value 0x836f3466
    li x3, 0x836f3466
    csrw 0x306, x3

    #Unmapped address 0xc3f testing: random write/read operations
    #Address 0xc3f Write value 0xfb055347
    li x3, 0xfb055347
    csrw 0xc3f, x3

    #Address 0xc3f read value
    csrr x14, 0xc3f

    #Unmapped address 0xb72 testing: random write/read operations
    #Address 0xb72 read value
    csrr x14, 0xb72

    #Unmapped address 0x55c testing: random write/read operations
    #Address 0x55c read value
    csrr x14, 0x55c

    #Address 0x55c Write value 0x5efe2af6
    li x3, 0x5efe2af6
    csrw 0x55c, x3

    #Unmapped address 0x4ac testing: random write/read operations
    #Address 0x4ac read value
    csrr x14, 0x4ac

    #Address 0x4ac read value
    csrr x14, 0x4ac

    #Address 0x4ac Write value 0x7b361634
    li x3, 0x7b361634
    csrw 0x4ac, x3

    #Address 0x4ac Write value 0x7bc690b3
    li x3, 0x7bc690b3
    csrw 0x4ac, x3

    #Unmapped address 0xf88 testing: random write/read operations
    #Address 0xf88 Write value 0x7189a60a
    li x3, 0x7189a60a
    csrw 0xf88, x3

    #Address 0xf88 Write value 0xb962e22d
    li x3, 0xb962e22d
    csrw 0xf88, x3

    #Address 0xf88 read value
    csrr x14, 0xf88

    #Unmapped address 0xb36 testing: random write/read operations
    #Address 0xb36 read value
    csrr x14, 0xb36

    #Address 0xb36 Write value 0x45d7c221
    li x3, 0x45d7c221
    csrw 0xb36, x3

    #Address 0xb36 read value
    csrr x14, 0xb36

    #Unmapped address 0x20d testing: random write/read operations
    #Address 0x20d read value
    csrr x14, 0x20d

    #Address 0x20d Write value 0xa6fae190
    li x3, 0xa6fae190
    csrw 0x20d, x3

    #Address 0x20d read value
    csrr x14, 0x20d

    #Unmapped address 0xe75 testing: random write/read operations
    #Address 0xe75 Write value 0x9912db3c
    li x3, 0x9912db3c
    csrw 0xe75, x3

    #Unmapped address 0x72b testing: random write/read operations
    #Address 0x72b Write value 0xb97ab223
    li x3, 0xb97ab223
    csrw 0x72b, x3

    #Address 0x72b read value
    csrr x14, 0x72b

    #Address 0x72b Write value 0x28839abd
    li x3, 0x28839abd
    csrw 0x72b, x3

    #Address 0x72b read value
    csrr x14, 0x72b

    #Address 0x72b Write value 0x9e7a5ea8
    li x3, 0x9e7a5ea8
    csrw 0x72b, x3

    #Unmapped address 0x888 testing: random write/read operations
    #Address 0x888 read value
    csrr x14, 0x888

    #Address 0x888 read value
    csrr x14, 0x888

    #Address 0x888 Write value 0x6303c707
    li x3, 0x6303c707
    csrw 0x888, x3

    #Address 0x888 read value
    csrr x14, 0x888

    #Address 0x888 read value
    csrr x14, 0x888

    #Unmapped address 0x717 testing: random write/read operations
    #Address 0x717 read value
    csrr x14, 0x717

    #Address 0x717 Write value 0x7438e804
    li x3, 0x7438e804
    csrw 0x717, x3

    #Unmapped address 0x56e testing: random write/read operations
    #Address 0x56e read value
    csrr x14, 0x56e

    #Unmapped address 0x3d testing: random write/read operations
    #Address 0x3d Write value 0xb1cda993
    li x3, 0xb1cda993
    csrw 0x3d, x3

    #Address 0x3d Write value 0x21334b0c
    li x3, 0x21334b0c
    csrw 0x3d, x3

    #Unmapped address 0xc5d testing: random write/read operations
    #Address 0xc5d read value
    csrr x14, 0xc5d

    #Address 0xc5d read value
    csrr x14, 0xc5d

    #Address 0xc5d read value
    csrr x14, 0xc5d

    #Address 0xc5d Write value 0xa6a5f4cf
    li x3, 0xa6a5f4cf
    csrw 0xc5d, x3

    #Unmapped address 0x4e5 testing: random write/read operations
    #Address 0x4e5 read value
    csrr x14, 0x4e5

    #Address 0x4e5 read value
    csrr x14, 0x4e5

    #Address 0x4e5 read value
    csrr x14, 0x4e5

    #Address 0x4e5 Write value 0x69f3cd07
    li x3, 0x69f3cd07
    csrw 0x4e5, x3

    #Address 0x4e5 Write value 0xe197147c
    li x3, 0xe197147c
    csrw 0x4e5, x3

    #Unmapped address 0x9cd testing: random write/read operations
    #Address 0x9cd Write value 0x1d63070f
    li x3, 0x1d63070f
    csrw 0x9cd, x3

    #Address 0x9cd Write value 0x1a71f04e
    li x3, 0x1a71f04e
    csrw 0x9cd, x3

    #Unmapped address 0xa23 testing: random write/read operations
    #Address 0xa23 Write value 0x4d699ab5
    li x3, 0x4d699ab5
    csrw 0xa23, x3

    #Address 0xa23 Write value 0x64f763e
    li x3, 0x64f763e
    csrw 0xa23, x3

    #Address 0xa23 read value
    csrr x14, 0xa23

    #Address 0xa23 Write value 0x1a2ac110
    li x3, 0x1a2ac110
    csrw 0xa23, x3

    #Unmapped address 0xdb9 testing: random write/read operations
    #Address 0xdb9 Write value 0xe24d09bc
    li x3, 0xe24d09bc
    csrw 0xdb9, x3

    #Address 0xdb9 Write value 0x933fedce
    li x3, 0x933fedce
    csrw 0xdb9, x3

    #Address 0xdb9 Write value 0x139831d3
    li x3, 0x139831d3
    csrw 0xdb9, x3

    #Address 0xdb9 read value
    csrr x14, 0xdb9

    #Unmapped address 0xecb testing: random write/read operations
    #Address 0xecb Write value 0x4a28ef45
    li x3, 0x4a28ef45
    csrw 0xecb, x3

    #Address 0xecb read value
    csrr x14, 0xecb

    #Address 0xecb Write value 0xce7104b3
    li x3, 0xce7104b3
    csrw 0xecb, x3

    #Unmapped address 0xdaf testing: random write/read operations
    #Address 0xdaf read value
    csrr x14, 0xdaf

    #Address 0xdaf read value
    csrr x14, 0xdaf

    #Address 0xdaf Write value 0x225b20d1
    li x3, 0x225b20d1
    csrw 0xdaf, x3

    #Address 0xdaf Write value 0x92a82e9a
    li x3, 0x92a82e9a
    csrw 0xdaf, x3

    #Unmapped address 0x519 testing: random write/read operations
    #Address 0x519 Write value 0xc342ad63
    li x3, 0xc342ad63
    csrw 0x519, x3

    #Address 0x519 read value
    csrr x14, 0x519

    #Address 0x519 read value
    csrr x14, 0x519

    #Unmapped address 0x4aa testing: random write/read operations
    #Address 0x4aa read value
    csrr x14, 0x4aa

    #Address 0x4aa Write value 0xb6e8bfec
    li x3, 0xb6e8bfec
    csrw 0x4aa, x3

    #Address 0x4aa Write value 0xceb9c830
    li x3, 0xceb9c830
    csrw 0x4aa, x3

    #Unmapped address 0x61b testing: random write/read operations
    #Address 0x61b read value
    csrr x14, 0x61b

    #Unmapped address 0xbd testing: random write/read operations
    #Address 0xbd read value
    csrr x14, 0xbd

    #Mapped address 0xb05 (mhpmcounter5) testing: random write/read operations
    #Address 0xb05 Write value 0xa8990b15
    li x3, 0xa8990b15
    csrw 0xb05, x3

    #Unmapped address 0x690 testing: random write/read operations
    #Address 0x690 read value
    csrr x14, 0x690

    #Address 0x690 Write value 0x745b83dc
    li x3, 0x745b83dc
    csrw 0x690, x3

    #Unmapped address 0x4fa testing: random write/read operations
    #Address 0x4fa read value
    csrr x14, 0x4fa

    #Address 0x4fa read value
    csrr x14, 0x4fa

    #Address 0x4fa read value
    csrr x14, 0x4fa

    #Address 0x4fa read value
    csrr x14, 0x4fa

    #Unmapped address 0xa9f testing: random write/read operations
    #Address 0xa9f Write value 0x229a5d70
    li x3, 0x229a5d70
    csrw 0xa9f, x3

    #Address 0xa9f Write value 0x4cb37664
    li x3, 0x4cb37664
    csrw 0xa9f, x3

    #Address 0xa9f read value
    csrr x14, 0xa9f

    #Unmapped address 0x71c testing: random write/read operations
    #Address 0x71c read value
    csrr x14, 0x71c

    #Address 0x71c Write value 0xd3a57c37
    li x3, 0xd3a57c37
    csrw 0x71c, x3

    #Address 0x71c read value
    csrr x14, 0x71c

    #Unmapped address 0x79f testing: random write/read operations
    #Address 0x79f read value
    csrr x14, 0x79f

    #Address 0x79f read value
    csrr x14, 0x79f

    #Address 0x79f Write value 0x90752b66
    li x3, 0x90752b66
    csrw 0x79f, x3

    #Address 0x79f Write value 0x67b61346
    li x3, 0x67b61346
    csrw 0x79f, x3

    #Address 0x79f read value
    csrr x14, 0x79f

    #Unmapped address 0x40e testing: random write/read operations
    #Address 0x40e read value
    csrr x14, 0x40e

    #Address 0x40e Write value 0x3372ec4d
    li x3, 0x3372ec4d
    csrw 0x40e, x3

    #Address 0x40e read value
    csrr x14, 0x40e

    #Address 0x40e read value
    csrr x14, 0x40e

    #Unmapped address 0x195 testing: random write/read operations
    #Address 0x195 Write value 0x738909e
    li x3, 0x738909e
    csrw 0x195, x3

    #Address 0x195 Write value 0x23759342
    li x3, 0x23759342
    csrw 0x195, x3

    #Address 0x195 Write value 0x3844ee9a
    li x3, 0x3844ee9a
    csrw 0x195, x3

    #Unmapped address 0x903 testing: random write/read operations
    #Address 0x903 Write value 0x305d2594
    li x3, 0x305d2594
    csrw 0x903, x3

    #Unmapped address 0x40d testing: random write/read operations
    #Address 0x40d Write value 0x8e5f8c00
    li x3, 0x8e5f8c00
    csrw 0x40d, x3

    #Address 0x40d read value
    csrr x14, 0x40d

    #Address 0x40d Write value 0x98db9a60
    li x3, 0x98db9a60
    csrw 0x40d, x3

    #Address 0x40d read value
    csrr x14, 0x40d

    #Address 0x40d read value
    csrr x14, 0x40d

    #Unmapped address 0xe46 testing: random write/read operations
    #Address 0xe46 Write value 0x2adf3113
    li x3, 0x2adf3113
    csrw 0xe46, x3

    #Address 0xe46 Write value 0x45d55821
    li x3, 0x45d55821
    csrw 0xe46, x3

    #Address 0xe46 read value
    csrr x14, 0xe46

    #Unmapped address 0x9c0 testing: random write/read operations
    #Address 0x9c0 read value
    csrr x14, 0x9c0

    #Address 0x9c0 Write value 0xa19003b2
    li x3, 0xa19003b2
    csrw 0x9c0, x3

    #Address 0x9c0 read value
    csrr x14, 0x9c0

    #Address 0x9c0 Write value 0xf83d01c9
    li x3, 0xf83d01c9
    csrw 0x9c0, x3

    #Address 0x9c0 read value
    csrr x14, 0x9c0

    #Unmapped address 0x2df testing: random write/read operations
    #Address 0x2df Write value 0x30449ae4
    li x3, 0x30449ae4
    csrw 0x2df, x3

    #Unmapped address 0xbc2 testing: random write/read operations
    #Address 0xbc2 Write value 0x45da5bb9
    li x3, 0x45da5bb9
    csrw 0xbc2, x3

    #Address 0xbc2 read value
    csrr x14, 0xbc2

    #Address 0xbc2 read value
    csrr x14, 0xbc2

    #Address 0xbc2 read value
    csrr x14, 0xbc2

    #Address 0xbc2 read value
    csrr x14, 0xbc2

    #Unmapped address 0x283 testing: random write/read operations
    #Address 0x283 Write value 0xe8aa27be
    li x3, 0xe8aa27be
    csrw 0x283, x3

    #Address 0x283 Write value 0x5e40878c
    li x3, 0x5e40878c
    csrw 0x283, x3

    #Unmapped address 0x769 testing: random write/read operations
    #Address 0x769 Write value 0xf5e18084
    li x3, 0xf5e18084
    csrw 0x769, x3

    #Address 0x769 Write value 0x5fece14
    li x3, 0x5fece14
    csrw 0x769, x3

    #Address 0x769 Write value 0xca1649b3
    li x3, 0xca1649b3
    csrw 0x769, x3

    #Address 0x769 read value
    csrr x14, 0x769

    #Address 0x769 Write value 0x43e81f4
    li x3, 0x43e81f4
    csrw 0x769, x3

    #Unmapped address 0x995 testing: random write/read operations
    #Address 0x995 Write value 0x849b5721
    li x3, 0x849b5721
    csrw 0x995, x3

    #Address 0x995 read value
    csrr x14, 0x995

    #Address 0x995 read value
    csrr x14, 0x995

    #Address 0x995 Write value 0x3845f700
    li x3, 0x3845f700
    csrw 0x995, x3

    #Unmapped address 0xe03 testing: random write/read operations
    #Address 0xe03 Write value 0x77067e95
    li x3, 0x77067e95
    csrw 0xe03, x3

    #Address 0xe03 read value
    csrr x14, 0xe03

    #Unmapped address 0x10 testing: random write/read operations
    #Address 0x10 read value
    csrr x14, 0x10

    #Address 0x10 read value
    csrr x14, 0x10

    #Address 0x10 read value
    csrr x14, 0x10

    #Address 0x10 read value
    csrr x14, 0x10

    #Address 0x10 read value
    csrr x14, 0x10

    #Unmapped address 0xc38 testing: random write/read operations
    #Address 0xc38 read value
    csrr x14, 0xc38

    #Unmapped address 0xeb6 testing: random write/read operations
    #Address 0xeb6 read value
    csrr x14, 0xeb6

    #Unmapped address 0xf82 testing: random write/read operations
    #Address 0xf82 read value
    csrr x14, 0xf82

    #Address 0xf82 read value
    csrr x14, 0xf82

    #Address 0xf82 Write value 0x5a182a65
    li x3, 0x5a182a65
    csrw 0xf82, x3

    #Address 0xf82 Write value 0xbff80250
    li x3, 0xbff80250
    csrw 0xf82, x3

    #Address 0xf82 read value
    csrr x14, 0xf82

    #Unmapped address 0xeb3 testing: random write/read operations
    #Address 0xeb3 read value
    csrr x14, 0xeb3

    #Address 0xeb3 Write value 0x3fa93520
    li x3, 0x3fa93520
    csrw 0xeb3, x3

    #Address 0xeb3 read value
    csrr x14, 0xeb3

    #Address 0xeb3 read value
    csrr x14, 0xeb3

    #Unmapped address 0x488 testing: random write/read operations
    #Address 0x488 Write value 0xec24368b
    li x3, 0xec24368b
    csrw 0x488, x3

    #Address 0x488 Write value 0x610994d0
    li x3, 0x610994d0
    csrw 0x488, x3

    #Address 0x488 Write value 0x31779f58
    li x3, 0x31779f58
    csrw 0x488, x3

    #Address 0x488 Write value 0xb309b2fe
    li x3, 0xb309b2fe
    csrw 0x488, x3

    #Address 0x488 read value
    csrr x14, 0x488

    #Unmapped address 0xa8d testing: random write/read operations
    #Address 0xa8d read value
    csrr x14, 0xa8d

    #Address 0xa8d Write value 0xd69e8688
    li x3, 0xd69e8688
    csrw 0xa8d, x3

    #Address 0xa8d Write value 0x7c659d00
    li x3, 0x7c659d00
    csrw 0xa8d, x3

    #Address 0xa8d Write value 0xb8ce4593
    li x3, 0xb8ce4593
    csrw 0xa8d, x3

    #Address 0xa8d read value
    csrr x14, 0xa8d

    #Unmapped address 0xca3 testing: random write/read operations
    #Address 0xca3 Write value 0x473e59bd
    li x3, 0x473e59bd
    csrw 0xca3, x3

    #Address 0xca3 Write value 0xd849a6f8
    li x3, 0xd849a6f8
    csrw 0xca3, x3

    #Address 0xca3 read value
    csrr x14, 0xca3

    #Address 0xca3 Write value 0xd5c6837a
    li x3, 0xd5c6837a
    csrw 0xca3, x3

    #Address 0xca3 read value
    csrr x14, 0xca3

    #Unmapped address 0xe74 testing: random write/read operations
    #Address 0xe74 read value
    csrr x14, 0xe74

    #Address 0xe74 read value
    csrr x14, 0xe74

    #Unmapped address 0xd50 testing: random write/read operations
    #Address 0xd50 read value
    csrr x14, 0xd50

    #Address 0xd50 read value
    csrr x14, 0xd50

    #Unmapped address 0x1bc testing: random write/read operations
    #Address 0x1bc read value
    csrr x14, 0x1bc

    #Address 0x1bc read value
    csrr x14, 0x1bc

    #Unmapped address 0xbae testing: random write/read operations
    #Address 0xbae Write value 0xec1fbd16
    li x3, 0xec1fbd16
    csrw 0xbae, x3

    #Address 0xbae read value
    csrr x14, 0xbae

    #Address 0xbae read value
    csrr x14, 0xbae

    #Address 0xbae Write value 0xa1e05bdb
    li x3, 0xa1e05bdb
    csrw 0xbae, x3

    #Unmapped address 0x27c testing: random write/read operations
    #Address 0x27c Write value 0xd6f9497f
    li x3, 0xd6f9497f
    csrw 0x27c, x3

    #Address 0x27c Write value 0x745ff9ea
    li x3, 0x745ff9ea
    csrw 0x27c, x3

    #Unmapped address 0xde0 testing: random write/read operations
    #Address 0xde0 read value
    csrr x14, 0xde0

    #Address 0xde0 Write value 0xa866a624
    li x3, 0xa866a624
    csrw 0xde0, x3

    #Address 0xde0 read value
    csrr x14, 0xde0

    #Address 0xde0 read value
    csrr x14, 0xde0

    #Address 0xde0 Write value 0x3e400182
    li x3, 0x3e400182
    csrw 0xde0, x3

    #Unmapped address 0x459 testing: random write/read operations
    #Address 0x459 Write value 0x7f3c9cf9
    li x3, 0x7f3c9cf9
    csrw 0x459, x3

    #Address 0x459 read value
    csrr x14, 0x459

    #Address 0x459 Write value 0xeecfc9fc
    li x3, 0xeecfc9fc
    csrw 0x459, x3

    #Address 0x459 Write value 0xb7a7d97
    li x3, 0xb7a7d97
    csrw 0x459, x3

    #Address 0x459 read value
    csrr x14, 0x459

    #Unmapped address 0x22d testing: random write/read operations
    #Address 0x22d read value
    csrr x14, 0x22d

    #Address 0x22d Write value 0x1de39e94
    li x3, 0x1de39e94
    csrw 0x22d, x3

    #Address 0x22d read value
    csrr x14, 0x22d

    #Address 0x22d read value
    csrr x14, 0x22d

    #Address 0x22d Write value 0x69e002c4
    li x3, 0x69e002c4
    csrw 0x22d, x3

    #Unmapped address 0x2d4 testing: random write/read operations
    #Address 0x2d4 read value
    csrr x14, 0x2d4

    #Address 0x2d4 read value
    csrr x14, 0x2d4

    #Address 0x2d4 read value
    csrr x14, 0x2d4

    #Address 0x2d4 Write value 0x137420e4
    li x3, 0x137420e4
    csrw 0x2d4, x3

    #Address 0x2d4 Write value 0x914b6fc1
    li x3, 0x914b6fc1
    csrw 0x2d4, x3

    #Unmapped address 0xa5 testing: random write/read operations
    #Address 0xa5 read value
    csrr x14, 0xa5

    #Address 0xa5 Write value 0x58a9470e
    li x3, 0x58a9470e
    csrw 0xa5, x3

    #Address 0xa5 read value
    csrr x14, 0xa5

    #Address 0xa5 Write value 0xbd842e9
    li x3, 0xbd842e9
    csrw 0xa5, x3

    #Unmapped address 0xe2 testing: random write/read operations
    #Address 0xe2 read value
    csrr x14, 0xe2

    #Address 0xe2 Write value 0x7b7c9219
    li x3, 0x7b7c9219
    csrw 0xe2, x3

    #Address 0xe2 read value
    csrr x14, 0xe2

    #Unmapped address 0x6c testing: random write/read operations
    #Address 0x6c read value
    csrr x14, 0x6c

    #Address 0x6c Write value 0x6f6a107a
    li x3, 0x6f6a107a
    csrw 0x6c, x3

    #Address 0x6c read value
    csrr x14, 0x6c

    #Unmapped address 0x641 testing: random write/read operations
    #Address 0x641 Write value 0xb21d6ed0
    li x3, 0xb21d6ed0
    csrw 0x641, x3

    #Address 0x641 Write value 0x86dd5313
    li x3, 0x86dd5313
    csrw 0x641, x3

    #Address 0x641 Write value 0x4659482c
    li x3, 0x4659482c
    csrw 0x641, x3

    #Address 0x641 Write value 0xd6125206
    li x3, 0xd6125206
    csrw 0x641, x3

    #Address 0x641 Write value 0xfa5169c4
    li x3, 0xfa5169c4
    csrw 0x641, x3

    #Unmapped address 0x3e2 testing: random write/read operations
    #Address 0x3e2 read value
    csrr x14, 0x3e2

    #Address 0x3e2 read value
    csrr x14, 0x3e2

    #Address 0x3e2 Write value 0x7bdffadb
    li x3, 0x7bdffadb
    csrw 0x3e2, x3

    #Address 0x3e2 read value
    csrr x14, 0x3e2

    #Unmapped address 0x925 testing: random write/read operations
    #Address 0x925 read value
    csrr x14, 0x925

    #Address 0x925 Write value 0x174d570e
    li x3, 0x174d570e
    csrw 0x925, x3

    #Address 0x925 read value
    csrr x14, 0x925

    #Address 0x925 Write value 0xa54027a
    li x3, 0xa54027a
    csrw 0x925, x3

    #Address 0x925 Write value 0x6e637c3b
    li x3, 0x6e637c3b
    csrw 0x925, x3

    #Unmapped address 0x1ea testing: random write/read operations
    #Address 0x1ea Write value 0xa3be061b
    li x3, 0xa3be061b
    csrw 0x1ea, x3

    #Unmapped address 0x721 testing: random write/read operations
    #Address 0x721 read value
    csrr x14, 0x721

    #Address 0x721 Write value 0xd54ae2c0
    li x3, 0xd54ae2c0
    csrw 0x721, x3

    #Address 0x721 read value
    csrr x14, 0x721

    #Address 0x721 Write value 0xcef22af
    li x3, 0xcef22af
    csrw 0x721, x3

    #Address 0x721 Write value 0xa7cb5fb8
    li x3, 0xa7cb5fb8
    csrw 0x721, x3

    #Unmapped address 0xdac testing: random write/read operations
    #Address 0xdac read value
    csrr x14, 0xdac

    #Address 0xdac read value
    csrr x14, 0xdac

    #Address 0xdac Write value 0x8f4645ce
    li x3, 0x8f4645ce
    csrw 0xdac, x3

    #Address 0xdac read value
    csrr x14, 0xdac

    #Unmapped address 0x6c5 testing: random write/read operations
    #Address 0x6c5 Write value 0xceff2b34
    li x3, 0xceff2b34
    csrw 0x6c5, x3

    #Address 0x6c5 read value
    csrr x14, 0x6c5

    #Address 0x6c5 read value
    csrr x14, 0x6c5

    #Unmapped address 0xe12 testing: random write/read operations
    #Address 0xe12 Write value 0x7535f2b
    li x3, 0x7535f2b
    csrw 0xe12, x3

    #Address 0xe12 Write value 0xec426b6f
    li x3, 0xec426b6f
    csrw 0xe12, x3

    #Address 0xe12 Write value 0x816e86b6
    li x3, 0x816e86b6
    csrw 0xe12, x3

    #Address 0xe12 read value
    csrr x14, 0xe12

    #Unmapped address 0xdef testing: random write/read operations
    #Address 0xdef read value
    csrr x14, 0xdef

    #Address 0xdef Write value 0x914de6a0
    li x3, 0x914de6a0
    csrw 0xdef, x3

    #Unmapped address 0xd9b testing: random write/read operations
    #Address 0xd9b Write value 0x34e2d637
    li x3, 0x34e2d637
    csrw 0xd9b, x3

    #Address 0xd9b read value
    csrr x14, 0xd9b

    #Address 0xd9b read value
    csrr x14, 0xd9b

    #Address 0xd9b Write value 0x777b9e57
    li x3, 0x777b9e57
    csrw 0xd9b, x3

    #Address 0xd9b Write value 0xb10b100f
    li x3, 0xb10b100f
    csrw 0xd9b, x3

    #Unmapped address 0x824 testing: random write/read operations
    #Address 0x824 Write value 0xf49cacb9
    li x3, 0xf49cacb9
    csrw 0x824, x3

    #Address 0x824 read value
    csrr x14, 0x824

    #Address 0x824 Write value 0x2a592f1
    li x3, 0x2a592f1
    csrw 0x824, x3

    #Unmapped address 0xc0 testing: random write/read operations
    #Address 0xc0 Write value 0x60f1f4ca
    li x3, 0x60f1f4ca
    csrw 0xc0, x3

    #Unmapped address 0x222 testing: random write/read operations
    #Address 0x222 read value
    csrr x14, 0x222

    #Address 0x222 read value
    csrr x14, 0x222

    #Unmapped address 0x4f testing: random write/read operations
    #Address 0x4f read value
    csrr x14, 0x4f

    #Unmapped address 0xf57 testing: random write/read operations
    #Address 0xf57 Write value 0x406aa7b0
    li x3, 0x406aa7b0
    csrw 0xf57, x3

    #Address 0xf57 read value
    csrr x14, 0xf57

    #Unmapped address 0x758 testing: random write/read operations
    #Address 0x758 read value
    csrr x14, 0x758

    #Address 0x758 read value
    csrr x14, 0x758

    #Address 0x758 Write value 0x3ba12191
    li x3, 0x3ba12191
    csrw 0x758, x3

    #Address 0x758 read value
    csrr x14, 0x758

    #Unmapped address 0x2c7 testing: random write/read operations
    #Address 0x2c7 read value
    csrr x14, 0x2c7

    #Address 0x2c7 Write value 0xd7d6ff35
    li x3, 0xd7d6ff35
    csrw 0x2c7, x3

    #Address 0x2c7 Write value 0xd208f2f3
    li x3, 0xd208f2f3
    csrw 0x2c7, x3

    #Address 0x2c7 Write value 0x16a74355
    li x3, 0x16a74355
    csrw 0x2c7, x3

    #Address 0x2c7 read value
    csrr x14, 0x2c7

    #Unmapped address 0xd74 testing: random write/read operations
    #Address 0xd74 read value
    csrr x14, 0xd74

    #Address 0xd74 Write value 0x2c4c8add
    li x3, 0x2c4c8add
    csrw 0xd74, x3

    #Unmapped address 0x8c3 testing: random write/read operations
    #Address 0x8c3 Write value 0xc7c6d7dc
    li x3, 0xc7c6d7dc
    csrw 0x8c3, x3

    #Unmapped address 0x23f testing: random write/read operations
    #Address 0x23f read value
    csrr x14, 0x23f

    #Address 0x23f Write value 0x50b3674e
    li x3, 0x50b3674e
    csrw 0x23f, x3

    #Address 0x23f read value
    csrr x14, 0x23f

    #Unmapped address 0x35 testing: random write/read operations
    #Address 0x35 read value
    csrr x14, 0x35

    #Unmapped address 0x7cb testing: random write/read operations
    #Address 0x7cb Write value 0x8ce1c267
    li x3, 0x8ce1c267
    csrw 0x7cb, x3

    #Address 0x7cb Write value 0xdde78a27
    li x3, 0xdde78a27
    csrw 0x7cb, x3

    #Address 0x7cb read value
    csrr x14, 0x7cb

    #Address 0x7cb read value
    csrr x14, 0x7cb

    #Unmapped address 0xe0c testing: random write/read operations
    #Address 0xe0c Write value 0x73506744
    li x3, 0x73506744
    csrw 0xe0c, x3

    #Address 0xe0c read value
    csrr x14, 0xe0c

    #Address 0xe0c read value
    csrr x14, 0xe0c

    #Address 0xe0c read value
    csrr x14, 0xe0c

    #Unmapped address 0xf66 testing: random write/read operations
    #Address 0xf66 Write value 0xe8550e55
    li x3, 0xe8550e55
    csrw 0xf66, x3

    #Address 0xf66 read value
    csrr x14, 0xf66

    #Address 0xf66 read value
    csrr x14, 0xf66

    #Address 0xf66 read value
    csrr x14, 0xf66

    #Unmapped address 0xdb7 testing: random write/read operations
    #Address 0xdb7 Write value 0xd1276938
    li x3, 0xd1276938
    csrw 0xdb7, x3

    #Address 0xdb7 Write value 0x326ad9b3
    li x3, 0x326ad9b3
    csrw 0xdb7, x3

    #Unmapped address 0x652 testing: random write/read operations
    #Address 0x652 Write value 0x16d4874e
    li x3, 0x16d4874e
    csrw 0x652, x3

    #Address 0x652 read value
    csrr x14, 0x652

    #Address 0x652 Write value 0x9c72857d
    li x3, 0x9c72857d
    csrw 0x652, x3

    #Address 0x652 read value
    csrr x14, 0x652

    #Address 0x652 read value
    csrr x14, 0x652

    #Unmapped address 0x847 testing: random write/read operations
    #Address 0x847 read value
    csrr x14, 0x847

    #Address 0x847 Write value 0xdd35800
    li x3, 0xdd35800
    csrw 0x847, x3

    #Mapped address 0xb99 (mhpmcounterh25) testing: random write/read operations
    #Address 0xb99 read value
    csrr x14, 0xb99

    #Address 0xb99 read value
    csrr x14, 0xb99

    #Address 0xb99 Write value 0x42fc4dfa
    li x3, 0x42fc4dfa
    csrw 0xb99, x3

    #Unmapped address 0xf0d testing: random write/read operations
    #Address 0xf0d Write value 0xb791932f
    li x3, 0xb791932f
    csrw 0xf0d, x3

    #Unmapped address 0x129 testing: random write/read operations
    #Address 0x129 Write value 0x734207a
    li x3, 0x734207a
    csrw 0x129, x3

    #Unmapped address 0xde2 testing: random write/read operations
    #Address 0xde2 Write value 0x827bd65e
    li x3, 0x827bd65e
    csrw 0xde2, x3

    #Address 0xde2 read value
    csrr x14, 0xde2

    #Address 0xde2 read value
    csrr x14, 0xde2

    #Address 0xde2 read value
    csrr x14, 0xde2

    #Unmapped address 0x1d8 testing: random write/read operations
    #Address 0x1d8 Write value 0x1dbac391
    li x3, 0x1dbac391
    csrw 0x1d8, x3

    #Address 0x1d8 read value
    csrr x14, 0x1d8

    #Address 0x1d8 read value
    csrr x14, 0x1d8

    #Unmapped address 0xa63 testing: random write/read operations
    #Address 0xa63 read value
    csrr x14, 0xa63

    #Address 0xa63 Write value 0xf9eb002d
    li x3, 0xf9eb002d
    csrw 0xa63, x3

    #Address 0xa63 read value
    csrr x14, 0xa63

    #Address 0xa63 Write value 0x93a87163
    li x3, 0x93a87163
    csrw 0xa63, x3

    #Address 0xa63 Write value 0xa36b5391
    li x3, 0xa36b5391
    csrw 0xa63, x3

    #Mapped address 0xb9d (mhpmcounterh29) testing: random write/read operations
    #Address 0xb9d read value
    csrr x14, 0xb9d

    #Address 0xb9d read value
    csrr x14, 0xb9d

    #Address 0xb9d read value
    csrr x14, 0xb9d

    #Address 0xb9d Write value 0x14c7ba1b
    li x3, 0x14c7ba1b
    csrw 0xb9d, x3

    #Unmapped address 0xa15 testing: random write/read operations
    #Address 0xa15 Write value 0x17776b95
    li x3, 0x17776b95
    csrw 0xa15, x3

    #Address 0xa15 Write value 0x14549f84
    li x3, 0x14549f84
    csrw 0xa15, x3

    #Address 0xa15 read value
    csrr x14, 0xa15

    #Unmapped address 0xa5b testing: random write/read operations
    #Address 0xa5b read value
    csrr x14, 0xa5b

    #Address 0xa5b Write value 0xdadc936
    li x3, 0xdadc936
    csrw 0xa5b, x3

    #Address 0xa5b read value
    csrr x14, 0xa5b

    #Address 0xa5b read value
    csrr x14, 0xa5b

    #Address 0xa5b read value
    csrr x14, 0xa5b

    #Unmapped address 0x863 testing: random write/read operations
    #Address 0x863 read value
    csrr x14, 0x863

    #Address 0x863 read value
    csrr x14, 0x863

    #Address 0x863 Write value 0xbec4a34
    li x3, 0xbec4a34
    csrw 0x863, x3

    #Address 0x863 read value
    csrr x14, 0x863

    #Unmapped address 0x6c1 testing: random write/read operations
    #Address 0x6c1 read value
    csrr x14, 0x6c1

    #Address 0x6c1 Write value 0x1e409ba2
    li x3, 0x1e409ba2
    csrw 0x6c1, x3

    #Address 0x6c1 Write value 0xf9e036ff
    li x3, 0xf9e036ff
    csrw 0x6c1, x3

    #Address 0x6c1 read value
    csrr x14, 0x6c1

    #Mapped address 0x3b0 (pmpaddr0) testing: random write/read operations
    #Address 0x3b0 Write value 0x48def8dc
    li x3, 0x48def8dc
    csrw 0x3b0, x3

    #Unmapped address 0x160 testing: random write/read operations
    #Address 0x160 Write value 0x1ce672f0
    li x3, 0x1ce672f0
    csrw 0x160, x3

    #Address 0x160 read value
    csrr x14, 0x160

    #Unmapped address 0x905 testing: random write/read operations
    #Address 0x905 read value
    csrr x14, 0x905

    #Unmapped address 0xb4f testing: random write/read operations
    #Address 0xb4f read value
    csrr x14, 0xb4f

    #Address 0xb4f Write value 0xb92964e3
    li x3, 0xb92964e3
    csrw 0xb4f, x3

    #Address 0xb4f Write value 0x126cdba
    li x3, 0x126cdba
    csrw 0xb4f, x3

    #Unmapped address 0x126 testing: random write/read operations
    #Address 0x126 Write value 0xb0180f78
    li x3, 0xb0180f78
    csrw 0x126, x3

    #Address 0x126 read value
    csrr x14, 0x126

    #Address 0x126 Write value 0x8b827b68
    li x3, 0x8b827b68
    csrw 0x126, x3

    #Address 0x126 read value
    csrr x14, 0x126

    #Unmapped address 0x9d6 testing: random write/read operations
    #Address 0x9d6 Write value 0x893aecb3
    li x3, 0x893aecb3
    csrw 0x9d6, x3

    #Address 0x9d6 read value
    csrr x14, 0x9d6

    #Address 0x9d6 Write value 0x4f4b6492
    li x3, 0x4f4b6492
    csrw 0x9d6, x3

    #Address 0x9d6 read value
    csrr x14, 0x9d6

    #Address 0x9d6 read value
    csrr x14, 0x9d6

    #Unmapped address 0x493 testing: random write/read operations
    #Address 0x493 read value
    csrr x14, 0x493

    #Address 0x493 read value
    csrr x14, 0x493

    #Unmapped address 0x104 testing: random write/read operations
    #Address 0x104 Write value 0x1f1756d2
    li x3, 0x1f1756d2
    csrw 0x104, x3

    #Address 0x104 Write value 0xc8faf2a8
    li x3, 0xc8faf2a8
    csrw 0x104, x3

    #Unmapped address 0xd6 testing: random write/read operations
    #Address 0xd6 read value
    csrr x14, 0xd6

    #Address 0xd6 Write value 0xee2086cc
    li x3, 0xee2086cc
    csrw 0xd6, x3

    #Address 0xd6 Write value 0x5611c9e9
    li x3, 0x5611c9e9
    csrw 0xd6, x3

    #Address 0xd6 read value
    csrr x14, 0xd6

    #Unmapped address 0x1d5 testing: random write/read operations
    #Address 0x1d5 Write value 0x2a78b38
    li x3, 0x2a78b38
    csrw 0x1d5, x3

    #Address 0x1d5 read value
    csrr x14, 0x1d5

    #Address 0x1d5 read value
    csrr x14, 0x1d5

    #Address 0x1d5 Write value 0x32189ecb
    li x3, 0x32189ecb
    csrw 0x1d5, x3

    #Address 0x1d5 read value
    csrr x14, 0x1d5

    #Unmapped address 0xafd testing: random write/read operations
    #Address 0xafd Write value 0xefc7a802
    li x3, 0xefc7a802
    csrw 0xafd, x3

    #Address 0xafd read value
    csrr x14, 0xafd

    #Address 0xafd Write value 0xd6ead5de
    li x3, 0xd6ead5de
    csrw 0xafd, x3

    #Address 0xafd Write value 0xf67e0c84
    li x3, 0xf67e0c84
    csrw 0xafd, x3

    #Unmapped address 0xa1e testing: random write/read operations
    #Address 0xa1e read value
    csrr x14, 0xa1e

    #Address 0xa1e read value
    csrr x14, 0xa1e

    #Address 0xa1e Write value 0xe145407f
    li x3, 0xe145407f
    csrw 0xa1e, x3

    #Address 0xa1e Write value 0xb4f4eb2b
    li x3, 0xb4f4eb2b
    csrw 0xa1e, x3

    #Address 0xa1e read value
    csrr x14, 0xa1e

    #Unmapped address 0x749 testing: random write/read operations
    #Address 0x749 read value
    csrr x14, 0x749

    #Address 0x749 read value
    csrr x14, 0x749

    #Address 0x749 Write value 0x97020fc2
    li x3, 0x97020fc2
    csrw 0x749, x3

    #Address 0x749 read value
    csrr x14, 0x749

    #Address 0x749 Write value 0xc1f00d77
    li x3, 0xc1f00d77
    csrw 0x749, x3

    #Unmapped address 0xf1c testing: random write/read operations
    #Address 0xf1c Write value 0xa324f35d
    li x3, 0xa324f35d
    csrw 0xf1c, x3

    #Address 0xf1c Write value 0x9179b645
    li x3, 0x9179b645
    csrw 0xf1c, x3

    #Address 0xf1c read value
    csrr x14, 0xf1c

    #Unmapped address 0xd6f testing: random write/read operations
    #Address 0xd6f read value
    csrr x14, 0xd6f

    #Address 0xd6f read value
    csrr x14, 0xd6f

    #Address 0xd6f read value
    csrr x14, 0xd6f

    #Unmapped address 0xc57 testing: random write/read operations
    #Address 0xc57 read value
    csrr x14, 0xc57

    #Address 0xc57 Write value 0x359154c8
    li x3, 0x359154c8
    csrw 0xc57, x3

    #Address 0xc57 Write value 0xc35aa638
    li x3, 0xc35aa638
    csrw 0xc57, x3

    #Unmapped address 0xcb2 testing: random write/read operations
    #Address 0xcb2 Write value 0x13fbd8c1
    li x3, 0x13fbd8c1
    csrw 0xcb2, x3

    #Address 0xcb2 Write value 0x5dba51d6
    li x3, 0x5dba51d6
    csrw 0xcb2, x3

    #Address 0xcb2 Write value 0xcd594f60
    li x3, 0xcd594f60
    csrw 0xcb2, x3

    #Unmapped address 0xeec testing: random write/read operations
    #Address 0xeec Write value 0x41278939
    li x3, 0x41278939
    csrw 0xeec, x3

    #Address 0xeec read value
    csrr x14, 0xeec

    #Address 0xeec Write value 0xd5e59210
    li x3, 0xd5e59210
    csrw 0xeec, x3

    #Address 0xeec Write value 0xf999ee8c
    li x3, 0xf999ee8c
    csrw 0xeec, x3

    #Address 0xeec read value
    csrr x14, 0xeec

    #Unmapped address 0xaac testing: random write/read operations
    #Address 0xaac Write value 0xaa666006
    li x3, 0xaa666006
    csrw 0xaac, x3

    #Address 0xaac read value
    csrr x14, 0xaac

    #Address 0xaac read value
    csrr x14, 0xaac

    #Address 0xaac Write value 0x236b2bad
    li x3, 0x236b2bad
    csrw 0xaac, x3

    #Unmapped address 0x603 testing: random write/read operations
    #Address 0x603 Write value 0x6222e672
    li x3, 0x6222e672
    csrw 0x603, x3

    #Address 0x603 Write value 0x998626b5
    li x3, 0x998626b5
    csrw 0x603, x3

    #Address 0x603 Write value 0x21bf0e47
    li x3, 0x21bf0e47
    csrw 0x603, x3

    #Address 0x603 read value
    csrr x14, 0x603

    #Address 0x603 read value
    csrr x14, 0x603

    #Unmapped address 0x306 testing: random write/read operations
    #Address 0x306 Write value 0xa42c2014
    li x3, 0xa42c2014
    csrw 0x306, x3

    #Address 0x306 Write value 0x4ef5e6cf
    li x3, 0x4ef5e6cf
    csrw 0x306, x3

    #Unmapped address 0x538 testing: random write/read operations
    #Address 0x538 read value
    csrr x14, 0x538

    #Unmapped address 0x450 testing: random write/read operations
    #Address 0x450 Write value 0xc399dd12
    li x3, 0xc399dd12
    csrw 0x450, x3

    #Address 0x450 Write value 0x3c08ce7e
    li x3, 0x3c08ce7e
    csrw 0x450, x3

    #Unmapped address 0x67a testing: random write/read operations
    #Address 0x67a Write value 0xf44efe6a
    li x3, 0xf44efe6a
    csrw 0x67a, x3

    #Address 0x67a read value
    csrr x14, 0x67a

    #Unmapped address 0xe49 testing: random write/read operations
    #Address 0xe49 read value
    csrr x14, 0xe49

    #Address 0xe49 Write value 0x766a9ef8
    li x3, 0x766a9ef8
    csrw 0xe49, x3

    #Address 0xe49 Write value 0x47ac9d5f
    li x3, 0x47ac9d5f
    csrw 0xe49, x3

    #Address 0xe49 Write value 0x8a358f0c
    li x3, 0x8a358f0c
    csrw 0xe49, x3

    #Unmapped address 0xc18 testing: random write/read operations
    #Address 0xc18 Write value 0x12423d42
    li x3, 0x12423d42
    csrw 0xc18, x3

    #Address 0xc18 Write value 0x990044f5
    li x3, 0x990044f5
    csrw 0xc18, x3

    #Address 0xc18 read value
    csrr x14, 0xc18

    #Address 0xc18 Write value 0xbcb19dc4
    li x3, 0xbcb19dc4
    csrw 0xc18, x3

    #Address 0xc18 Write value 0x26fcb8be
    li x3, 0x26fcb8be
    csrw 0xc18, x3

    #Mapped address 0x325 (mhpmevent5) testing: random write/read operations
    #Address 0x325 read value
    csrr x14, 0x325

    #Address 0x325 read value
    csrr x14, 0x325

    #Address 0x325 Write value 0xad20d884
    li x3, 0xad20d884
    csrw 0x325, x3

    #Unmapped address 0x72d testing: random write/read operations
    #Address 0x72d Write value 0x5f770dec
    li x3, 0x5f770dec
    csrw 0x72d, x3

    #Unmapped address 0x9d5 testing: random write/read operations
    #Address 0x9d5 Write value 0x694464ca
    li x3, 0x694464ca
    csrw 0x9d5, x3

    #Address 0x9d5 Write value 0x836d882c
    li x3, 0x836d882c
    csrw 0x9d5, x3

    #Address 0x9d5 Write value 0xaff71d09
    li x3, 0xaff71d09
    csrw 0x9d5, x3

    #Address 0x9d5 read value
    csrr x14, 0x9d5

    #Address 0x9d5 read value
    csrr x14, 0x9d5

    #Unmapped address 0x6f5 testing: random write/read operations
    #Address 0x6f5 read value
    csrr x14, 0x6f5

    #Address 0x6f5 Write value 0x23f352d4
    li x3, 0x23f352d4
    csrw 0x6f5, x3

    #Address 0x6f5 read value
    csrr x14, 0x6f5

    #Address 0x6f5 Write value 0x1f1e4a68
    li x3, 0x1f1e4a68
    csrw 0x6f5, x3

    #Address 0x6f5 read value
    csrr x14, 0x6f5

    #Mapped address 0xb18 (mhpmcounter24) testing: random write/read operations
    #Address 0xb18 read value
    csrr x14, 0xb18

    #Address 0xb18 Write value 0xa2f44ead
    li x3, 0xa2f44ead
    csrw 0xb18, x3

    #Address 0xb18 read value
    csrr x14, 0xb18

    #Unmapped address 0x5c testing: random write/read operations
    #Address 0x5c read value
    csrr x14, 0x5c

    #Address 0x5c Write value 0xfdfbb4b4
    li x3, 0xfdfbb4b4
    csrw 0x5c, x3

    #Unmapped address 0x19a testing: random write/read operations
    #Address 0x19a Write value 0x93546aa9
    li x3, 0x93546aa9
    csrw 0x19a, x3

    #Unmapped address 0xad8 testing: random write/read operations
    #Address 0xad8 read value
    csrr x14, 0xad8

    #Address 0xad8 Write value 0x87e0037a
    li x3, 0x87e0037a
    csrw 0xad8, x3

    #Address 0xad8 Write value 0xc9fb9580
    li x3, 0xc9fb9580
    csrw 0xad8, x3

    #Unmapped address 0xe1 testing: random write/read operations
    #Address 0xe1 read value
    csrr x14, 0xe1

    #Address 0xe1 Write value 0xadaf9eff
    li x3, 0xadaf9eff
    csrw 0xe1, x3

    #Address 0xe1 read value
    csrr x14, 0xe1

    #Address 0xe1 read value
    csrr x14, 0xe1

    #Unmapped address 0x2e0 testing: random write/read operations
    #Address 0x2e0 Write value 0x487646cb
    li x3, 0x487646cb
    csrw 0x2e0, x3

    #Address 0x2e0 Write value 0xc1785d51
    li x3, 0xc1785d51
    csrw 0x2e0, x3

    #Address 0x2e0 Write value 0x83f85dc3
    li x3, 0x83f85dc3
    csrw 0x2e0, x3

    #Address 0x2e0 read value
    csrr x14, 0x2e0

    #Unmapped address 0x692 testing: random write/read operations
    #Address 0x692 read value
    csrr x14, 0x692

    #Unmapped address 0xd41 testing: random write/read operations
    #Address 0xd41 Write value 0xef9bcda5
    li x3, 0xef9bcda5
    csrw 0xd41, x3

    #Unmapped address 0xed8 testing: random write/read operations
    #Address 0xed8 read value
    csrr x14, 0xed8

    #Address 0xed8 read value
    csrr x14, 0xed8

    #Address 0xed8 Write value 0x698796b3
    li x3, 0x698796b3
    csrw 0xed8, x3

    #Unmapped address 0xa3b testing: random write/read operations
    #Address 0xa3b read value
    csrr x14, 0xa3b

    #Address 0xa3b read value
    csrr x14, 0xa3b

    #Address 0xa3b read value
    csrr x14, 0xa3b

    #Address 0xa3b Write value 0xf7fbd174
    li x3, 0xf7fbd174
    csrw 0xa3b, x3

    #Address 0xa3b Write value 0x58238d30
    li x3, 0x58238d30
    csrw 0xa3b, x3

    #Unmapped address 0x95a testing: random write/read operations
    #Address 0x95a Write value 0x45fe06d6
    li x3, 0x45fe06d6
    csrw 0x95a, x3

    #Unmapped address 0xcbf testing: random write/read operations
    #Address 0xcbf read value
    csrr x14, 0xcbf

    #Address 0xcbf Write value 0x6d25cd7a
    li x3, 0x6d25cd7a
    csrw 0xcbf, x3

    #Unmapped address 0x9a3 testing: random write/read operations
    #Address 0x9a3 read value
    csrr x14, 0x9a3

    #Unmapped address 0xcd2 testing: random write/read operations
    #Address 0xcd2 Write value 0x3660878a
    li x3, 0x3660878a
    csrw 0xcd2, x3

    #Address 0xcd2 Write value 0x7cf55b66
    li x3, 0x7cf55b66
    csrw 0xcd2, x3

    #Address 0xcd2 Write value 0x854138db
    li x3, 0x854138db
    csrw 0xcd2, x3

    #Address 0xcd2 Write value 0x651e747f
    li x3, 0x651e747f
    csrw 0xcd2, x3

    #Address 0xcd2 Write value 0x21ebb64c
    li x3, 0x21ebb64c
    csrw 0xcd2, x3

    #Unmapped address 0x5aa testing: random write/read operations
    #Address 0x5aa Write value 0x8a5b6bab
    li x3, 0x8a5b6bab
    csrw 0x5aa, x3

    #Address 0x5aa Write value 0x3b500979
    li x3, 0x3b500979
    csrw 0x5aa, x3

    #Address 0x5aa Write value 0x91976b2c
    li x3, 0x91976b2c
    csrw 0x5aa, x3

    #Address 0x5aa Write value 0xbf3e1774
    li x3, 0xbf3e1774
    csrw 0x5aa, x3

    #Address 0x5aa Write value 0x54969204
    li x3, 0x54969204
    csrw 0x5aa, x3

    #Unmapped address 0x7ad testing: random write/read operations
    #Address 0x7ad read value
    csrr x14, 0x7ad

    #Address 0x7ad Write value 0x782787e1
    li x3, 0x782787e1
    csrw 0x7ad, x3

    #Unmapped address 0x995 testing: random write/read operations
    #Address 0x995 read value
    csrr x14, 0x995

    #Address 0x995 read value
    csrr x14, 0x995

    #Address 0x995 Write value 0xfc0b1a1d
    li x3, 0xfc0b1a1d
    csrw 0x995, x3

    #Address 0x995 Write value 0xe6cf682e
    li x3, 0xe6cf682e
    csrw 0x995, x3

    #Unmapped address 0xeed testing: random write/read operations
    #Address 0xeed Write value 0xf8a21b74
    li x3, 0xf8a21b74
    csrw 0xeed, x3

    #Unmapped address 0x4b5 testing: random write/read operations
    #Address 0x4b5 Write value 0xd00a616a
    li x3, 0xd00a616a
    csrw 0x4b5, x3

    #Address 0x4b5 read value
    csrr x14, 0x4b5

    #Address 0x4b5 Write value 0xbf23d8e8
    li x3, 0xbf23d8e8
    csrw 0x4b5, x3

    #Address 0x4b5 read value
    csrr x14, 0x4b5

    #Address 0x4b5 Write value 0x85f37f40
    li x3, 0x85f37f40
    csrw 0x4b5, x3

    #Unmapped address 0x5ad testing: random write/read operations
    #Address 0x5ad read value
    csrr x14, 0x5ad

    #Address 0x5ad read value
    csrr x14, 0x5ad

    #Unmapped address 0x3c0 testing: random write/read operations
    #Address 0x3c0 read value
    csrr x14, 0x3c0

    #Address 0x3c0 Write value 0x3b6793be
    li x3, 0x3b6793be
    csrw 0x3c0, x3

    #Unmapped address 0xe5e testing: random write/read operations
    #Address 0xe5e read value
    csrr x14, 0xe5e

    #Address 0xe5e Write value 0xdb9045f
    li x3, 0xdb9045f
    csrw 0xe5e, x3

    #Unmapped address 0xaa9 testing: random write/read operations
    #Address 0xaa9 Write value 0x77db3c33
    li x3, 0x77db3c33
    csrw 0xaa9, x3

    #Address 0xaa9 read value
    csrr x14, 0xaa9

    #Address 0xaa9 Write value 0x6f41325d
    li x3, 0x6f41325d
    csrw 0xaa9, x3

    #Address 0xaa9 read value
    csrr x14, 0xaa9

    #Unmapped address 0x9a4 testing: random write/read operations
    #Address 0x9a4 Write value 0x901b29ed
    li x3, 0x901b29ed
    csrw 0x9a4, x3

    #Address 0x9a4 read value
    csrr x14, 0x9a4

    #Unmapped address 0x846 testing: random write/read operations
    #Address 0x846 read value
    csrr x14, 0x846

    #Address 0x846 read value
    csrr x14, 0x846

    #Unmapped address 0xb3d testing: random write/read operations
    #Address 0xb3d Write value 0x6bcb927b
    li x3, 0x6bcb927b
    csrw 0xb3d, x3

    #Address 0xb3d read value
    csrr x14, 0xb3d

    #Address 0xb3d read value
    csrr x14, 0xb3d

    #Address 0xb3d Write value 0x2ea73e3d
    li x3, 0x2ea73e3d
    csrw 0xb3d, x3

    #Address 0xb3d read value
    csrr x14, 0xb3d

    #Unmapped address 0x5ef testing: random write/read operations
    #Address 0x5ef Write value 0x9f49d1f2
    li x3, 0x9f49d1f2
    csrw 0x5ef, x3

    #Address 0x5ef read value
    csrr x14, 0x5ef

    #Unmapped address 0x4c6 testing: random write/read operations
    #Address 0x4c6 Write value 0xd31ee495
    li x3, 0xd31ee495
    csrw 0x4c6, x3

    #Address 0x4c6 read value
    csrr x14, 0x4c6

    #Unmapped address 0x632 testing: random write/read operations
    #Address 0x632 Write value 0x430a04d
    li x3, 0x430a04d
    csrw 0x632, x3

    #Address 0x632 Write value 0xd2c01c0f
    li x3, 0xd2c01c0f
    csrw 0x632, x3

    #Address 0x632 read value
    csrr x14, 0x632

    #Unmapped address 0xe0f testing: random write/read operations
    #Address 0xe0f read value
    csrr x14, 0xe0f

    #Address 0xe0f read value
    csrr x14, 0xe0f

    #Unmapped address 0x734 testing: random write/read operations
    #Address 0x734 read value
    csrr x14, 0x734

    #Address 0x734 Write value 0x847523fd
    li x3, 0x847523fd
    csrw 0x734, x3

    #Address 0x734 read value
    csrr x14, 0x734

    #Unmapped address 0x590 testing: random write/read operations
    #Address 0x590 read value
    csrr x14, 0x590

    #Unmapped address 0x9aa testing: random write/read operations
    #Address 0x9aa read value
    csrr x14, 0x9aa

    #Address 0x9aa Write value 0x38dd9525
    li x3, 0x38dd9525
    csrw 0x9aa, x3

    #Address 0x9aa read value
    csrr x14, 0x9aa

    #Unmapped address 0x175 testing: random write/read operations
    #Address 0x175 read value
    csrr x14, 0x175

    #Address 0x175 Write value 0x32412bd0
    li x3, 0x32412bd0
    csrw 0x175, x3

    #Unmapped address 0xa4a testing: random write/read operations
    #Address 0xa4a Write value 0xee337bf8
    li x3, 0xee337bf8
    csrw 0xa4a, x3

    #Unmapped address 0x381 testing: random write/read operations
    #Address 0x381 read value
    csrr x14, 0x381

    #Address 0x381 Write value 0xbd6d2e95
    li x3, 0xbd6d2e95
    csrw 0x381, x3

    #Address 0x381 read value
    csrr x14, 0x381

    #Address 0x381 read value
    csrr x14, 0x381

    #Unmapped address 0x5ec testing: random write/read operations
    #Address 0x5ec read value
    csrr x14, 0x5ec

    #Address 0x5ec Write value 0xeb3108c7
    li x3, 0xeb3108c7
    csrw 0x5ec, x3

    #Address 0x5ec read value
    csrr x14, 0x5ec

    #Address 0x5ec Write value 0xd661a557
    li x3, 0xd661a557
    csrw 0x5ec, x3

    #Unmapped address 0x33 testing: random write/read operations
    #Address 0x33 Write value 0xf92ba635
    li x3, 0xf92ba635
    csrw 0x33, x3

    #Address 0x33 read value
    csrr x14, 0x33

    #Address 0x33 Write value 0x5f3cf70b
    li x3, 0x5f3cf70b
    csrw 0x33, x3

    #Address 0x33 read value
    csrr x14, 0x33

    #Unmapped address 0x9de testing: random write/read operations
    #Address 0x9de Write value 0x672756a1
    li x3, 0x672756a1
    csrw 0x9de, x3

    #Address 0x9de read value
    csrr x14, 0x9de

    #Address 0x9de Write value 0x2918eb0e
    li x3, 0x2918eb0e
    csrw 0x9de, x3

    #Address 0x9de read value
    csrr x14, 0x9de

    #Address 0x9de read value
    csrr x14, 0x9de

    #Unmapped address 0x155 testing: random write/read operations
    #Address 0x155 read value
    csrr x14, 0x155

    #Address 0x155 read value
    csrr x14, 0x155

    #Address 0x155 Write value 0x168fcfaa
    li x3, 0x168fcfaa
    csrw 0x155, x3

    #Unmapped address 0x5e3 testing: random write/read operations
    #Address 0x5e3 Write value 0x5e4cad27
    li x3, 0x5e4cad27
    csrw 0x5e3, x3

    #Address 0x5e3 Write value 0x26c37cca
    li x3, 0x26c37cca
    csrw 0x5e3, x3

    #Unmapped address 0xdaa testing: random write/read operations
    #Address 0xdaa Write value 0xe72d1659
    li x3, 0xe72d1659
    csrw 0xdaa, x3

    #Address 0xdaa read value
    csrr x14, 0xdaa

    #Address 0xdaa Write value 0xe5cc17e8
    li x3, 0xe5cc17e8
    csrw 0xdaa, x3

    #Address 0xdaa read value
    csrr x14, 0xdaa

    #Address 0xdaa read value
    csrr x14, 0xdaa

    #Unmapped address 0x39e testing: random write/read operations
    #Address 0x39e Write value 0xb3326102
    li x3, 0xb3326102
    csrw 0x39e, x3

    #Address 0x39e Write value 0x67dd7d42
    li x3, 0x67dd7d42
    csrw 0x39e, x3

    #Address 0x39e Write value 0x932754d3
    li x3, 0x932754d3
    csrw 0x39e, x3

    #Address 0x39e Write value 0x45b95dea
    li x3, 0x45b95dea
    csrw 0x39e, x3

    #Address 0x39e Write value 0x7cdb7762
    li x3, 0x7cdb7762
    csrw 0x39e, x3

    #Unmapped address 0xa01 testing: random write/read operations
    #Address 0xa01 read value
    csrr x14, 0xa01

    #Address 0xa01 Write value 0x6dec4d4
    li x3, 0x6dec4d4
    csrw 0xa01, x3

    #Unmapped address 0x509 testing: random write/read operations
    #Address 0x509 read value
    csrr x14, 0x509

    #Address 0x509 read value
    csrr x14, 0x509

    #Address 0x509 Write value 0xdcc56ba7
    li x3, 0xdcc56ba7
    csrw 0x509, x3

    #Unmapped address 0xdf8 testing: random write/read operations
    #Address 0xdf8 read value
    csrr x14, 0xdf8

    #Address 0xdf8 Write value 0x9048165a
    li x3, 0x9048165a
    csrw 0xdf8, x3

    #Address 0xdf8 Write value 0x4f1b226c
    li x3, 0x4f1b226c
    csrw 0xdf8, x3

    #Unmapped address 0xaaf testing: random write/read operations
    #Address 0xaaf Write value 0x25abe431
    li x3, 0x25abe431
    csrw 0xaaf, x3

    #Address 0xaaf read value
    csrr x14, 0xaaf

    #Address 0xaaf read value
    csrr x14, 0xaaf

    #Address 0xaaf Write value 0xc80421ce
    li x3, 0xc80421ce
    csrw 0xaaf, x3

    #Unmapped address 0xad2 testing: random write/read operations
    #Address 0xad2 Write value 0x97d4a9ca
    li x3, 0x97d4a9ca
    csrw 0xad2, x3

    #Unmapped address 0x960 testing: random write/read operations
    #Address 0x960 Write value 0x772df030
    li x3, 0x772df030
    csrw 0x960, x3

    #Unmapped address 0xb51 testing: random write/read operations
    #Address 0xb51 read value
    csrr x14, 0xb51

    #Unmapped address 0xf1 testing: random write/read operations
    #Address 0xf1 Write value 0xd952146d
    li x3, 0xd952146d
    csrw 0xf1, x3

    #Address 0xf1 read value
    csrr x14, 0xf1

    #Unmapped address 0xc17 testing: random write/read operations
    #Address 0xc17 Write value 0x5e23baf1
    li x3, 0x5e23baf1
    csrw 0xc17, x3

    #Address 0xc17 Write value 0xbee2f843
    li x3, 0xbee2f843
    csrw 0xc17, x3

    #Address 0xc17 read value
    csrr x14, 0xc17

    #Address 0xc17 Write value 0xfe087e8d
    li x3, 0xfe087e8d
    csrw 0xc17, x3

    #Unmapped address 0xe4b testing: random write/read operations
    #Address 0xe4b read value
    csrr x14, 0xe4b

    #Address 0xe4b read value
    csrr x14, 0xe4b

    #Address 0xe4b read value
    csrr x14, 0xe4b

    #Address 0xe4b read value
    csrr x14, 0xe4b

    #Address 0xe4b Write value 0xfcd81b75
    li x3, 0xfcd81b75
    csrw 0xe4b, x3

    #Unmapped address 0x54f testing: random write/read operations
    #Address 0x54f Write value 0xda010220
    li x3, 0xda010220
    csrw 0x54f, x3

    #Address 0x54f Write value 0xb7e62f52
    li x3, 0xb7e62f52
    csrw 0x54f, x3

    #Address 0x54f read value
    csrr x14, 0x54f

    #Address 0x54f read value
    csrr x14, 0x54f

    #Unmapped address 0x2d9 testing: random write/read operations
    #Address 0x2d9 Write value 0x46875baa
    li x3, 0x46875baa
    csrw 0x2d9, x3

    #Address 0x2d9 read value
    csrr x14, 0x2d9

    #Unmapped address 0xef testing: random write/read operations
    #Address 0xef Write value 0x2bed3155
    li x3, 0x2bed3155
    csrw 0xef, x3

    #Address 0xef read value
    csrr x14, 0xef

    #Address 0xef Write value 0xafb9b660
    li x3, 0xafb9b660
    csrw 0xef, x3

    #Address 0xef Write value 0xe927f50b
    li x3, 0xe927f50b
    csrw 0xef, x3

    #Unmapped address 0xd90 testing: random write/read operations
    #Address 0xd90 Write value 0xcc75f831
    li x3, 0xcc75f831
    csrw 0xd90, x3

    #Address 0xd90 read value
    csrr x14, 0xd90

    #Address 0xd90 Write value 0xf686652c
    li x3, 0xf686652c
    csrw 0xd90, x3

    #Address 0xd90 Write value 0x4edf8df7
    li x3, 0x4edf8df7
    csrw 0xd90, x3

    #Unmapped address 0x908 testing: random write/read operations
    #Address 0x908 Write value 0x2bf8f2c3
    li x3, 0x2bf8f2c3
    csrw 0x908, x3

    #Address 0x908 read value
    csrr x14, 0x908

    #Unmapped address 0x662 testing: random write/read operations
    #Address 0x662 read value
    csrr x14, 0x662

    #Address 0x662 read value
    csrr x14, 0x662

    #Address 0x662 Write value 0xf4246f4f
    li x3, 0xf4246f4f
    csrw 0x662, x3

    #Address 0x662 read value
    csrr x14, 0x662

    #Address 0x662 Write value 0x901d73e1
    li x3, 0x901d73e1
    csrw 0x662, x3

    #Unmapped address 0x445 testing: random write/read operations
    #Address 0x445 Write value 0x57218c53
    li x3, 0x57218c53
    csrw 0x445, x3

    #Address 0x445 Write value 0x397dbf6d
    li x3, 0x397dbf6d
    csrw 0x445, x3

    #Unmapped address 0x6dc testing: random write/read operations
    #Address 0x6dc Write value 0x7d1faa16
    li x3, 0x7d1faa16
    csrw 0x6dc, x3

    #Address 0x6dc Write value 0xe2df1182
    li x3, 0xe2df1182
    csrw 0x6dc, x3

    #Unmapped address 0x6e6 testing: random write/read operations
    #Address 0x6e6 Write value 0x798edc84
    li x3, 0x798edc84
    csrw 0x6e6, x3

    #Address 0x6e6 Write value 0xfa55a7c9
    li x3, 0xfa55a7c9
    csrw 0x6e6, x3

    #Address 0x6e6 Write value 0xe1d16538
    li x3, 0xe1d16538
    csrw 0x6e6, x3

    #Unmapped address 0xef7 testing: random write/read operations
    #Address 0xef7 read value
    csrr x14, 0xef7

    #Address 0xef7 Write value 0x43675528
    li x3, 0x43675528
    csrw 0xef7, x3

    #Address 0xef7 read value
    csrr x14, 0xef7

    #Address 0xef7 Write value 0xdf7f7601
    li x3, 0xdf7f7601
    csrw 0xef7, x3

    #Unmapped address 0x3f6 testing: random write/read operations
    #Address 0x3f6 Write value 0x56bc35a2
    li x3, 0x56bc35a2
    csrw 0x3f6, x3

    #Address 0x3f6 Write value 0xbd65b2ed
    li x3, 0xbd65b2ed
    csrw 0x3f6, x3

    #Unmapped address 0x25f testing: random write/read operations
    #Address 0x25f read value
    csrr x14, 0x25f

    #Address 0x25f read value
    csrr x14, 0x25f

    #Address 0x25f Write value 0xe1588e37
    li x3, 0xe1588e37
    csrw 0x25f, x3

    #Unmapped address 0xc62 testing: random write/read operations
    #Address 0xc62 read value
    csrr x14, 0xc62

    #Unmapped address 0x3d6 testing: random write/read operations
    #Address 0x3d6 read value
    csrr x14, 0x3d6

    #Address 0x3d6 read value
    csrr x14, 0x3d6

    #Unmapped address 0x93d testing: random write/read operations
    #Address 0x93d Write value 0x6472f236
    li x3, 0x6472f236
    csrw 0x93d, x3

    #Unmapped address 0x601 testing: random write/read operations
    #Address 0x601 read value
    csrr x14, 0x601

    #Address 0x601 Write value 0xf1cb05e9
    li x3, 0xf1cb05e9
    csrw 0x601, x3

    #Address 0x601 read value
    csrr x14, 0x601

    #Unmapped address 0x8dc testing: random write/read operations
    #Address 0x8dc Write value 0x14d47fc4
    li x3, 0x14d47fc4
    csrw 0x8dc, x3

    #Unmapped address 0x9d testing: random write/read operations
    #Address 0x9d Write value 0x791213e8
    li x3, 0x791213e8
    csrw 0x9d, x3

    #Address 0x9d read value
    csrr x14, 0x9d

    #Address 0x9d Write value 0xb00b7ca9
    li x3, 0xb00b7ca9
    csrw 0x9d, x3

    #Address 0x9d read value
    csrr x14, 0x9d

    #Address 0x9d read value
    csrr x14, 0x9d

    #Unmapped address 0x96b testing: random write/read operations
    #Address 0x96b read value
    csrr x14, 0x96b

    #Address 0x96b read value
    csrr x14, 0x96b

    #Address 0x96b read value
    csrr x14, 0x96b

    #Unmapped address 0x855 testing: random write/read operations
    #Address 0x855 Write value 0x1bceab93
    li x3, 0x1bceab93
    csrw 0x855, x3

    #Address 0x855 read value
    csrr x14, 0x855

    #Address 0x855 read value
    csrr x14, 0x855

    #Unmapped address 0xfee testing: random write/read operations
    #Address 0xfee Write value 0xb0619dd5
    li x3, 0xb0619dd5
    csrw 0xfee, x3

    #Unmapped address 0x137 testing: random write/read operations
    #Address 0x137 Write value 0xe63d5fd0
    li x3, 0xe63d5fd0
    csrw 0x137, x3

    #Unmapped address 0x49 testing: random write/read operations
    #Address 0x49 Write value 0x44d21f9b
    li x3, 0x44d21f9b
    csrw 0x49, x3

    #Address 0x49 read value
    csrr x14, 0x49

    #Address 0x49 Write value 0x74d8bd10
    li x3, 0x74d8bd10
    csrw 0x49, x3

    #Address 0x49 read value
    csrr x14, 0x49

    #Unmapped address 0x81e testing: random write/read operations
    #Address 0x81e read value
    csrr x14, 0x81e

    #Address 0x81e Write value 0x6ee9135a
    li x3, 0x6ee9135a
    csrw 0x81e, x3

    #Unmapped address 0xd64 testing: random write/read operations
    #Address 0xd64 read value
    csrr x14, 0xd64

    #Address 0xd64 read value
    csrr x14, 0xd64

    #Address 0xd64 Write value 0xa9ba228f
    li x3, 0xa9ba228f
    csrw 0xd64, x3

    #Address 0xd64 Write value 0xa6fbf885
    li x3, 0xa6fbf885
    csrw 0xd64, x3

    #Unmapped address 0xa74 testing: random write/read operations
    #Address 0xa74 Write value 0x8697d01f
    li x3, 0x8697d01f
    csrw 0xa74, x3

    #Address 0xa74 read value
    csrr x14, 0xa74

    #Address 0xa74 read value
    csrr x14, 0xa74

    #Address 0xa74 Write value 0x3fbb82a
    li x3, 0x3fbb82a
    csrw 0xa74, x3

    #Address 0xa74 Write value 0xd7398fec
    li x3, 0xd7398fec
    csrw 0xa74, x3

    #Mapped address 0xf11 (mvendorid) testing: random write/read operations
    #Address 0xf11 Write value 0x3071335
    li x3, 0x3071335
    csrw 0xf11, x3

    #Unmapped address 0x386 testing: random write/read operations
    #Address 0x386 Write value 0x5484df91
    li x3, 0x5484df91
    csrw 0x386, x3

    #Address 0x386 read value
    csrr x14, 0x386

    #Address 0x386 Write value 0xd8eec2c1
    li x3, 0xd8eec2c1
    csrw 0x386, x3

    #Address 0x386 read value
    csrr x14, 0x386

    #Address 0x386 read value
    csrr x14, 0x386

    #Unmapped address 0xf7 testing: random write/read operations
    #Address 0xf7 Write value 0xbf2c1114
    li x3, 0xbf2c1114
    csrw 0xf7, x3

    #Address 0xf7 read value
    csrr x14, 0xf7

    #Address 0xf7 read value
    csrr x14, 0xf7

    #Unmapped address 0xc9e testing: random write/read operations
    #Address 0xc9e Write value 0xd31d15c9
    li x3, 0xd31d15c9
    csrw 0xc9e, x3

    #Address 0xc9e read value
    csrr x14, 0xc9e

    #Address 0xc9e Write value 0xf48579e4
    li x3, 0xf48579e4
    csrw 0xc9e, x3

    #Address 0xc9e read value
    csrr x14, 0xc9e

    #Unmapped address 0xcaa testing: random write/read operations
    #Address 0xcaa read value
    csrr x14, 0xcaa

    #Address 0xcaa Write value 0x51d7c38e
    li x3, 0x51d7c38e
    csrw 0xcaa, x3

    #Unmapped address 0x60a testing: random write/read operations
    #Address 0x60a Write value 0xf86828a
    li x3, 0xf86828a
    csrw 0x60a, x3

    #Address 0x60a Write value 0x3fdcf97a
    li x3, 0x3fdcf97a
    csrw 0x60a, x3

    #Unmapped address 0xa5d testing: random write/read operations
    #Address 0xa5d read value
    csrr x14, 0xa5d

    #Address 0xa5d Write value 0x297c2b6f
    li x3, 0x297c2b6f
    csrw 0xa5d, x3

    #Address 0xa5d Write value 0x845a9a3c
    li x3, 0x845a9a3c
    csrw 0xa5d, x3

    #Address 0xa5d read value
    csrr x14, 0xa5d

    #Unmapped address 0x9b6 testing: random write/read operations
    #Address 0x9b6 read value
    csrr x14, 0x9b6

    #Unmapped address 0x455 testing: random write/read operations
    #Address 0x455 read value
    csrr x14, 0x455

    #Address 0x455 Write value 0x7dc2a14
    li x3, 0x7dc2a14
    csrw 0x455, x3

    #Address 0x455 read value
    csrr x14, 0x455

    #Unmapped address 0xa0 testing: random write/read operations
    #Address 0xa0 read value
    csrr x14, 0xa0

    #Address 0xa0 read value
    csrr x14, 0xa0

    #Unmapped address 0x1f8 testing: random write/read operations
    #Address 0x1f8 read value
    csrr x14, 0x1f8

    #Address 0x1f8 read value
    csrr x14, 0x1f8

    #Address 0x1f8 Write value 0x46f16a59
    li x3, 0x46f16a59
    csrw 0x1f8, x3

    #Unmapped address 0xcf7 testing: random write/read operations
    #Address 0xcf7 read value
    csrr x14, 0xcf7

    #Address 0xcf7 Write value 0xe9ba8637
    li x3, 0xe9ba8637
    csrw 0xcf7, x3

    #Address 0xcf7 Write value 0xb4e8959
    li x3, 0xb4e8959
    csrw 0xcf7, x3

    #Unmapped address 0xfaf testing: random write/read operations
    #Address 0xfaf read value
    csrr x14, 0xfaf

    #Address 0xfaf read value
    csrr x14, 0xfaf

    #Address 0xfaf Write value 0x976e0da
    li x3, 0x976e0da
    csrw 0xfaf, x3

    #Address 0xfaf Write value 0x28842bcd
    li x3, 0x28842bcd
    csrw 0xfaf, x3

    #Address 0xfaf read value
    csrr x14, 0xfaf

    #Unmapped address 0xc49 testing: random write/read operations
    #Address 0xc49 Write value 0xf543a945
    li x3, 0xf543a945
    csrw 0xc49, x3

    #Address 0xc49 Write value 0x79d9a4b0
    li x3, 0x79d9a4b0
    csrw 0xc49, x3

    #Unmapped address 0x6ad testing: random write/read operations
    #Address 0x6ad Write value 0xecfc83e1
    li x3, 0xecfc83e1
    csrw 0x6ad, x3

    #Address 0x6ad read value
    csrr x14, 0x6ad

    #Address 0x6ad read value
    csrr x14, 0x6ad

    #Unmapped address 0xbf0 testing: random write/read operations
    #Address 0xbf0 Write value 0xc41fdf0
    li x3, 0xc41fdf0
    csrw 0xbf0, x3

    #Address 0xbf0 read value
    csrr x14, 0xbf0

    #Address 0xbf0 Write value 0x76851963
    li x3, 0x76851963
    csrw 0xbf0, x3

    #Unmapped address 0x585 testing: random write/read operations
    #Address 0x585 Write value 0x3d955bdc
    li x3, 0x3d955bdc
    csrw 0x585, x3

    #Address 0x585 Write value 0x7b067870
    li x3, 0x7b067870
    csrw 0x585, x3

    #Address 0x585 Write value 0xc731ced6
    li x3, 0xc731ced6
    csrw 0x585, x3

    #Address 0x585 Write value 0x7b2e843e
    li x3, 0x7b2e843e
    csrw 0x585, x3

    #Address 0x585 Write value 0xe1ce70a5
    li x3, 0xe1ce70a5
    csrw 0x585, x3

    #Unmapped address 0x23a testing: random write/read operations
    #Address 0x23a read value
    csrr x14, 0x23a

    #Address 0x23a read value
    csrr x14, 0x23a

    #Address 0x23a Write value 0xf1f6a102
    li x3, 0xf1f6a102
    csrw 0x23a, x3

    #Address 0x23a read value
    csrr x14, 0x23a

    #Unmapped address 0xbd1 testing: random write/read operations
    #Address 0xbd1 Write value 0x477eacff
    li x3, 0x477eacff
    csrw 0xbd1, x3

    #Address 0xbd1 Write value 0x5979fd61
    li x3, 0x5979fd61
    csrw 0xbd1, x3

    #Address 0xbd1 read value
    csrr x14, 0xbd1

    #Address 0xbd1 Write value 0xbdd2285a
    li x3, 0xbdd2285a
    csrw 0xbd1, x3

    #Unmapped address 0x5f6 testing: random write/read operations
    #Address 0x5f6 read value
    csrr x14, 0x5f6

    #Unmapped address 0xbb testing: random write/read operations
    #Address 0xbb Write value 0x1ffb70b1
    li x3, 0x1ffb70b1
    csrw 0xbb, x3

    #Unmapped address 0x4a5 testing: random write/read operations
    #Address 0x4a5 read value
    csrr x14, 0x4a5

    #Address 0x4a5 Write value 0x15707046
    li x3, 0x15707046
    csrw 0x4a5, x3

    #Address 0x4a5 read value
    csrr x14, 0x4a5

    #Unmapped address 0xfd4 testing: random write/read operations
    #Address 0xfd4 read value
    csrr x14, 0xfd4

    #Address 0xfd4 Write value 0x68129365
    li x3, 0x68129365
    csrw 0xfd4, x3

    #Unmapped address 0xca5 testing: random write/read operations
    #Address 0xca5 read value
    csrr x14, 0xca5

    #Address 0xca5 read value
    csrr x14, 0xca5

    #Address 0xca5 Write value 0x86d62413
    li x3, 0x86d62413
    csrw 0xca5, x3

    #Address 0xca5 read value
    csrr x14, 0xca5

    #Address 0xca5 read value
    csrr x14, 0xca5

    #Mapped address 0xb05 (mhpmcounter5) testing: random write/read operations
    #Address 0xb05 Write value 0x143dd9a3
    li x3, 0x143dd9a3
    csrw 0xb05, x3

    #Unmapped address 0x949 testing: random write/read operations
    #Address 0x949 read value
    csrr x14, 0x949

    #Address 0x949 Write value 0xb3416794
    li x3, 0xb3416794
    csrw 0x949, x3

    #Address 0x949 Write value 0x415e20ff
    li x3, 0x415e20ff
    csrw 0x949, x3

    #Address 0x949 Write value 0xbe0ed93
    li x3, 0xbe0ed93
    csrw 0x949, x3

    #Unmapped address 0x892 testing: random write/read operations
    #Address 0x892 read value
    csrr x14, 0x892

    #Address 0x892 Write value 0x9c54ecb8
    li x3, 0x9c54ecb8
    csrw 0x892, x3

    #Unmapped address 0x3a testing: random write/read operations
    #Address 0x3a read value
    csrr x14, 0x3a

    #Address 0x3a read value
    csrr x14, 0x3a

    #Address 0x3a Write value 0x81462e94
    li x3, 0x81462e94
    csrw 0x3a, x3

    #Unmapped address 0xd79 testing: random write/read operations
    #Address 0xd79 read value
    csrr x14, 0xd79

    #Address 0xd79 read value
    csrr x14, 0xd79

    #Address 0xd79 read value
    csrr x14, 0xd79

    #Address 0xd79 Write value 0x8a3db5ac
    li x3, 0x8a3db5ac
    csrw 0xd79, x3

    #Address 0xd79 read value
    csrr x14, 0xd79

    #Unmapped address 0x7d8 testing: random write/read operations
    #Address 0x7d8 Write value 0x746f6aab
    li x3, 0x746f6aab
    csrw 0x7d8, x3

    #Address 0x7d8 Write value 0xdf3bb1c4
    li x3, 0xdf3bb1c4
    csrw 0x7d8, x3

    #Address 0x7d8 Write value 0xfa44bb30
    li x3, 0xfa44bb30
    csrw 0x7d8, x3

    #Address 0x7d8 read value
    csrr x14, 0x7d8

    #Mapped address 0xf14 (mhartid) testing: random write/read operations
    #Address 0xf14 read value
    csrr x14, 0xf14

    #Address 0xf14 read value
    csrr x14, 0xf14

    #Unmapped address 0x1b3 testing: random write/read operations
    #Address 0x1b3 Write value 0xbd35225e
    li x3, 0xbd35225e
    csrw 0x1b3, x3

    #Unmapped address 0xc0f testing: random write/read operations
    #Address 0xc0f Write value 0xc155b0d6
    li x3, 0xc155b0d6
    csrw 0xc0f, x3

    #Address 0xc0f read value
    csrr x14, 0xc0f

    #Unmapped address 0x3dc testing: random write/read operations
    #Address 0x3dc Write value 0x7c05479e
    li x3, 0x7c05479e
    csrw 0x3dc, x3

    #Unmapped address 0x555 testing: random write/read operations
    #Address 0x555 Write value 0x2020fd97
    li x3, 0x2020fd97
    csrw 0x555, x3

    #Unmapped address 0x1db testing: random write/read operations
    #Address 0x1db read value
    csrr x14, 0x1db

    #Unmapped address 0x4e2 testing: random write/read operations
    #Address 0x4e2 read value
    csrr x14, 0x4e2

    #Address 0x4e2 Write value 0x16e41fe4
    li x3, 0x16e41fe4
    csrw 0x4e2, x3

    #Unmapped address 0xdc2 testing: random write/read operations
    #Address 0xdc2 read value
    csrr x14, 0xdc2

    #Address 0xdc2 Write value 0x1a5cbc06
    li x3, 0x1a5cbc06
    csrw 0xdc2, x3

    #Address 0xdc2 Write value 0x9fc42fec
    li x3, 0x9fc42fec
    csrw 0xdc2, x3

    #Address 0xdc2 Write value 0x4955f7cf
    li x3, 0x4955f7cf
    csrw 0xdc2, x3

    #Unmapped address 0x5f4 testing: random write/read operations
    #Address 0x5f4 Write value 0xc820f602
    li x3, 0xc820f602
    csrw 0x5f4, x3

    #Address 0x5f4 read value
    csrr x14, 0x5f4

    #Unmapped address 0xcb3 testing: random write/read operations
    #Address 0xcb3 read value
    csrr x14, 0xcb3

    #Address 0xcb3 read value
    csrr x14, 0xcb3

    #Address 0xcb3 read value
    csrr x14, 0xcb3

    #Unmapped address 0xb34 testing: random write/read operations
    #Address 0xb34 Write value 0xd907176a
    li x3, 0xd907176a
    csrw 0xb34, x3

    #Address 0xb34 Write value 0x8961dc7d
    li x3, 0x8961dc7d
    csrw 0xb34, x3

    #Address 0xb34 Write value 0x84df52df
    li x3, 0x84df52df
    csrw 0xb34, x3

    #Unmapped address 0xfa0 testing: random write/read operations
    #Address 0xfa0 Write value 0x201bdc6
    li x3, 0x201bdc6
    csrw 0xfa0, x3

    #Address 0xfa0 read value
    csrr x14, 0xfa0

    #Address 0xfa0 read value
    csrr x14, 0xfa0

    #Address 0xfa0 read value
    csrr x14, 0xfa0

    #Unmapped address 0x474 testing: random write/read operations
    #Address 0x474 read value
    csrr x14, 0x474

    #Address 0x474 Write value 0x7f6883d6
    li x3, 0x7f6883d6
    csrw 0x474, x3

    #Address 0x474 Write value 0x1e580680
    li x3, 0x1e580680
    csrw 0x474, x3

    #Address 0x474 read value
    csrr x14, 0x474

    #Address 0x474 read value
    csrr x14, 0x474

    #Unmapped address 0xc40 testing: random write/read operations
    #Address 0xc40 read value
    csrr x14, 0xc40

    #Address 0xc40 Write value 0x81adc2c7
    li x3, 0x81adc2c7
    csrw 0xc40, x3

    #Address 0xc40 Write value 0x7652c681
    li x3, 0x7652c681
    csrw 0xc40, x3

    #Address 0xc40 Write value 0x96d02910
    li x3, 0x96d02910
    csrw 0xc40, x3

    #Address 0xc40 Write value 0x15fa97b3
    li x3, 0x15fa97b3
    csrw 0xc40, x3

    #Unmapped address 0x30d testing: random write/read operations
    #Address 0x30d Write value 0xeeff01d
    li x3, 0xeeff01d
    csrw 0x30d, x3

    #Address 0x30d read value
    csrr x14, 0x30d

    #Address 0x30d Write value 0x5cee9a0a
    li x3, 0x5cee9a0a
    csrw 0x30d, x3

    #Unmapped address 0x308 testing: random write/read operations
    #Address 0x308 read value
    csrr x14, 0x308

    #Address 0x308 read value
    csrr x14, 0x308

    #Mapped address 0xb87 (mhpmcounterh7) testing: random write/read operations
    #Address 0xb87 read value
    csrr x14, 0xb87

    #Address 0xb87 Write value 0x9370e58b
    li x3, 0x9370e58b
    csrw 0xb87, x3

    #Address 0xb87 read value
    csrr x14, 0xb87

    #Address 0xb87 read value
    csrr x14, 0xb87

    #Address 0xb87 read value
    csrr x14, 0xb87

    #Unmapped address 0x49c testing: random write/read operations
    #Address 0x49c read value
    csrr x14, 0x49c

    #Address 0x49c Write value 0x1988a438
    li x3, 0x1988a438
    csrw 0x49c, x3

    #Address 0x49c read value
    csrr x14, 0x49c

    #Address 0x49c Write value 0xb48ed84b
    li x3, 0xb48ed84b
    csrw 0x49c, x3

    #Address 0x49c Write value 0x8293304e
    li x3, 0x8293304e
    csrw 0x49c, x3

    #Unmapped address 0x69b testing: random write/read operations
    #Address 0x69b Write value 0x5398cd34
    li x3, 0x5398cd34
    csrw 0x69b, x3

    #Address 0x69b Write value 0x137a6713
    li x3, 0x137a6713
    csrw 0x69b, x3

    #Unmapped address 0x96e testing: random write/read operations
    #Address 0x96e read value
    csrr x14, 0x96e

    #Address 0x96e Write value 0x867b7de0
    li x3, 0x867b7de0
    csrw 0x96e, x3

    #Address 0x96e Write value 0x14f87385
    li x3, 0x14f87385
    csrw 0x96e, x3

    #Address 0x96e Write value 0xa670e30c
    li x3, 0xa670e30c
    csrw 0x96e, x3

    #Address 0x96e read value
    csrr x14, 0x96e

    #Unmapped address 0x281 testing: random write/read operations
    #Address 0x281 read value
    csrr x14, 0x281

    #Address 0x281 Write value 0xb92ee348
    li x3, 0xb92ee348
    csrw 0x281, x3

    #Address 0x281 read value
    csrr x14, 0x281

    #Address 0x281 Write value 0x861084f8
    li x3, 0x861084f8
    csrw 0x281, x3

    #Unmapped address 0x13d testing: random write/read operations
    #Address 0x13d Write value 0xa55ad46
    li x3, 0xa55ad46
    csrw 0x13d, x3

    #Address 0x13d Write value 0xf488ab7b
    li x3, 0xf488ab7b
    csrw 0x13d, x3

    #Address 0x13d read value
    csrr x14, 0x13d

    #Address 0x13d read value
    csrr x14, 0x13d

    #Unmapped address 0xe65 testing: random write/read operations
    #Address 0xe65 read value
    csrr x14, 0xe65

    #Address 0xe65 Write value 0xf24a1c56
    li x3, 0xf24a1c56
    csrw 0xe65, x3

    #Address 0xe65 read value
    csrr x14, 0xe65

    #Address 0xe65 read value
    csrr x14, 0xe65

    #Unmapped address 0x828 testing: random write/read operations
    #Address 0x828 Write value 0x8618feeb
    li x3, 0x8618feeb
    csrw 0x828, x3

    #Unmapped address 0x554 testing: random write/read operations
    #Address 0x554 read value
    csrr x14, 0x554

    #Address 0x554 Write value 0xe3539b6f
    li x3, 0xe3539b6f
    csrw 0x554, x3

    #Address 0x554 Write value 0x381baa9f
    li x3, 0x381baa9f
    csrw 0x554, x3

    #Address 0x554 Write value 0x3c728da4
    li x3, 0x3c728da4
    csrw 0x554, x3

    #Unmapped address 0x1d3 testing: random write/read operations
    #Address 0x1d3 read value
    csrr x14, 0x1d3

    #Address 0x1d3 read value
    csrr x14, 0x1d3

    #Unmapped address 0x537 testing: random write/read operations
    #Address 0x537 read value
    csrr x14, 0x537

    #Address 0x537 Write value 0xbc53625b
    li x3, 0xbc53625b
    csrw 0x537, x3

    #Address 0x537 Write value 0xa8e7685d
    li x3, 0xa8e7685d
    csrw 0x537, x3

    #Address 0x537 Write value 0xe99a7e87
    li x3, 0xe99a7e87
    csrw 0x537, x3

    #Unmapped address 0xe96 testing: random write/read operations
    #Address 0xe96 read value
    csrr x14, 0xe96

    #Address 0xe96 Write value 0x6226e2c6
    li x3, 0x6226e2c6
    csrw 0xe96, x3

    #Unmapped address 0x150 testing: random write/read operations
    #Address 0x150 Write value 0x982ba972
    li x3, 0x982ba972
    csrw 0x150, x3

    #Address 0x150 Write value 0xf1836672
    li x3, 0xf1836672
    csrw 0x150, x3

    #Address 0x150 read value
    csrr x14, 0x150

    #Address 0x150 Write value 0xa301a58b
    li x3, 0xa301a58b
    csrw 0x150, x3

    #Address 0x150 Write value 0xf0a3e509
    li x3, 0xf0a3e509
    csrw 0x150, x3

    #Unmapped address 0x528 testing: random write/read operations
    #Address 0x528 Write value 0x772d4a32
    li x3, 0x772d4a32
    csrw 0x528, x3

    #Address 0x528 read value
    csrr x14, 0x528

    #Unmapped address 0xac1 testing: random write/read operations
    #Address 0xac1 read value
    csrr x14, 0xac1

    #Address 0xac1 read value
    csrr x14, 0xac1

    #Address 0xac1 Write value 0xf609d0a1
    li x3, 0xf609d0a1
    csrw 0xac1, x3

    #Address 0xac1 read value
    csrr x14, 0xac1

    #Unmapped address 0xf6b testing: random write/read operations
    #Address 0xf6b Write value 0xc33768ad
    li x3, 0xc33768ad
    csrw 0xf6b, x3

    #Address 0xf6b Write value 0xecef1bc1
    li x3, 0xecef1bc1
    csrw 0xf6b, x3

    #Unmapped address 0x1a8 testing: random write/read operations
    #Address 0x1a8 Write value 0x553513d7
    li x3, 0x553513d7
    csrw 0x1a8, x3

    #Address 0x1a8 read value
    csrr x14, 0x1a8

    #Address 0x1a8 read value
    csrr x14, 0x1a8

    #Address 0x1a8 Write value 0x2721e218
    li x3, 0x2721e218
    csrw 0x1a8, x3

    #Address 0x1a8 Write value 0x25b61f5e
    li x3, 0x25b61f5e
    csrw 0x1a8, x3

    #Unmapped address 0xf55 testing: random write/read operations
    #Address 0xf55 Write value 0x90f7484
    li x3, 0x90f7484
    csrw 0xf55, x3

    #Address 0xf55 Write value 0xfce1277f
    li x3, 0xfce1277f
    csrw 0xf55, x3

    #Address 0xf55 read value
    csrr x14, 0xf55

    #Address 0xf55 read value
    csrr x14, 0xf55

    #Address 0xf55 Write value 0xfe9570e
    li x3, 0xfe9570e
    csrw 0xf55, x3

    #Unmapped address 0x151 testing: random write/read operations
    #Address 0x151 Write value 0x1803d4d9
    li x3, 0x1803d4d9
    csrw 0x151, x3

    #Address 0x151 read value
    csrr x14, 0x151

    #Address 0x151 Write value 0xe75ddd6f
    li x3, 0xe75ddd6f
    csrw 0x151, x3

    #Address 0x151 read value
    csrr x14, 0x151

    #Unmapped address 0xf0f testing: random write/read operations
    #Address 0xf0f read value
    csrr x14, 0xf0f

    #Address 0xf0f read value
    csrr x14, 0xf0f

    #Address 0xf0f Write value 0x44e73d55
    li x3, 0x44e73d55
    csrw 0xf0f, x3

    #Unmapped address 0x3dd testing: random write/read operations
    #Address 0x3dd read value
    csrr x14, 0x3dd

    #Address 0x3dd Write value 0xee991752
    li x3, 0xee991752
    csrw 0x3dd, x3

    #Address 0x3dd Write value 0x4afc1a64
    li x3, 0x4afc1a64
    csrw 0x3dd, x3

    #Address 0x3dd read value
    csrr x14, 0x3dd

    #Unmapped address 0x5d1 testing: random write/read operations
    #Address 0x5d1 read value
    csrr x14, 0x5d1

    #Unmapped address 0xeb0 testing: random write/read operations
    #Address 0xeb0 Write value 0x25e5b7f9
    li x3, 0x25e5b7f9
    csrw 0xeb0, x3

    #Address 0xeb0 Write value 0xe138ddc9
    li x3, 0xe138ddc9
    csrw 0xeb0, x3

    #Address 0xeb0 Write value 0x38f703c0
    li x3, 0x38f703c0
    csrw 0xeb0, x3

    #Address 0xeb0 Write value 0xdcb9081e
    li x3, 0xdcb9081e
    csrw 0xeb0, x3

    #Unmapped address 0x375 testing: random write/read operations
    #Address 0x375 read value
    csrr x14, 0x375

    #Address 0x375 read value
    csrr x14, 0x375

    #Unmapped address 0xa56 testing: random write/read operations
    #Address 0xa56 Write value 0xb35b816b
    li x3, 0xb35b816b
    csrw 0xa56, x3

    #Address 0xa56 read value
    csrr x14, 0xa56

    #Address 0xa56 Write value 0x8397b58a
    li x3, 0x8397b58a
    csrw 0xa56, x3

    #Unmapped address 0x47f testing: random write/read operations
    #Address 0x47f read value
    csrr x14, 0x47f

    #Address 0x47f read value
    csrr x14, 0x47f

    #Address 0x47f Write value 0x4c44cb7e
    li x3, 0x4c44cb7e
    csrw 0x47f, x3

    #Address 0x47f Write value 0x597ae2ca
    li x3, 0x597ae2ca
    csrw 0x47f, x3

    #Address 0x47f read value
    csrr x14, 0x47f

    #Unmapped address 0xc3 testing: random write/read operations
    #Address 0xc3 Write value 0xba9cc31f
    li x3, 0xba9cc31f
    csrw 0xc3, x3

    #Address 0xc3 read value
    csrr x14, 0xc3

    #Address 0xc3 read value
    csrr x14, 0xc3

    #Unmapped address 0x6a2 testing: random write/read operations
    #Address 0x6a2 read value
    csrr x14, 0x6a2

    #Address 0x6a2 Write value 0x49bde888
    li x3, 0x49bde888
    csrw 0x6a2, x3

    #Unmapped address 0x714 testing: random write/read operations
    #Address 0x714 read value
    csrr x14, 0x714

    #Unmapped address 0x5fa testing: random write/read operations
    #Address 0x5fa read value
    csrr x14, 0x5fa

    #Address 0x5fa Write value 0xba6ea9a2
    li x3, 0xba6ea9a2
    csrw 0x5fa, x3

    #Unmapped address 0x522 testing: random write/read operations
    #Address 0x522 read value
    csrr x14, 0x522

    #Address 0x522 Write value 0xea0aafee
    li x3, 0xea0aafee
    csrw 0x522, x3

    #Unmapped address 0xc7 testing: random write/read operations
    #Address 0xc7 Write value 0x8bc08e6
    li x3, 0x8bc08e6
    csrw 0xc7, x3

    #Address 0xc7 read value
    csrr x14, 0xc7

    #Address 0xc7 Write value 0x6e05efd9
    li x3, 0x6e05efd9
    csrw 0xc7, x3

    #Address 0xc7 read value
    csrr x14, 0xc7

    #Address 0xc7 Write value 0x90dc10d8
    li x3, 0x90dc10d8
    csrw 0xc7, x3

    #Unmapped address 0x8ed testing: random write/read operations
    #Address 0x8ed read value
    csrr x14, 0x8ed

    #Unmapped address 0xfa3 testing: random write/read operations
    #Address 0xfa3 Write value 0xd6177ceb
    li x3, 0xd6177ceb
    csrw 0xfa3, x3

    #Address 0xfa3 Write value 0xe9dc7e13
    li x3, 0xe9dc7e13
    csrw 0xfa3, x3

    #Unmapped address 0x42d testing: random write/read operations
    #Address 0x42d Write value 0x4bb03841
    li x3, 0x4bb03841
    csrw 0x42d, x3

    #Unmapped address 0xc2a testing: random write/read operations
    #Address 0xc2a Write value 0x8f384d4f
    li x3, 0x8f384d4f
    csrw 0xc2a, x3

    #Address 0xc2a read value
    csrr x14, 0xc2a

    #Address 0xc2a Write value 0x1e9fe000
    li x3, 0x1e9fe000
    csrw 0xc2a, x3

    #Address 0xc2a read value
    csrr x14, 0xc2a

    #Address 0xc2a read value
    csrr x14, 0xc2a

    #Unmapped address 0x9cc testing: random write/read operations
    #Address 0x9cc Write value 0x4e662b4b
    li x3, 0x4e662b4b
    csrw 0x9cc, x3

    #Address 0x9cc read value
    csrr x14, 0x9cc

    #Address 0x9cc read value
    csrr x14, 0x9cc

    #Address 0x9cc Write value 0xb466a461
    li x3, 0xb466a461
    csrw 0x9cc, x3

    #Unmapped address 0xb40 testing: random write/read operations
    #Address 0xb40 Write value 0x55354159
    li x3, 0x55354159
    csrw 0xb40, x3

    #Unmapped address 0x3f3 testing: random write/read operations
    #Address 0x3f3 Write value 0xd60a9b18
    li x3, 0xd60a9b18
    csrw 0x3f3, x3

    #Address 0x3f3 Write value 0x57060eaa
    li x3, 0x57060eaa
    csrw 0x3f3, x3

    #Address 0x3f3 read value
    csrr x14, 0x3f3

    #Address 0x3f3 Write value 0xe2d64893
    li x3, 0xe2d64893
    csrw 0x3f3, x3

    #Unmapped address 0x3f9 testing: random write/read operations
    #Address 0x3f9 read value
    csrr x14, 0x3f9

    #Address 0x3f9 read value
    csrr x14, 0x3f9

    #Address 0x3f9 read value
    csrr x14, 0x3f9

    #Unmapped address 0xc70 testing: random write/read operations
    #Address 0xc70 read value
    csrr x14, 0xc70

    #Address 0xc70 Write value 0x2088a1d4
    li x3, 0x2088a1d4
    csrw 0xc70, x3

    #Address 0xc70 read value
    csrr x14, 0xc70

    #Address 0xc70 read value
    csrr x14, 0xc70

    #Address 0xc70 read value
    csrr x14, 0xc70

    #Unmapped address 0xd4 testing: random write/read operations
    #Address 0xd4 read value
    csrr x14, 0xd4

    #Address 0xd4 Write value 0x610c391
    li x3, 0x610c391
    csrw 0xd4, x3

    #Address 0xd4 read value
    csrr x14, 0xd4

    #Address 0xd4 read value
    csrr x14, 0xd4

    #Address 0xd4 read value
    csrr x14, 0xd4

    #Unmapped address 0xe8a testing: random write/read operations
    #Address 0xe8a Write value 0xc0606347
    li x3, 0xc0606347
    csrw 0xe8a, x3

    #Address 0xe8a Write value 0xb952ed08
    li x3, 0xb952ed08
    csrw 0xe8a, x3

    #Address 0xe8a read value
    csrr x14, 0xe8a

    #Address 0xe8a read value
    csrr x14, 0xe8a

    #Unmapped address 0x65e testing: random write/read operations
    #Address 0x65e read value
    csrr x14, 0x65e

    #Address 0x65e Write value 0x6f83de1a
    li x3, 0x6f83de1a
    csrw 0x65e, x3

    #Address 0x65e Write value 0x65118f72
    li x3, 0x65118f72
    csrw 0x65e, x3

    #Address 0x65e Write value 0xa7e25b24
    li x3, 0xa7e25b24
    csrw 0x65e, x3

    #Unmapped address 0x762 testing: random write/read operations
    #Address 0x762 Write value 0xae4c7a69
    li x3, 0xae4c7a69
    csrw 0x762, x3

    #Address 0x762 read value
    csrr x14, 0x762

    #Address 0x762 read value
    csrr x14, 0x762

    #Address 0x762 Write value 0x10ccb2a9
    li x3, 0x10ccb2a9
    csrw 0x762, x3

    #Address 0x762 Write value 0x532c9df
    li x3, 0x532c9df
    csrw 0x762, x3

    #Unmapped address 0x9ff testing: random write/read operations
    #Address 0x9ff Write value 0xa6705183
    li x3, 0xa6705183
    csrw 0x9ff, x3

    #Address 0x9ff read value
    csrr x14, 0x9ff

    #Address 0x9ff Write value 0xa673d074
    li x3, 0xa673d074
    csrw 0x9ff, x3

    #Unmapped address 0xc54 testing: random write/read operations
    #Address 0xc54 read value
    csrr x14, 0xc54

    #Unmapped address 0xac2 testing: random write/read operations
    #Address 0xac2 Write value 0xe8a5318c
    li x3, 0xe8a5318c
    csrw 0xac2, x3

    #Address 0xac2 read value
    csrr x14, 0xac2

    #Address 0xac2 read value
    csrr x14, 0xac2

    #Address 0xac2 Write value 0x9fbad341
    li x3, 0x9fbad341
    csrw 0xac2, x3

    #Mapped address 0xb94 (mhpmcounterh20) testing: random write/read operations
    #Address 0xb94 read value
    csrr x14, 0xb94

    #Unmapped address 0xa1f testing: random write/read operations
    #Address 0xa1f read value
    csrr x14, 0xa1f

    #Unmapped address 0xf9c testing: random write/read operations
    #Address 0xf9c read value
    csrr x14, 0xf9c

    #Address 0xf9c Write value 0x5818b411
    li x3, 0x5818b411
    csrw 0xf9c, x3

    #Address 0xf9c read value
    csrr x14, 0xf9c

    #Address 0xf9c read value
    csrr x14, 0xf9c

    #Unmapped address 0x541 testing: random write/read operations
    #Address 0x541 read value
    csrr x14, 0x541

    #Unmapped address 0xced testing: random write/read operations
    #Address 0xced Write value 0x9a160c64
    li x3, 0x9a160c64
    csrw 0xced, x3

    #Address 0xced read value
    csrr x14, 0xced

    #Address 0xced read value
    csrr x14, 0xced

    #Address 0xced read value
    csrr x14, 0xced

    #Address 0xced read value
    csrr x14, 0xced

    #Unmapped address 0xba0 testing: random write/read operations
    #Address 0xba0 Write value 0xf3987005
    li x3, 0xf3987005
    csrw 0xba0, x3

    #Address 0xba0 read value
    csrr x14, 0xba0

    #Address 0xba0 read value
    csrr x14, 0xba0

    #Unmapped address 0xe89 testing: random write/read operations
    #Address 0xe89 read value
    csrr x14, 0xe89

    #Unmapped address 0xd60 testing: random write/read operations
    #Address 0xd60 Write value 0x433c8050
    li x3, 0x433c8050
    csrw 0xd60, x3

    #Unmapped address 0xfc0 testing: random write/read operations
    #Address 0xfc0 read value
    csrr x14, 0xfc0

    #Unmapped address 0x395 testing: random write/read operations
    #Address 0x395 Write value 0xcd878943
    li x3, 0xcd878943
    csrw 0x395, x3

    #Unmapped address 0x4c5 testing: random write/read operations
    #Address 0x4c5 read value
    csrr x14, 0x4c5

    #Address 0x4c5 Write value 0x4b1056a5
    li x3, 0x4b1056a5
    csrw 0x4c5, x3

    #Unmapped address 0x55c testing: random write/read operations
    #Address 0x55c read value
    csrr x14, 0x55c

    #Address 0x55c read value
    csrr x14, 0x55c

    #Address 0x55c Write value 0x81fd194e
    li x3, 0x81fd194e
    csrw 0x55c, x3

    #Address 0x55c read value
    csrr x14, 0x55c

    #Address 0x55c read value
    csrr x14, 0x55c

    #Unmapped address 0x825 testing: random write/read operations
    #Address 0x825 Write value 0x59f56eed
    li x3, 0x59f56eed
    csrw 0x825, x3

    #Address 0x825 read value
    csrr x14, 0x825

    #Address 0x825 Write value 0x3fe3290b
    li x3, 0x3fe3290b
    csrw 0x825, x3

    #Unmapped address 0x1de testing: random write/read operations
    #Address 0x1de read value
    csrr x14, 0x1de

    #Address 0x1de read value
    csrr x14, 0x1de

    #Address 0x1de Write value 0xf2304bea
    li x3, 0xf2304bea
    csrw 0x1de, x3

    #Unmapped address 0xd03 testing: random write/read operations
    #Address 0xd03 read value
    csrr x14, 0xd03

    #Address 0xd03 Write value 0xe3dc1f97
    li x3, 0xe3dc1f97
    csrw 0xd03, x3

    #Address 0xd03 read value
    csrr x14, 0xd03

    #Unmapped address 0xedc testing: random write/read operations
    #Address 0xedc read value
    csrr x14, 0xedc

    #Address 0xedc read value
    csrr x14, 0xedc

    #Unmapped address 0x44d testing: random write/read operations
    #Address 0x44d read value
    csrr x14, 0x44d

    #Address 0x44d read value
    csrr x14, 0x44d

    #Unmapped address 0xfec testing: random write/read operations
    #Address 0xfec Write value 0xe9a2f2c7
    li x3, 0xe9a2f2c7
    csrw 0xfec, x3

    #Address 0xfec read value
    csrr x14, 0xfec

    #Address 0xfec read value
    csrr x14, 0xfec

    #Unmapped address 0x68d testing: random write/read operations
    #Address 0x68d read value
    csrr x14, 0x68d

    #Address 0x68d Write value 0x3f90d037
    li x3, 0x3f90d037
    csrw 0x68d, x3

    #Address 0x68d read value
    csrr x14, 0x68d

    #Unmapped address 0xe1a testing: random write/read operations
    #Address 0xe1a Write value 0xdedc3668
    li x3, 0xdedc3668
    csrw 0xe1a, x3

    #Address 0xe1a Write value 0x2c3dd3dc
    li x3, 0x2c3dd3dc
    csrw 0xe1a, x3

    #Address 0xe1a Write value 0xb492f36a
    li x3, 0xb492f36a
    csrw 0xe1a, x3

    #Address 0xe1a Write value 0xb9aded64
    li x3, 0xb9aded64
    csrw 0xe1a, x3

    #Unmapped address 0x980 testing: random write/read operations
    #Address 0x980 Write value 0xf092b0ea
    li x3, 0xf092b0ea
    csrw 0x980, x3

    #Address 0x980 read value
    csrr x14, 0x980

    #Unmapped address 0xf64 testing: random write/read operations
    #Address 0xf64 Write value 0xb2c11f72
    li x3, 0xb2c11f72
    csrw 0xf64, x3

    #Address 0xf64 read value
    csrr x14, 0xf64

    #Unmapped address 0x816 testing: random write/read operations
    #Address 0x816 Write value 0x85863d29
    li x3, 0x85863d29
    csrw 0x816, x3

    #Address 0x816 read value
    csrr x14, 0x816

    #Address 0x816 read value
    csrr x14, 0x816

    #Address 0x816 Write value 0x51569c44
    li x3, 0x51569c44
    csrw 0x816, x3

    #Unmapped address 0x7c testing: random write/read operations
    #Address 0x7c read value
    csrr x14, 0x7c

    #Unmapped address 0x940 testing: random write/read operations
    #Address 0x940 Write value 0xb316c09
    li x3, 0xb316c09
    csrw 0x940, x3

    #Unmapped address 0xff3 testing: random write/read operations
    #Address 0xff3 read value
    csrr x14, 0xff3

    #Address 0xff3 Write value 0x533ee554
    li x3, 0x533ee554
    csrw 0xff3, x3

    #Address 0xff3 Write value 0x1f791523
    li x3, 0x1f791523
    csrw 0xff3, x3

    #Address 0xff3 Write value 0xba1c08db
    li x3, 0xba1c08db
    csrw 0xff3, x3

    #Address 0xff3 Write value 0xe5d7c011
    li x3, 0xe5d7c011
    csrw 0xff3, x3

    #Unmapped address 0xe93 testing: random write/read operations
    #Address 0xe93 Write value 0xbf601dce
    li x3, 0xbf601dce
    csrw 0xe93, x3

    #Address 0xe93 read value
    csrr x14, 0xe93

    #Unmapped address 0xbc5 testing: random write/read operations
    #Address 0xbc5 read value
    csrr x14, 0xbc5

    #Address 0xbc5 read value
    csrr x14, 0xbc5

    #Address 0xbc5 Write value 0xd721ee5f
    li x3, 0xd721ee5f
    csrw 0xbc5, x3

    #Address 0xbc5 Write value 0xe0655498
    li x3, 0xe0655498
    csrw 0xbc5, x3

    #Address 0xbc5 Write value 0xb9321925
    li x3, 0xb9321925
    csrw 0xbc5, x3

    #Mapped address 0xb96 (mhpmcounterh22) testing: random write/read operations
    #Address 0xb96 Write value 0xbafead95
    li x3, 0xbafead95
    csrw 0xb96, x3

    #Address 0xb96 read value
    csrr x14, 0xb96

    #Address 0xb96 read value
    csrr x14, 0xb96

    #Unmapped address 0xe22 testing: random write/read operations
    #Address 0xe22 read value
    csrr x14, 0xe22

    #Address 0xe22 read value
    csrr x14, 0xe22

    #Address 0xe22 Write value 0xd72b66f5
    li x3, 0xd72b66f5
    csrw 0xe22, x3

    #Address 0xe22 read value
    csrr x14, 0xe22

    #Address 0xe22 Write value 0xf03e6847
    li x3, 0xf03e6847
    csrw 0xe22, x3

    #Unmapped address 0xdb1 testing: random write/read operations
    #Address 0xdb1 read value
    csrr x14, 0xdb1

    #Address 0xdb1 Write value 0xb4aa1983
    li x3, 0xb4aa1983
    csrw 0xdb1, x3

    #Address 0xdb1 Write value 0x4da3f72d
    li x3, 0x4da3f72d
    csrw 0xdb1, x3

    #Unmapped address 0xae6 testing: random write/read operations
    #Address 0xae6 read value
    csrr x14, 0xae6

    #Unmapped address 0xb6c testing: random write/read operations
    #Address 0xb6c read value
    csrr x14, 0xb6c

    #Address 0xb6c Write value 0x7e25c93b
    li x3, 0x7e25c93b
    csrw 0xb6c, x3

    #Address 0xb6c read value
    csrr x14, 0xb6c

    #Address 0xb6c read value
    csrr x14, 0xb6c

    #Unmapped address 0x9ed testing: random write/read operations
    #Address 0x9ed read value
    csrr x14, 0x9ed

    #Address 0x9ed Write value 0x4ed71618
    li x3, 0x4ed71618
    csrw 0x9ed, x3

    #Address 0x9ed Write value 0x7d80f8a
    li x3, 0x7d80f8a
    csrw 0x9ed, x3

    #Address 0x9ed read value
    csrr x14, 0x9ed

    #Unmapped address 0xd5d testing: random write/read operations
    #Address 0xd5d Write value 0x99d435f6
    li x3, 0x99d435f6
    csrw 0xd5d, x3

    #Unmapped address 0x957 testing: random write/read operations
    #Address 0x957 read value
    csrr x14, 0x957

    #Unmapped address 0x7a5 testing: random write/read operations
    #Address 0x7a5 read value
    csrr x14, 0x7a5

    #Unmapped address 0xef2 testing: random write/read operations
    #Address 0xef2 Write value 0x13ec2140
    li x3, 0x13ec2140
    csrw 0xef2, x3

    #Address 0xef2 read value
    csrr x14, 0xef2

    #Address 0xef2 Write value 0xa637ecf6
    li x3, 0xa637ecf6
    csrw 0xef2, x3

    #Address 0xef2 Write value 0x8274bf65
    li x3, 0x8274bf65
    csrw 0xef2, x3

    #Unmapped address 0x36e testing: random write/read operations
    #Address 0x36e read value
    csrr x14, 0x36e

    #Mapped address 0xb1b (mhpmcounter27) testing: random write/read operations
    #Address 0xb1b Write value 0xba825994
    li x3, 0xba825994
    csrw 0xb1b, x3

    #Unmapped address 0x6e2 testing: random write/read operations
    #Address 0x6e2 read value
    csrr x14, 0x6e2

    #Address 0x6e2 read value
    csrr x14, 0x6e2

    #Unmapped address 0x399 testing: random write/read operations
    #Address 0x399 read value
    csrr x14, 0x399

    #Address 0x399 Write value 0xdad5d430
    li x3, 0xdad5d430
    csrw 0x399, x3

    #Address 0x399 read value
    csrr x14, 0x399

    #Unmapped address 0x359 testing: random write/read operations
    #Address 0x359 Write value 0x9b2bba85
    li x3, 0x9b2bba85
    csrw 0x359, x3

    #Address 0x359 read value
    csrr x14, 0x359

    #Address 0x359 Write value 0xbc6b3c4c
    li x3, 0xbc6b3c4c
    csrw 0x359, x3

    #Address 0x359 read value
    csrr x14, 0x359

    #Address 0x359 Write value 0x319f54f9
    li x3, 0x319f54f9
    csrw 0x359, x3

    #Unmapped address 0xf1a testing: random write/read operations
    #Address 0xf1a read value
    csrr x14, 0xf1a

    #Address 0xf1a Write value 0xa5245f3e
    li x3, 0xa5245f3e
    csrw 0xf1a, x3

    #Address 0xf1a Write value 0x339b36fc
    li x3, 0x339b36fc
    csrw 0xf1a, x3

    #Unmapped address 0x45 testing: random write/read operations
    #Address 0x45 read value
    csrr x14, 0x45

    #Address 0x45 Write value 0xc6768afe
    li x3, 0xc6768afe
    csrw 0x45, x3

    #Address 0x45 Write value 0xe71179a0
    li x3, 0xe71179a0
    csrw 0x45, x3

    #Address 0x45 read value
    csrr x14, 0x45

    #Unmapped address 0x4c8 testing: random write/read operations
    #Address 0x4c8 Write value 0x1399e40b
    li x3, 0x1399e40b
    csrw 0x4c8, x3

    #Address 0x4c8 Write value 0xfb8ca104
    li x3, 0xfb8ca104
    csrw 0x4c8, x3

    #Address 0x4c8 read value
    csrr x14, 0x4c8

    #Address 0x4c8 read value
    csrr x14, 0x4c8

    #Address 0x4c8 Write value 0x892f4b88
    li x3, 0x892f4b88
    csrw 0x4c8, x3

    #Unmapped address 0xbe5 testing: random write/read operations
    #Address 0xbe5 Write value 0xef0b9999
    li x3, 0xef0b9999
    csrw 0xbe5, x3

    #Address 0xbe5 Write value 0x8c8ab638
    li x3, 0x8c8ab638
    csrw 0xbe5, x3

    #Address 0xbe5 read value
    csrr x14, 0xbe5

    #Unmapped address 0xb4e testing: random write/read operations
    #Address 0xb4e read value
    csrr x14, 0xb4e

    #Unmapped address 0xa8b testing: random write/read operations
    #Address 0xa8b read value
    csrr x14, 0xa8b

    #Unmapped address 0x192 testing: random write/read operations
    #Address 0x192 Write value 0xe67fb988
    li x3, 0xe67fb988
    csrw 0x192, x3

    #Address 0x192 read value
    csrr x14, 0x192

    #Address 0x192 read value
    csrr x14, 0x192

    #Address 0x192 read value
    csrr x14, 0x192

    #Address 0x192 read value
    csrr x14, 0x192

    #Unmapped address 0xebc testing: random write/read operations
    #Address 0xebc Write value 0x35b6a351
    li x3, 0x35b6a351
    csrw 0xebc, x3

    #Address 0xebc Write value 0x30aa4afe
    li x3, 0x30aa4afe
    csrw 0xebc, x3

    #Address 0xebc read value
    csrr x14, 0xebc

    #Address 0xebc Write value 0x3590d31c
    li x3, 0x3590d31c
    csrw 0xebc, x3

    #Unmapped address 0x536 testing: random write/read operations
    #Address 0x536 Write value 0xa1365b56
    li x3, 0xa1365b56
    csrw 0x536, x3

    #Address 0x536 read value
    csrr x14, 0x536

    #Address 0x536 Write value 0x4bb19527
    li x3, 0x4bb19527
    csrw 0x536, x3

    #Unmapped address 0xb6 testing: random write/read operations
    #Address 0xb6 Write value 0x1f0d2fe3
    li x3, 0x1f0d2fe3
    csrw 0xb6, x3

    #Address 0xb6 read value
    csrr x14, 0xb6

    #Unmapped address 0x6c7 testing: random write/read operations
    #Address 0x6c7 read value
    csrr x14, 0x6c7

    #Address 0x6c7 Write value 0x9163755c
    li x3, 0x9163755c
    csrw 0x6c7, x3

    #Address 0x6c7 Write value 0xeb868b1d
    li x3, 0xeb868b1d
    csrw 0x6c7, x3

    #Unmapped address 0x974 testing: random write/read operations
    #Address 0x974 Write value 0xc7a2300f
    li x3, 0xc7a2300f
    csrw 0x974, x3

    #Address 0x974 read value
    csrr x14, 0x974

    #Unmapped address 0x500 testing: random write/read operations
    #Address 0x500 Write value 0x2acf852a
    li x3, 0x2acf852a
    csrw 0x500, x3

    #Unmapped address 0x3e5 testing: random write/read operations
    #Address 0x3e5 read value
    csrr x14, 0x3e5

    #Address 0x3e5 read value
    csrr x14, 0x3e5

    #Address 0x3e5 read value
    csrr x14, 0x3e5

    #Address 0x3e5 read value
    csrr x14, 0x3e5

    #Address 0x3e5 read value
    csrr x14, 0x3e5

    #Unmapped address 0x34f testing: random write/read operations
    #Address 0x34f read value
    csrr x14, 0x34f

    #Address 0x34f read value
    csrr x14, 0x34f

    #Unmapped address 0x8a3 testing: random write/read operations
    #Address 0x8a3 Write value 0x78793793
    li x3, 0x78793793
    csrw 0x8a3, x3

    #Address 0x8a3 Write value 0x2e09157c
    li x3, 0x2e09157c
    csrw 0x8a3, x3

    #Unmapped address 0x92 testing: random write/read operations
    #Address 0x92 Write value 0xc3ff9f2b
    li x3, 0xc3ff9f2b
    csrw 0x92, x3

    #Unmapped address 0x90c testing: random write/read operations
    #Address 0x90c Write value 0xf1207bac
    li x3, 0xf1207bac
    csrw 0x90c, x3

    #Address 0x90c Write value 0x2c15db8
    li x3, 0x2c15db8
    csrw 0x90c, x3

    #Address 0x90c read value
    csrr x14, 0x90c

    #Unmapped address 0x84c testing: random write/read operations
    #Address 0x84c read value
    csrr x14, 0x84c

    #Unmapped address 0x447 testing: random write/read operations
    #Address 0x447 read value
    csrr x14, 0x447

    #Unmapped address 0x5 testing: random write/read operations
    #Address 0x5 Write value 0x660143ac
    li x3, 0x660143ac
    csrw 0x5, x3

    #Address 0x5 Write value 0x652a424c
    li x3, 0x652a424c
    csrw 0x5, x3

    #Unmapped address 0xfc7 testing: random write/read operations
    #Address 0xfc7 Write value 0x5089c36
    li x3, 0x5089c36
    csrw 0xfc7, x3

    #Address 0xfc7 read value
    csrr x14, 0xfc7

    #Unmapped address 0xfb9 testing: random write/read operations
    #Address 0xfb9 Write value 0xe0fe9f8e
    li x3, 0xe0fe9f8e
    csrw 0xfb9, x3

    #Unmapped address 0x9c7 testing: random write/read operations
    #Address 0x9c7 read value
    csrr x14, 0x9c7

    #Address 0x9c7 Write value 0x8160d4f2
    li x3, 0x8160d4f2
    csrw 0x9c7, x3

    #Address 0x9c7 Write value 0xbe9dadae
    li x3, 0xbe9dadae
    csrw 0x9c7, x3

    #Address 0x9c7 read value
    csrr x14, 0x9c7

    #Address 0x9c7 Write value 0x6b7ba474
    li x3, 0x6b7ba474
    csrw 0x9c7, x3

    #Unmapped address 0x71b testing: random write/read operations
    #Address 0x71b Write value 0xfd857552
    li x3, 0xfd857552
    csrw 0x71b, x3

    #Address 0x71b read value
    csrr x14, 0x71b

    #Unmapped address 0x46b testing: random write/read operations
    #Address 0x46b read value
    csrr x14, 0x46b

    #Unmapped address 0x519 testing: random write/read operations
    #Address 0x519 read value
    csrr x14, 0x519

    #Address 0x519 read value
    csrr x14, 0x519

    #Address 0x519 Write value 0xb0729b69
    li x3, 0xb0729b69
    csrw 0x519, x3

    #Unmapped address 0x831 testing: random write/read operations
    #Address 0x831 Write value 0x76c7598a
    li x3, 0x76c7598a
    csrw 0x831, x3

    #Address 0x831 Write value 0x7e6ff358
    li x3, 0x7e6ff358
    csrw 0x831, x3

    #Address 0x831 Write value 0xff0c76f2
    li x3, 0xff0c76f2
    csrw 0x831, x3

    #Address 0x831 Write value 0x561b868e
    li x3, 0x561b868e
    csrw 0x831, x3

    #Unmapped address 0xa34 testing: random write/read operations
    #Address 0xa34 read value
    csrr x14, 0xa34

    #Address 0xa34 read value
    csrr x14, 0xa34

    #Unmapped address 0x939 testing: random write/read operations
    #Address 0x939 read value
    csrr x14, 0x939

    #Address 0x939 read value
    csrr x14, 0x939

    #Address 0x939 read value
    csrr x14, 0x939

    #Address 0x939 read value
    csrr x14, 0x939

    #Address 0x939 read value
    csrr x14, 0x939

    #Unmapped address 0x9e2 testing: random write/read operations
    #Address 0x9e2 read value
    csrr x14, 0x9e2

    #Address 0x9e2 read value
    csrr x14, 0x9e2

    #Unmapped address 0x487 testing: random write/read operations
    #Address 0x487 Write value 0x9f08ca7d
    li x3, 0x9f08ca7d
    csrw 0x487, x3

    #Address 0x487 read value
    csrr x14, 0x487

    #Address 0x487 Write value 0x79927917
    li x3, 0x79927917
    csrw 0x487, x3

    #Address 0x487 read value
    csrr x14, 0x487

    #Unmapped address 0x26c testing: random write/read operations
    #Address 0x26c Write value 0x7f922156
    li x3, 0x7f922156
    csrw 0x26c, x3

    #Address 0x26c Write value 0x6d139056
    li x3, 0x6d139056
    csrw 0x26c, x3

    #Unmapped address 0x40c testing: random write/read operations
    #Address 0x40c read value
    csrr x14, 0x40c

    #Address 0x40c Write value 0x61b6ef35
    li x3, 0x61b6ef35
    csrw 0x40c, x3

    #Unmapped address 0xd45 testing: random write/read operations
    #Address 0xd45 read value
    csrr x14, 0xd45

    #Unmapped address 0xf84 testing: random write/read operations
    #Address 0xf84 Write value 0xbd6d1e07
    li x3, 0xbd6d1e07
    csrw 0xf84, x3

    #Address 0xf84 Write value 0xeaa34f08
    li x3, 0xeaa34f08
    csrw 0xf84, x3

    #Address 0xf84 Write value 0xe1c45038
    li x3, 0xe1c45038
    csrw 0xf84, x3

    #Address 0xf84 read value
    csrr x14, 0xf84

    #Address 0xf84 read value
    csrr x14, 0xf84

    #Unmapped address 0x4e5 testing: random write/read operations
    #Address 0x4e5 Write value 0x39cd7ebb
    li x3, 0x39cd7ebb
    csrw 0x4e5, x3

    #Address 0x4e5 Write value 0x70192976
    li x3, 0x70192976
    csrw 0x4e5, x3

    #Address 0x4e5 Write value 0x9cc57c95
    li x3, 0x9cc57c95
    csrw 0x4e5, x3

    #Address 0x4e5 read value
    csrr x14, 0x4e5

    #Unmapped address 0xf42 testing: random write/read operations
    #Address 0xf42 Write value 0x7b340afa
    li x3, 0x7b340afa
    csrw 0xf42, x3

    #Address 0xf42 Write value 0x2aa99752
    li x3, 0x2aa99752
    csrw 0xf42, x3

    #Unmapped address 0xd04 testing: random write/read operations
    #Address 0xd04 read value
    csrr x14, 0xd04

    #Address 0xd04 Write value 0x4e4cd6df
    li x3, 0x4e4cd6df
    csrw 0xd04, x3

    #Address 0xd04 Write value 0x262f2c3d
    li x3, 0x262f2c3d
    csrw 0xd04, x3

    #Unmapped address 0xa30 testing: random write/read operations
    #Address 0xa30 read value
    csrr x14, 0xa30

    #Address 0xa30 read value
    csrr x14, 0xa30

    #Unmapped address 0x9ec testing: random write/read operations
    #Address 0x9ec read value
    csrr x14, 0x9ec

    #Unmapped address 0xf69 testing: random write/read operations
    #Address 0xf69 read value
    csrr x14, 0xf69

    #Address 0xf69 Write value 0x9c099a48
    li x3, 0x9c099a48
    csrw 0xf69, x3

    #Address 0xf69 read value
    csrr x14, 0xf69

    #Address 0xf69 Write value 0xfccb7232
    li x3, 0xfccb7232
    csrw 0xf69, x3

    #Unmapped address 0x67b testing: random write/read operations
    #Address 0x67b Write value 0xc165aaf3
    li x3, 0xc165aaf3
    csrw 0x67b, x3

    #Address 0x67b Write value 0x7776c46a
    li x3, 0x7776c46a
    csrw 0x67b, x3

    #Unmapped address 0x414 testing: random write/read operations
    #Address 0x414 Write value 0xb735abb4
    li x3, 0xb735abb4
    csrw 0x414, x3

    #Address 0x414 read value
    csrr x14, 0x414

    #Unmapped address 0xcaf testing: random write/read operations
    #Address 0xcaf Write value 0xddd7805f
    li x3, 0xddd7805f
    csrw 0xcaf, x3

    #Address 0xcaf read value
    csrr x14, 0xcaf

    #Address 0xcaf Write value 0x440df8e1
    li x3, 0x440df8e1
    csrw 0xcaf, x3

    #Unmapped address 0x637 testing: random write/read operations
    #Address 0x637 Write value 0x9477aa3
    li x3, 0x9477aa3
    csrw 0x637, x3

    #Address 0x637 Write value 0xf6bc05eb
    li x3, 0xf6bc05eb
    csrw 0x637, x3

    #Address 0x637 Write value 0xcc504
    li x3, 0xcc504
    csrw 0x637, x3

    #Address 0x637 read value
    csrr x14, 0x637

    #Unmapped address 0x18b testing: random write/read operations
    #Address 0x18b read value
    csrr x14, 0x18b

    #Address 0x18b Write value 0x3c57ae03
    li x3, 0x3c57ae03
    csrw 0x18b, x3

    #Unmapped address 0xddd testing: random write/read operations
    #Address 0xddd read value
    csrr x14, 0xddd

    #Address 0xddd Write value 0x9ed46ab1
    li x3, 0x9ed46ab1
    csrw 0xddd, x3

    #Unmapped address 0xac5 testing: random write/read operations
    #Address 0xac5 read value
    csrr x14, 0xac5

    #Unmapped address 0x218 testing: random write/read operations
    #Address 0x218 Write value 0x63297ccf
    li x3, 0x63297ccf
    csrw 0x218, x3

    #Unmapped address 0x4a8 testing: random write/read operations
    #Address 0x4a8 read value
    csrr x14, 0x4a8

    #Address 0x4a8 read value
    csrr x14, 0x4a8

    #Address 0x4a8 Write value 0xb376b20e
    li x3, 0xb376b20e
    csrw 0x4a8, x3

    #Address 0x4a8 Write value 0x55ded69c
    li x3, 0x55ded69c
    csrw 0x4a8, x3

    #Address 0x4a8 read value
    csrr x14, 0x4a8

    #Mapped address 0xb88 (mhpmcounterh8) testing: random write/read operations
    #Address 0xb88 Write value 0x836b23d
    li x3, 0x836b23d
    csrw 0xb88, x3

    #Unmapped address 0xd56 testing: random write/read operations
    #Address 0xd56 read value
    csrr x14, 0xd56

    #Address 0xd56 read value
    csrr x14, 0xd56

    #Address 0xd56 read value
    csrr x14, 0xd56

    #Address 0xd56 Write value 0x7e43114
    li x3, 0x7e43114
    csrw 0xd56, x3

    #Unmapped address 0xa17 testing: random write/read operations
    #Address 0xa17 read value
    csrr x14, 0xa17

    #Address 0xa17 Write value 0xa4176763
    li x3, 0xa4176763
    csrw 0xa17, x3

    #Unmapped address 0x708 testing: random write/read operations
    #Address 0x708 Write value 0x9a785808
    li x3, 0x9a785808
    csrw 0x708, x3

    #Address 0x708 Write value 0xfb5e3512
    li x3, 0xfb5e3512
    csrw 0x708, x3

    #Address 0x708 Write value 0x4c01a89
    li x3, 0x4c01a89
    csrw 0x708, x3

    #Address 0x708 read value
    csrr x14, 0x708

    #Unmapped address 0x97a testing: random write/read operations
    #Address 0x97a Write value 0x5a60f3c1
    li x3, 0x5a60f3c1
    csrw 0x97a, x3

    #Address 0x97a Write value 0x618d278d
    li x3, 0x618d278d
    csrw 0x97a, x3

    #Address 0x97a read value
    csrr x14, 0x97a

    #Address 0x97a Write value 0x23772081
    li x3, 0x23772081
    csrw 0x97a, x3

    #Unmapped address 0xf75 testing: random write/read operations
    #Address 0xf75 read value
    csrr x14, 0xf75

    #Address 0xf75 Write value 0xa8314db0
    li x3, 0xa8314db0
    csrw 0xf75, x3

    #Address 0xf75 read value
    csrr x14, 0xf75

    #Address 0xf75 Write value 0x8781a18b
    li x3, 0x8781a18b
    csrw 0xf75, x3

    #Address 0xf75 Write value 0x9782efb
    li x3, 0x9782efb
    csrw 0xf75, x3

    #Unmapped address 0xabe testing: random write/read operations
    #Address 0xabe read value
    csrr x14, 0xabe

    #Address 0xabe read value
    csrr x14, 0xabe

    #Unmapped address 0xd65 testing: random write/read operations
    #Address 0xd65 Write value 0x2a9cb6b8
    li x3, 0x2a9cb6b8
    csrw 0xd65, x3

    #Address 0xd65 read value
    csrr x14, 0xd65

    #Address 0xd65 read value
    csrr x14, 0xd65

    #Unmapped address 0xfdc testing: random write/read operations
    #Address 0xfdc read value
    csrr x14, 0xfdc

    #Address 0xfdc read value
    csrr x14, 0xfdc

    #Address 0xfdc read value
    csrr x14, 0xfdc

    #Address 0xfdc read value
    csrr x14, 0xfdc

    #Unmapped address 0xd21 testing: random write/read operations
    #Address 0xd21 Write value 0x52d6e587
    li x3, 0x52d6e587
    csrw 0xd21, x3

    #Address 0xd21 read value
    csrr x14, 0xd21

    #Address 0xd21 read value
    csrr x14, 0xd21

    #Address 0xd21 Write value 0x6c1219ab
    li x3, 0x6c1219ab
    csrw 0xd21, x3

    #Address 0xd21 Write value 0x3e9267fd
    li x3, 0x3e9267fd
    csrw 0xd21, x3

    #Unmapped address 0x49e testing: random write/read operations
    #Address 0x49e Write value 0xa1ba6eb7
    li x3, 0xa1ba6eb7
    csrw 0x49e, x3

    #Unmapped address 0x7a8 testing: random write/read operations
    #Address 0x7a8 Write value 0xffd40fdb
    li x3, 0xffd40fdb
    csrw 0x7a8, x3

    #Address 0x7a8 read value
    csrr x14, 0x7a8

    #Unmapped address 0xf82 testing: random write/read operations
    #Address 0xf82 read value
    csrr x14, 0xf82

    #Address 0xf82 Write value 0x1becf0d1
    li x3, 0x1becf0d1
    csrw 0xf82, x3

    #Address 0xf82 Write value 0x9483863f
    li x3, 0x9483863f
    csrw 0xf82, x3

    #Address 0xf82 Write value 0x8186c181
    li x3, 0x8186c181
    csrw 0xf82, x3

    #Address 0xf82 read value
    csrr x14, 0xf82

    #Unmapped address 0x7e4 testing: random write/read operations
    #Address 0x7e4 read value
    csrr x14, 0x7e4

    #Address 0x7e4 read value
    csrr x14, 0x7e4

    #Address 0x7e4 Write value 0xc70f9948
    li x3, 0xc70f9948
    csrw 0x7e4, x3

    #Address 0x7e4 read value
    csrr x14, 0x7e4

    #Address 0x7e4 read value
    csrr x14, 0x7e4

    #Unmapped address 0x158 testing: random write/read operations
    #Address 0x158 Write value 0xe44af2fd
    li x3, 0xe44af2fd
    csrw 0x158, x3

    #Address 0x158 read value
    csrr x14, 0x158

    #Address 0x158 read value
    csrr x14, 0x158

    #Address 0x158 Write value 0xc7b395dd
    li x3, 0xc7b395dd
    csrw 0x158, x3

    #Address 0x158 read value
    csrr x14, 0x158

    #Unmapped address 0x66b testing: random write/read operations
    #Address 0x66b Write value 0xba40d1c8
    li x3, 0xba40d1c8
    csrw 0x66b, x3

    #Address 0x66b Write value 0x5525cb6
    li x3, 0x5525cb6
    csrw 0x66b, x3

    #Address 0x66b read value
    csrr x14, 0x66b

    #Address 0x66b Write value 0xfb54846b
    li x3, 0xfb54846b
    csrw 0x66b, x3

    #Address 0x66b read value
    csrr x14, 0x66b

    #Unmapped address 0x6df testing: random write/read operations
    #Address 0x6df read value
    csrr x14, 0x6df

    #Address 0x6df Write value 0xd0ae3a19
    li x3, 0xd0ae3a19
    csrw 0x6df, x3

    #Address 0x6df read value
    csrr x14, 0x6df

    #Address 0x6df read value
    csrr x14, 0x6df

    #Unmapped address 0xd5e testing: random write/read operations
    #Address 0xd5e read value
    csrr x14, 0xd5e

    #Address 0xd5e Write value 0xe9920b39
    li x3, 0xe9920b39
    csrw 0xd5e, x3

    #Address 0xd5e read value
    csrr x14, 0xd5e

    #Address 0xd5e read value
    csrr x14, 0xd5e

    #Address 0xd5e Write value 0x1b7ef900
    li x3, 0x1b7ef900
    csrw 0xd5e, x3

    #Unmapped address 0x658 testing: random write/read operations
    #Address 0x658 read value
    csrr x14, 0x658

    #Address 0x658 read value
    csrr x14, 0x658

    #Address 0x658 Write value 0x85580c86
    li x3, 0x85580c86
    csrw 0x658, x3

    #Address 0x658 read value
    csrr x14, 0x658

    #Address 0x658 read value
    csrr x14, 0x658

    #Unmapped address 0x2c0 testing: random write/read operations
    #Address 0x2c0 read value
    csrr x14, 0x2c0

    #Address 0x2c0 read value
    csrr x14, 0x2c0

    #Address 0x2c0 Write value 0xc4cb2a4e
    li x3, 0xc4cb2a4e
    csrw 0x2c0, x3

    #Address 0x2c0 read value
    csrr x14, 0x2c0

    #Unmapped address 0x962 testing: random write/read operations
    #Address 0x962 read value
    csrr x14, 0x962

    #Address 0x962 Write value 0x701409ae
    li x3, 0x701409ae
    csrw 0x962, x3

    #Address 0x962 read value
    csrr x14, 0x962

    #Unmapped address 0x653 testing: random write/read operations
    #Address 0x653 read value
    csrr x14, 0x653

    #Address 0x653 read value
    csrr x14, 0x653

    #Address 0x653 Write value 0x4229092d
    li x3, 0x4229092d
    csrw 0x653, x3

    #Unmapped address 0xdc4 testing: random write/read operations
    #Address 0xdc4 read value
    csrr x14, 0xdc4

    #Address 0xdc4 read value
    csrr x14, 0xdc4

    #Address 0xdc4 read value
    csrr x14, 0xdc4

    #Address 0xdc4 Write value 0xc834f99a
    li x3, 0xc834f99a
    csrw 0xdc4, x3

    #Address 0xdc4 Write value 0x54398609
    li x3, 0x54398609
    csrw 0xdc4, x3

    #Unmapped address 0xfad testing: random write/read operations
    #Address 0xfad Write value 0x2840bab9
    li x3, 0x2840bab9
    csrw 0xfad, x3

    #Address 0xfad read value
    csrr x14, 0xfad

    #Address 0xfad Write value 0x39180c51
    li x3, 0x39180c51
    csrw 0xfad, x3

    #Address 0xfad read value
    csrr x14, 0xfad

    #Unmapped address 0xe54 testing: random write/read operations
    #Address 0xe54 Write value 0x26929c1f
    li x3, 0x26929c1f
    csrw 0xe54, x3

    #Address 0xe54 read value
    csrr x14, 0xe54

    #Address 0xe54 read value
    csrr x14, 0xe54

    #Address 0xe54 read value
    csrr x14, 0xe54

    #Address 0xe54 read value
    csrr x14, 0xe54

    #Unmapped address 0x8de testing: random write/read operations
    #Address 0x8de read value
    csrr x14, 0x8de

    #Address 0x8de Write value 0xe1552676
    li x3, 0xe1552676
    csrw 0x8de, x3

    #Address 0x8de read value
    csrr x14, 0x8de

    #Unmapped address 0x12d testing: random write/read operations
    #Address 0x12d Write value 0x1de8141e
    li x3, 0x1de8141e
    csrw 0x12d, x3

    #Address 0x12d read value
    csrr x14, 0x12d

    #Unmapped address 0x256 testing: random write/read operations
    #Address 0x256 read value
    csrr x14, 0x256

    #Address 0x256 read value
    csrr x14, 0x256

    #Unmapped address 0x3de testing: random write/read operations
    #Address 0x3de read value
    csrr x14, 0x3de

    #Address 0x3de Write value 0xa9dc6d9a
    li x3, 0xa9dc6d9a
    csrw 0x3de, x3

    #Unmapped address 0xaf6 testing: random write/read operations
    #Address 0xaf6 read value
    csrr x14, 0xaf6

    #Address 0xaf6 Write value 0x6396da41
    li x3, 0x6396da41
    csrw 0xaf6, x3

    #Unmapped address 0x752 testing: random write/read operations
    #Address 0x752 Write value 0xd872ffa8
    li x3, 0xd872ffa8
    csrw 0x752, x3

    #Address 0x752 read value
    csrr x14, 0x752

    #Address 0x752 read value
    csrr x14, 0x752

    #Address 0x752 Write value 0x3f679e41
    li x3, 0x3f679e41
    csrw 0x752, x3

    #Address 0x752 Write value 0xcfd10e82
    li x3, 0xcfd10e82
    csrw 0x752, x3

    #Unmapped address 0x835 testing: random write/read operations
    #Address 0x835 Write value 0x908c400b
    li x3, 0x908c400b
    csrw 0x835, x3

    #Address 0x835 read value
    csrr x14, 0x835

    #Address 0x835 Write value 0x11c8ed06
    li x3, 0x11c8ed06
    csrw 0x835, x3

    #Unmapped address 0xed4 testing: random write/read operations
    #Address 0xed4 read value
    csrr x14, 0xed4

    #Unmapped address 0xa5e testing: random write/read operations
    #Address 0xa5e Write value 0x86d09738
    li x3, 0x86d09738
    csrw 0xa5e, x3

    #Address 0xa5e Write value 0x35db6d10
    li x3, 0x35db6d10
    csrw 0xa5e, x3

    #Unmapped address 0xe86 testing: random write/read operations
    #Address 0xe86 read value
    csrr x14, 0xe86

    #Address 0xe86 Write value 0x76e564a
    li x3, 0x76e564a
    csrw 0xe86, x3

    #Address 0xe86 read value
    csrr x14, 0xe86

    #Unmapped address 0x29d testing: random write/read operations
    #Address 0x29d read value
    csrr x14, 0x29d

    #Address 0x29d Write value 0xa266646e
    li x3, 0xa266646e
    csrw 0x29d, x3

    #Address 0x29d read value
    csrr x14, 0x29d

    #Address 0x29d Write value 0xd241f4d6
    li x3, 0xd241f4d6
    csrw 0x29d, x3

    #Mapped address 0x33e (mhpmevent30) testing: random write/read operations
    #Address 0x33e read value
    csrr x14, 0x33e

    #Address 0x33e read value
    csrr x14, 0x33e

    #Address 0x33e Write value 0xcd14e9b7
    li x3, 0xcd14e9b7
    csrw 0x33e, x3

    #Address 0x33e Write value 0x6f32a033
    li x3, 0x6f32a033
    csrw 0x33e, x3

    #Unmapped address 0x1b7 testing: random write/read operations
    #Address 0x1b7 Write value 0x977c4bf3
    li x3, 0x977c4bf3
    csrw 0x1b7, x3

    #Address 0x1b7 read value
    csrr x14, 0x1b7

    #Unmapped address 0x6ff testing: random write/read operations
    #Address 0x6ff read value
    csrr x14, 0x6ff

    #Unmapped address 0x183 testing: random write/read operations
    #Address 0x183 read value
    csrr x14, 0x183

    #Unmapped address 0x113 testing: random write/read operations
    #Address 0x113 Write value 0x67f381e6
    li x3, 0x67f381e6
    csrw 0x113, x3

    #Address 0x113 Write value 0x1e22f8d7
    li x3, 0x1e22f8d7
    csrw 0x113, x3

    #Address 0x113 read value
    csrr x14, 0x113

    #Unmapped address 0x943 testing: random write/read operations
    #Address 0x943 read value
    csrr x14, 0x943

    #Unmapped address 0x380 testing: random write/read operations
    #Address 0x380 read value
    csrr x14, 0x380

    #Address 0x380 read value
    csrr x14, 0x380

    #Address 0x380 Write value 0xbc700cbd
    li x3, 0xbc700cbd
    csrw 0x380, x3

    #Address 0x380 read value
    csrr x14, 0x380

    #Unmapped address 0x277 testing: random write/read operations
    #Address 0x277 Write value 0x2193b339
    li x3, 0x2193b339
    csrw 0x277, x3

    #Address 0x277 Write value 0x2e8cb587
    li x3, 0x2e8cb587
    csrw 0x277, x3

    #Address 0x277 Write value 0xe3aecba2
    li x3, 0xe3aecba2
    csrw 0x277, x3

    #Address 0x277 read value
    csrr x14, 0x277

    #Unmapped address 0x1cf testing: random write/read operations
    #Address 0x1cf read value
    csrr x14, 0x1cf

    #Unmapped address 0x93b testing: random write/read operations
    #Address 0x93b Write value 0x91bba31c
    li x3, 0x91bba31c
    csrw 0x93b, x3

    #Address 0x93b Write value 0x8cd30539
    li x3, 0x8cd30539
    csrw 0x93b, x3

    #Address 0x93b read value
    csrr x14, 0x93b

    #Address 0x93b read value
    csrr x14, 0x93b

    #Address 0x93b read value
    csrr x14, 0x93b

    #Unmapped address 0x8b4 testing: random write/read operations
    #Address 0x8b4 read value
    csrr x14, 0x8b4

    #Address 0x8b4 read value
    csrr x14, 0x8b4

    #Address 0x8b4 read value
    csrr x14, 0x8b4

    #Unmapped address 0xdb2 testing: random write/read operations
    #Address 0xdb2 Write value 0x756d1e7c
    li x3, 0x756d1e7c
    csrw 0xdb2, x3

    #Address 0xdb2 Write value 0x394871c8
    li x3, 0x394871c8
    csrw 0xdb2, x3

    #Address 0xdb2 Write value 0x67d83896
    li x3, 0x67d83896
    csrw 0xdb2, x3

    #Address 0xdb2 read value
    csrr x14, 0xdb2

    #Address 0xdb2 Write value 0xbde342b2
    li x3, 0xbde342b2
    csrw 0xdb2, x3

    #Unmapped address 0x856 testing: random write/read operations
    #Address 0x856 read value
    csrr x14, 0x856

    #Unmapped address 0x458 testing: random write/read operations
    #Address 0x458 Write value 0x3cf1306a
    li x3, 0x3cf1306a
    csrw 0x458, x3

    #Address 0x458 Write value 0xdc0ef1a1
    li x3, 0xdc0ef1a1
    csrw 0x458, x3

    #Address 0x458 Write value 0xe6d46872
    li x3, 0xe6d46872
    csrw 0x458, x3

    #Address 0x458 Write value 0x48079ade
    li x3, 0x48079ade
    csrw 0x458, x3

    #Address 0x458 read value
    csrr x14, 0x458

    #Unmapped address 0xe63 testing: random write/read operations
    #Address 0xe63 Write value 0x3fb85827
    li x3, 0x3fb85827
    csrw 0xe63, x3

    #Address 0xe63 Write value 0xb778a2ed
    li x3, 0xb778a2ed
    csrw 0xe63, x3

    #Address 0xe63 read value
    csrr x14, 0xe63

    #Address 0xe63 read value
    csrr x14, 0xe63

    #Unmapped address 0x676 testing: random write/read operations
    #Address 0x676 Write value 0xee92a3df
    li x3, 0xee92a3df
    csrw 0x676, x3

    #Address 0x676 read value
    csrr x14, 0x676

    #Address 0x676 Write value 0xee6a0152
    li x3, 0xee6a0152
    csrw 0x676, x3

    #Unmapped address 0x559 testing: random write/read operations
    #Address 0x559 Write value 0xfe563dad
    li x3, 0xfe563dad
    csrw 0x559, x3

    #Address 0x559 read value
    csrr x14, 0x559

    #Address 0x559 Write value 0x5c547890
    li x3, 0x5c547890
    csrw 0x559, x3

    #Unmapped address 0x7a3 testing: random write/read operations
    #Address 0x7a3 Write value 0xf1c28107
    li x3, 0xf1c28107
    csrw 0x7a3, x3

    #Address 0x7a3 Write value 0xb4699635
    li x3, 0xb4699635
    csrw 0x7a3, x3

    #Unmapped address 0xe20 testing: random write/read operations
    #Address 0xe20 read value
    csrr x14, 0xe20

    #Address 0xe20 read value
    csrr x14, 0xe20

    #Unmapped address 0xc27 testing: random write/read operations
    #Address 0xc27 Write value 0x90657abb
    li x3, 0x90657abb
    csrw 0xc27, x3

    #Address 0xc27 Write value 0x2f8f75ed
    li x3, 0x2f8f75ed
    csrw 0xc27, x3

    #Address 0xc27 Write value 0x25007239
    li x3, 0x25007239
    csrw 0xc27, x3

    #Unmapped address 0x18a testing: random write/read operations
    #Address 0x18a Write value 0x75b73a1e
    li x3, 0x75b73a1e
    csrw 0x18a, x3

    #Unmapped address 0x787 testing: random write/read operations
    #Address 0x787 Write value 0xe2dfd2e5
    li x3, 0xe2dfd2e5
    csrw 0x787, x3

    #Address 0x787 read value
    csrr x14, 0x787

    #Address 0x787 Write value 0xf4f5d1f0
    li x3, 0xf4f5d1f0
    csrw 0x787, x3

    #Address 0x787 read value
    csrr x14, 0x787

    #Unmapped address 0x3ee testing: random write/read operations
    #Address 0x3ee read value
    csrr x14, 0x3ee

    #Address 0x3ee read value
    csrr x14, 0x3ee

    #Address 0x3ee Write value 0x1bce0882
    li x3, 0x1bce0882
    csrw 0x3ee, x3

    #Address 0x3ee read value
    csrr x14, 0x3ee

    #Unmapped address 0xb58 testing: random write/read operations
    #Address 0xb58 Write value 0x7a84e216
    li x3, 0x7a84e216
    csrw 0xb58, x3

    #Address 0xb58 Write value 0x1ee0b0af
    li x3, 0x1ee0b0af
    csrw 0xb58, x3

    #Address 0xb58 Write value 0x743b9ee5
    li x3, 0x743b9ee5
    csrw 0xb58, x3

    #Address 0xb58 Write value 0x32ab1f98
    li x3, 0x32ab1f98
    csrw 0xb58, x3

    #Address 0xb58 read value
    csrr x14, 0xb58

    #Unmapped address 0xf92 testing: random write/read operations
    #Address 0xf92 Write value 0x76244c63
    li x3, 0x76244c63
    csrw 0xf92, x3

    #Address 0xf92 read value
    csrr x14, 0xf92

    #Address 0xf92 read value
    csrr x14, 0xf92

    #Address 0xf92 read value
    csrr x14, 0xf92

    #Unmapped address 0x743 testing: random write/read operations
    #Address 0x743 Write value 0x1305dc72
    li x3, 0x1305dc72
    csrw 0x743, x3

    #Address 0x743 read value
    csrr x14, 0x743

    #Address 0x743 Write value 0xa35589ce
    li x3, 0xa35589ce
    csrw 0x743, x3

    #Address 0x743 Write value 0x2f60190a
    li x3, 0x2f60190a
    csrw 0x743, x3

    #Unmapped address 0x453 testing: random write/read operations
    #Address 0x453 read value
    csrr x14, 0x453

    #Address 0x453 Write value 0xea27201e
    li x3, 0xea27201e
    csrw 0x453, x3

    #Address 0x453 Write value 0x8d7557af
    li x3, 0x8d7557af
    csrw 0x453, x3

    #Unmapped address 0x6f0 testing: random write/read operations
    #Address 0x6f0 read value
    csrr x14, 0x6f0

    #Address 0x6f0 read value
    csrr x14, 0x6f0

    #Address 0x6f0 read value
    csrr x14, 0x6f0

    #Unmapped address 0x985 testing: random write/read operations
    #Address 0x985 read value
    csrr x14, 0x985

    #Unmapped address 0x7e3 testing: random write/read operations
    #Address 0x7e3 Write value 0x137d16bb
    li x3, 0x137d16bb
    csrw 0x7e3, x3

    #Unmapped address 0xa4f testing: random write/read operations
    #Address 0xa4f Write value 0xe9461b89
    li x3, 0xe9461b89
    csrw 0xa4f, x3

    #Address 0xa4f Write value 0x81adec5a
    li x3, 0x81adec5a
    csrw 0xa4f, x3

    #Address 0xa4f Write value 0x8e2b9589
    li x3, 0x8e2b9589
    csrw 0xa4f, x3

    #Unmapped address 0x45e testing: random write/read operations
    #Address 0x45e read value
    csrr x14, 0x45e

    #Address 0x45e read value
    csrr x14, 0x45e

    #Address 0x45e Write value 0x18f77918
    li x3, 0x18f77918
    csrw 0x45e, x3

    #Address 0x45e read value
    csrr x14, 0x45e

    #Unmapped address 0xe40 testing: random write/read operations
    #Address 0xe40 Write value 0x2f6a44cb
    li x3, 0x2f6a44cb
    csrw 0xe40, x3

    #Address 0xe40 Write value 0x287cbef
    li x3, 0x287cbef
    csrw 0xe40, x3

    #Address 0xe40 read value
    csrr x14, 0xe40

    #Unmapped address 0xd78 testing: random write/read operations
    #Address 0xd78 Write value 0xc7a0678d
    li x3, 0xc7a0678d
    csrw 0xd78, x3

    #Address 0xd78 read value
    csrr x14, 0xd78

    #Address 0xd78 read value
    csrr x14, 0xd78

    #Unmapped address 0x644 testing: random write/read operations
    #Address 0x644 Write value 0xc44e54df
    li x3, 0xc44e54df
    csrw 0x644, x3

    #Address 0x644 Write value 0xc8a6eb1d
    li x3, 0xc8a6eb1d
    csrw 0x644, x3

    #Address 0x644 Write value 0xab427dc5
    li x3, 0xab427dc5
    csrw 0x644, x3

    #Address 0x644 read value
    csrr x14, 0x644

    #Address 0x644 Write value 0x31caf9d4
    li x3, 0x31caf9d4
    csrw 0x644, x3

    #Unmapped address 0x623 testing: random write/read operations
    #Address 0x623 read value
    csrr x14, 0x623

    #Address 0x623 read value
    csrr x14, 0x623

    #Address 0x623 read value
    csrr x14, 0x623

    #Address 0x623 read value
    csrr x14, 0x623

    #Unmapped address 0xcdf testing: random write/read operations
    #Address 0xcdf read value
    csrr x14, 0xcdf

    #Address 0xcdf Write value 0x3ea1f47
    li x3, 0x3ea1f47
    csrw 0xcdf, x3

    #Unmapped address 0x3d1 testing: random write/read operations
    #Address 0x3d1 Write value 0x519a053d
    li x3, 0x519a053d
    csrw 0x3d1, x3

    #Unmapped address 0xd7e testing: random write/read operations
    #Address 0xd7e Write value 0x6eb3b247
    li x3, 0x6eb3b247
    csrw 0xd7e, x3

    #Unmapped address 0x2fb testing: random write/read operations
    #Address 0x2fb Write value 0x3d92da23
    li x3, 0x3d92da23
    csrw 0x2fb, x3

    #Address 0x2fb Write value 0xbb1accc2
    li x3, 0xbb1accc2
    csrw 0x2fb, x3

    #Address 0x2fb Write value 0x3d47a3e2
    li x3, 0x3d47a3e2
    csrw 0x2fb, x3

    #Unmapped address 0xb56 testing: random write/read operations
    #Address 0xb56 Write value 0x8db5db90
    li x3, 0x8db5db90
    csrw 0xb56, x3

    #Unmapped address 0xb64 testing: random write/read operations
    #Address 0xb64 read value
    csrr x14, 0xb64

    #Address 0xb64 Write value 0xc98fab7d
    li x3, 0xc98fab7d
    csrw 0xb64, x3

    #Unmapped address 0x2f4 testing: random write/read operations
    #Address 0x2f4 read value
    csrr x14, 0x2f4

    #Address 0x2f4 read value
    csrr x14, 0x2f4

    #Address 0x2f4 Write value 0xf7c6121e
    li x3, 0xf7c6121e
    csrw 0x2f4, x3

    #Unmapped address 0xbb2 testing: random write/read operations
    #Address 0xbb2 Write value 0xadf947ff
    li x3, 0xadf947ff
    csrw 0xbb2, x3

    #Address 0xbb2 Write value 0x4213a467
    li x3, 0x4213a467
    csrw 0xbb2, x3

    #Address 0xbb2 Write value 0x44cac29e
    li x3, 0x44cac29e
    csrw 0xbb2, x3

    #Unmapped address 0x1f2 testing: random write/read operations
    #Address 0x1f2 read value
    csrr x14, 0x1f2

    #Address 0x1f2 read value
    csrr x14, 0x1f2

    #Address 0x1f2 Write value 0x990afd81
    li x3, 0x990afd81
    csrw 0x1f2, x3

    #Unmapped address 0x6cc testing: random write/read operations
    #Address 0x6cc read value
    csrr x14, 0x6cc

    #Address 0x6cc Write value 0xe15fec27
    li x3, 0xe15fec27
    csrw 0x6cc, x3

    #Unmapped address 0x4f9 testing: random write/read operations
    #Address 0x4f9 Write value 0xfa650f27
    li x3, 0xfa650f27
    csrw 0x4f9, x3

    #Address 0x4f9 read value
    csrr x14, 0x4f9

    #Address 0x4f9 Write value 0x39414a20
    li x3, 0x39414a20
    csrw 0x4f9, x3

    #Unmapped address 0x9f3 testing: random write/read operations
    #Address 0x9f3 read value
    csrr x14, 0x9f3

    #Address 0x9f3 read value
    csrr x14, 0x9f3

    #Address 0x9f3 read value
    csrr x14, 0x9f3

    #Unmapped address 0xa47 testing: random write/read operations
    #Address 0xa47 Write value 0x321c9487
    li x3, 0x321c9487
    csrw 0xa47, x3

    #Address 0xa47 read value
    csrr x14, 0xa47

    #Address 0xa47 read value
    csrr x14, 0xa47

    #Address 0xa47 read value
    csrr x14, 0xa47

    #Unmapped address 0xa54 testing: random write/read operations
    #Address 0xa54 read value
    csrr x14, 0xa54

    #Address 0xa54 Write value 0x63f40356
    li x3, 0x63f40356
    csrw 0xa54, x3

    #Address 0xa54 Write value 0xf188ee89
    li x3, 0xf188ee89
    csrw 0xa54, x3

    #Address 0xa54 read value
    csrr x14, 0xa54

    #Unmapped address 0x6d3 testing: random write/read operations
    #Address 0x6d3 Write value 0xfd33dfff
    li x3, 0xfd33dfff
    csrw 0x6d3, x3

    #Address 0x6d3 Write value 0x926ff811
    li x3, 0x926ff811
    csrw 0x6d3, x3

    #Address 0x6d3 read value
    csrr x14, 0x6d3

    #Address 0x6d3 Write value 0xc2d84735
    li x3, 0xc2d84735
    csrw 0x6d3, x3

    #Address 0x6d3 read value
    csrr x14, 0x6d3

    #Unmapped address 0x59d testing: random write/read operations
    #Address 0x59d read value
    csrr x14, 0x59d

    #Address 0x59d read value
    csrr x14, 0x59d

    #Address 0x59d read value
    csrr x14, 0x59d

    #Address 0x59d Write value 0xee28525
    li x3, 0xee28525
    csrw 0x59d, x3

    #Unmapped address 0x72c testing: random write/read operations
    #Address 0x72c Write value 0xa802da92
    li x3, 0xa802da92
    csrw 0x72c, x3

    #Unmapped address 0xe39 testing: random write/read operations
    #Address 0xe39 Write value 0x9b85aa50
    li x3, 0x9b85aa50
    csrw 0xe39, x3

    #Address 0xe39 Write value 0x1c406701
    li x3, 0x1c406701
    csrw 0xe39, x3

    #Address 0xe39 Write value 0xed7543ea
    li x3, 0xed7543ea
    csrw 0xe39, x3

    #Address 0xe39 Write value 0x6f75e566
    li x3, 0x6f75e566
    csrw 0xe39, x3

    #Address 0xe39 Write value 0x3a436231
    li x3, 0x3a436231
    csrw 0xe39, x3

    #Unmapped address 0xd0a testing: random write/read operations
    #Address 0xd0a Write value 0x745c5396
    li x3, 0x745c5396
    csrw 0xd0a, x3

    #Address 0xd0a Write value 0x6de3253b
    li x3, 0x6de3253b
    csrw 0xd0a, x3

    #Address 0xd0a read value
    csrr x14, 0xd0a

    #Address 0xd0a Write value 0x1b975643
    li x3, 0x1b975643
    csrw 0xd0a, x3

    #Unmapped address 0xd85 testing: random write/read operations
    #Address 0xd85 read value
    csrr x14, 0xd85

    #Address 0xd85 Write value 0xbdcf6b18
    li x3, 0xbdcf6b18
    csrw 0xd85, x3

    #Address 0xd85 Write value 0xfa07c39
    li x3, 0xfa07c39
    csrw 0xd85, x3

    #Address 0xd85 read value
    csrr x14, 0xd85

    #Unmapped address 0xfe0 testing: random write/read operations
    #Address 0xfe0 read value
    csrr x14, 0xfe0

    #Address 0xfe0 Write value 0xc8217fc6
    li x3, 0xc8217fc6
    csrw 0xfe0, x3

    #Address 0xfe0 read value
    csrr x14, 0xfe0

    #Address 0xfe0 Write value 0x16bf0841
    li x3, 0x16bf0841
    csrw 0xfe0, x3

    #Address 0xfe0 read value
    csrr x14, 0xfe0

    #Unmapped address 0x37c testing: random write/read operations
    #Address 0x37c read value
    csrr x14, 0x37c

    #Unmapped address 0x8c5 testing: random write/read operations
    #Address 0x8c5 Write value 0xfd014668
    li x3, 0xfd014668
    csrw 0x8c5, x3

    #Address 0x8c5 Write value 0xff9ba6b1
    li x3, 0xff9ba6b1
    csrw 0x8c5, x3

    #Unmapped address 0xbcf testing: random write/read operations
    #Address 0xbcf Write value 0xe7b8f46e
    li x3, 0xe7b8f46e
    csrw 0xbcf, x3

    #Unmapped address 0x6a5 testing: random write/read operations
    #Address 0x6a5 Write value 0x33f7d9d0
    li x3, 0x33f7d9d0
    csrw 0x6a5, x3

    #Address 0x6a5 Write value 0x7b87d592
    li x3, 0x7b87d592
    csrw 0x6a5, x3

    #Address 0x6a5 read value
    csrr x14, 0x6a5

    #Unmapped address 0xd89 testing: random write/read operations
    #Address 0xd89 read value
    csrr x14, 0xd89

    #Unmapped address 0x570 testing: random write/read operations
    #Address 0x570 read value
    csrr x14, 0x570

    #Address 0x570 read value
    csrr x14, 0x570

    #Address 0x570 read value
    csrr x14, 0x570

    #Address 0x570 read value
    csrr x14, 0x570

    #Address 0x570 read value
    csrr x14, 0x570

    #Unmapped address 0xc1a testing: random write/read operations
    #Address 0xc1a Write value 0xa91f4a82
    li x3, 0xa91f4a82
    csrw 0xc1a, x3

    #Address 0xc1a read value
    csrr x14, 0xc1a

    #Address 0xc1a Write value 0xd2e6d812
    li x3, 0xd2e6d812
    csrw 0xc1a, x3

    #Address 0xc1a Write value 0xddf37a09
    li x3, 0xddf37a09
    csrw 0xc1a, x3

    #Address 0xc1a Write value 0xe1e836cd
    li x3, 0xe1e836cd
    csrw 0xc1a, x3

    #Unmapped address 0x7dc testing: random write/read operations
    #Address 0x7dc read value
    csrr x14, 0x7dc

    #Address 0x7dc read value
    csrr x14, 0x7dc

    #Unmapped address 0xbc1 testing: random write/read operations
    #Address 0xbc1 Write value 0x15449ad0
    li x3, 0x15449ad0
    csrw 0xbc1, x3

    #Address 0xbc1 read value
    csrr x14, 0xbc1

    #Address 0xbc1 Write value 0xb6136edd
    li x3, 0xb6136edd
    csrw 0xbc1, x3

    #Address 0xbc1 Write value 0x3792d017
    li x3, 0x3792d017
    csrw 0xbc1, x3

    #Address 0xbc1 read value
    csrr x14, 0xbc1

    #Unmapped address 0xaeb testing: random write/read operations
    #Address 0xaeb Write value 0x8c0e1233
    li x3, 0x8c0e1233
    csrw 0xaeb, x3

    #Unmapped address 0xa48 testing: random write/read operations
    #Address 0xa48 read value
    csrr x14, 0xa48

    #Address 0xa48 read value
    csrr x14, 0xa48

    #Address 0xa48 Write value 0x997e2c85
    li x3, 0x997e2c85
    csrw 0xa48, x3

    #Unmapped address 0x3c7 testing: random write/read operations
    #Address 0x3c7 read value
    csrr x14, 0x3c7

    #Unmapped address 0xede testing: random write/read operations
    #Address 0xede read value
    csrr x14, 0xede

    #Unmapped address 0x4d0 testing: random write/read operations
    #Address 0x4d0 read value
    csrr x14, 0x4d0

    #Address 0x4d0 Write value 0xb9d77e34
    li x3, 0xb9d77e34
    csrw 0x4d0, x3

    #Address 0x4d0 Write value 0xf129635a
    li x3, 0xf129635a
    csrw 0x4d0, x3

    #Unmapped address 0x87a testing: random write/read operations
    #Address 0x87a Write value 0x145a1947
    li x3, 0x145a1947
    csrw 0x87a, x3

    #Address 0x87a read value
    csrr x14, 0x87a

    #Address 0x87a Write value 0xf9e600a0
    li x3, 0xf9e600a0
    csrw 0x87a, x3

    #Address 0x87a Write value 0xaa5ecb93
    li x3, 0xaa5ecb93
    csrw 0x87a, x3

    #Address 0x87a Write value 0x71c8723d
    li x3, 0x71c8723d
    csrw 0x87a, x3

    #Unmapped address 0xcfe testing: random write/read operations
    #Address 0xcfe read value
    csrr x14, 0xcfe

    #Unmapped address 0x85d testing: random write/read operations
    #Address 0x85d Write value 0x62e458db
    li x3, 0x62e458db
    csrw 0x85d, x3

    #Address 0x85d read value
    csrr x14, 0x85d

    #Unmapped address 0xf68 testing: random write/read operations
    #Address 0xf68 read value
    csrr x14, 0xf68

    #Address 0xf68 read value
    csrr x14, 0xf68

    #Address 0xf68 read value
    csrr x14, 0xf68

    #Address 0xf68 read value
    csrr x14, 0xf68

    #Unmapped address 0x22e testing: random write/read operations
    #Address 0x22e read value
    csrr x14, 0x22e

    #Address 0x22e Write value 0x654ad588
    li x3, 0x654ad588
    csrw 0x22e, x3

    #Unmapped address 0x540 testing: random write/read operations
    #Address 0x540 read value
    csrr x14, 0x540

    #Unmapped address 0x546 testing: random write/read operations
    #Address 0x546 Write value 0xde06b6f9
    li x3, 0xde06b6f9
    csrw 0x546, x3

    #Address 0x546 read value
    csrr x14, 0x546

    #Address 0x546 read value
    csrr x14, 0x546

    #Address 0x546 read value
    csrr x14, 0x546

    #Unmapped address 0xa57 testing: random write/read operations
    #Address 0xa57 read value
    csrr x14, 0xa57

    #Address 0xa57 read value
    csrr x14, 0xa57

    #Address 0xa57 Write value 0x204a5a67
    li x3, 0x204a5a67
    csrw 0xa57, x3

    #Unmapped address 0xb29 testing: random write/read operations
    #Address 0xb29 Write value 0x37b8734c
    li x3, 0x37b8734c
    csrw 0xb29, x3

    #Address 0xb29 read value
    csrr x14, 0xb29

    #Address 0xb29 Write value 0x3493c085
    li x3, 0x3493c085
    csrw 0xb29, x3

    #Address 0xb29 read value
    csrr x14, 0xb29

    #Unmapped address 0x764 testing: random write/read operations
    #Address 0x764 Write value 0x80fde999
    li x3, 0x80fde999
    csrw 0x764, x3

    #Address 0x764 Write value 0x71ebf84d
    li x3, 0x71ebf84d
    csrw 0x764, x3

    #Address 0x764 Write value 0xc41b5c9d
    li x3, 0xc41b5c9d
    csrw 0x764, x3

    #Unmapped address 0x85f testing: random write/read operations
    #Address 0x85f Write value 0xd09ee8e8
    li x3, 0xd09ee8e8
    csrw 0x85f, x3

    #Address 0x85f Write value 0xea4cc2c5
    li x3, 0xea4cc2c5
    csrw 0x85f, x3

    #Unmapped address 0xd51 testing: random write/read operations
    #Address 0xd51 read value
    csrr x14, 0xd51

    #Address 0xd51 Write value 0x731c7e07
    li x3, 0x731c7e07
    csrw 0xd51, x3

    #Address 0xd51 Write value 0xbc6f946f
    li x3, 0xbc6f946f
    csrw 0xd51, x3

    #Unmapped address 0xc testing: random write/read operations
    #Address 0xc read value
    csrr x14, 0xc

    #Address 0xc Write value 0x9d8e71a3
    li x3, 0x9d8e71a3
    csrw 0xc, x3

    #Unmapped address 0xc7b testing: random write/read operations
    #Address 0xc7b read value
    csrr x14, 0xc7b

    #Address 0xc7b read value
    csrr x14, 0xc7b

    #Address 0xc7b Write value 0x4579603e
    li x3, 0x4579603e
    csrw 0xc7b, x3

    #Address 0xc7b Write value 0xf2691f5b
    li x3, 0xf2691f5b
    csrw 0xc7b, x3

    #Unmapped address 0xebb testing: random write/read operations
    #Address 0xebb Write value 0xa054f340
    li x3, 0xa054f340
    csrw 0xebb, x3

    #Address 0xebb read value
    csrr x14, 0xebb

    #Address 0xebb Write value 0x9063e212
    li x3, 0x9063e212
    csrw 0xebb, x3

    #Unmapped address 0xc79 testing: random write/read operations
    #Address 0xc79 Write value 0x1339aac6
    li x3, 0x1339aac6
    csrw 0xc79, x3

    #Address 0xc79 Write value 0xb0a579b
    li x3, 0xb0a579b
    csrw 0xc79, x3

    #Address 0xc79 Write value 0xd98b31
    li x3, 0xd98b31
    csrw 0xc79, x3

    #Unmapped address 0xacd testing: random write/read operations
    #Address 0xacd Write value 0x354caab3
    li x3, 0x354caab3
    csrw 0xacd, x3

    #Address 0xacd Write value 0xb2204380
    li x3, 0xb2204380
    csrw 0xacd, x3

    #Address 0xacd Write value 0x6e449e06
    li x3, 0x6e449e06
    csrw 0xacd, x3

    #Address 0xacd Write value 0xdc255787
    li x3, 0xdc255787
    csrw 0xacd, x3

    #Unmapped address 0x4b9 testing: random write/read operations
    #Address 0x4b9 Write value 0xa13cae8d
    li x3, 0xa13cae8d
    csrw 0x4b9, x3

    #Address 0x4b9 read value
    csrr x14, 0x4b9

    #Address 0x4b9 Write value 0xc8ff7c4a
    li x3, 0xc8ff7c4a
    csrw 0x4b9, x3

    #Address 0x4b9 Write value 0x175ee354
    li x3, 0x175ee354
    csrw 0x4b9, x3

    #Unmapped address 0xfab testing: random write/read operations
    #Address 0xfab Write value 0x4d2c2ecf
    li x3, 0x4d2c2ecf
    csrw 0xfab, x3

    #Address 0xfab Write value 0xb76279c4
    li x3, 0xb76279c4
    csrw 0xfab, x3

    #Address 0xfab read value
    csrr x14, 0xfab

    #Unmapped address 0xb2c testing: random write/read operations
    #Address 0xb2c Write value 0x9e23f920
    li x3, 0x9e23f920
    csrw 0xb2c, x3

    #Unmapped address 0x77c testing: random write/read operations
    #Address 0x77c read value
    csrr x14, 0x77c

    #Address 0x77c read value
    csrr x14, 0x77c

    #Unmapped address 0x58d testing: random write/read operations
    #Address 0x58d read value
    csrr x14, 0x58d

    #Unmapped address 0x479 testing: random write/read operations
    #Address 0x479 read value
    csrr x14, 0x479

    #Unmapped address 0xab3 testing: random write/read operations
    #Address 0xab3 Write value 0x92b82de1
    li x3, 0x92b82de1
    csrw 0xab3, x3

    #Address 0xab3 Write value 0xa7d19cab
    li x3, 0xa7d19cab
    csrw 0xab3, x3

    #Address 0xab3 read value
    csrr x14, 0xab3

    #Unmapped address 0x978 testing: random write/read operations
    #Address 0x978 read value
    csrr x14, 0x978

    #Address 0x978 read value
    csrr x14, 0x978

    #Address 0x978 read value
    csrr x14, 0x978

    #Address 0x978 Write value 0xb49b2c77
    li x3, 0xb49b2c77
    csrw 0x978, x3

    #Address 0x978 Write value 0xd3024789
    li x3, 0xd3024789
    csrw 0x978, x3

    #Unmapped address 0x2d5 testing: random write/read operations
    #Address 0x2d5 read value
    csrr x14, 0x2d5

    #Address 0x2d5 Write value 0xe40a05ce
    li x3, 0xe40a05ce
    csrw 0x2d5, x3

    #Address 0x2d5 Write value 0xad6848da
    li x3, 0xad6848da
    csrw 0x2d5, x3

    #Address 0x2d5 Write value 0x1d693dcf
    li x3, 0x1d693dcf
    csrw 0x2d5, x3

    #Unmapped address 0x521 testing: random write/read operations
    #Address 0x521 read value
    csrr x14, 0x521

    #Address 0x521 Write value 0x297e2a54
    li x3, 0x297e2a54
    csrw 0x521, x3

    #Address 0x521 read value
    csrr x14, 0x521

    #Address 0x521 read value
    csrr x14, 0x521

    #Address 0x521 Write value 0xe5bf3dd9
    li x3, 0xe5bf3dd9
    csrw 0x521, x3

    #Unmapped address 0x243 testing: random write/read operations
    #Address 0x243 read value
    csrr x14, 0x243

    #Address 0x243 read value
    csrr x14, 0x243

    #Address 0x243 Write value 0x847c78f6
    li x3, 0x847c78f6
    csrw 0x243, x3

    #Address 0x243 read value
    csrr x14, 0x243

    #Address 0x243 Write value 0x9d02ba5e
    li x3, 0x9d02ba5e
    csrw 0x243, x3

    #Unmapped address 0xf24 testing: random write/read operations
    #Address 0xf24 Write value 0x9775eeb3
    li x3, 0x9775eeb3
    csrw 0xf24, x3

    #Address 0xf24 Write value 0x86cc5f2b
    li x3, 0x86cc5f2b
    csrw 0xf24, x3

    #Address 0xf24 read value
    csrr x14, 0xf24

    #Address 0xf24 read value
    csrr x14, 0xf24

    #Address 0xf24 read value
    csrr x14, 0xf24

    #Unmapped address 0x201 testing: random write/read operations
    #Address 0x201 Write value 0x5142fe33
    li x3, 0x5142fe33
    csrw 0x201, x3

    #Address 0x201 Write value 0x9379169c
    li x3, 0x9379169c
    csrw 0x201, x3

    #Address 0x201 Write value 0x43124ed9
    li x3, 0x43124ed9
    csrw 0x201, x3

    #Address 0x201 read value
    csrr x14, 0x201

    #Address 0x201 Write value 0xe2126fa9
    li x3, 0xe2126fa9
    csrw 0x201, x3

    #Unmapped address 0x37e testing: random write/read operations
    #Address 0x37e read value
    csrr x14, 0x37e

    #Address 0x37e Write value 0xfb7039d
    li x3, 0xfb7039d
    csrw 0x37e, x3

    #Unmapped address 0xecf testing: random write/read operations
    #Address 0xecf Write value 0x956f7d23
    li x3, 0x956f7d23
    csrw 0xecf, x3

    #Address 0xecf Write value 0x2e8c1098
    li x3, 0x2e8c1098
    csrw 0xecf, x3

    #Address 0xecf Write value 0xac1ede7
    li x3, 0xac1ede7
    csrw 0xecf, x3

    #Address 0xecf read value
    csrr x14, 0xecf

    #Address 0xecf read value
    csrr x14, 0xecf

    #Unmapped address 0x376 testing: random write/read operations
    #Address 0x376 read value
    csrr x14, 0x376

    #Address 0x376 Write value 0xf94e0134
    li x3, 0xf94e0134
    csrw 0x376, x3

    #Address 0x376 read value
    csrr x14, 0x376

    #Unmapped address 0x90f testing: random write/read operations
    #Address 0x90f read value
    csrr x14, 0x90f

    #Address 0x90f read value
    csrr x14, 0x90f

    #Address 0x90f read value
    csrr x14, 0x90f

    #Unmapped address 0xbdf testing: random write/read operations
    #Address 0xbdf read value
    csrr x14, 0xbdf

    #Address 0xbdf Write value 0xac204835
    li x3, 0xac204835
    csrw 0xbdf, x3

    #Unmapped address 0xef3 testing: random write/read operations
    #Address 0xef3 Write value 0xa70fb8c2
    li x3, 0xa70fb8c2
    csrw 0xef3, x3

    #Address 0xef3 Write value 0x5df37640
    li x3, 0x5df37640
    csrw 0xef3, x3

    #Address 0xef3 Write value 0x82fcf4e3
    li x3, 0x82fcf4e3
    csrw 0xef3, x3

    #Address 0xef3 read value
    csrr x14, 0xef3

    #Mapped address 0xb00 (mcycle) testing: random write/read operations
    #Address 0xb00 read value
    csrr x14, 0xb00

    #Address 0xb00 read value
    csrr x14, 0xb00

    #Address 0xb00 Write value 0xdb03d275
    li x3, 0xdb03d275
    csrw 0xb00, x3

    #Address 0xb00 Write value 0x17bdb298
    li x3, 0x17bdb298
    csrw 0xb00, x3

    #Address 0xb00 read value
    csrr x14, 0xb00

    #Unmapped address 0x5fd testing: random write/read operations
    #Address 0x5fd Write value 0xb7183eb9
    li x3, 0xb7183eb9
    csrw 0x5fd, x3

    #Address 0x5fd read value
    csrr x14, 0x5fd

    #Unmapped address 0x9cd testing: random write/read operations
    #Address 0x9cd read value
    csrr x14, 0x9cd

    #Address 0x9cd read value
    csrr x14, 0x9cd

    #Address 0x9cd Write value 0x98a423cf
    li x3, 0x98a423cf
    csrw 0x9cd, x3

    #Unmapped address 0x516 testing: random write/read operations
    #Address 0x516 read value
    csrr x14, 0x516

    #Unmapped address 0xfdb testing: random write/read operations
    #Address 0xfdb read value
    csrr x14, 0xfdb

    #Address 0xfdb Write value 0xd73f370
    li x3, 0xd73f370
    csrw 0xfdb, x3

    #Address 0xfdb read value
    csrr x14, 0xfdb

    #Address 0xfdb Write value 0xa4af21b7
    li x3, 0xa4af21b7
    csrw 0xfdb, x3

    #Address 0xfdb Write value 0x78dac0e9
    li x3, 0x78dac0e9
    csrw 0xfdb, x3

    #Unmapped address 0x661 testing: random write/read operations
    #Address 0x661 read value
    csrr x14, 0x661

    #Address 0x661 Write value 0xa0912a85
    li x3, 0xa0912a85
    csrw 0x661, x3

    #Address 0x661 Write value 0x60bce605
    li x3, 0x60bce605
    csrw 0x661, x3

    #Unmapped address 0xc2e testing: random write/read operations
    #Address 0xc2e Write value 0x295bf0e8
    li x3, 0x295bf0e8
    csrw 0xc2e, x3

    #Address 0xc2e Write value 0x635525e4
    li x3, 0x635525e4
    csrw 0xc2e, x3

    #Address 0xc2e Write value 0x4bcafb8c
    li x3, 0x4bcafb8c
    csrw 0xc2e, x3

    #Unmapped address 0xa46 testing: random write/read operations
    #Address 0xa46 Write value 0xb11cd70d
    li x3, 0xb11cd70d
    csrw 0xa46, x3

    #Address 0xa46 Write value 0x41d180f8
    li x3, 0x41d180f8
    csrw 0xa46, x3

    #Address 0xa46 read value
    csrr x14, 0xa46

    #Address 0xa46 read value
    csrr x14, 0xa46

    #Unmapped address 0x7b2 testing: random write/read operations
    #Address 0x7b2 read value
    csrr x14, 0x7b2

    #Address 0x7b2 Write value 0xa0f7922e
    li x3, 0xa0f7922e
    csrw 0x7b2, x3

    #Address 0x7b2 read value
    csrr x14, 0x7b2

    #Unmapped address 0xe5a testing: random write/read operations
    #Address 0xe5a read value
    csrr x14, 0xe5a

    #Address 0xe5a Write value 0xf33c9193
    li x3, 0xf33c9193
    csrw 0xe5a, x3

    #Address 0xe5a read value
    csrr x14, 0xe5a

    #Address 0xe5a read value
    csrr x14, 0xe5a

    #Unmapped address 0x51c testing: random write/read operations
    #Address 0x51c read value
    csrr x14, 0x51c

    #Address 0x51c read value
    csrr x14, 0x51c

    #Address 0x51c read value
    csrr x14, 0x51c

    #Address 0x51c read value
    csrr x14, 0x51c

    #Address 0x51c Write value 0x789f5940
    li x3, 0x789f5940
    csrw 0x51c, x3

    #Unmapped address 0x99e testing: random write/read operations
    #Address 0x99e Write value 0x95ed9904
    li x3, 0x95ed9904
    csrw 0x99e, x3

    #Address 0x99e Write value 0x714cb49e
    li x3, 0x714cb49e
    csrw 0x99e, x3

    #Address 0x99e Write value 0x1f53d5aa
    li x3, 0x1f53d5aa
    csrw 0x99e, x3

    #Address 0x99e read value
    csrr x14, 0x99e

    #Unmapped address 0x506 testing: random write/read operations
    #Address 0x506 Write value 0x95c0dc1a
    li x3, 0x95c0dc1a
    csrw 0x506, x3

    #Address 0x506 read value
    csrr x14, 0x506

    #Address 0x506 read value
    csrr x14, 0x506

    #Address 0x506 read value
    csrr x14, 0x506

    #Unmapped address 0xe7a testing: random write/read operations
    #Address 0xe7a Write value 0x61ad4116
    li x3, 0x61ad4116
    csrw 0xe7a, x3

    #Unmapped address 0x747 testing: random write/read operations
    #Address 0x747 Write value 0xa2d27eb0
    li x3, 0xa2d27eb0
    csrw 0x747, x3

    #Address 0x747 read value
    csrr x14, 0x747

    #Unmapped address 0x57d testing: random write/read operations
    #Address 0x57d Write value 0xc689000e
    li x3, 0xc689000e
    csrw 0x57d, x3

    #Address 0x57d read value
    csrr x14, 0x57d

    #Address 0x57d Write value 0x9135f94a
    li x3, 0x9135f94a
    csrw 0x57d, x3

    #Address 0x57d read value
    csrr x14, 0x57d

    #Unmapped address 0x494 testing: random write/read operations
    #Address 0x494 Write value 0xc2a282ac
    li x3, 0xc2a282ac
    csrw 0x494, x3

    #Address 0x494 read value
    csrr x14, 0x494

    #Address 0x494 read value
    csrr x14, 0x494

    #Address 0x494 read value
    csrr x14, 0x494

    #Address 0x494 read value
    csrr x14, 0x494

    #Unmapped address 0xfc4 testing: random write/read operations
    #Address 0xfc4 Write value 0xe8585fc4
    li x3, 0xe8585fc4
    csrw 0xfc4, x3

    #Unmapped address 0x15e testing: random write/read operations
    #Address 0x15e Write value 0x2b8dcd5f
    li x3, 0x2b8dcd5f
    csrw 0x15e, x3

    #Address 0x15e read value
    csrr x14, 0x15e

    #Address 0x15e read value
    csrr x14, 0x15e

    #Address 0x15e read value
    csrr x14, 0x15e

    #Address 0x15e Write value 0x9a1848e6
    li x3, 0x9a1848e6
    csrw 0x15e, x3

    #Unmapped address 0x8ec testing: random write/read operations
    #Address 0x8ec read value
    csrr x14, 0x8ec

    #Unmapped address 0xdc5 testing: random write/read operations
    #Address 0xdc5 Write value 0xd25ebb53
    li x3, 0xd25ebb53
    csrw 0xdc5, x3

    #Address 0xdc5 Write value 0x3360a07d
    li x3, 0x3360a07d
    csrw 0xdc5, x3

    #Address 0xdc5 Write value 0x3946d2fd
    li x3, 0x3946d2fd
    csrw 0xdc5, x3

    #Address 0xdc5 Write value 0x1a620b12
    li x3, 0x1a620b12
    csrw 0xdc5, x3

    #Address 0xdc5 read value
    csrr x14, 0xdc5

    #Unmapped address 0x34a testing: random write/read operations
    #Address 0x34a Write value 0xc0045d3
    li x3, 0xc0045d3
    csrw 0x34a, x3

    #Address 0x34a Write value 0x82550827
    li x3, 0x82550827
    csrw 0x34a, x3

    #Address 0x34a Write value 0xfd87e5ed
    li x3, 0xfd87e5ed
    csrw 0x34a, x3

    #Unmapped address 0xa6d testing: random write/read operations
    #Address 0xa6d read value
    csrr x14, 0xa6d

    #Address 0xa6d read value
    csrr x14, 0xa6d

    #Address 0xa6d read value
    csrr x14, 0xa6d

    #Unmapped address 0xf3d testing: random write/read operations
    #Address 0xf3d Write value 0xe62df1ee
    li x3, 0xe62df1ee
    csrw 0xf3d, x3

    #Address 0xf3d Write value 0xc7f45772
    li x3, 0xc7f45772
    csrw 0xf3d, x3

    #Unmapped address 0xb5 testing: random write/read operations
    #Address 0xb5 Write value 0xa817875
    li x3, 0xa817875
    csrw 0xb5, x3

    #Address 0xb5 read value
    csrr x14, 0xb5

    #Address 0xb5 Write value 0x78906634
    li x3, 0x78906634
    csrw 0xb5, x3

    #Unmapped address 0x42 testing: random write/read operations
    #Address 0x42 Write value 0xce405162
    li x3, 0xce405162
    csrw 0x42, x3

    #Address 0x42 Write value 0xf212c159
    li x3, 0xf212c159
    csrw 0x42, x3

    #Address 0x42 Write value 0x4f07d841
    li x3, 0x4f07d841
    csrw 0x42, x3

    #Address 0x42 read value
    csrr x14, 0x42

    #Address 0x42 read value
    csrr x14, 0x42

    #Unmapped address 0x561 testing: random write/read operations
    #Address 0x561 read value
    csrr x14, 0x561

    #Address 0x561 read value
    csrr x14, 0x561

    #Address 0x561 Write value 0x6fc429bb
    li x3, 0x6fc429bb
    csrw 0x561, x3

    #Address 0x561 read value
    csrr x14, 0x561

    #Mapped address 0xc02 (instret) testing: random write/read operations
    #Address 0xc02 Write value 0x256244f0
    li x3, 0x256244f0
    csrw 0xc02, x3

    #Address 0xc02 read value
    csrr x14, 0xc02

    #Address 0xc02 read value
    csrr x14, 0xc02

    #Address 0xc02 read value
    csrr x14, 0xc02

    #Unmapped address 0x645 testing: random write/read operations
    #Address 0x645 Write value 0xd98ed29
    li x3, 0xd98ed29
    csrw 0x645, x3

    #Unmapped address 0x368 testing: random write/read operations
    #Address 0x368 read value
    csrr x14, 0x368

    #Address 0x368 read value
    csrr x14, 0x368

    #Address 0x368 Write value 0x724a22be
    li x3, 0x724a22be
    csrw 0x368, x3

    #Unmapped address 0x40b testing: random write/read operations
    #Address 0x40b Write value 0xabc6182c
    li x3, 0xabc6182c
    csrw 0x40b, x3

    #Address 0x40b Write value 0xfc99992
    li x3, 0xfc99992
    csrw 0x40b, x3

    #Address 0x40b Write value 0x59ede546
    li x3, 0x59ede546
    csrw 0x40b, x3

    #Unmapped address 0xda8 testing: random write/read operations
    #Address 0xda8 Write value 0x19653b5
    li x3, 0x19653b5
    csrw 0xda8, x3

    #Unmapped address 0x205 testing: random write/read operations
    #Address 0x205 read value
    csrr x14, 0x205

    #Address 0x205 read value
    csrr x14, 0x205

    #Address 0x205 Write value 0xed28a92b
    li x3, 0xed28a92b
    csrw 0x205, x3

    #Unmapped address 0x630 testing: random write/read operations
    #Address 0x630 Write value 0xdda10e3a
    li x3, 0xdda10e3a
    csrw 0x630, x3

    #Address 0x630 read value
    csrr x14, 0x630

    #Address 0x630 Write value 0x3fd5c278
    li x3, 0x3fd5c278
    csrw 0x630, x3

    #Address 0x630 read value
    csrr x14, 0x630

    #Address 0x630 read value
    csrr x14, 0x630

    #Mapped address 0xb1e (mhpmcounter30) testing: random write/read operations
    #Address 0xb1e read value
    csrr x14, 0xb1e

    #Address 0xb1e Write value 0xf30a5dcc
    li x3, 0xf30a5dcc
    csrw 0xb1e, x3

    #Address 0xb1e Write value 0x1981a50c
    li x3, 0x1981a50c
    csrw 0xb1e, x3

    #Address 0xb1e Write value 0x3a4465d1
    li x3, 0x3a4465d1
    csrw 0xb1e, x3

    #Address 0xb1e read value
    csrr x14, 0xb1e

    #Unmapped address 0x771 testing: random write/read operations
    #Address 0x771 Write value 0xfa53f0b5
    li x3, 0xfa53f0b5
    csrw 0x771, x3

    #Address 0x771 Write value 0xb3f3d727
    li x3, 0xb3f3d727
    csrw 0x771, x3

    #Unmapped address 0x6ba testing: random write/read operations
    #Address 0x6ba read value
    csrr x14, 0x6ba

    #Unmapped address 0xcc1 testing: random write/read operations
    #Address 0xcc1 Write value 0xec44c1cc
    li x3, 0xec44c1cc
    csrw 0xcc1, x3

    #Address 0xcc1 Write value 0xb9541
    li x3, 0xb9541
    csrw 0xcc1, x3

    #Address 0xcc1 Write value 0x8b64ee1
    li x3, 0x8b64ee1
    csrw 0xcc1, x3

    #Address 0xcc1 read value
    csrr x14, 0xcc1

    #Address 0xcc1 Write value 0xe434e31b
    li x3, 0xe434e31b
    csrw 0xcc1, x3

    #Unmapped address 0x123 testing: random write/read operations
    #Address 0x123 read value
    csrr x14, 0x123

    #Address 0x123 Write value 0x39f2ec09
    li x3, 0x39f2ec09
    csrw 0x123, x3

    #Address 0x123 Write value 0xe3e61074
    li x3, 0xe3e61074
    csrw 0x123, x3

    #Address 0x123 Write value 0x42e1a46d
    li x3, 0x42e1a46d
    csrw 0x123, x3

    #Unmapped address 0x242 testing: random write/read operations
    #Address 0x242 Write value 0x7cbe6f40
    li x3, 0x7cbe6f40
    csrw 0x242, x3

    #Unmapped address 0x52d testing: random write/read operations
    #Address 0x52d Write value 0x6b8818c
    li x3, 0x6b8818c
    csrw 0x52d, x3

    #Address 0x52d Write value 0x1018cf80
    li x3, 0x1018cf80
    csrw 0x52d, x3

    #Address 0x52d Write value 0x626b5571
    li x3, 0x626b5571
    csrw 0x52d, x3

    #Address 0x52d read value
    csrr x14, 0x52d

    #Unmapped address 0x8f testing: random write/read operations
    #Address 0x8f Write value 0x5faed9fa
    li x3, 0x5faed9fa
    csrw 0x8f, x3

    #Unmapped address 0xae9 testing: random write/read operations
    #Address 0xae9 read value
    csrr x14, 0xae9

    #Address 0xae9 Write value 0xabcc799
    li x3, 0xabcc799
    csrw 0xae9, x3

    #Address 0xae9 Write value 0x43615d34
    li x3, 0x43615d34
    csrw 0xae9, x3

    #Unmapped address 0x59 testing: random write/read operations
    #Address 0x59 read value
    csrr x14, 0x59

    #Address 0x59 Write value 0x52ffa4ea
    li x3, 0x52ffa4ea
    csrw 0x59, x3

    #Unmapped address 0xa53 testing: random write/read operations
    #Address 0xa53 read value
    csrr x14, 0xa53

    #Unmapped address 0xb50 testing: random write/read operations
    #Address 0xb50 read value
    csrr x14, 0xb50

    #Address 0xb50 Write value 0xe67c2154
    li x3, 0xe67c2154
    csrw 0xb50, x3

    #Address 0xb50 Write value 0xc818d5fd
    li x3, 0xc818d5fd
    csrw 0xb50, x3

    #Address 0xb50 Write value 0x8d81a605
    li x3, 0x8d81a605
    csrw 0xb50, x3

    #Unmapped address 0xbac testing: random write/read operations
    #Address 0xbac Write value 0xe51225c6
    li x3, 0xe51225c6
    csrw 0xbac, x3

    #Unmapped address 0xe61 testing: random write/read operations
    #Address 0xe61 read value
    csrr x14, 0xe61

    #Address 0xe61 read value
    csrr x14, 0xe61

    #Unmapped address 0xb7d testing: random write/read operations
    #Address 0xb7d read value
    csrr x14, 0xb7d

    #Unmapped address 0xfd3 testing: random write/read operations
    #Address 0xfd3 Write value 0xee69fa00
    li x3, 0xee69fa00
    csrw 0xfd3, x3

    #Unmapped address 0xc66 testing: random write/read operations
    #Address 0xc66 read value
    csrr x14, 0xc66

    #Unmapped address 0x6dd testing: random write/read operations
    #Address 0x6dd Write value 0x8f58b123
    li x3, 0x8f58b123
    csrw 0x6dd, x3

    #Unmapped address 0x39 testing: random write/read operations
    #Address 0x39 Write value 0x4d085ad7
    li x3, 0x4d085ad7
    csrw 0x39, x3

    #Address 0x39 read value
    csrr x14, 0x39

    #Unmapped address 0x866 testing: random write/read operations
    #Address 0x866 Write value 0x668edc54
    li x3, 0x668edc54
    csrw 0x866, x3

    #Address 0x866 read value
    csrr x14, 0x866

    #Address 0x866 read value
    csrr x14, 0x866

    #Address 0x866 read value
    csrr x14, 0x866

    #Unmapped address 0x8e4 testing: random write/read operations
    #Address 0x8e4 Write value 0x605a19e8
    li x3, 0x605a19e8
    csrw 0x8e4, x3

    #Unmapped address 0x8cb testing: random write/read operations
    #Address 0x8cb Write value 0x72e5f929
    li x3, 0x72e5f929
    csrw 0x8cb, x3

    #Unmapped address 0xd73 testing: random write/read operations
    #Address 0xd73 read value
    csrr x14, 0xd73

    #Address 0xd73 read value
    csrr x14, 0xd73

    #Address 0xd73 read value
    csrr x14, 0xd73

    #Unmapped address 0x673 testing: random write/read operations
    #Address 0x673 Write value 0xf4737430
    li x3, 0xf4737430
    csrw 0x673, x3

    #Address 0x673 read value
    csrr x14, 0x673

    #Address 0x673 read value
    csrr x14, 0x673

    #Address 0x673 Write value 0xda2b62c0
    li x3, 0xda2b62c0
    csrw 0x673, x3

    #Address 0x673 Write value 0x6c7a0663
    li x3, 0x6c7a0663
    csrw 0x673, x3

    #Unmapped address 0xa20 testing: random write/read operations
    #Address 0xa20 read value
    csrr x14, 0xa20

    #Address 0xa20 read value
    csrr x14, 0xa20

    #Address 0xa20 read value
    csrr x14, 0xa20

    #Address 0xa20 Write value 0xd415b5af
    li x3, 0xd415b5af
    csrw 0xa20, x3

    #Address 0xa20 read value
    csrr x14, 0xa20

    #Unmapped address 0xeaa testing: random write/read operations
    #Address 0xeaa Write value 0x82f29430
    li x3, 0x82f29430
    csrw 0xeaa, x3

    #Address 0xeaa read value
    csrr x14, 0xeaa

    #Address 0xeaa Write value 0x6a19711d
    li x3, 0x6a19711d
    csrw 0xeaa, x3

    #Address 0xeaa read value
    csrr x14, 0xeaa

    #Unmapped address 0xd06 testing: random write/read operations
    #Address 0xd06 Write value 0xab20d340
    li x3, 0xab20d340
    csrw 0xd06, x3

    #Address 0xd06 Write value 0x9a94034e
    li x3, 0x9a94034e
    csrw 0xd06, x3

    #Unmapped address 0x11a testing: random write/read operations
    #Address 0x11a read value
    csrr x14, 0x11a

    #Unmapped address 0xae1 testing: random write/read operations
    #Address 0xae1 read value
    csrr x14, 0xae1

    #Address 0xae1 Write value 0xb355bea0
    li x3, 0xb355bea0
    csrw 0xae1, x3

    #Address 0xae1 Write value 0x561d1857
    li x3, 0x561d1857
    csrw 0xae1, x3

    #Address 0xae1 Write value 0xd8060257
    li x3, 0xd8060257
    csrw 0xae1, x3

    #Unmapped address 0xd3f testing: random write/read operations
    #Address 0xd3f read value
    csrr x14, 0xd3f

    #Address 0xd3f read value
    csrr x14, 0xd3f

    #Address 0xd3f Write value 0x8a460845
    li x3, 0x8a460845
    csrw 0xd3f, x3

    #Address 0xd3f Write value 0x55d4f8a4
    li x3, 0x55d4f8a4
    csrw 0xd3f, x3

    #Address 0xd3f Write value 0xdacc62cb
    li x3, 0xdacc62cb
    csrw 0xd3f, x3

    #Unmapped address 0x935 testing: random write/read operations
    #Address 0x935 Write value 0x54b7d0b1
    li x3, 0x54b7d0b1
    csrw 0x935, x3

    #Unmapped address 0x8d6 testing: random write/read operations
    #Address 0x8d6 read value
    csrr x14, 0x8d6

    #Address 0x8d6 Write value 0x2dea1463
    li x3, 0x2dea1463
    csrw 0x8d6, x3

    #Unmapped address 0x50d testing: random write/read operations
    #Address 0x50d Write value 0xf9f9904b
    li x3, 0xf9f9904b
    csrw 0x50d, x3

    #Address 0x50d Write value 0x2c48d005
    li x3, 0x2c48d005
    csrw 0x50d, x3

    #Address 0x50d Write value 0xa82dc500
    li x3, 0xa82dc500
    csrw 0x50d, x3

    #Address 0x50d Write value 0xf81d086e
    li x3, 0xf81d086e
    csrw 0x50d, x3

    #Unmapped address 0x665 testing: random write/read operations
    #Address 0x665 read value
    csrr x14, 0x665

    #Address 0x665 read value
    csrr x14, 0x665

    #Address 0x665 read value
    csrr x14, 0x665

    #Address 0x665 read value
    csrr x14, 0x665

    #Address 0x665 read value
    csrr x14, 0x665

    #Unmapped address 0x3a8 testing: random write/read operations
    #Address 0x3a8 Write value 0x34e42170
    li x3, 0x34e42170
    csrw 0x3a8, x3

    #Address 0x3a8 Write value 0x9240413c
    li x3, 0x9240413c
    csrw 0x3a8, x3

    #Unmapped address 0x77a testing: random write/read operations
    #Address 0x77a read value
    csrr x14, 0x77a

    #Address 0x77a read value
    csrr x14, 0x77a

    #Address 0x77a read value
    csrr x14, 0x77a

    #Address 0x77a Write value 0x3567a253
    li x3, 0x3567a253
    csrw 0x77a, x3

    #Unmapped address 0xce4 testing: random write/read operations
    #Address 0xce4 read value
    csrr x14, 0xce4

    #Address 0xce4 Write value 0x22176c7b
    li x3, 0x22176c7b
    csrw 0xce4, x3

    #Address 0xce4 Write value 0xaf26da79
    li x3, 0xaf26da79
    csrw 0xce4, x3

    #Unmapped address 0x87b testing: random write/read operations
    #Address 0x87b read value
    csrr x14, 0x87b

    #Address 0x87b Write value 0xa8f8ab09
    li x3, 0xa8f8ab09
    csrw 0x87b, x3

    #Address 0x87b Write value 0x1d547f59
    li x3, 0x1d547f59
    csrw 0x87b, x3

    #Address 0x87b read value
    csrr x14, 0x87b

    #Address 0x87b Write value 0xa08dfba9
    li x3, 0xa08dfba9
    csrw 0x87b, x3

    #Unmapped address 0x92e testing: random write/read operations
    #Address 0x92e read value
    csrr x14, 0x92e

    #Address 0x92e Write value 0x79128f55
    li x3, 0x79128f55
    csrw 0x92e, x3

    #Address 0x92e read value
    csrr x14, 0x92e

    #Address 0x92e read value
    csrr x14, 0x92e

    #Address 0x92e read value
    csrr x14, 0x92e

    #Unmapped address 0x5a1 testing: random write/read operations
    #Address 0x5a1 Write value 0x1c9ac090
    li x3, 0x1c9ac090
    csrw 0x5a1, x3

    #Address 0x5a1 read value
    csrr x14, 0x5a1

    #Address 0x5a1 read value
    csrr x14, 0x5a1

    #Address 0x5a1 read value
    csrr x14, 0x5a1

    #Unmapped address 0x196 testing: random write/read operations
    #Address 0x196 read value
    csrr x14, 0x196

    #Address 0x196 Write value 0xa8f006b2
    li x3, 0xa8f006b2
    csrw 0x196, x3

    #Address 0x196 Write value 0x5134a7d8
    li x3, 0x5134a7d8
    csrw 0x196, x3

    #Address 0x196 Write value 0xa6ad0501
    li x3, 0xa6ad0501
    csrw 0x196, x3

    #Unmapped address 0x446 testing: random write/read operations
    #Address 0x446 read value
    csrr x14, 0x446

    #Unmapped address 0xaf7 testing: random write/read operations
    #Address 0xaf7 Write value 0xf63a5cec
    li x3, 0xf63a5cec
    csrw 0xaf7, x3

    #Address 0xaf7 read value
    csrr x14, 0xaf7

    #Address 0xaf7 Write value 0xa216e3a2
    li x3, 0xa216e3a2
    csrw 0xaf7, x3

    #Unmapped address 0x21b testing: random write/read operations
    #Address 0x21b Write value 0xbb4149ab
    li x3, 0xbb4149ab
    csrw 0x21b, x3

    #Unmapped address 0xdf7 testing: random write/read operations
    #Address 0xdf7 read value
    csrr x14, 0xdf7

    #Address 0xdf7 Write value 0xe1c66824
    li x3, 0xe1c66824
    csrw 0xdf7, x3

    #Address 0xdf7 Write value 0xdd356e91
    li x3, 0xdd356e91
    csrw 0xdf7, x3

    #Address 0xdf7 read value
    csrr x14, 0xdf7

    #Address 0xdf7 read value
    csrr x14, 0xdf7

    #Unmapped address 0x5c2 testing: random write/read operations
    #Address 0x5c2 Write value 0x9435a17
    li x3, 0x9435a17
    csrw 0x5c2, x3

    #Address 0x5c2 Write value 0x13482f5e
    li x3, 0x13482f5e
    csrw 0x5c2, x3

    #Address 0x5c2 read value
    csrr x14, 0x5c2

    #Address 0x5c2 Write value 0x1f2a5b7a
    li x3, 0x1f2a5b7a
    csrw 0x5c2, x3

    #Address 0x5c2 read value
    csrr x14, 0x5c2

    #Unmapped address 0x78f testing: random write/read operations
    #Address 0x78f read value
    csrr x14, 0x78f

    #Address 0x78f read value
    csrr x14, 0x78f

    #Unmapped address 0xae0 testing: random write/read operations
    #Address 0xae0 read value
    csrr x14, 0xae0

    #Address 0xae0 read value
    csrr x14, 0xae0

    #Address 0xae0 Write value 0xa38e5306
    li x3, 0xa38e5306
    csrw 0xae0, x3

    #Unmapped address 0x477 testing: random write/read operations
    #Address 0x477 read value
    csrr x14, 0x477

    #Address 0x477 read value
    csrr x14, 0x477

    #Address 0x477 Write value 0xe984eead
    li x3, 0xe984eead
    csrw 0x477, x3

    #Address 0x477 Write value 0x6603bc6f
    li x3, 0x6603bc6f
    csrw 0x477, x3

    #Unmapped address 0x7ee testing: random write/read operations
    #Address 0x7ee Write value 0x6472a629
    li x3, 0x6472a629
    csrw 0x7ee, x3

    #Address 0x7ee Write value 0x9e970c96
    li x3, 0x9e970c96
    csrw 0x7ee, x3

    #Address 0x7ee Write value 0x568c9f47
    li x3, 0x568c9f47
    csrw 0x7ee, x3

    #Address 0x7ee read value
    csrr x14, 0x7ee

    #Unmapped address 0x9bd testing: random write/read operations
    #Address 0x9bd Write value 0xb0531854
    li x3, 0xb0531854
    csrw 0x9bd, x3

    #Address 0x9bd Write value 0xfdde30c0
    li x3, 0xfdde30c0
    csrw 0x9bd, x3

    #Address 0x9bd Write value 0x119173a8
    li x3, 0x119173a8
    csrw 0x9bd, x3

    #Address 0x9bd Write value 0x398ba410
    li x3, 0x398ba410
    csrw 0x9bd, x3

    #Unmapped address 0x6a9 testing: random write/read operations
    #Address 0x6a9 read value
    csrr x14, 0x6a9

    #Address 0x6a9 read value
    csrr x14, 0x6a9

    #Unmapped address 0xd43 testing: random write/read operations
    #Address 0xd43 read value
    csrr x14, 0xd43

    #Address 0xd43 read value
    csrr x14, 0xd43

    #Address 0xd43 Write value 0x9ccd9cfd
    li x3, 0x9ccd9cfd
    csrw 0xd43, x3

    #Address 0xd43 read value
    csrr x14, 0xd43

    #Address 0xd43 read value
    csrr x14, 0xd43

    #Unmapped address 0xc55 testing: random write/read operations
    #Address 0xc55 Write value 0x18efb12d
    li x3, 0x18efb12d
    csrw 0xc55, x3

    #Address 0xc55 read value
    csrr x14, 0xc55

    #Address 0xc55 read value
    csrr x14, 0xc55

    #Unmapped address 0x1b4 testing: random write/read operations
    #Address 0x1b4 read value
    csrr x14, 0x1b4

    #Address 0x1b4 read value
    csrr x14, 0x1b4

    #Address 0x1b4 Write value 0x2bfd12cb
    li x3, 0x2bfd12cb
    csrw 0x1b4, x3

    #Unmapped address 0xa3c testing: random write/read operations
    #Address 0xa3c Write value 0x39a3708a
    li x3, 0x39a3708a
    csrw 0xa3c, x3

    #Unmapped address 0x52a testing: random write/read operations
    #Address 0x52a read value
    csrr x14, 0x52a

    #Address 0x52a read value
    csrr x14, 0x52a

    #Address 0x52a read value
    csrr x14, 0x52a

    #Unmapped address 0xfd0 testing: random write/read operations
    #Address 0xfd0 Write value 0x71a96909
    li x3, 0x71a96909
    csrw 0xfd0, x3

    #Address 0xfd0 read value
    csrr x14, 0xfd0

    #Address 0xfd0 read value
    csrr x14, 0xfd0

    #Address 0xfd0 Write value 0xeb8ed117
    li x3, 0xeb8ed117
    csrw 0xfd0, x3

    #Address 0xfd0 read value
    csrr x14, 0xfd0

    #Unmapped address 0x6ab testing: random write/read operations
    #Address 0x6ab Write value 0xcc90d8f4
    li x3, 0xcc90d8f4
    csrw 0x6ab, x3

    #Address 0x6ab Write value 0xdd776e94
    li x3, 0xdd776e94
    csrw 0x6ab, x3

    #Unmapped address 0x647 testing: random write/read operations
    #Address 0x647 Write value 0xf86741ef
    li x3, 0xf86741ef
    csrw 0x647, x3

    #Unmapped address 0xd19 testing: random write/read operations
    #Address 0xd19 Write value 0x259b0229
    li x3, 0x259b0229
    csrw 0xd19, x3

    #Address 0xd19 read value
    csrr x14, 0xd19

    #Unmapped address 0x96f testing: random write/read operations
    #Address 0x96f read value
    csrr x14, 0x96f

    #Address 0x96f Write value 0xd5dfd085
    li x3, 0xd5dfd085
    csrw 0x96f, x3

    #Address 0x96f read value
    csrr x14, 0x96f

    #Unmapped address 0x1c8 testing: random write/read operations
    #Address 0x1c8 read value
    csrr x14, 0x1c8

    #Unmapped address 0x605 testing: random write/read operations
    #Address 0x605 Write value 0xa8d6dce2
    li x3, 0xa8d6dce2
    csrw 0x605, x3

    #Unmapped address 0xa3d testing: random write/read operations
    #Address 0xa3d Write value 0xaf32ca2f
    li x3, 0xaf32ca2f
    csrw 0xa3d, x3

    #Unmapped address 0xe5 testing: random write/read operations
    #Address 0xe5 read value
    csrr x14, 0xe5

    #Address 0xe5 Write value 0xf654d190
    li x3, 0xf654d190
    csrw 0xe5, x3

    #Address 0xe5 read value
    csrr x14, 0xe5

    #Address 0xe5 Write value 0x9766e78e
    li x3, 0x9766e78e
    csrw 0xe5, x3

    #Address 0xe5 read value
    csrr x14, 0xe5

    #Unmapped address 0x5fe testing: random write/read operations
    #Address 0x5fe read value
    csrr x14, 0x5fe

    #Address 0x5fe Write value 0x95493055
    li x3, 0x95493055
    csrw 0x5fe, x3

    #Address 0x5fe read value
    csrr x14, 0x5fe

    #Unmapped address 0x843 testing: random write/read operations
    #Address 0x843 read value
    csrr x14, 0x843

    #Address 0x843 read value
    csrr x14, 0x843

    #Address 0x843 read value
    csrr x14, 0x843

    #Address 0x843 Write value 0xc21c0021
    li x3, 0xc21c0021
    csrw 0x843, x3

    #Address 0x843 Write value 0xd9b91a59
    li x3, 0xd9b91a59
    csrw 0x843, x3

    #Unmapped address 0xda3 testing: random write/read operations
    #Address 0xda3 Write value 0xdcc6fcfa
    li x3, 0xdcc6fcfa
    csrw 0xda3, x3

    #Address 0xda3 read value
    csrr x14, 0xda3

    #Unmapped address 0x73 testing: random write/read operations
    #Address 0x73 Write value 0xc661b782
    li x3, 0xc661b782
    csrw 0x73, x3

    #Address 0x73 Write value 0xc38a6d73
    li x3, 0xc38a6d73
    csrw 0x73, x3

    #Address 0x73 Write value 0x8895d715
    li x3, 0x8895d715
    csrw 0x73, x3

    #Address 0x73 read value
    csrr x14, 0x73

    #Address 0x73 read value
    csrr x14, 0x73

    #Unmapped address 0xbb8 testing: random write/read operations
    #Address 0xbb8 Write value 0xc01eac20
    li x3, 0xc01eac20
    csrw 0xbb8, x3

    #Address 0xbb8 Write value 0x896ad42c
    li x3, 0x896ad42c
    csrw 0xbb8, x3

    #Address 0xbb8 Write value 0x6924c6a6
    li x3, 0x6924c6a6
    csrw 0xbb8, x3

    #Address 0xbb8 Write value 0xe8dc72dc
    li x3, 0xe8dc72dc
    csrw 0xbb8, x3

    #Address 0xbb8 read value
    csrr x14, 0xbb8

    #Unmapped address 0xf60 testing: random write/read operations
    #Address 0xf60 read value
    csrr x14, 0xf60

    #Address 0xf60 read value
    csrr x14, 0xf60

    #Unmapped address 0x5a3 testing: random write/read operations
    #Address 0x5a3 read value
    csrr x14, 0x5a3

    #Address 0x5a3 read value
    csrr x14, 0x5a3

    #Unmapped address 0x420 testing: random write/read operations
    #Address 0x420 read value
    csrr x14, 0x420

    #Address 0x420 read value
    csrr x14, 0x420

    #Unmapped address 0xc56 testing: random write/read operations
    #Address 0xc56 read value
    csrr x14, 0xc56

    #Address 0xc56 read value
    csrr x14, 0xc56

    #Address 0xc56 read value
    csrr x14, 0xc56

    #Address 0xc56 Write value 0xf496aa32
    li x3, 0xf496aa32
    csrw 0xc56, x3

    #Address 0xc56 read value
    csrr x14, 0xc56

    #Unmapped address 0x785 testing: random write/read operations
    #Address 0x785 read value
    csrr x14, 0x785

    #Address 0x785 read value
    csrr x14, 0x785

    #Unmapped address 0x576 testing: random write/read operations
    #Address 0x576 read value
    csrr x14, 0x576

    #Address 0x576 read value
    csrr x14, 0x576

    #Unmapped address 0xb7 testing: random write/read operations
    #Address 0xb7 Write value 0x95691a8c
    li x3, 0x95691a8c
    csrw 0xb7, x3

    #Address 0xb7 read value
    csrr x14, 0xb7

    #Address 0xb7 read value
    csrr x14, 0xb7

    #Unmapped address 0x979 testing: random write/read operations
    #Address 0x979 read value
    csrr x14, 0x979

    #Address 0x979 read value
    csrr x14, 0x979

    #Unmapped address 0x58 testing: random write/read operations
    #Address 0x58 Write value 0x7c708b67
    li x3, 0x7c708b67
    csrw 0x58, x3

    #Unmapped address 0x9bb testing: random write/read operations
    #Address 0x9bb read value
    csrr x14, 0x9bb

    #Address 0x9bb read value
    csrr x14, 0x9bb

    #Unmapped address 0xa33 testing: random write/read operations
    #Address 0xa33 read value
    csrr x14, 0xa33

    #Address 0xa33 read value
    csrr x14, 0xa33

    #Address 0xa33 Write value 0xa2e95097
    li x3, 0xa2e95097
    csrw 0xa33, x3

    #Unmapped address 0x396 testing: random write/read operations
    #Address 0x396 read value
    csrr x14, 0x396

    #Address 0x396 read value
    csrr x14, 0x396

    #Address 0x396 Write value 0x704db208
    li x3, 0x704db208
    csrw 0x396, x3

    #Address 0x396 read value
    csrr x14, 0x396

    #Address 0x396 read value
    csrr x14, 0x396

    #Unmapped address 0x5da testing: random write/read operations
    #Address 0x5da read value
    csrr x14, 0x5da

    #Address 0x5da read value
    csrr x14, 0x5da

    #Address 0x5da Write value 0xde72aee7
    li x3, 0xde72aee7
    csrw 0x5da, x3

    #Address 0x5da Write value 0x804a9990
    li x3, 0x804a9990
    csrw 0x5da, x3

    #Address 0x5da Write value 0xe65abaef
    li x3, 0xe65abaef
    csrw 0x5da, x3

    #Unmapped address 0x7e0 testing: random write/read operations
    #Address 0x7e0 read value
    csrr x14, 0x7e0

    #Address 0x7e0 read value
    csrr x14, 0x7e0

    #Address 0x7e0 read value
    csrr x14, 0x7e0

    #Unmapped address 0x31 testing: random write/read operations
    #Address 0x31 read value
    csrr x14, 0x31

    #Unmapped address 0x80 testing: random write/read operations
    #Address 0x80 Write value 0x157740a7
    li x3, 0x157740a7
    csrw 0x80, x3

    #Address 0x80 read value
    csrr x14, 0x80

    #Address 0x80 read value
    csrr x14, 0x80

    #Address 0x80 read value
    csrr x14, 0x80

    #Address 0x80 read value
    csrr x14, 0x80

    #Unmapped address 0xf3 testing: random write/read operations
    #Address 0xf3 Write value 0xc704c72e
    li x3, 0xc704c72e
    csrw 0xf3, x3

    #Address 0xf3 Write value 0x6748ea69
    li x3, 0x6748ea69
    csrw 0xf3, x3

    #Address 0xf3 Write value 0x98fbe6dc
    li x3, 0x98fbe6dc
    csrw 0xf3, x3

    #Address 0xf3 read value
    csrr x14, 0xf3

    #Address 0xf3 read value
    csrr x14, 0xf3

    #Unmapped address 0xe79 testing: random write/read operations
    #Address 0xe79 read value
    csrr x14, 0xe79

    #Address 0xe79 read value
    csrr x14, 0xe79

    #Address 0xe79 Write value 0xe99debd7
    li x3, 0xe99debd7
    csrw 0xe79, x3

    #Address 0xe79 read value
    csrr x14, 0xe79

    #Unmapped address 0x8f3 testing: random write/read operations
    #Address 0x8f3 Write value 0x3e165df2
    li x3, 0x3e165df2
    csrw 0x8f3, x3

    #Address 0x8f3 read value
    csrr x14, 0x8f3

    #Address 0x8f3 read value
    csrr x14, 0x8f3

    #Address 0x8f3 Write value 0xf0e9054a
    li x3, 0xf0e9054a
    csrw 0x8f3, x3

    #Unmapped address 0xdc7 testing: random write/read operations
    #Address 0xdc7 read value
    csrr x14, 0xdc7

    #Unmapped address 0xe35 testing: random write/read operations
    #Address 0xe35 read value
    csrr x14, 0xe35

    #Address 0xe35 Write value 0xb3b67bef
    li x3, 0xb3b67bef
    csrw 0xe35, x3

    #Address 0xe35 Write value 0x8b759ce8
    li x3, 0x8b759ce8
    csrw 0xe35, x3

    #Unmapped address 0xd26 testing: random write/read operations
    #Address 0xd26 Write value 0x5b3e254c
    li x3, 0x5b3e254c
    csrw 0xd26, x3

    #Address 0xd26 read value
    csrr x14, 0xd26

    #Address 0xd26 Write value 0xd10997f1
    li x3, 0xd10997f1
    csrw 0xd26, x3

    #Address 0xd26 Write value 0x96efa8fa
    li x3, 0x96efa8fa
    csrw 0xd26, x3

    #Address 0xd26 read value
    csrr x14, 0xd26

    #Unmapped address 0xd7d testing: random write/read operations
    #Address 0xd7d read value
    csrr x14, 0xd7d

    #Address 0xd7d Write value 0xd921ad1d
    li x3, 0xd921ad1d
    csrw 0xd7d, x3

    #Address 0xd7d read value
    csrr x14, 0xd7d

    #Address 0xd7d Write value 0x42d73a14
    li x3, 0x42d73a14
    csrw 0xd7d, x3

    #Address 0xd7d read value
    csrr x14, 0xd7d

    #Unmapped address 0x763 testing: random write/read operations
    #Address 0x763 read value
    csrr x14, 0x763

    #Address 0x763 Write value 0x21c27d82
    li x3, 0x21c27d82
    csrw 0x763, x3

    #Address 0x763 Write value 0x57de11
    li x3, 0x57de11
    csrw 0x763, x3

    #Unmapped address 0x85 testing: random write/read operations
    #Address 0x85 read value
    csrr x14, 0x85

    #Unmapped address 0xb22 testing: random write/read operations
    #Address 0xb22 Write value 0xe6062e60
    li x3, 0xe6062e60
    csrw 0xb22, x3

    #Address 0xb22 Write value 0x1584b3e9
    li x3, 0x1584b3e9
    csrw 0xb22, x3

    #Address 0xb22 Write value 0x941d62dc
    li x3, 0x941d62dc
    csrw 0xb22, x3

    #Address 0xb22 Write value 0xc3815725
    li x3, 0xc3815725
    csrw 0xb22, x3

    #Address 0xb22 read value
    csrr x14, 0xb22

    #Unmapped address 0xb6f testing: random write/read operations
    #Address 0xb6f Write value 0xfd67da19
    li x3, 0xfd67da19
    csrw 0xb6f, x3

    #Address 0xb6f Write value 0xeed650f1
    li x3, 0xeed650f1
    csrw 0xb6f, x3

    #Unmapped address 0x86a testing: random write/read operations
    #Address 0x86a read value
    csrr x14, 0x86a

    #Address 0x86a read value
    csrr x14, 0x86a

    #Address 0x86a read value
    csrr x14, 0x86a

    #Address 0x86a read value
    csrr x14, 0x86a

    #Unmapped address 0xcd6 testing: random write/read operations
    #Address 0xcd6 read value
    csrr x14, 0xcd6

    #Address 0xcd6 read value
    csrr x14, 0xcd6

    #Address 0xcd6 read value
    csrr x14, 0xcd6

    #Address 0xcd6 Write value 0x6b1c04f4
    li x3, 0x6b1c04f4
    csrw 0xcd6, x3

    #Address 0xcd6 Write value 0x5b6486c1
    li x3, 0x5b6486c1
    csrw 0xcd6, x3

    #Unmapped address 0x52c testing: random write/read operations
    #Address 0x52c Write value 0x65c74e93
    li x3, 0x65c74e93
    csrw 0x52c, x3

    #Unmapped address 0x61c testing: random write/read operations
    #Address 0x61c Write value 0xaba5a940
    li x3, 0xaba5a940
    csrw 0x61c, x3

    #Address 0x61c read value
    csrr x14, 0x61c

    #Address 0x61c read value
    csrr x14, 0x61c

    #Address 0x61c read value
    csrr x14, 0x61c

    #Unmapped address 0x982 testing: random write/read operations
    #Address 0x982 Write value 0x356ffd68
    li x3, 0x356ffd68
    csrw 0x982, x3

    #Address 0x982 read value
    csrr x14, 0x982

    #Address 0x982 Write value 0x2da32c79
    li x3, 0x2da32c79
    csrw 0x982, x3

    #Address 0x982 Write value 0x445fe12d
    li x3, 0x445fe12d
    csrw 0x982, x3

    #Unmapped address 0xc3f testing: random write/read operations
    #Address 0xc3f Write value 0x9c189950
    li x3, 0x9c189950
    csrw 0xc3f, x3

    #Address 0xc3f read value
    csrr x14, 0xc3f

    #Unmapped address 0x1b8 testing: random write/read operations
    #Address 0x1b8 Write value 0xc7ac3b5e
    li x3, 0xc7ac3b5e
    csrw 0x1b8, x3

    #Address 0x1b8 Write value 0x600f5feb
    li x3, 0x600f5feb
    csrw 0x1b8, x3

    #Unmapped address 0xe1b testing: random write/read operations
    #Address 0xe1b read value
    csrr x14, 0xe1b

    #Address 0xe1b Write value 0x70530ead
    li x3, 0x70530ead
    csrw 0xe1b, x3

    #Address 0xe1b read value
    csrr x14, 0xe1b

    #Unmapped address 0x6e8 testing: random write/read operations
    #Address 0x6e8 read value
    csrr x14, 0x6e8

    #Unmapped address 0xdd testing: random write/read operations
    #Address 0xdd read value
    csrr x14, 0xdd

    #Address 0xdd Write value 0x17017f55
    li x3, 0x17017f55
    csrw 0xdd, x3

    #Address 0xdd read value
    csrr x14, 0xdd

    #Address 0xdd Write value 0x5d35a841
    li x3, 0x5d35a841
    csrw 0xdd, x3

    #Address 0xdd Write value 0x3f2d08cf
    li x3, 0x3f2d08cf
    csrw 0xdd, x3

    #Unmapped address 0xb69 testing: random write/read operations
    #Address 0xb69 Write value 0x66d74639
    li x3, 0x66d74639
    csrw 0xb69, x3

    #Address 0xb69 read value
    csrr x14, 0xb69

    #Address 0xb69 read value
    csrr x14, 0xb69

    #Address 0xb69 read value
    csrr x14, 0xb69

    #Unmapped address 0x5cb testing: random write/read operations
    #Address 0x5cb read value
    csrr x14, 0x5cb

    #Address 0x5cb read value
    csrr x14, 0x5cb

    #Address 0x5cb Write value 0x56bd200f
    li x3, 0x56bd200f
    csrw 0x5cb, x3

    #Unmapped address 0x4d1 testing: random write/read operations
    #Address 0x4d1 read value
    csrr x14, 0x4d1

    #Unmapped address 0xfd testing: random write/read operations
    #Address 0xfd read value
    csrr x14, 0xfd

    #Address 0xfd Write value 0xd0a661da
    li x3, 0xd0a661da
    csrw 0xfd, x3

    #Unmapped address 0xb5b testing: random write/read operations
    #Address 0xb5b read value
    csrr x14, 0xb5b

    #Address 0xb5b read value
    csrr x14, 0xb5b

    #Address 0xb5b Write value 0x5ab5b7e4
    li x3, 0x5ab5b7e4
    csrw 0xb5b, x3

    #Address 0xb5b read value
    csrr x14, 0xb5b

    #Address 0xb5b read value
    csrr x14, 0xb5b

    #Unmapped address 0xa14 testing: random write/read operations
    #Address 0xa14 Write value 0xc10efd4b
    li x3, 0xc10efd4b
    csrw 0xa14, x3

    #Address 0xa14 read value
    csrr x14, 0xa14

    #Address 0xa14 read value
    csrr x14, 0xa14

    #Unmapped address 0x928 testing: random write/read operations
    #Address 0x928 read value
    csrr x14, 0x928

    #Address 0x928 read value
    csrr x14, 0x928

    #Address 0x928 read value
    csrr x14, 0x928

    #Address 0x928 Write value 0xa77a2e2b
    li x3, 0xa77a2e2b
    csrw 0x928, x3

    #Address 0x928 read value
    csrr x14, 0x928

    #Unmapped address 0x699 testing: random write/read operations
    #Address 0x699 Write value 0xc8db231c
    li x3, 0xc8db231c
    csrw 0x699, x3

    #Address 0x699 Write value 0x99de8300
    li x3, 0x99de8300
    csrw 0x699, x3

    #Address 0x699 read value
    csrr x14, 0x699

    #Address 0x699 read value
    csrr x14, 0x699

    #Address 0x699 Write value 0xe241b32c
    li x3, 0xe241b32c
    csrw 0x699, x3

    #Unmapped address 0xfa8 testing: random write/read operations
    #Address 0xfa8 read value
    csrr x14, 0xfa8

    #Unmapped address 0xbe1 testing: random write/read operations
    #Address 0xbe1 Write value 0xc907de11
    li x3, 0xc907de11
    csrw 0xbe1, x3

    #Address 0xbe1 Write value 0x2612314c
    li x3, 0x2612314c
    csrw 0xbe1, x3

    #Address 0xbe1 Write value 0x954bf0b3
    li x3, 0x954bf0b3
    csrw 0xbe1, x3

    #Address 0xbe1 Write value 0x607d362a
    li x3, 0x607d362a
    csrw 0xbe1, x3

    #Address 0xbe1 read value
    csrr x14, 0xbe1

    #Unmapped address 0xf2b testing: random write/read operations
    #Address 0xf2b Write value 0x40eb1e6c
    li x3, 0x40eb1e6c
    csrw 0xf2b, x3

    #Unmapped address 0x2ea testing: random write/read operations
    #Address 0x2ea Write value 0x139c371e
    li x3, 0x139c371e
    csrw 0x2ea, x3

    #Address 0x2ea read value
    csrr x14, 0x2ea

    #Unmapped address 0x37f testing: random write/read operations
    #Address 0x37f read value
    csrr x14, 0x37f

    #Unmapped address 0x1a testing: random write/read operations
    #Address 0x1a Write value 0x5855e3b1
    li x3, 0x5855e3b1
    csrw 0x1a, x3

    #Address 0x1a Write value 0xb3ca1e54
    li x3, 0xb3ca1e54
    csrw 0x1a, x3

    #Address 0x1a Write value 0xcb25538a
    li x3, 0xcb25538a
    csrw 0x1a, x3

    #Address 0x1a read value
    csrr x14, 0x1a

    #Address 0x1a Write value 0xbe106764
    li x3, 0xbe106764
    csrw 0x1a, x3

    #Unmapped address 0x9b4 testing: random write/read operations
    #Address 0x9b4 Write value 0x4dbea9fb
    li x3, 0x4dbea9fb
    csrw 0x9b4, x3

    #Address 0x9b4 Write value 0x8bef3f77
    li x3, 0x8bef3f77
    csrw 0x9b4, x3

    #Unmapped address 0x197 testing: random write/read operations
    #Address 0x197 Write value 0x6e74e234
    li x3, 0x6e74e234
    csrw 0x197, x3

    #Address 0x197 read value
    csrr x14, 0x197

    #Unmapped address 0x8f1 testing: random write/read operations
    #Address 0x8f1 read value
    csrr x14, 0x8f1

    #Unmapped address 0x296 testing: random write/read operations
    #Address 0x296 Write value 0x7e47e9e5
    li x3, 0x7e47e9e5
    csrw 0x296, x3

    #Address 0x296 read value
    csrr x14, 0x296

    #Address 0x296 Write value 0x28af070
    li x3, 0x28af070
    csrw 0x296, x3

    #Address 0x296 read value
    csrr x14, 0x296

    #Address 0x296 Write value 0xecb759c0
    li x3, 0xecb759c0
    csrw 0x296, x3

    #Unmapped address 0x54b testing: random write/read operations
    #Address 0x54b Write value 0xe1fda731
    li x3, 0xe1fda731
    csrw 0x54b, x3

    #Address 0x54b read value
    csrr x14, 0x54b

    #Unmapped address 0x361 testing: random write/read operations
    #Address 0x361 read value
    csrr x14, 0x361

    #Address 0x361 read value
    csrr x14, 0x361

    #Unmapped address 0xb6a testing: random write/read operations
    #Address 0xb6a read value
    csrr x14, 0xb6a

    #Unmapped address 0xa2d testing: random write/read operations
    #Address 0xa2d Write value 0x3f705072
    li x3, 0x3f705072
    csrw 0xa2d, x3

    #Address 0xa2d read value
    csrr x14, 0xa2d

    #Address 0xa2d Write value 0x923ac26a
    li x3, 0x923ac26a
    csrw 0xa2d, x3

    #Unmapped address 0xa95 testing: random write/read operations
    #Address 0xa95 read value
    csrr x14, 0xa95

    #Address 0xa95 Write value 0x90274887
    li x3, 0x90274887
    csrw 0xa95, x3

    #Address 0xa95 Write value 0xb7eaa5bf
    li x3, 0xb7eaa5bf
    csrw 0xa95, x3

    #Unmapped address 0xb4b testing: random write/read operations
    #Address 0xb4b read value
    csrr x14, 0xb4b

    #Address 0xb4b Write value 0x73e7788a
    li x3, 0x73e7788a
    csrw 0xb4b, x3

    #Address 0xb4b read value
    csrr x14, 0xb4b

    #Address 0xb4b read value
    csrr x14, 0xb4b

    #Unmapped address 0xf06 testing: random write/read operations
    #Address 0xf06 Write value 0x468d922
    li x3, 0x468d922
    csrw 0xf06, x3

    #Unmapped address 0x4b7 testing: random write/read operations
    #Address 0x4b7 read value
    csrr x14, 0x4b7

    #Address 0x4b7 read value
    csrr x14, 0x4b7

    #Address 0x4b7 read value
    csrr x14, 0x4b7

    #Address 0x4b7 read value
    csrr x14, 0x4b7

    #Address 0x4b7 Write value 0xe3a0bb60
    li x3, 0xe3a0bb60
    csrw 0x4b7, x3

    #Unmapped address 0xf49 testing: random write/read operations
    #Address 0xf49 read value
    csrr x14, 0xf49

    #Address 0xf49 read value
    csrr x14, 0xf49

    #Unmapped address 0xa25 testing: random write/read operations
    #Address 0xa25 Write value 0x15b76f01
    li x3, 0x15b76f01
    csrw 0xa25, x3

    #Address 0xa25 read value
    csrr x14, 0xa25

    #Unmapped address 0x99d testing: random write/read operations
    #Address 0x99d read value
    csrr x14, 0x99d

    #Address 0x99d read value
    csrr x14, 0x99d

    #Unmapped address 0x6fc testing: random write/read operations
    #Address 0x6fc read value
    csrr x14, 0x6fc

    #Address 0x6fc Write value 0x5de2751b
    li x3, 0x5de2751b
    csrw 0x6fc, x3

    #Address 0x6fc read value
    csrr x14, 0x6fc

    #Address 0x6fc read value
    csrr x14, 0x6fc

    #Address 0x6fc read value
    csrr x14, 0x6fc

    #Unmapped address 0xa8 testing: random write/read operations
    #Address 0xa8 read value
    csrr x14, 0xa8

    #Address 0xa8 Write value 0x33b02a68
    li x3, 0x33b02a68
    csrw 0xa8, x3

    #Unmapped address 0x938 testing: random write/read operations
    #Address 0x938 Write value 0x4a76079b
    li x3, 0x4a76079b
    csrw 0x938, x3

    #Address 0x938 Write value 0x81b87210
    li x3, 0x81b87210
    csrw 0x938, x3

    #Address 0x938 Write value 0x4c47114d
    li x3, 0x4c47114d
    csrw 0x938, x3

    #Address 0x938 read value
    csrr x14, 0x938

    #Unmapped address 0xe9b testing: random write/read operations
    #Address 0xe9b Write value 0xc8ef96a7
    li x3, 0xc8ef96a7
    csrw 0xe9b, x3

    #Address 0xe9b read value
    csrr x14, 0xe9b

    #Address 0xe9b Write value 0x701ae66c
    li x3, 0x701ae66c
    csrw 0xe9b, x3

    #Address 0xe9b Write value 0x5709cba
    li x3, 0x5709cba
    csrw 0xe9b, x3

    #Unmapped address 0xe11 testing: random write/read operations
    #Address 0xe11 Write value 0x1e2730c8
    li x3, 0x1e2730c8
    csrw 0xe11, x3

    #Unmapped address 0x9c testing: random write/read operations
    #Address 0x9c Write value 0x612bf57b
    li x3, 0x612bf57b
    csrw 0x9c, x3

    #Unmapped address 0x3d8 testing: random write/read operations
    #Address 0x3d8 Write value 0x6bebe112
    li x3, 0x6bebe112
    csrw 0x3d8, x3

    #Address 0x3d8 read value
    csrr x14, 0x3d8

    #Unmapped address 0x612 testing: random write/read operations
    #Address 0x612 read value
    csrr x14, 0x612

    #Address 0x612 read value
    csrr x14, 0x612

    #Address 0x612 Write value 0xe07b8c8a
    li x3, 0xe07b8c8a
    csrw 0x612, x3

    #Address 0x612 Write value 0xc5bd07a7
    li x3, 0xc5bd07a7
    csrw 0x612, x3

    #Address 0x612 read value
    csrr x14, 0x612

    #Unmapped address 0xa36 testing: random write/read operations
    #Address 0xa36 Write value 0xe91302e7
    li x3, 0xe91302e7
    csrw 0xa36, x3

    #Address 0xa36 read value
    csrr x14, 0xa36

    #Address 0xa36 Write value 0x60a2dd26
    li x3, 0x60a2dd26
    csrw 0xa36, x3

    #Address 0xa36 Write value 0x86a6042e
    li x3, 0x86a6042e
    csrw 0xa36, x3

    #Address 0xa36 Write value 0x646a39f5
    li x3, 0x646a39f5
    csrw 0xa36, x3

    #Unmapped address 0xde3 testing: random write/read operations
    #Address 0xde3 read value
    csrr x14, 0xde3

    #Address 0xde3 read value
    csrr x14, 0xde3

    #Address 0xde3 read value
    csrr x14, 0xde3

    #Unmapped address 0xd54 testing: random write/read operations
    #Address 0xd54 Write value 0x18ac4b03
    li x3, 0x18ac4b03
    csrw 0xd54, x3

    #Address 0xd54 Write value 0xa61523d1
    li x3, 0xa61523d1
    csrw 0xd54, x3

    #Address 0xd54 read value
    csrr x14, 0xd54

    #Unmapped address 0x1a0 testing: random write/read operations
    #Address 0x1a0 Write value 0xf0eece9d
    li x3, 0xf0eece9d
    csrw 0x1a0, x3

    #Address 0x1a0 read value
    csrr x14, 0x1a0

    #Address 0x1a0 read value
    csrr x14, 0x1a0

    #Address 0x1a0 read value
    csrr x14, 0x1a0

    #Unmapped address 0x7fc testing: random write/read operations
    #Address 0x7fc read value
    csrr x14, 0x7fc

    #Unmapped address 0x79d testing: random write/read operations
    #Address 0x79d Write value 0x34612945
    li x3, 0x34612945
    csrw 0x79d, x3

    #Address 0x79d read value
    csrr x14, 0x79d

    #Address 0x79d Write value 0x6545d640
    li x3, 0x6545d640
    csrw 0x79d, x3

    #Unmapped address 0xc1e testing: random write/read operations
    #Address 0xc1e Write value 0x8a190473
    li x3, 0x8a190473
    csrw 0xc1e, x3

    #Address 0xc1e read value
    csrr x14, 0xc1e

    #Address 0xc1e read value
    csrr x14, 0xc1e

    #Address 0xc1e read value
    csrr x14, 0xc1e

    #Unmapped address 0x1cc testing: random write/read operations
    #Address 0x1cc read value
    csrr x14, 0x1cc

    #Address 0x1cc read value
    csrr x14, 0x1cc

    #Address 0x1cc read value
    csrr x14, 0x1cc

    #Address 0x1cc Write value 0x972fc2cb
    li x3, 0x972fc2cb
    csrw 0x1cc, x3

    #Address 0x1cc Write value 0xda81f699
    li x3, 0xda81f699
    csrw 0x1cc, x3

    #Unmapped address 0x1bc testing: random write/read operations
    #Address 0x1bc read value
    csrr x14, 0x1bc

    #Address 0x1bc read value
    csrr x14, 0x1bc

    #Address 0x1bc read value
    csrr x14, 0x1bc

    #Address 0x1bc read value
    csrr x14, 0x1bc

    #Unmapped address 0xeb9 testing: random write/read operations
    #Address 0xeb9 Write value 0xe96c08ea
    li x3, 0xe96c08ea
    csrw 0xeb9, x3

    #Address 0xeb9 read value
    csrr x14, 0xeb9

    #Unmapped address 0x5a7 testing: random write/read operations
    #Address 0x5a7 Write value 0x78218c49
    li x3, 0x78218c49
    csrw 0x5a7, x3

    #Address 0x5a7 read value
    csrr x14, 0x5a7

    #Address 0x5a7 Write value 0xbcc68c88
    li x3, 0xbcc68c88
    csrw 0x5a7, x3

    #Address 0x5a7 Write value 0x86880b9c
    li x3, 0x86880b9c
    csrw 0x5a7, x3

    #Unmapped address 0xcad testing: random write/read operations
    #Address 0xcad Write value 0x9dc99083
    li x3, 0x9dc99083
    csrw 0xcad, x3

    #Address 0xcad read value
    csrr x14, 0xcad

    #Address 0xcad read value
    csrr x14, 0xcad

    #Address 0xcad read value
    csrr x14, 0xcad

    #Address 0xcad read value
    csrr x14, 0xcad

    #Unmapped address 0xdd9 testing: random write/read operations
    #Address 0xdd9 read value
    csrr x14, 0xdd9

    #Address 0xdd9 read value
    csrr x14, 0xdd9

    #Address 0xdd9 read value
    csrr x14, 0xdd9

    #Address 0xdd9 Write value 0x30d97798
    li x3, 0x30d97798
    csrw 0xdd9, x3

    #Unmapped address 0x838 testing: random write/read operations
    #Address 0x838 read value
    csrr x14, 0x838

    #Unmapped address 0x9e8 testing: random write/read operations
    #Address 0x9e8 Write value 0xec74a213
    li x3, 0xec74a213
    csrw 0x9e8, x3

    #Address 0x9e8 read value
    csrr x14, 0x9e8

    #Unmapped address 0xcfc testing: random write/read operations
    #Address 0xcfc read value
    csrr x14, 0xcfc

    #Address 0xcfc read value
    csrr x14, 0xcfc

    #Address 0xcfc Write value 0x7b39852b
    li x3, 0x7b39852b
    csrw 0xcfc, x3

    #Address 0xcfc Write value 0xabddaa7c
    li x3, 0xabddaa7c
    csrw 0xcfc, x3

    #Address 0xcfc read value
    csrr x14, 0xcfc

    #Unmapped address 0xe23 testing: random write/read operations
    #Address 0xe23 read value
    csrr x14, 0xe23

    #Unmapped address 0xfb testing: random write/read operations
    #Address 0xfb read value
    csrr x14, 0xfb

    #Address 0xfb Write value 0xd6ecdc62
    li x3, 0xd6ecdc62
    csrw 0xfb, x3

    #Address 0xfb Write value 0xbf9da16b
    li x3, 0xbf9da16b
    csrw 0xfb, x3

    #Address 0xfb read value
    csrr x14, 0xfb

    #Address 0xfb read value
    csrr x14, 0xfb

    #Unmapped address 0x42c testing: random write/read operations
    #Address 0x42c read value
    csrr x14, 0x42c

    #Address 0x42c Write value 0xc5f06b02
    li x3, 0xc5f06b02
    csrw 0x42c, x3

    #Unmapped address 0x5e6 testing: random write/read operations
    #Address 0x5e6 read value
    csrr x14, 0x5e6

    #Address 0x5e6 Write value 0x23781d69
    li x3, 0x23781d69
    csrw 0x5e6, x3

    #Address 0x5e6 read value
    csrr x14, 0x5e6

    #Address 0x5e6 read value
    csrr x14, 0x5e6

    #Address 0x5e6 read value
    csrr x14, 0x5e6

    #Unmapped address 0x39f testing: random write/read operations
    #Address 0x39f Write value 0x39658dbc
    li x3, 0x39658dbc
    csrw 0x39f, x3

    #Address 0x39f read value
    csrr x14, 0x39f

    #Address 0x39f Write value 0xb2814e80
    li x3, 0xb2814e80
    csrw 0x39f, x3

    #Address 0x39f read value
    csrr x14, 0x39f

    #Address 0x39f read value
    csrr x14, 0x39f

    #Unmapped address 0x860 testing: random write/read operations
    #Address 0x860 Write value 0xd5844df9
    li x3, 0xd5844df9
    csrw 0x860, x3

    #Address 0x860 read value
    csrr x14, 0x860

    #Address 0x860 read value
    csrr x14, 0x860

    #Address 0x860 read value
    csrr x14, 0x860

    #Unmapped address 0x1cb testing: random write/read operations
    #Address 0x1cb Write value 0x81effb15
    li x3, 0x81effb15
    csrw 0x1cb, x3

    #Address 0x1cb read value
    csrr x14, 0x1cb

    #Address 0x1cb Write value 0xcea5cd2e
    li x3, 0xcea5cd2e
    csrw 0x1cb, x3

    #Unmapped address 0x475 testing: random write/read operations
    #Address 0x475 Write value 0xaab6ccc
    li x3, 0xaab6ccc
    csrw 0x475, x3

    #Address 0x475 read value
    csrr x14, 0x475

    #Address 0x475 Write value 0x94a80459
    li x3, 0x94a80459
    csrw 0x475, x3

    #Address 0x475 Write value 0x16fffeb0
    li x3, 0x16fffeb0
    csrw 0x475, x3

    #Unmapped address 0x859 testing: random write/read operations
    #Address 0x859 read value
    csrr x14, 0x859

    #Address 0x859 read value
    csrr x14, 0x859

    #Unmapped address 0x5d9 testing: random write/read operations
    #Address 0x5d9 read value
    csrr x14, 0x5d9

    #Address 0x5d9 read value
    csrr x14, 0x5d9

    #Unmapped address 0xe50 testing: random write/read operations
    #Address 0xe50 read value
    csrr x14, 0xe50

    #Unmapped address 0xac7 testing: random write/read operations
    #Address 0xac7 read value
    csrr x14, 0xac7

    #Address 0xac7 Write value 0xf28a60b
    li x3, 0xf28a60b
    csrw 0xac7, x3

    #Unmapped address 0xdcd testing: random write/read operations
    #Address 0xdcd Write value 0x101541a
    li x3, 0x101541a
    csrw 0xdcd, x3

    #Address 0xdcd Write value 0x4d4216e5
    li x3, 0x4d4216e5
    csrw 0xdcd, x3

    #Unmapped address 0x8c4 testing: random write/read operations
    #Address 0x8c4 read value
    csrr x14, 0x8c4

    #Address 0x8c4 Write value 0x9dfefbe4
    li x3, 0x9dfefbe4
    csrw 0x8c4, x3

    #Unmapped address 0x3d5 testing: random write/read operations
    #Address 0x3d5 read value
    csrr x14, 0x3d5

    #Address 0x3d5 read value
    csrr x14, 0x3d5

    #Address 0x3d5 Write value 0x16851882
    li x3, 0x16851882
    csrw 0x3d5, x3

    #Address 0x3d5 read value
    csrr x14, 0x3d5

    #Address 0x3d5 Write value 0x69687b3a
    li x3, 0x69687b3a
    csrw 0x3d5, x3

    #Unmapped address 0x84 testing: random write/read operations
    #Address 0x84 Write value 0x6011533
    li x3, 0x6011533
    csrw 0x84, x3

    #Address 0x84 Write value 0x29b0aedc
    li x3, 0x29b0aedc
    csrw 0x84, x3

    #Address 0x84 Write value 0xd58a2dd3
    li x3, 0xd58a2dd3
    csrw 0x84, x3

    #Unmapped address 0x694 testing: random write/read operations
    #Address 0x694 Write value 0x4865d0cf
    li x3, 0x4865d0cf
    csrw 0x694, x3

    #Address 0x694 Write value 0x37ee7786
    li x3, 0x37ee7786
    csrw 0x694, x3

    #Address 0x694 read value
    csrr x14, 0x694

    #Address 0x694 read value
    csrr x14, 0x694

    #Address 0x694 read value
    csrr x14, 0x694

    #Unmapped address 0x2bd testing: random write/read operations
    #Address 0x2bd Write value 0xc4e12ad2
    li x3, 0xc4e12ad2
    csrw 0x2bd, x3

    #Address 0x2bd read value
    csrr x14, 0x2bd

    #Unmapped address 0x8f4 testing: random write/read operations
    #Address 0x8f4 read value
    csrr x14, 0x8f4

    #Address 0x8f4 read value
    csrr x14, 0x8f4

    #Address 0x8f4 read value
    csrr x14, 0x8f4

    #Address 0x8f4 read value
    csrr x14, 0x8f4

    #Address 0x8f4 Write value 0x553b83ad
    li x3, 0x553b83ad
    csrw 0x8f4, x3

    #Unmapped address 0xee9 testing: random write/read operations
    #Address 0xee9 Write value 0xe7cc157b
    li x3, 0xe7cc157b
    csrw 0xee9, x3

    #Address 0xee9 Write value 0x5f11d8d6
    li x3, 0x5f11d8d6
    csrw 0xee9, x3

    #Unmapped address 0xeb testing: random write/read operations
    #Address 0xeb Write value 0x99145371
    li x3, 0x99145371
    csrw 0xeb, x3

    #Address 0xeb Write value 0xe18b7cc8
    li x3, 0xe18b7cc8
    csrw 0xeb, x3

    #Address 0xeb read value
    csrr x14, 0xeb

    #Address 0xeb Write value 0x5ff126ac
    li x3, 0x5ff126ac
    csrw 0xeb, x3

    #Unmapped address 0x374 testing: random write/read operations
    #Address 0x374 Write value 0xa3a1a412
    li x3, 0xa3a1a412
    csrw 0x374, x3

    #Address 0x374 read value
    csrr x14, 0x374

    #Address 0x374 read value
    csrr x14, 0x374

    #Address 0x374 read value
    csrr x14, 0x374

    #Unmapped address 0xde0 testing: random write/read operations
    #Address 0xde0 read value
    csrr x14, 0xde0

    #Address 0xde0 read value
    csrr x14, 0xde0

    #Address 0xde0 Write value 0xc8c36df5
    li x3, 0xc8c36df5
    csrw 0xde0, x3

    #Unmapped address 0x173 testing: random write/read operations
    #Address 0x173 Write value 0xa425ba4e
    li x3, 0xa425ba4e
    csrw 0x173, x3

    #Address 0x173 read value
    csrr x14, 0x173

    #Address 0x173 Write value 0x264e8fea
    li x3, 0x264e8fea
    csrw 0x173, x3

    #Address 0x173 read value
    csrr x14, 0x173

    #Unmapped address 0x793 testing: random write/read operations
    #Address 0x793 Write value 0x111a9349
    li x3, 0x111a9349
    csrw 0x793, x3

    #Unmapped address 0x3f7 testing: random write/read operations
    #Address 0x3f7 read value
    csrr x14, 0x3f7

    #Address 0x3f7 read value
    csrr x14, 0x3f7

    #Address 0x3f7 Write value 0x42882b42
    li x3, 0x42882b42
    csrw 0x3f7, x3

    #Address 0x3f7 read value
    csrr x14, 0x3f7

    #Address 0x3f7 read value
    csrr x14, 0x3f7

    #Unmapped address 0x3d4 testing: random write/read operations
    #Address 0x3d4 Write value 0xddf51a93
    li x3, 0xddf51a93
    csrw 0x3d4, x3

    #Address 0x3d4 read value
    csrr x14, 0x3d4

    #Address 0x3d4 Write value 0x84b9ec40
    li x3, 0x84b9ec40
    csrw 0x3d4, x3

    #Address 0x3d4 read value
    csrr x14, 0x3d4

    #Unmapped address 0x267 testing: random write/read operations
    #Address 0x267 Write value 0x991f6d3f
    li x3, 0x991f6d3f
    csrw 0x267, x3

    #Address 0x267 Write value 0x7eb12b33
    li x3, 0x7eb12b33
    csrw 0x267, x3

    #Address 0x267 read value
    csrr x14, 0x267

    #Address 0x267 read value
    csrr x14, 0x267

    #Unmapped address 0x9fb testing: random write/read operations
    #Address 0x9fb read value
    csrr x14, 0x9fb

    #Address 0x9fb Write value 0x3fab06ca
    li x3, 0x3fab06ca
    csrw 0x9fb, x3

    #Unmapped address 0x14d testing: random write/read operations
    #Address 0x14d read value
    csrr x14, 0x14d

    #Address 0x14d Write value 0x9dd98f7a
    li x3, 0x9dd98f7a
    csrw 0x14d, x3

    #Address 0x14d read value
    csrr x14, 0x14d

    #Unmapped address 0x195 testing: random write/read operations
    #Address 0x195 Write value 0x68ec3e27
    li x3, 0x68ec3e27
    csrw 0x195, x3

    #Unmapped address 0xf6f testing: random write/read operations
    #Address 0xf6f read value
    csrr x14, 0xf6f

    #Unmapped address 0x51d testing: random write/read operations
    #Address 0x51d Write value 0xddd924fa
    li x3, 0xddd924fa
    csrw 0x51d, x3

    #Unmapped address 0x122 testing: random write/read operations
    #Address 0x122 Write value 0xc904e322
    li x3, 0xc904e322
    csrw 0x122, x3

    #Address 0x122 Write value 0xea294634
    li x3, 0xea294634
    csrw 0x122, x3

    #Unmapped address 0x7dd testing: random write/read operations
    #Address 0x7dd Write value 0x9d2c0825
    li x3, 0x9d2c0825
    csrw 0x7dd, x3

    #Address 0x7dd Write value 0x6f6e98e4
    li x3, 0x6f6e98e4
    csrw 0x7dd, x3

    #Address 0x7dd read value
    csrr x14, 0x7dd

    #Address 0x7dd Write value 0xe81ae185
    li x3, 0xe81ae185
    csrw 0x7dd, x3

    #Address 0x7dd Write value 0xcf2dab4c
    li x3, 0xcf2dab4c
    csrw 0x7dd, x3

    #Unmapped address 0xd9 testing: random write/read operations
    #Address 0xd9 Write value 0x35ceec4f
    li x3, 0x35ceec4f
    csrw 0xd9, x3

    #Unmapped address 0x58e testing: random write/read operations
    #Address 0x58e read value
    csrr x14, 0x58e

    #Unmapped address 0x4ef testing: random write/read operations
    #Address 0x4ef read value
    csrr x14, 0x4ef

    #Unmapped address 0x1ab testing: random write/read operations
    #Address 0x1ab Write value 0xebe7dd34
    li x3, 0xebe7dd34
    csrw 0x1ab, x3

    #Address 0x1ab Write value 0x1791734
    li x3, 0x1791734
    csrw 0x1ab, x3

    #Address 0x1ab read value
    csrr x14, 0x1ab

    #Unmapped address 0x11b testing: random write/read operations
    #Address 0x11b Write value 0x67bda107
    li x3, 0x67bda107
    csrw 0x11b, x3

    #Address 0x11b Write value 0x504a0f7e
    li x3, 0x504a0f7e
    csrw 0x11b, x3

    #Address 0x11b read value
    csrr x14, 0x11b

    #Address 0x11b Write value 0x6d746915
    li x3, 0x6d746915
    csrw 0x11b, x3

    #Address 0x11b read value
    csrr x14, 0x11b

    #Unmapped address 0xb3b testing: random write/read operations
    #Address 0xb3b Write value 0x609f804
    li x3, 0x609f804
    csrw 0xb3b, x3

    #Address 0xb3b Write value 0x38cd1e50
    li x3, 0x38cd1e50
    csrw 0xb3b, x3

    #Address 0xb3b Write value 0x23ac4365
    li x3, 0x23ac4365
    csrw 0xb3b, x3

    #Address 0xb3b read value
    csrr x14, 0xb3b

    #Unmapped address 0x36c testing: random write/read operations
    #Address 0x36c read value
    csrr x14, 0x36c

    #Address 0x36c Write value 0x70959bf5
    li x3, 0x70959bf5
    csrw 0x36c, x3

    #Unmapped address 0xd4c testing: random write/read operations
    #Address 0xd4c Write value 0xfe1ed3b6
    li x3, 0xfe1ed3b6
    csrw 0xd4c, x3

    #Address 0xd4c read value
    csrr x14, 0xd4c

    #Address 0xd4c read value
    csrr x14, 0xd4c

    #Address 0xd4c Write value 0x889b5a5d
    li x3, 0x889b5a5d
    csrw 0xd4c, x3

    #Unmapped address 0xe70 testing: random write/read operations
    #Address 0xe70 Write value 0x43fc0349
    li x3, 0x43fc0349
    csrw 0xe70, x3

    #Address 0xe70 read value
    csrr x14, 0xe70

    #Unmapped address 0xe75 testing: random write/read operations
    #Address 0xe75 read value
    csrr x14, 0xe75

    #Address 0xe75 Write value 0x6b67e5f6
    li x3, 0x6b67e5f6
    csrw 0xe75, x3

    #Address 0xe75 read value
    csrr x14, 0xe75

    #Unmapped address 0xa98 testing: random write/read operations
    #Address 0xa98 Write value 0x46f78116
    li x3, 0x46f78116
    csrw 0xa98, x3

    #Address 0xa98 read value
    csrr x14, 0xa98

    #Address 0xa98 read value
    csrr x14, 0xa98

    #Address 0xa98 Write value 0x2f84d8f
    li x3, 0x2f84d8f
    csrw 0xa98, x3

    #Address 0xa98 read value
    csrr x14, 0xa98

    #Unmapped address 0xab1 testing: random write/read operations
    #Address 0xab1 Write value 0x7c0c6ceb
    li x3, 0x7c0c6ceb
    csrw 0xab1, x3

    #Address 0xab1 Write value 0x7864b918
    li x3, 0x7864b918
    csrw 0xab1, x3

    #Address 0xab1 read value
    csrr x14, 0xab1

    #Unmapped address 0x3d7 testing: random write/read operations
    #Address 0x3d7 Write value 0xc51e049a
    li x3, 0xc51e049a
    csrw 0x3d7, x3

    #Address 0x3d7 read value
    csrr x14, 0x3d7

    #Address 0x3d7 Write value 0x1f3d5d41
    li x3, 0x1f3d5d41
    csrw 0x3d7, x3

    #Unmapped address 0x595 testing: random write/read operations
    #Address 0x595 Write value 0xcb3f0f51
    li x3, 0xcb3f0f51
    csrw 0x595, x3

    #Unmapped address 0x625 testing: random write/read operations
    #Address 0x625 Write value 0x8f93f914
    li x3, 0x8f93f914
    csrw 0x625, x3

    #Address 0x625 read value
    csrr x14, 0x625

    #Unmapped address 0xa28 testing: random write/read operations
    #Address 0xa28 Write value 0xde29c200
    li x3, 0xde29c200
    csrw 0xa28, x3

    #Address 0xa28 read value
    csrr x14, 0xa28

    #Address 0xa28 Write value 0xa3475ca5
    li x3, 0xa3475ca5
    csrw 0xa28, x3

    #Address 0xa28 Write value 0xae865270
    li x3, 0xae865270
    csrw 0xa28, x3

    #Address 0xa28 read value
    csrr x14, 0xa28

    #Unmapped address 0xded testing: random write/read operations
    #Address 0xded read value
    csrr x14, 0xded

    #Address 0xded Write value 0x541841e2
    li x3, 0x541841e2
    csrw 0xded, x3

    #Unmapped address 0xfc2 testing: random write/read operations
    #Address 0xfc2 Write value 0x7a63a5e8
    li x3, 0x7a63a5e8
    csrw 0xfc2, x3

    #Address 0xfc2 Write value 0x75d2f3d7
    li x3, 0x75d2f3d7
    csrw 0xfc2, x3

    #Address 0xfc2 read value
    csrr x14, 0xfc2

    #Address 0xfc2 read value
    csrr x14, 0xfc2

    #Unmapped address 0xd46 testing: random write/read operations
    #Address 0xd46 Write value 0xf1d02aa0
    li x3, 0xf1d02aa0
    csrw 0xd46, x3

    #Address 0xd46 read value
    csrr x14, 0xd46

    #Address 0xd46 Write value 0x87e536fb
    li x3, 0x87e536fb
    csrw 0xd46, x3

    #Address 0xd46 read value
    csrr x14, 0xd46

    #Unmapped address 0x956 testing: random write/read operations
    #Address 0x956 Write value 0x13261cfa
    li x3, 0x13261cfa
    csrw 0x956, x3

    #Unmapped address 0xa9f testing: random write/read operations
    #Address 0xa9f read value
    csrr x14, 0xa9f

    #Address 0xa9f Write value 0xd6d46074
    li x3, 0xd6d46074
    csrw 0xa9f, x3

    #Address 0xa9f read value
    csrr x14, 0xa9f

    #Address 0xa9f Write value 0xbd337be
    li x3, 0xbd337be
    csrw 0xa9f, x3

    #Unmapped address 0x543 testing: random write/read operations
    #Address 0x543 read value
    csrr x14, 0x543

    #Address 0x543 read value
    csrr x14, 0x543

    #Address 0x543 Write value 0xdbff34f6
    li x3, 0xdbff34f6
    csrw 0x543, x3

    #Address 0x543 Write value 0x2740dd53
    li x3, 0x2740dd53
    csrw 0x543, x3

    #Unmapped address 0x245 testing: random write/read operations
    #Address 0x245 read value
    csrr x14, 0x245

    #Address 0x245 read value
    csrr x14, 0x245

    #Address 0x245 Write value 0xda871881
    li x3, 0xda871881
    csrw 0x245, x3

    #Unmapped address 0x8fe testing: random write/read operations
    #Address 0x8fe read value
    csrr x14, 0x8fe

    #Address 0x8fe read value
    csrr x14, 0x8fe

    #Address 0x8fe read value
    csrr x14, 0x8fe

    #Address 0x8fe read value
    csrr x14, 0x8fe

    #Address 0x8fe read value
    csrr x14, 0x8fe

    #Unmapped address 0x754 testing: random write/read operations
    #Address 0x754 Write value 0x6c28a7c2
    li x3, 0x6c28a7c2
    csrw 0x754, x3

    #Address 0x754 Write value 0xb2b65bf6
    li x3, 0xb2b65bf6
    csrw 0x754, x3

    #Address 0x754 Write value 0x21ff3574
    li x3, 0x21ff3574
    csrw 0x754, x3

    #Address 0x754 read value
    csrr x14, 0x754

    #Unmapped address 0xf02 testing: random write/read operations
    #Address 0xf02 Write value 0xd41115f3
    li x3, 0xd41115f3
    csrw 0xf02, x3

    #Address 0xf02 read value
    csrr x14, 0xf02

    #Address 0xf02 Write value 0xc4aef55c
    li x3, 0xc4aef55c
    csrw 0xf02, x3

    #Unmapped address 0x46f testing: random write/read operations
    #Address 0x46f read value
    csrr x14, 0x46f

    #Unmapped address 0x40a testing: random write/read operations
    #Address 0x40a Write value 0xbbf1a663
    li x3, 0xbbf1a663
    csrw 0x40a, x3

    #Address 0x40a Write value 0xb44d4465
    li x3, 0xb44d4465
    csrw 0x40a, x3

    #Unmapped address 0x6c5 testing: random write/read operations
    #Address 0x6c5 Write value 0x8c8b731
    li x3, 0x8c8b731
    csrw 0x6c5, x3

    #Address 0x6c5 read value
    csrr x14, 0x6c5

    #Address 0x6c5 read value
    csrr x14, 0x6c5

    #Address 0x6c5 read value
    csrr x14, 0x6c5

    #Address 0x6c5 Write value 0x9d4194f4
    li x3, 0x9d4194f4
    csrw 0x6c5, x3

    #Mapped address 0xb86 (mhpmcounterh6) testing: random write/read operations
    #Address 0xb86 read value
    csrr x14, 0xb86

    #Address 0xb86 Write value 0x43b8bf63
    li x3, 0x43b8bf63
    csrw 0xb86, x3

    #Unmapped address 0x72 testing: random write/read operations
    #Address 0x72 Write value 0x614e66d6
    li x3, 0x614e66d6
    csrw 0x72, x3

    #Address 0x72 read value
    csrr x14, 0x72

    #Address 0x72 Write value 0x7bf6ad47
    li x3, 0x7bf6ad47
    csrw 0x72, x3

    #Address 0x72 read value
    csrr x14, 0x72

    #Address 0x72 Write value 0x78c1f63e
    li x3, 0x78c1f63e
    csrw 0x72, x3

    #Unmapped address 0x462 testing: random write/read operations
    #Address 0x462 read value
    csrr x14, 0x462

    #Address 0x462 Write value 0x531e55e8
    li x3, 0x531e55e8
    csrw 0x462, x3

    #Address 0x462 Write value 0x29cb3e8c
    li x3, 0x29cb3e8c
    csrw 0x462, x3

    #Address 0x462 read value
    csrr x14, 0x462

    #Unmapped address 0x14a testing: random write/read operations
    #Address 0x14a read value
    csrr x14, 0x14a

    #Address 0x14a read value
    csrr x14, 0x14a

    #Unmapped address 0x1ed testing: random write/read operations
    #Address 0x1ed read value
    csrr x14, 0x1ed

    #Unmapped address 0x4d3 testing: random write/read operations
    #Address 0x4d3 Write value 0xa728526f
    li x3, 0xa728526f
    csrw 0x4d3, x3

    #Unmapped address 0x7ac testing: random write/read operations
    #Address 0x7ac read value
    csrr x14, 0x7ac

    #Unmapped address 0x716 testing: random write/read operations
    #Address 0x716 Write value 0x256d37df
    li x3, 0x256d37df
    csrw 0x716, x3

    #Unmapped address 0xb2 testing: random write/read operations
    #Address 0xb2 Write value 0xf00f601f
    li x3, 0xf00f601f
    csrw 0xb2, x3

    #Unmapped address 0xa05 testing: random write/read operations
    #Address 0xa05 read value
    csrr x14, 0xa05

    #Address 0xa05 Write value 0x2b0a8d9c
    li x3, 0x2b0a8d9c
    csrw 0xa05, x3

    #Address 0xa05 read value
    csrr x14, 0xa05

    #Address 0xa05 Write value 0xe2a28b34
    li x3, 0xe2a28b34
    csrw 0xa05, x3

    #Address 0xa05 Write value 0x4ef5a053
    li x3, 0x4ef5a053
    csrw 0xa05, x3

    #Unmapped address 0x35d testing: random write/read operations
    #Address 0x35d read value
    csrr x14, 0x35d

    #Address 0x35d read value
    csrr x14, 0x35d

    #Address 0x35d Write value 0xa1e7b5b8
    li x3, 0xa1e7b5b8
    csrw 0x35d, x3

    #Address 0x35d Write value 0x8c963f64
    li x3, 0x8c963f64
    csrw 0x35d, x3

    #Unmapped address 0x13a testing: random write/read operations
    #Address 0x13a read value
    csrr x14, 0x13a

    #Address 0x13a Write value 0x11870d3d
    li x3, 0x11870d3d
    csrw 0x13a, x3

    #Address 0x13a Write value 0xd3029e65
    li x3, 0xd3029e65
    csrw 0x13a, x3

    #Address 0x13a read value
    csrr x14, 0x13a

    #Address 0x13a Write value 0xf591c17
    li x3, 0xf591c17
    csrw 0x13a, x3

    #Unmapped address 0xbd testing: random write/read operations
    #Address 0xbd Write value 0x613513b5
    li x3, 0x613513b5
    csrw 0xbd, x3

    #Unmapped address 0x8f9 testing: random write/read operations
    #Address 0x8f9 read value
    csrr x14, 0x8f9

    #Unmapped address 0xd13 testing: random write/read operations
    #Address 0xd13 read value
    csrr x14, 0xd13

    #Address 0xd13 read value
    csrr x14, 0xd13

    #Address 0xd13 Write value 0x2e6e7def
    li x3, 0x2e6e7def
    csrw 0xd13, x3

    #Address 0xd13 Write value 0x691d0c6a
    li x3, 0x691d0c6a
    csrw 0xd13, x3

    #Unmapped address 0xcf1 testing: random write/read operations
    #Address 0xcf1 Write value 0xd6cf2216
    li x3, 0xd6cf2216
    csrw 0xcf1, x3

    #Address 0xcf1 Write value 0x6fe88084
    li x3, 0x6fe88084
    csrw 0xcf1, x3

    #Address 0xcf1 read value
    csrr x14, 0xcf1

    #Address 0xcf1 Write value 0x43768c8f
    li x3, 0x43768c8f
    csrw 0xcf1, x3

    #Address 0xcf1 Write value 0xebf8e9c7
    li x3, 0xebf8e9c7
    csrw 0xcf1, x3

    #Unmapped address 0xb24 testing: random write/read operations
    #Address 0xb24 Write value 0x64c71959
    li x3, 0x64c71959
    csrw 0xb24, x3

    #Address 0xb24 Write value 0x7bfb083c
    li x3, 0x7bfb083c
    csrw 0xb24, x3

    #Address 0xb24 read value
    csrr x14, 0xb24

    #Address 0xb24 read value
    csrr x14, 0xb24

    #Unmapped address 0x63b testing: random write/read operations
    #Address 0x63b Write value 0x12c1110d
    li x3, 0x12c1110d
    csrw 0x63b, x3

    #Address 0x63b Write value 0x6c51153d
    li x3, 0x6c51153d
    csrw 0x63b, x3

    #Unmapped address 0xdfb testing: random write/read operations
    #Address 0xdfb Write value 0xa169d6ad
    li x3, 0xa169d6ad
    csrw 0xdfb, x3

    #Address 0xdfb Write value 0xbb3a80c9
    li x3, 0xbb3a80c9
    csrw 0xdfb, x3

    #Unmapped address 0x54a testing: random write/read operations
    #Address 0x54a read value
    csrr x14, 0x54a

    #Unmapped address 0xe16 testing: random write/read operations
    #Address 0xe16 read value
    csrr x14, 0xe16

    #Unmapped address 0xfc6 testing: random write/read operations
    #Address 0xfc6 Write value 0xf8e721e0
    li x3, 0xf8e721e0
    csrw 0xfc6, x3

    #Unmapped address 0x4e3 testing: random write/read operations
    #Address 0x4e3 read value
    csrr x14, 0x4e3

    #Address 0x4e3 read value
    csrr x14, 0x4e3

    #Unmapped address 0xc84 testing: random write/read operations
    #Address 0xc84 Write value 0xa5b0dfe2
    li x3, 0xa5b0dfe2
    csrw 0xc84, x3

    #Unmapped address 0xa77 testing: random write/read operations
    #Address 0xa77 read value
    csrr x14, 0xa77

    #Address 0xa77 read value
    csrr x14, 0xa77

    #Address 0xa77 Write value 0x4d5b0025
    li x3, 0x4d5b0025
    csrw 0xa77, x3

    #Address 0xa77 Write value 0xf547db2
    li x3, 0xf547db2
    csrw 0xa77, x3

    #Unmapped address 0xdea testing: random write/read operations
    #Address 0xdea Write value 0xa8c5200f
    li x3, 0xa8c5200f
    csrw 0xdea, x3

    #Address 0xdea read value
    csrr x14, 0xdea

    #Address 0xdea read value
    csrr x14, 0xdea

    #Address 0xdea Write value 0x92dc63dd
    li x3, 0x92dc63dd
    csrw 0xdea, x3

    #Address 0xdea read value
    csrr x14, 0xdea

    #Unmapped address 0xc9 testing: random write/read operations
    #Address 0xc9 Write value 0xf319df8b
    li x3, 0xf319df8b
    csrw 0xc9, x3

    #Address 0xc9 Write value 0xb254a989
    li x3, 0xb254a989
    csrw 0xc9, x3

    #Address 0xc9 read value
    csrr x14, 0xc9

    #Unmapped address 0xe4a testing: random write/read operations
    #Address 0xe4a Write value 0x18ef3d95
    li x3, 0x18ef3d95
    csrw 0xe4a, x3

    #Address 0xe4a Write value 0xe95214a
    li x3, 0xe95214a
    csrw 0xe4a, x3

    #Address 0xe4a read value
    csrr x14, 0xe4a

    #Address 0xe4a read value
    csrr x14, 0xe4a

    #Unmapped address 0xab6 testing: random write/read operations
    #Address 0xab6 read value
    csrr x14, 0xab6

    #Address 0xab6 Write value 0x9123a9e0
    li x3, 0x9123a9e0
    csrw 0xab6, x3

    #Address 0xab6 read value
    csrr x14, 0xab6

    #Address 0xab6 Write value 0xcbe15397
    li x3, 0xcbe15397
    csrw 0xab6, x3

    #Unmapped address 0xee3 testing: random write/read operations
    #Address 0xee3 Write value 0xf5e6a435
    li x3, 0xf5e6a435
    csrw 0xee3, x3

    #Address 0xee3 Write value 0x680f1413
    li x3, 0x680f1413
    csrw 0xee3, x3

    #Unmapped address 0xf89 testing: random write/read operations
    #Address 0xf89 read value
    csrr x14, 0xf89

    #Unmapped address 0xcf8 testing: random write/read operations
    #Address 0xcf8 Write value 0xf7f6313d
    li x3, 0xf7f6313d
    csrw 0xcf8, x3

    #Unmapped address 0xc43 testing: random write/read operations
    #Address 0xc43 Write value 0x5b71f143
    li x3, 0x5b71f143
    csrw 0xc43, x3

    #Address 0xc43 read value
    csrr x14, 0xc43

    #Unmapped address 0x3d3 testing: random write/read operations
    #Address 0x3d3 read value
    csrr x14, 0x3d3

    #Address 0x3d3 read value
    csrr x14, 0x3d3

    #Address 0x3d3 Write value 0xa4e60afe
    li x3, 0xa4e60afe
    csrw 0x3d3, x3

    #Address 0x3d3 Write value 0xaa098b09
    li x3, 0xaa098b09
    csrw 0x3d3, x3

    #Unmapped address 0x19 testing: random write/read operations
    #Address 0x19 Write value 0x3ae45ee6
    li x3, 0x3ae45ee6
    csrw 0x19, x3

    #Address 0x19 Write value 0x15714f2b
    li x3, 0x15714f2b
    csrw 0x19, x3

    #Unmapped address 0xd61 testing: random write/read operations
    #Address 0xd61 Write value 0x530e2d9f
    li x3, 0x530e2d9f
    csrw 0xd61, x3

    #Address 0xd61 read value
    csrr x14, 0xd61

    #Unmapped address 0x2e1 testing: random write/read operations
    #Address 0x2e1 read value
    csrr x14, 0x2e1

    #Unmapped address 0x448 testing: random write/read operations
    #Address 0x448 read value
    csrr x14, 0x448

    #Address 0x448 Write value 0xbe5cf0a1
    li x3, 0xbe5cf0a1
    csrw 0x448, x3

    #Address 0x448 read value
    csrr x14, 0x448

    #Address 0x448 Write value 0xc4d7766c
    li x3, 0xc4d7766c
    csrw 0x448, x3

    #Address 0x448 Write value 0x2e333e64
    li x3, 0x2e333e64
    csrw 0x448, x3

    #Unmapped address 0x8d3 testing: random write/read operations
    #Address 0x8d3 Write value 0x8d72f4b7
    li x3, 0x8d72f4b7
    csrw 0x8d3, x3

    #Address 0x8d3 read value
    csrr x14, 0x8d3

    #Unmapped address 0xb4c testing: random write/read operations
    #Address 0xb4c Write value 0x675ddb8a
    li x3, 0x675ddb8a
    csrw 0xb4c, x3

    #Address 0xb4c Write value 0x22329067
    li x3, 0x22329067
    csrw 0xb4c, x3

    #Address 0xb4c Write value 0xd02a557d
    li x3, 0xd02a557d
    csrw 0xb4c, x3

    #Unmapped address 0xec5 testing: random write/read operations
    #Address 0xec5 Write value 0x6d14636d
    li x3, 0x6d14636d
    csrw 0xec5, x3

    #Address 0xec5 Write value 0xf8eea985
    li x3, 0xf8eea985
    csrw 0xec5, x3

    #Address 0xec5 read value
    csrr x14, 0xec5

    #Address 0xec5 read value
    csrr x14, 0xec5

    #Address 0xec5 Write value 0x3f620480
    li x3, 0x3f620480
    csrw 0xec5, x3

    #Unmapped address 0xaec testing: random write/read operations
    #Address 0xaec read value
    csrr x14, 0xaec

    #Address 0xaec read value
    csrr x14, 0xaec

    #Address 0xaec Write value 0xdbffe397
    li x3, 0xdbffe397
    csrw 0xaec, x3

    #Address 0xaec read value
    csrr x14, 0xaec

    #Address 0xaec Write value 0xefef8a60
    li x3, 0xefef8a60
    csrw 0xaec, x3

    #Unmapped address 0x232 testing: random write/read operations
    #Address 0x232 read value
    csrr x14, 0x232

    #Address 0x232 read value
    csrr x14, 0x232

    #Address 0x232 Write value 0xaff4b846
    li x3, 0xaff4b846
    csrw 0x232, x3

    #Address 0x232 read value
    csrr x14, 0x232

    #Address 0x232 read value
    csrr x14, 0x232

    #Unmapped address 0x2ff testing: random write/read operations
    #Address 0x2ff Write value 0xe1c4a480
    li x3, 0xe1c4a480
    csrw 0x2ff, x3

    #Address 0x2ff read value
    csrr x14, 0x2ff

    #Address 0x2ff Write value 0xcfef4b43
    li x3, 0xcfef4b43
    csrw 0x2ff, x3

    #Address 0x2ff Write value 0x72fa6e78
    li x3, 0x72fa6e78
    csrw 0x2ff, x3

    #Unmapped address 0x6ce testing: random write/read operations
    #Address 0x6ce Write value 0x955a7c04
    li x3, 0x955a7c04
    csrw 0x6ce, x3

    #Address 0x6ce Write value 0xc06951b1
    li x3, 0xc06951b1
    csrw 0x6ce, x3

    #Address 0x6ce Write value 0xa22535d
    li x3, 0xa22535d
    csrw 0x6ce, x3

    #Address 0x6ce Write value 0xe1c0cec6
    li x3, 0xe1c0cec6
    csrw 0x6ce, x3

    #Address 0x6ce read value
    csrr x14, 0x6ce

    #Mapped address 0x333 (mhpmevent19) testing: random write/read operations
    #Address 0x333 Write value 0x7ff116b5
    li x3, 0x7ff116b5
    csrw 0x333, x3

    #Address 0x333 Write value 0xa51accda
    li x3, 0xa51accda
    csrw 0x333, x3

    #Unmapped address 0x6b8 testing: random write/read operations
    #Address 0x6b8 read value
    csrr x14, 0x6b8

    #Address 0x6b8 Write value 0xe1abee9e
    li x3, 0xe1abee9e
    csrw 0x6b8, x3

    #Address 0x6b8 read value
    csrr x14, 0x6b8

    #Unmapped address 0x29b testing: random write/read operations
    #Address 0x29b read value
    csrr x14, 0x29b

    #Address 0x29b read value
    csrr x14, 0x29b

    #Address 0x29b Write value 0x99f939a4
    li x3, 0x99f939a4
    csrw 0x29b, x3

    #Unmapped address 0xa35 testing: random write/read operations
    #Address 0xa35 Write value 0xa8e186c
    li x3, 0xa8e186c
    csrw 0xa35, x3

    #Address 0xa35 read value
    csrr x14, 0xa35

    #Address 0xa35 Write value 0x3a9677d
    li x3, 0x3a9677d
    csrw 0xa35, x3

    #Address 0xa35 read value
    csrr x14, 0xa35

    #Unmapped address 0x25a testing: random write/read operations
    #Address 0x25a read value
    csrr x14, 0x25a

    #Address 0x25a read value
    csrr x14, 0x25a

    #Address 0x25a read value
    csrr x14, 0x25a

    #Address 0x25a read value
    csrr x14, 0x25a

    #Unmapped address 0x8cd testing: random write/read operations
    #Address 0x8cd Write value 0x871dff48
    li x3, 0x871dff48
    csrw 0x8cd, x3

    #Address 0x8cd read value
    csrr x14, 0x8cd

    #Address 0x8cd read value
    csrr x14, 0x8cd

    #Address 0x8cd Write value 0xd1933b7
    li x3, 0xd1933b7
    csrw 0x8cd, x3

    #Address 0x8cd read value
    csrr x14, 0x8cd

    #Unmapped address 0xa62 testing: random write/read operations
    #Address 0xa62 read value
    csrr x14, 0xa62

    #Address 0xa62 read value
    csrr x14, 0xa62

    #Address 0xa62 Write value 0x3920666b
    li x3, 0x3920666b
    csrw 0xa62, x3

    #Address 0xa62 Write value 0x8575e8cd
    li x3, 0x8575e8cd
    csrw 0xa62, x3

    #Address 0xa62 Write value 0x17b94104
    li x3, 0x17b94104
    csrw 0xa62, x3

    #Mapped address 0x343 (mtval) testing: random write/read operations
    #Address 0x343 read value
    csrr x14, 0x343

    #Address 0x343 read value
    csrr x14, 0x343

    #Unmapped address 0x322 testing: random write/read operations
    #Address 0x322 read value
    csrr x14, 0x322

    #Address 0x322 Write value 0xa487d2b0
    li x3, 0xa487d2b0
    csrw 0x322, x3

    #Address 0x322 read value
    csrr x14, 0x322

    #Unmapped address 0xb8 testing: random write/read operations
    #Address 0xb8 read value
    csrr x14, 0xb8

    #Unmapped address 0x6b0 testing: random write/read operations
    #Address 0x6b0 read value
    csrr x14, 0x6b0

    #Address 0x6b0 Write value 0xdec208d1
    li x3, 0xdec208d1
    csrw 0x6b0, x3

    #Address 0x6b0 read value
    csrr x14, 0x6b0

    #Unmapped address 0x4bc testing: random write/read operations
    #Address 0x4bc Write value 0xff9fbd34
    li x3, 0xff9fbd34
    csrw 0x4bc, x3

    #Address 0x4bc Write value 0x1345f293
    li x3, 0x1345f293
    csrw 0x4bc, x3

    #Address 0x4bc Write value 0x94081187
    li x3, 0x94081187
    csrw 0x4bc, x3

    #Address 0x4bc Write value 0xb048f78a
    li x3, 0xb048f78a
    csrw 0x4bc, x3

    #Unmapped address 0x4ee testing: random write/read operations
    #Address 0x4ee Write value 0x20e6b675
    li x3, 0x20e6b675
    csrw 0x4ee, x3

    #Address 0x4ee read value
    csrr x14, 0x4ee

    #Address 0x4ee read value
    csrr x14, 0x4ee

    #Address 0x4ee read value
    csrr x14, 0x4ee

    #Address 0x4ee read value
    csrr x14, 0x4ee

    #Unmapped address 0x679 testing: random write/read operations
    #Address 0x679 Write value 0xa3573cd8
    li x3, 0xa3573cd8
    csrw 0x679, x3

    #Address 0x679 read value
    csrr x14, 0x679

    #Address 0x679 Write value 0x75a133b1
    li x3, 0x75a133b1
    csrw 0x679, x3

    #Unmapped address 0x48f testing: random write/read operations
    #Address 0x48f read value
    csrr x14, 0x48f

    #Unmapped address 0x403 testing: random write/read operations
    #Address 0x403 Write value 0x6a3d7715
    li x3, 0x6a3d7715
    csrw 0x403, x3

    #Address 0x403 read value
    csrr x14, 0x403

    #Address 0x403 read value
    csrr x14, 0x403

    #Address 0x403 read value
    csrr x14, 0x403

    #Unmapped address 0xebd testing: random write/read operations
    #Address 0xebd read value
    csrr x14, 0xebd

    #Unmapped address 0xdc9 testing: random write/read operations
    #Address 0xdc9 read value
    csrr x14, 0xdc9

    #Address 0xdc9 Write value 0xd7fdc617
    li x3, 0xd7fdc617
    csrw 0xdc9, x3

    #Address 0xdc9 read value
    csrr x14, 0xdc9

    #Address 0xdc9 Write value 0x48b1d9a2
    li x3, 0x48b1d9a2
    csrw 0xdc9, x3

    #Address 0xdc9 read value
    csrr x14, 0xdc9

    #Unmapped address 0xea testing: random write/read operations
    #Address 0xea Write value 0xbf3eaec9
    li x3, 0xbf3eaec9
    csrw 0xea, x3

    #Address 0xea Write value 0x2a4e3047
    li x3, 0x2a4e3047
    csrw 0xea, x3

    #Mapped address 0x33d (mhpmevent29) testing: random write/read operations
    #Address 0x33d Write value 0x8eac1460
    li x3, 0x8eac1460
    csrw 0x33d, x3

    #Address 0x33d Write value 0xd7f26a4f
    li x3, 0xd7f26a4f
    csrw 0x33d, x3

    #Address 0x33d read value
    csrr x14, 0x33d

    #Address 0x33d Write value 0x9e85d68e
    li x3, 0x9e85d68e
    csrw 0x33d, x3

    #Unmapped address 0x5b7 testing: random write/read operations
    #Address 0x5b7 Write value 0x5e6c6429
    li x3, 0x5e6c6429
    csrw 0x5b7, x3

    #Address 0x5b7 read value
    csrr x14, 0x5b7

    #Address 0x5b7 Write value 0xf21f184
    li x3, 0xf21f184
    csrw 0x5b7, x3

    #Unmapped address 0x99a testing: random write/read operations
    #Address 0x99a Write value 0x43c84ff9
    li x3, 0x43c84ff9
    csrw 0x99a, x3

    #Address 0x99a Write value 0xd049081c
    li x3, 0xd049081c
    csrw 0x99a, x3

    #Address 0x99a read value
    csrr x14, 0x99a

    #Address 0x99a read value
    csrr x14, 0x99a

    #Unmapped address 0x5a2 testing: random write/read operations
    #Address 0x5a2 Write value 0x633678f0
    li x3, 0x633678f0
    csrw 0x5a2, x3

    #Address 0x5a2 read value
    csrr x14, 0x5a2

    #Address 0x5a2 read value
    csrr x14, 0x5a2

    #Address 0x5a2 Write value 0xa1f35113
    li x3, 0xa1f35113
    csrw 0x5a2, x3

    #Address 0x5a2 Write value 0x5685b9ee
    li x3, 0x5685b9ee
    csrw 0x5a2, x3

    #Unmapped address 0xcf5 testing: random write/read operations
    #Address 0xcf5 Write value 0x3d2263f2
    li x3, 0x3d2263f2
    csrw 0xcf5, x3

    #Address 0xcf5 read value
    csrr x14, 0xcf5

    #Address 0xcf5 Write value 0xa08a3aa9
    li x3, 0xa08a3aa9
    csrw 0xcf5, x3

    #Address 0xcf5 read value
    csrr x14, 0xcf5

    #Address 0xcf5 Write value 0xa19a596f
    li x3, 0xa19a596f
    csrw 0xcf5, x3

    #Unmapped address 0xbc7 testing: random write/read operations
    #Address 0xbc7 read value
    csrr x14, 0xbc7

    #Address 0xbc7 Write value 0x5355ecbf
    li x3, 0x5355ecbf
    csrw 0xbc7, x3

    #Address 0xbc7 Write value 0xaae83d37
    li x3, 0xaae83d37
    csrw 0xbc7, x3

    #Address 0xbc7 Write value 0x9334ed9
    li x3, 0x9334ed9
    csrw 0xbc7, x3

    #Unmapped address 0xaa1 testing: random write/read operations
    #Address 0xaa1 read value
    csrr x14, 0xaa1

    #Address 0xaa1 Write value 0x7c9be383
    li x3, 0x7c9be383
    csrw 0xaa1, x3

    #Address 0xaa1 read value
    csrr x14, 0xaa1

    #Unmapped address 0xadf testing: random write/read operations
    #Address 0xadf read value
    csrr x14, 0xadf

    #Address 0xadf Write value 0x894dbbf4
    li x3, 0x894dbbf4
    csrw 0xadf, x3

    #Address 0xadf Write value 0x652f75e6
    li x3, 0x652f75e6
    csrw 0xadf, x3

    #Unmapped address 0xea2 testing: random write/read operations
    #Address 0xea2 read value
    csrr x14, 0xea2

    #Address 0xea2 read value
    csrr x14, 0xea2

    #Address 0xea2 read value
    csrr x14, 0xea2

    #Unmapped address 0x15f testing: random write/read operations
    #Address 0x15f Write value 0xed0ee22f
    li x3, 0xed0ee22f
    csrw 0x15f, x3

    #Unmapped address 0x23d testing: random write/read operations
    #Address 0x23d Write value 0x4e67691a
    li x3, 0x4e67691a
    csrw 0x23d, x3

    #Address 0x23d Write value 0x387a6cd6
    li x3, 0x387a6cd6
    csrw 0x23d, x3

    #Address 0x23d Write value 0x2c2c702
    li x3, 0x2c2c702
    csrw 0x23d, x3

    #Address 0x23d read value
    csrr x14, 0x23d

    #Unmapped address 0xdf9 testing: random write/read operations
    #Address 0xdf9 Write value 0x9d251108
    li x3, 0x9d251108
    csrw 0xdf9, x3

    #Unmapped address 0x83 testing: random write/read operations
    #Address 0x83 Write value 0x527d14ff
    li x3, 0x527d14ff
    csrw 0x83, x3

    #Unmapped address 0xc4e testing: random write/read operations
    #Address 0xc4e read value
    csrr x14, 0xc4e

    #Address 0xc4e Write value 0xc30112eb
    li x3, 0xc30112eb
    csrw 0xc4e, x3

    #Address 0xc4e read value
    csrr x14, 0xc4e

    #Unmapped address 0xe0d testing: random write/read operations
    #Address 0xe0d Write value 0x66e12b7e
    li x3, 0x66e12b7e
    csrw 0xe0d, x3

    #Unmapped address 0x3fe testing: random write/read operations
    #Address 0x3fe read value
    csrr x14, 0x3fe

    #Unmapped address 0xbee testing: random write/read operations
    #Address 0xbee Write value 0x88de50ed
    li x3, 0x88de50ed
    csrw 0xbee, x3

    #Address 0xbee read value
    csrr x14, 0xbee

    #Unmapped address 0x728 testing: random write/read operations
    #Address 0x728 Write value 0x50d76a51
    li x3, 0x50d76a51
    csrw 0x728, x3

    #Address 0x728 read value
    csrr x14, 0x728

    #Unmapped address 0x942 testing: random write/read operations
    #Address 0x942 Write value 0xfe0e7f17
    li x3, 0xfe0e7f17
    csrw 0x942, x3

    #Address 0x942 read value
    csrr x14, 0x942

    #Address 0x942 Write value 0x9a89d23e
    li x3, 0x9a89d23e
    csrw 0x942, x3

    #Address 0x942 Write value 0x57ff8f2b
    li x3, 0x57ff8f2b
    csrw 0x942, x3

    #Unmapped address 0xe73 testing: random write/read operations
    #Address 0xe73 read value
    csrr x14, 0xe73

    #Address 0xe73 read value
    csrr x14, 0xe73

    #Address 0xe73 Write value 0x955019db
    li x3, 0x955019db
    csrw 0xe73, x3

    #Address 0xe73 read value
    csrr x14, 0xe73

    #Mapped address 0x338 (mhpmevent24) testing: random write/read operations
    #Address 0x338 read value
    csrr x14, 0x338

    #Address 0x338 read value
    csrr x14, 0x338

    #Unmapped address 0x24a testing: random write/read operations
    #Address 0x24a read value
    csrr x14, 0x24a

    #Address 0x24a Write value 0x98847fff
    li x3, 0x98847fff
    csrw 0x24a, x3

    #Unmapped address 0xde5 testing: random write/read operations
    #Address 0xde5 Write value 0x7ddb6df6
    li x3, 0x7ddb6df6
    csrw 0xde5, x3

    #Address 0xde5 Write value 0x335b33cb
    li x3, 0x335b33cb
    csrw 0xde5, x3

    #Address 0xde5 read value
    csrr x14, 0xde5

    #Address 0xde5 Write value 0x324ab1c2
    li x3, 0x324ab1c2
    csrw 0xde5, x3

    #Address 0xde5 Write value 0x3d58c8d3
    li x3, 0x3d58c8d3
    csrw 0xde5, x3

    #Unmapped address 0x2ce testing: random write/read operations
    #Address 0x2ce read value
    csrr x14, 0x2ce

    #Address 0x2ce read value
    csrr x14, 0x2ce

    #Address 0x2ce read value
    csrr x14, 0x2ce

    #Unmapped address 0x2a4 testing: random write/read operations
    #Address 0x2a4 Write value 0x3ebda5f5
    li x3, 0x3ebda5f5
    csrw 0x2a4, x3

    #Address 0x2a4 Write value 0x36357a4d
    li x3, 0x36357a4d
    csrw 0x2a4, x3

    #Unmapped address 0x2f6 testing: random write/read operations
    #Address 0x2f6 read value
    csrr x14, 0x2f6

    #Address 0x2f6 read value
    csrr x14, 0x2f6

    #Address 0x2f6 Write value 0x4bb691e2
    li x3, 0x4bb691e2
    csrw 0x2f6, x3

    #Unmapped address 0x30b testing: random write/read operations
    #Address 0x30b read value
    csrr x14, 0x30b

    #Unmapped address 0x263 testing: random write/read operations
    #Address 0x263 Write value 0x4e7dcb1e
    li x3, 0x4e7dcb1e
    csrw 0x263, x3

    #Unmapped address 0xcd0 testing: random write/read operations
    #Address 0xcd0 Write value 0x354d0ca
    li x3, 0x354d0ca
    csrw 0xcd0, x3

    #Address 0xcd0 read value
    csrr x14, 0xcd0

    #Address 0xcd0 Write value 0x9608ac2
    li x3, 0x9608ac2
    csrw 0xcd0, x3

    #Address 0xcd0 read value
    csrr x14, 0xcd0

    #Address 0xcd0 Write value 0xdb72c225
    li x3, 0xdb72c225
    csrw 0xcd0, x3

    #Unmapped address 0xea1 testing: random write/read operations
    #Address 0xea1 read value
    csrr x14, 0xea1

    #Address 0xea1 read value
    csrr x14, 0xea1

    #Address 0xea1 read value
    csrr x14, 0xea1

    #Address 0xea1 read value
    csrr x14, 0xea1

    #Unmapped address 0xef6 testing: random write/read operations
    #Address 0xef6 read value
    csrr x14, 0xef6

    #Address 0xef6 Write value 0xdbcce825
    li x3, 0xdbcce825
    csrw 0xef6, x3

    #Unmapped address 0x4fa testing: random write/read operations
    #Address 0x4fa Write value 0xc193177e
    li x3, 0xc193177e
    csrw 0x4fa, x3

    #Address 0x4fa Write value 0x3df90c7f
    li x3, 0x3df90c7f
    csrw 0x4fa, x3

    #Unmapped address 0x9f5 testing: random write/read operations
    #Address 0x9f5 Write value 0xd6d0f47b
    li x3, 0xd6d0f47b
    csrw 0x9f5, x3

    #Address 0x9f5 read value
    csrr x14, 0x9f5

    #Address 0x9f5 read value
    csrr x14, 0x9f5

    #Address 0x9f5 Write value 0xffa107ce
    li x3, 0xffa107ce
    csrw 0x9f5, x3

    #Address 0x9f5 Write value 0xa15a974f
    li x3, 0xa15a974f
    csrw 0x9f5, x3

    #Unmapped address 0x63d testing: random write/read operations
    #Address 0x63d Write value 0x4b7d7e71
    li x3, 0x4b7d7e71
    csrw 0x63d, x3

    #Address 0x63d Write value 0x9c7455b7
    li x3, 0x9c7455b7
    csrw 0x63d, x3

    #Address 0x63d Write value 0xcb627abc
    li x3, 0xcb627abc
    csrw 0x63d, x3

    #Address 0x63d read value
    csrr x14, 0x63d

    #Unmapped address 0x387 testing: random write/read operations
    #Address 0x387 Write value 0x812b6582
    li x3, 0x812b6582
    csrw 0x387, x3

    #Address 0x387 Write value 0xa6e6eacc
    li x3, 0xa6e6eacc
    csrw 0x387, x3

    #Address 0x387 Write value 0x1fb76186
    li x3, 0x1fb76186
    csrw 0x387, x3

    #Unmapped address 0x548 testing: random write/read operations
    #Address 0x548 Write value 0x86225535
    li x3, 0x86225535
    csrw 0x548, x3

    #Address 0x548 read value
    csrr x14, 0x548

    #Address 0x548 Write value 0x265de15b
    li x3, 0x265de15b
    csrw 0x548, x3

    #Address 0x548 read value
    csrr x14, 0x548

    #Address 0x548 Write value 0x6a087d0f
    li x3, 0x6a087d0f
    csrw 0x548, x3

    #Unmapped address 0xf6 testing: random write/read operations
    #Address 0xf6 Write value 0xac1e3a08
    li x3, 0xac1e3a08
    csrw 0xf6, x3

    #Address 0xf6 Write value 0x16420873
    li x3, 0x16420873
    csrw 0xf6, x3

    #Address 0xf6 read value
    csrr x14, 0xf6

    #Address 0xf6 Write value 0x55860c77
    li x3, 0x55860c77
    csrw 0xf6, x3

    #Unmapped address 0x210 testing: random write/read operations
    #Address 0x210 read value
    csrr x14, 0x210

    #Address 0x210 read value
    csrr x14, 0x210

    #Unmapped address 0xfca testing: random write/read operations
    #Address 0xfca Write value 0xc57eefab
    li x3, 0xc57eefab
    csrw 0xfca, x3

    #Address 0xfca Write value 0xfc4ecfe0
    li x3, 0xfc4ecfe0
    csrw 0xfca, x3

    #Unmapped address 0xdb3 testing: random write/read operations
    #Address 0xdb3 read value
    csrr x14, 0xdb3

    #Address 0xdb3 read value
    csrr x14, 0xdb3

    #Unmapped address 0x413 testing: random write/read operations
    #Address 0x413 Write value 0xa43c38d9
    li x3, 0xa43c38d9
    csrw 0x413, x3

    #Address 0x413 read value
    csrr x14, 0x413

    #Address 0x413 read value
    csrr x14, 0x413

    #Unmapped address 0xcd5 testing: random write/read operations
    #Address 0xcd5 Write value 0xf5754616
    li x3, 0xf5754616
    csrw 0xcd5, x3

    #Address 0xcd5 read value
    csrr x14, 0xcd5

    #Unmapped address 0x8f8 testing: random write/read operations
    #Address 0x8f8 Write value 0x6b2f4570
    li x3, 0x6b2f4570
    csrw 0x8f8, x3

    #Address 0x8f8 read value
    csrr x14, 0x8f8

    #Address 0x8f8 read value
    csrr x14, 0x8f8

    #Address 0x8f8 read value
    csrr x14, 0x8f8

    #Unmapped address 0xd49 testing: random write/read operations
    #Address 0xd49 read value
    csrr x14, 0xd49

    #Address 0xd49 Write value 0x419ab180
    li x3, 0x419ab180
    csrw 0xd49, x3

    #Unmapped address 0xff6 testing: random write/read operations
    #Address 0xff6 Write value 0x7983e42e
    li x3, 0x7983e42e
    csrw 0xff6, x3

    #Address 0xff6 read value
    csrr x14, 0xff6

    #Address 0xff6 Write value 0x34561e3a
    li x3, 0x34561e3a
    csrw 0xff6, x3

    #Address 0xff6 Write value 0x1583569b
    li x3, 0x1583569b
    csrw 0xff6, x3

    #Address 0xff6 read value
    csrr x14, 0xff6

    #Unmapped address 0x2a9 testing: random write/read operations
    #Address 0x2a9 read value
    csrr x14, 0x2a9

    #Address 0x2a9 read value
    csrr x14, 0x2a9

    #Address 0x2a9 read value
    csrr x14, 0x2a9

    #Address 0x2a9 Write value 0xa786b3d5
    li x3, 0xa786b3d5
    csrw 0x2a9, x3

    #Unmapped address 0x4 testing: random write/read operations
    #Address 0x4 Write value 0x3316f410
    li x3, 0x3316f410
    csrw 0x4, x3

    #Address 0x4 Write value 0xd11ac92f
    li x3, 0xd11ac92f
    csrw 0x4, x3

    #Address 0x4 Write value 0x65ebd6e1
    li x3, 0x65ebd6e1
    csrw 0x4, x3

    #Address 0x4 read value
    csrr x14, 0x4

    #Address 0x4 Write value 0xa84ed9a9
    li x3, 0xa84ed9a9
    csrw 0x4, x3

    #Unmapped address 0x163 testing: random write/read operations
    #Address 0x163 read value
    csrr x14, 0x163

    #Unmapped address 0x8ea testing: random write/read operations
    #Address 0x8ea read value
    csrr x14, 0x8ea

    #Address 0x8ea read value
    csrr x14, 0x8ea

    #Address 0x8ea Write value 0x40033d5f
    li x3, 0x40033d5f
    csrw 0x8ea, x3

    #Address 0x8ea read value
    csrr x14, 0x8ea

    #Unmapped address 0x124 testing: random write/read operations
    #Address 0x124 Write value 0x5477887d
    li x3, 0x5477887d
    csrw 0x124, x3

    #Address 0x124 Write value 0x420c8b91
    li x3, 0x420c8b91
    csrw 0x124, x3

    #Address 0x124 read value
    csrr x14, 0x124

    #Address 0x124 Write value 0x45be4bce
    li x3, 0x45be4bce
    csrw 0x124, x3

    #Unmapped address 0xf51 testing: random write/read operations
    #Address 0xf51 Write value 0x5d938f5
    li x3, 0x5d938f5
    csrw 0xf51, x3

    #Address 0xf51 Write value 0xbbdf2e28
    li x3, 0xbbdf2e28
    csrw 0xf51, x3

    #Address 0xf51 Write value 0x11ea806
    li x3, 0x11ea806
    csrw 0xf51, x3

    #Address 0xf51 Write value 0x74c3e2f7
    li x3, 0x74c3e2f7
    csrw 0xf51, x3

    #Address 0xf51 read value
    csrr x14, 0xf51

    #Unmapped address 0x5cf testing: random write/read operations
    #Address 0x5cf read value
    csrr x14, 0x5cf

    #Unmapped address 0xe2 testing: random write/read operations
    #Address 0xe2 read value
    csrr x14, 0xe2

    #Address 0xe2 Write value 0xa86ee2f8
    li x3, 0xa86ee2f8
    csrw 0xe2, x3

    #Unmapped address 0x4d6 testing: random write/read operations
    #Address 0x4d6 read value
    csrr x14, 0x4d6

    #Address 0x4d6 read value
    csrr x14, 0x4d6

    #Address 0x4d6 Write value 0x594b0f7d
    li x3, 0x594b0f7d
    csrw 0x4d6, x3

    #Address 0x4d6 Write value 0x42076a
    li x3, 0x42076a
    csrw 0x4d6, x3

    #Address 0x4d6 read value
    csrr x14, 0x4d6

    #Unmapped address 0x8c testing: random write/read operations
    #Address 0x8c read value
    csrr x14, 0x8c

    #Address 0x8c Write value 0x1860fe7
    li x3, 0x1860fe7
    csrw 0x8c, x3

    #Address 0x8c read value
    csrr x14, 0x8c

    #Address 0x8c Write value 0xd3843bbd
    li x3, 0xd3843bbd
    csrw 0x8c, x3

    #Unmapped address 0x7e testing: random write/read operations
    #Address 0x7e Write value 0xd8ea932c
    li x3, 0xd8ea932c
    csrw 0x7e, x3

    #Address 0x7e read value
    csrr x14, 0x7e

    #Address 0x7e read value
    csrr x14, 0x7e

    #Address 0x7e Write value 0x657baf53
    li x3, 0x657baf53
    csrw 0x7e, x3

    #Unmapped address 0xe06 testing: random write/read operations
    #Address 0xe06 Write value 0xc89687e0
    li x3, 0xc89687e0
    csrw 0xe06, x3

    #Address 0xe06 read value
    csrr x14, 0xe06

    #Unmapped address 0x46a testing: random write/read operations
    #Address 0x46a Write value 0x823324b4
    li x3, 0x823324b4
    csrw 0x46a, x3

    #Address 0x46a read value
    csrr x14, 0x46a

    #Address 0x46a read value
    csrr x14, 0x46a

    #Unmapped address 0x703 testing: random write/read operations
    #Address 0x703 Write value 0xa423f8d2
    li x3, 0xa423f8d2
    csrw 0x703, x3

    #Address 0x703 Write value 0xbc1fdb5f
    li x3, 0xbc1fdb5f
    csrw 0x703, x3

    #Address 0x703 Write value 0x961249d6
    li x3, 0x961249d6
    csrw 0x703, x3

    #Unmapped address 0xdcc testing: random write/read operations
    #Address 0xdcc Write value 0xcceb0981
    li x3, 0xcceb0981
    csrw 0xdcc, x3

    #Address 0xdcc Write value 0x6bdc84fa
    li x3, 0x6bdc84fa
    csrw 0xdcc, x3

    #Address 0xdcc read value
    csrr x14, 0xdcc

    #Address 0xdcc Write value 0x7074c0f
    li x3, 0x7074c0f
    csrw 0xdcc, x3

    #Address 0xdcc read value
    csrr x14, 0xdcc

    #Unmapped address 0xffd testing: random write/read operations
    #Address 0xffd Write value 0xed9ce255
    li x3, 0xed9ce255
    csrw 0xffd, x3

    #Unmapped address 0x620 testing: random write/read operations
    #Address 0x620 Write value 0xbebbfae8
    li x3, 0xbebbfae8
    csrw 0x620, x3

    #Unmapped address 0xe5b testing: random write/read operations
    #Address 0xe5b Write value 0x9cbaee9
    li x3, 0x9cbaee9
    csrw 0xe5b, x3

    #Address 0xe5b read value
    csrr x14, 0xe5b

    #Address 0xe5b read value
    csrr x14, 0xe5b

    #Address 0xe5b read value
    csrr x14, 0xe5b

    #Address 0xe5b Write value 0x4857443a
    li x3, 0x4857443a
    csrw 0xe5b, x3

    #Unmapped address 0xd62 testing: random write/read operations
    #Address 0xd62 Write value 0xed360986
    li x3, 0xed360986
    csrw 0xd62, x3

    #Address 0xd62 read value
    csrr x14, 0xd62

    #Address 0xd62 Write value 0x5c3a2465
    li x3, 0x5c3a2465
    csrw 0xd62, x3

    #Address 0xd62 Write value 0x7d34a478
    li x3, 0x7d34a478
    csrw 0xd62, x3

    #Unmapped address 0x774 testing: random write/read operations
    #Address 0x774 Write value 0x44a12a00
    li x3, 0x44a12a00
    csrw 0x774, x3

    #Address 0x774 read value
    csrr x14, 0x774

    #Address 0x774 read value
    csrr x14, 0x774

    #Address 0x774 Write value 0xfa4d010c
    li x3, 0xfa4d010c
    csrw 0x774, x3

    #Unmapped address 0x861 testing: random write/read operations
    #Address 0x861 read value
    csrr x14, 0x861

    #Address 0x861 read value
    csrr x14, 0x861

    #Address 0x861 read value
    csrr x14, 0x861

    #Address 0x861 read value
    csrr x14, 0x861

    #Address 0x861 Write value 0xecf8e9d7
    li x3, 0xecf8e9d7
    csrw 0x861, x3

    #Unmapped address 0x42f testing: random write/read operations
    #Address 0x42f read value
    csrr x14, 0x42f

    #Address 0x42f Write value 0x22a5775f
    li x3, 0x22a5775f
    csrw 0x42f, x3

    #Unmapped address 0x312 testing: random write/read operations
    #Address 0x312 Write value 0x33b34715
    li x3, 0x33b34715
    csrw 0x312, x3

    #Unmapped address 0x61f testing: random write/read operations
    #Address 0x61f Write value 0xf5d5d5
    li x3, 0xf5d5d5
    csrw 0x61f, x3

    #Address 0x61f Write value 0x9cf981b
    li x3, 0x9cf981b
    csrw 0x61f, x3

    #Address 0x61f Write value 0x13374022
    li x3, 0x13374022
    csrw 0x61f, x3

    #Address 0x61f read value
    csrr x14, 0x61f

    #Address 0x61f Write value 0xa5c0cc2
    li x3, 0xa5c0cc2
    csrw 0x61f, x3

    #Unmapped address 0xf5e testing: random write/read operations
    #Address 0xf5e read value
    csrr x14, 0xf5e

    #Address 0xf5e read value
    csrr x14, 0xf5e

    #Address 0xf5e Write value 0xbdfcd911
    li x3, 0xbdfcd911
    csrw 0xf5e, x3

    #Address 0xf5e read value
    csrr x14, 0xf5e

    #Address 0xf5e read value
    csrr x14, 0xf5e

    #Unmapped address 0x9e5 testing: random write/read operations
    #Address 0x9e5 Write value 0x55e05c6e
    li x3, 0x55e05c6e
    csrw 0x9e5, x3

    #Unmapped address 0x3ec testing: random write/read operations
    #Address 0x3ec Write value 0xb9b19d03
    li x3, 0xb9b19d03
    csrw 0x3ec, x3

    #Address 0x3ec Write value 0xe8201945
    li x3, 0xe8201945
    csrw 0x3ec, x3

    #Address 0x3ec read value
    csrr x14, 0x3ec

    #Address 0x3ec Write value 0x5e9e33bf
    li x3, 0x5e9e33bf
    csrw 0x3ec, x3

    #Address 0x3ec Write value 0xfda84ae3
    li x3, 0xfda84ae3
    csrw 0x3ec, x3

    #Unmapped address 0x393 testing: random write/read operations
    #Address 0x393 read value
    csrr x14, 0x393

    #Address 0x393 Write value 0x67f7d9e5
    li x3, 0x67f7d9e5
    csrw 0x393, x3

    #Address 0x393 read value
    csrr x14, 0x393

    #Address 0x393 read value
    csrr x14, 0x393

    #Unmapped address 0x16 testing: random write/read operations
    #Address 0x16 read value
    csrr x14, 0x16

    #Address 0x16 read value
    csrr x14, 0x16

    #Unmapped address 0x2f2 testing: random write/read operations
    #Address 0x2f2 read value
    csrr x14, 0x2f2

    #Address 0x2f2 Write value 0xaa749665
    li x3, 0xaa749665
    csrw 0x2f2, x3

    #Unmapped address 0xae5 testing: random write/read operations
    #Address 0xae5 read value
    csrr x14, 0xae5

    #Unmapped address 0x508 testing: random write/read operations
    #Address 0x508 read value
    csrr x14, 0x508

    #Address 0x508 read value
    csrr x14, 0x508

    #Address 0x508 read value
    csrr x14, 0x508

    #Address 0x508 read value
    csrr x14, 0x508

    #Address 0x508 read value
    csrr x14, 0x508

    #Unmapped address 0x412 testing: random write/read operations
    #Address 0x412 Write value 0x31e40fc8
    li x3, 0x31e40fc8
    csrw 0x412, x3

    #Unmapped address 0x94f testing: random write/read operations
    #Address 0x94f Write value 0x5775283b
    li x3, 0x5775283b
    csrw 0x94f, x3

    #Address 0x94f Write value 0x44d61dda
    li x3, 0x44d61dda
    csrw 0x94f, x3

    #Address 0x94f read value
    csrr x14, 0x94f

    #Address 0x94f read value
    csrr x14, 0x94f

    #Address 0x94f read value
    csrr x14, 0x94f

    #Unmapped address 0x631 testing: random write/read operations
    #Address 0x631 read value
    csrr x14, 0x631

    #Address 0x631 read value
    csrr x14, 0x631

    #Address 0x631 read value
    csrr x14, 0x631

    #Unmapped address 0xf04 testing: random write/read operations
    #Address 0xf04 read value
    csrr x14, 0xf04

    #Address 0xf04 read value
    csrr x14, 0xf04

    #Unmapped address 0xf99 testing: random write/read operations
    #Address 0xf99 read value
    csrr x14, 0xf99

    #Unmapped address 0xe7e testing: random write/read operations
    #Address 0xe7e Write value 0x99d1fa18
    li x3, 0x99d1fa18
    csrw 0xe7e, x3

    #Address 0xe7e Write value 0x78fb5bb8
    li x3, 0x78fb5bb8
    csrw 0xe7e, x3

    #Address 0xe7e Write value 0x3a54973e
    li x3, 0x3a54973e
    csrw 0xe7e, x3

    #Address 0xe7e Write value 0xe66f97c4
    li x3, 0xe66f97c4
    csrw 0xe7e, x3

    #Unmapped address 0xd02 testing: random write/read operations
    #Address 0xd02 Write value 0xfbdf3af0
    li x3, 0xfbdf3af0
    csrw 0xd02, x3

    #Address 0xd02 read value
    csrr x14, 0xd02

    #Address 0xd02 Write value 0x985ae803
    li x3, 0x985ae803
    csrw 0xd02, x3

    #Address 0xd02 Write value 0x974a0d01
    li x3, 0x974a0d01
    csrw 0xd02, x3

    #Address 0xd02 read value
    csrr x14, 0xd02

    #Unmapped address 0x418 testing: random write/read operations
    #Address 0x418 read value
    csrr x14, 0x418

    #Address 0x418 read value
    csrr x14, 0x418

    #Address 0x418 Write value 0x5744595b
    li x3, 0x5744595b
    csrw 0x418, x3

    #Address 0x418 Write value 0xed620319
    li x3, 0xed620319
    csrw 0x418, x3

    #Address 0x418 read value
    csrr x14, 0x418

    #Unmapped address 0xde9 testing: random write/read operations
    #Address 0xde9 read value
    csrr x14, 0xde9

    #Address 0xde9 read value
    csrr x14, 0xde9

    #Address 0xde9 read value
    csrr x14, 0xde9

    #Unmapped address 0xc2b testing: random write/read operations
    #Address 0xc2b Write value 0x3dd81d46
    li x3, 0x3dd81d46
    csrw 0xc2b, x3

    #Unmapped address 0xa75 testing: random write/read operations
    #Address 0xa75 Write value 0x860c15dc
    li x3, 0x860c15dc
    csrw 0xa75, x3

    #Unmapped address 0xeca testing: random write/read operations
    #Address 0xeca read value
    csrr x14, 0xeca

    #Address 0xeca read value
    csrr x14, 0xeca

    #Address 0xeca read value
    csrr x14, 0xeca

    #Address 0xeca Write value 0x6b3a124
    li x3, 0x6b3a124
    csrw 0xeca, x3

    #Unmapped address 0xe00 testing: random write/read operations
    #Address 0xe00 read value
    csrr x14, 0xe00

    #Address 0xe00 Write value 0x582b861c
    li x3, 0x582b861c
    csrw 0xe00, x3

    #Unmapped address 0x1b1 testing: random write/read operations
    #Address 0x1b1 read value
    csrr x14, 0x1b1

    #Address 0x1b1 read value
    csrr x14, 0x1b1

    #Address 0x1b1 Write value 0x1cd3eb4e
    li x3, 0x1cd3eb4e
    csrw 0x1b1, x3

    #Unmapped address 0xd7c testing: random write/read operations
    #Address 0xd7c Write value 0x33c818cd
    li x3, 0x33c818cd
    csrw 0xd7c, x3

    #Address 0xd7c Write value 0x2de19392
    li x3, 0x2de19392
    csrw 0xd7c, x3

    #Address 0xd7c read value
    csrr x14, 0xd7c

    #Address 0xd7c read value
    csrr x14, 0xd7c

    #Address 0xd7c Write value 0x85d22781
    li x3, 0x85d22781
    csrw 0xd7c, x3

    #Unmapped address 0xc08 testing: random write/read operations
    #Address 0xc08 Write value 0xd4a0234f
    li x3, 0xd4a0234f
    csrw 0xc08, x3

    #Unmapped address 0xd91 testing: random write/read operations
    #Address 0xd91 Write value 0x175da5f3
    li x3, 0x175da5f3
    csrw 0xd91, x3

    #Address 0xd91 read value
    csrr x14, 0xd91

    #Address 0xd91 read value
    csrr x14, 0xd91

    #Address 0xd91 read value
    csrr x14, 0xd91

    #Unmapped address 0x3ab testing: random write/read operations
    #Address 0x3ab Write value 0x29ecef5
    li x3, 0x29ecef5
    csrw 0x3ab, x3

    #Address 0x3ab Write value 0x1e74e7da
    li x3, 0x1e74e7da
    csrw 0x3ab, x3

    #Address 0x3ab read value
    csrr x14, 0x3ab

    #Unmapped address 0x90b testing: random write/read operations
    #Address 0x90b read value
    csrr x14, 0x90b

    #Address 0x90b Write value 0x2d568a10
    li x3, 0x2d568a10
    csrw 0x90b, x3

    #Address 0x90b read value
    csrr x14, 0x90b

    #Address 0x90b read value
    csrr x14, 0x90b

    #Unmapped address 0x9e testing: random write/read operations
    #Address 0x9e read value
    csrr x14, 0x9e

    #Address 0x9e Write value 0xe6427659
    li x3, 0xe6427659
    csrw 0x9e, x3

    #Unmapped address 0x71e testing: random write/read operations
    #Address 0x71e read value
    csrr x14, 0x71e

    #Unmapped address 0x89b testing: random write/read operations
    #Address 0x89b Write value 0x33f150e
    li x3, 0x33f150e
    csrw 0x89b, x3

    #Address 0x89b Write value 0xcb2bad37
    li x3, 0xcb2bad37
    csrw 0x89b, x3

    #Address 0x89b read value
    csrr x14, 0x89b

    #Unmapped address 0x4c4 testing: random write/read operations
    #Address 0x4c4 read value
    csrr x14, 0x4c4

    #Address 0x4c4 Write value 0x1c8efdf4
    li x3, 0x1c8efdf4
    csrw 0x4c4, x3

    #Unmapped address 0x2f5 testing: random write/read operations
    #Address 0x2f5 Write value 0x69e55473
    li x3, 0x69e55473
    csrw 0x2f5, x3

    #Address 0x2f5 read value
    csrr x14, 0x2f5

    #Unmapped address 0xcf2 testing: random write/read operations
    #Address 0xcf2 Write value 0xea8f7a52
    li x3, 0xea8f7a52
    csrw 0xcf2, x3

    #Address 0xcf2 Write value 0x96a0e9ab
    li x3, 0x96a0e9ab
    csrw 0xcf2, x3

    #Unmapped address 0x318 testing: random write/read operations
    #Address 0x318 Write value 0x8bcd2716
    li x3, 0x8bcd2716
    csrw 0x318, x3

    #Address 0x318 read value
    csrr x14, 0x318

    #Address 0x318 read value
    csrr x14, 0x318

    #Address 0x318 read value
    csrr x14, 0x318

    #Address 0x318 read value
    csrr x14, 0x318

    #Unmapped address 0xae3 testing: random write/read operations
    #Address 0xae3 Write value 0xb956e85d
    li x3, 0xb956e85d
    csrw 0xae3, x3

    #Address 0xae3 read value
    csrr x14, 0xae3

    #Address 0xae3 read value
    csrr x14, 0xae3

    #Address 0xae3 Write value 0xd6a38017
    li x3, 0xd6a38017
    csrw 0xae3, x3

    #Unmapped address 0xfc testing: random write/read operations
    #Address 0xfc read value
    csrr x14, 0xfc

    #Address 0xfc read value
    csrr x14, 0xfc

    #Address 0xfc read value
    csrr x14, 0xfc

    #Address 0xfc Write value 0x616f1af8
    li x3, 0x616f1af8
    csrw 0xfc, x3

    #Address 0xfc Write value 0x7fe4d243
    li x3, 0x7fe4d243
    csrw 0xfc, x3

    #Unmapped address 0x363 testing: random write/read operations
    #Address 0x363 read value
    csrr x14, 0x363

    #Address 0x363 read value
    csrr x14, 0x363

    #Address 0x363 read value
    csrr x14, 0x363

    #Address 0x363 read value
    csrr x14, 0x363

    #Address 0x363 Write value 0x7c4445dc
    li x3, 0x7c4445dc
    csrw 0x363, x3

    #Unmapped address 0xd76 testing: random write/read operations
    #Address 0xd76 read value
    csrr x14, 0xd76

    #Address 0xd76 Write value 0x1244840
    li x3, 0x1244840
    csrw 0xd76, x3

    #Address 0xd76 read value
    csrr x14, 0xd76

    #Address 0xd76 read value
    csrr x14, 0xd76

    #Address 0xd76 Write value 0x37a5bbf3
    li x3, 0x37a5bbf3
    csrw 0xd76, x3

    #Unmapped address 0x885 testing: random write/read operations
    #Address 0x885 Write value 0xae612f36
    li x3, 0xae612f36
    csrw 0x885, x3

    #Address 0x885 read value
    csrr x14, 0x885

    #Address 0x885 read value
    csrr x14, 0x885

    #Address 0x885 Write value 0x60d9b8f5
    li x3, 0x60d9b8f5
    csrw 0x885, x3

    #Address 0x885 read value
    csrr x14, 0x885

    #Unmapped address 0x248 testing: random write/read operations
    #Address 0x248 read value
    csrr x14, 0x248

    #Address 0x248 Write value 0x96a99b4a
    li x3, 0x96a99b4a
    csrw 0x248, x3

    #Address 0x248 Write value 0x3c759c71
    li x3, 0x3c759c71
    csrw 0x248, x3

    #Address 0x248 read value
    csrr x14, 0x248

    #Unmapped address 0x6a0 testing: random write/read operations
    #Address 0x6a0 Write value 0x7f08b0de
    li x3, 0x7f08b0de
    csrw 0x6a0, x3

    #Unmapped address 0xd09 testing: random write/read operations
    #Address 0xd09 Write value 0xe4bfa581
    li x3, 0xe4bfa581
    csrw 0xd09, x3

    #Address 0xd09 read value
    csrr x14, 0xd09

    #Mapped address 0x32e (mhpmevent14) testing: random write/read operations
    #Address 0x32e read value
    csrr x14, 0x32e

    #Address 0x32e Write value 0xc21ae90a
    li x3, 0xc21ae90a
    csrw 0x32e, x3

    #Address 0x32e read value
    csrr x14, 0x32e

    #Unmapped address 0xef4 testing: random write/read operations
    #Address 0xef4 read value
    csrr x14, 0xef4

    #Address 0xef4 Write value 0x7caf2e94
    li x3, 0x7caf2e94
    csrw 0xef4, x3

    #Unmapped address 0x640 testing: random write/read operations
    #Address 0x640 Write value 0xb9a61239
    li x3, 0xb9a61239
    csrw 0x640, x3

    #Address 0x640 read value
    csrr x14, 0x640

    #Address 0x640 read value
    csrr x14, 0x640

    #Address 0x640 read value
    csrr x14, 0x640

    #Address 0x640 Write value 0x169495a2
    li x3, 0x169495a2
    csrw 0x640, x3

    #Unmapped address 0x59c testing: random write/read operations
    #Address 0x59c Write value 0x925cf6b3
    li x3, 0x925cf6b3
    csrw 0x59c, x3

    #Unmapped address 0x904 testing: random write/read operations
    #Address 0x904 read value
    csrr x14, 0x904

    #Address 0x904 Write value 0x1d5b08b6
    li x3, 0x1d5b08b6
    csrw 0x904, x3

    #Address 0x904 Write value 0xf041b161
    li x3, 0xf041b161
    csrw 0x904, x3

    #Unmapped address 0xdf0 testing: random write/read operations
    #Address 0xdf0 Write value 0x455dbe53
    li x3, 0x455dbe53
    csrw 0xdf0, x3

    #Address 0xdf0 Write value 0x744bfd93
    li x3, 0x744bfd93
    csrw 0xdf0, x3

    #Address 0xdf0 read value
    csrr x14, 0xdf0

    #Address 0xdf0 read value
    csrr x14, 0xdf0

    #Unmapped address 0x134 testing: random write/read operations
    #Address 0x134 read value
    csrr x14, 0x134

    #Address 0x134 read value
    csrr x14, 0x134

    #Address 0x134 read value
    csrr x14, 0x134

    #Unmapped address 0x79 testing: random write/read operations
    #Address 0x79 Write value 0x332c6b17
    li x3, 0x332c6b17
    csrw 0x79, x3

    #Address 0x79 Write value 0xba55fe3a
    li x3, 0xba55fe3a
    csrw 0x79, x3

    #Address 0x79 Write value 0x84b7c75e
    li x3, 0x84b7c75e
    csrw 0x79, x3

    #Address 0x79 Write value 0x3e048acb
    li x3, 0x3e048acb
    csrw 0x79, x3

    #Address 0x79 Write value 0xeeb20f25
    li x3, 0xeeb20f25
    csrw 0x79, x3

    #Unmapped address 0x9db testing: random write/read operations
    #Address 0x9db Write value 0xa58ede0b
    li x3, 0xa58ede0b
    csrw 0x9db, x3

    #Address 0x9db read value
    csrr x14, 0x9db

    #Address 0x9db read value
    csrr x14, 0x9db

    #Address 0x9db Write value 0xd61f8b84
    li x3, 0xd61f8b84
    csrw 0x9db, x3

    #Address 0x9db read value
    csrr x14, 0x9db

    #Unmapped address 0x69f testing: random write/read operations
    #Address 0x69f Write value 0x2c4f12d7
    li x3, 0x2c4f12d7
    csrw 0x69f, x3

    #Address 0x69f read value
    csrr x14, 0x69f

    #Address 0x69f read value
    csrr x14, 0x69f

    #Address 0x69f read value
    csrr x14, 0x69f

    #Unmapped address 0x7fb testing: random write/read operations
    #Address 0x7fb read value
    csrr x14, 0x7fb

    #Address 0x7fb read value
    csrr x14, 0x7fb

    #Address 0x7fb read value
    csrr x14, 0x7fb

    #Unmapped address 0xb2e testing: random write/read operations
    #Address 0xb2e read value
    csrr x14, 0xb2e

    #Address 0xb2e read value
    csrr x14, 0xb2e

    #Address 0xb2e read value
    csrr x14, 0xb2e

    #Unmapped address 0xbbe testing: random write/read operations
    #Address 0xbbe read value
    csrr x14, 0xbbe

    #Address 0xbbe read value
    csrr x14, 0xbbe

    #Unmapped address 0xcb testing: random write/read operations
    #Address 0xcb Write value 0x9735596a
    li x3, 0x9735596a
    csrw 0xcb, x3

    #Address 0xcb read value
    csrr x14, 0xcb

    #Unmapped address 0x4eb testing: random write/read operations
    #Address 0x4eb Write value 0x9fddecc4
    li x3, 0x9fddecc4
    csrw 0x4eb, x3

    #Address 0x4eb Write value 0x6a269224
    li x3, 0x6a269224
    csrw 0x4eb, x3

    #Unmapped address 0x4ca testing: random write/read operations
    #Address 0x4ca read value
    csrr x14, 0x4ca

    #Address 0x4ca read value
    csrr x14, 0x4ca

    #Unmapped address 0x900 testing: random write/read operations
    #Address 0x900 Write value 0xdd20afac
    li x3, 0xdd20afac
    csrw 0x900, x3

    #Address 0x900 Write value 0x5c12be84
    li x3, 0x5c12be84
    csrw 0x900, x3

    #Address 0x900 read value
    csrr x14, 0x900

    #Unmapped address 0x142 testing: random write/read operations
    #Address 0x142 Write value 0xda376558
    li x3, 0xda376558
    csrw 0x142, x3

    #Unmapped address 0x1d testing: random write/read operations
    #Address 0x1d Write value 0x66460dbc
    li x3, 0x66460dbc
    csrw 0x1d, x3

    #Address 0x1d Write value 0xc56f75ad
    li x3, 0xc56f75ad
    csrw 0x1d, x3

    #Address 0x1d read value
    csrr x14, 0x1d

    #Address 0x1d Write value 0xe4acf2f2
    li x3, 0xe4acf2f2
    csrw 0x1d, x3

    #Address 0x1d Write value 0x6b912611
    li x3, 0x6b912611
    csrw 0x1d, x3

    #Unmapped address 0x717 testing: random write/read operations
    #Address 0x717 Write value 0x2b4cc52d
    li x3, 0x2b4cc52d
    csrw 0x717, x3

    #Address 0x717 Write value 0xc625ac50
    li x3, 0xc625ac50
    csrw 0x717, x3

    #Address 0x717 read value
    csrr x14, 0x717

    #Unmapped address 0xa6f testing: random write/read operations
    #Address 0xa6f read value
    csrr x14, 0xa6f

    #Address 0xa6f Write value 0x7d1e5acd
    li x3, 0x7d1e5acd
    csrw 0xa6f, x3

    #Address 0xa6f read value
    csrr x14, 0xa6f

    #Unmapped address 0xdf5 testing: random write/read operations
    #Address 0xdf5 read value
    csrr x14, 0xdf5

    #Address 0xdf5 read value
    csrr x14, 0xdf5

    #Address 0xdf5 read value
    csrr x14, 0xdf5

    #Address 0xdf5 Write value 0xf2020fd9
    li x3, 0xf2020fd9
    csrw 0xdf5, x3

    #Unmapped address 0x5e5 testing: random write/read operations
    #Address 0x5e5 read value
    csrr x14, 0x5e5

    #Unmapped address 0x806 testing: random write/read operations
    #Address 0x806 Write value 0xba1effb5
    li x3, 0xba1effb5
    csrw 0x806, x3

    #Address 0x806 Write value 0x73419c1d
    li x3, 0x73419c1d
    csrw 0x806, x3

    #Address 0x806 read value
    csrr x14, 0x806

    #Address 0x806 read value
    csrr x14, 0x806

    #Address 0x806 Write value 0x7fbd0193
    li x3, 0x7fbd0193
    csrw 0x806, x3

    #Unmapped address 0x4c9 testing: random write/read operations
    #Address 0x4c9 read value
    csrr x14, 0x4c9

    #Address 0x4c9 read value
    csrr x14, 0x4c9

    #Address 0x4c9 read value
    csrr x14, 0x4c9

    #Address 0x4c9 read value
    csrr x14, 0x4c9

    #Address 0x4c9 read value
    csrr x14, 0x4c9

    #Unmapped address 0x7f7 testing: random write/read operations
    #Address 0x7f7 Write value 0x5821c1b0
    li x3, 0x5821c1b0
    csrw 0x7f7, x3

    #Address 0x7f7 read value
    csrr x14, 0x7f7

    #Unmapped address 0x58a testing: random write/read operations
    #Address 0x58a read value
    csrr x14, 0x58a

    #Address 0x58a read value
    csrr x14, 0x58a

    #Address 0x58a read value
    csrr x14, 0x58a

    #Address 0x58a read value
    csrr x14, 0x58a

    #Address 0x58a read value
    csrr x14, 0x58a

    #Unmapped address 0x4ac testing: random write/read operations
    #Address 0x4ac read value
    csrr x14, 0x4ac

    #Address 0x4ac Write value 0xcee5cb65
    li x3, 0xcee5cb65
    csrw 0x4ac, x3

    #Address 0x4ac Write value 0xf92cdce0
    li x3, 0xf92cdce0
    csrw 0x4ac, x3

    #Unmapped address 0xd22 testing: random write/read operations
    #Address 0xd22 Write value 0xac498cf7
    li x3, 0xac498cf7
    csrw 0xd22, x3

    #Mapped address 0x3bb (pmpaddr11) testing: random write/read operations
    #Address 0x3bb Write value 0xc820856f
    li x3, 0xc820856f
    csrw 0x3bb, x3

    #Address 0x3bb Write value 0x9c9e4411
    li x3, 0x9c9e4411
    csrw 0x3bb, x3

    #Address 0x3bb read value
    csrr x14, 0x3bb

    #Address 0x3bb read value
    csrr x14, 0x3bb

    #Address 0x3bb read value
    csrr x14, 0x3bb

    #Unmapped address 0xc94 testing: random write/read operations
    #Address 0xc94 read value
    csrr x14, 0xc94

    #Address 0xc94 read value
    csrr x14, 0xc94

    #Address 0xc94 Write value 0x3c5e9af8
    li x3, 0x3c5e9af8
    csrw 0xc94, x3

    #Unmapped address 0x148 testing: random write/read operations
    #Address 0x148 Write value 0x8f6009a5
    li x3, 0x8f6009a5
    csrw 0x148, x3

    #Address 0x148 read value
    csrr x14, 0x148

    #Address 0x148 Write value 0x495905cf
    li x3, 0x495905cf
    csrw 0x148, x3

    #Address 0x148 read value
    csrr x14, 0x148

    #Unmapped address 0xe8c testing: random write/read operations
    #Address 0xe8c Write value 0xb61ff824
    li x3, 0xb61ff824
    csrw 0xe8c, x3

    #Address 0xe8c Write value 0x6e67afca
    li x3, 0x6e67afca
    csrw 0xe8c, x3

    #Address 0xe8c Write value 0x6b656f93
    li x3, 0x6b656f93
    csrw 0xe8c, x3

    #Address 0xe8c Write value 0x5ee9082
    li x3, 0x5ee9082
    csrw 0xe8c, x3

    #Address 0xe8c Write value 0x41eb4123
    li x3, 0x41eb4123
    csrw 0xe8c, x3

    #Unmapped address 0x721 testing: random write/read operations
    #Address 0x721 read value
    csrr x14, 0x721

    #Address 0x721 read value
    csrr x14, 0x721

    #Address 0x721 read value
    csrr x14, 0x721

    #Unmapped address 0x3e7 testing: random write/read operations
    #Address 0x3e7 read value
    csrr x14, 0x3e7

    #Address 0x3e7 read value
    csrr x14, 0x3e7

    #Address 0x3e7 Write value 0x88fbf792
    li x3, 0x88fbf792
    csrw 0x3e7, x3

    #Address 0x3e7 Write value 0xcfe10d5a
    li x3, 0xcfe10d5a
    csrw 0x3e7, x3

    #Unmapped address 0xdb6 testing: random write/read operations
    #Address 0xdb6 Write value 0x7a7cd036
    li x3, 0x7a7cd036
    csrw 0xdb6, x3

    #Address 0xdb6 Write value 0x5bdf86a8
    li x3, 0x5bdf86a8
    csrw 0xdb6, x3

    #Address 0xdb6 read value
    csrr x14, 0xdb6

    #Address 0xdb6 read value
    csrr x14, 0xdb6

    #Address 0xdb6 Write value 0xe5e18970
    li x3, 0xe5e18970
    csrw 0xdb6, x3

    #Unmapped address 0x425 testing: random write/read operations
    #Address 0x425 read value
    csrr x14, 0x425

    #Unmapped address 0x8ca testing: random write/read operations
    #Address 0x8ca read value
    csrr x14, 0x8ca

    #Unmapped address 0x88d testing: random write/read operations
    #Address 0x88d Write value 0x5e61ab9f
    li x3, 0x5e61ab9f
    csrw 0x88d, x3

    #Address 0x88d Write value 0x8ee8ca49
    li x3, 0x8ee8ca49
    csrw 0x88d, x3

    #Address 0x88d read value
    csrr x14, 0x88d

    #Address 0x88d read value
    csrr x14, 0x88d

    #Address 0x88d read value
    csrr x14, 0x88d

    #Unmapped address 0x520 testing: random write/read operations
    #Address 0x520 read value
    csrr x14, 0x520

    #Address 0x520 Write value 0xc6abb9f9
    li x3, 0xc6abb9f9
    csrw 0x520, x3

    #Address 0x520 Write value 0x39a0b4de
    li x3, 0x39a0b4de
    csrw 0x520, x3

    #Address 0x520 read value
    csrr x14, 0x520

    #Unmapped address 0x180 testing: random write/read operations
    #Address 0x180 Write value 0xa8752421
    li x3, 0xa8752421
    csrw 0x180, x3

    #Address 0x180 Write value 0xf6614f1f
    li x3, 0xf6614f1f
    csrw 0x180, x3

    #Address 0x180 Write value 0xeea90f20
    li x3, 0xeea90f20
    csrw 0x180, x3

    #Unmapped address 0xcba testing: random write/read operations
    #Address 0xcba read value
    csrr x14, 0xcba

    #Address 0xcba read value
    csrr x14, 0xcba

    #Address 0xcba read value
    csrr x14, 0xcba

    #Address 0xcba read value
    csrr x14, 0xcba

    #Address 0xcba read value
    csrr x14, 0xcba

    #Unmapped address 0x9b1 testing: random write/read operations
    #Address 0x9b1 Write value 0xcce2fdaa
    li x3, 0xcce2fdaa
    csrw 0x9b1, x3

    #Unmapped address 0x3e0 testing: random write/read operations
    #Address 0x3e0 read value
    csrr x14, 0x3e0

    #Unmapped address 0xac6 testing: random write/read operations
    #Address 0xac6 Write value 0x2d74aa77
    li x3, 0x2d74aa77
    csrw 0xac6, x3

    #Address 0xac6 Write value 0xbd7c60d8
    li x3, 0xbd7c60d8
    csrw 0xac6, x3

    #Address 0xac6 Write value 0x2ab39b1c
    li x3, 0x2ab39b1c
    csrw 0xac6, x3

    #Unmapped address 0x99c testing: random write/read operations
    #Address 0x99c read value
    csrr x14, 0x99c

    #Unmapped address 0xc97 testing: random write/read operations
    #Address 0xc97 read value
    csrr x14, 0xc97

    #Address 0xc97 read value
    csrr x14, 0xc97

    #Address 0xc97 Write value 0x73b4a5b8
    li x3, 0x73b4a5b8
    csrw 0xc97, x3

    #Address 0xc97 Write value 0x4755672b
    li x3, 0x4755672b
    csrw 0xc97, x3

    #Unmapped address 0x96 testing: random write/read operations
    #Address 0x96 read value
    csrr x14, 0x96

    #Unmapped address 0x430 testing: random write/read operations
    #Address 0x430 Write value 0xc7d24513
    li x3, 0xc7d24513
    csrw 0x430, x3

    #Address 0x430 read value
    csrr x14, 0x430

    #Address 0x430 read value
    csrr x14, 0x430

    #Unmapped address 0xef9 testing: random write/read operations
    #Address 0xef9 Write value 0x295aa8d9
    li x3, 0x295aa8d9
    csrw 0xef9, x3

    #Address 0xef9 read value
    csrr x14, 0xef9

    #Address 0xef9 read value
    csrr x14, 0xef9

    #Address 0xef9 read value
    csrr x14, 0xef9

    #Unmapped address 0x19f testing: random write/read operations
    #Address 0x19f read value
    csrr x14, 0x19f

    #Address 0x19f read value
    csrr x14, 0x19f

    #Address 0x19f Write value 0x9253aa37
    li x3, 0x9253aa37
    csrw 0x19f, x3

    #Unmapped address 0x270 testing: random write/read operations
    #Address 0x270 Write value 0x2850d646
    li x3, 0x2850d646
    csrw 0x270, x3

    #Address 0x270 read value
    csrr x14, 0x270

    #Unmapped address 0xe67 testing: random write/read operations
    #Address 0xe67 Write value 0x6c910717
    li x3, 0x6c910717
    csrw 0xe67, x3

    #Unmapped address 0xf testing: random write/read operations
    #Address 0xf read value
    csrr x14, 0xf

    #Unmapped address 0xc75 testing: random write/read operations
    #Address 0xc75 read value
    csrr x14, 0xc75

    #Address 0xc75 read value
    csrr x14, 0xc75

    #Address 0xc75 read value
    csrr x14, 0xc75

    #Address 0xc75 Write value 0x8214fbd9
    li x3, 0x8214fbd9
    csrw 0xc75, x3

    #Address 0xc75 read value
    csrr x14, 0xc75

    #Unmapped address 0x5b2 testing: random write/read operations
    #Address 0x5b2 Write value 0x4c54148f
    li x3, 0x4c54148f
    csrw 0x5b2, x3

    #Address 0x5b2 read value
    csrr x14, 0x5b2

    #Unmapped address 0x7b1 testing: random write/read operations
    #Address 0x7b1 Write value 0x6206cae3
    li x3, 0x6206cae3
    csrw 0x7b1, x3

    #Address 0x7b1 read value
    csrr x14, 0x7b1

    #Unmapped address 0xeef testing: random write/read operations
    #Address 0xeef Write value 0xb4528bb1
    li x3, 0xb4528bb1
    csrw 0xeef, x3

    #Unmapped address 0x4d2 testing: random write/read operations
    #Address 0x4d2 read value
    csrr x14, 0x4d2

    #Address 0x4d2 read value
    csrr x14, 0x4d2

    #Address 0x4d2 read value
    csrr x14, 0x4d2

    #Address 0x4d2 Write value 0xe216127e
    li x3, 0xe216127e
    csrw 0x4d2, x3

    #Address 0x4d2 read value
    csrr x14, 0x4d2

    #Unmapped address 0xa13 testing: random write/read operations
    #Address 0xa13 read value
    csrr x14, 0xa13

    #Address 0xa13 Write value 0x50c62f8b
    li x3, 0x50c62f8b
    csrw 0xa13, x3

    #Address 0xa13 Write value 0x7365890b
    li x3, 0x7365890b
    csrw 0xa13, x3

    #Address 0xa13 read value
    csrr x14, 0xa13

    #Unmapped address 0xbb5 testing: random write/read operations
    #Address 0xbb5 read value
    csrr x14, 0xbb5

    #Address 0xbb5 Write value 0x361ffa6
    li x3, 0x361ffa6
    csrw 0xbb5, x3

    #Unmapped address 0xd9f testing: random write/read operations
    #Address 0xd9f Write value 0x166513d3
    li x3, 0x166513d3
    csrw 0xd9f, x3

    #Address 0xd9f read value
    csrr x14, 0xd9f

    #Unmapped address 0x262 testing: random write/read operations
    #Address 0x262 read value
    csrr x14, 0x262

    #Address 0x262 read value
    csrr x14, 0x262

    #Address 0x262 Write value 0xade9f409
    li x3, 0xade9f409
    csrw 0x262, x3

    #Unmapped address 0x1f0 testing: random write/read operations
    #Address 0x1f0 read value
    csrr x14, 0x1f0

    #Address 0x1f0 read value
    csrr x14, 0x1f0

    #Address 0x1f0 Write value 0x7220a9d9
    li x3, 0x7220a9d9
    csrw 0x1f0, x3

    #Address 0x1f0 Write value 0x76af9527
    li x3, 0x76af9527
    csrw 0x1f0, x3

    #Unmapped address 0xd98 testing: random write/read operations
    #Address 0xd98 Write value 0x1da0b9b1
    li x3, 0x1da0b9b1
    csrw 0xd98, x3

    #Address 0xd98 Write value 0xdeb537a1
    li x3, 0xdeb537a1
    csrw 0xd98, x3

    #Unmapped address 0xde testing: random write/read operations
    #Address 0xde read value
    csrr x14, 0xde

    #Address 0xde Write value 0xb38dd029
    li x3, 0xb38dd029
    csrw 0xde, x3

    #Address 0xde Write value 0x5ff841ec
    li x3, 0x5ff841ec
    csrw 0xde, x3

    #Address 0xde Write value 0x44a26f4f
    li x3, 0x44a26f4f
    csrw 0xde, x3

    #Unmapped address 0x26d testing: random write/read operations
    #Address 0x26d read value
    csrr x14, 0x26d

    #Address 0x26d read value
    csrr x14, 0x26d

    #Address 0x26d read value
    csrr x14, 0x26d

    #Address 0x26d read value
    csrr x14, 0x26d

    #Unmapped address 0x3a6 testing: random write/read operations
    #Address 0x3a6 read value
    csrr x14, 0x3a6

    #Address 0x3a6 read value
    csrr x14, 0x3a6

    #Address 0x3a6 Write value 0x6ee10a90
    li x3, 0x6ee10a90
    csrw 0x3a6, x3

    #Address 0x3a6 read value
    csrr x14, 0x3a6

    #Address 0x3a6 read value
    csrr x14, 0x3a6

    #Unmapped address 0x212 testing: random write/read operations
    #Address 0x212 read value
    csrr x14, 0x212

    #Address 0x212 Write value 0x94a9073a
    li x3, 0x94a9073a
    csrw 0x212, x3

    #Unmapped address 0xf8a testing: random write/read operations
    #Address 0xf8a Write value 0x805998fa
    li x3, 0x805998fa
    csrw 0xf8a, x3

    #Address 0xf8a Write value 0x6442ac06
    li x3, 0x6442ac06
    csrw 0xf8a, x3

    #Address 0xf8a read value
    csrr x14, 0xf8a

    #Address 0xf8a Write value 0x352a8893
    li x3, 0x352a8893
    csrw 0xf8a, x3

    #Unmapped address 0xda6 testing: random write/read operations
    #Address 0xda6 Write value 0x5a2cb85e
    li x3, 0x5a2cb85e
    csrw 0xda6, x3

    #Unmapped address 0x40e testing: random write/read operations
    #Address 0x40e read value
    csrr x14, 0x40e

    #Address 0x40e Write value 0x9b32f698
    li x3, 0x9b32f698
    csrw 0x40e, x3

    #Address 0x40e Write value 0x50374ce7
    li x3, 0x50374ce7
    csrw 0x40e, x3

    #Address 0x40e Write value 0xf2ca82ab
    li x3, 0xf2ca82ab
    csrw 0x40e, x3

    #Address 0x40e read value
    csrr x14, 0x40e

    #Unmapped address 0x426 testing: random write/read operations
    #Address 0x426 Write value 0xf736983c
    li x3, 0xf736983c
    csrw 0x426, x3

    #Address 0x426 read value
    csrr x14, 0x426

    #Unmapped address 0x937 testing: random write/read operations
    #Address 0x937 read value
    csrr x14, 0x937

    #Address 0x937 read value
    csrr x14, 0x937

    #Address 0x937 read value
    csrr x14, 0x937

    #Address 0x937 read value
    csrr x14, 0x937

    #Unmapped address 0xad7 testing: random write/read operations
    #Address 0xad7 read value
    csrr x14, 0xad7

    #Unmapped address 0x849 testing: random write/read operations
    #Address 0x849 read value
    csrr x14, 0x849

    #Address 0x849 read value
    csrr x14, 0x849

    #Address 0x849 read value
    csrr x14, 0x849

    #Address 0x849 read value
    csrr x14, 0x849

    #Address 0x849 read value
    csrr x14, 0x849

    #Unmapped address 0xd96 testing: random write/read operations
    #Address 0xd96 Write value 0xf054f265
    li x3, 0xf054f265
    csrw 0xd96, x3

    #Address 0xd96 read value
    csrr x14, 0xd96

    #Address 0xd96 read value
    csrr x14, 0xd96

    #Address 0xd96 read value
    csrr x14, 0xd96

    #Unmapped address 0x7f5 testing: random write/read operations
    #Address 0x7f5 Write value 0xd6e87b64
    li x3, 0xd6e87b64
    csrw 0x7f5, x3

    #Address 0x7f5 Write value 0x85a56902
    li x3, 0x85a56902
    csrw 0x7f5, x3

    #Unmapped address 0xc5f testing: random write/read operations
    #Address 0xc5f Write value 0xa01e1dd6
    li x3, 0xa01e1dd6
    csrw 0xc5f, x3

    #Address 0xc5f Write value 0xd4b09290
    li x3, 0xd4b09290
    csrw 0xc5f, x3

    #Address 0xc5f Write value 0x109d5f2a
    li x3, 0x109d5f2a
    csrw 0xc5f, x3

    #Address 0xc5f Write value 0x9463c1ac
    li x3, 0x9463c1ac
    csrw 0xc5f, x3

    #Address 0xc5f Write value 0x992dd86c
    li x3, 0x992dd86c
    csrw 0xc5f, x3

    #Unmapped address 0x35a testing: random write/read operations
    #Address 0x35a Write value 0xaf03e8f8
    li x3, 0xaf03e8f8
    csrw 0x35a, x3

    #Address 0x35a Write value 0x1a8fc7e7
    li x3, 0x1a8fc7e7
    csrw 0x35a, x3

    #Address 0x35a read value
    csrr x14, 0x35a

    #Address 0x35a read value
    csrr x14, 0x35a

    #Unmapped address 0x45f testing: random write/read operations
    #Address 0x45f read value
    csrr x14, 0x45f

    #Address 0x45f Write value 0x5e70c4b9
    li x3, 0x5e70c4b9
    csrw 0x45f, x3

    #Address 0x45f read value
    csrr x14, 0x45f

    #Unmapped address 0x49a testing: random write/read operations
    #Address 0x49a read value
    csrr x14, 0x49a

    #Address 0x49a read value
    csrr x14, 0x49a

    #Unmapped address 0x732 testing: random write/read operations
    #Address 0x732 Write value 0x7918d72
    li x3, 0x7918d72
    csrw 0x732, x3

    #Unmapped address 0x27a testing: random write/read operations
    #Address 0x27a Write value 0x518394a9
    li x3, 0x518394a9
    csrw 0x27a, x3

    #Address 0x27a Write value 0xf4c4a50a
    li x3, 0xf4c4a50a
    csrw 0x27a, x3

    #Address 0x27a Write value 0xc22588c8
    li x3, 0xc22588c8
    csrw 0x27a, x3

    #Address 0x27a read value
    csrr x14, 0x27a

    #Address 0x27a read value
    csrr x14, 0x27a

    #Unmapped address 0x880 testing: random write/read operations
    #Address 0x880 read value
    csrr x14, 0x880

    #Address 0x880 Write value 0xe85e7846
    li x3, 0xe85e7846
    csrw 0x880, x3

    #Address 0x880 read value
    csrr x14, 0x880

    #Address 0x880 Write value 0x9aebc48e
    li x3, 0x9aebc48e
    csrw 0x880, x3

    #Address 0x880 Write value 0x527e1683
    li x3, 0x527e1683
    csrw 0x880, x3

    #Unmapped address 0x906 testing: random write/read operations
    #Address 0x906 read value
    csrr x14, 0x906

    #Address 0x906 Write value 0xe076bed5
    li x3, 0xe076bed5
    csrw 0x906, x3

    #Address 0x906 read value
    csrr x14, 0x906

    #Unmapped address 0x3e6 testing: random write/read operations
    #Address 0x3e6 Write value 0x6362e9c9
    li x3, 0x6362e9c9
    csrw 0x3e6, x3

    #Address 0x3e6 read value
    csrr x14, 0x3e6

    #Address 0x3e6 Write value 0x81892f4b
    li x3, 0x81892f4b
    csrw 0x3e6, x3

    #Address 0x3e6 Write value 0xd34fcecb
    li x3, 0xd34fcecb
    csrw 0x3e6, x3

    #Address 0x3e6 Write value 0x6e519aae
    li x3, 0x6e519aae
    csrw 0x3e6, x3

    #Unmapped address 0x53f testing: random write/read operations
    #Address 0x53f read value
    csrr x14, 0x53f

    #Address 0x53f Write value 0xfd43b508
    li x3, 0xfd43b508
    csrw 0x53f, x3

    #Address 0x53f Write value 0xaa2b1189
    li x3, 0xaa2b1189
    csrw 0x53f, x3

    #Address 0x53f Write value 0x20a4af2d
    li x3, 0x20a4af2d
    csrw 0x53f, x3

    #Unmapped address 0x59e testing: random write/read operations
    #Address 0x59e read value
    csrr x14, 0x59e

    #Address 0x59e read value
    csrr x14, 0x59e

    #Address 0x59e Write value 0xd35da399
    li x3, 0xd35da399
    csrw 0x59e, x3

    #Address 0x59e Write value 0xfd739a3c
    li x3, 0xfd739a3c
    csrw 0x59e, x3

    #Address 0x59e Write value 0x7d68592e
    li x3, 0x7d68592e
    csrw 0x59e, x3

    #Unmapped address 0x672 testing: random write/read operations
    #Address 0x672 Write value 0x15d0dce0
    li x3, 0x15d0dce0
    csrw 0x672, x3

    #Address 0x672 read value
    csrr x14, 0x672

    #Address 0x672 Write value 0x8194f03a
    li x3, 0x8194f03a
    csrw 0x672, x3

    #Unmapped address 0x7f4 testing: random write/read operations
    #Address 0x7f4 Write value 0x9474e15a
    li x3, 0x9474e15a
    csrw 0x7f4, x3

    #Address 0x7f4 read value
    csrr x14, 0x7f4

    #Address 0x7f4 read value
    csrr x14, 0x7f4

    #Unmapped address 0x6e5 testing: random write/read operations
    #Address 0x6e5 Write value 0x1d54def7
    li x3, 0x1d54def7
    csrw 0x6e5, x3

    #Address 0x6e5 Write value 0x8fdf194
    li x3, 0x8fdf194
    csrw 0x6e5, x3

    #Address 0x6e5 Write value 0x31429407
    li x3, 0x31429407
    csrw 0x6e5, x3

    #Address 0x6e5 read value
    csrr x14, 0x6e5

    #Address 0x6e5 Write value 0xf0c90a4b
    li x3, 0xf0c90a4b
    csrw 0x6e5, x3

    #Unmapped address 0xf3f testing: random write/read operations
    #Address 0xf3f Write value 0x1ab1ac6e
    li x3, 0x1ab1ac6e
    csrw 0xf3f, x3

    #Address 0xf3f Write value 0x1094ebf7
    li x3, 0x1094ebf7
    csrw 0xf3f, x3

    #Address 0xf3f Write value 0x686961e6
    li x3, 0x686961e6
    csrw 0xf3f, x3

    #Address 0xf3f read value
    csrr x14, 0xf3f

    #Address 0xf3f Write value 0xff840fd4
    li x3, 0xff840fd4
    csrw 0xf3f, x3

    #Unmapped address 0x347 testing: random write/read operations
    #Address 0x347 read value
    csrr x14, 0x347

    #Address 0x347 Write value 0x39c063e
    li x3, 0x39c063e
    csrw 0x347, x3

    #Address 0x347 read value
    csrr x14, 0x347

    #Unmapped address 0x98e testing: random write/read operations
    #Address 0x98e Write value 0x5aa2257f
    li x3, 0x5aa2257f
    csrw 0x98e, x3

    #Address 0x98e Write value 0xd2e90e6e
    li x3, 0xd2e90e6e
    csrw 0x98e, x3

    #Unmapped address 0x2e8 testing: random write/read operations
    #Address 0x2e8 Write value 0x50e9f578
    li x3, 0x50e9f578
    csrw 0x2e8, x3

    #Unmapped address 0x8c6 testing: random write/read operations
    #Address 0x8c6 Write value 0x6d7a6ca0
    li x3, 0x6d7a6ca0
    csrw 0x8c6, x3

    #Address 0x8c6 Write value 0x9fc72ddf
    li x3, 0x9fc72ddf
    csrw 0x8c6, x3

    #Unmapped address 0xf63 testing: random write/read operations
    #Address 0xf63 read value
    csrr x14, 0xf63

    #Address 0xf63 read value
    csrr x14, 0xf63

    #Unmapped address 0x8df testing: random write/read operations
    #Address 0x8df read value
    csrr x14, 0x8df

    #Unmapped address 0x54e testing: random write/read operations
    #Address 0x54e read value
    csrr x14, 0x54e

    #Address 0x54e read value
    csrr x14, 0x54e

    #Address 0x54e read value
    csrr x14, 0x54e

    #Address 0x54e Write value 0x42fae0ae
    li x3, 0x42fae0ae
    csrw 0x54e, x3

    #Unmapped address 0x8a4 testing: random write/read operations
    #Address 0x8a4 read value
    csrr x14, 0x8a4

    #Address 0x8a4 read value
    csrr x14, 0x8a4

    #Unmapped address 0x5c5 testing: random write/read operations
    #Address 0x5c5 Write value 0x66c71e1d
    li x3, 0x66c71e1d
    csrw 0x5c5, x3

    #Address 0x5c5 Write value 0x5f12b4eb
    li x3, 0x5f12b4eb
    csrw 0x5c5, x3

    #Address 0x5c5 read value
    csrr x14, 0x5c5

    #Address 0x5c5 read value
    csrr x14, 0x5c5

    #Address 0x5c5 Write value 0x864e7aa0
    li x3, 0x864e7aa0
    csrw 0x5c5, x3

    #Unmapped address 0xdab testing: random write/read operations
    #Address 0xdab read value
    csrr x14, 0xdab

    #Address 0xdab Write value 0x27aee8e
    li x3, 0x27aee8e
    csrw 0xdab, x3

    #Address 0xdab read value
    csrr x14, 0xdab

    #Address 0xdab read value
    csrr x14, 0xdab

    #Address 0xdab read value
    csrr x14, 0xdab

    #Mapped address 0x323 (mhpmevent3) testing: random write/read operations
    #Address 0x323 Write value 0xffe4c0bb
    li x3, 0xffe4c0bb
    csrw 0x323, x3

    #Address 0x323 Write value 0xf6fcdbce
    li x3, 0xf6fcdbce
    csrw 0x323, x3

    #Unmapped address 0xdbc testing: random write/read operations
    #Address 0xdbc Write value 0xee2e7290
    li x3, 0xee2e7290
    csrw 0xdbc, x3

    #Unmapped address 0x560 testing: random write/read operations
    #Address 0x560 read value
    csrr x14, 0x560

    #Address 0x560 read value
    csrr x14, 0x560

    #Address 0x560 read value
    csrr x14, 0x560

    #Unmapped address 0xc0e testing: random write/read operations
    #Address 0xc0e read value
    csrr x14, 0xc0e

    #Address 0xc0e Write value 0x1b5b2b18
    li x3, 0x1b5b2b18
    csrw 0xc0e, x3

    #Unmapped address 0xcd1 testing: random write/read operations
    #Address 0xcd1 read value
    csrr x14, 0xcd1

    #Address 0xcd1 Write value 0x8b3574cb
    li x3, 0x8b3574cb
    csrw 0xcd1, x3

    #Address 0xcd1 Write value 0x72fc2c
    li x3, 0x72fc2c
    csrw 0xcd1, x3

    #Unmapped address 0x2f1 testing: random write/read operations
    #Address 0x2f1 Write value 0xef8be7aa
    li x3, 0xef8be7aa
    csrw 0x2f1, x3

    #Address 0x2f1 read value
    csrr x14, 0x2f1

    #Address 0x2f1 Write value 0x53ff1068
    li x3, 0x53ff1068
    csrw 0x2f1, x3

    #Address 0x2f1 Write value 0x91598140
    li x3, 0x91598140
    csrw 0x2f1, x3

    #Address 0x2f1 Write value 0x5477abe8
    li x3, 0x5477abe8
    csrw 0x2f1, x3

    #Unmapped address 0x735 testing: random write/read operations
    #Address 0x735 Write value 0x7c31958a
    li x3, 0x7c31958a
    csrw 0x735, x3

    #Mapped address 0x334 (mhpmevent20) testing: random write/read operations
    #Address 0x334 read value
    csrr x14, 0x334

    #Address 0x334 Write value 0x667e0742
    li x3, 0x667e0742
    csrw 0x334, x3

    #Unmapped address 0xffb testing: random write/read operations
    #Address 0xffb Write value 0x2263a44b
    li x3, 0x2263a44b
    csrw 0xffb, x3

    #Unmapped address 0x2d7 testing: random write/read operations
    #Address 0x2d7 read value
    csrr x14, 0x2d7

    #Address 0x2d7 Write value 0x799d3ed2
    li x3, 0x799d3ed2
    csrw 0x2d7, x3

    #Address 0x2d7 read value
    csrr x14, 0x2d7

    #Address 0x2d7 read value
    csrr x14, 0x2d7

    #Address 0x2d7 Write value 0x99131e58
    li x3, 0x99131e58
    csrw 0x2d7, x3

    #Unmapped address 0x1bb testing: random write/read operations
    #Address 0x1bb read value
    csrr x14, 0x1bb

    #Address 0x1bb read value
    csrr x14, 0x1bb

    #Unmapped address 0xa04 testing: random write/read operations
    #Address 0xa04 Write value 0x585132aa
    li x3, 0x585132aa
    csrw 0xa04, x3

    #Address 0xa04 Write value 0x20d48217
    li x3, 0x20d48217
    csrw 0xa04, x3

    #Address 0xa04 read value
    csrr x14, 0xa04

    #Address 0xa04 read value
    csrr x14, 0xa04

    #Address 0xa04 Write value 0xfc4d898f
    li x3, 0xfc4d898f
    csrw 0xa04, x3

    #Unmapped address 0xa97 testing: random write/read operations
    #Address 0xa97 read value
    csrr x14, 0xa97

    #Address 0xa97 Write value 0x385643fb
    li x3, 0x385643fb
    csrw 0xa97, x3

    #Address 0xa97 read value
    csrr x14, 0xa97

    #Address 0xa97 Write value 0xc57ca1f5
    li x3, 0xc57ca1f5
    csrw 0xa97, x3

    #Address 0xa97 read value
    csrr x14, 0xa97

    #Unmapped address 0x862 testing: random write/read operations
    #Address 0x862 read value
    csrr x14, 0x862

    #Address 0x862 read value
    csrr x14, 0x862

    #Address 0x862 read value
    csrr x14, 0x862

    #Address 0x862 read value
    csrr x14, 0x862

    #Address 0x862 Write value 0x18f17b38
    li x3, 0x18f17b38
    csrw 0x862, x3

    #Unmapped address 0x1c1 testing: random write/read operations
    #Address 0x1c1 read value
    csrr x14, 0x1c1

    #Address 0x1c1 Write value 0xafb77899
    li x3, 0xafb77899
    csrw 0x1c1, x3

    #Address 0x1c1 Write value 0x6cd4d2d2
    li x3, 0x6cd4d2d2
    csrw 0x1c1, x3

    #Unmapped address 0x5a testing: random write/read operations
    #Address 0x5a Write value 0xe7e99664
    li x3, 0xe7e99664
    csrw 0x5a, x3

    #Address 0x5a Write value 0x8013883d
    li x3, 0x8013883d
    csrw 0x5a, x3

    #Address 0x5a Write value 0xae6a7e3d
    li x3, 0xae6a7e3d
    csrw 0x5a, x3

    #Address 0x5a Write value 0xdcebdd8
    li x3, 0xdcebdd8
    csrw 0x5a, x3

    #Address 0x5a Write value 0xe5f75e44
    li x3, 0xe5f75e44
    csrw 0x5a, x3

    #Unmapped address 0xc3d testing: random write/read operations
    #Address 0xc3d Write value 0x77e470b2
    li x3, 0x77e470b2
    csrw 0xc3d, x3

    #Address 0xc3d read value
    csrr x14, 0xc3d

    #Address 0xc3d Write value 0xea122a38
    li x3, 0xea122a38
    csrw 0xc3d, x3

    #Address 0xc3d read value
    csrr x14, 0xc3d

    #Address 0xc3d read value
    csrr x14, 0xc3d

    #Unmapped address 0xdf2 testing: random write/read operations
    #Address 0xdf2 read value
    csrr x14, 0xdf2

    #Address 0xdf2 Write value 0x7c92cddb
    li x3, 0x7c92cddb
    csrw 0xdf2, x3

    #Address 0xdf2 Write value 0xad9005bb
    li x3, 0xad9005bb
    csrw 0xdf2, x3

    #Address 0xdf2 read value
    csrr x14, 0xdf2

    #Unmapped address 0x840 testing: random write/read operations
    #Address 0x840 read value
    csrr x14, 0x840

    #Address 0x840 Write value 0x6da78158
    li x3, 0x6da78158
    csrw 0x840, x3

    #Unmapped address 0x651 testing: random write/read operations
    #Address 0x651 Write value 0x5c84f65f
    li x3, 0x5c84f65f
    csrw 0x651, x3

    #Address 0x651 Write value 0xb346e696
    li x3, 0xb346e696
    csrw 0x651, x3

    #Address 0x651 Write value 0xa4340eca
    li x3, 0xa4340eca
    csrw 0x651, x3

    #Address 0x651 read value
    csrr x14, 0x651

    #Address 0x651 read value
    csrr x14, 0x651

    #Unmapped address 0x391 testing: random write/read operations
    #Address 0x391 read value
    csrr x14, 0x391

    #Unmapped address 0x2c5 testing: random write/read operations
    #Address 0x2c5 Write value 0xeb980ac
    li x3, 0xeb980ac
    csrw 0x2c5, x3

    #Address 0x2c5 Write value 0xa283381e
    li x3, 0xa283381e
    csrw 0x2c5, x3

    #Unmapped address 0x8a9 testing: random write/read operations
    #Address 0x8a9 Write value 0xf7874df5
    li x3, 0xf7874df5
    csrw 0x8a9, x3

    #Address 0x8a9 read value
    csrr x14, 0x8a9

    #Address 0x8a9 Write value 0xa71d56a5
    li x3, 0xa71d56a5
    csrw 0x8a9, x3

    #Address 0x8a9 Write value 0xc21b0312
    li x3, 0xc21b0312
    csrw 0x8a9, x3

    #Unmapped address 0x669 testing: random write/read operations
    #Address 0x669 read value
    csrr x14, 0x669

    #Address 0x669 Write value 0xfb1d95e3
    li x3, 0xfb1d95e3
    csrw 0x669, x3

    #Address 0x669 read value
    csrr x14, 0x669

    #Address 0x669 Write value 0x7a595d8
    li x3, 0x7a595d8
    csrw 0x669, x3

    #Address 0x669 read value
    csrr x14, 0x669

    #Unmapped address 0x309 testing: random write/read operations
    #Address 0x309 Write value 0xb66ffb0e
    li x3, 0xb66ffb0e
    csrw 0x309, x3

    #Address 0x309 Write value 0x38cead28
    li x3, 0x38cead28
    csrw 0x309, x3

    #Address 0x309 Write value 0x1911c13f
    li x3, 0x1911c13f
    csrw 0x309, x3

    #Unmapped address 0xac4 testing: random write/read operations
    #Address 0xac4 read value
    csrr x14, 0xac4

    #Address 0xac4 Write value 0x37f0d88
    li x3, 0x37f0d88
    csrw 0xac4, x3

    #Unmapped address 0xbec testing: random write/read operations
    #Address 0xbec read value
    csrr x14, 0xbec

    #Unmapped address 0x929 testing: random write/read operations
    #Address 0x929 Write value 0x746e2141
    li x3, 0x746e2141
    csrw 0x929, x3

    #Address 0x929 Write value 0x9b4200c
    li x3, 0x9b4200c
    csrw 0x929, x3

    #Address 0x929 Write value 0x45eb5237
    li x3, 0x45eb5237
    csrw 0x929, x3

    #Address 0x929 read value
    csrr x14, 0x929

    #Address 0x929 Write value 0x592f0dae
    li x3, 0x592f0dae
    csrw 0x929, x3

    #Unmapped address 0x796 testing: random write/read operations
    #Address 0x796 read value
    csrr x14, 0x796

    #Address 0x796 read value
    csrr x14, 0x796

    #Address 0x796 Write value 0x162df368
    li x3, 0x162df368
    csrw 0x796, x3

    #Address 0x796 read value
    csrr x14, 0x796

    #Unmapped address 0xba6 testing: random write/read operations
    #Address 0xba6 Write value 0x2e3e3dcf
    li x3, 0x2e3e3dcf
    csrw 0xba6, x3

    #Address 0xba6 read value
    csrr x14, 0xba6

    #Unmapped address 0x813 testing: random write/read operations
    #Address 0x813 read value
    csrr x14, 0x813

    #Address 0x813 Write value 0xc77fd6a5
    li x3, 0xc77fd6a5
    csrw 0x813, x3

    #Address 0x813 Write value 0xfc51b862
    li x3, 0xfc51b862
    csrw 0x813, x3

    #Unmapped address 0xadd testing: random write/read operations
    #Address 0xadd read value
    csrr x14, 0xadd

    #Address 0xadd read value
    csrr x14, 0xadd

    #Address 0xadd read value
    csrr x14, 0xadd

    #Address 0xadd Write value 0xa36721cb
    li x3, 0xa36721cb
    csrw 0xadd, x3

    #Unmapped address 0x34 testing: random write/read operations
    #Address 0x34 Write value 0x2d4c7540
    li x3, 0x2d4c7540
    csrw 0x34, x3

    #Address 0x34 read value
    csrr x14, 0x34

    #Address 0x34 Write value 0x7d62a8f2
    li x3, 0x7d62a8f2
    csrw 0x34, x3

    #Address 0x34 read value
    csrr x14, 0x34

    #Address 0x34 Write value 0x2a76ec6e
    li x3, 0x2a76ec6e
    csrw 0x34, x3

    #Unmapped address 0x84d testing: random write/read operations
    #Address 0x84d Write value 0x78936125
    li x3, 0x78936125
    csrw 0x84d, x3

    #Address 0x84d Write value 0x3698c753
    li x3, 0x3698c753
    csrw 0x84d, x3

    #Address 0x84d Write value 0xd168815b
    li x3, 0xd168815b
    csrw 0x84d, x3

    #Address 0x84d read value
    csrr x14, 0x84d

    #Unmapped address 0xa9b testing: random write/read operations
    #Address 0xa9b Write value 0x44b6dceb
    li x3, 0x44b6dceb
    csrw 0xa9b, x3

    #Address 0xa9b Write value 0x2aad9e48
    li x3, 0x2aad9e48
    csrw 0xa9b, x3

    #Address 0xa9b read value
    csrr x14, 0xa9b

    #Address 0xa9b read value
    csrr x14, 0xa9b

    #Unmapped address 0x656 testing: random write/read operations
    #Address 0x656 Write value 0xfa1f221b
    li x3, 0xfa1f221b
    csrw 0x656, x3

    #Address 0x656 read value
    csrr x14, 0x656

    #Address 0x656 read value
    csrr x14, 0x656

    #Unmapped address 0xc04 testing: random write/read operations
    #Address 0xc04 read value
    csrr x14, 0xc04

    #Address 0xc04 read value
    csrr x14, 0xc04

    #Address 0xc04 Write value 0xb27017d0
    li x3, 0xb27017d0
    csrw 0xc04, x3

    #Address 0xc04 read value
    csrr x14, 0xc04

    #Address 0xc04 Write value 0x3f6a4b85
    li x3, 0x3f6a4b85
    csrw 0xc04, x3

    #Unmapped address 0xd5b testing: random write/read operations
    #Address 0xd5b read value
    csrr x14, 0xd5b

    #Address 0xd5b read value
    csrr x14, 0xd5b

    #Address 0xd5b read value
    csrr x14, 0xd5b

    #Unmapped address 0x8ce testing: random write/read operations
    #Address 0x8ce Write value 0x17260874
    li x3, 0x17260874
    csrw 0x8ce, x3

    #Address 0x8ce Write value 0x4333e501
    li x3, 0x4333e501
    csrw 0x8ce, x3

    #Address 0x8ce Write value 0x3b3c4d90
    li x3, 0x3b3c4d90
    csrw 0x8ce, x3

    #Address 0x8ce Write value 0xfd6c05b5
    li x3, 0xfd6c05b5
    csrw 0x8ce, x3

    #Address 0x8ce read value
    csrr x14, 0x8ce

    #Unmapped address 0xf73 testing: random write/read operations
    #Address 0xf73 Write value 0x5dc5e444
    li x3, 0x5dc5e444
    csrw 0xf73, x3

    #Address 0xf73 Write value 0xe9e7f334
    li x3, 0xe9e7f334
    csrw 0xf73, x3

    #Address 0xf73 read value
    csrr x14, 0xf73

    #Address 0xf73 Write value 0xfed5fee
    li x3, 0xfed5fee
    csrw 0xf73, x3

    #Address 0xf73 read value
    csrr x14, 0xf73

    #Unmapped address 0x7cc testing: random write/read operations
    #Address 0x7cc read value
    csrr x14, 0x7cc

    #Unmapped address 0xc07 testing: random write/read operations
    #Address 0xc07 read value
    csrr x14, 0xc07

    #Unmapped address 0x9a2 testing: random write/read operations
    #Address 0x9a2 Write value 0xfa088247
    li x3, 0xfa088247
    csrw 0x9a2, x3

    #Address 0x9a2 read value
    csrr x14, 0x9a2

    #Unmapped address 0x5b1 testing: random write/read operations
    #Address 0x5b1 Write value 0x95e83d90
    li x3, 0x95e83d90
    csrw 0x5b1, x3

    #Address 0x5b1 Write value 0x6e584b4c
    li x3, 0x6e584b4c
    csrw 0x5b1, x3

    #Address 0x5b1 Write value 0x3be80fcd
    li x3, 0x3be80fcd
    csrw 0x5b1, x3

    #Unmapped address 0x4bf testing: random write/read operations
    #Address 0x4bf Write value 0x6a92d355
    li x3, 0x6a92d355
    csrw 0x4bf, x3

    #Unmapped address 0x6cd testing: random write/read operations
    #Address 0x6cd Write value 0xe75bad54
    li x3, 0xe75bad54
    csrw 0x6cd, x3

    #Address 0x6cd read value
    csrr x14, 0x6cd

    #Unmapped address 0x5a4 testing: random write/read operations
    #Address 0x5a4 Write value 0x33eb5a58
    li x3, 0x33eb5a58
    csrw 0x5a4, x3

    #Address 0x5a4 read value
    csrr x14, 0x5a4

    #Address 0x5a4 Write value 0xac588e0
    li x3, 0xac588e0
    csrw 0x5a4, x3

    #Unmapped address 0x667 testing: random write/read operations
    #Address 0x667 read value
    csrr x14, 0x667

    #Address 0x667 Write value 0xb0faa92b
    li x3, 0xb0faa92b
    csrw 0x667, x3

    #Unmapped address 0xd0c testing: random write/read operations
    #Address 0xd0c read value
    csrr x14, 0xd0c

    #Address 0xd0c read value
    csrr x14, 0xd0c

    #Unmapped address 0x10b testing: random write/read operations
    #Address 0x10b Write value 0x6a936e11
    li x3, 0x6a936e11
    csrw 0x10b, x3

    #Unmapped address 0xce0 testing: random write/read operations
    #Address 0xce0 read value
    csrr x14, 0xce0

    #Address 0xce0 Write value 0x5f00690f
    li x3, 0x5f00690f
    csrw 0xce0, x3

    #Address 0xce0 read value
    csrr x14, 0xce0

    #Address 0xce0 Write value 0x8637f362
    li x3, 0x8637f362
    csrw 0xce0, x3

    #Address 0xce0 Write value 0x3517cd6b
    li x3, 0x3517cd6b
    csrw 0xce0, x3

    #Mapped address 0xb98 (mhpmcounterh24) testing: random write/read operations
    #Address 0xb98 Write value 0xfcaa1eb1
    li x3, 0xfcaa1eb1
    csrw 0xb98, x3

    #Address 0xb98 Write value 0x165d9d36
    li x3, 0x165d9d36
    csrw 0xb98, x3

    #Unmapped address 0x523 testing: random write/read operations
    #Address 0x523 read value
    csrr x14, 0x523

    #Address 0x523 read value
    csrr x14, 0x523

    #Address 0x523 read value
    csrr x14, 0x523

    #Address 0x523 read value
    csrr x14, 0x523

    #Unmapped address 0xc90 testing: random write/read operations
    #Address 0xc90 Write value 0xa19bc594
    li x3, 0xa19bc594
    csrw 0xc90, x3

    #Address 0xc90 read value
    csrr x14, 0xc90

    #Unmapped address 0xd28 testing: random write/read operations
    #Address 0xd28 Write value 0x1fdbfe69
    li x3, 0x1fdbfe69
    csrw 0xd28, x3

    #Unmapped address 0x433 testing: random write/read operations
    #Address 0x433 read value
    csrr x14, 0x433

    #Address 0x433 Write value 0xbe985c11
    li x3, 0xbe985c11
    csrw 0x433, x3

    #Address 0x433 read value
    csrr x14, 0x433

    #Address 0x433 read value
    csrr x14, 0x433

    #Address 0x433 read value
    csrr x14, 0x433

    #Unmapped address 0x233 testing: random write/read operations
    #Address 0x233 read value
    csrr x14, 0x233

    #Address 0x233 Write value 0x85b5e09d
    li x3, 0x85b5e09d
    csrw 0x233, x3

    #Address 0x233 Write value 0xdddccbab
    li x3, 0xdddccbab
    csrw 0x233, x3

    #Unmapped address 0x643 testing: random write/read operations
    #Address 0x643 Write value 0xd09a62b0
    li x3, 0xd09a62b0
    csrw 0x643, x3

    #Address 0x643 Write value 0xd5e25e91
    li x3, 0xd5e25e91
    csrw 0x643, x3

    #Address 0x643 Write value 0xb74ac39d
    li x3, 0xb74ac39d
    csrw 0x643, x3

    #Address 0x643 read value
    csrr x14, 0x643

    #Unmapped address 0x789 testing: random write/read operations
    #Address 0x789 read value
    csrr x14, 0x789

    #Address 0x789 read value
    csrr x14, 0x789

    #Address 0x789 read value
    csrr x14, 0x789

    #Address 0x789 Write value 0xe144d2dc
    li x3, 0xe144d2dc
    csrw 0x789, x3

    #Address 0x789 Write value 0xeab6735f
    li x3, 0xeab6735f
    csrw 0x789, x3

    #Unmapped address 0x1f4 testing: random write/read operations
    #Address 0x1f4 Write value 0x41afb382
    li x3, 0x41afb382
    csrw 0x1f4, x3

    #Address 0x1f4 read value
    csrr x14, 0x1f4

    #Address 0x1f4 Write value 0xebc3a899
    li x3, 0xebc3a899
    csrw 0x1f4, x3

    #Unmapped address 0xad5 testing: random write/read operations
    #Address 0xad5 Write value 0xff31b301
    li x3, 0xff31b301
    csrw 0xad5, x3

    #Address 0xad5 Write value 0x686ff3b4
    li x3, 0x686ff3b4
    csrw 0xad5, x3

    #Address 0xad5 read value
    csrr x14, 0xad5

    #Unmapped address 0x252 testing: random write/read operations
    #Address 0x252 read value
    csrr x14, 0x252

    #Address 0x252 Write value 0x22567c80
    li x3, 0x22567c80
    csrw 0x252, x3

    #Address 0x252 Write value 0x638547d6
    li x3, 0x638547d6
    csrw 0x252, x3

    #Address 0x252 read value
    csrr x14, 0x252

    #Address 0x252 Write value 0x94c1b366
    li x3, 0x94c1b366
    csrw 0x252, x3

    #Unmapped address 0x801 testing: random write/read operations
    #Address 0x801 read value
    csrr x14, 0x801

    #Address 0x801 read value
    csrr x14, 0x801

    #Unmapped address 0x274 testing: random write/read operations
    #Address 0x274 read value
    csrr x14, 0x274

    #Address 0x274 read value
    csrr x14, 0x274

    #Address 0x274 read value
    csrr x14, 0x274

    #Address 0x274 Write value 0x63ced93a
    li x3, 0x63ced93a
    csrw 0x274, x3

    #Address 0x274 Write value 0x7fa64911
    li x3, 0x7fa64911
    csrw 0x274, x3

    #Unmapped address 0xcff testing: random write/read operations
    #Address 0xcff Write value 0x79aa9c65
    li x3, 0x79aa9c65
    csrw 0xcff, x3

    #Address 0xcff Write value 0x9e2ab76f
    li x3, 0x9e2ab76f
    csrw 0xcff, x3

    #Address 0xcff Write value 0xdfc66a4b
    li x3, 0xdfc66a4b
    csrw 0xcff, x3

    #Unmapped address 0x94c testing: random write/read operations
    #Address 0x94c read value
    csrr x14, 0x94c

    #Address 0x94c read value
    csrr x14, 0x94c

    #Unmapped address 0x29c testing: random write/read operations
    #Address 0x29c Write value 0x40203759
    li x3, 0x40203759
    csrw 0x29c, x3

    #Address 0x29c read value
    csrr x14, 0x29c

    #Address 0x29c Write value 0xee40ff7f
    li x3, 0xee40ff7f
    csrw 0x29c, x3

    #Address 0x29c Write value 0xad642ebe
    li x3, 0xad642ebe
    csrw 0x29c, x3

    #Unmapped address 0x7eb testing: random write/read operations
    #Address 0x7eb read value
    csrr x14, 0x7eb

    #Address 0x7eb read value
    csrr x14, 0x7eb

    #Address 0x7eb Write value 0xd232dfbd
    li x3, 0xd232dfbd
    csrw 0x7eb, x3

    #Address 0x7eb read value
    csrr x14, 0x7eb

    #Address 0x7eb Write value 0x9ecb9ef0
    li x3, 0x9ecb9ef0
    csrw 0x7eb, x3

    #Mapped address 0xb0b (mhpmcounter11) testing: random write/read operations
    #Address 0xb0b read value
    csrr x14, 0xb0b

    #Address 0xb0b read value
    csrr x14, 0xb0b

    #Address 0xb0b Write value 0x19b14eb5
    li x3, 0x19b14eb5
    csrw 0xb0b, x3

    #Unmapped address 0xa19 testing: random write/read operations
    #Address 0xa19 read value
    csrr x14, 0xa19

    #Address 0xa19 Write value 0xc971dcbc
    li x3, 0xc971dcbc
    csrw 0xa19, x3

    #Address 0xa19 Write value 0x8a4d92ac
    li x3, 0x8a4d92ac
    csrw 0xa19, x3

    #Address 0xa19 read value
    csrr x14, 0xa19

    #Unmapped address 0xfb0 testing: random write/read operations
    #Address 0xfb0 read value
    csrr x14, 0xfb0

    #Unmapped address 0xeb6 testing: random write/read operations
    #Address 0xeb6 read value
    csrr x14, 0xeb6

    #Address 0xeb6 read value
    csrr x14, 0xeb6

    #Address 0xeb6 read value
    csrr x14, 0xeb6

    #Address 0xeb6 Write value 0x3b0d78e
    li x3, 0x3b0d78e
    csrw 0xeb6, x3

    #Address 0xeb6 read value
    csrr x14, 0xeb6

    #Unmapped address 0xa80 testing: random write/read operations
    #Address 0xa80 Write value 0xbab3c61f
    li x3, 0xbab3c61f
    csrw 0xa80, x3

    #Address 0xa80 Write value 0x766f40a3
    li x3, 0x766f40a3
    csrw 0xa80, x3

    #Address 0xa80 Write value 0xd64fe7e
    li x3, 0xd64fe7e
    csrw 0xa80, x3

    #Address 0xa80 Write value 0xf6b9cd89
    li x3, 0xf6b9cd89
    csrw 0xa80, x3

    #Address 0xa80 read value
    csrr x14, 0xa80

    #Unmapped address 0xfb6 testing: random write/read operations
    #Address 0xfb6 read value
    csrr x14, 0xfb6

    #Unmapped address 0x77b testing: random write/read operations
    #Address 0x77b Write value 0x304b88f
    li x3, 0x304b88f
    csrw 0x77b, x3

    #Address 0x77b Write value 0x80ba2d33
    li x3, 0x80ba2d33
    csrw 0x77b, x3

    #Address 0x77b Write value 0xcfe6694f
    li x3, 0xcfe6694f
    csrw 0x77b, x3

    #Address 0x77b read value
    csrr x14, 0x77b

    #Unmapped address 0x8b6 testing: random write/read operations
    #Address 0x8b6 Write value 0xc80e2ff0
    li x3, 0xc80e2ff0
    csrw 0x8b6, x3

    #Address 0x8b6 read value
    csrr x14, 0x8b6

    #Address 0x8b6 Write value 0xe983ff2c
    li x3, 0xe983ff2c
    csrw 0x8b6, x3

    #Address 0x8b6 Write value 0x32250716
    li x3, 0x32250716
    csrw 0x8b6, x3

    #Address 0x8b6 Write value 0x515c95d9
    li x3, 0x515c95d9
    csrw 0x8b6, x3

    #Unmapped address 0xe64 testing: random write/read operations
    #Address 0xe64 read value
    csrr x14, 0xe64

    #Address 0xe64 Write value 0xbdf15acb
    li x3, 0xbdf15acb
    csrw 0xe64, x3

    #Address 0xe64 Write value 0xf19454ff
    li x3, 0xf19454ff
    csrw 0xe64, x3

    #Address 0xe64 Write value 0x1bdcb3af
    li x3, 0x1bdcb3af
    csrw 0xe64, x3

    #Unmapped address 0xddb testing: random write/read operations
    #Address 0xddb read value
    csrr x14, 0xddb

    #Address 0xddb read value
    csrr x14, 0xddb

    #Address 0xddb read value
    csrr x14, 0xddb

    #Address 0xddb read value
    csrr x14, 0xddb

    #Address 0xddb read value
    csrr x14, 0xddb

    #Unmapped address 0xfba testing: random write/read operations
    #Address 0xfba Write value 0x91cce748
    li x3, 0x91cce748
    csrw 0xfba, x3

    #Unmapped address 0xca7 testing: random write/read operations
    #Address 0xca7 Write value 0xe3d14e43
    li x3, 0xe3d14e43
    csrw 0xca7, x3

    #Address 0xca7 read value
    csrr x14, 0xca7

    #Address 0xca7 Write value 0x22d2e8d2
    li x3, 0x22d2e8d2
    csrw 0xca7, x3

    #Unmapped address 0x3c1 testing: random write/read operations
    #Address 0x3c1 read value
    csrr x14, 0x3c1

    #Address 0x3c1 Write value 0x8ff469ac
    li x3, 0x8ff469ac
    csrw 0x3c1, x3

    #Address 0x3c1 Write value 0x63bdb76b
    li x3, 0x63bdb76b
    csrw 0x3c1, x3

    #Address 0x3c1 read value
    csrr x14, 0x3c1

    #Unmapped address 0xdcb testing: random write/read operations
    #Address 0xdcb read value
    csrr x14, 0xdcb

    #Address 0xdcb read value
    csrr x14, 0xdcb

    #Unmapped address 0xc89 testing: random write/read operations
    #Address 0xc89 Write value 0xbb309713
    li x3, 0xbb309713
    csrw 0xc89, x3

    #Unmapped address 0xe2c testing: random write/read operations
    #Address 0xe2c read value
    csrr x14, 0xe2c

    #Unmapped address 0xb43 testing: random write/read operations
    #Address 0xb43 Write value 0xdcdad52d
    li x3, 0xdcdad52d
    csrw 0xb43, x3

    #Address 0xb43 Write value 0x2fdc9ac6
    li x3, 0x2fdc9ac6
    csrw 0xb43, x3

    #Unmapped address 0x975 testing: random write/read operations
    #Address 0x975 read value
    csrr x14, 0x975

    #Address 0x975 read value
    csrr x14, 0x975

    #Address 0x975 Write value 0xd34aefeb
    li x3, 0xd34aefeb
    csrw 0x975, x3

    #Address 0x975 Write value 0xce733278
    li x3, 0xce733278
    csrw 0x975, x3

    #Address 0x975 read value
    csrr x14, 0x975

    #Unmapped address 0x599 testing: random write/read operations
    #Address 0x599 read value
    csrr x14, 0x599

    #Address 0x599 Write value 0x79ff813a
    li x3, 0x79ff813a
    csrw 0x599, x3

    #Address 0x599 Write value 0x71a2e4a6
    li x3, 0x71a2e4a6
    csrw 0x599, x3

    #Address 0x599 Write value 0xed23eb76
    li x3, 0xed23eb76
    csrw 0x599, x3

    #Address 0x599 Write value 0x508b1050
    li x3, 0x508b1050
    csrw 0x599, x3

    #Unmapped address 0x11d testing: random write/read operations
    #Address 0x11d Write value 0xa0bbbdbe
    li x3, 0xa0bbbdbe
    csrw 0x11d, x3

    #Address 0x11d Write value 0x373cbd59
    li x3, 0x373cbd59
    csrw 0x11d, x3

    #Address 0x11d Write value 0x3449beba
    li x3, 0x3449beba
    csrw 0x11d, x3

    #Address 0x11d read value
    csrr x14, 0x11d

    #Unmapped address 0xca8 testing: random write/read operations
    #Address 0xca8 Write value 0xaadc8507
    li x3, 0xaadc8507
    csrw 0xca8, x3

    #Unmapped address 0xc5c testing: random write/read operations
    #Address 0xc5c read value
    csrr x14, 0xc5c

    #Address 0xc5c read value
    csrr x14, 0xc5c

    #Address 0xc5c read value
    csrr x14, 0xc5c

    #Address 0xc5c read value
    csrr x14, 0xc5c

    #Address 0xc5c Write value 0xfe1e63cd
    li x3, 0xfe1e63cd
    csrw 0xc5c, x3

    #Unmapped address 0xb44 testing: random write/read operations
    #Address 0xb44 Write value 0xffaaeb4a
    li x3, 0xffaaeb4a
    csrw 0xb44, x3

    #Address 0xb44 Write value 0x81c8948f
    li x3, 0x81c8948f
    csrw 0xb44, x3

    #Address 0xb44 read value
    csrr x14, 0xb44

    #Address 0xb44 Write value 0x898e837d
    li x3, 0x898e837d
    csrw 0xb44, x3

    #Unmapped address 0xb73 testing: random write/read operations
    #Address 0xb73 read value
    csrr x14, 0xb73

    #Address 0xb73 Write value 0x8331b78d
    li x3, 0x8331b78d
    csrw 0xb73, x3

    #Unmapped address 0x678 testing: random write/read operations
    #Address 0x678 Write value 0xc72ffa37
    li x3, 0xc72ffa37
    csrw 0x678, x3

    #Address 0x678 read value
    csrr x14, 0x678

    #Address 0x678 read value
    csrr x14, 0x678

    #Address 0x678 read value
    csrr x14, 0x678

    #Unmapped address 0x867 testing: random write/read operations
    #Address 0x867 read value
    csrr x14, 0x867

    #Address 0x867 Write value 0xf73df15f
    li x3, 0xf73df15f
    csrw 0x867, x3

    #Address 0x867 read value
    csrr x14, 0x867

    #Address 0x867 read value
    csrr x14, 0x867

    #Unmapped address 0x46d testing: random write/read operations
    #Address 0x46d read value
    csrr x14, 0x46d

    #Address 0x46d Write value 0x25cae9e6
    li x3, 0x25cae9e6
    csrw 0x46d, x3

    #Address 0x46d Write value 0xdcbfb8a6
    li x3, 0xdcbfb8a6
    csrw 0x46d, x3

    #Unmapped address 0x756 testing: random write/read operations
    #Address 0x756 Write value 0x13975128
    li x3, 0x13975128
    csrw 0x756, x3

    #Address 0x756 read value
    csrr x14, 0x756

    #Address 0x756 Write value 0xc7b95d99
    li x3, 0xc7b95d99
    csrw 0x756, x3

    #Address 0x756 read value
    csrr x14, 0x756

    #Address 0x756 Write value 0xd08e6a32
    li x3, 0xd08e6a32
    csrw 0x756, x3

    #Unmapped address 0xc9a testing: random write/read operations
    #Address 0xc9a Write value 0xa6d4d2a1
    li x3, 0xa6d4d2a1
    csrw 0xc9a, x3

    #Address 0xc9a Write value 0xe2834e41
    li x3, 0xe2834e41
    csrw 0xc9a, x3

    #Address 0xc9a Write value 0x6fb01717
    li x3, 0x6fb01717
    csrw 0xc9a, x3

    #Address 0xc9a Write value 0xb82da3d2
    li x3, 0xb82da3d2
    csrw 0xc9a, x3

    #Unmapped address 0xbc8 testing: random write/read operations
    #Address 0xbc8 read value
    csrr x14, 0xbc8

    #Unmapped address 0x1dc testing: random write/read operations
    #Address 0x1dc Write value 0x5bfe79de
    li x3, 0x5bfe79de
    csrw 0x1dc, x3

    #Address 0x1dc Write value 0x648088e
    li x3, 0x648088e
    csrw 0x1dc, x3

    #Address 0x1dc read value
    csrr x14, 0x1dc

    #Unmapped address 0x93e testing: random write/read operations
    #Address 0x93e read value
    csrr x14, 0x93e

    #Address 0x93e read value
    csrr x14, 0x93e

    #Unmapped address 0x51b testing: random write/read operations
    #Address 0x51b Write value 0x57b91d29
    li x3, 0x57b91d29
    csrw 0x51b, x3

    #Address 0x51b Write value 0xa883c5ff
    li x3, 0xa883c5ff
    csrw 0x51b, x3

    #Address 0x51b read value
    csrr x14, 0x51b

    #Unmapped address 0xc32 testing: random write/read operations
    #Address 0xc32 read value
    csrr x14, 0xc32

    #Address 0xc32 Write value 0xbe026b7b
    li x3, 0xbe026b7b
    csrw 0xc32, x3

    #Address 0xc32 Write value 0x257c3c38
    li x3, 0x257c3c38
    csrw 0xc32, x3

    #Address 0xc32 Write value 0xf218a6f5
    li x3, 0xf218a6f5
    csrw 0xc32, x3

    #Unmapped address 0xc9f testing: random write/read operations
    #Address 0xc9f Write value 0xe9dc0bf7
    li x3, 0xe9dc0bf7
    csrw 0xc9f, x3

    #Address 0xc9f read value
    csrr x14, 0xc9f

    #Unmapped address 0x8f0 testing: random write/read operations
    #Address 0x8f0 read value
    csrr x14, 0x8f0

    #Address 0x8f0 read value
    csrr x14, 0x8f0

    #Address 0x8f0 read value
    csrr x14, 0x8f0

    #Unmapped address 0x686 testing: random write/read operations
    #Address 0x686 read value
    csrr x14, 0x686

    #Unmapped address 0x382 testing: random write/read operations
    #Address 0x382 read value
    csrr x14, 0x382

    #Address 0x382 Write value 0x85aa7315
    li x3, 0x85aa7315
    csrw 0x382, x3

    #Address 0x382 Write value 0x314d7a95
    li x3, 0x314d7a95
    csrw 0x382, x3

    #Address 0x382 read value
    csrr x14, 0x382

    #Unmapped address 0x495 testing: random write/read operations
    #Address 0x495 read value
    csrr x14, 0x495

    #Address 0x495 read value
    csrr x14, 0x495

    #Address 0x495 Write value 0x31e8bba0
    li x3, 0x31e8bba0
    csrw 0x495, x3

    #Address 0x495 Write value 0xcc108ea7
    li x3, 0xcc108ea7
    csrw 0x495, x3

    #Unmapped address 0xc34 testing: random write/read operations
    #Address 0xc34 read value
    csrr x14, 0xc34

    #Unmapped address 0x69 testing: random write/read operations
    #Address 0x69 read value
    csrr x14, 0x69

    #Unmapped address 0x87c testing: random write/read operations
    #Address 0x87c Write value 0xc5f11fd5
    li x3, 0xc5f11fd5
    csrw 0x87c, x3

    #Unmapped address 0xfde testing: random write/read operations
    #Address 0xfde Write value 0x393464f5
    li x3, 0x393464f5
    csrw 0xfde, x3

    #Address 0xfde read value
    csrr x14, 0xfde

    #Address 0xfde Write value 0x144efa6b
    li x3, 0x144efa6b
    csrw 0xfde, x3

    #Address 0xfde read value
    csrr x14, 0xfde

    #Unmapped address 0x93 testing: random write/read operations
    #Address 0x93 Write value 0x39bad77b
    li x3, 0x39bad77b
    csrw 0x93, x3

    #Address 0x93 read value
    csrr x14, 0x93

    #Address 0x93 Write value 0x441b608c
    li x3, 0x441b608c
    csrw 0x93, x3

    #Unmapped address 0x12 testing: random write/read operations
    #Address 0x12 Write value 0x7c58a763
    li x3, 0x7c58a763
    csrw 0x12, x3

    #Address 0x12 read value
    csrr x14, 0x12

    #Address 0x12 read value
    csrr x14, 0x12

    #Unmapped address 0xf1f testing: random write/read operations
    #Address 0xf1f read value
    csrr x14, 0xf1f

    #Address 0xf1f Write value 0xe2006292
    li x3, 0xe2006292
    csrw 0xf1f, x3

    #Address 0xf1f Write value 0x6e559db5
    li x3, 0x6e559db5
    csrw 0xf1f, x3

    #Unmapped address 0xc73 testing: random write/read operations
    #Address 0xc73 Write value 0xe8af44ec
    li x3, 0xe8af44ec
    csrw 0xc73, x3

    #Address 0xc73 Write value 0x72c48ed3
    li x3, 0x72c48ed3
    csrw 0xc73, x3

    #Address 0xc73 Write value 0xf1c284e2
    li x3, 0xf1c284e2
    csrw 0xc73, x3

    #Address 0xc73 read value
    csrr x14, 0xc73

    #Address 0xc73 Write value 0x6ada1fac
    li x3, 0x6ada1fac
    csrw 0xc73, x3

    #Unmapped address 0x8a6 testing: random write/read operations
    #Address 0x8a6 Write value 0x96f2310
    li x3, 0x96f2310
    csrw 0x8a6, x3

    #Address 0x8a6 read value
    csrr x14, 0x8a6

    #Address 0x8a6 Write value 0x6bafb0d2
    li x3, 0x6bafb0d2
    csrw 0x8a6, x3

    #Address 0x8a6 read value
    csrr x14, 0x8a6

    #Unmapped address 0x30a testing: random write/read operations
    #Address 0x30a Write value 0x736f1b2f
    li x3, 0x736f1b2f
    csrw 0x30a, x3

    #Unmapped address 0xa81 testing: random write/read operations
    #Address 0xa81 read value
    csrr x14, 0xa81

    #Address 0xa81 Write value 0xe23e2974
    li x3, 0xe23e2974
    csrw 0xa81, x3

    #Address 0xa81 Write value 0xb091c478
    li x3, 0xb091c478
    csrw 0xa81, x3

    #Unmapped address 0x7ba testing: random write/read operations
    #Address 0x7ba read value
    csrr x14, 0x7ba

    #Address 0x7ba read value
    csrr x14, 0x7ba

    #Address 0x7ba read value
    csrr x14, 0x7ba

    #Unmapped address 0x7f1 testing: random write/read operations
    #Address 0x7f1 read value
    csrr x14, 0x7f1

    #Unmapped address 0x94a testing: random write/read operations
    #Address 0x94a Write value 0xcb9302f7
    li x3, 0xcb9302f7
    csrw 0x94a, x3

    #Address 0x94a Write value 0xd4588183
    li x3, 0xd4588183
    csrw 0x94a, x3

    #Address 0x94a read value
    csrr x14, 0x94a

    #Address 0x94a read value
    csrr x14, 0x94a

    #Unmapped address 0x141 testing: random write/read operations
    #Address 0x141 Write value 0xf4e4c02
    li x3, 0xf4e4c02
    csrw 0x141, x3

    #Address 0x141 Write value 0x686dcbf1
    li x3, 0x686dcbf1
    csrw 0x141, x3

    #Address 0x141 read value
    csrr x14, 0x141

    #Address 0x141 Write value 0xdbbeae71
    li x3, 0xdbbeae71
    csrw 0x141, x3

    #Address 0x141 read value
    csrr x14, 0x141

    #Mapped address 0xb83 (mhpmcounterh3) testing: random write/read operations
    #Address 0xb83 Write value 0x1869e9d4
    li x3, 0x1869e9d4
    csrw 0xb83, x3

    #Unmapped address 0xaf0 testing: random write/read operations
    #Address 0xaf0 read value
    csrr x14, 0xaf0

    #Address 0xaf0 Write value 0x29a8eab8
    li x3, 0x29a8eab8
    csrw 0xaf0, x3

    #Address 0xaf0 read value
    csrr x14, 0xaf0

    #Unmapped address 0xca9 testing: random write/read operations
    #Address 0xca9 read value
    csrr x14, 0xca9

    #Mapped address 0xb0a (mhpmcounter10) testing: random write/read operations
    #Address 0xb0a read value
    csrr x14, 0xb0a

    #Address 0xb0a Write value 0x246a3ee1
    li x3, 0x246a3ee1
    csrw 0xb0a, x3

    #Unmapped address 0x989 testing: random write/read operations
    #Address 0x989 Write value 0xa13755c
    li x3, 0xa13755c
    csrw 0x989, x3

    #Unmapped address 0x9b testing: random write/read operations
    #Address 0x9b read value
    csrr x14, 0x9b

    #Address 0x9b read value
    csrr x14, 0x9b

    #Address 0x9b read value
    csrr x14, 0x9b

    #Address 0x9b read value
    csrr x14, 0x9b

    #Unmapped address 0xee0 testing: random write/read operations
    #Address 0xee0 Write value 0x4e8d4aeb
    li x3, 0x4e8d4aeb
    csrw 0xee0, x3

    #Address 0xee0 read value
    csrr x14, 0xee0

    #Address 0xee0 Write value 0xe29fc0ab
    li x3, 0xe29fc0ab
    csrw 0xee0, x3

    #Address 0xee0 read value
    csrr x14, 0xee0

    #Address 0xee0 read value
    csrr x14, 0xee0

    #Unmapped address 0xab2 testing: random write/read operations
    #Address 0xab2 Write value 0x17ff7538
    li x3, 0x17ff7538
    csrw 0xab2, x3

    #Unmapped address 0xdce testing: random write/read operations
    #Address 0xdce Write value 0xe95ed017
    li x3, 0xe95ed017
    csrw 0xdce, x3

    #Address 0xdce Write value 0x984762d
    li x3, 0x984762d
    csrw 0xdce, x3

    #Unmapped address 0x6ee testing: random write/read operations
    #Address 0x6ee read value
    csrr x14, 0x6ee

    #Address 0x6ee Write value 0x93dafea3
    li x3, 0x93dafea3
    csrw 0x6ee, x3

    #Address 0x6ee read value
    csrr x14, 0x6ee

    #Address 0x6ee Write value 0xbef0ac70
    li x3, 0xbef0ac70
    csrw 0x6ee, x3

    #Address 0x6ee Write value 0xc7e0020a
    li x3, 0xc7e0020a
    csrw 0x6ee, x3

    #Unmapped address 0x379 testing: random write/read operations
    #Address 0x379 read value
    csrr x14, 0x379

    #Address 0x379 read value
    csrr x14, 0x379

    #Address 0x379 Write value 0xc01b59a4
    li x3, 0xc01b59a4
    csrw 0x379, x3

    #Address 0x379 Write value 0x843b2ca1
    li x3, 0x843b2ca1
    csrw 0x379, x3

    #Address 0x379 read value
    csrr x14, 0x379

    #Unmapped address 0x4cd testing: random write/read operations
    #Address 0x4cd Write value 0x56293a90
    li x3, 0x56293a90
    csrw 0x4cd, x3

    #Address 0x4cd read value
    csrr x14, 0x4cd

    #Address 0x4cd Write value 0x28cbdb9a
    li x3, 0x28cbdb9a
    csrw 0x4cd, x3

    #Address 0x4cd Write value 0x162e13bc
    li x3, 0x162e13bc
    csrw 0x4cd, x3

    #Address 0x4cd Write value 0x8a6dfc4d
    li x3, 0x8a6dfc4d
    csrw 0x4cd, x3

    #Unmapped address 0xd59 testing: random write/read operations
    #Address 0xd59 read value
    csrr x14, 0xd59

    #Address 0xd59 Write value 0x2e831d99
    li x3, 0x2e831d99
    csrw 0xd59, x3

    #Unmapped address 0x564 testing: random write/read operations
    #Address 0x564 Write value 0x29d4082a
    li x3, 0x29d4082a
    csrw 0x564, x3

    #Address 0x564 read value
    csrr x14, 0x564

    #Unmapped address 0xe7c testing: random write/read operations
    #Address 0xe7c Write value 0x507f5f8d
    li x3, 0x507f5f8d
    csrw 0xe7c, x3

    #Address 0xe7c read value
    csrr x14, 0xe7c

    #Unmapped address 0xfd8 testing: random write/read operations
    #Address 0xfd8 read value
    csrr x14, 0xfd8

    #Address 0xfd8 Write value 0x47dd313b
    li x3, 0x47dd313b
    csrw 0xfd8, x3

    #Address 0xfd8 Write value 0xb2564270
    li x3, 0xb2564270
    csrw 0xfd8, x3

    #Address 0xfd8 Write value 0x22e72024
    li x3, 0x22e72024
    csrw 0xfd8, x3

    #Unmapped address 0x883 testing: random write/read operations
    #Address 0x883 Write value 0x503e8d21
    li x3, 0x503e8d21
    csrw 0x883, x3

    #Address 0x883 read value
    csrr x14, 0x883

    #Unmapped address 0x3af testing: random write/read operations
    #Address 0x3af Write value 0xdbea09cf
    li x3, 0xdbea09cf
    csrw 0x3af, x3

    #Unmapped address 0x707 testing: random write/read operations
    #Address 0x707 Write value 0x5c375afe
    li x3, 0x5c375afe
    csrw 0x707, x3

    #Address 0x707 read value
    csrr x14, 0x707

    #Address 0x707 Write value 0xdadb654
    li x3, 0xdadb654
    csrw 0x707, x3

    #Address 0x707 read value
    csrr x14, 0x707

    #Address 0x707 read value
    csrr x14, 0x707

    #Unmapped address 0x8b3 testing: random write/read operations
    #Address 0x8b3 Write value 0xbe4a7fc2
    li x3, 0xbe4a7fc2
    csrw 0x8b3, x3

    #Unmapped address 0xdd6 testing: random write/read operations
    #Address 0xdd6 read value
    csrr x14, 0xdd6

    #Address 0xdd6 read value
    csrr x14, 0xdd6

    #Unmapped address 0x460 testing: random write/read operations
    #Address 0x460 read value
    csrr x14, 0x460

    #Address 0x460 read value
    csrr x14, 0x460

    #Address 0x460 Write value 0x795a5fa3
    li x3, 0x795a5fa3
    csrw 0x460, x3

    #Address 0x460 Write value 0x603c116f
    li x3, 0x603c116f
    csrw 0x460, x3

    #Unmapped address 0x9ae testing: random write/read operations
    #Address 0x9ae Write value 0xf43bbae0
    li x3, 0xf43bbae0
    csrw 0x9ae, x3

    #Address 0x9ae Write value 0x841ceb25
    li x3, 0x841ceb25
    csrw 0x9ae, x3

    #Address 0x9ae Write value 0xe41eaefd
    li x3, 0xe41eaefd
    csrw 0x9ae, x3

    #Address 0x9ae Write value 0xf65a9adc
    li x3, 0xf65a9adc
    csrw 0x9ae, x3

    #Unmapped address 0xd1b testing: random write/read operations
    #Address 0xd1b Write value 0x94a8a5b7
    li x3, 0x94a8a5b7
    csrw 0xd1b, x3

    #Address 0xd1b read value
    csrr x14, 0xd1b

    #Address 0xd1b read value
    csrr x14, 0xd1b

    #Unmapped address 0xd7f testing: random write/read operations
    #Address 0xd7f read value
    csrr x14, 0xd7f

    #Address 0xd7f Write value 0xae2a385c
    li x3, 0xae2a385c
    csrw 0xd7f, x3

    #Address 0xd7f read value
    csrr x14, 0xd7f

    #Address 0xd7f read value
    csrr x14, 0xd7f

    #Address 0xd7f Write value 0xa3af83c7
    li x3, 0xa3af83c7
    csrw 0xd7f, x3

    #Mapped address 0xb12 (mhpmcounter18) testing: random write/read operations
    #Address 0xb12 Write value 0xc976617e
    li x3, 0xc976617e
    csrw 0xb12, x3

    #Address 0xb12 read value
    csrr x14, 0xb12

    #Unmapped address 0x27b testing: random write/read operations
    #Address 0x27b read value
    csrr x14, 0x27b

    #Unmapped address 0x7d4 testing: random write/read operations
    #Address 0x7d4 Write value 0xe4e10efc
    li x3, 0xe4e10efc
    csrw 0x7d4, x3

    #Address 0x7d4 Write value 0x4cef0e9c
    li x3, 0x4cef0e9c
    csrw 0x7d4, x3

    #Address 0x7d4 Write value 0xfcf65280
    li x3, 0xfcf65280
    csrw 0x7d4, x3

    #Address 0x7d4 Write value 0x86cc6fb0
    li x3, 0x86cc6fb0
    csrw 0x7d4, x3

    #Unmapped address 0xab9 testing: random write/read operations
    #Address 0xab9 Write value 0xdd6257ff
    li x3, 0xdd6257ff
    csrw 0xab9, x3

    #Address 0xab9 Write value 0x6a8610b7
    li x3, 0x6a8610b7
    csrw 0xab9, x3

    #Address 0xab9 read value
    csrr x14, 0xab9

    #Address 0xab9 Write value 0x4343f9a8
    li x3, 0x4343f9a8
    csrw 0xab9, x3

    #Unmapped address 0x3d testing: random write/read operations
    #Address 0x3d Write value 0x45e5dc4f
    li x3, 0x45e5dc4f
    csrw 0x3d, x3

    #Unmapped address 0x9d0 testing: random write/read operations
    #Address 0x9d0 Write value 0x13bbff80
    li x3, 0x13bbff80
    csrw 0x9d0, x3

    #Unmapped address 0x463 testing: random write/read operations
    #Address 0x463 Write value 0xe8497c87
    li x3, 0xe8497c87
    csrw 0x463, x3

    #Address 0x463 read value
    csrr x14, 0x463

    #Address 0x463 Write value 0x6a60e191
    li x3, 0x6a60e191
    csrw 0x463, x3

    #Address 0x463 Write value 0x45fc5ab
    li x3, 0x45fc5ab
    csrw 0x463, x3

    #Address 0x463 read value
    csrr x14, 0x463

    #Unmapped address 0x878 testing: random write/read operations
    #Address 0x878 Write value 0x80754608
    li x3, 0x80754608
    csrw 0x878, x3

    #Address 0x878 read value
    csrr x14, 0x878

    #Address 0x878 Write value 0x6e9496c3
    li x3, 0x6e9496c3
    csrw 0x878, x3

    #Address 0x878 read value
    csrr x14, 0x878

    #Address 0x878 read value
    csrr x14, 0x878

    #Unmapped address 0xa73 testing: random write/read operations
    #Address 0xa73 read value
    csrr x14, 0xa73

    #Address 0xa73 read value
    csrr x14, 0xa73

    #Mapped address 0xb9f (mhpmcounterh31) testing: random write/read operations
    #Address 0xb9f Write value 0x4e17278e
    li x3, 0x4e17278e
    csrw 0xb9f, x3

    #Unmapped address 0x20 testing: random write/read operations
    #Address 0x20 read value
    csrr x14, 0x20

    #Address 0x20 Write value 0x56811c0f
    li x3, 0x56811c0f
    csrw 0x20, x3

    #Address 0x20 read value
    csrr x14, 0x20

    #Address 0x20 read value
    csrr x14, 0x20

    #Unmapped address 0x7cd testing: random write/read operations
    #Address 0x7cd Write value 0x30de39ef
    li x3, 0x30de39ef
    csrw 0x7cd, x3

    #Address 0x7cd read value
    csrr x14, 0x7cd

    #Address 0x7cd Write value 0x5cf179e0
    li x3, 0x5cf179e0
    csrw 0x7cd, x3

    #Address 0x7cd Write value 0x60cd9c7b
    li x3, 0x60cd9c7b
    csrw 0x7cd, x3

    #Unmapped address 0x922 testing: random write/read operations
    #Address 0x922 Write value 0x50a5313b
    li x3, 0x50a5313b
    csrw 0x922, x3

    #Address 0x922 read value
    csrr x14, 0x922

    #Address 0x922 Write value 0x9ca09ac7
    li x3, 0x9ca09ac7
    csrw 0x922, x3

    #Unmapped address 0xc4 testing: random write/read operations
    #Address 0xc4 Write value 0x5cde86a4
    li x3, 0x5cde86a4
    csrw 0xc4, x3

    #Address 0xc4 read value
    csrr x14, 0xc4

    #Address 0xc4 read value
    csrr x14, 0xc4

    #Address 0xc4 Write value 0xf3701f6c
    li x3, 0xf3701f6c
    csrw 0xc4, x3

    #Address 0xc4 read value
    csrr x14, 0xc4

    #Unmapped address 0x9ba testing: random write/read operations
    #Address 0x9ba Write value 0xfb8227f3
    li x3, 0xfb8227f3
    csrw 0x9ba, x3

    #Address 0x9ba read value
    csrr x14, 0x9ba

    #Address 0x9ba Write value 0x21ac1811
    li x3, 0x21ac1811
    csrw 0x9ba, x3

    #Address 0x9ba Write value 0x8f27916a
    li x3, 0x8f27916a
    csrw 0x9ba, x3

    #Unmapped address 0x820 testing: random write/read operations
    #Address 0x820 read value
    csrr x14, 0x820

    #Address 0x820 read value
    csrr x14, 0x820

    #Address 0x820 Write value 0xeda76200
    li x3, 0xeda76200
    csrw 0x820, x3

    #Unmapped address 0x7db testing: random write/read operations
    #Address 0x7db Write value 0x690604e0
    li x3, 0x690604e0
    csrw 0x7db, x3

    #Address 0x7db Write value 0xb3c80842
    li x3, 0xb3c80842
    csrw 0x7db, x3

    #Address 0x7db read value
    csrr x14, 0x7db

    #Unmapped address 0xe09 testing: random write/read operations
    #Address 0xe09 Write value 0xd26e6b40
    li x3, 0xd26e6b40
    csrw 0xe09, x3

    #Address 0xe09 Write value 0xef44306b
    li x3, 0xef44306b
    csrw 0xe09, x3

    #Address 0xe09 read value
    csrr x14, 0xe09

    #Unmapped address 0x2bf testing: random write/read operations
    #Address 0x2bf Write value 0x2836cc
    li x3, 0x2836cc
    csrw 0x2bf, x3

    #Address 0x2bf Write value 0x43628105
    li x3, 0x43628105
    csrw 0x2bf, x3

    #Address 0x2bf Write value 0xc22b8bba
    li x3, 0xc22b8bba
    csrw 0x2bf, x3

    #Address 0x2bf Write value 0x356ead62
    li x3, 0x356ead62
    csrw 0x2bf, x3

    #Address 0x2bf read value
    csrr x14, 0x2bf

    #Unmapped address 0x845 testing: random write/read operations
    #Address 0x845 Write value 0x29afe8b4
    li x3, 0x29afe8b4
    csrw 0x845, x3

    #Address 0x845 Write value 0xa49c6ab2
    li x3, 0xa49c6ab2
    csrw 0x845, x3

    #Unmapped address 0xb28 testing: random write/read operations
    #Address 0xb28 Write value 0xad849483
    li x3, 0xad849483
    csrw 0xb28, x3

    #Unmapped address 0x7c1 testing: random write/read operations
    #Address 0x7c1 Write value 0xfe092e3f
    li x3, 0xfe092e3f
    csrw 0x7c1, x3

    #Address 0x7c1 Write value 0xc9b375f7
    li x3, 0xc9b375f7
    csrw 0x7c1, x3

    #Address 0x7c1 read value
    csrr x14, 0x7c1

    #Unmapped address 0x7 testing: random write/read operations
    #Address 0x7 Write value 0xc9b7e160
    li x3, 0xc9b7e160
    csrw 0x7, x3

    #Address 0x7 read value
    csrr x14, 0x7

    #Unmapped address 0x7b testing: random write/read operations
    #Address 0x7b read value
    csrr x14, 0x7b

    #Address 0x7b read value
    csrr x14, 0x7b

    #Mapped address 0x3b6 (pmpaddr6) testing: random write/read operations
    #Address 0x3b6 read value
    csrr x14, 0x3b6

    #Unmapped address 0xaf testing: random write/read operations
    #Address 0xaf Write value 0x4e0370ec
    li x3, 0x4e0370ec
    csrw 0xaf, x3

    #Unmapped address 0x6f testing: random write/read operations
    #Address 0x6f Write value 0x98ebbc3b
    li x3, 0x98ebbc3b
    csrw 0x6f, x3

    #Address 0x6f Write value 0xb7414fb3
    li x3, 0xb7414fb3
    csrw 0x6f, x3

    #Address 0x6f read value
    csrr x14, 0x6f

    #Unmapped address 0x513 testing: random write/read operations
    #Address 0x513 Write value 0x88134078
    li x3, 0x88134078
    csrw 0x513, x3

    #Address 0x513 Write value 0xe0822acb
    li x3, 0xe0822acb
    csrw 0x513, x3

    #Address 0x513 Write value 0xe3f3a13e
    li x3, 0xe3f3a13e
    csrw 0x513, x3

    #Address 0x513 read value
    csrr x14, 0x513

    #Unmapped address 0x8fb testing: random write/read operations
    #Address 0x8fb Write value 0x99d57a4f
    li x3, 0x99d57a4f
    csrw 0x8fb, x3

    #Address 0x8fb Write value 0xf1c8954f
    li x3, 0xf1c8954f
    csrw 0x8fb, x3

    #Address 0x8fb Write value 0x423ffe12
    li x3, 0x423ffe12
    csrw 0x8fb, x3

    #Address 0x8fb Write value 0x589725a
    li x3, 0x589725a
    csrw 0x8fb, x3

    #Address 0x8fb read value
    csrr x14, 0x8fb

    #Unmapped address 0x2de testing: random write/read operations
    #Address 0x2de Write value 0xf9aa990b
    li x3, 0xf9aa990b
    csrw 0x2de, x3

    #Address 0x2de read value
    csrr x14, 0x2de

    #Address 0x2de Write value 0x566a0086
    li x3, 0x566a0086
    csrw 0x2de, x3

    #Unmapped address 0x351 testing: random write/read operations
    #Address 0x351 read value
    csrr x14, 0x351

    #Unmapped address 0x170 testing: random write/read operations
    #Address 0x170 Write value 0xe30a41e5
    li x3, 0xe30a41e5
    csrw 0x170, x3

    #Unmapped address 0xbe4 testing: random write/read operations
    #Address 0xbe4 read value
    csrr x14, 0xbe4

    #Address 0xbe4 read value
    csrr x14, 0xbe4

    #Address 0xbe4 read value
    csrr x14, 0xbe4

    #Address 0xbe4 read value
    csrr x14, 0xbe4

    #Address 0xbe4 read value
    csrr x14, 0xbe4

    #Unmapped address 0x3ac testing: random write/read operations
    #Address 0x3ac Write value 0xa1391289
    li x3, 0xa1391289
    csrw 0x3ac, x3

    #Address 0x3ac read value
    csrr x14, 0x3ac

    #Address 0x3ac Write value 0x69136ff6
    li x3, 0x69136ff6
    csrw 0x3ac, x3

    #Unmapped address 0xfce testing: random write/read operations
    #Address 0xfce Write value 0xf2798606
    li x3, 0xf2798606
    csrw 0xfce, x3

    #Address 0xfce read value
    csrr x14, 0xfce

    #Address 0xfce Write value 0xe4eab8e5
    li x3, 0xe4eab8e5
    csrw 0xfce, x3

    #Address 0xfce read value
    csrr x14, 0xfce

    #Unmapped address 0x973 testing: random write/read operations
    #Address 0x973 read value
    csrr x14, 0x973

    #Address 0x973 Write value 0x6b75bbab
    li x3, 0x6b75bbab
    csrw 0x973, x3

    #Unmapped address 0x1d4 testing: random write/read operations
    #Address 0x1d4 Write value 0xf1e0586a
    li x3, 0xf1e0586a
    csrw 0x1d4, x3

    #Address 0x1d4 Write value 0x27e780e8
    li x3, 0x27e780e8
    csrw 0x1d4, x3

    #Address 0x1d4 Write value 0x8a1ca324
    li x3, 0x8a1ca324
    csrw 0x1d4, x3

    #Address 0x1d4 Write value 0xbe6f3c7e
    li x3, 0xbe6f3c7e
    csrw 0x1d4, x3

    #Unmapped address 0xc95 testing: random write/read operations
    #Address 0xc95 Write value 0xb87dd4f9
    li x3, 0xb87dd4f9
    csrw 0xc95, x3

    #Unmapped address 0x464 testing: random write/read operations
    #Address 0x464 Write value 0xf41ae1b1
    li x3, 0xf41ae1b1
    csrw 0x464, x3

    #Address 0x464 read value
    csrr x14, 0x464

    #Address 0x464 Write value 0x6585e2a
    li x3, 0x6585e2a
    csrw 0x464, x3

    #Unmapped address 0x8e1 testing: random write/read operations
    #Address 0x8e1 read value
    csrr x14, 0x8e1

    #Address 0x8e1 Write value 0xbab0b2b5
    li x3, 0xbab0b2b5
    csrw 0x8e1, x3

    #Address 0x8e1 Write value 0x17def15d
    li x3, 0x17def15d
    csrw 0x8e1, x3

    #Address 0x8e1 Write value 0x262ae422
    li x3, 0x262ae422
    csrw 0x8e1, x3

    #Unmapped address 0x857 testing: random write/read operations
    #Address 0x857 read value
    csrr x14, 0x857

    #Unmapped address 0xa87 testing: random write/read operations
    #Address 0xa87 read value
    csrr x14, 0xa87

    #Address 0xa87 Write value 0xea30c852
    li x3, 0xea30c852
    csrw 0xa87, x3

    #Address 0xa87 Write value 0x6ed471f5
    li x3, 0x6ed471f5
    csrw 0xa87, x3

    #Unmapped address 0xdd1 testing: random write/read operations
    #Address 0xdd1 Write value 0xe5917a7f
    li x3, 0xe5917a7f
    csrw 0xdd1, x3

    #Unmapped address 0xa90 testing: random write/read operations
    #Address 0xa90 read value
    csrr x14, 0xa90

    #Address 0xa90 read value
    csrr x14, 0xa90

    #Unmapped address 0x9e3 testing: random write/read operations
    #Address 0x9e3 Write value 0x8fbf9153
    li x3, 0x8fbf9153
    csrw 0x9e3, x3

    #Address 0x9e3 read value
    csrr x14, 0x9e3

    #Address 0x9e3 Write value 0x50d888d8
    li x3, 0x50d888d8
    csrw 0x9e3, x3

    #Address 0x9e3 read value
    csrr x14, 0x9e3

    #Unmapped address 0xa88 testing: random write/read operations
    #Address 0xa88 Write value 0x51e2796b
    li x3, 0x51e2796b
    csrw 0xa88, x3

    #Address 0xa88 read value
    csrr x14, 0xa88

    #Address 0xa88 Write value 0xefea006f
    li x3, 0xefea006f
    csrw 0xa88, x3

    #Unmapped address 0x2d2 testing: random write/read operations
    #Address 0x2d2 Write value 0xb1c5f82e
    li x3, 0xb1c5f82e
    csrw 0x2d2, x3

    #Unmapped address 0x31d testing: random write/read operations
    #Address 0x31d Write value 0x276b7e48
    li x3, 0x276b7e48
    csrw 0x31d, x3

    #Unmapped address 0x272 testing: random write/read operations
    #Address 0x272 read value
    csrr x14, 0x272

    #Address 0x272 Write value 0xd39d0c8a
    li x3, 0xd39d0c8a
    csrw 0x272, x3

    #Address 0x272 read value
    csrr x14, 0x272

    #Unmapped address 0x4e0 testing: random write/read operations
    #Address 0x4e0 Write value 0x9771bd3b
    li x3, 0x9771bd3b
    csrw 0x4e0, x3

    #Unmapped address 0x8a5 testing: random write/read operations
    #Address 0x8a5 read value
    csrr x14, 0x8a5

    #Address 0x8a5 read value
    csrr x14, 0x8a5

    #Address 0x8a5 read value
    csrr x14, 0x8a5

    #Address 0x8a5 read value
    csrr x14, 0x8a5

    #Unmapped address 0x4a9 testing: random write/read operations
    #Address 0x4a9 Write value 0xc5b7e128
    li x3, 0xc5b7e128
    csrw 0x4a9, x3

    #Address 0x4a9 read value
    csrr x14, 0x4a9

    #Unmapped address 0xa3 testing: random write/read operations
    #Address 0xa3 Write value 0x69da2015
    li x3, 0x69da2015
    csrw 0xa3, x3

    #Address 0xa3 read value
    csrr x14, 0xa3

    #Address 0xa3 read value
    csrr x14, 0xa3

    #Address 0xa3 Write value 0xe466ed7c
    li x3, 0xe466ed7c
    csrw 0xa3, x3

    #Unmapped address 0x4b4 testing: random write/read operations
    #Address 0x4b4 Write value 0x590a0399
    li x3, 0x590a0399
    csrw 0x4b4, x3

    #Address 0x4b4 Write value 0x284ffeef
    li x3, 0x284ffeef
    csrw 0x4b4, x3

    #Address 0x4b4 read value
    csrr x14, 0x4b4

    #Address 0x4b4 read value
    csrr x14, 0x4b4

    #Unmapped address 0xe4 testing: random write/read operations
    #Address 0xe4 Write value 0x8850e44d
    li x3, 0x8850e44d
    csrw 0xe4, x3

    #Address 0xe4 read value
    csrr x14, 0xe4

    #Unmapped address 0xad3 testing: random write/read operations
    #Address 0xad3 Write value 0x1d68a2cb
    li x3, 0x1d68a2cb
    csrw 0xad3, x3

    #Address 0xad3 Write value 0x3d8131b
    li x3, 0x3d8131b
    csrw 0xad3, x3

    #Unmapped address 0x609 testing: random write/read operations
    #Address 0x609 read value
    csrr x14, 0x609

    #Address 0x609 Write value 0x91710827
    li x3, 0x91710827
    csrw 0x609, x3

    #Unmapped address 0x865 testing: random write/read operations
    #Address 0x865 Write value 0xcee31774
    li x3, 0xcee31774
    csrw 0x865, x3

    #Address 0x865 Write value 0x50f22762
    li x3, 0x50f22762
    csrw 0x865, x3

    #Address 0x865 Write value 0xa264ab7f
    li x3, 0xa264ab7f
    csrw 0x865, x3

    #Address 0x865 read value
    csrr x14, 0x865

    #Unmapped address 0xb37 testing: random write/read operations
    #Address 0xb37 Write value 0xaa0891b5
    li x3, 0xaa0891b5
    csrw 0xb37, x3

    #Address 0xb37 read value
    csrr x14, 0xb37

    #Unmapped address 0x897 testing: random write/read operations
    #Address 0x897 read value
    csrr x14, 0x897

    #Address 0x897 Write value 0x48dbe2d1
    li x3, 0x48dbe2d1
    csrw 0x897, x3

    #Unmapped address 0x837 testing: random write/read operations
    #Address 0x837 Write value 0x5d480795
    li x3, 0x5d480795
    csrw 0x837, x3

    #Unmapped address 0xab8 testing: random write/read operations
    #Address 0xab8 Write value 0xe3e7114f
    li x3, 0xe3e7114f
    csrw 0xab8, x3

    #Unmapped address 0x915 testing: random write/read operations
    #Address 0x915 Write value 0xd91b3bfe
    li x3, 0xd91b3bfe
    csrw 0x915, x3

    #Address 0x915 Write value 0x8480a6f8
    li x3, 0x8480a6f8
    csrw 0x915, x3

    #Address 0x915 read value
    csrr x14, 0x915

    #Address 0x915 read value
    csrr x14, 0x915

    #Address 0x915 Write value 0x18467d4f
    li x3, 0x18467d4f
    csrw 0x915, x3

    #Unmapped address 0x24c testing: random write/read operations
    #Address 0x24c Write value 0xd785e10b
    li x3, 0xd785e10b
    csrw 0x24c, x3

    #Address 0x24c read value
    csrr x14, 0x24c

    #Address 0x24c Write value 0x9ef2d6e4
    li x3, 0x9ef2d6e4
    csrw 0x24c, x3

    #Address 0x24c Write value 0x5bdf11a4
    li x3, 0x5bdf11a4
    csrw 0x24c, x3

    #Unmapped address 0x74b testing: random write/read operations
    #Address 0x74b Write value 0x199451e2
    li x3, 0x199451e2
    csrw 0x74b, x3

    #Address 0x74b Write value 0x4d788132
    li x3, 0x4d788132
    csrw 0x74b, x3

    #Address 0x74b read value
    csrr x14, 0x74b

    #Unmapped address 0x3eb testing: random write/read operations
    #Address 0x3eb read value
    csrr x14, 0x3eb

    #Address 0x3eb read value
    csrr x14, 0x3eb

    #Unmapped address 0x449 testing: random write/read operations
    #Address 0x449 read value
    csrr x14, 0x449

    #Address 0x449 Write value 0x787c92b7
    li x3, 0x787c92b7
    csrw 0x449, x3

    #Unmapped address 0x3ea testing: random write/read operations
    #Address 0x3ea Write value 0xff9fef91
    li x3, 0xff9fef91
    csrw 0x3ea, x3

    #Unmapped address 0x2ba testing: random write/read operations
    #Address 0x2ba Write value 0xa2945e2c
    li x3, 0xa2945e2c
    csrw 0x2ba, x3

    #Address 0x2ba Write value 0xb7e00b4e
    li x3, 0xb7e00b4e
    csrw 0x2ba, x3

    #Address 0x2ba Write value 0xc92ab2aa
    li x3, 0xc92ab2aa
    csrw 0x2ba, x3

    #Address 0x2ba Write value 0xc78e71e1
    li x3, 0xc78e71e1
    csrw 0x2ba, x3

    #Mapped address 0xb15 (mhpmcounter21) testing: random write/read operations
    #Address 0xb15 read value
    csrr x14, 0xb15

    #Address 0xb15 Write value 0x9c4688de
    li x3, 0x9c4688de
    csrw 0xb15, x3

    #Unmapped address 0x830 testing: random write/read operations
    #Address 0x830 read value
    csrr x14, 0x830

    #Address 0x830 read value
    csrr x14, 0x830

    #Address 0x830 Write value 0x238a4b3e
    li x3, 0x238a4b3e
    csrw 0x830, x3

    #Address 0x830 read value
    csrr x14, 0x830

    #Address 0x830 read value
    csrr x14, 0x830

    #Unmapped address 0x55f testing: random write/read operations
    #Address 0x55f Write value 0xe73bc290
    li x3, 0xe73bc290
    csrw 0x55f, x3

    #Address 0x55f read value
    csrr x14, 0x55f

    #Address 0x55f Write value 0x3c58e00d
    li x3, 0x3c58e00d
    csrw 0x55f, x3

    #Address 0x55f read value
    csrr x14, 0x55f

    #Address 0x55f read value
    csrr x14, 0x55f

    #Unmapped address 0x8ab testing: random write/read operations
    #Address 0x8ab Write value 0x166413ec
    li x3, 0x166413ec
    csrw 0x8ab, x3

    #Address 0x8ab Write value 0xb11413b
    li x3, 0xb11413b
    csrw 0x8ab, x3

    #Address 0x8ab read value
    csrr x14, 0x8ab

    #Unmapped address 0xd7a testing: random write/read operations
    #Address 0xd7a Write value 0x8c2987e6
    li x3, 0x8c2987e6
    csrw 0xd7a, x3

    #Address 0xd7a Write value 0x88a0f859
    li x3, 0x88a0f859
    csrw 0xd7a, x3

    #Address 0xd7a Write value 0xd3b599a5
    li x3, 0xd3b599a5
    csrw 0xd7a, x3

    #Address 0xd7a read value
    csrr x14, 0xd7a

    #Unmapped address 0x4dc testing: random write/read operations
    #Address 0x4dc read value
    csrr x14, 0x4dc

    #Address 0x4dc Write value 0x753804ad
    li x3, 0x753804ad
    csrw 0x4dc, x3

    #Address 0x4dc read value
    csrr x14, 0x4dc

    #Address 0x4dc read value
    csrr x14, 0x4dc

    #Address 0x4dc read value
    csrr x14, 0x4dc

    #Unmapped address 0x803 testing: random write/read operations
    #Address 0x803 Write value 0x32bf5d34
    li x3, 0x32bf5d34
    csrw 0x803, x3

    #Unmapped address 0x14f testing: random write/read operations
    #Address 0x14f Write value 0xa41ce4ea
    li x3, 0xa41ce4ea
    csrw 0x14f, x3

    #Address 0x14f Write value 0xe5c3ce36
    li x3, 0xe5c3ce36
    csrw 0x14f, x3

    #Address 0x14f read value
    csrr x14, 0x14f

    #Unmapped address 0x261 testing: random write/read operations
    #Address 0x261 Write value 0x44680827
    li x3, 0x44680827
    csrw 0x261, x3

    #Unmapped address 0x47d testing: random write/read operations
    #Address 0x47d read value
    csrr x14, 0x47d

    #Unmapped address 0xf38 testing: random write/read operations
    #Address 0xf38 read value
    csrr x14, 0xf38

    #Address 0xf38 Write value 0x728a17d9
    li x3, 0x728a17d9
    csrw 0xf38, x3

    #Unmapped address 0x2c6 testing: random write/read operations
    #Address 0x2c6 read value
    csrr x14, 0x2c6

    #Address 0x2c6 Write value 0x8fc26f97
    li x3, 0x8fc26f97
    csrw 0x2c6, x3

    #Unmapped address 0xc19 testing: random write/read operations
    #Address 0xc19 Write value 0xf9fb9921
    li x3, 0xf9fb9921
    csrw 0xc19, x3

    #Address 0xc19 read value
    csrr x14, 0xc19

    #Address 0xc19 read value
    csrr x14, 0xc19

    #Unmapped address 0xcab testing: random write/read operations
    #Address 0xcab read value
    csrr x14, 0xcab

    #Address 0xcab read value
    csrr x14, 0xcab

    #Unmapped address 0x349 testing: random write/read operations
    #Address 0x349 Write value 0x300773fd
    li x3, 0x300773fd
    csrw 0x349, x3

    #Address 0x349 Write value 0xe4b033e8
    li x3, 0xe4b033e8
    csrw 0x349, x3

    #Address 0x349 Write value 0x8c163c19
    li x3, 0x8c163c19
    csrw 0x349, x3

    #Address 0x349 Write value 0xc0cd18a9
    li x3, 0xc0cd18a9
    csrw 0x349, x3

    #Address 0x349 Write value 0x411e664d
    li x3, 0x411e664d
    csrw 0x349, x3

    #Unmapped address 0x2c8 testing: random write/read operations
    #Address 0x2c8 read value
    csrr x14, 0x2c8

    #Address 0x2c8 read value
    csrr x14, 0x2c8

    #Address 0x2c8 Write value 0xb10acfa4
    li x3, 0xb10acfa4
    csrw 0x2c8, x3

    #Address 0x2c8 Write value 0x59d94c5a
    li x3, 0x59d94c5a
    csrw 0x2c8, x3

    #Unmapped address 0x945 testing: random write/read operations
    #Address 0x945 Write value 0xcc7fd5e5
    li x3, 0xcc7fd5e5
    csrw 0x945, x3

    #Address 0x945 Write value 0xe35d88e0
    li x3, 0xe35d88e0
    csrw 0x945, x3

    #Address 0x945 read value
    csrr x14, 0x945

    #Address 0x945 read value
    csrr x14, 0x945

    #Address 0x945 Write value 0x15855b0d
    li x3, 0x15855b0d
    csrw 0x945, x3

    #Unmapped address 0x712 testing: random write/read operations
    #Address 0x712 read value
    csrr x14, 0x712

    #Address 0x712 read value
    csrr x14, 0x712

    #Address 0x712 read value
    csrr x14, 0x712

    #Address 0x712 Write value 0x1340f028
    li x3, 0x1340f028
    csrw 0x712, x3

    #Address 0x712 read value
    csrr x14, 0x712

    #Unmapped address 0x7c9 testing: random write/read operations
    #Address 0x7c9 Write value 0xe8b1931b
    li x3, 0xe8b1931b
    csrw 0x7c9, x3

    #Unmapped address 0xc7c testing: random write/read operations
    #Address 0xc7c Write value 0x9623de45
    li x3, 0x9623de45
    csrw 0xc7c, x3

    #Address 0xc7c Write value 0xe7a44a2e
    li x3, 0xe7a44a2e
    csrw 0xc7c, x3

    #Address 0xc7c Write value 0x2fdc929e
    li x3, 0x2fdc929e
    csrw 0xc7c, x3

    #Unmapped address 0x964 testing: random write/read operations
    #Address 0x964 Write value 0xe3eb8e47
    li x3, 0xe3eb8e47
    csrw 0x964, x3

    #Address 0x964 Write value 0x54f09aa7
    li x3, 0x54f09aa7
    csrw 0x964, x3

    #Unmapped address 0x7ea testing: random write/read operations
    #Address 0x7ea Write value 0x532aa0a6
    li x3, 0x532aa0a6
    csrw 0x7ea, x3

    #Address 0x7ea Write value 0x91b23401
    li x3, 0x91b23401
    csrw 0x7ea, x3

    #Address 0x7ea Write value 0xe20f0754
    li x3, 0xe20f0754
    csrw 0x7ea, x3

    #Address 0x7ea read value
    csrr x14, 0x7ea

    #Unmapped address 0x177 testing: random write/read operations
    #Address 0x177 Write value 0xdecfa327
    li x3, 0xdecfa327
    csrw 0x177, x3

    #Address 0x177 read value
    csrr x14, 0x177

    #Address 0x177 Write value 0xc8effa2d
    li x3, 0xc8effa2d
    csrw 0x177, x3

    #Address 0x177 Write value 0x1ab40fab
    li x3, 0x1ab40fab
    csrw 0x177, x3

    #Unmapped address 0x423 testing: random write/read operations
    #Address 0x423 Write value 0x5f158d72
    li x3, 0x5f158d72
    csrw 0x423, x3

    #Unmapped address 0x5ca testing: random write/read operations
    #Address 0x5ca read value
    csrr x14, 0x5ca

    #Address 0x5ca read value
    csrr x14, 0x5ca

    #Address 0x5ca Write value 0xc81cd14d
    li x3, 0xc81cd14d
    csrw 0x5ca, x3

    #Address 0x5ca read value
    csrr x14, 0x5ca

    #Unmapped address 0x525 testing: random write/read operations
    #Address 0x525 read value
    csrr x14, 0x525

    #Unmapped address 0xbbb testing: random write/read operations
    #Address 0xbbb read value
    csrr x14, 0xbbb

    #Address 0xbbb read value
    csrr x14, 0xbbb

    #Unmapped address 0x967 testing: random write/read operations
    #Address 0x967 read value
    csrr x14, 0x967

    #Address 0x967 read value
    csrr x14, 0x967

    #Unmapped address 0xa67 testing: random write/read operations
    #Address 0xa67 Write value 0x615af0ac
    li x3, 0x615af0ac
    csrw 0xa67, x3

    #Unmapped address 0xd67 testing: random write/read operations
    #Address 0xd67 read value
    csrr x14, 0xd67

    #Address 0xd67 read value
    csrr x14, 0xd67

    #Address 0xd67 read value
    csrr x14, 0xd67

    #Address 0xd67 Write value 0xa89a1afe
    li x3, 0xa89a1afe
    csrw 0xd67, x3

    #Address 0xd67 read value
    csrr x14, 0xd67

    #Unmapped address 0xae testing: random write/read operations
    #Address 0xae read value
    csrr x14, 0xae

    #Address 0xae Write value 0xd3c0a8cf
    li x3, 0xd3c0a8cf
    csrw 0xae, x3

    #Address 0xae Write value 0xc580dedd
    li x3, 0xc580dedd
    csrw 0xae, x3

    #Unmapped address 0x8b7 testing: random write/read operations
    #Address 0x8b7 Write value 0xdf844616
    li x3, 0xdf844616
    csrw 0x8b7, x3

    #Unmapped address 0x6eb testing: random write/read operations
    #Address 0x6eb read value
    csrr x14, 0x6eb

    #Unmapped address 0x670 testing: random write/read operations
    #Address 0x670 Write value 0x538bfe9a
    li x3, 0x538bfe9a
    csrw 0x670, x3

    #Address 0x670 Write value 0x1cc64a58
    li x3, 0x1cc64a58
    csrw 0x670, x3

    #Address 0x670 Write value 0x38cecac9
    li x3, 0x38cecac9
    csrw 0x670, x3

    #Unmapped address 0x94d testing: random write/read operations
    #Address 0x94d Write value 0x9ac34bf5
    li x3, 0x9ac34bf5
    csrw 0x94d, x3

    #Unmapped address 0xd9a testing: random write/read operations
    #Address 0xd9a Write value 0xf9316666
    li x3, 0xf9316666
    csrw 0xd9a, x3

    #Unmapped address 0x668 testing: random write/read operations
    #Address 0x668 Write value 0xc6039e67
    li x3, 0xc6039e67
    csrw 0x668, x3

    #Address 0x668 Write value 0xf7cfe51a
    li x3, 0xf7cfe51a
    csrw 0x668, x3

    #Address 0x668 Write value 0x9b58257a
    li x3, 0x9b58257a
    csrw 0x668, x3

    #Address 0x668 read value
    csrr x14, 0x668

    #Unmapped address 0x706 testing: random write/read operations
    #Address 0x706 read value
    csrr x14, 0x706

    #Address 0x706 Write value 0x4c46079a
    li x3, 0x4c46079a
    csrw 0x706, x3

    #Address 0x706 Write value 0x6e186ac0
    li x3, 0x6e186ac0
    csrw 0x706, x3

    #Address 0x706 read value
    csrr x14, 0x706

    #Unmapped address 0x9f9 testing: random write/read operations
    #Address 0x9f9 Write value 0x2bdeb730
    li x3, 0x2bdeb730
    csrw 0x9f9, x3

    #Address 0x9f9 Write value 0x1ecdb3bf
    li x3, 0x1ecdb3bf
    csrw 0x9f9, x3

    #Address 0x9f9 read value
    csrr x14, 0x9f9

    #Address 0x9f9 Write value 0xb10c5cb6
    li x3, 0xb10c5cb6
    csrw 0x9f9, x3

    #Address 0x9f9 Write value 0x57bc3cd3
    li x3, 0x57bc3cd3
    csrw 0x9f9, x3

    #Unmapped address 0xaf1 testing: random write/read operations
    #Address 0xaf1 read value
    csrr x14, 0xaf1

    #Address 0xaf1 read value
    csrr x14, 0xaf1

    #Address 0xaf1 Write value 0x7712bda4
    li x3, 0x7712bda4
    csrw 0xaf1, x3

    #Address 0xaf1 Write value 0x9f0022d6
    li x3, 0x9f0022d6
    csrw 0xaf1, x3

    #Unmapped address 0x53c testing: random write/read operations
    #Address 0x53c read value
    csrr x14, 0x53c

    #Unmapped address 0x6fd testing: random write/read operations
    #Address 0x6fd Write value 0x700b76e8
    li x3, 0x700b76e8
    csrw 0x6fd, x3

    #Address 0x6fd Write value 0x8ba8467b
    li x3, 0x8ba8467b
    csrw 0x6fd, x3

    #Unmapped address 0x7b3 testing: random write/read operations
    #Address 0x7b3 Write value 0x2f5ef1f5
    li x3, 0x2f5ef1f5
    csrw 0x7b3, x3

    #Address 0x7b3 read value
    csrr x14, 0x7b3

    #Address 0x7b3 Write value 0x3e81fe62
    li x3, 0x3e81fe62
    csrw 0x7b3, x3

    #Address 0x7b3 read value
    csrr x14, 0x7b3

    #Unmapped address 0x7b9 testing: random write/read operations
    #Address 0x7b9 Write value 0xaf464105
    li x3, 0xaf464105
    csrw 0x7b9, x3

    #Address 0x7b9 read value
    csrr x14, 0x7b9

    #Address 0x7b9 read value
    csrr x14, 0x7b9

    #Unmapped address 0xae7 testing: random write/read operations
    #Address 0xae7 read value
    csrr x14, 0xae7

    #Address 0xae7 read value
    csrr x14, 0xae7

    #Address 0xae7 Write value 0x5d7fa1dd
    li x3, 0x5d7fa1dd
    csrw 0xae7, x3

    #Unmapped address 0x8a0 testing: random write/read operations
    #Address 0x8a0 Write value 0xca624efb
    li x3, 0xca624efb
    csrw 0x8a0, x3

    #Unmapped address 0x24f testing: random write/read operations
    #Address 0x24f Write value 0xd3ebfbe5
    li x3, 0xd3ebfbe5
    csrw 0x24f, x3

    #Address 0x24f read value
    csrr x14, 0x24f

    #Address 0x24f Write value 0x5caf29f5
    li x3, 0x5caf29f5
    csrw 0x24f, x3

    #Address 0x24f read value
    csrr x14, 0x24f

    #Unmapped address 0x44b testing: random write/read operations
    #Address 0x44b Write value 0xf3671634
    li x3, 0xf3671634
    csrw 0x44b, x3

    #Unmapped address 0x733 testing: random write/read operations
    #Address 0x733 read value
    csrr x14, 0x733

    #Address 0x733 Write value 0xc5f749ad
    li x3, 0xc5f749ad
    csrw 0x733, x3

    #Mapped address 0x3bd (pmpaddr13) testing: random write/read operations
    #Address 0x3bd read value
    csrr x14, 0x3bd

    #Address 0x3bd read value
    csrr x14, 0x3bd

    #Address 0x3bd read value
    csrr x14, 0x3bd

    #Address 0x3bd read value
    csrr x14, 0x3bd

    #Address 0x3bd Write value 0x5be283a6
    li x3, 0x5be283a6
    csrw 0x3bd, x3

    #Unmapped address 0x6ed testing: random write/read operations
    #Address 0x6ed Write value 0xd121162f
    li x3, 0xd121162f
    csrw 0x6ed, x3

    #Unmapped address 0x88e testing: random write/read operations
    #Address 0x88e Write value 0x30cf037f
    li x3, 0x30cf037f
    csrw 0x88e, x3

    #Address 0x88e Write value 0xbea3e194
    li x3, 0xbea3e194
    csrw 0x88e, x3

    #Unmapped address 0x9ce testing: random write/read operations
    #Address 0x9ce read value
    csrr x14, 0x9ce

    #Address 0x9ce read value
    csrr x14, 0x9ce

    #Unmapped address 0x4db testing: random write/read operations
    #Address 0x4db Write value 0x888e7458
    li x3, 0x888e7458
    csrw 0x4db, x3

    #Address 0x4db read value
    csrr x14, 0x4db

    #Address 0x4db read value
    csrr x14, 0x4db

    #Address 0x4db read value
    csrr x14, 0x4db

    #Address 0x4db Write value 0xd6130983
    li x3, 0xd6130983
    csrw 0x4db, x3

    #Unmapped address 0x230 testing: random write/read operations
    #Address 0x230 Write value 0x77c084e7
    li x3, 0x77c084e7
    csrw 0x230, x3

    #Address 0x230 read value
    csrr x14, 0x230

    #Address 0x230 Write value 0x7209f72b
    li x3, 0x7209f72b
    csrw 0x230, x3

    #Address 0x230 read value
    csrr x14, 0x230

    #Address 0x230 Write value 0x6cadfe17
    li x3, 0x6cadfe17
    csrw 0x230, x3

    #Unmapped address 0xdf testing: random write/read operations
    #Address 0xdf Write value 0xcbce6c43
    li x3, 0xcbce6c43
    csrw 0xdf, x3

    #Address 0xdf Write value 0x8241c6cf
    li x3, 0x8241c6cf
    csrw 0xdf, x3

    #Address 0xdf read value
    csrr x14, 0xdf

    #Address 0xdf Write value 0x449a4457
    li x3, 0x449a4457
    csrw 0xdf, x3

    #Unmapped address 0xf50 testing: random write/read operations
    #Address 0xf50 Write value 0x80471cd
    li x3, 0x80471cd
    csrw 0xf50, x3

    #Address 0xf50 Write value 0x2aadceac
    li x3, 0x2aadceac
    csrw 0xf50, x3

    #Unmapped address 0x641 testing: random write/read operations
    #Address 0x641 read value
    csrr x14, 0x641

    #Address 0x641 read value
    csrr x14, 0x641

    #Address 0x641 read value
    csrr x14, 0x641

    #Address 0x641 read value
    csrr x14, 0x641

    #Address 0x641 Write value 0xcc0c940f
    li x3, 0xcc0c940f
    csrw 0x641, x3

    #Unmapped address 0x7b7 testing: random write/read operations
    #Address 0x7b7 read value
    csrr x14, 0x7b7

    #Address 0x7b7 Write value 0xceb71e54
    li x3, 0xceb71e54
    csrw 0x7b7, x3

    #Address 0x7b7 Write value 0x6aafab6a
    li x3, 0x6aafab6a
    csrw 0x7b7, x3

    #Address 0x7b7 Write value 0x7a27f4d3
    li x3, 0x7a27f4d3
    csrw 0x7b7, x3

    #Address 0x7b7 Write value 0xd358210f
    li x3, 0xd358210f
    csrw 0x7b7, x3

    #Unmapped address 0x9e7 testing: random write/read operations
    #Address 0x9e7 read value
    csrr x14, 0x9e7

    #Address 0x9e7 read value
    csrr x14, 0x9e7

    #Address 0x9e7 Write value 0xf487b333
    li x3, 0xf487b333
    csrw 0x9e7, x3

    #Address 0x9e7 Write value 0xa3fa43c0
    li x3, 0xa3fa43c0
    csrw 0x9e7, x3

    #Address 0x9e7 read value
    csrr x14, 0x9e7

    #Unmapped address 0x3e9 testing: random write/read operations
    #Address 0x3e9 Write value 0x8a81eb5e
    li x3, 0x8a81eb5e
    csrw 0x3e9, x3

    #Address 0x3e9 read value
    csrr x14, 0x3e9

    #Address 0x3e9 Write value 0x46ab6e5e
    li x3, 0x46ab6e5e
    csrw 0x3e9, x3

    #Address 0x3e9 read value
    csrr x14, 0x3e9

    #Address 0x3e9 read value
    csrr x14, 0x3e9

    #Unmapped address 0x120 testing: random write/read operations
    #Address 0x120 read value
    csrr x14, 0x120

    #Address 0x120 read value
    csrr x14, 0x120

    #Address 0x120 Write value 0x5721ac66
    li x3, 0x5721ac66
    csrw 0x120, x3

    #Address 0x120 Write value 0x9c8c9183
    li x3, 0x9c8c9183
    csrw 0x120, x3

    #Address 0x120 Write value 0xc7211434
    li x3, 0xc7211434
    csrw 0x120, x3

    #Unmapped address 0xc91 testing: random write/read operations
    #Address 0xc91 read value
    csrr x14, 0xc91

    #Unmapped address 0xc4a testing: random write/read operations
    #Address 0xc4a read value
    csrr x14, 0xc4a

    #Address 0xc4a read value
    csrr x14, 0xc4a

    #Unmapped address 0xa18 testing: random write/read operations
    #Address 0xa18 read value
    csrr x14, 0xa18

    #Address 0xa18 Write value 0x656c760a
    li x3, 0x656c760a
    csrw 0xa18, x3

    #Unmapped address 0x42b testing: random write/read operations
    #Address 0x42b Write value 0xef5fdaf8
    li x3, 0xef5fdaf8
    csrw 0x42b, x3

    #Address 0x42b read value
    csrr x14, 0x42b

    #Address 0x42b read value
    csrr x14, 0x42b

    #Unmapped address 0x2d testing: random write/read operations
    #Address 0x2d read value
    csrr x14, 0x2d

    #Unmapped address 0x6a testing: random write/read operations
    #Address 0x6a Write value 0xfde627b9
    li x3, 0xfde627b9
    csrw 0x6a, x3

    #Mapped address 0xb84 (mhpmcounterh4) testing: random write/read operations
    #Address 0xb84 read value
    csrr x14, 0xb84

    #Address 0xb84 Write value 0xa63b15db
    li x3, 0xa63b15db
    csrw 0xb84, x3

    #Address 0xb84 read value
    csrr x14, 0xb84

    #Address 0xb84 Write value 0x579a53f3
    li x3, 0x579a53f3
    csrw 0xb84, x3

    #Unmapped address 0xf74 testing: random write/read operations
    #Address 0xf74 read value
    csrr x14, 0xf74

    #Address 0xf74 read value
    csrr x14, 0xf74

    #Address 0xf74 Write value 0x9bdf1160
    li x3, 0x9bdf1160
    csrw 0xf74, x3

    #Address 0xf74 read value
    csrr x14, 0xf74

    #Unmapped address 0xf87 testing: random write/read operations
    #Address 0xf87 Write value 0x7965c337
    li x3, 0x7965c337
    csrw 0xf87, x3

    #Address 0xf87 read value
    csrr x14, 0xf87

    #Address 0xf87 read value
    csrr x14, 0xf87

    #Unmapped address 0xd9e testing: random write/read operations
    #Address 0xd9e read value
    csrr x14, 0xd9e

    #Unmapped address 0x923 testing: random write/read operations
    #Address 0x923 read value
    csrr x14, 0x923

    #Address 0x923 Write value 0xd9f8c3a8
    li x3, 0xd9f8c3a8
    csrw 0x923, x3

    #Address 0x923 Write value 0x53dbabaa
    li x3, 0x53dbabaa
    csrw 0x923, x3

    #Address 0x923 Write value 0xe1b30089
    li x3, 0xe1b30089
    csrw 0x923, x3

    #Unmapped address 0xaed testing: random write/read operations
    #Address 0xaed read value
    csrr x14, 0xaed

    #Address 0xaed read value
    csrr x14, 0xaed

    #Address 0xaed Write value 0xc865cba4
    li x3, 0xc865cba4
    csrw 0xaed, x3

    #Address 0xaed Write value 0xeabcc0ac
    li x3, 0xeabcc0ac
    csrw 0xaed, x3

    #Address 0xaed read value
    csrr x14, 0xaed

    #Unmapped address 0x2ee testing: random write/read operations
    #Address 0x2ee read value
    csrr x14, 0x2ee

    #Address 0x2ee Write value 0xcab0295d
    li x3, 0xcab0295d
    csrw 0x2ee, x3

    #Unmapped address 0x788 testing: random write/read operations
    #Address 0x788 Write value 0xa7c56e9f
    li x3, 0xa7c56e9f
    csrw 0x788, x3

    #Address 0x788 Write value 0xfffeb1f2
    li x3, 0xfffeb1f2
    csrw 0x788, x3

    #Address 0x788 read value
    csrr x14, 0x788

    #Unmapped address 0x1c9 testing: random write/read operations
    #Address 0x1c9 Write value 0x684679f0
    li x3, 0x684679f0
    csrw 0x1c9, x3

    #Address 0x1c9 Write value 0xa6e97b3e
    li x3, 0xa6e97b3e
    csrw 0x1c9, x3

    #Address 0x1c9 read value
    csrr x14, 0x1c9

    #Address 0x1c9 Write value 0xdce3b9da
    li x3, 0xdce3b9da
    csrw 0x1c9, x3

    #Address 0x1c9 read value
    csrr x14, 0x1c9

    #Unmapped address 0x7b8 testing: random write/read operations
    #Address 0x7b8 Write value 0x72ac39de
    li x3, 0x72ac39de
    csrw 0x7b8, x3

    #Unmapped address 0x57c testing: random write/read operations
    #Address 0x57c read value
    csrr x14, 0x57c

    #Address 0x57c read value
    csrr x14, 0x57c

    #Address 0x57c read value
    csrr x14, 0x57c

    #Address 0x57c read value
    csrr x14, 0x57c

    #Address 0x57c Write value 0x1c50a6c1
    li x3, 0x1c50a6c1
    csrw 0x57c, x3

    #Unmapped address 0xe27 testing: random write/read operations
    #Address 0xe27 Write value 0xe989b710
    li x3, 0xe989b710
    csrw 0xe27, x3

    #Address 0xe27 read value
    csrr x14, 0xe27

    #Address 0xe27 Write value 0x5e60d203
    li x3, 0x5e60d203
    csrw 0xe27, x3

    #Address 0xe27 read value
    csrr x14, 0xe27

    #Unmapped address 0x6f9 testing: random write/read operations
    #Address 0x6f9 read value
    csrr x14, 0x6f9

    #Address 0x6f9 read value
    csrr x14, 0x6f9

    #Address 0x6f9 read value
    csrr x14, 0x6f9

    #Address 0x6f9 read value
    csrr x14, 0x6f9

    #Unmapped address 0xb75 testing: random write/read operations
    #Address 0xb75 read value
    csrr x14, 0xb75

    #Address 0xb75 Write value 0x339ddf70
    li x3, 0x339ddf70
    csrw 0xb75, x3

    #Address 0xb75 Write value 0x3595bfd0
    li x3, 0x3595bfd0
    csrw 0xb75, x3

    #Unmapped address 0x481 testing: random write/read operations
    #Address 0x481 read value
    csrr x14, 0x481

    #Address 0x481 Write value 0x774e4874
    li x3, 0x774e4874
    csrw 0x481, x3

    #Unmapped address 0x2b8 testing: random write/read operations
    #Address 0x2b8 Write value 0x21e39744
    li x3, 0x21e39744
    csrw 0x2b8, x3

    #Address 0x2b8 read value
    csrr x14, 0x2b8

    #Address 0x2b8 read value
    csrr x14, 0x2b8

    #Address 0x2b8 Write value 0xbb53f166
    li x3, 0xbb53f166
    csrw 0x2b8, x3

    #Unmapped address 0x105 testing: random write/read operations
    #Address 0x105 read value
    csrr x14, 0x105

    #Address 0x105 read value
    csrr x14, 0x105

    #Address 0x105 read value
    csrr x14, 0x105

    #Unmapped address 0xec1 testing: random write/read operations
    #Address 0xec1 Write value 0x67c780b
    li x3, 0x67c780b
    csrw 0xec1, x3

    #Unmapped address 0x62 testing: random write/read operations
    #Address 0x62 read value
    csrr x14, 0x62

    #Unmapped address 0x691 testing: random write/read operations
    #Address 0x691 read value
    csrr x14, 0x691

    #Unmapped address 0x5be testing: random write/read operations
    #Address 0x5be read value
    csrr x14, 0x5be

    #Unmapped address 0xa24 testing: random write/read operations
    #Address 0xa24 read value
    csrr x14, 0xa24

    #Address 0xa24 read value
    csrr x14, 0xa24

    #Address 0xa24 Write value 0xef57d35a
    li x3, 0xef57d35a
    csrw 0xa24, x3

    #Address 0xa24 read value
    csrr x14, 0xa24

    #Unmapped address 0xa4b testing: random write/read operations
    #Address 0xa4b read value
    csrr x14, 0xa4b

    #Unmapped address 0xc29 testing: random write/read operations
    #Address 0xc29 read value
    csrr x14, 0xc29

    #Address 0xc29 Write value 0x70ac7868
    li x3, 0x70ac7868
    csrw 0xc29, x3

    #Address 0xc29 read value
    csrr x14, 0xc29

    #Address 0xc29 Write value 0x37e9c06f
    li x3, 0x37e9c06f
    csrw 0xc29, x3

    #Address 0xc29 read value
    csrr x14, 0xc29

    #Unmapped address 0x3f2 testing: random write/read operations
    #Address 0x3f2 read value
    csrr x14, 0x3f2

    #Address 0x3f2 Write value 0x54555aa8
    li x3, 0x54555aa8
    csrw 0x3f2, x3

    #Address 0x3f2 read value
    csrr x14, 0x3f2

    #Unmapped address 0x3d0 testing: random write/read operations
    #Address 0x3d0 Write value 0xc3a41efc
    li x3, 0xc3a41efc
    csrw 0x3d0, x3

    #Unmapped address 0xc88 testing: random write/read operations
    #Address 0xc88 Write value 0x1cef8ee4
    li x3, 0x1cef8ee4
    csrw 0xc88, x3

    #Address 0xc88 read value
    csrr x14, 0xc88

    #Address 0xc88 read value
    csrr x14, 0xc88

    #Address 0xc88 read value
    csrr x14, 0xc88

    #Unmapped address 0xf44 testing: random write/read operations
    #Address 0xf44 Write value 0x2496b665
    li x3, 0x2496b665
    csrw 0xf44, x3

    #Address 0xf44 read value
    csrr x14, 0xf44

    #Address 0xf44 read value
    csrr x14, 0xf44

    #Address 0xf44 read value
    csrr x14, 0xf44

    #Unmapped address 0x388 testing: random write/read operations
    #Address 0x388 read value
    csrr x14, 0x388

    #Address 0x388 Write value 0x58a6f4fd
    li x3, 0x58a6f4fd
    csrw 0x388, x3

    #Address 0x388 read value
    csrr x14, 0x388

    #Address 0x388 read value
    csrr x14, 0x388

    #Unmapped address 0xa27 testing: random write/read operations
    #Address 0xa27 read value
    csrr x14, 0xa27

    #Address 0xa27 read value
    csrr x14, 0xa27

    #Address 0xa27 read value
    csrr x14, 0xa27

    #Address 0xa27 read value
    csrr x14, 0xa27

    #Address 0xa27 read value
    csrr x14, 0xa27

    #Unmapped address 0x2f0 testing: random write/read operations
    #Address 0x2f0 Write value 0x7399f254
    li x3, 0x7399f254
    csrw 0x2f0, x3

    #Address 0x2f0 Write value 0x950d0a18
    li x3, 0x950d0a18
    csrw 0x2f0, x3

    #Address 0x2f0 read value
    csrr x14, 0x2f0

    #Unmapped address 0x172 testing: random write/read operations
    #Address 0x172 Write value 0x35f6a251
    li x3, 0x35f6a251
    csrw 0x172, x3

    #Address 0x172 Write value 0x43fb3cf
    li x3, 0x43fb3cf
    csrw 0x172, x3

    #Address 0x172 Write value 0x9dbc354c
    li x3, 0x9dbc354c
    csrw 0x172, x3

    #Unmapped address 0x5c1 testing: random write/read operations
    #Address 0x5c1 read value
    csrr x14, 0x5c1

    #Unmapped address 0xaff testing: random write/read operations
    #Address 0xaff read value
    csrr x14, 0xaff

    #Address 0xaff Write value 0x22c2e66f
    li x3, 0x22c2e66f
    csrw 0xaff, x3

    #Address 0xaff read value
    csrr x14, 0xaff

    #Address 0xaff read value
    csrr x14, 0xaff

    #Address 0xaff read value
    csrr x14, 0xaff

    #Unmapped address 0x5e0 testing: random write/read operations
    #Address 0x5e0 read value
    csrr x14, 0x5e0

    #Address 0x5e0 read value
    csrr x14, 0x5e0

    #Address 0x5e0 Write value 0x7e190599
    li x3, 0x7e190599
    csrw 0x5e0, x3

    #Unmapped address 0x2ae testing: random write/read operations
    #Address 0x2ae read value
    csrr x14, 0x2ae

    #Address 0x2ae read value
    csrr x14, 0x2ae

    #Address 0x2ae read value
    csrr x14, 0x2ae

    #Address 0x2ae Write value 0xd41e94c
    li x3, 0xd41e94c
    csrw 0x2ae, x3

    #Unmapped address 0xe7b testing: random write/read operations
    #Address 0xe7b Write value 0xe89b7bf9
    li x3, 0xe89b7bf9
    csrw 0xe7b, x3

    #Address 0xe7b Write value 0x5d461373
    li x3, 0x5d461373
    csrw 0xe7b, x3

    #Address 0xe7b Write value 0x725c077b
    li x3, 0x725c077b
    csrw 0xe7b, x3

    #Unmapped address 0x3e8 testing: random write/read operations
    #Address 0x3e8 Write value 0x9cdf34cc
    li x3, 0x9cdf34cc
    csrw 0x3e8, x3

    #Address 0x3e8 Write value 0x36ad27ed
    li x3, 0x36ad27ed
    csrw 0x3e8, x3

    #Address 0x3e8 Write value 0x480caa8c
    li x3, 0x480caa8c
    csrw 0x3e8, x3

    #Address 0x3e8 Write value 0xb062c832
    li x3, 0xb062c832
    csrw 0x3e8, x3

    #Address 0x3e8 Write value 0x5aa93574
    li x3, 0x5aa93574
    csrw 0x3e8, x3

    #Unmapped address 0xd55 testing: random write/read operations
    #Address 0xd55 read value
    csrr x14, 0xd55

    #Address 0xd55 read value
    csrr x14, 0xd55

    #Address 0xd55 read value
    csrr x14, 0xd55

    #Address 0xd55 read value
    csrr x14, 0xd55

    #Address 0xd55 read value
    csrr x14, 0xd55

    #Unmapped address 0x1c2 testing: random write/read operations
    #Address 0x1c2 read value
    csrr x14, 0x1c2

    #Unmapped address 0x742 testing: random write/read operations
    #Address 0x742 Write value 0xfee7edf6
    li x3, 0xfee7edf6
    csrw 0x742, x3

    #Address 0x742 Write value 0x10ecec8b
    li x3, 0x10ecec8b
    csrw 0x742, x3

    #Address 0x742 read value
    csrr x14, 0x742

    #Address 0x742 Write value 0x82b3ed6c
    li x3, 0x82b3ed6c
    csrw 0x742, x3

    #Address 0x742 read value
    csrr x14, 0x742

    #Unmapped address 0x871 testing: random write/read operations
    #Address 0x871 read value
    csrr x14, 0x871

    #Address 0x871 Write value 0x1ed465e5
    li x3, 0x1ed465e5
    csrw 0x871, x3

    #Address 0x871 Write value 0x22792081
    li x3, 0x22792081
    csrw 0x871, x3

    #Address 0x871 Write value 0xb948fa5b
    li x3, 0xb948fa5b
    csrw 0x871, x3

    #Address 0x871 read value
    csrr x14, 0x871

    #Unmapped address 0x832 testing: random write/read operations
    #Address 0x832 Write value 0x1ab5525d
    li x3, 0x1ab5525d
    csrw 0x832, x3

    #Address 0x832 read value
    csrr x14, 0x832

    #Address 0x832 Write value 0x7b3e844e
    li x3, 0x7b3e844e
    csrw 0x832, x3

    #Address 0x832 Write value 0x70bd0996
    li x3, 0x70bd0996
    csrw 0x832, x3

    #Unmapped address 0x6d4 testing: random write/read operations
    #Address 0x6d4 read value
    csrr x14, 0x6d4

    #Address 0x6d4 Write value 0x25f529b8
    li x3, 0x25f529b8
    csrw 0x6d4, x3

    #Address 0x6d4 Write value 0x51ef39af
    li x3, 0x51ef39af
    csrw 0x6d4, x3

    #Address 0x6d4 Write value 0xe5016dee
    li x3, 0xe5016dee
    csrw 0x6d4, x3

    #Unmapped address 0x48 testing: random write/read operations
    #Address 0x48 read value
    csrr x14, 0x48

    #Address 0x48 read value
    csrr x14, 0x48

    #Address 0x48 Write value 0xfe3293ee
    li x3, 0xfe3293ee
    csrw 0x48, x3

    #Address 0x48 Write value 0xb2b17142
    li x3, 0xb2b17142
    csrw 0x48, x3

    #Address 0x48 read value
    csrr x14, 0x48

    #Unmapped address 0xd34 testing: random write/read operations
    #Address 0xd34 read value
    csrr x14, 0xd34

    #Address 0xd34 read value
    csrr x14, 0xd34

    #Address 0xd34 read value
    csrr x14, 0xd34

    #Address 0xd34 Write value 0xf4f1e3b1
    li x3, 0xf4f1e3b1
    csrw 0xd34, x3

    #Unmapped address 0x9e0 testing: random write/read operations
    #Address 0x9e0 read value
    csrr x14, 0x9e0

    #Address 0x9e0 Write value 0x699ac26
    li x3, 0x699ac26
    csrw 0x9e0, x3

    #Address 0x9e0 read value
    csrr x14, 0x9e0

    #Unmapped address 0xbc4 testing: random write/read operations
    #Address 0xbc4 Write value 0xc10ee0a0
    li x3, 0xc10ee0a0
    csrw 0xbc4, x3

    #Unmapped address 0xf56 testing: random write/read operations
    #Address 0xf56 Write value 0x6d1079fe
    li x3, 0x6d1079fe
    csrw 0xf56, x3

    #Address 0xf56 read value
    csrr x14, 0xf56

    #Unmapped address 0x283 testing: random write/read operations
    #Address 0x283 read value
    csrr x14, 0x283

    #Address 0x283 read value
    csrr x14, 0x283

    #Address 0x283 Write value 0x9213e99f
    li x3, 0x9213e99f
    csrw 0x283, x3

    #Unmapped address 0x62d testing: random write/read operations
    #Address 0x62d Write value 0x8d1803d3
    li x3, 0x8d1803d3
    csrw 0x62d, x3

    #Address 0x62d Write value 0xb8d8064a
    li x3, 0xb8d8064a
    csrw 0x62d, x3

    #Address 0x62d Write value 0x1d4b13af
    li x3, 0x1d4b13af
    csrw 0x62d, x3

    #Address 0x62d Write value 0xc4cdc050
    li x3, 0xc4cdc050
    csrw 0x62d, x3

    #Unmapped address 0x4e testing: random write/read operations
    #Address 0x4e Write value 0xe4252840
    li x3, 0xe4252840
    csrw 0x4e, x3

    #Address 0x4e Write value 0x6f813547
    li x3, 0x6f813547
    csrw 0x4e, x3

    #Address 0x4e read value
    csrr x14, 0x4e

    #Address 0x4e Write value 0x8c01c2e3
    li x3, 0x8c01c2e3
    csrw 0x4e, x3

    #Unmapped address 0xc5b testing: random write/read operations
    #Address 0xc5b read value
    csrr x14, 0xc5b

    #Address 0xc5b read value
    csrr x14, 0xc5b

    #Address 0xc5b Write value 0xd9ca958e
    li x3, 0xd9ca958e
    csrw 0xc5b, x3

    #Address 0xc5b Write value 0x6c16ad37
    li x3, 0x6c16ad37
    csrw 0xc5b, x3

    #Address 0xc5b Write value 0x211e3660
    li x3, 0x211e3660
    csrw 0xc5b, x3

    #Unmapped address 0x8dd testing: random write/read operations
    #Address 0x8dd read value
    csrr x14, 0x8dd

    #Unmapped address 0x701 testing: random write/read operations
    #Address 0x701 read value
    csrr x14, 0x701

    #Address 0x701 read value
    csrr x14, 0x701

    #Address 0x701 Write value 0x9f437ed2
    li x3, 0x9f437ed2
    csrw 0x701, x3

    #Address 0x701 read value
    csrr x14, 0x701

    #Address 0x701 read value
    csrr x14, 0x701

    #Unmapped address 0xc05 testing: random write/read operations
    #Address 0xc05 read value
    csrr x14, 0xc05

    #Address 0xc05 Write value 0xd99ebbb5
    li x3, 0xd99ebbb5
    csrw 0xc05, x3

    #Address 0xc05 Write value 0xaeedb04c
    li x3, 0xaeedb04c
    csrw 0xc05, x3

    #Unmapped address 0x821 testing: random write/read operations
    #Address 0x821 Write value 0x14f070ac
    li x3, 0x14f070ac
    csrw 0x821, x3

    #Address 0x821 Write value 0xeda60b97
    li x3, 0xeda60b97
    csrw 0x821, x3

    #Address 0x821 read value
    csrr x14, 0x821

    #Address 0x821 read value
    csrr x14, 0x821

    #Unmapped address 0x5d5 testing: random write/read operations
    #Address 0x5d5 read value
    csrr x14, 0x5d5

    #Unmapped address 0xcac testing: random write/read operations
    #Address 0xcac read value
    csrr x14, 0xcac

    #Unmapped address 0x44c testing: random write/read operations
    #Address 0x44c read value
    csrr x14, 0x44c

    #Address 0x44c read value
    csrr x14, 0x44c

    #Address 0x44c Write value 0xab0abc7d
    li x3, 0xab0abc7d
    csrw 0x44c, x3

    #Unmapped address 0x45c testing: random write/read operations
    #Address 0x45c read value
    csrr x14, 0x45c

    #Address 0x45c Write value 0x4eeb15fd
    li x3, 0x4eeb15fd
    csrw 0x45c, x3

    #Address 0x45c Write value 0x596ea77a
    li x3, 0x596ea77a
    csrw 0x45c, x3

    #Address 0x45c Write value 0xf632a3d3
    li x3, 0xf632a3d3
    csrw 0x45c, x3

    #Address 0x45c read value
    csrr x14, 0x45c

    #Unmapped address 0x297 testing: random write/read operations
    #Address 0x297 Write value 0x5d67e7c8
    li x3, 0x5d67e7c8
    csrw 0x297, x3

    #Address 0x297 read value
    csrr x14, 0x297

    #Address 0x297 read value
    csrr x14, 0x297

    #Address 0x297 read value
    csrr x14, 0x297

    #Address 0x297 read value
    csrr x14, 0x297

    #Unmapped address 0xf30 testing: random write/read operations
    #Address 0xf30 read value
    csrr x14, 0xf30

    #Unmapped address 0x28c testing: random write/read operations
    #Address 0x28c read value
    csrr x14, 0x28c

    #Address 0x28c read value
    csrr x14, 0x28c

    #Unmapped address 0x768 testing: random write/read operations
    #Address 0x768 read value
    csrr x14, 0x768

    #Unmapped address 0xcd testing: random write/read operations
    #Address 0xcd read value
    csrr x14, 0xcd

    #Address 0xcd read value
    csrr x14, 0xcd

    #Address 0xcd Write value 0xc400f09c
    li x3, 0xc400f09c
    csrw 0xcd, x3

    #Address 0xcd Write value 0xa26a9dc
    li x3, 0xa26a9dc
    csrw 0xcd, x3

    #Unmapped address 0x76f testing: random write/read operations
    #Address 0x76f read value
    csrr x14, 0x76f

    #Address 0x76f read value
    csrr x14, 0x76f

    #Unmapped address 0xbf9 testing: random write/read operations
    #Address 0xbf9 Write value 0x13c08532
    li x3, 0x13c08532
    csrw 0xbf9, x3

    #Unmapped address 0xf20 testing: random write/read operations
    #Address 0xf20 read value
    csrr x14, 0xf20

    #Address 0xf20 Write value 0x651ae3d0
    li x3, 0x651ae3d0
    csrw 0xf20, x3

    #Address 0xf20 Write value 0x5cba32d1
    li x3, 0x5cba32d1
    csrw 0xf20, x3

    #Address 0xf20 Write value 0x5c824140
    li x3, 0x5c824140
    csrw 0xf20, x3

    #Address 0xf20 Write value 0x8da1a6c0
    li x3, 0x8da1a6c0
    csrw 0xf20, x3

    #Mapped address 0xb9a (mhpmcounterh26) testing: random write/read operations
    #Address 0xb9a Write value 0x2e289dc7
    li x3, 0x2e289dc7
    csrw 0xb9a, x3

    #Address 0xb9a read value
    csrr x14, 0xb9a

    #Address 0xb9a Write value 0xd86ba849
    li x3, 0xd86ba849
    csrw 0xb9a, x3

    #Unmapped address 0x473 testing: random write/read operations
    #Address 0x473 Write value 0x2b9c572e
    li x3, 0x2b9c572e
    csrw 0x473, x3

    #Address 0x473 Write value 0xb95c5fbc
    li x3, 0xb95c5fbc
    csrw 0x473, x3

    #Unmapped address 0x4fe testing: random write/read operations
    #Address 0x4fe Write value 0x215ac311
    li x3, 0x215ac311
    csrw 0x4fe, x3

    #Address 0x4fe Write value 0xf66531d5
    li x3, 0xf66531d5
    csrw 0x4fe, x3

    #Address 0x4fe read value
    csrr x14, 0x4fe

    #Address 0x4fe Write value 0xdbe01c1b
    li x3, 0xdbe01c1b
    csrw 0x4fe, x3

    #Address 0x4fe Write value 0xc5768d54
    li x3, 0xc5768d54
    csrw 0x4fe, x3

    #Unmapped address 0xb0 testing: random write/read operations
    #Address 0xb0 Write value 0x9e576b04
    li x3, 0x9e576b04
    csrw 0xb0, x3

    #Address 0xb0 Write value 0x5ee7e70c
    li x3, 0x5ee7e70c
    csrw 0xb0, x3

    #Address 0xb0 Write value 0x5c413e68
    li x3, 0x5c413e68
    csrw 0xb0, x3

    #Address 0xb0 read value
    csrr x14, 0xb0

    #Address 0xb0 read value
    csrr x14, 0xb0

    #Mapped address 0x3a1 (pmpcfg1) testing: random write/read operations
    #Address 0x3a1 Write value 0x2a98b595
    li x3, 0x2a98b595
    csrw 0x3a1, x3

    #Address 0x3a1 read value
    csrr x14, 0x3a1

    #Address 0x3a1 Write value 0xd2a11d27
    li x3, 0xd2a11d27
    csrw 0x3a1, x3

    #Address 0x3a1 Write value 0x6a91dddd
    li x3, 0x6a91dddd
    csrw 0x3a1, x3

    #Unmapped address 0x97c testing: random write/read operations
    #Address 0x97c Write value 0xce3008aa
    li x3, 0xce3008aa
    csrw 0x97c, x3

    #Address 0x97c read value
    csrr x14, 0x97c

    #Address 0x97c Write value 0x7826152e
    li x3, 0x7826152e
    csrw 0x97c, x3

    #Address 0x97c Write value 0xc817293d
    li x3, 0xc817293d
    csrw 0x97c, x3

    #Unmapped address 0x5e9 testing: random write/read operations
    #Address 0x5e9 Write value 0x5933e425
    li x3, 0x5933e425
    csrw 0x5e9, x3

    #Mapped address 0xb0e (mhpmcounter14) testing: random write/read operations
    #Address 0xb0e Write value 0xeb70658e
    li x3, 0xeb70658e
    csrw 0xb0e, x3

    #Unmapped address 0xcef testing: random write/read operations
    #Address 0xcef read value
    csrr x14, 0xcef

    #Address 0xcef read value
    csrr x14, 0xcef

    #Unmapped address 0xcbc testing: random write/read operations
    #Address 0xcbc read value
    csrr x14, 0xcbc

    #Address 0xcbc Write value 0xd9261a36
    li x3, 0xd9261a36
    csrw 0xcbc, x3

    #Address 0xcbc read value
    csrr x14, 0xcbc

    #Address 0xcbc read value
    csrr x14, 0xcbc

    #Address 0xcbc read value
    csrr x14, 0xcbc

    #Unmapped address 0x80b testing: random write/read operations
    #Address 0x80b Write value 0x6e15af51
    li x3, 0x6e15af51
    csrw 0x80b, x3

    #Address 0x80b Write value 0x50a8dd97
    li x3, 0x50a8dd97
    csrw 0x80b, x3

    #Address 0x80b Write value 0x5d4cfaae
    li x3, 0x5d4cfaae
    csrw 0x80b, x3

    #Address 0x80b read value
    csrr x14, 0x80b

    #Address 0x80b read value
    csrr x14, 0x80b

    #Unmapped address 0x38e testing: random write/read operations
    #Address 0x38e read value
    csrr x14, 0x38e

    #Address 0x38e read value
    csrr x14, 0x38e

    #Unmapped address 0x7bf testing: random write/read operations
    #Address 0x7bf read value
    csrr x14, 0x7bf

    #Address 0x7bf read value
    csrr x14, 0x7bf

    #Address 0x7bf read value
    csrr x14, 0x7bf

    #Unmapped address 0xad0 testing: random write/read operations
    #Address 0xad0 read value
    csrr x14, 0xad0

    #Address 0xad0 read value
    csrr x14, 0xad0

    #Address 0xad0 Write value 0x621a8790
    li x3, 0x621a8790
    csrw 0xad0, x3

    #Address 0xad0 Write value 0xee248b7e
    li x3, 0xee248b7e
    csrw 0xad0, x3

    #Address 0xad0 read value
    csrr x14, 0xad0

    #Unmapped address 0x6c8 testing: random write/read operations
    #Address 0x6c8 read value
    csrr x14, 0x6c8

    #Address 0x6c8 Write value 0x247b9914
    li x3, 0x247b9914
    csrw 0x6c8, x3

    #Address 0x6c8 read value
    csrr x14, 0x6c8

    #Address 0x6c8 read value
    csrr x14, 0x6c8

    #Unmapped address 0x1cd testing: random write/read operations
    #Address 0x1cd read value
    csrr x14, 0x1cd

    #Address 0x1cd Write value 0x5f6351cf
    li x3, 0x5f6351cf
    csrw 0x1cd, x3

    #Address 0x1cd read value
    csrr x14, 0x1cd

    #Address 0x1cd read value
    csrr x14, 0x1cd

    #Unmapped address 0x465 testing: random write/read operations
    #Address 0x465 Write value 0xd50776eb
    li x3, 0xd50776eb
    csrw 0x465, x3

    #Address 0x465 read value
    csrr x14, 0x465

    #Address 0x465 Write value 0xffed9743
    li x3, 0xffed9743
    csrw 0x465, x3

    #Address 0x465 read value
    csrr x14, 0x465

    #Unmapped address 0x5ac testing: random write/read operations
    #Address 0x5ac Write value 0xb3123bf5
    li x3, 0xb3123bf5
    csrw 0x5ac, x3

    #Address 0x5ac Write value 0x97ae3b6d
    li x3, 0x97ae3b6d
    csrw 0x5ac, x3

    #Address 0x5ac Write value 0x467216a3
    li x3, 0x467216a3
    csrw 0x5ac, x3

    #Unmapped address 0x511 testing: random write/read operations
    #Address 0x511 Write value 0x926be601
    li x3, 0x926be601
    csrw 0x511, x3

    #Unmapped address 0x6a7 testing: random write/read operations
    #Address 0x6a7 Write value 0xf06504e2
    li x3, 0xf06504e2
    csrw 0x6a7, x3

    #Address 0x6a7 Write value 0x5a541c8c
    li x3, 0x5a541c8c
    csrw 0x6a7, x3

    #Address 0x6a7 read value
    csrr x14, 0x6a7

    #Address 0x6a7 Write value 0x8ed67c8a
    li x3, 0x8ed67c8a
    csrw 0x6a7, x3

    #Address 0x6a7 Write value 0x33772f39
    li x3, 0x33772f39
    csrw 0x6a7, x3

    #Unmapped address 0x7d7 testing: random write/read operations
    #Address 0x7d7 read value
    csrr x14, 0x7d7

    #Address 0x7d7 Write value 0xecff7e39
    li x3, 0xecff7e39
    csrw 0x7d7, x3

    #Address 0x7d7 read value
    csrr x14, 0x7d7

    #Unmapped address 0xd1e testing: random write/read operations
    #Address 0xd1e Write value 0x3f88da80
    li x3, 0x3f88da80
    csrw 0xd1e, x3

    #Address 0xd1e Write value 0x9d08b9b0
    li x3, 0x9d08b9b0
    csrw 0xd1e, x3

    #Address 0xd1e Write value 0xc4b72d3b
    li x3, 0xc4b72d3b
    csrw 0xd1e, x3

    #Address 0xd1e read value
    csrr x14, 0xd1e

    #Unmapped address 0x7d0 testing: random write/read operations
    #Address 0x7d0 Write value 0xd53fce97
    li x3, 0xd53fce97
    csrw 0x7d0, x3

    #Unmapped address 0xf18 testing: random write/read operations
    #Address 0xf18 Write value 0x384ecc5e
    li x3, 0x384ecc5e
    csrw 0xf18, x3

    #Address 0xf18 Write value 0x6222b644
    li x3, 0x6222b644
    csrw 0xf18, x3

    #Address 0xf18 Write value 0x91d5a70b
    li x3, 0x91d5a70b
    csrw 0xf18, x3

    #Unmapped address 0x12f testing: random write/read operations
    #Address 0x12f read value
    csrr x14, 0x12f

    #Address 0x12f Write value 0x446a152d
    li x3, 0x446a152d
    csrw 0x12f, x3

    #Address 0x12f Write value 0x2b43b41
    li x3, 0x2b43b41
    csrw 0x12f, x3

    #Unmapped address 0x5d8 testing: random write/read operations
    #Address 0x5d8 Write value 0xbb669567
    li x3, 0xbb669567
    csrw 0x5d8, x3

    #Address 0x5d8 read value
    csrr x14, 0x5d8

    #Address 0x5d8 read value
    csrr x14, 0x5d8

    #Address 0x5d8 read value
    csrr x14, 0x5d8

    #Unmapped address 0x6ae testing: random write/read operations
    #Address 0x6ae Write value 0x6ff02ad
    li x3, 0x6ff02ad
    csrw 0x6ae, x3

    #Address 0x6ae read value
    csrr x14, 0x6ae

    #Address 0x6ae Write value 0xb912d40a
    li x3, 0xb912d40a
    csrw 0x6ae, x3

    #Address 0x6ae read value
    csrr x14, 0x6ae

    #Address 0x6ae Write value 0x59a5ad4a
    li x3, 0x59a5ad4a
    csrw 0x6ae, x3

    #Unmapped address 0x27e testing: random write/read operations
    #Address 0x27e Write value 0x3d5d94b5
    li x3, 0x3d5d94b5
    csrw 0x27e, x3

    #Address 0x27e Write value 0x81bba9bc
    li x3, 0x81bba9bc
    csrw 0x27e, x3

    #Address 0x27e Write value 0xda7d3c37
    li x3, 0xda7d3c37
    csrw 0x27e, x3

    #Mapped address 0x3bf (pmpaddr15) testing: random write/read operations
    #Address 0x3bf read value
    csrr x14, 0x3bf

    #Address 0x3bf read value
    csrr x14, 0x3bf

    #Address 0x3bf Write value 0xca710594
    li x3, 0xca710594
    csrw 0x3bf, x3

    #Address 0x3bf Write value 0x3c5beb59
    li x3, 0x3c5beb59
    csrw 0x3bf, x3

    #Unmapped address 0x442 testing: random write/read operations
    #Address 0x442 read value
    csrr x14, 0x442

    #Address 0x442 read value
    csrr x14, 0x442

    #Address 0x442 read value
    csrr x14, 0x442

    #Unmapped address 0x5f2 testing: random write/read operations
    #Address 0x5f2 Write value 0x6aa13890
    li x3, 0x6aa13890
    csrw 0x5f2, x3

    #Unmapped address 0x8fc testing: random write/read operations
    #Address 0x8fc Write value 0x7df68acd
    li x3, 0x7df68acd
    csrw 0x8fc, x3

    #Address 0x8fc read value
    csrr x14, 0x8fc

    #Address 0x8fc Write value 0xd6354e5d
    li x3, 0xd6354e5d
    csrw 0x8fc, x3

    #Unmapped address 0x882 testing: random write/read operations
    #Address 0x882 read value
    csrr x14, 0x882

    #Address 0x882 read value
    csrr x14, 0x882

    #Unmapped address 0xaad testing: random write/read operations
    #Address 0xaad Write value 0xa6d3aa75
    li x3, 0xa6d3aa75
    csrw 0xaad, x3

    #Address 0xaad Write value 0xe695228e
    li x3, 0xe695228e
    csrw 0xaad, x3

    #Address 0xaad Write value 0xa238fc54
    li x3, 0xa238fc54
    csrw 0xaad, x3

    #Address 0xaad Write value 0xcc9bcccb
    li x3, 0xcc9bcccb
    csrw 0xaad, x3

    #Address 0xaad read value
    csrr x14, 0xaad

    #Unmapped address 0xa7a testing: random write/read operations
    #Address 0xa7a read value
    csrr x14, 0xa7a

    #Unmapped address 0xc72 testing: random write/read operations
    #Address 0xc72 Write value 0x2bbf3dac
    li x3, 0x2bbf3dac
    csrw 0xc72, x3

    #Unmapped address 0xd8f testing: random write/read operations
    #Address 0xd8f read value
    csrr x14, 0xd8f

    #Address 0xd8f read value
    csrr x14, 0xd8f

    #Address 0xd8f read value
    csrr x14, 0xd8f

    #Unmapped address 0xccc testing: random write/read operations
    #Address 0xccc read value
    csrr x14, 0xccc

    #Address 0xccc read value
    csrr x14, 0xccc

    #Address 0xccc read value
    csrr x14, 0xccc

    #Unmapped address 0x966 testing: random write/read operations
    #Address 0x966 Write value 0x287dd162
    li x3, 0x287dd162
    csrw 0x966, x3

    #Address 0x966 Write value 0x5bf7e3ba
    li x3, 0x5bf7e3ba
    csrw 0x966, x3

    #Address 0x966 read value
    csrr x14, 0x966

    #Address 0x966 Write value 0x65ea4d0e
    li x3, 0x65ea4d0e
    csrw 0x966, x3

    #Address 0x966 Write value 0x3084ba4b
    li x3, 0x3084ba4b
    csrw 0x966, x3

    #Unmapped address 0x7a6 testing: random write/read operations
    #Address 0x7a6 Write value 0xe1f35440
    li x3, 0xe1f35440
    csrw 0x7a6, x3

    #Address 0x7a6 Write value 0x49184543
    li x3, 0x49184543
    csrw 0x7a6, x3

    #Address 0x7a6 Write value 0xcc5fb507
    li x3, 0xcc5fb507
    csrw 0x7a6, x3

    #Unmapped address 0xe13 testing: random write/read operations
    #Address 0xe13 read value
    csrr x14, 0xe13

    #Address 0xe13 Write value 0xb7947093
    li x3, 0xb7947093
    csrw 0xe13, x3

    #Address 0xe13 read value
    csrr x14, 0xe13

    #Unmapped address 0x58c testing: random write/read operations
    #Address 0x58c read value
    csrr x14, 0x58c

    #Address 0x58c read value
    csrr x14, 0x58c

    #Address 0x58c read value
    csrr x14, 0x58c

    #Address 0x58c Write value 0x737fcf04
    li x3, 0x737fcf04
    csrw 0x58c, x3

    #Address 0x58c Write value 0xa9dbe7a2
    li x3, 0xa9dbe7a2
    csrw 0x58c, x3

    #Unmapped address 0x811 testing: random write/read operations
    #Address 0x811 Write value 0xfa890779
    li x3, 0xfa890779
    csrw 0x811, x3

    #Address 0x811 Write value 0x2a020db6
    li x3, 0x2a020db6
    csrw 0x811, x3

    #Unmapped address 0x167 testing: random write/read operations
    #Address 0x167 Write value 0x746ab62c
    li x3, 0x746ab62c
    csrw 0x167, x3

    #Address 0x167 read value
    csrr x14, 0x167

    #Unmapped address 0xa78 testing: random write/read operations
    #Address 0xa78 read value
    csrr x14, 0xa78

    #Address 0xa78 read value
    csrr x14, 0xa78

    #Address 0xa78 Write value 0x91772408
    li x3, 0x91772408
    csrw 0xa78, x3

    #Address 0xa78 Write value 0x5da4276e
    li x3, 0x5da4276e
    csrw 0xa78, x3

    #Unmapped address 0x93f testing: random write/read operations
    #Address 0x93f read value
    csrr x14, 0x93f

    #Address 0x93f read value
    csrr x14, 0x93f

    #Address 0x93f read value
    csrr x14, 0x93f

    #Address 0x93f read value
    csrr x14, 0x93f

    #Address 0x93f Write value 0x3487a651
    li x3, 0x3487a651
    csrw 0x93f, x3

    #Unmapped address 0x51e testing: random write/read operations
    #Address 0x51e read value
    csrr x14, 0x51e

    #Address 0x51e Write value 0x51cb37e1
    li x3, 0x51cb37e1
    csrw 0x51e, x3

    #Unmapped address 0x8fd testing: random write/read operations
    #Address 0x8fd Write value 0x48ad75e4
    li x3, 0x48ad75e4
    csrw 0x8fd, x3

    #Address 0x8fd read value
    csrr x14, 0x8fd

    #Address 0x8fd Write value 0xd067778
    li x3, 0xd067778
    csrw 0x8fd, x3

    #Unmapped address 0x7b4 testing: random write/read operations
    #Address 0x7b4 Write value 0xa83a8f40
    li x3, 0xa83a8f40
    csrw 0x7b4, x3

    #Address 0x7b4 read value
    csrr x14, 0x7b4

    #Address 0x7b4 Write value 0x7cbaf051
    li x3, 0x7cbaf051
    csrw 0x7b4, x3

    #Unmapped address 0x854 testing: random write/read operations
    #Address 0x854 Write value 0xab7553c7
    li x3, 0xab7553c7
    csrw 0x854, x3

    #Address 0x854 Write value 0x87e4fc90
    li x3, 0x87e4fc90
    csrw 0x854, x3

    #Address 0x854 read value
    csrr x14, 0x854

    #Address 0x854 read value
    csrr x14, 0x854

    #Unmapped address 0x773 testing: random write/read operations
    #Address 0x773 Write value 0x14478e87
    li x3, 0x14478e87
    csrw 0x773, x3

    #Address 0x773 Write value 0xdb43536f
    li x3, 0xdb43536f
    csrw 0x773, x3

    #Address 0x773 Write value 0x93325a75
    li x3, 0x93325a75
    csrw 0x773, x3

    #Address 0x773 read value
    csrr x14, 0x773

    #Unmapped address 0x779 testing: random write/read operations
    #Address 0x779 Write value 0xd51407c0
    li x3, 0xd51407c0
    csrw 0x779, x3

    #Address 0x779 read value
    csrr x14, 0x779

    #Address 0x779 Write value 0xbf2d18b2
    li x3, 0xbf2d18b2
    csrw 0x779, x3

    #Address 0x779 Write value 0x9c09b469
    li x3, 0x9c09b469
    csrw 0x779, x3

    #Unmapped address 0xbd2 testing: random write/read operations
    #Address 0xbd2 read value
    csrr x14, 0xbd2

    #Address 0xbd2 read value
    csrr x14, 0xbd2

    #Unmapped address 0xe43 testing: random write/read operations
    #Address 0xe43 Write value 0x22adac58
    li x3, 0x22adac58
    csrw 0xe43, x3

    #Address 0xe43 read value
    csrr x14, 0xe43

    #Address 0xe43 Write value 0x9aacc72f
    li x3, 0x9aacc72f
    csrw 0xe43, x3

    #Unmapped address 0x769 testing: random write/read operations
    #Address 0x769 Write value 0x519ed00c
    li x3, 0x519ed00c
    csrw 0x769, x3

    #Address 0x769 read value
    csrr x14, 0x769

    #Address 0x769 Write value 0xf9309e64
    li x3, 0xf9309e64
    csrw 0x769, x3

    #Address 0x769 Write value 0x1cc912ae
    li x3, 0x1cc912ae
    csrw 0x769, x3

    #Address 0x769 read value
    csrr x14, 0x769

    #Unmapped address 0xc6d testing: random write/read operations
    #Address 0xc6d read value
    csrr x14, 0xc6d

    #Address 0xc6d Write value 0xef0c09b7
    li x3, 0xef0c09b7
    csrw 0xc6d, x3

    #Address 0xc6d Write value 0x7e3eea2a
    li x3, 0x7e3eea2a
    csrw 0xc6d, x3

    #Unmapped address 0xda0 testing: random write/read operations
    #Address 0xda0 read value
    csrr x14, 0xda0

    #Address 0xda0 Write value 0x48a5195e
    li x3, 0x48a5195e
    csrw 0xda0, x3

    #Address 0xda0 read value
    csrr x14, 0xda0

    #Address 0xda0 read value
    csrr x14, 0xda0

    #Address 0xda0 Write value 0x1d93deac
    li x3, 0x1d93deac
    csrw 0xda0, x3

    #Unmapped address 0x74c testing: random write/read operations
    #Address 0x74c read value
    csrr x14, 0x74c

    #Address 0x74c Write value 0x2b087eaa
    li x3, 0x2b087eaa
    csrw 0x74c, x3

    #Address 0x74c read value
    csrr x14, 0x74c

    #Address 0x74c read value
    csrr x14, 0x74c

    #Address 0x74c read value
    csrr x14, 0x74c

    #Unmapped address 0xff9 testing: random write/read operations
    #Address 0xff9 Write value 0x1bcbbb77
    li x3, 0x1bcbbb77
    csrw 0xff9, x3

    #Address 0xff9 read value
    csrr x14, 0xff9

    #Address 0xff9 read value
    csrr x14, 0xff9

    #Address 0xff9 read value
    csrr x14, 0xff9

    #Unmapped address 0xc48 testing: random write/read operations
    #Address 0xc48 read value
    csrr x14, 0xc48

    #Address 0xc48 read value
    csrr x14, 0xc48

    #Address 0xc48 read value
    csrr x14, 0xc48

    #Address 0xc48 Write value 0x1d480d94
    li x3, 0x1d480d94
    csrw 0xc48, x3

    #Unmapped address 0xea4 testing: random write/read operations
    #Address 0xea4 Write value 0xa5cd3ac9
    li x3, 0xa5cd3ac9
    csrw 0xea4, x3

    #Unmapped address 0x4ae testing: random write/read operations
    #Address 0x4ae read value
    csrr x14, 0x4ae

    #Address 0x4ae Write value 0x8fe8d391
    li x3, 0x8fe8d391
    csrw 0x4ae, x3

    #Unmapped address 0xcf testing: random write/read operations
    #Address 0xcf Write value 0x22b9cf35
    li x3, 0x22b9cf35
    csrw 0xcf, x3

    #Unmapped address 0xfb2 testing: random write/read operations
    #Address 0xfb2 read value
    csrr x14, 0xfb2

    #Unmapped address 0x501 testing: random write/read operations
    #Address 0x501 read value
    csrr x14, 0x501

    #Address 0x501 read value
    csrr x14, 0x501

    #Address 0x501 Write value 0x371489b4
    li x3, 0x371489b4
    csrw 0x501, x3

    #Address 0x501 Write value 0xb7a21adf
    li x3, 0xb7a21adf
    csrw 0x501, x3

    #Unmapped address 0x2e5 testing: random write/read operations
    #Address 0x2e5 read value
    csrr x14, 0x2e5

    #Unmapped address 0x1bf testing: random write/read operations
    #Address 0x1bf read value
    csrr x14, 0x1bf

    #Address 0x1bf read value
    csrr x14, 0x1bf

    #Address 0x1bf read value
    csrr x14, 0x1bf

    #Unmapped address 0x74 testing: random write/read operations
    #Address 0x74 Write value 0x109cdeb4
    li x3, 0x109cdeb4
    csrw 0x74, x3

    #Address 0x74 Write value 0xfdbf1198
    li x3, 0xfdbf1198
    csrw 0x74, x3

    #Address 0x74 Write value 0x9c86dfa5
    li x3, 0x9c86dfa5
    csrw 0x74, x3

    #Address 0x74 Write value 0xc9ab6447
    li x3, 0xc9ab6447
    csrw 0x74, x3

    #Address 0x74 Write value 0x461d16b0
    li x3, 0x461d16b0
    csrw 0x74, x3

    #Unmapped address 0xe05 testing: random write/read operations
    #Address 0xe05 read value
    csrr x14, 0xe05

    #Address 0xe05 read value
    csrr x14, 0xe05

    #Address 0xe05 read value
    csrr x14, 0xe05

    #Address 0xe05 Write value 0xa9e55f03
    li x3, 0xa9e55f03
    csrw 0xe05, x3

    #Unmapped address 0xade testing: random write/read operations
    #Address 0xade Write value 0x176e6af9
    li x3, 0x176e6af9
    csrw 0xade, x3

    #Address 0xade read value
    csrr x14, 0xade

    #Address 0xade Write value 0x83775d11
    li x3, 0x83775d11
    csrw 0xade, x3

    #Unmapped address 0xf6d testing: random write/read operations
    #Address 0xf6d read value
    csrr x14, 0xf6d

    #Address 0xf6d read value
    csrr x14, 0xf6d

    #Address 0xf6d read value
    csrr x14, 0xf6d

    #Unmapped address 0x517 testing: random write/read operations
    #Address 0x517 Write value 0x60eaed28
    li x3, 0x60eaed28
    csrw 0x517, x3

    #Address 0x517 read value
    csrr x14, 0x517

    #Address 0x517 Write value 0x43604589
    li x3, 0x43604589
    csrw 0x517, x3

    #Address 0x517 Write value 0xbfbf45d0
    li x3, 0xbfbf45d0
    csrw 0x517, x3

    #Unmapped address 0xec6 testing: random write/read operations
    #Address 0xec6 read value
    csrr x14, 0xec6

    #Unmapped address 0xf7c testing: random write/read operations
    #Address 0xf7c read value
    csrr x14, 0xf7c

    #Address 0xf7c read value
    csrr x14, 0xf7c

    #Unmapped address 0x16e testing: random write/read operations
    #Address 0x16e Write value 0x4a94d2b9
    li x3, 0x4a94d2b9
    csrw 0x16e, x3

    #Address 0x16e Write value 0xd075f7e4
    li x3, 0xd075f7e4
    csrw 0x16e, x3

    #Unmapped address 0xd9c testing: random write/read operations
    #Address 0xd9c read value
    csrr x14, 0xd9c

    #Address 0xd9c Write value 0xc2e6cf40
    li x3, 0xc2e6cf40
    csrw 0xd9c, x3

    #Address 0xd9c read value
    csrr x14, 0xd9c

    #Address 0xd9c Write value 0xd438a2af
    li x3, 0xd438a2af
    csrw 0xd9c, x3

    #Unmapped address 0xa31 testing: random write/read operations
    #Address 0xa31 Write value 0xe97c4ab
    li x3, 0xe97c4ab
    csrw 0xa31, x3

    #Unmapped address 0x106 testing: random write/read operations
    #Address 0x106 Write value 0x12fd44ac
    li x3, 0x12fd44ac
    csrw 0x106, x3

    #Address 0x106 Write value 0xbf377904
    li x3, 0xbf377904
    csrw 0x106, x3

    #Address 0x106 read value
    csrr x14, 0x106

    #Address 0x106 read value
    csrr x14, 0x106

    #Unmapped address 0xce1 testing: random write/read operations
    #Address 0xce1 Write value 0x58540dfe
    li x3, 0x58540dfe
    csrw 0xce1, x3

    #Address 0xce1 read value
    csrr x14, 0xce1

    #Unmapped address 0xc7d testing: random write/read operations
    #Address 0xc7d Write value 0xe0096cf4
    li x3, 0xe0096cf4
    csrw 0xc7d, x3

    #Address 0xc7d read value
    csrr x14, 0xc7d

    #Unmapped address 0x4e4 testing: random write/read operations
    #Address 0x4e4 Write value 0x82d683fb
    li x3, 0x82d683fb
    csrw 0x4e4, x3

    #Address 0x4e4 read value
    csrr x14, 0x4e4

    #Address 0x4e4 read value
    csrr x14, 0x4e4

    #Address 0x4e4 Write value 0x7fb37264
    li x3, 0x7fb37264
    csrw 0x4e4, x3

    #Address 0x4e4 read value
    csrr x14, 0x4e4

    #Unmapped address 0x594 testing: random write/read operations
    #Address 0x594 Write value 0x2c21582d
    li x3, 0x2c21582d
    csrw 0x594, x3

    #Address 0x594 Write value 0x5a29fb2
    li x3, 0x5a29fb2
    csrw 0x594, x3

    #Address 0x594 read value
    csrr x14, 0x594

    #Address 0x594 Write value 0xd5dc3e83
    li x3, 0xd5dc3e83
    csrw 0x594, x3

    #Address 0x594 read value
    csrr x14, 0x594

    #Unmapped address 0x6a6 testing: random write/read operations
    #Address 0x6a6 Write value 0xffad99a5
    li x3, 0xffad99a5
    csrw 0x6a6, x3

    #Address 0x6a6 read value
    csrr x14, 0x6a6

    #Mapped address 0xb8f (mhpmcounterh15) testing: random write/read operations
    #Address 0xb8f read value
    csrr x14, 0xb8f

    #Unmapped address 0xaab testing: random write/read operations
    #Address 0xaab read value
    csrr x14, 0xaab

    #Address 0xaab read value
    csrr x14, 0xaab

    #Address 0xaab Write value 0x279cddaa
    li x3, 0x279cddaa
    csrw 0xaab, x3

    #Address 0xaab read value
    csrr x14, 0xaab

    #Unmapped address 0x3e3 testing: random write/read operations
    #Address 0x3e3 Write value 0x9d6896f8
    li x3, 0x9d6896f8
    csrw 0x3e3, x3

    #Address 0x3e3 Write value 0x333c6d62
    li x3, 0x333c6d62
    csrw 0x3e3, x3

    #Address 0x3e3 Write value 0xa3b2989e
    li x3, 0xa3b2989e
    csrw 0x3e3, x3

    #Address 0x3e3 Write value 0x208df9dc
    li x3, 0x208df9dc
    csrw 0x3e3, x3

    #Unmapped address 0xe2a testing: random write/read operations
    #Address 0xe2a read value
    csrr x14, 0xe2a

    #Unmapped address 0xcd8 testing: random write/read operations
    #Address 0xcd8 read value
    csrr x14, 0xcd8

    #Address 0xcd8 read value
    csrr x14, 0xcd8

    #Address 0xcd8 Write value 0xd90366a
    li x3, 0xd90366a
    csrw 0xcd8, x3

    #Address 0xcd8 read value
    csrr x14, 0xcd8

    #Unmapped address 0xfbc testing: random write/read operations
    #Address 0xfbc Write value 0xe0404e45
    li x3, 0xe0404e45
    csrw 0xfbc, x3

    #Address 0xfbc Write value 0x863fc453
    li x3, 0x863fc453
    csrw 0xfbc, x3

    #Address 0xfbc read value
    csrr x14, 0xfbc

    #Address 0xfbc Write value 0x80eebf9b
    li x3, 0x80eebf9b
    csrw 0xfbc, x3

    #Unmapped address 0x614 testing: random write/read operations
    #Address 0x614 Write value 0x773ae270
    li x3, 0x773ae270
    csrw 0x614, x3

    #Address 0x614 read value
    csrr x14, 0x614

    #Unmapped address 0x62a testing: random write/read operations
    #Address 0x62a Write value 0x86e77cdd
    li x3, 0x86e77cdd
    csrw 0x62a, x3

    #Address 0x62a read value
    csrr x14, 0x62a

    #Address 0x62a read value
    csrr x14, 0x62a

    #Address 0x62a Write value 0xa455eea4
    li x3, 0xa455eea4
    csrw 0x62a, x3

    #Address 0x62a read value
    csrr x14, 0x62a

    #Unmapped address 0xbaf testing: random write/read operations
    #Address 0xbaf Write value 0xef15c438
    li x3, 0xef15c438
    csrw 0xbaf, x3

    #Address 0xbaf read value
    csrr x14, 0xbaf

    #Address 0xbaf read value
    csrr x14, 0xbaf

    #Address 0xbaf read value
    csrr x14, 0xbaf

    #Address 0xbaf read value
    csrr x14, 0xbaf

    #Unmapped address 0x893 testing: random write/read operations
    #Address 0x893 read value
    csrr x14, 0x893

    #Address 0x893 read value
    csrr x14, 0x893

    #Address 0x893 Write value 0xbf30174f
    li x3, 0xbf30174f
    csrw 0x893, x3

    #Address 0x893 read value
    csrr x14, 0x893

    #Unmapped address 0xf1e testing: random write/read operations
    #Address 0xf1e read value
    csrr x14, 0xf1e

    #Address 0xf1e Write value 0xc7c38a35
    li x3, 0xc7c38a35
    csrw 0xf1e, x3

    #Address 0xf1e read value
    csrr x14, 0xf1e

    #Address 0xf1e Write value 0xaaa7758d
    li x3, 0xaaa7758d
    csrw 0xf1e, x3

    #Address 0xf1e read value
    csrr x14, 0xf1e

    #Unmapped address 0x894 testing: random write/read operations
    #Address 0x894 Write value 0x1171247a
    li x3, 0x1171247a
    csrw 0x894, x3

    #Address 0x894 read value
    csrr x14, 0x894

    #Address 0x894 Write value 0xf7087775
    li x3, 0xf7087775
    csrw 0x894, x3

    #Unmapped address 0x346 testing: random write/read operations
    #Address 0x346 read value
    csrr x14, 0x346

    #Address 0x346 read value
    csrr x14, 0x346

    #Address 0x346 read value
    csrr x14, 0x346

    #Address 0x346 Write value 0x4963ec23
    li x3, 0x4963ec23
    csrw 0x346, x3

    #Address 0x346 read value
    csrr x14, 0x346

    #Unmapped address 0xc58 testing: random write/read operations
    #Address 0xc58 read value
    csrr x14, 0xc58

    #Address 0xc58 read value
    csrr x14, 0xc58

    #Address 0xc58 read value
    csrr x14, 0xc58

    #Unmapped address 0xb5e testing: random write/read operations
    #Address 0xb5e read value
    csrr x14, 0xb5e

    #Address 0xb5e Write value 0x61893dbf
    li x3, 0x61893dbf
    csrw 0xb5e, x3

    #Address 0xb5e Write value 0x94225243
    li x3, 0x94225243
    csrw 0xb5e, x3

    #Address 0xb5e read value
    csrr x14, 0xb5e

    #Unmapped address 0x1c0 testing: random write/read operations
    #Address 0x1c0 read value
    csrr x14, 0x1c0

    #Address 0x1c0 Write value 0x2572f886
    li x3, 0x2572f886
    csrw 0x1c0, x3

    #Address 0x1c0 Write value 0x5d0c9c7f
    li x3, 0x5d0c9c7f
    csrw 0x1c0, x3

    #Unmapped address 0x791 testing: random write/read operations
    #Address 0x791 Write value 0x2b984ddf
    li x3, 0x2b984ddf
    csrw 0x791, x3

    #Address 0x791 read value
    csrr x14, 0x791

    #Address 0x791 read value
    csrr x14, 0x791

    #Address 0x791 Write value 0xd05ccbdb
    li x3, 0xd05ccbdb
    csrw 0x791, x3

    #Unmapped address 0x818 testing: random write/read operations
    #Address 0x818 read value
    csrr x14, 0x818

    #Address 0x818 read value
    csrr x14, 0x818

    #Address 0x818 Write value 0x5097f415
    li x3, 0x5097f415
    csrw 0x818, x3

    #Address 0x818 read value
    csrr x14, 0x818

    #Unmapped address 0x6ef testing: random write/read operations
    #Address 0x6ef Write value 0xae6d9267
    li x3, 0xae6d9267
    csrw 0x6ef, x3

    #Address 0x6ef read value
    csrr x14, 0x6ef

    #Address 0x6ef Write value 0xd0b854a1
    li x3, 0xd0b854a1
    csrw 0x6ef, x3

    #Address 0x6ef Write value 0x3c013018
    li x3, 0x3c013018
    csrw 0x6ef, x3

    #Address 0x6ef Write value 0xb7737188
    li x3, 0xb7737188
    csrw 0x6ef, x3

    #Unmapped address 0xd33 testing: random write/read operations
    #Address 0xd33 Write value 0x4538a05e
    li x3, 0x4538a05e
    csrw 0xd33, x3

    #Address 0xd33 read value
    csrr x14, 0xd33

    #Unmapped address 0xf4b testing: random write/read operations
    #Address 0xf4b read value
    csrr x14, 0xf4b

    #Address 0xf4b read value
    csrr x14, 0xf4b

    #Address 0xf4b read value
    csrr x14, 0xf4b

    #Unmapped address 0xe6f testing: random write/read operations
    #Address 0xe6f Write value 0x3fb362dd
    li x3, 0x3fb362dd
    csrw 0xe6f, x3

    #Address 0xe6f read value
    csrr x14, 0xe6f

    #Address 0xe6f read value
    csrr x14, 0xe6f

    #Address 0xe6f read value
    csrr x14, 0xe6f

    #Unmapped address 0x4f1 testing: random write/read operations
    #Address 0x4f1 Write value 0xf21df2c8
    li x3, 0xf21df2c8
    csrw 0x4f1, x3

    #Unmapped address 0xa43 testing: random write/read operations
    #Address 0xa43 Write value 0x67d4b435
    li x3, 0x67d4b435
    csrw 0xa43, x3

    #Address 0xa43 read value
    csrr x14, 0xa43

    #Address 0xa43 Write value 0x45b484ee
    li x3, 0x45b484ee
    csrw 0xa43, x3

    #Address 0xa43 read value
    csrr x14, 0xa43

    #Address 0xa43 Write value 0x12793f8b
    li x3, 0x12793f8b
    csrw 0xa43, x3

    #Unmapped address 0x26 testing: random write/read operations
    #Address 0x26 Write value 0x9366c584
    li x3, 0x9366c584
    csrw 0x26, x3

    #Unmapped address 0x83b testing: random write/read operations
    #Address 0x83b read value
    csrr x14, 0x83b

    #Address 0x83b Write value 0x34b7ad9c
    li x3, 0x34b7ad9c
    csrw 0x83b, x3

    #Unmapped address 0x48d testing: random write/read operations
    #Address 0x48d read value
    csrr x14, 0x48d

    #Address 0x48d Write value 0x1d43dc38
    li x3, 0x1d43dc38
    csrw 0x48d, x3

    #Address 0x48d Write value 0x65b836bf
    li x3, 0x65b836bf
    csrw 0x48d, x3

    #Address 0x48d Write value 0x8dfd3b02
    li x3, 0x8dfd3b02
    csrw 0x48d, x3

    #Address 0x48d Write value 0x99443f89
    li x3, 0x99443f89
    csrw 0x48d, x3

    #Unmapped address 0x4ff testing: random write/read operations
    #Address 0x4ff read value
    csrr x14, 0x4ff

    #Address 0x4ff Write value 0xbc62961
    li x3, 0xbc62961
    csrw 0x4ff, x3

    #Address 0x4ff Write value 0xc1b08ac
    li x3, 0xc1b08ac
    csrw 0x4ff, x3

    #Address 0x4ff Write value 0xc3fdbe7c
    li x3, 0xc3fdbe7c
    csrw 0x4ff, x3

    #Address 0x4ff read value
    csrr x14, 0x4ff

    #Unmapped address 0xeeb testing: random write/read operations
    #Address 0xeeb read value
    csrr x14, 0xeeb

    #Unmapped address 0x9b5 testing: random write/read operations
    #Address 0x9b5 Write value 0xef4816d1
    li x3, 0xef4816d1
    csrw 0x9b5, x3

    #Address 0x9b5 Write value 0xe9c14640
    li x3, 0xe9c14640
    csrw 0x9b5, x3

    #Address 0x9b5 Write value 0x661be76
    li x3, 0x661be76
    csrw 0x9b5, x3

    #Unmapped address 0x689 testing: random write/read operations
    #Address 0x689 read value
    csrr x14, 0x689

    #Address 0x689 read value
    csrr x14, 0x689

    #Address 0x689 Write value 0xf0c286b7
    li x3, 0xf0c286b7
    csrw 0x689, x3

    #Address 0x689 Write value 0x43b4221a
    li x3, 0x43b4221a
    csrw 0x689, x3

    #Address 0x689 Write value 0x6793dc47
    li x3, 0x6793dc47
    csrw 0x689, x3

    #Unmapped address 0x66e testing: random write/read operations
    #Address 0x66e read value
    csrr x14, 0x66e

    #Address 0x66e Write value 0x828a3244
    li x3, 0x828a3244
    csrw 0x66e, x3

    #Address 0x66e Write value 0x440003c1
    li x3, 0x440003c1
    csrw 0x66e, x3

    #Address 0x66e read value
    csrr x14, 0x66e

    #Unmapped address 0x657 testing: random write/read operations
    #Address 0x657 Write value 0xe3be4b78
    li x3, 0xe3be4b78
    csrw 0x657, x3

    #Address 0x657 read value
    csrr x14, 0x657

    #Address 0x657 Write value 0x9835da87
    li x3, 0x9835da87
    csrw 0x657, x3

    #Address 0x657 read value
    csrr x14, 0x657

    #Unmapped address 0x9cb testing: random write/read operations
    #Address 0x9cb Write value 0x2e2f1e7
    li x3, 0x2e2f1e7
    csrw 0x9cb, x3

    #Address 0x9cb read value
    csrr x14, 0x9cb

    #Address 0x9cb read value
    csrr x14, 0x9cb

    #Address 0x9cb Write value 0x1173d1b7
    li x3, 0x1173d1b7
    csrw 0x9cb, x3

    #Unmapped address 0x6e testing: random write/read operations
    #Address 0x6e read value
    csrr x14, 0x6e

    #Address 0x6e Write value 0xd468b897
    li x3, 0xd468b897
    csrw 0x6e, x3

    #Address 0x6e read value
    csrr x14, 0x6e

    #Address 0x6e read value
    csrr x14, 0x6e

    #Unmapped address 0x320 testing: random write/read operations
    #Address 0x320 Write value 0x485cf513
    li x3, 0x485cf513
    csrw 0x320, x3

    #Address 0x320 read value
    csrr x14, 0x320

    #Address 0x320 read value
    csrr x14, 0x320

    #Address 0x320 Write value 0xfb66cb11
    li x3, 0xfb66cb11
    csrw 0x320, x3

    #Address 0x320 read value
    csrr x14, 0x320

    #Unmapped address 0xfc9 testing: random write/read operations
    #Address 0xfc9 Write value 0x272f79d0
    li x3, 0x272f79d0
    csrw 0xfc9, x3

    #Address 0xfc9 Write value 0x1af15bda
    li x3, 0x1af15bda
    csrw 0xfc9, x3

    #Address 0xfc9 read value
    csrr x14, 0xfc9

    #Unmapped address 0x7da testing: random write/read operations
    #Address 0x7da Write value 0x9cb01b3b
    li x3, 0x9cb01b3b
    csrw 0x7da, x3

    #Address 0x7da Write value 0xa2ddaaf7
    li x3, 0xa2ddaaf7
    csrw 0x7da, x3

    #Address 0x7da Write value 0x1ac30615
    li x3, 0x1ac30615
    csrw 0x7da, x3

    #Address 0x7da read value
    csrr x14, 0x7da

    #Address 0x7da Write value 0x4c43eff6
    li x3, 0x4c43eff6
    csrw 0x7da, x3

    #Unmapped address 0xc92 testing: random write/read operations
    #Address 0xc92 Write value 0xd7b061e4
    li x3, 0xd7b061e4
    csrw 0xc92, x3

    #Address 0xc92 read value
    csrr x14, 0xc92

    #Unmapped address 0x5b0 testing: random write/read operations
    #Address 0x5b0 Write value 0xcd313f7e
    li x3, 0xcd313f7e
    csrw 0x5b0, x3

    #Address 0x5b0 read value
    csrr x14, 0x5b0

    #Address 0x5b0 Write value 0x4dd3eedb
    li x3, 0x4dd3eedb
    csrw 0x5b0, x3

    #Unmapped address 0x73b testing: random write/read operations
    #Address 0x73b read value
    csrr x14, 0x73b

    #Address 0x73b Write value 0x4fcf812f
    li x3, 0x4fcf812f
    csrw 0x73b, x3

    #Unmapped address 0x8c1 testing: random write/read operations
    #Address 0x8c1 Write value 0xf73b4306
    li x3, 0xf73b4306
    csrw 0x8c1, x3

    #Address 0x8c1 read value
    csrr x14, 0x8c1

    #Address 0x8c1 Write value 0x3f93f461
    li x3, 0x3f93f461
    csrw 0x8c1, x3

    #Address 0x8c1 read value
    csrr x14, 0x8c1

    #Address 0x8c1 Write value 0xb4d0aec8
    li x3, 0xb4d0aec8
    csrw 0x8c1, x3

    #Unmapped address 0xd69 testing: random write/read operations
    #Address 0xd69 Write value 0xf7907449
    li x3, 0xf7907449
    csrw 0xd69, x3

    #Address 0xd69 Write value 0x98c696cf
    li x3, 0x98c696cf
    csrw 0xd69, x3

    #Unmapped address 0x6e0 testing: random write/read operations
    #Address 0x6e0 Write value 0x544ccd63
    li x3, 0x544ccd63
    csrw 0x6e0, x3

    #Address 0x6e0 read value
    csrr x14, 0x6e0

    #Unmapped address 0xaf4 testing: random write/read operations
    #Address 0xaf4 read value
    csrr x14, 0xaf4

    #Address 0xaf4 Write value 0x62bf7cad
    li x3, 0x62bf7cad
    csrw 0xaf4, x3

    #Address 0xaf4 read value
    csrr x14, 0xaf4

    #Unmapped address 0x611 testing: random write/read operations
    #Address 0x611 Write value 0x2795f8b5
    li x3, 0x2795f8b5
    csrw 0x611, x3

    #Address 0x611 read value
    csrr x14, 0x611

    #Address 0x611 read value
    csrr x14, 0x611

    #Address 0x611 Write value 0x5e413218
    li x3, 0x5e413218
    csrw 0x611, x3

    #Unmapped address 0x27f testing: random write/read operations
    #Address 0x27f Write value 0xe5530df0
    li x3, 0xe5530df0
    csrw 0x27f, x3

    #Address 0x27f Write value 0x246e980a
    li x3, 0x246e980a
    csrw 0x27f, x3

    #Address 0x27f Write value 0x4d843bd7
    li x3, 0x4d843bd7
    csrw 0x27f, x3

    #Address 0x27f read value
    csrr x14, 0x27f

    #Unmapped address 0x11f testing: random write/read operations
    #Address 0x11f read value
    csrr x14, 0x11f

    #Unmapped address 0x5dd testing: random write/read operations
    #Address 0x5dd Write value 0x2f801b6c
    li x3, 0x2f801b6c
    csrw 0x5dd, x3

    #Unmapped address 0xdad testing: random write/read operations
    #Address 0xdad Write value 0xdf82c16f
    li x3, 0xdf82c16f
    csrw 0xdad, x3

    #Address 0xdad read value
    csrr x14, 0xdad

    #Address 0xdad read value
    csrr x14, 0xdad

    #Address 0xdad Write value 0xb547d748
    li x3, 0xb547d748
    csrw 0xdad, x3

    #Address 0xdad Write value 0x8cc68b4b
    li x3, 0x8cc68b4b
    csrw 0xdad, x3

    #Unmapped address 0xd63 testing: random write/read operations
    #Address 0xd63 read value
    csrr x14, 0xd63

    #Address 0xd63 Write value 0xf48d0004
    li x3, 0xf48d0004
    csrw 0xd63, x3

    #Unmapped address 0x628 testing: random write/read operations
    #Address 0x628 read value
    csrr x14, 0x628

    #Address 0x628 Write value 0x37e59ad3
    li x3, 0x37e59ad3
    csrw 0x628, x3

    #Address 0x628 Write value 0xe1bb03a1
    li x3, 0xe1bb03a1
    csrw 0x628, x3

    #Address 0x628 read value
    csrr x14, 0x628

    #Unmapped address 0x8b testing: random write/read operations
    #Address 0x8b Write value 0x8c122365
    li x3, 0x8c122365
    csrw 0x8b, x3

    #Address 0x8b read value
    csrr x14, 0x8b

    #Unmapped address 0x61d testing: random write/read operations
    #Address 0x61d read value
    csrr x14, 0x61d

    #Address 0x61d Write value 0xb568779b
    li x3, 0xb568779b
    csrw 0x61d, x3

    #Unmapped address 0xc5d testing: random write/read operations
    #Address 0xc5d Write value 0x3806f087
    li x3, 0x3806f087
    csrw 0xc5d, x3

    #Address 0xc5d Write value 0x6df07301
    li x3, 0x6df07301
    csrw 0xc5d, x3

    #Address 0xc5d Write value 0xead122c6
    li x3, 0xead122c6
    csrw 0xc5d, x3

    #Address 0xc5d read value
    csrr x14, 0xc5d

    #Unmapped address 0xf2c testing: random write/read operations
    #Address 0xf2c Write value 0xabb0a846
    li x3, 0xabb0a846
    csrw 0xf2c, x3

    #Address 0xf2c Write value 0x1986b9a5
    li x3, 0x1986b9a5
    csrw 0xf2c, x3

    #Unmapped address 0xbae testing: random write/read operations
    #Address 0xbae Write value 0x77921578
    li x3, 0x77921578
    csrw 0xbae, x3

    #Address 0xbae Write value 0xeb3c1a3c
    li x3, 0xeb3c1a3c
    csrw 0xbae, x3

    #Address 0xbae read value
    csrr x14, 0xbae

    #Address 0xbae read value
    csrr x14, 0xbae

    #Address 0xbae Write value 0x394d4652
    li x3, 0x394d4652
    csrw 0xbae, x3

    #Unmapped address 0x5d testing: random write/read operations
    #Address 0x5d Write value 0x7216450c
    li x3, 0x7216450c
    csrw 0x5d, x3

    #Address 0x5d read value
    csrr x14, 0x5d

    #Unmapped address 0xdde testing: random write/read operations
    #Address 0xdde read value
    csrr x14, 0xdde

    #Unmapped address 0x881 testing: random write/read operations
    #Address 0x881 read value
    csrr x14, 0x881

    #Address 0x881 read value
    csrr x14, 0x881

    #Address 0x881 read value
    csrr x14, 0x881

    #Unmapped address 0x598 testing: random write/read operations
    #Address 0x598 read value
    csrr x14, 0x598

    #Address 0x598 Write value 0xeac58721
    li x3, 0xeac58721
    csrw 0x598, x3

    #Address 0x598 read value
    csrr x14, 0x598

    #Unmapped address 0x895 testing: random write/read operations
    #Address 0x895 read value
    csrr x14, 0x895

    #Address 0x895 Write value 0xd4a4dfa8
    li x3, 0xd4a4dfa8
    csrw 0x895, x3

    #Address 0x895 Write value 0x2cec68ab
    li x3, 0x2cec68ab
    csrw 0x895, x3

    #Address 0x895 read value
    csrr x14, 0x895

    #Address 0x895 Write value 0x66b45c9
    li x3, 0x66b45c9
    csrw 0x895, x3

    #Unmapped address 0x4fb testing: random write/read operations
    #Address 0x4fb Write value 0x3875eb60
    li x3, 0x3875eb60
    csrw 0x4fb, x3

    #Address 0x4fb read value
    csrr x14, 0x4fb

    #Address 0x4fb read value
    csrr x14, 0x4fb

    #Address 0x4fb read value
    csrr x14, 0x4fb

    #Unmapped address 0x146 testing: random write/read operations
    #Address 0x146 Write value 0xb7431743
    li x3, 0xb7431743
    csrw 0x146, x3

    #Address 0x146 Write value 0xd79171e5
    li x3, 0xd79171e5
    csrw 0x146, x3

    #Unmapped address 0x7f9 testing: random write/read operations
    #Address 0x7f9 read value
    csrr x14, 0x7f9

    #Address 0x7f9 read value
    csrr x14, 0x7f9

    #Address 0x7f9 Write value 0x285ad321
    li x3, 0x285ad321
    csrw 0x7f9, x3

    #Address 0x7f9 Write value 0xf5d057b4
    li x3, 0xf5d057b4
    csrw 0x7f9, x3

    #Address 0x7f9 Write value 0xfa327dc7
    li x3, 0xfa327dc7
    csrw 0x7f9, x3

    #Unmapped address 0x981 testing: random write/read operations
    #Address 0x981 Write value 0x5ccc9f4c
    li x3, 0x5ccc9f4c
    csrw 0x981, x3

    #Address 0x981 Write value 0x48f91247
    li x3, 0x48f91247
    csrw 0x981, x3

    #Address 0x981 read value
    csrr x14, 0x981

    #Unmapped address 0x792 testing: random write/read operations
    #Address 0x792 Write value 0xc82f769b
    li x3, 0xc82f769b
    csrw 0x792, x3

    #Address 0x792 Write value 0xe8fbc328
    li x3, 0xe8fbc328
    csrw 0x792, x3

    #Address 0x792 read value
    csrr x14, 0x792

    #Address 0x792 Write value 0x7fb3f7f1
    li x3, 0x7fb3f7f1
    csrw 0x792, x3

    #Address 0x792 read value
    csrr x14, 0x792

    #Mapped address 0x324 (mhpmevent4) testing: random write/read operations
    #Address 0x324 read value
    csrr x14, 0x324

    #Address 0x324 Write value 0x57a37ed0
    li x3, 0x57a37ed0
    csrw 0x324, x3

    #Unmapped address 0xf7a testing: random write/read operations
    #Address 0xf7a Write value 0xbc819614
    li x3, 0xbc819614
    csrw 0xf7a, x3

    #Address 0xf7a Write value 0xd914fde4
    li x3, 0xd914fde4
    csrw 0xf7a, x3

    #Address 0xf7a read value
    csrr x14, 0xf7a

    #Address 0xf7a Write value 0x7fbcc8a2
    li x3, 0x7fbcc8a2
    csrw 0xf7a, x3

    #Unmapped address 0x143 testing: random write/read operations
    #Address 0x143 read value
    csrr x14, 0x143

    #Address 0x143 Write value 0x90be3752
    li x3, 0x90be3752
    csrw 0x143, x3

    #Address 0x143 Write value 0x1773d3b2
    li x3, 0x1773d3b2
    csrw 0x143, x3

    #Address 0x143 read value
    csrr x14, 0x143

    #Address 0x143 read value
    csrr x14, 0x143

    #Unmapped address 0x695 testing: random write/read operations
    #Address 0x695 Write value 0x8231fb4c
    li x3, 0x8231fb4c
    csrw 0x695, x3

    #Address 0x695 read value
    csrr x14, 0x695

    #Address 0x695 read value
    csrr x14, 0x695

    #Address 0x695 read value
    csrr x14, 0x695

    #Unmapped address 0xcc7 testing: random write/read operations
    #Address 0xcc7 Write value 0x80c0c77e
    li x3, 0x80c0c77e
    csrw 0xcc7, x3

    #Address 0xcc7 Write value 0xef36d066
    li x3, 0xef36d066
    csrw 0xcc7, x3

    #Address 0xcc7 Write value 0xee9cb980
    li x3, 0xee9cb980
    csrw 0xcc7, x3

    #Unmapped address 0xc24 testing: random write/read operations
    #Address 0xc24 Write value 0x7829efdf
    li x3, 0x7829efdf
    csrw 0xc24, x3

    #Address 0xc24 read value
    csrr x14, 0xc24

    #Unmapped address 0x9c1 testing: random write/read operations
    #Address 0x9c1 read value
    csrr x14, 0x9c1

    #Address 0x9c1 Write value 0xd8199cd
    li x3, 0xd8199cd
    csrw 0x9c1, x3

    #Unmapped address 0xf97 testing: random write/read operations
    #Address 0xf97 read value
    csrr x14, 0xf97

    #Address 0xf97 Write value 0xedc4f5e5
    li x3, 0xedc4f5e5
    csrw 0xf97, x3

    #Address 0xf97 Write value 0x669b858e
    li x3, 0x669b858e
    csrw 0xf97, x3

    #Address 0xf97 read value
    csrr x14, 0xf97

    #Address 0xf97 Write value 0xd007345
    li x3, 0xd007345
    csrw 0xf97, x3

    #Unmapped address 0x5f1 testing: random write/read operations
    #Address 0x5f1 Write value 0x54a1de99
    li x3, 0x54a1de99
    csrw 0x5f1, x3

    #Address 0x5f1 Write value 0xdb8f2fc
    li x3, 0xdb8f2fc
    csrw 0x5f1, x3

    #Address 0x5f1 read value
    csrr x14, 0x5f1

    #Address 0x5f1 read value
    csrr x14, 0x5f1

    #Address 0x5f1 Write value 0xc61c7189
    li x3, 0xc61c7189
    csrw 0x5f1, x3

    #Unmapped address 0x55 testing: random write/read operations
    #Address 0x55 Write value 0xccb3d60d
    li x3, 0xccb3d60d
    csrw 0x55, x3

    #Address 0x55 read value
    csrr x14, 0x55

    #Address 0x55 read value
    csrr x14, 0x55

    #Unmapped address 0xa1d testing: random write/read operations
    #Address 0xa1d read value
    csrr x14, 0xa1d

    #Address 0xa1d read value
    csrr x14, 0xa1d

    #Unmapped address 0x174 testing: random write/read operations
    #Address 0x174 Write value 0x405721d6
    li x3, 0x405721d6
    csrw 0x174, x3

    #Unmapped address 0x73d testing: random write/read operations
    #Address 0x73d Write value 0x78be063b
    li x3, 0x78be063b
    csrw 0x73d, x3

    #Address 0x73d Write value 0x7012ef89
    li x3, 0x7012ef89
    csrw 0x73d, x3

    #Address 0x73d Write value 0xb5a233d6
    li x3, 0xb5a233d6
    csrw 0x73d, x3

    #Unmapped address 0x221 testing: random write/read operations
    #Address 0x221 read value
    csrr x14, 0x221

    #Address 0x221 read value
    csrr x14, 0x221

    #Address 0x221 read value
    csrr x14, 0x221

    #Address 0x221 read value
    csrr x14, 0x221

    #Address 0x221 Write value 0xaa43be4f
    li x3, 0xaa43be4f
    csrw 0x221, x3

    #Unmapped address 0x289 testing: random write/read operations
    #Address 0x289 Write value 0x7494991a
    li x3, 0x7494991a
    csrw 0x289, x3

    #Address 0x289 Write value 0xe80fa4e1
    li x3, 0xe80fa4e1
    csrw 0x289, x3

    #Unmapped address 0x9fc testing: random write/read operations
    #Address 0x9fc Write value 0x90c721c0
    li x3, 0x90c721c0
    csrw 0x9fc, x3

    #Address 0x9fc Write value 0x6cb39399
    li x3, 0x6cb39399
    csrw 0x9fc, x3

    #Address 0x9fc Write value 0xf743558d
    li x3, 0xf743558d
    csrw 0x9fc, x3

    #Unmapped address 0x132 testing: random write/read operations
    #Address 0x132 Write value 0xcce71f66
    li x3, 0xcce71f66
    csrw 0x132, x3

    #Unmapped address 0x588 testing: random write/read operations
    #Address 0x588 read value
    csrr x14, 0x588

    #Address 0x588 read value
    csrr x14, 0x588

    #Address 0x588 Write value 0x56f95a18
    li x3, 0x56f95a18
    csrw 0x588, x3

    #Address 0x588 Write value 0x3484bcbb
    li x3, 0x3484bcbb
    csrw 0x588, x3

    #Address 0x588 Write value 0x95995664
    li x3, 0x95995664
    csrw 0x588, x3

    #Unmapped address 0x751 testing: random write/read operations
    #Address 0x751 read value
    csrr x14, 0x751

    #Address 0x751 read value
    csrr x14, 0x751

    #Address 0x751 read value
    csrr x14, 0x751

    #Address 0x751 Write value 0xa7b74b74
    li x3, 0xa7b74b74
    csrw 0x751, x3

    #Unmapped address 0xc1c testing: random write/read operations
    #Address 0xc1c Write value 0x1dfefd45
    li x3, 0x1dfefd45
    csrw 0xc1c, x3

    #Address 0xc1c read value
    csrr x14, 0xc1c

    #Unmapped address 0x456 testing: random write/read operations
    #Address 0x456 Write value 0x3947641e
    li x3, 0x3947641e
    csrw 0x456, x3

    #Address 0x456 read value
    csrr x14, 0x456

    #Address 0x456 Write value 0x3c5a9e02
    li x3, 0x3c5a9e02
    csrw 0x456, x3

    #Address 0x456 read value
    csrr x14, 0x456

    #Address 0x456 Write value 0x72b782a5
    li x3, 0x72b782a5
    csrw 0x456, x3

    #Unmapped address 0x23e testing: random write/read operations
    #Address 0x23e read value
    csrr x14, 0x23e

    #Unmapped address 0xdca testing: random write/read operations
    #Address 0xdca Write value 0x22490c9b
    li x3, 0x22490c9b
    csrw 0xdca, x3

    #Address 0xdca read value
    csrr x14, 0xdca

    #Unmapped address 0xba2 testing: random write/read operations
    #Address 0xba2 Write value 0x95b0c79c
    li x3, 0x95b0c79c
    csrw 0xba2, x3

    #Unmapped address 0xb42 testing: random write/read operations
    #Address 0xb42 Write value 0xb7f1c7bf
    li x3, 0xb7f1c7bf
    csrw 0xb42, x3

    #Address 0xb42 read value
    csrr x14, 0xb42

    #Address 0xb42 read value
    csrr x14, 0xb42

    #Address 0xb42 read value
    csrr x14, 0xb42

    #Unmapped address 0xfa7 testing: random write/read operations
    #Address 0xfa7 read value
    csrr x14, 0xfa7

    #Address 0xfa7 read value
    csrr x14, 0xfa7

    #Unmapped address 0x247 testing: random write/read operations
    #Address 0x247 Write value 0x88d3a426
    li x3, 0x88d3a426
    csrw 0x247, x3

    #Address 0x247 read value
    csrr x14, 0x247

    #Address 0x247 Write value 0xb52a6d92
    li x3, 0xb52a6d92
    csrw 0x247, x3

    #Address 0x247 read value
    csrr x14, 0x247

    #Unmapped address 0x136 testing: random write/read operations
    #Address 0x136 Write value 0x5c40bbb8
    li x3, 0x5c40bbb8
    csrw 0x136, x3

    #Unmapped address 0xa69 testing: random write/read operations
    #Address 0xa69 read value
    csrr x14, 0xa69

    #Address 0xa69 read value
    csrr x14, 0xa69

    #Unmapped address 0xe45 testing: random write/read operations
    #Address 0xe45 Write value 0x1168eb0
    li x3, 0x1168eb0
    csrw 0xe45, x3

    #Address 0xe45 Write value 0x9923ab94
    li x3, 0x9923ab94
    csrw 0xe45, x3

    #Address 0xe45 Write value 0x82bca00c
    li x3, 0x82bca00c
    csrw 0xe45, x3

    #Address 0xe45 Write value 0xf0951cdd
    li x3, 0xf0951cdd
    csrw 0xe45, x3

    #Unmapped address 0x200 testing: random write/read operations
    #Address 0x200 read value
    csrr x14, 0x200

    #Address 0x200 Write value 0x2aa6ca4
    li x3, 0x2aa6ca4
    csrw 0x200, x3

    #Unmapped address 0x729 testing: random write/read operations
    #Address 0x729 read value
    csrr x14, 0x729

    #Address 0x729 Write value 0x54646a52
    li x3, 0x54646a52
    csrw 0x729, x3

    #Address 0x729 read value
    csrr x14, 0x729

    #Unmapped address 0x9bc testing: random write/read operations
    #Address 0x9bc read value
    csrr x14, 0x9bc

    #Address 0x9bc read value
    csrr x14, 0x9bc

    #Address 0x9bc Write value 0xeeb6361b
    li x3, 0xeeb6361b
    csrw 0x9bc, x3

    #Address 0x9bc read value
    csrr x14, 0x9bc

    #Address 0x9bc Write value 0xdf011cdb
    li x3, 0xdf011cdb
    csrw 0x9bc, x3

    #Unmapped address 0xca testing: random write/read operations
    #Address 0xca read value
    csrr x14, 0xca

    #Unmapped address 0xfbb testing: random write/read operations
    #Address 0xfbb Write value 0xbc6d97ac
    li x3, 0xbc6d97ac
    csrw 0xfbb, x3

    #Address 0xfbb Write value 0x6019c0ff
    li x3, 0x6019c0ff
    csrw 0xfbb, x3

    #Address 0xfbb Write value 0xe58d8132
    li x3, 0xe58d8132
    csrw 0xfbb, x3

    #Address 0xfbb Write value 0x76ac078c
    li x3, 0x76ac078c
    csrw 0xfbb, x3

    #Unmapped address 0xbf testing: random write/read operations
    #Address 0xbf Write value 0xd3e5a411
    li x3, 0xd3e5a411
    csrw 0xbf, x3

    #Address 0xbf Write value 0xc7ba142a
    li x3, 0xc7ba142a
    csrw 0xbf, x3

    #Unmapped address 0x68e testing: random write/read operations
    #Address 0x68e Write value 0xf10128b3
    li x3, 0xf10128b3
    csrw 0x68e, x3

    #Address 0x68e Write value 0xf8f2f531
    li x3, 0xf8f2f531
    csrw 0x68e, x3

    #Address 0x68e Write value 0x5134e43d
    li x3, 0x5134e43d
    csrw 0x68e, x3

    #Unmapped address 0xab5 testing: random write/read operations
    #Address 0xab5 read value
    csrr x14, 0xab5

    #Address 0xab5 read value
    csrr x14, 0xab5

    #Address 0xab5 Write value 0x6b1f6607
    li x3, 0x6b1f6607
    csrw 0xab5, x3

    #Address 0xab5 read value
    csrr x14, 0xab5

    #Address 0xab5 Write value 0x4ec0851d
    li x3, 0x4ec0851d
    csrw 0xab5, x3

    #Unmapped address 0x2dd testing: random write/read operations
    #Address 0x2dd read value
    csrr x14, 0x2dd

    #Address 0x2dd Write value 0xd9ec38d4
    li x3, 0xd9ec38d4
    csrw 0x2dd, x3

    #Address 0x2dd Write value 0xbaab5536
    li x3, 0xbaab5536
    csrw 0x2dd, x3

    #Address 0x2dd Write value 0x48919594
    li x3, 0x48919594
    csrw 0x2dd, x3

    #Address 0x2dd Write value 0x98ac0b7a
    li x3, 0x98ac0b7a
    csrw 0x2dd, x3

    #Unmapped address 0xb9 testing: random write/read operations
    #Address 0xb9 read value
    csrr x14, 0xb9

    #Unmapped address 0x1ea testing: random write/read operations
    #Address 0x1ea Write value 0x21074915
    li x3, 0x21074915
    csrw 0x1ea, x3

    #Address 0x1ea read value
    csrr x14, 0x1ea

    #Unmapped address 0x7d9 testing: random write/read operations
    #Address 0x7d9 Write value 0xc88b16cd
    li x3, 0xc88b16cd
    csrw 0x7d9, x3

    #Address 0x7d9 Write value 0x8f09f8a6
    li x3, 0x8f09f8a6
    csrw 0x7d9, x3

    #Unmapped address 0x76a testing: random write/read operations
    #Address 0x76a read value
    csrr x14, 0x76a

    #Address 0x76a Write value 0x8361d31a
    li x3, 0x8361d31a
    csrw 0x76a, x3

    #Address 0x76a Write value 0xf2808764
    li x3, 0xf2808764
    csrw 0x76a, x3

    #Address 0x76a Write value 0x2f0dcb3b
    li x3, 0x2f0dcb3b
    csrw 0x76a, x3

    #Unmapped address 0x85a testing: random write/read operations
    #Address 0x85a Write value 0xe6b09f31
    li x3, 0xe6b09f31
    csrw 0x85a, x3

    #Address 0x85a read value
    csrr x14, 0x85a

    #Address 0x85a read value
    csrr x14, 0x85a

    #Address 0x85a read value
    csrr x14, 0x85a

    #Unmapped address 0xeb3 testing: random write/read operations
    #Address 0xeb3 read value
    csrr x14, 0xeb3

    #Address 0xeb3 read value
    csrr x14, 0xeb3

    #Address 0xeb3 read value
    csrr x14, 0xeb3

    #Unmapped address 0xf6c testing: random write/read operations
    #Address 0xf6c Write value 0xcdf9a268
    li x3, 0xcdf9a268
    csrw 0xf6c, x3

    #Address 0xf6c Write value 0x40cb6dae
    li x3, 0x40cb6dae
    csrw 0xf6c, x3

    #Unmapped address 0x5bf testing: random write/read operations
    #Address 0x5bf Write value 0x1f1bb4b5
    li x3, 0x1f1bb4b5
    csrw 0x5bf, x3

    #Address 0x5bf read value
    csrr x14, 0x5bf

    #Unmapped address 0x1a1 testing: random write/read operations
    #Address 0x1a1 Write value 0x6d09daa8
    li x3, 0x6d09daa8
    csrw 0x1a1, x3

    #Address 0x1a1 read value
    csrr x14, 0x1a1

    #Address 0x1a1 Write value 0x32a343
    li x3, 0x32a343
    csrw 0x1a1, x3

    #Unmapped address 0x31e testing: random write/read operations
    #Address 0x31e Write value 0x574041d1
    li x3, 0x574041d1
    csrw 0x31e, x3

    #Address 0x31e Write value 0x9886cbc0
    li x3, 0x9886cbc0
    csrw 0x31e, x3

    #Address 0x31e read value
    csrr x14, 0x31e

    #Address 0x31e read value
    csrr x14, 0x31e

    #Address 0x31e Write value 0xd755589d
    li x3, 0xd755589d
    csrw 0x31e, x3

    #Unmapped address 0x8e8 testing: random write/read operations
    #Address 0x8e8 Write value 0x84f8dd49
    li x3, 0x84f8dd49
    csrw 0x8e8, x3

    #Address 0x8e8 read value
    csrr x14, 0x8e8

    #Address 0x8e8 read value
    csrr x14, 0x8e8

    #Address 0x8e8 read value
    csrr x14, 0x8e8

    #Address 0x8e8 Write value 0x495d4cb3
    li x3, 0x495d4cb3
    csrw 0x8e8, x3

    #Unmapped address 0x5f7 testing: random write/read operations
    #Address 0x5f7 Write value 0x7f86864c
    li x3, 0x7f86864c
    csrw 0x5f7, x3

    #Address 0x5f7 Write value 0x3ac5928d
    li x3, 0x3ac5928d
    csrw 0x5f7, x3

    #Address 0x5f7 read value
    csrr x14, 0x5f7

    #Address 0x5f7 read value
    csrr x14, 0x5f7

    #Unmapped address 0xa99 testing: random write/read operations
    #Address 0xa99 read value
    csrr x14, 0xa99

    #Address 0xa99 Write value 0xcc1c5bed
    li x3, 0xcc1c5bed
    csrw 0xa99, x3

    #Address 0xa99 read value
    csrr x14, 0xa99

    #Address 0xa99 read value
    csrr x14, 0xa99

    #Unmapped address 0x6e3 testing: random write/read operations
    #Address 0x6e3 Write value 0x60e15e8c
    li x3, 0x60e15e8c
    csrw 0x6e3, x3

    #Address 0x6e3 Write value 0xc5064b2b
    li x3, 0xc5064b2b
    csrw 0x6e3, x3

    #Address 0x6e3 Write value 0x712468e0
    li x3, 0x712468e0
    csrw 0x6e3, x3

    #Unmapped address 0x45b testing: random write/read operations
    #Address 0x45b Write value 0xcdad3592
    li x3, 0xcdad3592
    csrw 0x45b, x3

    #Address 0x45b read value
    csrr x14, 0x45b

    #Address 0x45b Write value 0x1255804
    li x3, 0x1255804
    csrw 0x45b, x3

    #Address 0x45b read value
    csrr x14, 0x45b

    #Address 0x45b read value
    csrr x14, 0x45b

    #Unmapped address 0xb45 testing: random write/read operations
    #Address 0xb45 read value
    csrr x14, 0xb45

    #Address 0xb45 Write value 0x71c99abd
    li x3, 0x71c99abd
    csrw 0xb45, x3

    #Address 0xb45 Write value 0xf309874e
    li x3, 0xf309874e
    csrw 0xb45, x3

    #Address 0xb45 read value
    csrr x14, 0xb45

    #Unmapped address 0x43e testing: random write/read operations
    #Address 0x43e Write value 0x97f1fd72
    li x3, 0x97f1fd72
    csrw 0x43e, x3

    #Address 0x43e Write value 0x9925b5ac
    li x3, 0x9925b5ac
    csrw 0x43e, x3

    #Address 0x43e Write value 0xf930b2ba
    li x3, 0xf930b2ba
    csrw 0x43e, x3

    #Address 0x43e Write value 0xa5ce1a81
    li x3, 0xa5ce1a81
    csrw 0x43e, x3

    #Unmapped address 0x415 testing: random write/read operations
    #Address 0x415 read value
    csrr x14, 0x415

    #Address 0x415 read value
    csrr x14, 0x415

    #Address 0x415 Write value 0xfa411c3b
    li x3, 0xfa411c3b
    csrw 0x415, x3

    #Unmapped address 0xec2 testing: random write/read operations
    #Address 0xec2 read value
    csrr x14, 0xec2

    #Address 0xec2 Write value 0xc8ac537e
    li x3, 0xc8ac537e
    csrw 0xec2, x3

    #Unmapped address 0x10a testing: random write/read operations
    #Address 0x10a read value
    csrr x14, 0x10a

    #Address 0x10a Write value 0xa8e62bf0
    li x3, 0xa8e62bf0
    csrw 0x10a, x3

    #Address 0x10a read value
    csrr x14, 0x10a

    #Address 0x10a Write value 0x348b044d
    li x3, 0x348b044d
    csrw 0x10a, x3

    #Unmapped address 0xaa7 testing: random write/read operations
    #Address 0xaa7 read value
    csrr x14, 0xaa7

    #Unmapped address 0xd83 testing: random write/read operations
    #Address 0xd83 Write value 0x49afaa91
    li x3, 0x49afaa91
    csrw 0xd83, x3

    #Address 0xd83 Write value 0x71291961
    li x3, 0x71291961
    csrw 0xd83, x3

    #Address 0xd83 read value
    csrr x14, 0xd83

    #Address 0xd83 Write value 0xbd6fa419
    li x3, 0xbd6fa419
    csrw 0xd83, x3

    #Unmapped address 0x492 testing: random write/read operations
    #Address 0x492 read value
    csrr x14, 0x492

    #Unmapped address 0xe9d testing: random write/read operations
    #Address 0xe9d read value
    csrr x14, 0xe9d

    #Address 0xe9d read value
    csrr x14, 0xe9d

    #Address 0xe9d read value
    csrr x14, 0xe9d

    #Address 0xe9d Write value 0x29047136
    li x3, 0x29047136
    csrw 0xe9d, x3

    #Address 0xe9d read value
    csrr x14, 0xe9d

    #Unmapped address 0x40f testing: random write/read operations
    #Address 0x40f Write value 0xadd780cc
    li x3, 0xadd780cc
    csrw 0x40f, x3

    #Address 0x40f Write value 0x15fd4fca
    li x3, 0x15fd4fca
    csrw 0x40f, x3

    #Address 0x40f read value
    csrr x14, 0x40f

    #Address 0x40f read value
    csrr x14, 0x40f

    #Unmapped address 0x868 testing: random write/read operations
    #Address 0x868 read value
    csrr x14, 0x868

    #Address 0x868 Write value 0x3811a136
    li x3, 0x3811a136
    csrw 0x868, x3

    #Address 0x868 Write value 0xf9aacc1d
    li x3, 0xf9aacc1d
    csrw 0x868, x3

    #Address 0x868 read value
    csrr x14, 0x868

    #Unmapped address 0x4f3 testing: random write/read operations
    #Address 0x4f3 Write value 0x3998242e
    li x3, 0x3998242e
    csrw 0x4f3, x3

    #Address 0x4f3 Write value 0xa520d8dc
    li x3, 0xa520d8dc
    csrw 0x4f3, x3

    #Unmapped address 0xa5c testing: random write/read operations
    #Address 0xa5c Write value 0x1be928cc
    li x3, 0x1be928cc
    csrw 0xa5c, x3

    #Address 0xa5c read value
    csrr x14, 0xa5c

    #Address 0xa5c Write value 0x4b51532b
    li x3, 0x4b51532b
    csrw 0xa5c, x3

    #Address 0xa5c Write value 0x8910ee91
    li x3, 0x8910ee91
    csrw 0xa5c, x3

    #Unmapped address 0x315 testing: random write/read operations
    #Address 0x315 read value
    csrr x14, 0x315

    #Unmapped address 0x4c7 testing: random write/read operations
    #Address 0x4c7 read value
    csrr x14, 0x4c7

    #Unmapped address 0xcdb testing: random write/read operations
    #Address 0xcdb Write value 0xcd1db8ca
    li x3, 0xcd1db8ca
    csrw 0xcdb, x3

    #Address 0xcdb read value
    csrr x14, 0xcdb

    #Address 0xcdb read value
    csrr x14, 0xcdb

    #Unmapped address 0xc36 testing: random write/read operations
    #Address 0xc36 read value
    csrr x14, 0xc36

    #Unmapped address 0x149 testing: random write/read operations
    #Address 0x149 read value
    csrr x14, 0x149

    #Address 0x149 Write value 0xa2898dd9
    li x3, 0xa2898dd9
    csrw 0x149, x3

    #Address 0x149 Write value 0xc6d5aba2
    li x3, 0xc6d5aba2
    csrw 0x149, x3

    #Address 0x149 Write value 0x6877919b
    li x3, 0x6877919b
    csrw 0x149, x3

    #Address 0x149 Write value 0xa43613de
    li x3, 0xa43613de
    csrw 0x149, x3

    #Unmapped address 0x224 testing: random write/read operations
    #Address 0x224 Write value 0x5c9b8bc3
    li x3, 0x5c9b8bc3
    csrw 0x224, x3

    #Address 0x224 Write value 0xeebe1a15
    li x3, 0xeebe1a15
    csrw 0x224, x3

    #Address 0x224 read value
    csrr x14, 0x224

    #Unmapped address 0x498 testing: random write/read operations
    #Address 0x498 Write value 0x8e055374
    li x3, 0x8e055374
    csrw 0x498, x3

    #Address 0x498 read value
    csrr x14, 0x498

    #Address 0x498 read value
    csrr x14, 0x498

    #Unmapped address 0x996 testing: random write/read operations
    #Address 0x996 Write value 0x57eb99c0
    li x3, 0x57eb99c0
    csrw 0x996, x3

    #Address 0x996 read value
    csrr x14, 0x996

    #Address 0x996 read value
    csrr x14, 0x996

    #Address 0x996 Write value 0x3e2ff9cd
    li x3, 0x3e2ff9cd
    csrw 0x996, x3

    #Address 0x996 Write value 0xdf6aca1e
    li x3, 0xdf6aca1e
    csrw 0x996, x3

    #Unmapped address 0xfa4 testing: random write/read operations
    #Address 0xfa4 read value
    csrr x14, 0xfa4

    #Address 0xfa4 Write value 0x919151b6
    li x3, 0x919151b6
    csrw 0xfa4, x3

    #Address 0xfa4 Write value 0xd1405fcf
    li x3, 0xd1405fcf
    csrw 0xfa4, x3

    #Address 0xfa4 read value
    csrr x14, 0xfa4

    #Unmapped address 0xf26 testing: random write/read operations
    #Address 0xf26 read value
    csrr x14, 0xf26

    #Address 0xf26 Write value 0xe6bd2f6e
    li x3, 0xe6bd2f6e
    csrw 0xf26, x3

    #Address 0xf26 read value
    csrr x14, 0xf26

    #Address 0xf26 Write value 0xb0dba26f
    li x3, 0xb0dba26f
    csrw 0xf26, x3

    #Unmapped address 0x781 testing: random write/read operations
    #Address 0x781 Write value 0x956b7ccf
    li x3, 0x956b7ccf
    csrw 0x781, x3

    #Address 0x781 read value
    csrr x14, 0x781

    #Address 0x781 Write value 0xd0f8f93
    li x3, 0xd0f8f93
    csrw 0x781, x3

    #Unmapped address 0x810 testing: random write/read operations
    #Address 0x810 Write value 0x54263906
    li x3, 0x54263906
    csrw 0x810, x3

    #Address 0x810 Write value 0x437ee5db
    li x3, 0x437ee5db
    csrw 0x810, x3

    #Unmapped address 0x491 testing: random write/read operations
    #Address 0x491 read value
    csrr x14, 0x491

    #Address 0x491 read value
    csrr x14, 0x491

    #Unmapped address 0xebf testing: random write/read operations
    #Address 0xebf read value
    csrr x14, 0xebf

    #Address 0xebf Write value 0x94e914a1
    li x3, 0x94e914a1
    csrw 0xebf, x3

    #Address 0xebf Write value 0xe1f6ad26
    li x3, 0xe1f6ad26
    csrw 0xebf, x3

    #Unmapped address 0x7e7 testing: random write/read operations
    #Address 0x7e7 read value
    csrr x14, 0x7e7

    #Address 0x7e7 read value
    csrr x14, 0x7e7

    #Address 0x7e7 Write value 0x5f74f30a
    li x3, 0x5f74f30a
    csrw 0x7e7, x3

    #Address 0x7e7 Write value 0x85a6fd77
    li x3, 0x85a6fd77
    csrw 0x7e7, x3

    #Unmapped address 0x3e1 testing: random write/read operations
    #Address 0x3e1 read value
    csrr x14, 0x3e1

    #Unmapped address 0xf83 testing: random write/read operations
    #Address 0xf83 Write value 0x9a3849fd
    li x3, 0x9a3849fd
    csrw 0xf83, x3

    #Unmapped address 0xf0b testing: random write/read operations
    #Address 0xf0b Write value 0x21a73589
    li x3, 0x21a73589
    csrw 0xf0b, x3

    #Address 0xf0b Write value 0x689d77b1
    li x3, 0x689d77b1
    csrw 0xf0b, x3

    #Address 0xf0b read value
    csrr x14, 0xf0b

    #Address 0xf0b read value
    csrr x14, 0xf0b

    #Unmapped address 0xe52 testing: random write/read operations
    #Address 0xe52 read value
    csrr x14, 0xe52

    #Unmapped address 0x229 testing: random write/read operations
    #Address 0x229 Write value 0x12efc24d
    li x3, 0x12efc24d
    csrw 0x229, x3

    #Address 0x229 read value
    csrr x14, 0x229

    #Address 0x229 read value
    csrr x14, 0x229

    #Unmapped address 0xf8c testing: random write/read operations
    #Address 0xf8c Write value 0x3c7a9347
    li x3, 0x3c7a9347
    csrw 0xf8c, x3

    #Address 0xf8c read value
    csrr x14, 0xf8c

    #Address 0xf8c Write value 0xdcb501a7
    li x3, 0xdcb501a7
    csrw 0xf8c, x3

    #Address 0xf8c read value
    csrr x14, 0xf8c

    #Unmapped address 0xa41 testing: random write/read operations
    #Address 0xa41 read value
    csrr x14, 0xa41

    #Address 0xa41 Write value 0x85e903fb
    li x3, 0x85e903fb
    csrw 0xa41, x3

    #Unmapped address 0x29e testing: random write/read operations
    #Address 0x29e Write value 0x2d70a523
    li x3, 0x2d70a523
    csrw 0x29e, x3

    #Address 0x29e Write value 0xaffb5c4b
    li x3, 0xaffb5c4b
    csrw 0x29e, x3

    #Unmapped address 0x65a testing: random write/read operations
    #Address 0x65a read value
    csrr x14, 0x65a

    #Unmapped address 0x1d6 testing: random write/read operations
    #Address 0x1d6 Write value 0x352afbef
    li x3, 0x352afbef
    csrw 0x1d6, x3

    #Unmapped address 0x1ff testing: random write/read operations
    #Address 0x1ff read value
    csrr x14, 0x1ff

    #Address 0x1ff Write value 0xad523db3
    li x3, 0xad523db3
    csrw 0x1ff, x3

    #Unmapped address 0xccf testing: random write/read operations
    #Address 0xccf Write value 0xc146b9bd
    li x3, 0xc146b9bd
    csrw 0xccf, x3

    #Address 0xccf Write value 0x52fed5de
    li x3, 0x52fed5de
    csrw 0xccf, x3

    #Address 0xccf Write value 0xec653299
    li x3, 0xec653299
    csrw 0xccf, x3

    #Address 0xccf read value
    csrr x14, 0xccf

    #Unmapped address 0x4b0 testing: random write/read operations
    #Address 0x4b0 read value
    csrr x14, 0x4b0

    #Address 0x4b0 Write value 0xfa5e5bab
    li x3, 0xfa5e5bab
    csrw 0x4b0, x3

    #Address 0x4b0 read value
    csrr x14, 0x4b0

    #Unmapped address 0xdb9 testing: random write/read operations
    #Address 0xdb9 Write value 0x743df97e
    li x3, 0x743df97e
    csrw 0xdb9, x3

    #Address 0xdb9 Write value 0x37c15a01
    li x3, 0x37c15a01
    csrw 0xdb9, x3

    #Address 0xdb9 Write value 0xcc81a248
    li x3, 0xcc81a248
    csrw 0xdb9, x3

    #Address 0xdb9 read value
    csrr x14, 0xdb9

    #Address 0xdb9 read value
    csrr x14, 0xdb9

    #Unmapped address 0x75b testing: random write/read operations
    #Address 0x75b Write value 0xe737c64e
    li x3, 0xe737c64e
    csrw 0x75b, x3

    #Address 0x75b read value
    csrr x14, 0x75b

    #Address 0x75b read value
    csrr x14, 0x75b

    #Address 0x75b read value
    csrr x14, 0x75b

    #Address 0x75b Write value 0xfaf93459
    li x3, 0xfaf93459
    csrw 0x75b, x3

    #Unmapped address 0x4b8 testing: random write/read operations
    #Address 0x4b8 Write value 0x9d678da5
    li x3, 0x9d678da5
    csrw 0x4b8, x3

    #Address 0x4b8 read value
    csrr x14, 0x4b8

    #Address 0x4b8 read value
    csrr x14, 0x4b8

    #Address 0x4b8 read value
    csrr x14, 0x4b8

    #Address 0x4b8 Write value 0x3b342605
    li x3, 0x3b342605
    csrw 0x4b8, x3

    #Unmapped address 0x29a testing: random write/read operations
    #Address 0x29a Write value 0xbd4683c0
    li x3, 0xbd4683c0
    csrw 0x29a, x3

    #Address 0x29a read value
    csrr x14, 0x29a

    #Address 0x29a Write value 0x3fc098a5
    li x3, 0x3fc098a5
    csrw 0x29a, x3

    #Address 0x29a Write value 0x391280a1
    li x3, 0x391280a1
    csrw 0x29a, x3

    #Unmapped address 0x8b8 testing: random write/read operations
    #Address 0x8b8 Write value 0xe51855d2
    li x3, 0xe51855d2
    csrw 0x8b8, x3

    #Address 0x8b8 read value
    csrr x14, 0x8b8

    #Address 0x8b8 read value
    csrr x14, 0x8b8

    #Unmapped address 0x84a testing: random write/read operations
    #Address 0x84a Write value 0x7ae9f981
    li x3, 0x7ae9f981
    csrw 0x84a, x3

    #Address 0x84a read value
    csrr x14, 0x84a

    #Address 0x84a Write value 0x6247faba
    li x3, 0x6247faba
    csrw 0x84a, x3

    #Unmapped address 0xcc2 testing: random write/read operations
    #Address 0xcc2 Write value 0xf0a4fd94
    li x3, 0xf0a4fd94
    csrw 0xcc2, x3

    #Address 0xcc2 Write value 0x64dd27ea
    li x3, 0x64dd27ea
    csrw 0xcc2, x3

    #Address 0xcc2 Write value 0xab28f8d6
    li x3, 0xab28f8d6
    csrw 0xcc2, x3

    #Address 0xcc2 read value
    csrr x14, 0xcc2

    #Address 0xcc2 Write value 0x1ed491f7
    li x3, 0x1ed491f7
    csrw 0xcc2, x3

    #Unmapped address 0x437 testing: random write/read operations
    #Address 0x437 read value
    csrr x14, 0x437

    #Address 0x437 read value
    csrr x14, 0x437

    #Unmapped address 0xba3 testing: random write/read operations
    #Address 0xba3 read value
    csrr x14, 0xba3

    #Address 0xba3 Write value 0xfe1b6c47
    li x3, 0xfe1b6c47
    csrw 0xba3, x3

    #Unmapped address 0xe0 testing: random write/read operations
    #Address 0xe0 Write value 0x1f7d855f
    li x3, 0x1f7d855f
    csrw 0xe0, x3

    #Unmapped address 0x723 testing: random write/read operations
    #Address 0x723 Write value 0x2677880b
    li x3, 0x2677880b
    csrw 0x723, x3

    #Address 0x723 Write value 0xf1d3d488
    li x3, 0xf1d3d488
    csrw 0x723, x3

    #Address 0x723 read value
    csrr x14, 0x723

    #Unmapped address 0xe3d testing: random write/read operations
    #Address 0xe3d read value
    csrr x14, 0xe3d

    #Address 0xe3d Write value 0xdd315244
    li x3, 0xdd315244
    csrw 0xe3d, x3

    #Unmapped address 0x198 testing: random write/read operations
    #Address 0x198 Write value 0xf886d9c2
    li x3, 0xf886d9c2
    csrw 0x198, x3

    #Address 0x198 Write value 0x97290cb4
    li x3, 0x97290cb4
    csrw 0x198, x3

    #Unmapped address 0xce9 testing: random write/read operations
    #Address 0xce9 Write value 0xdb903bf7
    li x3, 0xdb903bf7
    csrw 0xce9, x3

    #Address 0xce9 read value
    csrr x14, 0xce9

    #Address 0xce9 read value
    csrr x14, 0xce9

    #Unmapped address 0x698 testing: random write/read operations
    #Address 0x698 Write value 0x3be65cfd
    li x3, 0x3be65cfd
    csrw 0x698, x3

    #Address 0x698 read value
    csrr x14, 0x698

    #Address 0x698 Write value 0xefab4dd5
    li x3, 0xefab4dd5
    csrw 0x698, x3

    #Unmapped address 0x1e6 testing: random write/read operations
    #Address 0x1e6 read value
    csrr x14, 0x1e6

    #Address 0x1e6 read value
    csrr x14, 0x1e6

    #Address 0x1e6 read value
    csrr x14, 0x1e6

    #Address 0x1e6 read value
    csrr x14, 0x1e6

    #Unmapped address 0xc33 testing: random write/read operations
    #Address 0xc33 read value
    csrr x14, 0xc33

    #Address 0xc33 Write value 0xce597366
    li x3, 0xce597366
    csrw 0xc33, x3

    #Unmapped address 0x921 testing: random write/read operations
    #Address 0x921 Write value 0x28877ddf
    li x3, 0x28877ddf
    csrw 0x921, x3

    #Address 0x921 read value
    csrr x14, 0x921

    #Address 0x921 Write value 0x5d0541cb
    li x3, 0x5d0541cb
    csrw 0x921, x3

    #Address 0x921 Write value 0xe446285d
    li x3, 0xe446285d
    csrw 0x921, x3

    #Unmapped address 0xb30 testing: random write/read operations
    #Address 0xb30 read value
    csrr x14, 0xb30

    #Address 0xb30 Write value 0xdc9eaad3
    li x3, 0xdc9eaad3
    csrw 0xb30, x3

    #Unmapped address 0xf4c testing: random write/read operations
    #Address 0xf4c read value
    csrr x14, 0xf4c

    #Address 0xf4c read value
    csrr x14, 0xf4c

    #Address 0xf4c Write value 0x9a177b5a
    li x3, 0x9a177b5a
    csrw 0xf4c, x3

    #Address 0xf4c read value
    csrr x14, 0xf4c

    #Unmapped address 0xc8 testing: random write/read operations
    #Address 0xc8 read value
    csrr x14, 0xc8

    #Unmapped address 0x69a testing: random write/read operations
    #Address 0x69a Write value 0xd6d6ab7e
    li x3, 0xd6d6ab7e
    csrw 0x69a, x3

    #Address 0x69a Write value 0x30475492
    li x3, 0x30475492
    csrw 0x69a, x3

    #Address 0x69a Write value 0x89365c32
    li x3, 0x89365c32
    csrw 0x69a, x3

    #Unmapped address 0xe9 testing: random write/read operations
    #Address 0xe9 read value
    csrr x14, 0xe9

    #Address 0xe9 Write value 0x20ae3e0b
    li x3, 0x20ae3e0b
    csrw 0xe9, x3

    #Unmapped address 0xbde testing: random write/read operations
    #Address 0xbde Write value 0x35aa194c
    li x3, 0x35aa194c
    csrw 0xbde, x3

    #Address 0xbde read value
    csrr x14, 0xbde

    #Unmapped address 0x874 testing: random write/read operations
    #Address 0x874 read value
    csrr x14, 0x874

    #Address 0x874 Write value 0x7970d492
    li x3, 0x7970d492
    csrw 0x874, x3

    #Address 0x874 read value
    csrr x14, 0x874

    #Unmapped address 0x37 testing: random write/read operations
    #Address 0x37 Write value 0xb66f6ebc
    li x3, 0xb66f6ebc
    csrw 0x37, x3

    #Unmapped address 0xaae testing: random write/read operations
    #Address 0xaae Write value 0xc195ffd8
    li x3, 0xc195ffd8
    csrw 0xaae, x3

    #Unmapped address 0x532 testing: random write/read operations
    #Address 0x532 Write value 0xd35202ad
    li x3, 0xd35202ad
    csrw 0x532, x3

    #Address 0x532 read value
    csrr x14, 0x532

    #Unmapped address 0x4de testing: random write/read operations
    #Address 0x4de Write value 0x8db69579
    li x3, 0x8db69579
    csrw 0x4de, x3

    #Unmapped address 0x872 testing: random write/read operations
    #Address 0x872 read value
    csrr x14, 0x872

    #Address 0x872 read value
    csrr x14, 0x872

    #Unmapped address 0x823 testing: random write/read operations
    #Address 0x823 Write value 0xd7f9d005
    li x3, 0xd7f9d005
    csrw 0x823, x3

    #Mapped address 0x330 (mhpmevent16) testing: random write/read operations
    #Address 0x330 read value
    csrr x14, 0x330

    #Address 0x330 read value
    csrr x14, 0x330

    #Address 0x330 Write value 0x534e30b4
    li x3, 0x534e30b4
    csrw 0x330, x3

    #Unmapped address 0x78a testing: random write/read operations
    #Address 0x78a Write value 0x16f8a39f
    li x3, 0x16f8a39f
    csrw 0x78a, x3

    #Address 0x78a Write value 0xaf50e703
    li x3, 0xaf50e703
    csrw 0x78a, x3

    #Unmapped address 0x1e0 testing: random write/read operations
    #Address 0x1e0 Write value 0x8d074754
    li x3, 0x8d074754
    csrw 0x1e0, x3

    #Address 0x1e0 Write value 0x975a4aac
    li x3, 0x975a4aac
    csrw 0x1e0, x3

    #Address 0x1e0 read value
    csrr x14, 0x1e0

    #Address 0x1e0 read value
    csrr x14, 0x1e0

    #Unmapped address 0x53e testing: random write/read operations
    #Address 0x53e Write value 0x85c4dcae
    li x3, 0x85c4dcae
    csrw 0x53e, x3

    #Address 0x53e read value
    csrr x14, 0x53e

    #Address 0x53e read value
    csrr x14, 0x53e

    #Address 0x53e read value
    csrr x14, 0x53e

    #Unmapped address 0x2fd testing: random write/read operations
    #Address 0x2fd read value
    csrr x14, 0x2fd

    #Address 0x2fd read value
    csrr x14, 0x2fd

    #Address 0x2fd Write value 0x9870b454
    li x3, 0x9870b454
    csrw 0x2fd, x3

    #Address 0x2fd Write value 0xd4d39f52
    li x3, 0xd4d39f52
    csrw 0x2fd, x3

    #Address 0x2fd Write value 0xbe701552
    li x3, 0xbe701552
    csrw 0x2fd, x3

    #Unmapped address 0xa9 testing: random write/read operations
    #Address 0xa9 Write value 0x20ae7252
    li x3, 0x20ae7252
    csrw 0xa9, x3

    #Address 0xa9 read value
    csrr x14, 0xa9

    #Address 0xa9 read value
    csrr x14, 0xa9

    #Address 0xa9 Write value 0xd03cd45b
    li x3, 0xd03cd45b
    csrw 0xa9, x3

    #Unmapped address 0x93a testing: random write/read operations
    #Address 0x93a Write value 0xcfd94c8d
    li x3, 0xcfd94c8d
    csrw 0x93a, x3

    #Address 0x93a read value
    csrr x14, 0x93a

    #Address 0x93a Write value 0xdf86b8af
    li x3, 0xdf86b8af
    csrw 0x93a, x3

    #Unmapped address 0xbdb testing: random write/read operations
    #Address 0xbdb Write value 0x29e51729
    li x3, 0x29e51729
    csrw 0xbdb, x3

    #Address 0xbdb Write value 0xc2e07c3c
    li x3, 0xc2e07c3c
    csrw 0xbdb, x3

    #Address 0xbdb read value
    csrr x14, 0xbdb

    #Address 0xbdb read value
    csrr x14, 0xbdb

    #Address 0xbdb read value
    csrr x14, 0xbdb

    #Unmapped address 0x184 testing: random write/read operations
    #Address 0x184 read value
    csrr x14, 0x184

    #Address 0x184 read value
    csrr x14, 0x184

    #Address 0x184 Write value 0x17770ea4
    li x3, 0x17770ea4
    csrw 0x184, x3

    #Unmapped address 0xca6 testing: random write/read operations
    #Address 0xca6 read value
    csrr x14, 0xca6

    #Unmapped address 0xfc8 testing: random write/read operations
    #Address 0xfc8 read value
    csrr x14, 0xfc8

    #Address 0xfc8 Write value 0x51113988
    li x3, 0x51113988
    csrw 0xfc8, x3

    #Unmapped address 0x953 testing: random write/read operations
    #Address 0x953 Write value 0xb7fda8e0
    li x3, 0xb7fda8e0
    csrw 0x953, x3

    #Address 0x953 read value
    csrr x14, 0x953

    #Unmapped address 0xdda testing: random write/read operations
    #Address 0xdda read value
    csrr x14, 0xdda

    #Address 0xdda read value
    csrr x14, 0xdda

    #Unmapped address 0xf23 testing: random write/read operations
    #Address 0xf23 read value
    csrr x14, 0xf23

    #Address 0xf23 read value
    csrr x14, 0xf23

    #Address 0xf23 Write value 0xe5c72ae9
    li x3, 0xe5c72ae9
    csrw 0xf23, x3

    #Address 0xf23 read value
    csrr x14, 0xf23

    #Unmapped address 0xa8c testing: random write/read operations
    #Address 0xa8c read value
    csrr x14, 0xa8c

    #Address 0xa8c Write value 0xacafc6a8
    li x3, 0xacafc6a8
    csrw 0xa8c, x3

    #Address 0xa8c Write value 0x59c0f0d1
    li x3, 0x59c0f0d1
    csrw 0xa8c, x3

    #Unmapped address 0x6d7 testing: random write/read operations
    #Address 0x6d7 Write value 0x56a3b37f
    li x3, 0x56a3b37f
    csrw 0x6d7, x3

    #Address 0x6d7 Write value 0xfbdaf002
    li x3, 0xfbdaf002
    csrw 0x6d7, x3

    #Unmapped address 0xea3 testing: random write/read operations
    #Address 0xea3 Write value 0xa4503abb
    li x3, 0xa4503abb
    csrw 0xea3, x3

    #Unmapped address 0x5bc testing: random write/read operations
    #Address 0x5bc read value
    csrr x14, 0x5bc

    #Address 0x5bc Write value 0xf0393bf8
    li x3, 0xf0393bf8
    csrw 0x5bc, x3

    #Address 0x5bc Write value 0x73e90d4a
    li x3, 0x73e90d4a
    csrw 0x5bc, x3

    #Address 0x5bc Write value 0x186fc7e0
    li x3, 0x186fc7e0
    csrw 0x5bc, x3

    #Unmapped address 0xb65 testing: random write/read operations
    #Address 0xb65 read value
    csrr x14, 0xb65

    #Address 0xb65 read value
    csrr x14, 0xb65

    #Address 0xb65 read value
    csrr x14, 0xb65

    #Address 0xb65 read value
    csrr x14, 0xb65

    #Unmapped address 0x9a8 testing: random write/read operations
    #Address 0x9a8 read value
    csrr x14, 0x9a8

    #Address 0x9a8 read value
    csrr x14, 0x9a8

    #Address 0x9a8 Write value 0x3b6a2f93
    li x3, 0x3b6a2f93
    csrw 0x9a8, x3

    #Address 0x9a8 Write value 0xaef1baf6
    li x3, 0xaef1baf6
    csrw 0x9a8, x3

    #Unmapped address 0x18f testing: random write/read operations
    #Address 0x18f read value
    csrr x14, 0x18f

    #Address 0x18f Write value 0xad7c7e86
    li x3, 0xad7c7e86
    csrw 0x18f, x3

    #Address 0x18f Write value 0x2336af60
    li x3, 0x2336af60
    csrw 0x18f, x3

    #Address 0x18f Write value 0x57ec85e1
    li x3, 0x57ec85e1
    csrw 0x18f, x3

    #Address 0x18f read value
    csrr x14, 0x18f

    #Unmapped address 0xfe7 testing: random write/read operations
    #Address 0xfe7 read value
    csrr x14, 0xfe7

    #Address 0xfe7 Write value 0xb530523e
    li x3, 0xb530523e
    csrw 0xfe7, x3

    #Address 0xfe7 read value
    csrr x14, 0xfe7

    #Address 0xfe7 Write value 0x3423387b
    li x3, 0x3423387b
    csrw 0xfe7, x3

    #Address 0xfe7 Write value 0x3271d47c
    li x3, 0x3271d47c
    csrw 0xfe7, x3

    #Unmapped address 0x8e6 testing: random write/read operations
    #Address 0x8e6 Write value 0xfddc950a
    li x3, 0xfddc950a
    csrw 0x8e6, x3

    #Address 0x8e6 read value
    csrr x14, 0x8e6

    #Unmapped address 0x795 testing: random write/read operations
    #Address 0x795 Write value 0x1a5c1b54
    li x3, 0x1a5c1b54
    csrw 0x795, x3

    #Address 0x795 read value
    csrr x14, 0x795

    #Address 0x795 read value
    csrr x14, 0x795

    #Address 0x795 read value
    csrr x14, 0x795

    #Unmapped address 0x47 testing: random write/read operations
    #Address 0x47 read value
    csrr x14, 0x47

    #Address 0x47 Write value 0x67abc197
    li x3, 0x67abc197
    csrw 0x47, x3

    #Unmapped address 0xac8 testing: random write/read operations
    #Address 0xac8 Write value 0x186e9917
    li x3, 0x186e9917
    csrw 0xac8, x3

    #Address 0xac8 read value
    csrr x14, 0xac8

    #Address 0xac8 read value
    csrr x14, 0xac8

    #Address 0xac8 read value
    csrr x14, 0xac8

    #Unmapped address 0x725 testing: random write/read operations
    #Address 0x725 Write value 0xa89f68f5
    li x3, 0xa89f68f5
    csrw 0x725, x3

    #Address 0x725 Write value 0xe4f0aafb
    li x3, 0xe4f0aafb
    csrw 0x725, x3

    #Address 0x725 Write value 0xf8408bcc
    li x3, 0xf8408bcc
    csrw 0x725, x3

    #Address 0x725 read value
    csrr x14, 0x725

    #Unmapped address 0xebe testing: random write/read operations
    #Address 0xebe Write value 0x50baa490
    li x3, 0x50baa490
    csrw 0xebe, x3

    #Address 0xebe Write value 0x683fc484
    li x3, 0x683fc484
    csrw 0xebe, x3

    #Address 0xebe Write value 0xba5f0102
    li x3, 0xba5f0102
    csrw 0xebe, x3

    #Address 0xebe Write value 0x87452249
    li x3, 0x87452249
    csrw 0xebe, x3

    #Unmapped address 0xf78 testing: random write/read operations
    #Address 0xf78 Write value 0xa0cb28f
    li x3, 0xa0cb28f
    csrw 0xf78, x3

    #Unmapped address 0xd92 testing: random write/read operations
    #Address 0xd92 Write value 0x1bcbbef4
    li x3, 0x1bcbbef4
    csrw 0xd92, x3

    #Address 0xd92 Write value 0x9f1df834
    li x3, 0x9f1df834
    csrw 0xd92, x3

    #Address 0xd92 Write value 0x91a4bce
    li x3, 0x91a4bce
    csrw 0xd92, x3

    #Address 0xd92 Write value 0x30cad8d8
    li x3, 0x30cad8d8
    csrw 0xd92, x3

    #Address 0xd92 read value
    csrr x14, 0xd92

    #Unmapped address 0x130 testing: random write/read operations
    #Address 0x130 Write value 0x674ca0ca
    li x3, 0x674ca0ca
    csrw 0x130, x3

    #Address 0x130 read value
    csrr x14, 0x130

    #Unmapped address 0x28d testing: random write/read operations
    #Address 0x28d Write value 0xa2a07544
    li x3, 0xa2a07544
    csrw 0x28d, x3

    #Address 0x28d Write value 0xdb715524
    li x3, 0xdb715524
    csrw 0x28d, x3

    #Address 0x28d read value
    csrr x14, 0x28d

    #Address 0x28d read value
    csrr x14, 0x28d

    #Address 0x28d Write value 0xa6b52084
    li x3, 0xa6b52084
    csrw 0x28d, x3

    #Unmapped address 0xeb1 testing: random write/read operations
    #Address 0xeb1 Write value 0x54b7fafd
    li x3, 0x54b7fafd
    csrw 0xeb1, x3

    #Address 0xeb1 Write value 0x46a5b2ab
    li x3, 0x46a5b2ab
    csrw 0xeb1, x3

    #Unmapped address 0x5ba testing: random write/read operations
    #Address 0x5ba Write value 0xacfbe326
    li x3, 0xacfbe326
    csrw 0x5ba, x3

    #Address 0x5ba read value
    csrr x14, 0x5ba

    #Address 0x5ba read value
    csrr x14, 0x5ba

    #Address 0x5ba read value
    csrr x14, 0x5ba

    #Address 0x5ba read value
    csrr x14, 0x5ba

    #Unmapped address 0x35e testing: random write/read operations
    #Address 0x35e Write value 0xb327f781
    li x3, 0xb327f781
    csrw 0x35e, x3

    #Address 0x35e Write value 0x59f0f7c7
    li x3, 0x59f0f7c7
    csrw 0x35e, x3

    #Unmapped address 0x927 testing: random write/read operations
    #Address 0x927 read value
    csrr x14, 0x927

    #Address 0x927 Write value 0x4cfe2254
    li x3, 0x4cfe2254
    csrw 0x927, x3

    #Address 0x927 read value
    csrr x14, 0x927

    #Address 0x927 read value
    csrr x14, 0x927

    #Address 0x927 Write value 0x620449c7
    li x3, 0x620449c7
    csrw 0x927, x3

    #Unmapped address 0xa4 testing: random write/read operations
    #Address 0xa4 Write value 0x3c65ee64
    li x3, 0x3c65ee64
    csrw 0xa4, x3

    #Address 0xa4 Write value 0x56e86976
    li x3, 0x56e86976
    csrw 0xa4, x3

    #Unmapped address 0x2cd testing: random write/read operations
    #Address 0x2cd read value
    csrr x14, 0x2cd

    #Address 0x2cd Write value 0xe5cfd87d
    li x3, 0xe5cfd87d
    csrw 0x2cd, x3

    #Unmapped address 0x3b testing: random write/read operations
    #Address 0x3b read value
    csrr x14, 0x3b

    #Unmapped address 0xce8 testing: random write/read operations
    #Address 0xce8 read value
    csrr x14, 0xce8

    #Address 0xce8 read value
    csrr x14, 0xce8

    #Address 0xce8 read value
    csrr x14, 0xce8

    #Unmapped address 0xa22 testing: random write/read operations
    #Address 0xa22 read value
    csrr x14, 0xa22

    #Address 0xa22 Write value 0xa291355b
    li x3, 0xa291355b
    csrw 0xa22, x3

    #Address 0xa22 Write value 0x8c0baa4d
    li x3, 0x8c0baa4d
    csrw 0xa22, x3

    #Address 0xa22 read value
    csrr x14, 0xa22

    #Address 0xa22 read value
    csrr x14, 0xa22

    #Unmapped address 0x822 testing: random write/read operations
    #Address 0x822 read value
    csrr x14, 0x822

    #Address 0x822 Write value 0x3e0acaa4
    li x3, 0x3e0acaa4
    csrw 0x822, x3

    #Unmapped address 0x8e9 testing: random write/read operations
    #Address 0x8e9 Write value 0xdfc8a8a6
    li x3, 0xdfc8a8a6
    csrw 0x8e9, x3

    #Unmapped address 0x741 testing: random write/read operations
    #Address 0x741 Write value 0x7caa281
    li x3, 0x7caa281
    csrw 0x741, x3

    #Address 0x741 Write value 0x7b3612e6
    li x3, 0x7b3612e6
    csrw 0x741, x3

    #Unmapped address 0x101 testing: random write/read operations
    #Address 0x101 read value
    csrr x14, 0x101

    #Address 0x101 read value
    csrr x14, 0x101

    #Unmapped address 0xfa testing: random write/read operations
    #Address 0xfa Write value 0x4a6bb643
    li x3, 0x4a6bb643
    csrw 0xfa, x3

    #Address 0xfa read value
    csrr x14, 0xfa

    #Address 0xfa Write value 0xb6021fa1
    li x3, 0xb6021fa1
    csrw 0xfa, x3

    #Address 0xfa Write value 0x890ff549
    li x3, 0x890ff549
    csrw 0xfa, x3

    #Unmapped address 0xc85 testing: random write/read operations
    #Address 0xc85 Write value 0x30daf133
    li x3, 0x30daf133
    csrw 0xc85, x3

    #Address 0xc85 Write value 0x1e7e75b7
    li x3, 0x1e7e75b7
    csrw 0xc85, x3

    #Address 0xc85 Write value 0x4782387e
    li x3, 0x4782387e
    csrw 0xc85, x3

    #Unmapped address 0x581 testing: random write/read operations
    #Address 0x581 read value
    csrr x14, 0x581

    #Address 0x581 read value
    csrr x14, 0x581

    #Mapped address 0xb92 (mhpmcounterh18) testing: random write/read operations
    #Address 0xb92 read value
    csrr x14, 0xb92

    #Address 0xb92 Write value 0x49df3bde
    li x3, 0x49df3bde
    csrw 0xb92, x3

    #Address 0xb92 Write value 0x76bfc332
    li x3, 0x76bfc332
    csrw 0xb92, x3

    #Unmapped address 0x9 testing: random write/read operations
    #Address 0x9 Write value 0xd8d35d44
    li x3, 0xd8d35d44
    csrw 0x9, x3

    #Unmapped address 0x50c testing: random write/read operations
    #Address 0x50c read value
    csrr x14, 0x50c

    #Address 0x50c read value
    csrr x14, 0x50c

    #Unmapped address 0xeb8 testing: random write/read operations
    #Address 0xeb8 Write value 0xe6bd8db9
    li x3, 0xe6bd8db9
    csrw 0xeb8, x3

    #Address 0xeb8 Write value 0xc2e213c
    li x3, 0xc2e213c
    csrw 0xeb8, x3

    #Address 0xeb8 read value
    csrr x14, 0xeb8

    #Unmapped address 0x489 testing: random write/read operations
    #Address 0x489 read value
    csrr x14, 0x489

    #Unmapped address 0xe66 testing: random write/read operations
    #Address 0xe66 Write value 0x4c5b5c4
    li x3, 0x4c5b5c4
    csrw 0xe66, x3

    #Address 0xe66 read value
    csrr x14, 0xe66

    #Address 0xe66 read value
    csrr x14, 0xe66

    #Unmapped address 0x535 testing: random write/read operations
    #Address 0x535 read value
    csrr x14, 0x535

    #Address 0x535 Write value 0x30c715c1
    li x3, 0x30c715c1
    csrw 0x535, x3

    #Address 0x535 Write value 0xca5dd95e
    li x3, 0xca5dd95e
    csrw 0x535, x3

    #Address 0x535 read value
    csrr x14, 0x535

    #Address 0x535 Write value 0x1cbf1932
    li x3, 0x1cbf1932
    csrw 0x535, x3

    #Unmapped address 0x138 testing: random write/read operations
    #Address 0x138 Write value 0x9e8a1f2b
    li x3, 0x9e8a1f2b
    csrw 0x138, x3

    #Unmapped address 0x18d testing: random write/read operations
    #Address 0x18d read value
    csrr x14, 0x18d

    #Unmapped address 0x140 testing: random write/read operations
    #Address 0x140 Write value 0xdfccf0ed
    li x3, 0xdfccf0ed
    csrw 0x140, x3

    #Address 0x140 Write value 0x6f637cb8
    li x3, 0x6f637cb8
    csrw 0x140, x3

    #Unmapped address 0xd8b testing: random write/read operations
    #Address 0xd8b read value
    csrr x14, 0xd8b

    #Address 0xd8b read value
    csrr x14, 0xd8b

    #Unmapped address 0x6b4 testing: random write/read operations
    #Address 0x6b4 read value
    csrr x14, 0x6b4

    #Address 0x6b4 Write value 0xd58fb0fb
    li x3, 0xd58fb0fb
    csrw 0x6b4, x3

    #Address 0x6b4 Write value 0x9135ec1
    li x3, 0x9135ec1
    csrw 0x6b4, x3

    #Address 0x6b4 read value
    csrr x14, 0x6b4

    #Address 0x6b4 read value
    csrr x14, 0x6b4

    #Unmapped address 0x74f testing: random write/read operations
    #Address 0x74f Write value 0xc142130c
    li x3, 0xc142130c
    csrw 0x74f, x3

    #Address 0x74f read value
    csrr x14, 0x74f

    #Address 0x74f read value
    csrr x14, 0x74f

    #Address 0x74f Write value 0xacdda72
    li x3, 0xacdda72
    csrw 0x74f, x3

    #Address 0x74f read value
    csrr x14, 0x74f

    #Unmapped address 0x5e1 testing: random write/read operations
    #Address 0x5e1 read value
    csrr x14, 0x5e1

    #Address 0x5e1 read value
    csrr x14, 0x5e1

    #Address 0x5e1 read value
    csrr x14, 0x5e1

    #Unmapped address 0x60e testing: random write/read operations
    #Address 0x60e Write value 0xa0f8f3f2
    li x3, 0xa0f8f3f2
    csrw 0x60e, x3

    #Unmapped address 0xdb0 testing: random write/read operations
    #Address 0xdb0 read value
    csrr x14, 0xdb0

    #Address 0xdb0 Write value 0xf2fe64f2
    li x3, 0xf2fe64f2
    csrw 0xdb0, x3

    #Address 0xdb0 Write value 0xa1413c66
    li x3, 0xa1413c66
    csrw 0xdb0, x3

    #Address 0xdb0 Write value 0xea0f503d
    li x3, 0xea0f503d
    csrw 0xdb0, x3

    #Unmapped address 0x203 testing: random write/read operations
    #Address 0x203 Write value 0x540a058f
    li x3, 0x540a058f
    csrw 0x203, x3

    #Address 0x203 Write value 0x89aedebe
    li x3, 0x89aedebe
    csrw 0x203, x3

    #Address 0x203 Write value 0x5dd5e702
    li x3, 0x5dd5e702
    csrw 0x203, x3

    #Address 0x203 Write value 0x407c88cb
    li x3, 0x407c88cb
    csrw 0x203, x3

    #Unmapped address 0x291 testing: random write/read operations
    #Address 0x291 Write value 0xd573026d
    li x3, 0xd573026d
    csrw 0x291, x3

    #Address 0x291 Write value 0xf6fa6312
    li x3, 0xf6fa6312
    csrw 0x291, x3

    #Address 0x291 Write value 0xba05c224
    li x3, 0xba05c224
    csrw 0x291, x3

    #Address 0x291 read value
    csrr x14, 0x291

    #Address 0x291 Write value 0x1ef357d3
    li x3, 0x1ef357d3
    csrw 0x291, x3

    #Unmapped address 0x9ab testing: random write/read operations
    #Address 0x9ab read value
    csrr x14, 0x9ab

    #Address 0x9ab read value
    csrr x14, 0x9ab

    #Address 0x9ab read value
    csrr x14, 0x9ab

    #Mapped address 0x336 (mhpmevent22) testing: random write/read operations
    #Address 0x336 Write value 0xac5f10eb
    li x3, 0xac5f10eb
    csrw 0x336, x3

    #Address 0x336 read value
    csrr x14, 0x336

    #Address 0x336 Write value 0x70e17e81
    li x3, 0x70e17e81
    csrw 0x336, x3

    #Unmapped address 0xd5c testing: random write/read operations
    #Address 0xd5c Write value 0xc93a2067
    li x3, 0xc93a2067
    csrw 0xd5c, x3

    #Unmapped address 0x119 testing: random write/read operations
    #Address 0x119 Write value 0x252a7766
    li x3, 0x252a7766
    csrw 0x119, x3

    #Address 0x119 read value
    csrr x14, 0x119

    #Address 0x119 Write value 0x7a05cd6f
    li x3, 0x7a05cd6f
    csrw 0x119, x3

    #Address 0x119 read value
    csrr x14, 0x119

    #Address 0x119 Write value 0x7c0038b3
    li x3, 0x7c0038b3
    csrw 0x119, x3

    #Unmapped address 0xe3e testing: random write/read operations
    #Address 0xe3e Write value 0x14a48d86
    li x3, 0x14a48d86
    csrw 0xe3e, x3

    #Address 0xe3e read value
    csrr x14, 0xe3e

    #Unmapped address 0x53b testing: random write/read operations
    #Address 0x53b Write value 0x773999b8
    li x3, 0x773999b8
    csrw 0x53b, x3

    #Unmapped address 0xd35 testing: random write/read operations
    #Address 0xd35 Write value 0x739142a5
    li x3, 0x739142a5
    csrw 0xd35, x3

    #Unmapped address 0x9bf testing: random write/read operations
    #Address 0x9bf Write value 0x6dd5fe61
    li x3, 0x6dd5fe61
    csrw 0x9bf, x3

    #Unmapped address 0xde6 testing: random write/read operations
    #Address 0xde6 Write value 0x7c5879e5
    li x3, 0x7c5879e5
    csrw 0xde6, x3

    #Address 0xde6 read value
    csrr x14, 0xde6

    #Address 0xde6 read value
    csrr x14, 0xde6

    #Unmapped address 0xfda testing: random write/read operations
    #Address 0xfda read value
    csrr x14, 0xfda

    #Unmapped address 0xf95 testing: random write/read operations
    #Address 0xf95 read value
    csrr x14, 0xf95

    #Address 0xf95 Write value 0xfe4e19d5
    li x3, 0xfe4e19d5
    csrw 0xf95, x3

    #Address 0xf95 read value
    csrr x14, 0xf95

    #Address 0xf95 Write value 0x4f7aae10
    li x3, 0x4f7aae10
    csrw 0xf95, x3

    #Unmapped address 0xbd8 testing: random write/read operations
    #Address 0xbd8 Write value 0xccee8a34
    li x3, 0xccee8a34
    csrw 0xbd8, x3

    #Address 0xbd8 Write value 0x35ed92a2
    li x3, 0x35ed92a2
    csrw 0xbd8, x3

    #Address 0xbd8 read value
    csrr x14, 0xbd8

    #Unmapped address 0x9c5 testing: random write/read operations
    #Address 0x9c5 Write value 0x31ee4743
    li x3, 0x31ee4743
    csrw 0x9c5, x3

    #Address 0x9c5 read value
    csrr x14, 0x9c5

    #Address 0x9c5 read value
    csrr x14, 0x9c5

    #Unmapped address 0xb76 testing: random write/read operations
    #Address 0xb76 read value
    csrr x14, 0xb76

    #Address 0xb76 Write value 0x6c62b0a2
    li x3, 0x6c62b0a2
    csrw 0xb76, x3

    #Unmapped address 0xdd4 testing: random write/read operations
    #Address 0xdd4 read value
    csrr x14, 0xdd4

    #Address 0xdd4 read value
    csrr x14, 0xdd4

    #Address 0xdd4 Write value 0x95773891
    li x3, 0x95773891
    csrw 0xdd4, x3

    #Address 0xdd4 read value
    csrr x14, 0xdd4

    #Address 0xdd4 Write value 0x6f941be4
    li x3, 0x6f941be4
    csrw 0xdd4, x3

    #Unmapped address 0x6cf testing: random write/read operations
    #Address 0x6cf read value
    csrr x14, 0x6cf

    #Address 0x6cf Write value 0x66173007
    li x3, 0x66173007
    csrw 0x6cf, x3

    #Address 0x6cf read value
    csrr x14, 0x6cf

    #Address 0x6cf read value
    csrr x14, 0x6cf

    #Address 0x6cf read value
    csrr x14, 0x6cf

    #Unmapped address 0xdeb testing: random write/read operations
    #Address 0xdeb read value
    csrr x14, 0xdeb

    #Unmapped address 0xbe testing: random write/read operations
    #Address 0xbe Write value 0xfc680722
    li x3, 0xfc680722
    csrw 0xbe, x3

    #Unmapped address 0xf6a testing: random write/read operations
    #Address 0xf6a read value
    csrr x14, 0xf6a

    #Address 0xf6a Write value 0xfc6e8cc0
    li x3, 0xfc6e8cc0
    csrw 0xf6a, x3

    #Address 0xf6a read value
    csrr x14, 0xf6a

    #Address 0xf6a Write value 0x295a734a
    li x3, 0x295a734a
    csrw 0xf6a, x3

    #Unmapped address 0x2a6 testing: random write/read operations
    #Address 0x2a6 read value
    csrr x14, 0x2a6

    #Address 0x2a6 read value
    csrr x14, 0x2a6

    #Unmapped address 0x2d3 testing: random write/read operations
    #Address 0x2d3 read value
    csrr x14, 0x2d3

    #Address 0x2d3 read value
    csrr x14, 0x2d3

    #Address 0x2d3 read value
    csrr x14, 0x2d3

    #Address 0x2d3 Write value 0x7774cb8f
    li x3, 0x7774cb8f
    csrw 0x2d3, x3

    #Address 0x2d3 read value
    csrr x14, 0x2d3

    #Unmapped address 0x58b testing: random write/read operations
    #Address 0x58b read value
    csrr x14, 0x58b

    #Unmapped address 0x7c2 testing: random write/read operations
    #Address 0x7c2 read value
    csrr x14, 0x7c2

    #Unmapped address 0x8ef testing: random write/read operations
    #Address 0x8ef read value
    csrr x14, 0x8ef

    #Address 0x8ef read value
    csrr x14, 0x8ef

    #Address 0x8ef read value
    csrr x14, 0x8ef

    #Address 0x8ef read value
    csrr x14, 0x8ef

    #Address 0x8ef read value
    csrr x14, 0x8ef

    #Mapped address 0xb91 (mhpmcounterh17) testing: random write/read operations
    #Address 0xb91 Write value 0x28d2fa20
    li x3, 0x28d2fa20
    csrw 0xb91, x3

    #Address 0xb91 Write value 0x10286648
    li x3, 0x10286648
    csrw 0xb91, x3

    #Address 0xb91 Write value 0xbea69d02
    li x3, 0xbea69d02
    csrw 0xb91, x3

    #Address 0xb91 Write value 0x1d447f67
    li x3, 0x1d447f67
    csrw 0xb91, x3

    #Address 0xb91 Write value 0xc028629e
    li x3, 0xc028629e
    csrw 0xb91, x3

    #Unmapped address 0xc13 testing: random write/read operations
    #Address 0xc13 Write value 0x9916da66
    li x3, 0x9916da66
    csrw 0xc13, x3

    #Address 0xc13 Write value 0x17943bda
    li x3, 0x17943bda
    csrw 0xc13, x3

    #Address 0xc13 Write value 0xadcfb406
    li x3, 0xadcfb406
    csrw 0xc13, x3

    #Unmapped address 0x5c8 testing: random write/read operations
    #Address 0x5c8 Write value 0x4ff9305e
    li x3, 0x4ff9305e
    csrw 0x5c8, x3

    #Address 0x5c8 Write value 0x82ad56c0
    li x3, 0x82ad56c0
    csrw 0x5c8, x3

    #Address 0x5c8 read value
    csrr x14, 0x5c8

    #Unmapped address 0x443 testing: random write/read operations
    #Address 0x443 read value
    csrr x14, 0x443

    #Address 0x443 read value
    csrr x14, 0x443

    #Address 0x443 Write value 0x4426e2cf
    li x3, 0x4426e2cf
    csrw 0x443, x3

    #Address 0x443 Write value 0xafa73a88
    li x3, 0xafa73a88
    csrw 0x443, x3

    #Unmapped address 0x91d testing: random write/read operations
    #Address 0x91d Write value 0xa59bc31a
    li x3, 0xa59bc31a
    csrw 0x91d, x3

    #Unmapped address 0x22 testing: random write/read operations
    #Address 0x22 Write value 0x2dbd28c2
    li x3, 0x2dbd28c2
    csrw 0x22, x3

    #Address 0x22 Write value 0x7d27cc9c
    li x3, 0x7d27cc9c
    csrw 0x22, x3

    #Unmapped address 0xe37 testing: random write/read operations
    #Address 0xe37 Write value 0x5c1d1063
    li x3, 0x5c1d1063
    csrw 0xe37, x3

    #Address 0xe37 Write value 0xe092c18c
    li x3, 0xe092c18c
    csrw 0xe37, x3

    #Address 0xe37 read value
    csrr x14, 0xe37

    #Address 0xe37 read value
    csrr x14, 0xe37

    #Address 0xe37 read value
    csrr x14, 0xe37

    #Unmapped address 0xed9 testing: random write/read operations
    #Address 0xed9 Write value 0xd59b84e2
    li x3, 0xd59b84e2
    csrw 0xed9, x3

    #Address 0xed9 read value
    csrr x14, 0xed9

    #Address 0xed9 Write value 0x63499423
    li x3, 0x63499423
    csrw 0xed9, x3

    #Address 0xed9 Write value 0xf9e67c81
    li x3, 0xf9e67c81
    csrw 0xed9, x3

    #Unmapped address 0x688 testing: random write/read operations
    #Address 0x688 Write value 0xf48d009f
    li x3, 0xf48d009f
    csrw 0x688, x3

    #Address 0x688 read value
    csrr x14, 0x688

    #Address 0x688 read value
    csrr x14, 0x688

    #Address 0x688 Write value 0x9a3b7b3f
    li x3, 0x9a3b7b3f
    csrw 0x688, x3

    #Address 0x688 read value
    csrr x14, 0x688

    #Unmapped address 0x5f9 testing: random write/read operations
    #Address 0x5f9 Write value 0xbe9426bd
    li x3, 0xbe9426bd
    csrw 0x5f9, x3

    #Address 0x5f9 read value
    csrr x14, 0x5f9

    #Address 0x5f9 read value
    csrr x14, 0x5f9

    #Address 0x5f9 read value
    csrr x14, 0x5f9

    #Unmapped address 0x767 testing: random write/read operations
    #Address 0x767 Write value 0x21cc87d7
    li x3, 0x21cc87d7
    csrw 0x767, x3

    #Address 0x767 Write value 0xd2d0bf7a
    li x3, 0xd2d0bf7a
    csrw 0x767, x3

    #Unmapped address 0x7e1 testing: random write/read operations
    #Address 0x7e1 Write value 0x414dd821
    li x3, 0x414dd821
    csrw 0x7e1, x3

    #Address 0x7e1 read value
    csrr x14, 0x7e1

    #Address 0x7e1 read value
    csrr x14, 0x7e1

    #Unmapped address 0x73e testing: random write/read operations
    #Address 0x73e Write value 0x6710bf58
    li x3, 0x6710bf58
    csrw 0x73e, x3

    #Address 0x73e read value
    csrr x14, 0x73e

    #Address 0x73e Write value 0xa36f360a
    li x3, 0xa36f360a
    csrw 0x73e, x3

    #Address 0x73e read value
    csrr x14, 0x73e

    #Unmapped address 0xcc testing: random write/read operations
    #Address 0xcc Write value 0x15488561
    li x3, 0x15488561
    csrw 0xcc, x3

    #Address 0xcc read value
    csrr x14, 0xcc

    #Address 0xcc Write value 0xbf3c6d69
    li x3, 0xbf3c6d69
    csrw 0xcc, x3

    #Address 0xcc Write value 0x57992e68
    li x3, 0x57992e68
    csrw 0xcc, x3

    #Unmapped address 0x918 testing: random write/read operations
    #Address 0x918 read value
    csrr x14, 0x918

    #Unmapped address 0x615 testing: random write/read operations
    #Address 0x615 Write value 0xe10d3a35
    li x3, 0xe10d3a35
    csrw 0x615, x3

    #Address 0x615 Write value 0xc3d91a7f
    li x3, 0xc3d91a7f
    csrw 0x615, x3

    #Address 0x615 Write value 0xcb5af27c
    li x3, 0xcb5af27c
    csrw 0x615, x3

    #Address 0x615 read value
    csrr x14, 0x615

    #Address 0x615 read value
    csrr x14, 0x615

    #Unmapped address 0xcc3 testing: random write/read operations
    #Address 0xcc3 Write value 0x4e8cb600
    li x3, 0x4e8cb600
    csrw 0xcc3, x3

    #Address 0xcc3 Write value 0x509b305b
    li x3, 0x509b305b
    csrw 0xcc3, x3

    #Address 0xcc3 Write value 0x6eafcc57
    li x3, 0x6eafcc57
    csrw 0xcc3, x3

    #Address 0xcc3 Write value 0x16ae321e
    li x3, 0x16ae321e
    csrw 0xcc3, x3

    #Address 0xcc3 read value
    csrr x14, 0xcc3

    #Unmapped address 0x1b6 testing: random write/read operations
    #Address 0x1b6 read value
    csrr x14, 0x1b6

    #Unmapped address 0xd6a testing: random write/read operations
    #Address 0xd6a Write value 0x38eb5aab
    li x3, 0x38eb5aab
    csrw 0xd6a, x3

    #Address 0xd6a read value
    csrr x14, 0xd6a

    #Address 0xd6a Write value 0x45e85155
    li x3, 0x45e85155
    csrw 0xd6a, x3

    #Address 0xd6a Write value 0xb690aca
    li x3, 0xb690aca
    csrw 0xd6a, x3

    #Address 0xd6a read value
    csrr x14, 0xd6a

    #Unmapped address 0x550 testing: random write/read operations
    #Address 0x550 read value
    csrr x14, 0x550

    #Address 0x550 read value
    csrr x14, 0x550

    #Unmapped address 0x1fd testing: random write/read operations
    #Address 0x1fd read value
    csrr x14, 0x1fd

    #Address 0x1fd Write value 0x5d9c6f99
    li x3, 0x5d9c6f99
    csrw 0x1fd, x3

    #Address 0x1fd read value
    csrr x14, 0x1fd

    #Address 0x1fd Write value 0x44515321
    li x3, 0x44515321
    csrw 0x1fd, x3

    #Unmapped address 0x542 testing: random write/read operations
    #Address 0x542 read value
    csrr x14, 0x542

    #Unmapped address 0x3c8 testing: random write/read operations
    #Address 0x3c8 Write value 0xc7f80fcb
    li x3, 0xc7f80fcb
    csrw 0x3c8, x3

    #Address 0x3c8 read value
    csrr x14, 0x3c8

    #Address 0x3c8 read value
    csrr x14, 0x3c8

    #Unmapped address 0xe48 testing: random write/read operations
    #Address 0xe48 read value
    csrr x14, 0xe48

    #Address 0xe48 Write value 0x9bcd5fb2
    li x3, 0x9bcd5fb2
    csrw 0xe48, x3

    #Address 0xe48 read value
    csrr x14, 0xe48

    #Address 0xe48 Write value 0x7dd3847b
    li x3, 0x7dd3847b
    csrw 0xe48, x3

    #Unmapped address 0x936 testing: random write/read operations
    #Address 0x936 Write value 0xa3064c1f
    li x3, 0xa3064c1f
    csrw 0x936, x3

    #Unmapped address 0xca1 testing: random write/read operations
    #Address 0xca1 Write value 0xfb4aea4c
    li x3, 0xfb4aea4c
    csrw 0xca1, x3

    #Unmapped address 0xe38 testing: random write/read operations
    #Address 0xe38 Write value 0xbf3ba958
    li x3, 0xbf3ba958
    csrw 0xe38, x3

    #Address 0xe38 Write value 0xe7611d27
    li x3, 0xe7611d27
    csrw 0xe38, x3

    #Address 0xe38 Write value 0x4744942
    li x3, 0x4744942
    csrw 0xe38, x3

    #Address 0xe38 read value
    csrr x14, 0xe38

    #Address 0xe38 Write value 0x87ab0c2e
    li x3, 0x87ab0c2e
    csrw 0xe38, x3

    #Unmapped address 0x5e2 testing: random write/read operations
    #Address 0x5e2 Write value 0x5827a15a
    li x3, 0x5827a15a
    csrw 0x5e2, x3

    #Unmapped address 0xe03 testing: random write/read operations
    #Address 0xe03 read value
    csrr x14, 0xe03

    #Address 0xe03 Write value 0x49876831
    li x3, 0x49876831
    csrw 0xe03, x3

    #Address 0xe03 read value
    csrr x14, 0xe03

    #Address 0xe03 Write value 0x94b9193b
    li x3, 0x94b9193b
    csrw 0xe03, x3

    #Address 0xe03 read value
    csrr x14, 0xe03

    #Unmapped address 0xe92 testing: random write/read operations
    #Address 0xe92 Write value 0x46e7effa
    li x3, 0x46e7effa
    csrw 0xe92, x3

    #Address 0xe92 Write value 0x2886624d
    li x3, 0x2886624d
    csrw 0xe92, x3

    #Address 0xe92 read value
    csrr x14, 0xe92

    #Address 0xe92 read value
    csrr x14, 0xe92

    #Address 0xe92 read value
    csrr x14, 0xe92

    #Unmapped address 0x4df testing: random write/read operations
    #Address 0x4df Write value 0x622bc3df
    li x3, 0x622bc3df
    csrw 0x4df, x3

    #Address 0x4df Write value 0x3a93c74b
    li x3, 0x3a93c74b
    csrw 0x4df, x3

    #Address 0x4df read value
    csrr x14, 0x4df

    #Address 0x4df read value
    csrr x14, 0x4df

    #Unmapped address 0x5f5 testing: random write/read operations
    #Address 0x5f5 read value
    csrr x14, 0x5f5

    #Address 0x5f5 read value
    csrr x14, 0x5f5

    #Address 0x5f5 read value
    csrr x14, 0x5f5

    #Address 0x5f5 Write value 0xa604097d
    li x3, 0xa604097d
    csrw 0x5f5, x3

    #Address 0x5f5 read value
    csrr x14, 0x5f5

    #Unmapped address 0x8d0 testing: random write/read operations
    #Address 0x8d0 Write value 0x8e669016
    li x3, 0x8e669016
    csrw 0x8d0, x3

    #Address 0x8d0 Write value 0x5f50cd27
    li x3, 0x5f50cd27
    csrw 0x8d0, x3

    #Address 0x8d0 Write value 0x31a3c9f5
    li x3, 0x31a3c9f5
    csrw 0x8d0, x3

    #Unmapped address 0x553 testing: random write/read operations
    #Address 0x553 Write value 0x54e7e40a
    li x3, 0x54e7e40a
    csrw 0x553, x3

    #Address 0x553 read value
    csrr x14, 0x553

    #Address 0x553 Write value 0x5eb86b8b
    li x3, 0x5eb86b8b
    csrw 0x553, x3

    #Address 0x553 read value
    csrr x14, 0x553

    #Unmapped address 0xd25 testing: random write/read operations
    #Address 0xd25 read value
    csrr x14, 0xd25

    #Address 0xd25 read value
    csrr x14, 0xd25

    #Address 0xd25 Write value 0x64fd6c27
    li x3, 0x64fd6c27
    csrw 0xd25, x3

    #Address 0xd25 Write value 0xb863233d
    li x3, 0xb863233d
    csrw 0xd25, x3

    #Address 0xd25 Write value 0xaf9d4c78
    li x3, 0xaf9d4c78
    csrw 0xd25, x3

    #Unmapped address 0xdb testing: random write/read operations
    #Address 0xdb read value
    csrr x14, 0xdb

    #Address 0xdb read value
    csrr x14, 0xdb

    #Address 0xdb Write value 0x55adf9ae
    li x3, 0x55adf9ae
    csrw 0xdb, x3

    #Address 0xdb Write value 0x684d335d
    li x3, 0x684d335d
    csrw 0xdb, x3

    #Unmapped address 0x25d testing: random write/read operations
    #Address 0x25d read value
    csrr x14, 0x25d

    #Address 0x25d read value
    csrr x14, 0x25d

    #Address 0x25d read value
    csrr x14, 0x25d

    #Address 0x25d Write value 0xafacf730
    li x3, 0xafacf730
    csrw 0x25d, x3

    #Address 0x25d Write value 0x5bdf7964
    li x3, 0x5bdf7964
    csrw 0x25d, x3

    #Unmapped address 0x352 testing: random write/read operations
    #Address 0x352 read value
    csrr x14, 0x352

    #Address 0x352 read value
    csrr x14, 0x352

    #Address 0x352 Write value 0xd371c92c
    li x3, 0xd371c92c
    csrw 0x352, x3

    #Address 0x352 Write value 0x351f721c
    li x3, 0x351f721c
    csrw 0x352, x3

    #Unmapped address 0x4d testing: random write/read operations
    #Address 0x4d Write value 0x1f1035ec
    li x3, 0x1f1035ec
    csrw 0x4d, x3

    #Address 0x4d read value
    csrr x14, 0x4d

    #Address 0x4d Write value 0x1c26d199
    li x3, 0x1c26d199
    csrw 0x4d, x3

    #Address 0x4d Write value 0xafadec37
    li x3, 0xafadec37
    csrw 0x4d, x3

    #Address 0x4d read value
    csrr x14, 0x4d

    #Unmapped address 0x5b8 testing: random write/read operations
    #Address 0x5b8 Write value 0x2166b46e
    li x3, 0x2166b46e
    csrw 0x5b8, x3

    #Address 0x5b8 read value
    csrr x14, 0x5b8

    #Address 0x5b8 read value
    csrr x14, 0x5b8

    #Address 0x5b8 Write value 0xcc0004d0
    li x3, 0xcc0004d0
    csrw 0x5b8, x3

    #Unmapped address 0xef1 testing: random write/read operations
    #Address 0xef1 Write value 0x154ccfc
    li x3, 0x154ccfc
    csrw 0xef1, x3

    #Address 0xef1 Write value 0xb2b5d597
    li x3, 0xb2b5d597
    csrw 0xef1, x3

    #Address 0xef1 Write value 0xcfa6aa07
    li x3, 0xcfa6aa07
    csrw 0xef1, x3

    #Unmapped address 0x321 testing: random write/read operations
    #Address 0x321 read value
    csrr x14, 0x321

    #Address 0x321 read value
    csrr x14, 0x321

    #Address 0x321 Write value 0xbaad53
    li x3, 0xbaad53
    csrw 0x321, x3

    #Unmapped address 0x49b testing: random write/read operations
    #Address 0x49b read value
    csrr x14, 0x49b

    #Address 0x49b read value
    csrr x14, 0x49b

    #Address 0x49b Write value 0xcfa69726
    li x3, 0xcfa69726
    csrw 0x49b, x3

    #Unmapped address 0xc06 testing: random write/read operations
    #Address 0xc06 read value
    csrr x14, 0xc06

    #Address 0xc06 Write value 0xad35f0f3
    li x3, 0xad35f0f3
    csrw 0xc06, x3

    #Address 0xc06 read value
    csrr x14, 0xc06

    #Address 0xc06 read value
    csrr x14, 0xc06

    #Address 0xc06 Write value 0x698639d4
    li x3, 0x698639d4
    csrw 0xc06, x3

    #Unmapped address 0xf22 testing: random write/read operations
    #Address 0xf22 read value
    csrr x14, 0xf22

    #Address 0xf22 read value
    csrr x14, 0xf22

    #Address 0xf22 Write value 0x3ca15696
    li x3, 0x3ca15696
    csrw 0xf22, x3

    #Unmapped address 0x5ae testing: random write/read operations
    #Address 0x5ae Write value 0xcc192a4f
    li x3, 0xcc192a4f
    csrw 0x5ae, x3

    #Address 0x5ae Write value 0x8b358166
    li x3, 0x8b358166
    csrw 0x5ae, x3

    #Address 0x5ae Write value 0x2ee6613
    li x3, 0x2ee6613
    csrw 0x5ae, x3

    #Address 0x5ae read value
    csrr x14, 0x5ae

    #Address 0x5ae read value
    csrr x14, 0x5ae

    #Unmapped address 0x748 testing: random write/read operations
    #Address 0x748 Write value 0xfcc554e5
    li x3, 0xfcc554e5
    csrw 0x748, x3

    #Address 0x748 read value
    csrr x14, 0x748

    #Address 0x748 read value
    csrr x14, 0x748

    #Address 0x748 Write value 0xf5025e1c
    li x3, 0xf5025e1c
    csrw 0x748, x3

    #Unmapped address 0x66d testing: random write/read operations
    #Address 0x66d read value
    csrr x14, 0x66d

    #Address 0x66d Write value 0xf3f9c04
    li x3, 0xf3f9c04
    csrw 0x66d, x3

    #Address 0x66d Write value 0x30af623e
    li x3, 0x30af623e
    csrw 0x66d, x3

    #Unmapped address 0x696 testing: random write/read operations
    #Address 0x696 Write value 0x6ea73478
    li x3, 0x6ea73478
    csrw 0x696, x3

    #Address 0x696 Write value 0xf4947309
    li x3, 0xf4947309
    csrw 0x696, x3

    #Address 0x696 read value
    csrr x14, 0x696

    #Unmapped address 0x486 testing: random write/read operations
    #Address 0x486 read value
    csrr x14, 0x486

    #Unmapped address 0x7d5 testing: random write/read operations
    #Address 0x7d5 read value
    csrr x14, 0x7d5

    #Unmapped address 0x56d testing: random write/read operations
    #Address 0x56d Write value 0xd4fd2ac7
    li x3, 0xd4fd2ac7
    csrw 0x56d, x3

    #Address 0x56d read value
    csrr x14, 0x56d

    #Address 0x56d read value
    csrr x14, 0x56d

    #Address 0x56d read value
    csrr x14, 0x56d

    #Address 0x56d Write value 0x12e2088e
    li x3, 0x12e2088e
    csrw 0x56d, x3

    #Unmapped address 0xfd2 testing: random write/read operations
    #Address 0xfd2 read value
    csrr x14, 0xfd2

    #Unmapped address 0x31a testing: random write/read operations
    #Address 0x31a Write value 0xbbc1414e
    li x3, 0xbbc1414e
    csrw 0x31a, x3

    #Address 0x31a read value
    csrr x14, 0x31a

    #Address 0x31a read value
    csrr x14, 0x31a

    #Unmapped address 0x365 testing: random write/read operations
    #Address 0x365 Write value 0x58d8fd0f
    li x3, 0x58d8fd0f
    csrw 0x365, x3

    #Address 0x365 read value
    csrr x14, 0x365

    #Address 0x365 Write value 0x9d6b8b8f
    li x3, 0x9d6b8b8f
    csrw 0x365, x3

    #Address 0x365 read value
    csrr x14, 0x365

    #Address 0x365 read value
    csrr x14, 0x365

    #Unmapped address 0x9d4 testing: random write/read operations
    #Address 0x9d4 read value
    csrr x14, 0x9d4

    #Unmapped address 0xc22 testing: random write/read operations
    #Address 0xc22 read value
    csrr x14, 0xc22

    #Address 0xc22 Write value 0xeae8586
    li x3, 0xeae8586
    csrw 0xc22, x3

    #Address 0xc22 Write value 0x92b09248
    li x3, 0x92b09248
    csrw 0xc22, x3

    #Address 0xc22 Write value 0x9febb8d7
    li x3, 0x9febb8d7
    csrw 0xc22, x3

    #Address 0xc22 read value
    csrr x14, 0xc22

    #Unmapped address 0x8c9 testing: random write/read operations
    #Address 0x8c9 read value
    csrr x14, 0x8c9

    #Address 0x8c9 Write value 0x2a791634
    li x3, 0x2a791634
    csrw 0x8c9, x3

    #Address 0x8c9 Write value 0x4be1d13f
    li x3, 0x4be1d13f
    csrw 0x8c9, x3

    #Address 0x8c9 read value
    csrr x14, 0x8c9

    #Address 0x8c9 Write value 0x3118221c
    li x3, 0x3118221c
    csrw 0x8c9, x3

    #Unmapped address 0x5c9 testing: random write/read operations
    #Address 0x5c9 read value
    csrr x14, 0x5c9

    #Address 0x5c9 read value
    csrr x14, 0x5c9

    #Address 0x5c9 Write value 0x918633c2
    li x3, 0x918633c2
    csrw 0x5c9, x3

    #Address 0x5c9 Write value 0xa9f146d0
    li x3, 0xa9f146d0
    csrw 0x5c9, x3

    #Unmapped address 0x56e testing: random write/read operations
    #Address 0x56e Write value 0x9014781f
    li x3, 0x9014781f
    csrw 0x56e, x3

    #Address 0x56e Write value 0x1ba2f8a7
    li x3, 0x1ba2f8a7
    csrw 0x56e, x3

    #Address 0x56e Write value 0xbb567fd3
    li x3, 0xbb567fd3
    csrw 0x56e, x3

    #Unmapped address 0x739 testing: random write/read operations
    #Address 0x739 Write value 0x91cc6d9
    li x3, 0x91cc6d9
    csrw 0x739, x3

    #Unmapped address 0x43 testing: random write/read operations
    #Address 0x43 read value
    csrr x14, 0x43

    #Unmapped address 0x215 testing: random write/read operations
    #Address 0x215 Write value 0x49b11a22
    li x3, 0x49b11a22
    csrw 0x215, x3

    #Address 0x215 read value
    csrr x14, 0x215

    #Address 0x215 read value
    csrr x14, 0x215

    #Address 0x215 read value
    csrr x14, 0x215

    #Unmapped address 0x972 testing: random write/read operations
    #Address 0x972 Write value 0xec7b73ac
    li x3, 0xec7b73ac
    csrw 0x972, x3

    #Unmapped address 0x47b testing: random write/read operations
    #Address 0x47b Write value 0x5019baa4
    li x3, 0x5019baa4
    csrw 0x47b, x3

    #Address 0x47b read value
    csrr x14, 0x47b

    #Address 0x47b read value
    csrr x14, 0x47b

    #Unmapped address 0xf0c testing: random write/read operations
    #Address 0xf0c read value
    csrr x14, 0xf0c

    #Address 0xf0c Write value 0x41356967
    li x3, 0x41356967
    csrw 0xf0c, x3

    #Unmapped address 0x589 testing: random write/read operations
    #Address 0x589 read value
    csrr x14, 0x589

    #Unmapped address 0x15c testing: random write/read operations
    #Address 0x15c read value
    csrr x14, 0x15c

    #Address 0x15c Write value 0xc776925d
    li x3, 0xc776925d
    csrw 0x15c, x3

    #Unmapped address 0xcea testing: random write/read operations
    #Address 0xcea Write value 0xdff3120a
    li x3, 0xdff3120a
    csrw 0xcea, x3

    #Address 0xcea read value
    csrr x14, 0xcea

    #Address 0xcea Write value 0xf74add2c
    li x3, 0xf74add2c
    csrw 0xcea, x3

    #Address 0xcea read value
    csrr x14, 0xcea

    #Address 0xcea read value
    csrr x14, 0xcea

    #Unmapped address 0xb21 testing: random write/read operations
    #Address 0xb21 Write value 0xbbc632da
    li x3, 0xbbc632da
    csrw 0xb21, x3

    #Unmapped address 0x478 testing: random write/read operations
    #Address 0x478 read value
    csrr x14, 0x478

    #Address 0x478 Write value 0x4c72a643
    li x3, 0x4c72a643
    csrw 0x478, x3

    #Address 0x478 Write value 0x78569012
    li x3, 0x78569012
    csrw 0x478, x3

    #Address 0x478 read value
    csrr x14, 0x478

    #Address 0x478 read value
    csrr x14, 0x478

    #Unmapped address 0xb49 testing: random write/read operations
    #Address 0xb49 Write value 0x538e83b6
    li x3, 0x538e83b6
    csrw 0xb49, x3

    #Address 0xb49 Write value 0xf3e1f406
    li x3, 0xf3e1f406
    csrw 0xb49, x3

    #Address 0xb49 read value
    csrr x14, 0xb49

    #Address 0xb49 Write value 0x4f8f0b99
    li x3, 0x4f8f0b99
    csrw 0xb49, x3

    #Address 0xb49 Write value 0x8f082f86
    li x3, 0x8f082f86
    csrw 0xb49, x3

    #Unmapped address 0xc3c testing: random write/read operations
    #Address 0xc3c read value
    csrr x14, 0xc3c

    #Address 0xc3c Write value 0x461ce7fe
    li x3, 0x461ce7fe
    csrw 0xc3c, x3

    #Address 0xc3c read value
    csrr x14, 0xc3c

    #Address 0xc3c Write value 0x94354a6b
    li x3, 0x94354a6b
    csrw 0xc3c, x3

    #Unmapped address 0x887 testing: random write/read operations
    #Address 0x887 read value
    csrr x14, 0x887

    #Address 0x887 read value
    csrr x14, 0x887

    #Address 0x887 Write value 0xe59cc20
    li x3, 0xe59cc20
    csrw 0x887, x3

    #Address 0x887 read value
    csrr x14, 0x887

    #Address 0x887 Write value 0x5eacd0c4
    li x3, 0x5eacd0c4
    csrw 0x887, x3

    #Unmapped address 0x56b testing: random write/read operations
    #Address 0x56b Write value 0x7dfcf0d3
    li x3, 0x7dfcf0d3
    csrw 0x56b, x3

    #Address 0x56b Write value 0x1dfd464
    li x3, 0x1dfd464
    csrw 0x56b, x3

    #Address 0x56b read value
    csrr x14, 0x56b

    #Unmapped address 0x7aa testing: random write/read operations
    #Address 0x7aa Write value 0x658e1d1a
    li x3, 0x658e1d1a
    csrw 0x7aa, x3

    #Address 0x7aa read value
    csrr x14, 0x7aa

    #Address 0x7aa read value
    csrr x14, 0x7aa

    #Address 0x7aa read value
    csrr x14, 0x7aa

    #Address 0x7aa read value
    csrr x14, 0x7aa

    #Unmapped address 0xb63 testing: random write/read operations
    #Address 0xb63 Write value 0x1fc21fde
    li x3, 0x1fc21fde
    csrw 0xb63, x3

    #Address 0xb63 read value
    csrr x14, 0xb63

    #Address 0xb63 read value
    csrr x14, 0xb63

    #Address 0xb63 read value
    csrr x14, 0xb63

    #Unmapped address 0x37d testing: random write/read operations
    #Address 0x37d Write value 0x54a8ab6b
    li x3, 0x54a8ab6b
    csrw 0x37d, x3

    #Address 0x37d Write value 0x7adf58df
    li x3, 0x7adf58df
    csrw 0x37d, x3

    #Address 0x37d read value
    csrr x14, 0x37d

    #Address 0x37d read value
    csrr x14, 0x37d

    #Address 0x37d Write value 0x488d4c58
    li x3, 0x488d4c58
    csrw 0x37d, x3

    #Unmapped address 0x73c testing: random write/read operations
    #Address 0x73c Write value 0xc358d98f
    li x3, 0xc358d98f
    csrw 0x73c, x3

    #Address 0x73c Write value 0x801dd409
    li x3, 0x801dd409
    csrw 0x73c, x3

    #Unmapped address 0x3e2 testing: random write/read operations
    #Address 0x3e2 Write value 0xd1df7770
    li x3, 0xd1df7770
    csrw 0x3e2, x3

    #Address 0x3e2 Write value 0x7f272a7e
    li x3, 0x7f272a7e
    csrw 0x3e2, x3

    #Address 0x3e2 Write value 0xfa3dd7fb
    li x3, 0xfa3dd7fb
    csrw 0x3e2, x3

    #Address 0x3e2 read value
    csrr x14, 0x3e2

    #Address 0x3e2 Write value 0x32044860
    li x3, 0x32044860
    csrw 0x3e2, x3

    #Unmapped address 0x5a8 testing: random write/read operations
    #Address 0x5a8 Write value 0xbcfd5e48
    li x3, 0xbcfd5e48
    csrw 0x5a8, x3

    #Address 0x5a8 read value
    csrr x14, 0x5a8

    #Unmapped address 0xe87 testing: random write/read operations
    #Address 0xe87 read value
    csrr x14, 0xe87

    #Address 0xe87 Write value 0x56614fa2
    li x3, 0x56614fa2
    csrw 0xe87, x3

    #Address 0xe87 Write value 0xa6111ca6
    li x3, 0xa6111ca6
    csrw 0xe87, x3

    #Unmapped address 0xbea testing: random write/read operations
    #Address 0xbea read value
    csrr x14, 0xbea

    #Address 0xbea Write value 0xd5bbe98b
    li x3, 0xd5bbe98b
    csrw 0xbea, x3

    #Unmapped address 0x8f5 testing: random write/read operations
    #Address 0x8f5 read value
    csrr x14, 0x8f5

    #Address 0x8f5 Write value 0x4e91f379
    li x3, 0x4e91f379
    csrw 0x8f5, x3

    #Address 0x8f5 read value
    csrr x14, 0x8f5

    #Unmapped address 0xfcc testing: random write/read operations
    #Address 0xfcc read value
    csrr x14, 0xfcc

    #Unmapped address 0x2df testing: random write/read operations
    #Address 0x2df read value
    csrr x14, 0x2df

    #Address 0x2df Write value 0x316b88de
    li x3, 0x316b88de
    csrw 0x2df, x3

    #Address 0x2df read value
    csrr x14, 0x2df

    #Unmapped address 0x57f testing: random write/read operations
    #Address 0x57f read value
    csrr x14, 0x57f

    #Unmapped address 0x161 testing: random write/read operations
    #Address 0x161 Write value 0x2363b717
    li x3, 0x2363b717
    csrw 0x161, x3

    #Address 0x161 read value
    csrr x14, 0x161

    #Address 0x161 Write value 0x6b060b12
    li x3, 0x6b060b12
    csrw 0x161, x3

    #Address 0x161 read value
    csrr x14, 0x161

    #Unmapped address 0x858 testing: random write/read operations
    #Address 0x858 Write value 0x8339fec4
    li x3, 0x8339fec4
    csrw 0x858, x3

    #Address 0x858 Write value 0x62e10b76
    li x3, 0x62e10b76
    csrw 0x858, x3

    #Address 0x858 Write value 0x59b97a12
    li x3, 0x59b97a12
    csrw 0x858, x3

    #Address 0x858 read value
    csrr x14, 0x858

    #Address 0x858 read value
    csrr x14, 0x858

    #Unmapped address 0x269 testing: random write/read operations
    #Address 0x269 read value
    csrr x14, 0x269

    #Address 0x269 read value
    csrr x14, 0x269

    #Address 0x269 Write value 0x486b41cd
    li x3, 0x486b41cd
    csrw 0x269, x3

    #Address 0x269 read value
    csrr x14, 0x269

    #Unmapped address 0xd1d testing: random write/read operations
    #Address 0xd1d Write value 0x795989e9
    li x3, 0x795989e9
    csrw 0xd1d, x3

    #Address 0xd1d read value
    csrr x14, 0xd1d

    #Unmapped address 0x9c9 testing: random write/read operations
    #Address 0x9c9 read value
    csrr x14, 0x9c9

    #Address 0x9c9 Write value 0x70ed239f
    li x3, 0x70ed239f
    csrw 0x9c9, x3

    #Address 0x9c9 Write value 0x8130c2f2
    li x3, 0x8130c2f2
    csrw 0x9c9, x3

    #Address 0x9c9 read value
    csrr x14, 0x9c9

    #Address 0x9c9 Write value 0x59225df6
    li x3, 0x59225df6
    csrw 0x9c9, x3

    #Unmapped address 0x9d3 testing: random write/read operations
    #Address 0x9d3 read value
    csrr x14, 0x9d3

    #Address 0x9d3 read value
    csrr x14, 0x9d3

    #Address 0x9d3 read value
    csrr x14, 0x9d3

    #Unmapped address 0x20b testing: random write/read operations
    #Address 0x20b read value
    csrr x14, 0x20b

    #Address 0x20b read value
    csrr x14, 0x20b

    #Address 0x20b read value
    csrr x14, 0x20b

    #Unmapped address 0x1f6 testing: random write/read operations
    #Address 0x1f6 Write value 0x837a0e30
    li x3, 0x837a0e30
    csrw 0x1f6, x3

    #Address 0x1f6 read value
    csrr x14, 0x1f6

    #Address 0x1f6 read value
    csrr x14, 0x1f6

    #Unmapped address 0x78d testing: random write/read operations
    #Address 0x78d read value
    csrr x14, 0x78d

    #Unmapped address 0x76b testing: random write/read operations
    #Address 0x76b Write value 0x95cbf8fc
    li x3, 0x95cbf8fc
    csrw 0x76b, x3

    #Unmapped address 0xd24 testing: random write/read operations
    #Address 0xd24 Write value 0xdd05ba4b
    li x3, 0xdd05ba4b
    csrw 0xd24, x3

    #Address 0xd24 Write value 0x493bb8dc
    li x3, 0x493bb8dc
    csrw 0xd24, x3

    #Address 0xd24 Write value 0x4dc3dbf5
    li x3, 0x4dc3dbf5
    csrw 0xd24, x3

    #Address 0xd24 Write value 0x318578b1
    li x3, 0x318578b1
    csrw 0xd24, x3

    #Unmapped address 0x75e testing: random write/read operations
    #Address 0x75e Write value 0x754f549a
    li x3, 0x754f549a
    csrw 0x75e, x3

    #Address 0x75e Write value 0xab37699c
    li x3, 0xab37699c
    csrw 0x75e, x3

    #Address 0x75e Write value 0xb3f47085
    li x3, 0xb3f47085
    csrw 0x75e, x3

    #Address 0x75e read value
    csrr x14, 0x75e

    #Unmapped address 0x3f0 testing: random write/read operations
    #Address 0x3f0 Write value 0x38ab002f
    li x3, 0x38ab002f
    csrw 0x3f0, x3

    #Address 0x3f0 read value
    csrr x14, 0x3f0

    #Address 0x3f0 Write value 0x70d422f5
    li x3, 0x70d422f5
    csrw 0x3f0, x3

    #Address 0x3f0 read value
    csrr x14, 0x3f0

    #Address 0x3f0 Write value 0x3a84e178
    li x3, 0x3a84e178
    csrw 0x3f0, x3

    #Unmapped address 0x718 testing: random write/read operations
    #Address 0x718 read value
    csrr x14, 0x718

    #Unmapped address 0xdd0 testing: random write/read operations
    #Address 0xdd0 Write value 0x33e33d2c
    li x3, 0x33e33d2c
    csrw 0xdd0, x3

    #Address 0xdd0 Write value 0x8ba425a5
    li x3, 0x8ba425a5
    csrw 0xdd0, x3

    #Address 0xdd0 read value
    csrr x14, 0xdd0

    #Address 0xdd0 read value
    csrr x14, 0xdd0

    #Unmapped address 0xdf3 testing: random write/read operations
    #Address 0xdf3 read value
    csrr x14, 0xdf3

    #Address 0xdf3 Write value 0x12c45ca5
    li x3, 0x12c45ca5
    csrw 0xdf3, x3

    #Address 0xdf3 read value
    csrr x14, 0xdf3

    #Address 0xdf3 Write value 0x3ab225f5
    li x3, 0x3ab225f5
    csrw 0xdf3, x3

    #Address 0xdf3 Write value 0xc4212e6f
    li x3, 0xc4212e6f
    csrw 0xdf3, x3

    #Unmapped address 0x504 testing: random write/read operations
    #Address 0x504 read value
    csrr x14, 0x504

    #Address 0x504 Write value 0x38e843b8
    li x3, 0x38e843b8
    csrw 0x504, x3

    #Unmapped address 0x76e testing: random write/read operations
    #Address 0x76e Write value 0x8f8edac5
    li x3, 0x8f8edac5
    csrw 0x76e, x3

    #Address 0x76e Write value 0xd76ffee2
    li x3, 0xd76ffee2
    csrw 0x76e, x3

    #Address 0x76e read value
    csrr x14, 0x76e

    #Unmapped address 0xee8 testing: random write/read operations
    #Address 0xee8 Write value 0x9d276554
    li x3, 0x9d276554
    csrw 0xee8, x3

    #Unmapped address 0x7f8 testing: random write/read operations
    #Address 0x7f8 read value
    csrr x14, 0x7f8

    #Address 0x7f8 read value
    csrr x14, 0x7f8

    #Address 0x7f8 Write value 0x9cc035c4
    li x3, 0x9cc035c4
    csrw 0x7f8, x3

    #Address 0x7f8 read value
    csrr x14, 0x7f8

    #Unmapped address 0x6c0 testing: random write/read operations
    #Address 0x6c0 Write value 0xd02963c8
    li x3, 0xd02963c8
    csrw 0x6c0, x3

    #Address 0x6c0 Write value 0xd2a36b49
    li x3, 0xd2a36b49
    csrw 0x6c0, x3

    #Address 0x6c0 Write value 0x39b64e6f
    li x3, 0x39b64e6f
    csrw 0x6c0, x3

    #Address 0x6c0 Write value 0x4c114f71
    li x3, 0x4c114f71
    csrw 0x6c0, x3

    #Address 0x6c0 Write value 0xcb4f7d56
    li x3, 0xcb4f7d56
    csrw 0x6c0, x3

    #Unmapped address 0x851 testing: random write/read operations
    #Address 0x851 read value
    csrr x14, 0x851

    #Address 0x851 Write value 0x98ff30b2
    li x3, 0x98ff30b2
    csrw 0x851, x3

    #Address 0x851 Write value 0x63306933
    li x3, 0x63306933
    csrw 0x851, x3

    #Unmapped address 0x9a7 testing: random write/read operations
    #Address 0x9a7 Write value 0x764fb4a6
    li x3, 0x764fb4a6
    csrw 0x9a7, x3

    #Address 0x9a7 read value
    csrr x14, 0x9a7

    #Address 0x9a7 Write value 0x17a51e2f
    li x3, 0x17a51e2f
    csrw 0x9a7, x3

    #Unmapped address 0x737 testing: random write/read operations
    #Address 0x737 read value
    csrr x14, 0x737

    #Address 0x737 read value
    csrr x14, 0x737

    #Address 0x737 Write value 0x2c202d71
    li x3, 0x2c202d71
    csrw 0x737, x3

    #Address 0x737 Write value 0x3a7a17ba
    li x3, 0x3a7a17ba
    csrw 0x737, x3

    #Address 0x737 read value
    csrr x14, 0x737

    #Unmapped address 0x505 testing: random write/read operations
    #Address 0x505 read value
    csrr x14, 0x505

    #Address 0x505 Write value 0xd6da3f77
    li x3, 0xd6da3f77
    csrw 0x505, x3

    #Address 0x505 Write value 0x6832bc4
    li x3, 0x6832bc4
    csrw 0x505, x3

    #Address 0x505 Write value 0x7c97fe79
    li x3, 0x7c97fe79
    csrw 0x505, x3

    #Unmapped address 0x19d testing: random write/read operations
    #Address 0x19d read value
    csrr x14, 0x19d

    #Address 0x19d read value
    csrr x14, 0x19d

    #Address 0x19d Write value 0xa8a95af5
    li x3, 0xa8a95af5
    csrw 0x19d, x3

    #Address 0x19d read value
    csrr x14, 0x19d

    #Address 0x19d read value
    csrr x14, 0x19d

    #Unmapped address 0xf77 testing: random write/read operations
    #Address 0xf77 Write value 0x4ff076eb
    li x3, 0x4ff076eb
    csrw 0xf77, x3

    #Address 0xf77 read value
    csrr x14, 0xf77

    #Address 0xf77 Write value 0xdce39e25
    li x3, 0xdce39e25
    csrw 0xf77, x3

    #Address 0xf77 Write value 0xb3aa9db8
    li x3, 0xb3aa9db8
    csrw 0xf77, x3

    #Address 0xf77 Write value 0xa520444c
    li x3, 0xa520444c
    csrw 0xf77, x3

    #Unmapped address 0xa55 testing: random write/read operations
    #Address 0xa55 Write value 0x5cc0016e
    li x3, 0x5cc0016e
    csrw 0xa55, x3

    #Address 0xa55 Write value 0x7a4b7c2
    li x3, 0x7a4b7c2
    csrw 0xa55, x3

    #Address 0xa55 read value
    csrr x14, 0xa55

    #Unmapped address 0xaba testing: random write/read operations
    #Address 0xaba Write value 0x7a44a410
    li x3, 0x7a44a410
    csrw 0xaba, x3

    #Address 0xaba read value
    csrr x14, 0xaba

    #Unmapped address 0x8ee testing: random write/read operations
    #Address 0x8ee Write value 0xf82022d9
    li x3, 0xf82022d9
    csrw 0x8ee, x3

    #Address 0x8ee Write value 0xba99cf22
    li x3, 0xba99cf22
    csrw 0x8ee, x3

    #Address 0x8ee Write value 0x8650cb62
    li x3, 0x8650cb62
    csrw 0x8ee, x3

    #Unmapped address 0x2e2 testing: random write/read operations
    #Address 0x2e2 Write value 0xe04bda6d
    li x3, 0xe04bda6d
    csrw 0x2e2, x3

    #Address 0x2e2 Write value 0x6bdc0d63
    li x3, 0x6bdc0d63
    csrw 0x2e2, x3

    #Address 0x2e2 read value
    csrr x14, 0x2e2

    #Unmapped address 0xec7 testing: random write/read operations
    #Address 0xec7 Write value 0x9d8addb4
    li x3, 0x9d8addb4
    csrw 0xec7, x3

    #Address 0xec7 Write value 0x6fb412a0
    li x3, 0x6fb412a0
    csrw 0xec7, x3

    #Address 0xec7 Write value 0xb2299d
    li x3, 0xb2299d
    csrw 0xec7, x3

    #Address 0xec7 Write value 0x600d1321
    li x3, 0x600d1321
    csrw 0xec7, x3

    #Address 0xec7 Write value 0x73436089
    li x3, 0x73436089
    csrw 0xec7, x3

    #Unmapped address 0x7ae testing: random write/read operations
    #Address 0x7ae read value
    csrr x14, 0x7ae

    #Address 0x7ae read value
    csrr x14, 0x7ae

    #Address 0x7ae read value
    csrr x14, 0x7ae

    #Address 0x7ae Write value 0x9497d889
    li x3, 0x9497d889
    csrw 0x7ae, x3

    #Unmapped address 0x63c testing: random write/read operations
    #Address 0x63c read value
    csrr x14, 0x63c

    #Address 0x63c Write value 0x88ef195e
    li x3, 0x88ef195e
    csrw 0x63c, x3

    #Address 0x63c Write value 0x8e5d43f7
    li x3, 0x8e5d43f7
    csrw 0x63c, x3

    #Address 0x63c Write value 0xa53d0598
    li x3, 0xa53d0598
    csrw 0x63c, x3

    #Unmapped address 0x1a6 testing: random write/read operations
    #Address 0x1a6 Write value 0xffea86bf
    li x3, 0xffea86bf
    csrw 0x1a6, x3

    #Address 0x1a6 read value
    csrr x14, 0x1a6

    #Address 0x1a6 read value
    csrr x14, 0x1a6

    #Unmapped address 0x526 testing: random write/read operations
    #Address 0x526 read value
    csrr x14, 0x526

    #Address 0x526 Write value 0xa624a7c2
    li x3, 0xa624a7c2
    csrw 0x526, x3

    #Address 0x526 read value
    csrr x14, 0x526

    #Unmapped address 0xa45 testing: random write/read operations
    #Address 0xa45 read value
    csrr x14, 0xa45

    #Address 0xa45 read value
    csrr x14, 0xa45

    #Address 0xa45 Write value 0x4587a51
    li x3, 0x4587a51
    csrw 0xa45, x3

    #Address 0xa45 read value
    csrr x14, 0xa45

    #Unmapped address 0xc2 testing: random write/read operations
    #Address 0xc2 Write value 0xa9dd12d1
    li x3, 0xa9dd12d1
    csrw 0xc2, x3

    #Unmapped address 0x250 testing: random write/read operations
    #Address 0x250 Write value 0xac74a8c
    li x3, 0xac74a8c
    csrw 0x250, x3

    #Address 0x250 Write value 0x738faff8
    li x3, 0x738faff8
    csrw 0x250, x3

    #Address 0x250 Write value 0xe81acc84
    li x3, 0xe81acc84
    csrw 0x250, x3

    #Address 0x250 read value
    csrr x14, 0x250

    #Unmapped address 0xd12 testing: random write/read operations
    #Address 0xd12 read value
    csrr x14, 0xd12

    #Address 0xd12 read value
    csrr x14, 0xd12

    #Unmapped address 0x8aa testing: random write/read operations
    #Address 0x8aa read value
    csrr x14, 0x8aa

    #Address 0x8aa read value
    csrr x14, 0x8aa

    #Address 0x8aa Write value 0x22b9a56e
    li x3, 0x22b9a56e
    csrw 0x8aa, x3

    #Address 0x8aa Write value 0xbe0ba60c
    li x3, 0xbe0ba60c
    csrw 0x8aa, x3

    #Address 0x8aa read value
    csrr x14, 0x8aa

    #Unmapped address 0xf08 testing: random write/read operations
    #Address 0xf08 read value
    csrr x14, 0xf08

    #Address 0xf08 Write value 0xc143d529
    li x3, 0xc143d529
    csrw 0xf08, x3

    #Unmapped address 0x290 testing: random write/read operations
    #Address 0x290 Write value 0x7c3bee45
    li x3, 0x7c3bee45
    csrw 0x290, x3

    #Address 0x290 read value
    csrr x14, 0x290

    #Address 0x290 read value
    csrr x14, 0x290

    #Unmapped address 0x5d6 testing: random write/read operations
    #Address 0x5d6 read value
    csrr x14, 0x5d6

    #Address 0x5d6 Write value 0xc7ac7ec5
    li x3, 0xc7ac7ec5
    csrw 0x5d6, x3

    #Address 0x5d6 Write value 0xce710faa
    li x3, 0xce710faa
    csrw 0x5d6, x3

    #Unmapped address 0x54c testing: random write/read operations
    #Address 0x54c Write value 0xca386cbb
    li x3, 0xca386cbb
    csrw 0x54c, x3

    #Address 0x54c read value
    csrr x14, 0x54c

    #Address 0x54c read value
    csrr x14, 0x54c

    #Address 0x54c read value
    csrr x14, 0x54c

    #Unmapped address 0xf35 testing: random write/read operations
    #Address 0xf35 read value
    csrr x14, 0xf35

    #Address 0xf35 Write value 0x32a6c80b
    li x3, 0x32a6c80b
    csrw 0xf35, x3

    #Unmapped address 0x50e testing: random write/read operations
    #Address 0x50e read value
    csrr x14, 0x50e

    #Address 0x50e Write value 0x4cdf1a12
    li x3, 0x4cdf1a12
    csrw 0x50e, x3

    #Address 0x50e read value
    csrr x14, 0x50e

    #Unmapped address 0xa9c testing: random write/read operations
    #Address 0xa9c Write value 0xc1f8d3b9
    li x3, 0xc1f8d3b9
    csrw 0xa9c, x3

    #Address 0xa9c read value
    csrr x14, 0xa9c

    #Address 0xa9c read value
    csrr x14, 0xa9c

    #Address 0xa9c read value
    csrr x14, 0xa9c

    #Address 0xa9c Write value 0x18e68b49
    li x3, 0x18e68b49
    csrw 0xa9c, x3

    #Unmapped address 0x476 testing: random write/read operations
    #Address 0x476 read value
    csrr x14, 0x476

    #Address 0x476 read value
    csrr x14, 0x476

    #Unmapped address 0xd3b testing: random write/read operations
    #Address 0xd3b read value
    csrr x14, 0xd3b

    #Address 0xd3b read value
    csrr x14, 0xd3b

    #Address 0xd3b read value
    csrr x14, 0xd3b

    #Address 0xd3b read value
    csrr x14, 0xd3b

    #Address 0xd3b read value
    csrr x14, 0xd3b

    #Unmapped address 0x94e testing: random write/read operations
    #Address 0x94e Write value 0xc3bb96c8
    li x3, 0xc3bb96c8
    csrw 0x94e, x3

    #Address 0x94e read value
    csrr x14, 0x94e

    #Address 0x94e read value
    csrr x14, 0x94e

    #Address 0x94e Write value 0x9438d493
    li x3, 0x9438d493
    csrw 0x94e, x3

    #Address 0x94e read value
    csrr x14, 0x94e

    #Mapped address 0x3a2 (pmpcfg2) testing: random write/read operations
    #Address 0x3a2 read value
    csrr x14, 0x3a2

    #Address 0x3a2 read value
    csrr x14, 0x3a2

    #Address 0x3a2 Write value 0x24ba234f
    li x3, 0x24ba234f
    csrw 0x3a2, x3

    #Unmapped address 0xf53 testing: random write/read operations
    #Address 0xf53 Write value 0x6e198d91
    li x3, 0x6e198d91
    csrw 0xf53, x3

    #Unmapped address 0x295 testing: random write/read operations
    #Address 0x295 Write value 0xf9f0ead6
    li x3, 0xf9f0ead6
    csrw 0x295, x3

    #Address 0x295 Write value 0x75618c2e
    li x3, 0x75618c2e
    csrw 0x295, x3

    #Address 0x295 read value
    csrr x14, 0x295

    #Address 0x295 read value
    csrr x14, 0x295

    #Unmapped address 0x3f4 testing: random write/read operations
    #Address 0x3f4 read value
    csrr x14, 0x3f4

    #Address 0x3f4 read value
    csrr x14, 0x3f4

    #Unmapped address 0x56f testing: random write/read operations
    #Address 0x56f Write value 0x47d29881
    li x3, 0x47d29881
    csrw 0x56f, x3

    #Address 0x56f read value
    csrr x14, 0x56f

    #Address 0x56f Write value 0x8f754750
    li x3, 0x8f754750
    csrw 0x56f, x3

    #Unmapped address 0x1ba testing: random write/read operations
    #Address 0x1ba read value
    csrr x14, 0x1ba

    #Address 0x1ba Write value 0x5f2f2601
    li x3, 0x5f2f2601
    csrw 0x1ba, x3

    #Address 0x1ba Write value 0xd634beae
    li x3, 0xd634beae
    csrw 0x1ba, x3

    #Address 0x1ba Write value 0xedbb5b4c
    li x3, 0xedbb5b4c
    csrw 0x1ba, x3

    #Unmapped address 0x92b testing: random write/read operations
    #Address 0x92b Write value 0x9e19a206
    li x3, 0x9e19a206
    csrw 0x92b, x3

    #Unmapped address 0x23b testing: random write/read operations
    #Address 0x23b Write value 0x10a0253a
    li x3, 0x10a0253a
    csrw 0x23b, x3

    #Address 0x23b Write value 0x7d9d4d43
    li x3, 0x7d9d4d43
    csrw 0x23b, x3

    #Address 0x23b read value
    csrr x14, 0x23b

    #Address 0x23b Write value 0xa1fa209f
    li x3, 0xa1fa209f
    csrw 0x23b, x3

    #Address 0x23b Write value 0xe933df4d
    li x3, 0xe933df4d
    csrw 0x23b, x3

    #Unmapped address 0x1ae testing: random write/read operations
    #Address 0x1ae read value
    csrr x14, 0x1ae

    #Address 0x1ae read value
    csrr x14, 0x1ae

    #Address 0x1ae read value
    csrr x14, 0x1ae

    #Unmapped address 0x83a testing: random write/read operations
    #Address 0x83a read value
    csrr x14, 0x83a

    #Address 0x83a Write value 0x3caefc71
    li x3, 0x3caefc71
    csrw 0x83a, x3

    #Unmapped address 0x162 testing: random write/read operations
    #Address 0x162 Write value 0x97e47926
    li x3, 0x97e47926
    csrw 0x162, x3

    #Address 0x162 read value
    csrr x14, 0x162

    #Address 0x162 Write value 0xefc8919b
    li x3, 0xefc8919b
    csrw 0x162, x3

    #Address 0x162 read value
    csrr x14, 0x162

    #Address 0x162 Write value 0x6557201b
    li x3, 0x6557201b
    csrw 0x162, x3

    #Unmapped address 0xc45 testing: random write/read operations
    #Address 0xc45 Write value 0x9885540a
    li x3, 0x9885540a
    csrw 0xc45, x3

    #Unmapped address 0xff5 testing: random write/read operations
    #Address 0xff5 read value
    csrr x14, 0xff5

    #Address 0xff5 Write value 0x9f65f94a
    li x3, 0x9f65f94a
    csrw 0xff5, x3

    #Address 0xff5 read value
    csrr x14, 0xff5

    #Unmapped address 0xba5 testing: random write/read operations
    #Address 0xba5 read value
    csrr x14, 0xba5

    #Address 0xba5 Write value 0x488ebbf3
    li x3, 0x488ebbf3
    csrw 0xba5, x3

    #Address 0xba5 read value
    csrr x14, 0xba5

    #Unmapped address 0x98d testing: random write/read operations
    #Address 0x98d Write value 0xd74d51cb
    li x3, 0xd74d51cb
    csrw 0x98d, x3

    #Address 0x98d Write value 0x305cab3e
    li x3, 0x305cab3e
    csrw 0x98d, x3

    #Address 0x98d read value
    csrr x14, 0x98d

    #Address 0x98d Write value 0x2034b877
    li x3, 0x2034b877
    csrw 0x98d, x3

    #Address 0x98d Write value 0xfff94458
    li x3, 0xfff94458
    csrw 0x98d, x3

    #Unmapped address 0xf0 testing: random write/read operations
    #Address 0xf0 Write value 0x4c9bb93b
    li x3, 0x4c9bb93b
    csrw 0xf0, x3

    #Address 0xf0 Write value 0x28bf7b15
    li x3, 0x28bf7b15
    csrw 0xf0, x3

    #Address 0xf0 read value
    csrr x14, 0xf0

    #Address 0xf0 Write value 0x9b24ed83
    li x3, 0x9b24ed83
    csrw 0xf0, x3

    #Address 0xf0 read value
    csrr x14, 0xf0

    #Unmapped address 0xec9 testing: random write/read operations
    #Address 0xec9 read value
    csrr x14, 0xec9

    #Address 0xec9 read value
    csrr x14, 0xec9

    #Address 0xec9 Write value 0x3fa7ffc9
    li x3, 0x3fa7ffc9
    csrw 0xec9, x3

    #Unmapped address 0xf65 testing: random write/read operations
    #Address 0xf65 read value
    csrr x14, 0xf65

    #Unmapped address 0x827 testing: random write/read operations
    #Address 0x827 Write value 0xe3e415ad
    li x3, 0xe3e415ad
    csrw 0x827, x3

    #Address 0x827 Write value 0xfa21892d
    li x3, 0xfa21892d
    csrw 0x827, x3

    #Address 0x827 Write value 0x509433e9
    li x3, 0x509433e9
    csrw 0x827, x3

    #Address 0x827 Write value 0x9f76fbb5
    li x3, 0x9f76fbb5
    csrw 0x827, x3

    #Unmapped address 0x5ab testing: random write/read operations
    #Address 0x5ab read value
    csrr x14, 0x5ab

    #Unmapped address 0x7d testing: random write/read operations
    #Address 0x7d read value
    csrr x14, 0x7d

    #Address 0x7d read value
    csrr x14, 0x7d

    #Address 0x7d Write value 0xc56e7f63
    li x3, 0xc56e7f63
    csrw 0x7d, x3

    #Address 0x7d Write value 0xd3b6b2c4
    li x3, 0xd3b6b2c4
    csrw 0x7d, x3

    #Unmapped address 0x503 testing: random write/read operations
    #Address 0x503 read value
    csrr x14, 0x503

    #Address 0x503 Write value 0xf5c53ab7
    li x3, 0xf5c53ab7
    csrw 0x503, x3

    #Unmapped address 0x219 testing: random write/read operations
    #Address 0x219 read value
    csrr x14, 0x219

    #Address 0x219 read value
    csrr x14, 0x219

    #Address 0x219 read value
    csrr x14, 0x219

    #Address 0x219 read value
    csrr x14, 0x219

    #Address 0x219 read value
    csrr x14, 0x219

    #Unmapped address 0xa2c testing: random write/read operations
    #Address 0xa2c Write value 0xc31c8c71
    li x3, 0xc31c8c71
    csrw 0xa2c, x3

    #Address 0xa2c Write value 0x16b1fe70
    li x3, 0x16b1fe70
    csrw 0xa2c, x3

    #Unmapped address 0x565 testing: random write/read operations
    #Address 0x565 read value
    csrr x14, 0x565

    #Address 0x565 Write value 0x7fd67f73
    li x3, 0x7fd67f73
    csrw 0x565, x3

    #Address 0x565 read value
    csrr x14, 0x565

    #Address 0x565 Write value 0xd3694924
    li x3, 0xd3694924
    csrw 0x565, x3

    #Unmapped address 0x14e testing: random write/read operations
    #Address 0x14e read value
    csrr x14, 0x14e

    #Address 0x14e read value
    csrr x14, 0x14e

    #Address 0x14e Write value 0x899506f1
    li x3, 0x899506f1
    csrw 0x14e, x3

    #Unmapped address 0x800 testing: random write/read operations
    #Address 0x800 Write value 0xa48ed5dd
    li x3, 0xa48ed5dd
    csrw 0x800, x3

    #Unmapped address 0xf27 testing: random write/read operations
    #Address 0xf27 read value
    csrr x14, 0xf27

    #Unmapped address 0x2f3 testing: random write/read operations
    #Address 0x2f3 read value
    csrr x14, 0x2f3

    #Address 0x2f3 read value
    csrr x14, 0x2f3

    #Address 0x2f3 Write value 0x2cf61c73
    li x3, 0x2cf61c73
    csrw 0x2f3, x3

    #Address 0x2f3 Write value 0x21d490bc
    li x3, 0x21d490bc
    csrw 0x2f3, x3

    #Address 0x2f3 Write value 0xb7d3f85f
    li x3, 0xb7d3f85f
    csrw 0x2f3, x3

    #Unmapped address 0xc8d testing: random write/read operations
    #Address 0xc8d read value
    csrr x14, 0xc8d

    #Address 0xc8d read value
    csrr x14, 0xc8d

    #Address 0xc8d Write value 0xf8016cef
    li x3, 0xf8016cef
    csrw 0xc8d, x3

    #Unmapped address 0x5cd testing: random write/read operations
    #Address 0x5cd Write value 0x370f2d94
    li x3, 0x370f2d94
    csrw 0x5cd, x3

    #Unmapped address 0xc2f testing: random write/read operations
    #Address 0xc2f read value
    csrr x14, 0xc2f

    #Address 0xc2f read value
    csrr x14, 0xc2f

    #Address 0xc2f Write value 0x39045b6f
    li x3, 0x39045b6f
    csrw 0xc2f, x3

    #Unmapped address 0xe9e testing: random write/read operations
    #Address 0xe9e read value
    csrr x14, 0xe9e

    #Address 0xe9e Write value 0xbb5a3cfe
    li x3, 0xbb5a3cfe
    csrw 0xe9e, x3

    #Unmapped address 0xd44 testing: random write/read operations
    #Address 0xd44 read value
    csrr x14, 0xd44

    #Address 0xd44 read value
    csrr x14, 0xd44

    #Address 0xd44 read value
    csrr x14, 0xd44

    #Address 0xd44 read value
    csrr x14, 0xd44

    #Unmapped address 0x22a testing: random write/read operations
    #Address 0x22a read value
    csrr x14, 0x22a

    #Address 0x22a read value
    csrr x14, 0x22a

    #Address 0x22a Write value 0x1957be88
    li x3, 0x1957be88
    csrw 0x22a, x3

    #Unmapped address 0x258 testing: random write/read operations
    #Address 0x258 read value
    csrr x14, 0x258

    #Address 0x258 Write value 0xd5c7bfb4
    li x3, 0xd5c7bfb4
    csrw 0x258, x3

    #Address 0x258 Write value 0x855c7b02
    li x3, 0x855c7b02
    csrw 0x258, x3

    #Address 0x258 Write value 0xad97868f
    li x3, 0xad97868f
    csrw 0x258, x3

    #Address 0x258 read value
    csrr x14, 0x258

    #Unmapped address 0xe99 testing: random write/read operations
    #Address 0xe99 read value
    csrr x14, 0xe99

    #Address 0xe99 read value
    csrr x14, 0xe99

    #Address 0xe99 Write value 0x3d9326c3
    li x3, 0x3d9326c3
    csrw 0xe99, x3

    #Address 0xe99 Write value 0xdb2f1989
    li x3, 0xdb2f1989
    csrw 0xe99, x3

    #Unmapped address 0xca2 testing: random write/read operations
    #Address 0xca2 read value
    csrr x14, 0xca2

    #Address 0xca2 read value
    csrr x14, 0xca2

    #Unmapped address 0x35c testing: random write/read operations
    #Address 0x35c Write value 0x80b5747f
    li x3, 0x80b5747f
    csrw 0x35c, x3

    #Unmapped address 0x6c testing: random write/read operations
    #Address 0x6c read value
    csrr x14, 0x6c

    #Address 0x6c Write value 0xea113bd8
    li x3, 0xea113bd8
    csrw 0x6c, x3

    #Address 0x6c Write value 0xf5335d54
    li x3, 0xf5335d54
    csrw 0x6c, x3

    #Address 0x6c Write value 0xd3d733e8
    li x3, 0xd3d733e8
    csrw 0x6c, x3

    #Address 0x6c read value
    csrr x14, 0x6c

    #Unmapped address 0x468 testing: random write/read operations
    #Address 0x468 read value
    csrr x14, 0x468

    #Unmapped address 0x364 testing: random write/read operations
    #Address 0x364 Write value 0xfb213328
    li x3, 0xfb213328
    csrw 0x364, x3

    #Address 0x364 Write value 0x1f70a2bb
    li x3, 0x1f70a2bb
    csrw 0x364, x3

    #Unmapped address 0xc52 testing: random write/read operations
    #Address 0xc52 Write value 0x9dfc2283
    li x3, 0x9dfc2283
    csrw 0xc52, x3

    #Address 0xc52 read value
    csrr x14, 0xc52

    #Unmapped address 0x46e testing: random write/read operations
    #Address 0x46e read value
    csrr x14, 0x46e

    #Address 0x46e Write value 0xac4ca5e0
    li x3, 0xac4ca5e0
    csrw 0x46e, x3

    #Address 0x46e Write value 0x14d155d2
    li x3, 0x14d155d2
    csrw 0x46e, x3

    #Address 0x46e read value
    csrr x14, 0x46e

    #Address 0x46e read value
    csrr x14, 0x46e

    #Unmapped address 0x6be testing: random write/read operations
    #Address 0x6be Write value 0xc721c3a2
    li x3, 0xc721c3a2
    csrw 0x6be, x3

    #Unmapped address 0xfa5 testing: random write/read operations
    #Address 0xfa5 read value
    csrr x14, 0xfa5

    #Address 0xfa5 read value
    csrr x14, 0xfa5

    #Address 0xfa5 Write value 0x9d9b7062
    li x3, 0x9d9b7062
    csrw 0xfa5, x3

    #Address 0xfa5 read value
    csrr x14, 0xfa5

    #Unmapped address 0x156 testing: random write/read operations
    #Address 0x156 Write value 0xdcce4590
    li x3, 0xdcce4590
    csrw 0x156, x3

    #Address 0x156 read value
    csrr x14, 0x156

    #Unmapped address 0x444 testing: random write/read operations
    #Address 0x444 read value
    csrr x14, 0x444

    #Address 0x444 read value
    csrr x14, 0x444

    #Address 0x444 read value
    csrr x14, 0x444

    #Unmapped address 0x73f testing: random write/read operations
    #Address 0x73f Write value 0x1f0c3ba
    li x3, 0x1f0c3ba
    csrw 0x73f, x3

    #Unmapped address 0xfed testing: random write/read operations
    #Address 0xfed Write value 0xccc1509f
    li x3, 0xccc1509f
    csrw 0xfed, x3

    #Address 0xfed Write value 0xaa4676b8
    li x3, 0xaa4676b8
    csrw 0xfed, x3

    #Address 0xfed Write value 0xfc590b3
    li x3, 0xfc590b3
    csrw 0xfed, x3

    #Unmapped address 0xd29 testing: random write/read operations
    #Address 0xd29 read value
    csrr x14, 0xd29

    #Address 0xd29 read value
    csrr x14, 0xd29

    #Unmapped address 0x27c testing: random write/read operations
    #Address 0x27c read value
    csrr x14, 0x27c

    #Address 0x27c Write value 0xb1efed63
    li x3, 0xb1efed63
    csrw 0x27c, x3

    #Unmapped address 0x9a1 testing: random write/read operations
    #Address 0x9a1 read value
    csrr x14, 0x9a1

    #Address 0x9a1 read value
    csrr x14, 0x9a1

    #Address 0x9a1 read value
    csrr x14, 0x9a1

    #Address 0x9a1 read value
    csrr x14, 0x9a1

    #Address 0x9a1 Write value 0x51cdfa6e
    li x3, 0x51cdfa6e
    csrw 0x9a1, x3

    #Unmapped address 0x6ea testing: random write/read operations
    #Address 0x6ea read value
    csrr x14, 0x6ea

    #Address 0x6ea Write value 0x487d1d66
    li x3, 0x487d1d66
    csrw 0x6ea, x3

    #Unmapped address 0xb47 testing: random write/read operations
    #Address 0xb47 Write value 0xfcc77396
    li x3, 0xfcc77396
    csrw 0xb47, x3

    #Address 0xb47 read value
    csrr x14, 0xb47

    #Address 0xb47 Write value 0x324369c9
    li x3, 0x324369c9
    csrw 0xb47, x3

    #Unmapped address 0xc41 testing: random write/read operations
    #Address 0xc41 read value
    csrr x14, 0xc41

    #Address 0xc41 read value
    csrr x14, 0xc41

    #Address 0xc41 read value
    csrr x14, 0xc41

    #Unmapped address 0xf81 testing: random write/read operations
    #Address 0xf81 read value
    csrr x14, 0xf81

    #Address 0xf81 Write value 0x642d4d65
    li x3, 0x642d4d65
    csrw 0xf81, x3

    #Address 0xf81 read value
    csrr x14, 0xf81

    #Address 0xf81 Write value 0x84437e16
    li x3, 0x84437e16
    csrw 0xf81, x3

    #Address 0xf81 read value
    csrr x14, 0xf81

    #Unmapped address 0xba4 testing: random write/read operations
    #Address 0xba4 read value
    csrr x14, 0xba4

    #Address 0xba4 read value
    csrr x14, 0xba4

    #Address 0xba4 Write value 0x5765eb74
    li x3, 0x5765eb74
    csrw 0xba4, x3

    #Unmapped address 0x677 testing: random write/read operations
    #Address 0x677 read value
    csrr x14, 0x677

    #Address 0x677 read value
    csrr x14, 0x677

    #Address 0x677 read value
    csrr x14, 0x677

    #Address 0x677 Write value 0x2b36056a
    li x3, 0x2b36056a
    csrw 0x677, x3

    #Unmapped address 0xeea testing: random write/read operations
    #Address 0xeea read value
    csrr x14, 0xeea

    #Address 0xeea Write value 0xe04215a8
    li x3, 0xe04215a8
    csrw 0xeea, x3

    #Address 0xeea read value
    csrr x14, 0xeea

    #Address 0xeea read value
    csrr x14, 0xeea

    #Address 0xeea read value
    csrr x14, 0xeea

    #Unmapped address 0x4bb testing: random write/read operations
    #Address 0x4bb Write value 0xf696551
    li x3, 0xf696551
    csrw 0x4bb, x3

    #Address 0x4bb Write value 0x31554762
    li x3, 0x31554762
    csrw 0x4bb, x3

    #Address 0x4bb read value
    csrr x14, 0x4bb

    #Address 0x4bb Write value 0xe1629ede
    li x3, 0xe1629ede
    csrw 0x4bb, x3

    #Address 0x4bb Write value 0x59fccce8
    li x3, 0x59fccce8
    csrw 0x4bb, x3

    #Unmapped address 0xc86 testing: random write/read operations
    #Address 0xc86 read value
    csrr x14, 0xc86

    #Address 0xc86 read value
    csrr x14, 0xc86

    #Address 0xc86 Write value 0xd9a7c4e7
    li x3, 0xd9a7c4e7
    csrw 0xc86, x3

    #Unmapped address 0x533 testing: random write/read operations
    #Address 0x533 Write value 0x335a49a8
    li x3, 0x335a49a8
    csrw 0x533, x3

    #Address 0x533 read value
    csrr x14, 0x533

    #Unmapped address 0x459 testing: random write/read operations
    #Address 0x459 read value
    csrr x14, 0x459

    #Address 0x459 read value
    csrr x14, 0x459

    #Unmapped address 0xb77 testing: random write/read operations
    #Address 0xb77 Write value 0xf8b470d6
    li x3, 0xf8b470d6
    csrw 0xb77, x3

    #Address 0xb77 read value
    csrr x14, 0xb77

    #Address 0xb77 Write value 0x121e116a
    li x3, 0x121e116a
    csrw 0xb77, x3

    #Address 0xb77 Write value 0x8b45e473
    li x3, 0x8b45e473
    csrw 0xb77, x3

    #Unmapped address 0x490 testing: random write/read operations
    #Address 0x490 Write value 0x3547832e
    li x3, 0x3547832e
    csrw 0x490, x3

    #Unmapped address 0x4cf testing: random write/read operations
    #Address 0x4cf Write value 0xa6881471
    li x3, 0xa6881471
    csrw 0x4cf, x3

    #Address 0x4cf Write value 0x9fc33bc
    li x3, 0x9fc33bc
    csrw 0x4cf, x3

    #Unmapped address 0x984 testing: random write/read operations
    #Address 0x984 Write value 0xd134f985
    li x3, 0xd134f985
    csrw 0x984, x3

    #Address 0x984 Write value 0xf1c57ebb
    li x3, 0xf1c57ebb
    csrw 0x984, x3

    #Address 0x984 Write value 0x83eafad4
    li x3, 0x83eafad4
    csrw 0x984, x3

    #Address 0x984 read value
    csrr x14, 0x984

    #Unmapped address 0xaf8 testing: random write/read operations
    #Address 0xaf8 Write value 0xec6810ba
    li x3, 0xec6810ba
    csrw 0xaf8, x3

    #Address 0xaf8 read value
    csrr x14, 0xaf8

    #Address 0xaf8 Write value 0xa9c14041
    li x3, 0xa9c14041
    csrw 0xaf8, x3

    #Address 0xaf8 Write value 0xcd500172
    li x3, 0xcd500172
    csrw 0xaf8, x3

    #Address 0xaf8 read value
    csrr x14, 0xaf8

    #Unmapped address 0xf98 testing: random write/read operations
    #Address 0xf98 Write value 0x70caaf86
    li x3, 0x70caaf86
    csrw 0xf98, x3

    #Address 0xf98 read value
    csrr x14, 0xf98

    #Address 0xf98 Write value 0x671db797
    li x3, 0x671db797
    csrw 0xf98, x3

    #Address 0xf98 read value
    csrr x14, 0xf98

    #Address 0xf98 read value
    csrr x14, 0xf98

    #Unmapped address 0xec0 testing: random write/read operations
    #Address 0xec0 Write value 0x33e44bab
    li x3, 0x33e44bab
    csrw 0xec0, x3

    #Unmapped address 0x2d4 testing: random write/read operations
    #Address 0x2d4 Write value 0x8cd6ca0f
    li x3, 0x8cd6ca0f
    csrw 0x2d4, x3

    #Address 0x2d4 Write value 0x23d5ed51
    li x3, 0x23d5ed51
    csrw 0x2d4, x3

    #Address 0x2d4 Write value 0x59a14eef
    li x3, 0x59a14eef
    csrw 0x2d4, x3

    #Address 0x2d4 Write value 0x459d1efe
    li x3, 0x459d1efe
    csrw 0x2d4, x3

    #Address 0x2d4 Write value 0xec2118b9
    li x3, 0xec2118b9
    csrw 0x2d4, x3

    #Unmapped address 0x9ac testing: random write/read operations
    #Address 0x9ac read value
    csrr x14, 0x9ac

    #Address 0x9ac read value
    csrr x14, 0x9ac

    #Address 0x9ac read value
    csrr x14, 0x9ac

    #Address 0x9ac Write value 0x2b371add
    li x3, 0x2b371add
    csrw 0x9ac, x3

    #Unmapped address 0x740 testing: random write/read operations
    #Address 0x740 read value
    csrr x14, 0x740

    #Address 0x740 Write value 0x12b5eec6
    li x3, 0x12b5eec6
    csrw 0x740, x3

    #Unmapped address 0xcb5 testing: random write/read operations
    #Address 0xcb5 read value
    csrr x14, 0xcb5

    #Address 0xcb5 read value
    csrr x14, 0xcb5

    #Address 0xcb5 read value
    csrr x14, 0xcb5

    #Address 0xcb5 Write value 0xf608d9c
    li x3, 0xf608d9c
    csrw 0xcb5, x3

    #Address 0xcb5 Write value 0x965c670a
    li x3, 0x965c670a
    csrw 0xcb5, x3

    #Unmapped address 0x91c testing: random write/read operations
    #Address 0x91c Write value 0x54accacc
    li x3, 0x54accacc
    csrw 0x91c, x3

    #Address 0x91c read value
    csrr x14, 0x91c

    #Address 0x91c read value
    csrr x14, 0x91c

    #Address 0x91c read value
    csrr x14, 0x91c

    #Unmapped address 0x8 testing: random write/read operations
    #Address 0x8 Write value 0x6b846536
    li x3, 0x6b846536
    csrw 0x8, x3

    #Address 0x8 read value
    csrr x14, 0x8

    #Address 0x8 read value
    csrr x14, 0x8

    #Address 0x8 read value
    csrr x14, 0x8

    #Unmapped address 0x7ef testing: random write/read operations
    #Address 0x7ef read value
    csrr x14, 0x7ef

    #Address 0x7ef Write value 0xfe7ad953
    li x3, 0xfe7ad953
    csrw 0x7ef, x3

    #Address 0x7ef Write value 0xd763e3dc
    li x3, 0xd763e3dc
    csrw 0x7ef, x3

    #Address 0x7ef Write value 0x6a82a3e5
    li x3, 0x6a82a3e5
    csrw 0x7ef, x3

    #Address 0x7ef read value
    csrr x14, 0x7ef

    #Unmapped address 0x7f testing: random write/read operations
    #Address 0x7f read value
    csrr x14, 0x7f

    #Address 0x7f Write value 0x4b25103f
    li x3, 0x4b25103f
    csrw 0x7f, x3

    #Address 0x7f read value
    csrr x14, 0x7f

    #Address 0x7f Write value 0x2d5e2a68
    li x3, 0x2d5e2a68
    csrw 0x7f, x3

    #Unmapped address 0x952 testing: random write/read operations
    #Address 0x952 Write value 0x1684db93
    li x3, 0x1684db93
    csrw 0x952, x3

    #Unmapped address 0xe29 testing: random write/read operations
    #Address 0xe29 read value
    csrr x14, 0xe29

    #Address 0xe29 Write value 0x965e58ca
    li x3, 0x965e58ca
    csrw 0xe29, x3

    #Unmapped address 0xe6e testing: random write/read operations
    #Address 0xe6e Write value 0x70cfe61e
    li x3, 0x70cfe61e
    csrw 0xe6e, x3

    #Unmapped address 0x202 testing: random write/read operations
    #Address 0x202 Write value 0xbd603b40
    li x3, 0xbd603b40
    csrw 0x202, x3

    #Address 0x202 Write value 0xb7d7b2a3
    li x3, 0xb7d7b2a3
    csrw 0x202, x3

    #Address 0x202 read value
    csrr x14, 0x202

    #Unmapped address 0xba9 testing: random write/read operations
    #Address 0xba9 Write value 0xe50809b2
    li x3, 0xe50809b2
    csrw 0xba9, x3

    #Address 0xba9 read value
    csrr x14, 0xba9

    #Address 0xba9 Write value 0x2e901e65
    li x3, 0x2e901e65
    csrw 0xba9, x3

    #Address 0xba9 read value
    csrr x14, 0xba9

    #Address 0xba9 Write value 0xee03fac0
    li x3, 0xee03fac0
    csrw 0xba9, x3

    #Unmapped address 0x22c testing: random write/read operations
    #Address 0x22c Write value 0x64420c58
    li x3, 0x64420c58
    csrw 0x22c, x3

    #Address 0x22c Write value 0x5fbbaa35
    li x3, 0x5fbbaa35
    csrw 0x22c, x3

    #Address 0x22c Write value 0x534ca638
    li x3, 0x534ca638
    csrw 0x22c, x3

    #Unmapped address 0xde7 testing: random write/read operations
    #Address 0xde7 Write value 0x2e566960
    li x3, 0x2e566960
    csrw 0xde7, x3

    #Address 0xde7 Write value 0x70835e80
    li x3, 0x70835e80
    csrw 0xde7, x3

    #Address 0xde7 read value
    csrr x14, 0xde7

    #Address 0xde7 Write value 0xa5cf39b2
    li x3, 0xa5cf39b2
    csrw 0xde7, x3

    #Unmapped address 0x6e7 testing: random write/read operations
    #Address 0x6e7 Write value 0x819a4190
    li x3, 0x819a4190
    csrw 0x6e7, x3

    #Address 0x6e7 read value
    csrr x14, 0x6e7

    #Address 0x6e7 Write value 0x4f5c39a3
    li x3, 0x4f5c39a3
    csrw 0x6e7, x3

    #Address 0x6e7 read value
    csrr x14, 0x6e7

    #Unmapped address 0x61e testing: random write/read operations
    #Address 0x61e read value
    csrr x14, 0x61e

    #Address 0x61e Write value 0x25f0f6f1
    li x3, 0x25f0f6f1
    csrw 0x61e, x3

    #Address 0x61e read value
    csrr x14, 0x61e

    #Unmapped address 0x873 testing: random write/read operations
    #Address 0x873 Write value 0x8bd4e854
    li x3, 0x8bd4e854
    csrw 0x873, x3

    #Address 0x873 read value
    csrr x14, 0x873

    #Address 0x873 read value
    csrr x14, 0x873

    #Unmapped address 0xa8a testing: random write/read operations
    #Address 0xa8a Write value 0x8a9dbe48
    li x3, 0x8a9dbe48
    csrw 0xa8a, x3

    #Address 0xa8a Write value 0x4e0fc429
    li x3, 0x4e0fc429
    csrw 0xa8a, x3

    #Address 0xa8a Write value 0xc23a042c
    li x3, 0xc23a042c
    csrw 0xa8a, x3

    #Address 0xa8a read value
    csrr x14, 0xa8a

    #Unmapped address 0x17c testing: random write/read operations
    #Address 0x17c Write value 0x1f2e2ed9
    li x3, 0x1f2e2ed9
    csrw 0x17c, x3

    #Address 0x17c read value
    csrr x14, 0x17c

    #Address 0x17c read value
    csrr x14, 0x17c

    #Address 0x17c Write value 0x5a2cb75e
    li x3, 0x5a2cb75e
    csrw 0x17c, x3

    #Address 0x17c Write value 0xef740f90
    li x3, 0xef740f90
    csrw 0x17c, x3

    #Unmapped address 0xa82 testing: random write/read operations
    #Address 0xa82 read value
    csrr x14, 0xa82

    #Address 0xa82 Write value 0x6a1d50f6
    li x3, 0x6a1d50f6
    csrw 0xa82, x3

    #Unmapped address 0xb81 testing: random write/read operations
    #Address 0xb81 read value
    csrr x14, 0xb81

    #Address 0xb81 Write value 0xfe5e8137
    li x3, 0xfe5e8137
    csrw 0xb81, x3

    #Address 0xb81 read value
    csrr x14, 0xb81

    #Address 0xb81 Write value 0x285578cd
    li x3, 0x285578cd
    csrw 0xb81, x3

    #Unmapped address 0x618 testing: random write/read operations
    #Address 0x618 read value
    csrr x14, 0x618

    #Address 0x618 Write value 0xe58dd54e
    li x3, 0xe58dd54e
    csrw 0x618, x3

    #Address 0x618 Write value 0xaf5a31f5
    li x3, 0xaf5a31f5
    csrw 0x618, x3

    #Unmapped address 0x6a8 testing: random write/read operations
    #Address 0x6a8 Write value 0x419e4028
    li x3, 0x419e4028
    csrw 0x6a8, x3

    #Address 0x6a8 read value
    csrr x14, 0x6a8

    #Address 0x6a8 Write value 0x52b10eba
    li x3, 0x52b10eba
    csrw 0x6a8, x3

    #Address 0x6a8 read value
    csrr x14, 0x6a8

    #Unmapped address 0x265 testing: random write/read operations
    #Address 0x265 Write value 0x82ad8b0f
    li x3, 0x82ad8b0f
    csrw 0x265, x3

    #Address 0x265 Write value 0x81e60e96
    li x3, 0x81e60e96
    csrw 0x265, x3

    #Address 0x265 Write value 0xcb6c79eb
    li x3, 0xcb6c79eb
    csrw 0x265, x3

    #Unmapped address 0x24 testing: random write/read operations
    #Address 0x24 read value
    csrr x14, 0x24

    #Unmapped address 0x241 testing: random write/read operations
    #Address 0x241 read value
    csrr x14, 0x241

    #Address 0x241 read value
    csrr x14, 0x241

    #Unmapped address 0x1b2 testing: random write/read operations
    #Address 0x1b2 read value
    csrr x14, 0x1b2

    #Address 0x1b2 read value
    csrr x14, 0x1b2

    #Address 0x1b2 Write value 0x66a38a8d
    li x3, 0x66a38a8d
    csrw 0x1b2, x3

    #Address 0x1b2 read value
    csrr x14, 0x1b2

    #Unmapped address 0xd97 testing: random write/read operations
    #Address 0xd97 Write value 0x38c7ce78
    li x3, 0x38c7ce78
    csrw 0xd97, x3

    #Address 0xd97 read value
    csrr x14, 0xd97

    #Address 0xd97 Write value 0x83068bbb
    li x3, 0x83068bbb
    csrw 0xd97, x3

    #Address 0xd97 read value
    csrr x14, 0xd97

    #Unmapped address 0xd0 testing: random write/read operations
    #Address 0xd0 read value
    csrr x14, 0xd0

    #Unmapped address 0x3df testing: random write/read operations
    #Address 0x3df read value
    csrr x14, 0x3df

    #Address 0x3df read value
    csrr x14, 0x3df

    #Unmapped address 0x48b testing: random write/read operations
    #Address 0x48b Write value 0x78ac37fd
    li x3, 0x78ac37fd
    csrw 0x48b, x3

    #Unmapped address 0xadc testing: random write/read operations
    #Address 0xadc Write value 0x57f1a983
    li x3, 0x57f1a983
    csrw 0xadc, x3

    #Address 0xadc Write value 0xe8388a75
    li x3, 0xe8388a75
    csrw 0xadc, x3

    #Address 0xadc read value
    csrr x14, 0xadc

    #Address 0xadc read value
    csrr x14, 0xadc

    #Address 0xadc Write value 0x5b474a33
    li x3, 0x5b474a33
    csrw 0xadc, x3

    #Unmapped address 0x549 testing: random write/read operations
    #Address 0x549 read value
    csrr x14, 0x549

    #Address 0x549 Write value 0xb80238e7
    li x3, 0xb80238e7
    csrw 0x549, x3

    #Unmapped address 0x1af testing: random write/read operations
    #Address 0x1af read value
    csrr x14, 0x1af

    #Address 0x1af Write value 0x512d8f61
    li x3, 0x512d8f61
    csrw 0x1af, x3

    #Unmapped address 0x83e testing: random write/read operations
    #Address 0x83e Write value 0xaa02ad00
    li x3, 0xaa02ad00
    csrw 0x83e, x3

    #Unmapped address 0x66c testing: random write/read operations
    #Address 0x66c read value
    csrr x14, 0x66c

    #Mapped address 0xb13 (mhpmcounter19) testing: random write/read operations
    #Address 0xb13 read value
    csrr x14, 0xb13

    #Address 0xb13 read value
    csrr x14, 0xb13

    #Address 0xb13 Write value 0x5045c609
    li x3, 0x5045c609
    csrw 0xb13, x3

    #Address 0xb13 Write value 0x5e348377
    li x3, 0x5e348377
    csrw 0xb13, x3

    #Unmapped address 0x102 testing: random write/read operations
    #Address 0x102 read value
    csrr x14, 0x102

    #Unmapped address 0x898 testing: random write/read operations
    #Address 0x898 read value
    csrr x14, 0x898

    #Address 0x898 read value
    csrr x14, 0x898

    #Address 0x898 read value
    csrr x14, 0x898

    #Address 0x898 Write value 0x2a2dcab9
    li x3, 0x2a2dcab9
    csrw 0x898, x3

    #Unmapped address 0x1e1 testing: random write/read operations
    #Address 0x1e1 Write value 0x1e22c0bf
    li x3, 0x1e22c0bf
    csrw 0x1e1, x3

    #Address 0x1e1 Write value 0xe2c100d5
    li x3, 0xe2c100d5
    csrw 0x1e1, x3

    #Address 0x1e1 read value
    csrr x14, 0x1e1

    #Unmapped address 0x16a testing: random write/read operations
    #Address 0x16a Write value 0xe1a871c1
    li x3, 0xe1a871c1
    csrw 0x16a, x3

    #Unmapped address 0xe08 testing: random write/read operations
    #Address 0xe08 read value
    csrr x14, 0xe08

    #Address 0xe08 Write value 0xba39df74
    li x3, 0xba39df74
    csrw 0xe08, x3

    #Unmapped address 0x9e9 testing: random write/read operations
    #Address 0x9e9 Write value 0xdb57a4d8
    li x3, 0xdb57a4d8
    csrw 0x9e9, x3

    #Address 0x9e9 read value
    csrr x14, 0x9e9

    #Address 0x9e9 Write value 0x16f975b0
    li x3, 0x16f975b0
    csrw 0x9e9, x3

    #Address 0x9e9 Write value 0x3687047
    li x3, 0x3687047
    csrw 0x9e9, x3

    #Address 0x9e9 read value
    csrr x14, 0x9e9

    #Unmapped address 0x2cf testing: random write/read operations
    #Address 0x2cf read value
    csrr x14, 0x2cf

    #Address 0x2cf read value
    csrr x14, 0x2cf

    #Address 0x2cf Write value 0xede865e2
    li x3, 0xede865e2
    csrw 0x2cf, x3

    #Address 0x2cf Write value 0x7444d673
    li x3, 0x7444d673
    csrw 0x2cf, x3

    #Unmapped address 0x9f4 testing: random write/read operations
    #Address 0x9f4 Write value 0x3da5c27e
    li x3, 0x3da5c27e
    csrw 0x9f4, x3

    #Unmapped address 0xe59 testing: random write/read operations
    #Address 0xe59 read value
    csrr x14, 0xe59

    #Address 0xe59 read value
    csrr x14, 0xe59

    #Address 0xe59 Write value 0x3c2c58ba
    li x3, 0x3c2c58ba
    csrw 0xe59, x3

    #Address 0xe59 read value
    csrr x14, 0xe59

    #Unmapped address 0x5d7 testing: random write/read operations
    #Address 0x5d7 Write value 0x8df86010
    li x3, 0x8df86010
    csrw 0x5d7, x3

    #Unmapped address 0x6c3 testing: random write/read operations
    #Address 0x6c3 read value
    csrr x14, 0x6c3

    #Address 0x6c3 Write value 0x7033342d
    li x3, 0x7033342d
    csrw 0x6c3, x3

    #Address 0x6c3 read value
    csrr x14, 0x6c3

    #Unmapped address 0xdbe testing: random write/read operations
    #Address 0xdbe read value
    csrr x14, 0xdbe

    #Address 0xdbe read value
    csrr x14, 0xdbe

    #Address 0xdbe read value
    csrr x14, 0xdbe

    #Address 0xdbe read value
    csrr x14, 0xdbe

    #Address 0xdbe Write value 0xeab6adf2
    li x3, 0xeab6adf2
    csrw 0xdbe, x3

    #Unmapped address 0xdaf testing: random write/read operations
    #Address 0xdaf Write value 0x8a8bc9ff
    li x3, 0x8a8bc9ff
    csrw 0xdaf, x3

    #Unmapped address 0x1 testing: random write/read operations
    #Address 0x1 Write value 0x845883b9
    li x3, 0x845883b9
    csrw 0x1, x3

    #Address 0x1 read value
    csrr x14, 0x1

    #Address 0x1 Write value 0xc9fecf5a
    li x3, 0xc9fecf5a
    csrw 0x1, x3

    #Unmapped address 0xc7a testing: random write/read operations
    #Address 0xc7a Write value 0x6ca0a752
    li x3, 0x6ca0a752
    csrw 0xc7a, x3

    #Address 0xc7a Write value 0x2794bcca
    li x3, 0x2794bcca
    csrw 0xc7a, x3

    #Address 0xc7a read value
    csrr x14, 0xc7a

    #Unmapped address 0x924 testing: random write/read operations
    #Address 0x924 Write value 0x95f5947f
    li x3, 0x95f5947f
    csrw 0x924, x3

    #Address 0x924 read value
    csrr x14, 0x924

    #Address 0x924 Write value 0xf97cb8ad
    li x3, 0xf97cb8ad
    csrw 0x924, x3

    #Unmapped address 0x3f1 testing: random write/read operations
    #Address 0x3f1 read value
    csrr x14, 0x3f1

    #Unmapped address 0xb5f testing: random write/read operations
    #Address 0xb5f read value
    csrr x14, 0xb5f

    #Address 0xb5f read value
    csrr x14, 0xb5f

    #Address 0xb5f read value
    csrr x14, 0xb5f

    #Address 0xb5f read value
    csrr x14, 0xb5f

    #Skipped Mapped address 0x305 (mtvec) because in user ignore list

    #Unmapped address 0x784 testing: random write/read operations
    #Address 0x784 Write value 0x6e28c940
    li x3, 0x6e28c940
    csrw 0x784, x3

    #Address 0x784 read value
    csrr x14, 0x784

    #Address 0x784 Write value 0x89873c74
    li x3, 0x89873c74
    csrw 0x784, x3

    #Address 0x784 read value
    csrr x14, 0x784

    #Address 0x784 read value
    csrr x14, 0x784

    #Mapped address 0xb08 (mhpmcounter8) testing: random write/read operations
    #Address 0xb08 Write value 0x3bcf4eb
    li x3, 0x3bcf4eb
    csrw 0xb08, x3

    #Address 0xb08 read value
    csrr x14, 0xb08

    #Unmapped address 0x6db testing: random write/read operations
    #Address 0x6db Write value 0x4cb1c497
    li x3, 0x4cb1c497
    csrw 0x6db, x3

    #Address 0x6db Write value 0x15e24f17
    li x3, 0x15e24f17
    csrw 0x6db, x3

    #Unmapped address 0x4a testing: random write/read operations
    #Address 0x4a read value
    csrr x14, 0x4a

    #Address 0x4a Write value 0xee84658f
    li x3, 0xee84658f
    csrw 0x4a, x3

    #Unmapped address 0x2cb testing: random write/read operations
    #Address 0x2cb Write value 0x89a64cbb
    li x3, 0x89a64cbb
    csrw 0x2cb, x3

    #Unmapped address 0x2a5 testing: random write/read operations
    #Address 0x2a5 Write value 0xcd389506
    li x3, 0xcd389506
    csrw 0x2a5, x3

    #Address 0x2a5 read value
    csrr x14, 0x2a5

    #Address 0x2a5 read value
    csrr x14, 0x2a5

    #Address 0x2a5 Write value 0x8438526e
    li x3, 0x8438526e
    csrw 0x2a5, x3

    #Unmapped address 0xfe4 testing: random write/read operations
    #Address 0xfe4 Write value 0x67b8dcb1
    li x3, 0x67b8dcb1
    csrw 0xfe4, x3

    #Address 0xfe4 Write value 0x1b4fb217
    li x3, 0x1b4fb217
    csrw 0xfe4, x3

    #Address 0xfe4 Write value 0xcfbbd30c
    li x3, 0xcfbbd30c
    csrw 0xfe4, x3

    #Address 0xfe4 read value
    csrr x14, 0xfe4

    #Unmapped address 0x959 testing: random write/read operations
    #Address 0x959 Write value 0xbd6fed8f
    li x3, 0xbd6fed8f
    csrw 0x959, x3

    #Address 0x959 read value
    csrr x14, 0x959

    #Unmapped address 0x394 testing: random write/read operations
    #Address 0x394 Write value 0x1ffa47a5
    li x3, 0x1ffa47a5
    csrw 0x394, x3

    #Address 0x394 read value
    csrr x14, 0x394

    #Address 0x394 read value
    csrr x14, 0x394

    #Address 0x394 read value
    csrr x14, 0x394

    #Unmapped address 0xb57 testing: random write/read operations
    #Address 0xb57 read value
    csrr x14, 0xb57

    #Address 0xb57 Write value 0xa4b920c
    li x3, 0xa4b920c
    csrw 0xb57, x3

    #Unmapped address 0x815 testing: random write/read operations
    #Address 0x815 Write value 0xbc837907
    li x3, 0xbc837907
    csrw 0x815, x3

    #Unmapped address 0x955 testing: random write/read operations
    #Address 0x955 Write value 0xdb7f7621
    li x3, 0xdb7f7621
    csrw 0x955, x3

    #Address 0x955 read value
    csrr x14, 0x955

    #Address 0x955 Write value 0x11f273f0
    li x3, 0x11f273f0
    csrw 0x955, x3

    #Unmapped address 0x879 testing: random write/read operations
    #Address 0x879 read value
    csrr x14, 0x879

    #Address 0x879 Write value 0x6c6e1f68
    li x3, 0x6c6e1f68
    csrw 0x879, x3

    #Address 0x879 Write value 0xbb8b8ac
    li x3, 0xbb8b8ac
    csrw 0x879, x3

    #Address 0x879 Write value 0x6390e88c
    li x3, 0x6390e88c
    csrw 0x879, x3

    #Unmapped address 0x422 testing: random write/read operations
    #Address 0x422 read value
    csrr x14, 0x422

    #Address 0x422 read value
    csrr x14, 0x422

    #Address 0x422 read value
    csrr x14, 0x422

    #Address 0x422 read value
    csrr x14, 0x422

    #Unmapped address 0x930 testing: random write/read operations
    #Address 0x930 Write value 0x63ec6e5c
    li x3, 0x63ec6e5c
    csrw 0x930, x3

    #Unmapped address 0x60c testing: random write/read operations
    #Address 0x60c Write value 0x6fe23f55
    li x3, 0x6fe23f55
    csrw 0x60c, x3

    #Unmapped address 0x407 testing: random write/read operations
    #Address 0x407 Write value 0xaf4f961b
    li x3, 0xaf4f961b
    csrw 0x407, x3

    #Address 0x407 read value
    csrr x14, 0x407

    #Unmapped address 0xfef testing: random write/read operations
    #Address 0xfef read value
    csrr x14, 0xfef

    #Address 0xfef Write value 0x7df3ba6e
    li x3, 0x7df3ba6e
    csrw 0xfef, x3

    #Unmapped address 0xb4d testing: random write/read operations
    #Address 0xb4d Write value 0x8b5a0138
    li x3, 0x8b5a0138
    csrw 0xb4d, x3

    #Address 0xb4d Write value 0xf5266692
    li x3, 0xf5266692
    csrw 0xb4d, x3

    #Address 0xb4d Write value 0x2060ca48
    li x3, 0x2060ca48
    csrw 0xb4d, x3

    #Address 0xb4d read value
    csrr x14, 0xb4d

    #Address 0xb4d read value
    csrr x14, 0xb4d

    #Unmapped address 0xef5 testing: random write/read operations
    #Address 0xef5 read value
    csrr x14, 0xef5

    #Address 0xef5 Write value 0x2a4a740d
    li x3, 0x2a4a740d
    csrw 0xef5, x3

    #Address 0xef5 read value
    csrr x14, 0xef5

    #Address 0xef5 read value
    csrr x14, 0xef5

    #Address 0xef5 Write value 0x3a7b8e5f
    li x3, 0x3a7b8e5f
    csrw 0xef5, x3

    #Unmapped address 0x2d1 testing: random write/read operations
    #Address 0x2d1 Write value 0x4bb4c209
    li x3, 0x4bb4c209
    csrw 0x2d1, x3

    #Unmapped address 0xbd6 testing: random write/read operations
    #Address 0xbd6 read value
    csrr x14, 0xbd6

    #Address 0xbd6 read value
    csrr x14, 0xbd6

    #Address 0xbd6 Write value 0x83a34372
    li x3, 0x83a34372
    csrw 0xbd6, x3

    #Address 0xbd6 Write value 0x50fc94b5
    li x3, 0x50fc94b5
    csrw 0xbd6, x3

    #Unmapped address 0xe72 testing: random write/read operations
    #Address 0xe72 read value
    csrr x14, 0xe72

    #Address 0xe72 Write value 0xebb0a180
    li x3, 0xebb0a180
    csrw 0xe72, x3

    #Address 0xe72 read value
    csrr x14, 0xe72

    #Address 0xe72 Write value 0xde3ed91a
    li x3, 0xde3ed91a
    csrw 0xe72, x3

    #Unmapped address 0xc5 testing: random write/read operations
    #Address 0xc5 Write value 0x5f3a8c41
    li x3, 0x5f3a8c41
    csrw 0xc5, x3

    #Address 0xc5 Write value 0x2ad56656
    li x3, 0x2ad56656
    csrw 0xc5, x3

    #Address 0xc5 Write value 0xfe129167
    li x3, 0xfe129167
    csrw 0xc5, x3

    #Address 0xc5 read value
    csrr x14, 0xc5

    #Unmapped address 0x91 testing: random write/read operations
    #Address 0x91 Write value 0xd800a0ec
    li x3, 0xd800a0ec
    csrw 0x91, x3

    #Unmapped address 0x7a7 testing: random write/read operations
    #Address 0x7a7 read value
    csrr x14, 0x7a7

    #Address 0x7a7 read value
    csrr x14, 0x7a7

    #Address 0x7a7 read value
    csrr x14, 0x7a7

    #Address 0x7a7 Write value 0x3bfc6146
    li x3, 0x3bfc6146
    csrw 0x7a7, x3

    #Unmapped address 0x2ad testing: random write/read operations
    #Address 0x2ad read value
    csrr x14, 0x2ad

    #Address 0x2ad read value
    csrr x14, 0x2ad

    #Address 0x2ad Write value 0x298c3dc3
    li x3, 0x298c3dc3
    csrw 0x2ad, x3

    #Address 0x2ad read value
    csrr x14, 0x2ad

    #Unmapped address 0x5b5 testing: random write/read operations
    #Address 0x5b5 read value
    csrr x14, 0x5b5

    #Address 0x5b5 read value
    csrr x14, 0x5b5

    #Unmapped address 0x7f3 testing: random write/read operations
    #Address 0x7f3 read value
    csrr x14, 0x7f3

    #Address 0x7f3 Write value 0xf243e857
    li x3, 0xf243e857
    csrw 0x7f3, x3

    #Unmapped address 0xad4 testing: random write/read operations
    #Address 0xad4 read value
    csrr x14, 0xad4

    #Address 0xad4 Write value 0xeae67091
    li x3, 0xeae67091
    csrw 0xad4, x3

    #Address 0xad4 Write value 0x75b9479
    li x3, 0x75b9479
    csrw 0xad4, x3

    #Address 0xad4 read value
    csrr x14, 0xad4

    #Address 0xad4 read value
    csrr x14, 0xad4

    #Unmapped address 0x891 testing: random write/read operations
    #Address 0x891 read value
    csrr x14, 0x891

    #Unmapped address 0x842 testing: random write/read operations
    #Address 0x842 Write value 0x5f9362aa
    li x3, 0x5f9362aa
    csrw 0x842, x3

    #Address 0x842 read value
    csrr x14, 0x842

    #Address 0x842 read value
    csrr x14, 0x842

    #Address 0x842 read value
    csrr x14, 0x842

    #Mapped address 0xb16 (mhpmcounter22) testing: random write/read operations
    #Address 0xb16 read value
    csrr x14, 0xb16

    #Address 0xb16 read value
    csrr x14, 0xb16

    #Address 0xb16 Write value 0x1f7c3c8
    li x3, 0x1f7c3c8
    csrw 0xb16, x3

    #Address 0xb16 Write value 0x1dedf095
    li x3, 0x1dedf095
    csrw 0xb16, x3

    #Unmapped address 0x64c testing: random write/read operations
    #Address 0x64c Write value 0xc5296cec
    li x3, 0xc5296cec
    csrw 0x64c, x3

    #Address 0x64c read value
    csrr x14, 0x64c

    #Address 0x64c Write value 0xc141739
    li x3, 0xc141739
    csrw 0x64c, x3

    #Unmapped address 0x55b testing: random write/read operations
    #Address 0x55b read value
    csrr x14, 0x55b

    #Unmapped address 0x39b testing: random write/read operations
    #Address 0x39b read value
    csrr x14, 0x39b

    #Unmapped address 0x83f testing: random write/read operations
    #Address 0x83f read value
    csrr x14, 0x83f

    #Address 0x83f read value
    csrr x14, 0x83f

    #Address 0x83f Write value 0x71053ffd
    li x3, 0x71053ffd
    csrw 0x83f, x3

    #Address 0x83f read value
    csrr x14, 0x83f

    #Unmapped address 0xabc testing: random write/read operations
    #Address 0xabc read value
    csrr x14, 0xabc

    #Address 0xabc Write value 0xd4327270
    li x3, 0xd4327270
    csrw 0xabc, x3

    #Address 0xabc Write value 0x9b46133c
    li x3, 0x9b46133c
    csrw 0xabc, x3

    #Address 0xabc read value
    csrr x14, 0xabc

    #Unmapped address 0xbdc testing: random write/read operations
    #Address 0xbdc Write value 0x2710eda1
    li x3, 0x2710eda1
    csrw 0xbdc, x3

    #Address 0xbdc Write value 0x5d63a5f6
    li x3, 0x5d63a5f6
    csrw 0xbdc, x3

    #Address 0xbdc read value
    csrr x14, 0xbdc

    #Address 0xbdc read value
    csrr x14, 0xbdc

    #Address 0xbdc read value
    csrr x14, 0xbdc

    #Unmapped address 0x702 testing: random write/read operations
    #Address 0x702 read value
    csrr x14, 0x702

    #Address 0x702 Write value 0xb1bc6be0
    li x3, 0xb1bc6be0
    csrw 0x702, x3

    #Unmapped address 0xbf5 testing: random write/read operations
    #Address 0xbf5 read value
    csrr x14, 0xbf5

    #Address 0xbf5 Write value 0xeb97e015
    li x3, 0xeb97e015
    csrw 0xbf5, x3

    #Address 0xbf5 read value
    csrr x14, 0xbf5

    #Unmapped address 0xecb testing: random write/read operations
    #Address 0xecb read value
    csrr x14, 0xecb

    #Address 0xecb Write value 0x979d2b83
    li x3, 0x979d2b83
    csrw 0xecb, x3

    #Unmapped address 0xc4f testing: random write/read operations
    #Address 0xc4f Write value 0xa219661
    li x3, 0xa219661
    csrw 0xc4f, x3

    #Unmapped address 0xb79 testing: random write/read operations
    #Address 0xb79 read value
    csrr x14, 0xb79

    #Address 0xb79 Write value 0x7c245cec
    li x3, 0x7c245cec
    csrw 0xb79, x3

    #Address 0xb79 read value
    csrr x14, 0xb79

    #Unmapped address 0xaa5 testing: random write/read operations
    #Address 0xaa5 read value
    csrr x14, 0xaa5

    #Address 0xaa5 Write value 0xabda6d2d
    li x3, 0xabda6d2d
    csrw 0xaa5, x3

    #Address 0xaa5 Write value 0x3006e05e
    li x3, 0x3006e05e
    csrw 0xaa5, x3

    #Address 0xaa5 Write value 0x8c232285
    li x3, 0x8c232285
    csrw 0xaa5, x3

    #Unmapped address 0x52e testing: random write/read operations
    #Address 0x52e read value
    csrr x14, 0x52e

    #Address 0x52e read value
    csrr x14, 0x52e

    #Unmapped address 0xde4 testing: random write/read operations
    #Address 0xde4 read value
    csrr x14, 0xde4

    #Unmapped address 0xa1a testing: random write/read operations
    #Address 0xa1a read value
    csrr x14, 0xa1a

    #Unmapped address 0x65b testing: random write/read operations
    #Address 0x65b read value
    csrr x14, 0x65b

    #Address 0x65b read value
    csrr x14, 0x65b

    #Address 0x65b read value
    csrr x14, 0x65b

    #Address 0x65b Write value 0xdd9798e5
    li x3, 0xdd9798e5
    csrw 0x65b, x3

    #Unmapped address 0xe9c testing: random write/read operations
    #Address 0xe9c read value
    csrr x14, 0xe9c

    #Address 0xe9c read value
    csrr x14, 0xe9c

    #Unmapped address 0x6ec testing: random write/read operations
    #Address 0x6ec Write value 0x679afb7
    li x3, 0x679afb7
    csrw 0x6ec, x3

    #Address 0x6ec Write value 0x991e3ee7
    li x3, 0x991e3ee7
    csrw 0x6ec, x3

    #Address 0x6ec read value
    csrr x14, 0x6ec

    #Unmapped address 0x68b testing: random write/read operations
    #Address 0x68b read value
    csrr x14, 0x68b

    #Unmapped address 0x98f testing: random write/read operations
    #Address 0x98f Write value 0x2e3500e6
    li x3, 0x2e3500e6
    csrw 0x98f, x3

    #Address 0x98f Write value 0x745cad5c
    li x3, 0x745cad5c
    csrw 0x98f, x3

    #Unmapped address 0xa91 testing: random write/read operations
    #Address 0xa91 Write value 0x666c2c54
    li x3, 0x666c2c54
    csrw 0xa91, x3

    #Unmapped address 0x85e testing: random write/read operations
    #Address 0x85e Write value 0x30156457
    li x3, 0x30156457
    csrw 0x85e, x3

    #Address 0x85e Write value 0x5a99c7f8
    li x3, 0x5a99c7f8
    csrw 0x85e, x3

    #Address 0x85e read value
    csrr x14, 0x85e

    #Address 0x85e read value
    csrr x14, 0x85e

    #Unmapped address 0x7e5 testing: random write/read operations
    #Address 0x7e5 Write value 0x95fdc233
    li x3, 0x95fdc233
    csrw 0x7e5, x3

    #Address 0x7e5 read value
    csrr x14, 0x7e5

    #Address 0x7e5 Write value 0x3bce5ba3
    li x3, 0x3bce5ba3
    csrw 0x7e5, x3

    #Address 0x7e5 read value
    csrr x14, 0x7e5

    #Unmapped address 0x1c3 testing: random write/read operations
    #Address 0x1c3 read value
    csrr x14, 0x1c3

    #Address 0x1c3 read value
    csrr x14, 0x1c3

    #Address 0x1c3 Write value 0xd8784228
    li x3, 0xd8784228
    csrw 0x1c3, x3

    #Unmapped address 0x52b testing: random write/read operations
    #Address 0x52b read value
    csrr x14, 0x52b

    #Address 0x52b read value
    csrr x14, 0x52b

    #Address 0x52b read value
    csrr x14, 0x52b

    #Unmapped address 0xbe2 testing: random write/read operations
    #Address 0xbe2 read value
    csrr x14, 0xbe2

    #Address 0xbe2 Write value 0xb7bfa95d
    li x3, 0xb7bfa95d
    csrw 0xbe2, x3

    #Address 0xbe2 read value
    csrr x14, 0xbe2

    #Address 0xbe2 read value
    csrr x14, 0xbe2

    #Address 0xbe2 Write value 0xf61151bd
    li x3, 0xf61151bd
    csrw 0xbe2, x3

    #Unmapped address 0x47a testing: random write/read operations
    #Address 0x47a Write value 0x61a6334b
    li x3, 0x61a6334b
    csrw 0x47a, x3

    #Address 0x47a read value
    csrr x14, 0x47a

    #Unmapped address 0xd3d testing: random write/read operations
    #Address 0xd3d read value
    csrr x14, 0xd3d

    #Address 0xd3d read value
    csrr x14, 0xd3d

    #Address 0xd3d read value
    csrr x14, 0xd3d

    #Address 0xd3d Write value 0xc25fc658
    li x3, 0xc25fc658
    csrw 0xd3d, x3

    #Unmapped address 0x434 testing: random write/read operations
    #Address 0x434 read value
    csrr x14, 0x434

    #Address 0x434 Write value 0x35018b14
    li x3, 0x35018b14
    csrw 0x434, x3

    #Unmapped address 0x30f testing: random write/read operations
    #Address 0x30f Write value 0x7f67b36e
    li x3, 0x7f67b36e
    csrw 0x30f, x3

    #Address 0x30f read value
    csrr x14, 0x30f

    #Address 0x30f read value
    csrr x14, 0x30f

    #Unmapped address 0xf8f testing: random write/read operations
    #Address 0xf8f read value
    csrr x14, 0xf8f

    #Address 0xf8f read value
    csrr x14, 0xf8f

    #Address 0xf8f read value
    csrr x14, 0xf8f

    #Address 0xf8f Write value 0xacdb0a12
    li x3, 0xacdb0a12
    csrw 0xf8f, x3

    #Unmapped address 0x6f4 testing: random write/read operations
    #Address 0x6f4 read value
    csrr x14, 0x6f4

    #Address 0x6f4 read value
    csrr x14, 0x6f4

    #Address 0x6f4 read value
    csrr x14, 0x6f4

    #Address 0x6f4 read value
    csrr x14, 0x6f4

    #Unmapped address 0xdfa testing: random write/read operations
    #Address 0xdfa Write value 0xbbcc8321
    li x3, 0xbbcc8321
    csrw 0xdfa, x3

    #Address 0xdfa Write value 0x438ddb16
    li x3, 0x438ddb16
    csrw 0xdfa, x3

    #Unmapped address 0xdfc testing: random write/read operations
    #Address 0xdfc read value
    csrr x14, 0xdfc

    #Address 0xdfc read value
    csrr x14, 0xdfc

    #Address 0xdfc Write value 0x18cf0f36
    li x3, 0x18cf0f36
    csrw 0xdfc, x3

    #Address 0xdfc Write value 0xa402410
    li x3, 0xa402410
    csrw 0xdfc, x3

    #Address 0xdfc Write value 0xc1c2facc
    li x3, 0xc1c2facc
    csrw 0xdfc, x3

    #Unmapped address 0x2e4 testing: random write/read operations
    #Address 0x2e4 Write value 0x50843c9e
    li x3, 0x50843c9e
    csrw 0x2e4, x3

    #Address 0x2e4 read value
    csrr x14, 0x2e4

    #Address 0x2e4 read value
    csrr x14, 0x2e4

    #Unmapped address 0x9ea testing: random write/read operations
    #Address 0x9ea read value
    csrr x14, 0x9ea

    #Address 0x9ea read value
    csrr x14, 0x9ea

    #Unmapped address 0xc63 testing: random write/read operations
    #Address 0xc63 Write value 0x6168fb1d
    li x3, 0x6168fb1d
    csrw 0xc63, x3

    #Address 0xc63 read value
    csrr x14, 0xc63

    #Unmapped address 0xefb testing: random write/read operations
    #Address 0xefb read value
    csrr x14, 0xefb

    #Address 0xefb Write value 0x466da9c3
    li x3, 0x466da9c3
    csrw 0xefb, x3

    #Address 0xefb read value
    csrr x14, 0xefb

    #Unmapped address 0xc96 testing: random write/read operations
    #Address 0xc96 read value
    csrr x14, 0xc96

    #Address 0xc96 Write value 0x54ed9dcd
    li x3, 0x54ed9dcd
    csrw 0xc96, x3

    #Address 0xc96 read value
    csrr x14, 0xc96

    #Unmapped address 0xeda testing: random write/read operations
    #Address 0xeda Write value 0x160a1868
    li x3, 0x160a1868
    csrw 0xeda, x3

    #Unmapped address 0xff1 testing: random write/read operations
    #Address 0xff1 Write value 0x22870ab2
    li x3, 0x22870ab2
    csrw 0xff1, x3

    #Address 0xff1 Write value 0x4b253209
    li x3, 0x4b253209
    csrw 0xff1, x3

    #Address 0xff1 read value
    csrr x14, 0xff1

    #Unmapped address 0xcc5 testing: random write/read operations
    #Address 0xcc5 read value
    csrr x14, 0xcc5

    #Address 0xcc5 read value
    csrr x14, 0xcc5

    #Unmapped address 0x5cc testing: random write/read operations
    #Address 0x5cc read value
    csrr x14, 0x5cc

    #Address 0x5cc read value
    csrr x14, 0x5cc

    #Unmapped address 0x56 testing: random write/read operations
    #Address 0x56 read value
    csrr x14, 0x56

    #Address 0x56 read value
    csrr x14, 0x56

    #Address 0x56 Write value 0xdfb34f61
    li x3, 0xdfb34f61
    csrw 0x56, x3

    #Address 0x56 Write value 0x8045d173
    li x3, 0x8045d173
    csrw 0x56, x3

    #Unmapped address 0x117 testing: random write/read operations
    #Address 0x117 read value
    csrr x14, 0x117

    #Address 0x117 read value
    csrr x14, 0x117

    #Address 0x117 read value
    csrr x14, 0x117

    #Address 0x117 Write value 0x41840fea
    li x3, 0x41840fea
    csrw 0x117, x3

    #Address 0x117 read value
    csrr x14, 0x117

    #Unmapped address 0xa5f testing: random write/read operations
    #Address 0xa5f read value
    csrr x14, 0xa5f

    #Address 0xa5f Write value 0x3b6af9ae
    li x3, 0x3b6af9ae
    csrw 0xa5f, x3

    #Unmapped address 0x47c testing: random write/read operations
    #Address 0x47c Write value 0x64d9fced
    li x3, 0x64d9fced
    csrw 0x47c, x3

    #Address 0x47c read value
    csrr x14, 0x47c

    #Address 0x47c read value
    csrr x14, 0x47c

    #Address 0x47c Write value 0x99a7120c
    li x3, 0x99a7120c
    csrw 0x47c, x3

    #Unmapped address 0xf0e testing: random write/read operations
    #Address 0xf0e read value
    csrr x14, 0xf0e

    #Unmapped address 0xc64 testing: random write/read operations
    #Address 0xc64 Write value 0x16be3c86
    li x3, 0x16be3c86
    csrw 0xc64, x3

    #Unmapped address 0xa93 testing: random write/read operations
    #Address 0xa93 read value
    csrr x14, 0xa93

    #Address 0xa93 Write value 0xe55bb847
    li x3, 0xe55bb847
    csrw 0xa93, x3

    #Address 0xa93 read value
    csrr x14, 0xa93

    #Address 0xa93 Write value 0xeb73c934
    li x3, 0xeb73c934
    csrw 0xa93, x3

    #Address 0xa93 read value
    csrr x14, 0xa93

    #Unmapped address 0x99 testing: random write/read operations
    #Address 0x99 read value
    csrr x14, 0x99

    #Unmapped address 0x8d8 testing: random write/read operations
    #Address 0x8d8 read value
    csrr x14, 0x8d8

    #Address 0x8d8 Write value 0x8a38fae6
    li x3, 0x8a38fae6
    csrw 0x8d8, x3

    #Address 0x8d8 read value
    csrr x14, 0x8d8

    #Unmapped address 0x1dd testing: random write/read operations
    #Address 0x1dd Write value 0x79ffdeed
    li x3, 0x79ffdeed
    csrw 0x1dd, x3

    #Unmapped address 0x709 testing: random write/read operations
    #Address 0x709 Write value 0x6674463f
    li x3, 0x6674463f
    csrw 0x709, x3

    #Address 0x709 Write value 0x6c36267
    li x3, 0x6c36267
    csrw 0x709, x3

    #Address 0x709 Write value 0x38545728
    li x3, 0x38545728
    csrw 0x709, x3

    #Address 0x709 Write value 0x93827fd0
    li x3, 0x93827fd0
    csrw 0x709, x3

    #Address 0x709 Write value 0x9322bcc4
    li x3, 0x9322bcc4
    csrw 0x709, x3

    #Unmapped address 0x4fd testing: random write/read operations
    #Address 0x4fd Write value 0x22af3d9c
    li x3, 0x22af3d9c
    csrw 0x4fd, x3

    #Unmapped address 0xeb2 testing: random write/read operations
    #Address 0xeb2 read value
    csrr x14, 0xeb2

    #Address 0xeb2 read value
    csrr x14, 0xeb2

    #Address 0xeb2 Write value 0x8f2cac60
    li x3, 0x8f2cac60
    csrw 0xeb2, x3

    #Address 0xeb2 read value
    csrr x14, 0xeb2

    #Address 0xeb2 read value
    csrr x14, 0xeb2

    #Unmapped address 0xe6b testing: random write/read operations
    #Address 0xe6b read value
    csrr x14, 0xe6b

    #Address 0xe6b read value
    csrr x14, 0xe6b

    #Address 0xe6b read value
    csrr x14, 0xe6b

    #Address 0xe6b read value
    csrr x14, 0xe6b

    #Address 0xe6b Write value 0x8a17475b
    li x3, 0x8a17475b
    csrw 0xe6b, x3

    #Unmapped address 0xc4b testing: random write/read operations
    #Address 0xc4b read value
    csrr x14, 0xc4b

    #Address 0xc4b read value
    csrr x14, 0xc4b

    #Unmapped address 0x9b3 testing: random write/read operations
    #Address 0x9b3 read value
    csrr x14, 0x9b3

    #Address 0x9b3 read value
    csrr x14, 0x9b3

    #Address 0x9b3 read value
    csrr x14, 0x9b3

    #Address 0x9b3 read value
    csrr x14, 0x9b3

    #Address 0x9b3 Write value 0x813bda56
    li x3, 0x813bda56
    csrw 0x9b3, x3

    #Unmapped address 0x20f testing: random write/read operations
    #Address 0x20f read value
    csrr x14, 0x20f

    #Address 0x20f Write value 0x81c2624a
    li x3, 0x81c2624a
    csrw 0x20f, x3

    #Address 0x20f Write value 0x528eea17
    li x3, 0x528eea17
    csrw 0x20f, x3

    #Address 0x20f Write value 0x99dd9238
    li x3, 0x99dd9238
    csrw 0x20f, x3

    #Mapped address 0x33c (mhpmevent28) testing: random write/read operations
    #Address 0x33c Write value 0xd4277dc
    li x3, 0xd4277dc
    csrw 0x33c, x3

    #Address 0x33c Write value 0x80ae943b
    li x3, 0x80ae943b
    csrw 0x33c, x3

    #Address 0x33c read value
    csrr x14, 0x33c

    #Address 0x33c Write value 0xdb1bca2a
    li x3, 0xdb1bca2a
    csrw 0x33c, x3

    #Unmapped address 0x240 testing: random write/read operations
    #Address 0x240 Write value 0xdf165de3
    li x3, 0xdf165de3
    csrw 0x240, x3

    #Address 0x240 read value
    csrr x14, 0x240

    #Address 0x240 Write value 0x467bf838
    li x3, 0x467bf838
    csrw 0x240, x3

    #Address 0x240 Write value 0xdba1756
    li x3, 0xdba1756
    csrw 0x240, x3

    #Address 0x240 Write value 0x8cbed7a6
    li x3, 0x8cbed7a6
    csrw 0x240, x3

    #Unmapped address 0xd57 testing: random write/read operations
    #Address 0xd57 read value
    csrr x14, 0xd57

    #Address 0xd57 Write value 0xfe1b82d5
    li x3, 0xfe1b82d5
    csrw 0xd57, x3

    #Address 0xd57 Write value 0x8261043c
    li x3, 0x8261043c
    csrw 0xd57, x3

    #Unmapped address 0x7a testing: random write/read operations
    #Address 0x7a read value
    csrr x14, 0x7a

    #Address 0x7a Write value 0xd2910129
    li x3, 0xd2910129
    csrw 0x7a, x3

    #Unmapped address 0x26b testing: random write/read operations
    #Address 0x26b read value
    csrr x14, 0x26b

    #Address 0x26b read value
    csrr x14, 0x26b

    #Unmapped address 0xa4c testing: random write/read operations
    #Address 0xa4c Write value 0x8853b946
    li x3, 0x8853b946
    csrw 0xa4c, x3

    #Address 0xa4c read value
    csrr x14, 0xa4c

    #Unmapped address 0xbdd testing: random write/read operations
    #Address 0xbdd Write value 0xe9d377a4
    li x3, 0xe9d377a4
    csrw 0xbdd, x3

    #Address 0xbdd Write value 0x74706dea
    li x3, 0x74706dea
    csrw 0xbdd, x3

    #Address 0xbdd read value
    csrr x14, 0xbdd

    #Address 0xbdd read value
    csrr x14, 0xbdd

    #Unmapped address 0xd40 testing: random write/read operations
    #Address 0xd40 read value
    csrr x14, 0xd40

    #Address 0xd40 read value
    csrr x14, 0xd40

    #Unmapped address 0xce5 testing: random write/read operations
    #Address 0xce5 Write value 0x56938e0c
    li x3, 0x56938e0c
    csrw 0xce5, x3

    #Address 0xce5 read value
    csrr x14, 0xce5

    #Address 0xce5 read value
    csrr x14, 0xce5

    #Unmapped address 0xef8 testing: random write/read operations
    #Address 0xef8 read value
    csrr x14, 0xef8

    #Address 0xef8 read value
    csrr x14, 0xef8

    #Address 0xef8 Write value 0x1b4fe841
    li x3, 0x1b4fe841
    csrw 0xef8, x3

    #Unmapped address 0x9d8 testing: random write/read operations
    #Address 0x9d8 Write value 0xda9128c2
    li x3, 0xda9128c2
    csrw 0x9d8, x3

    #Address 0x9d8 Write value 0x41f80395
    li x3, 0x41f80395
    csrw 0x9d8, x3

    #Address 0x9d8 read value
    csrr x14, 0x9d8

    #Address 0x9d8 Write value 0x71af6d4a
    li x3, 0x71af6d4a
    csrw 0x9d8, x3

    #Unmapped address 0x98 testing: random write/read operations
    #Address 0x98 read value
    csrr x14, 0x98

    #Address 0x98 Write value 0xa7301ba8
    li x3, 0xa7301ba8
    csrw 0x98, x3

    #Address 0x98 read value
    csrr x14, 0x98

    #Address 0x98 read value
    csrr x14, 0x98

    #Unmapped address 0x9c4 testing: random write/read operations
    #Address 0x9c4 read value
    csrr x14, 0x9c4

    #Address 0x9c4 read value
    csrr x14, 0x9c4

    #Address 0x9c4 read value
    csrr x14, 0x9c4

    #Address 0x9c4 read value
    csrr x14, 0x9c4

    #Unmapped address 0xcb8 testing: random write/read operations
    #Address 0xcb8 Write value 0x269d3861
    li x3, 0x269d3861
    csrw 0xcb8, x3

    #Address 0xcb8 read value
    csrr x14, 0xcb8

    #Unmapped address 0x687 testing: random write/read operations
    #Address 0x687 read value
    csrr x14, 0x687

    #Address 0x687 Write value 0xeef62b3
    li x3, 0xeef62b3
    csrw 0x687, x3

    #Address 0x687 read value
    csrr x14, 0x687

    #Address 0x687 read value
    csrr x14, 0x687

    #Address 0x687 Write value 0xbec91e3a
    li x3, 0xbec91e3a
    csrw 0x687, x3

    #Unmapped address 0xb2f testing: random write/read operations
    #Address 0xb2f read value
    csrr x14, 0xb2f

    #Address 0xb2f read value
    csrr x14, 0xb2f

    #Address 0xb2f read value
    csrr x14, 0xb2f

    #Address 0xb2f read value
    csrr x14, 0xb2f

    #Address 0xb2f read value
    csrr x14, 0xb2f

    #Unmapped address 0xdc8 testing: random write/read operations
    #Address 0xdc8 read value
    csrr x14, 0xdc8

    #Address 0xdc8 read value
    csrr x14, 0xdc8

    #Address 0xdc8 read value
    csrr x14, 0xdc8

    #Address 0xdc8 read value
    csrr x14, 0xdc8

    #Unmapped address 0xa70 testing: random write/read operations
    #Address 0xa70 Write value 0xcdc98521
    li x3, 0xcdc98521
    csrw 0xa70, x3

    #Address 0xa70 read value
    csrr x14, 0xa70

    #Unmapped address 0x70d testing: random write/read operations
    #Address 0x70d read value
    csrr x14, 0x70d

    #Address 0x70d read value
    csrr x14, 0x70d

    #Address 0x70d Write value 0xdac9d180
    li x3, 0xdac9d180
    csrw 0x70d, x3

    #Unmapped address 0x86c testing: random write/read operations
    #Address 0x86c read value
    csrr x14, 0x86c

    #Address 0x86c Write value 0xf4e1a284
    li x3, 0xf4e1a284
    csrw 0x86c, x3

    #Address 0x86c Write value 0x1e5b593f
    li x3, 0x1e5b593f
    csrw 0x86c, x3

    #Address 0x86c Write value 0xb05a665e
    li x3, 0xb05a665e
    csrw 0x86c, x3

    #Unmapped address 0xa61 testing: random write/read operations
    #Address 0xa61 read value
    csrr x14, 0xa61

    #Address 0xa61 read value
    csrr x14, 0xa61

    #Address 0xa61 read value
    csrr x14, 0xa61

    #Address 0xa61 Write value 0x1b135a94
    li x3, 0x1b135a94
    csrw 0xa61, x3

    #Unmapped address 0xe78 testing: random write/read operations
    #Address 0xe78 read value
    csrr x14, 0xe78

    #Address 0xe78 Write value 0xb0b31010
    li x3, 0xb0b31010
    csrw 0xe78, x3

    #Address 0xe78 read value
    csrr x14, 0xe78

    #Unmapped address 0xa7b testing: random write/read operations
    #Address 0xa7b Write value 0x36929fbf
    li x3, 0x36929fbf
    csrw 0xa7b, x3

    #Address 0xa7b read value
    csrr x14, 0xa7b

    #Unmapped address 0x20d testing: random write/read operations
    #Address 0x20d Write value 0x9af005db
    li x3, 0x9af005db
    csrw 0x20d, x3

    #Address 0x20d read value
    csrr x14, 0x20d

    #Address 0x20d read value
    csrr x14, 0x20d

    #Address 0x20d read value
    csrr x14, 0x20d

    #Unmapped address 0xaf5 testing: random write/read operations
    #Address 0xaf5 read value
    csrr x14, 0xaf5

    #Address 0xaf5 Write value 0x5a841a43
    li x3, 0x5a841a43
    csrw 0xaf5, x3

    #Unmapped address 0xda4 testing: random write/read operations
    #Address 0xda4 Write value 0x7eb28612
    li x3, 0x7eb28612
    csrw 0xda4, x3

    #Address 0xda4 read value
    csrr x14, 0xda4

    #Address 0xda4 Write value 0x627f1051
    li x3, 0x627f1051
    csrw 0xda4, x3

    #Address 0xda4 read value
    csrr x14, 0xda4

    #Address 0xda4 read value
    csrr x14, 0xda4

    #Unmapped address 0x5dc testing: random write/read operations
    #Address 0x5dc read value
    csrr x14, 0x5dc

    #Address 0x5dc read value
    csrr x14, 0x5dc

    #Address 0x5dc read value
    csrr x14, 0x5dc

    #Address 0x5dc read value
    csrr x14, 0x5dc

    #Address 0x5dc read value
    csrr x14, 0x5dc

    #Unmapped address 0xfb3 testing: random write/read operations
    #Address 0xfb3 Write value 0x67e7284d
    li x3, 0x67e7284d
    csrw 0xfb3, x3

    #Address 0xfb3 read value
    csrr x14, 0xfb3

    #Address 0xfb3 read value
    csrr x14, 0xfb3

    #Address 0xfb3 Write value 0x2c6fe08e
    li x3, 0x2c6fe08e
    csrw 0xfb3, x3

    #Unmapped address 0x780 testing: random write/read operations
    #Address 0x780 read value
    csrr x14, 0x780

    #Unmapped address 0x2f9 testing: random write/read operations
    #Address 0x2f9 read value
    csrr x14, 0x2f9

    #Address 0x2f9 Write value 0x98e98bf3
    li x3, 0x98e98bf3
    csrw 0x2f9, x3

    #Unmapped address 0x253 testing: random write/read operations
    #Address 0x253 Write value 0x99b8b192
    li x3, 0x99b8b192
    csrw 0x253, x3

    #Address 0x253 Write value 0x846d4872
    li x3, 0x846d4872
    csrw 0x253, x3

    #Address 0x253 read value
    csrr x14, 0x253

    #Address 0x253 read value
    csrr x14, 0x253

    #Address 0x253 read value
    csrr x14, 0x253

    #Unmapped address 0xa71 testing: random write/read operations
    #Address 0xa71 Write value 0x85a8b0ac
    li x3, 0x85a8b0ac
    csrw 0xa71, x3

    #Address 0xa71 Write value 0xbe8ca4c5
    li x3, 0xbe8ca4c5
    csrw 0xa71, x3

    #Unmapped address 0xb testing: random write/read operations
    #Address 0xb read value
    csrr x14, 0xb

    #Address 0xb read value
    csrr x14, 0xb

    #Unmapped address 0x76d testing: random write/read operations
    #Address 0x76d read value
    csrr x14, 0x76d

    #Address 0x76d Write value 0x8d539907
    li x3, 0x8d539907
    csrw 0x76d, x3

    #Unmapped address 0x727 testing: random write/read operations
    #Address 0x727 read value
    csrr x14, 0x727

    #Unmapped address 0x4d4 testing: random write/read operations
    #Address 0x4d4 Write value 0xac0f0f1e
    li x3, 0xac0f0f1e
    csrw 0x4d4, x3

    #Unmapped address 0x95d testing: random write/read operations
    #Address 0x95d Write value 0x27a34aae
    li x3, 0x27a34aae
    csrw 0x95d, x3

    #Address 0x95d Write value 0xbd3707a5
    li x3, 0xbd3707a5
    csrw 0x95d, x3

    #Address 0x95d read value
    csrr x14, 0x95d

    #Address 0x95d read value
    csrr x14, 0x95d

    #Address 0x95d Write value 0x84fb7ea6
    li x3, 0x84fb7ea6
    csrw 0x95d, x3

    #Unmapped address 0x4d8 testing: random write/read operations
    #Address 0x4d8 read value
    csrr x14, 0x4d8

    #Address 0x4d8 Write value 0x4077ae7
    li x3, 0x4077ae7
    csrw 0x4d8, x3

    #Address 0x4d8 read value
    csrr x14, 0x4d8

    #Unmapped address 0xc61 testing: random write/read operations
    #Address 0xc61 read value
    csrr x14, 0xc61

    #Address 0xc61 Write value 0xc75b533b
    li x3, 0xc75b533b
    csrw 0xc61, x3

    #Address 0xc61 read value
    csrr x14, 0xc61

    #Address 0xc61 read value
    csrr x14, 0xc61

    #Unmapped address 0xeb7 testing: random write/read operations
    #Address 0xeb7 read value
    csrr x14, 0xeb7

    #Address 0xeb7 Write value 0xc607a3c3
    li x3, 0xc607a3c3
    csrw 0xeb7, x3

    #Unmapped address 0x70 testing: random write/read operations
    #Address 0x70 read value
    csrr x14, 0x70

    #Address 0x70 Write value 0xe3c5104c
    li x3, 0xe3c5104c
    csrw 0x70, x3

    #Address 0x70 Write value 0x1d71109e
    li x3, 0x1d71109e
    csrw 0x70, x3

    #Address 0x70 Write value 0x3c925adc
    li x3, 0x3c925adc
    csrw 0x70, x3

    #Address 0x70 Write value 0x1d5afc3d
    li x3, 0x1d5afc3d
    csrw 0x70, x3

    #Unmapped address 0x1d1 testing: random write/read operations
    #Address 0x1d1 read value
    csrr x14, 0x1d1

    #Address 0x1d1 Write value 0x6684b0c9
    li x3, 0x6684b0c9
    csrw 0x1d1, x3

    #Address 0x1d1 read value
    csrr x14, 0x1d1

    #Unmapped address 0xe53 testing: random write/read operations
    #Address 0xe53 read value
    csrr x14, 0xe53

    #Address 0xe53 read value
    csrr x14, 0xe53

    #Address 0xe53 read value
    csrr x14, 0xe53

    #Unmapped address 0x6a3 testing: random write/read operations
    #Address 0x6a3 Write value 0xf51faa87
    li x3, 0xf51faa87
    csrw 0x6a3, x3

    #Address 0x6a3 Write value 0x6fef1bfc
    li x3, 0x6fef1bfc
    csrw 0x6a3, x3

    #Address 0x6a3 Write value 0xbe18a5aa
    li x3, 0xbe18a5aa
    csrw 0x6a3, x3

    #Address 0x6a3 Write value 0xec3c28e3
    li x3, 0xec3c28e3
    csrw 0x6a3, x3

    #Address 0x6a3 Write value 0xcd5d4d00
    li x3, 0xcd5d4d00
    csrw 0x6a3, x3

    #Unmapped address 0xe8b testing: random write/read operations
    #Address 0xe8b read value
    csrr x14, 0xe8b

    #Address 0xe8b Write value 0xc6a97afe
    li x3, 0xc6a97afe
    csrw 0xe8b, x3

    #Address 0xe8b read value
    csrr x14, 0xe8b

    #Unmapped address 0xf5 testing: random write/read operations
    #Address 0xf5 Write value 0x27df47c4
    li x3, 0x27df47c4
    csrw 0xf5, x3

    #Address 0xf5 read value
    csrr x14, 0xf5

    #Address 0xf5 Write value 0x21a18a60
    li x3, 0x21a18a60
    csrw 0xf5, x3

    #Address 0xf5 read value
    csrr x14, 0xf5

    #Address 0xf5 read value
    csrr x14, 0xf5

    #Unmapped address 0x2f testing: random write/read operations
    #Address 0x2f Write value 0x354ea424
    li x3, 0x354ea424
    csrw 0x2f, x3

    #Address 0x2f Write value 0x62b33092
    li x3, 0x62b33092
    csrw 0x2f, x3

    #Unmapped address 0x1e testing: random write/read operations
    #Address 0x1e read value
    csrr x14, 0x1e

    #Address 0x1e Write value 0xb32ef25f
    li x3, 0xb32ef25f
    csrw 0x1e, x3

    #Unmapped address 0xb39 testing: random write/read operations
    #Address 0xb39 read value
    csrr x14, 0xb39

    #Address 0xb39 Write value 0x7423aafe
    li x3, 0x7423aafe
    csrw 0xb39, x3

    #Address 0xb39 read value
    csrr x14, 0xb39

    #Address 0xb39 Write value 0x9b42e686
    li x3, 0x9b42e686
    csrw 0xb39, x3

    #Address 0xb39 read value
    csrr x14, 0xb39

    #Unmapped address 0xa16 testing: random write/read operations
    #Address 0xa16 read value
    csrr x14, 0xa16

    #Unmapped address 0x9f7 testing: random write/read operations
    #Address 0x9f7 read value
    csrr x14, 0x9f7

    #Address 0x9f7 read value
    csrr x14, 0x9f7

    #Address 0x9f7 Write value 0x4bc522d1
    li x3, 0x4bc522d1
    csrw 0x9f7, x3

    #Address 0x9f7 Write value 0x71d6a6e2
    li x3, 0x71d6a6e2
    csrw 0x9f7, x3

    #Unmapped address 0xee4 testing: random write/read operations
    #Address 0xee4 read value
    csrr x14, 0xee4

    #Address 0xee4 Write value 0x3b72c19d
    li x3, 0x3b72c19d
    csrw 0xee4, x3

    #Address 0xee4 read value
    csrr x14, 0xee4

    #Address 0xee4 read value
    csrr x14, 0xee4

    #Unmapped address 0xec testing: random write/read operations
    #Address 0xec Write value 0x3b107d7
    li x3, 0x3b107d7
    csrw 0xec, x3

    #Unmapped address 0x2ac testing: random write/read operations
    #Address 0x2ac read value
    csrr x14, 0x2ac

    #Address 0x2ac Write value 0x67abccd2
    li x3, 0x67abccd2
    csrw 0x2ac, x3

    #Address 0x2ac Write value 0x21bc5dc2
    li x3, 0x21bc5dc2
    csrw 0x2ac, x3

    #Address 0x2ac Write value 0xda8506d2
    li x3, 0xda8506d2
    csrw 0x2ac, x3

    #Address 0x2ac Write value 0xe78f59a4
    li x3, 0xe78f59a4
    csrw 0x2ac, x3

    #Unmapped address 0x5db testing: random write/read operations
    #Address 0x5db read value
    csrr x14, 0x5db

    #Address 0x5db Write value 0x28269a80
    li x3, 0x28269a80
    csrw 0x5db, x3

    #Address 0x5db Write value 0xb378088b
    li x3, 0xb378088b
    csrw 0x5db, x3

    #Unmapped address 0xa1b testing: random write/read operations
    #Address 0xa1b Write value 0xd5aed544
    li x3, 0xd5aed544
    csrw 0xa1b, x3

    #Address 0xa1b Write value 0x6de4352d
    li x3, 0x6de4352d
    csrw 0xa1b, x3

    #Unmapped address 0xac testing: random write/read operations
    #Address 0xac read value
    csrr x14, 0xac

    #Address 0xac read value
    csrr x14, 0xac

    #Unmapped address 0x5a6 testing: random write/read operations
    #Address 0x5a6 Write value 0x94757bd7
    li x3, 0x94757bd7
    csrw 0x5a6, x3

    #Address 0x5a6 read value
    csrr x14, 0x5a6

    #Address 0x5a6 read value
    csrr x14, 0x5a6

    #Address 0x5a6 read value
    csrr x14, 0x5a6

    #Address 0x5a6 Write value 0x1983d3fa
    li x3, 0x1983d3fa
    csrw 0x5a6, x3

    #Unmapped address 0x5c6 testing: random write/read operations
    #Address 0x5c6 Write value 0xf0ee3880
    li x3, 0xf0ee3880
    csrw 0x5c6, x3

    #Unmapped address 0xb7b testing: random write/read operations
    #Address 0xb7b Write value 0x1c0d0204
    li x3, 0x1c0d0204
    csrw 0xb7b, x3

    #Address 0xb7b Write value 0xfd7eff8f
    li x3, 0xfd7eff8f
    csrw 0xb7b, x3

    #Address 0xb7b Write value 0x35522953
    li x3, 0x35522953
    csrw 0xb7b, x3

    #Address 0xb7b Write value 0xda0da62f
    li x3, 0xda0da62f
    csrw 0xb7b, x3

    #Address 0xb7b Write value 0x9f200e38
    li x3, 0x9f200e38
    csrw 0xb7b, x3

    #Unmapped address 0x571 testing: random write/read operations
    #Address 0x571 Write value 0xb35432f0
    li x3, 0xb35432f0
    csrw 0x571, x3

    #Address 0x571 Write value 0x9d7b3c42
    li x3, 0x9d7b3c42
    csrw 0x571, x3

    #Unmapped address 0xe8 testing: random write/read operations
    #Address 0xe8 Write value 0x61026b2d
    li x3, 0x61026b2d
    csrw 0xe8, x3

    #Address 0xe8 read value
    csrr x14, 0xe8

    #Address 0xe8 Write value 0x6e3d9c7f
    li x3, 0x6e3d9c7f
    csrw 0xe8, x3

    #Address 0xe8 read value
    csrr x14, 0xe8

    #Unmapped address 0xc6c testing: random write/read operations
    #Address 0xc6c read value
    csrr x14, 0xc6c

    #Unmapped address 0x3ff testing: random write/read operations
    #Address 0x3ff Write value 0x6c486dbc
    li x3, 0x6c486dbc
    csrw 0x3ff, x3

    #Address 0x3ff read value
    csrr x14, 0x3ff

    #Unmapped address 0xe1f testing: random write/read operations
    #Address 0xe1f Write value 0x12de05aa
    li x3, 0x12de05aa
    csrw 0xe1f, x3

    #Address 0xe1f Write value 0xb7134f28
    li x3, 0xb7134f28
    csrw 0xe1f, x3

    #Address 0xe1f Write value 0xf061d2ac
    li x3, 0xf061d2ac
    csrw 0xe1f, x3

    #Unmapped address 0xf90 testing: random write/read operations
    #Address 0xf90 Write value 0x9179d725
    li x3, 0x9179d725
    csrw 0xf90, x3

    #Unmapped address 0x5e8 testing: random write/read operations
    #Address 0x5e8 Write value 0x3cbff313
    li x3, 0x3cbff313
    csrw 0x5e8, x3

    #Address 0x5e8 Write value 0x8334f189
    li x3, 0x8334f189
    csrw 0x5e8, x3

    #Address 0x5e8 Write value 0x5bce6657
    li x3, 0x5bce6657
    csrw 0x5e8, x3

    #Unmapped address 0xed6 testing: random write/read operations
    #Address 0xed6 Write value 0x5e8dff63
    li x3, 0x5e8dff63
    csrw 0xed6, x3

    #Address 0xed6 Write value 0x88ad0fc1
    li x3, 0x88ad0fc1
    csrw 0xed6, x3

    #Address 0xed6 Write value 0xbdc6ebcd
    li x3, 0xbdc6ebcd
    csrw 0xed6, x3

    #Address 0xed6 Write value 0x58a1f5f
    li x3, 0x58a1f5f
    csrw 0xed6, x3

    #Address 0xed6 read value
    csrr x14, 0xed6

    #Unmapped address 0x5b4 testing: random write/read operations
    #Address 0x5b4 Write value 0x2e1357f9
    li x3, 0x2e1357f9
    csrw 0x5b4, x3

    #Address 0x5b4 Write value 0x169294a
    li x3, 0x169294a
    csrw 0x5b4, x3

    #Unmapped address 0x4e8 testing: random write/read operations
    #Address 0x4e8 read value
    csrr x14, 0x4e8

    #Unmapped address 0xf3c testing: random write/read operations
    #Address 0xf3c read value
    csrr x14, 0xf3c

    #Address 0xf3c read value
    csrr x14, 0xf3c

    #Address 0xf3c Write value 0x46a1edb5
    li x3, 0x46a1edb5
    csrw 0xf3c, x3

    #Address 0xf3c Write value 0x45cec79c
    li x3, 0x45cec79c
    csrw 0xf3c, x3

    #Address 0xf3c read value
    csrr x14, 0xf3c

    #Unmapped address 0xb5a testing: random write/read operations
    #Address 0xb5a read value
    csrr x14, 0xb5a

    #Address 0xb5a read value
    csrr x14, 0xb5a

    #Address 0xb5a read value
    csrr x14, 0xb5a

    #Unmapped address 0x1d7 testing: random write/read operations
    #Address 0x1d7 Write value 0x69699b
    li x3, 0x69699b
    csrw 0x1d7, x3

    #Address 0x1d7 Write value 0x8069418
    li x3, 0x8069418
    csrw 0x1d7, x3

    #Address 0x1d7 Write value 0x6fdbffef
    li x3, 0x6fdbffef
    csrw 0x1d7, x3

    #Address 0x1d7 Write value 0x6c91e989
    li x3, 0x6c91e989
    csrw 0x1d7, x3

    #Address 0x1d7 read value
    csrr x14, 0x1d7

    #Unmapped address 0x28 testing: random write/read operations
    #Address 0x28 read value
    csrr x14, 0x28

    #Address 0x28 read value
    csrr x14, 0x28

    #Address 0x28 read value
    csrr x14, 0x28

    #Unmapped address 0xc20 testing: random write/read operations
    #Address 0xc20 Write value 0xf24d1a72
    li x3, 0xf24d1a72
    csrw 0xc20, x3

    #Address 0xc20 Write value 0xf30f98b3
    li x3, 0xf30f98b3
    csrw 0xc20, x3

    #Unmapped address 0x171 testing: random write/read operations
    #Address 0x171 read value
    csrr x14, 0x171

    #Address 0x171 Write value 0xbe1716d6
    li x3, 0xbe1716d6
    csrw 0x171, x3

    #Address 0x171 Write value 0xf3cbcb6e
    li x3, 0xf3cbcb6e
    csrw 0x171, x3

    #Address 0x171 Write value 0xfcc25f8
    li x3, 0xfcc25f8
    csrw 0x171, x3

    #Address 0x171 read value
    csrr x14, 0x171

    #Unmapped address 0x8e5 testing: random write/read operations
    #Address 0x8e5 Write value 0x828e5284
    li x3, 0x828e5284
    csrw 0x8e5, x3

    #Address 0x8e5 read value
    csrr x14, 0x8e5

    #Unmapped address 0xc83 testing: random write/read operations
    #Address 0xc83 Write value 0x6aef4ecd
    li x3, 0x6aef4ecd
    csrw 0xc83, x3

    #Unmapped address 0xaea testing: random write/read operations
    #Address 0xaea Write value 0x73fe2757
    li x3, 0x73fe2757
    csrw 0xaea, x3

    #Address 0xaea read value
    csrr x14, 0xaea

    #Address 0xaea read value
    csrr x14, 0xaea

    #Address 0xaea Write value 0x2540dade
    li x3, 0x2540dade
    csrw 0xaea, x3

    #Unmapped address 0x2af testing: random write/read operations
    #Address 0x2af read value
    csrr x14, 0x2af

    #Address 0x2af read value
    csrr x14, 0x2af

    #Address 0x2af read value
    csrr x14, 0x2af

    #Address 0x2af read value
    csrr x14, 0x2af

    #Unmapped address 0xec3 testing: random write/read operations
    #Address 0xec3 read value
    csrr x14, 0xec3

    #Address 0xec3 read value
    csrr x14, 0xec3

    #Address 0xec3 Write value 0x70e7d07d
    li x3, 0x70e7d07d
    csrw 0xec3, x3

    #Address 0xec3 Write value 0x4315e921
    li x3, 0x4315e921
    csrw 0xec3, x3

    #Unmapped address 0x5b6 testing: random write/read operations
    #Address 0x5b6 read value
    csrr x14, 0x5b6

    #Address 0x5b6 read value
    csrr x14, 0x5b6

    #Unmapped address 0x963 testing: random write/read operations
    #Address 0x963 read value
    csrr x14, 0x963

    #Address 0x963 Write value 0x2ddc04ce
    li x3, 0x2ddc04ce
    csrw 0x963, x3

    #Address 0x963 Write value 0x10192304
    li x3, 0x10192304
    csrw 0x963, x3

    #Address 0x963 Write value 0x3f885824
    li x3, 0x3f885824
    csrw 0x963, x3

    #Address 0x963 Write value 0xb29d96da
    li x3, 0xb29d96da
    csrw 0x963, x3

    #Mapped address 0x301 (misa) testing: random write/read operations
    #Address 0x301 Write value 0x5f5bb542
    li x3, 0x5f5bb542
    csrw 0x301, x3

    #Unmapped address 0x802 testing: random write/read operations
    #Address 0x802 Write value 0x476ad8ee
    li x3, 0x476ad8ee
    csrw 0x802, x3

    #Address 0x802 Write value 0xd0a54902
    li x3, 0xd0a54902
    csrw 0x802, x3

    #Address 0x802 read value
    csrr x14, 0x802

    #Address 0x802 read value
    csrr x14, 0x802

    #Address 0x802 read value
    csrr x14, 0x802

    #Unmapped address 0xc15 testing: random write/read operations
    #Address 0xc15 Write value 0xb84db024
    li x3, 0xb84db024
    csrw 0xc15, x3

    #Address 0xc15 read value
    csrr x14, 0xc15

    #Address 0xc15 Write value 0x492af982
    li x3, 0x492af982
    csrw 0xc15, x3

    #Address 0xc15 Write value 0xc440630
    li x3, 0xc440630
    csrw 0xc15, x3

    #Address 0xc15 Write value 0xb093cf44
    li x3, 0xb093cf44
    csrw 0xc15, x3

    #Unmapped address 0xc59 testing: random write/read operations
    #Address 0xc59 Write value 0xdc283707
    li x3, 0xdc283707
    csrw 0xc59, x3

    #Address 0xc59 Write value 0x700058d7
    li x3, 0x700058d7
    csrw 0xc59, x3

    #Address 0xc59 read value
    csrr x14, 0xc59

    #Unmapped address 0xbf7 testing: random write/read operations
    #Address 0xbf7 read value
    csrr x14, 0xbf7

    #Address 0xbf7 Write value 0xb386c8f1
    li x3, 0xb386c8f1
    csrw 0xbf7, x3

    #Mapped address 0x304 (mie) testing: random write/read operations
    #Address 0x304 Write value 0xb27cbd39
    li x3, 0xb27cbd39
    csrw 0x304, x3

    #Address 0x304 Write value 0xe1b73fb5
    li x3, 0xe1b73fb5
    csrw 0x304, x3

    #Address 0x304 Write value 0xcbfea4a8
    li x3, 0xcbfea4a8
    csrw 0x304, x3

    #Address 0x304 Write value 0xe3d38c36
    li x3, 0xe3d38c36
    csrw 0x304, x3

    #Unmapped address 0x366 testing: random write/read operations
    #Address 0x366 Write value 0x291e47ce
    li x3, 0x291e47ce
    csrw 0x366, x3

    #Address 0x366 read value
    csrr x14, 0x366

    #Address 0x366 Write value 0x4cd1758a
    li x3, 0x4cd1758a
    csrw 0x366, x3

    #Mapped address 0xc82 (instreth) testing: random write/read operations
    #Address 0xc82 Write value 0x184954e2
    li x3, 0x184954e2
    csrw 0xc82, x3

    #Address 0xc82 read value
    csrr x14, 0xc82

    #Address 0xc82 read value
    csrr x14, 0xc82

    #Unmapped address 0xcb0 testing: random write/read operations
    #Address 0xcb0 read value
    csrr x14, 0xcb0

    #Address 0xcb0 read value
    csrr x14, 0xcb0

    #Address 0xcb0 Write value 0xa1427683
    li x3, 0xa1427683
    csrw 0xcb0, x3

    #Address 0xcb0 Write value 0xa6fbe114
    li x3, 0xa6fbe114
    csrw 0xcb0, x3

    #Address 0xcb0 read value
    csrr x14, 0xcb0

    #Unmapped address 0xc38 testing: random write/read operations
    #Address 0xc38 read value
    csrr x14, 0xc38

    #Address 0xc38 Write value 0x1cfc65b4
    li x3, 0x1cfc65b4
    csrw 0xc38, x3

    #Address 0xc38 Write value 0x32d1b961
    li x3, 0x32d1b961
    csrw 0xc38, x3

    #Address 0xc38 read value
    csrr x14, 0xc38

    #Unmapped address 0xee6 testing: random write/read operations
    #Address 0xee6 read value
    csrr x14, 0xee6

    #Address 0xee6 Write value 0xcc223396
    li x3, 0xcc223396
    csrw 0xee6, x3

    #Unmapped address 0xfbd testing: random write/read operations
    #Address 0xfbd Write value 0xbb6da6ad
    li x3, 0xbb6da6ad
    csrw 0xfbd, x3

    #Address 0xfbd Write value 0x92c47605
    li x3, 0x92c47605
    csrw 0xfbd, x3

    #Address 0xfbd read value
    csrr x14, 0xfbd

    #Address 0xfbd read value
    csrr x14, 0xfbd

    #Unmapped address 0x569 testing: random write/read operations
    #Address 0x569 read value
    csrr x14, 0x569

    #Address 0x569 Write value 0x93fae6ea
    li x3, 0x93fae6ea
    csrw 0x569, x3

    #Mapped address 0xb1a (mhpmcounter26) testing: random write/read operations
    #Address 0xb1a read value
    csrr x14, 0xb1a

    #Address 0xb1a Write value 0x6efe4d1e
    li x3, 0x6efe4d1e
    csrw 0xb1a, x3

    #Address 0xb1a read value
    csrr x14, 0xb1a

    #Address 0xb1a read value
    csrr x14, 0xb1a

    #Unmapped address 0xbb3 testing: random write/read operations
    #Address 0xbb3 Write value 0xda4c665a
    li x3, 0xda4c665a
    csrw 0xbb3, x3

    #Address 0xbb3 read value
    csrr x14, 0xbb3

    #Unmapped address 0xef0 testing: random write/read operations
    #Address 0xef0 read value
    csrr x14, 0xef0

    #Unmapped address 0x2c2 testing: random write/read operations
    #Address 0x2c2 Write value 0xb4d8ec4f
    li x3, 0xb4d8ec4f
    csrw 0x2c2, x3

    #Address 0x2c2 read value
    csrr x14, 0x2c2

    #Unmapped address 0xbbd testing: random write/read operations
    #Address 0xbbd Write value 0x3c495d9d
    li x3, 0x3c495d9d
    csrw 0xbbd, x3

    #Unmapped address 0x2e6 testing: random write/read operations
    #Address 0x2e6 read value
    csrr x14, 0x2e6

    #Address 0x2e6 Write value 0x29da7935
    li x3, 0x29da7935
    csrw 0x2e6, x3

    #Address 0x2e6 Write value 0x54c0155a
    li x3, 0x54c0155a
    csrw 0x2e6, x3

    #Unmapped address 0xbfe testing: random write/read operations
    #Address 0xbfe read value
    csrr x14, 0xbfe

    #Address 0xbfe Write value 0x4a61d387
    li x3, 0x4a61d387
    csrw 0xbfe, x3

    #Unmapped address 0xb74 testing: random write/read operations
    #Address 0xb74 Write value 0x9a1df8ae
    li x3, 0x9a1df8ae
    csrw 0xb74, x3

    #Unmapped address 0x67e testing: random write/read operations
    #Address 0x67e read value
    csrr x14, 0x67e

    #Address 0x67e Write value 0x228469ff
    li x3, 0x228469ff
    csrw 0x67e, x3

    #Address 0x67e Write value 0xdafae6c6
    li x3, 0xdafae6c6
    csrw 0x67e, x3

    #Unmapped address 0x97f testing: random write/read operations
    #Address 0x97f read value
    csrr x14, 0x97f

    #Unmapped address 0xcee testing: random write/read operations
    #Address 0xcee read value
    csrr x14, 0xcee

    #Address 0xcee Write value 0x6b8027a1
    li x3, 0x6b8027a1
    csrw 0xcee, x3

    #Address 0xcee Write value 0x42271b00
    li x3, 0x42271b00
    csrw 0xcee, x3

    #Unmapped address 0x440 testing: random write/read operations
    #Address 0x440 read value
    csrr x14, 0x440

    #Address 0x440 Write value 0xef41cd7e
    li x3, 0xef41cd7e
    csrw 0x440, x3

    #Unmapped address 0x14b testing: random write/read operations
    #Address 0x14b Write value 0x9ac27ecd
    li x3, 0x9ac27ecd
    csrw 0x14b, x3

    #Unmapped address 0x204 testing: random write/read operations
    #Address 0x204 Write value 0x83c4e40c
    li x3, 0x83c4e40c
    csrw 0x204, x3

    #Address 0x204 Write value 0x3d7da220
    li x3, 0x3d7da220
    csrw 0x204, x3

    #Address 0x204 Write value 0x3bfabe4c
    li x3, 0x3bfabe4c
    csrw 0x204, x3

    #Unmapped address 0xe24 testing: random write/read operations
    #Address 0xe24 Write value 0x2d27a3f1
    li x3, 0x2d27a3f1
    csrw 0xe24, x3

    #Address 0xe24 Write value 0xb36c4d75
    li x3, 0xb36c4d75
    csrw 0xe24, x3

    #Address 0xe24 Write value 0xc0e937df
    li x3, 0xc0e937df
    csrw 0xe24, x3

    #Address 0xe24 read value
    csrr x14, 0xe24

    #Address 0xe24 Write value 0x560c8cfa
    li x3, 0x560c8cfa
    csrw 0xe24, x3

    #Unmapped address 0x986 testing: random write/read operations
    #Address 0x986 Write value 0x810bc4a4
    li x3, 0x810bc4a4
    csrw 0x986, x3

    #Address 0x986 read value
    csrr x14, 0x986

    #Address 0x986 read value
    csrr x14, 0x986

    #Address 0x986 read value
    csrr x14, 0x986

    #Address 0x986 read value
    csrr x14, 0x986

    #Unmapped address 0x24d testing: random write/read operations
    #Address 0x24d Write value 0x28420aba
    li x3, 0x28420aba
    csrw 0x24d, x3

    #Address 0x24d Write value 0xed68b879
    li x3, 0xed68b879
    csrw 0x24d, x3

    #Address 0x24d Write value 0x8a71824e
    li x3, 0x8a71824e
    csrw 0x24d, x3

    #Address 0x24d read value
    csrr x14, 0x24d

    #Unmapped address 0xf9 testing: random write/read operations
    #Address 0xf9 read value
    csrr x14, 0xf9

    #Address 0xf9 read value
    csrr x14, 0xf9

    #Address 0xf9 read value
    csrr x14, 0xf9

    #Address 0xf9 read value
    csrr x14, 0xf9

    #Unmapped address 0x596 testing: random write/read operations
    #Address 0x596 Write value 0x2615893b
    li x3, 0x2615893b
    csrw 0x596, x3

    #Address 0x596 Write value 0x3c559c76
    li x3, 0x3c559c76
    csrw 0x596, x3

    #Address 0x596 Write value 0x1faba5ed
    li x3, 0x1faba5ed
    csrw 0x596, x3

    #Address 0x596 Write value 0xf6ef8fd9
    li x3, 0xf6ef8fd9
    csrw 0x596, x3

    #Address 0x596 Write value 0x6aaff0c5
    li x3, 0x6aaff0c5
    csrw 0x596, x3

    #Unmapped address 0xc76 testing: random write/read operations
    #Address 0xc76 Write value 0x855315fd
    li x3, 0x855315fd
    csrw 0xc76, x3

    #Address 0xc76 read value
    csrr x14, 0xc76

    #Address 0xc76 read value
    csrr x14, 0xc76

    #Unmapped address 0x7d2 testing: random write/read operations
    #Address 0x7d2 Write value 0x1095caf3
    li x3, 0x1095caf3
    csrw 0x7d2, x3

    #Address 0x7d2 Write value 0xae570328
    li x3, 0xae570328
    csrw 0x7d2, x3

    #Address 0x7d2 read value
    csrr x14, 0x7d2

    #Address 0x7d2 Write value 0xf9c2b265
    li x3, 0xf9c2b265
    csrw 0x7d2, x3

    #Mapped address 0x33a (mhpmevent26) testing: random write/read operations
    #Address 0x33a Write value 0xee47c4b5
    li x3, 0xee47c4b5
    csrw 0x33a, x3

    #Address 0x33a read value
    csrr x14, 0x33a

    #Address 0x33a read value
    csrr x14, 0x33a

    #Address 0x33a read value
    csrr x14, 0x33a

    #Unmapped address 0x311 testing: random write/read operations
    #Address 0x311 read value
    csrr x14, 0x311

    #Address 0x311 read value
    csrr x14, 0x311

    #Address 0x311 read value
    csrr x14, 0x311

    #Unmapped address 0xe1e testing: random write/read operations
    #Address 0xe1e read value
    csrr x14, 0xe1e

    #Address 0xe1e read value
    csrr x14, 0xe1e

    #Unmapped address 0x7e8 testing: random write/read operations
    #Address 0x7e8 read value
    csrr x14, 0x7e8

    #Address 0x7e8 Write value 0xd6da3603
    li x3, 0xd6da3603
    csrw 0x7e8, x3

    #Address 0x7e8 Write value 0x25aee672
    li x3, 0x25aee672
    csrw 0x7e8, x3

    #Address 0x7e8 Write value 0xdb83315f
    li x3, 0xdb83315f
    csrw 0x7e8, x3

    #Address 0x7e8 Write value 0x9615ed80
    li x3, 0x9615ed80
    csrw 0x7e8, x3

    #Unmapped address 0x782 testing: random write/read operations
    #Address 0x782 read value
    csrr x14, 0x782

    #Address 0x782 read value
    csrr x14, 0x782

    #Address 0x782 read value
    csrr x14, 0x782

    #Address 0x782 Write value 0xc0e7aa35
    li x3, 0xc0e7aa35
    csrw 0x782, x3

    #Address 0x782 Write value 0x2e6d7200
    li x3, 0x2e6d7200
    csrw 0x782, x3

    #Unmapped address 0xb3c testing: random write/read operations
    #Address 0xb3c read value
    csrr x14, 0xb3c

    #Address 0xb3c Write value 0x2bf13bda
    li x3, 0x2bf13bda
    csrw 0xb3c, x3

    #Address 0xb3c Write value 0x428768e9
    li x3, 0x428768e9
    csrw 0xb3c, x3

    #Address 0xb3c Write value 0x98b20ca0
    li x3, 0x98b20ca0
    csrw 0xb3c, x3

    #Address 0xb3c Write value 0xc4bba322
    li x3, 0xc4bba322
    csrw 0xb3c, x3

    #Unmapped address 0xcde testing: random write/read operations
    #Address 0xcde read value
    csrr x14, 0xcde

    #Address 0xcde read value
    csrr x14, 0xcde

    #Unmapped address 0x690 testing: random write/read operations
    #Address 0x690 read value
    csrr x14, 0x690

    #Address 0x690 Write value 0x5bd2cd66
    li x3, 0x5bd2cd66
    csrw 0x690, x3

    #Address 0x690 read value
    csrr x14, 0x690

    #Address 0x690 read value
    csrr x14, 0x690

    #Unmapped address 0xd1f testing: random write/read operations
    #Address 0xd1f Write value 0xa168e7d2
    li x3, 0xa168e7d2
    csrw 0xd1f, x3

    #Address 0xd1f read value
    csrr x14, 0xd1f

    #Unmapped address 0x41c testing: random write/read operations
    #Address 0x41c read value
    csrr x14, 0x41c

    #Unmapped address 0x4be testing: random write/read operations
    #Address 0x4be Write value 0x25e0edfb
    li x3, 0x25e0edfb
    csrw 0x4be, x3

    #Address 0x4be Write value 0x32d2f91
    li x3, 0x32d2f91
    csrw 0x4be, x3

    #Address 0x4be read value
    csrr x14, 0x4be

    #Address 0x4be Write value 0xd351a689
    li x3, 0xd351a689
    csrw 0x4be, x3

    #Unmapped address 0x385 testing: random write/read operations
    #Address 0x385 read value
    csrr x14, 0x385

    #Address 0x385 Write value 0xe6211021
    li x3, 0xe6211021
    csrw 0x385, x3

    #Address 0x385 Write value 0x6e8e61a4
    li x3, 0x6e8e61a4
    csrw 0x385, x3

    #Unmapped address 0xa0c testing: random write/read operations
    #Address 0xa0c read value
    csrr x14, 0xa0c

    #Address 0xa0c read value
    csrr x14, 0xa0c

    #Address 0xa0c Write value 0xc801a802
    li x3, 0xc801a802
    csrw 0xa0c, x3

    #Address 0xa0c Write value 0x94460e78
    li x3, 0x94460e78
    csrw 0xa0c, x3

    #Address 0xa0c Write value 0xb1599686
    li x3, 0xb1599686
    csrw 0xa0c, x3

    #Unmapped address 0x1e3 testing: random write/read operations
    #Address 0x1e3 read value
    csrr x14, 0x1e3

    #Address 0x1e3 read value
    csrr x14, 0x1e3

    #Address 0x1e3 Write value 0xa526d3d3
    li x3, 0xa526d3d3
    csrw 0x1e3, x3

    #Unmapped address 0x1ef testing: random write/read operations
    #Address 0x1ef Write value 0xbffe7c90
    li x3, 0xbffe7c90
    csrw 0x1ef, x3

    #Address 0x1ef Write value 0x54255d4
    li x3, 0x54255d4
    csrw 0x1ef, x3

    #Address 0x1ef read value
    csrr x14, 0x1ef

    #Unmapped address 0xf7e testing: random write/read operations
    #Address 0xf7e read value
    csrr x14, 0xf7e

    #Address 0xf7e read value
    csrr x14, 0xf7e

    #Address 0xf7e read value
    csrr x14, 0xf7e

    #Address 0xf7e Write value 0xca9e26d6
    li x3, 0xca9e26d6
    csrw 0xf7e, x3

    #Address 0xf7e read value
    csrr x14, 0xf7e

    #Unmapped address 0x9af testing: random write/read operations
    #Address 0x9af Write value 0xa23694c2
    li x3, 0xa23694c2
    csrw 0x9af, x3

    #Address 0x9af read value
    csrr x14, 0x9af

    #Address 0x9af read value
    csrr x14, 0x9af

    #Address 0x9af read value
    csrr x14, 0x9af

    #Address 0x9af read value
    csrr x14, 0x9af

    #Unmapped address 0x3f testing: random write/read operations
    #Address 0x3f Write value 0x67a7bd78
    li x3, 0x67a7bd78
    csrw 0x3f, x3

    #Address 0x3f read value
    csrr x14, 0x3f

    #Address 0x3f read value
    csrr x14, 0x3f

    #Address 0x3f read value
    csrr x14, 0x3f

    #Unmapped address 0xd95 testing: random write/read operations
    #Address 0xd95 read value
    csrr x14, 0xd95

    #Unmapped address 0xd88 testing: random write/read operations
    #Address 0xd88 Write value 0xff81e98a
    li x3, 0xff81e98a
    csrw 0xd88, x3

    #Unmapped address 0x166 testing: random write/read operations
    #Address 0x166 read value
    csrr x14, 0x166

    #Address 0x166 read value
    csrr x14, 0x166

    #Address 0x166 Write value 0x73c13047
    li x3, 0x73c13047
    csrw 0x166, x3

    #Address 0x166 Write value 0x23083995
    li x3, 0x23083995
    csrw 0x166, x3

    #Unmapped address 0x82e testing: random write/read operations
    #Address 0x82e read value
    csrr x14, 0x82e

    #Address 0x82e Write value 0x9cab1d4f
    li x3, 0x9cab1d4f
    csrw 0x82e, x3

    #Address 0x82e read value
    csrr x14, 0x82e

    #Address 0x82e Write value 0xea46030d
    li x3, 0xea46030d
    csrw 0x82e, x3

    #Address 0x82e Write value 0xe6f56fa4
    li x3, 0xe6f56fa4
    csrw 0x82e, x3

    #Unmapped address 0xe21 testing: random write/read operations
    #Address 0xe21 read value
    csrr x14, 0xe21

    #Address 0xe21 read value
    csrr x14, 0xe21

    #Address 0xe21 read value
    csrr x14, 0xe21

    #Unmapped address 0x8b0 testing: random write/read operations
    #Address 0x8b0 Write value 0xd9fd759c
    li x3, 0xd9fd759c
    csrw 0x8b0, x3

    #Address 0x8b0 read value
    csrr x14, 0x8b0

    #Unmapped address 0xea5 testing: random write/read operations
    #Address 0xea5 Write value 0x9ca126c4
    li x3, 0x9ca126c4
    csrw 0xea5, x3

    #Unmapped address 0xa52 testing: random write/read operations
    #Address 0xa52 Write value 0xf2a9dd23
    li x3, 0xf2a9dd23
    csrw 0xa52, x3

    #Address 0xa52 read value
    csrr x14, 0xa52

    #Address 0xa52 read value
    csrr x14, 0xa52

    #Address 0xa52 Write value 0xb0545bc0
    li x3, 0xb0545bc0
    csrw 0xa52, x3

    #Unmapped address 0x21e testing: random write/read operations
    #Address 0x21e read value
    csrr x14, 0x21e

    #Address 0x21e Write value 0x64fca09
    li x3, 0x64fca09
    csrw 0x21e, x3

    #Unmapped address 0xe84 testing: random write/read operations
    #Address 0xe84 Write value 0x2dd5005a
    li x3, 0x2dd5005a
    csrw 0xe84, x3

    #Address 0xe84 Write value 0xb686e3e3
    li x3, 0xb686e3e3
    csrw 0xe84, x3

    #Unmapped address 0x75f testing: random write/read operations
    #Address 0x75f read value
    csrr x14, 0x75f

    #Address 0x75f read value
    csrr x14, 0x75f

    #Unmapped address 0x18 testing: random write/read operations
    #Address 0x18 read value
    csrr x14, 0x18

    #Address 0x18 read value
    csrr x14, 0x18

    #Address 0x18 read value
    csrr x14, 0x18

    #Address 0x18 read value
    csrr x14, 0x18

    #Unmapped address 0xa06 testing: random write/read operations
    #Address 0xa06 Write value 0xad3cbfc3
    li x3, 0xad3cbfc3
    csrw 0xa06, x3

    #Address 0xa06 read value
    csrr x14, 0xa06

    #Address 0xa06 read value
    csrr x14, 0xa06

    #Address 0xa06 read value
    csrr x14, 0xa06

    #Address 0xa06 read value
    csrr x14, 0xa06

    #Unmapped address 0xfb8 testing: random write/read operations
    #Address 0xfb8 read value
    csrr x14, 0xfb8

    #Address 0xfb8 read value
    csrr x14, 0xfb8

    #Unmapped address 0xe6a testing: random write/read operations
    #Address 0xe6a read value
    csrr x14, 0xe6a

    #Address 0xe6a Write value 0xcda46b32
    li x3, 0xcda46b32
    csrw 0xe6a, x3

    #Unmapped address 0x39d testing: random write/read operations
    #Address 0x39d Write value 0xc18b1e00
    li x3, 0xc18b1e00
    csrw 0x39d, x3

    #Address 0x39d Write value 0xc5dd94ca
    li x3, 0xc5dd94ca
    csrw 0x39d, x3

    #Unmapped address 0x9f testing: random write/read operations
    #Address 0x9f read value
    csrr x14, 0x9f

    #Address 0x9f Write value 0x27ba2034
    li x3, 0x27ba2034
    csrw 0x9f, x3

    #Unmapped address 0x293 testing: random write/read operations
    #Address 0x293 read value
    csrr x14, 0x293

    #Address 0x293 Write value 0x46a26362
    li x3, 0x46a26362
    csrw 0x293, x3

    #Address 0x293 Write value 0xa88f8d4d
    li x3, 0xa88f8d4d
    csrw 0x293, x3

    #Address 0x293 Write value 0x2d975263
    li x3, 0x2d975263
    csrw 0x293, x3

    #Address 0x293 Write value 0xd859619
    li x3, 0xd859619
    csrw 0x293, x3

    #Unmapped address 0xa26 testing: random write/read operations
    #Address 0xa26 read value
    csrr x14, 0xa26

    #Address 0xa26 read value
    csrr x14, 0xa26

    #Address 0xa26 Write value 0x397566d7
    li x3, 0x397566d7
    csrw 0xa26, x3

    #Address 0xa26 Write value 0x54c7cc42
    li x3, 0x54c7cc42
    csrw 0xa26, x3

    #Unmapped address 0xabf testing: random write/read operations
    #Address 0xabf read value
    csrr x14, 0xabf

    #Address 0xabf Write value 0x8b85e0c8
    li x3, 0x8b85e0c8
    csrw 0xabf, x3

    #Unmapped address 0xb72 testing: random write/read operations
    #Address 0xb72 read value
    csrr x14, 0xb72

    #Address 0xb72 Write value 0x5604c650
    li x3, 0x5604c650
    csrw 0xb72, x3

    #Unmapped address 0x83d testing: random write/read operations
    #Address 0x83d Write value 0xa63aae61
    li x3, 0xa63aae61
    csrw 0x83d, x3

    #Address 0x83d read value
    csrr x14, 0x83d

    #Unmapped address 0xf62 testing: random write/read operations
    #Address 0xf62 Write value 0x2eb78a36
    li x3, 0x2eb78a36
    csrw 0xf62, x3

    #Address 0xf62 read value
    csrr x14, 0xf62

    #Unmapped address 0x2c3 testing: random write/read operations
    #Address 0x2c3 Write value 0xbdef2f5d
    li x3, 0xbdef2f5d
    csrw 0x2c3, x3

    #Unmapped address 0x7a2 testing: random write/read operations
    #Address 0x7a2 read value
    csrr x14, 0x7a2

    #Address 0x7a2 read value
    csrr x14, 0x7a2

    #Address 0x7a2 Write value 0x6acd0393
    li x3, 0x6acd0393
    csrw 0x7a2, x3

    #Address 0x7a2 read value
    csrr x14, 0x7a2

    #Address 0x7a2 read value
    csrr x14, 0x7a2

    #Unmapped address 0xa4e testing: random write/read operations
    #Address 0xa4e read value
    csrr x14, 0xa4e

    #Address 0xa4e read value
    csrr x14, 0xa4e

    #Address 0xa4e read value
    csrr x14, 0xa4e

    #Address 0xa4e read value
    csrr x14, 0xa4e

    #Address 0xa4e read value
    csrr x14, 0xa4e

    #Mapped address 0x332 (mhpmevent18) testing: random write/read operations
    #Address 0x332 Write value 0xa09389cf
    li x3, 0xa09389cf
    csrw 0x332, x3

    #Unmapped address 0x307 testing: random write/read operations
    #Address 0x307 Write value 0x2c8eade3
    li x3, 0x2c8eade3
    csrw 0x307, x3

    #Address 0x307 Write value 0x9fa7cc62
    li x3, 0x9fa7cc62
    csrw 0x307, x3

    #Address 0x307 read value
    csrr x14, 0x307

    #Address 0x307 Write value 0xd4159dca
    li x3, 0xd4159dca
    csrw 0x307, x3

    #Unmapped address 0xd05 testing: random write/read operations
    #Address 0xd05 Write value 0x84c7e9f5
    li x3, 0x84c7e9f5
    csrw 0xd05, x3

    #Address 0xd05 read value
    csrr x14, 0xd05

    #Address 0xd05 read value
    csrr x14, 0xd05

    #Address 0xd05 read value
    csrr x14, 0xd05

    #Unmapped address 0x753 testing: random write/read operations
    #Address 0x753 read value
    csrr x14, 0x753

    #Unmapped address 0xbd5 testing: random write/read operations
    #Address 0xbd5 Write value 0x433f6f02
    li x3, 0x433f6f02
    csrw 0xbd5, x3

    #Address 0xbd5 Write value 0x7c080432
    li x3, 0x7c080432
    csrw 0xbd5, x3

    #Address 0xbd5 read value
    csrr x14, 0xbd5

    #Address 0xbd5 Write value 0xa5301fba
    li x3, 0xa5301fba
    csrw 0xbd5, x3

    #Unmapped address 0xbce testing: random write/read operations
    #Address 0xbce read value
    csrr x14, 0xbce

    #Address 0xbce Write value 0xbb9cce12
    li x3, 0xbb9cce12
    csrw 0xbce, x3

    #Address 0xbce read value
    csrr x14, 0xbce

    #Address 0xbce read value
    csrr x14, 0xbce

    #Address 0xbce Write value 0xf6925a3c
    li x3, 0xf6925a3c
    csrw 0xbce, x3

    #Unmapped address 0x5d4 testing: random write/read operations
    #Address 0x5d4 Write value 0xcb263706
    li x3, 0xcb263706
    csrw 0x5d4, x3

    #Address 0x5d4 Write value 0x1771305b
    li x3, 0x1771305b
    csrw 0x5d4, x3

    #Address 0x5d4 read value
    csrr x14, 0x5d4

    #Address 0x5d4 read value
    csrr x14, 0x5d4

    #Address 0x5d4 read value
    csrr x14, 0x5d4

    #Unmapped address 0xfe3 testing: random write/read operations
    #Address 0xfe3 Write value 0xd472731a
    li x3, 0xd472731a
    csrw 0xfe3, x3

    #Address 0xfe3 read value
    csrr x14, 0xfe3

    #Address 0xfe3 Write value 0x46a8e2c9
    li x3, 0x46a8e2c9
    csrw 0xfe3, x3

    #Unmapped address 0xcc8 testing: random write/read operations
    #Address 0xcc8 Write value 0xe90f06ca
    li x3, 0xe90f06ca
    csrw 0xcc8, x3

    #Address 0xcc8 Write value 0xe20ac32
    li x3, 0xe20ac32
    csrw 0xcc8, x3

    #Address 0xcc8 read value
    csrr x14, 0xcc8

    #Address 0xcc8 read value
    csrr x14, 0xcc8

    #Unmapped address 0x1fc testing: random write/read operations
    #Address 0x1fc Write value 0x11a54598
    li x3, 0x11a54598
    csrw 0x1fc, x3

    #Address 0x1fc read value
    csrr x14, 0x1fc

    #Unmapped address 0x31b testing: random write/read operations
    #Address 0x31b read value
    csrr x14, 0x31b

    #Address 0x31b Write value 0x3a6fbb16
    li x3, 0x3a6fbb16
    csrw 0x31b, x3

    #Address 0x31b Write value 0xf7f87455
    li x3, 0xf7f87455
    csrw 0x31b, x3

    #Unmapped address 0x6af testing: random write/read operations
    #Address 0x6af Write value 0x230e6f2f
    li x3, 0x230e6f2f
    csrw 0x6af, x3

    #Address 0x6af Write value 0x6dee438f
    li x3, 0x6dee438f
    csrw 0x6af, x3

    #Address 0x6af read value
    csrr x14, 0x6af

    #Address 0x6af read value
    csrr x14, 0x6af

    #Unmapped address 0x469 testing: random write/read operations
    #Address 0x469 Write value 0xda25508
    li x3, 0xda25508
    csrw 0x469, x3

    #Address 0x469 Write value 0xecbfde67
    li x3, 0xecbfde67
    csrw 0x469, x3

    #Address 0x469 read value
    csrr x14, 0x469

    #Unmapped address 0xf9a testing: random write/read operations
    #Address 0xf9a read value
    csrr x14, 0xf9a

    #Address 0xf9a read value
    csrr x14, 0xf9a

    #Unmapped address 0xbfa testing: random write/read operations
    #Address 0xbfa Write value 0xa43381f9
    li x3, 0xa43381f9
    csrw 0xbfa, x3

    #Address 0xbfa read value
    csrr x14, 0xbfa

    #Address 0xbfa Write value 0xa06461ac
    li x3, 0xa06461ac
    csrw 0xbfa, x3

    #Address 0xbfa read value
    csrr x14, 0xbfa

    #Address 0xbfa Write value 0x1e6e60f5
    li x3, 0x1e6e60f5
    csrw 0xbfa, x3

    #Unmapped address 0x276 testing: random write/read operations
    #Address 0x276 read value
    csrr x14, 0x276

    #Unmapped address 0xf9d testing: random write/read operations
    #Address 0xf9d Write value 0xa4b05f3c
    li x3, 0xa4b05f3c
    csrw 0xf9d, x3

    #Address 0xf9d Write value 0x78e866a6
    li x3, 0x78e866a6
    csrw 0xf9d, x3

    #Address 0xf9d read value
    csrr x14, 0xf9d

    #Address 0xf9d read value
    csrr x14, 0xf9d

    #Address 0xf9d Write value 0x15241651
    li x3, 0x15241651
    csrw 0xf9d, x3

    #Unmapped address 0x1fe testing: random write/read operations
    #Address 0x1fe read value
    csrr x14, 0x1fe

    #Address 0x1fe read value
    csrr x14, 0x1fe

    #Address 0x1fe Write value 0x665b25d0
    li x3, 0x665b25d0
    csrw 0x1fe, x3

    #Address 0x1fe Write value 0x36a572fb
    li x3, 0x36a572fb
    csrw 0x1fe, x3

    #Unmapped address 0x21d testing: random write/read operations
    #Address 0x21d read value
    csrr x14, 0x21d

    #Unmapped address 0x3fc testing: random write/read operations
    #Address 0x3fc read value
    csrr x14, 0x3fc

    #Address 0x3fc Write value 0xe018c82c
    li x3, 0xe018c82c
    csrw 0x3fc, x3

    #Address 0x3fc Write value 0xf5ccef5c
    li x3, 0xf5ccef5c
    csrw 0x3fc, x3

    #Address 0x3fc read value
    csrr x14, 0x3fc

    #Unmapped address 0xdb4 testing: random write/read operations
    #Address 0xdb4 read value
    csrr x14, 0xdb4

    #Address 0xdb4 Write value 0x44654b5c
    li x3, 0x44654b5c
    csrw 0xdb4, x3

    #Address 0xdb4 Write value 0x25b58e0d
    li x3, 0x25b58e0d
    csrw 0xdb4, x3

    #Address 0xdb4 read value
    csrr x14, 0xdb4

    #Address 0xdb4 read value
    csrr x14, 0xdb4

    #Unmapped address 0x5a5 testing: random write/read operations
    #Address 0x5a5 read value
    csrr x14, 0x5a5

    #Address 0x5a5 read value
    csrr x14, 0x5a5

    #Address 0x5a5 Write value 0xa00bb5c7
    li x3, 0xa00bb5c7
    csrw 0x5a5, x3

    #Address 0x5a5 read value
    csrr x14, 0x5a5

    #Address 0x5a5 read value
    csrr x14, 0x5a5

    #Unmapped address 0x4f4 testing: random write/read operations
    #Address 0x4f4 read value
    csrr x14, 0x4f4

    #Address 0x4f4 Write value 0x1b7d12d9
    li x3, 0x1b7d12d9
    csrw 0x4f4, x3

    #Address 0x4f4 Write value 0xf630eaf1
    li x3, 0xf630eaf1
    csrw 0x4f4, x3

    #Address 0x4f4 Write value 0xb03951b3
    li x3, 0xb03951b3
    csrw 0x4f4, x3

    #Address 0x4f4 Write value 0x32c8bec0
    li x3, 0x32c8bec0
    csrw 0x4f4, x3

    #Unmapped address 0x539 testing: random write/read operations
    #Address 0x539 read value
    csrr x14, 0x539

    #Address 0x539 read value
    csrr x14, 0x539

    #Unmapped address 0xf8 testing: random write/read operations
    #Address 0xf8 read value
    csrr x14, 0xf8

    #Address 0xf8 read value
    csrr x14, 0xf8

    #Unmapped address 0x551 testing: random write/read operations
    #Address 0x551 read value
    csrr x14, 0x551

    #Address 0x551 Write value 0xc8ab518b
    li x3, 0xc8ab518b
    csrw 0x551, x3

    #Unmapped address 0x8ad testing: random write/read operations
    #Address 0x8ad Write value 0x13e583b5
    li x3, 0x13e583b5
    csrw 0x8ad, x3

    #Address 0x8ad Write value 0x5ee9825d
    li x3, 0x5ee9825d
    csrw 0x8ad, x3

    #Address 0x8ad read value
    csrr x14, 0x8ad

    #Address 0x8ad read value
    csrr x14, 0x8ad

    #Unmapped address 0x107 testing: random write/read operations
    #Address 0x107 read value
    csrr x14, 0x107

    #Address 0x107 read value
    csrr x14, 0x107

    #Unmapped address 0xcca testing: random write/read operations
    #Address 0xcca read value
    csrr x14, 0xcca

    #Unmapped address 0xc65 testing: random write/read operations
    #Address 0xc65 Write value 0x97a27735
    li x3, 0x97a27735
    csrw 0xc65, x3

    #Unmapped address 0x22b testing: random write/read operations
    #Address 0x22b read value
    csrr x14, 0x22b

    #Address 0x22b Write value 0x1349e07c
    li x3, 0x1349e07c
    csrw 0x22b, x3

    #Address 0x22b read value
    csrr x14, 0x22b

    #Unmapped address 0x76 testing: random write/read operations
    #Address 0x76 Write value 0x4f012def
    li x3, 0x4f012def
    csrw 0x76, x3

    #Unmapped address 0x51a testing: random write/read operations
    #Address 0x51a read value
    csrr x14, 0x51a

    #Address 0x51a read value
    csrr x14, 0x51a

    #Unmapped address 0xc01 testing: random write/read operations
    #Address 0xc01 read value
    csrr x14, 0xc01

    #Address 0xc01 Write value 0x5edfd64c
    li x3, 0x5edfd64c
    csrw 0xc01, x3

    #Unmapped address 0x9f8 testing: random write/read operations
    #Address 0x9f8 read value
    csrr x14, 0x9f8

    #Address 0x9f8 Write value 0xa1acf803
    li x3, 0xa1acf803
    csrw 0x9f8, x3

    #Address 0x9f8 Write value 0x73ba93eb
    li x3, 0x73ba93eb
    csrw 0x9f8, x3

    #Unmapped address 0x903 testing: random write/read operations
    #Address 0x903 Write value 0x7db2ab76
    li x3, 0x7db2ab76
    csrw 0x903, x3

    #Address 0x903 Write value 0x66b1be0b
    li x3, 0x66b1be0b
    csrw 0x903, x3

    #Address 0x903 read value
    csrr x14, 0x903

    #Unmapped address 0xe8d testing: random write/read operations
    #Address 0xe8d read value
    csrr x14, 0xe8d

    #Address 0xe8d Write value 0x25c28884
    li x3, 0x25c28884
    csrw 0xe8d, x3

    #Unmapped address 0xdd3 testing: random write/read operations
    #Address 0xdd3 Write value 0x82c4e428
    li x3, 0x82c4e428
    csrw 0xdd3, x3

    #Unmapped address 0x1a5 testing: random write/read operations
    #Address 0x1a5 Write value 0x928393c7
    li x3, 0x928393c7
    csrw 0x1a5, x3

    #Unmapped address 0x610 testing: random write/read operations
    #Address 0x610 read value
    csrr x14, 0x610

    #Address 0x610 Write value 0xa6c47b68
    li x3, 0xa6c47b68
    csrw 0x610, x3

    #Unmapped address 0xbf4 testing: random write/read operations
    #Address 0xbf4 read value
    csrr x14, 0xbf4

    #Address 0xbf4 Write value 0xab2e2b46
    li x3, 0xab2e2b46
    csrw 0xbf4, x3

    #Unmapped address 0x3fd testing: random write/read operations
    #Address 0x3fd Write value 0x8db36d8d
    li x3, 0x8db36d8d
    csrw 0x3fd, x3

    #Address 0x3fd Write value 0x572e21e4
    li x3, 0x572e21e4
    csrw 0x3fd, x3

    #Unmapped address 0x7a1 testing: random write/read operations
    #Address 0x7a1 Write value 0x5cd6af1a
    li x3, 0x5cd6af1a
    csrw 0x7a1, x3

    #Address 0x7a1 read value
    csrr x14, 0x7a1

    #Address 0x7a1 read value
    csrr x14, 0x7a1

    #Address 0x7a1 Write value 0x8fc9ecda
    li x3, 0x8fc9ecda
    csrw 0x7a1, x3

    #Unmapped address 0x299 testing: random write/read operations
    #Address 0x299 read value
    csrr x14, 0x299

    #Address 0x299 read value
    csrr x14, 0x299

    #Address 0x299 Write value 0x3bd3ae86
    li x3, 0x3bd3ae86
    csrw 0x299, x3

    #Address 0x299 read value
    csrr x14, 0x299

    #Unmapped address 0xd18 testing: random write/read operations
    #Address 0xd18 Write value 0xac828883
    li x3, 0xac828883
    csrw 0xd18, x3

    #Address 0xd18 read value
    csrr x14, 0xd18

    #Address 0xd18 Write value 0x7f50d25e
    li x3, 0x7f50d25e
    csrw 0xd18, x3

    #Unmapped address 0xd94 testing: random write/read operations
    #Address 0xd94 read value
    csrr x14, 0xd94

    #Unmapped address 0x383 testing: random write/read operations
    #Address 0x383 Write value 0xcc520cce
    li x3, 0xcc520cce
    csrw 0x383, x3

    #Address 0x383 read value
    csrr x14, 0x383

    #Address 0x383 Write value 0x74871178
    li x3, 0x74871178
    csrw 0x383, x3

    #Address 0x383 Write value 0x2eea7372
    li x3, 0x2eea7372
    csrw 0x383, x3

    #Address 0x383 Write value 0xcdeee264
    li x3, 0xcdeee264
    csrw 0x383, x3

    #Unmapped address 0x567 testing: random write/read operations
    #Address 0x567 read value
    csrr x14, 0x567

    #Unmapped address 0xc78 testing: random write/read operations
    #Address 0xc78 Write value 0xc17d77e3
    li x3, 0xc17d77e3
    csrw 0xc78, x3

    #Address 0xc78 read value
    csrr x14, 0xc78

    #Address 0xc78 Write value 0x90340867
    li x3, 0x90340867
    csrw 0xc78, x3

    #Address 0xc78 read value
    csrr x14, 0xc78

    #Address 0xc78 Write value 0x5856f08e
    li x3, 0x5856f08e
    csrw 0xc78, x3

    #Unmapped address 0x5bd testing: random write/read operations
    #Address 0x5bd Write value 0x920778b
    li x3, 0x920778b
    csrw 0x5bd, x3

    #Address 0x5bd read value
    csrr x14, 0x5bd

    #Address 0x5bd Write value 0xdd8f53da
    li x3, 0xdd8f53da
    csrw 0x5bd, x3

    #Unmapped address 0xcbd testing: random write/read operations
    #Address 0xcbd read value
    csrr x14, 0xcbd

    #Unmapped address 0xfa6 testing: random write/read operations
    #Address 0xfa6 Write value 0x61cb075a
    li x3, 0x61cb075a
    csrw 0xfa6, x3

    #Address 0xfa6 Write value 0x872e1694
    li x3, 0x872e1694
    csrw 0xfa6, x3

    #Address 0xfa6 read value
    csrr x14, 0xfa6

    #Unmapped address 0x510 testing: random write/read operations
    #Address 0x510 Write value 0x8915c89c
    li x3, 0x8915c89c
    csrw 0x510, x3

    #Unmapped address 0xa66 testing: random write/read operations
    #Address 0xa66 read value
    csrr x14, 0xa66

    #Address 0xa66 Write value 0xcc00060b
    li x3, 0xcc00060b
    csrw 0xa66, x3

    #Address 0xa66 Write value 0xf5c618c7
    li x3, 0xf5c618c7
    csrw 0xa66, x3

    #Unmapped address 0xc42 testing: random write/read operations
    #Address 0xc42 read value
    csrr x14, 0xc42

    #Unmapped address 0x303 testing: random write/read operations
    #Address 0x303 read value
    csrr x14, 0x303

    #Address 0x303 read value
    csrr x14, 0x303

    #Address 0x303 Write value 0x9d906b15
    li x3, 0x9d906b15
    csrw 0x303, x3

    #Address 0x303 read value
    csrr x14, 0x303

    #Address 0x303 read value
    csrr x14, 0x303

    #Unmapped address 0x1a7 testing: random write/read operations
    #Address 0x1a7 read value
    csrr x14, 0x1a7

    #Address 0x1a7 read value
    csrr x14, 0x1a7

    #Address 0x1a7 Write value 0xc18c7dc5
    li x3, 0xc18c7dc5
    csrw 0x1a7, x3

    #Address 0x1a7 Write value 0xb5e9499b
    li x3, 0xb5e9499b
    csrw 0x1a7, x3

    #Address 0x1a7 Write value 0x41d72f06
    li x3, 0x41d72f06
    csrw 0x1a7, x3

    #Unmapped address 0x977 testing: random write/read operations
    #Address 0x977 read value
    csrr x14, 0x977

    #Address 0x977 Write value 0x7218eeaa
    li x3, 0x7218eeaa
    csrw 0x977, x3

    #Unmapped address 0xa07 testing: random write/read operations
    #Address 0xa07 Write value 0xc3b449e
    li x3, 0xc3b449e
    csrw 0xa07, x3

    #Unmapped address 0xbfb testing: random write/read operations
    #Address 0xbfb read value
    csrr x14, 0xbfb

    #Unmapped address 0x227 testing: random write/read operations
    #Address 0x227 Write value 0x9d5d7812
    li x3, 0x9d5d7812
    csrw 0x227, x3

    #Address 0x227 Write value 0x277054b2
    li x3, 0x277054b2
    csrw 0x227, x3

    #Address 0x227 read value
    csrr x14, 0x227

    #Unmapped address 0x62b testing: random write/read operations
    #Address 0x62b read value
    csrr x14, 0x62b

    #Address 0x62b Write value 0x8ab845
    li x3, 0x8ab845
    csrw 0x62b, x3

    #Address 0x62b Write value 0xfae897dc
    li x3, 0xfae897dc
    csrw 0x62b, x3

    #Address 0x62b read value
    csrr x14, 0x62b

    #Unmapped address 0x5d3 testing: random write/read operations
    #Address 0x5d3 read value
    csrr x14, 0x5d3

    #Unmapped address 0xefa testing: random write/read operations
    #Address 0xefa Write value 0x7b08b671
    li x3, 0x7b08b671
    csrw 0xefa, x3

    #Address 0xefa Write value 0x82fb15f
    li x3, 0x82fb15f
    csrw 0xefa, x3

    #Address 0xefa Write value 0x16149e78
    li x3, 0x16149e78
    csrw 0xefa, x3

    #Address 0xefa Write value 0xff4d68fb
    li x3, 0xff4d68fb
    csrw 0xefa, x3

    #Address 0xefa read value
    csrr x14, 0xefa

    #Unmapped address 0xb2d testing: random write/read operations
    #Address 0xb2d Write value 0xc1cbfbff
    li x3, 0xc1cbfbff
    csrw 0xb2d, x3

    #Unmapped address 0x8c7 testing: random write/read operations
    #Address 0x8c7 read value
    csrr x14, 0x8c7

    #Unmapped address 0xa5a testing: random write/read operations
    #Address 0xa5a read value
    csrr x14, 0xa5a

    #Address 0xa5a read value
    csrr x14, 0xa5a

    #Address 0xa5a Write value 0xa535d82c
    li x3, 0xa535d82c
    csrw 0xa5a, x3

    #Address 0xa5a read value
    csrr x14, 0xa5a

    #Address 0xa5a Write value 0xc5d9db2e
    li x3, 0xc5d9db2e
    csrw 0xa5a, x3

    #Unmapped address 0xbf1 testing: random write/read operations
    #Address 0xbf1 Write value 0x8cd5cf48
    li x3, 0x8cd5cf48
    csrw 0xbf1, x3

    #Address 0xbf1 read value
    csrr x14, 0xbf1

    #Unmapped address 0x2e3 testing: random write/read operations
    #Address 0x2e3 read value
    csrr x14, 0x2e3

    #Address 0x2e3 Write value 0x19d54c93
    li x3, 0x19d54c93
    csrw 0x2e3, x3

    #Address 0x2e3 read value
    csrr x14, 0x2e3

    #Unmapped address 0xce7 testing: random write/read operations
    #Address 0xce7 Write value 0xe079a9ac
    li x3, 0xe079a9ac
    csrw 0xce7, x3

    #Address 0xce7 Write value 0x8ca14501
    li x3, 0x8ca14501
    csrw 0xce7, x3

    #Address 0xce7 Write value 0x22bcc38a
    li x3, 0x22bcc38a
    csrw 0xce7, x3

    #Address 0xce7 read value
    csrr x14, 0xce7

    #Address 0xce7 Write value 0x2052343a
    li x3, 0x2052343a
    csrw 0xce7, x3

    #Unmapped address 0x3f8 testing: random write/read operations
    #Address 0x3f8 Write value 0x520d7ebf
    li x3, 0x520d7ebf
    csrw 0x3f8, x3

    #Address 0x3f8 Write value 0xf187656e
    li x3, 0xf187656e
    csrw 0x3f8, x3

    #Address 0x3f8 read value
    csrr x14, 0x3f8

    #Address 0x3f8 Write value 0x43998f1d
    li x3, 0x43998f1d
    csrw 0x3f8, x3

    #Unmapped address 0xf2 testing: random write/read operations
    #Address 0xf2 read value
    csrr x14, 0xf2

    #Address 0xf2 read value
    csrr x14, 0xf2

    #Unmapped address 0x9b8 testing: random write/read operations
    #Address 0x9b8 Write value 0x6b3a5d8
    li x3, 0x6b3a5d8
    csrw 0x9b8, x3

    #Unmapped address 0x663 testing: random write/read operations
    #Address 0x663 Write value 0xb921b98e
    li x3, 0xb921b98e
    csrw 0x663, x3

    #Address 0x663 Write value 0x81d2fc2b
    li x3, 0x81d2fc2b
    csrw 0x663, x3

    #Address 0x663 Write value 0x658808f8
    li x3, 0x658808f8
    csrw 0x663, x3

    #Unmapped address 0x722 testing: random write/read operations
    #Address 0x722 read value
    csrr x14, 0x722

    #Address 0x722 read value
    csrr x14, 0x722

    #Unmapped address 0x765 testing: random write/read operations
    #Address 0x765 read value
    csrr x14, 0x765

    #Address 0x765 read value
    csrr x14, 0x765

    #Address 0x765 read value
    csrr x14, 0x765

    #Address 0x765 read value
    csrr x14, 0x765

    #Unmapped address 0xff testing: random write/read operations
    #Address 0xff read value
    csrr x14, 0xff

    #Address 0xff read value
    csrr x14, 0xff

    #Unmapped address 0xd2e testing: random write/read operations
    #Address 0xd2e read value
    csrr x14, 0xd2e

    #Address 0xd2e Write value 0xa72d55f5
    li x3, 0xa72d55f5
    csrw 0xd2e, x3

    #Address 0xd2e read value
    csrr x14, 0xd2e

    #Address 0xd2e read value
    csrr x14, 0xd2e

    #Unmapped address 0x3ca testing: random write/read operations
    #Address 0x3ca Write value 0xbffd1720
    li x3, 0xbffd1720
    csrw 0x3ca, x3

    #Address 0x3ca read value
    csrr x14, 0x3ca

    #Address 0x3ca Write value 0x22181c77
    li x3, 0x22181c77
    csrw 0x3ca, x3

    #Address 0x3ca read value
    csrr x14, 0x3ca

    #Address 0x3ca Write value 0xa269a21b
    li x3, 0xa269a21b
    csrw 0x3ca, x3

    #Unmapped address 0x55e testing: random write/read operations
    #Address 0x55e Write value 0x8dd3fd7d
    li x3, 0x8dd3fd7d
    csrw 0x55e, x3

    #Address 0x55e read value
    csrr x14, 0x55e

    #Address 0x55e read value
    csrr x14, 0x55e

    #Address 0x55e read value
    csrr x14, 0x55e

    #Address 0x55e read value
    csrr x14, 0x55e

    #Unmapped address 0x864 testing: random write/read operations
    #Address 0x864 read value
    csrr x14, 0x864

    #Address 0x864 read value
    csrr x14, 0x864

    #Unmapped address 0xfc5 testing: random write/read operations
    #Address 0xfc5 Write value 0x6f2fd75d
    li x3, 0x6f2fd75d
    csrw 0xfc5, x3

    #Address 0xfc5 Write value 0x241863a
    li x3, 0x241863a
    csrw 0xfc5, x3

    #Address 0xfc5 read value
    csrr x14, 0xfc5

    #Address 0xfc5 Write value 0xfc97ce40
    li x3, 0xfc97ce40
    csrw 0xfc5, x3

    #Address 0xfc5 Write value 0x1939af2c
    li x3, 0x1939af2c
    csrw 0xfc5, x3

    #Unmapped address 0x302 testing: random write/read operations
    #Address 0x302 Write value 0xa21677fe
    li x3, 0xa21677fe
    csrw 0x302, x3

    #Unmapped address 0x9b9 testing: random write/read operations
    #Address 0x9b9 read value
    csrr x14, 0x9b9

    #Address 0x9b9 Write value 0xbc436595
    li x3, 0xbc436595
    csrw 0x9b9, x3

    #Address 0x9b9 read value
    csrr x14, 0x9b9

    #Address 0x9b9 read value
    csrr x14, 0x9b9

    #Address 0x9b9 Write value 0x628ebecd
    li x3, 0x628ebecd
    csrw 0x9b9, x3

    #Unmapped address 0xa42 testing: random write/read operations
    #Address 0xa42 read value
    csrr x14, 0xa42

    #Address 0xa42 read value
    csrr x14, 0xa42

    #Address 0xa42 read value
    csrr x14, 0xa42

    #Address 0xa42 read value
    csrr x14, 0xa42

    #Address 0xa42 read value
    csrr x14, 0xa42

    #Unmapped address 0xddf testing: random write/read operations
    #Address 0xddf Write value 0xe7e1c57f
    li x3, 0xe7e1c57f
    csrw 0xddf, x3

    #Address 0xddf read value
    csrr x14, 0xddf

    #Address 0xddf read value
    csrr x14, 0xddf

    #Unmapped address 0x439 testing: random write/read operations
    #Address 0x439 Write value 0x43989ca4
    li x3, 0x43989ca4
    csrw 0x439, x3

    #Address 0x439 Write value 0x4d4def2d
    li x3, 0x4d4def2d
    csrw 0x439, x3

    #Address 0x439 Write value 0x6c7ac8d1
    li x3, 0x6c7ac8d1
    csrw 0x439, x3

    #Address 0x439 read value
    csrr x14, 0x439

    #Address 0x439 read value
    csrr x14, 0x439

    #Unmapped address 0xd4e testing: random write/read operations
    #Address 0xd4e read value
    csrr x14, 0xd4e

    #Address 0xd4e Write value 0xc06d9fd7
    li x3, 0xc06d9fd7
    csrw 0xd4e, x3

    #Address 0xd4e read value
    csrr x14, 0xd4e

    #Address 0xd4e read value
    csrr x14, 0xd4e

    #Unmapped address 0x287 testing: random write/read operations
    #Address 0x287 read value
    csrr x14, 0x287

    #Address 0x287 read value
    csrr x14, 0x287

    #Unmapped address 0x5b testing: random write/read operations
    #Address 0x5b read value
    csrr x14, 0x5b

    #Address 0x5b Write value 0xa04d7755
    li x3, 0xa04d7755
    csrw 0x5b, x3

    #Address 0x5b read value
    csrr x14, 0x5b

    #Address 0x5b Write value 0x29172de1
    li x3, 0x29172de1
    csrw 0x5b, x3

    #Address 0x5b Write value 0x32119c4
    li x3, 0x32119c4
    csrw 0x5b, x3

    #Unmapped address 0x108 testing: random write/read operations
    #Address 0x108 read value
    csrr x14, 0x108

    #Address 0x108 Write value 0x72b85a3c
    li x3, 0x72b85a3c
    csrw 0x108, x3

    #Address 0x108 Write value 0x12e79dfb
    li x3, 0x12e79dfb
    csrw 0x108, x3

    #Address 0x108 read value
    csrr x14, 0x108

    #Address 0x108 Write value 0xa103ca19
    li x3, 0xa103ca19
    csrw 0x108, x3

    #Unmapped address 0x90e testing: random write/read operations
    #Address 0x90e Write value 0x6a9d8a2d
    li x3, 0x6a9d8a2d
    csrw 0x90e, x3

    #Address 0x90e read value
    csrr x14, 0x90e

    #Address 0x90e Write value 0x592d7116
    li x3, 0x592d7116
    csrw 0x90e, x3

    #Address 0x90e read value
    csrr x14, 0x90e

    #Address 0x90e read value
    csrr x14, 0x90e

    #Unmapped address 0x9d9 testing: random write/read operations
    #Address 0x9d9 Write value 0xc6e3403d
    li x3, 0xc6e3403d
    csrw 0x9d9, x3

    #Address 0x9d9 read value
    csrr x14, 0x9d9

    #Address 0x9d9 read value
    csrr x14, 0x9d9

    #Unmapped address 0xfeb testing: random write/read operations
    #Address 0xfeb read value
    csrr x14, 0xfeb

    #Address 0xfeb read value
    csrr x14, 0xfeb

    #Address 0xfeb read value
    csrr x14, 0xfeb

    #Unmapped address 0xc2d testing: random write/read operations
    #Address 0xc2d read value
    csrr x14, 0xc2d

    #Unmapped address 0xf8e testing: random write/read operations
    #Address 0xf8e read value
    csrr x14, 0xf8e

    #Address 0xf8e read value
    csrr x14, 0xf8e

    #Address 0xf8e read value
    csrr x14, 0xf8e

    #Unmapped address 0x8da testing: random write/read operations
    #Address 0x8da Write value 0xe50e68ee
    li x3, 0xe50e68ee
    csrw 0x8da, x3

    #Address 0x8da Write value 0x62c91309
    li x3, 0x62c91309
    csrw 0x8da, x3

    #Address 0x8da read value
    csrr x14, 0x8da

    #Address 0x8da Write value 0xfcbe88af
    li x3, 0xfcbe88af
    csrw 0x8da, x3

    #Address 0x8da Write value 0x9db82004
    li x3, 0x9db82004
    csrw 0x8da, x3

    #Unmapped address 0xd75 testing: random write/read operations
    #Address 0xd75 read value
    csrr x14, 0xd75

    #Address 0xd75 read value
    csrr x14, 0xd75

    #Address 0xd75 Write value 0x6233c3b9
    li x3, 0x6233c3b9
    csrw 0xd75, x3

    #Address 0xd75 Write value 0x9f8a7447
    li x3, 0x9f8a7447
    csrw 0xd75, x3

    #Address 0xd75 read value
    csrr x14, 0xd75

    #Unmapped address 0x8af testing: random write/read operations
    #Address 0x8af Write value 0xb4b09b32
    li x3, 0xb4b09b32
    csrw 0x8af, x3

    #Address 0x8af read value
    csrr x14, 0x8af

    #Address 0x8af read value
    csrr x14, 0x8af

    #Address 0x8af Write value 0xb15e9cf0
    li x3, 0xb15e9cf0
    csrw 0x8af, x3

    #Unmapped address 0x82c testing: random write/read operations
    #Address 0x82c read value
    csrr x14, 0x82c

    #Address 0x82c Write value 0x3d10b024
    li x3, 0x3d10b024
    csrw 0x82c, x3

    #Address 0x82c read value
    csrr x14, 0x82c

    #Unmapped address 0x239 testing: random write/read operations
    #Address 0x239 read value
    csrr x14, 0x239

    #Address 0x239 read value
    csrr x14, 0x239

    #Address 0x239 Write value 0x50f55c0
    li x3, 0x50f55c0
    csrw 0x239, x3

    #Address 0x239 Write value 0x4a5dfe7e
    li x3, 0x4a5dfe7e
    csrw 0x239, x3

    #Address 0x239 read value
    csrr x14, 0x239

    #Unmapped address 0x78b testing: random write/read operations
    #Address 0x78b Write value 0x6e08bbd4
    li x3, 0x6e08bbd4
    csrw 0x78b, x3

    #Unmapped address 0x4f2 testing: random write/read operations
    #Address 0x4f2 Write value 0xb885425c
    li x3, 0xb885425c
    csrw 0x4f2, x3

    #Unmapped address 0xf25 testing: random write/read operations
    #Address 0xf25 Write value 0xe3827e2
    li x3, 0xe3827e2
    csrw 0xf25, x3

    #Address 0xf25 Write value 0xdc4d736c
    li x3, 0xdc4d736c
    csrw 0xf25, x3

    #Address 0xf25 read value
    csrr x14, 0xf25

    #Address 0xf25 read value
    csrr x14, 0xf25

    #Unmapped address 0xfdd testing: random write/read operations
    #Address 0xfdd read value
    csrr x14, 0xfdd

    #Address 0xfdd Write value 0xf5de1f3f
    li x3, 0xf5de1f3f
    csrw 0xfdd, x3

    #Address 0xfdd Write value 0x978a13a7
    li x3, 0x978a13a7
    csrw 0xfdd, x3

    #Address 0xfdd Write value 0xef0c5040
    li x3, 0xef0c5040
    csrw 0xfdd, x3

    #Address 0xfdd Write value 0x934852ef
    li x3, 0x934852ef
    csrw 0xfdd, x3

    #Unmapped address 0x36b testing: random write/read operations
    #Address 0x36b Write value 0x9c238816
    li x3, 0x9c238816
    csrw 0x36b, x3

    #Address 0x36b read value
    csrr x14, 0x36b

    #Address 0x36b read value
    csrr x14, 0x36b

    #Address 0x36b read value
    csrr x14, 0x36b

    #Unmapped address 0x914 testing: random write/read operations
    #Address 0x914 Write value 0xdc1a1f8e
    li x3, 0xdc1a1f8e
    csrw 0x914, x3

    #Address 0x914 Write value 0xbe716b87
    li x3, 0xbe716b87
    csrw 0x914, x3

    #Unmapped address 0xb6e testing: random write/read operations
    #Address 0xb6e Write value 0xe5036b1d
    li x3, 0xe5036b1d
    csrw 0xb6e, x3

    #Unmapped address 0xd66 testing: random write/read operations
    #Address 0xd66 Write value 0x9e6d18a1
    li x3, 0x9e6d18a1
    csrw 0xd66, x3

    #Address 0xd66 read value
    csrr x14, 0xd66

    #Unmapped address 0xd4a testing: random write/read operations
    #Address 0xd4a Write value 0x1c1d1ecc
    li x3, 0x1c1d1ecc
    csrw 0xd4a, x3

    #Address 0xd4a read value
    csrr x14, 0xd4a

    #Address 0xd4a read value
    csrr x14, 0xd4a

    #Address 0xd4a Write value 0x393164ce
    li x3, 0x393164ce
    csrw 0xd4a, x3

    #Address 0xd4a Write value 0x8ee9ee0e
    li x3, 0x8ee9ee0e
    csrw 0xd4a, x3

    #Unmapped address 0xab testing: random write/read operations
    #Address 0xab Write value 0xc87606b1
    li x3, 0xc87606b1
    csrw 0xab, x3

    #Unmapped address 0xcc4 testing: random write/read operations
    #Address 0xcc4 Write value 0xf9f41690
    li x3, 0xf9f41690
    csrw 0xcc4, x3

    #Address 0xcc4 Write value 0xdade192d
    li x3, 0xdade192d
    csrw 0xcc4, x3

    #Address 0xcc4 read value
    csrr x14, 0xcc4

    #Address 0xcc4 read value
    csrr x14, 0xcc4

    #Unmapped address 0xe44 testing: random write/read operations
    #Address 0xe44 read value
    csrr x14, 0xe44

    #Address 0xe44 read value
    csrr x14, 0xe44

    #Address 0xe44 Write value 0x651f6de6
    li x3, 0x651f6de6
    csrw 0xe44, x3

    #Unmapped address 0x84b testing: random write/read operations
    #Address 0x84b read value
    csrr x14, 0x84b

    #Address 0x84b Write value 0x933eea83
    li x3, 0x933eea83
    csrw 0x84b, x3

    #Address 0x84b read value
    csrr x14, 0x84b

    #Address 0x84b Write value 0xe23e69ae
    li x3, 0xe23e69ae
    csrw 0x84b, x3

    #Address 0x84b read value
    csrr x14, 0x84b

    #Unmapped address 0x56a testing: random write/read operations
    #Address 0x56a Write value 0x55e39e66
    li x3, 0x55e39e66
    csrw 0x56a, x3

    #Unmapped address 0xe3f testing: random write/read operations
    #Address 0xe3f read value
    csrr x14, 0xe3f

    #Address 0xe3f read value
    csrr x14, 0xe3f

    #Unmapped address 0x51 testing: random write/read operations
    #Address 0x51 read value
    csrr x14, 0x51

    #Address 0x51 Write value 0xa20113de
    li x3, 0xa20113de
    csrw 0x51, x3

    #Unmapped address 0x436 testing: random write/read operations
    #Address 0x436 read value
    csrr x14, 0x436

    #Address 0x436 Write value 0xeb4f4789
    li x3, 0xeb4f4789
    csrw 0x436, x3

    #Address 0x436 Write value 0xa79bfe67
    li x3, 0xa79bfe67
    csrw 0x436, x3

    #Address 0x436 read value
    csrr x14, 0x436

    #Unmapped address 0x273 testing: random write/read operations
    #Address 0x273 Write value 0xdab21a59
    li x3, 0xdab21a59
    csrw 0x273, x3

    #Address 0x273 read value
    csrr x14, 0x273

    #Address 0x273 Write value 0x346d3ba1
    li x3, 0x346d3ba1
    csrw 0x273, x3

    #Unmapped address 0x926 testing: random write/read operations
    #Address 0x926 read value
    csrr x14, 0x926

    #Address 0x926 Write value 0x4b02604c
    li x3, 0x4b02604c
    csrw 0x926, x3

    #Unmapped address 0xc2c testing: random write/read operations
    #Address 0xc2c read value
    csrr x14, 0xc2c

    #Unmapped address 0xa51 testing: random write/read operations
    #Address 0xa51 Write value 0xdfe767ee
    li x3, 0xdfe767ee
    csrw 0xa51, x3

    #Address 0xa51 read value
    csrr x14, 0xa51

    #Address 0xa51 Write value 0xbd99bcd
    li x3, 0xbd99bcd
    csrw 0xa51, x3

    #Address 0xa51 Write value 0x4c7607eb
    li x3, 0x4c7607eb
    csrw 0xa51, x3

    #Unmapped address 0x3cb testing: random write/read operations
    #Address 0x3cb Write value 0xbba20b48
    li x3, 0xbba20b48
    csrw 0x3cb, x3

    #Address 0x3cb Write value 0x4c9f2e3e
    li x3, 0x4c9f2e3e
    csrw 0x3cb, x3

    #Address 0x3cb read value
    csrr x14, 0x3cb

    #Address 0x3cb Write value 0x52a84cb7
    li x3, 0x52a84cb7
    csrw 0x3cb, x3

    #Unmapped address 0x572 testing: random write/read operations
    #Address 0x572 Write value 0x67ee6880
    li x3, 0x67ee6880
    csrw 0x572, x3

    #Address 0x572 read value
    csrr x14, 0x572

    #Address 0x572 read value
    csrr x14, 0x572

    #Address 0x572 Write value 0x9acfefce
    li x3, 0x9acfefce
    csrw 0x572, x3

    #Unmapped address 0xc8b testing: random write/read operations
    #Address 0xc8b Write value 0xb4a49316
    li x3, 0xb4a49316
    csrw 0xc8b, x3

    #Address 0xc8b Write value 0xbe78cadd
    li x3, 0xbe78cadd
    csrw 0xc8b, x3

    #Address 0xc8b read value
    csrr x14, 0xc8b

    #Address 0xc8b read value
    csrr x14, 0xc8b

    #Address 0xc8b Write value 0x82e5eb5d
    li x3, 0x82e5eb5d
    csrw 0xc8b, x3

    #Unmapped address 0x199 testing: random write/read operations
    #Address 0x199 Write value 0x24ad7bcb
    li x3, 0x24ad7bcb
    csrw 0x199, x3

    #Unmapped address 0xaee testing: random write/read operations
    #Address 0xaee Write value 0x3bd0f654
    li x3, 0x3bd0f654
    csrw 0xaee, x3

    #Address 0xaee Write value 0x9e037518
    li x3, 0x9e037518
    csrw 0xaee, x3

    #Address 0xaee read value
    csrr x14, 0xaee

    #Unmapped address 0x1e7 testing: random write/read operations
    #Address 0x1e7 Write value 0xf93b1f6b
    li x3, 0xf93b1f6b
    csrw 0x1e7, x3

    #Address 0x1e7 read value
    csrr x14, 0x1e7

    #Address 0x1e7 read value
    csrr x14, 0x1e7

    #Address 0x1e7 read value
    csrr x14, 0x1e7

    #Unmapped address 0xd11 testing: random write/read operations
    #Address 0xd11 Write value 0x8abc6d11
    li x3, 0x8abc6d11
    csrw 0xd11, x3

    #Address 0xd11 Write value 0x2f44b134
    li x3, 0x2f44b134
    csrw 0xd11, x3

    #Address 0xd11 Write value 0x3e4d026c
    li x3, 0x3e4d026c
    csrw 0xd11, x3

    #Unmapped address 0xd23 testing: random write/read operations
    #Address 0xd23 Write value 0x4d960cb1
    li x3, 0x4d960cb1
    csrw 0xd23, x3

    #Unmapped address 0x28f testing: random write/read operations
    #Address 0x28f Write value 0xea664497
    li x3, 0xea664497
    csrw 0x28f, x3

    #Address 0x28f read value
    csrr x14, 0x28f

    #Address 0x28f Write value 0xad46e385
    li x3, 0xad46e385
    csrw 0x28f, x3

    #Unmapped address 0xd1c testing: random write/read operations
    #Address 0xd1c Write value 0x273b7b2c
    li x3, 0x273b7b2c
    csrw 0xd1c, x3

    #Address 0xd1c read value
    csrr x14, 0xd1c

    #Address 0xd1c Write value 0x3dda021
    li x3, 0x3dda021
    csrw 0xd1c, x3

    #Address 0xd1c Write value 0x23ea392
    li x3, 0x23ea392
    csrw 0xd1c, x3

    #Unmapped address 0x876 testing: random write/read operations
    #Address 0x876 Write value 0x62e66d26
    li x3, 0x62e66d26
    csrw 0x876, x3

    #Unmapped address 0x710 testing: random write/read operations
    #Address 0x710 Write value 0x59fffeae
    li x3, 0x59fffeae
    csrw 0x710, x3

    #Address 0x710 read value
    csrr x14, 0x710

    #Address 0x710 Write value 0x32cac27c
    li x3, 0x32cac27c
    csrw 0x710, x3

    #Unmapped address 0xe97 testing: random write/read operations
    #Address 0xe97 Write value 0xa55cd24f
    li x3, 0xa55cd24f
    csrw 0xe97, x3

    #Unmapped address 0x32 testing: random write/read operations
    #Address 0x32 read value
    csrr x14, 0x32

    #Unmapped address 0xf76 testing: random write/read operations
    #Address 0xf76 Write value 0x7ce7073d
    li x3, 0x7ce7073d
    csrw 0xf76, x3

    #Unmapped address 0x577 testing: random write/read operations
    #Address 0x577 Write value 0x5c83af3e
    li x3, 0x5c83af3e
    csrw 0x577, x3

    #Address 0x577 Write value 0x931b5bc0
    li x3, 0x931b5bc0
    csrw 0x577, x3

    #Address 0x577 Write value 0xac89f083
    li x3, 0xac89f083
    csrw 0x577, x3

    #Address 0x577 read value
    csrr x14, 0x577

    #Unmapped address 0x80f testing: random write/read operations
    #Address 0x80f Write value 0x90e0fd54
    li x3, 0x90e0fd54
    csrw 0x80f, x3

    #Address 0x80f read value
    csrr x14, 0x80f

    #Unmapped address 0x154 testing: random write/read operations
    #Address 0x154 Write value 0xa9a874a4
    li x3, 0xa9a874a4
    csrw 0x154, x3

    #Address 0x154 Write value 0x653bd5be
    li x3, 0x653bd5be
    csrw 0x154, x3

    #Address 0x154 read value
    csrr x14, 0x154

    #Address 0x154 Write value 0xa39e36e5
    li x3, 0xa39e36e5
    csrw 0x154, x3

    #Unmapped address 0xd0d testing: random write/read operations
    #Address 0xd0d Write value 0xbb228604
    li x3, 0xbb228604
    csrw 0xd0d, x3

    #Address 0xd0d read value
    csrr x14, 0xd0d

    #Address 0xd0d Write value 0x48ee4c3b
    li x3, 0x48ee4c3b
    csrw 0xd0d, x3

    #Address 0xd0d read value
    csrr x14, 0xd0d

    #Address 0xd0d read value
    csrr x14, 0xd0d

    #Unmapped address 0x9c8 testing: random write/read operations
    #Address 0x9c8 Write value 0x89df0412
    li x3, 0x89df0412
    csrw 0x9c8, x3

    #Address 0x9c8 Write value 0x96fe213f
    li x3, 0x96fe213f
    csrw 0x9c8, x3

    #Address 0x9c8 Write value 0x5dc8cc6d
    li x3, 0x5dc8cc6d
    csrw 0x9c8, x3

    #Address 0x9c8 read value
    csrr x14, 0x9c8

    #Mapped address 0x7c0 (icache) testing: random write/read operations
    #Address 0x7c0 read value
    csrr x14, 0x7c0

    #Address 0x7c0 Write value 0xe79bd7c3
    li x3, 0xe79bd7c3
    csrw 0x7c0, x3

    #Address 0x7c0 read value
    csrr x14, 0x7c0

    #Address 0x7c0 Write value 0xdd87c65d
    li x3, 0xdd87c65d
    csrw 0x7c0, x3

    #Unmapped address 0x2b testing: random write/read operations
    #Address 0x2b read value
    csrr x14, 0x2b

    #Address 0x2b Write value 0x941444a9
    li x3, 0x941444a9
    csrw 0x2b, x3

    #Unmapped address 0x4f0 testing: random write/read operations
    #Address 0x4f0 Write value 0x7f7f5096
    li x3, 0x7f7f5096
    csrw 0x4f0, x3

    #Address 0x4f0 read value
    csrr x14, 0x4f0

    #Address 0x4f0 read value
    csrr x14, 0x4f0

    #Unmapped address 0x26a testing: random write/read operations
    #Address 0x26a Write value 0xd2d6017b
    li x3, 0xd2d6017b
    csrw 0x26a, x3

    #Unmapped address 0xc9b testing: random write/read operations
    #Address 0xc9b read value
    csrr x14, 0xc9b

    #Address 0xc9b Write value 0x18b2b0e0
    li x3, 0x18b2b0e0
    csrw 0xc9b, x3

    #Mapped address 0x32a (mhpmevent10) testing: random write/read operations
    #Address 0x32a Write value 0x699ce7e4
    li x3, 0x699ce7e4
    csrw 0x32a, x3

    #Address 0x32a read value
    csrr x14, 0x32a

    #Address 0x32a Write value 0xaf509859
    li x3, 0xaf509859
    csrw 0x32a, x3

    #Address 0x32a Write value 0xc972dbae
    li x3, 0xc972dbae
    csrw 0x32a, x3

    #Unmapped address 0x650 testing: random write/read operations
    #Address 0x650 read value
    csrr x14, 0x650

    #Address 0x650 Write value 0xeba352a8
    li x3, 0xeba352a8
    csrw 0x650, x3

    #Address 0x650 Write value 0xce1966dd
    li x3, 0xce1966dd
    csrw 0x650, x3

    #Unmapped address 0x43c testing: random write/read operations
    #Address 0x43c Write value 0xcab61445
    li x3, 0xcab61445
    csrw 0x43c, x3

    #Address 0x43c read value
    csrr x14, 0x43c

    #Unmapped address 0xb1 testing: random write/read operations
    #Address 0xb1 read value
    csrr x14, 0xb1

    #Unmapped address 0xa65 testing: random write/read operations
    #Address 0xa65 Write value 0xccd9afb2
    li x3, 0xccd9afb2
    csrw 0xa65, x3

    #Unmapped address 0xbf8 testing: random write/read operations
    #Address 0xbf8 Write value 0xe13781a9
    li x3, 0xe13781a9
    csrw 0xbf8, x3

    #Unmapped address 0xbaa testing: random write/read operations
    #Address 0xbaa read value
    csrr x14, 0xbaa

    #Address 0xbaa read value
    csrr x14, 0xbaa

    #Address 0xbaa Write value 0x749da190
    li x3, 0x749da190
    csrw 0xbaa, x3

    #Unmapped address 0xf9f testing: random write/read operations
    #Address 0xf9f Write value 0x6779a552
    li x3, 0x6779a552
    csrw 0xf9f, x3

    #Address 0xf9f Write value 0x6ebf95d1
    li x3, 0x6ebf95d1
    csrw 0xf9f, x3

    #Unmapped address 0x298 testing: random write/read operations
    #Address 0x298 Write value 0x4c7c7b3f
    li x3, 0x4c7c7b3f
    csrw 0x298, x3

    #Address 0x298 Write value 0xf10de547
    li x3, 0xf10de547
    csrw 0x298, x3

    #Address 0x298 Write value 0x349deb9a
    li x3, 0x349deb9a
    csrw 0x298, x3

    #Address 0x298 Write value 0x3d28ad28
    li x3, 0x3d28ad28
    csrw 0x298, x3

    #Mapped address 0xb14 (mhpmcounter20) testing: random write/read operations
    #Address 0xb14 read value
    csrr x14, 0xb14

    #Address 0xb14 read value
    csrr x14, 0xb14

    #Mapped address 0xb9b (mhpmcounterh27) testing: random write/read operations
    #Address 0xb9b read value
    csrr x14, 0xb9b

    #Unmapped address 0xa38 testing: random write/read operations
    #Address 0xa38 read value
    csrr x14, 0xa38

    #Address 0xa38 read value
    csrr x14, 0xa38

    #Unmapped address 0x970 testing: random write/read operations
    #Address 0x970 Write value 0xbc3840e5
    li x3, 0xbc3840e5
    csrw 0x970, x3

    #Address 0x970 Write value 0x9966c6a6
    li x3, 0x9966c6a6
    csrw 0x970, x3

    #Unmapped address 0x31f testing: random write/read operations
    #Address 0x31f Write value 0xca735410
    li x3, 0xca735410
    csrw 0x31f, x3

    #Address 0x31f read value
    csrr x14, 0x31f

    #Unmapped address 0xbad testing: random write/read operations
    #Address 0xbad read value
    csrr x14, 0xbad

    #Address 0xbad read value
    csrr x14, 0xbad

    #Address 0xbad Write value 0xfede0d4c
    li x3, 0xfede0d4c
    csrw 0xbad, x3

    #Mapped address 0x3b7 (pmpaddr7) testing: random write/read operations
    #Address 0x3b7 read value
    csrr x14, 0x3b7

    #Unmapped address 0x965 testing: random write/read operations
    #Address 0x965 Write value 0x5e4f4729
    li x3, 0x5e4f4729
    csrw 0x965, x3

    #Unmapped address 0xc1d testing: random write/read operations
    #Address 0xc1d Write value 0xa0485ab7
    li x3, 0xa0485ab7
    csrw 0xc1d, x3

    #Address 0xc1d Write value 0x9453e7b2
    li x3, 0x9453e7b2
    csrw 0xc1d, x3

    #Unmapped address 0xf7b testing: random write/read operations
    #Address 0xf7b read value
    csrr x14, 0xf7b

    #Address 0xf7b Write value 0x3b5113eb
    li x3, 0x3b5113eb
    csrw 0xf7b, x3

    #Address 0xf7b Write value 0xfcadca32
    li x3, 0xfcadca32
    csrw 0xf7b, x3

    #Address 0xf7b Write value 0x73b531a2
    li x3, 0x73b531a2
    csrw 0xf7b, x3

    #Address 0xf7b read value
    csrr x14, 0xf7b

    #Unmapped address 0x9eb testing: random write/read operations
    #Address 0x9eb Write value 0x13058ac3
    li x3, 0x13058ac3
    csrw 0x9eb, x3

    #Address 0x9eb Write value 0x887da921
    li x3, 0x887da921
    csrw 0x9eb, x3

    #Address 0x9eb Write value 0x8212d69b
    li x3, 0x8212d69b
    csrw 0x9eb, x3

    #Address 0x9eb read value
    csrr x14, 0x9eb

    #Unmapped address 0x72a testing: random write/read operations
    #Address 0x72a Write value 0x47b5f782
    li x3, 0x47b5f782
    csrw 0x72a, x3

    #Address 0x72a read value
    csrr x14, 0x72a

    #Address 0x72a read value
    csrr x14, 0x72a

    #Address 0x72a read value
    csrr x14, 0x72a

    #Address 0x72a read value
    csrr x14, 0x72a

    #Unmapped address 0x2b7 testing: random write/read operations
    #Address 0x2b7 read value
    csrr x14, 0x2b7

    #Address 0x2b7 Write value 0x125a51d
    li x3, 0x125a51d
    csrw 0x2b7, x3

    #Address 0x2b7 read value
    csrr x14, 0x2b7

    #Address 0x2b7 Write value 0x46e918cc
    li x3, 0x46e918cc
    csrw 0x2b7, x3

    #Address 0x2b7 read value
    csrr x14, 0x2b7

    #Unmapped address 0x35b testing: random write/read operations
    #Address 0x35b read value
    csrr x14, 0x35b

    #Address 0x35b Write value 0xbf055dad
    li x3, 0xbf055dad
    csrw 0x35b, x3

    #Unmapped address 0xdf4 testing: random write/read operations
    #Address 0xdf4 read value
    csrr x14, 0xdf4

    #Address 0xdf4 Write value 0x2aa2130b
    li x3, 0x2aa2130b
    csrw 0xdf4, x3

    #Address 0xdf4 Write value 0xfa061f16
    li x3, 0xfa061f16
    csrw 0xdf4, x3

    #Mapped address 0x344 (mip) testing: random write/read operations
    #Address 0x344 read value
    csrr x14, 0x344

    #Address 0x344 Write value 0xdc069e4a
    li x3, 0xdc069e4a
    csrw 0x344, x3

    #Unmapped address 0x899 testing: random write/read operations
    #Address 0x899 read value
    csrr x14, 0x899

    #Address 0x899 Write value 0x230c566e
    li x3, 0x230c566e
    csrw 0x899, x3

    #Unmapped address 0xdbd testing: random write/read operations
    #Address 0xdbd Write value 0x42fab867
    li x3, 0x42fab867
    csrw 0xdbd, x3

    #Address 0xdbd Write value 0x4f0d3689
    li x3, 0x4f0d3689
    csrw 0xdbd, x3

    #Address 0xdbd Write value 0xddaae824
    li x3, 0xddaae824
    csrw 0xdbd, x3

    #Address 0xdbd read value
    csrr x14, 0xdbd

    #Unmapped address 0x59a testing: random write/read operations
    #Address 0x59a Write value 0xc9a6ef4b
    li x3, 0xc9a6ef4b
    csrw 0x59a, x3

    #Address 0x59a read value
    csrr x14, 0x59a

    #Address 0x59a Write value 0x2c49f3bf
    li x3, 0x2c49f3bf
    csrw 0x59a, x3

    #Address 0x59a Write value 0xf867b1bd
    li x3, 0xf867b1bd
    csrw 0x59a, x3

    #Unmapped address 0xb70 testing: random write/read operations
    #Address 0xb70 read value
    csrr x14, 0xb70

    #Address 0xb70 Write value 0x4f60c90e
    li x3, 0x4f60c90e
    csrw 0xb70, x3

    #Address 0xb70 Write value 0x200feeb1
    li x3, 0x200feeb1
    csrw 0xb70, x3

    #Address 0xb70 read value
    csrr x14, 0xb70

    #Address 0xb70 read value
    csrr x14, 0xb70

    #Unmapped address 0xecc testing: random write/read operations
    #Address 0xecc Write value 0x65568fc9
    li x3, 0x65568fc9
    csrw 0xecc, x3

    #Address 0xecc read value
    csrr x14, 0xecc

    #Address 0xecc Write value 0x3a35a6d8
    li x3, 0x3a35a6d8
    csrw 0xecc, x3

    #Unmapped address 0x8bc testing: random write/read operations
    #Address 0x8bc Write value 0x22915286
    li x3, 0x22915286
    csrw 0x8bc, x3

    #Address 0x8bc Write value 0xac7061
    li x3, 0xac7061
    csrw 0x8bc, x3

    #Address 0x8bc Write value 0x439dcb25
    li x3, 0x439dcb25
    csrw 0x8bc, x3

    #Unmapped address 0x159 testing: random write/read operations
    #Address 0x159 Write value 0x2a93f42c
    li x3, 0x2a93f42c
    csrw 0x159, x3

    #Address 0x159 read value
    csrr x14, 0x159

    #Unmapped address 0xf6e testing: random write/read operations
    #Address 0xf6e read value
    csrr x14, 0xf6e

    #Address 0xf6e read value
    csrr x14, 0xf6e

    #Unmapped address 0x6b testing: random write/read operations
    #Address 0x6b Write value 0x4f1627df
    li x3, 0x4f1627df
    csrw 0x6b, x3

    #Address 0x6b read value
    csrr x14, 0x6b

    #Address 0x6b Write value 0x6a811d57
    li x3, 0x6a811d57
    csrw 0x6b, x3

    #Address 0x6b read value
    csrr x14, 0x6b

    #Unmapped address 0x6f7 testing: random write/read operations
    #Address 0x6f7 read value
    csrr x14, 0x6f7

    #Unmapped address 0x8d1 testing: random write/read operations
    #Address 0x8d1 Write value 0x1661f8ad
    li x3, 0x1661f8ad
    csrw 0x8d1, x3

    #Address 0x8d1 Write value 0x2fc34710
    li x3, 0x2fc34710
    csrw 0x8d1, x3

    #Address 0x8d1 read value
    csrr x14, 0x8d1

    #Address 0x8d1 read value
    csrr x14, 0x8d1

    #Address 0x8d1 read value
    csrr x14, 0x8d1

    #Unmapped address 0x67d testing: random write/read operations
    #Address 0x67d Write value 0x2de68ef4
    li x3, 0x2de68ef4
    csrw 0x67d, x3

    #Address 0x67d Write value 0xed0d6b95
    li x3, 0xed0d6b95
    csrw 0x67d, x3

    #Address 0x67d read value
    csrr x14, 0x67d

    #Address 0x67d read value
    csrr x14, 0x67d

    #Address 0x67d read value
    csrr x14, 0x67d

    #Unmapped address 0x8ba testing: random write/read operations
    #Address 0x8ba Write value 0xc32e529e
    li x3, 0xc32e529e
    csrw 0x8ba, x3

    #Address 0x8ba read value
    csrr x14, 0x8ba

    #Mapped address 0xb95 (mhpmcounterh21) testing: random write/read operations
    #Address 0xb95 Write value 0x21f5e81a
    li x3, 0x21f5e81a
    csrw 0xb95, x3

    #Address 0xb95 Write value 0xd681a778
    li x3, 0xd681a778
    csrw 0xb95, x3

    #Address 0xb95 Write value 0xc6b3755c
    li x3, 0xc6b3755c
    csrw 0xb95, x3

    #Address 0xb95 Write value 0x3a854276
    li x3, 0x3a854276
    csrw 0xb95, x3

    #Unmapped address 0xc1f testing: random write/read operations
    #Address 0xc1f read value
    csrr x14, 0xc1f

    #Address 0xc1f read value
    csrr x14, 0xc1f

    #Unmapped address 0x69e testing: random write/read operations
    #Address 0x69e read value
    csrr x14, 0x69e

    #Address 0x69e Write value 0x375eb747
    li x3, 0x375eb747
    csrw 0x69e, x3

    #Address 0x69e Write value 0x2a99fb5c
    li x3, 0x2a99fb5c
    csrw 0x69e, x3

    #Address 0x69e Write value 0x623221b8
    li x3, 0x623221b8
    csrw 0x69e, x3

    #Unmapped address 0xf43 testing: random write/read operations
    #Address 0xf43 read value
    csrr x14, 0xf43

    #Address 0xf43 read value
    csrr x14, 0xf43

    #Address 0xf43 read value
    csrr x14, 0xf43

    #Address 0xf43 Write value 0xb03e1a95
    li x3, 0xb03e1a95
    csrw 0xf43, x3

    #Unmapped address 0x1bd testing: random write/read operations
    #Address 0x1bd read value
    csrr x14, 0x1bd

    #Unmapped address 0x3c9 testing: random write/read operations
    #Address 0x3c9 Write value 0x1ae4145e
    li x3, 0x1ae4145e
    csrw 0x3c9, x3

    #Address 0x3c9 read value
    csrr x14, 0x3c9

    #Address 0x3c9 read value
    csrr x14, 0x3c9

    #Address 0x3c9 read value
    csrr x14, 0x3c9

    #Address 0x3c9 read value
    csrr x14, 0x3c9

    #Unmapped address 0x884 testing: random write/read operations
    #Address 0x884 Write value 0xbeb7fa47
    li x3, 0xbeb7fa47
    csrw 0x884, x3

    #Unmapped address 0xdcf testing: random write/read operations
    #Address 0xdcf Write value 0x5a761b20
    li x3, 0x5a761b20
    csrw 0xdcf, x3

    #Unmapped address 0xf33 testing: random write/read operations
    #Address 0xf33 Write value 0xaede06c
    li x3, 0xaede06c
    csrw 0xf33, x3

    #Unmapped address 0xd01 testing: random write/read operations
    #Address 0xd01 read value
    csrr x14, 0xd01

    #Address 0xd01 read value
    csrr x14, 0xd01

    #Address 0xd01 read value
    csrr x14, 0xd01

    #Address 0xd01 read value
    csrr x14, 0xd01

    #Unmapped address 0x89d testing: random write/read operations
    #Address 0x89d read value
    csrr x14, 0x89d

    #Address 0x89d Write value 0x6a984116
    li x3, 0x6a984116
    csrw 0x89d, x3

    #Address 0x89d read value
    csrr x14, 0x89d

    #Unmapped address 0xcae testing: random write/read operations
    #Address 0xcae Write value 0xf32e6db1
    li x3, 0xf32e6db1
    csrw 0xcae, x3

    #Address 0xcae read value
    csrr x14, 0xcae

    #Address 0xcae Write value 0xca3b3efd
    li x3, 0xca3b3efd
    csrw 0xcae, x3

    #Unmapped address 0x72f testing: random write/read operations
    #Address 0x72f Write value 0x118050b4
    li x3, 0x118050b4
    csrw 0x72f, x3

    #Address 0x72f Write value 0x361870b4
    li x3, 0x361870b4
    csrw 0x72f, x3

    #Address 0x72f Write value 0xbdd3b2f8
    li x3, 0xbdd3b2f8
    csrw 0x72f, x3

    #Unmapped address 0x7c8 testing: random write/read operations
    #Address 0x7c8 Write value 0x46c31dc9
    li x3, 0x46c31dc9
    csrw 0x7c8, x3

    #Address 0x7c8 Write value 0x4013381
    li x3, 0x4013381
    csrw 0x7c8, x3

    #Address 0x7c8 Write value 0x8ec0d044
    li x3, 0x8ec0d044
    csrw 0x7c8, x3

    #Address 0x7c8 Write value 0x566051fa
    li x3, 0x566051fa
    csrw 0x7c8, x3

    #Address 0x7c8 read value
    csrr x14, 0x7c8

    #Unmapped address 0x991 testing: random write/read operations
    #Address 0x991 Write value 0x68d4a4f4
    li x3, 0x68d4a4f4
    csrw 0x991, x3

    #Address 0x991 Write value 0x11bc0747
    li x3, 0x11bc0747
    csrw 0x991, x3

    #Address 0x991 Write value 0xc6127346
    li x3, 0xc6127346
    csrw 0x991, x3

    #Address 0x991 Write value 0x76ede441
    li x3, 0x76ede441
    csrw 0x991, x3

    #Unmapped address 0x88c testing: random write/read operations
    #Address 0x88c read value
    csrr x14, 0x88c

    #Address 0x88c Write value 0x1176794
    li x3, 0x1176794
    csrw 0x88c, x3

    #Unmapped address 0x419 testing: random write/read operations
    #Address 0x419 read value
    csrr x14, 0x419

    #Address 0x419 Write value 0x63119f37
    li x3, 0x63119f37
    csrw 0x419, x3

    #Address 0x419 read value
    csrr x14, 0x419

    #Address 0x419 Write value 0xcee77695
    li x3, 0xcee77695
    csrw 0x419, x3

    #Address 0x419 Write value 0xa4d0d1d7
    li x3, 0xa4d0d1d7
    csrw 0x419, x3

    #Unmapped address 0x57e testing: random write/read operations
    #Address 0x57e read value
    csrr x14, 0x57e

    #Address 0x57e read value
    csrr x14, 0x57e

    #Address 0x57e Write value 0xd0048ec
    li x3, 0xd0048ec
    csrw 0x57e, x3

    #Address 0x57e Write value 0xfd184c4d
    li x3, 0xfd184c4d
    csrw 0x57e, x3

    #Address 0x57e read value
    csrr x14, 0x57e

    #Unmapped address 0xe95 testing: random write/read operations
    #Address 0xe95 read value
    csrr x14, 0xe95

    #Address 0xe95 read value
    csrr x14, 0xe95

    #Mapped address 0x3a0 (pmpcfg0) testing: random write/read operations
    #Address 0x3a0 Write value 0x4eddc4d9
    li x3, 0x4eddc4d9
    csrw 0x3a0, x3

    #Address 0x3a0 read value
    csrr x14, 0x3a0

    #Address 0x3a0 read value
    csrr x14, 0x3a0

    #Address 0x3a0 Write value 0xfc0fffae
    li x3, 0xfc0fffae
    csrw 0x3a0, x3

    #Unmapped address 0x121 testing: random write/read operations
    #Address 0x121 read value
    csrr x14, 0x121

    #Address 0x121 Write value 0xe242fdcf
    li x3, 0xe242fdcf
    csrw 0x121, x3

    #Address 0x121 read value
    csrr x14, 0x121

    #Address 0x121 Write value 0xf37510cf
    li x3, 0xf37510cf
    csrw 0x121, x3

    #Address 0x121 Write value 0x35ad195d
    li x3, 0x35ad195d
    csrw 0x121, x3

    #Unmapped address 0xd4f testing: random write/read operations
    #Address 0xd4f Write value 0xc195cb2
    li x3, 0xc195cb2
    csrw 0xd4f, x3

    #Address 0xd4f Write value 0x7de22acb
    li x3, 0x7de22acb
    csrw 0xd4f, x3

    #Unmapped address 0xfa1 testing: random write/read operations
    #Address 0xfa1 Write value 0x77c7fd24
    li x3, 0x77c7fd24
    csrw 0xfa1, x3

    #Unmapped address 0x888 testing: random write/read operations
    #Address 0x888 Write value 0x1e6912
    li x3, 0x1e6912
    csrw 0x888, x3

    #Address 0x888 Write value 0x8d10b287
    li x3, 0x8d10b287
    csrw 0x888, x3

    #Unmapped address 0x235 testing: random write/read operations
    #Address 0x235 read value
    csrr x14, 0x235

    #Address 0x235 Write value 0x98185ce
    li x3, 0x98185ce
    csrw 0x235, x3

    #Address 0x235 read value
    csrr x14, 0x235

    #Address 0x235 Write value 0xc0110aa
    li x3, 0xc0110aa
    csrw 0x235, x3

    #Address 0x235 Write value 0xef5e5e02
    li x3, 0xef5e5e02
    csrw 0x235, x3

    #Unmapped address 0x81f testing: random write/read operations
    #Address 0x81f Write value 0x93df102b
    li x3, 0x93df102b
    csrw 0x81f, x3

    #Address 0x81f read value
    csrr x14, 0x81f

    #Address 0x81f read value
    csrr x14, 0x81f

    #Unmapped address 0x249 testing: random write/read operations
    #Address 0x249 Write value 0xdfad7cd
    li x3, 0xdfad7cd
    csrw 0x249, x3

    #Address 0x249 Write value 0xd96a72a6
    li x3, 0xd96a72a6
    csrw 0x249, x3

    #Address 0x249 Write value 0xf1a1afd3
    li x3, 0xf1a1afd3
    csrw 0x249, x3

    #Address 0x249 read value
    csrr x14, 0x249

    #Unmapped address 0x2fc testing: random write/read operations
    #Address 0x2fc Write value 0x56df4a3f
    li x3, 0x56df4a3f
    csrw 0x2fc, x3

    #Address 0x2fc Write value 0x79b49fce
    li x3, 0x79b49fce
    csrw 0x2fc, x3

    #Address 0x2fc Write value 0x32f6936c
    li x3, 0x32f6936c
    csrw 0x2fc, x3

    #Address 0x2fc Write value 0xffaddf92
    li x3, 0xffaddf92
    csrw 0x2fc, x3

    #Address 0x2fc read value
    csrr x14, 0x2fc

    #Unmapped address 0x9c3 testing: random write/read operations
    #Address 0x9c3 read value
    csrr x14, 0x9c3

    #Address 0x9c3 read value
    csrr x14, 0x9c3

    #Address 0x9c3 Write value 0x92881a9b
    li x3, 0x92881a9b
    csrw 0x9c3, x3

    #Address 0x9c3 Write value 0x74874e23
    li x3, 0x74874e23
    csrw 0x9c3, x3

    #Unmapped address 0xf21 testing: random write/read operations
    #Address 0xf21 Write value 0x88fc6aa2
    li x3, 0x88fc6aa2
    csrw 0xf21, x3

    #Address 0xf21 Write value 0x1e6eb070
    li x3, 0x1e6eb070
    csrw 0xf21, x3

    #Address 0xf21 read value
    csrr x14, 0xf21

    #Address 0xf21 Write value 0x6c2db0f8
    li x3, 0x6c2db0f8
    csrw 0xf21, x3

    #Unmapped address 0x471 testing: random write/read operations
    #Address 0x471 read value
    csrr x14, 0x471

    #Address 0x471 Write value 0xd05af86e
    li x3, 0xd05af86e
    csrw 0x471, x3

    #Address 0x471 read value
    csrr x14, 0x471

    #Address 0x471 read value
    csrr x14, 0x471

    #Address 0x471 read value
    csrr x14, 0x471

    #Unmapped address 0x1f1 testing: random write/read operations
    #Address 0x1f1 read value
    csrr x14, 0x1f1

    #Address 0x1f1 read value
    csrr x14, 0x1f1

    #Address 0x1f1 read value
    csrr x14, 0x1f1

    #Unmapped address 0xa21 testing: random write/read operations
    #Address 0xa21 read value
    csrr x14, 0xa21

    #Address 0xa21 Write value 0x4caaa087
    li x3, 0x4caaa087
    csrw 0xa21, x3

    #Unmapped address 0x836 testing: random write/read operations
    #Address 0x836 Write value 0xfa63919d
    li x3, 0xfa63919d
    csrw 0x836, x3

    #Address 0x836 read value
    csrr x14, 0x836

    #Address 0x836 read value
    csrr x14, 0x836

    #Address 0x836 Write value 0xbce8c83e
    li x3, 0xbce8c83e
    csrw 0x836, x3

    #Unmapped address 0x1b9 testing: random write/read operations
    #Address 0x1b9 read value
    csrr x14, 0x1b9

    #Address 0x1b9 Write value 0x4c13e607
    li x3, 0x4c13e607
    csrw 0x1b9, x3

    #Unmapped address 0x5f8 testing: random write/read operations
    #Address 0x5f8 Write value 0x16d8b831
    li x3, 0x16d8b831
    csrw 0x5f8, x3

    #Unmapped address 0xd52 testing: random write/read operations
    #Address 0xd52 Write value 0x651f27c
    li x3, 0x651f27c
    csrw 0xd52, x3

    #Address 0xd52 read value
    csrr x14, 0xd52

    #Unmapped address 0x52 testing: random write/read operations
    #Address 0x52 Write value 0x892d3dbc
    li x3, 0x892d3dbc
    csrw 0x52, x3

    #Unmapped address 0xee2 testing: random write/read operations
    #Address 0xee2 read value
    csrr x14, 0xee2

    #Address 0xee2 read value
    csrr x14, 0xee2

    #Address 0xee2 read value
    csrr x14, 0xee2

    #Address 0xee2 read value
    csrr x14, 0xee2

    #Unmapped address 0x736 testing: random write/read operations
    #Address 0x736 read value
    csrr x14, 0x736

    #Address 0x736 read value
    csrr x14, 0x736

    #Address 0x736 Write value 0x3e484e07
    li x3, 0x3e484e07
    csrw 0x736, x3

    #Unmapped address 0xdee testing: random write/read operations
    #Address 0xdee Write value 0xb3816dc8
    li x3, 0xb3816dc8
    csrw 0xdee, x3

    #Address 0xdee Write value 0xe42610f4
    li x3, 0xe42610f4
    csrw 0xdee, x3

    #Unmapped address 0x925 testing: random write/read operations
    #Address 0x925 Write value 0xe6a6c601
    li x3, 0xe6a6c601
    csrw 0x925, x3

    #Address 0x925 read value
    csrr x14, 0x925

    #Address 0x925 read value
    csrr x14, 0x925

    #Address 0x925 Write value 0x40791e3f
    li x3, 0x40791e3f
    csrw 0x925, x3

    #Address 0x925 read value
    csrr x14, 0x925

    #Unmapped address 0x17 testing: random write/read operations
    #Address 0x17 Write value 0x9ab8cfa8
    li x3, 0x9ab8cfa8
    csrw 0x17, x3

    #Address 0x17 Write value 0x61cf104c
    li x3, 0x61cf104c
    csrw 0x17, x3

    #Address 0x17 Write value 0xa37f35c0
    li x3, 0xa37f35c0
    csrw 0x17, x3

    #Unmapped address 0xa8d testing: random write/read operations
    #Address 0xa8d Write value 0x93b11910
    li x3, 0x93b11910
    csrw 0xa8d, x3

    #Address 0xa8d read value
    csrr x14, 0xa8d

    #Address 0xa8d Write value 0xaa246279
    li x3, 0xaa246279
    csrw 0xa8d, x3

    #Unmapped address 0xcf0 testing: random write/read operations
    #Address 0xcf0 read value
    csrr x14, 0xcf0

    #Address 0xcf0 Write value 0xca814fae
    li x3, 0xca814fae
    csrw 0xcf0, x3

    #Unmapped address 0xad1 testing: random write/read operations
    #Address 0xad1 read value
    csrr x14, 0xad1

    #Address 0xad1 read value
    csrr x14, 0xad1

    #Unmapped address 0xc9c testing: random write/read operations
    #Address 0xc9c Write value 0x8c2b6188
    li x3, 0x8c2b6188
    csrw 0xc9c, x3

    #Address 0xc9c read value
    csrr x14, 0xc9c

    #Address 0xc9c Write value 0x895ca0f3
    li x3, 0x895ca0f3
    csrw 0xc9c, x3

    #Unmapped address 0x25e testing: random write/read operations
    #Address 0x25e read value
    csrr x14, 0x25e

    #Address 0x25e Write value 0x76ab33a5
    li x3, 0x76ab33a5
    csrw 0x25e, x3

    #Unmapped address 0xd27 testing: random write/read operations
    #Address 0xd27 read value
    csrr x14, 0xd27

    #Unmapped address 0xc12 testing: random write/read operations
    #Address 0xc12 read value
    csrr x14, 0xc12

    #Address 0xc12 read value
    csrr x14, 0xc12

    #Address 0xc12 Write value 0x87f7c243
    li x3, 0x87f7c243
    csrw 0xc12, x3

    #Unmapped address 0x50a testing: random write/read operations
    #Address 0x50a Write value 0x42131224
    li x3, 0x42131224
    csrw 0x50a, x3

    #Unmapped address 0x2aa testing: random write/read operations
    #Address 0x2aa Write value 0x7bd3e1b0
    li x3, 0x7bd3e1b0
    csrw 0x2aa, x3

    #Address 0x2aa Write value 0xc5713240
    li x3, 0xc5713240
    csrw 0x2aa, x3

    #Address 0x2aa Write value 0x93790fb1
    li x3, 0x93790fb1
    csrw 0x2aa, x3

    #Address 0x2aa Write value 0x1a1b3f37
    li x3, 0x1a1b3f37
    csrw 0x2aa, x3

    #Address 0x2aa Write value 0x93ef78b4
    li x3, 0x93ef78b4
    csrw 0x2aa, x3

    #Unmapped address 0x50f testing: random write/read operations
    #Address 0x50f read value
    csrr x14, 0x50f

    #Address 0x50f read value
    csrr x14, 0x50f

    #Address 0x50f Write value 0x3ad85624
    li x3, 0x3ad85624
    csrw 0x50f, x3

    #Unmapped address 0x805 testing: random write/read operations
    #Address 0x805 read value
    csrr x14, 0x805

    #Address 0x805 Write value 0xb0734410
    li x3, 0xb0734410
    csrw 0x805, x3

    #Unmapped address 0x4ce testing: random write/read operations
    #Address 0x4ce read value
    csrr x14, 0x4ce

    #Address 0x4ce read value
    csrr x14, 0x4ce

    #Address 0x4ce read value
    csrr x14, 0x4ce

    #Unmapped address 0xf80 testing: random write/read operations
    #Address 0xf80 Write value 0x9c4a1db5
    li x3, 0x9c4a1db5
    csrw 0xf80, x3

    #Address 0xf80 read value
    csrr x14, 0xf80

    #Address 0xf80 Write value 0xc89c2f3c
    li x3, 0xc89c2f3c
    csrw 0xf80, x3

    #Address 0xf80 Write value 0x11bd74de
    li x3, 0x11bd74de
    csrw 0xf80, x3

    #Unmapped address 0x53d testing: random write/read operations
    #Address 0x53d read value
    csrr x14, 0x53d

    #Address 0x53d read value
    csrr x14, 0x53d

    #Unmapped address 0x76c testing: random write/read operations
    #Address 0x76c read value
    csrr x14, 0x76c

    #Address 0x76c read value
    csrr x14, 0x76c

    #Address 0x76c Write value 0x951b1260
    li x3, 0x951b1260
    csrw 0x76c, x3

    #Address 0x76c Write value 0x2c4ba889
    li x3, 0x2c4ba889
    csrw 0x76c, x3

    #Mapped address 0xb11 (mhpmcounter17) testing: random write/read operations
    #Address 0xb11 Write value 0x2b2b2e91
    li x3, 0x2b2b2e91
    csrw 0xb11, x3

    #Address 0xb11 read value
    csrr x14, 0xb11

    #Address 0xb11 read value
    csrr x14, 0xb11

    #Mapped address 0xb82 (minstreth) testing: random write/read operations
    #Address 0xb82 read value
    csrr x14, 0xb82

    #Address 0xb82 Write value 0x5852f7b6
    li x3, 0x5852f7b6
    csrw 0xb82, x3

    #Address 0xb82 read value
    csrr x14, 0xb82

    #Address 0xb82 Write value 0xe635aba1
    li x3, 0xe635aba1
    csrw 0xb82, x3

    #Unmapped address 0x1f testing: random write/read operations
    #Address 0x1f read value
    csrr x14, 0x1f

    #Address 0x1f read value
    csrr x14, 0x1f

    #Address 0x1f Write value 0x1d981dbf
    li x3, 0x1d981dbf
    csrw 0x1f, x3

    #Unmapped address 0x9c0 testing: random write/read operations
    #Address 0x9c0 Write value 0xcb12ce7c
    li x3, 0xcb12ce7c
    csrw 0x9c0, x3

    #Address 0x9c0 Write value 0x8751f6b3
    li x3, 0x8751f6b3
    csrw 0x9c0, x3

    #Address 0x9c0 read value
    csrr x14, 0x9c0

    #Unmapped address 0x470 testing: random write/read operations
    #Address 0x470 Write value 0xd4be3914
    li x3, 0xd4be3914
    csrw 0x470, x3

    #Unmapped address 0xa72 testing: random write/read operations
    #Address 0xa72 read value
    csrr x14, 0xa72

    #Address 0xa72 read value
    csrr x14, 0xa72

    #Address 0xa72 Write value 0xbdf539d8
    li x3, 0xbdf539d8
    csrw 0xa72, x3

    #Address 0xa72 read value
    csrr x14, 0xa72

    #Unmapped address 0x6c2 testing: random write/read operations
    #Address 0x6c2 Write value 0x8ec94cd4
    li x3, 0x8ec94cd4
    csrw 0x6c2, x3

    #Address 0x6c2 read value
    csrr x14, 0x6c2

    #Address 0x6c2 Write value 0xb9c582c0
    li x3, 0xb9c582c0
    csrw 0x6c2, x3

    #Address 0x6c2 read value
    csrr x14, 0x6c2

    #Unmapped address 0x466 testing: random write/read operations
    #Address 0x466 Write value 0x8993fad7
    li x3, 0x8993fad7
    csrw 0x466, x3

    #Address 0x466 read value
    csrr x14, 0x466

    #Address 0x466 Write value 0xedf82d56
    li x3, 0xedf82d56
    csrw 0x466, x3

    #Address 0x466 read value
    csrr x14, 0x466

    #Address 0x466 read value
    csrr x14, 0x466

    #Unmapped address 0x534 testing: random write/read operations
    #Address 0x534 read value
    csrr x14, 0x534

    #Address 0x534 read value
    csrr x14, 0x534

    #Address 0x534 read value
    csrr x14, 0x534

    #Address 0x534 Write value 0x87667a7a
    li x3, 0x87667a7a
    csrw 0x534, x3

    #Address 0x534 Write value 0xf16d9ed0
    li x3, 0xf16d9ed0
    csrw 0x534, x3

    #Unmapped address 0x89a testing: random write/read operations
    #Address 0x89a read value
    csrr x14, 0x89a

    #Unmapped address 0x4a1 testing: random write/read operations
    #Address 0x4a1 read value
    csrr x14, 0x4a1

    #Unmapped address 0xdfd testing: random write/read operations
    #Address 0xdfd read value
    csrr x14, 0xdfd

    #Address 0xdfd Write value 0xbee1f2a
    li x3, 0xbee1f2a
    csrw 0xdfd, x3

    #Address 0xdfd read value
    csrr x14, 0xdfd

    #Address 0xdfd read value
    csrr x14, 0xdfd

    #Unmapped address 0xba1 testing: random write/read operations
    #Address 0xba1 read value
    csrr x14, 0xba1

    #Address 0xba1 read value
    csrr x14, 0xba1

    #Address 0xba1 Write value 0xebe039b2
    li x3, 0xebe039b2
    csrw 0xba1, x3

    #Unmapped address 0x11c testing: random write/read operations
    #Address 0x11c Write value 0xe3d699c0
    li x3, 0xe3d699c0
    csrw 0x11c, x3

    #Address 0x11c Write value 0x7a203ec6
    li x3, 0x7a203ec6
    csrw 0x11c, x3

    #Address 0x11c Write value 0xc4224c36
    li x3, 0xc4224c36
    csrw 0x11c, x3

    #Address 0x11c Write value 0x64d6c8e4
    li x3, 0x64d6c8e4
    csrw 0x11c, x3

    #Address 0x11c Write value 0x9e33c8b5
    li x3, 0x9e33c8b5
    csrw 0x11c, x3

    #Unmapped address 0xaf9 testing: random write/read operations
    #Address 0xaf9 Write value 0xf4069ed7
    li x3, 0xf4069ed7
    csrw 0xaf9, x3

    #Address 0xaf9 read value
    csrr x14, 0xaf9

    #Address 0xaf9 Write value 0x74773e47
    li x3, 0x74773e47
    csrw 0xaf9, x3

    #Unmapped address 0x36d testing: random write/read operations
    #Address 0x36d read value
    csrr x14, 0x36d

    #Address 0x36d read value
    csrr x14, 0x36d

    #Address 0x36d Write value 0x80d9334f
    li x3, 0x80d9334f
    csrw 0x36d, x3

    #Address 0x36d read value
    csrr x14, 0x36d

    #Address 0x36d Write value 0x8d60c62a
    li x3, 0x8d60c62a
    csrw 0x36d, x3

    #Unmapped address 0xa02 testing: random write/read operations
    #Address 0xa02 Write value 0x1e1b3133
    li x3, 0x1e1b3133
    csrw 0xa02, x3

    #Address 0xa02 read value
    csrr x14, 0xa02

    #Address 0xa02 read value
    csrr x14, 0xa02

    #Address 0xa02 Write value 0xa768f004
    li x3, 0xa768f004
    csrw 0xa02, x3

    #Unmapped address 0xbd7 testing: random write/read operations
    #Address 0xbd7 Write value 0x93ff4927
    li x3, 0x93ff4927
    csrw 0xbd7, x3

    #Address 0xbd7 read value
    csrr x14, 0xbd7

    #Address 0xbd7 Write value 0x56bea3dd
    li x3, 0x56bea3dd
    csrw 0xbd7, x3

    #Address 0xbd7 Write value 0x43aaac
    li x3, 0x43aaac
    csrw 0xbd7, x3

    #Unmapped address 0xefe testing: random write/read operations
    #Address 0xefe Write value 0x72e6cb7e
    li x3, 0x72e6cb7e
    csrw 0xefe, x3

    #Address 0xefe read value
    csrr x14, 0xefe

    #Address 0xefe Write value 0x4a719d32
    li x3, 0x4a719d32
    csrw 0xefe, x3

    #Address 0xefe read value
    csrr x14, 0xefe

    #Unmapped address 0x397 testing: random write/read operations
    #Address 0x397 Write value 0x4feb73bd
    li x3, 0x4feb73bd
    csrw 0x397, x3

    #Address 0x397 read value
    csrr x14, 0x397

    #Address 0x397 Write value 0xaf37fbf7
    li x3, 0xaf37fbf7
    csrw 0x397, x3

    #Address 0x397 read value
    csrr x14, 0x397

    #Address 0x397 read value
    csrr x14, 0x397

    #Unmapped address 0xfe2 testing: random write/read operations
    #Address 0xfe2 Write value 0x2dee7797
    li x3, 0x2dee7797
    csrw 0xfe2, x3

    #Address 0xfe2 read value
    csrr x14, 0xfe2

    #Address 0xfe2 read value
    csrr x14, 0xfe2

    #Unmapped address 0x744 testing: random write/read operations
    #Address 0x744 Write value 0xc4494764
    li x3, 0xc4494764
    csrw 0x744, x3

    #Address 0x744 Write value 0x494ff169
    li x3, 0x494ff169
    csrw 0x744, x3

    #Address 0x744 Write value 0x10bb6573
    li x3, 0x10bb6573
    csrw 0x744, x3

    #Address 0x744 read value
    csrr x14, 0x744

    #Unmapped address 0x839 testing: random write/read operations
    #Address 0x839 read value
    csrr x14, 0x839

    #Address 0x839 read value
    csrr x14, 0x839

    #Unmapped address 0x3a4 testing: random write/read operations
    #Address 0x3a4 read value
    csrr x14, 0x3a4

    #Address 0x3a4 Write value 0x4c14be51
    li x3, 0x4c14be51
    csrw 0x3a4, x3

    #Address 0x3a4 Write value 0x4613b259
    li x3, 0x4613b259
    csrw 0x3a4, x3

    #Unmapped address 0xbe7 testing: random write/read operations
    #Address 0xbe7 Write value 0xf4a31973
    li x3, 0xf4a31973
    csrw 0xbe7, x3

    #Address 0xbe7 Write value 0xcc26ec2d
    li x3, 0xcc26ec2d
    csrw 0xbe7, x3

    #Unmapped address 0xea6 testing: random write/read operations
    #Address 0xea6 Write value 0x6f0b114c
    li x3, 0x6f0b114c
    csrw 0xea6, x3

    #Address 0xea6 Write value 0x18d73295
    li x3, 0x18d73295
    csrw 0xea6, x3

    #Address 0xea6 Write value 0x769f98d4
    li x3, 0x769f98d4
    csrw 0xea6, x3

    #Address 0xea6 Write value 0xd8ef3c01
    li x3, 0xd8ef3c01
    csrw 0xea6, x3

    #Address 0xea6 read value
    csrr x14, 0xea6

    #Unmapped address 0xf4a testing: random write/read operations
    #Address 0xf4a read value
    csrr x14, 0xf4a

    #Address 0xf4a read value
    csrr x14, 0xf4a

    #Address 0xf4a read value
    csrr x14, 0xf4a

    #Unmapped address 0xf70 testing: random write/read operations
    #Address 0xf70 read value
    csrr x14, 0xf70

    #Address 0xf70 read value
    csrr x14, 0xf70

    #Address 0xf70 Write value 0xd751b716
    li x3, 0xd751b716
    csrw 0xf70, x3

    #Address 0xf70 read value
    csrr x14, 0xf70

    #Address 0xf70 read value
    csrr x14, 0xf70

    #Unmapped address 0x480 testing: random write/read operations
    #Address 0x480 read value
    csrr x14, 0x480

    #Address 0x480 Write value 0x17e331ca
    li x3, 0x17e331ca
    csrw 0x480, x3

    #Address 0x480 Write value 0xafdc8660
    li x3, 0xafdc8660
    csrw 0x480, x3

    #Address 0x480 Write value 0x76cb10cb
    li x3, 0x76cb10cb
    csrw 0x480, x3

    #Address 0x480 read value
    csrr x14, 0x480

    #Unmapped address 0x531 testing: random write/read operations
    #Address 0x531 Write value 0x6f7e15dd
    li x3, 0x6f7e15dd
    csrw 0x531, x3

    #Address 0x531 Write value 0xf8c46aba
    li x3, 0xf8c46aba
    csrw 0x531, x3

    #Address 0x531 Write value 0x3da5dcd6
    li x3, 0x3da5dcd6
    csrw 0x531, x3

    #Address 0x531 read value
    csrr x14, 0x531

    #Address 0x531 read value
    csrr x14, 0x531

    #Unmapped address 0x558 testing: random write/read operations
    #Address 0x558 Write value 0xf9013c5a
    li x3, 0xf9013c5a
    csrw 0x558, x3

    #Address 0x558 Write value 0x267071bd
    li x3, 0x267071bd
    csrw 0x558, x3

    #Address 0x558 read value
    csrr x14, 0x558

    #Address 0x558 read value
    csrr x14, 0x558

    #Unmapped address 0xa2b testing: random write/read operations
    #Address 0xa2b read value
    csrr x14, 0xa2b

    #Address 0xa2b read value
    csrr x14, 0xa2b

    #Address 0xa2b read value
    csrr x14, 0xa2b

    #Address 0xa2b read value
    csrr x14, 0xa2b

    #Address 0xa2b read value
    csrr x14, 0xa2b

    #Unmapped address 0x4d5 testing: random write/read operations
    #Address 0x4d5 Write value 0xea90fe8a
    li x3, 0xea90fe8a
    csrw 0x4d5, x3

    #Address 0x4d5 read value
    csrr x14, 0x4d5

    #Unmapped address 0x9d1 testing: random write/read operations
    #Address 0x9d1 Write value 0x5168cc6e
    li x3, 0x5168cc6e
    csrw 0x9d1, x3

    #Address 0x9d1 Write value 0xeebebc2d
    li x3, 0xeebebc2d
    csrw 0x9d1, x3

    #Unmapped address 0xedd testing: random write/read operations
    #Address 0xedd Write value 0x70a2b8b0
    li x3, 0x70a2b8b0
    csrw 0xedd, x3

    #Address 0xedd Write value 0x5b4d83db
    li x3, 0x5b4d83db
    csrw 0xedd, x3

    #Unmapped address 0x11e testing: random write/read operations
    #Address 0x11e read value
    csrr x14, 0x11e

    #Address 0x11e read value
    csrr x14, 0x11e

    #Address 0x11e Write value 0x5ef3efa2
    li x3, 0x5ef3efa2
    csrw 0x11e, x3

    #Address 0x11e read value
    csrr x14, 0x11e

    #Unmapped address 0x7a4 testing: random write/read operations
    #Address 0x7a4 Write value 0x277c9af9
    li x3, 0x277c9af9
    csrw 0x7a4, x3

    #Address 0x7a4 Write value 0xb9b6d86d
    li x3, 0xb9b6d86d
    csrw 0x7a4, x3

    #Address 0x7a4 Write value 0x2d34aca6
    li x3, 0x2d34aca6
    csrw 0x7a4, x3

    #Address 0x7a4 read value
    csrr x14, 0x7a4

    #Address 0x7a4 read value
    csrr x14, 0x7a4

    #Unmapped address 0xc77 testing: random write/read operations
    #Address 0xc77 Write value 0x1aea8db
    li x3, 0x1aea8db
    csrw 0xc77, x3

    #Address 0xc77 read value
    csrr x14, 0xc77

    #Address 0xc77 Write value 0x37b41d44
    li x3, 0x37b41d44
    csrw 0xc77, x3

    #Unmapped address 0xda9 testing: random write/read operations
    #Address 0xda9 read value
    csrr x14, 0xda9

    #Address 0xda9 Write value 0xbc37a99b
    li x3, 0xbc37a99b
    csrw 0xda9, x3

    #Unmapped address 0x20c testing: random write/read operations
    #Address 0x20c read value
    csrr x14, 0x20c

    #Address 0x20c read value
    csrr x14, 0x20c

    #Address 0x20c read value
    csrr x14, 0x20c

    #Address 0x20c read value
    csrr x14, 0x20c

    #Unmapped address 0x64f testing: random write/read operations
    #Address 0x64f read value
    csrr x14, 0x64f

    #Address 0x64f read value
    csrr x14, 0x64f

    #Address 0x64f Write value 0x55564f2e
    li x3, 0x55564f2e
    csrw 0x64f, x3

    #Address 0x64f read value
    csrr x14, 0x64f

    #Unmapped address 0x55d testing: random write/read operations
    #Address 0x55d Write value 0x67425f11
    li x3, 0x67425f11
    csrw 0x55d, x3

    #Address 0x55d Write value 0xf658941a
    li x3, 0xf658941a
    csrw 0x55d, x3

    #Address 0x55d read value
    csrr x14, 0x55d

    #Address 0x55d read value
    csrr x14, 0x55d

    #Address 0x55d Write value 0xf27491ec
    li x3, 0xf27491ec
    csrw 0x55d, x3

    #Unmapped address 0xe17 testing: random write/read operations
    #Address 0xe17 read value
    csrr x14, 0xe17

    #Address 0xe17 read value
    csrr x14, 0xe17

    #Address 0xe17 read value
    csrr x14, 0xe17

    #Address 0xe17 Write value 0x43e1a4cd
    li x3, 0x43e1a4cd
    csrw 0xe17, x3

    #Unmapped address 0xa0f testing: random write/read operations
    #Address 0xa0f read value
    csrr x14, 0xa0f

    #Address 0xa0f Write value 0x1cc0b62d
    li x3, 0x1cc0b62d
    csrw 0xa0f, x3

    #Address 0xa0f read value
    csrr x14, 0xa0f

    #Address 0xa0f read value
    csrr x14, 0xa0f

    #Address 0xa0f read value
    csrr x14, 0xa0f

    #Unmapped address 0x932 testing: random write/read operations
    #Address 0x932 Write value 0xdd8c147a
    li x3, 0xdd8c147a
    csrw 0x932, x3

    #Address 0x932 read value
    csrr x14, 0x932

    #Address 0x932 read value
    csrr x14, 0x932

    #Address 0x932 read value
    csrr x14, 0x932

    #Address 0x932 Write value 0x67210566
    li x3, 0x67210566
    csrw 0x932, x3

    #Unmapped address 0xadb testing: random write/read operations
    #Address 0xadb Write value 0x6122b4a9
    li x3, 0x6122b4a9
    csrw 0xadb, x3

    #Address 0xadb read value
    csrr x14, 0xadb

    #Unmapped address 0x2c testing: random write/read operations
    #Address 0x2c Write value 0x7602655f
    li x3, 0x7602655f
    csrw 0x2c, x3

    #Address 0x2c read value
    csrr x14, 0x2c

    #Address 0x2c read value
    csrr x14, 0x2c

    #Address 0x2c Write value 0xaeba0717
    li x3, 0xaeba0717
    csrw 0x2c, x3

    #Address 0x2c Write value 0x5e7c85f0
    li x3, 0x5e7c85f0
    csrw 0x2c, x3

    #Unmapped address 0x12a testing: random write/read operations
    #Address 0x12a read value
    csrr x14, 0x12a

    #Address 0x12a Write value 0x21126fcf
    li x3, 0x21126fcf
    csrw 0x12a, x3

    #Unmapped address 0xe07 testing: random write/read operations
    #Address 0xe07 Write value 0x845aaa58
    li x3, 0x845aaa58
    csrw 0xe07, x3

    #Address 0xe07 Write value 0xac4bfa01
    li x3, 0xac4bfa01
    csrw 0xe07, x3

    #Address 0xe07 Write value 0x3e398209
    li x3, 0x3e398209
    csrw 0xe07, x3

    #Address 0xe07 Write value 0x7d913880
    li x3, 0x7d913880
    csrw 0xe07, x3

    #Unmapped address 0x87f testing: random write/read operations
    #Address 0x87f read value
    csrr x14, 0x87f

    #Address 0x87f read value
    csrr x14, 0x87f

    #Address 0x87f read value
    csrr x14, 0x87f

    #Address 0x87f Write value 0x3ca3410f
    li x3, 0x3ca3410f
    csrw 0x87f, x3

    #Unmapped address 0x2a8 testing: random write/read operations
    #Address 0x2a8 read value
    csrr x14, 0x2a8

    #Address 0x2a8 read value
    csrr x14, 0x2a8

    #Address 0x2a8 read value
    csrr x14, 0x2a8

    #Unmapped address 0x655 testing: random write/read operations
    #Address 0x655 read value
    csrr x14, 0x655

    #Address 0x655 Write value 0x187a7c06
    li x3, 0x187a7c06
    csrw 0x655, x3

    #Address 0x655 read value
    csrr x14, 0x655

    #Unmapped address 0x46 testing: random write/read operations
    #Address 0x46 Write value 0xc0e0deec
    li x3, 0xc0e0deec
    csrw 0x46, x3

    #Address 0x46 Write value 0x4dee239c
    li x3, 0x4dee239c
    csrw 0x46, x3

    #Address 0x46 Write value 0x8eb3d570
    li x3, 0x8eb3d570
    csrw 0x46, x3

    #Unmapped address 0x638 testing: random write/read operations
    #Address 0x638 Write value 0x643c2335
    li x3, 0x643c2335
    csrw 0x638, x3

    #Address 0x638 Write value 0x9b967b46
    li x3, 0x9b967b46
    csrw 0x638, x3

    #Address 0x638 Write value 0x580d1c84
    li x3, 0x580d1c84
    csrw 0x638, x3

    #Address 0x638 Write value 0x70dd27e4
    li x3, 0x70dd27e4
    csrw 0x638, x3

    #Unmapped address 0xe36 testing: random write/read operations
    #Address 0xe36 read value
    csrr x14, 0xe36

    #Unmapped address 0xe2f testing: random write/read operations
    #Address 0xe2f Write value 0x11c91246
    li x3, 0x11c91246
    csrw 0xe2f, x3

    #Address 0xe2f Write value 0x85201e05
    li x3, 0x85201e05
    csrw 0xe2f, x3

    #Address 0xe2f read value
    csrr x14, 0xe2f

    #Address 0xe2f read value
    csrr x14, 0xe2f

    #Address 0xe2f read value
    csrr x14, 0xe2f

    #Unmapped address 0x1ca testing: random write/read operations
    #Address 0x1ca Write value 0x71de2588
    li x3, 0x71de2588
    csrw 0x1ca, x3

    #Address 0x1ca Write value 0x5c00d36
    li x3, 0x5c00d36
    csrw 0x1ca, x3

    #Unmapped address 0x797 testing: random write/read operations
    #Address 0x797 Write value 0xb5227a5d
    li x3, 0xb5227a5d
    csrw 0x797, x3

    #Address 0x797 Write value 0x24291242
    li x3, 0x24291242
    csrw 0x797, x3

    #Unmapped address 0xfe9 testing: random write/read operations
    #Address 0xfe9 Write value 0x5743a552
    li x3, 0x5743a552
    csrw 0xfe9, x3

    #Address 0xfe9 Write value 0x9963cb14
    li x3, 0x9963cb14
    csrw 0xfe9, x3

    #Address 0xfe9 read value
    csrr x14, 0xfe9

    #Address 0xfe9 read value
    csrr x14, 0xfe9

    #Unmapped address 0xc3a testing: random write/read operations
    #Address 0xc3a read value
    csrr x14, 0xc3a

    #Address 0xc3a Write value 0x4ac409fe
    li x3, 0x4ac409fe
    csrw 0xc3a, x3

    #Unmapped address 0x3d9 testing: random write/read operations
    #Address 0x3d9 Write value 0x3c4025b6
    li x3, 0x3c4025b6
    csrw 0x3d9, x3

    #Unmapped address 0xcfb testing: random write/read operations
    #Address 0xcfb read value
    csrr x14, 0xcfb

    #Unmapped address 0xd6e testing: random write/read operations
    #Address 0xd6e Write value 0x1a2d6016
    li x3, 0x1a2d6016
    csrw 0xd6e, x3

    #Address 0xd6e read value
    csrr x14, 0xd6e

    #Address 0xd6e Write value 0x6350fee2
    li x3, 0x6350fee2
    csrw 0xd6e, x3

    #Unmapped address 0x1ac testing: random write/read operations
    #Address 0x1ac Write value 0x97046da4
    li x3, 0x97046da4
    csrw 0x1ac, x3

    #Address 0x1ac read value
    csrr x14, 0x1ac

    #Unmapped address 0x223 testing: random write/read operations
    #Address 0x223 read value
    csrr x14, 0x223

    #Address 0x223 read value
    csrr x14, 0x223

    #Address 0x223 read value
    csrr x14, 0x223

    #Address 0x223 read value
    csrr x14, 0x223

    #Unmapped address 0x2d6 testing: random write/read operations
    #Address 0x2d6 Write value 0x625921c7
    li x3, 0x625921c7
    csrw 0x2d6, x3

    #Unmapped address 0x496 testing: random write/read operations
    #Address 0x496 read value
    csrr x14, 0x496

    #Address 0x496 read value
    csrr x14, 0x496

    #Unmapped address 0xaa testing: random write/read operations
    #Address 0xaa Write value 0xaeda1354
    li x3, 0xaeda1354
    csrw 0xaa, x3

    #Address 0xaa read value
    csrr x14, 0xaa

    #Address 0xaa read value
    csrr x14, 0xaa

    #Address 0xaa read value
    csrr x14, 0xaa

    #Address 0xaa Write value 0x6d9ee8fd
    li x3, 0x6d9ee8fd
    csrw 0xaa, x3

    #Unmapped address 0x9b7 testing: random write/read operations
    #Address 0x9b7 Write value 0x26834962
    li x3, 0x26834962
    csrw 0x9b7, x3

    #Unmapped address 0xc69 testing: random write/read operations
    #Address 0xc69 read value
    csrr x14, 0xc69

    #Address 0xc69 Write value 0x5232b6f0
    li x3, 0x5232b6f0
    csrw 0xc69, x3

    #Address 0xc69 Write value 0xda5fd331
    li x3, 0xda5fd331
    csrw 0xc69, x3

    #Unmapped address 0xb7a testing: random write/read operations
    #Address 0xb7a read value
    csrr x14, 0xb7a

    #Unmapped address 0xe80 testing: random write/read operations
    #Address 0xe80 Write value 0x5118c1e2
    li x3, 0x5118c1e2
    csrw 0xe80, x3

    #Unmapped address 0x6f2 testing: random write/read operations
    #Address 0x6f2 read value
    csrr x14, 0x6f2

    #Address 0x6f2 read value
    csrr x14, 0x6f2

    #Address 0x6f2 read value
    csrr x14, 0x6f2

    #Unmapped address 0x8e testing: random write/read operations
    #Address 0x8e Write value 0x53eb888c
    li x3, 0x53eb888c
    csrw 0x8e, x3

    #Unmapped address 0x96a testing: random write/read operations
    #Address 0x96a Write value 0xefb8a3b4
    li x3, 0xefb8a3b4
    csrw 0x96a, x3

    #Mapped address 0xb04 (mhpmcounter4) testing: random write/read operations
    #Address 0xb04 read value
    csrr x14, 0xb04

    #Address 0xb04 Write value 0xd34f172f
    li x3, 0xd34f172f
    csrw 0xb04, x3

    #Address 0xb04 read value
    csrr x14, 0xb04

    #Address 0xb04 Write value 0x34e0d0ca
    li x3, 0x34e0d0ca
    csrw 0xb04, x3

    #Unmapped address 0x9e1 testing: random write/read operations
    #Address 0x9e1 Write value 0x5c7ded0b
    li x3, 0x5c7ded0b
    csrw 0x9e1, x3

    #Address 0x9e1 read value
    csrr x14, 0x9e1

    #Address 0x9e1 Write value 0x43b846a1
    li x3, 0x43b846a1
    csrw 0x9e1, x3

    #Address 0x9e1 Write value 0xce8c5923
    li x3, 0xce8c5923
    csrw 0x9e1, x3

    #Mapped address 0x300 (mstatus) testing: random write/read operations
    #Address 0x300 Write value 0xdd0ee664
    li x3, 0xdd0ee664
    csrw 0x300, x3

    #Address 0x300 read value
    csrr x14, 0x300

    #Address 0x300 Write value 0x5b6fb0cc
    li x3, 0x5b6fb0cc
    csrw 0x300, x3

    #Address 0x300 read value
    csrr x14, 0x300

    #Mapped address 0x329 (mhpmevent9) testing: random write/read operations
    #Address 0x329 read value
    csrr x14, 0x329

    #Address 0x329 read value
    csrr x14, 0x329

    #Unmapped address 0x3c4 testing: random write/read operations
    #Address 0x3c4 read value
    csrr x14, 0x3c4

    #Address 0x3c4 Write value 0x75888987
    li x3, 0x75888987
    csrw 0x3c4, x3

    #Unmapped address 0x81a testing: random write/read operations
    #Address 0x81a read value
    csrr x14, 0x81a

    #Address 0x81a Write value 0xdd03d4a8
    li x3, 0xdd03d4a8
    csrw 0x81a, x3

    #Address 0x81a Write value 0x906c8d64
    li x3, 0x906c8d64
    csrw 0x81a, x3

    #Address 0x81a read value
    csrr x14, 0x81a

    #Address 0x81a Write value 0x480e6d2f
    li x3, 0x480e6d2f
    csrw 0x81a, x3

    #Unmapped address 0xcbe testing: random write/read operations
    #Address 0xcbe Write value 0x6ddac98a
    li x3, 0x6ddac98a
    csrw 0xcbe, x3

    #Address 0xcbe read value
    csrr x14, 0xcbe

    #Address 0xcbe Write value 0xc77a7fc8
    li x3, 0xc77a7fc8
    csrw 0xcbe, x3

    #Address 0xcbe Write value 0x84280e92
    li x3, 0x84280e92
    csrw 0xcbe, x3

    #Unmapped address 0x759 testing: random write/read operations
    #Address 0x759 read value
    csrr x14, 0x759

    #Unmapped address 0x5d0 testing: random write/read operations
    #Address 0x5d0 Write value 0x8abfb0a
    li x3, 0x8abfb0a
    csrw 0x5d0, x3

    #Address 0x5d0 read value
    csrr x14, 0x5d0

    #Address 0x5d0 read value
    csrr x14, 0x5d0

    #Address 0x5d0 read value
    csrr x14, 0x5d0

    #Address 0x5d0 Write value 0xf5224247
    li x3, 0xf5224247
    csrw 0x5d0, x3

    #Unmapped address 0xdc3 testing: random write/read operations
    #Address 0xdc3 Write value 0x9e76ab6b
    li x3, 0x9e76ab6b
    csrw 0xdc3, x3

    #Address 0xdc3 read value
    csrr x14, 0xdc3

    #Unmapped address 0xc03 testing: random write/read operations
    #Address 0xc03 read value
    csrr x14, 0xc03

    #Address 0xc03 read value
    csrr x14, 0xc03

    #Unmapped address 0x6e9 testing: random write/read operations
    #Address 0x6e9 Write value 0xd079f63d
    li x3, 0xd079f63d
    csrw 0x6e9, x3

    #Unmapped address 0x182 testing: random write/read operations
    #Address 0x182 Write value 0x40bd86d9
    li x3, 0x40bd86d9
    csrw 0x182, x3

    #Address 0x182 read value
    csrr x14, 0x182

    #Address 0x182 Write value 0x1ae25507
    li x3, 0x1ae25507
    csrw 0x182, x3

    #Unmapped address 0x5c0 testing: random write/read operations
    #Address 0x5c0 Write value 0x9894e95a
    li x3, 0x9894e95a
    csrw 0x5c0, x3

    #Address 0x5c0 read value
    csrr x14, 0x5c0

    #Address 0x5c0 read value
    csrr x14, 0x5c0

    #Address 0x5c0 Write value 0x2a03b709
    li x3, 0x2a03b709
    csrw 0x5c0, x3

    #Address 0x5c0 Write value 0x2ac02bf9
    li x3, 0x2ac02bf9
    csrw 0x5c0, x3

    #Unmapped address 0x934 testing: random write/read operations
    #Address 0x934 Write value 0x23c99f35
    li x3, 0x23c99f35
    csrw 0x934, x3

    #Address 0x934 read value
    csrr x14, 0x934

    #Unmapped address 0x1f3 testing: random write/read operations
    #Address 0x1f3 Write value 0x2f2da24d
    li x3, 0x2f2da24d
    csrw 0x1f3, x3

    #Address 0x1f3 Write value 0x4bc96789
    li x3, 0x4bc96789
    csrw 0x1f3, x3

    #Address 0x1f3 read value
    csrr x14, 0x1f3

    #Address 0x1f3 read value
    csrr x14, 0x1f3

    #Unmapped address 0x5c7 testing: random write/read operations
    #Address 0x5c7 Write value 0x205eb077
    li x3, 0x205eb077
    csrw 0x5c7, x3

    #Address 0x5c7 Write value 0x365c8d2b
    li x3, 0x365c8d2b
    csrw 0x5c7, x3

    #Address 0x5c7 read value
    csrr x14, 0x5c7

    #Address 0x5c7 read value
    csrr x14, 0x5c7

    #Unmapped address 0xa0b testing: random write/read operations
    #Address 0xa0b Write value 0xb96487da
    li x3, 0xb96487da
    csrw 0xa0b, x3

    #Address 0xa0b Write value 0x54bea8d3
    li x3, 0x54bea8d3
    csrw 0xa0b, x3

    #Address 0xa0b read value
    csrr x14, 0xa0b

    #Address 0xa0b read value
    csrr x14, 0xa0b

    #Address 0xa0b Write value 0x933f9cea
    li x3, 0x933f9cea
    csrw 0xa0b, x3

    #Unmapped address 0x53 testing: random write/read operations
    #Address 0x53 Write value 0x2cfb2615
    li x3, 0x2cfb2615
    csrw 0x53, x3

    #Address 0x53 read value
    csrr x14, 0x53

    #Address 0x53 Write value 0x475628ab
    li x3, 0x475628ab
    csrw 0x53, x3

    #Address 0x53 read value
    csrr x14, 0x53

    #Unmapped address 0x3cd testing: random write/read operations
    #Address 0x3cd read value
    csrr x14, 0x3cd

    #Unmapped address 0x583 testing: random write/read operations
    #Address 0x583 read value
    csrr x14, 0x583

    #Address 0x583 Write value 0x17541131
    li x3, 0x17541131
    csrw 0x583, x3

    #Address 0x583 Write value 0xcd1dcdbe
    li x3, 0xcd1dcdbe
    csrw 0x583, x3

    #Address 0x583 read value
    csrr x14, 0x583

    #Unmapped address 0x1e4 testing: random write/read operations
    #Address 0x1e4 Write value 0x70be35c6
    li x3, 0x70be35c6
    csrw 0x1e4, x3

    #Address 0x1e4 read value
    csrr x14, 0x1e4

    #Address 0x1e4 Write value 0x431f5f41
    li x3, 0x431f5f41
    csrw 0x1e4, x3

    #Unmapped address 0x552 testing: random write/read operations
    #Address 0x552 read value
    csrr x14, 0x552

    #Address 0x552 read value
    csrr x14, 0x552

    #Unmapped address 0x65 testing: random write/read operations
    #Address 0x65 Write value 0xfb42ec80
    li x3, 0xfb42ec80
    csrw 0x65, x3

    #Address 0x65 Write value 0xff69f53f
    li x3, 0xff69f53f
    csrw 0x65, x3

    #Address 0x65 Write value 0x2f6591f1
    li x3, 0x2f6591f1
    csrw 0x65, x3

    #Address 0x65 read value
    csrr x14, 0x65

    #Address 0x65 read value
    csrr x14, 0x65

    #Unmapped address 0x6fe testing: random write/read operations
    #Address 0x6fe read value
    csrr x14, 0x6fe

    #Address 0x6fe read value
    csrr x14, 0x6fe

    #Unmapped address 0x990 testing: random write/read operations
    #Address 0x990 read value
    csrr x14, 0x990

    #Address 0x990 Write value 0x6b3a7b90
    li x3, 0x6b3a7b90
    csrw 0x990, x3

    #Unmapped address 0xaaa testing: random write/read operations
    #Address 0xaaa read value
    csrr x14, 0xaaa

    #Address 0xaaa read value
    csrr x14, 0xaaa

    #Address 0xaaa Write value 0xb7b874b4
    li x3, 0xb7b874b4
    csrw 0xaaa, x3

    #Address 0xaaa Write value 0xad19d1c2
    li x3, 0xad19d1c2
    csrw 0xaaa, x3

    #Unmapped address 0xfb5 testing: random write/read operations
    #Address 0xfb5 read value
    csrr x14, 0xfb5

    #Address 0xfb5 Write value 0x404236ab
    li x3, 0x404236ab
    csrw 0xfb5, x3

    #Address 0xfb5 Write value 0x64ae4b7e
    li x3, 0x64ae4b7e
    csrw 0xfb5, x3

    #Address 0xfb5 Write value 0x5269fe67
    li x3, 0x5269fe67
    csrw 0xfb5, x3

    #Address 0xfb5 read value
    csrr x14, 0xfb5

    #Unmapped address 0x9c6 testing: random write/read operations
    #Address 0x9c6 read value
    csrr x14, 0x9c6

    #Address 0x9c6 Write value 0xc13ccbb1
    li x3, 0xc13ccbb1
    csrw 0x9c6, x3

    #Address 0x9c6 read value
    csrr x14, 0x9c6

    #Address 0x9c6 read value
    csrr x14, 0x9c6

    #Address 0x9c6 read value
    csrr x14, 0x9c6

    #Unmapped address 0xdc testing: random write/read operations
    #Address 0xdc Write value 0x6d327006
    li x3, 0x6d327006
    csrw 0xdc, x3

    #Unmapped address 0xd08 testing: random write/read operations
    #Address 0xd08 read value
    csrr x14, 0xd08

    #Address 0xd08 read value
    csrr x14, 0xd08

    #Address 0xd08 Write value 0x73db3ae7
    li x3, 0x73db3ae7
    csrw 0xd08, x3

    #Unmapped address 0x188 testing: random write/read operations
    #Address 0x188 Write value 0xded1ab00
    li x3, 0xded1ab00
    csrw 0x188, x3

    #Address 0x188 Write value 0x6bd32fed
    li x3, 0x6bd32fed
    csrw 0x188, x3

    #Mapped address 0x3bc (pmpaddr12) testing: random write/read operations
    #Address 0x3bc read value
    csrr x14, 0x3bc

    #Unmapped address 0xddc testing: random write/read operations
    #Address 0xddc Write value 0x34eb4c4a
    li x3, 0x34eb4c4a
    csrw 0xddc, x3

    #Address 0xddc read value
    csrr x14, 0xddc

    #Address 0xddc read value
    csrr x14, 0xddc

    #Address 0xddc read value
    csrr x14, 0xddc

    #Unmapped address 0x392 testing: random write/read operations
    #Address 0x392 read value
    csrr x14, 0x392

    #Address 0x392 read value
    csrr x14, 0x392

    #Unmapped address 0x9f6 testing: random write/read operations
    #Address 0x9f6 read value
    csrr x14, 0x9f6

    #Address 0x9f6 Write value 0x44bf5ebe
    li x3, 0x44bf5ebe
    csrw 0x9f6, x3

    #Unmapped address 0x566 testing: random write/read operations
    #Address 0x566 read value
    csrr x14, 0x566

    #Address 0x566 Write value 0x993191c8
    li x3, 0x993191c8
    csrw 0x566, x3

    #Unmapped address 0xa60 testing: random write/read operations
    #Address 0xa60 read value
    csrr x14, 0xa60

    #Address 0xa60 Write value 0x6132622
    li x3, 0x6132622
    csrw 0xa60, x3

    #Address 0xa60 Write value 0xf0173b99
    li x3, 0xf0173b99
    csrw 0xa60, x3

    #Unmapped address 0xe30 testing: random write/read operations
    #Address 0xe30 Write value 0x5d3a66f0
    li x3, 0x5d3a66f0
    csrw 0xe30, x3

    #Unmapped address 0xb01 testing: random write/read operations
    #Address 0xb01 Write value 0x591e4ca3
    li x3, 0x591e4ca3
    csrw 0xb01, x3

    #Address 0xb01 read value
    csrr x14, 0xb01

    #Address 0xb01 Write value 0xbfdcdea5
    li x3, 0xbfdcdea5
    csrw 0xb01, x3

    #Address 0xb01 read value
    csrr x14, 0xb01

    #Address 0xb01 read value
    csrr x14, 0xb01

    #Unmapped address 0x2ca testing: random write/read operations
    #Address 0x2ca Write value 0x7e21a006
    li x3, 0x7e21a006
    csrw 0x2ca, x3

    #Unmapped address 0xd38 testing: random write/read operations
    #Address 0xd38 read value
    csrr x14, 0xd38

    #Unmapped address 0x144 testing: random write/read operations
    #Address 0x144 Write value 0x802f4f60
    li x3, 0x802f4f60
    csrw 0x144, x3

    #Address 0x144 read value
    csrr x14, 0x144

    #Address 0x144 Write value 0x624ca5e1
    li x3, 0x624ca5e1
    csrw 0x144, x3

    #Address 0x144 read value
    csrr x14, 0x144

    #Address 0x144 Write value 0x82426465
    li x3, 0x82426465
    csrw 0x144, x3

    #Unmapped address 0x8e0 testing: random write/read operations
    #Address 0x8e0 read value
    csrr x14, 0x8e0

    #Unmapped address 0x369 testing: random write/read operations
    #Address 0x369 read value
    csrr x14, 0x369

    #Address 0x369 Write value 0xa702c285
    li x3, 0xa702c285
    csrw 0x369, x3

    #Unmapped address 0x401 testing: random write/read operations
    #Address 0x401 Write value 0xf4d2bb34
    li x3, 0xf4d2bb34
    csrw 0x401, x3

    #Address 0x401 read value
    csrr x14, 0x401

    #Address 0x401 read value
    csrr x14, 0x401

    #Address 0x401 read value
    csrr x14, 0x401

    #Unmapped address 0x2a0 testing: random write/read operations
    #Address 0x2a0 Write value 0x90efe245
    li x3, 0x90efe245
    csrw 0x2a0, x3

    #Address 0x2a0 Write value 0x32803a43
    li x3, 0x32803a43
    csrw 0x2a0, x3

    #Address 0x2a0 Write value 0xe12e9b11
    li x3, 0xe12e9b11
    csrw 0x2a0, x3

    #Unmapped address 0xa50 testing: random write/read operations
    #Address 0xa50 Write value 0x3f1fe09d
    li x3, 0x3f1fe09d
    csrw 0xa50, x3

    #Address 0xa50 Write value 0x14f53f9
    li x3, 0x14f53f9
    csrw 0xa50, x3

    #Unmapped address 0xc0d testing: random write/read operations
    #Address 0xc0d Write value 0x74c478c9
    li x3, 0x74c478c9
    csrw 0xc0d, x3

    #Address 0xc0d Write value 0x45e87f52
    li x3, 0x45e87f52
    csrw 0xc0d, x3

    #Address 0xc0d Write value 0x911e1fa4
    li x3, 0x911e1fa4
    csrw 0xc0d, x3

    #Unmapped address 0x358 testing: random write/read operations
    #Address 0x358 read value
    csrr x14, 0x358

    #Address 0x358 Write value 0x79793e83
    li x3, 0x79793e83
    csrw 0x358, x3

    #Address 0x358 read value
    csrr x14, 0x358

    #Address 0x358 Write value 0x36affb58
    li x3, 0x36affb58
    csrw 0x358, x3

    #Unmapped address 0x294 testing: random write/read operations
    #Address 0x294 read value
    csrr x14, 0x294

    #Address 0x294 read value
    csrr x14, 0x294

    #Address 0x294 read value
    csrr x14, 0x294

    #Address 0x294 Write value 0x45f1649f
    li x3, 0x45f1649f
    csrw 0x294, x3

    #Mapped address 0x32c (mhpmevent12) testing: random write/read operations
    #Address 0x32c read value
    csrr x14, 0x32c

    #Address 0x32c read value
    csrr x14, 0x32c

    #Unmapped address 0xe1c testing: random write/read operations
    #Address 0xe1c read value
    csrr x14, 0xe1c

    #Unmapped address 0x5e testing: random write/read operations
    #Address 0x5e Write value 0x83acedf7
    li x3, 0x83acedf7
    csrw 0x5e, x3

    #Unmapped address 0x17a testing: random write/read operations
    #Address 0x17a Write value 0x564e29ba
    li x3, 0x564e29ba
    csrw 0x17a, x3

    #Unmapped address 0x1c7 testing: random write/read operations
    #Address 0x1c7 Write value 0x797d0af4
    li x3, 0x797d0af4
    csrw 0x1c7, x3

    #Address 0x1c7 Write value 0xeb595318
    li x3, 0xeb595318
    csrw 0x1c7, x3

    #Address 0x1c7 Write value 0x59ce25a6
    li x3, 0x59ce25a6
    csrw 0x1c7, x3

    #Address 0x1c7 Write value 0x8b96d95d
    li x3, 0x8b96d95d
    csrw 0x1c7, x3

    #Address 0x1c7 read value
    csrr x14, 0x1c7

    #Unmapped address 0x72e testing: random write/read operations
    #Address 0x72e Write value 0x58a5ab2f
    li x3, 0x58a5ab2f
    csrw 0x72e, x3

    #Address 0x72e read value
    csrr x14, 0x72e

    #Address 0x72e read value
    csrr x14, 0x72e

    #Address 0x72e Write value 0xf9eaecc0
    li x3, 0xf9eaecc0
    csrw 0x72e, x3

    #Unmapped address 0x6bf testing: random write/read operations
    #Address 0x6bf Write value 0x82c8d238
    li x3, 0x82c8d238
    csrw 0x6bf, x3

    #Address 0x6bf Write value 0x2cfd8833
    li x3, 0x2cfd8833
    csrw 0x6bf, x3

    #Address 0x6bf Write value 0x19ddf852
    li x3, 0x19ddf852
    csrw 0x6bf, x3

    #Address 0x6bf Write value 0xd8585cb7
    li x3, 0xd8585cb7
    csrw 0x6bf, x3

    #Address 0x6bf read value
    csrr x14, 0x6bf

    #Unmapped address 0x71a testing: random write/read operations
    #Address 0x71a Write value 0x663770bb
    li x3, 0x663770bb
    csrw 0x71a, x3

    #Unmapped address 0xc30 testing: random write/read operations
    #Address 0xc30 Write value 0x886b3cb7
    li x3, 0x886b3cb7
    csrw 0xc30, x3

    #Address 0xc30 Write value 0xaa25011e
    li x3, 0xaa25011e
    csrw 0xc30, x3

    #Unmapped address 0x93c testing: random write/read operations
    #Address 0x93c Write value 0xe9a6f7a5
    li x3, 0xe9a6f7a5
    csrw 0x93c, x3

    #Mapped address 0x326 (mhpmevent6) testing: random write/read operations
    #Address 0x326 read value
    csrr x14, 0x326

    #Address 0x326 read value
    csrr x14, 0x326

    #Address 0x326 Write value 0x932dd82d
    li x3, 0x932dd82d
    csrw 0x326, x3

    #Address 0x326 read value
    csrr x14, 0x326

    #Address 0x326 read value
    csrr x14, 0x326

    #Unmapped address 0x4e7 testing: random write/read operations
    #Address 0x4e7 Write value 0xa9c4b4cd
    li x3, 0xa9c4b4cd
    csrw 0x4e7, x3

    #Address 0x4e7 read value
    csrr x14, 0x4e7

    #Address 0x4e7 Write value 0x3c28fdbb
    li x3, 0x3c28fdbb
    csrw 0x4e7, x3

    #Unmapped address 0xfea testing: random write/read operations
    #Address 0xfea read value
    csrr x14, 0xfea

    #Address 0xfea Write value 0xbda15e6b
    li x3, 0xbda15e6b
    csrw 0xfea, x3

    #Address 0xfea read value
    csrr x14, 0xfea

    #Unmapped address 0xf86 testing: random write/read operations
    #Address 0xf86 Write value 0x38ae7804
    li x3, 0x38ae7804
    csrw 0xf86, x3

    #Address 0xf86 read value
    csrr x14, 0xf86

    #Address 0xf86 read value
    csrr x14, 0xf86

    #Address 0xf86 Write value 0x4dba607d
    li x3, 0x4dba607d
    csrw 0xf86, x3

    #Unmapped address 0x90a testing: random write/read operations
    #Address 0x90a read value
    csrr x14, 0x90a

    #Address 0x90a read value
    csrr x14, 0x90a

    #Address 0x90a read value
    csrr x14, 0x90a

    #Address 0x90a read value
    csrr x14, 0x90a

    #Address 0x90a Write value 0x917cafde
    li x3, 0x917cafde
    csrw 0x90a, x3

    #Unmapped address 0x68f testing: random write/read operations
    #Address 0x68f Write value 0x6da2a482
    li x3, 0x6da2a482
    csrw 0x68f, x3

    #Address 0x68f Write value 0xacf55b5d
    li x3, 0xacf55b5d
    csrw 0x68f, x3

    #Address 0x68f read value
    csrr x14, 0x68f

    #Address 0x68f read value
    csrr x14, 0x68f

    #Unmapped address 0x683 testing: random write/read operations
    #Address 0x683 read value
    csrr x14, 0x683

    #Address 0x683 read value
    csrr x14, 0x683

    #Address 0x683 read value
    csrr x14, 0x683

    #Address 0x683 Write value 0x744e950e
    li x3, 0x744e950e
    csrw 0x683, x3

    #Unmapped address 0x254 testing: random write/read operations
    #Address 0x254 Write value 0x383a0b94
    li x3, 0x383a0b94
    csrw 0x254, x3

    #Address 0x254 Write value 0xf291db5c
    li x3, 0xf291db5c
    csrw 0x254, x3

    #Address 0x254 Write value 0x5c1b93e6
    li x3, 0x5c1b93e6
    csrw 0x254, x3

    #Address 0x254 Write value 0xa2e9d44b
    li x3, 0xa2e9d44b
    csrw 0x254, x3

    #Address 0x254 Write value 0x307ec890
    li x3, 0x307ec890
    csrw 0x254, x3

    #Unmapped address 0xd53 testing: random write/read operations
    #Address 0xd53 read value
    csrr x14, 0xd53

    #Address 0xd53 Write value 0x1838e39
    li x3, 0x1838e39
    csrw 0xd53, x3

    #Address 0xd53 Write value 0x52176b2d
    li x3, 0x52176b2d
    csrw 0xd53, x3

    #Unmapped address 0x61 testing: random write/read operations
    #Address 0x61 Write value 0x54ff520f
    li x3, 0x54ff520f
    csrw 0x61, x3

    #Address 0x61 read value
    csrr x14, 0x61

    #Address 0x61 Write value 0x4c500a8e
    li x3, 0x4c500a8e
    csrw 0x61, x3

    #Address 0x61 read value
    csrr x14, 0x61

    #Address 0x61 read value
    csrr x14, 0x61

    #Unmapped address 0xd93 testing: random write/read operations
    #Address 0xd93 Write value 0xa5d2c012
    li x3, 0xa5d2c012
    csrw 0xd93, x3

    #Unmapped address 0xd14 testing: random write/read operations
    #Address 0xd14 read value
    csrr x14, 0xd14

    #Address 0xd14 read value
    csrr x14, 0xd14

    #Address 0xd14 read value
    csrr x14, 0xd14

    #Unmapped address 0xec4 testing: random write/read operations
    #Address 0xec4 Write value 0x9999a273
    li x3, 0x9999a273
    csrw 0xec4, x3

    #Unmapped address 0x1b0 testing: random write/read operations
    #Address 0x1b0 Write value 0x24c7f0a7
    li x3, 0x24c7f0a7
    csrw 0x1b0, x3

    #Address 0x1b0 Write value 0x88b53a51
    li x3, 0x88b53a51
    csrw 0x1b0, x3

    #Address 0x1b0 Write value 0xc3c896ab
    li x3, 0xc3c896ab
    csrw 0x1b0, x3

    #Unmapped address 0x81b testing: random write/read operations
    #Address 0x81b read value
    csrr x14, 0x81b

    #Address 0x81b Write value 0x2f1a35dc
    li x3, 0x2f1a35dc
    csrw 0x81b, x3

    #Address 0x81b read value
    csrr x14, 0x81b

    #Address 0x81b read value
    csrr x14, 0x81b

    #Address 0x81b Write value 0x42c0a4a1
    li x3, 0x42c0a4a1
    csrw 0x81b, x3

    #Unmapped address 0x954 testing: random write/read operations
    #Address 0x954 read value
    csrr x14, 0x954

    #Address 0x954 Write value 0x1bec1310
    li x3, 0x1bec1310
    csrw 0x954, x3

    #Address 0x954 Write value 0x719beeee
    li x3, 0x719beeee
    csrw 0x954, x3

    #Address 0x954 read value
    csrr x14, 0x954

    #Unmapped address 0x86b testing: random write/read operations
    #Address 0x86b Write value 0x1e078b8c
    li x3, 0x1e078b8c
    csrw 0x86b, x3

    #Address 0x86b Write value 0x7c8f41f5
    li x3, 0x7c8f41f5
    csrw 0x86b, x3

    #Unmapped address 0x9fd testing: random write/read operations
    #Address 0x9fd read value
    csrr x14, 0x9fd

    #Address 0x9fd Write value 0x8dc39f39
    li x3, 0x8dc39f39
    csrw 0x9fd, x3

    #Address 0x9fd read value
    csrr x14, 0x9fd

    #Address 0x9fd Write value 0xc3e7110f
    li x3, 0xc3e7110f
    csrw 0x9fd, x3

    #Address 0x9fd read value
    csrr x14, 0x9fd

    #Unmapped address 0x3e testing: random write/read operations
    #Address 0x3e Write value 0xfdc2f53e
    li x3, 0xfdc2f53e
    csrw 0x3e, x3

    #Address 0x3e Write value 0xbe45c9d2
    li x3, 0xbe45c9d2
    csrw 0x3e, x3

    #Unmapped address 0xf3e testing: random write/read operations
    #Address 0xf3e Write value 0xe739dbc9
    li x3, 0xe739dbc9
    csrw 0xf3e, x3

    #Address 0xf3e read value
    csrr x14, 0xf3e

    #Address 0xf3e Write value 0x6f7995d6
    li x3, 0x6f7995d6
    csrw 0xf3e, x3

    #Address 0xf3e Write value 0xebe0353e
    li x3, 0xebe0353e
    csrw 0xf3e, x3

    #Address 0xf3e Write value 0x834e9434
    li x3, 0x834e9434
    csrw 0xf3e, x3

    #Unmapped address 0xe testing: random write/read operations
    #Address 0xe Write value 0x3e9abfa5
    li x3, 0x3e9abfa5
    csrw 0xe, x3

    #Unmapped address 0x429 testing: random write/read operations
    #Address 0x429 Write value 0x7d6c3d0a
    li x3, 0x7d6c3d0a
    csrw 0x429, x3

    #Address 0x429 read value
    csrr x14, 0x429

    #Address 0x429 read value
    csrr x14, 0x429

    #Unmapped address 0x5ee testing: random write/read operations
    #Address 0x5ee Write value 0xdfee1a10
    li x3, 0xdfee1a10
    csrw 0x5ee, x3

    #Address 0x5ee Write value 0x47c60909
    li x3, 0x47c60909
    csrw 0x5ee, x3

    #Address 0x5ee Write value 0x97ea4a2c
    li x3, 0x97ea4a2c
    csrw 0x5ee, x3

    #Unmapped address 0x92a testing: random write/read operations
    #Address 0x92a read value
    csrr x14, 0x92a

    #Address 0x92a read value
    csrr x14, 0x92a

    #Unmapped address 0xa03 testing: random write/read operations
    #Address 0xa03 Write value 0xfc9084c8
    li x3, 0xfc9084c8
    csrw 0xa03, x3

    #Address 0xa03 Write value 0x76cfed6e
    li x3, 0x76cfed6e
    csrw 0xa03, x3

    #Address 0xa03 read value
    csrr x14, 0xa03

    #Unmapped address 0x208 testing: random write/read operations
    #Address 0x208 read value
    csrr x14, 0x208

    #Address 0x208 Write value 0x386a7fbd
    li x3, 0x386a7fbd
    csrw 0x208, x3

    #Unmapped address 0xb68 testing: random write/read operations
    #Address 0xb68 Write value 0x3d917768
    li x3, 0x3d917768
    csrw 0xb68, x3

    #Address 0xb68 read value
    csrr x14, 0xb68

    #Unmapped address 0xdb5 testing: random write/read operations
    #Address 0xdb5 Write value 0xd27202ca
    li x3, 0xd27202ca
    csrw 0xdb5, x3

    #Address 0xdb5 read value
    csrr x14, 0xdb5

    #Address 0xdb5 read value
    csrr x14, 0xdb5

    #Unmapped address 0x38a testing: random write/read operations
    #Address 0x38a read value
    csrr x14, 0x38a

    #Address 0x38a Write value 0xf543c491
    li x3, 0xf543c491
    csrw 0x38a, x3

    #Address 0x38a Write value 0x430d1697
    li x3, 0x430d1697
    csrw 0x38a, x3

    #Unmapped address 0x7f2 testing: random write/read operations
    #Address 0x7f2 Write value 0x21da4ed8
    li x3, 0x21da4ed8
    csrw 0x7f2, x3

    #Unmapped address 0xeac testing: random write/read operations
    #Address 0xeac Write value 0x8d71e4d1
    li x3, 0x8d71e4d1
    csrw 0xeac, x3

    #Address 0xeac read value
    csrr x14, 0xeac

    #Address 0xeac read value
    csrr x14, 0xeac

    #Unmapped address 0x216 testing: random write/read operations
    #Address 0x216 read value
    csrr x14, 0x216

    #Unmapped address 0xa84 testing: random write/read operations
    #Address 0xa84 Write value 0x7c3dc4ad
    li x3, 0x7c3dc4ad
    csrw 0xa84, x3

    #Address 0xa84 Write value 0xf27182bf
    li x3, 0xf27182bf
    csrw 0xa84, x3

    #Address 0xa84 Write value 0x1bc31e16
    li x3, 0x1bc31e16
    csrw 0xa84, x3

    #Address 0xa84 Write value 0xe8fd1560
    li x3, 0xe8fd1560
    csrw 0xa84, x3

    #Unmapped address 0x833 testing: random write/read operations
    #Address 0x833 Write value 0x8cd42d9
    li x3, 0x8cd42d9
    csrw 0x833, x3

    #Address 0x833 read value
    csrr x14, 0x833

    #Unmapped address 0xd5f testing: random write/read operations
    #Address 0xd5f Write value 0xe7b96443
    li x3, 0xe7b96443
    csrw 0xd5f, x3

    #Unmapped address 0xe7d testing: random write/read operations
    #Address 0xe7d Write value 0x3154aa33
    li x3, 0x3154aa33
    csrw 0xe7d, x3

    #Address 0xe7d Write value 0xf3798a80
    li x3, 0xf3798a80
    csrw 0xe7d, x3

    #Unmapped address 0xd70 testing: random write/read operations
    #Address 0xd70 Write value 0x6025cd51
    li x3, 0x6025cd51
    csrw 0xd70, x3

    #Unmapped address 0x6d8 testing: random write/read operations
    #Address 0x6d8 Write value 0xde945e4
    li x3, 0xde945e4
    csrw 0x6d8, x3

    #Unmapped address 0xd3c testing: random write/read operations
    #Address 0xd3c Write value 0xa838d20e
    li x3, 0xa838d20e
    csrw 0xd3c, x3

    #Address 0xd3c Write value 0xe3583404
    li x3, 0xe3583404
    csrw 0xd3c, x3

    #Address 0xd3c Write value 0x9fc8a4e0
    li x3, 0x9fc8a4e0
    csrw 0xd3c, x3

    #Address 0xd3c Write value 0x2f53a36c
    li x3, 0x2f53a36c
    csrw 0xd3c, x3

    #Address 0xd3c read value
    csrr x14, 0xd3c

    #Unmapped address 0x75c testing: random write/read operations
    #Address 0x75c read value
    csrr x14, 0x75c

    #Unmapped address 0x79a testing: random write/read operations
    #Address 0x79a read value
    csrr x14, 0x79a

    #Unmapped address 0x187 testing: random write/read operations
    #Address 0x187 Write value 0xdafb4aa7
    li x3, 0xdafb4aa7
    csrw 0x187, x3

    #Unmapped address 0x664 testing: random write/read operations
    #Address 0x664 Write value 0xf07f8802
    li x3, 0xf07f8802
    csrw 0x664, x3

    #Address 0x664 Write value 0xa6f193fb
    li x3, 0xa6f193fb
    csrw 0x664, x3

    #Address 0x664 Write value 0x5599359
    li x3, 0x5599359
    csrw 0x664, x3

    #Address 0x664 read value
    csrr x14, 0x664

    #Unmapped address 0x54 testing: random write/read operations
    #Address 0x54 Write value 0xa17b7b1e
    li x3, 0xa17b7b1e
    csrw 0x54, x3

    #Address 0x54 read value
    csrr x14, 0x54

    #Address 0x54 Write value 0xeeb10e0d
    li x3, 0xeeb10e0d
    csrw 0x54, x3

    #Unmapped address 0x547 testing: random write/read operations
    #Address 0x547 Write value 0x475e5dbb
    li x3, 0x475e5dbb
    csrw 0x547, x3

    #Address 0x547 Write value 0x2bc84bbb
    li x3, 0x2bc84bbb
    csrw 0x547, x3

    #Unmapped address 0x35f testing: random write/read operations
    #Address 0x35f read value
    csrr x14, 0x35f

    #Address 0x35f read value
    csrr x14, 0x35f

    #Address 0x35f read value
    csrr x14, 0x35f

    #Unmapped address 0x7ec testing: random write/read operations
    #Address 0x7ec Write value 0xf9eaaec6
    li x3, 0xf9eaaec6
    csrw 0x7ec, x3

    #Address 0x7ec read value
    csrr x14, 0x7ec

    #Address 0x7ec Write value 0x657dd95f
    li x3, 0x657dd95f
    csrw 0x7ec, x3

    #Unmapped address 0xae4 testing: random write/read operations
    #Address 0xae4 read value
    csrr x14, 0xae4

    #Address 0xae4 read value
    csrr x14, 0xae4

    #Address 0xae4 Write value 0xcf4bca8d
    li x3, 0xcf4bca8d
    csrw 0xae4, x3

    #Address 0xae4 read value
    csrr x14, 0xae4

    #Unmapped address 0xed5 testing: random write/read operations
    #Address 0xed5 read value
    csrr x14, 0xed5

    #Address 0xed5 Write value 0x39295ddd
    li x3, 0x39295ddd
    csrw 0xed5, x3

    #Address 0xed5 read value
    csrr x14, 0xed5

    #Address 0xed5 read value
    csrr x14, 0xed5

    #Address 0xed5 read value
    csrr x14, 0xed5

    #Unmapped address 0xcd4 testing: random write/read operations
    #Address 0xcd4 Write value 0x8253b5c8
    li x3, 0x8253b5c8
    csrw 0xcd4, x3

    #Address 0xcd4 Write value 0xdecfa50e
    li x3, 0xdecfa50e
    csrw 0xcd4, x3

    #Address 0xcd4 Write value 0xe9658dc6
    li x3, 0xe9658dc6
    csrw 0xcd4, x3

    #Address 0xcd4 Write value 0xc9d20303
    li x3, 0xc9d20303
    csrw 0xcd4, x3

    #Address 0xcd4 read value
    csrr x14, 0xcd4

    #Unmapped address 0x51f testing: random write/read operations
    #Address 0x51f read value
    csrr x14, 0x51f

    #Address 0x51f read value
    csrr x14, 0x51f

    #Address 0x51f Write value 0x76fb940f
    li x3, 0x76fb940f
    csrw 0x51f, x3

    #Address 0x51f read value
    csrr x14, 0x51f

    #Unmapped address 0x226 testing: random write/read operations
    #Address 0x226 read value
    csrr x14, 0x226

    #Address 0x226 Write value 0x20d21da5
    li x3, 0x20d21da5
    csrw 0x226, x3

    #Unmapped address 0x61b testing: random write/read operations
    #Address 0x61b Write value 0x60ff1e3
    li x3, 0x60ff1e3
    csrw 0x61b, x3

    #Address 0x61b read value
    csrr x14, 0x61b

    #Address 0x61b read value
    csrr x14, 0x61b

    #Address 0x61b read value
    csrr x14, 0x61b

    #Address 0x61b read value
    csrr x14, 0x61b

    #Unmapped address 0x60b testing: random write/read operations
    #Address 0x60b Write value 0xb50990ec
    li x3, 0xb50990ec
    csrw 0x60b, x3

    #Address 0x60b read value
    csrr x14, 0x60b

    #Address 0x60b Write value 0x25e16cec
    li x3, 0x25e16cec
    csrw 0x60b, x3

    #Address 0x60b Write value 0x6414fc24
    li x3, 0x6414fc24
    csrw 0x60b, x3

    #Unmapped address 0x14 testing: random write/read operations
    #Address 0x14 Write value 0x375505c8
    li x3, 0x375505c8
    csrw 0x14, x3

    #Address 0x14 read value
    csrr x14, 0x14

    #Address 0x14 read value
    csrr x14, 0x14

    #Unmapped address 0x635 testing: random write/read operations
    #Address 0x635 Write value 0xa5aa4834
    li x3, 0xa5aa4834
    csrw 0x635, x3

    #Unmapped address 0xc5a testing: random write/read operations
    #Address 0xc5a read value
    csrr x14, 0xc5a

    #Unmapped address 0x279 testing: random write/read operations
    #Address 0x279 Write value 0xa2588b5a
    li x3, 0xa2588b5a
    csrw 0x279, x3

    #Unmapped address 0x8e2 testing: random write/read operations
    #Address 0x8e2 Write value 0x20a16de8
    li x3, 0x20a16de8
    csrw 0x8e2, x3

    #Address 0x8e2 read value
    csrr x14, 0x8e2

    #Address 0x8e2 Write value 0xb2a4dbbb
    li x3, 0xb2a4dbbb
    csrw 0x8e2, x3

    #Address 0x8e2 Write value 0xc1d9216d
    li x3, 0xc1d9216d
    csrw 0x8e2, x3

    #Address 0x8e2 Write value 0x1a092d7f
    li x3, 0x1a092d7f
    csrw 0x8e2, x3

    #Unmapped address 0x8bf testing: random write/read operations
    #Address 0x8bf Write value 0x42bef556
    li x3, 0x42bef556
    csrw 0x8bf, x3

    #Address 0x8bf Write value 0x374a332c
    li x3, 0x374a332c
    csrw 0x8bf, x3

    #Address 0x8bf read value
    csrr x14, 0x8bf

    #Unmapped address 0xb52 testing: random write/read operations
    #Address 0xb52 read value
    csrr x14, 0xb52

    #Address 0xb52 read value
    csrr x14, 0xb52

    #Unmapped address 0x9df testing: random write/read operations
    #Address 0x9df read value
    csrr x14, 0x9df

    #Unmapped address 0xfc1 testing: random write/read operations
    #Address 0xfc1 read value
    csrr x14, 0xfc1

    #Address 0xfc1 read value
    csrr x14, 0xfc1

    #Unmapped address 0x7d3 testing: random write/read operations
    #Address 0x7d3 Write value 0x97c4458e
    li x3, 0x97c4458e
    csrw 0x7d3, x3

    #Address 0x7d3 read value
    csrr x14, 0x7d3

    #Address 0x7d3 Write value 0xa6a7a02a
    li x3, 0xa6a7a02a
    csrw 0x7d3, x3

    #Address 0x7d3 read value
    csrr x14, 0x7d3

    #Address 0x7d3 Write value 0xb29e64f6
    li x3, 0xb29e64f6
    csrw 0x7d3, x3

    #Unmapped address 0x286 testing: random write/read operations
    #Address 0x286 Write value 0xc5e92513
    li x3, 0xc5e92513
    csrw 0x286, x3

    #Address 0x286 read value
    csrr x14, 0x286

    #Address 0x286 Write value 0xe09c4f4
    li x3, 0xe09c4f4
    csrw 0x286, x3

    #Unmapped address 0x75 testing: random write/read operations
    #Address 0x75 read value
    csrr x14, 0x75

    #Address 0x75 Write value 0x50f6d9a0
    li x3, 0x50f6d9a0
    csrw 0x75, x3

    #Address 0x75 read value
    csrr x14, 0x75

    #Unmapped address 0x70b testing: random write/read operations
    #Address 0x70b read value
    csrr x14, 0x70b

    #Address 0x70b Write value 0xfddb8cfd
    li x3, 0xfddb8cfd
    csrw 0x70b, x3

    #Address 0x70b Write value 0x3006b028
    li x3, 0x3006b028
    csrw 0x70b, x3

    #Unmapped address 0xfd5 testing: random write/read operations
    #Address 0xfd5 Write value 0xf34d1fa2
    li x3, 0xf34d1fa2
    csrw 0xfd5, x3

    #Address 0xfd5 Write value 0xfa5fb8b9
    li x3, 0xfa5fb8b9
    csrw 0xfd5, x3

    #Address 0xfd5 Write value 0x28285ad7
    li x3, 0x28285ad7
    csrw 0xfd5, x3

    #Unmapped address 0xed7 testing: random write/read operations
    #Address 0xed7 read value
    csrr x14, 0xed7

    #Address 0xed7 read value
    csrr x14, 0xed7

    #Address 0xed7 Write value 0x8c9cf1b8
    li x3, 0x8c9cf1b8
    csrw 0xed7, x3

    #Unmapped address 0x4e1 testing: random write/read operations
    #Address 0x4e1 Write value 0xf0eb85a1
    li x3, 0xf0eb85a1
    csrw 0x4e1, x3

    #Unmapped address 0x8bd testing: random write/read operations
    #Address 0x8bd read value
    csrr x14, 0x8bd

    #Address 0x8bd Write value 0xd8795afd
    li x3, 0xd8795afd
    csrw 0x8bd, x3

    #Address 0x8bd Write value 0xda9e0874
    li x3, 0xda9e0874
    csrw 0x8bd, x3

    #Address 0x8bd read value
    csrr x14, 0x8bd

    #Address 0x8bd read value
    csrr x14, 0x8bd

    #Unmapped address 0xabb testing: random write/read operations
    #Address 0xabb Write value 0x2454bdc9
    li x3, 0x2454bdc9
    csrw 0xabb, x3

    #Address 0xabb read value
    csrr x14, 0xabb

    #Address 0xabb read value
    csrr x14, 0xabb

    #Unmapped address 0xa9e testing: random write/read operations
    #Address 0xa9e read value
    csrr x14, 0xa9e

    #Address 0xa9e read value
    csrr x14, 0xa9e

    #Address 0xa9e read value
    csrr x14, 0xa9e

    #Address 0xa9e Write value 0x8d20fffd
    li x3, 0x8d20fffd
    csrw 0xa9e, x3

    #Unmapped address 0xe9a testing: random write/read operations
    #Address 0xe9a Write value 0x1aff119c
    li x3, 0x1aff119c
    csrw 0xe9a, x3

    #Address 0xe9a Write value 0xe807f09d
    li x3, 0xe807f09d
    csrw 0xe9a, x3

    #Mapped address 0x33b (mhpmevent27) testing: random write/read operations
    #Address 0x33b read value
    csrr x14, 0x33b

    #Address 0x33b Write value 0x9c44a9d0
    li x3, 0x9c44a9d0
    csrw 0x33b, x3

    #Address 0x33b read value
    csrr x14, 0x33b

    #Address 0x33b Write value 0x980e187c
    li x3, 0x980e187c
    csrw 0x33b, x3

    #Unmapped address 0xe68 testing: random write/read operations
    #Address 0xe68 read value
    csrr x14, 0xe68

    #Address 0xe68 Write value 0xb6ef9883
    li x3, 0xb6ef9883
    csrw 0xe68, x3

    #Address 0xe68 Write value 0xf7e0086b
    li x3, 0xf7e0086b
    csrw 0xe68, x3

    #Address 0xe68 Write value 0x32e0cda5
    li x3, 0x32e0cda5
    csrw 0xe68, x3

    #Mapped address 0x32f (mhpmevent15) testing: random write/read operations
    #Address 0x32f Write value 0xdbdb976e
    li x3, 0xdbdb976e
    csrw 0x32f, x3

    #Unmapped address 0xb33 testing: random write/read operations
    #Address 0xb33 read value
    csrr x14, 0xb33

    #Address 0xb33 Write value 0x6984aae6
    li x3, 0x6984aae6
    csrw 0xb33, x3

    #Address 0xb33 Write value 0x380f823c
    li x3, 0x380f823c
    csrw 0xb33, x3

    #Address 0xb33 read value
    csrr x14, 0xb33

    #Address 0xb33 Write value 0x2a44c42b
    li x3, 0x2a44c42b
    csrw 0xb33, x3

    #Unmapped address 0x169 testing: random write/read operations
    #Address 0x169 Write value 0xa8c9c51
    li x3, 0xa8c9c51
    csrw 0x169, x3

    #Unmapped address 0x428 testing: random write/read operations
    #Address 0x428 Write value 0xa9c4359c
    li x3, 0xa9c4359c
    csrw 0x428, x3

    #Unmapped address 0xd16 testing: random write/read operations
    #Address 0xd16 read value
    csrr x14, 0xd16

    #Unmapped address 0x427 testing: random write/read operations
    #Address 0x427 Write value 0x28f318e8
    li x3, 0x28f318e8
    csrw 0x427, x3

    #Address 0x427 Write value 0xfb84a336
    li x3, 0xfb84a336
    csrw 0x427, x3

    #Address 0x427 Write value 0xfe65cd24
    li x3, 0xfe65cd24
    csrw 0x427, x3

    #Address 0x427 read value
    csrr x14, 0x427

    #Unmapped address 0xac3 testing: random write/read operations
    #Address 0xac3 read value
    csrr x14, 0xac3

    #Address 0xac3 Write value 0xe22b48d9
    li x3, 0xe22b48d9
    csrw 0xac3, x3

    #Address 0xac3 read value
    csrr x14, 0xac3

    #Unmapped address 0x7c7 testing: random write/read operations
    #Address 0x7c7 Write value 0x620be76d
    li x3, 0x620be76d
    csrw 0x7c7, x3

    #Address 0x7c7 read value
    csrr x14, 0x7c7

    #Address 0x7c7 read value
    csrr x14, 0x7c7

    #Address 0x7c7 read value
    csrr x14, 0x7c7

    #Address 0x7c7 read value
    csrr x14, 0x7c7

    #Unmapped address 0x82b testing: random write/read operations
    #Address 0x82b Write value 0xb7df198d
    li x3, 0xb7df198d
    csrw 0x82b, x3

    #Address 0x82b read value
    csrr x14, 0x82b

    #Unmapped address 0x7ab testing: random write/read operations
    #Address 0x7ab read value
    csrr x14, 0x7ab

    #Address 0x7ab Write value 0x8422df09
    li x3, 0x8422df09
    csrw 0x7ab, x3

    #Unmapped address 0x483 testing: random write/read operations
    #Address 0x483 read value
    csrr x14, 0x483

    #Address 0x483 Write value 0x54e2b2f9
    li x3, 0x54e2b2f9
    csrw 0x483, x3

    #Unmapped address 0xff7 testing: random write/read operations
    #Address 0xff7 Write value 0x544e87c5
    li x3, 0x544e87c5
    csrw 0xff7, x3

    #Address 0xff7 read value
    csrr x14, 0xff7

    #Unmapped address 0x8d5 testing: random write/read operations
    #Address 0x8d5 read value
    csrr x14, 0x8d5

    #Unmapped address 0xee5 testing: random write/read operations
    #Address 0xee5 read value
    csrr x14, 0xee5

    #Address 0xee5 read value
    csrr x14, 0xee5

    #Unmapped address 0xf48 testing: random write/read operations
    #Address 0xf48 read value
    csrr x14, 0xf48

    #Address 0xf48 Write value 0x8d6b9feb
    li x3, 0x8d6b9feb
    csrw 0xf48, x3

    #Address 0xf48 Write value 0x7e175efc
    li x3, 0x7e175efc
    csrw 0xf48, x3

    #Address 0xf48 read value
    csrr x14, 0xf48

    #Unmapped address 0xd3e testing: random write/read operations
    #Address 0xd3e read value
    csrr x14, 0xd3e

    #Unmapped address 0xcb7 testing: random write/read operations
    #Address 0xcb7 Write value 0xf52199e8
    li x3, 0xf52199e8
    csrw 0xcb7, x3

    #Unmapped address 0xec8 testing: random write/read operations
    #Address 0xec8 Write value 0xca64d2d1
    li x3, 0xca64d2d1
    csrw 0xec8, x3

    #Unmapped address 0x6fb testing: random write/read operations
    #Address 0x6fb read value
    csrr x14, 0x6fb

    #Unmapped address 0xb71 testing: random write/read operations
    #Address 0xb71 Write value 0x1bd7850c
    li x3, 0x1bd7850c
    csrw 0xb71, x3

    #Unmapped address 0xeba testing: random write/read operations
    #Address 0xeba Write value 0x1f4aa8e0
    li x3, 0x1f4aa8e0
    csrw 0xeba, x3

    #Address 0xeba Write value 0x9acef6d6
    li x3, 0x9acef6d6
    csrw 0xeba, x3

    #Unmapped address 0x961 testing: random write/read operations
    #Address 0x961 read value
    csrr x14, 0x961

    #Address 0x961 read value
    csrr x14, 0x961

    #Address 0x961 Write value 0xb0bd5c89
    li x3, 0xb0bd5c89
    csrw 0x961, x3

    #Address 0x961 Write value 0x8e6dedf2
    li x3, 0x8e6dedf2
    csrw 0x961, x3

    #Mapped address 0xb19 (mhpmcounter25) testing: random write/read operations
    #Address 0xb19 Write value 0xa9bfe3f2
    li x3, 0xa9bfe3f2
    csrw 0xb19, x3

    #Unmapped address 0x278 testing: random write/read operations
    #Address 0x278 read value
    csrr x14, 0x278

    #Unmapped address 0x9f1 testing: random write/read operations
    #Address 0x9f1 read value
    csrr x14, 0x9f1

    #Unmapped address 0x794 testing: random write/read operations
    #Address 0x794 Write value 0xdbcfbbe0
    li x3, 0xdbcfbbe0
    csrw 0x794, x3

    #Address 0x794 read value
    csrr x14, 0x794

    #Unmapped address 0x251 testing: random write/read operations
    #Address 0x251 Write value 0x11849b60
    li x3, 0x11849b60
    csrw 0x251, x3

    #Unmapped address 0x4e9 testing: random write/read operations
    #Address 0x4e9 Write value 0x1067fd31
    li x3, 0x1067fd31
    csrw 0x4e9, x3

    #Address 0x4e9 Write value 0x18da5797
    li x3, 0x18da5797
    csrw 0x4e9, x3

    #Unmapped address 0x7c5 testing: random write/read operations
    #Address 0x7c5 read value
    csrr x14, 0x7c5

    #Address 0x7c5 Write value 0x221476da
    li x3, 0x221476da
    csrw 0x7c5, x3

    #Unmapped address 0x421 testing: random write/read operations
    #Address 0x421 Write value 0x7efb712b
    li x3, 0x7efb712b
    csrw 0x421, x3

    #Address 0x421 read value
    csrr x14, 0x421

    #Address 0x421 Write value 0xe7b68f48
    li x3, 0xe7b68f48
    csrw 0x421, x3

    #Address 0x421 Write value 0x8fdf60b2
    li x3, 0x8fdf60b2
    csrw 0x421, x3

    #Unmapped address 0x648 testing: random write/read operations
    #Address 0x648 read value
    csrr x14, 0x648

    #Unmapped address 0x7a0 testing: random write/read operations
    #Address 0x7a0 read value
    csrr x14, 0x7a0

    #Address 0x7a0 Write value 0xbfa99d51
    li x3, 0xbfa99d51
    csrw 0x7a0, x3

    #Unmapped address 0x417 testing: random write/read operations
    #Address 0x417 read value
    csrr x14, 0x417

    #Address 0x417 read value
    csrr x14, 0x417

    #Address 0x417 read value
    csrr x14, 0x417

    #Unmapped address 0x544 testing: random write/read operations
    #Address 0x544 read value
    csrr x14, 0x544

    #Address 0x544 Write value 0x84017e39
    li x3, 0x84017e39
    csrw 0x544, x3

    #Address 0x544 read value
    csrr x14, 0x544

    #Unmapped address 0x65c testing: random write/read operations
    #Address 0x65c Write value 0xfe8d14ba
    li x3, 0xfe8d14ba
    csrw 0x65c, x3

    #Address 0x65c read value
    csrr x14, 0x65c

    #Address 0x65c Write value 0xbe0a46fa
    li x3, 0xbe0a46fa
    csrw 0x65c, x3

    #Address 0x65c Write value 0xde7d8c7a
    li x3, 0xde7d8c7a
    csrw 0x65c, x3

    #Unmapped address 0xe76 testing: random write/read operations
    #Address 0xe76 Write value 0xf5a06c89
    li x3, 0xf5a06c89
    csrw 0xe76, x3

    #Unmapped address 0x636 testing: random write/read operations
    #Address 0x636 Write value 0x9c40e892
    li x3, 0x9c40e892
    csrw 0x636, x3

    #Address 0x636 Write value 0x4dad5bb7
    li x3, 0x4dad5bb7
    csrw 0x636, x3

    #Address 0x636 read value
    csrr x14, 0x636

    #Unmapped address 0xf00 testing: random write/read operations
    #Address 0xf00 read value
    csrr x14, 0xf00

    #Address 0xf00 read value
    csrr x14, 0xf00

    #Unmapped address 0x1c5 testing: random write/read operations
    #Address 0x1c5 read value
    csrr x14, 0x1c5

    #Unmapped address 0x746 testing: random write/read operations
    #Address 0x746 Write value 0xd75edbc2
    li x3, 0xd75edbc2
    csrw 0x746, x3

    #Address 0x746 read value
    csrr x14, 0x746

    #Unmapped address 0x4af testing: random write/read operations
    #Address 0x4af Write value 0xb4e73e82
    li x3, 0xb4e73e82
    csrw 0x4af, x3

    #Address 0x4af Write value 0x9be84f81
    li x3, 0x9be84f81
    csrw 0x4af, x3

    #Unmapped address 0x43d testing: random write/read operations
    #Address 0x43d read value
    csrr x14, 0x43d

    #Unmapped address 0x62f testing: random write/read operations
    #Address 0x62f read value
    csrr x14, 0x62f

    #Address 0x62f Write value 0xa19357a6
    li x3, 0xa19357a6
    csrw 0x62f, x3

    #Address 0x62f Write value 0xee51c60a
    li x3, 0xee51c60a
    csrw 0x62f, x3

    #Address 0x62f Write value 0x19dee32a
    li x3, 0x19dee32a
    csrw 0x62f, x3

    #Address 0x62f read value
    csrr x14, 0x62f

    #Unmapped address 0xfe testing: random write/read operations
    #Address 0xfe read value
    csrr x14, 0xfe

    #Unmapped address 0x1ad testing: random write/read operations
    #Address 0x1ad read value
    csrr x14, 0x1ad

    #Address 0x1ad Write value 0xc942476b
    li x3, 0xc942476b
    csrw 0x1ad, x3

    #Address 0x1ad read value
    csrr x14, 0x1ad

    #Unmapped address 0xafc testing: random write/read operations
    #Address 0xafc Write value 0x9122de26
    li x3, 0x9122de26
    csrw 0xafc, x3

    #Address 0xafc Write value 0xf8417da0
    li x3, 0xf8417da0
    csrw 0xafc, x3

    #Address 0xafc read value
    csrr x14, 0xafc

    #Unmapped address 0x4c2 testing: random write/read operations
    #Address 0x4c2 Write value 0xe9e0ebef
    li x3, 0xe9e0ebef
    csrw 0x4c2, x3

    #Address 0x4c2 Write value 0xaaed2701
    li x3, 0xaaed2701
    csrw 0x4c2, x3

    #Address 0x4c2 Write value 0x4f9c47c4
    li x3, 0x4f9c47c4
    csrw 0x4c2, x3

    #Address 0x4c2 Write value 0xf462d5dd
    li x3, 0xf462d5dd
    csrw 0x4c2, x3

    #Address 0x4c2 read value
    csrr x14, 0x4c2

    #Unmapped address 0x68c testing: random write/read operations
    #Address 0x68c Write value 0x86c555dd
    li x3, 0x86c555dd
    csrw 0x68c, x3

    #Address 0x68c read value
    csrr x14, 0x68c

    #Address 0x68c Write value 0x9c07458
    li x3, 0x9c07458
    csrw 0x68c, x3

    #Address 0x68c read value
    csrr x14, 0x68c

    #Address 0x68c Write value 0x73d45d3e
    li x3, 0x73d45d3e
    csrw 0x68c, x3

    #Unmapped address 0xd0b testing: random write/read operations
    #Address 0xd0b Write value 0x44048900
    li x3, 0x44048900
    csrw 0xd0b, x3

    #Unmapped address 0xab7 testing: random write/read operations
    #Address 0xab7 read value
    csrr x14, 0xab7

    #Address 0xab7 Write value 0xee9edd23
    li x3, 0xee9edd23
    csrw 0xab7, x3

    #Address 0xab7 Write value 0x763db8b2
    li x3, 0x763db8b2
    csrw 0xab7, x3

    #Address 0xab7 read value
    csrr x14, 0xab7

    #Unmapped address 0x1fa testing: random write/read operations
    #Address 0x1fa Write value 0xdba7f750
    li x3, 0xdba7f750
    csrw 0x1fa, x3

    #Address 0x1fa Write value 0xf1c5f12a
    li x3, 0xf1c5f12a
    csrw 0x1fa, x3

    #Address 0x1fa Write value 0xe06d6a92
    li x3, 0xe06d6a92
    csrw 0x1fa, x3

    #Address 0x1fa Write value 0xc08012f2
    li x3, 0xc08012f2
    csrw 0x1fa, x3

    #Unmapped address 0x64e testing: random write/read operations
    #Address 0x64e read value
    csrr x14, 0x64e

    #Address 0x64e read value
    csrr x14, 0x64e

    #Address 0x64e Write value 0xc819d260
    li x3, 0xc819d260
    csrw 0x64e, x3

    #Unmapped address 0x57 testing: random write/read operations
    #Address 0x57 Write value 0x97989fd9
    li x3, 0x97989fd9
    csrw 0x57, x3

    #Address 0x57 read value
    csrr x14, 0x57

    #Address 0x57 read value
    csrr x14, 0x57

    #Unmapped address 0x356 testing: random write/read operations
    #Address 0x356 Write value 0xae23b12
    li x3, 0xae23b12
    csrw 0x356, x3

    #Address 0x356 read value
    csrr x14, 0x356

    #Address 0x356 Write value 0x1dbdf83
    li x3, 0x1dbdf83
    csrw 0x356, x3

    #Unmapped address 0xd31 testing: random write/read operations
    #Address 0xd31 read value
    csrr x14, 0xd31

    #Address 0xd31 Write value 0xe7bfd13
    li x3, 0xe7bfd13
    csrw 0xd31, x3

    #Address 0xd31 read value
    csrr x14, 0xd31

    #Unmapped address 0xe46 testing: random write/read operations
    #Address 0xe46 read value
    csrr x14, 0xe46

    #Address 0xe46 read value
    csrr x14, 0xe46

    #Mapped address 0x331 (mhpmevent17) testing: random write/read operations
    #Address 0x331 read value
    csrr x14, 0x331

    #Address 0x331 read value
    csrr x14, 0x331

    #Address 0x331 Write value 0xf7e153b5
    li x3, 0xf7e153b5
    csrw 0x331, x3

    #Unmapped address 0xc26 testing: random write/read operations
    #Address 0xc26 Write value 0x4c909cf1
    li x3, 0x4c909cf1
    csrw 0xc26, x3

    #Address 0xc26 read value
    csrr x14, 0xc26

    #Unmapped address 0x268 testing: random write/read operations
    #Address 0x268 read value
    csrr x14, 0x268

    #Address 0x268 Write value 0xa2f2ca59
    li x3, 0xa2f2ca59
    csrw 0x268, x3

    #Address 0x268 Write value 0x3d44a6d0
    li x3, 0x3d44a6d0
    csrw 0x268, x3

    #Address 0x268 read value
    csrr x14, 0x268

    #Address 0x268 Write value 0x2394a81b
    li x3, 0x2394a81b
    csrw 0x268, x3

    #Unmapped address 0xc46 testing: random write/read operations
    #Address 0xc46 read value
    csrr x14, 0xc46

    #Address 0xc46 read value
    csrr x14, 0xc46

    #Address 0xc46 read value
    csrr x14, 0xc46

    #Address 0xc46 Write value 0x23c18bad
    li x3, 0x23c18bad
    csrw 0xc46, x3

    #Unmapped address 0xdb8 testing: random write/read operations
    #Address 0xdb8 read value
    csrr x14, 0xdb8

    #Address 0xdb8 read value
    csrr x14, 0xdb8

    #Address 0xdb8 Write value 0x55d8ef6e
    li x3, 0x55d8ef6e
    csrw 0xdb8, x3

    #Unmapped address 0x4aa testing: random write/read operations
    #Address 0x4aa Write value 0xce431e36
    li x3, 0xce431e36
    csrw 0x4aa, x3

    #Address 0x4aa read value
    csrr x14, 0x4aa

    #Unmapped address 0x6e1 testing: random write/read operations
    #Address 0x6e1 read value
    csrr x14, 0x6e1

    #Address 0x6e1 Write value 0x3f315299
    li x3, 0x3f315299
    csrw 0x6e1, x3

    #Address 0x6e1 Write value 0xf82fcb58
    li x3, 0xf82fcb58
    csrw 0x6e1, x3

    #Address 0x6e1 Write value 0xfd530561
    li x3, 0xfd530561
    csrw 0x6e1, x3

    #Address 0x6e1 Write value 0x4d46694c
    li x3, 0x4d46694c
    csrw 0x6e1, x3

    #Unmapped address 0xe5d testing: random write/read operations
    #Address 0xe5d Write value 0x7341c416
    li x3, 0x7341c416
    csrw 0xe5d, x3

    #Unmapped address 0x5ea testing: random write/read operations
    #Address 0x5ea Write value 0xed5f0466
    li x3, 0xed5f0466
    csrw 0x5ea, x3

    #Address 0x5ea Write value 0x66e1a768
    li x3, 0x66e1a768
    csrw 0x5ea, x3

    #Address 0x5ea Write value 0x28f6daef
    li x3, 0x28f6daef
    csrw 0x5ea, x3

    #Address 0x5ea Write value 0x4fe7f918
    li x3, 0x4fe7f918
    csrw 0x5ea, x3

    #Unmapped address 0x593 testing: random write/read operations
    #Address 0x593 read value
    csrr x14, 0x593

    #Address 0x593 read value
    csrr x14, 0x593

    #Address 0x593 read value
    csrr x14, 0x593

    #Unmapped address 0x30e testing: random write/read operations
    #Address 0x30e read value
    csrr x14, 0x30e

    #Unmapped address 0x189 testing: random write/read operations
    #Address 0x189 Write value 0xeda6d410
    li x3, 0xeda6d410
    csrw 0x189, x3

    #Address 0x189 Write value 0xb47c4d4
    li x3, 0xb47c4d4
    csrw 0x189, x3

    #Address 0x189 read value
    csrr x14, 0x189

    #Address 0x189 Write value 0x87951714
    li x3, 0x87951714
    csrw 0x189, x3

    #Unmapped address 0xcfd testing: random write/read operations
    #Address 0xcfd Write value 0x50f37756
    li x3, 0x50f37756
    csrw 0xcfd, x3

    #Address 0xcfd read value
    csrr x14, 0xcfd

    #Address 0xcfd Write value 0xbbbd9995
    li x3, 0xbbbd9995
    csrw 0xcfd, x3

    #Address 0xcfd Write value 0xdcd2ff4
    li x3, 0xdcd2ff4
    csrw 0xcfd, x3

    #Address 0xcfd Write value 0x61df736b
    li x3, 0x61df736b
    csrw 0xcfd, x3

    #Unmapped address 0x5bb testing: random write/read operations
    #Address 0x5bb read value
    csrr x14, 0x5bb

    #Unmapped address 0x592 testing: random write/read operations
    #Address 0x592 read value
    csrr x14, 0x592

    #Address 0x592 read value
    csrr x14, 0x592

    #Address 0x592 read value
    csrr x14, 0x592

    #Address 0x592 Write value 0x8936428b
    li x3, 0x8936428b
    csrw 0x592, x3

    #Unmapped address 0x350 testing: random write/read operations
    #Address 0x350 read value
    csrr x14, 0x350

    #Address 0x350 read value
    csrr x14, 0x350

    #Unmapped address 0xb41 testing: random write/read operations
    #Address 0xb41 read value
    csrr x14, 0xb41

    #Address 0xb41 Write value 0x1fea0bbf
    li x3, 0x1fea0bbf
    csrw 0xb41, x3

    #Unmapped address 0x86d testing: random write/read operations
    #Address 0x86d Write value 0x4860f16b
    li x3, 0x4860f16b
    csrw 0x86d, x3

    #Address 0x86d read value
    csrr x14, 0x86d

    #Address 0x86d Write value 0x16f33c5d
    li x3, 0x16f33c5d
    csrw 0x86d, x3

    #Address 0x86d read value
    csrr x14, 0x86d

    #Address 0x86d Write value 0x355dbe1
    li x3, 0x355dbe1
    csrw 0x86d, x3

    #Unmapped address 0x115 testing: random write/read operations
    #Address 0x115 read value
    csrr x14, 0x115

    #Address 0x115 read value
    csrr x14, 0x115

    #Unmapped address 0x153 testing: random write/read operations
    #Address 0x153 Write value 0x6bae256c
    li x3, 0x6bae256c
    csrw 0x153, x3

    #Address 0x153 Write value 0x86b3fe6c
    li x3, 0x86b3fe6c
    csrw 0x153, x3

    #Address 0x153 read value
    csrr x14, 0x153

    #Address 0x153 Write value 0xfde869a
    li x3, 0xfde869a
    csrw 0x153, x3

    #Unmapped address 0x238 testing: random write/read operations
    #Address 0x238 read value
    csrr x14, 0x238

    #Address 0x238 read value
    csrr x14, 0x238

    #Address 0x238 read value
    csrr x14, 0x238

    #Address 0x238 Write value 0x7fb885f8
    li x3, 0x7fb885f8
    csrw 0x238, x3

    #Unmapped address 0x6da testing: random write/read operations
    #Address 0x6da Write value 0x946598d8
    li x3, 0x946598d8
    csrw 0x6da, x3

    #Address 0x6da read value
    csrr x14, 0x6da

    #Unmapped address 0x36f testing: random write/read operations
    #Address 0x36f read value
    csrr x14, 0x36f

    #Unmapped address 0xc44 testing: random write/read operations
    #Address 0xc44 read value
    csrr x14, 0xc44

    #Unmapped address 0x6d5 testing: random write/read operations
    #Address 0x6d5 Write value 0x150f9a9c
    li x3, 0x150f9a9c
    csrw 0x6d5, x3

    #Address 0x6d5 Write value 0xda126a8b
    li x3, 0xda126a8b
    csrw 0x6d5, x3

    #Address 0x6d5 read value
    csrr x14, 0x6d5

    #Address 0x6d5 Write value 0x6d71816a
    li x3, 0x6d71816a
    csrw 0x6d5, x3

    #Address 0x6d5 read value
    csrr x14, 0x6d5

    #Unmapped address 0x432 testing: random write/read operations
    #Address 0x432 Write value 0x41c304ca
    li x3, 0x41c304ca
    csrw 0x432, x3

    #Address 0x432 Write value 0x5a499f6f
    li x3, 0x5a499f6f
    csrw 0x432, x3

    #Address 0x432 read value
    csrr x14, 0x432

    #Address 0x432 read value
    csrr x14, 0x432

    #Address 0x432 read value
    csrr x14, 0x432

    #Unmapped address 0xae2 testing: random write/read operations
    #Address 0xae2 read value
    csrr x14, 0xae2

    #Address 0xae2 read value
    csrr x14, 0xae2

    #Address 0xae2 Write value 0xce3f2564
    li x3, 0xce3f2564
    csrw 0xae2, x3

    #Address 0xae2 Write value 0x7690e435
    li x3, 0x7690e435
    csrw 0xae2, x3

    #Address 0xae2 Write value 0x98c4efdd
    li x3, 0x98c4efdd
    csrw 0xae2, x3

    #Unmapped address 0x41e testing: random write/read operations
    #Address 0x41e read value
    csrr x14, 0x41e

    #Unmapped address 0xbe8 testing: random write/read operations
    #Address 0xbe8 read value
    csrr x14, 0xbe8

    #Address 0xbe8 Write value 0xd084d9fe
    li x3, 0xd084d9fe
    csrw 0xbe8, x3

    #Address 0xbe8 Write value 0x6f597434
    li x3, 0x6f597434
    csrw 0xbe8, x3

    #Address 0xbe8 Write value 0x646e7476
    li x3, 0x646e7476
    csrw 0xbe8, x3

    #Unmapped address 0xea9 testing: random write/read operations
    #Address 0xea9 read value
    csrr x14, 0xea9

    #Address 0xea9 Write value 0x5b4b8cd2
    li x3, 0x5b4b8cd2
    csrw 0xea9, x3

    #Address 0xea9 Write value 0xd7c57448
    li x3, 0xd7c57448
    csrw 0xea9, x3

    #Address 0xea9 read value
    csrr x14, 0xea9

    #Unmapped address 0xed1 testing: random write/read operations
    #Address 0xed1 read value
    csrr x14, 0xed1

    #Unmapped address 0x933 testing: random write/read operations
    #Address 0x933 read value
    csrr x14, 0x933

    #Unmapped address 0x607 testing: random write/read operations
    #Address 0x607 read value
    csrr x14, 0x607

    #Address 0x607 Write value 0x1bb2f3ec
    li x3, 0x1bb2f3ec
    csrw 0x607, x3

    #Unmapped address 0xf15 testing: random write/read operations
    #Address 0xf15 read value
    csrr x14, 0xf15

    #Address 0xf15 read value
    csrr x14, 0xf15

    #Unmapped address 0x5f testing: random write/read operations
    #Address 0x5f read value
    csrr x14, 0x5f

    #Address 0x5f Write value 0x646e9017
    li x3, 0x646e9017
    csrw 0x5f, x3

    #Address 0x5f Write value 0xe6a31deb
    li x3, 0xe6a31deb
    csrw 0x5f, x3

    #Address 0x5f read value
    csrr x14, 0x5f

    #Unmapped address 0xa86 testing: random write/read operations
    #Address 0xa86 Write value 0xb7d488b7
    li x3, 0xb7d488b7
    csrw 0xa86, x3

    #Address 0xa86 read value
    csrr x14, 0xa86

    #Unmapped address 0xf17 testing: random write/read operations
    #Address 0xf17 read value
    csrr x14, 0xf17

    #Address 0xf17 Write value 0x473e0f7d
    li x3, 0x473e0f7d
    csrw 0xf17, x3

    #Address 0xf17 Write value 0x18a54cd8
    li x3, 0x18a54cd8
    csrw 0xf17, x3

    #Address 0xf17 Write value 0xafcc8f97
    li x3, 0xafcc8f97
    csrw 0xf17, x3

    #Address 0xf17 Write value 0x1841513d
    li x3, 0x1841513d
    csrw 0xf17, x3

    #Unmapped address 0xfd6 testing: random write/read operations
    #Address 0xfd6 read value
    csrr x14, 0xfd6

    #Address 0xfd6 Write value 0x6018f8aa
    li x3, 0x6018f8aa
    csrw 0xfd6, x3

    #Address 0xfd6 Write value 0x19a4e0c9
    li x3, 0x19a4e0c9
    csrw 0xfd6, x3

    #Address 0xfd6 Write value 0xc7896685
    li x3, 0xc7896685
    csrw 0xfd6, x3

    #Unmapped address 0x724 testing: random write/read operations
    #Address 0x724 Write value 0x24e1a395
    li x3, 0x24e1a395
    csrw 0x724, x3

    #Address 0x724 read value
    csrr x14, 0x724

    #Address 0x724 Write value 0x39635e0e
    li x3, 0x39635e0e
    csrw 0x724, x3

    #Address 0x724 Write value 0xfeb45ec1
    li x3, 0xfeb45ec1
    csrw 0x724, x3

    #Address 0x724 read value
    csrr x14, 0x724

    #Unmapped address 0x78 testing: random write/read operations
    #Address 0x78 Write value 0x752d34a0
    li x3, 0x752d34a0
    csrw 0x78, x3

    #Address 0x78 Write value 0x1e81a11f
    li x3, 0x1e81a11f
    csrw 0x78, x3

    #Address 0x78 read value
    csrr x14, 0x78

    #Address 0x78 read value
    csrr x14, 0x78

    #Unmapped address 0x23c testing: random write/read operations
    #Address 0x23c read value
    csrr x14, 0x23c

    #Address 0x23c Write value 0xa9576c7c
    li x3, 0xa9576c7c
    csrw 0x23c, x3

    #Unmapped address 0x28b testing: random write/read operations
    #Address 0x28b Write value 0x34317cc0
    li x3, 0x34317cc0
    csrw 0x28b, x3

    #Address 0x28b read value
    csrr x14, 0x28b

    #Unmapped address 0xc93 testing: random write/read operations
    #Address 0xc93 read value
    csrr x14, 0xc93

    #Unmapped address 0xfcd testing: random write/read operations
    #Address 0xfcd Write value 0xea3eaf18
    li x3, 0xea3eaf18
    csrw 0xfcd, x3

    #Address 0xfcd read value
    csrr x14, 0xfcd

    #Address 0xfcd read value
    csrr x14, 0xfcd

    #Address 0xfcd read value
    csrr x14, 0xfcd

    #Unmapped address 0xf93 testing: random write/read operations
    #Address 0xf93 read value
    csrr x14, 0xf93

    #Address 0xf93 read value
    csrr x14, 0xf93

    #Address 0xf93 read value
    csrr x14, 0xf93

    #Unmapped address 0xd42 testing: random write/read operations
    #Address 0xd42 Write value 0x808ae7c
    li x3, 0x808ae7c
    csrw 0xd42, x3

    #Address 0xd42 read value
    csrr x14, 0xd42

    #Address 0xd42 Write value 0xa88edc61
    li x3, 0xa88edc61
    csrw 0xd42, x3

    #Address 0xd42 read value
    csrr x14, 0xd42

    #Unmapped address 0x127 testing: random write/read operations
    #Address 0x127 Write value 0xf5bce810
    li x3, 0xf5bce810
    csrw 0x127, x3

    #Address 0x127 Write value 0xac31f9ad
    li x3, 0xac31f9ad
    csrw 0x127, x3

    #Address 0x127 Write value 0xa3eb2c52
    li x3, 0xa3eb2c52
    csrw 0x127, x3

    #Address 0x127 read value
    csrr x14, 0x127

    #Unmapped address 0xdd5 testing: random write/read operations
    #Address 0xdd5 Write value 0x4032474b
    li x3, 0x4032474b
    csrw 0xdd5, x3

    #Unmapped address 0x7e2 testing: random write/read operations
    #Address 0x7e2 Write value 0xe93143ab
    li x3, 0xe93143ab
    csrw 0x7e2, x3

    #Unmapped address 0xffe testing: random write/read operations
    #Address 0xffe Write value 0x65695552
    li x3, 0x65695552
    csrw 0xffe, x3

    #Address 0xffe read value
    csrr x14, 0xffe

    #Unmapped address 0x400 testing: random write/read operations
    #Address 0x400 Write value 0x45041c83
    li x3, 0x45041c83
    csrw 0x400, x3

    #Address 0x400 Write value 0x1b7b66d1
    li x3, 0x1b7b66d1
    csrw 0x400, x3

    #Address 0x400 read value
    csrr x14, 0x400

    #Unmapped address 0x13f testing: random write/read operations
    #Address 0x13f read value
    csrr x14, 0x13f

    #Address 0x13f read value
    csrr x14, 0x13f

    #Address 0x13f read value
    csrr x14, 0x13f

    #Address 0x13f read value
    csrr x14, 0x13f

    #Address 0x13f Write value 0x22b74fe4
    li x3, 0x22b74fe4
    csrw 0x13f, x3

    #Unmapped address 0x7ed testing: random write/read operations
    #Address 0x7ed read value
    csrr x14, 0x7ed

    #Unmapped address 0x87 testing: random write/read operations
    #Address 0x87 read value
    csrr x14, 0x87

    #Address 0x87 Write value 0x47f52b0
    li x3, 0x47f52b0
    csrw 0x87, x3

    #Unmapped address 0xeaf testing: random write/read operations
    #Address 0xeaf read value
    csrr x14, 0xeaf

    #Address 0xeaf read value
    csrr x14, 0xeaf

    #Address 0xeaf read value
    csrr x14, 0xeaf

    #Address 0xeaf read value
    csrr x14, 0xeaf

    #Unmapped address 0xb62 testing: random write/read operations
    #Address 0xb62 Write value 0x763a4d9f
    li x3, 0x763a4d9f
    csrw 0xb62, x3

    #Address 0xb62 read value
    csrr x14, 0xb62

    #Address 0xb62 Write value 0x58449c49
    li x3, 0x58449c49
    csrw 0xb62, x3

    #Address 0xb62 Write value 0xe9f49792
    li x3, 0xe9f49792
    csrw 0xb62, x3

    #Unmapped address 0xca3 testing: random write/read operations
    #Address 0xca3 read value
    csrr x14, 0xca3

    #Address 0xca3 Write value 0x5ab6ea44
    li x3, 0x5ab6ea44
    csrw 0xca3, x3

    #Address 0xca3 read value
    csrr x14, 0xca3

    #Unmapped address 0x65f testing: random write/read operations
    #Address 0x65f Write value 0x6847a536
    li x3, 0x6847a536
    csrw 0x65f, x3

    #Address 0x65f read value
    csrr x14, 0x65f

    #Address 0x65f read value
    csrr x14, 0x65f

    #Address 0x65f read value
    csrr x14, 0x65f

    #Unmapped address 0xd0e testing: random write/read operations
    #Address 0xd0e read value
    csrr x14, 0xd0e

    #Mapped address 0x3b4 (pmpaddr4) testing: random write/read operations
    #Address 0x3b4 Write value 0x43ab69f9
    li x3, 0x43ab69f9
    csrw 0x3b4, x3

    #Address 0x3b4 read value
    csrr x14, 0x3b4

    #Address 0x3b4 Write value 0x6815d6d2
    li x3, 0x6815d6d2
    csrw 0x3b4, x3

    #Address 0x3b4 read value
    csrr x14, 0x3b4

    #Unmapped address 0x947 testing: random write/read operations
    #Address 0x947 Write value 0x2621a21a
    li x3, 0x2621a21a
    csrw 0x947, x3

    #Address 0x947 Write value 0x6bef8f40
    li x3, 0x6bef8f40
    csrw 0x947, x3

    #Address 0x947 read value
    csrr x14, 0x947

    #Unmapped address 0x7bb testing: random write/read operations
    #Address 0x7bb read value
    csrr x14, 0x7bb

    #Address 0x7bb read value
    csrr x14, 0x7bb

    #Address 0x7bb Write value 0xb8c9b1a1
    li x3, 0xb8c9b1a1
    csrw 0x7bb, x3

    #Address 0x7bb read value
    csrr x14, 0x7bb

    #Address 0x7bb Write value 0x209a49ca
    li x3, 0x209a49ca
    csrw 0x7bb, x3

    #Unmapped address 0xafa testing: random write/read operations
    #Address 0xafa Write value 0x98579171
    li x3, 0x98579171
    csrw 0xafa, x3

    #Address 0xafa Write value 0x2f28f095
    li x3, 0x2f28f095
    csrw 0xafa, x3

    #Address 0xafa Write value 0x985ad3ba
    li x3, 0x985ad3ba
    csrw 0xafa, x3

    #Address 0xafa read value
    csrr x14, 0xafa

    #Unmapped address 0xafb testing: random write/read operations
    #Address 0xafb Write value 0xcbad100d
    li x3, 0xcbad100d
    csrw 0xafb, x3

    #Address 0xafb Write value 0xca049f69
    li x3, 0xca049f69
    csrw 0xafb, x3

    #Address 0xafb Write value 0x5ac18606
    li x3, 0x5ac18606
    csrw 0xafb, x3

    #Address 0xafb read value
    csrr x14, 0xafb

    #Address 0xafb read value
    csrr x14, 0xafb

    #Unmapped address 0x9a5 testing: random write/read operations
    #Address 0x9a5 Write value 0x3f71fa37
    li x3, 0x3f71fa37
    csrw 0x9a5, x3

    #Address 0x9a5 Write value 0x2c2f9bfb
    li x3, 0x2c2f9bfb
    csrw 0x9a5, x3

    #Unmapped address 0x987 testing: random write/read operations
    #Address 0x987 read value
    csrr x14, 0x987

    #Address 0x987 read value
    csrr x14, 0x987

    #Address 0x987 read value
    csrr x14, 0x987

    #Address 0x987 Write value 0xdf88474f
    li x3, 0xdf88474f
    csrw 0x987, x3

    #Address 0x987 read value
    csrr x14, 0x987

    #Unmapped address 0x34e testing: random write/read operations
    #Address 0x34e Write value 0x3b3ba350
    li x3, 0x3b3ba350
    csrw 0x34e, x3

    #Address 0x34e Write value 0x386c4cfd
    li x3, 0x386c4cfd
    csrw 0x34e, x3

    #Address 0x34e read value
    csrr x14, 0x34e

    #Unmapped address 0x1b5 testing: random write/read operations
    #Address 0x1b5 read value
    csrr x14, 0x1b5

    #Address 0x1b5 Write value 0xe66f96ff
    li x3, 0xe66f96ff
    csrw 0x1b5, x3

    #Address 0x1b5 read value
    csrr x14, 0x1b5

    #Address 0x1b5 read value
    csrr x14, 0x1b5

    #Unmapped address 0x5df testing: random write/read operations
    #Address 0x5df Write value 0x98fd5f3b
    li x3, 0x98fd5f3b
    csrw 0x5df, x3

    #Address 0x5df read value
    csrr x14, 0x5df

    #Address 0x5df Write value 0xb7728353
    li x3, 0xb7728353
    csrw 0x5df, x3

    #Address 0x5df read value
    csrr x14, 0x5df

    #Address 0x5df read value
    csrr x14, 0x5df

    #Unmapped address 0x485 testing: random write/read operations
    #Address 0x485 Write value 0xaa7f65c1
    li x3, 0xaa7f65c1
    csrw 0x485, x3

    #Address 0x485 Write value 0xa63b4682
    li x3, 0xa63b4682
    csrw 0x485, x3

    #Unmapped address 0xcda testing: random write/read operations
    #Address 0xcda Write value 0xffe4f22a
    li x3, 0xffe4f22a
    csrw 0xcda, x3

    #Address 0xcda read value
    csrr x14, 0xcda

    #Unmapped address 0x451 testing: random write/read operations
    #Address 0x451 read value
    csrr x14, 0x451

    #Address 0x451 read value
    csrr x14, 0x451

    #Unmapped address 0x9ad testing: random write/read operations
    #Address 0x9ad read value
    csrr x14, 0x9ad

    #Unmapped address 0xfcf testing: random write/read operations
    #Address 0xfcf read value
    csrr x14, 0xfcf

    #Address 0xfcf Write value 0xa43c3c5d
    li x3, 0xa43c3c5d
    csrw 0xfcf, x3

    #Address 0xfcf Write value 0xdd389aa9
    li x3, 0xdd389aa9
    csrw 0xfcf, x3

    #Address 0xfcf Write value 0xdf47c8ca
    li x3, 0xdf47c8ca
    csrw 0xfcf, x3

    #Unmapped address 0x362 testing: random write/read operations
    #Address 0x362 Write value 0x4121829
    li x3, 0x4121829
    csrw 0x362, x3

    #Address 0x362 Write value 0xaee598e5
    li x3, 0xaee598e5
    csrw 0x362, x3

    #Address 0x362 read value
    csrr x14, 0x362

    #Unmapped address 0xa8e testing: random write/read operations
    #Address 0xa8e read value
    csrr x14, 0xa8e

    #Address 0xa8e Write value 0x91c35fed
    li x3, 0x91c35fed
    csrw 0xa8e, x3

    #Address 0xa8e read value
    csrr x14, 0xa8e

    #Address 0xa8e Write value 0xb06cb6a0
    li x3, 0xb06cb6a0
    csrw 0xa8e, x3

    #Address 0xa8e Write value 0xa72360ce
    li x3, 0xa72360ce
    csrw 0xa8e, x3

    #Unmapped address 0xaa2 testing: random write/read operations
    #Address 0xaa2 Write value 0x25cb457a
    li x3, 0x25cb457a
    csrw 0xaa2, x3

    #Unmapped address 0xf46 testing: random write/read operations
    #Address 0xf46 read value
    csrr x14, 0xf46

    #Address 0xf46 read value
    csrr x14, 0xf46

    #Unmapped address 0xe41 testing: random write/read operations
    #Address 0xe41 Write value 0x7f15c0f0
    li x3, 0x7f15c0f0
    csrw 0xe41, x3

    #Address 0xe41 Write value 0x85654658
    li x3, 0x85654658
    csrw 0xe41, x3

    #Address 0xe41 read value
    csrr x14, 0xe41

    #Address 0xe41 Write value 0x931fd602
    li x3, 0x931fd602
    csrw 0xe41, x3

    #Unmapped address 0xbb0 testing: random write/read operations
    #Address 0xbb0 Write value 0x9247d2e7
    li x3, 0x9247d2e7
    csrw 0xbb0, x3

    #Address 0xbb0 Write value 0xdd688fcf
    li x3, 0xdd688fcf
    csrw 0xbb0, x3

    #Address 0xbb0 Write value 0x3b8ad262
    li x3, 0x3b8ad262
    csrw 0xbb0, x3

    #Unmapped address 0x7cf testing: random write/read operations
    #Address 0x7cf Write value 0x2936ff76
    li x3, 0x2936ff76
    csrw 0x7cf, x3

    #Unmapped address 0xa0a testing: random write/read operations
    #Address 0xa0a read value
    csrr x14, 0xa0a

    #Address 0xa0a Write value 0x3262f6fa
    li x3, 0x3262f6fa
    csrw 0xa0a, x3

    #Address 0xa0a Write value 0x9b036792
    li x3, 0x9b036792
    csrw 0xa0a, x3

    #Address 0xa0a read value
    csrr x14, 0xa0a

    #Unmapped address 0x8f7 testing: random write/read operations
    #Address 0x8f7 read value
    csrr x14, 0x8f7

    #Address 0x8f7 read value
    csrr x14, 0x8f7

    #Address 0x8f7 read value
    csrr x14, 0x8f7

    #Address 0x8f7 read value
    csrr x14, 0x8f7

    #Unmapped address 0x87d testing: random write/read operations
    #Address 0x87d read value
    csrr x14, 0x87d

    #Unmapped address 0x86f testing: random write/read operations
    #Address 0x86f Write value 0xc1cf4b17
    li x3, 0xc1cf4b17
    csrw 0x86f, x3

    #Address 0x86f read value
    csrr x14, 0x86f

    #Address 0x86f Write value 0x4a1a915a
    li x3, 0x4a1a915a
    csrw 0x86f, x3

    #Address 0x86f Write value 0xd37d68e1
    li x3, 0xd37d68e1
    csrw 0x86f, x3

    #Unmapped address 0x1ce testing: random write/read operations
    #Address 0x1ce read value
    csrr x14, 0x1ce

    #Address 0x1ce Write value 0xcc103c6
    li x3, 0xcc103c6
    csrw 0x1ce, x3

    #Address 0x1ce Write value 0x3ca2aed4
    li x3, 0x3ca2aed4
    csrw 0x1ce, x3

    #Address 0x1ce Write value 0xdff8c001
    li x3, 0xdff8c001
    csrw 0x1ce, x3

    #Mapped address 0xb10 (mhpmcounter16) testing: random write/read operations
    #Address 0xb10 read value
    csrr x14, 0xb10

    #Address 0xb10 Write value 0xb2ee2999
    li x3, 0xb2ee2999
    csrw 0xb10, x3

    #Address 0xb10 read value
    csrr x14, 0xb10

    #Address 0xb10 Write value 0x56d15ca1
    li x3, 0x56d15ca1
    csrw 0xb10, x3

    #Unmapped address 0xc7f testing: random write/read operations
    #Address 0xc7f read value
    csrr x14, 0xc7f

    #Unmapped address 0xccd testing: random write/read operations
    #Address 0xccd Write value 0x4b2b36c0
    li x3, 0x4b2b36c0
    csrw 0xccd, x3

    #Address 0xccd read value
    csrr x14, 0xccd

    #Address 0xccd Write value 0x30bd8496
    li x3, 0x30bd8496
    csrw 0xccd, x3

    #Address 0xccd Write value 0xfdb878f7
    li x3, 0xfdb878f7
    csrw 0xccd, x3

    #Unmapped address 0xc31 testing: random write/read operations
    #Address 0xc31 read value
    csrr x14, 0xc31

    #Address 0xc31 Write value 0x10436117
    li x3, 0x10436117
    csrw 0xc31, x3

    #Address 0xc31 Write value 0x406f9144
    li x3, 0x406f9144
    csrw 0xc31, x3

    #Address 0xc31 read value
    csrr x14, 0xc31

    #Unmapped address 0xe74 testing: random write/read operations
    #Address 0xe74 read value
    csrr x14, 0xe74

    #Unmapped address 0x84f testing: random write/read operations
    #Address 0x84f read value
    csrr x14, 0x84f

    #Address 0x84f Write value 0x116be920
    li x3, 0x116be920
    csrw 0x84f, x3

    #Unmapped address 0x633 testing: random write/read operations
    #Address 0x633 read value
    csrr x14, 0x633

    #Address 0x633 Write value 0x3bce9232
    li x3, 0x3bce9232
    csrw 0x633, x3

    #Address 0x633 read value
    csrr x14, 0x633

    #Unmapped address 0x8b1 testing: random write/read operations
    #Address 0x8b1 read value
    csrr x14, 0x8b1

    #Address 0x8b1 read value
    csrr x14, 0x8b1

    #Address 0x8b1 Write value 0xa93362fa
    li x3, 0xa93362fa
    csrw 0x8b1, x3

    #Address 0x8b1 Write value 0x581e6263
    li x3, 0x581e6263
    csrw 0x8b1, x3

    #Unmapped address 0x642 testing: random write/read operations
    #Address 0x642 read value
    csrr x14, 0x642

    #Address 0x642 read value
    csrr x14, 0x642

    #Address 0x642 read value
    csrr x14, 0x642

    #Address 0x642 Write value 0x18768e71
    li x3, 0x18768e71
    csrw 0x642, x3

    #Address 0x642 read value
    csrr x14, 0x642

    #Unmapped address 0x6cb testing: random write/read operations
    #Address 0x6cb Write value 0x231c5821
    li x3, 0x231c5821
    csrw 0x6cb, x3

    #Unmapped address 0x4ad testing: random write/read operations
    #Address 0x4ad read value
    csrr x14, 0x4ad

    #Address 0x4ad Write value 0x761202a9
    li x3, 0x761202a9
    csrw 0x4ad, x3

    #Address 0x4ad Write value 0x489e0b3b
    li x3, 0x489e0b3b
    csrw 0x4ad, x3

    #Unmapped address 0x7e9 testing: random write/read operations
    #Address 0x7e9 read value
    csrr x14, 0x7e9

    #Address 0x7e9 Write value 0x27ddd24c
    li x3, 0x27ddd24c
    csrw 0x7e9, x3

    #Address 0x7e9 read value
    csrr x14, 0x7e9

    #Address 0x7e9 Write value 0xa5c4e73b
    li x3, 0xa5c4e73b
    csrw 0x7e9, x3

    #Unmapped address 0x649 testing: random write/read operations
    #Address 0x649 Write value 0x369d17b7
    li x3, 0x369d17b7
    csrw 0x649, x3

    #Address 0x649 Write value 0x3d70912a
    li x3, 0x3d70912a
    csrw 0x649, x3

    #Address 0x649 Write value 0x1c2b392b
    li x3, 0x1c2b392b
    csrw 0x649, x3

    #Address 0x649 Write value 0x613eb9c1
    li x3, 0x613eb9c1
    csrw 0x649, x3

    #Address 0x649 Write value 0x73621b1
    li x3, 0x73621b1
    csrw 0x649, x3

    #Unmapped address 0xf31 testing: random write/read operations
    #Address 0xf31 Write value 0x33dee804
    li x3, 0x33dee804
    csrw 0xf31, x3

    #Address 0xf31 Write value 0x7d0c27b6
    li x3, 0x7d0c27b6
    csrw 0xf31, x3

    #Address 0xf31 Write value 0xfc4cdc67
    li x3, 0xfc4cdc67
    csrw 0xf31, x3

    #Address 0xf31 Write value 0x560f31a4
    li x3, 0x560f31a4
    csrw 0xf31, x3

    #Address 0xf31 read value
    csrr x14, 0xf31

    #Unmapped address 0xd2f testing: random write/read operations
    #Address 0xd2f read value
    csrr x14, 0xd2f

    #Unmapped address 0x8d9 testing: random write/read operations
    #Address 0x8d9 Write value 0xae78e28d
    li x3, 0xae78e28d
    csrw 0x8d9, x3

    #Address 0x8d9 Write value 0xf0ea9e94
    li x3, 0xf0ea9e94
    csrw 0x8d9, x3

    #Address 0x8d9 read value
    csrr x14, 0x8d9

    #Address 0x8d9 Write value 0x93c13a28
    li x3, 0x93c13a28
    csrw 0x8d9, x3

    #Unmapped address 0xcd7 testing: random write/read operations
    #Address 0xcd7 read value
    csrr x14, 0xcd7

    #Address 0xcd7 read value
    csrr x14, 0xcd7

    #Address 0xcd7 read value
    csrr x14, 0xcd7

    #Address 0xcd7 read value
    csrr x14, 0xcd7

    #Unmapped address 0xe4d testing: random write/read operations
    #Address 0xe4d Write value 0x8ac8ea97
    li x3, 0x8ac8ea97
    csrw 0xe4d, x3

    #Address 0xe4d read value
    csrr x14, 0xe4d

    #Unmapped address 0x4fc testing: random write/read operations
    #Address 0x4fc Write value 0xac7f1cb
    li x3, 0xac7f1cb
    csrw 0x4fc, x3

    #Unmapped address 0xacc testing: random write/read operations
    #Address 0xacc read value
    csrr x14, 0xacc

    #Address 0xacc Write value 0x4bfd532
    li x3, 0x4bfd532
    csrw 0xacc, x3

    #Address 0xacc Write value 0xe62880b9
    li x3, 0xe62880b9
    csrw 0xacc, x3

    #Unmapped address 0xfa2 testing: random write/read operations
    #Address 0xfa2 read value
    csrr x14, 0xfa2

    #Address 0xfa2 Write value 0xf42f38c6
    li x3, 0xf42f38c6
    csrw 0xfa2, x3

    #Address 0xfa2 Write value 0x6cca1926
    li x3, 0x6cca1926
    csrw 0xfa2, x3

    #Address 0xfa2 read value
    csrr x14, 0xfa2

    #Unmapped address 0xad9 testing: random write/read operations
    #Address 0xad9 Write value 0xfc5adc18
    li x3, 0xfc5adc18
    csrw 0xad9, x3

    #Address 0xad9 Write value 0x7821c8ba
    li x3, 0x7821c8ba
    csrw 0xad9, x3

    #Address 0xad9 Write value 0x43b5bb8
    li x3, 0x43b5bb8
    csrw 0xad9, x3

    #Unmapped address 0x9dd testing: random write/read operations
    #Address 0x9dd Write value 0x28ec7ca0
    li x3, 0x28ec7ca0
    csrw 0x9dd, x3

    #Address 0x9dd Write value 0xfd1bce35
    li x3, 0xfd1bce35
    csrw 0x9dd, x3

    #Address 0x9dd read value
    csrr x14, 0x9dd

    #Address 0x9dd read value
    csrr x14, 0x9dd

    #Unmapped address 0x125 testing: random write/read operations
    #Address 0x125 read value
    csrr x14, 0x125

    #Unmapped address 0xe94 testing: random write/read operations
    #Address 0xe94 read value
    csrr x14, 0xe94

    #Address 0xe94 read value
    csrr x14, 0xe94

    #Address 0xe94 read value
    csrr x14, 0xe94

    #Address 0xe94 read value
    csrr x14, 0xe94

    #Address 0xe94 Write value 0xba01083
    li x3, 0xba01083
    csrw 0xe94, x3

    #Unmapped address 0xd9d testing: random write/read operations
    #Address 0xd9d Write value 0xaf2f325b
    li x3, 0xaf2f325b
    csrw 0xd9d, x3

    #Address 0xd9d Write value 0x5e8618d0
    li x3, 0x5e8618d0
    csrw 0xd9d, x3

    #Address 0xd9d read value
    csrr x14, 0xd9d

    #Address 0xd9d read value
    csrr x14, 0xd9d

    #Address 0xd9d Write value 0x2452b362
    li x3, 0x2452b362
    csrw 0xd9d, x3

    #Unmapped address 0xd7b testing: random write/read operations
    #Address 0xd7b Write value 0xbdb85908
    li x3, 0xbdb85908
    csrw 0xd7b, x3

    #Address 0xd7b read value
    csrr x14, 0xd7b

    #Unmapped address 0x131 testing: random write/read operations
    #Address 0x131 read value
    csrr x14, 0x131

    #Address 0x131 read value
    csrr x14, 0x131

    #Address 0x131 Write value 0x41760e8
    li x3, 0x41760e8
    csrw 0x131, x3

    #Address 0x131 Write value 0xf681c1c9
    li x3, 0xf681c1c9
    csrw 0x131, x3

    #Address 0x131 read value
    csrr x14, 0x131

    #Unmapped address 0x398 testing: random write/read operations
    #Address 0x398 Write value 0xbc9adc8
    li x3, 0xbc9adc8
    csrw 0x398, x3

    #Address 0x398 read value
    csrr x14, 0x398

    #Unmapped address 0x9a6 testing: random write/read operations
    #Address 0x9a6 read value
    csrr x14, 0x9a6

    #Address 0x9a6 read value
    csrr x14, 0x9a6

    #Address 0x9a6 read value
    csrr x14, 0x9a6

    #Unmapped address 0xaef testing: random write/read operations
    #Address 0xaef Write value 0xd402f377
    li x3, 0xd402f377
    csrw 0xaef, x3

    #Address 0xaef Write value 0xa7751da3
    li x3, 0xa7751da3
    csrw 0xaef, x3

    #Address 0xaef read value
    csrr x14, 0xaef

    #Address 0xaef read value
    csrr x14, 0xaef

    #Unmapped address 0x72b testing: random write/read operations
    #Address 0x72b Write value 0x4c0d3853
    li x3, 0x4c0d3853
    csrw 0x72b, x3

    #Unmapped address 0xa68 testing: random write/read operations
    #Address 0xa68 Write value 0xca886dc5
    li x3, 0xca886dc5
    csrw 0xa68, x3

    #Unmapped address 0x8a7 testing: random write/read operations
    #Address 0x8a7 read value
    csrr x14, 0x8a7

    #Address 0x8a7 Write value 0xd46082eb
    li x3, 0xd46082eb
    csrw 0x8a7, x3

    #Unmapped address 0x834 testing: random write/read operations
    #Address 0x834 read value
    csrr x14, 0x834

    #Address 0x834 Write value 0xfcff5a1f
    li x3, 0xfcff5a1f
    csrw 0x834, x3

    #Address 0x834 Write value 0xa2ce3816
    li x3, 0xa2ce3816
    csrw 0x834, x3

    #Address 0x834 Write value 0xe1dec77b
    li x3, 0xe1dec77b
    csrw 0x834, x3

    #Unmapped address 0xd32 testing: random write/read operations
    #Address 0xd32 Write value 0xa228f962
    li x3, 0xa228f962
    csrw 0xd32, x3

    #Address 0xd32 read value
    csrr x14, 0xd32

    #Address 0xd32 Write value 0x154d3756
    li x3, 0x154d3756
    csrw 0xd32, x3

    #Unmapped address 0xce3 testing: random write/read operations
    #Address 0xce3 read value
    csrr x14, 0xce3

    #Address 0xce3 Write value 0x486ecfaf
    li x3, 0x486ecfaf
    csrw 0xce3, x3

    #Unmapped address 0x931 testing: random write/read operations
    #Address 0x931 read value
    csrr x14, 0x931

    #Address 0x931 read value
    csrr x14, 0x931

    #Unmapped address 0x6d6 testing: random write/read operations
    #Address 0x6d6 read value
    csrr x14, 0x6d6

    #Address 0x6d6 read value
    csrr x14, 0x6d6

    #Address 0x6d6 read value
    csrr x14, 0x6d6

    #Address 0x6d6 Write value 0xd4e4391e
    li x3, 0xd4e4391e
    csrw 0x6d6, x3

    #Unmapped address 0x179 testing: random write/read operations
    #Address 0x179 read value
    csrr x14, 0x179

    #Address 0x179 Write value 0x45c9114d
    li x3, 0x45c9114d
    csrw 0x179, x3

    #Address 0x179 Write value 0xc9de21ab
    li x3, 0xc9de21ab
    csrw 0x179, x3

    #Unmapped address 0x557 testing: random write/read operations
    #Address 0x557 read value
    csrr x14, 0x557

    #Address 0x557 read value
    csrr x14, 0x557

    #Address 0x557 read value
    csrr x14, 0x557

    #Address 0x557 read value
    csrr x14, 0x557

    #Address 0x557 Write value 0x9e6024b8
    li x3, 0x9e6024b8
    csrw 0x557, x3

    #Unmapped address 0x82d testing: random write/read operations
    #Address 0x82d read value
    csrr x14, 0x82d

    #Address 0x82d read value
    csrr x14, 0x82d

    #Unmapped address 0xbb1 testing: random write/read operations
    #Address 0xbb1 Write value 0x5077492f
    li x3, 0x5077492f
    csrw 0xbb1, x3

    #Address 0xbb1 Write value 0x9fa559e2
    li x3, 0x9fa559e2
    csrw 0xbb1, x3

    #Address 0xbb1 read value
    csrr x14, 0xbb1

    #Address 0xbb1 Write value 0x8a8cf7b9
    li x3, 0x8a8cf7b9
    csrw 0xbb1, x3

    #Unmapped address 0x9ef testing: random write/read operations
    #Address 0x9ef Write value 0x7dc6823c
    li x3, 0x7dc6823c
    csrw 0x9ef, x3

    #Address 0x9ef read value
    csrr x14, 0x9ef

    #Address 0x9ef read value
    csrr x14, 0x9ef

    #Address 0x9ef read value
    csrr x14, 0x9ef

    #Unmapped address 0xcc0 testing: random write/read operations
    #Address 0xcc0 Write value 0x4760062c
    li x3, 0x4760062c
    csrw 0xcc0, x3

    #Mapped address 0xb8d (mhpmcounterh13) testing: random write/read operations
    #Address 0xb8d read value
    csrr x14, 0xb8d

    #Address 0xb8d read value
    csrr x14, 0xb8d

    #Address 0xb8d Write value 0xef0762e8
    li x3, 0xef0762e8
    csrw 0xb8d, x3

    #Address 0xb8d read value
    csrr x14, 0xb8d

    #Address 0xb8d read value
    csrr x14, 0xb8d

    #Unmapped address 0x770 testing: random write/read operations
    #Address 0x770 Write value 0x69909562
    li x3, 0x69909562
    csrw 0x770, x3

    #Address 0x770 Write value 0xec6ca04d
    li x3, 0xec6ca04d
    csrw 0x770, x3

    #Address 0x770 read value
    csrr x14, 0x770

    #Address 0x770 read value
    csrr x14, 0x770

    #Address 0x770 read value
    csrr x14, 0x770

    #Unmapped address 0x6d1 testing: random write/read operations
    #Address 0x6d1 read value
    csrr x14, 0x6d1

    #Address 0x6d1 Write value 0x6759a784
    li x3, 0x6759a784
    csrw 0x6d1, x3

    #Address 0x6d1 read value
    csrr x14, 0x6d1

    #Address 0x6d1 Write value 0x3036fefb
    li x3, 0x3036fefb
    csrw 0x6d1, x3

    #Unmapped address 0xa6e testing: random write/read operations
    #Address 0xa6e Write value 0x9a11a8d4
    li x3, 0x9a11a8d4
    csrw 0xa6e, x3

    #Address 0xa6e Write value 0x13e67897
    li x3, 0x13e67897
    csrw 0xa6e, x3

    #Unmapped address 0xf05 testing: random write/read operations
    #Address 0xf05 Write value 0xb358695f
    li x3, 0xb358695f
    csrw 0xf05, x3

    #Address 0xf05 Write value 0xaf026cf
    li x3, 0xaf026cf
    csrw 0xf05, x3

    #Address 0xf05 read value
    csrr x14, 0xf05

    #Unmapped address 0xc6b testing: random write/read operations
    #Address 0xc6b Write value 0x78eed6ba
    li x3, 0x78eed6ba
    csrw 0xc6b, x3

    #Address 0xc6b Write value 0xf206fa46
    li x3, 0xf206fa46
    csrw 0xc6b, x3

    #Unmapped address 0xc0c testing: random write/read operations
    #Address 0xc0c Write value 0x2edb5de8
    li x3, 0x2edb5de8
    csrw 0xc0c, x3

    #Unmapped address 0x185 testing: random write/read operations
    #Address 0x185 read value
    csrr x14, 0x185

    #Address 0x185 read value
    csrr x14, 0x185

    #Address 0x185 Write value 0xe923a8d9
    li x3, 0xe923a8d9
    csrw 0x185, x3

    #Address 0x185 Write value 0xc41d77b4
    li x3, 0xc41d77b4
    csrw 0x185, x3

    #Address 0x185 read value
    csrr x14, 0x185

    #Unmapped address 0xe47 testing: random write/read operations
    #Address 0xe47 read value
    csrr x14, 0xe47

    #Address 0xe47 read value
    csrr x14, 0xe47

    #Address 0xe47 Write value 0x914ec145
    li x3, 0x914ec145
    csrw 0xe47, x3

    #Address 0xe47 read value
    csrr x14, 0xe47

    #Address 0xe47 read value
    csrr x14, 0xe47

    #Mapped address 0x3ba (pmpaddr10) testing: random write/read operations
    #Address 0x3ba Write value 0x8f52e8e5
    li x3, 0x8f52e8e5
    csrw 0x3ba, x3

    #Unmapped address 0x497 testing: random write/read operations
    #Address 0x497 Write value 0x8db34ee2
    li x3, 0x8db34ee2
    csrw 0x497, x3

    #Unmapped address 0xfaa testing: random write/read operations
    #Address 0xfaa read value
    csrr x14, 0xfaa

    #Address 0xfaa read value
    csrr x14, 0xfaa

    #Address 0xfaa Write value 0x75668b3a
    li x3, 0x75668b3a
    csrw 0xfaa, x3

    #Unmapped address 0x909 testing: random write/read operations
    #Address 0x909 read value
    csrr x14, 0x909

    #Unmapped address 0xac0 testing: random write/read operations
    #Address 0xac0 Write value 0x4c646288
    li x3, 0x4c646288
    csrw 0xac0, x3

    #Address 0xac0 read value
    csrr x14, 0xac0

    #Address 0xac0 read value
    csrr x14, 0xac0

    #Unmapped address 0xa6b testing: random write/read operations
    #Address 0xa6b Write value 0x497bd18a
    li x3, 0x497bd18a
    csrw 0xa6b, x3

    #Unmapped address 0x255 testing: random write/read operations
    #Address 0x255 read value
    csrr x14, 0x255

    #Address 0x255 read value
    csrr x14, 0x255

    #Address 0x255 read value
    csrr x14, 0x255

    #Unmapped address 0xfd9 testing: random write/read operations
    #Address 0xfd9 read value
    csrr x14, 0xfd9

    #Address 0xfd9 Write value 0x61641b77
    li x3, 0x61641b77
    csrw 0xfd9, x3

    #Address 0xfd9 read value
    csrr x14, 0xfd9

    #Address 0xfd9 Write value 0x5c2390af
    li x3, 0x5c2390af
    csrw 0xfd9, x3

    #Address 0xfd9 read value
    csrr x14, 0xfd9

    #Unmapped address 0x786 testing: random write/read operations
    #Address 0x786 Write value 0x4e58cefc
    li x3, 0x4e58cefc
    csrw 0x786, x3

    #Unmapped address 0xff4 testing: random write/read operations
    #Address 0xff4 read value
    csrr x14, 0xff4

    #Address 0xff4 Write value 0xcaa1c3be
    li x3, 0xcaa1c3be
    csrw 0xff4, x3

    #Unmapped address 0x666 testing: random write/read operations
    #Address 0x666 Write value 0x79ef9e3b
    li x3, 0x79ef9e3b
    csrw 0x666, x3

    #Address 0x666 Write value 0x302ceaab
    li x3, 0x302ceaab
    csrw 0x666, x3

    #Unmapped address 0x9a9 testing: random write/read operations
    #Address 0x9a9 Write value 0xb5a0a368
    li x3, 0xb5a0a368
    csrw 0x9a9, x3

    #Address 0x9a9 read value
    csrr x14, 0x9a9

    #Address 0x9a9 Write value 0x595cbf2c
    li x3, 0x595cbf2c
    csrw 0x9a9, x3

    #Address 0x9a9 read value
    csrr x14, 0x9a9

    #Mapped address 0x310 (mstatush) testing: random write/read operations
    #Address 0x310 read value
    csrr x14, 0x310

    #Address 0x310 Write value 0x9107636
    li x3, 0x9107636
    csrw 0x310, x3

    #Address 0x310 Write value 0x772b2492
    li x3, 0x772b2492
    csrw 0x310, x3

    #Address 0x310 Write value 0xf6ad2d80
    li x3, 0xf6ad2d80
    csrw 0x310, x3

    #Unmapped address 0x5de testing: random write/read operations
    #Address 0x5de Write value 0xbc015544
    li x3, 0xbc015544
    csrw 0x5de, x3

    #Mapped address 0x340 (mscratch) testing: random write/read operations
    #Address 0x340 Write value 0x57cad6f9
    li x3, 0x57cad6f9
    csrw 0x340, x3

    #Address 0x340 read value
    csrr x14, 0x340

    #Address 0x340 read value
    csrr x14, 0x340

    #Unmapped address 0xd8e testing: random write/read operations
    #Address 0xd8e read value
    csrr x14, 0xd8e

    #Unmapped address 0x34d testing: random write/read operations
    #Address 0x34d Write value 0x7eb4bc19
    li x3, 0x7eb4bc19
    csrw 0x34d, x3

    #Address 0x34d Write value 0xe52a2913
    li x3, 0xe52a2913
    csrw 0x34d, x3

    #Unmapped address 0xc99 testing: random write/read operations
    #Address 0xc99 Write value 0xc8113904
    li x3, 0xc8113904
    csrw 0xc99, x3

    #Address 0xc99 Write value 0x621beaf7
    li x3, 0x621beaf7
    csrw 0xc99, x3

    #Address 0xc99 Write value 0x784929da
    li x3, 0x784929da
    csrw 0xc99, x3

    #Unmapped address 0xf41 testing: random write/read operations
    #Address 0xf41 Write value 0xf9e03cdf
    li x3, 0xf9e03cdf
    csrw 0xf41, x3

    #Address 0xf41 read value
    csrr x14, 0xf41

    #Address 0xf41 read value
    csrr x14, 0xf41

    #Unmapped address 0x98a testing: random write/read operations
    #Address 0x98a read value
    csrr x14, 0x98a

    #Address 0x98a Write value 0xe9145847
    li x3, 0xe9145847
    csrw 0x98a, x3

    #Address 0x98a read value
    csrr x14, 0x98a

    #Address 0x98a read value
    csrr x14, 0x98a

    #Address 0x98a read value
    csrr x14, 0x98a

    #Unmapped address 0x4bd testing: random write/read operations
    #Address 0x4bd read value
    csrr x14, 0x4bd

    #Address 0x4bd read value
    csrr x14, 0x4bd

    #Unmapped address 0xda7 testing: random write/read operations
    #Address 0xda7 Write value 0xbe41a323
    li x3, 0xbe41a323
    csrw 0xda7, x3

    #Address 0xda7 Write value 0xb141bc18
    li x3, 0xb141bc18
    csrw 0xda7, x3

    #Address 0xda7 Write value 0xae16d7f6
    li x3, 0xae16d7f6
    csrw 0xda7, x3

    #Address 0xda7 Write value 0xa74c8151
    li x3, 0xa74c8151
    csrw 0xda7, x3

    #Address 0xda7 read value
    csrr x14, 0xda7

    #Unmapped address 0x135 testing: random write/read operations
    #Address 0x135 Write value 0x2b1a9de6
    li x3, 0x2b1a9de6
    csrw 0x135, x3

    #Address 0x135 Write value 0x3cca037d
    li x3, 0x3cca037d
    csrw 0x135, x3

    #Address 0x135 Write value 0xde870423
    li x3, 0xde870423
    csrw 0x135, x3

    #Address 0x135 Write value 0x9554c246
    li x3, 0x9554c246
    csrw 0x135, x3

    #Unmapped address 0x685 testing: random write/read operations
    #Address 0x685 Write value 0xfae96405
    li x3, 0xfae96405
    csrw 0x685, x3

    #Unmapped address 0x288 testing: random write/read operations
    #Address 0x288 read value
    csrr x14, 0x288

    #Address 0x288 Write value 0xe2f9b9eb
    li x3, 0xe2f9b9eb
    csrw 0x288, x3

    #Unmapped address 0x5eb testing: random write/read operations
    #Address 0x5eb Write value 0xda245943
    li x3, 0xda245943
    csrw 0x5eb, x3

    #Address 0x5eb read value
    csrr x14, 0x5eb

    #Address 0x5eb Write value 0x66a3a617
    li x3, 0x66a3a617
    csrw 0x5eb, x3

    #Address 0x5eb read value
    csrr x14, 0x5eb

    #Address 0x5eb Write value 0xdccb79ec
    li x3, 0xdccb79ec
    csrw 0x5eb, x3

    #Unmapped address 0x7ca testing: random write/read operations
    #Address 0x7ca read value
    csrr x14, 0x7ca

    #Address 0x7ca Write value 0x7be7b0ea
    li x3, 0x7be7b0ea
    csrw 0x7ca, x3

    #Address 0x7ca read value
    csrr x14, 0x7ca

    #Unmapped address 0xd36 testing: random write/read operations
    #Address 0xd36 read value
    csrr x14, 0xd36

    #Address 0xd36 read value
    csrr x14, 0xd36

    #Address 0xd36 read value
    csrr x14, 0xd36

    #Unmapped address 0xee7 testing: random write/read operations
    #Address 0xee7 Write value 0xdabef3ef
    li x3, 0xdabef3ef
    csrw 0xee7, x3

    #Address 0xee7 read value
    csrr x14, 0xee7

    #Unmapped address 0xfbf testing: random write/read operations
    #Address 0xfbf read value
    csrr x14, 0xfbf

    #Unmapped address 0x2eb testing: random write/read operations
    #Address 0x2eb read value
    csrr x14, 0x2eb

    #Address 0x2eb Write value 0xd285f79
    li x3, 0xd285f79
    csrw 0x2eb, x3

    #Unmapped address 0xacb testing: random write/read operations
    #Address 0xacb read value
    csrr x14, 0xacb

    #Unmapped address 0x9a testing: random write/read operations
    #Address 0x9a read value
    csrr x14, 0x9a

    #Address 0x9a read value
    csrr x14, 0x9a

    #Unmapped address 0x829 testing: random write/read operations
    #Address 0x829 Write value 0xac6521f
    li x3, 0xac6521f
    csrw 0x829, x3

    #Address 0x829 read value
    csrr x14, 0x829

    #Address 0x829 read value
    csrr x14, 0x829

    #Unmapped address 0xa11 testing: random write/read operations
    #Address 0xa11 Write value 0x90daff33
    li x3, 0x90daff33
    csrw 0xa11, x3

    #Address 0xa11 read value
    csrr x14, 0xa11

    #Unmapped address 0xda testing: random write/read operations
    #Address 0xda read value
    csrr x14, 0xda

    #Address 0xda read value
    csrr x14, 0xda

    #Address 0xda Write value 0x2ab4da6d
    li x3, 0x2ab4da6d
    csrw 0xda, x3

    #Unmapped address 0xbbc testing: random write/read operations
    #Address 0xbbc Write value 0xf65eed28
    li x3, 0xf65eed28
    csrw 0xbbc, x3

    #Address 0xbbc Write value 0x5b89fc34
    li x3, 0x5b89fc34
    csrw 0xbbc, x3

    #Address 0xbbc read value
    csrr x14, 0xbbc

    #Address 0xbbc read value
    csrr x14, 0xbbc

    #Unmapped address 0xad6 testing: random write/read operations
    #Address 0xad6 read value
    csrr x14, 0xad6

    #Address 0xad6 Write value 0x16c74185
    li x3, 0x16c74185
    csrw 0xad6, x3

    #Address 0xad6 Write value 0x39da38ae
    li x3, 0x39da38ae
    csrw 0xad6, x3

    #Address 0xad6 read value
    csrr x14, 0xad6

    #Unmapped address 0xa89 testing: random write/read operations
    #Address 0xa89 Write value 0x1834bf9d
    li x3, 0x1834bf9d
    csrw 0xa89, x3

    #Address 0xa89 read value
    csrr x14, 0xa89

    #Unmapped address 0xfe6 testing: random write/read operations
    #Address 0xfe6 read value
    csrr x14, 0xfe6

    #Address 0xfe6 read value
    csrr x14, 0xfe6

    #Address 0xfe6 read value
    csrr x14, 0xfe6

    #Address 0xfe6 read value
    csrr x14, 0xfe6

    #Unmapped address 0xe8e testing: random write/read operations
    #Address 0xe8e Write value 0xd6a2b40b
    li x3, 0xd6a2b40b
    csrw 0xe8e, x3

    #Address 0xe8e Write value 0xd5fa722c
    li x3, 0xd5fa722c
    csrw 0xe8e, x3

    #Address 0xe8e Write value 0x5fbe3819
    li x3, 0x5fbe3819
    csrw 0xe8e, x3

    #Address 0xe8e read value
    csrr x14, 0xe8e

    #Unmapped address 0xb2b testing: random write/read operations
    #Address 0xb2b read value
    csrr x14, 0xb2b

    #Unmapped address 0x2b6 testing: random write/read operations
    #Address 0x2b6 Write value 0xc43ff9ca
    li x3, 0xc43ff9ca
    csrw 0x2b6, x3

    #Unmapped address 0xa7d testing: random write/read operations
    #Address 0xa7d Write value 0xd41eecb9
    li x3, 0xd41eecb9
    csrw 0xa7d, x3

    #Address 0xa7d Write value 0x499548d5
    li x3, 0x499548d5
    csrw 0xa7d, x3

    #Address 0xa7d read value
    csrr x14, 0xa7d

    #Unmapped address 0xc53 testing: random write/read operations
    #Address 0xc53 read value
    csrr x14, 0xc53

    #Address 0xc53 read value
    csrr x14, 0xc53

    #Address 0xc53 read value
    csrr x14, 0xc53

    #Unmapped address 0x2d8 testing: random write/read operations
    #Address 0x2d8 read value
    csrr x14, 0x2d8

    #Address 0x2d8 read value
    csrr x14, 0x2d8

    #Address 0x2d8 read value
    csrr x14, 0x2d8

    #Address 0x2d8 read value
    csrr x14, 0x2d8

    #Unmapped address 0x244 testing: random write/read operations
    #Address 0x244 read value
    csrr x14, 0x244

    #Address 0x244 read value
    csrr x14, 0x244

    #Address 0x244 read value
    csrr x14, 0x244

    #Unmapped address 0xf59 testing: random write/read operations
    #Address 0xf59 read value
    csrr x14, 0xf59

    #Address 0xf59 Write value 0x277f468c
    li x3, 0x277f468c
    csrw 0xf59, x3

    #Address 0xf59 read value
    csrr x14, 0xf59

    #Address 0xf59 read value
    csrr x14, 0xf59

    #Unmapped address 0xe19 testing: random write/read operations
    #Address 0xe19 Write value 0x7167d5ca
    li x3, 0x7167d5ca
    csrw 0xe19, x3

    #Address 0xe19 read value
    csrr x14, 0xe19

    #Address 0xe19 Write value 0x1e98270e
    li x3, 0x1e98270e
    csrw 0xe19, x3

    #Address 0xe19 Write value 0x6695f786
    li x3, 0x6695f786
    csrw 0xe19, x3

    #Address 0xe19 Write value 0x86ccf9b0
    li x3, 0x86ccf9b0
    csrw 0xe19, x3

    #Unmapped address 0x80d testing: random write/read operations
    #Address 0x80d read value
    csrr x14, 0x80d

    #Address 0x80d Write value 0xd0ce6d15
    li x3, 0xd0ce6d15
    csrw 0x80d, x3

    #Address 0x80d Write value 0xea94eb0f
    li x3, 0xea94eb0f
    csrw 0x80d, x3

    #Address 0x80d read value
    csrr x14, 0x80d

    #Address 0x80d read value
    csrr x14, 0x80d

    #Unmapped address 0xdbf testing: random write/read operations
    #Address 0xdbf Write value 0xfc8a4cf0
    li x3, 0xfc8a4cf0
    csrw 0xdbf, x3

    #Address 0xdbf read value
    csrr x14, 0xdbf

    #Mapped address 0x32d (mhpmevent13) testing: random write/read operations
    #Address 0x32d Write value 0x34f00f76
    li x3, 0x34f00f76
    csrw 0x32d, x3

    #Address 0x32d Write value 0xb328b888
    li x3, 0xb328b888
    csrw 0x32d, x3

    #Address 0x32d Write value 0x63acef4e
    li x3, 0x63acef4e
    csrw 0x32d, x3

    #Address 0x32d Write value 0xa4591dfd
    li x3, 0xa4591dfd
    csrw 0x32d, x3

    #Unmapped address 0x2da testing: random write/read operations
    #Address 0x2da read value
    csrr x14, 0x2da

    #Address 0x2da read value
    csrr x14, 0x2da

    #Address 0x2da Write value 0xff60c3ba
    li x3, 0xff60c3ba
    csrw 0x2da, x3

    #Unmapped address 0x41b testing: random write/read operations
    #Address 0x41b read value
    csrr x14, 0x41b

    #Address 0x41b read value
    csrr x14, 0x41b

    #Address 0x41b read value
    csrr x14, 0x41b

    #Address 0x41b Write value 0xc57f3de7
    li x3, 0xc57f3de7
    csrw 0x41b, x3

    #Address 0x41b read value
    csrr x14, 0x41b

    #Unmapped address 0xc28 testing: random write/read operations
    #Address 0xc28 read value
    csrr x14, 0xc28

    #Address 0xc28 Write value 0x54ba6153
    li x3, 0x54ba6153
    csrw 0xc28, x3

    #Address 0xc28 read value
    csrr x14, 0xc28

    #Unmapped address 0x674 testing: random write/read operations
    #Address 0x674 Write value 0x7d5aa9ea
    li x3, 0x7d5aa9ea
    csrw 0x674, x3

    #Address 0x674 read value
    csrr x14, 0x674

    #Address 0x674 read value
    csrr x14, 0x674

    #Address 0x674 Write value 0xc3d02308
    li x3, 0xc3d02308
    csrw 0x674, x3

    #Unmapped address 0x2a testing: random write/read operations
    #Address 0x2a read value
    csrr x14, 0x2a

    #Address 0x2a read value
    csrr x14, 0x2a

    #Address 0x2a Write value 0x3a855477
    li x3, 0x3a855477
    csrw 0x2a, x3

    #Unmapped address 0xf29 testing: random write/read operations
    #Address 0xf29 Write value 0xde6b53bf
    li x3, 0xde6b53bf
    csrw 0xf29, x3

    #Address 0xf29 read value
    csrr x14, 0xf29

    #Address 0xf29 read value
    csrr x14, 0xf29

    #Address 0xf29 read value
    csrr x14, 0xf29

    #Address 0xf29 Write value 0x9c07829a
    li x3, 0x9c07829a
    csrw 0xf29, x3

    #Unmapped address 0x390 testing: random write/read operations
    #Address 0x390 read value
    csrr x14, 0x390

    #Address 0x390 Write value 0x2e85a15d
    li x3, 0x2e85a15d
    csrw 0x390, x3

    #Address 0x390 Write value 0x6b179ec9
    li x3, 0x6b179ec9
    csrw 0x390, x3

    #Unmapped address 0xbff testing: random write/read operations
    #Address 0xbff read value
    csrr x14, 0xbff

    #Address 0xbff Write value 0x34ef7971
    li x3, 0x34ef7971
    csrw 0xbff, x3

    #Address 0xbff read value
    csrr x14, 0xbff

    #Address 0xbff read value
    csrr x14, 0xbff

    #Unmapped address 0xa40 testing: random write/read operations
    #Address 0xa40 read value
    csrr x14, 0xa40

    #Address 0xa40 read value
    csrr x14, 0xa40

    #Address 0xa40 read value
    csrr x14, 0xa40

    #Address 0xa40 Write value 0x84cce89a
    li x3, 0x84cce89a
    csrw 0xa40, x3

    #Unmapped address 0x591 testing: random write/read operations
    #Address 0x591 read value
    csrr x14, 0x591

    #Address 0x591 Write value 0xac1d92ad
    li x3, 0xac1d92ad
    csrw 0x591, x3

    #Address 0x591 Write value 0xdeaf6688
    li x3, 0xdeaf6688
    csrw 0x591, x3

    #Address 0x591 read value
    csrr x14, 0x591

    #Unmapped address 0x775 testing: random write/read operations
    #Address 0x775 read value
    csrr x14, 0x775

    #Address 0x775 Write value 0x1dfa8450
    li x3, 0x1dfa8450
    csrw 0x775, x3

    #Address 0x775 read value
    csrr x14, 0x775

    #Unmapped address 0x193 testing: random write/read operations
    #Address 0x193 Write value 0x8d33eec8
    li x3, 0x8d33eec8
    csrw 0x193, x3

    #Address 0x193 read value
    csrr x14, 0x193

    #Address 0x193 Write value 0xe9a99ceb
    li x3, 0xe9a99ceb
    csrw 0x193, x3

    #Address 0x193 Write value 0x6f467602
    li x3, 0x6f467602
    csrw 0x193, x3

    #Address 0x193 read value
    csrr x14, 0x193

    #Unmapped address 0xc3e testing: random write/read operations
    #Address 0xc3e read value
    csrr x14, 0xc3e

    #Address 0xc3e read value
    csrr x14, 0xc3e

    #Address 0xc3e read value
    csrr x14, 0xc3e

    #Unmapped address 0x8eb testing: random write/read operations
    #Address 0x8eb Write value 0xf76413fb
    li x3, 0xf76413fb
    csrw 0x8eb, x3

    #Address 0x8eb read value
    csrr x14, 0x8eb

    #Address 0x8eb Write value 0x12393845
    li x3, 0x12393845
    csrw 0x8eb, x3

    #Address 0x8eb Write value 0xb0b9932f
    li x3, 0xb0b9932f
    csrw 0x8eb, x3

    #Unmapped address 0xd58 testing: random write/read operations
    #Address 0xd58 Write value 0x4900a2be
    li x3, 0x4900a2be
    csrw 0xd58, x3

    #Address 0xd58 read value
    csrr x14, 0xd58

    #Unmapped address 0x941 testing: random write/read operations
    #Address 0x941 Write value 0x5f6e8e41
    li x3, 0x5f6e8e41
    csrw 0x941, x3

    #Unmapped address 0xe98 testing: random write/read operations
    #Address 0xe98 read value
    csrr x14, 0xe98

    #Address 0xe98 read value
    csrr x14, 0xe98

    #Address 0xe98 read value
    csrr x14, 0xe98

    #Address 0xe98 read value
    csrr x14, 0xe98

    #Address 0xe98 read value
    csrr x14, 0xe98

    #Unmapped address 0xbd0 testing: random write/read operations
    #Address 0xbd0 read value
    csrr x14, 0xbd0

    #Address 0xbd0 Write value 0x8357c0d6
    li x3, 0x8357c0d6
    csrw 0xbd0, x3

    #Address 0xbd0 Write value 0x9f8f132c
    li x3, 0x9f8f132c
    csrw 0xbd0, x3

    #Mapped address 0x3b3 (pmpaddr3) testing: random write/read operations
    #Address 0x3b3 Write value 0xea078d6
    li x3, 0xea078d6
    csrw 0x3b3, x3

    #Address 0x3b3 Write value 0x2ab01e1b
    li x3, 0x2ab01e1b
    csrw 0x3b3, x3

    #Unmapped address 0xb78 testing: random write/read operations
    #Address 0xb78 Write value 0x9899ecdc
    li x3, 0x9899ecdc
    csrw 0xb78, x3

    #Address 0xb78 read value
    csrr x14, 0xb78

    #Unmapped address 0x2db testing: random write/read operations
    #Address 0x2db Write value 0x93746301
    li x3, 0x93746301
    csrw 0x2db, x3

    #Address 0x2db Write value 0x3ed2f39
    li x3, 0x3ed2f39
    csrw 0x2db, x3

    #Address 0x2db read value
    csrr x14, 0x2db

    #Address 0x2db read value
    csrr x14, 0x2db

    #Address 0x2db Write value 0x2bb93b45
    li x3, 0x2bb93b45
    csrw 0x2db, x3

    #Unmapped address 0xe25 testing: random write/read operations
    #Address 0xe25 read value
    csrr x14, 0xe25

    #Address 0xe25 Write value 0x5c7cecd7
    li x3, 0x5c7cecd7
    csrw 0xe25, x3

    #Unmapped address 0x70f testing: random write/read operations
    #Address 0x70f Write value 0x3ecf755e
    li x3, 0x3ecf755e
    csrw 0x70f, x3

    #Address 0x70f read value
    csrr x14, 0x70f

    #Unmapped address 0x48a testing: random write/read operations
    #Address 0x48a Write value 0x822878d6
    li x3, 0x822878d6
    csrw 0x48a, x3

    #Address 0x48a read value
    csrr x14, 0x48a

    #Address 0x48a Write value 0x964b9529
    li x3, 0x964b9529
    csrw 0x48a, x3

    #Unmapped address 0x94b testing: random write/read operations
    #Address 0x94b Write value 0x50b1e747
    li x3, 0x50b1e747
    csrw 0x94b, x3

    #Address 0x94b read value
    csrr x14, 0x94b

    #Address 0x94b Write value 0x82a84a65
    li x3, 0x82a84a65
    csrw 0x94b, x3

    #Unmapped address 0xbcc testing: random write/read operations
    #Address 0xbcc read value
    csrr x14, 0xbcc

    #Address 0xbcc Write value 0xfb296e0c
    li x3, 0xfb296e0c
    csrw 0xbcc, x3

    #Unmapped address 0xd50 testing: random write/read operations
    #Address 0xd50 Write value 0xfc56d767
    li x3, 0xfc56d767
    csrw 0xd50, x3

    #Address 0xd50 Write value 0xea2e1704
    li x3, 0xea2e1704
    csrw 0xd50, x3

    #Address 0xd50 Write value 0xf8bf6729
    li x3, 0xf8bf6729
    csrw 0xd50, x3

    #Address 0xd50 Write value 0xd680b1c8
    li x3, 0xd680b1c8
    csrw 0xd50, x3

    #Unmapped address 0x6bb testing: random write/read operations
    #Address 0x6bb read value
    csrr x14, 0x6bb

    #Unmapped address 0x1c4 testing: random write/read operations
    #Address 0x1c4 Write value 0x11dfec3f
    li x3, 0x11dfec3f
    csrw 0x1c4, x3

    #Address 0x1c4 read value
    csrr x14, 0x1c4

    #Unmapped address 0x693 testing: random write/read operations
    #Address 0x693 read value
    csrr x14, 0x693

    #Address 0x693 read value
    csrr x14, 0x693

    #Address 0x693 read value
    csrr x14, 0x693

    #Unmapped address 0x20e testing: random write/read operations
    #Address 0x20e Write value 0x8ec34669
    li x3, 0x8ec34669
    csrw 0x20e, x3

    #Address 0x20e Write value 0x4d1b148f
    li x3, 0x4d1b148f
    csrw 0x20e, x3

    #Address 0x20e read value
    csrr x14, 0x20e

    #Address 0x20e Write value 0xa948dad8
    li x3, 0xa948dad8
    csrw 0x20e, x3

    #Address 0x20e read value
    csrr x14, 0x20e

    #Unmapped address 0xfbe testing: random write/read operations
    #Address 0xfbe Write value 0xc3297000
    li x3, 0xc3297000
    csrw 0xfbe, x3

    #Address 0xfbe read value
    csrr x14, 0xfbe

    #Unmapped address 0x5af testing: random write/read operations
    #Address 0x5af Write value 0x41962c3d
    li x3, 0x41962c3d
    csrw 0x5af, x3

    #Unmapped address 0x64b testing: random write/read operations
    #Address 0x64b read value
    csrr x14, 0x64b

    #Address 0x64b Write value 0x2d27bf59
    li x3, 0x2d27bf59
    csrw 0x64b, x3

    #Unmapped address 0xe32 testing: random write/read operations
    #Address 0xe32 read value
    csrr x14, 0xe32

    #Address 0xe32 Write value 0xb38df247
    li x3, 0xb38df247
    csrw 0xe32, x3

    #Address 0xe32 read value
    csrr x14, 0xe32

    #Address 0xe32 Write value 0x21bcb4af
    li x3, 0x21bcb4af
    csrw 0xe32, x3

    #Address 0xe32 Write value 0x615c9c35
    li x3, 0x615c9c35
    csrw 0xe32, x3

    #Unmapped address 0xff0 testing: random write/read operations
    #Address 0xff0 Write value 0x6300a59c
    li x3, 0x6300a59c
    csrw 0xff0, x3

    #Unmapped address 0x814 testing: random write/read operations
    #Address 0x814 read value
    csrr x14, 0x814

    #Unmapped address 0x9e4 testing: random write/read operations
    #Address 0x9e4 read value
    csrr x14, 0x9e4

    #Unmapped address 0x1a3 testing: random write/read operations
    #Address 0x1a3 Write value 0x9b81d924
    li x3, 0x9b81d924
    csrw 0x1a3, x3

    #Address 0x1a3 Write value 0x902601ff
    li x3, 0x902601ff
    csrw 0x1a3, x3

    #Address 0x1a3 read value
    csrr x14, 0x1a3

    #Address 0x1a3 Write value 0xcfe2798
    li x3, 0xcfe2798
    csrw 0x1a3, x3

    #Unmapped address 0xf19 testing: random write/read operations
    #Address 0xf19 Write value 0x1bf2cd37
    li x3, 0x1bf2cd37
    csrw 0xf19, x3

    #Address 0xf19 Write value 0x33779404
    li x3, 0x33779404
    csrw 0xf19, x3

    #Address 0xf19 read value
    csrr x14, 0xf19

    #Address 0xf19 Write value 0xb74d8eb6
    li x3, 0xb74d8eb6
    csrw 0xf19, x3

    #Address 0xf19 Write value 0xd330aa7c
    li x3, 0xd330aa7c
    csrw 0xf19, x3

    #Unmapped address 0xbed testing: random write/read operations
    #Address 0xbed read value
    csrr x14, 0xbed

    #Address 0xbed read value
    csrr x14, 0xbed

    #Unmapped address 0x82a testing: random write/read operations
    #Address 0x82a read value
    csrr x14, 0x82a

    #Unmapped address 0xd72 testing: random write/read operations
    #Address 0xd72 read value
    csrr x14, 0xd72

    #Address 0xd72 read value
    csrr x14, 0xd72

    #Unmapped address 0x96c testing: random write/read operations
    #Address 0x96c read value
    csrr x14, 0x96c

    #Address 0x96c Write value 0x53851dd
    li x3, 0x53851dd
    csrw 0x96c, x3

    #Address 0x96c Write value 0x7cff7e6
    li x3, 0x7cff7e6
    csrw 0x96c, x3

    #Address 0x96c read value
    csrr x14, 0x96c

    #Unmapped address 0x2ed testing: random write/read operations
    #Address 0x2ed read value
    csrr x14, 0x2ed

    #Unmapped address 0x1ec testing: random write/read operations
    #Address 0x1ec Write value 0x22421682
    li x3, 0x22421682
    csrw 0x1ec, x3

    #Unmapped address 0x8a2 testing: random write/read operations
    #Address 0x8a2 Write value 0xed158624
    li x3, 0xed158624
    csrw 0x8a2, x3

    #Address 0x8a2 Write value 0x1b508bb9
    li x3, 0x1b508bb9
    csrw 0x8a2, x3

    #Unmapped address 0x9fe testing: random write/read operations
    #Address 0x9fe read value
    csrr x14, 0x9fe

    #Address 0x9fe Write value 0x61e4bb26
    li x3, 0x61e4bb26
    csrw 0x9fe, x3

    #Address 0x9fe Write value 0x7befc25f
    li x3, 0x7befc25f
    csrw 0x9fe, x3

    #Unmapped address 0x20a testing: random write/read operations
    #Address 0x20a read value
    csrr x14, 0x20a

    #Address 0x20a read value
    csrr x14, 0x20a

    #Unmapped address 0x77 testing: random write/read operations
    #Address 0x77 Write value 0xb5e8d5cc
    li x3, 0xb5e8d5cc
    csrw 0x77, x3

    #Address 0x77 Write value 0xebd801d0
    li x3, 0xebd801d0
    csrw 0x77, x3

    #Address 0x77 Write value 0x9d6e8403
    li x3, 0x9d6e8403
    csrw 0x77, x3

    #Unmapped address 0x1d2 testing: random write/read operations
    #Address 0x1d2 read value
    csrr x14, 0x1d2

    #Address 0x1d2 Write value 0x7854034
    li x3, 0x7854034
    csrw 0x1d2, x3

    #Address 0x1d2 Write value 0xcf7f06af
    li x3, 0xcf7f06af
    csrw 0x1d2, x3

    #Address 0x1d2 read value
    csrr x14, 0x1d2

    #Unmapped address 0xf9e testing: random write/read operations
    #Address 0xf9e read value
    csrr x14, 0xf9e

    #Unmapped address 0x47e testing: random write/read operations
    #Address 0x47e Write value 0x3b7ff146
    li x3, 0x3b7ff146
    csrw 0x47e, x3

    #Unmapped address 0x807 testing: random write/read operations
    #Address 0x807 read value
    csrr x14, 0x807

    #Address 0x807 Write value 0x93cb875f
    li x3, 0x93cb875f
    csrw 0x807, x3

    #Address 0x807 read value
    csrr x14, 0x807

    #Address 0x807 read value
    csrr x14, 0x807

    #Address 0x807 read value
    csrr x14, 0x807

    #Unmapped address 0x5a0 testing: random write/read operations
    #Address 0x5a0 Write value 0x2a1237cd
    li x3, 0x2a1237cd
    csrw 0x5a0, x3

    #Address 0x5a0 Write value 0x48349d1b
    li x3, 0x48349d1b
    csrw 0x5a0, x3

    #Address 0x5a0 Write value 0x1908efc3
    li x3, 0x1908efc3
    csrw 0x5a0, x3

    #Unmapped address 0xa7 testing: random write/read operations
    #Address 0xa7 read value
    csrr x14, 0xa7

    #Unmapped address 0x597 testing: random write/read operations
    #Address 0x597 read value
    csrr x14, 0x597

    #Unmapped address 0x8d2 testing: random write/read operations
    #Address 0x8d2 read value
    csrr x14, 0x8d2

    #Address 0x8d2 read value
    csrr x14, 0x8d2

    #Address 0x8d2 Write value 0xc7947393
    li x3, 0xc7947393
    csrw 0x8d2, x3

    #Address 0x8d2 read value
    csrr x14, 0x8d2

    #Address 0x8d2 read value
    csrr x14, 0x8d2

    #Unmapped address 0x2cc testing: random write/read operations
    #Address 0x2cc read value
    csrr x14, 0x2cc

    #Address 0x2cc Write value 0x600f938e
    li x3, 0x600f938e
    csrw 0x2cc, x3

    #Address 0x2cc read value
    csrr x14, 0x2cc

    #Address 0x2cc Write value 0x321c686e
    li x3, 0x321c686e
    csrw 0x2cc, x3

    #Address 0x2cc Write value 0x6ef9799f
    li x3, 0x6ef9799f
    csrw 0x2cc, x3

    #Unmapped address 0xd8c testing: random write/read operations
    #Address 0xd8c read value
    csrr x14, 0xd8c

    #Address 0xd8c read value
    csrr x14, 0xd8c

    #Address 0xd8c read value
    csrr x14, 0xd8c

    #Address 0xd8c read value
    csrr x14, 0xd8c

    #Address 0xd8c Write value 0xb8fdd86c
    li x3, 0xb8fdd86c
    csrw 0xd8c, x3

    #Mapped address 0x3b5 (pmpaddr5) testing: random write/read operations
    #Address 0x3b5 Write value 0x61a3351c
    li x3, 0x61a3351c
    csrw 0x3b5, x3

    #Unmapped address 0x94 testing: random write/read operations
    #Address 0x94 Write value 0xe696a883
    li x3, 0xe696a883
    csrw 0x94, x3

    #Unmapped address 0x168 testing: random write/read operations
    #Address 0x168 read value
    csrr x14, 0x168

    #Address 0x168 read value
    csrr x14, 0x168

    #Address 0x168 Write value 0xe6c251ac
    li x3, 0xe6c251ac
    csrw 0x168, x3

    #Address 0x168 Write value 0xa268503b
    li x3, 0xa268503b
    csrw 0x168, x3

    #Unmapped address 0xb3a testing: random write/read operations
    #Address 0xb3a read value
    csrr x14, 0xb3a

    #Address 0xb3a Write value 0x39a2fed5
    li x3, 0x39a2fed5
    csrw 0xb3a, x3

    #Address 0xb3a read value
    csrr x14, 0xb3a

    #Unmapped address 0xf54 testing: random write/read operations
    #Address 0xf54 read value
    csrr x14, 0xf54

    #Address 0xf54 read value
    csrr x14, 0xf54

    #Address 0xf54 Write value 0x331256c5
    li x3, 0x331256c5
    csrw 0xf54, x3

    #Address 0xf54 read value
    csrr x14, 0xf54

    #Address 0xf54 read value
    csrr x14, 0xf54

    #Unmapped address 0x6d2 testing: random write/read operations
    #Address 0x6d2 read value
    csrr x14, 0x6d2

    #Address 0x6d2 read value
    csrr x14, 0x6d2

    #Address 0x6d2 Write value 0xf59cfccc
    li x3, 0xf59cfccc
    csrw 0x6d2, x3

    #Address 0x6d2 read value
    csrr x14, 0x6d2

    #Unmapped address 0x720 testing: random write/read operations
    #Address 0x720 read value
    csrr x14, 0x720

    #Unmapped address 0xf9b testing: random write/read operations
    #Address 0xf9b read value
    csrr x14, 0xf9b

    #Address 0xf9b Write value 0x952fa954
    li x3, 0x952fa954
    csrw 0xf9b, x3

    #Unmapped address 0xcb9 testing: random write/read operations
    #Address 0xcb9 read value
    csrr x14, 0xcb9

    #Address 0xcb9 read value
    csrr x14, 0xcb9

    #Address 0xcb9 Write value 0x505e5854
    li x3, 0x505e5854
    csrw 0xcb9, x3

    #Unmapped address 0x12e testing: random write/read operations
    #Address 0x12e read value
    csrr x14, 0x12e

    #Address 0x12e read value
    csrr x14, 0x12e

    #Address 0x12e read value
    csrr x14, 0x12e

    #Unmapped address 0x9be testing: random write/read operations
    #Address 0x9be read value
    csrr x14, 0x9be

    #Address 0x9be Write value 0x1eb8d7a6
    li x3, 0x1eb8d7a6
    csrw 0x9be, x3

    #Address 0x9be Write value 0x139a652c
    li x3, 0x139a652c
    csrw 0x9be, x3

    #Address 0x9be read value
    csrr x14, 0x9be

    #Address 0x9be Write value 0xf47ba572
    li x3, 0xf47ba572
    csrw 0x9be, x3

    #Unmapped address 0xb2a testing: random write/read operations
    #Address 0xb2a read value
    csrr x14, 0xb2a

    #Address 0xb2a read value
    csrr x14, 0xb2a

    #Address 0xb2a read value
    csrr x14, 0xb2a

    #Unmapped address 0xf61 testing: random write/read operations
    #Address 0xf61 read value
    csrr x14, 0xf61

    #Address 0xf61 read value
    csrr x14, 0xf61

    #Address 0xf61 Write value 0xb70921b8
    li x3, 0xb70921b8
    csrw 0xf61, x3

    #Unmapped address 0x8fa testing: random write/read operations
    #Address 0x8fa read value
    csrr x14, 0x8fa

    #Address 0x8fa Write value 0x8c9fd115
    li x3, 0x8c9fd115
    csrw 0x8fa, x3

    #Address 0x8fa Write value 0xd47bf652
    li x3, 0xd47bf652
    csrw 0x8fa, x3

    #Unmapped address 0xefd testing: random write/read operations
    #Address 0xefd Write value 0x1e90f162
    li x3, 0x1e90f162
    csrw 0xefd, x3

    #Address 0xefd read value
    csrr x14, 0xefd

    #Address 0xefd Write value 0xe684081c
    li x3, 0xe684081c
    csrw 0xefd, x3

    #Address 0xefd Write value 0x7504d71b
    li x3, 0x7504d71b
    csrw 0xefd, x3

    #Address 0xefd Write value 0xaee6cc70
    li x3, 0xaee6cc70
    csrw 0xefd, x3

    #Unmapped address 0xf94 testing: random write/read operations
    #Address 0xf94 read value
    csrr x14, 0xf94

    #Address 0xf94 read value
    csrr x14, 0xf94

    #Address 0xf94 read value
    csrr x14, 0xf94

    #Address 0xf94 read value
    csrr x14, 0xf94

    #Address 0xf94 Write value 0x629dd0f8
    li x3, 0x629dd0f8
    csrw 0xf94, x3

    #Unmapped address 0x7be testing: random write/read operations
    #Address 0x7be Write value 0x357b0e4c
    li x3, 0x357b0e4c
    csrw 0x7be, x3

    #Address 0x7be read value
    csrr x14, 0x7be

    #Unmapped address 0x4c1 testing: random write/read operations
    #Address 0x4c1 Write value 0x7e535183
    li x3, 0x7e535183
    csrw 0x4c1, x3

    #Address 0x4c1 Write value 0xd9790d94
    li x3, 0xd9790d94
    csrw 0x4c1, x3

    #Address 0x4c1 Write value 0x5d60a777
    li x3, 0x5d60a777
    csrw 0x4c1, x3

    #Unmapped address 0x745 testing: random write/read operations
    #Address 0x745 read value
    csrr x14, 0x745

    #Address 0x745 Write value 0x9fc1d515
    li x3, 0x9fc1d515
    csrw 0x745, x3

    #Unmapped address 0x50b testing: random write/read operations
    #Address 0x50b read value
    csrr x14, 0x50b

    #Address 0x50b read value
    csrr x14, 0x50b

    #Unmapped address 0x139 testing: random write/read operations
    #Address 0x139 Write value 0x2d9581cf
    li x3, 0x2d9581cf
    csrw 0x139, x3

    #Address 0x139 Write value 0x1351024c
    li x3, 0x1351024c
    csrw 0x139, x3

    #Address 0x139 Write value 0x3c48913a
    li x3, 0x3c48913a
    csrw 0x139, x3

    #Address 0x139 read value
    csrr x14, 0x139

    #Mapped address 0xb8b (mhpmcounterh11) testing: random write/read operations
    #Address 0xb8b read value
    csrr x14, 0xb8b

    #Unmapped address 0x31c testing: random write/read operations
    #Address 0x31c Write value 0x29e59fd4
    li x3, 0x29e59fd4
    csrw 0x31c, x3

    #Address 0x31c read value
    csrr x14, 0x31c

    #Unmapped address 0x461 testing: random write/read operations
    #Address 0x461 read value
    csrr x14, 0x461

    #Unmapped address 0x7f6 testing: random write/read operations
    #Address 0x7f6 Write value 0xb290c9a6
    li x3, 0xb290c9a6
    csrw 0x7f6, x3

    #Address 0x7f6 read value
    csrr x14, 0x7f6

    #Address 0x7f6 read value
    csrr x14, 0x7f6

    #Address 0x7f6 Write value 0x99d2b50e
    li x3, 0x99d2b50e
    csrw 0x7f6, x3

    #Mapped address 0xb85 (mhpmcounterh5) testing: random write/read operations
    #Address 0xb85 read value
    csrr x14, 0xb85

    #Unmapped address 0x6aa testing: random write/read operations
    #Address 0x6aa Write value 0x4f2ed6ab
    li x3, 0x4f2ed6ab
    csrw 0x6aa, x3

    #Address 0x6aa read value
    csrr x14, 0x6aa

    #Unmapped address 0xb23 testing: random write/read operations
    #Address 0xb23 Write value 0xa70c9b1b
    li x3, 0xa70c9b1b
    csrw 0xb23, x3

    #Address 0xb23 Write value 0x39bfaf67
    li x3, 0x39bfaf67
    csrw 0xb23, x3

    #Unmapped address 0xb7f testing: random write/read operations
    #Address 0xb7f read value
    csrr x14, 0xb7f

    #Address 0xb7f read value
    csrr x14, 0xb7f

    #Address 0xb7f Write value 0xc97104ae
    li x3, 0xc97104ae
    csrw 0xb7f, x3

    #Unmapped address 0xf5b testing: random write/read operations
    #Address 0xf5b read value
    csrr x14, 0xf5b

    #Address 0xf5b Write value 0xd9e1b648
    li x3, 0xd9e1b648
    csrw 0xf5b, x3

    #Address 0xf5b Write value 0x24b50a8f
    li x3, 0x24b50a8f
    csrw 0xf5b, x3

    #Address 0xf5b read value
    csrr x14, 0xf5b

    #Address 0xf5b Write value 0xb535aa18
    li x3, 0xb535aa18
    csrw 0xf5b, x3

    #Unmapped address 0x353 testing: random write/read operations
    #Address 0x353 read value
    csrr x14, 0x353

    #Address 0x353 read value
    csrr x14, 0x353

    #Address 0x353 Write value 0x72962dc4
    li x3, 0x72962dc4
    csrw 0x353, x3

    #Address 0x353 Write value 0x28ef03df
    li x3, 0x28ef03df
    csrw 0x353, x3

    #Address 0x353 Write value 0x44f9c7f8
    li x3, 0x44f9c7f8
    csrw 0x353, x3

    #Unmapped address 0x348 testing: random write/read operations
    #Address 0x348 read value
    csrr x14, 0x348

    #Unmapped address 0x5ed testing: random write/read operations
    #Address 0x5ed Write value 0x2e45e06c
    li x3, 0x2e45e06c
    csrw 0x5ed, x3

    #Address 0x5ed read value
    csrr x14, 0x5ed

    #Address 0x5ed read value
    csrr x14, 0x5ed

    #Address 0x5ed read value
    csrr x14, 0x5ed

    #Unmapped address 0x3a7 testing: random write/read operations
    #Address 0x3a7 read value
    csrr x14, 0x3a7

    #Address 0x3a7 read value
    csrr x14, 0x3a7

    #Address 0x3a7 read value
    csrr x14, 0x3a7

    #Address 0x3a7 Write value 0xa5bd9ad3
    li x3, 0xa5bd9ad3
    csrw 0x3a7, x3

    #Unmapped address 0xf47 testing: random write/read operations
    #Address 0xf47 Write value 0x19701095
    li x3, 0x19701095
    csrw 0xf47, x3

    #Address 0xf47 read value
    csrr x14, 0xf47

    #Address 0xf47 read value
    csrr x14, 0xf47

    #Unmapped address 0xf5c testing: random write/read operations
    #Address 0xf5c Write value 0x36653c9a
    li x3, 0x36653c9a
    csrw 0xf5c, x3

    #Address 0xf5c Write value 0xea027251
    li x3, 0xea027251
    csrw 0xf5c, x3

    #Address 0xf5c Write value 0xa52e5b6d
    li x3, 0xa52e5b6d
    csrw 0xf5c, x3

    #Address 0xf5c Write value 0xeec1ffa7
    li x3, 0xeec1ffa7
    csrw 0xf5c, x3

    #Unmapped address 0xc11 testing: random write/read operations
    #Address 0xc11 Write value 0x4aabb7e9
    li x3, 0x4aabb7e9
    csrw 0xc11, x3

    #Unmapped address 0x5b9 testing: random write/read operations
    #Address 0x5b9 Write value 0xe22f1742
    li x3, 0xe22f1742
    csrw 0x5b9, x3

    #Unmapped address 0xdff testing: random write/read operations
    #Address 0xdff read value
    csrr x14, 0xdff

    #Address 0xdff read value
    csrr x14, 0xdff

    #Address 0xdff read value
    csrr x14, 0xdff

    #Address 0xdff read value
    csrr x14, 0xdff

    #Unmapped address 0xa10 testing: random write/read operations
    #Address 0xa10 read value
    csrr x14, 0xa10

    #Address 0xa10 Write value 0xbdb5eb34
    li x3, 0xbdb5eb34
    csrw 0xa10, x3

    #Address 0xa10 Write value 0x85924cc2
    li x3, 0x85924cc2
    csrw 0xa10, x3

    #Address 0xa10 Write value 0x83968eb9
    li x3, 0x83968eb9
    csrw 0xa10, x3

    #Address 0xa10 Write value 0x701d26b0
    li x3, 0x701d26b0
    csrw 0xa10, x3

    #Unmapped address 0xeee testing: random write/read operations
    #Address 0xeee Write value 0x39643ea6
    li x3, 0x39643ea6
    csrw 0xeee, x3

    #Address 0xeee read value
    csrr x14, 0xeee

    #Address 0xeee read value
    csrr x14, 0xeee

    #Address 0xeee read value
    csrr x14, 0xeee

    #Address 0xeee Write value 0xf53abe39
    li x3, 0xf53abe39
    csrw 0xeee, x3

    #Unmapped address 0xa00 testing: random write/read operations
    #Address 0xa00 Write value 0xb9f09549
    li x3, 0xb9f09549
    csrw 0xa00, x3

    #Address 0xa00 Write value 0x8113158c
    li x3, 0x8113158c
    csrw 0xa00, x3

    #Address 0xa00 read value
    csrr x14, 0xa00

    #Unmapped address 0x573 testing: random write/read operations
    #Address 0x573 Write value 0x37e2fa2c
    li x3, 0x37e2fa2c
    csrw 0x573, x3

    #Address 0x573 read value
    csrr x14, 0x573

    #Address 0x573 Write value 0x794d61f9
    li x3, 0x794d61f9
    csrw 0x573, x3

    #Address 0x573 Write value 0x1ad8b295
    li x3, 0x1ad8b295
    csrw 0x573, x3

    #Address 0x573 Write value 0xa14f5b15
    li x3, 0xa14f5b15
    csrw 0x573, x3

    #Unmapped address 0x626 testing: random write/read operations
    #Address 0x626 Write value 0xf7cd0c55
    li x3, 0xf7cd0c55
    csrw 0x626, x3

    #Address 0x626 read value
    csrr x14, 0x626

    #Address 0x626 read value
    csrr x14, 0x626

    #Unmapped address 0x6ac testing: random write/read operations
    #Address 0x6ac Write value 0xb95279ee
    li x3, 0xb95279ee
    csrw 0x6ac, x3

    #Address 0x6ac Write value 0x881cb71e
    li x3, 0x881cb71e
    csrw 0x6ac, x3

    #Address 0x6ac Write value 0xf5ee5b08
    li x3, 0xf5ee5b08
    csrw 0x6ac, x3

    #Address 0x6ac read value
    csrr x14, 0x6ac

    #Address 0x6ac Write value 0xa5c16675
    li x3, 0xa5c16675
    csrw 0x6ac, x3

    #Unmapped address 0xd20 testing: random write/read operations
    #Address 0xd20 Write value 0xad70cbdf
    li x3, 0xad70cbdf
    csrw 0xd20, x3

    #Unmapped address 0x826 testing: random write/read operations
    #Address 0x826 Write value 0x989b2e6b
    li x3, 0x989b2e6b
    csrw 0x826, x3

    #Unmapped address 0x8b5 testing: random write/read operations
    #Address 0x8b5 read value
    csrr x14, 0x8b5

    #Address 0x8b5 Write value 0xa5c68165
    li x3, 0xa5c68165
    csrw 0x8b5, x3

    #Address 0x8b5 read value
    csrr x14, 0x8b5

    #Address 0x8b5 Write value 0xe122fd5f
    li x3, 0xe122fd5f
    csrw 0x8b5, x3

    #Unmapped address 0x6c4 testing: random write/read operations
    #Address 0x6c4 read value
    csrr x14, 0x6c4

    #Address 0x6c4 Write value 0xf1ce48c1
    li x3, 0xf1ce48c1
    csrw 0x6c4, x3

    #Address 0x6c4 Write value 0x3d8b1c96
    li x3, 0x3d8b1c96
    csrw 0x6c4, x3

    #Address 0x6c4 read value
    csrr x14, 0x6c4

    #Unmapped address 0xd87 testing: random write/read operations
    #Address 0xd87 Write value 0x580b57df
    li x3, 0x580b57df
    csrw 0xd87, x3

    #Address 0xd87 Write value 0x3166f92d
    li x3, 0x3166f92d
    csrw 0xd87, x3

    #Unmapped address 0x15d testing: random write/read operations
    #Address 0x15d Write value 0x5a8b1815
    li x3, 0x5a8b1815
    csrw 0x15d, x3

    #Address 0x15d Write value 0x76aaa17
    li x3, 0x76aaa17
    csrw 0x15d, x3

    #Address 0x15d Write value 0x50f4fb1c
    li x3, 0x50f4fb1c
    csrw 0x15d, x3

    #Unmapped address 0x920 testing: random write/read operations
    #Address 0x920 Write value 0xc883b5d8
    li x3, 0xc883b5d8
    csrw 0x920, x3

    #Unmapped address 0xb60 testing: random write/read operations
    #Address 0xb60 Write value 0x692594fa
    li x3, 0x692594fa
    csrw 0xb60, x3

    #Address 0xb60 Write value 0x596b8c03
    li x3, 0x596b8c03
    csrw 0xb60, x3

    #Address 0xb60 Write value 0xcca04871
    li x3, 0xcca04871
    csrw 0xb60, x3

    #Address 0xb60 Write value 0xf4219212
    li x3, 0xf4219212
    csrw 0xb60, x3

    #Address 0xb60 read value
    csrr x14, 0xb60

    #Unmapped address 0xe6 testing: random write/read operations
    #Address 0xe6 read value
    csrr x14, 0xe6

    #Address 0xe6 read value
    csrr x14, 0xe6

    #Address 0xe6 Write value 0xc48d9c32
    li x3, 0xc48d9c32
    csrw 0xe6, x3

    #Address 0xe6 Write value 0xaf58243b
    li x3, 0xaf58243b
    csrw 0xe6, x3

    #Unmapped address 0x7ce testing: random write/read operations
    #Address 0x7ce read value
    csrr x14, 0x7ce

    #Address 0x7ce Write value 0x74b958c6
    li x3, 0x74b958c6
    csrw 0x7ce, x3

    #Address 0x7ce read value
    csrr x14, 0x7ce

    #Address 0x7ce Write value 0xb49ef7fc
    li x3, 0xb49ef7fc
    csrw 0x7ce, x3

    #Address 0x7ce Write value 0xd5fb9e23
    li x3, 0xd5fb9e23
    csrw 0x7ce, x3

    #Unmapped address 0xe9f testing: random write/read operations
    #Address 0xe9f Write value 0x9888f3aa
    li x3, 0x9888f3aa
    csrw 0xe9f, x3

    #Address 0xe9f Write value 0x6e8a4860
    li x3, 0x6e8a4860
    csrw 0xe9f, x3

    #Unmapped address 0x911 testing: random write/read operations
    #Address 0x911 Write value 0xbd0b6401
    li x3, 0xbd0b6401
    csrw 0x911, x3

    #Address 0x911 Write value 0xb3843ca7
    li x3, 0xb3843ca7
    csrw 0x911, x3

    #Address 0x911 Write value 0x9766ddd4
    li x3, 0x9766ddd4
    csrw 0x911, x3

    #Address 0x911 Write value 0x9cfa084b
    li x3, 0x9cfa084b
    csrw 0x911, x3

    #Unmapped address 0x70a testing: random write/read operations
    #Address 0x70a Write value 0x8f7e00d0
    li x3, 0x8f7e00d0
    csrw 0x70a, x3

    #Address 0x70a Write value 0x1242f0ce
    li x3, 0x1242f0ce
    csrw 0x70a, x3

    #Address 0x70a Write value 0x3bd2a79
    li x3, 0x3bd2a79
    csrw 0x70a, x3

    #Address 0x70a read value
    csrr x14, 0x70a

    #Unmapped address 0xe6d testing: random write/read operations
    #Address 0xe6d read value
    csrr x14, 0xe6d

    #Address 0xe6d Write value 0x8ec5b115
    li x3, 0x8ec5b115
    csrw 0xe6d, x3

    #Address 0xe6d Write value 0x4187c6aa
    li x3, 0x4187c6aa
    csrw 0xe6d, x3

    #Unmapped address 0x234 testing: random write/read operations
    #Address 0x234 read value
    csrr x14, 0x234

    #Address 0x234 Write value 0xf5a99adb
    li x3, 0xf5a99adb
    csrw 0x234, x3

    #Address 0x234 read value
    csrr x14, 0x234

    #Unmapped address 0xe2d testing: random write/read operations
    #Address 0xe2d read value
    csrr x14, 0xe2d

    #Address 0xe2d Write value 0x1e493a9d
    li x3, 0x1e493a9d
    csrw 0xe2d, x3

    #Unmapped address 0x1e8 testing: random write/read operations
    #Address 0x1e8 Write value 0x52cf1088
    li x3, 0x52cf1088
    csrw 0x1e8, x3

    #Address 0x1e8 Write value 0xdb6d7dff
    li x3, 0xdb6d7dff
    csrw 0x1e8, x3

    #Address 0x1e8 read value
    csrr x14, 0x1e8

    #Unmapped address 0x1c testing: random write/read operations
    #Address 0x1c read value
    csrr x14, 0x1c

    #Address 0x1c read value
    csrr x14, 0x1c

    #Address 0x1c read value
    csrr x14, 0x1c

    #Address 0x1c Write value 0x40b7c5e3
    li x3, 0x40b7c5e3
    csrw 0x1c, x3

    #Unmapped address 0xe56 testing: random write/read operations
    #Address 0xe56 Write value 0x60defc0e
    li x3, 0x60defc0e
    csrw 0xe56, x3

    #Address 0xe56 Write value 0xd3f0ffe6
    li x3, 0xd3f0ffe6
    csrw 0xe56, x3

    #Address 0xe56 read value
    csrr x14, 0xe56

    #Unmapped address 0xead testing: random write/read operations
    #Address 0xead Write value 0x81a36fb2
    li x3, 0x81a36fb2
    csrw 0xead, x3

    #Address 0xead Write value 0xa0afae7a
    li x3, 0xa0afae7a
    csrw 0xead, x3

    #Address 0xead Write value 0xe3279a7d
    li x3, 0xe3279a7d
    csrw 0xead, x3

    #Address 0xead Write value 0xb9a40bd1
    li x3, 0xb9a40bd1
    csrw 0xead, x3

    #Address 0xead read value
    csrr x14, 0xead

    #Unmapped address 0x624 testing: random write/read operations
    #Address 0x624 read value
    csrr x14, 0x624

    #Address 0x624 read value
    csrr x14, 0x624

    #Address 0x624 read value
    csrr x14, 0x624

    #Unmapped address 0x4ba testing: random write/read operations
    #Address 0x4ba Write value 0x3ae3cc4
    li x3, 0x3ae3cc4
    csrw 0x4ba, x3

    #Address 0x4ba read value
    csrr x14, 0x4ba

    #Address 0x4ba read value
    csrr x14, 0x4ba

    #Address 0x4ba read value
    csrr x14, 0x4ba

    #Unmapped address 0x2c1 testing: random write/read operations
    #Address 0x2c1 read value
    csrr x14, 0x2c1

    #Address 0x2c1 read value
    csrr x14, 0x2c1

    #Address 0x2c1 Write value 0x4dbb54c4
    li x3, 0x4dbb54c4
    csrw 0x2c1, x3

    #Address 0x2c1 Write value 0x7ea27bfc
    li x3, 0x7ea27bfc
    csrw 0x2c1, x3

    #Address 0x2c1 Write value 0xc501da19
    li x3, 0xc501da19
    csrw 0x2c1, x3

    #Unmapped address 0x6f6 testing: random write/read operations
    #Address 0x6f6 read value
    csrr x14, 0x6f6

    #Address 0x6f6 Write value 0x3410227a
    li x3, 0x3410227a
    csrw 0x6f6, x3

    #Address 0x6f6 read value
    csrr x14, 0x6f6

    #Address 0x6f6 Write value 0xc8692e56
    li x3, 0xc8692e56
    csrw 0x6f6, x3

    #Unmapped address 0x901 testing: random write/read operations
    #Address 0x901 read value
    csrr x14, 0x901

    #Address 0x901 read value
    csrr x14, 0x901

    #Unmapped address 0x457 testing: random write/read operations
    #Address 0x457 Write value 0x3a5a5230
    li x3, 0x3a5a5230
    csrw 0x457, x3

    #Address 0x457 read value
    csrr x14, 0x457

    #Address 0x457 read value
    csrr x14, 0x457

    #Address 0x457 read value
    csrr x14, 0x457

    #Address 0x457 read value
    csrr x14, 0x457

    #Unmapped address 0xf2a testing: random write/read operations
    #Address 0xf2a Write value 0xb673423e
    li x3, 0xb673423e
    csrw 0xf2a, x3

    #Unmapped address 0x1e2 testing: random write/read operations
    #Address 0x1e2 read value
    csrr x14, 0x1e2

    #Address 0x1e2 read value
    csrr x14, 0x1e2

    #Address 0x1e2 read value
    csrr x14, 0x1e2

    #Unmapped address 0x34c testing: random write/read operations
    #Address 0x34c read value
    csrr x14, 0x34c

    #Address 0x34c Write value 0x1fc241ec
    li x3, 0x1fc241ec
    csrw 0x34c, x3

    #Address 0x34c Write value 0x3072f05
    li x3, 0x3072f05
    csrw 0x34c, x3

    #Address 0x34c Write value 0x1694a526
    li x3, 0x1694a526
    csrw 0x34c, x3

    #Address 0x34c read value
    csrr x14, 0x34c

    #Unmapped address 0x2b9 testing: random write/read operations
    #Address 0x2b9 read value
    csrr x14, 0x2b9

    #Address 0x2b9 read value
    csrr x14, 0x2b9

    #Address 0x2b9 read value
    csrr x14, 0x2b9

    #Unmapped address 0x1d9 testing: random write/read operations
    #Address 0x1d9 read value
    csrr x14, 0x1d9

    #Address 0x1d9 read value
    csrr x14, 0x1d9

    #Address 0x1d9 Write value 0xc38869b
    li x3, 0xc38869b
    csrw 0x1d9, x3

    #Address 0x1d9 read value
    csrr x14, 0x1d9

    #Unmapped address 0xf4f testing: random write/read operations
    #Address 0xf4f read value
    csrr x14, 0xf4f

    #Address 0xf4f Write value 0x8391b25a
    li x3, 0x8391b25a
    csrw 0xf4f, x3

    #Address 0xf4f read value
    csrr x14, 0xf4f

    #Address 0xf4f Write value 0x7485f686
    li x3, 0x7485f686
    csrw 0xf4f, x3

    #Unmapped address 0xfae testing: random write/read operations
    #Address 0xfae Write value 0xe741ef80
    li x3, 0xe741ef80
    csrw 0xfae, x3

    #Unmapped address 0x41 testing: random write/read operations
    #Address 0x41 read value
    csrr x14, 0x41

    #Address 0x41 Write value 0x7b9a9abf
    li x3, 0x7b9a9abf
    csrw 0x41, x3

    #Address 0x41 read value
    csrr x14, 0x41

    #Unmapped address 0xf71 testing: random write/read operations
    #Address 0xf71 read value
    csrr x14, 0xf71

    #Address 0xf71 Write value 0xd36816ef
    li x3, 0xd36816ef
    csrw 0xf71, x3

    #Address 0xf71 Write value 0x22814c90
    li x3, 0x22814c90
    csrw 0xf71, x3

    #Address 0xf71 read value
    csrr x14, 0xf71

    #Unmapped address 0x38c testing: random write/read operations
    #Address 0x38c read value
    csrr x14, 0x38c

    #Address 0x38c read value
    csrr x14, 0x38c

    #Unmapped address 0xbf2 testing: random write/read operations
    #Address 0xbf2 read value
    csrr x14, 0xbf2

    #Address 0xbf2 Write value 0x67123136
    li x3, 0x67123136
    csrw 0xbf2, x3

    #Address 0xbf2 Write value 0x1b2270f0
    li x3, 0x1b2270f0
    csrw 0xbf2, x3

    #Address 0xbf2 Write value 0x71d935d1
    li x3, 0x71d935d1
    csrw 0xbf2, x3

    #Unmapped address 0x8ff testing: random write/read operations
    #Address 0x8ff Write value 0xba6e3137
    li x3, 0xba6e3137
    csrw 0x8ff, x3

    #Unmapped address 0x681 testing: random write/read operations
    #Address 0x681 Write value 0xef440ebd
    li x3, 0xef440ebd
    csrw 0x681, x3

    #Address 0x681 Write value 0x7f201139
    li x3, 0x7f201139
    csrw 0x681, x3

    #Address 0x681 read value
    csrr x14, 0x681

    #Unmapped address 0xa3f testing: random write/read operations
    #Address 0xa3f Write value 0xd509d489
    li x3, 0xd509d489
    csrw 0xa3f, x3

    #Address 0xa3f read value
    csrr x14, 0xa3f

    #Unmapped address 0xc51 testing: random write/read operations
    #Address 0xc51 read value
    csrr x14, 0xc51

    #Unmapped address 0xb66 testing: random write/read operations
    #Address 0xb66 Write value 0x814c03c5
    li x3, 0x814c03c5
    csrw 0xb66, x3

    #Address 0xb66 read value
    csrr x14, 0xb66

    #Address 0xb66 Write value 0xd0599f74
    li x3, 0xd0599f74
    csrw 0xb66, x3

    #Unmapped address 0xe77 testing: random write/read operations
    #Address 0xe77 Write value 0xee199267
    li x3, 0xee199267
    csrw 0xe77, x3

    #Address 0xe77 read value
    csrr x14, 0xe77

    #Address 0xe77 Write value 0x5daf9e7d
    li x3, 0x5daf9e7d
    csrw 0xe77, x3

    #Address 0xe77 Write value 0x45d571e5
    li x3, 0x45d571e5
    csrw 0xe77, x3

    #Unmapped address 0x16c testing: random write/read operations
    #Address 0x16c read value
    csrr x14, 0x16c

    #Address 0x16c Write value 0xaaa1488b
    li x3, 0xaaa1488b
    csrw 0x16c, x3

    #Address 0x16c read value
    csrr x14, 0x16c

    #Unmapped address 0x804 testing: random write/read operations
    #Address 0x804 read value
    csrr x14, 0x804

    #Address 0x804 read value
    csrr x14, 0x804

    #Address 0x804 Write value 0xc58d0f22
    li x3, 0xc58d0f22
    csrw 0x804, x3

    #Address 0x804 read value
    csrr x14, 0x804

    #Unmapped address 0x4c testing: random write/read operations
    #Address 0x4c read value
    csrr x14, 0x4c

    #Unmapped address 0x145 testing: random write/read operations
    #Address 0x145 Write value 0xf88bd92c
    li x3, 0xf88bd92c
    csrw 0x145, x3

    #Address 0x145 Write value 0x9f24695a
    li x3, 0x9f24695a
    csrw 0x145, x3

    #Address 0x145 Write value 0x9a9b9195
    li x3, 0x9a9b9195
    csrw 0x145, x3

    #Address 0x145 read value
    csrr x14, 0x145

    #Unmapped address 0x100 testing: random write/read operations
    #Address 0x100 read value
    csrr x14, 0x100

    #Address 0x100 Write value 0x1f8e81c3
    li x3, 0x1f8e81c3
    csrw 0x100, x3

    #Address 0x100 Write value 0x38213f72
    li x3, 0x38213f72
    csrw 0x100, x3

    #Address 0x100 read value
    csrr x14, 0x100

    #Address 0x100 Write value 0x243f978c
    li x3, 0x243f978c
    csrw 0x100, x3

    #Unmapped address 0x95f testing: random write/read operations
    #Address 0x95f read value
    csrr x14, 0x95f

    #Unmapped address 0x5f0 testing: random write/read operations
    #Address 0x5f0 read value
    csrr x14, 0x5f0

    #Address 0x5f0 Write value 0x5fff21cf
    li x3, 0x5fff21cf
    csrw 0x5f0, x3

    #Address 0x5f0 Write value 0x9574ef85
    li x3, 0x9574ef85
    csrw 0x5f0, x3

    #Address 0x5f0 read value
    csrr x14, 0x5f0

    #Unmapped address 0x10c testing: random write/read operations
    #Address 0x10c read value
    csrr x14, 0x10c

    #Unmapped address 0x284 testing: random write/read operations
    #Address 0x284 read value
    csrr x14, 0x284

    #Address 0x284 Write value 0x123ff3e0
    li x3, 0x123ff3e0
    csrw 0x284, x3

    #Address 0x284 read value
    csrr x14, 0x284

    #Address 0x284 Write value 0x223905ee
    li x3, 0x223905ee
    csrw 0x284, x3

    #Unmapped address 0xf07 testing: random write/read operations
    #Address 0xf07 read value
    csrr x14, 0xf07

    #Address 0xf07 read value
    csrr x14, 0xf07

    #Unmapped address 0x3ce testing: random write/read operations
    #Address 0x3ce read value
    csrr x14, 0x3ce

    #Unmapped address 0x563 testing: random write/read operations
    #Address 0x563 Write value 0x11361257
    li x3, 0x11361257
    csrw 0x563, x3

    #Address 0x563 Write value 0x7da8ff5a
    li x3, 0x7da8ff5a
    csrw 0x563, x3

    #Address 0x563 Write value 0x93895b42
    li x3, 0x93895b42
    csrw 0x563, x3

    #Unmapped address 0xeb4 testing: random write/read operations
    #Address 0xeb4 read value
    csrr x14, 0xeb4

    #Address 0xeb4 read value
    csrr x14, 0xeb4

    #Address 0xeb4 Write value 0xc355ac8c
    li x3, 0xc355ac8c
    csrw 0xeb4, x3

    #Unmapped address 0x3ae testing: random write/read operations
    #Address 0x3ae Write value 0x9a97f229
    li x3, 0x9a97f229
    csrw 0x3ae, x3

    #Address 0x3ae read value
    csrr x14, 0x3ae

    #Address 0x3ae Write value 0xc1a5d015
    li x3, 0xc1a5d015
    csrw 0x3ae, x3

    #Unmapped address 0xeab testing: random write/read operations
    #Address 0xeab Write value 0x87c69883
    li x3, 0x87c69883
    csrw 0xeab, x3

    #Address 0xeab Write value 0x4dd8d1fc
    li x3, 0x4dd8d1fc
    csrw 0xeab, x3

    #Address 0xeab Write value 0x96d817d5
    li x3, 0x96d817d5
    csrw 0xeab, x3

    #Address 0xeab Write value 0x199b9b54
    li x3, 0x199b9b54
    csrw 0xeab, x3

    #Address 0xeab read value
    csrr x14, 0xeab

    #Unmapped address 0x994 testing: random write/read operations
    #Address 0x994 read value
    csrr x14, 0x994

    #Address 0x994 Write value 0x893abc61
    li x3, 0x893abc61
    csrw 0x994, x3

    #Address 0x994 Write value 0x4265969c
    li x3, 0x4265969c
    csrw 0x994, x3

    #Address 0x994 Write value 0xcffeeb1a
    li x3, 0xcffeeb1a
    csrw 0x994, x3

    #Address 0x994 read value
    csrr x14, 0x994

    #Unmapped address 0x80e testing: random write/read operations
    #Address 0x80e read value
    csrr x14, 0x80e

    #Address 0x80e read value
    csrr x14, 0x80e

    #Unmapped address 0xd5 testing: random write/read operations
    #Address 0xd5 read value
    csrr x14, 0xd5

    #Unmapped address 0xe60 testing: random write/read operations
    #Address 0xe60 read value
    csrr x14, 0xe60

    #Address 0xe60 Write value 0xbb8e25f1
    li x3, 0xbb8e25f1
    csrw 0xe60, x3

    #Address 0xe60 read value
    csrr x14, 0xe60

    #Address 0xe60 read value
    csrr x14, 0xe60

    #Address 0xe60 read value
    csrr x14, 0xe60

    #Unmapped address 0xbd9 testing: random write/read operations
    #Address 0xbd9 read value
    csrr x14, 0xbd9

    #Address 0xbd9 read value
    csrr x14, 0xbd9

    #Unmapped address 0xcb1 testing: random write/read operations
    #Address 0xcb1 Write value 0x15f9f801
    li x3, 0x15f9f801
    csrw 0xcb1, x3

    #Address 0xcb1 read value
    csrr x14, 0xcb1

    #Address 0xcb1 read value
    csrr x14, 0xcb1

    #Unmapped address 0xfdf testing: random write/read operations
    #Address 0xfdf Write value 0x5e52cd2e
    li x3, 0x5e52cd2e
    csrw 0xfdf, x3

    #Mapped address 0x3b9 (pmpaddr9) testing: random write/read operations
    #Address 0x3b9 Write value 0x569dbdee
    li x3, 0x569dbdee
    csrw 0x3b9, x3

    #Address 0x3b9 Write value 0x17457119
    li x3, 0x17457119
    csrw 0x3b9, x3

    #Unmapped address 0x92f testing: random write/read operations
    #Address 0x92f Write value 0xa027dac7
    li x3, 0xa027dac7
    csrw 0x92f, x3

    #Address 0x92f read value
    csrr x14, 0x92f

    #Address 0x92f read value
    csrr x14, 0x92f

    #Address 0x92f read value
    csrr x14, 0x92f

    #Unmapped address 0xc39 testing: random write/read operations
    #Address 0xc39 read value
    csrr x14, 0xc39

    #Address 0xc39 read value
    csrr x14, 0xc39

    #Address 0xc39 Write value 0xc7b67978
    li x3, 0xc7b67978
    csrw 0xc39, x3

    #Address 0xc39 Write value 0x9bb46fd5
    li x3, 0x9bb46fd5
    csrw 0xc39, x3

    #Address 0xc39 read value
    csrr x14, 0xc39

    #Unmapped address 0xe2e testing: random write/read operations
    #Address 0xe2e read value
    csrr x14, 0xe2e

    #Address 0xe2e read value
    csrr x14, 0xe2e

    #Unmapped address 0xfd7 testing: random write/read operations
    #Address 0xfd7 Write value 0x1f53753b
    li x3, 0x1f53753b
    csrw 0xfd7, x3

    #Address 0xfd7 read value
    csrr x14, 0xfd7

    #Address 0xfd7 read value
    csrr x14, 0xfd7

    #Address 0xfd7 read value
    csrr x14, 0xfd7

    #Address 0xfd7 Write value 0x453e3ced
    li x3, 0x453e3ced
    csrw 0xfd7, x3

    #Unmapped address 0x9fa testing: random write/read operations
    #Address 0x9fa read value
    csrr x14, 0x9fa

    #Address 0x9fa read value
    csrr x14, 0x9fa

    #Address 0x9fa read value
    csrr x14, 0x9fa

    #Unmapped address 0x377 testing: random write/read operations
    #Address 0x377 Write value 0x5cba62a6
    li x3, 0x5cba62a6
    csrw 0x377, x3

    #Address 0x377 read value
    csrr x14, 0x377

    #Address 0x377 read value
    csrr x14, 0x377

    #Unmapped address 0x3ed testing: random write/read operations
    #Address 0x3ed Write value 0x7a0ceea0
    li x3, 0x7a0ceea0
    csrw 0x3ed, x3

    #Address 0x3ed Write value 0x166d5201
    li x3, 0x166d5201
    csrw 0x3ed, x3

    #Address 0x3ed read value
    csrr x14, 0x3ed

    #Address 0x3ed read value
    csrr x14, 0x3ed

    #Address 0x3ed Write value 0x1d986691
    li x3, 0x1d986691
    csrw 0x3ed, x3

    #Unmapped address 0xfb1 testing: random write/read operations
    #Address 0xfb1 Write value 0x92d07ee4
    li x3, 0x92d07ee4
    csrw 0xfb1, x3

    #Address 0xfb1 read value
    csrr x14, 0xfb1

    #Unmapped address 0x67 testing: random write/read operations
    #Address 0x67 read value
    csrr x14, 0x67

    #Unmapped address 0x4f7 testing: random write/read operations
    #Address 0x4f7 read value
    csrr x14, 0x4f7

    #Unmapped address 0x410 testing: random write/read operations
    #Address 0x410 read value
    csrr x14, 0x410

    #Address 0x410 read value
    csrr x14, 0x410

    #Address 0x410 read value
    csrr x14, 0x410

    #Address 0x410 Write value 0x576446bb
    li x3, 0x576446bb
    csrw 0x410, x3

    #Unmapped address 0x44e testing: random write/read operations
    #Address 0x44e read value
    csrr x14, 0x44e

    #Address 0x44e read value
    csrr x14, 0x44e

    #Address 0x44e Write value 0xee83b2e1
    li x3, 0xee83b2e1
    csrw 0x44e, x3

    #Unmapped address 0x90d testing: random write/read operations
    #Address 0x90d read value
    csrr x14, 0x90d

    #Address 0x90d read value
    csrr x14, 0x90d

    #Address 0x90d Write value 0xcc36d6c4
    li x3, 0xcc36d6c4
    csrw 0x90d, x3

    #Address 0x90d Write value 0x5a0203d9
    li x3, 0x5a0203d9
    csrw 0x90d, x3

    #Address 0x90d Write value 0x6b6cee85
    li x3, 0x6b6cee85
    csrw 0x90d, x3

    #Unmapped address 0xc4d testing: random write/read operations
    #Address 0xc4d read value
    csrr x14, 0xc4d

    #Address 0xc4d read value
    csrr x14, 0xc4d

    #Unmapped address 0x17e testing: random write/read operations
    #Address 0x17e Write value 0x9f053902
    li x3, 0x9f053902
    csrw 0x17e, x3

    #Address 0x17e read value
    csrr x14, 0x17e

    #Address 0x17e read value
    csrr x14, 0x17e

    #Unmapped address 0x37a testing: random write/read operations
    #Address 0x37a Write value 0x399e8f4a
    li x3, 0x399e8f4a
    csrw 0x37a, x3

    #Address 0x37a read value
    csrr x14, 0x37a

    #Unmapped address 0x147 testing: random write/read operations
    #Address 0x147 read value
    csrr x14, 0x147

    #Address 0x147 read value
    csrr x14, 0x147

    #Address 0x147 Write value 0x92e85011
    li x3, 0x92e85011
    csrw 0x147, x3

    #Address 0x147 Write value 0x7030425b
    li x3, 0x7030425b
    csrw 0x147, x3

    #Unmapped address 0x62c testing: random write/read operations
    #Address 0x62c read value
    csrr x14, 0x62c

    #Address 0x62c Write value 0xa67f9f4c
    li x3, 0xa67f9f4c
    csrw 0x62c, x3

    #Unmapped address 0xea7 testing: random write/read operations
    #Address 0xea7 read value
    csrr x14, 0xea7

    #Address 0xea7 Write value 0xf46af27c
    li x3, 0xf46af27c
    csrw 0xea7, x3

    #Unmapped address 0xda5 testing: random write/read operations
    #Address 0xda5 read value
    csrr x14, 0xda5

    #Unmapped address 0xcce testing: random write/read operations
    #Address 0xcce Write value 0x5135641c
    li x3, 0x5135641c
    csrw 0xcce, x3

    #Address 0xcce Write value 0x107fc167
    li x3, 0x107fc167
    csrw 0xcce, x3

    #Unmapped address 0xc87 testing: random write/read operations
    #Address 0xc87 read value
    csrr x14, 0xc87

    #Address 0xc87 Write value 0x36e5404b
    li x3, 0x36e5404b
    csrw 0xc87, x3

    #Address 0xc87 Write value 0x8af7f861
    li x3, 0x8af7f861
    csrw 0xc87, x3

    #Unmapped address 0xd6b testing: random write/read operations
    #Address 0xd6b read value
    csrr x14, 0xd6b

    #Address 0xd6b read value
    csrr x14, 0xd6b

    #Address 0xd6b Write value 0xde69b07d
    li x3, 0xde69b07d
    csrw 0xd6b, x3

    #Address 0xd6b read value
    csrr x14, 0xd6b

    #Address 0xd6b Write value 0xc6267c36
    li x3, 0xc6267c36
    csrw 0xd6b, x3

    #Unmapped address 0xe10 testing: random write/read operations
    #Address 0xe10 read value
    csrr x14, 0xe10

    #Address 0xe10 Write value 0x18a5543e
    li x3, 0x18a5543e
    csrw 0xe10, x3

    #Unmapped address 0x0 testing: random write/read operations
    #Address 0x0 read value
    csrr x14, 0x0

    #Address 0x0 read value
    csrr x14, 0x0

    #Address 0x0 read value
    csrr x14, 0x0

    #Address 0x0 Write value 0xf91c1f1e
    li x3, 0xf91c1f1e
    csrw 0x0, x3

    #Address 0x0 read value
    csrr x14, 0x0

    #Mapped address 0x327 (mhpmevent7) testing: random write/read operations
    #Address 0x327 read value
    csrr x14, 0x327

    #Address 0x327 Write value 0x83ae4dd5
    li x3, 0x83ae4dd5
    csrw 0x327, x3

    #Address 0x327 read value
    csrr x14, 0x327

    #Address 0x327 Write value 0x1be260d5
    li x3, 0x1be260d5
    csrw 0x327, x3

    #Unmapped address 0xa8f testing: random write/read operations
    #Address 0xa8f read value
    csrr x14, 0xa8f

    #Address 0xa8f read value
    csrr x14, 0xa8f

    #Address 0xa8f read value
    csrr x14, 0xa8f

    #Address 0xa8f Write value 0x9e1e8916
    li x3, 0x9e1e8916
    csrw 0xa8f, x3

    #Address 0xa8f read value
    csrr x14, 0xa8f

    #Unmapped address 0xd71 testing: random write/read operations
    #Address 0xd71 Write value 0xd8dd4b2d
    li x3, 0xd8dd4b2d
    csrw 0xd71, x3

    #Address 0xd71 Write value 0x1faf40f0
    li x3, 0x1faf40f0
    csrw 0xd71, x3

    #Address 0xd71 Write value 0x6ca6414
    li x3, 0x6ca6414
    csrw 0xd71, x3

    #Unmapped address 0xbda testing: random write/read operations
    #Address 0xbda read value
    csrr x14, 0xbda

    #Address 0xbda Write value 0x6380148
    li x3, 0x6380148
    csrw 0xbda, x3

    #Unmapped address 0xc3b testing: random write/read operations
    #Address 0xc3b read value
    csrr x14, 0xc3b

    #Address 0xc3b read value
    csrr x14, 0xc3b

    #Unmapped address 0x6de testing: random write/read operations
    #Address 0x6de read value
    csrr x14, 0x6de

    #Address 0x6de Write value 0xe2979682
    li x3, 0xe2979682
    csrw 0x6de, x3

    #Address 0x6de Write value 0xf4498173
    li x3, 0xf4498173
    csrw 0x6de, x3

    #Address 0x6de read value
    csrr x14, 0x6de

    #Address 0x6de Write value 0xf4134f51
    li x3, 0xf4134f51
    csrw 0x6de, x3

    #Unmapped address 0x848 testing: random write/read operations
    #Address 0x848 Write value 0xa76f6fe7
    li x3, 0xa76f6fe7
    csrw 0x848, x3

    #Address 0x848 Write value 0x5a43fcd9
    li x3, 0x5a43fcd9
    csrw 0x848, x3

    #Address 0x848 Write value 0xa93309a
    li x3, 0xa93309a
    csrw 0x848, x3

    #Address 0x848 Write value 0x383cf99b
    li x3, 0x383cf99b
    csrw 0x848, x3

    #Unmapped address 0x55a testing: random write/read operations
    #Address 0x55a read value
    csrr x14, 0x55a

    #Address 0x55a read value
    csrr x14, 0x55a

    #Unmapped address 0xd84 testing: random write/read operations
    #Address 0xd84 read value
    csrr x14, 0xd84

    #Unmapped address 0xc1 testing: random write/read operations
    #Address 0xc1 read value
    csrr x14, 0xc1

    #Address 0xc1 Write value 0x14d8d1df
    li x3, 0x14d8d1df
    csrw 0xc1, x3

    #Address 0xc1 read value
    csrr x14, 0xc1

    #Address 0xc1 Write value 0xd7d22dd7
    li x3, 0xd7d22dd7
    csrw 0xc1, x3

    #Address 0xc1 Write value 0x7d234ccf
    li x3, 0x7d234ccf
    csrw 0xc1, x3

    #Unmapped address 0xad testing: random write/read operations
    #Address 0xad read value
    csrr x14, 0xad

    #Address 0xad Write value 0x1ac4101
    li x3, 0x1ac4101
    csrw 0xad, x3

    #Address 0xad read value
    csrr x14, 0xad

    #Unmapped address 0xa49 testing: random write/read operations
    #Address 0xa49 Write value 0xa9cc9ad8
    li x3, 0xa9cc9ad8
    csrw 0xa49, x3

    #Address 0xa49 read value
    csrr x14, 0xa49

    #Address 0xa49 read value
    csrr x14, 0xa49

    #Address 0xa49 Write value 0xe495b285
    li x3, 0xe495b285
    csrw 0xa49, x3

    #Address 0xa49 Write value 0x5d4d00bc
    li x3, 0x5d4d00bc
    csrw 0xa49, x3

    #Unmapped address 0x206 testing: random write/read operations
    #Address 0x206 Write value 0x3471b86f
    li x3, 0x3471b86f
    csrw 0x206, x3

    #Unmapped address 0xea8 testing: random write/read operations
    #Address 0xea8 Write value 0xf7b6d379
    li x3, 0xf7b6d379
    csrw 0xea8, x3

    #Address 0xea8 Write value 0xd575556c
    li x3, 0xd575556c
    csrw 0xea8, x3

    #Address 0xea8 Write value 0x418b9392
    li x3, 0x418b9392
    csrw 0xea8, x3

    #Address 0xea8 read value
    csrr x14, 0xea8

    #Address 0xea8 Write value 0xeee7c398
    li x3, 0xeee7c398
    csrw 0xea8, x3

    #Unmapped address 0x850 testing: random write/read operations
    #Address 0x850 Write value 0x8c0c2065
    li x3, 0x8c0c2065
    csrw 0x850, x3

    #Unmapped address 0x9ca testing: random write/read operations
    #Address 0x9ca read value
    csrr x14, 0x9ca

    #Address 0x9ca read value
    csrr x14, 0x9ca

    #Unmapped address 0xbb6 testing: random write/read operations
    #Address 0xbb6 read value
    csrr x14, 0xbb6

    #Address 0xbb6 Write value 0xc4dcfc6b
    li x3, 0xc4dcfc6b
    csrw 0xbb6, x3

    #Address 0xbb6 Write value 0xb5a4b1d
    li x3, 0xb5a4b1d
    csrw 0xbb6, x3

    #Address 0xbb6 read value
    csrr x14, 0xbb6

    #Address 0xbb6 read value
    csrr x14, 0xbb6

    #Unmapped address 0x731 testing: random write/read operations
    #Address 0x731 Write value 0x231bb2b9
    li x3, 0x231bb2b9
    csrw 0x731, x3

    #Address 0x731 read value
    csrr x14, 0x731

    #Address 0x731 Write value 0x4a6396b
    li x3, 0x4a6396b
    csrw 0x731, x3

    #Address 0x731 Write value 0xabc50c88
    li x3, 0xabc50c88
    csrw 0x731, x3

    #Unmapped address 0x608 testing: random write/read operations
    #Address 0x608 read value
    csrr x14, 0x608

    #Address 0x608 read value
    csrr x14, 0x608

    #Address 0x608 read value
    csrr x14, 0x608

    #Address 0x608 read value
    csrr x14, 0x608

    #Address 0x608 Write value 0x575cd552
    li x3, 0x575cd552
    csrw 0x608, x3

    #Unmapped address 0x484 testing: random write/read operations
    #Address 0x484 read value
    csrr x14, 0x484

    #Address 0x484 Write value 0xab8ffb47
    li x3, 0xab8ffb47
    csrw 0x484, x3

    #Address 0x484 Write value 0x70880434
    li x3, 0x70880434
    csrw 0x484, x3

    #Address 0x484 Write value 0x801bf4d3
    li x3, 0x801bf4d3
    csrw 0x484, x3

    #Unmapped address 0xa5 testing: random write/read operations
    #Address 0xa5 read value
    csrr x14, 0xa5

    #Address 0xa5 Write value 0x4b8f8288
    li x3, 0x4b8f8288
    csrw 0xa5, x3

    #Address 0xa5 read value
    csrr x14, 0xa5

    #Address 0xa5 read value
    csrr x14, 0xa5

    #Address 0xa5 Write value 0x8173e97
    li x3, 0x8173e97
    csrw 0xa5, x3

    #Unmapped address 0x431 testing: random write/read operations
    #Address 0x431 Write value 0x398631ca
    li x3, 0x398631ca
    csrw 0x431, x3

    #Address 0x431 Write value 0x5ab9c0b1
    li x3, 0x5ab9c0b1
    csrw 0x431, x3

    #Address 0x431 Write value 0x25219dca
    li x3, 0x25219dca
    csrw 0x431, x3

    #Address 0x431 Write value 0xad37d368
    li x3, 0xad37d368
    csrw 0x431, x3

    #Address 0x431 Write value 0xc9874523
    li x3, 0xc9874523
    csrw 0x431, x3

    #Unmapped address 0x17d testing: random write/read operations
    #Address 0x17d read value
    csrr x14, 0x17d

    #Address 0x17d Write value 0xde087e47
    li x3, 0xde087e47
    csrw 0x17d, x3

    #Address 0x17d Write value 0xc18ee854
    li x3, 0xc18ee854
    csrw 0x17d, x3

    #Address 0x17d Write value 0x3983a77f
    li x3, 0x3983a77f
    csrw 0x17d, x3

    #Address 0x17d Write value 0x5b7d482f
    li x3, 0x5b7d482f
    csrw 0x17d, x3

    #Unmapped address 0x646 testing: random write/read operations
    #Address 0x646 Write value 0xcbcf3fcb
    li x3, 0xcbcf3fcb
    csrw 0x646, x3

    #Address 0x646 Write value 0x25b33995
    li x3, 0x25b33995
    csrw 0x646, x3

    #Address 0x646 Write value 0x1bd57d46
    li x3, 0x1bd57d46
    csrw 0x646, x3

    #Address 0x646 Write value 0xb6873adb
    li x3, 0xb6873adb
    csrw 0x646, x3

    #Unmapped address 0x852 testing: random write/read operations
    #Address 0x852 read value
    csrr x14, 0x852

    #Address 0x852 Write value 0xbad16cbf
    li x3, 0xbad16cbf
    csrw 0x852, x3

    #Address 0x852 Write value 0x730e3981
    li x3, 0x730e3981
    csrw 0x852, x3

    #Address 0x852 read value
    csrr x14, 0x852

    #Address 0x852 read value
    csrr x14, 0x852

    #Unmapped address 0xd2a testing: random write/read operations
    #Address 0xd2a read value
    csrr x14, 0xd2a

    #Address 0xd2a Write value 0x1c328fbb
    li x3, 0x1c328fbb
    csrw 0xd2a, x3

    #Address 0xd2a Write value 0x2ff7bce9
    li x3, 0x2ff7bce9
    csrw 0xd2a, x3

    #Address 0xd2a read value
    csrr x14, 0xd2a

    #Address 0xd2a Write value 0xef323e59
    li x3, 0xef323e59
    csrw 0xd2a, x3

    #Unmapped address 0x57b testing: random write/read operations
    #Address 0x57b Write value 0x4d7835b9
    li x3, 0x4d7835b9
    csrw 0x57b, x3

    #Address 0x57b Write value 0xef58f75e
    li x3, 0xef58f75e
    csrw 0x57b, x3

    #Address 0x57b Write value 0xddfee209
    li x3, 0xddfee209
    csrw 0x57b, x3

    #Address 0x57b read value
    csrr x14, 0x57b

    #Address 0x57b Write value 0xd0a1e667
    li x3, 0xd0a1e667
    csrw 0x57b, x3

    #Unmapped address 0x64d testing: random write/read operations
    #Address 0x64d read value
    csrr x14, 0x64d

    #Unmapped address 0x25c testing: random write/read operations
    #Address 0x25c Write value 0x5988ad24
    li x3, 0x5988ad24
    csrw 0x25c, x3

    #Address 0x25c read value
    csrr x14, 0x25c

    #Unmapped address 0x7df testing: random write/read operations
    #Address 0x7df Write value 0xcaa1741e
    li x3, 0xcaa1741e
    csrw 0x7df, x3

    #Address 0x7df Write value 0x580325c4
    li x3, 0x580325c4
    csrw 0x7df, x3

    #Unmapped address 0xcc6 testing: random write/read operations
    #Address 0xcc6 read value
    csrr x14, 0xcc6

    #Address 0xcc6 read value
    csrr x14, 0xcc6

    #Address 0xcc6 read value
    csrr x14, 0xcc6

    #Mapped address 0xb80 (mcycleh) testing: random write/read operations
    #Address 0xb80 read value
    csrr x14, 0xb80

    #Address 0xb80 read value
    csrr x14, 0xb80

    #Unmapped address 0x654 testing: random write/read operations
    #Address 0x654 Write value 0x1389368c
    li x3, 0x1389368c
    csrw 0x654, x3

    #Unmapped address 0xc25 testing: random write/read operations
    #Address 0xc25 read value
    csrr x14, 0xc25

    #Address 0xc25 Write value 0x1be70cc5
    li x3, 0x1be70cc5
    csrw 0xc25, x3

    #Address 0xc25 read value
    csrr x14, 0xc25

    #Address 0xc25 read value
    csrr x14, 0xc25

    #Unmapped address 0xd7 testing: random write/read operations
    #Address 0xd7 Write value 0xf1c98bf5
    li x3, 0xf1c98bf5
    csrw 0xd7, x3

    #Address 0xd7 read value
    csrr x14, 0xd7

    #Address 0xd7 read value
    csrr x14, 0xd7

    #Address 0xd7 Write value 0xdfb2833b
    li x3, 0xdfb2833b
    csrw 0xd7, x3

    #Unmapped address 0xdae testing: random write/read operations
    #Address 0xdae read value
    csrr x14, 0xdae

    #Address 0xdae read value
    csrr x14, 0xdae

    #Address 0xdae read value
    csrr x14, 0xdae

    #Address 0xdae read value
    csrr x14, 0xdae

    #Address 0xdae read value
    csrr x14, 0xdae

    #Unmapped address 0x24e testing: random write/read operations
    #Address 0x24e read value
    csrr x14, 0x24e

    #Address 0x24e read value
    csrr x14, 0x24e

    #Address 0x24e read value
    csrr x14, 0x24e

    #Address 0x24e read value
    csrr x14, 0x24e

    #Address 0x24e read value
    csrr x14, 0x24e

    #Unmapped address 0x7bc testing: random write/read operations
    #Address 0x7bc read value
    csrr x14, 0x7bc

    #Address 0x7bc Write value 0x40b99ef6
    li x3, 0x40b99ef6
    csrw 0x7bc, x3

    #Unmapped address 0x819 testing: random write/read operations
    #Address 0x819 read value
    csrr x14, 0x819

    #Address 0x819 Write value 0xdd25e3fa
    li x3, 0xdd25e3fa
    csrw 0x819, x3

    #Address 0x819 read value
    csrr x14, 0x819

    #Address 0x819 Write value 0x2e58845b
    li x3, 0x2e58845b
    csrw 0x819, x3

    #Address 0x819 read value
    csrr x14, 0x819

    #Unmapped address 0x587 testing: random write/read operations
    #Address 0x587 Write value 0x164911b6
    li x3, 0x164911b6
    csrw 0x587, x3

    #Address 0x587 read value
    csrr x14, 0x587

    #Address 0x587 Write value 0xd0eb28c8
    li x3, 0xd0eb28c8
    csrw 0x587, x3

    #Unmapped address 0x16b testing: random write/read operations
    #Address 0x16b Write value 0x310eab5e
    li x3, 0x310eab5e
    csrw 0x16b, x3

    #Address 0x16b Write value 0x3ce67e0f
    li x3, 0x3ce67e0f
    csrw 0x16b, x3

    #Address 0x16b Write value 0x17486a4e
    li x3, 0x17486a4e
    csrw 0x16b, x3

    #Address 0x16b Write value 0x2536381a
    li x3, 0x2536381a
    csrw 0x16b, x3

    #Address 0x16b Write value 0x209b9fa3
    li x3, 0x209b9fa3
    csrw 0x16b, x3

    #Unmapped address 0x60f testing: random write/read operations
    #Address 0x60f read value
    csrr x14, 0x60f

    #Address 0x60f Write value 0x54b4ede4
    li x3, 0x54b4ede4
    csrw 0x60f, x3

    #Address 0x60f Write value 0x9ed3e89b
    li x3, 0x9ed3e89b
    csrw 0x60f, x3

    #Address 0x60f Write value 0xf9894618
    li x3, 0xf9894618
    csrw 0x60f, x3

    #Unmapped address 0x389 testing: random write/read operations
    #Address 0x389 read value
    csrr x14, 0x389

    #Address 0x389 Write value 0x250b22cb
    li x3, 0x250b22cb
    csrw 0x389, x3

    #Address 0x389 read value
    csrr x14, 0x389

    #Address 0x389 Write value 0x60e4c04d
    li x3, 0x60e4c04d
    csrw 0x389, x3

    #Unmapped address 0x602 testing: random write/read operations
    #Address 0x602 read value
    csrr x14, 0x602

    #Address 0x602 Write value 0x56c3787b
    li x3, 0x56c3787b
    csrw 0x602, x3

    #Address 0x602 Write value 0xf67036e5
    li x3, 0xf67036e5
    csrw 0x602, x3

    #Address 0x602 read value
    csrr x14, 0x602

    #Address 0x602 read value
    csrr x14, 0x602

    #Unmapped address 0x9f0 testing: random write/read operations
    #Address 0x9f0 Write value 0xdc412089
    li x3, 0xdc412089
    csrw 0x9f0, x3

    #Address 0x9f0 Write value 0xea6fa76e
    li x3, 0xea6fa76e
    csrw 0x9f0, x3

    #Unmapped address 0x6fa testing: random write/read operations
    #Address 0x6fa read value
    csrr x14, 0x6fa

    #Address 0x6fa read value
    csrr x14, 0x6fa

    #Unmapped address 0x152 testing: random write/read operations
    #Address 0x152 read value
    csrr x14, 0x152

    #Address 0x152 read value
    csrr x14, 0x152

    #Unmapped address 0x5b3 testing: random write/read operations
    #Address 0x5b3 read value
    csrr x14, 0x5b3

    #Address 0x5b3 Write value 0x6a9e1cb6
    li x3, 0x6a9e1cb6
    csrw 0x5b3, x3

    #Address 0x5b3 Write value 0x798778b3
    li x3, 0x798778b3
    csrw 0x5b3, x3

    #Unmapped address 0xe33 testing: random write/read operations
    #Address 0xe33 Write value 0x2adf7c3b
    li x3, 0x2adf7c3b
    csrw 0xe33, x3

    #Unmapped address 0x4e6 testing: random write/read operations
    #Address 0x4e6 Write value 0xd0d9a794
    li x3, 0xd0d9a794
    csrw 0x4e6, x3

    #Address 0x4e6 Write value 0xf07c8cbe
    li x3, 0xf07c8cbe
    csrw 0x4e6, x3

    #Address 0x4e6 read value
    csrr x14, 0x4e6

    #Address 0x4e6 read value
    csrr x14, 0x4e6

    #Address 0x4e6 Write value 0x77199d67
    li x3, 0x77199d67
    csrw 0x4e6, x3

    #Unmapped address 0x6a4 testing: random write/read operations
    #Address 0x6a4 read value
    csrr x14, 0x6a4

    #Address 0x6a4 read value
    csrr x14, 0x6a4

    #Unmapped address 0x586 testing: random write/read operations
    #Address 0x586 read value
    csrr x14, 0x586

    #Address 0x586 read value
    csrr x14, 0x586

    #Address 0x586 read value
    csrr x14, 0x586

    #Address 0x586 read value
    csrr x14, 0x586

    #Address 0x586 read value
    csrr x14, 0x586

    #Unmapped address 0x39c testing: random write/read operations
    #Address 0x39c Write value 0xb075aac8
    li x3, 0xb075aac8
    csrw 0x39c, x3

    #Unmapped address 0xc74 testing: random write/read operations
    #Address 0xc74 Write value 0x2d46d050
    li x3, 0x2d46d050
    csrw 0xc74, x3

    #Unmapped address 0xc4c testing: random write/read operations
    #Address 0xc4c read value
    csrr x14, 0xc4c

    #Address 0xc4c Write value 0x6e73751d
    li x3, 0x6e73751d
    csrw 0xc4c, x3

    #Address 0xc4c Write value 0xbe11b416
    li x3, 0xbe11b416
    csrw 0xc4c, x3

    #Unmapped address 0xd48 testing: random write/read operations
    #Address 0xd48 read value
    csrr x14, 0xd48

    #Address 0xd48 read value
    csrr x14, 0xd48

    #Address 0xd48 Write value 0x57765715
    li x3, 0x57765715
    csrw 0xd48, x3

    #Address 0xd48 Write value 0x71d92b8b
    li x3, 0x71d92b8b
    csrw 0xd48, x3

    #Unmapped address 0xb36 testing: random write/read operations
    #Address 0xb36 read value
    csrr x14, 0xb36

    #Unmapped address 0xf28 testing: random write/read operations
    #Address 0xf28 Write value 0xfaf8399
    li x3, 0xfaf8399
    csrw 0xf28, x3

    #Unmapped address 0x1e5 testing: random write/read operations
    #Address 0x1e5 read value
    csrr x14, 0x1e5

    #Address 0x1e5 Write value 0x153be3db
    li x3, 0x153be3db
    csrw 0x1e5, x3

    #Address 0x1e5 read value
    csrr x14, 0x1e5

    #Address 0x1e5 Write value 0xe3f45fa7
    li x3, 0xe3f45fa7
    csrw 0x1e5, x3

    #Unmapped address 0x4b2 testing: random write/read operations
    #Address 0x4b2 Write value 0x49581dc1
    li x3, 0x49581dc1
    csrw 0x4b2, x3

    #Address 0x4b2 Write value 0xdae22642
    li x3, 0xdae22642
    csrw 0x4b2, x3

    #Address 0x4b2 Write value 0x51f5c167
    li x3, 0x51f5c167
    csrw 0x4b2, x3

    #Address 0x4b2 read value
    csrr x14, 0x4b2

    #Unmapped address 0xc1b testing: random write/read operations
    #Address 0xc1b Write value 0x48c7d6cc
    li x3, 0x48c7d6cc
    csrw 0xc1b, x3

    #Address 0xc1b read value
    csrr x14, 0xc1b

    #Unmapped address 0xd00 testing: random write/read operations
    #Address 0xd00 Write value 0x23d7ae35
    li x3, 0x23d7ae35
    csrw 0xd00, x3

    #Address 0xd00 read value
    csrr x14, 0xd00

    #Unmapped address 0x4f6 testing: random write/read operations
    #Address 0x4f6 read value
    csrr x14, 0x4f6

    #Address 0x4f6 Write value 0xadc848e7
    li x3, 0xadc848e7
    csrw 0x4f6, x3

    #Address 0x4f6 read value
    csrr x14, 0x4f6

    #Address 0x4f6 Write value 0x9abf5971
    li x3, 0x9abf5971
    csrw 0x4f6, x3

    #Unmapped address 0xe55 testing: random write/read operations
    #Address 0xe55 read value
    csrr x14, 0xe55

    #Address 0xe55 Write value 0xfd930c12
    li x3, 0xfd930c12
    csrw 0xe55, x3

    #Address 0xe55 read value
    csrr x14, 0xe55

    #Address 0xe55 Write value 0x4d2162b8
    li x3, 0x4d2162b8
    csrw 0xe55, x3

    #Unmapped address 0xda2 testing: random write/read operations
    #Address 0xda2 Write value 0xb48affa6
    li x3, 0xb48affa6
    csrw 0xda2, x3

    #Unmapped address 0x231 testing: random write/read operations
    #Address 0x231 read value
    csrr x14, 0x231

    #Address 0x231 Write value 0x63759dac
    li x3, 0x63759dac
    csrw 0x231, x3

    #Address 0x231 Write value 0xa43e3114
    li x3, 0xa43e3114
    csrw 0x231, x3

    #Unmapped address 0xe5f testing: random write/read operations
    #Address 0xe5f Write value 0x3d6e640
    li x3, 0x3d6e640
    csrw 0xe5f, x3

    #Address 0xe5f Write value 0xb0e98d03
    li x3, 0xb0e98d03
    csrw 0xe5f, x3

    #Address 0xe5f Write value 0x9d60a783
    li x3, 0x9d60a783
    csrw 0xe5f, x3

    #Unmapped address 0x89f testing: random write/read operations
    #Address 0x89f read value
    csrr x14, 0x89f

    #Address 0x89f Write value 0x4a82aa18
    li x3, 0x4a82aa18
    csrw 0x89f, x3

    #Address 0x89f Write value 0xcdc65f3b
    li x3, 0xcdc65f3b
    csrw 0x89f, x3

    #Address 0x89f Write value 0x2d44f412
    li x3, 0x2d44f412
    csrw 0x89f, x3

    #Address 0x89f read value
    csrr x14, 0x89f

    #Unmapped address 0x34b testing: random write/read operations
    #Address 0x34b read value
    csrr x14, 0x34b

    #Address 0x34b read value
    csrr x14, 0x34b

    #Address 0x34b Write value 0x554ca8da
    li x3, 0x554ca8da
    csrw 0x34b, x3

    #Address 0x34b read value
    csrr x14, 0x34b

    #Unmapped address 0xe6c testing: random write/read operations
    #Address 0xe6c read value
    csrr x14, 0xe6c

    #Address 0xe6c read value
    csrr x14, 0xe6c

    #Address 0xe6c read value
    csrr x14, 0xe6c

    #Address 0xe6c read value
    csrr x14, 0xe6c

    #Address 0xe6c read value
    csrr x14, 0xe6c

    #Unmapped address 0x37b testing: random write/read operations
    #Address 0x37b Write value 0xa2c279af
    li x3, 0xa2c279af
    csrw 0x37b, x3

    #Address 0x37b read value
    csrr x14, 0x37b

    #Address 0x37b Write value 0x9e18daab
    li x3, 0x9e18daab
    csrw 0x37b, x3

    #Address 0x37b read value
    csrr x14, 0x37b

    #Unmapped address 0xb5d testing: random write/read operations
    #Address 0xb5d read value
    csrr x14, 0xb5d

    #Address 0xb5d Write value 0xe4c252c5
    li x3, 0xe4c252c5
    csrw 0xb5d, x3

    #Unmapped address 0x4b6 testing: random write/read operations
    #Address 0x4b6 read value
    csrr x14, 0x4b6

    #Address 0x4b6 Write value 0x1040eaf8
    li x3, 0x1040eaf8
    csrw 0x4b6, x3

    #Address 0x4b6 Write value 0xe923cf03
    li x3, 0xe923cf03
    csrw 0x4b6, x3

    #Address 0x4b6 read value
    csrr x14, 0x4b6

    #Unmapped address 0xb20 testing: random write/read operations
    #Address 0xb20 Write value 0xefe007c
    li x3, 0xefe007c
    csrw 0xb20, x3

    #Address 0xb20 Write value 0x43d5aa3
    li x3, 0x43d5aa3
    csrw 0xb20, x3

    #Address 0xb20 Write value 0xc20ff55c
    li x3, 0xc20ff55c
    csrw 0xb20, x3

    #Address 0xb20 read value
    csrr x14, 0xb20

    #Unmapped address 0x74a testing: random write/read operations
    #Address 0x74a read value
    csrr x14, 0x74a

    #Address 0x74a read value
    csrr x14, 0x74a

    #Address 0x74a read value
    csrr x14, 0x74a

    #Address 0x74a read value
    csrr x14, 0x74a

    #Address 0x74a Write value 0x56c681d6
    li x3, 0x56c681d6
    csrw 0x74a, x3

    #Unmapped address 0x713 testing: random write/read operations
    #Address 0x713 read value
    csrr x14, 0x713

    #Unmapped address 0xc6f testing: random write/read operations
    #Address 0xc6f Write value 0x913dd57c
    li x3, 0x913dd57c
    csrw 0xc6f, x3

    #Address 0xc6f read value
    csrr x14, 0xc6f

    #Address 0xc6f read value
    csrr x14, 0xc6f

    #Address 0xc6f Write value 0x5b72e1e3
    li x3, 0x5b72e1e3
    csrw 0xc6f, x3

    #Unmapped address 0x209 testing: random write/read operations
    #Address 0x209 read value
    csrr x14, 0x209

    #Address 0x209 Write value 0x717b844b
    li x3, 0x717b844b
    csrw 0x209, x3

    #Unmapped address 0x5fb testing: random write/read operations
    #Address 0x5fb Write value 0x49a6632a
    li x3, 0x49a6632a
    csrw 0x5fb, x3

    #Address 0x5fb read value
    csrr x14, 0x5fb

    #Address 0x5fb read value
    csrr x14, 0x5fb

    #Address 0x5fb read value
    csrr x14, 0x5fb

    #Unmapped address 0x912 testing: random write/read operations
    #Address 0x912 read value
    csrr x14, 0x912

    #Address 0x912 Write value 0xd9809ee2
    li x3, 0xd9809ee2
    csrw 0x912, x3

    #Unmapped address 0x211 testing: random write/read operations
    #Address 0x211 Write value 0xca7baa9a
    li x3, 0xca7baa9a
    csrw 0x211, x3

    #Unmapped address 0xe4c testing: random write/read operations
    #Address 0xe4c read value
    csrr x14, 0xe4c

    #Address 0xe4c Write value 0x34366157
    li x3, 0x34366157
    csrw 0xe4c, x3

    #Unmapped address 0xa9d testing: random write/read operations
    #Address 0xa9d read value
    csrr x14, 0xa9d

    #Address 0xa9d Write value 0xf210ecb
    li x3, 0xf210ecb
    csrw 0xa9d, x3

    #Address 0xa9d Write value 0x8ca0be6e
    li x3, 0x8ca0be6e
    csrw 0xa9d, x3

    #Address 0xa9d Write value 0xa8cfe1c8
    li x3, 0xa8cfe1c8
    csrw 0xa9d, x3

    #Address 0xa9d Write value 0xc931232d
    li x3, 0xc931232d
    csrw 0xa9d, x3

    #Unmapped address 0x89c testing: random write/read operations
    #Address 0x89c read value
    csrr x14, 0x89c

    #Address 0x89c read value
    csrr x14, 0x89c

    #Unmapped address 0x452 testing: random write/read operations
    #Address 0x452 Write value 0x7ec0cde4
    li x3, 0x7ec0cde4
    csrw 0x452, x3

    #Address 0x452 read value
    csrr x14, 0x452

    #Address 0x452 read value
    csrr x14, 0x452

    #Address 0x452 read value
    csrr x14, 0x452

    #Unmapped address 0xbc0 testing: random write/read operations
    #Address 0xbc0 read value
    csrr x14, 0xbc0

    #Unmapped address 0x976 testing: random write/read operations
    #Address 0x976 read value
    csrr x14, 0x976

    #Unmapped address 0xd2c testing: random write/read operations
    #Address 0xd2c Write value 0xba09ad2b
    li x3, 0xba09ad2b
    csrw 0xd2c, x3

    #Address 0xd2c Write value 0xedfdd78e
    li x3, 0xedfdd78e
    csrw 0xd2c, x3

    #Unmapped address 0x877 testing: random write/read operations
    #Address 0x877 read value
    csrr x14, 0x877

    #Address 0x877 Write value 0xea6385be
    li x3, 0xea6385be
    csrw 0x877, x3

    #Address 0x877 read value
    csrr x14, 0x877

    #Unmapped address 0x8b9 testing: random write/read operations
    #Address 0x8b9 read value
    csrr x14, 0x8b9

    #Address 0x8b9 read value
    csrr x14, 0x8b9

    #Unmapped address 0xf45 testing: random write/read operations
    #Address 0xf45 read value
    csrr x14, 0xf45

    #Address 0xf45 Write value 0xbbcea70c
    li x3, 0xbbcea70c
    csrw 0xf45, x3

    #Unmapped address 0x8bb testing: random write/read operations
    #Address 0x8bb Write value 0x94d7baab
    li x3, 0x94d7baab
    csrw 0x8bb, x3

    #Address 0x8bb Write value 0x8a12e1de
    li x3, 0x8a12e1de
    csrw 0x8bb, x3

    #Address 0x8bb Write value 0x88908251
    li x3, 0x88908251
    csrw 0x8bb, x3

    #Address 0x8bb Write value 0xf0f11a5f
    li x3, 0xf0f11a5f
    csrw 0x8bb, x3

    #Address 0x8bb read value
    csrr x14, 0x8bb

    #Unmapped address 0x165 testing: random write/read operations
    #Address 0x165 read value
    csrr x14, 0x165

    #Address 0x165 Write value 0x9daf44da
    li x3, 0x9daf44da
    csrw 0x165, x3

    #Address 0x165 Write value 0x982c0751
    li x3, 0x982c0751
    csrw 0x165, x3

    #Unmapped address 0x896 testing: random write/read operations
    #Address 0x896 Write value 0xd4fa06b5
    li x3, 0xd4fa06b5
    csrw 0x896, x3

    #Unmapped address 0x41f testing: random write/read operations
    #Address 0x41f Write value 0xfce9b3
    li x3, 0xfce9b3
    csrw 0x41f, x3

    #Address 0x41f read value
    csrr x14, 0x41f

    #Address 0x41f read value
    csrr x14, 0x41f

    #Address 0x41f read value
    csrr x14, 0x41f

    #Unmapped address 0xe57 testing: random write/read operations
    #Address 0xe57 Write value 0x37b8124b
    li x3, 0x37b8124b
    csrw 0xe57, x3

    #Address 0xe57 Write value 0x6662ed19
    li x3, 0x6662ed19
    csrw 0xe57, x3

    #Address 0xe57 read value
    csrr x14, 0xe57

    #Address 0xe57 Write value 0x851c4d64
    li x3, 0x851c4d64
    csrw 0xe57, x3

    #Address 0xe57 read value
    csrr x14, 0xe57

    #Mapped address 0xc80 (cycleh) testing: random write/read operations
    #Address 0xc80 read value
    csrr x14, 0xc80

    #Unmapped address 0x44f testing: random write/read operations
    #Address 0x44f Write value 0xd04db97b
    li x3, 0xd04db97b
    csrw 0x44f, x3

    #Unmapped address 0x416 testing: random write/read operations
    #Address 0x416 read value
    csrr x14, 0x416

    #Address 0x416 Write value 0xed28c5d9
    li x3, 0xed28c5d9
    csrw 0x416, x3

    #Address 0x416 read value
    csrr x14, 0x416

    #Address 0x416 read value
    csrr x14, 0x416

    #Unmapped address 0xe3 testing: random write/read operations
    #Address 0xe3 read value
    csrr x14, 0xe3

    #Address 0xe3 read value
    csrr x14, 0xe3

    #Unmapped address 0xe15 testing: random write/read operations
    #Address 0xe15 read value
    csrr x14, 0xe15

    #Address 0xe15 Write value 0x7e71a51b
    li x3, 0x7e71a51b
    csrw 0xe15, x3

    #Address 0xe15 Write value 0xb2b0fbd9
    li x3, 0xb2b0fbd9
    csrw 0xe15, x3

    #Address 0xe15 read value
    csrr x14, 0xe15

    #Unmapped address 0x841 testing: random write/read operations
    #Address 0x841 read value
    csrr x14, 0x841

    #Address 0x841 read value
    csrr x14, 0x841

    #Address 0x841 Write value 0xb5ac38f2
    li x3, 0xb5ac38f2
    csrw 0x841, x3

    #Unmapped address 0xe7f testing: random write/read operations
    #Address 0xe7f read value
    csrr x14, 0xe7f

    #Unmapped address 0x79f testing: random write/read operations
    #Address 0x79f Write value 0x66b0880d
    li x3, 0x66b0880d
    csrw 0x79f, x3

    #Address 0x79f read value
    csrr x14, 0x79f

    #Address 0x79f read value
    csrr x14, 0x79f

    #Address 0x79f read value
    csrr x14, 0x79f

    #Unmapped address 0x705 testing: random write/read operations
    #Address 0x705 Write value 0x627ddc08
    li x3, 0x627ddc08
    csrw 0x705, x3

    #Address 0x705 Write value 0x50fc34c8
    li x3, 0x50fc34c8
    csrw 0x705, x3

    #Address 0x705 Write value 0x7721de39
    li x3, 0x7721de39
    csrw 0x705, x3

    #Address 0x705 read value
    csrr x14, 0x705

    #Unmapped address 0x3cc testing: random write/read operations
    #Address 0x3cc read value
    csrr x14, 0x3cc

    #Address 0x3cc read value
    csrr x14, 0x3cc

    #Unmapped address 0x870 testing: random write/read operations
    #Address 0x870 Write value 0x68e547f1
    li x3, 0x68e547f1
    csrw 0x870, x3

    #Address 0x870 Write value 0x62607883
    li x3, 0x62607883
    csrw 0x870, x3

    #Address 0x870 read value
    csrr x14, 0x870

    #Unmapped address 0x992 testing: random write/read operations
    #Address 0x992 read value
    csrr x14, 0x992

    #Address 0x992 read value
    csrr x14, 0x992

    #Unmapped address 0xcf4 testing: random write/read operations
    #Address 0xcf4 read value
    csrr x14, 0xcf4

    #Address 0xcf4 read value
    csrr x14, 0xcf4

    #Address 0xcf4 read value
    csrr x14, 0xcf4

    #Unmapped address 0x1a4 testing: random write/read operations
    #Address 0x1a4 read value
    csrr x14, 0x1a4

    #Unmapped address 0x9cf testing: random write/read operations
    #Address 0x9cf read value
    csrr x14, 0x9cf

    #Address 0x9cf Write value 0x51274a3a
    li x3, 0x51274a3a
    csrw 0x9cf, x3

    #Unmapped address 0xa testing: random write/read operations
    #Address 0xa Write value 0xc08c1785
    li x3, 0xc08c1785
    csrw 0xa, x3

    #Unmapped address 0xab4 testing: random write/read operations
    #Address 0xab4 Write value 0xb9693d0c
    li x3, 0xb9693d0c
    csrw 0xab4, x3

    #Address 0xab4 Write value 0xe2db8fab
    li x3, 0xe2db8fab
    csrw 0xab4, x3

    #Address 0xab4 read value
    csrr x14, 0xab4

    #Address 0xab4 Write value 0xa762b71b
    li x3, 0xa762b71b
    csrw 0xab4, x3

    #Address 0xab4 read value
    csrr x14, 0xab4

    #Unmapped address 0x19e testing: random write/read operations
    #Address 0x19e Write value 0x2175df2c
    li x3, 0x2175df2c
    csrw 0x19e, x3

    #Address 0x19e read value
    csrr x14, 0x19e

    #Address 0x19e read value
    csrr x14, 0x19e

    #Unmapped address 0x4b testing: random write/read operations
    #Address 0x4b read value
    csrr x14, 0x4b

    #Address 0x4b read value
    csrr x14, 0x4b

    #Address 0x4b Write value 0xc30f2a6f
    li x3, 0xc30f2a6f
    csrw 0x4b, x3

    #Address 0x4b Write value 0x6742dd26
    li x3, 0x6742dd26
    csrw 0x4b, x3

    #Address 0x4b Write value 0x4588835b
    li x3, 0x4588835b
    csrw 0x4b, x3

    #Unmapped address 0x719 testing: random write/read operations
    #Address 0x719 Write value 0x5c7d4736
    li x3, 0x5c7d4736
    csrw 0x719, x3

    #Address 0x719 read value
    csrr x14, 0x719

    #Address 0x719 Write value 0x254edde5
    li x3, 0x254edde5
    csrw 0x719, x3

    #Address 0x719 read value
    csrr x14, 0x719

    #Address 0x719 Write value 0x8b57ba05
    li x3, 0x8b57ba05
    csrw 0x719, x3

    #Unmapped address 0x4a6 testing: random write/read operations
    #Address 0x4a6 Write value 0x96960a67
    li x3, 0x96960a67
    csrw 0x4a6, x3

    #Address 0x4a6 Write value 0xcd28111e
    li x3, 0xcd28111e
    csrw 0x4a6, x3

    #Unmapped address 0xb55 testing: random write/read operations
    #Address 0xb55 read value
    csrr x14, 0xb55

    #Address 0xb55 read value
    csrr x14, 0xb55

    #Address 0xb55 read value
    csrr x14, 0xb55

    #Unmapped address 0xda1 testing: random write/read operations
    #Address 0xda1 read value
    csrr x14, 0xda1

    #Address 0xda1 read value
    csrr x14, 0xda1

    #Unmapped address 0x194 testing: random write/read operations
    #Address 0x194 read value
    csrr x14, 0x194

    #Unmapped address 0x907 testing: random write/read operations
    #Address 0x907 Write value 0x773fd2f0
    li x3, 0x773fd2f0
    csrw 0x907, x3

    #Address 0x907 read value
    csrr x14, 0x907

    #Unmapped address 0xc81 testing: random write/read operations
    #Address 0xc81 read value
    csrr x14, 0xc81

    #Address 0xc81 Write value 0xbda240d9
    li x3, 0xbda240d9
    csrw 0xc81, x3

    #Address 0xc81 Write value 0xc26d23a3
    li x3, 0xc26d23a3
    csrw 0xc81, x3

    #Address 0xc81 read value
    csrr x14, 0xc81

    #Address 0xc81 read value
    csrr x14, 0xc81

    #Unmapped address 0xb53 testing: random write/read operations
    #Address 0xb53 Write value 0xe618932c
    li x3, 0xe618932c
    csrw 0xb53, x3

    #Address 0xb53 Write value 0xce177387
    li x3, 0xce177387
    csrw 0xb53, x3

    #Unmapped address 0x9dc testing: random write/read operations
    #Address 0x9dc Write value 0xd5012100
    li x3, 0xd5012100
    csrw 0x9dc, x3

    #Address 0x9dc Write value 0xaeb84bf6
    li x3, 0xaeb84bf6
    csrw 0x9dc, x3

    #Address 0x9dc Write value 0x607c618c
    li x3, 0x607c618c
    csrw 0x9dc, x3

    #Address 0x9dc Write value 0x3006851e
    li x3, 0x3006851e
    csrw 0x9dc, x3

    #Address 0x9dc Write value 0xd02394cd
    li x3, 0xd02394cd
    csrw 0x9dc, x3

    #Unmapped address 0x10 testing: random write/read operations
    #Address 0x10 Write value 0xdddf14a
    li x3, 0xdddf14a
    csrw 0x10, x3

    #Address 0x10 Write value 0x2d2c702d
    li x3, 0x2d2c702d
    csrw 0x10, x3

    #Address 0x10 Write value 0x3e0f69a2
    li x3, 0x3e0f69a2
    csrw 0x10, x3

    #Address 0x10 Write value 0x8842f572
    li x3, 0x8842f572
    csrw 0x10, x3

    #Address 0x10 read value
    csrr x14, 0x10

    #Unmapped address 0xf03 testing: random write/read operations
    #Address 0xf03 Write value 0xd3d8a66f
    li x3, 0xd3d8a66f
    csrw 0xf03, x3

    #Unmapped address 0x8cf testing: random write/read operations
    #Address 0x8cf Write value 0xdd6ab968
    li x3, 0xdd6ab968
    csrw 0x8cf, x3

    #Address 0x8cf read value
    csrr x14, 0x8cf

    #Unmapped address 0xe34 testing: random write/read operations
    #Address 0xe34 Write value 0xd6dd16dd
    li x3, 0xd6dd16dd
    csrw 0xe34, x3

    #Address 0xe34 Write value 0x24f4b7a
    li x3, 0x24f4b7a
    csrw 0xe34, x3

    #Address 0xe34 read value
    csrr x14, 0xe34

    #Unmapped address 0x9a0 testing: random write/read operations
    #Address 0x9a0 Write value 0xc90952bf
    li x3, 0xc90952bf
    csrw 0x9a0, x3

    #Address 0x9a0 Write value 0x1ba5fdbc
    li x3, 0x1ba5fdbc
    csrw 0x9a0, x3

    #Address 0x9a0 Write value 0xd5009429
    li x3, 0xd5009429
    csrw 0x9a0, x3

    #Address 0x9a0 read value
    csrr x14, 0x9a0

    #Address 0x9a0 Write value 0xe9bb3fdc
    li x3, 0xe9bb3fdc
    csrw 0x9a0, x3

    #Unmapped address 0xba7 testing: random write/read operations
    #Address 0xba7 read value
    csrr x14, 0xba7

    #Address 0xba7 Write value 0x1c668db4
    li x3, 0x1c668db4
    csrw 0xba7, x3

    #Address 0xba7 Write value 0x1e8d35c7
    li x3, 0x1e8d35c7
    csrw 0xba7, x3

    #Unmapped address 0x2a1 testing: random write/read operations
    #Address 0x2a1 Write value 0xcfa042d0
    li x3, 0xcfa042d0
    csrw 0x2a1, x3

    #Address 0x2a1 read value
    csrr x14, 0x2a1

    #Address 0x2a1 read value
    csrr x14, 0x2a1

    #Address 0x2a1 read value
    csrr x14, 0x2a1

    #Address 0x2a1 read value
    csrr x14, 0x2a1

    #Unmapped address 0x2d0 testing: random write/read operations
    #Address 0x2d0 Write value 0xb770a1e4
    li x3, 0xb770a1e4
    csrw 0x2d0, x3

    #Address 0x2d0 Write value 0x175e8d51
    li x3, 0x175e8d51
    csrw 0x2d0, x3

    #Address 0x2d0 read value
    csrr x14, 0x2d0

    #Address 0x2d0 Write value 0x58eb9adb
    li x3, 0x58eb9adb
    csrw 0x2d0, x3

    #Unmapped address 0xbb9 testing: random write/read operations
    #Address 0xbb9 read value
    csrr x14, 0xbb9

    #Address 0xbb9 Write value 0x6772f171
    li x3, 0x6772f171
    csrw 0xbb9, x3

    #Address 0xbb9 Write value 0xa0e3197c
    li x3, 0xa0e3197c
    csrw 0xbb9, x3

    #Address 0xbb9 read value
    csrr x14, 0xbb9

    #Unmapped address 0xf1b testing: random write/read operations
    #Address 0xf1b Write value 0xf2bc72c3
    li x3, 0xf2bc72c3
    csrw 0xf1b, x3

    #Address 0xf1b Write value 0xe2c576c0
    li x3, 0xe2c576c0
    csrw 0xf1b, x3

    #Address 0xf1b read value
    csrr x14, 0xf1b

    #Address 0xf1b Write value 0xe74c3e3e
    li x3, 0xe74c3e3e
    csrw 0xf1b, x3

    #Unmapped address 0x4ea testing: random write/read operations
    #Address 0x4ea read value
    csrr x14, 0x4ea

    #Address 0x4ea Write value 0xc75fdb57
    li x3, 0xc75fdb57
    csrw 0x4ea, x3

    #Address 0x4ea Write value 0x1ae57869
    li x3, 0x1ae57869
    csrw 0x4ea, x3

    #Address 0x4ea Write value 0x293fee36
    li x3, 0x293fee36
    csrw 0x4ea, x3

    #Address 0x4ea read value
    csrr x14, 0x4ea

    #Unmapped address 0xfc3 testing: random write/read operations
    #Address 0xfc3 read value
    csrr x14, 0xfc3

    #Address 0xfc3 Write value 0x218a2c65
    li x3, 0x218a2c65
    csrw 0xfc3, x3

    #Address 0xfc3 Write value 0xf33f1490
    li x3, 0xf33f1490
    csrw 0xfc3, x3

    #Address 0xfc3 read value
    csrr x14, 0xfc3

    #Address 0xfc3 Write value 0x9ea890dd
    li x3, 0x9ea890dd
    csrw 0xfc3, x3

    #Unmapped address 0x8ae testing: random write/read operations
    #Address 0x8ae read value
    csrr x14, 0x8ae

    #Address 0x8ae Write value 0x484a75c3
    li x3, 0x484a75c3
    csrw 0x8ae, x3

    #Address 0x8ae read value
    csrr x14, 0x8ae

    #Address 0x8ae Write value 0x337ad7fa
    li x3, 0x337ad7fa
    csrw 0x8ae, x3

    #Unmapped address 0x12b testing: random write/read operations
    #Address 0x12b Write value 0x91a456a5
    li x3, 0x91a456a5
    csrw 0x12b, x3

    #Address 0x12b Write value 0x2c538491
    li x3, 0x2c538491
    csrw 0x12b, x3

    #Address 0x12b read value
    csrr x14, 0x12b

    #Unmapped address 0x488 testing: random write/read operations
    #Address 0x488 Write value 0xa45f9c96
    li x3, 0xa45f9c96
    csrw 0x488, x3

    #Address 0x488 Write value 0xa1e6b311
    li x3, 0xa1e6b311
    csrw 0x488, x3

    #Unmapped address 0xe04 testing: random write/read operations
    #Address 0xe04 Write value 0x7d019cf7
    li x3, 0x7d019cf7
    csrw 0xe04, x3

    #Address 0xe04 read value
    csrr x14, 0xe04

    #Address 0xe04 read value
    csrr x14, 0xe04

    #Unmapped address 0x21a testing: random write/read operations
    #Address 0x21a read value
    csrr x14, 0x21a

    #Address 0x21a Write value 0xcbcae056
    li x3, 0xcbcae056
    csrw 0x21a, x3

    #Address 0x21a Write value 0x3cce57cc
    li x3, 0x3cce57cc
    csrw 0x21a, x3

    #Unmapped address 0x4a7 testing: random write/read operations
    #Address 0x4a7 Write value 0xe4999557
    li x3, 0xe4999557
    csrw 0x4a7, x3

    #Address 0x4a7 Write value 0xff6431c4
    li x3, 0xff6431c4
    csrw 0x4a7, x3

    #Unmapped address 0xecd testing: random write/read operations
    #Address 0xecd read value
    csrr x14, 0xecd

    #Address 0xecd read value
    csrr x14, 0xecd

    #Address 0xecd Write value 0xf98a50aa
    li x3, 0xf98a50aa
    csrw 0xecd, x3

    #Address 0xecd Write value 0x3ad38a68
    li x3, 0x3ad38a68
    csrw 0xecd, x3

    #Address 0xecd read value
    csrr x14, 0xecd

    #Unmapped address 0x77f testing: random write/read operations
    #Address 0x77f read value
    csrr x14, 0x77f

    #Address 0x77f Write value 0x4aec822e
    li x3, 0x4aec822e
    csrw 0x77f, x3

    #Address 0x77f Write value 0x11279325
    li x3, 0x11279325
    csrw 0x77f, x3

    #Unmapped address 0x317 testing: random write/read operations
    #Address 0x317 read value
    csrr x14, 0x317

    #Address 0x317 read value
    csrr x14, 0x317

    #Unmapped address 0xe3a testing: random write/read operations
    #Address 0xe3a Write value 0x8e2a2680
    li x3, 0x8e2a2680
    csrw 0xe3a, x3

    #Unmapped address 0x574 testing: random write/read operations
    #Address 0x574 Write value 0x315f84ee
    li x3, 0x315f84ee
    csrw 0x574, x3

    #Address 0x574 read value
    csrr x14, 0x574

    #Address 0x574 read value
    csrr x14, 0x574

    #Unmapped address 0xb7e testing: random write/read operations
    #Address 0xb7e Write value 0x11bf2825
    li x3, 0x11bf2825
    csrw 0xb7e, x3

    #Address 0xb7e read value
    csrr x14, 0xb7e

    #Address 0xb7e Write value 0x870debd3
    li x3, 0x870debd3
    csrw 0xb7e, x3

    #Address 0xb7e Write value 0xa705681b
    li x3, 0xa705681b
    csrw 0xb7e, x3

    #Unmapped address 0x4b3 testing: random write/read operations
    #Address 0x4b3 Write value 0x7c3688c4
    li x3, 0x7c3688c4
    csrw 0x4b3, x3

    #Address 0x4b3 Write value 0xadd974ce
    li x3, 0xadd974ce
    csrw 0x4b3, x3

    #Unmapped address 0x7af testing: random write/read operations
    #Address 0x7af read value
    csrr x14, 0x7af

    #Address 0x7af Write value 0x24a7d3bb
    li x3, 0x24a7d3bb
    csrw 0x7af, x3

    #Address 0x7af read value
    csrr x14, 0x7af

    #Address 0x7af read value
    csrr x14, 0x7af

    #Address 0x7af Write value 0xf5218676
    li x3, 0xf5218676
    csrw 0x7af, x3

    #Unmapped address 0x6b3 testing: random write/read operations
    #Address 0x6b3 read value
    csrr x14, 0x6b3

    #Address 0x6b3 read value
    csrr x14, 0x6b3

    #Address 0x6b3 read value
    csrr x14, 0x6b3

    #Address 0x6b3 Write value 0x952c3164
    li x3, 0x952c3164
    csrw 0x6b3, x3

    #Unmapped address 0xa7f testing: random write/read operations
    #Address 0xa7f read value
    csrr x14, 0xa7f

    #Address 0xa7f Write value 0x221492a3
    li x3, 0x221492a3
    csrw 0xa7f, x3

    #Unmapped address 0xc6e testing: random write/read operations
    #Address 0xc6e read value
    csrr x14, 0xc6e

    #Address 0xc6e Write value 0x47fb7227
    li x3, 0x47fb7227
    csrw 0xc6e, x3

    #Address 0xc6e Write value 0x4a1dcca7
    li x3, 0x4a1dcca7
    csrw 0xc6e, x3

    #Address 0xc6e Write value 0xa379f2cb
    li x3, 0xa379f2cb
    csrw 0xc6e, x3

    #Unmapped address 0x45a testing: random write/read operations
    #Address 0x45a read value
    csrr x14, 0x45a

    #Address 0x45a read value
    csrr x14, 0x45a

    #Address 0x45a Write value 0x365c0534
    li x3, 0x365c0534
    csrw 0x45a, x3

    #Mapped address 0xb1c (mhpmcounter28) testing: random write/read operations
    #Address 0xb1c Write value 0x25ee170a
    li x3, 0x25ee170a
    csrw 0xb1c, x3

    #Address 0xb1c Write value 0xdafb32fc
    li x3, 0xdafb32fc
    csrw 0xb1c, x3

    #Address 0xb1c read value
    csrr x14, 0xb1c

    #Address 0xb1c read value
    csrr x14, 0xb1c

    #Address 0xb1c Write value 0xb22bee71
    li x3, 0xb22bee71
    csrw 0xb1c, x3

    #Unmapped address 0xe58 testing: random write/read operations
    #Address 0xe58 Write value 0xf2102e58
    li x3, 0xf2102e58
    csrw 0xe58, x3

    #Address 0xe58 read value
    csrr x14, 0xe58

    #Address 0xe58 read value
    csrr x14, 0xe58

    #Unmapped address 0xf58 testing: random write/read operations
    #Address 0xf58 Write value 0xfd928b93
    li x3, 0xfd928b93
    csrw 0xf58, x3

    #Address 0xf58 Write value 0x6b8f2a47
    li x3, 0x6b8f2a47
    csrw 0xf58, x3

    #Unmapped address 0x49d testing: random write/read operations
    #Address 0x49d read value
    csrr x14, 0x49d

    #Address 0x49d read value
    csrr x14, 0x49d

    #Address 0x49d Write value 0xf1792827
    li x3, 0xf1792827
    csrw 0x49d, x3

    #Address 0x49d read value
    csrr x14, 0x49d

    #Unmapped address 0x2e7 testing: random write/read operations
    #Address 0x2e7 Write value 0xc77be5a6
    li x3, 0xc77be5a6
    csrw 0x2e7, x3

    #Unmapped address 0x402 testing: random write/read operations
    #Address 0x402 Write value 0xee90ad2c
    li x3, 0xee90ad2c
    csrw 0x402, x3

    #Address 0x402 read value
    csrr x14, 0x402

    #Unmapped address 0x95c testing: random write/read operations
    #Address 0x95c read value
    csrr x14, 0x95c

    #Address 0x95c Write value 0xb3cce27f
    li x3, 0xb3cce27f
    csrw 0x95c, x3

    #Address 0x95c read value
    csrr x14, 0x95c

    #Address 0x95c Write value 0x46c4ad5e
    li x3, 0x46c4ad5e
    csrw 0x95c, x3

    #Address 0x95c read value
    csrr x14, 0x95c

    #Unmapped address 0x738 testing: random write/read operations
    #Address 0x738 Write value 0x940cfe1c
    li x3, 0x940cfe1c
    csrw 0x738, x3

    #Address 0x738 read value
    csrr x14, 0x738

    #Address 0x738 read value
    csrr x14, 0x738

    #Unmapped address 0x54d testing: random write/read operations
    #Address 0x54d read value
    csrr x14, 0x54d

    #Address 0x54d Write value 0xc0325046
    li x3, 0xc0325046
    csrw 0x54d, x3

    #Address 0x54d Write value 0x2c51e87d
    li x3, 0x2c51e87d
    csrw 0x54d, x3

    #Address 0x54d read value
    csrr x14, 0x54d

    #Unmapped address 0x438 testing: random write/read operations
    #Address 0x438 read value
    csrr x14, 0x438

    #Unmapped address 0xee testing: random write/read operations
    #Address 0xee read value
    csrr x14, 0xee

    #Address 0xee Write value 0x28630a8f
    li x3, 0x28630a8f
    csrw 0xee, x3

    #Address 0xee Write value 0xb6fd2710
    li x3, 0xb6fd2710
    csrw 0xee, x3

    #Address 0xee read value
    csrr x14, 0xee

    #Unmapped address 0xb35 testing: random write/read operations
    #Address 0xb35 Write value 0xab6b35ab
    li x3, 0xab6b35ab
    csrw 0xb35, x3

    #Unmapped address 0x65d testing: random write/read operations
    #Address 0x65d read value
    csrr x14, 0x65d

    #Address 0x65d read value
    csrr x14, 0x65d

    #Address 0x65d read value
    csrr x14, 0x65d

    #Unmapped address 0x60d testing: random write/read operations
    #Address 0x60d Write value 0x4f783a6c
    li x3, 0x4f783a6c
    csrw 0x60d, x3

    #Address 0x60d Write value 0xb01570cd
    li x3, 0xb01570cd
    csrw 0x60d, x3

    #Address 0x60d read value
    csrr x14, 0x60d

    #Address 0x60d Write value 0x550a1967
    li x3, 0x550a1967
    csrw 0x60d, x3

    #Mapped address 0xb0d (mhpmcounter13) testing: random write/read operations
    #Address 0xb0d read value
    csrr x14, 0xb0d

    #Address 0xb0d Write value 0xadc774b1
    li x3, 0xadc774b1
    csrw 0xb0d, x3

    #Address 0xb0d Write value 0x63149d29
    li x3, 0x63149d29
    csrw 0xb0d, x3

    #Address 0xb0d Write value 0xfbb36c2b
    li x3, 0xfbb36c2b
    csrw 0xb0d, x3

    #Unmapped address 0x97d testing: random write/read operations
    #Address 0x97d Write value 0x22469773
    li x3, 0x22469773
    csrw 0x97d, x3

    #Address 0x97d Write value 0xed6f2e81
    li x3, 0xed6f2e81
    csrw 0x97d, x3

    #Address 0x97d read value
    csrr x14, 0x97d

    #Address 0x97d Write value 0x847c0945
    li x3, 0x847c0945
    csrw 0x97d, x3

    #Address 0x97d Write value 0x37728cbf
    li x3, 0x37728cbf
    csrw 0x97d, x3

    #Mapped address 0xb06 (mhpmcounter6) testing: random write/read operations
    #Address 0xb06 read value
    csrr x14, 0xb06

    #Address 0xb06 read value
    csrr x14, 0xb06

    #Address 0xb06 read value
    csrr x14, 0xb06

    #Address 0xb06 read value
    csrr x14, 0xb06

    #Address 0xb06 Write value 0xa155bf8
    li x3, 0xa155bf8
    csrw 0xb06, x3

    #Unmapped address 0x38d testing: random write/read operations
    #Address 0x38d Write value 0x107bc744
    li x3, 0x107bc744
    csrw 0x38d, x3

    #Unmapped address 0x6d testing: random write/read operations
    #Address 0x6d read value
    csrr x14, 0x6d

    #Address 0x6d read value
    csrr x14, 0x6d

    #Unmapped address 0x52f testing: random write/read operations
    #Address 0x52f read value
    csrr x14, 0x52f

    #Address 0x52f read value
    csrr x14, 0x52f

    #Unmapped address 0x902 testing: random write/read operations
    #Address 0x902 Write value 0x4218545f
    li x3, 0x4218545f
    csrw 0x902, x3

    #Address 0x902 Write value 0xeb2e9457
    li x3, 0xeb2e9457
    csrw 0x902, x3

    #Address 0x902 Write value 0x5901c019
    li x3, 0x5901c019
    csrw 0x902, x3

    #Address 0x902 read value
    csrr x14, 0x902

    #Unmapped address 0x225 testing: random write/read operations
    #Address 0x225 Write value 0x828552d6
    li x3, 0x828552d6
    csrw 0x225, x3

    #Address 0x225 read value
    csrr x14, 0x225

    #Unmapped address 0xaa8 testing: random write/read operations
    #Address 0xaa8 read value
    csrr x14, 0xaa8

    #Address 0xaa8 Write value 0xe87d9365
    li x3, 0xe87d9365
    csrw 0xaa8, x3

    #Unmapped address 0x21 testing: random write/read operations
    #Address 0x21 Write value 0x6d49bd25
    li x3, 0x6d49bd25
    csrw 0x21, x3

    #Address 0x21 read value
    csrr x14, 0x21

    #Unmapped address 0x91f testing: random write/read operations
    #Address 0x91f Write value 0x5400a9b5
    li x3, 0x5400a9b5
    csrw 0x91f, x3

    #Unmapped address 0xc35 testing: random write/read operations
    #Address 0xc35 Write value 0x1cdfa970
    li x3, 0x1cdfa970
    csrw 0xc35, x3

    #Address 0xc35 Write value 0xacccff9d
    li x3, 0xacccff9d
    csrw 0xc35, x3

    #Address 0xc35 Write value 0x5fbca223
    li x3, 0x5fbca223
    csrw 0xc35, x3

    #Address 0xc35 Write value 0x78a23f80
    li x3, 0x78a23f80
    csrw 0xc35, x3

    #Unmapped address 0x285 testing: random write/read operations
    #Address 0x285 read value
    csrr x14, 0x285

    #Address 0x285 Write value 0x25c80277
    li x3, 0x25c80277
    csrw 0x285, x3

    #Unmapped address 0x6bc testing: random write/read operations
    #Address 0x6bc Write value 0xe085b12b
    li x3, 0xe085b12b
    csrw 0x6bc, x3

    #Address 0x6bc read value
    csrr x14, 0x6bc

    #Address 0x6bc read value
    csrr x14, 0x6bc

    #Address 0x6bc read value
    csrr x14, 0x6bc

    #Mapped address 0xb8a (mhpmcounterh10) testing: random write/read operations
    #Address 0xb8a Write value 0xd92e8e62
    li x3, 0xd92e8e62
    csrw 0xb8a, x3

    #Address 0xb8a read value
    csrr x14, 0xb8a

    #Unmapped address 0x3c5 testing: random write/read operations
    #Address 0x3c5 read value
    csrr x14, 0x3c5

    #Address 0x3c5 read value
    csrr x14, 0x3c5

    #Unmapped address 0x578 testing: random write/read operations
    #Address 0x578 Write value 0xf173e6ec
    li x3, 0xf173e6ec
    csrw 0x578, x3

    #Address 0x578 Write value 0x73b6be35
    li x3, 0x73b6be35
    csrw 0x578, x3

    #Address 0x578 read value
    csrr x14, 0x578

    #Unmapped address 0xce testing: random write/read operations
    #Address 0xce Write value 0xc14ff289
    li x3, 0xc14ff289
    csrw 0xce, x3

    #Address 0xce read value
    csrr x14, 0xce

    #Address 0xce read value
    csrr x14, 0xce

    #Address 0xce Write value 0x456bff0f
    li x3, 0x456bff0f
    csrw 0xce, x3

    #Unmapped address 0x853 testing: random write/read operations
    #Address 0x853 Write value 0x447666c6
    li x3, 0x447666c6
    csrw 0x853, x3

    #Address 0x853 read value
    csrr x14, 0x853

    #Address 0x853 read value
    csrr x14, 0x853

    #Unmapped address 0x30 testing: random write/read operations
    #Address 0x30 Write value 0x2bb1275
    li x3, 0x2bb1275
    csrw 0x30, x3

    #Address 0x30 Write value 0xcb7e425b
    li x3, 0xcb7e425b
    csrw 0x30, x3

    #Address 0x30 Write value 0x112260c5
    li x3, 0x112260c5
    csrw 0x30, x3

    #Address 0x30 Write value 0x795b396
    li x3, 0x795b396
    csrw 0x30, x3

    #Address 0x30 read value
    csrr x14, 0x30

    #Unmapped address 0xd0f testing: random write/read operations
    #Address 0xd0f read value
    csrr x14, 0xd0f

    #Address 0xd0f read value
    csrr x14, 0xd0f

    #Address 0xd0f Write value 0xe2f2a4c3
    li x3, 0xe2f2a4c3
    csrw 0xd0f, x3

    #Address 0xd0f Write value 0xd1514df8
    li x3, 0xd1514df8
    csrw 0xd0f, x3

    #Address 0xd0f read value
    csrr x14, 0xd0f

    #Unmapped address 0xa2a testing: random write/read operations
    #Address 0xa2a read value
    csrr x14, 0xa2a

    #Address 0xa2a Write value 0x3be6db5c
    li x3, 0x3be6db5c
    csrw 0xa2a, x3

    #Unmapped address 0x2fe testing: random write/read operations
    #Address 0x2fe Write value 0x7559d6da
    li x3, 0x7559d6da
    csrw 0x2fe, x3

    #Address 0x2fe read value
    csrr x14, 0x2fe

    #Address 0x2fe Write value 0x49c44146
    li x3, 0x49c44146
    csrw 0x2fe, x3

    #Address 0x2fe read value
    csrr x14, 0x2fe

    #Unmapped address 0x84e testing: random write/read operations
    #Address 0x84e read value
    csrr x14, 0x84e

    #Address 0x84e Write value 0x5815fd29
    li x3, 0x5815fd29
    csrw 0x84e, x3

    #Address 0x84e Write value 0xff74a4fc
    li x3, 0xff74a4fc
    csrw 0x84e, x3

    #Address 0x84e Write value 0x69efdb42
    li x3, 0x69efdb42
    csrw 0x84e, x3

    #Unmapped address 0x39a testing: random write/read operations
    #Address 0x39a Write value 0x254904ee
    li x3, 0x254904ee
    csrw 0x39a, x3

    #Address 0x39a read value
    csrr x14, 0x39a

    #Unmapped address 0x3db testing: random write/read operations
    #Address 0x3db Write value 0x2dcf7d90
    li x3, 0x2dcf7d90
    csrw 0x3db, x3

    #Address 0x3db read value
    csrr x14, 0x3db

    #Unmapped address 0x38f testing: random write/read operations
    #Address 0x38f Write value 0xb70536c0
    li x3, 0xb70536c0
    csrw 0x38f, x3

    #Address 0x38f Write value 0xe896f9f1
    li x3, 0xe896f9f1
    csrw 0x38f, x3

    #Address 0x38f Write value 0x4443ba9d
    li x3, 0x4443ba9d
    csrw 0x38f, x3

    #Unmapped address 0x86e testing: random write/read operations
    #Address 0x86e read value
    csrr x14, 0x86e

    #Address 0x86e read value
    csrr x14, 0x86e

    #Address 0x86e read value
    csrr x14, 0x86e

    #Unmapped address 0x246 testing: random write/read operations
    #Address 0x246 Write value 0x408a6d35
    li x3, 0x408a6d35
    csrw 0x246, x3

    #Address 0x246 Write value 0xb0e4fc2a
    li x3, 0xb0e4fc2a
    csrw 0x246, x3

    #Address 0x246 read value
    csrr x14, 0x246

    #Mapped address 0xb07 (mhpmcounter7) testing: random write/read operations
    #Address 0xb07 Write value 0x553a3133
    li x3, 0x553a3133
    csrw 0xb07, x3

    #Address 0xb07 read value
    csrr x14, 0xb07

    #Address 0xb07 Write value 0x6278d358
    li x3, 0x6278d358
    csrw 0xb07, x3

    #Unmapped address 0xa32 testing: random write/read operations
    #Address 0xa32 read value
    csrr x14, 0xa32

    #Address 0xa32 read value
    csrr x14, 0xa32

    #Address 0xa32 Write value 0x8aec588a
    li x3, 0x8aec588a
    csrw 0xa32, x3

    #Address 0xa32 read value
    csrr x14, 0xa32

    #Address 0xa32 Write value 0x98305213
    li x3, 0x98305213
    csrw 0xa32, x3

    #Unmapped address 0xbfd testing: random write/read operations
    #Address 0xbfd Write value 0xf2ad8b78
    li x3, 0xf2ad8b78
    csrw 0xbfd, x3

    #Address 0xbfd read value
    csrr x14, 0xbfd

    #Address 0xbfd read value
    csrr x14, 0xbfd

    #Unmapped address 0xdd8 testing: random write/read operations
    #Address 0xdd8 read value
    csrr x14, 0xdd8

    #Address 0xdd8 read value
    csrr x14, 0xdd8

    #Address 0xdd8 Write value 0x7c259626
    li x3, 0x7c259626
    csrw 0xdd8, x3

    #Address 0xdd8 Write value 0x8b428892
    li x3, 0x8b428892
    csrw 0xdd8, x3

    #Address 0xdd8 Write value 0x16764406
    li x3, 0x16764406
    csrw 0xdd8, x3

    #Unmapped address 0x3fb testing: random write/read operations
    #Address 0x3fb read value
    csrr x14, 0x3fb

    #Address 0x3fb read value
    csrr x14, 0x3fb

    #Address 0x3fb Write value 0x26a25eb5
    li x3, 0x26a25eb5
    csrw 0x3fb, x3

    #Unmapped address 0xf32 testing: random write/read operations
    #Address 0xf32 read value
    csrr x14, 0xf32

    #Address 0xf32 read value
    csrr x14, 0xf32

    #Address 0xf32 Write value 0xb347ddf7
    li x3, 0xb347ddf7
    csrw 0xf32, x3

    #Unmapped address 0x772 testing: random write/read operations
    #Address 0x772 Write value 0x9d5ab9c5
    li x3, 0x9d5ab9c5
    csrw 0x772, x3

    #Address 0x772 Write value 0x20e5875b
    li x3, 0x20e5875b
    csrw 0x772, x3

    #Address 0x772 read value
    csrr x14, 0x772

    #Address 0x772 read value
    csrr x14, 0x772

    #Address 0x772 read value
    csrr x14, 0x772

    #Unmapped address 0xcf9 testing: random write/read operations
    #Address 0xcf9 Write value 0x4a3e1128
    li x3, 0x4a3e1128
    csrw 0xcf9, x3

    #Address 0xcf9 Write value 0x33f1875a
    li x3, 0x33f1875a
    csrw 0xcf9, x3

    #Address 0xcf9 read value
    csrr x14, 0xcf9

    #Address 0xcf9 Write value 0x46a7b216
    li x3, 0x46a7b216
    csrw 0xcf9, x3

    #Unmapped address 0x844 testing: random write/read operations
    #Address 0x844 read value
    csrr x14, 0x844

    #Address 0x844 read value
    csrr x14, 0x844

    #Address 0x844 read value
    csrr x14, 0x844

    #Address 0x844 Write value 0xbcc3bfe
    li x3, 0xbcc3bfe
    csrw 0x844, x3

    #Address 0x844 read value
    csrr x14, 0x844

    #Unmapped address 0x2f7 testing: random write/read operations
    #Address 0x2f7 Write value 0x4c46d6f5
    li x3, 0x4c46d6f5
    csrw 0x2f7, x3

    #Unmapped address 0xb26 testing: random write/read operations
    #Address 0xb26 Write value 0xe82bc1a2
    li x3, 0xe82bc1a2
    csrw 0xb26, x3

    #Address 0xb26 Write value 0x11d23991
    li x3, 0x11d23991
    csrw 0xb26, x3

    #Address 0xb26 read value
    csrr x14, 0xb26

    #Address 0xb26 Write value 0x2ce66d83
    li x3, 0x2ce66d83
    csrw 0xb26, x3

    #Unmapped address 0x18c testing: random write/read operations
    #Address 0x18c Write value 0xaff4e080
    li x3, 0xaff4e080
    csrw 0x18c, x3

    #Address 0x18c read value
    csrr x14, 0x18c

    #Unmapped address 0xa0d testing: random write/read operations
    #Address 0xa0d Write value 0xf92a97f2
    li x3, 0xf92a97f2
    csrw 0xa0d, x3

    #Unmapped address 0x6b9 testing: random write/read operations
    #Address 0x6b9 Write value 0x73d04da2
    li x3, 0x73d04da2
    csrw 0x6b9, x3

    #Address 0x6b9 Write value 0xc687d88d
    li x3, 0xc687d88d
    csrw 0x6b9, x3

    #Address 0x6b9 read value
    csrr x14, 0x6b9

    #Address 0x6b9 read value
    csrr x14, 0x6b9

    #Address 0x6b9 read value
    csrr x14, 0x6b9

    #Unmapped address 0xb32 testing: random write/read operations
    #Address 0xb32 read value
    csrr x14, 0xb32

    #Address 0xb32 Write value 0xd0451a3b
    li x3, 0xd0451a3b
    csrw 0xb32, x3

    #Unmapped address 0xd80 testing: random write/read operations
    #Address 0xd80 Write value 0x4555d9d3
    li x3, 0x4555d9d3
    csrw 0xd80, x3

    #Address 0xd80 read value
    csrr x14, 0xd80

    #Unmapped address 0x3fa testing: random write/read operations
    #Address 0x3fa Write value 0x5c978404
    li x3, 0x5c978404
    csrw 0x3fa, x3

    #Address 0x3fa read value
    csrr x14, 0x3fa

    #Address 0x3fa read value
    csrr x14, 0x3fa

    #Address 0x3fa Write value 0xaee548d2
    li x3, 0xaee548d2
    csrw 0x3fa, x3

    #Address 0x3fa Write value 0xc2e2cf82
    li x3, 0xc2e2cf82
    csrw 0x3fa, x3

    #Unmapped address 0x316 testing: random write/read operations
    #Address 0x316 read value
    csrr x14, 0x316

    #Address 0x316 Write value 0x794f9485
    li x3, 0x794f9485
    csrw 0x316, x3

    #Address 0x316 Write value 0x46a7e9e1
    li x3, 0x46a7e9e1
    csrw 0x316, x3

    #Address 0x316 Write value 0x54ae454b
    li x3, 0x54ae454b
    csrw 0x316, x3

    #Unmapped address 0xa58 testing: random write/read operations
    #Address 0xa58 read value
    csrr x14, 0xa58

    #Address 0xa58 Write value 0x5e1e43ac
    li x3, 0x5e1e43ac
    csrw 0xa58, x3

    #Address 0xa58 Write value 0xf38f7c09
    li x3, 0xf38f7c09
    csrw 0xa58, x3

    #Address 0xa58 Write value 0x9ae38be4
    li x3, 0x9ae38be4
    csrw 0xa58, x3

    #Address 0xa58 Write value 0x401c09ad
    li x3, 0x401c09ad
    csrw 0xa58, x3

    #Unmapped address 0xf01 testing: random write/read operations
    #Address 0xf01 Write value 0x2fa97419
    li x3, 0x2fa97419
    csrw 0xf01, x3

    #Unmapped address 0xf67 testing: random write/read operations
    #Address 0xf67 read value
    csrr x14, 0xf67

    #Unmapped address 0xf10 testing: random write/read operations
    #Address 0xf10 read value
    csrr x14, 0xf10

    #Unmapped address 0x1e9 testing: random write/read operations
    #Address 0x1e9 Write value 0x8e993b24
    li x3, 0x8e993b24
    csrw 0x1e9, x3

    #Address 0x1e9 read value
    csrr x14, 0x1e9

    #Address 0x1e9 read value
    csrr x14, 0x1e9

    #Address 0x1e9 Write value 0x79245afd
    li x3, 0x79245afd
    csrw 0x1e9, x3

    #Unmapped address 0x760 testing: random write/read operations
    #Address 0x760 Write value 0xd387b6d4
    li x3, 0xd387b6d4
    csrw 0x760, x3

    #Address 0x760 Write value 0x1ff3470f
    li x3, 0x1ff3470f
    csrw 0x760, x3

    #Address 0x760 Write value 0x10a95191
    li x3, 0x10a95191
    csrw 0x760, x3

    #Unmapped address 0x1be testing: random write/read operations
    #Address 0x1be read value
    csrr x14, 0x1be

    #Address 0x1be read value
    csrr x14, 0x1be

    #Address 0x1be read value
    csrr x14, 0x1be

    #Address 0x1be Write value 0xa2703622
    li x3, 0xa2703622
    csrw 0x1be, x3

    #Address 0x1be Write value 0x51d2ef44
    li x3, 0x51d2ef44
    csrw 0x1be, x3

    #Unmapped address 0x69c testing: random write/read operations
    #Address 0x69c read value
    csrr x14, 0x69c

    #Address 0x69c Write value 0x217d9339
    li x3, 0x217d9339
    csrw 0x69c, x3

    #Address 0x69c read value
    csrr x14, 0x69c

    #Address 0x69c read value
    csrr x14, 0x69c

    #Address 0x69c Write value 0x5df7d95d
    li x3, 0x5df7d95d
    csrw 0x69c, x3

    #Unmapped address 0x74d testing: random write/read operations
    #Address 0x74d Write value 0x5883cf23
    li x3, 0x5883cf23
    csrw 0x74d, x3

    #Address 0x74d read value
    csrr x14, 0x74d

    #Address 0x74d Write value 0x88a07
    li x3, 0x88a07
    csrw 0x74d, x3

    #Address 0x74d read value
    csrr x14, 0x74d

    #Address 0x74d read value
    csrr x14, 0x74d

    #Unmapped address 0x4ec testing: random write/read operations
    #Address 0x4ec read value
    csrr x14, 0x4ec

    #Address 0x4ec read value
    csrr x14, 0x4ec

    #Unmapped address 0x190 testing: random write/read operations
    #Address 0x190 Write value 0xab7e1d7
    li x3, 0xab7e1d7
    csrw 0x190, x3

    #Address 0x190 read value
    csrr x14, 0x190

    #Address 0x190 Write value 0xb3d3b6c6
    li x3, 0xb3d3b6c6
    csrw 0x190, x3

    #Address 0x190 Write value 0x6ed64eb
    li x3, 0x6ed64eb
    csrw 0x190, x3

    #Address 0x190 read value
    csrr x14, 0x190

    #Unmapped address 0x114 testing: random write/read operations
    #Address 0x114 Write value 0x5575a600
    li x3, 0x5575a600
    csrw 0x114, x3

    #Unmapped address 0x50 testing: random write/read operations
    #Address 0x50 Write value 0xc3e81fdd
    li x3, 0xc3e81fdd
    csrw 0x50, x3

    #Address 0x50 Write value 0x38ba3b8e
    li x3, 0x38ba3b8e
    csrw 0x50, x3

    #Unmapped address 0x3a5 testing: random write/read operations
    #Address 0x3a5 read value
    csrr x14, 0x3a5

    #Unmapped address 0x207 testing: random write/read operations
    #Address 0x207 Write value 0x22d2d631
    li x3, 0x22d2d631
    csrw 0x207, x3

    #Address 0x207 Write value 0xa519a256
    li x3, 0xa519a256
    csrw 0x207, x3

    #Address 0x207 read value
    csrr x14, 0x207

    #Address 0x207 Write value 0xed05b861
    li x3, 0xed05b861
    csrw 0x207, x3

    #Address 0x207 read value
    csrr x14, 0x207

    #Unmapped address 0x23 testing: random write/read operations
    #Address 0x23 read value
    csrr x14, 0x23

    #Address 0x23 read value
    csrr x14, 0x23

    #Address 0x23 read value
    csrr x14, 0x23

    #Unmapped address 0x27d testing: random write/read operations
    #Address 0x27d read value
    csrr x14, 0x27d

    #Address 0x27d read value
    csrr x14, 0x27d

    #Unmapped address 0x946 testing: random write/read operations
    #Address 0x946 Write value 0x4e14deb7
    li x3, 0x4e14deb7
    csrw 0x946, x3

    #Unmapped address 0x75a testing: random write/read operations
    #Address 0x75a read value
    csrr x14, 0x75a

    #Address 0x75a read value
    csrr x14, 0x75a

    #Address 0x75a Write value 0xfa1be4c1
    li x3, 0xfa1be4c1
    csrw 0x75a, x3

    #Address 0x75a Write value 0x60c981ad
    li x3, 0x60c981ad
    csrw 0x75a, x3

    #Address 0x75a Write value 0x1fa1c8d
    li x3, 0x1fa1c8d
    csrw 0x75a, x3

    #Unmapped address 0x5e4 testing: random write/read operations
    #Address 0x5e4 read value
    csrr x14, 0x5e4

    #Address 0x5e4 Write value 0x59822c3d
    li x3, 0x59822c3d
    csrw 0x5e4, x3

    #Unmapped address 0x7de testing: random write/read operations
    #Address 0x7de Write value 0xbf0acd7d
    li x3, 0xbf0acd7d
    csrw 0x7de, x3

    #Address 0x7de Write value 0xa36a30f9
    li x3, 0xa36a30f9
    csrw 0x7de, x3

    #Address 0x7de read value
    csrr x14, 0x7de

    #Address 0x7de Write value 0x459f2293
    li x3, 0x459f2293
    csrw 0x7de, x3

    #Address 0x7de Write value 0xd63f281f
    li x3, 0xd63f281f
    csrw 0x7de, x3

    #Unmapped address 0x73a testing: random write/read operations
    #Address 0x73a Write value 0x67ac2a09
    li x3, 0x67ac2a09
    csrw 0x73a, x3

    #Address 0x73a read value
    csrr x14, 0x73a

    #Unmapped address 0x360 testing: random write/read operations
    #Address 0x360 Write value 0xfe9cc84a
    li x3, 0xfe9cc84a
    csrw 0x360, x3

    #Address 0x360 Write value 0xe1b06517
    li x3, 0xe1b06517
    csrw 0x360, x3

    #Address 0x360 Write value 0x3e03f230
    li x3, 0x3e03f230
    csrw 0x360, x3

    #Unmapped address 0x969 testing: random write/read operations
    #Address 0x969 read value
    csrr x14, 0x969

    #Address 0x969 Write value 0xd57ceff0
    li x3, 0xd57ceff0
    csrw 0x969, x3

    #Address 0x969 read value
    csrr x14, 0x969

    #Address 0x969 read value
    csrr x14, 0x969

    #Address 0x969 Write value 0x8551f782
    li x3, 0x8551f782
    csrw 0x969, x3

    #Unmapped address 0xbe0 testing: random write/read operations
    #Address 0xbe0 read value
    csrr x14, 0xbe0

    #Address 0xbe0 Write value 0xe3e664df
    li x3, 0xe3e664df
    csrw 0xbe0, x3

    #Address 0xbe0 Write value 0xb1589410
    li x3, 0xb1589410
    csrw 0xbe0, x3

    #Address 0xbe0 read value
    csrr x14, 0xbe0

    #Address 0xbe0 Write value 0xcff07249
    li x3, 0xcff07249
    csrw 0xbe0, x3

    #Unmapped address 0x680 testing: random write/read operations
    #Address 0x680 Write value 0xf23a532a
    li x3, 0xf23a532a
    csrw 0x680, x3

    #Unmapped address 0x405 testing: random write/read operations
    #Address 0x405 Write value 0xad275537
    li x3, 0xad275537
    csrw 0x405, x3

    #Address 0x405 Write value 0x556af3bb
    li x3, 0x556af3bb
    csrw 0x405, x3

    #Unmapped address 0x890 testing: random write/read operations
    #Address 0x890 read value
    csrr x14, 0x890

    #Address 0x890 Write value 0x7d2cd414
    li x3, 0x7d2cd414
    csrw 0x890, x3

    #Address 0x890 Write value 0x30c4a10b
    li x3, 0x30c4a10b
    csrw 0x890, x3

    #Unmapped address 0x2c4 testing: random write/read operations
    #Address 0x2c4 Write value 0x8c52c800
    li x3, 0x8c52c800
    csrw 0x2c4, x3

    #Address 0x2c4 Write value 0xd54685b8
    li x3, 0xd54685b8
    csrw 0x2c4, x3

    #Address 0x2c4 Write value 0x180cf949
    li x3, 0x180cf949
    csrw 0x2c4, x3

    #Unmapped address 0x86 testing: random write/read operations
    #Address 0x86 read value
    csrr x14, 0x86

    #Unmapped address 0x28e testing: random write/read operations
    #Address 0x28e Write value 0x4a1cad6a
    li x3, 0x4a1cad6a
    csrw 0x28e, x3

    #Address 0x28e Write value 0xe3c41b16
    li x3, 0xe3c41b16
    csrw 0x28e, x3

    #Address 0x28e Write value 0x4be3dfbb
    li x3, 0x4be3dfbb
    csrw 0x28e, x3

    #Unmapped address 0x157 testing: random write/read operations
    #Address 0x157 read value
    csrr x14, 0x157

    #Address 0x157 read value
    csrr x14, 0x157

    #Address 0x157 read value
    csrr x14, 0x157

    #Address 0x157 Write value 0x5e22f35d
    li x3, 0x5e22f35d
    csrw 0x157, x3

    #Unmapped address 0xbb7 testing: random write/read operations
    #Address 0xbb7 Write value 0x1b94117c
    li x3, 0x1b94117c
    csrw 0xbb7, x3

    #Address 0xbb7 read value
    csrr x14, 0xbb7

    #Address 0xbb7 read value
    csrr x14, 0xbb7

    #Address 0xbb7 Write value 0x9fe9beec
    li x3, 0x9fe9beec
    csrw 0xbb7, x3

    #Address 0xbb7 read value
    csrr x14, 0xbb7

    #Unmapped address 0xf2d testing: random write/read operations
    #Address 0xf2d read value
    csrr x14, 0xf2d

    #Address 0xf2d read value
    csrr x14, 0xf2d

    #Address 0xf2d Write value 0x558b814b
    li x3, 0x558b814b
    csrw 0xf2d, x3

    #Address 0xf2d Write value 0xa73c13c
    li x3, 0xa73c13c
    csrw 0xf2d, x3

    #Address 0xf2d read value
    csrr x14, 0xf2d

    #Unmapped address 0x3c6 testing: random write/read operations
    #Address 0x3c6 Write value 0xf76aea6a
    li x3, 0xf76aea6a
    csrw 0x3c6, x3

    #Address 0x3c6 Write value 0xb7470582
    li x3, 0xb7470582
    csrw 0x3c6, x3

    #Address 0x3c6 Write value 0x84e00a55
    li x3, 0x84e00a55
    csrw 0x3c6, x3

    #Address 0x3c6 read value
    csrr x14, 0x3c6

    #Unmapped address 0xd8a testing: random write/read operations
    #Address 0xd8a Write value 0x5c4e40a
    li x3, 0x5c4e40a
    csrw 0xd8a, x3

    #Address 0xd8a read value
    csrr x14, 0xd8a

    #Address 0xd8a read value
    csrr x14, 0xd8a

    #Unmapped address 0xac9 testing: random write/read operations
    #Address 0xac9 read value
    csrr x14, 0xac9

    #Address 0xac9 Write value 0xcbe92299
    li x3, 0xcbe92299
    csrw 0xac9, x3

    #Address 0xac9 Write value 0xe7fcf801
    li x3, 0xe7fcf801
    csrw 0xac9, x3

    #Unmapped address 0xe28 testing: random write/read operations
    #Address 0xe28 Write value 0x5805932d
    li x3, 0x5805932d
    csrw 0xe28, x3

    #Address 0xe28 Write value 0x8043d137
    li x3, 0x8043d137
    csrw 0xe28, x3

    #Address 0xe28 read value
    csrr x14, 0xe28

    #Address 0xe28 Write value 0xf77a5471
    li x3, 0xf77a5471
    csrw 0xe28, x3

    #Address 0xe28 read value
    csrr x14, 0xe28

    #Unmapped address 0x314 testing: random write/read operations
    #Address 0x314 Write value 0x3d51e809
    li x3, 0x3d51e809
    csrw 0x314, x3

    #Address 0x314 Write value 0x8aad9b0e
    li x3, 0x8aad9b0e
    csrw 0x314, x3

    #Address 0x314 read value
    csrr x14, 0x314

    #Address 0x314 read value
    csrr x14, 0x314

    #Unmapped address 0x90 testing: random write/read operations
    #Address 0x90 Write value 0xd24ed16f
    li x3, 0xd24ed16f
    csrw 0x90, x3

    #Address 0x90 read value
    csrr x14, 0x90

    #Address 0x90 read value
    csrr x14, 0x90

    #Unmapped address 0x700 testing: random write/read operations
    #Address 0x700 Write value 0x891c08e1
    li x3, 0x891c08e1
    csrw 0x700, x3

    #Address 0x700 read value
    csrr x14, 0x700

    #Address 0x700 Write value 0xf8c40192
    li x3, 0xf8c40192
    csrw 0x700, x3

    #Address 0x700 Write value 0x4a3acf82
    li x3, 0x4a3acf82
    csrw 0x700, x3

    #Unmapped address 0x4b1 testing: random write/read operations
    #Address 0x4b1 read value
    csrr x14, 0x4b1

    #Address 0x4b1 read value
    csrr x14, 0x4b1

    #Address 0x4b1 read value
    csrr x14, 0x4b1

    #Unmapped address 0xe18 testing: random write/read operations
    #Address 0xe18 Write value 0x3aaf09d8
    li x3, 0x3aaf09d8
    csrw 0xe18, x3

    #Address 0xe18 read value
    csrr x14, 0xe18

    #Address 0xe18 read value
    csrr x14, 0xe18

    #Unmapped address 0xc8e testing: random write/read operations
    #Address 0xc8e read value
    csrr x14, 0xc8e

    #Unmapped address 0xdd2 testing: random write/read operations
    #Address 0xdd2 read value
    csrr x14, 0xdd2

    #Address 0xdd2 Write value 0x4caac9ca
    li x3, 0x4caac9ca
    csrw 0xdd2, x3

    #Unmapped address 0x43f testing: random write/read operations
    #Address 0x43f Write value 0x8a1bd1
    li x3, 0x8a1bd1
    csrw 0x43f, x3

    #Unmapped address 0x639 testing: random write/read operations
    #Address 0x639 read value
    csrr x14, 0x639

    #Address 0x639 read value
    csrr x14, 0x639

    #Address 0x639 read value
    csrr x14, 0x639

    #Address 0x639 Write value 0xb87a5310
    li x3, 0xb87a5310
    csrw 0x639, x3

    #Address 0x639 Write value 0x71f28081
    li x3, 0x71f28081
    csrw 0x639, x3

    #Unmapped address 0x111 testing: random write/read operations
    #Address 0x111 read value
    csrr x14, 0x111

    #Address 0x111 read value
    csrr x14, 0x111

    #Address 0x111 Write value 0xc3db3799
    li x3, 0xc3db3799
    csrw 0x111, x3

    #Address 0x111 read value
    csrr x14, 0x111

    #Unmapped address 0xd6d testing: random write/read operations
    #Address 0xd6d read value
    csrr x14, 0xd6d

    #Address 0xd6d read value
    csrr x14, 0xd6d

    #Address 0xd6d read value
    csrr x14, 0xd6d

    #Mapped address 0xb97 (mhpmcounterh23) testing: random write/read operations
    #Address 0xb97 Write value 0xe735e404
    li x3, 0xe735e404
    csrw 0xb97, x3

    #Address 0xb97 read value
    csrr x14, 0xb97

    #Address 0xb97 Write value 0xed76f769
    li x3, 0xed76f769
    csrw 0xb97, x3

    #Address 0xb97 Write value 0x517344f0
    li x3, 0x517344f0
    csrw 0xb97, x3

    #Unmapped address 0x6bd testing: random write/read operations
    #Address 0x6bd Write value 0xb6cd961b
    li x3, 0xb6cd961b
    csrw 0x6bd, x3

    #Address 0x6bd Write value 0x840419ca
    li x3, 0x840419ca
    csrw 0x6bd, x3

    #Address 0x6bd Write value 0x81ceb70e
    li x3, 0x81ceb70e
    csrw 0x6bd, x3

    #Address 0x6bd Write value 0x6eef87d2
    li x3, 0x6eef87d2
    csrw 0x6bd, x3

    #Address 0x6bd Write value 0x2b0ea222
    li x3, 0x2b0ea222
    csrw 0x6bd, x3

    #Unmapped address 0xeb5 testing: random write/read operations
    #Address 0xeb5 Write value 0xb773c686
    li x3, 0xb773c686
    csrw 0xeb5, x3

    #Address 0xeb5 read value
    csrr x14, 0xeb5

    #Address 0xeb5 read value
    csrr x14, 0xeb5

    #Unmapped address 0x9d7 testing: random write/read operations
    #Address 0x9d7 read value
    csrr x14, 0x9d7

    #Address 0x9d7 Write value 0x19b78a5b
    li x3, 0x19b78a5b
    csrw 0x9d7, x3

    #Address 0x9d7 read value
    csrr x14, 0x9d7

    #Unmapped address 0x3cf testing: random write/read operations
    #Address 0x3cf read value
    csrr x14, 0x3cf

    #Address 0x3cf Write value 0xf24250b7
    li x3, 0xf24250b7
    csrw 0x3cf, x3

    #Address 0x3cf Write value 0xcc6fd520
    li x3, 0xcc6fd520
    csrw 0x3cf, x3

    #Unmapped address 0xbeb testing: random write/read operations
    #Address 0xbeb Write value 0x287680a9
    li x3, 0x287680a9
    csrw 0xbeb, x3

    #Address 0xbeb read value
    csrr x14, 0xbeb

    #Address 0xbeb Write value 0x91e2dde2
    li x3, 0x91e2dde2
    csrw 0xbeb, x3

    #Address 0xbeb Write value 0xaf294e5e
    li x3, 0xaf294e5e
    csrw 0xbeb, x3

    #Address 0xbeb Write value 0xe1961096
    li x3, 0xe1961096
    csrw 0xbeb, x3

    #Unmapped address 0x1f5 testing: random write/read operations
    #Address 0x1f5 read value
    csrr x14, 0x1f5

    #Address 0x1f5 Write value 0xeca7a41e
    li x3, 0xeca7a41e
    csrw 0x1f5, x3

    #Address 0x1f5 Write value 0xa567749
    li x3, 0xa567749
    csrw 0x1f5, x3

    #Address 0x1f5 read value
    csrr x14, 0x1f5

    #Address 0x1f5 read value
    csrr x14, 0x1f5

    #Unmapped address 0xb7c testing: random write/read operations
    #Address 0xb7c Write value 0xfd540a6d
    li x3, 0xfd540a6d
    csrw 0xb7c, x3

    #Address 0xb7c read value
    csrr x14, 0xb7c

    #Unmapped address 0x78e testing: random write/read operations
    #Address 0x78e read value
    csrr x14, 0x78e

    #Address 0x78e Write value 0x3fe75f00
    li x3, 0x3fe75f00
    csrw 0x78e, x3

    #Address 0x78e Write value 0x8650a505
    li x3, 0x8650a505
    csrw 0x78e, x3

    #Address 0x78e Write value 0x8a2cdb03
    li x3, 0x8a2cdb03
    csrw 0x78e, x3

    #Unmapped address 0x2c9 testing: random write/read operations
    #Address 0x2c9 Write value 0x426cc37f
    li x3, 0x426cc37f
    csrw 0x2c9, x3

    #Unmapped address 0xd testing: random write/read operations
    #Address 0xd read value
    csrr x14, 0xd

    #Address 0xd Write value 0x4d61e4ef
    li x3, 0x4d61e4ef
    csrw 0xd, x3

    #Address 0xd read value
    csrr x14, 0xd

    #Address 0xd read value
    csrr x14, 0xd

    #Address 0xd Write value 0x1c2306c0
    li x3, 0x1c2306c0
    csrw 0xd, x3

    #Unmapped address 0x97e testing: random write/read operations
    #Address 0x97e read value
    csrr x14, 0x97e

    #Address 0x97e read value
    csrr x14, 0x97e

    #Unmapped address 0x6d0 testing: random write/read operations
    #Address 0x6d0 Write value 0x3c88ab54
    li x3, 0x3c88ab54
    csrw 0x6d0, x3

    #Address 0x6d0 read value
    csrr x14, 0x6d0

    #Unmapped address 0x92d testing: random write/read operations
    #Address 0x92d read value
    csrr x14, 0x92d

    #Address 0x92d read value
    csrr x14, 0x92d

    #Address 0x92d Write value 0xe2904cf6
    li x3, 0xe2904cf6
    csrw 0x92d, x3

    #Unmapped address 0x530 testing: random write/read operations
    #Address 0x530 read value
    csrr x14, 0x530

    #Address 0x530 read value
    csrr x14, 0x530

    #Address 0x530 Write value 0x4c2e6357
    li x3, 0x4c2e6357
    csrw 0x530, x3

    #Address 0x530 Write value 0xe5a5c146
    li x3, 0xe5a5c146
    csrw 0x530, x3

    #Address 0x530 Write value 0x8af21b3c
    li x3, 0x8af21b3c
    csrw 0x530, x3

    #Unmapped address 0xdd7 testing: random write/read operations
    #Address 0xdd7 read value
    csrr x14, 0xdd7

    #Unmapped address 0x778 testing: random write/read operations
    #Address 0x778 read value
    csrr x14, 0x778

    #Unmapped address 0xa0e testing: random write/read operations
    #Address 0xa0e Write value 0x85e35b1a
    li x3, 0x85e35b1a
    csrw 0xa0e, x3

    #Address 0xa0e read value
    csrr x14, 0xa0e

    #Address 0xa0e read value
    csrr x14, 0xa0e

    #Address 0xa0e Write value 0x419db7a6
    li x3, 0x419db7a6
    csrw 0xa0e, x3

    #Address 0xa0e Write value 0xaaeacc81
    li x3, 0xaaeacc81
    csrw 0xa0e, x3

    #Unmapped address 0x67c testing: random write/read operations
    #Address 0x67c Write value 0x732208e5
    li x3, 0x732208e5
    csrw 0x67c, x3

    #Unmapped address 0x916 testing: random write/read operations
    #Address 0x916 read value
    csrr x14, 0x916

    #Unmapped address 0x181 testing: random write/read operations
    #Address 0x181 read value
    csrr x14, 0x181

    #Address 0x181 Write value 0x58631715
    li x3, 0x58631715
    csrw 0x181, x3

    #Address 0x181 read value
    csrr x14, 0x181

    #Address 0x181 Write value 0xb80bb3b3
    li x3, 0xb80bb3b3
    csrw 0x181, x3

    #Unmapped address 0xfd1 testing: random write/read operations
    #Address 0xfd1 Write value 0x2297f7d9
    li x3, 0x2297f7d9
    csrw 0xfd1, x3

    #Address 0xfd1 Write value 0x86c3ed52
    li x3, 0x86c3ed52
    csrw 0xfd1, x3

    #Address 0xfd1 Write value 0xbe29902e
    li x3, 0xbe29902e
    csrw 0xfd1, x3

    #Unmapped address 0x5ff testing: random write/read operations
    #Address 0x5ff read value
    csrr x14, 0x5ff

    #Unmapped address 0x6c6 testing: random write/read operations
    #Address 0x6c6 read value
    csrr x14, 0x6c6

    #Address 0x6c6 Write value 0x69db0ae6
    li x3, 0x69db0ae6
    csrw 0x6c6, x3

    #Unmapped address 0xa83 testing: random write/read operations
    #Address 0xa83 read value
    csrr x14, 0xa83

    #Address 0xa83 Write value 0xdf4178b9
    li x3, 0xdf4178b9
    csrw 0xa83, x3

    #Address 0xa83 Write value 0xfcfe388f
    li x3, 0xfcfe388f
    csrw 0xa83, x3

    #Address 0xa83 read value
    csrr x14, 0xa83

    #Unmapped address 0xc98 testing: random write/read operations
    #Address 0xc98 Write value 0xbf8c2563
    li x3, 0xbf8c2563
    csrw 0xc98, x3

    #Address 0xc98 Write value 0xb2e20505
    li x3, 0xb2e20505
    csrw 0xc98, x3

    #Address 0xc98 read value
    csrr x14, 0xc98

    #Address 0xc98 Write value 0xcdad8dd9
    li x3, 0xcdad8dd9
    csrw 0xc98, x3

    #Unmapped address 0xf4 testing: random write/read operations
    #Address 0xf4 Write value 0x1d1921be
    li x3, 0x1d1921be
    csrw 0xf4, x3

    #Address 0xf4 read value
    csrr x14, 0xf4

    #Address 0xf4 read value
    csrr x14, 0xf4

    #Mapped address 0xc00 (cycle) testing: random write/read operations
    #Address 0xc00 read value
    csrr x14, 0xc00

    #Address 0xc00 read value
    csrr x14, 0xc00

    #Address 0xc00 Write value 0x8842f65c
    li x3, 0x8842f65c
    csrw 0xc00, x3

    #Unmapped address 0xe88 testing: random write/read operations
    #Address 0xe88 read value
    csrr x14, 0xe88

    #Address 0xe88 Write value 0x168458c2
    li x3, 0x168458c2
    csrw 0xe88, x3

    #Address 0xe88 read value
    csrr x14, 0xe88

    #Unmapped address 0x10e testing: random write/read operations
    #Address 0x10e read value
    csrr x14, 0x10e

    #Address 0x10e Write value 0x14036ed7
    li x3, 0x14036ed7
    csrw 0x10e, x3

    #Unmapped address 0x53a testing: random write/read operations
    #Address 0x53a read value
    csrr x14, 0x53a

    #Address 0x53a read value
    csrr x14, 0x53a

    #Address 0x53a Write value 0xb7f170be
    li x3, 0xb7f170be
    csrw 0x53a, x3

    #Address 0x53a Write value 0x8302c514
    li x3, 0x8302c514
    csrw 0x53a, x3

    #Unmapped address 0x482 testing: random write/read operations
    #Address 0x482 read value
    csrr x14, 0x482

    #Address 0x482 Write value 0x2c099629
    li x3, 0x2c099629
    csrw 0x482, x3

    #Address 0x482 Write value 0x8e6b515
    li x3, 0x8e6b515
    csrw 0x482, x3

    #Unmapped address 0x7fa testing: random write/read operations
    #Address 0x7fa read value
    csrr x14, 0x7fa

    #Address 0x7fa Write value 0xf5c4c1
    li x3, 0xf5c4c1
    csrw 0x7fa, x3

    #Address 0x7fa Write value 0x91d1bc81
    li x3, 0x91d1bc81
    csrw 0x7fa, x3

    #Unmapped address 0xafe testing: random write/read operations
    #Address 0xafe read value
    csrr x14, 0xafe

    #Address 0xafe Write value 0x47c509f6
    li x3, 0x47c509f6
    csrw 0xafe, x3

    #Address 0xafe read value
    csrr x14, 0xafe

    #Address 0xafe read value
    csrr x14, 0xafe

    #Unmapped address 0x988 testing: random write/read operations
    #Address 0x988 Write value 0x68be9fd2
    li x3, 0x68be9fd2
    csrw 0x988, x3

    #Address 0x988 read value
    csrr x14, 0x988

    #Address 0x988 Write value 0x753a0f53
    li x3, 0x753a0f53
    csrw 0x988, x3

    #Address 0x988 read value
    csrr x14, 0x988

    #Address 0x988 read value
    csrr x14, 0x988

    #Unmapped address 0x622 testing: random write/read operations
    #Address 0x622 Write value 0x9938131f
    li x3, 0x9938131f
    csrw 0x622, x3

    #Address 0x622 Write value 0x10a2053e
    li x3, 0x10a2053e
    csrw 0x622, x3

    #Unmapped address 0xe14 testing: random write/read operations
    #Address 0xe14 Write value 0xed3be280
    li x3, 0xed3be280
    csrw 0xe14, x3

    #Address 0xe14 Write value 0x5c4522c5
    li x3, 0x5c4522c5
    csrw 0xe14, x3

    #Unmapped address 0xa79 testing: random write/read operations
    #Address 0xa79 read value
    csrr x14, 0xa79

    #Unmapped address 0x808 testing: random write/read operations
    #Address 0x808 Write value 0xe6133d80
    li x3, 0xe6133d80
    csrw 0x808, x3

    #Address 0x808 Write value 0x37972f00
    li x3, 0x37972f00
    csrw 0x808, x3

    #Address 0x808 read value
    csrr x14, 0x808

    #Address 0x808 Write value 0xb924e6f0
    li x3, 0xb924e6f0
    csrw 0x808, x3

    #Unmapped address 0x13 testing: random write/read operations
    #Address 0x13 Write value 0x333368a
    li x3, 0x333368a
    csrw 0x13, x3

    #Address 0x13 Write value 0xb015160c
    li x3, 0xb015160c
    csrw 0x13, x3

    #Unmapped address 0xf7d testing: random write/read operations
    #Address 0xf7d Write value 0xb16ca249
    li x3, 0xb16ca249
    csrw 0xf7d, x3

    #Address 0xf7d read value
    csrr x14, 0xf7d

    #Unmapped address 0xd77 testing: random write/read operations
    #Address 0xd77 Write value 0x75e8483f
    li x3, 0x75e8483f
    csrw 0xd77, x3

    #Address 0xd77 Write value 0x1e6af511
    li x3, 0x1e6af511
    csrw 0xd77, x3

    #Address 0xd77 read value
    csrr x14, 0xd77

    #Address 0xd77 Write value 0x978110bc
    li x3, 0x978110bc
    csrw 0xd77, x3

    #Unmapped address 0x260 testing: random write/read operations
    #Address 0x260 Write value 0xc5a4125d
    li x3, 0xc5a4125d
    csrw 0x260, x3

    #Unmapped address 0x613 testing: random write/read operations
    #Address 0x613 read value
    csrr x14, 0x613

    #Unmapped address 0x7d1 testing: random write/read operations
    #Address 0x7d1 read value
    csrr x14, 0x7d1

    #Unmapped address 0x14c testing: random write/read operations
    #Address 0x14c Write value 0xa9c2d9ef
    li x3, 0xa9c2d9ef
    csrw 0x14c, x3

    #Address 0x14c Write value 0xfc6f6960
    li x3, 0xfc6f6960
    csrw 0x14c, x3

    #Address 0x14c read value
    csrr x14, 0x14c

    #Address 0x14c read value
    csrr x14, 0x14c

    #Address 0x14c Write value 0xf28adc23
    li x3, 0xf28adc23
    csrw 0x14c, x3

    #Unmapped address 0xc8f testing: random write/read operations
    #Address 0xc8f Write value 0x91ff3edd
    li x3, 0x91ff3edd
    csrw 0xc8f, x3

    #Address 0xc8f Write value 0xdfc4f7f6
    li x3, 0xdfc4f7f6
    csrw 0xc8f, x3

    #Unmapped address 0x1b testing: random write/read operations
    #Address 0x1b Write value 0xb0829e89
    li x3, 0xb0829e89
    csrw 0x1b, x3

    #Address 0x1b Write value 0x8480ac69
    li x3, 0x8480ac69
    csrw 0x1b, x3

    #Unmapped address 0x1f7 testing: random write/read operations
    #Address 0x1f7 Write value 0x7459580a
    li x3, 0x7459580a
    csrw 0x1f7, x3

    #Address 0x1f7 Write value 0x2a925a77
    li x3, 0x2a925a77
    csrw 0x1f7, x3

    #Address 0x1f7 Write value 0xaec771fe
    li x3, 0xaec771fe
    csrw 0x1f7, x3

    #Address 0x1f7 Write value 0x7ee78f74
    li x3, 0x7ee78f74
    csrw 0x1f7, x3

    #Address 0x1f7 Write value 0xe12723c4
    li x3, 0xe12723c4
    csrw 0x1f7, x3

    #Unmapped address 0xbca testing: random write/read operations
    #Address 0xbca read value
    csrr x14, 0xbca

    #Address 0xbca Write value 0xf6c23023
    li x3, 0xf6c23023
    csrw 0xbca, x3

    #Address 0xbca Write value 0xbc671b21
    li x3, 0xbc671b21
    csrw 0xbca, x3

    #Address 0xbca read value
    csrr x14, 0xbca

    #Unmapped address 0xf85 testing: random write/read operations
    #Address 0xf85 Write value 0x63792eec
    li x3, 0x63792eec
    csrw 0xf85, x3

    #Address 0xf85 Write value 0x6cf32fd3
    li x3, 0x6cf32fd3
    csrw 0xf85, x3

    #Unmapped address 0x43b testing: random write/read operations
    #Address 0x43b Write value 0xc3e636b8
    li x3, 0xc3e636b8
    csrw 0x43b, x3

    #Address 0x43b Write value 0x5acb06b9
    li x3, 0x5acb06b9
    csrw 0x43b, x3

    #Address 0x43b Write value 0x997eb18c
    li x3, 0x997eb18c
    csrw 0x43b, x3

    #Unmapped address 0x345 testing: random write/read operations
    #Address 0x345 read value
    csrr x14, 0x345

    #Address 0x345 Write value 0x11763417
    li x3, 0x11763417
    csrw 0x345, x3

    #Address 0x345 read value
    csrr x14, 0x345

    #Unmapped address 0xa3a testing: random write/read operations
    #Address 0xa3a Write value 0x57dd365e
    li x3, 0x57dd365e
    csrw 0xa3a, x3

    #Address 0xa3a read value
    csrr x14, 0xa3a

    #Address 0xa3a Write value 0xb56313c6
    li x3, 0xb56313c6
    csrw 0xa3a, x3

    #Address 0xa3a read value
    csrr x14, 0xa3a

    #Unmapped address 0x38 testing: random write/read operations
    #Address 0x38 Write value 0x90640fc
    li x3, 0x90640fc
    csrw 0x38, x3

    #Address 0x38 read value
    csrr x14, 0x38

    #Address 0x38 read value
    csrr x14, 0x38

    #Address 0x38 read value
    csrr x14, 0x38

    #Address 0x38 read value
    csrr x14, 0x38

    #Unmapped address 0xfe1 testing: random write/read operations
    #Address 0xfe1 Write value 0xa77adcec
    li x3, 0xa77adcec
    csrw 0xfe1, x3

    #Address 0xfe1 read value
    csrr x14, 0xfe1

    #Address 0xfe1 read value
    csrr x14, 0xfe1

    #Unmapped address 0xc0a testing: random write/read operations
    #Address 0xc0a read value
    csrr x14, 0xc0a

    #Address 0xc0a Write value 0xe51878e7
    li x3, 0xe51878e7
    csrw 0xc0a, x3

    #Address 0xc0a Write value 0xe2156c6e
    li x3, 0xe2156c6e
    csrw 0xc0a, x3

    #Address 0xc0a Write value 0x4c84dfa7
    li x3, 0x4c84dfa7
    csrw 0xc0a, x3

    #Unmapped address 0xa44 testing: random write/read operations
    #Address 0xa44 read value
    csrr x14, 0xa44

    #Address 0xa44 Write value 0x32f73ef0
    li x3, 0x32f73ef0
    csrw 0xa44, x3

    #Address 0xa44 Write value 0xc33d52a3
    li x3, 0xc33d52a3
    csrw 0xa44, x3

    #Address 0xa44 read value
    csrr x14, 0xa44

    #Address 0xa44 read value
    csrr x14, 0xa44

    #Unmapped address 0x4d9 testing: random write/read operations
    #Address 0x4d9 read value
    csrr x14, 0x4d9

    #Address 0x4d9 read value
    csrr x14, 0x4d9

    #Address 0x4d9 read value
    csrr x14, 0x4d9

    #Mapped address 0x342 (mcause) testing: random write/read operations
    #Address 0x342 Write value 0x69b2f1d9
    li x3, 0x69b2f1d9
    csrw 0x342, x3

    #Address 0x342 Write value 0x519b2eba
    li x3, 0x519b2eba
    csrw 0x342, x3

    #Unmapped address 0x25b testing: random write/read operations
    #Address 0x25b Write value 0x3816ce88
    li x3, 0x3816ce88
    csrw 0x25b, x3

    #Address 0x25b read value
    csrr x14, 0x25b

    #Address 0x25b read value
    csrr x14, 0x25b

    #Address 0x25b read value
    csrr x14, 0x25b

    #Unmapped address 0x441 testing: random write/read operations
    #Address 0x441 Write value 0xb1fbc1dd
    li x3, 0xb1fbc1dd
    csrw 0x441, x3

    #Address 0x441 read value
    csrr x14, 0x441

    #Address 0x441 read value
    csrr x14, 0x441

    #Address 0x441 read value
    csrr x14, 0x441

    #Address 0x441 Write value 0x228b7a52
    li x3, 0x228b7a52
    csrw 0x441, x3

    #Unmapped address 0x63 testing: random write/read operations
    #Address 0x63 read value
    csrr x14, 0x63

    #Address 0x63 Write value 0xc721dddf
    li x3, 0xc721dddf
    csrw 0x63, x3

    #Unmapped address 0xf96 testing: random write/read operations
    #Address 0xf96 read value
    csrr x14, 0xf96

    #Address 0xf96 Write value 0xa8e210e6
    li x3, 0xa8e210e6
    csrw 0xf96, x3

    #Address 0xf96 Write value 0xcd2ff333
    li x3, 0xcd2ff333
    csrw 0xf96, x3

    #Address 0xf96 Write value 0xc71877a5
    li x3, 0xc71877a5
    csrw 0xf96, x3

    #Unmapped address 0xc14 testing: random write/read operations
    #Address 0xc14 read value
    csrr x14, 0xc14

    #Address 0xc14 read value
    csrr x14, 0xc14

    #Address 0xc14 Write value 0xef2d5e5a
    li x3, 0xef2d5e5a
    csrw 0xc14, x3

    #Address 0xc14 read value
    csrr x14, 0xc14

    #Unmapped address 0x66 testing: random write/read operations
    #Address 0x66 read value
    csrr x14, 0x66

    #Address 0x66 Write value 0x8ea913bf
    li x3, 0x8ea913bf
    csrw 0x66, x3

    #Address 0x66 read value
    csrr x14, 0x66

    #Address 0x66 read value
    csrr x14, 0x66

    #Address 0x66 read value
    csrr x14, 0x66

    #Unmapped address 0xe2b testing: random write/read operations
    #Address 0xe2b Write value 0xa9c84307
    li x3, 0xa9c84307
    csrw 0xe2b, x3

    #Address 0xe2b Write value 0x29ad9cf5
    li x3, 0x29ad9cf5
    csrw 0xe2b, x3

    #Address 0xe2b read value
    csrr x14, 0xe2b

    #Unmapped address 0xe83 testing: random write/read operations
    #Address 0xe83 read value
    csrr x14, 0xe83

    #Address 0xe83 read value
    csrr x14, 0xe83

    #Address 0xe83 Write value 0xc50fc15b
    li x3, 0xc50fc15b
    csrw 0xe83, x3

    #Address 0xe83 Write value 0xef5c7c60
    li x3, 0xef5c7c60
    csrw 0xe83, x3

    #Address 0xe83 Write value 0xbb9a3dd7
    li x3, 0xbb9a3dd7
    csrw 0xe83, x3

    #Unmapped address 0xa6c testing: random write/read operations
    #Address 0xa6c read value
    csrr x14, 0xa6c

    #Address 0xa6c Write value 0x32fac378
    li x3, 0x32fac378
    csrw 0xa6c, x3

    #Unmapped address 0xa2e testing: random write/read operations
    #Address 0xa2e Write value 0x6eacf8e4
    li x3, 0x6eacf8e4
    csrw 0xa2e, x3

    #Address 0xa2e Write value 0x84d1e87b
    li x3, 0x84d1e87b
    csrw 0xa2e, x3

    #Address 0xa2e read value
    csrr x14, 0xa2e

    #Unmapped address 0xb38 testing: random write/read operations
    #Address 0xb38 read value
    csrr x14, 0xb38

    #Unmapped address 0xf4e testing: random write/read operations
    #Address 0xf4e read value
    csrr x14, 0xf4e

    #Address 0xf4e read value
    csrr x14, 0xf4e

    #Address 0xf4e Write value 0xd3f680bd
    li x3, 0xd3f680bd
    csrw 0xf4e, x3

    #Address 0xf4e read value
    csrr x14, 0xf4e

    #Mapped address 0xb03 (mhpmcounter3) testing: random write/read operations
    #Address 0xb03 read value
    csrr x14, 0xb03

    #Address 0xb03 Write value 0x78aca4ee
    li x3, 0x78aca4ee
    csrw 0xb03, x3

    #Unmapped address 0x4a2 testing: random write/read operations
    #Address 0x4a2 read value
    csrr x14, 0x4a2

    #Address 0x4a2 Write value 0xee42b66c
    li x3, 0xee42b66c
    csrw 0x4a2, x3

    #Unmapped address 0x48c testing: random write/read operations
    #Address 0x48c Write value 0x49335509
    li x3, 0x49335509
    csrw 0x48c, x3

    #Address 0x48c Write value 0x1ae94ea
    li x3, 0x1ae94ea
    csrw 0x48c, x3

    #Address 0x48c read value
    csrr x14, 0x48c

    #Unmapped address 0x191 testing: random write/read operations
    #Address 0x191 read value
    csrr x14, 0x191

    #Address 0x191 read value
    csrr x14, 0x191

    #Unmapped address 0x43a testing: random write/read operations
    #Address 0x43a read value
    csrr x14, 0x43a

    #Address 0x43a read value
    csrr x14, 0x43a

    #Unmapped address 0xefc testing: random write/read operations
    #Address 0xefc Write value 0x6dc2b0e4
    li x3, 0x6dc2b0e4
    csrw 0xefc, x3

    #Address 0xefc read value
    csrr x14, 0xefc

    #Unmapped address 0x919 testing: random write/read operations
    #Address 0x919 Write value 0xb8fe6476
    li x3, 0xb8fe6476
    csrw 0x919, x3

    #Unmapped address 0x993 testing: random write/read operations
    #Address 0x993 Write value 0x77e29d1b
    li x3, 0x77e29d1b
    csrw 0x993, x3

    #Address 0x993 read value
    csrr x14, 0x993

    #Address 0x993 Write value 0x6d9a4ef6
    li x3, 0x6d9a4ef6
    csrw 0x993, x3

    #Address 0x993 Write value 0xf9c5fa58
    li x3, 0xf9c5fa58
    csrw 0x993, x3

    #Address 0x993 read value
    csrr x14, 0x993

    #Unmapped address 0x968 testing: random write/read operations
    #Address 0x968 read value
    csrr x14, 0x968

    #Address 0x968 read value
    csrr x14, 0x968

    #Address 0x968 Write value 0x710bd732
    li x3, 0x710bd732
    csrw 0x968, x3

    #Address 0x968 Write value 0xfd367b02
    li x3, 0xfd367b02
    csrw 0x968, x3

    #Address 0x968 read value
    csrr x14, 0x968

    #Unmapped address 0xd2 testing: random write/read operations
    #Address 0xd2 Write value 0x287e8cff
    li x3, 0x287e8cff
    csrw 0xd2, x3

    #Address 0xd2 read value
    csrr x14, 0xd2

    #Address 0xd2 Write value 0x29653d5e
    li x3, 0x29653d5e
    csrw 0xd2, x3

    #Address 0xd2 read value
    csrr x14, 0xd2

    #Address 0xd2 Write value 0xcd9cf903
    li x3, 0xcd9cf903
    csrw 0xd2, x3

    #Mapped address 0x335 (mhpmevent21) testing: random write/read operations
    #Address 0x335 Write value 0xa8ff6abe
    li x3, 0xa8ff6abe
    csrw 0x335, x3

    #Unmapped address 0xc09 testing: random write/read operations
    #Address 0xc09 read value
    csrr x14, 0xc09

    #Address 0xc09 Write value 0xa9c66f55
    li x3, 0xa9c66f55
    csrw 0xc09, x3

    #Address 0xc09 Write value 0x7333e40a
    li x3, 0x7333e40a
    csrw 0xc09, x3

    #Address 0xc09 read value
    csrr x14, 0xc09

    #Unmapped address 0x38b testing: random write/read operations
    #Address 0x38b Write value 0xad59864
    li x3, 0xad59864
    csrw 0x38b, x3

    #Address 0x38b read value
    csrr x14, 0x38b

    #Address 0x38b read value
    csrr x14, 0x38b

    #Address 0x38b read value
    csrr x14, 0x38b

    #Unmapped address 0xd81 testing: random write/read operations
    #Address 0xd81 Write value 0x7a862267
    li x3, 0x7a862267
    csrw 0xd81, x3

    #Address 0xd81 Write value 0xee310a9f
    li x3, 0xee310a9f
    csrw 0xd81, x3

    #Address 0xd81 Write value 0xfddcfd7d
    li x3, 0xfddcfd7d
    csrw 0xd81, x3

    #Unmapped address 0xf16 testing: random write/read operations
    #Address 0xf16 Write value 0x4cdf3adc
    li x3, 0x4cdf3adc
    csrw 0xf16, x3

    #Address 0xf16 read value
    csrr x14, 0xf16

    #Address 0xf16 read value
    csrr x14, 0xf16

    #Address 0xf16 Write value 0x1241c3db
    li x3, 0x1241c3db
    csrw 0xf16, x3

    #Unmapped address 0x2f8 testing: random write/read operations
    #Address 0x2f8 Write value 0x43a67121
    li x3, 0x43a67121
    csrw 0x2f8, x3

    #Address 0x2f8 Write value 0xbef87279
    li x3, 0xbef87279
    csrw 0x2f8, x3

    #Address 0x2f8 read value
    csrr x14, 0x2f8

    #Address 0x2f8 Write value 0xbfa99391
    li x3, 0xbfa99391
    csrw 0x2f8, x3

    #Unmapped address 0xedb testing: random write/read operations
    #Address 0xedb Write value 0xb6049a09
    li x3, 0xb6049a09
    csrw 0xedb, x3

    #Address 0xedb Write value 0x1b314826
    li x3, 0x1b314826
    csrw 0xedb, x3

    #Address 0xedb read value
    csrr x14, 0xedb

    #Address 0xedb Write value 0xee440be
    li x3, 0xee440be
    csrw 0xedb, x3

    #Address 0xedb read value
    csrr x14, 0xedb

    #Mapped address 0x337 (mhpmevent23) testing: random write/read operations
    #Address 0x337 read value
    csrr x14, 0x337

    #Address 0x337 Write value 0x3eeea431
    li x3, 0x3eeea431
    csrw 0x337, x3

    #Unmapped address 0xed testing: random write/read operations
    #Address 0xed Write value 0xb5d8839d
    li x3, 0xb5d8839d
    csrw 0xed, x3

    #Address 0xed Write value 0x3c3dbb99
    li x3, 0x3c3dbb99
    csrw 0xed, x3

    #Unmapped address 0x36 testing: random write/read operations
    #Address 0x36 read value
    csrr x14, 0x36

    #Address 0x36 Write value 0xee8b5dc0
    li x3, 0xee8b5dc0
    csrw 0x36, x3

    #Address 0x36 Write value 0x617abfba
    li x3, 0x617abfba
    csrw 0x36, x3

    #Unmapped address 0x524 testing: random write/read operations
    #Address 0x524 Write value 0x72c54355
    li x3, 0x72c54355
    csrw 0x524, x3

    #Address 0x524 read value
    csrr x14, 0x524

    #Unmapped address 0xa59 testing: random write/read operations
    #Address 0xa59 Write value 0x63c73e00
    li x3, 0x63c73e00
    csrw 0xa59, x3

    #Unmapped address 0x2ab testing: random write/read operations
    #Address 0x2ab read value
    csrr x14, 0x2ab

    #Address 0x2ab Write value 0xf0ead26e
    li x3, 0xf0ead26e
    csrw 0x2ab, x3

    #Address 0x2ab Write value 0xb062b483
    li x3, 0xb062b483
    csrw 0x2ab, x3

    #Address 0x2ab Write value 0x21cd48c4
    li x3, 0x21cd48c4
    csrw 0x2ab, x3

    #Address 0x2ab read value
    csrr x14, 0x2ab

    #Unmapped address 0x3ad testing: random write/read operations
    #Address 0x3ad read value
    csrr x14, 0x3ad

    #Address 0x3ad Write value 0x563b1c84
    li x3, 0x563b1c84
    csrw 0x3ad, x3

    #Address 0x3ad read value
    csrr x14, 0x3ad

    #Address 0x3ad Write value 0xa33cd3ab
    li x3, 0xa33cd3ab
    csrw 0x3ad, x3

    #Address 0x3ad read value
    csrr x14, 0x3ad

    #Unmapped address 0x357 testing: random write/read operations
    #Address 0x357 read value
    csrr x14, 0x357

    #Unmapped address 0xccb testing: random write/read operations
    #Address 0xccb read value
    csrr x14, 0xccb

    #Unmapped address 0xf36 testing: random write/read operations
    #Address 0xf36 Write value 0xba75d1e1
    li x3, 0xba75d1e1
    csrw 0xf36, x3

    #Address 0xf36 Write value 0x13c73502
    li x3, 0x13c73502
    csrw 0xf36, x3

    #Address 0xf36 Write value 0x8aae2888
    li x3, 0x8aae2888
    csrw 0xf36, x3

    #Address 0xf36 Write value 0x4f2d4ae
    li x3, 0x4f2d4ae
    csrw 0xf36, x3

    #Address 0xf36 Write value 0x1463ece1
    li x3, 0x1463ece1
    csrw 0xf36, x3

    #Unmapped address 0x69d testing: random write/read operations
    #Address 0x69d Write value 0x12506374
    li x3, 0x12506374
    csrw 0x69d, x3

    #Address 0x69d Write value 0x9d9faf3f
    li x3, 0x9d9faf3f
    csrw 0x69d, x3

    #Unmapped address 0xc67 testing: random write/read operations
    #Address 0xc67 Write value 0x414eff71
    li x3, 0x414eff71
    csrw 0xc67, x3

    #Address 0xc67 Write value 0x3aaa8188
    li x3, 0x3aaa8188
    csrw 0xc67, x3

    #Address 0xc67 Write value 0xae0fd51
    li x3, 0xae0fd51
    csrw 0xc67, x3

    #Address 0xc67 read value
    csrr x14, 0xc67

    #Address 0xc67 read value
    csrr x14, 0xc67

    #Unmapped address 0x2a3 testing: random write/read operations
    #Address 0x2a3 Write value 0x28d89cb5
    li x3, 0x28d89cb5
    csrw 0x2a3, x3

    #Address 0x2a3 read value
    csrr x14, 0x2a3

    #Address 0x2a3 read value
    csrr x14, 0x2a3

    #Address 0x2a3 Write value 0x26d11b69
    li x3, 0x26d11b69
    csrw 0x2a3, x3

    #Unmapped address 0x236 testing: random write/read operations
    #Address 0x236 read value
    csrr x14, 0x236

    #Unmapped address 0xab0 testing: random write/read operations
    #Address 0xab0 Write value 0x58b1aa50
    li x3, 0x58b1aa50
    csrw 0xab0, x3

    #Unmapped address 0x6a1 testing: random write/read operations
    #Address 0x6a1 read value
    csrr x14, 0x6a1

    #Address 0x6a1 read value
    csrr x14, 0x6a1

    #Unmapped address 0x6c9 testing: random write/read operations
    #Address 0x6c9 read value
    csrr x14, 0x6c9

    #Unmapped address 0x88 testing: random write/read operations
    #Address 0x88 read value
    csrr x14, 0x88

    #Address 0x88 Write value 0xc36ef33a
    li x3, 0xc36ef33a
    csrw 0x88, x3

    #Address 0x88 Write value 0xc39ebf32
    li x3, 0xc39ebf32
    csrw 0x88, x3

    #Unmapped address 0xa29 testing: random write/read operations
    #Address 0xa29 read value
    csrr x14, 0xa29

    #Address 0xa29 read value
    csrr x14, 0xa29

    #Address 0xa29 read value
    csrr x14, 0xa29

    #Mapped address 0x3a3 (pmpcfg3) testing: random write/read operations
    #Address 0x3a3 read value
    csrr x14, 0x3a3

    #Address 0x3a3 read value
    csrr x14, 0x3a3

    #Unmapped address 0x948 testing: random write/read operations
    #Address 0x948 read value
    csrr x14, 0x948

    #Address 0x948 Write value 0x244a7191
    li x3, 0x244a7191
    csrw 0x948, x3

    #Address 0x948 read value
    csrr x14, 0x948

    #Unmapped address 0x75d testing: random write/read operations
    #Address 0x75d read value
    csrr x14, 0x75d

    #Unmapped address 0x64 testing: random write/read operations
    #Address 0x64 Write value 0x257bf279
    li x3, 0x257bf279
    csrw 0x64, x3

    #Address 0x64 Write value 0x70501d64
    li x3, 0x70501d64
    csrw 0x64, x3

    #Unmapped address 0xdfe testing: random write/read operations
    #Address 0xdfe Write value 0x373d78bf
    li x3, 0x373d78bf
    csrw 0xdfe, x3

    #Address 0xdfe Write value 0x596bb557
    li x3, 0x596bb557
    csrw 0xdfe, x3

    #Unmapped address 0xfe8 testing: random write/read operations
    #Address 0xfe8 read value
    csrr x14, 0xfe8

    #Address 0xfe8 read value
    csrr x14, 0xfe8

    #Address 0xfe8 Write value 0xc7cf28f6
    li x3, 0xc7cf28f6
    csrw 0xfe8, x3

    #Unmapped address 0x502 testing: random write/read operations
    #Address 0x502 Write value 0x8789e2a2
    li x3, 0x8789e2a2
    csrw 0x502, x3

    #Address 0x502 Write value 0x926b0851
    li x3, 0x926b0851
    csrw 0x502, x3

    #Unmapped address 0x16f testing: random write/read operations
    #Address 0x16f Write value 0xbdb9a02c
    li x3, 0xbdb9a02c
    csrw 0x16f, x3

    #Address 0x16f read value
    csrr x14, 0x16f

    #Address 0x16f Write value 0xe4ddc0e8
    li x3, 0xe4ddc0e8
    csrw 0x16f, x3

    #Address 0x16f read value
    csrr x14, 0x16f

    #Unmapped address 0x9da testing: random write/read operations
    #Address 0x9da read value
    csrr x14, 0x9da

    #Address 0x9da read value
    csrr x14, 0x9da

    #Address 0x9da read value
    csrr x14, 0x9da

    #Address 0x9da Write value 0x3add78b8
    li x3, 0x3add78b8
    csrw 0x9da, x3

    #Unmapped address 0x3da testing: random write/read operations
    #Address 0x3da read value
    csrr x14, 0x3da

    #Unmapped address 0xc60 testing: random write/read operations
    #Address 0xc60 read value
    csrr x14, 0xc60

    #Address 0xc60 Write value 0xd3370ef1
    li x3, 0xd3370ef1
    csrw 0xc60, x3

    #Unmapped address 0xf39 testing: random write/read operations
    #Address 0xf39 Write value 0x7c614308
    li x3, 0x7c614308
    csrw 0xf39, x3

    #Unmapped address 0x71c testing: random write/read operations
    #Address 0x71c Write value 0xbad39b70
    li x3, 0xbad39b70
    csrw 0x71c, x3

    #Address 0x71c Write value 0x51aef357
    li x3, 0x51aef357
    csrw 0x71c, x3

    #Address 0x71c read value
    csrr x14, 0x71c

    #Unmapped address 0xcb4 testing: random write/read operations
    #Address 0xcb4 read value
    csrr x14, 0xcb4

    #Address 0xcb4 read value
    csrr x14, 0xcb4

    #Unmapped address 0xb61 testing: random write/read operations
    #Address 0xb61 Write value 0x9951fce
    li x3, 0x9951fce
    csrw 0xb61, x3

    #Unmapped address 0x27 testing: random write/read operations
    #Address 0x27 Write value 0x1b2ed47a
    li x3, 0x1b2ed47a
    csrw 0x27, x3

    #Address 0x27 read value
    csrr x14, 0x27

    #Address 0x27 read value
    csrr x14, 0x27

    #Unmapped address 0x81 testing: random write/read operations
    #Address 0x81 read value
    csrr x14, 0x81

    #Address 0x81 read value
    csrr x14, 0x81

    #Address 0x81 Write value 0xc0654e07
    li x3, 0xc0654e07
    csrw 0x81, x3

    #Address 0x81 Write value 0x7ac17734
    li x3, 0x7ac17734
    csrw 0x81, x3

    #Address 0x81 read value
    csrr x14, 0x81

    #Unmapped address 0x757 testing: random write/read operations
    #Address 0x757 read value
    csrr x14, 0x757

    #Unmapped address 0x292 testing: random write/read operations
    #Address 0x292 Write value 0xf7a08d4d
    li x3, 0xf7a08d4d
    csrw 0x292, x3

    #Address 0x292 Write value 0x370b4053
    li x3, 0x370b4053
    csrw 0x292, x3

    #Address 0x292 read value
    csrr x14, 0x292

    #Address 0x292 read value
    csrr x14, 0x292

    #Address 0x292 Write value 0x9c2224cd
    li x3, 0x9c2224cd
    csrw 0x292, x3

    #Unmapped address 0x4f5 testing: random write/read operations
    #Address 0x4f5 Write value 0x5807b939
    li x3, 0x5807b939
    csrw 0x4f5, x3

    #Address 0x4f5 Write value 0x26f26b75
    li x3, 0x26f26b75
    csrw 0x4f5, x3

    #Address 0x4f5 read value
    csrr x14, 0x4f5

    #Address 0x4f5 read value
    csrr x14, 0x4f5

    #Unmapped address 0xdba testing: random write/read operations
    #Address 0xdba read value
    csrr x14, 0xdba

    #Address 0xdba Write value 0x38d3b1f4
    li x3, 0x38d3b1f4
    csrw 0xdba, x3

    #Address 0xdba read value
    csrr x14, 0xdba

    #Address 0xdba Write value 0xfeabda0c
    li x3, 0xfeabda0c
    csrw 0xdba, x3

    #Unmapped address 0x1eb testing: random write/read operations
    #Address 0x1eb Write value 0xf5f32b82
    li x3, 0xf5f32b82
    csrw 0x1eb, x3

    #Address 0x1eb Write value 0x4916d937
    li x3, 0x4916d937
    csrw 0x1eb, x3

    #Address 0x1eb Write value 0xec7213e1
    li x3, 0xec7213e1
    csrw 0x1eb, x3

    #Address 0x1eb Write value 0x5e01a840
    li x3, 0x5e01a840
    csrw 0x1eb, x3

    #Unmapped address 0x7b0 testing: random write/read operations
    #Address 0x7b0 read value
    csrr x14, 0x7b0

    #Address 0x7b0 read value
    csrr x14, 0x7b0

    #Address 0x7b0 Write value 0xe31c438f
    li x3, 0xe31c438f
    csrw 0x7b0, x3

    #Address 0x7b0 Write value 0x40317ae0
    li x3, 0x40317ae0
    csrw 0x7b0, x3

    #Unmapped address 0x408 testing: random write/read operations
    #Address 0x408 Write value 0x3d924a9a
    li x3, 0x3d924a9a
    csrw 0x408, x3

    #Address 0x408 read value
    csrr x14, 0x408

    #Unmapped address 0x6ca testing: random write/read operations
    #Address 0x6ca Write value 0xdebf55d6
    li x3, 0xdebf55d6
    csrw 0x6ca, x3

    #Address 0x6ca read value
    csrr x14, 0x6ca

    #Address 0x6ca read value
    csrr x14, 0x6ca

    #Address 0x6ca Write value 0x1ba44f6a
    li x3, 0x1ba44f6a
    csrw 0x6ca, x3

    #Address 0x6ca read value
    csrr x14, 0x6ca

    #Unmapped address 0x3c2 testing: random write/read operations
    #Address 0x3c2 read value
    csrr x14, 0x3c2

    #Address 0x3c2 Write value 0x7994597
    li x3, 0x7994597
    csrw 0x3c2, x3

    #Mapped address 0xb9c (mhpmcounterh28) testing: random write/read operations
    #Address 0xb9c read value
    csrr x14, 0xb9c

    #Unmapped address 0x6f3 testing: random write/read operations
    #Address 0x6f3 Write value 0xc4774b46
    li x3, 0xc4774b46
    csrw 0x6f3, x3

    #Address 0x6f3 Write value 0xb6c812e
    li x3, 0xb6c812e
    csrw 0x6f3, x3

    #Unmapped address 0x809 testing: random write/read operations
    #Address 0x809 read value
    csrr x14, 0x809

    #Address 0x809 Write value 0xebab6af
    li x3, 0xebab6af
    csrw 0x809, x3

    #Address 0x809 read value
    csrr x14, 0x809

    #Unmapped address 0xd2b testing: random write/read operations
    #Address 0xd2b Write value 0x21038266
    li x3, 0x21038266
    csrw 0xd2b, x3

    #Address 0xd2b read value
    csrr x14, 0xd2b

    #Address 0xd2b Write value 0x856e2796
    li x3, 0x856e2796
    csrw 0xd2b, x3

    #Address 0xd2b Write value 0x72cb7f1e
    li x3, 0x72cb7f1e
    csrw 0xd2b, x3

    #Address 0xd2b read value
    csrr x14, 0xd2b

    #Unmapped address 0xd4d testing: random write/read operations
    #Address 0xd4d Write value 0xa954fb1
    li x3, 0xa954fb1
    csrw 0xd4d, x3

    #Unmapped address 0x91b testing: random write/read operations
    #Address 0x91b read value
    csrr x14, 0x91b

    #Address 0x91b read value
    csrr x14, 0x91b

    #Address 0x91b read value
    csrr x14, 0x91b

    #Address 0x91b read value
    csrr x14, 0x91b

    #Unmapped address 0x6f1 testing: random write/read operations
    #Address 0x6f1 Write value 0x8f83d6e3
    li x3, 0x8f83d6e3
    csrw 0x6f1, x3

    #Address 0x6f1 Write value 0xcd36698c
    li x3, 0xcd36698c
    csrw 0x6f1, x3

    #Address 0x6f1 Write value 0xd14a3c91
    li x3, 0xd14a3c91
    csrw 0x6f1, x3

    #Address 0x6f1 Write value 0x8da77dca
    li x3, 0x8da77dca
    csrw 0x6f1, x3

    #Unmapped address 0x5ce testing: random write/read operations
    #Address 0x5ce read value
    csrr x14, 0x5ce

    #Address 0x5ce Write value 0xd7b11693
    li x3, 0xd7b11693
    csrw 0x5ce, x3

    #Address 0x5ce Write value 0x28d7c69f
    li x3, 0x28d7c69f
    csrw 0x5ce, x3

    #Unmapped address 0xa64 testing: random write/read operations
    #Address 0xa64 Write value 0xcbd90e5f
    li x3, 0xcbd90e5f
    csrw 0xa64, x3

    #Address 0xa64 read value
    csrr x14, 0xa64

    #Address 0xa64 read value
    csrr x14, 0xa64

    #Address 0xa64 Write value 0x3d356dfb
    li x3, 0x3d356dfb
    csrw 0xa64, x3

    #Unmapped address 0xd15 testing: random write/read operations
    #Address 0xd15 read value
    csrr x14, 0xd15

    #Address 0xd15 Write value 0x93ef27e6
    li x3, 0x93ef27e6
    csrw 0xd15, x3

    #Unmapped address 0x798 testing: random write/read operations
    #Address 0x798 Write value 0x40f7dada
    li x3, 0x40f7dada
    csrw 0x798, x3

    #Address 0x798 read value
    csrr x14, 0x798

    #Address 0x798 read value
    csrr x14, 0x798

    #Address 0x798 read value
    csrr x14, 0x798

    #Unmapped address 0xa6a testing: random write/read operations
    #Address 0xa6a Write value 0x787da3de
    li x3, 0x787da3de
    csrw 0xa6a, x3

    #Unmapped address 0xd86 testing: random write/read operations
    #Address 0xd86 Write value 0x3fcea3e5
    li x3, 0x3fcea3e5
    csrw 0xd86, x3

    #Address 0xd86 Write value 0xddea03fc
    li x3, 0xddea03fc
    csrw 0xd86, x3

    #Address 0xd86 read value
    csrr x14, 0xd86

    #Unmapped address 0x112 testing: random write/read operations
    #Address 0x112 read value
    csrr x14, 0x112

    #Unmapped address 0xa23 testing: random write/read operations
    #Address 0xa23 read value
    csrr x14, 0xa23

    #Address 0xa23 read value
    csrr x14, 0xa23

    #Address 0xa23 Write value 0xc0e29098
    li x3, 0xc0e29098
    csrw 0xa23, x3

    #Unmapped address 0x8db testing: random write/read operations
    #Address 0x8db Write value 0x4884a6ff
    li x3, 0x4884a6ff
    csrw 0x8db, x3

    #Unmapped address 0x515 testing: random write/read operations
    #Address 0x515 Write value 0x82f95f9f
    li x3, 0x82f95f9f
    csrw 0x515, x3

    #Unmapped address 0xbe6 testing: random write/read operations
    #Address 0xbe6 read value
    csrr x14, 0xbe6

    #Address 0xbe6 read value
    csrr x14, 0xbe6

    #Address 0xbe6 Write value 0x9cffb60
    li x3, 0x9cffb60
    csrw 0xbe6, x3

    #Address 0xbe6 read value
    csrr x14, 0xbe6

    #Address 0xbe6 Write value 0x30cb81a9
    li x3, 0x30cb81a9
    csrw 0xbe6, x3

    #Unmapped address 0x116 testing: random write/read operations
    #Address 0x116 Write value 0xf182b628
    li x3, 0xf182b628
    csrw 0x116, x3

    #Address 0x116 read value
    csrr x14, 0x116

    #Address 0x116 Write value 0xeb1a5250
    li x3, 0xeb1a5250
    csrw 0x116, x3

    #Unmapped address 0x9b2 testing: random write/read operations
    #Address 0x9b2 Write value 0x91892b96
    li x3, 0x91892b96
    csrw 0x9b2, x3

    #Unmapped address 0x435 testing: random write/read operations
    #Address 0x435 Write value 0x2120d178
    li x3, 0x2120d178
    csrw 0x435, x3

    #Address 0x435 read value
    csrr x14, 0x435

    #Unmapped address 0x110 testing: random write/read operations
    #Address 0x110 read value
    csrr x14, 0x110

    #Address 0x110 Write value 0x7ebdcc98
    li x3, 0x7ebdcc98
    csrw 0x110, x3

    #Address 0x110 read value
    csrr x14, 0x110

    #Unmapped address 0xbe9 testing: random write/read operations
    #Address 0xbe9 Write value 0x16f72379
    li x3, 0x16f72379
    csrw 0xbe9, x3

    #Address 0xbe9 Write value 0x31a11248
    li x3, 0x31a11248
    csrw 0xbe9, x3

    #Address 0xbe9 read value
    csrr x14, 0xbe9

    #Address 0xbe9 read value
    csrr x14, 0xbe9

    #Address 0xbe9 Write value 0x706c310
    li x3, 0x706c310
    csrw 0xbe9, x3

    #Unmapped address 0xdec testing: random write/read operations
    #Address 0xdec Write value 0xd40547ad
    li x3, 0xd40547ad
    csrw 0xdec, x3

    #Address 0xdec Write value 0x1e795ce6
    li x3, 0x1e795ce6
    csrw 0xdec, x3

    #Address 0xdec read value
    csrr x14, 0xdec

    #Unmapped address 0xe8f testing: random write/read operations
    #Address 0xe8f read value
    csrr x14, 0xe8f

    #Unmapped address 0x82f testing: random write/read operations
    #Address 0x82f Write value 0xd4ac0e4f
    li x3, 0xd4ac0e4f
    csrw 0x82f, x3

    #Address 0x82f Write value 0x69e43a37
    li x3, 0x69e43a37
    csrw 0x82f, x3

    #Address 0x82f Write value 0xd0f2f427
    li x3, 0xd0f2f427
    csrw 0x82f, x3

    #Address 0x82f read value
    csrr x14, 0x82f

    #Unmapped address 0x25 testing: random write/read operations
    #Address 0x25 read value
    csrr x14, 0x25

    #Unmapped address 0x259 testing: random write/read operations
    #Address 0x259 Write value 0x498b67d1
    li x3, 0x498b67d1
    csrw 0x259, x3

    #Unmapped address 0x8c8 testing: random write/read operations
    #Address 0x8c8 Write value 0xf95c7cd2
    li x3, 0xf95c7cd2
    csrw 0x8c8, x3

    #Unmapped address 0x675 testing: random write/read operations
    #Address 0x675 read value
    csrr x14, 0x675

    #Address 0x675 read value
    csrr x14, 0x675

    #Address 0x675 Write value 0x646b675f
    li x3, 0x646b675f
    csrw 0x675, x3

    #Address 0x675 read value
    csrr x14, 0x675

    #Address 0x675 Write value 0xfb056fe6
    li x3, 0xfb056fe6
    csrw 0x675, x3

    #Unmapped address 0xd99 testing: random write/read operations
    #Address 0xd99 read value
    csrr x14, 0xd99

    #Address 0xd99 read value
    csrr x14, 0xd99

    #Address 0xd99 Write value 0x50119f27
    li x3, 0x50119f27
    csrw 0xd99, x3

    #Address 0xd99 Write value 0x2b5e8609
    li x3, 0x2b5e8609
    csrw 0xd99, x3

    #Unmapped address 0x62e testing: random write/read operations
    #Address 0x62e read value
    csrr x14, 0x62e

    #Address 0x62e Write value 0x8636a341
    li x3, 0x8636a341
    csrw 0x62e, x3

    #Address 0x62e read value
    csrr x14, 0x62e

    #Address 0x62e read value
    csrr x14, 0x62e

    #Mapped address 0xb1f (mhpmcounter31) testing: random write/read operations
    #Address 0xb1f Write value 0x492fcded
    li x3, 0x492fcded
    csrw 0xb1f, x3

    #Address 0xb1f read value
    csrr x14, 0xb1f

    #Address 0xb1f read value
    csrr x14, 0xb1f

    #Address 0xb1f Write value 0x3c2015b4
    li x3, 0x3c2015b4
    csrw 0xb1f, x3

    #Address 0xb1f Write value 0x50a7cecb
    li x3, 0x50a7cecb
    csrw 0xb1f, x3

    #Unmapped address 0xed3 testing: random write/read operations
    #Address 0xed3 read value
    csrr x14, 0xed3

    #Address 0xed3 Write value 0x6568de3
    li x3, 0x6568de3
    csrw 0xed3, x3

    #Address 0xed3 read value
    csrr x14, 0xed3

    #Address 0xed3 read value
    csrr x14, 0xed3

    #Unmapped address 0x777 testing: random write/read operations
    #Address 0x777 Write value 0x10feefef
    li x3, 0x10feefef
    csrw 0x777, x3

    #Address 0x777 Write value 0xb7d77c64
    li x3, 0xb7d77c64
    csrw 0x777, x3

    #Address 0x777 read value
    csrr x14, 0x777

    #Address 0x777 Write value 0x528398e9
    li x3, 0x528398e9
    csrw 0x777, x3

    #Address 0x777 Write value 0x24ebb1b7
    li x3, 0x24ebb1b7
    csrw 0x777, x3

    #Unmapped address 0xdf6 testing: random write/read operations
    #Address 0xdf6 Write value 0xb3c51aef
    li x3, 0xb3c51aef
    csrw 0xdf6, x3

    #Address 0xdf6 read value
    csrr x14, 0xdf6

    #Unmapped address 0x44a testing: random write/read operations
    #Address 0x44a Write value 0x103a723b
    li x3, 0x103a723b
    csrw 0x44a, x3

    #Address 0x44a read value
    csrr x14, 0x44a

    #Address 0x44a Write value 0x6e01824f
    li x3, 0x6e01824f
    csrw 0x44a, x3

    #Address 0x44a read value
    csrr x14, 0x44a

    #Unmapped address 0x766 testing: random write/read operations
    #Address 0x766 read value
    csrr x14, 0x766

    #Address 0x766 read value
    csrr x14, 0x766

    #Address 0x766 Write value 0xd1f3c2fd
    li x3, 0xd1f3c2fd
    csrw 0x766, x3

    #Address 0x766 read value
    csrr x14, 0x766

    #Unmapped address 0xaa3 testing: random write/read operations
    #Address 0xaa3 read value
    csrr x14, 0xaa3

    #Address 0xaa3 read value
    csrr x14, 0xaa3

    #Address 0xaa3 read value
    csrr x14, 0xaa3

    #Address 0xaa3 read value
    csrr x14, 0xaa3

    #Address 0xaa3 read value
    csrr x14, 0xaa3

    #Unmapped address 0x9d2 testing: random write/read operations
    #Address 0x9d2 read value
    csrr x14, 0x9d2

    #Address 0x9d2 Write value 0x11fbbab4
    li x3, 0x11fbbab4
    csrw 0x9d2, x3

    #Address 0x9d2 read value
    csrr x14, 0x9d2

    #Address 0x9d2 Write value 0x16918da1
    li x3, 0x16918da1
    csrw 0x9d2, x3

    #Address 0x9d2 read value
    csrr x14, 0x9d2

    #Mapped address 0xb89 (mhpmcounterh9) testing: random write/read operations
    #Address 0xb89 Write value 0x84c70b5
    li x3, 0x84c70b5
    csrw 0xb89, x3

    #Address 0xb89 read value
    csrr x14, 0xb89

    #Address 0xb89 read value
    csrr x14, 0xb89

    #Unmapped address 0xbd3 testing: random write/read operations
    #Address 0xbd3 read value
    csrr x14, 0xbd3

    #Address 0xbd3 read value
    csrr x14, 0xbd3

    #Address 0xbd3 read value
    csrr x14, 0xbd3

    #Unmapped address 0xe01 testing: random write/read operations
    #Address 0xe01 read value
    csrr x14, 0xe01

    #Address 0xe01 Write value 0x3ed3515b
    li x3, 0x3ed3515b
    csrw 0xe01, x3

    #Unmapped address 0xbf3 testing: random write/read operations
    #Address 0xbf3 read value
    csrr x14, 0xbf3

    #Address 0xbf3 Write value 0x3491a7e5
    li x3, 0x3491a7e5
    csrw 0xbf3, x3

    #Unmapped address 0xe3c testing: random write/read operations
    #Address 0xe3c read value
    csrr x14, 0xe3c

    #Address 0xe3c Write value 0x1bc5168a
    li x3, 0x1bc5168a
    csrw 0xe3c, x3

    #Address 0xe3c read value
    csrr x14, 0xe3c

    #Address 0xe3c read value
    csrr x14, 0xe3c

    #Address 0xe3c read value
    csrr x14, 0xe3c

    #Unmapped address 0xe5c testing: random write/read operations
    #Address 0xe5c read value
    csrr x14, 0xe5c

    #Address 0xe5c read value
    csrr x14, 0xe5c

    #Unmapped address 0xaca testing: random write/read operations
    #Address 0xaca read value
    csrr x14, 0xaca

    #Address 0xaca read value
    csrr x14, 0xaca

    #Unmapped address 0xf5d testing: random write/read operations
    #Address 0xf5d read value
    csrr x14, 0xf5d

    #Address 0xf5d Write value 0xccf3be72
    li x3, 0xccf3be72
    csrw 0xf5d, x3

    #Address 0xf5d Write value 0x55e7c582
    li x3, 0x55e7c582
    csrw 0xf5d, x3

    #Address 0xf5d read value
    csrr x14, 0xf5d

    #Address 0xf5d Write value 0xfdeae2b1
    li x3, 0xfdeae2b1
    csrw 0xf5d, x3

    #Unmapped address 0x3f5 testing: random write/read operations
    #Address 0x3f5 Write value 0x13bfcbfb
    li x3, 0x13bfcbfb
    csrw 0x3f5, x3

    #Address 0x3f5 read value
    csrr x14, 0x3f5

    #Address 0x3f5 Write value 0xa3ec18d0
    li x3, 0xa3ec18d0
    csrw 0x3f5, x3

    #Address 0x3f5 Write value 0xf8025f91
    li x3, 0xf8025f91
    csrw 0x3f5, x3

    #Unmapped address 0xb3 testing: random write/read operations
    #Address 0xb3 read value
    csrr x14, 0xb3

    #Unmapped address 0x79c testing: random write/read operations
    #Address 0x79c read value
    csrr x14, 0x79c

    #Address 0x79c Write value 0x16f12322
    li x3, 0x16f12322
    csrw 0x79c, x3

    #Address 0x79c read value
    csrr x14, 0x79c

    #Unmapped address 0x71d testing: random write/read operations
    #Address 0x71d read value
    csrr x14, 0x71d

    #Address 0x71d read value
    csrr x14, 0x71d

    #Address 0x71d read value
    csrr x14, 0x71d

    #Address 0x71d read value
    csrr x14, 0x71d

    #Unmapped address 0x512 testing: random write/read operations
    #Address 0x512 read value
    csrr x14, 0x512

    #Address 0x512 read value
    csrr x14, 0x512

    #Unmapped address 0xe82 testing: random write/read operations
    #Address 0xe82 Write value 0xd831db1d
    li x3, 0xd831db1d
    csrw 0xe82, x3

    #Address 0xe82 read value
    csrr x14, 0xe82

    #Unmapped address 0xa37 testing: random write/read operations
    #Address 0xa37 read value
    csrr x14, 0xa37

    #Address 0xa37 Write value 0xe672e0d5
    li x3, 0xe672e0d5
    csrw 0xa37, x3

    #Address 0xa37 Write value 0x9239d3ef
    li x3, 0x9239d3ef
    csrw 0xa37, x3

    #Address 0xa37 read value
    csrr x14, 0xa37

    #Address 0xa37 Write value 0x2bc19508
    li x3, 0x2bc19508
    csrw 0xa37, x3

    #Unmapped address 0x29 testing: random write/read operations
    #Address 0x29 read value
    csrr x14, 0x29

    #Address 0x29 Write value 0x32d5d82a
    li x3, 0x32d5d82a
    csrw 0x29, x3

    #Address 0x29 Write value 0xb36a5e5f
    li x3, 0xb36a5e5f
    csrw 0x29, x3

    #Address 0x29 Write value 0xd835e75d
    li x3, 0xd835e75d
    csrw 0x29, x3

    #Unmapped address 0xa85 testing: random write/read operations
    #Address 0xa85 Write value 0xcdf1b3f3
    li x3, 0xcdf1b3f3
    csrw 0xa85, x3

    #Unmapped address 0xf3b testing: random write/read operations
    #Address 0xf3b Write value 0xab966e4c
    li x3, 0xab966e4c
    csrw 0xf3b, x3

    #Address 0xf3b read value
    csrr x14, 0xf3b

    #Address 0xf3b Write value 0x2551d89e
    li x3, 0x2551d89e
    csrw 0xf3b, x3

    #Address 0xf3b Write value 0x55dd4e00
    li x3, 0x55dd4e00
    csrw 0xf3b, x3

    #Unmapped address 0x257 testing: random write/read operations
    #Address 0x257 read value
    csrr x14, 0x257

    #Address 0x257 Write value 0x2bc71d31
    li x3, 0x2bc71d31
    csrw 0x257, x3

    #Unmapped address 0xbf6 testing: random write/read operations
    #Address 0xbf6 read value
    csrr x14, 0xbf6

    #Address 0xbf6 Write value 0xc11af383
    li x3, 0xc11af383
    csrw 0xbf6, x3

    #Address 0xbf6 read value
    csrr x14, 0xbf6

    #Address 0xbf6 read value
    csrr x14, 0xbf6

    #Unmapped address 0xd8d testing: random write/read operations
    #Address 0xd8d read value
    csrr x14, 0xd8d

    #Address 0xd8d read value
    csrr x14, 0xd8d

    #Address 0xd8d Write value 0x4fe4f1e2
    li x3, 0x4fe4f1e2
    csrw 0xd8d, x3

    #Address 0xd8d Write value 0x9e56144d
    li x3, 0x9e56144d
    csrw 0xd8d, x3

    #Address 0xd8d Write value 0xe0421e19
    li x3, 0xe0421e19
    csrw 0xd8d, x3

    #Unmapped address 0x958 testing: random write/read operations
    #Address 0x958 Write value 0x7a2bc11f
    li x3, 0x7a2bc11f
    csrw 0x958, x3

    #Address 0x958 Write value 0xd676e3df
    li x3, 0xd676e3df
    csrw 0x958, x3

    #Address 0x958 read value
    csrr x14, 0x958

    #Address 0x958 Write value 0x86ea5f8
    li x3, 0x86ea5f8
    csrw 0x958, x3

    #Unmapped address 0x6f8 testing: random write/read operations
    #Address 0x6f8 read value
    csrr x14, 0x6f8

    #Address 0x6f8 Write value 0xda2c13d9
    li x3, 0xda2c13d9
    csrw 0x6f8, x3

    #Address 0x6f8 read value
    csrr x14, 0x6f8

    #Address 0x6f8 Write value 0x6f3852f5
    li x3, 0x6f3852f5
    csrw 0x6f8, x3

    #Address 0x6f8 read value
    csrr x14, 0x6f8

    #Unmapped address 0xfb7 testing: random write/read operations
    #Address 0xfb7 Write value 0x2cd73d72
    li x3, 0x2cd73d72
    csrw 0xfb7, x3

    #Address 0xfb7 read value
    csrr x14, 0xfb7

    #Address 0xfb7 Write value 0xc17dda1
    li x3, 0xc17dda1
    csrw 0xfb7, x3

    #Address 0xfb7 read value
    csrr x14, 0xfb7

    #Unmapped address 0x16d testing: random write/read operations
    #Address 0x16d read value
    csrr x14, 0x16d

    #Address 0x16d Write value 0xcb2d63e9
    li x3, 0xcb2d63e9
    csrw 0x16d, x3

    #Unmapped address 0xe85 testing: random write/read operations
    #Address 0xe85 Write value 0xb0aeb1b9
    li x3, 0xb0aeb1b9
    csrw 0xe85, x3

    #Address 0xe85 Write value 0x56dad7a0
    li x3, 0x56dad7a0
    csrw 0xe85, x3

    #Address 0xe85 read value
    csrr x14, 0xe85

    #Address 0xe85 Write value 0xaeedf0bd
    li x3, 0xaeedf0bd
    csrw 0xe85, x3

    #Address 0xe85 read value
    csrr x14, 0xe85

    #Unmapped address 0x275 testing: random write/read operations
    #Address 0x275 Write value 0x10575bc5
    li x3, 0x10575bc5
    csrw 0x275, x3

    #Address 0x275 read value
    csrr x14, 0x275

    #Address 0x275 read value
    csrr x14, 0x275

    #Address 0x275 read value
    csrr x14, 0x275

    #Unmapped address 0x89e testing: random write/read operations
    #Address 0x89e Write value 0x56e58716
    li x3, 0x56e58716
    csrw 0x89e, x3

    #Address 0x89e Write value 0x63b20738
    li x3, 0x63b20738
    csrw 0x89e, x3

    #Address 0x89e Write value 0xb1681ebd
    li x3, 0xb1681ebd
    csrw 0x89e, x3

    #Address 0x89e read value
    csrr x14, 0x89e

    #Address 0x89e Write value 0x4d2dc9fc
    li x3, 0x4d2dc9fc
    csrw 0x89e, x3

    #Unmapped address 0xed0 testing: random write/read operations
    #Address 0xed0 read value
    csrr x14, 0xed0

    #Address 0xed0 read value
    csrr x14, 0xed0

    #Address 0xed0 read value
    csrr x14, 0xed0

    #Address 0xed0 read value
    csrr x14, 0xed0

    #Address 0xed0 read value
    csrr x14, 0xed0

    #Unmapped address 0x507 testing: random write/read operations
    #Address 0x507 read value
    csrr x14, 0x507

    #Address 0x507 read value
    csrr x14, 0x507

    #Address 0x507 Write value 0xe553ff6d
    li x3, 0xe553ff6d
    csrw 0x507, x3

    #Unmapped address 0x83c testing: random write/read operations
    #Address 0x83c Write value 0xf898cea8
    li x3, 0xf898cea8
    csrw 0x83c, x3

    #Address 0x83c Write value 0x8024dc51
    li x3, 0x8024dc51
    csrw 0x83c, x3

    #Address 0x83c Write value 0x98e15fde
    li x3, 0x98e15fde
    csrw 0x83c, x3

    #Address 0x83c Write value 0xe8d7bca7
    li x3, 0xe8d7bca7
    csrw 0x83c, x3

    #Address 0x83c read value
    csrr x14, 0x83c

    #Unmapped address 0x875 testing: random write/read operations
    #Address 0x875 read value
    csrr x14, 0x875

    #Address 0x875 Write value 0xf7ec1e2b
    li x3, 0xf7ec1e2b
    csrw 0x875, x3

    #Address 0x875 Write value 0x265db807
    li x3, 0x265db807
    csrw 0x875, x3

    #Unmapped address 0x4d7 testing: random write/read operations
    #Address 0x4d7 read value
    csrr x14, 0x4d7

    #Address 0x4d7 Write value 0xd407f71e
    li x3, 0xd407f71e
    csrw 0x4d7, x3

    #Address 0x4d7 Write value 0xb41cc64c
    li x3, 0xb41cc64c
    csrw 0x4d7, x3

    #Address 0x4d7 Write value 0x3f8aeddb
    li x3, 0x3f8aeddb
    csrw 0x4d7, x3

    #Unmapped address 0x11 testing: random write/read operations
    #Address 0x11 read value
    csrr x14, 0x11

    #Address 0x11 Write value 0x1a4f665c
    li x3, 0x1a4f665c
    csrw 0x11, x3

    #Address 0x11 Write value 0x1646317b
    li x3, 0x1646317b
    csrw 0x11, x3

    #Mapped address 0x341 (mepc) testing: random write/read operations
    #Address 0x341 Write value 0xaff366bf
    li x3, 0xaff366bf
    csrw 0x341, x3

    #Unmapped address 0xed2 testing: random write/read operations
    #Address 0xed2 Write value 0xaef896d1
    li x3, 0xaef896d1
    csrw 0xed2, x3

    #Address 0xed2 Write value 0x664b1bc6
    li x3, 0x664b1bc6
    csrw 0xed2, x3

    #Unmapped address 0xe7 testing: random write/read operations
    #Address 0xe7 read value
    csrr x14, 0xe7

    #Address 0xe7 Write value 0x5969dee
    li x3, 0x5969dee
    csrw 0xe7, x3

    #Unmapped address 0x103 testing: random write/read operations
    #Address 0x103 Write value 0x18e56f01
    li x3, 0x18e56f01
    csrw 0x103, x3

    #Address 0x103 Write value 0x5f525927
    li x3, 0x5f525927
    csrw 0x103, x3

    #Address 0x103 Write value 0x4d63c4a3
    li x3, 0x4d63c4a3
    csrw 0x103, x3

    #Address 0x103 Write value 0xa530a77
    li x3, 0xa530a77
    csrw 0x103, x3

    #Address 0x103 read value
    csrr x14, 0x103

    #Unmapped address 0x556 testing: random write/read operations
    #Address 0x556 read value
    csrr x14, 0x556

    #Address 0x556 Write value 0xa667a7
    li x3, 0xa667a7
    csrw 0x556, x3

    #Address 0x556 read value
    csrr x14, 0x556

    #Address 0x556 read value
    csrr x14, 0x556

    #Address 0x556 Write value 0x24b5bc0
    li x3, 0x24b5bc0
    csrw 0x556, x3

    #Unmapped address 0xaf2 testing: random write/read operations
    #Address 0xaf2 read value
    csrr x14, 0xaf2

    #Address 0xaf2 Write value 0x8616535b
    li x3, 0x8616535b
    csrw 0xaf2, x3

    #Address 0xaf2 read value
    csrr x14, 0xaf2

    #Address 0xaf2 read value
    csrr x14, 0xaf2

    #Unmapped address 0x85b testing: random write/read operations
    #Address 0x85b read value
    csrr x14, 0x85b

    #Address 0x85b read value
    csrr x14, 0x85b

    #Address 0x85b Write value 0x159d36e9
    li x3, 0x159d36e9
    csrw 0x85b, x3

    #Address 0x85b Write value 0x32d6c58b
    li x3, 0x32d6c58b
    csrw 0x85b, x3

    #Address 0x85b read value
    csrr x14, 0x85b

    #Unmapped address 0xc68 testing: random write/read operations
    #Address 0xc68 Write value 0x22695f64
    li x3, 0x22695f64
    csrw 0xc68, x3

    #Address 0xc68 read value
    csrr x14, 0xc68

    #Unmapped address 0xabd testing: random write/read operations
    #Address 0xabd read value
    csrr x14, 0xabd

    #Unmapped address 0x17f testing: random write/read operations
    #Address 0x17f read value
    csrr x14, 0x17f

    #Address 0x17f read value
    csrr x14, 0x17f

    #Address 0x17f read value
    csrr x14, 0x17f

    #Address 0x17f read value
    csrr x14, 0x17f

    #Address 0x17f Write value 0x76e9c08b
    li x3, 0x76e9c08b
    csrw 0x17f, x3

    #Unmapped address 0xada testing: random write/read operations
    #Address 0xada read value
    csrr x14, 0xada

    #Address 0xada read value
    csrr x14, 0xada

    #Unmapped address 0x755 testing: random write/read operations
    #Address 0x755 Write value 0x9621ea8c
    li x3, 0x9621ea8c
    csrw 0x755, x3

    #Address 0x755 read value
    csrr x14, 0x755

    #Address 0x755 read value
    csrr x14, 0x755

    #Unmapped address 0xd5a testing: random write/read operations
    #Address 0xd5a read value
    csrr x14, 0xd5a

    #Unmapped address 0xf72 testing: random write/read operations
    #Address 0xf72 Write value 0xb21d934c
    li x3, 0xb21d934c
    csrw 0xf72, x3

    #Address 0xf72 Write value 0xeb9fbc66
    li x3, 0xeb9fbc66
    csrw 0xf72, x3

    #Address 0xf72 Write value 0xb065385d
    li x3, 0xb065385d
    csrw 0xf72, x3

    #Address 0xf72 Write value 0xe7bbe6aa
    li x3, 0xe7bbe6aa
    csrw 0xf72, x3

    #Address 0xf72 read value
    csrr x14, 0xf72

    #Unmapped address 0x96d testing: random write/read operations
    #Address 0x96d read value
    csrr x14, 0x96d

    #Address 0x96d read value
    csrr x14, 0x96d

    #Unmapped address 0x77e testing: random write/read operations
    #Address 0x77e Write value 0x3a23378f
    li x3, 0x3a23378f
    csrw 0x77e, x3

    #Address 0x77e Write value 0xa2a56705
    li x3, 0xa2a56705
    csrw 0x77e, x3

    #Address 0x77e read value
    csrr x14, 0x77e

    #Address 0x77e read value
    csrr x14, 0x77e

    #Address 0x77e Write value 0x4a1d89e8
    li x3, 0x4a1d89e8
    csrw 0x77e, x3

    #Unmapped address 0x95b testing: random write/read operations
    #Address 0x95b read value
    csrr x14, 0x95b

    #Unmapped address 0xa3e testing: random write/read operations
    #Address 0xa3e read value
    csrr x14, 0xa3e

    #Unmapped address 0xbc9 testing: random write/read operations
    #Address 0xbc9 read value
    csrr x14, 0xbc9

    #Address 0xbc9 Write value 0x91d9db75
    li x3, 0x91d9db75
    csrw 0xbc9, x3

    #Address 0xbc9 Write value 0x1945558b
    li x3, 0x1945558b
    csrw 0xbc9, x3

    #Address 0xbc9 Write value 0xb8807207
    li x3, 0xb8807207
    csrw 0xbc9, x3

    #Address 0xbc9 Write value 0x1a70d387
    li x3, 0x1a70d387
    csrw 0xbc9, x3

    #Unmapped address 0xd07 testing: random write/read operations
    #Address 0xd07 Write value 0x22f04338
    li x3, 0x22f04338
    csrw 0xd07, x3

    #Unmapped address 0x164 testing: random write/read operations
    #Address 0x164 Write value 0x602ba1f5
    li x3, 0x602ba1f5
    csrw 0x164, x3

    #Address 0x164 Write value 0xea27f023
    li x3, 0xea27f023
    csrw 0x164, x3

    #Address 0x164 read value
    csrr x14, 0x164

    #Unmapped address 0xf1d testing: random write/read operations
    #Address 0xf1d read value
    csrr x14, 0xf1d

    #Address 0xf1d read value
    csrr x14, 0xf1d

    #Address 0xf1d Write value 0x14649eb4
    li x3, 0x14649eb4
    csrw 0xf1d, x3

    #Address 0xf1d Write value 0x38399abd
    li x3, 0x38399abd
    csrw 0xf1d, x3

    #Address 0xf1d read value
    csrr x14, 0xf1d

    #Mapped address 0x328 (mhpmevent8) testing: random write/read operations
    #Address 0x328 read value
    csrr x14, 0x328

    #Unmapped address 0xa2f testing: random write/read operations
    #Address 0xa2f read value
    csrr x14, 0xa2f

    #Address 0xa2f Write value 0x3427968d
    li x3, 0x3427968d
    csrw 0xa2f, x3

    #Address 0xa2f read value
    csrr x14, 0xa2f

    #Unmapped address 0x2ec testing: random write/read operations
    #Address 0x2ec Write value 0xe962d3fa
    li x3, 0xe962d3fa
    csrw 0x2ec, x3

    #Address 0x2ec Write value 0x3f2b499d
    li x3, 0x3f2b499d
    csrw 0x2ec, x3

    #Mapped address 0x3b8 (pmpaddr8) testing: random write/read operations
    #Address 0x3b8 read value
    csrr x14, 0x3b8

    #Address 0x3b8 Write value 0x4a89c681
    li x3, 0x4a89c681
    csrw 0x3b8, x3

    #Address 0x3b8 read value
    csrr x14, 0x3b8

    #Address 0x3b8 read value
    csrr x14, 0x3b8

    #Unmapped address 0xb5c testing: random write/read operations
    #Address 0xb5c read value
    csrr x14, 0xb5c

    #Address 0xb5c Write value 0xf8991ea7
    li x3, 0xf8991ea7
    csrw 0xb5c, x3

    #Address 0xb5c read value
    csrr x14, 0xb5c

    #Address 0xb5c read value
    csrr x14, 0xb5c

    #Unmapped address 0x378 testing: random write/read operations
    #Address 0x378 Write value 0xd5c39c5f
    li x3, 0xd5c39c5f
    csrw 0x378, x3

    #Unmapped address 0xa94 testing: random write/read operations
    #Address 0xa94 read value
    csrr x14, 0xa94

    #Address 0xa94 read value
    csrr x14, 0xa94

    #Address 0xa94 read value
    csrr x14, 0xa94

    #Unmapped address 0x2b1 testing: random write/read operations
    #Address 0x2b1 read value
    csrr x14, 0x2b1

    #Address 0x2b1 read value
    csrr x14, 0x2b1

    #Unmapped address 0x118 testing: random write/read operations
    #Address 0x118 read value
    csrr x14, 0x118

    #Address 0x118 read value
    csrr x14, 0x118

    #Address 0x118 read value
    csrr x14, 0x118

    #Address 0x118 Write value 0x1bb6dfaa
    li x3, 0x1bb6dfaa
    csrw 0x118, x3

    #Unmapped address 0x575 testing: random write/read operations
    #Address 0x575 Write value 0x18e16941
    li x3, 0x18e16941
    csrw 0x575, x3

    #Address 0x575 read value
    csrr x14, 0x575

    #Address 0x575 Write value 0x64deb4b5
    li x3, 0x64deb4b5
    csrw 0x575, x3

    #Address 0x575 read value
    csrr x14, 0x575

    #Unmapped address 0x619 testing: random write/read operations
    #Address 0x619 read value
    csrr x14, 0x619

    #Address 0x619 read value
    csrr x14, 0x619

    #Unmapped address 0x49f testing: random write/read operations
    #Address 0x49f Write value 0xf16099e8
    li x3, 0xf16099e8
    csrw 0x49f, x3

    #Mapped address 0xb9e (mhpmcounterh30) testing: random write/read operations
    #Address 0xb9e read value
    csrr x14, 0xb9e

    #Unmapped address 0x6b2 testing: random write/read operations
    #Address 0x6b2 Write value 0xc29abc29
    li x3, 0xc29abc29
    csrw 0x6b2, x3

    #Address 0x6b2 Write value 0xcb316528
    li x3, 0xcb316528
    csrw 0x6b2, x3

    #Address 0x6b2 Write value 0x22ec5113
    li x3, 0x22ec5113
    csrw 0x6b2, x3

    #Address 0x6b2 read value
    csrr x14, 0x6b2

    #Unmapped address 0x12c testing: random write/read operations
    #Address 0x12c read value
    csrr x14, 0x12c

    #Address 0x12c Write value 0x142149cf
    li x3, 0x142149cf
    csrw 0x12c, x3

    #Address 0x12c Write value 0x4a559f2e
    li x3, 0x4a559f2e
    csrw 0x12c, x3

    #Unmapped address 0x600 testing: random write/read operations
    #Address 0x600 Write value 0x4bb507e9
    li x3, 0x4bb507e9
    csrw 0x600, x3

    #Address 0x600 read value
    csrr x14, 0x600

    #Address 0x600 read value
    csrr x14, 0x600

    #Address 0x600 Write value 0x42117f4
    li x3, 0x42117f4
    csrw 0x600, x3

    #Unmapped address 0xde8 testing: random write/read operations
    #Address 0xde8 read value
    csrr x14, 0xde8

    #Address 0xde8 read value
    csrr x14, 0xde8

    #Unmapped address 0xa96 testing: random write/read operations
    #Address 0xa96 Write value 0x935d648c
    li x3, 0x935d648c
    csrw 0xa96, x3

    #Address 0xa96 Write value 0x8020ae9c
    li x3, 0x8020ae9c
    csrw 0xa96, x3

    #Unmapped address 0x133 testing: random write/read operations
    #Address 0x133 read value
    csrr x14, 0x133

    #Address 0x133 Write value 0xb6922499
    li x3, 0xb6922499
    csrw 0x133, x3

    #Address 0x133 read value
    csrr x14, 0x133

    #Address 0x133 Write value 0x6c3512fe
    li x3, 0x6c3512fe
    csrw 0x133, x3

    #Unmapped address 0xe4f testing: random write/read operations
    #Address 0xe4f Write value 0x813f4498
    li x3, 0x813f4498
    csrw 0xe4f, x3

    #Address 0xe4f read value
    csrr x14, 0xe4f

    #Address 0xe4f Write value 0x5c739828
    li x3, 0x5c739828
    csrw 0xe4f, x3

    #Address 0xe4f read value
    csrr x14, 0xe4f

    #Unmapped address 0xeff testing: random write/read operations
    #Address 0xeff Write value 0x4f54f7a7
    li x3, 0x4f54f7a7
    csrw 0xeff, x3

    #Address 0xeff Write value 0xce0964b3
    li x3, 0xce0964b3
    csrw 0xeff, x3

    #Address 0xeff Write value 0x9accc22f
    li x3, 0x9accc22f
    csrw 0xeff, x3

    #Unmapped address 0xc6 testing: random write/read operations
    #Address 0xc6 Write value 0xef8119a
    li x3, 0xef8119a
    csrw 0xc6, x3

    #Address 0xc6 read value
    csrr x14, 0xc6

    #Unmapped address 0x68 testing: random write/read operations
    #Address 0x68 read value
    csrr x14, 0x68

    #Address 0x68 read value
    csrr x14, 0x68

    #Unmapped address 0xf34 testing: random write/read operations
    #Address 0xf34 read value
    csrr x14, 0xf34

    #Address 0xf34 Write value 0x44787643
    li x3, 0x44787643
    csrw 0xf34, x3

    #Address 0xf34 read value
    csrr x14, 0xf34

    #Address 0xf34 Write value 0x87c27ac2
    li x3, 0x87c27ac2
    csrw 0xf34, x3

    #Address 0xf34 read value
    csrr x14, 0xf34

    #Unmapped address 0x186 testing: random write/read operations
    #Address 0x186 Write value 0x27d8c7db
    li x3, 0x27d8c7db
    csrw 0x186, x3

    #Address 0x186 read value
    csrr x14, 0x186

    #Address 0x186 Write value 0x230f54af
    li x3, 0x230f54af
    csrw 0x186, x3

    #Unmapped address 0x82 testing: random write/read operations
    #Address 0x82 read value
    csrr x14, 0x82

    #Address 0x82 Write value 0x1e23cce9
    li x3, 0x1e23cce9
    csrw 0x82, x3

    #Address 0x82 Write value 0x3cc2383
    li x3, 0x3cc2383
    csrw 0x82, x3

    #Unmapped address 0x30c testing: random write/read operations
    #Address 0x30c Write value 0xfa5bee62
    li x3, 0xfa5bee62
    csrw 0x30c, x3

    #Address 0x30c Write value 0x1546dc37
    li x3, 0x1546dc37
    csrw 0x30c, x3

    #Unmapped address 0x68a testing: random write/read operations
    #Address 0x68a read value
    csrr x14, 0x68a

    #Address 0x68a Write value 0x3d463f54
    li x3, 0x3d463f54
    csrw 0x68a, x3

    #Address 0x68a read value
    csrr x14, 0x68a

    #Unmapped address 0x704 testing: random write/read operations
    #Address 0x704 Write value 0x3dbfa983
    li x3, 0x3dbfa983
    csrw 0x704, x3

    #Address 0x704 read value
    csrr x14, 0x704

    #Address 0x704 Write value 0x8750fc13
    li x3, 0x8750fc13
    csrw 0x704, x3

    #Unmapped address 0x4f8 testing: random write/read operations
    #Address 0x4f8 Write value 0x8535460c
    li x3, 0x8535460c
    csrw 0x4f8, x3

    #Address 0x4f8 read value
    csrr x14, 0x4f8

    #Address 0x4f8 read value
    csrr x14, 0x4f8

    #Address 0x4f8 Write value 0xbae034c
    li x3, 0xbae034c
    csrw 0x4f8, x3

    #Address 0x4f8 Write value 0xc73c1427
    li x3, 0xc73c1427
    csrw 0x4f8, x3

    #Unmapped address 0x80a testing: random write/read operations
    #Address 0x80a Write value 0xc03ee740
    li x3, 0xc03ee740
    csrw 0x80a, x3

    #Unmapped address 0x2 testing: random write/read operations
    #Address 0x2 Write value 0x28f1cd78
    li x3, 0x28f1cd78
    csrw 0x2, x3

    #Address 0x2 Write value 0xa5e9e500
    li x3, 0xa5e9e500
    csrw 0x2, x3

    #Address 0x2 Write value 0x57e1f16d
    li x3, 0x57e1f16d
    csrw 0x2, x3

    #Unmapped address 0x92c testing: random write/read operations
    #Address 0x92c Write value 0xcecae423
    li x3, 0xcecae423
    csrw 0x92c, x3

    #Address 0x92c Write value 0x3899d7e3
    li x3, 0x3899d7e3
    csrw 0x92c, x3

    #Address 0x92c read value
    csrr x14, 0x92c

    #Unmapped address 0x998 testing: random write/read operations
    #Address 0x998 read value
    csrr x14, 0x998

    #Address 0x998 read value
    csrr x14, 0x998

    #Unmapped address 0x4dd testing: random write/read operations
    #Address 0x4dd read value
    csrr x14, 0x4dd

    #Address 0x4dd Write value 0x7a0c837f
    li x3, 0x7a0c837f
    csrw 0x4dd, x3

    #Address 0x4dd Write value 0xbcc2e2d4
    li x3, 0xbcc2e2d4
    csrw 0x4dd, x3

    #Unmapped address 0xe51 testing: random write/read operations
    #Address 0xe51 read value
    csrr x14, 0xe51

    #Address 0xe51 read value
    csrr x14, 0xe51

    #Address 0xe51 read value
    csrr x14, 0xe51

    #Address 0xe51 read value
    csrr x14, 0xe51

    #Unmapped address 0xeae testing: random write/read operations
    #Address 0xeae read value
    csrr x14, 0xeae

    #Address 0xeae Write value 0xefee52fe
    li x3, 0xefee52fe
    csrw 0xeae, x3

    #Unmapped address 0xfcb testing: random write/read operations
    #Address 0xfcb Write value 0xc2e7564c
    li x3, 0xc2e7564c
    csrw 0xfcb, x3

    #Address 0xfcb Write value 0x552ad1df
    li x3, 0x552ad1df
    csrw 0xfcb, x3

    #Address 0xfcb read value
    csrr x14, 0xfcb

    #Address 0xfcb read value
    csrr x14, 0xfcb

    #Unmapped address 0xb48 testing: random write/read operations
    #Address 0xb48 Write value 0xbc1d9340
    li x3, 0xbc1d9340
    csrw 0xb48, x3

    #Unmapped address 0x2b0 testing: random write/read operations
    #Address 0x2b0 read value
    csrr x14, 0x2b0

    #Unmapped address 0xc6a testing: random write/read operations
    #Address 0xc6a Write value 0xaf6f2693
    li x3, 0xaf6f2693
    csrw 0xc6a, x3

    #Address 0xc6a Write value 0x1d151bbc
    li x3, 0x1d151bbc
    csrw 0xc6a, x3

    #Unmapped address 0x604 testing: random write/read operations
    #Address 0x604 Write value 0x27660ff6
    li x3, 0x27660ff6
    csrw 0x604, x3

    #Unmapped address 0x7c4 testing: random write/read operations
    #Address 0x7c4 Write value 0x35389698
    li x3, 0x35389698
    csrw 0x7c4, x3

    #Address 0x7c4 Write value 0xe540a3a9
    li x3, 0xe540a3a9
    csrw 0x7c4, x3

    #Address 0x7c4 Write value 0xbb2388f
    li x3, 0xbb2388f
    csrw 0x7c4, x3

    #Unmapped address 0x1ee testing: random write/read operations
    #Address 0x1ee Write value 0xc6f27ee3
    li x3, 0xc6f27ee3
    csrw 0x1ee, x3

    #Address 0x1ee read value
    csrr x14, 0x1ee

    #Address 0x1ee read value
    csrr x14, 0x1ee

    #Address 0x1ee Write value 0xf26a59b1
    li x3, 0xf26a59b1
    csrw 0x1ee, x3

    #Unmapped address 0xb46 testing: random write/read operations
    #Address 0xb46 read value
    csrr x14, 0xb46

    #Address 0xb46 read value
    csrr x14, 0xb46

    #Address 0xb46 Write value 0x72bec0fa
    li x3, 0x72bec0fa
    csrw 0xb46, x3

    #Address 0xb46 read value
    csrr x14, 0xb46

    #Unmapped address 0xcf6 testing: random write/read operations
    #Address 0xcf6 read value
    csrr x14, 0xcf6

    #Unmapped address 0x971 testing: random write/read operations
    #Address 0x971 read value
    csrr x14, 0x971

    #Address 0x971 read value
    csrr x14, 0x971

    #Unmapped address 0x5c4 testing: random write/read operations
    #Address 0x5c4 read value
    csrr x14, 0x5c4

    #Unmapped address 0x63e testing: random write/read operations
    #Address 0x63e read value
    csrr x14, 0x63e

    #Address 0x63e Write value 0x55e1f8e0
    li x3, 0x55e1f8e0
    csrw 0x63e, x3

    #Unmapped address 0x917 testing: random write/read operations
    #Address 0x917 Write value 0x6fe73987
    li x3, 0x6fe73987
    csrw 0x917, x3

    #Address 0x917 Write value 0x9f47d37e
    li x3, 0x9f47d37e
    csrw 0x917, x3

    #Address 0x917 Write value 0x8e32dea1
    li x3, 0x8e32dea1
    csrw 0x917, x3

    #Address 0x917 Write value 0x1ed73f6a
    li x3, 0x1ed73f6a
    csrw 0x917, x3

    #Address 0x917 Write value 0xa15d5860
    li x3, 0xa15d5860
    csrw 0x917, x3

    #Unmapped address 0xe62 testing: random write/read operations
    #Address 0xe62 read value
    csrr x14, 0xe62

    #Address 0xe62 read value
    csrr x14, 0xe62

    #Address 0xe62 Write value 0x620197df
    li x3, 0x620197df
    csrw 0xe62, x3

    #Address 0xe62 Write value 0xf110f4e1
    li x3, 0xf110f4e1
    csrw 0xe62, x3

    #Unmapped address 0x1fb testing: random write/read operations
    #Address 0x1fb Write value 0xe392e330
    li x3, 0xe392e330
    csrw 0x1fb, x3

    #Address 0x1fb read value
    csrr x14, 0x1fb

    #Address 0x1fb read value
    csrr x14, 0x1fb

    #Address 0x1fb read value
    csrr x14, 0x1fb

    #Address 0x1fb read value
    csrr x14, 0x1fb

    #Unmapped address 0x1df testing: random write/read operations
    #Address 0x1df read value
    csrr x14, 0x1df

    #Address 0x1df Write value 0xe1b3c71a
    li x3, 0xe1b3c71a
    csrw 0x1df, x3

    #Address 0x1df Write value 0x4c96a14
    li x3, 0x4c96a14
    csrw 0x1df, x3

    #Address 0x1df read value
    csrr x14, 0x1df

    #Address 0x1df Write value 0xf2614087
    li x3, 0xf2614087
    csrw 0x1df, x3

    #Unmapped address 0x424 testing: random write/read operations
    #Address 0x424 Write value 0xd78d93f
    li x3, 0xd78d93f
    csrw 0x424, x3

    #Unmapped address 0x40d testing: random write/read operations
    #Address 0x40d read value
    csrr x14, 0x40d

    #Address 0x40d Write value 0xf0a36ac1
    li x3, 0xf0a36ac1
    csrw 0x40d, x3

    #Unmapped address 0x97 testing: random write/read operations
    #Address 0x97 read value
    csrr x14, 0x97

    #Address 0x97 read value
    csrr x14, 0x97

    #Unmapped address 0xc21 testing: random write/read operations
    #Address 0xc21 Write value 0x69249796
    li x3, 0x69249796
    csrw 0xc21, x3

    #Address 0xc21 Write value 0xb07b304e
    li x3, 0xb07b304e
    csrw 0xc21, x3

    #Address 0xc21 Write value 0x35cfd463
    li x3, 0x35cfd463
    csrw 0xc21, x3

    #Address 0xc21 read value
    csrr x14, 0xc21

    #Address 0xc21 read value
    csrr x14, 0xc21

    #Unmapped address 0x264 testing: random write/read operations
    #Address 0x264 read value
    csrr x14, 0x264

    #Address 0x264 Write value 0xf231035f
    li x3, 0xf231035f
    csrw 0x264, x3

    #Unmapped address 0x41a testing: random write/read operations
    #Address 0x41a read value
    csrr x14, 0x41a

    #Address 0x41a Write value 0x1b233d35
    li x3, 0x1b233d35
    csrw 0x41a, x3

    #Unmapped address 0xe71 testing: random write/read operations
    #Address 0xe71 Write value 0x715d9918
    li x3, 0x715d9918
    csrw 0xe71, x3

    #Address 0xe71 Write value 0x96345a5a
    li x3, 0x96345a5a
    csrw 0xe71, x3

    #Address 0xe71 read value
    csrr x14, 0xe71

    #Address 0xe71 read value
    csrr x14, 0xe71

    #Address 0xe71 read value
    csrr x14, 0xe71

    #Unmapped address 0xedf testing: random write/read operations
    #Address 0xedf read value
    csrr x14, 0xedf

    #Address 0xedf Write value 0xfbc8c96e
    li x3, 0xfbc8c96e
    csrw 0xedf, x3

    #Address 0xedf Write value 0x86bcd36
    li x3, 0x86bcd36
    csrw 0xedf, x3

    #Address 0xedf Write value 0x2e9080ec
    li x3, 0x2e9080ec
    csrw 0xedf, x3

    #Unmapped address 0xb27 testing: random write/read operations
    #Address 0xb27 read value
    csrr x14, 0xb27

    #Unmapped address 0xbc6 testing: random write/read operations
    #Address 0xbc6 read value
    csrr x14, 0xbc6

    #Unmapped address 0x46c testing: random write/read operations
    #Address 0x46c Write value 0x6b7483f0
    li x3, 0x6b7483f0
    csrw 0x46c, x3

    #Unmapped address 0x109 testing: random write/read operations
    #Address 0x109 read value
    csrr x14, 0x109

    #Address 0x109 Write value 0xe5150973
    li x3, 0xe5150973
    csrw 0x109, x3

    #Address 0x109 Write value 0x84510a06
    li x3, 0x84510a06
    csrw 0x109, x3

    #Unmapped address 0x682 testing: random write/read operations
    #Address 0x682 Write value 0x6cb41425
    li x3, 0x6cb41425
    csrw 0x682, x3

    #Address 0x682 read value
    csrr x14, 0x682

    #Unmapped address 0xb25 testing: random write/read operations
    #Address 0xb25 read value
    csrr x14, 0xb25

    #Unmapped address 0xe26 testing: random write/read operations
    #Address 0xe26 Write value 0xe84a18a8
    li x3, 0xe84a18a8
    csrw 0xe26, x3

    #Address 0xe26 Write value 0xef525a32
    li x3, 0xef525a32
    csrw 0xe26, x3

    #Address 0xe26 Write value 0x527af39e
    li x3, 0x527af39e
    csrw 0xe26, x3

    #Unmapped address 0x2dc testing: random write/read operations
    #Address 0x2dc read value
    csrr x14, 0x2dc

    #Address 0x2dc Write value 0x92ac3004
    li x3, 0x92ac3004
    csrw 0x2dc, x3

    #Address 0x2dc Write value 0x8ea706d3
    li x3, 0x8ea706d3
    csrw 0x2dc, x3

    #Unmapped address 0xd4b testing: random write/read operations
    #Address 0xd4b read value
    csrr x14, 0xd4b

    #Address 0xd4b read value
    csrr x14, 0xd4b

    #Unmapped address 0xf88 testing: random write/read operations
    #Address 0xf88 Write value 0x1fc9a15a
    li x3, 0x1fc9a15a
    csrw 0xf88, x3

    #Address 0xf88 read value
    csrr x14, 0xf88

    #Address 0xf88 read value
    csrr x14, 0xf88

    #Address 0xf88 read value
    csrr x14, 0xf88

    #Unmapped address 0x1da testing: random write/read operations
    #Address 0x1da read value
    csrr x14, 0x1da

    #Unmapped address 0x15 testing: random write/read operations
    #Address 0x15 read value
    csrr x14, 0x15

    #Address 0x15 Write value 0xf6007a40
    li x3, 0xf6007a40
    csrw 0x15, x3

    #Address 0x15 read value
    csrr x14, 0x15

    #Unmapped address 0xa1 testing: random write/read operations
    #Address 0xa1 read value
    csrr x14, 0xa1

    #Address 0xa1 read value
    csrr x14, 0xa1

    #Address 0xa1 read value
    csrr x14, 0xa1

    #Unmapped address 0xb59 testing: random write/read operations
    #Address 0xb59 read value
    csrr x14, 0xb59

    #Address 0xb59 Write value 0x31c6e253
    li x3, 0x31c6e253
    csrw 0xb59, x3

    #Unmapped address 0x373 testing: random write/read operations
    #Address 0x373 Write value 0x235d0fd2
    li x3, 0x235d0fd2
    csrw 0x373, x3

    #Address 0x373 read value
    csrr x14, 0x373

    #Address 0x373 Write value 0x1e6395e
    li x3, 0x1e6395e
    csrw 0x373, x3

    #Address 0x373 Write value 0x7c5fe207
    li x3, 0x7c5fe207
    csrw 0x373, x3

    #Address 0x373 Write value 0xadef4af5
    li x3, 0xadef4af5
    csrw 0x373, x3

    #Unmapped address 0xa4d testing: random write/read operations
    #Address 0xa4d read value
    csrr x14, 0xa4d

    #Address 0xa4d Write value 0xb30bf48b
    li x3, 0xb30bf48b
    csrw 0xa4d, x3

    #Address 0xa4d Write value 0xda006ea4
    li x3, 0xda006ea4
    csrw 0xa4d, x3

    #Address 0xa4d read value
    csrr x14, 0xa4d

    #Unmapped address 0xc8c testing: random write/read operations
    #Address 0xc8c Write value 0x6a7cbf3f
    li x3, 0x6a7cbf3f
    csrw 0xc8c, x3

    #Unmapped address 0x8ac testing: random write/read operations
    #Address 0x8ac read value
    csrr x14, 0x8ac

    #Address 0x8ac Write value 0xfb492ec9
    li x3, 0xfb492ec9
    csrw 0x8ac, x3

    #Address 0x8ac Write value 0xf6a330fa
    li x3, 0xf6a330fa
    csrw 0x8ac, x3

    #Address 0x8ac read value
    csrr x14, 0x8ac

    #Unmapped address 0x213 testing: random write/read operations
    #Address 0x213 read value
    csrr x14, 0x213

    #Address 0x213 Write value 0xf66b6fb6
    li x3, 0xf66b6fb6
    csrw 0x213, x3

    #Address 0x213 read value
    csrr x14, 0x213

    #Address 0x213 read value
    csrr x14, 0x213

    #Address 0x213 read value
    csrr x14, 0x213

    #Unmapped address 0xb6b testing: random write/read operations
    #Address 0xb6b read value
    csrr x14, 0xb6b

    #Address 0xb6b read value
    csrr x14, 0xb6b

    #Address 0xb6b Write value 0x23b4bdc5
    li x3, 0x23b4bdc5
    csrw 0xb6b, x3

    #Unmapped address 0xfb4 testing: random write/read operations
    #Address 0xfb4 read value
    csrr x14, 0xfb4

    #Address 0xfb4 read value
    csrr x14, 0xfb4

    #Address 0xfb4 Write value 0xdd75c40a
    li x3, 0xdd75c40a
    csrw 0xfb4, x3

    #Unmapped address 0x950 testing: random write/read operations
    #Address 0x950 read value
    csrr x14, 0x950

    #Address 0x950 Write value 0xddc0070f
    li x3, 0xddc0070f
    csrw 0x950, x3

    #Address 0x950 Write value 0xc85abd9e
    li x3, 0xc85abd9e
    csrw 0x950, x3

    #Address 0x950 read value
    csrr x14, 0x950

    #Unmapped address 0x404 testing: random write/read operations
    #Address 0x404 Write value 0x27747c1a
    li x3, 0x27747c1a
    csrw 0x404, x3

    #Address 0x404 read value
    csrr x14, 0x404

    #Mapped address 0xb09 (mhpmcounter9) testing: random write/read operations
    #Address 0xb09 read value
    csrr x14, 0xb09

    #Address 0xb09 Write value 0x351dfd21
    li x3, 0x351dfd21
    csrw 0xb09, x3

    #Address 0xb09 read value
    csrr x14, 0xb09

    #Address 0xb09 Write value 0x1fcb9257
    li x3, 0x1fcb9257
    csrw 0xb09, x3

    #Address 0xb09 Write value 0xd4c2416e
    li x3, 0xd4c2416e
    csrw 0xb09, x3

    #Unmapped address 0x527 testing: random write/read operations
    #Address 0x527 Write value 0x66742f50
    li x3, 0x66742f50
    csrw 0x527, x3

    #Address 0x527 read value
    csrr x14, 0x527

    #Address 0x527 read value
    csrr x14, 0x527

    #Address 0x527 Write value 0xe356176d
    li x3, 0xe356176d
    csrw 0x527, x3

    #Unmapped address 0x214 testing: random write/read operations
    #Address 0x214 read value
    csrr x14, 0x214

    #Address 0x214 read value
    csrr x14, 0x214

    #Unmapped address 0xbb4 testing: random write/read operations
    #Address 0xbb4 read value
    csrr x14, 0xbb4

    #Address 0xbb4 read value
    csrr x14, 0xbb4

    #Address 0xbb4 Write value 0x791c7445
    li x3, 0x791c7445
    csrw 0xbb4, x3

    #Address 0xbb4 Write value 0x337e87f
    li x3, 0x337e87f
    csrw 0xbb4, x3

    #Address 0xbb4 Write value 0x631d69cc
    li x3, 0x631d69cc
    csrw 0xbb4, x3

    #Unmapped address 0x580 testing: random write/read operations
    #Address 0x580 read value
    csrr x14, 0x580

    #Address 0x580 read value
    csrr x14, 0x580

    #Address 0x580 Write value 0x41ef8262
    li x3, 0x41ef8262
    csrw 0x580, x3

    #Address 0x580 Write value 0xe378f774
    li x3, 0xe378f774
    csrw 0x580, x3

    #Unmapped address 0x1aa testing: random write/read operations
    #Address 0x1aa read value
    csrr x14, 0x1aa

    #Address 0x1aa Write value 0xbbcfbc21
    li x3, 0xbbcfbc21
    csrw 0x1aa, x3

    #Address 0x1aa Write value 0x21c90e7c
    li x3, 0x21c90e7c
    csrw 0x1aa, x3

    #Address 0x1aa Write value 0xcca1e191
    li x3, 0xcca1e191
    csrw 0x1aa, x3

    #Unmapped address 0xa08 testing: random write/read operations
    #Address 0xa08 read value
    csrr x14, 0xa08

    #Unmapped address 0x9e6 testing: random write/read operations
    #Address 0x9e6 read value
    csrr x14, 0x9e6

    #Address 0x9e6 Write value 0x70761ac4
    li x3, 0x70761ac4
    csrw 0x9e6, x3

    #Address 0x9e6 read value
    csrr x14, 0x9e6

    #Unmapped address 0x2e9 testing: random write/read operations
    #Address 0x2e9 Write value 0x76a97517
    li x3, 0x76a97517
    csrw 0x2e9, x3

    #Address 0x2e9 read value
    csrr x14, 0x2e9

    #Address 0x2e9 Write value 0xad3e7663
    li x3, 0xad3e7663
    csrw 0x2e9, x3

    #Address 0x2e9 read value
    csrr x14, 0x2e9

    #Address 0x2e9 Write value 0xa66b5fdc
    li x3, 0xa66b5fdc
    csrw 0x2e9, x3

    #Unmapped address 0x9b0 testing: random write/read operations
    #Address 0x9b0 Write value 0x96fb15d7
    li x3, 0x96fb15d7
    csrw 0x9b0, x3

    #Address 0x9b0 read value
    csrr x14, 0x9b0

    #Unmapped address 0xf8b testing: random write/read operations
    #Address 0xf8b Write value 0x921b6945
    li x3, 0x921b6945
    csrw 0xf8b, x3

    #Address 0xf8b read value
    csrr x14, 0xf8b

    #Address 0xf8b Write value 0xd616e952
    li x3, 0xd616e952
    csrw 0xf8b, x3

    #Address 0xf8b Write value 0xedb7eff3
    li x3, 0xedb7eff3
    csrw 0xf8b, x3

    #Unmapped address 0x24b testing: random write/read operations
    #Address 0x24b Write value 0xcc975834
    li x3, 0xcc975834
    csrw 0x24b, x3

    #Address 0x24b read value
    csrr x14, 0x24b

    #Address 0x24b Write value 0xfbfbecd7
    li x3, 0xfbfbecd7
    csrw 0x24b, x3

    #Address 0x24b Write value 0xe3083f95
    li x3, 0xe3083f95
    csrw 0x24b, x3

    #Unmapped address 0x634 testing: random write/read operations
    #Address 0x634 Write value 0xc5be231e
    li x3, 0xc5be231e
    csrw 0x634, x3

    #Address 0x634 read value
    csrr x14, 0x634

    #Address 0x634 read value
    csrr x14, 0x634

    #Address 0x634 read value
    csrr x14, 0x634

    #Unmapped address 0xace testing: random write/read operations
    #Address 0xace Write value 0x1d3a173d
    li x3, 0x1d3a173d
    csrw 0xace, x3

    #Address 0xace read value
    csrr x14, 0xace

    #Unmapped address 0xece testing: random write/read operations
    #Address 0xece Write value 0x530ccdc2
    li x3, 0x530ccdc2
    csrw 0xece, x3

    #Unmapped address 0x3a9 testing: random write/read operations
    #Address 0x3a9 read value
    csrr x14, 0x3a9

    #Address 0x3a9 Write value 0xb81cc848
    li x3, 0xb81cc848
    csrw 0x3a9, x3

    #Address 0x3a9 read value
    csrr x14, 0x3a9

    #Address 0x3a9 Write value 0xc95ef54
    li x3, 0xc95ef54
    csrw 0x3a9, x3

    #Address 0x3a9 read value
    csrr x14, 0x3a9

    #Unmapped address 0x176 testing: random write/read operations
    #Address 0x176 read value
    csrr x14, 0x176

    #Address 0x176 read value
    csrr x14, 0x176

    #Address 0x176 Write value 0xced93463
    li x3, 0xced93463
    csrw 0x176, x3

    #Address 0x176 read value
    csrr x14, 0x176

    #Unmapped address 0x228 testing: random write/read operations
    #Address 0x228 Write value 0xde02d36
    li x3, 0xde02d36
    csrw 0x228, x3

    #Unmapped address 0xd1 testing: random write/read operations
    #Address 0xd1 Write value 0x219d8880
    li x3, 0x219d8880
    csrw 0xd1, x3

    #Address 0xd1 read value
    csrr x14, 0xd1

    #Address 0xd1 Write value 0x60fd9b9a
    li x3, 0x60fd9b9a
    csrw 0xd1, x3

    #Address 0xd1 read value
    csrr x14, 0xd1

    #Unmapped address 0x8f2 testing: random write/read operations
    #Address 0x8f2 Write value 0xde3dcd6c
    li x3, 0xde3dcd6c
    csrw 0x8f2, x3

    #Address 0x8f2 Write value 0x9b64c06c
    li x3, 0x9b64c06c
    csrw 0x8f2, x3

    #Address 0x8f2 read value
    csrr x14, 0x8f2

    #Address 0x8f2 Write value 0xe7dfaaa
    li x3, 0xe7dfaaa
    csrw 0x8f2, x3

    #Address 0x8f2 Write value 0xd5c5b55d
    li x3, 0xd5c5b55d
    csrw 0x8f2, x3

    #Unmapped address 0x10d testing: random write/read operations
    #Address 0x10d read value
    csrr x14, 0x10d

    #Address 0x10d Write value 0xeaa1995a
    li x3, 0xeaa1995a
    csrw 0x10d, x3

    #Address 0x10d Write value 0x44b6b0ae
    li x3, 0x44b6b0ae
    csrw 0x10d, x3

    #Unmapped address 0x28a testing: random write/read operations
    #Address 0x28a Write value 0x7114a2d4
    li x3, 0x7114a2d4
    csrw 0x28a, x3

    #Address 0x28a Write value 0x271f932b
    li x3, 0x271f932b
    csrw 0x28a, x3

    #Address 0x28a Write value 0x5ece18c4
    li x3, 0x5ece18c4
    csrw 0x28a, x3

    #Unmapped address 0x3c testing: random write/read operations
    #Address 0x3c read value
    csrr x14, 0x3c

    #Address 0x3c read value
    csrr x14, 0x3c

    #Address 0x3c Write value 0x64fc1f69
    li x3, 0x64fc1f69
    csrw 0x3c, x3

    #Address 0x3c Write value 0xdef6a256
    li x3, 0xdef6a256
    csrw 0x3c, x3

    #Address 0x3c read value
    csrr x14, 0x3c

    #Unmapped address 0xde1 testing: random write/read operations
    #Address 0xde1 read value
    csrr x14, 0xde1

    #Address 0xde1 Write value 0xcc3e001e
    li x3, 0xcc3e001e
    csrw 0xde1, x3

    #Unmapped address 0x282 testing: random write/read operations
    #Address 0x282 read value
    csrr x14, 0x282

    #Address 0x282 read value
    csrr x14, 0x282

    #Address 0x282 read value
    csrr x14, 0x282

    #Unmapped address 0x42a testing: random write/read operations
    #Address 0x42a Write value 0x6cf148e8
    li x3, 0x6cf148e8
    csrw 0x42a, x3

    #Address 0x42a read value
    csrr x14, 0x42a

    #Unmapped address 0x13c testing: random write/read operations
    #Address 0x13c Write value 0xcd8d0da5
    li x3, 0xcd8d0da5
    csrw 0x13c, x3

    #Address 0x13c read value
    csrr x14, 0x13c

    #Address 0x13c Write value 0xb80126a6
    li x3, 0xb80126a6
    csrw 0x13c, x3

    #Unmapped address 0x87e testing: random write/read operations
    #Address 0x87e read value
    csrr x14, 0x87e

    #Unmapped address 0x280 testing: random write/read operations
    #Address 0x280 Write value 0xb8416bd1
    li x3, 0xb8416bd1
    csrw 0x280, x3

    #Unmapped address 0x370 testing: random write/read operations
    #Address 0x370 read value
    csrr x14, 0x370

    #Address 0x370 Write value 0x4b0e1afa
    li x3, 0x4b0e1afa
    csrw 0x370, x3

    #Address 0x370 Write value 0xaea38edc
    li x3, 0xaea38edc
    csrw 0x370, x3

    #Unmapped address 0xf7f testing: random write/read operations
    #Address 0xf7f Write value 0x88061b5c
    li x3, 0x88061b5c
    csrw 0xf7f, x3

    #Address 0xf7f read value
    csrr x14, 0xf7f

    #Unmapped address 0x7d6 testing: random write/read operations
    #Address 0x7d6 Write value 0x98fa5af2
    li x3, 0x98fa5af2
    csrw 0x7d6, x3

    #Address 0x7d6 read value
    csrr x14, 0x7d6

    #Address 0x7d6 Write value 0xd28e893c
    li x3, 0xd28e893c
    csrw 0x7d6, x3

    #Unmapped address 0x80c testing: random write/read operations
    #Address 0x80c Write value 0xaf4d6b09
    li x3, 0xaf4d6b09
    csrw 0x80c, x3

    #Address 0x80c Write value 0x97fba87
    li x3, 0x97fba87
    csrw 0x80c, x3

    #Address 0x80c read value
    csrr x14, 0x80c

    #Address 0x80c read value
    csrr x14, 0x80c

    #Address 0x80c Write value 0xc4c7fc59
    li x3, 0xc4c7fc59
    csrw 0x80c, x3

    #Unmapped address 0xf3a testing: random write/read operations
    #Address 0xf3a read value
    csrr x14, 0xf3a

    #Unmapped address 0xb31 testing: random write/read operations
    #Address 0xb31 Write value 0x16d5314a
    li x3, 0x16d5314a
    csrw 0xb31, x3

    #Address 0xb31 Write value 0x707a059
    li x3, 0x707a059
    csrw 0xb31, x3

    #Address 0xb31 read value
    csrr x14, 0xb31

    #Unmapped address 0x70c testing: random write/read operations
    #Address 0x70c read value
    csrr x14, 0x70c

    #Address 0x70c read value
    csrr x14, 0x70c

    #Unmapped address 0x997 testing: random write/read operations
    #Address 0x997 Write value 0xe333af1d
    li x3, 0xe333af1d
    csrw 0x997, x3

    #Unmapped address 0x99b testing: random write/read operations
    #Address 0x99b Write value 0x287d26e9
    li x3, 0x287d26e9
    csrw 0x99b, x3

    #Address 0x99b read value
    csrr x14, 0x99b

    #Address 0x99b Write value 0xf6dd356c
    li x3, 0xf6dd356c
    csrw 0x99b, x3

    #Address 0x99b Write value 0x1b945dea
    li x3, 0x1b945dea
    csrw 0x99b, x3

    #Unmapped address 0x95 testing: random write/read operations
    #Address 0x95 read value
    csrr x14, 0x95

    #Unmapped address 0x354 testing: random write/read operations
    #Address 0x354 read value
    csrr x14, 0x354

    #Address 0x354 read value
    csrr x14, 0x354

    #Address 0x354 Write value 0x2d231837
    li x3, 0x2d231837
    csrw 0x354, x3

    #Address 0x354 Write value 0xcfd9e8fc
    li x3, 0xcfd9e8fc
    csrw 0x354, x3

    #Address 0x354 Write value 0xb9e2c530
    li x3, 0xb9e2c530
    csrw 0x354, x3

    #Unmapped address 0xb67 testing: random write/read operations
    #Address 0xb67 read value
    csrr x14, 0xb67

    #Address 0xb67 read value
    csrr x14, 0xb67

    #Address 0xb67 Write value 0x852765e3
    li x3, 0x852765e3
    csrw 0xb67, x3

    #Address 0xb67 read value
    csrr x14, 0xb67

    #Address 0xb67 Write value 0xb243b281
    li x3, 0xb243b281
    csrw 0xb67, x3

    #Unmapped address 0x951 testing: random write/read operations
    #Address 0x951 read value
    csrr x14, 0x951

    #Unmapped address 0x63a testing: random write/read operations
    #Address 0x63a read value
    csrr x14, 0x63a

    #Address 0x63a Write value 0xcdf9b9ea
    li x3, 0xcdf9b9ea
    csrw 0x63a, x3

    #Address 0x63a read value
    csrr x14, 0x63a

    #Unmapped address 0xc7e testing: random write/read operations
    #Address 0xc7e Write value 0x4926d9f0
    li x3, 0x4926d9f0
    csrw 0xc7e, x3

    #Address 0xc7e read value
    csrr x14, 0xc7e

    #Address 0xc7e read value
    csrr x14, 0xc7e

    #Address 0xc7e read value
    csrr x14, 0xc7e

    #Unmapped address 0x472 testing: random write/read operations
    #Address 0x472 read value
    csrr x14, 0x472

    #Address 0x472 Write value 0xd207d609
    li x3, 0xd207d609
    csrw 0x472, x3

    #Unmapped address 0xbc2 testing: random write/read operations
    #Address 0xbc2 Write value 0x5088231d
    li x3, 0x5088231d
    csrw 0xbc2, x3

    #Address 0xbc2 Write value 0x18135374
    li x3, 0x18135374
    csrw 0xbc2, x3

    #Address 0xbc2 Write value 0xf149d213
    li x3, 0xf149d213
    csrw 0xbc2, x3

    #Address 0xbc2 read value
    csrr x14, 0xbc2

    #Address 0xbc2 read value
    csrr x14, 0xbc2

    #Unmapped address 0x3e4 testing: random write/read operations
    #Address 0x3e4 read value
    csrr x14, 0x3e4

    #Address 0x3e4 read value
    csrr x14, 0x3e4

    #Unmapped address 0xd1a testing: random write/read operations
    #Address 0xd1a Write value 0x83ac7845
    li x3, 0x83ac7845
    csrw 0xd1a, x3

    #Address 0xd1a Write value 0x5b0a20f1
    li x3, 0x5b0a20f1
    csrw 0xd1a, x3

    #Address 0xd1a read value
    csrr x14, 0xd1a

    #Unmapped address 0xb3e testing: random write/read operations
    #Address 0xb3e Write value 0xb7e8d6a7
    li x3, 0xb7e8d6a7
    csrw 0xb3e, x3

    #Address 0xb3e read value
    csrr x14, 0xb3e

    #Address 0xb3e Write value 0x57885f73
    li x3, 0x57885f73
    csrw 0xb3e, x3

    #Address 0xb3e Write value 0xdfe57ba1
    li x3, 0xdfe57ba1
    csrw 0xb3e, x3

    #Address 0xb3e read value
    csrr x14, 0xb3e

    #Unmapped address 0x1f9 testing: random write/read operations
    #Address 0x1f9 read value
    csrr x14, 0x1f9

    #Address 0x1f9 read value
    csrr x14, 0x1f9

    #Address 0x1f9 read value
    csrr x14, 0x1f9

    #Unmapped address 0x178 testing: random write/read operations
    #Address 0x178 Write value 0x7b263dad
    li x3, 0x7b263dad
    csrw 0x178, x3

    #Address 0x178 Write value 0x324bf18d
    li x3, 0x324bf18d
    csrw 0x178, x3

    #Unmapped address 0xe0a testing: random write/read operations
    #Address 0xe0a Write value 0xb9b82b65
    li x3, 0xb9b82b65
    csrw 0xe0a, x3

    #Unmapped address 0x697 testing: random write/read operations
    #Address 0x697 Write value 0x90ab722c
    li x3, 0x90ab722c
    csrw 0x697, x3

    #Address 0x697 Write value 0xbd6e726a
    li x3, 0xbd6e726a
    csrw 0x697, x3

    #Mapped address 0xf13 (mimpid) testing: random write/read operations
    #Address 0xf13 read value
    csrr x14, 0xf13

    #Address 0xf13 Write value 0x36127dae
    li x3, 0x36127dae
    csrw 0xf13, x3

    #Unmapped address 0x1a2 testing: random write/read operations
    #Address 0x1a2 Write value 0x7a09bc9f
    li x3, 0x7a09bc9f
    csrw 0x1a2, x3

    #Address 0x1a2 read value
    csrr x14, 0x1a2

    #Unmapped address 0x715 testing: random write/read operations
    #Address 0x715 read value
    csrr x14, 0x715

    #Address 0x715 Write value 0xee8ffc24
    li x3, 0xee8ffc24
    csrw 0x715, x3

    #Address 0x715 read value
    csrr x14, 0x715

    #Address 0x715 Write value 0x79e51bea
    li x3, 0x79e51bea
    csrw 0x715, x3

    #Unmapped address 0xf40 testing: random write/read operations
    #Address 0xf40 read value
    csrr x14, 0xf40

    #Address 0xf40 read value
    csrr x14, 0xf40

    #Address 0xf40 Write value 0x4d0cc10c
    li x3, 0x4d0cc10c
    csrw 0xf40, x3

    #Address 0xf40 read value
    csrr x14, 0xf40

    #Address 0xf40 Write value 0xc9af378b
    li x3, 0xc9af378b
    csrw 0xf40, x3

    #Unmapped address 0x26f testing: random write/read operations
    #Address 0x26f read value
    csrr x14, 0x26f

    #Address 0x26f read value
    csrr x14, 0x26f

    #Address 0x26f Write value 0xa6a864ae
    li x3, 0xa6a864ae
    csrw 0x26f, x3

    #Address 0x26f read value
    csrr x14, 0x26f

    #Address 0x26f Write value 0xc7d7ff7d
    li x3, 0xc7d7ff7d
    csrw 0x26f, x3

    #Unmapped address 0xa1c testing: random write/read operations
    #Address 0xa1c Write value 0x1bf4620
    li x3, 0x1bf4620
    csrw 0xa1c, x3

    #Address 0xa1c Write value 0xdff7f022
    li x3, 0xdff7f022
    csrw 0xa1c, x3

    #Address 0xa1c read value
    csrr x14, 0xa1c

    #Address 0xa1c Write value 0xb2bd26e8
    li x3, 0xb2bd26e8
    csrw 0xa1c, x3

    #Unmapped address 0xa92 testing: random write/read operations
    #Address 0xa92 read value
    csrr x14, 0xa92

    #Unmapped address 0x98b testing: random write/read operations
    #Address 0x98b Write value 0x1d041fcc
    li x3, 0x1d041fcc
    csrw 0x98b, x3

    #Address 0x98b Write value 0x1e10200e
    li x3, 0x1e10200e
    csrw 0x98b, x3

    #Address 0x98b read value
    csrr x14, 0x98b

    #Unmapped address 0x64a testing: random write/read operations
    #Address 0x64a Write value 0xe3b6dc1f
    li x3, 0xe3b6dc1f
    csrw 0x64a, x3

    #Address 0x64a read value
    csrr x14, 0x64a

    #Address 0x64a read value
    csrr x14, 0x64a

    #Address 0x64a Write value 0x54d1244f
    li x3, 0x54d1244f
    csrw 0x64a, x3

    #Address 0x64a read value
    csrr x14, 0x64a

    #Unmapped address 0x29f testing: random write/read operations
    #Address 0x29f read value
    csrr x14, 0x29f

    #Address 0x29f Write value 0x244f8f3
    li x3, 0x244f8f3
    csrw 0x29f, x3

    #Address 0x29f read value
    csrr x14, 0x29f

    #Unmapped address 0xe1d testing: random write/read operations
    #Address 0xe1d read value
    csrr x14, 0xe1d

    #Address 0xe1d read value
    csrr x14, 0xe1d

    #Address 0xe1d Write value 0xff93474c
    li x3, 0xff93474c
    csrw 0xe1d, x3

    #Address 0xe1d read value
    csrr x14, 0xe1d

    #Unmapped address 0x2a7 testing: random write/read operations
    #Address 0x2a7 read value
    csrr x14, 0x2a7

    #Address 0x2a7 read value
    csrr x14, 0x2a7

    #Unmapped address 0x606 testing: random write/read operations
    #Address 0x606 Write value 0x174fc444
    li x3, 0x174fc444
    csrw 0x606, x3

    #Address 0x606 read value
    csrr x14, 0x606

    #Address 0x606 Write value 0xdcd4eaba
    li x3, 0xdcd4eaba
    csrw 0x606, x3

    #Unmapped address 0x4ed testing: random write/read operations
    #Address 0x4ed read value
    csrr x14, 0x4ed

    #Address 0x4ed Write value 0x805288d4
    li x3, 0x805288d4
    csrw 0x4ed, x3

    #Address 0x4ed Write value 0xadce626f
    li x3, 0xadce626f
    csrw 0x4ed, x3

    #Unmapped address 0x10f testing: random write/read operations
    #Address 0x10f Write value 0x8989e645
    li x3, 0x8989e645
    csrw 0x10f, x3

    #Address 0x10f Write value 0x7eeb4ddb
    li x3, 0x7eeb4ddb
    csrw 0x10f, x3

    #Address 0x10f read value
    csrr x14, 0x10f

    #Address 0x10f read value
    csrr x14, 0x10f

    #Address 0x10f Write value 0x46e98b01
    li x3, 0x46e98b01
    csrw 0x10f, x3

    #Unmapped address 0x582 testing: random write/read operations
    #Address 0x582 Write value 0xf40af16b
    li x3, 0xf40af16b
    csrw 0x582, x3

    #Address 0x582 read value
    csrr x14, 0x582

    #Address 0x582 Write value 0x7ee6d37d
    li x3, 0x7ee6d37d
    csrw 0x582, x3

    #Address 0x582 Write value 0x6afd233b
    li x3, 0x6afd233b
    csrw 0x582, x3

    #Unmapped address 0x4a0 testing: random write/read operations
    #Address 0x4a0 read value
    csrr x14, 0x4a0

    #Unmapped address 0x2b5 testing: random write/read operations
    #Address 0x2b5 read value
    csrr x14, 0x2b5

    #Address 0x2b5 Write value 0x9a2833bf
    li x3, 0x9a2833bf
    csrw 0x2b5, x3

    #Address 0x2b5 Write value 0x58bb02de
    li x3, 0x58bb02de
    csrw 0x2b5, x3

    #Address 0x2b5 Write value 0x616bec22
    li x3, 0x616bec22
    csrw 0x2b5, x3

    #Address 0x2b5 read value
    csrr x14, 0x2b5

    #Unmapped address 0xae8 testing: random write/read operations
    #Address 0xae8 Write value 0xcc1ea354
    li x3, 0xcc1ea354
    csrw 0xae8, x3

    #Address 0xae8 read value
    csrr x14, 0xae8

    #Address 0xae8 read value
    csrr x14, 0xae8

    #Address 0xae8 Write value 0x8dcb260e
    li x3, 0x8dcb260e
    csrw 0xae8, x3

    #Unmapped address 0x271 testing: random write/read operations
    #Address 0x271 Write value 0x52c573b2
    li x3, 0x52c573b2
    csrw 0x271, x3

    #Address 0x271 Write value 0xebd25ea2
    li x3, 0xebd25ea2
    csrw 0x271, x3

    #Address 0x271 read value
    csrr x14, 0x271

    #Address 0x271 read value
    csrr x14, 0x271

    #Unmapped address 0x5c3 testing: random write/read operations
    #Address 0x5c3 Write value 0x140469c3
    li x3, 0x140469c3
    csrw 0x5c3, x3

    #Address 0x5c3 read value
    csrr x14, 0x5c3

    #Address 0x5c3 read value
    csrr x14, 0x5c3

    #Unmapped address 0x81d testing: random write/read operations
    #Address 0x81d read value
    csrr x14, 0x81d

    #Unmapped address 0xf5a testing: random write/read operations
    #Address 0xf5a Write value 0xa9c232db
    li x3, 0xa9c232db
    csrw 0xf5a, x3

    #Address 0xf5a Write value 0xb360f93d
    li x3, 0xb360f93d
    csrw 0xf5a, x3

    #Address 0xf5a read value
    csrr x14, 0xf5a

    #Unmapped address 0xcec testing: random write/read operations
    #Address 0xcec read value
    csrr x14, 0xcec

    #Address 0xcec read value
    csrr x14, 0xcec

    #Address 0xcec read value
    csrr x14, 0xcec

    #Address 0xcec read value
    csrr x14, 0xcec

    #Address 0xcec read value
    csrr x14, 0xcec

    #Unmapped address 0x584 testing: random write/read operations
    #Address 0x584 Write value 0xbd79943a
    li x3, 0xbd79943a
    csrw 0x584, x3

    #Address 0x584 Write value 0xb28e124
    li x3, 0xb28e124
    csrw 0x584, x3

    #Address 0x584 read value
    csrr x14, 0x584

    #Address 0x584 read value
    csrr x14, 0x584

    #Address 0x584 Write value 0x6c5a5da1
    li x3, 0x6c5a5da1
    csrw 0x584, x3

    #Unmapped address 0x266 testing: random write/read operations
    #Address 0x266 Write value 0x443715d3
    li x3, 0x443715d3
    csrw 0x266, x3

    #Unmapped address 0xa09 testing: random write/read operations
    #Address 0xa09 Write value 0xe2c42c4f
    li x3, 0xe2c42c4f
    csrw 0xa09, x3

    #Address 0xa09 read value
    csrr x14, 0xa09

    #Address 0xa09 read value
    csrr x14, 0xa09

    #Address 0xa09 read value
    csrr x14, 0xa09

    #Unmapped address 0x88b testing: random write/read operations
    #Address 0x88b read value
    csrr x14, 0x88b

    #Address 0x88b read value
    csrr x14, 0x88b

    #Address 0x88b Write value 0x14fdf32e
    li x3, 0x14fdf32e
    csrw 0x88b, x3

    #Unmapped address 0x730 testing: random write/read operations
    #Address 0x730 read value
    csrr x14, 0x730

    #Address 0x730 read value
    csrr x14, 0x730

    #Address 0x730 Write value 0x943931b1
    li x3, 0x943931b1
    csrw 0x730, x3

    #Address 0x730 read value
    csrr x14, 0x730

    #Unmapped address 0x999 testing: random write/read operations
    #Address 0x999 read value
    csrr x14, 0x999

    #Address 0x999 read value
    csrr x14, 0x999

    #Address 0x999 Write value 0x8a703bdb
    li x3, 0x8a703bdb
    csrw 0x999, x3

    #Address 0x999 Write value 0x61524823
    li x3, 0x61524823
    csrw 0x999, x3

    #Address 0x999 read value
    csrr x14, 0x999

    #Unmapped address 0x40 testing: random write/read operations
    #Address 0x40 read value
    csrr x14, 0x40

    #Address 0x40 Write value 0x82925e53
    li x3, 0x82925e53
    csrw 0x40, x3

    #Unmapped address 0xd10 testing: random write/read operations
    #Address 0xd10 read value
    csrr x14, 0xd10

    #Address 0xd10 Write value 0x72fdc22b
    li x3, 0x72fdc22b
    csrw 0xd10, x3

    #Address 0xd10 Write value 0xd3d0dd57
    li x3, 0xd3d0dd57
    csrw 0xd10, x3

    #Unmapped address 0xbef testing: random write/read operations
    #Address 0xbef Write value 0x319ad9fb
    li x3, 0x319ad9fb
    csrw 0xbef, x3

    #Address 0xbef Write value 0x8f84f575
    li x3, 0x8f84f575
    csrw 0xbef, x3

    #Address 0xbef read value
    csrr x14, 0xbef

    #Address 0xbef Write value 0x4ac07252
    li x3, 0x4ac07252
    csrw 0xbef, x3

    #Unmapped address 0xcbb testing: random write/read operations
    #Address 0xcbb read value
    csrr x14, 0xcbb

    #Address 0xcbb read value
    csrr x14, 0xcbb

    #Address 0xcbb read value
    csrr x14, 0xcbb

    #Address 0xcbb read value
    csrr x14, 0xcbb

    #Address 0xcbb read value
    csrr x14, 0xcbb

    #Unmapped address 0xf37 testing: random write/read operations
    #Address 0xf37 read value
    csrr x14, 0xf37

    #Unmapped address 0x61a testing: random write/read operations
    #Address 0x61a Write value 0x4bbb3f9e
    li x3, 0x4bbb3f9e
    csrw 0x61a, x3

    #Address 0x61a read value
    csrr x14, 0x61a

    #Address 0x61a Write value 0xa1f3ab59
    li x3, 0xa1f3ab59
    csrw 0x61a, x3

    #Address 0x61a Write value 0x4b3aa45f
    li x3, 0x4b3aa45f
    csrw 0x61a, x3

    #Unmapped address 0xcf3 testing: random write/read operations
    #Address 0xcf3 read value
    csrr x14, 0xcf3

    #Address 0xcf3 read value
    csrr x14, 0xcf3

    #Address 0xcf3 Write value 0xd8e46495
    li x3, 0xd8e46495
    csrw 0xcf3, x3

    #Unmapped address 0x1c6 testing: random write/read operations
    #Address 0x1c6 Write value 0x71635cec
    li x3, 0x71635cec
    csrw 0x1c6, x3

    #Address 0x1c6 read value
    csrr x14, 0x1c6

    #Address 0x1c6 read value
    csrr x14, 0x1c6

    #Unmapped address 0x6b7 testing: random write/read operations
    #Address 0x6b7 Write value 0xe77206a7
    li x3, 0xe77206a7
    csrw 0x6b7, x3

    #Address 0x6b7 Write value 0xad7a43a2
    li x3, 0xad7a43a2
    csrw 0x6b7, x3

    #Address 0x6b7 read value
    csrr x14, 0x6b7

    #Address 0x6b7 Write value 0x8d7d0057
    li x3, 0x8d7d0057
    csrw 0x6b7, x3

    #Unmapped address 0xb54 testing: random write/read operations
    #Address 0xb54 Write value 0xaa0f3929
    li x3, 0xaa0f3929
    csrw 0xb54, x3

    #Address 0xb54 read value
    csrr x14, 0xb54

    #Unmapped address 0x726 testing: random write/read operations
    #Address 0x726 read value
    csrr x14, 0x726

    #Unmapped address 0x48e testing: random write/read operations
    #Address 0x48e Write value 0x170abefa
    li x3, 0x170abefa
    csrw 0x48e, x3

    #Address 0x48e Write value 0x4340dec4
    li x3, 0x4340dec4
    csrw 0x48e, x3

    #Address 0x48e read value
    csrr x14, 0x48e

    #Unmapped address 0xd8 testing: random write/read operations
    #Address 0xd8 read value
    csrr x14, 0xd8

    #Address 0xd8 Write value 0x3033f704
    li x3, 0x3033f704
    csrw 0xd8, x3

    #Address 0xd8 Write value 0x7153c6c0
    li x3, 0x7153c6c0
    csrw 0xd8, x3

    #Address 0xd8 Write value 0xb0a0226e
    li x3, 0xb0a0226e
    csrw 0xd8, x3

    #Address 0xd8 Write value 0xfeb3c327
    li x3, 0xfeb3c327
    csrw 0xd8, x3

    #Unmapped address 0x19c testing: random write/read operations
    #Address 0x19c Write value 0x10ee0491
    li x3, 0x10ee0491
    csrw 0x19c, x3

    #Address 0x19c read value
    csrr x14, 0x19c

    #Unmapped address 0x7c3 testing: random write/read operations
    #Address 0x7c3 Write value 0x37cc4678
    li x3, 0x37cc4678
    csrw 0x7c3, x3

    #Address 0x7c3 Write value 0x7d2a77fe
    li x3, 0x7d2a77fe
    csrw 0x7c3, x3

    #Address 0x7c3 read value
    csrr x14, 0x7c3

    #Unmapped address 0x2b4 testing: random write/read operations
    #Address 0x2b4 Write value 0xa6909808
    li x3, 0xa6909808
    csrw 0x2b4, x3

    #Address 0x2b4 read value
    csrr x14, 0x2b4

    #Address 0x2b4 read value
    csrr x14, 0x2b4

    #Address 0x2b4 Write value 0xe3a71ec8
    li x3, 0xe3a71ec8
    csrw 0x2b4, x3

    #Address 0x2b4 read value
    csrr x14, 0x2b4

    #Unmapped address 0x7b6 testing: random write/read operations
    #Address 0x7b6 Write value 0xa549bdb1
    li x3, 0xa549bdb1
    csrw 0x7b6, x3

    #Address 0x7b6 read value
    csrr x14, 0x7b6

    #Unmapped address 0x579 testing: random write/read operations
    #Address 0x579 read value
    csrr x14, 0x579

    #Unmapped address 0xf79 testing: random write/read operations
    #Address 0xf79 Write value 0x6031bd29
    li x3, 0x6031bd29
    csrw 0xf79, x3

    #Address 0xf79 read value
    csrr x14, 0xf79

    #Address 0xf79 read value
    csrr x14, 0xf79

    #Unmapped address 0xbe3 testing: random write/read operations
    #Address 0xbe3 Write value 0x9ac82b78
    li x3, 0x9ac82b78
    csrw 0xbe3, x3

    #Address 0xbe3 read value
    csrr x14, 0xbe3

    #Address 0xbe3 Write value 0x75d92056
    li x3, 0x75d92056
    csrw 0xbe3, x3

    #Address 0xbe3 Write value 0x8c54f424
    li x3, 0x8c54f424
    csrw 0xbe3, x3

    #Address 0xbe3 Write value 0xb681b834
    li x3, 0xb681b834
    csrw 0xbe3, x3

    #Unmapped address 0x71f testing: random write/read operations
    #Address 0x71f Write value 0xa0acfa4e
    li x3, 0xa0acfa4e
    csrw 0x71f, x3

    #Address 0x71f read value
    csrr x14, 0x71f

    #Address 0x71f Write value 0xe22e5a71
    li x3, 0xe22e5a71
    csrw 0x71f, x3

    #Unmapped address 0x42e testing: random write/read operations
    #Address 0x42e Write value 0xa1bc0845
    li x3, 0xa1bc0845
    csrw 0x42e, x3

    #Address 0x42e Write value 0x9a0310cb
    li x3, 0x9a0310cb
    csrw 0x42e, x3

    #Address 0x42e read value
    csrr x14, 0x42e

    #Unmapped address 0x750 testing: random write/read operations
    #Address 0x750 read value
    csrr x14, 0x750

    #Address 0x750 read value
    csrr x14, 0x750

    #Address 0x750 read value
    csrr x14, 0x750

    #Address 0x750 Write value 0x1634b5a5
    li x3, 0x1634b5a5
    csrw 0x750, x3

    #Address 0x750 read value
    csrr x14, 0x750

    #Unmapped address 0x812 testing: random write/read operations
    #Address 0x812 read value
    csrr x14, 0x812

    #Unmapped address 0x98c testing: random write/read operations
    #Address 0x98c Write value 0xc1c0aa14
    li x3, 0xc1c0aa14
    csrw 0x98c, x3

    #Address 0x98c read value
    csrr x14, 0x98c

    #Address 0x98c Write value 0x9e32fdb6
    li x3, 0x9e32fdb6
    csrw 0x98c, x3

    #Unmapped address 0x409 testing: random write/read operations
    #Address 0x409 Write value 0xe72330a1
    li x3, 0xe72330a1
    csrw 0x409, x3

    #Address 0x409 read value
    csrr x14, 0x409

    #Unmapped address 0xdbb testing: random write/read operations
    #Address 0xdbb read value
    csrr x14, 0xdbb

    #Address 0xdbb Write value 0x84be849b
    li x3, 0x84be849b
    csrw 0xdbb, x3

    #Address 0xdbb Write value 0x72e3029
    li x3, 0x72e3029
    csrw 0xdbb, x3

    #Address 0xdbb read value
    csrr x14, 0xdbb

    #Address 0xdbb Write value 0xec0835de
    li x3, 0xec0835de
    csrw 0xdbb, x3

    #Unmapped address 0x59f testing: random write/read operations
    #Address 0x59f Write value 0x19403822
    li x3, 0x19403822
    csrw 0x59f, x3

    #Address 0x59f Write value 0xd8b254df
    li x3, 0xd8b254df
    csrw 0x59f, x3

    #Unmapped address 0xca4 testing: random write/read operations
    #Address 0xca4 Write value 0x5b6b2afa
    li x3, 0x5b6b2afa
    csrw 0xca4, x3

    #Unmapped address 0xcc9 testing: random write/read operations
    #Address 0xcc9 read value
    csrr x14, 0xcc9

    #Unmapped address 0xe3b testing: random write/read operations
    #Address 0xe3b Write value 0x92fce8b1
    li x3, 0x92fce8b1
    csrw 0xe3b, x3

    #Unmapped address 0x2b3 testing: random write/read operations
    #Address 0x2b3 Write value 0xb2eaf329
    li x3, 0xb2eaf329
    csrw 0x2b3, x3

    #Address 0x2b3 Write value 0xf6dcb948
    li x3, 0xf6dcb948
    csrw 0x2b3, x3

    #Address 0x2b3 Write value 0x7a797bc1
    li x3, 0x7a797bc1
    csrw 0x2b3, x3

    #Unmapped address 0xba testing: random write/read operations
    #Address 0xba read value
    csrr x14, 0xba

    #Address 0xba read value
    csrr x14, 0xba

    #Address 0xba read value
    csrr x14, 0xba

    #Unmapped address 0x7e6 testing: random write/read operations
    #Address 0x7e6 read value
    csrr x14, 0x7e6

    #Address 0x7e6 Write value 0xd6750e1
    li x3, 0xd6750e1
    csrw 0x7e6, x3

    #Address 0x7e6 read value
    csrr x14, 0x7e6

    #Unmapped address 0x15b testing: random write/read operations
    #Address 0x15b read value
    csrr x14, 0x15b

    #Unmapped address 0x5f3 testing: random write/read operations
    #Address 0x5f3 Write value 0x33f4182e
    li x3, 0x33f4182e
    csrw 0x5f3, x3

    #Address 0x5f3 Write value 0x974376cd
    li x3, 0x974376cd
    csrw 0x5f3, x3

    #Address 0x5f3 Write value 0xec8ff2ef
    li x3, 0xec8ff2ef
    csrw 0x5f3, x3

    #Address 0x5f3 Write value 0x2f9fc6ee
    li x3, 0x2f9fc6ee
    csrw 0x5f3, x3

    #Unmapped address 0x384 testing: random write/read operations
    #Address 0x384 read value
    csrr x14, 0x384

    #Address 0x384 Write value 0x7b846b8
    li x3, 0x7b846b8
    csrw 0x384, x3

    #Address 0x384 read value
    csrr x14, 0x384

    #Unmapped address 0x7f0 testing: random write/read operations
    #Address 0x7f0 read value
    csrr x14, 0x7f0

    #Mapped address 0x3b1 (pmpaddr1) testing: random write/read operations
    #Address 0x3b1 read value
    csrr x14, 0x3b1

    #Address 0x3b1 read value
    csrr x14, 0x3b1

    #Address 0x3b1 read value
    csrr x14, 0x3b1

    #Address 0x3b1 Write value 0x71b841bc
    li x3, 0x71b841bc
    csrw 0x3b1, x3

    #Unmapped address 0x4a4 testing: random write/read operations
    #Address 0x4a4 Write value 0xf8cf1e47
    li x3, 0xf8cf1e47
    csrw 0x4a4, x3

    #Unmapped address 0x88a testing: random write/read operations
    #Address 0x88a Write value 0x87379b5f
    li x3, 0x87379b5f
    csrw 0x88a, x3

    #Address 0x88a read value
    csrr x14, 0x88a

    #Address 0x88a Write value 0x8050b61
    li x3, 0x8050b61
    csrw 0x88a, x3

    #Address 0x88a read value
    csrr x14, 0x88a

    #Unmapped address 0xd2d testing: random write/read operations
    #Address 0xd2d Write value 0xd2749a1b
    li x3, 0xd2749a1b
    csrw 0xd2d, x3

    #Address 0xd2d read value
    csrr x14, 0xd2d

    #Unmapped address 0xd82 testing: random write/read operations
    #Address 0xd82 read value
    csrr x14, 0xd82

    #Address 0xd82 Write value 0x88a3d100
    li x3, 0x88a3d100
    csrw 0xd82, x3

    #Unmapped address 0xd47 testing: random write/read operations
    #Address 0xd47 Write value 0x12930ef2
    li x3, 0x12930ef2
    csrw 0xd47, x3

    #Address 0xd47 Write value 0xb8fb255
    li x3, 0xb8fb255
    csrw 0xd47, x3

    #Address 0xd47 Write value 0x7e149f81
    li x3, 0x7e149f81
    csrw 0xd47, x3

    #Address 0xd47 Write value 0x9ac7a7e3
    li x3, 0x9ac7a7e3
    csrw 0xd47, x3

    #Address 0xd47 read value
    csrr x14, 0xd47

    #Unmapped address 0x499 testing: random write/read operations
    #Address 0x499 Write value 0x2d8fe376
    li x3, 0x2d8fe376
    csrw 0x499, x3

    #Address 0x499 read value
    csrr x14, 0x499

    #Unmapped address 0x79e testing: random write/read operations
    #Address 0x79e Write value 0xe9aa4844
    li x3, 0xe9aa4844
    csrw 0x79e, x3

    #Address 0x79e read value
    csrr x14, 0x79e

    #Address 0x79e Write value 0xd9a7dfed
    li x3, 0xd9a7dfed
    csrw 0x79e, x3

    #Address 0x79e read value
    csrr x14, 0x79e

    #Unmapped address 0x41d testing: random write/read operations
    #Address 0x41d read value
    csrr x14, 0x41d

    #Address 0x41d read value
    csrr x14, 0x41d

    #Unmapped address 0x8e3 testing: random write/read operations
    #Address 0x8e3 Write value 0x76fac324
    li x3, 0x76fac324
    csrw 0x8e3, x3

    #Address 0x8e3 Write value 0xb78f2b70
    li x3, 0xb78f2b70
    csrw 0x8e3, x3

    #Address 0x8e3 Write value 0xbf168e66
    li x3, 0xbf168e66
    csrw 0x8e3, x3

    #Unmapped address 0xd3a testing: random write/read operations
    #Address 0xd3a Write value 0xf14ae8
    li x3, 0xf14ae8
    csrw 0xd3a, x3

    #Address 0xd3a read value
    csrr x14, 0xd3a

    #Address 0xd3a read value
    csrr x14, 0xd3a

    #Address 0xd3a read value
    csrr x14, 0xd3a

    #Unmapped address 0xcb6 testing: random write/read operations
    #Address 0xcb6 Write value 0xd388f2f8
    li x3, 0xd388f2f8
    csrw 0xcb6, x3

    #Address 0xcb6 Write value 0xcd3df4e0
    li x3, 0xcd3df4e0
    csrw 0xcb6, x3

    #Address 0xcb6 Write value 0x6725f042
    li x3, 0x6725f042
    csrw 0xcb6, x3

    #Address 0xcb6 read value
    csrr x14, 0xcb6

    #Unmapped address 0x56c testing: random write/read operations
    #Address 0x56c Write value 0x1f004753
    li x3, 0x1f004753
    csrw 0x56c, x3

    #Unmapped address 0xe69 testing: random write/read operations
    #Address 0xe69 read value
    csrr x14, 0xe69

    #Address 0xe69 Write value 0x7429309c
    li x3, 0x7429309c
    csrw 0xe69, x3

    #Address 0xe69 read value
    csrr x14, 0xe69

    #Address 0xe69 read value
    csrr x14, 0xe69

    #Address 0xe69 Write value 0x336d2b91
    li x3, 0x336d2b91
    csrw 0xe69, x3

    #Unmapped address 0x58f testing: random write/read operations
    #Address 0x58f read value
    csrr x14, 0x58f

    #Mapped address 0x3be (pmpaddr14) testing: random write/read operations
    #Address 0x3be read value
    csrr x14, 0x3be

    #Address 0x3be Write value 0x7aca9ad
    li x3, 0x7aca9ad
    csrw 0x3be, x3

    #Address 0x3be Write value 0x2dabd3c9
    li x3, 0x2dabd3c9
    csrw 0x3be, x3

    #Unmapped address 0x217 testing: random write/read operations
    #Address 0x217 Write value 0xef7555f9
    li x3, 0xef7555f9
    csrw 0x217, x3

    #Address 0x217 read value
    csrr x14, 0x217

    #Address 0x217 read value
    csrr x14, 0x217

    #Address 0x217 Write value 0xbdaa4de7
    li x3, 0xbdaa4de7
    csrw 0x217, x3

    #Address 0x217 Write value 0x10444445
    li x3, 0x10444445
    csrw 0x217, x3

    #Unmapped address 0x63f testing: random write/read operations
    #Address 0x63f read value
    csrr x14, 0x63f

    #Address 0x63f read value
    csrr x14, 0x63f

    #Address 0x63f Write value 0x62991720
    li x3, 0x62991720
    csrw 0x63f, x3

    #Address 0x63f read value
    csrr x14, 0x63f

    #Unmapped address 0xbc testing: random write/read operations
    #Address 0xbc read value
    csrr x14, 0xbc

    #Address 0xbc Write value 0x5d9d5271
    li x3, 0x5d9d5271
    csrw 0xbc, x3

    #Address 0xbc read value
    csrr x14, 0xbc

    #Unmapped address 0x97b testing: random write/read operations
    #Address 0x97b Write value 0x5795e738
    li x3, 0x5795e738
    csrw 0x97b, x3

    #Unmapped address 0x81c testing: random write/read operations
    #Address 0x81c read value
    csrr x14, 0x81c

    #Address 0x81c Write value 0xae0ee352
    li x3, 0xae0ee352
    csrw 0x81c, x3

    #Address 0x81c Write value 0xda98b635
    li x3, 0xda98b635
    csrw 0x81c, x3

    #Address 0x81c Write value 0x18c7b904
    li x3, 0x18c7b904
    csrw 0x81c, x3

    #Address 0x81c Write value 0xf8782460
    li x3, 0xf8782460
    csrw 0x81c, x3

    #Unmapped address 0xfe5 testing: random write/read operations
    #Address 0xfe5 read value
    csrr x14, 0xfe5

    #Address 0xfe5 Write value 0xcee6977c
    li x3, 0xcee6977c
    csrw 0xfe5, x3

    #Address 0xfe5 read value
    csrr x14, 0xfe5

    #Unmapped address 0x44 testing: random write/read operations
    #Address 0x44 Write value 0x2e67ef51
    li x3, 0x2e67ef51
    csrw 0x44, x3

    #Address 0x44 read value
    csrr x14, 0x44

    #Address 0x44 Write value 0x3bf7052e
    li x3, 0x3bf7052e
    csrw 0x44, x3

    #Address 0x44 read value
    csrr x14, 0x44

    #Address 0x44 Write value 0x7f3a005b
    li x3, 0x7f3a005b
    csrw 0x44, x3

    #Unmapped address 0x910 testing: random write/read operations
    #Address 0x910 Write value 0x6b923372
    li x3, 0x6b923372
    csrw 0x910, x3

    #Address 0x910 Write value 0x43c7e7ef
    li x3, 0x43c7e7ef
    csrw 0x910, x3

    #Address 0x910 read value
    csrr x14, 0x910

    #Unmapped address 0xaa4 testing: random write/read operations
    #Address 0xaa4 read value
    csrr x14, 0xaa4

    #Address 0xaa4 read value
    csrr x14, 0xaa4

    #Address 0xaa4 Write value 0x90cbbd71
    li x3, 0x90cbbd71
    csrw 0xaa4, x3

    #Unmapped address 0xc50 testing: random write/read operations
    #Address 0xc50 read value
    csrr x14, 0xc50

    #Unmapped address 0x18e testing: random write/read operations
    #Address 0x18e read value
    csrr x14, 0x18e

    #Address 0x18e read value
    csrr x14, 0x18e

    #Address 0x18e read value
    csrr x14, 0x18e

    #Unmapped address 0x454 testing: random write/read operations
    #Address 0x454 Write value 0xafbacbbc
    li x3, 0xafbacbbc
    csrw 0x454, x3

    #Address 0x454 Write value 0x9312b6d0
    li x3, 0x9312b6d0
    csrw 0x454, x3

    #Address 0x454 read value
    csrr x14, 0x454

    #Unmapped address 0x372 testing: random write/read operations
    #Address 0x372 read value
    csrr x14, 0x372

    #Address 0x372 Write value 0xb2b8ae35
    li x3, 0xb2b8ae35
    csrw 0x372, x3

    #Address 0x372 Write value 0xf5c22edf
    li x3, 0xf5c22edf
    csrw 0x372, x3

    #Unmapped address 0xb3f testing: random write/read operations
    #Address 0xb3f read value
    csrr x14, 0xb3f

    #Unmapped address 0x2be testing: random write/read operations
    #Address 0x2be read value
    csrr x14, 0x2be

    #Address 0x2be Write value 0x3b3342b
    li x3, 0x3b3342b
    csrw 0x2be, x3

    #Unmapped address 0x8d7 testing: random write/read operations
    #Address 0x8d7 read value
    csrr x14, 0x8d7

    #Address 0x8d7 Write value 0xe875e2d4
    li x3, 0xe875e2d4
    csrw 0x8d7, x3

    #Unmapped address 0x3d2 testing: random write/read operations
    #Address 0x3d2 read value
    csrr x14, 0x3d2

    #Address 0x3d2 read value
    csrr x14, 0x3d2

    #Address 0x3d2 Write value 0xc4609fe
    li x3, 0xc4609fe
    csrw 0x3d2, x3

    #Unmapped address 0xa7e testing: random write/read operations
    #Address 0xa7e read value
    csrr x14, 0xa7e

    #Address 0xa7e read value
    csrr x14, 0xa7e

    #Address 0xa7e Write value 0x5b4ef962
    li x3, 0x5b4ef962
    csrw 0xa7e, x3

    #Address 0xa7e Write value 0x333b249
    li x3, 0x333b249
    csrw 0xa7e, x3

    #Unmapped address 0x7b5 testing: random write/read operations
    #Address 0x7b5 Write value 0xce0c57fe
    li x3, 0xce0c57fe
    csrw 0x7b5, x3

    #Address 0x7b5 read value
    csrr x14, 0x7b5

    #Address 0x7b5 Write value 0x252a6c19
    li x3, 0x252a6c19
    csrw 0x7b5, x3

    #Unmapped address 0xf91 testing: random write/read operations
    #Address 0xf91 read value
    csrr x14, 0xf91

    #Address 0xf91 read value
    csrr x14, 0xf91

    #Address 0xf91 Write value 0x6be4fe1f
    li x3, 0x6be4fe1f
    csrw 0xf91, x3

    #Address 0xf91 Write value 0x90676e71
    li x3, 0x90676e71
    csrw 0xf91, x3

    #Unmapped address 0x8a1 testing: random write/read operations
    #Address 0x8a1 read value
    csrr x14, 0x8a1

    #Address 0x8a1 Write value 0x64f9b986
    li x3, 0x64f9b986
    csrw 0x8a1, x3

    #Address 0x8a1 Write value 0x1bd2436b
    li x3, 0x1bd2436b
    csrw 0x8a1, x3

    #Address 0x8a1 read value
    csrr x14, 0x8a1

    #Unmapped address 0x6 testing: random write/read operations
    #Address 0x6 read value
    csrr x14, 0x6

    #Unmapped address 0xd30 testing: random write/read operations
    #Address 0xd30 Write value 0x65eadf07
    li x3, 0x65eadf07
    csrw 0xd30, x3

    #Address 0xd30 Write value 0x8c987337
    li x3, 0x8c987337
    csrw 0xd30, x3

    #Address 0xd30 read value
    csrr x14, 0xd30

    #Address 0xd30 read value
    csrr x14, 0xd30

    #Address 0xd30 Write value 0x65ae405d
    li x3, 0x65ae405d
    csrw 0xd30, x3

    #Unmapped address 0x4ab testing: random write/read operations
    #Address 0x4ab read value
    csrr x14, 0x4ab

    #Address 0x4ab Write value 0x63a12996
    li x3, 0x63a12996
    csrw 0x4ab, x3

    #Address 0x4ab read value
    csrr x14, 0x4ab

    #Unmapped address 0x7bd testing: random write/read operations
    #Address 0x7bd read value
    csrr x14, 0x7bd

    #Address 0x7bd Write value 0xcdc9e7bd
    li x3, 0xcdc9e7bd
    csrw 0x7bd, x3

    #Address 0x7bd read value
    csrr x14, 0x7bd

    #Address 0x7bd Write value 0x7e8a71b5
    li x3, 0x7e8a71b5
    csrw 0x7bd, x3

    #Unmapped address 0xd6c testing: random write/read operations
    #Address 0xd6c Write value 0x9c4131de
    li x3, 0x9c4131de
    csrw 0xd6c, x3

    #Address 0xd6c read value
    csrr x14, 0xd6c

    #Mapped address 0xb8c (mhpmcounterh12) testing: random write/read operations
    #Address 0xb8c read value
    csrr x14, 0xb8c

    #Address 0xb8c read value
    csrr x14, 0xb8c

    #Address 0xb8c Write value 0xd1c462aa
    li x3, 0xd1c462aa
    csrw 0xb8c, x3

    #Unmapped address 0x514 testing: random write/read operations
    #Address 0x514 Write value 0x43c258de
    li x3, 0x43c258de
    csrw 0x514, x3

    #Address 0x514 Write value 0xdb0519fc
    li x3, 0xdb0519fc
    csrw 0x514, x3

    #Address 0x514 read value
    csrr x14, 0x514

    #Address 0x514 Write value 0xacd9b852
    li x3, 0xacd9b852
    csrw 0x514, x3

    #Address 0x514 read value
    csrr x14, 0x514

    #Unmapped address 0x7ff testing: random write/read operations
    #Address 0x7ff read value
    csrr x14, 0x7ff

    #Address 0x7ff read value
    csrr x14, 0x7ff

    #Unmapped address 0x13e testing: random write/read operations
    #Address 0x13e Write value 0x8c383697
    li x3, 0x8c383697
    csrw 0x13e, x3

    #Address 0x13e Write value 0x3ad6802a
    li x3, 0x3ad6802a
    csrw 0x13e, x3

    #Address 0x13e Write value 0x4f605e9
    li x3, 0x4f605e9
    csrw 0x13e, x3

    #Unmapped address 0x371 testing: random write/read operations
    #Address 0x371 read value
    csrr x14, 0x371

    #Address 0x371 read value
    csrr x14, 0x371

    #Address 0x371 read value
    csrr x14, 0x371

    #Unmapped address 0xfa9 testing: random write/read operations
    #Address 0xfa9 read value
    csrr x14, 0xfa9

    #Unmapped address 0x95e testing: random write/read operations
    #Address 0x95e read value
    csrr x14, 0x95e

    #Address 0x95e read value
    csrr x14, 0x95e

    #Address 0x95e read value
    csrr x14, 0x95e

    #Address 0x95e read value
    csrr x14, 0x95e

    #Address 0x95e read value
    csrr x14, 0x95e

    #Unmapped address 0x8a8 testing: random write/read operations
    #Address 0x8a8 Write value 0xfd822394
    li x3, 0xfd822394
    csrw 0x8a8, x3

    #Address 0x8a8 Write value 0x8d997653
    li x3, 0x8d997653
    csrw 0x8a8, x3

    #Unmapped address 0xceb testing: random write/read operations
    #Address 0xceb Write value 0xc34fbdf3
    li x3, 0xc34fbdf3
    csrw 0xceb, x3

    #Address 0xceb Write value 0x5a8cfd58
    li x3, 0x5a8cfd58
    csrw 0xceb, x3

    #Address 0xceb read value
    csrr x14, 0xceb

    #Address 0xceb Write value 0xf87a670
    li x3, 0xf87a670
    csrw 0xceb, x3

    #Unmapped address 0x8c2 testing: random write/read operations
    #Address 0x8c2 read value
    csrr x14, 0x8c2

    #Unmapped address 0x2ef testing: random write/read operations
    #Address 0x2ef Write value 0x9a616ac3
    li x3, 0x9a616ac3
    csrw 0x2ef, x3

    #Address 0x2ef Write value 0x904305d9
    li x3, 0x904305d9
    csrw 0x2ef, x3

    #Address 0x2ef Write value 0x96968e1b
    li x3, 0x96968e1b
    csrw 0x2ef, x3

    #Address 0x2ef Write value 0xc2b5e899
    li x3, 0xc2b5e899
    csrw 0x2ef, x3

    #Unmapped address 0xcd9 testing: random write/read operations
    #Address 0xcd9 Write value 0x99dc4173
    li x3, 0x99dc4173
    csrw 0xcd9, x3

    #Address 0xcd9 read value
    csrr x14, 0xcd9

    #Unmapped address 0x886 testing: random write/read operations
    #Address 0x886 read value
    csrr x14, 0x886

    #Address 0x886 read value
    csrr x14, 0x886

    #Address 0x886 Write value 0xe9acb762
    li x3, 0xe9acb762
    csrw 0x886, x3

    #Address 0x886 read value
    csrr x14, 0x886

    #Unmapped address 0xea0 testing: random write/read operations
    #Address 0xea0 Write value 0xca3445a7
    li x3, 0xca3445a7
    csrw 0xea0, x3

    #Address 0xea0 Write value 0xe8448328
    li x3, 0xe8448328
    csrw 0xea0, x3

    #Address 0xea0 Write value 0x6df1f75a
    li x3, 0x6df1f75a
    csrw 0xea0, x3

    #Address 0xea0 read value
    csrr x14, 0xea0

    #Unmapped address 0x529 testing: random write/read operations
    #Address 0x529 read value
    csrr x14, 0x529

    #Unmapped address 0x6b1 testing: random write/read operations
    #Address 0x6b1 read value
    csrr x14, 0x6b1

    #Address 0x6b1 read value
    csrr x14, 0x6b1

    #Address 0x6b1 read value
    csrr x14, 0x6b1

    #Address 0x6b1 Write value 0x704a848c
    li x3, 0x704a848c
    csrw 0x6b1, x3

    #Address 0x6b1 Write value 0x6ac38f79
    li x3, 0x6ac38f79
    csrw 0x6b1, x3

    #Unmapped address 0xd3 testing: random write/read operations
    #Address 0xd3 read value
    csrr x14, 0xd3

    #Address 0xd3 read value
    csrr x14, 0xd3

    #Address 0xd3 Write value 0xa535d724
    li x3, 0xa535d724
    csrw 0xd3, x3

    #Address 0xd3 Write value 0xaaee11ee
    li x3, 0xaaee11ee
    csrw 0xd3, x3

    #Unmapped address 0x78c testing: random write/read operations
    #Address 0x78c read value
    csrr x14, 0x78c

    #Unmapped address 0x9f2 testing: random write/read operations
    #Address 0x9f2 Write value 0xeb110be2
    li x3, 0xeb110be2
    csrw 0x9f2, x3

    #Unmapped address 0xdac testing: random write/read operations
    #Address 0xdac read value
    csrr x14, 0xdac

    #Address 0xdac read value
    csrr x14, 0xdac

    #Unmapped address 0xa76 testing: random write/read operations
    #Address 0xa76 read value
    csrr x14, 0xa76

    #Address 0xa76 Write value 0xf53a15d5
    li x3, 0xf53a15d5
    csrw 0xa76, x3

    #Address 0xa76 Write value 0x5f27dd80
    li x3, 0x5f27dd80
    csrw 0xa76, x3

    #Address 0xa76 read value
    csrr x14, 0xa76

    #Unmapped address 0x8e7 testing: random write/read operations
    #Address 0x8e7 read value
    csrr x14, 0x8e7

    #Address 0x8e7 Write value 0x4d3b1c3d
    li x3, 0x4d3b1c3d
    csrw 0x8e7, x3

    #Address 0x8e7 read value
    csrr x14, 0x8e7

    #Address 0x8e7 read value
    csrr x14, 0x8e7

    #Unmapped address 0xf0a testing: random write/read operations
    #Address 0xf0a Write value 0xf41f2a34
    li x3, 0xf41f2a34
    csrw 0xf0a, x3

    #Unmapped address 0xa9a testing: random write/read operations
    #Address 0xa9a read value
    csrr x14, 0xa9a

    #Unmapped address 0x74e testing: random write/read operations
    #Address 0x74e read value
    csrr x14, 0x74e

    #Unmapped address 0xdc0 testing: random write/read operations
    #Address 0xdc0 Write value 0x1c83a15f
    li x3, 0x1c83a15f
    csrw 0xdc0, x3

    #Address 0xdc0 read value
    csrr x14, 0xdc0

    #Unmapped address 0xc0b testing: random write/read operations
    #Address 0xc0b read value
    csrr x14, 0xc0b

    #Address 0xc0b Write value 0xa07ce25
    li x3, 0xa07ce25
    csrw 0xc0b, x3

    #Address 0xc0b Write value 0xce3ef336
    li x3, 0xce3ef336
    csrw 0xc0b, x3

    #Unmapped address 0x7c6 testing: random write/read operations
    #Address 0x7c6 read value
    csrr x14, 0x7c6

    #Address 0x7c6 Write value 0x8c97dc1d
    li x3, 0x8c97dc1d
    csrw 0x7c6, x3

    #Unmapped address 0xffc testing: random write/read operations
    #Address 0xffc Write value 0xb9dd6bda
    li x3, 0xb9dd6bda
    csrw 0xffc, x3

    #Address 0xffc read value
    csrr x14, 0xffc

    #Address 0xffc Write value 0xd25b50fa
    li x3, 0xd25b50fa
    csrw 0xffc, x3

    #Address 0xffc read value
    csrr x14, 0xffc

    #Unmapped address 0x711 testing: random write/read operations
    #Address 0x711 Write value 0x16f102a8
    li x3, 0x16f102a8
    csrw 0x711, x3

    #Address 0x711 read value
    csrr x14, 0x711

    #Address 0x711 Write value 0x8127ef9a
    li x3, 0x8127ef9a
    csrw 0x711, x3

    #Address 0x711 Write value 0xc1360f28
    li x3, 0xc1360f28
    csrw 0x711, x3

    #Address 0x711 Write value 0xed9340c1
    li x3, 0xed9340c1
    csrw 0x711, x3

    #Unmapped address 0x621 testing: random write/read operations
    #Address 0x621 Write value 0xed3e60ac
    li x3, 0xed3e60ac
    csrw 0x621, x3

    #Address 0x621 read value
    csrr x14, 0x621

    #Unmapped address 0xc8a testing: random write/read operations
    #Address 0xc8a Write value 0x39e2204e
    li x3, 0x39e2204e
    csrw 0xc8a, x3

    #Address 0xc8a read value
    csrr x14, 0xc8a

    #Address 0xc8a read value
    csrr x14, 0xc8a

    #Address 0xc8a Write value 0x5666a6de
    li x3, 0x5666a6de
    csrw 0xc8a, x3

    #Address 0xc8a Write value 0xc085ed4
    li x3, 0xc085ed4
    csrw 0xc8a, x3

    #Unmapped address 0xd17 testing: random write/read operations
    #Address 0xd17 Write value 0xa5466886
    li x3, 0xa5466886
    csrw 0xd17, x3

    #Address 0xd17 read value
    csrr x14, 0xd17

    #Address 0xd17 Write value 0x95200f4a
    li x3, 0x95200f4a
    csrw 0xd17, x3

    #Address 0xd17 Write value 0xf8fa711
    li x3, 0xf8fa711
    csrw 0xd17, x3

    #Unmapped address 0x26e testing: random write/read operations
    #Address 0x26e read value
    csrr x14, 0x26e

    #Address 0x26e Write value 0x5e4789f8
    li x3, 0x5e4789f8
    csrw 0x26e, x3

    #Address 0x26e Write value 0x18901420
    li x3, 0x18901420
    csrw 0x26e, x3

    #Unmapped address 0xf4d testing: random write/read operations
    #Address 0xf4d read value
    csrr x14, 0xf4d

    #Address 0xf4d read value
    csrr x14, 0xf4d

    #Address 0xf4d read value
    csrr x14, 0xf4d

    #Unmapped address 0x616 testing: random write/read operations
    #Address 0x616 read value
    csrr x14, 0x616

    #Address 0x616 Write value 0xacf29129
    li x3, 0xacf29129
    csrw 0x616, x3

    #Address 0x616 Write value 0x323cc493
    li x3, 0x323cc493
    csrw 0x616, x3

    #Address 0x616 read value
    csrr x14, 0x616

    #Address 0x616 read value
    csrr x14, 0x616

    #Unmapped address 0x659 testing: random write/read operations
    #Address 0x659 read value
    csrr x14, 0x659

    #Address 0x659 read value
    csrr x14, 0x659

    #Address 0x659 Write value 0xc6ce50b2
    li x3, 0xc6ce50b2
    csrw 0x659, x3

    #Address 0x659 Write value 0x2197c804
    li x3, 0x2197c804
    csrw 0x659, x3

    #Unmapped address 0xf2e testing: random write/read operations
    #Address 0xf2e Write value 0xc9f00512
    li x3, 0xc9f00512
    csrw 0xf2e, x3

    #Address 0xf2e Write value 0x8cb3c88
    li x3, 0x8cb3c88
    csrw 0xf2e, x3

    #Address 0xf2e read value
    csrr x14, 0xf2e

    #Address 0xf2e Write value 0xb99b9e6a
    li x3, 0xb99b9e6a
    csrw 0xf2e, x3

    #Unmapped address 0xd37 testing: random write/read operations
    #Address 0xd37 Write value 0xa63c477f
    li x3, 0xa63c477f
    csrw 0xd37, x3

    #Address 0xd37 Write value 0xad1f27d0
    li x3, 0xad1f27d0
    csrw 0xd37, x3

    #Address 0xd37 read value
    csrr x14, 0xd37

    #Address 0xd37 Write value 0x249fbf6b
    li x3, 0x249fbf6b
    csrw 0xd37, x3

    #Address 0xd37 Write value 0xd57fb935
    li x3, 0xd57fb935
    csrw 0xd37, x3

    #Unmapped address 0xe42 testing: random write/read operations
    #Address 0xe42 read value
    csrr x14, 0xe42

    #Mapped address 0x339 (mhpmevent25) testing: random write/read operations
    #Address 0x339 read value
    csrr x14, 0x339

    #Address 0x339 Write value 0x14383985
    li x3, 0x14383985
    csrw 0x339, x3

    #Address 0x339 Write value 0xa20263fb
    li x3, 0xa20263fb
    csrw 0x339, x3

    #Unmapped address 0xfac testing: random write/read operations
    #Address 0xfac read value
    csrr x14, 0xfac

    #Unmapped address 0x5e7 testing: random write/read operations
    #Address 0x5e7 read value
    csrr x14, 0x5e7

    #Mapped address 0xb90 (mhpmcounterh16) testing: random write/read operations
    #Address 0xb90 read value
    csrr x14, 0xb90

    #Address 0xb90 Write value 0x822e81bb
    li x3, 0x822e81bb
    csrw 0xb90, x3

    #Address 0xb90 Write value 0x4c1e2b8c
    li x3, 0x4c1e2b8c
    csrw 0xb90, x3

    #Address 0xb90 read value
    csrr x14, 0xb90

    #Unmapped address 0xd68 testing: random write/read operations
    #Address 0xd68 Write value 0xecacb757
    li x3, 0xecacb757
    csrw 0xd68, x3

    #Address 0xd68 Write value 0xbed179c6
    li x3, 0xbed179c6
    csrw 0xd68, x3

    #Address 0xd68 Write value 0xe706fe6a
    li x3, 0xe706fe6a
    csrw 0xd68, x3

    #Address 0xd68 read value
    csrr x14, 0xd68

    #Unmapped address 0x2bc testing: random write/read operations
    #Address 0x2bc Write value 0xc61aa6c0
    li x3, 0xc61aa6c0
    csrw 0x2bc, x3

    #Address 0x2bc Write value 0x6fc8b23b
    li x3, 0x6fc8b23b
    csrw 0x2bc, x3

    #Address 0x2bc Write value 0xc01c5dba
    li x3, 0xc01c5dba
    csrw 0x2bc, x3

    #Address 0x2bc read value
    csrr x14, 0x2bc

    #Mapped address 0xb8e (mhpmcounterh14) testing: random write/read operations
    #Address 0xb8e read value
    csrr x14, 0xb8e

    #Unmapped address 0x15a testing: random write/read operations
    #Address 0x15a read value
    csrr x14, 0x15a

    #Address 0x15a Write value 0xc0c00198
    li x3, 0xc0c00198
    csrw 0x15a, x3

    #Address 0x15a read value
    csrr x14, 0x15a

    #Unmapped address 0x6b5 testing: random write/read operations
    #Address 0x6b5 Write value 0x5b94ad98
    li x3, 0x5b94ad98
    csrw 0x6b5, x3

    #Address 0x6b5 read value
    csrr x14, 0x6b5

    #Address 0x6b5 read value
    csrr x14, 0x6b5

    #Address 0x6b5 read value
    csrr x14, 0x6b5

    #Address 0x6b5 read value
    csrr x14, 0x6b5

    #Unmapped address 0x545 testing: random write/read operations
    #Address 0x545 Write value 0x58859182
    li x3, 0x58859182
    csrw 0x545, x3

    #Address 0x545 Write value 0x347ee6f1
    li x3, 0x347ee6f1
    csrw 0x545, x3

    #Address 0x545 Write value 0xe672a4c1
    li x3, 0xe672a4c1
    csrw 0x545, x3

    #Address 0x545 Write value 0xe0b1552
    li x3, 0xe0b1552
    csrw 0x545, x3

    #Unmapped address 0x66a testing: random write/read operations
    #Address 0x66a Write value 0x318200f9
    li x3, 0x318200f9
    csrw 0x66a, x3

    #Unmapped address 0xdc6 testing: random write/read operations
    #Address 0xdc6 read value
    csrr x14, 0xdc6

    #Address 0xdc6 Write value 0x9d109fcb
    li x3, 0x9d109fcb
    csrw 0xdc6, x3

    #Address 0xdc6 read value
    csrr x14, 0xdc6

    #Unmapped address 0xf09 testing: random write/read operations
    #Address 0xf09 read value
    csrr x14, 0xf09

    #Address 0xf09 Write value 0xbaea25b1
    li x3, 0xbaea25b1
    csrw 0xf09, x3

    #Unmapped address 0xb6d testing: random write/read operations
    #Address 0xb6d Write value 0x2b82d51b
    li x3, 0x2b82d51b
    csrw 0xb6d, x3

    #Address 0xb6d Write value 0x3845c5a4
    li x3, 0x3845c5a4
    csrw 0xb6d, x3

    #Address 0xb6d Write value 0xde6db68a
    li x3, 0xde6db68a
    csrw 0xb6d, x3

    #Address 0xb6d read value
    csrr x14, 0xb6d

    #Unmapped address 0x220 testing: random write/read operations
    #Address 0x220 read value
    csrr x14, 0x220

    #Address 0x220 read value
    csrr x14, 0x220

    #Address 0x220 Write value 0x68f36ec8
    li x3, 0x68f36ec8
    csrw 0x220, x3

    #Address 0x220 read value
    csrr x14, 0x220

    #Address 0x220 read value
    csrr x14, 0x220

    #Mapped address 0x3b2 (pmpaddr2) testing: random write/read operations
    #Address 0x3b2 read value
    csrr x14, 0x3b2

    #Address 0x3b2 Write value 0xa73bffc5
    li x3, 0xa73bffc5
    csrw 0x3b2, x3

    #Address 0x3b2 Write value 0x36351aff
    li x3, 0x36351aff
    csrw 0x3b2, x3

    #Address 0x3b2 Write value 0xb7e63e87
    li x3, 0xb7e63e87
    csrw 0x3b2, x3

    #Unmapped address 0x13b testing: random write/read operations
    #Address 0x13b Write value 0x326044dc
    li x3, 0x326044dc
    csrw 0x13b, x3

    #Address 0x13b read value
    csrr x14, 0x13b

    #Address 0x13b Write value 0x10ea6747
    li x3, 0x10ea6747
    csrw 0x13b, x3

    #Address 0x13b read value
    csrr x14, 0x13b

    #Unmapped address 0x406 testing: random write/read operations
    #Address 0x406 Write value 0xbce40345
    li x3, 0xbce40345
    csrw 0x406, x3

    #Address 0x406 Write value 0x3c8a24e9
    li x3, 0x3c8a24e9
    csrw 0x406, x3

    #Unmapped address 0x59b testing: random write/read operations
    #Address 0x59b read value
    csrr x14, 0x59b

    #Address 0x59b read value
    csrr x14, 0x59b

    #Address 0x59b Write value 0xa47af438
    li x3, 0xa47af438
    csrw 0x59b, x3

    #Address 0x59b Write value 0xa386e6b3
    li x3, 0xa386e6b3
    csrw 0x59b, x3

    #Address 0x59b read value
    csrr x14, 0x59b

    #Mapped address 0xb0f (mhpmcounter15) testing: random write/read operations
    #Address 0xb0f read value
    csrr x14, 0xb0f

    #Unmapped address 0xa7c testing: random write/read operations
    #Address 0xa7c read value
    csrr x14, 0xa7c

    #Address 0xa7c read value
    csrr x14, 0xa7c

    #Address 0xa7c Write value 0x8acf503e
    li x3, 0x8acf503e
    csrw 0xa7c, x3

    #Address 0xa7c read value
    csrr x14, 0xa7c

    #Address 0xa7c Write value 0x2b263361
    li x3, 0x2b263361
    csrw 0xa7c, x3

    #Unmapped address 0x660 testing: random write/read operations
    #Address 0x660 read value
    csrr x14, 0x660

    #Address 0x660 read value
    csrr x14, 0x660

    #Address 0x660 read value
    csrr x14, 0x660

    #Unmapped address 0x2e testing: random write/read operations
    #Address 0x2e Write value 0x68a751e3
    li x3, 0x68a751e3
    csrw 0x2e, x3

    #Address 0x2e Write value 0xce8687bc
    li x3, 0xce8687bc
    csrw 0x2e, x3

    #Unmapped address 0x89 testing: random write/read operations
    #Address 0x89 Write value 0xd78607d2
    li x3, 0xd78607d2
    csrw 0x89, x3

    #Address 0x89 Write value 0x8ed51572
    li x3, 0x8ed51572
    csrw 0x89, x3

    #Address 0x89 Write value 0xd2ccc8c6
    li x3, 0xd2ccc8c6
    csrw 0x89, x3

    #Address 0x89 read value
    csrr x14, 0x89

    #Address 0x89 read value
    csrr x14, 0x89

    #Unmapped address 0xe4e testing: random write/read operations
    #Address 0xe4e read value
    csrr x14, 0xe4e

    #Address 0xe4e Write value 0x2bec2112
    li x3, 0x2bec2112
    csrw 0xe4e, x3

    #Address 0xe4e read value
    csrr x14, 0xe4e

    #Address 0xe4e read value
    csrr x14, 0xe4e

    #Unmapped address 0x467 testing: random write/read operations
    #Address 0x467 Write value 0x6bfa1496
    li x3, 0x6bfa1496
    csrw 0x467, x3

    #Address 0x467 read value
    csrr x14, 0x467

    #Address 0x467 read value
    csrr x14, 0x467

    #Address 0x467 read value
    csrr x14, 0x467

    #Mapped address 0x32b (mhpmevent11) testing: random write/read operations
    #Address 0x32b read value
    csrr x14, 0x32b

    #Unmapped address 0x367 testing: random write/read operations
    #Address 0x367 read value
    csrr x14, 0x367

    #Unmapped address 0x22d testing: random write/read operations
    #Address 0x22d Write value 0x283c1fe2
    li x3, 0x283c1fe2
    csrw 0x22d, x3

    #Address 0x22d Write value 0xb8ddbd18
    li x3, 0xb8ddbd18
    csrw 0x22d, x3

    #Unmapped address 0xacf testing: random write/read operations
    #Address 0xacf read value
    csrr x14, 0xacf

    #Address 0xacf Write value 0x58eb8654
    li x3, 0x58eb8654
    csrw 0xacf, x3

    #Address 0xacf Write value 0x725d7332
    li x3, 0x725d7332
    csrw 0xacf, x3

    #Unmapped address 0xf52 testing: random write/read operations
    #Address 0xf52 read value
    csrr x14, 0xf52

    #Unmapped address 0xe02 testing: random write/read operations
    #Address 0xe02 Write value 0xbd71c25b
    li x3, 0xbd71c25b
    csrw 0xe02, x3

    #Address 0xe02 read value
    csrr x14, 0xe02

    #Address 0xe02 Write value 0x9ffb80fb
    li x3, 0x9ffb80fb
    csrw 0xe02, x3

    #Address 0xe02 Write value 0x7b3f35f1
    li x3, 0x7b3f35f1
    csrw 0xe02, x3

    #Unmapped address 0x19b testing: random write/read operations
    #Address 0x19b read value
    csrr x14, 0x19b

    #Address 0x19b read value
    csrr x14, 0x19b

    #Address 0x19b read value
    csrr x14, 0x19b

    #Address 0x19b Write value 0x16082aa4
    li x3, 0x16082aa4
    csrw 0x19b, x3

    #Unmapped address 0xcdd testing: random write/read operations
    #Address 0xcdd read value
    csrr x14, 0xcdd

    #Address 0xcdd read value
    csrr x14, 0xcdd

    #Address 0xcdd read value
    csrr x14, 0xcdd

    #Address 0xcdd read value
    csrr x14, 0xcdd

    #Mapped address 0x33f (mhpmevent31) testing: random write/read operations
    #Address 0x33f Write value 0xf83de662
    li x3, 0xf83de662
    csrw 0x33f, x3

    #Address 0x33f read value
    csrr x14, 0x33f

    #Unmapped address 0xce2 testing: random write/read operations
    #Address 0xce2 read value
    csrr x14, 0xce2

    #Address 0xce2 read value
    csrr x14, 0xce2

    #Address 0xce2 Write value 0xee732115
    li x3, 0xee732115
    csrw 0xce2, x3

    #Address 0xce2 read value
    csrr x14, 0xce2

    #Unmapped address 0xf2f testing: random write/read operations
    #Address 0xf2f Write value 0x71a80ba2
    li x3, 0x71a80ba2
    csrw 0xf2f, x3

    #Address 0xf2f read value
    csrr x14, 0xf2f

    #Address 0xf2f Write value 0x180b7052
    li x3, 0x180b7052
    csrw 0xf2f, x3

    #Address 0xf2f Write value 0x57671fe7
    li x3, 0x57671fe7
    csrw 0xf2f, x3

    #Mapped address 0xb02 (minstret) testing: random write/read operations
    #Address 0xb02 read value
    csrr x14, 0xb02

    #Address 0xb02 Write value 0x885b5028
    li x3, 0x885b5028
    csrw 0xb02, x3

    #Unmapped address 0x66f testing: random write/read operations
    #Address 0x66f Write value 0xfca187d1
    li x3, 0xfca187d1
    csrw 0x66f, x3

    #Address 0x66f read value
    csrr x14, 0x66f

    #Address 0x66f Write value 0xe5f7b7d5
    li x3, 0xe5f7b7d5
    csrw 0x66f, x3

    #Unmapped address 0x7fd testing: random write/read operations
    #Address 0x7fd Write value 0xd34c5bf
    li x3, 0xd34c5bf
    csrw 0x7fd, x3

    #Mapped address 0xb1d (mhpmcounter29) testing: random write/read operations
    #Address 0xb1d Write value 0xff38843c
    li x3, 0xff38843c
    csrw 0xb1d, x3

    #Address 0xb1d Write value 0x279b0293
    li x3, 0x279b0293
    csrw 0xb1d, x3

    #Address 0xb1d read value
    csrr x14, 0xb1d

    #Unmapped address 0xc9d testing: random write/read operations
    #Address 0xc9d read value
    csrr x14, 0xc9d

    #Address 0xc9d read value
    csrr x14, 0xc9d

    #Address 0xc9d Write value 0xf9794b80
    li x3, 0xf9794b80
    csrw 0xc9d, x3

    #Address 0xc9d Write value 0x19633bed
    li x3, 0x19633bed
    csrw 0xc9d, x3

    #Address 0xc9d Write value 0xa21be42
    li x3, 0xa21be42
    csrw 0xc9d, x3

    #Unmapped address 0x627 testing: random write/read operations
    #Address 0x627 read value
    csrr x14, 0x627

    #Unmapped address 0xff2 testing: random write/read operations
    #Address 0xff2 read value
    csrr x14, 0xff2

    #Address 0xff2 read value
    csrr x14, 0xff2

    #Address 0xff2 read value
    csrr x14, 0xff2

    #Address 0xff2 Write value 0xe213e239
    li x3, 0xe213e239
    csrw 0xff2, x3

    #Unmapped address 0xb4 testing: random write/read operations
    #Address 0xb4 read value
    csrr x14, 0xb4

    #Address 0xb4 read value
    csrr x14, 0xb4

    #Address 0xb4 read value
    csrr x14, 0xb4

    #Unmapped address 0x3 testing: random write/read operations
    #Address 0x3 read value
    csrr x14, 0x3

    #Address 0x3 Write value 0xd3240cf
    li x3, 0xd3240cf
    csrw 0x3, x3

    #Address 0x3 read value
    csrr x14, 0x3

    #Unmapped address 0x21c testing: random write/read operations
    #Address 0x21c Write value 0xbbc856d4
    li x3, 0xbbc856d4
    csrw 0x21c, x3

    #Address 0x21c Write value 0x70f1a3af
    li x3, 0x70f1a3af
    csrw 0x21c, x3

    #Unmapped address 0x6d9 testing: random write/read operations
    #Address 0x6d9 read value
    csrr x14, 0x6d9

    #Address 0x6d9 Write value 0x155a4fe7
    li x3, 0x155a4fe7
    csrw 0x6d9, x3

    #Address 0x6d9 Write value 0x43559259
    li x3, 0x43559259
    csrw 0x6d9, x3

    #Unmapped address 0xe31 testing: random write/read operations
    #Address 0xe31 read value
    csrr x14, 0xe31

    #Address 0xe31 Write value 0x936d4045
    li x3, 0x936d4045
    csrw 0xe31, x3

    #Address 0xe31 read value
    csrr x14, 0xe31

    #Address 0xe31 read value
    csrr x14, 0xe31

    #Unmapped address 0xbab testing: random write/read operations
    #Address 0xbab Write value 0x36acb1ef
    li x3, 0x36acb1ef
    csrw 0xbab, x3

    #Address 0xbab Write value 0xc2c08bec
    li x3, 0xc2c08bec
    csrw 0xbab, x3

    #Address 0xbab read value
    csrr x14, 0xbab

    #Address 0xbab read value
    csrr x14, 0xbab

    #Address 0xbab Write value 0x91f7a883
    li x3, 0x91f7a883
    csrw 0xbab, x3

    #Unmapped address 0x617 testing: random write/read operations
    #Address 0x617 Write value 0xc18c501f
    li x3, 0xc18c501f
    csrw 0x617, x3

    #Address 0x617 Write value 0xd8833520
    li x3, 0xd8833520
    csrw 0x617, x3

    #Address 0x617 read value
    csrr x14, 0x617

    #Address 0x617 Write value 0xc1beea7d
    li x3, 0xc1beea7d
    csrw 0x617, x3

    #Address 0x617 read value
    csrr x14, 0x617

    #Mapped address 0xb0c (mhpmcounter12) testing: random write/read operations
    #Address 0xb0c Write value 0xbb000e28
    li x3, 0xbb000e28
    csrw 0xb0c, x3

    #Address 0xb0c read value
    csrr x14, 0xb0c

    #Unmapped address 0x761 testing: random write/read operations
    #Address 0x761 read value
    csrr x14, 0x761

    #Address 0x761 Write value 0x506f68a4
    li x3, 0x506f68a4
    csrw 0x761, x3

    #Address 0x761 Write value 0x8bb2f31
    li x3, 0x8bb2f31
    csrw 0x761, x3

    #Address 0x761 read value
    csrr x14, 0x761

    #Unmapped address 0x21f testing: random write/read operations
    #Address 0x21f read value
    csrr x14, 0x21f

    #Unmapped address 0xf5f testing: random write/read operations
    #Address 0xf5f read value
    csrr x14, 0xf5f

    #Address 0xf5f Write value 0x155d7177
    li x3, 0x155d7177
    csrw 0xf5f, x3

    #Address 0xf5f read value
    csrr x14, 0xf5f

    #Address 0xf5f read value
    csrr x14, 0xf5f

    #Unmapped address 0x71 testing: random write/read operations
    #Address 0x71 Write value 0xa5f80789
    li x3, 0xa5f80789
    csrw 0x71, x3

    #Address 0x71 Write value 0x21e9dece
    li x3, 0x21e9dece
    csrw 0x71, x3

    #Address 0x71 Write value 0x47a8293
    li x3, 0x47a8293
    csrw 0x71, x3

    #Address 0x71 read value
    csrr x14, 0x71

    #Unmapped address 0xf8d testing: random write/read operations
    #Address 0xf8d read value
    csrr x14, 0xf8d

    #Address 0xf8d Write value 0x7c325380
    li x3, 0x7c325380
    csrw 0xf8d, x3

    #Address 0xf8d read value
    csrr x14, 0xf8d

    #Unmapped address 0x684 testing: random write/read operations
    #Address 0x684 read value
    csrr x14, 0x684

    #Address 0x684 Write value 0xc347b721
    li x3, 0xc347b721
    csrw 0x684, x3

    #Unmapped address 0xdf1 testing: random write/read operations
    #Address 0xdf1 read value
    csrr x14, 0xdf1

    #Address 0xdf1 Write value 0x2b926341
    li x3, 0x2b926341
    csrw 0xdf1, x3

    #Unmapped address 0x2fa testing: random write/read operations
    #Address 0x2fa read value
    csrr x14, 0x2fa

    #Address 0x2fa Write value 0x9ddb26a2
    li x3, 0x9ddb26a2
    csrw 0x2fa, x3

    #Address 0x2fa read value
    csrr x14, 0x2fa

    #Address 0x2fa read value
    csrr x14, 0x2fa

    #Unmapped address 0x77d testing: random write/read operations
    #Address 0x77d Write value 0x62aff7e8
    li x3, 0x62aff7e8
    csrw 0x77d, x3

    #Unmapped address 0xffa testing: random write/read operations
    #Address 0xffa Write value 0xb6eb0d49
    li x3, 0xb6eb0d49
    csrw 0xffa, x3

    #Address 0xffa Write value 0x2e7d8d36
    li x3, 0x2e7d8d36
    csrw 0xffa, x3

    #Address 0xffa read value
    csrr x14, 0xffa

    #Unmapped address 0xa2 testing: random write/read operations
    #Address 0xa2 read value
    csrr x14, 0xa2

    #Address 0xa2 read value
    csrr x14, 0xa2

    #Address 0xa2 Write value 0xdd028b32
    li x3, 0xdd028b32
    csrw 0xa2, x3

    #Address 0xa2 Write value 0x7f11a6fe
    li x3, 0x7f11a6fe
    csrw 0xa2, x3

    #Unmapped address 0xbba testing: random write/read operations
    #Address 0xbba read value
    csrr x14, 0xbba

    #Address 0xbba read value
    csrr x14, 0xbba

    #Address 0xbba Write value 0x245ceb33
    li x3, 0x245ceb33
    csrw 0xbba, x3

    #Unmapped address 0xa39 testing: random write/read operations
    #Address 0xa39 Write value 0x45ddfcab
    li x3, 0x45ddfcab
    csrw 0xa39, x3

    #Address 0xa39 read value
    csrr x14, 0xa39

    #Address 0xa39 read value
    csrr x14, 0xa39

    #Address 0xa39 read value
    csrr x14, 0xa39

    #Unmapped address 0xaa0 testing: random write/read operations
    #Address 0xaa0 Write value 0xabb1c3b0
    li x3, 0xabb1c3b0
    csrw 0xaa0, x3

    #Address 0xaa0 Write value 0x9b4fb831
    li x3, 0x9b4fb831
    csrw 0xaa0, x3

    #Address 0xaa0 Write value 0x14cdf336
    li x3, 0x14cdf336
    csrw 0xaa0, x3

    #Address 0xaa0 read value
    csrr x14, 0xaa0

    #Address 0xaa0 read value
    csrr x14, 0xaa0

    #Unmapped address 0x79b testing: random write/read operations
    #Address 0x79b Write value 0x77f6cb9f
    li x3, 0x77f6cb9f
    csrw 0x79b, x3

    #Address 0x79b read value
    csrr x14, 0x79b

    #Address 0x79b read value
    csrr x14, 0x79b

    #Unmapped address 0x4c3 testing: random write/read operations
    #Address 0x4c3 Write value 0xd5038233
    li x3, 0xd5038233
    csrw 0x4c3, x3

    #Address 0x4c3 Write value 0x7ed0492c
    li x3, 0x7ed0492c
    csrw 0x4c3, x3

    #Address 0x4c3 read value
    csrr x14, 0x4c3

    #Address 0x4c3 Write value 0x1d6656f4
    li x3, 0x1d6656f4
    csrw 0x4c3, x3

    #Address 0x4c3 read value
    csrr x14, 0x4c3

    #Unmapped address 0x237 testing: random write/read operations
    #Address 0x237 read value
    csrr x14, 0x237

    #Address 0x237 Write value 0xae454116
    li x3, 0xae454116
    csrw 0x237, x3

    #Address 0x237 Write value 0xb10bfa18
    li x3, 0xb10bfa18
    csrw 0x237, x3

    #Address 0x237 Write value 0xe5ea7380
    li x3, 0xe5ea7380
    csrw 0x237, x3

    #Unmapped address 0xbc3 testing: random write/read operations
    #Address 0xbc3 Write value 0xe398f23
    li x3, 0xe398f23
    csrw 0xbc3, x3

    #Address 0xbc3 Write value 0x5aeb949b
    li x3, 0x5aeb949b
    csrw 0xbc3, x3

    #Unmapped address 0xaa6 testing: random write/read operations
    #Address 0xaa6 Write value 0x104cc8c1
    li x3, 0x104cc8c1
    csrw 0xaa6, x3

    #Address 0xaa6 Write value 0x19787c28
    li x3, 0x19787c28
    csrw 0xaa6, x3

    #Unmapped address 0x8d testing: random write/read operations
    #Address 0x8d Write value 0x7275a45b
    li x3, 0x7275a45b
    csrw 0x8d, x3

    #Address 0x8d read value
    csrr x14, 0x8d

    #Unmapped address 0x67f testing: random write/read operations
    #Address 0x67f read value
    csrr x14, 0x67f

    #Unmapped address 0xa12 testing: random write/read operations
    #Address 0xa12 Write value 0xa51b8e56
    li x3, 0xa51b8e56
    csrw 0xa12, x3

    #Address 0xa12 Write value 0xe385f5dd
    li x3, 0xe385f5dd
    csrw 0xa12, x3

    #Address 0xa12 read value
    csrr x14, 0xa12

    #Address 0xa12 read value
    csrr x14, 0xa12

    #Address 0xa12 Write value 0xa080be26
    li x3, 0xa080be26
    csrw 0xa12, x3

    #Unmapped address 0xbcb testing: random write/read operations
    #Address 0xbcb read value
    csrr x14, 0xbcb

    #Mapped address 0xb93 (mhpmcounterh19) testing: random write/read operations
    #Address 0xb93 Write value 0xe8131b86
    li x3, 0xe8131b86
    csrw 0xb93, x3

    #Address 0xb93 read value
    csrr x14, 0xb93

    #Address 0xb93 Write value 0xb1d91680
    li x3, 0xb1d91680
    csrw 0xb93, x3

    #Address 0xb93 read value
    csrr x14, 0xb93

    #Address 0xb93 read value
    csrr x14, 0xb93

    #Unmapped address 0x5a9 testing: random write/read operations
    #Address 0x5a9 Write value 0x71db254
    li x3, 0x71db254
    csrw 0x5a9, x3

    #Address 0x5a9 read value
    csrr x14, 0x5a9

    #Address 0x5a9 Write value 0x7830c648
    li x3, 0x7830c648
    csrw 0x5a9, x3

    #Address 0x5a9 Write value 0x97f201
    li x3, 0x97f201
    csrw 0x5a9, x3

    #Unmapped address 0xaf3 testing: random write/read operations
    #Address 0xaf3 Write value 0xc32ce6ca
    li x3, 0xc32ce6ca
    csrw 0xaf3, x3

    #Address 0xaf3 read value
    csrr x14, 0xaf3

    #Unmapped address 0x889 testing: random write/read operations
    #Address 0x889 read value
    csrr x14, 0x889

    #Unmapped address 0x1d0 testing: random write/read operations
    #Address 0x1d0 read value
    csrr x14, 0x1d0

    #Unmapped address 0x913 testing: random write/read operations
    #Address 0x913 read value
    csrr x14, 0x913

    #Address 0x913 Write value 0x56d6caa3
    li x3, 0x56d6caa3
    csrw 0x913, x3

    #Unmapped address 0xc16 testing: random write/read operations
    #Address 0xc16 Write value 0x8fefe9c
    li x3, 0x8fefe9c
    csrw 0xc16, x3

    #Address 0xc16 Write value 0xbd0f1c2b
    li x3, 0xbd0f1c2b
    csrw 0xc16, x3

    #Unmapped address 0x562 testing: random write/read operations
    #Address 0x562 Write value 0xbdbcc82f
    li x3, 0xbdbcc82f
    csrw 0x562, x3

    #Unmapped address 0xbcd testing: random write/read operations
    #Address 0xbcd Write value 0x14812afc
    li x3, 0x14812afc
    csrw 0xbcd, x3

    #Address 0xbcd read value
    csrr x14, 0xbcd

    #Address 0xbcd Write value 0x6bb2de82
    li x3, 0x6bb2de82
    csrw 0xbcd, x3

    #Unmapped address 0xc37 testing: random write/read operations
    #Address 0xc37 Write value 0xf8f416fb
    li x3, 0xf8f416fb
    csrw 0xc37, x3

    #Address 0xc37 read value
    csrr x14, 0xc37

    #Unmapped address 0x91e testing: random write/read operations
    #Address 0x91e read value
    csrr x14, 0x91e

    #Address 0x91e Write value 0x620f39a1
    li x3, 0x620f39a1
    csrw 0x91e, x3

    #Unmapped address 0xce6 testing: random write/read operations
    #Address 0xce6 Write value 0x37d1759e
    li x3, 0x37d1759e
    csrw 0xce6, x3

    #Address 0xce6 Write value 0x52bd8e3d
    li x3, 0x52bd8e3d
    csrw 0xce6, x3

    #Address 0xce6 read value
    csrr x14, 0xce6

    #Address 0xce6 read value
    csrr x14, 0xce6

    #Address 0xce6 Write value 0xa801accc
    li x3, 0xa801accc
    csrw 0xce6, x3

    #Unmapped address 0x568 testing: random write/read operations
    #Address 0x568 Write value 0x2d50ed84
    li x3, 0x2d50ed84
    csrw 0x568, x3

    #Unmapped address 0x3ef testing: random write/read operations
    #Address 0x3ef read value
    csrr x14, 0x3ef

    #Address 0x3ef read value
    csrr x14, 0x3ef

    #Address 0x3ef Write value 0xfeedc464
    li x3, 0xfeedc464
    csrw 0x3ef, x3

    #Unmapped address 0x869 testing: random write/read operations
    #Address 0x869 read value
    csrr x14, 0x869

    #Unmapped address 0x57a testing: random write/read operations
    #Address 0x57a read value
    csrr x14, 0x57a

    #Address 0x57a read value
    csrr x14, 0x57a

    #Address 0x57a read value
    csrr x14, 0x57a

    #Unmapped address 0xbd4 testing: random write/read operations
    #Address 0xbd4 read value
    csrr x14, 0xbd4

    #Address 0xbd4 Write value 0x6fd914e4
    li x3, 0x6fd914e4
    csrw 0xbd4, x3

    #Unmapped address 0x4c0 testing: random write/read operations
    #Address 0x4c0 Write value 0x70228d09
    li x3, 0x70228d09
    csrw 0x4c0, x3

    #Address 0x4c0 read value
    csrr x14, 0x4c0

    #Unmapped address 0x411 testing: random write/read operations
    #Address 0x411 read value
    csrr x14, 0x411

    #Unmapped address 0xc23 testing: random write/read operations
    #Address 0xc23 Write value 0xbf9cace8
    li x3, 0xbf9cace8
    csrw 0xc23, x3

    #Address 0xc23 read value
    csrr x14, 0xc23

    #Address 0xc23 Write value 0xa1c5a4c3
    li x3, 0xa1c5a4c3
    csrw 0xc23, x3

    #Unmapped address 0x1a9 testing: random write/read operations
    #Address 0x1a9 Write value 0xee76bc77
    li x3, 0xee76bc77
    csrw 0x1a9, x3

    #Address 0x1a9 read value
    csrr x14, 0x1a9

    #Address 0x1a9 Write value 0x2cb54ca5
    li x3, 0x2cb54ca5
    csrw 0x1a9, x3

    #Unmapped address 0xbbf testing: random write/read operations
    #Address 0xbbf read value
    csrr x14, 0xbbf

    #Address 0xbbf Write value 0xef072d4d
    li x3, 0xef072d4d
    csrw 0xbbf, x3

    #Address 0xbbf Write value 0xf39f5960
    li x3, 0xf39f5960
    csrw 0xbbf, x3

    #Unmapped address 0x799 testing: random write/read operations
    #Address 0x799 read value
    csrr x14, 0x799

    #Address 0x799 Write value 0x9d14b4de
    li x3, 0x9d14b4de
    csrw 0x799, x3

    #Unmapped address 0x9ee testing: random write/read operations
    #Address 0x9ee Write value 0x452c857
    li x3, 0x452c857
    csrw 0x9ee, x3

    #Unmapped address 0x7fe testing: random write/read operations
    #Address 0x7fe Write value 0x71840316
    li x3, 0x71840316
    csrw 0x7fe, x3

    #Address 0x7fe Write value 0x2fb0727e
    li x3, 0x2fb0727e
    csrw 0x7fe, x3

    #Mapped address 0xb17 (mhpmcounter23) testing: random write/read operations
    #Address 0xb17 read value
    csrr x14, 0xb17

    #Address 0xb17 Write value 0xfc54cfe7
    li x3, 0xfc54cfe7
    csrw 0xb17, x3

    #Address 0xb17 Write value 0x49397cab
    li x3, 0x49397cab
    csrw 0xb17, x3

    #Address 0xb17 Write value 0x92822d58
    li x3, 0x92822d58
    csrw 0xb17, x3

    #Unmapped address 0x629 testing: random write/read operations
    #Address 0x629 read value
    csrr x14, 0x629

    #Address 0x629 Write value 0x7a270f27
    li x3, 0x7a270f27
    csrw 0x629, x3

    #Unmapped address 0x671 testing: random write/read operations
    #Address 0x671 Write value 0xee65bd17
    li x3, 0xee65bd17
    csrw 0x671, x3

    #Address 0x671 read value
    csrr x14, 0x671

    #Address 0x671 read value
    csrr x14, 0x671

    #Address 0x671 Write value 0xfa4fc7b3
    li x3, 0xfa4fc7b3
    csrw 0x671, x3

    #Address 0x671 read value
    csrr x14, 0x671

    #Unmapped address 0xa6 testing: random write/read operations
    #Address 0xa6 read value
    csrr x14, 0xa6

    #Address 0xa6 read value
    csrr x14, 0xa6

    #Address 0xa6 read value
    csrr x14, 0xa6

    #Address 0xa6 read value
    csrr x14, 0xa6

    #Address 0xa6 Write value 0x1b94673a
    li x3, 0x1b94673a
    csrw 0xa6, x3

    #Unmapped address 0xe90 testing: random write/read operations
    #Address 0xe90 read value
    csrr x14, 0xe90

    #Address 0xe90 Write value 0x2429a5da
    li x3, 0x2429a5da
    csrw 0xe90, x3

    #Address 0xe90 Write value 0x7eba78b0
    li x3, 0x7eba78b0
    csrw 0xe90, x3

    #Unmapped address 0xc5e testing: random write/read operations
    #Address 0xc5e read value
    csrr x14, 0xc5e

    #Address 0xc5e read value
    csrr x14, 0xc5e

    #Address 0xc5e Write value 0xe6be16ae
    li x3, 0xe6be16ae
    csrw 0xc5e, x3

    #Address 0xc5e Write value 0x7836fd4a
    li x3, 0x7836fd4a
    csrw 0xc5e, x3

    #Unmapped address 0x8a testing: random write/read operations
    #Address 0x8a Write value 0xd18c465e
    li x3, 0xd18c465e
    csrw 0x8a, x3

    #Address 0x8a read value
    csrr x14, 0x8a

    #Unmapped address 0xe0e testing: random write/read operations
    #Address 0xe0e Write value 0x23e91aca
    li x3, 0x23e91aca
    csrw 0xe0e, x3

    #Unmapped address 0x99f testing: random write/read operations
    #Address 0x99f read value
    csrr x14, 0x99f

    #Unmapped address 0xcfa testing: random write/read operations
    #Address 0xcfa Write value 0xe4db9b75
    li x3, 0xe4db9b75
    csrw 0xcfa, x3

    #Address 0xcfa Write value 0xf1dfeb2a
    li x3, 0xf1dfeb2a
    csrw 0xcfa, x3

    #Address 0xcfa read value
    csrr x14, 0xcfa

    #Address 0xcfa Write value 0xce5d5f8e
    li x3, 0xce5d5f8e
    csrw 0xcfa, x3

    #Unmapped address 0xee1 testing: random write/read operations
    #Address 0xee1 read value
    csrr x14, 0xee1

    #Address 0xee1 Write value 0x21c40f82
    li x3, 0x21c40f82
    csrw 0xee1, x3

    #Unmapped address 0x4cb testing: random write/read operations
    #Address 0x4cb Write value 0xcf22dc4f
    li x3, 0xcf22dc4f
    csrw 0x4cb, x3

    #Address 0x4cb Write value 0x9a11c297
    li x3, 0x9a11c297
    csrw 0x4cb, x3

    #Address 0x4cb Write value 0xaf8ddf37
    li x3, 0xaf8ddf37
    csrw 0x4cb, x3

    #Unmapped address 0x5d2 testing: random write/read operations
    #Address 0x5d2 Write value 0xc0c64f24
    li x3, 0xc0c64f24
    csrw 0x5d2, x3

    #Address 0x5d2 read value
    csrr x14, 0x5d2

    #Unmapped address 0x22f testing: random write/read operations
    #Address 0x22f Write value 0x447c7f45
    li x3, 0x447c7f45
    csrw 0x22f, x3

    #Address 0x22f read value
    csrr x14, 0x22f

    #Address 0x22f read value
    csrr x14, 0x22f

    #Unmapped address 0x2bb testing: random write/read operations
    #Address 0x2bb read value
    csrr x14, 0x2bb

    #Address 0x2bb read value
    csrr x14, 0x2bb

    #Address 0x2bb Write value 0x96ac4898
    li x3, 0x96ac4898
    csrw 0x2bb, x3

    #Address 0x2bb Write value 0x24b58e85
    li x3, 0x24b58e85
    csrw 0x2bb, x3

    #Address 0x2bb Write value 0x55477448
    li x3, 0x55477448
    csrw 0x2bb, x3

    #Unmapped address 0x790 testing: random write/read operations
    #Address 0x790 read value
    csrr x14, 0x790

    #Address 0x790 Write value 0xf242bc3d
    li x3, 0xf242bc3d
    csrw 0x790, x3

    #Address 0x790 read value
    csrr x14, 0x790

    #Address 0x790 read value
    csrr x14, 0x790

    #Unmapped address 0x518 testing: random write/read operations
    #Address 0x518 Write value 0x5e517fe
    li x3, 0x5e517fe
    csrw 0x518, x3

    #Address 0x518 Write value 0x2eaf3ea4
    li x3, 0x2eaf3ea4
    csrw 0x518, x3

    #Address 0x518 Write value 0x8216b5fc
    li x3, 0x8216b5fc
    csrw 0x518, x3

    #Address 0x518 read value
    csrr x14, 0x518

    #Unmapped address 0x776 testing: random write/read operations
    #Address 0x776 read value
    csrr x14, 0x776

    #Address 0x776 Write value 0xa95c7fae
    li x3, 0xa95c7fae
    csrw 0x776, x3

    #Address 0x776 read value
    csrr x14, 0x776

    #Unmapped address 0x17b testing: random write/read operations
    #Address 0x17b Write value 0x83800ff0
    li x3, 0x83800ff0
    csrw 0x17b, x3

    #Address 0x17b Write value 0x30c9a38d
    li x3, 0x30c9a38d
    csrw 0x17b, x3

    #Unmapped address 0x8c0 testing: random write/read operations
    #Address 0x8c0 Write value 0x24c37a26
    li x3, 0x24c37a26
    csrw 0x8c0, x3

    #Address 0x8c0 Write value 0x54b20323
    li x3, 0x54b20323
    csrw 0x8c0, x3

    #Address 0x8c0 Write value 0x6d094ce0
    li x3, 0x6d094ce0
    csrw 0x8c0, x3

    #Address 0x8c0 read value
    csrr x14, 0x8c0

    #Unmapped address 0x3c3 testing: random write/read operations
    #Address 0x3c3 Write value 0xb1d9c205
    li x3, 0xb1d9c205
    csrw 0x3c3, x3

    #Address 0x3c3 Write value 0x57f4efdd
    li x3, 0x57f4efdd
    csrw 0x3c3, x3

    #Address 0x3c3 read value
    csrr x14, 0x3c3

    #Address 0x3c3 read value
    csrr x14, 0x3c3

    #Unmapped address 0x8be testing: random write/read operations
    #Address 0x8be read value
    csrr x14, 0x8be

    #Unmapped address 0x45d testing: random write/read operations
    #Address 0x45d Write value 0xf53ead83
    li x3, 0xf53ead83
    csrw 0x45d, x3

    #Address 0x45d read value
    csrr x14, 0x45d

    #Address 0x45d read value
    csrr x14, 0x45d

    #Address 0x45d Write value 0xa8d58288
    li x3, 0xa8d58288
    csrw 0x45d, x3

    #Address 0x45d Write value 0xdd971a43
    li x3, 0xdd971a43
    csrw 0x45d, x3

    #Unmapped address 0x4da testing: random write/read operations
    #Address 0x4da read value
    csrr x14, 0x4da

    #Address 0x4da read value
    csrr x14, 0x4da

    #Address 0x4da read value
    csrr x14, 0x4da

    #Unmapped address 0x36a testing: random write/read operations
    #Address 0x36a Write value 0x7a67d066
    li x3, 0x7a67d066
    csrw 0x36a, x3

    #Address 0x36a read value
    csrr x14, 0x36a

    #Address 0x36a Write value 0x632c5eee
    li x3, 0x632c5eee
    csrw 0x36a, x3

    #Unmapped address 0x817 testing: random write/read operations
    #Address 0x817 Write value 0x4cedda3e
    li x3, 0x4cedda3e
    csrw 0x817, x3

    #Address 0x817 read value
    csrr x14, 0x817

    #Address 0x817 Write value 0x133f1d19
    li x3, 0x133f1d19
    csrw 0x817, x3

    #Unmapped address 0xdc1 testing: random write/read operations
    #Address 0xdc1 Write value 0x7a421666
    li x3, 0x7a421666
    csrw 0xdc1, x3

    #Address 0xdc1 read value
    csrr x14, 0xdc1

    #Address 0xdc1 Write value 0x10f9f882
    li x3, 0x10f9f882
    csrw 0xdc1, x3

    #Address 0xdc1 Write value 0xff515154
    li x3, 0xff515154
    csrw 0xdc1, x3

    #Unmapped address 0x944 testing: random write/read operations
    #Address 0x944 read value
    csrr x14, 0x944

    #Address 0x944 read value
    csrr x14, 0x944

    #Address 0x944 Write value 0x408c7840
    li x3, 0x408c7840
    csrw 0x944, x3

    #Address 0x944 read value
    csrr x14, 0x944

    #Address 0x944 Write value 0xaba213d7
    li x3, 0xaba213d7
    csrw 0x944, x3

    #Unmapped address 0x355 testing: random write/read operations
    #Address 0x355 read value
    csrr x14, 0x355

    #Address 0x355 read value
    csrr x14, 0x355

    #Address 0x355 read value
    csrr x14, 0x355

    #Address 0x355 Write value 0x5b8e8206
    li x3, 0x5b8e8206
    csrw 0x355, x3

    #Address 0x355 Write value 0xa09f3560
    li x3, 0xa09f3560
    csrw 0x355, x3

    #Unmapped address 0x3aa testing: random write/read operations
    #Address 0x3aa read value
    csrr x14, 0x3aa

    #Address 0x3aa Write value 0x96db296c
    li x3, 0x96db296c
    csrw 0x3aa, x3

    #Address 0x3aa read value
    csrr x14, 0x3aa

    #Address 0x3aa read value
    csrr x14, 0x3aa

    #Unmapped address 0x91a testing: random write/read operations
    #Address 0x91a Write value 0x4bee88d9
    li x3, 0x4bee88d9
    csrw 0x91a, x3

    #Address 0x91a Write value 0x8c244650
    li x3, 0x8c244650
    csrw 0x91a, x3

    #Unmapped address 0x319 testing: random write/read operations
    #Address 0x319 Write value 0xef60cbd9
    li x3, 0xef60cbd9
    csrw 0x319, x3

    #Address 0x319 read value
    csrr x14, 0x319

    #Unmapped address 0xc71 testing: random write/read operations
    #Address 0xc71 read value
    csrr x14, 0xc71

    #Unmapped address 0x2b2 testing: random write/read operations
    #Address 0x2b2 read value
    csrr x14, 0x2b2

    #Address 0x2b2 Write value 0xec085897
    li x3, 0xec085897
    csrw 0x2b2, x3

    #Address 0x2b2 Write value 0xf6fac53b
    li x3, 0xf6fac53b
    csrw 0x2b2, x3

    #Address 0x2b2 read value
    csrr x14, 0x2b2

    #Unmapped address 0xca0 testing: random write/read operations
    #Address 0xca0 read value
    csrr x14, 0xca0

    #Unmapped address 0x6e4 testing: random write/read operations
    #Address 0x6e4 read value
    csrr x14, 0x6e4

    #Address 0x6e4 Write value 0x446d6de4
    li x3, 0x446d6de4
    csrw 0x6e4, x3

    #Mapped address 0xf12 (marchid) testing: random write/read operations
    #Address 0xf12 read value
    csrr x14, 0xf12

    #Address 0xf12 read value
    csrr x14, 0xf12

    #Address 0xf12 read value
    csrr x14, 0xf12

    #Address 0xf12 Write value 0xe513f1ff
    li x3, 0xe513f1ff
    csrw 0xf12, x3

    #Address 0xf12 Write value 0xa54dd1bc
    li x3, 0xa54dd1bc
    csrw 0xf12, x3

    #Unmapped address 0x4cc testing: random write/read operations
    #Address 0x4cc Write value 0x26312b1b
    li x3, 0x26312b1b
    csrw 0x4cc, x3

    #Address 0x4cc Write value 0xdbbb6764
    li x3, 0xdbbb6764
    csrw 0x4cc, x3

    #Address 0x4cc Write value 0xcfbc634
    li x3, 0xcfbc634
    csrw 0x4cc, x3

    #Unmapped address 0x70e testing: random write/read operations
    #Address 0x70e read value
    csrr x14, 0x70e

    #Address 0x70e Write value 0xcddc69a1
    li x3, 0xcddc69a1
    csrw 0x70e, x3

    #Address 0x70e Write value 0xaf0d8e05
    li x3, 0xaf0d8e05
    csrw 0x70e, x3

    #Address 0x70e Write value 0xeac75fef
    li x3, 0xeac75fef
    csrw 0x70e, x3

    #Unmapped address 0x983 testing: random write/read operations
    #Address 0x983 Write value 0x1a5716d
    li x3, 0x1a5716d
    csrw 0x983, x3

    #Address 0x983 Write value 0x4f0530a9
    li x3, 0x4f0530a9
    csrw 0x983, x3

    #Unmapped address 0x7a9 testing: random write/read operations
    #Address 0x7a9 Write value 0xb37b2615
    li x3, 0xb37b2615
    csrw 0x7a9, x3

    #Address 0x7a9 read value
    csrr x14, 0x7a9

    #Address 0x7a9 Write value 0xbf474563
    li x3, 0xbf474563
    csrw 0x7a9, x3

    #Address 0x7a9 Write value 0x13cf5c4c
    li x3, 0x13cf5c4c
    csrw 0x7a9, x3

    #Unmapped address 0xcdc testing: random write/read operations
    #Address 0xcdc Write value 0x64768a0a
    li x3, 0x64768a0a
    csrw 0xcdc, x3

    #Address 0xcdc Write value 0x2ab22a36
    li x3, 0x2ab22a36
    csrw 0xcdc, x3

    #Unmapped address 0x8cc testing: random write/read operations
    #Address 0x8cc Write value 0x20dfae9e
    li x3, 0x20dfae9e
    csrw 0x8cc, x3

    #Address 0x8cc Write value 0x20e5ca4e
    li x3, 0x20e5ca4e
    csrw 0x8cc, x3

    #Address 0x8cc Write value 0x2c42097a
    li x3, 0x2c42097a
    csrw 0x8cc, x3

    #Address 0x8cc read value
    csrr x14, 0x8cc

    #Unmapped address 0x8b2 testing: random write/read operations
    #Address 0x8b2 Write value 0xa1fded35
    li x3, 0xa1fded35
    csrw 0x8b2, x3

    #Unmapped address 0xe0b testing: random write/read operations
    #Address 0xe0b Write value 0x2d26832a
    li x3, 0x2d26832a
    csrw 0xe0b, x3

    #Address 0xe0b Write value 0xcfafc1e4
    li x3, 0xcfafc1e4
    csrw 0xe0b, x3

    #Address 0xe0b Write value 0x2004ae2
    li x3, 0x2004ae2
    csrw 0xe0b, x3

    #Unmapped address 0x5fc testing: random write/read operations
    #Address 0x5fc read value
    csrr x14, 0x5fc

    #Address 0x5fc Write value 0xd92fbb07
    li x3, 0xd92fbb07
    csrw 0x5fc, x3

    #Address 0x5fc read value
    csrr x14, 0x5fc

    #Unmapped address 0xd39 testing: random write/read operations
    #Address 0xd39 read value
    csrr x14, 0xd39

    #Address 0xd39 Write value 0x268e0fcd
    li x3, 0x268e0fcd
    csrw 0xd39, x3

    #Address 0xd39 Write value 0x5bbc7d92
    li x3, 0x5bbc7d92
    csrw 0xd39, x3

    #Unmapped address 0xe81 testing: random write/read operations
    #Address 0xe81 Write value 0x85307de
    li x3, 0x85307de
    csrw 0xe81, x3

    #Address 0xe81 Write value 0x7316e559
    li x3, 0x7316e559
    csrw 0xe81, x3

    #Address 0xe81 read value
    csrr x14, 0xe81

    #Address 0xe81 Write value 0xbf7400d9
    li x3, 0xbf7400d9
    csrw 0xe81, x3

    #Unmapped address 0x60 testing: random write/read operations
    #Address 0x60 Write value 0xc38c7547
    li x3, 0xc38c7547
    csrw 0x60, x3

    #Address 0x60 read value
    csrr x14, 0x60

    #Address 0x60 Write value 0x9cb1409f
    li x3, 0x9cb1409f
    csrw 0x60, x3

    #Address 0x60 Write value 0x9f097830
    li x3, 0x9f097830
    csrw 0x60, x3

    #Address 0x60 read value
    csrr x14, 0x60

    #Unmapped address 0xba8 testing: random write/read operations
    #Address 0xba8 Write value 0x5c5ae6be
    li x3, 0x5c5ae6be
    csrw 0xba8, x3

    #Address 0xba8 Write value 0x2a2517da
    li x3, 0x2a2517da
    csrw 0xba8, x3

    #Address 0xba8 Write value 0x38cb2aa6
    li x3, 0x38cb2aa6
    csrw 0xba8, x3

    #Address 0xba8 read value
    csrr x14, 0xba8

    #Address 0xba8 read value
    csrr x14, 0xba8

    #Unmapped address 0xcd3 testing: random write/read operations
    #Address 0xcd3 Write value 0x7e519d45
    li x3, 0x7e519d45
    csrw 0xcd3, x3

    #Address 0xcd3 Write value 0x373439ef
    li x3, 0x373439ef
    csrw 0xcd3, x3

    #Address 0xcd3 Write value 0x6d02de1d
    li x3, 0x6d02de1d
    csrw 0xcd3, x3

    #Address 0xcd3 Write value 0x2c66000a
    li x3, 0x2c66000a
    csrw 0xcd3, x3

    #Unmapped address 0x128 testing: random write/read operations
    #Address 0x128 read value
    csrr x14, 0x128

    #Address 0x128 Write value 0x931f937b
    li x3, 0x931f937b
    csrw 0x128, x3

    #Address 0x128 read value
    csrr x14, 0x128

    #Unmapped address 0x2a2 testing: random write/read operations
    #Address 0x2a2 Write value 0x66d4f1fa
    li x3, 0x66d4f1fa
    csrw 0x2a2, x3

    #Unmapped address 0x8d4 testing: random write/read operations
    #Address 0x8d4 Write value 0xcfa33ed8
    li x3, 0xcfa33ed8
    csrw 0x8d4, x3

    #Address 0x8d4 Write value 0x28d249ff
    li x3, 0x28d249ff
    csrw 0x8d4, x3

    #Address 0x8d4 read value
    csrr x14, 0x8d4

    #Unmapped address 0x85c testing: random write/read operations
    #Address 0x85c Write value 0x5ab274bb
    li x3, 0x5ab274bb
    csrw 0x85c, x3

    #Unmapped address 0xbfc testing: random write/read operations
    #Address 0xbfc Write value 0xce6472e2
    li x3, 0xce6472e2
    csrw 0xbfc, x3

    #Address 0xbfc read value
    csrr x14, 0xbfc

    #Unmapped address 0xe91 testing: random write/read operations
    #Address 0xe91 Write value 0x40a6cabe
    li x3, 0x40a6cabe
    csrw 0xe91, x3

    #Address 0xe91 Write value 0xb7221fce
    li x3, 0xb7221fce
    csrw 0xe91, x3

    #Address 0xe91 Write value 0x142123ab
    li x3, 0x142123ab
    csrw 0xe91, x3

    #Address 0xe91 read value
    csrr x14, 0xe91

    #Address 0xe91 Write value 0xa2490900
    li x3, 0xa2490900
    csrw 0xe91, x3

    #Unmapped address 0x4a3 testing: random write/read operations
    #Address 0x4a3 Write value 0xe473cb6e
    li x3, 0xe473cb6e
    csrw 0x4a3, x3

    #Address 0x4a3 read value
    csrr x14, 0x4a3

    #Address 0x4a3 Write value 0x3918b1ec
    li x3, 0x3918b1ec
    csrw 0x4a3, x3

    #Address 0x4a3 read value
    csrr x14, 0x4a3

    #Unmapped address 0x8f6 testing: random write/read operations
    #Address 0x8f6 read value
    csrr x14, 0x8f6

    #Address 0x8f6 read value
    csrr x14, 0x8f6

    #Address 0x8f6 read value
    csrr x14, 0x8f6

    #Address 0x8f6 read value
    csrr x14, 0x8f6

    #Unmapped address 0xb4a testing: random write/read operations
    #Address 0xb4a read value
    csrr x14, 0xb4a

    #Address 0xb4a Write value 0x8e3a7cf1
    li x3, 0x8e3a7cf1
    csrw 0xb4a, x3

    #Unmapped address 0xff8 testing: random write/read operations
    #Address 0xff8 read value
    csrr x14, 0xff8

    #Address 0xff8 read value
    csrr x14, 0xff8

    #Unmapped address 0xc10 testing: random write/read operations
    #Address 0xc10 read value
    csrr x14, 0xc10

    #Unmapped address 0x9c2 testing: random write/read operations
    #Address 0x9c2 Write value 0x66044791
    li x3, 0x66044791
    csrw 0x9c2, x3

    #Address 0x9c2 read value
    csrr x14, 0x9c2

    #Address 0x9c2 read value
    csrr x14, 0x9c2

    #Address 0x9c2 read value
    csrr x14, 0x9c2

    #Address 0x9c2 read value
    csrr x14, 0x9c2

    #Unmapped address 0x6b6 testing: random write/read operations
    #Address 0x6b6 read value
    csrr x14, 0x6b6

    #Address 0x6b6 read value
    csrr x14, 0x6b6

    #Unmapped address 0xc47 testing: random write/read operations
    #Address 0xc47 Write value 0xc6ed40f9
    li x3, 0xc6ed40f9
    csrw 0xc47, x3

    #Address 0xc47 read value
    csrr x14, 0xc47

    #Address 0xc47 read value
    csrr x14, 0xc47

    #Address 0xc47 read value
    csrr x14, 0xc47

    #Address 0xc47 read value
    csrr x14, 0xc47

    #Unmapped address 0x313 testing: random write/read operations
    #Address 0x313 Write value 0x1b9764cc
    li x3, 0x1b9764cc
    csrw 0x313, x3

    #Address 0x313 Write value 0xd25976d0
    li x3, 0xd25976d0
    csrw 0x313, x3

    #Unmapped address 0x783 testing: random write/read operations
    #Address 0x783 Write value 0xf248a69b
    li x3, 0xf248a69b
    csrw 0x783, x3

    #Address 0x783 read value
    csrr x14, 0x783

    #Address 0x783 Write value 0x2bd941ee
    li x3, 0x2bd941ee
    csrw 0x783, x3

    #Unmapped address 0x88f testing: random write/read operations
    #Address 0x88f read value
    csrr x14, 0x88f

    #Address 0x88f read value
    csrr x14, 0x88f


    #End of csr test
    j csr_pass

csr_pass:
    li x1, 0xBEEFBEEF
    li x1, 0
    slli x1, x1, 1
    addi x1, x1, 1
    sw x1, tohost, x30
    self_loop: j self_loop

csr_fail:
    li x1, 0xBADBAD
    li x1, 1
    slli x1, x1, 1
    addi x1, x1, 1
    sw x1, tohost, x30
    self_loop_2: j self_loop_2

.align 8
exception_handler:
    # increment return address to skip instruction generating the exception
    # valid only if faulting instruction is not compressed (4-byte long)
    csrr    x30, mepc  # mepc: 0x341
    addi    x30, x30, 4
    csrw    mepc, x30  # mepc: 0x341
    mret

