# Copyright 2023 Thales DIS France SAS
#
# Licensed under the Solderpad Hardware Licence, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# SPDX-License-Identifier: Apache-2.0 WITH SHL-2.0
# You may obtain a copy of the License at https://solderpad.org/licenses/
#

.globl main
main:
    #Start CSR tests: Write/Read all unmapped addresses in a random order
    #Handle exceptions
    la x6, exception_handler
    csrw mtvec, x6  ## Load the address of the exception handler into MTVEC
    csrw 0x341, x0  ## Writing Zero to MEPC CSR
    csrw 0x342, x0  ## Writing Zero to MCAUSE CSR
    #End Handle exceptions

    #Total 3966 unmapped CSR address to test from 0x0 to 0xfff, List : '{'h0, 'h1, 'h2, 'h3, 'h4, 'h5, 'h6, 'h7, 'h8, 'h9, 'ha, 'hb, 'hc, 'hd, 'he, 'hf, 'h10, 'h11, 'h12, 'h13, 'h14, 'h15, 'h16, 'h17, 'h18, 'h19, 'h1a, 'h1b, 'h1c, 'h1d, 'h1e, 'h1f, 'h20, 'h21, 'h22, 'h23, 'h24, 'h25, 'h26, 'h27, 'h28, 'h29, 'h2a, 'h2b, 'h2c, 'h2d, 'h2e, 'h2f, 'h30, 'h31, 'h32, 'h33, 'h34, 'h35, 'h36, 'h37, 'h38, 'h39, 'h3a, 'h3b, 'h3c, 'h3d, 'h3e, 'h3f, 'h40, 'h41, 'h42, 'h43, 'h44, 'h45, 'h46, 'h47, 'h48, 'h49, 'h4a, 'h4b, 'h4c, 'h4d, 'h4e, 'h4f, 'h50, 'h51, 'h52, 'h53, 'h54, 'h55, 'h56, 'h57, 'h58, 'h59, 'h5a, 'h5b, 'h5c, 'h5d, 'h5e, 'h5f, 'h60, 'h61, 'h62, 'h63, 'h64, 'h65, 'h66, 'h67, 'h68, 'h69, 'h6a, 'h6b, 'h6c, 'h6d, 'h6e, 'h6f, 'h70, 'h71, 'h72, 'h73, 'h74, 'h75, 'h76, 'h77, 'h78, 'h79, 'h7a, 'h7b, 'h7c, 'h7d, 'h7e, 'h7f, 'h80, 'h81, 'h82, 'h83, 'h84, 'h85, 'h86, 'h87, 'h88, 'h89, 'h8a, 'h8b, 'h8c, 'h8d, 'h8e, 'h8f, 'h90, 'h91, 'h92, 'h93, 'h94, 'h95, 'h96, 'h97, 'h98, 'h99, 'h9a, 'h9b, 'h9c, 'h9d, 'h9e, 'h9f, 'ha0, 'ha1, 'ha2, 'ha3, 'ha4, 'ha5, 'ha6, 'ha7, 'ha8, 'ha9, 'haa, 'hab, 'hac, 'had, 'hae, 'haf, 'hb0, 'hb1, 'hb2, 'hb3, 'hb4, 'hb5, 'hb6, 'hb7, 'hb8, 'hb9, 'hba, 'hbb, 'hbc, 'hbd, 'hbe, 'hbf, 'hc0, 'hc1, 'hc2, 'hc3, 'hc4, 'hc5, 'hc6, 'hc7, 'hc8, 'hc9, 'hca, 'hcb, 'hcc, 'hcd, 'hce, 'hcf, 'hd0, 'hd1, 'hd2, 'hd3, 'hd4, 'hd5, 'hd6, 'hd7, 'hd8, 'hd9, 'hda, 'hdb, 'hdc, 'hdd, 'hde, 'hdf, 'he0, 'he1, 'he2, 'he3, 'he4, 'he5, 'he6, 'he7, 'he8, 'he9, 'hea, 'heb, 'hec, 'hed, 'hee, 'hef, 'hf0, 'hf1, 'hf2, 'hf3, 'hf4, 'hf5, 'hf6, 'hf7, 'hf8, 'hf9, 'hfa, 'hfb, 'hfc, 'hfd, 'hfe, 'hff, 'h100, 'h101, 'h102, 'h103, 'h104, 'h105, 'h106, 'h107, 'h108, 'h109, 'h10a, 'h10b, 'h10c, 'h10d, 'h10e, 'h10f, 'h110, 'h111, 'h112, 'h113, 'h114, 'h115, 'h116, 'h117, 'h118, 'h119, 'h11a, 'h11b, 'h11c, 'h11d, 'h11e, 'h11f, 'h120, 'h121, 'h122, 'h123, 'h124, 'h125, 'h126, 'h127, 'h128, 'h129, 'h12a, 'h12b, 'h12c, 'h12d, 'h12e, 'h12f, 'h130, 'h131, 'h132, 'h133, 'h134, 'h135, 'h136, 'h137, 'h138, 'h139, 'h13a, 'h13b, 'h13c, 'h13d, 'h13e, 'h13f, 'h140, 'h141, 'h142, 'h143, 'h144, 'h145, 'h146, 'h147, 'h148, 'h149, 'h14a, 'h14b, 'h14c, 'h14d, 'h14e, 'h14f, 'h150, 'h151, 'h152, 'h153, 'h154, 'h155, 'h156, 'h157, 'h158, 'h159, 'h15a, 'h15b, 'h15c, 'h15d, 'h15e, 'h15f, 'h160, 'h161, 'h162, 'h163, 'h164, 'h165, 'h166, 'h167, 'h168, 'h169, 'h16a, 'h16b, 'h16c, 'h16d, 'h16e, 'h16f, 'h170, 'h171, 'h172, 'h173, 'h174, 'h175, 'h176, 'h177, 'h178, 'h179, 'h17a, 'h17b, 'h17c, 'h17d, 'h17e, 'h17f, 'h180, 'h181, 'h182, 'h183, 'h184, 'h185, 'h186, 'h187, 'h188, 'h189, 'h18a, 'h18b, 'h18c, 'h18d, 'h18e, 'h18f, 'h190, 'h191, 'h192, 'h193, 'h194, 'h195, 'h196, 'h197, 'h198, 'h199, 'h19a, 'h19b, 'h19c, 'h19d, 'h19e, 'h19f, 'h1a0, 'h1a1, 'h1a2, 'h1a3, 'h1a4, 'h1a5, 'h1a6, 'h1a7, 'h1a8, 'h1a9, 'h1aa, 'h1ab, 'h1ac, 'h1ad, 'h1ae, 'h1af, 'h1b0, 'h1b1, 'h1b2, 'h1b3, 'h1b4, 'h1b5, 'h1b6, 'h1b7, 'h1b8, 'h1b9, 'h1ba, 'h1bb, 'h1bc, 'h1bd, 'h1be, 'h1bf, 'h1c0, 'h1c1, 'h1c2, 'h1c3, 'h1c4, 'h1c5, 'h1c6, 'h1c7, 'h1c8, 'h1c9, 'h1ca, 'h1cb, 'h1cc, 'h1cd, 'h1ce, 'h1cf, 'h1d0, 'h1d1, 'h1d2, 'h1d3, 'h1d4, 'h1d5, 'h1d6, 'h1d7, 'h1d8, 'h1d9, 'h1da, 'h1db, 'h1dc, 'h1dd, 'h1de, 'h1df, 'h1e0, 'h1e1, 'h1e2, 'h1e3, 'h1e4, 'h1e5, 'h1e6, 'h1e7, 'h1e8, 'h1e9, 'h1ea, 'h1eb, 'h1ec, 'h1ed, 'h1ee, 'h1ef, 'h1f0, 'h1f1, 'h1f2, 'h1f3, 'h1f4, 'h1f5, 'h1f6, 'h1f7, 'h1f8, 'h1f9, 'h1fa, 'h1fb, 'h1fc, 'h1fd, 'h1fe, 'h1ff, 'h200, 'h201, 'h202, 'h203, 'h204, 'h205, 'h206, 'h207, 'h208, 'h209, 'h20a, 'h20b, 'h20c, 'h20d, 'h20e, 'h20f, 'h210, 'h211, 'h212, 'h213, 'h214, 'h215, 'h216, 'h217, 'h218, 'h219, 'h21a, 'h21b, 'h21c, 'h21d, 'h21e, 'h21f, 'h220, 'h221, 'h222, 'h223, 'h224, 'h225, 'h226, 'h227, 'h228, 'h229, 'h22a, 'h22b, 'h22c, 'h22d, 'h22e, 'h22f, 'h230, 'h231, 'h232, 'h233, 'h234, 'h235, 'h236, 'h237, 'h238, 'h239, 'h23a, 'h23b, 'h23c, 'h23d, 'h23e, 'h23f, 'h240, 'h241, 'h242, 'h243, 'h244, 'h245, 'h246, 'h247, 'h248, 'h249, 'h24a, 'h24b, 'h24c, 'h24d, 'h24e, 'h24f, 'h250, 'h251, 'h252, 'h253, 'h254, 'h255, 'h256, 'h257, 'h258, 'h259, 'h25a, 'h25b, 'h25c, 'h25d, 'h25e, 'h25f, 'h260, 'h261, 'h262, 'h263, 'h264, 'h265, 'h266, 'h267, 'h268, 'h269, 'h26a, 'h26b, 'h26c, 'h26d, 'h26e, 'h26f, 'h270, 'h271, 'h272, 'h273, 'h274, 'h275, 'h276, 'h277, 'h278, 'h279, 'h27a, 'h27b, 'h27c, 'h27d, 'h27e, 'h27f, 'h280, 'h281, 'h282, 'h283, 'h284, 'h285, 'h286, 'h287, 'h288, 'h289, 'h28a, 'h28b, 'h28c, 'h28d, 'h28e, 'h28f, 'h290, 'h291, 'h292, 'h293, 'h294, 'h295, 'h296, 'h297, 'h298, 'h299, 'h29a, 'h29b, 'h29c, 'h29d, 'h29e, 'h29f, 'h2a0, 'h2a1, 'h2a2, 'h2a3, 'h2a4, 'h2a5, 'h2a6, 'h2a7, 'h2a8, 'h2a9, 'h2aa, 'h2ab, 'h2ac, 'h2ad, 'h2ae, 'h2af, 'h2b0, 'h2b1, 'h2b2, 'h2b3, 'h2b4, 'h2b5, 'h2b6, 'h2b7, 'h2b8, 'h2b9, 'h2ba, 'h2bb, 'h2bc, 'h2bd, 'h2be, 'h2bf, 'h2c0, 'h2c1, 'h2c2, 'h2c3, 'h2c4, 'h2c5, 'h2c6, 'h2c7, 'h2c8, 'h2c9, 'h2ca, 'h2cb, 'h2cc, 'h2cd, 'h2ce, 'h2cf, 'h2d0, 'h2d1, 'h2d2, 'h2d3, 'h2d4, 'h2d5, 'h2d6, 'h2d7, 'h2d8, 'h2d9, 'h2da, 'h2db, 'h2dc, 'h2dd, 'h2de, 'h2df, 'h2e0, 'h2e1, 'h2e2, 'h2e3, 'h2e4, 'h2e5, 'h2e6, 'h2e7, 'h2e8, 'h2e9, 'h2ea, 'h2eb, 'h2ec, 'h2ed, 'h2ee, 'h2ef, 'h2f0, 'h2f1, 'h2f2, 'h2f3, 'h2f4, 'h2f5, 'h2f6, 'h2f7, 'h2f8, 'h2f9, 'h2fa, 'h2fb, 'h2fc, 'h2fd, 'h2fe, 'h2ff, 'h302, 'h303, 'h306, 'h307, 'h308, 'h309, 'h30a, 'h30b, 'h30c, 'h30d, 'h30e, 'h30f, 'h311, 'h312, 'h313, 'h314, 'h315, 'h316, 'h317, 'h318, 'h319, 'h31a, 'h31b, 'h31c, 'h31d, 'h31e, 'h31f, 'h320, 'h321, 'h322, 'h345, 'h346, 'h347, 'h348, 'h349, 'h34a, 'h34b, 'h34c, 'h34d, 'h34e, 'h34f, 'h350, 'h351, 'h352, 'h353, 'h354, 'h355, 'h356, 'h357, 'h358, 'h359, 'h35a, 'h35b, 'h35c, 'h35d, 'h35e, 'h35f, 'h360, 'h361, 'h362, 'h363, 'h364, 'h365, 'h366, 'h367, 'h368, 'h369, 'h36a, 'h36b, 'h36c, 'h36d, 'h36e, 'h36f, 'h370, 'h371, 'h372, 'h373, 'h374, 'h375, 'h376, 'h377, 'h378, 'h379, 'h37a, 'h37b, 'h37c, 'h37d, 'h37e, 'h37f, 'h380, 'h381, 'h382, 'h383, 'h384, 'h385, 'h386, 'h387, 'h388, 'h389, 'h38a, 'h38b, 'h38c, 'h38d, 'h38e, 'h38f, 'h390, 'h391, 'h392, 'h393, 'h394, 'h395, 'h396, 'h397, 'h398, 'h399, 'h39a, 'h39b, 'h39c, 'h39d, 'h39e, 'h39f, 'h3a4, 'h3a5, 'h3a6, 'h3a7, 'h3a8, 'h3a9, 'h3aa, 'h3ab, 'h3ac, 'h3ad, 'h3ae, 'h3af, 'h3c0, 'h3c1, 'h3c2, 'h3c3, 'h3c4, 'h3c5, 'h3c6, 'h3c7, 'h3c8, 'h3c9, 'h3ca, 'h3cb, 'h3cc, 'h3cd, 'h3ce, 'h3cf, 'h3d0, 'h3d1, 'h3d2, 'h3d3, 'h3d4, 'h3d5, 'h3d6, 'h3d7, 'h3d8, 'h3d9, 'h3da, 'h3db, 'h3dc, 'h3dd, 'h3de, 'h3df, 'h3e0, 'h3e1, 'h3e2, 'h3e3, 'h3e4, 'h3e5, 'h3e6, 'h3e7, 'h3e8, 'h3e9, 'h3ea, 'h3eb, 'h3ec, 'h3ed, 'h3ee, 'h3ef, 'h3f0, 'h3f1, 'h3f2, 'h3f3, 'h3f4, 'h3f5, 'h3f6, 'h3f7, 'h3f8, 'h3f9, 'h3fa, 'h3fb, 'h3fc, 'h3fd, 'h3fe, 'h3ff, 'h400, 'h401, 'h402, 'h403, 'h404, 'h405, 'h406, 'h407, 'h408, 'h409, 'h40a, 'h40b, 'h40c, 'h40d, 'h40e, 'h40f, 'h410, 'h411, 'h412, 'h413, 'h414, 'h415, 'h416, 'h417, 'h418, 'h419, 'h41a, 'h41b, 'h41c, 'h41d, 'h41e, 'h41f, 'h420, 'h421, 'h422, 'h423, 'h424, 'h425, 'h426, 'h427, 'h428, 'h429, 'h42a, 'h42b, 'h42c, 'h42d, 'h42e, 'h42f, 'h430, 'h431, 'h432, 'h433, 'h434, 'h435, 'h436, 'h437, 'h438, 'h439, 'h43a, 'h43b, 'h43c, 'h43d, 'h43e, 'h43f, 'h440, 'h441, 'h442, 'h443, 'h444, 'h445, 'h446, 'h447, 'h448, 'h449, 'h44a, 'h44b, 'h44c, 'h44d, 'h44e, 'h44f, 'h450, 'h451, 'h452, 'h453, 'h454, 'h455, 'h456, 'h457, 'h458, 'h459, 'h45a, 'h45b, 'h45c, 'h45d, 'h45e, 'h45f, 'h460, 'h461, 'h462, 'h463, 'h464, 'h465, 'h466, 'h467, 'h468, 'h469, 'h46a, 'h46b, 'h46c, 'h46d, 'h46e, 'h46f, 'h470, 'h471, 'h472, 'h473, 'h474, 'h475, 'h476, 'h477, 'h478, 'h479, 'h47a, 'h47b, 'h47c, 'h47d, 'h47e, 'h47f, 'h480, 'h481, 'h482, 'h483, 'h484, 'h485, 'h486, 'h487, 'h488, 'h489, 'h48a, 'h48b, 'h48c, 'h48d, 'h48e, 'h48f, 'h490, 'h491, 'h492, 'h493, 'h494, 'h495, 'h496, 'h497, 'h498, 'h499, 'h49a, 'h49b, 'h49c, 'h49d, 'h49e, 'h49f, 'h4a0, 'h4a1, 'h4a2, 'h4a3, 'h4a4, 'h4a5, 'h4a6, 'h4a7, 'h4a8, 'h4a9, 'h4aa, 'h4ab, 'h4ac, 'h4ad, 'h4ae, 'h4af, 'h4b0, 'h4b1, 'h4b2, 'h4b3, 'h4b4, 'h4b5, 'h4b6, 'h4b7, 'h4b8, 'h4b9, 'h4ba, 'h4bb, 'h4bc, 'h4bd, 'h4be, 'h4bf, 'h4c0, 'h4c1, 'h4c2, 'h4c3, 'h4c4, 'h4c5, 'h4c6, 'h4c7, 'h4c8, 'h4c9, 'h4ca, 'h4cb, 'h4cc, 'h4cd, 'h4ce, 'h4cf, 'h4d0, 'h4d1, 'h4d2, 'h4d3, 'h4d4, 'h4d5, 'h4d6, 'h4d7, 'h4d8, 'h4d9, 'h4da, 'h4db, 'h4dc, 'h4dd, 'h4de, 'h4df, 'h4e0, 'h4e1, 'h4e2, 'h4e3, 'h4e4, 'h4e5, 'h4e6, 'h4e7, 'h4e8, 'h4e9, 'h4ea, 'h4eb, 'h4ec, 'h4ed, 'h4ee, 'h4ef, 'h4f0, 'h4f1, 'h4f2, 'h4f3, 'h4f4, 'h4f5, 'h4f6, 'h4f7, 'h4f8, 'h4f9, 'h4fa, 'h4fb, 'h4fc, 'h4fd, 'h4fe, 'h4ff, 'h500, 'h501, 'h502, 'h503, 'h504, 'h505, 'h506, 'h507, 'h508, 'h509, 'h50a, 'h50b, 'h50c, 'h50d, 'h50e, 'h50f, 'h510, 'h511, 'h512, 'h513, 'h514, 'h515, 'h516, 'h517, 'h518, 'h519, 'h51a, 'h51b, 'h51c, 'h51d, 'h51e, 'h51f, 'h520, 'h521, 'h522, 'h523, 'h524, 'h525, 'h526, 'h527, 'h528, 'h529, 'h52a, 'h52b, 'h52c, 'h52d, 'h52e, 'h52f, 'h530, 'h531, 'h532, 'h533, 'h534, 'h535, 'h536, 'h537, 'h538, 'h539, 'h53a, 'h53b, 'h53c, 'h53d, 'h53e, 'h53f, 'h540, 'h541, 'h542, 'h543, 'h544, 'h545, 'h546, 'h547, 'h548, 'h549, 'h54a, 'h54b, 'h54c, 'h54d, 'h54e, 'h54f, 'h550, 'h551, 'h552, 'h553, 'h554, 'h555, 'h556, 'h557, 'h558, 'h559, 'h55a, 'h55b, 'h55c, 'h55d, 'h55e, 'h55f, 'h560, 'h561, 'h562, 'h563, 'h564, 'h565, 'h566, 'h567, 'h568, 'h569, 'h56a, 'h56b, 'h56c, 'h56d, 'h56e, 'h56f, 'h570, 'h571, 'h572, 'h573, 'h574, 'h575, 'h576, 'h577, 'h578, 'h579, 'h57a, 'h57b, 'h57c, 'h57d, 'h57e, 'h57f, 'h580, 'h581, 'h582, 'h583, 'h584, 'h585, 'h586, 'h587, 'h588, 'h589, 'h58a, 'h58b, 'h58c, 'h58d, 'h58e, 'h58f, 'h590, 'h591, 'h592, 'h593, 'h594, 'h595, 'h596, 'h597, 'h598, 'h599, 'h59a, 'h59b, 'h59c, 'h59d, 'h59e, 'h59f, 'h5a0, 'h5a1, 'h5a2, 'h5a3, 'h5a4, 'h5a5, 'h5a6, 'h5a7, 'h5a8, 'h5a9, 'h5aa, 'h5ab, 'h5ac, 'h5ad, 'h5ae, 'h5af, 'h5b0, 'h5b1, 'h5b2, 'h5b3, 'h5b4, 'h5b5, 'h5b6, 'h5b7, 'h5b8, 'h5b9, 'h5ba, 'h5bb, 'h5bc, 'h5bd, 'h5be, 'h5bf, 'h5c0, 'h5c1, 'h5c2, 'h5c3, 'h5c4, 'h5c5, 'h5c6, 'h5c7, 'h5c8, 'h5c9, 'h5ca, 'h5cb, 'h5cc, 'h5cd, 'h5ce, 'h5cf, 'h5d0, 'h5d1, 'h5d2, 'h5d3, 'h5d4, 'h5d5, 'h5d6, 'h5d7, 'h5d8, 'h5d9, 'h5da, 'h5db, 'h5dc, 'h5dd, 'h5de, 'h5df, 'h5e0, 'h5e1, 'h5e2, 'h5e3, 'h5e4, 'h5e5, 'h5e6, 'h5e7, 'h5e8, 'h5e9, 'h5ea, 'h5eb, 'h5ec, 'h5ed, 'h5ee, 'h5ef, 'h5f0, 'h5f1, 'h5f2, 'h5f3, 'h5f4, 'h5f5, 'h5f6, 'h5f7, 'h5f8, 'h5f9, 'h5fa, 'h5fb, 'h5fc, 'h5fd, 'h5fe, 'h5ff, 'h600, 'h601, 'h602, 'h603, 'h604, 'h605, 'h606, 'h607, 'h608, 'h609, 'h60a, 'h60b, 'h60c, 'h60d, 'h60e, 'h60f, 'h610, 'h611, 'h612, 'h613, 'h614, 'h615, 'h616, 'h617, 'h618, 'h619, 'h61a, 'h61b, 'h61c, 'h61d, 'h61e, 'h61f, 'h620, 'h621, 'h622, 'h623, 'h624, 'h625, 'h626, 'h627, 'h628, 'h629, 'h62a, 'h62b, 'h62c, 'h62d, 'h62e, 'h62f, 'h630, 'h631, 'h632, 'h633, 'h634, 'h635, 'h636, 'h637, 'h638, 'h639, 'h63a, 'h63b, 'h63c, 'h63d, 'h63e, 'h63f, 'h640, 'h641, 'h642, 'h643, 'h644, 'h645, 'h646, 'h647, 'h648, 'h649, 'h64a, 'h64b, 'h64c, 'h64d, 'h64e, 'h64f, 'h650, 'h651, 'h652, 'h653, 'h654, 'h655, 'h656, 'h657, 'h658, 'h659, 'h65a, 'h65b, 'h65c, 'h65d, 'h65e, 'h65f, 'h660, 'h661, 'h662, 'h663, 'h664, 'h665, 'h666, 'h667, 'h668, 'h669, 'h66a, 'h66b, 'h66c, 'h66d, 'h66e, 'h66f, 'h670, 'h671, 'h672, 'h673, 'h674, 'h675, 'h676, 'h677, 'h678, 'h679, 'h67a, 'h67b, 'h67c, 'h67d, 'h67e, 'h67f, 'h680, 'h681, 'h682, 'h683, 'h684, 'h685, 'h686, 'h687, 'h688, 'h689, 'h68a, 'h68b, 'h68c, 'h68d, 'h68e, 'h68f, 'h690, 'h691, 'h692, 'h693, 'h694, 'h695, 'h696, 'h697, 'h698, 'h699, 'h69a, 'h69b, 'h69c, 'h69d, 'h69e, 'h69f, 'h6a0, 'h6a1, 'h6a2, 'h6a3, 'h6a4, 'h6a5, 'h6a6, 'h6a7, 'h6a8, 'h6a9, 'h6aa, 'h6ab, 'h6ac, 'h6ad, 'h6ae, 'h6af, 'h6b0, 'h6b1, 'h6b2, 'h6b3, 'h6b4, 'h6b5, 'h6b6, 'h6b7, 'h6b8, 'h6b9, 'h6ba, 'h6bb, 'h6bc, 'h6bd, 'h6be, 'h6bf, 'h6c0, 'h6c1, 'h6c2, 'h6c3, 'h6c4, 'h6c5, 'h6c6, 'h6c7, 'h6c8, 'h6c9, 'h6ca, 'h6cb, 'h6cc, 'h6cd, 'h6ce, 'h6cf, 'h6d0, 'h6d1, 'h6d2, 'h6d3, 'h6d4, 'h6d5, 'h6d6, 'h6d7, 'h6d8, 'h6d9, 'h6da, 'h6db, 'h6dc, 'h6dd, 'h6de, 'h6df, 'h6e0, 'h6e1, 'h6e2, 'h6e3, 'h6e4, 'h6e5, 'h6e6, 'h6e7, 'h6e8, 'h6e9, 'h6ea, 'h6eb, 'h6ec, 'h6ed, 'h6ee, 'h6ef, 'h6f0, 'h6f1, 'h6f2, 'h6f3, 'h6f4, 'h6f5, 'h6f6, 'h6f7, 'h6f8, 'h6f9, 'h6fa, 'h6fb, 'h6fc, 'h6fd, 'h6fe, 'h6ff, 'h700, 'h701, 'h702, 'h703, 'h704, 'h705, 'h706, 'h707, 'h708, 'h709, 'h70a, 'h70b, 'h70c, 'h70d, 'h70e, 'h70f, 'h710, 'h711, 'h712, 'h713, 'h714, 'h715, 'h716, 'h717, 'h718, 'h719, 'h71a, 'h71b, 'h71c, 'h71d, 'h71e, 'h71f, 'h720, 'h721, 'h722, 'h723, 'h724, 'h725, 'h726, 'h727, 'h728, 'h729, 'h72a, 'h72b, 'h72c, 'h72d, 'h72e, 'h72f, 'h730, 'h731, 'h732, 'h733, 'h734, 'h735, 'h736, 'h737, 'h738, 'h739, 'h73a, 'h73b, 'h73c, 'h73d, 'h73e, 'h73f, 'h740, 'h741, 'h742, 'h743, 'h744, 'h745, 'h746, 'h747, 'h748, 'h749, 'h74a, 'h74b, 'h74c, 'h74d, 'h74e, 'h74f, 'h750, 'h751, 'h752, 'h753, 'h754, 'h755, 'h756, 'h757, 'h758, 'h759, 'h75a, 'h75b, 'h75c, 'h75d, 'h75e, 'h75f, 'h760, 'h761, 'h762, 'h763, 'h764, 'h765, 'h766, 'h767, 'h768, 'h769, 'h76a, 'h76b, 'h76c, 'h76d, 'h76e, 'h76f, 'h770, 'h771, 'h772, 'h773, 'h774, 'h775, 'h776, 'h777, 'h778, 'h779, 'h77a, 'h77b, 'h77c, 'h77d, 'h77e, 'h77f, 'h780, 'h781, 'h782, 'h783, 'h784, 'h785, 'h786, 'h787, 'h788, 'h789, 'h78a, 'h78b, 'h78c, 'h78d, 'h78e, 'h78f, 'h790, 'h791, 'h792, 'h793, 'h794, 'h795, 'h796, 'h797, 'h798, 'h799, 'h79a, 'h79b, 'h79c, 'h79d, 'h79e, 'h79f, 'h7a0, 'h7a1, 'h7a2, 'h7a3, 'h7a4, 'h7a5, 'h7a6, 'h7a7, 'h7a8, 'h7a9, 'h7aa, 'h7ab, 'h7ac, 'h7ad, 'h7ae, 'h7af, 'h7b0, 'h7b1, 'h7b2, 'h7b3, 'h7b4, 'h7b5, 'h7b6, 'h7b7, 'h7b8, 'h7b9, 'h7ba, 'h7bb, 'h7bc, 'h7bd, 'h7be, 'h7bf, 'h7c1, 'h7c2, 'h7c3, 'h7c4, 'h7c5, 'h7c6, 'h7c7, 'h7c8, 'h7c9, 'h7ca, 'h7cb, 'h7cc, 'h7cd, 'h7ce, 'h7cf, 'h7d0, 'h7d1, 'h7d2, 'h7d3, 'h7d4, 'h7d5, 'h7d6, 'h7d7, 'h7d8, 'h7d9, 'h7da, 'h7db, 'h7dc, 'h7dd, 'h7de, 'h7df, 'h7e0, 'h7e1, 'h7e2, 'h7e3, 'h7e4, 'h7e5, 'h7e6, 'h7e7, 'h7e8, 'h7e9, 'h7ea, 'h7eb, 'h7ec, 'h7ed, 'h7ee, 'h7ef, 'h7f0, 'h7f1, 'h7f2, 'h7f3, 'h7f4, 'h7f5, 'h7f6, 'h7f7, 'h7f8, 'h7f9, 'h7fa, 'h7fb, 'h7fc, 'h7fd, 'h7fe, 'h7ff, 'h800, 'h801, 'h802, 'h803, 'h804, 'h805, 'h806, 'h807, 'h808, 'h809, 'h80a, 'h80b, 'h80c, 'h80d, 'h80e, 'h80f, 'h810, 'h811, 'h812, 'h813, 'h814, 'h815, 'h816, 'h817, 'h818, 'h819, 'h81a, 'h81b, 'h81c, 'h81d, 'h81e, 'h81f, 'h820, 'h821, 'h822, 'h823, 'h824, 'h825, 'h826, 'h827, 'h828, 'h829, 'h82a, 'h82b, 'h82c, 'h82d, 'h82e, 'h82f, 'h830, 'h831, 'h832, 'h833, 'h834, 'h835, 'h836, 'h837, 'h838, 'h839, 'h83a, 'h83b, 'h83c, 'h83d, 'h83e, 'h83f, 'h840, 'h841, 'h842, 'h843, 'h844, 'h845, 'h846, 'h847, 'h848, 'h849, 'h84a, 'h84b, 'h84c, 'h84d, 'h84e, 'h84f, 'h850, 'h851, 'h852, 'h853, 'h854, 'h855, 'h856, 'h857, 'h858, 'h859, 'h85a, 'h85b, 'h85c, 'h85d, 'h85e, 'h85f, 'h860, 'h861, 'h862, 'h863, 'h864, 'h865, 'h866, 'h867, 'h868, 'h869, 'h86a, 'h86b, 'h86c, 'h86d, 'h86e, 'h86f, 'h870, 'h871, 'h872, 'h873, 'h874, 'h875, 'h876, 'h877, 'h878, 'h879, 'h87a, 'h87b, 'h87c, 'h87d, 'h87e, 'h87f, 'h880, 'h881, 'h882, 'h883, 'h884, 'h885, 'h886, 'h887, 'h888, 'h889, 'h88a, 'h88b, 'h88c, 'h88d, 'h88e, 'h88f, 'h890, 'h891, 'h892, 'h893, 'h894, 'h895, 'h896, 'h897, 'h898, 'h899, 'h89a, 'h89b, 'h89c, 'h89d, 'h89e, 'h89f, 'h8a0, 'h8a1, 'h8a2, 'h8a3, 'h8a4, 'h8a5, 'h8a6, 'h8a7, 'h8a8, 'h8a9, 'h8aa, 'h8ab, 'h8ac, 'h8ad, 'h8ae, 'h8af, 'h8b0, 'h8b1, 'h8b2, 'h8b3, 'h8b4, 'h8b5, 'h8b6, 'h8b7, 'h8b8, 'h8b9, 'h8ba, 'h8bb, 'h8bc, 'h8bd, 'h8be, 'h8bf, 'h8c0, 'h8c1, 'h8c2, 'h8c3, 'h8c4, 'h8c5, 'h8c6, 'h8c7, 'h8c8, 'h8c9, 'h8ca, 'h8cb, 'h8cc, 'h8cd, 'h8ce, 'h8cf, 'h8d0, 'h8d1, 'h8d2, 'h8d3, 'h8d4, 'h8d5, 'h8d6, 'h8d7, 'h8d8, 'h8d9, 'h8da, 'h8db, 'h8dc, 'h8dd, 'h8de, 'h8df, 'h8e0, 'h8e1, 'h8e2, 'h8e3, 'h8e4, 'h8e5, 'h8e6, 'h8e7, 'h8e8, 'h8e9, 'h8ea, 'h8eb, 'h8ec, 'h8ed, 'h8ee, 'h8ef, 'h8f0, 'h8f1, 'h8f2, 'h8f3, 'h8f4, 'h8f5, 'h8f6, 'h8f7, 'h8f8, 'h8f9, 'h8fa, 'h8fb, 'h8fc, 'h8fd, 'h8fe, 'h8ff, 'h900, 'h901, 'h902, 'h903, 'h904, 'h905, 'h906, 'h907, 'h908, 'h909, 'h90a, 'h90b, 'h90c, 'h90d, 'h90e, 'h90f, 'h910, 'h911, 'h912, 'h913, 'h914, 'h915, 'h916, 'h917, 'h918, 'h919, 'h91a, 'h91b, 'h91c, 'h91d, 'h91e, 'h91f, 'h920, 'h921, 'h922, 'h923, 'h924, 'h925, 'h926, 'h927, 'h928, 'h929, 'h92a, 'h92b, 'h92c, 'h92d, 'h92e, 'h92f, 'h930, 'h931, 'h932, 'h933, 'h934, 'h935, 'h936, 'h937, 'h938, 'h939, 'h93a, 'h93b, 'h93c, 'h93d, 'h93e, 'h93f, 'h940, 'h941, 'h942, 'h943, 'h944, 'h945, 'h946, 'h947, 'h948, 'h949, 'h94a, 'h94b, 'h94c, 'h94d, 'h94e, 'h94f, 'h950, 'h951, 'h952, 'h953, 'h954, 'h955, 'h956, 'h957, 'h958, 'h959, 'h95a, 'h95b, 'h95c, 'h95d, 'h95e, 'h95f, 'h960, 'h961, 'h962, 'h963, 'h964, 'h965, 'h966, 'h967, 'h968, 'h969, 'h96a, 'h96b, 'h96c, 'h96d, 'h96e, 'h96f, 'h970, 'h971, 'h972, 'h973, 'h974, 'h975, 'h976, 'h977, 'h978, 'h979, 'h97a, 'h97b, 'h97c, 'h97d, 'h97e, 'h97f, 'h980, 'h981, 'h982, 'h983, 'h984, 'h985, 'h986, 'h987, 'h988, 'h989, 'h98a, 'h98b, 'h98c, 'h98d, 'h98e, 'h98f, 'h990, 'h991, 'h992, 'h993, 'h994, 'h995, 'h996, 'h997, 'h998, 'h999, 'h99a, 'h99b, 'h99c, 'h99d, 'h99e, 'h99f, 'h9a0, 'h9a1, 'h9a2, 'h9a3, 'h9a4, 'h9a5, 'h9a6, 'h9a7, 'h9a8, 'h9a9, 'h9aa, 'h9ab, 'h9ac, 'h9ad, 'h9ae, 'h9af, 'h9b0, 'h9b1, 'h9b2, 'h9b3, 'h9b4, 'h9b5, 'h9b6, 'h9b7, 'h9b8, 'h9b9, 'h9ba, 'h9bb, 'h9bc, 'h9bd, 'h9be, 'h9bf, 'h9c0, 'h9c1, 'h9c2, 'h9c3, 'h9c4, 'h9c5, 'h9c6, 'h9c7, 'h9c8, 'h9c9, 'h9ca, 'h9cb, 'h9cc, 'h9cd, 'h9ce, 'h9cf, 'h9d0, 'h9d1, 'h9d2, 'h9d3, 'h9d4, 'h9d5, 'h9d6, 'h9d7, 'h9d8, 'h9d9, 'h9da, 'h9db, 'h9dc, 'h9dd, 'h9de, 'h9df, 'h9e0, 'h9e1, 'h9e2, 'h9e3, 'h9e4, 'h9e5, 'h9e6, 'h9e7, 'h9e8, 'h9e9, 'h9ea, 'h9eb, 'h9ec, 'h9ed, 'h9ee, 'h9ef, 'h9f0, 'h9f1, 'h9f2, 'h9f3, 'h9f4, 'h9f5, 'h9f6, 'h9f7, 'h9f8, 'h9f9, 'h9fa, 'h9fb, 'h9fc, 'h9fd, 'h9fe, 'h9ff, 'ha00, 'ha01, 'ha02, 'ha03, 'ha04, 'ha05, 'ha06, 'ha07, 'ha08, 'ha09, 'ha0a, 'ha0b, 'ha0c, 'ha0d, 'ha0e, 'ha0f, 'ha10, 'ha11, 'ha12, 'ha13, 'ha14, 'ha15, 'ha16, 'ha17, 'ha18, 'ha19, 'ha1a, 'ha1b, 'ha1c, 'ha1d, 'ha1e, 'ha1f, 'ha20, 'ha21, 'ha22, 'ha23, 'ha24, 'ha25, 'ha26, 'ha27, 'ha28, 'ha29, 'ha2a, 'ha2b, 'ha2c, 'ha2d, 'ha2e, 'ha2f, 'ha30, 'ha31, 'ha32, 'ha33, 'ha34, 'ha35, 'ha36, 'ha37, 'ha38, 'ha39, 'ha3a, 'ha3b, 'ha3c, 'ha3d, 'ha3e, 'ha3f, 'ha40, 'ha41, 'ha42, 'ha43, 'ha44, 'ha45, 'ha46, 'ha47, 'ha48, 'ha49, 'ha4a, 'ha4b, 'ha4c, 'ha4d, 'ha4e, 'ha4f, 'ha50, 'ha51, 'ha52, 'ha53, 'ha54, 'ha55, 'ha56, 'ha57, 'ha58, 'ha59, 'ha5a, 'ha5b, 'ha5c, 'ha5d, 'ha5e, 'ha5f, 'ha60, 'ha61, 'ha62, 'ha63, 'ha64, 'ha65, 'ha66, 'ha67, 'ha68, 'ha69, 'ha6a, 'ha6b, 'ha6c, 'ha6d, 'ha6e, 'ha6f, 'ha70, 'ha71, 'ha72, 'ha73, 'ha74, 'ha75, 'ha76, 'ha77, 'ha78, 'ha79, 'ha7a, 'ha7b, 'ha7c, 'ha7d, 'ha7e, 'ha7f, 'ha80, 'ha81, 'ha82, 'ha83, 'ha84, 'ha85, 'ha86, 'ha87, 'ha88, 'ha89, 'ha8a, 'ha8b, 'ha8c, 'ha8d, 'ha8e, 'ha8f, 'ha90, 'ha91, 'ha92, 'ha93, 'ha94, 'ha95, 'ha96, 'ha97, 'ha98, 'ha99, 'ha9a, 'ha9b, 'ha9c, 'ha9d, 'ha9e, 'ha9f, 'haa0, 'haa1, 'haa2, 'haa3, 'haa4, 'haa5, 'haa6, 'haa7, 'haa8, 'haa9, 'haaa, 'haab, 'haac, 'haad, 'haae, 'haaf, 'hab0, 'hab1, 'hab2, 'hab3, 'hab4, 'hab5, 'hab6, 'hab7, 'hab8, 'hab9, 'haba, 'habb, 'habc, 'habd, 'habe, 'habf, 'hac0, 'hac1, 'hac2, 'hac3, 'hac4, 'hac5, 'hac6, 'hac7, 'hac8, 'hac9, 'haca, 'hacb, 'hacc, 'hacd, 'hace, 'hacf, 'had0, 'had1, 'had2, 'had3, 'had4, 'had5, 'had6, 'had7, 'had8, 'had9, 'hada, 'hadb, 'hadc, 'hadd, 'hade, 'hadf, 'hae0, 'hae1, 'hae2, 'hae3, 'hae4, 'hae5, 'hae6, 'hae7, 'hae8, 'hae9, 'haea, 'haeb, 'haec, 'haed, 'haee, 'haef, 'haf0, 'haf1, 'haf2, 'haf3, 'haf4, 'haf5, 'haf6, 'haf7, 'haf8, 'haf9, 'hafa, 'hafb, 'hafc, 'hafd, 'hafe, 'haff, 'hb01, 'hb20, 'hb21, 'hb22, 'hb23, 'hb24, 'hb25, 'hb26, 'hb27, 'hb28, 'hb29, 'hb2a, 'hb2b, 'hb2c, 'hb2d, 'hb2e, 'hb2f, 'hb30, 'hb31, 'hb32, 'hb33, 'hb34, 'hb35, 'hb36, 'hb37, 'hb38, 'hb39, 'hb3a, 'hb3b, 'hb3c, 'hb3d, 'hb3e, 'hb3f, 'hb40, 'hb41, 'hb42, 'hb43, 'hb44, 'hb45, 'hb46, 'hb47, 'hb48, 'hb49, 'hb4a, 'hb4b, 'hb4c, 'hb4d, 'hb4e, 'hb4f, 'hb50, 'hb51, 'hb52, 'hb53, 'hb54, 'hb55, 'hb56, 'hb57, 'hb58, 'hb59, 'hb5a, 'hb5b, 'hb5c, 'hb5d, 'hb5e, 'hb5f, 'hb60, 'hb61, 'hb62, 'hb63, 'hb64, 'hb65, 'hb66, 'hb67, 'hb68, 'hb69, 'hb6a, 'hb6b, 'hb6c, 'hb6d, 'hb6e, 'hb6f, 'hb70, 'hb71, 'hb72, 'hb73, 'hb74, 'hb75, 'hb76, 'hb77, 'hb78, 'hb79, 'hb7a, 'hb7b, 'hb7c, 'hb7d, 'hb7e, 'hb7f, 'hb81, 'hba0, 'hba1, 'hba2, 'hba3, 'hba4, 'hba5, 'hba6, 'hba7, 'hba8, 'hba9, 'hbaa, 'hbab, 'hbac, 'hbad, 'hbae, 'hbaf, 'hbb0, 'hbb1, 'hbb2, 'hbb3, 'hbb4, 'hbb5, 'hbb6, 'hbb7, 'hbb8, 'hbb9, 'hbba, 'hbbb, 'hbbc, 'hbbd, 'hbbe, 'hbbf, 'hbc0, 'hbc1, 'hbc2, 'hbc3, 'hbc4, 'hbc5, 'hbc6, 'hbc7, 'hbc8, 'hbc9, 'hbca, 'hbcb, 'hbcc, 'hbcd, 'hbce, 'hbcf, 'hbd0, 'hbd1, 'hbd2, 'hbd3, 'hbd4, 'hbd5, 'hbd6, 'hbd7, 'hbd8, 'hbd9, 'hbda, 'hbdb, 'hbdc, 'hbdd, 'hbde, 'hbdf, 'hbe0, 'hbe1, 'hbe2, 'hbe3, 'hbe4, 'hbe5, 'hbe6, 'hbe7, 'hbe8, 'hbe9, 'hbea, 'hbeb, 'hbec, 'hbed, 'hbee, 'hbef, 'hbf0, 'hbf1, 'hbf2, 'hbf3, 'hbf4, 'hbf5, 'hbf6, 'hbf7, 'hbf8, 'hbf9, 'hbfa, 'hbfb, 'hbfc, 'hbfd, 'hbfe, 'hbff, 'hc01, 'hc03, 'hc04, 'hc05, 'hc06, 'hc07, 'hc08, 'hc09, 'hc0a, 'hc0b, 'hc0c, 'hc0d, 'hc0e, 'hc0f, 'hc10, 'hc11, 'hc12, 'hc13, 'hc14, 'hc15, 'hc16, 'hc17, 'hc18, 'hc19, 'hc1a, 'hc1b, 'hc1c, 'hc1d, 'hc1e, 'hc1f, 'hc20, 'hc21, 'hc22, 'hc23, 'hc24, 'hc25, 'hc26, 'hc27, 'hc28, 'hc29, 'hc2a, 'hc2b, 'hc2c, 'hc2d, 'hc2e, 'hc2f, 'hc30, 'hc31, 'hc32, 'hc33, 'hc34, 'hc35, 'hc36, 'hc37, 'hc38, 'hc39, 'hc3a, 'hc3b, 'hc3c, 'hc3d, 'hc3e, 'hc3f, 'hc40, 'hc41, 'hc42, 'hc43, 'hc44, 'hc45, 'hc46, 'hc47, 'hc48, 'hc49, 'hc4a, 'hc4b, 'hc4c, 'hc4d, 'hc4e, 'hc4f, 'hc50, 'hc51, 'hc52, 'hc53, 'hc54, 'hc55, 'hc56, 'hc57, 'hc58, 'hc59, 'hc5a, 'hc5b, 'hc5c, 'hc5d, 'hc5e, 'hc5f, 'hc60, 'hc61, 'hc62, 'hc63, 'hc64, 'hc65, 'hc66, 'hc67, 'hc68, 'hc69, 'hc6a, 'hc6b, 'hc6c, 'hc6d, 'hc6e, 'hc6f, 'hc70, 'hc71, 'hc72, 'hc73, 'hc74, 'hc75, 'hc76, 'hc77, 'hc78, 'hc79, 'hc7a, 'hc7b, 'hc7c, 'hc7d, 'hc7e, 'hc7f, 'hc81, 'hc83, 'hc84, 'hc85, 'hc86, 'hc87, 'hc88, 'hc89, 'hc8a, 'hc8b, 'hc8c, 'hc8d, 'hc8e, 'hc8f, 'hc90, 'hc91, 'hc92, 'hc93, 'hc94, 'hc95, 'hc96, 'hc97, 'hc98, 'hc99, 'hc9a, 'hc9b, 'hc9c, 'hc9d, 'hc9e, 'hc9f, 'hca0, 'hca1, 'hca2, 'hca3, 'hca4, 'hca5, 'hca6, 'hca7, 'hca8, 'hca9, 'hcaa, 'hcab, 'hcac, 'hcad, 'hcae, 'hcaf, 'hcb0, 'hcb1, 'hcb2, 'hcb3, 'hcb4, 'hcb5, 'hcb6, 'hcb7, 'hcb8, 'hcb9, 'hcba, 'hcbb, 'hcbc, 'hcbd, 'hcbe, 'hcbf, 'hcc0, 'hcc1, 'hcc2, 'hcc3, 'hcc4, 'hcc5, 'hcc6, 'hcc7, 'hcc8, 'hcc9, 'hcca, 'hccb, 'hccc, 'hccd, 'hcce, 'hccf, 'hcd0, 'hcd1, 'hcd2, 'hcd3, 'hcd4, 'hcd5, 'hcd6, 'hcd7, 'hcd8, 'hcd9, 'hcda, 'hcdb, 'hcdc, 'hcdd, 'hcde, 'hcdf, 'hce0, 'hce1, 'hce2, 'hce3, 'hce4, 'hce5, 'hce6, 'hce7, 'hce8, 'hce9, 'hcea, 'hceb, 'hcec, 'hced, 'hcee, 'hcef, 'hcf0, 'hcf1, 'hcf2, 'hcf3, 'hcf4, 'hcf5, 'hcf6, 'hcf7, 'hcf8, 'hcf9, 'hcfa, 'hcfb, 'hcfc, 'hcfd, 'hcfe, 'hcff, 'hd00, 'hd01, 'hd02, 'hd03, 'hd04, 'hd05, 'hd06, 'hd07, 'hd08, 'hd09, 'hd0a, 'hd0b, 'hd0c, 'hd0d, 'hd0e, 'hd0f, 'hd10, 'hd11, 'hd12, 'hd13, 'hd14, 'hd15, 'hd16, 'hd17, 'hd18, 'hd19, 'hd1a, 'hd1b, 'hd1c, 'hd1d, 'hd1e, 'hd1f, 'hd20, 'hd21, 'hd22, 'hd23, 'hd24, 'hd25, 'hd26, 'hd27, 'hd28, 'hd29, 'hd2a, 'hd2b, 'hd2c, 'hd2d, 'hd2e, 'hd2f, 'hd30, 'hd31, 'hd32, 'hd33, 'hd34, 'hd35, 'hd36, 'hd37, 'hd38, 'hd39, 'hd3a, 'hd3b, 'hd3c, 'hd3d, 'hd3e, 'hd3f, 'hd40, 'hd41, 'hd42, 'hd43, 'hd44, 'hd45, 'hd46, 'hd47, 'hd48, 'hd49, 'hd4a, 'hd4b, 'hd4c, 'hd4d, 'hd4e, 'hd4f, 'hd50, 'hd51, 'hd52, 'hd53, 'hd54, 'hd55, 'hd56, 'hd57, 'hd58, 'hd59, 'hd5a, 'hd5b, 'hd5c, 'hd5d, 'hd5e, 'hd5f, 'hd60, 'hd61, 'hd62, 'hd63, 'hd64, 'hd65, 'hd66, 'hd67, 'hd68, 'hd69, 'hd6a, 'hd6b, 'hd6c, 'hd6d, 'hd6e, 'hd6f, 'hd70, 'hd71, 'hd72, 'hd73, 'hd74, 'hd75, 'hd76, 'hd77, 'hd78, 'hd79, 'hd7a, 'hd7b, 'hd7c, 'hd7d, 'hd7e, 'hd7f, 'hd80, 'hd81, 'hd82, 'hd83, 'hd84, 'hd85, 'hd86, 'hd87, 'hd88, 'hd89, 'hd8a, 'hd8b, 'hd8c, 'hd8d, 'hd8e, 'hd8f, 'hd90, 'hd91, 'hd92, 'hd93, 'hd94, 'hd95, 'hd96, 'hd97, 'hd98, 'hd99, 'hd9a, 'hd9b, 'hd9c, 'hd9d, 'hd9e, 'hd9f, 'hda0, 'hda1, 'hda2, 'hda3, 'hda4, 'hda5, 'hda6, 'hda7, 'hda8, 'hda9, 'hdaa, 'hdab, 'hdac, 'hdad, 'hdae, 'hdaf, 'hdb0, 'hdb1, 'hdb2, 'hdb3, 'hdb4, 'hdb5, 'hdb6, 'hdb7, 'hdb8, 'hdb9, 'hdba, 'hdbb, 'hdbc, 'hdbd, 'hdbe, 'hdbf, 'hdc0, 'hdc1, 'hdc2, 'hdc3, 'hdc4, 'hdc5, 'hdc6, 'hdc7, 'hdc8, 'hdc9, 'hdca, 'hdcb, 'hdcc, 'hdcd, 'hdce, 'hdcf, 'hdd0, 'hdd1, 'hdd2, 'hdd3, 'hdd4, 'hdd5, 'hdd6, 'hdd7, 'hdd8, 'hdd9, 'hdda, 'hddb, 'hddc, 'hddd, 'hdde, 'hddf, 'hde0, 'hde1, 'hde2, 'hde3, 'hde4, 'hde5, 'hde6, 'hde7, 'hde8, 'hde9, 'hdea, 'hdeb, 'hdec, 'hded, 'hdee, 'hdef, 'hdf0, 'hdf1, 'hdf2, 'hdf3, 'hdf4, 'hdf5, 'hdf6, 'hdf7, 'hdf8, 'hdf9, 'hdfa, 'hdfb, 'hdfc, 'hdfd, 'hdfe, 'hdff, 'he00, 'he01, 'he02, 'he03, 'he04, 'he05, 'he06, 'he07, 'he08, 'he09, 'he0a, 'he0b, 'he0c, 'he0d, 'he0e, 'he0f, 'he10, 'he11, 'he12, 'he13, 'he14, 'he15, 'he16, 'he17, 'he18, 'he19, 'he1a, 'he1b, 'he1c, 'he1d, 'he1e, 'he1f, 'he20, 'he21, 'he22, 'he23, 'he24, 'he25, 'he26, 'he27, 'he28, 'he29, 'he2a, 'he2b, 'he2c, 'he2d, 'he2e, 'he2f, 'he30, 'he31, 'he32, 'he33, 'he34, 'he35, 'he36, 'he37, 'he38, 'he39, 'he3a, 'he3b, 'he3c, 'he3d, 'he3e, 'he3f, 'he40, 'he41, 'he42, 'he43, 'he44, 'he45, 'he46, 'he47, 'he48, 'he49, 'he4a, 'he4b, 'he4c, 'he4d, 'he4e, 'he4f, 'he50, 'he51, 'he52, 'he53, 'he54, 'he55, 'he56, 'he57, 'he58, 'he59, 'he5a, 'he5b, 'he5c, 'he5d, 'he5e, 'he5f, 'he60, 'he61, 'he62, 'he63, 'he64, 'he65, 'he66, 'he67, 'he68, 'he69, 'he6a, 'he6b, 'he6c, 'he6d, 'he6e, 'he6f, 'he70, 'he71, 'he72, 'he73, 'he74, 'he75, 'he76, 'he77, 'he78, 'he79, 'he7a, 'he7b, 'he7c, 'he7d, 'he7e, 'he7f, 'he80, 'he81, 'he82, 'he83, 'he84, 'he85, 'he86, 'he87, 'he88, 'he89, 'he8a, 'he8b, 'he8c, 'he8d, 'he8e, 'he8f, 'he90, 'he91, 'he92, 'he93, 'he94, 'he95, 'he96, 'he97, 'he98, 'he99, 'he9a, 'he9b, 'he9c, 'he9d, 'he9e, 'he9f, 'hea0, 'hea1, 'hea2, 'hea3, 'hea4, 'hea5, 'hea6, 'hea7, 'hea8, 'hea9, 'heaa, 'heab, 'heac, 'head, 'heae, 'heaf, 'heb0, 'heb1, 'heb2, 'heb3, 'heb4, 'heb5, 'heb6, 'heb7, 'heb8, 'heb9, 'heba, 'hebb, 'hebc, 'hebd, 'hebe, 'hebf, 'hec0, 'hec1, 'hec2, 'hec3, 'hec4, 'hec5, 'hec6, 'hec7, 'hec8, 'hec9, 'heca, 'hecb, 'hecc, 'hecd, 'hece, 'hecf, 'hed0, 'hed1, 'hed2, 'hed3, 'hed4, 'hed5, 'hed6, 'hed7, 'hed8, 'hed9, 'heda, 'hedb, 'hedc, 'hedd, 'hede, 'hedf, 'hee0, 'hee1, 'hee2, 'hee3, 'hee4, 'hee5, 'hee6, 'hee7, 'hee8, 'hee9, 'heea, 'heeb, 'heec, 'heed, 'heee, 'heef, 'hef0, 'hef1, 'hef2, 'hef3, 'hef4, 'hef5, 'hef6, 'hef7, 'hef8, 'hef9, 'hefa, 'hefb, 'hefc, 'hefd, 'hefe, 'heff, 'hf00, 'hf01, 'hf02, 'hf03, 'hf04, 'hf05, 'hf06, 'hf07, 'hf08, 'hf09, 'hf0a, 'hf0b, 'hf0c, 'hf0d, 'hf0e, 'hf0f, 'hf10, 'hf15, 'hf16, 'hf17, 'hf18, 'hf19, 'hf1a, 'hf1b, 'hf1c, 'hf1d, 'hf1e, 'hf1f, 'hf20, 'hf21, 'hf22, 'hf23, 'hf24, 'hf25, 'hf26, 'hf27, 'hf28, 'hf29, 'hf2a, 'hf2b, 'hf2c, 'hf2d, 'hf2e, 'hf2f, 'hf30, 'hf31, 'hf32, 'hf33, 'hf34, 'hf35, 'hf36, 'hf37, 'hf38, 'hf39, 'hf3a, 'hf3b, 'hf3c, 'hf3d, 'hf3e, 'hf3f, 'hf40, 'hf41, 'hf42, 'hf43, 'hf44, 'hf45, 'hf46, 'hf47, 'hf48, 'hf49, 'hf4a, 'hf4b, 'hf4c, 'hf4d, 'hf4e, 'hf4f, 'hf50, 'hf51, 'hf52, 'hf53, 'hf54, 'hf55, 'hf56, 'hf57, 'hf58, 'hf59, 'hf5a, 'hf5b, 'hf5c, 'hf5d, 'hf5e, 'hf5f, 'hf60, 'hf61, 'hf62, 'hf63, 'hf64, 'hf65, 'hf66, 'hf67, 'hf68, 'hf69, 'hf6a, 'hf6b, 'hf6c, 'hf6d, 'hf6e, 'hf6f, 'hf70, 'hf71, 'hf72, 'hf73, 'hf74, 'hf75, 'hf76, 'hf77, 'hf78, 'hf79, 'hf7a, 'hf7b, 'hf7c, 'hf7d, 'hf7e, 'hf7f, 'hf80, 'hf81, 'hf82, 'hf83, 'hf84, 'hf85, 'hf86, 'hf87, 'hf88, 'hf89, 'hf8a, 'hf8b, 'hf8c, 'hf8d, 'hf8e, 'hf8f, 'hf90, 'hf91, 'hf92, 'hf93, 'hf94, 'hf95, 'hf96, 'hf97, 'hf98, 'hf99, 'hf9a, 'hf9b, 'hf9c, 'hf9d, 'hf9e, 'hf9f, 'hfa0, 'hfa1, 'hfa2, 'hfa3, 'hfa4, 'hfa5, 'hfa6, 'hfa7, 'hfa8, 'hfa9, 'hfaa, 'hfab, 'hfac, 'hfad, 'hfae, 'hfaf, 'hfb0, 'hfb1, 'hfb2, 'hfb3, 'hfb4, 'hfb5, 'hfb6, 'hfb7, 'hfb8, 'hfb9, 'hfba, 'hfbb, 'hfbc, 'hfbd, 'hfbe, 'hfbf, 'hfc0, 'hfc1, 'hfc2, 'hfc3, 'hfc4, 'hfc5, 'hfc6, 'hfc7, 'hfc8, 'hfc9, 'hfca, 'hfcb, 'hfcc, 'hfcd, 'hfce, 'hfcf, 'hfd0, 'hfd1, 'hfd2, 'hfd3, 'hfd4, 'hfd5, 'hfd6, 'hfd7, 'hfd8, 'hfd9, 'hfda, 'hfdb, 'hfdc, 'hfdd, 'hfde, 'hfdf, 'hfe0, 'hfe1, 'hfe2, 'hfe3, 'hfe4, 'hfe5, 'hfe6, 'hfe7, 'hfe8, 'hfe9, 'hfea, 'hfeb, 'hfec, 'hfed, 'hfee, 'hfef, 'hff0, 'hff1, 'hff2, 'hff3, 'hff4, 'hff5, 'hff6, 'hff7, 'hff8, 'hff9, 'hffa, 'hffb, 'hffc, 'hffd, 'hffe, 'hfff} 

    #Unmapped address 0x44a testing: Read Reset + Random data Write/Read
    #Address 0x44a read value
    csrr x14, 0x44a

    #Address 0x44a Write value 0x806bdb1e
    li x3, 0x806bdb1e
    csrw 0x44a, x3

    #Address 0x44a read value
    csrr x14, 0x44a

    #Unmapped address 0x951 testing: Read Reset + Random data Write/Read
    #Address 0x951 read value
    csrr x14, 0x951

    #Address 0x951 Write value 0x2ae64452
    li x3, 0x2ae64452
    csrw 0x951, x3

    #Address 0x951 read value
    csrr x14, 0x951

    #Unmapped address 0xe93 testing: Read Reset + Random data Write/Read
    #Address 0xe93 read value
    csrr x14, 0xe93

    #Address 0xe93 Write value 0x5fe9f009
    li x3, 0x5fe9f009
    csrw 0xe93, x3

    #Address 0xe93 read value
    csrr x14, 0xe93

    #Unmapped address 0x38e testing: Read Reset + Random data Write/Read
    #Address 0x38e read value
    csrr x14, 0x38e

    #Address 0x38e Write value 0xdfca4a6a
    li x3, 0xdfca4a6a
    csrw 0x38e, x3

    #Address 0x38e read value
    csrr x14, 0x38e

    #Unmapped address 0x25b testing: Read Reset + Random data Write/Read
    #Address 0x25b read value
    csrr x14, 0x25b

    #Address 0x25b Write value 0xb04e7a5c
    li x3, 0xb04e7a5c
    csrw 0x25b, x3

    #Address 0x25b read value
    csrr x14, 0x25b

    #Unmapped address 0xc52 testing: Read Reset + Random data Write/Read
    #Address 0xc52 read value
    csrr x14, 0xc52

    #Address 0xc52 Write value 0x26f3d921
    li x3, 0x26f3d921
    csrw 0xc52, x3

    #Address 0xc52 read value
    csrr x14, 0xc52

    #Unmapped address 0xc64 testing: Read Reset + Random data Write/Read
    #Address 0xc64 read value
    csrr x14, 0xc64

    #Address 0xc64 Write value 0xb32ddf8f
    li x3, 0xb32ddf8f
    csrw 0xc64, x3

    #Address 0xc64 read value
    csrr x14, 0xc64

    #Unmapped address 0xfb5 testing: Read Reset + Random data Write/Read
    #Address 0xfb5 read value
    csrr x14, 0xfb5

    #Address 0xfb5 Write value 0x764cd0c1
    li x3, 0x764cd0c1
    csrw 0xfb5, x3

    #Address 0xfb5 read value
    csrr x14, 0xfb5

    #Unmapped address 0x62e testing: Read Reset + Random data Write/Read
    #Address 0x62e read value
    csrr x14, 0x62e

    #Address 0x62e Write value 0x3d86b9ce
    li x3, 0x3d86b9ce
    csrw 0x62e, x3

    #Address 0x62e read value
    csrr x14, 0x62e

    #Unmapped address 0x929 testing: Read Reset + Random data Write/Read
    #Address 0x929 read value
    csrr x14, 0x929

    #Address 0x929 Write value 0xe0540d8a
    li x3, 0xe0540d8a
    csrw 0x929, x3

    #Address 0x929 read value
    csrr x14, 0x929

    #Unmapped address 0x370 testing: Read Reset + Random data Write/Read
    #Address 0x370 read value
    csrr x14, 0x370

    #Address 0x370 Write value 0x9ec51869
    li x3, 0x9ec51869
    csrw 0x370, x3

    #Address 0x370 read value
    csrr x14, 0x370

    #Unmapped address 0x7da testing: Read Reset + Random data Write/Read
    #Address 0x7da read value
    csrr x14, 0x7da

    #Address 0x7da Write value 0xad9343ee
    li x3, 0xad9343ee
    csrw 0x7da, x3

    #Address 0x7da read value
    csrr x14, 0x7da

    #Unmapped address 0x696 testing: Read Reset + Random data Write/Read
    #Address 0x696 read value
    csrr x14, 0x696

    #Address 0x696 Write value 0x77bd9941
    li x3, 0x77bd9941
    csrw 0x696, x3

    #Address 0x696 read value
    csrr x14, 0x696

    #Unmapped address 0xa62 testing: Read Reset + Random data Write/Read
    #Address 0xa62 read value
    csrr x14, 0xa62

    #Address 0xa62 Write value 0xf91d99f
    li x3, 0xf91d99f
    csrw 0xa62, x3

    #Address 0xa62 read value
    csrr x14, 0xa62

    #Unmapped address 0x2e7 testing: Read Reset + Random data Write/Read
    #Address 0x2e7 read value
    csrr x14, 0x2e7

    #Address 0x2e7 Write value 0x76b61454
    li x3, 0x76b61454
    csrw 0x2e7, x3

    #Address 0x2e7 read value
    csrr x14, 0x2e7

    #Unmapped address 0xc1b testing: Read Reset + Random data Write/Read
    #Address 0xc1b read value
    csrr x14, 0xc1b

    #Address 0xc1b Write value 0x3a11f8aa
    li x3, 0x3a11f8aa
    csrw 0xc1b, x3

    #Address 0xc1b read value
    csrr x14, 0xc1b

    #Unmapped address 0x746 testing: Read Reset + Random data Write/Read
    #Address 0x746 read value
    csrr x14, 0x746

    #Address 0x746 Write value 0x91d54d14
    li x3, 0x91d54d14
    csrw 0x746, x3

    #Address 0x746 read value
    csrr x14, 0x746

    #Unmapped address 0x372 testing: Read Reset + Random data Write/Read
    #Address 0x372 read value
    csrr x14, 0x372

    #Address 0x372 Write value 0x8f935971
    li x3, 0x8f935971
    csrw 0x372, x3

    #Address 0x372 read value
    csrr x14, 0x372

    #Unmapped address 0xd02 testing: Read Reset + Random data Write/Read
    #Address 0xd02 read value
    csrr x14, 0xd02

    #Address 0xd02 Write value 0x6daf2e3a
    li x3, 0x6daf2e3a
    csrw 0xd02, x3

    #Address 0xd02 read value
    csrr x14, 0xd02

    #Unmapped address 0x1bd testing: Read Reset + Random data Write/Read
    #Address 0x1bd read value
    csrr x14, 0x1bd

    #Address 0x1bd Write value 0xa6912068
    li x3, 0xa6912068
    csrw 0x1bd, x3

    #Address 0x1bd read value
    csrr x14, 0x1bd

    #Unmapped address 0x792 testing: Read Reset + Random data Write/Read
    #Address 0x792 read value
    csrr x14, 0x792

    #Address 0x792 Write value 0x61a30a55
    li x3, 0x61a30a55
    csrw 0x792, x3

    #Address 0x792 read value
    csrr x14, 0x792

    #Unmapped address 0x22b testing: Read Reset + Random data Write/Read
    #Address 0x22b read value
    csrr x14, 0x22b

    #Address 0x22b Write value 0x15af426f
    li x3, 0x15af426f
    csrw 0x22b, x3

    #Address 0x22b read value
    csrr x14, 0x22b

    #Unmapped address 0xc05 testing: Read Reset + Random data Write/Read
    #Address 0xc05 read value
    csrr x14, 0xc05

    #Address 0xc05 Write value 0x9ddbd625
    li x3, 0x9ddbd625
    csrw 0xc05, x3

    #Address 0xc05 read value
    csrr x14, 0xc05

    #Unmapped address 0x12 testing: Read Reset + Random data Write/Read
    #Address 0x12 read value
    csrr x14, 0x12

    #Address 0x12 Write value 0x520ec2a1
    li x3, 0x520ec2a1
    csrw 0x12, x3

    #Address 0x12 read value
    csrr x14, 0x12

    #Unmapped address 0x5cd testing: Read Reset + Random data Write/Read
    #Address 0x5cd read value
    csrr x14, 0x5cd

    #Address 0x5cd Write value 0xf4bd5d59
    li x3, 0xf4bd5d59
    csrw 0x5cd, x3

    #Address 0x5cd read value
    csrr x14, 0x5cd

    #Unmapped address 0xa56 testing: Read Reset + Random data Write/Read
    #Address 0xa56 read value
    csrr x14, 0xa56

    #Address 0xa56 Write value 0xfd22ad2
    li x3, 0xfd22ad2
    csrw 0xa56, x3

    #Address 0xa56 read value
    csrr x14, 0xa56

    #Unmapped address 0x17e testing: Read Reset + Random data Write/Read
    #Address 0x17e read value
    csrr x14, 0x17e

    #Address 0x17e Write value 0xa82fd0d6
    li x3, 0xa82fd0d6
    csrw 0x17e, x3

    #Address 0x17e read value
    csrr x14, 0x17e

    #Unmapped address 0x772 testing: Read Reset + Random data Write/Read
    #Address 0x772 read value
    csrr x14, 0x772

    #Address 0x772 Write value 0x6eedf410
    li x3, 0x6eedf410
    csrw 0x772, x3

    #Address 0x772 read value
    csrr x14, 0x772

    #Unmapped address 0xf78 testing: Read Reset + Random data Write/Read
    #Address 0xf78 read value
    csrr x14, 0xf78

    #Address 0xf78 Write value 0xad34ed40
    li x3, 0xad34ed40
    csrw 0xf78, x3

    #Address 0xf78 read value
    csrr x14, 0xf78

    #Unmapped address 0xebb testing: Read Reset + Random data Write/Read
    #Address 0xebb read value
    csrr x14, 0xebb

    #Address 0xebb Write value 0x52f748e
    li x3, 0x52f748e
    csrw 0xebb, x3

    #Address 0xebb read value
    csrr x14, 0xebb

    #Unmapped address 0x4e0 testing: Read Reset + Random data Write/Read
    #Address 0x4e0 read value
    csrr x14, 0x4e0

    #Address 0x4e0 Write value 0xaebef9db
    li x3, 0xaebef9db
    csrw 0x4e0, x3

    #Address 0x4e0 read value
    csrr x14, 0x4e0

    #Unmapped address 0x99d testing: Read Reset + Random data Write/Read
    #Address 0x99d read value
    csrr x14, 0x99d

    #Address 0x99d Write value 0x12661d2a
    li x3, 0x12661d2a
    csrw 0x99d, x3

    #Address 0x99d read value
    csrr x14, 0x99d

    #Unmapped address 0x1f1 testing: Read Reset + Random data Write/Read
    #Address 0x1f1 read value
    csrr x14, 0x1f1

    #Address 0x1f1 Write value 0xac46892f
    li x3, 0xac46892f
    csrw 0x1f1, x3

    #Address 0x1f1 read value
    csrr x14, 0x1f1

    #Unmapped address 0xcd5 testing: Read Reset + Random data Write/Read
    #Address 0xcd5 read value
    csrr x14, 0xcd5

    #Address 0xcd5 Write value 0x2260624a
    li x3, 0x2260624a
    csrw 0xcd5, x3

    #Address 0xcd5 read value
    csrr x14, 0xcd5

    #Unmapped address 0x648 testing: Read Reset + Random data Write/Read
    #Address 0x648 read value
    csrr x14, 0x648

    #Address 0x648 Write value 0x7f2c20c5
    li x3, 0x7f2c20c5
    csrw 0x648, x3

    #Address 0x648 read value
    csrr x14, 0x648

    #Unmapped address 0x665 testing: Read Reset + Random data Write/Read
    #Address 0x665 read value
    csrr x14, 0x665

    #Address 0x665 Write value 0xde48a709
    li x3, 0xde48a709
    csrw 0x665, x3

    #Address 0x665 read value
    csrr x14, 0x665

    #Unmapped address 0x9b7 testing: Read Reset + Random data Write/Read
    #Address 0x9b7 read value
    csrr x14, 0x9b7

    #Address 0x9b7 Write value 0x85c26867
    li x3, 0x85c26867
    csrw 0x9b7, x3

    #Address 0x9b7 read value
    csrr x14, 0x9b7

    #Unmapped address 0xddf testing: Read Reset + Random data Write/Read
    #Address 0xddf read value
    csrr x14, 0xddf

    #Address 0xddf Write value 0x775b522e
    li x3, 0x775b522e
    csrw 0xddf, x3

    #Address 0xddf read value
    csrr x14, 0xddf

    #Unmapped address 0x9c2 testing: Read Reset + Random data Write/Read
    #Address 0x9c2 read value
    csrr x14, 0x9c2

    #Address 0x9c2 Write value 0xad0f7055
    li x3, 0xad0f7055
    csrw 0x9c2, x3

    #Address 0x9c2 read value
    csrr x14, 0x9c2

    #Unmapped address 0x6c9 testing: Read Reset + Random data Write/Read
    #Address 0x6c9 read value
    csrr x14, 0x6c9

    #Address 0x6c9 Write value 0x2c799822
    li x3, 0x2c799822
    csrw 0x6c9, x3

    #Address 0x6c9 read value
    csrr x14, 0x6c9

    #Unmapped address 0x7e6 testing: Read Reset + Random data Write/Read
    #Address 0x7e6 read value
    csrr x14, 0x7e6

    #Address 0x7e6 Write value 0xaefc0120
    li x3, 0xaefc0120
    csrw 0x7e6, x3

    #Address 0x7e6 read value
    csrr x14, 0x7e6

    #Unmapped address 0x1bf testing: Read Reset + Random data Write/Read
    #Address 0x1bf read value
    csrr x14, 0x1bf

    #Address 0x1bf Write value 0x94205b24
    li x3, 0x94205b24
    csrw 0x1bf, x3

    #Address 0x1bf read value
    csrr x14, 0x1bf

    #Unmapped address 0x429 testing: Read Reset + Random data Write/Read
    #Address 0x429 read value
    csrr x14, 0x429

    #Address 0x429 Write value 0xf103330
    li x3, 0xf103330
    csrw 0x429, x3

    #Address 0x429 read value
    csrr x14, 0x429

    #Unmapped address 0x1ed testing: Read Reset + Random data Write/Read
    #Address 0x1ed read value
    csrr x14, 0x1ed

    #Address 0x1ed Write value 0xfc74084c
    li x3, 0xfc74084c
    csrw 0x1ed, x3

    #Address 0x1ed read value
    csrr x14, 0x1ed

    #Unmapped address 0x7e4 testing: Read Reset + Random data Write/Read
    #Address 0x7e4 read value
    csrr x14, 0x7e4

    #Address 0x7e4 Write value 0xda4b1115
    li x3, 0xda4b1115
    csrw 0x7e4, x3

    #Address 0x7e4 read value
    csrr x14, 0x7e4

    #Unmapped address 0x171 testing: Read Reset + Random data Write/Read
    #Address 0x171 read value
    csrr x14, 0x171

    #Address 0x171 Write value 0x84af019b
    li x3, 0x84af019b
    csrw 0x171, x3

    #Address 0x171 read value
    csrr x14, 0x171

    #Unmapped address 0x657 testing: Read Reset + Random data Write/Read
    #Address 0x657 read value
    csrr x14, 0x657

    #Address 0x657 Write value 0x7b968815
    li x3, 0x7b968815
    csrw 0x657, x3

    #Address 0x657 read value
    csrr x14, 0x657

    #Unmapped address 0x155 testing: Read Reset + Random data Write/Read
    #Address 0x155 read value
    csrr x14, 0x155

    #Address 0x155 Write value 0x678c05f
    li x3, 0x678c05f
    csrw 0x155, x3

    #Address 0x155 read value
    csrr x14, 0x155

    #Unmapped address 0xb7c testing: Read Reset + Random data Write/Read
    #Address 0xb7c read value
    csrr x14, 0xb7c

    #Address 0xb7c Write value 0xadd0ae8b
    li x3, 0xadd0ae8b
    csrw 0xb7c, x3

    #Address 0xb7c read value
    csrr x14, 0xb7c

    #Unmapped address 0xd05 testing: Read Reset + Random data Write/Read
    #Address 0xd05 read value
    csrr x14, 0xd05

    #Address 0xd05 Write value 0x81eaa0fa
    li x3, 0x81eaa0fa
    csrw 0xd05, x3

    #Address 0xd05 read value
    csrr x14, 0xd05

    #Unmapped address 0x281 testing: Read Reset + Random data Write/Read
    #Address 0x281 read value
    csrr x14, 0x281

    #Address 0x281 Write value 0x108a562e
    li x3, 0x108a562e
    csrw 0x281, x3

    #Address 0x281 read value
    csrr x14, 0x281

    #Unmapped address 0xe20 testing: Read Reset + Random data Write/Read
    #Address 0xe20 read value
    csrr x14, 0xe20

    #Address 0xe20 Write value 0x37d67c94
    li x3, 0x37d67c94
    csrw 0xe20, x3

    #Address 0xe20 read value
    csrr x14, 0xe20

    #Unmapped address 0x8d7 testing: Read Reset + Random data Write/Read
    #Address 0x8d7 read value
    csrr x14, 0x8d7

    #Address 0x8d7 Write value 0xac9dc992
    li x3, 0xac9dc992
    csrw 0x8d7, x3

    #Address 0x8d7 read value
    csrr x14, 0x8d7

    #Unmapped address 0xd79 testing: Read Reset + Random data Write/Read
    #Address 0xd79 read value
    csrr x14, 0xd79

    #Address 0xd79 Write value 0x4cd6fe4
    li x3, 0x4cd6fe4
    csrw 0xd79, x3

    #Address 0xd79 read value
    csrr x14, 0xd79

    #Unmapped address 0x37e testing: Read Reset + Random data Write/Read
    #Address 0x37e read value
    csrr x14, 0x37e

    #Address 0x37e Write value 0x6fba607f
    li x3, 0x6fba607f
    csrw 0x37e, x3

    #Address 0x37e read value
    csrr x14, 0x37e

    #Unmapped address 0x6 testing: Read Reset + Random data Write/Read
    #Address 0x6 read value
    csrr x14, 0x6

    #Address 0x6 Write value 0x4d7e5223
    li x3, 0x4d7e5223
    csrw 0x6, x3

    #Address 0x6 read value
    csrr x14, 0x6

    #Unmapped address 0x46f testing: Read Reset + Random data Write/Read
    #Address 0x46f read value
    csrr x14, 0x46f

    #Address 0x46f Write value 0x53e82c63
    li x3, 0x53e82c63
    csrw 0x46f, x3

    #Address 0x46f read value
    csrr x14, 0x46f

    #Unmapped address 0x15f testing: Read Reset + Random data Write/Read
    #Address 0x15f read value
    csrr x14, 0x15f

    #Address 0x15f Write value 0x5786c003
    li x3, 0x5786c003
    csrw 0x15f, x3

    #Address 0x15f read value
    csrr x14, 0x15f

    #Unmapped address 0x734 testing: Read Reset + Random data Write/Read
    #Address 0x734 read value
    csrr x14, 0x734

    #Address 0x734 Write value 0xcd81fc8d
    li x3, 0xcd81fc8d
    csrw 0x734, x3

    #Address 0x734 read value
    csrr x14, 0x734

    #Unmapped address 0x33 testing: Read Reset + Random data Write/Read
    #Address 0x33 read value
    csrr x14, 0x33

    #Address 0x33 Write value 0xbd7f9ee4
    li x3, 0xbd7f9ee4
    csrw 0x33, x3

    #Address 0x33 read value
    csrr x14, 0x33

    #Unmapped address 0xa86 testing: Read Reset + Random data Write/Read
    #Address 0xa86 read value
    csrr x14, 0xa86

    #Address 0xa86 Write value 0xac977dbd
    li x3, 0xac977dbd
    csrw 0xa86, x3

    #Address 0xa86 read value
    csrr x14, 0xa86

    #Unmapped address 0xbd testing: Read Reset + Random data Write/Read
    #Address 0xbd read value
    csrr x14, 0xbd

    #Address 0xbd Write value 0xdcf943e0
    li x3, 0xdcf943e0
    csrw 0xbd, x3

    #Address 0xbd read value
    csrr x14, 0xbd

    #Unmapped address 0xf08 testing: Read Reset + Random data Write/Read
    #Address 0xf08 read value
    csrr x14, 0xf08

    #Address 0xf08 Write value 0xbe94259b
    li x3, 0xbe94259b
    csrw 0xf08, x3

    #Address 0xf08 read value
    csrr x14, 0xf08

    #Unmapped address 0x8c0 testing: Read Reset + Random data Write/Read
    #Address 0x8c0 read value
    csrr x14, 0x8c0

    #Address 0x8c0 Write value 0xa7105009
    li x3, 0xa7105009
    csrw 0x8c0, x3

    #Address 0x8c0 read value
    csrr x14, 0x8c0

    #Unmapped address 0x84e testing: Read Reset + Random data Write/Read
    #Address 0x84e read value
    csrr x14, 0x84e

    #Address 0x84e Write value 0x7718c231
    li x3, 0x7718c231
    csrw 0x84e, x3

    #Address 0x84e read value
    csrr x14, 0x84e

    #Unmapped address 0x88a testing: Read Reset + Random data Write/Read
    #Address 0x88a read value
    csrr x14, 0x88a

    #Address 0x88a Write value 0x80640e5f
    li x3, 0x80640e5f
    csrw 0x88a, x3

    #Address 0x88a read value
    csrr x14, 0x88a

    #Unmapped address 0xf93 testing: Read Reset + Random data Write/Read
    #Address 0xf93 read value
    csrr x14, 0xf93

    #Address 0xf93 Write value 0x293cbfa5
    li x3, 0x293cbfa5
    csrw 0xf93, x3

    #Address 0xf93 read value
    csrr x14, 0xf93

    #Unmapped address 0x2e6 testing: Read Reset + Random data Write/Read
    #Address 0x2e6 read value
    csrr x14, 0x2e6

    #Address 0x2e6 Write value 0xa256fa50
    li x3, 0xa256fa50
    csrw 0x2e6, x3

    #Address 0x2e6 read value
    csrr x14, 0x2e6

    #Unmapped address 0x886 testing: Read Reset + Random data Write/Read
    #Address 0x886 read value
    csrr x14, 0x886

    #Address 0x886 Write value 0xcf85b2f5
    li x3, 0xcf85b2f5
    csrw 0x886, x3

    #Address 0x886 read value
    csrr x14, 0x886

    #Unmapped address 0x2f3 testing: Read Reset + Random data Write/Read
    #Address 0x2f3 read value
    csrr x14, 0x2f3

    #Address 0x2f3 Write value 0x271981c1
    li x3, 0x271981c1
    csrw 0x2f3, x3

    #Address 0x2f3 read value
    csrr x14, 0x2f3

    #Unmapped address 0x7d1 testing: Read Reset + Random data Write/Read
    #Address 0x7d1 read value
    csrr x14, 0x7d1

    #Address 0x7d1 Write value 0x34a099fc
    li x3, 0x34a099fc
    csrw 0x7d1, x3

    #Address 0x7d1 read value
    csrr x14, 0x7d1

    #Unmapped address 0xcb0 testing: Read Reset + Random data Write/Read
    #Address 0xcb0 read value
    csrr x14, 0xcb0

    #Address 0xcb0 Write value 0x36555ad8
    li x3, 0x36555ad8
    csrw 0xcb0, x3

    #Address 0xcb0 read value
    csrr x14, 0xcb0

    #Unmapped address 0x8ec testing: Read Reset + Random data Write/Read
    #Address 0x8ec read value
    csrr x14, 0x8ec

    #Address 0x8ec Write value 0xfe8e87e9
    li x3, 0xfe8e87e9
    csrw 0x8ec, x3

    #Address 0x8ec read value
    csrr x14, 0x8ec

    #Unmapped address 0xa6a testing: Read Reset + Random data Write/Read
    #Address 0xa6a read value
    csrr x14, 0xa6a

    #Address 0xa6a Write value 0x5e939f9c
    li x3, 0x5e939f9c
    csrw 0xa6a, x3

    #Address 0xa6a read value
    csrr x14, 0xa6a

    #Unmapped address 0x7ab testing: Read Reset + Random data Write/Read
    #Address 0x7ab read value
    csrr x14, 0x7ab

    #Address 0x7ab Write value 0xa08d51a7
    li x3, 0xa08d51a7
    csrw 0x7ab, x3

    #Address 0x7ab read value
    csrr x14, 0x7ab

    #Unmapped address 0x9cb testing: Read Reset + Random data Write/Read
    #Address 0x9cb read value
    csrr x14, 0x9cb

    #Address 0x9cb Write value 0xcffa6eb1
    li x3, 0xcffa6eb1
    csrw 0x9cb, x3

    #Address 0x9cb read value
    csrr x14, 0x9cb

    #Unmapped address 0xd86 testing: Read Reset + Random data Write/Read
    #Address 0xd86 read value
    csrr x14, 0xd86

    #Address 0xd86 Write value 0xa976366c
    li x3, 0xa976366c
    csrw 0xd86, x3

    #Address 0xd86 read value
    csrr x14, 0xd86

    #Unmapped address 0x107 testing: Read Reset + Random data Write/Read
    #Address 0x107 read value
    csrr x14, 0x107

    #Address 0x107 Write value 0xa2414fbe
    li x3, 0xa2414fbe
    csrw 0x107, x3

    #Address 0x107 read value
    csrr x14, 0x107

    #Unmapped address 0xfda testing: Read Reset + Random data Write/Read
    #Address 0xfda read value
    csrr x14, 0xfda

    #Address 0xfda Write value 0x59bc5b2a
    li x3, 0x59bc5b2a
    csrw 0xfda, x3

    #Address 0xfda read value
    csrr x14, 0xfda

    #Unmapped address 0x709 testing: Read Reset + Random data Write/Read
    #Address 0x709 read value
    csrr x14, 0x709

    #Address 0x709 Write value 0xc7fdbfca
    li x3, 0xc7fdbfca
    csrw 0x709, x3

    #Address 0x709 read value
    csrr x14, 0x709

    #Unmapped address 0xc1f testing: Read Reset + Random data Write/Read
    #Address 0xc1f read value
    csrr x14, 0xc1f

    #Address 0xc1f Write value 0x4f219da8
    li x3, 0x4f219da8
    csrw 0xc1f, x3

    #Address 0xc1f read value
    csrr x14, 0xc1f

    #Unmapped address 0xd31 testing: Read Reset + Random data Write/Read
    #Address 0xd31 read value
    csrr x14, 0xd31

    #Address 0xd31 Write value 0xb08fdcf5
    li x3, 0xb08fdcf5
    csrw 0xd31, x3

    #Address 0xd31 read value
    csrr x14, 0xd31

    #Unmapped address 0x295 testing: Read Reset + Random data Write/Read
    #Address 0x295 read value
    csrr x14, 0x295

    #Address 0x295 Write value 0x3a4293ac
    li x3, 0x3a4293ac
    csrw 0x295, x3

    #Address 0x295 read value
    csrr x14, 0x295

    #Unmapped address 0x6b2 testing: Read Reset + Random data Write/Read
    #Address 0x6b2 read value
    csrr x14, 0x6b2

    #Address 0x6b2 Write value 0x7c3ec5da
    li x3, 0x7c3ec5da
    csrw 0x6b2, x3

    #Address 0x6b2 read value
    csrr x14, 0x6b2

    #Unmapped address 0xc9c testing: Read Reset + Random data Write/Read
    #Address 0xc9c read value
    csrr x14, 0xc9c

    #Address 0xc9c Write value 0xba352fc7
    li x3, 0xba352fc7
    csrw 0xc9c, x3

    #Address 0xc9c read value
    csrr x14, 0xc9c

    #Unmapped address 0x55 testing: Read Reset + Random data Write/Read
    #Address 0x55 read value
    csrr x14, 0x55

    #Address 0x55 Write value 0xf352f19b
    li x3, 0xf352f19b
    csrw 0x55, x3

    #Address 0x55 read value
    csrr x14, 0x55

    #Unmapped address 0xfc1 testing: Read Reset + Random data Write/Read
    #Address 0xfc1 read value
    csrr x14, 0xfc1

    #Address 0xfc1 Write value 0xef2e36ce
    li x3, 0xef2e36ce
    csrw 0xfc1, x3

    #Address 0xfc1 read value
    csrr x14, 0xfc1

    #Unmapped address 0xc45 testing: Read Reset + Random data Write/Read
    #Address 0xc45 read value
    csrr x14, 0xc45

    #Address 0xc45 Write value 0x64752c8e
    li x3, 0x64752c8e
    csrw 0xc45, x3

    #Address 0xc45 read value
    csrr x14, 0xc45

    #Unmapped address 0x3f4 testing: Read Reset + Random data Write/Read
    #Address 0x3f4 read value
    csrr x14, 0x3f4

    #Address 0x3f4 Write value 0x2b20a634
    li x3, 0x2b20a634
    csrw 0x3f4, x3

    #Address 0x3f4 read value
    csrr x14, 0x3f4

    #Unmapped address 0x8eb testing: Read Reset + Random data Write/Read
    #Address 0x8eb read value
    csrr x14, 0x8eb

    #Address 0x8eb Write value 0x4f8e29c1
    li x3, 0x4f8e29c1
    csrw 0x8eb, x3

    #Address 0x8eb read value
    csrr x14, 0x8eb

    #Unmapped address 0xdb0 testing: Read Reset + Random data Write/Read
    #Address 0xdb0 read value
    csrr x14, 0xdb0

    #Address 0xdb0 Write value 0x48aa1252
    li x3, 0x48aa1252
    csrw 0xdb0, x3

    #Address 0xdb0 read value
    csrr x14, 0xdb0

    #Unmapped address 0x28d testing: Read Reset + Random data Write/Read
    #Address 0x28d read value
    csrr x14, 0x28d

    #Address 0x28d Write value 0xaef8538
    li x3, 0xaef8538
    csrw 0x28d, x3

    #Address 0x28d read value
    csrr x14, 0x28d

    #Unmapped address 0x920 testing: Read Reset + Random data Write/Read
    #Address 0x920 read value
    csrr x14, 0x920

    #Address 0x920 Write value 0xbcf06205
    li x3, 0xbcf06205
    csrw 0x920, x3

    #Address 0x920 read value
    csrr x14, 0x920

    #Unmapped address 0xc2f testing: Read Reset + Random data Write/Read
    #Address 0xc2f read value
    csrr x14, 0xc2f

    #Address 0xc2f Write value 0x32795971
    li x3, 0x32795971
    csrw 0xc2f, x3

    #Address 0xc2f read value
    csrr x14, 0xc2f

    #Unmapped address 0xfa9 testing: Read Reset + Random data Write/Read
    #Address 0xfa9 read value
    csrr x14, 0xfa9

    #Address 0xfa9 Write value 0xc116cba8
    li x3, 0xc116cba8
    csrw 0xfa9, x3

    #Address 0xfa9 read value
    csrr x14, 0xfa9

    #Unmapped address 0x866 testing: Read Reset + Random data Write/Read
    #Address 0x866 read value
    csrr x14, 0x866

    #Address 0x866 Write value 0x737431ec
    li x3, 0x737431ec
    csrw 0x866, x3

    #Address 0x866 read value
    csrr x14, 0x866

    #Unmapped address 0xc3f testing: Read Reset + Random data Write/Read
    #Address 0xc3f read value
    csrr x14, 0xc3f

    #Address 0xc3f Write value 0xd8c84d28
    li x3, 0xd8c84d28
    csrw 0xc3f, x3

    #Address 0xc3f read value
    csrr x14, 0xc3f

    #Unmapped address 0x111 testing: Read Reset + Random data Write/Read
    #Address 0x111 read value
    csrr x14, 0x111

    #Address 0x111 Write value 0x6b113929
    li x3, 0x6b113929
    csrw 0x111, x3

    #Address 0x111 read value
    csrr x14, 0x111

    #Unmapped address 0x716 testing: Read Reset + Random data Write/Read
    #Address 0x716 read value
    csrr x14, 0x716

    #Address 0x716 Write value 0x5ab1e19a
    li x3, 0x5ab1e19a
    csrw 0x716, x3

    #Address 0x716 read value
    csrr x14, 0x716

    #Unmapped address 0x6c4 testing: Read Reset + Random data Write/Read
    #Address 0x6c4 read value
    csrr x14, 0x6c4

    #Address 0x6c4 Write value 0x716da4e3
    li x3, 0x716da4e3
    csrw 0x6c4, x3

    #Address 0x6c4 read value
    csrr x14, 0x6c4

    #Unmapped address 0xd16 testing: Read Reset + Random data Write/Read
    #Address 0xd16 read value
    csrr x14, 0xd16

    #Address 0xd16 Write value 0x5acc5478
    li x3, 0x5acc5478
    csrw 0xd16, x3

    #Address 0xd16 read value
    csrr x14, 0xd16

    #Unmapped address 0x308 testing: Read Reset + Random data Write/Read
    #Address 0x308 read value
    csrr x14, 0x308

    #Address 0x308 Write value 0x1af88516
    li x3, 0x1af88516
    csrw 0x308, x3

    #Address 0x308 read value
    csrr x14, 0x308

    #Unmapped address 0xe26 testing: Read Reset + Random data Write/Read
    #Address 0xe26 read value
    csrr x14, 0xe26

    #Address 0xe26 Write value 0x6cc2403
    li x3, 0x6cc2403
    csrw 0xe26, x3

    #Address 0xe26 read value
    csrr x14, 0xe26

    #Unmapped address 0x86e testing: Read Reset + Random data Write/Read
    #Address 0x86e read value
    csrr x14, 0x86e

    #Address 0x86e Write value 0xffaf4e51
    li x3, 0xffaf4e51
    csrw 0x86e, x3

    #Address 0x86e read value
    csrr x14, 0x86e

    #Unmapped address 0x2cf testing: Read Reset + Random data Write/Read
    #Address 0x2cf read value
    csrr x14, 0x2cf

    #Address 0x2cf Write value 0xab9ce922
    li x3, 0xab9ce922
    csrw 0x2cf, x3

    #Address 0x2cf read value
    csrr x14, 0x2cf

    #Unmapped address 0xec5 testing: Read Reset + Random data Write/Read
    #Address 0xec5 read value
    csrr x14, 0xec5

    #Address 0xec5 Write value 0x407c91dc
    li x3, 0x407c91dc
    csrw 0xec5, x3

    #Address 0xec5 read value
    csrr x14, 0xec5

    #Unmapped address 0x4f8 testing: Read Reset + Random data Write/Read
    #Address 0x4f8 read value
    csrr x14, 0x4f8

    #Address 0x4f8 Write value 0x5920ee84
    li x3, 0x5920ee84
    csrw 0x4f8, x3

    #Address 0x4f8 read value
    csrr x14, 0x4f8

    #Unmapped address 0xd00 testing: Read Reset + Random data Write/Read
    #Address 0xd00 read value
    csrr x14, 0xd00

    #Address 0xd00 Write value 0xb22bf3db
    li x3, 0xb22bf3db
    csrw 0xd00, x3

    #Address 0xd00 read value
    csrr x14, 0xd00

    #Unmapped address 0x94d testing: Read Reset + Random data Write/Read
    #Address 0x94d read value
    csrr x14, 0x94d

    #Address 0x94d Write value 0x6a2e025a
    li x3, 0x6a2e025a
    csrw 0x94d, x3

    #Address 0x94d read value
    csrr x14, 0x94d

    #Unmapped address 0x8d4 testing: Read Reset + Random data Write/Read
    #Address 0x8d4 read value
    csrr x14, 0x8d4

    #Address 0x8d4 Write value 0x5744929a
    li x3, 0x5744929a
    csrw 0x8d4, x3

    #Address 0x8d4 read value
    csrr x14, 0x8d4

    #Unmapped address 0x315 testing: Read Reset + Random data Write/Read
    #Address 0x315 read value
    csrr x14, 0x315

    #Address 0x315 Write value 0x24e0476e
    li x3, 0x24e0476e
    csrw 0x315, x3

    #Address 0x315 read value
    csrr x14, 0x315

    #Unmapped address 0x75 testing: Read Reset + Random data Write/Read
    #Address 0x75 read value
    csrr x14, 0x75

    #Address 0x75 Write value 0xfa70093c
    li x3, 0xfa70093c
    csrw 0x75, x3

    #Address 0x75 read value
    csrr x14, 0x75

    #Unmapped address 0x7ac testing: Read Reset + Random data Write/Read
    #Address 0x7ac read value
    csrr x14, 0x7ac

    #Address 0x7ac Write value 0xa37b56c0
    li x3, 0xa37b56c0
    csrw 0x7ac, x3

    #Address 0x7ac read value
    csrr x14, 0x7ac

    #Unmapped address 0x65d testing: Read Reset + Random data Write/Read
    #Address 0x65d read value
    csrr x14, 0x65d

    #Address 0x65d Write value 0x1c8ea1cc
    li x3, 0x1c8ea1cc
    csrw 0x65d, x3

    #Address 0x65d read value
    csrr x14, 0x65d

    #Unmapped address 0x6b8 testing: Read Reset + Random data Write/Read
    #Address 0x6b8 read value
    csrr x14, 0x6b8

    #Address 0x6b8 Write value 0x9813cee4
    li x3, 0x9813cee4
    csrw 0x6b8, x3

    #Address 0x6b8 read value
    csrr x14, 0x6b8

    #Unmapped address 0x624 testing: Read Reset + Random data Write/Read
    #Address 0x624 read value
    csrr x14, 0x624

    #Address 0x624 Write value 0x110fa8e2
    li x3, 0x110fa8e2
    csrw 0x624, x3

    #Address 0x624 read value
    csrr x14, 0x624

    #Unmapped address 0x692 testing: Read Reset + Random data Write/Read
    #Address 0x692 read value
    csrr x14, 0x692

    #Address 0x692 Write value 0x66fc3293
    li x3, 0x66fc3293
    csrw 0x692, x3

    #Address 0x692 read value
    csrr x14, 0x692

    #Unmapped address 0x9e8 testing: Read Reset + Random data Write/Read
    #Address 0x9e8 read value
    csrr x14, 0x9e8

    #Address 0x9e8 Write value 0x63222e39
    li x3, 0x63222e39
    csrw 0x9e8, x3

    #Address 0x9e8 read value
    csrr x14, 0x9e8

    #Unmapped address 0xb79 testing: Read Reset + Random data Write/Read
    #Address 0xb79 read value
    csrr x14, 0xb79

    #Address 0xb79 Write value 0x6019f0ab
    li x3, 0x6019f0ab
    csrw 0xb79, x3

    #Address 0xb79 read value
    csrr x14, 0xb79

    #Unmapped address 0xfad testing: Read Reset + Random data Write/Read
    #Address 0xfad read value
    csrr x14, 0xfad

    #Address 0xfad Write value 0x2e661cfc
    li x3, 0x2e661cfc
    csrw 0xfad, x3

    #Address 0xfad read value
    csrr x14, 0xfad

    #Unmapped address 0x388 testing: Read Reset + Random data Write/Read
    #Address 0x388 read value
    csrr x14, 0x388

    #Address 0x388 Write value 0x72686084
    li x3, 0x72686084
    csrw 0x388, x3

    #Address 0x388 read value
    csrr x14, 0x388

    #Unmapped address 0x75d testing: Read Reset + Random data Write/Read
    #Address 0x75d read value
    csrr x14, 0x75d

    #Address 0x75d Write value 0x9af7ccad
    li x3, 0x9af7ccad
    csrw 0x75d, x3

    #Address 0x75d read value
    csrr x14, 0x75d

    #Unmapped address 0xede testing: Read Reset + Random data Write/Read
    #Address 0xede read value
    csrr x14, 0xede

    #Address 0xede Write value 0x32502f4b
    li x3, 0x32502f4b
    csrw 0xede, x3

    #Address 0xede read value
    csrr x14, 0xede

    #Unmapped address 0x6da testing: Read Reset + Random data Write/Read
    #Address 0x6da read value
    csrr x14, 0x6da

    #Address 0x6da Write value 0x41aa4f35
    li x3, 0x41aa4f35
    csrw 0x6da, x3

    #Address 0x6da read value
    csrr x14, 0x6da

    #Unmapped address 0xdc3 testing: Read Reset + Random data Write/Read
    #Address 0xdc3 read value
    csrr x14, 0xdc3

    #Address 0xdc3 Write value 0xd23d801
    li x3, 0xd23d801
    csrw 0xdc3, x3

    #Address 0xdc3 read value
    csrr x14, 0xdc3

    #Unmapped address 0x70e testing: Read Reset + Random data Write/Read
    #Address 0x70e read value
    csrr x14, 0x70e

    #Address 0x70e Write value 0xfe4707ec
    li x3, 0xfe4707ec
    csrw 0x70e, x3

    #Address 0x70e read value
    csrr x14, 0x70e

    #Unmapped address 0xdf8 testing: Read Reset + Random data Write/Read
    #Address 0xdf8 read value
    csrr x14, 0xdf8

    #Address 0xdf8 Write value 0x3cba6af4
    li x3, 0x3cba6af4
    csrw 0xdf8, x3

    #Address 0xdf8 read value
    csrr x14, 0xdf8

    #Unmapped address 0x71c testing: Read Reset + Random data Write/Read
    #Address 0x71c read value
    csrr x14, 0x71c

    #Address 0x71c Write value 0x467bac78
    li x3, 0x467bac78
    csrw 0x71c, x3

    #Address 0x71c read value
    csrr x14, 0x71c

    #Unmapped address 0x170 testing: Read Reset + Random data Write/Read
    #Address 0x170 read value
    csrr x14, 0x170

    #Address 0x170 Write value 0xf0e0ddad
    li x3, 0xf0e0ddad
    csrw 0x170, x3

    #Address 0x170 read value
    csrr x14, 0x170

    #Unmapped address 0xc84 testing: Read Reset + Random data Write/Read
    #Address 0xc84 read value
    csrr x14, 0xc84

    #Address 0xc84 Write value 0xb5404fdd
    li x3, 0xb5404fdd
    csrw 0xc84, x3

    #Address 0xc84 read value
    csrr x14, 0xc84

    #Unmapped address 0xd3f testing: Read Reset + Random data Write/Read
    #Address 0xd3f read value
    csrr x14, 0xd3f

    #Address 0xd3f Write value 0x850df599
    li x3, 0x850df599
    csrw 0xd3f, x3

    #Address 0xd3f read value
    csrr x14, 0xd3f

    #Unmapped address 0xd56 testing: Read Reset + Random data Write/Read
    #Address 0xd56 read value
    csrr x14, 0xd56

    #Address 0xd56 Write value 0xa4b2f54a
    li x3, 0xa4b2f54a
    csrw 0xd56, x3

    #Address 0xd56 read value
    csrr x14, 0xd56

    #Unmapped address 0x82b testing: Read Reset + Random data Write/Read
    #Address 0x82b read value
    csrr x14, 0x82b

    #Address 0x82b Write value 0x34ea24fb
    li x3, 0x34ea24fb
    csrw 0x82b, x3

    #Address 0x82b read value
    csrr x14, 0x82b

    #Unmapped address 0x56c testing: Read Reset + Random data Write/Read
    #Address 0x56c read value
    csrr x14, 0x56c

    #Address 0x56c Write value 0xf156c124
    li x3, 0xf156c124
    csrw 0x56c, x3

    #Address 0x56c read value
    csrr x14, 0x56c

    #Unmapped address 0x5af testing: Read Reset + Random data Write/Read
    #Address 0x5af read value
    csrr x14, 0x5af

    #Address 0x5af Write value 0xf7095b2
    li x3, 0xf7095b2
    csrw 0x5af, x3

    #Address 0x5af read value
    csrr x14, 0x5af

    #Unmapped address 0x591 testing: Read Reset + Random data Write/Read
    #Address 0x591 read value
    csrr x14, 0x591

    #Address 0x591 Write value 0xe04edf67
    li x3, 0xe04edf67
    csrw 0x591, x3

    #Address 0x591 read value
    csrr x14, 0x591

    #Unmapped address 0xe71 testing: Read Reset + Random data Write/Read
    #Address 0xe71 read value
    csrr x14, 0xe71

    #Address 0xe71 Write value 0x2a0d4b76
    li x3, 0x2a0d4b76
    csrw 0xe71, x3

    #Address 0xe71 read value
    csrr x14, 0xe71

    #Unmapped address 0xec0 testing: Read Reset + Random data Write/Read
    #Address 0xec0 read value
    csrr x14, 0xec0

    #Address 0xec0 Write value 0x1478e232
    li x3, 0x1478e232
    csrw 0xec0, x3

    #Address 0xec0 read value
    csrr x14, 0xec0

    #Unmapped address 0x8b4 testing: Read Reset + Random data Write/Read
    #Address 0x8b4 read value
    csrr x14, 0x8b4

    #Address 0x8b4 Write value 0x6253ed74
    li x3, 0x6253ed74
    csrw 0x8b4, x3

    #Address 0x8b4 read value
    csrr x14, 0x8b4

    #Unmapped address 0xd41 testing: Read Reset + Random data Write/Read
    #Address 0xd41 read value
    csrr x14, 0xd41

    #Address 0xd41 Write value 0xde27803e
    li x3, 0xde27803e
    csrw 0xd41, x3

    #Address 0xd41 read value
    csrr x14, 0xd41

    #Unmapped address 0xc1a testing: Read Reset + Random data Write/Read
    #Address 0xc1a read value
    csrr x14, 0xc1a

    #Address 0xc1a Write value 0x440ca6b6
    li x3, 0x440ca6b6
    csrw 0xc1a, x3

    #Address 0xc1a read value
    csrr x14, 0xc1a

    #Unmapped address 0x96d testing: Read Reset + Random data Write/Read
    #Address 0x96d read value
    csrr x14, 0x96d

    #Address 0x96d Write value 0xc8a624a
    li x3, 0xc8a624a
    csrw 0x96d, x3

    #Address 0x96d read value
    csrr x14, 0x96d

    #Unmapped address 0xb58 testing: Read Reset + Random data Write/Read
    #Address 0xb58 read value
    csrr x14, 0xb58

    #Address 0xb58 Write value 0xef207d9
    li x3, 0xef207d9
    csrw 0xb58, x3

    #Address 0xb58 read value
    csrr x14, 0xb58

    #Unmapped address 0x1b0 testing: Read Reset + Random data Write/Read
    #Address 0x1b0 read value
    csrr x14, 0x1b0

    #Address 0x1b0 Write value 0x289c1f5
    li x3, 0x289c1f5
    csrw 0x1b0, x3

    #Address 0x1b0 read value
    csrr x14, 0x1b0

    #Unmapped address 0x72e testing: Read Reset + Random data Write/Read
    #Address 0x72e read value
    csrr x14, 0x72e

    #Address 0x72e Write value 0x8f40bc82
    li x3, 0x8f40bc82
    csrw 0x72e, x3

    #Address 0x72e read value
    csrr x14, 0x72e

    #Unmapped address 0xceb testing: Read Reset + Random data Write/Read
    #Address 0xceb read value
    csrr x14, 0xceb

    #Address 0xceb Write value 0xe58d33a6
    li x3, 0xe58d33a6
    csrw 0xceb, x3

    #Address 0xceb read value
    csrr x14, 0xceb

    #Unmapped address 0x9e testing: Read Reset + Random data Write/Read
    #Address 0x9e read value
    csrr x14, 0x9e

    #Address 0x9e Write value 0x52b024f
    li x3, 0x52b024f
    csrw 0x9e, x3

    #Address 0x9e read value
    csrr x14, 0x9e

    #Unmapped address 0xaf9 testing: Read Reset + Random data Write/Read
    #Address 0xaf9 read value
    csrr x14, 0xaf9

    #Address 0xaf9 Write value 0x48e6a64e
    li x3, 0x48e6a64e
    csrw 0xaf9, x3

    #Address 0xaf9 read value
    csrr x14, 0xaf9

    #Unmapped address 0x970 testing: Read Reset + Random data Write/Read
    #Address 0x970 read value
    csrr x14, 0x970

    #Address 0x970 Write value 0xf7eb6cb9
    li x3, 0xf7eb6cb9
    csrw 0x970, x3

    #Address 0x970 read value
    csrr x14, 0x970

    #Unmapped address 0x533 testing: Read Reset + Random data Write/Read
    #Address 0x533 read value
    csrr x14, 0x533

    #Address 0x533 Write value 0xb320db69
    li x3, 0xb320db69
    csrw 0x533, x3

    #Address 0x533 read value
    csrr x14, 0x533

    #Unmapped address 0xd2c testing: Read Reset + Random data Write/Read
    #Address 0xd2c read value
    csrr x14, 0xd2c

    #Address 0xd2c Write value 0x6c6420e9
    li x3, 0x6c6420e9
    csrw 0xd2c, x3

    #Address 0xd2c read value
    csrr x14, 0xd2c

    #Unmapped address 0xeae testing: Read Reset + Random data Write/Read
    #Address 0xeae read value
    csrr x14, 0xeae

    #Address 0xeae Write value 0x3cfd5dbc
    li x3, 0x3cfd5dbc
    csrw 0xeae, x3

    #Address 0xeae read value
    csrr x14, 0xeae

    #Unmapped address 0x71e testing: Read Reset + Random data Write/Read
    #Address 0x71e read value
    csrr x14, 0x71e

    #Address 0x71e Write value 0x2e28a3c6
    li x3, 0x2e28a3c6
    csrw 0x71e, x3

    #Address 0x71e read value
    csrr x14, 0x71e

    #Unmapped address 0xfb7 testing: Read Reset + Random data Write/Read
    #Address 0xfb7 read value
    csrr x14, 0xfb7

    #Address 0xfb7 Write value 0x723c491a
    li x3, 0x723c491a
    csrw 0xfb7, x3

    #Address 0xfb7 read value
    csrr x14, 0xfb7

    #Unmapped address 0xfb9 testing: Read Reset + Random data Write/Read
    #Address 0xfb9 read value
    csrr x14, 0xfb9

    #Address 0xfb9 Write value 0xe83ceee2
    li x3, 0xe83ceee2
    csrw 0xfb9, x3

    #Address 0xfb9 read value
    csrr x14, 0xfb9

    #Unmapped address 0xdc4 testing: Read Reset + Random data Write/Read
    #Address 0xdc4 read value
    csrr x14, 0xdc4

    #Address 0xdc4 Write value 0xa5039549
    li x3, 0xa5039549
    csrw 0xdc4, x3

    #Address 0xdc4 read value
    csrr x14, 0xdc4

    #Unmapped address 0xd64 testing: Read Reset + Random data Write/Read
    #Address 0xd64 read value
    csrr x14, 0xd64

    #Address 0xd64 Write value 0xf3da4a02
    li x3, 0xf3da4a02
    csrw 0xd64, x3

    #Address 0xd64 read value
    csrr x14, 0xd64

    #Unmapped address 0x5e3 testing: Read Reset + Random data Write/Read
    #Address 0x5e3 read value
    csrr x14, 0x5e3

    #Address 0x5e3 Write value 0x3077c482
    li x3, 0x3077c482
    csrw 0x5e3, x3

    #Address 0x5e3 read value
    csrr x14, 0x5e3

    #Unmapped address 0x9fc testing: Read Reset + Random data Write/Read
    #Address 0x9fc read value
    csrr x14, 0x9fc

    #Address 0x9fc Write value 0x8e4d30d5
    li x3, 0x8e4d30d5
    csrw 0x9fc, x3

    #Address 0x9fc read value
    csrr x14, 0x9fc

    #Unmapped address 0xf1d testing: Read Reset + Random data Write/Read
    #Address 0xf1d read value
    csrr x14, 0xf1d

    #Address 0xf1d Write value 0x8854a7b4
    li x3, 0x8854a7b4
    csrw 0xf1d, x3

    #Address 0xf1d read value
    csrr x14, 0xf1d

    #Unmapped address 0x2c4 testing: Read Reset + Random data Write/Read
    #Address 0x2c4 read value
    csrr x14, 0x2c4

    #Address 0x2c4 Write value 0xd67068cb
    li x3, 0xd67068cb
    csrw 0x2c4, x3

    #Address 0x2c4 read value
    csrr x14, 0x2c4

    #Unmapped address 0xf83 testing: Read Reset + Random data Write/Read
    #Address 0xf83 read value
    csrr x14, 0xf83

    #Address 0xf83 Write value 0x15328285
    li x3, 0x15328285
    csrw 0xf83, x3

    #Address 0xf83 read value
    csrr x14, 0xf83

    #Unmapped address 0x93c testing: Read Reset + Random data Write/Read
    #Address 0x93c read value
    csrr x14, 0x93c

    #Address 0x93c Write value 0x5e02d991
    li x3, 0x5e02d991
    csrw 0x93c, x3

    #Address 0x93c read value
    csrr x14, 0x93c

    #Unmapped address 0xe7b testing: Read Reset + Random data Write/Read
    #Address 0xe7b read value
    csrr x14, 0xe7b

    #Address 0xe7b Write value 0x9555561a
    li x3, 0x9555561a
    csrw 0xe7b, x3

    #Address 0xe7b read value
    csrr x14, 0xe7b

    #Unmapped address 0xa33 testing: Read Reset + Random data Write/Read
    #Address 0xa33 read value
    csrr x14, 0xa33

    #Address 0xa33 Write value 0x39240a7c
    li x3, 0x39240a7c
    csrw 0xa33, x3

    #Address 0xa33 read value
    csrr x14, 0xa33

    #Unmapped address 0xfdd testing: Read Reset + Random data Write/Read
    #Address 0xfdd read value
    csrr x14, 0xfdd

    #Address 0xfdd Write value 0xd5011afb
    li x3, 0xd5011afb
    csrw 0xfdd, x3

    #Address 0xfdd read value
    csrr x14, 0xfdd

    #Unmapped address 0x63f testing: Read Reset + Random data Write/Read
    #Address 0x63f read value
    csrr x14, 0x63f

    #Address 0x63f Write value 0x69d91240
    li x3, 0x69d91240
    csrw 0x63f, x3

    #Address 0x63f read value
    csrr x14, 0x63f

    #Unmapped address 0x222 testing: Read Reset + Random data Write/Read
    #Address 0x222 read value
    csrr x14, 0x222

    #Address 0x222 Write value 0x9048c975
    li x3, 0x9048c975
    csrw 0x222, x3

    #Address 0x222 read value
    csrr x14, 0x222

    #Unmapped address 0xc3c testing: Read Reset + Random data Write/Read
    #Address 0xc3c read value
    csrr x14, 0xc3c

    #Address 0xc3c Write value 0x2b2da7de
    li x3, 0x2b2da7de
    csrw 0xc3c, x3

    #Address 0xc3c read value
    csrr x14, 0xc3c

    #Unmapped address 0x509 testing: Read Reset + Random data Write/Read
    #Address 0x509 read value
    csrr x14, 0x509

    #Address 0x509 Write value 0x2cf59389
    li x3, 0x2cf59389
    csrw 0x509, x3

    #Address 0x509 read value
    csrr x14, 0x509

    #Unmapped address 0x14c testing: Read Reset + Random data Write/Read
    #Address 0x14c read value
    csrr x14, 0x14c

    #Address 0x14c Write value 0x8183dec0
    li x3, 0x8183dec0
    csrw 0x14c, x3

    #Address 0x14c read value
    csrr x14, 0x14c

    #Unmapped address 0xee1 testing: Read Reset + Random data Write/Read
    #Address 0xee1 read value
    csrr x14, 0xee1

    #Address 0xee1 Write value 0xb13e7af0
    li x3, 0xb13e7af0
    csrw 0xee1, x3

    #Address 0xee1 read value
    csrr x14, 0xee1

    #Unmapped address 0x66a testing: Read Reset + Random data Write/Read
    #Address 0x66a read value
    csrr x14, 0x66a

    #Address 0x66a Write value 0x5caff0a3
    li x3, 0x5caff0a3
    csrw 0x66a, x3

    #Address 0x66a read value
    csrr x14, 0x66a

    #Unmapped address 0xaf5 testing: Read Reset + Random data Write/Read
    #Address 0xaf5 read value
    csrr x14, 0xaf5

    #Address 0xaf5 Write value 0x5afdf3b2
    li x3, 0x5afdf3b2
    csrw 0xaf5, x3

    #Address 0xaf5 read value
    csrr x14, 0xaf5

    #Unmapped address 0x1de testing: Read Reset + Random data Write/Read
    #Address 0x1de read value
    csrr x14, 0x1de

    #Address 0x1de Write value 0x46b0c01f
    li x3, 0x46b0c01f
    csrw 0x1de, x3

    #Address 0x1de read value
    csrr x14, 0x1de

    #Unmapped address 0x620 testing: Read Reset + Random data Write/Read
    #Address 0x620 read value
    csrr x14, 0x620

    #Address 0x620 Write value 0x1b41fcaa
    li x3, 0x1b41fcaa
    csrw 0x620, x3

    #Address 0x620 read value
    csrr x14, 0x620

    #Unmapped address 0xef2 testing: Read Reset + Random data Write/Read
    #Address 0xef2 read value
    csrr x14, 0xef2

    #Address 0xef2 Write value 0x3894f3ec
    li x3, 0x3894f3ec
    csrw 0xef2, x3

    #Address 0xef2 read value
    csrr x14, 0xef2

    #Unmapped address 0x3f8 testing: Read Reset + Random data Write/Read
    #Address 0x3f8 read value
    csrr x14, 0x3f8

    #Address 0x3f8 Write value 0x3902c216
    li x3, 0x3902c216
    csrw 0x3f8, x3

    #Address 0x3f8 read value
    csrr x14, 0x3f8

    #Unmapped address 0xf3 testing: Read Reset + Random data Write/Read
    #Address 0xf3 read value
    csrr x14, 0xf3

    #Address 0xf3 Write value 0x2462cc4e
    li x3, 0x2462cc4e
    csrw 0xf3, x3

    #Address 0xf3 read value
    csrr x14, 0xf3

    #Unmapped address 0x92a testing: Read Reset + Random data Write/Read
    #Address 0x92a read value
    csrr x14, 0x92a

    #Address 0x92a Write value 0xecd800bb
    li x3, 0xecd800bb
    csrw 0x92a, x3

    #Address 0x92a read value
    csrr x14, 0x92a

    #Unmapped address 0xe23 testing: Read Reset + Random data Write/Read
    #Address 0xe23 read value
    csrr x14, 0xe23

    #Address 0xe23 Write value 0x666928b4
    li x3, 0x666928b4
    csrw 0xe23, x3

    #Address 0xe23 read value
    csrr x14, 0xe23

    #Unmapped address 0x9a7 testing: Read Reset + Random data Write/Read
    #Address 0x9a7 read value
    csrr x14, 0x9a7

    #Address 0x9a7 Write value 0xb0f9e961
    li x3, 0xb0f9e961
    csrw 0x9a7, x3

    #Address 0x9a7 read value
    csrr x14, 0x9a7

    #Unmapped address 0xa93 testing: Read Reset + Random data Write/Read
    #Address 0xa93 read value
    csrr x14, 0xa93

    #Address 0xa93 Write value 0xbd00ad2
    li x3, 0xbd00ad2
    csrw 0xa93, x3

    #Address 0xa93 read value
    csrr x14, 0xa93

    #Unmapped address 0x2c7 testing: Read Reset + Random data Write/Read
    #Address 0x2c7 read value
    csrr x14, 0x2c7

    #Address 0x2c7 Write value 0xf4a8c964
    li x3, 0xf4a8c964
    csrw 0x2c7, x3

    #Address 0x2c7 read value
    csrr x14, 0x2c7

    #Unmapped address 0x14e testing: Read Reset + Random data Write/Read
    #Address 0x14e read value
    csrr x14, 0x14e

    #Address 0x14e Write value 0x8e5c7dd8
    li x3, 0x8e5c7dd8
    csrw 0x14e, x3

    #Address 0x14e read value
    csrr x14, 0x14e

    #Unmapped address 0x79e testing: Read Reset + Random data Write/Read
    #Address 0x79e read value
    csrr x14, 0x79e

    #Address 0x79e Write value 0x3a340fef
    li x3, 0x3a340fef
    csrw 0x79e, x3

    #Address 0x79e read value
    csrr x14, 0x79e

    #Unmapped address 0xec2 testing: Read Reset + Random data Write/Read
    #Address 0xec2 read value
    csrr x14, 0xec2

    #Address 0xec2 Write value 0x13ad2dda
    li x3, 0x13ad2dda
    csrw 0xec2, x3

    #Address 0xec2 read value
    csrr x14, 0xec2

    #Unmapped address 0x69a testing: Read Reset + Random data Write/Read
    #Address 0x69a read value
    csrr x14, 0x69a

    #Address 0x69a Write value 0x20dcd58e
    li x3, 0x20dcd58e
    csrw 0x69a, x3

    #Address 0x69a read value
    csrr x14, 0x69a

    #Unmapped address 0xbd4 testing: Read Reset + Random data Write/Read
    #Address 0xbd4 read value
    csrr x14, 0xbd4

    #Address 0xbd4 Write value 0x950a776
    li x3, 0x950a776
    csrw 0xbd4, x3

    #Address 0xbd4 read value
    csrr x14, 0xbd4

    #Unmapped address 0x576 testing: Read Reset + Random data Write/Read
    #Address 0x576 read value
    csrr x14, 0x576

    #Address 0x576 Write value 0xfd0bba13
    li x3, 0xfd0bba13
    csrw 0x576, x3

    #Address 0x576 read value
    csrr x14, 0x576

    #Unmapped address 0x559 testing: Read Reset + Random data Write/Read
    #Address 0x559 read value
    csrr x14, 0x559

    #Address 0x559 Write value 0xf42dbea6
    li x3, 0xf42dbea6
    csrw 0x559, x3

    #Address 0x559 read value
    csrr x14, 0x559

    #Unmapped address 0x8f9 testing: Read Reset + Random data Write/Read
    #Address 0x8f9 read value
    csrr x14, 0x8f9

    #Address 0x8f9 Write value 0x2c3d294c
    li x3, 0x2c3d294c
    csrw 0x8f9, x3

    #Address 0x8f9 read value
    csrr x14, 0x8f9

    #Unmapped address 0xa4f testing: Read Reset + Random data Write/Read
    #Address 0xa4f read value
    csrr x14, 0xa4f

    #Address 0xa4f Write value 0x3dae53fa
    li x3, 0x3dae53fa
    csrw 0xa4f, x3

    #Address 0xa4f read value
    csrr x14, 0xa4f

    #Unmapped address 0xe53 testing: Read Reset + Random data Write/Read
    #Address 0xe53 read value
    csrr x14, 0xe53

    #Address 0xe53 Write value 0xefd6be8d
    li x3, 0xefd6be8d
    csrw 0xe53, x3

    #Address 0xe53 read value
    csrr x14, 0xe53

    #Unmapped address 0x84f testing: Read Reset + Random data Write/Read
    #Address 0x84f read value
    csrr x14, 0x84f

    #Address 0x84f Write value 0xcb3fca1c
    li x3, 0xcb3fca1c
    csrw 0x84f, x3

    #Address 0x84f read value
    csrr x14, 0x84f

    #Unmapped address 0x206 testing: Read Reset + Random data Write/Read
    #Address 0x206 read value
    csrr x14, 0x206

    #Address 0x206 Write value 0x21df05de
    li x3, 0x21df05de
    csrw 0x206, x3

    #Address 0x206 read value
    csrr x14, 0x206

    #Unmapped address 0xa8b testing: Read Reset + Random data Write/Read
    #Address 0xa8b read value
    csrr x14, 0xa8b

    #Address 0xa8b Write value 0x3afbb9b6
    li x3, 0x3afbb9b6
    csrw 0xa8b, x3

    #Address 0xa8b read value
    csrr x14, 0xa8b

    #Unmapped address 0xffd testing: Read Reset + Random data Write/Read
    #Address 0xffd read value
    csrr x14, 0xffd

    #Address 0xffd Write value 0xd003986
    li x3, 0xd003986
    csrw 0xffd, x3

    #Address 0xffd read value
    csrr x14, 0xffd

    #Unmapped address 0x686 testing: Read Reset + Random data Write/Read
    #Address 0x686 read value
    csrr x14, 0x686

    #Address 0x686 Write value 0xacb2c290
    li x3, 0xacb2c290
    csrw 0x686, x3

    #Address 0x686 read value
    csrr x14, 0x686

    #Unmapped address 0x894 testing: Read Reset + Random data Write/Read
    #Address 0x894 read value
    csrr x14, 0x894

    #Address 0x894 Write value 0x1cfd6031
    li x3, 0x1cfd6031
    csrw 0x894, x3

    #Address 0x894 read value
    csrr x14, 0x894

    #Unmapped address 0xa3a testing: Read Reset + Random data Write/Read
    #Address 0xa3a read value
    csrr x14, 0xa3a

    #Address 0xa3a Write value 0x425faea4
    li x3, 0x425faea4
    csrw 0xa3a, x3

    #Address 0xa3a read value
    csrr x14, 0xa3a

    #Unmapped address 0xdda testing: Read Reset + Random data Write/Read
    #Address 0xdda read value
    csrr x14, 0xdda

    #Address 0xdda Write value 0xdc2b841d
    li x3, 0xdc2b841d
    csrw 0xdda, x3

    #Address 0xdda read value
    csrr x14, 0xdda

    #Unmapped address 0xd8b testing: Read Reset + Random data Write/Read
    #Address 0xd8b read value
    csrr x14, 0xd8b

    #Address 0xd8b Write value 0xa6b2d6cf
    li x3, 0xa6b2d6cf
    csrw 0xd8b, x3

    #Address 0xd8b read value
    csrr x14, 0xd8b

    #Unmapped address 0x97c testing: Read Reset + Random data Write/Read
    #Address 0x97c read value
    csrr x14, 0x97c

    #Address 0x97c Write value 0x14a08c68
    li x3, 0x14a08c68
    csrw 0x97c, x3

    #Address 0x97c read value
    csrr x14, 0x97c

    #Unmapped address 0x18c testing: Read Reset + Random data Write/Read
    #Address 0x18c read value
    csrr x14, 0x18c

    #Address 0x18c Write value 0xf10d7781
    li x3, 0xf10d7781
    csrw 0x18c, x3

    #Address 0x18c read value
    csrr x14, 0x18c

    #Unmapped address 0xc48 testing: Read Reset + Random data Write/Read
    #Address 0xc48 read value
    csrr x14, 0xc48

    #Address 0xc48 Write value 0xd8e40f7
    li x3, 0xd8e40f7
    csrw 0xc48, x3

    #Address 0xc48 read value
    csrr x14, 0xc48

    #Unmapped address 0xf5f testing: Read Reset + Random data Write/Read
    #Address 0xf5f read value
    csrr x14, 0xf5f

    #Address 0xf5f Write value 0x1024c384
    li x3, 0x1024c384
    csrw 0xf5f, x3

    #Address 0xf5f read value
    csrr x14, 0xf5f

    #Unmapped address 0x3ef testing: Read Reset + Random data Write/Read
    #Address 0x3ef read value
    csrr x14, 0x3ef

    #Address 0x3ef Write value 0xfb332d3
    li x3, 0xfb332d3
    csrw 0x3ef, x3

    #Address 0x3ef read value
    csrr x14, 0x3ef

    #Unmapped address 0x16e testing: Read Reset + Random data Write/Read
    #Address 0x16e read value
    csrr x14, 0x16e

    #Address 0x16e Write value 0x453b6ae5
    li x3, 0x453b6ae5
    csrw 0x16e, x3

    #Address 0x16e read value
    csrr x14, 0x16e

    #Unmapped address 0xade testing: Read Reset + Random data Write/Read
    #Address 0xade read value
    csrr x14, 0xade

    #Address 0xade Write value 0xfb8c2aa9
    li x3, 0xfb8c2aa9
    csrw 0xade, x3

    #Address 0xade read value
    csrr x14, 0xade

    #Unmapped address 0x50e testing: Read Reset + Random data Write/Read
    #Address 0x50e read value
    csrr x14, 0x50e

    #Address 0x50e Write value 0xfae41271
    li x3, 0xfae41271
    csrw 0x50e, x3

    #Address 0x50e read value
    csrr x14, 0x50e

    #Unmapped address 0x4a3 testing: Read Reset + Random data Write/Read
    #Address 0x4a3 read value
    csrr x14, 0x4a3

    #Address 0x4a3 Write value 0x5af8cdfb
    li x3, 0x5af8cdfb
    csrw 0x4a3, x3

    #Address 0x4a3 read value
    csrr x14, 0x4a3

    #Unmapped address 0x803 testing: Read Reset + Random data Write/Read
    #Address 0x803 read value
    csrr x14, 0x803

    #Address 0x803 Write value 0x78ce0840
    li x3, 0x78ce0840
    csrw 0x803, x3

    #Address 0x803 read value
    csrr x14, 0x803

    #Unmapped address 0x23e testing: Read Reset + Random data Write/Read
    #Address 0x23e read value
    csrr x14, 0x23e

    #Address 0x23e Write value 0x21faa74
    li x3, 0x21faa74
    csrw 0x23e, x3

    #Address 0x23e read value
    csrr x14, 0x23e

    #Unmapped address 0x77d testing: Read Reset + Random data Write/Read
    #Address 0x77d read value
    csrr x14, 0x77d

    #Address 0x77d Write value 0x718adc66
    li x3, 0x718adc66
    csrw 0x77d, x3

    #Address 0x77d read value
    csrr x14, 0x77d

    #Unmapped address 0x674 testing: Read Reset + Random data Write/Read
    #Address 0x674 read value
    csrr x14, 0x674

    #Address 0x674 Write value 0xfe89a07b
    li x3, 0xfe89a07b
    csrw 0x674, x3

    #Address 0x674 read value
    csrr x14, 0x674

    #Unmapped address 0x706 testing: Read Reset + Random data Write/Read
    #Address 0x706 read value
    csrr x14, 0x706

    #Address 0x706 Write value 0x24e6818a
    li x3, 0x24e6818a
    csrw 0x706, x3

    #Address 0x706 read value
    csrr x14, 0x706

    #Unmapped address 0x5c9 testing: Read Reset + Random data Write/Read
    #Address 0x5c9 read value
    csrr x14, 0x5c9

    #Address 0x5c9 Write value 0xce308e18
    li x3, 0xce308e18
    csrw 0x5c9, x3

    #Address 0x5c9 read value
    csrr x14, 0x5c9

    #Unmapped address 0x47c testing: Read Reset + Random data Write/Read
    #Address 0x47c read value
    csrr x14, 0x47c

    #Address 0x47c Write value 0xd6420b53
    li x3, 0xd6420b53
    csrw 0x47c, x3

    #Address 0x47c read value
    csrr x14, 0x47c

    #Unmapped address 0xacc testing: Read Reset + Random data Write/Read
    #Address 0xacc read value
    csrr x14, 0xacc

    #Address 0xacc Write value 0xb2e6e6a7
    li x3, 0xb2e6e6a7
    csrw 0xacc, x3

    #Address 0xacc read value
    csrr x14, 0xacc

    #Unmapped address 0x5a4 testing: Read Reset + Random data Write/Read
    #Address 0x5a4 read value
    csrr x14, 0x5a4

    #Address 0x5a4 Write value 0x1609754
    li x3, 0x1609754
    csrw 0x5a4, x3

    #Address 0x5a4 read value
    csrr x14, 0x5a4

    #Unmapped address 0xf96 testing: Read Reset + Random data Write/Read
    #Address 0xf96 read value
    csrr x14, 0xf96

    #Address 0xf96 Write value 0x3478ba81
    li x3, 0x3478ba81
    csrw 0xf96, x3

    #Address 0xf96 read value
    csrr x14, 0xf96

    #Unmapped address 0xf64 testing: Read Reset + Random data Write/Read
    #Address 0xf64 read value
    csrr x14, 0xf64

    #Address 0xf64 Write value 0xb8637ea2
    li x3, 0xb8637ea2
    csrw 0xf64, x3

    #Address 0xf64 read value
    csrr x14, 0xf64

    #Unmapped address 0x753 testing: Read Reset + Random data Write/Read
    #Address 0x753 read value
    csrr x14, 0x753

    #Address 0x753 Write value 0x2563b202
    li x3, 0x2563b202
    csrw 0x753, x3

    #Address 0x753 read value
    csrr x14, 0x753

    #Unmapped address 0x8b5 testing: Read Reset + Random data Write/Read
    #Address 0x8b5 read value
    csrr x14, 0x8b5

    #Address 0x8b5 Write value 0xfe92521a
    li x3, 0xfe92521a
    csrw 0x8b5, x3

    #Address 0x8b5 read value
    csrr x14, 0x8b5

    #Unmapped address 0xfbc testing: Read Reset + Random data Write/Read
    #Address 0xfbc read value
    csrr x14, 0xfbc

    #Address 0xfbc Write value 0x8f36cc5c
    li x3, 0x8f36cc5c
    csrw 0xfbc, x3

    #Address 0xfbc read value
    csrr x14, 0xfbc

    #Unmapped address 0xf03 testing: Read Reset + Random data Write/Read
    #Address 0xf03 read value
    csrr x14, 0xf03

    #Address 0xf03 Write value 0xd0bc9182
    li x3, 0xd0bc9182
    csrw 0xf03, x3

    #Address 0xf03 read value
    csrr x14, 0xf03

    #Unmapped address 0x42b testing: Read Reset + Random data Write/Read
    #Address 0x42b read value
    csrr x14, 0x42b

    #Address 0x42b Write value 0x23b344c3
    li x3, 0x23b344c3
    csrw 0x42b, x3

    #Address 0x42b read value
    csrr x14, 0x42b

    #Unmapped address 0x12b testing: Read Reset + Random data Write/Read
    #Address 0x12b read value
    csrr x14, 0x12b

    #Address 0x12b Write value 0xc3127bf5
    li x3, 0xc3127bf5
    csrw 0x12b, x3

    #Address 0x12b read value
    csrr x14, 0x12b

    #Unmapped address 0x252 testing: Read Reset + Random data Write/Read
    #Address 0x252 read value
    csrr x14, 0x252

    #Address 0x252 Write value 0x60ad8b4d
    li x3, 0x60ad8b4d
    csrw 0x252, x3

    #Address 0x252 read value
    csrr x14, 0x252

    #Unmapped address 0xaa9 testing: Read Reset + Random data Write/Read
    #Address 0xaa9 read value
    csrr x14, 0xaa9

    #Address 0xaa9 Write value 0x28d6d70
    li x3, 0x28d6d70
    csrw 0xaa9, x3

    #Address 0xaa9 read value
    csrr x14, 0xaa9

    #Unmapped address 0xf21 testing: Read Reset + Random data Write/Read
    #Address 0xf21 read value
    csrr x14, 0xf21

    #Address 0xf21 Write value 0x24726bce
    li x3, 0x24726bce
    csrw 0xf21, x3

    #Address 0xf21 read value
    csrr x14, 0xf21

    #Unmapped address 0xb5 testing: Read Reset + Random data Write/Read
    #Address 0xb5 read value
    csrr x14, 0xb5

    #Address 0xb5 Write value 0xe091e787
    li x3, 0xe091e787
    csrw 0xb5, x3

    #Address 0xb5 read value
    csrr x14, 0xb5

    #Unmapped address 0xfe8 testing: Read Reset + Random data Write/Read
    #Address 0xfe8 read value
    csrr x14, 0xfe8

    #Address 0xfe8 Write value 0x4fd98bae
    li x3, 0x4fd98bae
    csrw 0xfe8, x3

    #Address 0xfe8 read value
    csrr x14, 0xfe8

    #Unmapped address 0x124 testing: Read Reset + Random data Write/Read
    #Address 0x124 read value
    csrr x14, 0x124

    #Address 0x124 Write value 0x6a5003ff
    li x3, 0x6a5003ff
    csrw 0x124, x3

    #Address 0x124 read value
    csrr x14, 0x124

    #Unmapped address 0x61c testing: Read Reset + Random data Write/Read
    #Address 0x61c read value
    csrr x14, 0x61c

    #Address 0x61c Write value 0x1104fdaf
    li x3, 0x1104fdaf
    csrw 0x61c, x3

    #Address 0x61c read value
    csrr x14, 0x61c

    #Unmapped address 0x7f2 testing: Read Reset + Random data Write/Read
    #Address 0x7f2 read value
    csrr x14, 0x7f2

    #Address 0x7f2 Write value 0x8b12942b
    li x3, 0x8b12942b
    csrw 0x7f2, x3

    #Address 0x7f2 read value
    csrr x14, 0x7f2

    #Unmapped address 0xd44 testing: Read Reset + Random data Write/Read
    #Address 0xd44 read value
    csrr x14, 0xd44

    #Address 0xd44 Write value 0xab694890
    li x3, 0xab694890
    csrw 0xd44, x3

    #Address 0xd44 read value
    csrr x14, 0xd44

    #Unmapped address 0xb64 testing: Read Reset + Random data Write/Read
    #Address 0xb64 read value
    csrr x14, 0xb64

    #Address 0xb64 Write value 0x98e15e6c
    li x3, 0x98e15e6c
    csrw 0xb64, x3

    #Address 0xb64 read value
    csrr x14, 0xb64

    #Unmapped address 0x443 testing: Read Reset + Random data Write/Read
    #Address 0x443 read value
    csrr x14, 0x443

    #Address 0x443 Write value 0x23283ea8
    li x3, 0x23283ea8
    csrw 0x443, x3

    #Address 0x443 read value
    csrr x14, 0x443

    #Unmapped address 0xc85 testing: Read Reset + Random data Write/Read
    #Address 0xc85 read value
    csrr x14, 0xc85

    #Address 0xc85 Write value 0xf42b30d2
    li x3, 0xf42b30d2
    csrw 0xc85, x3

    #Address 0xc85 read value
    csrr x14, 0xc85

    #Unmapped address 0x26b testing: Read Reset + Random data Write/Read
    #Address 0x26b read value
    csrr x14, 0x26b

    #Address 0x26b Write value 0x4bce5d28
    li x3, 0x4bce5d28
    csrw 0x26b, x3

    #Address 0x26b read value
    csrr x14, 0x26b

    #Unmapped address 0xa88 testing: Read Reset + Random data Write/Read
    #Address 0xa88 read value
    csrr x14, 0xa88

    #Address 0xa88 Write value 0xfef1ec4e
    li x3, 0xfef1ec4e
    csrw 0xa88, x3

    #Address 0xa88 read value
    csrr x14, 0xa88

    #Unmapped address 0x85c testing: Read Reset + Random data Write/Read
    #Address 0x85c read value
    csrr x14, 0x85c

    #Address 0x85c Write value 0x2a77e5b9
    li x3, 0x2a77e5b9
    csrw 0x85c, x3

    #Address 0x85c read value
    csrr x14, 0x85c

    #Unmapped address 0x418 testing: Read Reset + Random data Write/Read
    #Address 0x418 read value
    csrr x14, 0x418

    #Address 0x418 Write value 0xd8fd2a9a
    li x3, 0xd8fd2a9a
    csrw 0x418, x3

    #Address 0x418 read value
    csrr x14, 0x418

    #Unmapped address 0x402 testing: Read Reset + Random data Write/Read
    #Address 0x402 read value
    csrr x14, 0x402

    #Address 0x402 Write value 0x1252a68b
    li x3, 0x1252a68b
    csrw 0x402, x3

    #Address 0x402 read value
    csrr x14, 0x402

    #Unmapped address 0xcf0 testing: Read Reset + Random data Write/Read
    #Address 0xcf0 read value
    csrr x14, 0xcf0

    #Address 0xcf0 Write value 0x6ce7e42d
    li x3, 0x6ce7e42d
    csrw 0xcf0, x3

    #Address 0xcf0 read value
    csrr x14, 0xcf0

    #Unmapped address 0x35b testing: Read Reset + Random data Write/Read
    #Address 0x35b read value
    csrr x14, 0x35b

    #Address 0x35b Write value 0x92f718ea
    li x3, 0x92f718ea
    csrw 0x35b, x3

    #Address 0x35b read value
    csrr x14, 0x35b

    #Unmapped address 0x5ef testing: Read Reset + Random data Write/Read
    #Address 0x5ef read value
    csrr x14, 0x5ef

    #Address 0x5ef Write value 0x8aa63717
    li x3, 0x8aa63717
    csrw 0x5ef, x3

    #Address 0x5ef read value
    csrr x14, 0x5ef

    #Unmapped address 0x2da testing: Read Reset + Random data Write/Read
    #Address 0x2da read value
    csrr x14, 0x2da

    #Address 0x2da Write value 0x41ce0de6
    li x3, 0x41ce0de6
    csrw 0x2da, x3

    #Address 0x2da read value
    csrr x14, 0x2da

    #Unmapped address 0x5e8 testing: Read Reset + Random data Write/Read
    #Address 0x5e8 read value
    csrr x14, 0x5e8

    #Address 0x5e8 Write value 0x3f8bb7be
    li x3, 0x3f8bb7be
    csrw 0x5e8, x3

    #Address 0x5e8 read value
    csrr x14, 0x5e8

    #Unmapped address 0x3da testing: Read Reset + Random data Write/Read
    #Address 0x3da read value
    csrr x14, 0x3da

    #Address 0x3da Write value 0x2f4c330b
    li x3, 0x2f4c330b
    csrw 0x3da, x3

    #Address 0x3da read value
    csrr x14, 0x3da

    #Unmapped address 0x910 testing: Read Reset + Random data Write/Read
    #Address 0x910 read value
    csrr x14, 0x910

    #Address 0x910 Write value 0xeca04340
    li x3, 0xeca04340
    csrw 0x910, x3

    #Address 0x910 read value
    csrr x14, 0x910

    #Unmapped address 0xf65 testing: Read Reset + Random data Write/Read
    #Address 0xf65 read value
    csrr x14, 0xf65

    #Address 0xf65 Write value 0x73dac266
    li x3, 0x73dac266
    csrw 0xf65, x3

    #Address 0xf65 read value
    csrr x14, 0xf65

    #Unmapped address 0x25f testing: Read Reset + Random data Write/Read
    #Address 0x25f read value
    csrr x14, 0x25f

    #Address 0x25f Write value 0x331589d8
    li x3, 0x331589d8
    csrw 0x25f, x3

    #Address 0x25f read value
    csrr x14, 0x25f

    #Unmapped address 0xff8 testing: Read Reset + Random data Write/Read
    #Address 0xff8 read value
    csrr x14, 0xff8

    #Address 0xff8 Write value 0xd11ee50d
    li x3, 0xd11ee50d
    csrw 0xff8, x3

    #Address 0xff8 read value
    csrr x14, 0xff8

    #Unmapped address 0x46b testing: Read Reset + Random data Write/Read
    #Address 0x46b read value
    csrr x14, 0x46b

    #Address 0x46b Write value 0xbfd394a2
    li x3, 0xbfd394a2
    csrw 0x46b, x3

    #Address 0x46b read value
    csrr x14, 0x46b

    #Unmapped address 0xa39 testing: Read Reset + Random data Write/Read
    #Address 0xa39 read value
    csrr x14, 0xa39

    #Address 0xa39 Write value 0xf5ce645b
    li x3, 0xf5ce645b
    csrw 0xa39, x3

    #Address 0xa39 read value
    csrr x14, 0xa39

    #Unmapped address 0x666 testing: Read Reset + Random data Write/Read
    #Address 0x666 read value
    csrr x14, 0x666

    #Address 0x666 Write value 0x28afdc3d
    li x3, 0x28afdc3d
    csrw 0x666, x3

    #Address 0x666 read value
    csrr x14, 0x666

    #Unmapped address 0x893 testing: Read Reset + Random data Write/Read
    #Address 0x893 read value
    csrr x14, 0x893

    #Address 0x893 Write value 0x5e435b1f
    li x3, 0x5e435b1f
    csrw 0x893, x3

    #Address 0x893 read value
    csrr x14, 0x893

    #Unmapped address 0xe09 testing: Read Reset + Random data Write/Read
    #Address 0xe09 read value
    csrr x14, 0xe09

    #Address 0xe09 Write value 0xfa7d093b
    li x3, 0xfa7d093b
    csrw 0xe09, x3

    #Address 0xe09 read value
    csrr x14, 0xe09

    #Unmapped address 0x77b testing: Read Reset + Random data Write/Read
    #Address 0x77b read value
    csrr x14, 0x77b

    #Address 0x77b Write value 0x293500e6
    li x3, 0x293500e6
    csrw 0x77b, x3

    #Address 0x77b read value
    csrr x14, 0x77b

    #Unmapped address 0x6c3 testing: Read Reset + Random data Write/Read
    #Address 0x6c3 read value
    csrr x14, 0x6c3

    #Address 0x6c3 Write value 0xb2405a21
    li x3, 0xb2405a21
    csrw 0x6c3, x3

    #Address 0x6c3 read value
    csrr x14, 0x6c3

    #Unmapped address 0x6c1 testing: Read Reset + Random data Write/Read
    #Address 0x6c1 read value
    csrr x14, 0x6c1

    #Address 0x6c1 Write value 0xa9761dd5
    li x3, 0xa9761dd5
    csrw 0x6c1, x3

    #Address 0x6c1 read value
    csrr x14, 0x6c1

    #Unmapped address 0xb1 testing: Read Reset + Random data Write/Read
    #Address 0xb1 read value
    csrr x14, 0xb1

    #Address 0xb1 Write value 0xee64047a
    li x3, 0xee64047a
    csrw 0xb1, x3

    #Address 0xb1 read value
    csrr x14, 0xb1

    #Unmapped address 0x9a1 testing: Read Reset + Random data Write/Read
    #Address 0x9a1 read value
    csrr x14, 0x9a1

    #Address 0x9a1 Write value 0xd858abc4
    li x3, 0xd858abc4
    csrw 0x9a1, x3

    #Address 0x9a1 read value
    csrr x14, 0x9a1

    #Unmapped address 0x1b1 testing: Read Reset + Random data Write/Read
    #Address 0x1b1 read value
    csrr x14, 0x1b1

    #Address 0x1b1 Write value 0x4763ee97
    li x3, 0x4763ee97
    csrw 0x1b1, x3

    #Address 0x1b1 read value
    csrr x14, 0x1b1

    #Unmapped address 0x6c6 testing: Read Reset + Random data Write/Read
    #Address 0x6c6 read value
    csrr x14, 0x6c6

    #Address 0x6c6 Write value 0x14f682bd
    li x3, 0x14f682bd
    csrw 0x6c6, x3

    #Address 0x6c6 read value
    csrr x14, 0x6c6

    #Unmapped address 0xc57 testing: Read Reset + Random data Write/Read
    #Address 0xc57 read value
    csrr x14, 0xc57

    #Address 0xc57 Write value 0x9dddd0d7
    li x3, 0x9dddd0d7
    csrw 0xc57, x3

    #Address 0xc57 read value
    csrr x14, 0xc57

    #Unmapped address 0xa1d testing: Read Reset + Random data Write/Read
    #Address 0xa1d read value
    csrr x14, 0xa1d

    #Address 0xa1d Write value 0xb053262c
    li x3, 0xb053262c
    csrw 0xa1d, x3

    #Address 0xa1d read value
    csrr x14, 0xa1d

    #Unmapped address 0xb22 testing: Read Reset + Random data Write/Read
    #Address 0xb22 read value
    csrr x14, 0xb22

    #Address 0xb22 Write value 0xf7f330dd
    li x3, 0xf7f330dd
    csrw 0xb22, x3

    #Address 0xb22 read value
    csrr x14, 0xb22

    #Unmapped address 0xd36 testing: Read Reset + Random data Write/Read
    #Address 0xd36 read value
    csrr x14, 0xd36

    #Address 0xd36 Write value 0x98a0dc83
    li x3, 0x98a0dc83
    csrw 0xd36, x3

    #Address 0xd36 read value
    csrr x14, 0xd36

    #Unmapped address 0x63e testing: Read Reset + Random data Write/Read
    #Address 0x63e read value
    csrr x14, 0x63e

    #Address 0x63e Write value 0x42f4d66c
    li x3, 0x42f4d66c
    csrw 0x63e, x3

    #Address 0x63e read value
    csrr x14, 0x63e

    #Unmapped address 0xaa0 testing: Read Reset + Random data Write/Read
    #Address 0xaa0 read value
    csrr x14, 0xaa0

    #Address 0xaa0 Write value 0x76c33790
    li x3, 0x76c33790
    csrw 0xaa0, x3

    #Address 0xaa0 read value
    csrr x14, 0xaa0

    #Unmapped address 0x9d8 testing: Read Reset + Random data Write/Read
    #Address 0x9d8 read value
    csrr x14, 0x9d8

    #Address 0x9d8 Write value 0x2bd73cb4
    li x3, 0x2bd73cb4
    csrw 0x9d8, x3

    #Address 0x9d8 read value
    csrr x14, 0x9d8

    #Unmapped address 0x8f7 testing: Read Reset + Random data Write/Read
    #Address 0x8f7 read value
    csrr x14, 0x8f7

    #Address 0x8f7 Write value 0x355ef70d
    li x3, 0x355ef70d
    csrw 0x8f7, x3

    #Address 0x8f7 read value
    csrr x14, 0x8f7

    #Unmapped address 0xd77 testing: Read Reset + Random data Write/Read
    #Address 0xd77 read value
    csrr x14, 0xd77

    #Address 0xd77 Write value 0xd8be3d2f
    li x3, 0xd8be3d2f
    csrw 0xd77, x3

    #Address 0xd77 read value
    csrr x14, 0xd77

    #Unmapped address 0x969 testing: Read Reset + Random data Write/Read
    #Address 0x969 read value
    csrr x14, 0x969

    #Address 0x969 Write value 0x6fc94c46
    li x3, 0x6fc94c46
    csrw 0x969, x3

    #Address 0x969 read value
    csrr x14, 0x969

    #Unmapped address 0x380 testing: Read Reset + Random data Write/Read
    #Address 0x380 read value
    csrr x14, 0x380

    #Address 0x380 Write value 0xdbf1a2fd
    li x3, 0xdbf1a2fd
    csrw 0x380, x3

    #Address 0x380 read value
    csrr x14, 0x380

    #Unmapped address 0xf6d testing: Read Reset + Random data Write/Read
    #Address 0xf6d read value
    csrr x14, 0xf6d

    #Address 0xf6d Write value 0x3eac7df6
    li x3, 0x3eac7df6
    csrw 0xf6d, x3

    #Address 0xf6d read value
    csrr x14, 0xf6d

    #Unmapped address 0xe67 testing: Read Reset + Random data Write/Read
    #Address 0xe67 read value
    csrr x14, 0xe67

    #Address 0xe67 Write value 0x3188b30e
    li x3, 0x3188b30e
    csrw 0xe67, x3

    #Address 0xe67 read value
    csrr x14, 0xe67

    #Unmapped address 0x146 testing: Read Reset + Random data Write/Read
    #Address 0x146 read value
    csrr x14, 0x146

    #Address 0x146 Write value 0xa724c66f
    li x3, 0xa724c66f
    csrw 0x146, x3

    #Address 0x146 read value
    csrr x14, 0x146

    #Unmapped address 0xf18 testing: Read Reset + Random data Write/Read
    #Address 0xf18 read value
    csrr x14, 0xf18

    #Address 0xf18 Write value 0xcc247e69
    li x3, 0xcc247e69
    csrw 0xf18, x3

    #Address 0xf18 read value
    csrr x14, 0xf18

    #Unmapped address 0x457 testing: Read Reset + Random data Write/Read
    #Address 0x457 read value
    csrr x14, 0x457

    #Address 0x457 Write value 0xcae7dd22
    li x3, 0xcae7dd22
    csrw 0x457, x3

    #Address 0x457 read value
    csrr x14, 0x457

    #Unmapped address 0x7fa testing: Read Reset + Random data Write/Read
    #Address 0x7fa read value
    csrr x14, 0x7fa

    #Address 0x7fa Write value 0xed5ec0ea
    li x3, 0xed5ec0ea
    csrw 0x7fa, x3

    #Address 0x7fa read value
    csrr x14, 0x7fa

    #Unmapped address 0x4c4 testing: Read Reset + Random data Write/Read
    #Address 0x4c4 read value
    csrr x14, 0x4c4

    #Address 0x4c4 Write value 0xfcc8b07f
    li x3, 0xfcc8b07f
    csrw 0x4c4, x3

    #Address 0x4c4 read value
    csrr x14, 0x4c4

    #Unmapped address 0x377 testing: Read Reset + Random data Write/Read
    #Address 0x377 read value
    csrr x14, 0x377

    #Address 0x377 Write value 0x917d6d76
    li x3, 0x917d6d76
    csrw 0x377, x3

    #Address 0x377 read value
    csrr x14, 0x377

    #Unmapped address 0x423 testing: Read Reset + Random data Write/Read
    #Address 0x423 read value
    csrr x14, 0x423

    #Address 0x423 Write value 0x624a2991
    li x3, 0x624a2991
    csrw 0x423, x3

    #Address 0x423 read value
    csrr x14, 0x423

    #Unmapped address 0xfba testing: Read Reset + Random data Write/Read
    #Address 0xfba read value
    csrr x14, 0xfba

    #Address 0xfba Write value 0x5b9c2871
    li x3, 0x5b9c2871
    csrw 0xfba, x3

    #Address 0xfba read value
    csrr x14, 0xfba

    #Unmapped address 0x156 testing: Read Reset + Random data Write/Read
    #Address 0x156 read value
    csrr x14, 0x156

    #Address 0x156 Write value 0xf6529d63
    li x3, 0xf6529d63
    csrw 0x156, x3

    #Address 0x156 read value
    csrr x14, 0x156

    #Unmapped address 0x67b testing: Read Reset + Random data Write/Read
    #Address 0x67b read value
    csrr x14, 0x67b

    #Address 0x67b Write value 0xf27efc11
    li x3, 0xf27efc11
    csrw 0x67b, x3

    #Address 0x67b read value
    csrr x14, 0x67b

    #Unmapped address 0x3fe testing: Read Reset + Random data Write/Read
    #Address 0x3fe read value
    csrr x14, 0x3fe

    #Address 0x3fe Write value 0x79697878
    li x3, 0x79697878
    csrw 0x3fe, x3

    #Address 0x3fe read value
    csrr x14, 0x3fe

    #Unmapped address 0x493 testing: Read Reset + Random data Write/Read
    #Address 0x493 read value
    csrr x14, 0x493

    #Address 0x493 Write value 0xa128bf64
    li x3, 0xa128bf64
    csrw 0x493, x3

    #Address 0x493 read value
    csrr x14, 0x493

    #Unmapped address 0x37 testing: Read Reset + Random data Write/Read
    #Address 0x37 read value
    csrr x14, 0x37

    #Address 0x37 Write value 0xa052912a
    li x3, 0xa052912a
    csrw 0x37, x3

    #Address 0x37 read value
    csrr x14, 0x37

    #Unmapped address 0xee9 testing: Read Reset + Random data Write/Read
    #Address 0xee9 read value
    csrr x14, 0xee9

    #Address 0xee9 Write value 0xca76a482
    li x3, 0xca76a482
    csrw 0xee9, x3

    #Address 0xee9 read value
    csrr x14, 0xee9

    #Unmapped address 0x512 testing: Read Reset + Random data Write/Read
    #Address 0x512 read value
    csrr x14, 0x512

    #Address 0x512 Write value 0xa6bac0ee
    li x3, 0xa6bac0ee
    csrw 0x512, x3

    #Address 0x512 read value
    csrr x14, 0x512

    #Unmapped address 0x934 testing: Read Reset + Random data Write/Read
    #Address 0x934 read value
    csrr x14, 0x934

    #Address 0x934 Write value 0x7b850ae0
    li x3, 0x7b850ae0
    csrw 0x934, x3

    #Address 0x934 read value
    csrr x14, 0x934

    #Unmapped address 0x91c testing: Read Reset + Random data Write/Read
    #Address 0x91c read value
    csrr x14, 0x91c

    #Address 0x91c Write value 0xe08b2de3
    li x3, 0xe08b2de3
    csrw 0x91c, x3

    #Address 0x91c read value
    csrr x14, 0x91c

    #Unmapped address 0xe79 testing: Read Reset + Random data Write/Read
    #Address 0xe79 read value
    csrr x14, 0xe79

    #Address 0xe79 Write value 0xd23d29aa
    li x3, 0xd23d29aa
    csrw 0xe79, x3

    #Address 0xe79 read value
    csrr x14, 0xe79

    #Unmapped address 0x378 testing: Read Reset + Random data Write/Read
    #Address 0x378 read value
    csrr x14, 0x378

    #Address 0x378 Write value 0xcd256723
    li x3, 0xcd256723
    csrw 0x378, x3

    #Address 0x378 read value
    csrr x14, 0x378

    #Unmapped address 0x3e8 testing: Read Reset + Random data Write/Read
    #Address 0x3e8 read value
    csrr x14, 0x3e8

    #Address 0x3e8 Write value 0x62fd7bdc
    li x3, 0x62fd7bdc
    csrw 0x3e8, x3

    #Address 0x3e8 read value
    csrr x14, 0x3e8

    #Unmapped address 0x150 testing: Read Reset + Random data Write/Read
    #Address 0x150 read value
    csrr x14, 0x150

    #Address 0x150 Write value 0xe13f0f6f
    li x3, 0xe13f0f6f
    csrw 0x150, x3

    #Address 0x150 read value
    csrr x14, 0x150

    #Unmapped address 0x4d3 testing: Read Reset + Random data Write/Read
    #Address 0x4d3 read value
    csrr x14, 0x4d3

    #Address 0x4d3 Write value 0xa34b8b2b
    li x3, 0xa34b8b2b
    csrw 0x4d3, x3

    #Address 0x4d3 read value
    csrr x14, 0x4d3

    #Unmapped address 0x17c testing: Read Reset + Random data Write/Read
    #Address 0x17c read value
    csrr x14, 0x17c

    #Address 0x17c Write value 0xf3f9339b
    li x3, 0xf3f9339b
    csrw 0x17c, x3

    #Address 0x17c read value
    csrr x14, 0x17c

    #Unmapped address 0xf62 testing: Read Reset + Random data Write/Read
    #Address 0xf62 read value
    csrr x14, 0xf62

    #Address 0xf62 Write value 0xe09f142c
    li x3, 0xe09f142c
    csrw 0xf62, x3

    #Address 0xf62 read value
    csrr x14, 0xf62

    #Unmapped address 0x5de testing: Read Reset + Random data Write/Read
    #Address 0x5de read value
    csrr x14, 0x5de

    #Address 0x5de Write value 0xd5d7ef20
    li x3, 0xd5d7ef20
    csrw 0x5de, x3

    #Address 0x5de read value
    csrr x14, 0x5de

    #Unmapped address 0x2a6 testing: Read Reset + Random data Write/Read
    #Address 0x2a6 read value
    csrr x14, 0x2a6

    #Address 0x2a6 Write value 0xcd1dfe71
    li x3, 0xcd1dfe71
    csrw 0x2a6, x3

    #Address 0x2a6 read value
    csrr x14, 0x2a6

    #Unmapped address 0xadd testing: Read Reset + Random data Write/Read
    #Address 0xadd read value
    csrr x14, 0xadd

    #Address 0xadd Write value 0xa11d1e45
    li x3, 0xa11d1e45
    csrw 0xadd, x3

    #Address 0xadd read value
    csrr x14, 0xadd

    #Unmapped address 0x1dd testing: Read Reset + Random data Write/Read
    #Address 0x1dd read value
    csrr x14, 0x1dd

    #Address 0x1dd Write value 0xeb4cb5ff
    li x3, 0xeb4cb5ff
    csrw 0x1dd, x3

    #Address 0x1dd read value
    csrr x14, 0x1dd

    #Unmapped address 0x775 testing: Read Reset + Random data Write/Read
    #Address 0x775 read value
    csrr x14, 0x775

    #Address 0x775 Write value 0x6b7ede03
    li x3, 0x6b7ede03
    csrw 0x775, x3

    #Address 0x775 read value
    csrr x14, 0x775

    #Unmapped address 0x5ba testing: Read Reset + Random data Write/Read
    #Address 0x5ba read value
    csrr x14, 0x5ba

    #Address 0x5ba Write value 0xbdf9a52e
    li x3, 0xbdf9a52e
    csrw 0x5ba, x3

    #Address 0x5ba read value
    csrr x14, 0x5ba

    #Unmapped address 0x569 testing: Read Reset + Random data Write/Read
    #Address 0x569 read value
    csrr x14, 0x569

    #Address 0x569 Write value 0x6f73a4ad
    li x3, 0x6f73a4ad
    csrw 0x569, x3

    #Address 0x569 read value
    csrr x14, 0x569

    #Unmapped address 0x6ce testing: Read Reset + Random data Write/Read
    #Address 0x6ce read value
    csrr x14, 0x6ce

    #Address 0x6ce Write value 0xfd54d497
    li x3, 0xfd54d497
    csrw 0x6ce, x3

    #Address 0x6ce read value
    csrr x14, 0x6ce

    #Unmapped address 0x7f0 testing: Read Reset + Random data Write/Read
    #Address 0x7f0 read value
    csrr x14, 0x7f0

    #Address 0x7f0 Write value 0x622e8eda
    li x3, 0x622e8eda
    csrw 0x7f0, x3

    #Address 0x7f0 read value
    csrr x14, 0x7f0

    #Unmapped address 0xcd7 testing: Read Reset + Random data Write/Read
    #Address 0xcd7 read value
    csrr x14, 0xcd7

    #Address 0xcd7 Write value 0x4847d154
    li x3, 0x4847d154
    csrw 0xcd7, x3

    #Address 0xcd7 read value
    csrr x14, 0xcd7

    #Unmapped address 0x762 testing: Read Reset + Random data Write/Read
    #Address 0x762 read value
    csrr x14, 0x762

    #Address 0x762 Write value 0xd90e8499
    li x3, 0xd90e8499
    csrw 0x762, x3

    #Address 0x762 read value
    csrr x14, 0x762

    #Unmapped address 0xe25 testing: Read Reset + Random data Write/Read
    #Address 0xe25 read value
    csrr x14, 0xe25

    #Address 0xe25 Write value 0xb60ed8b2
    li x3, 0xb60ed8b2
    csrw 0xe25, x3

    #Address 0xe25 read value
    csrr x14, 0xe25

    #Unmapped address 0x8ea testing: Read Reset + Random data Write/Read
    #Address 0x8ea read value
    csrr x14, 0x8ea

    #Address 0x8ea Write value 0xdee31880
    li x3, 0xdee31880
    csrw 0x8ea, x3

    #Address 0x8ea read value
    csrr x14, 0x8ea

    #Unmapped address 0xcf9 testing: Read Reset + Random data Write/Read
    #Address 0xcf9 read value
    csrr x14, 0xcf9

    #Address 0xcf9 Write value 0xf061573
    li x3, 0xf061573
    csrw 0xcf9, x3

    #Address 0xcf9 read value
    csrr x14, 0xcf9

    #Unmapped address 0x912 testing: Read Reset + Random data Write/Read
    #Address 0x912 read value
    csrr x14, 0x912

    #Address 0x912 Write value 0x76bfa64d
    li x3, 0x76bfa64d
    csrw 0x912, x3

    #Address 0x912 read value
    csrr x14, 0x912

    #Unmapped address 0x244 testing: Read Reset + Random data Write/Read
    #Address 0x244 read value
    csrr x14, 0x244

    #Address 0x244 Write value 0x9c6dd2d5
    li x3, 0x9c6dd2d5
    csrw 0x244, x3

    #Address 0x244 read value
    csrr x14, 0x244

    #Unmapped address 0xcb testing: Read Reset + Random data Write/Read
    #Address 0xcb read value
    csrr x14, 0xcb

    #Address 0xcb Write value 0x6de60919
    li x3, 0x6de60919
    csrw 0xcb, x3

    #Address 0xcb read value
    csrr x14, 0xcb

    #Unmapped address 0x4a testing: Read Reset + Random data Write/Read
    #Address 0x4a read value
    csrr x14, 0x4a

    #Address 0x4a Write value 0x4dce07b2
    li x3, 0x4dce07b2
    csrw 0x4a, x3

    #Address 0x4a read value
    csrr x14, 0x4a

    #Unmapped address 0x407 testing: Read Reset + Random data Write/Read
    #Address 0x407 read value
    csrr x14, 0x407

    #Address 0x407 Write value 0x944787c7
    li x3, 0x944787c7
    csrw 0x407, x3

    #Address 0x407 read value
    csrr x14, 0x407

    #Unmapped address 0xafc testing: Read Reset + Random data Write/Read
    #Address 0xafc read value
    csrr x14, 0xafc

    #Address 0xafc Write value 0x9583767f
    li x3, 0x9583767f
    csrw 0xafc, x3

    #Address 0xafc read value
    csrr x14, 0xafc

    #Unmapped address 0x7d9 testing: Read Reset + Random data Write/Read
    #Address 0x7d9 read value
    csrr x14, 0x7d9

    #Address 0x7d9 Write value 0x124c0533
    li x3, 0x124c0533
    csrw 0x7d9, x3

    #Address 0x7d9 read value
    csrr x14, 0x7d9

    #Unmapped address 0xe91 testing: Read Reset + Random data Write/Read
    #Address 0xe91 read value
    csrr x14, 0xe91

    #Address 0xe91 Write value 0x7469d0db
    li x3, 0x7469d0db
    csrw 0xe91, x3

    #Address 0xe91 read value
    csrr x14, 0xe91

    #Unmapped address 0x578 testing: Read Reset + Random data Write/Read
    #Address 0x578 read value
    csrr x14, 0x578

    #Address 0x578 Write value 0xdfb93a98
    li x3, 0xdfb93a98
    csrw 0x578, x3

    #Address 0x578 read value
    csrr x14, 0x578

    #Unmapped address 0xcf testing: Read Reset + Random data Write/Read
    #Address 0xcf read value
    csrr x14, 0xcf

    #Address 0xcf Write value 0x12808676
    li x3, 0x12808676
    csrw 0xcf, x3

    #Address 0xcf read value
    csrr x14, 0xcf

    #Unmapped address 0xf4a testing: Read Reset + Random data Write/Read
    #Address 0xf4a read value
    csrr x14, 0xf4a

    #Address 0xf4a Write value 0x68c84f8a
    li x3, 0x68c84f8a
    csrw 0xf4a, x3

    #Address 0xf4a read value
    csrr x14, 0xf4a

    #Unmapped address 0x5b5 testing: Read Reset + Random data Write/Read
    #Address 0x5b5 read value
    csrr x14, 0x5b5

    #Address 0x5b5 Write value 0xd43682b7
    li x3, 0xd43682b7
    csrw 0x5b5, x3

    #Address 0x5b5 read value
    csrr x14, 0x5b5

    #Unmapped address 0xc60 testing: Read Reset + Random data Write/Read
    #Address 0xc60 read value
    csrr x14, 0xc60

    #Address 0xc60 Write value 0x95580dff
    li x3, 0x95580dff
    csrw 0xc60, x3

    #Address 0xc60 read value
    csrr x14, 0xc60

    #Unmapped address 0x6bb testing: Read Reset + Random data Write/Read
    #Address 0x6bb read value
    csrr x14, 0x6bb

    #Address 0x6bb Write value 0xa0079294
    li x3, 0xa0079294
    csrw 0x6bb, x3

    #Address 0x6bb read value
    csrr x14, 0x6bb

    #Unmapped address 0xa3f testing: Read Reset + Random data Write/Read
    #Address 0xa3f read value
    csrr x14, 0xa3f

    #Address 0xa3f Write value 0x3206f70e
    li x3, 0x3206f70e
    csrw 0xa3f, x3

    #Address 0xa3f read value
    csrr x14, 0xa3f

    #Unmapped address 0x276 testing: Read Reset + Random data Write/Read
    #Address 0x276 read value
    csrr x14, 0x276

    #Address 0x276 Write value 0xf925c419
    li x3, 0xf925c419
    csrw 0x276, x3

    #Address 0x276 read value
    csrr x14, 0x276

    #Unmapped address 0xe testing: Read Reset + Random data Write/Read
    #Address 0xe read value
    csrr x14, 0xe

    #Address 0xe Write value 0xc17331b8
    li x3, 0xc17331b8
    csrw 0xe, x3

    #Address 0xe read value
    csrr x14, 0xe

    #Unmapped address 0xd80 testing: Read Reset + Random data Write/Read
    #Address 0xd80 read value
    csrr x14, 0xd80

    #Address 0xd80 Write value 0x97565853
    li x3, 0x97565853
    csrw 0xd80, x3

    #Address 0xd80 read value
    csrr x14, 0xd80

    #Unmapped address 0x4a7 testing: Read Reset + Random data Write/Read
    #Address 0x4a7 read value
    csrr x14, 0x4a7

    #Address 0x4a7 Write value 0xf92186d3
    li x3, 0xf92186d3
    csrw 0x4a7, x3

    #Address 0x4a7 read value
    csrr x14, 0x4a7

    #Unmapped address 0xf0c testing: Read Reset + Random data Write/Read
    #Address 0xf0c read value
    csrr x14, 0xf0c

    #Address 0xf0c Write value 0xc5258802
    li x3, 0xc5258802
    csrw 0xf0c, x3

    #Address 0xf0c read value
    csrr x14, 0xf0c

    #Unmapped address 0x273 testing: Read Reset + Random data Write/Read
    #Address 0x273 read value
    csrr x14, 0x273

    #Address 0x273 Write value 0x617ef20d
    li x3, 0x617ef20d
    csrw 0x273, x3

    #Address 0x273 read value
    csrr x14, 0x273

    #Unmapped address 0x96b testing: Read Reset + Random data Write/Read
    #Address 0x96b read value
    csrr x14, 0x96b

    #Address 0x96b Write value 0xb6fd4c94
    li x3, 0xb6fd4c94
    csrw 0x96b, x3

    #Address 0x96b read value
    csrr x14, 0x96b

    #Unmapped address 0xa46 testing: Read Reset + Random data Write/Read
    #Address 0xa46 read value
    csrr x14, 0xa46

    #Address 0xa46 Write value 0xffaed289
    li x3, 0xffaed289
    csrw 0xa46, x3

    #Address 0xa46 read value
    csrr x14, 0xa46

    #Unmapped address 0xd6b testing: Read Reset + Random data Write/Read
    #Address 0xd6b read value
    csrr x14, 0xd6b

    #Address 0xd6b Write value 0xb6d1ef3c
    li x3, 0xb6d1ef3c
    csrw 0xd6b, x3

    #Address 0xd6b read value
    csrr x14, 0xd6b

    #Unmapped address 0xc4a testing: Read Reset + Random data Write/Read
    #Address 0xc4a read value
    csrr x14, 0xc4a

    #Address 0xc4a Write value 0x73346c05
    li x3, 0x73346c05
    csrw 0xc4a, x3

    #Address 0xc4a read value
    csrr x14, 0xc4a

    #Unmapped address 0x15e testing: Read Reset + Random data Write/Read
    #Address 0x15e read value
    csrr x14, 0x15e

    #Address 0x15e Write value 0xfa72ee66
    li x3, 0xfa72ee66
    csrw 0x15e, x3

    #Address 0x15e read value
    csrr x14, 0x15e

    #Unmapped address 0xcbb testing: Read Reset + Random data Write/Read
    #Address 0xcbb read value
    csrr x14, 0xcbb

    #Address 0xcbb Write value 0xd1a18d8b
    li x3, 0xd1a18d8b
    csrw 0xcbb, x3

    #Address 0xcbb read value
    csrr x14, 0xcbb

    #Unmapped address 0xeb testing: Read Reset + Random data Write/Read
    #Address 0xeb read value
    csrr x14, 0xeb

    #Address 0xeb Write value 0x4e946857
    li x3, 0x4e946857
    csrw 0xeb, x3

    #Address 0xeb read value
    csrr x14, 0xeb

    #Unmapped address 0xa43 testing: Read Reset + Random data Write/Read
    #Address 0xa43 read value
    csrr x14, 0xa43

    #Address 0xa43 Write value 0xe0def518
    li x3, 0xe0def518
    csrw 0xa43, x3

    #Address 0xa43 read value
    csrr x14, 0xa43

    #Unmapped address 0xf6a testing: Read Reset + Random data Write/Read
    #Address 0xf6a read value
    csrr x14, 0xf6a

    #Address 0xf6a Write value 0x63934a98
    li x3, 0x63934a98
    csrw 0xf6a, x3

    #Address 0xf6a read value
    csrr x14, 0xf6a

    #Unmapped address 0x5bd testing: Read Reset + Random data Write/Read
    #Address 0x5bd read value
    csrr x14, 0x5bd

    #Address 0x5bd Write value 0x71f18401
    li x3, 0x71f18401
    csrw 0x5bd, x3

    #Address 0x5bd read value
    csrr x14, 0x5bd

    #Unmapped address 0x0 testing: Read Reset + Random data Write/Read
    #Address 0x0 read value
    csrr x14, 0x0

    #Address 0x0 Write value 0xe6f82e82
    li x3, 0xe6f82e82
    csrw 0x0, x3

    #Address 0x0 read value
    csrr x14, 0x0

    #Unmapped address 0x2d6 testing: Read Reset + Random data Write/Read
    #Address 0x2d6 read value
    csrr x14, 0x2d6

    #Address 0x2d6 Write value 0xdcd5bfbd
    li x3, 0xdcd5bfbd
    csrw 0x2d6, x3

    #Address 0x2d6 read value
    csrr x14, 0x2d6

    #Unmapped address 0xaf4 testing: Read Reset + Random data Write/Read
    #Address 0xaf4 read value
    csrr x14, 0xaf4

    #Address 0xaf4 Write value 0x681c320
    li x3, 0x681c320
    csrw 0xaf4, x3

    #Address 0xaf4 read value
    csrr x14, 0xaf4

    #Unmapped address 0xe82 testing: Read Reset + Random data Write/Read
    #Address 0xe82 read value
    csrr x14, 0xe82

    #Address 0xe82 Write value 0xd8ba0c7c
    li x3, 0xd8ba0c7c
    csrw 0xe82, x3

    #Address 0xe82 read value
    csrr x14, 0xe82

    #Unmapped address 0x136 testing: Read Reset + Random data Write/Read
    #Address 0x136 read value
    csrr x14, 0x136

    #Address 0x136 Write value 0x6965947
    li x3, 0x6965947
    csrw 0x136, x3

    #Address 0x136 read value
    csrr x14, 0x136

    #Unmapped address 0x813 testing: Read Reset + Random data Write/Read
    #Address 0x813 read value
    csrr x14, 0x813

    #Address 0x813 Write value 0x983e6db5
    li x3, 0x983e6db5
    csrw 0x813, x3

    #Address 0x813 read value
    csrr x14, 0x813

    #Unmapped address 0xbfe testing: Read Reset + Random data Write/Read
    #Address 0xbfe read value
    csrr x14, 0xbfe

    #Address 0xbfe Write value 0x2ab15626
    li x3, 0x2ab15626
    csrw 0xbfe, x3

    #Address 0xbfe read value
    csrr x14, 0xbfe

    #Unmapped address 0x41c testing: Read Reset + Random data Write/Read
    #Address 0x41c read value
    csrr x14, 0x41c

    #Address 0x41c Write value 0x9916f235
    li x3, 0x9916f235
    csrw 0x41c, x3

    #Address 0x41c read value
    csrr x14, 0x41c

    #Unmapped address 0x5f0 testing: Read Reset + Random data Write/Read
    #Address 0x5f0 read value
    csrr x14, 0x5f0

    #Address 0x5f0 Write value 0x8dc92efb
    li x3, 0x8dc92efb
    csrw 0x5f0, x3

    #Address 0x5f0 read value
    csrr x14, 0x5f0

    #Unmapped address 0xd94 testing: Read Reset + Random data Write/Read
    #Address 0xd94 read value
    csrr x14, 0xd94

    #Address 0xd94 Write value 0xa1692b9e
    li x3, 0xa1692b9e
    csrw 0xd94, x3

    #Address 0xd94 read value
    csrr x14, 0xd94

    #Unmapped address 0x672 testing: Read Reset + Random data Write/Read
    #Address 0x672 read value
    csrr x14, 0x672

    #Address 0x672 Write value 0x852eca1a
    li x3, 0x852eca1a
    csrw 0x672, x3

    #Address 0x672 read value
    csrr x14, 0x672

    #Unmapped address 0xb3b testing: Read Reset + Random data Write/Read
    #Address 0xb3b read value
    csrr x14, 0xb3b

    #Address 0xb3b Write value 0x9fb91b67
    li x3, 0x9fb91b67
    csrw 0xb3b, x3

    #Address 0xb3b read value
    csrr x14, 0xb3b

    #Unmapped address 0x4dc testing: Read Reset + Random data Write/Read
    #Address 0x4dc read value
    csrr x14, 0x4dc

    #Address 0x4dc Write value 0xa29644da
    li x3, 0xa29644da
    csrw 0x4dc, x3

    #Address 0x4dc read value
    csrr x14, 0x4dc

    #Unmapped address 0x280 testing: Read Reset + Random data Write/Read
    #Address 0x280 read value
    csrr x14, 0x280

    #Address 0x280 Write value 0x18ccce76
    li x3, 0x18ccce76
    csrw 0x280, x3

    #Address 0x280 read value
    csrr x14, 0x280

    #Unmapped address 0x7fc testing: Read Reset + Random data Write/Read
    #Address 0x7fc read value
    csrr x14, 0x7fc

    #Address 0x7fc Write value 0xf8763670
    li x3, 0xf8763670
    csrw 0x7fc, x3

    #Address 0x7fc read value
    csrr x14, 0x7fc

    #Unmapped address 0x955 testing: Read Reset + Random data Write/Read
    #Address 0x955 read value
    csrr x14, 0x955

    #Address 0x955 Write value 0x8f31cafd
    li x3, 0x8f31cafd
    csrw 0x955, x3

    #Address 0x955 read value
    csrr x14, 0x955

    #Unmapped address 0xb2d testing: Read Reset + Random data Write/Read
    #Address 0xb2d read value
    csrr x14, 0xb2d

    #Address 0xb2d Write value 0xf6b24fbe
    li x3, 0xf6b24fbe
    csrw 0xb2d, x3

    #Address 0xb2d read value
    csrr x14, 0xb2d

    #Unmapped address 0x8dd testing: Read Reset + Random data Write/Read
    #Address 0x8dd read value
    csrr x14, 0x8dd

    #Address 0x8dd Write value 0x53c86f3b
    li x3, 0x53c86f3b
    csrw 0x8dd, x3

    #Address 0x8dd read value
    csrr x14, 0x8dd

    #Unmapped address 0x740 testing: Read Reset + Random data Write/Read
    #Address 0x740 read value
    csrr x14, 0x740

    #Address 0x740 Write value 0xca672bf4
    li x3, 0xca672bf4
    csrw 0x740, x3

    #Address 0x740 read value
    csrr x14, 0x740

    #Unmapped address 0x3e5 testing: Read Reset + Random data Write/Read
    #Address 0x3e5 read value
    csrr x14, 0x3e5

    #Address 0x3e5 Write value 0xd46e6913
    li x3, 0xd46e6913
    csrw 0x3e5, x3

    #Address 0x3e5 read value
    csrr x14, 0x3e5

    #Unmapped address 0xdb1 testing: Read Reset + Random data Write/Read
    #Address 0xdb1 read value
    csrr x14, 0xdb1

    #Address 0xdb1 Write value 0x38e16181
    li x3, 0x38e16181
    csrw 0xdb1, x3

    #Address 0xdb1 read value
    csrr x14, 0xdb1

    #Unmapped address 0xbd9 testing: Read Reset + Random data Write/Read
    #Address 0xbd9 read value
    csrr x14, 0xbd9

    #Address 0xbd9 Write value 0x27b8187e
    li x3, 0x27b8187e
    csrw 0xbd9, x3

    #Address 0xbd9 read value
    csrr x14, 0xbd9

    #Unmapped address 0xd98 testing: Read Reset + Random data Write/Read
    #Address 0xd98 read value
    csrr x14, 0xd98

    #Address 0xd98 Write value 0x87cb9469
    li x3, 0x87cb9469
    csrw 0xd98, x3

    #Address 0xd98 read value
    csrr x14, 0xd98

    #Unmapped address 0xcf3 testing: Read Reset + Random data Write/Read
    #Address 0xcf3 read value
    csrr x14, 0xcf3

    #Address 0xcf3 Write value 0x3edea067
    li x3, 0x3edea067
    csrw 0xcf3, x3

    #Address 0xcf3 read value
    csrr x14, 0xcf3

    #Unmapped address 0xfa0 testing: Read Reset + Random data Write/Read
    #Address 0xfa0 read value
    csrr x14, 0xfa0

    #Address 0xfa0 Write value 0x187ad0e5
    li x3, 0x187ad0e5
    csrw 0xfa0, x3

    #Address 0xfa0 read value
    csrr x14, 0xfa0

    #Unmapped address 0x82a testing: Read Reset + Random data Write/Read
    #Address 0x82a read value
    csrr x14, 0x82a

    #Address 0x82a Write value 0xe2be4f28
    li x3, 0xe2be4f28
    csrw 0x82a, x3

    #Address 0x82a read value
    csrr x14, 0x82a

    #Unmapped address 0xa40 testing: Read Reset + Random data Write/Read
    #Address 0xa40 read value
    csrr x14, 0xa40

    #Address 0xa40 Write value 0x1e5697d4
    li x3, 0x1e5697d4
    csrw 0xa40, x3

    #Address 0xa40 read value
    csrr x14, 0xa40

    #Unmapped address 0x690 testing: Read Reset + Random data Write/Read
    #Address 0x690 read value
    csrr x14, 0x690

    #Address 0x690 Write value 0x289d26f3
    li x3, 0x289d26f3
    csrw 0x690, x3

    #Address 0x690 read value
    csrr x14, 0x690

    #Unmapped address 0x197 testing: Read Reset + Random data Write/Read
    #Address 0x197 read value
    csrr x14, 0x197

    #Address 0x197 Write value 0xefdf4f37
    li x3, 0xefdf4f37
    csrw 0x197, x3

    #Address 0x197 read value
    csrr x14, 0x197

    #Unmapped address 0x165 testing: Read Reset + Random data Write/Read
    #Address 0x165 read value
    csrr x14, 0x165

    #Address 0x165 Write value 0x84b354e0
    li x3, 0x84b354e0
    csrw 0x165, x3

    #Address 0x165 read value
    csrr x14, 0x165

    #Unmapped address 0x3cd testing: Read Reset + Random data Write/Read
    #Address 0x3cd read value
    csrr x14, 0x3cd

    #Address 0x3cd Write value 0xb1526622
    li x3, 0xb1526622
    csrw 0x3cd, x3

    #Address 0x3cd read value
    csrr x14, 0x3cd

    #Unmapped address 0x661 testing: Read Reset + Random data Write/Read
    #Address 0x661 read value
    csrr x14, 0x661

    #Address 0x661 Write value 0x39d4d62a
    li x3, 0x39d4d62a
    csrw 0x661, x3

    #Address 0x661 read value
    csrr x14, 0x661

    #Unmapped address 0x49e testing: Read Reset + Random data Write/Read
    #Address 0x49e read value
    csrr x14, 0x49e

    #Address 0x49e Write value 0x8dd8b2b8
    li x3, 0x8dd8b2b8
    csrw 0x49e, x3

    #Address 0x49e read value
    csrr x14, 0x49e

    #Unmapped address 0xc39 testing: Read Reset + Random data Write/Read
    #Address 0xc39 read value
    csrr x14, 0xc39

    #Address 0xc39 Write value 0xfcb6b125
    li x3, 0xfcb6b125
    csrw 0xc39, x3

    #Address 0xc39 read value
    csrr x14, 0xc39

    #Unmapped address 0xd0a testing: Read Reset + Random data Write/Read
    #Address 0xd0a read value
    csrr x14, 0xd0a

    #Address 0xd0a Write value 0x4cd2cd7d
    li x3, 0x4cd2cd7d
    csrw 0xd0a, x3

    #Address 0xd0a read value
    csrr x14, 0xd0a

    #Unmapped address 0x6e0 testing: Read Reset + Random data Write/Read
    #Address 0x6e0 read value
    csrr x14, 0x6e0

    #Address 0x6e0 Write value 0x26ab7412
    li x3, 0x26ab7412
    csrw 0x6e0, x3

    #Address 0x6e0 read value
    csrr x14, 0x6e0

    #Unmapped address 0x91f testing: Read Reset + Random data Write/Read
    #Address 0x91f read value
    csrr x14, 0x91f

    #Address 0x91f Write value 0xb3134c43
    li x3, 0xb3134c43
    csrw 0x91f, x3

    #Address 0x91f read value
    csrr x14, 0x91f

    #Unmapped address 0xf8e testing: Read Reset + Random data Write/Read
    #Address 0xf8e read value
    csrr x14, 0xf8e

    #Address 0xf8e Write value 0x735be87
    li x3, 0x735be87
    csrw 0xf8e, x3

    #Address 0xf8e read value
    csrr x14, 0xf8e

    #Unmapped address 0xe7d testing: Read Reset + Random data Write/Read
    #Address 0xe7d read value
    csrr x14, 0xe7d

    #Address 0xe7d Write value 0xb3a8037c
    li x3, 0xb3a8037c
    csrw 0xe7d, x3

    #Address 0xe7d read value
    csrr x14, 0xe7d

    #Unmapped address 0x433 testing: Read Reset + Random data Write/Read
    #Address 0x433 read value
    csrr x14, 0x433

    #Address 0x433 Write value 0x1e1d112d
    li x3, 0x1e1d112d
    csrw 0x433, x3

    #Address 0x433 read value
    csrr x14, 0x433

    #Unmapped address 0x6a4 testing: Read Reset + Random data Write/Read
    #Address 0x6a4 read value
    csrr x14, 0x6a4

    #Address 0x6a4 Write value 0x55a6cd29
    li x3, 0x55a6cd29
    csrw 0x6a4, x3

    #Address 0x6a4 read value
    csrr x14, 0x6a4

    #Unmapped address 0xd6c testing: Read Reset + Random data Write/Read
    #Address 0xd6c read value
    csrr x14, 0xd6c

    #Address 0xd6c Write value 0xf799bf64
    li x3, 0xf799bf64
    csrw 0xd6c, x3

    #Address 0xd6c read value
    csrr x14, 0xd6c

    #Unmapped address 0xdbd testing: Read Reset + Random data Write/Read
    #Address 0xdbd read value
    csrr x14, 0xdbd

    #Address 0xdbd Write value 0x9bce8c7f
    li x3, 0x9bce8c7f
    csrw 0xdbd, x3

    #Address 0xdbd read value
    csrr x14, 0xdbd

    #Unmapped address 0xc33 testing: Read Reset + Random data Write/Read
    #Address 0xc33 read value
    csrr x14, 0xc33

    #Address 0xc33 Write value 0xfc49c3c6
    li x3, 0xfc49c3c6
    csrw 0xc33, x3

    #Address 0xc33 read value
    csrr x14, 0xc33

    #Unmapped address 0x473 testing: Read Reset + Random data Write/Read
    #Address 0x473 read value
    csrr x14, 0x473

    #Address 0x473 Write value 0xe24a6f48
    li x3, 0xe24a6f48
    csrw 0x473, x3

    #Address 0x473 read value
    csrr x14, 0x473

    #Unmapped address 0x8cd testing: Read Reset + Random data Write/Read
    #Address 0x8cd read value
    csrr x14, 0x8cd

    #Address 0x8cd Write value 0x85243dbc
    li x3, 0x85243dbc
    csrw 0x8cd, x3

    #Address 0x8cd read value
    csrr x14, 0x8cd

    #Unmapped address 0x745 testing: Read Reset + Random data Write/Read
    #Address 0x745 read value
    csrr x14, 0x745

    #Address 0x745 Write value 0xf06c9786
    li x3, 0xf06c9786
    csrw 0x745, x3

    #Address 0x745 read value
    csrr x14, 0x745

    #Unmapped address 0xe7a testing: Read Reset + Random data Write/Read
    #Address 0xe7a read value
    csrr x14, 0xe7a

    #Address 0xe7a Write value 0xbe92b8b5
    li x3, 0xbe92b8b5
    csrw 0xe7a, x3

    #Address 0xe7a read value
    csrr x14, 0xe7a

    #Unmapped address 0xe73 testing: Read Reset + Random data Write/Read
    #Address 0xe73 read value
    csrr x14, 0xe73

    #Address 0xe73 Write value 0x8263d8b8
    li x3, 0x8263d8b8
    csrw 0xe73, x3

    #Address 0xe73 read value
    csrr x14, 0xe73

    #Unmapped address 0xd3c testing: Read Reset + Random data Write/Read
    #Address 0xd3c read value
    csrr x14, 0xd3c

    #Address 0xd3c Write value 0xba0eed88
    li x3, 0xba0eed88
    csrw 0xd3c, x3

    #Address 0xd3c read value
    csrr x14, 0xd3c

    #Unmapped address 0xe99 testing: Read Reset + Random data Write/Read
    #Address 0xe99 read value
    csrr x14, 0xe99

    #Address 0xe99 Write value 0xcdd4f690
    li x3, 0xcdd4f690
    csrw 0xe99, x3

    #Address 0xe99 read value
    csrr x14, 0xe99

    #Unmapped address 0x375 testing: Read Reset + Random data Write/Read
    #Address 0x375 read value
    csrr x14, 0x375

    #Address 0x375 Write value 0x279e4885
    li x3, 0x279e4885
    csrw 0x375, x3

    #Address 0x375 read value
    csrr x14, 0x375

    #Unmapped address 0xbfc testing: Read Reset + Random data Write/Read
    #Address 0xbfc read value
    csrr x14, 0xbfc

    #Address 0xbfc Write value 0x92f2e9e
    li x3, 0x92f2e9e
    csrw 0xbfc, x3

    #Address 0xbfc read value
    csrr x14, 0xbfc

    #Unmapped address 0x781 testing: Read Reset + Random data Write/Read
    #Address 0x781 read value
    csrr x14, 0x781

    #Address 0x781 Write value 0x44f060f4
    li x3, 0x44f060f4
    csrw 0x781, x3

    #Address 0x781 read value
    csrr x14, 0x781

    #Unmapped address 0x2ab testing: Read Reset + Random data Write/Read
    #Address 0x2ab read value
    csrr x14, 0x2ab

    #Address 0x2ab Write value 0x753620a9
    li x3, 0x753620a9
    csrw 0x2ab, x3

    #Address 0x2ab read value
    csrr x14, 0x2ab

    #Unmapped address 0x3d7 testing: Read Reset + Random data Write/Read
    #Address 0x3d7 read value
    csrr x14, 0x3d7

    #Address 0x3d7 Write value 0x972c37bb
    li x3, 0x972c37bb
    csrw 0x3d7, x3

    #Address 0x3d7 read value
    csrr x14, 0x3d7

    #Unmapped address 0x65c testing: Read Reset + Random data Write/Read
    #Address 0x65c read value
    csrr x14, 0x65c

    #Address 0x65c Write value 0x7aaf88be
    li x3, 0x7aaf88be
    csrw 0x65c, x3

    #Address 0x65c read value
    csrr x14, 0x65c

    #Unmapped address 0x9ab testing: Read Reset + Random data Write/Read
    #Address 0x9ab read value
    csrr x14, 0x9ab

    #Address 0x9ab Write value 0xa81e8cce
    li x3, 0xa81e8cce
    csrw 0x9ab, x3

    #Address 0x9ab read value
    csrr x14, 0x9ab

    #Unmapped address 0x9dd testing: Read Reset + Random data Write/Read
    #Address 0x9dd read value
    csrr x14, 0x9dd

    #Address 0x9dd Write value 0x72ce2bdc
    li x3, 0x72ce2bdc
    csrw 0x9dd, x3

    #Address 0x9dd read value
    csrr x14, 0x9dd

    #Unmapped address 0xce7 testing: Read Reset + Random data Write/Read
    #Address 0xce7 read value
    csrr x14, 0xce7

    #Address 0xce7 Write value 0x9ab0f04d
    li x3, 0x9ab0f04d
    csrw 0xce7, x3

    #Address 0xce7 read value
    csrr x14, 0xce7

    #Unmapped address 0x91d testing: Read Reset + Random data Write/Read
    #Address 0x91d read value
    csrr x14, 0x91d

    #Address 0x91d Write value 0xf214285f
    li x3, 0xf214285f
    csrw 0x91d, x3

    #Address 0x91d read value
    csrr x14, 0x91d

    #Unmapped address 0x8dc testing: Read Reset + Random data Write/Read
    #Address 0x8dc read value
    csrr x14, 0x8dc

    #Address 0x8dc Write value 0xd9b8ed7b
    li x3, 0xd9b8ed7b
    csrw 0x8dc, x3

    #Address 0x8dc read value
    csrr x14, 0x8dc

    #Unmapped address 0x5d4 testing: Read Reset + Random data Write/Read
    #Address 0x5d4 read value
    csrr x14, 0x5d4

    #Address 0x5d4 Write value 0xcb85e4bb
    li x3, 0xcb85e4bb
    csrw 0x5d4, x3

    #Address 0x5d4 read value
    csrr x14, 0x5d4

    #Unmapped address 0xc56 testing: Read Reset + Random data Write/Read
    #Address 0xc56 read value
    csrr x14, 0xc56

    #Address 0xc56 Write value 0xe306e21a
    li x3, 0xe306e21a
    csrw 0xc56, x3

    #Address 0xc56 read value
    csrr x14, 0xc56

    #Unmapped address 0xdcd testing: Read Reset + Random data Write/Read
    #Address 0xdcd read value
    csrr x14, 0xdcd

    #Address 0xdcd Write value 0x1cc18130
    li x3, 0x1cc18130
    csrw 0xdcd, x3

    #Address 0xdcd read value
    csrr x14, 0xdcd

    #Unmapped address 0x1d2 testing: Read Reset + Random data Write/Read
    #Address 0x1d2 read value
    csrr x14, 0x1d2

    #Address 0x1d2 Write value 0xfca3125d
    li x3, 0xfca3125d
    csrw 0x1d2, x3

    #Address 0x1d2 read value
    csrr x14, 0x1d2

    #Unmapped address 0x20 testing: Read Reset + Random data Write/Read
    #Address 0x20 read value
    csrr x14, 0x20

    #Address 0x20 Write value 0x9db73e73
    li x3, 0x9db73e73
    csrw 0x20, x3

    #Address 0x20 read value
    csrr x14, 0x20

    #Unmapped address 0x881 testing: Read Reset + Random data Write/Read
    #Address 0x881 read value
    csrr x14, 0x881

    #Address 0x881 Write value 0x7392374f
    li x3, 0x7392374f
    csrw 0x881, x3

    #Address 0x881 read value
    csrr x14, 0x881

    #Unmapped address 0x95a testing: Read Reset + Random data Write/Read
    #Address 0x95a read value
    csrr x14, 0x95a

    #Address 0x95a Write value 0xe7141aef
    li x3, 0xe7141aef
    csrw 0x95a, x3

    #Address 0x95a read value
    csrr x14, 0x95a

    #Unmapped address 0x241 testing: Read Reset + Random data Write/Read
    #Address 0x241 read value
    csrr x14, 0x241

    #Address 0x241 Write value 0xe7bb0c71
    li x3, 0xe7bb0c71
    csrw 0x241, x3

    #Address 0x241 read value
    csrr x14, 0x241

    #Unmapped address 0xfa6 testing: Read Reset + Random data Write/Read
    #Address 0xfa6 read value
    csrr x14, 0xfa6

    #Address 0xfa6 Write value 0x7d64ca8f
    li x3, 0x7d64ca8f
    csrw 0xfa6, x3

    #Address 0xfa6 read value
    csrr x14, 0xfa6

    #Unmapped address 0x135 testing: Read Reset + Random data Write/Read
    #Address 0x135 read value
    csrr x14, 0x135

    #Address 0x135 Write value 0xa6ec1874
    li x3, 0xa6ec1874
    csrw 0x135, x3

    #Address 0x135 read value
    csrr x14, 0x135

    #Unmapped address 0x2c5 testing: Read Reset + Random data Write/Read
    #Address 0x2c5 read value
    csrr x14, 0x2c5

    #Address 0x2c5 Write value 0xa2ff4945
    li x3, 0xa2ff4945
    csrw 0x2c5, x3

    #Address 0x2c5 read value
    csrr x14, 0x2c5

    #Unmapped address 0x199 testing: Read Reset + Random data Write/Read
    #Address 0x199 read value
    csrr x14, 0x199

    #Address 0x199 Write value 0x2f8ba1d6
    li x3, 0x2f8ba1d6
    csrw 0x199, x3

    #Address 0x199 read value
    csrr x14, 0x199

    #Unmapped address 0x203 testing: Read Reset + Random data Write/Read
    #Address 0x203 read value
    csrr x14, 0x203

    #Address 0x203 Write value 0xaa930779
    li x3, 0xaa930779
    csrw 0x203, x3

    #Address 0x203 read value
    csrr x14, 0x203

    #Unmapped address 0x81a testing: Read Reset + Random data Write/Read
    #Address 0x81a read value
    csrr x14, 0x81a

    #Address 0x81a Write value 0x20c46b15
    li x3, 0x20c46b15
    csrw 0x81a, x3

    #Address 0x81a read value
    csrr x14, 0x81a

    #Unmapped address 0x952 testing: Read Reset + Random data Write/Read
    #Address 0x952 read value
    csrr x14, 0x952

    #Address 0x952 Write value 0xf3d558dc
    li x3, 0xf3d558dc
    csrw 0x952, x3

    #Address 0x952 read value
    csrr x14, 0x952

    #Unmapped address 0x108 testing: Read Reset + Random data Write/Read
    #Address 0x108 read value
    csrr x14, 0x108

    #Address 0x108 Write value 0xbc249830
    li x3, 0xbc249830
    csrw 0x108, x3

    #Address 0x108 read value
    csrr x14, 0x108

    #Unmapped address 0x694 testing: Read Reset + Random data Write/Read
    #Address 0x694 read value
    csrr x14, 0x694

    #Address 0x694 Write value 0xf37e0faa
    li x3, 0xf37e0faa
    csrw 0x694, x3

    #Address 0x694 read value
    csrr x14, 0x694

    #Unmapped address 0xc2e testing: Read Reset + Random data Write/Read
    #Address 0xc2e read value
    csrr x14, 0xc2e

    #Address 0xc2e Write value 0x666e9270
    li x3, 0x666e9270
    csrw 0xc2e, x3

    #Address 0xc2e read value
    csrr x14, 0xc2e

    #Unmapped address 0x959 testing: Read Reset + Random data Write/Read
    #Address 0x959 read value
    csrr x14, 0x959

    #Address 0x959 Write value 0x4a48f0e0
    li x3, 0x4a48f0e0
    csrw 0x959, x3

    #Address 0x959 read value
    csrr x14, 0x959

    #Unmapped address 0x46e testing: Read Reset + Random data Write/Read
    #Address 0x46e read value
    csrr x14, 0x46e

    #Address 0x46e Write value 0x602220bb
    li x3, 0x602220bb
    csrw 0x46e, x3

    #Address 0x46e read value
    csrr x14, 0x46e

    #Unmapped address 0xf77 testing: Read Reset + Random data Write/Read
    #Address 0xf77 read value
    csrr x14, 0xf77

    #Address 0xf77 Write value 0x30b1788
    li x3, 0x30b1788
    csrw 0xf77, x3

    #Address 0xf77 read value
    csrr x14, 0xf77

    #Unmapped address 0x6b4 testing: Read Reset + Random data Write/Read
    #Address 0x6b4 read value
    csrr x14, 0x6b4

    #Address 0x6b4 Write value 0x737ba814
    li x3, 0x737ba814
    csrw 0x6b4, x3

    #Address 0x6b4 read value
    csrr x14, 0x6b4

    #Unmapped address 0x6f8 testing: Read Reset + Random data Write/Read
    #Address 0x6f8 read value
    csrr x14, 0x6f8

    #Address 0x6f8 Write value 0xefdb77fa
    li x3, 0xefdb77fa
    csrw 0x6f8, x3

    #Address 0x6f8 read value
    csrr x14, 0x6f8

    #Unmapped address 0x78c testing: Read Reset + Random data Write/Read
    #Address 0x78c read value
    csrr x14, 0x78c

    #Address 0x78c Write value 0x73c7acc7
    li x3, 0x73c7acc7
    csrw 0x78c, x3

    #Address 0x78c read value
    csrr x14, 0x78c

    #Unmapped address 0xa3 testing: Read Reset + Random data Write/Read
    #Address 0xa3 read value
    csrr x14, 0xa3

    #Address 0xa3 Write value 0xbbcfa8c5
    li x3, 0xbbcfa8c5
    csrw 0xa3, x3

    #Address 0xa3 read value
    csrr x14, 0xa3

    #Unmapped address 0x859 testing: Read Reset + Random data Write/Read
    #Address 0x859 read value
    csrr x14, 0x859

    #Address 0x859 Write value 0x9bcac381
    li x3, 0x9bcac381
    csrw 0x859, x3

    #Address 0x859 read value
    csrr x14, 0x859

    #Unmapped address 0x4e6 testing: Read Reset + Random data Write/Read
    #Address 0x4e6 read value
    csrr x14, 0x4e6

    #Address 0x4e6 Write value 0x1eeea7d4
    li x3, 0x1eeea7d4
    csrw 0x4e6, x3

    #Address 0x4e6 read value
    csrr x14, 0x4e6

    #Unmapped address 0x8de testing: Read Reset + Random data Write/Read
    #Address 0x8de read value
    csrr x14, 0x8de

    #Address 0x8de Write value 0x6e443cb2
    li x3, 0x6e443cb2
    csrw 0x8de, x3

    #Address 0x8de read value
    csrr x14, 0x8de

    #Unmapped address 0x3c0 testing: Read Reset + Random data Write/Read
    #Address 0x3c0 read value
    csrr x14, 0x3c0

    #Address 0x3c0 Write value 0xd1209317
    li x3, 0xd1209317
    csrw 0x3c0, x3

    #Address 0x3c0 read value
    csrr x14, 0x3c0

    #Unmapped address 0x15c testing: Read Reset + Random data Write/Read
    #Address 0x15c read value
    csrr x14, 0x15c

    #Address 0x15c Write value 0xd7c1015c
    li x3, 0xd7c1015c
    csrw 0x15c, x3

    #Address 0x15c read value
    csrr x14, 0x15c

    #Unmapped address 0x887 testing: Read Reset + Random data Write/Read
    #Address 0x887 read value
    csrr x14, 0x887

    #Address 0x887 Write value 0x58fceccf
    li x3, 0x58fceccf
    csrw 0x887, x3

    #Address 0x887 read value
    csrr x14, 0x887

    #Unmapped address 0x447 testing: Read Reset + Random data Write/Read
    #Address 0x447 read value
    csrr x14, 0x447

    #Address 0x447 Write value 0xc42d0c4a
    li x3, 0xc42d0c4a
    csrw 0x447, x3

    #Address 0x447 read value
    csrr x14, 0x447

    #Unmapped address 0xbbd testing: Read Reset + Random data Write/Read
    #Address 0xbbd read value
    csrr x14, 0xbbd

    #Address 0xbbd Write value 0x59cfb6c1
    li x3, 0x59cfb6c1
    csrw 0xbbd, x3

    #Address 0xbbd read value
    csrr x14, 0xbbd

    #Unmapped address 0x84c testing: Read Reset + Random data Write/Read
    #Address 0x84c read value
    csrr x14, 0x84c

    #Address 0x84c Write value 0x913e6053
    li x3, 0x913e6053
    csrw 0x84c, x3

    #Address 0x84c read value
    csrr x14, 0x84c

    #Unmapped address 0xf88 testing: Read Reset + Random data Write/Read
    #Address 0xf88 read value
    csrr x14, 0xf88

    #Address 0xf88 Write value 0xafe73682
    li x3, 0xafe73682
    csrw 0xf88, x3

    #Address 0xf88 read value
    csrr x14, 0xf88

    #Unmapped address 0x11f testing: Read Reset + Random data Write/Read
    #Address 0x11f read value
    csrr x14, 0x11f

    #Address 0x11f Write value 0x925966ea
    li x3, 0x925966ea
    csrw 0x11f, x3

    #Address 0x11f read value
    csrr x14, 0x11f

    #Unmapped address 0x265 testing: Read Reset + Random data Write/Read
    #Address 0x265 read value
    csrr x14, 0x265

    #Address 0x265 Write value 0x3f6a5d46
    li x3, 0x3f6a5d46
    csrw 0x265, x3

    #Address 0x265 read value
    csrr x14, 0x265

    #Unmapped address 0xa54 testing: Read Reset + Random data Write/Read
    #Address 0xa54 read value
    csrr x14, 0xa54

    #Address 0xa54 Write value 0xd37642bf
    li x3, 0xd37642bf
    csrw 0xa54, x3

    #Address 0xa54 read value
    csrr x14, 0xa54

    #Unmapped address 0x9c6 testing: Read Reset + Random data Write/Read
    #Address 0x9c6 read value
    csrr x14, 0x9c6

    #Address 0x9c6 Write value 0xabd391fe
    li x3, 0xabd391fe
    csrw 0x9c6, x3

    #Address 0x9c6 read value
    csrr x14, 0x9c6

    #Unmapped address 0x783 testing: Read Reset + Random data Write/Read
    #Address 0x783 read value
    csrr x14, 0x783

    #Address 0x783 Write value 0xa768f186
    li x3, 0xa768f186
    csrw 0x783, x3

    #Address 0x783 read value
    csrr x14, 0x783

    #Unmapped address 0x83b testing: Read Reset + Random data Write/Read
    #Address 0x83b read value
    csrr x14, 0x83b

    #Address 0x83b Write value 0xaa84552f
    li x3, 0xaa84552f
    csrw 0x83b, x3

    #Address 0x83b read value
    csrr x14, 0x83b

    #Unmapped address 0x194 testing: Read Reset + Random data Write/Read
    #Address 0x194 read value
    csrr x14, 0x194

    #Address 0x194 Write value 0x820b6c1c
    li x3, 0x820b6c1c
    csrw 0x194, x3

    #Address 0x194 read value
    csrr x14, 0x194

    #Unmapped address 0xabd testing: Read Reset + Random data Write/Read
    #Address 0xabd read value
    csrr x14, 0xabd

    #Address 0xabd Write value 0xa3b58442
    li x3, 0xa3b58442
    csrw 0xabd, x3

    #Address 0xabd read value
    csrr x14, 0xabd

    #Unmapped address 0x13f testing: Read Reset + Random data Write/Read
    #Address 0x13f read value
    csrr x14, 0x13f

    #Address 0x13f Write value 0x9cccc562
    li x3, 0x9cccc562
    csrw 0x13f, x3

    #Address 0x13f read value
    csrr x14, 0x13f

    #Unmapped address 0x995 testing: Read Reset + Random data Write/Read
    #Address 0x995 read value
    csrr x14, 0x995

    #Address 0x995 Write value 0x65193730
    li x3, 0x65193730
    csrw 0x995, x3

    #Address 0x995 read value
    csrr x14, 0x995

    #Unmapped address 0x484 testing: Read Reset + Random data Write/Read
    #Address 0x484 read value
    csrr x14, 0x484

    #Address 0x484 Write value 0x6d5f4b13
    li x3, 0x6d5f4b13
    csrw 0x484, x3

    #Address 0x484 read value
    csrr x14, 0x484

    #Unmapped address 0xe1a testing: Read Reset + Random data Write/Read
    #Address 0xe1a read value
    csrr x14, 0xe1a

    #Address 0xe1a Write value 0xe5726bd1
    li x3, 0xe5726bd1
    csrw 0xe1a, x3

    #Address 0xe1a read value
    csrr x14, 0xe1a

    #Unmapped address 0x8f4 testing: Read Reset + Random data Write/Read
    #Address 0x8f4 read value
    csrr x14, 0x8f4

    #Address 0x8f4 Write value 0x36053c86
    li x3, 0x36053c86
    csrw 0x8f4, x3

    #Address 0x8f4 read value
    csrr x14, 0x8f4

    #Unmapped address 0x1a1 testing: Read Reset + Random data Write/Read
    #Address 0x1a1 read value
    csrr x14, 0x1a1

    #Address 0x1a1 Write value 0x96a7e0df
    li x3, 0x96a7e0df
    csrw 0x1a1, x3

    #Address 0x1a1 read value
    csrr x14, 0x1a1

    #Unmapped address 0xed testing: Read Reset + Random data Write/Read
    #Address 0xed read value
    csrr x14, 0xed

    #Address 0xed Write value 0x116229cb
    li x3, 0x116229cb
    csrw 0xed, x3

    #Address 0xed read value
    csrr x14, 0xed

    #Unmapped address 0xbef testing: Read Reset + Random data Write/Read
    #Address 0xbef read value
    csrr x14, 0xbef

    #Address 0xbef Write value 0xb51fc17f
    li x3, 0xb51fc17f
    csrw 0xbef, x3

    #Address 0xbef read value
    csrr x14, 0xbef

    #Unmapped address 0x9bf testing: Read Reset + Random data Write/Read
    #Address 0x9bf read value
    csrr x14, 0x9bf

    #Address 0x9bf Write value 0xcf8d0194
    li x3, 0xcf8d0194
    csrw 0x9bf, x3

    #Address 0x9bf read value
    csrr x14, 0x9bf

    #Unmapped address 0x464 testing: Read Reset + Random data Write/Read
    #Address 0x464 read value
    csrr x14, 0x464

    #Address 0x464 Write value 0x4b54ed04
    li x3, 0x4b54ed04
    csrw 0x464, x3

    #Address 0x464 read value
    csrr x14, 0x464

    #Unmapped address 0xf9b testing: Read Reset + Random data Write/Read
    #Address 0xf9b read value
    csrr x14, 0xf9b

    #Address 0xf9b Write value 0x4bfc4d93
    li x3, 0x4bfc4d93
    csrw 0xf9b, x3

    #Address 0xf9b read value
    csrr x14, 0xf9b

    #Unmapped address 0x73e testing: Read Reset + Random data Write/Read
    #Address 0x73e read value
    csrr x14, 0x73e

    #Address 0x73e Write value 0xeb1ef2c8
    li x3, 0xeb1ef2c8
    csrw 0x73e, x3

    #Address 0x73e read value
    csrr x14, 0x73e

    #Unmapped address 0x3c6 testing: Read Reset + Random data Write/Read
    #Address 0x3c6 read value
    csrr x14, 0x3c6

    #Address 0x3c6 Write value 0x83826e03
    li x3, 0x83826e03
    csrw 0x3c6, x3

    #Address 0x3c6 read value
    csrr x14, 0x3c6

    #Unmapped address 0x677 testing: Read Reset + Random data Write/Read
    #Address 0x677 read value
    csrr x14, 0x677

    #Address 0x677 Write value 0xa26c3a4a
    li x3, 0xa26c3a4a
    csrw 0x677, x3

    #Address 0x677 read value
    csrr x14, 0x677

    #Unmapped address 0x1fd testing: Read Reset + Random data Write/Read
    #Address 0x1fd read value
    csrr x14, 0x1fd

    #Address 0x1fd Write value 0x1a83bac7
    li x3, 0x1a83bac7
    csrw 0x1fd, x3

    #Address 0x1fd read value
    csrr x14, 0x1fd

    #Unmapped address 0xfde testing: Read Reset + Random data Write/Read
    #Address 0xfde read value
    csrr x14, 0xfde

    #Address 0xfde Write value 0xf4febdeb
    li x3, 0xf4febdeb
    csrw 0xfde, x3

    #Address 0xfde read value
    csrr x14, 0xfde

    #Unmapped address 0x92e testing: Read Reset + Random data Write/Read
    #Address 0x92e read value
    csrr x14, 0x92e

    #Address 0x92e Write value 0xa844aa59
    li x3, 0xa844aa59
    csrw 0x92e, x3

    #Address 0x92e read value
    csrr x14, 0x92e

    #Unmapped address 0xac9 testing: Read Reset + Random data Write/Read
    #Address 0xac9 read value
    csrr x14, 0xac9

    #Address 0xac9 Write value 0x7c44221c
    li x3, 0x7c44221c
    csrw 0xac9, x3

    #Address 0xac9 read value
    csrr x14, 0xac9

    #Unmapped address 0xf2e testing: Read Reset + Random data Write/Read
    #Address 0xf2e read value
    csrr x14, 0xf2e

    #Address 0xf2e Write value 0xec9449b9
    li x3, 0xec9449b9
    csrw 0xf2e, x3

    #Address 0xf2e read value
    csrr x14, 0xf2e

    #Unmapped address 0x8c1 testing: Read Reset + Random data Write/Read
    #Address 0x8c1 read value
    csrr x14, 0x8c1

    #Address 0x8c1 Write value 0xff1b3916
    li x3, 0xff1b3916
    csrw 0x8c1, x3

    #Address 0x8c1 read value
    csrr x14, 0x8c1

    #Unmapped address 0x8e3 testing: Read Reset + Random data Write/Read
    #Address 0x8e3 read value
    csrr x14, 0x8e3

    #Address 0x8e3 Write value 0x7d616e47
    li x3, 0x7d616e47
    csrw 0x8e3, x3

    #Address 0x8e3 read value
    csrr x14, 0x8e3

    #Unmapped address 0xe42 testing: Read Reset + Random data Write/Read
    #Address 0xe42 read value
    csrr x14, 0xe42

    #Address 0xe42 Write value 0x7ebcc1a1
    li x3, 0x7ebcc1a1
    csrw 0xe42, x3

    #Address 0xe42 read value
    csrr x14, 0xe42

    #Unmapped address 0xde3 testing: Read Reset + Random data Write/Read
    #Address 0xde3 read value
    csrr x14, 0xde3

    #Address 0xde3 Write value 0x2a6bc1c
    li x3, 0x2a6bc1c
    csrw 0xde3, x3

    #Address 0xde3 read value
    csrr x14, 0xde3

    #Unmapped address 0x8d5 testing: Read Reset + Random data Write/Read
    #Address 0x8d5 read value
    csrr x14, 0x8d5

    #Address 0x8d5 Write value 0xe649b48b
    li x3, 0xe649b48b
    csrw 0x8d5, x3

    #Address 0x8d5 read value
    csrr x14, 0x8d5

    #Unmapped address 0x756 testing: Read Reset + Random data Write/Read
    #Address 0x756 read value
    csrr x14, 0x756

    #Address 0x756 Write value 0xe1451878
    li x3, 0xe1451878
    csrw 0x756, x3

    #Address 0x756 read value
    csrr x14, 0x756

    #Unmapped address 0xad2 testing: Read Reset + Random data Write/Read
    #Address 0xad2 read value
    csrr x14, 0xad2

    #Address 0xad2 Write value 0xe56b61ae
    li x3, 0xe56b61ae
    csrw 0xad2, x3

    #Address 0xad2 read value
    csrr x14, 0xad2

    #Unmapped address 0x747 testing: Read Reset + Random data Write/Read
    #Address 0x747 read value
    csrr x14, 0x747

    #Address 0x747 Write value 0x4f62eebe
    li x3, 0x4f62eebe
    csrw 0x747, x3

    #Address 0x747 read value
    csrr x14, 0x747

    #Unmapped address 0x104 testing: Read Reset + Random data Write/Read
    #Address 0x104 read value
    csrr x14, 0x104

    #Address 0x104 Write value 0xd96a3527
    li x3, 0xd96a3527
    csrw 0x104, x3

    #Address 0x104 read value
    csrr x14, 0x104

    #Unmapped address 0x983 testing: Read Reset + Random data Write/Read
    #Address 0x983 read value
    csrr x14, 0x983

    #Address 0x983 Write value 0x5b83f125
    li x3, 0x5b83f125
    csrw 0x983, x3

    #Address 0x983 read value
    csrr x14, 0x983

    #Unmapped address 0xf71 testing: Read Reset + Random data Write/Read
    #Address 0xf71 read value
    csrr x14, 0xf71

    #Address 0xf71 Write value 0xb0da82b8
    li x3, 0xb0da82b8
    csrw 0xf71, x3

    #Address 0xf71 read value
    csrr x14, 0xf71

    #Unmapped address 0x9e4 testing: Read Reset + Random data Write/Read
    #Address 0x9e4 read value
    csrr x14, 0x9e4

    #Address 0x9e4 Write value 0xffa402e1
    li x3, 0xffa402e1
    csrw 0x9e4, x3

    #Address 0x9e4 read value
    csrr x14, 0x9e4

    #Unmapped address 0x4bd testing: Read Reset + Random data Write/Read
    #Address 0x4bd read value
    csrr x14, 0x4bd

    #Address 0x4bd Write value 0x2d4896d4
    li x3, 0x2d4896d4
    csrw 0x4bd, x3

    #Address 0x4bd read value
    csrr x14, 0x4bd

    #Unmapped address 0xe85 testing: Read Reset + Random data Write/Read
    #Address 0xe85 read value
    csrr x14, 0xe85

    #Address 0xe85 Write value 0x9ab21c90
    li x3, 0x9ab21c90
    csrw 0xe85, x3

    #Address 0xe85 read value
    csrr x14, 0xe85

    #Unmapped address 0x147 testing: Read Reset + Random data Write/Read
    #Address 0x147 read value
    csrr x14, 0x147

    #Address 0x147 Write value 0x4761669b
    li x3, 0x4761669b
    csrw 0x147, x3

    #Address 0x147 read value
    csrr x14, 0x147

    #Unmapped address 0xa85 testing: Read Reset + Random data Write/Read
    #Address 0xa85 read value
    csrr x14, 0xa85

    #Address 0xa85 Write value 0x7f7f1171
    li x3, 0x7f7f1171
    csrw 0xa85, x3

    #Address 0xa85 read value
    csrr x14, 0xa85

    #Unmapped address 0x8ae testing: Read Reset + Random data Write/Read
    #Address 0x8ae read value
    csrr x14, 0x8ae

    #Address 0x8ae Write value 0xd3ebf21
    li x3, 0xd3ebf21
    csrw 0x8ae, x3

    #Address 0x8ae read value
    csrr x14, 0x8ae

    #Unmapped address 0x939 testing: Read Reset + Random data Write/Read
    #Address 0x939 read value
    csrr x14, 0x939

    #Address 0x939 Write value 0xed080a90
    li x3, 0xed080a90
    csrw 0x939, x3

    #Address 0x939 read value
    csrr x14, 0x939

    #Unmapped address 0x26d testing: Read Reset + Random data Write/Read
    #Address 0x26d read value
    csrr x14, 0x26d

    #Address 0x26d Write value 0x383480e1
    li x3, 0x383480e1
    csrw 0x26d, x3

    #Address 0x26d read value
    csrr x14, 0x26d

    #Unmapped address 0x3eb testing: Read Reset + Random data Write/Read
    #Address 0x3eb read value
    csrr x14, 0x3eb

    #Address 0x3eb Write value 0x183b943d
    li x3, 0x183b943d
    csrw 0x3eb, x3

    #Address 0x3eb read value
    csrr x14, 0x3eb

    #Unmapped address 0xf79 testing: Read Reset + Random data Write/Read
    #Address 0xf79 read value
    csrr x14, 0xf79

    #Address 0xf79 Write value 0xcf91cff
    li x3, 0xcf91cff
    csrw 0xf79, x3

    #Address 0xf79 read value
    csrr x14, 0xf79

    #Unmapped address 0x637 testing: Read Reset + Random data Write/Read
    #Address 0x637 read value
    csrr x14, 0x637

    #Address 0x637 Write value 0x6aa38ad4
    li x3, 0x6aa38ad4
    csrw 0x637, x3

    #Address 0x637 read value
    csrr x14, 0x637

    #Unmapped address 0xa36 testing: Read Reset + Random data Write/Read
    #Address 0xa36 read value
    csrr x14, 0xa36

    #Address 0xa36 Write value 0xf37e9a79
    li x3, 0xf37e9a79
    csrw 0xa36, x3

    #Address 0xa36 read value
    csrr x14, 0xa36

    #Unmapped address 0x77e testing: Read Reset + Random data Write/Read
    #Address 0x77e read value
    csrr x14, 0x77e

    #Address 0x77e Write value 0xe4e8ce3a
    li x3, 0xe4e8ce3a
    csrw 0x77e, x3

    #Address 0x77e read value
    csrr x14, 0x77e

    #Unmapped address 0x751 testing: Read Reset + Random data Write/Read
    #Address 0x751 read value
    csrr x14, 0x751

    #Address 0x751 Write value 0x3490e1b1
    li x3, 0x3490e1b1
    csrw 0x751, x3

    #Address 0x751 read value
    csrr x14, 0x751

    #Unmapped address 0x5ab testing: Read Reset + Random data Write/Read
    #Address 0x5ab read value
    csrr x14, 0x5ab

    #Address 0x5ab Write value 0x70eef71a
    li x3, 0x70eef71a
    csrw 0x5ab, x3

    #Address 0x5ab read value
    csrr x14, 0x5ab

    #Unmapped address 0xf1f testing: Read Reset + Random data Write/Read
    #Address 0xf1f read value
    csrr x14, 0xf1f

    #Address 0xf1f Write value 0x2d49915a
    li x3, 0x2d49915a
    csrw 0xf1f, x3

    #Address 0xf1f read value
    csrr x14, 0xf1f

    #Unmapped address 0x2dd testing: Read Reset + Random data Write/Read
    #Address 0x2dd read value
    csrr x14, 0x2dd

    #Address 0x2dd Write value 0x48fe4c0c
    li x3, 0x48fe4c0c
    csrw 0x2dd, x3

    #Address 0x2dd read value
    csrr x14, 0x2dd

    #Unmapped address 0xe61 testing: Read Reset + Random data Write/Read
    #Address 0xe61 read value
    csrr x14, 0xe61

    #Address 0xe61 Write value 0x6e32592e
    li x3, 0x6e32592e
    csrw 0xe61, x3

    #Address 0xe61 read value
    csrr x14, 0xe61

    #Unmapped address 0x8c7 testing: Read Reset + Random data Write/Read
    #Address 0x8c7 read value
    csrr x14, 0x8c7

    #Address 0x8c7 Write value 0xc11d1a72
    li x3, 0xc11d1a72
    csrw 0x8c7, x3

    #Address 0x8c7 read value
    csrr x14, 0x8c7

    #Unmapped address 0x9f8 testing: Read Reset + Random data Write/Read
    #Address 0x9f8 read value
    csrr x14, 0x9f8

    #Address 0x9f8 Write value 0x121a3fc7
    li x3, 0x121a3fc7
    csrw 0x9f8, x3

    #Address 0x9f8 read value
    csrr x14, 0x9f8

    #Unmapped address 0x25a testing: Read Reset + Random data Write/Read
    #Address 0x25a read value
    csrr x14, 0x25a

    #Address 0x25a Write value 0x3c1733c0
    li x3, 0x3c1733c0
    csrw 0x25a, x3

    #Address 0x25a read value
    csrr x14, 0x25a

    #Unmapped address 0xbf5 testing: Read Reset + Random data Write/Read
    #Address 0xbf5 read value
    csrr x14, 0xbf5

    #Address 0xbf5 Write value 0xd8987868
    li x3, 0xd8987868
    csrw 0xbf5, x3

    #Address 0xbf5 read value
    csrr x14, 0xbf5

    #Unmapped address 0xb7 testing: Read Reset + Random data Write/Read
    #Address 0xb7 read value
    csrr x14, 0xb7

    #Address 0xb7 Write value 0x471eeb4b
    li x3, 0x471eeb4b
    csrw 0xb7, x3

    #Address 0xb7 read value
    csrr x14, 0xb7

    #Unmapped address 0x79d testing: Read Reset + Random data Write/Read
    #Address 0x79d read value
    csrr x14, 0x79d

    #Address 0x79d Write value 0x8267da90
    li x3, 0x8267da90
    csrw 0x79d, x3

    #Address 0x79d read value
    csrr x14, 0x79d

    #Unmapped address 0x6b6 testing: Read Reset + Random data Write/Read
    #Address 0x6b6 read value
    csrr x14, 0x6b6

    #Address 0x6b6 Write value 0xb8166eaa
    li x3, 0xb8166eaa
    csrw 0x6b6, x3

    #Address 0x6b6 read value
    csrr x14, 0x6b6

    #Unmapped address 0x43 testing: Read Reset + Random data Write/Read
    #Address 0x43 read value
    csrr x14, 0x43

    #Address 0x43 Write value 0xc37528a1
    li x3, 0xc37528a1
    csrw 0x43, x3

    #Address 0x43 read value
    csrr x14, 0x43

    #Unmapped address 0x3ec testing: Read Reset + Random data Write/Read
    #Address 0x3ec read value
    csrr x14, 0x3ec

    #Address 0x3ec Write value 0x3af3ae41
    li x3, 0x3af3ae41
    csrw 0x3ec, x3

    #Address 0x3ec read value
    csrr x14, 0x3ec

    #Unmapped address 0xcc9 testing: Read Reset + Random data Write/Read
    #Address 0xcc9 read value
    csrr x14, 0xcc9

    #Address 0xcc9 Write value 0xf4282006
    li x3, 0xf4282006
    csrw 0xcc9, x3

    #Address 0xcc9 read value
    csrr x14, 0xcc9

    #Unmapped address 0x824 testing: Read Reset + Random data Write/Read
    #Address 0x824 read value
    csrr x14, 0x824

    #Address 0x824 Write value 0xde39d59
    li x3, 0xde39d59
    csrw 0x824, x3

    #Address 0x824 read value
    csrr x14, 0x824

    #Unmapped address 0xc96 testing: Read Reset + Random data Write/Read
    #Address 0xc96 read value
    csrr x14, 0xc96

    #Address 0xc96 Write value 0x3d65a224
    li x3, 0x3d65a224
    csrw 0xc96, x3

    #Address 0xc96 read value
    csrr x14, 0xc96

    #Unmapped address 0x90d testing: Read Reset + Random data Write/Read
    #Address 0x90d read value
    csrr x14, 0x90d

    #Address 0x90d Write value 0x99c45d85
    li x3, 0x99c45d85
    csrw 0x90d, x3

    #Address 0x90d read value
    csrr x14, 0x90d

    #Unmapped address 0xfa testing: Read Reset + Random data Write/Read
    #Address 0xfa read value
    csrr x14, 0xfa

    #Address 0xfa Write value 0xc6e0853e
    li x3, 0xc6e0853e
    csrw 0xfa, x3

    #Address 0xfa read value
    csrr x14, 0xfa

    #Unmapped address 0xed8 testing: Read Reset + Random data Write/Read
    #Address 0xed8 read value
    csrr x14, 0xed8

    #Address 0xed8 Write value 0xc914ec40
    li x3, 0xc914ec40
    csrw 0xed8, x3

    #Address 0xed8 read value
    csrr x14, 0xed8

    #Unmapped address 0x414 testing: Read Reset + Random data Write/Read
    #Address 0x414 read value
    csrr x14, 0x414

    #Address 0x414 Write value 0xbf380874
    li x3, 0xbf380874
    csrw 0x414, x3

    #Address 0x414 read value
    csrr x14, 0x414

    #Unmapped address 0x257 testing: Read Reset + Random data Write/Read
    #Address 0x257 read value
    csrr x14, 0x257

    #Address 0x257 Write value 0xb81eb10d
    li x3, 0xb81eb10d
    csrw 0x257, x3

    #Address 0x257 read value
    csrr x14, 0x257

    #Unmapped address 0xc4d testing: Read Reset + Random data Write/Read
    #Address 0xc4d read value
    csrr x14, 0xc4d

    #Address 0xc4d Write value 0x188ce171
    li x3, 0x188ce171
    csrw 0xc4d, x3

    #Address 0xc4d read value
    csrr x14, 0xc4d

    #Unmapped address 0x22f testing: Read Reset + Random data Write/Read
    #Address 0x22f read value
    csrr x14, 0x22f

    #Address 0x22f Write value 0x93e1a379
    li x3, 0x93e1a379
    csrw 0x22f, x3

    #Address 0x22f read value
    csrr x14, 0x22f

    #Unmapped address 0xfc7 testing: Read Reset + Random data Write/Read
    #Address 0xfc7 read value
    csrr x14, 0xfc7

    #Address 0xfc7 Write value 0x42d4a01d
    li x3, 0x42d4a01d
    csrw 0xfc7, x3

    #Address 0xfc7 read value
    csrr x14, 0xfc7

    #Unmapped address 0xddb testing: Read Reset + Random data Write/Read
    #Address 0xddb read value
    csrr x14, 0xddb

    #Address 0xddb Write value 0xa3e5061d
    li x3, 0xa3e5061d
    csrw 0xddb, x3

    #Address 0xddb read value
    csrr x14, 0xddb

    #Unmapped address 0xf51 testing: Read Reset + Random data Write/Read
    #Address 0xf51 read value
    csrr x14, 0xf51

    #Address 0xf51 Write value 0x3d6787c6
    li x3, 0x3d6787c6
    csrw 0xf51, x3

    #Address 0xf51 read value
    csrr x14, 0xf51

    #Unmapped address 0x159 testing: Read Reset + Random data Write/Read
    #Address 0x159 read value
    csrr x14, 0x159

    #Address 0x159 Write value 0xf334b7af
    li x3, 0xf334b7af
    csrw 0x159, x3

    #Address 0x159 read value
    csrr x14, 0x159

    #Unmapped address 0xf80 testing: Read Reset + Random data Write/Read
    #Address 0xf80 read value
    csrr x14, 0xf80

    #Address 0xf80 Write value 0xbb67b0fa
    li x3, 0xbb67b0fa
    csrw 0xf80, x3

    #Address 0xf80 read value
    csrr x14, 0xf80

    #Unmapped address 0x5f8 testing: Read Reset + Random data Write/Read
    #Address 0x5f8 read value
    csrr x14, 0x5f8

    #Address 0x5f8 Write value 0xebd70d78
    li x3, 0xebd70d78
    csrw 0x5f8, x3

    #Address 0x5f8 read value
    csrr x14, 0x5f8

    #Unmapped address 0xde testing: Read Reset + Random data Write/Read
    #Address 0xde read value
    csrr x14, 0xde

    #Address 0xde Write value 0x79de40f4
    li x3, 0x79de40f4
    csrw 0xde, x3

    #Address 0xde read value
    csrr x14, 0xde

    #Unmapped address 0x289 testing: Read Reset + Random data Write/Read
    #Address 0x289 read value
    csrr x14, 0x289

    #Address 0x289 Write value 0x2f973c61
    li x3, 0x2f973c61
    csrw 0x289, x3

    #Address 0x289 read value
    csrr x14, 0x289

    #Unmapped address 0xb42 testing: Read Reset + Random data Write/Read
    #Address 0xb42 read value
    csrr x14, 0xb42

    #Address 0xb42 Write value 0xecd13670
    li x3, 0xecd13670
    csrw 0xb42, x3

    #Address 0xb42 read value
    csrr x14, 0xb42

    #Unmapped address 0x70b testing: Read Reset + Random data Write/Read
    #Address 0x70b read value
    csrr x14, 0x70b

    #Address 0x70b Write value 0x2b37b486
    li x3, 0x2b37b486
    csrw 0x70b, x3

    #Address 0x70b read value
    csrr x14, 0x70b

    #Unmapped address 0xdcc testing: Read Reset + Random data Write/Read
    #Address 0xdcc read value
    csrr x14, 0xdcc

    #Address 0xdcc Write value 0x7a93eaa1
    li x3, 0x7a93eaa1
    csrw 0xdcc, x3

    #Address 0xdcc read value
    csrr x14, 0xdcc

    #Unmapped address 0x215 testing: Read Reset + Random data Write/Read
    #Address 0x215 read value
    csrr x14, 0x215

    #Address 0x215 Write value 0x2f069124
    li x3, 0x2f069124
    csrw 0x215, x3

    #Address 0x215 read value
    csrr x14, 0x215

    #Unmapped address 0x2fd testing: Read Reset + Random data Write/Read
    #Address 0x2fd read value
    csrr x14, 0x2fd

    #Address 0x2fd Write value 0xe7d7ea48
    li x3, 0xe7d7ea48
    csrw 0x2fd, x3

    #Address 0x2fd read value
    csrr x14, 0x2fd

    #Unmapped address 0x13a testing: Read Reset + Random data Write/Read
    #Address 0x13a read value
    csrr x14, 0x13a

    #Address 0x13a Write value 0xbf781c6e
    li x3, 0xbf781c6e
    csrw 0x13a, x3

    #Address 0x13a read value
    csrr x14, 0x13a

    #Unmapped address 0x5e4 testing: Read Reset + Random data Write/Read
    #Address 0x5e4 read value
    csrr x14, 0x5e4

    #Address 0x5e4 Write value 0x84479f48
    li x3, 0x84479f48
    csrw 0x5e4, x3

    #Address 0x5e4 read value
    csrr x14, 0x5e4

    #Unmapped address 0xa31 testing: Read Reset + Random data Write/Read
    #Address 0xa31 read value
    csrr x14, 0xa31

    #Address 0xa31 Write value 0x4d58dd89
    li x3, 0x4d58dd89
    csrw 0xa31, x3

    #Address 0xa31 read value
    csrr x14, 0xa31

    #Unmapped address 0xd0e testing: Read Reset + Random data Write/Read
    #Address 0xd0e read value
    csrr x14, 0xd0e

    #Address 0xd0e Write value 0x457c17ff
    li x3, 0x457c17ff
    csrw 0xd0e, x3

    #Address 0xd0e read value
    csrr x14, 0xd0e

    #Unmapped address 0xc63 testing: Read Reset + Random data Write/Read
    #Address 0xc63 read value
    csrr x14, 0xc63

    #Address 0xc63 Write value 0x13658e09
    li x3, 0x13658e09
    csrw 0xc63, x3

    #Address 0xc63 read value
    csrr x14, 0xc63

    #Unmapped address 0xbc3 testing: Read Reset + Random data Write/Read
    #Address 0xbc3 read value
    csrr x14, 0xbc3

    #Address 0xbc3 Write value 0x2354bb17
    li x3, 0x2354bb17
    csrw 0xbc3, x3

    #Address 0xbc3 read value
    csrr x14, 0xbc3

    #Unmapped address 0xfe9 testing: Read Reset + Random data Write/Read
    #Address 0xfe9 read value
    csrr x14, 0xfe9

    #Address 0xfe9 Write value 0x4022d13d
    li x3, 0x4022d13d
    csrw 0xfe9, x3

    #Address 0xfe9 read value
    csrr x14, 0xfe9

    #Unmapped address 0xed7 testing: Read Reset + Random data Write/Read
    #Address 0xed7 read value
    csrr x14, 0xed7

    #Address 0xed7 Write value 0x364fec76
    li x3, 0x364fec76
    csrw 0xed7, x3

    #Address 0xed7 read value
    csrr x14, 0xed7

    #Unmapped address 0xc15 testing: Read Reset + Random data Write/Read
    #Address 0xc15 read value
    csrr x14, 0xc15

    #Address 0xc15 Write value 0xddf230b5
    li x3, 0xddf230b5
    csrw 0xc15, x3

    #Address 0xc15 read value
    csrr x14, 0xc15

    #Unmapped address 0xb63 testing: Read Reset + Random data Write/Read
    #Address 0xb63 read value
    csrr x14, 0xb63

    #Address 0xb63 Write value 0x447a6c26
    li x3, 0x447a6c26
    csrw 0xb63, x3

    #Address 0xb63 read value
    csrr x14, 0xb63

    #Unmapped address 0x6b7 testing: Read Reset + Random data Write/Read
    #Address 0x6b7 read value
    csrr x14, 0x6b7

    #Address 0x6b7 Write value 0x800fd139
    li x3, 0x800fd139
    csrw 0x6b7, x3

    #Address 0x6b7 read value
    csrr x14, 0x6b7

    #Unmapped address 0x847 testing: Read Reset + Random data Write/Read
    #Address 0x847 read value
    csrr x14, 0x847

    #Address 0x847 Write value 0xd093e5bd
    li x3, 0xd093e5bd
    csrw 0x847, x3

    #Address 0x847 read value
    csrr x14, 0x847

    #Unmapped address 0x536 testing: Read Reset + Random data Write/Read
    #Address 0x536 read value
    csrr x14, 0x536

    #Address 0x536 Write value 0x2cb53c18
    li x3, 0x2cb53c18
    csrw 0x536, x3

    #Address 0x536 read value
    csrr x14, 0x536

    #Unmapped address 0xccf testing: Read Reset + Random data Write/Read
    #Address 0xccf read value
    csrr x14, 0xccf

    #Address 0xccf Write value 0x9c1c5ccf
    li x3, 0x9c1c5ccf
    csrw 0xccf, x3

    #Address 0xccf read value
    csrr x14, 0xccf

    #Unmapped address 0x3ae testing: Read Reset + Random data Write/Read
    #Address 0x3ae read value
    csrr x14, 0x3ae

    #Address 0x3ae Write value 0x50ac1209
    li x3, 0x50ac1209
    csrw 0x3ae, x3

    #Address 0x3ae read value
    csrr x14, 0x3ae

    #Unmapped address 0x1f0 testing: Read Reset + Random data Write/Read
    #Address 0x1f0 read value
    csrr x14, 0x1f0

    #Address 0x1f0 Write value 0xbcab28d2
    li x3, 0xbcab28d2
    csrw 0x1f0, x3

    #Address 0x1f0 read value
    csrr x14, 0x1f0

    #Unmapped address 0x816 testing: Read Reset + Random data Write/Read
    #Address 0x816 read value
    csrr x14, 0x816

    #Address 0x816 Write value 0x3f58e7a2
    li x3, 0x3f58e7a2
    csrw 0x816, x3

    #Address 0x816 read value
    csrr x14, 0x816

    #Unmapped address 0x82e testing: Read Reset + Random data Write/Read
    #Address 0x82e read value
    csrr x14, 0x82e

    #Address 0x82e Write value 0xb91914ac
    li x3, 0xb91914ac
    csrw 0x82e, x3

    #Address 0x82e read value
    csrr x14, 0x82e

    #Unmapped address 0xdce testing: Read Reset + Random data Write/Read
    #Address 0xdce read value
    csrr x14, 0xdce

    #Address 0xdce Write value 0x612eaa37
    li x3, 0x612eaa37
    csrw 0xdce, x3

    #Address 0xdce read value
    csrr x14, 0xdce

    #Unmapped address 0xd0d testing: Read Reset + Random data Write/Read
    #Address 0xd0d read value
    csrr x14, 0xd0d

    #Address 0xd0d Write value 0x1c93d88c
    li x3, 0x1c93d88c
    csrw 0xd0d, x3

    #Address 0xd0d read value
    csrr x14, 0xd0d

    #Unmapped address 0x957 testing: Read Reset + Random data Write/Read
    #Address 0x957 read value
    csrr x14, 0x957

    #Address 0x957 Write value 0x65ac541d
    li x3, 0x65ac541d
    csrw 0x957, x3

    #Address 0x957 read value
    csrr x14, 0x957

    #Unmapped address 0xfae testing: Read Reset + Random data Write/Read
    #Address 0xfae read value
    csrr x14, 0xfae

    #Address 0xfae Write value 0xb7941432
    li x3, 0xb7941432
    csrw 0xfae, x3

    #Address 0xfae read value
    csrr x14, 0xfae

    #Unmapped address 0x3dc testing: Read Reset + Random data Write/Read
    #Address 0x3dc read value
    csrr x14, 0x3dc

    #Address 0x3dc Write value 0xfb7165d9
    li x3, 0xfb7165d9
    csrw 0x3dc, x3

    #Address 0x3dc read value
    csrr x14, 0x3dc

    #Unmapped address 0xfbe testing: Read Reset + Random data Write/Read
    #Address 0xfbe read value
    csrr x14, 0xfbe

    #Address 0xfbe Write value 0xaafcf865
    li x3, 0xaafcf865
    csrw 0xfbe, x3

    #Address 0xfbe read value
    csrr x14, 0xfbe

    #Unmapped address 0x9aa testing: Read Reset + Random data Write/Read
    #Address 0x9aa read value
    csrr x14, 0x9aa

    #Address 0x9aa Write value 0x32c7351
    li x3, 0x32c7351
    csrw 0x9aa, x3

    #Address 0x9aa read value
    csrr x14, 0x9aa

    #Unmapped address 0xa6f testing: Read Reset + Random data Write/Read
    #Address 0xa6f read value
    csrr x14, 0xa6f

    #Address 0xa6f Write value 0xe7f10dbb
    li x3, 0xe7f10dbb
    csrw 0xa6f, x3

    #Address 0xa6f read value
    csrr x14, 0xa6f

    #Unmapped address 0xba2 testing: Read Reset + Random data Write/Read
    #Address 0xba2 read value
    csrr x14, 0xba2

    #Address 0xba2 Write value 0xcb6d8d19
    li x3, 0xcb6d8d19
    csrw 0xba2, x3

    #Address 0xba2 read value
    csrr x14, 0xba2

    #Unmapped address 0xa8a testing: Read Reset + Random data Write/Read
    #Address 0xa8a read value
    csrr x14, 0xa8a

    #Address 0xa8a Write value 0x36ffb6f7
    li x3, 0x36ffb6f7
    csrw 0xa8a, x3

    #Address 0xa8a read value
    csrr x14, 0xa8a

    #Unmapped address 0x35d testing: Read Reset + Random data Write/Read
    #Address 0x35d read value
    csrr x14, 0x35d

    #Address 0x35d Write value 0xa123f2b
    li x3, 0xa123f2b
    csrw 0x35d, x3

    #Address 0x35d read value
    csrr x14, 0x35d

    #Unmapped address 0x992 testing: Read Reset + Random data Write/Read
    #Address 0x992 read value
    csrr x14, 0x992

    #Address 0x992 Write value 0xfd770826
    li x3, 0xfd770826
    csrw 0x992, x3

    #Address 0x992 read value
    csrr x14, 0x992

    #Unmapped address 0x754 testing: Read Reset + Random data Write/Read
    #Address 0x754 read value
    csrr x14, 0x754

    #Address 0x754 Write value 0x40e9185e
    li x3, 0x40e9185e
    csrw 0x754, x3

    #Address 0x754 read value
    csrr x14, 0x754

    #Unmapped address 0x8bb testing: Read Reset + Random data Write/Read
    #Address 0x8bb read value
    csrr x14, 0x8bb

    #Address 0x8bb Write value 0x60912d02
    li x3, 0x60912d02
    csrw 0x8bb, x3

    #Address 0x8bb read value
    csrr x14, 0x8bb

    #Unmapped address 0xdf7 testing: Read Reset + Random data Write/Read
    #Address 0xdf7 read value
    csrr x14, 0xdf7

    #Address 0xdf7 Write value 0x6f75db1b
    li x3, 0x6f75db1b
    csrw 0xdf7, x3

    #Address 0xdf7 read value
    csrr x14, 0xdf7

    #Unmapped address 0xd71 testing: Read Reset + Random data Write/Read
    #Address 0xd71 read value
    csrr x14, 0xd71

    #Address 0xd71 Write value 0x294f02f9
    li x3, 0x294f02f9
    csrw 0xd71, x3

    #Address 0xd71 read value
    csrr x14, 0xd71

    #Unmapped address 0x584 testing: Read Reset + Random data Write/Read
    #Address 0x584 read value
    csrr x14, 0x584

    #Address 0x584 Write value 0x573f5687
    li x3, 0x573f5687
    csrw 0x584, x3

    #Address 0x584 read value
    csrr x14, 0x584

    #Unmapped address 0x36 testing: Read Reset + Random data Write/Read
    #Address 0x36 read value
    csrr x14, 0x36

    #Address 0x36 Write value 0x6ed1847d
    li x3, 0x6ed1847d
    csrw 0x36, x3

    #Address 0x36 read value
    csrr x14, 0x36

    #Unmapped address 0x9a3 testing: Read Reset + Random data Write/Read
    #Address 0x9a3 read value
    csrr x14, 0x9a3

    #Address 0x9a3 Write value 0x6befaf9d
    li x3, 0x6befaf9d
    csrw 0x9a3, x3

    #Address 0x9a3 read value
    csrr x14, 0x9a3

    #Unmapped address 0x5f testing: Read Reset + Random data Write/Read
    #Address 0x5f read value
    csrr x14, 0x5f

    #Address 0x5f Write value 0x6cf4bd6
    li x3, 0x6cf4bd6
    csrw 0x5f, x3

    #Address 0x5f read value
    csrr x14, 0x5f

    #Unmapped address 0xfb2 testing: Read Reset + Random data Write/Read
    #Address 0xfb2 read value
    csrr x14, 0xfb2

    #Address 0xfb2 Write value 0x55ead2d5
    li x3, 0x55ead2d5
    csrw 0xfb2, x3

    #Address 0xfb2 read value
    csrr x14, 0xfb2

    #Unmapped address 0xebf testing: Read Reset + Random data Write/Read
    #Address 0xebf read value
    csrr x14, 0xebf

    #Address 0xebf Write value 0x7678d2b9
    li x3, 0x7678d2b9
    csrw 0xebf, x3

    #Address 0xebf read value
    csrr x14, 0xebf

    #Unmapped address 0xc08 testing: Read Reset + Random data Write/Read
    #Address 0xc08 read value
    csrr x14, 0xc08

    #Address 0xc08 Write value 0xcb24a967
    li x3, 0xcb24a967
    csrw 0xc08, x3

    #Address 0xc08 read value
    csrr x14, 0xc08

    #Unmapped address 0x629 testing: Read Reset + Random data Write/Read
    #Address 0x629 read value
    csrr x14, 0x629

    #Address 0x629 Write value 0xfd08ac73
    li x3, 0xfd08ac73
    csrw 0x629, x3

    #Address 0x629 read value
    csrr x14, 0x629

    #Unmapped address 0x3ad testing: Read Reset + Random data Write/Read
    #Address 0x3ad read value
    csrr x14, 0x3ad

    #Address 0x3ad Write value 0x890749cb
    li x3, 0x890749cb
    csrw 0x3ad, x3

    #Address 0x3ad read value
    csrr x14, 0x3ad

    #Unmapped address 0xc8b testing: Read Reset + Random data Write/Read
    #Address 0xc8b read value
    csrr x14, 0xc8b

    #Address 0xc8b Write value 0x49ae3a10
    li x3, 0x49ae3a10
    csrw 0xc8b, x3

    #Address 0xc8b read value
    csrr x14, 0xc8b

    #Unmapped address 0xd28 testing: Read Reset + Random data Write/Read
    #Address 0xd28 read value
    csrr x14, 0xd28

    #Address 0xd28 Write value 0xe0e8b6d2
    li x3, 0xe0e8b6d2
    csrw 0xd28, x3

    #Address 0xd28 read value
    csrr x14, 0xd28

    #Unmapped address 0x168 testing: Read Reset + Random data Write/Read
    #Address 0x168 read value
    csrr x14, 0x168

    #Address 0x168 Write value 0x987c10b1
    li x3, 0x987c10b1
    csrw 0x168, x3

    #Address 0x168 read value
    csrr x14, 0x168

    #Unmapped address 0xa20 testing: Read Reset + Random data Write/Read
    #Address 0xa20 read value
    csrr x14, 0xa20

    #Address 0xa20 Write value 0x2a7bf9b3
    li x3, 0x2a7bf9b3
    csrw 0xa20, x3

    #Address 0xa20 read value
    csrr x14, 0xa20

    #Unmapped address 0x767 testing: Read Reset + Random data Write/Read
    #Address 0x767 read value
    csrr x14, 0x767

    #Address 0x767 Write value 0xfed4a99a
    li x3, 0xfed4a99a
    csrw 0x767, x3

    #Address 0x767 read value
    csrr x14, 0x767

    #Unmapped address 0x4ec testing: Read Reset + Random data Write/Read
    #Address 0x4ec read value
    csrr x14, 0x4ec

    #Address 0x4ec Write value 0x48eebc
    li x3, 0x48eebc
    csrw 0x4ec, x3

    #Address 0x4ec read value
    csrr x14, 0x4ec

    #Unmapped address 0x29c testing: Read Reset + Random data Write/Read
    #Address 0x29c read value
    csrr x14, 0x29c

    #Address 0x29c Write value 0x31eaef49
    li x3, 0x31eaef49
    csrw 0x29c, x3

    #Address 0x29c read value
    csrr x14, 0x29c

    #Unmapped address 0xf00 testing: Read Reset + Random data Write/Read
    #Address 0xf00 read value
    csrr x14, 0xf00

    #Address 0xf00 Write value 0x85d68eee
    li x3, 0x85d68eee
    csrw 0xf00, x3

    #Address 0xf00 read value
    csrr x14, 0xf00

    #Unmapped address 0x97a testing: Read Reset + Random data Write/Read
    #Address 0x97a read value
    csrr x14, 0x97a

    #Address 0x97a Write value 0x746f7e18
    li x3, 0x746f7e18
    csrw 0x97a, x3

    #Address 0x97a read value
    csrr x14, 0x97a

    #Unmapped address 0xc12 testing: Read Reset + Random data Write/Read
    #Address 0xc12 read value
    csrr x14, 0xc12

    #Address 0xc12 Write value 0x9343af98
    li x3, 0x9343af98
    csrw 0xc12, x3

    #Address 0xc12 read value
    csrr x14, 0xc12

    #Unmapped address 0x4b3 testing: Read Reset + Random data Write/Read
    #Address 0x4b3 read value
    csrr x14, 0x4b3

    #Address 0x4b3 Write value 0x986245e2
    li x3, 0x986245e2
    csrw 0x4b3, x3

    #Address 0x4b3 read value
    csrr x14, 0x4b3

    #Unmapped address 0x7a3 testing: Read Reset + Random data Write/Read
    #Address 0x7a3 read value
    csrr x14, 0x7a3

    #Address 0x7a3 Write value 0x55d723ac
    li x3, 0x55d723ac
    csrw 0x7a3, x3

    #Address 0x7a3 read value
    csrr x14, 0x7a3

    #Unmapped address 0xb73 testing: Read Reset + Random data Write/Read
    #Address 0xb73 read value
    csrr x14, 0xb73

    #Address 0xb73 Write value 0x36b9321d
    li x3, 0x36b9321d
    csrw 0xb73, x3

    #Address 0xb73 read value
    csrr x14, 0xb73

    #Unmapped address 0x3ff testing: Read Reset + Random data Write/Read
    #Address 0x3ff read value
    csrr x14, 0x3ff

    #Address 0x3ff Write value 0xbd29ccf5
    li x3, 0xbd29ccf5
    csrw 0x3ff, x3

    #Address 0x3ff read value
    csrr x14, 0x3ff

    #Unmapped address 0x2ac testing: Read Reset + Random data Write/Read
    #Address 0x2ac read value
    csrr x14, 0x2ac

    #Address 0x2ac Write value 0x5ee4169d
    li x3, 0x5ee4169d
    csrw 0x2ac, x3

    #Address 0x2ac read value
    csrr x14, 0x2ac

    #Unmapped address 0xc4f testing: Read Reset + Random data Write/Read
    #Address 0xc4f read value
    csrr x14, 0xc4f

    #Address 0xc4f Write value 0x811bf479
    li x3, 0x811bf479
    csrw 0xc4f, x3

    #Address 0xc4f read value
    csrr x14, 0xc4f

    #Unmapped address 0xa61 testing: Read Reset + Random data Write/Read
    #Address 0xa61 read value
    csrr x14, 0xa61

    #Address 0xa61 Write value 0x473b0291
    li x3, 0x473b0291
    csrw 0xa61, x3

    #Address 0xa61 read value
    csrr x14, 0xa61

    #Unmapped address 0x311 testing: Read Reset + Random data Write/Read
    #Address 0x311 read value
    csrr x14, 0x311

    #Address 0x311 Write value 0xba068d7
    li x3, 0xba068d7
    csrw 0x311, x3

    #Address 0x311 read value
    csrr x14, 0x311

    #Unmapped address 0x5c2 testing: Read Reset + Random data Write/Read
    #Address 0x5c2 read value
    csrr x14, 0x5c2

    #Address 0x5c2 Write value 0xd481e284
    li x3, 0xd481e284
    csrw 0x5c2, x3

    #Address 0x5c2 read value
    csrr x14, 0x5c2

    #Unmapped address 0x38 testing: Read Reset + Random data Write/Read
    #Address 0x38 read value
    csrr x14, 0x38

    #Address 0x38 Write value 0xafa6a614
    li x3, 0xafa6a614
    csrw 0x38, x3

    #Address 0x38 read value
    csrr x14, 0x38

    #Unmapped address 0x9b testing: Read Reset + Random data Write/Read
    #Address 0x9b read value
    csrr x14, 0x9b

    #Address 0x9b Write value 0xe3ece149
    li x3, 0xe3ece149
    csrw 0x9b, x3

    #Address 0x9b read value
    csrr x14, 0x9b

    #Unmapped address 0x8c5 testing: Read Reset + Random data Write/Read
    #Address 0x8c5 read value
    csrr x14, 0x8c5

    #Address 0x8c5 Write value 0x88ad6248
    li x3, 0x88ad6248
    csrw 0x8c5, x3

    #Address 0x8c5 read value
    csrr x14, 0x8c5

    #Unmapped address 0x594 testing: Read Reset + Random data Write/Read
    #Address 0x594 read value
    csrr x14, 0x594

    #Address 0x594 Write value 0x23be5707
    li x3, 0x23be5707
    csrw 0x594, x3

    #Address 0x594 read value
    csrr x14, 0x594

    #Unmapped address 0x389 testing: Read Reset + Random data Write/Read
    #Address 0x389 read value
    csrr x14, 0x389

    #Address 0x389 Write value 0xe290e5f2
    li x3, 0xe290e5f2
    csrw 0x389, x3

    #Address 0x389 read value
    csrr x14, 0x389

    #Unmapped address 0x392 testing: Read Reset + Random data Write/Read
    #Address 0x392 read value
    csrr x14, 0x392

    #Address 0x392 Write value 0xfa6332fd
    li x3, 0xfa6332fd
    csrw 0x392, x3

    #Address 0x392 read value
    csrr x14, 0x392

    #Unmapped address 0x8ff testing: Read Reset + Random data Write/Read
    #Address 0x8ff read value
    csrr x14, 0x8ff

    #Address 0x8ff Write value 0x78158060
    li x3, 0x78158060
    csrw 0x8ff, x3

    #Address 0x8ff read value
    csrr x14, 0x8ff

    #Unmapped address 0x653 testing: Read Reset + Random data Write/Read
    #Address 0x653 read value
    csrr x14, 0x653

    #Address 0x653 Write value 0xdca44a1
    li x3, 0xdca44a1
    csrw 0x653, x3

    #Address 0x653 read value
    csrr x14, 0x653

    #Unmapped address 0x354 testing: Read Reset + Random data Write/Read
    #Address 0x354 read value
    csrr x14, 0x354

    #Address 0x354 Write value 0x30b44bca
    li x3, 0x30b44bca
    csrw 0x354, x3

    #Address 0x354 read value
    csrr x14, 0x354

    #Unmapped address 0x9af testing: Read Reset + Random data Write/Read
    #Address 0x9af read value
    csrr x14, 0x9af

    #Address 0x9af Write value 0x42e8f5e1
    li x3, 0x42e8f5e1
    csrw 0x9af, x3

    #Address 0x9af read value
    csrr x14, 0x9af

    #Unmapped address 0xb39 testing: Read Reset + Random data Write/Read
    #Address 0xb39 read value
    csrr x14, 0xb39

    #Address 0xb39 Write value 0x91fbaab1
    li x3, 0x91fbaab1
    csrw 0xb39, x3

    #Address 0xb39 read value
    csrr x14, 0xb39

    #Unmapped address 0x9e3 testing: Read Reset + Random data Write/Read
    #Address 0x9e3 read value
    csrr x14, 0x9e3

    #Address 0x9e3 Write value 0x5ec4db7a
    li x3, 0x5ec4db7a
    csrw 0x9e3, x3

    #Address 0x9e3 read value
    csrr x14, 0x9e3

    #Unmapped address 0x3f7 testing: Read Reset + Random data Write/Read
    #Address 0x3f7 read value
    csrr x14, 0x3f7

    #Address 0x3f7 Write value 0x3264d560
    li x3, 0x3264d560
    csrw 0x3f7, x3

    #Address 0x3f7 read value
    csrr x14, 0x3f7

    #Unmapped address 0x7f testing: Read Reset + Random data Write/Read
    #Address 0x7f read value
    csrr x14, 0x7f

    #Address 0x7f Write value 0x547f975b
    li x3, 0x547f975b
    csrw 0x7f, x3

    #Address 0x7f read value
    csrr x14, 0x7f

    #Unmapped address 0x1ae testing: Read Reset + Random data Write/Read
    #Address 0x1ae read value
    csrr x14, 0x1ae

    #Address 0x1ae Write value 0x7ff49df7
    li x3, 0x7ff49df7
    csrw 0x1ae, x3

    #Address 0x1ae read value
    csrr x14, 0x1ae

    #Unmapped address 0x85b testing: Read Reset + Random data Write/Read
    #Address 0x85b read value
    csrr x14, 0x85b

    #Address 0x85b Write value 0x1a5bfb01
    li x3, 0x1a5bfb01
    csrw 0x85b, x3

    #Address 0x85b read value
    csrr x14, 0x85b

    #Unmapped address 0xbe7 testing: Read Reset + Random data Write/Read
    #Address 0xbe7 read value
    csrr x14, 0xbe7

    #Address 0xbe7 Write value 0xb0e497e6
    li x3, 0xb0e497e6
    csrw 0xbe7, x3

    #Address 0xbe7 read value
    csrr x14, 0xbe7

    #Unmapped address 0x911 testing: Read Reset + Random data Write/Read
    #Address 0x911 read value
    csrr x14, 0x911

    #Address 0x911 Write value 0x74a71e2f
    li x3, 0x74a71e2f
    csrw 0x911, x3

    #Address 0x911 read value
    csrr x14, 0x911

    #Unmapped address 0xa91 testing: Read Reset + Random data Write/Read
    #Address 0xa91 read value
    csrr x14, 0xa91

    #Address 0xa91 Write value 0x5284b23c
    li x3, 0x5284b23c
    csrw 0xa91, x3

    #Address 0xa91 read value
    csrr x14, 0xa91

    #Unmapped address 0xa6d testing: Read Reset + Random data Write/Read
    #Address 0xa6d read value
    csrr x14, 0xa6d

    #Address 0xa6d Write value 0x7ac6389e
    li x3, 0x7ac6389e
    csrw 0xa6d, x3

    #Address 0xa6d read value
    csrr x14, 0xa6d

    #Unmapped address 0x7eb testing: Read Reset + Random data Write/Read
    #Address 0x7eb read value
    csrr x14, 0x7eb

    #Address 0x7eb Write value 0x22b18f56
    li x3, 0x22b18f56
    csrw 0x7eb, x3

    #Address 0x7eb read value
    csrr x14, 0x7eb

    #Unmapped address 0x260 testing: Read Reset + Random data Write/Read
    #Address 0x260 read value
    csrr x14, 0x260

    #Address 0x260 Write value 0xe967bba7
    li x3, 0xe967bba7
    csrw 0x260, x3

    #Address 0x260 read value
    csrr x14, 0x260

    #Unmapped address 0x20a testing: Read Reset + Random data Write/Read
    #Address 0x20a read value
    csrr x14, 0x20a

    #Address 0x20a Write value 0x75a91e73
    li x3, 0x75a91e73
    csrw 0x20a, x3

    #Address 0x20a read value
    csrr x14, 0x20a

    #Unmapped address 0x7dd testing: Read Reset + Random data Write/Read
    #Address 0x7dd read value
    csrr x14, 0x7dd

    #Address 0x7dd Write value 0xdce4ad15
    li x3, 0xdce4ad15
    csrw 0x7dd, x3

    #Address 0x7dd read value
    csrr x14, 0x7dd

    #Unmapped address 0xd4 testing: Read Reset + Random data Write/Read
    #Address 0xd4 read value
    csrr x14, 0xd4

    #Address 0xd4 Write value 0x29d19016
    li x3, 0x29d19016
    csrw 0xd4, x3

    #Address 0xd4 read value
    csrr x14, 0xd4

    #Unmapped address 0xf1a testing: Read Reset + Random data Write/Read
    #Address 0xf1a read value
    csrr x14, 0xf1a

    #Address 0xf1a Write value 0x4fc84b65
    li x3, 0x4fc84b65
    csrw 0xf1a, x3

    #Address 0xf1a read value
    csrr x14, 0xf1a

    #Unmapped address 0x778 testing: Read Reset + Random data Write/Read
    #Address 0x778 read value
    csrr x14, 0x778

    #Address 0x778 Write value 0x552ece4a
    li x3, 0x552ece4a
    csrw 0x778, x3

    #Address 0x778 read value
    csrr x14, 0x778

    #Unmapped address 0x1a3 testing: Read Reset + Random data Write/Read
    #Address 0x1a3 read value
    csrr x14, 0x1a3

    #Address 0x1a3 Write value 0xce87a416
    li x3, 0xce87a416
    csrw 0x1a3, x3

    #Address 0x1a3 read value
    csrr x14, 0x1a3

    #Unmapped address 0xdec testing: Read Reset + Random data Write/Read
    #Address 0xdec read value
    csrr x14, 0xdec

    #Address 0xdec Write value 0xacd3ddc
    li x3, 0xacd3ddc
    csrw 0xdec, x3

    #Address 0xdec read value
    csrr x14, 0xdec

    #Unmapped address 0xc5f testing: Read Reset + Random data Write/Read
    #Address 0xc5f read value
    csrr x14, 0xc5f

    #Address 0xc5f Write value 0xf4e4b180
    li x3, 0xf4e4b180
    csrw 0xc5f, x3

    #Address 0xc5f read value
    csrr x14, 0xc5f

    #Unmapped address 0x838 testing: Read Reset + Random data Write/Read
    #Address 0x838 read value
    csrr x14, 0x838

    #Address 0x838 Write value 0xee857e8c
    li x3, 0xee857e8c
    csrw 0x838, x3

    #Address 0x838 read value
    csrr x14, 0x838

    #Unmapped address 0x6ff testing: Read Reset + Random data Write/Read
    #Address 0x6ff read value
    csrr x14, 0x6ff

    #Address 0x6ff Write value 0x9f31921
    li x3, 0x9f31921
    csrw 0x6ff, x3

    #Address 0x6ff read value
    csrr x14, 0x6ff

    #Unmapped address 0xab9 testing: Read Reset + Random data Write/Read
    #Address 0xab9 read value
    csrr x14, 0xab9

    #Address 0xab9 Write value 0x46a8784d
    li x3, 0x46a8784d
    csrw 0xab9, x3

    #Address 0xab9 read value
    csrr x14, 0xab9

    #Unmapped address 0xfdb testing: Read Reset + Random data Write/Read
    #Address 0xfdb read value
    csrr x14, 0xfdb

    #Address 0xfdb Write value 0x9e865fa0
    li x3, 0x9e865fa0
    csrw 0xfdb, x3

    #Address 0xfdb read value
    csrr x14, 0xfdb

    #Unmapped address 0xf42 testing: Read Reset + Random data Write/Read
    #Address 0xf42 read value
    csrr x14, 0xf42

    #Address 0xf42 Write value 0x5a753ed2
    li x3, 0x5a753ed2
    csrw 0xf42, x3

    #Address 0xf42 read value
    csrr x14, 0xf42

    #Unmapped address 0xf3b testing: Read Reset + Random data Write/Read
    #Address 0xf3b read value
    csrr x14, 0xf3b

    #Address 0xf3b Write value 0x4aa49007
    li x3, 0x4aa49007
    csrw 0xf3b, x3

    #Address 0xf3b read value
    csrr x14, 0xf3b

    #Unmapped address 0x525 testing: Read Reset + Random data Write/Read
    #Address 0x525 read value
    csrr x14, 0x525

    #Address 0x525 Write value 0x7b8631d6
    li x3, 0x7b8631d6
    csrw 0x525, x3

    #Address 0x525 read value
    csrr x14, 0x525

    #Unmapped address 0xa6b testing: Read Reset + Random data Write/Read
    #Address 0xa6b read value
    csrr x14, 0xa6b

    #Address 0xa6b Write value 0x514bb006
    li x3, 0x514bb006
    csrw 0xa6b, x3

    #Address 0xa6b read value
    csrr x14, 0xa6b

    #Unmapped address 0x81b testing: Read Reset + Random data Write/Read
    #Address 0x81b read value
    csrr x14, 0x81b

    #Address 0x81b Write value 0x2214fe4f
    li x3, 0x2214fe4f
    csrw 0x81b, x3

    #Address 0x81b read value
    csrr x14, 0x81b

    #Unmapped address 0x3ed testing: Read Reset + Random data Write/Read
    #Address 0x3ed read value
    csrr x14, 0x3ed

    #Address 0x3ed Write value 0x37a67789
    li x3, 0x37a67789
    csrw 0x3ed, x3

    #Address 0x3ed read value
    csrr x14, 0x3ed

    #Unmapped address 0x900 testing: Read Reset + Random data Write/Read
    #Address 0x900 read value
    csrr x14, 0x900

    #Address 0x900 Write value 0xfe4dc7e
    li x3, 0xfe4dc7e
    csrw 0x900, x3

    #Address 0x900 read value
    csrr x14, 0x900

    #Unmapped address 0x9be testing: Read Reset + Random data Write/Read
    #Address 0x9be read value
    csrr x14, 0x9be

    #Address 0x9be Write value 0x9112d9a3
    li x3, 0x9112d9a3
    csrw 0x9be, x3

    #Address 0x9be read value
    csrr x14, 0x9be

    #Unmapped address 0xbd5 testing: Read Reset + Random data Write/Read
    #Address 0xbd5 read value
    csrr x14, 0xbd5

    #Address 0xbd5 Write value 0xa5961150
    li x3, 0xa5961150
    csrw 0xbd5, x3

    #Address 0xbd5 read value
    csrr x14, 0xbd5

    #Unmapped address 0xa5a testing: Read Reset + Random data Write/Read
    #Address 0xa5a read value
    csrr x14, 0xa5a

    #Address 0xa5a Write value 0x87da5556
    li x3, 0x87da5556
    csrw 0xa5a, x3

    #Address 0xa5a read value
    csrr x14, 0xa5a

    #Unmapped address 0x393 testing: Read Reset + Random data Write/Read
    #Address 0x393 read value
    csrr x14, 0x393

    #Address 0x393 Write value 0x212a6e88
    li x3, 0x212a6e88
    csrw 0x393, x3

    #Address 0x393 read value
    csrr x14, 0x393

    #Unmapped address 0x3f6 testing: Read Reset + Random data Write/Read
    #Address 0x3f6 read value
    csrr x14, 0x3f6

    #Address 0x3f6 Write value 0x798d2dd4
    li x3, 0x798d2dd4
    csrw 0x3f6, x3

    #Address 0x3f6 read value
    csrr x14, 0x3f6

    #Unmapped address 0xd12 testing: Read Reset + Random data Write/Read
    #Address 0xd12 read value
    csrr x14, 0xd12

    #Address 0xd12 Write value 0x13acf438
    li x3, 0x13acf438
    csrw 0xd12, x3

    #Address 0xd12 read value
    csrr x14, 0xd12

    #Unmapped address 0x6e8 testing: Read Reset + Random data Write/Read
    #Address 0x6e8 read value
    csrr x14, 0x6e8

    #Address 0x6e8 Write value 0xd6094a42
    li x3, 0xd6094a42
    csrw 0x6e8, x3

    #Address 0x6e8 read value
    csrr x14, 0x6e8

    #Unmapped address 0xb4e testing: Read Reset + Random data Write/Read
    #Address 0xb4e read value
    csrr x14, 0xb4e

    #Address 0xb4e Write value 0x9de77a49
    li x3, 0x9de77a49
    csrw 0xb4e, x3

    #Address 0xb4e read value
    csrr x14, 0xb4e

    #Unmapped address 0xb62 testing: Read Reset + Random data Write/Read
    #Address 0xb62 read value
    csrr x14, 0xb62

    #Address 0xb62 Write value 0xd47f8b0f
    li x3, 0xd47f8b0f
    csrw 0xb62, x3

    #Address 0xb62 read value
    csrr x14, 0xb62

    #Unmapped address 0xdd2 testing: Read Reset + Random data Write/Read
    #Address 0xdd2 read value
    csrr x14, 0xdd2

    #Address 0xdd2 Write value 0x61d0d71e
    li x3, 0x61d0d71e
    csrw 0xdd2, x3

    #Address 0xdd2 read value
    csrr x14, 0xdd2

    #Unmapped address 0xfed testing: Read Reset + Random data Write/Read
    #Address 0xfed read value
    csrr x14, 0xfed

    #Address 0xfed Write value 0xbc4305dd
    li x3, 0xbc4305dd
    csrw 0xfed, x3

    #Address 0xfed read value
    csrr x14, 0xfed

    #Unmapped address 0xcad testing: Read Reset + Random data Write/Read
    #Address 0xcad read value
    csrr x14, 0xcad

    #Address 0xcad Write value 0xb510ce56
    li x3, 0xb510ce56
    csrw 0xcad, x3

    #Address 0xcad read value
    csrr x14, 0xcad

    #Unmapped address 0x54b testing: Read Reset + Random data Write/Read
    #Address 0x54b read value
    csrr x14, 0x54b

    #Address 0x54b Write value 0xf4b06f06
    li x3, 0xf4b06f06
    csrw 0x54b, x3

    #Address 0x54b read value
    csrr x14, 0x54b

    #Unmapped address 0x88d testing: Read Reset + Random data Write/Read
    #Address 0x88d read value
    csrr x14, 0x88d

    #Address 0x88d Write value 0xdcf9dea6
    li x3, 0xdcf9dea6
    csrw 0x88d, x3

    #Address 0x88d read value
    csrr x14, 0x88d

    #Unmapped address 0xbf9 testing: Read Reset + Random data Write/Read
    #Address 0xbf9 read value
    csrr x14, 0xbf9

    #Address 0xbf9 Write value 0x1505d528
    li x3, 0x1505d528
    csrw 0xbf9, x3

    #Address 0xbf9 read value
    csrr x14, 0xbf9

    #Unmapped address 0xf01 testing: Read Reset + Random data Write/Read
    #Address 0xf01 read value
    csrr x14, 0xf01

    #Address 0xf01 Write value 0xb7c43103
    li x3, 0xb7c43103
    csrw 0xf01, x3

    #Address 0xf01 read value
    csrr x14, 0xf01

    #Unmapped address 0x22e testing: Read Reset + Random data Write/Read
    #Address 0x22e read value
    csrr x14, 0x22e

    #Address 0x22e Write value 0x1e3322a5
    li x3, 0x1e3322a5
    csrw 0x22e, x3

    #Address 0x22e read value
    csrr x14, 0x22e

    #Unmapped address 0x5c5 testing: Read Reset + Random data Write/Read
    #Address 0x5c5 read value
    csrr x14, 0x5c5

    #Address 0x5c5 Write value 0x21b1c858
    li x3, 0x21b1c858
    csrw 0x5c5, x3

    #Address 0x5c5 read value
    csrr x14, 0x5c5

    #Unmapped address 0xff2 testing: Read Reset + Random data Write/Read
    #Address 0xff2 read value
    csrr x14, 0xff2

    #Address 0xff2 Write value 0xa6c577da
    li x3, 0xa6c577da
    csrw 0xff2, x3

    #Address 0xff2 read value
    csrr x14, 0xff2

    #Unmapped address 0x3cc testing: Read Reset + Random data Write/Read
    #Address 0x3cc read value
    csrr x14, 0x3cc

    #Address 0x3cc Write value 0xcc410859
    li x3, 0xcc410859
    csrw 0x3cc, x3

    #Address 0x3cc read value
    csrr x14, 0x3cc

    #Unmapped address 0x99c testing: Read Reset + Random data Write/Read
    #Address 0x99c read value
    csrr x14, 0x99c

    #Address 0x99c Write value 0xae176731
    li x3, 0xae176731
    csrw 0x99c, x3

    #Address 0x99c read value
    csrr x14, 0x99c

    #Unmapped address 0x2e3 testing: Read Reset + Random data Write/Read
    #Address 0x2e3 read value
    csrr x14, 0x2e3

    #Address 0x2e3 Write value 0x34b0c3f8
    li x3, 0x34b0c3f8
    csrw 0x2e3, x3

    #Address 0x2e3 read value
    csrr x14, 0x2e3

    #Unmapped address 0x55a testing: Read Reset + Random data Write/Read
    #Address 0x55a read value
    csrr x14, 0x55a

    #Address 0x55a Write value 0xc79c21d3
    li x3, 0xc79c21d3
    csrw 0x55a, x3

    #Address 0x55a read value
    csrr x14, 0x55a

    #Unmapped address 0xeda testing: Read Reset + Random data Write/Read
    #Address 0xeda read value
    csrr x14, 0xeda

    #Address 0xeda Write value 0x5afc214e
    li x3, 0x5afc214e
    csrw 0xeda, x3

    #Address 0xeda read value
    csrr x14, 0xeda

    #Unmapped address 0xeca testing: Read Reset + Random data Write/Read
    #Address 0xeca read value
    csrr x14, 0xeca

    #Address 0xeca Write value 0x9683bf2b
    li x3, 0x9683bf2b
    csrw 0xeca, x3

    #Address 0xeca read value
    csrr x14, 0xeca

    #Unmapped address 0x4d2 testing: Read Reset + Random data Write/Read
    #Address 0x4d2 read value
    csrr x14, 0x4d2

    #Address 0x4d2 Write value 0x72860691
    li x3, 0x72860691
    csrw 0x4d2, x3

    #Address 0x4d2 read value
    csrr x14, 0x4d2

    #Unmapped address 0x7e testing: Read Reset + Random data Write/Read
    #Address 0x7e read value
    csrr x14, 0x7e

    #Address 0x7e Write value 0x5b82c0c2
    li x3, 0x5b82c0c2
    csrw 0x7e, x3

    #Address 0x7e read value
    csrr x14, 0x7e

    #Unmapped address 0x53c testing: Read Reset + Random data Write/Read
    #Address 0x53c read value
    csrr x14, 0x53c

    #Address 0x53c Write value 0x9168b8e1
    li x3, 0x9168b8e1
    csrw 0x53c, x3

    #Address 0x53c read value
    csrr x14, 0x53c

    #Unmapped address 0x9d6 testing: Read Reset + Random data Write/Read
    #Address 0x9d6 read value
    csrr x14, 0x9d6

    #Address 0x9d6 Write value 0x35c4b01b
    li x3, 0x35c4b01b
    csrw 0x9d6, x3

    #Address 0x9d6 read value
    csrr x14, 0x9d6

    #Unmapped address 0x6c0 testing: Read Reset + Random data Write/Read
    #Address 0x6c0 read value
    csrr x14, 0x6c0

    #Address 0x6c0 Write value 0xeb8ed879
    li x3, 0xeb8ed879
    csrw 0x6c0, x3

    #Address 0x6c0 read value
    csrr x14, 0x6c0

    #Unmapped address 0x243 testing: Read Reset + Random data Write/Read
    #Address 0x243 read value
    csrr x14, 0x243

    #Address 0x243 Write value 0xe2dd77a3
    li x3, 0xe2dd77a3
    csrw 0x243, x3

    #Address 0x243 read value
    csrr x14, 0x243

    #Unmapped address 0x960 testing: Read Reset + Random data Write/Read
    #Address 0x960 read value
    csrr x14, 0x960

    #Address 0x960 Write value 0x61938e18
    li x3, 0x61938e18
    csrw 0x960, x3

    #Address 0x960 read value
    csrr x14, 0x960

    #Unmapped address 0xfa4 testing: Read Reset + Random data Write/Read
    #Address 0xfa4 read value
    csrr x14, 0xfa4

    #Address 0xfa4 Write value 0xe411987b
    li x3, 0xe411987b
    csrw 0xfa4, x3

    #Address 0xfa4 read value
    csrr x14, 0xfa4

    #Unmapped address 0xf2b testing: Read Reset + Random data Write/Read
    #Address 0xf2b read value
    csrr x14, 0xf2b

    #Address 0xf2b Write value 0x89e21239
    li x3, 0x89e21239
    csrw 0xf2b, x3

    #Address 0xf2b read value
    csrr x14, 0xf2b

    #Unmapped address 0xa7b testing: Read Reset + Random data Write/Read
    #Address 0xa7b read value
    csrr x14, 0xa7b

    #Address 0xa7b Write value 0x6bedfa76
    li x3, 0x6bedfa76
    csrw 0xa7b, x3

    #Address 0xa7b read value
    csrr x14, 0xa7b

    #Unmapped address 0x373 testing: Read Reset + Random data Write/Read
    #Address 0x373 read value
    csrr x14, 0x373

    #Address 0x373 Write value 0x620414ed
    li x3, 0x620414ed
    csrw 0x373, x3

    #Address 0x373 read value
    csrr x14, 0x373

    #Unmapped address 0x9c0 testing: Read Reset + Random data Write/Read
    #Address 0x9c0 read value
    csrr x14, 0x9c0

    #Address 0x9c0 Write value 0x974a7779
    li x3, 0x974a7779
    csrw 0x9c0, x3

    #Address 0x9c0 read value
    csrr x14, 0x9c0

    #Unmapped address 0x928 testing: Read Reset + Random data Write/Read
    #Address 0x928 read value
    csrr x14, 0x928

    #Address 0x928 Write value 0x1c708da7
    li x3, 0x1c708da7
    csrw 0x928, x3

    #Address 0x928 read value
    csrr x14, 0x928

    #Unmapped address 0xb4 testing: Read Reset + Random data Write/Read
    #Address 0xb4 read value
    csrr x14, 0xb4

    #Address 0xb4 Write value 0xd2ab97c2
    li x3, 0xd2ab97c2
    csrw 0xb4, x3

    #Address 0xb4 read value
    csrr x14, 0xb4

    #Unmapped address 0x95e testing: Read Reset + Random data Write/Read
    #Address 0x95e read value
    csrr x14, 0x95e

    #Address 0x95e Write value 0x56655d2a
    li x3, 0x56655d2a
    csrw 0x95e, x3

    #Address 0x95e read value
    csrr x14, 0x95e

    #Unmapped address 0xd61 testing: Read Reset + Random data Write/Read
    #Address 0xd61 read value
    csrr x14, 0xd61

    #Address 0xd61 Write value 0x2404b4d3
    li x3, 0x2404b4d3
    csrw 0xd61, x3

    #Address 0xd61 read value
    csrr x14, 0xd61

    #Unmapped address 0x469 testing: Read Reset + Random data Write/Read
    #Address 0x469 read value
    csrr x14, 0x469

    #Address 0x469 Write value 0x597cc89f
    li x3, 0x597cc89f
    csrw 0x469, x3

    #Address 0x469 read value
    csrr x14, 0x469

    #Unmapped address 0x5 testing: Read Reset + Random data Write/Read
    #Address 0x5 read value
    csrr x14, 0x5

    #Address 0x5 Write value 0x7dd82ab2
    li x3, 0x7dd82ab2
    csrw 0x5, x3

    #Address 0x5 read value
    csrr x14, 0x5

    #Unmapped address 0xfcd testing: Read Reset + Random data Write/Read
    #Address 0xfcd read value
    csrr x14, 0xfcd

    #Address 0xfcd Write value 0xe3367ce0
    li x3, 0xe3367ce0
    csrw 0xfcd, x3

    #Address 0xfcd read value
    csrr x14, 0xfcd

    #Unmapped address 0x67a testing: Read Reset + Random data Write/Read
    #Address 0x67a read value
    csrr x14, 0x67a

    #Address 0x67a Write value 0x70c1ff23
    li x3, 0x70c1ff23
    csrw 0x67a, x3

    #Address 0x67a read value
    csrr x14, 0x67a

    #Unmapped address 0x7ae testing: Read Reset + Random data Write/Read
    #Address 0x7ae read value
    csrr x14, 0x7ae

    #Address 0x7ae Write value 0x4f021a86
    li x3, 0x4f021a86
    csrw 0x7ae, x3

    #Address 0x7ae read value
    csrr x14, 0x7ae

    #Unmapped address 0xaa8 testing: Read Reset + Random data Write/Read
    #Address 0xaa8 read value
    csrr x14, 0xaa8

    #Address 0xaa8 Write value 0x2c0e307f
    li x3, 0x2c0e307f
    csrw 0xaa8, x3

    #Address 0xaa8 read value
    csrr x14, 0xaa8

    #Unmapped address 0x949 testing: Read Reset + Random data Write/Read
    #Address 0x949 read value
    csrr x14, 0x949

    #Address 0x949 Write value 0x24a05275
    li x3, 0x24a05275
    csrw 0x949, x3

    #Address 0x949 read value
    csrr x14, 0x949

    #Unmapped address 0x98f testing: Read Reset + Random data Write/Read
    #Address 0x98f read value
    csrr x14, 0x98f

    #Address 0x98f Write value 0x9e433650
    li x3, 0x9e433650
    csrw 0x98f, x3

    #Address 0x98f read value
    csrr x14, 0x98f

    #Unmapped address 0x3fb testing: Read Reset + Random data Write/Read
    #Address 0x3fb read value
    csrr x14, 0x3fb

    #Address 0x3fb Write value 0x707e9940
    li x3, 0x707e9940
    csrw 0x3fb, x3

    #Address 0x3fb read value
    csrr x14, 0x3fb

    #Unmapped address 0x830 testing: Read Reset + Random data Write/Read
    #Address 0x830 read value
    csrr x14, 0x830

    #Address 0x830 Write value 0xa346213d
    li x3, 0xa346213d
    csrw 0x830, x3

    #Address 0x830 read value
    csrr x14, 0x830

    #Unmapped address 0xafa testing: Read Reset + Random data Write/Read
    #Address 0xafa read value
    csrr x14, 0xafa

    #Address 0xafa Write value 0x2205ca36
    li x3, 0x2205ca36
    csrw 0xafa, x3

    #Address 0xafa read value
    csrr x14, 0xafa

    #Unmapped address 0xb6a testing: Read Reset + Random data Write/Read
    #Address 0xb6a read value
    csrr x14, 0xb6a

    #Address 0xb6a Write value 0x50d2052d
    li x3, 0x50d2052d
    csrw 0xb6a, x3

    #Address 0xb6a read value
    csrr x14, 0xb6a

    #Unmapped address 0xd97 testing: Read Reset + Random data Write/Read
    #Address 0xd97 read value
    csrr x14, 0xd97

    #Address 0xd97 Write value 0xc2480a5e
    li x3, 0xc2480a5e
    csrw 0xd97, x3

    #Address 0xd97 read value
    csrr x14, 0xd97

    #Unmapped address 0xac testing: Read Reset + Random data Write/Read
    #Address 0xac read value
    csrr x14, 0xac

    #Address 0xac Write value 0xc4090fbe
    li x3, 0xc4090fbe
    csrw 0xac, x3

    #Address 0xac read value
    csrr x14, 0xac

    #Unmapped address 0x6a2 testing: Read Reset + Random data Write/Read
    #Address 0x6a2 read value
    csrr x14, 0x6a2

    #Address 0x6a2 Write value 0x807c3249
    li x3, 0x807c3249
    csrw 0x6a2, x3

    #Address 0x6a2 read value
    csrr x14, 0x6a2

    #Unmapped address 0x254 testing: Read Reset + Random data Write/Read
    #Address 0x254 read value
    csrr x14, 0x254

    #Address 0x254 Write value 0x8868ead6
    li x3, 0x8868ead6
    csrw 0x254, x3

    #Address 0x254 read value
    csrr x14, 0x254

    #Unmapped address 0xbe8 testing: Read Reset + Random data Write/Read
    #Address 0xbe8 read value
    csrr x14, 0xbe8

    #Address 0xbe8 Write value 0x3b415f8d
    li x3, 0x3b415f8d
    csrw 0xbe8, x3

    #Address 0xbe8 read value
    csrr x14, 0xbe8

    #Unmapped address 0xdeb testing: Read Reset + Random data Write/Read
    #Address 0xdeb read value
    csrr x14, 0xdeb

    #Address 0xdeb Write value 0xe57a6e19
    li x3, 0xe57a6e19
    csrw 0xdeb, x3

    #Address 0xdeb read value
    csrr x14, 0xdeb

    #Unmapped address 0xc9e testing: Read Reset + Random data Write/Read
    #Address 0xc9e read value
    csrr x14, 0xc9e

    #Address 0xc9e Write value 0xb2b15726
    li x3, 0xb2b15726
    csrw 0xc9e, x3

    #Address 0xc9e read value
    csrr x14, 0xc9e

    #Unmapped address 0xe9a testing: Read Reset + Random data Write/Read
    #Address 0xe9a read value
    csrr x14, 0xe9a

    #Address 0xe9a Write value 0x42217f35
    li x3, 0x42217f35
    csrw 0xe9a, x3

    #Address 0xe9a read value
    csrr x14, 0xe9a

    #Unmapped address 0xfd2 testing: Read Reset + Random data Write/Read
    #Address 0xfd2 read value
    csrr x14, 0xfd2

    #Address 0xfd2 Write value 0x8b32ced0
    li x3, 0x8b32ced0
    csrw 0xfd2, x3

    #Address 0xfd2 read value
    csrr x14, 0xfd2

    #Unmapped address 0x17f testing: Read Reset + Random data Write/Read
    #Address 0x17f read value
    csrr x14, 0x17f

    #Address 0x17f Write value 0xc8e07357
    li x3, 0xc8e07357
    csrw 0x17f, x3

    #Address 0x17f read value
    csrr x14, 0x17f

    #Unmapped address 0x54d testing: Read Reset + Random data Write/Read
    #Address 0x54d read value
    csrr x14, 0x54d

    #Address 0x54d Write value 0xdbcf4053
    li x3, 0xdbcf4053
    csrw 0x54d, x3

    #Address 0x54d read value
    csrr x14, 0x54d

    #Unmapped address 0x485 testing: Read Reset + Random data Write/Read
    #Address 0x485 read value
    csrr x14, 0x485

    #Address 0x485 Write value 0x17096674
    li x3, 0x17096674
    csrw 0x485, x3

    #Address 0x485 read value
    csrr x14, 0x485

    #Unmapped address 0xc4e testing: Read Reset + Random data Write/Read
    #Address 0xc4e read value
    csrr x14, 0xc4e

    #Address 0xc4e Write value 0xf7cb1447
    li x3, 0xf7cb1447
    csrw 0xc4e, x3

    #Address 0xc4e read value
    csrr x14, 0xc4e

    #Unmapped address 0xd0c testing: Read Reset + Random data Write/Read
    #Address 0xd0c read value
    csrr x14, 0xd0c

    #Address 0xd0c Write value 0xdf3a7948
    li x3, 0xdf3a7948
    csrw 0xd0c, x3

    #Address 0xd0c read value
    csrr x14, 0xd0c

    #Unmapped address 0xf9c testing: Read Reset + Random data Write/Read
    #Address 0xf9c read value
    csrr x14, 0xf9c

    #Address 0xf9c Write value 0xc84e5b19
    li x3, 0xc84e5b19
    csrw 0xf9c, x3

    #Address 0xf9c read value
    csrr x14, 0xf9c

    #Unmapped address 0xc78 testing: Read Reset + Random data Write/Read
    #Address 0xc78 read value
    csrr x14, 0xc78

    #Address 0xc78 Write value 0x4045e4a7
    li x3, 0x4045e4a7
    csrw 0xc78, x3

    #Address 0xc78 read value
    csrr x14, 0xc78

    #Unmapped address 0x70f testing: Read Reset + Random data Write/Read
    #Address 0x70f read value
    csrr x14, 0x70f

    #Address 0x70f Write value 0x7bde714b
    li x3, 0x7bde714b
    csrw 0x70f, x3

    #Address 0x70f read value
    csrr x14, 0x70f

    #Unmapped address 0x854 testing: Read Reset + Random data Write/Read
    #Address 0x854 read value
    csrr x14, 0x854

    #Address 0x854 Write value 0x1a61ad36
    li x3, 0x1a61ad36
    csrw 0x854, x3

    #Address 0x854 read value
    csrr x14, 0x854

    #Unmapped address 0xa66 testing: Read Reset + Random data Write/Read
    #Address 0xa66 read value
    csrr x14, 0xa66

    #Address 0xa66 Write value 0xdff24635
    li x3, 0xdff24635
    csrw 0xa66, x3

    #Address 0xa66 read value
    csrr x14, 0xa66

    #Unmapped address 0xdbb testing: Read Reset + Random data Write/Read
    #Address 0xdbb read value
    csrr x14, 0xdbb

    #Address 0xdbb Write value 0x100134c7
    li x3, 0x100134c7
    csrw 0xdbb, x3

    #Address 0xdbb read value
    csrr x14, 0xdbb

    #Unmapped address 0x14d testing: Read Reset + Random data Write/Read
    #Address 0x14d read value
    csrr x14, 0x14d

    #Address 0x14d Write value 0x2820744e
    li x3, 0x2820744e
    csrw 0x14d, x3

    #Address 0x14d read value
    csrr x14, 0x14d

    #Unmapped address 0x585 testing: Read Reset + Random data Write/Read
    #Address 0x585 read value
    csrr x14, 0x585

    #Address 0x585 Write value 0xcdf69154
    li x3, 0xcdf69154
    csrw 0x585, x3

    #Address 0x585 read value
    csrr x14, 0x585

    #Unmapped address 0x8be testing: Read Reset + Random data Write/Read
    #Address 0x8be read value
    csrr x14, 0x8be

    #Address 0x8be Write value 0x5e12ad3
    li x3, 0x5e12ad3
    csrw 0x8be, x3

    #Address 0x8be read value
    csrr x14, 0x8be

    #Unmapped address 0xdb9 testing: Read Reset + Random data Write/Read
    #Address 0xdb9 read value
    csrr x14, 0xdb9

    #Address 0xdb9 Write value 0x24947501
    li x3, 0x24947501
    csrw 0xdb9, x3

    #Address 0xdb9 read value
    csrr x14, 0xdb9

    #Unmapped address 0x968 testing: Read Reset + Random data Write/Read
    #Address 0x968 read value
    csrr x14, 0x968

    #Address 0x968 Write value 0x77c2867f
    li x3, 0x77c2867f
    csrw 0x968, x3

    #Address 0x968 read value
    csrr x14, 0x968

    #Unmapped address 0x6f7 testing: Read Reset + Random data Write/Read
    #Address 0x6f7 read value
    csrr x14, 0x6f7

    #Address 0x6f7 Write value 0x80d77c91
    li x3, 0x80d77c91
    csrw 0x6f7, x3

    #Address 0x6f7 read value
    csrr x14, 0x6f7

    #Unmapped address 0x353 testing: Read Reset + Random data Write/Read
    #Address 0x353 read value
    csrr x14, 0x353

    #Address 0x353 Write value 0x31f490dd
    li x3, 0x31f490dd
    csrw 0x353, x3

    #Address 0x353 read value
    csrr x14, 0x353

    #Unmapped address 0x49a testing: Read Reset + Random data Write/Read
    #Address 0x49a read value
    csrr x14, 0x49a

    #Address 0x49a Write value 0x7e41929e
    li x3, 0x7e41929e
    csrw 0x49a, x3

    #Address 0x49a read value
    csrr x14, 0x49a

    #Unmapped address 0xdad testing: Read Reset + Random data Write/Read
    #Address 0xdad read value
    csrr x14, 0xdad

    #Address 0xdad Write value 0x4bd38e28
    li x3, 0x4bd38e28
    csrw 0xdad, x3

    #Address 0xdad read value
    csrr x14, 0xdad

    #Unmapped address 0x695 testing: Read Reset + Random data Write/Read
    #Address 0x695 read value
    csrr x14, 0x695

    #Address 0x695 Write value 0x1b46e85a
    li x3, 0x1b46e85a
    csrw 0x695, x3

    #Address 0x695 read value
    csrr x14, 0x695

    #Unmapped address 0x432 testing: Read Reset + Random data Write/Read
    #Address 0x432 read value
    csrr x14, 0x432

    #Address 0x432 Write value 0xa74e2b97
    li x3, 0xa74e2b97
    csrw 0x432, x3

    #Address 0x432 read value
    csrr x14, 0x432

    #Unmapped address 0xf02 testing: Read Reset + Random data Write/Read
    #Address 0xf02 read value
    csrr x14, 0xf02

    #Address 0xf02 Write value 0x7b4c7dc9
    li x3, 0x7b4c7dc9
    csrw 0xf02, x3

    #Address 0xf02 read value
    csrr x14, 0xf02

    #Unmapped address 0x98a testing: Read Reset + Random data Write/Read
    #Address 0x98a read value
    csrr x14, 0x98a

    #Address 0x98a Write value 0xa0e95db1
    li x3, 0xa0e95db1
    csrw 0x98a, x3

    #Address 0x98a read value
    csrr x14, 0x98a

    #Unmapped address 0xe1d testing: Read Reset + Random data Write/Read
    #Address 0xe1d read value
    csrr x14, 0xe1d

    #Address 0xe1d Write value 0x2e008c24
    li x3, 0x2e008c24
    csrw 0xe1d, x3

    #Address 0xe1d read value
    csrr x14, 0xe1d

    #Unmapped address 0xd53 testing: Read Reset + Random data Write/Read
    #Address 0xd53 read value
    csrr x14, 0xd53

    #Address 0xd53 Write value 0x67cacbf4
    li x3, 0x67cacbf4
    csrw 0xd53, x3

    #Address 0xd53 read value
    csrr x14, 0xd53

    #Unmapped address 0x5fb testing: Read Reset + Random data Write/Read
    #Address 0x5fb read value
    csrr x14, 0x5fb

    #Address 0x5fb Write value 0x733fd8c6
    li x3, 0x733fd8c6
    csrw 0x5fb, x3

    #Address 0x5fb read value
    csrr x14, 0x5fb

    #Unmapped address 0x8f testing: Read Reset + Random data Write/Read
    #Address 0x8f read value
    csrr x14, 0x8f

    #Address 0x8f Write value 0xcacff108
    li x3, 0xcacff108
    csrw 0x8f, x3

    #Address 0x8f read value
    csrr x14, 0x8f

    #Unmapped address 0x7a6 testing: Read Reset + Random data Write/Read
    #Address 0x7a6 read value
    csrr x14, 0x7a6

    #Address 0x7a6 Write value 0x58dfbc7e
    li x3, 0x58dfbc7e
    csrw 0x7a6, x3

    #Address 0x7a6 read value
    csrr x14, 0x7a6

    #Unmapped address 0x5d0 testing: Read Reset + Random data Write/Read
    #Address 0x5d0 read value
    csrr x14, 0x5d0

    #Address 0x5d0 Write value 0xc05dc18d
    li x3, 0xc05dc18d
    csrw 0x5d0, x3

    #Address 0x5d0 read value
    csrr x14, 0x5d0

    #Unmapped address 0x858 testing: Read Reset + Random data Write/Read
    #Address 0x858 read value
    csrr x14, 0x858

    #Address 0x858 Write value 0x7555b5ea
    li x3, 0x7555b5ea
    csrw 0x858, x3

    #Address 0x858 read value
    csrr x14, 0x858

    #Unmapped address 0x5e2 testing: Read Reset + Random data Write/Read
    #Address 0x5e2 read value
    csrr x14, 0x5e2

    #Address 0x5e2 Write value 0xc6fa698a
    li x3, 0xc6fa698a
    csrw 0x5e2, x3

    #Address 0x5e2 read value
    csrr x14, 0x5e2

    #Unmapped address 0x494 testing: Read Reset + Random data Write/Read
    #Address 0x494 read value
    csrr x14, 0x494

    #Address 0x494 Write value 0x983ce874
    li x3, 0x983ce874
    csrw 0x494, x3

    #Address 0x494 read value
    csrr x14, 0x494

    #Unmapped address 0x49c testing: Read Reset + Random data Write/Read
    #Address 0x49c read value
    csrr x14, 0x49c

    #Address 0x49c Write value 0x9d9bffbb
    li x3, 0x9d9bffbb
    csrw 0x49c, x3

    #Address 0x49c read value
    csrr x14, 0x49c

    #Unmapped address 0xff testing: Read Reset + Random data Write/Read
    #Address 0xff read value
    csrr x14, 0xff

    #Address 0xff Write value 0x649ee361
    li x3, 0x649ee361
    csrw 0xff, x3

    #Address 0xff read value
    csrr x14, 0xff

    #Unmapped address 0x80a testing: Read Reset + Random data Write/Read
    #Address 0x80a read value
    csrr x14, 0x80a

    #Address 0x80a Write value 0xbe94791f
    li x3, 0xbe94791f
    csrw 0x80a, x3

    #Address 0x80a read value
    csrr x14, 0x80a

    #Unmapped address 0x63c testing: Read Reset + Random data Write/Read
    #Address 0x63c read value
    csrr x14, 0x63c

    #Address 0x63c Write value 0xbacdfed5
    li x3, 0xbacdfed5
    csrw 0x63c, x3

    #Address 0x63c read value
    csrr x14, 0x63c

    #Unmapped address 0x703 testing: Read Reset + Random data Write/Read
    #Address 0x703 read value
    csrr x14, 0x703

    #Address 0x703 Write value 0x58247800
    li x3, 0x58247800
    csrw 0x703, x3

    #Address 0x703 read value
    csrr x14, 0x703

    #Unmapped address 0xfaf testing: Read Reset + Random data Write/Read
    #Address 0xfaf read value
    csrr x14, 0xfaf

    #Address 0xfaf Write value 0x11ca2aa9
    li x3, 0x11ca2aa9
    csrw 0xfaf, x3

    #Address 0xfaf read value
    csrr x14, 0xfaf

    #Unmapped address 0x89a testing: Read Reset + Random data Write/Read
    #Address 0x89a read value
    csrr x14, 0x89a

    #Address 0x89a Write value 0x57478d62
    li x3, 0x57478d62
    csrw 0x89a, x3

    #Address 0x89a read value
    csrr x14, 0x89a

    #Unmapped address 0x200 testing: Read Reset + Random data Write/Read
    #Address 0x200 read value
    csrr x14, 0x200

    #Address 0x200 Write value 0x20841356
    li x3, 0x20841356
    csrw 0x200, x3

    #Address 0x200 read value
    csrr x14, 0x200

    #Unmapped address 0xfc6 testing: Read Reset + Random data Write/Read
    #Address 0xfc6 read value
    csrr x14, 0xfc6

    #Address 0xfc6 Write value 0x8f066f9
    li x3, 0x8f066f9
    csrw 0xfc6, x3

    #Address 0xfc6 read value
    csrr x14, 0xfc6

    #Unmapped address 0x92 testing: Read Reset + Random data Write/Read
    #Address 0x92 read value
    csrr x14, 0x92

    #Address 0x92 Write value 0x3c2a8894
    li x3, 0x3c2a8894
    csrw 0x92, x3

    #Address 0x92 read value
    csrr x14, 0x92

    #Unmapped address 0x2ce testing: Read Reset + Random data Write/Read
    #Address 0x2ce read value
    csrr x14, 0x2ce

    #Address 0x2ce Write value 0xf9ea6f5d
    li x3, 0xf9ea6f5d
    csrw 0x2ce, x3

    #Address 0x2ce read value
    csrr x14, 0x2ce

    #Unmapped address 0x65 testing: Read Reset + Random data Write/Read
    #Address 0x65 read value
    csrr x14, 0x65

    #Address 0x65 Write value 0x1f6cd95a
    li x3, 0x1f6cd95a
    csrw 0x65, x3

    #Address 0x65 read value
    csrr x14, 0x65

    #Unmapped address 0xd1d testing: Read Reset + Random data Write/Read
    #Address 0xd1d read value
    csrr x14, 0xd1d

    #Address 0xd1d Write value 0x7d1fb18a
    li x3, 0x7d1fb18a
    csrw 0xd1d, x3

    #Address 0xd1d read value
    csrr x14, 0xd1d

    #Unmapped address 0x923 testing: Read Reset + Random data Write/Read
    #Address 0x923 read value
    csrr x14, 0x923

    #Address 0x923 Write value 0x4e75d39e
    li x3, 0x4e75d39e
    csrw 0x923, x3

    #Address 0x923 read value
    csrr x14, 0x923

    #Unmapped address 0xbc8 testing: Read Reset + Random data Write/Read
    #Address 0xbc8 read value
    csrr x14, 0xbc8

    #Address 0xbc8 Write value 0x79c450d8
    li x3, 0x79c450d8
    csrw 0xbc8, x3

    #Address 0xbc8 read value
    csrr x14, 0xbc8

    #Unmapped address 0x68 testing: Read Reset + Random data Write/Read
    #Address 0x68 read value
    csrr x14, 0x68

    #Address 0x68 Write value 0xe1aa7b50
    li x3, 0xe1aa7b50
    csrw 0x68, x3

    #Address 0x68 read value
    csrr x14, 0x68

    #Unmapped address 0xe5f testing: Read Reset + Random data Write/Read
    #Address 0xe5f read value
    csrr x14, 0xe5f

    #Address 0xe5f Write value 0x33bc0545
    li x3, 0x33bc0545
    csrw 0xe5f, x3

    #Address 0xe5f read value
    csrr x14, 0xe5f

    #Unmapped address 0xf47 testing: Read Reset + Random data Write/Read
    #Address 0xf47 read value
    csrr x14, 0xf47

    #Address 0xf47 Write value 0xa7018f68
    li x3, 0xa7018f68
    csrw 0xf47, x3

    #Address 0xf47 read value
    csrr x14, 0xf47

    #Unmapped address 0xe0 testing: Read Reset + Random data Write/Read
    #Address 0xe0 read value
    csrr x14, 0xe0

    #Address 0xe0 Write value 0x1c088b2c
    li x3, 0x1c088b2c
    csrw 0xe0, x3

    #Address 0xe0 read value
    csrr x14, 0xe0

    #Unmapped address 0xd7e testing: Read Reset + Random data Write/Read
    #Address 0xd7e read value
    csrr x14, 0xd7e

    #Address 0xd7e Write value 0xbd4d87e1
    li x3, 0xbd4d87e1
    csrw 0xd7e, x3

    #Address 0xd7e read value
    csrr x14, 0xd7e

    #Unmapped address 0x3db testing: Read Reset + Random data Write/Read
    #Address 0x3db read value
    csrr x14, 0x3db

    #Address 0x3db Write value 0xa93f6f55
    li x3, 0xa93f6f55
    csrw 0x3db, x3

    #Address 0x3db read value
    csrr x14, 0x3db

    #Unmapped address 0x7e1 testing: Read Reset + Random data Write/Read
    #Address 0x7e1 read value
    csrr x14, 0x7e1

    #Address 0x7e1 Write value 0x5a29f25b
    li x3, 0x5a29f25b
    csrw 0x7e1, x3

    #Address 0x7e1 read value
    csrr x14, 0x7e1

    #Unmapped address 0x488 testing: Read Reset + Random data Write/Read
    #Address 0x488 read value
    csrr x14, 0x488

    #Address 0x488 Write value 0x95001efb
    li x3, 0x95001efb
    csrw 0x488, x3

    #Address 0x488 read value
    csrr x14, 0x488

    #Unmapped address 0x9b8 testing: Read Reset + Random data Write/Read
    #Address 0x9b8 read value
    csrr x14, 0x9b8

    #Address 0x9b8 Write value 0x7aa26ad
    li x3, 0x7aa26ad
    csrw 0x9b8, x3

    #Address 0x9b8 read value
    csrr x14, 0x9b8

    #Unmapped address 0x9a4 testing: Read Reset + Random data Write/Read
    #Address 0x9a4 read value
    csrr x14, 0x9a4

    #Address 0x9a4 Write value 0xe263414f
    li x3, 0xe263414f
    csrw 0x9a4, x3

    #Address 0x9a4 read value
    csrr x14, 0x9a4

    #Unmapped address 0xfc5 testing: Read Reset + Random data Write/Read
    #Address 0xfc5 read value
    csrr x14, 0xfc5

    #Address 0xfc5 Write value 0xd6d496d
    li x3, 0xd6d496d
    csrw 0xfc5, x3

    #Address 0xfc5 read value
    csrr x14, 0xfc5

    #Unmapped address 0x223 testing: Read Reset + Random data Write/Read
    #Address 0x223 read value
    csrr x14, 0x223

    #Address 0x223 Write value 0xf6135658
    li x3, 0xf6135658
    csrw 0x223, x3

    #Address 0x223 read value
    csrr x14, 0x223

    #Unmapped address 0x766 testing: Read Reset + Random data Write/Read
    #Address 0x766 read value
    csrr x14, 0x766

    #Address 0x766 Write value 0xa4be3870
    li x3, 0xa4be3870
    csrw 0x766, x3

    #Address 0x766 read value
    csrr x14, 0x766

    #Unmapped address 0x49f testing: Read Reset + Random data Write/Read
    #Address 0x49f read value
    csrr x14, 0x49f

    #Address 0x49f Write value 0x843290d2
    li x3, 0x843290d2
    csrw 0x49f, x3

    #Address 0x49f read value
    csrr x14, 0x49f

    #Unmapped address 0xbeb testing: Read Reset + Random data Write/Read
    #Address 0xbeb read value
    csrr x14, 0xbeb

    #Address 0xbeb Write value 0x35c1c9a4
    li x3, 0x35c1c9a4
    csrw 0xbeb, x3

    #Address 0xbeb read value
    csrr x14, 0xbeb

    #Unmapped address 0xc3e testing: Read Reset + Random data Write/Read
    #Address 0xc3e read value
    csrr x14, 0xc3e

    #Address 0xc3e Write value 0x4e9f8c7b
    li x3, 0x4e9f8c7b
    csrw 0xc3e, x3

    #Address 0xc3e read value
    csrr x14, 0xc3e

    #Unmapped address 0xa2d testing: Read Reset + Random data Write/Read
    #Address 0xa2d read value
    csrr x14, 0xa2d

    #Address 0xa2d Write value 0x1756459e
    li x3, 0x1756459e
    csrw 0xa2d, x3

    #Address 0xa2d read value
    csrr x14, 0xa2d

    #Unmapped address 0x6f6 testing: Read Reset + Random data Write/Read
    #Address 0x6f6 read value
    csrr x14, 0x6f6

    #Address 0x6f6 Write value 0xb9502dba
    li x3, 0xb9502dba
    csrw 0x6f6, x3

    #Address 0x6f6 read value
    csrr x14, 0x6f6

    #Unmapped address 0xda7 testing: Read Reset + Random data Write/Read
    #Address 0xda7 read value
    csrr x14, 0xda7

    #Address 0xda7 Write value 0xbb2741ca
    li x3, 0xbb2741ca
    csrw 0xda7, x3

    #Address 0xda7 read value
    csrr x14, 0xda7

    #Unmapped address 0xf94 testing: Read Reset + Random data Write/Read
    #Address 0xf94 read value
    csrr x14, 0xf94

    #Address 0xf94 Write value 0xc236173d
    li x3, 0xc236173d
    csrw 0xf94, x3

    #Address 0xf94 read value
    csrr x14, 0xf94

    #Unmapped address 0xe11 testing: Read Reset + Random data Write/Read
    #Address 0xe11 read value
    csrr x14, 0xe11

    #Address 0xe11 Write value 0x9ad4fe68
    li x3, 0x9ad4fe68
    csrw 0xe11, x3

    #Address 0xe11 read value
    csrr x14, 0xe11

    #Unmapped address 0x517 testing: Read Reset + Random data Write/Read
    #Address 0x517 read value
    csrr x14, 0x517

    #Address 0x517 Write value 0x441ed97b
    li x3, 0x441ed97b
    csrw 0x517, x3

    #Address 0x517 read value
    csrr x14, 0x517

    #Unmapped address 0x725 testing: Read Reset + Random data Write/Read
    #Address 0x725 read value
    csrr x14, 0x725

    #Address 0x725 Write value 0x89545dc
    li x3, 0x89545dc
    csrw 0x725, x3

    #Address 0x725 read value
    csrr x14, 0x725

    #Unmapped address 0xfe1 testing: Read Reset + Random data Write/Read
    #Address 0xfe1 read value
    csrr x14, 0xfe1

    #Address 0xfe1 Write value 0x72a3c7d8
    li x3, 0x72a3c7d8
    csrw 0xfe1, x3

    #Address 0xfe1 read value
    csrr x14, 0xfe1

    #Unmapped address 0xbc0 testing: Read Reset + Random data Write/Read
    #Address 0xbc0 read value
    csrr x14, 0xbc0

    #Address 0xbc0 Write value 0xfd053285
    li x3, 0xfd053285
    csrw 0xbc0, x3

    #Address 0xbc0 read value
    csrr x14, 0xbc0

    #Unmapped address 0xf4c testing: Read Reset + Random data Write/Read
    #Address 0xf4c read value
    csrr x14, 0xf4c

    #Address 0xf4c Write value 0x5378aeb1
    li x3, 0x5378aeb1
    csrw 0xf4c, x3

    #Address 0xf4c read value
    csrr x14, 0xf4c

    #Unmapped address 0x173 testing: Read Reset + Random data Write/Read
    #Address 0x173 read value
    csrr x14, 0x173

    #Address 0x173 Write value 0x19f18702
    li x3, 0x19f18702
    csrw 0x173, x3

    #Address 0x173 read value
    csrr x14, 0x173

    #Unmapped address 0xfc8 testing: Read Reset + Random data Write/Read
    #Address 0xfc8 read value
    csrr x14, 0xfc8

    #Address 0xfc8 Write value 0x699d281e
    li x3, 0x699d281e
    csrw 0xfc8, x3

    #Address 0xfc8 read value
    csrr x14, 0xfc8

    #Unmapped address 0x41d testing: Read Reset + Random data Write/Read
    #Address 0x41d read value
    csrr x14, 0x41d

    #Address 0x41d Write value 0x63597fe5
    li x3, 0x63597fe5
    csrw 0x41d, x3

    #Address 0x41d read value
    csrr x14, 0x41d

    #Unmapped address 0x8a testing: Read Reset + Random data Write/Read
    #Address 0x8a read value
    csrr x14, 0x8a

    #Address 0x8a Write value 0x12ed77aa
    li x3, 0x12ed77aa
    csrw 0x8a, x3

    #Address 0x8a read value
    csrr x14, 0x8a

    #Unmapped address 0xdaf testing: Read Reset + Random data Write/Read
    #Address 0xdaf read value
    csrr x14, 0xdaf

    #Address 0xdaf Write value 0x54c39561
    li x3, 0x54c39561
    csrw 0xdaf, x3

    #Address 0xdaf read value
    csrr x14, 0xdaf

    #Unmapped address 0xfcb testing: Read Reset + Random data Write/Read
    #Address 0xfcb read value
    csrr x14, 0xfcb

    #Address 0xfcb Write value 0x11ada329
    li x3, 0x11ada329
    csrw 0xfcb, x3

    #Address 0xfcb read value
    csrr x14, 0xfcb

    #Unmapped address 0x52d testing: Read Reset + Random data Write/Read
    #Address 0x52d read value
    csrr x14, 0x52d

    #Address 0x52d Write value 0xe078fc84
    li x3, 0xe078fc84
    csrw 0x52d, x3

    #Address 0x52d read value
    csrr x14, 0x52d

    #Unmapped address 0x434 testing: Read Reset + Random data Write/Read
    #Address 0x434 read value
    csrr x14, 0x434

    #Address 0x434 Write value 0x20edae30
    li x3, 0x20edae30
    csrw 0x434, x3

    #Address 0x434 read value
    csrr x14, 0x434

    #Unmapped address 0x367 testing: Read Reset + Random data Write/Read
    #Address 0x367 read value
    csrr x14, 0x367

    #Address 0x367 Write value 0xb6f71ab1
    li x3, 0xb6f71ab1
    csrw 0x367, x3

    #Address 0x367 read value
    csrr x14, 0x367

    #Unmapped address 0xc38 testing: Read Reset + Random data Write/Read
    #Address 0xc38 read value
    csrr x14, 0xc38

    #Address 0xc38 Write value 0x56a7b5a5
    li x3, 0x56a7b5a5
    csrw 0xc38, x3

    #Address 0xc38 read value
    csrr x14, 0xc38

    #Unmapped address 0x8e8 testing: Read Reset + Random data Write/Read
    #Address 0x8e8 read value
    csrr x14, 0x8e8

    #Address 0x8e8 Write value 0xcca4ebe
    li x3, 0xcca4ebe
    csrw 0x8e8, x3

    #Address 0x8e8 read value
    csrr x14, 0x8e8

    #Unmapped address 0xd2e testing: Read Reset + Random data Write/Read
    #Address 0xd2e read value
    csrr x14, 0xd2e

    #Address 0xd2e Write value 0xd58dc154
    li x3, 0xd58dc154
    csrw 0xd2e, x3

    #Address 0xd2e read value
    csrr x14, 0xd2e

    #Unmapped address 0x2d3 testing: Read Reset + Random data Write/Read
    #Address 0x2d3 read value
    csrr x14, 0x2d3

    #Address 0x2d3 Write value 0xa9decb85
    li x3, 0xa9decb85
    csrw 0x2d3, x3

    #Address 0x2d3 read value
    csrr x14, 0x2d3

    #Unmapped address 0xf68 testing: Read Reset + Random data Write/Read
    #Address 0xf68 read value
    csrr x14, 0xf68

    #Address 0xf68 Write value 0x668fff02
    li x3, 0x668fff02
    csrw 0xf68, x3

    #Address 0xf68 read value
    csrr x14, 0xf68

    #Unmapped address 0xf09 testing: Read Reset + Random data Write/Read
    #Address 0xf09 read value
    csrr x14, 0xf09

    #Address 0xf09 Write value 0xe406ff3f
    li x3, 0xe406ff3f
    csrw 0xf09, x3

    #Address 0xf09 read value
    csrr x14, 0xf09

    #Unmapped address 0x53d testing: Read Reset + Random data Write/Read
    #Address 0x53d read value
    csrr x14, 0x53d

    #Address 0x53d Write value 0x6cd1b91a
    li x3, 0x6cd1b91a
    csrw 0x53d, x3

    #Address 0x53d read value
    csrr x14, 0x53d

    #Unmapped address 0x47f testing: Read Reset + Random data Write/Read
    #Address 0x47f read value
    csrr x14, 0x47f

    #Address 0x47f Write value 0x121e0e99
    li x3, 0x121e0e99
    csrw 0x47f, x3

    #Address 0x47f read value
    csrr x14, 0x47f

    #Unmapped address 0xfcc testing: Read Reset + Random data Write/Read
    #Address 0xfcc read value
    csrr x14, 0xfcc

    #Address 0xfcc Write value 0xf4cf383a
    li x3, 0xf4cf383a
    csrw 0xfcc, x3

    #Address 0xfcc read value
    csrr x14, 0xfcc

    #Unmapped address 0x239 testing: Read Reset + Random data Write/Read
    #Address 0x239 read value
    csrr x14, 0x239

    #Address 0x239 Write value 0xc943c35
    li x3, 0xc943c35
    csrw 0x239, x3

    #Address 0x239 read value
    csrr x14, 0x239

    #Unmapped address 0xb57 testing: Read Reset + Random data Write/Read
    #Address 0xb57 read value
    csrr x14, 0xb57

    #Address 0xb57 Write value 0x3c305ea1
    li x3, 0x3c305ea1
    csrw 0xb57, x3

    #Address 0xb57 read value
    csrr x14, 0xb57

    #Unmapped address 0x821 testing: Read Reset + Random data Write/Read
    #Address 0x821 read value
    csrr x14, 0x821

    #Address 0x821 Write value 0x5f05c842
    li x3, 0x5f05c842
    csrw 0x821, x3

    #Address 0x821 read value
    csrr x14, 0x821

    #Unmapped address 0x500 testing: Read Reset + Random data Write/Read
    #Address 0x500 read value
    csrr x14, 0x500

    #Address 0x500 Write value 0x45681c14
    li x3, 0x45681c14
    csrw 0x500, x3

    #Address 0x500 read value
    csrr x14, 0x500

    #Unmapped address 0xb78 testing: Read Reset + Random data Write/Read
    #Address 0xb78 read value
    csrr x14, 0xb78

    #Address 0xb78 Write value 0xd66368d6
    li x3, 0xd66368d6
    csrw 0xb78, x3

    #Address 0xb78 read value
    csrr x14, 0xb78

    #Unmapped address 0x61 testing: Read Reset + Random data Write/Read
    #Address 0x61 read value
    csrr x14, 0x61

    #Address 0x61 Write value 0xaa3f8147
    li x3, 0xaa3f8147
    csrw 0x61, x3

    #Address 0x61 read value
    csrr x14, 0x61

    #Unmapped address 0x982 testing: Read Reset + Random data Write/Read
    #Address 0x982 read value
    csrr x14, 0x982

    #Address 0x982 Write value 0xa8a079e2
    li x3, 0xa8a079e2
    csrw 0x982, x3

    #Address 0x982 read value
    csrr x14, 0x982

    #Unmapped address 0xd38 testing: Read Reset + Random data Write/Read
    #Address 0xd38 read value
    csrr x14, 0xd38

    #Address 0xd38 Write value 0x88566938
    li x3, 0x88566938
    csrw 0xd38, x3

    #Address 0xd38 read value
    csrr x14, 0xd38

    #Unmapped address 0x69c testing: Read Reset + Random data Write/Read
    #Address 0x69c read value
    csrr x14, 0x69c

    #Address 0x69c Write value 0x4803bc9b
    li x3, 0x4803bc9b
    csrw 0x69c, x3

    #Address 0x69c read value
    csrr x14, 0x69c

    #Unmapped address 0x26f testing: Read Reset + Random data Write/Read
    #Address 0x26f read value
    csrr x14, 0x26f

    #Address 0x26f Write value 0xe122ab65
    li x3, 0xe122ab65
    csrw 0x26f, x3

    #Address 0x26f read value
    csrr x14, 0x26f

    #Unmapped address 0x8a2 testing: Read Reset + Random data Write/Read
    #Address 0x8a2 read value
    csrr x14, 0x8a2

    #Address 0x8a2 Write value 0x293234d0
    li x3, 0x293234d0
    csrw 0x8a2, x3

    #Address 0x8a2 read value
    csrr x14, 0x8a2

    #Unmapped address 0x63 testing: Read Reset + Random data Write/Read
    #Address 0x63 read value
    csrr x14, 0x63

    #Address 0x63 Write value 0x31b37b23
    li x3, 0x31b37b23
    csrw 0x63, x3

    #Address 0x63 read value
    csrr x14, 0x63

    #Unmapped address 0xe0a testing: Read Reset + Random data Write/Read
    #Address 0xe0a read value
    csrr x14, 0xe0a

    #Address 0xe0a Write value 0x3e1a2a40
    li x3, 0x3e1a2a40
    csrw 0xe0a, x3

    #Address 0xe0a read value
    csrr x14, 0xe0a

    #Unmapped address 0x15 testing: Read Reset + Random data Write/Read
    #Address 0x15 read value
    csrr x14, 0x15

    #Address 0x15 Write value 0xe72759d6
    li x3, 0xe72759d6
    csrw 0x15, x3

    #Address 0x15 read value
    csrr x14, 0x15

    #Unmapped address 0xa64 testing: Read Reset + Random data Write/Read
    #Address 0xa64 read value
    csrr x14, 0xa64

    #Address 0xa64 Write value 0x218cef4d
    li x3, 0x218cef4d
    csrw 0xa64, x3

    #Address 0xa64 read value
    csrr x14, 0xa64

    #Unmapped address 0xae6 testing: Read Reset + Random data Write/Read
    #Address 0xae6 read value
    csrr x14, 0xae6

    #Address 0xae6 Write value 0x4a4146f6
    li x3, 0x4a4146f6
    csrw 0xae6, x3

    #Address 0xae6 read value
    csrr x14, 0xae6

    #Unmapped address 0xa0 testing: Read Reset + Random data Write/Read
    #Address 0xa0 read value
    csrr x14, 0xa0

    #Address 0xa0 Write value 0x1fcbd7ba
    li x3, 0x1fcbd7ba
    csrw 0xa0, x3

    #Address 0xa0 read value
    csrr x14, 0xa0

    #Unmapped address 0xc16 testing: Read Reset + Random data Write/Read
    #Address 0xc16 read value
    csrr x14, 0xc16

    #Address 0xc16 Write value 0x37182e1e
    li x3, 0x37182e1e
    csrw 0xc16, x3

    #Address 0xc16 read value
    csrr x14, 0xc16

    #Unmapped address 0x4eb testing: Read Reset + Random data Write/Read
    #Address 0x4eb read value
    csrr x14, 0x4eb

    #Address 0x4eb Write value 0xe1af1911
    li x3, 0xe1af1911
    csrw 0x4eb, x3

    #Address 0x4eb read value
    csrr x14, 0x4eb

    #Unmapped address 0x37f testing: Read Reset + Random data Write/Read
    #Address 0x37f read value
    csrr x14, 0x37f

    #Address 0x37f Write value 0x9e831616
    li x3, 0x9e831616
    csrw 0x37f, x3

    #Address 0x37f read value
    csrr x14, 0x37f

    #Unmapped address 0xf20 testing: Read Reset + Random data Write/Read
    #Address 0xf20 read value
    csrr x14, 0xf20

    #Address 0xf20 Write value 0x7191e15a
    li x3, 0x7191e15a
    csrw 0xf20, x3

    #Address 0xf20 read value
    csrr x14, 0xf20

    #Unmapped address 0x154 testing: Read Reset + Random data Write/Read
    #Address 0x154 read value
    csrr x14, 0x154

    #Address 0x154 Write value 0x15da719b
    li x3, 0x15da719b
    csrw 0x154, x3

    #Address 0x154 read value
    csrr x14, 0x154

    #Unmapped address 0x28a testing: Read Reset + Random data Write/Read
    #Address 0x28a read value
    csrr x14, 0x28a

    #Address 0x28a Write value 0xcec09665
    li x3, 0xcec09665
    csrw 0x28a, x3

    #Address 0x28a read value
    csrr x14, 0x28a

    #Unmapped address 0x5ee testing: Read Reset + Random data Write/Read
    #Address 0x5ee read value
    csrr x14, 0x5ee

    #Address 0x5ee Write value 0x2adbdb8b
    li x3, 0x2adbdb8b
    csrw 0x5ee, x3

    #Address 0x5ee read value
    csrr x14, 0x5ee

    #Unmapped address 0x924 testing: Read Reset + Random data Write/Read
    #Address 0x924 read value
    csrr x14, 0x924

    #Address 0x924 Write value 0x87c96b23
    li x3, 0x87c96b23
    csrw 0x924, x3

    #Address 0x924 read value
    csrr x14, 0x924

    #Unmapped address 0x53 testing: Read Reset + Random data Write/Read
    #Address 0x53 read value
    csrr x14, 0x53

    #Address 0x53 Write value 0xe54e447f
    li x3, 0xe54e447f
    csrw 0x53, x3

    #Address 0x53 read value
    csrr x14, 0x53

    #Unmapped address 0xcb7 testing: Read Reset + Random data Write/Read
    #Address 0xcb7 read value
    csrr x14, 0xcb7

    #Address 0xcb7 Write value 0xe22eae9e
    li x3, 0xe22eae9e
    csrw 0xcb7, x3

    #Address 0xcb7 read value
    csrr x14, 0xcb7

    #Unmapped address 0x580 testing: Read Reset + Random data Write/Read
    #Address 0x580 read value
    csrr x14, 0x580

    #Address 0x580 Write value 0x772295e9
    li x3, 0x772295e9
    csrw 0x580, x3

    #Address 0x580 read value
    csrr x14, 0x580

    #Unmapped address 0xecc testing: Read Reset + Random data Write/Read
    #Address 0xecc read value
    csrr x14, 0xecc

    #Address 0xecc Write value 0xc28d0e4a
    li x3, 0xc28d0e4a
    csrw 0xecc, x3

    #Address 0xecc read value
    csrr x14, 0xecc

    #Unmapped address 0xc9b testing: Read Reset + Random data Write/Read
    #Address 0xc9b read value
    csrr x14, 0xc9b

    #Address 0xc9b Write value 0x74ce825
    li x3, 0x74ce825
    csrw 0xc9b, x3

    #Address 0xc9b read value
    csrr x14, 0xc9b

    #Unmapped address 0x73c testing: Read Reset + Random data Write/Read
    #Address 0x73c read value
    csrr x14, 0x73c

    #Address 0x73c Write value 0xa5617161
    li x3, 0xa5617161
    csrw 0x73c, x3

    #Address 0x73c read value
    csrr x14, 0x73c

    #Unmapped address 0x4be testing: Read Reset + Random data Write/Read
    #Address 0x4be read value
    csrr x14, 0x4be

    #Address 0x4be Write value 0x2e57af14
    li x3, 0x2e57af14
    csrw 0x4be, x3

    #Address 0x4be read value
    csrr x14, 0x4be

    #Unmapped address 0x3e0 testing: Read Reset + Random data Write/Read
    #Address 0x3e0 read value
    csrr x14, 0x3e0

    #Address 0x3e0 Write value 0x789d1e51
    li x3, 0x789d1e51
    csrw 0x3e0, x3

    #Address 0x3e0 read value
    csrr x14, 0x3e0

    #Unmapped address 0x5e9 testing: Read Reset + Random data Write/Read
    #Address 0x5e9 read value
    csrr x14, 0x5e9

    #Address 0x5e9 Write value 0xcd64ead4
    li x3, 0xcd64ead4
    csrw 0x5e9, x3

    #Address 0x5e9 read value
    csrr x14, 0x5e9

    #Unmapped address 0xe68 testing: Read Reset + Random data Write/Read
    #Address 0xe68 read value
    csrr x14, 0xe68

    #Address 0xe68 Write value 0xf46f02f3
    li x3, 0xf46f02f3
    csrw 0xe68, x3

    #Address 0xe68 read value
    csrr x14, 0xe68

    #Unmapped address 0x2d0 testing: Read Reset + Random data Write/Read
    #Address 0x2d0 read value
    csrr x14, 0x2d0

    #Address 0x2d0 Write value 0x44578a38
    li x3, 0x44578a38
    csrw 0x2d0, x3

    #Address 0x2d0 read value
    csrr x14, 0x2d0

    #Unmapped address 0x4de testing: Read Reset + Random data Write/Read
    #Address 0x4de read value
    csrr x14, 0x4de

    #Address 0x4de Write value 0x3273cccd
    li x3, 0x3273cccd
    csrw 0x4de, x3

    #Address 0x4de read value
    csrr x14, 0x4de

    #Unmapped address 0x4df testing: Read Reset + Random data Write/Read
    #Address 0x4df read value
    csrr x14, 0x4df

    #Address 0x4df Write value 0x3fe48327
    li x3, 0x3fe48327
    csrw 0x4df, x3

    #Address 0x4df read value
    csrr x14, 0x4df

    #Unmapped address 0x812 testing: Read Reset + Random data Write/Read
    #Address 0x812 read value
    csrr x14, 0x812

    #Address 0x812 Write value 0x9acce496
    li x3, 0x9acce496
    csrw 0x812, x3

    #Address 0x812 read value
    csrr x14, 0x812

    #Unmapped address 0x7f8 testing: Read Reset + Random data Write/Read
    #Address 0x7f8 read value
    csrr x14, 0x7f8

    #Address 0x7f8 Write value 0x337ca236
    li x3, 0x337ca236
    csrw 0x7f8, x3

    #Address 0x7f8 read value
    csrr x14, 0x7f8

    #Unmapped address 0xda4 testing: Read Reset + Random data Write/Read
    #Address 0xda4 read value
    csrr x14, 0xda4

    #Address 0xda4 Write value 0xf057b200
    li x3, 0xf057b200
    csrw 0xda4, x3

    #Address 0xda4 read value
    csrr x14, 0xda4

    #Unmapped address 0xa7e testing: Read Reset + Random data Write/Read
    #Address 0xa7e read value
    csrr x14, 0xa7e

    #Address 0xa7e Write value 0xd3993c80
    li x3, 0xd3993c80
    csrw 0xa7e, x3

    #Address 0xa7e read value
    csrr x14, 0xa7e

    #Unmapped address 0x9ff testing: Read Reset + Random data Write/Read
    #Address 0x9ff read value
    csrr x14, 0x9ff

    #Address 0x9ff Write value 0x3756032
    li x3, 0x3756032
    csrw 0x9ff, x3

    #Address 0x9ff read value
    csrr x14, 0x9ff

    #Unmapped address 0xb70 testing: Read Reset + Random data Write/Read
    #Address 0xb70 read value
    csrr x14, 0xb70

    #Address 0xb70 Write value 0x48cda9e7
    li x3, 0x48cda9e7
    csrw 0xb70, x3

    #Address 0xb70 read value
    csrr x14, 0xb70

    #Unmapped address 0xb35 testing: Read Reset + Random data Write/Read
    #Address 0xb35 read value
    csrr x14, 0xb35

    #Address 0xb35 Write value 0xa1e13bc9
    li x3, 0xa1e13bc9
    csrw 0xb35, x3

    #Address 0xb35 read value
    csrr x14, 0xb35

    #Unmapped address 0x5f1 testing: Read Reset + Random data Write/Read
    #Address 0x5f1 read value
    csrr x14, 0x5f1

    #Address 0x5f1 Write value 0xd2cdc351
    li x3, 0xd2cdc351
    csrw 0x5f1, x3

    #Address 0x5f1 read value
    csrr x14, 0x5f1

    #Unmapped address 0x6d3 testing: Read Reset + Random data Write/Read
    #Address 0x6d3 read value
    csrr x14, 0x6d3

    #Address 0x6d3 Write value 0x1b83cbf
    li x3, 0x1b83cbf
    csrw 0x6d3, x3

    #Address 0x6d3 read value
    csrr x14, 0x6d3

    #Unmapped address 0x4db testing: Read Reset + Random data Write/Read
    #Address 0x4db read value
    csrr x14, 0x4db

    #Address 0x4db Write value 0xf08a6b88
    li x3, 0xf08a6b88
    csrw 0x4db, x3

    #Address 0x4db read value
    csrr x14, 0x4db

    #Unmapped address 0x269 testing: Read Reset + Random data Write/Read
    #Address 0x269 read value
    csrr x14, 0x269

    #Address 0x269 Write value 0x41fb72f
    li x3, 0x41fb72f
    csrw 0x269, x3

    #Address 0x269 read value
    csrr x14, 0x269

    #Unmapped address 0x483 testing: Read Reset + Random data Write/Read
    #Address 0x483 read value
    csrr x14, 0x483

    #Address 0x483 Write value 0x1265e396
    li x3, 0x1265e396
    csrw 0x483, x3

    #Address 0x483 read value
    csrr x14, 0x483

    #Unmapped address 0xe24 testing: Read Reset + Random data Write/Read
    #Address 0xe24 read value
    csrr x14, 0xe24

    #Address 0xe24 Write value 0x1d330419
    li x3, 0x1d330419
    csrw 0xe24, x3

    #Address 0xe24 read value
    csrr x14, 0xe24

    #Unmapped address 0x669 testing: Read Reset + Random data Write/Read
    #Address 0x669 read value
    csrr x14, 0x669

    #Address 0x669 Write value 0x112f7538
    li x3, 0x112f7538
    csrw 0x669, x3

    #Address 0x669 read value
    csrr x14, 0x669

    #Unmapped address 0x411 testing: Read Reset + Random data Write/Read
    #Address 0x411 read value
    csrr x14, 0x411

    #Address 0x411 Write value 0x896eea27
    li x3, 0x896eea27
    csrw 0x411, x3

    #Address 0x411 read value
    csrr x14, 0x411

    #Unmapped address 0x5cf testing: Read Reset + Random data Write/Read
    #Address 0x5cf read value
    csrr x14, 0x5cf

    #Address 0x5cf Write value 0xef114101
    li x3, 0xef114101
    csrw 0x5cf, x3

    #Address 0x5cf read value
    csrr x14, 0x5cf

    #Unmapped address 0xe2b testing: Read Reset + Random data Write/Read
    #Address 0xe2b read value
    csrr x14, 0xe2b

    #Address 0xe2b Write value 0x9c3d0bef
    li x3, 0x9c3d0bef
    csrw 0xe2b, x3

    #Address 0xe2b read value
    csrr x14, 0xe2b

    #Unmapped address 0xf30 testing: Read Reset + Random data Write/Read
    #Address 0xf30 read value
    csrr x14, 0xf30

    #Address 0xf30 Write value 0x8ee3bc
    li x3, 0x8ee3bc
    csrw 0xf30, x3

    #Address 0xf30 read value
    csrr x14, 0xf30

    #Unmapped address 0xe49 testing: Read Reset + Random data Write/Read
    #Address 0xe49 read value
    csrr x14, 0xe49

    #Address 0xe49 Write value 0x16e2caa1
    li x3, 0x16e2caa1
    csrw 0xe49, x3

    #Address 0xe49 read value
    csrr x14, 0xe49

    #Unmapped address 0x5be testing: Read Reset + Random data Write/Read
    #Address 0x5be read value
    csrr x14, 0x5be

    #Address 0x5be Write value 0xdb9e45c5
    li x3, 0xdb9e45c5
    csrw 0x5be, x3

    #Address 0x5be read value
    csrr x14, 0x5be

    #Unmapped address 0x26c testing: Read Reset + Random data Write/Read
    #Address 0x26c read value
    csrr x14, 0x26c

    #Address 0x26c Write value 0xd04c4bec
    li x3, 0xd04c4bec
    csrw 0x26c, x3

    #Address 0x26c read value
    csrr x14, 0x26c

    #Unmapped address 0xe62 testing: Read Reset + Random data Write/Read
    #Address 0xe62 read value
    csrr x14, 0xe62

    #Address 0xe62 Write value 0x65d011d0
    li x3, 0x65d011d0
    csrw 0xe62, x3

    #Address 0xe62 read value
    csrr x14, 0xe62

    #Unmapped address 0x134 testing: Read Reset + Random data Write/Read
    #Address 0x134 read value
    csrr x14, 0x134

    #Address 0x134 Write value 0x696cbddc
    li x3, 0x696cbddc
    csrw 0x134, x3

    #Address 0x134 read value
    csrr x14, 0x134

    #Unmapped address 0x760 testing: Read Reset + Random data Write/Read
    #Address 0x760 read value
    csrr x14, 0x760

    #Address 0x760 Write value 0x8857dfe4
    li x3, 0x8857dfe4
    csrw 0x760, x3

    #Address 0x760 read value
    csrr x14, 0x760

    #Unmapped address 0x266 testing: Read Reset + Random data Write/Read
    #Address 0x266 read value
    csrr x14, 0x266

    #Address 0x266 Write value 0xda834b69
    li x3, 0xda834b69
    csrw 0x266, x3

    #Address 0x266 read value
    csrr x14, 0x266

    #Unmapped address 0xd9 testing: Read Reset + Random data Write/Read
    #Address 0xd9 read value
    csrr x14, 0xd9

    #Address 0xd9 Write value 0x45aae5d5
    li x3, 0x45aae5d5
    csrw 0xd9, x3

    #Address 0xd9 read value
    csrr x14, 0xd9

    #Unmapped address 0x9cd testing: Read Reset + Random data Write/Read
    #Address 0x9cd read value
    csrr x14, 0x9cd

    #Address 0x9cd Write value 0xf09c9e73
    li x3, 0xf09c9e73
    csrw 0x9cd, x3

    #Address 0x9cd read value
    csrr x14, 0x9cd

    #Unmapped address 0xdde testing: Read Reset + Random data Write/Read
    #Address 0xdde read value
    csrr x14, 0xdde

    #Address 0xdde Write value 0xebd4cbb
    li x3, 0xebd4cbb
    csrw 0xdde, x3

    #Address 0xdde read value
    csrr x14, 0xdde

    #Unmapped address 0xda0 testing: Read Reset + Random data Write/Read
    #Address 0xda0 read value
    csrr x14, 0xda0

    #Address 0xda0 Write value 0x6cc2bb2c
    li x3, 0x6cc2bb2c
    csrw 0xda0, x3

    #Address 0xda0 read value
    csrr x14, 0xda0

    #Unmapped address 0x4ed testing: Read Reset + Random data Write/Read
    #Address 0x4ed read value
    csrr x14, 0x4ed

    #Address 0x4ed Write value 0xf7565662
    li x3, 0xf7565662
    csrw 0x4ed, x3

    #Address 0x4ed read value
    csrr x14, 0x4ed

    #Unmapped address 0x628 testing: Read Reset + Random data Write/Read
    #Address 0x628 read value
    csrr x14, 0x628

    #Address 0x628 Write value 0x9cf83fe2
    li x3, 0x9cf83fe2
    csrw 0x628, x3

    #Address 0x628 read value
    csrr x14, 0x628

    #Unmapped address 0x731 testing: Read Reset + Random data Write/Read
    #Address 0x731 read value
    csrr x14, 0x731

    #Address 0x731 Write value 0xef2e01d2
    li x3, 0xef2e01d2
    csrw 0x731, x3

    #Address 0x731 read value
    csrr x14, 0x731

    #Unmapped address 0x92d testing: Read Reset + Random data Write/Read
    #Address 0x92d read value
    csrr x14, 0x92d

    #Address 0x92d Write value 0x771442b2
    li x3, 0x771442b2
    csrw 0x92d, x3

    #Address 0x92d read value
    csrr x14, 0x92d

    #Unmapped address 0xa11 testing: Read Reset + Random data Write/Read
    #Address 0xa11 read value
    csrr x14, 0xa11

    #Address 0xa11 Write value 0x1aac50c7
    li x3, 0x1aac50c7
    csrw 0xa11, x3

    #Address 0xa11 read value
    csrr x14, 0xa11

    #Unmapped address 0xcc1 testing: Read Reset + Random data Write/Read
    #Address 0xcc1 read value
    csrr x14, 0xcc1

    #Address 0xcc1 Write value 0xb8b04c06
    li x3, 0xb8b04c06
    csrw 0xcc1, x3

    #Address 0xcc1 read value
    csrr x14, 0xcc1

    #Unmapped address 0x984 testing: Read Reset + Random data Write/Read
    #Address 0x984 read value
    csrr x14, 0x984

    #Address 0x984 Write value 0x79c44eb5
    li x3, 0x79c44eb5
    csrw 0x984, x3

    #Address 0x984 read value
    csrr x14, 0x984

    #Unmapped address 0x213 testing: Read Reset + Random data Write/Read
    #Address 0x213 read value
    csrr x14, 0x213

    #Address 0x213 Write value 0x71fb16b5
    li x3, 0x71fb16b5
    csrw 0x213, x3

    #Address 0x213 read value
    csrr x14, 0x213

    #Unmapped address 0xf16 testing: Read Reset + Random data Write/Read
    #Address 0xf16 read value
    csrr x14, 0xf16

    #Address 0xf16 Write value 0xdf568fa4
    li x3, 0xdf568fa4
    csrw 0xf16, x3

    #Address 0xf16 read value
    csrr x14, 0xf16

    #Unmapped address 0x8b testing: Read Reset + Random data Write/Read
    #Address 0x8b read value
    csrr x14, 0x8b

    #Address 0x8b Write value 0x7b9ff827
    li x3, 0x7b9ff827
    csrw 0x8b, x3

    #Address 0x8b read value
    csrr x14, 0x8b

    #Unmapped address 0x57e testing: Read Reset + Random data Write/Read
    #Address 0x57e read value
    csrr x14, 0x57e

    #Address 0x57e Write value 0x74573baa
    li x3, 0x74573baa
    csrw 0x57e, x3

    #Address 0x57e read value
    csrr x14, 0x57e

    #Unmapped address 0xf49 testing: Read Reset + Random data Write/Read
    #Address 0xf49 read value
    csrr x14, 0xf49

    #Address 0xf49 Write value 0x916466b2
    li x3, 0x916466b2
    csrw 0xf49, x3

    #Address 0xf49 read value
    csrr x14, 0xf49

    #Unmapped address 0x2e testing: Read Reset + Random data Write/Read
    #Address 0x2e read value
    csrr x14, 0x2e

    #Address 0x2e Write value 0x1573de2e
    li x3, 0x1573de2e
    csrw 0x2e, x3

    #Address 0x2e read value
    csrr x14, 0x2e

    #Unmapped address 0xe78 testing: Read Reset + Random data Write/Read
    #Address 0xe78 read value
    csrr x14, 0xe78

    #Address 0xe78 Write value 0xfa9cdaea
    li x3, 0xfa9cdaea
    csrw 0xe78, x3

    #Address 0xe78 read value
    csrr x14, 0xe78

    #Unmapped address 0x607 testing: Read Reset + Random data Write/Read
    #Address 0x607 read value
    csrr x14, 0x607

    #Address 0x607 Write value 0xefa58459
    li x3, 0xefa58459
    csrw 0x607, x3

    #Address 0x607 read value
    csrr x14, 0x607

    #Unmapped address 0xba4 testing: Read Reset + Random data Write/Read
    #Address 0xba4 read value
    csrr x14, 0xba4

    #Address 0xba4 Write value 0x26e82492
    li x3, 0x26e82492
    csrw 0xba4, x3

    #Address 0xba4 read value
    csrr x14, 0xba4

    #Unmapped address 0x710 testing: Read Reset + Random data Write/Read
    #Address 0x710 read value
    csrr x14, 0x710

    #Address 0x710 Write value 0xc2c7f424
    li x3, 0xc2c7f424
    csrw 0x710, x3

    #Address 0x710 read value
    csrr x14, 0x710

    #Unmapped address 0x53f testing: Read Reset + Random data Write/Read
    #Address 0x53f read value
    csrr x14, 0x53f

    #Address 0x53f Write value 0xced078a7
    li x3, 0xced078a7
    csrw 0x53f, x3

    #Address 0x53f read value
    csrr x14, 0x53f

    #Unmapped address 0x347 testing: Read Reset + Random data Write/Read
    #Address 0x347 read value
    csrr x14, 0x347

    #Address 0x347 Write value 0x20672e47
    li x3, 0x20672e47
    csrw 0x347, x3

    #Address 0x347 read value
    csrr x14, 0x347

    #Unmapped address 0xf10 testing: Read Reset + Random data Write/Read
    #Address 0xf10 read value
    csrr x14, 0xf10

    #Address 0xf10 Write value 0xadc8bc5b
    li x3, 0xadc8bc5b
    csrw 0xf10, x3

    #Address 0xf10 read value
    csrr x14, 0xf10

    #Unmapped address 0x875 testing: Read Reset + Random data Write/Read
    #Address 0x875 read value
    csrr x14, 0x875

    #Address 0x875 Write value 0x563c4e49
    li x3, 0x563c4e49
    csrw 0x875, x3

    #Address 0x875 read value
    csrr x14, 0x875

    #Unmapped address 0x897 testing: Read Reset + Random data Write/Read
    #Address 0x897 read value
    csrr x14, 0x897

    #Address 0x897 Write value 0x9711fdd3
    li x3, 0x9711fdd3
    csrw 0x897, x3

    #Address 0x897 read value
    csrr x14, 0x897

    #Unmapped address 0xea9 testing: Read Reset + Random data Write/Read
    #Address 0xea9 read value
    csrr x14, 0xea9

    #Address 0xea9 Write value 0x8676bbef
    li x3, 0x8676bbef
    csrw 0xea9, x3

    #Address 0xea9 read value
    csrr x14, 0xea9

    #Unmapped address 0x8d3 testing: Read Reset + Random data Write/Read
    #Address 0x8d3 read value
    csrr x14, 0x8d3

    #Address 0x8d3 Write value 0x3e14ebea
    li x3, 0x3e14ebea
    csrw 0x8d3, x3

    #Address 0x8d3 read value
    csrr x14, 0x8d3

    #Unmapped address 0x9ed testing: Read Reset + Random data Write/Read
    #Address 0x9ed read value
    csrr x14, 0x9ed

    #Address 0x9ed Write value 0x50a9b30c
    li x3, 0x50a9b30c
    csrw 0x9ed, x3

    #Address 0x9ed read value
    csrr x14, 0x9ed

    #Unmapped address 0xcb4 testing: Read Reset + Random data Write/Read
    #Address 0xcb4 read value
    csrr x14, 0xcb4

    #Address 0xcb4 Write value 0x9a8d93f8
    li x3, 0x9a8d93f8
    csrw 0xcb4, x3

    #Address 0xcb4 read value
    csrr x14, 0xcb4

    #Unmapped address 0x186 testing: Read Reset + Random data Write/Read
    #Address 0x186 read value
    csrr x14, 0x186

    #Address 0x186 Write value 0x82b644af
    li x3, 0x82b644af
    csrw 0x186, x3

    #Address 0x186 read value
    csrr x14, 0x186

    #Unmapped address 0x303 testing: Read Reset + Random data Write/Read
    #Address 0x303 read value
    csrr x14, 0x303

    #Address 0x303 Write value 0x779eff22
    li x3, 0x779eff22
    csrw 0x303, x3

    #Address 0x303 read value
    csrr x14, 0x303

    #Unmapped address 0x90b testing: Read Reset + Random data Write/Read
    #Address 0x90b read value
    csrr x14, 0x90b

    #Address 0x90b Write value 0x7c2c5b44
    li x3, 0x7c2c5b44
    csrw 0x90b, x3

    #Address 0x90b read value
    csrr x14, 0x90b

    #Unmapped address 0xbfd testing: Read Reset + Random data Write/Read
    #Address 0xbfd read value
    csrr x14, 0xbfd

    #Address 0xbfd Write value 0xbae8f786
    li x3, 0xbae8f786
    csrw 0xbfd, x3

    #Address 0xbfd read value
    csrr x14, 0xbfd

    #Unmapped address 0x95b testing: Read Reset + Random data Write/Read
    #Address 0x95b read value
    csrr x14, 0x95b

    #Address 0x95b Write value 0xe17999fd
    li x3, 0xe17999fd
    csrw 0x95b, x3

    #Address 0x95b read value
    csrr x14, 0x95b

    #Unmapped address 0xbe3 testing: Read Reset + Random data Write/Read
    #Address 0xbe3 read value
    csrr x14, 0xbe3

    #Address 0xbe3 Write value 0xa1c800bd
    li x3, 0xa1c800bd
    csrw 0xbe3, x3

    #Address 0xbe3 read value
    csrr x14, 0xbe3

    #Unmapped address 0xdf6 testing: Read Reset + Random data Write/Read
    #Address 0xdf6 read value
    csrr x14, 0xdf6

    #Address 0xdf6 Write value 0x6215cdb8
    li x3, 0x6215cdb8
    csrw 0xdf6, x3

    #Address 0xdf6 read value
    csrr x14, 0xdf6

    #Unmapped address 0x350 testing: Read Reset + Random data Write/Read
    #Address 0x350 read value
    csrr x14, 0x350

    #Address 0x350 Write value 0xfe7166a4
    li x3, 0xfe7166a4
    csrw 0x350, x3

    #Address 0x350 read value
    csrr x14, 0x350

    #Unmapped address 0xab1 testing: Read Reset + Random data Write/Read
    #Address 0xab1 read value
    csrr x14, 0xab1

    #Address 0xab1 Write value 0x22973b18
    li x3, 0x22973b18
    csrw 0xab1, x3

    #Address 0xab1 read value
    csrr x14, 0xab1

    #Unmapped address 0x66d testing: Read Reset + Random data Write/Read
    #Address 0x66d read value
    csrr x14, 0x66d

    #Address 0x66d Write value 0x799baf6d
    li x3, 0x799baf6d
    csrw 0x66d, x3

    #Address 0x66d read value
    csrr x14, 0x66d

    #Unmapped address 0x7f6 testing: Read Reset + Random data Write/Read
    #Address 0x7f6 read value
    csrr x14, 0x7f6

    #Address 0x7f6 Write value 0x2ad91c40
    li x3, 0x2ad91c40
    csrw 0x7f6, x3

    #Address 0x7f6 read value
    csrr x14, 0x7f6

    #Unmapped address 0xec4 testing: Read Reset + Random data Write/Read
    #Address 0xec4 read value
    csrr x14, 0xec4

    #Address 0xec4 Write value 0x176c05bb
    li x3, 0x176c05bb
    csrw 0xec4, x3

    #Address 0xec4 read value
    csrr x14, 0xec4

    #Unmapped address 0x2c9 testing: Read Reset + Random data Write/Read
    #Address 0x2c9 read value
    csrr x14, 0x2c9

    #Address 0x2c9 Write value 0x130fe8c8
    li x3, 0x130fe8c8
    csrw 0x2c9, x3

    #Address 0x2c9 read value
    csrr x14, 0x2c9

    #Unmapped address 0xf7 testing: Read Reset + Random data Write/Read
    #Address 0xf7 read value
    csrr x14, 0xf7

    #Address 0xf7 Write value 0x77478312
    li x3, 0x77478312
    csrw 0xf7, x3

    #Address 0xf7 read value
    csrr x14, 0xf7

    #Unmapped address 0x83c testing: Read Reset + Random data Write/Read
    #Address 0x83c read value
    csrr x14, 0x83c

    #Address 0x83c Write value 0x380afacf
    li x3, 0x380afacf
    csrw 0x83c, x3

    #Address 0x83c read value
    csrr x14, 0x83c

    #Unmapped address 0x1d1 testing: Read Reset + Random data Write/Read
    #Address 0x1d1 read value
    csrr x14, 0x1d1

    #Address 0x1d1 Write value 0x92760687
    li x3, 0x92760687
    csrw 0x1d1, x3

    #Address 0x1d1 read value
    csrr x14, 0x1d1

    #Unmapped address 0xf2f testing: Read Reset + Random data Write/Read
    #Address 0xf2f read value
    csrr x14, 0xf2f

    #Address 0xf2f Write value 0x893ea0bf
    li x3, 0x893ea0bf
    csrw 0xf2f, x3

    #Address 0xf2f read value
    csrr x14, 0xf2f

    #Unmapped address 0x20c testing: Read Reset + Random data Write/Read
    #Address 0x20c read value
    csrr x14, 0x20c

    #Address 0x20c Write value 0x28949f63
    li x3, 0x28949f63
    csrw 0x20c, x3

    #Address 0x20c read value
    csrr x14, 0x20c

    #Unmapped address 0xd34 testing: Read Reset + Random data Write/Read
    #Address 0xd34 read value
    csrr x14, 0xd34

    #Address 0xd34 Write value 0xad3dafe2
    li x3, 0xad3dafe2
    csrw 0xd34, x3

    #Address 0xd34 read value
    csrr x14, 0xd34

    #Unmapped address 0xa14 testing: Read Reset + Random data Write/Read
    #Address 0xa14 read value
    csrr x14, 0xa14

    #Address 0xa14 Write value 0x8e132fd9
    li x3, 0x8e132fd9
    csrw 0xa14, x3

    #Address 0xa14 read value
    csrr x14, 0xa14

    #Unmapped address 0xc6 testing: Read Reset + Random data Write/Read
    #Address 0xc6 read value
    csrr x14, 0xc6

    #Address 0xc6 Write value 0x49769943
    li x3, 0x49769943
    csrw 0xc6, x3

    #Address 0xc6 read value
    csrr x14, 0xc6

    #Unmapped address 0x744 testing: Read Reset + Random data Write/Read
    #Address 0x744 read value
    csrr x14, 0x744

    #Address 0x744 Write value 0x6d3702d9
    li x3, 0x6d3702d9
    csrw 0x744, x3

    #Address 0x744 read value
    csrr x14, 0x744

    #Unmapped address 0x60f testing: Read Reset + Random data Write/Read
    #Address 0x60f read value
    csrr x14, 0x60f

    #Address 0x60f Write value 0xda755393
    li x3, 0xda755393
    csrw 0x60f, x3

    #Address 0x60f read value
    csrr x14, 0x60f

    #Unmapped address 0xe65 testing: Read Reset + Random data Write/Read
    #Address 0xe65 read value
    csrr x14, 0xe65

    #Address 0xe65 Write value 0xd3a91afb
    li x3, 0xd3a91afb
    csrw 0xe65, x3

    #Address 0xe65 read value
    csrr x14, 0xe65

    #Unmapped address 0xd5a testing: Read Reset + Random data Write/Read
    #Address 0xd5a read value
    csrr x14, 0xd5a

    #Address 0xd5a Write value 0x356a5cd7
    li x3, 0x356a5cd7
    csrw 0xd5a, x3

    #Address 0xd5a read value
    csrr x14, 0xd5a

    #Unmapped address 0x160 testing: Read Reset + Random data Write/Read
    #Address 0x160 read value
    csrr x14, 0x160

    #Address 0x160 Write value 0x164727b8
    li x3, 0x164727b8
    csrw 0x160, x3

    #Address 0x160 read value
    csrr x14, 0x160

    #Unmapped address 0x456 testing: Read Reset + Random data Write/Read
    #Address 0x456 read value
    csrr x14, 0x456

    #Address 0x456 Write value 0xb5fe75a5
    li x3, 0xb5fe75a5
    csrw 0x456, x3

    #Address 0x456 read value
    csrr x14, 0x456

    #Unmapped address 0xaba testing: Read Reset + Random data Write/Read
    #Address 0xaba read value
    csrr x14, 0xaba

    #Address 0xaba Write value 0xc2e56dce
    li x3, 0xc2e56dce
    csrw 0xaba, x3

    #Address 0xaba read value
    csrr x14, 0xaba

    #Unmapped address 0xe36 testing: Read Reset + Random data Write/Read
    #Address 0xe36 read value
    csrr x14, 0xe36

    #Address 0xe36 Write value 0x85799158
    li x3, 0x85799158
    csrw 0xe36, x3

    #Address 0xe36 read value
    csrr x14, 0xe36

    #Unmapped address 0x7d3 testing: Read Reset + Random data Write/Read
    #Address 0x7d3 read value
    csrr x14, 0x7d3

    #Address 0x7d3 Write value 0x1afbcb8b
    li x3, 0x1afbcb8b
    csrw 0x7d3, x3

    #Address 0x7d3 read value
    csrr x14, 0x7d3

    #Unmapped address 0x862 testing: Read Reset + Random data Write/Read
    #Address 0x862 read value
    csrr x14, 0x862

    #Address 0x862 Write value 0x3b72c7b5
    li x3, 0x3b72c7b5
    csrw 0x862, x3

    #Address 0x862 read value
    csrr x14, 0x862

    #Unmapped address 0x4f9 testing: Read Reset + Random data Write/Read
    #Address 0x4f9 read value
    csrr x14, 0x4f9

    #Address 0x4f9 Write value 0x4c32ff03
    li x3, 0x4c32ff03
    csrw 0x4f9, x3

    #Address 0x4f9 read value
    csrr x14, 0x4f9

    #Unmapped address 0x8e6 testing: Read Reset + Random data Write/Read
    #Address 0x8e6 read value
    csrr x14, 0x8e6

    #Address 0x8e6 Write value 0x3dd57b43
    li x3, 0x3dd57b43
    csrw 0x8e6, x3

    #Address 0x8e6 read value
    csrr x14, 0x8e6

    #Unmapped address 0xe59 testing: Read Reset + Random data Write/Read
    #Address 0xe59 read value
    csrr x14, 0xe59

    #Address 0xe59 Write value 0x92745b95
    li x3, 0x92745b95
    csrw 0xe59, x3

    #Address 0xe59 read value
    csrr x14, 0xe59

    #Unmapped address 0x60a testing: Read Reset + Random data Write/Read
    #Address 0x60a read value
    csrr x14, 0x60a

    #Address 0x60a Write value 0xc884880b
    li x3, 0xc884880b
    csrw 0x60a, x3

    #Address 0x60a read value
    csrr x14, 0x60a

    #Unmapped address 0xe66 testing: Read Reset + Random data Write/Read
    #Address 0xe66 read value
    csrr x14, 0xe66

    #Address 0xe66 Write value 0x5696e3ee
    li x3, 0x5696e3ee
    csrw 0xe66, x3

    #Address 0xe66 read value
    csrr x14, 0xe66

    #Unmapped address 0x399 testing: Read Reset + Random data Write/Read
    #Address 0x399 read value
    csrr x14, 0x399

    #Address 0x399 Write value 0xb74fc5c8
    li x3, 0xb74fc5c8
    csrw 0x399, x3

    #Address 0x399 read value
    csrr x14, 0x399

    #Unmapped address 0x48e testing: Read Reset + Random data Write/Read
    #Address 0x48e read value
    csrr x14, 0x48e

    #Address 0x48e Write value 0x8fb1f201
    li x3, 0x8fb1f201
    csrw 0x48e, x3

    #Address 0x48e read value
    csrr x14, 0x48e

    #Unmapped address 0xc30 testing: Read Reset + Random data Write/Read
    #Address 0xc30 read value
    csrr x14, 0xc30

    #Address 0xc30 Write value 0xc0fecdf
    li x3, 0xc0fecdf
    csrw 0xc30, x3

    #Address 0xc30 read value
    csrr x14, 0xc30

    #Unmapped address 0xbe1 testing: Read Reset + Random data Write/Read
    #Address 0xbe1 read value
    csrr x14, 0xbe1

    #Address 0xbe1 Write value 0xdda3c17
    li x3, 0xdda3c17
    csrw 0xbe1, x3

    #Address 0xbe1 read value
    csrr x14, 0xbe1

    #Unmapped address 0xc4c testing: Read Reset + Random data Write/Read
    #Address 0xc4c read value
    csrr x14, 0xc4c

    #Address 0xc4c Write value 0x1c641ccb
    li x3, 0x1c641ccb
    csrw 0xc4c, x3

    #Address 0xc4c read value
    csrr x14, 0xc4c

    #Unmapped address 0x2e2 testing: Read Reset + Random data Write/Read
    #Address 0x2e2 read value
    csrr x14, 0x2e2

    #Address 0x2e2 Write value 0x1105e4ed
    li x3, 0x1105e4ed
    csrw 0x2e2, x3

    #Address 0x2e2 read value
    csrr x14, 0x2e2

    #Unmapped address 0xe04 testing: Read Reset + Random data Write/Read
    #Address 0xe04 read value
    csrr x14, 0xe04

    #Address 0xe04 Write value 0x5704f391
    li x3, 0x5704f391
    csrw 0xe04, x3

    #Address 0xe04 read value
    csrr x14, 0xe04

    #Unmapped address 0x945 testing: Read Reset + Random data Write/Read
    #Address 0x945 read value
    csrr x14, 0x945

    #Address 0x945 Write value 0x425eef12
    li x3, 0x425eef12
    csrw 0x945, x3

    #Address 0x945 read value
    csrr x14, 0x945

    #Unmapped address 0x74e testing: Read Reset + Random data Write/Read
    #Address 0x74e read value
    csrr x14, 0x74e

    #Address 0x74e Write value 0xf0e43570
    li x3, 0xf0e43570
    csrw 0x74e, x3

    #Address 0x74e read value
    csrr x14, 0x74e

    #Unmapped address 0x35a testing: Read Reset + Random data Write/Read
    #Address 0x35a read value
    csrr x14, 0x35a

    #Address 0x35a Write value 0x59973a04
    li x3, 0x59973a04
    csrw 0x35a, x3

    #Address 0x35a read value
    csrr x14, 0x35a

    #Unmapped address 0x932 testing: Read Reset + Random data Write/Read
    #Address 0x932 read value
    csrr x14, 0x932

    #Address 0x932 Write value 0x10e79c93
    li x3, 0x10e79c93
    csrw 0x932, x3

    #Address 0x932 read value
    csrr x14, 0x932

    #Unmapped address 0xdb3 testing: Read Reset + Random data Write/Read
    #Address 0xdb3 read value
    csrr x14, 0xdb3

    #Address 0xdb3 Write value 0x8b223c44
    li x3, 0x8b223c44
    csrw 0xdb3, x3

    #Address 0xdb3 read value
    csrr x14, 0xdb3

    #Unmapped address 0x67d testing: Read Reset + Random data Write/Read
    #Address 0x67d read value
    csrr x14, 0x67d

    #Address 0x67d Write value 0x558a6ba5
    li x3, 0x558a6ba5
    csrw 0x67d, x3

    #Address 0x67d read value
    csrr x14, 0x67d

    #Unmapped address 0x458 testing: Read Reset + Random data Write/Read
    #Address 0x458 read value
    csrr x14, 0x458

    #Address 0x458 Write value 0x4aab5119
    li x3, 0x4aab5119
    csrw 0x458, x3

    #Address 0x458 read value
    csrr x14, 0x458

    #Unmapped address 0x2d8 testing: Read Reset + Random data Write/Read
    #Address 0x2d8 read value
    csrr x14, 0x2d8

    #Address 0x2d8 Write value 0xb718ffae
    li x3, 0xb718ffae
    csrw 0x2d8, x3

    #Address 0x2d8 read value
    csrr x14, 0x2d8

    #Unmapped address 0x41e testing: Read Reset + Random data Write/Read
    #Address 0x41e read value
    csrr x14, 0x41e

    #Address 0x41e Write value 0x7457f957
    li x3, 0x7457f957
    csrw 0x41e, x3

    #Address 0x41e read value
    csrr x14, 0x41e

    #Unmapped address 0xa83 testing: Read Reset + Random data Write/Read
    #Address 0xa83 read value
    csrr x14, 0xa83

    #Address 0xa83 Write value 0x30e4955f
    li x3, 0x30e4955f
    csrw 0xa83, x3

    #Address 0xa83 read value
    csrr x14, 0xa83

    #Unmapped address 0x85e testing: Read Reset + Random data Write/Read
    #Address 0x85e read value
    csrr x14, 0x85e

    #Address 0x85e Write value 0x660c828
    li x3, 0x660c828
    csrw 0x85e, x3

    #Address 0x85e read value
    csrr x14, 0x85e

    #Unmapped address 0x73a testing: Read Reset + Random data Write/Read
    #Address 0x73a read value
    csrr x14, 0x73a

    #Address 0x73a Write value 0xd77e1832
    li x3, 0xd77e1832
    csrw 0x73a, x3

    #Address 0x73a read value
    csrr x14, 0x73a

    #Unmapped address 0xe31 testing: Read Reset + Random data Write/Read
    #Address 0xe31 read value
    csrr x14, 0xe31

    #Address 0xe31 Write value 0x2a7d450
    li x3, 0x2a7d450
    csrw 0xe31, x3

    #Address 0xe31 read value
    csrr x14, 0xe31

    #Unmapped address 0x4a0 testing: Read Reset + Random data Write/Read
    #Address 0x4a0 read value
    csrr x14, 0x4a0

    #Address 0x4a0 Write value 0x3a9d98de
    li x3, 0x3a9d98de
    csrw 0x4a0, x3

    #Address 0x4a0 read value
    csrr x14, 0x4a0

    #Unmapped address 0x718 testing: Read Reset + Random data Write/Read
    #Address 0x718 read value
    csrr x14, 0x718

    #Address 0x718 Write value 0x441f5ff0
    li x3, 0x441f5ff0
    csrw 0x718, x3

    #Address 0x718 read value
    csrr x14, 0x718

    #Unmapped address 0x17a testing: Read Reset + Random data Write/Read
    #Address 0x17a read value
    csrr x14, 0x17a

    #Address 0x17a Write value 0x67e827dc
    li x3, 0x67e827dc
    csrw 0x17a, x3

    #Address 0x17a read value
    csrr x14, 0x17a

    #Unmapped address 0xe28 testing: Read Reset + Random data Write/Read
    #Address 0xe28 read value
    csrr x14, 0xe28

    #Address 0xe28 Write value 0x938d7d64
    li x3, 0x938d7d64
    csrw 0xe28, x3

    #Address 0xe28 read value
    csrr x14, 0xe28

    #Unmapped address 0x39f testing: Read Reset + Random data Write/Read
    #Address 0x39f read value
    csrr x14, 0x39f

    #Address 0x39f Write value 0x7feb1496
    li x3, 0x7feb1496
    csrw 0x39f, x3

    #Address 0x39f read value
    csrr x14, 0x39f

    #Unmapped address 0x48d testing: Read Reset + Random data Write/Read
    #Address 0x48d read value
    csrr x14, 0x48d

    #Address 0x48d Write value 0x16bdf839
    li x3, 0x16bdf839
    csrw 0x48d, x3

    #Address 0x48d read value
    csrr x14, 0x48d

    #Unmapped address 0x48a testing: Read Reset + Random data Write/Read
    #Address 0x48a read value
    csrr x14, 0x48a

    #Address 0x48a Write value 0x4a5bc3
    li x3, 0x4a5bc3
    csrw 0x48a, x3

    #Address 0x48a read value
    csrr x14, 0x48a

    #Unmapped address 0x67 testing: Read Reset + Random data Write/Read
    #Address 0x67 read value
    csrr x14, 0x67

    #Address 0x67 Write value 0x12f45ed2
    li x3, 0x12f45ed2
    csrw 0x67, x3

    #Address 0x67 read value
    csrr x14, 0x67

    #Unmapped address 0xb75 testing: Read Reset + Random data Write/Read
    #Address 0xb75 read value
    csrr x14, 0xb75

    #Address 0xb75 Write value 0x10096b41
    li x3, 0x10096b41
    csrw 0xb75, x3

    #Address 0xb75 read value
    csrr x14, 0xb75

    #Unmapped address 0x9d0 testing: Read Reset + Random data Write/Read
    #Address 0x9d0 read value
    csrr x14, 0x9d0

    #Address 0x9d0 Write value 0x94f5df76
    li x3, 0x94f5df76
    csrw 0x9d0, x3

    #Address 0x9d0 read value
    csrr x14, 0x9d0

    #Unmapped address 0x72d testing: Read Reset + Random data Write/Read
    #Address 0x72d read value
    csrr x14, 0x72d

    #Address 0x72d Write value 0xe41cc76d
    li x3, 0xe41cc76d
    csrw 0x72d, x3

    #Address 0x72d read value
    csrr x14, 0x72d

    #Unmapped address 0xfe2 testing: Read Reset + Random data Write/Read
    #Address 0xfe2 read value
    csrr x14, 0xfe2

    #Address 0xfe2 Write value 0x5902772f
    li x3, 0x5902772f
    csrw 0xfe2, x3

    #Address 0xfe2 read value
    csrr x14, 0xfe2

    #Unmapped address 0x2b6 testing: Read Reset + Random data Write/Read
    #Address 0x2b6 read value
    csrr x14, 0x2b6

    #Address 0x2b6 Write value 0xe2d2aa22
    li x3, 0xe2d2aa22
    csrw 0x2b6, x3

    #Address 0x2b6 read value
    csrr x14, 0x2b6

    #Unmapped address 0x30b testing: Read Reset + Random data Write/Read
    #Address 0x30b read value
    csrr x14, 0x30b

    #Address 0x30b Write value 0x1fa7d122
    li x3, 0x1fa7d122
    csrw 0x30b, x3

    #Address 0x30b read value
    csrr x14, 0x30b

    #Unmapped address 0xcbe testing: Read Reset + Random data Write/Read
    #Address 0xcbe read value
    csrr x14, 0xcbe

    #Address 0xcbe Write value 0x428f1580
    li x3, 0x428f1580
    csrw 0xcbe, x3

    #Address 0xcbe read value
    csrr x14, 0xcbe

    #Unmapped address 0x3f1 testing: Read Reset + Random data Write/Read
    #Address 0x3f1 read value
    csrr x14, 0x3f1

    #Address 0x3f1 Write value 0xc9c94c9f
    li x3, 0xc9c94c9f
    csrw 0x3f1, x3

    #Address 0x3f1 read value
    csrr x14, 0x3f1

    #Unmapped address 0xf3e testing: Read Reset + Random data Write/Read
    #Address 0xf3e read value
    csrr x14, 0xf3e

    #Address 0xf3e Write value 0x68a404bd
    li x3, 0x68a404bd
    csrw 0xf3e, x3

    #Address 0xf3e read value
    csrr x14, 0xf3e

    #Unmapped address 0x9c5 testing: Read Reset + Random data Write/Read
    #Address 0x9c5 read value
    csrr x14, 0x9c5

    #Address 0x9c5 Write value 0x526fa5b5
    li x3, 0x526fa5b5
    csrw 0x9c5, x3

    #Address 0x9c5 read value
    csrr x14, 0x9c5

    #Unmapped address 0xe88 testing: Read Reset + Random data Write/Read
    #Address 0xe88 read value
    csrr x14, 0xe88

    #Address 0xe88 Write value 0x7492ff87
    li x3, 0x7492ff87
    csrw 0xe88, x3

    #Address 0xe88 read value
    csrr x14, 0xe88

    #Unmapped address 0xa25 testing: Read Reset + Random data Write/Read
    #Address 0xa25 read value
    csrr x14, 0xa25

    #Address 0xa25 Write value 0xa3bb949
    li x3, 0xa3bb949
    csrw 0xa25, x3

    #Address 0xa25 read value
    csrr x14, 0xa25

    #Unmapped address 0x8e4 testing: Read Reset + Random data Write/Read
    #Address 0x8e4 read value
    csrr x14, 0x8e4

    #Address 0x8e4 Write value 0xd8f844df
    li x3, 0xd8f844df
    csrw 0x8e4, x3

    #Address 0x8e4 read value
    csrr x14, 0x8e4

    #Unmapped address 0x701 testing: Read Reset + Random data Write/Read
    #Address 0x701 read value
    csrr x14, 0x701

    #Address 0x701 Write value 0x56f89c09
    li x3, 0x56f89c09
    csrw 0x701, x3

    #Address 0x701 read value
    csrr x14, 0x701

    #Unmapped address 0x9f testing: Read Reset + Random data Write/Read
    #Address 0x9f read value
    csrr x14, 0x9f

    #Address 0x9f Write value 0xd66ea171
    li x3, 0xd66ea171
    csrw 0x9f, x3

    #Address 0x9f read value
    csrr x14, 0x9f

    #Unmapped address 0xf97 testing: Read Reset + Random data Write/Read
    #Address 0xf97 read value
    csrr x14, 0xf97

    #Address 0xf97 Write value 0xffae89ae
    li x3, 0xffae89ae
    csrw 0xf97, x3

    #Address 0xf97 read value
    csrr x14, 0xf97

    #Unmapped address 0x39 testing: Read Reset + Random data Write/Read
    #Address 0x39 read value
    csrr x14, 0x39

    #Address 0x39 Write value 0x7cd11590
    li x3, 0x7cd11590
    csrw 0x39, x3

    #Address 0x39 read value
    csrr x14, 0x39

    #Unmapped address 0x5c testing: Read Reset + Random data Write/Read
    #Address 0x5c read value
    csrr x14, 0x5c

    #Address 0x5c Write value 0x37b0bcba
    li x3, 0x37b0bcba
    csrw 0x5c, x3

    #Address 0x5c read value
    csrr x14, 0x5c

    #Unmapped address 0x9d1 testing: Read Reset + Random data Write/Read
    #Address 0x9d1 read value
    csrr x14, 0x9d1

    #Address 0x9d1 Write value 0x349e45db
    li x3, 0x349e45db
    csrw 0x9d1, x3

    #Address 0x9d1 read value
    csrr x14, 0x9d1

    #Unmapped address 0x765 testing: Read Reset + Random data Write/Read
    #Address 0x765 read value
    csrr x14, 0x765

    #Address 0x765 Write value 0x28d89553
    li x3, 0x28d89553
    csrw 0x765, x3

    #Address 0x765 read value
    csrr x14, 0x765

    #Unmapped address 0xff4 testing: Read Reset + Random data Write/Read
    #Address 0xff4 read value
    csrr x14, 0xff4

    #Address 0xff4 Write value 0xaeb9c425
    li x3, 0xaeb9c425
    csrw 0xff4, x3

    #Address 0xff4 read value
    csrr x14, 0xff4

    #Unmapped address 0xacb testing: Read Reset + Random data Write/Read
    #Address 0xacb read value
    csrr x14, 0xacb

    #Address 0xacb Write value 0x239f97a4
    li x3, 0x239f97a4
    csrw 0xacb, x3

    #Address 0xacb read value
    csrr x14, 0xacb

    #Unmapped address 0x568 testing: Read Reset + Random data Write/Read
    #Address 0x568 read value
    csrr x14, 0x568

    #Address 0x568 Write value 0x96df10f9
    li x3, 0x96df10f9
    csrw 0x568, x3

    #Address 0x568 read value
    csrr x14, 0x568

    #Unmapped address 0xff3 testing: Read Reset + Random data Write/Read
    #Address 0xff3 read value
    csrr x14, 0xff3

    #Address 0xff3 Write value 0x6b5a5999
    li x3, 0x6b5a5999
    csrw 0xff3, x3

    #Address 0xff3 read value
    csrr x14, 0xff3

    #Unmapped address 0x7d7 testing: Read Reset + Random data Write/Read
    #Address 0x7d7 read value
    csrr x14, 0x7d7

    #Address 0x7d7 Write value 0x6ce9cf29
    li x3, 0x6ce9cf29
    csrw 0x7d7, x3

    #Address 0x7d7 read value
    csrr x14, 0x7d7

    #Unmapped address 0xbf7 testing: Read Reset + Random data Write/Read
    #Address 0xbf7 read value
    csrr x14, 0xbf7

    #Address 0xbf7 Write value 0xb969cca
    li x3, 0xb969cca
    csrw 0xbf7, x3

    #Address 0xbf7 read value
    csrr x14, 0xbf7

    #Unmapped address 0x4fb testing: Read Reset + Random data Write/Read
    #Address 0x4fb read value
    csrr x14, 0x4fb

    #Address 0x4fb Write value 0x4c8cd3f5
    li x3, 0x4c8cd3f5
    csrw 0x4fb, x3

    #Address 0x4fb read value
    csrr x14, 0x4fb

    #Unmapped address 0xbdf testing: Read Reset + Random data Write/Read
    #Address 0xbdf read value
    csrr x14, 0xbdf

    #Address 0xbdf Write value 0x4201942a
    li x3, 0x4201942a
    csrw 0xbdf, x3

    #Address 0xbdf read value
    csrr x14, 0xbdf

    #Unmapped address 0x1a testing: Read Reset + Random data Write/Read
    #Address 0x1a read value
    csrr x14, 0x1a

    #Address 0x1a Write value 0x2a6eb939
    li x3, 0x2a6eb939
    csrw 0x1a, x3

    #Address 0x1a read value
    csrr x14, 0x1a

    #Unmapped address 0xc2b testing: Read Reset + Random data Write/Read
    #Address 0xc2b read value
    csrr x14, 0xc2b

    #Address 0xc2b Write value 0x65ca94c8
    li x3, 0x65ca94c8
    csrw 0xc2b, x3

    #Address 0xc2b read value
    csrr x14, 0xc2b

    #Unmapped address 0x737 testing: Read Reset + Random data Write/Read
    #Address 0x737 read value
    csrr x14, 0x737

    #Address 0x737 Write value 0xfc77f98a
    li x3, 0xfc77f98a
    csrw 0x737, x3

    #Address 0x737 read value
    csrr x14, 0x737

    #Unmapped address 0xf5b testing: Read Reset + Random data Write/Read
    #Address 0xf5b read value
    csrr x14, 0xf5b

    #Address 0xf5b Write value 0x3ba91e74
    li x3, 0x3ba91e74
    csrw 0xf5b, x3

    #Address 0xf5b read value
    csrr x14, 0xf5b

    #Unmapped address 0x205 testing: Read Reset + Random data Write/Read
    #Address 0x205 read value
    csrr x14, 0x205

    #Address 0x205 Write value 0xae2969f7
    li x3, 0xae2969f7
    csrw 0x205, x3

    #Address 0x205 read value
    csrr x14, 0x205

    #Unmapped address 0xcf5 testing: Read Reset + Random data Write/Read
    #Address 0xcf5 read value
    csrr x14, 0xcf5

    #Address 0xcf5 Write value 0x86ae5b63
    li x3, 0x86ae5b63
    csrw 0xcf5, x3

    #Address 0xcf5 read value
    csrr x14, 0xcf5

    #Unmapped address 0xd11 testing: Read Reset + Random data Write/Read
    #Address 0xd11 read value
    csrr x14, 0xd11

    #Address 0xd11 Write value 0x7915c5cb
    li x3, 0x7915c5cb
    csrw 0xd11, x3

    #Address 0xd11 read value
    csrr x14, 0xd11

    #Unmapped address 0x8f1 testing: Read Reset + Random data Write/Read
    #Address 0x8f1 read value
    csrr x14, 0x8f1

    #Address 0x8f1 Write value 0x42f6c2a
    li x3, 0x42f6c2a
    csrw 0x8f1, x3

    #Address 0x8f1 read value
    csrr x14, 0x8f1

    #Unmapped address 0x7c4 testing: Read Reset + Random data Write/Read
    #Address 0x7c4 read value
    csrr x14, 0x7c4

    #Address 0x7c4 Write value 0xff3f6497
    li x3, 0xff3f6497
    csrw 0x7c4, x3

    #Address 0x7c4 read value
    csrr x14, 0x7c4

    #Unmapped address 0x944 testing: Read Reset + Random data Write/Read
    #Address 0x944 read value
    csrr x14, 0x944

    #Address 0x944 Write value 0x620a0571
    li x3, 0x620a0571
    csrw 0x944, x3

    #Address 0x944 read value
    csrr x14, 0x944

    #Unmapped address 0x791 testing: Read Reset + Random data Write/Read
    #Address 0x791 read value
    csrr x14, 0x791

    #Address 0x791 Write value 0xd46a90dc
    li x3, 0xd46a90dc
    csrw 0x791, x3

    #Address 0x791 read value
    csrr x14, 0x791

    #Unmapped address 0xb24 testing: Read Reset + Random data Write/Read
    #Address 0xb24 read value
    csrr x14, 0xb24

    #Address 0xb24 Write value 0x33231631
    li x3, 0x33231631
    csrw 0xb24, x3

    #Address 0xb24 read value
    csrr x14, 0xb24

    #Unmapped address 0x39a testing: Read Reset + Random data Write/Read
    #Address 0x39a read value
    csrr x14, 0x39a

    #Address 0x39a Write value 0x84eccb66
    li x3, 0x84eccb66
    csrw 0x39a, x3

    #Address 0x39a read value
    csrr x14, 0x39a

    #Unmapped address 0xa5f testing: Read Reset + Random data Write/Read
    #Address 0xa5f read value
    csrr x14, 0xa5f

    #Address 0xa5f Write value 0x5de2aaf
    li x3, 0x5de2aaf
    csrw 0xa5f, x3

    #Address 0xa5f read value
    csrr x14, 0xa5f

    #Unmapped address 0xe9b testing: Read Reset + Random data Write/Read
    #Address 0xe9b read value
    csrr x14, 0xe9b

    #Address 0xe9b Write value 0x690d1d78
    li x3, 0x690d1d78
    csrw 0xe9b, x3

    #Address 0xe9b read value
    csrr x14, 0xe9b

    #Unmapped address 0x2d1 testing: Read Reset + Random data Write/Read
    #Address 0x2d1 read value
    csrr x14, 0x2d1

    #Address 0x2d1 Write value 0x25d777e6
    li x3, 0x25d777e6
    csrw 0x2d1, x3

    #Address 0x2d1 read value
    csrr x14, 0x2d1

    #Unmapped address 0xc6c testing: Read Reset + Random data Write/Read
    #Address 0xc6c read value
    csrr x14, 0xc6c

    #Address 0xc6c Write value 0x38d650d0
    li x3, 0x38d650d0
    csrw 0xc6c, x3

    #Address 0xc6c read value
    csrr x14, 0xc6c

    #Unmapped address 0xa27 testing: Read Reset + Random data Write/Read
    #Address 0xa27 read value
    csrr x14, 0xa27

    #Address 0xa27 Write value 0xfd207b84
    li x3, 0xfd207b84
    csrw 0xa27, x3

    #Address 0xa27 read value
    csrr x14, 0xa27

    #Unmapped address 0x43b testing: Read Reset + Random data Write/Read
    #Address 0x43b read value
    csrr x14, 0x43b

    #Address 0x43b Write value 0x23e1810d
    li x3, 0x23e1810d
    csrw 0x43b, x3

    #Address 0x43b read value
    csrr x14, 0x43b

    #Unmapped address 0x346 testing: Read Reset + Random data Write/Read
    #Address 0x346 read value
    csrr x14, 0x346

    #Address 0x346 Write value 0xaabe333e
    li x3, 0xaabe333e
    csrw 0x346, x3

    #Address 0x346 read value
    csrr x14, 0x346

    #Unmapped address 0x805 testing: Read Reset + Random data Write/Read
    #Address 0x805 read value
    csrr x14, 0x805

    #Address 0x805 Write value 0x7794560e
    li x3, 0x7794560e
    csrw 0x805, x3

    #Address 0x805 read value
    csrr x14, 0x805

    #Unmapped address 0x865 testing: Read Reset + Random data Write/Read
    #Address 0x865 read value
    csrr x14, 0x865

    #Address 0x865 Write value 0xa7324fcf
    li x3, 0xa7324fcf
    csrw 0x865, x3

    #Address 0x865 read value
    csrr x14, 0x865

    #Unmapped address 0x292 testing: Read Reset + Random data Write/Read
    #Address 0x292 read value
    csrr x14, 0x292

    #Address 0x292 Write value 0xba4c1
    li x3, 0xba4c1
    csrw 0x292, x3

    #Address 0x292 read value
    csrr x14, 0x292

    #Unmapped address 0x575 testing: Read Reset + Random data Write/Read
    #Address 0x575 read value
    csrr x14, 0x575

    #Address 0x575 Write value 0xac584c80
    li x3, 0xac584c80
    csrw 0x575, x3

    #Address 0x575 read value
    csrr x14, 0x575

    #Unmapped address 0x618 testing: Read Reset + Random data Write/Read
    #Address 0x618 read value
    csrr x14, 0x618

    #Address 0x618 Write value 0x289f1ea8
    li x3, 0x289f1ea8
    csrw 0x618, x3

    #Address 0x618 read value
    csrr x14, 0x618

    #Unmapped address 0xb7a testing: Read Reset + Random data Write/Read
    #Address 0xb7a read value
    csrr x14, 0xb7a

    #Address 0xb7a Write value 0xaf2fe617
    li x3, 0xaf2fe617
    csrw 0xb7a, x3

    #Address 0xb7a read value
    csrr x14, 0xb7a

    #Unmapped address 0xa5 testing: Read Reset + Random data Write/Read
    #Address 0xa5 read value
    csrr x14, 0xa5

    #Address 0xa5 Write value 0x723f1b39
    li x3, 0x723f1b39
    csrw 0xa5, x3

    #Address 0xa5 read value
    csrr x14, 0xa5

    #Unmapped address 0x693 testing: Read Reset + Random data Write/Read
    #Address 0x693 read value
    csrr x14, 0x693

    #Address 0x693 Write value 0xb0197a5a
    li x3, 0xb0197a5a
    csrw 0x693, x3

    #Address 0x693 read value
    csrr x14, 0x693

    #Unmapped address 0x837 testing: Read Reset + Random data Write/Read
    #Address 0x837 read value
    csrr x14, 0x837

    #Address 0x837 Write value 0x9ebf56c6
    li x3, 0x9ebf56c6
    csrw 0x837, x3

    #Address 0x837 read value
    csrr x14, 0x837

    #Unmapped address 0x9a8 testing: Read Reset + Random data Write/Read
    #Address 0x9a8 read value
    csrr x14, 0x9a8

    #Address 0x9a8 Write value 0xefd2743d
    li x3, 0xefd2743d
    csrw 0x9a8, x3

    #Address 0x9a8 read value
    csrr x14, 0x9a8

    #Unmapped address 0x6d5 testing: Read Reset + Random data Write/Read
    #Address 0x6d5 read value
    csrr x14, 0x6d5

    #Address 0x6d5 Write value 0x8185db3
    li x3, 0x8185db3
    csrw 0x6d5, x3

    #Address 0x6d5 read value
    csrr x14, 0x6d5

    #Unmapped address 0x829 testing: Read Reset + Random data Write/Read
    #Address 0x829 read value
    csrr x14, 0x829

    #Address 0x829 Write value 0x9797fa99
    li x3, 0x9797fa99
    csrw 0x829, x3

    #Address 0x829 read value
    csrr x14, 0x829

    #Unmapped address 0x4f testing: Read Reset + Random data Write/Read
    #Address 0x4f read value
    csrr x14, 0x4f

    #Address 0x4f Write value 0x11ea863
    li x3, 0x11ea863
    csrw 0x4f, x3

    #Address 0x4f read value
    csrr x14, 0x4f

    #Unmapped address 0x1c4 testing: Read Reset + Random data Write/Read
    #Address 0x1c4 read value
    csrr x14, 0x1c4

    #Address 0x1c4 Write value 0x14a40f24
    li x3, 0x14a40f24
    csrw 0x1c4, x3

    #Address 0x1c4 read value
    csrr x14, 0x1c4

    #Unmapped address 0x48 testing: Read Reset + Random data Write/Read
    #Address 0x48 read value
    csrr x14, 0x48

    #Address 0x48 Write value 0xca065923
    li x3, 0xca065923
    csrw 0x48, x3

    #Address 0x48 read value
    csrr x14, 0x48

    #Unmapped address 0x1f2 testing: Read Reset + Random data Write/Read
    #Address 0x1f2 read value
    csrr x14, 0x1f2

    #Address 0x1f2 Write value 0x3cf6e2bb
    li x3, 0x3cf6e2bb
    csrw 0x1f2, x3

    #Address 0x1f2 read value
    csrr x14, 0x1f2

    #Unmapped address 0xdaa testing: Read Reset + Random data Write/Read
    #Address 0xdaa read value
    csrr x14, 0xdaa

    #Address 0xdaa Write value 0x626ea0ca
    li x3, 0x626ea0ca
    csrw 0xdaa, x3

    #Address 0xdaa read value
    csrr x14, 0xdaa

    #Unmapped address 0x774 testing: Read Reset + Random data Write/Read
    #Address 0x774 read value
    csrr x14, 0x774

    #Address 0x774 Write value 0xecb4946a
    li x3, 0xecb4946a
    csrw 0x774, x3

    #Address 0x774 read value
    csrr x14, 0x774

    #Unmapped address 0x22a testing: Read Reset + Random data Write/Read
    #Address 0x22a read value
    csrr x14, 0x22a

    #Address 0x22a Write value 0xb13f141a
    li x3, 0xb13f141a
    csrw 0x22a, x3

    #Address 0x22a read value
    csrr x14, 0x22a

    #Unmapped address 0x130 testing: Read Reset + Random data Write/Read
    #Address 0x130 read value
    csrr x14, 0x130

    #Address 0x130 Write value 0x1e1b2050
    li x3, 0x1e1b2050
    csrw 0x130, x3

    #Address 0x130 read value
    csrr x14, 0x130

    #Unmapped address 0x9db testing: Read Reset + Random data Write/Read
    #Address 0x9db read value
    csrr x14, 0x9db

    #Address 0x9db Write value 0x4c68a5c2
    li x3, 0x4c68a5c2
    csrw 0x9db, x3

    #Address 0x9db read value
    csrr x14, 0x9db

    #Unmapped address 0x23b testing: Read Reset + Random data Write/Read
    #Address 0x23b read value
    csrr x14, 0x23b

    #Address 0x23b Write value 0xdfec98b4
    li x3, 0xdfec98b4
    csrw 0x23b, x3

    #Address 0x23b read value
    csrr x14, 0x23b

    #Unmapped address 0x6ba testing: Read Reset + Random data Write/Read
    #Address 0x6ba read value
    csrr x14, 0x6ba

    #Address 0x6ba Write value 0xe8451627
    li x3, 0xe8451627
    csrw 0x6ba, x3

    #Address 0x6ba read value
    csrr x14, 0x6ba

    #Unmapped address 0xf8d testing: Read Reset + Random data Write/Read
    #Address 0xf8d read value
    csrr x14, 0xf8d

    #Address 0xf8d Write value 0x42529967
    li x3, 0x42529967
    csrw 0xf8d, x3

    #Address 0xf8d read value
    csrr x14, 0xf8d

    #Unmapped address 0xbd8 testing: Read Reset + Random data Write/Read
    #Address 0xbd8 read value
    csrr x14, 0xbd8

    #Address 0xbd8 Write value 0x21d626c7
    li x3, 0x21d626c7
    csrw 0xbd8, x3

    #Address 0xbd8 read value
    csrr x14, 0xbd8

    #Unmapped address 0xd63 testing: Read Reset + Random data Write/Read
    #Address 0xd63 read value
    csrr x14, 0xd63

    #Address 0xd63 Write value 0xb83566b9
    li x3, 0xb83566b9
    csrw 0xd63, x3

    #Address 0xd63 read value
    csrr x14, 0xd63

    #Unmapped address 0xff1 testing: Read Reset + Random data Write/Read
    #Address 0xff1 read value
    csrr x14, 0xff1

    #Address 0xff1 Write value 0xbc2f9936
    li x3, 0xbc2f9936
    csrw 0xff1, x3

    #Address 0xff1 read value
    csrr x14, 0xff1

    #Unmapped address 0x873 testing: Read Reset + Random data Write/Read
    #Address 0x873 read value
    csrr x14, 0x873

    #Address 0x873 Write value 0x7295c341
    li x3, 0x7295c341
    csrw 0x873, x3

    #Address 0x873 read value
    csrr x14, 0x873

    #Unmapped address 0x172 testing: Read Reset + Random data Write/Read
    #Address 0x172 read value
    csrr x14, 0x172

    #Address 0x172 Write value 0xb214d6cf
    li x3, 0xb214d6cf
    csrw 0x172, x3

    #Address 0x172 read value
    csrr x14, 0x172

    #Unmapped address 0x461 testing: Read Reset + Random data Write/Read
    #Address 0x461 read value
    csrr x14, 0x461

    #Address 0x461 Write value 0xf2b51e8f
    li x3, 0xf2b51e8f
    csrw 0x461, x3

    #Address 0x461 read value
    csrr x14, 0x461

    #Unmapped address 0x13d testing: Read Reset + Random data Write/Read
    #Address 0x13d read value
    csrr x14, 0x13d

    #Address 0x13d Write value 0xab8073cd
    li x3, 0xab8073cd
    csrw 0x13d, x3

    #Address 0x13d read value
    csrr x14, 0x13d

    #Unmapped address 0x604 testing: Read Reset + Random data Write/Read
    #Address 0x604 read value
    csrr x14, 0x604

    #Address 0x604 Write value 0x7fd377a4
    li x3, 0x7fd377a4
    csrw 0x604, x3

    #Address 0x604 read value
    csrr x14, 0x604

    #Unmapped address 0xabe testing: Read Reset + Random data Write/Read
    #Address 0xabe read value
    csrr x14, 0xabe

    #Address 0xabe Write value 0xa8c536b6
    li x3, 0xa8c536b6
    csrw 0xabe, x3

    #Address 0xabe read value
    csrr x14, 0xabe

    #Unmapped address 0xd76 testing: Read Reset + Random data Write/Read
    #Address 0xd76 read value
    csrr x14, 0xd76

    #Address 0xd76 Write value 0xff4f9be7
    li x3, 0xff4f9be7
    csrw 0xd76, x3

    #Address 0xd76 read value
    csrr x14, 0xd76

    #Unmapped address 0x59a testing: Read Reset + Random data Write/Read
    #Address 0x59a read value
    csrr x14, 0x59a

    #Address 0x59a Write value 0xe1cc552c
    li x3, 0xe1cc552c
    csrw 0x59a, x3

    #Address 0x59a read value
    csrr x14, 0x59a

    #Unmapped address 0xcc8 testing: Read Reset + Random data Write/Read
    #Address 0xcc8 read value
    csrr x14, 0xcc8

    #Address 0xcc8 Write value 0x1071a4b6
    li x3, 0x1071a4b6
    csrw 0xcc8, x3

    #Address 0xcc8 read value
    csrr x14, 0xcc8

    #Unmapped address 0xfe testing: Read Reset + Random data Write/Read
    #Address 0xfe read value
    csrr x14, 0xfe

    #Address 0xfe Write value 0xbd65f5b6
    li x3, 0xbd65f5b6
    csrw 0xfe, x3

    #Address 0xfe read value
    csrr x14, 0xfe

    #Unmapped address 0x520 testing: Read Reset + Random data Write/Read
    #Address 0x520 read value
    csrr x14, 0x520

    #Address 0x520 Write value 0xaf19a798
    li x3, 0xaf19a798
    csrw 0x520, x3

    #Address 0x520 read value
    csrr x14, 0x520

    #Unmapped address 0x448 testing: Read Reset + Random data Write/Read
    #Address 0x448 read value
    csrr x14, 0x448

    #Address 0x448 Write value 0xe8c79daa
    li x3, 0xe8c79daa
    csrw 0x448, x3

    #Address 0x448 read value
    csrr x14, 0x448

    #Unmapped address 0xb31 testing: Read Reset + Random data Write/Read
    #Address 0xb31 read value
    csrr x14, 0xb31

    #Address 0xb31 Write value 0xafa31547
    li x3, 0xafa31547
    csrw 0xb31, x3

    #Address 0xb31 read value
    csrr x14, 0xb31

    #Unmapped address 0xcbc testing: Read Reset + Random data Write/Read
    #Address 0xcbc read value
    csrr x14, 0xcbc

    #Address 0xcbc Write value 0xd78de01e
    li x3, 0xd78de01e
    csrw 0xcbc, x3

    #Address 0xcbc read value
    csrr x14, 0xcbc

    #Unmapped address 0xb48 testing: Read Reset + Random data Write/Read
    #Address 0xb48 read value
    csrr x14, 0xb48

    #Address 0xb48 Write value 0xe50927e1
    li x3, 0xe50927e1
    csrw 0xb48, x3

    #Address 0xb48 read value
    csrr x14, 0xb48

    #Unmapped address 0x63a testing: Read Reset + Random data Write/Read
    #Address 0x63a read value
    csrr x14, 0x63a

    #Address 0x63a Write value 0xf62e5947
    li x3, 0xf62e5947
    csrw 0x63a, x3

    #Address 0x63a read value
    csrr x14, 0x63a

    #Unmapped address 0xdfb testing: Read Reset + Random data Write/Read
    #Address 0xdfb read value
    csrr x14, 0xdfb

    #Address 0xdfb Write value 0x261e08a9
    li x3, 0x261e08a9
    csrw 0xdfb, x3

    #Address 0xdfb read value
    csrr x14, 0xdfb

    #Unmapped address 0x72f testing: Read Reset + Random data Write/Read
    #Address 0x72f read value
    csrr x14, 0x72f

    #Address 0x72f Write value 0x57bbed39
    li x3, 0x57bbed39
    csrw 0x72f, x3

    #Address 0x72f read value
    csrr x14, 0x72f

    #Unmapped address 0x291 testing: Read Reset + Random data Write/Read
    #Address 0x291 read value
    csrr x14, 0x291

    #Address 0x291 Write value 0x72dacc73
    li x3, 0x72dacc73
    csrw 0x291, x3

    #Address 0x291 read value
    csrr x14, 0x291

    #Unmapped address 0xc65 testing: Read Reset + Random data Write/Read
    #Address 0xc65 read value
    csrr x14, 0xc65

    #Address 0xc65 Write value 0xa57ab392
    li x3, 0xa57ab392
    csrw 0xc65, x3

    #Address 0xc65 read value
    csrr x14, 0xc65

    #Unmapped address 0xe3a testing: Read Reset + Random data Write/Read
    #Address 0xe3a read value
    csrr x14, 0xe3a

    #Address 0xe3a Write value 0xcbb16475
    li x3, 0xcbb16475
    csrw 0xe3a, x3

    #Address 0xe3a read value
    csrr x14, 0xe3a

    #Unmapped address 0x5b6 testing: Read Reset + Random data Write/Read
    #Address 0x5b6 read value
    csrr x14, 0x5b6

    #Address 0x5b6 Write value 0x5072c78
    li x3, 0x5072c78
    csrw 0x5b6, x3

    #Address 0x5b6 read value
    csrr x14, 0x5b6

    #Unmapped address 0x30f testing: Read Reset + Random data Write/Read
    #Address 0x30f read value
    csrr x14, 0x30f

    #Address 0x30f Write value 0x32d8e82d
    li x3, 0x32d8e82d
    csrw 0x30f, x3

    #Address 0x30f read value
    csrr x14, 0x30f

    #Unmapped address 0xdd8 testing: Read Reset + Random data Write/Read
    #Address 0xdd8 read value
    csrr x14, 0xdd8

    #Address 0xdd8 Write value 0xf60ecfab
    li x3, 0xf60ecfab
    csrw 0xdd8, x3

    #Address 0xdd8 read value
    csrr x14, 0xdd8

    #Unmapped address 0x71a testing: Read Reset + Random data Write/Read
    #Address 0x71a read value
    csrr x14, 0x71a

    #Address 0x71a Write value 0x536d77cb
    li x3, 0x536d77cb
    csrw 0x71a, x3

    #Address 0x71a read value
    csrr x14, 0x71a

    #Unmapped address 0x759 testing: Read Reset + Random data Write/Read
    #Address 0x759 read value
    csrr x14, 0x759

    #Address 0x759 Write value 0x8591959d
    li x3, 0x8591959d
    csrw 0x759, x3

    #Address 0x759 read value
    csrr x14, 0x759

    #Unmapped address 0x1e8 testing: Read Reset + Random data Write/Read
    #Address 0x1e8 read value
    csrr x14, 0x1e8

    #Address 0x1e8 Write value 0x4eb5797a
    li x3, 0x4eb5797a
    csrw 0x1e8, x3

    #Address 0x1e8 read value
    csrr x14, 0x1e8

    #Unmapped address 0x9fa testing: Read Reset + Random data Write/Read
    #Address 0x9fa read value
    csrr x14, 0x9fa

    #Address 0x9fa Write value 0xee4b4c09
    li x3, 0xee4b4c09
    csrw 0x9fa, x3

    #Address 0x9fa read value
    csrr x14, 0x9fa

    #Unmapped address 0x3d9 testing: Read Reset + Random data Write/Read
    #Address 0x3d9 read value
    csrr x14, 0x3d9

    #Address 0x3d9 Write value 0x1b71cbc3
    li x3, 0x1b71cbc3
    csrw 0x3d9, x3

    #Address 0x3d9 read value
    csrr x14, 0x3d9

    #Unmapped address 0xc36 testing: Read Reset + Random data Write/Read
    #Address 0xc36 read value
    csrr x14, 0xc36

    #Address 0xc36 Write value 0xe1dd049
    li x3, 0xe1dd049
    csrw 0xc36, x3

    #Address 0xc36 read value
    csrr x14, 0xc36

    #Unmapped address 0x610 testing: Read Reset + Random data Write/Read
    #Address 0x610 read value
    csrr x14, 0x610

    #Address 0x610 Write value 0x970e61f2
    li x3, 0x970e61f2
    csrw 0x610, x3

    #Address 0x610 read value
    csrr x14, 0x610

    #Unmapped address 0x9fd testing: Read Reset + Random data Write/Read
    #Address 0x9fd read value
    csrr x14, 0x9fd

    #Address 0x9fd Write value 0x43dce192
    li x3, 0x43dce192
    csrw 0x9fd, x3

    #Address 0x9fd read value
    csrr x14, 0x9fd

    #Unmapped address 0xf75 testing: Read Reset + Random data Write/Read
    #Address 0xf75 read value
    csrr x14, 0xf75

    #Address 0xf75 Write value 0xbe0075da
    li x3, 0xbe0075da
    csrw 0xf75, x3

    #Address 0xf75 read value
    csrr x14, 0xf75

    #Unmapped address 0x831 testing: Read Reset + Random data Write/Read
    #Address 0x831 read value
    csrr x14, 0x831

    #Address 0x831 Write value 0x85e18322
    li x3, 0x85e18322
    csrw 0x831, x3

    #Address 0x831 read value
    csrr x14, 0x831

    #Unmapped address 0xe48 testing: Read Reset + Random data Write/Read
    #Address 0xe48 read value
    csrr x14, 0xe48

    #Address 0xe48 Write value 0x7103cbe9
    li x3, 0x7103cbe9
    csrw 0xe48, x3

    #Address 0xe48 read value
    csrr x14, 0xe48

    #Unmapped address 0x1e1 testing: Read Reset + Random data Write/Read
    #Address 0x1e1 read value
    csrr x14, 0x1e1

    #Address 0x1e1 Write value 0x368a2643
    li x3, 0x368a2643
    csrw 0x1e1, x3

    #Address 0x1e1 read value
    csrr x14, 0x1e1

    #Unmapped address 0x209 testing: Read Reset + Random data Write/Read
    #Address 0x209 read value
    csrr x14, 0x209

    #Address 0x209 Write value 0x5b65d0be
    li x3, 0x5b65d0be
    csrw 0x209, x3

    #Address 0x209 read value
    csrr x14, 0x209

    #Unmapped address 0xef4 testing: Read Reset + Random data Write/Read
    #Address 0xef4 read value
    csrr x14, 0xef4

    #Address 0xef4 Write value 0xd2e4db3f
    li x3, 0xd2e4db3f
    csrw 0xef4, x3

    #Address 0xef4 read value
    csrr x14, 0xef4

    #Unmapped address 0x798 testing: Read Reset + Random data Write/Read
    #Address 0x798 read value
    csrr x14, 0x798

    #Address 0x798 Write value 0xb5dca70d
    li x3, 0xb5dca70d
    csrw 0x798, x3

    #Address 0x798 read value
    csrr x14, 0x798

    #Unmapped address 0x58c testing: Read Reset + Random data Write/Read
    #Address 0x58c read value
    csrr x14, 0x58c

    #Address 0x58c Write value 0x52c3efdb
    li x3, 0x52c3efdb
    csrw 0x58c, x3

    #Address 0x58c read value
    csrr x14, 0x58c

    #Unmapped address 0x814 testing: Read Reset + Random data Write/Read
    #Address 0x814 read value
    csrr x14, 0x814

    #Address 0x814 Write value 0x2ad36296
    li x3, 0x2ad36296
    csrw 0x814, x3

    #Address 0x814 read value
    csrr x14, 0x814

    #Unmapped address 0x856 testing: Read Reset + Random data Write/Read
    #Address 0x856 read value
    csrr x14, 0x856

    #Address 0x856 Write value 0x69c85667
    li x3, 0x69c85667
    csrw 0x856, x3

    #Address 0x856 read value
    csrr x14, 0x856

    #Unmapped address 0x8f3 testing: Read Reset + Random data Write/Read
    #Address 0x8f3 read value
    csrr x14, 0x8f3

    #Address 0x8f3 Write value 0x870b6018
    li x3, 0x870b6018
    csrw 0x8f3, x3

    #Address 0x8f3 read value
    csrr x14, 0x8f3

    #Unmapped address 0x4ad testing: Read Reset + Random data Write/Read
    #Address 0x4ad read value
    csrr x14, 0x4ad

    #Address 0x4ad Write value 0xca13c74a
    li x3, 0xca13c74a
    csrw 0x4ad, x3

    #Address 0x4ad read value
    csrr x14, 0x4ad

    #Unmapped address 0x86 testing: Read Reset + Random data Write/Read
    #Address 0x86 read value
    csrr x14, 0x86

    #Address 0x86 Write value 0x1fa195f2
    li x3, 0x1fa195f2
    csrw 0x86, x3

    #Address 0x86 read value
    csrr x14, 0x86

    #Unmapped address 0xa92 testing: Read Reset + Random data Write/Read
    #Address 0xa92 read value
    csrr x14, 0xa92

    #Address 0xa92 Write value 0x1312ab43
    li x3, 0x1312ab43
    csrw 0xa92, x3

    #Address 0xa92 read value
    csrr x14, 0xa92

    #Unmapped address 0x30 testing: Read Reset + Random data Write/Read
    #Address 0x30 read value
    csrr x14, 0x30

    #Address 0x30 Write value 0xd13db476
    li x3, 0xd13db476
    csrw 0x30, x3

    #Address 0x30 read value
    csrr x14, 0x30

    #Unmapped address 0x9f6 testing: Read Reset + Random data Write/Read
    #Address 0x9f6 read value
    csrr x14, 0x9f6

    #Address 0x9f6 Write value 0x992bdb52
    li x3, 0x992bdb52
    csrw 0x9f6, x3

    #Address 0x9f6 read value
    csrr x14, 0x9f6

    #Unmapped address 0x642 testing: Read Reset + Random data Write/Read
    #Address 0x642 read value
    csrr x14, 0x642

    #Address 0x642 Write value 0xecfbefdb
    li x3, 0xecfbefdb
    csrw 0x642, x3

    #Address 0x642 read value
    csrr x14, 0x642

    #Unmapped address 0x89c testing: Read Reset + Random data Write/Read
    #Address 0x89c read value
    csrr x14, 0x89c

    #Address 0x89c Write value 0xfe485de7
    li x3, 0xfe485de7
    csrw 0x89c, x3

    #Address 0x89c read value
    csrr x14, 0x89c

    #Unmapped address 0xa00 testing: Read Reset + Random data Write/Read
    #Address 0xa00 read value
    csrr x14, 0xa00

    #Address 0xa00 Write value 0x64be3154
    li x3, 0x64be3154
    csrw 0xa00, x3

    #Address 0xa00 read value
    csrr x14, 0xa00

    #Unmapped address 0x7de testing: Read Reset + Random data Write/Read
    #Address 0x7de read value
    csrr x14, 0x7de

    #Address 0x7de Write value 0x51a6171d
    li x3, 0x51a6171d
    csrw 0x7de, x3

    #Address 0x7de read value
    csrr x14, 0x7de

    #Unmapped address 0xbb testing: Read Reset + Random data Write/Read
    #Address 0xbb read value
    csrr x14, 0xbb

    #Address 0xbb Write value 0xb85470c6
    li x3, 0xb85470c6
    csrw 0xbb, x3

    #Address 0xbb read value
    csrr x14, 0xbb

    #Unmapped address 0x22c testing: Read Reset + Random data Write/Read
    #Address 0x22c read value
    csrr x14, 0x22c

    #Address 0x22c Write value 0x967a2581
    li x3, 0x967a2581
    csrw 0x22c, x3

    #Address 0x22c read value
    csrr x14, 0x22c

    #Unmapped address 0x4da testing: Read Reset + Random data Write/Read
    #Address 0x4da read value
    csrr x14, 0x4da

    #Address 0x4da Write value 0x1177f7e9
    li x3, 0x1177f7e9
    csrw 0x4da, x3

    #Address 0x4da read value
    csrr x14, 0x4da

    #Unmapped address 0x68b testing: Read Reset + Random data Write/Read
    #Address 0x68b read value
    csrr x14, 0x68b

    #Address 0x68b Write value 0xde3074e0
    li x3, 0xde3074e0
    csrw 0x68b, x3

    #Address 0x68b read value
    csrr x14, 0x68b

    #Unmapped address 0x9df testing: Read Reset + Random data Write/Read
    #Address 0x9df read value
    csrr x14, 0x9df

    #Address 0x9df Write value 0x97e13d15
    li x3, 0x97e13d15
    csrw 0x9df, x3

    #Address 0x9df read value
    csrr x14, 0x9df

    #Unmapped address 0x58b testing: Read Reset + Random data Write/Read
    #Address 0x58b read value
    csrr x14, 0x58b

    #Address 0x58b Write value 0x94965db5
    li x3, 0x94965db5
    csrw 0x58b, x3

    #Address 0x58b read value
    csrr x14, 0x58b

    #Unmapped address 0xbe9 testing: Read Reset + Random data Write/Read
    #Address 0xbe9 read value
    csrr x14, 0xbe9

    #Address 0xbe9 Write value 0x8257dd9f
    li x3, 0x8257dd9f
    csrw 0xbe9, x3

    #Address 0xbe9 read value
    csrr x14, 0xbe9

    #Unmapped address 0xd8c testing: Read Reset + Random data Write/Read
    #Address 0xd8c read value
    csrr x14, 0xd8c

    #Address 0xd8c Write value 0x1b0a516
    li x3, 0x1b0a516
    csrw 0xd8c, x3

    #Address 0xd8c read value
    csrr x14, 0xd8c

    #Unmapped address 0x3fc testing: Read Reset + Random data Write/Read
    #Address 0x3fc read value
    csrr x14, 0x3fc

    #Address 0x3fc Write value 0xcbc032b2
    li x3, 0xcbc032b2
    csrw 0x3fc, x3

    #Address 0x3fc read value
    csrr x14, 0x3fc

    #Unmapped address 0x504 testing: Read Reset + Random data Write/Read
    #Address 0x504 read value
    csrr x14, 0x504

    #Address 0x504 Write value 0x7159ae86
    li x3, 0x7159ae86
    csrw 0x504, x3

    #Address 0x504 read value
    csrr x14, 0x504

    #Unmapped address 0x6e9 testing: Read Reset + Random data Write/Read
    #Address 0x6e9 read value
    csrr x14, 0x6e9

    #Address 0x6e9 Write value 0x74a6cc88
    li x3, 0x74a6cc88
    csrw 0x6e9, x3

    #Address 0x6e9 read value
    csrr x14, 0x6e9

    #Unmapped address 0x352 testing: Read Reset + Random data Write/Read
    #Address 0x352 read value
    csrr x14, 0x352

    #Address 0x352 Write value 0x9e1290d5
    li x3, 0x9e1290d5
    csrw 0x352, x3

    #Address 0x352 read value
    csrr x14, 0x352

    #Unmapped address 0xcaa testing: Read Reset + Random data Write/Read
    #Address 0xcaa read value
    csrr x14, 0xcaa

    #Address 0xcaa Write value 0x9138606a
    li x3, 0x9138606a
    csrw 0xcaa, x3

    #Address 0xcaa read value
    csrr x14, 0xcaa

    #Unmapped address 0x691 testing: Read Reset + Random data Write/Read
    #Address 0x691 read value
    csrr x14, 0x691

    #Address 0x691 Write value 0xe9d24d1f
    li x3, 0xe9d24d1f
    csrw 0x691, x3

    #Address 0x691 read value
    csrr x14, 0x691

    #Unmapped address 0xf46 testing: Read Reset + Random data Write/Read
    #Address 0xf46 read value
    csrr x14, 0xf46

    #Address 0xf46 Write value 0x954e996c
    li x3, 0x954e996c
    csrw 0xf46, x3

    #Address 0xf46 read value
    csrr x14, 0xf46

    #Unmapped address 0x35e testing: Read Reset + Random data Write/Read
    #Address 0x35e read value
    csrr x14, 0x35e

    #Address 0x35e Write value 0xdfe55821
    li x3, 0xdfe55821
    csrw 0x35e, x3

    #Address 0x35e read value
    csrr x14, 0x35e

    #Unmapped address 0x282 testing: Read Reset + Random data Write/Read
    #Address 0x282 read value
    csrr x14, 0x282

    #Address 0x282 Write value 0xa4d16741
    li x3, 0xa4d16741
    csrw 0x282, x3

    #Address 0x282 read value
    csrr x14, 0x282

    #Unmapped address 0x365 testing: Read Reset + Random data Write/Read
    #Address 0x365 read value
    csrr x14, 0x365

    #Address 0x365 Write value 0xe887111d
    li x3, 0xe887111d
    csrw 0x365, x3

    #Address 0x365 read value
    csrr x14, 0x365

    #Unmapped address 0x4a9 testing: Read Reset + Random data Write/Read
    #Address 0x4a9 read value
    csrr x14, 0x4a9

    #Address 0x4a9 Write value 0xd0570d46
    li x3, 0xd0570d46
    csrw 0x4a9, x3

    #Address 0x4a9 read value
    csrr x14, 0x4a9

    #Unmapped address 0x76 testing: Read Reset + Random data Write/Read
    #Address 0x76 read value
    csrr x14, 0x76

    #Address 0x76 Write value 0x1cdeab23
    li x3, 0x1cdeab23
    csrw 0x76, x3

    #Address 0x76 read value
    csrr x14, 0x76

    #Unmapped address 0x78b testing: Read Reset + Random data Write/Read
    #Address 0x78b read value
    csrr x14, 0x78b

    #Address 0x78b Write value 0x5ac9f282
    li x3, 0x5ac9f282
    csrw 0x78b, x3

    #Address 0x78b read value
    csrr x14, 0x78b

    #Unmapped address 0x56a testing: Read Reset + Random data Write/Read
    #Address 0x56a read value
    csrr x14, 0x56a

    #Address 0x56a Write value 0x4e0a72df
    li x3, 0x4e0a72df
    csrw 0x56a, x3

    #Address 0x56a read value
    csrr x14, 0x56a

    #Unmapped address 0x86c testing: Read Reset + Random data Write/Read
    #Address 0x86c read value
    csrr x14, 0x86c

    #Address 0x86c Write value 0x2e049bcb
    li x3, 0x2e049bcb
    csrw 0x86c, x3

    #Address 0x86c read value
    csrr x14, 0x86c

    #Unmapped address 0x382 testing: Read Reset + Random data Write/Read
    #Address 0x382 read value
    csrr x14, 0x382

    #Address 0x382 Write value 0x4102df83
    li x3, 0x4102df83
    csrw 0x382, x3

    #Address 0x382 read value
    csrr x14, 0x382

    #Unmapped address 0x2b1 testing: Read Reset + Random data Write/Read
    #Address 0x2b1 read value
    csrr x14, 0x2b1

    #Address 0x2b1 Write value 0x7d975086
    li x3, 0x7d975086
    csrw 0x2b1, x3

    #Address 0x2b1 read value
    csrr x14, 0x2b1

    #Unmapped address 0x4ff testing: Read Reset + Random data Write/Read
    #Address 0x4ff read value
    csrr x14, 0x4ff

    #Address 0x4ff Write value 0xa93e0297
    li x3, 0xa93e0297
    csrw 0x4ff, x3

    #Address 0x4ff read value
    csrr x14, 0x4ff

    #Unmapped address 0xdc0 testing: Read Reset + Random data Write/Read
    #Address 0xdc0 read value
    csrr x14, 0xdc0

    #Address 0xdc0 Write value 0xd3ce5890
    li x3, 0xd3ce5890
    csrw 0xdc0, x3

    #Address 0xdc0 read value
    csrr x14, 0xdc0

    #Unmapped address 0x3d2 testing: Read Reset + Random data Write/Read
    #Address 0x3d2 read value
    csrr x14, 0x3d2

    #Address 0x3d2 Write value 0xea353475
    li x3, 0xea353475
    csrw 0x3d2, x3

    #Address 0x3d2 read value
    csrr x14, 0x3d2

    #Unmapped address 0x10b testing: Read Reset + Random data Write/Read
    #Address 0x10b read value
    csrr x14, 0x10b

    #Address 0x10b Write value 0x8bd34fcd
    li x3, 0x8bd34fcd
    csrw 0x10b, x3

    #Address 0x10b read value
    csrr x14, 0x10b

    #Unmapped address 0x120 testing: Read Reset + Random data Write/Read
    #Address 0x120 read value
    csrr x14, 0x120

    #Address 0x120 Write value 0x533aadf9
    li x3, 0x533aadf9
    csrw 0x120, x3

    #Address 0x120 read value
    csrr x14, 0x120

    #Unmapped address 0xc49 testing: Read Reset + Random data Write/Read
    #Address 0xc49 read value
    csrr x14, 0xc49

    #Address 0xc49 Write value 0xacab470c
    li x3, 0xacab470c
    csrw 0xc49, x3

    #Address 0xc49 read value
    csrr x14, 0xc49

    #Unmapped address 0x220 testing: Read Reset + Random data Write/Read
    #Address 0x220 read value
    csrr x14, 0x220

    #Address 0x220 Write value 0x7c889fb1
    li x3, 0x7c889fb1
    csrw 0x220, x3

    #Address 0x220 read value
    csrr x14, 0x220

    #Unmapped address 0xdcf testing: Read Reset + Random data Write/Read
    #Address 0xdcf read value
    csrr x14, 0xdcf

    #Address 0xdcf Write value 0xa404e4f3
    li x3, 0xa404e4f3
    csrw 0xdcf, x3

    #Address 0xdcf read value
    csrr x14, 0xdcf

    #Unmapped address 0x98 testing: Read Reset + Random data Write/Read
    #Address 0x98 read value
    csrr x14, 0x98

    #Address 0x98 Write value 0x1646040e
    li x3, 0x1646040e
    csrw 0x98, x3

    #Address 0x98 read value
    csrr x14, 0x98

    #Unmapped address 0x840 testing: Read Reset + Random data Write/Read
    #Address 0x840 read value
    csrr x14, 0x840

    #Address 0x840 Write value 0x8ac47733
    li x3, 0x8ac47733
    csrw 0x840, x3

    #Address 0x840 read value
    csrr x14, 0x840

    #Unmapped address 0xbdc testing: Read Reset + Random data Write/Read
    #Address 0xbdc read value
    csrr x14, 0xbdc

    #Address 0xbdc Write value 0xfedd72d2
    li x3, 0xfedd72d2
    csrw 0xbdc, x3

    #Address 0xbdc read value
    csrr x14, 0xbdc

    #Unmapped address 0xd90 testing: Read Reset + Random data Write/Read
    #Address 0xd90 read value
    csrr x14, 0xd90

    #Address 0xd90 Write value 0xe61ab050
    li x3, 0xe61ab050
    csrw 0xd90, x3

    #Address 0xd90 read value
    csrr x14, 0xd90

    #Unmapped address 0x9d2 testing: Read Reset + Random data Write/Read
    #Address 0x9d2 read value
    csrr x14, 0x9d2

    #Address 0x9d2 Write value 0xf023690
    li x3, 0xf023690
    csrw 0x9d2, x3

    #Address 0x9d2 read value
    csrr x14, 0x9d2

    #Unmapped address 0xa4b testing: Read Reset + Random data Write/Read
    #Address 0xa4b read value
    csrr x14, 0xa4b

    #Address 0xa4b Write value 0x305b31a7
    li x3, 0x305b31a7
    csrw 0xa4b, x3

    #Address 0xa4b read value
    csrr x14, 0xa4b

    #Unmapped address 0x4cc testing: Read Reset + Random data Write/Read
    #Address 0x4cc read value
    csrr x14, 0x4cc

    #Address 0x4cc Write value 0xa2c006b8
    li x3, 0xa2c006b8
    csrw 0x4cc, x3

    #Address 0x4cc read value
    csrr x14, 0x4cc

    #Unmapped address 0xea2 testing: Read Reset + Random data Write/Read
    #Address 0xea2 read value
    csrr x14, 0xea2

    #Address 0xea2 Write value 0x4e8a2d1b
    li x3, 0x4e8a2d1b
    csrw 0xea2, x3

    #Address 0xea2 read value
    csrr x14, 0xea2

    #Unmapped address 0x64d testing: Read Reset + Random data Write/Read
    #Address 0x64d read value
    csrr x14, 0x64d

    #Address 0x64d Write value 0xd27b0e
    li x3, 0xd27b0e
    csrw 0x64d, x3

    #Address 0x64d read value
    csrr x14, 0x64d

    #Unmapped address 0x59c testing: Read Reset + Random data Write/Read
    #Address 0x59c read value
    csrr x14, 0x59c

    #Address 0x59c Write value 0x5b694421
    li x3, 0x5b694421
    csrw 0x59c, x3

    #Address 0x59c read value
    csrr x14, 0x59c

    #Unmapped address 0x524 testing: Read Reset + Random data Write/Read
    #Address 0x524 read value
    csrr x14, 0x524

    #Address 0x524 Write value 0x6dcfd7f1
    li x3, 0x6dcfd7f1
    csrw 0x524, x3

    #Address 0x524 read value
    csrr x14, 0x524

    #Unmapped address 0x57f testing: Read Reset + Random data Write/Read
    #Address 0x57f read value
    csrr x14, 0x57f

    #Address 0x57f Write value 0x97f1e4a3
    li x3, 0x97f1e4a3
    csrw 0x57f, x3

    #Address 0x57f read value
    csrr x14, 0x57f

    #Unmapped address 0x7f7 testing: Read Reset + Random data Write/Read
    #Address 0x7f7 read value
    csrr x14, 0x7f7

    #Address 0x7f7 Write value 0x9d89dbb9
    li x3, 0x9d89dbb9
    csrw 0x7f7, x3

    #Address 0x7f7 read value
    csrr x14, 0x7f7

    #Unmapped address 0xaf testing: Read Reset + Random data Write/Read
    #Address 0xaf read value
    csrr x14, 0xaf

    #Address 0xaf Write value 0x900bf057
    li x3, 0x900bf057
    csrw 0xaf, x3

    #Address 0xaf read value
    csrr x14, 0xaf

    #Unmapped address 0x8e5 testing: Read Reset + Random data Write/Read
    #Address 0x8e5 read value
    csrr x14, 0x8e5

    #Address 0x8e5 Write value 0xf734c837
    li x3, 0xf734c837
    csrw 0x8e5, x3

    #Address 0x8e5 read value
    csrr x14, 0x8e5

    #Unmapped address 0xc66 testing: Read Reset + Random data Write/Read
    #Address 0xc66 read value
    csrr x14, 0xc66

    #Address 0xc66 Write value 0xb099c1fa
    li x3, 0xb099c1fa
    csrw 0xc66, x3

    #Address 0xc66 read value
    csrr x14, 0xc66

    #Unmapped address 0xcb6 testing: Read Reset + Random data Write/Read
    #Address 0xcb6 read value
    csrr x14, 0xcb6

    #Address 0xcb6 Write value 0xff241430
    li x3, 0xff241430
    csrw 0xcb6, x3

    #Address 0xcb6 read value
    csrr x14, 0xcb6

    #Unmapped address 0x848 testing: Read Reset + Random data Write/Read
    #Address 0x848 read value
    csrr x14, 0x848

    #Address 0x848 Write value 0xb00e1ae7
    li x3, 0xb00e1ae7
    csrw 0x848, x3

    #Address 0x848 read value
    csrr x14, 0x848

    #Unmapped address 0x8b7 testing: Read Reset + Random data Write/Read
    #Address 0x8b7 read value
    csrr x14, 0x8b7

    #Address 0x8b7 Write value 0x7085b350
    li x3, 0x7085b350
    csrw 0x8b7, x3

    #Address 0x8b7 read value
    csrr x14, 0x8b7

    #Unmapped address 0x3f2 testing: Read Reset + Random data Write/Read
    #Address 0x3f2 read value
    csrr x14, 0x3f2

    #Address 0x3f2 Write value 0x19bc6b9d
    li x3, 0x19bc6b9d
    csrw 0x3f2, x3

    #Address 0x3f2 read value
    csrr x14, 0x3f2

    #Unmapped address 0x2 testing: Read Reset + Random data Write/Read
    #Address 0x2 read value
    csrr x14, 0x2

    #Address 0x2 Write value 0x65d55a82
    li x3, 0x65d55a82
    csrw 0x2, x3

    #Address 0x2 read value
    csrr x14, 0x2

    #Unmapped address 0x6cd testing: Read Reset + Random data Write/Read
    #Address 0x6cd read value
    csrr x14, 0x6cd

    #Address 0x6cd Write value 0x4ba8b36
    li x3, 0x4ba8b36
    csrw 0x6cd, x3

    #Address 0x6cd read value
    csrr x14, 0x6cd

    #Unmapped address 0xcd1 testing: Read Reset + Random data Write/Read
    #Address 0xcd1 read value
    csrr x14, 0xcd1

    #Address 0xcd1 Write value 0xb3729a13
    li x3, 0xb3729a13
    csrw 0xcd1, x3

    #Address 0xcd1 read value
    csrr x14, 0xcd1

    #Unmapped address 0x1c8 testing: Read Reset + Random data Write/Read
    #Address 0x1c8 read value
    csrr x14, 0x1c8

    #Address 0x1c8 Write value 0xd615de5b
    li x3, 0xd615de5b
    csrw 0x1c8, x3

    #Address 0x1c8 read value
    csrr x14, 0x1c8

    #Unmapped address 0x971 testing: Read Reset + Random data Write/Read
    #Address 0x971 read value
    csrr x14, 0x971

    #Address 0x971 Write value 0xca20414d
    li x3, 0xca20414d
    csrw 0x971, x3

    #Address 0x971 read value
    csrr x14, 0x971

    #Unmapped address 0xcf8 testing: Read Reset + Random data Write/Read
    #Address 0xcf8 read value
    csrr x14, 0xcf8

    #Address 0xcf8 Write value 0xc5caf341
    li x3, 0xc5caf341
    csrw 0xcf8, x3

    #Address 0xcf8 read value
    csrr x14, 0xcf8

    #Unmapped address 0x187 testing: Read Reset + Random data Write/Read
    #Address 0x187 read value
    csrr x14, 0x187

    #Address 0x187 Write value 0x879c018e
    li x3, 0x879c018e
    csrw 0x187, x3

    #Address 0x187 read value
    csrr x14, 0x187

    #Unmapped address 0x3a4 testing: Read Reset + Random data Write/Read
    #Address 0x3a4 read value
    csrr x14, 0x3a4

    #Address 0x3a4 Write value 0x28eacc5b
    li x3, 0x28eacc5b
    csrw 0x3a4, x3

    #Address 0x3a4 read value
    csrr x14, 0x3a4

    #Unmapped address 0x40a testing: Read Reset + Random data Write/Read
    #Address 0x40a read value
    csrr x14, 0x40a

    #Address 0x40a Write value 0xe509d03e
    li x3, 0xe509d03e
    csrw 0x40a, x3

    #Address 0x40a read value
    csrr x14, 0x40a

    #Unmapped address 0xcdd testing: Read Reset + Random data Write/Read
    #Address 0xcdd read value
    csrr x14, 0xcdd

    #Address 0xcdd Write value 0x7afbff3f
    li x3, 0x7afbff3f
    csrw 0xcdd, x3

    #Address 0xcdd read value
    csrr x14, 0xcdd

    #Unmapped address 0xe3d testing: Read Reset + Random data Write/Read
    #Address 0xe3d read value
    csrr x14, 0xe3d

    #Address 0xe3d Write value 0xa786655b
    li x3, 0xa786655b
    csrw 0xe3d, x3

    #Address 0xe3d read value
    csrr x14, 0xe3d

    #Unmapped address 0x6a8 testing: Read Reset + Random data Write/Read
    #Address 0x6a8 read value
    csrr x14, 0x6a8

    #Address 0x6a8 Write value 0x52e771bd
    li x3, 0x52e771bd
    csrw 0x6a8, x3

    #Address 0x6a8 read value
    csrr x14, 0x6a8

    #Unmapped address 0x169 testing: Read Reset + Random data Write/Read
    #Address 0x169 read value
    csrr x14, 0x169

    #Address 0x169 Write value 0x299247c0
    li x3, 0x299247c0
    csrw 0x169, x3

    #Address 0x169 read value
    csrr x14, 0x169

    #Unmapped address 0x3d5 testing: Read Reset + Random data Write/Read
    #Address 0x3d5 read value
    csrr x14, 0x3d5

    #Address 0x3d5 Write value 0xe0325ffe
    li x3, 0xe0325ffe
    csrw 0x3d5, x3

    #Address 0x3d5 read value
    csrr x14, 0x3d5

    #Unmapped address 0xfd testing: Read Reset + Random data Write/Read
    #Address 0xfd read value
    csrr x14, 0xfd

    #Address 0xfd Write value 0x4353daf5
    li x3, 0x4353daf5
    csrw 0xfd, x3

    #Address 0xfd read value
    csrr x14, 0xfd

    #Unmapped address 0xdf2 testing: Read Reset + Random data Write/Read
    #Address 0xdf2 read value
    csrr x14, 0xdf2

    #Address 0xdf2 Write value 0xcc8af584
    li x3, 0xcc8af584
    csrw 0xdf2, x3

    #Address 0xdf2 read value
    csrr x14, 0xdf2

    #Unmapped address 0xcca testing: Read Reset + Random data Write/Read
    #Address 0xcca read value
    csrr x14, 0xcca

    #Address 0xcca Write value 0xbdcae559
    li x3, 0xbdcae559
    csrw 0xcca, x3

    #Address 0xcca read value
    csrr x14, 0xcca

    #Unmapped address 0x44e testing: Read Reset + Random data Write/Read
    #Address 0x44e read value
    csrr x14, 0x44e

    #Address 0x44e Write value 0xb2ff2e28
    li x3, 0xb2ff2e28
    csrw 0x44e, x3

    #Address 0x44e read value
    csrr x14, 0x44e

    #Unmapped address 0x770 testing: Read Reset + Random data Write/Read
    #Address 0x770 read value
    csrr x14, 0x770

    #Address 0x770 Write value 0x9b5a1566
    li x3, 0x9b5a1566
    csrw 0x770, x3

    #Address 0x770 read value
    csrr x14, 0x770

    #Unmapped address 0xc50 testing: Read Reset + Random data Write/Read
    #Address 0xc50 read value
    csrr x14, 0xc50

    #Address 0xc50 Write value 0x5b48535b
    li x3, 0x5b48535b
    csrw 0xc50, x3

    #Address 0xc50 read value
    csrr x14, 0xc50

    #Unmapped address 0x5fd testing: Read Reset + Random data Write/Read
    #Address 0x5fd read value
    csrr x14, 0x5fd

    #Address 0x5fd Write value 0xc67b7ba1
    li x3, 0xc67b7ba1
    csrw 0x5fd, x3

    #Address 0x5fd read value
    csrr x14, 0x5fd

    #Unmapped address 0x763 testing: Read Reset + Random data Write/Read
    #Address 0x763 read value
    csrr x14, 0x763

    #Address 0x763 Write value 0xc868b804
    li x3, 0xc868b804
    csrw 0x763, x3

    #Address 0x763 read value
    csrr x14, 0x763

    #Unmapped address 0xa0d testing: Read Reset + Random data Write/Read
    #Address 0xa0d read value
    csrr x14, 0xa0d

    #Address 0xa0d Write value 0x868830d9
    li x3, 0x868830d9
    csrw 0xa0d, x3

    #Address 0xa0d read value
    csrr x14, 0xa0d

    #Unmapped address 0x985 testing: Read Reset + Random data Write/Read
    #Address 0x985 read value
    csrr x14, 0x985

    #Address 0x985 Write value 0xe1c4af4a
    li x3, 0xe1c4af4a
    csrw 0x985, x3

    #Address 0x985 read value
    csrr x14, 0x985

    #Unmapped address 0xa8d testing: Read Reset + Random data Write/Read
    #Address 0xa8d read value
    csrr x14, 0xa8d

    #Address 0xa8d Write value 0x2a43f654
    li x3, 0x2a43f654
    csrw 0xa8d, x3

    #Address 0xa8d read value
    csrr x14, 0xa8d

    #Unmapped address 0x8b0 testing: Read Reset + Random data Write/Read
    #Address 0x8b0 read value
    csrr x14, 0x8b0

    #Address 0x8b0 Write value 0x3bd56792
    li x3, 0x3bd56792
    csrw 0x8b0, x3

    #Address 0x8b0 read value
    csrr x14, 0x8b0

    #Unmapped address 0x453 testing: Read Reset + Random data Write/Read
    #Address 0x453 read value
    csrr x14, 0x453

    #Address 0x453 Write value 0x5c75279c
    li x3, 0x5c75279c
    csrw 0x453, x3

    #Address 0x453 read value
    csrr x14, 0x453

    #Unmapped address 0x5b8 testing: Read Reset + Random data Write/Read
    #Address 0x5b8 read value
    csrr x14, 0x5b8

    #Address 0x5b8 Write value 0x88907640
    li x3, 0x88907640
    csrw 0x5b8, x3

    #Address 0x5b8 read value
    csrr x14, 0x5b8

    #Unmapped address 0x9ca testing: Read Reset + Random data Write/Read
    #Address 0x9ca read value
    csrr x14, 0x9ca

    #Address 0x9ca Write value 0xf60a7cfe
    li x3, 0xf60a7cfe
    csrw 0x9ca, x3

    #Address 0x9ca read value
    csrr x14, 0x9ca

    #Unmapped address 0xd9b testing: Read Reset + Random data Write/Read
    #Address 0xd9b read value
    csrr x14, 0xd9b

    #Address 0xd9b Write value 0x693c31cd
    li x3, 0x693c31cd
    csrw 0xd9b, x3

    #Address 0xd9b read value
    csrr x14, 0xd9b

    #Unmapped address 0x60c testing: Read Reset + Random data Write/Read
    #Address 0x60c read value
    csrr x14, 0x60c

    #Address 0x60c Write value 0x3ba20e5a
    li x3, 0x3ba20e5a
    csrw 0x60c, x3

    #Address 0x60c read value
    csrr x14, 0x60c

    #Unmapped address 0xbc6 testing: Read Reset + Random data Write/Read
    #Address 0xbc6 read value
    csrr x14, 0xbc6

    #Address 0xbc6 Write value 0x861d7858
    li x3, 0x861d7858
    csrw 0xbc6, x3

    #Address 0xbc6 read value
    csrr x14, 0xbc6

    #Unmapped address 0xd2f testing: Read Reset + Random data Write/Read
    #Address 0xd2f read value
    csrr x14, 0xd2f

    #Address 0xd2f Write value 0x5ee0ef15
    li x3, 0x5ee0ef15
    csrw 0xd2f, x3

    #Address 0xd2f read value
    csrr x14, 0xd2f

    #Unmapped address 0x76a testing: Read Reset + Random data Write/Read
    #Address 0x76a read value
    csrr x14, 0x76a

    #Address 0x76a Write value 0xf71d5277
    li x3, 0xf71d5277
    csrw 0x76a, x3

    #Address 0x76a read value
    csrr x14, 0x76a

    #Unmapped address 0x247 testing: Read Reset + Random data Write/Read
    #Address 0x247 read value
    csrr x14, 0x247

    #Address 0x247 Write value 0x20a522c8
    li x3, 0x20a522c8
    csrw 0x247, x3

    #Address 0x247 read value
    csrr x14, 0x247

    #Unmapped address 0xef3 testing: Read Reset + Random data Write/Read
    #Address 0xef3 read value
    csrr x14, 0xef3

    #Address 0xef3 Write value 0x90efccb8
    li x3, 0x90efccb8
    csrw 0xef3, x3

    #Address 0xef3 read value
    csrr x14, 0xef3

    #Unmapped address 0x4f2 testing: Read Reset + Random data Write/Read
    #Address 0x4f2 read value
    csrr x14, 0x4f2

    #Address 0x4f2 Write value 0x84f66f49
    li x3, 0x84f66f49
    csrw 0x4f2, x3

    #Address 0x4f2 read value
    csrr x14, 0x4f2

    #Unmapped address 0xa24 testing: Read Reset + Random data Write/Read
    #Address 0xa24 read value
    csrr x14, 0xa24

    #Address 0xa24 Write value 0x90f4bf26
    li x3, 0x90f4bf26
    csrw 0xa24, x3

    #Address 0xa24 read value
    csrr x14, 0xa24

    #Unmapped address 0xe6f testing: Read Reset + Random data Write/Read
    #Address 0xe6f read value
    csrr x14, 0xe6f

    #Address 0xe6f Write value 0x3aebf0fc
    li x3, 0x3aebf0fc
    csrw 0xe6f, x3

    #Address 0xe6f read value
    csrr x14, 0xe6f

    #Unmapped address 0xe69 testing: Read Reset + Random data Write/Read
    #Address 0xe69 read value
    csrr x14, 0xe69

    #Address 0xe69 Write value 0x6425d841
    li x3, 0x6425d841
    csrw 0xe69, x3

    #Address 0xe69 read value
    csrr x14, 0xe69

    #Unmapped address 0xc6a testing: Read Reset + Random data Write/Read
    #Address 0xc6a read value
    csrr x14, 0xc6a

    #Address 0xc6a Write value 0x9f36e25f
    li x3, 0x9f36e25f
    csrw 0xc6a, x3

    #Address 0xc6a read value
    csrr x14, 0xc6a

    #Unmapped address 0x521 testing: Read Reset + Random data Write/Read
    #Address 0x521 read value
    csrr x14, 0x521

    #Address 0x521 Write value 0x8fb452c9
    li x3, 0x8fb452c9
    csrw 0x521, x3

    #Address 0x521 read value
    csrr x14, 0x521

    #Unmapped address 0x973 testing: Read Reset + Random data Write/Read
    #Address 0x973 read value
    csrr x14, 0x973

    #Address 0x973 Write value 0x7f05ee3a
    li x3, 0x7f05ee3a
    csrw 0x973, x3

    #Address 0x973 read value
    csrr x14, 0x973

    #Unmapped address 0x987 testing: Read Reset + Random data Write/Read
    #Address 0x987 read value
    csrr x14, 0x987

    #Address 0x987 Write value 0x2fd39c1c
    li x3, 0x2fd39c1c
    csrw 0x987, x3

    #Address 0x987 read value
    csrr x14, 0x987

    #Unmapped address 0x8a8 testing: Read Reset + Random data Write/Read
    #Address 0x8a8 read value
    csrr x14, 0x8a8

    #Address 0x8a8 Write value 0x81eb7cc0
    li x3, 0x81eb7cc0
    csrw 0x8a8, x3

    #Address 0x8a8 read value
    csrr x14, 0x8a8

    #Unmapped address 0x836 testing: Read Reset + Random data Write/Read
    #Address 0x836 read value
    csrr x14, 0x836

    #Address 0x836 Write value 0x92192c8c
    li x3, 0x92192c8c
    csrw 0x836, x3

    #Address 0x836 read value
    csrr x14, 0x836

    #Unmapped address 0xfc2 testing: Read Reset + Random data Write/Read
    #Address 0xfc2 read value
    csrr x14, 0xfc2

    #Address 0xfc2 Write value 0x564968da
    li x3, 0x564968da
    csrw 0xfc2, x3

    #Address 0xfc2 read value
    csrr x14, 0xfc2

    #Unmapped address 0x34b testing: Read Reset + Random data Write/Read
    #Address 0x34b read value
    csrr x14, 0x34b

    #Address 0x34b Write value 0xfd9d8c46
    li x3, 0xfd9d8c46
    csrw 0x34b, x3

    #Address 0x34b read value
    csrr x14, 0x34b

    #Unmapped address 0x595 testing: Read Reset + Random data Write/Read
    #Address 0x595 read value
    csrr x14, 0x595

    #Address 0x595 Write value 0xba012bb6
    li x3, 0xba012bb6
    csrw 0x595, x3

    #Address 0x595 read value
    csrr x14, 0x595

    #Unmapped address 0x4f6 testing: Read Reset + Random data Write/Read
    #Address 0x4f6 read value
    csrr x14, 0x4f6

    #Address 0x4f6 Write value 0xe98632e8
    li x3, 0xe98632e8
    csrw 0x4f6, x3

    #Address 0x4f6 read value
    csrr x14, 0x4f6

    #Unmapped address 0x699 testing: Read Reset + Random data Write/Read
    #Address 0x699 read value
    csrr x14, 0x699

    #Address 0x699 Write value 0xaff6c3be
    li x3, 0xaff6c3be
    csrw 0x699, x3

    #Address 0x699 read value
    csrr x14, 0x699

    #Unmapped address 0xae9 testing: Read Reset + Random data Write/Read
    #Address 0xae9 read value
    csrr x14, 0xae9

    #Address 0xae9 Write value 0xa8af3fc7
    li x3, 0xa8af3fc7
    csrw 0xae9, x3

    #Address 0xae9 read value
    csrr x14, 0xae9

    #Unmapped address 0x18b testing: Read Reset + Random data Write/Read
    #Address 0x18b read value
    csrr x14, 0x18b

    #Address 0x18b Write value 0x62d96403
    li x3, 0x62d96403
    csrw 0x18b, x3

    #Address 0x18b read value
    csrr x14, 0x18b

    #Unmapped address 0x2aa testing: Read Reset + Random data Write/Read
    #Address 0x2aa read value
    csrr x14, 0x2aa

    #Address 0x2aa Write value 0xe1f2d5b2
    li x3, 0xe1f2d5b2
    csrw 0x2aa, x3

    #Address 0x2aa read value
    csrr x14, 0x2aa

    #Unmapped address 0x8df testing: Read Reset + Random data Write/Read
    #Address 0x8df read value
    csrr x14, 0x8df

    #Address 0x8df Write value 0x9c1c1a88
    li x3, 0x9c1c1a88
    csrw 0x8df, x3

    #Address 0x8df read value
    csrr x14, 0x8df

    #Unmapped address 0xb28 testing: Read Reset + Random data Write/Read
    #Address 0xb28 read value
    csrr x14, 0xb28

    #Address 0xb28 Write value 0x6bc80e3c
    li x3, 0x6bc80e3c
    csrw 0xb28, x3

    #Address 0xb28 read value
    csrr x14, 0xb28

    #Unmapped address 0x2f6 testing: Read Reset + Random data Write/Read
    #Address 0x2f6 read value
    csrr x14, 0x2f6

    #Address 0x2f6 Write value 0x6e0289c0
    li x3, 0x6e0289c0
    csrw 0x2f6, x3

    #Address 0x2f6 read value
    csrr x14, 0x2f6

    #Unmapped address 0x8f8 testing: Read Reset + Random data Write/Read
    #Address 0x8f8 read value
    csrr x14, 0x8f8

    #Address 0x8f8 Write value 0x64090f42
    li x3, 0x64090f42
    csrw 0x8f8, x3

    #Address 0x8f8 read value
    csrr x14, 0x8f8

    #Unmapped address 0x36d testing: Read Reset + Random data Write/Read
    #Address 0x36d read value
    csrr x14, 0x36d

    #Address 0x36d Write value 0xb072cec3
    li x3, 0xb072cec3
    csrw 0x36d, x3

    #Address 0x36d read value
    csrr x14, 0x36d

    #Unmapped address 0x3ca testing: Read Reset + Random data Write/Read
    #Address 0x3ca read value
    csrr x14, 0x3ca

    #Address 0x3ca Write value 0x87161abd
    li x3, 0x87161abd
    csrw 0x3ca, x3

    #Address 0x3ca read value
    csrr x14, 0x3ca

    #Unmapped address 0x90a testing: Read Reset + Random data Write/Read
    #Address 0x90a read value
    csrr x14, 0x90a

    #Address 0x90a Write value 0x61e6b67
    li x3, 0x61e6b67
    csrw 0x90a, x3

    #Address 0x90a read value
    csrr x14, 0x90a

    #Unmapped address 0x6cf testing: Read Reset + Random data Write/Read
    #Address 0x6cf read value
    csrr x14, 0x6cf

    #Address 0x6cf Write value 0x510ef1ac
    li x3, 0x510ef1ac
    csrw 0x6cf, x3

    #Address 0x6cf read value
    csrr x14, 0x6cf

    #Unmapped address 0xfb8 testing: Read Reset + Random data Write/Read
    #Address 0xfb8 read value
    csrr x14, 0xfb8

    #Address 0xfb8 Write value 0xbea7b72d
    li x3, 0xbea7b72d
    csrw 0xfb8, x3

    #Address 0xfb8 read value
    csrr x14, 0xfb8

    #Unmapped address 0xb34 testing: Read Reset + Random data Write/Read
    #Address 0xb34 read value
    csrr x14, 0xb34

    #Address 0xb34 Write value 0x9e4aa9a0
    li x3, 0x9e4aa9a0
    csrw 0xb34, x3

    #Address 0xb34 read value
    csrr x14, 0xb34

    #Unmapped address 0x7f4 testing: Read Reset + Random data Write/Read
    #Address 0x7f4 read value
    csrr x14, 0x7f4

    #Address 0x7f4 Write value 0x1ebcf83f
    li x3, 0x1ebcf83f
    csrw 0x7f4, x3

    #Address 0x7f4 read value
    csrr x14, 0x7f4

    #Unmapped address 0x582 testing: Read Reset + Random data Write/Read
    #Address 0x582 read value
    csrr x14, 0x582

    #Address 0x582 Write value 0xe8d770bd
    li x3, 0xe8d770bd
    csrw 0x582, x3

    #Address 0x582 read value
    csrr x14, 0x582

    #Unmapped address 0x126 testing: Read Reset + Random data Write/Read
    #Address 0x126 read value
    csrr x14, 0x126

    #Address 0x126 Write value 0xa86a5f06
    li x3, 0xa86a5f06
    csrw 0x126, x3

    #Address 0x126 read value
    csrr x14, 0x126

    #Unmapped address 0xeef testing: Read Reset + Random data Write/Read
    #Address 0xeef read value
    csrr x14, 0xeef

    #Address 0xeef Write value 0x6b970d6b
    li x3, 0x6b970d6b
    csrw 0xeef, x3

    #Address 0xeef read value
    csrr x14, 0xeef

    #Unmapped address 0x4d testing: Read Reset + Random data Write/Read
    #Address 0x4d read value
    csrr x14, 0x4d

    #Address 0x4d Write value 0x4fff734d
    li x3, 0x4fff734d
    csrw 0x4d, x3

    #Address 0x4d read value
    csrr x14, 0x4d

    #Unmapped address 0x9fb testing: Read Reset + Random data Write/Read
    #Address 0x9fb read value
    csrr x14, 0x9fb

    #Address 0x9fb Write value 0xe4aa70ce
    li x3, 0xe4aa70ce
    csrw 0x9fb, x3

    #Address 0x9fb read value
    csrr x14, 0x9fb

    #Unmapped address 0xe07 testing: Read Reset + Random data Write/Read
    #Address 0xe07 read value
    csrr x14, 0xe07

    #Address 0xe07 Write value 0x77db100d
    li x3, 0x77db100d
    csrw 0xe07, x3

    #Address 0xe07 read value
    csrr x14, 0xe07

    #Unmapped address 0xf32 testing: Read Reset + Random data Write/Read
    #Address 0xf32 read value
    csrr x14, 0xf32

    #Address 0xf32 Write value 0xf80b69d2
    li x3, 0xf80b69d2
    csrw 0xf32, x3

    #Address 0xf32 read value
    csrr x14, 0xf32

    #Unmapped address 0x689 testing: Read Reset + Random data Write/Read
    #Address 0x689 read value
    csrr x14, 0x689

    #Address 0x689 Write value 0x132a5abc
    li x3, 0x132a5abc
    csrw 0x689, x3

    #Address 0x689 read value
    csrr x14, 0x689

    #Unmapped address 0x5d8 testing: Read Reset + Random data Write/Read
    #Address 0x5d8 read value
    csrr x14, 0x5d8

    #Address 0x5d8 Write value 0xbefa2c0
    li x3, 0xbefa2c0
    csrw 0x5d8, x3

    #Address 0x5d8 read value
    csrr x14, 0x5d8

    #Unmapped address 0xdf1 testing: Read Reset + Random data Write/Read
    #Address 0xdf1 read value
    csrr x14, 0xdf1

    #Address 0xdf1 Write value 0x44a1b344
    li x3, 0x44a1b344
    csrw 0xdf1, x3

    #Address 0xdf1 read value
    csrr x14, 0xdf1

    #Unmapped address 0xeaa testing: Read Reset + Random data Write/Read
    #Address 0xeaa read value
    csrr x14, 0xeaa

    #Address 0xeaa Write value 0xd85ee497
    li x3, 0xd85ee497
    csrw 0xeaa, x3

    #Address 0xeaa read value
    csrr x14, 0xeaa

    #Unmapped address 0x3f9 testing: Read Reset + Random data Write/Read
    #Address 0x3f9 read value
    csrr x14, 0x3f9

    #Address 0x3f9 Write value 0xfd2d8ceb
    li x3, 0xfd2d8ceb
    csrw 0x3f9, x3

    #Address 0x3f9 read value
    csrr x14, 0x3f9

    #Unmapped address 0x572 testing: Read Reset + Random data Write/Read
    #Address 0x572 read value
    csrr x14, 0x572

    #Address 0x572 Write value 0x61c09ba8
    li x3, 0x61c09ba8
    csrw 0x572, x3

    #Address 0x572 read value
    csrr x14, 0x572

    #Unmapped address 0x974 testing: Read Reset + Random data Write/Read
    #Address 0x974 read value
    csrr x14, 0x974

    #Address 0x974 Write value 0x7766f873
    li x3, 0x7766f873
    csrw 0x974, x3

    #Address 0x974 read value
    csrr x14, 0x974

    #Unmapped address 0x7ec testing: Read Reset + Random data Write/Read
    #Address 0x7ec read value
    csrr x14, 0x7ec

    #Address 0x7ec Write value 0xd0f33263
    li x3, 0xd0f33263
    csrw 0x7ec, x3

    #Address 0x7ec read value
    csrr x14, 0x7ec

    #Unmapped address 0xa7d testing: Read Reset + Random data Write/Read
    #Address 0xa7d read value
    csrr x14, 0xa7d

    #Address 0xa7d Write value 0x369ed7b4
    li x3, 0x369ed7b4
    csrw 0xa7d, x3

    #Address 0xa7d read value
    csrr x14, 0xa7d

    #Unmapped address 0x70 testing: Read Reset + Random data Write/Read
    #Address 0x70 read value
    csrr x14, 0x70

    #Address 0x70 Write value 0x7df9289d
    li x3, 0x7df9289d
    csrw 0x70, x3

    #Address 0x70 read value
    csrr x14, 0x70

    #Unmapped address 0x83e testing: Read Reset + Random data Write/Read
    #Address 0x83e read value
    csrr x14, 0x83e

    #Address 0x83e Write value 0xd55d4b52
    li x3, 0xd55d4b52
    csrw 0x83e, x3

    #Address 0x83e read value
    csrr x14, 0x83e

    #Unmapped address 0x62b testing: Read Reset + Random data Write/Read
    #Address 0x62b read value
    csrr x14, 0x62b

    #Address 0x62b Write value 0x739a13dc
    li x3, 0x739a13dc
    csrw 0x62b, x3

    #Address 0x62b read value
    csrr x14, 0x62b

    #Unmapped address 0x290 testing: Read Reset + Random data Write/Read
    #Address 0x290 read value
    csrr x14, 0x290

    #Address 0x290 Write value 0xcb8fdcd7
    li x3, 0xcb8fdcd7
    csrw 0x290, x3

    #Address 0x290 read value
    csrr x14, 0x290

    #Unmapped address 0x9f4 testing: Read Reset + Random data Write/Read
    #Address 0x9f4 read value
    csrr x14, 0x9f4

    #Address 0x9f4 Write value 0x3771db4
    li x3, 0x3771db4
    csrw 0x9f4, x3

    #Address 0x9f4 read value
    csrr x14, 0x9f4

    #Unmapped address 0x941 testing: Read Reset + Random data Write/Read
    #Address 0x941 read value
    csrr x14, 0x941

    #Address 0x941 Write value 0x862a2eb
    li x3, 0x862a2eb
    csrw 0x941, x3

    #Address 0x941 read value
    csrr x14, 0x941

    #Unmapped address 0xde2 testing: Read Reset + Random data Write/Read
    #Address 0xde2 read value
    csrr x14, 0xde2

    #Address 0xde2 Write value 0xe1f0ecdc
    li x3, 0xe1f0ecdc
    csrw 0xde2, x3

    #Address 0xde2 read value
    csrr x14, 0xde2

    #Unmapped address 0xe76 testing: Read Reset + Random data Write/Read
    #Address 0xe76 read value
    csrr x14, 0xe76

    #Address 0xe76 Write value 0xab21b9d
    li x3, 0xab21b9d
    csrw 0xe76, x3

    #Address 0xe76 read value
    csrr x14, 0xe76

    #Unmapped address 0x663 testing: Read Reset + Random data Write/Read
    #Address 0x663 read value
    csrr x14, 0x663

    #Address 0x663 Write value 0xf6ea292f
    li x3, 0xf6ea292f
    csrw 0x663, x3

    #Address 0x663 read value
    csrr x14, 0x663

    #Unmapped address 0xdff testing: Read Reset + Random data Write/Read
    #Address 0xdff read value
    csrr x14, 0xdff

    #Address 0xdff Write value 0x85af7d92
    li x3, 0x85af7d92
    csrw 0xdff, x3

    #Address 0xdff read value
    csrr x14, 0xdff

    #Unmapped address 0x467 testing: Read Reset + Random data Write/Read
    #Address 0x467 read value
    csrr x14, 0x467

    #Address 0x467 Write value 0xf2f9a236
    li x3, 0xf2f9a236
    csrw 0x467, x3

    #Address 0x467 read value
    csrr x14, 0x467

    #Unmapped address 0xaab testing: Read Reset + Random data Write/Read
    #Address 0xaab read value
    csrr x14, 0xaab

    #Address 0xaab Write value 0x4df33bb8
    li x3, 0x4df33bb8
    csrw 0xaab, x3

    #Address 0xaab read value
    csrr x14, 0xaab

    #Unmapped address 0x988 testing: Read Reset + Random data Write/Read
    #Address 0x988 read value
    csrr x14, 0x988

    #Address 0x988 Write value 0x2bffc1
    li x3, 0x2bffc1
    csrw 0x988, x3

    #Address 0x988 read value
    csrr x14, 0x988

    #Unmapped address 0x38a testing: Read Reset + Random data Write/Read
    #Address 0x38a read value
    csrr x14, 0x38a

    #Address 0x38a Write value 0x40bc36f2
    li x3, 0x40bc36f2
    csrw 0x38a, x3

    #Address 0x38a read value
    csrr x14, 0x38a

    #Unmapped address 0x81e testing: Read Reset + Random data Write/Read
    #Address 0x81e read value
    csrr x14, 0x81e

    #Address 0x81e Write value 0xb8f3dc99
    li x3, 0xb8f3dc99
    csrw 0x81e, x3

    #Address 0x81e read value
    csrr x14, 0x81e

    #Unmapped address 0x9bd testing: Read Reset + Random data Write/Read
    #Address 0x9bd read value
    csrr x14, 0x9bd

    #Address 0x9bd Write value 0x9b58fa94
    li x3, 0x9b58fa94
    csrw 0x9bd, x3

    #Address 0x9bd read value
    csrr x14, 0x9bd

    #Unmapped address 0xd91 testing: Read Reset + Random data Write/Read
    #Address 0xd91 read value
    csrr x14, 0xd91

    #Address 0xd91 Write value 0x3c0374a5
    li x3, 0x3c0374a5
    csrw 0xd91, x3

    #Address 0xd91 read value
    csrr x14, 0xd91

    #Unmapped address 0xd51 testing: Read Reset + Random data Write/Read
    #Address 0xd51 read value
    csrr x14, 0xd51

    #Address 0xd51 Write value 0x66a89f08
    li x3, 0x66a89f08
    csrw 0xd51, x3

    #Address 0xd51 read value
    csrr x14, 0xd51

    #Unmapped address 0xa15 testing: Read Reset + Random data Write/Read
    #Address 0xa15 read value
    csrr x14, 0xa15

    #Address 0xa15 Write value 0x419a156d
    li x3, 0x419a156d
    csrw 0xa15, x3

    #Address 0xa15 read value
    csrr x14, 0xa15

    #Unmapped address 0x817 testing: Read Reset + Random data Write/Read
    #Address 0x817 read value
    csrr x14, 0x817

    #Address 0x817 Write value 0x7453af30
    li x3, 0x7453af30
    csrw 0x817, x3

    #Address 0x817 read value
    csrr x14, 0x817

    #Unmapped address 0x4a1 testing: Read Reset + Random data Write/Read
    #Address 0x4a1 read value
    csrr x14, 0x4a1

    #Address 0x4a1 Write value 0x777dced6
    li x3, 0x777dced6
    csrw 0x4a1, x3

    #Address 0x4a1 read value
    csrr x14, 0x4a1

    #Unmapped address 0xa16 testing: Read Reset + Random data Write/Read
    #Address 0xa16 read value
    csrr x14, 0xa16

    #Address 0xa16 Write value 0xb63fc66a
    li x3, 0xb63fc66a
    csrw 0xa16, x3

    #Address 0xa16 read value
    csrr x14, 0xa16

    #Unmapped address 0x3d6 testing: Read Reset + Random data Write/Read
    #Address 0x3d6 read value
    csrr x14, 0x3d6

    #Address 0x3d6 Write value 0x9488eb91
    li x3, 0x9488eb91
    csrw 0x3d6, x3

    #Address 0x3d6 read value
    csrr x14, 0x3d6

    #Unmapped address 0x92b testing: Read Reset + Random data Write/Read
    #Address 0x92b read value
    csrr x14, 0x92b

    #Address 0x92b Write value 0xf300380d
    li x3, 0xf300380d
    csrw 0x92b, x3

    #Address 0x92b read value
    csrr x14, 0x92b

    #Unmapped address 0x5f9 testing: Read Reset + Random data Write/Read
    #Address 0x5f9 read value
    csrr x14, 0x5f9

    #Address 0x5f9 Write value 0x21ff794c
    li x3, 0x21ff794c
    csrw 0x5f9, x3

    #Address 0x5f9 read value
    csrr x14, 0x5f9

    #Unmapped address 0x88 testing: Read Reset + Random data Write/Read
    #Address 0x88 read value
    csrr x14, 0x88

    #Address 0x88 Write value 0xbdc8d980
    li x3, 0xbdc8d980
    csrw 0x88, x3

    #Address 0x88 read value
    csrr x14, 0x88

    #Unmapped address 0xfee testing: Read Reset + Random data Write/Read
    #Address 0xfee read value
    csrr x14, 0xfee

    #Address 0xfee Write value 0x89793292
    li x3, 0x89793292
    csrw 0xfee, x3

    #Address 0xfee read value
    csrr x14, 0xfee

    #Unmapped address 0xf6f testing: Read Reset + Random data Write/Read
    #Address 0xf6f read value
    csrr x14, 0xf6f

    #Address 0xf6f Write value 0xf92f3140
    li x3, 0xf92f3140
    csrw 0xf6f, x3

    #Address 0xf6f read value
    csrr x14, 0xf6f

    #Unmapped address 0x9c9 testing: Read Reset + Random data Write/Read
    #Address 0x9c9 read value
    csrr x14, 0x9c9

    #Address 0x9c9 Write value 0x5b553770
    li x3, 0x5b553770
    csrw 0x9c9, x3

    #Address 0x9c9 read value
    csrr x14, 0x9c9

    #Unmapped address 0x616 testing: Read Reset + Random data Write/Read
    #Address 0x616 read value
    csrr x14, 0x616

    #Address 0x616 Write value 0xf82d3662
    li x3, 0xf82d3662
    csrw 0x616, x3

    #Address 0x616 read value
    csrr x14, 0x616

    #Unmapped address 0x27e testing: Read Reset + Random data Write/Read
    #Address 0x27e read value
    csrr x14, 0x27e

    #Address 0x27e Write value 0x2fcfc678
    li x3, 0x2fcfc678
    csrw 0x27e, x3

    #Address 0x27e read value
    csrr x14, 0x27e

    #Unmapped address 0x28b testing: Read Reset + Random data Write/Read
    #Address 0x28b read value
    csrr x14, 0x28b

    #Address 0x28b Write value 0x76f924d9
    li x3, 0x76f924d9
    csrw 0x28b, x3

    #Address 0x28b read value
    csrr x14, 0x28b

    #Unmapped address 0x228 testing: Read Reset + Random data Write/Read
    #Address 0x228 read value
    csrr x14, 0x228

    #Address 0x228 Write value 0x6c4f0f6e
    li x3, 0x6c4f0f6e
    csrw 0x228, x3

    #Address 0x228 read value
    csrr x14, 0x228

    #Unmapped address 0x51e testing: Read Reset + Random data Write/Read
    #Address 0x51e read value
    csrr x14, 0x51e

    #Address 0x51e Write value 0x108273e0
    li x3, 0x108273e0
    csrw 0x51e, x3

    #Address 0x51e read value
    csrr x14, 0x51e

    #Unmapped address 0x477 testing: Read Reset + Random data Write/Read
    #Address 0x477 read value
    csrr x14, 0x477

    #Address 0x477 Write value 0xa778a59
    li x3, 0xa778a59
    csrw 0x477, x3

    #Address 0x477 read value
    csrr x14, 0x477

    #Unmapped address 0x201 testing: Read Reset + Random data Write/Read
    #Address 0x201 read value
    csrr x14, 0x201

    #Address 0x201 Write value 0x152a457
    li x3, 0x152a457
    csrw 0x201, x3

    #Address 0x201 read value
    csrr x14, 0x201

    #Unmapped address 0xf31 testing: Read Reset + Random data Write/Read
    #Address 0xf31 read value
    csrr x14, 0xf31

    #Address 0xf31 Write value 0x358ef6c7
    li x3, 0x358ef6c7
    csrw 0xf31, x3

    #Address 0xf31 read value
    csrr x14, 0xf31

    #Unmapped address 0x75e testing: Read Reset + Random data Write/Read
    #Address 0x75e read value
    csrr x14, 0x75e

    #Address 0x75e Write value 0x96841519
    li x3, 0x96841519
    csrw 0x75e, x3

    #Address 0x75e read value
    csrr x14, 0x75e

    #Unmapped address 0x246 testing: Read Reset + Random data Write/Read
    #Address 0x246 read value
    csrr x14, 0x246

    #Address 0x246 Write value 0x8062a41b
    li x3, 0x8062a41b
    csrw 0x246, x3

    #Address 0x246 read value
    csrr x14, 0x246

    #Unmapped address 0xd5c testing: Read Reset + Random data Write/Read
    #Address 0xd5c read value
    csrr x14, 0xd5c

    #Address 0xd5c Write value 0xcc06a8eb
    li x3, 0xcc06a8eb
    csrw 0xd5c, x3

    #Address 0xd5c read value
    csrr x14, 0xd5c

    #Unmapped address 0x662 testing: Read Reset + Random data Write/Read
    #Address 0x662 read value
    csrr x14, 0x662

    #Address 0x662 Write value 0x8874285f
    li x3, 0x8874285f
    csrw 0x662, x3

    #Address 0x662 read value
    csrr x14, 0x662

    #Unmapped address 0x47 testing: Read Reset + Random data Write/Read
    #Address 0x47 read value
    csrr x14, 0x47

    #Address 0x47 Write value 0xd8ba5c2c
    li x3, 0xd8ba5c2c
    csrw 0x47, x3

    #Address 0x47 read value
    csrr x14, 0x47

    #Unmapped address 0xde8 testing: Read Reset + Random data Write/Read
    #Address 0xde8 read value
    csrr x14, 0xde8

    #Address 0xde8 Write value 0xb37bf98c
    li x3, 0xb37bf98c
    csrw 0xde8, x3

    #Address 0xde8 read value
    csrr x14, 0xde8

    #Unmapped address 0x1f4 testing: Read Reset + Random data Write/Read
    #Address 0x1f4 read value
    csrr x14, 0x1f4

    #Address 0x1f4 Write value 0x9d288646
    li x3, 0x9d288646
    csrw 0x1f4, x3

    #Address 0x1f4 read value
    csrr x14, 0x1f4

    #Unmapped address 0x7b7 testing: Read Reset + Random data Write/Read
    #Address 0x7b7 read value
    csrr x14, 0x7b7

    #Address 0x7b7 Write value 0x75e0168a
    li x3, 0x75e0168a
    csrw 0x7b7, x3

    #Address 0x7b7 read value
    csrr x14, 0x7b7

    #Unmapped address 0x4c0 testing: Read Reset + Random data Write/Read
    #Address 0x4c0 read value
    csrr x14, 0x4c0

    #Address 0x4c0 Write value 0xd603a2b0
    li x3, 0xd603a2b0
    csrw 0x4c0, x3

    #Address 0x4c0 read value
    csrr x14, 0x4c0

    #Unmapped address 0xca1 testing: Read Reset + Random data Write/Read
    #Address 0xca1 read value
    csrr x14, 0xca1

    #Address 0xca1 Write value 0xec9583c7
    li x3, 0xec9583c7
    csrw 0xca1, x3

    #Address 0xca1 read value
    csrr x14, 0xca1

    #Unmapped address 0x9d9 testing: Read Reset + Random data Write/Read
    #Address 0x9d9 read value
    csrr x14, 0x9d9

    #Address 0x9d9 Write value 0xa0603e15
    li x3, 0xa0603e15
    csrw 0x9d9, x3

    #Address 0x9d9 read value
    csrr x14, 0x9d9

    #Unmapped address 0x67f testing: Read Reset + Random data Write/Read
    #Address 0x67f read value
    csrr x14, 0x67f

    #Address 0x67f Write value 0x980487ec
    li x3, 0x980487ec
    csrw 0x67f, x3

    #Address 0x67f read value
    csrr x14, 0x67f

    #Unmapped address 0x490 testing: Read Reset + Random data Write/Read
    #Address 0x490 read value
    csrr x14, 0x490

    #Address 0x490 Write value 0x733efedf
    li x3, 0x733efedf
    csrw 0x490, x3

    #Address 0x490 read value
    csrr x14, 0x490

    #Unmapped address 0x35 testing: Read Reset + Random data Write/Read
    #Address 0x35 read value
    csrr x14, 0x35

    #Address 0x35 Write value 0x901b9e4d
    li x3, 0x901b9e4d
    csrw 0x35, x3

    #Address 0x35 read value
    csrr x14, 0x35

    #Unmapped address 0x114 testing: Read Reset + Random data Write/Read
    #Address 0x114 read value
    csrr x14, 0x114

    #Address 0x114 Write value 0x3a30bd07
    li x3, 0x3a30bd07
    csrw 0x114, x3

    #Address 0x114 read value
    csrr x14, 0x114

    #Unmapped address 0xca4 testing: Read Reset + Random data Write/Read
    #Address 0xca4 read value
    csrr x14, 0xca4

    #Address 0xca4 Write value 0x2085219e
    li x3, 0x2085219e
    csrw 0xca4, x3

    #Address 0xca4 read value
    csrr x14, 0xca4

    #Unmapped address 0xe1 testing: Read Reset + Random data Write/Read
    #Address 0xe1 read value
    csrr x14, 0xe1

    #Address 0xe1 Write value 0xaef85347
    li x3, 0xaef85347
    csrw 0xe1, x3

    #Address 0xe1 read value
    csrr x14, 0xe1

    #Unmapped address 0x2ec testing: Read Reset + Random data Write/Read
    #Address 0x2ec read value
    csrr x14, 0x2ec

    #Address 0x2ec Write value 0xe9af49b7
    li x3, 0xe9af49b7
    csrw 0x2ec, x3

    #Address 0x2ec read value
    csrr x14, 0x2ec

    #Unmapped address 0x299 testing: Read Reset + Random data Write/Read
    #Address 0x299 read value
    csrr x14, 0x299

    #Address 0x299 Write value 0x39be272c
    li x3, 0x39be272c
    csrw 0x299, x3

    #Address 0x299 read value
    csrr x14, 0x299

    #Unmapped address 0xf6b testing: Read Reset + Random data Write/Read
    #Address 0xf6b read value
    csrr x14, 0xf6b

    #Address 0xf6b Write value 0x91035068
    li x3, 0x91035068
    csrw 0xf6b, x3

    #Address 0xf6b read value
    csrr x14, 0xf6b

    #Unmapped address 0x742 testing: Read Reset + Random data Write/Read
    #Address 0x742 read value
    csrr x14, 0x742

    #Address 0x742 Write value 0xa0a3b2f
    li x3, 0xa0a3b2f
    csrw 0x742, x3

    #Address 0x742 read value
    csrr x14, 0x742

    #Unmapped address 0xcc7 testing: Read Reset + Random data Write/Read
    #Address 0xcc7 read value
    csrr x14, 0xcc7

    #Address 0xcc7 Write value 0x5270f42b
    li x3, 0x5270f42b
    csrw 0xcc7, x3

    #Address 0xcc7 read value
    csrr x14, 0xcc7

    #Unmapped address 0xe0f testing: Read Reset + Random data Write/Read
    #Address 0xe0f read value
    csrr x14, 0xe0f

    #Address 0xe0f Write value 0x3c23ca6b
    li x3, 0x3c23ca6b
    csrw 0xe0f, x3

    #Address 0xe0f read value
    csrr x14, 0xe0f

    #Unmapped address 0x4a8 testing: Read Reset + Random data Write/Read
    #Address 0x4a8 read value
    csrr x14, 0x4a8

    #Address 0x4a8 Write value 0x5adb7bde
    li x3, 0x5adb7bde
    csrw 0x4a8, x3

    #Address 0x4a8 read value
    csrr x14, 0x4a8

    #Unmapped address 0xf3d testing: Read Reset + Random data Write/Read
    #Address 0xf3d read value
    csrr x14, 0xf3d

    #Address 0xf3d Write value 0x827bf896
    li x3, 0x827bf896
    csrw 0xf3d, x3

    #Address 0xf3d read value
    csrr x14, 0xf3d

    #Unmapped address 0x9c1 testing: Read Reset + Random data Write/Read
    #Address 0x9c1 read value
    csrr x14, 0x9c1

    #Address 0x9c1 Write value 0x2c109d74
    li x3, 0x2c109d74
    csrw 0x9c1, x3

    #Address 0x9c1 read value
    csrr x14, 0x9c1

    #Unmapped address 0xb6e testing: Read Reset + Random data Write/Read
    #Address 0xb6e read value
    csrr x14, 0xb6e

    #Address 0xb6e Write value 0x821e1649
    li x3, 0x821e1649
    csrw 0xb6e, x3

    #Address 0xb6e read value
    csrr x14, 0xb6e

    #Unmapped address 0xc35 testing: Read Reset + Random data Write/Read
    #Address 0xc35 read value
    csrr x14, 0xc35

    #Address 0xc35 Write value 0x5355af80
    li x3, 0x5355af80
    csrw 0xc35, x3

    #Address 0xc35 read value
    csrr x14, 0xc35

    #Unmapped address 0x2ad testing: Read Reset + Random data Write/Read
    #Address 0x2ad read value
    csrr x14, 0x2ad

    #Address 0x2ad Write value 0x4064de91
    li x3, 0x4064de91
    csrw 0x2ad, x3

    #Address 0x2ad read value
    csrr x14, 0x2ad

    #Unmapped address 0x2cb testing: Read Reset + Random data Write/Read
    #Address 0x2cb read value
    csrr x14, 0x2cb

    #Address 0x2cb Write value 0x51a8499
    li x3, 0x51a8499
    csrw 0x2cb, x3

    #Address 0x2cb read value
    csrr x14, 0x2cb

    #Unmapped address 0xbe6 testing: Read Reset + Random data Write/Read
    #Address 0xbe6 read value
    csrr x14, 0xbe6

    #Address 0xbe6 Write value 0x5a4d8247
    li x3, 0x5a4d8247
    csrw 0xbe6, x3

    #Address 0xbe6 read value
    csrr x14, 0xbe6

    #Unmapped address 0x6f9 testing: Read Reset + Random data Write/Read
    #Address 0x6f9 read value
    csrr x14, 0x6f9

    #Address 0x6f9 Write value 0xcab73f3d
    li x3, 0xcab73f3d
    csrw 0x6f9, x3

    #Address 0x6f9 read value
    csrr x14, 0x6f9

    #Unmapped address 0xe33 testing: Read Reset + Random data Write/Read
    #Address 0xe33 read value
    csrr x14, 0xe33

    #Address 0xe33 Write value 0x6fb34ac5
    li x3, 0x6fb34ac5
    csrw 0xe33, x3

    #Address 0xe33 read value
    csrr x14, 0xe33

    #Unmapped address 0x1f3 testing: Read Reset + Random data Write/Read
    #Address 0x1f3 read value
    csrr x14, 0x1f3

    #Address 0x1f3 Write value 0xe136b393
    li x3, 0xe136b393
    csrw 0x1f3, x3

    #Address 0x1f3 read value
    csrr x14, 0x1f3

    #Unmapped address 0x2c testing: Read Reset + Random data Write/Read
    #Address 0x2c read value
    csrr x14, 0x2c

    #Address 0x2c Write value 0x86a4c44a
    li x3, 0x86a4c44a
    csrw 0x2c, x3

    #Address 0x2c read value
    csrr x14, 0x2c

    #Unmapped address 0x314 testing: Read Reset + Random data Write/Read
    #Address 0x314 read value
    csrr x14, 0x314

    #Address 0x314 Write value 0xd6d994d3
    li x3, 0xd6d994d3
    csrw 0x314, x3

    #Address 0x314 read value
    csrr x14, 0x314

    #Unmapped address 0xb01 testing: Read Reset + Random data Write/Read
    #Address 0xb01 read value
    csrr x14, 0xb01

    #Address 0xb01 Write value 0x5b356dbf
    li x3, 0x5b356dbf
    csrw 0xb01, x3

    #Address 0xb01 read value
    csrr x14, 0xb01

    #Unmapped address 0x50 testing: Read Reset + Random data Write/Read
    #Address 0x50 read value
    csrr x14, 0x50

    #Address 0x50 Write value 0x2498db83
    li x3, 0x2498db83
    csrw 0x50, x3

    #Address 0x50 read value
    csrr x14, 0x50

    #Unmapped address 0x799 testing: Read Reset + Random data Write/Read
    #Address 0x799 read value
    csrr x14, 0x799

    #Address 0x799 Write value 0x1515b853
    li x3, 0x1515b853
    csrw 0x799, x3

    #Address 0x799 read value
    csrr x14, 0x799

    #Unmapped address 0x51b testing: Read Reset + Random data Write/Read
    #Address 0x51b read value
    csrr x14, 0x51b

    #Address 0x51b Write value 0x2d56061f
    li x3, 0x2d56061f
    csrw 0x51b, x3

    #Address 0x51b read value
    csrr x14, 0x51b

    #Unmapped address 0x71d testing: Read Reset + Random data Write/Read
    #Address 0x71d read value
    csrr x14, 0x71d

    #Address 0x71d Write value 0x14713d84
    li x3, 0x14713d84
    csrw 0x71d, x3

    #Address 0x71d read value
    csrr x14, 0x71d

    #Unmapped address 0x2f0 testing: Read Reset + Random data Write/Read
    #Address 0x2f0 read value
    csrr x14, 0x2f0

    #Address 0x2f0 Write value 0x460e156a
    li x3, 0x460e156a
    csrw 0x2f0, x3

    #Address 0x2f0 read value
    csrr x14, 0x2f0

    #Unmapped address 0x478 testing: Read Reset + Random data Write/Read
    #Address 0x478 read value
    csrr x14, 0x478

    #Address 0x478 Write value 0xb3c57e81
    li x3, 0xb3c57e81
    csrw 0x478, x3

    #Address 0x478 read value
    csrr x14, 0x478

    #Unmapped address 0x78e testing: Read Reset + Random data Write/Read
    #Address 0x78e read value
    csrr x14, 0x78e

    #Address 0x78e Write value 0xfc5b3517
    li x3, 0xfc5b3517
    csrw 0x78e, x3

    #Address 0x78e read value
    csrr x14, 0x78e

    #Unmapped address 0x1 testing: Read Reset + Random data Write/Read
    #Address 0x1 read value
    csrr x14, 0x1

    #Address 0x1 Write value 0x19710064
    li x3, 0x19710064
    csrw 0x1, x3

    #Address 0x1 read value
    csrr x14, 0x1

    #Unmapped address 0x736 testing: Read Reset + Random data Write/Read
    #Address 0x736 read value
    csrr x14, 0x736

    #Address 0x736 Write value 0xd92fe1e
    li x3, 0xd92fe1e
    csrw 0x736, x3

    #Address 0x736 read value
    csrr x14, 0x736

    #Unmapped address 0x8e9 testing: Read Reset + Random data Write/Read
    #Address 0x8e9 read value
    csrr x14, 0x8e9

    #Address 0x8e9 Write value 0x97a2917e
    li x3, 0x97a2917e
    csrw 0x8e9, x3

    #Address 0x8e9 read value
    csrr x14, 0x8e9

    #Unmapped address 0x74a testing: Read Reset + Random data Write/Read
    #Address 0x74a read value
    csrr x14, 0x74a

    #Address 0x74a Write value 0x6f8d52f4
    li x3, 0x6f8d52f4
    csrw 0x74a, x3

    #Address 0x74a read value
    csrr x14, 0x74a

    #Unmapped address 0xb27 testing: Read Reset + Random data Write/Read
    #Address 0xb27 read value
    csrr x14, 0xb27

    #Address 0xb27 Write value 0xee5efaaf
    li x3, 0xee5efaaf
    csrw 0xb27, x3

    #Address 0xb27 read value
    csrr x14, 0xb27

    #Unmapped address 0x519 testing: Read Reset + Random data Write/Read
    #Address 0x519 read value
    csrr x14, 0x519

    #Address 0x519 Write value 0xa9a9c570
    li x3, 0xa9a9c570
    csrw 0x519, x3

    #Address 0x519 read value
    csrr x14, 0x519

    #Unmapped address 0x16f testing: Read Reset + Random data Write/Read
    #Address 0x16f read value
    csrr x14, 0x16f

    #Address 0x16f Write value 0xff2be8f5
    li x3, 0xff2be8f5
    csrw 0x16f, x3

    #Address 0x16f read value
    csrr x14, 0x16f

    #Unmapped address 0xee7 testing: Read Reset + Random data Write/Read
    #Address 0xee7 read value
    csrr x14, 0xee7

    #Address 0xee7 Write value 0xfe6263b3
    li x3, 0xfe6263b3
    csrw 0xee7, x3

    #Address 0xee7 read value
    csrr x14, 0xee7

    #Unmapped address 0x1a8 testing: Read Reset + Random data Write/Read
    #Address 0x1a8 read value
    csrr x14, 0x1a8

    #Address 0x1a8 Write value 0x65518f1b
    li x3, 0x65518f1b
    csrw 0x1a8, x3

    #Address 0x1a8 read value
    csrr x14, 0x1a8

    #Unmapped address 0xea7 testing: Read Reset + Random data Write/Read
    #Address 0xea7 read value
    csrr x14, 0xea7

    #Address 0xea7 Write value 0xa0dea8eb
    li x3, 0xa0dea8eb
    csrw 0xea7, x3

    #Address 0xea7 read value
    csrr x14, 0xea7

    #Unmapped address 0xe92 testing: Read Reset + Random data Write/Read
    #Address 0xe92 read value
    csrr x14, 0xe92

    #Address 0xe92 Write value 0x758090cf
    li x3, 0x758090cf
    csrw 0xe92, x3

    #Address 0xe92 read value
    csrr x14, 0xe92

    #Unmapped address 0x19e testing: Read Reset + Random data Write/Read
    #Address 0x19e read value
    csrr x14, 0x19e

    #Address 0x19e Write value 0x50f004a8
    li x3, 0x50f004a8
    csrw 0x19e, x3

    #Address 0x19e read value
    csrr x14, 0x19e

    #Unmapped address 0x82c testing: Read Reset + Random data Write/Read
    #Address 0x82c read value
    csrr x14, 0x82c

    #Address 0x82c Write value 0x1ef997d5
    li x3, 0x1ef997d5
    csrw 0x82c, x3

    #Address 0x82c read value
    csrr x14, 0x82c

    #Unmapped address 0xd08 testing: Read Reset + Random data Write/Read
    #Address 0xd08 read value
    csrr x14, 0xd08

    #Address 0xd08 Write value 0x95d6782
    li x3, 0x95d6782
    csrw 0xd08, x3

    #Address 0xd08 read value
    csrr x14, 0xd08

    #Unmapped address 0xbbf testing: Read Reset + Random data Write/Read
    #Address 0xbbf read value
    csrr x14, 0xbbf

    #Address 0xbbf Write value 0x730f5bba
    li x3, 0x730f5bba
    csrw 0xbbf, x3

    #Address 0xbbf read value
    csrr x14, 0xbbf

    #Unmapped address 0xf5d testing: Read Reset + Random data Write/Read
    #Address 0xf5d read value
    csrr x14, 0xf5d

    #Address 0xf5d Write value 0x443fdae2
    li x3, 0x443fdae2
    csrw 0xf5d, x3

    #Address 0xf5d read value
    csrr x14, 0xf5d

    #Unmapped address 0x498 testing: Read Reset + Random data Write/Read
    #Address 0x498 read value
    csrr x14, 0x498

    #Address 0x498 Write value 0xd013baf8
    li x3, 0xd013baf8
    csrw 0x498, x3

    #Address 0x498 read value
    csrr x14, 0x498

    #Unmapped address 0xc4b testing: Read Reset + Random data Write/Read
    #Address 0xc4b read value
    csrr x14, 0xc4b

    #Address 0xc4b Write value 0xbba50d8b
    li x3, 0xbba50d8b
    csrw 0xc4b, x3

    #Address 0xc4b read value
    csrr x14, 0xc4b

    #Unmapped address 0xeab testing: Read Reset + Random data Write/Read
    #Address 0xeab read value
    csrr x14, 0xeab

    #Address 0xeab Write value 0xdaa08180
    li x3, 0xdaa08180
    csrw 0xeab, x3

    #Address 0xeab read value
    csrr x14, 0xeab

    #Unmapped address 0xecf testing: Read Reset + Random data Write/Read
    #Address 0xecf read value
    csrr x14, 0xecf

    #Address 0xecf Write value 0xfdc07e69
    li x3, 0xfdc07e69
    csrw 0xecf, x3

    #Address 0xecf read value
    csrr x14, 0xecf

    #Unmapped address 0xb54 testing: Read Reset + Random data Write/Read
    #Address 0xb54 read value
    csrr x14, 0xb54

    #Address 0xb54 Write value 0x4f19fefe
    li x3, 0x4f19fefe
    csrw 0xb54, x3

    #Address 0xb54 read value
    csrr x14, 0xb54

    #Unmapped address 0xec9 testing: Read Reset + Random data Write/Read
    #Address 0xec9 read value
    csrr x14, 0xec9

    #Address 0xec9 Write value 0x31ee1781
    li x3, 0x31ee1781
    csrw 0xec9, x3

    #Address 0xec9 read value
    csrr x14, 0xec9

    #Unmapped address 0xa98 testing: Read Reset + Random data Write/Read
    #Address 0xa98 read value
    csrr x14, 0xa98

    #Address 0xa98 Write value 0xaf424395
    li x3, 0xaf424395
    csrw 0xa98, x3

    #Address 0xa98 read value
    csrr x14, 0xa98

    #Unmapped address 0xff6 testing: Read Reset + Random data Write/Read
    #Address 0xff6 read value
    csrr x14, 0xff6

    #Address 0xff6 Write value 0x55c7e21d
    li x3, 0x55c7e21d
    csrw 0xff6, x3

    #Address 0xff6 read value
    csrr x14, 0xff6

    #Unmapped address 0x55e testing: Read Reset + Random data Write/Read
    #Address 0x55e read value
    csrr x14, 0x55e

    #Address 0x55e Write value 0xa32a59c7
    li x3, 0xa32a59c7
    csrw 0x55e, x3

    #Address 0x55e read value
    csrr x14, 0x55e

    #Unmapped address 0x534 testing: Read Reset + Random data Write/Read
    #Address 0x534 read value
    csrr x14, 0x534

    #Address 0x534 Write value 0x541eac85
    li x3, 0x541eac85
    csrw 0x534, x3

    #Address 0x534 read value
    csrr x14, 0x534

    #Unmapped address 0xd3 testing: Read Reset + Random data Write/Read
    #Address 0xd3 read value
    csrr x14, 0xd3

    #Address 0xd3 Write value 0x8ac0c97a
    li x3, 0x8ac0c97a
    csrw 0xd3, x3

    #Address 0xd3 read value
    csrr x14, 0xd3

    #Unmapped address 0xf9 testing: Read Reset + Random data Write/Read
    #Address 0xf9 read value
    csrr x14, 0xf9

    #Address 0xf9 Write value 0x37c9ae4c
    li x3, 0x37c9ae4c
    csrw 0xf9, x3

    #Address 0xf9 read value
    csrr x14, 0xf9

    #Unmapped address 0x571 testing: Read Reset + Random data Write/Read
    #Address 0x571 read value
    csrr x14, 0x571

    #Address 0x571 Write value 0x6c78c451
    li x3, 0x6c78c451
    csrw 0x571, x3

    #Address 0x571 read value
    csrr x14, 0x571

    #Unmapped address 0xef0 testing: Read Reset + Random data Write/Read
    #Address 0xef0 read value
    csrr x14, 0xef0

    #Address 0xef0 Write value 0xbe0ebfef
    li x3, 0xbe0ebfef
    csrw 0xef0, x3

    #Address 0xef0 read value
    csrr x14, 0xef0

    #Unmapped address 0x966 testing: Read Reset + Random data Write/Read
    #Address 0x966 read value
    csrr x14, 0x966

    #Address 0x966 Write value 0xe934d97c
    li x3, 0xe934d97c
    csrw 0x966, x3

    #Address 0x966 read value
    csrr x14, 0x966

    #Unmapped address 0xa03 testing: Read Reset + Random data Write/Read
    #Address 0xa03 read value
    csrr x14, 0xa03

    #Address 0xa03 Write value 0x95d7f555
    li x3, 0x95d7f555
    csrw 0xa03, x3

    #Address 0xa03 read value
    csrr x14, 0xa03

    #Unmapped address 0x882 testing: Read Reset + Random data Write/Read
    #Address 0x882 read value
    csrr x14, 0x882

    #Address 0x882 Write value 0x869cc54d
    li x3, 0x869cc54d
    csrw 0x882, x3

    #Address 0x882 read value
    csrr x14, 0x882

    #Unmapped address 0x86d testing: Read Reset + Random data Write/Read
    #Address 0x86d read value
    csrr x14, 0x86d

    #Address 0x86d Write value 0xad1ff953
    li x3, 0xad1ff953
    csrw 0x86d, x3

    #Address 0x86d read value
    csrr x14, 0x86d

    #Unmapped address 0x9ee testing: Read Reset + Random data Write/Read
    #Address 0x9ee read value
    csrr x14, 0x9ee

    #Address 0x9ee Write value 0xd455b9c
    li x3, 0xd455b9c
    csrw 0x9ee, x3

    #Address 0x9ee read value
    csrr x14, 0x9ee

    #Unmapped address 0x6d1 testing: Read Reset + Random data Write/Read
    #Address 0x6d1 read value
    csrr x14, 0x6d1

    #Address 0x6d1 Write value 0xa8c5282f
    li x3, 0xa8c5282f
    csrw 0x6d1, x3

    #Address 0x6d1 read value
    csrr x14, 0x6d1

    #Unmapped address 0xb40 testing: Read Reset + Random data Write/Read
    #Address 0xb40 read value
    csrr x14, 0xb40

    #Address 0xb40 Write value 0xd9061388
    li x3, 0xd9061388
    csrw 0xb40, x3

    #Address 0xb40 read value
    csrr x14, 0xb40

    #Unmapped address 0x566 testing: Read Reset + Random data Write/Read
    #Address 0x566 read value
    csrr x14, 0x566

    #Address 0x566 Write value 0x328137b7
    li x3, 0x328137b7
    csrw 0x566, x3

    #Address 0x566 read value
    csrr x14, 0x566

    #Unmapped address 0xafe testing: Read Reset + Random data Write/Read
    #Address 0xafe read value
    csrr x14, 0xafe

    #Address 0xafe Write value 0xae96b799
    li x3, 0xae96b799
    csrw 0xafe, x3

    #Address 0xafe read value
    csrr x14, 0xafe

    #Unmapped address 0x72 testing: Read Reset + Random data Write/Read
    #Address 0x72 read value
    csrr x14, 0x72

    #Address 0x72 Write value 0xa7d31ece
    li x3, 0xa7d31ece
    csrw 0x72, x3

    #Address 0x72 read value
    csrr x14, 0x72

    #Unmapped address 0x579 testing: Read Reset + Random data Write/Read
    #Address 0x579 read value
    csrr x14, 0x579

    #Address 0x579 Write value 0x8bf49da8
    li x3, 0x8bf49da8
    csrw 0x579, x3

    #Address 0x579 read value
    csrr x14, 0x579

    #Unmapped address 0xc31 testing: Read Reset + Random data Write/Read
    #Address 0xc31 read value
    csrr x14, 0xc31

    #Address 0xc31 Write value 0x98835344
    li x3, 0x98835344
    csrw 0xc31, x3

    #Address 0xc31 read value
    csrr x14, 0xc31

    #Unmapped address 0x386 testing: Read Reset + Random data Write/Read
    #Address 0x386 read value
    csrr x14, 0x386

    #Address 0x386 Write value 0x6cd7c9f8
    li x3, 0x6cd7c9f8
    csrw 0x386, x3

    #Address 0x386 read value
    csrr x14, 0x386

    #Unmapped address 0xed1 testing: Read Reset + Random data Write/Read
    #Address 0xed1 read value
    csrr x14, 0xed1

    #Address 0xed1 Write value 0x6842233d
    li x3, 0x6842233d
    csrw 0xed1, x3

    #Address 0xed1 read value
    csrr x14, 0xed1

    #Unmapped address 0x675 testing: Read Reset + Random data Write/Read
    #Address 0x675 read value
    csrr x14, 0x675

    #Address 0x675 Write value 0x8dd2b22a
    li x3, 0x8dd2b22a
    csrw 0x675, x3

    #Address 0x675 read value
    csrr x14, 0x675

    #Unmapped address 0xf73 testing: Read Reset + Random data Write/Read
    #Address 0xf73 read value
    csrr x14, 0xf73

    #Address 0xf73 Write value 0xa7aaa5d3
    li x3, 0xa7aaa5d3
    csrw 0xf73, x3

    #Address 0xf73 read value
    csrr x14, 0xf73

    #Unmapped address 0x53a testing: Read Reset + Random data Write/Read
    #Address 0x53a read value
    csrr x14, 0x53a

    #Address 0x53a Write value 0x9b41eb90
    li x3, 0x9b41eb90
    csrw 0x53a, x3

    #Address 0x53a read value
    csrr x14, 0x53a

    #Unmapped address 0xf54 testing: Read Reset + Random data Write/Read
    #Address 0xf54 read value
    csrr x14, 0xf54

    #Address 0xf54 Write value 0x941204c1
    li x3, 0x941204c1
    csrw 0xf54, x3

    #Address 0xf54 read value
    csrr x14, 0xf54

    #Unmapped address 0xcf7 testing: Read Reset + Random data Write/Read
    #Address 0xcf7 read value
    csrr x14, 0xcf7

    #Address 0xcf7 Write value 0xd454b857
    li x3, 0xd454b857
    csrw 0xcf7, x3

    #Address 0xcf7 read value
    csrr x14, 0xcf7

    #Unmapped address 0xa5b testing: Read Reset + Random data Write/Read
    #Address 0xa5b read value
    csrr x14, 0xa5b

    #Address 0xa5b Write value 0x1efa7e29
    li x3, 0x1efa7e29
    csrw 0xa5b, x3

    #Address 0xa5b read value
    csrr x14, 0xa5b

    #Unmapped address 0x8aa testing: Read Reset + Random data Write/Read
    #Address 0x8aa read value
    csrr x14, 0x8aa

    #Address 0x8aa Write value 0xa041c23
    li x3, 0xa041c23
    csrw 0x8aa, x3

    #Address 0x8aa read value
    csrr x14, 0x8aa

    #Unmapped address 0x5ff testing: Read Reset + Random data Write/Read
    #Address 0x5ff read value
    csrr x14, 0x5ff

    #Address 0x5ff Write value 0x480fb51a
    li x3, 0x480fb51a
    csrw 0x5ff, x3

    #Address 0x5ff read value
    csrr x14, 0x5ff

    #Unmapped address 0x9 testing: Read Reset + Random data Write/Read
    #Address 0x9 read value
    csrr x14, 0x9

    #Address 0x9 Write value 0xcec46de6
    li x3, 0xcec46de6
    csrw 0x9, x3

    #Address 0x9 read value
    csrr x14, 0x9

    #Unmapped address 0x583 testing: Read Reset + Random data Write/Read
    #Address 0x583 read value
    csrr x14, 0x583

    #Address 0x583 Write value 0xbc7e2194
    li x3, 0xbc7e2194
    csrw 0x583, x3

    #Address 0x583 read value
    csrr x14, 0x583

    #Unmapped address 0x6dd testing: Read Reset + Random data Write/Read
    #Address 0x6dd read value
    csrr x14, 0x6dd

    #Address 0x6dd Write value 0x81eace40
    li x3, 0x81eace40
    csrw 0x6dd, x3

    #Address 0x6dd read value
    csrr x14, 0x6dd

    #Unmapped address 0x758 testing: Read Reset + Random data Write/Read
    #Address 0x758 read value
    csrr x14, 0x758

    #Address 0x758 Write value 0x940c986b
    li x3, 0x940c986b
    csrw 0x758, x3

    #Address 0x758 read value
    csrr x14, 0x758

    #Unmapped address 0xe19 testing: Read Reset + Random data Write/Read
    #Address 0xe19 read value
    csrr x14, 0xe19

    #Address 0xe19 Write value 0xd5e8adcd
    li x3, 0xd5e8adcd
    csrw 0xe19, x3

    #Address 0xe19 read value
    csrr x14, 0xe19

    #Unmapped address 0x60d testing: Read Reset + Random data Write/Read
    #Address 0x60d read value
    csrr x14, 0x60d

    #Address 0x60d Write value 0x199d2fc1
    li x3, 0x199d2fc1
    csrw 0x60d, x3

    #Address 0x60d read value
    csrr x14, 0x60d

    #Unmapped address 0x6b0 testing: Read Reset + Random data Write/Read
    #Address 0x6b0 read value
    csrr x14, 0x6b0

    #Address 0x6b0 Write value 0x917c7d70
    li x3, 0x917c7d70
    csrw 0x6b0, x3

    #Address 0x6b0 read value
    csrr x14, 0x6b0

    #Unmapped address 0xb37 testing: Read Reset + Random data Write/Read
    #Address 0xb37 read value
    csrr x14, 0xb37

    #Address 0xb37 Write value 0xd6880962
    li x3, 0xd6880962
    csrw 0xb37, x3

    #Address 0xb37 read value
    csrr x14, 0xb37

    #Unmapped address 0xf0b testing: Read Reset + Random data Write/Read
    #Address 0xf0b read value
    csrr x14, 0xf0b

    #Address 0xf0b Write value 0x4c8a2b7b
    li x3, 0x4c8a2b7b
    csrw 0xf0b, x3

    #Address 0xf0b read value
    csrr x14, 0xf0b

    #Unmapped address 0xba3 testing: Read Reset + Random data Write/Read
    #Address 0xba3 read value
    csrr x14, 0xba3

    #Address 0xba3 Write value 0x87f5fff6
    li x3, 0x87f5fff6
    csrw 0xba3, x3

    #Address 0xba3 read value
    csrr x14, 0xba3

    #Unmapped address 0x3cf testing: Read Reset + Random data Write/Read
    #Address 0x3cf read value
    csrr x14, 0x3cf

    #Address 0x3cf Write value 0xa8233a7a
    li x3, 0xa8233a7a
    csrw 0x3cf, x3

    #Address 0x3cf read value
    csrr x14, 0x3cf

    #Unmapped address 0x789 testing: Read Reset + Random data Write/Read
    #Address 0x789 read value
    csrr x14, 0x789

    #Address 0x789 Write value 0x6b75b29f
    li x3, 0x6b75b29f
    csrw 0x789, x3

    #Address 0x789 read value
    csrr x14, 0x789

    #Unmapped address 0x7cd testing: Read Reset + Random data Write/Read
    #Address 0x7cd read value
    csrr x14, 0x7cd

    #Address 0x7cd Write value 0xd8291dc9
    li x3, 0xd8291dc9
    csrw 0x7cd, x3

    #Address 0x7cd read value
    csrr x14, 0x7cd

    #Unmapped address 0x44f testing: Read Reset + Random data Write/Read
    #Address 0x44f read value
    csrr x14, 0x44f

    #Address 0x44f Write value 0xcb3dce82
    li x3, 0xcb3dce82
    csrw 0x44f, x3

    #Address 0x44f read value
    csrr x14, 0x44f

    #Unmapped address 0x91e testing: Read Reset + Random data Write/Read
    #Address 0x91e read value
    csrr x14, 0x91e

    #Address 0x91e Write value 0xb9fa0732
    li x3, 0xb9fa0732
    csrw 0x91e, x3

    #Address 0x91e read value
    csrr x14, 0x91e

    #Unmapped address 0x4c3 testing: Read Reset + Random data Write/Read
    #Address 0x4c3 read value
    csrr x14, 0x4c3

    #Address 0x4c3 Write value 0x9563d5d4
    li x3, 0x9563d5d4
    csrw 0x4c3, x3

    #Address 0x4c3 read value
    csrr x14, 0x4c3

    #Unmapped address 0xa0c testing: Read Reset + Random data Write/Read
    #Address 0xa0c read value
    csrr x14, 0xa0c

    #Address 0xa0c Write value 0xa2daa96c
    li x3, 0xa2daa96c
    csrw 0xa0c, x3

    #Address 0xa0c read value
    csrr x14, 0xa0c

    #Unmapped address 0x5b1 testing: Read Reset + Random data Write/Read
    #Address 0x5b1 read value
    csrr x14, 0x5b1

    #Address 0x5b1 Write value 0x3abf0df9
    li x3, 0x3abf0df9
    csrw 0x5b1, x3

    #Address 0x5b1 read value
    csrr x14, 0x5b1

    #Unmapped address 0x564 testing: Read Reset + Random data Write/Read
    #Address 0x564 read value
    csrr x14, 0x564

    #Address 0x564 Write value 0x41064fe9
    li x3, 0x41064fe9
    csrw 0x564, x3

    #Address 0x564 read value
    csrr x14, 0x564

    #Unmapped address 0x74f testing: Read Reset + Random data Write/Read
    #Address 0x74f read value
    csrr x14, 0x74f

    #Address 0x74f Write value 0xc206a48f
    li x3, 0xc206a48f
    csrw 0x74f, x3

    #Address 0x74f read value
    csrr x14, 0x74f

    #Unmapped address 0x57d testing: Read Reset + Random data Write/Read
    #Address 0x57d read value
    csrr x14, 0x57d

    #Address 0x57d Write value 0x5e27b7e8
    li x3, 0x5e27b7e8
    csrw 0x57d, x3

    #Address 0x57d read value
    csrr x14, 0x57d

    #Unmapped address 0x599 testing: Read Reset + Random data Write/Read
    #Address 0x599 read value
    csrr x14, 0x599

    #Address 0x599 Write value 0x2e9a8666
    li x3, 0x2e9a8666
    csrw 0x599, x3

    #Address 0x599 read value
    csrr x14, 0x599

    #Unmapped address 0xaa3 testing: Read Reset + Random data Write/Read
    #Address 0xaa3 read value
    csrr x14, 0xaa3

    #Address 0xaa3 Write value 0xd53711f7
    li x3, 0xd53711f7
    csrw 0xaa3, x3

    #Address 0xaa3 read value
    csrr x14, 0xaa3

    #Unmapped address 0x30e testing: Read Reset + Random data Write/Read
    #Address 0x30e read value
    csrr x14, 0x30e

    #Address 0x30e Write value 0x410f1b33
    li x3, 0x410f1b33
    csrw 0x30e, x3

    #Address 0x30e read value
    csrr x14, 0x30e

    #Unmapped address 0xedd testing: Read Reset + Random data Write/Read
    #Address 0xedd read value
    csrr x14, 0xedd

    #Address 0xedd Write value 0x160c82c3
    li x3, 0x160c82c3
    csrw 0xedd, x3

    #Address 0xedd read value
    csrr x14, 0xedd

    #Unmapped address 0x978 testing: Read Reset + Random data Write/Read
    #Address 0x978 read value
    csrr x14, 0x978

    #Address 0x978 Write value 0xfced70ba
    li x3, 0xfced70ba
    csrw 0x978, x3

    #Address 0x978 read value
    csrr x14, 0x978

    #Unmapped address 0xd testing: Read Reset + Random data Write/Read
    #Address 0xd read value
    csrr x14, 0xd

    #Address 0xd Write value 0x4639bdad
    li x3, 0x4639bdad
    csrw 0xd, x3

    #Address 0xd read value
    csrr x14, 0xd

    #Unmapped address 0x975 testing: Read Reset + Random data Write/Read
    #Address 0x975 read value
    csrr x14, 0x975

    #Address 0x975 Write value 0x32bdab17
    li x3, 0x32bdab17
    csrw 0x975, x3

    #Address 0x975 read value
    csrr x14, 0x975

    #Unmapped address 0x3d testing: Read Reset + Random data Write/Read
    #Address 0x3d read value
    csrr x14, 0x3d

    #Address 0x3d Write value 0x48cb8fea
    li x3, 0x48cb8fea
    csrw 0x3d, x3

    #Address 0x3d read value
    csrr x14, 0x3d

    #Unmapped address 0xd45 testing: Read Reset + Random data Write/Read
    #Address 0xd45 read value
    csrr x14, 0xd45

    #Address 0xd45 Write value 0x83f5da44
    li x3, 0x83f5da44
    csrw 0xd45, x3

    #Address 0xd45 read value
    csrr x14, 0xd45

    #Unmapped address 0x6fe testing: Read Reset + Random data Write/Read
    #Address 0x6fe read value
    csrr x14, 0x6fe

    #Address 0x6fe Write value 0xf44c5de9
    li x3, 0xf44c5de9
    csrw 0x6fe, x3

    #Address 0x6fe read value
    csrr x14, 0x6fe

    #Unmapped address 0x9a9 testing: Read Reset + Random data Write/Read
    #Address 0x9a9 read value
    csrr x14, 0x9a9

    #Address 0x9a9 Write value 0x3b65d48c
    li x3, 0x3b65d48c
    csrw 0x9a9, x3

    #Address 0x9a9 read value
    csrr x14, 0x9a9

    #Unmapped address 0x8d9 testing: Read Reset + Random data Write/Read
    #Address 0x8d9 read value
    csrr x14, 0x8d9

    #Address 0x8d9 Write value 0x5f50ab9b
    li x3, 0x5f50ab9b
    csrw 0x8d9, x3

    #Address 0x8d9 read value
    csrr x14, 0x8d9

    #Unmapped address 0x496 testing: Read Reset + Random data Write/Read
    #Address 0x496 read value
    csrr x14, 0x496

    #Address 0x496 Write value 0x514b47c3
    li x3, 0x514b47c3
    csrw 0x496, x3

    #Address 0x496 read value
    csrr x14, 0x496

    #Unmapped address 0x140 testing: Read Reset + Random data Write/Read
    #Address 0x140 read value
    csrr x14, 0x140

    #Address 0x140 Write value 0x382659d1
    li x3, 0x382659d1
    csrw 0x140, x3

    #Address 0x140 read value
    csrr x14, 0x140

    #Unmapped address 0x9a2 testing: Read Reset + Random data Write/Read
    #Address 0x9a2 read value
    csrr x14, 0x9a2

    #Address 0x9a2 Write value 0xd42efd6b
    li x3, 0xd42efd6b
    csrw 0x9a2, x3

    #Address 0x9a2 read value
    csrr x14, 0x9a2

    #Unmapped address 0x609 testing: Read Reset + Random data Write/Read
    #Address 0x609 read value
    csrr x14, 0x609

    #Address 0x609 Write value 0xc3d218e5
    li x3, 0xc3d218e5
    csrw 0x609, x3

    #Address 0x609 read value
    csrr x14, 0x609

    #Unmapped address 0x6b1 testing: Read Reset + Random data Write/Read
    #Address 0x6b1 read value
    csrr x14, 0x6b1

    #Address 0x6b1 Write value 0xceb515d9
    li x3, 0xceb515d9
    csrw 0x6b1, x3

    #Address 0x6b1 read value
    csrr x14, 0x6b1

    #Unmapped address 0xda9 testing: Read Reset + Random data Write/Read
    #Address 0xda9 read value
    csrr x14, 0xda9

    #Address 0xda9 Write value 0x1963af0d
    li x3, 0x1963af0d
    csrw 0xda9, x3

    #Address 0xda9 read value
    csrr x14, 0xda9

    #Unmapped address 0x86a testing: Read Reset + Random data Write/Read
    #Address 0x86a read value
    csrr x14, 0x86a

    #Address 0x86a Write value 0x86df7327
    li x3, 0x86df7327
    csrw 0x86a, x3

    #Address 0x86a read value
    csrr x14, 0x86a

    #Unmapped address 0x4ca testing: Read Reset + Random data Write/Read
    #Address 0x4ca read value
    csrr x14, 0x4ca

    #Address 0x4ca Write value 0xc250d2b4
    li x3, 0xc250d2b4
    csrw 0x4ca, x3

    #Address 0x4ca read value
    csrr x14, 0x4ca

    #Unmapped address 0x47b testing: Read Reset + Random data Write/Read
    #Address 0x47b read value
    csrr x14, 0x47b

    #Address 0x47b Write value 0x31c83fd3
    li x3, 0x31c83fd3
    csrw 0x47b, x3

    #Address 0x47b read value
    csrr x14, 0x47b

    #Unmapped address 0x9f1 testing: Read Reset + Random data Write/Read
    #Address 0x9f1 read value
    csrr x14, 0x9f1

    #Address 0x9f1 Write value 0x9bad37af
    li x3, 0x9bad37af
    csrw 0x9f1, x3

    #Address 0x9f1 read value
    csrr x14, 0x9f1

    #Unmapped address 0x454 testing: Read Reset + Random data Write/Read
    #Address 0x454 read value
    csrr x14, 0x454

    #Address 0x454 Write value 0x76f66d38
    li x3, 0x76f66d38
    csrw 0x454, x3

    #Address 0x454 read value
    csrr x14, 0x454

    #Unmapped address 0xc5b testing: Read Reset + Random data Write/Read
    #Address 0xc5b read value
    csrr x14, 0xc5b

    #Address 0xc5b Write value 0x68de4867
    li x3, 0x68de4867
    csrw 0xc5b, x3

    #Address 0xc5b read value
    csrr x14, 0xc5b

    #Unmapped address 0xb7d testing: Read Reset + Random data Write/Read
    #Address 0xb7d read value
    csrr x14, 0xb7d

    #Address 0xb7d Write value 0x3e2618aa
    li x3, 0x3e2618aa
    csrw 0xb7d, x3

    #Address 0xb7d read value
    csrr x14, 0xb7d

    #Unmapped address 0x7ce testing: Read Reset + Random data Write/Read
    #Address 0x7ce read value
    csrr x14, 0x7ce

    #Address 0x7ce Write value 0xf3913d5c
    li x3, 0xf3913d5c
    csrw 0x7ce, x3

    #Address 0x7ce read value
    csrr x14, 0x7ce

    #Unmapped address 0x702 testing: Read Reset + Random data Write/Read
    #Address 0x702 read value
    csrr x14, 0x702

    #Address 0x702 Write value 0x555304f8
    li x3, 0x555304f8
    csrw 0x702, x3

    #Address 0x702 read value
    csrr x14, 0x702

    #Unmapped address 0x48b testing: Read Reset + Random data Write/Read
    #Address 0x48b read value
    csrr x14, 0x48b

    #Address 0x48b Write value 0x6508e12c
    li x3, 0x6508e12c
    csrw 0x48b, x3

    #Address 0x48b read value
    csrr x14, 0x48b

    #Unmapped address 0xc23 testing: Read Reset + Random data Write/Read
    #Address 0xc23 read value
    csrr x14, 0xc23

    #Address 0xc23 Write value 0x6b9e6edb
    li x3, 0x6b9e6edb
    csrw 0xc23, x3

    #Address 0xc23 read value
    csrr x14, 0xc23

    #Unmapped address 0xb59 testing: Read Reset + Random data Write/Read
    #Address 0xb59 read value
    csrr x14, 0xb59

    #Address 0xb59 Write value 0xa360f400
    li x3, 0xa360f400
    csrw 0xb59, x3

    #Address 0xb59 read value
    csrr x14, 0xb59

    #Unmapped address 0xcb1 testing: Read Reset + Random data Write/Read
    #Address 0xcb1 read value
    csrr x14, 0xcb1

    #Address 0xcb1 Write value 0xdc2ab3f4
    li x3, 0xdc2ab3f4
    csrw 0xcb1, x3

    #Address 0xcb1 read value
    csrr x14, 0xcb1

    #Unmapped address 0x601 testing: Read Reset + Random data Write/Read
    #Address 0x601 read value
    csrr x14, 0x601

    #Address 0x601 Write value 0x43eeda4d
    li x3, 0x43eeda4d
    csrw 0x601, x3

    #Address 0x601 read value
    csrr x14, 0x601

    #Unmapped address 0xc0d testing: Read Reset + Random data Write/Read
    #Address 0xc0d read value
    csrr x14, 0xc0d

    #Address 0xc0d Write value 0xf2d8fbd4
    li x3, 0xf2d8fbd4
    csrw 0xc0d, x3

    #Address 0xc0d read value
    csrr x14, 0xc0d

    #Unmapped address 0x46c testing: Read Reset + Random data Write/Read
    #Address 0x46c read value
    csrr x14, 0x46c

    #Address 0x46c Write value 0x135fbb72
    li x3, 0x135fbb72
    csrw 0x46c, x3

    #Address 0x46c read value
    csrr x14, 0x46c

    #Unmapped address 0x95c testing: Read Reset + Random data Write/Read
    #Address 0x95c read value
    csrr x14, 0x95c

    #Address 0x95c Write value 0x679ea39a
    li x3, 0x679ea39a
    csrw 0x95c, x3

    #Address 0x95c read value
    csrr x14, 0x95c

    #Unmapped address 0x253 testing: Read Reset + Random data Write/Read
    #Address 0x253 read value
    csrr x14, 0x253

    #Address 0x253 Write value 0xa0f92b0c
    li x3, 0xa0f92b0c
    csrw 0x253, x3

    #Address 0x253 read value
    csrr x14, 0x253

    #Unmapped address 0xa3c testing: Read Reset + Random data Write/Read
    #Address 0xa3c read value
    csrr x14, 0xa3c

    #Address 0xa3c Write value 0xb3a19561
    li x3, 0xb3a19561
    csrw 0xa3c, x3

    #Address 0xa3c read value
    csrr x14, 0xa3c

    #Unmapped address 0x5b testing: Read Reset + Random data Write/Read
    #Address 0x5b read value
    csrr x14, 0x5b

    #Address 0x5b Write value 0xaedff171
    li x3, 0xaedff171
    csrw 0x5b, x3

    #Address 0x5b read value
    csrr x14, 0x5b

    #Unmapped address 0x7b2 testing: Read Reset + Random data Write/Read
    #Address 0x7b2 read value
    csrr x14, 0x7b2

    #Address 0x7b2 Write value 0xf37b1f06
    li x3, 0xf37b1f06
    csrw 0x7b2, x3

    #Address 0x7b2 read value
    csrr x14, 0x7b2

    #Unmapped address 0x45e testing: Read Reset + Random data Write/Read
    #Address 0x45e read value
    csrr x14, 0x45e

    #Address 0x45e Write value 0xe96ab79c
    li x3, 0xe96ab79c
    csrw 0x45e, x3

    #Address 0x45e read value
    csrr x14, 0x45e

    #Unmapped address 0x729 testing: Read Reset + Random data Write/Read
    #Address 0x729 read value
    csrr x14, 0x729

    #Address 0x729 Write value 0xfad9a50b
    li x3, 0xfad9a50b
    csrw 0x729, x3

    #Address 0x729 read value
    csrr x14, 0x729

    #Unmapped address 0x88b testing: Read Reset + Random data Write/Read
    #Address 0x88b read value
    csrr x14, 0x88b

    #Address 0x88b Write value 0xa215bf65
    li x3, 0xa215bf65
    csrw 0x88b, x3

    #Address 0x88b read value
    csrr x14, 0x88b

    #Unmapped address 0x6d4 testing: Read Reset + Random data Write/Read
    #Address 0x6d4 read value
    csrr x14, 0x6d4

    #Address 0x6d4 Write value 0xc7e0dfbb
    li x3, 0xc7e0dfbb
    csrw 0x6d4, x3

    #Address 0x6d4 read value
    csrr x14, 0x6d4

    #Unmapped address 0xbba testing: Read Reset + Random data Write/Read
    #Address 0xbba read value
    csrr x14, 0xbba

    #Address 0xbba Write value 0xda48de83
    li x3, 0xda48de83
    csrw 0xbba, x3

    #Address 0xbba read value
    csrr x14, 0xbba

    #Unmapped address 0x46a testing: Read Reset + Random data Write/Read
    #Address 0x46a read value
    csrr x14, 0x46a

    #Address 0x46a Write value 0x6b4ab239
    li x3, 0x6b4ab239
    csrw 0x46a, x3

    #Address 0x46a read value
    csrr x14, 0x46a

    #Unmapped address 0x10f testing: Read Reset + Random data Write/Read
    #Address 0x10f read value
    csrr x14, 0x10f

    #Address 0x10f Write value 0xc145bce9
    li x3, 0xc145bce9
    csrw 0x10f, x3

    #Address 0x10f read value
    csrr x14, 0x10f

    #Unmapped address 0x1e0 testing: Read Reset + Random data Write/Read
    #Address 0x1e0 read value
    csrr x14, 0x1e0

    #Address 0x1e0 Write value 0xb0ac5078
    li x3, 0xb0ac5078
    csrw 0x1e0, x3

    #Address 0x1e0 read value
    csrr x14, 0x1e0

    #Unmapped address 0x262 testing: Read Reset + Random data Write/Read
    #Address 0x262 read value
    csrr x14, 0x262

    #Address 0x262 Write value 0xfcefac9f
    li x3, 0xfcefac9f
    csrw 0x262, x3

    #Address 0x262 read value
    csrr x14, 0x262

    #Unmapped address 0xc40 testing: Read Reset + Random data Write/Read
    #Address 0xc40 read value
    csrr x14, 0xc40

    #Address 0xc40 Write value 0x24d5549a
    li x3, 0x24d5549a
    csrw 0xc40, x3

    #Address 0xc40 read value
    csrr x14, 0xc40

    #Unmapped address 0x129 testing: Read Reset + Random data Write/Read
    #Address 0x129 read value
    csrr x14, 0x129

    #Address 0x129 Write value 0xcceb0b8c
    li x3, 0xcceb0b8c
    csrw 0x129, x3

    #Address 0x129 read value
    csrr x14, 0x129

    #Unmapped address 0x439 testing: Read Reset + Random data Write/Read
    #Address 0x439 read value
    csrr x14, 0x439

    #Address 0x439 Write value 0x3165db05
    li x3, 0x3165db05
    csrw 0x439, x3

    #Address 0x439 read value
    csrr x14, 0x439

    #Unmapped address 0x732 testing: Read Reset + Random data Write/Read
    #Address 0x732 read value
    csrr x14, 0x732

    #Address 0x732 Write value 0x8b59de67
    li x3, 0x8b59de67
    csrw 0x732, x3

    #Address 0x732 read value
    csrr x14, 0x732

    #Unmapped address 0xbf0 testing: Read Reset + Random data Write/Read
    #Address 0xbf0 read value
    csrr x14, 0xbf0

    #Address 0xbf0 Write value 0xe06cda4d
    li x3, 0xe06cda4d
    csrw 0xbf0, x3

    #Address 0xbf0 read value
    csrr x14, 0xbf0

    #Unmapped address 0xc0b testing: Read Reset + Random data Write/Read
    #Address 0xc0b read value
    csrr x14, 0xc0b

    #Address 0xc0b Write value 0xaa3fdd28
    li x3, 0xaa3fdd28
    csrw 0xc0b, x3

    #Address 0xc0b read value
    csrr x14, 0xc0b

    #Unmapped address 0x20d testing: Read Reset + Random data Write/Read
    #Address 0x20d read value
    csrr x14, 0x20d

    #Address 0x20d Write value 0x644ab55c
    li x3, 0x644ab55c
    csrw 0x20d, x3

    #Address 0x20d read value
    csrr x14, 0x20d

    #Unmapped address 0x627 testing: Read Reset + Random data Write/Read
    #Address 0x627 read value
    csrr x14, 0x627

    #Address 0x627 Write value 0x9c6ab600
    li x3, 0x9c6ab600
    csrw 0x627, x3

    #Address 0x627 read value
    csrr x14, 0x627

    #Unmapped address 0xd5e testing: Read Reset + Random data Write/Read
    #Address 0xd5e read value
    csrr x14, 0xd5e

    #Address 0xd5e Write value 0x830c9f4a
    li x3, 0x830c9f4a
    csrw 0xd5e, x3

    #Address 0xd5e read value
    csrr x14, 0xd5e

    #Unmapped address 0x91b testing: Read Reset + Random data Write/Read
    #Address 0x91b read value
    csrr x14, 0x91b

    #Address 0x91b Write value 0x986d0a7b
    li x3, 0x986d0a7b
    csrw 0x91b, x3

    #Address 0x91b read value
    csrr x14, 0x91b

    #Unmapped address 0x860 testing: Read Reset + Random data Write/Read
    #Address 0x860 read value
    csrr x14, 0x860

    #Address 0x860 Write value 0x1930f82f
    li x3, 0x1930f82f
    csrw 0x860, x3

    #Address 0x860 read value
    csrr x14, 0x860

    #Unmapped address 0x232 testing: Read Reset + Random data Write/Read
    #Address 0x232 read value
    csrr x14, 0x232

    #Address 0x232 Write value 0xe31c3ac0
    li x3, 0xe31c3ac0
    csrw 0x232, x3

    #Address 0x232 read value
    csrr x14, 0x232

    #Unmapped address 0x972 testing: Read Reset + Random data Write/Read
    #Address 0x972 read value
    csrr x14, 0x972

    #Address 0x972 Write value 0x125bf885
    li x3, 0x125bf885
    csrw 0x972, x3

    #Address 0x972 read value
    csrr x14, 0x972

    #Unmapped address 0xecb testing: Read Reset + Random data Write/Read
    #Address 0xecb read value
    csrr x14, 0xecb

    #Address 0xecb Write value 0xe6c855b
    li x3, 0xe6c855b
    csrw 0xecb, x3

    #Address 0xecb read value
    csrr x14, 0xecb

    #Unmapped address 0x7cc testing: Read Reset + Random data Write/Read
    #Address 0x7cc read value
    csrr x14, 0x7cc

    #Address 0x7cc Write value 0xe66323c7
    li x3, 0xe66323c7
    csrw 0x7cc, x3

    #Address 0x7cc read value
    csrr x14, 0x7cc

    #Unmapped address 0xd01 testing: Read Reset + Random data Write/Read
    #Address 0xd01 read value
    csrr x14, 0xd01

    #Address 0xd01 Write value 0x41a3bcdb
    li x3, 0x41a3bcdb
    csrw 0xd01, x3

    #Address 0xd01 read value
    csrr x14, 0xd01

    #Unmapped address 0xc18 testing: Read Reset + Random data Write/Read
    #Address 0xc18 read value
    csrr x14, 0xc18

    #Address 0xc18 Write value 0xea73a142
    li x3, 0xea73a142
    csrw 0xc18, x3

    #Address 0xc18 read value
    csrr x14, 0xc18

    #Unmapped address 0x918 testing: Read Reset + Random data Write/Read
    #Address 0x918 read value
    csrr x14, 0x918

    #Address 0x918 Write value 0xf0801b0d
    li x3, 0xf0801b0d
    csrw 0x918, x3

    #Address 0x918 read value
    csrr x14, 0x918

    #Unmapped address 0x5bc testing: Read Reset + Random data Write/Read
    #Address 0x5bc read value
    csrr x14, 0x5bc

    #Address 0x5bc Write value 0x3d98fabc
    li x3, 0x3d98fabc
    csrw 0x5bc, x3

    #Address 0x5bc read value
    csrr x14, 0x5bc

    #Unmapped address 0x57 testing: Read Reset + Random data Write/Read
    #Address 0x57 read value
    csrr x14, 0x57

    #Address 0x57 Write value 0xfaeef92d
    li x3, 0xfaeef92d
    csrw 0x57, x3

    #Address 0x57 read value
    csrr x14, 0x57

    #Unmapped address 0x9ae testing: Read Reset + Random data Write/Read
    #Address 0x9ae read value
    csrr x14, 0x9ae

    #Address 0x9ae Write value 0x37a09e45
    li x3, 0x37a09e45
    csrw 0x9ae, x3

    #Address 0x9ae read value
    csrr x14, 0x9ae

    #Unmapped address 0x460 testing: Read Reset + Random data Write/Read
    #Address 0x460 read value
    csrr x14, 0x460

    #Address 0x460 Write value 0xf4bd464f
    li x3, 0xf4bd464f
    csrw 0x460, x3

    #Address 0x460 read value
    csrr x14, 0x460

    #Unmapped address 0xda2 testing: Read Reset + Random data Write/Read
    #Address 0xda2 read value
    csrr x14, 0xda2

    #Address 0xda2 Write value 0xdbc46dd9
    li x3, 0xdbc46dd9
    csrw 0xda2, x3

    #Address 0xda2 read value
    csrr x14, 0xda2

    #Unmapped address 0x361 testing: Read Reset + Random data Write/Read
    #Address 0x361 read value
    csrr x14, 0x361

    #Address 0x361 Write value 0xd875cfbc
    li x3, 0xd875cfbc
    csrw 0x361, x3

    #Address 0x361 read value
    csrr x14, 0x361

    #Unmapped address 0x81c testing: Read Reset + Random data Write/Read
    #Address 0x81c read value
    csrr x14, 0x81c

    #Address 0x81c Write value 0x5976146d
    li x3, 0x5976146d
    csrw 0x81c, x3

    #Address 0x81c read value
    csrr x14, 0x81c

    #Unmapped address 0x2bf testing: Read Reset + Random data Write/Read
    #Address 0x2bf read value
    csrr x14, 0x2bf

    #Address 0x2bf Write value 0x5329c200
    li x3, 0x5329c200
    csrw 0x2bf, x3

    #Address 0x2bf read value
    csrr x14, 0x2bf

    #Unmapped address 0xb5f testing: Read Reset + Random data Write/Read
    #Address 0xb5f read value
    csrr x14, 0xb5f

    #Address 0xb5f Write value 0x68b65087
    li x3, 0x68b65087
    csrw 0xb5f, x3

    #Address 0xb5f read value
    csrr x14, 0xb5f

    #Unmapped address 0xd1e testing: Read Reset + Random data Write/Read
    #Address 0xd1e read value
    csrr x14, 0xd1e

    #Address 0xd1e Write value 0xe505e75a
    li x3, 0xe505e75a
    csrw 0xd1e, x3

    #Address 0xd1e read value
    csrr x14, 0xd1e

    #Unmapped address 0xa35 testing: Read Reset + Random data Write/Read
    #Address 0xa35 read value
    csrr x14, 0xa35

    #Address 0xa35 Write value 0x89cf231
    li x3, 0x89cf231
    csrw 0xa35, x3

    #Address 0xa35 read value
    csrr x14, 0xa35

    #Unmapped address 0x752 testing: Read Reset + Random data Write/Read
    #Address 0x752 read value
    csrr x14, 0x752

    #Address 0x752 Write value 0x2beade61
    li x3, 0x2beade61
    csrw 0x752, x3

    #Address 0x752 read value
    csrr x14, 0x752

    #Unmapped address 0x27a testing: Read Reset + Random data Write/Read
    #Address 0x27a read value
    csrr x14, 0x27a

    #Address 0x27a Write value 0xde15d96
    li x3, 0xde15d96
    csrw 0x27a, x3

    #Address 0x27a read value
    csrr x14, 0x27a

    #Unmapped address 0x2d9 testing: Read Reset + Random data Write/Read
    #Address 0x2d9 read value
    csrr x14, 0x2d9

    #Address 0x2d9 Write value 0x3b7c7b61
    li x3, 0x3b7c7b61
    csrw 0x2d9, x3

    #Address 0x2d9 read value
    csrr x14, 0x2d9

    #Unmapped address 0x749 testing: Read Reset + Random data Write/Read
    #Address 0x749 read value
    csrr x14, 0x749

    #Address 0x749 Write value 0x3d0c3527
    li x3, 0x3d0c3527
    csrw 0x749, x3

    #Address 0x749 read value
    csrr x14, 0x749

    #Unmapped address 0xcd0 testing: Read Reset + Random data Write/Read
    #Address 0xcd0 read value
    csrr x14, 0xcd0

    #Address 0xcd0 Write value 0x7ea25090
    li x3, 0x7ea25090
    csrw 0xcd0, x3

    #Address 0xcd0 read value
    csrr x14, 0xcd0

    #Unmapped address 0x492 testing: Read Reset + Random data Write/Read
    #Address 0x492 read value
    csrr x14, 0x492

    #Address 0x492 Write value 0x16dfaae8
    li x3, 0x16dfaae8
    csrw 0x492, x3

    #Address 0x492 read value
    csrr x14, 0x492

    #Unmapped address 0xfa8 testing: Read Reset + Random data Write/Read
    #Address 0xfa8 read value
    csrr x14, 0xfa8

    #Address 0xfa8 Write value 0xf6953a6b
    li x3, 0xf6953a6b
    csrw 0xfa8, x3

    #Address 0xfa8 read value
    csrr x14, 0xfa8

    #Unmapped address 0x793 testing: Read Reset + Random data Write/Read
    #Address 0x793 read value
    csrr x14, 0x793

    #Address 0x793 Write value 0xc0a150c
    li x3, 0xc0a150c
    csrw 0x793, x3

    #Address 0x793 read value
    csrr x14, 0x793

    #Unmapped address 0x651 testing: Read Reset + Random data Write/Read
    #Address 0x651 read value
    csrr x14, 0x651

    #Address 0x651 Write value 0xad553d6e
    li x3, 0xad553d6e
    csrw 0x651, x3

    #Address 0x651 read value
    csrr x14, 0x651

    #Unmapped address 0x30d testing: Read Reset + Random data Write/Read
    #Address 0x30d read value
    csrr x14, 0x30d

    #Address 0x30d Write value 0xb8a1c912
    li x3, 0xb8a1c912
    csrw 0x30d, x3

    #Address 0x30d read value
    csrr x14, 0x30d

    #Unmapped address 0x364 testing: Read Reset + Random data Write/Read
    #Address 0x364 read value
    csrr x14, 0x364

    #Address 0x364 Write value 0x872d2f17
    li x3, 0x872d2f17
    csrw 0x364, x3

    #Address 0x364 read value
    csrr x14, 0x364

    #Unmapped address 0xf85 testing: Read Reset + Random data Write/Read
    #Address 0xf85 read value
    csrr x14, 0xf85

    #Address 0xf85 Write value 0xf318c59f
    li x3, 0xf318c59f
    csrw 0xf85, x3

    #Address 0xf85 read value
    csrr x14, 0xf85

    #Unmapped address 0xeb3 testing: Read Reset + Random data Write/Read
    #Address 0xeb3 read value
    csrr x14, 0xeb3

    #Address 0xeb3 Write value 0x3dcb93ee
    li x3, 0x3dcb93ee
    csrw 0xeb3, x3

    #Address 0xeb3 read value
    csrr x14, 0xeb3

    #Unmapped address 0xd40 testing: Read Reset + Random data Write/Read
    #Address 0xd40 read value
    csrr x14, 0xd40

    #Address 0xd40 Write value 0x78e2647f
    li x3, 0x78e2647f
    csrw 0xd40, x3

    #Address 0xd40 read value
    csrr x14, 0xd40

    #Unmapped address 0xa77 testing: Read Reset + Random data Write/Read
    #Address 0xa77 read value
    csrr x14, 0xa77

    #Address 0xa77 Write value 0xeb0ca1eb
    li x3, 0xeb0ca1eb
    csrw 0xa77, x3

    #Address 0xa77 read value
    csrr x14, 0xa77

    #Unmapped address 0xe4f testing: Read Reset + Random data Write/Read
    #Address 0xe4f read value
    csrr x14, 0xe4f

    #Address 0xe4f Write value 0xd5c1d4fe
    li x3, 0xd5c1d4fe
    csrw 0xe4f, x3

    #Address 0xe4f read value
    csrr x14, 0xe4f

    #Unmapped address 0x41b testing: Read Reset + Random data Write/Read
    #Address 0x41b read value
    csrr x14, 0x41b

    #Address 0x41b Write value 0xc78bd826
    li x3, 0xc78bd826
    csrw 0x41b, x3

    #Address 0x41b read value
    csrr x14, 0x41b

    #Unmapped address 0x3c2 testing: Read Reset + Random data Write/Read
    #Address 0x3c2 read value
    csrr x14, 0x3c2

    #Address 0x3c2 Write value 0x1e42de5d
    li x3, 0x1e42de5d
    csrw 0x3c2, x3

    #Address 0x3c2 read value
    csrr x14, 0x3c2

    #Unmapped address 0x1ff testing: Read Reset + Random data Write/Read
    #Address 0x1ff read value
    csrr x14, 0x1ff

    #Address 0x1ff Write value 0xb96025fa
    li x3, 0xb96025fa
    csrw 0x1ff, x3

    #Address 0x1ff read value
    csrr x14, 0x1ff

    #Unmapped address 0xdca testing: Read Reset + Random data Write/Read
    #Address 0xdca read value
    csrr x14, 0xdca

    #Address 0xdca Write value 0xad5d0b28
    li x3, 0xad5d0b28
    csrw 0xdca, x3

    #Address 0xdca read value
    csrr x14, 0xdca

    #Unmapped address 0xc81 testing: Read Reset + Random data Write/Read
    #Address 0xc81 read value
    csrr x14, 0xc81

    #Address 0xc81 Write value 0x1fe3af33
    li x3, 0x1fe3af33
    csrw 0xc81, x3

    #Address 0xc81 read value
    csrr x14, 0xc81

    #Unmapped address 0x85 testing: Read Reset + Random data Write/Read
    #Address 0x85 read value
    csrr x14, 0x85

    #Address 0x85 Write value 0xa3b9a985
    li x3, 0xa3b9a985
    csrw 0x85, x3

    #Address 0x85 read value
    csrr x14, 0x85

    #Unmapped address 0x207 testing: Read Reset + Random data Write/Read
    #Address 0x207 read value
    csrr x14, 0x207

    #Address 0x207 Write value 0x27b0f588
    li x3, 0x27b0f588
    csrw 0x207, x3

    #Address 0x207 read value
    csrr x14, 0x207

    #Unmapped address 0xa04 testing: Read Reset + Random data Write/Read
    #Address 0xa04 read value
    csrr x14, 0xa04

    #Address 0xa04 Write value 0x7ade2682
    li x3, 0x7ade2682
    csrw 0xa04, x3

    #Address 0xa04 read value
    csrr x14, 0xa04

    #Unmapped address 0xe0c testing: Read Reset + Random data Write/Read
    #Address 0xe0c read value
    csrr x14, 0xe0c

    #Address 0xe0c Write value 0xd9d1c085
    li x3, 0xd9d1c085
    csrw 0xe0c, x3

    #Address 0xe0c read value
    csrr x14, 0xe0c

    #Unmapped address 0x405 testing: Read Reset + Random data Write/Read
    #Address 0x405 read value
    csrr x14, 0x405

    #Address 0x405 Write value 0x7dd92925
    li x3, 0x7dd92925
    csrw 0x405, x3

    #Address 0x405 read value
    csrr x14, 0x405

    #Unmapped address 0x274 testing: Read Reset + Random data Write/Read
    #Address 0x274 read value
    csrr x14, 0x274

    #Address 0x274 Write value 0xdca49508
    li x3, 0xdca49508
    csrw 0x274, x3

    #Address 0x274 read value
    csrr x14, 0x274

    #Unmapped address 0xc83 testing: Read Reset + Random data Write/Read
    #Address 0xc83 read value
    csrr x14, 0xc83

    #Address 0xc83 Write value 0xa6851405
    li x3, 0xa6851405
    csrw 0xc83, x3

    #Address 0xc83 read value
    csrr x14, 0xc83

    #Unmapped address 0xad7 testing: Read Reset + Random data Write/Read
    #Address 0xad7 read value
    csrr x14, 0xad7

    #Address 0xad7 Write value 0x2654357c
    li x3, 0x2654357c
    csrw 0xad7, x3

    #Address 0xad7 read value
    csrr x14, 0xad7

    #Unmapped address 0xbdb testing: Read Reset + Random data Write/Read
    #Address 0xbdb read value
    csrr x14, 0xbdb

    #Address 0xbdb Write value 0x6ecad83a
    li x3, 0x6ecad83a
    csrw 0xbdb, x3

    #Address 0xbdb read value
    csrr x14, 0xbdb

    #Unmapped address 0x3ac testing: Read Reset + Random data Write/Read
    #Address 0x3ac read value
    csrr x14, 0x3ac

    #Address 0x3ac Write value 0x7d45ca7e
    li x3, 0x7d45ca7e
    csrw 0x3ac, x3

    #Address 0x3ac read value
    csrr x14, 0x3ac

    #Unmapped address 0x376 testing: Read Reset + Random data Write/Read
    #Address 0x376 read value
    csrr x14, 0x376

    #Address 0x376 Write value 0xd009e4f0
    li x3, 0xd009e4f0
    csrw 0x376, x3

    #Address 0x376 read value
    csrr x14, 0x376

    #Unmapped address 0xad8 testing: Read Reset + Random data Write/Read
    #Address 0xad8 read value
    csrr x14, 0xad8

    #Address 0xad8 Write value 0x3fff8fd9
    li x3, 0x3fff8fd9
    csrw 0xad8, x3

    #Address 0xad8 read value
    csrr x14, 0xad8

    #Unmapped address 0xe3f testing: Read Reset + Random data Write/Read
    #Address 0xe3f read value
    csrr x14, 0xe3f

    #Address 0xe3f Write value 0x4193c938
    li x3, 0x4193c938
    csrw 0xe3f, x3

    #Address 0xe3f read value
    csrr x14, 0xe3f

    #Unmapped address 0xc41 testing: Read Reset + Random data Write/Read
    #Address 0xc41 read value
    csrr x14, 0xc41

    #Address 0xc41 Write value 0xdfe03100
    li x3, 0xdfe03100
    csrw 0xc41, x3

    #Address 0xc41 read value
    csrr x14, 0xc41

    #Unmapped address 0x4cb testing: Read Reset + Random data Write/Read
    #Address 0x4cb read value
    csrr x14, 0x4cb

    #Address 0x4cb Write value 0x61d0a455
    li x3, 0x61d0a455
    csrw 0x4cb, x3

    #Address 0x4cb read value
    csrr x14, 0x4cb

    #Unmapped address 0xe6b testing: Read Reset + Random data Write/Read
    #Address 0xe6b read value
    csrr x14, 0xe6b

    #Address 0xe6b Write value 0x6f907055
    li x3, 0x6f907055
    csrw 0xe6b, x3

    #Address 0xe6b read value
    csrr x14, 0xe6b

    #Unmapped address 0xac4 testing: Read Reset + Random data Write/Read
    #Address 0xac4 read value
    csrr x14, 0xac4

    #Address 0xac4 Write value 0xd2d78f3b
    li x3, 0xd2d78f3b
    csrw 0xac4, x3

    #Address 0xac4 read value
    csrr x14, 0xac4

    #Unmapped address 0xb5b testing: Read Reset + Random data Write/Read
    #Address 0xb5b read value
    csrr x14, 0xb5b

    #Address 0xb5b Write value 0xec870418
    li x3, 0xec870418
    csrw 0xb5b, x3

    #Address 0xb5b read value
    csrr x14, 0xb5b

    #Unmapped address 0xdfd testing: Read Reset + Random data Write/Read
    #Address 0xdfd read value
    csrr x14, 0xdfd

    #Address 0xdfd Write value 0x16fadc78
    li x3, 0x16fadc78
    csrw 0xdfd, x3

    #Address 0xdfd read value
    csrr x14, 0xdfd

    #Unmapped address 0x27f testing: Read Reset + Random data Write/Read
    #Address 0x27f read value
    csrr x14, 0x27f

    #Address 0x27f Write value 0x2337b38c
    li x3, 0x2337b38c
    csrw 0x27f, x3

    #Address 0x27f read value
    csrr x14, 0x27f

    #Unmapped address 0xb7b testing: Read Reset + Random data Write/Read
    #Address 0xb7b read value
    csrr x14, 0xb7b

    #Address 0xb7b Write value 0x8c2ebf1
    li x3, 0x8c2ebf1
    csrw 0xb7b, x3

    #Address 0xb7b read value
    csrr x14, 0xb7b

    #Unmapped address 0x97e testing: Read Reset + Random data Write/Read
    #Address 0x97e read value
    csrr x14, 0x97e

    #Address 0x97e Write value 0xcbf23ccd
    li x3, 0xcbf23ccd
    csrw 0x97e, x3

    #Address 0x97e read value
    csrr x14, 0x97e

    #Unmapped address 0xd6e testing: Read Reset + Random data Write/Read
    #Address 0xd6e read value
    csrr x14, 0xd6e

    #Address 0xd6e Write value 0xbabf934e
    li x3, 0xbabf934e
    csrw 0xd6e, x3

    #Address 0xd6e read value
    csrr x14, 0xd6e

    #Unmapped address 0xc6b testing: Read Reset + Random data Write/Read
    #Address 0xc6b read value
    csrr x14, 0xc6b

    #Address 0xc6b Write value 0xb141642
    li x3, 0xb141642
    csrw 0xc6b, x3

    #Address 0xc6b read value
    csrr x14, 0xc6b

    #Unmapped address 0x2ee testing: Read Reset + Random data Write/Read
    #Address 0x2ee read value
    csrr x14, 0x2ee

    #Address 0x2ee Write value 0x4862126d
    li x3, 0x4862126d
    csrw 0x2ee, x3

    #Address 0x2ee read value
    csrr x14, 0x2ee

    #Unmapped address 0x93 testing: Read Reset + Random data Write/Read
    #Address 0x93 read value
    csrr x14, 0x93

    #Address 0x93 Write value 0xdc6b6fc8
    li x3, 0xdc6b6fc8
    csrw 0x93, x3

    #Address 0x93 read value
    csrr x14, 0x93

    #Unmapped address 0x621 testing: Read Reset + Random data Write/Read
    #Address 0x621 read value
    csrr x14, 0x621

    #Address 0x621 Write value 0xb327e1b9
    li x3, 0xb327e1b9
    csrw 0x621, x3

    #Address 0x621 read value
    csrr x14, 0x621

    #Unmapped address 0xa1a testing: Read Reset + Random data Write/Read
    #Address 0xa1a read value
    csrr x14, 0xa1a

    #Address 0xa1a Write value 0x34e6604a
    li x3, 0x34e6604a
    csrw 0xa1a, x3

    #Address 0xa1a read value
    csrr x14, 0xa1a

    #Unmapped address 0xb6c testing: Read Reset + Random data Write/Read
    #Address 0xb6c read value
    csrr x14, 0xb6c

    #Address 0xb6c Write value 0x88ee028b
    li x3, 0x88ee028b
    csrw 0xb6c, x3

    #Address 0xb6c read value
    csrr x14, 0xb6c

    #Unmapped address 0x309 testing: Read Reset + Random data Write/Read
    #Address 0x309 read value
    csrr x14, 0x309

    #Address 0x309 Write value 0x4a0b8e3a
    li x3, 0x4a0b8e3a
    csrw 0x309, x3

    #Address 0x309 read value
    csrr x14, 0x309

    #Unmapped address 0xe7 testing: Read Reset + Random data Write/Read
    #Address 0xe7 read value
    csrr x14, 0xe7

    #Address 0xe7 Write value 0x3cfcde16
    li x3, 0x3cfcde16
    csrw 0xe7, x3

    #Address 0xe7 read value
    csrr x14, 0xe7

    #Unmapped address 0x8ac testing: Read Reset + Random data Write/Read
    #Address 0x8ac read value
    csrr x14, 0x8ac

    #Address 0x8ac Write value 0xbc74670c
    li x3, 0xbc74670c
    csrw 0x8ac, x3

    #Address 0x8ac read value
    csrr x14, 0x8ac

    #Unmapped address 0xa69 testing: Read Reset + Random data Write/Read
    #Address 0xa69 read value
    csrr x14, 0xa69

    #Address 0xa69 Write value 0x8c1697c6
    li x3, 0x8c1697c6
    csrw 0xa69, x3

    #Address 0xa69 read value
    csrr x14, 0xa69

    #Unmapped address 0x5a5 testing: Read Reset + Random data Write/Read
    #Address 0x5a5 read value
    csrr x14, 0x5a5

    #Address 0x5a5 Write value 0x12709eaa
    li x3, 0x12709eaa
    csrw 0x5a5, x3

    #Address 0x5a5 read value
    csrr x14, 0x5a5

    #Unmapped address 0x5a testing: Read Reset + Random data Write/Read
    #Address 0x5a read value
    csrr x14, 0x5a

    #Address 0x5a Write value 0x1863a54d
    li x3, 0x1863a54d
    csrw 0x5a, x3

    #Address 0x5a read value
    csrr x14, 0x5a

    #Unmapped address 0xe4 testing: Read Reset + Random data Write/Read
    #Address 0xe4 read value
    csrr x14, 0xe4

    #Address 0xe4 Write value 0xaa31e8b2
    li x3, 0xaa31e8b2
    csrw 0xe4, x3

    #Address 0xe4 read value
    csrr x14, 0xe4

    #Unmapped address 0xb51 testing: Read Reset + Random data Write/Read
    #Address 0xb51 read value
    csrr x14, 0xb51

    #Address 0xb51 Write value 0xc4e14b6d
    li x3, 0xc4e14b6d
    csrw 0xb51, x3

    #Address 0xb51 read value
    csrr x14, 0xb51

    #Unmapped address 0x908 testing: Read Reset + Random data Write/Read
    #Address 0x908 read value
    csrr x14, 0x908

    #Address 0x908 Write value 0x6597c9b5
    li x3, 0x6597c9b5
    csrw 0x908, x3

    #Address 0x908 read value
    csrr x14, 0x908

    #Unmapped address 0x2b2 testing: Read Reset + Random data Write/Read
    #Address 0x2b2 read value
    csrr x14, 0x2b2

    #Address 0x2b2 Write value 0x1327a528
    li x3, 0x1327a528
    csrw 0x2b2, x3

    #Address 0x2b2 read value
    csrr x14, 0x2b2

    #Unmapped address 0x57c testing: Read Reset + Random data Write/Read
    #Address 0x57c read value
    csrr x14, 0x57c

    #Address 0x57c Write value 0x6f0fc518
    li x3, 0x6f0fc518
    csrw 0x57c, x3

    #Address 0x57c read value
    csrr x14, 0x57c

    #Unmapped address 0x42 testing: Read Reset + Random data Write/Read
    #Address 0x42 read value
    csrr x14, 0x42

    #Address 0x42 Write value 0x98363b2b
    li x3, 0x98363b2b
    csrw 0x42, x3

    #Address 0x42 read value
    csrr x14, 0x42

    #Unmapped address 0x87 testing: Read Reset + Random data Write/Read
    #Address 0x87 read value
    csrr x14, 0x87

    #Address 0x87 Write value 0xa57e3e5f
    li x3, 0xa57e3e5f
    csrw 0x87, x3

    #Address 0x87 read value
    csrr x14, 0x87

    #Unmapped address 0xba5 testing: Read Reset + Random data Write/Read
    #Address 0xba5 read value
    csrr x14, 0xba5

    #Address 0xba5 Write value 0x857da3d7
    li x3, 0x857da3d7
    csrw 0xba5, x3

    #Address 0xba5 read value
    csrr x14, 0xba5

    #Unmapped address 0x190 testing: Read Reset + Random data Write/Read
    #Address 0x190 read value
    csrr x14, 0x190

    #Address 0x190 Write value 0xf153322e
    li x3, 0xf153322e
    csrw 0x190, x3

    #Address 0x190 read value
    csrr x14, 0x190

    #Unmapped address 0xf7c testing: Read Reset + Random data Write/Read
    #Address 0xf7c read value
    csrr x14, 0xf7c

    #Address 0xf7c Write value 0xb0ac84f3
    li x3, 0xb0ac84f3
    csrw 0xf7c, x3

    #Address 0xf7c read value
    csrr x14, 0xf7c

    #Unmapped address 0xad1 testing: Read Reset + Random data Write/Read
    #Address 0xad1 read value
    csrr x14, 0xad1

    #Address 0xad1 Write value 0x9c5ad71f
    li x3, 0x9c5ad71f
    csrw 0xad1, x3

    #Address 0xad1 read value
    csrr x14, 0xad1

    #Unmapped address 0xa2a testing: Read Reset + Random data Write/Read
    #Address 0xa2a read value
    csrr x14, 0xa2a

    #Address 0xa2a Write value 0x63eee41f
    li x3, 0x63eee41f
    csrw 0xa2a, x3

    #Address 0xa2a read value
    csrr x14, 0xa2a

    #Unmapped address 0xd68 testing: Read Reset + Random data Write/Read
    #Address 0xd68 read value
    csrr x14, 0xd68

    #Address 0xd68 Write value 0xdcce122a
    li x3, 0xdcce122a
    csrw 0xd68, x3

    #Address 0xd68 read value
    csrr x14, 0xd68

    #Unmapped address 0xc0f testing: Read Reset + Random data Write/Read
    #Address 0xc0f read value
    csrr x14, 0xc0f

    #Address 0xc0f Write value 0xbb5c8235
    li x3, 0xbb5c8235
    csrw 0xc0f, x3

    #Address 0xc0f read value
    csrr x14, 0xc0f

    #Unmapped address 0x444 testing: Read Reset + Random data Write/Read
    #Address 0x444 read value
    csrr x14, 0x444

    #Address 0x444 Write value 0x4c3dc3e5
    li x3, 0x4c3dc3e5
    csrw 0x444, x3

    #Address 0x444 read value
    csrr x14, 0x444

    #Unmapped address 0xd13 testing: Read Reset + Random data Write/Read
    #Address 0xd13 read value
    csrr x14, 0xd13

    #Address 0xd13 Write value 0x3df0c02d
    li x3, 0x3df0c02d
    csrw 0xd13, x3

    #Address 0xd13 read value
    csrr x14, 0xd13

    #Unmapped address 0x307 testing: Read Reset + Random data Write/Read
    #Address 0x307 read value
    csrr x14, 0x307

    #Address 0x307 Write value 0x167fda3e
    li x3, 0x167fda3e
    csrw 0x307, x3

    #Address 0x307 read value
    csrr x14, 0x307

    #Unmapped address 0x7c7 testing: Read Reset + Random data Write/Read
    #Address 0x7c7 read value
    csrr x14, 0x7c7

    #Address 0x7c7 Write value 0x1c95e2e2
    li x3, 0x1c95e2e2
    csrw 0x7c7, x3

    #Address 0x7c7 read value
    csrr x14, 0x7c7

    #Unmapped address 0x4cf testing: Read Reset + Random data Write/Read
    #Address 0x4cf read value
    csrr x14, 0x4cf

    #Address 0x4cf Write value 0xc000ef77
    li x3, 0xc000ef77
    csrw 0x4cf, x3

    #Address 0x4cf read value
    csrr x14, 0x4cf

    #Unmapped address 0x9e7 testing: Read Reset + Random data Write/Read
    #Address 0x9e7 read value
    csrr x14, 0x9e7

    #Address 0x9e7 Write value 0x9907994a
    li x3, 0x9907994a
    csrw 0x9e7, x3

    #Address 0x9e7 read value
    csrr x14, 0x9e7

    #Unmapped address 0x9e6 testing: Read Reset + Random data Write/Read
    #Address 0x9e6 read value
    csrr x14, 0x9e6

    #Address 0x9e6 Write value 0xc9612d0d
    li x3, 0xc9612d0d
    csrw 0x9e6, x3

    #Address 0x9e6 read value
    csrr x14, 0x9e6

    #Unmapped address 0x79a testing: Read Reset + Random data Write/Read
    #Address 0x79a read value
    csrr x14, 0x79a

    #Address 0x79a Write value 0x637ea306
    li x3, 0x637ea306
    csrw 0x79a, x3

    #Address 0x79a read value
    csrr x14, 0x79a

    #Unmapped address 0x7a0 testing: Read Reset + Random data Write/Read
    #Address 0x7a0 read value
    csrr x14, 0x7a0

    #Address 0x7a0 Write value 0xf946ed90
    li x3, 0xf946ed90
    csrw 0x7a0, x3

    #Address 0x7a0 read value
    csrr x14, 0x7a0

    #Unmapped address 0xf05 testing: Read Reset + Random data Write/Read
    #Address 0xf05 read value
    csrr x14, 0xf05

    #Address 0xf05 Write value 0x83980a0
    li x3, 0x83980a0
    csrw 0xf05, x3

    #Address 0xf05 read value
    csrr x14, 0xf05

    #Unmapped address 0x655 testing: Read Reset + Random data Write/Read
    #Address 0x655 read value
    csrr x14, 0x655

    #Address 0x655 Write value 0xb019d908
    li x3, 0xb019d908
    csrw 0x655, x3

    #Address 0x655 read value
    csrr x14, 0x655

    #Unmapped address 0x251 testing: Read Reset + Random data Write/Read
    #Address 0x251 read value
    csrr x14, 0x251

    #Address 0x251 Write value 0x6fc3d913
    li x3, 0x6fc3d913
    csrw 0x251, x3

    #Address 0x251 read value
    csrr x14, 0x251

    #Unmapped address 0x6e5 testing: Read Reset + Random data Write/Read
    #Address 0x6e5 read value
    csrr x14, 0x6e5

    #Address 0x6e5 Write value 0xa939b646
    li x3, 0xa939b646
    csrw 0x6e5, x3

    #Address 0x6e5 read value
    csrr x14, 0x6e5

    #Unmapped address 0xeba testing: Read Reset + Random data Write/Read
    #Address 0xeba read value
    csrr x14, 0xeba

    #Address 0xeba Write value 0xd7eb097a
    li x3, 0xd7eb097a
    csrw 0xeba, x3

    #Address 0xeba read value
    csrr x14, 0xeba

    #Unmapped address 0x45f testing: Read Reset + Random data Write/Read
    #Address 0x45f read value
    csrr x14, 0x45f

    #Address 0x45f Write value 0x2527d98f
    li x3, 0x2527d98f
    csrw 0x45f, x3

    #Address 0x45f read value
    csrr x14, 0x45f

    #Unmapped address 0xef5 testing: Read Reset + Random data Write/Read
    #Address 0xef5 read value
    csrr x14, 0xef5

    #Address 0xef5 Write value 0xa8294c00
    li x3, 0xa8294c00
    csrw 0xef5, x3

    #Address 0xef5 read value
    csrr x14, 0xef5

    #Unmapped address 0xf81 testing: Read Reset + Random data Write/Read
    #Address 0xf81 read value
    csrr x14, 0xf81

    #Address 0xf81 Write value 0x13e4f9e6
    li x3, 0x13e4f9e6
    csrw 0xf81, x3

    #Address 0xf81 read value
    csrr x14, 0xf81

    #Unmapped address 0x9d3 testing: Read Reset + Random data Write/Read
    #Address 0x9d3 read value
    csrr x14, 0x9d3

    #Address 0x9d3 Write value 0xfdb69ca5
    li x3, 0xfdb69ca5
    csrw 0x9d3, x3

    #Address 0x9d3 read value
    csrr x14, 0x9d3

    #Unmapped address 0xb2c testing: Read Reset + Random data Write/Read
    #Address 0xb2c read value
    csrr x14, 0xb2c

    #Address 0xb2c Write value 0x3a5d8f4a
    li x3, 0x3a5d8f4a
    csrw 0xb2c, x3

    #Address 0xb2c read value
    csrr x14, 0xb2c

    #Unmapped address 0xaeb testing: Read Reset + Random data Write/Read
    #Address 0xaeb read value
    csrr x14, 0xaeb

    #Address 0xaeb Write value 0x37162dd0
    li x3, 0x37162dd0
    csrw 0xaeb, x3

    #Address 0xaeb read value
    csrr x14, 0xaeb

    #Unmapped address 0x68d testing: Read Reset + Random data Write/Read
    #Address 0x68d read value
    csrr x14, 0x68d

    #Address 0x68d Write value 0xea391aa8
    li x3, 0xea391aa8
    csrw 0x68d, x3

    #Address 0x68d read value
    csrr x14, 0x68d

    #Unmapped address 0xf26 testing: Read Reset + Random data Write/Read
    #Address 0xf26 read value
    csrr x14, 0xf26

    #Address 0xf26 Write value 0x865310e0
    li x3, 0x865310e0
    csrw 0xf26, x3

    #Address 0xf26 read value
    csrr x14, 0xf26

    #Unmapped address 0x553 testing: Read Reset + Random data Write/Read
    #Address 0x553 read value
    csrr x14, 0x553

    #Address 0x553 Write value 0x651d2868
    li x3, 0x651d2868
    csrw 0x553, x3

    #Address 0x553 read value
    csrr x14, 0x553

    #Unmapped address 0xf2 testing: Read Reset + Random data Write/Read
    #Address 0xf2 read value
    csrr x14, 0xf2

    #Address 0xf2 Write value 0x8d9a0f45
    li x3, 0x8d9a0f45
    csrw 0xf2, x3

    #Address 0xf2 read value
    csrr x14, 0xf2

    #Unmapped address 0x395 testing: Read Reset + Random data Write/Read
    #Address 0x395 read value
    csrr x14, 0x395

    #Address 0x395 Write value 0xa6814df9
    li x3, 0xa6814df9
    csrw 0x395, x3

    #Address 0x395 read value
    csrr x14, 0x395

    #Unmapped address 0x574 testing: Read Reset + Random data Write/Read
    #Address 0x574 read value
    csrr x14, 0x574

    #Address 0x574 Write value 0xa5c792b0
    li x3, 0xa5c792b0
    csrw 0x574, x3

    #Address 0x574 read value
    csrr x14, 0x574

    #Unmapped address 0x869 testing: Read Reset + Random data Write/Read
    #Address 0x869 read value
    csrr x14, 0x869

    #Address 0x869 Write value 0xfc0740fd
    li x3, 0xfc0740fd
    csrw 0x869, x3

    #Address 0x869 read value
    csrr x14, 0x869

    #Unmapped address 0xd66 testing: Read Reset + Random data Write/Read
    #Address 0xd66 read value
    csrr x14, 0xd66

    #Address 0xd66 Write value 0x260d516b
    li x3, 0x260d516b
    csrw 0xd66, x3

    #Address 0xd66 read value
    csrr x14, 0xd66

    #Unmapped address 0xd9e testing: Read Reset + Random data Write/Read
    #Address 0xd9e read value
    csrr x14, 0xd9e

    #Address 0xd9e Write value 0x871e007b
    li x3, 0x871e007b
    csrw 0xd9e, x3

    #Address 0xd9e read value
    csrr x14, 0xd9e

    #Unmapped address 0x635 testing: Read Reset + Random data Write/Read
    #Address 0x635 read value
    csrr x14, 0x635

    #Address 0x635 Write value 0x7d70a91b
    li x3, 0x7d70a91b
    csrw 0x635, x3

    #Address 0x635 read value
    csrr x14, 0x635

    #Unmapped address 0xb7f testing: Read Reset + Random data Write/Read
    #Address 0xb7f read value
    csrr x14, 0xb7f

    #Address 0xb7f Write value 0x146a5e3c
    li x3, 0x146a5e3c
    csrw 0xb7f, x3

    #Address 0xb7f read value
    csrr x14, 0xb7f

    #Unmapped address 0xa90 testing: Read Reset + Random data Write/Read
    #Address 0xa90 read value
    csrr x14, 0xa90

    #Address 0xa90 Write value 0xcd8dcf13
    li x3, 0xcd8dcf13
    csrw 0xa90, x3

    #Address 0xa90 read value
    csrr x14, 0xa90

    #Unmapped address 0x828 testing: Read Reset + Random data Write/Read
    #Address 0x828 read value
    csrr x14, 0x828

    #Address 0x828 Write value 0x2c066b0e
    li x3, 0x2c066b0e
    csrw 0x828, x3

    #Address 0x828 read value
    csrr x14, 0x828

    #Unmapped address 0x4bc testing: Read Reset + Random data Write/Read
    #Address 0x4bc read value
    csrr x14, 0x4bc

    #Address 0x4bc Write value 0x3c9d5431
    li x3, 0x3c9d5431
    csrw 0x4bc, x3

    #Address 0x4bc read value
    csrr x14, 0x4bc

    #Unmapped address 0x31c testing: Read Reset + Random data Write/Read
    #Address 0x31c read value
    csrr x14, 0x31c

    #Address 0x31c Write value 0xdc07e0b3
    li x3, 0xdc07e0b3
    csrw 0x31c, x3

    #Address 0x31c read value
    csrr x14, 0x31c

    #Unmapped address 0x6c testing: Read Reset + Random data Write/Read
    #Address 0x6c read value
    csrr x14, 0x6c

    #Address 0x6c Write value 0xddac79a
    li x3, 0xddac79a
    csrw 0x6c, x3

    #Address 0x6c read value
    csrr x14, 0x6c

    #Unmapped address 0xc91 testing: Read Reset + Random data Write/Read
    #Address 0xc91 read value
    csrr x14, 0xc91

    #Address 0xc91 Write value 0x497d04ea
    li x3, 0x497d04ea
    csrw 0xc91, x3

    #Address 0xc91 read value
    csrr x14, 0xc91

    #Unmapped address 0xd5f testing: Read Reset + Random data Write/Read
    #Address 0xd5f read value
    csrr x14, 0xd5f

    #Address 0xd5f Write value 0x5a67f700
    li x3, 0x5a67f700
    csrw 0xd5f, x3

    #Address 0xd5f read value
    csrr x14, 0xd5f

    #Unmapped address 0x5eb testing: Read Reset + Random data Write/Read
    #Address 0x5eb read value
    csrr x14, 0x5eb

    #Address 0x5eb Write value 0xede4bc58
    li x3, 0xede4bc58
    csrw 0x5eb, x3

    #Address 0x5eb read value
    csrr x14, 0x5eb

    #Unmapped address 0x1c1 testing: Read Reset + Random data Write/Read
    #Address 0x1c1 read value
    csrr x14, 0x1c1

    #Address 0x1c1 Write value 0x3c7831e2
    li x3, 0x3c7831e2
    csrw 0x1c1, x3

    #Address 0x1c1 read value
    csrr x14, 0x1c1

    #Unmapped address 0x78d testing: Read Reset + Random data Write/Read
    #Address 0x78d read value
    csrr x14, 0x78d

    #Address 0x78d Write value 0xfad07046
    li x3, 0xfad07046
    csrw 0x78d, x3

    #Address 0x78d read value
    csrr x14, 0x78d

    #Unmapped address 0xd4a testing: Read Reset + Random data Write/Read
    #Address 0xd4a read value
    csrr x14, 0xd4a

    #Address 0xd4a Write value 0xca636b37
    li x3, 0xca636b37
    csrw 0xd4a, x3

    #Address 0xd4a read value
    csrr x14, 0xd4a

    #Unmapped address 0x612 testing: Read Reset + Random data Write/Read
    #Address 0x612 read value
    csrr x14, 0x612

    #Address 0x612 Write value 0x4fd85bf5
    li x3, 0x4fd85bf5
    csrw 0x612, x3

    #Address 0x612 read value
    csrr x14, 0x612

    #Unmapped address 0xd1f testing: Read Reset + Random data Write/Read
    #Address 0xd1f read value
    csrr x14, 0xd1f

    #Address 0xd1f Write value 0x773784c2
    li x3, 0x773784c2
    csrw 0xd1f, x3

    #Address 0xd1f read value
    csrr x14, 0xd1f

    #Unmapped address 0x64a testing: Read Reset + Random data Write/Read
    #Address 0x64a read value
    csrr x14, 0x64a

    #Address 0x64a Write value 0xa149793a
    li x3, 0xa149793a
    csrw 0x64a, x3

    #Address 0x64a read value
    csrr x14, 0x64a

    #Unmapped address 0xae7 testing: Read Reset + Random data Write/Read
    #Address 0xae7 read value
    csrr x14, 0xae7

    #Address 0xae7 Write value 0x7c89c225
    li x3, 0x7c89c225
    csrw 0xae7, x3

    #Address 0xae7 read value
    csrr x14, 0xae7

    #Unmapped address 0x82 testing: Read Reset + Random data Write/Read
    #Address 0x82 read value
    csrr x14, 0x82

    #Address 0x82 Write value 0x5ed072f3
    li x3, 0x5ed072f3
    csrw 0x82, x3

    #Address 0x82 read value
    csrr x14, 0x82

    #Unmapped address 0xf0a testing: Read Reset + Random data Write/Read
    #Address 0xf0a read value
    csrr x14, 0xf0a

    #Address 0xf0a Write value 0x6490239c
    li x3, 0x6490239c
    csrw 0xf0a, x3

    #Address 0xf0a read value
    csrr x14, 0xf0a

    #Unmapped address 0x962 testing: Read Reset + Random data Write/Read
    #Address 0x962 read value
    csrr x14, 0x962

    #Address 0x962 Write value 0x448d0098
    li x3, 0x448d0098
    csrw 0x962, x3

    #Address 0x962 read value
    csrr x14, 0x962

    #Unmapped address 0x10c testing: Read Reset + Random data Write/Read
    #Address 0x10c read value
    csrr x14, 0x10c

    #Address 0x10c Write value 0xa677ce35
    li x3, 0xa677ce35
    csrw 0x10c, x3

    #Address 0x10c read value
    csrr x14, 0x10c

    #Unmapped address 0x4c1 testing: Read Reset + Random data Write/Read
    #Address 0x4c1 read value
    csrr x14, 0x4c1

    #Address 0x4c1 Write value 0xc05990be
    li x3, 0xc05990be
    csrw 0x4c1, x3

    #Address 0x4c1 read value
    csrr x14, 0x4c1

    #Unmapped address 0x422 testing: Read Reset + Random data Write/Read
    #Address 0x422 read value
    csrr x14, 0x422

    #Address 0x422 Write value 0x7bc705ce
    li x3, 0x7bc705ce
    csrw 0x422, x3

    #Address 0x422 read value
    csrr x14, 0x422

    #Unmapped address 0x3d1 testing: Read Reset + Random data Write/Read
    #Address 0x3d1 read value
    csrr x14, 0x3d1

    #Address 0x3d1 Write value 0x361ed21f
    li x3, 0x361ed21f
    csrw 0x3d1, x3

    #Address 0x3d1 read value
    csrr x14, 0x3d1

    #Unmapped address 0x596 testing: Read Reset + Random data Write/Read
    #Address 0x596 read value
    csrr x14, 0x596

    #Address 0x596 Write value 0x1165e558
    li x3, 0x1165e558
    csrw 0x596, x3

    #Address 0x596 read value
    csrr x14, 0x596

    #Unmapped address 0xfbb testing: Read Reset + Random data Write/Read
    #Address 0xfbb read value
    csrr x14, 0xfbb

    #Address 0xfbb Write value 0x219ffdfc
    li x3, 0x219ffdfc
    csrw 0xfbb, x3

    #Address 0xfbb read value
    csrr x14, 0xfbb

    #Unmapped address 0xd2 testing: Read Reset + Random data Write/Read
    #Address 0xd2 read value
    csrr x14, 0xd2

    #Address 0xd2 Write value 0xd5347d5f
    li x3, 0xd5347d5f
    csrw 0xd2, x3

    #Address 0xd2 read value
    csrr x14, 0xd2

    #Unmapped address 0x673 testing: Read Reset + Random data Write/Read
    #Address 0x673 read value
    csrr x14, 0x673

    #Address 0x673 Write value 0x1d621320
    li x3, 0x1d621320
    csrw 0x673, x3

    #Address 0x673 read value
    csrr x14, 0x673

    #Unmapped address 0x22d testing: Read Reset + Random data Write/Read
    #Address 0x22d read value
    csrr x14, 0x22d

    #Address 0x22d Write value 0x8086241a
    li x3, 0x8086241a
    csrw 0x22d, x3

    #Address 0x22d read value
    csrr x14, 0x22d

    #Unmapped address 0x807 testing: Read Reset + Random data Write/Read
    #Address 0x807 read value
    csrr x14, 0x807

    #Address 0x807 Write value 0x632850a3
    li x3, 0x632850a3
    csrw 0x807, x3

    #Address 0x807 read value
    csrr x14, 0x807

    #Unmapped address 0x9bc testing: Read Reset + Random data Write/Read
    #Address 0x9bc read value
    csrr x14, 0x9bc

    #Address 0x9bc Write value 0xb42c7104
    li x3, 0xb42c7104
    csrw 0x9bc, x3

    #Address 0x9bc read value
    csrr x14, 0x9bc

    #Unmapped address 0x4ae testing: Read Reset + Random data Write/Read
    #Address 0x4ae read value
    csrr x14, 0x4ae

    #Address 0x4ae Write value 0x8b73db5
    li x3, 0x8b73db5
    csrw 0x4ae, x3

    #Address 0x4ae read value
    csrr x14, 0x4ae

    #Unmapped address 0x3af testing: Read Reset + Random data Write/Read
    #Address 0x3af read value
    csrr x14, 0x3af

    #Address 0x3af Write value 0x152aa283
    li x3, 0x152aa283
    csrw 0x3af, x3

    #Address 0x3af read value
    csrr x14, 0x3af

    #Unmapped address 0xf27 testing: Read Reset + Random data Write/Read
    #Address 0xf27 read value
    csrr x14, 0xf27

    #Address 0xf27 Write value 0x3378dfd3
    li x3, 0x3378dfd3
    csrw 0xf27, x3

    #Address 0xf27 read value
    csrr x14, 0xf27

    #Unmapped address 0x486 testing: Read Reset + Random data Write/Read
    #Address 0x486 read value
    csrr x14, 0x486

    #Address 0x486 Write value 0x359bdc80
    li x3, 0x359bdc80
    csrw 0x486, x3

    #Address 0x486 read value
    csrr x14, 0x486

    #Unmapped address 0x451 testing: Read Reset + Random data Write/Read
    #Address 0x451 read value
    csrr x14, 0x451

    #Address 0x451 Write value 0x364e0d00
    li x3, 0x364e0d00
    csrw 0x451, x3

    #Address 0x451 read value
    csrr x14, 0x451

    #Unmapped address 0x6be testing: Read Reset + Random data Write/Read
    #Address 0x6be read value
    csrr x14, 0x6be

    #Address 0x6be Write value 0xd39c2c6a
    li x3, 0xd39c2c6a
    csrw 0x6be, x3

    #Address 0x6be read value
    csrr x14, 0x6be

    #Unmapped address 0xb61 testing: Read Reset + Random data Write/Read
    #Address 0xb61 read value
    csrr x14, 0xb61

    #Address 0xb61 Write value 0x5dbe0d23
    li x3, 0x5dbe0d23
    csrw 0xb61, x3

    #Address 0xb61 read value
    csrr x14, 0xb61

    #Unmapped address 0xd6f testing: Read Reset + Random data Write/Read
    #Address 0xd6f read value
    csrr x14, 0xd6f

    #Address 0xd6f Write value 0x84e669e4
    li x3, 0x84e669e4
    csrw 0xd6f, x3

    #Address 0xd6f read value
    csrr x14, 0xd6f

    #Unmapped address 0xe06 testing: Read Reset + Random data Write/Read
    #Address 0xe06 read value
    csrr x14, 0xe06

    #Address 0xe06 Write value 0xbfda7bb9
    li x3, 0xbfda7bb9
    csrw 0xe06, x3

    #Address 0xe06 read value
    csrr x14, 0xe06

    #Unmapped address 0x806 testing: Read Reset + Random data Write/Read
    #Address 0x806 read value
    csrr x14, 0x806

    #Address 0x806 Write value 0xa1d10c70
    li x3, 0xa1d10c70
    csrw 0x806, x3

    #Address 0x806 read value
    csrr x14, 0x806

    #Unmapped address 0x3a5 testing: Read Reset + Random data Write/Read
    #Address 0x3a5 read value
    csrr x14, 0x3a5

    #Address 0x3a5 Write value 0xf58ecb9e
    li x3, 0xf58ecb9e
    csrw 0x3a5, x3

    #Address 0x3a5 read value
    csrr x14, 0x3a5

    #Unmapped address 0x1ea testing: Read Reset + Random data Write/Read
    #Address 0x1ea read value
    csrr x14, 0x1ea

    #Address 0x1ea Write value 0x60f6618b
    li x3, 0x60f6618b
    csrw 0x1ea, x3

    #Address 0x1ea read value
    csrr x14, 0x1ea

    #Unmapped address 0x4e2 testing: Read Reset + Random data Write/Read
    #Address 0x4e2 read value
    csrr x14, 0x4e2

    #Address 0x4e2 Write value 0x9a23af88
    li x3, 0x9a23af88
    csrw 0x4e2, x3

    #Address 0x4e2 read value
    csrr x14, 0x4e2

    #Unmapped address 0xa60 testing: Read Reset + Random data Write/Read
    #Address 0xa60 read value
    csrr x14, 0xa60

    #Address 0xa60 Write value 0x6a96e192
    li x3, 0x6a96e192
    csrw 0xa60, x3

    #Address 0xa60 read value
    csrr x14, 0xa60

    #Unmapped address 0x1d4 testing: Read Reset + Random data Write/Read
    #Address 0x1d4 read value
    csrr x14, 0x1d4

    #Address 0x1d4 Write value 0xdf9eba3b
    li x3, 0xdf9eba3b
    csrw 0x1d4, x3

    #Address 0x1d4 read value
    csrr x14, 0x1d4

    #Unmapped address 0xcbf testing: Read Reset + Random data Write/Read
    #Address 0xcbf read value
    csrr x14, 0xcbf

    #Address 0xcbf Write value 0xbb9b5e85
    li x3, 0xbb9b5e85
    csrw 0xcbf, x3

    #Address 0xcbf read value
    csrr x14, 0xcbf

    #Unmapped address 0x52e testing: Read Reset + Random data Write/Read
    #Address 0x52e read value
    csrr x14, 0x52e

    #Address 0x52e Write value 0xad47f7c6
    li x3, 0xad47f7c6
    csrw 0x52e, x3

    #Address 0x52e read value
    csrr x14, 0x52e

    #Unmapped address 0x7cf testing: Read Reset + Random data Write/Read
    #Address 0x7cf read value
    csrr x14, 0x7cf

    #Address 0x7cf Write value 0x66fea11b
    li x3, 0x66fea11b
    csrw 0x7cf, x3

    #Address 0x7cf read value
    csrr x14, 0x7cf

    #Unmapped address 0x69b testing: Read Reset + Random data Write/Read
    #Address 0x69b read value
    csrr x14, 0x69b

    #Address 0x69b Write value 0xf8fceed1
    li x3, 0xf8fceed1
    csrw 0x69b, x3

    #Address 0x69b read value
    csrr x14, 0x69b

    #Unmapped address 0x39e testing: Read Reset + Random data Write/Read
    #Address 0x39e read value
    csrr x14, 0x39e

    #Address 0x39e Write value 0xcea37ee3
    li x3, 0xcea37ee3
    csrw 0x39e, x3

    #Address 0x39e read value
    csrr x14, 0x39e

    #Unmapped address 0x5a9 testing: Read Reset + Random data Write/Read
    #Address 0x5a9 read value
    csrr x14, 0x5a9

    #Address 0x5a9 Write value 0x1632bde
    li x3, 0x1632bde
    csrw 0x5a9, x3

    #Address 0x5a9 read value
    csrr x14, 0x5a9

    #Unmapped address 0x953 testing: Read Reset + Random data Write/Read
    #Address 0x953 read value
    csrr x14, 0x953

    #Address 0x953 Write value 0xcbb8a56d
    li x3, 0xcbb8a56d
    csrw 0x953, x3

    #Address 0x953 read value
    csrr x14, 0x953

    #Unmapped address 0x998 testing: Read Reset + Random data Write/Read
    #Address 0x998 read value
    csrr x14, 0x998

    #Address 0x998 Write value 0x5641e616
    li x3, 0x5641e616
    csrw 0x998, x3

    #Address 0x998 read value
    csrr x14, 0x998

    #Unmapped address 0xf1c testing: Read Reset + Random data Write/Read
    #Address 0xf1c read value
    csrr x14, 0xf1c

    #Address 0xf1c Write value 0x2571dc9
    li x3, 0x2571dc9
    csrw 0xf1c, x3

    #Address 0xf1c read value
    csrr x14, 0xf1c

    #Unmapped address 0xc9f testing: Read Reset + Random data Write/Read
    #Address 0xc9f read value
    csrr x14, 0xc9f

    #Address 0xc9f Write value 0x259d63ec
    li x3, 0x259d63ec
    csrw 0xc9f, x3

    #Address 0xc9f read value
    csrr x14, 0xc9f

    #Unmapped address 0xc03 testing: Read Reset + Random data Write/Read
    #Address 0xc03 read value
    csrr x14, 0xc03

    #Address 0xc03 Write value 0x48c42508
    li x3, 0x48c42508
    csrw 0xc03, x3

    #Address 0xc03 read value
    csrr x14, 0xc03

    #Unmapped address 0xa50 testing: Read Reset + Random data Write/Read
    #Address 0xa50 read value
    csrr x14, 0xa50

    #Address 0xa50 Write value 0x299f670f
    li x3, 0x299f670f
    csrw 0xa50, x3

    #Address 0xa50 read value
    csrr x14, 0xa50

    #Unmapped address 0x415 testing: Read Reset + Random data Write/Read
    #Address 0x415 read value
    csrr x14, 0x415

    #Address 0x415 Write value 0x387a4bac
    li x3, 0x387a4bac
    csrw 0x415, x3

    #Address 0x415 read value
    csrr x14, 0x415

    #Unmapped address 0x531 testing: Read Reset + Random data Write/Read
    #Address 0x531 read value
    csrr x14, 0x531

    #Address 0x531 Write value 0x9f0dae0a
    li x3, 0x9f0dae0a
    csrw 0x531, x3

    #Address 0x531 read value
    csrr x14, 0x531

    #Unmapped address 0x6e testing: Read Reset + Random data Write/Read
    #Address 0x6e read value
    csrr x14, 0x6e

    #Address 0x6e Write value 0x3576d48e
    li x3, 0x3576d48e
    csrw 0x6e, x3

    #Address 0x6e read value
    csrr x14, 0x6e

    #Unmapped address 0x1e testing: Read Reset + Random data Write/Read
    #Address 0x1e read value
    csrr x14, 0x1e

    #Address 0x1e Write value 0x6a51b628
    li x3, 0x6a51b628
    csrw 0x1e, x3

    #Address 0x1e read value
    csrr x14, 0x1e

    #Unmapped address 0x9e2 testing: Read Reset + Random data Write/Read
    #Address 0x9e2 read value
    csrr x14, 0x9e2

    #Address 0x9e2 Write value 0x9216d163
    li x3, 0x9216d163
    csrw 0x9e2, x3

    #Address 0x9e2 read value
    csrr x14, 0x9e2

    #Unmapped address 0xa1 testing: Read Reset + Random data Write/Read
    #Address 0xa1 read value
    csrr x14, 0xa1

    #Address 0xa1 Write value 0x99342558
    li x3, 0x99342558
    csrw 0xa1, x3

    #Address 0xa1 read value
    csrr x14, 0xa1

    #Unmapped address 0xdd6 testing: Read Reset + Random data Write/Read
    #Address 0xdd6 read value
    csrr x14, 0xdd6

    #Address 0xdd6 Write value 0xfb7bcab4
    li x3, 0xfb7bcab4
    csrw 0xdd6, x3

    #Address 0xdd6 read value
    csrr x14, 0xdd6

    #Unmapped address 0x44b testing: Read Reset + Random data Write/Read
    #Address 0x44b read value
    csrr x14, 0x44b

    #Address 0x44b Write value 0x384b5f62
    li x3, 0x384b5f62
    csrw 0x44b, x3

    #Address 0x44b read value
    csrr x14, 0x44b

    #Unmapped address 0xf19 testing: Read Reset + Random data Write/Read
    #Address 0xf19 read value
    csrr x14, 0xf19

    #Address 0xf19 Write value 0x2623599c
    li x3, 0x2623599c
    csrw 0xf19, x3

    #Address 0xf19 read value
    csrr x14, 0xf19

    #Unmapped address 0x4a5 testing: Read Reset + Random data Write/Read
    #Address 0x4a5 read value
    csrr x14, 0x4a5

    #Address 0x4a5 Write value 0x81085abe
    li x3, 0x81085abe
    csrw 0x4a5, x3

    #Address 0x4a5 read value
    csrr x14, 0x4a5

    #Unmapped address 0x698 testing: Read Reset + Random data Write/Read
    #Address 0x698 read value
    csrr x14, 0x698

    #Address 0x698 Write value 0x100a0ccc
    li x3, 0x100a0ccc
    csrw 0x698, x3

    #Address 0x698 read value
    csrr x14, 0x698

    #Unmapped address 0x528 testing: Read Reset + Random data Write/Read
    #Address 0x528 read value
    csrr x14, 0x528

    #Address 0x528 Write value 0x7954761
    li x3, 0x7954761
    csrw 0x528, x3

    #Address 0x528 read value
    csrr x14, 0x528

    #Unmapped address 0x6e6 testing: Read Reset + Random data Write/Read
    #Address 0x6e6 read value
    csrr x14, 0x6e6

    #Address 0x6e6 Write value 0x7e2c108e
    li x3, 0x7e2c108e
    csrw 0x6e6, x3

    #Address 0x6e6 read value
    csrr x14, 0x6e6

    #Unmapped address 0x93e testing: Read Reset + Random data Write/Read
    #Address 0x93e read value
    csrr x14, 0x93e

    #Address 0x93e Write value 0xbb3c4b7f
    li x3, 0xbb3c4b7f
    csrw 0x93e, x3

    #Address 0x93e read value
    csrr x14, 0x93e

    #Unmapped address 0x25d testing: Read Reset + Random data Write/Read
    #Address 0x25d read value
    csrr x14, 0x25d

    #Address 0x25d Write value 0x1299a128
    li x3, 0x1299a128
    csrw 0x25d, x3

    #Address 0x25d read value
    csrr x14, 0x25d

    #Unmapped address 0x143 testing: Read Reset + Random data Write/Read
    #Address 0x143 read value
    csrr x14, 0x143

    #Address 0x143 Write value 0x358ceece
    li x3, 0x358ceece
    csrw 0x143, x3

    #Address 0x143 read value
    csrr x14, 0x143

    #Unmapped address 0x38b testing: Read Reset + Random data Write/Read
    #Address 0x38b read value
    csrr x14, 0x38b

    #Address 0x38b Write value 0xa6dee946
    li x3, 0xa6dee946
    csrw 0x38b, x3

    #Address 0x38b read value
    csrr x14, 0x38b

    #Unmapped address 0x286 testing: Read Reset + Random data Write/Read
    #Address 0x286 read value
    csrr x14, 0x286

    #Address 0x286 Write value 0xc4d77f3a
    li x3, 0xc4d77f3a
    csrw 0x286, x3

    #Address 0x286 read value
    csrr x14, 0x286

    #Unmapped address 0xafd testing: Read Reset + Random data Write/Read
    #Address 0xafd read value
    csrr x14, 0xafd

    #Address 0xafd Write value 0xf5ed2b3
    li x3, 0xf5ed2b3
    csrw 0xafd, x3

    #Address 0xafd read value
    csrr x14, 0xafd

    #Unmapped address 0x40 testing: Read Reset + Random data Write/Read
    #Address 0x40 read value
    csrr x14, 0x40

    #Address 0x40 Write value 0xf8db23b8
    li x3, 0xf8db23b8
    csrw 0x40, x3

    #Address 0x40 read value
    csrr x14, 0x40

    #Unmapped address 0x867 testing: Read Reset + Random data Write/Read
    #Address 0x867 read value
    csrr x14, 0x867

    #Address 0x867 Write value 0xf2b670a6
    li x3, 0xf2b670a6
    csrw 0x867, x3

    #Address 0x867 read value
    csrr x14, 0x867

    #Unmapped address 0x1aa testing: Read Reset + Random data Write/Read
    #Address 0x1aa read value
    csrr x14, 0x1aa

    #Address 0x1aa Write value 0xe8093509
    li x3, 0xe8093509
    csrw 0x1aa, x3

    #Address 0x1aa read value
    csrr x14, 0x1aa

    #Unmapped address 0x680 testing: Read Reset + Random data Write/Read
    #Address 0x680 read value
    csrr x14, 0x680

    #Address 0x680 Write value 0x99d239b4
    li x3, 0x99d239b4
    csrw 0x680, x3

    #Address 0x680 read value
    csrr x14, 0x680

    #Unmapped address 0x2f1 testing: Read Reset + Random data Write/Read
    #Address 0x2f1 read value
    csrr x14, 0x2f1

    #Address 0x2f1 Write value 0xc4546619
    li x3, 0xc4546619
    csrw 0x2f1, x3

    #Address 0x2f1 read value
    csrr x14, 0x2f1

    #Unmapped address 0x7ee testing: Read Reset + Random data Write/Read
    #Address 0x7ee read value
    csrr x14, 0x7ee

    #Address 0x7ee Write value 0xf915fa17
    li x3, 0xf915fa17
    csrw 0x7ee, x3

    #Address 0x7ee read value
    csrr x14, 0x7ee

    #Unmapped address 0xcb9 testing: Read Reset + Random data Write/Read
    #Address 0xcb9 read value
    csrr x14, 0xcb9

    #Address 0xcb9 Write value 0x9a5c24bc
    li x3, 0x9a5c24bc
    csrw 0xcb9, x3

    #Address 0xcb9 read value
    csrr x14, 0xcb9

    #Unmapped address 0x31a testing: Read Reset + Random data Write/Read
    #Address 0x31a read value
    csrr x14, 0x31a

    #Address 0x31a Write value 0x702a0aca
    li x3, 0x702a0aca
    csrw 0x31a, x3

    #Address 0x31a read value
    csrr x14, 0x31a

    #Unmapped address 0xdd1 testing: Read Reset + Random data Write/Read
    #Address 0xdd1 read value
    csrr x14, 0xdd1

    #Address 0xdd1 Write value 0x5fa0a1d0
    li x3, 0x5fa0a1d0
    csrw 0xdd1, x3

    #Address 0xdd1 read value
    csrr x14, 0xdd1

    #Unmapped address 0xfa5 testing: Read Reset + Random data Write/Read
    #Address 0xfa5 read value
    csrr x14, 0xfa5

    #Address 0xfa5 Write value 0xfe3f842b
    li x3, 0xfe3f842b
    csrw 0xfa5, x3

    #Address 0xfa5 read value
    csrr x14, 0xfa5

    #Unmapped address 0x29d testing: Read Reset + Random data Write/Read
    #Address 0x29d read value
    csrr x14, 0x29d

    #Address 0x29d Write value 0xde6ea3c2
    li x3, 0xde6ea3c2
    csrw 0x29d, x3

    #Address 0x29d read value
    csrr x14, 0x29d

    #Unmapped address 0xc51 testing: Read Reset + Random data Write/Read
    #Address 0xc51 read value
    csrr x14, 0xc51

    #Address 0xc51 Write value 0x74155729
    li x3, 0x74155729
    csrw 0xc51, x3

    #Address 0xc51 read value
    csrr x14, 0xc51

    #Unmapped address 0x58f testing: Read Reset + Random data Write/Read
    #Address 0x58f read value
    csrr x14, 0x58f

    #Address 0x58f Write value 0xbe066386
    li x3, 0xbe066386
    csrw 0x58f, x3

    #Address 0x58f read value
    csrr x14, 0x58f

    #Unmapped address 0x34e testing: Read Reset + Random data Write/Read
    #Address 0x34e read value
    csrr x14, 0x34e

    #Address 0x34e Write value 0x3a5f0540
    li x3, 0x3a5f0540
    csrw 0x34e, x3

    #Address 0x34e read value
    csrr x14, 0x34e

    #Unmapped address 0x5a0 testing: Read Reset + Random data Write/Read
    #Address 0x5a0 read value
    csrr x14, 0x5a0

    #Address 0x5a0 Write value 0x8814ab6d
    li x3, 0x8814ab6d
    csrw 0x5a0, x3

    #Address 0x5a0 read value
    csrr x14, 0x5a0

    #Unmapped address 0x237 testing: Read Reset + Random data Write/Read
    #Address 0x237 read value
    csrr x14, 0x237

    #Address 0x237 Write value 0x5535cbb0
    li x3, 0x5535cbb0
    csrw 0x237, x3

    #Address 0x237 read value
    csrr x14, 0x237

    #Unmapped address 0x90e testing: Read Reset + Random data Write/Read
    #Address 0x90e read value
    csrr x14, 0x90e

    #Address 0x90e Write value 0x45829c09
    li x3, 0x45829c09
    csrw 0x90e, x3

    #Address 0x90e read value
    csrr x14, 0x90e

    #Unmapped address 0xd85 testing: Read Reset + Random data Write/Read
    #Address 0xd85 read value
    csrr x14, 0xd85

    #Address 0xd85 Write value 0x4bc4a86f
    li x3, 0x4bc4a86f
    csrw 0xd85, x3

    #Address 0xd85 read value
    csrr x14, 0xd85

    #Unmapped address 0xa52 testing: Read Reset + Random data Write/Read
    #Address 0xa52 read value
    csrr x14, 0xa52

    #Address 0xa52 Write value 0x390a5222
    li x3, 0x390a5222
    csrw 0xa52, x3

    #Address 0xa52 read value
    csrr x14, 0xa52

    #Unmapped address 0x1e5 testing: Read Reset + Random data Write/Read
    #Address 0x1e5 read value
    csrr x14, 0x1e5

    #Address 0x1e5 Write value 0xc0f17d21
    li x3, 0xc0f17d21
    csrw 0x1e5, x3

    #Address 0x1e5 read value
    csrr x14, 0x1e5

    #Unmapped address 0xdf testing: Read Reset + Random data Write/Read
    #Address 0xdf read value
    csrr x14, 0xdf

    #Address 0xdf Write value 0x26512890
    li x3, 0x26512890
    csrw 0xdf, x3

    #Address 0xdf read value
    csrr x14, 0xdf

    #Unmapped address 0x4b6 testing: Read Reset + Random data Write/Read
    #Address 0x4b6 read value
    csrr x14, 0x4b6

    #Address 0x4b6 Write value 0x7fbb96d7
    li x3, 0x7fbb96d7
    csrw 0x4b6, x3

    #Address 0x4b6 read value
    csrr x14, 0x4b6

    #Unmapped address 0x117 testing: Read Reset + Random data Write/Read
    #Address 0x117 read value
    csrr x14, 0x117

    #Address 0x117 Write value 0x2a9f7dc9
    li x3, 0x2a9f7dc9
    csrw 0x117, x3

    #Address 0x117 read value
    csrr x14, 0x117

    #Unmapped address 0xcc4 testing: Read Reset + Random data Write/Read
    #Address 0xcc4 read value
    csrr x14, 0xcc4

    #Address 0xcc4 Write value 0x8af42b10
    li x3, 0x8af42b10
    csrw 0xcc4, x3

    #Address 0xcc4 read value
    csrr x14, 0xcc4

    #Unmapped address 0x487 testing: Read Reset + Random data Write/Read
    #Address 0x487 read value
    csrr x14, 0x487

    #Address 0x487 Write value 0x1190ce8c
    li x3, 0x1190ce8c
    csrw 0x487, x3

    #Address 0x487 read value
    csrr x14, 0x487

    #Unmapped address 0xa76 testing: Read Reset + Random data Write/Read
    #Address 0xa76 read value
    csrr x14, 0xa76

    #Address 0xa76 Write value 0xad45256b
    li x3, 0xad45256b
    csrw 0xa76, x3

    #Address 0xa76 read value
    csrr x14, 0xa76

    #Unmapped address 0xc1d testing: Read Reset + Random data Write/Read
    #Address 0xc1d read value
    csrr x14, 0xc1d

    #Address 0xc1d Write value 0x76893f65
    li x3, 0x76893f65
    csrw 0xc1d, x3

    #Address 0xc1d read value
    csrr x14, 0xc1d

    #Unmapped address 0x64c testing: Read Reset + Random data Write/Read
    #Address 0x64c read value
    csrr x14, 0x64c

    #Address 0x64c Write value 0x51579172
    li x3, 0x51579172
    csrw 0x64c, x3

    #Address 0x64c read value
    csrr x14, 0x64c

    #Unmapped address 0x5d7 testing: Read Reset + Random data Write/Read
    #Address 0x5d7 read value
    csrr x14, 0x5d7

    #Address 0x5d7 Write value 0xd0f51305
    li x3, 0xd0f51305
    csrw 0x5d7, x3

    #Address 0x5d7 read value
    csrr x14, 0x5d7

    #Unmapped address 0x183 testing: Read Reset + Random data Write/Read
    #Address 0x183 read value
    csrr x14, 0x183

    #Address 0x183 Write value 0xaae0e3fb
    li x3, 0xaae0e3fb
    csrw 0x183, x3

    #Address 0x183 read value
    csrr x14, 0x183

    #Unmapped address 0x647 testing: Read Reset + Random data Write/Read
    #Address 0x647 read value
    csrr x14, 0x647

    #Address 0x647 Write value 0xb1fdee17
    li x3, 0xb1fdee17
    csrw 0x647, x3

    #Address 0x647 read value
    csrr x14, 0x647

    #Unmapped address 0x99b testing: Read Reset + Random data Write/Read
    #Address 0x99b read value
    csrr x14, 0x99b

    #Address 0x99b Write value 0xb9267e5b
    li x3, 0xb9267e5b
    csrw 0x99b, x3

    #Address 0x99b read value
    csrr x14, 0x99b

    #Unmapped address 0x724 testing: Read Reset + Random data Write/Read
    #Address 0x724 read value
    csrr x14, 0x724

    #Address 0x724 Write value 0x3b5d95d3
    li x3, 0x3b5d95d3
    csrw 0x724, x3

    #Address 0x724 read value
    csrr x14, 0x724

    #Unmapped address 0xd06 testing: Read Reset + Random data Write/Read
    #Address 0xd06 read value
    csrr x14, 0xd06

    #Address 0xd06 Write value 0x2f5b287e
    li x3, 0x2f5b287e
    csrw 0xd06, x3

    #Address 0xd06 read value
    csrr x14, 0xd06

    #Unmapped address 0xdc5 testing: Read Reset + Random data Write/Read
    #Address 0xdc5 read value
    csrr x14, 0xdc5

    #Address 0xdc5 Write value 0x71fcfcd1
    li x3, 0x71fcfcd1
    csrw 0xdc5, x3

    #Address 0xdc5 read value
    csrr x14, 0xdc5

    #Unmapped address 0x898 testing: Read Reset + Random data Write/Read
    #Address 0x898 read value
    csrr x14, 0x898

    #Address 0x898 Write value 0x90ebe8d2
    li x3, 0x90ebe8d2
    csrw 0x898, x3

    #Address 0x898 read value
    csrr x14, 0x898

    #Unmapped address 0xd18 testing: Read Reset + Random data Write/Read
    #Address 0xd18 read value
    csrr x14, 0xd18

    #Address 0xd18 Write value 0xbe070150
    li x3, 0xbe070150
    csrw 0xd18, x3

    #Address 0xd18 read value
    csrr x14, 0xd18

    #Unmapped address 0x1fe testing: Read Reset + Random data Write/Read
    #Address 0x1fe read value
    csrr x14, 0x1fe

    #Address 0x1fe Write value 0x739b0749
    li x3, 0x739b0749
    csrw 0x1fe, x3

    #Address 0x1fe read value
    csrr x14, 0x1fe

    #Unmapped address 0x3c5 testing: Read Reset + Random data Write/Read
    #Address 0x3c5 read value
    csrr x14, 0x3c5

    #Address 0x3c5 Write value 0xfafe9a85
    li x3, 0xfafe9a85
    csrw 0x3c5, x3

    #Address 0x3c5 read value
    csrr x14, 0x3c5

    #Unmapped address 0x851 testing: Read Reset + Random data Write/Read
    #Address 0x851 read value
    csrr x14, 0x851

    #Address 0x851 Write value 0xd35429f7
    li x3, 0xd35429f7
    csrw 0x851, x3

    #Address 0x851 read value
    csrr x14, 0x851

    #Unmapped address 0xcd testing: Read Reset + Random data Write/Read
    #Address 0xcd read value
    csrr x14, 0xcd

    #Address 0xcd Write value 0xa358312c
    li x3, 0xa358312c
    csrw 0xcd, x3

    #Address 0xcd read value
    csrr x14, 0xcd

    #Unmapped address 0xa71 testing: Read Reset + Random data Write/Read
    #Address 0xa71 read value
    csrr x14, 0xa71

    #Address 0xa71 Write value 0xb021606a
    li x3, 0xb021606a
    csrw 0xa71, x3

    #Address 0xa71 read value
    csrr x14, 0xa71

    #Unmapped address 0x96c testing: Read Reset + Random data Write/Read
    #Address 0x96c read value
    csrr x14, 0x96c

    #Address 0x96c Write value 0xa516d93f
    li x3, 0xa516d93f
    csrw 0x96c, x3

    #Address 0x96c read value
    csrr x14, 0x96c

    #Unmapped address 0x1a9 testing: Read Reset + Random data Write/Read
    #Address 0x1a9 read value
    csrr x14, 0x1a9

    #Address 0x1a9 Write value 0x2e42948
    li x3, 0x2e42948
    csrw 0x1a9, x3

    #Address 0x1a9 read value
    csrr x14, 0x1a9

    #Unmapped address 0xd70 testing: Read Reset + Random data Write/Read
    #Address 0xd70 read value
    csrr x14, 0xd70

    #Address 0xd70 Write value 0xea1c6ef0
    li x3, 0xea1c6ef0
    csrw 0xd70, x3

    #Address 0xd70 read value
    csrr x14, 0xd70

    #Unmapped address 0xa2c testing: Read Reset + Random data Write/Read
    #Address 0xa2c read value
    csrr x14, 0xa2c

    #Address 0xa2c Write value 0x32359299
    li x3, 0x32359299
    csrw 0xa2c, x3

    #Address 0xa2c read value
    csrr x14, 0xa2c

    #Unmapped address 0x58 testing: Read Reset + Random data Write/Read
    #Address 0x58 read value
    csrr x14, 0x58

    #Address 0x58 Write value 0x293542b
    li x3, 0x293542b
    csrw 0x58, x3

    #Address 0x58 read value
    csrr x14, 0x58

    #Unmapped address 0xa28 testing: Read Reset + Random data Write/Read
    #Address 0xa28 read value
    csrr x14, 0xa28

    #Address 0xa28 Write value 0x33fac115
    li x3, 0x33fac115
    csrw 0xa28, x3

    #Address 0xa28 read value
    csrr x14, 0xa28

    #Unmapped address 0xbb3 testing: Read Reset + Random data Write/Read
    #Address 0xbb3 read value
    csrr x14, 0xbb3

    #Address 0xbb3 Write value 0x64dcb90a
    li x3, 0x64dcb90a
    csrw 0xbb3, x3

    #Address 0xbb3 read value
    csrr x14, 0xbb3

    #Unmapped address 0xcdc testing: Read Reset + Random data Write/Read
    #Address 0xcdc read value
    csrr x14, 0xcdc

    #Address 0xcdc Write value 0x2bd9be0f
    li x3, 0x2bd9be0f
    csrw 0xcdc, x3

    #Address 0xcdc read value
    csrr x14, 0xcdc

    #Unmapped address 0xf38 testing: Read Reset + Random data Write/Read
    #Address 0xf38 read value
    csrr x14, 0xf38

    #Address 0xf38 Write value 0xd8b0aa20
    li x3, 0xd8b0aa20
    csrw 0xf38, x3

    #Address 0xf38 read value
    csrr x14, 0xf38

    #Unmapped address 0xdd4 testing: Read Reset + Random data Write/Read
    #Address 0xdd4 read value
    csrr x14, 0xdd4

    #Address 0xdd4 Write value 0x3428ee24
    li x3, 0x3428ee24
    csrw 0xdd4, x3

    #Address 0xdd4 read value
    csrr x14, 0xdd4

    #Unmapped address 0xd8f testing: Read Reset + Random data Write/Read
    #Address 0xd8f read value
    csrr x14, 0xd8f

    #Address 0xd8f Write value 0x1406887e
    li x3, 0x1406887e
    csrw 0xd8f, x3

    #Address 0xd8f read value
    csrr x14, 0xd8f

    #Unmapped address 0xd43 testing: Read Reset + Random data Write/Read
    #Address 0xd43 read value
    csrr x14, 0xd43

    #Address 0xd43 Write value 0x3b770bb2
    li x3, 0x3b770bb2
    csrw 0xd43, x3

    #Address 0xd43 read value
    csrr x14, 0xd43

    #Unmapped address 0x100 testing: Read Reset + Random data Write/Read
    #Address 0x100 read value
    csrr x14, 0x100

    #Address 0x100 Write value 0x48f7895b
    li x3, 0x48f7895b
    csrw 0x100, x3

    #Address 0x100 read value
    csrr x14, 0x100

    #Unmapped address 0x400 testing: Read Reset + Random data Write/Read
    #Address 0x400 read value
    csrr x14, 0x400

    #Address 0x400 Write value 0xeb5828f5
    li x3, 0xeb5828f5
    csrw 0x400, x3

    #Address 0x400 read value
    csrr x14, 0x400

    #Unmapped address 0x861 testing: Read Reset + Random data Write/Read
    #Address 0x861 read value
    csrr x14, 0x861

    #Address 0x861 Write value 0xeac30e45
    li x3, 0xeac30e45
    csrw 0x861, x3

    #Address 0x861 read value
    csrr x14, 0x861

    #Unmapped address 0x8fb testing: Read Reset + Random data Write/Read
    #Address 0x8fb read value
    csrr x14, 0x8fb

    #Address 0x8fb Write value 0x7a9f28ea
    li x3, 0x7a9f28ea
    csrw 0x8fb, x3

    #Address 0x8fb read value
    csrr x14, 0x8fb

    #Unmapped address 0xa79 testing: Read Reset + Random data Write/Read
    #Address 0xa79 read value
    csrr x14, 0xa79

    #Address 0xa79 Write value 0x5b8ecb4b
    li x3, 0x5b8ecb4b
    csrw 0xa79, x3

    #Address 0xa79 read value
    csrr x14, 0xa79

    #Unmapped address 0xc8f testing: Read Reset + Random data Write/Read
    #Address 0xc8f read value
    csrr x14, 0xc8f

    #Address 0xc8f Write value 0xaf3d7149
    li x3, 0xaf3d7149
    csrw 0xc8f, x3

    #Address 0xc8f read value
    csrr x14, 0xc8f

    #Unmapped address 0x9f0 testing: Read Reset + Random data Write/Read
    #Address 0x9f0 read value
    csrr x14, 0x9f0

    #Address 0x9f0 Write value 0x2c8168c6
    li x3, 0x2c8168c6
    csrw 0x9f0, x3

    #Address 0x9f0 read value
    csrr x14, 0x9f0

    #Unmapped address 0x1b9 testing: Read Reset + Random data Write/Read
    #Address 0x1b9 read value
    csrr x14, 0x1b9

    #Address 0x1b9 Write value 0x52c8466d
    li x3, 0x52c8466d
    csrw 0x1b9, x3

    #Address 0x1b9 read value
    csrr x14, 0x1b9

    #Unmapped address 0x4e4 testing: Read Reset + Random data Write/Read
    #Address 0x4e4 read value
    csrr x14, 0x4e4

    #Address 0x4e4 Write value 0x11a6ccb5
    li x3, 0x11a6ccb5
    csrw 0x4e4, x3

    #Address 0x4e4 read value
    csrr x14, 0x4e4

    #Unmapped address 0x23c testing: Read Reset + Random data Write/Read
    #Address 0x23c read value
    csrr x14, 0x23c

    #Address 0x23c Write value 0x40c115f5
    li x3, 0x40c115f5
    csrw 0x23c, x3

    #Address 0x23c read value
    csrr x14, 0x23c

    #Unmapped address 0x9ea testing: Read Reset + Random data Write/Read
    #Address 0x9ea read value
    csrr x14, 0x9ea

    #Address 0x9ea Write value 0xb425ac0c
    li x3, 0xb425ac0c
    csrw 0x9ea, x3

    #Address 0x9ea read value
    csrr x14, 0x9ea

    #Unmapped address 0xc28 testing: Read Reset + Random data Write/Read
    #Address 0xc28 read value
    csrr x14, 0xc28

    #Address 0xc28 Write value 0x18e6083f
    li x3, 0x18e6083f
    csrw 0xc28, x3

    #Address 0xc28 read value
    csrr x14, 0xc28

    #Unmapped address 0x45a testing: Read Reset + Random data Write/Read
    #Address 0x45a read value
    csrr x14, 0x45a

    #Address 0x45a Write value 0x8978ad53
    li x3, 0x8978ad53
    csrw 0x45a, x3

    #Address 0x45a read value
    csrr x14, 0x45a

    #Unmapped address 0xc53 testing: Read Reset + Random data Write/Read
    #Address 0xc53 read value
    csrr x14, 0xc53

    #Address 0xc53 Write value 0x65f2eefc
    li x3, 0x65f2eefc
    csrw 0xc53, x3

    #Address 0xc53 read value
    csrr x14, 0xc53

    #Unmapped address 0x5ca testing: Read Reset + Random data Write/Read
    #Address 0x5ca read value
    csrr x14, 0x5ca

    #Address 0x5ca Write value 0x172cf47f
    li x3, 0x172cf47f
    csrw 0x5ca, x3

    #Address 0x5ca read value
    csrr x14, 0x5ca

    #Unmapped address 0x17b testing: Read Reset + Random data Write/Read
    #Address 0x17b read value
    csrr x14, 0x17b

    #Address 0x17b Write value 0x5206c29d
    li x3, 0x5206c29d
    csrw 0x17b, x3

    #Address 0x17b read value
    csrr x14, 0x17b

    #Unmapped address 0x78f testing: Read Reset + Random data Write/Read
    #Address 0x78f read value
    csrr x14, 0x78f

    #Address 0x78f Write value 0x2a9bc72b
    li x3, 0x2a9bc72b
    csrw 0x78f, x3

    #Address 0x78f read value
    csrr x14, 0x78f

    #Unmapped address 0x408 testing: Read Reset + Random data Write/Read
    #Address 0x408 read value
    csrr x14, 0x408

    #Address 0x408 Write value 0x6e73865c
    li x3, 0x6e73865c
    csrw 0x408, x3

    #Address 0x408 read value
    csrr x14, 0x408

    #Unmapped address 0x506 testing: Read Reset + Random data Write/Read
    #Address 0x506 read value
    csrr x14, 0x506

    #Address 0x506 Write value 0xf29824cb
    li x3, 0xf29824cb
    csrw 0x506, x3

    #Address 0x506 read value
    csrr x14, 0x506

    #Unmapped address 0xea8 testing: Read Reset + Random data Write/Read
    #Address 0xea8 read value
    csrr x14, 0xea8

    #Address 0xea8 Write value 0x2445ed9a
    li x3, 0x2445ed9a
    csrw 0xea8, x3

    #Address 0xea8 read value
    csrr x14, 0xea8

    #Unmapped address 0xc26 testing: Read Reset + Random data Write/Read
    #Address 0xc26 read value
    csrr x14, 0xc26

    #Address 0xc26 Write value 0x59c4dacc
    li x3, 0x59c4dacc
    csrw 0xc26, x3

    #Address 0xc26 read value
    csrr x14, 0xc26

    #Unmapped address 0x10a testing: Read Reset + Random data Write/Read
    #Address 0x10a read value
    csrr x14, 0x10a

    #Address 0x10a Write value 0xe6f03d1d
    li x3, 0xe6f03d1d
    csrw 0x10a, x3

    #Address 0x10a read value
    csrr x14, 0x10a

    #Unmapped address 0x34c testing: Read Reset + Random data Write/Read
    #Address 0x34c read value
    csrr x14, 0x34c

    #Address 0x34c Write value 0x45ff99ee
    li x3, 0x45ff99ee
    csrw 0x34c, x3

    #Address 0x34c read value
    csrr x14, 0x34c

    #Unmapped address 0x40e testing: Read Reset + Random data Write/Read
    #Address 0x40e read value
    csrr x14, 0x40e

    #Address 0x40e Write value 0x2f579cde
    li x3, 0x2f579cde
    csrw 0x40e, x3

    #Address 0x40e read value
    csrr x14, 0x40e

    #Unmapped address 0x6f4 testing: Read Reset + Random data Write/Read
    #Address 0x6f4 read value
    csrr x14, 0x6f4

    #Address 0x6f4 Write value 0x2e98e3ea
    li x3, 0x2e98e3ea
    csrw 0x6f4, x3

    #Address 0x6f4 read value
    csrr x14, 0x6f4

    #Unmapped address 0x3d3 testing: Read Reset + Random data Write/Read
    #Address 0x3d3 read value
    csrr x14, 0x3d3

    #Address 0x3d3 Write value 0xab329eb6
    li x3, 0xab329eb6
    csrw 0x3d3, x3

    #Address 0x3d3 read value
    csrr x14, 0x3d3

    #Unmapped address 0xef9 testing: Read Reset + Random data Write/Read
    #Address 0xef9 read value
    csrr x14, 0xef9

    #Address 0xef9 Write value 0xcd24f82
    li x3, 0xcd24f82
    csrw 0xef9, x3

    #Address 0xef9 read value
    csrr x14, 0xef9

    #Unmapped address 0x8f6 testing: Read Reset + Random data Write/Read
    #Address 0x8f6 read value
    csrr x14, 0x8f6

    #Address 0x8f6 Write value 0xd93101b2
    li x3, 0xd93101b2
    csrw 0x8f6, x3

    #Address 0x8f6 read value
    csrr x14, 0x8f6

    #Unmapped address 0xaf1 testing: Read Reset + Random data Write/Read
    #Address 0xaf1 read value
    csrr x14, 0xaf1

    #Address 0xaf1 Write value 0x46b2d909
    li x3, 0x46b2d909
    csrw 0xaf1, x3

    #Address 0xaf1 read value
    csrr x14, 0xaf1

    #Unmapped address 0xc20 testing: Read Reset + Random data Write/Read
    #Address 0xc20 read value
    csrr x14, 0xc20

    #Address 0xc20 Write value 0x67542cab
    li x3, 0x67542cab
    csrw 0xc20, x3

    #Address 0xc20 read value
    csrr x14, 0xc20

    #Unmapped address 0x730 testing: Read Reset + Random data Write/Read
    #Address 0x730 read value
    csrr x14, 0x730

    #Address 0x730 Write value 0x1745ce32
    li x3, 0x1745ce32
    csrw 0x730, x3

    #Address 0x730 read value
    csrr x14, 0x730

    #Unmapped address 0xcbd testing: Read Reset + Random data Write/Read
    #Address 0xcbd read value
    csrr x14, 0xcbd

    #Address 0xcbd Write value 0xa432a258
    li x3, 0xa432a258
    csrw 0xcbd, x3

    #Address 0xcbd read value
    csrr x14, 0xcbd

    #Unmapped address 0xb5d testing: Read Reset + Random data Write/Read
    #Address 0xb5d read value
    csrr x14, 0xb5d

    #Address 0xb5d Write value 0x5e8993fa
    li x3, 0x5e8993fa
    csrw 0xb5d, x3

    #Address 0xb5d read value
    csrr x14, 0xb5d

    #Unmapped address 0x56f testing: Read Reset + Random data Write/Read
    #Address 0x56f read value
    csrr x14, 0x56f

    #Address 0x56f Write value 0x97b8cf3e
    li x3, 0x97b8cf3e
    csrw 0x56f, x3

    #Address 0x56f read value
    csrr x14, 0x56f

    #Unmapped address 0x101 testing: Read Reset + Random data Write/Read
    #Address 0x101 read value
    csrr x14, 0x101

    #Address 0x101 Write value 0x61c99a18
    li x3, 0x61c99a18
    csrw 0x101, x3

    #Address 0x101 read value
    csrr x14, 0x101

    #Unmapped address 0x8ce testing: Read Reset + Random data Write/Read
    #Address 0x8ce read value
    csrr x14, 0x8ce

    #Address 0x8ce Write value 0xd6a3c53d
    li x3, 0xd6a3c53d
    csrw 0x8ce, x3

    #Address 0x8ce read value
    csrr x14, 0x8ce

    #Unmapped address 0x986 testing: Read Reset + Random data Write/Read
    #Address 0x986 read value
    csrr x14, 0x986

    #Address 0x986 Write value 0x6d8c805
    li x3, 0x6d8c805
    csrw 0x986, x3

    #Address 0x986 read value
    csrr x14, 0x986

    #Unmapped address 0x21 testing: Read Reset + Random data Write/Read
    #Address 0x21 read value
    csrr x14, 0x21

    #Address 0x21 Write value 0x46822118
    li x3, 0x46822118
    csrw 0x21, x3

    #Address 0x21 read value
    csrr x14, 0x21

    #Unmapped address 0x994 testing: Read Reset + Random data Write/Read
    #Address 0x994 read value
    csrr x14, 0x994

    #Address 0x994 Write value 0x7798ee55
    li x3, 0x7798ee55
    csrw 0x994, x3

    #Address 0x994 read value
    csrr x14, 0x994

    #Unmapped address 0x788 testing: Read Reset + Random data Write/Read
    #Address 0x788 read value
    csrr x14, 0x788

    #Address 0x788 Write value 0x1d78250d
    li x3, 0x1d78250d
    csrw 0x788, x3

    #Address 0x788 read value
    csrr x14, 0x788

    #Unmapped address 0x6af testing: Read Reset + Random data Write/Read
    #Address 0x6af read value
    csrr x14, 0x6af

    #Address 0x6af Write value 0x8df53bd7
    li x3, 0x8df53bd7
    csrw 0x6af, x3

    #Address 0x6af read value
    csrr x14, 0x6af

    #Unmapped address 0x8fe testing: Read Reset + Random data Write/Read
    #Address 0x8fe read value
    csrr x14, 0x8fe

    #Address 0x8fe Write value 0x7d13ede0
    li x3, 0x7d13ede0
    csrw 0x8fe, x3

    #Address 0x8fe read value
    csrr x14, 0x8fe

    #Unmapped address 0x4b4 testing: Read Reset + Random data Write/Read
    #Address 0x4b4 read value
    csrr x14, 0x4b4

    #Address 0x4b4 Write value 0xac79adfe
    li x3, 0xac79adfe
    csrw 0x4b4, x3

    #Address 0x4b4 read value
    csrr x14, 0x4b4

    #Unmapped address 0xf9a testing: Read Reset + Random data Write/Read
    #Address 0xf9a read value
    csrr x14, 0xf9a

    #Address 0xf9a Write value 0x6df2174c
    li x3, 0x6df2174c
    csrw 0xf9a, x3

    #Address 0xf9a read value
    csrr x14, 0xf9a

    #Unmapped address 0x27 testing: Read Reset + Random data Write/Read
    #Address 0x27 read value
    csrr x14, 0x27

    #Address 0x27 Write value 0xdced9b7c
    li x3, 0xdced9b7c
    csrw 0x27, x3

    #Address 0x27 read value
    csrr x14, 0x27

    #Unmapped address 0xf55 testing: Read Reset + Random data Write/Read
    #Address 0xf55 read value
    csrr x14, 0xf55

    #Address 0xf55 Write value 0xfb7cb9dc
    li x3, 0xfb7cb9dc
    csrw 0xf55, x3

    #Address 0xf55 read value
    csrr x14, 0xf55

    #Unmapped address 0xbea testing: Read Reset + Random data Write/Read
    #Address 0xbea read value
    csrr x14, 0xbea

    #Address 0xbea Write value 0xbb6ef114
    li x3, 0xbb6ef114
    csrw 0xbea, x3

    #Address 0xbea read value
    csrr x14, 0xbea

    #Unmapped address 0xbf2 testing: Read Reset + Random data Write/Read
    #Address 0xbf2 read value
    csrr x14, 0xbf2

    #Address 0xbf2 Write value 0x8ad5b404
    li x3, 0x8ad5b404
    csrw 0xbf2, x3

    #Address 0xbf2 read value
    csrr x14, 0xbf2

    #Unmapped address 0x79c testing: Read Reset + Random data Write/Read
    #Address 0x79c read value
    csrr x14, 0x79c

    #Address 0x79c Write value 0x9e68cf16
    li x3, 0x9e68cf16
    csrw 0x79c, x3

    #Address 0x79c read value
    csrr x14, 0x79c

    #Unmapped address 0xd50 testing: Read Reset + Random data Write/Read
    #Address 0xd50 read value
    csrr x14, 0xd50

    #Address 0xd50 Write value 0x8c132b72
    li x3, 0x8c132b72
    csrw 0xd50, x3

    #Address 0xd50 read value
    csrr x14, 0xd50

    #Unmapped address 0xf8 testing: Read Reset + Random data Write/Read
    #Address 0xf8 read value
    csrr x14, 0xf8

    #Address 0xf8 Write value 0xaa2b4152
    li x3, 0xaa2b4152
    csrw 0xf8, x3

    #Address 0xf8 read value
    csrr x14, 0xf8

    #Unmapped address 0xbbb testing: Read Reset + Random data Write/Read
    #Address 0xbbb read value
    csrr x14, 0xbbb

    #Address 0xbbb Write value 0x73d7c212
    li x3, 0x73d7c212
    csrw 0xbbb, x3

    #Address 0xbbb read value
    csrr x14, 0xbbb

    #Unmapped address 0x634 testing: Read Reset + Random data Write/Read
    #Address 0x634 read value
    csrr x14, 0x634

    #Address 0x634 Write value 0xde480449
    li x3, 0xde480449
    csrw 0x634, x3

    #Address 0x634 read value
    csrr x14, 0x634

    #Unmapped address 0x7c2 testing: Read Reset + Random data Write/Read
    #Address 0x7c2 read value
    csrr x14, 0x7c2

    #Address 0x7c2 Write value 0x2f1320c6
    li x3, 0x2f1320c6
    csrw 0x7c2, x3

    #Address 0x7c2 read value
    csrr x14, 0x7c2

    #Unmapped address 0x225 testing: Read Reset + Random data Write/Read
    #Address 0x225 read value
    csrr x14, 0x225

    #Address 0x225 Write value 0xd90fe368
    li x3, 0xd90fe368
    csrw 0x225, x3

    #Address 0x225 read value
    csrr x14, 0x225

    #Unmapped address 0x55c testing: Read Reset + Random data Write/Read
    #Address 0x55c read value
    csrr x14, 0x55c

    #Address 0x55c Write value 0xb473e88b
    li x3, 0xb473e88b
    csrw 0x55c, x3

    #Address 0x55c read value
    csrr x14, 0x55c

    #Unmapped address 0x72c testing: Read Reset + Random data Write/Read
    #Address 0x72c read value
    csrr x14, 0x72c

    #Address 0x72c Write value 0xf51bc95a
    li x3, 0xf51bc95a
    csrw 0x72c, x3

    #Address 0x72c read value
    csrr x14, 0x72c

    #Unmapped address 0xf29 testing: Read Reset + Random data Write/Read
    #Address 0xf29 read value
    csrr x14, 0xf29

    #Address 0xf29 Write value 0x61a020f1
    li x3, 0x61a020f1
    csrw 0xf29, x3

    #Address 0xf29 read value
    csrr x14, 0xf29

    #Unmapped address 0x619 testing: Read Reset + Random data Write/Read
    #Address 0x619 read value
    csrr x14, 0x619

    #Address 0x619 Write value 0xaa7ff9d3
    li x3, 0xaa7ff9d3
    csrw 0x619, x3

    #Address 0x619 read value
    csrr x14, 0x619

    #Unmapped address 0xe2c testing: Read Reset + Random data Write/Read
    #Address 0xe2c read value
    csrr x14, 0xe2c

    #Address 0xe2c Write value 0x7c677177
    li x3, 0x7c677177
    csrw 0xe2c, x3

    #Address 0xe2c read value
    csrr x14, 0xe2c

    #Unmapped address 0x780 testing: Read Reset + Random data Write/Read
    #Address 0x780 read value
    csrr x14, 0x780

    #Address 0x780 Write value 0xd3971121
    li x3, 0xd3971121
    csrw 0x780, x3

    #Address 0x780 read value
    csrr x14, 0x780

    #Unmapped address 0xe16 testing: Read Reset + Random data Write/Read
    #Address 0xe16 read value
    csrr x14, 0xe16

    #Address 0xe16 Write value 0xec9cf094
    li x3, 0xec9cf094
    csrw 0xe16, x3

    #Address 0xe16 read value
    csrr x14, 0xe16

    #Unmapped address 0xab8 testing: Read Reset + Random data Write/Read
    #Address 0xab8 read value
    csrr x14, 0xab8

    #Address 0xab8 Write value 0x9628f23f
    li x3, 0x9628f23f
    csrw 0xab8, x3

    #Address 0xab8 read value
    csrr x14, 0xab8

    #Unmapped address 0x78a testing: Read Reset + Random data Write/Read
    #Address 0x78a read value
    csrr x14, 0x78a

    #Address 0x78a Write value 0x6fa92f28
    li x3, 0x6fa92f28
    csrw 0x78a, x3

    #Address 0x78a read value
    csrr x14, 0x78a

    #Unmapped address 0xe1b testing: Read Reset + Random data Write/Read
    #Address 0xe1b read value
    csrr x14, 0xe1b

    #Address 0xe1b Write value 0x77e3694b
    li x3, 0x77e3694b
    csrw 0xe1b, x3

    #Address 0xe1b read value
    csrr x14, 0xe1b

    #Unmapped address 0x2cd testing: Read Reset + Random data Write/Read
    #Address 0x2cd read value
    csrr x14, 0x2cd

    #Address 0x2cd Write value 0xe01adb55
    li x3, 0xe01adb55
    csrw 0x2cd, x3

    #Address 0x2cd read value
    csrr x14, 0x2cd

    #Unmapped address 0xf6c testing: Read Reset + Random data Write/Read
    #Address 0xf6c read value
    csrr x14, 0xf6c

    #Address 0xf6c Write value 0xd3e4e4ec
    li x3, 0xd3e4e4ec
    csrw 0xf6c, x3

    #Address 0xf6c read value
    csrr x14, 0xf6c

    #Unmapped address 0xa06 testing: Read Reset + Random data Write/Read
    #Address 0xa06 read value
    csrr x14, 0xa06

    #Address 0xa06 Write value 0x6f417d74
    li x3, 0x6f417d74
    csrw 0xa06, x3

    #Address 0xa06 read value
    csrr x14, 0xa06

    #Unmapped address 0x242 testing: Read Reset + Random data Write/Read
    #Address 0x242 read value
    csrr x14, 0x242

    #Address 0x242 Write value 0xc430ec25
    li x3, 0xc430ec25
    csrw 0x242, x3

    #Address 0x242 read value
    csrr x14, 0x242

    #Unmapped address 0xe2e testing: Read Reset + Random data Write/Read
    #Address 0xe2e read value
    csrr x14, 0xe2e

    #Address 0xe2e Write value 0x1d631fb5
    li x3, 0x1d631fb5
    csrw 0xe2e, x3

    #Address 0xe2e read value
    csrr x14, 0xe2e

    #Unmapped address 0xa58 testing: Read Reset + Random data Write/Read
    #Address 0xa58 read value
    csrr x14, 0xa58

    #Address 0xa58 Write value 0xf5e74ce8
    li x3, 0xf5e74ce8
    csrw 0xa58, x3

    #Address 0xa58 read value
    csrr x14, 0xa58

    #Unmapped address 0x97d testing: Read Reset + Random data Write/Read
    #Address 0x97d read value
    csrr x14, 0x97d

    #Address 0x97d Write value 0xf52e5941
    li x3, 0xf52e5941
    csrw 0x97d, x3

    #Address 0x97d read value
    csrr x14, 0x97d

    #Unmapped address 0x4b5 testing: Read Reset + Random data Write/Read
    #Address 0x4b5 read value
    csrr x14, 0x4b5

    #Address 0x4b5 Write value 0x6941971c
    li x3, 0x6941971c
    csrw 0x4b5, x3

    #Address 0x4b5 read value
    csrr x14, 0x4b5

    #Unmapped address 0x5ce testing: Read Reset + Random data Write/Read
    #Address 0x5ce read value
    csrr x14, 0x5ce

    #Address 0x5ce Write value 0x9fc9b3f7
    li x3, 0x9fc9b3f7
    csrw 0x5ce, x3

    #Address 0x5ce read value
    csrr x14, 0x5ce

    #Unmapped address 0xffa testing: Read Reset + Random data Write/Read
    #Address 0xffa read value
    csrr x14, 0xffa

    #Address 0xffa Write value 0xf6fa518e
    li x3, 0xf6fa518e
    csrw 0xffa, x3

    #Address 0xffa read value
    csrr x14, 0xffa

    #Unmapped address 0x4f4 testing: Read Reset + Random data Write/Read
    #Address 0x4f4 read value
    csrr x14, 0x4f4

    #Address 0x4f4 Write value 0x406cc294
    li x3, 0x406cc294
    csrw 0x4f4, x3

    #Address 0x4f4 read value
    csrr x14, 0x4f4

    #Unmapped address 0x28f testing: Read Reset + Random data Write/Read
    #Address 0x28f read value
    csrr x14, 0x28f

    #Address 0x28f Write value 0x8ef545fc
    li x3, 0x8ef545fc
    csrw 0x28f, x3

    #Address 0x28f read value
    csrr x14, 0x28f

    #Unmapped address 0x93f testing: Read Reset + Random data Write/Read
    #Address 0x93f read value
    csrr x14, 0x93f

    #Address 0x93f Write value 0x7d28291a
    li x3, 0x7d28291a
    csrw 0x93f, x3

    #Address 0x93f read value
    csrr x14, 0x93f

    #Unmapped address 0xe5c testing: Read Reset + Random data Write/Read
    #Address 0xe5c read value
    csrr x14, 0xe5c

    #Address 0xe5c Write value 0x4e6b51c2
    li x3, 0x4e6b51c2
    csrw 0xe5c, x3

    #Address 0xe5c read value
    csrr x14, 0xe5c

    #Unmapped address 0x18d testing: Read Reset + Random data Write/Read
    #Address 0x18d read value
    csrr x14, 0x18d

    #Address 0x18d Write value 0x3923c588
    li x3, 0x3923c588
    csrw 0x18d, x3

    #Address 0x18d read value
    csrr x14, 0x18d

    #Unmapped address 0x8a1 testing: Read Reset + Random data Write/Read
    #Address 0x8a1 read value
    csrr x14, 0x8a1

    #Address 0x8a1 Write value 0x16edc9d3
    li x3, 0x16edc9d3
    csrw 0x8a1, x3

    #Address 0x8a1 read value
    csrr x14, 0x8a1

    #Unmapped address 0x345 testing: Read Reset + Random data Write/Read
    #Address 0x345 read value
    csrr x14, 0x345

    #Address 0x345 Write value 0xb21df214
    li x3, 0xb21df214
    csrw 0x345, x3

    #Address 0x345 read value
    csrr x14, 0x345

    #Unmapped address 0xfe3 testing: Read Reset + Random data Write/Read
    #Address 0xfe3 read value
    csrr x14, 0xfe3

    #Address 0xfe3 Write value 0xf2108779
    li x3, 0xf2108779
    csrw 0xfe3, x3

    #Address 0xfe3 read value
    csrr x14, 0xfe3

    #Unmapped address 0xbcc testing: Read Reset + Random data Write/Read
    #Address 0xbcc read value
    csrr x14, 0xbcc

    #Address 0xbcc Write value 0x6b6487f
    li x3, 0x6b6487f
    csrw 0xbcc, x3

    #Address 0xbcc read value
    csrr x14, 0xbcc

    #Unmapped address 0x2ca testing: Read Reset + Random data Write/Read
    #Address 0x2ca read value
    csrr x14, 0x2ca

    #Address 0x2ca Write value 0xbd1c81d8
    li x3, 0xbd1c81d8
    csrw 0x2ca, x3

    #Address 0x2ca read value
    csrr x14, 0x2ca

    #Unmapped address 0x66f testing: Read Reset + Random data Write/Read
    #Address 0x66f read value
    csrr x14, 0x66f

    #Address 0x66f Write value 0x9df928af
    li x3, 0x9df928af
    csrw 0x66f, x3

    #Address 0x66f read value
    csrr x14, 0x66f

    #Unmapped address 0x435 testing: Read Reset + Random data Write/Read
    #Address 0x435 read value
    csrr x14, 0x435

    #Address 0x435 Write value 0xa195fd78
    li x3, 0xa195fd78
    csrw 0x435, x3

    #Address 0x435 read value
    csrr x14, 0x435

    #Unmapped address 0x2eb testing: Read Reset + Random data Write/Read
    #Address 0x2eb read value
    csrr x14, 0x2eb

    #Address 0x2eb Write value 0xdc87601f
    li x3, 0xdc87601f
    csrw 0x2eb, x3

    #Address 0x2eb read value
    csrr x14, 0x2eb

    #Unmapped address 0xa6e testing: Read Reset + Random data Write/Read
    #Address 0xa6e read value
    csrr x14, 0xa6e

    #Address 0xa6e Write value 0xbdcb021e
    li x3, 0xbdcb021e
    csrw 0xa6e, x3

    #Address 0xa6e read value
    csrr x14, 0xa6e

    #Unmapped address 0x357 testing: Read Reset + Random data Write/Read
    #Address 0x357 read value
    csrr x14, 0x357

    #Address 0x357 Write value 0xe54f382b
    li x3, 0xe54f382b
    csrw 0x357, x3

    #Address 0x357 read value
    csrr x14, 0x357

    #Unmapped address 0x40f testing: Read Reset + Random data Write/Read
    #Address 0x40f read value
    csrr x14, 0x40f

    #Address 0x40f Write value 0x9dbb52c9
    li x3, 0x9dbb52c9
    csrw 0x40f, x3

    #Address 0x40f read value
    csrr x14, 0x40f

    #Unmapped address 0x3e3 testing: Read Reset + Random data Write/Read
    #Address 0x3e3 read value
    csrr x14, 0x3e3

    #Address 0x3e3 Write value 0xa4cd9d3d
    li x3, 0xa4cd9d3d
    csrw 0x3e3, x3

    #Address 0x3e3 read value
    csrr x14, 0x3e3

    #Unmapped address 0xa4e testing: Read Reset + Random data Write/Read
    #Address 0xa4e read value
    csrr x14, 0xa4e

    #Address 0xa4e Write value 0x5b0f0b18
    li x3, 0x5b0f0b18
    csrw 0xa4e, x3

    #Address 0xa4e read value
    csrr x14, 0xa4e

    #Unmapped address 0x810 testing: Read Reset + Random data Write/Read
    #Address 0x810 read value
    csrr x14, 0x810

    #Address 0x810 Write value 0xbd139513
    li x3, 0xbd139513
    csrw 0x810, x3

    #Address 0x810 read value
    csrr x14, 0x810

    #Unmapped address 0xe86 testing: Read Reset + Random data Write/Read
    #Address 0xe86 read value
    csrr x14, 0xe86

    #Address 0xe86 Write value 0x481cdac6
    li x3, 0x481cdac6
    csrw 0xe86, x3

    #Address 0xe86 read value
    csrr x14, 0xe86

    #Unmapped address 0x4ab testing: Read Reset + Random data Write/Read
    #Address 0x4ab read value
    csrr x14, 0x4ab

    #Address 0x4ab Write value 0x1c0c6614
    li x3, 0x1c0c6614
    csrw 0x4ab, x3

    #Address 0x4ab read value
    csrr x14, 0x4ab

    #Unmapped address 0x99f testing: Read Reset + Random data Write/Read
    #Address 0x99f read value
    csrr x14, 0x99f

    #Address 0x99f Write value 0xdfbc2433
    li x3, 0xdfbc2433
    csrw 0x99f, x3

    #Address 0x99f read value
    csrr x14, 0x99f

    #Unmapped address 0x7be testing: Read Reset + Random data Write/Read
    #Address 0x7be read value
    csrr x14, 0x7be

    #Address 0x7be Write value 0xfc169157
    li x3, 0xfc169157
    csrw 0x7be, x3

    #Address 0x7be read value
    csrr x14, 0x7be

    #Unmapped address 0xc97 testing: Read Reset + Random data Write/Read
    #Address 0xc97 read value
    csrr x14, 0xc97

    #Address 0xc97 Write value 0xc0987258
    li x3, 0xc0987258
    csrw 0xc97, x3

    #Address 0xc97 read value
    csrr x14, 0xc97

    #Unmapped address 0xe3c testing: Read Reset + Random data Write/Read
    #Address 0xe3c read value
    csrr x14, 0xe3c

    #Address 0xe3c Write value 0xf850a368
    li x3, 0xf850a368
    csrw 0xe3c, x3

    #Address 0xe3c read value
    csrr x14, 0xe3c

    #Unmapped address 0xc2d testing: Read Reset + Random data Write/Read
    #Address 0xc2d read value
    csrr x14, 0xc2d

    #Address 0xc2d Write value 0x677f6e46
    li x3, 0x677f6e46
    csrw 0xc2d, x3

    #Address 0xc2d read value
    csrr x14, 0xc2d

    #Unmapped address 0xf76 testing: Read Reset + Random data Write/Read
    #Address 0xf76 read value
    csrr x14, 0xf76

    #Address 0xf76 Write value 0x81b399d9
    li x3, 0x81b399d9
    csrw 0xf76, x3

    #Address 0xf76 read value
    csrr x14, 0xf76

    #Unmapped address 0xc13 testing: Read Reset + Random data Write/Read
    #Address 0xc13 read value
    csrr x14, 0xc13

    #Address 0xc13 Write value 0xfc95483c
    li x3, 0xfc95483c
    csrw 0xc13, x3

    #Address 0xc13 read value
    csrr x14, 0xc13

    #Unmapped address 0x782 testing: Read Reset + Random data Write/Read
    #Address 0x782 read value
    csrr x14, 0x782

    #Address 0x782 Write value 0x64e8fd65
    li x3, 0x64e8fd65
    csrw 0x782, x3

    #Address 0x782 read value
    csrr x14, 0x782

    #Unmapped address 0xdea testing: Read Reset + Random data Write/Read
    #Address 0xdea read value
    csrr x14, 0xdea

    #Address 0xdea Write value 0x7be90986
    li x3, 0x7be90986
    csrw 0xdea, x3

    #Address 0xdea read value
    csrr x14, 0xdea

    #Unmapped address 0x548 testing: Read Reset + Random data Write/Read
    #Address 0x548 read value
    csrr x14, 0x548

    #Address 0x548 Write value 0x2601a77a
    li x3, 0x2601a77a
    csrw 0x548, x3

    #Address 0x548 read value
    csrr x14, 0x548

    #Unmapped address 0x261 testing: Read Reset + Random data Write/Read
    #Address 0x261 read value
    csrr x14, 0x261

    #Address 0x261 Write value 0xc92002c9
    li x3, 0xc92002c9
    csrw 0x261, x3

    #Address 0x261 read value
    csrr x14, 0x261

    #Unmapped address 0xfab testing: Read Reset + Random data Write/Read
    #Address 0xfab read value
    csrr x14, 0xfab

    #Address 0xfab Write value 0xb7dbf39c
    li x3, 0xb7dbf39c
    csrw 0xfab, x3

    #Address 0xfab read value
    csrr x14, 0xfab

    #Unmapped address 0xd7b testing: Read Reset + Random data Write/Read
    #Address 0xd7b read value
    csrr x14, 0xd7b

    #Address 0xd7b Write value 0xe53d658a
    li x3, 0xe53d658a
    csrw 0xd7b, x3

    #Address 0xd7b read value
    csrr x14, 0xd7b

    #Unmapped address 0xf7b testing: Read Reset + Random data Write/Read
    #Address 0xf7b read value
    csrr x14, 0xf7b

    #Address 0xf7b Write value 0xce5389cb
    li x3, 0xce5389cb
    csrw 0xf7b, x3

    #Address 0xf7b read value
    csrr x14, 0xf7b

    #Unmapped address 0xb4f testing: Read Reset + Random data Write/Read
    #Address 0xb4f read value
    csrr x14, 0xb4f

    #Address 0xb4f Write value 0x121d6ac
    li x3, 0x121d6ac
    csrw 0xb4f, x3

    #Address 0xb4f read value
    csrr x14, 0xb4f

    #Unmapped address 0x431 testing: Read Reset + Random data Write/Read
    #Address 0x431 read value
    csrr x14, 0x431

    #Address 0x431 Write value 0x1572b1d7
    li x3, 0x1572b1d7
    csrw 0x431, x3

    #Address 0x431 read value
    csrr x14, 0x431

    #Unmapped address 0x8f0 testing: Read Reset + Random data Write/Read
    #Address 0x8f0 read value
    csrr x14, 0x8f0

    #Address 0x8f0 Write value 0xf7db2caf
    li x3, 0xf7db2caf
    csrw 0x8f0, x3

    #Address 0x8f0 read value
    csrr x14, 0x8f0

    #Unmapped address 0x2c1 testing: Read Reset + Random data Write/Read
    #Address 0x2c1 read value
    csrr x14, 0x2c1

    #Address 0x2c1 Write value 0x11799489
    li x3, 0x11799489
    csrw 0x2c1, x3

    #Address 0x2c1 read value
    csrr x14, 0x2c1

    #Unmapped address 0x3d4 testing: Read Reset + Random data Write/Read
    #Address 0x3d4 read value
    csrr x14, 0x3d4

    #Address 0x3d4 Write value 0x717ccb04
    li x3, 0x717ccb04
    csrw 0x3d4, x3

    #Address 0x3d4 read value
    csrr x14, 0x3d4

    #Unmapped address 0x69d testing: Read Reset + Random data Write/Read
    #Address 0x69d read value
    csrr x14, 0x69d

    #Address 0x69d Write value 0x179ce55d
    li x3, 0x179ce55d
    csrw 0x69d, x3

    #Address 0x69d read value
    csrr x14, 0x69d

    #Unmapped address 0xc98 testing: Read Reset + Random data Write/Read
    #Address 0xc98 read value
    csrr x14, 0xc98

    #Address 0xc98 Write value 0xb84c6f94
    li x3, 0xb84c6f94
    csrw 0xc98, x3

    #Address 0xc98 read value
    csrr x14, 0xc98

    #Unmapped address 0xbb5 testing: Read Reset + Random data Write/Read
    #Address 0xbb5 read value
    csrr x14, 0xbb5

    #Address 0xbb5 Write value 0x6ffe7660
    li x3, 0x6ffe7660
    csrw 0xbb5, x3

    #Address 0xbb5 read value
    csrr x14, 0xbb5

    #Unmapped address 0xdb4 testing: Read Reset + Random data Write/Read
    #Address 0xdb4 read value
    csrr x14, 0xdb4

    #Address 0xdb4 Write value 0xe504b9a7
    li x3, 0xe504b9a7
    csrw 0xdb4, x3

    #Address 0xdb4 read value
    csrr x14, 0xdb4

    #Unmapped address 0x2a testing: Read Reset + Random data Write/Read
    #Address 0x2a read value
    csrr x14, 0x2a

    #Address 0x2a Write value 0x723171a7
    li x3, 0x723171a7
    csrw 0x2a, x3

    #Address 0x2a read value
    csrr x14, 0x2a

    #Unmapped address 0xb74 testing: Read Reset + Random data Write/Read
    #Address 0xb74 read value
    csrr x14, 0xb74

    #Address 0xb74 Write value 0x2ad6899f
    li x3, 0x2ad6899f
    csrw 0xb74, x3

    #Address 0xb74 read value
    csrr x14, 0xb74

    #Unmapped address 0x7d6 testing: Read Reset + Random data Write/Read
    #Address 0x7d6 read value
    csrr x14, 0x7d6

    #Address 0x7d6 Write value 0x54e57862
    li x3, 0x54e57862
    csrw 0x7d6, x3

    #Address 0x7d6 read value
    csrr x14, 0x7d6

    #Unmapped address 0xd60 testing: Read Reset + Random data Write/Read
    #Address 0xd60 read value
    csrr x14, 0xd60

    #Address 0xd60 Write value 0xb7b22153
    li x3, 0xb7b22153
    csrw 0xd60, x3

    #Address 0xd60 read value
    csrr x14, 0xd60

    #Unmapped address 0xd75 testing: Read Reset + Random data Write/Read
    #Address 0xd75 read value
    csrr x14, 0xd75

    #Address 0xd75 Write value 0x6a960a75
    li x3, 0x6a960a75
    csrw 0xd75, x3

    #Address 0xd75 read value
    csrr x14, 0xd75

    #Unmapped address 0x842 testing: Read Reset + Random data Write/Read
    #Address 0x842 read value
    csrr x14, 0x842

    #Address 0x842 Write value 0xeef6e8ee
    li x3, 0xeef6e8ee
    csrw 0x842, x3

    #Address 0x842 read value
    csrr x14, 0x842

    #Unmapped address 0x21e testing: Read Reset + Random data Write/Read
    #Address 0x21e read value
    csrr x14, 0x21e

    #Address 0x21e Write value 0xfd5318d0
    li x3, 0xfd5318d0
    csrw 0x21e, x3

    #Address 0x21e read value
    csrr x14, 0x21e

    #Unmapped address 0x312 testing: Read Reset + Random data Write/Read
    #Address 0x312 read value
    csrr x14, 0x312

    #Address 0x312 Write value 0x518a777b
    li x3, 0x518a777b
    csrw 0x312, x3

    #Address 0x312 read value
    csrr x14, 0x312

    #Unmapped address 0x80f testing: Read Reset + Random data Write/Read
    #Address 0x80f read value
    csrr x14, 0x80f

    #Address 0x80f Write value 0x9bf650de
    li x3, 0x9bf650de
    csrw 0x80f, x3

    #Address 0x80f read value
    csrr x14, 0x80f

    #Unmapped address 0xebc testing: Read Reset + Random data Write/Read
    #Address 0xebc read value
    csrr x14, 0xebc

    #Address 0xebc Write value 0x6b2875c9
    li x3, 0x6b2875c9
    csrw 0xebc, x3

    #Address 0xebc read value
    csrr x14, 0xebc

    #Unmapped address 0xaf6 testing: Read Reset + Random data Write/Read
    #Address 0xaf6 read value
    csrr x14, 0xaf6

    #Address 0xaf6 Write value 0xb45b6b5e
    li x3, 0xb45b6b5e
    csrw 0xaf6, x3

    #Address 0xaf6 read value
    csrr x14, 0xaf6

    #Unmapped address 0x9d testing: Read Reset + Random data Write/Read
    #Address 0x9d read value
    csrr x14, 0x9d

    #Address 0x9d Write value 0x7ec1051c
    li x3, 0x7ec1051c
    csrw 0x9d, x3

    #Address 0x9d read value
    csrr x14, 0x9d

    #Unmapped address 0x755 testing: Read Reset + Random data Write/Read
    #Address 0x755 read value
    csrr x14, 0x755

    #Address 0x755 Write value 0x7d58ebb2
    li x3, 0x7d58ebb2
    csrw 0x755, x3

    #Address 0x755 read value
    csrr x14, 0x755

    #Unmapped address 0x1d5 testing: Read Reset + Random data Write/Read
    #Address 0x1d5 read value
    csrr x14, 0x1d5

    #Address 0x1d5 Write value 0x4a1e6b61
    li x3, 0x4a1e6b61
    csrw 0x1d5, x3

    #Address 0x1d5 read value
    csrr x14, 0x1d5

    #Unmapped address 0xffc testing: Read Reset + Random data Write/Read
    #Address 0xffc read value
    csrr x14, 0xffc

    #Address 0xffc Write value 0xb334f35b
    li x3, 0xb334f35b
    csrw 0xffc, x3

    #Address 0xffc read value
    csrr x14, 0xffc

    #Unmapped address 0xd1b testing: Read Reset + Random data Write/Read
    #Address 0xd1b read value
    csrr x14, 0xd1b

    #Address 0xd1b Write value 0x74c7a244
    li x3, 0x74c7a244
    csrw 0xd1b, x3

    #Address 0xd1b read value
    csrr x14, 0xd1b

    #Unmapped address 0x3f3 testing: Read Reset + Random data Write/Read
    #Address 0x3f3 read value
    csrr x14, 0x3f3

    #Address 0x3f3 Write value 0x9dca81fb
    li x3, 0x9dca81fb
    csrw 0x3f3, x3

    #Address 0x3f3 read value
    csrr x14, 0x3f3

    #Unmapped address 0xc87 testing: Read Reset + Random data Write/Read
    #Address 0xc87 read value
    csrr x14, 0xc87

    #Address 0xc87 Write value 0x99a09647
    li x3, 0x99a09647
    csrw 0xc87, x3

    #Address 0xc87 read value
    csrr x14, 0xc87

    #Unmapped address 0xab testing: Read Reset + Random data Write/Read
    #Address 0xab read value
    csrr x14, 0xab

    #Address 0xab Write value 0xbe303e62
    li x3, 0xbe303e62
    csrw 0xab, x3

    #Address 0xab read value
    csrr x14, 0xab

    #Unmapped address 0xf74 testing: Read Reset + Random data Write/Read
    #Address 0xf74 read value
    csrr x14, 0xf74

    #Address 0xf74 Write value 0x5fb0d80
    li x3, 0x5fb0d80
    csrw 0xf74, x3

    #Address 0xf74 read value
    csrr x14, 0xf74

    #Unmapped address 0xd42 testing: Read Reset + Random data Write/Read
    #Address 0xd42 read value
    csrr x14, 0xd42

    #Address 0xd42 Write value 0xb5d7f743
    li x3, 0xb5d7f743
    csrw 0xd42, x3

    #Address 0xd42 read value
    csrr x14, 0xd42

    #Unmapped address 0xfe5 testing: Read Reset + Random data Write/Read
    #Address 0xfe5 read value
    csrr x14, 0xfe5

    #Address 0xfe5 Write value 0x4ba35b7b
    li x3, 0x4ba35b7b
    csrw 0xfe5, x3

    #Address 0xfe5 read value
    csrr x14, 0xfe5

    #Unmapped address 0x518 testing: Read Reset + Random data Write/Read
    #Address 0x518 read value
    csrr x14, 0x518

    #Address 0x518 Write value 0xf5e92618
    li x3, 0xf5e92618
    csrw 0x518, x3

    #Address 0x518 read value
    csrr x14, 0x518

    #Unmapped address 0xdba testing: Read Reset + Random data Write/Read
    #Address 0xdba read value
    csrr x14, 0xdba

    #Address 0xdba Write value 0xcd1472d3
    li x3, 0xcd1472d3
    csrw 0xdba, x3

    #Address 0xdba read value
    csrr x14, 0xdba

    #Unmapped address 0x513 testing: Read Reset + Random data Write/Read
    #Address 0x513 read value
    csrr x14, 0x513

    #Address 0x513 Write value 0xab03ca1a
    li x3, 0xab03ca1a
    csrw 0x513, x3

    #Address 0x513 read value
    csrr x14, 0x513

    #Unmapped address 0x445 testing: Read Reset + Random data Write/Read
    #Address 0x445 read value
    csrr x14, 0x445

    #Address 0x445 Write value 0x607679f0
    li x3, 0x607679f0
    csrw 0x445, x3

    #Address 0x445 read value
    csrr x14, 0x445

    #Unmapped address 0xca testing: Read Reset + Random data Write/Read
    #Address 0xca read value
    csrr x14, 0xca

    #Address 0xca Write value 0x950f29f8
    li x3, 0x950f29f8
    csrw 0xca, x3

    #Address 0xca read value
    csrr x14, 0xca

    #Unmapped address 0xc7b testing: Read Reset + Random data Write/Read
    #Address 0xc7b read value
    csrr x14, 0xc7b

    #Address 0xc7b Write value 0x25a58e5e
    li x3, 0x25a58e5e
    csrw 0xc7b, x3

    #Address 0xc7b read value
    csrr x14, 0xc7b

    #Unmapped address 0xc04 testing: Read Reset + Random data Write/Read
    #Address 0xc04 read value
    csrr x14, 0xc04

    #Address 0xc04 Write value 0xbc4c129
    li x3, 0xbc4c129
    csrw 0xc04, x3

    #Address 0xc04 read value
    csrr x14, 0xc04

    #Unmapped address 0x43c testing: Read Reset + Random data Write/Read
    #Address 0x43c read value
    csrr x14, 0x43c

    #Address 0x43c Write value 0x80240c3c
    li x3, 0x80240c3c
    csrw 0x43c, x3

    #Address 0x43c read value
    csrr x14, 0x43c

    #Unmapped address 0x6bc testing: Read Reset + Random data Write/Read
    #Address 0x6bc read value
    csrr x14, 0x6bc

    #Address 0x6bc Write value 0xa02be7a3
    li x3, 0xa02be7a3
    csrw 0x6bc, x3

    #Address 0x6bc read value
    csrr x14, 0x6bc

    #Unmapped address 0x5a7 testing: Read Reset + Random data Write/Read
    #Address 0x5a7 read value
    csrr x14, 0x5a7

    #Address 0x5a7 Write value 0x70ff3817
    li x3, 0x70ff3817
    csrw 0x5a7, x3

    #Address 0x5a7 read value
    csrr x14, 0x5a7

    #Unmapped address 0x776 testing: Read Reset + Random data Write/Read
    #Address 0x776 read value
    csrr x14, 0x776

    #Address 0x776 Write value 0xf869f40e
    li x3, 0xf869f40e
    csrw 0x776, x3

    #Address 0x776 read value
    csrr x14, 0x776

    #Unmapped address 0x38f testing: Read Reset + Random data Write/Read
    #Address 0x38f read value
    csrr x14, 0x38f

    #Address 0x38f Write value 0x2fd71ee7
    li x3, 0x2fd71ee7
    csrw 0x38f, x3

    #Address 0x38f read value
    csrr x14, 0x38f

    #Unmapped address 0xe14 testing: Read Reset + Random data Write/Read
    #Address 0xe14 read value
    csrr x14, 0xe14

    #Address 0xe14 Write value 0xe69e070b
    li x3, 0xe69e070b
    csrw 0xe14, x3

    #Address 0xe14 read value
    csrr x14, 0xe14

    #Unmapped address 0x359 testing: Read Reset + Random data Write/Read
    #Address 0x359 read value
    csrr x14, 0x359

    #Address 0x359 Write value 0x2f1aaeef
    li x3, 0x2f1aaeef
    csrw 0x359, x3

    #Address 0x359 read value
    csrr x14, 0x359

    #Unmapped address 0x89f testing: Read Reset + Random data Write/Read
    #Address 0x89f read value
    csrr x14, 0x89f

    #Address 0x89f Write value 0xc0002559
    li x3, 0xc0002559
    csrw 0x89f, x3

    #Address 0x89f read value
    csrr x14, 0x89f

    #Unmapped address 0xa4d testing: Read Reset + Random data Write/Read
    #Address 0xa4d read value
    csrr x14, 0xa4d

    #Address 0xa4d Write value 0x6c57dd2c
    li x3, 0x6c57dd2c
    csrw 0xa4d, x3

    #Address 0xa4d read value
    csrr x14, 0xa4d

    #Unmapped address 0xf59 testing: Read Reset + Random data Write/Read
    #Address 0xf59 read value
    csrr x14, 0xf59

    #Address 0xf59 Write value 0x10ee0c73
    li x3, 0x10ee0c73
    csrw 0xf59, x3

    #Address 0xf59 read value
    csrr x14, 0xf59

    #Unmapped address 0x573 testing: Read Reset + Random data Write/Read
    #Address 0x573 read value
    csrr x14, 0x573

    #Address 0x573 Write value 0xd777eaba
    li x3, 0xd777eaba
    csrw 0x573, x3

    #Address 0x573 read value
    csrr x14, 0x573

    #Unmapped address 0x8b1 testing: Read Reset + Random data Write/Read
    #Address 0x8b1 read value
    csrr x14, 0x8b1

    #Address 0x8b1 Write value 0x727e8a5f
    li x3, 0x727e8a5f
    csrw 0x8b1, x3

    #Address 0x8b1 read value
    csrr x14, 0x8b1

    #Unmapped address 0x8e2 testing: Read Reset + Random data Write/Read
    #Address 0x8e2 read value
    csrr x14, 0x8e2

    #Address 0x8e2 Write value 0xc3ae3fd1
    li x3, 0xc3ae3fd1
    csrw 0x8e2, x3

    #Address 0x8e2 read value
    csrr x14, 0x8e2

    #Unmapped address 0x368 testing: Read Reset + Random data Write/Read
    #Address 0x368 read value
    csrr x14, 0x368

    #Address 0x368 Write value 0x149bbab0
    li x3, 0x149bbab0
    csrw 0x368, x3

    #Address 0x368 read value
    csrr x14, 0x368

    #Unmapped address 0xc7c testing: Read Reset + Random data Write/Read
    #Address 0xc7c read value
    csrr x14, 0xc7c

    #Address 0xc7c Write value 0xe9ce181f
    li x3, 0xe9ce181f
    csrw 0xc7c, x3

    #Address 0xc7c read value
    csrr x14, 0xc7c

    #Unmapped address 0xb25 testing: Read Reset + Random data Write/Read
    #Address 0xb25 read value
    csrr x14, 0xb25

    #Address 0xb25 Write value 0x8450c3f5
    li x3, 0x8450c3f5
    csrw 0xb25, x3

    #Address 0xb25 read value
    csrr x14, 0xb25

    #Unmapped address 0x43e testing: Read Reset + Random data Write/Read
    #Address 0x43e read value
    csrr x14, 0x43e

    #Address 0x43e Write value 0x4ca7b0d7
    li x3, 0x4ca7b0d7
    csrw 0x43e, x3

    #Address 0x43e read value
    csrr x14, 0x43e

    #Unmapped address 0x1e7 testing: Read Reset + Random data Write/Read
    #Address 0x1e7 read value
    csrr x14, 0x1e7

    #Address 0x1e7 Write value 0x93bd5953
    li x3, 0x93bd5953
    csrw 0x1e7, x3

    #Address 0x1e7 read value
    csrr x14, 0x1e7

    #Unmapped address 0xbe5 testing: Read Reset + Random data Write/Read
    #Address 0xbe5 read value
    csrr x14, 0xbe5

    #Address 0xbe5 Write value 0x2b8a70d7
    li x3, 0x2b8a70d7
    csrw 0xbe5, x3

    #Address 0xbe5 read value
    csrr x14, 0xbe5

    #Unmapped address 0xb5c testing: Read Reset + Random data Write/Read
    #Address 0xb5c read value
    csrr x14, 0xb5c

    #Address 0xb5c Write value 0x7502f092
    li x3, 0x7502f092
    csrw 0xb5c, x3

    #Address 0xb5c read value
    csrr x14, 0xb5c

    #Unmapped address 0x958 testing: Read Reset + Random data Write/Read
    #Address 0x958 read value
    csrr x14, 0x958

    #Address 0x958 Write value 0x72849cf7
    li x3, 0x72849cf7
    csrw 0x958, x3

    #Address 0x958 read value
    csrr x14, 0x958

    #Unmapped address 0x51f testing: Read Reset + Random data Write/Read
    #Address 0x51f read value
    csrr x14, 0x51f

    #Address 0x51f Write value 0x988620d1
    li x3, 0x988620d1
    csrw 0x51f, x3

    #Address 0x51f read value
    csrr x14, 0x51f

    #Unmapped address 0xe5a testing: Read Reset + Random data Write/Read
    #Address 0xe5a read value
    csrr x14, 0xe5a

    #Address 0xe5a Write value 0xc0f0c043
    li x3, 0xc0f0c043
    csrw 0xe5a, x3

    #Address 0xe5a read value
    csrr x14, 0xe5a

    #Unmapped address 0x4c5 testing: Read Reset + Random data Write/Read
    #Address 0x4c5 read value
    csrr x14, 0x4c5

    #Address 0x4c5 Write value 0x62d946ef
    li x3, 0x62d946ef
    csrw 0x4c5, x3

    #Address 0x4c5 read value
    csrr x14, 0x4c5

    #Unmapped address 0x48c testing: Read Reset + Random data Write/Read
    #Address 0x48c read value
    csrr x14, 0x48c

    #Address 0x48c Write value 0x32d0fa22
    li x3, 0x32d0fa22
    csrw 0x48c, x3

    #Address 0x48c read value
    csrr x14, 0x48c

    #Unmapped address 0xab7 testing: Read Reset + Random data Write/Read
    #Address 0xab7 read value
    csrr x14, 0xab7

    #Address 0xab7 Write value 0x2520f44a
    li x3, 0x2520f44a
    csrw 0xab7, x3

    #Address 0xab7 read value
    csrr x14, 0xab7

    #Unmapped address 0x60 testing: Read Reset + Random data Write/Read
    #Address 0x60 read value
    csrr x14, 0x60

    #Address 0x60 Write value 0xaf60e808
    li x3, 0xaf60e808
    csrw 0x60, x3

    #Address 0x60 read value
    csrr x14, 0x60

    #Unmapped address 0xa99 testing: Read Reset + Random data Write/Read
    #Address 0xa99 read value
    csrr x14, 0xa99

    #Address 0xa99 Write value 0x904dbf3c
    li x3, 0x904dbf3c
    csrw 0xa99, x3

    #Address 0xa99 read value
    csrr x14, 0xa99

    #Unmapped address 0xb56 testing: Read Reset + Random data Write/Read
    #Address 0xb56 read value
    csrr x14, 0xb56

    #Address 0xb56 Write value 0x27efb267
    li x3, 0x27efb267
    csrw 0xb56, x3

    #Address 0xb56 read value
    csrr x14, 0xb56

    #Unmapped address 0xb33 testing: Read Reset + Random data Write/Read
    #Address 0xb33 read value
    csrr x14, 0xb33

    #Address 0xb33 Write value 0xab3cc6e
    li x3, 0xab3cc6e
    csrw 0xb33, x3

    #Address 0xb33 read value
    csrr x14, 0xb33

    #Unmapped address 0x1b5 testing: Read Reset + Random data Write/Read
    #Address 0x1b5 read value
    csrr x14, 0x1b5

    #Address 0x1b5 Write value 0x886b046b
    li x3, 0x886b046b
    csrw 0x1b5, x3

    #Address 0x1b5 read value
    csrr x14, 0x1b5

    #Unmapped address 0xf22 testing: Read Reset + Random data Write/Read
    #Address 0xf22 read value
    csrr x14, 0xf22

    #Address 0xf22 Write value 0x4b8010fc
    li x3, 0x4b8010fc
    csrw 0xf22, x3

    #Address 0xf22 read value
    csrr x14, 0xf22

    #Unmapped address 0x234 testing: Read Reset + Random data Write/Read
    #Address 0x234 read value
    csrr x14, 0x234

    #Address 0x234 Write value 0x2c425e39
    li x3, 0x2c425e39
    csrw 0x234, x3

    #Address 0x234 read value
    csrr x14, 0x234

    #Unmapped address 0x5a1 testing: Read Reset + Random data Write/Read
    #Address 0x5a1 read value
    csrr x14, 0x5a1

    #Address 0x5a1 Write value 0x87b99964
    li x3, 0x87b99964
    csrw 0x5a1, x3

    #Address 0x5a1 read value
    csrr x14, 0x5a1

    #Unmapped address 0x489 testing: Read Reset + Random data Write/Read
    #Address 0x489 read value
    csrr x14, 0x489

    #Address 0x489 Write value 0xbb8efcf7
    li x3, 0xbb8efcf7
    csrw 0x489, x3

    #Address 0x489 read value
    csrr x14, 0x489

    #Unmapped address 0x52f testing: Read Reset + Random data Write/Read
    #Address 0x52f read value
    csrr x14, 0x52f

    #Address 0x52f Write value 0x68835d82
    li x3, 0x68835d82
    csrw 0x52f, x3

    #Address 0x52f read value
    csrr x14, 0x52f

    #Unmapped address 0x834 testing: Read Reset + Random data Write/Read
    #Address 0x834 read value
    csrr x14, 0x834

    #Address 0x834 Write value 0xdfa8d23b
    li x3, 0xdfa8d23b
    csrw 0x834, x3

    #Address 0x834 read value
    csrr x14, 0x834

    #Unmapped address 0xea5 testing: Read Reset + Random data Write/Read
    #Address 0xea5 read value
    csrr x14, 0xea5

    #Address 0xea5 Write value 0x156139b8
    li x3, 0x156139b8
    csrw 0xea5, x3

    #Address 0xea5 read value
    csrr x14, 0xea5

    #Unmapped address 0x3df testing: Read Reset + Random data Write/Read
    #Address 0x3df read value
    csrr x14, 0x3df

    #Address 0x3df Write value 0x5f0ba11a
    li x3, 0x5f0ba11a
    csrw 0x3df, x3

    #Address 0x3df read value
    csrr x14, 0x3df

    #Unmapped address 0x56 testing: Read Reset + Random data Write/Read
    #Address 0x56 read value
    csrr x14, 0x56

    #Address 0x56 Write value 0x3a8260d0
    li x3, 0x3a8260d0
    csrw 0x56, x3

    #Address 0x56 read value
    csrr x14, 0x56

    #Unmapped address 0x802 testing: Read Reset + Random data Write/Read
    #Address 0x802 read value
    csrr x14, 0x802

    #Address 0x802 Write value 0x70512707
    li x3, 0x70512707
    csrw 0x802, x3

    #Address 0x802 read value
    csrr x14, 0x802

    #Unmapped address 0xe5b testing: Read Reset + Random data Write/Read
    #Address 0xe5b read value
    csrr x14, 0xe5b

    #Address 0xe5b Write value 0x3086f87c
    li x3, 0x3086f87c
    csrw 0xe5b, x3

    #Address 0xe5b read value
    csrr x14, 0xe5b

    #Unmapped address 0xb50 testing: Read Reset + Random data Write/Read
    #Address 0xb50 read value
    csrr x14, 0xb50

    #Address 0xb50 Write value 0x5980b6bb
    li x3, 0x5980b6bb
    csrw 0xb50, x3

    #Address 0xb50 read value
    csrr x14, 0xb50

    #Unmapped address 0xbb0 testing: Read Reset + Random data Write/Read
    #Address 0xbb0 read value
    csrr x14, 0xbb0

    #Address 0xbb0 Write value 0xcf2666d3
    li x3, 0xcf2666d3
    csrw 0xbb0, x3

    #Address 0xbb0 read value
    csrr x14, 0xbb0

    #Unmapped address 0xc61 testing: Read Reset + Random data Write/Read
    #Address 0xc61 read value
    csrr x14, 0xc61

    #Address 0xc61 Write value 0xa6e046c8
    li x3, 0xa6e046c8
    csrw 0xc61, x3

    #Address 0xc61 read value
    csrr x14, 0xc61

    #Unmapped address 0x59b testing: Read Reset + Random data Write/Read
    #Address 0x59b read value
    csrr x14, 0x59b

    #Address 0x59b Write value 0x76af7857
    li x3, 0x76af7857
    csrw 0x59b, x3

    #Address 0x59b read value
    csrr x14, 0x59b

    #Unmapped address 0xf36 testing: Read Reset + Random data Write/Read
    #Address 0xf36 read value
    csrr x14, 0xf36

    #Address 0xf36 Write value 0x6eef18ca
    li x3, 0x6eef18ca
    csrw 0xf36, x3

    #Address 0xf36 read value
    csrr x14, 0xf36

    #Unmapped address 0xf2c testing: Read Reset + Random data Write/Read
    #Address 0xf2c read value
    csrr x14, 0xf2c

    #Address 0xf2c Write value 0xcba9f1a0
    li x3, 0xcba9f1a0
    csrw 0xf2c, x3

    #Address 0xf2c read value
    csrr x14, 0xf2c

    #Unmapped address 0x75a testing: Read Reset + Random data Write/Read
    #Address 0x75a read value
    csrr x14, 0x75a

    #Address 0x75a Write value 0xc2b65ca6
    li x3, 0xc2b65ca6
    csrw 0x75a, x3

    #Address 0x75a read value
    csrr x14, 0x75a

    #Unmapped address 0x95 testing: Read Reset + Random data Write/Read
    #Address 0x95 read value
    csrr x14, 0x95

    #Address 0x95 Write value 0x980f3d1b
    li x3, 0x980f3d1b
    csrw 0x95, x3

    #Address 0x95 read value
    csrr x14, 0x95

    #Unmapped address 0xf44 testing: Read Reset + Random data Write/Read
    #Address 0xf44 read value
    csrr x14, 0xf44

    #Address 0xf44 Write value 0x23e77018
    li x3, 0x23e77018
    csrw 0xf44, x3

    #Address 0xf44 read value
    csrr x14, 0xf44

    #Unmapped address 0x9da testing: Read Reset + Random data Write/Read
    #Address 0x9da read value
    csrr x14, 0x9da

    #Address 0x9da Write value 0xb4600a97
    li x3, 0xb4600a97
    csrw 0x9da, x3

    #Address 0x9da read value
    csrr x14, 0x9da

    #Unmapped address 0x1e6 testing: Read Reset + Random data Write/Read
    #Address 0x1e6 read value
    csrr x14, 0x1e6

    #Address 0x1e6 Write value 0xe9891e28
    li x3, 0xe9891e28
    csrw 0x1e6, x3

    #Address 0x1e6 read value
    csrr x14, 0x1e6

    #Unmapped address 0x185 testing: Read Reset + Random data Write/Read
    #Address 0x185 read value
    csrr x14, 0x185

    #Address 0x185 Write value 0x1b40117e
    li x3, 0x1b40117e
    csrw 0x185, x3

    #Address 0x185 read value
    csrr x14, 0x185

    #Unmapped address 0x93b testing: Read Reset + Random data Write/Read
    #Address 0x93b read value
    csrr x14, 0x93b

    #Address 0x93b Write value 0x1525b7cb
    li x3, 0x1525b7cb
    csrw 0x93b, x3

    #Address 0x93b read value
    csrr x14, 0x93b

    #Unmapped address 0x381 testing: Read Reset + Random data Write/Read
    #Address 0x381 read value
    csrr x14, 0x381

    #Address 0x381 Write value 0x78d0f7bd
    li x3, 0x78d0f7bd
    csrw 0x381, x3

    #Address 0x381 read value
    csrr x14, 0x381

    #Unmapped address 0x5ac testing: Read Reset + Random data Write/Read
    #Address 0x5ac read value
    csrr x14, 0x5ac

    #Address 0x5ac Write value 0x8433351f
    li x3, 0x8433351f
    csrw 0x5ac, x3

    #Address 0x5ac read value
    csrr x14, 0x5ac

    #Unmapped address 0x1e9 testing: Read Reset + Random data Write/Read
    #Address 0x1e9 read value
    csrr x14, 0x1e9

    #Address 0x1e9 Write value 0xb618f972
    li x3, 0xb618f972
    csrw 0x1e9, x3

    #Address 0x1e9 read value
    csrr x14, 0x1e9

    #Unmapped address 0xcd3 testing: Read Reset + Random data Write/Read
    #Address 0xcd3 read value
    csrr x14, 0xcd3

    #Address 0xcd3 Write value 0xa110701e
    li x3, 0xa110701e
    csrw 0xcd3, x3

    #Address 0xcd3 read value
    csrr x14, 0xcd3

    #Unmapped address 0x61d testing: Read Reset + Random data Write/Read
    #Address 0x61d read value
    csrr x14, 0x61d

    #Address 0x61d Write value 0x11e1db31
    li x3, 0x11e1db31
    csrw 0x61d, x3

    #Address 0x61d read value
    csrr x14, 0x61d

    #Unmapped address 0x7a1 testing: Read Reset + Random data Write/Read
    #Address 0x7a1 read value
    csrr x14, 0x7a1

    #Address 0x7a1 Write value 0xd9b15895
    li x3, 0xd9b15895
    csrw 0x7a1, x3

    #Address 0x7a1 read value
    csrr x14, 0x7a1

    #Unmapped address 0xc9a testing: Read Reset + Random data Write/Read
    #Address 0xc9a read value
    csrr x14, 0xc9a

    #Address 0xc9a Write value 0xda525cca
    li x3, 0xda525cca
    csrw 0xc9a, x3

    #Address 0xc9a read value
    csrr x14, 0xc9a

    #Unmapped address 0x728 testing: Read Reset + Random data Write/Read
    #Address 0x728 read value
    csrr x14, 0x728

    #Address 0x728 Write value 0x5aa21999
    li x3, 0x5aa21999
    csrw 0x728, x3

    #Address 0x728 read value
    csrr x14, 0x728

    #Unmapped address 0x302 testing: Read Reset + Random data Write/Read
    #Address 0x302 read value
    csrr x14, 0x302

    #Address 0x302 Write value 0xd620e544
    li x3, 0xd620e544
    csrw 0x302, x3

    #Address 0x302 read value
    csrr x14, 0x302

    #Unmapped address 0x2b9 testing: Read Reset + Random data Write/Read
    #Address 0x2b9 read value
    csrr x14, 0x2b9

    #Address 0x2b9 Write value 0x7e42cc49
    li x3, 0x7e42cc49
    csrw 0x2b9, x3

    #Address 0x2b9 read value
    csrr x14, 0x2b9

    #Unmapped address 0x397 testing: Read Reset + Random data Write/Read
    #Address 0x397 read value
    csrr x14, 0x397

    #Address 0x397 Write value 0xdc06bfe5
    li x3, 0xdc06bfe5
    csrw 0x397, x3

    #Address 0x397 read value
    csrr x14, 0x397

    #Unmapped address 0xfb1 testing: Read Reset + Random data Write/Read
    #Address 0xfb1 read value
    csrr x14, 0xfb1

    #Address 0xfb1 Write value 0x8573f9a0
    li x3, 0x8573f9a0
    csrw 0xfb1, x3

    #Address 0xfb1 read value
    csrr x14, 0xfb1

    #Unmapped address 0x73d testing: Read Reset + Random data Write/Read
    #Address 0x73d read value
    csrr x14, 0x73d

    #Address 0x73d Write value 0xe81e96df
    li x3, 0xe81e96df
    csrw 0x73d, x3

    #Address 0x73d read value
    csrr x14, 0x73d

    #Unmapped address 0x87b testing: Read Reset + Random data Write/Read
    #Address 0x87b read value
    csrr x14, 0x87b

    #Address 0x87b Write value 0x65fc5454
    li x3, 0x65fc5454
    csrw 0x87b, x3

    #Address 0x87b read value
    csrr x14, 0x87b

    #Unmapped address 0xe13 testing: Read Reset + Random data Write/Read
    #Address 0xe13 read value
    csrr x14, 0xe13

    #Address 0xe13 Write value 0x66153c4c
    li x3, 0x66153c4c
    csrw 0xe13, x3

    #Address 0xe13 read value
    csrr x14, 0xe13

    #Unmapped address 0x9f5 testing: Read Reset + Random data Write/Read
    #Address 0x9f5 read value
    csrr x14, 0x9f5

    #Address 0x9f5 Write value 0xe184f6ff
    li x3, 0xe184f6ff
    csrw 0x9f5, x3

    #Address 0x9f5 read value
    csrr x14, 0x9f5

    #Unmapped address 0xc1c testing: Read Reset + Random data Write/Read
    #Address 0xc1c read value
    csrr x14, 0xc1c

    #Address 0xc1c Write value 0x6d7b9493
    li x3, 0x6d7b9493
    csrw 0xc1c, x3

    #Address 0xc1c read value
    csrr x14, 0xc1c

    #Unmapped address 0xf15 testing: Read Reset + Random data Write/Read
    #Address 0xf15 read value
    csrr x14, 0xf15

    #Address 0xf15 Write value 0xc7c91834
    li x3, 0xc7c91834
    csrw 0xf15, x3

    #Address 0xf15 read value
    csrr x14, 0xf15

    #Unmapped address 0xcc5 testing: Read Reset + Random data Write/Read
    #Address 0xcc5 read value
    csrr x14, 0xcc5

    #Address 0xcc5 Write value 0xd3355a76
    li x3, 0xd3355a76
    csrw 0xcc5, x3

    #Address 0xcc5 read value
    csrr x14, 0xcc5

    #Unmapped address 0x123 testing: Read Reset + Random data Write/Read
    #Address 0x123 read value
    csrr x14, 0x123

    #Address 0x123 Write value 0x2d9fa3f
    li x3, 0x2d9fa3f
    csrw 0x123, x3

    #Address 0x123 read value
    csrr x14, 0x123

    #Unmapped address 0xac2 testing: Read Reset + Random data Write/Read
    #Address 0xac2 read value
    csrr x14, 0xac2

    #Address 0xac2 Write value 0x2d39ab53
    li x3, 0x2d39ab53
    csrw 0xac2, x3

    #Address 0xac2 read value
    csrr x14, 0xac2

    #Unmapped address 0x94e testing: Read Reset + Random data Write/Read
    #Address 0x94e read value
    csrr x14, 0x94e

    #Address 0x94e Write value 0x8b2dad3a
    li x3, 0x8b2dad3a
    csrw 0x94e, x3

    #Address 0x94e read value
    csrr x14, 0x94e

    #Unmapped address 0xcba testing: Read Reset + Random data Write/Read
    #Address 0xcba read value
    csrr x14, 0xcba

    #Address 0xcba Write value 0x78858f91
    li x3, 0x78858f91
    csrw 0xcba, x3

    #Address 0xcba read value
    csrr x14, 0xcba

    #Unmapped address 0xedb testing: Read Reset + Random data Write/Read
    #Address 0xedb read value
    csrr x14, 0xedb

    #Address 0xedb Write value 0x957f105
    li x3, 0x957f105
    csrw 0xedb, x3

    #Address 0xedb read value
    csrr x14, 0xedb

    #Unmapped address 0xac5 testing: Read Reset + Random data Write/Read
    #Address 0xac5 read value
    csrr x14, 0xac5

    #Address 0xac5 Write value 0x2c44173e
    li x3, 0x2c44173e
    csrw 0xac5, x3

    #Address 0xac5 read value
    csrr x14, 0xac5

    #Unmapped address 0x96e testing: Read Reset + Random data Write/Read
    #Address 0x96e read value
    csrr x14, 0x96e

    #Address 0x96e Write value 0xde57ff15
    li x3, 0xde57ff15
    csrw 0x96e, x3

    #Address 0x96e read value
    csrr x14, 0x96e

    #Unmapped address 0x5b3 testing: Read Reset + Random data Write/Read
    #Address 0x5b3 read value
    csrr x14, 0x5b3

    #Address 0x5b3 Write value 0x978f5319
    li x3, 0x978f5319
    csrw 0x5b3, x3

    #Address 0x5b3 read value
    csrr x14, 0x5b3

    #Unmapped address 0xfc3 testing: Read Reset + Random data Write/Read
    #Address 0xfc3 read value
    csrr x14, 0xfc3

    #Address 0xfc3 Write value 0x2be889de
    li x3, 0x2be889de
    csrw 0xfc3, x3

    #Address 0xfc3 read value
    csrr x14, 0xfc3

    #Unmapped address 0x72a testing: Read Reset + Random data Write/Read
    #Address 0x72a read value
    csrr x14, 0x72a

    #Address 0x72a Write value 0x949e7453
    li x3, 0x949e7453
    csrw 0x72a, x3

    #Address 0x72a read value
    csrr x14, 0x72a

    #Unmapped address 0xbdd testing: Read Reset + Random data Write/Read
    #Address 0xbdd read value
    csrr x14, 0xbdd

    #Address 0xbdd Write value 0x1bd36d71
    li x3, 0x1bd36d71
    csrw 0xbdd, x3

    #Address 0xbdd read value
    csrr x14, 0xbdd

    #Unmapped address 0x66c testing: Read Reset + Random data Write/Read
    #Address 0x66c read value
    csrr x14, 0x66c

    #Address 0x66c Write value 0xbf099764
    li x3, 0xbf099764
    csrw 0x66c, x3

    #Address 0x66c read value
    csrr x14, 0x66c

    #Unmapped address 0x549 testing: Read Reset + Random data Write/Read
    #Address 0x549 read value
    csrr x14, 0x549

    #Address 0x549 Write value 0x7036e4d6
    li x3, 0x7036e4d6
    csrw 0x549, x3

    #Address 0x549 read value
    csrr x14, 0x549

    #Unmapped address 0xdc7 testing: Read Reset + Random data Write/Read
    #Address 0xdc7 read value
    csrr x14, 0xdc7

    #Address 0xdc7 Write value 0xa2fdcec5
    li x3, 0xa2fdcec5
    csrw 0xdc7, x3

    #Address 0xdc7 read value
    csrr x14, 0xdc7

    #Unmapped address 0x8da testing: Read Reset + Random data Write/Read
    #Address 0x8da read value
    csrr x14, 0x8da

    #Address 0x8da Write value 0x6c959a92
    li x3, 0x6c959a92
    csrw 0x8da, x3

    #Address 0x8da read value
    csrr x14, 0x8da

    #Unmapped address 0x697 testing: Read Reset + Random data Write/Read
    #Address 0x697 read value
    csrr x14, 0x697

    #Address 0x697 Write value 0x4c1bc5a
    li x3, 0x4c1bc5a
    csrw 0x697, x3

    #Address 0x697 read value
    csrr x14, 0x697

    #Unmapped address 0x427 testing: Read Reset + Random data Write/Read
    #Address 0x427 read value
    csrr x14, 0x427

    #Address 0x427 Write value 0xf6fd1bc6
    li x3, 0xf6fd1bc6
    csrw 0x427, x3

    #Address 0x427 read value
    csrr x14, 0x427

    #Unmapped address 0xf86 testing: Read Reset + Random data Write/Read
    #Address 0xf86 read value
    csrr x14, 0xf86

    #Address 0xf86 Write value 0x570babd2
    li x3, 0x570babd2
    csrw 0xf86, x3

    #Address 0xf86 read value
    csrr x14, 0xf86

    #Unmapped address 0xf82 testing: Read Reset + Random data Write/Read
    #Address 0xf82 read value
    csrr x14, 0xf82

    #Address 0xf82 Write value 0x5efe8724
    li x3, 0x5efe8724
    csrw 0xf82, x3

    #Address 0xf82 read value
    csrr x14, 0xf82

    #Unmapped address 0xa9c testing: Read Reset + Random data Write/Read
    #Address 0xa9c read value
    csrr x14, 0xa9c

    #Address 0xa9c Write value 0x9af63e41
    li x3, 0x9af63e41
    csrw 0xa9c, x3

    #Address 0xa9c read value
    csrr x14, 0xa9c

    #Unmapped address 0x608 testing: Read Reset + Random data Write/Read
    #Address 0x608 read value
    csrr x14, 0x608

    #Address 0x608 Write value 0xfb733966
    li x3, 0xfb733966
    csrw 0x608, x3

    #Address 0x608 read value
    csrr x14, 0x608

    #Unmapped address 0x9ec testing: Read Reset + Random data Write/Read
    #Address 0x9ec read value
    csrr x14, 0x9ec

    #Address 0x9ec Write value 0x68e242a8
    li x3, 0x68e242a8
    csrw 0x9ec, x3

    #Address 0x9ec read value
    csrr x14, 0x9ec

    #Unmapped address 0x138 testing: Read Reset + Random data Write/Read
    #Address 0x138 read value
    csrr x14, 0x138

    #Address 0x138 Write value 0x7a02aba
    li x3, 0x7a02aba
    csrw 0x138, x3

    #Address 0x138 read value
    csrr x14, 0x138

    #Unmapped address 0x3ee testing: Read Reset + Random data Write/Read
    #Address 0x3ee read value
    csrr x14, 0x3ee

    #Address 0x3ee Write value 0xb6278108
    li x3, 0xb6278108
    csrw 0x3ee, x3

    #Address 0x3ee read value
    csrr x14, 0x3ee

    #Unmapped address 0x4ef testing: Read Reset + Random data Write/Read
    #Address 0x4ef read value
    csrr x14, 0x4ef

    #Address 0x4ef Write value 0x924f872d
    li x3, 0x924f872d
    csrw 0x4ef, x3

    #Address 0x4ef read value
    csrr x14, 0x4ef

    #Unmapped address 0xf8a testing: Read Reset + Random data Write/Read
    #Address 0xf8a read value
    csrr x14, 0xf8a

    #Address 0xf8a Write value 0x18b4b057
    li x3, 0x18b4b057
    csrw 0xf8a, x3

    #Address 0xf8a read value
    csrr x14, 0xf8a

    #Unmapped address 0x3c7 testing: Read Reset + Random data Write/Read
    #Address 0x3c7 read value
    csrr x14, 0x3c7

    #Address 0x3c7 Write value 0xdb4e8f88
    li x3, 0xdb4e8f88
    csrw 0x3c7, x3

    #Address 0x3c7 read value
    csrr x14, 0x3c7

    #Unmapped address 0x2e9 testing: Read Reset + Random data Write/Read
    #Address 0x2e9 read value
    csrr x14, 0x2e9

    #Address 0x2e9 Write value 0xcc68c169
    li x3, 0xcc68c169
    csrw 0x2e9, x3

    #Address 0x2e9 read value
    csrr x14, 0x2e9

    #Unmapped address 0xa testing: Read Reset + Random data Write/Read
    #Address 0xa read value
    csrr x14, 0xa

    #Address 0xa Write value 0x955612c0
    li x3, 0x955612c0
    csrw 0xa, x3

    #Address 0xa read value
    csrr x14, 0xa

    #Unmapped address 0x6d2 testing: Read Reset + Random data Write/Read
    #Address 0x6d2 read value
    csrr x14, 0x6d2

    #Address 0x6d2 Write value 0xa19e4f6f
    li x3, 0xa19e4f6f
    csrw 0x6d2, x3

    #Address 0x6d2 read value
    csrr x14, 0x6d2

    #Unmapped address 0x2ae testing: Read Reset + Random data Write/Read
    #Address 0x2ae read value
    csrr x14, 0x2ae

    #Address 0x2ae Write value 0x768c1657
    li x3, 0x768c1657
    csrw 0x2ae, x3

    #Address 0x2ae read value
    csrr x14, 0x2ae

    #Unmapped address 0x2c2 testing: Read Reset + Random data Write/Read
    #Address 0x2c2 read value
    csrr x14, 0x2c2

    #Address 0x2c2 Write value 0xbcc1e70f
    li x3, 0xbcc1e70f
    csrw 0x2c2, x3

    #Address 0x2c2 read value
    csrr x14, 0x2c2

    #Unmapped address 0x441 testing: Read Reset + Random data Write/Read
    #Address 0x441 read value
    csrr x14, 0x441

    #Address 0x441 Write value 0x2fe8bd7c
    li x3, 0x2fe8bd7c
    csrw 0x441, x3

    #Address 0x441 read value
    csrr x14, 0x441

    #Unmapped address 0x2b7 testing: Read Reset + Random data Write/Read
    #Address 0x2b7 read value
    csrr x14, 0x2b7

    #Address 0x2b7 Write value 0x425baef
    li x3, 0x425baef
    csrw 0x2b7, x3

    #Address 0x2b7 read value
    csrr x14, 0x2b7

    #Unmapped address 0x94 testing: Read Reset + Random data Write/Read
    #Address 0x94 read value
    csrr x14, 0x94

    #Address 0x94 Write value 0xf24de254
    li x3, 0xf24de254
    csrw 0x94, x3

    #Address 0x94 read value
    csrr x14, 0x94

    #Unmapped address 0x45d testing: Read Reset + Random data Write/Read
    #Address 0x45d read value
    csrr x14, 0x45d

    #Address 0x45d Write value 0x30e8dcd5
    li x3, 0x30e8dcd5
    csrw 0x45d, x3

    #Address 0x45d read value
    csrr x14, 0x45d

    #Unmapped address 0xa23 testing: Read Reset + Random data Write/Read
    #Address 0xa23 read value
    csrr x14, 0xa23

    #Address 0xa23 Write value 0x594a19aa
    li x3, 0x594a19aa
    csrw 0xa23, x3

    #Address 0xa23 read value
    csrr x14, 0xa23

    #Unmapped address 0x5aa testing: Read Reset + Random data Write/Read
    #Address 0x5aa read value
    csrr x14, 0x5aa

    #Address 0x5aa Write value 0x2ed101c0
    li x3, 0x2ed101c0
    csrw 0x5aa, x3

    #Address 0x5aa read value
    csrr x14, 0x5aa

    #Unmapped address 0x499 testing: Read Reset + Random data Write/Read
    #Address 0x499 read value
    csrr x14, 0x499

    #Address 0x499 Write value 0x4ed9b6dd
    li x3, 0x4ed9b6dd
    csrw 0x499, x3

    #Address 0x499 read value
    csrr x14, 0x499

    #Unmapped address 0xacf testing: Read Reset + Random data Write/Read
    #Address 0xacf read value
    csrr x14, 0xacf

    #Address 0xacf Write value 0xc649545b
    li x3, 0xc649545b
    csrw 0xacf, x3

    #Address 0xacf read value
    csrr x14, 0xacf

    #Unmapped address 0xcfa testing: Read Reset + Random data Write/Read
    #Address 0xcfa read value
    csrr x14, 0xcfa

    #Address 0xcfa Write value 0x274a72ca
    li x3, 0x274a72ca
    csrw 0xcfa, x3

    #Address 0xcfa read value
    csrr x14, 0xcfa

    #Unmapped address 0x705 testing: Read Reset + Random data Write/Read
    #Address 0x705 read value
    csrr x14, 0x705

    #Address 0x705 Write value 0x267c4516
    li x3, 0x267c4516
    csrw 0x705, x3

    #Address 0x705 read value
    csrr x14, 0x705

    #Unmapped address 0xabf testing: Read Reset + Random data Write/Read
    #Address 0xabf read value
    csrr x14, 0xabf

    #Address 0xabf Write value 0x4e2a316d
    li x3, 0x4e2a316d
    csrw 0xabf, x3

    #Address 0xabf read value
    csrr x14, 0xabf

    #Unmapped address 0x560 testing: Read Reset + Random data Write/Read
    #Address 0x560 read value
    csrr x14, 0x560

    #Address 0x560 Write value 0x372f7f66
    li x3, 0x372f7f66
    csrw 0x560, x3

    #Address 0x560 read value
    csrr x14, 0x560

    #Unmapped address 0xfe7 testing: Read Reset + Random data Write/Read
    #Address 0xfe7 read value
    csrr x14, 0xfe7

    #Address 0xfe7 Write value 0x823964ad
    li x3, 0x823964ad
    csrw 0xfe7, x3

    #Address 0xfe7 read value
    csrr x14, 0xfe7

    #Unmapped address 0xed6 testing: Read Reset + Random data Write/Read
    #Address 0xed6 read value
    csrr x14, 0xed6

    #Address 0xed6 Write value 0x30aa1a5a
    li x3, 0x30aa1a5a
    csrw 0xed6, x3

    #Address 0xed6 read value
    csrr x14, 0xed6

    #Unmapped address 0xd0b testing: Read Reset + Random data Write/Read
    #Address 0xd0b read value
    csrr x14, 0xd0b

    #Address 0xd0b Write value 0xf12c7733
    li x3, 0xf12c7733
    csrw 0xd0b, x3

    #Address 0xd0b read value
    csrr x14, 0xd0b

    #Unmapped address 0x2ba testing: Read Reset + Random data Write/Read
    #Address 0x2ba read value
    csrr x14, 0x2ba

    #Address 0x2ba Write value 0x6af79873
    li x3, 0x6af79873
    csrw 0x2ba, x3

    #Address 0x2ba read value
    csrr x14, 0x2ba

    #Unmapped address 0xbce testing: Read Reset + Random data Write/Read
    #Address 0xbce read value
    csrr x14, 0xbce

    #Address 0xbce Write value 0xa3c1880
    li x3, 0xa3c1880
    csrw 0xbce, x3

    #Address 0xbce read value
    csrr x14, 0xbce

    #Unmapped address 0xd52 testing: Read Reset + Random data Write/Read
    #Address 0xd52 read value
    csrr x14, 0xd52

    #Address 0xd52 Write value 0x8ec487ab
    li x3, 0x8ec487ab
    csrw 0xd52, x3

    #Address 0xd52 read value
    csrr x14, 0xd52

    #Unmapped address 0x75f testing: Read Reset + Random data Write/Read
    #Address 0x75f read value
    csrr x14, 0x75f

    #Address 0x75f Write value 0xa3a869c0
    li x3, 0xa3a869c0
    csrw 0x75f, x3

    #Address 0x75f read value
    csrr x14, 0x75f

    #Unmapped address 0xcc2 testing: Read Reset + Random data Write/Read
    #Address 0xcc2 read value
    csrr x14, 0xcc2

    #Address 0xcc2 Write value 0xf90d0b06
    li x3, 0xf90d0b06
    csrw 0xcc2, x3

    #Address 0xcc2 read value
    csrr x14, 0xcc2

    #Unmapped address 0xd30 testing: Read Reset + Random data Write/Read
    #Address 0xd30 read value
    csrr x14, 0xd30

    #Address 0xd30 Write value 0xdbfaadc9
    li x3, 0xdbfaadc9
    csrw 0xd30, x3

    #Address 0xd30 read value
    csrr x14, 0xd30

    #Unmapped address 0x935 testing: Read Reset + Random data Write/Read
    #Address 0x935 read value
    csrr x14, 0x935

    #Address 0x935 Write value 0xc8bc8f4e
    li x3, 0xc8bc8f4e
    csrw 0x935, x3

    #Address 0x935 read value
    csrr x14, 0x935

    #Unmapped address 0x529 testing: Read Reset + Random data Write/Read
    #Address 0x529 read value
    csrr x14, 0x529

    #Address 0x529 Write value 0xcd99b3c0
    li x3, 0xcd99b3c0
    csrw 0x529, x3

    #Address 0x529 read value
    csrr x14, 0x529

    #Unmapped address 0x8e7 testing: Read Reset + Random data Write/Read
    #Address 0x8e7 read value
    csrr x14, 0x8e7

    #Address 0x8e7 Write value 0xe6ce6d97
    li x3, 0xe6ce6d97
    csrw 0x8e7, x3

    #Address 0x8e7 read value
    csrr x14, 0x8e7

    #Unmapped address 0x84 testing: Read Reset + Random data Write/Read
    #Address 0x84 read value
    csrr x14, 0x84

    #Address 0x84 Write value 0x3ad118cf
    li x3, 0x3ad118cf
    csrw 0x84, x3

    #Address 0x84 read value
    csrr x14, 0x84

    #Unmapped address 0x81 testing: Read Reset + Random data Write/Read
    #Address 0x81 read value
    csrr x14, 0x81

    #Address 0x81 Write value 0x56c9b7a3
    li x3, 0x56c9b7a3
    csrw 0x81, x3

    #Address 0x81 read value
    csrr x14, 0x81

    #Unmapped address 0x2e8 testing: Read Reset + Random data Write/Read
    #Address 0x2e8 read value
    csrr x14, 0x2e8

    #Address 0x2e8 Write value 0x783914d1
    li x3, 0x783914d1
    csrw 0x2e8, x3

    #Address 0x2e8 read value
    csrr x14, 0x2e8

    #Unmapped address 0x62 testing: Read Reset + Random data Write/Read
    #Address 0x62 read value
    csrr x14, 0x62

    #Address 0x62 Write value 0xd33a2995
    li x3, 0xd33a2995
    csrw 0x62, x3

    #Address 0x62 read value
    csrr x14, 0x62

    #Unmapped address 0xd46 testing: Read Reset + Random data Write/Read
    #Address 0xd46 read value
    csrr x14, 0xd46

    #Address 0xd46 Write value 0x6e521f8b
    li x3, 0x6e521f8b
    csrw 0xd46, x3

    #Address 0xd46 read value
    csrr x14, 0xd46

    #Unmapped address 0xad0 testing: Read Reset + Random data Write/Read
    #Address 0xad0 read value
    csrr x14, 0xad0

    #Address 0xad0 Write value 0xf7daa46f
    li x3, 0xf7daa46f
    csrw 0xad0, x3

    #Address 0xad0 read value
    csrr x14, 0xad0

    #Unmapped address 0x216 testing: Read Reset + Random data Write/Read
    #Address 0x216 read value
    csrr x14, 0x216

    #Address 0x216 Write value 0x575e82ff
    li x3, 0x575e82ff
    csrw 0x216, x3

    #Address 0x216 read value
    csrr x14, 0x216

    #Unmapped address 0x2dc testing: Read Reset + Random data Write/Read
    #Address 0x2dc read value
    csrr x14, 0x2dc

    #Address 0x2dc Write value 0xb1840e02
    li x3, 0xb1840e02
    csrw 0x2dc, x3

    #Address 0x2dc read value
    csrr x14, 0x2dc

    #Unmapped address 0x436 testing: Read Reset + Random data Write/Read
    #Address 0x436 read value
    csrr x14, 0x436

    #Address 0x436 Write value 0x67a64766
    li x3, 0x67a64766
    csrw 0x436, x3

    #Address 0x436 read value
    csrr x14, 0x436

    #Unmapped address 0x468 testing: Read Reset + Random data Write/Read
    #Address 0x468 read value
    csrr x14, 0x468

    #Address 0x468 Write value 0x429a8211
    li x3, 0x429a8211
    csrw 0x468, x3

    #Address 0x468 read value
    csrr x14, 0x468

    #Unmapped address 0x902 testing: Read Reset + Random data Write/Read
    #Address 0x902 read value
    csrr x14, 0x902

    #Address 0x902 Write value 0x4af70f04
    li x3, 0x4af70f04
    csrw 0x902, x3

    #Address 0x902 read value
    csrr x14, 0x902

    #Unmapped address 0x5c4 testing: Read Reset + Random data Write/Read
    #Address 0x5c4 read value
    csrr x14, 0x5c4

    #Address 0x5c4 Write value 0xeb8c9a6e
    li x3, 0xeb8c9a6e
    csrw 0x5c4, x3

    #Address 0x5c4 read value
    csrr x14, 0x5c4

    #Unmapped address 0x2b testing: Read Reset + Random data Write/Read
    #Address 0x2b read value
    csrr x14, 0x2b

    #Address 0x2b Write value 0x49ebc9ee
    li x3, 0x49ebc9ee
    csrw 0x2b, x3

    #Address 0x2b read value
    csrr x14, 0x2b

    #Unmapped address 0xece testing: Read Reset + Random data Write/Read
    #Address 0xece read value
    csrr x14, 0xece

    #Address 0xece Write value 0x41dc64d
    li x3, 0x41dc64d
    csrw 0xece, x3

    #Address 0xece read value
    csrr x14, 0xece

    #Unmapped address 0x10 testing: Read Reset + Random data Write/Read
    #Address 0x10 read value
    csrr x14, 0x10

    #Address 0x10 Write value 0xb5dd74ce
    li x3, 0xb5dd74ce
    csrw 0x10, x3

    #Address 0x10 read value
    csrr x14, 0x10

    #Unmapped address 0x8a5 testing: Read Reset + Random data Write/Read
    #Address 0x8a5 read value
    csrr x14, 0x8a5

    #Address 0x8a5 Write value 0xfa6bf2f4
    li x3, 0xfa6bf2f4
    csrw 0x8a5, x3

    #Address 0x8a5 read value
    csrr x14, 0x8a5

    #Unmapped address 0x717 testing: Read Reset + Random data Write/Read
    #Address 0x717 read value
    csrr x14, 0x717

    #Address 0x717 Write value 0x181eed54
    li x3, 0x181eed54
    csrw 0x717, x3

    #Address 0x717 read value
    csrr x14, 0x717

    #Unmapped address 0xf7f testing: Read Reset + Random data Write/Read
    #Address 0xf7f read value
    csrr x14, 0xf7f

    #Address 0xf7f Write value 0x49d4c6e9
    li x3, 0x49d4c6e9
    csrw 0xf7f, x3

    #Address 0xf7f read value
    csrr x14, 0xf7f

    #Unmapped address 0xcee testing: Read Reset + Random data Write/Read
    #Address 0xcee read value
    csrr x14, 0xcee

    #Address 0xcee Write value 0xecb8fb4f
    li x3, 0xecb8fb4f
    csrw 0xcee, x3

    #Address 0xcee read value
    csrr x14, 0xcee

    #Unmapped address 0x463 testing: Read Reset + Random data Write/Read
    #Address 0x463 read value
    csrr x14, 0x463

    #Address 0x463 Write value 0xb3f8ce9c
    li x3, 0xb3f8ce9c
    csrw 0x463, x3

    #Address 0x463 read value
    csrr x14, 0x463

    #Unmapped address 0xefb testing: Read Reset + Random data Write/Read
    #Address 0xefb read value
    csrr x14, 0xefb

    #Address 0xefb Write value 0xe6bd79cf
    li x3, 0xe6bd79cf
    csrw 0xefb, x3

    #Address 0xefb read value
    csrr x14, 0xefb

    #Unmapped address 0xc10 testing: Read Reset + Random data Write/Read
    #Address 0xc10 read value
    csrr x14, 0xc10

    #Address 0xc10 Write value 0x6dcc8195
    li x3, 0x6dcc8195
    csrw 0xc10, x3

    #Address 0xc10 read value
    csrr x14, 0xc10

    #Unmapped address 0x7fb testing: Read Reset + Random data Write/Read
    #Address 0x7fb read value
    csrr x14, 0x7fb

    #Address 0x7fb Write value 0xe6c2a8d9
    li x3, 0xe6c2a8d9
    csrw 0x7fb, x3

    #Address 0x7fb read value
    csrr x14, 0x7fb

    #Unmapped address 0x9de testing: Read Reset + Random data Write/Read
    #Address 0x9de read value
    csrr x14, 0x9de

    #Address 0x9de Write value 0x376845c9
    li x3, 0x376845c9
    csrw 0x9de, x3

    #Address 0x9de read value
    csrr x14, 0x9de

    #Unmapped address 0x2e4 testing: Read Reset + Random data Write/Read
    #Address 0x2e4 read value
    csrr x14, 0x2e4

    #Address 0x2e4 Write value 0x14cf50d8
    li x3, 0x14cf50d8
    csrw 0x2e4, x3

    #Address 0x2e4 read value
    csrr x14, 0x2e4

    #Unmapped address 0x4e8 testing: Read Reset + Random data Write/Read
    #Address 0x4e8 read value
    csrr x14, 0x4e8

    #Address 0x4e8 Write value 0x5fd6dc75
    li x3, 0x5fd6dc75
    csrw 0x4e8, x3

    #Address 0x4e8 read value
    csrr x14, 0x4e8

    #Unmapped address 0x73 testing: Read Reset + Random data Write/Read
    #Address 0x73 read value
    csrr x14, 0x73

    #Address 0x73 Write value 0xef4541fc
    li x3, 0xef4541fc
    csrw 0x73, x3

    #Address 0x73 read value
    csrr x14, 0x73

    #Unmapped address 0xd93 testing: Read Reset + Random data Write/Read
    #Address 0xd93 read value
    csrr x14, 0xd93

    #Address 0xd93 Write value 0x4bd44eff
    li x3, 0x4bd44eff
    csrw 0xd93, x3

    #Address 0xd93 read value
    csrr x14, 0xd93

    #Unmapped address 0xad4 testing: Read Reset + Random data Write/Read
    #Address 0xad4 read value
    csrr x14, 0xad4

    #Address 0xad4 Write value 0x1a86acdf
    li x3, 0x1a86acdf
    csrw 0xad4, x3

    #Address 0xad4 read value
    csrr x14, 0xad4

    #Unmapped address 0xd78 testing: Read Reset + Random data Write/Read
    #Address 0xd78 read value
    csrr x14, 0xd78

    #Address 0xd78 Write value 0xa34eff49
    li x3, 0xa34eff49
    csrw 0xd78, x3

    #Address 0xd78 read value
    csrr x14, 0xd78

    #Unmapped address 0xbcb testing: Read Reset + Random data Write/Read
    #Address 0xbcb read value
    csrr x14, 0xbcb

    #Address 0xbcb Write value 0x61aefc60
    li x3, 0x61aefc60
    csrw 0xbcb, x3

    #Address 0xbcb read value
    csrr x14, 0xbcb

    #Unmapped address 0xfce testing: Read Reset + Random data Write/Read
    #Address 0xfce read value
    csrr x14, 0xfce

    #Address 0xfce Write value 0xe2d46c11
    li x3, 0xe2d46c11
    csrw 0xfce, x3

    #Address 0xfce read value
    csrr x14, 0xfce

    #Unmapped address 0x8fc testing: Read Reset + Random data Write/Read
    #Address 0x8fc read value
    csrr x14, 0x8fc

    #Address 0x8fc Write value 0xd8b2fa57
    li x3, 0xd8b2fa57
    csrw 0x8fc, x3

    #Address 0x8fc read value
    csrr x14, 0x8fc

    #Unmapped address 0xa6 testing: Read Reset + Random data Write/Read
    #Address 0xa6 read value
    csrr x14, 0xa6

    #Address 0xa6 Write value 0x8cfd2b52
    li x3, 0x8cfd2b52
    csrw 0xa6, x3

    #Address 0xa6 read value
    csrr x14, 0xa6

    #Unmapped address 0x74d testing: Read Reset + Random data Write/Read
    #Address 0x74d read value
    csrr x14, 0x74d

    #Address 0x74d Write value 0x991c1ceb
    li x3, 0x991c1ceb
    csrw 0x74d, x3

    #Address 0x74d read value
    csrr x14, 0x74d

    #Unmapped address 0x76f testing: Read Reset + Random data Write/Read
    #Address 0x76f read value
    csrr x14, 0x76f

    #Address 0x76f Write value 0xaf8c0c41
    li x3, 0xaf8c0c41
    csrw 0x76f, x3

    #Address 0x76f read value
    csrr x14, 0x76f

    #Unmapped address 0xc21 testing: Read Reset + Random data Write/Read
    #Address 0xc21 read value
    csrr x14, 0xc21

    #Address 0xc21 Write value 0xf601943d
    li x3, 0xf601943d
    csrw 0xc21, x3

    #Address 0xc21 read value
    csrr x14, 0xc21

    #Unmapped address 0xe97 testing: Read Reset + Random data Write/Read
    #Address 0xe97 read value
    csrr x14, 0xe97

    #Address 0xe97 Write value 0xe2b31a56
    li x3, 0xe2b31a56
    csrw 0xe97, x3

    #Address 0xe97 read value
    csrr x14, 0xe97

    #Unmapped address 0x240 testing: Read Reset + Random data Write/Read
    #Address 0x240 read value
    csrr x14, 0x240

    #Address 0x240 Write value 0xe9acfed8
    li x3, 0xe9acfed8
    csrw 0x240, x3

    #Address 0x240 read value
    csrr x14, 0x240

    #Unmapped address 0xeb2 testing: Read Reset + Random data Write/Read
    #Address 0xeb2 read value
    csrr x14, 0xeb2

    #Address 0xeb2 Write value 0xf43f976f
    li x3, 0xf43f976f
    csrw 0xeb2, x3

    #Address 0xeb2 read value
    csrr x14, 0xeb2

    #Unmapped address 0xbae testing: Read Reset + Random data Write/Read
    #Address 0xbae read value
    csrr x14, 0xbae

    #Address 0xbae Write value 0x8fbb6d19
    li x3, 0x8fbb6d19
    csrw 0xbae, x3

    #Address 0xbae read value
    csrr x14, 0xbae

    #Unmapped address 0x18e testing: Read Reset + Random data Write/Read
    #Address 0x18e read value
    csrr x14, 0x18e

    #Address 0x18e Write value 0x9f3a8a77
    li x3, 0x9f3a8a77
    csrw 0x18e, x3

    #Address 0x18e read value
    csrr x14, 0x18e

    #Unmapped address 0x8e testing: Read Reset + Random data Write/Read
    #Address 0x8e read value
    csrr x14, 0x8e

    #Address 0x8e Write value 0x155b5e84
    li x3, 0x155b5e84
    csrw 0x8e, x3

    #Address 0x8e read value
    csrr x14, 0x8e

    #Unmapped address 0x42d testing: Read Reset + Random data Write/Read
    #Address 0x42d read value
    csrr x14, 0x42d

    #Address 0x42d Write value 0x43ad1973
    li x3, 0x43ad1973
    csrw 0x42d, x3

    #Address 0x42d read value
    csrr x14, 0x42d

    #Unmapped address 0x24a testing: Read Reset + Random data Write/Read
    #Address 0x24a read value
    csrr x14, 0x24a

    #Address 0x24a Write value 0xfd8e7062
    li x3, 0xfd8e7062
    csrw 0x24a, x3

    #Address 0x24a read value
    csrr x14, 0x24a

    #Unmapped address 0xe54 testing: Read Reset + Random data Write/Read
    #Address 0xe54 read value
    csrr x14, 0xe54

    #Address 0xe54 Write value 0x49131b7b
    li x3, 0x49131b7b
    csrw 0xe54, x3

    #Address 0xe54 read value
    csrr x14, 0xe54

    #Unmapped address 0x879 testing: Read Reset + Random data Write/Read
    #Address 0x879 read value
    csrr x14, 0x879

    #Address 0x879 Write value 0x5aa6c5ff
    li x3, 0x5aa6c5ff
    csrw 0x879, x3

    #Address 0x879 read value
    csrr x14, 0x879

    #Unmapped address 0xd17 testing: Read Reset + Random data Write/Read
    #Address 0xd17 read value
    csrr x14, 0xd17

    #Address 0xd17 Write value 0x3f937fd8
    li x3, 0x3f937fd8
    csrw 0xd17, x3

    #Address 0xd17 read value
    csrr x14, 0xd17

    #Unmapped address 0xd37 testing: Read Reset + Random data Write/Read
    #Address 0xd37 read value
    csrr x14, 0xd37

    #Address 0xd37 Write value 0x1f4ba32c
    li x3, 0x1f4ba32c
    csrw 0xd37, x3

    #Address 0xd37 read value
    csrr x14, 0xd37

    #Unmapped address 0xccb testing: Read Reset + Random data Write/Read
    #Address 0xccb read value
    csrr x14, 0xccb

    #Address 0xccb Write value 0x3186f6ea
    li x3, 0x3186f6ea
    csrw 0xccb, x3

    #Address 0xccb read value
    csrr x14, 0xccb

    #Unmapped address 0x1d8 testing: Read Reset + Random data Write/Read
    #Address 0x1d8 read value
    csrr x14, 0x1d8

    #Address 0x1d8 Write value 0x368dda10
    li x3, 0x368dda10
    csrw 0x1d8, x3

    #Address 0x1d8 read value
    csrr x14, 0x1d8

    #Unmapped address 0x235 testing: Read Reset + Random data Write/Read
    #Address 0x235 read value
    csrr x14, 0x235

    #Address 0x235 Write value 0xdbc8afb2
    li x3, 0xdbc8afb2
    csrw 0x235, x3

    #Address 0x235 read value
    csrr x14, 0x235

    #Unmapped address 0x1cf testing: Read Reset + Random data Write/Read
    #Address 0x1cf read value
    csrr x14, 0x1cf

    #Address 0x1cf Write value 0x5ca8a1f
    li x3, 0x5ca8a1f
    csrw 0x1cf, x3

    #Address 0x1cf read value
    csrr x14, 0x1cf

    #Unmapped address 0xee0 testing: Read Reset + Random data Write/Read
    #Address 0xee0 read value
    csrr x14, 0xee0

    #Address 0xee0 Write value 0xf1ef21fb
    li x3, 0xf1ef21fb
    csrw 0xee0, x3

    #Address 0xee0 read value
    csrr x14, 0xee0

    #Unmapped address 0xbd7 testing: Read Reset + Random data Write/Read
    #Address 0xbd7 read value
    csrr x14, 0xbd7

    #Address 0xbd7 Write value 0x5a8d5d69
    li x3, 0x5a8d5d69
    csrw 0xbd7, x3

    #Address 0xbd7 read value
    csrr x14, 0xbd7

    #Unmapped address 0x6f2 testing: Read Reset + Random data Write/Read
    #Address 0x6f2 read value
    csrr x14, 0x6f2

    #Address 0x6f2 Write value 0x60e3eb58
    li x3, 0x60e3eb58
    csrw 0x6f2, x3

    #Address 0x6f2 read value
    csrr x14, 0x6f2

    #Unmapped address 0x158 testing: Read Reset + Random data Write/Read
    #Address 0x158 read value
    csrr x14, 0x158

    #Address 0x158 Write value 0x8c19e11d
    li x3, 0x8c19e11d
    csrw 0x158, x3

    #Address 0x158 read value
    csrr x14, 0x158

    #Unmapped address 0x820 testing: Read Reset + Random data Write/Read
    #Address 0x820 read value
    csrr x14, 0x820

    #Address 0x820 Write value 0x85ca9e67
    li x3, 0x85ca9e67
    csrw 0x820, x3

    #Address 0x820 read value
    csrr x14, 0x820

    #Unmapped address 0xe32 testing: Read Reset + Random data Write/Read
    #Address 0xe32 read value
    csrr x14, 0xe32

    #Address 0xe32 Write value 0x9d858f11
    li x3, 0x9d858f11
    csrw 0xe32, x3

    #Address 0xe32 read value
    csrr x14, 0xe32

    #Unmapped address 0x6f3 testing: Read Reset + Random data Write/Read
    #Address 0x6f3 read value
    csrr x14, 0x6f3

    #Address 0x6f3 Write value 0x623677f8
    li x3, 0x623677f8
    csrw 0x6f3, x3

    #Address 0x6f3 read value
    csrr x14, 0x6f3

    #Unmapped address 0xae5 testing: Read Reset + Random data Write/Read
    #Address 0xae5 read value
    csrr x14, 0xae5

    #Address 0xae5 Write value 0x10ba038d
    li x3, 0x10ba038d
    csrw 0xae5, x3

    #Address 0xae5 read value
    csrr x14, 0xae5

    #Unmapped address 0x20b testing: Read Reset + Random data Write/Read
    #Address 0x20b read value
    csrr x14, 0x20b

    #Address 0x20b Write value 0x1380b065
    li x3, 0x1380b065
    csrw 0x20b, x3

    #Address 0x20b read value
    csrr x14, 0x20b

    #Unmapped address 0x623 testing: Read Reset + Random data Write/Read
    #Address 0x623 read value
    csrr x14, 0x623

    #Address 0x623 Write value 0xba9616c7
    li x3, 0xba9616c7
    csrw 0x623, x3

    #Address 0x623 read value
    csrr x14, 0x623

    #Unmapped address 0x947 testing: Read Reset + Random data Write/Read
    #Address 0x947 read value
    csrr x14, 0x947

    #Address 0x947 Write value 0x41d3d047
    li x3, 0x41d3d047
    csrw 0x947, x3

    #Address 0x947 read value
    csrr x14, 0x947

    #Unmapped address 0xc99 testing: Read Reset + Random data Write/Read
    #Address 0xc99 read value
    csrr x14, 0xc99

    #Address 0xc99 Write value 0x9f406d3d
    li x3, 0x9f406d3d
    csrw 0xc99, x3

    #Address 0xc99 read value
    csrr x14, 0xc99

    #Unmapped address 0x632 testing: Read Reset + Random data Write/Read
    #Address 0x632 read value
    csrr x14, 0x632

    #Address 0x632 Write value 0x3aeec2c5
    li x3, 0x3aeec2c5
    csrw 0x632, x3

    #Address 0x632 read value
    csrr x14, 0x632

    #Unmapped address 0x77c testing: Read Reset + Random data Write/Read
    #Address 0x77c read value
    csrr x14, 0x77c

    #Address 0x77c Write value 0x3d46205f
    li x3, 0x3d46205f
    csrw 0x77c, x3

    #Address 0x77c read value
    csrr x14, 0x77c

    #Unmapped address 0xc75 testing: Read Reset + Random data Write/Read
    #Address 0xc75 read value
    csrr x14, 0xc75

    #Address 0xc75 Write value 0x92929a12
    li x3, 0x92929a12
    csrw 0xc75, x3

    #Address 0xc75 read value
    csrr x14, 0xc75

    #Unmapped address 0xad6 testing: Read Reset + Random data Write/Read
    #Address 0xad6 read value
    csrr x14, 0xad6

    #Address 0xad6 Write value 0xf8edb0d5
    li x3, 0xf8edb0d5
    csrw 0xad6, x3

    #Address 0xad6 read value
    csrr x14, 0xad6

    #Unmapped address 0xe8c testing: Read Reset + Random data Write/Read
    #Address 0xe8c read value
    csrr x14, 0xe8c

    #Address 0xe8c Write value 0x2227fbb0
    li x3, 0x2227fbb0
    csrw 0xe8c, x3

    #Address 0xe8c read value
    csrr x14, 0xe8c

    #Unmapped address 0x707 testing: Read Reset + Random data Write/Read
    #Address 0x707 read value
    csrr x14, 0x707

    #Address 0x707 Write value 0x96411033
    li x3, 0x96411033
    csrw 0x707, x3

    #Address 0x707 read value
    csrr x14, 0x707

    #Unmapped address 0x82f testing: Read Reset + Random data Write/Read
    #Address 0x82f read value
    csrr x14, 0x82f

    #Address 0x82f Write value 0x3016cb7e
    li x3, 0x3016cb7e
    csrw 0x82f, x3

    #Address 0x82f read value
    csrr x14, 0x82f

    #Unmapped address 0xa18 testing: Read Reset + Random data Write/Read
    #Address 0xa18 read value
    csrr x14, 0xa18

    #Address 0xa18 Write value 0x9416a8e
    li x3, 0x9416a8e
    csrw 0xa18, x3

    #Address 0xa18 read value
    csrr x14, 0xa18

    #Unmapped address 0x51 testing: Read Reset + Random data Write/Read
    #Address 0x51 read value
    csrr x14, 0x51

    #Address 0x51 Write value 0x8cbac707
    li x3, 0x8cbac707
    csrw 0x51, x3

    #Address 0x51 read value
    csrr x14, 0x51

    #Unmapped address 0x654 testing: Read Reset + Random data Write/Read
    #Address 0x654 read value
    csrr x14, 0x654

    #Address 0x654 Write value 0x75cf7a31
    li x3, 0x75cf7a31
    csrw 0x654, x3

    #Address 0x654 read value
    csrr x14, 0x654

    #Unmapped address 0x65f testing: Read Reset + Random data Write/Read
    #Address 0x65f read value
    csrr x14, 0x65f

    #Address 0x65f Write value 0xc6a4a430
    li x3, 0xc6a4a430
    csrw 0x65f, x3

    #Address 0x65f read value
    csrr x14, 0x65f

    #Unmapped address 0x7f3 testing: Read Reset + Random data Write/Read
    #Address 0x7f3 read value
    csrr x14, 0x7f3

    #Address 0x7f3 Write value 0x46e741a5
    li x3, 0x46e741a5
    csrw 0x7f3, x3

    #Address 0x7f3 read value
    csrr x14, 0x7f3

    #Unmapped address 0x39c testing: Read Reset + Random data Write/Read
    #Address 0x39c read value
    csrr x14, 0x39c

    #Address 0x39c Write value 0xeca147c4
    li x3, 0xeca147c4
    csrw 0x39c, x3

    #Address 0x39c read value
    csrr x14, 0x39c

    #Unmapped address 0x863 testing: Read Reset + Random data Write/Read
    #Address 0x863 read value
    csrr x14, 0x863

    #Address 0x863 Write value 0x17750a18
    li x3, 0x17750a18
    csrw 0x863, x3

    #Address 0x863 read value
    csrr x14, 0x863

    #Unmapped address 0x313 testing: Read Reset + Random data Write/Read
    #Address 0x313 read value
    csrr x14, 0x313

    #Address 0x313 Write value 0x216c5bf0
    li x3, 0x216c5bf0
    csrw 0x313, x3

    #Address 0x313 read value
    csrr x14, 0x313

    #Unmapped address 0x94f testing: Read Reset + Random data Write/Read
    #Address 0x94f read value
    csrr x14, 0x94f

    #Address 0x94f Write value 0x860b8b4d
    li x3, 0x860b8b4d
    csrw 0x94f, x3

    #Address 0x94f read value
    csrr x14, 0x94f

    #Unmapped address 0xa2 testing: Read Reset + Random data Write/Read
    #Address 0xa2 read value
    csrr x14, 0xa2

    #Address 0xa2 Write value 0x66c89c71
    li x3, 0x66c89c71
    csrw 0xa2, x3

    #Address 0xa2 read value
    csrr x14, 0xa2

    #Unmapped address 0xd67 testing: Read Reset + Random data Write/Read
    #Address 0xd67 read value
    csrr x14, 0xd67

    #Address 0xd67 Write value 0x66ba575d
    li x3, 0x66ba575d
    csrw 0xd67, x3

    #Address 0xd67 read value
    csrr x14, 0xd67

    #Unmapped address 0x76c testing: Read Reset + Random data Write/Read
    #Address 0x76c read value
    csrr x14, 0x76c

    #Address 0x76c Write value 0x76883172
    li x3, 0x76883172
    csrw 0x76c, x3

    #Address 0x76c read value
    csrr x14, 0x76c

    #Unmapped address 0x7ea testing: Read Reset + Random data Write/Read
    #Address 0x7ea read value
    csrr x14, 0x7ea

    #Address 0x7ea Write value 0xe189ed50
    li x3, 0xe189ed50
    csrw 0x7ea, x3

    #Address 0x7ea read value
    csrr x14, 0x7ea

    #Unmapped address 0x1d testing: Read Reset + Random data Write/Read
    #Address 0x1d read value
    csrr x14, 0x1d

    #Address 0x1d Write value 0xee0f6300
    li x3, 0xee0f6300
    csrw 0x1d, x3

    #Address 0x1d read value
    csrr x14, 0x1d

    #Unmapped address 0xe9c testing: Read Reset + Random data Write/Read
    #Address 0xe9c read value
    csrr x14, 0xe9c

    #Address 0xe9c Write value 0x2ae4fd1b
    li x3, 0x2ae4fd1b
    csrw 0xe9c, x3

    #Address 0xe9c read value
    csrr x14, 0xe9c

    #Unmapped address 0xe30 testing: Read Reset + Random data Write/Read
    #Address 0xe30 read value
    csrr x14, 0xe30

    #Address 0xe30 Write value 0xa2f5b82e
    li x3, 0xa2f5b82e
    csrw 0xe30, x3

    #Address 0xe30 read value
    csrr x14, 0xe30

    #Unmapped address 0x870 testing: Read Reset + Random data Write/Read
    #Address 0x870 read value
    csrr x14, 0x870

    #Address 0x870 Write value 0x3166be3a
    li x3, 0x3166be3a
    csrw 0x870, x3

    #Address 0x870 read value
    csrr x14, 0x870

    #Unmapped address 0x9e5 testing: Read Reset + Random data Write/Read
    #Address 0x9e5 read value
    csrr x14, 0x9e5

    #Address 0x9e5 Write value 0x9c98b08
    li x3, 0x9c98b08
    csrw 0x9e5, x3

    #Address 0x9e5 read value
    csrr x14, 0x9e5

    #Unmapped address 0x7e0 testing: Read Reset + Random data Write/Read
    #Address 0x7e0 read value
    csrr x14, 0x7e0

    #Address 0x7e0 Write value 0xdbc7b8ca
    li x3, 0xdbc7b8ca
    csrw 0x7e0, x3

    #Address 0x7e0 read value
    csrr x14, 0x7e0

    #Unmapped address 0x1c6 testing: Read Reset + Random data Write/Read
    #Address 0x1c6 read value
    csrr x14, 0x1c6

    #Address 0x1c6 Write value 0x88728a16
    li x3, 0x88728a16
    csrw 0x1c6, x3

    #Address 0x1c6 read value
    csrr x14, 0x1c6

    #Unmapped address 0xca5 testing: Read Reset + Random data Write/Read
    #Address 0xca5 read value
    csrr x14, 0xca5

    #Address 0xca5 Write value 0xc9fff530
    li x3, 0xc9fff530
    csrw 0xca5, x3

    #Address 0xca5 read value
    csrr x14, 0xca5

    #Unmapped address 0xaaf testing: Read Reset + Random data Write/Read
    #Address 0xaaf read value
    csrr x14, 0xaaf

    #Address 0xaaf Write value 0xd21f04a9
    li x3, 0xd21f04a9
    csrw 0xaaf, x3

    #Address 0xaaf read value
    csrr x14, 0xaaf

    #Unmapped address 0xeed testing: Read Reset + Random data Write/Read
    #Address 0xeed read value
    csrr x14, 0xeed

    #Address 0xeed Write value 0xf3b54015
    li x3, 0xf3b54015
    csrw 0xeed, x3

    #Address 0xeed read value
    csrr x14, 0xeed

    #Unmapped address 0x8a4 testing: Read Reset + Random data Write/Read
    #Address 0x8a4 read value
    csrr x14, 0x8a4

    #Address 0x8a4 Write value 0x871071d
    li x3, 0x871071d
    csrw 0x8a4, x3

    #Address 0x8a4 read value
    csrr x14, 0x8a4

    #Unmapped address 0xdf9 testing: Read Reset + Random data Write/Read
    #Address 0xdf9 read value
    csrr x14, 0xdf9

    #Address 0xdf9 Write value 0x67fbc6fc
    li x3, 0x67fbc6fc
    csrw 0xdf9, x3

    #Address 0xdf9 read value
    csrr x14, 0xdf9

    #Unmapped address 0xc7f testing: Read Reset + Random data Write/Read
    #Address 0xc7f read value
    csrr x14, 0xc7f

    #Address 0xc7f Write value 0x3c08b8c0
    li x3, 0x3c08b8c0
    csrw 0xc7f, x3

    #Address 0xc7f read value
    csrr x14, 0xc7f

    #Unmapped address 0xd95 testing: Read Reset + Random data Write/Read
    #Address 0xd95 read value
    csrr x14, 0xd95

    #Address 0xd95 Write value 0xb1fc9325
    li x3, 0xb1fc9325
    csrw 0xd95, x3

    #Address 0xd95 read value
    csrr x14, 0xd95

    #Unmapped address 0x2f2 testing: Read Reset + Random data Write/Read
    #Address 0x2f2 read value
    csrr x14, 0x2f2

    #Address 0x2f2 Write value 0xd2a0c899
    li x3, 0xd2a0c899
    csrw 0x2f2, x3

    #Address 0x2f2 read value
    csrr x14, 0x2f2

    #Unmapped address 0x613 testing: Read Reset + Random data Write/Read
    #Address 0x613 read value
    csrr x14, 0x613

    #Address 0x613 Write value 0xbbeb2e63
    li x3, 0xbbeb2e63
    csrw 0x613, x3

    #Address 0x613 read value
    csrr x14, 0x613

    #Unmapped address 0x21d testing: Read Reset + Random data Write/Read
    #Address 0x21d read value
    csrr x14, 0x21d

    #Address 0x21d Write value 0xd5225daf
    li x3, 0xd5225daf
    csrw 0x21d, x3

    #Address 0x21d read value
    csrr x14, 0x21d

    #Unmapped address 0x1bb testing: Read Reset + Random data Write/Read
    #Address 0x1bb read value
    csrr x14, 0x1bb

    #Address 0x1bb Write value 0x5d4f9315
    li x3, 0x5d4f9315
    csrw 0x1bb, x3

    #Address 0x1bb read value
    csrr x14, 0x1bb

    #Unmapped address 0x318 testing: Read Reset + Random data Write/Read
    #Address 0x318 read value
    csrr x14, 0x318

    #Address 0x318 Write value 0xd483e238
    li x3, 0xd483e238
    csrw 0x318, x3

    #Address 0x318 read value
    csrr x14, 0x318

    #Unmapped address 0x149 testing: Read Reset + Random data Write/Read
    #Address 0x149 read value
    csrr x14, 0x149

    #Address 0x149 Write value 0x76589e0c
    li x3, 0x76589e0c
    csrw 0x149, x3

    #Address 0x149 read value
    csrr x14, 0x149

    #Unmapped address 0x9c8 testing: Read Reset + Random data Write/Read
    #Address 0x9c8 read value
    csrr x14, 0x9c8

    #Address 0x9c8 Write value 0xffd03926
    li x3, 0xffd03926
    csrw 0x9c8, x3

    #Address 0x9c8 read value
    csrr x14, 0x9c8

    #Unmapped address 0x9c3 testing: Read Reset + Random data Write/Read
    #Address 0x9c3 read value
    csrr x14, 0x9c3

    #Address 0x9c3 Write value 0x14720cdf
    li x3, 0x14720cdf
    csrw 0x9c3, x3

    #Address 0x9c3 read value
    csrr x14, 0x9c3

    #Unmapped address 0xcd2 testing: Read Reset + Random data Write/Read
    #Address 0xcd2 read value
    csrr x14, 0xcd2

    #Address 0xcd2 Write value 0x3cf17084
    li x3, 0x3cf17084
    csrw 0xcd2, x3

    #Address 0xcd2 read value
    csrr x14, 0xcd2

    #Unmapped address 0x3d0 testing: Read Reset + Random data Write/Read
    #Address 0x3d0 read value
    csrr x14, 0x3d0

    #Address 0x3d0 Write value 0x304ec55f
    li x3, 0x304ec55f
    csrw 0x3d0, x3

    #Address 0x3d0 read value
    csrr x14, 0x3d0

    #Unmapped address 0x878 testing: Read Reset + Random data Write/Read
    #Address 0x878 read value
    csrr x14, 0x878

    #Address 0x878 Write value 0x6245d953
    li x3, 0x6245d953
    csrw 0x878, x3

    #Address 0x878 read value
    csrr x14, 0x878

    #Unmapped address 0xb66 testing: Read Reset + Random data Write/Read
    #Address 0xb66 read value
    csrr x14, 0xb66

    #Address 0xb66 Write value 0x83f217b7
    li x3, 0x83f217b7
    csrw 0xb66, x3

    #Address 0xb66 read value
    csrr x14, 0xb66

    #Unmapped address 0x217 testing: Read Reset + Random data Write/Read
    #Address 0x217 read value
    csrr x14, 0x217

    #Address 0x217 Write value 0xa9316484
    li x3, 0xa9316484
    csrw 0x217, x3

    #Address 0x217 read value
    csrr x14, 0x217

    #Unmapped address 0xc09 testing: Read Reset + Random data Write/Read
    #Address 0xc09 read value
    csrr x14, 0xc09

    #Address 0xc09 Write value 0x81cadcbe
    li x3, 0x81cadcbe
    csrw 0xc09, x3

    #Address 0xc09 read value
    csrr x14, 0xc09

    #Unmapped address 0x379 testing: Read Reset + Random data Write/Read
    #Address 0x379 read value
    csrr x14, 0x379

    #Address 0x379 Write value 0x2ad3eb71
    li x3, 0x2ad3eb71
    csrw 0x379, x3

    #Address 0x379 read value
    csrr x14, 0x379

    #Unmapped address 0xec6 testing: Read Reset + Random data Write/Read
    #Address 0xec6 read value
    csrr x14, 0xec6

    #Address 0xec6 Write value 0xc0370cee
    li x3, 0xc0370cee
    csrw 0xec6, x3

    #Address 0xec6 read value
    csrr x14, 0xec6

    #Unmapped address 0xc89 testing: Read Reset + Random data Write/Read
    #Address 0xc89 read value
    csrr x14, 0xc89

    #Address 0xc89 Write value 0x36115f09
    li x3, 0x36115f09
    csrw 0xc89, x3

    #Address 0xc89 read value
    csrr x14, 0xc89

    #Unmapped address 0xe8a testing: Read Reset + Random data Write/Read
    #Address 0xe8a read value
    csrr x14, 0xe8a

    #Address 0xe8a Write value 0xb9904bc5
    li x3, 0xb9904bc5
    csrw 0xe8a, x3

    #Address 0xe8a read value
    csrr x14, 0xe8a

    #Unmapped address 0xe37 testing: Read Reset + Random data Write/Read
    #Address 0xe37 read value
    csrr x14, 0xe37

    #Address 0xe37 Write value 0xc8c832f1
    li x3, 0xc8c832f1
    csrw 0xe37, x3

    #Address 0xe37 read value
    csrr x14, 0xe37

    #Unmapped address 0xd35 testing: Read Reset + Random data Write/Read
    #Address 0xd35 read value
    csrr x14, 0xd35

    #Address 0xd35 Write value 0x14a24a88
    li x3, 0x14a24a88
    csrw 0xd35, x3

    #Address 0xd35 read value
    csrr x14, 0xd35

    #Unmapped address 0xe56 testing: Read Reset + Random data Write/Read
    #Address 0xe56 read value
    csrr x14, 0xe56

    #Address 0xe56 Write value 0x3147b9bd
    li x3, 0x3147b9bd
    csrw 0xe56, x3

    #Address 0xe56 read value
    csrr x14, 0xe56

    #Unmapped address 0xc5c testing: Read Reset + Random data Write/Read
    #Address 0xc5c read value
    csrr x14, 0xc5c

    #Address 0xc5c Write value 0x81c8c152
    li x3, 0x81c8c152
    csrw 0xc5c, x3

    #Address 0xc5c read value
    csrr x14, 0xc5c

    #Unmapped address 0xf9d testing: Read Reset + Random data Write/Read
    #Address 0xf9d read value
    csrr x14, 0xf9d

    #Address 0xf9d Write value 0x12341d20
    li x3, 0x12341d20
    csrw 0xf9d, x3

    #Address 0xf9d read value
    csrr x14, 0xf9d

    #Unmapped address 0xa5d testing: Read Reset + Random data Write/Read
    #Address 0xa5d read value
    csrr x14, 0xa5d

    #Address 0xa5d Write value 0xcadd4f91
    li x3, 0xcadd4f91
    csrw 0xa5d, x3

    #Address 0xa5d read value
    csrr x14, 0xa5d

    #Unmapped address 0xee2 testing: Read Reset + Random data Write/Read
    #Address 0xee2 read value
    csrr x14, 0xee2

    #Address 0xee2 Write value 0x8069a7ca
    li x3, 0x8069a7ca
    csrw 0xee2, x3

    #Address 0xee2 read value
    csrr x14, 0xee2

    #Unmapped address 0xaac testing: Read Reset + Random data Write/Read
    #Address 0xaac read value
    csrr x14, 0xaac

    #Address 0xaac Write value 0xac8f7672
    li x3, 0xac8f7672
    csrw 0xaac, x3

    #Address 0xaac read value
    csrr x14, 0xaac

    #Unmapped address 0xde1 testing: Read Reset + Random data Write/Read
    #Address 0xde1 read value
    csrr x14, 0xde1

    #Address 0xde1 Write value 0x492a1768
    li x3, 0x492a1768
    csrw 0xde1, x3

    #Address 0xde1 read value
    csrr x14, 0xde1

    #Unmapped address 0x70d testing: Read Reset + Random data Write/Read
    #Address 0x70d read value
    csrr x14, 0x70d

    #Address 0x70d Write value 0x4a4ea2cd
    li x3, 0x4a4ea2cd
    csrw 0x70d, x3

    #Address 0x70d read value
    csrr x14, 0x70d

    #Unmapped address 0x428 testing: Read Reset + Random data Write/Read
    #Address 0x428 read value
    csrr x14, 0x428

    #Address 0x428 Write value 0xe5a02272
    li x3, 0xe5a02272
    csrw 0x428, x3

    #Address 0x428 read value
    csrr x14, 0x428

    #Unmapped address 0x757 testing: Read Reset + Random data Write/Read
    #Address 0x757 read value
    csrr x14, 0x757

    #Address 0x757 Write value 0xd6831ffa
    li x3, 0xd6831ffa
    csrw 0x757, x3

    #Address 0x757 read value
    csrr x14, 0x757

    #Unmapped address 0x28 testing: Read Reset + Random data Write/Read
    #Address 0x28 read value
    csrr x14, 0x28

    #Address 0x28 Write value 0x64159c29
    li x3, 0x64159c29
    csrw 0x28, x3

    #Address 0x28 read value
    csrr x14, 0x28

    #Unmapped address 0x293 testing: Read Reset + Random data Write/Read
    #Address 0x293 read value
    csrr x14, 0x293

    #Address 0x293 Write value 0xca9d1706
    li x3, 0xca9d1706
    csrw 0x293, x3

    #Address 0x293 read value
    csrr x14, 0x293

    #Unmapped address 0xd7f testing: Read Reset + Random data Write/Read
    #Address 0xd7f read value
    csrr x14, 0xd7f

    #Address 0xd7f Write value 0x5d3c1b1b
    li x3, 0x5d3c1b1b
    csrw 0xd7f, x3

    #Address 0xd7f read value
    csrr x14, 0xd7f

    #Unmapped address 0xbbc testing: Read Reset + Random data Write/Read
    #Address 0xbbc read value
    csrr x14, 0xbbc

    #Address 0xbbc Write value 0x82d8ccc1
    li x3, 0x82d8ccc1
    csrw 0xbbc, x3

    #Address 0xbbc read value
    csrr x14, 0xbbc

    #Unmapped address 0x92f testing: Read Reset + Random data Write/Read
    #Address 0x92f read value
    csrr x14, 0x92f

    #Address 0x92f Write value 0xbfcc95da
    li x3, 0xbfcc95da
    csrw 0x92f, x3

    #Address 0x92f read value
    csrr x14, 0x92f

    #Unmapped address 0x3fd testing: Read Reset + Random data Write/Read
    #Address 0x3fd read value
    csrr x14, 0x3fd

    #Address 0x3fd Write value 0x4ff0de63
    li x3, 0x4ff0de63
    csrw 0x3fd, x3

    #Address 0x3fd read value
    csrr x14, 0x3fd

    #Unmapped address 0x36a testing: Read Reset + Random data Write/Read
    #Address 0x36a read value
    csrr x14, 0x36a

    #Address 0x36a Write value 0x2c51e86b
    li x3, 0x2c51e86b
    csrw 0x36a, x3

    #Address 0x36a read value
    csrr x14, 0x36a

    #Unmapped address 0xaa7 testing: Read Reset + Random data Write/Read
    #Address 0xaa7 read value
    csrr x14, 0xaa7

    #Address 0xaa7 Write value 0xe6f92761
    li x3, 0xe6f92761
    csrw 0xaa7, x3

    #Address 0xaa7 read value
    csrr x14, 0xaa7

    #Unmapped address 0x113 testing: Read Reset + Random data Write/Read
    #Address 0x113 read value
    csrr x14, 0x113

    #Address 0x113 Write value 0xd70a5bb
    li x3, 0xd70a5bb
    csrw 0x113, x3

    #Address 0x113 read value
    csrr x14, 0x113

    #Unmapped address 0xec7 testing: Read Reset + Random data Write/Read
    #Address 0xec7 read value
    csrr x14, 0xec7

    #Address 0xec7 Write value 0x3eab6d3f
    li x3, 0x3eab6d3f
    csrw 0xec7, x3

    #Address 0xec7 read value
    csrr x14, 0xec7

    #Unmapped address 0x739 testing: Read Reset + Random data Write/Read
    #Address 0x739 read value
    csrr x14, 0x739

    #Address 0x739 Write value 0x38c2b251
    li x3, 0x38c2b251
    csrw 0x739, x3

    #Address 0x739 read value
    csrr x14, 0x739

    #Unmapped address 0x827 testing: Read Reset + Random data Write/Read
    #Address 0x827 read value
    csrr x14, 0x827

    #Address 0x827 Write value 0xdb08033c
    li x3, 0xdb08033c
    csrw 0x827, x3

    #Address 0x827 read value
    csrr x14, 0x827

    #Unmapped address 0xa9 testing: Read Reset + Random data Write/Read
    #Address 0xa9 read value
    csrr x14, 0xa9

    #Address 0xa9 Write value 0xfdf1d910
    li x3, 0xfdf1d910
    csrw 0xa9, x3

    #Address 0xa9 read value
    csrr x14, 0xa9

    #Unmapped address 0xfa2 testing: Read Reset + Random data Write/Read
    #Address 0xfa2 read value
    csrr x14, 0xfa2

    #Address 0xfa2 Write value 0xfd80e859
    li x3, 0xfd80e859
    csrw 0xfa2, x3

    #Address 0xfa2 read value
    csrr x14, 0xfa2

    #Unmapped address 0x8a3 testing: Read Reset + Random data Write/Read
    #Address 0x8a3 read value
    csrr x14, 0x8a3

    #Address 0x8a3 Write value 0xed60b587
    li x3, 0xed60b587
    csrw 0x8a3, x3

    #Address 0x8a3 read value
    csrr x14, 0x8a3

    #Unmapped address 0xae3 testing: Read Reset + Random data Write/Read
    #Address 0xae3 read value
    csrr x14, 0xae3

    #Address 0xae3 Write value 0x58d48b35
    li x3, 0x58d48b35
    csrw 0xae3, x3

    #Address 0xae3 read value
    csrr x14, 0xae3

    #Unmapped address 0xf4 testing: Read Reset + Random data Write/Read
    #Address 0xf4 read value
    csrr x14, 0xf4

    #Address 0xf4 Write value 0x39fcd6c1
    li x3, 0x39fcd6c1
    csrw 0xf4, x3

    #Address 0xf4 read value
    csrr x14, 0xf4

    #Unmapped address 0xd58 testing: Read Reset + Random data Write/Read
    #Address 0xd58 read value
    csrr x14, 0xd58

    #Address 0xd58 Write value 0x1374bb5d
    li x3, 0x1374bb5d
    csrw 0xd58, x3

    #Address 0xd58 read value
    csrr x14, 0xd58

    #Unmapped address 0xbc testing: Read Reset + Random data Write/Read
    #Address 0xbc read value
    csrr x14, 0xbc

    #Address 0xbc Write value 0xcaece227
    li x3, 0xcaece227
    csrw 0xbc, x3

    #Address 0xbc read value
    csrr x14, 0xbc

    #Unmapped address 0xd09 testing: Read Reset + Random data Write/Read
    #Address 0xd09 read value
    csrr x14, 0xd09

    #Address 0xd09 Write value 0xa2fd6fc1
    li x3, 0xa2fd6fc1
    csrw 0xd09, x3

    #Address 0xd09 read value
    csrr x14, 0xd09

    #Unmapped address 0x6e4 testing: Read Reset + Random data Write/Read
    #Address 0x6e4 read value
    csrr x14, 0x6e4

    #Address 0x6e4 Write value 0x889bb8bd
    li x3, 0x889bb8bd
    csrw 0x6e4, x3

    #Address 0x6e4 read value
    csrr x14, 0x6e4

    #Unmapped address 0x5b7 testing: Read Reset + Random data Write/Read
    #Address 0x5b7 read value
    csrr x14, 0x5b7

    #Address 0x5b7 Write value 0x97508e44
    li x3, 0x97508e44
    csrw 0x5b7, x3

    #Address 0x5b7 read value
    csrr x14, 0x5b7

    #Unmapped address 0x105 testing: Read Reset + Random data Write/Read
    #Address 0x105 read value
    csrr x14, 0x105

    #Address 0x105 Write value 0xc02714e
    li x3, 0xc02714e
    csrw 0x105, x3

    #Address 0x105 read value
    csrr x14, 0x105

    #Unmapped address 0xfca testing: Read Reset + Random data Write/Read
    #Address 0xfca read value
    csrr x14, 0xfca

    #Address 0xfca Write value 0x82c750e5
    li x3, 0x82c750e5
    csrw 0xfca, x3

    #Address 0xfca read value
    csrr x14, 0xfca

    #Unmapped address 0xf58 testing: Read Reset + Random data Write/Read
    #Address 0xf58 read value
    csrr x14, 0xf58

    #Address 0xf58 Write value 0xdb2344e3
    li x3, 0xdb2344e3
    csrw 0xf58, x3

    #Address 0xf58 read value
    csrr x14, 0xf58

    #Unmapped address 0x95f testing: Read Reset + Random data Write/Read
    #Address 0x95f read value
    csrr x14, 0x95f

    #Address 0x95f Write value 0x5a726dbc
    li x3, 0x5a726dbc
    csrw 0x95f, x3

    #Address 0x95f read value
    csrr x14, 0x95f

    #Unmapped address 0x2d7 testing: Read Reset + Random data Write/Read
    #Address 0x2d7 read value
    csrr x14, 0x2d7

    #Address 0x2d7 Write value 0x2d23d2b5
    li x3, 0x2d23d2b5
    csrw 0x2d7, x3

    #Address 0x2d7 read value
    csrr x14, 0x2d7

    #Unmapped address 0x570 testing: Read Reset + Random data Write/Read
    #Address 0x570 read value
    csrr x14, 0x570

    #Address 0x570 Write value 0x631f70d6
    li x3, 0x631f70d6
    csrw 0x570, x3

    #Address 0x570 read value
    csrr x14, 0x570

    #Unmapped address 0xed0 testing: Read Reset + Random data Write/Read
    #Address 0xed0 read value
    csrr x14, 0xed0

    #Address 0xed0 Write value 0x61f20f8e
    li x3, 0x61f20f8e
    csrw 0xed0, x3

    #Address 0xed0 read value
    csrr x14, 0xed0

    #Unmapped address 0x708 testing: Read Reset + Random data Write/Read
    #Address 0x708 read value
    csrr x14, 0x708

    #Address 0x708 Write value 0x4835876c
    li x3, 0x4835876c
    csrw 0x708, x3

    #Address 0x708 read value
    csrr x14, 0x708

    #Unmapped address 0x25c testing: Read Reset + Random data Write/Read
    #Address 0x25c read value
    csrr x14, 0x25c

    #Address 0x25c Write value 0xc0c778f1
    li x3, 0xc0c778f1
    csrw 0x25c, x3

    #Address 0x25c read value
    csrr x14, 0x25c

    #Unmapped address 0x24b testing: Read Reset + Random data Write/Read
    #Address 0x24b read value
    csrr x14, 0x24b

    #Address 0x24b Write value 0x444276e7
    li x3, 0x444276e7
    csrw 0x24b, x3

    #Address 0x24b read value
    csrr x14, 0x24b

    #Unmapped address 0x180 testing: Read Reset + Random data Write/Read
    #Address 0x180 read value
    csrr x14, 0x180

    #Address 0x180 Write value 0xcdf76097
    li x3, 0xcdf76097
    csrw 0x180, x3

    #Address 0x180 read value
    csrr x14, 0x180

    #Unmapped address 0x2d testing: Read Reset + Random data Write/Read
    #Address 0x2d read value
    csrr x14, 0x2d

    #Address 0x2d Write value 0x47f49ba2
    li x3, 0x47f49ba2
    csrw 0x2d, x3

    #Address 0x2d read value
    csrr x14, 0x2d

    #Unmapped address 0xe96 testing: Read Reset + Random data Write/Read
    #Address 0xe96 read value
    csrr x14, 0xe96

    #Address 0xe96 Write value 0x5a0fe37f
    li x3, 0x5a0fe37f
    csrw 0xe96, x3

    #Address 0xe96 read value
    csrr x14, 0xe96

    #Unmapped address 0x7e2 testing: Read Reset + Random data Write/Read
    #Address 0x7e2 read value
    csrr x14, 0x7e2

    #Address 0x7e2 Write value 0x7465ab6
    li x3, 0x7465ab6
    csrw 0x7e2, x3

    #Address 0x7e2 read value
    csrr x14, 0x7e2

    #Unmapped address 0x9b2 testing: Read Reset + Random data Write/Read
    #Address 0x9b2 read value
    csrr x14, 0x9b2

    #Address 0x9b2 Write value 0x3eab1990
    li x3, 0x3eab1990
    csrw 0x9b2, x3

    #Address 0x9b2 read value
    csrr x14, 0x9b2

    #Unmapped address 0x279 testing: Read Reset + Random data Write/Read
    #Address 0x279 read value
    csrr x14, 0x279

    #Address 0x279 Write value 0xd12b8a90
    li x3, 0xd12b8a90
    csrw 0x279, x3

    #Address 0x279 read value
    csrr x14, 0x279

    #Unmapped address 0xab0 testing: Read Reset + Random data Write/Read
    #Address 0xab0 read value
    csrr x14, 0xab0

    #Address 0xab0 Write value 0x81cb5db1
    li x3, 0x81cb5db1
    csrw 0xab0, x3

    #Address 0xab0 read value
    csrr x14, 0xab0

    #Unmapped address 0xd1 testing: Read Reset + Random data Write/Read
    #Address 0xd1 read value
    csrr x14, 0xd1

    #Address 0xd1 Write value 0x65aa49e6
    li x3, 0x65aa49e6
    csrw 0xd1, x3

    #Address 0xd1 read value
    csrr x14, 0xd1

    #Unmapped address 0x4e7 testing: Read Reset + Random data Write/Read
    #Address 0x4e7 read value
    csrr x14, 0x4e7

    #Address 0x4e7 Write value 0xa465460f
    li x3, 0xa465460f
    csrw 0x4e7, x3

    #Address 0x4e7 read value
    csrr x14, 0x4e7

    #Unmapped address 0x7ff testing: Read Reset + Random data Write/Read
    #Address 0x7ff read value
    csrr x14, 0x7ff

    #Address 0x7ff Write value 0x66d51b9d
    li x3, 0x66d51b9d
    csrw 0x7ff, x3

    #Address 0x7ff read value
    csrr x14, 0x7ff

    #Unmapped address 0xaff testing: Read Reset + Random data Write/Read
    #Address 0xaff read value
    csrr x14, 0xaff

    #Address 0xaff Write value 0x5c7dc6c7
    li x3, 0x5c7dc6c7
    csrw 0xaff, x3

    #Address 0xaff read value
    csrr x14, 0xaff

    #Unmapped address 0xf1b testing: Read Reset + Random data Write/Read
    #Address 0xf1b read value
    csrr x14, 0xf1b

    #Address 0xf1b Write value 0x4fcf46fc
    li x3, 0x4fcf46fc
    csrw 0xf1b, x3

    #Address 0xf1b read value
    csrr x14, 0xf1b

    #Unmapped address 0x109 testing: Read Reset + Random data Write/Read
    #Address 0x109 read value
    csrr x14, 0x109

    #Address 0x109 Write value 0x5dbabfdf
    li x3, 0x5dbabfdf
    csrw 0x109, x3

    #Address 0x109 read value
    csrr x14, 0x109

    #Unmapped address 0xf8b testing: Read Reset + Random data Write/Read
    #Address 0xf8b read value
    csrr x14, 0xf8b

    #Address 0xf8b Write value 0xaab8db1
    li x3, 0xaab8db1
    csrw 0xf8b, x3

    #Address 0xf8b read value
    csrr x14, 0xf8b

    #Unmapped address 0xedf testing: Read Reset + Random data Write/Read
    #Address 0xedf read value
    csrr x14, 0xedf

    #Address 0xedf Write value 0x9807c0bd
    li x3, 0x9807c0bd
    csrw 0xedf, x3

    #Address 0xedf read value
    csrr x14, 0xedf

    #Unmapped address 0xc67 testing: Read Reset + Random data Write/Read
    #Address 0xc67 read value
    csrr x14, 0xc67

    #Address 0xc67 Write value 0x729519ee
    li x3, 0x729519ee
    csrw 0xc67, x3

    #Address 0xc67 read value
    csrr x14, 0xc67

    #Unmapped address 0x116 testing: Read Reset + Random data Write/Read
    #Address 0x116 read value
    csrr x14, 0x116

    #Address 0x116 Write value 0xa191354d
    li x3, 0xa191354d
    csrw 0x116, x3

    #Address 0x116 read value
    csrr x14, 0x116

    #Unmapped address 0xcf1 testing: Read Reset + Random data Write/Read
    #Address 0xcf1 read value
    csrr x14, 0xcf1

    #Address 0xcf1 Write value 0x617347ef
    li x3, 0x617347ef
    csrw 0xcf1, x3

    #Address 0xcf1 read value
    csrr x14, 0xcf1

    #Unmapped address 0x406 testing: Read Reset + Random data Write/Read
    #Address 0x406 read value
    csrr x14, 0x406

    #Address 0x406 Write value 0xa8bbadfe
    li x3, 0xa8bbadfe
    csrw 0x406, x3

    #Address 0x406 read value
    csrr x14, 0x406

    #Unmapped address 0xedc testing: Read Reset + Random data Write/Read
    #Address 0xedc read value
    csrr x14, 0xedc

    #Address 0xedc Write value 0x7583b0a8
    li x3, 0x7583b0a8
    csrw 0xedc, x3

    #Address 0xedc read value
    csrr x14, 0xedc

    #Unmapped address 0x681 testing: Read Reset + Random data Write/Read
    #Address 0x681 read value
    csrr x14, 0x681

    #Address 0x681 Write value 0x18ec41f6
    li x3, 0x18ec41f6
    csrw 0x681, x3

    #Address 0x681 read value
    csrr x14, 0x681

    #Unmapped address 0x37a testing: Read Reset + Random data Write/Read
    #Address 0x37a read value
    csrr x14, 0x37a

    #Address 0x37a Write value 0x2aff6a35
    li x3, 0x2aff6a35
    csrw 0x37a, x3

    #Address 0x37a read value
    csrr x14, 0x37a

    #Unmapped address 0x9ba testing: Read Reset + Random data Write/Read
    #Address 0x9ba read value
    csrr x14, 0x9ba

    #Address 0x9ba Write value 0xd6a97cc5
    li x3, 0xd6a97cc5
    csrw 0x9ba, x3

    #Address 0x9ba read value
    csrr x14, 0x9ba

    #Unmapped address 0x7f5 testing: Read Reset + Random data Write/Read
    #Address 0x7f5 read value
    csrr x14, 0x7f5

    #Address 0x7f5 Write value 0xad99228c
    li x3, 0xad99228c
    csrw 0x7f5, x3

    #Address 0x7f5 read value
    csrr x14, 0x7f5

    #Unmapped address 0x12c testing: Read Reset + Random data Write/Read
    #Address 0x12c read value
    csrr x14, 0x12c

    #Address 0x12c Write value 0xa0e23b54
    li x3, 0xa0e23b54
    csrw 0x12c, x3

    #Address 0x12c read value
    csrr x14, 0x12c

    #Unmapped address 0x976 testing: Read Reset + Random data Write/Read
    #Address 0x976 read value
    csrr x14, 0x976

    #Address 0x976 Write value 0x5d7f2598
    li x3, 0x5d7f2598
    csrw 0x976, x3

    #Address 0x976 read value
    csrr x14, 0x976

    #Unmapped address 0xc68 testing: Read Reset + Random data Write/Read
    #Address 0xc68 read value
    csrr x14, 0xc68

    #Address 0xc68 Write value 0xc2c71a45
    li x3, 0xc2c71a45
    csrw 0xc68, x3

    #Address 0xc68 read value
    csrr x14, 0xc68

    #Unmapped address 0x933 testing: Read Reset + Random data Write/Read
    #Address 0x933 read value
    csrr x14, 0x933

    #Address 0x933 Write value 0x2bca13f5
    li x3, 0x2bca13f5
    csrw 0x933, x3

    #Address 0x933 read value
    csrr x14, 0x933

    #Unmapped address 0x264 testing: Read Reset + Random data Write/Read
    #Address 0x264 read value
    csrr x14, 0x264

    #Address 0x264 Write value 0x79829beb
    li x3, 0x79829beb
    csrw 0x264, x3

    #Address 0x264 read value
    csrr x14, 0x264

    #Unmapped address 0x543 testing: Read Reset + Random data Write/Read
    #Address 0x543 read value
    csrr x14, 0x543

    #Address 0x543 Write value 0x4cf3b285
    li x3, 0x4cf3b285
    csrw 0x543, x3

    #Address 0x543 read value
    csrr x14, 0x543

    #Unmapped address 0x72b testing: Read Reset + Random data Write/Read
    #Address 0x72b read value
    csrr x14, 0x72b

    #Address 0x72b Write value 0x4a6bfeea
    li x3, 0x4a6bfeea
    csrw 0x72b, x3

    #Address 0x72b read value
    csrr x14, 0x72b

    #Unmapped address 0xee3 testing: Read Reset + Random data Write/Read
    #Address 0xee3 read value
    csrr x14, 0xee3

    #Address 0xee3 Write value 0x2c95e126
    li x3, 0x2c95e126
    csrw 0xee3, x3

    #Address 0xee3 read value
    csrr x14, 0xee3

    #Unmapped address 0x6e7 testing: Read Reset + Random data Write/Read
    #Address 0x6e7 read value
    csrr x14, 0x6e7

    #Address 0x6e7 Write value 0x2bf1ffd2
    li x3, 0x2bf1ffd2
    csrw 0x6e7, x3

    #Address 0x6e7 read value
    csrr x14, 0x6e7

    #Unmapped address 0x297 testing: Read Reset + Random data Write/Read
    #Address 0x297 read value
    csrr x14, 0x297

    #Address 0x297 Write value 0x13ceaadb
    li x3, 0x13ceaadb
    csrw 0x297, x3

    #Address 0x297 read value
    csrr x14, 0x297

    #Unmapped address 0x9dc testing: Read Reset + Random data Write/Read
    #Address 0x9dc read value
    csrr x14, 0x9dc

    #Address 0x9dc Write value 0x132df171
    li x3, 0x132df171
    csrw 0x9dc, x3

    #Address 0x9dc read value
    csrr x14, 0x9dc

    #Unmapped address 0xc2a testing: Read Reset + Random data Write/Read
    #Address 0xc2a read value
    csrr x14, 0xc2a

    #Address 0xc2a Write value 0xd1ae0fac
    li x3, 0xd1ae0fac
    csrw 0xc2a, x3

    #Address 0xc2a read value
    csrr x14, 0xc2a

    #Unmapped address 0x275 testing: Read Reset + Random data Write/Read
    #Address 0x275 read value
    csrr x14, 0x275

    #Address 0x275 Write value 0xd5efb549
    li x3, 0xd5efb549
    csrw 0x275, x3

    #Address 0x275 read value
    csrr x14, 0x275

    #Unmapped address 0x148 testing: Read Reset + Random data Write/Read
    #Address 0x148 read value
    csrr x14, 0x148

    #Address 0x148 Write value 0x7ea68d34
    li x3, 0x7ea68d34
    csrw 0x148, x3

    #Address 0x148 read value
    csrr x14, 0x148

    #Unmapped address 0x511 testing: Read Reset + Random data Write/Read
    #Address 0x511 read value
    csrr x14, 0x511

    #Address 0x511 Write value 0x9e3c495f
    li x3, 0x9e3c495f
    csrw 0x511, x3

    #Address 0x511 read value
    csrr x14, 0x511

    #Unmapped address 0x349 testing: Read Reset + Random data Write/Read
    #Address 0x349 read value
    csrr x14, 0x349

    #Address 0x349 Write value 0xc9999ea7
    li x3, 0xc9999ea7
    csrw 0x349, x3

    #Address 0x349 read value
    csrr x14, 0x349

    #Unmapped address 0xd5d testing: Read Reset + Random data Write/Read
    #Address 0xd5d read value
    csrr x14, 0xd5d

    #Address 0xd5d Write value 0xa6c30218
    li x3, 0xa6c30218
    csrw 0xd5d, x3

    #Address 0xd5d read value
    csrr x14, 0xd5d

    #Unmapped address 0xe77 testing: Read Reset + Random data Write/Read
    #Address 0xe77 read value
    csrr x14, 0xe77

    #Address 0xe77 Write value 0xc4644869
    li x3, 0xc4644869
    csrw 0xe77, x3

    #Address 0xe77 read value
    csrr x14, 0xe77

    #Unmapped address 0xf testing: Read Reset + Random data Write/Read
    #Address 0xf read value
    csrr x14, 0xf

    #Address 0xf Write value 0x243cc0e6
    li x3, 0x243cc0e6
    csrw 0xf, x3

    #Address 0xf read value
    csrr x14, 0xf

    #Unmapped address 0xd69 testing: Read Reset + Random data Write/Read
    #Address 0xd69 read value
    csrr x14, 0xd69

    #Address 0xd69 Write value 0xd70bf4fc
    li x3, 0xd70bf4fc
    csrw 0xd69, x3

    #Address 0xd69 read value
    csrr x14, 0xd69

    #Unmapped address 0x60e testing: Read Reset + Random data Write/Read
    #Address 0x60e read value
    csrr x14, 0x60e

    #Address 0x60e Write value 0xfa843dc1
    li x3, 0xfa843dc1
    csrw 0x60e, x3

    #Address 0x60e read value
    csrr x14, 0x60e

    #Unmapped address 0x50b testing: Read Reset + Random data Write/Read
    #Address 0x50b read value
    csrr x14, 0x50b

    #Address 0x50b Write value 0x7788c72f
    li x3, 0x7788c72f
    csrw 0x50b, x3

    #Address 0x50b read value
    csrr x14, 0x50b

    #Unmapped address 0x720 testing: Read Reset + Random data Write/Read
    #Address 0x720 read value
    csrr x14, 0x720

    #Address 0x720 Write value 0x88fabb4f
    li x3, 0x88fabb4f
    csrw 0x720, x3

    #Address 0x720 read value
    csrr x14, 0x720

    #Unmapped address 0xca7 testing: Read Reset + Random data Write/Read
    #Address 0xca7 read value
    csrr x14, 0xca7

    #Address 0xca7 Write value 0xfb9a7c6
    li x3, 0xfb9a7c6
    csrw 0xca7, x3

    #Address 0xca7 read value
    csrr x14, 0xca7

    #Unmapped address 0x7c3 testing: Read Reset + Random data Write/Read
    #Address 0x7c3 read value
    csrr x14, 0x7c3

    #Address 0x7c3 Write value 0x20387868
    li x3, 0x20387868
    csrw 0x7c3, x3

    #Address 0x7c3 read value
    csrr x14, 0x7c3

    #Unmapped address 0x31d testing: Read Reset + Random data Write/Read
    #Address 0x31d read value
    csrr x14, 0x31d

    #Address 0x31d Write value 0x1242e041
    li x3, 0x1242e041
    csrw 0x31d, x3

    #Address 0x31d read value
    csrr x14, 0x31d

    #Unmapped address 0xefd testing: Read Reset + Random data Write/Read
    #Address 0xefd read value
    csrr x14, 0xefd

    #Address 0xefd Write value 0xf4358b38
    li x3, 0xf4358b38
    csrw 0xefd, x3

    #Address 0xefd read value
    csrr x14, 0xefd

    #Unmapped address 0x15a testing: Read Reset + Random data Write/Read
    #Address 0x15a read value
    csrr x14, 0x15a

    #Address 0x15a Write value 0x915c01da
    li x3, 0x915c01da
    csrw 0x15a, x3

    #Address 0x15a read value
    csrr x14, 0x15a

    #Unmapped address 0x151 testing: Read Reset + Random data Write/Read
    #Address 0x151 read value
    csrr x14, 0x151

    #Address 0x151 Write value 0x2c62f3cc
    li x3, 0x2c62f3cc
    csrw 0x151, x3

    #Address 0x151 read value
    csrr x14, 0x151

    #Unmapped address 0xce9 testing: Read Reset + Random data Write/Read
    #Address 0xce9 read value
    csrr x14, 0xce9

    #Address 0xce9 Write value 0xb8155d81
    li x3, 0xb8155d81
    csrw 0xce9, x3

    #Address 0xce9 read value
    csrr x14, 0xce9

    #Unmapped address 0xa0e testing: Read Reset + Random data Write/Read
    #Address 0xa0e read value
    csrr x14, 0xa0e

    #Address 0xa0e Write value 0x89fbe3bf
    li x3, 0x89fbe3bf
    csrw 0xa0e, x3

    #Address 0xa0e read value
    csrr x14, 0xa0e

    #Unmapped address 0x3c1 testing: Read Reset + Random data Write/Read
    #Address 0x3c1 read value
    csrr x14, 0x3c1

    #Address 0x3c1 Write value 0xf29f36fe
    li x3, 0xf29f36fe
    csrw 0x3c1, x3

    #Address 0x3c1 read value
    csrr x14, 0x3c1

    #Unmapped address 0x7a4 testing: Read Reset + Random data Write/Read
    #Address 0x7a4 read value
    csrr x14, 0x7a4

    #Address 0x7a4 Write value 0xe21cb797
    li x3, 0xe21cb797
    csrw 0x7a4, x3

    #Address 0x7a4 read value
    csrr x14, 0x7a4

    #Unmapped address 0x8ca testing: Read Reset + Random data Write/Read
    #Address 0x8ca read value
    csrr x14, 0x8ca

    #Address 0x8ca Write value 0x4c4c8749
    li x3, 0x4c4c8749
    csrw 0x8ca, x3

    #Address 0x8ca read value
    csrr x14, 0x8ca

    #Unmapped address 0x9ef testing: Read Reset + Random data Write/Read
    #Address 0x9ef read value
    csrr x14, 0x9ef

    #Address 0x9ef Write value 0xa69c89c
    li x3, 0xa69c89c
    csrw 0x9ef, x3

    #Address 0x9ef read value
    csrr x14, 0x9ef

    #Unmapped address 0xcc6 testing: Read Reset + Random data Write/Read
    #Address 0xcc6 read value
    csrr x14, 0xcc6

    #Address 0xcc6 Write value 0xbdfb50be
    li x3, 0xbdfb50be
    csrw 0xcc6, x3

    #Address 0xcc6 read value
    csrr x14, 0xcc6

    #Unmapped address 0x319 testing: Read Reset + Random data Write/Read
    #Address 0x319 read value
    csrr x14, 0x319

    #Address 0x319 Write value 0x76a2416d
    li x3, 0x76a2416d
    csrw 0x319, x3

    #Address 0x319 read value
    csrr x14, 0x319

    #Unmapped address 0x938 testing: Read Reset + Random data Write/Read
    #Address 0x938 read value
    csrr x14, 0x938

    #Address 0x938 Write value 0x79827f28
    li x3, 0x79827f28
    csrw 0x938, x3

    #Address 0x938 read value
    csrr x14, 0x938

    #Unmapped address 0x62d testing: Read Reset + Random data Write/Read
    #Address 0x62d read value
    csrr x14, 0x62d

    #Address 0x62d Write value 0xdff3d7d9
    li x3, 0xdff3d7d9
    csrw 0x62d, x3

    #Address 0x62d read value
    csrr x14, 0x62d

    #Unmapped address 0x7d4 testing: Read Reset + Random data Write/Read
    #Address 0x7d4 read value
    csrr x14, 0x7d4

    #Address 0x7d4 Write value 0x62cd7057
    li x3, 0x62cd7057
    csrw 0x7d4, x3

    #Address 0x7d4 read value
    csrr x14, 0x7d4

    #Unmapped address 0xaad testing: Read Reset + Random data Write/Read
    #Address 0xaad read value
    csrr x14, 0xaad

    #Address 0xaad Write value 0xe92f3c11
    li x3, 0xe92f3c11
    csrw 0xaad, x3

    #Address 0xaad read value
    csrr x14, 0xaad

    #Unmapped address 0xfb4 testing: Read Reset + Random data Write/Read
    #Address 0xfb4 read value
    csrr x14, 0xfb4

    #Address 0xfb4 Write value 0xb2f8a1b4
    li x3, 0xb2f8a1b4
    csrw 0xfb4, x3

    #Address 0xfb4 read value
    csrr x14, 0xfb4

    #Unmapped address 0x2bd testing: Read Reset + Random data Write/Read
    #Address 0x2bd read value
    csrr x14, 0x2bd

    #Address 0x2bd Write value 0x9837a53e
    li x3, 0x9837a53e
    csrw 0x2bd, x3

    #Address 0x2bd read value
    csrr x14, 0x2bd

    #Unmapped address 0xdcb testing: Read Reset + Random data Write/Read
    #Address 0xdcb read value
    csrr x14, 0xdcb

    #Address 0xdcb Write value 0x84fc1378
    li x3, 0x84fc1378
    csrw 0xdcb, x3

    #Address 0xdcb read value
    csrr x14, 0xdcb

    #Unmapped address 0x2e1 testing: Read Reset + Random data Write/Read
    #Address 0x2e1 read value
    csrr x14, 0x2e1

    #Address 0x2e1 Write value 0x29efae4a
    li x3, 0x29efae4a
    csrw 0x2e1, x3

    #Address 0x2e1 read value
    csrr x14, 0x2e1

    #Unmapped address 0xe74 testing: Read Reset + Random data Write/Read
    #Address 0xe74 read value
    csrr x14, 0xe74

    #Address 0xe74 Write value 0xac042644
    li x3, 0xac042644
    csrw 0xe74, x3

    #Address 0xe74 read value
    csrr x14, 0xe74

    #Unmapped address 0x645 testing: Read Reset + Random data Write/Read
    #Address 0x645 read value
    csrr x14, 0x645

    #Address 0x645 Write value 0xea4c4628
    li x3, 0xea4c4628
    csrw 0x645, x3

    #Address 0x645 read value
    csrr x14, 0x645

    #Unmapped address 0xff9 testing: Read Reset + Random data Write/Read
    #Address 0xff9 read value
    csrr x14, 0xff9

    #Address 0xff9 Write value 0x5abcaf33
    li x3, 0x5abcaf33
    csrw 0xff9, x3

    #Address 0xff9 read value
    csrr x14, 0xff9

    #Unmapped address 0xe4d testing: Read Reset + Random data Write/Read
    #Address 0xe4d read value
    csrr x14, 0xe4d

    #Address 0xe4d Write value 0xef0eafe1
    li x3, 0xef0eafe1
    csrw 0xe4d, x3

    #Address 0xe4d read value
    csrr x14, 0xe4d

    #Unmapped address 0x491 testing: Read Reset + Random data Write/Read
    #Address 0x491 read value
    csrr x14, 0x491

    #Address 0x491 Write value 0x1f565a69
    li x3, 0x1f565a69
    csrw 0x491, x3

    #Address 0x491 read value
    csrr x14, 0x491

    #Unmapped address 0x538 testing: Read Reset + Random data Write/Read
    #Address 0x538 read value
    csrr x14, 0x538

    #Address 0x538 Write value 0x77d659c
    li x3, 0x77d659c
    csrw 0x538, x3

    #Address 0x538 read value
    csrr x14, 0x538

    #Unmapped address 0x589 testing: Read Reset + Random data Write/Read
    #Address 0x589 read value
    csrr x14, 0x589

    #Address 0x589 Write value 0x859949c1
    li x3, 0x859949c1
    csrw 0x589, x3

    #Address 0x589 read value
    csrr x14, 0x589

    #Unmapped address 0x2e5 testing: Read Reset + Random data Write/Read
    #Address 0x2e5 read value
    csrr x14, 0x2e5

    #Address 0x2e5 Write value 0x12582d0
    li x3, 0x12582d0
    csrw 0x2e5, x3

    #Address 0x2e5 read value
    csrr x14, 0x2e5

    #Unmapped address 0x355 testing: Read Reset + Random data Write/Read
    #Address 0x355 read value
    csrr x14, 0x355

    #Address 0x355 Write value 0x62c878c5
    li x3, 0x62c878c5
    csrw 0x355, x3

    #Address 0x355 read value
    csrr x14, 0x355

    #Unmapped address 0xd19 testing: Read Reset + Random data Write/Read
    #Address 0xd19 read value
    csrr x14, 0xd19

    #Address 0xd19 Write value 0x26d67bf0
    li x3, 0x26d67bf0
    csrw 0xd19, x3

    #Address 0xd19 read value
    csrr x14, 0xd19

    #Unmapped address 0x23f testing: Read Reset + Random data Write/Read
    #Address 0x23f read value
    csrr x14, 0x23f

    #Address 0x23f Write value 0xd4331efd
    li x3, 0xd4331efd
    csrw 0x23f, x3

    #Address 0x23f read value
    csrr x14, 0x23f

    #Unmapped address 0x94b testing: Read Reset + Random data Write/Read
    #Address 0x94b read value
    csrr x14, 0x94b

    #Address 0x94b Write value 0xd0dcb1e1
    li x3, 0xd0dcb1e1
    csrw 0x94b, x3

    #Address 0x94b read value
    csrr x14, 0x94b

    #Unmapped address 0x19f testing: Read Reset + Random data Write/Read
    #Address 0x19f read value
    csrr x14, 0x19f

    #Address 0x19f Write value 0xe4abd19
    li x3, 0xe4abd19
    csrw 0x19f, x3

    #Address 0x19f read value
    csrr x14, 0x19f

    #Unmapped address 0xbed testing: Read Reset + Random data Write/Read
    #Address 0xbed read value
    csrr x14, 0xbed

    #Address 0xbed Write value 0x67f76685
    li x3, 0x67f76685
    csrw 0xbed, x3

    #Address 0xbed read value
    csrr x14, 0xbed

    #Unmapped address 0xf99 testing: Read Reset + Random data Write/Read
    #Address 0xf99 read value
    csrr x14, 0xf99

    #Address 0xf99 Write value 0xe92da200
    li x3, 0xe92da200
    csrw 0xf99, x3

    #Address 0xf99 read value
    csrr x14, 0xf99

    #Unmapped address 0x44d testing: Read Reset + Random data Write/Read
    #Address 0x44d read value
    csrr x14, 0x44d

    #Address 0x44d Write value 0xac096dc5
    li x3, 0xac096dc5
    csrw 0x44d, x3

    #Address 0x44d read value
    csrr x14, 0x44d

    #Unmapped address 0x96f testing: Read Reset + Random data Write/Read
    #Address 0x96f read value
    csrr x14, 0x96f

    #Address 0x96f Write value 0xea585bfa
    li x3, 0xea585bfa
    csrw 0x96f, x3

    #Address 0x96f read value
    csrr x14, 0x96f

    #Unmapped address 0x465 testing: Read Reset + Random data Write/Read
    #Address 0x465 read value
    csrr x14, 0x465

    #Address 0x465 Write value 0x3d42d97d
    li x3, 0x3d42d97d
    csrw 0x465, x3

    #Address 0x465 read value
    csrr x14, 0x465

    #Unmapped address 0x45 testing: Read Reset + Random data Write/Read
    #Address 0x45 read value
    csrr x14, 0x45

    #Address 0x45 Write value 0x2be448c
    li x3, 0x2be448c
    csrw 0x45, x3

    #Address 0x45 read value
    csrr x14, 0x45

    #Unmapped address 0xbb2 testing: Read Reset + Random data Write/Read
    #Address 0xbb2 read value
    csrr x14, 0xbb2

    #Address 0xbb2 Write value 0x4205b8b5
    li x3, 0x4205b8b5
    csrw 0xbb2, x3

    #Address 0xbb2 read value
    csrr x14, 0xbb2

    #Unmapped address 0x4f0 testing: Read Reset + Random data Write/Read
    #Address 0x4f0 read value
    csrr x14, 0x4f0

    #Address 0x4f0 Write value 0xfda2504d
    li x3, 0xfda2504d
    csrw 0x4f0, x3

    #Address 0x4f0 read value
    csrr x14, 0x4f0

    #Unmapped address 0x221 testing: Read Reset + Random data Write/Read
    #Address 0x221 read value
    csrr x14, 0x221

    #Address 0x221 Write value 0xdb6ead4e
    li x3, 0xdb6ead4e
    csrw 0x221, x3

    #Address 0x221 read value
    csrr x14, 0x221

    #Unmapped address 0x5b9 testing: Read Reset + Random data Write/Read
    #Address 0x5b9 read value
    csrr x14, 0x5b9

    #Address 0x5b9 Write value 0x4f7c3b8b
    li x3, 0x4f7c3b8b
    csrw 0x5b9, x3

    #Address 0x5b9 read value
    csrr x14, 0x5b9

    #Unmapped address 0x6fc testing: Read Reset + Random data Write/Read
    #Address 0x6fc read value
    csrr x14, 0x6fc

    #Address 0x6fc Write value 0x52de1961
    li x3, 0x52de1961
    csrw 0x6fc, x3

    #Address 0x6fc read value
    csrr x14, 0x6fc

    #Unmapped address 0xfe6 testing: Read Reset + Random data Write/Read
    #Address 0xfe6 read value
    csrr x14, 0xfe6

    #Address 0xfe6 Write value 0x2aeeab04
    li x3, 0x2aeeab04
    csrw 0xfe6, x3

    #Address 0xfe6 read value
    csrr x14, 0xfe6

    #Unmapped address 0x927 testing: Read Reset + Random data Write/Read
    #Address 0x927 read value
    csrr x14, 0x927

    #Address 0x927 Write value 0x713d9292
    li x3, 0x713d9292
    csrw 0x927, x3

    #Address 0x927 read value
    csrr x14, 0x927

    #Unmapped address 0xf1 testing: Read Reset + Random data Write/Read
    #Address 0xf1 read value
    csrr x14, 0xf1

    #Address 0xf1 Write value 0x7d7adb
    li x3, 0x7d7adb
    csrw 0xf1, x3

    #Address 0xf1 read value
    csrr x14, 0xf1

    #Unmapped address 0x704 testing: Read Reset + Random data Write/Read
    #Address 0x704 read value
    csrr x14, 0x704

    #Address 0x704 Write value 0x4e251d0c
    li x3, 0x4e251d0c
    csrw 0x704, x3

    #Address 0x704 read value
    csrr x14, 0x704

    #Unmapped address 0xfd8 testing: Read Reset + Random data Write/Read
    #Address 0xfd8 read value
    csrr x14, 0xfd8

    #Address 0xfd8 Write value 0xb8371157
    li x3, 0xb8371157
    csrw 0xfd8, x3

    #Address 0xfd8 read value
    csrr x14, 0xfd8

    #Unmapped address 0x544 testing: Read Reset + Random data Write/Read
    #Address 0x544 read value
    csrr x14, 0x544

    #Address 0x544 Write value 0x4777e19c
    li x3, 0x4777e19c
    csrw 0x544, x3

    #Address 0x544 read value
    csrr x14, 0x544

    #Unmapped address 0x426 testing: Read Reset + Random data Write/Read
    #Address 0x426 read value
    csrr x14, 0x426

    #Address 0x426 Write value 0x99cdcc89
    li x3, 0x99cdcc89
    csrw 0x426, x3

    #Address 0x426 read value
    csrr x14, 0x426

    #Unmapped address 0x74 testing: Read Reset + Random data Write/Read
    #Address 0x74 read value
    csrr x14, 0x74

    #Address 0x74 Write value 0x98d9bfc9
    li x3, 0x98d9bfc9
    csrw 0x74, x3

    #Address 0x74 read value
    csrr x14, 0x74

    #Unmapped address 0xf07 testing: Read Reset + Random data Write/Read
    #Address 0xf07 read value
    csrr x14, 0xf07

    #Address 0xf07 Write value 0x5f907fa8
    li x3, 0x5f907fa8
    csrw 0xf07, x3

    #Address 0xf07 read value
    csrr x14, 0xf07

    #Unmapped address 0xe6e testing: Read Reset + Random data Write/Read
    #Address 0xe6e read value
    csrr x14, 0xe6e

    #Address 0xe6e Write value 0xb6c16040
    li x3, 0xb6c16040
    csrw 0xe6e, x3

    #Address 0xe6e read value
    csrr x14, 0xe6e

    #Unmapped address 0x930 testing: Read Reset + Random data Write/Read
    #Address 0x930 read value
    csrr x14, 0x930

    #Address 0x930 Write value 0xa6d3df00
    li x3, 0xa6d3df00
    csrw 0x930, x3

    #Address 0x930 read value
    csrr x14, 0x930

    #Unmapped address 0x2a3 testing: Read Reset + Random data Write/Read
    #Address 0x2a3 read value
    csrr x14, 0x2a3

    #Address 0x2a3 Write value 0x265abf5c
    li x3, 0x265abf5c
    csrw 0x2a3, x3

    #Address 0x2a3 read value
    csrr x14, 0x2a3

    #Unmapped address 0x4ee testing: Read Reset + Random data Write/Read
    #Address 0x4ee read value
    csrr x14, 0x4ee

    #Address 0x4ee Write value 0x190aaae0
    li x3, 0x190aaae0
    csrw 0x4ee, x3

    #Address 0x4ee read value
    csrr x14, 0x4ee

    #Unmapped address 0x51c testing: Read Reset + Random data Write/Read
    #Address 0x51c read value
    csrr x14, 0x51c

    #Address 0x51c Write value 0x9e91bf8d
    li x3, 0x9e91bf8d
    csrw 0x51c, x3

    #Address 0x51c read value
    csrr x14, 0x51c

    #Unmapped address 0x152 testing: Read Reset + Random data Write/Read
    #Address 0x152 read value
    csrr x14, 0x152

    #Address 0x152 Write value 0xe51b629e
    li x3, 0xe51b629e
    csrw 0x152, x3

    #Address 0x152 read value
    csrr x14, 0x152

    #Unmapped address 0x819 testing: Read Reset + Random data Write/Read
    #Address 0x819 read value
    csrr x14, 0x819

    #Address 0x819 Write value 0x38f804ba
    li x3, 0x38f804ba
    csrw 0x819, x3

    #Address 0x819 read value
    csrr x14, 0x819

    #Unmapped address 0xf41 testing: Read Reset + Random data Write/Read
    #Address 0xf41 read value
    csrr x14, 0xf41

    #Address 0xf41 Write value 0x1a193c3a
    li x3, 0x1a193c3a
    csrw 0xf41, x3

    #Address 0xf41 read value
    csrr x14, 0xf41

    #Unmapped address 0xbf8 testing: Read Reset + Random data Write/Read
    #Address 0xbf8 read value
    csrr x14, 0xbf8

    #Address 0xbf8 Write value 0xd9335aed
    li x3, 0xd9335aed
    csrw 0xbf8, x3

    #Address 0xbf8 read value
    csrr x14, 0xbf8

    #Unmapped address 0xcb3 testing: Read Reset + Random data Write/Read
    #Address 0xcb3 read value
    csrr x14, 0xcb3

    #Address 0xcb3 Write value 0xd073bebd
    li x3, 0xd073bebd
    csrw 0xcb3, x3

    #Address 0xcb3 read value
    csrr x14, 0xcb3

    #Unmapped address 0x4c6 testing: Read Reset + Random data Write/Read
    #Address 0x4c6 read value
    csrr x14, 0x4c6

    #Address 0x4c6 Write value 0x231e0cf7
    li x3, 0x231e0cf7
    csrw 0x4c6, x3

    #Address 0x4c6 read value
    csrr x14, 0x4c6

    #Unmapped address 0xd96 testing: Read Reset + Random data Write/Read
    #Address 0xd96 read value
    csrr x14, 0xd96

    #Address 0xd96 Write value 0x7f5f3641
    li x3, 0x7f5f3641
    csrw 0xd96, x3

    #Address 0xd96 read value
    csrr x14, 0xd96

    #Unmapped address 0x3f testing: Read Reset + Random data Write/Read
    #Address 0x3f read value
    csrr x14, 0x3f

    #Address 0x3f Write value 0x592ece7
    li x3, 0x592ece7
    csrw 0x3f, x3

    #Address 0x3f read value
    csrr x14, 0x3f

    #Unmapped address 0x7ef testing: Read Reset + Random data Write/Read
    #Address 0x7ef read value
    csrr x14, 0x7ef

    #Address 0x7ef Write value 0xe9cf86fb
    li x3, 0xe9cf86fb
    csrw 0x7ef, x3

    #Address 0x7ef read value
    csrr x14, 0x7ef

    #Unmapped address 0x52b testing: Read Reset + Random data Write/Read
    #Address 0x52b read value
    csrr x14, 0x52b

    #Address 0x52b Write value 0x916da384
    li x3, 0x916da384
    csrw 0x52b, x3

    #Address 0x52b read value
    csrr x14, 0x52b

    #Unmapped address 0xeb1 testing: Read Reset + Random data Write/Read
    #Address 0xeb1 read value
    csrr x14, 0xeb1

    #Address 0xeb1 Write value 0x8d834dba
    li x3, 0x8d834dba
    csrw 0xeb1, x3

    #Address 0xeb1 read value
    csrr x14, 0xeb1

    #Unmapped address 0x631 testing: Read Reset + Random data Write/Read
    #Address 0x631 read value
    csrr x14, 0x631

    #Address 0x631 Write value 0x32f41ad7
    li x3, 0x32f41ad7
    csrw 0x631, x3

    #Address 0x631 read value
    csrr x14, 0x631

    #Unmapped address 0x430 testing: Read Reset + Random data Write/Read
    #Address 0x430 read value
    csrr x14, 0x430

    #Address 0x430 Write value 0xf1a4bcce
    li x3, 0xf1a4bcce
    csrw 0x430, x3

    #Address 0x430 read value
    csrr x14, 0x430

    #Unmapped address 0xd88 testing: Read Reset + Random data Write/Read
    #Address 0xd88 read value
    csrr x14, 0xd88

    #Address 0xd88 Write value 0x12586e91
    li x3, 0x12586e91
    csrw 0xd88, x3

    #Address 0xd88 read value
    csrr x14, 0xd88

    #Unmapped address 0x682 testing: Read Reset + Random data Write/Read
    #Address 0x682 read value
    csrr x14, 0x682

    #Address 0x682 Write value 0x4773c7bf
    li x3, 0x4773c7bf
    csrw 0x682, x3

    #Address 0x682 read value
    csrr x14, 0x682

    #Unmapped address 0xe8b testing: Read Reset + Random data Write/Read
    #Address 0xe8b read value
    csrr x14, 0xe8b

    #Address 0xe8b Write value 0x76a50db4
    li x3, 0x76a50db4
    csrw 0xe8b, x3

    #Address 0xe8b read value
    csrr x14, 0xe8b

    #Unmapped address 0x2c6 testing: Read Reset + Random data Write/Read
    #Address 0x2c6 read value
    csrr x14, 0x2c6

    #Address 0x2c6 Write value 0x6dedd61e
    li x3, 0x6dedd61e
    csrw 0x2c6, x3

    #Address 0x2c6 read value
    csrr x14, 0x2c6

    #Unmapped address 0xcfc testing: Read Reset + Random data Write/Read
    #Address 0xcfc read value
    csrr x14, 0xcfc

    #Address 0xcfc Write value 0x356ab664
    li x3, 0x356ab664
    csrw 0xcfc, x3

    #Address 0xcfc read value
    csrr x14, 0xcfc

    #Unmapped address 0x876 testing: Read Reset + Random data Write/Read
    #Address 0x876 read value
    csrr x14, 0x876

    #Address 0x876 Write value 0xafafdc5d
    li x3, 0xafafdc5d
    csrw 0x876, x3

    #Address 0x876 read value
    csrr x14, 0x876

    #Unmapped address 0x592 testing: Read Reset + Random data Write/Read
    #Address 0x592 read value
    csrr x14, 0x592

    #Address 0x592 Write value 0xac684926
    li x3, 0xac684926
    csrw 0x592, x3

    #Address 0x592 read value
    csrr x14, 0x592

    #Unmapped address 0x42f testing: Read Reset + Random data Write/Read
    #Address 0x42f read value
    csrr x14, 0x42f

    #Address 0x42f Write value 0x7955bf02
    li x3, 0x7955bf02
    csrw 0x42f, x3

    #Address 0x42f read value
    csrr x14, 0x42f

    #Unmapped address 0xbc9 testing: Read Reset + Random data Write/Read
    #Address 0xbc9 read value
    csrr x14, 0xbc9

    #Address 0xbc9 Write value 0xa35689d6
    li x3, 0xa35689d6
    csrw 0xbc9, x3

    #Address 0xbc9 read value
    csrr x14, 0xbc9

    #Unmapped address 0x3a8 testing: Read Reset + Random data Write/Read
    #Address 0x3a8 read value
    csrr x14, 0x3a8

    #Address 0x3a8 Write value 0x1877de2e
    li x3, 0x1877de2e
    csrw 0x3a8, x3

    #Address 0x3a8 read value
    csrr x14, 0x3a8

    #Unmapped address 0x54c testing: Read Reset + Random data Write/Read
    #Address 0x54c read value
    csrr x14, 0x54c

    #Address 0x54c Write value 0xf24caada
    li x3, 0xf24caada
    csrw 0x54c, x3

    #Address 0x54c read value
    csrr x14, 0x54c

    #Unmapped address 0x1c7 testing: Read Reset + Random data Write/Read
    #Address 0x1c7 read value
    csrr x14, 0x1c7

    #Address 0x1c7 Write value 0x90d88202
    li x3, 0x90d88202
    csrw 0x1c7, x3

    #Address 0x1c7 read value
    csrr x14, 0x1c7

    #Unmapped address 0xfd5 testing: Read Reset + Random data Write/Read
    #Address 0xfd5 read value
    csrr x14, 0xfd5

    #Address 0xfd5 Write value 0x65a66548
    li x3, 0x65a66548
    csrw 0xfd5, x3

    #Address 0xfd5 read value
    csrr x14, 0xfd5

    #Unmapped address 0xac8 testing: Read Reset + Random data Write/Read
    #Address 0xac8 read value
    csrr x14, 0xac8

    #Address 0xac8 Write value 0xb833df2a
    li x3, 0xb833df2a
    csrw 0xac8, x3

    #Address 0xac8 read value
    csrr x14, 0xac8

    #Unmapped address 0xaa5 testing: Read Reset + Random data Write/Read
    #Address 0xaa5 read value
    csrr x14, 0xaa5

    #Address 0xaa5 Write value 0xc7a1b6b1
    li x3, 0xc7a1b6b1
    csrw 0xaa5, x3

    #Address 0xaa5 read value
    csrr x14, 0xaa5

    #Unmapped address 0xe44 testing: Read Reset + Random data Write/Read
    #Address 0xe44 read value
    csrr x14, 0xe44

    #Address 0xe44 Write value 0x39a5ccfc
    li x3, 0x39a5ccfc
    csrw 0xe44, x3

    #Address 0xe44 read value
    csrr x14, 0xe44

    #Unmapped address 0x13b testing: Read Reset + Random data Write/Read
    #Address 0x13b read value
    csrr x14, 0x13b

    #Address 0x13b Write value 0x3415c8a9
    li x3, 0x3415c8a9
    csrw 0x13b, x3

    #Address 0x13b read value
    csrr x14, 0x13b

    #Unmapped address 0xf6e testing: Read Reset + Random data Write/Read
    #Address 0xf6e read value
    csrr x14, 0xf6e

    #Address 0xf6e Write value 0xd18664df
    li x3, 0xd18664df
    csrw 0xf6e, x3

    #Address 0xf6e read value
    csrr x14, 0xf6e

    #Unmapped address 0x271 testing: Read Reset + Random data Write/Read
    #Address 0x271 read value
    csrr x14, 0x271

    #Address 0x271 Write value 0xd5420c62
    li x3, 0xd5420c62
    csrw 0x271, x3

    #Address 0x271 read value
    csrr x14, 0x271

    #Unmapped address 0x8db testing: Read Reset + Random data Write/Read
    #Address 0x8db read value
    csrr x14, 0x8db

    #Address 0x8db Write value 0x62761e33
    li x3, 0x62761e33
    csrw 0x8db, x3

    #Address 0x8db read value
    csrr x14, 0x8db

    #Unmapped address 0x29f testing: Read Reset + Random data Write/Read
    #Address 0x29f read value
    csrr x14, 0x29f

    #Address 0x29f Write value 0x3bbcbb5f
    li x3, 0x3bbcbb5f
    csrw 0x29f, x3

    #Address 0x29f read value
    csrr x14, 0x29f

    #Unmapped address 0x245 testing: Read Reset + Random data Write/Read
    #Address 0x245 read value
    csrr x14, 0x245

    #Address 0x245 Write value 0x62d2c0a0
    li x3, 0x62d2c0a0
    csrw 0x245, x3

    #Address 0x245 read value
    csrr x14, 0x245

    #Unmapped address 0x476 testing: Read Reset + Random data Write/Read
    #Address 0x476 read value
    csrr x14, 0x476

    #Address 0x476 Write value 0x55743313
    li x3, 0x55743313
    csrw 0x476, x3

    #Address 0x476 read value
    csrr x14, 0x476

    #Unmapped address 0xfeb testing: Read Reset + Random data Write/Read
    #Address 0xfeb read value
    csrr x14, 0xfeb

    #Address 0xfeb Write value 0xcde0066c
    li x3, 0xcde0066c
    csrw 0xfeb, x3

    #Address 0xfeb read value
    csrr x14, 0xfeb

    #Unmapped address 0x452 testing: Read Reset + Random data Write/Read
    #Address 0x452 read value
    csrr x14, 0x452

    #Address 0x452 Write value 0x342f3409
    li x3, 0x342f3409
    csrw 0x452, x3

    #Address 0x452 read value
    csrr x14, 0x452

    #Unmapped address 0x577 testing: Read Reset + Random data Write/Read
    #Address 0x577 read value
    csrr x14, 0x577

    #Address 0x577 Write value 0x9ebd587e
    li x3, 0x9ebd587e
    csrw 0x577, x3

    #Address 0x577 read value
    csrr x14, 0x577

    #Unmapped address 0xef8 testing: Read Reset + Random data Write/Read
    #Address 0xef8 read value
    csrr x14, 0xef8

    #Address 0xef8 Write value 0xe8f7a8b4
    li x3, 0xe8f7a8b4
    csrw 0xef8, x3

    #Address 0xef8 read value
    csrr x14, 0xef8

    #Unmapped address 0x9b6 testing: Read Reset + Random data Write/Read
    #Address 0x9b6 read value
    csrr x14, 0x9b6

    #Address 0x9b6 Write value 0x31f1e86f
    li x3, 0x31f1e86f
    csrw 0x9b6, x3

    #Address 0x9b6 read value
    csrr x14, 0x9b6

    #Unmapped address 0xfea testing: Read Reset + Random data Write/Read
    #Address 0xfea read value
    csrr x14, 0xfea

    #Address 0xfea Write value 0x5aa3b7b4
    li x3, 0x5aa3b7b4
    csrw 0xfea, x3

    #Address 0xfea read value
    csrr x14, 0xfea

    #Unmapped address 0xd4b testing: Read Reset + Random data Write/Read
    #Address 0xd4b read value
    csrr x14, 0xd4b

    #Address 0xd4b Write value 0x9b623037
    li x3, 0x9b623037
    csrw 0xd4b, x3

    #Address 0xd4b read value
    csrr x14, 0xd4b

    #Unmapped address 0x567 testing: Read Reset + Random data Write/Read
    #Address 0x567 read value
    csrr x14, 0x567

    #Address 0x567 Write value 0xde8a08c8
    li x3, 0xde8a08c8
    csrw 0x567, x3

    #Address 0x567 read value
    csrr x14, 0x567

    #Unmapped address 0x3e9 testing: Read Reset + Random data Write/Read
    #Address 0x3e9 read value
    csrr x14, 0x3e9

    #Address 0x3e9 Write value 0x709821cf
    li x3, 0x709821cf
    csrw 0x3e9, x3

    #Address 0x3e9 read value
    csrr x14, 0x3e9

    #Unmapped address 0x69 testing: Read Reset + Random data Write/Read
    #Address 0x69 read value
    csrr x14, 0x69

    #Address 0x69 Write value 0xb8df6bf3
    li x3, 0xb8df6bf3
    csrw 0x69, x3

    #Address 0x69 read value
    csrr x14, 0x69

    #Unmapped address 0xd6d testing: Read Reset + Random data Write/Read
    #Address 0xd6d read value
    csrr x14, 0xd6d

    #Address 0xd6d Write value 0x7d5aaae5
    li x3, 0x7d5aaae5
    csrw 0xd6d, x3

    #Address 0xd6d read value
    csrr x14, 0xd6d

    #Unmapped address 0x7e9 testing: Read Reset + Random data Write/Read
    #Address 0x7e9 read value
    csrr x14, 0x7e9

    #Address 0x7e9 Write value 0xe5b416d4
    li x3, 0xe5b416d4
    csrw 0x7e9, x3

    #Address 0x7e9 read value
    csrr x14, 0x7e9

    #Unmapped address 0x23a testing: Read Reset + Random data Write/Read
    #Address 0x23a read value
    csrr x14, 0x23a

    #Address 0x23a Write value 0xfe06a6e6
    li x3, 0xfe06a6e6
    csrw 0x23a, x3

    #Address 0x23a read value
    csrr x14, 0x23a

    #Unmapped address 0x481 testing: Read Reset + Random data Write/Read
    #Address 0x481 read value
    csrr x14, 0x481

    #Address 0x481 Write value 0x4a57a60d
    li x3, 0x4a57a60d
    csrw 0x481, x3

    #Address 0x481 read value
    csrr x14, 0x481

    #Unmapped address 0xeb9 testing: Read Reset + Random data Write/Read
    #Address 0xeb9 read value
    csrr x14, 0xeb9

    #Address 0xeb9 Write value 0x54f08991
    li x3, 0x54f08991
    csrw 0xeb9, x3

    #Address 0xeb9 read value
    csrr x14, 0xeb9

    #Unmapped address 0x12d testing: Read Reset + Random data Write/Read
    #Address 0x12d read value
    csrr x14, 0x12d

    #Address 0x12d Write value 0x4e742ca4
    li x3, 0x4e742ca4
    csrw 0x12d, x3

    #Address 0x12d read value
    csrr x14, 0x12d

    #Unmapped address 0x88e testing: Read Reset + Random data Write/Read
    #Address 0x88e read value
    csrr x14, 0x88e

    #Address 0x88e Write value 0x77a3be72
    li x3, 0x77a3be72
    csrw 0x88e, x3

    #Address 0x88e read value
    csrr x14, 0x88e

    #Unmapped address 0x4a4 testing: Read Reset + Random data Write/Read
    #Address 0x4a4 read value
    csrr x14, 0x4a4

    #Address 0x4a4 Write value 0x4608fcfe
    li x3, 0x4608fcfe
    csrw 0x4a4, x3

    #Address 0x4a4 read value
    csrr x14, 0x4a4

    #Unmapped address 0x258 testing: Read Reset + Random data Write/Read
    #Address 0x258 read value
    csrr x14, 0x258

    #Address 0x258 Write value 0xcb9c7d49
    li x3, 0xcb9c7d49
    csrw 0x258, x3

    #Address 0x258 read value
    csrr x14, 0x258

    #Unmapped address 0x1a4 testing: Read Reset + Random data Write/Read
    #Address 0x1a4 read value
    csrr x14, 0x1a4

    #Address 0x1a4 Write value 0xbf44e68b
    li x3, 0xbf44e68b
    csrw 0x1a4, x3

    #Address 0x1a4 read value
    csrr x14, 0x1a4

    #Unmapped address 0xab4 testing: Read Reset + Random data Write/Read
    #Address 0xab4 read value
    csrr x14, 0xab4

    #Address 0xab4 Write value 0x30d51ee7
    li x3, 0x30d51ee7
    csrw 0xab4, x3

    #Address 0xab4 read value
    csrr x14, 0xab4

    #Unmapped address 0xb30 testing: Read Reset + Random data Write/Read
    #Address 0xb30 read value
    csrr x14, 0xb30

    #Address 0xb30 Write value 0x83bde875
    li x3, 0x83bde875
    csrw 0xb30, x3

    #Address 0xb30 read value
    csrr x14, 0xb30

    #Unmapped address 0x229 testing: Read Reset + Random data Write/Read
    #Address 0x229 read value
    csrr x14, 0x229

    #Address 0x229 Write value 0x61008ca7
    li x3, 0x61008ca7
    csrw 0x229, x3

    #Address 0x229 read value
    csrr x14, 0x229

    #Unmapped address 0x9c4 testing: Read Reset + Random data Write/Read
    #Address 0x9c4 read value
    csrr x14, 0x9c4

    #Address 0x9c4 Write value 0x807e6b40
    li x3, 0x807e6b40
    csrw 0x9c4, x3

    #Address 0x9c4 read value
    csrr x14, 0x9c4

    #Unmapped address 0x8cc testing: Read Reset + Random data Write/Read
    #Address 0x8cc read value
    csrr x14, 0x8cc

    #Address 0x8cc Write value 0xbf2b9295
    li x3, 0xbf2b9295
    csrw 0x8cc, x3

    #Address 0x8cc read value
    csrr x14, 0x8cc

    #Unmapped address 0x7d testing: Read Reset + Random data Write/Read
    #Address 0x7d read value
    csrr x14, 0x7d

    #Address 0x7d Write value 0x81788ee3
    li x3, 0x81788ee3
    csrw 0x7d, x3

    #Address 0x7d read value
    csrr x14, 0x7d

    #Unmapped address 0xb6d testing: Read Reset + Random data Write/Read
    #Address 0xb6d read value
    csrr x14, 0xb6d

    #Address 0xb6d Write value 0x7e670dd
    li x3, 0x7e670dd
    csrw 0xb6d, x3

    #Address 0xb6d read value
    csrr x14, 0xb6d

    #Unmapped address 0x131 testing: Read Reset + Random data Write/Read
    #Address 0x131 read value
    csrr x14, 0x131

    #Address 0x131 Write value 0xaca27ee9
    li x3, 0xaca27ee9
    csrw 0x131, x3

    #Address 0x131 read value
    csrr x14, 0x131

    #Unmapped address 0x5e5 testing: Read Reset + Random data Write/Read
    #Address 0x5e5 read value
    csrr x14, 0x5e5

    #Address 0x5e5 Write value 0x3348c947
    li x3, 0x3348c947
    csrw 0x5e5, x3

    #Address 0x5e5 read value
    csrr x14, 0x5e5

    #Unmapped address 0xfb3 testing: Read Reset + Random data Write/Read
    #Address 0xfb3 read value
    csrr x14, 0xfb3

    #Address 0xfb3 Write value 0x5a8a2670
    li x3, 0x5a8a2670
    csrw 0xfb3, x3

    #Address 0xfb3 read value
    csrr x14, 0xfb3

    #Unmapped address 0x24d testing: Read Reset + Random data Write/Read
    #Address 0x24d read value
    csrr x14, 0x24d

    #Address 0x24d Write value 0xec0d2dd4
    li x3, 0xec0d2dd4
    csrw 0x24d, x3

    #Address 0x24d read value
    csrr x14, 0x24d

    #Unmapped address 0xe4e testing: Read Reset + Random data Write/Read
    #Address 0xe4e read value
    csrr x14, 0xe4e

    #Address 0xe4e Write value 0xddb59436
    li x3, 0xddb59436
    csrw 0xe4e, x3

    #Address 0xe4e read value
    csrr x14, 0xe4e

    #Unmapped address 0x4fc testing: Read Reset + Random data Write/Read
    #Address 0x4fc read value
    csrr x14, 0x4fc

    #Address 0x4fc Write value 0x53dabc15
    li x3, 0x53dabc15
    csrw 0x4fc, x3

    #Address 0x4fc read value
    csrr x14, 0x4fc

    #Unmapped address 0x5ed testing: Read Reset + Random data Write/Read
    #Address 0x5ed read value
    csrr x14, 0x5ed

    #Address 0x5ed Write value 0xe43f30ed
    li x3, 0xe43f30ed
    csrw 0x5ed, x3

    #Address 0x5ed read value
    csrr x14, 0x5ed

    #Unmapped address 0x8ba testing: Read Reset + Random data Write/Read
    #Address 0x8ba read value
    csrr x14, 0x8ba

    #Address 0x8ba Write value 0x2032e75c
    li x3, 0x2032e75c
    csrw 0x8ba, x3

    #Address 0x8ba read value
    csrr x14, 0x8ba

    #Unmapped address 0xe6d testing: Read Reset + Random data Write/Read
    #Address 0xe6d read value
    csrr x14, 0xe6d

    #Address 0xe6d Write value 0x427fdbe1
    li x3, 0x427fdbe1
    csrw 0xe6d, x3

    #Address 0xe6d read value
    csrr x14, 0xe6d

    #Unmapped address 0x9b5 testing: Read Reset + Random data Write/Read
    #Address 0x9b5 read value
    csrr x14, 0x9b5

    #Address 0x9b5 Write value 0xbeeb7b42
    li x3, 0xbeeb7b42
    csrw 0x9b5, x3

    #Address 0x9b5 read value
    csrr x14, 0x9b5

    #Unmapped address 0xa48 testing: Read Reset + Random data Write/Read
    #Address 0xa48 read value
    csrr x14, 0xa48

    #Address 0xa48 Write value 0xe23182e1
    li x3, 0xe23182e1
    csrw 0xa48, x3

    #Address 0xa48 read value
    csrr x14, 0xa48

    #Unmapped address 0xc59 testing: Read Reset + Random data Write/Read
    #Address 0xc59 read value
    csrr x14, 0xc59

    #Address 0xc59 Write value 0x55187795
    li x3, 0x55187795
    csrw 0xc59, x3

    #Address 0xc59 read value
    csrr x14, 0xc59

    #Unmapped address 0x83f testing: Read Reset + Random data Write/Read
    #Address 0x83f read value
    csrr x14, 0x83f

    #Address 0x83f Write value 0xc7e8d437
    li x3, 0xc7e8d437
    csrw 0x83f, x3

    #Address 0x83f read value
    csrr x14, 0x83f

    #Unmapped address 0x1c testing: Read Reset + Random data Write/Read
    #Address 0x1c read value
    csrr x14, 0x1c

    #Address 0x1c Write value 0x6fa6600
    li x3, 0x6fa6600
    csrw 0x1c, x3

    #Address 0x1c read value
    csrr x14, 0x1c

    #Unmapped address 0x1b4 testing: Read Reset + Random data Write/Read
    #Address 0x1b4 read value
    csrr x14, 0x1b4

    #Address 0x1b4 Write value 0xf83b903
    li x3, 0xf83b903
    csrw 0x1b4, x3

    #Address 0x1b4 read value
    csrr x14, 0x1b4

    #Unmapped address 0x7bd testing: Read Reset + Random data Write/Read
    #Address 0x7bd read value
    csrr x14, 0x7bd

    #Address 0x7bd Write value 0x4edbdcd6
    li x3, 0x4edbdcd6
    csrw 0x7bd, x3

    #Address 0x7bd read value
    csrr x14, 0x7bd

    #Unmapped address 0xfac testing: Read Reset + Random data Write/Read
    #Address 0xfac read value
    csrr x14, 0xfac

    #Address 0xfac Write value 0x902525d3
    li x3, 0x902525d3
    csrw 0xfac, x3

    #Address 0xfac read value
    csrr x14, 0xfac

    #Unmapped address 0x11 testing: Read Reset + Random data Write/Read
    #Address 0x11 read value
    csrr x14, 0x11

    #Address 0x11 Write value 0xb0af0d45
    li x3, 0xb0af0d45
    csrw 0x11, x3

    #Address 0x11 read value
    csrr x14, 0x11

    #Unmapped address 0xa47 testing: Read Reset + Random data Write/Read
    #Address 0xa47 read value
    csrr x14, 0xa47

    #Address 0xa47 Write value 0x264cfae0
    li x3, 0x264cfae0
    csrw 0xa47, x3

    #Address 0xa47 read value
    csrr x14, 0xa47

    #Unmapped address 0xfff testing: Read Reset + Random data Write/Read
    #Address 0xfff read value
    csrr x14, 0xfff

    #Address 0xfff Write value 0x5742f961
    li x3, 0x5742f961
    csrw 0xfff, x3

    #Address 0xfff read value
    csrr x14, 0xfff

    #Unmapped address 0x1cb testing: Read Reset + Random data Write/Read
    #Address 0x1cb read value
    csrr x14, 0x1cb

    #Address 0x1cb Write value 0xb8560a08
    li x3, 0xb8560a08
    csrw 0x1cb, x3

    #Address 0x1cb read value
    csrr x14, 0x1cb

    #Unmapped address 0xfa3 testing: Read Reset + Random data Write/Read
    #Address 0xfa3 read value
    csrr x14, 0xfa3

    #Address 0xfa3 Write value 0x881bef5c
    li x3, 0x881bef5c
    csrw 0xfa3, x3

    #Address 0xfa3 read value
    csrr x14, 0xfa3

    #Unmapped address 0xf95 testing: Read Reset + Random data Write/Read
    #Address 0xf95 read value
    csrr x14, 0xf95

    #Address 0xf95 Write value 0x680583c4
    li x3, 0x680583c4
    csrw 0xf95, x3

    #Address 0xf95 read value
    csrr x14, 0xf95

    #Unmapped address 0x89 testing: Read Reset + Random data Write/Read
    #Address 0x89 read value
    csrr x14, 0x89

    #Address 0x89 Write value 0x6deef3a0
    li x3, 0x6deef3a0
    csrw 0x89, x3

    #Address 0x89 read value
    csrr x14, 0x89

    #Unmapped address 0x796 testing: Read Reset + Random data Write/Read
    #Address 0x796 read value
    csrr x14, 0x796

    #Address 0x796 Write value 0x6fc09c58
    li x3, 0x6fc09c58
    csrw 0x796, x3

    #Address 0x796 read value
    csrr x14, 0x796

    #Unmapped address 0xac0 testing: Read Reset + Random data Write/Read
    #Address 0xac0 read value
    csrr x14, 0xac0

    #Address 0xac0 Write value 0x1e0a75ce
    li x3, 0x1e0a75ce
    csrw 0xac0, x3

    #Address 0xac0 read value
    csrr x14, 0xac0

    #Unmapped address 0xa49 testing: Read Reset + Random data Write/Read
    #Address 0xa49 read value
    csrr x14, 0xa49

    #Address 0xa49 Write value 0xcd8f285
    li x3, 0xcd8f285
    csrw 0xa49, x3

    #Address 0xa49 read value
    csrr x14, 0xa49

    #Unmapped address 0xa68 testing: Read Reset + Random data Write/Read
    #Address 0xa68 read value
    csrr x14, 0xa68

    #Address 0xa68 Write value 0xe22496c2
    li x3, 0xe22496c2
    csrw 0xa68, x3

    #Address 0xa68 read value
    csrr x14, 0xa68

    #Unmapped address 0x6a1 testing: Read Reset + Random data Write/Read
    #Address 0x6a1 read value
    csrr x14, 0x6a1

    #Address 0x6a1 Write value 0xb1af180e
    li x3, 0xb1af180e
    csrw 0x6a1, x3

    #Address 0x6a1 read value
    csrr x14, 0x6a1

    #Unmapped address 0xc9d testing: Read Reset + Random data Write/Read
    #Address 0xc9d read value
    csrr x14, 0xc9d

    #Address 0xc9d Write value 0xb5fe1e6e
    li x3, 0xb5fe1e6e
    csrw 0xc9d, x3

    #Address 0xc9d read value
    csrr x14, 0xc9d

    #Unmapped address 0x1cd testing: Read Reset + Random data Write/Read
    #Address 0x1cd read value
    csrr x14, 0x1cd

    #Address 0x1cd Write value 0xba3868c0
    li x3, 0xba3868c0
    csrw 0x1cd, x3

    #Address 0x1cd read value
    csrr x14, 0x1cd

    #Unmapped address 0xa22 testing: Read Reset + Random data Write/Read
    #Address 0xa22 read value
    csrr x14, 0xa22

    #Address 0xa22 Write value 0xb23bbf36
    li x3, 0xb23bbf36
    csrw 0xa22, x3

    #Address 0xa22 read value
    csrr x14, 0xa22

    #Unmapped address 0x555 testing: Read Reset + Random data Write/Read
    #Address 0x555 read value
    csrr x14, 0x555

    #Address 0x555 Write value 0x9e50ee71
    li x3, 0x9e50ee71
    csrw 0x555, x3

    #Address 0x555 read value
    csrr x14, 0x555

    #Unmapped address 0x20f testing: Read Reset + Random data Write/Read
    #Address 0x20f read value
    csrr x14, 0x20f

    #Address 0x20f Write value 0xbc5cdb99
    li x3, 0xbc5cdb99
    csrw 0x20f, x3

    #Address 0x20f read value
    csrr x14, 0x20f

    #Unmapped address 0xc14 testing: Read Reset + Random data Write/Read
    #Address 0xc14 read value
    csrr x14, 0xc14

    #Address 0xc14 Write value 0xe0f0116c
    li x3, 0xe0f0116c
    csrw 0xc14, x3

    #Address 0xc14 read value
    csrr x14, 0xc14

    #Unmapped address 0x19a testing: Read Reset + Random data Write/Read
    #Address 0x19a read value
    csrr x14, 0x19a

    #Address 0x19a Write value 0xf348c344
    li x3, 0xf348c344
    csrw 0x19a, x3

    #Address 0x19a read value
    csrr x14, 0x19a

    #Unmapped address 0xc5 testing: Read Reset + Random data Write/Read
    #Address 0xc5 read value
    csrr x14, 0xc5

    #Address 0xc5 Write value 0xff968a32
    li x3, 0xff968a32
    csrw 0xc5, x3

    #Address 0xc5 read value
    csrr x14, 0xc5

    #Unmapped address 0xaf0 testing: Read Reset + Random data Write/Read
    #Address 0xaf0 read value
    csrr x14, 0xaf0

    #Address 0xaf0 Write value 0x6f532fae
    li x3, 0x6f532fae
    csrw 0xaf0, x3

    #Address 0xaf0 read value
    csrr x14, 0xaf0

    #Unmapped address 0x712 testing: Read Reset + Random data Write/Read
    #Address 0x712 read value
    csrr x14, 0x712

    #Address 0x712 Write value 0x59405330
    li x3, 0x59405330
    csrw 0x712, x3

    #Address 0x712 read value
    csrr x14, 0x712

    #Unmapped address 0xb77 testing: Read Reset + Random data Write/Read
    #Address 0xb77 read value
    csrr x14, 0xb77

    #Address 0xb77 Write value 0x70ae4546
    li x3, 0x70ae4546
    csrw 0xb77, x3

    #Address 0xb77 read value
    csrr x14, 0xb77

    #Unmapped address 0x9b1 testing: Read Reset + Random data Write/Read
    #Address 0x9b1 read value
    csrr x14, 0x9b1

    #Address 0x9b1 Write value 0xe7d78cfc
    li x3, 0xe7d78cfc
    csrw 0x9b1, x3

    #Address 0x9b1 read value
    csrr x14, 0x9b1

    #Unmapped address 0x95d testing: Read Reset + Random data Write/Read
    #Address 0x95d read value
    csrr x14, 0x95d

    #Address 0x95d Write value 0xa12050e5
    li x3, 0xa12050e5
    csrw 0x95d, x3

    #Address 0x95d read value
    csrr x14, 0x95d

    #Unmapped address 0x558 testing: Read Reset + Random data Write/Read
    #Address 0x558 read value
    csrr x14, 0x558

    #Address 0x558 Write value 0xa1ea2a3e
    li x3, 0xa1ea2a3e
    csrw 0x558, x3

    #Address 0x558 read value
    csrr x14, 0x558

    #Unmapped address 0xcb8 testing: Read Reset + Random data Write/Read
    #Address 0xcb8 read value
    csrr x14, 0xcb8

    #Address 0xcb8 Write value 0x3a9942e5
    li x3, 0x3a9942e5
    csrw 0xcb8, x3

    #Address 0xcb8 read value
    csrr x14, 0xcb8

    #Unmapped address 0x915 testing: Read Reset + Random data Write/Read
    #Address 0x915 read value
    csrr x14, 0x915

    #Address 0x915 Write value 0xab283ae0
    li x3, 0xab283ae0
    csrw 0x915, x3

    #Address 0x915 read value
    csrr x14, 0x915

    #Unmapped address 0x8ad testing: Read Reset + Random data Write/Read
    #Address 0x8ad read value
    csrr x14, 0x8ad

    #Address 0x8ad Write value 0x16234bd1
    li x3, 0x16234bd1
    csrw 0x8ad, x3

    #Address 0x8ad read value
    csrr x14, 0x8ad

    #Unmapped address 0x87a testing: Read Reset + Random data Write/Read
    #Address 0x87a read value
    csrr x14, 0x87a

    #Address 0x87a Write value 0x1e20f88a
    li x3, 0x1e20f88a
    csrw 0x87a, x3

    #Address 0x87a read value
    csrr x14, 0x87a

    #Unmapped address 0x68e testing: Read Reset + Random data Write/Read
    #Address 0x68e read value
    csrr x14, 0x68e

    #Address 0x68e Write value 0xaea8bbf
    li x3, 0xaea8bbf
    csrw 0x68e, x3

    #Address 0x68e read value
    csrr x14, 0x68e

    #Unmapped address 0x8bf testing: Read Reset + Random data Write/Read
    #Address 0x8bf read value
    csrr x14, 0x8bf

    #Address 0x8bf Write value 0xfe60d0e8
    li x3, 0xfe60d0e8
    csrw 0x8bf, x3

    #Address 0x8bf read value
    csrr x14, 0x8bf

    #Unmapped address 0x855 testing: Read Reset + Random data Write/Read
    #Address 0x855 read value
    csrr x14, 0x855

    #Address 0x855 Write value 0x37bc848f
    li x3, 0x37bc848f
    csrw 0x855, x3

    #Address 0x855 read value
    csrr x14, 0x855

    #Unmapped address 0xa44 testing: Read Reset + Random data Write/Read
    #Address 0xa44 read value
    csrr x14, 0xa44

    #Address 0xa44 Write value 0xaf75d90f
    li x3, 0xaf75d90f
    csrw 0xa44, x3

    #Address 0xa44 read value
    csrr x14, 0xa44

    #Unmapped address 0x212 testing: Read Reset + Random data Write/Read
    #Address 0x212 read value
    csrr x14, 0x212

    #Address 0x212 Write value 0xefb7343a
    li x3, 0xefb7343a
    csrw 0x212, x3

    #Address 0x212 read value
    csrr x14, 0x212

    #Unmapped address 0x522 testing: Read Reset + Random data Write/Read
    #Address 0x522 read value
    csrr x14, 0x522

    #Address 0x522 Write value 0x6d864a43
    li x3, 0x6d864a43
    csrw 0x522, x3

    #Address 0x522 read value
    csrr x14, 0x522

    #Unmapped address 0xbc5 testing: Read Reset + Random data Write/Read
    #Address 0xbc5 read value
    csrr x14, 0xbc5

    #Address 0xbc5 Write value 0x1ea1fd7f
    li x3, 0x1ea1fd7f
    csrw 0xbc5, x3

    #Address 0xbc5 read value
    csrr x14, 0xbc5

    #Unmapped address 0xd25 testing: Read Reset + Random data Write/Read
    #Address 0xd25 read value
    csrr x14, 0xd25

    #Address 0xd25 Write value 0xe26f9239
    li x3, 0xe26f9239
    csrw 0xd25, x3

    #Address 0xd25 read value
    csrr x14, 0xd25

    #Unmapped address 0x9e0 testing: Read Reset + Random data Write/Read
    #Address 0x9e0 read value
    csrr x14, 0x9e0

    #Address 0x9e0 Write value 0x2332650
    li x3, 0x2332650
    csrw 0x9e0, x3

    #Address 0x9e0 read value
    csrr x14, 0x9e0

    #Unmapped address 0xcf6 testing: Read Reset + Random data Write/Read
    #Address 0xcf6 read value
    csrr x14, 0xcf6

    #Address 0xcf6 Write value 0x336a6710
    li x3, 0x336a6710
    csrw 0xcf6, x3

    #Address 0xcf6 read value
    csrr x14, 0xcf6

    #Unmapped address 0x459 testing: Read Reset + Random data Write/Read
    #Address 0x459 read value
    csrr x14, 0x459

    #Address 0x459 Write value 0xbfa1c5b8
    li x3, 0xbfa1c5b8
    csrw 0x459, x3

    #Address 0x459 read value
    csrr x14, 0x459

    #Unmapped address 0xd83 testing: Read Reset + Random data Write/Read
    #Address 0xd83 read value
    csrr x14, 0xd83

    #Address 0xd83 Write value 0x897f5bf2
    li x3, 0x897f5bf2
    csrw 0xd83, x3

    #Address 0xd83 read value
    csrr x14, 0xd83

    #Unmapped address 0xfd7 testing: Read Reset + Random data Write/Read
    #Address 0xfd7 read value
    csrr x14, 0xfd7

    #Address 0xfd7 Write value 0xa27b7718
    li x3, 0xa27b7718
    csrw 0xfd7, x3

    #Address 0xfd7 read value
    csrr x14, 0xfd7

    #Unmapped address 0xa87 testing: Read Reset + Random data Write/Read
    #Address 0xa87 read value
    csrr x14, 0xa87

    #Address 0xa87 Write value 0x913177c5
    li x3, 0x913177c5
    csrw 0xa87, x3

    #Address 0xa87 read value
    csrr x14, 0xa87

    #Unmapped address 0x119 testing: Read Reset + Random data Write/Read
    #Address 0x119 read value
    csrr x14, 0x119

    #Address 0x119 Write value 0x36219ff
    li x3, 0x36219ff
    csrw 0x119, x3

    #Address 0x119 read value
    csrr x14, 0x119

    #Unmapped address 0x61a testing: Read Reset + Random data Write/Read
    #Address 0x61a read value
    csrr x14, 0x61a

    #Address 0x61a Write value 0xeb455a8a
    li x3, 0xeb455a8a
    csrw 0x61a, x3

    #Address 0x61a read value
    csrr x14, 0x61a

    #Unmapped address 0xa5c testing: Read Reset + Random data Write/Read
    #Address 0xa5c read value
    csrr x14, 0xa5c

    #Address 0xa5c Write value 0xded89063
    li x3, 0xded89063
    csrw 0xa5c, x3

    #Address 0xa5c read value
    csrr x14, 0xa5c

    #Unmapped address 0x809 testing: Read Reset + Random data Write/Read
    #Address 0x809 read value
    csrr x14, 0x809

    #Address 0x809 Write value 0x8da71810
    li x3, 0x8da71810
    csrw 0x809, x3

    #Address 0x809 read value
    csrr x14, 0x809

    #Unmapped address 0x68c testing: Read Reset + Random data Write/Read
    #Address 0x68c read value
    csrr x14, 0x68c

    #Address 0x68c Write value 0x39b65a3c
    li x3, 0x39b65a3c
    csrw 0x68c, x3

    #Address 0x68c read value
    csrr x14, 0x68c

    #Unmapped address 0xeff testing: Read Reset + Random data Write/Read
    #Address 0xeff read value
    csrr x14, 0xeff

    #Address 0xeff Write value 0x4a54a0a0
    li x3, 0x4a54a0a0
    csrw 0xeff, x3

    #Address 0xeff read value
    csrr x14, 0xeff

    #Unmapped address 0x8fa testing: Read Reset + Random data Write/Read
    #Address 0x8fa read value
    csrr x14, 0x8fa

    #Address 0x8fa Write value 0x77a57034
    li x3, 0x77a57034
    csrw 0x8fa, x3

    #Address 0x8fa read value
    csrr x14, 0x8fa

    #Unmapped address 0x514 testing: Read Reset + Random data Write/Read
    #Address 0x514 read value
    csrr x14, 0x514

    #Address 0x514 Write value 0xa9aebd18
    li x3, 0xa9aebd18
    csrw 0x514, x3

    #Address 0x514 read value
    csrr x14, 0x514

    #Unmapped address 0x5db testing: Read Reset + Random data Write/Read
    #Address 0x5db read value
    csrr x14, 0x5db

    #Address 0x5db Write value 0x56e9be8
    li x3, 0x56e9be8
    csrw 0x5db, x3

    #Address 0x5db read value
    csrr x14, 0x5db

    #Unmapped address 0xea6 testing: Read Reset + Random data Write/Read
    #Address 0xea6 read value
    csrr x14, 0xea6

    #Address 0xea6 Write value 0xa1eb5a44
    li x3, 0xa1eb5a44
    csrw 0xea6, x3

    #Address 0xea6 read value
    csrr x14, 0xea6

    #Unmapped address 0x83d testing: Read Reset + Random data Write/Read
    #Address 0x83d read value
    csrr x14, 0x83d

    #Address 0x83d Write value 0xe96ee528
    li x3, 0xe96ee528
    csrw 0x83d, x3

    #Address 0x83d read value
    csrr x14, 0x83d

    #Unmapped address 0x78 testing: Read Reset + Random data Write/Read
    #Address 0x78 read value
    csrr x14, 0x78

    #Address 0x78 Write value 0x821aa50a
    li x3, 0x821aa50a
    csrw 0x78, x3

    #Address 0x78 read value
    csrr x14, 0x78

    #Unmapped address 0xe9d testing: Read Reset + Random data Write/Read
    #Address 0xe9d read value
    csrr x14, 0xe9d

    #Address 0xe9d Write value 0x2486e8dd
    li x3, 0x2486e8dd
    csrw 0xe9d, x3

    #Address 0xe9d read value
    csrr x14, 0xe9d

    #Unmapped address 0x2b4 testing: Read Reset + Random data Write/Read
    #Address 0x2b4 read value
    csrr x14, 0x2b4

    #Address 0x2b4 Write value 0x7e0a9413
    li x3, 0x7e0a9413
    csrw 0x2b4, x3

    #Address 0x2b4 read value
    csrr x14, 0x2b4

    #Unmapped address 0xb3a testing: Read Reset + Random data Write/Read
    #Address 0xb3a read value
    csrr x14, 0xb3a

    #Address 0xb3a Write value 0x9df79a4e
    li x3, 0x9df79a4e
    csrw 0xb3a, x3

    #Address 0xb3a read value
    csrr x14, 0xb3a

    #Unmapped address 0x5f5 testing: Read Reset + Random data Write/Read
    #Address 0x5f5 read value
    csrr x14, 0x5f5

    #Address 0x5f5 Write value 0x8c352b07
    li x3, 0x8c352b07
    csrw 0x5f5, x3

    #Address 0x5f5 read value
    csrr x14, 0x5f5

    #Unmapped address 0x839 testing: Read Reset + Random data Write/Read
    #Address 0x839 read value
    csrr x14, 0x839

    #Address 0x839 Write value 0xbf857060
    li x3, 0xbf857060
    csrw 0x839, x3

    #Address 0x839 read value
    csrr x14, 0x839

    #Unmapped address 0xde5 testing: Read Reset + Random data Write/Read
    #Address 0xde5 read value
    csrr x14, 0xde5

    #Address 0xde5 Write value 0xcc348c52
    li x3, 0xcc348c52
    csrw 0xde5, x3

    #Address 0xde5 read value
    csrr x14, 0xde5

    #Unmapped address 0xb20 testing: Read Reset + Random data Write/Read
    #Address 0xb20 read value
    csrr x14, 0xb20

    #Address 0xb20 Write value 0xa3ec3400
    li x3, 0xa3ec3400
    csrw 0xb20, x3

    #Address 0xb20 read value
    csrr x14, 0xb20

    #Unmapped address 0x5c0 testing: Read Reset + Random data Write/Read
    #Address 0x5c0 read value
    csrr x14, 0x5c0

    #Address 0x5c0 Write value 0xac228995
    li x3, 0xac228995
    csrw 0x5c0, x3

    #Address 0x5c0 read value
    csrr x14, 0x5c0

    #Unmapped address 0x103 testing: Read Reset + Random data Write/Read
    #Address 0x103 read value
    csrr x14, 0x103

    #Address 0x103 Write value 0xdc377d7f
    li x3, 0xdc377d7f
    csrw 0x103, x3

    #Address 0x103 read value
    csrr x14, 0x103

    #Unmapped address 0x7ba testing: Read Reset + Random data Write/Read
    #Address 0x7ba read value
    csrr x14, 0x7ba

    #Address 0x7ba Write value 0xa7f7ac78
    li x3, 0xa7f7ac78
    csrw 0x7ba, x3

    #Address 0x7ba read value
    csrr x14, 0x7ba

    #Unmapped address 0x30a testing: Read Reset + Random data Write/Read
    #Address 0x30a read value
    csrr x14, 0x30a

    #Address 0x30a Write value 0xd5cb9fd7
    li x3, 0xd5cb9fd7
    csrw 0x30a, x3

    #Address 0x30a read value
    csrr x14, 0x30a

    #Unmapped address 0x32 testing: Read Reset + Random data Write/Read
    #Address 0x32 read value
    csrr x14, 0x32

    #Address 0x32 Write value 0x7c24c467
    li x3, 0x7c24c467
    csrw 0x32, x3

    #Address 0x32 read value
    csrr x14, 0x32

    #Unmapped address 0x6ee testing: Read Reset + Random data Write/Read
    #Address 0x6ee read value
    csrr x14, 0x6ee

    #Address 0x6ee Write value 0x408e3107
    li x3, 0x408e3107
    csrw 0x6ee, x3

    #Address 0x6ee read value
    csrr x14, 0x6ee

    #Unmapped address 0xcce testing: Read Reset + Random data Write/Read
    #Address 0xcce read value
    csrr x14, 0xcce

    #Address 0xcce Write value 0x58ef1418
    li x3, 0x58ef1418
    csrw 0xcce, x3

    #Address 0xcce read value
    csrr x14, 0xcce

    #Unmapped address 0xb81 testing: Read Reset + Random data Write/Read
    #Address 0xb81 read value
    csrr x14, 0xb81

    #Address 0xb81 Write value 0xbd2efb84
    li x3, 0xbd2efb84
    csrw 0xb81, x3

    #Address 0xb81 read value
    csrr x14, 0xb81

    #Unmapped address 0x664 testing: Read Reset + Random data Write/Read
    #Address 0x664 read value
    csrr x14, 0x664

    #Address 0x664 Write value 0x162b7e5
    li x3, 0x162b7e5
    csrw 0x664, x3

    #Address 0x664 read value
    csrr x14, 0x664

    #Unmapped address 0x7e7 testing: Read Reset + Random data Write/Read
    #Address 0x7e7 read value
    csrr x14, 0x7e7

    #Address 0x7e7 Write value 0x139cab33
    li x3, 0x139cab33
    csrw 0x7e7, x3

    #Address 0x7e7 read value
    csrr x14, 0x7e7

    #Unmapped address 0x6d0 testing: Read Reset + Random data Write/Read
    #Address 0x6d0 read value
    csrr x14, 0x6d0

    #Address 0x6d0 Write value 0x1433bbea
    li x3, 0x1433bbea
    csrw 0x6d0, x3

    #Address 0x6d0 read value
    csrr x14, 0x6d0

    #Unmapped address 0x722 testing: Read Reset + Random data Write/Read
    #Address 0x722 read value
    csrr x14, 0x722

    #Address 0x722 Write value 0x1aacf4f4
    li x3, 0x1aacf4f4
    csrw 0x722, x3

    #Address 0x722 read value
    csrr x14, 0x722

    #Unmapped address 0x385 testing: Read Reset + Random data Write/Read
    #Address 0x385 read value
    csrr x14, 0x385

    #Address 0x385 Write value 0xaa5aaec9
    li x3, 0xaa5aaec9
    csrw 0x385, x3

    #Address 0x385 read value
    csrr x14, 0x385

    #Unmapped address 0x888 testing: Read Reset + Random data Write/Read
    #Address 0x888 read value
    csrr x14, 0x888

    #Address 0x888 Write value 0x886848cb
    li x3, 0x886848cb
    csrw 0x888, x3

    #Address 0x888 read value
    csrr x14, 0x888

    #Unmapped address 0x4c2 testing: Read Reset + Random data Write/Read
    #Address 0x4c2 read value
    csrr x14, 0x4c2

    #Address 0x4c2 Write value 0xc0bc704b
    li x3, 0xc0bc704b
    csrw 0x4c2, x3

    #Address 0x4c2 read value
    csrr x14, 0x4c2

    #Unmapped address 0xb2 testing: Read Reset + Random data Write/Read
    #Address 0xb2 read value
    csrr x14, 0xb2

    #Address 0xb2 Write value 0xc7c9bd07
    li x3, 0xc7c9bd07
    csrw 0xb2, x3

    #Address 0xb2 read value
    csrr x14, 0xb2

    #Unmapped address 0x5dd testing: Read Reset + Random data Write/Read
    #Address 0x5dd read value
    csrr x14, 0x5dd

    #Address 0x5dd Write value 0x732bbf05
    li x3, 0x732bbf05
    csrw 0x5dd, x3

    #Address 0x5dd read value
    csrr x14, 0x5dd

    #Unmapped address 0xcab testing: Read Reset + Random data Write/Read
    #Address 0xcab read value
    csrr x14, 0xcab

    #Address 0xcab Write value 0x47d4e132
    li x3, 0x47d4e132
    csrw 0xcab, x3

    #Address 0xcab read value
    csrr x14, 0xcab

    #Unmapped address 0x65a testing: Read Reset + Random data Write/Read
    #Address 0x65a read value
    csrr x14, 0x65a

    #Address 0x65a Write value 0xd1c51f4c
    li x3, 0xd1c51f4c
    csrw 0x65a, x3

    #Address 0x65a read value
    csrr x14, 0x65a

    #Unmapped address 0x4ba testing: Read Reset + Random data Write/Read
    #Address 0x4ba read value
    csrr x14, 0x4ba

    #Address 0x4ba Write value 0x7be12f3d
    li x3, 0x7be12f3d
    csrw 0x4ba, x3

    #Address 0x4ba read value
    csrr x14, 0x4ba

    #Unmapped address 0x598 testing: Read Reset + Random data Write/Read
    #Address 0x598 read value
    csrr x14, 0x598

    #Address 0x598 Write value 0xef00f38c
    li x3, 0xef00f38c
    csrw 0x598, x3

    #Address 0x598 read value
    csrr x14, 0x598

    #Unmapped address 0x21a testing: Read Reset + Random data Write/Read
    #Address 0x21a read value
    csrr x14, 0x21a

    #Address 0x21a Write value 0xe1ddbe11
    li x3, 0xe1ddbe11
    csrw 0x21a, x3

    #Address 0x21a read value
    csrr x14, 0x21a

    #Unmapped address 0xc9 testing: Read Reset + Random data Write/Read
    #Address 0xc9 read value
    csrr x14, 0xc9

    #Address 0xc9 Write value 0x45e19d9f
    li x3, 0x45e19d9f
    csrw 0xc9, x3

    #Address 0xc9 read value
    csrr x14, 0xc9

    #Unmapped address 0x36e testing: Read Reset + Random data Write/Read
    #Address 0x36e read value
    csrr x14, 0x36e

    #Address 0x36e Write value 0x226f91ff
    li x3, 0x226f91ff
    csrw 0x36e, x3

    #Address 0x36e read value
    csrr x14, 0x36e

    #Unmapped address 0x179 testing: Read Reset + Random data Write/Read
    #Address 0x179 read value
    csrr x14, 0x179

    #Address 0x179 Write value 0xf8592183
    li x3, 0xf8592183
    csrw 0x179, x3

    #Address 0x179 read value
    csrr x14, 0x179

    #Unmapped address 0x899 testing: Read Reset + Random data Write/Read
    #Address 0x899 read value
    csrr x14, 0x899

    #Address 0x899 Write value 0x1558a9f9
    li x3, 0x1558a9f9
    csrw 0x899, x3

    #Address 0x899 read value
    csrr x14, 0x899

    #Unmapped address 0xe47 testing: Read Reset + Random data Write/Read
    #Address 0xe47 read value
    csrr x14, 0xe47

    #Address 0xe47 Write value 0x373754ec
    li x3, 0x373754ec
    csrw 0xe47, x3

    #Address 0xe47 read value
    csrr x14, 0xe47

    #Unmapped address 0x46d testing: Read Reset + Random data Write/Read
    #Address 0x46d read value
    csrr x14, 0x46d

    #Address 0x46d Write value 0x3e52075f
    li x3, 0x3e52075f
    csrw 0x46d, x3

    #Address 0x46d read value
    csrr x14, 0x46d

    #Unmapped address 0xf3f testing: Read Reset + Random data Write/Read
    #Address 0xf3f read value
    csrr x14, 0xf3f

    #Address 0xf3f Write value 0xbb7a6ee5
    li x3, 0xbb7a6ee5
    csrw 0xf3f, x3

    #Address 0xf3f read value
    csrr x14, 0xf3f

    #Unmapped address 0xcec testing: Read Reset + Random data Write/Read
    #Address 0xcec read value
    csrr x14, 0xcec

    #Address 0xcec Write value 0x5318962c
    li x3, 0x5318962c
    csrw 0xcec, x3

    #Address 0xcec read value
    csrr x14, 0xcec

    #Unmapped address 0xefe testing: Read Reset + Random data Write/Read
    #Address 0xefe read value
    csrr x14, 0xefe

    #Address 0xefe Write value 0xe1a319e0
    li x3, 0xe1a319e0
    csrw 0xefe, x3

    #Address 0xefe read value
    csrr x14, 0xefe

    #Unmapped address 0x272 testing: Read Reset + Random data Write/Read
    #Address 0x272 read value
    csrr x14, 0x272

    #Address 0x272 Write value 0xe152efab
    li x3, 0xe152efab
    csrw 0x272, x3

    #Address 0x272 read value
    csrr x14, 0x272

    #Unmapped address 0x18f testing: Read Reset + Random data Write/Read
    #Address 0x18f read value
    csrr x14, 0x18f

    #Address 0x18f Write value 0x92037477
    li x3, 0x92037477
    csrw 0x18f, x3

    #Address 0x18f read value
    csrr x14, 0x18f

    #Unmapped address 0x6b9 testing: Read Reset + Random data Write/Read
    #Address 0x6b9 read value
    csrr x14, 0x6b9

    #Address 0x6b9 Write value 0x6e3d7bf5
    li x3, 0x6e3d7bf5
    csrw 0x6b9, x3

    #Address 0x6b9 read value
    csrr x14, 0x6b9

    #Unmapped address 0x8e0 testing: Read Reset + Random data Write/Read
    #Address 0x8e0 read value
    csrr x14, 0x8e0

    #Address 0x8e0 Write value 0x235bd0fd
    li x3, 0x235bd0fd
    csrw 0x8e0, x3

    #Address 0x8e0 read value
    csrr x14, 0x8e0

    #Unmapped address 0x5df testing: Read Reset + Random data Write/Read
    #Address 0x5df read value
    csrr x14, 0x5df

    #Address 0x5df Write value 0x86a88747
    li x3, 0x86a88747
    csrw 0x5df, x3

    #Address 0x5df read value
    csrr x14, 0x5df

    #Unmapped address 0x5b4 testing: Read Reset + Random data Write/Read
    #Address 0x5b4 read value
    csrr x14, 0x5b4

    #Address 0x5b4 Write value 0x6b7aa050
    li x3, 0x6b7aa050
    csrw 0x5b4, x3

    #Address 0x5b4 read value
    csrr x14, 0x5b4

    #Unmapped address 0xc2c testing: Read Reset + Random data Write/Read
    #Address 0xc2c read value
    csrr x14, 0xc2c

    #Address 0xc2c Write value 0x3f7a0d25
    li x3, 0x3f7a0d25
    csrw 0xc2c, x3

    #Address 0xc2c read value
    csrr x14, 0xc2c

    #Unmapped address 0xca3 testing: Read Reset + Random data Write/Read
    #Address 0xca3 read value
    csrr x14, 0xca3

    #Address 0xca3 Write value 0x5f537007
    li x3, 0x5f537007
    csrw 0xca3, x3

    #Address 0xca3 read value
    csrr x14, 0xca3

    #Unmapped address 0x238 testing: Read Reset + Random data Write/Read
    #Address 0x238 read value
    csrr x14, 0x238

    #Address 0x238 Write value 0x8f2fa78e
    li x3, 0x8f2fa78e
    csrw 0x238, x3

    #Address 0x238 read value
    csrr x14, 0x238

    #Unmapped address 0x3a6 testing: Read Reset + Random data Write/Read
    #Address 0x3a6 read value
    csrr x14, 0x3a6

    #Address 0x3a6 Write value 0x868da2af
    li x3, 0x868da2af
    csrw 0x3a6, x3

    #Address 0x3a6 read value
    csrr x14, 0x3a6

    #Unmapped address 0x5cc testing: Read Reset + Random data Write/Read
    #Address 0x5cc read value
    csrr x14, 0x5cc

    #Address 0x5cc Write value 0x60df5347
    li x3, 0x60df5347
    csrw 0x5cc, x3

    #Address 0x5cc read value
    csrr x14, 0x5cc

    #Unmapped address 0x1be testing: Read Reset + Random data Write/Read
    #Address 0x1be read value
    csrr x14, 0x1be

    #Address 0x1be Write value 0xc8150aa6
    li x3, 0xc8150aa6
    csrw 0x1be, x3

    #Address 0x1be read value
    csrr x14, 0x1be

    #Unmapped address 0x37d testing: Read Reset + Random data Write/Read
    #Address 0x37d read value
    csrr x14, 0x37d

    #Address 0x37d Write value 0xa95dedb2
    li x3, 0xa95dedb2
    csrw 0x37d, x3

    #Address 0x37d read value
    csrr x14, 0x37d

    #Unmapped address 0xd0 testing: Read Reset + Random data Write/Read
    #Address 0xd0 read value
    csrr x14, 0xd0

    #Address 0xd0 Write value 0x294d05d2
    li x3, 0x294d05d2
    csrw 0xd0, x3

    #Address 0xd0 read value
    csrr x14, 0xd0

    #Unmapped address 0x65b testing: Read Reset + Random data Write/Read
    #Address 0x65b read value
    csrr x14, 0x65b

    #Address 0x65b Write value 0x915ac7f0
    li x3, 0x915ac7f0
    csrw 0x65b, x3

    #Address 0x65b read value
    csrr x14, 0x65b

    #Unmapped address 0x19 testing: Read Reset + Random data Write/Read
    #Address 0x19 read value
    csrr x14, 0x19

    #Address 0x19 Write value 0x5a9ebf06
    li x3, 0x5a9ebf06
    csrw 0x19, x3

    #Address 0x19 read value
    csrr x14, 0x19

    #Unmapped address 0x5d2 testing: Read Reset + Random data Write/Read
    #Address 0x5d2 read value
    csrr x14, 0x5d2

    #Address 0x5d2 Write value 0x5771b82b
    li x3, 0x5771b82b
    csrw 0x5d2, x3

    #Address 0x5d2 read value
    csrr x14, 0x5d2

    #Unmapped address 0x226 testing: Read Reset + Random data Write/Read
    #Address 0x226 read value
    csrr x14, 0x226

    #Address 0x226 Write value 0x4a97563e
    li x3, 0x4a97563e
    csrw 0x226, x3

    #Address 0x226 read value
    csrr x14, 0x226

    #Unmapped address 0x50d testing: Read Reset + Random data Write/Read
    #Address 0x50d read value
    csrr x14, 0x50d

    #Address 0x50d Write value 0xf63711ee
    li x3, 0xf63711ee
    csrw 0x50d, x3

    #Address 0x50d read value
    csrr x14, 0x50d

    #Unmapped address 0xca6 testing: Read Reset + Random data Write/Read
    #Address 0xca6 read value
    csrr x14, 0xca6

    #Address 0xca6 Write value 0x17f14ed0
    li x3, 0x17f14ed0
    csrw 0xca6, x3

    #Address 0xca6 read value
    csrr x14, 0xca6

    #Unmapped address 0xbc2 testing: Read Reset + Random data Write/Read
    #Address 0xbc2 read value
    csrr x14, 0xbc2

    #Address 0xbc2 Write value 0xecce9e25
    li x3, 0xecce9e25
    csrw 0xbc2, x3

    #Address 0xbc2 read value
    csrr x14, 0xbc2

    #Unmapped address 0xda3 testing: Read Reset + Random data Write/Read
    #Address 0xda3 read value
    csrr x14, 0xda3

    #Address 0xda3 Write value 0xc35f2b1f
    li x3, 0xc35f2b1f
    csrw 0xda3, x3

    #Address 0xda3 read value
    csrr x14, 0xda3

    #Unmapped address 0xcaf testing: Read Reset + Random data Write/Read
    #Address 0xcaf read value
    csrr x14, 0xcaf

    #Address 0xcaf Write value 0x5cbb6c83
    li x3, 0x5cbb6c83
    csrw 0xcaf, x3

    #Address 0xcaf read value
    csrr x14, 0xcaf

    #Unmapped address 0x62a testing: Read Reset + Random data Write/Read
    #Address 0x62a read value
    csrr x14, 0x62a

    #Address 0x62a Write value 0x7f64d878
    li x3, 0x7f64d878
    csrw 0x62a, x3

    #Address 0x62a read value
    csrr x14, 0x62a

    #Unmapped address 0xfbd testing: Read Reset + Random data Write/Read
    #Address 0xfbd read value
    csrr x14, 0xfbd

    #Address 0xfbd Write value 0x1b05992d
    li x3, 0x1b05992d
    csrw 0xfbd, x3

    #Address 0xfbd read value
    csrr x14, 0xfbd

    #Unmapped address 0xb72 testing: Read Reset + Random data Write/Read
    #Address 0xb72 read value
    csrr x14, 0xb72

    #Address 0xb72 Write value 0x7a26f674
    li x3, 0x7a26f674
    csrw 0xb72, x3

    #Address 0xb72 read value
    csrr x14, 0xb72

    #Unmapped address 0xa0f testing: Read Reset + Random data Write/Read
    #Address 0xa0f read value
    csrr x14, 0xa0f

    #Address 0xa0f Write value 0xdf67fd75
    li x3, 0xdf67fd75
    csrw 0xa0f, x3

    #Address 0xa0f read value
    csrr x14, 0xa0f

    #Unmapped address 0x2fe testing: Read Reset + Random data Write/Read
    #Address 0x2fe read value
    csrr x14, 0x2fe

    #Address 0x2fe Write value 0xb126cf7f
    li x3, 0xb126cf7f
    csrw 0x2fe, x3

    #Address 0x2fe read value
    csrr x14, 0x2fe

    #Unmapped address 0x719 testing: Read Reset + Random data Write/Read
    #Address 0x719 read value
    csrr x14, 0x719

    #Address 0x719 Write value 0xd6995c5e
    li x3, 0xd6995c5e
    csrw 0x719, x3

    #Address 0x719 read value
    csrr x14, 0x719

    #Unmapped address 0x41f testing: Read Reset + Random data Write/Read
    #Address 0x41f read value
    csrr x14, 0x41f

    #Address 0x41f Write value 0x79f091f5
    li x3, 0x79f091f5
    csrw 0x41f, x3

    #Address 0x41f read value
    csrr x14, 0x41f

    #Unmapped address 0x1ee testing: Read Reset + Random data Write/Read
    #Address 0x1ee read value
    csrr x14, 0x1ee

    #Address 0x1ee Write value 0x79cb2660
    li x3, 0x79cb2660
    csrw 0x1ee, x3

    #Address 0x1ee read value
    csrr x14, 0x1ee

    #Unmapped address 0xd04 testing: Read Reset + Random data Write/Read
    #Address 0xd04 read value
    csrr x14, 0xd04

    #Address 0xd04 Write value 0xb7648f4f
    li x3, 0xb7648f4f
    csrw 0xd04, x3

    #Address 0xd04 read value
    csrr x14, 0xd04

    #Unmapped address 0xce1 testing: Read Reset + Random data Write/Read
    #Address 0xce1 read value
    csrr x14, 0xce1

    #Address 0xce1 Write value 0xff358ba4
    li x3, 0xff358ba4
    csrw 0xce1, x3

    #Address 0xce1 read value
    csrr x14, 0xce1

    #Unmapped address 0xe50 testing: Read Reset + Random data Write/Read
    #Address 0xe50 read value
    csrr x14, 0xe50

    #Address 0xe50 Write value 0xbe363e33
    li x3, 0xbe363e33
    csrw 0xe50, x3

    #Address 0xe50 read value
    csrr x14, 0xe50

    #Unmapped address 0x545 testing: Read Reset + Random data Write/Read
    #Address 0x545 read value
    csrr x14, 0x545

    #Address 0x545 Write value 0x23ed9c95
    li x3, 0x23ed9c95
    csrw 0x545, x3

    #Address 0x545 read value
    csrr x14, 0x545

    #Unmapped address 0xdfa testing: Read Reset + Random data Write/Read
    #Address 0xdfa read value
    csrr x14, 0xdfa

    #Address 0xdfa Write value 0x49ce91b9
    li x3, 0x49ce91b9
    csrw 0xdfa, x3

    #Address 0xdfa read value
    csrr x14, 0xdfa

    #Unmapped address 0xeb4 testing: Read Reset + Random data Write/Read
    #Address 0xeb4 read value
    csrr x14, 0xeb4

    #Address 0xeb4 Write value 0x48850442
    li x3, 0x48850442
    csrw 0xeb4, x3

    #Address 0xeb4 read value
    csrr x14, 0xeb4

    #Unmapped address 0xda5 testing: Read Reset + Random data Write/Read
    #Address 0xda5 read value
    csrr x14, 0xda5

    #Address 0xda5 Write value 0xa978ed90
    li x3, 0xa978ed90
    csrw 0xda5, x3

    #Address 0xda5 read value
    csrr x14, 0xda5

    #Unmapped address 0x3e7 testing: Read Reset + Random data Write/Read
    #Address 0x3e7 read value
    csrr x14, 0x3e7

    #Address 0x3e7 Write value 0xa049a649
    li x3, 0xa049a649
    csrw 0x3e7, x3

    #Address 0x3e7 read value
    csrr x14, 0x3e7

    #Unmapped address 0x5fc testing: Read Reset + Random data Write/Read
    #Address 0x5fc read value
    csrr x14, 0x5fc

    #Address 0x5fc Write value 0xeda41e54
    li x3, 0xeda41e54
    csrw 0x5fc, x3

    #Address 0x5fc read value
    csrr x14, 0x5fc

    #Unmapped address 0x4e5 testing: Read Reset + Random data Write/Read
    #Address 0x4e5 read value
    csrr x14, 0x4e5

    #Address 0x4e5 Write value 0xd3404500
    li x3, 0xd3404500
    csrw 0x4e5, x3

    #Address 0x4e5 read value
    csrr x14, 0x4e5

    #Unmapped address 0x76b testing: Read Reset + Random data Write/Read
    #Address 0x76b read value
    csrr x14, 0x76b

    #Address 0x76b Write value 0x95379f6
    li x3, 0x95379f6
    csrw 0x76b, x3

    #Address 0x76b read value
    csrr x14, 0x76b

    #Unmapped address 0xfc4 testing: Read Reset + Random data Write/Read
    #Address 0xfc4 read value
    csrr x14, 0xfc4

    #Address 0xfc4 Write value 0x16cbb5fe
    li x3, 0x16cbb5fe
    csrw 0xfc4, x3

    #Address 0xfc4 read value
    csrr x14, 0xfc4

    #Unmapped address 0x31f testing: Read Reset + Random data Write/Read
    #Address 0x31f read value
    csrr x14, 0x31f

    #Address 0x31f Write value 0xdc3df903
    li x3, 0xdc3df903
    csrw 0x31f, x3

    #Address 0x31f read value
    csrr x14, 0x31f

    #Unmapped address 0x110 testing: Read Reset + Random data Write/Read
    #Address 0x110 read value
    csrr x14, 0x110

    #Address 0x110 Write value 0x362ddf7a
    li x3, 0x362ddf7a
    csrw 0x110, x3

    #Address 0x110 read value
    csrr x14, 0x110

    #Unmapped address 0xf61 testing: Read Reset + Random data Write/Read
    #Address 0xf61 read value
    csrr x14, 0xf61

    #Address 0xf61 Write value 0x93650286
    li x3, 0x93650286
    csrw 0xf61, x3

    #Address 0xf61 read value
    csrr x14, 0xf61

    #Unmapped address 0x198 testing: Read Reset + Random data Write/Read
    #Address 0x198 read value
    csrr x14, 0x198

    #Address 0x198 Write value 0x66cd40db
    li x3, 0x66cd40db
    csrw 0x198, x3

    #Address 0x198 read value
    csrr x14, 0x198

    #Unmapped address 0xb67 testing: Read Reset + Random data Write/Read
    #Address 0xb67 read value
    csrr x14, 0xb67

    #Address 0xb67 Write value 0x719bef90
    li x3, 0x719bef90
    csrw 0xb67, x3

    #Address 0xb67 read value
    csrr x14, 0xb67

    #Unmapped address 0x446 testing: Read Reset + Random data Write/Read
    #Address 0x446 read value
    csrr x14, 0x446

    #Address 0x446 Write value 0x8baeef65
    li x3, 0x8baeef65
    csrw 0x446, x3

    #Address 0x446 read value
    csrr x14, 0x446

    #Unmapped address 0xc1e testing: Read Reset + Random data Write/Read
    #Address 0xc1e read value
    csrr x14, 0xc1e

    #Address 0xc1e Write value 0xc2e97553
    li x3, 0xc2e97553
    csrw 0xc1e, x3

    #Address 0xc1e read value
    csrr x14, 0xc1e

    #Unmapped address 0x8a9 testing: Read Reset + Random data Write/Read
    #Address 0x8a9 read value
    csrr x14, 0x8a9

    #Address 0x8a9 Write value 0x3f71d0e4
    li x3, 0x3f71d0e4
    csrw 0x8a9, x3

    #Address 0x8a9 read value
    csrr x14, 0x8a9

    #Unmapped address 0xce4 testing: Read Reset + Random data Write/Read
    #Address 0xce4 read value
    csrr x14, 0xce4

    #Address 0xce4 Write value 0x4449db5
    li x3, 0x4449db5
    csrw 0xce4, x3

    #Address 0xce4 read value
    csrr x14, 0xce4

    #Unmapped address 0x2ef testing: Read Reset + Random data Write/Read
    #Address 0x2ef read value
    csrr x14, 0x2ef

    #Address 0x2ef Write value 0x47e63dd
    li x3, 0x47e63dd
    csrw 0x2ef, x3

    #Address 0x2ef read value
    csrr x14, 0x2ef

    #Unmapped address 0x1ad testing: Read Reset + Random data Write/Read
    #Address 0x1ad read value
    csrr x14, 0x1ad

    #Address 0x1ad Write value 0xf48c3229
    li x3, 0xf48c3229
    csrw 0x1ad, x3

    #Address 0x1ad read value
    csrr x14, 0x1ad

    #Unmapped address 0xa32 testing: Read Reset + Random data Write/Read
    #Address 0xa32 read value
    csrr x14, 0xa32

    #Address 0xa32 Write value 0xbaed9830
    li x3, 0xbaed9830
    csrw 0xa32, x3

    #Address 0xa32 read value
    csrr x14, 0xa32

    #Unmapped address 0x50c testing: Read Reset + Random data Write/Read
    #Address 0x50c read value
    csrr x14, 0x50c

    #Address 0x50c Write value 0xb9ab02ef
    li x3, 0xb9ab02ef
    csrw 0x50c, x3

    #Address 0x50c read value
    csrr x14, 0x50c

    #Unmapped address 0x11b testing: Read Reset + Random data Write/Read
    #Address 0x11b read value
    csrr x14, 0x11b

    #Address 0x11b Write value 0xa52d1ef7
    li x3, 0xa52d1ef7
    csrw 0x11b, x3

    #Address 0x11b read value
    csrr x14, 0x11b

    #Unmapped address 0xf4f testing: Read Reset + Random data Write/Read
    #Address 0xf4f read value
    csrr x14, 0xf4f

    #Address 0xf4f Write value 0x6e49e8c
    li x3, 0x6e49e8c
    csrw 0xf4f, x3

    #Address 0xf4f read value
    csrr x14, 0xf4f

    #Unmapped address 0xdf5 testing: Read Reset + Random data Write/Read
    #Address 0xdf5 read value
    csrr x14, 0xdf5

    #Address 0xdf5 Write value 0xdf013e3e
    li x3, 0xdf013e3e
    csrw 0xdf5, x3

    #Address 0xdf5 read value
    csrr x14, 0xdf5

    #Unmapped address 0xc3d testing: Read Reset + Random data Write/Read
    #Address 0xc3d read value
    csrr x14, 0xc3d

    #Address 0xc3d Write value 0xdac6c183
    li x3, 0xdac6c183
    csrw 0xc3d, x3

    #Address 0xc3d read value
    csrr x14, 0xc3d

    #Unmapped address 0x195 testing: Read Reset + Random data Write/Read
    #Address 0x195 read value
    csrr x14, 0x195

    #Address 0x195 Write value 0xc4193273
    li x3, 0xc4193273
    csrw 0x195, x3

    #Address 0x195 read value
    csrr x14, 0x195

    #Unmapped address 0x384 testing: Read Reset + Random data Write/Read
    #Address 0x384 read value
    csrr x14, 0x384

    #Address 0x384 Write value 0x88aa12a4
    li x3, 0x88aa12a4
    csrw 0x384, x3

    #Address 0x384 read value
    csrr x14, 0x384

    #Unmapped address 0x6c2 testing: Read Reset + Random data Write/Read
    #Address 0x6c2 read value
    csrr x14, 0x6c2

    #Address 0x6c2 Write value 0x2bb0302a
    li x3, 0x2bb0302a
    csrw 0x6c2, x3

    #Address 0x6c2 read value
    csrr x14, 0x6c2

    #Unmapped address 0xb3d testing: Read Reset + Random data Write/Read
    #Address 0xb3d read value
    csrr x14, 0xb3d

    #Address 0xb3d Write value 0x77d10d1a
    li x3, 0x77d10d1a
    csrw 0xb3d, x3

    #Address 0xb3d read value
    csrr x14, 0xb3d

    #Unmapped address 0x29a testing: Read Reset + Random data Write/Read
    #Address 0x29a read value
    csrr x14, 0x29a

    #Address 0x29a Write value 0x5e0d4718
    li x3, 0x5e0d4718
    csrw 0x29a, x3

    #Address 0x29a read value
    csrr x14, 0x29a

    #Unmapped address 0x4b2 testing: Read Reset + Random data Write/Read
    #Address 0x4b2 read value
    csrr x14, 0x4b2

    #Address 0x4b2 Write value 0x8cbca2a9
    li x3, 0x8cbca2a9
    csrw 0x4b2, x3

    #Address 0x4b2 read value
    csrr x14, 0x4b2

    #Unmapped address 0x34f testing: Read Reset + Random data Write/Read
    #Address 0x34f read value
    csrr x14, 0x34f

    #Address 0x34f Write value 0x72fbe05c
    li x3, 0x72fbe05c
    csrw 0x34f, x3

    #Address 0x34f read value
    csrr x14, 0x34f

    #Unmapped address 0xa70 testing: Read Reset + Random data Write/Read
    #Address 0xa70 read value
    csrr x14, 0xa70

    #Address 0xa70 Write value 0x74c08dd7
    li x3, 0x74c08dd7
    csrw 0xa70, x3

    #Address 0xa70 read value
    csrr x14, 0xa70

    #Unmapped address 0x16 testing: Read Reset + Random data Write/Read
    #Address 0x16 read value
    csrr x14, 0x16

    #Address 0x16 Write value 0xa326ae0f
    li x3, 0xa326ae0f
    csrw 0x16, x3

    #Address 0x16 read value
    csrr x14, 0x16

    #Unmapped address 0xab3 testing: Read Reset + Random data Write/Read
    #Address 0xab3 read value
    csrr x14, 0xab3

    #Address 0xab3 Write value 0x84fa33f3
    li x3, 0x84fa33f3
    csrw 0xab3, x3

    #Address 0xab3 read value
    csrr x14, 0xab3

    #Unmapped address 0x27b testing: Read Reset + Random data Write/Read
    #Address 0x27b read value
    csrr x14, 0x27b

    #Address 0x27b Write value 0xf708095e
    li x3, 0xf708095e
    csrw 0x27b, x3

    #Address 0x27b read value
    csrr x14, 0x27b

    #Unmapped address 0x53e testing: Read Reset + Random data Write/Read
    #Address 0x53e read value
    csrr x14, 0x53e

    #Address 0x53e Write value 0xe4854254
    li x3, 0xe4854254
    csrw 0x53e, x3

    #Address 0x53e read value
    csrr x14, 0x53e

    #Unmapped address 0xa34 testing: Read Reset + Random data Write/Read
    #Address 0xa34 read value
    csrr x14, 0xa34

    #Address 0xa34 Write value 0x44ec9f6e
    li x3, 0x44ec9f6e
    csrw 0xa34, x3

    #Address 0xa34 read value
    csrr x14, 0xa34

    #Unmapped address 0x2b5 testing: Read Reset + Random data Write/Read
    #Address 0x2b5 read value
    csrr x14, 0x2b5

    #Address 0x2b5 Write value 0xdbf03562
    li x3, 0xdbf03562
    csrw 0x2b5, x3

    #Address 0x2b5 read value
    csrr x14, 0x2b5

    #Unmapped address 0x3aa testing: Read Reset + Random data Write/Read
    #Address 0x3aa read value
    csrr x14, 0x3aa

    #Address 0x3aa Write value 0xd4c6271e
    li x3, 0xd4c6271e
    csrw 0x3aa, x3

    #Address 0x3aa read value
    csrr x14, 0x3aa

    #Unmapped address 0xa8e testing: Read Reset + Random data Write/Read
    #Address 0xa8e read value
    csrr x14, 0xa8e

    #Address 0xa8e Write value 0x8a782e5f
    li x3, 0x8a782e5f
    csrw 0xa8e, x3

    #Address 0xa8e read value
    csrr x14, 0xa8e

    #Unmapped address 0xc86 testing: Read Reset + Random data Write/Read
    #Address 0xc86 read value
    csrr x14, 0xc86

    #Address 0xc86 Write value 0x7ba4abb
    li x3, 0x7ba4abb
    csrw 0xc86, x3

    #Address 0xc86 read value
    csrr x14, 0xc86

    #Unmapped address 0xa9f testing: Read Reset + Random data Write/Read
    #Address 0xa9f read value
    csrr x14, 0xa9f

    #Address 0xa9f Write value 0xa115f415
    li x3, 0xa115f415
    csrw 0xa9f, x3

    #Address 0xa9f read value
    csrr x14, 0xa9f

    #Unmapped address 0xcde testing: Read Reset + Random data Write/Read
    #Address 0xcde read value
    csrr x14, 0xcde

    #Address 0xcde Write value 0xf23f7f4c
    li x3, 0xf23f7f4c
    csrw 0xcde, x3

    #Address 0xcde read value
    csrr x14, 0xcde

    #Unmapped address 0x7ed testing: Read Reset + Random data Write/Read
    #Address 0x7ed read value
    csrr x14, 0x7ed

    #Address 0x7ed Write value 0xbbbe3558
    li x3, 0xbbbe3558
    csrw 0x7ed, x3

    #Address 0x7ed read value
    csrr x14, 0x7ed

    #Unmapped address 0x883 testing: Read Reset + Random data Write/Read
    #Address 0x883 read value
    csrr x14, 0x883

    #Address 0x883 Write value 0xb5f24df8
    li x3, 0xb5f24df8
    csrw 0x883, x3

    #Address 0x883 read value
    csrr x14, 0x883

    #Unmapped address 0xe1f testing: Read Reset + Random data Write/Read
    #Address 0xe1f read value
    csrr x14, 0xe1f

    #Address 0xe1f Write value 0xf4234849
    li x3, 0xf4234849
    csrw 0xe1f, x3

    #Address 0xe1f read value
    csrr x14, 0xe1f

    #Unmapped address 0x6d9 testing: Read Reset + Random data Write/Read
    #Address 0x6d9 read value
    csrr x14, 0x6d9

    #Address 0x6d9 Write value 0xa8c57650
    li x3, 0xa8c57650
    csrw 0x6d9, x3

    #Address 0x6d9 read value
    csrr x14, 0x6d9

    #Unmapped address 0x679 testing: Read Reset + Random data Write/Read
    #Address 0x679 read value
    csrr x14, 0x679

    #Address 0x679 Write value 0x33fae415
    li x3, 0x33fae415
    csrw 0x679, x3

    #Address 0x679 read value
    csrr x14, 0x679

    #Unmapped address 0x626 testing: Read Reset + Random data Write/Read
    #Address 0x626 read value
    csrr x14, 0x626

    #Address 0x626 Write value 0x1f6beefe
    li x3, 0x1f6beefe
    csrw 0x626, x3

    #Address 0x626 read value
    csrr x14, 0x626

    #Unmapped address 0x6f testing: Read Reset + Random data Write/Read
    #Address 0x6f read value
    csrr x14, 0x6f

    #Address 0x6f Write value 0x8fc33172
    li x3, 0x8fc33172
    csrw 0x6f, x3

    #Address 0x6f read value
    csrr x14, 0x6f

    #Unmapped address 0x931 testing: Read Reset + Random data Write/Read
    #Address 0x931 read value
    csrr x14, 0x931

    #Address 0x931 Write value 0xbddd7aa6
    li x3, 0xbddd7aa6
    csrw 0x931, x3

    #Address 0x931 read value
    csrr x14, 0x931

    #Unmapped address 0x25 testing: Read Reset + Random data Write/Read
    #Address 0x25 read value
    csrr x14, 0x25

    #Address 0x25 Write value 0xd5606b33
    li x3, 0xd5606b33
    csrw 0x25, x3

    #Address 0x25 read value
    csrr x14, 0x25

    #Unmapped address 0x808 testing: Read Reset + Random data Write/Read
    #Address 0x808 read value
    csrr x14, 0x808

    #Address 0x808 Write value 0x24009a3c
    li x3, 0x24009a3c
    csrw 0x808, x3

    #Address 0x808 read value
    csrr x14, 0x808

    #Unmapped address 0x89e testing: Read Reset + Random data Write/Read
    #Address 0x89e read value
    csrr x14, 0x89e

    #Address 0x89e Write value 0x6676a72f
    li x3, 0x6676a72f
    csrw 0x89e, x3

    #Address 0x89e read value
    csrr x14, 0x89e

    #Unmapped address 0x874 testing: Read Reset + Random data Write/Read
    #Address 0x874 read value
    csrr x14, 0x874

    #Address 0x874 Write value 0x34889001
    li x3, 0x34889001
    csrw 0x874, x3

    #Address 0x874 read value
    csrr x14, 0x874

    #Unmapped address 0x24f testing: Read Reset + Random data Write/Read
    #Address 0x24f read value
    csrr x14, 0x24f

    #Address 0x24f Write value 0x82f1196a
    li x3, 0x82f1196a
    csrw 0x24f, x3

    #Address 0x24f read value
    csrr x14, 0x24f

    #Unmapped address 0xdc9 testing: Read Reset + Random data Write/Read
    #Address 0xdc9 read value
    csrr x14, 0xdc9

    #Address 0xdc9 Write value 0x1d7e6709
    li x3, 0x1d7e6709
    csrw 0xdc9, x3

    #Address 0xdc9 read value
    csrr x14, 0xdc9

    #Unmapped address 0xf7d testing: Read Reset + Random data Write/Read
    #Address 0xf7d read value
    csrr x14, 0xf7d

    #Address 0xf7d Write value 0x92b9e287
    li x3, 0x92b9e287
    csrw 0xf7d, x3

    #Address 0xf7d read value
    csrr x14, 0xf7d

    #Unmapped address 0xba9 testing: Read Reset + Random data Write/Read
    #Address 0xba9 read value
    csrr x14, 0xba9

    #Address 0xba9 Write value 0xdd328b58
    li x3, 0xdd328b58
    csrw 0xba9, x3

    #Address 0xba9 read value
    csrr x14, 0xba9

    #Unmapped address 0xe9 testing: Read Reset + Random data Write/Read
    #Address 0xe9 read value
    csrr x14, 0xe9

    #Address 0xe9 Write value 0x3741e81
    li x3, 0x3741e81
    csrw 0xe9, x3

    #Address 0xe9 read value
    csrr x14, 0xe9

    #Unmapped address 0xff0 testing: Read Reset + Random data Write/Read
    #Address 0xff0 read value
    csrr x14, 0xff0

    #Address 0xff0 Write value 0x4a86ec5
    li x3, 0x4a86ec5
    csrw 0xff0, x3

    #Address 0xff0 read value
    csrr x14, 0xff0

    #Unmapped address 0x163 testing: Read Reset + Random data Write/Read
    #Address 0x163 read value
    csrr x14, 0x163

    #Address 0x163 Write value 0x958d1e06
    li x3, 0x958d1e06
    csrw 0x163, x3

    #Address 0x163 read value
    csrr x14, 0x163

    #Unmapped address 0x54 testing: Read Reset + Random data Write/Read
    #Address 0x54 read value
    csrr x14, 0x54

    #Address 0x54 Write value 0x3fb34d7
    li x3, 0x3fb34d7
    csrw 0x54, x3

    #Address 0x54 read value
    csrr x14, 0x54

    #Unmapped address 0xa51 testing: Read Reset + Random data Write/Read
    #Address 0xa51 read value
    csrr x14, 0xa51

    #Address 0xa51 Write value 0x878086c4
    li x3, 0x878086c4
    csrw 0xa51, x3

    #Address 0xa51 read value
    csrr x14, 0xa51

    #Unmapped address 0x2e0 testing: Read Reset + Random data Write/Read
    #Address 0x2e0 read value
    csrr x14, 0x2e0

    #Address 0x2e0 Write value 0x58440b91
    li x3, 0x58440b91
    csrw 0x2e0, x3

    #Address 0x2e0 read value
    csrr x14, 0x2e0

    #Unmapped address 0x413 testing: Read Reset + Random data Write/Read
    #Address 0x413 read value
    csrr x14, 0x413

    #Address 0x413 Write value 0xed0236bb
    li x3, 0xed0236bb
    csrw 0x413, x3

    #Address 0x413 read value
    csrr x14, 0x413

    #Unmapped address 0x2d5 testing: Read Reset + Random data Write/Read
    #Address 0x2d5 read value
    csrr x14, 0x2d5

    #Address 0x2d5 Write value 0x2a831cec
    li x3, 0x2a831cec
    csrw 0x2d5, x3

    #Address 0x2d5 read value
    csrr x14, 0x2d5

    #Unmapped address 0x516 testing: Read Reset + Random data Write/Read
    #Address 0x516 read value
    csrr x14, 0x516

    #Address 0x516 Write value 0x1e4ce758
    li x3, 0x1e4ce758
    csrw 0x516, x3

    #Address 0x516 read value
    csrr x14, 0x516

    #Unmapped address 0xc88 testing: Read Reset + Random data Write/Read
    #Address 0xc88 read value
    csrr x14, 0xc88

    #Address 0xc88 Write value 0x1550ec47
    li x3, 0x1550ec47
    csrw 0xc88, x3

    #Address 0xc88 read value
    csrr x14, 0xc88

    #Unmapped address 0x184 testing: Read Reset + Random data Write/Read
    #Address 0x184 read value
    csrr x14, 0x184

    #Address 0x184 Write value 0xeeb5a024
    li x3, 0xeeb5a024
    csrw 0x184, x3

    #Address 0x184 read value
    csrr x14, 0x184

    #Unmapped address 0x942 testing: Read Reset + Random data Write/Read
    #Address 0x942 read value
    csrr x14, 0x942

    #Address 0x942 Write value 0x9287a136
    li x3, 0x9287a136
    csrw 0x942, x3

    #Address 0x942 read value
    csrr x14, 0x942

    #Unmapped address 0x67c testing: Read Reset + Random data Write/Read
    #Address 0x67c read value
    csrr x14, 0x67c

    #Address 0x67c Write value 0x355bd95d
    li x3, 0x355bd95d
    csrw 0x67c, x3

    #Address 0x67c read value
    csrr x14, 0x67c

    #Unmapped address 0xd7d testing: Read Reset + Random data Write/Read
    #Address 0xd7d read value
    csrr x14, 0xd7d

    #Address 0xd7d Write value 0x9fc1ee42
    li x3, 0x9fc1ee42
    csrw 0xd7d, x3

    #Address 0xd7d read value
    csrr x14, 0xd7d

    #Unmapped address 0x9a testing: Read Reset + Random data Write/Read
    #Address 0x9a read value
    csrr x14, 0x9a

    #Address 0x9a Write value 0xd2eb3270
    li x3, 0xd2eb3270
    csrw 0x9a, x3

    #Address 0x9a read value
    csrr x14, 0x9a

    #Unmapped address 0x38c testing: Read Reset + Random data Write/Read
    #Address 0x38c read value
    csrr x14, 0x38c

    #Address 0x38c Write value 0x7bc21201
    li x3, 0x7bc21201
    csrw 0x38c, x3

    #Address 0x38c read value
    csrr x14, 0x38c

    #Unmapped address 0xb65 testing: Read Reset + Random data Write/Read
    #Address 0xb65 read value
    csrr x14, 0xb65

    #Address 0xb65 Write value 0x64785abd
    li x3, 0x64785abd
    csrw 0xb65, x3

    #Address 0xb65 read value
    csrr x14, 0xb65

    #Unmapped address 0x3e testing: Read Reset + Random data Write/Read
    #Address 0x3e read value
    csrr x14, 0x3e

    #Address 0x3e Write value 0xfdfdd725
    li x3, 0xfdfdd725
    csrw 0x3e, x3

    #Address 0x3e read value
    csrr x14, 0x3e

    #Unmapped address 0xb6f testing: Read Reset + Random data Write/Read
    #Address 0xb6f read value
    csrr x14, 0xb6f

    #Address 0xb6f Write value 0x887ae4d6
    li x3, 0x887ae4d6
    csrw 0xb6f, x3

    #Address 0xb6f read value
    csrr x14, 0xb6f

    #Unmapped address 0xd21 testing: Read Reset + Random data Write/Read
    #Address 0xd21 read value
    csrr x14, 0xd21

    #Address 0xd21 Write value 0x2e8c02d3
    li x3, 0x2e8c02d3
    csrw 0xd21, x3

    #Address 0xd21 read value
    csrr x14, 0xd21

    #Unmapped address 0xb6b testing: Read Reset + Random data Write/Read
    #Address 0xb6b read value
    csrr x14, 0xb6b

    #Address 0xb6b Write value 0x6f18204
    li x3, 0x6f18204
    csrw 0xb6b, x3

    #Address 0xb6b read value
    csrr x14, 0xb6b

    #Unmapped address 0xa7f testing: Read Reset + Random data Write/Read
    #Address 0xa7f read value
    csrr x14, 0xa7f

    #Address 0xa7f Write value 0xf3b8df48
    li x3, 0xf3b8df48
    csrw 0xa7f, x3

    #Address 0xa7f read value
    csrr x14, 0xa7f

    #Unmapped address 0x7e3 testing: Read Reset + Random data Write/Read
    #Address 0x7e3 read value
    csrr x14, 0x7e3

    #Address 0x7e3 Write value 0x126b1716
    li x3, 0x126b1716
    csrw 0x7e3, x3

    #Address 0x7e3 read value
    csrr x14, 0x7e3

    #Unmapped address 0xea3 testing: Read Reset + Random data Write/Read
    #Address 0xea3 read value
    csrr x14, 0xea3

    #Address 0xea3 Write value 0x7b4aaa15
    li x3, 0x7b4aaa15
    csrw 0xea3, x3

    #Address 0xea3 read value
    csrr x14, 0xea3

    #Unmapped address 0x5ec testing: Read Reset + Random data Write/Read
    #Address 0x5ec read value
    csrr x14, 0x5ec

    #Address 0x5ec Write value 0xa1882a5f
    li x3, 0xa1882a5f
    csrw 0x5ec, x3

    #Address 0x5ec read value
    csrr x14, 0x5ec

    #Unmapped address 0x2a7 testing: Read Reset + Random data Write/Read
    #Address 0x2a7 read value
    csrr x14, 0x2a7

    #Address 0x2a7 Write value 0x452f9e1a
    li x3, 0x452f9e1a
    csrw 0x2a7, x3

    #Address 0x2a7 read value
    csrr x14, 0x2a7

    #Unmapped address 0x4ac testing: Read Reset + Random data Write/Read
    #Address 0x4ac read value
    csrr x14, 0x4ac

    #Address 0x4ac Write value 0x8f5c3a58
    li x3, 0x8f5c3a58
    csrw 0x4ac, x3

    #Address 0x4ac read value
    csrr x14, 0x4ac

    #Unmapped address 0x3e6 testing: Read Reset + Random data Write/Read
    #Address 0x3e6 read value
    csrr x14, 0x3e6

    #Address 0x3e6 Write value 0xd4130e95
    li x3, 0xd4130e95
    csrw 0x3e6, x3

    #Address 0x3e6 read value
    csrr x14, 0x3e6

    #Unmapped address 0xb2f testing: Read Reset + Random data Write/Read
    #Address 0xb2f read value
    csrr x14, 0xb2f

    #Address 0xb2f Write value 0xfa127e8b
    li x3, 0xfa127e8b
    csrw 0xb2f, x3

    #Address 0xb2f read value
    csrr x14, 0xb2f

    #Unmapped address 0x3ab testing: Read Reset + Random data Write/Read
    #Address 0x3ab read value
    csrr x14, 0x3ab

    #Address 0x3ab Write value 0x4c1d5ef7
    li x3, 0x4c1d5ef7
    csrw 0x3ab, x3

    #Address 0x3ab read value
    csrr x14, 0x3ab

    #Unmapped address 0x3f5 testing: Read Reset + Random data Write/Read
    #Address 0x3f5 read value
    csrr x14, 0x3f5

    #Address 0x3f5 Write value 0x298d67a4
    li x3, 0x298d67a4
    csrw 0x3f5, x3

    #Address 0x3f5 read value
    csrr x14, 0x3f5

    #Unmapped address 0xbf3 testing: Read Reset + Random data Write/Read
    #Address 0xbf3 read value
    csrr x14, 0xbf3

    #Address 0xbf3 Write value 0x8ef0a462
    li x3, 0x8ef0a462
    csrw 0xbf3, x3

    #Address 0xbf3 read value
    csrr x14, 0xbf3

    #Unmapped address 0xf45 testing: Read Reset + Random data Write/Read
    #Address 0xf45 read value
    csrr x14, 0xf45

    #Address 0xf45 Write value 0x3445fa32
    li x3, 0x3445fa32
    csrw 0xf45, x3

    #Address 0xf45 read value
    csrr x14, 0xf45

    #Unmapped address 0xba testing: Read Reset + Random data Write/Read
    #Address 0xba read value
    csrr x14, 0xba

    #Address 0xba Write value 0x43fe4f0f
    li x3, 0x43fe4f0f
    csrw 0xba, x3

    #Address 0xba read value
    csrr x14, 0xba

    #Unmapped address 0xa1b testing: Read Reset + Random data Write/Read
    #Address 0xa1b read value
    csrr x14, 0xa1b

    #Address 0xa1b Write value 0xd08594b9
    li x3, 0xd08594b9
    csrw 0xa1b, x3

    #Address 0xa1b read value
    csrr x14, 0xa1b

    #Unmapped address 0xb52 testing: Read Reset + Random data Write/Read
    #Address 0xb52 read value
    csrr x14, 0xb52

    #Address 0xb52 Write value 0xc6f29d87
    li x3, 0xc6f29d87
    csrw 0xb52, x3

    #Address 0xb52 read value
    csrr x14, 0xb52

    #Unmapped address 0x3d8 testing: Read Reset + Random data Write/Read
    #Address 0x3d8 read value
    csrr x14, 0x3d8

    #Address 0x3d8 Write value 0xfd6b8fd5
    li x3, 0xfd6b8fd5
    csrw 0x3d8, x3

    #Address 0x3d8 read value
    csrr x14, 0x3d8

    #Unmapped address 0x5da testing: Read Reset + Random data Write/Read
    #Address 0x5da read value
    csrr x14, 0x5da

    #Address 0x5da Write value 0x17081153
    li x3, 0x17081153
    csrw 0x5da, x3

    #Address 0x5da read value
    csrr x14, 0x5da

    #Unmapped address 0x515 testing: Read Reset + Random data Write/Read
    #Address 0x515 read value
    csrr x14, 0x515

    #Address 0x515 Write value 0xf159ba01
    li x3, 0xf159ba01
    csrw 0x515, x3

    #Address 0x515 read value
    csrr x14, 0x515

    #Unmapped address 0x1ac testing: Read Reset + Random data Write/Read
    #Address 0x1ac read value
    csrr x14, 0x1ac

    #Address 0x1ac Write value 0x3856e6c2
    li x3, 0x3856e6c2
    csrw 0x1ac, x3

    #Address 0x1ac read value
    csrr x14, 0x1ac

    #Unmapped address 0x940 testing: Read Reset + Random data Write/Read
    #Address 0x940 read value
    csrr x14, 0x940

    #Address 0x940 Write value 0xa7b0a80a
    li x3, 0xa7b0a80a
    csrw 0x940, x3

    #Address 0x940 read value
    csrr x14, 0x940

    #Unmapped address 0x557 testing: Read Reset + Random data Write/Read
    #Address 0x557 read value
    csrr x14, 0x557

    #Address 0x557 Write value 0x25006634
    li x3, 0x25006634
    csrw 0x557, x3

    #Address 0x557 read value
    csrr x14, 0x557

    #Unmapped address 0xa19 testing: Read Reset + Random data Write/Read
    #Address 0xa19 read value
    csrr x14, 0xa19

    #Address 0xa19 Write value 0x352b341a
    li x3, 0x352b341a
    csrw 0xa19, x3

    #Address 0xa19 read value
    csrr x14, 0xa19

    #Unmapped address 0xdd testing: Read Reset + Random data Write/Read
    #Address 0xdd read value
    csrr x14, 0xdd

    #Address 0xdd Write value 0x851433ed
    li x3, 0x851433ed
    csrw 0xdd, x3

    #Address 0xdd read value
    csrr x14, 0xdd

    #Unmapped address 0x4d6 testing: Read Reset + Random data Write/Read
    #Address 0x4d6 read value
    csrr x14, 0x4d6

    #Address 0x4d6 Write value 0x7f652792
    li x3, 0x7f652792
    csrw 0x4d6, x3

    #Address 0x4d6 read value
    csrr x14, 0x4d6

    #Unmapped address 0x4bf testing: Read Reset + Random data Write/Read
    #Address 0x4bf read value
    csrr x14, 0x4bf

    #Address 0x4bf Write value 0x8714ab2c
    li x3, 0x8714ab2c
    csrw 0x4bf, x3

    #Address 0x4bf read value
    csrr x14, 0x4bf

    #Unmapped address 0x5fa testing: Read Reset + Random data Write/Read
    #Address 0x5fa read value
    csrr x14, 0x5fa

    #Address 0x5fa Write value 0x59d83e98
    li x3, 0x59d83e98
    csrw 0x5fa, x3

    #Address 0x5fa read value
    csrr x14, 0x5fa

    #Unmapped address 0x2a9 testing: Read Reset + Random data Write/Read
    #Address 0x2a9 read value
    csrr x14, 0x2a9

    #Address 0x2a9 Write value 0x258b04b3
    li x3, 0x258b04b3
    csrw 0x2a9, x3

    #Address 0x2a9 read value
    csrr x14, 0x2a9

    #Unmapped address 0x9ac testing: Read Reset + Random data Write/Read
    #Address 0x9ac read value
    csrr x14, 0x9ac

    #Address 0x9ac Write value 0xdf41ccb0
    li x3, 0xdf41ccb0
    csrw 0x9ac, x3

    #Address 0x9ac read value
    csrr x14, 0x9ac

    #Unmapped address 0x587 testing: Read Reset + Random data Write/Read
    #Address 0x587 read value
    csrr x14, 0x587

    #Address 0x587 Write value 0x452cf459
    li x3, 0x452cf459
    csrw 0x587, x3

    #Address 0x587 read value
    csrr x14, 0x587

    #Unmapped address 0xb71 testing: Read Reset + Random data Write/Read
    #Address 0xb71 read value
    csrr x14, 0xb71

    #Address 0xb71 Write value 0x5c267279
    li x3, 0x5c267279
    csrw 0xb71, x3

    #Address 0xb71 read value
    csrr x14, 0xb71

    #Unmapped address 0xc7e testing: Read Reset + Random data Write/Read
    #Address 0xc7e read value
    csrr x14, 0xc7e

    #Address 0xc7e Write value 0x9315e565
    li x3, 0x9315e565
    csrw 0xc7e, x3

    #Address 0xc7e read value
    csrr x14, 0xc7e

    #Unmapped address 0xb53 testing: Read Reset + Random data Write/Read
    #Address 0xb53 read value
    csrr x14, 0xb53

    #Address 0xb53 Write value 0x62ab6159
    li x3, 0x62ab6159
    csrw 0xb53, x3

    #Address 0xb53 read value
    csrr x14, 0xb53

    #Unmapped address 0xba6 testing: Read Reset + Random data Write/Read
    #Address 0xba6 read value
    csrr x14, 0xba6

    #Address 0xba6 Write value 0xe3961c40
    li x3, 0xe3961c40
    csrw 0xba6, x3

    #Address 0xba6 read value
    csrr x14, 0xba6

    #Unmapped address 0xb6 testing: Read Reset + Random data Write/Read
    #Address 0xb6 read value
    csrr x14, 0xb6

    #Address 0xb6 Write value 0x7bf5fad7
    li x3, 0x7bf5fad7
    csrw 0xb6, x3

    #Address 0xb6 read value
    csrr x14, 0xb6

    #Unmapped address 0xefa testing: Read Reset + Random data Write/Read
    #Address 0xefa read value
    csrr x14, 0xefa

    #Address 0xefa Write value 0xc8f88823
    li x3, 0xc8f88823
    csrw 0xefa, x3

    #Address 0xefa read value
    csrr x14, 0xefa

    #Unmapped address 0x495 testing: Read Reset + Random data Write/Read
    #Address 0x495 read value
    csrr x14, 0x495

    #Address 0x495 Write value 0x6daf2e05
    li x3, 0x6daf2e05
    csrw 0x495, x3

    #Address 0x495 read value
    csrr x14, 0x495

    #Unmapped address 0xb43 testing: Read Reset + Random data Write/Read
    #Address 0xb43 read value
    csrr x14, 0xb43

    #Address 0xb43 Write value 0x2633233e
    li x3, 0x2633233e
    csrw 0xb43, x3

    #Address 0xb43 read value
    csrr x14, 0xb43

    #Unmapped address 0xcd9 testing: Read Reset + Random data Write/Read
    #Address 0xcd9 read value
    csrr x14, 0xcd9

    #Address 0xcd9 Write value 0x8632e969
    li x3, 0x8632e969
    csrw 0xcd9, x3

    #Address 0xcd9 read value
    csrr x14, 0xcd9

    #Unmapped address 0x29e testing: Read Reset + Random data Write/Read
    #Address 0x29e read value
    csrr x14, 0x29e

    #Address 0x29e Write value 0xeae0c710
    li x3, 0xeae0c710
    csrw 0x29e, x3

    #Address 0x29e read value
    csrr x14, 0x29e

    #Unmapped address 0xe81 testing: Read Reset + Random data Write/Read
    #Address 0xe81 read value
    csrr x14, 0xe81

    #Address 0xe81 Write value 0x6b205e51
    li x3, 0x6b205e51
    csrw 0xe81, x3

    #Address 0xe81 read value
    csrr x14, 0xe81

    #Unmapped address 0xef1 testing: Read Reset + Random data Write/Read
    #Address 0xef1 read value
    csrr x14, 0xef1

    #Address 0xef1 Write value 0xa5545035
    li x3, 0xa5545035
    csrw 0xef1, x3

    #Address 0xef1 read value
    csrr x14, 0xef1

    #Unmapped address 0x174 testing: Read Reset + Random data Write/Read
    #Address 0x174 read value
    csrr x14, 0x174

    #Address 0x174 Write value 0x2af8a196
    li x3, 0x2af8a196
    csrw 0x174, x3

    #Address 0x174 read value
    csrr x14, 0x174

    #Unmapped address 0x6dc testing: Read Reset + Random data Write/Read
    #Address 0x6dc read value
    csrr x14, 0x6dc

    #Address 0x6dc Write value 0x54ce6b6c
    li x3, 0x54ce6b6c
    csrw 0x6dc, x3

    #Address 0x6dc read value
    csrr x14, 0x6dc

    #Unmapped address 0x6e3 testing: Read Reset + Random data Write/Read
    #Address 0x6e3 read value
    csrr x14, 0x6e3

    #Address 0x6e3 Write value 0xee235aea
    li x3, 0xee235aea
    csrw 0x6e3, x3

    #Address 0x6e3 read value
    csrr x14, 0x6e3

    #Unmapped address 0x7bf testing: Read Reset + Random data Write/Read
    #Address 0x7bf read value
    csrr x14, 0x7bf

    #Address 0x7bf Write value 0x360e1c84
    li x3, 0x360e1c84
    csrw 0x7bf, x3

    #Address 0x7bf read value
    csrr x14, 0x7bf

    #Unmapped address 0x7 testing: Read Reset + Random data Write/Read
    #Address 0x7 read value
    csrr x14, 0x7

    #Address 0x7 Write value 0x681843b7
    li x3, 0x681843b7
    csrw 0x7, x3

    #Address 0x7 read value
    csrr x14, 0x7

    #Unmapped address 0x98d testing: Read Reset + Random data Write/Read
    #Address 0x98d read value
    csrr x14, 0x98d

    #Address 0x98d Write value 0x55de1b40
    li x3, 0x55de1b40
    csrw 0x98d, x3

    #Address 0x98d read value
    csrr x14, 0x98d

    #Unmapped address 0xe7e testing: Read Reset + Random data Write/Read
    #Address 0xe7e read value
    csrr x14, 0xe7e

    #Address 0xe7e Write value 0xbe47441d
    li x3, 0xbe47441d
    csrw 0xe7e, x3

    #Address 0xe7e read value
    csrr x14, 0xe7e

    #Unmapped address 0x348 testing: Read Reset + Random data Write/Read
    #Address 0x348 read value
    csrr x14, 0x348

    #Address 0x348 Write value 0x795cd4f6
    li x3, 0x795cd4f6
    csrw 0x348, x3

    #Address 0x348 read value
    csrr x14, 0x348

    #Unmapped address 0x6fb testing: Read Reset + Random data Write/Read
    #Address 0x6fb read value
    csrr x14, 0x6fb

    #Address 0x6fb Write value 0x3f334fbe
    li x3, 0x3f334fbe
    csrw 0x6fb, x3

    #Address 0x6fb read value
    csrr x14, 0x6fb

    #Unmapped address 0x66b testing: Read Reset + Random data Write/Read
    #Address 0x66b read value
    csrr x14, 0x66b

    #Address 0x66b Write value 0xca7eb690
    li x3, 0xca7eb690
    csrw 0x66b, x3

    #Address 0x66b read value
    csrr x14, 0x66b

    #Unmapped address 0x832 testing: Read Reset + Random data Write/Read
    #Address 0x832 read value
    csrr x14, 0x832

    #Address 0x832 Write value 0xb0febca0
    li x3, 0xb0febca0
    csrw 0x832, x3

    #Address 0x832 read value
    csrr x14, 0x832

    #Unmapped address 0x8cb testing: Read Reset + Random data Write/Read
    #Address 0x8cb read value
    csrr x14, 0x8cb

    #Address 0x8cb Write value 0x8cf4b86c
    li x3, 0x8cf4b86c
    csrw 0x8cb, x3

    #Address 0x8cb read value
    csrr x14, 0x8cb

    #Unmapped address 0xe87 testing: Read Reset + Random data Write/Read
    #Address 0xe87 read value
    csrr x14, 0xe87

    #Address 0xe87 Write value 0x4c28c72d
    li x3, 0x4c28c72d
    csrw 0xe87, x3

    #Address 0xe87 read value
    csrr x14, 0xe87

    #Unmapped address 0xf98 testing: Read Reset + Random data Write/Read
    #Address 0xf98 read value
    csrr x14, 0xf98

    #Address 0xf98 Write value 0xec88e80c
    li x3, 0xec88e80c
    csrw 0xf98, x3

    #Address 0xf98 read value
    csrr x14, 0xf98

    #Unmapped address 0x4a6 testing: Read Reset + Random data Write/Read
    #Address 0x4a6 read value
    csrr x14, 0x4a6

    #Address 0x4a6 Write value 0x1b5abaed
    li x3, 0x1b5abaed
    csrw 0x4a6, x3

    #Address 0x4a6 read value
    csrr x14, 0x4a6

    #Unmapped address 0xf69 testing: Read Reset + Random data Write/Read
    #Address 0xf69 read value
    csrr x14, 0xf69

    #Address 0xf69 Write value 0x4520d0b9
    li x3, 0x4520d0b9
    csrw 0xf69, x3

    #Address 0xf69 read value
    csrr x14, 0xf69

    #Unmapped address 0x218 testing: Read Reset + Random data Write/Read
    #Address 0x218 read value
    csrr x14, 0x218

    #Address 0x218 Write value 0x890ea53f
    li x3, 0x890ea53f
    csrw 0x218, x3

    #Address 0x218 read value
    csrr x14, 0x218

    #Unmapped address 0xb7e testing: Read Reset + Random data Write/Read
    #Address 0xb7e read value
    csrr x14, 0xb7e

    #Address 0xb7e Write value 0x3221c155
    li x3, 0x3221c155
    csrw 0xb7e, x3

    #Address 0xb7e read value
    csrr x14, 0xb7e

    #Unmapped address 0xcae testing: Read Reset + Random data Write/Read
    #Address 0xcae read value
    csrr x14, 0xcae

    #Address 0xcae Write value 0x68fdb216
    li x3, 0x68fdb216
    csrw 0xcae, x3

    #Address 0xcae read value
    csrr x14, 0xcae

    #Unmapped address 0xf37 testing: Read Reset + Random data Write/Read
    #Address 0xf37 read value
    csrr x14, 0xf37

    #Address 0xf37 Write value 0xdf0257c3
    li x3, 0xdf0257c3
    csrw 0xf37, x3

    #Address 0xf37 read value
    csrr x14, 0xf37

    #Unmapped address 0x31b testing: Read Reset + Random data Write/Read
    #Address 0x31b read value
    csrr x14, 0x31b

    #Address 0x31b Write value 0x3ccfb25
    li x3, 0x3ccfb25
    csrw 0x31b, x3

    #Address 0x31b read value
    csrr x14, 0x31b

    #Unmapped address 0x455 testing: Read Reset + Random data Write/Read
    #Address 0x455 read value
    csrr x14, 0x455

    #Address 0x455 Write value 0x54b65e6b
    li x3, 0x54b65e6b
    csrw 0x455, x3

    #Address 0x455 read value
    csrr x14, 0x455

    #Unmapped address 0xfbf testing: Read Reset + Random data Write/Read
    #Address 0xfbf read value
    csrr x14, 0xfbf

    #Address 0xfbf Write value 0xf2a8a704
    li x3, 0xf2a8a704
    csrw 0xfbf, x3

    #Address 0xfbf read value
    csrr x14, 0xfbf

    #Unmapped address 0x906 testing: Read Reset + Random data Write/Read
    #Address 0x906 read value
    csrr x14, 0x906

    #Address 0x906 Write value 0xecb20c8c
    li x3, 0xecb20c8c
    csrw 0x906, x3

    #Address 0x906 read value
    csrr x14, 0x906

    #Unmapped address 0xdb5 testing: Read Reset + Random data Write/Read
    #Address 0xdb5 read value
    csrr x14, 0xdb5

    #Address 0xdb5 Write value 0x937cfdf4
    li x3, 0x937cfdf4
    csrw 0xdb5, x3

    #Address 0xdb5 read value
    csrr x14, 0xdb5

    #Unmapped address 0xc70 testing: Read Reset + Random data Write/Read
    #Address 0xc70 read value
    csrr x14, 0xc70

    #Address 0xc70 Write value 0x3bb86ec4
    li x3, 0x3bb86ec4
    csrw 0xc70, x3

    #Address 0xc70 read value
    csrr x14, 0xc70

    #Unmapped address 0xdfe testing: Read Reset + Random data Write/Read
    #Address 0xdfe read value
    csrr x14, 0xdfe

    #Address 0xdfe Write value 0x448830c
    li x3, 0x448830c
    csrw 0xdfe, x3

    #Address 0xdfe read value
    csrr x14, 0xdfe

    #Unmapped address 0x479 testing: Read Reset + Random data Write/Read
    #Address 0x479 read value
    csrr x14, 0x479

    #Address 0x479 Write value 0x23a0c0f9
    li x3, 0x23a0c0f9
    csrw 0x479, x3

    #Address 0x479 read value
    csrr x14, 0x479

    #Unmapped address 0xddd testing: Read Reset + Random data Write/Read
    #Address 0xddd read value
    csrr x14, 0xddd

    #Address 0xddd Write value 0x2d3e8644
    li x3, 0x2d3e8644
    csrw 0xddd, x3

    #Address 0xddd read value
    csrr x14, 0xddd

    #Unmapped address 0xc4 testing: Read Reset + Random data Write/Read
    #Address 0xc4 read value
    csrr x14, 0xc4

    #Address 0xc4 Write value 0x34fe9407
    li x3, 0x34fe9407
    csrw 0xc4, x3

    #Address 0xc4 read value
    csrr x14, 0xc4

    #Unmapped address 0x8ab testing: Read Reset + Random data Write/Read
    #Address 0x8ab read value
    csrr x14, 0x8ab

    #Address 0x8ab Write value 0x4f5b4a43
    li x3, 0x4f5b4a43
    csrw 0x8ab, x3

    #Address 0x8ab read value
    csrr x14, 0x8ab

    #Unmapped address 0xb32 testing: Read Reset + Random data Write/Read
    #Address 0xb32 read value
    csrr x14, 0xb32

    #Address 0xb32 Write value 0x21b5a1c8
    li x3, 0x21b5a1c8
    csrw 0xb32, x3

    #Address 0xb32 read value
    csrr x14, 0xb32

    #Unmapped address 0xb8 testing: Read Reset + Random data Write/Read
    #Address 0xb8 read value
    csrr x14, 0xb8

    #Address 0xb8 Write value 0x8a6f88d0
    li x3, 0x8a6f88d0
    csrw 0xb8, x3

    #Address 0xb8 read value
    csrr x14, 0xb8

    #Unmapped address 0x93a testing: Read Reset + Random data Write/Read
    #Address 0x93a read value
    csrr x14, 0x93a

    #Address 0x93a Write value 0x93ac3134
    li x3, 0x93ac3134
    csrw 0x93a, x3

    #Address 0x93a read value
    csrr x14, 0x93a

    #Unmapped address 0xae2 testing: Read Reset + Random data Write/Read
    #Address 0xae2 read value
    csrr x14, 0xae2

    #Address 0xae2 Write value 0xffe185fd
    li x3, 0xffe185fd
    csrw 0xae2, x3

    #Address 0xae2 read value
    csrr x14, 0xae2

    #Unmapped address 0xd23 testing: Read Reset + Random data Write/Read
    #Address 0xd23 read value
    csrr x14, 0xd23

    #Address 0xd23 Write value 0xf1acb3e1
    li x3, 0xf1acb3e1
    csrw 0xd23, x3

    #Address 0xd23 read value
    csrr x14, 0xd23

    #Unmapped address 0xb41 testing: Read Reset + Random data Write/Read
    #Address 0xb41 read value
    csrr x14, 0xb41

    #Address 0xb41 Write value 0x2f4abb1a
    li x3, 0x2f4abb1a
    csrw 0xb41, x3

    #Address 0xb41 read value
    csrr x14, 0xb41

    #Unmapped address 0xa01 testing: Read Reset + Random data Write/Read
    #Address 0xa01 read value
    csrr x14, 0xa01

    #Address 0xa01 Write value 0xe54f2dd9
    li x3, 0xe54f2dd9
    csrw 0xa01, x3

    #Address 0xa01 read value
    csrr x14, 0xa01

    #Unmapped address 0x256 testing: Read Reset + Random data Write/Read
    #Address 0x256 read value
    csrr x14, 0x256

    #Address 0x256 Write value 0x49bd84a0
    li x3, 0x49bd84a0
    csrw 0x256, x3

    #Address 0x256 read value
    csrr x14, 0x256

    #Unmapped address 0xd1a testing: Read Reset + Random data Write/Read
    #Address 0xd1a read value
    csrr x14, 0xd1a

    #Address 0xd1a Write value 0x6b1531e3
    li x3, 0x6b1531e3
    csrw 0xd1a, x3

    #Address 0xd1a read value
    csrr x14, 0xd1a

    #Unmapped address 0x356 testing: Read Reset + Random data Write/Read
    #Address 0x356 read value
    csrr x14, 0x356

    #Address 0x356 Write value 0x55c83d9e
    li x3, 0x55c83d9e
    csrw 0x356, x3

    #Address 0x356 read value
    csrr x14, 0x356

    #Unmapped address 0x990 testing: Read Reset + Random data Write/Read
    #Address 0x990 read value
    csrr x14, 0x990

    #Address 0x990 Write value 0x50ca14d
    li x3, 0x50ca14d
    csrw 0x990, x3

    #Address 0x990 read value
    csrr x14, 0x990

    #Unmapped address 0x786 testing: Read Reset + Random data Write/Read
    #Address 0x786 read value
    csrr x14, 0x786

    #Address 0x786 Write value 0x25d6dc66
    li x3, 0x25d6dc66
    csrw 0x786, x3

    #Address 0x786 read value
    csrr x14, 0x786

    #Unmapped address 0xb0 testing: Read Reset + Random data Write/Read
    #Address 0xb0 read value
    csrr x14, 0xb0

    #Address 0xb0 Write value 0x1634ae01
    li x3, 0x1634ae01
    csrw 0xb0, x3

    #Address 0xb0 read value
    csrr x14, 0xb0

    #Unmapped address 0x404 testing: Read Reset + Random data Write/Read
    #Address 0x404 read value
    csrr x14, 0x404

    #Address 0x404 Write value 0x7dfb45e3
    li x3, 0x7dfb45e3
    csrw 0x404, x3

    #Address 0x404 read value
    csrr x14, 0x404

    #Unmapped address 0xc7 testing: Read Reset + Random data Write/Read
    #Address 0xc7 read value
    csrr x14, 0xc7

    #Address 0xc7 Write value 0x94d23254
    li x3, 0x94d23254
    csrw 0xc7, x3

    #Address 0xc7 read value
    csrr x14, 0xc7

    #Unmapped address 0xdb8 testing: Read Reset + Random data Write/Read
    #Address 0xdb8 read value
    csrr x14, 0xdb8

    #Address 0xdb8 Write value 0x487e24e7
    li x3, 0x487e24e7
    csrw 0xdb8, x3

    #Address 0xdb8 read value
    csrr x14, 0xdb8

    #Unmapped address 0xf04 testing: Read Reset + Random data Write/Read
    #Address 0xf04 read value
    csrr x14, 0xf04

    #Address 0xf04 Write value 0x6bd7b2ea
    li x3, 0x6bd7b2ea
    csrw 0xf04, x3

    #Address 0xf04 read value
    csrr x14, 0xf04

    #Unmapped address 0x8b6 testing: Read Reset + Random data Write/Read
    #Address 0x8b6 read value
    csrr x14, 0x8b6

    #Address 0x8b6 Write value 0x324923d5
    li x3, 0x324923d5
    csrw 0x8b6, x3

    #Address 0x8b6 read value
    csrr x14, 0x8b6

    #Unmapped address 0x249 testing: Read Reset + Random data Write/Read
    #Address 0x249 read value
    csrr x14, 0x249

    #Address 0x249 Write value 0x506f07f4
    li x3, 0x506f07f4
    csrw 0x249, x3

    #Address 0x249 read value
    csrr x14, 0x249

    #Unmapped address 0x227 testing: Read Reset + Random data Write/Read
    #Address 0x227 read value
    csrr x14, 0x227

    #Address 0x227 Write value 0x1ce4d512
    li x3, 0x1ce4d512
    csrw 0x227, x3

    #Address 0x227 read value
    csrr x14, 0x227

    #Unmapped address 0x55d testing: Read Reset + Random data Write/Read
    #Address 0x55d read value
    csrr x14, 0x55d

    #Address 0x55d Write value 0xdb987be2
    li x3, 0xdb987be2
    csrw 0x55d, x3

    #Address 0x55d read value
    csrr x14, 0x55d

    #Unmapped address 0x14 testing: Read Reset + Random data Write/Read
    #Address 0x14 read value
    csrr x14, 0x14

    #Address 0x14 Write value 0xf9df3dc0
    li x3, 0xf9df3dc0
    csrw 0x14, x3

    #Address 0x14 read value
    csrr x14, 0x14

    #Unmapped address 0xbf1 testing: Read Reset + Random data Write/Read
    #Address 0xbf1 read value
    csrr x14, 0xbf1

    #Address 0xbf1 Write value 0x28fda8df
    li x3, 0x28fda8df
    csrw 0xbf1, x3

    #Address 0xbf1 read value
    csrr x14, 0xbf1

    #Unmapped address 0x61f testing: Read Reset + Random data Write/Read
    #Address 0x61f read value
    csrr x14, 0x61f

    #Address 0x61f Write value 0x3c8da502
    li x3, 0x3c8da502
    csrw 0x61f, x3

    #Address 0x61f read value
    csrr x14, 0x61f

    #Unmapped address 0x86b testing: Read Reset + Random data Write/Read
    #Address 0x86b read value
    csrr x14, 0x86b

    #Address 0x86b Write value 0x972b33be
    li x3, 0x972b33be
    csrw 0x86b, x3

    #Address 0x86b read value
    csrr x14, 0x86b

    #Unmapped address 0x84d testing: Read Reset + Random data Write/Read
    #Address 0x84d read value
    csrr x14, 0x84d

    #Address 0x84d Write value 0x57020cdc
    li x3, 0x57020cdc
    csrw 0x84d, x3

    #Address 0x84d read value
    csrr x14, 0x84d

    #Unmapped address 0x16b testing: Read Reset + Random data Write/Read
    #Address 0x16b read value
    csrr x14, 0x16b

    #Address 0x16b Write value 0xc1c6b68c
    li x3, 0xc1c6b68c
    csrw 0x16b, x3

    #Address 0x16b read value
    csrr x14, 0x16b

    #Unmapped address 0x40d testing: Read Reset + Random data Write/Read
    #Address 0x40d read value
    csrr x14, 0x40d

    #Address 0x40d Write value 0x884965f2
    li x3, 0x884965f2
    csrw 0x40d, x3

    #Address 0x40d read value
    csrr x14, 0x40d

    #Unmapped address 0xac1 testing: Read Reset + Random data Write/Read
    #Address 0xac1 read value
    csrr x14, 0xac1

    #Address 0xac1 Write value 0x2ac8e0cf
    li x3, 0x2ac8e0cf
    csrw 0xac1, x3

    #Address 0xac1 read value
    csrr x14, 0xac1

    #Unmapped address 0x248 testing: Read Reset + Random data Write/Read
    #Address 0x248 read value
    csrr x14, 0x248

    #Address 0x248 Write value 0x8f4ff255
    li x3, 0x8f4ff255
    csrw 0x248, x3

    #Address 0x248 read value
    csrr x14, 0x248

    #Unmapped address 0x6c5 testing: Read Reset + Random data Write/Read
    #Address 0x6c5 read value
    csrr x14, 0x6c5

    #Address 0x6c5 Write value 0x53a40507
    li x3, 0x53a40507
    csrw 0x6c5, x3

    #Address 0x6c5 read value
    csrr x14, 0x6c5

    #Unmapped address 0x28c testing: Read Reset + Random data Write/Read
    #Address 0x28c read value
    csrr x14, 0x28c

    #Address 0x28c Write value 0xf92a268c
    li x3, 0xf92a268c
    csrw 0x28c, x3

    #Address 0x28c read value
    csrr x14, 0x28c

    #Unmapped address 0x56e testing: Read Reset + Random data Write/Read
    #Address 0x56e read value
    csrr x14, 0x56e

    #Address 0x56e Write value 0x7bf271d2
    li x3, 0x7bf271d2
    csrw 0x56e, x3

    #Address 0x56e read value
    csrr x14, 0x56e

    #Unmapped address 0x54a testing: Read Reset + Random data Write/Read
    #Address 0x54a read value
    csrr x14, 0x54a

    #Address 0x54a Write value 0x3a11f8cb
    li x3, 0x3a11f8cb
    csrw 0x54a, x3

    #Address 0x54a read value
    csrr x14, 0x54a

    #Unmapped address 0x21b testing: Read Reset + Random data Write/Read
    #Address 0x21b read value
    csrr x14, 0x21b

    #Address 0x21b Write value 0x3e1540c3
    li x3, 0x3e1540c3
    csrw 0x21b, x3

    #Address 0x21b read value
    csrr x14, 0x21b

    #Unmapped address 0x19d testing: Read Reset + Random data Write/Read
    #Address 0x19d read value
    csrr x14, 0x19d

    #Address 0x19d Write value 0x2b9cdfee
    li x3, 0x2b9cdfee
    csrw 0x19d, x3

    #Address 0x19d read value
    csrr x14, 0x19d

    #Unmapped address 0x449 testing: Read Reset + Random data Write/Read
    #Address 0x449 read value
    csrr x14, 0x449

    #Address 0x449 Write value 0xc99a8174
    li x3, 0xc99a8174
    csrw 0x449, x3

    #Address 0x449 read value
    csrr x14, 0x449

    #Unmapped address 0x4f5 testing: Read Reset + Random data Write/Read
    #Address 0x4f5 read value
    csrr x14, 0x4f5

    #Address 0x4f5 Write value 0x7373d113
    li x3, 0x7373d113
    csrw 0x4f5, x3

    #Address 0x4f5 read value
    csrr x14, 0x4f5

    #Unmapped address 0x50f testing: Read Reset + Random data Write/Read
    #Address 0x50f read value
    csrr x14, 0x50f

    #Address 0x50f Write value 0x4760e30
    li x3, 0x4760e30
    csrw 0x50f, x3

    #Address 0x50f read value
    csrr x14, 0x50f

    #Unmapped address 0xa72 testing: Read Reset + Random data Write/Read
    #Address 0xa72 read value
    csrr x14, 0xa72

    #Address 0xa72 Write value 0xfbaef83b
    li x3, 0xfbaef83b
    csrw 0xa72, x3

    #Address 0xa72 read value
    csrr x14, 0xa72

    #Unmapped address 0x946 testing: Read Reset + Random data Write/Read
    #Address 0x946 read value
    csrr x14, 0x946

    #Address 0x946 Write value 0xcdf041b7
    li x3, 0xcdf041b7
    csrw 0x946, x3

    #Address 0x946 read value
    csrr x14, 0x946

    #Unmapped address 0x8c9 testing: Read Reset + Random data Write/Read
    #Address 0x8c9 read value
    csrr x14, 0x8c9

    #Address 0x8c9 Write value 0x11004363
    li x3, 0x11004363
    csrw 0x8c9, x3

    #Address 0x8c9 read value
    csrr x14, 0x8c9

    #Unmapped address 0x3a7 testing: Read Reset + Random data Write/Read
    #Address 0x3a7 read value
    csrr x14, 0x3a7

    #Address 0x3a7 Write value 0xa791ad5d
    li x3, 0xa791ad5d
    csrw 0x3a7, x3

    #Address 0x3a7 read value
    csrr x14, 0x3a7

    #Unmapped address 0xa73 testing: Read Reset + Random data Write/Read
    #Address 0xa73 read value
    csrr x14, 0xa73

    #Address 0xa73 Write value 0xe14000c0
    li x3, 0xe14000c0
    csrw 0xa73, x3

    #Address 0xa73 read value
    csrr x14, 0xa73

    #Unmapped address 0xaa testing: Read Reset + Random data Write/Read
    #Address 0xaa read value
    csrr x14, 0xaa

    #Address 0xaa Write value 0x148837f6
    li x3, 0x148837f6
    csrw 0xaa, x3

    #Address 0xaa read value
    csrr x14, 0xaa

    #Unmapped address 0x684 testing: Read Reset + Random data Write/Read
    #Address 0x684 read value
    csrr x14, 0x684

    #Address 0x684 Write value 0x68849c93
    li x3, 0x68849c93
    csrw 0x684, x3

    #Address 0x684 read value
    csrr x14, 0x684

    #Unmapped address 0xe72 testing: Read Reset + Random data Write/Read
    #Address 0xe72 read value
    csrr x14, 0xe72

    #Address 0xe72 Write value 0x33a11515
    li x3, 0x33a11515
    csrw 0xe72, x3

    #Address 0xe72 read value
    csrr x14, 0xe72

    #Unmapped address 0xe7c testing: Read Reset + Random data Write/Read
    #Address 0xe7c read value
    csrr x14, 0xe7c

    #Address 0xe7c Write value 0x290e390a
    li x3, 0x290e390a
    csrw 0xe7c, x3

    #Address 0xe7c read value
    csrr x14, 0xe7c

    #Unmapped address 0xe41 testing: Read Reset + Random data Write/Read
    #Address 0xe41 read value
    csrr x14, 0xe41

    #Address 0xe41 Write value 0xbc0b7a6e
    li x3, 0xbc0b7a6e
    csrw 0xe41, x3

    #Address 0xe41 read value
    csrr x14, 0xe41

    #Unmapped address 0x4d5 testing: Read Reset + Random data Write/Read
    #Address 0x4d5 read value
    csrr x14, 0x4d5

    #Address 0x4d5 Write value 0x439ad2be
    li x3, 0x439ad2be
    csrw 0x4d5, x3

    #Address 0x4d5 read value
    csrr x14, 0x4d5

    #Unmapped address 0x16d testing: Read Reset + Random data Write/Read
    #Address 0x16d read value
    csrr x14, 0x16d

    #Address 0x16d Write value 0xafa44016
    li x3, 0xafa44016
    csrw 0x16d, x3

    #Address 0x16d read value
    csrr x14, 0x16d

    #Unmapped address 0x398 testing: Read Reset + Random data Write/Read
    #Address 0x398 read value
    csrr x14, 0x398

    #Address 0x398 Write value 0xef269ac
    li x3, 0xef269ac
    csrw 0x398, x3

    #Address 0x398 read value
    csrr x14, 0x398

    #Unmapped address 0xa96 testing: Read Reset + Random data Write/Read
    #Address 0xa96 read value
    csrr x14, 0xa96

    #Address 0xa96 Write value 0x42c444a9
    li x3, 0x42c444a9
    csrw 0xa96, x3

    #Address 0xa96 read value
    csrr x14, 0xa96

    #Unmapped address 0xd9d testing: Read Reset + Random data Write/Read
    #Address 0xd9d read value
    csrr x14, 0xd9d

    #Address 0xd9d Write value 0x913052a3
    li x3, 0x913052a3
    csrw 0xd9d, x3

    #Address 0xd9d read value
    csrr x14, 0xd9d

    #Unmapped address 0xacd testing: Read Reset + Random data Write/Read
    #Address 0xacd read value
    csrr x14, 0xacd

    #Address 0xacd Write value 0x5584504d
    li x3, 0x5584504d
    csrw 0xacd, x3

    #Address 0xacd read value
    csrr x14, 0xacd

    #Unmapped address 0xf2a testing: Read Reset + Random data Write/Read
    #Address 0xf2a read value
    csrr x14, 0xf2a

    #Address 0xf2a Write value 0x4f65238b
    li x3, 0x4f65238b
    csrw 0xf2a, x3

    #Address 0xf2a read value
    csrr x14, 0xf2a

    #Unmapped address 0x943 testing: Read Reset + Random data Write/Read
    #Address 0x943 read value
    csrr x14, 0x943

    #Address 0x943 Write value 0x3187120e
    li x3, 0x3187120e
    csrw 0x943, x3

    #Address 0x943 read value
    csrr x14, 0x943

    #Unmapped address 0x9ad testing: Read Reset + Random data Write/Read
    #Address 0x9ad read value
    csrr x14, 0x9ad

    #Address 0x9ad Write value 0x64e79035
    li x3, 0x64e79035
    csrw 0x9ad, x3

    #Address 0x9ad read value
    csrr x14, 0x9ad

    #Unmapped address 0x5d1 testing: Read Reset + Random data Write/Read
    #Address 0x5d1 read value
    csrr x14, 0x5d1

    #Address 0x5d1 Write value 0xc7f6094
    li x3, 0xc7f6094
    csrw 0x5d1, x3

    #Address 0x5d1 read value
    csrr x14, 0x5d1

    #Unmapped address 0xd15 testing: Read Reset + Random data Write/Read
    #Address 0xd15 read value
    csrr x14, 0xd15

    #Address 0xd15 Write value 0x54a64946
    li x3, 0x54a64946
    csrw 0xd15, x3

    #Address 0xd15 read value
    csrr x14, 0xd15

    #Unmapped address 0x565 testing: Read Reset + Random data Write/Read
    #Address 0x565 read value
    csrr x14, 0x565

    #Address 0x565 Write value 0x1b6facf0
    li x3, 0x1b6facf0
    csrw 0x565, x3

    #Address 0x565 read value
    csrr x14, 0x565

    #Unmapped address 0x178 testing: Read Reset + Random data Write/Read
    #Address 0x178 read value
    csrr x14, 0x178

    #Address 0x178 Write value 0x862cb957
    li x3, 0x862cb957
    csrw 0x178, x3

    #Address 0x178 read value
    csrr x14, 0x178

    #Unmapped address 0xc32 testing: Read Reset + Random data Write/Read
    #Address 0xc32 read value
    csrr x14, 0xc32

    #Address 0xc32 Write value 0x50dd38bf
    li x3, 0x50dd38bf
    csrw 0xc32, x3

    #Address 0xc32 read value
    csrr x14, 0xc32

    #Unmapped address 0x144 testing: Read Reset + Random data Write/Read
    #Address 0x144 read value
    csrr x14, 0x144

    #Address 0x144 Write value 0xfb084b3
    li x3, 0xfb084b3
    csrw 0x144, x3

    #Address 0x144 read value
    csrr x14, 0x144

    #Unmapped address 0x40c testing: Read Reset + Random data Write/Read
    #Address 0x40c read value
    csrr x14, 0x40c

    #Address 0x40c Write value 0x7159b9f6
    li x3, 0x7159b9f6
    csrw 0x40c, x3

    #Address 0x40c read value
    csrr x14, 0x40c

    #Unmapped address 0x885 testing: Read Reset + Random data Write/Read
    #Address 0x885 read value
    csrr x14, 0x885

    #Address 0x885 Write value 0x5afa6565
    li x3, 0x5afa6565
    csrw 0x885, x3

    #Address 0x885 read value
    csrr x14, 0x885

    #Unmapped address 0x7aa testing: Read Reset + Random data Write/Read
    #Address 0x7aa read value
    csrr x14, 0x7aa

    #Address 0x7aa Write value 0x523cd7a9
    li x3, 0x523cd7a9
    csrw 0x7aa, x3

    #Address 0x7aa read value
    csrr x14, 0x7aa

    #Unmapped address 0xefc testing: Read Reset + Random data Write/Read
    #Address 0xefc read value
    csrr x14, 0xefc

    #Address 0xefc Write value 0x34c96b8
    li x3, 0x34c96b8
    csrw 0xefc, x3

    #Address 0xefc read value
    csrr x14, 0xefc

    #Unmapped address 0x5b2 testing: Read Reset + Random data Write/Read
    #Address 0x5b2 read value
    csrr x14, 0x5b2

    #Address 0x5b2 Write value 0xd012cd5c
    li x3, 0xd012cd5c
    csrw 0x5b2, x3

    #Address 0x5b2 read value
    csrr x14, 0x5b2

    #Unmapped address 0x967 testing: Read Reset + Random data Write/Read
    #Address 0x967 read value
    csrr x14, 0x967

    #Address 0x967 Write value 0xa0246e4d
    li x3, 0xa0246e4d
    csrw 0x967, x3

    #Address 0x967 read value
    csrr x14, 0x967

    #Unmapped address 0xd3d testing: Read Reset + Random data Write/Read
    #Address 0xd3d read value
    csrr x14, 0xd3d

    #Address 0xd3d Write value 0x3c86b0ff
    li x3, 0x3c86b0ff
    csrw 0xd3d, x3

    #Address 0xd3d read value
    csrr x14, 0xd3d

    #Unmapped address 0x99a testing: Read Reset + Random data Write/Read
    #Address 0x99a read value
    csrr x14, 0x99a

    #Address 0x99a Write value 0xdeca23ad
    li x3, 0xdeca23ad
    csrw 0x99a, x3

    #Address 0x99a read value
    csrr x14, 0x99a

    #Unmapped address 0x162 testing: Read Reset + Random data Write/Read
    #Address 0x162 read value
    csrr x14, 0x162

    #Address 0x162 Write value 0x507645fd
    li x3, 0x507645fd
    csrw 0x162, x3

    #Address 0x162 read value
    csrr x14, 0x162

    #Unmapped address 0x112 testing: Read Reset + Random data Write/Read
    #Address 0x112 read value
    csrr x14, 0x112

    #Address 0x112 Write value 0x7fcda16e
    li x3, 0x7fcda16e
    csrw 0x112, x3

    #Address 0x112 read value
    csrr x14, 0x112

    #Unmapped address 0xe4b testing: Read Reset + Random data Write/Read
    #Address 0xe4b read value
    csrr x14, 0xe4b

    #Address 0xe4b Write value 0xc469a0f6
    li x3, 0xc469a0f6
    csrw 0xe4b, x3

    #Address 0xe4b read value
    csrr x14, 0xe4b

    #Unmapped address 0xfb testing: Read Reset + Random data Write/Read
    #Address 0xfb read value
    csrr x14, 0xfb

    #Address 0xfb Write value 0x1ca8ffe5
    li x3, 0x1ca8ffe5
    csrw 0xfb, x3

    #Address 0xfb read value
    csrr x14, 0xfb

    #Unmapped address 0xc0c testing: Read Reset + Random data Write/Read
    #Address 0xc0c read value
    csrr x14, 0xc0c

    #Address 0xc0c Write value 0x82ca37b3
    li x3, 0x82ca37b3
    csrw 0xc0c, x3

    #Address 0xc0c read value
    csrr x14, 0xc0c

    #Unmapped address 0xd8 testing: Read Reset + Random data Write/Read
    #Address 0xd8 read value
    csrr x14, 0xd8

    #Address 0xd8 Write value 0x83b63e1b
    li x3, 0x83b63e1b
    csrw 0xd8, x3

    #Address 0xd8 read value
    csrr x14, 0xd8

    #Unmapped address 0xad3 testing: Read Reset + Random data Write/Read
    #Address 0xad3 read value
    csrr x14, 0xad3

    #Address 0xad3 Write value 0x269cef0e
    li x3, 0x269cef0e
    csrw 0xad3, x3

    #Address 0xad3 read value
    csrr x14, 0xad3

    #Unmapped address 0x4b9 testing: Read Reset + Random data Write/Read
    #Address 0x4b9 read value
    csrr x14, 0x4b9

    #Address 0x4b9 Write value 0x6c850ffb
    li x3, 0x6c850ffb
    csrw 0x4b9, x3

    #Address 0x4b9 read value
    csrr x14, 0x4b9

    #Unmapped address 0xe38 testing: Read Reset + Random data Write/Read
    #Address 0xe38 read value
    csrr x14, 0xe38

    #Address 0xe38 Write value 0x472a403f
    li x3, 0x472a403f
    csrw 0xe38, x3

    #Address 0xe38 read value
    csrr x14, 0xe38

    #Unmapped address 0xd57 testing: Read Reset + Random data Write/Read
    #Address 0xd57 read value
    csrr x14, 0xd57

    #Address 0xd57 Write value 0xf04a4019
    li x3, 0xf04a4019
    csrw 0xd57, x3

    #Address 0xd57 read value
    csrr x14, 0xd57

    #Unmapped address 0xd6a testing: Read Reset + Random data Write/Read
    #Address 0xd6a read value
    csrr x14, 0xd6a

    #Address 0xd6a Write value 0xd4760ff5
    li x3, 0xd4760ff5
    csrw 0xd6a, x3

    #Address 0xd6a read value
    csrr x14, 0xd6a

    #Unmapped address 0x20e testing: Read Reset + Random data Write/Read
    #Address 0x20e read value
    csrr x14, 0x20e

    #Address 0x20e Write value 0xf141446
    li x3, 0xf141446
    csrw 0x20e, x3

    #Address 0x20e read value
    csrr x14, 0x20e

    #Unmapped address 0x21c testing: Read Reset + Random data Write/Read
    #Address 0x21c read value
    csrr x14, 0x21c

    #Address 0x21c Write value 0x5c9587ed
    li x3, 0x5c9587ed
    csrw 0x21c, x3

    #Address 0x21c read value
    csrr x14, 0x21c

    #Unmapped address 0xd03 testing: Read Reset + Random data Write/Read
    #Address 0xd03 read value
    csrr x14, 0xd03

    #Address 0xd03 Write value 0x851f7a2d
    li x3, 0x851f7a2d
    csrw 0xd03, x3

    #Address 0xd03 read value
    csrr x14, 0xd03

    #Unmapped address 0x47a testing: Read Reset + Random data Write/Read
    #Address 0x47a read value
    csrr x14, 0x47a

    #Address 0x47a Write value 0x33d87bec
    li x3, 0x33d87bec
    csrw 0x47a, x3

    #Address 0x47a read value
    csrr x14, 0x47a

    #Unmapped address 0x133 testing: Read Reset + Random data Write/Read
    #Address 0x133 read value
    csrr x14, 0x133

    #Address 0x133 Write value 0x21c4426d
    li x3, 0x21c4426d
    csrw 0x133, x3

    #Address 0x133 read value
    csrr x14, 0x133

    #Unmapped address 0x29b testing: Read Reset + Random data Write/Read
    #Address 0x29b read value
    csrr x14, 0x29b

    #Address 0x29b Write value 0x7b730f2e
    li x3, 0x7b730f2e
    csrw 0x29b, x3

    #Address 0x29b read value
    csrr x14, 0x29b

    #Unmapped address 0x2bc testing: Read Reset + Random data Write/Read
    #Address 0x2bc read value
    csrr x14, 0x2bc

    #Address 0x2bc Write value 0x11fc5b82
    li x3, 0x11fc5b82
    csrw 0x2bc, x3

    #Address 0x2bc read value
    csrr x14, 0x2bc

    #Unmapped address 0x43d testing: Read Reset + Random data Write/Read
    #Address 0x43d read value
    csrr x14, 0x43d

    #Address 0x43d Write value 0x11fde134
    li x3, 0x11fde134
    csrw 0x43d, x3

    #Address 0x43d read value
    csrr x14, 0x43d

    #Unmapped address 0xd4f testing: Read Reset + Random data Write/Read
    #Address 0xd4f read value
    csrr x14, 0xd4f

    #Address 0xd4f Write value 0x29738bd3
    li x3, 0x29738bd3
    csrw 0xd4f, x3

    #Address 0xd4f read value
    csrr x14, 0xd4f

    #Unmapped address 0xadb testing: Read Reset + Random data Write/Read
    #Address 0xadb read value
    csrr x14, 0xadb

    #Address 0xadb Write value 0x38b4d817
    li x3, 0x38b4d817
    csrw 0xadb, x3

    #Address 0xadb read value
    csrr x14, 0xadb

    #Unmapped address 0xb3f testing: Read Reset + Random data Write/Read
    #Address 0xb3f read value
    csrr x14, 0xb3f

    #Address 0xb3f Write value 0xfa67882f
    li x3, 0xfa67882f
    csrw 0xb3f, x3

    #Address 0xb3f read value
    csrr x14, 0xb3f

    #Unmapped address 0x890 testing: Read Reset + Random data Write/Read
    #Address 0x890 read value
    csrr x14, 0x890

    #Address 0x890 Write value 0x8d0c3459
    li x3, 0x8d0c3459
    csrw 0x890, x3

    #Address 0x890 read value
    csrr x14, 0x890

    #Unmapped address 0xe4a testing: Read Reset + Random data Write/Read
    #Address 0xe4a read value
    csrr x14, 0xe4a

    #Address 0xe4a Write value 0xb413d1b1
    li x3, 0xb413d1b1
    csrw 0xe4a, x3

    #Address 0xe4a read value
    csrr x14, 0xe4a

    #Unmapped address 0xdef testing: Read Reset + Random data Write/Read
    #Address 0xdef read value
    csrr x14, 0xdef

    #Address 0xdef Write value 0x7335bcd6
    li x3, 0x7335bcd6
    csrw 0xdef, x3

    #Address 0xdef read value
    csrr x14, 0xdef

    #Unmapped address 0x926 testing: Read Reset + Random data Write/Read
    #Address 0x926 read value
    csrr x14, 0x926

    #Address 0x926 Write value 0x22bb3a7b
    li x3, 0x22bb3a7b
    csrw 0x926, x3

    #Address 0x926 read value
    csrr x14, 0x926

    #Unmapped address 0xad9 testing: Read Reset + Random data Write/Read
    #Address 0xad9 read value
    csrr x14, 0xad9

    #Address 0xad9 Write value 0x62cae877
    li x3, 0x62cae877
    csrw 0xad9, x3

    #Address 0xad9 read value
    csrr x14, 0xad9

    #Unmapped address 0xd54 testing: Read Reset + Random data Write/Read
    #Address 0xd54 read value
    csrr x14, 0xd54

    #Address 0xd54 Write value 0x671cd22d
    li x3, 0x671cd22d
    csrw 0xd54, x3

    #Address 0xd54 read value
    csrr x14, 0xd54

    #Unmapped address 0x4d7 testing: Read Reset + Random data Write/Read
    #Address 0x4d7 read value
    csrr x14, 0x4d7

    #Address 0x4d7 Write value 0xc77cfbe2
    li x3, 0xc77cfbe2
    csrw 0x4d7, x3

    #Address 0x4d7 read value
    csrr x14, 0x4d7

    #Unmapped address 0x53b testing: Read Reset + Random data Write/Read
    #Address 0x53b read value
    csrr x14, 0x53b

    #Address 0x53b Write value 0x247d71b1
    li x3, 0x247d71b1
    csrw 0x53b, x3

    #Address 0x53b read value
    csrr x14, 0x53b

    #Unmapped address 0xafb testing: Read Reset + Random data Write/Read
    #Address 0xafb read value
    csrr x14, 0xafb

    #Address 0xafb Write value 0x5b49f31e
    li x3, 0x5b49f31e
    csrw 0xafb, x3

    #Address 0xafb read value
    csrr x14, 0xafb

    #Unmapped address 0x660 testing: Read Reset + Random data Write/Read
    #Address 0x660 read value
    csrr x14, 0x660

    #Address 0x660 Write value 0x91498531
    li x3, 0x91498531
    csrw 0x660, x3

    #Address 0x660 read value
    csrr x14, 0x660

    #Unmapped address 0xa94 testing: Read Reset + Random data Write/Read
    #Address 0xa94 read value
    csrr x14, 0xa94

    #Address 0xa94 Write value 0xa9e717c5
    li x3, 0xa9e717c5
    csrw 0xa94, x3

    #Address 0xa94 read value
    csrr x14, 0xa94

    #Unmapped address 0xed5 testing: Read Reset + Random data Write/Read
    #Address 0xed5 read value
    csrr x14, 0xed5

    #Address 0xed5 Write value 0x13704722
    li x3, 0x13704722
    csrw 0xed5, x3

    #Address 0xed5 read value
    csrr x14, 0xed5

    #Unmapped address 0xcfd testing: Read Reset + Random data Write/Read
    #Address 0xcfd read value
    csrr x14, 0xcfd

    #Address 0xcfd Write value 0xcc45c0cb
    li x3, 0xcc45c0cb
    csrw 0xcfd, x3

    #Address 0xcfd read value
    csrr x14, 0xcfd

    #Unmapped address 0xd3e testing: Read Reset + Random data Write/Read
    #Address 0xd3e read value
    csrr x14, 0xd3e

    #Address 0xd3e Write value 0x15a7c6a1
    li x3, 0x15a7c6a1
    csrw 0xd3e, x3

    #Address 0xd3e read value
    csrr x14, 0xd3e

    #Unmapped address 0xf89 testing: Read Reset + Random data Write/Read
    #Address 0xf89 read value
    csrr x14, 0xf89

    #Address 0xf89 Write value 0x378e2b06
    li x3, 0x378e2b06
    csrw 0xf89, x3

    #Address 0xf89 read value
    csrr x14, 0xf89

    #Unmapped address 0x6f5 testing: Read Reset + Random data Write/Read
    #Address 0x6f5 read value
    csrr x14, 0x6f5

    #Address 0x6f5 Write value 0x425865bf
    li x3, 0x425865bf
    csrw 0x6f5, x3

    #Address 0x6f5 read value
    csrr x14, 0x6f5

    #Unmapped address 0xd07 testing: Read Reset + Random data Write/Read
    #Address 0xd07 read value
    csrr x14, 0xd07

    #Address 0xd07 Write value 0x7b26af13
    li x3, 0x7b26af13
    csrw 0xd07, x3

    #Address 0xd07 read value
    csrr x14, 0xd07

    #Unmapped address 0x5f7 testing: Read Reset + Random data Write/Read
    #Address 0x5f7 read value
    csrr x14, 0x5f7

    #Address 0x5f7 Write value 0x41094485
    li x3, 0x41094485
    csrw 0x5f7, x3

    #Address 0x5f7 read value
    csrr x14, 0x5f7

    #Unmapped address 0xf33 testing: Read Reset + Random data Write/Read
    #Address 0xf33 read value
    csrr x14, 0xf33

    #Address 0xf33 Write value 0x2e6c26ac
    li x3, 0x2e6c26ac
    csrw 0xf33, x3

    #Address 0xf33 read value
    csrr x14, 0xf33

    #Unmapped address 0x8f5 testing: Read Reset + Random data Write/Read
    #Address 0x8f5 read value
    csrr x14, 0x8f5

    #Address 0x8f5 Write value 0x304835ab
    li x3, 0x304835ab
    csrw 0x8f5, x3

    #Address 0x8f5 read value
    csrr x14, 0x8f5

    #Unmapped address 0x9f9 testing: Read Reset + Random data Write/Read
    #Address 0x9f9 read value
    csrr x14, 0x9f9

    #Address 0x9f9 Write value 0x8ecf6686
    li x3, 0x8ecf6686
    csrw 0x9f9, x3

    #Address 0x9f9 read value
    csrr x14, 0x9f9

    #Unmapped address 0x6d testing: Read Reset + Random data Write/Read
    #Address 0x6d read value
    csrr x14, 0x6d

    #Address 0x6d Write value 0xfc5f4abd
    li x3, 0xfc5f4abd
    csrw 0x6d, x3

    #Address 0x6d read value
    csrr x14, 0x6d

    #Unmapped address 0x6ac testing: Read Reset + Random data Write/Read
    #Address 0x6ac read value
    csrr x14, 0x6ac

    #Address 0x6ac Write value 0xcd90df83
    li x3, 0xcd90df83
    csrw 0x6ac, x3

    #Address 0x6ac read value
    csrr x14, 0x6ac

    #Unmapped address 0x2bb testing: Read Reset + Random data Write/Read
    #Address 0x2bb read value
    csrr x14, 0x2bb

    #Address 0x2bb Write value 0x9041afa6
    li x3, 0x9041afa6
    csrw 0x2bb, x3

    #Address 0x2bb read value
    csrr x14, 0x2bb

    #Unmapped address 0x7d5 testing: Read Reset + Random data Write/Read
    #Address 0x7d5 read value
    csrr x14, 0x7d5

    #Address 0x7d5 Write value 0xc12c66d0
    li x3, 0xc12c66d0
    csrw 0x7d5, x3

    #Address 0x7d5 read value
    csrr x14, 0x7d5

    #Unmapped address 0x1a7 testing: Read Reset + Random data Write/Read
    #Address 0x1a7 read value
    csrr x14, 0x1a7

    #Address 0x1a7 Write value 0xeb4d2cdb
    li x3, 0xeb4d2cdb
    csrw 0x1a7, x3

    #Address 0x1a7 read value
    csrr x14, 0x1a7

    #Unmapped address 0x6fd testing: Read Reset + Random data Write/Read
    #Address 0x6fd read value
    csrr x14, 0x6fd

    #Address 0x6fd Write value 0x8cadc123
    li x3, 0x8cadc123
    csrw 0x6fd, x3

    #Address 0x6fd read value
    csrr x14, 0x6fd

    #Unmapped address 0x1a2 testing: Read Reset + Random data Write/Read
    #Address 0x1a2 read value
    csrr x14, 0x1a2

    #Address 0x1a2 Write value 0xaa8829a9
    li x3, 0xaa8829a9
    csrw 0x1a2, x3

    #Address 0x1a2 read value
    csrr x14, 0x1a2

    #Unmapped address 0x208 testing: Read Reset + Random data Write/Read
    #Address 0x208 read value
    csrr x14, 0x208

    #Address 0x208 Write value 0x37395a63
    li x3, 0x37395a63
    csrw 0x208, x3

    #Address 0x208 read value
    csrr x14, 0x208

    #Unmapped address 0x919 testing: Read Reset + Random data Write/Read
    #Address 0x919 read value
    csrr x14, 0x919

    #Address 0x919 Write value 0xd33de26e
    li x3, 0xd33de26e
    csrw 0x919, x3

    #Address 0x919 read value
    csrr x14, 0x919

    #Unmapped address 0x320 testing: Read Reset + Random data Write/Read
    #Address 0x320 read value
    csrr x14, 0x320

    #Address 0x320 Write value 0xb22464be
    li x3, 0xb22464be
    csrw 0x320, x3

    #Address 0x320 read value
    csrr x14, 0x320

    #Unmapped address 0x8a6 testing: Read Reset + Random data Write/Read
    #Address 0x8a6 read value
    csrr x14, 0x8a6

    #Address 0x8a6 Write value 0xe0867d0d
    li x3, 0xe0867d0d
    csrw 0x8a6, x3

    #Address 0x8a6 read value
    csrr x14, 0x8a6

    #Unmapped address 0x8d0 testing: Read Reset + Random data Write/Read
    #Address 0x8d0 read value
    csrr x14, 0x8d0

    #Address 0x8d0 Write value 0x1aa392df
    li x3, 0x1aa392df
    csrw 0x8d0, x3

    #Address 0x8d0 read value
    csrr x14, 0x8d0

    #Unmapped address 0x287 testing: Read Reset + Random data Write/Read
    #Address 0x287 read value
    csrr x14, 0x287

    #Address 0x287 Write value 0x9d4aa9bb
    li x3, 0x9d4aa9bb
    csrw 0x287, x3

    #Address 0x287 read value
    csrr x14, 0x287

    #Unmapped address 0xa09 testing: Read Reset + Random data Write/Read
    #Address 0xa09 read value
    csrr x14, 0xa09

    #Address 0xa09 Write value 0xd213f793
    li x3, 0xd213f793
    csrw 0xa09, x3

    #Address 0xa09 read value
    csrr x14, 0xa09

    #Unmapped address 0xc77 testing: Read Reset + Random data Write/Read
    #Address 0xc77 read value
    csrr x14, 0xc77

    #Address 0xc77 Write value 0xc4247283
    li x3, 0xc4247283
    csrw 0xc77, x3

    #Address 0xc77 read value
    csrr x14, 0xc77

    #Unmapped address 0x784 testing: Read Reset + Random data Write/Read
    #Address 0x784 read value
    csrr x14, 0x784

    #Address 0x784 Write value 0xb7c1f422
    li x3, 0xb7c1f422
    csrw 0x784, x3

    #Address 0x784 read value
    csrr x14, 0x784

    #Unmapped address 0x49d testing: Read Reset + Random data Write/Read
    #Address 0x49d read value
    csrr x14, 0x49d

    #Address 0x49d Write value 0x55d33378
    li x3, 0x55d33378
    csrw 0x49d, x3

    #Address 0x49d read value
    csrr x14, 0x49d

    #Unmapped address 0x403 testing: Read Reset + Random data Write/Read
    #Address 0x403 read value
    csrr x14, 0x403

    #Address 0x403 Write value 0xae0a61a9
    li x3, 0xae0a61a9
    csrw 0x403, x3

    #Address 0x403 read value
    csrr x14, 0x403

    #Unmapped address 0xf50 testing: Read Reset + Random data Write/Read
    #Address 0xf50 read value
    csrr x14, 0xf50

    #Address 0xf50 Write value 0x6d961ce6
    li x3, 0x6d961ce6
    csrw 0xf50, x3

    #Address 0xf50 read value
    csrr x14, 0xf50

    #Unmapped address 0xbcf testing: Read Reset + Random data Write/Read
    #Address 0xbcf read value
    csrr x14, 0xbcf

    #Address 0xbcf Write value 0x8b3d464a
    li x3, 0x8b3d464a
    csrw 0xbcf, x3

    #Address 0xbcf read value
    csrr x14, 0xbcf

    #Unmapped address 0x7bc testing: Read Reset + Random data Write/Read
    #Address 0x7bc read value
    csrr x14, 0x7bc

    #Address 0x7bc Write value 0xcaae0978
    li x3, 0xcaae0978
    csrw 0x7bc, x3

    #Address 0x7bc read value
    csrr x14, 0x7bc

    #Unmapped address 0xa10 testing: Read Reset + Random data Write/Read
    #Address 0xa10 read value
    csrr x14, 0xa10

    #Address 0xa10 Write value 0xf45a4b7f
    li x3, 0xf45a4b7f
    csrw 0xa10, x3

    #Address 0xa10 read value
    csrr x14, 0xa10

    #Unmapped address 0x115 testing: Read Reset + Random data Write/Read
    #Address 0x115 read value
    csrr x14, 0x115

    #Address 0x115 Write value 0x668cacae
    li x3, 0x668cacae
    csrw 0x115, x3

    #Address 0x115 read value
    csrr x14, 0x115

    #Unmapped address 0x14a testing: Read Reset + Random data Write/Read
    #Address 0x14a read value
    csrr x14, 0x14a

    #Address 0x14a Write value 0x3f00ab32
    li x3, 0x3f00ab32
    csrw 0x14a, x3

    #Address 0x14a read value
    csrr x14, 0x14a

    #Unmapped address 0x999 testing: Read Reset + Random data Write/Read
    #Address 0x999 read value
    csrr x14, 0x999

    #Address 0x999 Write value 0x211b0e5d
    li x3, 0x211b0e5d
    csrw 0x999, x3

    #Address 0x999 read value
    csrr x14, 0x999

    #Unmapped address 0x214 testing: Read Reset + Random data Write/Read
    #Address 0x214 read value
    csrr x14, 0x214

    #Address 0x214 Write value 0x6bde3e3d
    li x3, 0x6bde3e3d
    csrw 0x214, x3

    #Address 0x214 read value
    csrr x14, 0x214

    #Unmapped address 0xc5a testing: Read Reset + Random data Write/Read
    #Address 0xc5a read value
    csrr x14, 0xc5a

    #Address 0xc5a Write value 0x8a10ce66
    li x3, 0x8a10ce66
    csrw 0xc5a, x3

    #Address 0xc5a read value
    csrr x14, 0xc5a

    #Unmapped address 0xe17 testing: Read Reset + Random data Write/Read
    #Address 0xe17 read value
    csrr x14, 0xe17

    #Address 0xe17 Write value 0x8e7638cb
    li x3, 0x8e7638cb
    csrw 0xe17, x3

    #Address 0xe17 read value
    csrr x14, 0xe17

    #Unmapped address 0xbfb testing: Read Reset + Random data Write/Read
    #Address 0xbfb read value
    csrr x14, 0xbfb

    #Address 0xbfb Write value 0x42f7ba67
    li x3, 0x42f7ba67
    csrw 0xbfb, x3

    #Address 0xbfb read value
    csrr x14, 0xbfb

    #Unmapped address 0x34a testing: Read Reset + Random data Write/Read
    #Address 0x34a read value
    csrr x14, 0x34a

    #Address 0x34a Write value 0x465fade4
    li x3, 0x465fade4
    csrw 0x34a, x3

    #Address 0x34a read value
    csrr x14, 0x34a

    #Unmapped address 0x685 testing: Read Reset + Random data Write/Read
    #Address 0x685 read value
    csrr x14, 0x685

    #Address 0x685 Write value 0xc6ec7739
    li x3, 0xc6ec7739
    csrw 0x685, x3

    #Address 0x685 read value
    csrr x14, 0x685

    #Unmapped address 0x8d2 testing: Read Reset + Random data Write/Read
    #Address 0x8d2 read value
    csrr x14, 0x8d2

    #Address 0x8d2 Write value 0x4ef271d
    li x3, 0x4ef271d
    csrw 0x8d2, x3

    #Address 0x8d2 read value
    csrr x14, 0x8d2

    #Unmapped address 0xe10 testing: Read Reset + Random data Write/Read
    #Address 0xe10 read value
    csrr x14, 0xe10

    #Address 0xe10 Write value 0x7e7ac557
    li x3, 0x7e7ac557
    csrw 0xe10, x3

    #Address 0xe10 read value
    csrr x14, 0xe10

    #Unmapped address 0x4dd testing: Read Reset + Random data Write/Read
    #Address 0x4dd read value
    csrr x14, 0x4dd

    #Address 0x4dd Write value 0x3ca7cdf4
    li x3, 0x3ca7cdf4
    csrw 0x4dd, x3

    #Address 0x4dd read value
    csrr x14, 0x4dd

    #Unmapped address 0x9b3 testing: Read Reset + Random data Write/Read
    #Address 0x9b3 read value
    csrr x14, 0x9b3

    #Address 0x9b3 Write value 0x828ede19
    li x3, 0x828ede19
    csrw 0x9b3, x3

    #Address 0x9b3 read value
    csrr x14, 0x9b3

    #Unmapped address 0x748 testing: Read Reset + Random data Write/Read
    #Address 0x748 read value
    csrr x14, 0x748

    #Address 0x748 Write value 0x9ed77e7c
    li x3, 0x9ed77e7c
    csrw 0x748, x3

    #Address 0x748 read value
    csrr x14, 0x748

    #Unmapped address 0xeb6 testing: Read Reset + Random data Write/Read
    #Address 0xeb6 read value
    csrr x14, 0xeb6

    #Address 0xeb6 Write value 0xee8dd31b
    li x3, 0xee8dd31b
    csrw 0xeb6, x3

    #Address 0xeb6 read value
    csrr x14, 0xeb6

    #Unmapped address 0x9b4 testing: Read Reset + Random data Write/Read
    #Address 0x9b4 read value
    csrr x14, 0x9b4

    #Address 0x9b4 Write value 0x9eef2906
    li x3, 0x9eef2906
    csrw 0x9b4, x3

    #Address 0x9b4 read value
    csrr x14, 0x9b4

    #Unmapped address 0xf0e testing: Read Reset + Random data Write/Read
    #Address 0xf0e read value
    csrr x14, 0xf0e

    #Address 0xf0e Write value 0x479657d5
    li x3, 0x479657d5
    csrw 0xf0e, x3

    #Address 0xf0e read value
    csrr x14, 0xf0e

    #Unmapped address 0x17 testing: Read Reset + Random data Write/Read
    #Address 0x17 read value
    csrr x14, 0x17

    #Address 0x17 Write value 0x944766f4
    li x3, 0x944766f4
    csrw 0x17, x3

    #Address 0x17 read value
    csrr x14, 0x17

    #Unmapped address 0xb2a testing: Read Reset + Random data Write/Read
    #Address 0xb2a read value
    csrr x14, 0xb2a

    #Address 0xb2a Write value 0x8199a830
    li x3, 0x8199a830
    csrw 0xb2a, x3

    #Address 0xb2a read value
    csrr x14, 0xb2a

    #Unmapped address 0x614 testing: Read Reset + Random data Write/Read
    #Address 0x614 read value
    csrr x14, 0x614

    #Address 0x614 Write value 0x755091
    li x3, 0x755091
    csrw 0x614, x3

    #Address 0x614 read value
    csrr x14, 0x614

    #Unmapped address 0xf0f testing: Read Reset + Random data Write/Read
    #Address 0xf0f read value
    csrr x14, 0xf0f

    #Address 0xf0f Write value 0x45d5efb9
    li x3, 0x45d5efb9
    csrw 0xf0f, x3

    #Address 0xf0f read value
    csrr x14, 0xf0f

    #Unmapped address 0x541 testing: Read Reset + Random data Write/Read
    #Address 0x541 read value
    csrr x14, 0x541

    #Address 0x541 Write value 0x4bc66b7
    li x3, 0x4bc66b7
    csrw 0x541, x3

    #Address 0x541 read value
    csrr x14, 0x541

    #Unmapped address 0x58e testing: Read Reset + Random data Write/Read
    #Address 0x58e read value
    csrr x14, 0x58e

    #Address 0x58e Write value 0xfe09a0e0
    li x3, 0xfe09a0e0
    csrw 0x58e, x3

    #Address 0x58e read value
    csrr x14, 0x58e

    #Unmapped address 0x3ea testing: Read Reset + Random data Write/Read
    #Address 0x3ea read value
    csrr x14, 0x3ea

    #Address 0x3ea Write value 0xeeac9cf1
    li x3, 0xeeac9cf1
    csrw 0x3ea, x3

    #Address 0x3ea read value
    csrr x14, 0x3ea

    #Unmapped address 0x7e8 testing: Read Reset + Random data Write/Read
    #Address 0x7e8 read value
    csrr x14, 0x7e8

    #Address 0x7e8 Write value 0xbe4ad2ec
    li x3, 0xbe4ad2ec
    csrw 0x7e8, x3

    #Address 0x7e8 read value
    csrr x14, 0x7e8

    #Unmapped address 0xa55 testing: Read Reset + Random data Write/Read
    #Address 0xa55 read value
    csrr x14, 0xa55

    #Address 0xa55 Write value 0x69a8a5c1
    li x3, 0x69a8a5c1
    csrw 0xa55, x3

    #Address 0xa55 read value
    csrr x14, 0xa55

    #Unmapped address 0x12e testing: Read Reset + Random data Write/Read
    #Address 0x12e read value
    csrr x14, 0x12e

    #Address 0x12e Write value 0xf0b10e98
    li x3, 0xf0b10e98
    csrw 0x12e, x3

    #Address 0x12e read value
    csrr x14, 0x12e

    #Unmapped address 0x45b testing: Read Reset + Random data Write/Read
    #Address 0x45b read value
    csrr x14, 0x45b

    #Address 0x45b Write value 0x3c8c3d55
    li x3, 0x3c8c3d55
    csrw 0x45b, x3

    #Address 0x45b read value
    csrr x14, 0x45b

    #Unmapped address 0x211 testing: Read Reset + Random data Write/Read
    #Address 0x211 read value
    csrr x14, 0x211

    #Address 0x211 Write value 0xb1dc5b55
    li x3, 0xb1dc5b55
    csrw 0x211, x3

    #Address 0x211 read value
    csrr x14, 0x211

    #Unmapped address 0x7a2 testing: Read Reset + Random data Write/Read
    #Address 0x7a2 read value
    csrr x14, 0x7a2

    #Address 0x7a2 Write value 0x21a745f6
    li x3, 0x21a745f6
    csrw 0x7a2, x3

    #Address 0x7a2 read value
    csrr x14, 0x7a2

    #Unmapped address 0xf92 testing: Read Reset + Random data Write/Read
    #Address 0xf92 read value
    csrr x14, 0xf92

    #Address 0xf92 Write value 0x8402ff31
    li x3, 0x8402ff31
    csrw 0xf92, x3

    #Address 0xf92 read value
    csrr x14, 0xf92

    #Unmapped address 0x5f4 testing: Read Reset + Random data Write/Read
    #Address 0x5f4 read value
    csrr x14, 0x5f4

    #Address 0x5f4 Write value 0xf2d57cd
    li x3, 0xf2d57cd
    csrw 0x5f4, x3

    #Address 0x5f4 read value
    csrr x14, 0x5f4

    #Unmapped address 0x526 testing: Read Reset + Random data Write/Read
    #Address 0x526 read value
    csrr x14, 0x526

    #Address 0x526 Write value 0x7fb9b8ca
    li x3, 0x7fb9b8ca
    csrw 0x526, x3

    #Address 0x526 read value
    csrr x14, 0x526

    #Unmapped address 0x471 testing: Read Reset + Random data Write/Read
    #Address 0x471 read value
    csrr x14, 0x471

    #Address 0x471 Write value 0x78a9bb59
    li x3, 0x78a9bb59
    csrw 0x471, x3

    #Address 0x471 read value
    csrr x14, 0x471

    #Unmapped address 0xf0 testing: Read Reset + Random data Write/Read
    #Address 0xf0 read value
    csrr x14, 0xf0

    #Address 0xf0 Write value 0x22c2ce72
    li x3, 0x22c2ce72
    csrw 0xf0, x3

    #Address 0xf0 read value
    csrr x14, 0xf0

    #Unmapped address 0xdd3 testing: Read Reset + Random data Write/Read
    #Address 0xdd3 read value
    csrr x14, 0xdd3

    #Address 0xdd3 Write value 0x80e8c026
    li x3, 0x80e8c026
    csrw 0xdd3, x3

    #Address 0xdd3 read value
    csrr x14, 0xdd3

    #Unmapped address 0xf43 testing: Read Reset + Random data Write/Read
    #Address 0xf43 read value
    csrr x14, 0xf43

    #Address 0xf43 Write value 0xc8606f40
    li x3, 0xc8606f40
    csrw 0xf43, x3

    #Address 0xf43 read value
    csrr x14, 0xf43

    #Unmapped address 0xc69 testing: Read Reset + Random data Write/Read
    #Address 0xc69 read value
    csrr x14, 0xc69

    #Address 0xc69 Write value 0x6ac063c2
    li x3, 0x6ac063c2
    csrw 0xc69, x3

    #Address 0xc69 read value
    csrr x14, 0xc69

    #Unmapped address 0xd89 testing: Read Reset + Random data Write/Read
    #Address 0xd89 read value
    csrr x14, 0xd89

    #Address 0xd89 Write value 0xda55aa9e
    li x3, 0xda55aa9e
    csrw 0xd89, x3

    #Address 0xd89 read value
    csrr x14, 0xd89

    #Unmapped address 0x24 testing: Read Reset + Random data Write/Read
    #Address 0x24 read value
    csrr x14, 0x24

    #Address 0x24 Write value 0x312d8a61
    li x3, 0x312d8a61
    csrw 0x24, x3

    #Address 0x24 read value
    csrr x14, 0x24

    #Unmapped address 0xd24 testing: Read Reset + Random data Write/Read
    #Address 0xd24 read value
    csrr x14, 0xd24

    #Address 0xd24 Write value 0xf598a4ac
    li x3, 0xf598a4ac
    csrw 0xd24, x3

    #Address 0xd24 read value
    csrr x14, 0xd24

    #Unmapped address 0x387 testing: Read Reset + Random data Write/Read
    #Address 0x387 read value
    csrr x14, 0x387

    #Address 0x387 Write value 0x2706665e
    li x3, 0x2706665e
    csrw 0x387, x3

    #Address 0x387 read value
    csrr x14, 0x387

    #Unmapped address 0xa57 testing: Read Reset + Random data Write/Read
    #Address 0xa57 read value
    csrr x14, 0xa57

    #Address 0xa57 Write value 0x1dfeabae
    li x3, 0x1dfeabae
    csrw 0xa57, x3

    #Address 0xa57 read value
    csrr x14, 0xa57

    #Unmapped address 0xc54 testing: Read Reset + Random data Write/Read
    #Address 0xc54 read value
    csrr x14, 0xc54

    #Address 0xc54 Write value 0xb554d875
    li x3, 0xb554d875
    csrw 0xc54, x3

    #Address 0xc54 read value
    csrr x14, 0xc54

    #Unmapped address 0xa29 testing: Read Reset + Random data Write/Read
    #Address 0xa29 read value
    csrr x14, 0xa29

    #Address 0xa29 Write value 0xc5de04fd
    li x3, 0xc5de04fd
    csrw 0xa29, x3

    #Address 0xa29 read value
    csrr x14, 0xa29

    #Unmapped address 0xd1c testing: Read Reset + Random data Write/Read
    #Address 0xd1c read value
    csrr x14, 0xd1c

    #Address 0xd1c Write value 0x4602e314
    li x3, 0x4602e314
    csrw 0xd1c, x3

    #Address 0xd1c read value
    csrr x14, 0xd1c

    #Unmapped address 0x5e testing: Read Reset + Random data Write/Read
    #Address 0x5e read value
    csrr x14, 0x5e

    #Address 0x5e Write value 0x916507d0
    li x3, 0x916507d0
    csrw 0x5e, x3

    #Address 0x5e read value
    csrr x14, 0x5e

    #Unmapped address 0xf7e testing: Read Reset + Random data Write/Read
    #Address 0xf7e read value
    csrr x14, 0xf7e

    #Address 0xf7e Write value 0xe3f911a2
    li x3, 0xe3f911a2
    csrw 0xf7e, x3

    #Address 0xf7e read value
    csrr x14, 0xf7e

    #Unmapped address 0x94a testing: Read Reset + Random data Write/Read
    #Address 0x94a read value
    csrr x14, 0x94a

    #Address 0x94a Write value 0x47f5b90f
    li x3, 0x47f5b90f
    csrw 0x94a, x3

    #Address 0x94a read value
    csrr x14, 0x94a

    #Unmapped address 0x8bc testing: Read Reset + Random data Write/Read
    #Address 0x8bc read value
    csrr x14, 0x8bc

    #Address 0x8bc Write value 0x4ba4a23
    li x3, 0x4ba4a23
    csrw 0x8bc, x3

    #Address 0x8bc read value
    csrr x14, 0x8bc

    #Unmapped address 0x638 testing: Read Reset + Random data Write/Read
    #Address 0x638 read value
    csrr x14, 0x638

    #Address 0x638 Write value 0xa1be3a63
    li x3, 0xa1be3a63
    csrw 0x638, x3

    #Address 0x638 read value
    csrr x14, 0x638

    #Unmapped address 0xa1f testing: Read Reset + Random data Write/Read
    #Address 0xa1f read value
    csrr x14, 0xa1f

    #Address 0xa1f Write value 0x604faa83
    li x3, 0x604faa83
    csrw 0xa1f, x3

    #Address 0xa1f read value
    csrr x14, 0xa1f

    #Unmapped address 0xc17 testing: Read Reset + Random data Write/Read
    #Address 0xc17 read value
    csrr x14, 0xc17

    #Address 0xc17 Write value 0x461940e8
    li x3, 0x461940e8
    csrw 0xc17, x3

    #Address 0xc17 read value
    csrr x14, 0xc17

    #Unmapped address 0x726 testing: Read Reset + Random data Write/Read
    #Address 0x726 read value
    csrr x14, 0x726

    #Address 0x726 Write value 0x87cb5b77
    li x3, 0x87cb5b77
    csrw 0x726, x3

    #Address 0x726 read value
    csrr x14, 0x726

    #Unmapped address 0x41 testing: Read Reset + Random data Write/Read
    #Address 0x41 read value
    csrr x14, 0x41

    #Address 0x41 Write value 0x5329da0d
    li x3, 0x5329da0d
    csrw 0x41, x3

    #Address 0x41 read value
    csrr x14, 0x41

    #Unmapped address 0xcc3 testing: Read Reset + Random data Write/Read
    #Address 0xcc3 read value
    csrr x14, 0xcc3

    #Address 0xcc3 Write value 0x640b7f04
    li x3, 0x640b7f04
    csrw 0xcc3, x3

    #Address 0xcc3 read value
    csrr x14, 0xcc3

    #Unmapped address 0xc24 testing: Read Reset + Random data Write/Read
    #Address 0xc24 read value
    csrr x14, 0xc24

    #Address 0xc24 Write value 0x1a288b7c
    li x3, 0x1a288b7c
    csrw 0xc24, x3

    #Address 0xc24 read value
    csrr x14, 0xc24

    #Unmapped address 0xc47 testing: Read Reset + Random data Write/Read
    #Address 0xc47 read value
    csrr x14, 0xc47

    #Address 0xc47 Write value 0xc66a4ec1
    li x3, 0xc66a4ec1
    csrw 0xc47, x3

    #Address 0xc47 read value
    csrr x14, 0xc47

    #Unmapped address 0x4bb testing: Read Reset + Random data Write/Read
    #Address 0x4bb read value
    csrr x14, 0x4bb

    #Address 0x4bb Write value 0x5535581a
    li x3, 0x5535581a
    csrw 0x4bb, x3

    #Address 0x4bb read value
    csrr x14, 0x4bb

    #Unmapped address 0xd5b testing: Read Reset + Random data Write/Read
    #Address 0xd5b read value
    csrr x14, 0xd5b

    #Address 0xd5b Write value 0x3f6ae36b
    li x3, 0x3f6ae36b
    csrw 0xd5b, x3

    #Address 0xd5b read value
    csrr x14, 0xd5b

    #Unmapped address 0x66 testing: Read Reset + Random data Write/Read
    #Address 0x66 read value
    csrr x14, 0x66

    #Address 0x66 Write value 0x2bb97a4
    li x3, 0x2bb97a4
    csrw 0x66, x3

    #Address 0x66 read value
    csrr x14, 0x66

    #Unmapped address 0xb3 testing: Read Reset + Random data Write/Read
    #Address 0xb3 read value
    csrr x14, 0xb3

    #Address 0xb3 Write value 0x514ae836
    li x3, 0x514ae836
    csrw 0xb3, x3

    #Address 0xb3 read value
    csrr x14, 0xb3

    #Unmapped address 0x4d8 testing: Read Reset + Random data Write/Read
    #Address 0x4d8 read value
    csrr x14, 0x4d8

    #Address 0x4d8 Write value 0xd0cd62ab
    li x3, 0xd0cd62ab
    csrw 0x4d8, x3

    #Address 0x4d8 read value
    csrr x14, 0x4d8

    #Unmapped address 0xf5c testing: Read Reset + Random data Write/Read
    #Address 0xf5c read value
    csrr x14, 0xf5c

    #Address 0xf5c Write value 0xcea8ae1d
    li x3, 0xcea8ae1d
    csrw 0xf5c, x3

    #Address 0xf5c read value
    csrr x14, 0xf5c

    #Unmapped address 0x77 testing: Read Reset + Random data Write/Read
    #Address 0x77 read value
    csrr x14, 0x77

    #Address 0x77 Write value 0xda0375bc
    li x3, 0xda0375bc
    csrw 0x77, x3

    #Address 0x77 read value
    csrr x14, 0x77

    #Unmapped address 0x97b testing: Read Reset + Random data Write/Read
    #Address 0x97b read value
    csrr x14, 0x97b

    #Address 0x97b Write value 0xe4128923
    li x3, 0xe4128923
    csrw 0x97b, x3

    #Address 0x97b read value
    csrr x14, 0x97b

    #Unmapped address 0x1db testing: Read Reset + Random data Write/Read
    #Address 0x1db read value
    csrr x14, 0x1db

    #Address 0x1db Write value 0xab201935
    li x3, 0xab201935
    csrw 0x1db, x3

    #Address 0x1db read value
    csrr x14, 0x1db

    #Unmapped address 0xfec testing: Read Reset + Random data Write/Read
    #Address 0xfec read value
    csrr x14, 0xfec

    #Address 0xfec Write value 0xa5f0ecf4
    li x3, 0xa5f0ecf4
    csrw 0xfec, x3

    #Address 0xfec read value
    csrr x14, 0xfec

    #Unmapped address 0x723 testing: Read Reset + Random data Write/Read
    #Address 0x723 read value
    csrr x14, 0x723

    #Address 0x723 Write value 0xccd8109d
    li x3, 0xccd8109d
    csrw 0x723, x3

    #Address 0x723 read value
    csrr x14, 0x723

    #Unmapped address 0xcc testing: Read Reset + Random data Write/Read
    #Address 0xcc read value
    csrr x14, 0xcc

    #Address 0xcc Write value 0xf38866f7
    li x3, 0xf38866f7
    csrw 0xcc, x3

    #Address 0xcc read value
    csrr x14, 0xcc

    #Unmapped address 0x5e6 testing: Read Reset + Random data Write/Read
    #Address 0x5e6 read value
    csrr x14, 0x5e6

    #Address 0x5e6 Write value 0xfc0d4393
    li x3, 0xfc0d4393
    csrw 0x5e6, x3

    #Address 0x5e6 read value
    csrr x14, 0x5e6

    #Unmapped address 0xe39 testing: Read Reset + Random data Write/Read
    #Address 0xe39 read value
    csrr x14, 0xe39

    #Address 0xe39 Write value 0x6662f961
    li x3, 0x6662f961
    csrw 0xe39, x3

    #Address 0xe39 read value
    csrr x14, 0xe39

    #Unmapped address 0x14f testing: Read Reset + Random data Write/Read
    #Address 0x14f read value
    csrr x14, 0x14f

    #Address 0x14f Write value 0x675cb8a9
    li x3, 0x675cb8a9
    csrw 0x14f, x3

    #Address 0x14f read value
    csrr x14, 0x14f

    #Unmapped address 0x8af testing: Read Reset + Random data Write/Read
    #Address 0x8af read value
    csrr x14, 0x8af

    #Address 0x8af Write value 0xa940c75d
    li x3, 0xa940c75d
    csrw 0x8af, x3

    #Address 0x8af read value
    csrr x14, 0x8af

    #Unmapped address 0x47d testing: Read Reset + Random data Write/Read
    #Address 0x47d read value
    csrr x14, 0x47d

    #Address 0x47d Write value 0x90838527
    li x3, 0x90838527
    csrw 0x47d, x3

    #Address 0x47d read value
    csrr x14, 0x47d

    #Unmapped address 0xecd testing: Read Reset + Random data Write/Read
    #Address 0xecd read value
    csrr x14, 0xecd

    #Address 0xecd Write value 0xaeb1bbf5
    li x3, 0xaeb1bbf5
    csrw 0xecd, x3

    #Address 0xecd read value
    csrr x14, 0xecd

    #Unmapped address 0xcfb testing: Read Reset + Random data Write/Read
    #Address 0xcfb read value
    csrr x14, 0xcfb

    #Address 0xcfb Write value 0xc631418b
    li x3, 0xc631418b
    csrw 0xcfb, x3

    #Address 0xcfb read value
    csrr x14, 0xcfb

    #Unmapped address 0x137 testing: Read Reset + Random data Write/Read
    #Address 0x137 read value
    csrr x14, 0x137

    #Address 0x137 Write value 0xa1dc2e6d
    li x3, 0xa1dc2e6d
    csrw 0x137, x3

    #Address 0x137 read value
    csrr x14, 0x137

    #Unmapped address 0xb5a testing: Read Reset + Random data Write/Read
    #Address 0xb5a read value
    csrr x14, 0xb5a

    #Address 0xb5a Write value 0x176f0443
    li x3, 0x176f0443
    csrw 0xb5a, x3

    #Address 0xb5a read value
    csrr x14, 0xb5a

    #Unmapped address 0xa1e testing: Read Reset + Random data Write/Read
    #Address 0xa1e read value
    csrr x14, 0xa1e

    #Address 0xa1e Write value 0xaa2120d7
    li x3, 0xaa2120d7
    csrw 0xa1e, x3

    #Address 0xa1e read value
    csrr x14, 0xa1e

    #Unmapped address 0xab6 testing: Read Reset + Random data Write/Read
    #Address 0xab6 read value
    csrr x14, 0xab6

    #Address 0xab6 Write value 0x457e82a9
    li x3, 0x457e82a9
    csrw 0xab6, x3

    #Address 0xab6 read value
    csrr x14, 0xab6

    #Unmapped address 0x383 testing: Read Reset + Random data Write/Read
    #Address 0x383 read value
    csrr x14, 0x383

    #Address 0x383 Write value 0xd0daf1a8
    li x3, 0xd0daf1a8
    csrw 0x383, x3

    #Address 0x383 read value
    csrr x14, 0x383

    #Unmapped address 0xc5e testing: Read Reset + Random data Write/Read
    #Address 0xc5e read value
    csrr x14, 0xc5e

    #Address 0xc5e Write value 0x2dfa7ce7
    li x3, 0x2dfa7ce7
    csrw 0xc5e, x3

    #Address 0xc5e read value
    csrr x14, 0xc5e

    #Unmapped address 0x74b testing: Read Reset + Random data Write/Read
    #Address 0x74b read value
    csrr x14, 0x74b

    #Address 0x74b Write value 0xe40d89c0
    li x3, 0xe40d89c0
    csrw 0x74b, x3

    #Address 0x74b read value
    csrr x14, 0x74b

    #Unmapped address 0x6a7 testing: Read Reset + Random data Write/Read
    #Address 0x6a7 read value
    csrr x14, 0x6a7

    #Address 0x6a7 Write value 0x5143be0f
    li x3, 0x5143be0f
    csrw 0x6a7, x3

    #Address 0x6a7 read value
    csrr x14, 0x6a7

    #Unmapped address 0x56b testing: Read Reset + Random data Write/Read
    #Address 0x56b read value
    csrr x14, 0x56b

    #Address 0x56b Write value 0x4db80b79
    li x3, 0x4db80b79
    csrw 0x56b, x3

    #Address 0x56b read value
    csrr x14, 0x56b

    #Unmapped address 0xa0b testing: Read Reset + Random data Write/Read
    #Address 0xa0b read value
    csrr x14, 0xa0b

    #Address 0xa0b Write value 0x5dce4af7
    li x3, 0x5dce4af7
    csrw 0xa0b, x3

    #Address 0xa0b read value
    csrr x14, 0xa0b

    #Unmapped address 0x65e testing: Read Reset + Random data Write/Read
    #Address 0x65e read value
    csrr x14, 0x65e

    #Address 0x65e Write value 0x9d5d79e0
    li x3, 0x9d5d79e0
    csrw 0x65e, x3

    #Address 0x65e read value
    csrr x14, 0x65e

    #Unmapped address 0xbe0 testing: Read Reset + Random data Write/Read
    #Address 0xbe0 read value
    csrr x14, 0xbe0

    #Address 0xbe0 Write value 0x98a5d534
    li x3, 0x98a5d534
    csrw 0xbe0, x3

    #Address 0xbe0 read value
    csrr x14, 0xbe0

    #Unmapped address 0xa08 testing: Read Reset + Random data Write/Read
    #Address 0xa08 read value
    csrr x14, 0xa08

    #Address 0xa08 Write value 0xeac43ef6
    li x3, 0xeac43ef6
    csrw 0xa08, x3

    #Address 0xa08 read value
    csrr x14, 0xa08

    #Unmapped address 0x277 testing: Read Reset + Random data Write/Read
    #Address 0x277 read value
    csrr x14, 0x277

    #Address 0x277 Write value 0xb34246c
    li x3, 0xb34246c
    csrw 0x277, x3

    #Address 0x277 read value
    csrr x14, 0x277

    #Unmapped address 0x8b8 testing: Read Reset + Random data Write/Read
    #Address 0x8b8 read value
    csrr x14, 0x8b8

    #Address 0x8b8 Write value 0x9145099f
    li x3, 0x9145099f
    csrw 0x8b8, x3

    #Address 0x8b8 read value
    csrr x14, 0x8b8

    #Unmapped address 0xf23 testing: Read Reset + Random data Write/Read
    #Address 0xf23 read value
    csrr x14, 0xf23

    #Address 0xf23 Write value 0x52d0bb86
    li x3, 0x52d0bb86
    csrw 0xf23, x3

    #Address 0xf23 read value
    csrr x14, 0xf23

    #Unmapped address 0x542 testing: Read Reset + Random data Write/Read
    #Address 0x542 read value
    csrr x14, 0x542

    #Address 0x542 Write value 0xedf85879
    li x3, 0xedf85879
    csrw 0x542, x3

    #Address 0x542 read value
    csrr x14, 0x542

    #Unmapped address 0x6a9 testing: Read Reset + Random data Write/Read
    #Address 0x6a9 read value
    csrr x14, 0x6a9

    #Address 0x6a9 Write value 0x961ed004
    li x3, 0x961ed004
    csrw 0x6a9, x3

    #Address 0x6a9 read value
    csrr x14, 0x6a9

    #Unmapped address 0x991 testing: Read Reset + Random data Write/Read
    #Address 0x991 read value
    csrr x14, 0x991

    #Address 0x991 Write value 0xc9ed1dfb
    li x3, 0xc9ed1dfb
    csrw 0x991, x3

    #Address 0x991 read value
    csrr x14, 0x991

    #Unmapped address 0xa13 testing: Read Reset + Random data Write/Read
    #Address 0xa13 read value
    csrr x14, 0xa13

    #Address 0xa13 Write value 0x4cb45a03
    li x3, 0x4cb45a03
    csrw 0xa13, x3

    #Address 0xa13 read value
    csrr x14, 0xa13

    #Unmapped address 0x670 testing: Read Reset + Random data Write/Read
    #Address 0x670 read value
    csrr x14, 0x670

    #Address 0x670 Write value 0x3f97aa74
    li x3, 0x3f97aa74
    csrw 0x670, x3

    #Address 0x670 read value
    csrr x14, 0x670

    #Unmapped address 0xd32 testing: Read Reset + Random data Write/Read
    #Address 0xd32 read value
    csrr x14, 0xd32

    #Address 0xd32 Write value 0x4bc7368f
    li x3, 0x4bc7368f
    csrw 0xd32, x3

    #Address 0xd32 read value
    csrr x14, 0xd32

    #Unmapped address 0x74c testing: Read Reset + Random data Write/Read
    #Address 0x74c read value
    csrr x14, 0x74c

    #Address 0x74c Write value 0x548fe9f0
    li x3, 0x548fe9f0
    csrw 0x74c, x3

    #Address 0x74c read value
    csrr x14, 0x74c

    #Unmapped address 0x7b0 testing: Read Reset + Random data Write/Read
    #Address 0x7b0 read value
    csrr x14, 0x7b0

    #Address 0x7b0 Write value 0x34997200
    li x3, 0x34997200
    csrw 0x7b0, x3

    #Address 0x7b0 read value
    csrr x14, 0x7b0

    #Unmapped address 0x2c3 testing: Read Reset + Random data Write/Read
    #Address 0x2c3 read value
    csrr x14, 0x2c3

    #Address 0x2c3 Write value 0x8fe533f9
    li x3, 0x8fe533f9
    csrw 0x2c3, x3

    #Address 0x2c3 read value
    csrr x14, 0x2c3

    #Unmapped address 0xdbe testing: Read Reset + Random data Write/Read
    #Address 0xdbe read value
    csrr x14, 0xdbe

    #Address 0xdbe Write value 0x2d23603d
    li x3, 0x2d23603d
    csrw 0xdbe, x3

    #Address 0xdbe read value
    csrr x14, 0xdbe

    #Unmapped address 0x2f4 testing: Read Reset + Random data Write/Read
    #Address 0x2f4 read value
    csrr x14, 0x2f4

    #Address 0x2f4 Write value 0xba80e5f0
    li x3, 0xba80e5f0
    csrw 0x2f4, x3

    #Address 0x2f4 read value
    csrr x14, 0x2f4

    #Unmapped address 0x646 testing: Read Reset + Random data Write/Read
    #Address 0x646 read value
    csrr x14, 0x646

    #Address 0x646 Write value 0xcaec1d1a
    li x3, 0xcaec1d1a
    csrw 0x646, x3

    #Address 0x646 read value
    csrr x14, 0x646

    #Unmapped address 0xa3b testing: Read Reset + Random data Write/Read
    #Address 0xa3b read value
    csrr x14, 0xa3b

    #Address 0xa3b Write value 0x41ed0fd0
    li x3, 0x41ed0fd0
    csrw 0xa3b, x3

    #Address 0xa3b read value
    csrr x14, 0xa3b

    #Unmapped address 0x1fc testing: Read Reset + Random data Write/Read
    #Address 0x1fc read value
    csrr x14, 0x1fc

    #Address 0x1fc Write value 0xf2c5b20e
    li x3, 0xf2c5b20e
    csrw 0x1fc, x3

    #Address 0x1fc read value
    csrr x14, 0x1fc

    #Unmapped address 0x916 testing: Read Reset + Random data Write/Read
    #Address 0x916 read value
    csrr x14, 0x916

    #Address 0x916 Write value 0xa1ceedd0
    li x3, 0xa1ceedd0
    csrw 0x916, x3

    #Address 0x916 read value
    csrr x14, 0x916

    #Unmapped address 0x2a2 testing: Read Reset + Random data Write/Read
    #Address 0x2a2 read value
    csrr x14, 0x2a2

    #Address 0x2a2 Write value 0xd87f6418
    li x3, 0xd87f6418
    csrw 0x2a2, x3

    #Address 0x2a2 read value
    csrr x14, 0x2a2

    #Unmapped address 0x77f testing: Read Reset + Random data Write/Read
    #Address 0x77f read value
    csrr x14, 0x77f

    #Address 0x77f Write value 0xe8c3cc3
    li x3, 0xe8c3cc3
    csrw 0x77f, x3

    #Address 0x77f read value
    csrr x14, 0x77f

    #Unmapped address 0xcfe testing: Read Reset + Random data Write/Read
    #Address 0xcfe read value
    csrr x14, 0xcfe

    #Address 0xcfe Write value 0xdb175bcb
    li x3, 0xdb175bcb
    csrw 0xcfe, x3

    #Address 0xcfe read value
    csrr x14, 0xcfe

    #Unmapped address 0x2f7 testing: Read Reset + Random data Write/Read
    #Address 0x2f7 read value
    csrr x14, 0x2f7

    #Address 0x2f7 Write value 0x944c6d4b
    li x3, 0x944c6d4b
    csrw 0x2f7, x3

    #Address 0x2f7 read value
    csrr x14, 0x2f7

    #Unmapped address 0xb69 testing: Read Reset + Random data Write/Read
    #Address 0xb69 read value
    csrr x14, 0xb69

    #Address 0xb69 Write value 0xd8982229
    li x3, 0xd8982229
    csrw 0xb69, x3

    #Address 0xb69 read value
    csrr x14, 0xb69

    #Unmapped address 0x420 testing: Read Reset + Random data Write/Read
    #Address 0x420 read value
    csrr x14, 0x420

    #Address 0x420 Write value 0xfa4a52ed
    li x3, 0xfa4a52ed
    csrw 0x420, x3

    #Address 0x420 read value
    csrr x14, 0x420

    #Unmapped address 0x41a testing: Read Reset + Random data Write/Read
    #Address 0x41a read value
    csrr x14, 0x41a

    #Address 0x41a Write value 0xf04d7fe4
    li x3, 0xf04d7fe4
    csrw 0x41a, x3

    #Address 0x41a read value
    csrr x14, 0x41a

    #Unmapped address 0x2ea testing: Read Reset + Random data Write/Read
    #Address 0x2ea read value
    csrr x14, 0x2ea

    #Address 0x2ea Write value 0xeb4dd3db
    li x3, 0xeb4dd3db
    csrw 0x2ea, x3

    #Address 0x2ea read value
    csrr x14, 0x2ea

    #Unmapped address 0xba0 testing: Read Reset + Random data Write/Read
    #Address 0xba0 read value
    csrr x14, 0xba0

    #Address 0xba0 Write value 0x33a3ee73
    li x3, 0x33a3ee73
    csrw 0xba0, x3

    #Address 0xba0 read value
    csrr x14, 0xba0

    #Unmapped address 0xbee testing: Read Reset + Random data Write/Read
    #Address 0xbee read value
    csrr x14, 0xbee

    #Address 0xbee Write value 0x66434c69
    li x3, 0x66434c69
    csrw 0xbee, x3

    #Address 0xbee read value
    csrr x14, 0xbee

    #Unmapped address 0x8a7 testing: Read Reset + Random data Write/Read
    #Address 0x8a7 read value
    csrr x14, 0x8a7

    #Address 0x8a7 Write value 0x98c68517
    li x3, 0x98c68517
    csrw 0x8a7, x3

    #Address 0x8a7 read value
    csrr x14, 0x8a7

    #Unmapped address 0x6bd testing: Read Reset + Random data Write/Read
    #Address 0x6bd read value
    csrr x14, 0x6bd

    #Address 0x6bd Write value 0x7a32ffc5
    li x3, 0x7a32ffc5
    csrw 0x6bd, x3

    #Address 0x6bd read value
    csrr x14, 0x6bd

    #Unmapped address 0x641 testing: Read Reset + Random data Write/Read
    #Address 0x641 read value
    csrr x14, 0x641

    #Address 0x641 Write value 0x16cc41c2
    li x3, 0x16cc41c2
    csrw 0x641, x3

    #Address 0x641 read value
    csrr x14, 0x641

    #Unmapped address 0xf7a testing: Read Reset + Random data Write/Read
    #Address 0xf7a read value
    csrr x14, 0xf7a

    #Address 0xf7a Write value 0xaa1dcdc
    li x3, 0xaa1dcdc
    csrw 0xf7a, x3

    #Address 0xf7a read value
    csrr x14, 0xf7a

    #Unmapped address 0x6d7 testing: Read Reset + Random data Write/Read
    #Address 0x6d7 read value
    csrr x14, 0x6d7

    #Address 0x6d7 Write value 0x2444289b
    li x3, 0x2444289b
    csrw 0x6d7, x3

    #Address 0x6d7 read value
    csrr x14, 0x6d7

    #Unmapped address 0x901 testing: Read Reset + Random data Write/Read
    #Address 0x901 read value
    csrr x14, 0x901

    #Address 0x901 Write value 0xccff5b6a
    li x3, 0xccff5b6a
    csrw 0x901, x3

    #Address 0x901 read value
    csrr x14, 0x901

    #Unmapped address 0x539 testing: Read Reset + Random data Write/Read
    #Address 0x539 read value
    csrr x14, 0x539

    #Address 0x539 Write value 0x2b4cf352
    li x3, 0x2b4cf352
    csrw 0x539, x3

    #Address 0x539 read value
    csrr x14, 0x539

    #Unmapped address 0x360 testing: Read Reset + Random data Write/Read
    #Address 0x360 read value
    csrr x14, 0x360

    #Address 0x360 Write value 0x4aae9c7a
    li x3, 0x4aae9c7a
    csrw 0x360, x3

    #Address 0x360 read value
    csrr x14, 0x360

    #Unmapped address 0x2df testing: Read Reset + Random data Write/Read
    #Address 0x2df read value
    csrr x14, 0x2df

    #Address 0x2df Write value 0xfd1b8dfc
    li x3, 0xfd1b8dfc
    csrw 0x2df, x3

    #Address 0x2df read value
    csrr x14, 0x2df

    #Unmapped address 0xa82 testing: Read Reset + Random data Write/Read
    #Address 0xa82 read value
    csrr x14, 0xa82

    #Address 0xa82 Write value 0x7f9ef58
    li x3, 0x7f9ef58
    csrw 0xa82, x3

    #Address 0xa82 read value
    csrr x14, 0xa82

    #Unmapped address 0x5c3 testing: Read Reset + Random data Write/Read
    #Address 0x5c3 read value
    csrr x14, 0x5c3

    #Address 0x5c3 Write value 0xfbbb6ba6
    li x3, 0xfbbb6ba6
    csrw 0x5c3, x3

    #Address 0x5c3 read value
    csrr x14, 0x5c3

    #Unmapped address 0x59f testing: Read Reset + Random data Write/Read
    #Address 0x59f read value
    csrr x14, 0x59f

    #Address 0x59f Write value 0x92f1c761
    li x3, 0x92f1c761
    csrw 0x59f, x3

    #Address 0x59f read value
    csrr x14, 0x59f

    #Unmapped address 0xbfa testing: Read Reset + Random data Write/Read
    #Address 0xbfa read value
    csrr x14, 0xbfa

    #Address 0xbfa Write value 0xca9244d8
    li x3, 0xca9244d8
    csrw 0xbfa, x3

    #Address 0xbfa read value
    csrr x14, 0xbfa

    #Unmapped address 0x1f7 testing: Read Reset + Random data Write/Read
    #Address 0x1f7 read value
    csrr x14, 0x1f7

    #Address 0x1f7 Write value 0x28e89cbb
    li x3, 0x28e89cbb
    csrw 0x1f7, x3

    #Address 0x1f7 read value
    csrr x14, 0x1f7

    #Unmapped address 0xffb testing: Read Reset + Random data Write/Read
    #Address 0xffb read value
    csrr x14, 0xffb

    #Address 0xffb Write value 0x6954edfe
    li x3, 0x6954edfe
    csrw 0xffb, x3

    #Address 0xffb read value
    csrr x14, 0xffb

    #Unmapped address 0xaf3 testing: Read Reset + Random data Write/Read
    #Address 0xaf3 read value
    csrr x14, 0xaf3

    #Address 0xaf3 Write value 0x3f05e1f1
    li x3, 0x3f05e1f1
    csrw 0xaf3, x3

    #Address 0xaf3 read value
    csrr x14, 0xaf3

    #Unmapped address 0xd3a testing: Read Reset + Random data Write/Read
    #Address 0xd3a read value
    csrr x14, 0xd3a

    #Address 0xd3a Write value 0x6d68048d
    li x3, 0x6d68048d
    csrw 0xd3a, x3

    #Address 0xd3a read value
    csrr x14, 0xd3a

    #Unmapped address 0x8c2 testing: Read Reset + Random data Write/Read
    #Address 0x8c2 read value
    csrr x14, 0x8c2

    #Address 0x8c2 Write value 0xe3f29c50
    li x3, 0xe3f29c50
    csrw 0x8c2, x3

    #Address 0x8c2 read value
    csrr x14, 0x8c2

    #Unmapped address 0xc3b testing: Read Reset + Random data Write/Read
    #Address 0xc3b read value
    csrr x14, 0xc3b

    #Address 0xc3b Write value 0x9ff7aad
    li x3, 0x9ff7aad
    csrw 0xc3b, x3

    #Address 0xc3b read value
    csrr x14, 0xc3b

    #Unmapped address 0x5ea testing: Read Reset + Random data Write/Read
    #Address 0x5ea read value
    csrr x14, 0x5ea

    #Address 0x5ea Write value 0x50d58bb7
    li x3, 0x50d58bb7
    csrw 0x5ea, x3

    #Address 0x5ea read value
    csrr x14, 0x5ea

    #Unmapped address 0x43f testing: Read Reset + Random data Write/Read
    #Address 0x43f read value
    csrr x14, 0x43f

    #Address 0x43f Write value 0xf47e3f66
    li x3, 0xf47e3f66
    csrw 0x43f, x3

    #Address 0x43f read value
    csrr x14, 0x43f

    #Unmapped address 0x71 testing: Read Reset + Random data Write/Read
    #Address 0x71 read value
    csrr x14, 0x71

    #Address 0x71 Write value 0xa842d16e
    li x3, 0xa842d16e
    csrw 0x71, x3

    #Address 0x71 read value
    csrr x14, 0x71

    #Unmapped address 0x3b testing: Read Reset + Random data Write/Read
    #Address 0x3b read value
    csrr x14, 0x3b

    #Address 0x3b Write value 0x3aca7ff6
    li x3, 0x3aca7ff6
    csrw 0x3b, x3

    #Address 0x3b read value
    csrr x14, 0x3b

    #Unmapped address 0x394 testing: Read Reset + Random data Write/Read
    #Address 0x394 read value
    csrr x14, 0x394

    #Address 0x394 Write value 0xe28fde56
    li x3, 0xe28fde56
    csrw 0x394, x3

    #Address 0x394 read value
    csrr x14, 0x394

    #Unmapped address 0xb4b testing: Read Reset + Random data Write/Read
    #Address 0xb4b read value
    csrr x14, 0xb4b

    #Address 0xb4b Write value 0xa111a654
    li x3, 0xa111a654
    csrw 0xb4b, x3

    #Address 0xb4b read value
    csrr x14, 0xb4b

    #Unmapped address 0x66e testing: Read Reset + Random data Write/Read
    #Address 0x66e read value
    csrr x14, 0x66e

    #Address 0x66e Write value 0x89639802
    li x3, 0x89639802
    csrw 0x66e, x3

    #Address 0x66e read value
    csrr x14, 0x66e

    #Unmapped address 0xd74 testing: Read Reset + Random data Write/Read
    #Address 0xd74 read value
    csrr x14, 0xd74

    #Address 0xd74 Write value 0x95a2502
    li x3, 0x95a2502
    csrw 0xd74, x3

    #Address 0xd74 read value
    csrr x14, 0xd74

    #Unmapped address 0x64e testing: Read Reset + Random data Write/Read
    #Address 0x64e read value
    csrr x14, 0x64e

    #Address 0x64e Write value 0x28503eeb
    li x3, 0x28503eeb
    csrw 0x64e, x3

    #Address 0x64e read value
    csrr x14, 0x64e

    #Unmapped address 0x5d5 testing: Read Reset + Random data Write/Read
    #Address 0x5d5 read value
    csrr x14, 0x5d5

    #Address 0x5d5 Write value 0xe198c8b1
    li x3, 0xe198c8b1
    csrw 0x5d5, x3

    #Address 0x5d5 read value
    csrr x14, 0x5d5

    #Unmapped address 0x6df testing: Read Reset + Random data Write/Read
    #Address 0x6df read value
    csrr x14, 0x6df

    #Address 0x6df Write value 0x286bb35
    li x3, 0x286bb35
    csrw 0x6df, x3

    #Address 0x6df read value
    csrr x14, 0x6df

    #Unmapped address 0x26a testing: Read Reset + Random data Write/Read
    #Address 0x26a read value
    csrr x14, 0x26a

    #Address 0x26a Write value 0xf8157216
    li x3, 0xf8157216
    csrw 0x26a, x3

    #Address 0x26a read value
    csrr x14, 0x26a

    #Unmapped address 0x1b3 testing: Read Reset + Random data Write/Read
    #Address 0x1b3 read value
    csrr x14, 0x1b3

    #Address 0x1b3 Write value 0xe3be0ea6
    li x3, 0xe3be0ea6
    csrw 0x1b3, x3

    #Address 0x1b3 read value
    csrr x14, 0x1b3

    #Unmapped address 0x5f3 testing: Read Reset + Random data Write/Read
    #Address 0x5f3 read value
    csrr x14, 0x5f3

    #Address 0x5f3 Write value 0x8e83de41
    li x3, 0x8e83de41
    csrw 0x5f3, x3

    #Address 0x5f3 read value
    csrr x14, 0x5f3

    #Unmapped address 0xdd5 testing: Read Reset + Random data Write/Read
    #Address 0xdd5 read value
    csrr x14, 0xdd5

    #Address 0xdd5 Write value 0x9e1cdbfc
    li x3, 0x9e1cdbfc
    csrw 0xdd5, x3

    #Address 0xdd5 read value
    csrr x14, 0xdd5

    #Unmapped address 0xd9c testing: Read Reset + Random data Write/Read
    #Address 0xd9c read value
    csrr x14, 0xd9c

    #Address 0xd9c Write value 0x2bbe8a19
    li x3, 0x2bbe8a19
    csrw 0xd9c, x3

    #Address 0xd9c read value
    csrr x14, 0xd9c

    #Unmapped address 0xcef testing: Read Reset + Random data Write/Read
    #Address 0xcef read value
    csrr x14, 0xcef

    #Address 0xcef Write value 0x16b7b669
    li x3, 0x16b7b669
    csrw 0xcef, x3

    #Address 0xcef read value
    csrr x14, 0xcef

    #Unmapped address 0x210 testing: Read Reset + Random data Write/Read
    #Address 0x210 read value
    csrr x14, 0x210

    #Address 0x210 Write value 0xe2e9b56d
    li x3, 0xe2e9b56d
    csrw 0x210, x3

    #Address 0x210 read value
    csrr x14, 0x210

    #Unmapped address 0x316 testing: Read Reset + Random data Write/Read
    #Address 0x316 read value
    csrr x14, 0x316

    #Address 0x316 Write value 0x8673469a
    li x3, 0x8673469a
    csrw 0x316, x3

    #Address 0x316 read value
    csrr x14, 0x316

    #Unmapped address 0x87d testing: Read Reset + Random data Write/Read
    #Address 0x87d read value
    csrr x14, 0x87d

    #Address 0x87d Write value 0x6c50a3f
    li x3, 0x6c50a3f
    csrw 0x87d, x3

    #Address 0x87d read value
    csrr x14, 0x87d

    #Unmapped address 0x7b6 testing: Read Reset + Random data Write/Read
    #Address 0x7b6 read value
    csrr x14, 0x7b6

    #Address 0x7b6 Write value 0xa075bf84
    li x3, 0xa075bf84
    csrw 0x7b6, x3

    #Address 0x7b6 read value
    csrr x14, 0x7b6

    #Unmapped address 0x979 testing: Read Reset + Random data Write/Read
    #Address 0x979 read value
    csrr x14, 0x979

    #Address 0x979 Write value 0x811de39e
    li x3, 0x811de39e
    csrw 0x979, x3

    #Address 0x979 read value
    csrr x14, 0x979

    #Unmapped address 0x80c testing: Read Reset + Random data Write/Read
    #Address 0x80c read value
    csrr x14, 0x80c

    #Address 0x80c Write value 0xce8ea87c
    li x3, 0xce8ea87c
    csrw 0x80c, x3

    #Address 0x80c read value
    csrr x14, 0x80c

    #Unmapped address 0x914 testing: Read Reset + Random data Write/Read
    #Address 0x914 read value
    csrr x14, 0x914

    #Address 0x914 Write value 0x31ac240
    li x3, 0x31ac240
    csrw 0x914, x3

    #Address 0x914 read value
    csrr x14, 0x914

    #Unmapped address 0x42c testing: Read Reset + Random data Write/Read
    #Address 0x42c read value
    csrr x14, 0x42c

    #Address 0x42c Write value 0x544a3589
    li x3, 0x544a3589
    csrw 0x42c, x3

    #Address 0x42c read value
    csrr x14, 0x42c

    #Unmapped address 0xef7 testing: Read Reset + Random data Write/Read
    #Address 0xef7 read value
    csrr x14, 0xef7

    #Address 0xef7 Write value 0x4d9629cc
    li x3, 0x4d9629cc
    csrw 0xef7, x3

    #Address 0xef7 read value
    csrr x14, 0xef7

    #Unmapped address 0x586 testing: Read Reset + Random data Write/Read
    #Address 0x586 read value
    csrr x14, 0x586

    #Address 0x586 Write value 0x9cb29e84
    li x3, 0x9cb29e84
    csrw 0x586, x3

    #Address 0x586 read value
    csrr x14, 0x586

    #Unmapped address 0x4e9 testing: Read Reset + Random data Write/Read
    #Address 0x4e9 read value
    csrr x14, 0x4e9

    #Address 0x4e9 Write value 0x9b7d9a54
    li x3, 0x9b7d9a54
    csrw 0x4e9, x3

    #Address 0x4e9 read value
    csrr x14, 0x4e9

    #Unmapped address 0x89b testing: Read Reset + Random data Write/Read
    #Address 0x89b read value
    csrr x14, 0x89b

    #Address 0x89b Write value 0xcbe2efff
    li x3, 0xcbe2efff
    csrw 0x89b, x3

    #Address 0x89b read value
    csrr x14, 0x89b

    #Unmapped address 0x8d6 testing: Read Reset + Random data Write/Read
    #Address 0x8d6 read value
    csrr x14, 0x8d6

    #Address 0x8d6 Write value 0xf79975b0
    li x3, 0xf79975b0
    csrw 0x8d6, x3

    #Address 0x8d6 read value
    csrr x14, 0x8d6

    #Unmapped address 0x3e2 testing: Read Reset + Random data Write/Read
    #Address 0x3e2 read value
    csrr x14, 0x3e2

    #Address 0x3e2 Write value 0xf351c88f
    li x3, 0xf351c88f
    csrw 0x3e2, x3

    #Address 0x3e2 read value
    csrr x14, 0x3e2

    #Unmapped address 0x259 testing: Read Reset + Random data Write/Read
    #Address 0x259 read value
    csrr x14, 0x259

    #Address 0x259 Write value 0x23c8069f
    li x3, 0x23c8069f
    csrw 0x259, x3

    #Address 0x259 read value
    csrr x14, 0x259

    #Unmapped address 0x4d1 testing: Read Reset + Random data Write/Read
    #Address 0x4d1 read value
    csrr x14, 0x4d1

    #Address 0x4d1 Write value 0x29b61787
    li x3, 0x29b61787
    csrw 0x4d1, x3

    #Address 0x4d1 read value
    csrr x14, 0x4d1

    #Unmapped address 0xef testing: Read Reset + Random data Write/Read
    #Address 0xef read value
    csrr x14, 0xef

    #Address 0xef Write value 0xdfd0bf2c
    li x3, 0xdfd0bf2c
    csrw 0xef, x3

    #Address 0xef read value
    csrr x14, 0xef

    #Unmapped address 0x9b9 testing: Read Reset + Random data Write/Read
    #Address 0x9b9 read value
    csrr x14, 0x9b9

    #Address 0x9b9 Write value 0x3559c883
    li x3, 0x3559c883
    csrw 0x9b9, x3

    #Address 0x9b9 read value
    csrr x14, 0x9b9

    #Unmapped address 0x643 testing: Read Reset + Random data Write/Read
    #Address 0x643 read value
    csrr x14, 0x643

    #Address 0x643 Write value 0xf76249b
    li x3, 0xf76249b
    csrw 0x643, x3

    #Address 0x643 read value
    csrr x14, 0x643

    #Unmapped address 0x466 testing: Read Reset + Random data Write/Read
    #Address 0x466 read value
    csrr x14, 0x466

    #Address 0x466 Write value 0x1a1e6da9
    li x3, 0x1a1e6da9
    csrw 0x466, x3

    #Address 0x466 read value
    csrr x14, 0x466

    #Unmapped address 0x2be testing: Read Reset + Random data Write/Read
    #Address 0x2be read value
    csrr x14, 0x2be

    #Address 0x2be Write value 0xad48889e
    li x3, 0xad48889e
    csrw 0x2be, x3

    #Address 0x2be read value
    csrr x14, 0x2be

    #Unmapped address 0x139 testing: Read Reset + Random data Write/Read
    #Address 0x139 read value
    csrr x14, 0x139

    #Address 0x139 Write value 0xb0ffd358
    li x3, 0xb0ffd358
    csrw 0x139, x3

    #Address 0x139 read value
    csrr x14, 0x139

    #Unmapped address 0xa3d testing: Read Reset + Random data Write/Read
    #Address 0xa3d read value
    csrr x14, 0xa3d

    #Address 0xa3d Write value 0x1f07d8b3
    li x3, 0x1f07d8b3
    csrw 0xa3d, x3

    #Address 0xa3d read value
    csrr x14, 0xa3d

    #Unmapped address 0x268 testing: Read Reset + Random data Write/Read
    #Address 0x268 read value
    csrr x14, 0x268

    #Address 0x268 Write value 0xa507121b
    li x3, 0xa507121b
    csrw 0x268, x3

    #Address 0x268 read value
    csrr x14, 0x268

    #Unmapped address 0xd29 testing: Read Reset + Random data Write/Read
    #Address 0xd29 read value
    csrr x14, 0xd29

    #Address 0xd29 Write value 0xf47f1aa
    li x3, 0xf47f1aa
    csrw 0xd29, x3

    #Address 0xd29 read value
    csrr x14, 0xd29

    #Unmapped address 0xcdf testing: Read Reset + Random data Write/Read
    #Address 0xcdf read value
    csrr x14, 0xcdf

    #Address 0xcdf Write value 0x20f67e48
    li x3, 0x20f67e48
    csrw 0xcdf, x3

    #Address 0xcdf read value
    csrr x14, 0xcdf

    #Unmapped address 0xe51 testing: Read Reset + Random data Write/Read
    #Address 0xe51 read value
    csrr x14, 0xe51

    #Address 0xe51 Write value 0x79a7181a
    li x3, 0x79a7181a
    csrw 0xe51, x3

    #Address 0xe51 read value
    csrr x14, 0xe51

    #Unmapped address 0xe75 testing: Read Reset + Random data Write/Read
    #Address 0xe75 read value
    csrr x14, 0xe75

    #Address 0xe75 Write value 0xe74419b7
    li x3, 0xe74419b7
    csrw 0xe75, x3

    #Address 0xe75 read value
    csrr x14, 0xe75

    #Unmapped address 0x80 testing: Read Reset + Random data Write/Read
    #Address 0x80 read value
    csrr x14, 0x80

    #Address 0x80 Write value 0x131ca392
    li x3, 0x131ca392
    csrw 0x80, x3

    #Address 0x80 read value
    csrr x14, 0x80

    #Unmapped address 0x71f testing: Read Reset + Random data Write/Read
    #Address 0x71f read value
    csrr x14, 0x71f

    #Address 0x71f Write value 0xa45d2a15
    li x3, 0xa45d2a15
    csrw 0x71f, x3

    #Address 0x71f read value
    csrr x14, 0x71f

    #Unmapped address 0xe9f testing: Read Reset + Random data Write/Read
    #Address 0xe9f read value
    csrr x14, 0xe9f

    #Address 0xe9f Write value 0x3a8f6965
    li x3, 0x3a8f6965
    csrw 0xe9f, x3

    #Address 0xe9f read value
    csrr x14, 0xe9f

    #Unmapped address 0x868 testing: Read Reset + Random data Write/Read
    #Address 0x868 read value
    csrr x14, 0x868

    #Address 0x868 Write value 0xc03a32d0
    li x3, 0xc03a32d0
    csrw 0x868, x3

    #Address 0x868 read value
    csrr x14, 0x868

    #Unmapped address 0x581 testing: Read Reset + Random data Write/Read
    #Address 0x581 read value
    csrr x14, 0x581

    #Address 0x581 Write value 0x8fe93da8
    li x3, 0x8fe93da8
    csrw 0x581, x3

    #Address 0x581 read value
    csrr x14, 0x581

    #Unmapped address 0x46 testing: Read Reset + Random data Write/Read
    #Address 0x46 read value
    csrr x14, 0x46

    #Address 0x46 Write value 0xd3371ee5
    li x3, 0xd3371ee5
    csrw 0x46, x3

    #Address 0x46 read value
    csrr x14, 0x46

    #Unmapped address 0xc5d testing: Read Reset + Random data Write/Read
    #Address 0xc5d read value
    csrr x14, 0xc5d

    #Address 0xc5d Write value 0xfa0ac599
    li x3, 0xfa0ac599
    csrw 0xc5d, x3

    #Address 0xc5d read value
    csrr x14, 0xc5d

    #Unmapped address 0x925 testing: Read Reset + Random data Write/Read
    #Address 0x925 read value
    csrr x14, 0x925

    #Address 0x925 Write value 0x64257338
    li x3, 0x64257338
    csrw 0x925, x3

    #Address 0x925 read value
    csrr x14, 0x925

    #Unmapped address 0x527 testing: Read Reset + Random data Write/Read
    #Address 0x527 read value
    csrr x14, 0x527

    #Address 0x527 Write value 0xe5c52806
    li x3, 0xe5c52806
    csrw 0x527, x3

    #Address 0x527 read value
    csrr x14, 0x527

    #Unmapped address 0xee6 testing: Read Reset + Random data Write/Read
    #Address 0xee6 read value
    csrr x14, 0xee6

    #Address 0xee6 Write value 0x9bb92acb
    li x3, 0x9bb92acb
    csrw 0xee6, x3

    #Address 0xee6 read value
    csrr x14, 0xee6

    #Unmapped address 0xb2e testing: Read Reset + Random data Write/Read
    #Address 0xb2e read value
    csrr x14, 0xb2e

    #Address 0xb2e Write value 0x3ee28543
    li x3, 0x3ee28543
    csrw 0xb2e, x3

    #Address 0xb2e read value
    csrr x14, 0xb2e

    #Unmapped address 0xec1 testing: Read Reset + Random data Write/Read
    #Address 0xec1 read value
    csrr x14, 0xec1

    #Address 0xec1 Write value 0xdf6f477b
    li x3, 0xdf6f477b
    csrw 0xec1, x3

    #Address 0xec1 read value
    csrr x14, 0xec1

    #Unmapped address 0xfe4 testing: Read Reset + Random data Write/Read
    #Address 0xfe4 read value
    csrr x14, 0xfe4

    #Address 0xfe4 Write value 0xc4558d04
    li x3, 0xc4558d04
    csrw 0xfe4, x3

    #Address 0xfe4 read value
    csrr x14, 0xfe4

    #Unmapped address 0x6ef testing: Read Reset + Random data Write/Read
    #Address 0x6ef read value
    csrr x14, 0x6ef

    #Address 0x6ef Write value 0x1cb89a4a
    li x3, 0x1cb89a4a
    csrw 0x6ef, x3

    #Address 0x6ef read value
    csrr x14, 0x6ef

    #Unmapped address 0xe15 testing: Read Reset + Random data Write/Read
    #Address 0xe15 read value
    csrr x14, 0xe15

    #Address 0xe15 Write value 0x1078731
    li x3, 0x1078731
    csrw 0xe15, x3

    #Address 0xe15 read value
    csrr x14, 0xe15

    #Unmapped address 0x366 testing: Read Reset + Random data Write/Read
    #Address 0x366 read value
    csrr x14, 0x366

    #Address 0x366 Write value 0xf776f675
    li x3, 0xf776f675
    csrw 0x366, x3

    #Address 0x366 read value
    csrr x14, 0x366

    #Unmapped address 0xed4 testing: Read Reset + Random data Write/Read
    #Address 0xed4 read value
    csrr x14, 0xed4

    #Address 0xed4 Write value 0x499c8495
    li x3, 0x499c8495
    csrw 0xed4, x3

    #Address 0xed4 read value
    csrr x14, 0xed4

    #Unmapped address 0x25e testing: Read Reset + Random data Write/Read
    #Address 0x25e read value
    csrr x14, 0x25e

    #Address 0x25e Write value 0x85d83e40
    li x3, 0x85d83e40
    csrw 0x25e, x3

    #Address 0x25e read value
    csrr x14, 0x25e

    #Unmapped address 0xa63 testing: Read Reset + Random data Write/Read
    #Address 0xa63 read value
    csrr x14, 0xa63

    #Address 0xa63 Write value 0xb8b40308
    li x3, 0xb8b40308
    csrw 0xa63, x3

    #Address 0xa63 read value
    csrr x14, 0xa63

    #Unmapped address 0xf40 testing: Read Reset + Random data Write/Read
    #Address 0xf40 read value
    csrr x14, 0xf40

    #Address 0xf40 Write value 0x26ce92fb
    li x3, 0x26ce92fb
    csrw 0xf40, x3

    #Address 0xf40 read value
    csrr x14, 0xf40

    #Unmapped address 0x6bf testing: Read Reset + Random data Write/Read
    #Address 0x6bf read value
    csrr x14, 0x6bf

    #Address 0x6bf Write value 0x9b871cea
    li x3, 0x9b871cea
    csrw 0x6bf, x3

    #Address 0x6bf read value
    csrr x14, 0x6bf

    #Unmapped address 0x741 testing: Read Reset + Random data Write/Read
    #Address 0x741 read value
    csrr x14, 0x741

    #Address 0x741 Write value 0x58da3b0d
    li x3, 0x58da3b0d
    csrw 0x741, x3

    #Address 0x741 read value
    csrr x14, 0x741

    #Unmapped address 0x219 testing: Read Reset + Random data Write/Read
    #Address 0x219 read value
    csrr x14, 0x219

    #Address 0x219 Write value 0xf39a6b98
    li x3, 0xf39a6b98
    csrw 0x219, x3

    #Address 0x219 read value
    csrr x14, 0x219

    #Unmapped address 0x656 testing: Read Reset + Random data Write/Read
    #Address 0x656 read value
    csrr x14, 0x656

    #Address 0x656 Write value 0x7e6b5610
    li x3, 0x7e6b5610
    csrw 0x656, x3

    #Address 0x656 read value
    csrr x14, 0x656

    #Unmapped address 0x2ed testing: Read Reset + Random data Write/Read
    #Address 0x2ed read value
    csrr x14, 0x2ed

    #Address 0x2ed Write value 0xa76defde
    li x3, 0xa76defde
    csrw 0x2ed, x3

    #Address 0x2ed read value
    csrr x14, 0x2ed

    #Unmapped address 0xaf2 testing: Read Reset + Random data Write/Read
    #Address 0xaf2 read value
    csrr x14, 0xaf2

    #Address 0xaf2 Write value 0x92fff8b6
    li x3, 0x92fff8b6
    csrw 0xaf2, x3

    #Address 0xaf2 read value
    csrr x14, 0xaf2

    #Unmapped address 0xc27 testing: Read Reset + Random data Write/Read
    #Address 0xc27 read value
    csrr x14, 0xc27

    #Address 0xc27 Write value 0xb58ba2af
    li x3, 0xb58ba2af
    csrw 0xc27, x3

    #Address 0xc27 read value
    csrr x14, 0xc27

    #Unmapped address 0xb21 testing: Read Reset + Random data Write/Read
    #Address 0xb21 read value
    csrr x14, 0xb21

    #Address 0xb21 Write value 0xb09df3af
    li x3, 0xb09df3af
    csrw 0xb21, x3

    #Address 0xb21 read value
    csrr x14, 0xb21

    #Unmapped address 0x42a testing: Read Reset + Random data Write/Read
    #Address 0x42a read value
    csrr x14, 0x42a

    #Address 0x42a Write value 0xbeb5fb4b
    li x3, 0xbeb5fb4b
    csrw 0x42a, x3

    #Address 0x42a read value
    csrr x14, 0x42a

    #Unmapped address 0xccc testing: Read Reset + Random data Write/Read
    #Address 0xccc read value
    csrr x14, 0xccc

    #Address 0xccc Write value 0x9f575162
    li x3, 0x9f575162
    csrw 0xccc, x3

    #Address 0xccc read value
    csrr x14, 0xccc

    #Unmapped address 0x611 testing: Read Reset + Random data Write/Read
    #Address 0x611 read value
    csrr x14, 0x611

    #Address 0x611 Write value 0x3b0b4592
    li x3, 0x3b0b4592
    csrw 0x611, x3

    #Address 0x611 read value
    csrr x14, 0x611

    #Unmapped address 0x6f1 testing: Read Reset + Random data Write/Read
    #Address 0x6f1 read value
    csrr x14, 0x6f1

    #Address 0x6f1 Write value 0x7627291b
    li x3, 0x7627291b
    csrw 0x6f1, x3

    #Address 0x6f1 read value
    csrr x14, 0x6f1

    #Unmapped address 0xb60 testing: Read Reset + Random data Write/Read
    #Address 0xb60 read value
    csrr x14, 0xb60

    #Address 0xb60 Write value 0x1b960a15
    li x3, 0x1b960a15
    csrw 0xb60, x3

    #Address 0xb60 read value
    csrr x14, 0xb60

    #Unmapped address 0x1f8 testing: Read Reset + Random data Write/Read
    #Address 0x1f8 read value
    csrr x14, 0x1f8

    #Address 0x1f8 Write value 0x4a9d5bb6
    li x3, 0x4a9d5bb6
    csrw 0x1f8, x3

    #Address 0x1f8 read value
    csrr x14, 0x1f8

    #Unmapped address 0x1c5 testing: Read Reset + Random data Write/Read
    #Address 0x1c5 read value
    csrr x14, 0x1c5

    #Address 0x1c5 Write value 0x36a01b
    li x3, 0x36a01b
    csrw 0x1c5, x3

    #Address 0x1c5 read value
    csrr x14, 0x1c5

    #Unmapped address 0xd48 testing: Read Reset + Random data Write/Read
    #Address 0xd48 read value
    csrr x14, 0xd48

    #Address 0xd48 Write value 0x2d6532ee
    li x3, 0x2d6532ee
    csrw 0xd48, x3

    #Address 0xd48 read value
    csrr x14, 0xd48

    #Unmapped address 0x5c8 testing: Read Reset + Random data Write/Read
    #Address 0x5c8 read value
    csrr x14, 0x5c8

    #Address 0x5c8 Write value 0x2c3af2b2
    li x3, 0x2c3af2b2
    csrw 0x5c8, x3

    #Address 0x5c8 read value
    csrr x14, 0x5c8

    #Unmapped address 0x153 testing: Read Reset + Random data Write/Read
    #Address 0x153 read value
    csrr x14, 0x153

    #Address 0x153 Write value 0xc1422056
    li x3, 0xc1422056
    csrw 0x153, x3

    #Address 0x153 read value
    csrr x14, 0x153

    #Unmapped address 0x61e testing: Read Reset + Random data Write/Read
    #Address 0x61e read value
    csrr x14, 0x61e

    #Address 0x61e Write value 0x2b199158
    li x3, 0x2b199158
    csrw 0x61e, x3

    #Address 0x61e read value
    csrr x14, 0x61e

    #Unmapped address 0x12f testing: Read Reset + Random data Write/Read
    #Address 0x12f read value
    csrr x14, 0x12f

    #Address 0x12f Write value 0x92287dad
    li x3, 0x92287dad
    csrw 0x12f, x3

    #Address 0x12f read value
    csrr x14, 0x12f

    #Unmapped address 0xa84 testing: Read Reset + Random data Write/Read
    #Address 0xa84 read value
    csrr x14, 0xa84

    #Address 0xa84 Write value 0xceacc90e
    li x3, 0xceacc90e
    csrw 0xa84, x3

    #Address 0xa84 read value
    csrr x14, 0xa84

    #Unmapped address 0xbb1 testing: Read Reset + Random data Write/Read
    #Address 0xbb1 read value
    csrr x14, 0xbb1

    #Address 0xbb1 Write value 0x3949ea6
    li x3, 0x3949ea6
    csrw 0xbb1, x3

    #Address 0xbb1 read value
    csrr x14, 0xbb1

    #Unmapped address 0x5a2 testing: Read Reset + Random data Write/Read
    #Address 0x5a2 read value
    csrr x14, 0x5a2

    #Address 0x5a2 Write value 0x409e264b
    li x3, 0x409e264b
    csrw 0x5a2, x3

    #Address 0x5a2 read value
    csrr x14, 0x5a2

    #Unmapped address 0xcd6 testing: Read Reset + Random data Write/Read
    #Address 0xcd6 read value
    csrr x14, 0xcd6

    #Address 0xcd6 Write value 0xa7a61436
    li x3, 0xa7a61436
    csrw 0xcd6, x3

    #Address 0xcd6 read value
    csrr x14, 0xcd6

    #Unmapped address 0x884 testing: Read Reset + Random data Write/Read
    #Address 0x884 read value
    csrr x14, 0x884

    #Address 0x884 Write value 0x1761029f
    li x3, 0x1761029f
    csrw 0x884, x3

    #Address 0x884 read value
    csrr x14, 0x884

    #Unmapped address 0xd87 testing: Read Reset + Random data Write/Read
    #Address 0xd87 read value
    csrr x14, 0xd87

    #Address 0xd87 Write value 0xdfa003b5
    li x3, 0xdfa003b5
    csrw 0xd87, x3

    #Address 0xd87 read value
    csrr x14, 0xd87

    #Unmapped address 0x4c9 testing: Read Reset + Random data Write/Read
    #Address 0x4c9 read value
    csrr x14, 0x4c9

    #Address 0x4c9 Write value 0x6b3c48c7
    li x3, 0x6b3c48c7
    csrw 0x4c9, x3

    #Address 0x4c9 read value
    csrr x14, 0x4c9

    #Unmapped address 0x700 testing: Read Reset + Random data Write/Read
    #Address 0x700 read value
    csrr x14, 0x700

    #Address 0x700 Write value 0x41bcb549
    li x3, 0x41bcb549
    csrw 0x700, x3

    #Address 0x700 read value
    csrr x14, 0x700

    #Unmapped address 0xd2b testing: Read Reset + Random data Write/Read
    #Address 0xd2b read value
    csrr x14, 0xd2b

    #Address 0xd2b Write value 0x4e6b4ec6
    li x3, 0x4e6b4ec6
    csrw 0xd2b, x3

    #Address 0xd2b read value
    csrr x14, 0xd2b

    #Unmapped address 0x121 testing: Read Reset + Random data Write/Read
    #Address 0x121 read value
    csrr x14, 0x121

    #Address 0x121 Write value 0x34bdfe86
    li x3, 0x34bdfe86
    csrw 0x121, x3

    #Address 0x121 read value
    csrr x14, 0x121

    #Unmapped address 0x1b2 testing: Read Reset + Random data Write/Read
    #Address 0x1b2 read value
    csrr x14, 0x1b2

    #Address 0x1b2 Write value 0x31d8a010
    li x3, 0x31d8a010
    csrw 0x1b2, x3

    #Address 0x1b2 read value
    csrr x14, 0x1b2

    #Unmapped address 0xdd0 testing: Read Reset + Random data Write/Read
    #Address 0xdd0 read value
    csrr x14, 0xdd0

    #Address 0xdd0 Write value 0xdbdb56a7
    li x3, 0xdbdb56a7
    csrw 0xdd0, x3

    #Address 0xdd0 read value
    csrr x14, 0xdd0

    #Unmapped address 0x1a6 testing: Read Reset + Random data Write/Read
    #Address 0x1a6 read value
    csrr x14, 0x1a6

    #Address 0x1a6 Write value 0x310b3f45
    li x3, 0x310b3f45
    csrw 0x1a6, x3

    #Address 0x1a6 read value
    csrr x14, 0x1a6

    #Unmapped address 0x142 testing: Read Reset + Random data Write/Read
    #Address 0x142 read value
    csrr x14, 0x142

    #Address 0x142 Write value 0xecead6dc
    li x3, 0xecead6dc
    csrw 0x142, x3

    #Address 0x142 read value
    csrr x14, 0x142

    #Unmapped address 0xfcf testing: Read Reset + Random data Write/Read
    #Address 0xfcf read value
    csrr x14, 0xfcf

    #Address 0xfcf Write value 0xa4bf2e7f
    li x3, 0xa4bf2e7f
    csrw 0xfcf, x3

    #Address 0xfcf read value
    csrr x14, 0xfcf

    #Unmapped address 0x552 testing: Read Reset + Random data Write/Read
    #Address 0x552 read value
    csrr x14, 0x552

    #Address 0x552 Write value 0x388eb9ab
    li x3, 0x388eb9ab
    csrw 0x552, x3

    #Address 0x552 read value
    csrr x14, 0x552

    #Unmapped address 0xa38 testing: Read Reset + Random data Write/Read
    #Address 0xa38 read value
    csrr x14, 0xa38

    #Address 0xa38 Write value 0x37d3867a
    li x3, 0x37d3867a
    csrw 0xa38, x3

    #Address 0xa38 read value
    csrr x14, 0xa38

    #Unmapped address 0xfd1 testing: Read Reset + Random data Write/Read
    #Address 0xfd1 read value
    csrr x14, 0xfd1

    #Address 0xfd1 Write value 0xa3411a9d
    li x3, 0xa3411a9d
    csrw 0xfd1, x3

    #Address 0xfd1 read value
    csrr x14, 0xfd1

    #Unmapped address 0xce testing: Read Reset + Random data Write/Read
    #Address 0xce read value
    csrr x14, 0xce

    #Address 0xce Write value 0xaff61314
    li x3, 0xaff61314
    csrw 0xce, x3

    #Address 0xce read value
    csrr x14, 0xce

    #Unmapped address 0x278 testing: Read Reset + Random data Write/Read
    #Address 0x278 read value
    csrr x14, 0x278

    #Address 0x278 Write value 0x2a0c171
    li x3, 0x2a0c171
    csrw 0x278, x3

    #Address 0x278 read value
    csrr x14, 0x278

    #Unmapped address 0xe64 testing: Read Reset + Random data Write/Read
    #Address 0xe64 read value
    csrr x14, 0xe64

    #Address 0xe64 Write value 0x50990f65
    li x3, 0x50990f65
    csrw 0xe64, x3

    #Address 0xe64 read value
    csrr x14, 0xe64

    #Unmapped address 0x40b testing: Read Reset + Random data Write/Read
    #Address 0x40b read value
    csrr x14, 0x40b

    #Address 0x40b Write value 0x181e7eb3
    li x3, 0x181e7eb3
    csrw 0x40b, x3

    #Address 0x40b read value
    csrr x14, 0x40b

    #Unmapped address 0x727 testing: Read Reset + Random data Write/Read
    #Address 0x727 read value
    csrr x14, 0x727

    #Address 0x727 Write value 0x21815797
    li x3, 0x21815797
    csrw 0x727, x3

    #Address 0x727 read value
    csrr x14, 0x727

    #Unmapped address 0xda6 testing: Read Reset + Random data Write/Read
    #Address 0xda6 read value
    csrr x14, 0xda6

    #Address 0xda6 Write value 0x63def188
    li x3, 0x63def188
    csrw 0xda6, x3

    #Address 0xda6 read value
    csrr x14, 0xda6

    #Unmapped address 0x52 testing: Read Reset + Random data Write/Read
    #Address 0x52 read value
    csrr x14, 0x52

    #Address 0x52 Write value 0x6f72bff4
    li x3, 0x6f72bff4
    csrw 0x52, x3

    #Address 0x52 read value
    csrr x14, 0x52

    #Unmapped address 0x482 testing: Read Reset + Random data Write/Read
    #Address 0x482 read value
    csrr x14, 0x482

    #Address 0x482 Write value 0x2ecbeace
    li x3, 0x2ecbeace
    csrw 0x482, x3

    #Address 0x482 read value
    csrr x14, 0x482

    #Unmapped address 0x989 testing: Read Reset + Random data Write/Read
    #Address 0x989 read value
    csrr x14, 0x989

    #Address 0x989 Write value 0x4d6541b0
    li x3, 0x4d6541b0
    csrw 0x989, x3

    #Address 0x989 read value
    csrr x14, 0x989

    #Unmapped address 0x2c0 testing: Read Reset + Random data Write/Read
    #Address 0x2c0 read value
    csrr x14, 0x2c0

    #Address 0x2c0 Write value 0xa3f5aee2
    li x3, 0xa3f5aee2
    csrw 0x2c0, x3

    #Address 0x2c0 read value
    csrr x14, 0x2c0

    #Unmapped address 0x94c testing: Read Reset + Random data Write/Read
    #Address 0x94c read value
    csrr x14, 0x94c

    #Address 0x94c Write value 0x336d891
    li x3, 0x336d891
    csrw 0x94c, x3

    #Address 0x94c read value
    csrr x14, 0x94c

    #Unmapped address 0xebe testing: Read Reset + Random data Write/Read
    #Address 0xebe read value
    csrr x14, 0xebe

    #Address 0xebe Write value 0xc4051c84
    li x3, 0xc4051c84
    csrw 0xebe, x3

    #Address 0xebe read value
    csrr x14, 0xebe

    #Unmapped address 0xa42 testing: Read Reset + Random data Write/Read
    #Address 0xa42 read value
    csrr x14, 0xa42

    #Address 0xa42 Write value 0x61ba2e59
    li x3, 0x61ba2e59
    csrw 0xa42, x3

    #Address 0xa42 read value
    csrr x14, 0xa42

    #Unmapped address 0xb68 testing: Read Reset + Random data Write/Read
    #Address 0xb68 read value
    csrr x14, 0xb68

    #Address 0xb68 Write value 0xa29e5c62
    li x3, 0xa29e5c62
    csrw 0xb68, x3

    #Address 0xb68 read value
    csrr x14, 0xb68

    #Unmapped address 0xf28 testing: Read Reset + Random data Write/Read
    #Address 0xf28 read value
    csrr x14, 0xf28

    #Address 0xf28 Write value 0xabddbc7b
    li x3, 0xabddbc7b
    csrw 0xf28, x3

    #Address 0xf28 read value
    csrr x14, 0xf28

    #Unmapped address 0xbaf testing: Read Reset + Random data Write/Read
    #Address 0xbaf read value
    csrr x14, 0xbaf

    #Address 0xbaf Write value 0x565e139e
    li x3, 0x565e139e
    csrw 0xbaf, x3

    #Address 0xbaf read value
    csrr x14, 0xbaf

    #Unmapped address 0xaec testing: Read Reset + Random data Write/Read
    #Address 0xaec read value
    csrr x14, 0xaec

    #Address 0xaec Write value 0x1e227ee7
    li x3, 0x1e227ee7
    csrw 0xaec, x3

    #Address 0xaec read value
    csrr x14, 0xaec

    #Unmapped address 0xa6c testing: Read Reset + Random data Write/Read
    #Address 0xa6c read value
    csrr x14, 0xa6c

    #Address 0xa6c Write value 0x9f55acce
    li x3, 0x9f55acce
    csrw 0xa6c, x3

    #Address 0xa6c read value
    csrr x14, 0xa6c

    #Unmapped address 0x351 testing: Read Reset + Random data Write/Read
    #Address 0x351 read value
    csrr x14, 0x351

    #Address 0x351 Write value 0x7251e069
    li x3, 0x7251e069
    csrw 0x351, x3

    #Address 0x351 read value
    csrr x14, 0x351

    #Unmapped address 0x981 testing: Read Reset + Random data Write/Read
    #Address 0x981 read value
    csrr x14, 0x981

    #Address 0x981 Write value 0xd3e1c6ea
    li x3, 0xd3e1c6ea
    csrw 0x981, x3

    #Address 0x981 read value
    csrr x14, 0x981

    #Unmapped address 0xf53 testing: Read Reset + Random data Write/Read
    #Address 0xf53 read value
    csrr x14, 0xf53

    #Address 0xf53 Write value 0x4a575dd4
    li x3, 0x4a575dd4
    csrw 0xf53, x3

    #Address 0xf53 read value
    csrr x14, 0xf53

    #Unmapped address 0xba7 testing: Read Reset + Random data Write/Read
    #Address 0xba7 read value
    csrr x14, 0xba7

    #Address 0xba7 Write value 0x751b830d
    li x3, 0x751b830d
    csrw 0xba7, x3

    #Address 0xba7 read value
    csrr x14, 0xba7

    #Unmapped address 0xba1 testing: Read Reset + Random data Write/Read
    #Address 0xba1 read value
    csrr x14, 0xba1

    #Address 0xba1 Write value 0x3e13c711
    li x3, 0x3e13c711
    csrw 0xba1, x3

    #Address 0xba1 read value
    csrr x14, 0xba1

    #Unmapped address 0x69e testing: Read Reset + Random data Write/Read
    #Address 0x69e read value
    csrr x14, 0x69e

    #Address 0x69e Write value 0x3a9b40fb
    li x3, 0x3a9b40fb
    csrw 0x69e, x3

    #Address 0x69e read value
    csrr x14, 0x69e

    #Unmapped address 0x118 testing: Read Reset + Random data Write/Read
    #Address 0x118 read value
    csrr x14, 0x118

    #Address 0x118 Write value 0xd7024aff
    li x3, 0xd7024aff
    csrw 0x118, x3

    #Address 0x118 read value
    csrr x14, 0x118

    #Unmapped address 0xe2f testing: Read Reset + Random data Write/Read
    #Address 0xe2f read value
    csrr x14, 0xe2f

    #Address 0xe2f Write value 0x94bc9ff7
    li x3, 0x94bc9ff7
    csrw 0xe2f, x3

    #Address 0xe2f read value
    csrr x14, 0xe2f

    #Unmapped address 0x835 testing: Read Reset + Random data Write/Read
    #Address 0x835 read value
    csrr x14, 0x835

    #Address 0x835 Write value 0xf259bc2d
    li x3, 0xf259bc2d
    csrw 0x835, x3

    #Address 0x835 read value
    csrr x14, 0x835

    #Unmapped address 0x667 testing: Read Reset + Random data Write/Read
    #Address 0x667 read value
    csrr x14, 0x667

    #Address 0x667 Write value 0x8a93931c
    li x3, 0x8a93931c
    csrw 0x667, x3

    #Address 0x667 read value
    csrr x14, 0x667

    #Unmapped address 0x872 testing: Read Reset + Random data Write/Read
    #Address 0x872 read value
    csrr x14, 0x872

    #Address 0x872 Write value 0xa9bbd3ca
    li x3, 0xa9bbd3ca
    csrw 0x872, x3

    #Address 0x872 read value
    csrr x14, 0x872

    #Unmapped address 0x3 testing: Read Reset + Random data Write/Read
    #Address 0x3 read value
    csrr x14, 0x3

    #Address 0x3 Write value 0x16843de
    li x3, 0x16843de
    csrw 0x3, x3

    #Address 0x3 read value
    csrr x14, 0x3

    #Unmapped address 0x1ca testing: Read Reset + Random data Write/Read
    #Address 0x1ca read value
    csrr x14, 0x1ca

    #Address 0x1ca Write value 0x1a51159c
    li x3, 0x1a51159c
    csrw 0x1ca, x3

    #Address 0x1ca read value
    csrr x14, 0x1ca

    #Unmapped address 0xc46 testing: Read Reset + Random data Write/Read
    #Address 0xc46 read value
    csrr x14, 0xc46

    #Address 0xc46 Write value 0x20860f07
    li x3, 0x20860f07
    csrw 0xc46, x3

    #Address 0xc46 read value
    csrr x14, 0xc46

    #Unmapped address 0x44c testing: Read Reset + Random data Write/Read
    #Address 0x44c read value
    csrr x14, 0x44c

    #Address 0x44c Write value 0xf14184eb
    li x3, 0xf14184eb
    csrw 0x44c, x3

    #Address 0x44c read value
    csrr x14, 0x44c

    #Unmapped address 0x1df testing: Read Reset + Random data Write/Read
    #Address 0x1df read value
    csrr x14, 0x1df

    #Address 0x1df Write value 0xe7ccee9b
    li x3, 0xe7ccee9b
    csrw 0x1df, x3

    #Address 0x1df read value
    csrr x14, 0x1df

    #Unmapped address 0xd82 testing: Read Reset + Random data Write/Read
    #Address 0xd82 read value
    csrr x14, 0xd82

    #Address 0xd82 Write value 0xbe5425b3
    li x3, 0xbe5425b3
    csrw 0xd82, x3

    #Address 0xd82 read value
    csrr x14, 0xd82

    #Unmapped address 0x554 testing: Read Reset + Random data Write/Read
    #Address 0x554 read value
    csrr x14, 0x554

    #Address 0x554 Write value 0x557bea6a
    li x3, 0x557bea6a
    csrw 0x554, x3

    #Address 0x554 read value
    csrr x14, 0x554

    #Unmapped address 0x997 testing: Read Reset + Random data Write/Read
    #Address 0x997 read value
    csrr x14, 0x997

    #Address 0x997 Write value 0xdab4bb02
    li x3, 0xdab4bb02
    csrw 0x997, x3

    #Address 0x997 read value
    csrr x14, 0x997

    #Unmapped address 0x844 testing: Read Reset + Random data Write/Read
    #Address 0x844 read value
    csrr x14, 0x844

    #Address 0x844 Write value 0xc7e56d01
    li x3, 0xc7e56d01
    csrw 0x844, x3

    #Address 0x844 read value
    csrr x14, 0x844

    #Unmapped address 0x937 testing: Read Reset + Random data Write/Read
    #Address 0x937 read value
    csrr x14, 0x937

    #Address 0x937 Write value 0x2a903a8f
    li x3, 0x2a903a8f
    csrw 0x937, x3

    #Address 0x937 read value
    csrr x14, 0x937

    #Unmapped address 0x797 testing: Read Reset + Random data Write/Read
    #Address 0x797 read value
    csrr x14, 0x797

    #Address 0x797 Write value 0x73240d6d
    li x3, 0x73240d6d
    csrw 0x797, x3

    #Address 0x797 read value
    csrr x14, 0x797

    #Unmapped address 0x795 testing: Read Reset + Random data Write/Read
    #Address 0x795 read value
    csrr x14, 0x795

    #Address 0x795 Write value 0x249b1dcf
    li x3, 0x249b1dcf
    csrw 0x795, x3

    #Address 0x795 read value
    csrr x14, 0x795

    #Unmapped address 0x145 testing: Read Reset + Random data Write/Read
    #Address 0x145 read value
    csrr x14, 0x145

    #Address 0x145 Write value 0xcae10519
    li x3, 0xcae10519
    csrw 0x145, x3

    #Address 0x145 read value
    csrr x14, 0x145

    #Unmapped address 0x640 testing: Read Reset + Random data Write/Read
    #Address 0x640 read value
    csrr x14, 0x640

    #Address 0x640 Write value 0x87360d65
    li x3, 0x87360d65
    csrw 0x640, x3

    #Address 0x640 read value
    csrr x14, 0x640

    #Unmapped address 0x188 testing: Read Reset + Random data Write/Read
    #Address 0x188 read value
    csrr x14, 0x188

    #Address 0x188 Write value 0x2ccf88eb
    li x3, 0x2ccf88eb
    csrw 0x188, x3

    #Address 0x188 read value
    csrr x14, 0x188

    #Unmapped address 0xcac testing: Read Reset + Random data Write/Read
    #Address 0xcac read value
    csrr x14, 0xcac

    #Address 0xcac Write value 0x672e73b1
    li x3, 0x672e73b1
    csrw 0xcac, x3

    #Address 0xcac read value
    csrr x14, 0xcac

    #Unmapped address 0xd7c testing: Read Reset + Random data Write/Read
    #Address 0xd7c read value
    csrr x14, 0xd7c

    #Address 0xd7c Write value 0x45625b14
    li x3, 0x45625b14
    csrw 0xd7c, x3

    #Address 0xd7c read value
    csrr x14, 0xd7c

    #Unmapped address 0x90 testing: Read Reset + Random data Write/Read
    #Address 0x90 read value
    csrr x14, 0x90

    #Address 0x90 Write value 0xf536aeff
    li x3, 0xf536aeff
    csrw 0x90, x3

    #Address 0x90 read value
    csrr x14, 0x90

    #Unmapped address 0x12a testing: Read Reset + Random data Write/Read
    #Address 0x12a read value
    csrr x14, 0x12a

    #Address 0x12a Write value 0xdc1a60b4
    li x3, 0xdc1a60b4
    csrw 0x12a, x3

    #Address 0x12a read value
    csrr x14, 0x12a

    #Unmapped address 0x36b testing: Read Reset + Random data Write/Read
    #Address 0x36b read value
    csrr x14, 0x36b

    #Address 0x36b Write value 0xab3b8ef1
    li x3, 0xab3b8ef1
    csrw 0x36b, x3

    #Address 0x36b read value
    csrr x14, 0x36b

    #Unmapped address 0x122 testing: Read Reset + Random data Write/Read
    #Address 0x122 read value
    csrr x14, 0x122

    #Address 0x122 Write value 0xde6de2b9
    li x3, 0xde6de2b9
    csrw 0x122, x3

    #Address 0x122 read value
    csrr x14, 0x122

    #Unmapped address 0xc6d testing: Read Reset + Random data Write/Read
    #Address 0xc6d read value
    csrr x14, 0xc6d

    #Address 0xc6d Write value 0xfee7490f
    li x3, 0xfee7490f
    csrw 0xc6d, x3

    #Address 0xc6d read value
    csrr x14, 0xc6d

    #Unmapped address 0xb5e testing: Read Reset + Random data Write/Read
    #Address 0xb5e read value
    csrr x14, 0xb5e

    #Address 0xb5e Write value 0x79c2f0c
    li x3, 0x79c2f0c
    csrw 0xb5e, x3

    #Address 0xb5e read value
    csrr x14, 0xb5e

    #Unmapped address 0xdb testing: Read Reset + Random data Write/Read
    #Address 0xdb read value
    csrr x14, 0xdb

    #Address 0xdb Write value 0xc8d1971
    li x3, 0xc8d1971
    csrw 0xdb, x3

    #Address 0xdb read value
    csrr x14, 0xdb

    #Unmapped address 0x85f testing: Read Reset + Random data Write/Read
    #Address 0x85f read value
    csrr x14, 0x85f

    #Address 0x85f Write value 0x45cbbaf6
    li x3, 0x45cbbaf6
    csrw 0x85f, x3

    #Address 0x85f read value
    csrr x14, 0x85f

    #Unmapped address 0xa2b testing: Read Reset + Random data Write/Read
    #Address 0xa2b read value
    csrr x14, 0xa2b

    #Address 0xa2b Write value 0x32182754
    li x3, 0x32182754
    csrw 0xa2b, x3

    #Address 0xa2b read value
    csrr x14, 0xa2b

    #Unmapped address 0xcd8 testing: Read Reset + Random data Write/Read
    #Address 0xcd8 read value
    csrr x14, 0xcd8

    #Address 0xcd8 Write value 0xfb947de9
    li x3, 0xfb947de9
    csrw 0xcd8, x3

    #Address 0xcd8 read value
    csrr x14, 0xcd8

    #Unmapped address 0xeac testing: Read Reset + Random data Write/Read
    #Address 0xeac read value
    csrr x14, 0xeac

    #Address 0xeac Write value 0x3d53a1ce
    li x3, 0x3d53a1ce
    csrw 0xeac, x3

    #Address 0xeac read value
    csrr x14, 0xeac

    #Unmapped address 0x6aa testing: Read Reset + Random data Write/Read
    #Address 0x6aa read value
    csrr x14, 0x6aa

    #Address 0x6aa Write value 0x1c577449
    li x3, 0x1c577449
    csrw 0x6aa, x3

    #Address 0x6aa read value
    csrr x14, 0x6aa

    #Unmapped address 0xcea testing: Read Reset + Random data Write/Read
    #Address 0xcea read value
    csrr x14, 0xcea

    #Address 0xcea Write value 0x9c209f3
    li x3, 0x9c209f3
    csrw 0xcea, x3

    #Address 0xcea read value
    csrr x14, 0xcea

    #Unmapped address 0x6e1 testing: Read Reset + Random data Write/Read
    #Address 0x6e1 read value
    csrr x14, 0x6e1

    #Address 0x6e1 Write value 0x5eef5b18
    li x3, 0x5eef5b18
    csrw 0x6e1, x3

    #Address 0x6e1 read value
    csrr x14, 0x6e1

    #Unmapped address 0x161 testing: Read Reset + Random data Write/Read
    #Address 0x161 read value
    csrr x14, 0x161

    #Address 0x161 Write value 0xe3f3863f
    li x3, 0xe3f3863f
    csrw 0x161, x3

    #Address 0x161 read value
    csrr x14, 0x161

    #Unmapped address 0xc1 testing: Read Reset + Random data Write/Read
    #Address 0xc1 read value
    csrr x14, 0xc1

    #Address 0xc1 Write value 0xe8ec824a
    li x3, 0xe8ec824a
    csrw 0xc1, x3

    #Address 0xc1 read value
    csrr x14, 0xc1

    #Unmapped address 0x787 testing: Read Reset + Random data Write/Read
    #Address 0x787 read value
    csrr x14, 0x787

    #Address 0x787 Write value 0x1851928c
    li x3, 0x1851928c
    csrw 0x787, x3

    #Address 0x787 read value
    csrr x14, 0x787

    #Unmapped address 0xed3 testing: Read Reset + Random data Write/Read
    #Address 0xed3 read value
    csrr x14, 0xed3

    #Address 0xed3 Write value 0x6b7880ae
    li x3, 0x6b7880ae
    csrw 0xed3, x3

    #Address 0xed3 read value
    csrr x14, 0xed3

    #Unmapped address 0x401 testing: Read Reset + Random data Write/Read
    #Address 0x401 read value
    csrr x14, 0x401

    #Address 0x401 Write value 0x89f559c7
    li x3, 0x89f559c7
    csrw 0x401, x3

    #Address 0x401 read value
    csrr x14, 0x401

    #Unmapped address 0x4f1 testing: Read Reset + Random data Write/Read
    #Address 0x4f1 read value
    csrr x14, 0x4f1

    #Address 0x4f1 Write value 0xda79eb6
    li x3, 0xda79eb6
    csrw 0x4f1, x3

    #Address 0x4f1 read value
    csrr x14, 0x4f1

    #Unmapped address 0xa4c testing: Read Reset + Random data Write/Read
    #Address 0xa4c read value
    csrr x14, 0xa4c

    #Address 0xa4c Write value 0x33fab41d
    li x3, 0x33fab41d
    csrw 0xa4c, x3

    #Address 0xa4c read value
    csrr x14, 0xa4c

    #Unmapped address 0x6eb testing: Read Reset + Random data Write/Read
    #Address 0x6eb read value
    csrr x14, 0x6eb

    #Address 0x6eb Write value 0x7a8c2a41
    li x3, 0x7a8c2a41
    csrw 0x6eb, x3

    #Address 0x6eb read value
    csrr x14, 0x6eb

    #Unmapped address 0xa97 testing: Read Reset + Random data Write/Read
    #Address 0xa97 read value
    csrr x14, 0xa97

    #Address 0xa97 Write value 0xebc5ef10
    li x3, 0xebc5ef10
    csrw 0xa97, x3

    #Address 0xa97 read value
    csrr x14, 0xa97

    #Unmapped address 0xc0a testing: Read Reset + Random data Write/Read
    #Address 0xc0a read value
    csrr x14, 0xc0a

    #Address 0xc0a Write value 0x5dfdda30
    li x3, 0x5dfdda30
    csrw 0xc0a, x3

    #Address 0xc0a read value
    csrr x14, 0xc0a

    #Unmapped address 0xda1 testing: Read Reset + Random data Write/Read
    #Address 0xda1 read value
    csrr x14, 0xda1

    #Address 0xda1 Write value 0xff4900e9
    li x3, 0xff4900e9
    csrw 0xda1, x3

    #Address 0xda1 read value
    csrr x14, 0xda1

    #Unmapped address 0xaa6 testing: Read Reset + Random data Write/Read
    #Address 0xaa6 read value
    csrr x14, 0xaa6

    #Address 0xaa6 Write value 0xdc7ebce3
    li x3, 0xdc7ebce3
    csrw 0xaa6, x3

    #Address 0xaa6 read value
    csrr x14, 0xaa6

    #Unmapped address 0x615 testing: Read Reset + Random data Write/Read
    #Address 0x615 read value
    csrr x14, 0x615

    #Address 0x615 Write value 0xea4287ef
    li x3, 0xea4287ef
    csrw 0x615, x3

    #Address 0x615 read value
    csrr x14, 0x615

    #Unmapped address 0xa4 testing: Read Reset + Random data Write/Read
    #Address 0xa4 read value
    csrr x14, 0xa4

    #Address 0xa4 Write value 0x246be41a
    li x3, 0x246be41a
    csrw 0xa4, x3

    #Address 0xa4 read value
    csrr x14, 0xa4

    #Unmapped address 0x505 testing: Read Reset + Random data Write/Read
    #Address 0x505 read value
    csrr x14, 0x505

    #Address 0x505 Write value 0xc1a62d2d
    li x3, 0xc1a62d2d
    csrw 0x505, x3

    #Address 0x505 read value
    csrr x14, 0x505

    #Unmapped address 0xda8 testing: Read Reset + Random data Write/Read
    #Address 0xda8 read value
    csrr x14, 0xda8

    #Address 0xda8 Write value 0x1783de22
    li x3, 0x1783de22
    csrw 0xda8, x3

    #Address 0xda8 read value
    csrr x14, 0xda8

    #Unmapped address 0xe8e testing: Read Reset + Random data Write/Read
    #Address 0xe8e read value
    csrr x14, 0xe8e

    #Address 0xe8e Write value 0xa9e8b494
    li x3, 0xa9e8b494
    csrw 0xe8e, x3

    #Address 0xe8e read value
    csrr x14, 0xe8e

    #Unmapped address 0xa65 testing: Read Reset + Random data Write/Read
    #Address 0xa65 read value
    csrr x14, 0xa65

    #Address 0xa65 Write value 0x5379af7f
    li x3, 0x5379af7f
    csrw 0xa65, x3

    #Address 0xa65 read value
    csrr x14, 0xa65

    #Unmapped address 0x132 testing: Read Reset + Random data Write/Read
    #Address 0x132 read value
    csrr x14, 0x132

    #Address 0x132 Write value 0x6bf2ad72
    li x3, 0x6bf2ad72
    csrw 0x132, x3

    #Address 0x132 read value
    csrr x14, 0x132

    #Unmapped address 0x4ce testing: Read Reset + Random data Write/Read
    #Address 0x4ce read value
    csrr x14, 0x4ce

    #Address 0x4ce Write value 0x2ebe303e
    li x3, 0x2ebe303e
    csrw 0x4ce, x3

    #Address 0x4ce read value
    csrr x14, 0x4ce

    #Unmapped address 0x711 testing: Read Reset + Random data Write/Read
    #Address 0x711 read value
    csrr x14, 0x711

    #Address 0x711 Write value 0x306411b9
    li x3, 0x306411b9
    csrw 0x711, x3

    #Address 0x711 read value
    csrr x14, 0x711

    #Unmapped address 0x1eb testing: Read Reset + Random data Write/Read
    #Address 0x1eb read value
    csrr x14, 0x1eb

    #Address 0x1eb Write value 0xe3b8bd
    li x3, 0xe3b8bd
    csrw 0x1eb, x3

    #Address 0x1eb read value
    csrr x14, 0x1eb

    #Unmapped address 0xdc testing: Read Reset + Random data Write/Read
    #Address 0xdc read value
    csrr x14, 0xdc

    #Address 0xdc Write value 0xb4d0bd11
    li x3, 0xb4d0bd11
    csrw 0xdc, x3

    #Address 0xdc read value
    csrr x14, 0xdc

    #Unmapped address 0x49 testing: Read Reset + Random data Write/Read
    #Address 0x49 read value
    csrr x14, 0x49

    #Address 0x49 Write value 0x1125d6e0
    li x3, 0x1125d6e0
    csrw 0x49, x3

    #Address 0x49 read value
    csrr x14, 0x49

    #Unmapped address 0x3dd testing: Read Reset + Random data Write/Read
    #Address 0x3dd read value
    csrr x14, 0x3dd

    #Address 0x3dd Write value 0x76905185
    li x3, 0x76905185
    csrw 0x3dd, x3

    #Address 0x3dd read value
    csrr x14, 0x3dd

    #Unmapped address 0x790 testing: Read Reset + Random data Write/Read
    #Address 0x790 read value
    csrr x14, 0x790

    #Address 0x790 Write value 0xefc921fd
    li x3, 0xefc921fd
    csrw 0x790, x3

    #Address 0x790 read value
    csrr x14, 0x790

    #Unmapped address 0x4e testing: Read Reset + Random data Write/Read
    #Address 0x4e read value
    csrr x14, 0x4e

    #Address 0x4e Write value 0x76f72efd
    li x3, 0x76f72efd
    csrw 0x4e, x3

    #Address 0x4e read value
    csrr x14, 0x4e

    #Unmapped address 0xc testing: Read Reset + Random data Write/Read
    #Address 0xc read value
    csrr x14, 0xc

    #Address 0xc Write value 0x19200204
    li x3, 0x19200204
    csrw 0xc, x3

    #Address 0xc read value
    csrr x14, 0xc

    #Unmapped address 0xbd0 testing: Read Reset + Random data Write/Read
    #Address 0xbd0 read value
    csrr x14, 0xbd0

    #Address 0xbd0 Write value 0x3c1c39a6
    li x3, 0x3c1c39a6
    csrw 0xbd0, x3

    #Address 0xbd0 read value
    csrr x14, 0xbd0

    #Unmapped address 0x6a6 testing: Read Reset + Random data Write/Read
    #Address 0x6a6 read value
    csrr x14, 0x6a6

    #Address 0x6a6 Write value 0xd1edc474
    li x3, 0xd1edc474
    csrw 0x6a6, x3

    #Address 0x6a6 read value
    csrr x14, 0x6a6

    #Unmapped address 0x794 testing: Read Reset + Random data Write/Read
    #Address 0x794 read value
    csrr x14, 0x794

    #Address 0x794 Write value 0x4896b3db
    li x3, 0x4896b3db
    csrw 0x794, x3

    #Address 0x794 read value
    csrr x14, 0x794

    #Unmapped address 0x54e testing: Read Reset + Random data Write/Read
    #Address 0x54e read value
    csrr x14, 0x54e

    #Address 0x54e Write value 0x2ba7f669
    li x3, 0x2ba7f669
    csrw 0x54e, x3

    #Address 0x54e read value
    csrr x14, 0x54e

    #Unmapped address 0x905 testing: Read Reset + Random data Write/Read
    #Address 0x905 read value
    csrr x14, 0x905

    #Address 0x905 Write value 0xcb2e0353
    li x3, 0xcb2e0353
    csrw 0x905, x3

    #Address 0x905 read value
    csrr x14, 0x905

    #Unmapped address 0xded testing: Read Reset + Random data Write/Read
    #Address 0xded read value
    csrr x14, 0xded

    #Address 0xded Write value 0xce76b123
    li x3, 0xce76b123
    csrw 0xded, x3

    #Address 0xded read value
    csrr x14, 0xded

    #Unmapped address 0x5a8 testing: Read Reset + Random data Write/Read
    #Address 0x5a8 read value
    csrr x14, 0x5a8

    #Address 0x5a8 Write value 0x2c4d3e73
    li x3, 0x2c4d3e73
    csrw 0x5a8, x3

    #Address 0x5a8 read value
    csrr x14, 0x5a8

    #Unmapped address 0xbb9 testing: Read Reset + Random data Write/Read
    #Address 0xbb9 read value
    csrr x14, 0xbb9

    #Address 0xbb9 Write value 0x80206282
    li x3, 0x80206282
    csrw 0xbb9, x3

    #Address 0xbb9 read value
    csrr x14, 0xbb9

    #Unmapped address 0xa81 testing: Read Reset + Random data Write/Read
    #Address 0xa81 read value
    csrr x14, 0xa81

    #Address 0xa81 Write value 0x2c9fa899
    li x3, 0x2c9fa899
    csrw 0xa81, x3

    #Address 0xa81 read value
    csrr x14, 0xa81

    #Unmapped address 0xe58 testing: Read Reset + Random data Write/Read
    #Address 0xe58 read value
    csrr x14, 0xe58

    #Address 0xe58 Write value 0xb225171d
    li x3, 0xb225171d
    csrw 0xe58, x3

    #Address 0xe58 read value
    csrr x14, 0xe58

    #Unmapped address 0x224 testing: Read Reset + Random data Write/Read
    #Address 0x224 read value
    csrr x14, 0x224

    #Address 0x224 Write value 0xeee66d31
    li x3, 0xeee66d31
    csrw 0x224, x3

    #Address 0x224 read value
    csrr x14, 0x224

    #Unmapped address 0x64b testing: Read Reset + Random data Write/Read
    #Address 0x64b read value
    csrr x14, 0x64b

    #Address 0x64b Write value 0xc29b55a6
    li x3, 0xc29b55a6
    csrw 0x64b, x3

    #Address 0x64b read value
    csrr x14, 0x64b

    #Unmapped address 0xde7 testing: Read Reset + Random data Write/Read
    #Address 0xde7 read value
    csrr x14, 0xde7

    #Address 0xde7 Write value 0x19689db3
    li x3, 0x19689db3
    csrw 0xde7, x3

    #Address 0xde7 read value
    csrr x14, 0xde7

    #Unmapped address 0xd49 testing: Read Reset + Random data Write/Read
    #Address 0xd49 read value
    csrr x14, 0xd49

    #Address 0xd49 Write value 0x61e1de97
    li x3, 0x61e1de97
    csrw 0xd49, x3

    #Address 0xd49 read value
    csrr x14, 0xd49

    #Unmapped address 0xe95 testing: Read Reset + Random data Write/Read
    #Address 0xe95 read value
    csrr x14, 0xe95

    #Address 0xe95 Write value 0xdec9fe35
    li x3, 0xdec9fe35
    csrw 0xe95, x3

    #Address 0xe95 read value
    csrr x14, 0xe95

    #Unmapped address 0x50a testing: Read Reset + Random data Write/Read
    #Address 0x50a read value
    csrr x14, 0x50a

    #Address 0x50a Write value 0x43c3660e
    li x3, 0x43c3660e
    csrw 0x50a, x3

    #Address 0x50a read value
    csrr x14, 0x50a

    #Unmapped address 0x617 testing: Read Reset + Random data Write/Read
    #Address 0x617 read value
    csrr x14, 0x617

    #Address 0x617 Write value 0xcb103df7
    li x3, 0xcb103df7
    csrw 0x617, x3

    #Address 0x617 read value
    csrr x14, 0x617

    #Unmapped address 0xf5 testing: Read Reset + Random data Write/Read
    #Address 0xf5 read value
    csrr x14, 0xf5

    #Address 0xf5 Write value 0xfcaa6d4
    li x3, 0xfcaa6d4
    csrw 0xf5, x3

    #Address 0xf5 read value
    csrr x14, 0xf5

    #Unmapped address 0xad testing: Read Reset + Random data Write/Read
    #Address 0xad read value
    csrr x14, 0xad

    #Address 0xad Write value 0x50108628
    li x3, 0x50108628
    csrw 0xad, x3

    #Address 0xad read value
    csrr x14, 0xad

    #Unmapped address 0xeb8 testing: Read Reset + Random data Write/Read
    #Address 0xeb8 read value
    csrr x14, 0xeb8

    #Address 0xeb8 Write value 0x58a2c1ae
    li x3, 0x58a2c1ae
    csrw 0xeb8, x3

    #Address 0xeb8 read value
    csrr x14, 0xeb8

    #Unmapped address 0xadf testing: Read Reset + Random data Write/Read
    #Address 0xadf read value
    csrr x14, 0xadf

    #Address 0xadf Write value 0xa8f72cd4
    li x3, 0xa8f72cd4
    csrw 0xadf, x3

    #Address 0xadf read value
    csrr x14, 0xadf

    #Unmapped address 0x714 testing: Read Reset + Random data Write/Read
    #Address 0x714 read value
    csrr x14, 0x714

    #Address 0x714 Write value 0xc3888ca3
    li x3, 0xc3888ca3
    csrw 0x714, x3

    #Address 0x714 read value
    csrr x14, 0x714

    #Unmapped address 0x2f testing: Read Reset + Random data Write/Read
    #Address 0x2f read value
    csrr x14, 0x2f

    #Address 0x2f Write value 0x75160f6b
    li x3, 0x75160f6b
    csrw 0x2f, x3

    #Address 0x2f read value
    csrr x14, 0x2f

    #Unmapped address 0xfb0 testing: Read Reset + Random data Write/Read
    #Address 0xfb0 read value
    csrr x14, 0xfb0

    #Address 0xfb0 Write value 0x68a18cac
    li x3, 0x68a18cac
    csrw 0xfb0, x3

    #Address 0xfb0 read value
    csrr x14, 0xfb0

    #Unmapped address 0xa05 testing: Read Reset + Random data Write/Read
    #Address 0xa05 read value
    csrr x14, 0xa05

    #Address 0xa05 Write value 0xfd76118d
    li x3, 0xfd76118d
    csrw 0xa05, x3

    #Address 0xa05 read value
    csrr x14, 0xa05

    #Unmapped address 0x13e testing: Read Reset + Random data Write/Read
    #Address 0x13e read value
    csrr x14, 0x13e

    #Address 0x13e Write value 0x769951f9
    li x3, 0x769951f9
    csrw 0x13e, x3

    #Address 0x13e read value
    csrr x14, 0x13e

    #Unmapped address 0xa8 testing: Read Reset + Random data Write/Read
    #Address 0xa8 read value
    csrr x14, 0xa8

    #Address 0xa8 Write value 0x4082bfb9
    li x3, 0x4082bfb9
    csrw 0xa8, x3

    #Address 0xa8 read value
    csrr x14, 0xa8

    #Unmapped address 0x71b testing: Read Reset + Random data Write/Read
    #Address 0x71b read value
    csrr x14, 0x71b

    #Address 0x71b Write value 0xf8b104cc
    li x3, 0xf8b104cc
    csrw 0x71b, x3

    #Address 0x71b read value
    csrr x14, 0x71b

    #Unmapped address 0xe2d testing: Read Reset + Random data Write/Read
    #Address 0xe2d read value
    csrr x14, 0xe2d

    #Address 0xe2d Write value 0x4e1e5a8f
    li x3, 0x4e1e5a8f
    csrw 0xe2d, x3

    #Address 0xe2d read value
    csrr x14, 0xe2d

    #Unmapped address 0x678 testing: Read Reset + Random data Write/Read
    #Address 0x678 read value
    csrr x14, 0x678

    #Address 0x678 Write value 0x96e668ce
    li x3, 0x96e668ce
    csrw 0x678, x3

    #Address 0x678 read value
    csrr x14, 0x678

    #Unmapped address 0x588 testing: Read Reset + Random data Write/Read
    #Address 0x588 read value
    csrr x14, 0x588

    #Address 0x588 Write value 0x1b01d7d5
    li x3, 0x1b01d7d5
    csrw 0x588, x3

    #Address 0x588 read value
    csrr x14, 0x588

    #Unmapped address 0x561 testing: Read Reset + Random data Write/Read
    #Address 0x561 read value
    csrr x14, 0x561

    #Address 0x561 Write value 0x930eb0d5
    li x3, 0x930eb0d5
    csrw 0x561, x3

    #Address 0x561 read value
    csrr x14, 0x561

    #Unmapped address 0x735 testing: Read Reset + Random data Write/Read
    #Address 0x735 read value
    csrr x14, 0x735

    #Address 0x735 Write value 0x9c4fa188
    li x3, 0x9c4fa188
    csrw 0x735, x3

    #Address 0x735 read value
    csrr x14, 0x735

    #Unmapped address 0x3a testing: Read Reset + Random data Write/Read
    #Address 0x3a read value
    csrr x14, 0x3a

    #Address 0x3a Write value 0x66b5b7c7
    li x3, 0x66b5b7c7
    csrw 0x3a, x3

    #Address 0x3a read value
    csrr x14, 0x3a

    #Unmapped address 0xb3e testing: Read Reset + Random data Write/Read
    #Address 0xb3e read value
    csrr x14, 0xb3e

    #Address 0xb3e Write value 0x765ae7e9
    li x3, 0x765ae7e9
    csrw 0xb3e, x3

    #Address 0xb3e read value
    csrr x14, 0xb3e

    #Unmapped address 0x26e testing: Read Reset + Random data Write/Read
    #Address 0x26e read value
    csrr x14, 0x26e

    #Address 0x26e Write value 0x586cac77
    li x3, 0x586cac77
    csrw 0x26e, x3

    #Address 0x26e read value
    csrr x14, 0x26e

    #Unmapped address 0x91a testing: Read Reset + Random data Write/Read
    #Address 0x91a read value
    csrr x14, 0x91a

    #Address 0x91a Write value 0xbda4230e
    li x3, 0xbda4230e
    csrw 0x91a, x3

    #Address 0x91a read value
    csrr x14, 0x91a

    #Unmapped address 0x177 testing: Read Reset + Random data Write/Read
    #Address 0x177 read value
    csrr x14, 0x177

    #Address 0x177 Write value 0xdcd15947
    li x3, 0xdcd15947
    csrw 0x177, x3

    #Address 0x177 read value
    csrr x14, 0x177

    #Unmapped address 0x8c4 testing: Read Reset + Random data Write/Read
    #Address 0x8c4 read value
    csrr x14, 0x8c4

    #Address 0x8c4 Write value 0xea5a01ec
    li x3, 0xea5a01ec
    csrw 0x8c4, x3

    #Address 0x8c4 read value
    csrr x14, 0x8c4

    #Unmapped address 0xea testing: Read Reset + Random data Write/Read
    #Address 0xea read value
    csrr x14, 0xea

    #Address 0xea Write value 0xc0cac121
    li x3, 0xc0cac121
    csrw 0xea, x3

    #Address 0xea read value
    csrr x14, 0xea

    #Unmapped address 0x7dc testing: Read Reset + Random data Write/Read
    #Address 0x7dc read value
    csrr x14, 0x7dc

    #Address 0x7dc Write value 0x7fbda3de
    li x3, 0x7fbda3de
    csrw 0x7dc, x3

    #Address 0x7dc read value
    csrr x14, 0x7dc

    #Unmapped address 0x671 testing: Read Reset + Random data Write/Read
    #Address 0x671 read value
    csrr x14, 0x671

    #Address 0x671 Write value 0x8be3bd48
    li x3, 0x8be3bd48
    csrw 0x671, x3

    #Address 0x671 read value
    csrr x14, 0x671

    #Unmapped address 0xc25 testing: Read Reset + Random data Write/Read
    #Address 0xc25 read value
    csrr x14, 0xc25

    #Address 0xc25 Write value 0x42b74910
    li x3, 0x42b74910
    csrw 0xc25, x3

    #Address 0xc25 read value
    csrr x14, 0xc25

    #Unmapped address 0xf24 testing: Read Reset + Random data Write/Read
    #Address 0xf24 read value
    csrr x14, 0xf24

    #Address 0xf24 Write value 0x61858f63
    li x3, 0x61858f63
    csrw 0xf24, x3

    #Address 0xf24 read value
    csrr x14, 0xf24

    #Unmapped address 0xe46 testing: Read Reset + Random data Write/Read
    #Address 0xe46 read value
    csrr x14, 0xe46

    #Address 0xe46 Write value 0x24adf446
    li x3, 0x24adf446
    csrw 0xe46, x3

    #Address 0xe46 read value
    csrr x14, 0xe46

    #Unmapped address 0x57b testing: Read Reset + Random data Write/Read
    #Address 0x57b read value
    csrr x14, 0x57b

    #Address 0x57b Write value 0x80d09177
    li x3, 0x80d09177
    csrw 0x57b, x3

    #Address 0x57b read value
    csrr x14, 0x57b

    #Unmapped address 0xd81 testing: Read Reset + Random data Write/Read
    #Address 0xd81 read value
    csrr x14, 0xd81

    #Address 0xd81 Write value 0x921166fb
    li x3, 0x921166fb
    csrw 0xd81, x3

    #Address 0xd81 read value
    csrr x14, 0xd81

    #Unmapped address 0x58d testing: Read Reset + Random data Write/Read
    #Address 0x58d read value
    csrr x14, 0x58d

    #Address 0x58d Write value 0x7d409147
    li x3, 0x7d409147
    csrw 0x58d, x3

    #Address 0x58d read value
    csrr x14, 0x58d

    #Unmapped address 0x68a testing: Read Reset + Random data Write/Read
    #Address 0x68a read value
    csrr x14, 0x68a

    #Address 0x68a Write value 0xbb66f630
    li x3, 0xbb66f630
    csrw 0x68a, x3

    #Address 0x68a read value
    csrr x14, 0x68a

    #Unmapped address 0x7f9 testing: Read Reset + Random data Write/Read
    #Address 0x7f9 read value
    csrr x14, 0x7f9

    #Address 0x7f9 Write value 0x7cb75eb
    li x3, 0x7cb75eb
    csrw 0x7f9, x3

    #Address 0x7f9 read value
    csrr x14, 0x7f9

    #Unmapped address 0xc92 testing: Read Reset + Random data Write/Read
    #Address 0xc92 read value
    csrr x14, 0xc92

    #Address 0xc92 Write value 0x1d9fe40f
    li x3, 0x1d9fe40f
    csrw 0xc92, x3

    #Address 0xc92 read value
    csrr x14, 0xc92

    #Unmapped address 0x7db testing: Read Reset + Random data Write/Read
    #Address 0x7db read value
    csrr x14, 0x7db

    #Address 0x7db Write value 0xb351bcd4
    li x3, 0xb351bcd4
    csrw 0x7db, x3

    #Address 0x7db read value
    csrr x14, 0x7db

    #Unmapped address 0x1b testing: Read Reset + Random data Write/Read
    #Address 0x1b read value
    csrr x14, 0x1b

    #Address 0x1b Write value 0x57a422dd
    li x3, 0x57a422dd
    csrw 0x1b, x3

    #Address 0x1b read value
    csrr x14, 0x1b

    #Unmapped address 0xf06 testing: Read Reset + Random data Write/Read
    #Address 0xf06 read value
    csrr x14, 0xf06

    #Address 0xf06 Write value 0xcd35e070
    li x3, 0xcd35e070
    csrw 0xf06, x3

    #Address 0xf06 read value
    csrr x14, 0xf06

    #Unmapped address 0x2af testing: Read Reset + Random data Write/Read
    #Address 0x2af read value
    csrr x14, 0x2af

    #Address 0x2af Write value 0xa84ca86
    li x3, 0xa84ca86
    csrw 0x2af, x3

    #Address 0x2af read value
    csrr x14, 0x2af

    #Unmapped address 0x2d4 testing: Read Reset + Random data Write/Read
    #Address 0x2d4 read value
    csrr x14, 0x2d4

    #Address 0x2d4 Write value 0x7a8596e3
    li x3, 0x7a8596e3
    csrw 0x2d4, x3

    #Address 0x2d4 read value
    csrr x14, 0x2d4

    #Unmapped address 0xf72 testing: Read Reset + Random data Write/Read
    #Address 0xf72 read value
    csrr x14, 0xf72

    #Address 0xf72 Write value 0x7ae067f9
    li x3, 0x7ae067f9
    csrw 0xf72, x3

    #Address 0xf72 read value
    csrr x14, 0xf72

    #Unmapped address 0xed2 testing: Read Reset + Random data Write/Read
    #Address 0xed2 read value
    csrr x14, 0xed2

    #Address 0xed2 Write value 0x99b3c063
    li x3, 0x99b3c063
    csrw 0xed2, x3

    #Address 0xed2 read value
    csrr x14, 0xed2

    #Unmapped address 0x1f testing: Read Reset + Random data Write/Read
    #Address 0x1f read value
    csrr x14, 0x1f

    #Address 0x1f Write value 0x3710d34f
    li x3, 0x3710d34f
    csrw 0x1f, x3

    #Address 0x1f read value
    csrr x14, 0x1f

    #Unmapped address 0xe03 testing: Read Reset + Random data Write/Read
    #Address 0xe03 read value
    csrr x14, 0xe03

    #Address 0xe03 Write value 0x24f3d144
    li x3, 0x24f3d144
    csrw 0xe03, x3

    #Address 0xe03 read value
    csrr x14, 0xe03

    #Unmapped address 0xf6 testing: Read Reset + Random data Write/Read
    #Address 0xf6 read value
    csrr x14, 0xf6

    #Address 0xf6 Write value 0xf20df364
    li x3, 0xf20df364
    csrw 0xf6, x3

    #Address 0xf6 read value
    csrr x14, 0xf6

    #Unmapped address 0x75c testing: Read Reset + Random data Write/Read
    #Address 0x75c read value
    csrr x14, 0x75c

    #Address 0x75c Write value 0x56b450b2
    li x3, 0x56b450b2
    csrw 0x75c, x3

    #Address 0x75c read value
    csrr x14, 0x75c

    #Unmapped address 0xde6 testing: Read Reset + Random data Write/Read
    #Address 0xde6 read value
    csrr x14, 0xde6

    #Address 0xde6 Write value 0xd0bdb5a3
    li x3, 0xd0bdb5a3
    csrw 0xde6, x3

    #Address 0xde6 read value
    csrr x14, 0xde6

    #Unmapped address 0x9a0 testing: Read Reset + Random data Write/Read
    #Address 0x9a0 read value
    csrr x14, 0x9a0

    #Address 0x9a0 Write value 0xb47f1e1d
    li x3, 0xb47f1e1d
    csrw 0x9a0, x3

    #Address 0x9a0 read value
    csrr x14, 0x9a0

    #Unmapped address 0x5e0 testing: Read Reset + Random data Write/Read
    #Address 0x5e0 read value
    csrr x14, 0x5e0

    #Address 0x5e0 Write value 0x4841922c
    li x3, 0x4841922c
    csrw 0x5e0, x3

    #Address 0x5e0 read value
    csrr x14, 0x5e0

    #Unmapped address 0x55b testing: Read Reset + Random data Write/Read
    #Address 0x55b read value
    csrr x14, 0x55b

    #Address 0x55b Write value 0x86495b7
    li x3, 0x86495b7
    csrw 0x55b, x3

    #Address 0x55b read value
    csrr x14, 0x55b

    #Unmapped address 0x5bf testing: Read Reset + Random data Write/Read
    #Address 0x5bf read value
    csrr x14, 0x5bf

    #Address 0x5bf Write value 0x440416f8
    li x3, 0x440416f8
    csrw 0x5bf, x3

    #Address 0x5bf read value
    csrr x14, 0x5bf

    #Unmapped address 0xbf testing: Read Reset + Random data Write/Read
    #Address 0xbf read value
    csrr x14, 0xbf

    #Address 0xbf Write value 0xc1234e79
    li x3, 0xc1234e79
    csrw 0xbf, x3

    #Address 0xbf read value
    csrr x14, 0xbf

    #Unmapped address 0x3c testing: Read Reset + Random data Write/Read
    #Address 0x3c read value
    csrr x14, 0x3c

    #Address 0x3c Write value 0xaf46816
    li x3, 0xaf46816
    csrw 0x3c, x3

    #Address 0x3c read value
    csrr x14, 0x3c

    #Unmapped address 0x7df testing: Read Reset + Random data Write/Read
    #Address 0x7df read value
    csrr x14, 0x7df

    #Address 0x7df Write value 0xbd03eeb8
    li x3, 0xbd03eeb8
    csrw 0x7df, x3

    #Address 0x7df read value
    csrr x14, 0x7df

    #Unmapped address 0x864 testing: Read Reset + Random data Write/Read
    #Address 0x864 read value
    csrr x14, 0x864

    #Address 0x864 Write value 0x8f1a3f14
    li x3, 0x8f1a3f14
    csrw 0x864, x3

    #Address 0x864 read value
    csrr x14, 0x864

    #Unmapped address 0xa95 testing: Read Reset + Random data Write/Read
    #Address 0xa95 read value
    csrr x14, 0xa95

    #Address 0xa95 Write value 0x6882df0b
    li x3, 0x6882df0b
    csrw 0xa95, x3

    #Address 0xa95 read value
    csrr x14, 0xa95

    #Unmapped address 0x1d7 testing: Read Reset + Random data Write/Read
    #Address 0x1d7 read value
    csrr x14, 0x1d7

    #Address 0x1d7 Write value 0x5f674bb7
    li x3, 0x5f674bb7
    csrw 0x1d7, x3

    #Address 0x1d7 read value
    csrr x14, 0x1d7

    #Unmapped address 0x63b testing: Read Reset + Random data Write/Read
    #Address 0x63b read value
    csrr x14, 0x63b

    #Address 0x63b Write value 0x9639b1ba
    li x3, 0x9639b1ba
    csrw 0x63b, x3

    #Address 0x63b read value
    csrr x14, 0x63b

    #Unmapped address 0xb36 testing: Read Reset + Random data Write/Read
    #Address 0xb36 read value
    csrr x14, 0xb36

    #Address 0xb36 Write value 0x85451cd6
    li x3, 0x85451cd6
    csrw 0xb36, x3

    #Address 0xb36 read value
    csrr x14, 0xb36

    #Unmapped address 0xdc1 testing: Read Reset + Random data Write/Read
    #Address 0xdc1 read value
    csrr x14, 0xdc1

    #Address 0xdc1 Write value 0xb15640ff
    li x3, 0xb15640ff
    csrw 0xdc1, x3

    #Address 0xdc1 read value
    csrr x14, 0xdc1

    #Unmapped address 0x176 testing: Read Reset + Random data Write/Read
    #Address 0x176 read value
    csrr x14, 0x176

    #Address 0x176 Write value 0x14187a2a
    li x3, 0x14187a2a
    csrw 0x176, x3

    #Address 0x176 read value
    csrr x14, 0x176

    #Unmapped address 0x18 testing: Read Reset + Random data Write/Read
    #Address 0x18 read value
    csrr x14, 0x18

    #Address 0x18 Write value 0x3b8c9d00
    li x3, 0x3b8c9d00
    csrw 0x18, x3

    #Address 0x18 read value
    csrr x14, 0x18

    #Unmapped address 0x51a testing: Read Reset + Random data Write/Read
    #Address 0x51a read value
    csrr x14, 0x51a

    #Address 0x51a Write value 0x29f9384c
    li x3, 0x29f9384c
    csrw 0x51a, x3

    #Address 0x51a read value
    csrr x14, 0x51a

    #Unmapped address 0x8b2 testing: Read Reset + Random data Write/Read
    #Address 0x8b2 read value
    csrr x14, 0x8b2

    #Address 0x8b2 Write value 0x6991d069
    li x3, 0x6991d069
    csrw 0x8b2, x3

    #Address 0x8b2 read value
    csrr x14, 0x8b2

    #Unmapped address 0x6ed testing: Read Reset + Random data Write/Read
    #Address 0x6ed read value
    csrr x14, 0x6ed

    #Address 0x6ed Write value 0x9b10cac0
    li x3, 0x9b10cac0
    csrw 0x6ed, x3

    #Address 0x6ed read value
    csrr x14, 0x6ed

    #Unmapped address 0x2f8 testing: Read Reset + Random data Write/Read
    #Address 0x2f8 read value
    csrr x14, 0x2f8

    #Address 0x2f8 Write value 0x414a36c9
    li x3, 0x414a36c9
    csrw 0x2f8, x3

    #Address 0x2f8 read value
    csrr x14, 0x2f8

    #Unmapped address 0xca0 testing: Read Reset + Random data Write/Read
    #Address 0xca0 read value
    csrr x14, 0xca0

    #Address 0xca0 Write value 0x23c6fb96
    li x3, 0x23c6fb96
    csrw 0xca0, x3

    #Address 0xca0 read value
    csrr x14, 0xca0

    #Unmapped address 0x5ae testing: Read Reset + Random data Write/Read
    #Address 0x5ae read value
    csrr x14, 0x5ae

    #Address 0x5ae Write value 0x42aa5680
    li x3, 0x42aa5680
    csrw 0x5ae, x3

    #Address 0x5ae read value
    csrr x14, 0x5ae

    #Unmapped address 0xc6f testing: Read Reset + Random data Write/Read
    #Address 0xc6f read value
    csrr x14, 0xc6f

    #Address 0xc6f Write value 0x5438f37f
    li x3, 0x5438f37f
    csrw 0xc6f, x3

    #Address 0xc6f read value
    csrr x14, 0xc6f

    #Unmapped address 0x5d9 testing: Read Reset + Random data Write/Read
    #Address 0x5d9 read value
    csrr x14, 0x5d9

    #Address 0x5d9 Write value 0x1d5ce30b
    li x3, 0x1d5ce30b
    csrw 0x5d9, x3

    #Address 0x5d9 read value
    csrr x14, 0x5d9

    #Unmapped address 0x181 testing: Read Reset + Random data Write/Read
    #Address 0x181 read value
    csrr x14, 0x181

    #Address 0x181 Write value 0x36d66a7c
    li x3, 0x36d66a7c
    csrw 0x181, x3

    #Address 0x181 read value
    csrr x14, 0x181

    #Unmapped address 0xe52 testing: Read Reset + Random data Write/Read
    #Address 0xe52 read value
    csrr x14, 0xe52

    #Address 0xe52 Write value 0xf90face4
    li x3, 0xf90face4
    csrw 0xe52, x3

    #Address 0xe52 read value
    csrr x14, 0xe52

    #Unmapped address 0xa2e testing: Read Reset + Random data Write/Read
    #Address 0xa2e read value
    csrr x14, 0xa2e

    #Address 0xa2e Write value 0x3abba90f
    li x3, 0x3abba90f
    csrw 0xa2e, x3

    #Address 0xa2e read value
    csrr x14, 0xa2e

    #Unmapped address 0x73b testing: Read Reset + Random data Write/Read
    #Address 0x73b read value
    csrr x14, 0x73b

    #Address 0x73b Write value 0x4793eb5a
    li x3, 0x4793eb5a
    csrw 0x73b, x3

    #Address 0x73b read value
    csrr x14, 0x73b

    #Unmapped address 0xd2d testing: Read Reset + Random data Write/Read
    #Address 0xd2d read value
    csrr x14, 0xd2d

    #Address 0xd2d Write value 0xb581cf3f
    li x3, 0xb581cf3f
    csrw 0xd2d, x3

    #Address 0xd2d read value
    csrr x14, 0xd2d

    #Unmapped address 0x768 testing: Read Reset + Random data Write/Read
    #Address 0x768 read value
    csrr x14, 0x768

    #Address 0x768 Write value 0x83850cdb
    li x3, 0x83850cdb
    csrw 0x768, x3

    #Address 0x768 read value
    csrr x14, 0x768

    #Unmapped address 0xf84 testing: Read Reset + Random data Write/Read
    #Address 0xf84 read value
    csrr x14, 0xf84

    #Address 0xf84 Write value 0x6ccbc98a
    li x3, 0x6ccbc98a
    csrw 0xf84, x3

    #Address 0xf84 read value
    csrr x14, 0xf84

    #Unmapped address 0xe0b testing: Read Reset + Random data Write/Read
    #Address 0xe0b read value
    csrr x14, 0xe0b

    #Address 0xe0b Write value 0x102da6df
    li x3, 0x102da6df
    csrw 0xe0b, x3

    #Address 0xe0b read value
    csrr x14, 0xe0b

    #Unmapped address 0x6ca testing: Read Reset + Random data Write/Read
    #Address 0x6ca read value
    csrr x14, 0x6ca

    #Address 0x6ca Write value 0x183c25e1
    li x3, 0x183c25e1
    csrw 0x6ca, x3

    #Address 0x6ca read value
    csrr x14, 0x6ca

    #Unmapped address 0x1bc testing: Read Reset + Random data Write/Read
    #Address 0x1bc read value
    csrr x14, 0x1bc

    #Address 0x1bc Write value 0x77cbbfd3
    li x3, 0x77cbbfd3
    csrw 0x1bc, x3

    #Address 0x1bc read value
    csrr x14, 0x1bc

    #Unmapped address 0x1cc testing: Read Reset + Random data Write/Read
    #Address 0x1cc read value
    csrr x14, 0x1cc

    #Address 0x1cc Write value 0xa0657618
    li x3, 0xa0657618
    csrw 0x1cc, x3

    #Address 0x1cc read value
    csrr x14, 0x1cc

    #Unmapped address 0x4ea testing: Read Reset + Random data Write/Read
    #Address 0x4ea read value
    csrr x14, 0x4ea

    #Address 0x4ea Write value 0xdcaf946c
    li x3, 0xdcaf946c
    csrw 0x4ea, x3

    #Address 0x4ea read value
    csrr x14, 0x4ea

    #Unmapped address 0xa9a testing: Read Reset + Random data Write/Read
    #Address 0xa9a read value
    csrr x14, 0xa9a

    #Address 0xa9a Write value 0x703377e4
    li x3, 0x703377e4
    csrw 0xa9a, x3

    #Address 0xa9a read value
    csrr x14, 0xa9a

    #Unmapped address 0xf63 testing: Read Reset + Random data Write/Read
    #Address 0xf63 read value
    csrr x14, 0xf63

    #Address 0xf63 Write value 0xa7b6bc0f
    li x3, 0xa7b6bc0f
    csrw 0xf63, x3

    #Address 0xf63 read value
    csrr x14, 0xf63

    #Unmapped address 0xf90 testing: Read Reset + Random data Write/Read
    #Address 0xf90 read value
    csrr x14, 0xf90

    #Address 0xf90 Write value 0x2a48776d
    li x3, 0x2a48776d
    csrw 0xf90, x3

    #Address 0xf90 read value
    csrr x14, 0xf90

    #Unmapped address 0x8d1 testing: Read Reset + Random data Write/Read
    #Address 0x8d1 read value
    csrr x14, 0x8d1

    #Address 0x8d1 Write value 0x5d7ae72f
    li x3, 0x5d7ae72f
    csrw 0x8d1, x3

    #Address 0x8d1 read value
    csrr x14, 0x8d1

    #Unmapped address 0xa9e testing: Read Reset + Random data Write/Read
    #Address 0xa9e read value
    csrr x14, 0xa9e

    #Address 0xa9e Write value 0x41ab0dc1
    li x3, 0x41ab0dc1
    csrw 0xa9e, x3

    #Address 0xa9e read value
    csrr x14, 0xa9e

    #Unmapped address 0x771 testing: Read Reset + Random data Write/Read
    #Address 0x771 read value
    csrr x14, 0x771

    #Address 0x771 Write value 0xe5255a19
    li x3, 0xe5255a19
    csrw 0x771, x3

    #Address 0x771 read value
    csrr x14, 0x771

    #Unmapped address 0x9e9 testing: Read Reset + Random data Write/Read
    #Address 0x9e9 read value
    csrr x14, 0x9e9

    #Address 0x9e9 Write value 0xf92844d8
    li x3, 0xf92844d8
    csrw 0x9e9, x3

    #Address 0x9e9 read value
    csrr x14, 0x9e9

    #Unmapped address 0x600 testing: Read Reset + Random data Write/Read
    #Address 0x600 read value
    csrr x14, 0x600

    #Address 0x600 Write value 0x989d0b55
    li x3, 0x989d0b55
    csrw 0x600, x3

    #Address 0x600 read value
    csrr x14, 0x600

    #Unmapped address 0xcc0 testing: Read Reset + Random data Write/Read
    #Address 0xcc0 read value
    csrr x14, 0xcc0

    #Address 0xcc0 Write value 0xe0330962
    li x3, 0xe0330962
    csrw 0xcc0, x3

    #Address 0xcc0 read value
    csrr x14, 0xcc0

    #Unmapped address 0x889 testing: Read Reset + Random data Write/Read
    #Address 0x889 read value
    csrr x14, 0x889

    #Address 0x889 Write value 0xb15124d4
    li x3, 0xb15124d4
    csrw 0x889, x3

    #Address 0x889 read value
    csrr x14, 0x889

    #Unmapped address 0x54f testing: Read Reset + Random data Write/Read
    #Address 0x54f read value
    csrr x14, 0x54f

    #Address 0x54f Write value 0x700564b4
    li x3, 0x700564b4
    csrw 0x54f, x3

    #Address 0x54f read value
    csrr x14, 0x54f

    #Unmapped address 0x255 testing: Read Reset + Random data Write/Read
    #Address 0x255 read value
    csrr x14, 0x255

    #Address 0x255 Write value 0x5e387848
    li x3, 0x5e387848
    csrw 0x255, x3

    #Address 0x255 read value
    csrr x14, 0x255

    #Unmapped address 0x2f9 testing: Read Reset + Random data Write/Read
    #Address 0x2f9 read value
    csrr x14, 0x2f9

    #Address 0x2f9 Write value 0xffbe9f63
    li x3, 0xffbe9f63
    csrw 0x2f9, x3

    #Address 0x2f9 read value
    csrr x14, 0x2f9

    #Unmapped address 0x8c testing: Read Reset + Random data Write/Read
    #Address 0x8c read value
    csrr x14, 0x8c

    #Address 0x8c Write value 0xb5d775e3
    li x3, 0xb5d775e3
    csrw 0x8c, x3

    #Address 0x8c read value
    csrr x14, 0x8c

    #Unmapped address 0x3e1 testing: Read Reset + Random data Write/Read
    #Address 0x3e1 read value
    csrr x14, 0x3e1

    #Address 0x3e1 Write value 0x65ce7ae0
    li x3, 0x65ce7ae0
    csrw 0x3e1, x3

    #Address 0x3e1 read value
    csrr x14, 0x3e1

    #Unmapped address 0x8ef testing: Read Reset + Random data Write/Read
    #Address 0x8ef read value
    csrr x14, 0x8ef

    #Address 0x8ef Write value 0x2f407909
    li x3, 0x2f407909
    csrw 0x8ef, x3

    #Address 0x8ef read value
    csrr x14, 0x8ef

    #Unmapped address 0xd2a testing: Read Reset + Random data Write/Read
    #Address 0xd2a read value
    csrr x14, 0xd2a

    #Address 0xd2a Write value 0xa08a9fea
    li x3, 0xa08a9fea
    csrw 0xd2a, x3

    #Address 0xd2a read value
    csrr x14, 0xd2a

    #Unmapped address 0x7b5 testing: Read Reset + Random data Write/Read
    #Address 0x7b5 read value
    csrr x14, 0x7b5

    #Address 0x7b5 Write value 0x77d2118a
    li x3, 0x77d2118a
    csrw 0x7b5, x3

    #Address 0x7b5 read value
    csrr x14, 0x7b5

    #Unmapped address 0xd14 testing: Read Reset + Random data Write/Read
    #Address 0xd14 read value
    csrr x14, 0xd14

    #Address 0xd14 Write value 0x4709ba40
    li x3, 0x4709ba40
    csrw 0xd14, x3

    #Address 0xd14 read value
    csrr x14, 0xd14

    #Unmapped address 0x61b testing: Read Reset + Random data Write/Read
    #Address 0x61b read value
    csrr x14, 0x61b

    #Address 0x61b Write value 0x1a285
    li x3, 0x1a285
    csrw 0x61b, x3

    #Address 0x61b read value
    csrr x14, 0x61b

    #Unmapped address 0xee testing: Read Reset + Random data Write/Read
    #Address 0xee read value
    csrr x14, 0xee

    #Address 0xee Write value 0x22174cd9
    li x3, 0x22174cd9
    csrw 0xee, x3

    #Address 0xee read value
    csrr x14, 0xee

    #Unmapped address 0x475 testing: Read Reset + Random data Write/Read
    #Address 0x475 read value
    csrr x14, 0x475

    #Address 0x475 Write value 0x32ae8033
    li x3, 0x32ae8033
    csrw 0x475, x3

    #Address 0x475 read value
    csrr x14, 0x475

    #Unmapped address 0x3cb testing: Read Reset + Random data Write/Read
    #Address 0x3cb read value
    csrr x14, 0x3cb

    #Address 0x3cb Write value 0xdc8fb5e1
    li x3, 0xdc8fb5e1
    csrw 0x3cb, x3

    #Address 0x3cb read value
    csrr x14, 0x3cb

    #Unmapped address 0x7c6 testing: Read Reset + Random data Write/Read
    #Address 0x7c6 read value
    csrr x14, 0x7c6

    #Address 0x7c6 Write value 0xf34e1506
    li x3, 0xf34e1506
    csrw 0x7c6, x3

    #Address 0x7c6 read value
    csrr x14, 0x7c6

    #Unmapped address 0xc8 testing: Read Reset + Random data Write/Read
    #Address 0xc8 read value
    csrr x14, 0xc8

    #Address 0xc8 Write value 0xb558482f
    li x3, 0xb558482f
    csrw 0xc8, x3

    #Address 0xc8 read value
    csrr x14, 0xc8

    #Unmapped address 0xdb2 testing: Read Reset + Random data Write/Read
    #Address 0xdb2 read value
    csrr x14, 0xdb2

    #Address 0xdb2 Write value 0x43efe068
    li x3, 0x43efe068
    csrw 0xdb2, x3

    #Address 0xdb2 read value
    csrr x14, 0xdb2

    #Unmapped address 0x845 testing: Read Reset + Random data Write/Read
    #Address 0x845 read value
    csrr x14, 0x845

    #Address 0x845 Write value 0xdb60408d
    li x3, 0xdb60408d
    csrw 0x845, x3

    #Address 0x845 read value
    csrr x14, 0x845

    #Unmapped address 0x833 testing: Read Reset + Random data Write/Read
    #Address 0x833 read value
    csrr x14, 0x833

    #Address 0x833 Write value 0x76dd7b03
    li x3, 0x76dd7b03
    csrw 0x833, x3

    #Address 0x833 read value
    csrr x14, 0x833

    #Unmapped address 0x8 testing: Read Reset + Random data Write/Read
    #Address 0x8 read value
    csrr x14, 0x8

    #Address 0x8 Write value 0x790ae6d8
    li x3, 0x790ae6d8
    csrw 0x8, x3

    #Address 0x8 read value
    csrr x14, 0x8

    #Unmapped address 0x11a testing: Read Reset + Random data Write/Read
    #Address 0x11a read value
    csrr x14, 0x11a

    #Address 0x11a Write value 0x1833bd90
    li x3, 0x1833bd90
    csrw 0x11a, x3

    #Address 0x11a read value
    csrr x14, 0x11a

    #Unmapped address 0xd33 testing: Read Reset + Random data Write/Read
    #Address 0xd33 read value
    csrr x14, 0xd33

    #Address 0xd33 Write value 0x666cb211
    li x3, 0x666cb211
    csrw 0xd33, x3

    #Address 0xd33 read value
    csrr x14, 0xd33

    #Unmapped address 0x8b9 testing: Read Reset + Random data Write/Read
    #Address 0x8b9 read value
    csrr x14, 0x8b9

    #Address 0x8b9 Write value 0x8ba5f023
    li x3, 0x8ba5f023
    csrw 0x8b9, x3

    #Address 0x8b9 read value
    csrr x14, 0x8b9

    #Unmapped address 0x8a0 testing: Read Reset + Random data Write/Read
    #Address 0x8a0 read value
    csrr x14, 0x8a0

    #Address 0x8a0 Write value 0xee444045
    li x3, 0xee444045
    csrw 0x8a0, x3

    #Address 0x8a0 read value
    csrr x14, 0x8a0

    #Unmapped address 0x7e5 testing: Read Reset + Random data Write/Read
    #Address 0x7e5 read value
    csrr x14, 0x7e5

    #Address 0x7e5 Write value 0x190d1c2b
    li x3, 0x190d1c2b
    csrw 0x7e5, x3

    #Address 0x7e5 read value
    csrr x14, 0x7e5

    #Unmapped address 0xe1c testing: Read Reset + Random data Write/Read
    #Address 0xe1c read value
    csrr x14, 0xe1c

    #Address 0xe1c Write value 0x5236eb83
    li x3, 0x5236eb83
    csrw 0xe1c, x3

    #Address 0xe1c read value
    csrr x14, 0xe1c

    #Unmapped address 0x550 testing: Read Reset + Random data Write/Read
    #Address 0x550 read value
    csrr x14, 0x550

    #Address 0x550 Write value 0xd6243bd9
    li x3, 0xd6243bd9
    csrw 0x550, x3

    #Address 0x550 read value
    csrr x14, 0x550

    #Unmapped address 0x7b3 testing: Read Reset + Random data Write/Read
    #Address 0x7b3 read value
    csrr x14, 0x7b3

    #Address 0x7b3 Write value 0xd2ea1537
    li x3, 0xd2ea1537
    csrw 0x7b3, x3

    #Address 0x7b3 read value
    csrr x14, 0x7b3

    #Unmapped address 0x1a5 testing: Read Reset + Random data Write/Read
    #Address 0x1a5 read value
    csrr x14, 0x1a5

    #Address 0x1a5 Write value 0xf070c6b1
    li x3, 0xf070c6b1
    csrw 0x1a5, x3

    #Address 0x1a5 read value
    csrr x14, 0x1a5

    #Unmapped address 0x191 testing: Read Reset + Random data Write/Read
    #Address 0x191 read value
    csrr x14, 0x191

    #Address 0x191 Write value 0x15dcb880
    li x3, 0x15dcb880
    csrw 0x191, x3

    #Address 0x191 read value
    csrr x14, 0x191

    #Unmapped address 0x18a testing: Read Reset + Random data Write/Read
    #Address 0x18a read value
    csrr x14, 0x18a

    #Address 0x18a Write value 0xf1183bf5
    li x3, 0xf1183bf5
    csrw 0x18a, x3

    #Address 0x18a read value
    csrr x14, 0x18a

    #Unmapped address 0x34d testing: Read Reset + Random data Write/Read
    #Address 0x34d read value
    csrr x14, 0x34d

    #Address 0x34d Write value 0xd029d1ca
    li x3, 0xd029d1ca
    csrw 0x34d, x3

    #Address 0x34d read value
    csrr x14, 0x34d

    #Unmapped address 0xb47 testing: Read Reset + Random data Write/Read
    #Address 0xb47 read value
    csrr x14, 0xb47

    #Address 0xb47 Write value 0xb31c96d
    li x3, 0xb31c96d
    csrw 0xb47, x3

    #Address 0xb47 read value
    csrr x14, 0xb47

    #Unmapped address 0x141 testing: Read Reset + Random data Write/Read
    #Address 0x141 read value
    csrr x14, 0x141

    #Address 0x141 Write value 0xf09afcff
    li x3, 0xf09afcff
    csrw 0x141, x3

    #Address 0x141 read value
    csrr x14, 0x141

    #Unmapped address 0x4f3 testing: Read Reset + Random data Write/Read
    #Address 0x4f3 read value
    csrr x14, 0x4f3

    #Address 0x4f3 Write value 0x35f26805
    li x3, 0x35f26805
    csrw 0x4f3, x3

    #Address 0x4f3 read value
    csrr x14, 0x4f3

    #Unmapped address 0x358 testing: Read Reset + Random data Write/Read
    #Address 0x358 read value
    csrr x14, 0x358

    #Address 0x358 Write value 0x86a8d2e8
    li x3, 0x86a8d2e8
    csrw 0x358, x3

    #Address 0x358 read value
    csrr x14, 0x358

    #Unmapped address 0xfef testing: Read Reset + Random data Write/Read
    #Address 0xfef read value
    csrr x14, 0xfef

    #Address 0xfef Write value 0xce65abad
    li x3, 0xce65abad
    csrw 0xfef, x3

    #Address 0xfef read value
    csrr x14, 0xfef

    #Unmapped address 0x7c8 testing: Read Reset + Random data Write/Read
    #Address 0x7c8 read value
    csrr x14, 0x7c8

    #Address 0x7c8 Write value 0x7121ccab
    li x3, 0x7121ccab
    csrw 0x7c8, x3

    #Address 0x7c8 read value
    csrr x14, 0x7c8

    #Unmapped address 0x4af testing: Read Reset + Random data Write/Read
    #Address 0x4af read value
    csrr x14, 0x4af

    #Address 0x4af Write value 0x528766d9
    li x3, 0x528766d9
    csrw 0x4af, x3

    #Address 0x4af read value
    csrr x14, 0x4af

    #Unmapped address 0x47e testing: Read Reset + Random data Write/Read
    #Address 0x47e read value
    csrr x14, 0x47e

    #Address 0x47e Write value 0xb394bae
    li x3, 0xb394bae
    csrw 0x47e, x3

    #Address 0x47e read value
    csrr x14, 0x47e

    #Unmapped address 0xc8a testing: Read Reset + Random data Write/Read
    #Address 0xc8a read value
    csrr x14, 0xc8a

    #Address 0xc8a Write value 0x475dfeea
    li x3, 0x475dfeea
    csrw 0xc8a, x3

    #Address 0xc8a read value
    csrr x14, 0xc8a

    #Unmapped address 0xdf0 testing: Read Reset + Random data Write/Read
    #Address 0xdf0 read value
    csrr x14, 0xdf0

    #Address 0xdf0 Write value 0x91d90818
    li x3, 0x91d90818
    csrw 0xdf0, x3

    #Address 0xdf0 read value
    csrr x14, 0xdf0

    #Unmapped address 0x70a testing: Read Reset + Random data Write/Read
    #Address 0x70a read value
    csrr x14, 0x70a

    #Address 0x70a Write value 0x8c2569a4
    li x3, 0x8c2569a4
    csrw 0x70a, x3

    #Address 0x70a read value
    csrr x14, 0x70a

    #Unmapped address 0xb4c testing: Read Reset + Random data Write/Read
    #Address 0xb4c read value
    csrr x14, 0xb4c

    #Address 0xb4c Write value 0x1b4f5c2
    li x3, 0x1b4f5c2
    csrw 0xb4c, x3

    #Address 0xb4c read value
    csrr x14, 0xb4c

    #Unmapped address 0xf9e testing: Read Reset + Random data Write/Read
    #Address 0xf9e read value
    csrr x14, 0xf9e

    #Address 0xf9e Write value 0x76b99f66
    li x3, 0x76b99f66
    csrw 0xf9e, x3

    #Address 0xf9e read value
    csrr x14, 0xf9e

    #Unmapped address 0x13 testing: Read Reset + Random data Write/Read
    #Address 0x13 read value
    csrr x14, 0x13

    #Address 0x13 Write value 0x9fef48d7
    li x3, 0x9fef48d7
    csrw 0x13, x3

    #Address 0x13 read value
    csrr x14, 0x13

    #Unmapped address 0x75b testing: Read Reset + Random data Write/Read
    #Address 0x75b read value
    csrr x14, 0x75b

    #Address 0x75b Write value 0x4b34b474
    li x3, 0x4b34b474
    csrw 0x75b, x3

    #Address 0x75b read value
    csrr x14, 0x75b

    #Unmapped address 0xd8d testing: Read Reset + Random data Write/Read
    #Address 0xd8d read value
    csrr x14, 0xd8d

    #Address 0xd8d Write value 0x249e3996
    li x3, 0x249e3996
    csrw 0xd8d, x3

    #Address 0xd8d read value
    csrr x14, 0xd8d

    #Unmapped address 0xd99 testing: Read Reset + Random data Write/Read
    #Address 0xd99 read value
    csrr x14, 0xd99

    #Address 0xd99 Write value 0xc2483b2a
    li x3, 0xc2483b2a
    csrw 0xd99, x3

    #Address 0xd99 read value
    csrr x14, 0xd99

    #Unmapped address 0xfd0 testing: Read Reset + Random data Write/Read
    #Address 0xfd0 read value
    csrr x14, 0xfd0

    #Address 0xfd0 Write value 0x400fa40
    li x3, 0x400fa40
    csrw 0xfd0, x3

    #Address 0xfd0 read value
    csrr x14, 0xfd0

    #Unmapped address 0xced testing: Read Reset + Random data Write/Read
    #Address 0xced read value
    csrr x14, 0xced

    #Address 0xced Write value 0xe8a88c66
    li x3, 0xe8a88c66
    csrw 0xced, x3

    #Address 0xced read value
    csrr x14, 0xced

    #Unmapped address 0xfc testing: Read Reset + Random data Write/Read
    #Address 0xfc read value
    csrr x14, 0xfc

    #Address 0xfc Write value 0x1e614868
    li x3, 0x1e614868
    csrw 0xfc, x3

    #Address 0xfc read value
    csrr x14, 0xfc

    #Unmapped address 0xb testing: Read Reset + Random data Write/Read
    #Address 0xb read value
    csrr x14, 0xb

    #Address 0xb Write value 0x276ee5b2
    li x3, 0x276ee5b2
    csrw 0xb, x3

    #Address 0xb read value
    csrr x14, 0xb

    #Unmapped address 0xe08 testing: Read Reset + Random data Write/Read
    #Address 0xe08 read value
    csrr x14, 0xe08

    #Address 0xe08 Write value 0x946f1626
    li x3, 0x946f1626
    csrw 0xe08, x3

    #Address 0xe08 read value
    csrr x14, 0xe08

    #Unmapped address 0x683 testing: Read Reset + Random data Write/Read
    #Address 0x683 read value
    csrr x14, 0x683

    #Address 0x683 Write value 0x1cdeb46
    li x3, 0x1cdeb46
    csrw 0x683, x3

    #Address 0x683 read value
    csrr x14, 0x683

    #Unmapped address 0x502 testing: Read Reset + Random data Write/Read
    #Address 0x502 read value
    csrr x14, 0x502

    #Address 0x502 Write value 0x9db5962f
    li x3, 0x9db5962f
    csrw 0x502, x3

    #Address 0x502 read value
    csrr x14, 0x502

    #Unmapped address 0xbde testing: Read Reset + Random data Write/Read
    #Address 0xbde read value
    csrr x14, 0xbde

    #Address 0xbde Write value 0x4a3d33e6
    li x3, 0x4a3d33e6
    csrw 0xbde, x3

    #Address 0xbde read value
    csrr x14, 0xbde

    #Unmapped address 0x6ae testing: Read Reset + Random data Write/Read
    #Address 0x6ae read value
    csrr x14, 0x6ae

    #Address 0x6ae Write value 0x6b852b15
    li x3, 0x6b852b15
    csrw 0x6ae, x3

    #Address 0x6ae read value
    csrr x14, 0x6ae

    #Unmapped address 0x4 testing: Read Reset + Random data Write/Read
    #Address 0x4 read value
    csrr x14, 0x4

    #Address 0x4 Write value 0x88b912d2
    li x3, 0x88b912d2
    csrw 0x4, x3

    #Address 0x4 read value
    csrr x14, 0x4

    #Unmapped address 0x52c testing: Read Reset + Random data Write/Read
    #Address 0x52c read value
    csrr x14, 0x52c

    #Address 0x52c Write value 0xee325aba
    li x3, 0xee325aba
    csrw 0x52c, x3

    #Address 0x52c read value
    csrr x14, 0x52c

    #Unmapped address 0xe02 testing: Read Reset + Random data Write/Read
    #Address 0xe02 read value
    csrr x14, 0xe02

    #Address 0xe02 Write value 0xc2b8df48
    li x3, 0xc2b8df48
    csrw 0xe02, x3

    #Address 0xe02 read value
    csrr x14, 0xe02

    #Unmapped address 0xc11 testing: Read Reset + Random data Write/Read
    #Address 0xc11 read value
    csrr x14, 0xc11

    #Address 0xc11 Write value 0x2d37e0d5
    li x3, 0x2d37e0d5
    csrw 0xc11, x3

    #Address 0xc11 read value
    csrr x14, 0xc11

    #Unmapped address 0xffe testing: Read Reset + Random data Write/Read
    #Address 0xffe read value
    csrr x14, 0xffe

    #Address 0xffe Write value 0x3f0b627
    li x3, 0x3f0b627
    csrw 0xffe, x3

    #Address 0xffe read value
    csrr x14, 0xffe

    #Unmapped address 0xb44 testing: Read Reset + Random data Write/Read
    #Address 0xb44 read value
    csrr x14, 0xb44

    #Address 0xb44 Write value 0x41c3213e
    li x3, 0x41c3213e
    csrw 0xb44, x3

    #Address 0xb44 read value
    csrr x14, 0xb44

    #Unmapped address 0xabb testing: Read Reset + Random data Write/Read
    #Address 0xabb read value
    csrr x14, 0xabb

    #Address 0xabb Write value 0x7d61d879
    li x3, 0x7d61d879
    csrw 0xabb, x3

    #Address 0xabb read value
    csrr x14, 0xabb

    #Unmapped address 0xf2d testing: Read Reset + Random data Write/Read
    #Address 0xf2d read value
    csrr x14, 0xf2d

    #Address 0xf2d Write value 0x4abd30fb
    li x3, 0x4abd30fb
    csrw 0xf2d, x3

    #Address 0xf2d read value
    csrr x14, 0xf2d

    #Unmapped address 0x410 testing: Read Reset + Random data Write/Read
    #Address 0x410 read value
    csrr x14, 0x410

    #Address 0x410 Write value 0x36f10996
    li x3, 0x36f10996
    csrw 0x410, x3

    #Address 0x410 read value
    csrr x14, 0x410

    #Unmapped address 0xaa2 testing: Read Reset + Random data Write/Read
    #Address 0xaa2 read value
    csrr x14, 0xaa2

    #Address 0xaa2 Write value 0x7a96f076
    li x3, 0x7a96f076
    csrw 0xaa2, x3

    #Address 0xaa2 read value
    csrr x14, 0xaa2

    #Unmapped address 0xdb7 testing: Read Reset + Random data Write/Read
    #Address 0xdb7 read value
    csrr x14, 0xdb7

    #Address 0xdb7 Write value 0xf2cd4815
    li x3, 0xf2cd4815
    csrw 0xdb7, x3

    #Address 0xdb7 read value
    csrr x14, 0xdb7

    #Unmapped address 0x79f testing: Read Reset + Random data Write/Read
    #Address 0x79f read value
    csrr x14, 0x79f

    #Address 0x79f Write value 0xb839d364
    li x3, 0xb839d364
    csrw 0x79f, x3

    #Address 0x79f read value
    csrr x14, 0x79f

    #Unmapped address 0xab5 testing: Read Reset + Random data Write/Read
    #Address 0xab5 read value
    csrr x14, 0xab5

    #Address 0xab5 Write value 0x7cd8da58
    li x3, 0x7cd8da58
    csrw 0xab5, x3

    #Address 0xab5 read value
    csrr x14, 0xab5

    #Unmapped address 0xaf7 testing: Read Reset + Random data Write/Read
    #Address 0xaf7 read value
    csrr x14, 0xaf7

    #Address 0xaf7 Write value 0xa0c33da3
    li x3, 0xa0c33da3
    csrw 0xaf7, x3

    #Address 0xaf7 read value
    csrr x14, 0xaf7

    #Unmapped address 0xdee testing: Read Reset + Random data Write/Read
    #Address 0xdee read value
    csrr x14, 0xdee

    #Address 0xdee Write value 0xb0048299
    li x3, 0xb0048299
    csrw 0xdee, x3

    #Address 0xdee read value
    csrr x14, 0xdee

    #Unmapped address 0x11c testing: Read Reset + Random data Write/Read
    #Address 0x11c read value
    csrr x14, 0x11c

    #Address 0x11c Write value 0x885d5ab5
    li x3, 0x885d5ab5
    csrw 0x11c, x3

    #Address 0x11c read value
    csrr x14, 0x11c

    #Unmapped address 0x424 testing: Read Reset + Random data Write/Read
    #Address 0x424 read value
    csrr x14, 0x424

    #Address 0x424 Write value 0xd465e8fc
    li x3, 0xd465e8fc
    csrw 0x424, x3

    #Address 0x424 read value
    csrr x14, 0x424

    #Unmapped address 0x73f testing: Read Reset + Random data Write/Read
    #Address 0x73f read value
    csrr x14, 0x73f

    #Address 0x73f Write value 0x1ba25151
    li x3, 0x1ba25151
    csrw 0x73f, x3

    #Address 0x73f read value
    csrr x14, 0x73f

    #Unmapped address 0x419 testing: Read Reset + Random data Write/Read
    #Address 0x419 read value
    csrr x14, 0x419

    #Address 0x419 Write value 0xd31e1994
    li x3, 0xd31e1994
    csrw 0x419, x3

    #Address 0x419 read value
    csrr x14, 0x419

    #Unmapped address 0xbd2 testing: Read Reset + Random data Write/Read
    #Address 0xbd2 read value
    csrr x14, 0xbd2

    #Address 0xbd2 Write value 0x7c193ea0
    li x3, 0x7c193ea0
    csrw 0xbd2, x3

    #Address 0xbd2 read value
    csrr x14, 0xbd2

    #Unmapped address 0xe1e testing: Read Reset + Random data Write/Read
    #Address 0xe1e read value
    csrr x14, 0xe1e

    #Address 0xe1e Write value 0xdaaf45ca
    li x3, 0xdaaf45ca
    csrw 0xe1e, x3

    #Address 0xe1e read value
    csrr x14, 0xe1e

    #Unmapped address 0x950 testing: Read Reset + Random data Write/Read
    #Address 0x950 read value
    csrr x14, 0x950

    #Address 0x950 Write value 0x4c8b1d4a
    li x3, 0x4c8b1d4a
    csrw 0x950, x3

    #Address 0x950 read value
    csrr x14, 0x950

    #Unmapped address 0xce3 testing: Read Reset + Random data Write/Read
    #Address 0xce3 read value
    csrr x14, 0xce3

    #Address 0xce3 Write value 0xe92609b8
    li x3, 0xe92609b8
    csrw 0xce3, x3

    #Address 0xce3 read value
    csrr x14, 0xce3

    #Unmapped address 0x64f testing: Read Reset + Random data Write/Read
    #Address 0x64f read value
    csrr x14, 0x64f

    #Address 0x64f Write value 0xc9be8522
    li x3, 0xc9be8522
    csrw 0x64f, x3

    #Address 0x64f read value
    csrr x14, 0x64f

    #Unmapped address 0x1f9 testing: Read Reset + Random data Write/Read
    #Address 0x1f9 read value
    csrr x14, 0x1f9

    #Address 0x1f9 Write value 0xa60c3cf
    li x3, 0xa60c3cf
    csrw 0x1f9, x3

    #Address 0x1f9 read value
    csrr x14, 0x1f9

    #Unmapped address 0x6f0 testing: Read Reset + Random data Write/Read
    #Address 0x6f0 read value
    csrr x14, 0x6f0

    #Address 0x6f0 Write value 0xb2acd2d1
    li x3, 0xb2acd2d1
    csrw 0x6f0, x3

    #Address 0x6f0 read value
    csrr x14, 0x6f0

    #Unmapped address 0xac3 testing: Read Reset + Random data Write/Read
    #Address 0xac3 read value
    csrr x14, 0xac3

    #Address 0xac3 Write value 0xf90164d7
    li x3, 0xf90164d7
    csrw 0xac3, x3

    #Address 0xac3 read value
    csrr x14, 0xac3

    #Unmapped address 0xf66 testing: Read Reset + Random data Write/Read
    #Address 0xf66 read value
    csrr x14, 0xf66

    #Address 0xf66 Write value 0x47cc97e1
    li x3, 0x47cc97e1
    csrw 0xf66, x3

    #Address 0xf66 read value
    csrr x14, 0xf66

    #Unmapped address 0xc2 testing: Read Reset + Random data Write/Read
    #Address 0xc2 read value
    csrr x14, 0xc2

    #Address 0xc2 Write value 0xc6f1e6d7
    li x3, 0xc6f1e6d7
    csrw 0xc2, x3

    #Address 0xc2 read value
    csrr x14, 0xc2

    #Unmapped address 0x2a4 testing: Read Reset + Random data Write/Read
    #Address 0x2a4 read value
    csrr x14, 0x2a4

    #Address 0x2a4 Write value 0xba2762c6
    li x3, 0xba2762c6
    csrw 0x2a4, x3

    #Address 0x2a4 read value
    csrr x14, 0x2a4

    #Unmapped address 0xeec testing: Read Reset + Random data Write/Read
    #Address 0xeec read value
    csrr x14, 0xeec

    #Address 0xeec Write value 0xf49a08fc
    li x3, 0xf49a08fc
    csrw 0xeec, x3

    #Address 0xeec read value
    csrr x14, 0xeec

    #Unmapped address 0xc44 testing: Read Reset + Random data Write/Read
    #Address 0xc44 read value
    csrr x14, 0xc44

    #Address 0xc44 Write value 0xcc77986a
    li x3, 0xcc77986a
    csrw 0xc44, x3

    #Address 0xc44 read value
    csrr x14, 0xc44

    #Unmapped address 0x909 testing: Read Reset + Random data Write/Read
    #Address 0x909 read value
    csrr x14, 0x909

    #Address 0x909 Write value 0x1d8c40b0
    li x3, 0x1d8c40b0
    csrw 0x909, x3

    #Address 0x909 read value
    csrr x14, 0x909

    #Unmapped address 0xfd4 testing: Read Reset + Random data Write/Read
    #Address 0xfd4 read value
    csrr x14, 0xfd4

    #Address 0xfd4 Write value 0x5ebb7490
    li x3, 0x5ebb7490
    csrw 0xfd4, x3

    #Address 0xfd4 read value
    csrr x14, 0xfd4

    #Unmapped address 0x676 testing: Read Reset + Random data Write/Read
    #Address 0x676 read value
    csrr x14, 0x676

    #Address 0x676 Write value 0xe14fc39b
    li x3, 0xe14fc39b
    csrw 0x676, x3

    #Address 0x676 read value
    csrr x14, 0x676

    #Unmapped address 0xae testing: Read Reset + Random data Write/Read
    #Address 0xae read value
    csrr x14, 0xae

    #Address 0xae Write value 0x2617db69
    li x3, 0x2617db69
    csrw 0xae, x3

    #Address 0xae read value
    csrr x14, 0xae

    #Unmapped address 0x284 testing: Read Reset + Random data Write/Read
    #Address 0x284 read value
    csrr x14, 0x284

    #Address 0x284 Write value 0x9dbd1d69
    li x3, 0x9dbd1d69
    csrw 0x284, x3

    #Address 0x284 read value
    csrr x14, 0x284

    #Unmapped address 0x8f2 testing: Read Reset + Random data Write/Read
    #Address 0x8f2 read value
    csrr x14, 0x8f2

    #Address 0x8f2 Write value 0xc4849ed7
    li x3, 0xc4849ed7
    csrw 0x8f2, x3

    #Address 0x8f2 read value
    csrr x14, 0x8f2

    #Unmapped address 0x87c testing: Read Reset + Random data Write/Read
    #Address 0x87c read value
    csrr x14, 0x87c

    #Address 0x87c Write value 0x7d9aa2ef
    li x3, 0x7d9aa2ef
    csrw 0x87c, x3

    #Address 0x87c read value
    csrr x14, 0x87c

    #Unmapped address 0xd4d testing: Read Reset + Random data Write/Read
    #Address 0xd4d read value
    csrr x14, 0xd4d

    #Address 0xd4d Write value 0x429ed432
    li x3, 0x429ed432
    csrw 0xd4d, x3

    #Address 0xd4d read value
    csrr x14, 0xd4d

    #Unmapped address 0xbaa testing: Read Reset + Random data Write/Read
    #Address 0xbaa read value
    csrr x14, 0xbaa

    #Address 0xbaa Write value 0x9d3b10e0
    li x3, 0x9d3b10e0
    csrw 0xbaa, x3

    #Address 0xbaa read value
    csrr x14, 0xbaa

    #Unmapped address 0x22 testing: Read Reset + Random data Write/Read
    #Address 0x22 read value
    csrr x14, 0x22

    #Address 0x22 Write value 0xdf29b5ba
    li x3, 0xdf29b5ba
    csrw 0x22, x3

    #Address 0x22 read value
    csrr x14, 0x22

    #Unmapped address 0x532 testing: Read Reset + Random data Write/Read
    #Address 0x532 read value
    csrr x14, 0x532

    #Address 0x532 Write value 0x53c447dc
    li x3, 0x53c447dc
    csrw 0x532, x3

    #Address 0x532 read value
    csrr x14, 0x532

    #Unmapped address 0x98e testing: Read Reset + Random data Write/Read
    #Address 0x98e read value
    csrr x14, 0x98e

    #Address 0x98e Write value 0xecacf486
    li x3, 0xecacf486
    csrw 0x98e, x3

    #Address 0x98e read value
    csrr x14, 0x98e

    #Unmapped address 0xf70 testing: Read Reset + Random data Write/Read
    #Address 0xf70 read value
    csrr x14, 0xf70

    #Address 0xf70 Write value 0x325eae20
    li x3, 0x325eae20
    csrw 0xf70, x3

    #Address 0xf70 read value
    csrr x14, 0xf70

    #Unmapped address 0x917 testing: Read Reset + Random data Write/Read
    #Address 0x917 read value
    csrr x14, 0x917

    #Address 0x917 Write value 0x2f10f661
    li x3, 0x2f10f661
    csrw 0x917, x3

    #Address 0x917 read value
    csrr x14, 0x917

    #Unmapped address 0xabc testing: Read Reset + Random data Write/Read
    #Address 0xabc read value
    csrr x14, 0xabc

    #Address 0xabc Write value 0x5b1f833f
    li x3, 0x5b1f833f
    csrw 0xabc, x3

    #Address 0xabc read value
    csrr x14, 0xabc

    #Unmapped address 0xd84 testing: Read Reset + Random data Write/Read
    #Address 0xd84 read value
    csrr x14, 0xd84

    #Address 0xd84 Write value 0xa420f720
    li x3, 0xa420f720
    csrw 0xd84, x3

    #Address 0xd84 read value
    csrr x14, 0xd84

    #Unmapped address 0x510 testing: Read Reset + Random data Write/Read
    #Address 0x510 read value
    csrr x14, 0x510

    #Address 0x510 Write value 0xb7daf90d
    li x3, 0xb7daf90d
    csrw 0x510, x3

    #Address 0x510 read value
    csrr x14, 0x510

    #Unmapped address 0x9cc testing: Read Reset + Random data Write/Read
    #Address 0x9cc read value
    csrr x14, 0x9cc

    #Address 0x9cc Write value 0xd3e97b60
    li x3, 0xd3e97b60
    csrw 0x9cc, x3

    #Address 0x9cc read value
    csrr x14, 0x9cc

    #Unmapped address 0x9c7 testing: Read Reset + Random data Write/Read
    #Address 0x9c7 read value
    csrr x14, 0x9c7

    #Address 0x9c7 Write value 0x7e4cbf0
    li x3, 0x7e4cbf0
    csrw 0x9c7, x3

    #Address 0x9c7 read value
    csrr x14, 0x9c7

    #Unmapped address 0x204 testing: Read Reset + Random data Write/Read
    #Address 0x204 read value
    csrr x14, 0x204

    #Address 0x204 Write value 0x196edadd
    li x3, 0x196edadd
    csrw 0x204, x3

    #Address 0x204 read value
    csrr x14, 0x204

    #Unmapped address 0x30c testing: Read Reset + Random data Write/Read
    #Address 0x30c read value
    csrr x14, 0x30c

    #Address 0x30c Write value 0xd2ea0af1
    li x3, 0xd2ea0af1
    csrw 0x30c, x3

    #Address 0x30c read value
    csrr x14, 0x30c

    #Unmapped address 0xcf2 testing: Read Reset + Random data Write/Read
    #Address 0xcf2 read value
    csrr x14, 0xcf2

    #Address 0xcf2 Write value 0x91fc61b9
    li x3, 0x91fc61b9
    csrw 0xcf2, x3

    #Address 0xcf2 read value
    csrr x14, 0xcf2

    #Unmapped address 0xe89 testing: Read Reset + Random data Write/Read
    #Address 0xe89 read value
    csrr x14, 0xe89

    #Address 0xe89 Write value 0xf051f529
    li x3, 0xf051f529
    csrw 0xe89, x3

    #Address 0xe89 read value
    csrr x14, 0xe89

    #Unmapped address 0xf4e testing: Read Reset + Random data Write/Read
    #Address 0xf4e read value
    csrr x14, 0xf4e

    #Address 0xf4e Write value 0x6c536a7c
    li x3, 0x6c536a7c
    csrw 0xf4e, x3

    #Address 0xf4e read value
    csrr x14, 0xf4e

    #Unmapped address 0xc42 testing: Read Reset + Random data Write/Read
    #Address 0xc42 read value
    csrr x14, 0xc42

    #Address 0xc42 Write value 0x22cd85b1
    li x3, 0x22cd85b1
    csrw 0xc42, x3

    #Address 0xc42 read value
    csrr x14, 0xc42

    #Unmapped address 0xe18 testing: Read Reset + Random data Write/Read
    #Address 0xe18 read value
    csrr x14, 0xe18

    #Address 0xe18 Write value 0x391f1ef6
    li x3, 0x391f1ef6
    csrw 0xe18, x3

    #Address 0xe18 read value
    csrr x14, 0xe18

    #Unmapped address 0x85a testing: Read Reset + Random data Write/Read
    #Address 0x85a read value
    csrr x14, 0x85a

    #Address 0x85a Write value 0x125cdf45
    li x3, 0x125cdf45
    csrw 0x85a, x3

    #Address 0x85a read value
    csrr x14, 0x85a

    #Unmapped address 0x9f2 testing: Read Reset + Random data Write/Read
    #Address 0x9f2 read value
    csrr x14, 0x9f2

    #Address 0x9f2 Write value 0xcf06bd77
    li x3, 0xcf06bd77
    csrw 0x9f2, x3

    #Address 0x9f2 read value
    csrr x14, 0x9f2

    #Unmapped address 0x164 testing: Read Reset + Random data Write/Read
    #Address 0x164 read value
    csrr x14, 0x164

    #Address 0x164 Write value 0x5e07938c
    li x3, 0x5e07938c
    csrw 0x164, x3

    #Address 0x164 read value
    csrr x14, 0x164

    #Unmapped address 0xf52 testing: Read Reset + Random data Write/Read
    #Address 0xf52 read value
    csrr x14, 0xf52

    #Address 0xf52 Write value 0xc46f077c
    li x3, 0xc46f077c
    csrw 0xf52, x3

    #Address 0xf52 read value
    csrr x14, 0xf52

    #Unmapped address 0xc7a testing: Read Reset + Random data Write/Read
    #Address 0xc7a read value
    csrr x14, 0xc7a

    #Address 0xc7a Write value 0x675762ef
    li x3, 0x675762ef
    csrw 0xc7a, x3

    #Address 0xc7a read value
    csrr x14, 0xc7a

    #Unmapped address 0x10d testing: Read Reset + Random data Write/Read
    #Address 0x10d read value
    csrr x14, 0x10d

    #Address 0x10d Write value 0xa10ef83a
    li x3, 0xa10ef83a
    csrw 0x10d, x3

    #Address 0x10d read value
    csrr x14, 0x10d

    #Unmapped address 0x88f testing: Read Reset + Random data Write/Read
    #Address 0x88f read value
    csrr x14, 0x88f

    #Address 0x88f Write value 0xb232ce7d
    li x3, 0xb232ce7d
    csrw 0x88f, x3

    #Address 0x88f read value
    csrr x14, 0x88f

    #Unmapped address 0xe40 testing: Read Reset + Random data Write/Read
    #Address 0xe40 read value
    csrr x14, 0xe40

    #Address 0xe40 Write value 0xe95b1559
    li x3, 0xe95b1559
    csrw 0xe40, x3

    #Address 0xe40 read value
    csrr x14, 0xe40

    #Unmapped address 0x192 testing: Read Reset + Random data Write/Read
    #Address 0x192 read value
    csrr x14, 0x192

    #Address 0x192 Write value 0x65e44e37
    li x3, 0x65e44e37
    csrw 0x192, x3

    #Address 0x192 read value
    csrr x14, 0x192

    #Unmapped address 0x43a testing: Read Reset + Random data Write/Read
    #Address 0x43a read value
    csrr x14, 0x43a

    #Address 0x43a Write value 0xf1e0e6aa
    li x3, 0xf1e0e6aa
    csrw 0x43a, x3

    #Address 0x43a read value
    csrr x14, 0x43a

    #Unmapped address 0xf8f testing: Read Reset + Random data Write/Read
    #Address 0xf8f read value
    csrr x14, 0xf8f

    #Address 0xf8f Write value 0x7bf21f0c
    li x3, 0x7bf21f0c
    csrw 0xf8f, x3

    #Address 0xf8f read value
    csrr x14, 0xf8f

    #Unmapped address 0xa41 testing: Read Reset + Random data Write/Read
    #Address 0xa41 read value
    csrr x14, 0xa41

    #Address 0xa41 Write value 0xc2fa7f18
    li x3, 0xc2fa7f18
    csrw 0xa41, x3

    #Address 0xa41 read value
    csrr x14, 0xa41

    #Unmapped address 0x270 testing: Read Reset + Random data Write/Read
    #Address 0x270 read value
    csrr x14, 0x270

    #Address 0x270 Write value 0xbc979609
    li x3, 0xbc979609
    csrw 0x270, x3

    #Address 0x270 read value
    csrr x14, 0x270

    #Unmapped address 0xa2f testing: Read Reset + Random data Write/Read
    #Address 0xa2f read value
    csrr x14, 0xa2f

    #Address 0xa2f Write value 0x6d6f9b70
    li x3, 0x6d6f9b70
    csrw 0xa2f, x3

    #Address 0xa2f read value
    csrr x14, 0xa2f

    #Unmapped address 0x7a7 testing: Read Reset + Random data Write/Read
    #Address 0x7a7 read value
    csrr x14, 0x7a7

    #Address 0x7a7 Write value 0xd1917996
    li x3, 0xd1917996
    csrw 0x7a7, x3

    #Address 0x7a7 read value
    csrr x14, 0x7a7

    #Unmapped address 0x58a testing: Read Reset + Random data Write/Read
    #Address 0x58a read value
    csrr x14, 0x58a

    #Address 0x58a Write value 0xd33b928d
    li x3, 0xd33b928d
    csrw 0x58a, x3

    #Address 0x58a read value
    csrr x14, 0x58a

    #Unmapped address 0x127 testing: Read Reset + Random data Write/Read
    #Address 0x127 read value
    csrr x14, 0x127

    #Address 0x127 Write value 0x6ac95fd5
    li x3, 0x6ac95fd5
    csrw 0x127, x3

    #Address 0x127 read value
    csrr x14, 0x127

    #Unmapped address 0x90c testing: Read Reset + Random data Write/Read
    #Address 0x90c read value
    csrr x14, 0x90c

    #Address 0x90c Write value 0x910f7844
    li x3, 0x910f7844
    csrw 0x90c, x3

    #Address 0x90c read value
    csrr x14, 0x90c

    #Unmapped address 0xcdb testing: Read Reset + Random data Write/Read
    #Address 0xcdb read value
    csrr x14, 0xcdb

    #Address 0xcdb Write value 0x571bc8c4
    li x3, 0x571bc8c4
    csrw 0xcdb, x3

    #Address 0xcdb read value
    csrr x14, 0xcdb

    #Unmapped address 0x19c testing: Read Reset + Random data Write/Read
    #Address 0x19c read value
    csrr x14, 0x19c

    #Address 0x19c Write value 0xda2695a6
    li x3, 0xda2695a6
    csrw 0x19c, x3

    #Address 0x19c read value
    csrr x14, 0x19c

    #Unmapped address 0x659 testing: Read Reset + Random data Write/Read
    #Address 0x659 read value
    csrr x14, 0x659

    #Address 0x659 Write value 0x97f58bdc
    li x3, 0x97f58bdc
    csrw 0x659, x3

    #Address 0x659 read value
    csrr x14, 0x659

    #Unmapped address 0x7d2 testing: Read Reset + Random data Write/Read
    #Address 0x7d2 read value
    csrr x14, 0x7d2

    #Address 0x7d2 Write value 0xc2453077
    li x3, 0xc2453077
    csrw 0x7d2, x3

    #Address 0x7d2 read value
    csrr x14, 0x7d2

    #Unmapped address 0xe98 testing: Read Reset + Random data Write/Read
    #Address 0xe98 read value
    csrr x14, 0xe98

    #Address 0xe98 Write value 0xf95687bc
    li x3, 0xf95687bc
    csrw 0xe98, x3

    #Address 0xe98 read value
    csrr x14, 0xe98

    #Unmapped address 0x3a9 testing: Read Reset + Random data Write/Read
    #Address 0x3a9 read value
    csrr x14, 0x3a9

    #Address 0x3a9 Write value 0xc1c17f40
    li x3, 0xc1c17f40
    csrw 0x3a9, x3

    #Address 0x3a9 read value
    csrr x14, 0x3a9

    #Unmapped address 0xcff testing: Read Reset + Random data Write/Read
    #Address 0xcff read value
    csrr x14, 0xcff

    #Address 0xcff Write value 0x47d228d9
    li x3, 0x47d228d9
    csrw 0xcff, x3

    #Address 0xcff read value
    csrr x14, 0xcff

    #Unmapped address 0x23 testing: Read Reset + Random data Write/Read
    #Address 0x23 read value
    csrr x14, 0x23

    #Address 0x23 Write value 0x437d803c
    li x3, 0x437d803c
    csrw 0x23, x3

    #Address 0x23 read value
    csrr x14, 0x23

    #Unmapped address 0x31 testing: Read Reset + Random data Write/Read
    #Address 0x31 read value
    csrr x14, 0x31

    #Address 0x31 Write value 0x3e2d9e21
    li x3, 0x3e2d9e21
    csrw 0x31, x3

    #Address 0x31 read value
    csrr x14, 0x31

    #Unmapped address 0x322 testing: Read Reset + Random data Write/Read
    #Address 0x322 read value
    csrr x14, 0x322

    #Address 0x322 Write value 0x7a41067a
    li x3, 0x7a41067a
    csrw 0x322, x3

    #Address 0x322 read value
    csrr x14, 0x322

    #Unmapped address 0xdf4 testing: Read Reset + Random data Write/Read
    #Address 0xdf4 read value
    csrr x14, 0xdf4

    #Address 0xdf4 Write value 0x3e6fb4fd
    li x3, 0x3e6fb4fd
    csrw 0xdf4, x3

    #Address 0xdf4 read value
    csrr x14, 0xdf4

    #Unmapped address 0xf5a testing: Read Reset + Random data Write/Read
    #Address 0xf5a read value
    csrr x14, 0xf5a

    #Address 0xf5a Write value 0xc6588eca
    li x3, 0xc6588eca
    csrw 0xf5a, x3

    #Address 0xf5a read value
    csrr x14, 0xf5a

    #Unmapped address 0xe70 testing: Read Reset + Random data Write/Read
    #Address 0xe70 read value
    csrr x14, 0xe70

    #Address 0xe70 Write value 0x251f9860
    li x3, 0x251f9860
    csrw 0xe70, x3

    #Address 0xe70 read value
    csrr x14, 0xe70

    #Unmapped address 0x687 testing: Read Reset + Random data Write/Read
    #Address 0x687 read value
    csrr x14, 0x687

    #Address 0x687 Write value 0x6e665977
    li x3, 0x6e665977
    csrw 0x687, x3

    #Address 0x687 read value
    csrr x14, 0x687

    #Unmapped address 0xcb2 testing: Read Reset + Random data Write/Read
    #Address 0xcb2 read value
    csrr x14, 0xcb2

    #Address 0xcb2 Write value 0x365301bb
    li x3, 0x365301bb
    csrw 0xcb2, x3

    #Address 0xcb2 read value
    csrr x14, 0xcb2

    #Unmapped address 0x51d testing: Read Reset + Random data Write/Read
    #Address 0x51d read value
    csrr x14, 0x51d

    #Address 0x51d Write value 0x9eb4fea8
    li x3, 0x9eb4fea8
    csrw 0x51d, x3

    #Address 0x51d read value
    csrr x14, 0x51d

    #Unmapped address 0x15d testing: Read Reset + Random data Write/Read
    #Address 0x15d read value
    csrr x14, 0x15d

    #Address 0x15d Write value 0x56fef85c
    li x3, 0x56fef85c
    csrw 0x15d, x3

    #Address 0x15d read value
    csrr x14, 0x15d

    #Unmapped address 0x472 testing: Read Reset + Random data Write/Read
    #Address 0x472 read value
    csrr x14, 0x472

    #Address 0x472 Write value 0x142f88c9
    li x3, 0x142f88c9
    csrw 0x472, x3

    #Address 0x472 read value
    csrr x14, 0x472

    #Unmapped address 0x713 testing: Read Reset + Random data Write/Read
    #Address 0x713 read value
    csrr x14, 0x713

    #Address 0x713 Write value 0x7b6f377d
    li x3, 0x7b6f377d
    csrw 0x713, x3

    #Address 0x713 read value
    csrr x14, 0x713

    #Unmapped address 0xc93 testing: Read Reset + Random data Write/Read
    #Address 0xc93 read value
    csrr x14, 0xc93

    #Address 0xc93 Write value 0xad138a80
    li x3, 0xad138a80
    csrw 0xc93, x3

    #Address 0xc93 read value
    csrr x14, 0xc93

    #Unmapped address 0xf3a testing: Read Reset + Random data Write/Read
    #Address 0xf3a read value
    csrr x14, 0xf3a

    #Address 0xf3a Write value 0x618b80
    li x3, 0x618b80
    csrw 0xf3a, x3

    #Address 0xf3a read value
    csrr x14, 0xf3a

    #Unmapped address 0x317 testing: Read Reset + Random data Write/Read
    #Address 0x317 read value
    csrr x14, 0x317

    #Address 0x317 Write value 0x3f65b043
    li x3, 0x3f65b043
    csrw 0x317, x3

    #Address 0x317 read value
    csrr x14, 0x317

    #Unmapped address 0xce8 testing: Read Reset + Random data Write/Read
    #Address 0xce8 read value
    csrr x14, 0xce8

    #Address 0xce8 Write value 0x9d618c0c
    li x3, 0x9d618c0c
    csrw 0xce8, x3

    #Address 0xce8 read value
    csrr x14, 0xce8

    #Unmapped address 0x891 testing: Read Reset + Random data Write/Read
    #Address 0x891 read value
    csrr x14, 0x891

    #Address 0x891 Write value 0x2577e281
    li x3, 0x2577e281
    csrw 0x891, x3

    #Address 0x891 read value
    csrr x14, 0x891

    #Unmapped address 0x15b testing: Read Reset + Random data Write/Read
    #Address 0x15b read value
    csrr x14, 0x15b

    #Address 0x15b Write value 0x368ac69e
    li x3, 0x368ac69e
    csrw 0x15b, x3

    #Address 0x15b read value
    csrr x14, 0x15b

    #Unmapped address 0x99 testing: Read Reset + Random data Write/Read
    #Address 0x99 read value
    csrr x14, 0x99

    #Address 0x99 Write value 0x4e516db
    li x3, 0x4e516db
    csrw 0x99, x3

    #Address 0x99 read value
    csrr x14, 0x99

    #Unmapped address 0xbb8 testing: Read Reset + Random data Write/Read
    #Address 0xbb8 read value
    csrr x14, 0xbb8

    #Address 0xbb8 Write value 0x8ca44ce9
    li x3, 0x8ca44ce9
    csrw 0xbb8, x3

    #Address 0xbb8 read value
    csrr x14, 0xbb8

    #Unmapped address 0x4c8 testing: Read Reset + Random data Write/Read
    #Address 0x4c8 read value
    csrr x14, 0x4c8

    #Address 0x4c8 Write value 0x736ebffa
    li x3, 0x736ebffa
    csrw 0x4c8, x3

    #Address 0x4c8 read value
    csrr x14, 0x4c8

    #Unmapped address 0x9e1 testing: Read Reset + Random data Write/Read
    #Address 0x9e1 read value
    csrr x14, 0x9e1

    #Address 0x9e1 Write value 0xddab1a3f
    li x3, 0xddab1a3f
    csrw 0x9e1, x3

    #Address 0x9e1 read value
    csrr x14, 0x9e1

    #Unmapped address 0xd9f testing: Read Reset + Random data Write/Read
    #Address 0xd9f read value
    csrr x14, 0xd9f

    #Address 0xd9f Write value 0x644d1114
    li x3, 0x644d1114
    csrw 0xd9f, x3

    #Address 0xd9f read value
    csrr x14, 0xd9f

    #Unmapped address 0x7c1 testing: Read Reset + Random data Write/Read
    #Address 0x7c1 read value
    csrr x14, 0x7c1

    #Address 0x7c1 Write value 0x36d9c5d3
    li x3, 0x36d9c5d3
    csrw 0x7c1, x3

    #Address 0x7c1 read value
    csrr x14, 0x7c1

    #Unmapped address 0xfc9 testing: Read Reset + Random data Write/Read
    #Address 0xfc9 read value
    csrr x14, 0xfc9

    #Address 0xfc9 Write value 0x821bc611
    li x3, 0x821bc611
    csrw 0xfc9, x3

    #Address 0xfc9 read value
    csrr x14, 0xfc9

    #Unmapped address 0xf25 testing: Read Reset + Random data Write/Read
    #Address 0xf25 read value
    csrr x14, 0xf25

    #Address 0xf25 Write value 0x5cc0bad7
    li x3, 0x5cc0bad7
    csrw 0xf25, x3

    #Address 0xf25 read value
    csrr x14, 0xf25

    #Unmapped address 0x546 testing: Read Reset + Random data Write/Read
    #Address 0x546 read value
    csrr x14, 0x546

    #Address 0x546 Write value 0x2e333328
    li x3, 0x2e333328
    csrw 0x546, x3

    #Address 0x546 read value
    csrr x14, 0x546

    #Unmapped address 0xa7a testing: Read Reset + Random data Write/Read
    #Address 0xa7a read value
    csrr x14, 0xa7a

    #Address 0xa7a Write value 0xc45c3967
    li x3, 0xc45c3967
    csrw 0xa7a, x3

    #Address 0xa7a read value
    csrr x14, 0xa7a

    #Unmapped address 0x64 testing: Read Reset + Random data Write/Read
    #Address 0x64 read value
    csrr x14, 0x64

    #Address 0x64 Write value 0x5cc6c5db
    li x3, 0x5cc6c5db
    csrw 0x64, x3

    #Address 0x64 read value
    csrr x14, 0x64

    #Unmapped address 0x743 testing: Read Reset + Random data Write/Read
    #Address 0x743 read value
    csrr x14, 0x743

    #Address 0x743 Write value 0x2f22c1ea
    li x3, 0x2f22c1ea
    csrw 0x743, x3

    #Address 0x743 read value
    csrr x14, 0x743

    #Unmapped address 0x7fe testing: Read Reset + Random data Write/Read
    #Address 0x7fe read value
    csrr x14, 0x7fe

    #Address 0x7fe Write value 0x389e6ab
    li x3, 0x389e6ab
    csrw 0x7fe, x3

    #Address 0x7fe read value
    csrr x14, 0x7fe

    #Unmapped address 0xeea testing: Read Reset + Random data Write/Read
    #Address 0xeea read value
    csrr x14, 0xeea

    #Address 0xeea Write value 0x1325b9f1
    li x3, 0x1325b9f1
    csrw 0xeea, x3

    #Address 0xeea read value
    csrr x14, 0xeea

    #Unmapped address 0x93d testing: Read Reset + Random data Write/Read
    #Address 0x93d read value
    csrr x14, 0x93d

    #Address 0x93d Write value 0x5635b706
    li x3, 0x5635b706
    csrw 0x93d, x3

    #Address 0x93d read value
    csrr x14, 0x93d

    #Unmapped address 0xbcd testing: Read Reset + Random data Write/Read
    #Address 0xbcd read value
    csrr x14, 0xbcd

    #Address 0xbcd Write value 0xf9d8f892
    li x3, 0xf9d8f892
    csrw 0xbcd, x3

    #Address 0xbcd read value
    csrr x14, 0xbcd

    #Unmapped address 0xe29 testing: Read Reset + Random data Write/Read
    #Address 0xe29 read value
    csrr x14, 0xe29

    #Address 0xe29 Write value 0x46d736b9
    li x3, 0x46d736b9
    csrw 0xe29, x3

    #Address 0xe29 read value
    csrr x14, 0xe29

    #Unmapped address 0xca8 testing: Read Reset + Random data Write/Read
    #Address 0xca8 read value
    csrr x14, 0xca8

    #Address 0xca8 Write value 0xe2f50b57
    li x3, 0xe2f50b57
    csrw 0xca8, x3

    #Address 0xca8 read value
    csrr x14, 0xca8

    #Unmapped address 0x668 testing: Read Reset + Random data Write/Read
    #Address 0x668 read value
    csrr x14, 0x668

    #Address 0x668 Write value 0x1298b844
    li x3, 0x1298b844
    csrw 0x668, x3

    #Address 0x668 read value
    csrr x14, 0x668

    #Unmapped address 0xe27 testing: Read Reset + Random data Write/Read
    #Address 0xe27 read value
    csrr x14, 0xe27

    #Address 0xe27 Write value 0x49e8a00b
    li x3, 0x49e8a00b
    csrw 0xe27, x3

    #Address 0xe27 read value
    csrr x14, 0xe27

    #Unmapped address 0x2ff testing: Read Reset + Random data Write/Read
    #Address 0x2ff read value
    csrr x14, 0x2ff

    #Address 0x2ff Write value 0xd412e65e
    li x3, 0xd412e65e
    csrw 0x2ff, x3

    #Address 0x2ff read value
    csrr x14, 0x2ff

    #Unmapped address 0xb38 testing: Read Reset + Random data Write/Read
    #Address 0xb38 read value
    csrr x14, 0xb38

    #Address 0xb38 Write value 0x82178e9d
    li x3, 0x82178e9d
    csrw 0xb38, x3

    #Address 0xb38 read value
    csrr x14, 0xb38

    #Unmapped address 0x7a9 testing: Read Reset + Random data Write/Read
    #Address 0x7a9 read value
    csrr x14, 0x7a9

    #Address 0x7a9 Write value 0x31ab7697
    li x3, 0x31ab7697
    csrw 0x7a9, x3

    #Address 0x7a9 read value
    csrr x14, 0x7a9

    #Unmapped address 0x1c9 testing: Read Reset + Random data Write/Read
    #Address 0x1c9 read value
    csrr x14, 0x1c9

    #Address 0x1c9 Write value 0xd93cb7dd
    li x3, 0xd93cb7dd
    csrw 0x1c9, x3

    #Address 0x1c9 read value
    csrr x14, 0x1c9

    #Unmapped address 0xc76 testing: Read Reset + Random data Write/Read
    #Address 0xc76 read value
    csrr x14, 0xc76

    #Address 0xc76 Write value 0x7ee4f2a8
    li x3, 0x7ee4f2a8
    csrw 0xc76, x3

    #Address 0xc76 read value
    csrr x14, 0xc76

    #Unmapped address 0xdac testing: Read Reset + Random data Write/Read
    #Address 0xdac read value
    csrr x14, 0xdac

    #Address 0xdac Write value 0x7602430a
    li x3, 0x7602430a
    csrw 0xdac, x3

    #Address 0xdac read value
    csrr x14, 0xdac

    #Unmapped address 0xf1e testing: Read Reset + Random data Write/Read
    #Address 0xf1e read value
    csrr x14, 0xf1e

    #Address 0xf1e Write value 0xd90eb0a
    li x3, 0xd90eb0a
    csrw 0xf1e, x3

    #Address 0xf1e read value
    csrr x14, 0xf1e

    #Unmapped address 0xe84 testing: Read Reset + Random data Write/Read
    #Address 0xe84 read value
    csrr x14, 0xe84

    #Address 0xe84 Write value 0xcfb8f752
    li x3, 0xcfb8f752
    csrw 0xe84, x3

    #Address 0xe84 read value
    csrr x14, 0xe84

    #Unmapped address 0x922 testing: Read Reset + Random data Write/Read
    #Address 0x922 read value
    csrr x14, 0x922

    #Address 0x922 Write value 0xd80b38c
    li x3, 0xd80b38c
    csrw 0x922, x3

    #Address 0x922 read value
    csrr x14, 0x922

    #Unmapped address 0x6c8 testing: Read Reset + Random data Write/Read
    #Address 0x6c8 read value
    csrr x14, 0x6c8

    #Address 0x6c8 Write value 0xffe174ea
    li x3, 0xffe174ea
    csrw 0x6c8, x3

    #Address 0x6c8 read value
    csrr x14, 0x6c8

    #Unmapped address 0x37b testing: Read Reset + Random data Write/Read
    #Address 0x37b read value
    csrr x14, 0x37b

    #Address 0x37b Write value 0x261564e5
    li x3, 0x261564e5
    csrw 0x37b, x3

    #Address 0x37b read value
    csrr x14, 0x37b

    #Unmapped address 0xb23 testing: Read Reset + Random data Write/Read
    #Address 0xb23 read value
    csrr x14, 0xb23

    #Address 0xb23 Write value 0xa3810dc0
    li x3, 0xa3810dc0
    csrw 0xb23, x3

    #Address 0xb23 read value
    csrr x14, 0xb23

    #Unmapped address 0xe83 testing: Read Reset + Random data Write/Read
    #Address 0xe83 read value
    csrr x14, 0xe83

    #Address 0xe83 Write value 0xfdf542d9
    li x3, 0xfdf542d9
    csrw 0xe83, x3

    #Address 0xe83 read value
    csrr x14, 0xe83

    #Unmapped address 0x69f testing: Read Reset + Random data Write/Read
    #Address 0x69f read value
    csrr x14, 0x69f

    #Address 0x69f Write value 0x7cdea070
    li x3, 0x7cdea070
    csrw 0x69f, x3

    #Address 0x69f read value
    csrr x14, 0x69f

    #Unmapped address 0x128 testing: Read Reset + Random data Write/Read
    #Address 0x128 read value
    csrr x14, 0x128

    #Address 0x128 Write value 0xaad11daa
    li x3, 0xaad11daa
    csrw 0x128, x3

    #Address 0x128 read value
    csrr x14, 0x128

    #Unmapped address 0x769 testing: Read Reset + Random data Write/Read
    #Address 0x769 read value
    csrr x14, 0x769

    #Address 0x769 Write value 0x4a8d5af8
    li x3, 0x4a8d5af8
    csrw 0x769, x3

    #Address 0x769 read value
    csrr x14, 0x769

    #Unmapped address 0x846 testing: Read Reset + Random data Write/Read
    #Address 0x846 read value
    csrr x14, 0x846

    #Address 0x846 Write value 0x53cc0427
    li x3, 0x53cc0427
    csrw 0x846, x3

    #Address 0x846 read value
    csrr x14, 0x846

    #Unmapped address 0xc19 testing: Read Reset + Random data Write/Read
    #Address 0xc19 read value
    csrr x14, 0xc19

    #Address 0xc19 Write value 0x47cf1d43
    li x3, 0x47cf1d43
    csrw 0xc19, x3

    #Address 0xc19 read value
    csrr x14, 0xc19

    #Unmapped address 0xa30 testing: Read Reset + Random data Write/Read
    #Address 0xa30 read value
    csrr x14, 0xa30

    #Address 0xa30 Write value 0x77df1392
    li x3, 0x77df1392
    csrw 0xa30, x3

    #Address 0xa30 read value
    csrr x14, 0xa30

    #Unmapped address 0x9ce testing: Read Reset + Random data Write/Read
    #Address 0x9ce read value
    csrr x14, 0x9ce

    #Address 0x9ce Write value 0x962a8ede
    li x3, 0x962a8ede
    csrw 0x9ce, x3

    #Address 0x9ce read value
    csrr x14, 0x9ce

    #Unmapped address 0x4b testing: Read Reset + Random data Write/Read
    #Address 0x4b read value
    csrr x14, 0x4b

    #Address 0x4b Write value 0xd5b0bf8f
    li x3, 0xd5b0bf8f
    csrw 0x4b, x3

    #Address 0x4b read value
    csrr x14, 0x4b

    #Unmapped address 0x88c testing: Read Reset + Random data Write/Read
    #Address 0x88c read value
    csrr x14, 0x88c

    #Address 0x88c Write value 0x74601b98
    li x3, 0x74601b98
    csrw 0x88c, x3

    #Address 0x88c read value
    csrr x14, 0x88c

    #Unmapped address 0x13c testing: Read Reset + Random data Write/Read
    #Address 0x13c read value
    csrr x14, 0x13c

    #Address 0x13c Write value 0x2f480a91
    li x3, 0x2f480a91
    csrw 0x13c, x3

    #Address 0x13c read value
    csrr x14, 0x13c

    #Unmapped address 0xdd9 testing: Read Reset + Random data Write/Read
    #Address 0xdd9 read value
    csrr x14, 0xdd9

    #Address 0xdd9 Write value 0x671c917b
    li x3, 0x671c917b
    csrw 0xdd9, x3

    #Address 0xdd9 read value
    csrr x14, 0xdd9

    #Unmapped address 0xa07 testing: Read Reset + Random data Write/Read
    #Address 0xa07 read value
    csrr x14, 0xa07

    #Address 0xa07 Write value 0x93869f03
    li x3, 0x93869f03
    csrw 0xa07, x3

    #Address 0xa07 read value
    csrr x14, 0xa07

    #Unmapped address 0xa67 testing: Read Reset + Random data Write/Read
    #Address 0xa67 read value
    csrr x14, 0xa67

    #Address 0xa67 Write value 0xb0a77f6e
    li x3, 0xb0a77f6e
    csrw 0xa67, x3

    #Address 0xa67 read value
    csrr x14, 0xa67

    #Unmapped address 0x7ad testing: Read Reset + Random data Write/Read
    #Address 0x7ad read value
    csrr x14, 0x7ad

    #Address 0x7ad Write value 0x39cff57
    li x3, 0x39cff57
    csrw 0x7ad, x3

    #Address 0x7ad read value
    csrr x14, 0x7ad

    #Unmapped address 0x189 testing: Read Reset + Random data Write/Read
    #Address 0x189 read value
    csrr x14, 0x189

    #Address 0x189 Write value 0x13c9897c
    li x3, 0x13c9897c
    csrw 0x189, x3

    #Address 0x189 read value
    csrr x14, 0x189

    #Unmapped address 0x36c testing: Read Reset + Random data Write/Read
    #Address 0x36c read value
    csrr x14, 0x36c

    #Address 0x36c Write value 0x20514e60
    li x3, 0x20514e60
    csrw 0x36c, x3

    #Address 0x36c read value
    csrr x14, 0x36c

    #Unmapped address 0x800 testing: Read Reset + Random data Write/Read
    #Address 0x800 read value
    csrr x14, 0x800

    #Address 0x800 Write value 0x5baf1c4
    li x3, 0x5baf1c4
    csrw 0x800, x3

    #Address 0x800 read value
    csrr x14, 0x800

    #Unmapped address 0x857 testing: Read Reset + Random data Write/Read
    #Address 0x857 read value
    csrr x14, 0x857

    #Address 0x857 Write value 0x6b3d2fb1
    li x3, 0x6b3d2fb1
    csrw 0x857, x3

    #Address 0x857 read value
    csrr x14, 0x857

    #Unmapped address 0xa74 testing: Read Reset + Random data Write/Read
    #Address 0xa74 read value
    csrr x14, 0xa74

    #Address 0xa74 Write value 0xb52653c9
    li x3, 0xb52653c9
    csrw 0xa74, x3

    #Address 0xa74 read value
    csrr x14, 0xa74

    #Unmapped address 0x605 testing: Read Reset + Random data Write/Read
    #Address 0x605 read value
    csrr x14, 0x605

    #Address 0x605 Write value 0xbe69fb1d
    li x3, 0xbe69fb1d
    csrw 0x605, x3

    #Address 0x605 read value
    csrr x14, 0x605

    #Unmapped address 0x508 testing: Read Reset + Random data Write/Read
    #Address 0x508 read value
    csrr x14, 0x508

    #Address 0x508 Write value 0xcfb51366
    li x3, 0xcfb51366
    csrw 0x508, x3

    #Address 0x508 read value
    csrr x14, 0x508

    #Unmapped address 0xc90 testing: Read Reset + Random data Write/Read
    #Address 0xc90 read value
    csrr x14, 0xc90

    #Address 0xc90 Write value 0xf3c340f9
    li x3, 0xf3c340f9
    csrw 0xc90, x3

    #Address 0xc90 read value
    csrr x14, 0xc90

    #Unmapped address 0xe2 testing: Read Reset + Random data Write/Read
    #Address 0xe2 read value
    csrr x14, 0xe2

    #Address 0xe2 Write value 0xeb6bc014
    li x3, 0xeb6bc014
    csrw 0xe2, x3

    #Address 0xe2 read value
    csrr x14, 0xe2

    #Unmapped address 0xbd1 testing: Read Reset + Random data Write/Read
    #Address 0xbd1 read value
    csrr x14, 0xbd1

    #Address 0xbd1 Write value 0x97ca10b1
    li x3, 0x97ca10b1
    csrw 0xbd1, x3

    #Address 0xbd1 read value
    csrr x14, 0xbd1

    #Unmapped address 0xea4 testing: Read Reset + Random data Write/Read
    #Address 0xea4 read value
    csrr x14, 0xea4

    #Address 0xea4 Write value 0x7dd891cb
    li x3, 0x7dd891cb
    csrw 0xea4, x3

    #Address 0xea4 read value
    csrr x14, 0xea4

    #Unmapped address 0x5c6 testing: Read Reset + Random data Write/Read
    #Address 0x5c6 read value
    csrr x14, 0x5c6

    #Address 0x5c6 Write value 0x3bc8ce56
    li x3, 0x3bc8ce56
    csrw 0x5c6, x3

    #Address 0x5c6 read value
    csrr x14, 0x5c6

    #Unmapped address 0x4b8 testing: Read Reset + Random data Write/Read
    #Address 0x4b8 read value
    csrr x14, 0x4b8

    #Address 0x4b8 Write value 0x7452571d
    li x3, 0x7452571d
    csrw 0x4b8, x3

    #Address 0x4b8 read value
    csrr x14, 0x4b8

    #Unmapped address 0xd6 testing: Read Reset + Random data Write/Read
    #Address 0xd6 read value
    csrr x14, 0xd6

    #Address 0xd6 Write value 0x8dcde55a
    li x3, 0x8dcde55a
    csrw 0xd6, x3

    #Address 0xd6 read value
    csrr x14, 0xd6

    #Unmapped address 0x91 testing: Read Reset + Random data Write/Read
    #Address 0x91 read value
    csrr x14, 0x91

    #Address 0x91 Write value 0xc9b1cd18
    li x3, 0xc9b1cd18
    csrw 0x91, x3

    #Address 0x91 read value
    csrr x14, 0x91

    #Unmapped address 0xc07 testing: Read Reset + Random data Write/Read
    #Address 0xc07 read value
    csrr x14, 0xc07

    #Address 0xc07 Write value 0xfd818f8
    li x3, 0xfd818f8
    csrw 0xc07, x3

    #Address 0xc07 read value
    csrr x14, 0xc07

    #Unmapped address 0x8d8 testing: Read Reset + Random data Write/Read
    #Address 0x8d8 read value
    csrr x14, 0x8d8

    #Address 0x8d8 Write value 0xf796a322
    li x3, 0xf796a322
    csrw 0x8d8, x3

    #Address 0x8d8 read value
    csrr x14, 0x8d8

    #Unmapped address 0x4fe testing: Read Reset + Random data Write/Read
    #Address 0x4fe read value
    csrr x14, 0x4fe

    #Address 0x4fe Write value 0xc70e043c
    li x3, 0xc70e043c
    csrw 0x4fe, x3

    #Address 0x4fe read value
    csrr x14, 0x4fe

    #Unmapped address 0x5ad testing: Read Reset + Random data Write/Read
    #Address 0x5ad read value
    csrr x14, 0x5ad

    #Address 0x5ad Write value 0x9274b41b
    li x3, 0x9274b41b
    csrw 0x5ad, x3

    #Address 0x5ad read value
    csrr x14, 0x5ad

    #Unmapped address 0xc7d testing: Read Reset + Random data Write/Read
    #Address 0xc7d read value
    csrr x14, 0xc7d

    #Address 0xc7d Write value 0x1f036c61
    li x3, 0x1f036c61
    csrw 0xc7d, x3

    #Address 0xc7d read value
    csrr x14, 0xc7d

    #Unmapped address 0x1b7 testing: Read Reset + Random data Write/Read
    #Address 0x1b7 read value
    csrr x14, 0x1b7

    #Address 0x1b7 Write value 0xe5d22623
    li x3, 0xe5d22623
    csrw 0x1b7, x3

    #Address 0x1b7 read value
    csrr x14, 0x1b7

    #Unmapped address 0x622 testing: Read Reset + Random data Write/Read
    #Address 0x622 read value
    csrr x14, 0x622

    #Address 0x622 Write value 0xb5c43914
    li x3, 0xb5c43914
    csrw 0x622, x3

    #Address 0x622 read value
    csrr x14, 0x622

    #Unmapped address 0xed9 testing: Read Reset + Random data Write/Read
    #Address 0xed9 read value
    csrr x14, 0xed9

    #Address 0xed9 Write value 0x8423589e
    li x3, 0x8423589e
    csrw 0xed9, x3

    #Address 0xed9 read value
    csrr x14, 0xed9

    #Unmapped address 0x5bb testing: Read Reset + Random data Write/Read
    #Address 0x5bb read value
    csrr x14, 0x5bb

    #Address 0x5bb Write value 0x3c6213f4
    li x3, 0x3c6213f4
    csrw 0x5bb, x3

    #Address 0x5bb read value
    csrr x14, 0x5bb

    #Unmapped address 0x551 testing: Read Reset + Random data Write/Read
    #Address 0x551 read value
    csrr x14, 0x551

    #Address 0x551 Write value 0x6f7c1b9b
    li x3, 0x6f7c1b9b
    csrw 0x551, x3

    #Address 0x551 read value
    csrr x14, 0x551

    #Unmapped address 0xdc2 testing: Read Reset + Random data Write/Read
    #Address 0xdc2 read value
    csrr x14, 0xdc2

    #Address 0xdc2 Write value 0x3c61434
    li x3, 0x3c61434
    csrw 0xdc2, x3

    #Address 0xdc2 read value
    csrr x14, 0xdc2

    #Unmapped address 0x362 testing: Read Reset + Random data Write/Read
    #Address 0x362 read value
    csrr x14, 0x362

    #Address 0x362 Write value 0x80bb720c
    li x3, 0x80bb720c
    csrw 0x362, x3

    #Address 0x362 read value
    csrr x14, 0x362

    #Unmapped address 0x4d0 testing: Read Reset + Random data Write/Read
    #Address 0x4d0 read value
    csrr x14, 0x4d0

    #Address 0x4d0 Write value 0xafdd94df
    li x3, 0xafdd94df
    csrw 0x4d0, x3

    #Address 0x4d0 read value
    csrr x14, 0x4d0

    #Unmapped address 0x474 testing: Read Reset + Random data Write/Read
    #Address 0x474 read value
    csrr x14, 0x474

    #Address 0x474 Write value 0xd33f4ca6
    li x3, 0xd33f4ca6
    csrw 0x474, x3

    #Address 0x474 read value
    csrr x14, 0x474

    #Unmapped address 0xe60 testing: Read Reset + Random data Write/Read
    #Address 0xe60 read value
    csrr x14, 0xe60

    #Address 0xe60 Write value 0x71d468d7
    li x3, 0x71d468d7
    csrw 0xe60, x3

    #Address 0xe60 read value
    csrr x14, 0xe60

    #Unmapped address 0xe35 testing: Read Reset + Random data Write/Read
    #Address 0xe35 read value
    csrr x14, 0xe35

    #Address 0xe35 Write value 0x31abea61
    li x3, 0x31abea61
    csrw 0xe35, x3

    #Address 0xe35 read value
    csrr x14, 0xe35

    #Unmapped address 0x417 testing: Read Reset + Random data Write/Read
    #Address 0x417 read value
    csrr x14, 0x417

    #Address 0x417 Write value 0x2bad1def
    li x3, 0x2bad1def
    csrw 0x417, x3

    #Address 0x417 read value
    csrr x14, 0x417

    #Unmapped address 0x4fd testing: Read Reset + Random data Write/Read
    #Address 0x4fd read value
    csrr x14, 0x4fd

    #Address 0x4fd Write value 0xbc150a16
    li x3, 0xbc150a16
    csrw 0x4fd, x3

    #Address 0x4fd read value
    csrr x14, 0x4fd

    #Unmapped address 0x7fd testing: Read Reset + Random data Write/Read
    #Address 0x7fd read value
    csrr x14, 0x7fd

    #Address 0x7fd Write value 0x90a4072f
    li x3, 0x90a4072f
    csrw 0x7fd, x3

    #Address 0x7fd read value
    csrr x14, 0x7fd

    #Unmapped address 0x738 testing: Read Reset + Random data Write/Read
    #Address 0x738 read value
    csrr x14, 0x738

    #Address 0x738 Write value 0xe9db95e0
    li x3, 0xe9db95e0
    csrw 0x738, x3

    #Address 0x738 read value
    csrr x14, 0x738

    #Unmapped address 0x815 testing: Read Reset + Random data Write/Read
    #Address 0x815 read value
    csrr x14, 0x815

    #Address 0x815 Write value 0x78d4935b
    li x3, 0x78d4935b
    csrw 0x815, x3

    #Address 0x815 read value
    csrr x14, 0x815

    #Unmapped address 0xbd6 testing: Read Reset + Random data Write/Read
    #Address 0xbd6 read value
    csrr x14, 0xbd6

    #Address 0xbd6 Write value 0xd00cfd03
    li x3, 0xd00cfd03
    csrw 0xbd6, x3

    #Address 0xbd6 read value
    csrr x14, 0xbd6

    #Unmapped address 0x374 testing: Read Reset + Random data Write/Read
    #Address 0x374 read value
    csrr x14, 0x374

    #Address 0x374 Write value 0xa2f5e920
    li x3, 0xa2f5e920
    csrw 0x374, x3

    #Address 0x374 read value
    csrr x14, 0x374

    #Unmapped address 0xec3 testing: Read Reset + Random data Write/Read
    #Address 0xec3 read value
    csrr x14, 0xec3

    #Address 0xec3 Write value 0xc82e6433
    li x3, 0xc82e6433
    csrw 0xec3, x3

    #Address 0xec3 read value
    csrr x14, 0xec3

    #Unmapped address 0x6d6 testing: Read Reset + Random data Write/Read
    #Address 0x6d6 read value
    csrr x14, 0x6d6

    #Address 0x6d6 Write value 0x42a9de52
    li x3, 0x42a9de52
    csrw 0x6d6, x3

    #Address 0x6d6 read value
    csrr x14, 0x6d6

    #Unmapped address 0x1fb testing: Read Reset + Random data Write/Read
    #Address 0x1fb read value
    csrr x14, 0x1fb

    #Address 0x1fb Write value 0x29ddfe58
    li x3, 0x29ddfe58
    csrw 0x1fb, x3

    #Address 0x1fb read value
    csrr x14, 0x1fb

    #Unmapped address 0x81f testing: Read Reset + Random data Write/Read
    #Address 0x81f read value
    csrr x14, 0x81f

    #Address 0x81f Write value 0xf8d44e1
    li x3, 0xf8d44e1
    csrw 0x81f, x3

    #Address 0x81f read value
    csrr x14, 0x81f

    #Unmapped address 0x87f testing: Read Reset + Random data Write/Read
    #Address 0x87f read value
    csrr x14, 0x87f

    #Address 0x87f Write value 0x5ae36077
    li x3, 0x5ae36077
    csrw 0x87f, x3

    #Address 0x87f read value
    csrr x14, 0x87f

    #Unmapped address 0x4f7 testing: Read Reset + Random data Write/Read
    #Address 0x4f7 read value
    csrr x14, 0x4f7

    #Address 0x4f7 Write value 0xee298975
    li x3, 0xee298975
    csrw 0x4f7, x3

    #Address 0x4f7 read value
    csrr x14, 0x4f7

    #Unmapped address 0x267 testing: Read Reset + Random data Write/Read
    #Address 0x267 read value
    csrr x14, 0x267

    #Address 0x267 Write value 0x512c02be
    li x3, 0x512c02be
    csrw 0x267, x3

    #Address 0x267 read value
    csrr x14, 0x267

    #Unmapped address 0xe01 testing: Read Reset + Random data Write/Read
    #Address 0xe01 read value
    csrr x14, 0xe01

    #Address 0xe01 Write value 0x179cc83f
    li x3, 0x179cc83f
    csrw 0xe01, x3

    #Address 0xe01 read value
    csrr x14, 0xe01

    #Unmapped address 0xa78 testing: Read Reset + Random data Write/Read
    #Address 0xa78 read value
    csrr x14, 0xa78

    #Address 0xa78 Write value 0xcb94e912
    li x3, 0xcb94e912
    csrw 0xa78, x3

    #Address 0xa78 read value
    csrr x14, 0xa78

    #Unmapped address 0xa8f testing: Read Reset + Random data Write/Read
    #Address 0xa8f read value
    csrr x14, 0xa8f

    #Address 0xa8f Write value 0x3b13c67c
    li x3, 0x3b13c67c
    csrw 0xa8f, x3

    #Address 0xa8f read value
    csrr x14, 0xa8f

    #Unmapped address 0x39b testing: Read Reset + Random data Write/Read
    #Address 0x39b read value
    csrr x14, 0x39b

    #Address 0x39b Write value 0xb62d2f10
    li x3, 0xb62d2f10
    csrw 0x39b, x3

    #Address 0x39b read value
    csrr x14, 0x39b

    #Unmapped address 0xbec testing: Read Reset + Random data Write/Read
    #Address 0xbec read value
    csrr x14, 0xbec

    #Address 0xbec Write value 0xad77bd93
    li x3, 0xad77bd93
    csrw 0xbec, x3

    #Address 0xbec read value
    csrr x14, 0xbec

    #Unmapped address 0xf35 testing: Read Reset + Random data Write/Read
    #Address 0xf35 read value
    csrr x14, 0xf35

    #Address 0xf35 Write value 0xd2728498
    li x3, 0xd2728498
    csrw 0xf35, x3

    #Address 0xf35 read value
    csrr x14, 0xf35

    #Unmapped address 0x409 testing: Read Reset + Random data Write/Read
    #Address 0x409 read value
    csrr x14, 0x409

    #Address 0x409 Write value 0x28a9d8b7
    li x3, 0x28a9d8b7
    csrw 0x409, x3

    #Address 0x409 read value
    csrr x14, 0x409

    #Unmapped address 0x597 testing: Read Reset + Random data Write/Read
    #Address 0x597 read value
    csrr x14, 0x597

    #Address 0x597 Write value 0x6307142e
    li x3, 0x6307142e
    csrw 0x597, x3

    #Address 0x597 read value
    csrr x14, 0x597

    #Unmapped address 0x1e2 testing: Read Reset + Random data Write/Read
    #Address 0x1e2 read value
    csrr x14, 0x1e2

    #Address 0x1e2 Write value 0xb88a30e3
    li x3, 0xb88a30e3
    csrw 0x1e2, x3

    #Address 0x1e2 read value
    csrr x14, 0x1e2

    #Unmapped address 0x649 testing: Read Reset + Random data Write/Read
    #Address 0x649 read value
    csrr x14, 0x649

    #Address 0x649 Write value 0xfe67c96
    li x3, 0xfe67c96
    csrw 0x649, x3

    #Address 0x649 read value
    csrr x14, 0x649

    #Unmapped address 0x175 testing: Read Reset + Random data Write/Read
    #Address 0x175 read value
    csrr x14, 0x175

    #Address 0x175 Write value 0xf7db4957
    li x3, 0xf7db4957
    csrw 0x175, x3

    #Address 0x175 read value
    csrr x14, 0x175

    #Unmapped address 0x60b testing: Read Reset + Random data Write/Read
    #Address 0x60b read value
    csrr x14, 0x60b

    #Address 0x60b Write value 0x66a2cbf6
    li x3, 0x66a2cbf6
    csrw 0x60b, x3

    #Address 0x60b read value
    csrr x14, 0x60b

    #Unmapped address 0xdb6 testing: Read Reset + Random data Write/Read
    #Address 0xdb6 read value
    csrr x14, 0xdb6

    #Address 0xdb6 Write value 0x868d66f0
    li x3, 0x868d66f0
    csrw 0xdb6, x3

    #Address 0xdb6 read value
    csrr x14, 0xdb6

    #Unmapped address 0xf48 testing: Read Reset + Random data Write/Read
    #Address 0xf48 read value
    csrr x14, 0xf48

    #Address 0xf48 Write value 0x9a9781ff
    li x3, 0x9a9781ff
    csrw 0xf48, x3

    #Address 0xf48 read value
    csrr x14, 0xf48

    #Unmapped address 0x5dc testing: Read Reset + Random data Write/Read
    #Address 0x5dc read value
    csrr x14, 0x5dc

    #Address 0x5dc Write value 0x7725e619
    li x3, 0x7725e619
    csrw 0x5dc, x3

    #Address 0x5dc read value
    csrr x14, 0x5dc

    #Unmapped address 0x822 testing: Read Reset + Random data Write/Read
    #Address 0x822 read value
    csrr x14, 0x822

    #Address 0x822 Write value 0xeb1891af
    li x3, 0xeb1891af
    csrw 0x822, x3

    #Address 0x822 read value
    csrr x14, 0x822

    #Unmapped address 0x6b3 testing: Read Reset + Random data Write/Read
    #Address 0x6b3 read value
    csrr x14, 0x6b3

    #Address 0x6b3 Write value 0x96441aaa
    li x3, 0x96441aaa
    csrw 0x6b3, x3

    #Address 0x6b3 read value
    csrr x14, 0x6b3

    #Unmapped address 0xe05 testing: Read Reset + Random data Write/Read
    #Address 0xe05 read value
    csrr x14, 0xe05

    #Address 0xe05 Write value 0xb325057c
    li x3, 0xb325057c
    csrw 0xe05, x3

    #Address 0xe05 read value
    csrr x14, 0xe05

    #Unmapped address 0xe8d testing: Read Reset + Random data Write/Read
    #Address 0xe8d read value
    csrr x14, 0xe8d

    #Address 0xe8d Write value 0xd72a8f46
    li x3, 0xd72a8f46
    csrw 0xe8d, x3

    #Address 0xe8d read value
    csrr x14, 0xe8d

    #Unmapped address 0x2c8 testing: Read Reset + Random data Write/Read
    #Address 0x2c8 read value
    csrr x14, 0x2c8

    #Address 0x2c8 Write value 0xc4fa3397
    li x3, 0xc4fa3397
    csrw 0x2c8, x3

    #Address 0x2c8 read value
    csrr x14, 0x2c8

    #Unmapped address 0xfaa testing: Read Reset + Random data Write/Read
    #Address 0xfaa read value
    csrr x14, 0xfaa

    #Address 0xfaa Write value 0x8d24e30f
    li x3, 0x8d24e30f
    csrw 0xfaa, x3

    #Address 0xfaa read value
    csrr x14, 0xfaa

    #Unmapped address 0xd72 testing: Read Reset + Random data Write/Read
    #Address 0xd72 read value
    csrr x14, 0xd72

    #Address 0xd72 Write value 0xed9a6cf8
    li x3, 0xed9a6cf8
    csrw 0xd72, x3

    #Address 0xd72 read value
    csrr x14, 0xd72

    #Unmapped address 0xae0 testing: Read Reset + Random data Write/Read
    #Address 0xae0 read value
    csrr x14, 0xae0

    #Address 0xae0 Write value 0xd30c15fb
    li x3, 0xd30c15fb
    csrw 0xae0, x3

    #Address 0xae0 read value
    csrr x14, 0xae0

    #Unmapped address 0x10e testing: Read Reset + Random data Write/Read
    #Address 0x10e read value
    csrr x14, 0x10e

    #Address 0x10e Write value 0xe7e036f3
    li x3, 0xe7e036f3
    csrw 0x10e, x3

    #Address 0x10e read value
    csrr x14, 0x10e

    #Unmapped address 0x5c7 testing: Read Reset + Random data Write/Read
    #Address 0x5c7 read value
    csrr x14, 0x5c7

    #Address 0x5c7 Write value 0x6662e5c4
    li x3, 0x6662e5c4
    csrw 0x5c7, x3

    #Address 0x5c7 read value
    csrr x14, 0x5c7

    #Unmapped address 0xe22 testing: Read Reset + Random data Write/Read
    #Address 0xe22 read value
    csrr x14, 0xe22

    #Address 0xe22 Write value 0xd22e15e7
    li x3, 0xd22e15e7
    csrw 0xe22, x3

    #Address 0xe22 read value
    csrr x14, 0xe22

    #Unmapped address 0x2d2 testing: Read Reset + Random data Write/Read
    #Address 0x2d2 read value
    csrr x14, 0x2d2

    #Address 0x2d2 Write value 0x70a2ea3b
    li x3, 0x70a2ea3b
    csrw 0x2d2, x3

    #Address 0x2d2 read value
    csrr x14, 0x2d2

    #Unmapped address 0x6ec testing: Read Reset + Random data Write/Read
    #Address 0x6ec read value
    csrr x14, 0x6ec

    #Address 0x6ec Write value 0x44f65ae1
    li x3, 0x44f65ae1
    csrw 0x6ec, x3

    #Address 0x6ec read value
    csrr x14, 0x6ec

    #Unmapped address 0x540 testing: Read Reset + Random data Write/Read
    #Address 0x540 read value
    csrr x14, 0x540

    #Address 0x540 Write value 0xc4cb2c5c
    li x3, 0xc4cb2c5c
    csrw 0x540, x3

    #Address 0x540 read value
    csrr x14, 0x540

    #Unmapped address 0x412 testing: Read Reset + Random data Write/Read
    #Address 0x412 read value
    csrr x14, 0x412

    #Address 0x412 Write value 0xfb923979
    li x3, 0xfb923979
    csrw 0x412, x3

    #Address 0x412 read value
    csrr x14, 0x412

    #Unmapped address 0xc22 testing: Read Reset + Random data Write/Read
    #Address 0xc22 read value
    csrr x14, 0xc22

    #Address 0xc22 Write value 0xce7c68e0
    li x3, 0xce7c68e0
    csrw 0xc22, x3

    #Address 0xc22 read value
    csrr x14, 0xc22

    #Unmapped address 0xd55 testing: Read Reset + Random data Write/Read
    #Address 0xd55 read value
    csrr x14, 0xd55

    #Address 0xd55 Write value 0xd066f6a0
    li x3, 0xd066f6a0
    csrw 0xd55, x3

    #Address 0xd55 read value
    csrr x14, 0xd55

    #Unmapped address 0x57a testing: Read Reset + Random data Write/Read
    #Address 0x57a read value
    csrr x14, 0x57a

    #Address 0x57a Write value 0xd142535
    li x3, 0xd142535
    csrw 0x57a, x3

    #Address 0x57a read value
    csrr x14, 0x57a

    #Unmapped address 0xc71 testing: Read Reset + Random data Write/Read
    #Address 0xc71 read value
    csrr x14, 0xc71

    #Address 0xc71 Write value 0xdf5c1c8a
    li x3, 0xdf5c1c8a
    csrw 0xc71, x3

    #Address 0xc71 read value
    csrr x14, 0xc71

    #Unmapped address 0x850 testing: Read Reset + Random data Write/Read
    #Address 0x850 read value
    csrr x14, 0x850

    #Address 0x850 Write value 0xcfd15075
    li x3, 0xcfd15075
    csrw 0x850, x3

    #Address 0x850 read value
    csrr x14, 0x850

    #Unmapped address 0x996 testing: Read Reset + Random data Write/Read
    #Address 0x996 read value
    csrr x14, 0x996

    #Address 0x996 Write value 0x951dc071
    li x3, 0x951dc071
    csrw 0x996, x3

    #Address 0x996 read value
    csrr x14, 0x996

    #Unmapped address 0xe55 testing: Read Reset + Random data Write/Read
    #Address 0xe55 read value
    csrr x14, 0xe55

    #Address 0xe55 Write value 0xbda32611
    li x3, 0xbda32611
    csrw 0xe55, x3

    #Address 0xe55 read value
    csrr x14, 0xe55

    #Unmapped address 0x363 testing: Read Reset + Random data Write/Read
    #Address 0x363 read value
    csrr x14, 0x363

    #Address 0x363 Write value 0x430e525e
    li x3, 0x430e525e
    csrw 0x363, x3

    #Address 0x363 read value
    csrr x14, 0x363

    #Unmapped address 0xbad testing: Read Reset + Random data Write/Read
    #Address 0xbad read value
    csrr x14, 0xbad

    #Address 0xbad Write value 0xebd7bd07
    li x3, 0xebd7bd07
    csrw 0xbad, x3

    #Address 0xbad read value
    csrr x14, 0xbad

    #Unmapped address 0x31e testing: Read Reset + Random data Write/Read
    #Address 0x31e read value
    csrr x14, 0x31e

    #Address 0x31e Write value 0x7ee7d35
    li x3, 0x7ee7d35
    csrw 0x31e, x3

    #Address 0x31e read value
    csrr x14, 0x31e

    #Unmapped address 0x167 testing: Read Reset + Random data Write/Read
    #Address 0x167 read value
    csrr x14, 0x167

    #Address 0x167 Write value 0x2932b2a3
    li x3, 0x2932b2a3
    csrw 0x167, x3

    #Address 0x167 read value
    csrr x14, 0x167

    #Unmapped address 0x19b testing: Read Reset + Random data Write/Read
    #Address 0x19b read value
    csrr x14, 0x19b

    #Address 0x19b Write value 0x35f80c96
    li x3, 0x35f80c96
    csrw 0x19b, x3

    #Address 0x19b read value
    csrr x14, 0x19b

    #Unmapped address 0x230 testing: Read Reset + Random data Write/Read
    #Address 0x230 read value
    csrr x14, 0x230

    #Address 0x230 Write value 0x2f44494f
    li x3, 0x2f44494f
    csrw 0x230, x3

    #Address 0x230 read value
    csrr x14, 0x230

    #Unmapped address 0x96a testing: Read Reset + Random data Write/Read
    #Address 0x96a read value
    csrr x14, 0x96a

    #Address 0x96a Write value 0x162cced9
    li x3, 0x162cced9
    csrw 0x96a, x3

    #Address 0x96a read value
    csrr x14, 0x96a

    #Unmapped address 0x49b testing: Read Reset + Random data Write/Read
    #Address 0x49b read value
    csrr x14, 0x49b

    #Address 0x49b Write value 0x1171bfc1
    li x3, 0x1171bfc1
    csrw 0x49b, x3

    #Address 0x49b read value
    csrr x14, 0x49b

    #Unmapped address 0x87e testing: Read Reset + Random data Write/Read
    #Address 0x87e read value
    csrr x14, 0x87e

    #Address 0x87e Write value 0x8d76963c
    li x3, 0x8d76963c
    csrw 0x87e, x3

    #Address 0x87e read value
    csrr x14, 0x87e

    #Unmapped address 0x8c3 testing: Read Reset + Random data Write/Read
    #Address 0x8c3 read value
    csrr x14, 0x8c3

    #Address 0x8c3 Write value 0xb84d476e
    li x3, 0xb84d476e
    csrw 0x8c3, x3

    #Address 0x8c3 read value
    csrr x14, 0x8c3

    #Unmapped address 0xec testing: Read Reset + Random data Write/Read
    #Address 0xec read value
    csrr x14, 0xec

    #Address 0xec Write value 0x85106310
    li x3, 0x85106310
    csrw 0xec, x3

    #Address 0xec read value
    csrr x14, 0xec

    #Unmapped address 0xe5e testing: Read Reset + Random data Write/Read
    #Address 0xe5e read value
    csrr x14, 0xe5e

    #Address 0xe5e Write value 0x7cb2ccc9
    li x3, 0x7cb2ccc9
    csrw 0xe5e, x3

    #Address 0xe5e read value
    csrr x14, 0xe5e

    #Unmapped address 0xea1 testing: Read Reset + Random data Write/Read
    #Address 0xea1 read value
    csrr x14, 0xea1

    #Address 0xea1 Write value 0x7a311752
    li x3, 0x7a311752
    csrw 0xea1, x3

    #Address 0xea1 read value
    csrr x14, 0xea1

    #Unmapped address 0x6cc testing: Read Reset + Random data Write/Read
    #Address 0x6cc read value
    csrr x14, 0x6cc

    #Address 0x6cc Write value 0x93acb62f
    li x3, 0x93acb62f
    csrw 0x6cc, x3

    #Address 0x6cc read value
    csrr x14, 0x6cc

    #Unmapped address 0xae8 testing: Read Reset + Random data Write/Read
    #Address 0xae8 read value
    csrr x14, 0xae8

    #Address 0xae8 Write value 0xd44b88c7
    li x3, 0xd44b88c7
    csrw 0xae8, x3

    #Address 0xae8 read value
    csrr x14, 0xae8

    #Unmapped address 0xc0 testing: Read Reset + Random data Write/Read
    #Address 0xc0 read value
    csrr x14, 0xc0

    #Address 0xc0 Write value 0x86fb07d
    li x3, 0x86fb07d
    csrw 0xc0, x3

    #Address 0xc0 read value
    csrr x14, 0xc0

    #Unmapped address 0xd62 testing: Read Reset + Random data Write/Read
    #Address 0xd62 read value
    csrr x14, 0xd62

    #Address 0xd62 Write value 0x3851f73d
    li x3, 0x3851f73d
    csrw 0xd62, x3

    #Address 0xd62 read value
    csrr x14, 0xd62

    #Unmapped address 0xbc1 testing: Read Reset + Random data Write/Read
    #Address 0xbc1 read value
    csrr x14, 0xbc1

    #Address 0xbc1 Write value 0x5ee53a51
    li x3, 0x5ee53a51
    csrw 0xbc1, x3

    #Address 0xbc1 read value
    csrr x14, 0xbc1

    #Unmapped address 0x2fc testing: Read Reset + Random data Write/Read
    #Address 0x2fc read value
    csrr x14, 0x2fc

    #Address 0x2fc Write value 0xc431f3bc
    li x3, 0xc431f3bc
    csrw 0x2fc, x3

    #Address 0x2fc read value
    csrr x14, 0x2fc

    #Unmapped address 0x1ec testing: Read Reset + Random data Write/Read
    #Address 0x1ec read value
    csrr x14, 0x1ec

    #Address 0x1ec Write value 0xb2ca38fa
    li x3, 0xb2ca38fa
    csrw 0x1ec, x3

    #Address 0x1ec read value
    csrr x14, 0x1ec

    #Unmapped address 0x907 testing: Read Reset + Random data Write/Read
    #Address 0x907 read value
    csrr x14, 0x907

    #Address 0x907 Write value 0x36de4d13
    li x3, 0x36de4d13
    csrw 0x907, x3

    #Address 0x907 read value
    csrr x14, 0x907

    #Unmapped address 0x977 testing: Read Reset + Random data Write/Read
    #Address 0x977 read value
    csrr x14, 0x977

    #Address 0x977 Write value 0xe04cdfa9
    li x3, 0xe04cdfa9
    csrw 0x977, x3

    #Address 0x977 read value
    csrr x14, 0x977

    #Unmapped address 0x3c8 testing: Read Reset + Random data Write/Read
    #Address 0x3c8 read value
    csrr x14, 0x3c8

    #Address 0x3c8 Write value 0x8bff0732
    li x3, 0x8bff0732
    csrw 0x3c8, x3

    #Address 0x3c8 read value
    csrr x14, 0x3c8

    #Unmapped address 0xd47 testing: Read Reset + Random data Write/Read
    #Address 0xd47 read value
    csrr x14, 0xd47

    #Address 0xd47 Write value 0xf6e43e76
    li x3, 0xf6e43e76
    csrw 0xd47, x3

    #Address 0xd47 read value
    csrr x14, 0xd47

    #Unmapped address 0xa53 testing: Read Reset + Random data Write/Read
    #Address 0xa53 read value
    csrr x14, 0xa53

    #Address 0xa53 Write value 0x6b1c6602
    li x3, 0x6b1c6602
    csrw 0xa53, x3

    #Address 0xa53 read value
    csrr x14, 0xa53

    #Unmapped address 0x921 testing: Read Reset + Random data Write/Read
    #Address 0x921 read value
    csrr x14, 0x921

    #Address 0x921 Write value 0x6619ffb0
    li x3, 0x6619ffb0
    csrw 0x921, x3

    #Address 0x921 read value
    csrr x14, 0x921

    #Unmapped address 0xc06 testing: Read Reset + Random data Write/Read
    #Address 0xc06 read value
    csrr x14, 0xc06

    #Address 0xc06 Write value 0xeecc09aa
    li x3, 0xeecc09aa
    csrw 0xc06, x3

    #Address 0xc06 read value
    csrr x14, 0xc06

    #Unmapped address 0xe80 testing: Read Reset + Random data Write/Read
    #Address 0xe80 read value
    csrr x14, 0xe80

    #Address 0xe80 Write value 0xb2f22cae
    li x3, 0xb2f22cae
    csrw 0xe80, x3

    #Address 0xe80 read value
    csrr x14, 0xe80

    #Unmapped address 0x44 testing: Read Reset + Random data Write/Read
    #Address 0x44 read value
    csrr x14, 0x44

    #Address 0x44 Write value 0xfaaff39a
    li x3, 0xfaaff39a
    csrw 0x44, x3

    #Address 0x44 read value
    csrr x14, 0x44

    #Unmapped address 0x841 testing: Read Reset + Random data Write/Read
    #Address 0x841 read value
    csrr x14, 0x841

    #Address 0x841 Write value 0xf893e14
    li x3, 0xf893e14
    csrw 0x841, x3

    #Address 0x841 read value
    csrr x14, 0x841

    #Unmapped address 0xf34 testing: Read Reset + Random data Write/Read
    #Address 0xf34 read value
    csrr x14, 0xf34

    #Address 0xf34 Write value 0xf9d0acf8
    li x3, 0xf9d0acf8
    csrw 0xf34, x3

    #Address 0xf34 read value
    csrr x14, 0xf34

    #Unmapped address 0xd59 testing: Read Reset + Random data Write/Read
    #Address 0xd59 read value
    csrr x14, 0xd59

    #Address 0xd59 Write value 0xd3fcdc8b
    li x3, 0xd3fcdc8b
    csrw 0xd59, x3

    #Address 0xd59 read value
    csrr x14, 0xd59

    #Unmapped address 0xa7 testing: Read Reset + Random data Write/Read
    #Address 0xa7 read value
    csrr x14, 0xa7

    #Address 0xa7 Write value 0x6088d8a2
    li x3, 0x6088d8a2
    csrw 0xa7, x3

    #Address 0xa7 read value
    csrr x14, 0xa7

    #Unmapped address 0xaed testing: Read Reset + Random data Write/Read
    #Address 0xaed read value
    csrr x14, 0xaed

    #Address 0xaed Write value 0x88f58186
    li x3, 0x88f58186
    csrw 0xaed, x3

    #Address 0xaed read value
    csrr x14, 0xaed

    #Unmapped address 0xdae testing: Read Reset + Random data Write/Read
    #Address 0xdae read value
    csrr x14, 0xdae

    #Address 0xdae Write value 0x78695984
    li x3, 0x78695984
    csrw 0xdae, x3

    #Address 0xdae read value
    csrr x14, 0xdae

    #Unmapped address 0x6a5 testing: Read Reset + Random data Write/Read
    #Address 0x6a5 read value
    csrr x14, 0x6a5

    #Address 0x6a5 Write value 0x3f92d2b2
    li x3, 0x3f92d2b2
    csrw 0x6a5, x3

    #Address 0x6a5 read value
    csrr x14, 0x6a5

    #Unmapped address 0xe5 testing: Read Reset + Random data Write/Read
    #Address 0xe5 read value
    csrr x14, 0xe5

    #Address 0xe5 Write value 0x79fa7495
    li x3, 0x79fa7495
    csrw 0xe5, x3

    #Address 0xe5 read value
    csrr x14, 0xe5

    #Unmapped address 0x936 testing: Read Reset + Random data Write/Read
    #Address 0x936 read value
    csrr x14, 0x936

    #Address 0x936 Write value 0x9ef63c3d
    li x3, 0x9ef63c3d
    csrw 0x936, x3

    #Address 0x936 read value
    csrr x14, 0x936

    #Unmapped address 0xeb0 testing: Read Reset + Random data Write/Read
    #Address 0xeb0 read value
    csrr x14, 0xeb0

    #Address 0xeb0 Write value 0x176f0c91
    li x3, 0x176f0c91
    csrw 0xeb0, x3

    #Address 0xeb0 read value
    csrr x14, 0xeb0

    #Unmapped address 0xfa1 testing: Read Reset + Random data Write/Read
    #Address 0xfa1 read value
    csrr x14, 0xfa1

    #Address 0xfa1 Write value 0xc556f1ec
    li x3, 0xc556f1ec
    csrw 0xfa1, x3

    #Address 0xfa1 read value
    csrr x14, 0xfa1

    #Unmapped address 0x470 testing: Read Reset + Random data Write/Read
    #Address 0x470 read value
    csrr x14, 0x470

    #Address 0x470 Write value 0x5410d384
    li x3, 0x5410d384
    csrw 0x470, x3

    #Address 0x470 read value
    csrr x14, 0x470

    #Unmapped address 0x7a8 testing: Read Reset + Random data Write/Read
    #Address 0x7a8 read value
    csrr x14, 0x7a8

    #Address 0x7a8 Write value 0xcc178267
    li x3, 0xcc178267
    csrw 0x7a8, x3

    #Address 0x7a8 read value
    csrr x14, 0x7a8

    #Unmapped address 0xbf4 testing: Read Reset + Random data Write/Read
    #Address 0xbf4 read value
    csrr x14, 0xbf4

    #Address 0xbf4 Write value 0x3785c406
    li x3, 0x3785c406
    csrw 0xbf4, x3

    #Address 0xbf4 read value
    csrr x14, 0xbf4

    #Unmapped address 0x86f testing: Read Reset + Random data Write/Read
    #Address 0x86f read value
    csrr x14, 0x86f

    #Address 0x86f Write value 0x488d108e
    li x3, 0x488d108e
    csrw 0x86f, x3

    #Address 0x86f read value
    csrr x14, 0x86f

    #Unmapped address 0x202 testing: Read Reset + Random data Write/Read
    #Address 0x202 read value
    csrr x14, 0x202

    #Address 0x202 Write value 0x75cc64ee
    li x3, 0x75cc64ee
    csrw 0x202, x3

    #Address 0x202 read value
    csrr x14, 0x202

    #Unmapped address 0x421 testing: Read Reset + Random data Write/Read
    #Address 0x421 read value
    csrr x14, 0x421

    #Address 0x421 Write value 0xda532c5d
    li x3, 0xda532c5d
    csrw 0x421, x3

    #Address 0x421 read value
    csrr x14, 0x421

    #Unmapped address 0x7bb testing: Read Reset + Random data Write/Read
    #Address 0x7bb read value
    csrr x14, 0x7bb

    #Address 0x7bb Write value 0xd1830a2b
    li x3, 0xd1830a2b
    csrw 0x7bb, x3

    #Address 0x7bb read value
    csrr x14, 0x7bb

    #Unmapped address 0x3c9 testing: Read Reset + Random data Write/Read
    #Address 0x3c9 read value
    csrr x14, 0x3c9

    #Address 0x3c9 Write value 0xbba974dc
    li x3, 0xbba974dc
    csrw 0x3c9, x3

    #Address 0x3c9 read value
    csrr x14, 0x3c9

    #Unmapped address 0x8ed testing: Read Reset + Random data Write/Read
    #Address 0x8ed read value
    csrr x14, 0x8ed

    #Address 0x8ed Write value 0xb5d927f4
    li x3, 0xb5d927f4
    csrw 0x8ed, x3

    #Address 0x8ed read value
    csrr x14, 0x8ed

    #Unmapped address 0x563 testing: Read Reset + Random data Write/Read
    #Address 0x563 read value
    csrr x14, 0x563

    #Address 0x563 Write value 0xaf11b904
    li x3, 0xaf11b904
    csrw 0x563, x3

    #Address 0x563 read value
    csrr x14, 0x563

    #Unmapped address 0xe2a testing: Read Reset + Random data Write/Read
    #Address 0xe2a read value
    csrr x14, 0xe2a

    #Address 0xe2a Write value 0x16494573
    li x3, 0x16494573
    csrw 0xe2a, x3

    #Address 0xe2a read value
    csrr x14, 0xe2a

    #Unmapped address 0x606 testing: Read Reset + Random data Write/Read
    #Address 0x606 read value
    csrr x14, 0x606

    #Address 0x606 Write value 0x1078d67
    li x3, 0x1078d67
    csrw 0x606, x3

    #Address 0x606 read value
    csrr x14, 0x606

    #Unmapped address 0x537 testing: Read Reset + Random data Write/Read
    #Address 0x537 read value
    csrr x14, 0x537

    #Address 0x537 Write value 0x8d3c6a54
    li x3, 0x8d3c6a54
    csrw 0x537, x3

    #Address 0x537 read value
    csrr x14, 0x537

    #Unmapped address 0xe3e testing: Read Reset + Random data Write/Read
    #Address 0xe3e read value
    csrr x14, 0xe3e

    #Address 0xe3e Write value 0x28b02fda
    li x3, 0x28b02fda
    csrw 0xe3e, x3

    #Address 0xe3e read value
    csrr x14, 0xe3e

    #Unmapped address 0xfdc testing: Read Reset + Random data Write/Read
    #Address 0xfdc read value
    csrr x14, 0xfdc

    #Address 0xfdc Write value 0x186ddf56
    li x3, 0x186ddf56
    csrw 0xfdc, x3

    #Address 0xfdc read value
    csrr x14, 0xfdc

    #Unmapped address 0x9fe testing: Read Reset + Random data Write/Read
    #Address 0x9fe read value
    csrr x14, 0x9fe

    #Address 0x9fe Write value 0x3036eb8e
    li x3, 0x3036eb8e
    csrw 0x9fe, x3

    #Address 0x9fe read value
    csrr x14, 0x9fe

    #Unmapped address 0x34 testing: Read Reset + Random data Write/Read
    #Address 0x34 read value
    csrr x14, 0x34

    #Address 0x34 Write value 0xce6cf094
    li x3, 0xce6cf094
    csrw 0x34, x3

    #Address 0x34 read value
    csrr x14, 0x34

    #Unmapped address 0x48f testing: Read Reset + Random data Write/Read
    #Address 0x48f read value
    csrr x14, 0x48f

    #Address 0x48f Write value 0x7a1bf684
    li x3, 0x7a1bf684
    csrw 0x48f, x3

    #Address 0x48f read value
    csrr x14, 0x48f

    #Unmapped address 0xac6 testing: Read Reset + Random data Write/Read
    #Address 0xac6 read value
    csrr x14, 0xac6

    #Address 0xac6 Write value 0xdec23ab
    li x3, 0xdec23ab
    csrw 0xac6, x3

    #Address 0xac6 read value
    csrr x14, 0xac6

    #Unmapped address 0x390 testing: Read Reset + Random data Write/Read
    #Address 0x390 read value
    csrr x14, 0x390

    #Address 0x390 Write value 0x5843533e
    li x3, 0x5843533e
    csrw 0x390, x3

    #Address 0x390 read value
    csrr x14, 0x390

    #Unmapped address 0x26 testing: Read Reset + Random data Write/Read
    #Address 0x26 read value
    csrr x14, 0x26

    #Address 0x26 Write value 0x27c9b86a
    li x3, 0x27c9b86a
    csrw 0x26, x3

    #Address 0x26 read value
    csrr x14, 0x26

    #Unmapped address 0x5e7 testing: Read Reset + Random data Write/Read
    #Address 0x5e7 read value
    csrr x14, 0x5e7

    #Address 0x5e7 Write value 0x44609fb0
    li x3, 0x44609fb0
    csrw 0x5e7, x3

    #Address 0x5e7 read value
    csrr x14, 0x5e7

    #Unmapped address 0x5b0 testing: Read Reset + Random data Write/Read
    #Address 0x5b0 read value
    csrr x14, 0x5b0

    #Address 0x5b0 Write value 0x6676b8aa
    li x3, 0x6676b8aa
    csrw 0x5b0, x3

    #Address 0x5b0 read value
    csrr x14, 0x5b0

    #Unmapped address 0x438 testing: Read Reset + Random data Write/Read
    #Address 0x438 read value
    csrr x14, 0x438

    #Address 0x438 Write value 0x43221a1
    li x3, 0x43221a1
    csrw 0x438, x3

    #Address 0x438 read value
    csrr x14, 0x438

    #Unmapped address 0xc73 testing: Read Reset + Random data Write/Read
    #Address 0xc73 read value
    csrr x14, 0xc73

    #Address 0xc73 Write value 0x7e979eaa
    li x3, 0x7e979eaa
    csrw 0xc73, x3

    #Address 0xc73 read value
    csrr x14, 0xc73

    #Unmapped address 0xaef testing: Read Reset + Random data Write/Read
    #Address 0xaef read value
    csrr x14, 0xaef

    #Address 0xaef Write value 0xae61f8f0
    li x3, 0xae61f8f0
    csrw 0xaef, x3

    #Address 0xaef read value
    csrr x14, 0xaef

    #Unmapped address 0xe7f testing: Read Reset + Random data Write/Read
    #Address 0xe7f read value
    csrr x14, 0xe7f

    #Address 0xe7f Write value 0xad46893c
    li x3, 0xad46893c
    csrw 0xe7f, x3

    #Address 0xe7f read value
    csrr x14, 0xe7f

    #Unmapped address 0xeb7 testing: Read Reset + Random data Write/Read
    #Address 0xeb7 read value
    csrr x14, 0xeb7

    #Address 0xeb7 Write value 0x37383e39
    li x3, 0x37383e39
    csrw 0xeb7, x3

    #Address 0xeb7 read value
    csrr x14, 0xeb7

    #Unmapped address 0xa80 testing: Read Reset + Random data Write/Read
    #Address 0xa80 read value
    csrr x14, 0xa80

    #Address 0xa80 Write value 0x1f01bea5
    li x3, 0x1f01bea5
    csrw 0xa80, x3

    #Address 0xa80 read value
    csrr x14, 0xa80

    #Unmapped address 0x507 testing: Read Reset + Random data Write/Read
    #Address 0x507 read value
    csrr x14, 0x507

    #Address 0x507 Write value 0x7f62a8e9
    li x3, 0x7f62a8e9
    csrw 0x507, x3

    #Address 0x507 read value
    csrr x14, 0x507

    #Unmapped address 0x750 testing: Read Reset + Random data Write/Read
    #Address 0x750 read value
    csrr x14, 0x750

    #Address 0x750 Write value 0x4ffe037b
    li x3, 0x4ffe037b
    csrw 0x750, x3

    #Address 0x750 read value
    csrr x14, 0x750

    #Unmapped address 0x1f5 testing: Read Reset + Random data Write/Read
    #Address 0x1f5 read value
    csrr x14, 0x1f5

    #Address 0x1f5 Write value 0x48b60167
    li x3, 0x48b60167
    csrw 0x1f5, x3

    #Address 0x1f5 read value
    csrr x14, 0x1f5

    #Unmapped address 0xf60 testing: Read Reset + Random data Write/Read
    #Address 0xf60 read value
    csrr x14, 0xf60

    #Address 0xf60 Write value 0x680d5dd1
    li x3, 0x680d5dd1
    csrw 0xf60, x3

    #Address 0xf60 read value
    csrr x14, 0xf60

    #Unmapped address 0xbab testing: Read Reset + Random data Write/Read
    #Address 0xbab read value
    csrr x14, 0xbab

    #Address 0xbab Write value 0xa6ff9f9e
    li x3, 0xa6ff9f9e
    csrw 0xbab, x3

    #Address 0xbab read value
    csrr x14, 0xbab

    #Unmapped address 0x556 testing: Read Reset + Random data Write/Read
    #Address 0x556 read value
    csrr x14, 0x556

    #Address 0x556 Write value 0xcb3dda0d
    li x3, 0xcb3dda0d
    csrw 0x556, x3

    #Address 0x556 read value
    csrr x14, 0x556

    #Unmapped address 0x425 testing: Read Reset + Random data Write/Read
    #Address 0x425 read value
    csrr x14, 0x425

    #Address 0x425 Write value 0x75e38dcc
    li x3, 0x75e38dcc
    csrw 0x425, x3

    #Address 0x425 read value
    csrr x14, 0x425

    #Unmapped address 0x1e4 testing: Read Reset + Random data Write/Read
    #Address 0x1e4 read value
    csrr x14, 0x1e4

    #Address 0x1e4 Write value 0x5e5d5179
    li x3, 0x5e5d5179
    csrw 0x1e4, x3

    #Address 0x1e4 read value
    csrr x14, 0x1e4

    #Unmapped address 0xd20 testing: Read Reset + Random data Write/Read
    #Address 0xd20 read value
    csrr x14, 0xd20

    #Address 0xd20 Write value 0xbcd08f9e
    li x3, 0xbcd08f9e
    csrw 0xd20, x3

    #Address 0xd20 read value
    csrr x14, 0xd20

    #Unmapped address 0xae1 testing: Read Reset + Random data Write/Read
    #Address 0xae1 read value
    csrr x14, 0xae1

    #Address 0xae1 Write value 0x50a9fde7
    li x3, 0x50a9fde7
    csrw 0xae1, x3

    #Address 0xae1 read value
    csrr x14, 0xae1

    #Unmapped address 0x7b8 testing: Read Reset + Random data Write/Read
    #Address 0x7b8 read value
    csrr x14, 0x7b8

    #Address 0x7b8 Write value 0xd0a30c3a
    li x3, 0xd0a30c3a
    csrw 0x7b8, x3

    #Address 0x7b8 read value
    csrr x14, 0x7b8

    #Unmapped address 0xaae testing: Read Reset + Random data Write/Read
    #Address 0xaae read value
    csrr x14, 0xaae

    #Address 0xaae Write value 0x8ca7d5b4
    li x3, 0x8ca7d5b4
    csrw 0xaae, x3

    #Address 0xaae read value
    csrr x14, 0xaae

    #Unmapped address 0x5c1 testing: Read Reset + Random data Write/Read
    #Address 0x5c1 read value
    csrr x14, 0x5c1

    #Address 0x5c1 Write value 0xdd7ee282
    li x3, 0xdd7ee282
    csrw 0x5c1, x3

    #Address 0x5c1 read value
    csrr x14, 0x5c1

    #Unmapped address 0x2fb testing: Read Reset + Random data Write/Read
    #Address 0x2fb read value
    csrr x14, 0x2fb

    #Address 0x2fb Write value 0x66d870c9
    li x3, 0x66d870c9
    csrw 0x2fb, x3

    #Address 0x2fb read value
    csrr x14, 0x2fb

    #Unmapped address 0x1af testing: Read Reset + Random data Write/Read
    #Address 0x1af read value
    csrr x14, 0x1af

    #Address 0x1af Write value 0x5532b913
    li x3, 0x5532b913
    csrw 0x1af, x3

    #Address 0x1af read value
    csrr x14, 0x1af

    #Unmapped address 0xbbe testing: Read Reset + Random data Write/Read
    #Address 0xbbe read value
    csrr x14, 0xbbe

    #Address 0xbbe Write value 0xf7857fdc
    li x3, 0xf7857fdc
    csrw 0xbbe, x3

    #Address 0xbbe read value
    csrr x14, 0xbbe

    #Unmapped address 0x321 testing: Read Reset + Random data Write/Read
    #Address 0x321 read value
    csrr x14, 0x321

    #Address 0x321 Write value 0xafb9e68a
    li x3, 0xafb9e68a
    csrw 0x321, x3

    #Address 0x321 read value
    csrr x14, 0x321

    #Unmapped address 0x6de testing: Read Reset + Random data Write/Read
    #Address 0x6de read value
    csrr x14, 0x6de

    #Address 0x6de Write value 0xab4a164
    li x3, 0xab4a164
    csrw 0x6de, x3

    #Address 0x6de read value
    csrr x14, 0x6de

    #Unmapped address 0x590 testing: Read Reset + Random data Write/Read
    #Address 0x590 read value
    csrr x14, 0x590

    #Address 0x590 Write value 0x47c4baff
    li x3, 0x47c4baff
    csrw 0x590, x3

    #Address 0x590 read value
    csrr x14, 0x590

    #Unmapped address 0x497 testing: Read Reset + Random data Write/Read
    #Address 0x497 read value
    csrr x14, 0x497

    #Address 0x497 Write value 0x8d4839bc
    li x3, 0x8d4839bc
    csrw 0x497, x3

    #Address 0x497 read value
    csrr x14, 0x497

    #Unmapped address 0x602 testing: Read Reset + Random data Write/Read
    #Address 0x602 read value
    csrr x14, 0x602

    #Address 0x602 Write value 0xcc5f314a
    li x3, 0xcc5f314a
    csrw 0x602, x3

    #Address 0x602 read value
    csrr x14, 0x602

    #Unmapped address 0xd26 testing: Read Reset + Random data Write/Read
    #Address 0xd26 read value
    csrr x14, 0xd26

    #Address 0xd26 Write value 0x6d7ef8aa
    li x3, 0x6d7ef8aa
    csrw 0xd26, x3

    #Address 0xd26 read value
    csrr x14, 0xd26

    #Unmapped address 0xaee testing: Read Reset + Random data Write/Read
    #Address 0xaee read value
    csrr x14, 0xaee

    #Address 0xaee Write value 0x1661694a
    li x3, 0x1661694a
    csrw 0xaee, x3

    #Address 0xaee read value
    csrr x14, 0xaee

    #Unmapped address 0x4aa testing: Read Reset + Random data Write/Read
    #Address 0x4aa read value
    csrr x14, 0x4aa

    #Address 0x4aa Write value 0x4a54ca38
    li x3, 0x4a54ca38
    csrw 0x4aa, x3

    #Address 0x4aa read value
    csrr x14, 0x4aa

    #Unmapped address 0x7b4 testing: Read Reset + Random data Write/Read
    #Address 0x7b4 read value
    csrr x14, 0x7b4

    #Address 0x7b4 Write value 0xcfffe0e6
    li x3, 0xcfffe0e6
    csrw 0x7b4, x3

    #Address 0x7b4 read value
    csrr x14, 0x7b4

    #Unmapped address 0x77a testing: Read Reset + Random data Write/Read
    #Address 0x77a read value
    csrr x14, 0x77a

    #Address 0x77a Write value 0xadae76a4
    li x3, 0xadae76a4
    csrw 0x77a, x3

    #Address 0x77a read value
    csrr x14, 0x77a

    #Unmapped address 0x11d testing: Read Reset + Random data Write/Read
    #Address 0x11d read value
    csrr x14, 0x11d

    #Address 0x11d Write value 0xbf811b53
    li x3, 0xbf811b53
    csrw 0x11d, x3

    #Address 0x11d read value
    csrr x14, 0x11d

    #Unmapped address 0x38d testing: Read Reset + Random data Write/Read
    #Address 0x38d read value
    csrr x14, 0x38d

    #Address 0x38d Write value 0xcbce2919
    li x3, 0xcbce2919
    csrw 0x38d, x3

    #Address 0x38d read value
    csrr x14, 0x38d

    #Unmapped address 0x2f5 testing: Read Reset + Random data Write/Read
    #Address 0x2f5 read value
    csrr x14, 0x2f5

    #Address 0x2f5 Write value 0x2ade5079
    li x3, 0x2ade5079
    csrw 0x2f5, x3

    #Address 0x2f5 read value
    csrr x14, 0x2f5

    #Unmapped address 0x954 testing: Read Reset + Random data Write/Read
    #Address 0x954 read value
    csrr x14, 0x954

    #Address 0x954 Write value 0xcf3935f2
    li x3, 0xcf3935f2
    csrw 0x954, x3

    #Address 0x954 read value
    csrr x14, 0x954

    #Unmapped address 0x296 testing: Read Reset + Random data Write/Read
    #Address 0x296 read value
    csrr x14, 0x296

    #Address 0x296 Write value 0x338e6974
    li x3, 0x338e6974
    csrw 0x296, x3

    #Address 0x296 read value
    csrr x14, 0x296

    #Unmapped address 0x35f testing: Read Reset + Random data Write/Read
    #Address 0x35f read value
    csrr x14, 0x35f

    #Address 0x35f Write value 0xdf007684
    li x3, 0xdf007684
    csrw 0x35f, x3

    #Address 0x35f read value
    csrr x14, 0x35f

    #Unmapped address 0xbc7 testing: Read Reset + Random data Write/Read
    #Address 0xbc7 read value
    csrr x14, 0xbc7

    #Address 0xbc7 Write value 0x26e92eed
    li x3, 0x26e92eed
    csrw 0xbc7, x3

    #Address 0xbc7 read value
    csrr x14, 0xbc7

    #Unmapped address 0xe6c testing: Read Reset + Random data Write/Read
    #Address 0xe6c read value
    csrr x14, 0xe6c

    #Address 0xe6c Write value 0xac9735dc
    li x3, 0xac9735dc
    csrw 0xe6c, x3

    #Address 0xe6c read value
    csrr x14, 0xe6c

    #Unmapped address 0x501 testing: Read Reset + Random data Write/Read
    #Address 0x501 read value
    csrr x14, 0x501

    #Address 0x501 Write value 0x4c61d5b0
    li x3, 0x4c61d5b0
    csrw 0x501, x3

    #Address 0x501 read value
    csrr x14, 0x501

    #Unmapped address 0xd92 testing: Read Reset + Random data Write/Read
    #Address 0xd92 read value
    csrr x14, 0xd92

    #Address 0xd92 Write value 0xaab95b3f
    li x3, 0xaab95b3f
    csrw 0xd92, x3

    #Address 0xd92 read value
    csrr x14, 0xd92

    #Unmapped address 0x6a3 testing: Read Reset + Random data Write/Read
    #Address 0x6a3 read value
    csrr x14, 0x6a3

    #Address 0x6a3 Write value 0x867ad425
    li x3, 0x867ad425
    csrw 0x6a3, x3

    #Address 0x6a3 read value
    csrr x14, 0x6a3

    #Unmapped address 0x9a5 testing: Read Reset + Random data Write/Read
    #Address 0x9a5 read value
    csrr x14, 0x9a5

    #Address 0x9a5 Write value 0xde508aed
    li x3, 0xde508aed
    csrw 0x9a5, x3

    #Address 0x9a5 read value
    csrr x14, 0x9a5

    #Unmapped address 0x236 testing: Read Reset + Random data Write/Read
    #Address 0x236 read value
    csrr x14, 0x236

    #Address 0x236 Write value 0x9be5a667
    li x3, 0x9be5a667
    csrw 0x236, x3

    #Address 0x236 read value
    csrr x14, 0x236

    #Unmapped address 0x96 testing: Read Reset + Random data Write/Read
    #Address 0x96 read value
    csrr x14, 0x96

    #Address 0x96 Write value 0x8e6732cf
    li x3, 0x8e6732cf
    csrw 0x96, x3

    #Address 0x96 read value
    csrr x14, 0x96

    #Unmapped address 0xff5 testing: Read Reset + Random data Write/Read
    #Address 0xff5 read value
    csrr x14, 0xff5

    #Address 0xff5 Write value 0x6644e002
    li x3, 0x6644e002
    csrw 0xff5, x3

    #Address 0xff5 read value
    csrr x14, 0xff5

    #Unmapped address 0xbac testing: Read Reset + Random data Write/Read
    #Address 0xbac read value
    csrr x14, 0xbac

    #Address 0xbac Write value 0x595e6e0a
    li x3, 0x595e6e0a
    csrw 0xbac, x3

    #Address 0xbac read value
    csrr x14, 0xbac

    #Unmapped address 0xeeb testing: Read Reset + Random data Write/Read
    #Address 0xeeb read value
    csrr x14, 0xeeb

    #Address 0xeeb Write value 0x356d5051
    li x3, 0x356d5051
    csrw 0xeeb, x3

    #Address 0xeeb read value
    csrr x14, 0xeeb

    #Unmapped address 0x231 testing: Read Reset + Random data Write/Read
    #Address 0x231 read value
    csrr x14, 0x231

    #Address 0x231 Write value 0x25889b62
    li x3, 0x25889b62
    csrw 0x231, x3

    #Address 0x231 read value
    csrr x14, 0x231

    #Unmapped address 0xa3e testing: Read Reset + Random data Write/Read
    #Address 0xa3e read value
    csrr x14, 0xa3e

    #Address 0xa3e Write value 0xc8dfc610
    li x3, 0xc8dfc610
    csrw 0xa3e, x3

    #Address 0xa3e read value
    csrr x14, 0xa3e

    #Unmapped address 0x3c4 testing: Read Reset + Random data Write/Read
    #Address 0x3c4 read value
    csrr x14, 0x3c4

    #Address 0x3c4 Write value 0x5b1f42a7
    li x3, 0x5b1f42a7
    csrw 0x3c4, x3

    #Address 0x3c4 read value
    csrr x14, 0x3c4

    #Unmapped address 0x8fd testing: Read Reset + Random data Write/Read
    #Address 0x8fd read value
    csrr x14, 0x8fd

    #Address 0x8fd Write value 0x8d290647
    li x3, 0x8d290647
    csrw 0x8fd, x3

    #Address 0x8fd read value
    csrr x14, 0x8fd

    #Unmapped address 0x68f testing: Read Reset + Random data Write/Read
    #Address 0x68f read value
    csrr x14, 0x68f

    #Address 0x68f Write value 0xb97c2441
    li x3, 0xb97c2441
    csrw 0x68f, x3

    #Address 0x68f read value
    csrr x14, 0x68f

    #Unmapped address 0x688 testing: Read Reset + Random data Write/Read
    #Address 0x688 read value
    csrr x14, 0x688

    #Address 0x688 Write value 0x258febee
    li x3, 0x258febee
    csrw 0x688, x3

    #Address 0x688 read value
    csrr x14, 0x688

    #Unmapped address 0x964 testing: Read Reset + Random data Write/Read
    #Address 0x964 read value
    csrr x14, 0x964

    #Address 0x964 Write value 0x97b97808
    li x3, 0x97b97808
    csrw 0x964, x3

    #Address 0x964 read value
    csrr x14, 0x964

    #Unmapped address 0x779 testing: Read Reset + Random data Write/Read
    #Address 0x779 read value
    csrr x14, 0x779

    #Address 0x779 Write value 0x86e76cd
    li x3, 0x86e76cd
    csrw 0x779, x3

    #Address 0x779 read value
    csrr x14, 0x779

    #Unmapped address 0xe00 testing: Read Reset + Random data Write/Read
    #Address 0xe00 read value
    csrr x14, 0xe00

    #Address 0xe00 Write value 0x6ad90f2
    li x3, 0x6ad90f2
    csrw 0xe00, x3

    #Address 0xe00 read value
    csrr x14, 0xe00

    #Unmapped address 0x811 testing: Read Reset + Random data Write/Read
    #Address 0x811 read value
    csrr x14, 0x811

    #Address 0x811 Write value 0xec74fd7
    li x3, 0xec74fd7
    csrw 0x811, x3

    #Address 0x811 read value
    csrr x14, 0x811

    #Unmapped address 0x83 testing: Read Reset + Random data Write/Read
    #Address 0x83 read value
    csrr x14, 0x83

    #Address 0x83 Write value 0x9f29f60b
    li x3, 0x9f29f60b
    csrw 0x83, x3

    #Address 0x83 read value
    csrr x14, 0x83

    #Unmapped address 0x6a0 testing: Read Reset + Random data Write/Read
    #Address 0x6a0 read value
    csrr x14, 0x6a0

    #Address 0x6a0 Write value 0x6c8ddc42
    li x3, 0x6c8ddc42
    csrw 0x6a0, x3

    #Address 0x6a0 read value
    csrr x14, 0x6a0

    #Unmapped address 0x6db testing: Read Reset + Random data Write/Read
    #Address 0x6db read value
    csrr x14, 0x6db

    #Address 0x6db Write value 0x92f5c1ce
    li x3, 0x92f5c1ce
    csrw 0x6db, x3

    #Address 0x6db read value
    csrr x14, 0x6db

    #Unmapped address 0x6e2 testing: Read Reset + Random data Write/Read
    #Address 0x6e2 read value
    csrr x14, 0x6e2

    #Address 0x6e2 Write value 0x4d1d39a7
    li x3, 0x4d1d39a7
    csrw 0x6e2, x3

    #Address 0x6e2 read value
    csrr x14, 0x6e2

    #Unmapped address 0xeb5 testing: Read Reset + Random data Write/Read
    #Address 0xeb5 read value
    csrr x14, 0xeb5

    #Address 0xeb5 Write value 0x74b999f3
    li x3, 0x74b999f3
    csrw 0xeb5, x3

    #Address 0xeb5 read value
    csrr x14, 0xeb5

    #Unmapped address 0x6ad testing: Read Reset + Random data Write/Read
    #Address 0x6ad read value
    csrr x14, 0x6ad

    #Address 0x6ad Write value 0x53e0e8c9
    li x3, 0x53e0e8c9
    csrw 0x6ad, x3

    #Address 0x6ad read value
    csrr x14, 0x6ad

    #Unmapped address 0x715 testing: Read Reset + Random data Write/Read
    #Address 0x715 read value
    csrr x14, 0x715

    #Address 0x715 Write value 0x1a5e5014
    li x3, 0x1a5e5014
    csrw 0x715, x3

    #Address 0x715 read value
    csrr x14, 0x715

    #Unmapped address 0x849 testing: Read Reset + Random data Write/Read
    #Address 0x849 read value
    csrr x14, 0x849

    #Address 0x849 Write value 0x3be8a447
    li x3, 0x3be8a447
    csrw 0x849, x3

    #Address 0x849 read value
    csrr x14, 0x849

    #Unmapped address 0x24e testing: Read Reset + Random data Write/Read
    #Address 0x24e read value
    csrr x14, 0x24e

    #Address 0x24e Write value 0xf19b2ac8
    li x3, 0xf19b2ac8
    csrw 0x24e, x3

    #Address 0x24e read value
    csrr x14, 0x24e

    #Unmapped address 0xbca testing: Read Reset + Random data Write/Read
    #Address 0xbca read value
    csrr x14, 0xbca

    #Address 0xbca Write value 0x749ef7bc
    li x3, 0x749ef7bc
    csrw 0xbca, x3

    #Address 0xbca read value
    csrr x14, 0xbca

    #Unmapped address 0x76d testing: Read Reset + Random data Write/Read
    #Address 0x76d read value
    csrr x14, 0x76d

    #Address 0x76d Write value 0x5f48a1ff
    li x3, 0x5f48a1ff
    csrw 0x76d, x3

    #Address 0x76d read value
    csrr x14, 0x76d

    #Unmapped address 0xf56 testing: Read Reset + Random data Write/Read
    #Address 0xf56 read value
    csrr x14, 0xf56

    #Address 0xf56 Write value 0xf70024cc
    li x3, 0xf70024cc
    csrw 0xf56, x3

    #Address 0xf56 read value
    csrr x14, 0xf56

    #Unmapped address 0x6b testing: Read Reset + Random data Write/Read
    #Address 0x6b read value
    csrr x14, 0x6b

    #Address 0x6b Write value 0x3fe04037
    li x3, 0x3fe04037
    csrw 0x6b, x3

    #Address 0x6b read value
    csrr x14, 0x6b

    #Unmapped address 0x630 testing: Read Reset + Random data Write/Read
    #Address 0x630 read value
    csrr x14, 0x630

    #Address 0x630 Write value 0x67a6675
    li x3, 0x67a6675
    csrw 0x630, x3

    #Address 0x630 read value
    csrr x14, 0x630

    #Unmapped address 0x7cb testing: Read Reset + Random data Write/Read
    #Address 0x7cb read value
    csrr x14, 0x7cb

    #Address 0x7cb Write value 0x3655f4f7
    li x3, 0x3655f4f7
    csrw 0x7cb, x3

    #Address 0x7cb read value
    csrr x14, 0x7cb

    #Unmapped address 0x437 testing: Read Reset + Random data Write/Read
    #Address 0x437 read value
    csrr x14, 0x437

    #Address 0x437 Write value 0x13a4a1e7
    li x3, 0x13a4a1e7
    csrw 0x437, x3

    #Address 0x437 read value
    csrr x14, 0x437

    #Unmapped address 0xddc testing: Read Reset + Random data Write/Read
    #Address 0xddc read value
    csrr x14, 0xddc

    #Address 0xddc Write value 0x2b05d3a0
    li x3, 0x2b05d3a0
    csrw 0xddc, x3

    #Address 0xddc read value
    csrr x14, 0xddc

    #Unmapped address 0xd7a testing: Read Reset + Random data Write/Read
    #Address 0xd7a read value
    csrr x14, 0xd7a

    #Address 0xd7a Write value 0x3e7ac3df
    li x3, 0x3e7ac3df
    csrw 0xd7a, x3

    #Address 0xd7a read value
    csrr x14, 0xd7a

    #Unmapped address 0x62c testing: Read Reset + Random data Write/Read
    #Address 0x62c read value
    csrr x14, 0x62c

    #Address 0x62c Write value 0x3dcde357
    li x3, 0x3dcde357
    csrw 0x62c, x3

    #Address 0x62c read value
    csrr x14, 0x62c

    #Unmapped address 0x7d8 testing: Read Reset + Random data Write/Read
    #Address 0x7d8 read value
    csrr x14, 0x7d8

    #Address 0x7d8 Write value 0x8b05c952
    li x3, 0x8b05c952
    csrw 0x7d8, x3

    #Address 0x7d8 read value
    csrr x14, 0x7d8

    #Unmapped address 0x853 testing: Read Reset + Random data Write/Read
    #Address 0x853 read value
    csrr x14, 0x853

    #Address 0x853 Write value 0x89fd229c
    li x3, 0x89fd229c
    csrw 0x853, x3

    #Address 0x853 read value
    csrr x14, 0x853

    #Unmapped address 0xff7 testing: Read Reset + Random data Write/Read
    #Address 0xff7 read value
    csrr x14, 0xff7

    #Address 0xff7 Write value 0x6a7f7bb2
    li x3, 0x6a7f7bb2
    csrw 0xff7, x3

    #Address 0xff7 read value
    csrr x14, 0xff7

    #Unmapped address 0x535 testing: Read Reset + Random data Write/Read
    #Address 0x535 read value
    csrr x14, 0x535

    #Address 0x535 Write value 0x2ce355ed
    li x3, 0x2ce355ed
    csrw 0x535, x3

    #Address 0x535 read value
    csrr x14, 0x535

    #Unmapped address 0x4c7 testing: Read Reset + Random data Write/Read
    #Address 0x4c7 read value
    csrr x14, 0x4c7

    #Address 0x4c7 Write value 0x982c30f6
    li x3, 0x982c30f6
    csrw 0x4c7, x3

    #Address 0x4c7 read value
    csrr x14, 0x4c7

    #Unmapped address 0x764 testing: Read Reset + Random data Write/Read
    #Address 0x764 read value
    csrr x14, 0x764

    #Address 0x764 Write value 0xfefaa6ab
    li x3, 0xfefaa6ab
    csrw 0x764, x3

    #Address 0x764 read value
    csrr x14, 0x764

    #Unmapped address 0x9b0 testing: Read Reset + Random data Write/Read
    #Address 0x9b0 read value
    csrr x14, 0x9b0

    #Address 0x9b0 Write value 0xa3a107da
    li x3, 0xa3a107da
    csrw 0x9b0, x3

    #Address 0x9b0 read value
    csrr x14, 0x9b0

    #Unmapped address 0xa59 testing: Read Reset + Random data Write/Read
    #Address 0xa59 read value
    csrr x14, 0xa59

    #Address 0xa59 Write value 0x8dea1e0a
    li x3, 0x8dea1e0a
    csrw 0xa59, x3

    #Address 0xa59 read value
    csrr x14, 0xa59

    #Unmapped address 0x4d4 testing: Read Reset + Random data Write/Read
    #Address 0x4d4 read value
    csrr x14, 0x4d4

    #Address 0x4d4 Write value 0xf27a6b85
    li x3, 0xf27a6b85
    csrw 0x4d4, x3

    #Address 0x4d4 read value
    csrr x14, 0x4d4

    #Unmapped address 0x62f testing: Read Reset + Random data Write/Read
    #Address 0x62f read value
    csrr x14, 0x62f

    #Address 0x62f Write value 0x8c8fed49
    li x3, 0x8c8fed49
    csrw 0x62f, x3

    #Address 0x62f read value
    csrr x14, 0x62f

    #Unmapped address 0xc72 testing: Read Reset + Random data Write/Read
    #Address 0xc72 read value
    csrr x14, 0xc72

    #Address 0xc72 Write value 0x27fe2da4
    li x3, 0x27fe2da4
    csrw 0xc72, x3

    #Address 0xc72 read value
    csrr x14, 0xc72

    #Unmapped address 0x1da testing: Read Reset + Random data Write/Read
    #Address 0x1da read value
    csrr x14, 0x1da

    #Address 0x1da Write value 0xa1e4805c
    li x3, 0xa1e4805c
    csrw 0x1da, x3

    #Address 0x1da read value
    csrr x14, 0x1da

    #Unmapped address 0x9cf testing: Read Reset + Random data Write/Read
    #Address 0x9cf read value
    csrr x14, 0x9cf

    #Address 0x9cf Write value 0x4c422cd4
    li x3, 0x4c422cd4
    csrw 0x9cf, x3

    #Address 0x9cf read value
    csrr x14, 0x9cf

    #Unmapped address 0xab2 testing: Read Reset + Random data Write/Read
    #Address 0xab2 read value
    csrr x14, 0xab2

    #Address 0xab2 Write value 0x29c290eb
    li x3, 0x29c290eb
    csrw 0xab2, x3

    #Address 0xab2 read value
    csrr x14, 0xab2

    #Unmapped address 0x79b testing: Read Reset + Random data Write/Read
    #Address 0x79b read value
    csrr x14, 0x79b

    #Address 0x79b Write value 0x2455ed6a
    li x3, 0x2455ed6a
    csrw 0x79b, x3

    #Address 0x79b read value
    csrr x14, 0x79b

    #Unmapped address 0xbda testing: Read Reset + Random data Write/Read
    #Address 0xbda read value
    csrr x14, 0xbda

    #Address 0xbda Write value 0xb589e702
    li x3, 0xb589e702
    csrw 0xbda, x3

    #Address 0xbda read value
    csrr x14, 0xbda

    #Unmapped address 0x895 testing: Read Reset + Random data Write/Read
    #Address 0x895 read value
    csrr x14, 0x895

    #Address 0x895 Write value 0xf1d8585
    li x3, 0xf1d8585
    csrw 0x895, x3

    #Address 0x895 read value
    csrr x14, 0x895

    #Unmapped address 0x79 testing: Read Reset + Random data Write/Read
    #Address 0x79 read value
    csrr x14, 0x79

    #Address 0x79 Write value 0xa0226fbf
    li x3, 0xa0226fbf
    csrw 0x79, x3

    #Address 0x79 read value
    csrr x14, 0x79

    #Unmapped address 0xa7c testing: Read Reset + Random data Write/Read
    #Address 0xa7c read value
    csrr x14, 0xa7c

    #Address 0xa7c Write value 0xb57b79ef
    li x3, 0xb57b79ef
    csrw 0xa7c, x3

    #Address 0xa7c read value
    csrr x14, 0xa7c

    #Unmapped address 0xb76 testing: Read Reset + Random data Write/Read
    #Address 0xb76 read value
    csrr x14, 0xb76

    #Address 0xb76 Write value 0x67803f52
    li x3, 0x67803f52
    csrw 0xb76, x3

    #Address 0xb76 read value
    csrr x14, 0xb76

    #Unmapped address 0xbb6 testing: Read Reset + Random data Write/Read
    #Address 0xbb6 read value
    csrr x14, 0xbb6

    #Address 0xbb6 Write value 0x4c2c90a6
    li x3, 0x4c2c90a6
    csrw 0xbb6, x3

    #Address 0xbb6 read value
    csrr x14, 0xbb6

    #Unmapped address 0x892 testing: Read Reset + Random data Write/Read
    #Address 0x892 read value
    csrr x14, 0x892

    #Address 0x892 Write value 0x1c76a994
    li x3, 0x1c76a994
    csrw 0x892, x3

    #Address 0x892 read value
    csrr x14, 0x892

    #Unmapped address 0xd4e testing: Read Reset + Random data Write/Read
    #Address 0xd4e read value
    csrr x14, 0xd4e

    #Address 0xd4e Write value 0xda383791
    li x3, 0xda383791
    csrw 0xd4e, x3

    #Address 0xd4e read value
    csrr x14, 0xd4e

    #Unmapped address 0x391 testing: Read Reset + Random data Write/Read
    #Address 0x391 read value
    csrr x14, 0x391

    #Address 0x391 Write value 0x7f7544e6
    li x3, 0x7f7544e6
    csrw 0x391, x3

    #Address 0x391 read value
    csrr x14, 0x391

    #Unmapped address 0xbb7 testing: Read Reset + Random data Write/Read
    #Address 0xbb7 read value
    csrr x14, 0xbb7

    #Address 0xbb7 Write value 0x9403aa05
    li x3, 0x9403aa05
    csrw 0xbb7, x3

    #Address 0xbb7 read value
    csrr x14, 0xbb7

    #Unmapped address 0xa02 testing: Read Reset + Random data Write/Read
    #Address 0xa02 read value
    csrr x14, 0xa02

    #Address 0xa02 Write value 0x8f9c0ef4
    li x3, 0x8f9c0ef4
    csrw 0xa02, x3

    #Address 0xa02 read value
    csrr x14, 0xa02

    #Unmapped address 0x913 testing: Read Reset + Random data Write/Read
    #Address 0x913 read value
    csrr x14, 0x913

    #Address 0x913 Write value 0xa0ad3a65
    li x3, 0xa0ad3a65
    csrw 0x913, x3

    #Address 0x913 read value
    csrr x14, 0x913

    #Unmapped address 0x67e testing: Read Reset + Random data Write/Read
    #Address 0x67e read value
    csrr x14, 0x67e

    #Address 0x67e Write value 0x6e949b0e
    li x3, 0x6e949b0e
    csrw 0x67e, x3

    #Address 0x67e read value
    csrr x14, 0x67e

    #Unmapped address 0x8bd testing: Read Reset + Random data Write/Read
    #Address 0x8bd read value
    csrr x14, 0x8bd

    #Address 0x8bd Write value 0x74d2ddc9
    li x3, 0x74d2ddc9
    csrw 0x8bd, x3

    #Address 0x8bd read value
    csrr x14, 0x8bd

    #Unmapped address 0x166 testing: Read Reset + Random data Write/Read
    #Address 0x166 read value
    csrr x14, 0x166

    #Address 0x166 Write value 0x956c50e4
    li x3, 0x956c50e4
    csrw 0x166, x3

    #Address 0x166 read value
    csrr x14, 0x166

    #Unmapped address 0xc3a testing: Read Reset + Random data Write/Read
    #Address 0xc3a read value
    csrr x14, 0xc3a

    #Address 0xc3a Write value 0x41e15e2b
    li x3, 0x41e15e2b
    csrw 0xc3a, x3

    #Address 0xc3a read value
    csrr x14, 0xc3a

    #Unmapped address 0xb26 testing: Read Reset + Random data Write/Read
    #Address 0xb26 read value
    csrr x14, 0xb26

    #Address 0xb26 Write value 0xd8fd6145
    li x3, 0xd8fd6145
    csrw 0xb26, x3

    #Address 0xb26 read value
    csrr x14, 0xb26

    #Unmapped address 0xdc6 testing: Read Reset + Random data Write/Read
    #Address 0xdc6 read value
    csrr x14, 0xdc6

    #Address 0xdc6 Write value 0x39badaf8
    li x3, 0x39badaf8
    csrw 0xdc6, x3

    #Address 0xdc6 read value
    csrr x14, 0xdc6

    #Unmapped address 0xf9f testing: Read Reset + Random data Write/Read
    #Address 0xf9f read value
    csrr x14, 0xf9f

    #Address 0xf9f Write value 0x70feffbc
    li x3, 0x70feffbc
    csrw 0xf9f, x3

    #Address 0xf9f read value
    csrr x14, 0xf9f

    #Unmapped address 0x2a8 testing: Read Reset + Random data Write/Read
    #Address 0x2a8 read value
    csrr x14, 0x2a8

    #Address 0x2a8 Write value 0x92f68cb
    li x3, 0x92f68cb
    csrw 0x2a8, x3

    #Address 0x2a8 read value
    csrr x14, 0x2a8

    #Unmapped address 0xb2b testing: Read Reset + Random data Write/Read
    #Address 0xb2b read value
    csrr x14, 0xb2b

    #Address 0xb2b Write value 0x693a97d
    li x3, 0x693a97d
    csrw 0xb2b, x3

    #Address 0xb2b read value
    csrr x14, 0xb2b

    #Unmapped address 0x462 testing: Read Reset + Random data Write/Read
    #Address 0x462 read value
    csrr x14, 0x462

    #Address 0x462 Write value 0x4d28dff1
    li x3, 0x4d28dff1
    csrw 0x462, x3

    #Address 0x462 read value
    csrr x14, 0x462

    #Unmapped address 0xd3b testing: Read Reset + Random data Write/Read
    #Address 0xd3b read value
    csrr x14, 0xd3b

    #Address 0xd3b Write value 0x8177be7
    li x3, 0x8177be7
    csrw 0xd3b, x3

    #Address 0xd3b read value
    csrr x14, 0xd3b

    #Unmapped address 0x658 testing: Read Reset + Random data Write/Read
    #Address 0x658 read value
    csrr x14, 0x658

    #Address 0x658 Write value 0x2779b6b0
    li x3, 0x2779b6b0
    csrw 0x658, x3

    #Address 0x658 read value
    csrr x14, 0x658

    #Unmapped address 0x4b0 testing: Read Reset + Random data Write/Read
    #Address 0x4b0 read value
    csrr x14, 0x4b0

    #Address 0x4b0 Write value 0x2038afe9
    li x3, 0x2038afe9
    csrw 0x4b0, x3

    #Address 0x4b0 read value
    csrr x14, 0x4b0

    #Unmapped address 0x650 testing: Read Reset + Random data Write/Read
    #Address 0x650 read value
    csrr x14, 0x650

    #Address 0x650 Write value 0x2c057281
    li x3, 0x2c057281
    csrw 0x650, x3

    #Address 0x650 read value
    csrr x14, 0x650

    #Unmapped address 0x871 testing: Read Reset + Random data Write/Read
    #Address 0x871 read value
    csrr x14, 0x871

    #Address 0x871 Write value 0xac67bf14
    li x3, 0xac67bf14
    csrw 0x871, x3

    #Address 0x871 read value
    csrr x14, 0x871

    #Unmapped address 0x23d testing: Read Reset + Random data Write/Read
    #Address 0x23d read value
    csrr x14, 0x23d

    #Address 0x23d Write value 0xbcedc9d2
    li x3, 0xbcedc9d2
    csrw 0x23d, x3

    #Address 0x23d read value
    csrr x14, 0x23d

    #Unmapped address 0xa8c testing: Read Reset + Random data Write/Read
    #Address 0xa8c read value
    csrr x14, 0xa8c

    #Address 0xa8c Write value 0x72487234
    li x3, 0x72487234
    csrw 0xa8c, x3

    #Address 0xa8c read value
    csrr x14, 0xa8c

    #Unmapped address 0x1ef testing: Read Reset + Random data Write/Read
    #Address 0x1ef read value
    csrr x14, 0x1ef

    #Address 0x1ef Write value 0x5f328e86
    li x3, 0x5f328e86
    csrw 0x1ef, x3

    #Address 0x1ef read value
    csrr x14, 0x1ef

    #Unmapped address 0x636 testing: Read Reset + Random data Write/Read
    #Address 0x636 read value
    csrr x14, 0x636

    #Address 0x636 Write value 0x55a71385
    li x3, 0x55a71385
    csrw 0x636, x3

    #Address 0x636 read value
    csrr x14, 0x636

    #Unmapped address 0x288 testing: Read Reset + Random data Write/Read
    #Address 0x288 read value
    csrr x14, 0x288

    #Address 0x288 Write value 0x7d0cf7e4
    li x3, 0x7d0cf7e4
    csrw 0x288, x3

    #Address 0x288 read value
    csrr x14, 0x288

    #Unmapped address 0xfc0 testing: Read Reset + Random data Write/Read
    #Address 0xfc0 read value
    csrr x14, 0xfc0

    #Address 0xfc0 Write value 0xbf17a40a
    li x3, 0xbf17a40a
    csrw 0xfc0, x3

    #Address 0xfc0 read value
    csrr x14, 0xfc0

    #Unmapped address 0xc34 testing: Read Reset + Random data Write/Read
    #Address 0xc34 read value
    csrr x14, 0xc34

    #Address 0xc34 Write value 0xcb9b1167
    li x3, 0xcb9b1167
    csrw 0xc34, x3

    #Address 0xc34 read value
    csrr x14, 0xc34

    #Unmapped address 0x773 testing: Read Reset + Random data Write/Read
    #Address 0x773 read value
    csrr x14, 0x773

    #Address 0x773 Write value 0x23ec9053
    li x3, 0x23ec9053
    csrw 0x773, x3

    #Address 0x773 read value
    csrr x14, 0x773

    #Unmapped address 0xb3c testing: Read Reset + Random data Write/Read
    #Address 0xb3c read value
    csrr x14, 0xb3c

    #Address 0xb3c Write value 0xbd759501
    li x3, 0xbd759501
    csrw 0xb3c, x3

    #Address 0xb3c read value
    csrr x14, 0xb3c

    #Unmapped address 0x1b6 testing: Read Reset + Random data Write/Read
    #Address 0x1b6 read value
    csrr x14, 0x1b6

    #Address 0x1b6 Write value 0x4d6a0d70
    li x3, 0x4d6a0d70
    csrw 0x1b6, x3

    #Address 0x1b6 read value
    csrr x14, 0x1b6

    #Unmapped address 0x7f1 testing: Read Reset + Random data Write/Read
    #Address 0x7f1 read value
    csrr x14, 0x7f1

    #Address 0x7f1 Write value 0xa98f4b6f
    li x3, 0xa98f4b6f
    csrw 0x7f1, x3

    #Address 0x7f1 read value
    csrr x14, 0x7f1

    #Unmapped address 0xc0e testing: Read Reset + Random data Write/Read
    #Address 0xc0e read value
    csrr x14, 0xc0e

    #Address 0xc0e Write value 0xcc51261a
    li x3, 0xcc51261a
    csrw 0xc0e, x3

    #Address 0xc0e read value
    csrr x14, 0xc0e

    #Unmapped address 0x5d3 testing: Read Reset + Random data Write/Read
    #Address 0x5d3 read value
    csrr x14, 0x5d3

    #Address 0x5d3 Write value 0xd0e4c83d
    li x3, 0xd0e4c83d
    csrw 0x5d3, x3

    #Address 0x5d3 read value
    csrr x14, 0x5d3

    #Unmapped address 0x2cc testing: Read Reset + Random data Write/Read
    #Address 0x2cc read value
    csrr x14, 0x2cc

    #Address 0x2cc Write value 0xfb704375
    li x3, 0xfb704375
    csrw 0x2cc, x3

    #Address 0x2cc read value
    csrr x14, 0x2cc

    #Unmapped address 0x80b testing: Read Reset + Random data Write/Read
    #Address 0x80b read value
    csrr x14, 0x80b

    #Address 0x80b Write value 0xb4a2d315
    li x3, 0xb4a2d315
    csrw 0x80b, x3

    #Address 0x80b read value
    csrr x14, 0x80b

    #Unmapped address 0x825 testing: Read Reset + Random data Write/Read
    #Address 0x825 read value
    csrr x14, 0x825

    #Address 0x825 Write value 0x87ffc189
    li x3, 0x87ffc189
    csrw 0x825, x3

    #Address 0x825 read value
    csrr x14, 0x825

    #Unmapped address 0x3f0 testing: Read Reset + Random data Write/Read
    #Address 0x3f0 read value
    csrr x14, 0x3f0

    #Address 0x3f0 Write value 0xe346ae4a
    li x3, 0xe346ae4a
    csrw 0x3f0, x3

    #Address 0x3f0 read value
    csrr x14, 0x3f0

    #Unmapped address 0xe8 testing: Read Reset + Random data Write/Read
    #Address 0xe8 read value
    csrr x14, 0xe8

    #Address 0xe8 Write value 0x56229071
    li x3, 0x56229071
    csrw 0xe8, x3

    #Address 0xe8 read value
    csrr x14, 0xe8

    #Unmapped address 0x9f7 testing: Read Reset + Random data Write/Read
    #Address 0x9f7 read value
    csrr x14, 0x9f7

    #Address 0x9f7 Write value 0x6754c6bc
    li x3, 0x6754c6bc
    csrw 0x9f7, x3

    #Address 0x9f7 read value
    csrr x14, 0x9f7

    #Unmapped address 0xaca testing: Read Reset + Random data Write/Read
    #Address 0xaca read value
    csrr x14, 0xaca

    #Address 0xaca Write value 0xaba4380a
    li x3, 0xaba4380a
    csrw 0xaca, x3

    #Address 0xaca read value
    csrr x14, 0xaca

    #Unmapped address 0xc74 testing: Read Reset + Random data Write/Read
    #Address 0xc74 read value
    csrr x14, 0xc74

    #Address 0xc74 Write value 0xd37da478
    li x3, 0xd37da478
    csrw 0xc74, x3

    #Address 0xc74 read value
    csrr x14, 0xc74

    #Unmapped address 0x8b3 testing: Read Reset + Random data Write/Read
    #Address 0x8b3 read value
    csrr x14, 0x8b3

    #Address 0x8b3 Write value 0x8de6292d
    li x3, 0x8de6292d
    csrw 0x8b3, x3

    #Address 0x8b3 read value
    csrr x14, 0x8b3

    #Unmapped address 0xaf8 testing: Read Reset + Random data Write/Read
    #Address 0xaf8 read value
    csrr x14, 0xaf8

    #Address 0xaf8 Write value 0x1d7bbece
    li x3, 0x1d7bbece
    csrw 0xaf8, x3

    #Address 0xaf8 read value
    csrr x14, 0xaf8

    #Unmapped address 0x16a testing: Read Reset + Random data Write/Read
    #Address 0x16a read value
    csrr x14, 0x16a

    #Address 0x16a Write value 0xba1f775e
    li x3, 0xba1f775e
    csrw 0x16a, x3

    #Address 0x16a read value
    csrr x14, 0x16a

    #Unmapped address 0x11e testing: Read Reset + Random data Write/Read
    #Address 0x11e read value
    csrr x14, 0x11e

    #Address 0x11e Write value 0x726c72ca
    li x3, 0x726c72ca
    csrw 0x11e, x3

    #Address 0x11e read value
    csrr x14, 0x11e

    #Unmapped address 0x63d testing: Read Reset + Random data Write/Read
    #Address 0x63d read value
    csrr x14, 0x63d

    #Address 0x63d Write value 0x857c575a
    li x3, 0x857c575a
    csrw 0x63d, x3

    #Address 0x63d read value
    csrr x14, 0x63d

    #Unmapped address 0x84b testing: Read Reset + Random data Write/Read
    #Address 0x84b read value
    csrr x14, 0x84b

    #Address 0x84b Write value 0x294b45dc
    li x3, 0x294b45dc
    csrw 0x84b, x3

    #Address 0x84b read value
    csrr x14, 0x84b

    #Unmapped address 0xcd4 testing: Read Reset + Random data Write/Read
    #Address 0xcd4 read value
    csrr x14, 0xcd4

    #Address 0xcd4 Write value 0x172300eb
    li x3, 0x172300eb
    csrw 0xcd4, x3

    #Address 0xcd4 read value
    csrr x14, 0xcd4

    #Unmapped address 0x8d testing: Read Reset + Random data Write/Read
    #Address 0x8d read value
    csrr x14, 0x8d

    #Address 0x8d Write value 0x28ee80f2
    li x3, 0x28ee80f2
    csrw 0x8d, x3

    #Address 0x8d read value
    csrr x14, 0x8d

    #Unmapped address 0xbd3 testing: Read Reset + Random data Write/Read
    #Address 0xbd3 read value
    csrr x14, 0xbd3

    #Address 0xbd3 Write value 0x6226b3d6
    li x3, 0x6226b3d6
    csrw 0xbd3, x3

    #Address 0xbd3 read value
    csrr x14, 0xbd3

    #Unmapped address 0xdc8 testing: Read Reset + Random data Write/Read
    #Address 0xdc8 read value
    csrr x14, 0xdc8

    #Address 0xdc8 Write value 0x1380cc32
    li x3, 0x1380cc32
    csrw 0xdc8, x3

    #Address 0xdc8 read value
    csrr x14, 0xdc8

    #Unmapped address 0xcda testing: Read Reset + Random data Write/Read
    #Address 0xcda read value
    csrr x14, 0xcda

    #Address 0xcda Write value 0xd878014c
    li x3, 0xd878014c
    csrw 0xcda, x3

    #Address 0xcda read value
    csrr x14, 0xcda

    #Unmapped address 0x5d testing: Read Reset + Random data Write/Read
    #Address 0x5d read value
    csrr x14, 0x5d

    #Address 0x5d Write value 0xbd2d787
    li x3, 0xbd2d787
    csrw 0x5d, x3

    #Address 0x5d read value
    csrr x14, 0x5d

    #Unmapped address 0xace testing: Read Reset + Random data Write/Read
    #Address 0xace read value
    csrr x14, 0xace

    #Address 0xace Write value 0x8b815c21
    li x3, 0x8b815c21
    csrw 0xace, x3

    #Address 0xace read value
    csrr x14, 0xace

    #Unmapped address 0xdbc testing: Read Reset + Random data Write/Read
    #Address 0xdbc read value
    csrr x14, 0xdbc

    #Address 0xdbc Write value 0x8e69613b
    li x3, 0x8e69613b
    csrw 0xdbc, x3

    #Address 0xdbc read value
    csrr x14, 0xdbc

    #Unmapped address 0x440 testing: Read Reset + Random data Write/Read
    #Address 0x440 read value
    csrr x14, 0x440

    #Address 0x440 Write value 0xba4eb014
    li x3, 0xba4eb014
    csrw 0x440, x3

    #Address 0x440 read value
    csrr x14, 0x440

    #Unmapped address 0x250 testing: Read Reset + Random data Write/Read
    #Address 0x250 read value
    csrr x14, 0x250

    #Address 0x250 Write value 0x53357b02
    li x3, 0x53357b02
    csrw 0x250, x3

    #Address 0x250 read value
    csrr x14, 0x250

    #Unmapped address 0xf4b testing: Read Reset + Random data Write/Read
    #Address 0xf4b read value
    csrr x14, 0xf4b

    #Address 0xf4b Write value 0xbb21e154
    li x3, 0xbb21e154
    csrw 0xf4b, x3

    #Address 0xf4b read value
    csrr x14, 0xf4b

    #Unmapped address 0x1c0 testing: Read Reset + Random data Write/Read
    #Address 0x1c0 read value
    csrr x14, 0x1c0

    #Address 0x1c0 Write value 0x666b027c
    li x3, 0x666b027c
    csrw 0x1c0, x3

    #Address 0x1c0 read value
    csrr x14, 0x1c0

    #Unmapped address 0x3ce testing: Read Reset + Random data Write/Read
    #Address 0x3ce read value
    csrr x14, 0x3ce

    #Address 0x3ce Write value 0x67e4d32e
    li x3, 0x67e4d32e
    csrw 0x3ce, x3

    #Address 0x3ce read value
    csrr x14, 0x3ce

    #Unmapped address 0x603 testing: Read Reset + Random data Write/Read
    #Address 0x603 read value
    csrr x14, 0x603

    #Address 0x603 Write value 0xadd93c6e
    li x3, 0xadd93c6e
    csrw 0x603, x3

    #Address 0x603 read value
    csrr x14, 0x603

    #Unmapped address 0xbc4 testing: Read Reset + Random data Write/Read
    #Address 0xbc4 read value
    csrr x14, 0xbc4

    #Address 0xbc4 Write value 0xda3401b0
    li x3, 0xda3401b0
    csrw 0xbc4, x3

    #Address 0xbc4 read value
    csrr x14, 0xbc4

    #Unmapped address 0x956 testing: Read Reset + Random data Write/Read
    #Address 0x956 read value
    csrr x14, 0x956

    #Address 0x956 Write value 0x5dfa9a5d
    li x3, 0x5dfa9a5d
    csrw 0x956, x3

    #Address 0x956 read value
    csrr x14, 0x956

    #Unmapped address 0xfe0 testing: Read Reset + Random data Write/Read
    #Address 0xfe0 read value
    csrr x14, 0xfe0

    #Address 0xfe0 Write value 0x3aeea30c
    li x3, 0x3aeea30c
    csrw 0xfe0, x3

    #Address 0xfe0 read value
    csrr x14, 0xfe0

    #Unmapped address 0xe94 testing: Read Reset + Random data Write/Read
    #Address 0xe94 read value
    csrr x14, 0xe94

    #Address 0xe94 Write value 0xf2237d23
    li x3, 0xf2237d23
    csrw 0xe94, x3

    #Address 0xe94 read value
    csrr x14, 0xe94

    #Unmapped address 0xd39 testing: Read Reset + Random data Write/Read
    #Address 0xd39 read value
    csrr x14, 0xd39

    #Address 0xd39 Write value 0x47600c09
    li x3, 0x47600c09
    csrw 0xd39, x3

    #Address 0xd39 read value
    csrr x14, 0xd39

    #Unmapped address 0xc62 testing: Read Reset + Random data Write/Read
    #Address 0xc62 read value
    csrr x14, 0xc62

    #Address 0xc62 Write value 0x6b2cdec9
    li x3, 0x6b2cdec9
    csrw 0xc62, x3

    #Address 0xc62 read value
    csrr x14, 0xc62

    #Unmapped address 0x85d testing: Read Reset + Random data Write/Read
    #Address 0x85d read value
    csrr x14, 0x85d

    #Address 0x85d Write value 0x304b39c
    li x3, 0x304b39c
    csrw 0x85d, x3

    #Address 0x85d read value
    csrr x14, 0x85d

    #Unmapped address 0x2a1 testing: Read Reset + Random data Write/Read
    #Address 0x2a1 read value
    csrr x14, 0x2a1

    #Address 0x2a1 Write value 0x925dd20
    li x3, 0x925dd20
    csrw 0x2a1, x3

    #Address 0x2a1 read value
    csrr x14, 0x2a1

    #Unmapped address 0x14b testing: Read Reset + Random data Write/Read
    #Address 0x14b read value
    csrr x14, 0x14b

    #Address 0x14b Write value 0x2e8a5ace
    li x3, 0x2e8a5ace
    csrw 0x14b, x3

    #Address 0x14b read value
    csrr x14, 0x14b

    #Unmapped address 0x27c testing: Read Reset + Random data Write/Read
    #Address 0x27c read value
    csrr x14, 0x27c

    #Address 0x27c Write value 0x8bf1149e
    li x3, 0x8bf1149e
    csrw 0x27c, x3

    #Address 0x27c read value
    csrr x14, 0x27c

    #Unmapped address 0x182 testing: Read Reset + Random data Write/Read
    #Address 0x182 read value
    csrr x14, 0x182

    #Address 0x182 Write value 0x60ce1b8d
    li x3, 0x60ce1b8d
    csrw 0x182, x3

    #Address 0x182 read value
    csrr x14, 0x182

    #Unmapped address 0x27d testing: Read Reset + Random data Write/Read
    #Address 0x27d read value
    csrr x14, 0x27d

    #Address 0x27d Write value 0xbe61a23c
    li x3, 0xbe61a23c
    csrw 0x27d, x3

    #Address 0x27d read value
    csrr x14, 0x27d

    #Unmapped address 0xec8 testing: Read Reset + Random data Write/Read
    #Address 0xec8 read value
    csrr x14, 0xec8

    #Address 0xec8 Write value 0x40db43fa
    li x3, 0x40db43fa
    csrw 0xec8, x3

    #Address 0xec8 read value
    csrr x14, 0xec8

    #Unmapped address 0xe34 testing: Read Reset + Random data Write/Read
    #Address 0xe34 read value
    csrr x14, 0xe34

    #Address 0xe34 Write value 0xbfa43852
    li x3, 0xbfa43852
    csrw 0xe34, x3

    #Address 0xe34 read value
    csrr x14, 0xe34

    #Unmapped address 0x6cb testing: Read Reset + Random data Write/Read
    #Address 0x6cb read value
    csrr x14, 0x6cb

    #Address 0x6cb Write value 0xff4c1430
    li x3, 0xff4c1430
    csrw 0x6cb, x3

    #Address 0x6cb read value
    csrr x14, 0x6cb

    #Unmapped address 0x125 testing: Read Reset + Random data Write/Read
    #Address 0x125 read value
    csrr x14, 0x125

    #Address 0x125 Write value 0x2e35465a
    li x3, 0x2e35465a
    csrw 0x125, x3

    #Address 0x125 read value
    csrr x14, 0x125

    #Unmapped address 0x880 testing: Read Reset + Random data Write/Read
    #Address 0x880 read value
    csrr x14, 0x880

    #Address 0x880 Write value 0x1e06de07
    li x3, 0x1e06de07
    csrw 0x880, x3

    #Address 0x880 read value
    csrr x14, 0x880

    #Unmapped address 0xee5 testing: Read Reset + Random data Write/Read
    #Address 0xee5 read value
    csrr x14, 0xee5

    #Address 0xee5 Write value 0xf91db789
    li x3, 0xf91db789
    csrw 0xee5, x3

    #Address 0xee5 read value
    csrr x14, 0xee5

    #Unmapped address 0xfdf testing: Read Reset + Random data Write/Read
    #Address 0xfdf read value
    csrr x14, 0xfdf

    #Address 0xfdf Write value 0xda700a5a
    li x3, 0xda700a5a
    csrw 0xfdf, x3

    #Address 0xfdf read value
    csrr x14, 0xfdf

    #Unmapped address 0x21f testing: Read Reset + Random data Write/Read
    #Address 0x21f read value
    csrr x14, 0x21f

    #Address 0x21f Write value 0x37cb9a55
    li x3, 0x37cb9a55
    csrw 0x21f, x3

    #Address 0x21f read value
    csrr x14, 0x21f

    #Unmapped address 0x5e1 testing: Read Reset + Random data Write/Read
    #Address 0x5e1 read value
    csrr x14, 0x5e1

    #Address 0x5e1 Write value 0xd345b2d3
    li x3, 0xd345b2d3
    csrw 0x5e1, x3

    #Address 0x5e1 read value
    csrr x14, 0x5e1

    #Unmapped address 0xa26 testing: Read Reset + Random data Write/Read
    #Address 0xa26 read value
    csrr x14, 0xa26

    #Address 0xa26 Write value 0xc2fcc670
    li x3, 0xc2fcc670
    csrw 0xa26, x3

    #Address 0xa26 read value
    csrr x14, 0xa26

    #Unmapped address 0x298 testing: Read Reset + Random data Write/Read
    #Address 0x298 read value
    csrr x14, 0x298

    #Address 0x298 Write value 0x57895e39
    li x3, 0x57895e39
    csrw 0x298, x3

    #Address 0x298 read value
    csrr x14, 0x298

    #Unmapped address 0xf8c testing: Read Reset + Random data Write/Read
    #Address 0xf8c read value
    csrr x14, 0xf8c

    #Address 0xf8c Write value 0x63e020fe
    li x3, 0x63e020fe
    csrw 0xf8c, x3

    #Address 0xf8c read value
    csrr x14, 0xf8c

    #Unmapped address 0x733 testing: Read Reset + Random data Write/Read
    #Address 0x733 read value
    csrr x14, 0x733

    #Address 0x733 Write value 0x3c35843a
    li x3, 0x3c35843a
    csrw 0x733, x3

    #Address 0x733 read value
    csrr x14, 0x733

    #Unmapped address 0xf57 testing: Read Reset + Random data Write/Read
    #Address 0xf57 read value
    csrr x14, 0xf57

    #Address 0xf57 Write value 0x4e30c98b
    li x3, 0x4e30c98b
    csrw 0xf57, x3

    #Address 0xf57 read value
    csrr x14, 0xf57

    #Unmapped address 0x35c testing: Read Reset + Random data Write/Read
    #Address 0x35c read value
    csrr x14, 0x35c

    #Address 0x35c Write value 0xe825a9e4
    li x3, 0xe825a9e4
    csrw 0x35c, x3

    #Address 0x35c read value
    csrr x14, 0x35c

    #Unmapped address 0x904 testing: Read Reset + Random data Write/Read
    #Address 0x904 read value
    csrr x14, 0x904

    #Address 0x904 Write value 0xcfbc1073
    li x3, 0xcfbc1073
    csrw 0x904, x3

    #Address 0x904 read value
    csrr x14, 0x904

    #Unmapped address 0xd73 testing: Read Reset + Random data Write/Read
    #Address 0xd73 read value
    csrr x14, 0xd73

    #Address 0xd73 Write value 0x6727058e
    li x3, 0x6727058e
    csrw 0xd73, x3

    #Address 0xd73 read value
    csrr x14, 0xd73

    #Unmapped address 0x263 testing: Read Reset + Random data Write/Read
    #Address 0x263 read value
    csrr x14, 0x263

    #Address 0x263 Write value 0x495132cf
    li x3, 0x495132cf
    csrw 0x263, x3

    #Address 0x263 read value
    csrr x14, 0x263

    #Unmapped address 0x7c9 testing: Read Reset + Random data Write/Read
    #Address 0x7c9 read value
    csrr x14, 0x7c9

    #Address 0x7c9 Write value 0x88a11548
    li x3, 0x88a11548
    csrw 0x7c9, x3

    #Address 0x7c9 read value
    csrr x14, 0x7c9

    #Unmapped address 0x480 testing: Read Reset + Random data Write/Read
    #Address 0x480 read value
    csrr x14, 0x480

    #Address 0x480 Write value 0x7e207522
    li x3, 0x7e207522
    csrw 0x480, x3

    #Address 0x480 read value
    csrr x14, 0x480

    #Unmapped address 0x9d5 testing: Read Reset + Random data Write/Read
    #Address 0x9d5 read value
    csrr x14, 0x9d5

    #Address 0x9d5 Write value 0x14d0c54d
    li x3, 0x14d0c54d
    csrw 0x9d5, x3

    #Address 0x9d5 read value
    csrr x14, 0x9d5

    #Unmapped address 0x644 testing: Read Reset + Random data Write/Read
    #Address 0x644 read value
    csrr x14, 0x644

    #Address 0x644 Write value 0x8a02b372
    li x3, 0x8a02b372
    csrw 0x644, x3

    #Address 0x644 read value
    csrr x14, 0x644

    #Unmapped address 0x97 testing: Read Reset + Random data Write/Read
    #Address 0x97 read value
    csrr x14, 0x97

    #Address 0x97 Write value 0xe7b879fe
    li x3, 0xe7b879fe
    csrw 0x97, x3

    #Address 0x97 read value
    csrr x14, 0x97

    #Unmapped address 0xc8d testing: Read Reset + Random data Write/Read
    #Address 0xc8d read value
    csrr x14, 0xc8d

    #Address 0xc8d Write value 0x21d64194
    li x3, 0x21d64194
    csrw 0xc8d, x3

    #Address 0xc8d read value
    csrr x14, 0xc8d

    #Unmapped address 0x2b8 testing: Read Reset + Random data Write/Read
    #Address 0x2b8 read value
    csrr x14, 0x2b8

    #Address 0x2b8 Write value 0xa980211c
    li x3, 0xa980211c
    csrw 0x2b8, x3

    #Address 0x2b8 read value
    csrr x14, 0x2b8

    #Unmapped address 0x70c testing: Read Reset + Random data Write/Read
    #Address 0x70c read value
    csrr x14, 0x70c

    #Address 0x70c Write value 0xd1b8085
    li x3, 0xd1b8085
    csrw 0x70c, x3

    #Address 0x70c read value
    csrr x14, 0x70c

    #Unmapped address 0xf5e testing: Read Reset + Random data Write/Read
    #Address 0xf5e read value
    csrr x14, 0xf5e

    #Address 0xf5e Write value 0xea0b713
    li x3, 0xea0b713
    csrw 0xf5e, x3

    #Address 0xf5e read value
    csrr x14, 0xf5e

    #Unmapped address 0xd4c testing: Read Reset + Random data Write/Read
    #Address 0xd4c read value
    csrr x14, 0xd4c

    #Address 0xd4c Write value 0xfeb1815f
    li x3, 0xfeb1815f
    csrw 0xd4c, x3

    #Address 0xd4c read value
    csrr x14, 0xd4c

    #Unmapped address 0xbf6 testing: Read Reset + Random data Write/Read
    #Address 0xbf6 read value
    csrr x14, 0xbf6

    #Address 0xbf6 Write value 0xdf927e7b
    li x3, 0xdf927e7b
    csrw 0xbf6, x3

    #Address 0xbf6 read value
    csrr x14, 0xbf6

    #Unmapped address 0x371 testing: Read Reset + Random data Write/Read
    #Address 0x371 read value
    csrr x14, 0x371

    #Address 0x371 Write value 0x11b7b19d
    li x3, 0x11b7b19d
    csrw 0x371, x3

    #Address 0x371 read value
    csrr x14, 0x371

    #Unmapped address 0xd8a testing: Read Reset + Random data Write/Read
    #Address 0xd8a read value
    csrr x14, 0xd8a

    #Address 0xd8a Write value 0xe47e6a37
    li x3, 0xe47e6a37
    csrw 0xd8a, x3

    #Address 0xd8a read value
    csrr x14, 0xd8a

    #Unmapped address 0xef6 testing: Read Reset + Random data Write/Read
    #Address 0xef6 read value
    csrr x14, 0xef6

    #Address 0xef6 Write value 0xcb1dc1f4
    li x3, 0xcb1dc1f4
    csrw 0xef6, x3

    #Address 0xef6 read value
    csrr x14, 0xef6

    #Unmapped address 0xa45 testing: Read Reset + Random data Write/Read
    #Address 0xa45 read value
    csrr x14, 0xa45

    #Address 0xa45 Write value 0x51d4b4bc
    li x3, 0x51d4b4bc
    csrw 0xa45, x3

    #Address 0xa45 read value
    csrr x14, 0xa45

    #Unmapped address 0x193 testing: Read Reset + Random data Write/Read
    #Address 0x193 read value
    csrr x14, 0x193

    #Address 0x193 Write value 0xece8a240
    li x3, 0xece8a240
    csrw 0x193, x3

    #Address 0x193 read value
    csrr x14, 0x193

    #Unmapped address 0x1b8 testing: Read Reset + Random data Write/Read
    #Address 0x1b8 read value
    csrr x14, 0x1b8

    #Address 0x1b8 Write value 0x3946a782
    li x3, 0x3946a782
    csrw 0x1b8, x3

    #Address 0x1b8 read value
    csrr x14, 0x1b8

    #Unmapped address 0x8c8 testing: Read Reset + Random data Write/Read
    #Address 0x8c8 read value
    csrr x14, 0x8c8

    #Address 0x8c8 Write value 0xa2a2bea6
    li x3, 0xa2a2bea6
    csrw 0x8c8, x3

    #Address 0x8c8 read value
    csrr x14, 0x8c8

    #Unmapped address 0x4a2 testing: Read Reset + Random data Write/Read
    #Address 0x4a2 read value
    csrr x14, 0x4a2

    #Address 0x4a2 Write value 0x5ba2fa5e
    li x3, 0x5ba2fa5e
    csrw 0x4a2, x3

    #Address 0x4a2 read value
    csrr x14, 0x4a2

    #Unmapped address 0xce2 testing: Read Reset + Random data Write/Read
    #Address 0xce2 read value
    csrr x14, 0xce2

    #Address 0xce2 Write value 0x77ce7a3f
    li x3, 0x77ce7a3f
    csrw 0xce2, x3

    #Address 0xce2 read value
    csrr x14, 0xce2

    #Unmapped address 0xcb5 testing: Read Reset + Random data Write/Read
    #Address 0xcb5 read value
    csrr x14, 0xcb5

    #Address 0xcb5 Write value 0xdb0df58a
    li x3, 0xdb0df58a
    csrw 0xcb5, x3

    #Address 0xcb5 read value
    csrr x14, 0xcb5

    #Unmapped address 0x826 testing: Read Reset + Random data Write/Read
    #Address 0x826 read value
    csrr x14, 0x826

    #Address 0x826 Write value 0xe9958b56
    li x3, 0xe9958b56
    csrw 0x826, x3

    #Address 0x826 read value
    csrr x14, 0x826

    #Unmapped address 0xc79 testing: Read Reset + Random data Write/Read
    #Address 0xc79 read value
    csrr x14, 0xc79

    #Address 0xc79 Write value 0x9f44cde4
    li x3, 0x9f44cde4
    csrw 0xc79, x3

    #Address 0xc79 read value
    csrr x14, 0xc79

    #Unmapped address 0xe45 testing: Read Reset + Random data Write/Read
    #Address 0xe45 read value
    csrr x14, 0xe45

    #Address 0xe45 Write value 0x623a4a59
    li x3, 0x623a4a59
    csrw 0xe45, x3

    #Address 0xe45 read value
    csrr x14, 0xe45

    #Unmapped address 0xce6 testing: Read Reset + Random data Write/Read
    #Address 0xce6 read value
    csrr x14, 0xce6

    #Address 0xce6 Write value 0xc55e40c6
    li x3, 0xc55e40c6
    csrw 0xce6, x3

    #Address 0xce6 read value
    csrr x14, 0xce6

    #Unmapped address 0xf87 testing: Read Reset + Random data Write/Read
    #Address 0xf87 read value
    csrr x14, 0xf87

    #Address 0xf87 Write value 0x78afb03a
    li x3, 0x78afb03a
    csrw 0xf87, x3

    #Address 0xf87 read value
    csrr x14, 0xf87

    #Unmapped address 0xf3c testing: Read Reset + Random data Write/Read
    #Address 0xf3c read value
    csrr x14, 0xf3c

    #Address 0xf3c Write value 0xa84ddbbd
    li x3, 0xa84ddbbd
    csrw 0xf3c, x3

    #Address 0xf3c read value
    csrr x14, 0xf3c

    #Unmapped address 0x6fa testing: Read Reset + Random data Write/Read
    #Address 0x6fa read value
    csrr x14, 0x6fa

    #Address 0x6fa Write value 0x1256800f
    li x3, 0x1256800f
    csrw 0x6fa, x3

    #Address 0x6fa read value
    csrr x14, 0x6fa

    #Unmapped address 0x7ca testing: Read Reset + Random data Write/Read
    #Address 0x7ca read value
    csrr x14, 0x7ca

    #Address 0x7ca Write value 0x2cf1d1bc
    li x3, 0x2cf1d1bc
    csrw 0x7ca, x3

    #Address 0x7ca read value
    csrr x14, 0x7ca

    #Unmapped address 0x852 testing: Read Reset + Random data Write/Read
    #Address 0x852 read value
    csrr x14, 0x852

    #Address 0x852 Write value 0x84241cba
    li x3, 0x84241cba
    csrw 0x852, x3

    #Address 0x852 read value
    csrr x14, 0x852

    #Unmapped address 0x6c7 testing: Read Reset + Random data Write/Read
    #Address 0x6c7 read value
    csrr x14, 0x6c7

    #Address 0x6c7 Write value 0x13fa282c
    li x3, 0x13fa282c
    csrw 0x6c7, x3

    #Address 0x6c7 read value
    csrr x14, 0x6c7

    #Unmapped address 0x97f testing: Read Reset + Random data Write/Read
    #Address 0x97f read value
    csrr x14, 0x97f

    #Address 0x97f Write value 0x50030bfc
    li x3, 0x50030bfc
    csrw 0x97f, x3

    #Address 0x97f read value
    csrr x14, 0x97f

    #Unmapped address 0xb49 testing: Read Reset + Random data Write/Read
    #Address 0xb49 read value
    csrr x14, 0xb49

    #Address 0xb49 Write value 0xf2483117
    li x3, 0xf2483117
    csrw 0xb49, x3

    #Address 0xb49 read value
    csrr x14, 0xb49

    #Unmapped address 0xd5 testing: Read Reset + Random data Write/Read
    #Address 0xd5 read value
    csrr x14, 0xd5

    #Address 0xd5 Write value 0xf9f9f984
    li x3, 0xf9f9f984
    csrw 0xd5, x3

    #Address 0xd5 read value
    csrr x14, 0xd5

    #Unmapped address 0xc43 testing: Read Reset + Random data Write/Read
    #Address 0xc43 read value
    csrr x14, 0xc43

    #Address 0xc43 Write value 0x5caf2336
    li x3, 0x5caf2336
    csrw 0xc43, x3

    #Address 0xc43 read value
    csrr x14, 0xc43

    #Unmapped address 0x2fa testing: Read Reset + Random data Write/Read
    #Address 0x2fa read value
    csrr x14, 0x2fa

    #Address 0x2fa Write value 0x8bc5d1c3
    li x3, 0x8bc5d1c3
    csrw 0x2fa, x3

    #Address 0x2fa read value
    csrr x14, 0x2fa

    #Unmapped address 0xdab testing: Read Reset + Random data Write/Read
    #Address 0xdab read value
    csrr x14, 0xdab

    #Address 0xdab Write value 0xd3f45327
    li x3, 0xd3f45327
    csrw 0xdab, x3

    #Address 0xdab read value
    csrr x14, 0xdab

    #Unmapped address 0xa21 testing: Read Reset + Random data Write/Read
    #Address 0xa21 read value
    csrr x14, 0xa21

    #Address 0xa21 Write value 0xba7b60e
    li x3, 0xba7b60e
    csrw 0xa21, x3

    #Address 0xa21 read value
    csrr x14, 0xa21

    #Unmapped address 0x59 testing: Read Reset + Random data Write/Read
    #Address 0x59 read value
    csrr x14, 0x59

    #Address 0x59 Write value 0xf5681def
    li x3, 0xf5681def
    csrw 0x59, x3

    #Address 0x59 read value
    csrr x14, 0x59

    #Unmapped address 0x9eb testing: Read Reset + Random data Write/Read
    #Address 0x9eb read value
    csrr x14, 0x9eb

    #Address 0x9eb Write value 0x42daea5a
    li x3, 0x42daea5a
    csrw 0x9eb, x3

    #Address 0x9eb read value
    csrr x14, 0x9eb

    #Unmapped address 0x652 testing: Read Reset + Random data Write/Read
    #Address 0x652 read value
    csrr x14, 0x652

    #Address 0x652 Write value 0xe3c380ea
    li x3, 0xe3c380ea
    csrw 0x652, x3

    #Address 0x652 read value
    csrr x14, 0x652

    #Unmapped address 0x8ee testing: Read Reset + Random data Write/Read
    #Address 0x8ee read value
    csrr x14, 0x8ee

    #Address 0x8ee Write value 0x1bfeba7c
    li x3, 0x1bfeba7c
    csrw 0x8ee, x3

    #Address 0x8ee read value
    csrr x14, 0x8ee

    #Unmapped address 0x639 testing: Read Reset + Random data Write/Read
    #Address 0x639 read value
    csrr x14, 0x639

    #Address 0x639 Write value 0xd2ad6a1d
    li x3, 0xd2ad6a1d
    csrw 0x639, x3

    #Address 0x639 read value
    csrr x14, 0x639

    #Unmapped address 0xce5 testing: Read Reset + Random data Write/Read
    #Address 0xce5 read value
    csrr x14, 0xce5

    #Address 0xce5 Write value 0x7adfa2b
    li x3, 0x7adfa2b
    csrw 0xce5, x3

    #Address 0xce5 read value
    csrr x14, 0xce5

    #Unmapped address 0x45c testing: Read Reset + Random data Write/Read
    #Address 0x45c read value
    csrr x14, 0x45c

    #Address 0x45c Write value 0x5be913b4
    li x3, 0x5be913b4
    csrw 0x45c, x3

    #Address 0x45c read value
    csrr x14, 0x45c

    #Unmapped address 0x5f2 testing: Read Reset + Random data Write/Read
    #Address 0x5f2 read value
    csrr x14, 0x5f2

    #Address 0x5f2 Write value 0xf1a725db
    li x3, 0xf1a725db
    csrw 0x5f2, x3

    #Address 0x5f2 read value
    csrr x14, 0x5f2

    #Unmapped address 0x3e4 testing: Read Reset + Random data Write/Read
    #Address 0x3e4 read value
    csrr x14, 0x3e4

    #Address 0x3e4 Write value 0x4adb7d9d
    li x3, 0x4adb7d9d
    csrw 0x3e4, x3

    #Address 0x3e4 read value
    csrr x14, 0x3e4

    #Unmapped address 0x4e3 testing: Read Reset + Random data Write/Read
    #Address 0x4e3 read value
    csrr x14, 0x4e3

    #Address 0x4e3 Write value 0x7a027c0c
    li x3, 0x7a027c0c
    csrw 0x4e3, x3

    #Address 0x4e3 read value
    csrr x14, 0x4e3

    #Unmapped address 0xba8 testing: Read Reset + Random data Write/Read
    #Address 0xba8 read value
    csrr x14, 0xba8

    #Address 0xba8 Write value 0x2b17605a
    li x3, 0x2b17605a
    csrw 0xba8, x3

    #Address 0xba8 read value
    csrr x14, 0xba8

    #Unmapped address 0xb4d testing: Read Reset + Random data Write/Read
    #Address 0xb4d read value
    csrr x14, 0xb4d

    #Address 0xb4d Write value 0xb8743aaf
    li x3, 0xb8743aaf
    csrw 0xb4d, x3

    #Address 0xb4d read value
    csrr x14, 0xb4d

    #Unmapped address 0xc95 testing: Read Reset + Random data Write/Read
    #Address 0xc95 read value
    csrr x14, 0xc95

    #Address 0xc95 Write value 0x25f052e1
    li x3, 0x25f052e1
    csrw 0xc95, x3

    #Address 0xc95 read value
    csrr x14, 0xc95

    #Unmapped address 0x98b testing: Read Reset + Random data Write/Read
    #Address 0x98b read value
    csrr x14, 0x98b

    #Address 0x98b Write value 0xb4d5d429
    li x3, 0xb4d5d429
    csrw 0x98b, x3

    #Address 0x98b read value
    csrr x14, 0x98b

    #Unmapped address 0xc6e testing: Read Reset + Random data Write/Read
    #Address 0xc6e read value
    csrr x14, 0xc6e

    #Address 0xc6e Write value 0x94f047b6
    li x3, 0x94f047b6
    csrw 0xc6e, x3

    #Address 0xc6e read value
    csrr x14, 0xc6e

    #Unmapped address 0xb55 testing: Read Reset + Random data Write/Read
    #Address 0xb55 read value
    csrr x14, 0xb55

    #Address 0xb55 Write value 0x29da4146
    li x3, 0x29da4146
    csrw 0xb55, x3

    #Address 0xb55 read value
    csrr x14, 0xb55

    #Unmapped address 0xadc testing: Read Reset + Random data Write/Read
    #Address 0xadc read value
    csrr x14, 0xadc

    #Address 0xadc Write value 0xe006144e
    li x3, 0xe006144e
    csrw 0xadc, x3

    #Address 0xadc read value
    csrr x14, 0xadc

    #Unmapped address 0xdfc testing: Read Reset + Random data Write/Read
    #Address 0xdfc read value
    csrr x14, 0xdfc

    #Address 0xdfc Write value 0x9ace0bf5
    li x3, 0x9ace0bf5
    csrw 0xdfc, x3

    #Address 0xdfc read value
    csrr x14, 0xdfc

    #Unmapped address 0xe5d testing: Read Reset + Random data Write/Read
    #Address 0xe5d read value
    csrr x14, 0xe5d

    #Address 0xe5d Write value 0xd8bc6099
    li x3, 0xd8bc6099
    csrw 0xe5d, x3

    #Address 0xe5d read value
    csrr x14, 0xe5d

    #Unmapped address 0xd7 testing: Read Reset + Random data Write/Read
    #Address 0xd7 read value
    csrr x14, 0xd7

    #Address 0xd7 Write value 0xb6ca30f0
    li x3, 0xb6ca30f0
    csrw 0xd7, x3

    #Address 0xd7 read value
    csrr x14, 0xd7

    #Unmapped address 0x877 testing: Read Reset + Random data Write/Read
    #Address 0x877 read value
    csrr x14, 0x877

    #Address 0x877 Write value 0xdfbbd34f
    li x3, 0xdfbbd34f
    csrw 0x877, x3

    #Address 0x877 read value
    csrr x14, 0x877

    #Unmapped address 0xbe4 testing: Read Reset + Random data Write/Read
    #Address 0xbe4 read value
    csrr x14, 0xbe4

    #Address 0xbe4 Write value 0xab276b2c
    li x3, 0xab276b2c
    csrw 0xbe4, x3

    #Address 0xbe4 read value
    csrr x14, 0xbe4

    #Unmapped address 0x233 testing: Read Reset + Random data Write/Read
    #Address 0x233 read value
    csrr x14, 0x233

    #Address 0x233 Write value 0x29ed83aa
    li x3, 0x29ed83aa
    csrw 0x233, x3

    #Address 0x233 read value
    csrr x14, 0x233

    #Unmapped address 0xb46 testing: Read Reset + Random data Write/Read
    #Address 0xb46 read value
    csrr x14, 0xb46

    #Address 0xb46 Write value 0xc757ea5c
    li x3, 0xc757ea5c
    csrw 0xb46, x3

    #Address 0xb46 read value
    csrr x14, 0xb46

    #Unmapped address 0x9d4 testing: Read Reset + Random data Write/Read
    #Address 0x9d4 read value
    csrr x14, 0x9d4

    #Address 0x9d4 Write value 0xdc26847b
    li x3, 0xdc26847b
    csrw 0x9d4, x3

    #Address 0x9d4 read value
    csrr x14, 0x9d4

    #Unmapped address 0x7a testing: Read Reset + Random data Write/Read
    #Address 0x7a read value
    csrr x14, 0x7a

    #Address 0x7a Write value 0xd54d1098
    li x3, 0xd54d1098
    csrw 0x7a, x3

    #Address 0x7a read value
    csrr x14, 0x7a

    #Unmapped address 0x1ba testing: Read Reset + Random data Write/Read
    #Address 0x1ba read value
    csrr x14, 0x1ba

    #Address 0x1ba Write value 0xbbc439d1
    li x3, 0xbbc439d1
    csrw 0x1ba, x3

    #Address 0x1ba read value
    csrr x14, 0x1ba

    #Unmapped address 0xd0f testing: Read Reset + Random data Write/Read
    #Address 0xd0f read value
    csrr x14, 0xd0f

    #Address 0xd0f Write value 0xdd4b9b05
    li x3, 0xdd4b9b05
    csrw 0xd0f, x3

    #Address 0xd0f read value
    csrr x14, 0xd0f

    #Unmapped address 0x9a6 testing: Read Reset + Random data Write/Read
    #Address 0x9a6 read value
    csrr x14, 0x9a6

    #Address 0x9a6 Write value 0x20c7373
    li x3, 0x20c7373
    csrw 0x9a6, x3

    #Address 0x9a6 read value
    csrr x14, 0x9a6

    #Unmapped address 0xe57 testing: Read Reset + Random data Write/Read
    #Address 0xe57 read value
    csrr x14, 0xe57

    #Address 0xe57 Write value 0xe5e90209
    li x3, 0xe5e90209
    csrw 0xe57, x3

    #Address 0xe57 read value
    csrr x14, 0xe57

    #Unmapped address 0x17d testing: Read Reset + Random data Write/Read
    #Address 0x17d read value
    csrr x14, 0x17d

    #Address 0x17d Write value 0xa04913ee
    li x3, 0xa04913ee
    csrw 0x17d, x3

    #Address 0x17d read value
    csrr x14, 0x17d

    #Unmapped address 0x5d6 testing: Read Reset + Random data Write/Read
    #Address 0x5d6 read value
    csrr x14, 0x5d6

    #Address 0x5d6 Write value 0xe8b8eab8
    li x3, 0xe8b8eab8
    csrw 0x5d6, x3

    #Address 0x5d6 read value
    csrr x14, 0x5d6

    #Unmapped address 0x450 testing: Read Reset + Random data Write/Read
    #Address 0x450 read value
    csrr x14, 0x450

    #Address 0x450 Write value 0x603bed47
    li x3, 0x603bed47
    csrw 0x450, x3

    #Address 0x450 read value
    csrr x14, 0x450

    #Unmapped address 0x7af testing: Read Reset + Random data Write/Read
    #Address 0x7af read value
    csrr x14, 0x7af

    #Address 0x7af Write value 0xac2a9597
    li x3, 0xac2a9597
    csrw 0x7af, x3

    #Address 0x7af read value
    csrr x14, 0x7af

    #Unmapped address 0x80e testing: Read Reset + Random data Write/Read
    #Address 0x80e read value
    csrr x14, 0x80e

    #Address 0x80e Write value 0xdb737c64
    li x3, 0xdb737c64
    csrw 0x80e, x3

    #Address 0x80e read value
    csrr x14, 0x80e

    #Unmapped address 0x5fe testing: Read Reset + Random data Write/Read
    #Address 0x5fe read value
    csrr x14, 0x5fe

    #Address 0x5fe Write value 0x1b30e32f
    li x3, 0x1b30e32f
    csrw 0x5fe, x3

    #Address 0x5fe read value
    csrr x14, 0x5fe

    #Unmapped address 0xd10 testing: Read Reset + Random data Write/Read
    #Address 0xd10 read value
    csrr x14, 0xd10

    #Address 0xd10 Write value 0x397702a4
    li x3, 0x397702a4
    csrw 0xd10, x3

    #Address 0xd10 read value
    csrr x14, 0xd10

    #Unmapped address 0xdf3 testing: Read Reset + Random data Write/Read
    #Address 0xdf3 read value
    csrr x14, 0xdf3

    #Address 0xdf3 Write value 0x3d126506
    li x3, 0x3d126506
    csrw 0xdf3, x3

    #Address 0xdf3 read value
    csrr x14, 0xdf3

    #Unmapped address 0x6ea testing: Read Reset + Random data Write/Read
    #Address 0x6ea read value
    csrr x14, 0x6ea

    #Address 0x6ea Write value 0xa10c1ae4
    li x3, 0xa10c1ae4
    csrw 0x6ea, x3

    #Address 0x6ea read value
    csrr x14, 0x6ea

    #Unmapped address 0xad5 testing: Read Reset + Random data Write/Read
    #Address 0xad5 read value
    csrr x14, 0xad5

    #Address 0xad5 Write value 0x23f7262a
    li x3, 0x23f7262a
    csrw 0xad5, x3

    #Address 0xad5 read value
    csrr x14, 0xad5

    #Unmapped address 0xd8e testing: Read Reset + Random data Write/Read
    #Address 0xd8e read value
    csrr x14, 0xd8e

    #Address 0xd8e Write value 0xdcf13aa5
    li x3, 0xdcf13aa5
    csrw 0xd8e, x3

    #Address 0xd8e read value
    csrr x14, 0xd8e

    #Unmapped address 0xca9 testing: Read Reset + Random data Write/Read
    #Address 0xca9 read value
    csrr x14, 0xca9

    #Address 0xca9 Write value 0x21891002
    li x3, 0x21891002
    csrw 0xca9, x3

    #Address 0xca9 read value
    csrr x14, 0xca9

    #Unmapped address 0xc3 testing: Read Reset + Random data Write/Read
    #Address 0xc3 read value
    csrr x14, 0xc3

    #Address 0xc3 Write value 0x78b4b0f8
    li x3, 0x78b4b0f8
    csrw 0xc3, x3

    #Address 0xc3 read value
    csrr x14, 0xc3

    #Unmapped address 0x2a0 testing: Read Reset + Random data Write/Read
    #Address 0x2a0 read value
    csrr x14, 0x2a0

    #Address 0x2a0 Write value 0x22147ff0
    li x3, 0x22147ff0
    csrw 0x2a0, x3

    #Address 0x2a0 read value
    csrr x14, 0x2a0

    #Unmapped address 0x90f testing: Read Reset + Random data Write/Read
    #Address 0x90f read value
    csrr x14, 0x90f

    #Address 0x90f Write value 0x36aceb20
    li x3, 0x36aceb20
    csrw 0x90f, x3

    #Address 0x90f read value
    csrr x14, 0x90f

    #Unmapped address 0x530 testing: Read Reset + Random data Write/Read
    #Address 0x530 read value
    csrr x14, 0x530

    #Address 0x530 Write value 0xead0df5d
    li x3, 0xead0df5d
    csrw 0x530, x3

    #Address 0x530 read value
    csrr x14, 0x530

    #Unmapped address 0xe8f testing: Read Reset + Random data Write/Read
    #Address 0xe8f read value
    csrr x14, 0xe8f

    #Address 0xe8f Write value 0xa8efeb54
    li x3, 0xa8efeb54
    csrw 0xe8f, x3

    #Address 0xe8f read value
    csrr x14, 0xe8f

    #Unmapped address 0xee4 testing: Read Reset + Random data Write/Read
    #Address 0xee4 read value
    csrr x14, 0xee4

    #Address 0xee4 Write value 0x41c935ea
    li x3, 0x41c935ea
    csrw 0xee4, x3

    #Address 0xee4 read value
    csrr x14, 0xee4

    #Unmapped address 0x896 testing: Read Reset + Random data Write/Read
    #Address 0x896 read value
    csrr x14, 0x896

    #Address 0x896 Write value 0xc7aa20a7
    li x3, 0xc7aa20a7
    csrw 0x896, x3

    #Address 0x896 read value
    csrr x14, 0x896

    #Unmapped address 0x903 testing: Read Reset + Random data Write/Read
    #Address 0x903 read value
    csrr x14, 0x903

    #Address 0x903 Write value 0xe4358f20
    li x3, 0xe4358f20
    csrw 0x903, x3

    #Address 0x903 read value
    csrr x14, 0x903

    #Unmapped address 0xebd testing: Read Reset + Random data Write/Read
    #Address 0xebd read value
    csrr x14, 0xebd

    #Address 0xebd Write value 0x91c5b74d
    li x3, 0x91c5b74d
    csrw 0xebd, x3

    #Address 0xebd read value
    csrr x14, 0xebd

    #Unmapped address 0xc8c testing: Read Reset + Random data Write/Read
    #Address 0xc8c read value
    csrr x14, 0xc8c

    #Address 0xc8c Write value 0x7b709587
    li x3, 0x7b709587
    csrw 0xc8c, x3

    #Address 0xc8c read value
    csrr x14, 0xc8c

    #Unmapped address 0x80d testing: Read Reset + Random data Write/Read
    #Address 0x80d read value
    csrr x14, 0x80d

    #Address 0x80d Write value 0x2bb9fa50
    li x3, 0x2bb9fa50
    csrw 0x80d, x3

    #Address 0x80d read value
    csrr x14, 0x80d

    #Unmapped address 0xe90 testing: Read Reset + Random data Write/Read
    #Address 0xe90 read value
    csrr x14, 0xe90

    #Address 0xe90 Write value 0x917b6858
    li x3, 0x917b6858
    csrw 0xe90, x3

    #Address 0xe90 read value
    csrr x14, 0xe90

    #Unmapped address 0xe21 testing: Read Reset + Random data Write/Read
    #Address 0xe21 read value
    csrr x14, 0xe21

    #Address 0xe21 Write value 0xb807e4a0
    li x3, 0xb807e4a0
    csrw 0xe21, x3

    #Address 0xe21 read value
    csrr x14, 0xe21

    #Unmapped address 0x8cf testing: Read Reset + Random data Write/Read
    #Address 0x8cf read value
    csrr x14, 0x8cf

    #Address 0x8cf Write value 0x2a3361f2
    li x3, 0x2a3361f2
    csrw 0x8cf, x3

    #Address 0x8cf read value
    csrr x14, 0x8cf

    #Unmapped address 0x6ab testing: Read Reset + Random data Write/Read
    #Address 0x6ab read value
    csrr x14, 0x6ab

    #Address 0x6ab Write value 0x61023ba1
    li x3, 0x61023ba1
    csrw 0x6ab, x3

    #Address 0x6ab read value
    csrr x14, 0x6ab

    #Unmapped address 0xc8e testing: Read Reset + Random data Write/Read
    #Address 0xc8e read value
    csrr x14, 0xc8e

    #Address 0xc8e Write value 0xfbb9cae4
    li x3, 0xfbb9cae4
    csrw 0xc8e, x3

    #Address 0xc8e read value
    csrr x14, 0xc8e

    #Unmapped address 0x1f6 testing: Read Reset + Random data Write/Read
    #Address 0x1f6 read value
    csrr x14, 0x1f6

    #Address 0x1f6 Write value 0x29cfd138
    li x3, 0x29cfd138
    csrw 0x1f6, x3

    #Address 0x1f6 read value
    csrr x14, 0x1f6

    #Unmapped address 0x1fa testing: Read Reset + Random data Write/Read
    #Address 0x1fa read value
    csrr x14, 0x1fa

    #Address 0x1fa Write value 0x7a999cc0
    li x3, 0x7a999cc0
    csrw 0x1fa, x3

    #Address 0x1fa read value
    csrr x14, 0x1fa

    #Unmapped address 0x7b1 testing: Read Reset + Random data Write/Read
    #Address 0x7b1 read value
    csrr x14, 0x7b1

    #Address 0x7b1 Write value 0xf86bd6a
    li x3, 0xf86bd6a
    csrw 0x7b1, x3

    #Address 0x7b1 read value
    csrr x14, 0x7b1

    #Unmapped address 0xae4 testing: Read Reset + Random data Write/Read
    #Address 0xae4 read value
    csrr x14, 0xae4

    #Address 0xae4 Write value 0x4c6e5477
    li x3, 0x4c6e5477
    csrw 0xae4, x3

    #Address 0xae4 read value
    csrr x14, 0xae4

    #Unmapped address 0xb9 testing: Read Reset + Random data Write/Read
    #Address 0xb9 read value
    csrr x14, 0xb9

    #Address 0xb9 Write value 0xf3635481
    li x3, 0xf3635481
    csrw 0xb9, x3

    #Address 0xb9 read value
    csrr x14, 0xb9

    #Unmapped address 0x6d8 testing: Read Reset + Random data Write/Read
    #Address 0x6d8 read value
    csrr x14, 0x6d8

    #Address 0x6d8 Write value 0xb5aac220
    li x3, 0xb5aac220
    csrw 0x6d8, x3

    #Address 0x6d8 read value
    csrr x14, 0x6d8

    #Unmapped address 0xada testing: Read Reset + Random data Write/Read
    #Address 0xada read value
    csrr x14, 0xada

    #Address 0xada Write value 0x9e31b5a9
    li x3, 0x9e31b5a9
    csrw 0xada, x3

    #Address 0xada read value
    csrr x14, 0xada

    #Unmapped address 0xaa4 testing: Read Reset + Random data Write/Read
    #Address 0xaa4 read value
    csrr x14, 0xaa4

    #Address 0xaa4 Write value 0xd25ab423
    li x3, 0xd25ab423
    csrw 0xaa4, x3

    #Address 0xaa4 read value
    csrr x14, 0xaa4

    #Unmapped address 0xead testing: Read Reset + Random data Write/Read
    #Address 0xead read value
    csrr x14, 0xead

    #Address 0xead Write value 0x49154090
    li x3, 0x49154090
    csrw 0xead, x3

    #Address 0xead read value
    csrr x14, 0xead

    #Unmapped address 0x6b5 testing: Read Reset + Random data Write/Read
    #Address 0x6b5 read value
    csrr x14, 0x6b5

    #Address 0x6b5 Write value 0x8e27ea0
    li x3, 0x8e27ea0
    csrw 0x6b5, x3

    #Address 0x6b5 read value
    csrr x14, 0x6b5

    #Unmapped address 0x948 testing: Read Reset + Random data Write/Read
    #Address 0x948 read value
    csrr x14, 0x948

    #Address 0x948 Write value 0xd66ba512
    li x3, 0xd66ba512
    csrw 0x948, x3

    #Address 0x948 read value
    csrr x14, 0x948

    #Unmapped address 0x1d6 testing: Read Reset + Random data Write/Read
    #Address 0x1d6 read value
    csrr x14, 0x1d6

    #Address 0x1d6 Write value 0xfd73e163
    li x3, 0xfd73e163
    csrw 0x1d6, x3

    #Address 0x1d6 read value
    csrr x14, 0x1d6

    #Unmapped address 0xac7 testing: Read Reset + Random data Write/Read
    #Address 0xac7 read value
    csrr x14, 0xac7

    #Address 0xac7 Write value 0xecce80fb
    li x3, 0xecce80fb
    csrw 0xac7, x3

    #Address 0xac7 read value
    csrr x14, 0xac7

    #Unmapped address 0xc58 testing: Read Reset + Random data Write/Read
    #Address 0xc58 read value
    csrr x14, 0xc58

    #Address 0xc58 Write value 0x7a10144c
    li x3, 0x7a10144c
    csrw 0xc58, x3

    #Address 0xc58 read value
    csrr x14, 0xc58

    #Unmapped address 0x7c testing: Read Reset + Random data Write/Read
    #Address 0x7c read value
    csrr x14, 0x7c

    #Address 0x7c Write value 0xf43641cc
    li x3, 0xf43641cc
    csrw 0x7c, x3

    #Address 0x7c read value
    csrr x14, 0x7c

    #Unmapped address 0x106 testing: Read Reset + Random data Write/Read
    #Address 0x106 read value
    csrr x14, 0x106

    #Address 0x106 Write value 0xffda1885
    li x3, 0xffda1885
    csrw 0x106, x3

    #Address 0x106 read value
    csrr x14, 0x106

    #Unmapped address 0xc37 testing: Read Reset + Random data Write/Read
    #Address 0xc37 read value
    csrr x14, 0xc37

    #Address 0xc37 Write value 0x2f30898d
    li x3, 0x2f30898d
    csrw 0xc37, x3

    #Address 0xc37 read value
    csrr x14, 0xc37

    #Unmapped address 0x2de testing: Read Reset + Random data Write/Read
    #Address 0x2de read value
    csrr x14, 0x2de

    #Address 0x2de Write value 0x4a17070
    li x3, 0x4a17070
    csrw 0x2de, x3

    #Address 0x2de read value
    csrr x14, 0x2de

    #Unmapped address 0xda testing: Read Reset + Random data Write/Read
    #Address 0xda read value
    csrr x14, 0xda

    #Address 0xda Write value 0xcb26eb2b
    li x3, 0xcb26eb2b
    csrw 0xda, x3

    #Address 0xda read value
    csrr x14, 0xda

    #Unmapped address 0x99e testing: Read Reset + Random data Write/Read
    #Address 0x99e read value
    csrr x14, 0x99e

    #Address 0x99e Write value 0x289045f9
    li x3, 0x289045f9
    csrw 0x99e, x3

    #Address 0x99e read value
    csrr x14, 0x99e

    #Unmapped address 0xe12 testing: Read Reset + Random data Write/Read
    #Address 0xe12 read value
    csrr x14, 0xe12

    #Address 0xe12 Write value 0xfe24b050
    li x3, 0xfe24b050
    csrw 0xe12, x3

    #Address 0xe12 read value
    csrr x14, 0xe12

    #Unmapped address 0xfa7 testing: Read Reset + Random data Write/Read
    #Address 0xfa7 read value
    csrr x14, 0xfa7

    #Address 0xfa7 Write value 0x9b3cfb0f
    li x3, 0x9b3cfb0f
    csrw 0xfa7, x3

    #Address 0xfa7 read value
    csrr x14, 0xfa7

    #Unmapped address 0x2db testing: Read Reset + Random data Write/Read
    #Address 0x2db read value
    csrr x14, 0x2db

    #Address 0x2db Write value 0x70764384
    li x3, 0x70764384
    csrw 0x2db, x3

    #Address 0x2db read value
    csrr x14, 0x2db

    #Unmapped address 0xa75 testing: Read Reset + Random data Write/Read
    #Address 0xa75 read value
    csrr x14, 0xa75

    #Address 0xa75 Write value 0x6c389455
    li x3, 0x6c389455
    csrw 0xa75, x3

    #Address 0xa75 read value
    csrr x14, 0xa75

    #Unmapped address 0x8e1 testing: Read Reset + Random data Write/Read
    #Address 0x8e1 read value
    csrr x14, 0x8e1

    #Address 0x8e1 Write value 0xade2b0be
    li x3, 0xade2b0be
    csrw 0x8e1, x3

    #Address 0x8e1 read value
    csrr x14, 0x8e1

    #Unmapped address 0x843 testing: Read Reset + Random data Write/Read
    #Address 0x843 read value
    csrr x14, 0x843

    #Address 0x843 Write value 0xac2554a3
    li x3, 0xac2554a3
    csrw 0x843, x3

    #Address 0x843 read value
    csrr x14, 0x843

    #Unmapped address 0xaa1 testing: Read Reset + Random data Write/Read
    #Address 0xaa1 read value
    csrr x14, 0xaa1

    #Address 0xaa1 Write value 0x58d5e9c3
    li x3, 0x58d5e9c3
    csrw 0xaa1, x3

    #Address 0xaa1 read value
    csrr x14, 0xaa1

    #Unmapped address 0x4fa testing: Read Reset + Random data Write/Read
    #Address 0x4fa read value
    csrr x14, 0x4fa

    #Address 0x4fa Write value 0x731164c2
    li x3, 0x731164c2
    csrw 0x4fa, x3

    #Address 0x4fa read value
    csrr x14, 0x4fa

    #Unmapped address 0x523 testing: Read Reset + Random data Write/Read
    #Address 0x523 read value
    csrr x14, 0x523

    #Address 0x523 Write value 0xfa53eb5c
    li x3, 0xfa53eb5c
    csrw 0x523, x3

    #Address 0x523 read value
    csrr x14, 0x523

    #Unmapped address 0x1d3 testing: Read Reset + Random data Write/Read
    #Address 0x1d3 read value
    csrr x14, 0x1d3

    #Address 0x1d3 Write value 0x25b0404
    li x3, 0x25b0404
    csrw 0x1d3, x3

    #Address 0x1d3 read value
    csrr x14, 0x1d3

    #Unmapped address 0x503 testing: Read Reset + Random data Write/Read
    #Address 0x503 read value
    csrr x14, 0x503

    #Address 0x503 Write value 0xd9ee9f70
    li x3, 0xd9ee9f70
    csrw 0x503, x3

    #Address 0x503 read value
    csrr x14, 0x503

    #Unmapped address 0x294 testing: Read Reset + Random data Write/Read
    #Address 0x294 read value
    csrr x14, 0x294

    #Address 0x294 Write value 0x13293862
    li x3, 0x13293862
    csrw 0x294, x3

    #Address 0x294 read value
    csrr x14, 0x294

    #Unmapped address 0x4c testing: Read Reset + Random data Write/Read
    #Address 0x4c read value
    csrr x14, 0x4c

    #Address 0x4c Write value 0x6ba9e83c
    li x3, 0x6ba9e83c
    csrw 0x4c, x3

    #Address 0x4c read value
    csrr x14, 0x4c

    #Unmapped address 0xd22 testing: Read Reset + Random data Write/Read
    #Address 0xd22 read value
    csrr x14, 0xd22

    #Address 0xd22 Write value 0x77c0c082
    li x3, 0x77c0c082
    csrw 0xd22, x3

    #Address 0xd22 read value
    csrr x14, 0xd22

    #Unmapped address 0x4cd testing: Read Reset + Random data Write/Read
    #Address 0x4cd read value
    csrr x14, 0x4cd

    #Address 0x4cd Write value 0x735e00f5
    li x3, 0x735e00f5
    csrw 0x4cd, x3

    #Address 0x4cd read value
    csrr x14, 0x4cd

    #Unmapped address 0x3de testing: Read Reset + Random data Write/Read
    #Address 0x3de read value
    csrr x14, 0x3de

    #Address 0x3de Write value 0x845bf459
    li x3, 0x845bf459
    csrw 0x3de, x3

    #Address 0x3de read value
    csrr x14, 0x3de

    #Unmapped address 0x285 testing: Read Reset + Random data Write/Read
    #Address 0x285 read value
    csrr x14, 0x285

    #Address 0x285 Write value 0xee2c51e4
    li x3, 0xee2c51e4
    csrw 0x285, x3

    #Address 0x285 read value
    csrr x14, 0x285

    #Unmapped address 0x1e3 testing: Read Reset + Random data Write/Read
    #Address 0x1e3 read value
    csrr x14, 0x1e3

    #Address 0x1e3 Write value 0xf21487d1
    li x3, 0xf21487d1
    csrw 0x1e3, x3

    #Address 0x1e3 read value
    csrr x14, 0x1e3

    #Unmapped address 0x633 testing: Read Reset + Random data Write/Read
    #Address 0x633 read value
    csrr x14, 0x633

    #Address 0x633 Write value 0x7634e26b
    li x3, 0x7634e26b
    csrw 0x633, x3

    #Address 0x633 read value
    csrr x14, 0x633

    #Unmapped address 0xa5e testing: Read Reset + Random data Write/Read
    #Address 0xa5e read value
    csrr x14, 0xa5e

    #Address 0xa5e Write value 0xe25e9219
    li x3, 0xe25e9219
    csrw 0xa5e, x3

    #Address 0xa5e read value
    csrr x14, 0xa5e

    #Unmapped address 0x55f testing: Read Reset + Random data Write/Read
    #Address 0x55f read value
    csrr x14, 0x55f

    #Address 0x55f Write value 0x5c823b03
    li x3, 0x5c823b03
    csrw 0x55f, x3

    #Address 0x55f read value
    csrr x14, 0x55f

    #Unmapped address 0x28e testing: Read Reset + Random data Write/Read
    #Address 0x28e read value
    csrr x14, 0x28e

    #Address 0x28e Write value 0x8e3684a7
    li x3, 0x8e3684a7
    csrw 0x28e, x3

    #Address 0x28e read value
    csrr x14, 0x28e

    #Unmapped address 0xb45 testing: Read Reset + Random data Write/Read
    #Address 0xb45 read value
    csrr x14, 0xb45

    #Address 0xb45 Write value 0x7ba86470
    li x3, 0x7ba86470
    csrw 0xb45, x3

    #Address 0xb45 read value
    csrr x14, 0xb45

    #Unmapped address 0x625 testing: Read Reset + Random data Write/Read
    #Address 0x625 read value
    csrr x14, 0x625

    #Address 0x625 Write value 0x2fb42228
    li x3, 0x2fb42228
    csrw 0x625, x3

    #Address 0x625 read value
    csrr x14, 0x625

    #Unmapped address 0x42e testing: Read Reset + Random data Write/Read
    #Address 0x42e read value
    csrr x14, 0x42e

    #Address 0x42e Write value 0x2dd58dad
    li x3, 0x2dd58dad
    csrw 0x42e, x3

    #Address 0x42e read value
    csrr x14, 0x42e

    #Unmapped address 0x9c testing: Read Reset + Random data Write/Read
    #Address 0x9c read value
    csrr x14, 0x9c

    #Address 0x9c Write value 0xf6e4ec10
    li x3, 0xf6e4ec10
    csrw 0x9c, x3

    #Address 0x9c read value
    csrr x14, 0x9c

    #Unmapped address 0x396 testing: Read Reset + Random data Write/Read
    #Address 0x396 read value
    csrr x14, 0x396

    #Address 0x396 Write value 0x16396b03
    li x3, 0x16396b03
    csrw 0x396, x3

    #Address 0x396 read value
    csrr x14, 0x396

    #Unmapped address 0x39d testing: Read Reset + Random data Write/Read
    #Address 0x39d read value
    csrr x14, 0x39d

    #Address 0x39d Write value 0xd73a4c0c
    li x3, 0xd73a4c0c
    csrw 0x39d, x3

    #Address 0x39d read value
    csrr x14, 0x39d

    #Unmapped address 0xd27 testing: Read Reset + Random data Write/Read
    #Address 0xd27 read value
    csrr x14, 0xd27

    #Address 0xd27 Write value 0x4c70e57f
    li x3, 0x4c70e57f
    csrw 0xd27, x3

    #Address 0xd27 read value
    csrr x14, 0xd27

    #Unmapped address 0xbe2 testing: Read Reset + Random data Write/Read
    #Address 0xbe2 read value
    csrr x14, 0xbe2

    #Address 0xbe2 Write value 0x1ebb162a
    li x3, 0x1ebb162a
    csrw 0xbe2, x3

    #Address 0xbe2 read value
    csrr x14, 0xbe2

    #Unmapped address 0xe0d testing: Read Reset + Random data Write/Read
    #Address 0xe0d read value
    csrr x14, 0xe0d

    #Address 0xe0d Write value 0x95c478c2
    li x3, 0x95c478c2
    csrw 0xe0d, x3

    #Address 0xe0d read value
    csrr x14, 0xe0d

    #Unmapped address 0x3c3 testing: Read Reset + Random data Write/Read
    #Address 0x3c3 read value
    csrr x14, 0x3c3

    #Address 0x3c3 Write value 0x2a4e7326
    li x3, 0x2a4e7326
    csrw 0x3c3, x3

    #Address 0x3c3 read value
    csrr x14, 0x3c3

    #Unmapped address 0x965 testing: Read Reset + Random data Write/Read
    #Address 0x965 read value
    csrr x14, 0x965

    #Address 0x965 Write value 0x70147480
    li x3, 0x70147480
    csrw 0x965, x3

    #Address 0x965 read value
    csrr x14, 0x965

    #Unmapped address 0xbb4 testing: Read Reset + Random data Write/Read
    #Address 0xbb4 read value
    csrr x14, 0xbb4

    #Address 0xbb4 Write value 0x80ab3b99
    li x3, 0x80ab3b99
    csrw 0xbb4, x3

    #Address 0xbb4 read value
    csrr x14, 0xbb4

    #Unmapped address 0xa9d testing: Read Reset + Random data Write/Read
    #Address 0xa9d read value
    csrr x14, 0xa9d

    #Address 0xa9d Write value 0xbe9770d
    li x3, 0xbe9770d
    csrw 0xa9d, x3

    #Address 0xa9d read value
    csrr x14, 0xa9d

    #Unmapped address 0xa0a testing: Read Reset + Random data Write/Read
    #Address 0xa0a read value
    csrr x14, 0xa0a

    #Address 0xa0a Write value 0x76206906
    li x3, 0x76206906
    csrw 0xa0a, x3

    #Address 0xa0a read value
    csrr x14, 0xa0a

    #Unmapped address 0xf4d testing: Read Reset + Random data Write/Read
    #Address 0xf4d read value
    csrr x14, 0xf4d

    #Address 0xf4d Write value 0x4d333e04
    li x3, 0x4d333e04
    csrw 0xf4d, x3

    #Address 0xf4d read value
    csrr x14, 0xf4d

    #Unmapped address 0x16c testing: Read Reset + Random data Write/Read
    #Address 0x16c read value
    csrr x14, 0x16c

    #Address 0x16c Write value 0x2320cfb2
    li x3, 0x2320cfb2
    csrw 0x16c, x3

    #Address 0x16c read value
    csrr x14, 0x16c

    #Unmapped address 0xb29 testing: Read Reset + Random data Write/Read
    #Address 0xb29 read value
    csrr x14, 0xb29

    #Address 0xb29 Write value 0xfb6c0585
    li x3, 0xfb6c0585
    csrw 0xb29, x3

    #Address 0xb29 read value
    csrr x14, 0xb29

    #Unmapped address 0x7b testing: Read Reset + Random data Write/Read
    #Address 0x7b read value
    csrr x14, 0x7b

    #Address 0x7b Write value 0xee8edcf6
    li x3, 0xee8edcf6
    csrw 0x7b, x3

    #Address 0x7b read value
    csrr x14, 0x7b

    #Unmapped address 0xe3b testing: Read Reset + Random data Write/Read
    #Address 0xe3b read value
    csrr x14, 0xe3b

    #Address 0xe3b Write value 0xd81aeec8
    li x3, 0xd81aeec8
    csrw 0xe3b, x3

    #Address 0xe3b read value
    csrr x14, 0xe3b

    #Unmapped address 0xdd7 testing: Read Reset + Random data Write/Read
    #Address 0xdd7 read value
    csrr x14, 0xdd7

    #Address 0xdd7 Write value 0x5357e94b
    li x3, 0x5357e94b
    csrw 0xdd7, x3

    #Address 0xdd7 read value
    csrr x14, 0xdd7

    #Unmapped address 0x37c testing: Read Reset + Random data Write/Read
    #Address 0x37c read value
    csrr x14, 0x37c

    #Address 0x37c Write value 0xf0d685e4
    li x3, 0xf0d685e4
    csrw 0x37c, x3

    #Address 0x37c read value
    csrr x14, 0x37c

    #Unmapped address 0x76e testing: Read Reset + Random data Write/Read
    #Address 0x76e read value
    csrr x14, 0x76e

    #Address 0x76e Write value 0x73c29e5b
    li x3, 0x73c29e5b
    csrw 0x76e, x3

    #Address 0x76e read value
    csrr x14, 0x76e

    #Unmapped address 0x2a5 testing: Read Reset + Random data Write/Read
    #Address 0x2a5 read value
    csrr x14, 0x2a5

    #Address 0x2a5 Write value 0x4e8c439
    li x3, 0x4e8c439
    csrw 0x2a5, x3

    #Address 0x2a5 read value
    csrr x14, 0x2a5

    #Unmapped address 0x3fa testing: Read Reset + Random data Write/Read
    #Address 0x3fa read value
    csrr x14, 0x3fa

    #Address 0x3fa Write value 0xcdd2345d
    li x3, 0xcdd2345d
    csrw 0x3fa, x3

    #Address 0x3fa read value
    csrr x14, 0x3fa

    #Unmapped address 0xe43 testing: Read Reset + Random data Write/Read
    #Address 0xe43 read value
    csrr x14, 0xe43

    #Address 0xe43 Write value 0x8adc566f
    li x3, 0x8adc566f
    csrw 0xe43, x3

    #Address 0xe43 read value
    csrr x14, 0xe43

    #Unmapped address 0xc29 testing: Read Reset + Random data Write/Read
    #Address 0xc29 read value
    csrr x14, 0xc29

    #Address 0xc29 Write value 0x81d815cb
    li x3, 0x81d815cb
    csrw 0xc29, x3

    #Address 0xc29 read value
    csrr x14, 0xc29

    #Unmapped address 0x4b7 testing: Read Reset + Random data Write/Read
    #Address 0x4b7 read value
    csrr x14, 0x4b7

    #Address 0x4b7 Write value 0xecb49beb
    li x3, 0xecb49beb
    csrw 0x4b7, x3

    #Address 0x4b7 read value
    csrr x14, 0x4b7

    #Unmapped address 0xfd3 testing: Read Reset + Random data Write/Read
    #Address 0xfd3 read value
    csrr x14, 0xfd3

    #Address 0xfd3 Write value 0x93be9c46
    li x3, 0x93be9c46
    csrw 0xfd3, x3

    #Address 0xfd3 read value
    csrr x14, 0xfd3

    #Unmapped address 0x593 testing: Read Reset + Random data Write/Read
    #Address 0x593 read value
    csrr x14, 0x593

    #Address 0x593 Write value 0xc56235d8
    li x3, 0xc56235d8
    csrw 0x593, x3

    #Address 0x593 read value
    csrr x14, 0x593

    #Unmapped address 0x5a6 testing: Read Reset + Random data Write/Read
    #Address 0x5a6 read value
    csrr x14, 0x5a6

    #Address 0x5a6 Write value 0xcc055700
    li x3, 0xcc055700
    csrw 0x5a6, x3

    #Address 0x5a6 read value
    csrr x14, 0x5a6

    #Unmapped address 0xa9b testing: Read Reset + Random data Write/Read
    #Address 0xa9b read value
    csrr x14, 0xa9b

    #Address 0xa9b Write value 0xc1dc3fb2
    li x3, 0xc1dc3fb2
    csrw 0xa9b, x3

    #Address 0xa9b read value
    csrr x14, 0xa9b

    #Unmapped address 0x777 testing: Read Reset + Random data Write/Read
    #Address 0x777 read value
    csrr x14, 0x777

    #Address 0x777 Write value 0xbc154d5d
    li x3, 0xbc154d5d
    csrw 0x777, x3

    #Address 0x777 read value
    csrr x14, 0x777

    #Unmapped address 0xbff testing: Read Reset + Random data Write/Read
    #Address 0xbff read value
    csrr x14, 0xbff

    #Address 0xbff Write value 0xa16065d4
    li x3, 0xa16065d4
    csrw 0xbff, x3

    #Address 0xbff read value
    csrr x14, 0xbff

    #Unmapped address 0x823 testing: Read Reset + Random data Write/Read
    #Address 0x823 read value
    csrr x14, 0x823

    #Address 0x823 Write value 0x4c4c4401
    li x3, 0x4c4c4401
    csrw 0x823, x3

    #Address 0x823 read value
    csrr x14, 0x823

    #Unmapped address 0xf0d testing: Read Reset + Random data Write/Read
    #Address 0xf0d read value
    csrr x14, 0xf0d

    #Address 0xf0d Write value 0x16a3995e
    li x3, 0x16a3995e
    csrw 0xf0d, x3

    #Address 0xf0d read value
    csrr x14, 0xf0d

    #Unmapped address 0x8c6 testing: Read Reset + Random data Write/Read
    #Address 0x8c6 read value
    csrr x14, 0x8c6

    #Address 0x8c6 Write value 0xd150e9f8
    li x3, 0xd150e9f8
    csrw 0x8c6, x3

    #Address 0x8c6 read value
    csrr x14, 0x8c6

    #Unmapped address 0x56d testing: Read Reset + Random data Write/Read
    #Address 0x56d read value
    csrr x14, 0x56d

    #Address 0x56d Write value 0x98d17331
    li x3, 0x98d17331
    csrw 0x56d, x3

    #Address 0x56d read value
    csrr x14, 0x56d

    #Unmapped address 0xc55 testing: Read Reset + Random data Write/Read
    #Address 0xc55 read value
    csrr x14, 0xc55

    #Address 0xc55 Write value 0x37a5da08
    li x3, 0x37a5da08
    csrw 0xc55, x3

    #Address 0xc55 read value
    csrr x14, 0xc55

    #Unmapped address 0xe3 testing: Read Reset + Random data Write/Read
    #Address 0xe3 read value
    csrr x14, 0xe3

    #Address 0xe3 Write value 0xef0099d5
    li x3, 0xef0099d5
    csrw 0xe3, x3

    #Address 0xe3 read value
    csrr x14, 0xe3

    #Unmapped address 0x5a3 testing: Read Reset + Random data Write/Read
    #Address 0x5a3 read value
    csrr x14, 0x5a3

    #Address 0x5a3 Write value 0xcf7035a3
    li x3, 0xcf7035a3
    csrw 0x5a3, x3

    #Address 0x5a3 read value
    csrr x14, 0x5a3

    #Unmapped address 0xea0 testing: Read Reset + Random data Write/Read
    #Address 0xea0 read value
    csrr x14, 0xea0

    #Address 0xea0 Write value 0x75d1466
    li x3, 0x75d1466
    csrw 0xea0, x3

    #Address 0xea0 read value
    csrr x14, 0xea0

    #Unmapped address 0x29 testing: Read Reset + Random data Write/Read
    #Address 0x29 read value
    csrr x14, 0x29

    #Address 0x29 Write value 0x73733430
    li x3, 0x73733430
    csrw 0x29, x3

    #Address 0x29 read value
    csrr x14, 0x29

    #Unmapped address 0x1ab testing: Read Reset + Random data Write/Read
    #Address 0x1ab read value
    csrr x14, 0x1ab

    #Address 0x1ab Write value 0x6a8c814
    li x3, 0x6a8c814
    csrw 0x1ab, x3

    #Address 0x1ab read value
    csrr x14, 0x1ab

    #Unmapped address 0xe6 testing: Read Reset + Random data Write/Read
    #Address 0xe6 read value
    csrr x14, 0xe6

    #Address 0xe6 Write value 0xccc9c60a
    li x3, 0xccc9c60a
    csrw 0xe6, x3

    #Address 0xe6 read value
    csrr x14, 0xe6

    #Unmapped address 0xe4c testing: Read Reset + Random data Write/Read
    #Address 0xe4c read value
    csrr x14, 0xe4c

    #Address 0xe4c Write value 0x4b755d00
    li x3, 0x4b755d00
    csrw 0xe4c, x3

    #Address 0xe4c read value
    csrr x14, 0xe4c

    #Unmapped address 0xfd9 testing: Read Reset + Random data Write/Read
    #Address 0xfd9 read value
    csrr x14, 0xfd9

    #Address 0xfd9 Write value 0x71468f02
    li x3, 0x71468f02
    csrw 0xfd9, x3

    #Address 0xfd9 read value
    csrr x14, 0xfd9

    #Unmapped address 0x6a testing: Read Reset + Random data Write/Read
    #Address 0x6a read value
    csrr x14, 0x6a

    #Address 0x6a Write value 0xfc87c750
    li x3, 0xfc87c750
    csrw 0x6a, x3

    #Address 0x6a read value
    csrr x14, 0x6a

    #Unmapped address 0x1dc testing: Read Reset + Random data Write/Read
    #Address 0x1dc read value
    csrr x14, 0x1dc

    #Address 0x1dc Write value 0xdaad48da
    li x3, 0xdaad48da
    csrw 0x1dc, x3

    #Address 0x1dc read value
    csrr x14, 0x1dc

    #Unmapped address 0x89d testing: Read Reset + Random data Write/Read
    #Address 0x89d read value
    csrr x14, 0x89d

    #Address 0x89d Write value 0xc034f645
    li x3, 0xc034f645
    csrw 0x89d, x3

    #Address 0x89d read value
    csrr x14, 0x89d

    #Unmapped address 0x7b9 testing: Read Reset + Random data Write/Read
    #Address 0x7b9 read value
    csrr x14, 0x7b9

    #Address 0x7b9 Write value 0x2027d270
    li x3, 0x2027d270
    csrw 0x7b9, x3

    #Address 0x7b9 read value
    csrr x14, 0x7b9

    #Unmapped address 0x2b3 testing: Read Reset + Random data Write/Read
    #Address 0x2b3 read value
    csrr x14, 0x2b3

    #Address 0x2b3 Write value 0xbd5fff67
    li x3, 0xbd5fff67
    csrw 0x2b3, x3

    #Address 0x2b3 read value
    csrr x14, 0x2b3

    #Unmapped address 0x1c3 testing: Read Reset + Random data Write/Read
    #Address 0x1c3 read value
    csrr x14, 0x1c3

    #Address 0x1c3 Write value 0x61cbb99a
    li x3, 0x61cbb99a
    csrw 0x1c3, x3

    #Address 0x1c3 read value
    csrr x14, 0x1c3

    #Unmapped address 0xd9a testing: Read Reset + Random data Write/Read
    #Address 0xd9a read value
    csrr x14, 0xd9a

    #Address 0xd9a Write value 0xc8cf12f2
    li x3, 0xc8cf12f2
    csrw 0xd9a, x3

    #Address 0xd9a read value
    csrr x14, 0xd9a

    #Unmapped address 0xe6a testing: Read Reset + Random data Write/Read
    #Address 0xe6a read value
    csrr x14, 0xe6a

    #Address 0xe6a Write value 0xcd6634c5
    li x3, 0xcd6634c5
    csrw 0xe6a, x3

    #Address 0xe6a read value
    csrr x14, 0xe6a

    #Unmapped address 0x9bb testing: Read Reset + Random data Write/Read
    #Address 0x9bb read value
    csrr x14, 0x9bb

    #Address 0x9bb Write value 0x9075a25f
    li x3, 0x9075a25f
    csrw 0x9bb, x3

    #Address 0x9bb read value
    csrr x14, 0x9bb

    #Unmapped address 0xb4a testing: Read Reset + Random data Write/Read
    #Address 0xb4a read value
    csrr x14, 0xb4a

    #Address 0xb4a Write value 0x642bbf27
    li x3, 0x642bbf27
    csrw 0xb4a, x3

    #Address 0xb4a read value
    csrr x14, 0xb4a

    #Unmapped address 0xf17 testing: Read Reset + Random data Write/Read
    #Address 0xf17 read value
    csrr x14, 0xf17

    #Address 0xf17 Write value 0xe11a2e7d
    li x3, 0xe11a2e7d
    csrw 0xf17, x3

    #Address 0xf17 read value
    csrr x14, 0xf17

    #Unmapped address 0xe9e testing: Read Reset + Random data Write/Read
    #Address 0xe9e read value
    csrr x14, 0xe9e

    #Address 0xe9e Write value 0x4a8ff7ad
    li x3, 0x4a8ff7ad
    csrw 0xe9e, x3

    #Address 0xe9e read value
    csrr x14, 0xe9e

    #Unmapped address 0x83a testing: Read Reset + Random data Write/Read
    #Address 0x83a read value
    csrr x14, 0x83a

    #Address 0x83a Write value 0xe2b604f0
    li x3, 0xe2b604f0
    csrw 0x83a, x3

    #Address 0x83a read value
    csrr x14, 0x83a

    #Unmapped address 0xcf4 testing: Read Reset + Random data Write/Read
    #Address 0xcf4 read value
    csrr x14, 0xcf4

    #Address 0xcf4 Write value 0xdd4a5e0e
    li x3, 0xdd4a5e0e
    csrw 0xcf4, x3

    #Address 0xcf4 read value
    csrr x14, 0xcf4

    #Unmapped address 0xa12 testing: Read Reset + Random data Write/Read
    #Address 0xa12 read value
    csrr x14, 0xa12

    #Address 0xa12 Write value 0x3a581990
    li x3, 0x3a581990
    csrw 0xa12, x3

    #Address 0xa12 read value
    csrr x14, 0xa12

    #Unmapped address 0xf67 testing: Read Reset + Random data Write/Read
    #Address 0xf67 read value
    csrr x14, 0xf67

    #Address 0xf67 Write value 0x98503d35
    li x3, 0x98503d35
    csrw 0xf67, x3

    #Address 0xf67 read value
    csrr x14, 0xf67

    #Unmapped address 0x36f testing: Read Reset + Random data Write/Read
    #Address 0x36f read value
    csrr x14, 0x36f

    #Address 0x36f Write value 0xbfde18f2
    li x3, 0xbfde18f2
    csrw 0x36f, x3

    #Address 0x36f read value
    csrr x14, 0x36f

    #Unmapped address 0x9d7 testing: Read Reset + Random data Write/Read
    #Address 0x9d7 read value
    csrr x14, 0x9d7

    #Address 0x9d7 Write value 0x3cff52df
    li x3, 0x3cff52df
    csrw 0x9d7, x3

    #Address 0x9d7 read value
    csrr x14, 0x9d7

    #Unmapped address 0x59d testing: Read Reset + Random data Write/Read
    #Address 0x59d read value
    csrr x14, 0x59d

    #Address 0x59d Write value 0x39b4d2df
    li x3, 0x39b4d2df
    csrw 0x59d, x3

    #Address 0x59d read value
    csrr x14, 0x59d

    #Unmapped address 0x5cb testing: Read Reset + Random data Write/Read
    #Address 0x5cb read value
    csrr x14, 0x5cb

    #Address 0x5cb Write value 0xa4874189
    li x3, 0xa4874189
    csrw 0x5cb, x3

    #Address 0x5cb read value
    csrr x14, 0x5cb

    #Unmapped address 0x761 testing: Read Reset + Random data Write/Read
    #Address 0x761 read value
    csrr x14, 0x761

    #Address 0x761 Write value 0x3517d1a5
    li x3, 0x3517d1a5
    csrw 0x761, x3

    #Address 0x761 read value
    csrr x14, 0x761

    #Unmapped address 0x442 testing: Read Reset + Random data Write/Read
    #Address 0x442 read value
    csrr x14, 0x442

    #Address 0x442 Write value 0x120effc6
    li x3, 0x120effc6
    csrw 0x442, x3

    #Address 0x442 read value
    csrr x14, 0x442

    #Unmapped address 0x980 testing: Read Reset + Random data Write/Read
    #Address 0x980 read value
    csrr x14, 0x980

    #Address 0x980 Write value 0xbfc6d2ab
    li x3, 0xbfc6d2ab
    csrw 0x980, x3

    #Address 0x980 read value
    csrr x14, 0x980

    #Unmapped address 0xd65 testing: Read Reset + Random data Write/Read
    #Address 0xd65 read value
    csrr x14, 0xd65

    #Address 0xd65 Write value 0x57142c23
    li x3, 0x57142c23
    csrw 0xd65, x3

    #Address 0xd65 read value
    csrr x14, 0xd65

    #Unmapped address 0xde0 testing: Read Reset + Random data Write/Read
    #Address 0xde0 read value
    csrr x14, 0xde0

    #Address 0xde0 Write value 0x5d154754
    li x3, 0x5d154754
    csrw 0xde0, x3

    #Address 0xde0 read value
    csrr x14, 0xde0

    #Unmapped address 0xdbf testing: Read Reset + Random data Write/Read
    #Address 0xdbf read value
    csrr x14, 0xdbf

    #Address 0xdbf Write value 0xe6e965ef
    li x3, 0xe6e965ef
    csrw 0xdbf, x3

    #Address 0xdbf read value
    csrr x14, 0xdbf

    #Unmapped address 0x52a testing: Read Reset + Random data Write/Read
    #Address 0x52a read value
    csrr x14, 0x52a

    #Address 0x52a Write value 0xcd7a945d
    li x3, 0xcd7a945d
    csrw 0x52a, x3

    #Address 0x52a read value
    csrr x14, 0x52a

    #Unmapped address 0x785 testing: Read Reset + Random data Write/Read
    #Address 0x785 read value
    csrr x14, 0x785

    #Address 0x785 Write value 0x369fcb1f
    li x3, 0x369fcb1f
    csrw 0x785, x3

    #Address 0x785 read value
    csrr x14, 0x785

    #Unmapped address 0x98c testing: Read Reset + Random data Write/Read
    #Address 0x98c read value
    csrr x14, 0x98c

    #Address 0x98c Write value 0x74b81ed5
    li x3, 0x74b81ed5
    csrw 0x98c, x3

    #Address 0x98c read value
    csrr x14, 0x98c

    #Unmapped address 0x59e testing: Read Reset + Random data Write/Read
    #Address 0x59e read value
    csrr x14, 0x59e

    #Address 0x59e Write value 0x5f28e5a4
    li x3, 0x5f28e5a4
    csrw 0x59e, x3

    #Address 0x59e read value
    csrr x14, 0x59e

    #Unmapped address 0xa17 testing: Read Reset + Random data Write/Read
    #Address 0xa17 read value
    csrr x14, 0xa17

    #Address 0xa17 Write value 0x58544a83
    li x3, 0x58544a83
    csrw 0xa17, x3

    #Address 0xa17 read value
    csrr x14, 0xa17

    #Unmapped address 0xeaf testing: Read Reset + Random data Write/Read
    #Address 0xeaf read value
    csrr x14, 0xeaf

    #Address 0xeaf Write value 0x4b5f610
    li x3, 0x4b5f610
    csrw 0xeaf, x3

    #Address 0xeaf read value
    csrr x14, 0xeaf

    #Unmapped address 0xf39 testing: Read Reset + Random data Write/Read
    #Address 0xf39 read value
    csrr x14, 0xf39

    #Address 0xf39 Write value 0x60f90d53
    li x3, 0x60f90d53
    csrw 0xf39, x3

    #Address 0xf39 read value
    csrr x14, 0xf39

    #Unmapped address 0x804 testing: Read Reset + Random data Write/Read
    #Address 0x804 read value
    csrr x14, 0x804

    #Address 0x804 Write value 0xac2c44a5
    li x3, 0xac2c44a5
    csrw 0x804, x3

    #Address 0x804 read value
    csrr x14, 0x804

    #Unmapped address 0xfd6 testing: Read Reset + Random data Write/Read
    #Address 0xfd6 read value
    csrr x14, 0xfd6

    #Address 0xfd6 Write value 0x1320a71f
    li x3, 0x1320a71f
    csrw 0xfd6, x3

    #Address 0xfd6 read value
    csrr x14, 0xfd6

    #Unmapped address 0x5f6 testing: Read Reset + Random data Write/Read
    #Address 0x5f6 read value
    csrr x14, 0x5f6

    #Address 0x5f6 Write value 0xd1a5019a
    li x3, 0xd1a5019a
    csrw 0x5f6, x3

    #Address 0x5f6 read value
    csrr x14, 0x5f6

    #Unmapped address 0x7c5 testing: Read Reset + Random data Write/Read
    #Address 0x7c5 read value
    csrr x14, 0x7c5

    #Address 0x7c5 Write value 0x298e37d1
    li x3, 0x298e37d1
    csrw 0x7c5, x3

    #Address 0x7c5 read value
    csrr x14, 0x7c5

    #Unmapped address 0x416 testing: Read Reset + Random data Write/Read
    #Address 0x416 read value
    csrr x14, 0x416

    #Address 0x416 Write value 0xd3381673
    li x3, 0xd3381673
    csrw 0x416, x3

    #Address 0x416 read value
    csrr x14, 0x416

    #Unmapped address 0xee8 testing: Read Reset + Random data Write/Read
    #Address 0xee8 read value
    csrr x14, 0xee8

    #Address 0xee8 Write value 0x2abffe5
    li x3, 0x2abffe5
    csrw 0xee8, x3

    #Address 0xee8 read value
    csrr x14, 0xee8

    #Unmapped address 0x9f3 testing: Read Reset + Random data Write/Read
    #Address 0x9f3 read value
    csrr x14, 0x9f3

    #Address 0x9f3 Write value 0xb4a5cce7
    li x3, 0xb4a5cce7
    csrw 0x9f3, x3

    #Address 0x9f3 read value
    csrr x14, 0x9f3

    #Unmapped address 0x1c2 testing: Read Reset + Random data Write/Read
    #Address 0x1c2 read value
    csrr x14, 0x1c2

    #Address 0x1c2 Write value 0x3646f38d
    li x3, 0x3646f38d
    csrw 0x1c2, x3

    #Address 0x1c2 read value
    csrr x14, 0x1c2

    #Unmapped address 0x1ce testing: Read Reset + Random data Write/Read
    #Address 0x1ce read value
    csrr x14, 0x1ce

    #Address 0x1ce Write value 0xcb4e44a
    li x3, 0xcb4e44a
    csrw 0x1ce, x3

    #Address 0x1ce read value
    csrr x14, 0x1ce

    #Unmapped address 0x1d0 testing: Read Reset + Random data Write/Read
    #Address 0x1d0 read value
    csrr x14, 0x1d0

    #Address 0x1d0 Write value 0xd8150ad0
    li x3, 0xd8150ad0
    csrw 0x1d0, x3

    #Address 0x1d0 read value
    csrr x14, 0x1d0

    #Unmapped address 0xa37 testing: Read Reset + Random data Write/Read
    #Address 0xa37 read value
    csrr x14, 0xa37

    #Address 0xa37 Write value 0xfd2c7793
    li x3, 0xfd2c7793
    csrw 0xa37, x3

    #Address 0xa37 read value
    csrr x14, 0xa37

    #Unmapped address 0x1a0 testing: Read Reset + Random data Write/Read
    #Address 0x1a0 read value
    csrr x14, 0x1a0

    #Address 0x1a0 Write value 0x9f3f80c3
    li x3, 0x9f3f80c3
    csrw 0x1a0, x3

    #Address 0x1a0 read value
    csrr x14, 0x1a0

    #Unmapped address 0x157 testing: Read Reset + Random data Write/Read
    #Address 0x157 read value
    csrr x14, 0x157

    #Address 0x157 Write value 0x6c373c2f
    li x3, 0x6c373c2f
    csrw 0x157, x3

    #Address 0x157 read value
    csrr x14, 0x157

    #Unmapped address 0xfb6 testing: Read Reset + Random data Write/Read
    #Address 0xfb6 read value
    csrr x14, 0xfb6

    #Address 0xfb6 Write value 0x87000fed
    li x3, 0x87000fed
    csrw 0xfb6, x3

    #Address 0xfb6 read value
    csrr x14, 0xfb6

    #Unmapped address 0x196 testing: Read Reset + Random data Write/Read
    #Address 0x196 read value
    csrr x14, 0x196

    #Address 0x196 Write value 0xf870aa67
    li x3, 0xf870aa67
    csrw 0x196, x3

    #Address 0x196 read value
    csrr x14, 0x196

    #Unmapped address 0x801 testing: Read Reset + Random data Write/Read
    #Address 0x801 read value
    csrr x14, 0x801

    #Address 0x801 Write value 0xba63d57e
    li x3, 0xba63d57e
    csrw 0x801, x3

    #Address 0x801 read value
    csrr x14, 0x801

    #Unmapped address 0xce0 testing: Read Reset + Random data Write/Read
    #Address 0xce0 read value
    csrr x14, 0xce0

    #Address 0xce0 Write value 0x5a52aadf
    li x3, 0x5a52aadf
    csrw 0xce0, x3

    #Address 0xce0 read value
    csrr x14, 0xce0

    #Unmapped address 0x4e1 testing: Read Reset + Random data Write/Read
    #Address 0x4e1 read value
    csrr x14, 0x4e1

    #Address 0x4e1 Write value 0x161f3b07
    li x3, 0x161f3b07
    csrw 0x4e1, x3

    #Address 0x4e1 read value
    csrr x14, 0x4e1

    #Unmapped address 0x92c testing: Read Reset + Random data Write/Read
    #Address 0x92c read value
    csrr x14, 0x92c

    #Address 0x92c Write value 0x511910fb
    li x3, 0x511910fb
    csrw 0x92c, x3

    #Address 0x92c read value
    csrr x14, 0x92c

    #Unmapped address 0x963 testing: Read Reset + Random data Write/Read
    #Address 0x963 read value
    csrr x14, 0x963

    #Address 0x963 Write value 0x4e7deb6e
    li x3, 0x4e7deb6e
    csrw 0x963, x3

    #Address 0x963 read value
    csrr x14, 0x963

    #Unmapped address 0x721 testing: Read Reset + Random data Write/Read
    #Address 0x721 read value
    csrr x14, 0x721

    #Address 0x721 Write value 0x4238d03a
    li x3, 0x4238d03a
    csrw 0x721, x3

    #Address 0x721 read value
    csrr x14, 0x721

    #Unmapped address 0x818 testing: Read Reset + Random data Write/Read
    #Address 0x818 read value
    csrr x14, 0x818

    #Address 0x818 Write value 0xf5a6e4ff
    li x3, 0xf5a6e4ff
    csrw 0x818, x3

    #Address 0x818 read value
    csrr x14, 0x818

    #Unmapped address 0xa4a testing: Read Reset + Random data Write/Read
    #Address 0xa4a read value
    csrr x14, 0xa4a

    #Address 0xa4a Write value 0x587d2f73
    li x3, 0x587d2f73
    csrw 0xa4a, x3

    #Address 0xa4a read value
    csrr x14, 0xa4a

    #Unmapped address 0x993 testing: Read Reset + Random data Write/Read
    #Address 0x993 read value
    csrr x14, 0x993

    #Address 0x993 Write value 0x2dd12d7b
    li x3, 0x2dd12d7b
    csrw 0x993, x3

    #Address 0x993 read value
    csrr x14, 0x993

    #Unmapped address 0xe63 testing: Read Reset + Random data Write/Read
    #Address 0xe63 read value
    csrr x14, 0xe63

    #Address 0xe63 Write value 0x35b9ad24
    li x3, 0x35b9ad24
    csrw 0xe63, x3

    #Address 0xe63 read value
    csrr x14, 0xe63

    #Unmapped address 0xa1c testing: Read Reset + Random data Write/Read
    #Address 0xa1c read value
    csrr x14, 0xa1c

    #Address 0xa1c Write value 0xf91c7fab
    li x3, 0xf91c7fab
    csrw 0xa1c, x3

    #Address 0xa1c read value
    csrr x14, 0xa1c

    #Unmapped address 0x547 testing: Read Reset + Random data Write/Read
    #Address 0x547 read value
    csrr x14, 0x547

    #Address 0x547 Write value 0xa7ee08fb
    li x3, 0xa7ee08fb
    csrw 0x547, x3

    #Address 0x547 read value
    csrr x14, 0x547

    #Unmapped address 0xe0e testing: Read Reset + Random data Write/Read
    #Address 0xe0e read value
    csrr x14, 0xe0e

    #Address 0xe0e Write value 0xf573b9cc
    li x3, 0xf573b9cc
    csrw 0xe0e, x3

    #Address 0xe0e read value
    csrr x14, 0xe0e

    #Unmapped address 0x82d testing: Read Reset + Random data Write/Read
    #Address 0x82d read value
    csrr x14, 0x82d

    #Address 0x82d Write value 0xb6aa0cbb
    li x3, 0xb6aa0cbb
    csrw 0x82d, x3

    #Address 0x82d read value
    csrr x14, 0x82d

    #Unmapped address 0xf91 testing: Read Reset + Random data Write/Read
    #Address 0xf91 read value
    csrr x14, 0xf91

    #Address 0xf91 Write value 0x30af426b
    li x3, 0x30af426b
    csrw 0xf91, x3

    #Address 0xf91 read value
    csrr x14, 0xf91

    #Unmapped address 0xde9 testing: Read Reset + Random data Write/Read
    #Address 0xde9 read value
    csrr x14, 0xde9

    #Address 0xde9 Write value 0xa3a27680
    li x3, 0xa3a27680
    csrw 0xde9, x3

    #Address 0xde9 read value
    csrr x14, 0xde9

    #Unmapped address 0xde4 testing: Read Reset + Random data Write/Read
    #Address 0xde4 read value
    csrr x14, 0xde4

    #Address 0xde4 Write value 0x8c5facb4
    li x3, 0x8c5facb4
    csrw 0xde4, x3

    #Address 0xde4 read value
    csrr x14, 0xde4

    #Unmapped address 0x961 testing: Read Reset + Random data Write/Read
    #Address 0x961 read value
    csrr x14, 0x961

    #Address 0x961 Write value 0xadb8a049
    li x3, 0xadb8a049
    csrw 0x961, x3

    #Address 0x961 read value
    csrr x14, 0x961

    #Unmapped address 0xbe testing: Read Reset + Random data Write/Read
    #Address 0xbe read value
    csrr x14, 0xbe

    #Address 0xbe Write value 0xd4228cb7
    li x3, 0xd4228cb7
    csrw 0xbe, x3

    #Address 0xbe read value
    csrr x14, 0xbe

    #Unmapped address 0xa89 testing: Read Reset + Random data Write/Read
    #Address 0xa89 read value
    csrr x14, 0xa89

    #Address 0xa89 Write value 0xdac6a452
    li x3, 0xdac6a452
    csrw 0xa89, x3

    #Address 0xa89 read value
    csrr x14, 0xa89

    #Unmapped address 0x7d0 testing: Read Reset + Random data Write/Read
    #Address 0x7d0 read value
    csrr x14, 0x7d0

    #Address 0x7d0 Write value 0x3daaadc3
    li x3, 0x3daaadc3
    csrw 0x7d0, x3

    #Address 0x7d0 read value
    csrr x14, 0x7d0

    #Unmapped address 0xeee testing: Read Reset + Random data Write/Read
    #Address 0xeee read value
    csrr x14, 0xeee

    #Address 0xeee Write value 0x175dc8c7
    li x3, 0x175dc8c7
    csrw 0xeee, x3

    #Address 0xeee read value
    csrr x14, 0xeee

    #Unmapped address 0xaea testing: Read Reset + Random data Write/Read
    #Address 0xaea read value
    csrr x14, 0xaea

    #Address 0xaea Write value 0xacc8400c
    li x3, 0xacc8400c
    csrw 0xaea, x3

    #Address 0xaea read value
    csrr x14, 0xaea

    #Unmapped address 0x1d9 testing: Read Reset + Random data Write/Read
    #Address 0x1d9 read value
    csrr x14, 0x1d9

    #Address 0x1d9 Write value 0xad9e5d50
    li x3, 0xad9e5d50
    csrw 0x1d9, x3

    #Address 0x1d9 read value
    csrr x14, 0x1d9

    #Unmapped address 0xaaa testing: Read Reset + Random data Write/Read
    #Address 0xaaa read value
    csrr x14, 0xaaa

    #Address 0xaaa Write value 0xdcd40cbf
    li x3, 0xdcd40cbf
    csrw 0xaaa, x3

    #Address 0xaaa read value
    csrr x14, 0xaaa

    #Unmapped address 0x102 testing: Read Reset + Random data Write/Read
    #Address 0x102 read value
    csrr x14, 0x102

    #Address 0x102 Write value 0x1d2f1f4f
    li x3, 0x1d2f1f4f
    csrw 0x102, x3

    #Address 0x102 read value
    csrr x14, 0x102

    #Unmapped address 0x2b0 testing: Read Reset + Random data Write/Read
    #Address 0x2b0 read value
    csrr x14, 0x2b0

    #Address 0x2b0 Write value 0xc56ec61b
    li x3, 0xc56ec61b
    csrw 0x2b0, x3

    #Address 0x2b0 read value
    csrr x14, 0x2b0

    #Unmapped address 0x84a testing: Read Reset + Random data Write/Read
    #Address 0x84a read value
    csrr x14, 0x84a

    #Address 0x84a Write value 0x3115ccaf
    li x3, 0x3115ccaf
    csrw 0x84a, x3

    #Address 0x84a read value
    csrr x14, 0x84a

    #Unmapped address 0x306 testing: Read Reset + Random data Write/Read
    #Address 0x306 read value
    csrr x14, 0x306

    #Address 0x306 Write value 0x960b95c0
    li x3, 0x960b95c0
    csrw 0x306, x3

    #Address 0x306 read value
    csrr x14, 0x306

    #Unmapped address 0x81d testing: Read Reset + Random data Write/Read
    #Address 0x81d read value
    csrr x14, 0x81d

    #Address 0x81d Write value 0x8fb4895c
    li x3, 0x8fb4895c
    csrw 0x81d, x3

    #Address 0x81d read value
    csrr x14, 0x81d

    #Unmapped address 0x4d9 testing: Read Reset + Random data Write/Read
    #Address 0x4d9 read value
    csrr x14, 0x4d9

    #Address 0x4d9 Write value 0x4b1428ba
    li x3, 0x4b1428ba
    csrw 0x4d9, x3

    #Address 0x4d9 read value
    csrr x14, 0x4d9

    #Unmapped address 0xca2 testing: Read Reset + Random data Write/Read
    #Address 0xca2 read value
    csrr x14, 0xca2

    #Address 0xca2 Write value 0x3975d111
    li x3, 0x3975d111
    csrw 0xca2, x3

    #Address 0xca2 read value
    csrr x14, 0xca2

    #Unmapped address 0xccd testing: Read Reset + Random data Write/Read
    #Address 0xccd read value
    csrr x14, 0xccd

    #Address 0xccd Write value 0xb3dd7833
    li x3, 0xb3dd7833
    csrw 0xccd, x3

    #Address 0xccd read value
    csrr x14, 0xccd

    #Unmapped address 0xc94 testing: Read Reset + Random data Write/Read
    #Address 0xc94 read value
    csrr x14, 0xc94

    #Address 0xc94 Write value 0x23ed420
    li x3, 0x23ed420
    csrw 0xc94, x3

    #Address 0xc94 read value
    csrr x14, 0xc94

    #Unmapped address 0x7a5 testing: Read Reset + Random data Write/Read
    #Address 0x7a5 read value
    csrr x14, 0x7a5

    #Address 0x7a5 Write value 0xab42c1d1
    li x3, 0xab42c1d1
    csrw 0x7a5, x3

    #Address 0x7a5 read value
    csrr x14, 0x7a5

    #Unmapped address 0x562 testing: Read Reset + Random data Write/Read
    #Address 0x562 read value
    csrr x14, 0x562

    #Address 0x562 Write value 0xe4cf6bb3
    li x3, 0xe4cf6bb3
    csrw 0x562, x3

    #Address 0x562 read value
    csrr x14, 0x562

    #Unmapped address 0x24c testing: Read Reset + Random data Write/Read
    #Address 0x24c read value
    csrr x14, 0x24c

    #Address 0x24c Write value 0xb0a14039
    li x3, 0xb0a14039
    csrw 0x24c, x3

    #Address 0x24c read value
    csrr x14, 0x24c

    #Unmapped address 0xc01 testing: Read Reset + Random data Write/Read
    #Address 0xc01 read value
    csrr x14, 0xc01

    #Address 0xc01 Write value 0xfef61f16
    li x3, 0xfef61f16
    csrw 0xc01, x3

    #Address 0xc01 read value
    csrr x14, 0xc01

    #Unmapped address 0x369 testing: Read Reset + Random data Write/Read
    #Address 0x369 read value
    csrr x14, 0x369

    #Address 0x369 Write value 0x7a531232
    li x3, 0x7a531232
    csrw 0x369, x3

    #Address 0x369 read value
    csrr x14, 0x369

    #Unmapped address 0x283 testing: Read Reset + Random data Write/Read
    #Address 0x283 read value
    csrr x14, 0x283

    #Address 0x283 Write value 0xfb265660
    li x3, 0xfb265660
    csrw 0x283, x3

    #Address 0x283 read value
    csrr x14, 0x283

    #Unmapped address 0x4b1 testing: Read Reset + Random data Write/Read
    #Address 0x4b1 read value
    csrr x14, 0x4b1

    #Address 0x4b1 Write value 0xfcfc125
    li x3, 0xfcfc125
    csrw 0x4b1, x3

    #Address 0x4b1 read value
    csrr x14, 0x4b1


    #End of csr test
    j csr_pass

csr_pass:
    li x1, 0xBEEFBEEF
    li x1, 0
    slli x1, x1, 1
    addi x1, x1, 1
    sw x1, tohost, x30
    self_loop: j self_loop

csr_fail:
    li x1, 0xBADBAD
    li x1, 1
    slli x1, x1, 1
    addi x1, x1, 1
    sw x1, tohost, x30
    self_loop_2: j self_loop_2

.align 8
exception_handler:
    # increment return address to skip instruction generating the exception
    # valid only if faulting instruction is not compressed (4-byte long)
    csrr    x30, mepc  # mepc: 0x341
    addi    x30, x30, 4
    csrw    mepc, x30  # mepc: 0x341
    mret

